#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 12862
#define LARGE_STATE_COUNT 2378
#define SYMBOL_COUNT 537
#define ALIAS_COUNT 15
#define TOKEN_COUNT 156
#define EXTERNAL_TOKEN_COUNT 49
#define FIELD_COUNT 84
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 560

enum ts_symbol_identifiers {
  sym_variable = 1,
  anon_sym_SEMI = 2,
  anon_sym_let = 3,
  anon_sym_COMMA = 4,
  anon_sym_LBRACE = 5,
  anon_sym_RBRACE = 6,
  anon_sym__ = 7,
  anon_sym_SQUOTE = 8,
  anon_sym_STAR = 9,
  anon_sym_u2605 = 10,
  anon_sym_forall = 11,
  anon_sym_u2200 = 12,
  anon_sym_DOT = 13,
  anon_sym_type = 14,
  anon_sym_EQ = 15,
  anon_sym_instance = 16,
  anon_sym_DOT_DOT = 17,
  anon_sym_family = 18,
  anon_sym_representational = 19,
  anon_sym_nominal = 20,
  anon_sym_phantom = 21,
  anon_sym_role = 22,
  anon_sym_SQUOTE_SQUOTE = 23,
  anon_sym_then = 24,
  anon_sym_group = 25,
  anon_sym_by = 26,
  anon_sym_using = 27,
  anon_sym_PIPE = 28,
  anon_sym_BSLASH = 29,
  anon_sym_in = 30,
  anon_sym_if = 31,
  anon_sym_else = 32,
  anon_sym_rec = 33,
  anon_sym_mdo = 34,
  anon_sym_do = 35,
  anon_sym_case = 36,
  anon_sym_of = 37,
  anon_sym_cases = 38,
  anon_sym_DASH = 39,
  anon_sym_pattern = 40,
  anon_sym_import = 41,
  anon_sym_qualified = 42,
  anon_sym_as = 43,
  anon_sym_hiding = 44,
  anon_sym_module = 45,
  anon_sym_via = 46,
  anon_sym_stock = 47,
  anon_sym_newtype = 48,
  anon_sym_anyclass = 49,
  anon_sym_deriving = 50,
  anon_sym_data = 51,
  anon_sym_default = 52,
  anon_sym_class = 53,
  anon_sym_1 = 54,
  anon_sym_infixr = 55,
  anon_sym_DASH_GT = 56,
  anon_sym_infixl = 57,
  anon_sym_infix = 58,
  sym_calling_convention = 59,
  sym_safety = 60,
  anon_sym_foreign = 61,
  anon_sym_export = 62,
  anon_sym_DOLLAR = 63,
  anon_sym_DOLLAR_DOLLAR = 64,
  anon_sym_LBRACK = 65,
  anon_sym_PIPE_RBRACK = 66,
  anon_sym_u27e7 = 67,
  anon_sym_u27e6 = 68,
  anon_sym_e = 69,
  anon_sym_t = 70,
  anon_sym_p = 71,
  anon_sym_d = 72,
  anon_sym_PIPE_PIPE = 73,
  anon_sym_PIPE_PIPE_RBRACK = 74,
  sym_float = 75,
  sym_char = 76,
  sym_string = 77,
  sym__integer_literal = 78,
  sym__binary_literal = 79,
  sym__octal_literal = 80,
  sym__hex_literal = 81,
  anon_sym_BQUOTE = 82,
  anon_sym_POUND = 83,
  anon_sym_POUND2 = 84,
  anon_sym_PIPE2 = 85,
  sym_implicit_variable = 86,
  sym_name = 87,
  sym_label = 88,
  anon_sym_EQ_GT = 89,
  anon_sym_u21d2 = 90,
  anon_sym_u2192 = 91,
  anon_sym_DASH_GT_DOT = 92,
  anon_sym_u22b8 = 93,
  anon_sym_LT_DASH = 94,
  anon_sym_u2190 = 95,
  anon_sym_COLON_COLON = 96,
  anon_sym_u2237 = 97,
  anon_sym_AT = 98,
  anon_sym_BANG = 99,
  anon_sym_TILDE = 100,
  anon_sym_PERCENT = 101,
  aux_sym__paren_open_token1 = 102,
  aux_sym__paren_close_token1 = 103,
  anon_sym_RBRACK = 104,
  anon_sym_POUND_RPAREN = 105,
  anon_sym_where = 106,
  aux_sym__token1 = 107,
  sym_error_sentinel = 108,
  sym__cond_layout_semicolon = 109,
  sym__cmd_layout_start = 110,
  sym__cmd_layout_start_do = 111,
  sym__cmd_layout_start_case = 112,
  sym__cmd_layout_start_if = 113,
  sym__cmd_layout_start_let = 114,
  sym__cmd_layout_start_quote = 115,
  sym__cmd_layout_start_explicit = 116,
  sym__cond_layout_end = 117,
  sym__cond_layout_end_explicit = 118,
  sym__cmd_brace_open = 119,
  sym__cmd_brace_close = 120,
  sym__cmd_texp_start = 121,
  sym__cmd_texp_end = 122,
  sym__phantom_where = 123,
  sym__phantom_in = 124,
  sym__phantom_arrow = 125,
  sym__phantom_bar = 126,
  sym__phantom_deriving = 127,
  sym_comment = 128,
  sym_haddock = 129,
  sym_cpp = 130,
  sym_pragma = 131,
  sym__cond_quote_start = 132,
  sym_quasiquote_body = 133,
  sym__cond_splice = 134,
  sym__cond_qual_dot = 135,
  sym__cond_tight_dot = 136,
  sym__cond_prefix_dot = 137,
  sym__cond_dotdot = 138,
  sym__cond_tight_at = 139,
  sym__cond_prefix_at = 140,
  sym__cond_tight_bang = 141,
  sym__cond_prefix_bang = 142,
  sym__cond_tight_tilde = 143,
  sym__cond_prefix_tilde = 144,
  sym__cond_prefix_percent = 145,
  sym__cond_qualified_op = 146,
  sym__cond_left_section_op = 147,
  sym__cond_no_section_op = 148,
  sym__cond_minus = 149,
  sym__cond_context = 150,
  sym__cond_infix = 151,
  sym__cond_data_infix = 152,
  sym__cond_assoc_tyinst = 153,
  sym__varsym = 154,
  sym__consym = 155,
  sym_haskell = 156,
  sym_generator = 157,
  sym__let_binds = 158,
  sym_let = 159,
  sym_guard = 160,
  sym_guards = 161,
  sym__guards = 162,
  sym__inferred_tyvar = 163,
  sym__type_param_parens = 164,
  sym__type_param_wildcard = 165,
  sym__type_param_annotated = 166,
  sym__type_param_invisible = 167,
  sym_type_param = 168,
  sym__ktype_param = 169,
  sym_type_params = 170,
  sym_quantified_variables = 171,
  sym__type_parens = 172,
  sym__type_tuple_elems = 173,
  sym__type_tuple = 174,
  sym__type_unboxed_tuple = 175,
  sym__type_unboxed_sum = 176,
  sym__type_list = 177,
  sym__type_promoted = 178,
  sym__type_star = 179,
  sym__type_wildcard = 180,
  sym__at_type = 181,
  sym__type_apply = 182,
  sym__type_infix = 183,
  sym_type = 184,
  sym__forall_keyword = 185,
  sym__forall_body = 186,
  sym_forall = 187,
  sym_forall_required = 188,
  sym__qtype_forall = 189,
  sym__qtype_forall_required = 190,
  sym__fun_arrow = 191,
  sym_modifier = 192,
  sym__linear_fun_arrow = 193,
  sym_strict_field = 194,
  sym_lazy_field = 195,
  sym__qtype_function = 196,
  sym__qtype_linear_function = 197,
  sym__qtype_context = 198,
  sym_quantified_type = 199,
  sym__type_signature = 200,
  sym__ktype = 201,
  sym__type_head_name = 202,
  sym__type_head_parens = 203,
  sym__type_head_params = 204,
  sym__type_head_infix = 205,
  sym__type_instance_head_parens = 206,
  sym__type_instance_head_params = 207,
  sym_type_patterns = 208,
  sym_type_synomym = 209,
  sym_kind_signature = 210,
  sym__type_instance_common = 211,
  sym__type_instance = 212,
  sym_type_instance = 213,
  sym_type_family_result = 214,
  sym_type_family_injectivity = 215,
  sym__tyfam_inj = 216,
  sym__tyfam = 217,
  sym__tyfam_equations = 218,
  sym_abstract_family = 219,
  sym_type_family = 220,
  sym_type_role = 221,
  sym_role_annotation = 222,
  sym__class_apply = 223,
  sym__class_infix = 224,
  sym__ctr_parens = 225,
  sym__ctr_tuple = 226,
  sym_implicit_parameter = 227,
  sym_constraint = 228,
  sym__ctr_forall = 229,
  sym__ctr_context = 230,
  sym__ctr_signature = 231,
  sym_constraints = 232,
  sym__context_inline = 233,
  sym_context = 234,
  sym__exp_th_quoted_name = 235,
  sym__exp_parens = 236,
  sym__exp_tuple_elems = 237,
  sym__exp_tuple = 238,
  sym__exp_unboxed_tuple = 239,
  sym__exp_unboxed_sum = 240,
  sym__exp_list = 241,
  sym__exp_arithmetic_sequence = 242,
  sym_group = 243,
  sym_transform = 244,
  sym_qualifier = 245,
  sym_qualifiers = 246,
  sym__exp_list_comprehension = 247,
  sym__exp_lambda = 248,
  sym__exp_let_in = 249,
  sym__exp_conditional = 250,
  sym__exp_statement = 251,
  sym_statement = 252,
  sym__statements = 253,
  sym_rec = 254,
  sym__do_keyword = 255,
  sym_do_module = 256,
  sym__do = 257,
  sym__exp_do = 258,
  sym_match = 259,
  sym__simple_match = 260,
  sym__matches = 261,
  sym_alternative = 262,
  sym__nalt = 263,
  sym_alternatives = 264,
  sym__nalts = 265,
  sym__exp_case = 266,
  sym__exp_lambda_case = 267,
  sym__exp_lambda_cases = 268,
  sym__exp_multi_way_if = 269,
  sym_field_update = 270,
  sym__exp_record = 271,
  sym__exp_projection_selector = 272,
  sym__exp_projection = 273,
  sym_explicit_type = 274,
  sym__exp_apply = 275,
  sym__exp_op = 276,
  sym__exp_section_left = 277,
  sym__exp_section_right = 278,
  sym__exp_negation = 279,
  sym__exp_infix = 280,
  sym_expression = 281,
  sym__exp_signature = 282,
  sym__exp = 283,
  sym__pat_parens = 284,
  sym__pat_tuple_elems = 285,
  sym__pat_tuple = 286,
  sym__pat_unboxed_tuple = 287,
  sym__pat_unboxed_sum = 288,
  sym__pat_list = 289,
  sym_field_pattern = 290,
  sym__pat_record = 291,
  sym__pat_as = 292,
  sym__pat_wildcard = 293,
  sym__pat_strict = 294,
  sym__pat_irrefutable = 295,
  sym__pat_apply = 296,
  sym__pat_negation = 297,
  sym__pat_infix = 298,
  sym_pattern = 299,
  sym_patterns = 300,
  sym__pat_signature = 301,
  sym__pat = 302,
  sym_view_pattern = 303,
  sym__modid_prefix = 304,
  aux_sym__qualifying_module = 305,
  sym_module = 306,
  sym_namespace = 307,
  sym__child_type = 308,
  sym__child = 309,
  sym_children = 310,
  sym__ie_entity = 311,
  sym_import_list = 312,
  sym_import = 313,
  sym_module_export = 314,
  sym_exports = 315,
  sym_header = 316,
  sym_imports = 317,
  sym_declarations = 318,
  sym__body = 319,
  sym__layout_end = 320,
  sym_declaration = 321,
  sym_field_name = 322,
  sym__qfield_name = 323,
  sym__field_names = 324,
  sym_field_path = 325,
  sym__field_spec = 326,
  sym_field = 327,
  sym__record_fields = 328,
  sym_via = 329,
  sym_deriving_strategy = 330,
  sym_deriving = 331,
  sym__gadt_con_prefix = 332,
  sym__gadt_con_record = 333,
  sym_gadt_constructor = 334,
  sym_gadt_constructors = 335,
  sym__gadt = 336,
  sym__datacon_prefix = 337,
  sym__datacon_infix = 338,
  sym__datacon_record = 339,
  sym__datacon_unboxed_sum = 340,
  sym__datacon_special = 341,
  sym_data_constructor = 342,
  sym_data_constructors = 343,
  sym__data_rhs = 344,
  sym__data = 345,
  sym_data_type = 346,
  sym__newtype_con_field = 347,
  sym_newtype_constructor = 348,
  sym__newtype = 349,
  sym_newtype = 350,
  sym__datafam = 351,
  sym_data_family = 352,
  sym__inst_adt = 353,
  sym_decl_inst_adt = 354,
  sym__inst_newtype = 355,
  sym_decl_inst_newtype = 356,
  sym_data_instance = 357,
  sym__assoc_tyfam = 358,
  sym__assoc_tyinst = 359,
  sym__assoc_datafam = 360,
  sym__assoc_datainst_adt = 361,
  sym__assoc_datainst_newtype = 362,
  sym__assoc_datainst = 363,
  sym_default_signature = 364,
  sym_class_decl = 365,
  sym_fundep = 366,
  sym_fundeps = 367,
  sym_class_declarations = 368,
  sym_class = 369,
  sym_instance_decl = 370,
  sym_instance_declarations = 371,
  sym__instance = 372,
  sym_instance = 373,
  sym_deriving_instance = 374,
  sym__fun_arrow_prec = 375,
  sym__fun_arrow_fixity = 376,
  sym_fixity = 377,
  sym__con_binding_list = 378,
  sym__var_binding_list = 379,
  sym_signature = 380,
  sym__simple_bind_match = 381,
  sym__bind_match = 382,
  sym__bind_matches = 383,
  sym__function_name = 384,
  sym_function_head_parens = 385,
  sym__function_head_infix = 386,
  sym_function = 387,
  sym_bind = 388,
  sym_decl = 389,
  sym__local_decl = 390,
  sym_local_binds = 391,
  sym__where_binds = 392,
  sym_entity = 393,
  sym_foreign_import = 394,
  sym_foreign_export = 395,
  sym_default_types = 396,
  sym__patsyn_signature = 397,
  sym__patsyn_cons = 398,
  sym__patsyn_equation = 399,
  sym_pattern_synonym = 400,
  sym__splice_exp = 401,
  sym__splice_dollars = 402,
  sym_splice = 403,
  sym_top_splice = 404,
  sym_quoter = 405,
  sym_quasiquote = 406,
  sym_quoted_decls = 407,
  sym__exp_quote = 408,
  sym__exp_typed_quote = 409,
  sym_integer = 410,
  sym__plist = 411,
  sym_unit = 412,
  sym_unboxed_unit = 413,
  sym_prefix_tuple = 414,
  sym_prefix_unboxed_tuple = 415,
  sym_prefix_unboxed_sum = 416,
  sym_literal = 417,
  sym__qualified_variable = 418,
  sym__qvarid = 419,
  sym__qvar = 420,
  sym__variable_ticked = 421,
  sym__qvariable_ticked = 422,
  sym__qualified_constructor = 423,
  sym__qconid = 424,
  sym__constructor_ticked = 425,
  sym__qconstructor_ticked = 426,
  sym__qualified_type = 427,
  sym__qtyconid = 428,
  sym__tycon_arrow = 429,
  sym__qualified_arrow = 430,
  sym__qtycon_arrow = 431,
  sym__promoted_tycons_alias = 432,
  sym__promoted_tycons = 433,
  sym__tycon_ticked = 434,
  sym__qtycon_ticked = 435,
  sym__tyconids_ticked = 436,
  sym__promoted_tyconops_alias = 437,
  sym__promoted_tyconops = 438,
  sym__ops = 439,
  sym__qname = 440,
  sym__operator_qual_dot_head = 441,
  sym__operator_hash_head = 442,
  sym_operator = 443,
  sym__operator_alias = 444,
  sym__operator_minus = 445,
  sym__varsym_prefix = 446,
  sym__pvarsym = 447,
  sym__qualified_varsym = 448,
  sym__qvarsym_prefix = 449,
  sym__pqvarsym = 450,
  sym_constructor_operator = 451,
  sym__constructor_operator_alias = 452,
  sym__consym_prefix = 453,
  sym__pconsym = 454,
  sym__qualified_consym = 455,
  sym__qconsym_prefix = 456,
  sym__pqconsym = 457,
  sym__sym_prefix = 458,
  sym__carrow = 459,
  sym__arrow = 460,
  sym__linear_arrow = 461,
  sym__larrow = 462,
  sym__colon2 = 463,
  sym__qual_dot = 464,
  sym__tight_dot = 465,
  sym__prefix_dot = 466,
  sym__tight_at = 467,
  sym__prefix_at = 468,
  sym__prefix_bang = 469,
  sym__tight_bang = 470,
  sym__any_prefix_bang = 471,
  sym__prefix_tilde = 472,
  sym__tight_tilde = 473,
  sym__any_prefix_tilde = 474,
  sym__prefix_percent = 475,
  sym__dotdot = 476,
  sym__paren_open = 477,
  sym__paren_close = 478,
  sym__bracket_open = 479,
  sym__bracket_close = 480,
  sym__unboxed_open = 481,
  sym__unboxed_close = 482,
  sym__where = 483,
  sym__bar = 484,
  aux_sym__let_binds_repeat1 = 485,
  aux_sym__let_binds_repeat2 = 486,
  aux_sym_guards_repeat1 = 487,
  aux_sym_type_params_repeat1 = 488,
  aux_sym_quantified_variables_repeat1 = 489,
  aux_sym__type_tuple_elems_repeat1 = 490,
  aux_sym__type_unboxed_sum_repeat1 = 491,
  aux_sym_type_patterns_repeat1 = 492,
  aux_sym_type_family_injectivity_repeat1 = 493,
  aux_sym__tyfam_equations_repeat1 = 494,
  aux_sym_role_annotation_repeat1 = 495,
  aux_sym__ctr_tuple_repeat1 = 496,
  aux_sym__exp_tuple_elems_repeat1 = 497,
  aux_sym__exp_tuple_elems_repeat2 = 498,
  aux_sym__exp_unboxed_sum_repeat1 = 499,
  aux_sym__exp_list_repeat1 = 500,
  aux_sym_qualifiers_repeat1 = 501,
  aux_sym__exp_list_comprehension_repeat1 = 502,
  aux_sym__statements_repeat1 = 503,
  aux_sym__matches_repeat1 = 504,
  aux_sym_alternatives_repeat1 = 505,
  aux_sym__nalts_repeat1 = 506,
  aux_sym__exp_multi_way_if_repeat1 = 507,
  aux_sym__exp_record_repeat1 = 508,
  aux_sym__exp_projection_selector_repeat1 = 509,
  aux_sym__pat_tuple_elems_repeat1 = 510,
  aux_sym__pat_record_repeat1 = 511,
  aux_sym_patterns_repeat1 = 512,
  aux_sym_module_repeat1 = 513,
  aux_sym_children_repeat1 = 514,
  aux_sym_import_list_repeat1 = 515,
  aux_sym_exports_repeat1 = 516,
  aux_sym_imports_repeat1 = 517,
  aux_sym_declarations_repeat1 = 518,
  aux_sym_field_path_repeat1 = 519,
  aux_sym_field_repeat1 = 520,
  aux_sym__record_fields_repeat1 = 521,
  aux_sym_gadt_constructors_repeat1 = 522,
  aux_sym__datacon_prefix_repeat1 = 523,
  aux_sym_data_constructors_repeat1 = 524,
  aux_sym__data_repeat1 = 525,
  aux_sym_fundeps_repeat1 = 526,
  aux_sym_class_declarations_repeat1 = 527,
  aux_sym_instance_declarations_repeat1 = 528,
  aux_sym_fixity_repeat1 = 529,
  aux_sym__con_binding_list_repeat1 = 530,
  aux_sym__var_binding_list_repeat1 = 531,
  aux_sym__bind_matches_repeat1 = 532,
  aux_sym_local_binds_repeat1 = 533,
  aux_sym_default_types_repeat1 = 534,
  aux_sym__patsyn_cons_repeat1 = 535,
  aux_sym_quoted_decls_repeat1 = 536,
  anon_alias_sym_LPAREN_POUND = 537,
  alias_sym_all_names = 538,
  alias_sym_boolean = 539,
  alias_sym_constructor = 540,
  alias_sym_constructor_synonym = 541,
  alias_sym_export = 542,
  alias_sym_import_package = 543,
  alias_sym_module_id = 544,
  alias_sym_pattern_guard = 545,
  alias_sym_prefix_list = 546,
  alias_sym_quoted_expression = 547,
  alias_sym_quoted_pattern = 548,
  alias_sym_quoted_type = 549,
  alias_sym_type_application = 550,
  alias_sym_type_binder = 551,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_variable] = "variable",
  [anon_sym_SEMI] = ";",
  [anon_sym_let] = "let",
  [anon_sym_COMMA] = ",",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym__] = "_",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_STAR] = "*",
  [anon_sym_u2605] = "\u2605",
  [anon_sym_forall] = "forall",
  [anon_sym_u2200] = "\u2200",
  [anon_sym_DOT] = ".",
  [anon_sym_type] = "type",
  [anon_sym_EQ] = "=",
  [anon_sym_instance] = "instance",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_family] = "family",
  [anon_sym_representational] = "representational",
  [anon_sym_nominal] = "nominal",
  [anon_sym_phantom] = "phantom",
  [anon_sym_role] = "role",
  [anon_sym_SQUOTE_SQUOTE] = "''",
  [anon_sym_then] = "then",
  [anon_sym_group] = "group",
  [anon_sym_by] = "by",
  [anon_sym_using] = "using",
  [anon_sym_PIPE] = "|",
  [anon_sym_BSLASH] = "\\",
  [anon_sym_in] = "in",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_rec] = "rec",
  [anon_sym_mdo] = "mdo",
  [anon_sym_do] = "do",
  [anon_sym_case] = "case",
  [anon_sym_of] = "of",
  [anon_sym_cases] = "cases",
  [anon_sym_DASH] = "-",
  [anon_sym_pattern] = "pattern",
  [anon_sym_import] = "import",
  [anon_sym_qualified] = "qualified",
  [anon_sym_as] = "as",
  [anon_sym_hiding] = "hiding",
  [anon_sym_module] = "module",
  [anon_sym_via] = "via",
  [anon_sym_stock] = "stock",
  [anon_sym_newtype] = "newtype",
  [anon_sym_anyclass] = "anyclass",
  [anon_sym_deriving] = "deriving",
  [anon_sym_data] = "data",
  [anon_sym_default] = "default",
  [anon_sym_class] = "class",
  [anon_sym_1] = "1",
  [anon_sym_infixr] = "infixr",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_infixl] = "infixl",
  [anon_sym_infix] = "infix",
  [sym_calling_convention] = "calling_convention",
  [sym_safety] = "safety",
  [anon_sym_foreign] = "foreign",
  [anon_sym_export] = "export",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_DOLLAR_DOLLAR] = "$$",
  [anon_sym_LBRACK] = "[",
  [anon_sym_PIPE_RBRACK] = "|]",
  [anon_sym_u27e7] = "\u27e7",
  [anon_sym_u27e6] = "\u27e6",
  [anon_sym_e] = "e",
  [anon_sym_t] = "t",
  [anon_sym_p] = "p",
  [anon_sym_d] = "d",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_PIPE_PIPE_RBRACK] = "||]",
  [sym_float] = "float",
  [sym_char] = "char",
  [sym_string] = "string",
  [sym__integer_literal] = "_integer_literal",
  [sym__binary_literal] = "_binary_literal",
  [sym__octal_literal] = "_octal_literal",
  [sym__hex_literal] = "_hex_literal",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_POUND] = "#",
  [anon_sym_POUND2] = "#",
  [anon_sym_PIPE2] = "|",
  [sym_implicit_variable] = "implicit_variable",
  [sym_name] = "name",
  [sym_label] = "label",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_u21d2] = "\u21d2",
  [anon_sym_u2192] = "\u2192",
  [anon_sym_DASH_GT_DOT] = "->.",
  [anon_sym_u22b8] = "\u22b8",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_u2190] = "\u2190",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_u2237] = "\u2237",
  [anon_sym_AT] = "@",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_PERCENT] = "%",
  [aux_sym__paren_open_token1] = "(",
  [aux_sym__paren_close_token1] = ")",
  [anon_sym_RBRACK] = "]",
  [anon_sym_POUND_RPAREN] = "#)",
  [anon_sym_where] = "where",
  [aux_sym__token1] = "_token1",
  [sym_error_sentinel] = "error_sentinel",
  [sym__cond_layout_semicolon] = "_cond_layout_semicolon",
  [sym__cmd_layout_start] = "_cmd_layout_start",
  [sym__cmd_layout_start_do] = "_cmd_layout_start_do",
  [sym__cmd_layout_start_case] = "_cmd_layout_start_case",
  [sym__cmd_layout_start_if] = "_cmd_layout_start_if",
  [sym__cmd_layout_start_let] = "_cmd_layout_start_let",
  [sym__cmd_layout_start_quote] = "_cmd_layout_start_quote",
  [sym__cmd_layout_start_explicit] = "{",
  [sym__cond_layout_end] = "_cond_layout_end",
  [sym__cond_layout_end_explicit] = "}",
  [sym__cmd_brace_open] = "_cmd_brace_open",
  [sym__cmd_brace_close] = "_cmd_brace_close",
  [sym__cmd_texp_start] = "_cmd_texp_start",
  [sym__cmd_texp_end] = "_cmd_texp_end",
  [sym__phantom_where] = "_phantom_where",
  [sym__phantom_in] = "_phantom_in",
  [sym__phantom_arrow] = "_phantom_arrow",
  [sym__phantom_bar] = "_phantom_bar",
  [sym__phantom_deriving] = "_phantom_deriving",
  [sym_comment] = "comment",
  [sym_haddock] = "haddock",
  [sym_cpp] = "cpp",
  [sym_pragma] = "pragma",
  [sym__cond_quote_start] = "_cond_quote_start",
  [sym_quasiquote_body] = "quasiquote_body",
  [sym__cond_splice] = "_cond_splice",
  [sym__cond_qual_dot] = "_cond_qual_dot",
  [sym__cond_tight_dot] = "_cond_tight_dot",
  [sym__cond_prefix_dot] = "_cond_prefix_dot",
  [sym__cond_dotdot] = "_cond_dotdot",
  [sym__cond_tight_at] = "_cond_tight_at",
  [sym__cond_prefix_at] = "_cond_prefix_at",
  [sym__cond_tight_bang] = "_cond_tight_bang",
  [sym__cond_prefix_bang] = "_cond_prefix_bang",
  [sym__cond_tight_tilde] = "_cond_tight_tilde",
  [sym__cond_prefix_tilde] = "_cond_prefix_tilde",
  [sym__cond_prefix_percent] = "_cond_prefix_percent",
  [sym__cond_qualified_op] = "_cond_qualified_op",
  [sym__cond_left_section_op] = "_cond_left_section_op",
  [sym__cond_no_section_op] = "_cond_no_section_op",
  [sym__cond_minus] = "_cond_minus",
  [sym__cond_context] = "_cond_context",
  [sym__cond_infix] = "_cond_infix",
  [sym__cond_data_infix] = "_cond_data_infix",
  [sym__cond_assoc_tyinst] = "_cond_assoc_tyinst",
  [sym__varsym] = "_varsym",
  [sym__consym] = "_consym",
  [sym_haskell] = "haskell",
  [sym_generator] = "generator",
  [sym__let_binds] = "local_binds",
  [sym_let] = "let",
  [sym_guard] = "guard",
  [sym_guards] = "guards",
  [sym__guards] = "_guards",
  [sym__inferred_tyvar] = "inferred",
  [sym__type_param_parens] = "parens",
  [sym__type_param_wildcard] = "wildcard",
  [sym__type_param_annotated] = "annotated",
  [sym__type_param_invisible] = "invisible",
  [sym_type_param] = "type_param",
  [sym__ktype_param] = "_ktype_param",
  [sym_type_params] = "type_params",
  [sym_quantified_variables] = "quantified_variables",
  [sym__type_parens] = "parens",
  [sym__type_tuple_elems] = "_type_tuple_elems",
  [sym__type_tuple] = "tuple",
  [sym__type_unboxed_tuple] = "unboxed_tuple",
  [sym__type_unboxed_sum] = "unboxed_sum",
  [sym__type_list] = "list",
  [sym__type_promoted] = "promoted",
  [sym__type_star] = "star",
  [sym__type_wildcard] = "wildcard",
  [sym__at_type] = "kind_application",
  [sym__type_apply] = "apply",
  [sym__type_infix] = "infix",
  [sym_type] = "type",
  [sym__forall_keyword] = "_forall_keyword",
  [sym__forall_body] = "_forall_body",
  [sym_forall] = "forall",
  [sym_forall_required] = "forall_required",
  [sym__qtype_forall] = "forall",
  [sym__qtype_forall_required] = "forall_required",
  [sym__fun_arrow] = "_fun_arrow",
  [sym_modifier] = "modifier",
  [sym__linear_fun_arrow] = "_linear_fun_arrow",
  [sym_strict_field] = "strict_field",
  [sym_lazy_field] = "lazy_field",
  [sym__qtype_function] = "function",
  [sym__qtype_linear_function] = "linear_function",
  [sym__qtype_context] = "context",
  [sym_quantified_type] = "quantified_type",
  [sym__type_signature] = "signature",
  [sym__ktype] = "_ktype",
  [sym__type_head_name] = "_type_head_name",
  [sym__type_head_parens] = "parens",
  [sym__type_head_params] = "_type_head_params",
  [sym__type_head_infix] = "infix",
  [sym__type_instance_head_parens] = "parens",
  [sym__type_instance_head_params] = "_type_instance_head_params",
  [sym_type_patterns] = "type_patterns",
  [sym_type_synomym] = "type_synomym",
  [sym_kind_signature] = "kind_signature",
  [sym__type_instance_common] = "_type_instance_common",
  [sym__type_instance] = "_type_instance",
  [sym_type_instance] = "type_instance",
  [sym_type_family_result] = "type_family_result",
  [sym_type_family_injectivity] = "type_family_injectivity",
  [sym__tyfam_inj] = "_tyfam_inj",
  [sym__tyfam] = "_tyfam",
  [sym__tyfam_equations] = "equations",
  [sym_abstract_family] = "abstract_family",
  [sym_type_family] = "type_family",
  [sym_type_role] = "type_role",
  [sym_role_annotation] = "role_annotation",
  [sym__class_apply] = "apply",
  [sym__class_infix] = "infix",
  [sym__ctr_parens] = "parens",
  [sym__ctr_tuple] = "tuple",
  [sym_implicit_parameter] = "implicit_parameter",
  [sym_constraint] = "constraint",
  [sym__ctr_forall] = "forall",
  [sym__ctr_context] = "context",
  [sym__ctr_signature] = "signature",
  [sym_constraints] = "constraints",
  [sym__context_inline] = "_context_inline",
  [sym_context] = "context",
  [sym__exp_th_quoted_name] = "th_quoted_name",
  [sym__exp_parens] = "parens",
  [sym__exp_tuple_elems] = "_exp_tuple_elems",
  [sym__exp_tuple] = "tuple",
  [sym__exp_unboxed_tuple] = "unboxed_tuple",
  [sym__exp_unboxed_sum] = "unboxed_sum",
  [sym__exp_list] = "list",
  [sym__exp_arithmetic_sequence] = "arithmetic_sequence",
  [sym_group] = "group",
  [sym_transform] = "transform",
  [sym_qualifier] = "qualifier",
  [sym_qualifiers] = "qualifiers",
  [sym__exp_list_comprehension] = "list_comprehension",
  [sym__exp_lambda] = "lambda",
  [sym__exp_let_in] = "let_in",
  [sym__exp_conditional] = "conditional",
  [sym__exp_statement] = "exp",
  [sym_statement] = "statement",
  [sym__statements] = "_statements",
  [sym_rec] = "rec",
  [sym__do_keyword] = "_do_keyword",
  [sym_do_module] = "do_module",
  [sym__do] = "_do",
  [sym__exp_do] = "do",
  [sym_match] = "match",
  [sym__simple_match] = "match",
  [sym__matches] = "_matches",
  [sym_alternative] = "alternative",
  [sym__nalt] = "alternative",
  [sym_alternatives] = "alternatives",
  [sym__nalts] = "alternatives",
  [sym__exp_case] = "case",
  [sym__exp_lambda_case] = "lambda_case",
  [sym__exp_lambda_cases] = "lambda_cases",
  [sym__exp_multi_way_if] = "multi_way_if",
  [sym_field_update] = "field_update",
  [sym__exp_record] = "record",
  [sym__exp_projection_selector] = "projection_selector",
  [sym__exp_projection] = "projection",
  [sym_explicit_type] = "explicit_type",
  [sym__exp_apply] = "apply",
  [sym__exp_op] = "_exp_op",
  [sym__exp_section_left] = "left_section",
  [sym__exp_section_right] = "right_section",
  [sym__exp_negation] = "negation",
  [sym__exp_infix] = "infix",
  [sym_expression] = "expression",
  [sym__exp_signature] = "signature",
  [sym__exp] = "_exp",
  [sym__pat_parens] = "parens",
  [sym__pat_tuple_elems] = "_pat_tuple_elems",
  [sym__pat_tuple] = "tuple",
  [sym__pat_unboxed_tuple] = "unboxed_tuple",
  [sym__pat_unboxed_sum] = "unboxed_sum",
  [sym__pat_list] = "list",
  [sym_field_pattern] = "field_pattern",
  [sym__pat_record] = "record",
  [sym__pat_as] = "as",
  [sym__pat_wildcard] = "wildcard",
  [sym__pat_strict] = "strict",
  [sym__pat_irrefutable] = "irrefutable",
  [sym__pat_apply] = "apply",
  [sym__pat_negation] = "negation",
  [sym__pat_infix] = "infix",
  [sym_pattern] = "pattern",
  [sym_patterns] = "patterns",
  [sym__pat_signature] = "signature",
  [sym__pat] = "_pat",
  [sym_view_pattern] = "view_pattern",
  [sym__modid_prefix] = "_modid_prefix",
  [aux_sym__qualifying_module] = "_qualifying_module",
  [sym_module] = "module",
  [sym_namespace] = "namespace",
  [sym__child_type] = "associated_type",
  [sym__child] = "_child",
  [sym_children] = "children",
  [sym__ie_entity] = "import_name",
  [sym_import_list] = "import_list",
  [sym_import] = "import",
  [sym_module_export] = "module_export",
  [sym_exports] = "exports",
  [sym_header] = "header",
  [sym_imports] = "imports",
  [sym_declarations] = "declarations",
  [sym__body] = "_body",
  [sym__layout_end] = "_layout_end",
  [sym_declaration] = "declaration",
  [sym_field_name] = "field_name",
  [sym__qfield_name] = "qualified",
  [sym__field_names] = "_field_names",
  [sym_field_path] = "field_path",
  [sym__field_spec] = "_field_spec",
  [sym_field] = "field",
  [sym__record_fields] = "fields",
  [sym_via] = "via",
  [sym_deriving_strategy] = "deriving_strategy",
  [sym_deriving] = "deriving",
  [sym__gadt_con_prefix] = "prefix",
  [sym__gadt_con_record] = "record",
  [sym_gadt_constructor] = "gadt_constructor",
  [sym_gadt_constructors] = "gadt_constructors",
  [sym__gadt] = "_gadt",
  [sym__datacon_prefix] = "prefix",
  [sym__datacon_infix] = "infix",
  [sym__datacon_record] = "record",
  [sym__datacon_unboxed_sum] = "unboxed_sum",
  [sym__datacon_special] = "special",
  [sym_data_constructor] = "data_constructor",
  [sym_data_constructors] = "data_constructors",
  [sym__data_rhs] = "_data_rhs",
  [sym__data] = "_data",
  [sym_data_type] = "data_type",
  [sym__newtype_con_field] = "field",
  [sym_newtype_constructor] = "newtype_constructor",
  [sym__newtype] = "_newtype",
  [sym_newtype] = "newtype",
  [sym__datafam] = "_datafam",
  [sym_data_family] = "data_family",
  [sym__inst_adt] = "_inst_adt",
  [sym_decl_inst_adt] = "data_type",
  [sym__inst_newtype] = "_inst_newtype",
  [sym_decl_inst_newtype] = "newtype",
  [sym_data_instance] = "data_instance",
  [sym__assoc_tyfam] = "type_family",
  [sym__assoc_tyinst] = "type_instance",
  [sym__assoc_datafam] = "data_family",
  [sym__assoc_datainst_adt] = "data_type",
  [sym__assoc_datainst_newtype] = "newtype",
  [sym__assoc_datainst] = "data_instance",
  [sym_default_signature] = "default_signature",
  [sym_class_decl] = "class_decl",
  [sym_fundep] = "fundep",
  [sym_fundeps] = "fundeps",
  [sym_class_declarations] = "class_declarations",
  [sym_class] = "class",
  [sym_instance_decl] = "instance_decl",
  [sym_instance_declarations] = "instance_declarations",
  [sym__instance] = "_instance",
  [sym_instance] = "instance",
  [sym_deriving_instance] = "deriving_instance",
  [sym__fun_arrow_prec] = "integer",
  [sym__fun_arrow_fixity] = "_fun_arrow_fixity",
  [sym_fixity] = "fixity",
  [sym__con_binding_list] = "binding_list",
  [sym__var_binding_list] = "binding_list",
  [sym_signature] = "signature",
  [sym__simple_bind_match] = "match",
  [sym__bind_match] = "match",
  [sym__bind_matches] = "_bind_matches",
  [sym__function_name] = "_function_name",
  [sym_function_head_parens] = "function_head_parens",
  [sym__function_head_infix] = "infix",
  [sym_function] = "function",
  [sym_bind] = "bind",
  [sym_decl] = "decl",
  [sym__local_decl] = "_local_decl",
  [sym_local_binds] = "local_binds",
  [sym__where_binds] = "_where_binds",
  [sym_entity] = "entity",
  [sym_foreign_import] = "foreign_import",
  [sym_foreign_export] = "foreign_export",
  [sym_default_types] = "default_types",
  [sym__patsyn_signature] = "signature",
  [sym__patsyn_cons] = "constructor_synonyms",
  [sym__patsyn_equation] = "equation",
  [sym_pattern_synonym] = "pattern_synonym",
  [sym__splice_exp] = "_splice_exp",
  [sym__splice_dollars] = "_splice_dollars",
  [sym_splice] = "splice",
  [sym_top_splice] = "top_splice",
  [sym_quoter] = "quoter",
  [sym_quasiquote] = "quasiquote",
  [sym_quoted_decls] = "quoted_decls",
  [sym__exp_quote] = "quote",
  [sym__exp_typed_quote] = "typed_quote",
  [sym_integer] = "integer",
  [sym__plist] = "empty_list",
  [sym_unit] = "unit",
  [sym_unboxed_unit] = "unboxed_unit",
  [sym_prefix_tuple] = "prefix_tuple",
  [sym_prefix_unboxed_tuple] = "prefix_unboxed_tuple",
  [sym_prefix_unboxed_sum] = "prefix_unboxed_sum",
  [sym_literal] = "literal",
  [sym__qualified_variable] = "qualified",
  [sym__qvarid] = "_qvarid",
  [sym__qvar] = "_qvar",
  [sym__variable_ticked] = "infix_id",
  [sym__qvariable_ticked] = "infix_id",
  [sym__qualified_constructor] = "qualified",
  [sym__qconid] = "_qconid",
  [sym__constructor_ticked] = "infix_id",
  [sym__qconstructor_ticked] = "infix_id",
  [sym__qualified_type] = "qualified",
  [sym__qtyconid] = "_qtyconid",
  [sym__tycon_arrow] = "prefix_id",
  [sym__qualified_arrow] = "qualified",
  [sym__qtycon_arrow] = "prefix_id",
  [sym__promoted_tycons_alias] = "promoted",
  [sym__promoted_tycons] = "_promoted_tycons",
  [sym__tycon_ticked] = "infix_id",
  [sym__qtycon_ticked] = "infix_id",
  [sym__tyconids_ticked] = "_tyconids_ticked",
  [sym__promoted_tyconops_alias] = "promoted",
  [sym__promoted_tyconops] = "_promoted_tyconops",
  [sym__ops] = "_ops",
  [sym__qname] = "_qname",
  [sym__operator_qual_dot_head] = "operator",
  [sym__operator_hash_head] = "_operator_hash_head",
  [sym_operator] = "operator",
  [sym__operator_alias] = "_operator_alias",
  [sym__operator_minus] = "_operator_minus",
  [sym__varsym_prefix] = "prefix_id",
  [sym__pvarsym] = "_pvarsym",
  [sym__qualified_varsym] = "qualified",
  [sym__qvarsym_prefix] = "prefix_id",
  [sym__pqvarsym] = "_pqvarsym",
  [sym_constructor_operator] = "constructor_operator",
  [sym__constructor_operator_alias] = "_constructor_operator_alias",
  [sym__consym_prefix] = "prefix_id",
  [sym__pconsym] = "_pconsym",
  [sym__qualified_consym] = "qualified",
  [sym__qconsym_prefix] = "prefix_id",
  [sym__pqconsym] = "_pqconsym",
  [sym__sym_prefix] = "_sym_prefix",
  [sym__carrow] = "_carrow",
  [sym__arrow] = "_arrow",
  [sym__linear_arrow] = "_linear_arrow",
  [sym__larrow] = "_larrow",
  [sym__colon2] = "_colon2",
  [sym__qual_dot] = "_qual_dot",
  [sym__tight_dot] = "_tight_dot",
  [sym__prefix_dot] = "_prefix_dot",
  [sym__tight_at] = "_tight_at",
  [sym__prefix_at] = "_prefix_at",
  [sym__prefix_bang] = "_prefix_bang",
  [sym__tight_bang] = "_tight_bang",
  [sym__any_prefix_bang] = "_any_prefix_bang",
  [sym__prefix_tilde] = "_prefix_tilde",
  [sym__tight_tilde] = "_tight_tilde",
  [sym__any_prefix_tilde] = "_any_prefix_tilde",
  [sym__prefix_percent] = "_prefix_percent",
  [sym__dotdot] = "_dotdot",
  [sym__paren_open] = "_paren_open",
  [sym__paren_close] = "_paren_close",
  [sym__bracket_open] = "_bracket_open",
  [sym__bracket_close] = "_bracket_close",
  [sym__unboxed_open] = "_unboxed_open",
  [sym__unboxed_close] = "_unboxed_close",
  [sym__where] = "_where",
  [sym__bar] = "_bar",
  [aux_sym__let_binds_repeat1] = "_let_binds_repeat1",
  [aux_sym__let_binds_repeat2] = "_let_binds_repeat2",
  [aux_sym_guards_repeat1] = "guards_repeat1",
  [aux_sym_type_params_repeat1] = "type_params_repeat1",
  [aux_sym_quantified_variables_repeat1] = "quantified_variables_repeat1",
  [aux_sym__type_tuple_elems_repeat1] = "_type_tuple_elems_repeat1",
  [aux_sym__type_unboxed_sum_repeat1] = "_type_unboxed_sum_repeat1",
  [aux_sym_type_patterns_repeat1] = "type_patterns_repeat1",
  [aux_sym_type_family_injectivity_repeat1] = "type_family_injectivity_repeat1",
  [aux_sym__tyfam_equations_repeat1] = "_tyfam_equations_repeat1",
  [aux_sym_role_annotation_repeat1] = "role_annotation_repeat1",
  [aux_sym__ctr_tuple_repeat1] = "_ctr_tuple_repeat1",
  [aux_sym__exp_tuple_elems_repeat1] = "_exp_tuple_elems_repeat1",
  [aux_sym__exp_tuple_elems_repeat2] = "_exp_tuple_elems_repeat2",
  [aux_sym__exp_unboxed_sum_repeat1] = "_exp_unboxed_sum_repeat1",
  [aux_sym__exp_list_repeat1] = "_exp_list_repeat1",
  [aux_sym_qualifiers_repeat1] = "qualifiers_repeat1",
  [aux_sym__exp_list_comprehension_repeat1] = "_exp_list_comprehension_repeat1",
  [aux_sym__statements_repeat1] = "_statements_repeat1",
  [aux_sym__matches_repeat1] = "_matches_repeat1",
  [aux_sym_alternatives_repeat1] = "alternatives_repeat1",
  [aux_sym__nalts_repeat1] = "_nalts_repeat1",
  [aux_sym__exp_multi_way_if_repeat1] = "_exp_multi_way_if_repeat1",
  [aux_sym__exp_record_repeat1] = "_exp_record_repeat1",
  [aux_sym__exp_projection_selector_repeat1] = "_exp_projection_selector_repeat1",
  [aux_sym__pat_tuple_elems_repeat1] = "_pat_tuple_elems_repeat1",
  [aux_sym__pat_record_repeat1] = "_pat_record_repeat1",
  [aux_sym_patterns_repeat1] = "patterns_repeat1",
  [aux_sym_module_repeat1] = "module_repeat1",
  [aux_sym_children_repeat1] = "children_repeat1",
  [aux_sym_import_list_repeat1] = "import_list_repeat1",
  [aux_sym_exports_repeat1] = "exports_repeat1",
  [aux_sym_imports_repeat1] = "imports_repeat1",
  [aux_sym_declarations_repeat1] = "declarations_repeat1",
  [aux_sym_field_path_repeat1] = "field_path_repeat1",
  [aux_sym_field_repeat1] = "field_repeat1",
  [aux_sym__record_fields_repeat1] = "_record_fields_repeat1",
  [aux_sym_gadt_constructors_repeat1] = "gadt_constructors_repeat1",
  [aux_sym__datacon_prefix_repeat1] = "_datacon_prefix_repeat1",
  [aux_sym_data_constructors_repeat1] = "data_constructors_repeat1",
  [aux_sym__data_repeat1] = "_data_repeat1",
  [aux_sym_fundeps_repeat1] = "fundeps_repeat1",
  [aux_sym_class_declarations_repeat1] = "class_declarations_repeat1",
  [aux_sym_instance_declarations_repeat1] = "instance_declarations_repeat1",
  [aux_sym_fixity_repeat1] = "fixity_repeat1",
  [aux_sym__con_binding_list_repeat1] = "_con_binding_list_repeat1",
  [aux_sym__var_binding_list_repeat1] = "_var_binding_list_repeat1",
  [aux_sym__bind_matches_repeat1] = "_bind_matches_repeat1",
  [aux_sym_local_binds_repeat1] = "local_binds_repeat1",
  [aux_sym_default_types_repeat1] = "default_types_repeat1",
  [aux_sym__patsyn_cons_repeat1] = "_patsyn_cons_repeat1",
  [aux_sym_quoted_decls_repeat1] = "quoted_decls_repeat1",
  [anon_alias_sym_LPAREN_POUND] = "(#",
  [alias_sym_all_names] = "all_names",
  [alias_sym_boolean] = "boolean",
  [alias_sym_constructor] = "constructor",
  [alias_sym_constructor_synonym] = "constructor_synonym",
  [alias_sym_export] = "export",
  [alias_sym_import_package] = "import_package",
  [alias_sym_module_id] = "module_id",
  [alias_sym_pattern_guard] = "pattern_guard",
  [alias_sym_prefix_list] = "prefix_list",
  [alias_sym_quoted_expression] = "quoted_expression",
  [alias_sym_quoted_pattern] = "quoted_pattern",
  [alias_sym_quoted_type] = "quoted_type",
  [alias_sym_type_application] = "type_application",
  [alias_sym_type_binder] = "type_binder",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_variable] = sym_variable,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym__] = anon_sym__,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_u2605] = anon_sym_u2605,
  [anon_sym_forall] = anon_sym_forall,
  [anon_sym_u2200] = anon_sym_u2200,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_instance] = anon_sym_instance,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_family] = anon_sym_family,
  [anon_sym_representational] = anon_sym_representational,
  [anon_sym_nominal] = anon_sym_nominal,
  [anon_sym_phantom] = anon_sym_phantom,
  [anon_sym_role] = anon_sym_role,
  [anon_sym_SQUOTE_SQUOTE] = anon_sym_SQUOTE_SQUOTE,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_group] = anon_sym_group,
  [anon_sym_by] = anon_sym_by,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_rec] = anon_sym_rec,
  [anon_sym_mdo] = anon_sym_mdo,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_cases] = anon_sym_cases,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_pattern] = anon_sym_pattern,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_qualified] = anon_sym_qualified,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_hiding] = anon_sym_hiding,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_via] = anon_sym_via,
  [anon_sym_stock] = anon_sym_stock,
  [anon_sym_newtype] = anon_sym_newtype,
  [anon_sym_anyclass] = anon_sym_anyclass,
  [anon_sym_deriving] = anon_sym_deriving,
  [anon_sym_data] = anon_sym_data,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_1] = anon_sym_1,
  [anon_sym_infixr] = anon_sym_infixr,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_infixl] = anon_sym_infixl,
  [anon_sym_infix] = anon_sym_infix,
  [sym_calling_convention] = sym_calling_convention,
  [sym_safety] = sym_safety,
  [anon_sym_foreign] = anon_sym_foreign,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_DOLLAR_DOLLAR] = anon_sym_DOLLAR_DOLLAR,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_PIPE_RBRACK] = anon_sym_PIPE_RBRACK,
  [anon_sym_u27e7] = anon_sym_u27e7,
  [anon_sym_u27e6] = anon_sym_u27e6,
  [anon_sym_e] = anon_sym_e,
  [anon_sym_t] = anon_sym_t,
  [anon_sym_p] = anon_sym_p,
  [anon_sym_d] = anon_sym_d,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_PIPE_PIPE_RBRACK] = anon_sym_PIPE_PIPE_RBRACK,
  [sym_float] = sym_float,
  [sym_char] = sym_char,
  [sym_string] = sym_string,
  [sym__integer_literal] = sym__integer_literal,
  [sym__binary_literal] = sym__binary_literal,
  [sym__octal_literal] = sym__octal_literal,
  [sym__hex_literal] = sym__hex_literal,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_POUND2] = anon_sym_POUND,
  [anon_sym_PIPE2] = anon_sym_PIPE,
  [sym_implicit_variable] = sym_implicit_variable,
  [sym_name] = sym_name,
  [sym_label] = sym_label,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_u21d2] = anon_sym_u21d2,
  [anon_sym_u2192] = anon_sym_u2192,
  [anon_sym_DASH_GT_DOT] = anon_sym_DASH_GT_DOT,
  [anon_sym_u22b8] = anon_sym_u22b8,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_u2190] = anon_sym_u2190,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_u2237] = anon_sym_u2237,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [aux_sym__paren_open_token1] = aux_sym__paren_open_token1,
  [aux_sym__paren_close_token1] = aux_sym__paren_close_token1,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_POUND_RPAREN] = anon_sym_POUND_RPAREN,
  [anon_sym_where] = anon_sym_where,
  [aux_sym__token1] = aux_sym__token1,
  [sym_error_sentinel] = sym_error_sentinel,
  [sym__cond_layout_semicolon] = sym__cond_layout_semicolon,
  [sym__cmd_layout_start] = sym__cmd_layout_start,
  [sym__cmd_layout_start_do] = sym__cmd_layout_start_do,
  [sym__cmd_layout_start_case] = sym__cmd_layout_start_case,
  [sym__cmd_layout_start_if] = sym__cmd_layout_start_if,
  [sym__cmd_layout_start_let] = sym__cmd_layout_start_let,
  [sym__cmd_layout_start_quote] = sym__cmd_layout_start_quote,
  [sym__cmd_layout_start_explicit] = anon_sym_LBRACE,
  [sym__cond_layout_end] = sym__cond_layout_end,
  [sym__cond_layout_end_explicit] = anon_sym_RBRACE,
  [sym__cmd_brace_open] = sym__cmd_brace_open,
  [sym__cmd_brace_close] = sym__cmd_brace_close,
  [sym__cmd_texp_start] = sym__cmd_texp_start,
  [sym__cmd_texp_end] = sym__cmd_texp_end,
  [sym__phantom_where] = sym__phantom_where,
  [sym__phantom_in] = sym__phantom_in,
  [sym__phantom_arrow] = sym__phantom_arrow,
  [sym__phantom_bar] = sym__phantom_bar,
  [sym__phantom_deriving] = sym__phantom_deriving,
  [sym_comment] = sym_comment,
  [sym_haddock] = sym_haddock,
  [sym_cpp] = sym_cpp,
  [sym_pragma] = sym_pragma,
  [sym__cond_quote_start] = sym__cond_quote_start,
  [sym_quasiquote_body] = sym_quasiquote_body,
  [sym__cond_splice] = sym__cond_splice,
  [sym__cond_qual_dot] = sym__cond_qual_dot,
  [sym__cond_tight_dot] = sym__cond_tight_dot,
  [sym__cond_prefix_dot] = sym__cond_prefix_dot,
  [sym__cond_dotdot] = sym__cond_dotdot,
  [sym__cond_tight_at] = sym__cond_tight_at,
  [sym__cond_prefix_at] = sym__cond_prefix_at,
  [sym__cond_tight_bang] = sym__cond_tight_bang,
  [sym__cond_prefix_bang] = sym__cond_prefix_bang,
  [sym__cond_tight_tilde] = sym__cond_tight_tilde,
  [sym__cond_prefix_tilde] = sym__cond_prefix_tilde,
  [sym__cond_prefix_percent] = sym__cond_prefix_percent,
  [sym__cond_qualified_op] = sym__cond_qualified_op,
  [sym__cond_left_section_op] = sym__cond_left_section_op,
  [sym__cond_no_section_op] = sym__cond_no_section_op,
  [sym__cond_minus] = sym__cond_minus,
  [sym__cond_context] = sym__cond_context,
  [sym__cond_infix] = sym__cond_infix,
  [sym__cond_data_infix] = sym__cond_data_infix,
  [sym__cond_assoc_tyinst] = sym__cond_assoc_tyinst,
  [sym__varsym] = sym__varsym,
  [sym__consym] = sym__consym,
  [sym_haskell] = sym_haskell,
  [sym_generator] = sym_generator,
  [sym__let_binds] = sym_local_binds,
  [sym_let] = sym_let,
  [sym_guard] = sym_guard,
  [sym_guards] = sym_guards,
  [sym__guards] = sym__guards,
  [sym__inferred_tyvar] = sym__inferred_tyvar,
  [sym__type_param_parens] = sym__type_param_parens,
  [sym__type_param_wildcard] = sym__type_param_wildcard,
  [sym__type_param_annotated] = sym__type_param_annotated,
  [sym__type_param_invisible] = sym__type_param_invisible,
  [sym_type_param] = sym_type_param,
  [sym__ktype_param] = sym__ktype_param,
  [sym_type_params] = sym_type_params,
  [sym_quantified_variables] = sym_quantified_variables,
  [sym__type_parens] = sym__type_param_parens,
  [sym__type_tuple_elems] = sym__type_tuple_elems,
  [sym__type_tuple] = sym__type_tuple,
  [sym__type_unboxed_tuple] = sym__type_unboxed_tuple,
  [sym__type_unboxed_sum] = sym__type_unboxed_sum,
  [sym__type_list] = sym__type_list,
  [sym__type_promoted] = sym__type_promoted,
  [sym__type_star] = sym__type_star,
  [sym__type_wildcard] = sym__type_param_wildcard,
  [sym__at_type] = sym__at_type,
  [sym__type_apply] = sym__type_apply,
  [sym__type_infix] = sym__type_infix,
  [sym_type] = sym_type,
  [sym__forall_keyword] = sym__forall_keyword,
  [sym__forall_body] = sym__forall_body,
  [sym_forall] = sym_forall,
  [sym_forall_required] = sym_forall_required,
  [sym__qtype_forall] = sym_forall,
  [sym__qtype_forall_required] = sym_forall_required,
  [sym__fun_arrow] = sym__fun_arrow,
  [sym_modifier] = sym_modifier,
  [sym__linear_fun_arrow] = sym__linear_fun_arrow,
  [sym_strict_field] = sym_strict_field,
  [sym_lazy_field] = sym_lazy_field,
  [sym__qtype_function] = sym_function,
  [sym__qtype_linear_function] = sym__qtype_linear_function,
  [sym__qtype_context] = sym_context,
  [sym_quantified_type] = sym_quantified_type,
  [sym__type_signature] = sym_signature,
  [sym__ktype] = sym__ktype,
  [sym__type_head_name] = sym__type_head_name,
  [sym__type_head_parens] = sym__type_param_parens,
  [sym__type_head_params] = sym__type_head_params,
  [sym__type_head_infix] = sym__type_infix,
  [sym__type_instance_head_parens] = sym__type_param_parens,
  [sym__type_instance_head_params] = sym__type_instance_head_params,
  [sym_type_patterns] = sym_type_patterns,
  [sym_type_synomym] = sym_type_synomym,
  [sym_kind_signature] = sym_kind_signature,
  [sym__type_instance_common] = sym__type_instance_common,
  [sym__type_instance] = sym__type_instance,
  [sym_type_instance] = sym_type_instance,
  [sym_type_family_result] = sym_type_family_result,
  [sym_type_family_injectivity] = sym_type_family_injectivity,
  [sym__tyfam_inj] = sym__tyfam_inj,
  [sym__tyfam] = sym__tyfam,
  [sym__tyfam_equations] = sym__tyfam_equations,
  [sym_abstract_family] = sym_abstract_family,
  [sym_type_family] = sym_type_family,
  [sym_type_role] = sym_type_role,
  [sym_role_annotation] = sym_role_annotation,
  [sym__class_apply] = sym__type_apply,
  [sym__class_infix] = sym__type_infix,
  [sym__ctr_parens] = sym__type_param_parens,
  [sym__ctr_tuple] = sym__type_tuple,
  [sym_implicit_parameter] = sym_implicit_parameter,
  [sym_constraint] = sym_constraint,
  [sym__ctr_forall] = sym_forall,
  [sym__ctr_context] = sym_context,
  [sym__ctr_signature] = sym_signature,
  [sym_constraints] = sym_constraints,
  [sym__context_inline] = sym__context_inline,
  [sym_context] = sym_context,
  [sym__exp_th_quoted_name] = sym__exp_th_quoted_name,
  [sym__exp_parens] = sym__type_param_parens,
  [sym__exp_tuple_elems] = sym__exp_tuple_elems,
  [sym__exp_tuple] = sym__type_tuple,
  [sym__exp_unboxed_tuple] = sym__type_unboxed_tuple,
  [sym__exp_unboxed_sum] = sym__type_unboxed_sum,
  [sym__exp_list] = sym__type_list,
  [sym__exp_arithmetic_sequence] = sym__exp_arithmetic_sequence,
  [sym_group] = sym_group,
  [sym_transform] = sym_transform,
  [sym_qualifier] = sym_qualifier,
  [sym_qualifiers] = sym_qualifiers,
  [sym__exp_list_comprehension] = sym__exp_list_comprehension,
  [sym__exp_lambda] = sym__exp_lambda,
  [sym__exp_let_in] = sym__exp_let_in,
  [sym__exp_conditional] = sym__exp_conditional,
  [sym__exp_statement] = sym__exp_statement,
  [sym_statement] = sym_statement,
  [sym__statements] = sym__statements,
  [sym_rec] = sym_rec,
  [sym__do_keyword] = sym__do_keyword,
  [sym_do_module] = sym_do_module,
  [sym__do] = sym__do,
  [sym__exp_do] = sym__exp_do,
  [sym_match] = sym_match,
  [sym__simple_match] = sym_match,
  [sym__matches] = sym__matches,
  [sym_alternative] = sym_alternative,
  [sym__nalt] = sym_alternative,
  [sym_alternatives] = sym_alternatives,
  [sym__nalts] = sym_alternatives,
  [sym__exp_case] = sym__exp_case,
  [sym__exp_lambda_case] = sym__exp_lambda_case,
  [sym__exp_lambda_cases] = sym__exp_lambda_cases,
  [sym__exp_multi_way_if] = sym__exp_multi_way_if,
  [sym_field_update] = sym_field_update,
  [sym__exp_record] = sym__exp_record,
  [sym__exp_projection_selector] = sym__exp_projection_selector,
  [sym__exp_projection] = sym__exp_projection,
  [sym_explicit_type] = sym_explicit_type,
  [sym__exp_apply] = sym__type_apply,
  [sym__exp_op] = sym__exp_op,
  [sym__exp_section_left] = sym__exp_section_left,
  [sym__exp_section_right] = sym__exp_section_right,
  [sym__exp_negation] = sym__exp_negation,
  [sym__exp_infix] = sym__type_infix,
  [sym_expression] = sym_expression,
  [sym__exp_signature] = sym_signature,
  [sym__exp] = sym__exp,
  [sym__pat_parens] = sym__type_param_parens,
  [sym__pat_tuple_elems] = sym__pat_tuple_elems,
  [sym__pat_tuple] = sym__type_tuple,
  [sym__pat_unboxed_tuple] = sym__type_unboxed_tuple,
  [sym__pat_unboxed_sum] = sym__type_unboxed_sum,
  [sym__pat_list] = sym__type_list,
  [sym_field_pattern] = sym_field_pattern,
  [sym__pat_record] = sym__exp_record,
  [sym__pat_as] = sym__pat_as,
  [sym__pat_wildcard] = sym__type_param_wildcard,
  [sym__pat_strict] = sym__pat_strict,
  [sym__pat_irrefutable] = sym__pat_irrefutable,
  [sym__pat_apply] = sym__type_apply,
  [sym__pat_negation] = sym__exp_negation,
  [sym__pat_infix] = sym__type_infix,
  [sym_pattern] = sym_pattern,
  [sym_patterns] = sym_patterns,
  [sym__pat_signature] = sym_signature,
  [sym__pat] = sym__pat,
  [sym_view_pattern] = sym_view_pattern,
  [sym__modid_prefix] = sym__modid_prefix,
  [aux_sym__qualifying_module] = aux_sym__qualifying_module,
  [sym_module] = sym_module,
  [sym_namespace] = sym_namespace,
  [sym__child_type] = sym__child_type,
  [sym__child] = sym__child,
  [sym_children] = sym_children,
  [sym__ie_entity] = sym__ie_entity,
  [sym_import_list] = sym_import_list,
  [sym_import] = sym_import,
  [sym_module_export] = sym_module_export,
  [sym_exports] = sym_exports,
  [sym_header] = sym_header,
  [sym_imports] = sym_imports,
  [sym_declarations] = sym_declarations,
  [sym__body] = sym__body,
  [sym__layout_end] = sym__layout_end,
  [sym_declaration] = sym_declaration,
  [sym_field_name] = sym_field_name,
  [sym__qfield_name] = sym__qfield_name,
  [sym__field_names] = sym__field_names,
  [sym_field_path] = sym_field_path,
  [sym__field_spec] = sym__field_spec,
  [sym_field] = sym_field,
  [sym__record_fields] = sym__record_fields,
  [sym_via] = sym_via,
  [sym_deriving_strategy] = sym_deriving_strategy,
  [sym_deriving] = sym_deriving,
  [sym__gadt_con_prefix] = sym__gadt_con_prefix,
  [sym__gadt_con_record] = sym__exp_record,
  [sym_gadt_constructor] = sym_gadt_constructor,
  [sym_gadt_constructors] = sym_gadt_constructors,
  [sym__gadt] = sym__gadt,
  [sym__datacon_prefix] = sym__gadt_con_prefix,
  [sym__datacon_infix] = sym__type_infix,
  [sym__datacon_record] = sym__exp_record,
  [sym__datacon_unboxed_sum] = sym__type_unboxed_sum,
  [sym__datacon_special] = sym__datacon_special,
  [sym_data_constructor] = sym_data_constructor,
  [sym_data_constructors] = sym_data_constructors,
  [sym__data_rhs] = sym__data_rhs,
  [sym__data] = sym__data,
  [sym_data_type] = sym_data_type,
  [sym__newtype_con_field] = sym_field,
  [sym_newtype_constructor] = sym_newtype_constructor,
  [sym__newtype] = sym__newtype,
  [sym_newtype] = sym_newtype,
  [sym__datafam] = sym__datafam,
  [sym_data_family] = sym_data_family,
  [sym__inst_adt] = sym__inst_adt,
  [sym_decl_inst_adt] = sym_data_type,
  [sym__inst_newtype] = sym__inst_newtype,
  [sym_decl_inst_newtype] = sym_newtype,
  [sym_data_instance] = sym_data_instance,
  [sym__assoc_tyfam] = sym_type_family,
  [sym__assoc_tyinst] = sym_type_instance,
  [sym__assoc_datafam] = sym_data_family,
  [sym__assoc_datainst_adt] = sym_data_type,
  [sym__assoc_datainst_newtype] = sym_newtype,
  [sym__assoc_datainst] = sym_data_instance,
  [sym_default_signature] = sym_default_signature,
  [sym_class_decl] = sym_class_decl,
  [sym_fundep] = sym_fundep,
  [sym_fundeps] = sym_fundeps,
  [sym_class_declarations] = sym_class_declarations,
  [sym_class] = sym_class,
  [sym_instance_decl] = sym_instance_decl,
  [sym_instance_declarations] = sym_instance_declarations,
  [sym__instance] = sym__instance,
  [sym_instance] = sym_instance,
  [sym_deriving_instance] = sym_deriving_instance,
  [sym__fun_arrow_prec] = sym_integer,
  [sym__fun_arrow_fixity] = sym__fun_arrow_fixity,
  [sym_fixity] = sym_fixity,
  [sym__con_binding_list] = sym__con_binding_list,
  [sym__var_binding_list] = sym__con_binding_list,
  [sym_signature] = sym_signature,
  [sym__simple_bind_match] = sym_match,
  [sym__bind_match] = sym_match,
  [sym__bind_matches] = sym__bind_matches,
  [sym__function_name] = sym__function_name,
  [sym_function_head_parens] = sym_function_head_parens,
  [sym__function_head_infix] = sym__type_infix,
  [sym_function] = sym_function,
  [sym_bind] = sym_bind,
  [sym_decl] = sym_decl,
  [sym__local_decl] = sym__local_decl,
  [sym_local_binds] = sym_local_binds,
  [sym__where_binds] = sym__where_binds,
  [sym_entity] = sym_entity,
  [sym_foreign_import] = sym_foreign_import,
  [sym_foreign_export] = sym_foreign_export,
  [sym_default_types] = sym_default_types,
  [sym__patsyn_signature] = sym_signature,
  [sym__patsyn_cons] = sym__patsyn_cons,
  [sym__patsyn_equation] = sym__patsyn_equation,
  [sym_pattern_synonym] = sym_pattern_synonym,
  [sym__splice_exp] = sym__splice_exp,
  [sym__splice_dollars] = sym__splice_dollars,
  [sym_splice] = sym_splice,
  [sym_top_splice] = sym_top_splice,
  [sym_quoter] = sym_quoter,
  [sym_quasiquote] = sym_quasiquote,
  [sym_quoted_decls] = sym_quoted_decls,
  [sym__exp_quote] = sym__exp_quote,
  [sym__exp_typed_quote] = sym__exp_typed_quote,
  [sym_integer] = sym_integer,
  [sym__plist] = sym__plist,
  [sym_unit] = sym_unit,
  [sym_unboxed_unit] = sym_unboxed_unit,
  [sym_prefix_tuple] = sym_prefix_tuple,
  [sym_prefix_unboxed_tuple] = sym_prefix_unboxed_tuple,
  [sym_prefix_unboxed_sum] = sym_prefix_unboxed_sum,
  [sym_literal] = sym_literal,
  [sym__qualified_variable] = sym__qfield_name,
  [sym__qvarid] = sym__qvarid,
  [sym__qvar] = sym__qvar,
  [sym__variable_ticked] = sym__variable_ticked,
  [sym__qvariable_ticked] = sym__variable_ticked,
  [sym__qualified_constructor] = sym__qfield_name,
  [sym__qconid] = sym__qconid,
  [sym__constructor_ticked] = sym__variable_ticked,
  [sym__qconstructor_ticked] = sym__variable_ticked,
  [sym__qualified_type] = sym__qfield_name,
  [sym__qtyconid] = sym__qtyconid,
  [sym__tycon_arrow] = sym__tycon_arrow,
  [sym__qualified_arrow] = sym__qfield_name,
  [sym__qtycon_arrow] = sym__tycon_arrow,
  [sym__promoted_tycons_alias] = sym__type_promoted,
  [sym__promoted_tycons] = sym__promoted_tycons,
  [sym__tycon_ticked] = sym__variable_ticked,
  [sym__qtycon_ticked] = sym__variable_ticked,
  [sym__tyconids_ticked] = sym__tyconids_ticked,
  [sym__promoted_tyconops_alias] = sym__type_promoted,
  [sym__promoted_tyconops] = sym__promoted_tyconops,
  [sym__ops] = sym__ops,
  [sym__qname] = sym__qname,
  [sym__operator_qual_dot_head] = sym_operator,
  [sym__operator_hash_head] = sym__operator_hash_head,
  [sym_operator] = sym_operator,
  [sym__operator_alias] = sym__operator_alias,
  [sym__operator_minus] = sym__operator_minus,
  [sym__varsym_prefix] = sym__tycon_arrow,
  [sym__pvarsym] = sym__pvarsym,
  [sym__qualified_varsym] = sym__qfield_name,
  [sym__qvarsym_prefix] = sym__tycon_arrow,
  [sym__pqvarsym] = sym__pqvarsym,
  [sym_constructor_operator] = sym_constructor_operator,
  [sym__constructor_operator_alias] = sym__constructor_operator_alias,
  [sym__consym_prefix] = sym__tycon_arrow,
  [sym__pconsym] = sym__pconsym,
  [sym__qualified_consym] = sym__qfield_name,
  [sym__qconsym_prefix] = sym__tycon_arrow,
  [sym__pqconsym] = sym__pqconsym,
  [sym__sym_prefix] = sym__sym_prefix,
  [sym__carrow] = sym__carrow,
  [sym__arrow] = sym__arrow,
  [sym__linear_arrow] = sym__linear_arrow,
  [sym__larrow] = sym__larrow,
  [sym__colon2] = sym__colon2,
  [sym__qual_dot] = sym__qual_dot,
  [sym__tight_dot] = sym__tight_dot,
  [sym__prefix_dot] = sym__prefix_dot,
  [sym__tight_at] = sym__tight_at,
  [sym__prefix_at] = sym__prefix_at,
  [sym__prefix_bang] = sym__prefix_bang,
  [sym__tight_bang] = sym__tight_bang,
  [sym__any_prefix_bang] = sym__any_prefix_bang,
  [sym__prefix_tilde] = sym__prefix_tilde,
  [sym__tight_tilde] = sym__tight_tilde,
  [sym__any_prefix_tilde] = sym__any_prefix_tilde,
  [sym__prefix_percent] = sym__prefix_percent,
  [sym__dotdot] = sym__dotdot,
  [sym__paren_open] = sym__paren_open,
  [sym__paren_close] = sym__paren_close,
  [sym__bracket_open] = sym__bracket_open,
  [sym__bracket_close] = sym__bracket_close,
  [sym__unboxed_open] = sym__unboxed_open,
  [sym__unboxed_close] = sym__unboxed_close,
  [sym__where] = sym__where,
  [sym__bar] = sym__bar,
  [aux_sym__let_binds_repeat1] = aux_sym__let_binds_repeat1,
  [aux_sym__let_binds_repeat2] = aux_sym__let_binds_repeat2,
  [aux_sym_guards_repeat1] = aux_sym_guards_repeat1,
  [aux_sym_type_params_repeat1] = aux_sym_type_params_repeat1,
  [aux_sym_quantified_variables_repeat1] = aux_sym_quantified_variables_repeat1,
  [aux_sym__type_tuple_elems_repeat1] = aux_sym__type_tuple_elems_repeat1,
  [aux_sym__type_unboxed_sum_repeat1] = aux_sym__type_unboxed_sum_repeat1,
  [aux_sym_type_patterns_repeat1] = aux_sym_type_patterns_repeat1,
  [aux_sym_type_family_injectivity_repeat1] = aux_sym_type_family_injectivity_repeat1,
  [aux_sym__tyfam_equations_repeat1] = aux_sym__tyfam_equations_repeat1,
  [aux_sym_role_annotation_repeat1] = aux_sym_role_annotation_repeat1,
  [aux_sym__ctr_tuple_repeat1] = aux_sym__ctr_tuple_repeat1,
  [aux_sym__exp_tuple_elems_repeat1] = aux_sym__exp_tuple_elems_repeat1,
  [aux_sym__exp_tuple_elems_repeat2] = aux_sym__exp_tuple_elems_repeat2,
  [aux_sym__exp_unboxed_sum_repeat1] = aux_sym__exp_unboxed_sum_repeat1,
  [aux_sym__exp_list_repeat1] = aux_sym__exp_list_repeat1,
  [aux_sym_qualifiers_repeat1] = aux_sym_qualifiers_repeat1,
  [aux_sym__exp_list_comprehension_repeat1] = aux_sym__exp_list_comprehension_repeat1,
  [aux_sym__statements_repeat1] = aux_sym__statements_repeat1,
  [aux_sym__matches_repeat1] = aux_sym__matches_repeat1,
  [aux_sym_alternatives_repeat1] = aux_sym_alternatives_repeat1,
  [aux_sym__nalts_repeat1] = aux_sym__nalts_repeat1,
  [aux_sym__exp_multi_way_if_repeat1] = aux_sym__exp_multi_way_if_repeat1,
  [aux_sym__exp_record_repeat1] = aux_sym__exp_record_repeat1,
  [aux_sym__exp_projection_selector_repeat1] = aux_sym__exp_projection_selector_repeat1,
  [aux_sym__pat_tuple_elems_repeat1] = aux_sym__pat_tuple_elems_repeat1,
  [aux_sym__pat_record_repeat1] = aux_sym__pat_record_repeat1,
  [aux_sym_patterns_repeat1] = aux_sym_patterns_repeat1,
  [aux_sym_module_repeat1] = aux_sym_module_repeat1,
  [aux_sym_children_repeat1] = aux_sym_children_repeat1,
  [aux_sym_import_list_repeat1] = aux_sym_import_list_repeat1,
  [aux_sym_exports_repeat1] = aux_sym_exports_repeat1,
  [aux_sym_imports_repeat1] = aux_sym_imports_repeat1,
  [aux_sym_declarations_repeat1] = aux_sym_declarations_repeat1,
  [aux_sym_field_path_repeat1] = aux_sym_field_path_repeat1,
  [aux_sym_field_repeat1] = aux_sym_field_repeat1,
  [aux_sym__record_fields_repeat1] = aux_sym__record_fields_repeat1,
  [aux_sym_gadt_constructors_repeat1] = aux_sym_gadt_constructors_repeat1,
  [aux_sym__datacon_prefix_repeat1] = aux_sym__datacon_prefix_repeat1,
  [aux_sym_data_constructors_repeat1] = aux_sym_data_constructors_repeat1,
  [aux_sym__data_repeat1] = aux_sym__data_repeat1,
  [aux_sym_fundeps_repeat1] = aux_sym_fundeps_repeat1,
  [aux_sym_class_declarations_repeat1] = aux_sym_class_declarations_repeat1,
  [aux_sym_instance_declarations_repeat1] = aux_sym_instance_declarations_repeat1,
  [aux_sym_fixity_repeat1] = aux_sym_fixity_repeat1,
  [aux_sym__con_binding_list_repeat1] = aux_sym__con_binding_list_repeat1,
  [aux_sym__var_binding_list_repeat1] = aux_sym__var_binding_list_repeat1,
  [aux_sym__bind_matches_repeat1] = aux_sym__bind_matches_repeat1,
  [aux_sym_local_binds_repeat1] = aux_sym_local_binds_repeat1,
  [aux_sym_default_types_repeat1] = aux_sym_default_types_repeat1,
  [aux_sym__patsyn_cons_repeat1] = aux_sym__patsyn_cons_repeat1,
  [aux_sym_quoted_decls_repeat1] = aux_sym_quoted_decls_repeat1,
  [anon_alias_sym_LPAREN_POUND] = anon_alias_sym_LPAREN_POUND,
  [alias_sym_all_names] = alias_sym_all_names,
  [alias_sym_boolean] = alias_sym_boolean,
  [alias_sym_constructor] = alias_sym_constructor,
  [alias_sym_constructor_synonym] = alias_sym_constructor_synonym,
  [alias_sym_export] = alias_sym_export,
  [alias_sym_import_package] = alias_sym_import_package,
  [alias_sym_module_id] = alias_sym_module_id,
  [alias_sym_pattern_guard] = alias_sym_pattern_guard,
  [alias_sym_prefix_list] = alias_sym_prefix_list,
  [alias_sym_quoted_expression] = alias_sym_quoted_expression,
  [alias_sym_quoted_pattern] = alias_sym_quoted_pattern,
  [alias_sym_quoted_type] = alias_sym_quoted_type,
  [alias_sym_type_application] = alias_sym_type_application,
  [alias_sym_type_binder] = alias_sym_type_binder,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_variable] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2605] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_forall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2200] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instance] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_family] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_representational] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nominal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_phantom] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_role] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_group] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_by] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mdo] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cases] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pattern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_qualified] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hiding] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_via] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_stock] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_newtype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_anyclass] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_deriving] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_data] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infixr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infixl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infix] = {
    .visible = true,
    .named = false,
  },
  [sym_calling_convention] = {
    .visible = true,
    .named = true,
  },
  [sym_safety] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_foreign] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u27e7] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u27e6] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_e] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_t] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_p] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_d] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_char] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym__integer_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__octal_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__hex_literal] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE2] = {
    .visible = true,
    .named = false,
  },
  [sym_implicit_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_name] = {
    .visible = true,
    .named = true,
  },
  [sym_label] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u21d2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2192] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u22b8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2190] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2237] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__paren_open_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__paren_close_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__token1] = {
    .visible = false,
    .named = false,
  },
  [sym_error_sentinel] = {
    .visible = true,
    .named = true,
  },
  [sym__cond_layout_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__cmd_layout_start] = {
    .visible = false,
    .named = true,
  },
  [sym__cmd_layout_start_do] = {
    .visible = false,
    .named = true,
  },
  [sym__cmd_layout_start_case] = {
    .visible = false,
    .named = true,
  },
  [sym__cmd_layout_start_if] = {
    .visible = false,
    .named = true,
  },
  [sym__cmd_layout_start_let] = {
    .visible = false,
    .named = true,
  },
  [sym__cmd_layout_start_quote] = {
    .visible = false,
    .named = true,
  },
  [sym__cmd_layout_start_explicit] = {
    .visible = true,
    .named = false,
  },
  [sym__cond_layout_end] = {
    .visible = false,
    .named = true,
  },
  [sym__cond_layout_end_explicit] = {
    .visible = true,
    .named = false,
  },
  [sym__cmd_brace_open] = {
    .visible = false,
    .named = true,
  },
  [sym__cmd_brace_close] = {
    .visible = false,
    .named = true,
  },
  [sym__cmd_texp_start] = {
    .visible = false,
    .named = true,
  },
  [sym__cmd_texp_end] = {
    .visible = false,
    .named = true,
  },
  [sym__phantom_where] = {
    .visible = false,
    .named = true,
  },
  [sym__phantom_in] = {
    .visible = false,
    .named = true,
  },
  [sym__phantom_arrow] = {
    .visible = false,
    .named = true,
  },
  [sym__phantom_bar] = {
    .visible = false,
    .named = true,
  },
  [sym__phantom_deriving] = {
    .visible = false,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_haddock] = {
    .visible = true,
    .named = true,
  },
  [sym_cpp] = {
    .visible = true,
    .named = true,
  },
  [sym_pragma] = {
    .visible = true,
    .named = true,
  },
  [sym__cond_quote_start] = {
    .visible = false,
    .named = true,
  },
  [sym_quasiquote_body] = {
    .visible = true,
    .named = true,
  },
  [sym__cond_splice] = {
    .visible = false,
    .named = true,
  },
  [sym__cond_qual_dot] = {
    .visible = false,
    .named = true,
  },
  [sym__cond_tight_dot] = {
    .visible = false,
    .named = true,
  },
  [sym__cond_prefix_dot] = {
    .visible = false,
    .named = true,
  },
  [sym__cond_dotdot] = {
    .visible = false,
    .named = true,
  },
  [sym__cond_tight_at] = {
    .visible = false,
    .named = true,
  },
  [sym__cond_prefix_at] = {
    .visible = false,
    .named = true,
  },
  [sym__cond_tight_bang] = {
    .visible = false,
    .named = true,
  },
  [sym__cond_prefix_bang] = {
    .visible = false,
    .named = true,
  },
  [sym__cond_tight_tilde] = {
    .visible = false,
    .named = true,
  },
  [sym__cond_prefix_tilde] = {
    .visible = false,
    .named = true,
  },
  [sym__cond_prefix_percent] = {
    .visible = false,
    .named = true,
  },
  [sym__cond_qualified_op] = {
    .visible = false,
    .named = true,
  },
  [sym__cond_left_section_op] = {
    .visible = false,
    .named = true,
  },
  [sym__cond_no_section_op] = {
    .visible = false,
    .named = true,
  },
  [sym__cond_minus] = {
    .visible = false,
    .named = true,
  },
  [sym__cond_context] = {
    .visible = false,
    .named = true,
  },
  [sym__cond_infix] = {
    .visible = false,
    .named = true,
  },
  [sym__cond_data_infix] = {
    .visible = false,
    .named = true,
  },
  [sym__cond_assoc_tyinst] = {
    .visible = false,
    .named = true,
  },
  [sym__varsym] = {
    .visible = false,
    .named = true,
  },
  [sym__consym] = {
    .visible = false,
    .named = true,
  },
  [sym_haskell] = {
    .visible = true,
    .named = true,
  },
  [sym_generator] = {
    .visible = true,
    .named = true,
  },
  [sym__let_binds] = {
    .visible = true,
    .named = true,
  },
  [sym_let] = {
    .visible = true,
    .named = true,
  },
  [sym_guard] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_guards] = {
    .visible = true,
    .named = true,
  },
  [sym__guards] = {
    .visible = false,
    .named = true,
  },
  [sym__inferred_tyvar] = {
    .visible = true,
    .named = true,
  },
  [sym__type_param_parens] = {
    .visible = true,
    .named = true,
  },
  [sym__type_param_wildcard] = {
    .visible = true,
    .named = true,
  },
  [sym__type_param_annotated] = {
    .visible = true,
    .named = true,
  },
  [sym__type_param_invisible] = {
    .visible = true,
    .named = true,
  },
  [sym_type_param] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__ktype_param] = {
    .visible = false,
    .named = true,
  },
  [sym_type_params] = {
    .visible = true,
    .named = true,
  },
  [sym_quantified_variables] = {
    .visible = true,
    .named = true,
  },
  [sym__type_parens] = {
    .visible = true,
    .named = true,
  },
  [sym__type_tuple_elems] = {
    .visible = false,
    .named = true,
  },
  [sym__type_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym__type_unboxed_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym__type_unboxed_sum] = {
    .visible = true,
    .named = true,
  },
  [sym__type_list] = {
    .visible = true,
    .named = true,
  },
  [sym__type_promoted] = {
    .visible = true,
    .named = true,
  },
  [sym__type_star] = {
    .visible = true,
    .named = true,
  },
  [sym__type_wildcard] = {
    .visible = true,
    .named = true,
  },
  [sym__at_type] = {
    .visible = true,
    .named = true,
  },
  [sym__type_apply] = {
    .visible = true,
    .named = true,
  },
  [sym__type_infix] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__forall_keyword] = {
    .visible = false,
    .named = true,
  },
  [sym__forall_body] = {
    .visible = false,
    .named = true,
  },
  [sym_forall] = {
    .visible = true,
    .named = true,
  },
  [sym_forall_required] = {
    .visible = true,
    .named = true,
  },
  [sym__qtype_forall] = {
    .visible = true,
    .named = true,
  },
  [sym__qtype_forall_required] = {
    .visible = true,
    .named = true,
  },
  [sym__fun_arrow] = {
    .visible = false,
    .named = true,
  },
  [sym_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym__linear_fun_arrow] = {
    .visible = false,
    .named = true,
  },
  [sym_strict_field] = {
    .visible = true,
    .named = true,
  },
  [sym_lazy_field] = {
    .visible = true,
    .named = true,
  },
  [sym__qtype_function] = {
    .visible = true,
    .named = true,
  },
  [sym__qtype_linear_function] = {
    .visible = true,
    .named = true,
  },
  [sym__qtype_context] = {
    .visible = true,
    .named = true,
  },
  [sym_quantified_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__type_signature] = {
    .visible = true,
    .named = true,
  },
  [sym__ktype] = {
    .visible = false,
    .named = true,
  },
  [sym__type_head_name] = {
    .visible = false,
    .named = true,
  },
  [sym__type_head_parens] = {
    .visible = true,
    .named = true,
  },
  [sym__type_head_params] = {
    .visible = false,
    .named = true,
  },
  [sym__type_head_infix] = {
    .visible = true,
    .named = true,
  },
  [sym__type_instance_head_parens] = {
    .visible = true,
    .named = true,
  },
  [sym__type_instance_head_params] = {
    .visible = false,
    .named = true,
  },
  [sym_type_patterns] = {
    .visible = true,
    .named = true,
  },
  [sym_type_synomym] = {
    .visible = true,
    .named = true,
  },
  [sym_kind_signature] = {
    .visible = true,
    .named = true,
  },
  [sym__type_instance_common] = {
    .visible = false,
    .named = true,
  },
  [sym__type_instance] = {
    .visible = false,
    .named = true,
  },
  [sym_type_instance] = {
    .visible = true,
    .named = true,
  },
  [sym_type_family_result] = {
    .visible = true,
    .named = true,
  },
  [sym_type_family_injectivity] = {
    .visible = true,
    .named = true,
  },
  [sym__tyfam_inj] = {
    .visible = false,
    .named = true,
  },
  [sym__tyfam] = {
    .visible = false,
    .named = true,
  },
  [sym__tyfam_equations] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_family] = {
    .visible = true,
    .named = true,
  },
  [sym_type_family] = {
    .visible = true,
    .named = true,
  },
  [sym_type_role] = {
    .visible = true,
    .named = true,
  },
  [sym_role_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__class_apply] = {
    .visible = true,
    .named = true,
  },
  [sym__class_infix] = {
    .visible = true,
    .named = true,
  },
  [sym__ctr_parens] = {
    .visible = true,
    .named = true,
  },
  [sym__ctr_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_implicit_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__ctr_forall] = {
    .visible = true,
    .named = true,
  },
  [sym__ctr_context] = {
    .visible = true,
    .named = true,
  },
  [sym__ctr_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_constraints] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__context_inline] = {
    .visible = false,
    .named = true,
  },
  [sym_context] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_th_quoted_name] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_parens] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_tuple_elems] = {
    .visible = false,
    .named = true,
  },
  [sym__exp_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_unboxed_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_unboxed_sum] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_list] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_arithmetic_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_group] = {
    .visible = true,
    .named = true,
  },
  [sym_transform] = {
    .visible = true,
    .named = true,
  },
  [sym_qualifier] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_qualifiers] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_list_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_let_in] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_conditional] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__statements] = {
    .visible = false,
    .named = true,
  },
  [sym_rec] = {
    .visible = true,
    .named = true,
  },
  [sym__do_keyword] = {
    .visible = false,
    .named = true,
  },
  [sym_do_module] = {
    .visible = true,
    .named = true,
  },
  [sym__do] = {
    .visible = false,
    .named = true,
  },
  [sym__exp_do] = {
    .visible = true,
    .named = true,
  },
  [sym_match] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_match] = {
    .visible = true,
    .named = true,
  },
  [sym__matches] = {
    .visible = false,
    .named = true,
  },
  [sym_alternative] = {
    .visible = true,
    .named = true,
  },
  [sym__nalt] = {
    .visible = true,
    .named = true,
  },
  [sym_alternatives] = {
    .visible = true,
    .named = true,
  },
  [sym__nalts] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_case] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_lambda_case] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_lambda_cases] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_multi_way_if] = {
    .visible = true,
    .named = true,
  },
  [sym_field_update] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_record] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_projection_selector] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_projection] = {
    .visible = true,
    .named = true,
  },
  [sym_explicit_type] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_apply] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_op] = {
    .visible = false,
    .named = true,
  },
  [sym__exp_section_left] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_section_right] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_negation] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_infix] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__exp_signature] = {
    .visible = true,
    .named = true,
  },
  [sym__exp] = {
    .visible = false,
    .named = true,
  },
  [sym__pat_parens] = {
    .visible = true,
    .named = true,
  },
  [sym__pat_tuple_elems] = {
    .visible = false,
    .named = true,
  },
  [sym__pat_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym__pat_unboxed_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym__pat_unboxed_sum] = {
    .visible = true,
    .named = true,
  },
  [sym__pat_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__pat_record] = {
    .visible = true,
    .named = true,
  },
  [sym__pat_as] = {
    .visible = true,
    .named = true,
  },
  [sym__pat_wildcard] = {
    .visible = true,
    .named = true,
  },
  [sym__pat_strict] = {
    .visible = true,
    .named = true,
  },
  [sym__pat_irrefutable] = {
    .visible = true,
    .named = true,
  },
  [sym__pat_apply] = {
    .visible = true,
    .named = true,
  },
  [sym__pat_negation] = {
    .visible = true,
    .named = true,
  },
  [sym__pat_infix] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_patterns] = {
    .visible = true,
    .named = true,
  },
  [sym__pat_signature] = {
    .visible = true,
    .named = true,
  },
  [sym__pat] = {
    .visible = false,
    .named = true,
  },
  [sym_view_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__modid_prefix] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__qualifying_module] = {
    .visible = false,
    .named = false,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace] = {
    .visible = true,
    .named = true,
  },
  [sym__child_type] = {
    .visible = true,
    .named = true,
  },
  [sym__child] = {
    .visible = false,
    .named = true,
  },
  [sym_children] = {
    .visible = true,
    .named = true,
  },
  [sym__ie_entity] = {
    .visible = true,
    .named = true,
  },
  [sym_import_list] = {
    .visible = true,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_module_export] = {
    .visible = true,
    .named = true,
  },
  [sym_exports] = {
    .visible = true,
    .named = true,
  },
  [sym_header] = {
    .visible = true,
    .named = true,
  },
  [sym_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_declarations] = {
    .visible = true,
    .named = true,
  },
  [sym__body] = {
    .visible = false,
    .named = true,
  },
  [sym__layout_end] = {
    .visible = false,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_field_name] = {
    .visible = true,
    .named = true,
  },
  [sym__qfield_name] = {
    .visible = true,
    .named = true,
  },
  [sym__field_names] = {
    .visible = false,
    .named = true,
  },
  [sym_field_path] = {
    .visible = true,
    .named = true,
  },
  [sym__field_spec] = {
    .visible = false,
    .named = true,
  },
  [sym_field] = {
    .visible = true,
    .named = true,
  },
  [sym__record_fields] = {
    .visible = true,
    .named = true,
  },
  [sym_via] = {
    .visible = true,
    .named = true,
  },
  [sym_deriving_strategy] = {
    .visible = true,
    .named = true,
  },
  [sym_deriving] = {
    .visible = true,
    .named = true,
  },
  [sym__gadt_con_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym__gadt_con_record] = {
    .visible = true,
    .named = true,
  },
  [sym_gadt_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym_gadt_constructors] = {
    .visible = true,
    .named = true,
  },
  [sym__gadt] = {
    .visible = false,
    .named = true,
  },
  [sym__datacon_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym__datacon_infix] = {
    .visible = true,
    .named = true,
  },
  [sym__datacon_record] = {
    .visible = true,
    .named = true,
  },
  [sym__datacon_unboxed_sum] = {
    .visible = true,
    .named = true,
  },
  [sym__datacon_special] = {
    .visible = true,
    .named = true,
  },
  [sym_data_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym_data_constructors] = {
    .visible = true,
    .named = true,
  },
  [sym__data_rhs] = {
    .visible = false,
    .named = true,
  },
  [sym__data] = {
    .visible = false,
    .named = true,
  },
  [sym_data_type] = {
    .visible = true,
    .named = true,
  },
  [sym__newtype_con_field] = {
    .visible = true,
    .named = true,
  },
  [sym_newtype_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym__newtype] = {
    .visible = false,
    .named = true,
  },
  [sym_newtype] = {
    .visible = true,
    .named = true,
  },
  [sym__datafam] = {
    .visible = false,
    .named = true,
  },
  [sym_data_family] = {
    .visible = true,
    .named = true,
  },
  [sym__inst_adt] = {
    .visible = false,
    .named = true,
  },
  [sym_decl_inst_adt] = {
    .visible = true,
    .named = true,
  },
  [sym__inst_newtype] = {
    .visible = false,
    .named = true,
  },
  [sym_decl_inst_newtype] = {
    .visible = true,
    .named = true,
  },
  [sym_data_instance] = {
    .visible = true,
    .named = true,
  },
  [sym__assoc_tyfam] = {
    .visible = true,
    .named = true,
  },
  [sym__assoc_tyinst] = {
    .visible = true,
    .named = true,
  },
  [sym__assoc_datafam] = {
    .visible = true,
    .named = true,
  },
  [sym__assoc_datainst_adt] = {
    .visible = true,
    .named = true,
  },
  [sym__assoc_datainst_newtype] = {
    .visible = true,
    .named = true,
  },
  [sym__assoc_datainst] = {
    .visible = true,
    .named = true,
  },
  [sym_default_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_class_decl] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_fundep] = {
    .visible = true,
    .named = true,
  },
  [sym_fundeps] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declarations] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_instance_decl] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_instance_declarations] = {
    .visible = true,
    .named = true,
  },
  [sym__instance] = {
    .visible = false,
    .named = true,
  },
  [sym_instance] = {
    .visible = true,
    .named = true,
  },
  [sym_deriving_instance] = {
    .visible = true,
    .named = true,
  },
  [sym__fun_arrow_prec] = {
    .visible = true,
    .named = true,
  },
  [sym__fun_arrow_fixity] = {
    .visible = false,
    .named = true,
  },
  [sym_fixity] = {
    .visible = true,
    .named = true,
  },
  [sym__con_binding_list] = {
    .visible = true,
    .named = true,
  },
  [sym__var_binding_list] = {
    .visible = true,
    .named = true,
  },
  [sym_signature] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_bind_match] = {
    .visible = true,
    .named = true,
  },
  [sym__bind_match] = {
    .visible = true,
    .named = true,
  },
  [sym__bind_matches] = {
    .visible = false,
    .named = true,
  },
  [sym__function_name] = {
    .visible = false,
    .named = true,
  },
  [sym_function_head_parens] = {
    .visible = true,
    .named = true,
  },
  [sym__function_head_infix] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_bind] = {
    .visible = true,
    .named = true,
  },
  [sym_decl] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__local_decl] = {
    .visible = false,
    .named = true,
  },
  [sym_local_binds] = {
    .visible = true,
    .named = true,
  },
  [sym__where_binds] = {
    .visible = false,
    .named = true,
  },
  [sym_entity] = {
    .visible = true,
    .named = true,
  },
  [sym_foreign_import] = {
    .visible = true,
    .named = true,
  },
  [sym_foreign_export] = {
    .visible = true,
    .named = true,
  },
  [sym_default_types] = {
    .visible = true,
    .named = true,
  },
  [sym__patsyn_signature] = {
    .visible = true,
    .named = true,
  },
  [sym__patsyn_cons] = {
    .visible = true,
    .named = true,
  },
  [sym__patsyn_equation] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_synonym] = {
    .visible = true,
    .named = true,
  },
  [sym__splice_exp] = {
    .visible = false,
    .named = true,
  },
  [sym__splice_dollars] = {
    .visible = false,
    .named = true,
  },
  [sym_splice] = {
    .visible = true,
    .named = true,
  },
  [sym_top_splice] = {
    .visible = true,
    .named = true,
  },
  [sym_quoter] = {
    .visible = true,
    .named = true,
  },
  [sym_quasiquote] = {
    .visible = true,
    .named = true,
  },
  [sym_quoted_decls] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_quote] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_typed_quote] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym__plist] = {
    .visible = true,
    .named = true,
  },
  [sym_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_unboxed_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_prefix_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_prefix_unboxed_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_prefix_unboxed_sum] = {
    .visible = true,
    .named = true,
  },
  [sym_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__qualified_variable] = {
    .visible = true,
    .named = true,
  },
  [sym__qvarid] = {
    .visible = false,
    .named = true,
  },
  [sym__qvar] = {
    .visible = false,
    .named = true,
  },
  [sym__variable_ticked] = {
    .visible = true,
    .named = true,
  },
  [sym__qvariable_ticked] = {
    .visible = true,
    .named = true,
  },
  [sym__qualified_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym__qconid] = {
    .visible = false,
    .named = true,
  },
  [sym__constructor_ticked] = {
    .visible = true,
    .named = true,
  },
  [sym__qconstructor_ticked] = {
    .visible = true,
    .named = true,
  },
  [sym__qualified_type] = {
    .visible = true,
    .named = true,
  },
  [sym__qtyconid] = {
    .visible = false,
    .named = true,
  },
  [sym__tycon_arrow] = {
    .visible = true,
    .named = true,
  },
  [sym__qualified_arrow] = {
    .visible = true,
    .named = true,
  },
  [sym__qtycon_arrow] = {
    .visible = true,
    .named = true,
  },
  [sym__promoted_tycons_alias] = {
    .visible = true,
    .named = true,
  },
  [sym__promoted_tycons] = {
    .visible = false,
    .named = true,
  },
  [sym__tycon_ticked] = {
    .visible = true,
    .named = true,
  },
  [sym__qtycon_ticked] = {
    .visible = true,
    .named = true,
  },
  [sym__tyconids_ticked] = {
    .visible = false,
    .named = true,
  },
  [sym__promoted_tyconops_alias] = {
    .visible = true,
    .named = true,
  },
  [sym__promoted_tyconops] = {
    .visible = false,
    .named = true,
  },
  [sym__ops] = {
    .visible = false,
    .named = true,
  },
  [sym__qname] = {
    .visible = false,
    .named = true,
  },
  [sym__operator_qual_dot_head] = {
    .visible = true,
    .named = true,
  },
  [sym__operator_hash_head] = {
    .visible = false,
    .named = true,
  },
  [sym_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__operator_alias] = {
    .visible = false,
    .named = true,
  },
  [sym__operator_minus] = {
    .visible = false,
    .named = true,
  },
  [sym__varsym_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym__pvarsym] = {
    .visible = false,
    .named = true,
  },
  [sym__qualified_varsym] = {
    .visible = true,
    .named = true,
  },
  [sym__qvarsym_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym__pqvarsym] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__constructor_operator_alias] = {
    .visible = false,
    .named = true,
  },
  [sym__consym_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym__pconsym] = {
    .visible = false,
    .named = true,
  },
  [sym__qualified_consym] = {
    .visible = true,
    .named = true,
  },
  [sym__qconsym_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym__pqconsym] = {
    .visible = false,
    .named = true,
  },
  [sym__sym_prefix] = {
    .visible = false,
    .named = true,
  },
  [sym__carrow] = {
    .visible = false,
    .named = true,
  },
  [sym__arrow] = {
    .visible = false,
    .named = true,
  },
  [sym__linear_arrow] = {
    .visible = false,
    .named = true,
  },
  [sym__larrow] = {
    .visible = false,
    .named = true,
  },
  [sym__colon2] = {
    .visible = false,
    .named = true,
  },
  [sym__qual_dot] = {
    .visible = false,
    .named = true,
  },
  [sym__tight_dot] = {
    .visible = false,
    .named = true,
  },
  [sym__prefix_dot] = {
    .visible = false,
    .named = true,
  },
  [sym__tight_at] = {
    .visible = false,
    .named = true,
  },
  [sym__prefix_at] = {
    .visible = false,
    .named = true,
  },
  [sym__prefix_bang] = {
    .visible = false,
    .named = true,
  },
  [sym__tight_bang] = {
    .visible = false,
    .named = true,
  },
  [sym__any_prefix_bang] = {
    .visible = false,
    .named = true,
  },
  [sym__prefix_tilde] = {
    .visible = false,
    .named = true,
  },
  [sym__tight_tilde] = {
    .visible = false,
    .named = true,
  },
  [sym__any_prefix_tilde] = {
    .visible = false,
    .named = true,
  },
  [sym__prefix_percent] = {
    .visible = false,
    .named = true,
  },
  [sym__dotdot] = {
    .visible = false,
    .named = true,
  },
  [sym__paren_open] = {
    .visible = false,
    .named = true,
  },
  [sym__paren_close] = {
    .visible = false,
    .named = true,
  },
  [sym__bracket_open] = {
    .visible = false,
    .named = true,
  },
  [sym__bracket_close] = {
    .visible = false,
    .named = true,
  },
  [sym__unboxed_open] = {
    .visible = false,
    .named = true,
  },
  [sym__unboxed_close] = {
    .visible = false,
    .named = true,
  },
  [sym__where] = {
    .visible = false,
    .named = true,
  },
  [sym__bar] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__let_binds_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__let_binds_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_guards_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_params_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_quantified_variables_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_tuple_elems_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_unboxed_sum_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_patterns_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_family_injectivity_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__tyfam_equations_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_role_annotation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__ctr_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__exp_tuple_elems_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__exp_tuple_elems_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__exp_unboxed_sum_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__exp_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_qualifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__exp_list_comprehension_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__matches_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_alternatives_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__nalts_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__exp_multi_way_if_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__exp_record_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__exp_projection_selector_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__pat_tuple_elems_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__pat_record_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_patterns_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_children_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declarations_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_path_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__record_fields_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gadt_constructors_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__datacon_prefix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_data_constructors_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__data_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_fundeps_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_declarations_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instance_declarations_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_fixity_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__con_binding_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__var_binding_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__bind_matches_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_local_binds_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_default_types_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__patsyn_cons_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_quoted_decls_repeat1] = {
    .visible = false,
    .named = false,
  },
  [anon_alias_sym_LPAREN_POUND] = {
    .visible = true,
    .named = false,
  },
  [alias_sym_all_names] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_constructor] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_constructor_synonym] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_export] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_package] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_module_id] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_pattern_guard] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_prefix_list] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_quoted_expression] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_quoted_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_quoted_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_application] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_binder] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_alternative = 2,
  field_alternatives = 3,
  field_argument = 4,
  field_arrow = 5,
  field_associativity = 6,
  field_bind = 7,
  field_binds = 8,
  field_body = 9,
  field_calling_convention = 10,
  field_children = 11,
  field_classes = 12,
  field_classifier = 13,
  field_closed_family = 14,
  field_constraint = 15,
  field_constructor = 16,
  field_constructors = 17,
  field_context = 18,
  field_decl = 19,
  field_declaration = 20,
  field_declarations = 21,
  field_deriving = 22,
  field_determined = 23,
  field_element = 24,
  field_else = 25,
  field_entity = 26,
  field_equation = 27,
  field_export = 28,
  field_exports = 29,
  field_expression = 30,
  field_field = 31,
  field_fields = 32,
  field_forall = 33,
  field_from = 34,
  field_function = 35,
  field_fundep = 36,
  field_fundeps = 37,
  field_guard = 38,
  field_guards = 39,
  field_id = 40,
  field_if = 41,
  field_implicit = 42,
  field_import = 43,
  field_imports = 44,
  field_key = 45,
  field_kind = 46,
  field_left_operand = 47,
  field_match = 48,
  field_matched = 49,
  field_minus = 50,
  field_module = 51,
  field_multiplicity = 52,
  field_name = 53,
  field_names = 54,
  field_namespace = 55,
  field_number = 56,
  field_operator = 57,
  field_package = 58,
  field_parameter = 59,
  field_parens = 60,
  field_pattern = 61,
  field_patterns = 62,
  field_precedence = 63,
  field_qualifier = 64,
  field_qualifiers = 65,
  field_quantifier = 66,
  field_quoter = 67,
  field_result = 68,
  field_right_operand = 69,
  field_role = 70,
  field_safety = 71,
  field_signature = 72,
  field_statement = 73,
  field_step = 74,
  field_strategy = 75,
  field_subfield = 76,
  field_synonym = 77,
  field_then = 78,
  field_to = 79,
  field_transformation = 80,
  field_type = 81,
  field_variable = 82,
  field_variables = 83,
  field_via = 84,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_alternatives] = "alternatives",
  [field_argument] = "argument",
  [field_arrow] = "arrow",
  [field_associativity] = "associativity",
  [field_bind] = "bind",
  [field_binds] = "binds",
  [field_body] = "body",
  [field_calling_convention] = "calling_convention",
  [field_children] = "children",
  [field_classes] = "classes",
  [field_classifier] = "classifier",
  [field_closed_family] = "closed_family",
  [field_constraint] = "constraint",
  [field_constructor] = "constructor",
  [field_constructors] = "constructors",
  [field_context] = "context",
  [field_decl] = "decl",
  [field_declaration] = "declaration",
  [field_declarations] = "declarations",
  [field_deriving] = "deriving",
  [field_determined] = "determined",
  [field_element] = "element",
  [field_else] = "else",
  [field_entity] = "entity",
  [field_equation] = "equation",
  [field_export] = "export",
  [field_exports] = "exports",
  [field_expression] = "expression",
  [field_field] = "field",
  [field_fields] = "fields",
  [field_forall] = "forall",
  [field_from] = "from",
  [field_function] = "function",
  [field_fundep] = "fundep",
  [field_fundeps] = "fundeps",
  [field_guard] = "guard",
  [field_guards] = "guards",
  [field_id] = "id",
  [field_if] = "if",
  [field_implicit] = "implicit",
  [field_import] = "import",
  [field_imports] = "imports",
  [field_key] = "key",
  [field_kind] = "kind",
  [field_left_operand] = "left_operand",
  [field_match] = "match",
  [field_matched] = "matched",
  [field_minus] = "minus",
  [field_module] = "module",
  [field_multiplicity] = "multiplicity",
  [field_name] = "name",
  [field_names] = "names",
  [field_namespace] = "namespace",
  [field_number] = "number",
  [field_operator] = "operator",
  [field_package] = "package",
  [field_parameter] = "parameter",
  [field_parens] = "parens",
  [field_pattern] = "pattern",
  [field_patterns] = "patterns",
  [field_precedence] = "precedence",
  [field_qualifier] = "qualifier",
  [field_qualifiers] = "qualifiers",
  [field_quantifier] = "quantifier",
  [field_quoter] = "quoter",
  [field_result] = "result",
  [field_right_operand] = "right_operand",
  [field_role] = "role",
  [field_safety] = "safety",
  [field_signature] = "signature",
  [field_statement] = "statement",
  [field_step] = "step",
  [field_strategy] = "strategy",
  [field_subfield] = "subfield",
  [field_synonym] = "synonym",
  [field_then] = "then",
  [field_to] = "to",
  [field_transformation] = "transformation",
  [field_type] = "type",
  [field_variable] = "variable",
  [field_variables] = "variables",
  [field_via] = "via",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 2},
  [2] = {.index = 2, .length = 1},
  [4] = {.index = 3, .length = 2},
  [5] = {.index = 5, .length = 1},
  [6] = {.index = 6, .length = 1},
  [7] = {.index = 6, .length = 1},
  [8] = {.index = 7, .length = 3},
  [9] = {.index = 10, .length = 2},
  [10] = {.index = 12, .length = 2},
  [11] = {.index = 14, .length = 2},
  [12] = {.index = 16, .length = 3},
  [13] = {.index = 19, .length = 1},
  [14] = {.index = 20, .length = 1},
  [15] = {.index = 21, .length = 1},
  [16] = {.index = 22, .length = 2},
  [17] = {.index = 24, .length = 1},
  [18] = {.index = 25, .length = 2},
  [19] = {.index = 27, .length = 2},
  [20] = {.index = 29, .length = 1},
  [21] = {.index = 30, .length = 2},
  [22] = {.index = 32, .length = 3},
  [23] = {.index = 35, .length = 1},
  [24] = {.index = 36, .length = 2},
  [25] = {.index = 38, .length = 2},
  [26] = {.index = 40, .length = 1},
  [27] = {.index = 41, .length = 2},
  [28] = {.index = 43, .length = 4},
  [29] = {.index = 47, .length = 3},
  [30] = {.index = 50, .length = 1},
  [32] = {.index = 51, .length = 2},
  [34] = {.index = 53, .length = 2},
  [35] = {.index = 55, .length = 1},
  [36] = {.index = 55, .length = 1},
  [37] = {.index = 56, .length = 1},
  [38] = {.index = 57, .length = 1},
  [39] = {.index = 58, .length = 1},
  [40] = {.index = 59, .length = 2},
  [41] = {.index = 2, .length = 1},
  [42] = {.index = 61, .length = 1},
  [43] = {.index = 62, .length = 3},
  [44] = {.index = 65, .length = 1},
  [45] = {.index = 66, .length = 2},
  [46] = {.index = 68, .length = 1},
  [47] = {.index = 69, .length = 2},
  [48] = {.index = 71, .length = 1},
  [50] = {.index = 68, .length = 1},
  [51] = {.index = 72, .length = 2},
  [52] = {.index = 74, .length = 1},
  [53] = {.index = 75, .length = 2},
  [54] = {.index = 77, .length = 2},
  [55] = {.index = 79, .length = 3},
  [56] = {.index = 82, .length = 1},
  [57] = {.index = 83, .length = 4},
  [58] = {.index = 87, .length = 6},
  [59] = {.index = 93, .length = 3},
  [61] = {.index = 96, .length = 2},
  [62] = {.index = 98, .length = 2},
  [63] = {.index = 100, .length = 3},
  [64] = {.index = 103, .length = 3},
  [65] = {.index = 106, .length = 2},
  [66] = {.index = 108, .length = 3},
  [67] = {.index = 111, .length = 1},
  [68] = {.index = 112, .length = 3},
  [69] = {.index = 115, .length = 2},
  [70] = {.index = 112, .length = 3},
  [71] = {.index = 117, .length = 3},
  [72] = {.index = 120, .length = 2},
  [73] = {.index = 120, .length = 2},
  [74] = {.index = 122, .length = 1},
  [75] = {.index = 123, .length = 1},
  [76] = {.index = 124, .length = 1},
  [77] = {.index = 125, .length = 5},
  [78] = {.index = 130, .length = 1},
  [79] = {.index = 131, .length = 1},
  [82] = {.index = 132, .length = 1},
  [83] = {.index = 133, .length = 1},
  [84] = {.index = 134, .length = 4},
  [85] = {.index = 138, .length = 1},
  [86] = {.index = 139, .length = 3},
  [87] = {.index = 142, .length = 3},
  [88] = {.index = 145, .length = 6},
  [89] = {.index = 151, .length = 2},
  [90] = {.index = 153, .length = 1},
  [91] = {.index = 154, .length = 3},
  [92] = {.index = 157, .length = 2},
  [93] = {.index = 159, .length = 2},
  [94] = {.index = 161, .length = 2},
  [95] = {.index = 163, .length = 2},
  [96] = {.index = 165, .length = 2},
  [98] = {.index = 167, .length = 1},
  [99] = {.index = 168, .length = 3},
  [100] = {.index = 171, .length = 2},
  [101] = {.index = 173, .length = 3},
  [102] = {.index = 176, .length = 3},
  [103] = {.index = 179, .length = 4},
  [104] = {.index = 183, .length = 3},
  [105] = {.index = 186, .length = 2},
  [106] = {.index = 188, .length = 1},
  [107] = {.index = 189, .length = 2},
  [108] = {.index = 191, .length = 1},
  [109] = {.index = 106, .length = 2},
  [110] = {.index = 192, .length = 1},
  [111] = {.index = 193, .length = 2},
  [112] = {.index = 195, .length = 2},
  [113] = {.index = 197, .length = 8},
  [114] = {.index = 205, .length = 2},
  [115] = {.index = 207, .length = 5},
  [116] = {.index = 212, .length = 7},
  [117] = {.index = 219, .length = 5},
  [118] = {.index = 224, .length = 5},
  [119] = {.index = 229, .length = 7},
  [120] = {.index = 236, .length = 2},
  [121] = {.index = 238, .length = 1},
  [122] = {.index = 239, .length = 3},
  [123] = {.index = 242, .length = 2},
  [124] = {.index = 244, .length = 5},
  [125] = {.index = 249, .length = 4},
  [126] = {.index = 253, .length = 2},
  [127] = {.index = 255, .length = 4},
  [128] = {.index = 259, .length = 2},
  [129] = {.index = 261, .length = 4},
  [130] = {.index = 265, .length = 4},
  [131] = {.index = 269, .length = 3},
  [132] = {.index = 269, .length = 3},
  [133] = {.index = 272, .length = 3},
  [135] = {.index = 275, .length = 3},
  [136] = {.index = 278, .length = 2},
  [137] = {.index = 280, .length = 2},
  [138] = {.index = 282, .length = 2},
  [139] = {.index = 284, .length = 2},
  [140] = {.index = 286, .length = 2},
  [142] = {.index = 288, .length = 3},
  [143] = {.index = 291, .length = 2},
  [144] = {.index = 293, .length = 2},
  [145] = {.index = 295, .length = 1},
  [146] = {.index = 296, .length = 2},
  [147] = {.index = 298, .length = 2},
  [148] = {.index = 300, .length = 2},
  [149] = {.index = 302, .length = 5},
  [150] = {.index = 307, .length = 3},
  [151] = {.index = 310, .length = 4},
  [152] = {.index = 314, .length = 4},
  [153] = {.index = 318, .length = 1},
  [154] = {.index = 319, .length = 2},
  [155] = {.index = 321, .length = 1},
  [156] = {.index = 322, .length = 2},
  [157] = {.index = 324, .length = 1},
  [158] = {.index = 325, .length = 2},
  [159] = {.index = 327, .length = 1},
  [160] = {.index = 328, .length = 1},
  [161] = {.index = 329, .length = 1},
  [162] = {.index = 330, .length = 2},
  [163] = {.index = 332, .length = 5},
  [164] = {.index = 337, .length = 5},
  [165] = {.index = 342, .length = 1},
  [166] = {.index = 343, .length = 1},
  [167] = {.index = 344, .length = 3},
  [168] = {.index = 347, .length = 3},
  [169] = {.index = 350, .length = 1},
  [170] = {.index = 351, .length = 2},
  [171] = {.index = 353, .length = 5},
  [172] = {.index = 358, .length = 7},
  [173] = {.index = 365, .length = 2},
  [174] = {.index = 367, .length = 2},
  [175] = {.index = 369, .length = 4},
  [176] = {.index = 373, .length = 4},
  [178] = {.index = 377, .length = 2},
  [179] = {.index = 379, .length = 3},
  [180] = {.index = 382, .length = 3},
  [181] = {.index = 385, .length = 2},
  [182] = {.index = 387, .length = 4},
  [183] = {.index = 391, .length = 3},
  [184] = {.index = 394, .length = 3},
  [185] = {.index = 397, .length = 4},
  [186] = {.index = 401, .length = 3},
  [187] = {.index = 120, .length = 2},
  [188] = {.index = 404, .length = 5},
  [189] = {.index = 409, .length = 1},
  [190] = {.index = 410, .length = 3},
  [191] = {.index = 413, .length = 2},
  [192] = {.index = 415, .length = 1},
  [193] = {.index = 416, .length = 2},
  [194] = {.index = 418, .length = 1},
  [195] = {.index = 419, .length = 2},
  [196] = {.index = 421, .length = 2},
  [197] = {.index = 423, .length = 3},
  [198] = {.index = 419, .length = 2},
  [199] = {.index = 426, .length = 2},
  [200] = {.index = 428, .length = 2},
  [201] = {.index = 430, .length = 3},
  [202] = {.index = 433, .length = 2},
  [203] = {.index = 435, .length = 2},
  [204] = {.index = 437, .length = 5},
  [205] = {.index = 442, .length = 1},
  [206] = {.index = 443, .length = 6},
  [207] = {.index = 449, .length = 3},
  [208] = {.index = 452, .length = 1},
  [209] = {.index = 453, .length = 6},
  [210] = {.index = 459, .length = 8},
  [211] = {.index = 467, .length = 2},
  [212] = {.index = 2, .length = 1},
  [213] = {.index = 469, .length = 3},
  [214] = {.index = 472, .length = 4},
  [215] = {.index = 476, .length = 3},
  [216] = {.index = 479, .length = 1},
  [217] = {.index = 480, .length = 1},
  [218] = {.index = 481, .length = 4},
  [219] = {.index = 485, .length = 3},
  [220] = {.index = 488, .length = 4},
  [221] = {.index = 492, .length = 1},
  [222] = {.index = 493, .length = 2},
  [223] = {.index = 495, .length = 6},
  [224] = {.index = 501, .length = 3},
  [225] = {.index = 504, .length = 4},
  [226] = {.index = 508, .length = 3},
  [227] = {.index = 511, .length = 6},
  [228] = {.index = 517, .length = 5},
  [229] = {.index = 522, .length = 1},
  [230] = {.index = 523, .length = 3},
  [231] = {.index = 526, .length = 2},
  [232] = {.index = 528, .length = 1},
  [233] = {.index = 529, .length = 4},
  [234] = {.index = 533, .length = 3},
  [235] = {.index = 536, .length = 5},
  [236] = {.index = 541, .length = 4},
  [237] = {.index = 545, .length = 2},
  [238] = {.index = 547, .length = 1},
  [240] = {.index = 548, .length = 1},
  [241] = {.index = 549, .length = 1},
  [243] = {.index = 550, .length = 2},
  [244] = {.index = 552, .length = 1},
  [245] = {.index = 553, .length = 6},
  [246] = {.index = 559, .length = 3},
  [247] = {.index = 562, .length = 4},
  [249] = {.index = 566, .length = 1},
  [250] = {.index = 567, .length = 3},
  [251] = {.index = 570, .length = 7},
  [252] = {.index = 577, .length = 8},
  [253] = {.index = 585, .length = 2},
  [254] = {.index = 587, .length = 2},
  [255] = {.index = 589, .length = 2},
  [256] = {.index = 591, .length = 2},
  [257] = {.index = 593, .length = 2},
  [258] = {.index = 595, .length = 1},
  [259] = {.index = 596, .length = 1},
  [260] = {.index = 597, .length = 2},
  [261] = {.index = 599, .length = 1},
  [262] = {.index = 600, .length = 1},
  [263] = {.index = 601, .length = 1},
  [264] = {.index = 602, .length = 2},
  [265] = {.index = 604, .length = 2},
  [266] = {.index = 606, .length = 1},
  [267] = {.index = 607, .length = 2},
  [268] = {.index = 609, .length = 2},
  [269] = {.index = 611, .length = 2},
  [270] = {.index = 613, .length = 2},
  [271] = {.index = 615, .length = 2},
  [272] = {.index = 617, .length = 6},
  [273] = {.index = 623, .length = 2},
  [275] = {.index = 625, .length = 1},
  [276] = {.index = 626, .length = 1},
  [277] = {.index = 627, .length = 2},
  [278] = {.index = 629, .length = 2},
  [279] = {.index = 631, .length = 3},
  [280] = {.index = 634, .length = 1},
  [281] = {.index = 635, .length = 2},
  [282] = {.index = 637, .length = 4},
  [283] = {.index = 641, .length = 5},
  [284] = {.index = 646, .length = 4},
  [285] = {.index = 650, .length = 2},
  [286] = {.index = 652, .length = 3},
  [287] = {.index = 655, .length = 3},
  [288] = {.index = 658, .length = 2},
  [289] = {.index = 660, .length = 3},
  [290] = {.index = 663, .length = 5},
  [291] = {.index = 668, .length = 4},
  [292] = {.index = 672, .length = 3},
  [293] = {.index = 675, .length = 1},
  [294] = {.index = 676, .length = 3},
  [295] = {.index = 679, .length = 2},
  [296] = {.index = 681, .length = 4},
  [297] = {.index = 685, .length = 2},
  [298] = {.index = 687, .length = 1},
  [299] = {.index = 688, .length = 2},
  [300] = {.index = 690, .length = 4},
  [301] = {.index = 694, .length = 2},
  [302] = {.index = 696, .length = 3},
  [303] = {.index = 699, .length = 2},
  [304] = {.index = 701, .length = 2},
  [305] = {.index = 703, .length = 3},
  [306] = {.index = 706, .length = 3},
  [307] = {.index = 709, .length = 2},
  [308] = {.index = 711, .length = 2},
  [309] = {.index = 713, .length = 3},
  [310] = {.index = 716, .length = 6},
  [311] = {.index = 722, .length = 6},
  [312] = {.index = 728, .length = 6},
  [313] = {.index = 734, .length = 6},
  [314] = {.index = 740, .length = 3},
  [315] = {.index = 743, .length = 2},
  [316] = {.index = 745, .length = 2},
  [317] = {.index = 740, .length = 3},
  [318] = {.index = 743, .length = 2},
  [319] = {.index = 747, .length = 7},
  [320] = {.index = 754, .length = 5},
  [321] = {.index = 759, .length = 4},
  [322] = {.index = 763, .length = 4},
  [323] = {.index = 767, .length = 3},
  [324] = {.index = 770, .length = 4},
  [325] = {.index = 774, .length = 3},
  [326] = {.index = 777, .length = 3},
  [327] = {.index = 780, .length = 4},
  [328] = {.index = 784, .length = 1},
  [329] = {.index = 785, .length = 3},
  [330] = {.index = 788, .length = 2},
  [331] = {.index = 790, .length = 4},
  [332] = {.index = 794, .length = 5},
  [333] = {.index = 799, .length = 4},
  [334] = {.index = 803, .length = 2},
  [335] = {.index = 805, .length = 4},
  [336] = {.index = 809, .length = 5},
  [337] = {.index = 814, .length = 4},
  [338] = {.index = 818, .length = 2},
  [339] = {.index = 820, .length = 2},
  [340] = {.index = 788, .length = 2},
  [341] = {.index = 822, .length = 2},
  [342] = {.index = 824, .length = 2},
  [343] = {.index = 826, .length = 5},
  [344] = {.index = 831, .length = 5},
  [345] = {.index = 836, .length = 4},
  [346] = {.index = 840, .length = 5},
  [347] = {.index = 845, .length = 7},
  [348] = {.index = 852, .length = 2},
  [349] = {.index = 854, .length = 2},
  [350] = {.index = 856, .length = 3},
  [351] = {.index = 859, .length = 3},
  [352] = {.index = 862, .length = 2},
  [353] = {.index = 864, .length = 5},
  [354] = {.index = 869, .length = 4},
  [355] = {.index = 873, .length = 3},
  [356] = {.index = 876, .length = 5},
  [357] = {.index = 881, .length = 3},
  [358] = {.index = 884, .length = 3},
  [359] = {.index = 887, .length = 2},
  [360] = {.index = 889, .length = 2},
  [361] = {.index = 891, .length = 1},
  [362] = {.index = 892, .length = 2},
  [363] = {.index = 894, .length = 2},
  [364] = {.index = 896, .length = 3},
  [365] = {.index = 899, .length = 6},
  [366] = {.index = 905, .length = 4},
  [367] = {.index = 909, .length = 1},
  [368] = {.index = 910, .length = 2},
  [369] = {.index = 912, .length = 8},
  [370] = {.index = 920, .length = 7},
  [371] = {.index = 927, .length = 1},
  [372] = {.index = 928, .length = 2},
  [373] = {.index = 930, .length = 4},
  [374] = {.index = 934, .length = 3},
  [375] = {.index = 937, .length = 1},
  [376] = {.index = 938, .length = 2},
  [377] = {.index = 940, .length = 2},
  [378] = {.index = 942, .length = 1},
  [379] = {.index = 943, .length = 2},
  [380] = {.index = 945, .length = 2},
  [381] = {.index = 947, .length = 2},
  [382] = {.index = 949, .length = 2},
  [383] = {.index = 951, .length = 3},
  [384] = {.index = 954, .length = 3},
  [385] = {.index = 957, .length = 3},
  [386] = {.index = 960, .length = 7},
  [387] = {.index = 967, .length = 2},
  [388] = {.index = 969, .length = 1},
  [389] = {.index = 625, .length = 1},
  [391] = {.index = 625, .length = 1},
  [392] = {.index = 625, .length = 1},
  [393] = {.index = 970, .length = 2},
  [394] = {.index = 972, .length = 2},
  [395] = {.index = 974, .length = 3},
  [396] = {.index = 977, .length = 3},
  [397] = {.index = 980, .length = 5},
  [398] = {.index = 985, .length = 3},
  [399] = {.index = 988, .length = 2},
  [400] = {.index = 990, .length = 1},
  [401] = {.index = 991, .length = 2},
  [402] = {.index = 993, .length = 2},
  [403] = {.index = 995, .length = 3},
  [404] = {.index = 998, .length = 4},
  [405] = {.index = 1002, .length = 5},
  [406] = {.index = 1007, .length = 3},
  [407] = {.index = 1010, .length = 3},
  [408] = {.index = 1013, .length = 3},
  [409] = {.index = 1016, .length = 3},
  [410] = {.index = 1019, .length = 3},
  [411] = {.index = 1022, .length = 2},
  [412] = {.index = 1024, .length = 2},
  [413] = {.index = 1026, .length = 3},
  [414] = {.index = 1029, .length = 3},
  [415] = {.index = 1032, .length = 3},
  [416] = {.index = 1035, .length = 4},
  [417] = {.index = 1039, .length = 3},
  [418] = {.index = 1042, .length = 3},
  [419] = {.index = 1045, .length = 7},
  [420] = {.index = 1052, .length = 8},
  [421] = {.index = 1060, .length = 7},
  [422] = {.index = 1067, .length = 7},
  [423] = {.index = 1074, .length = 8},
  [424] = {.index = 1082, .length = 7},
  [425] = {.index = 1089, .length = 2},
  [426] = {.index = 1091, .length = 6},
  [427] = {.index = 1097, .length = 6},
  [428] = {.index = 1103, .length = 5},
  [429] = {.index = 1108, .length = 5},
  [430] = {.index = 1113, .length = 4},
  [431] = {.index = 1117, .length = 5},
  [432] = {.index = 1122, .length = 5},
  [433] = {.index = 1127, .length = 4},
  [434] = {.index = 1131, .length = 5},
  [435] = {.index = 1136, .length = 4},
  [436] = {.index = 1140, .length = 6},
  [437] = {.index = 1146, .length = 5},
  [438] = {.index = 1151, .length = 2},
  [439] = {.index = 1153, .length = 2},
  [440] = {.index = 1155, .length = 5},
  [441] = {.index = 1160, .length = 6},
  [442] = {.index = 1166, .length = 5},
  [443] = {.index = 1171, .length = 3},
  [444] = {.index = 1174, .length = 2},
  [445] = {.index = 1176, .length = 3},
  [446] = {.index = 1179, .length = 6},
  [447] = {.index = 1185, .length = 4},
  [448] = {.index = 1189, .length = 3},
  [449] = {.index = 1192, .length = 1},
  [450] = {.index = 1193, .length = 2},
  [451] = {.index = 1195, .length = 2},
  [452] = {.index = 1197, .length = 4},
  [453] = {.index = 1201, .length = 4},
  [454] = {.index = 1205, .length = 6},
  [455] = {.index = 1211, .length = 4},
  [456] = {.index = 1215, .length = 1},
  [457] = {.index = 1216, .length = 2},
  [458] = {.index = 1218, .length = 2},
  [459] = {.index = 1220, .length = 2},
  [460] = {.index = 1222, .length = 1},
  [461] = {.index = 1223, .length = 2},
  [462] = {.index = 1225, .length = 2},
  [463] = {.index = 1227, .length = 2},
  [464] = {.index = 1229, .length = 2},
  [465] = {.index = 1231, .length = 1},
  [466] = {.index = 1232, .length = 2},
  [467] = {.index = 1234, .length = 2},
  [468] = {.index = 1236, .length = 2},
  [469] = {.index = 1238, .length = 2},
  [470] = {.index = 1240, .length = 1},
  [471] = {.index = 1241, .length = 2},
  [472] = {.index = 324, .length = 1},
  [473] = {.index = 1243, .length = 4},
  [474] = {.index = 1247, .length = 4},
  [475] = {.index = 1251, .length = 2},
  [476] = {.index = 1253, .length = 5},
  [477] = {.index = 1258, .length = 2},
  [478] = {.index = 1260, .length = 3},
  [479] = {.index = 1263, .length = 3},
  [480] = {.index = 1266, .length = 3},
  [481] = {.index = 1269, .length = 3},
  [482] = {.index = 1272, .length = 4},
  [483] = {.index = 1276, .length = 3},
  [484] = {.index = 1279, .length = 3},
  [485] = {.index = 1282, .length = 4},
  [486] = {.index = 1286, .length = 4},
  [487] = {.index = 1290, .length = 3},
  [488] = {.index = 1293, .length = 9},
  [489] = {.index = 1302, .length = 8},
  [490] = {.index = 1310, .length = 1},
  [491] = {.index = 1311, .length = 3},
  [492] = {.index = 1314, .length = 5},
  [493] = {.index = 1319, .length = 2},
  [494] = {.index = 1321, .length = 4},
  [495] = {.index = 1325, .length = 6},
  [496] = {.index = 1311, .length = 3},
  [497] = {.index = 1314, .length = 5},
  [498] = {.index = 1331, .length = 7},
  [499] = {.index = 1338, .length = 6},
  [500] = {.index = 1344, .length = 7},
  [501] = {.index = 1351, .length = 6},
  [502] = {.index = 1357, .length = 6},
  [503] = {.index = 1363, .length = 5},
  [504] = {.index = 1368, .length = 6},
  [505] = {.index = 1374, .length = 7},
  [506] = {.index = 1381, .length = 3},
  [507] = {.index = 1384, .length = 1},
  [508] = {.index = 1385, .length = 5},
  [509] = {.index = 1390, .length = 3},
  [510] = {.index = 1393, .length = 3},
  [511] = {.index = 1396, .length = 2},
  [512] = {.index = 1398, .length = 2},
  [513] = {.index = 1400, .length = 3},
  [514] = {.index = 1403, .length = 3},
  [515] = {.index = 1406, .length = 1},
  [516] = {.index = 1407, .length = 2},
  [517] = {.index = 597, .length = 2},
  [518] = {.index = 1409, .length = 2},
  [519] = {.index = 1411, .length = 4},
  [520] = {.index = 1415, .length = 5},
  [521] = {.index = 1420, .length = 2},
  [522] = {.index = 1422, .length = 3},
  [524] = {.index = 1425, .length = 4},
  [525] = {.index = 1429, .length = 4},
  [526] = {.index = 1433, .length = 3},
  [527] = {.index = 1436, .length = 4},
  [528] = {.index = 1440, .length = 2},
  [529] = {.index = 1442, .length = 4},
  [530] = {.index = 1446, .length = 6},
  [531] = {.index = 1452, .length = 4},
  [532] = {.index = 1456, .length = 6},
  [533] = {.index = 1462, .length = 5},
  [534] = {.index = 1467, .length = 7},
  [535] = {.index = 1474, .length = 5},
  [536] = {.index = 1479, .length = 7},
  [537] = {.index = 1442, .length = 4},
  [538] = {.index = 1446, .length = 6},
  [539] = {.index = 1452, .length = 4},
  [540] = {.index = 1456, .length = 6},
  [541] = {.index = 1486, .length = 8},
  [542] = {.index = 1494, .length = 7},
  [543] = {.index = 1501, .length = 2},
  [544] = {.index = 1503, .length = 3},
  [545] = {.index = 1506, .length = 5},
  [547] = {.index = 1511, .length = 4},
  [548] = {.index = 1515, .length = 5},
  [549] = {.index = 1520, .length = 7},
  [550] = {.index = 1527, .length = 5},
  [551] = {.index = 1532, .length = 6},
  [552] = {.index = 1538, .length = 8},
  [553] = {.index = 1515, .length = 5},
  [554] = {.index = 1520, .length = 7},
  [555] = {.index = 1546, .length = 2},
  [556] = {.index = 1548, .length = 2},
  [557] = {.index = 1550, .length = 4},
  [558] = {.index = 1554, .length = 3},
  [559] = {.index = 1557, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_declarations, 0, .inherited = true},
    {field_imports, 0, .inherited = true},
  [2] =
    {field_name, 0},
  [3] =
    {field_name, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [5] =
    {field_expression, 0, .inherited = true},
  [6] =
    {field_element, 0, .inherited = true},
  [7] =
    {field_from, 0, .inherited = true},
    {field_step, 0, .inherited = true},
    {field_to, 0, .inherited = true},
  [10] =
    {field_expression, 0, .inherited = true},
    {field_qualifiers, 0, .inherited = true},
  [12] =
    {field_expression, 0, .inherited = true},
    {field_patterns, 0, .inherited = true},
  [14] =
    {field_binds, 0, .inherited = true},
    {field_expression, 0, .inherited = true},
  [16] =
    {field_else, 0, .inherited = true},
    {field_if, 0, .inherited = true},
    {field_then, 0, .inherited = true},
  [19] =
    {field_statement, 0, .inherited = true},
  [20] =
    {field_alternatives, 0, .inherited = true},
  [21] =
    {field_match, 0, .inherited = true},
  [22] =
    {field_expression, 0, .inherited = true},
    {field_field, 0, .inherited = true},
  [24] =
    {field_field, 0, .inherited = true},
  [25] =
    {field_argument, 0, .inherited = true},
    {field_function, 0, .inherited = true},
  [27] =
    {field_left_operand, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
  [29] =
    {field_right_operand, 0, .inherited = true},
  [30] =
    {field_expression, 0, .inherited = true},
    {field_minus, 0, .inherited = true},
  [32] =
    {field_left_operand, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_right_operand, 0, .inherited = true},
  [35] =
    {field_pattern, 0, .inherited = true},
  [36] =
    {field_constructor, 0, .inherited = true},
    {field_field, 0, .inherited = true},
  [38] =
    {field_bind, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
  [40] =
    {field_number, 0, .inherited = true},
  [41] =
    {field_pattern, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [43] =
    {field_context, 0, .inherited = true},
    {field_forall, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_patterns, 0, .inherited = true},
  [47] =
    {field_associativity, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_precedence, 0, .inherited = true},
  [50] =
    {field_quoter, 0, .inherited = true},
  [51] =
    {field_id, 0, .inherited = true},
    {field_module, 0, .inherited = true},
  [53] =
    {field_declarations, 1, .inherited = true},
    {field_imports, 1, .inherited = true},
  [55] =
    {field_name, 1},
  [56] =
    {field_bind, 0},
  [57] =
    {field_bind, 0, .inherited = true},
  [58] =
    {field_name, 0, .inherited = true},
  [59] =
    {field_name, 0, .inherited = true},
    {field_patterns, 0, .inherited = true},
  [61] =
    {field_quantifier, 0},
  [62] =
    {field_kind, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_patterns, 0, .inherited = true},
  [65] =
    {field_name, 1, .inherited = true},
  [66] =
    {field_arrow, 0, .inherited = true},
    {field_context, 0, .inherited = true},
  [68] =
    {field_type, 0, .inherited = true},
  [69] =
    {field_argument, 0, .inherited = true},
    {field_constructor, 0, .inherited = true},
  [71] =
    {field_type, 1},
  [72] =
    {field_expression, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [74] =
    {field_number, 1},
  [75] =
    {field_expression, 1},
    {field_minus, 0},
  [77] =
    {field_synonym, 1, .inherited = true},
    {field_type, 1, .inherited = true},
  [79] =
    {field_constructors, 1, .inherited = true},
    {field_pattern, 1, .inherited = true},
    {field_synonym, 1, .inherited = true},
  [82] =
    {field_module, 1},
  [83] =
    {field_context, 1, .inherited = true},
    {field_forall, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_patterns, 1, .inherited = true},
  [87] =
    {field_constructors, 1, .inherited = true},
    {field_context, 1, .inherited = true},
    {field_deriving, 1, .inherited = true},
    {field_kind, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_patterns, 1, .inherited = true},
  [93] =
    {field_left_operand, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right_operand, 1, .inherited = true},
  [96] =
    {field_associativity, 0},
    {field_operator, 1},
  [98] =
    {field_expression, 0, .inherited = true},
    {field_match, 0},
  [100] =
    {field_expression, 0, .inherited = true},
    {field_guards, 0, .inherited = true},
    {field_match, 0},
  [103] =
    {field_binds, 1, .inherited = true},
    {field_match, 1, .inherited = true},
    {field_name, 0},
  [106] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
  [108] =
    {field_binds, 1, .inherited = true},
    {field_implicit, 0},
    {field_match, 1, .inherited = true},
  [111] =
    {field_statement, 1, .inherited = true},
  [112] =
    {field_argument, 1},
    {field_function, 0},
    {field_type, 1, .inherited = true},
  [115] =
    {field_argument, 1},
    {field_function, 0},
  [117] =
    {field_binds, 1, .inherited = true},
    {field_match, 1, .inherited = true},
    {field_pattern, 0},
  [120] =
    {field_id, 1},
    {field_module, 0},
  [122] =
    {field_import, 0},
  [123] =
    {field_imports, 1},
  [124] =
    {field_declarations, 1},
  [125] =
    {field_binds, 1, .inherited = true},
    {field_left_operand, 0, .inherited = true},
    {field_match, 1, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_right_operand, 0, .inherited = true},
  [130] =
    {field_expression, 1},
  [131] =
    {field_pattern, 1},
  [132] =
    {field_imports, 2},
  [133] =
    {field_declarations, 2},
  [134] =
    {field_context, 2, .inherited = true},
    {field_forall, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_patterns, 2, .inherited = true},
  [138] =
    {field_expression, 2},
  [139] =
    {field_forall, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_patterns, 2, .inherited = true},
  [142] =
    {field_kind, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_patterns, 2, .inherited = true},
  [145] =
    {field_constructors, 2, .inherited = true},
    {field_context, 2, .inherited = true},
    {field_deriving, 2, .inherited = true},
    {field_kind, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_patterns, 2, .inherited = true},
  [151] =
    {field_bind, 1},
    {field_bind, 1, .inherited = true},
  [153] =
    {field_kind, 0, .inherited = true},
  [154] =
    {field_left_operand, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right_operand, 2, .inherited = true},
  [157] =
    {field_quantifier, 0},
    {field_variables, 1},
  [159] =
    {field_quantifier, 0, .inherited = true},
    {field_variables, 0, .inherited = true},
  [161] =
    {field_forall, 1},
    {field_name, 2, .inherited = true},
  [163] =
    {field_name, 1, .inherited = true},
    {field_patterns, 2},
  [165] =
    {field_context, 1},
    {field_name, 2, .inherited = true},
  [167] =
    {field_element, 1, .inherited = true},
  [168] =
    {field_argument, 1},
    {field_constructor, 0},
    {field_type, 1, .inherited = true},
  [171] =
    {field_argument, 1},
    {field_constructor, 0},
  [173] =
    {field_quantifier, 0, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_variables, 0, .inherited = true},
  [176] =
    {field_arrow, 0, .inherited = true},
    {field_parameter, 0, .inherited = true},
    {field_result, 0, .inherited = true},
  [179] =
    {field_arrow, 0, .inherited = true},
    {field_multiplicity, 0, .inherited = true},
    {field_parameter, 0, .inherited = true},
    {field_result, 0, .inherited = true},
  [183] =
    {field_arrow, 0, .inherited = true},
    {field_context, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [186] =
    {field_kind, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [188] =
    {field_alternatives, 2},
  [189] =
    {field_alternative, 2, .inherited = true},
    {field_alternatives, 2},
  [191] =
    {field_match, 0},
  [192] =
    {field_module, 2},
  [193] =
    {field_module, 2},
    {field_package, 1},
  [195] =
    {field_module, 1},
    {field_names, 2},
  [197] =
    {field_constructor, 2, .inherited = true},
    {field_constructors, 2, .inherited = true},
    {field_context, 2, .inherited = true},
    {field_deriving, 2, .inherited = true},
    {field_forall, 2, .inherited = true},
    {field_kind, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_patterns, 2, .inherited = true},
  [205] =
    {field_constructors, 0, .inherited = true},
    {field_kind, 0, .inherited = true},
  [207] =
    {field_constructor, 2, .inherited = true},
    {field_constructors, 2, .inherited = true},
    {field_deriving, 2, .inherited = true},
    {field_kind, 2, .inherited = true},
    {field_name, 1, .inherited = true},
  [212] =
    {field_constructor, 2, .inherited = true},
    {field_constructors, 2, .inherited = true},
    {field_deriving, 2, .inherited = true},
    {field_kind, 2, .inherited = true},
    {field_left_operand, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right_operand, 1, .inherited = true},
  [219] =
    {field_context, 2, .inherited = true},
    {field_forall, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_patterns, 2, .inherited = true},
    {field_via, 1},
  [224] =
    {field_context, 2, .inherited = true},
    {field_forall, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_patterns, 2, .inherited = true},
    {field_strategy, 1},
  [229] =
    {field_constructors, 2, .inherited = true},
    {field_context, 2, .inherited = true},
    {field_deriving, 2, .inherited = true},
    {field_forall, 2, .inherited = true},
    {field_kind, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_patterns, 2, .inherited = true},
  [236] =
    {field_name, 0, .inherited = true},
    {field_patterns, 1},
  [238] =
    {field_deriving, 0},
  [239] =
    {field_constructors, 1, .inherited = true},
    {field_kind, 1, .inherited = true},
    {field_name, 0, .inherited = true},
  [242] =
    {field_deriving, 1, .inherited = true},
    {field_name, 0, .inherited = true},
  [244] =
    {field_constructors, 1, .inherited = true},
    {field_kind, 1, .inherited = true},
    {field_left_operand, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_right_operand, 0, .inherited = true},
  [249] =
    {field_deriving, 1, .inherited = true},
    {field_left_operand, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_right_operand, 0, .inherited = true},
  [253] =
    {field_context, 0},
    {field_name, 1, .inherited = true},
  [255] =
    {field_context, 0},
    {field_left_operand, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right_operand, 1, .inherited = true},
  [259] =
    {field_fundeps, 2},
    {field_name, 1, .inherited = true},
  [261] =
    {field_fundeps, 2},
    {field_left_operand, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right_operand, 1, .inherited = true},
  [265] =
    {field_context, 1},
    {field_left_operand, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right_operand, 2, .inherited = true},
  [269] =
    {field_associativity, 0},
    {field_operator, 2},
    {field_precedence, 1},
  [272] =
    {field_associativity, 0},
    {field_operator, 1},
    {field_operator, 2},
  [275] =
    {field_binds, 1, .inherited = true},
    {field_expression, 0, .inherited = true},
    {field_match, 0},
  [278] =
    {field_name, 0},
    {field_type, 2},
  [280] =
    {field_bind, 0},
    {field_pattern, 2},
  [282] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [284] =
    {field_binds, 1, .inherited = true},
    {field_match, 0, .inherited = true},
  [286] =
    {field_match, 0, .inherited = true},
    {field_match, 1, .inherited = true},
  [288] =
    {field_left_operand, 0},
    {field_operator, 1},
    {field_right_operand, 2},
  [291] =
    {field_expression, 0},
    {field_field, 2},
  [293] =
    {field_pattern, 0},
    {field_type, 2},
  [295] =
    {field_import, 1},
  [296] =
    {field_import, 0},
    {field_import, 1, .inherited = true},
  [298] =
    {field_import, 0, .inherited = true},
    {field_import, 1, .inherited = true},
  [300] =
    {field_declarations, 2},
    {field_imports, 1},
  [302] =
    {field_context, 0, .inherited = true},
    {field_declarations, 2},
    {field_forall, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_patterns, 0, .inherited = true},
  [307] =
    {field_name, 0, .inherited = true},
    {field_names, 0},
    {field_type, 2},
  [310] =
    {field_binds, 2, .inherited = true},
    {field_match, 2, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_patterns, 1},
  [314] =
    {field_binds, 2, .inherited = true},
    {field_match, 2, .inherited = true},
    {field_parens, 0},
    {field_patterns, 1},
  [318] =
    {field_element, 0},
  [319] =
    {field_element, 0},
    {field_element, 1, .inherited = true},
  [321] =
    {field_parens, 1},
  [322] =
    {field_id, 1, .inherited = true},
    {field_module, 1, .inherited = true},
  [324] =
    {field_element, 1},
  [325] =
    {field_exports, 2},
    {field_module, 1},
  [327] =
    {field_variable, 0},
  [328] =
    {field_type, 0},
  [329] =
    {field_operator, 0},
  [330] =
    {field_declarations, 3},
    {field_imports, 2},
  [332] =
    {field_context, 3, .inherited = true},
    {field_forall, 3, .inherited = true},
    {field_name, 3, .inherited = true},
    {field_patterns, 3, .inherited = true},
    {field_via, 2},
  [337] =
    {field_context, 3, .inherited = true},
    {field_forall, 3, .inherited = true},
    {field_name, 3, .inherited = true},
    {field_patterns, 3, .inherited = true},
    {field_strategy, 2},
  [342] =
    {field_decl, 1},
  [343] =
    {field_expression, 3},
  [344] =
    {field_binds, 1},
    {field_decl, 1, .inherited = true},
    {field_expression, 3},
  [347] =
    {field_forall, 0},
    {field_name, 1, .inherited = true},
    {field_patterns, 1, .inherited = true},
  [350] =
    {field_role, 0},
  [351] =
    {field_role, 3, .inherited = true},
    {field_type, 2},
  [353] =
    {field_bind, 0, .inherited = true},
    {field_bind, 2, .inherited = true},
    {field_left_operand, 0},
    {field_operator, 1},
    {field_right_operand, 2},
  [358] =
    {field_bind, 0, .inherited = true},
    {field_bind, 2, .inherited = true},
    {field_id, 1, .inherited = true},
    {field_left_operand, 0},
    {field_module, 1, .inherited = true},
    {field_operator, 1},
    {field_right_operand, 2},
  [365] =
    {field_name, 1, .inherited = true},
    {field_type, 3},
  [367] =
    {field_kind, 3},
    {field_name, 1, .inherited = true},
  [369] =
    {field_left_operand, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right_operand, 1, .inherited = true},
    {field_type, 3},
  [373] =
    {field_kind, 3},
    {field_left_operand, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right_operand, 1, .inherited = true},
  [377] =
    {field_arrow, 2},
    {field_context, 1},
  [379] =
    {field_constraint, 0, .inherited = true},
    {field_quantifier, 0, .inherited = true},
    {field_variables, 0, .inherited = true},
  [382] =
    {field_arrow, 0, .inherited = true},
    {field_constraint, 0, .inherited = true},
    {field_context, 0, .inherited = true},
  [385] =
    {field_constraint, 0, .inherited = true},
    {field_kind, 0, .inherited = true},
  [387] =
    {field_forall, 1},
    {field_left_operand, 3, .inherited = true},
    {field_operator, 3, .inherited = true},
    {field_right_operand, 3, .inherited = true},
  [391] =
    {field_forall, 1},
    {field_name, 2, .inherited = true},
    {field_patterns, 3},
  [394] =
    {field_context, 2},
    {field_forall, 1},
    {field_name, 3, .inherited = true},
  [397] =
    {field_context, 1},
    {field_left_operand, 3, .inherited = true},
    {field_operator, 3, .inherited = true},
    {field_right_operand, 3, .inherited = true},
  [401] =
    {field_context, 1},
    {field_name, 2, .inherited = true},
    {field_patterns, 3},
  [404] =
    {field_id, 1, .inherited = true},
    {field_left_operand, 0},
    {field_module, 1, .inherited = true},
    {field_operator, 1},
    {field_right_operand, 2},
  [409] =
    {field_arrow, 0},
  [410] =
    {field_arrow, 0, .inherited = true},
    {field_context, 0, .inherited = true},
    {field_type, 1},
  [413] =
    {field_expression, 3},
    {field_patterns, 1},
  [415] =
    {field_match, 2, .inherited = true},
  [416] =
    {field_expression, 0},
    {field_type, 2},
  [418] =
    {field_alternatives, 3},
  [419] =
    {field_synonym, 0},
    {field_type, 2},
  [421] =
    {field_pattern, 2},
    {field_synonym, 0},
  [423] =
    {field_name, 0, .inherited = true},
    {field_synonym, 0},
    {field_type, 2},
  [426] =
    {field_module, 3},
    {field_package, 2},
  [428] =
    {field_module, 2},
    {field_names, 3},
  [430] =
    {field_module, 2},
    {field_names, 3},
    {field_package, 1},
  [433] =
    {field_module, 1},
    {field_names, 3},
  [435] =
    {field_alias, 3},
    {field_module, 1},
  [437] =
    {field_constructor, 1, .inherited = true},
    {field_constructors, 1, .inherited = true},
    {field_deriving, 1, .inherited = true},
    {field_kind, 1, .inherited = true},
    {field_name, 0, .inherited = true},
  [442] =
    {field_constructor, 1},
  [443] =
    {field_constructor, 3, .inherited = true},
    {field_constructors, 3, .inherited = true},
    {field_deriving, 3, .inherited = true},
    {field_kind, 3, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_patterns, 2},
  [449] =
    {field_constructors, 0, .inherited = true},
    {field_deriving, 1, .inherited = true},
    {field_kind, 0, .inherited = true},
  [452] =
    {field_constructors, 1},
  [453] =
    {field_constructor, 3, .inherited = true},
    {field_constructors, 3, .inherited = true},
    {field_context, 1},
    {field_deriving, 3, .inherited = true},
    {field_kind, 3, .inherited = true},
    {field_name, 2, .inherited = true},
  [459] =
    {field_constructor, 3, .inherited = true},
    {field_constructors, 3, .inherited = true},
    {field_context, 1},
    {field_deriving, 3, .inherited = true},
    {field_kind, 3, .inherited = true},
    {field_left_operand, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right_operand, 2, .inherited = true},
  [467] =
    {field_forall, 0},
    {field_name, 1, .inherited = true},
  [469] =
    {field_constructor, 0},
    {field_field, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [472] =
    {field_constructor, 0},
    {field_left_operand, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_right_operand, 0, .inherited = true},
  [476] =
    {field_constructor, 0},
    {field_fields, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [479] =
    {field_constructor, 0},
  [480] =
    {field_classes, 1},
  [481] =
    {field_constructors, 2, .inherited = true},
    {field_kind, 2, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_patterns, 1},
  [485] =
    {field_deriving, 2, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_patterns, 1},
  [488] =
    {field_constructors, 1, .inherited = true},
    {field_deriving, 2, .inherited = true},
    {field_kind, 1, .inherited = true},
    {field_name, 0, .inherited = true},
  [492] =
    {field_kind, 1},
  [493] =
    {field_deriving, 0, .inherited = true},
    {field_deriving, 1, .inherited = true},
  [495] =
    {field_constructors, 1, .inherited = true},
    {field_deriving, 2, .inherited = true},
    {field_kind, 1, .inherited = true},
    {field_left_operand, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_right_operand, 0, .inherited = true},
  [501] =
    {field_context, 0},
    {field_name, 1, .inherited = true},
    {field_patterns, 2},
  [504] =
    {field_constructors, 2, .inherited = true},
    {field_context, 0},
    {field_kind, 2, .inherited = true},
    {field_name, 1, .inherited = true},
  [508] =
    {field_context, 0},
    {field_deriving, 2, .inherited = true},
    {field_name, 1, .inherited = true},
  [511] =
    {field_constructors, 2, .inherited = true},
    {field_context, 0},
    {field_kind, 2, .inherited = true},
    {field_left_operand, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right_operand, 1, .inherited = true},
  [517] =
    {field_context, 0},
    {field_deriving, 2, .inherited = true},
    {field_left_operand, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right_operand, 1, .inherited = true},
  [522] =
    {field_type, 2},
  [523] =
    {field_fundeps, 3},
    {field_name, 1, .inherited = true},
    {field_patterns, 2},
  [526] =
    {field_declarations, 3},
    {field_name, 1, .inherited = true},
  [528] =
    {field_fundep, 1},
  [529] =
    {field_declarations, 3},
    {field_left_operand, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right_operand, 1, .inherited = true},
  [533] =
    {field_context, 1},
    {field_fundeps, 3},
    {field_name, 2, .inherited = true},
  [536] =
    {field_context, 1},
    {field_fundeps, 3},
    {field_left_operand, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right_operand, 2, .inherited = true},
  [541] =
    {field_associativity, 0},
    {field_operator, 2},
    {field_operator, 3},
    {field_precedence, 1},
  [545] =
    {field_calling_convention, 2},
    {field_signature, 3},
  [547] =
    {field_binds, 1},
  [548] =
    {field_guard, 0},
  [549] =
    {field_guards, 2},
  [550] =
    {field_binds, 1},
    {field_decl, 1, .inherited = true},
  [552] =
    {field_statement, 1},
  [553] =
    {field_id, 2, .inherited = true},
    {field_left_operand, 0},
    {field_module, 2, .inherited = true},
    {field_operator, 1},
    {field_operator, 2},
    {field_right_operand, 3},
  [559] =
    {field_left_operand, 0},
    {field_operator, 2},
    {field_right_operand, 3},
  [562] =
    {field_left_operand, 0},
    {field_operator, 1},
    {field_operator, 2},
    {field_right_operand, 3},
  [566] =
    {field_field, 0},
  [567] =
    {field_forall, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_patterns, 0, .inherited = true},
  [570] =
    {field_constructors, 0, .inherited = true},
    {field_context, 0, .inherited = true},
    {field_deriving, 0, .inherited = true},
    {field_forall, 0, .inherited = true},
    {field_kind, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_patterns, 0, .inherited = true},
  [577] =
    {field_constructor, 0, .inherited = true},
    {field_constructors, 0, .inherited = true},
    {field_context, 0, .inherited = true},
    {field_deriving, 0, .inherited = true},
    {field_forall, 0, .inherited = true},
    {field_kind, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_patterns, 0, .inherited = true},
  [585] =
    {field_element, 0},
    {field_element, 2},
  [587] =
    {field_element, 0},
    {field_element, 2, .inherited = true},
  [589] =
    {field_expression, 0},
    {field_pattern, 2},
  [591] =
    {field_element, 0, .inherited = true},
    {field_element, 1, .inherited = true},
  [593] =
    {field_parens, 1},
    {field_patterns, 2},
  [595] =
    {field_right_operand, 2},
  [596] =
    {field_field, 2},
  [597] =
    {field_element, 1},
    {field_element, 2, .inherited = true},
  [599] =
    {field_qualifier, 0},
  [600] =
    {field_qualifiers, 1},
  [601] =
    {field_from, 1},
  [602] =
    {field_expression, 1},
    {field_qualifiers, 2, .inherited = true},
  [604] =
    {field_qualifiers, 0, .inherited = true},
    {field_qualifiers, 1, .inherited = true},
  [606] =
    {field_element, 2},
  [607] =
    {field_children, 1},
    {field_variable, 0},
  [609] =
    {field_children, 1},
    {field_type, 0},
  [611] =
    {field_namespace, 0},
    {field_variable, 1},
  [613] =
    {field_namespace, 0},
    {field_type, 1},
  [615] =
    {field_namespace, 0},
    {field_operator, 1},
  [617] =
    {field_children, 1, .inherited = true},
    {field_export, 1},
    {field_namespace, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_type, 1, .inherited = true},
    {field_variable, 1, .inherited = true},
  [623] =
    {field_children, 1},
    {field_operator, 0},
  [625] =
    {field_quoter, 2},
  [626] =
    {field_decl, 2},
  [627] =
    {field_decl, 1},
    {field_decl, 2, .inherited = true},
  [629] =
    {field_decl, 0, .inherited = true},
    {field_decl, 1, .inherited = true},
  [631] =
    {field_binds, 1},
    {field_decl, 1, .inherited = true},
    {field_expression, 4},
  [634] =
    {field_result, 1},
  [635] =
    {field_kind, 2},
    {field_name, 0, .inherited = true},
  [637] =
    {field_kind, 2},
    {field_left_operand, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_right_operand, 0, .inherited = true},
  [641] =
    {field_closed_family, 4},
    {field_equation, 4, .inherited = true},
    {field_kind, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_patterns, 2, .inherited = true},
  [646] =
    {field_closed_family, 4},
    {field_kind, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_patterns, 2, .inherited = true},
  [650] =
    {field_role, 0, .inherited = true},
    {field_role, 1, .inherited = true},
  [652] =
    {field_name, 1, .inherited = true},
    {field_patterns, 2},
    {field_type, 4},
  [655] =
    {field_kind, 4},
    {field_name, 1, .inherited = true},
    {field_patterns, 2},
  [658] =
    {field_bind, 0, .inherited = true},
    {field_kind, 2},
  [660] =
    {field_arrow, 0, .inherited = true},
    {field_constraint, 1},
    {field_context, 0, .inherited = true},
  [663] =
    {field_context, 2},
    {field_forall, 1},
    {field_left_operand, 4, .inherited = true},
    {field_operator, 4, .inherited = true},
    {field_right_operand, 4, .inherited = true},
  [668] =
    {field_context, 2},
    {field_forall, 1},
    {field_name, 3, .inherited = true},
    {field_patterns, 4},
  [672] =
    {field_quantifier, 0, .inherited = true},
    {field_type, 2},
    {field_variables, 0, .inherited = true},
  [675] =
    {field_arrow, 1},
  [676] =
    {field_arrow, 1, .inherited = true},
    {field_parameter, 0},
    {field_result, 2},
  [679] =
    {field_arrow, 1, .inherited = true},
    {field_multiplicity, 0},
  [681] =
    {field_arrow, 1, .inherited = true},
    {field_multiplicity, 1, .inherited = true},
    {field_parameter, 0},
    {field_result, 2},
  [685] =
    {field_kind, 2},
    {field_type, 0},
  [687] =
    {field_alternative, 1},
  [688] =
    {field_match, 1, .inherited = true},
    {field_pattern, 0},
  [690] =
    {field_alternative, 1},
    {field_binds, 1, .inherited = true},
    {field_match, 1, .inherited = true},
    {field_patterns, 1, .inherited = true},
  [694] =
    {field_match, 1, .inherited = true},
    {field_patterns, 0},
  [696] =
    {field_module, 3},
    {field_names, 4},
    {field_package, 2},
  [699] =
    {field_module, 2},
    {field_names, 4},
  [701] =
    {field_alias, 4},
    {field_module, 2},
  [703] =
    {field_module, 2},
    {field_names, 4},
    {field_package, 1},
  [706] =
    {field_alias, 4},
    {field_module, 2},
    {field_package, 1},
  [709] =
    {field_alias, 4},
    {field_module, 1},
  [711] =
    {field_module, 1},
    {field_names, 4},
  [713] =
    {field_alias, 3},
    {field_module, 1},
    {field_names, 4},
  [716] =
    {field_children, 1, .inherited = true},
    {field_name, 1},
    {field_namespace, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_type, 1, .inherited = true},
    {field_variable, 1, .inherited = true},
  [722] =
    {field_constructor, 2, .inherited = true},
    {field_constructors, 2, .inherited = true},
    {field_deriving, 2, .inherited = true},
    {field_forall, 0},
    {field_kind, 2, .inherited = true},
    {field_name, 1, .inherited = true},
  [728] =
    {field_constructor, 2, .inherited = true},
    {field_constructors, 2, .inherited = true},
    {field_deriving, 2, .inherited = true},
    {field_kind, 2, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_patterns, 1},
  [734] =
    {field_constructor, 2, .inherited = true},
    {field_constructors, 2, .inherited = true},
    {field_context, 0},
    {field_deriving, 2, .inherited = true},
    {field_kind, 2, .inherited = true},
    {field_name, 1, .inherited = true},
  [740] =
    {field_field, 1},
    {field_field, 1, .inherited = true},
    {field_name, 0},
  [743] =
    {field_field, 1},
    {field_name, 0},
  [745] =
    {field_constructor, 1},
    {field_deriving, 2, .inherited = true},
  [747] =
    {field_constructor, 4, .inherited = true},
    {field_constructors, 4, .inherited = true},
    {field_context, 1},
    {field_deriving, 4, .inherited = true},
    {field_kind, 4, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_patterns, 3},
  [754] =
    {field_constructors, 2, .inherited = true},
    {field_kind, 2, .inherited = true},
    {field_left_operand, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right_operand, 1, .inherited = true},
  [759] =
    {field_deriving, 2, .inherited = true},
    {field_left_operand, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right_operand, 1, .inherited = true},
  [763] =
    {field_forall, 0},
    {field_left_operand, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right_operand, 2, .inherited = true},
  [767] =
    {field_forall, 0},
    {field_name, 1, .inherited = true},
    {field_patterns, 2},
  [770] =
    {field_constructors, 2, .inherited = true},
    {field_forall, 0},
    {field_kind, 2, .inherited = true},
    {field_name, 1, .inherited = true},
  [774] =
    {field_deriving, 2, .inherited = true},
    {field_forall, 0},
    {field_name, 1, .inherited = true},
  [777] =
    {field_context, 1},
    {field_forall, 0},
    {field_name, 2, .inherited = true},
  [780] =
    {field_context, 0},
    {field_left_operand, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right_operand, 2, .inherited = true},
  [784] =
    {field_classes, 2},
  [785] =
    {field_field, 1, .inherited = true},
    {field_fields, 1},
    {field_name, 0},
  [788] =
    {field_field, 1, .inherited = true},
    {field_name, 0},
  [790] =
    {field_constructor, 1},
    {field_field, 1, .inherited = true},
    {field_forall, 0},
    {field_name, 1, .inherited = true},
  [794] =
    {field_constructor, 1},
    {field_forall, 0},
    {field_left_operand, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right_operand, 1, .inherited = true},
  [799] =
    {field_constructor, 1},
    {field_fields, 1, .inherited = true},
    {field_forall, 0},
    {field_name, 1, .inherited = true},
  [803] =
    {field_constructor, 1},
    {field_forall, 0},
  [805] =
    {field_constructor, 1},
    {field_context, 0},
    {field_field, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [809] =
    {field_constructor, 1},
    {field_context, 0},
    {field_left_operand, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right_operand, 1, .inherited = true},
  [814] =
    {field_constructor, 1},
    {field_context, 0},
    {field_fields, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [818] =
    {field_constructor, 1},
    {field_context, 0},
  [820] =
    {field_constructor, 0},
    {field_constructor, 1, .inherited = true},
  [822] =
    {field_classes, 1},
    {field_via, 2},
  [824] =
    {field_classes, 2},
    {field_strategy, 1},
  [826] =
    {field_constructors, 2, .inherited = true},
    {field_deriving, 3, .inherited = true},
    {field_kind, 2, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_patterns, 1},
  [831] =
    {field_constructors, 3, .inherited = true},
    {field_context, 0},
    {field_kind, 3, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_patterns, 2},
  [836] =
    {field_context, 0},
    {field_deriving, 3, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_patterns, 2},
  [840] =
    {field_constructors, 2, .inherited = true},
    {field_context, 0},
    {field_deriving, 3, .inherited = true},
    {field_kind, 2, .inherited = true},
    {field_name, 1, .inherited = true},
  [845] =
    {field_constructors, 2, .inherited = true},
    {field_context, 0},
    {field_deriving, 3, .inherited = true},
    {field_kind, 2, .inherited = true},
    {field_left_operand, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right_operand, 1, .inherited = true},
  [852] =
    {field_type, 2},
    {field_type, 3, .inherited = true},
  [854] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [856] =
    {field_declarations, 4},
    {field_name, 1, .inherited = true},
    {field_patterns, 2},
  [859] =
    {field_declarations, 4},
    {field_fundeps, 2},
    {field_name, 1, .inherited = true},
  [862] =
    {field_fundep, 1},
    {field_fundep, 2, .inherited = true},
  [864] =
    {field_declarations, 4},
    {field_fundeps, 2},
    {field_left_operand, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right_operand, 1, .inherited = true},
  [869] =
    {field_context, 1},
    {field_fundeps, 4},
    {field_name, 2, .inherited = true},
    {field_patterns, 3},
  [873] =
    {field_context, 1},
    {field_declarations, 4},
    {field_name, 2, .inherited = true},
  [876] =
    {field_context, 1},
    {field_declarations, 4},
    {field_left_operand, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right_operand, 2, .inherited = true},
  [881] =
    {field_calling_convention, 2},
    {field_safety, 3},
    {field_signature, 4},
  [884] =
    {field_calling_convention, 2},
    {field_entity, 3},
    {field_signature, 4},
  [887] =
    {field_expression, 3},
    {field_guards, 0, .inherited = true},
  [889] =
    {field_guard, 0},
    {field_guard, 1, .inherited = true},
  [891] =
    {field_statement, 2},
  [892] =
    {field_statement, 1},
    {field_statement, 2, .inherited = true},
  [894] =
    {field_statement, 0, .inherited = true},
    {field_statement, 1, .inherited = true},
  [896] =
    {field_arrow, 1},
    {field_expression, 2},
    {field_pattern, 0},
  [899] =
    {field_id, 3, .inherited = true},
    {field_left_operand, 0},
    {field_module, 3, .inherited = true},
    {field_operator, 2},
    {field_operator, 3},
    {field_right_operand, 4},
  [905] =
    {field_left_operand, 0},
    {field_operator, 2},
    {field_operator, 3},
    {field_right_operand, 4},
  [909] =
    {field_expression, 0},
  [910] =
    {field_field, 0},
    {field_subfield, 1, .inherited = true},
  [912] =
    {field_constructor, 1, .inherited = true},
    {field_constructors, 1, .inherited = true},
    {field_context, 1, .inherited = true},
    {field_deriving, 1, .inherited = true},
    {field_forall, 1, .inherited = true},
    {field_kind, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_patterns, 1, .inherited = true},
  [920] =
    {field_constructors, 1, .inherited = true},
    {field_context, 1, .inherited = true},
    {field_deriving, 1, .inherited = true},
    {field_forall, 1, .inherited = true},
    {field_kind, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_patterns, 1, .inherited = true},
  [927] =
    {field_declaration, 1},
  [928] =
    {field_left_operand, 1},
    {field_operator, 3},
  [930] =
    {field_id, 3, .inherited = true},
    {field_left_operand, 1},
    {field_module, 3, .inherited = true},
    {field_operator, 3},
  [934] =
    {field_element, 0},
    {field_element, 2},
    {field_element, 3, .inherited = true},
  [937] =
    {field_field, 1},
  [938] =
    {field_field, 2},
    {field_field, 3, .inherited = true},
  [940] =
    {field_field, 0, .inherited = true},
    {field_field, 1, .inherited = true},
  [942] =
    {field_transformation, 1},
  [943] =
    {field_qualifier, 0},
    {field_qualifier, 1, .inherited = true},
  [945] =
    {field_from, 1},
    {field_to, 3},
  [947] =
    {field_element, 2},
    {field_element, 3, .inherited = true},
  [949] =
    {field_namespace, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [951] =
    {field_children, 2},
    {field_namespace, 0},
    {field_variable, 1},
  [954] =
    {field_children, 2},
    {field_namespace, 0},
    {field_type, 1},
  [957] =
    {field_children, 2},
    {field_namespace, 0},
    {field_operator, 1},
  [960] =
    {field_children, 1, .inherited = true},
    {field_export, 1},
    {field_export, 2, .inherited = true},
    {field_namespace, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_type, 1, .inherited = true},
    {field_variable, 1, .inherited = true},
  [967] =
    {field_export, 0, .inherited = true},
    {field_export, 1, .inherited = true},
  [969] =
    {field_export, 2, .inherited = true},
  [970] =
    {field_body, 4},
    {field_quoter, 2},
  [972] =
    {field_decl, 2},
    {field_decl, 3, .inherited = true},
  [974] =
    {field_kind, 3},
    {field_name, 0, .inherited = true},
    {field_patterns, 1},
  [977] =
    {field_left_operand, 1},
    {field_operator, 2},
    {field_right_operand, 3},
  [980] =
    {field_id, 2, .inherited = true},
    {field_left_operand, 1},
    {field_module, 2, .inherited = true},
    {field_operator, 2},
    {field_right_operand, 3},
  [985] =
    {field_constraint, 2},
    {field_quantifier, 0, .inherited = true},
    {field_variables, 0, .inherited = true},
  [988] =
    {field_constraint, 0},
    {field_kind, 2},
  [990] =
    {field_alternative, 2},
  [991] =
    {field_alternative, 1},
    {field_alternative, 2, .inherited = true},
  [993] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [995] =
    {field_binds, 2, .inherited = true},
    {field_match, 1, .inherited = true},
    {field_pattern, 0},
  [998] =
    {field_alternative, 2},
    {field_binds, 2, .inherited = true},
    {field_match, 2, .inherited = true},
    {field_patterns, 2, .inherited = true},
  [1002] =
    {field_alternative, 1},
    {field_alternative, 2, .inherited = true},
    {field_binds, 1, .inherited = true},
    {field_match, 1, .inherited = true},
    {field_patterns, 1, .inherited = true},
  [1007] =
    {field_binds, 2, .inherited = true},
    {field_match, 1, .inherited = true},
    {field_patterns, 0},
  [1010] =
    {field_else, 5},
    {field_if, 1},
    {field_then, 3},
  [1013] =
    {field_constructors, 4},
    {field_pattern, 2},
    {field_synonym, 0},
  [1016] =
    {field_module, 3},
    {field_names, 5},
    {field_package, 2},
  [1019] =
    {field_alias, 5},
    {field_module, 3},
    {field_package, 2},
  [1022] =
    {field_alias, 5},
    {field_module, 2},
  [1024] =
    {field_module, 2},
    {field_names, 5},
  [1026] =
    {field_alias, 4},
    {field_module, 2},
    {field_names, 5},
  [1029] =
    {field_alias, 5},
    {field_module, 2},
    {field_package, 1},
  [1032] =
    {field_module, 2},
    {field_names, 5},
    {field_package, 1},
  [1035] =
    {field_alias, 4},
    {field_module, 2},
    {field_names, 5},
    {field_package, 1},
  [1039] =
    {field_alias, 4},
    {field_module, 1},
    {field_names, 5},
  [1042] =
    {field_alias, 3},
    {field_module, 1},
    {field_names, 5},
  [1045] =
    {field_children, 1, .inherited = true},
    {field_name, 1},
    {field_name, 2, .inherited = true},
    {field_namespace, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_type, 1, .inherited = true},
    {field_variable, 1, .inherited = true},
  [1052] =
    {field_constructor, 3, .inherited = true},
    {field_constructors, 3, .inherited = true},
    {field_deriving, 3, .inherited = true},
    {field_forall, 0},
    {field_kind, 3, .inherited = true},
    {field_left_operand, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right_operand, 2, .inherited = true},
  [1060] =
    {field_constructor, 3, .inherited = true},
    {field_constructors, 3, .inherited = true},
    {field_deriving, 3, .inherited = true},
    {field_forall, 0},
    {field_kind, 3, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_patterns, 2},
  [1067] =
    {field_constructor, 3, .inherited = true},
    {field_constructors, 3, .inherited = true},
    {field_context, 1},
    {field_deriving, 3, .inherited = true},
    {field_forall, 0},
    {field_kind, 3, .inherited = true},
    {field_name, 2, .inherited = true},
  [1074] =
    {field_constructor, 3, .inherited = true},
    {field_constructors, 3, .inherited = true},
    {field_context, 0},
    {field_deriving, 3, .inherited = true},
    {field_kind, 3, .inherited = true},
    {field_left_operand, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right_operand, 2, .inherited = true},
  [1082] =
    {field_constructor, 3, .inherited = true},
    {field_constructors, 3, .inherited = true},
    {field_context, 0},
    {field_deriving, 3, .inherited = true},
    {field_kind, 3, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_patterns, 2},
  [1089] =
    {field_constructors, 3},
    {field_kind, 1},
  [1091] =
    {field_constructors, 2, .inherited = true},
    {field_deriving, 3, .inherited = true},
    {field_kind, 2, .inherited = true},
    {field_left_operand, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right_operand, 1, .inherited = true},
  [1097] =
    {field_constructors, 3, .inherited = true},
    {field_forall, 0},
    {field_kind, 3, .inherited = true},
    {field_left_operand, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right_operand, 2, .inherited = true},
  [1103] =
    {field_deriving, 3, .inherited = true},
    {field_forall, 0},
    {field_left_operand, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right_operand, 2, .inherited = true},
  [1108] =
    {field_constructors, 3, .inherited = true},
    {field_forall, 0},
    {field_kind, 3, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_patterns, 2},
  [1113] =
    {field_deriving, 3, .inherited = true},
    {field_forall, 0},
    {field_name, 1, .inherited = true},
    {field_patterns, 2},
  [1117] =
    {field_constructors, 2, .inherited = true},
    {field_deriving, 3, .inherited = true},
    {field_forall, 0},
    {field_kind, 2, .inherited = true},
    {field_name, 1, .inherited = true},
  [1122] =
    {field_context, 1},
    {field_forall, 0},
    {field_left_operand, 3, .inherited = true},
    {field_operator, 3, .inherited = true},
    {field_right_operand, 3, .inherited = true},
  [1127] =
    {field_context, 1},
    {field_forall, 0},
    {field_name, 2, .inherited = true},
    {field_patterns, 3},
  [1131] =
    {field_constructors, 3, .inherited = true},
    {field_context, 1},
    {field_forall, 0},
    {field_kind, 3, .inherited = true},
    {field_name, 2, .inherited = true},
  [1136] =
    {field_context, 1},
    {field_deriving, 3, .inherited = true},
    {field_forall, 0},
    {field_name, 2, .inherited = true},
  [1140] =
    {field_constructors, 3, .inherited = true},
    {field_context, 0},
    {field_kind, 3, .inherited = true},
    {field_left_operand, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right_operand, 2, .inherited = true},
  [1146] =
    {field_context, 0},
    {field_deriving, 3, .inherited = true},
    {field_left_operand, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right_operand, 2, .inherited = true},
  [1151] =
    {field_classes, 2},
    {field_via, 3},
  [1153] =
    {field_classes, 3},
    {field_strategy, 2},
  [1155] =
    {field_constructor, 2},
    {field_context, 1},
    {field_field, 2, .inherited = true},
    {field_forall, 0},
    {field_name, 2, .inherited = true},
  [1160] =
    {field_constructor, 2},
    {field_context, 1},
    {field_forall, 0},
    {field_left_operand, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right_operand, 2, .inherited = true},
  [1166] =
    {field_constructor, 2},
    {field_context, 1},
    {field_fields, 2, .inherited = true},
    {field_forall, 0},
    {field_name, 2, .inherited = true},
  [1171] =
    {field_constructor, 2},
    {field_context, 1},
    {field_forall, 0},
  [1174] =
    {field_constructor, 0, .inherited = true},
    {field_constructor, 1, .inherited = true},
  [1176] =
    {field_classes, 2},
    {field_strategy, 1},
    {field_via, 3},
  [1179] =
    {field_constructors, 3, .inherited = true},
    {field_context, 0},
    {field_deriving, 4, .inherited = true},
    {field_kind, 3, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_patterns, 2},
  [1185] =
    {field_declarations, 5},
    {field_fundeps, 3},
    {field_name, 1, .inherited = true},
    {field_patterns, 2},
  [1189] =
    {field_kind, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_patterns, 1, .inherited = true},
  [1192] =
    {field_signature, 1},
  [1193] =
    {field_fundep, 0, .inherited = true},
    {field_fundep, 1, .inherited = true},
  [1195] =
    {field_determined, 2},
    {field_matched, 0},
  [1197] =
    {field_context, 1},
    {field_declarations, 5},
    {field_name, 2, .inherited = true},
    {field_patterns, 3},
  [1201] =
    {field_context, 1},
    {field_declarations, 5},
    {field_fundeps, 3},
    {field_name, 2, .inherited = true},
  [1205] =
    {field_context, 1},
    {field_declarations, 5},
    {field_fundeps, 3},
    {field_left_operand, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right_operand, 2, .inherited = true},
  [1211] =
    {field_calling_convention, 2},
    {field_entity, 4},
    {field_safety, 3},
    {field_signature, 5},
  [1215] =
    {field_guard, 1},
  [1216] =
    {field_guard, 0, .inherited = true},
    {field_guard, 1, .inherited = true},
  [1218] =
    {field_statement, 2},
    {field_statement, 3, .inherited = true},
  [1220] =
    {field_expression, 0},
    {field_field, 3},
  [1222] =
    {field_subfield, 1},
  [1223] =
    {field_subfield, 0, .inherited = true},
    {field_subfield, 1, .inherited = true},
  [1225] =
    {field_expression, 2},
    {field_field, 0},
  [1227] =
    {field_constructor, 0},
    {field_field, 3},
  [1229] =
    {field_field, 0},
    {field_pattern, 2},
  [1231] =
    {field_declaration, 2},
  [1232] =
    {field_name, 2, .inherited = true},
    {field_patterns, 2, .inherited = true},
  [1234] =
    {field_declaration, 1},
    {field_declaration, 2, .inherited = true},
  [1236] =
    {field_declaration, 0, .inherited = true},
    {field_declaration, 1, .inherited = true},
  [1238] =
    {field_from, 1},
    {field_step, 3},
  [1240] =
    {field_qualifier, 1},
  [1241] =
    {field_qualifier, 0, .inherited = true},
    {field_qualifier, 1, .inherited = true},
  [1243] =
    {field_equation, 1},
    {field_forall, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_patterns, 1, .inherited = true},
  [1247] =
    {field_kind, 4},
    {field_left_operand, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right_operand, 2, .inherited = true},
  [1251] =
    {field_alternative, 2},
    {field_alternative, 3, .inherited = true},
  [1253] =
    {field_alternative, 2},
    {field_alternative, 3, .inherited = true},
    {field_binds, 2, .inherited = true},
    {field_match, 2, .inherited = true},
    {field_patterns, 2, .inherited = true},
  [1258] =
    {field_expression, 4},
    {field_guards, 0, .inherited = true},
  [1260] =
    {field_else, 6},
    {field_if, 1},
    {field_then, 3},
  [1263] =
    {field_else, 6},
    {field_if, 1},
    {field_then, 4},
  [1266] =
    {field_alias, 6},
    {field_module, 3},
    {field_package, 2},
  [1269] =
    {field_module, 3},
    {field_names, 6},
    {field_package, 2},
  [1272] =
    {field_alias, 5},
    {field_module, 3},
    {field_names, 6},
    {field_package, 2},
  [1276] =
    {field_alias, 5},
    {field_module, 2},
    {field_names, 6},
  [1279] =
    {field_alias, 4},
    {field_module, 2},
    {field_names, 6},
  [1282] =
    {field_alias, 5},
    {field_module, 2},
    {field_names, 6},
    {field_package, 1},
  [1286] =
    {field_alias, 4},
    {field_module, 2},
    {field_names, 6},
    {field_package, 1},
  [1290] =
    {field_alias, 4},
    {field_module, 1},
    {field_names, 6},
  [1293] =
    {field_constructor, 4, .inherited = true},
    {field_constructors, 4, .inherited = true},
    {field_context, 1},
    {field_deriving, 4, .inherited = true},
    {field_forall, 0},
    {field_kind, 4, .inherited = true},
    {field_left_operand, 3, .inherited = true},
    {field_operator, 3, .inherited = true},
    {field_right_operand, 3, .inherited = true},
  [1302] =
    {field_constructor, 4, .inherited = true},
    {field_constructors, 4, .inherited = true},
    {field_context, 1},
    {field_deriving, 4, .inherited = true},
    {field_forall, 0},
    {field_kind, 4, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_patterns, 3},
  [1310] =
    {field_constructor, 2},
  [1311] =
    {field_name, 0},
    {field_type, 2},
    {field_type, 2, .inherited = true},
  [1314] =
    {field_arrow, 2, .inherited = true},
    {field_fields, 2, .inherited = true},
    {field_name, 0},
    {field_type, 2},
    {field_type, 2, .inherited = true},
  [1319] =
    {field_constructor, 1},
    {field_constructor, 2, .inherited = true},
  [1321] =
    {field_name, 0, .inherited = true},
    {field_names, 0},
    {field_type, 2},
    {field_type, 2, .inherited = true},
  [1325] =
    {field_arrow, 2, .inherited = true},
    {field_fields, 2, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_names, 0},
    {field_type, 2},
    {field_type, 2, .inherited = true},
  [1331] =
    {field_constructors, 3, .inherited = true},
    {field_deriving, 4, .inherited = true},
    {field_forall, 0},
    {field_kind, 3, .inherited = true},
    {field_left_operand, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right_operand, 2, .inherited = true},
  [1338] =
    {field_constructors, 3, .inherited = true},
    {field_deriving, 4, .inherited = true},
    {field_forall, 0},
    {field_kind, 3, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_patterns, 2},
  [1344] =
    {field_constructors, 4, .inherited = true},
    {field_context, 1},
    {field_forall, 0},
    {field_kind, 4, .inherited = true},
    {field_left_operand, 3, .inherited = true},
    {field_operator, 3, .inherited = true},
    {field_right_operand, 3, .inherited = true},
  [1351] =
    {field_context, 1},
    {field_deriving, 4, .inherited = true},
    {field_forall, 0},
    {field_left_operand, 3, .inherited = true},
    {field_operator, 3, .inherited = true},
    {field_right_operand, 3, .inherited = true},
  [1357] =
    {field_constructors, 4, .inherited = true},
    {field_context, 1},
    {field_forall, 0},
    {field_kind, 4, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_patterns, 3},
  [1363] =
    {field_context, 1},
    {field_deriving, 4, .inherited = true},
    {field_forall, 0},
    {field_name, 2, .inherited = true},
    {field_patterns, 3},
  [1368] =
    {field_constructors, 3, .inherited = true},
    {field_context, 1},
    {field_deriving, 4, .inherited = true},
    {field_forall, 0},
    {field_kind, 3, .inherited = true},
    {field_name, 2, .inherited = true},
  [1374] =
    {field_constructors, 3, .inherited = true},
    {field_context, 0},
    {field_deriving, 4, .inherited = true},
    {field_kind, 3, .inherited = true},
    {field_left_operand, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right_operand, 2, .inherited = true},
  [1381] =
    {field_classes, 3},
    {field_strategy, 2},
    {field_via, 4},
  [1384] =
    {field_name, 2, .inherited = true},
  [1385] =
    {field_context, 1},
    {field_declarations, 6},
    {field_fundeps, 4},
    {field_name, 2, .inherited = true},
    {field_patterns, 3},
  [1390] =
    {field_expression, 0},
    {field_field, 3},
    {field_field, 4, .inherited = true},
  [1393] =
    {field_constructor, 0},
    {field_field, 3},
    {field_field, 4, .inherited = true},
  [1396] =
    {field_declaration, 2},
    {field_declaration, 3, .inherited = true},
  [1398] =
    {field_name, 3, .inherited = true},
    {field_patterns, 3, .inherited = true},
  [1400] =
    {field_forall, 1},
    {field_name, 3, .inherited = true},
    {field_patterns, 3, .inherited = true},
  [1403] =
    {field_from, 1},
    {field_step, 3},
    {field_to, 5},
  [1406] =
    {field_classifier, 3},
  [1407] =
    {field_key, 3},
    {field_transformation, 1},
  [1409] =
    {field_determined, 3},
    {field_result, 1},
  [1411] =
    {field_equation, 2},
    {field_forall, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_patterns, 2, .inherited = true},
  [1415] =
    {field_equation, 1},
    {field_equation, 2, .inherited = true},
    {field_forall, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_patterns, 1, .inherited = true},
  [1420] =
    {field_equation, 0, .inherited = true},
    {field_equation, 1, .inherited = true},
  [1422] =
    {field_else, 7},
    {field_if, 1},
    {field_then, 4},
  [1425] =
    {field_alias, 6},
    {field_module, 3},
    {field_names, 7},
    {field_package, 2},
  [1429] =
    {field_alias, 5},
    {field_module, 3},
    {field_names, 7},
    {field_package, 2},
  [1433] =
    {field_alias, 5},
    {field_module, 2},
    {field_names, 7},
  [1436] =
    {field_alias, 5},
    {field_module, 2},
    {field_names, 7},
    {field_package, 1},
  [1440] =
    {field_constructor, 2},
    {field_constructor, 3, .inherited = true},
  [1442] =
    {field_forall, 2},
    {field_name, 0},
    {field_type, 3},
    {field_type, 3, .inherited = true},
  [1446] =
    {field_arrow, 3, .inherited = true},
    {field_fields, 3, .inherited = true},
    {field_forall, 2},
    {field_name, 0},
    {field_type, 3},
    {field_type, 3, .inherited = true},
  [1452] =
    {field_context, 2},
    {field_name, 0},
    {field_type, 3},
    {field_type, 3, .inherited = true},
  [1456] =
    {field_arrow, 3, .inherited = true},
    {field_context, 2},
    {field_fields, 3, .inherited = true},
    {field_name, 0},
    {field_type, 3},
    {field_type, 3, .inherited = true},
  [1462] =
    {field_forall, 2},
    {field_name, 0, .inherited = true},
    {field_names, 0},
    {field_type, 3},
    {field_type, 3, .inherited = true},
  [1467] =
    {field_arrow, 3, .inherited = true},
    {field_fields, 3, .inherited = true},
    {field_forall, 2},
    {field_name, 0, .inherited = true},
    {field_names, 0},
    {field_type, 3},
    {field_type, 3, .inherited = true},
  [1474] =
    {field_context, 2},
    {field_name, 0, .inherited = true},
    {field_names, 0},
    {field_type, 3},
    {field_type, 3, .inherited = true},
  [1479] =
    {field_arrow, 3, .inherited = true},
    {field_context, 2},
    {field_fields, 3, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_names, 0},
    {field_type, 3},
    {field_type, 3, .inherited = true},
  [1486] =
    {field_constructors, 4, .inherited = true},
    {field_context, 1},
    {field_deriving, 5, .inherited = true},
    {field_forall, 0},
    {field_kind, 4, .inherited = true},
    {field_left_operand, 3, .inherited = true},
    {field_operator, 3, .inherited = true},
    {field_right_operand, 3, .inherited = true},
  [1494] =
    {field_constructors, 4, .inherited = true},
    {field_context, 1},
    {field_deriving, 5, .inherited = true},
    {field_forall, 0},
    {field_kind, 4, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_patterns, 3},
  [1501] =
    {field_name, 2, .inherited = true},
    {field_patterns, 3},
  [1503] =
    {field_forall, 2},
    {field_name, 4, .inherited = true},
    {field_patterns, 4, .inherited = true},
  [1506] =
    {field_equation, 2},
    {field_equation, 3, .inherited = true},
    {field_forall, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_patterns, 2, .inherited = true},
  [1511] =
    {field_alias, 6},
    {field_module, 3},
    {field_names, 8},
    {field_package, 2},
  [1515] =
    {field_context, 3},
    {field_forall, 2},
    {field_name, 0},
    {field_type, 4},
    {field_type, 4, .inherited = true},
  [1520] =
    {field_arrow, 4, .inherited = true},
    {field_context, 3},
    {field_fields, 4, .inherited = true},
    {field_forall, 2},
    {field_name, 0},
    {field_type, 4},
    {field_type, 4, .inherited = true},
  [1527] =
    {field_arrow, 1},
    {field_arrow, 1, .inherited = true},
    {field_field, 0, .inherited = true},
    {field_fields, 0},
    {field_type, 2},
  [1532] =
    {field_context, 3},
    {field_forall, 2},
    {field_name, 0, .inherited = true},
    {field_names, 0},
    {field_type, 4},
    {field_type, 4, .inherited = true},
  [1538] =
    {field_arrow, 4, .inherited = true},
    {field_context, 3},
    {field_fields, 4, .inherited = true},
    {field_forall, 2},
    {field_name, 0, .inherited = true},
    {field_names, 0},
    {field_type, 4},
    {field_type, 4, .inherited = true},
  [1546] =
    {field_kind, 4},
    {field_name, 2, .inherited = true},
  [1548] =
    {field_classifier, 5},
    {field_key, 3},
  [1550] =
    {field_classifier, 5},
    {field_expression, 3, .inherited = true},
    {field_key, 3},
    {field_type, 3, .inherited = true},
  [1554] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
    {field_type, 3},
  [1557] =
    {field_kind, 5},
    {field_name, 2, .inherited = true},
    {field_patterns, 3},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [3] = {
    [0] = alias_sym_constructor,
  },
  [7] = {
    [0] = sym__type_list,
  },
  [31] = {
    [0] = sym__type_list,
  },
  [33] = {
    [0] = alias_sym_module_id,
  },
  [36] = {
    [1] = alias_sym_constructor,
  },
  [41] = {
    [0] = alias_sym_prefix_list,
  },
  [49] = {
    [0] = alias_sym_prefix_list,
  },
  [50] = {
    [0] = alias_sym_type_binder,
  },
  [60] = {
    [0] = sym_operator,
  },
  [68] = {
    [1] = alias_sym_type_application,
  },
  [70] = {
    [1] = alias_sym_type_binder,
  },
  [72] = {
    [0] = sym_module,
  },
  [73] = {
    [0] = sym_module,
    [1] = alias_sym_constructor,
  },
  [80] = {
    [0] = anon_alias_sym_LPAREN_POUND,
    [1] = anon_alias_sym_LPAREN_POUND,
  },
  [81] = {
    [1] = alias_sym_module_id,
  },
  [97] = {
    [1] = alias_sym_constructor,
  },
  [109] = {
    [0] = alias_sym_constructor,
  },
  [111] = {
    [1] = alias_sym_import_package,
  },
  [131] = {
    [2] = sym_operator,
  },
  [134] = {
    [1] = alias_sym_quoted_expression,
  },
  [141] = {
    [0] = sym_bind,
  },
  [177] = {
    [1] = sym_operator,
  },
  [187] = {
    [0] = sym_module,
    [1] = sym_operator,
  },
  [195] = {
    [0] = alias_sym_constructor,
  },
  [199] = {
    [2] = alias_sym_import_package,
  },
  [201] = {
    [1] = alias_sym_import_package,
  },
  [212] = {
    [0] = alias_sym_constructor,
  },
  [239] = {
    [0] = alias_sym_pattern_guard,
  },
  [242] = {
    [0] = alias_sym_boolean,
  },
  [248] = {
    [0] = sym__type_param_wildcard,
  },
  [272] = {
    [1] = alias_sym_export,
  },
  [274] = {
    [3] = alias_sym_quoted_expression,
  },
  [302] = {
    [2] = alias_sym_import_package,
  },
  [305] = {
    [1] = alias_sym_import_package,
  },
  [306] = {
    [1] = alias_sym_import_package,
  },
  [314] = {
    [0] = alias_sym_constructor,
    [1] = sym__exp_record,
  },
  [315] = {
    [0] = alias_sym_constructor,
  },
  [317] = {
    [1] = sym__exp_record,
  },
  [329] = {
    [0] = alias_sym_constructor,
  },
  [330] = {
    [0] = alias_sym_constructor,
  },
  [386] = {
    [1] = alias_sym_export,
  },
  [389] = {
    [4] = alias_sym_quoted_expression,
  },
  [390] = {
    [4] = alias_sym_quoted_expression,
  },
  [391] = {
    [4] = alias_sym_quoted_type,
  },
  [392] = {
    [4] = alias_sym_quoted_pattern,
  },
  [409] = {
    [2] = alias_sym_import_package,
  },
  [410] = {
    [2] = alias_sym_import_package,
  },
  [414] = {
    [1] = alias_sym_import_package,
  },
  [415] = {
    [1] = alias_sym_import_package,
  },
  [416] = {
    [1] = alias_sym_import_package,
  },
  [472] = {
    [1] = alias_sym_all_names,
  },
  [473] = {
    [1] = sym__patsyn_equation,
  },
  [480] = {
    [2] = alias_sym_import_package,
  },
  [481] = {
    [2] = alias_sym_import_package,
  },
  [482] = {
    [2] = alias_sym_import_package,
  },
  [485] = {
    [1] = alias_sym_import_package,
  },
  [486] = {
    [1] = alias_sym_import_package,
  },
  [491] = {
    [0] = alias_sym_constructor,
  },
  [492] = {
    [0] = alias_sym_constructor,
  },
  [517] = {
    [1] = alias_sym_all_names,
  },
  [519] = {
    [2] = sym__patsyn_equation,
  },
  [520] = {
    [1] = sym__patsyn_equation,
  },
  [523] = {
    [1] = alias_sym_constructor_synonym,
  },
  [524] = {
    [2] = alias_sym_import_package,
  },
  [525] = {
    [2] = alias_sym_import_package,
  },
  [527] = {
    [1] = alias_sym_import_package,
  },
  [529] = {
    [0] = alias_sym_constructor,
  },
  [530] = {
    [0] = alias_sym_constructor,
  },
  [531] = {
    [0] = alias_sym_constructor,
  },
  [532] = {
    [0] = alias_sym_constructor,
  },
  [545] = {
    [2] = sym__patsyn_equation,
  },
  [546] = {
    [2] = alias_sym_constructor_synonym,
  },
  [547] = {
    [2] = alias_sym_import_package,
  },
  [548] = {
    [0] = alias_sym_constructor,
  },
  [549] = {
    [0] = alias_sym_constructor,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_generator, 3,
    sym_generator,
    alias_sym_pattern_guard,
    sym_bind,
  sym__at_type, 3,
    sym__at_type,
    alias_sym_type_application,
    alias_sym_type_binder,
  sym__ktype, 2,
    sym__ktype,
    alias_sym_quoted_type,
  sym__type_instance, 2,
    sym__type_instance,
    sym__patsyn_equation,
  sym__exp, 3,
    sym__exp,
    alias_sym_boolean,
    alias_sym_quoted_expression,
  sym__pat, 2,
    sym__pat,
    alias_sym_quoted_pattern,
  aux_sym__qualifying_module, 2,
    aux_sym__qualifying_module,
    sym_module,
  sym__ie_entity, 2,
    sym__ie_entity,
    alias_sym_export,
  sym__record_fields, 2,
    sym__record_fields,
    sym__exp_record,
  sym_bind, 2,
    sym_bind,
    alias_sym_constructor_synonym,
  sym__plist, 3,
    sym__plist,
    alias_sym_prefix_list,
    sym__type_list,
  sym__arrow, 2,
    sym__arrow,
    sym_operator,
  sym__prefix_dot, 2,
    sym__prefix_dot,
    sym_operator,
  sym__paren_open, 2,
    sym__paren_open,
    anon_alias_sym_LPAREN_POUND,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 26,
  [28] = 26,
  [29] = 29,
  [30] = 29,
  [31] = 29,
  [32] = 29,
  [33] = 29,
  [34] = 29,
  [35] = 29,
  [36] = 29,
  [37] = 37,
  [38] = 38,
  [39] = 38,
  [40] = 38,
  [41] = 38,
  [42] = 38,
  [43] = 38,
  [44] = 38,
  [45] = 45,
  [46] = 45,
  [47] = 45,
  [48] = 45,
  [49] = 45,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 50,
  [62] = 62,
  [63] = 62,
  [64] = 62,
  [65] = 62,
  [66] = 62,
  [67] = 62,
  [68] = 62,
  [69] = 62,
  [70] = 62,
  [71] = 62,
  [72] = 62,
  [73] = 73,
  [74] = 73,
  [75] = 75,
  [76] = 76,
  [77] = 73,
  [78] = 78,
  [79] = 76,
  [80] = 75,
  [81] = 76,
  [82] = 73,
  [83] = 78,
  [84] = 78,
  [85] = 73,
  [86] = 76,
  [87] = 78,
  [88] = 75,
  [89] = 75,
  [90] = 76,
  [91] = 73,
  [92] = 76,
  [93] = 73,
  [94] = 75,
  [95] = 76,
  [96] = 78,
  [97] = 76,
  [98] = 78,
  [99] = 78,
  [100] = 75,
  [101] = 73,
  [102] = 78,
  [103] = 78,
  [104] = 75,
  [105] = 78,
  [106] = 76,
  [107] = 76,
  [108] = 75,
  [109] = 76,
  [110] = 78,
  [111] = 75,
  [112] = 73,
  [113] = 73,
  [114] = 75,
  [115] = 75,
  [116] = 73,
  [117] = 50,
  [118] = 50,
  [119] = 58,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 121,
  [124] = 124,
  [125] = 57,
  [126] = 122,
  [127] = 122,
  [128] = 124,
  [129] = 121,
  [130] = 120,
  [131] = 120,
  [132] = 124,
  [133] = 120,
  [134] = 121,
  [135] = 124,
  [136] = 55,
  [137] = 120,
  [138] = 121,
  [139] = 52,
  [140] = 124,
  [141] = 60,
  [142] = 120,
  [143] = 120,
  [144] = 56,
  [145] = 122,
  [146] = 121,
  [147] = 124,
  [148] = 121,
  [149] = 121,
  [150] = 121,
  [151] = 53,
  [152] = 124,
  [153] = 122,
  [154] = 59,
  [155] = 120,
  [156] = 120,
  [157] = 124,
  [158] = 121,
  [159] = 122,
  [160] = 122,
  [161] = 122,
  [162] = 120,
  [163] = 54,
  [164] = 120,
  [165] = 124,
  [166] = 121,
  [167] = 122,
  [168] = 124,
  [169] = 122,
  [170] = 122,
  [171] = 51,
  [172] = 124,
  [173] = 173,
  [174] = 173,
  [175] = 175,
  [176] = 50,
  [177] = 50,
  [178] = 50,
  [179] = 173,
  [180] = 173,
  [181] = 50,
  [182] = 50,
  [183] = 50,
  [184] = 184,
  [185] = 175,
  [186] = 186,
  [187] = 173,
  [188] = 173,
  [189] = 186,
  [190] = 186,
  [191] = 186,
  [192] = 173,
  [193] = 175,
  [194] = 173,
  [195] = 186,
  [196] = 186,
  [197] = 186,
  [198] = 173,
  [199] = 173,
  [200] = 173,
  [201] = 186,
  [202] = 175,
  [203] = 186,
  [204] = 186,
  [205] = 186,
  [206] = 175,
  [207] = 53,
  [208] = 59,
  [209] = 209,
  [210] = 56,
  [211] = 57,
  [212] = 57,
  [213] = 209,
  [214] = 209,
  [215] = 209,
  [216] = 54,
  [217] = 51,
  [218] = 209,
  [219] = 52,
  [220] = 50,
  [221] = 55,
  [222] = 53,
  [223] = 209,
  [224] = 56,
  [225] = 56,
  [226] = 53,
  [227] = 60,
  [228] = 57,
  [229] = 52,
  [230] = 58,
  [231] = 209,
  [232] = 59,
  [233] = 55,
  [234] = 51,
  [235] = 59,
  [236] = 236,
  [237] = 54,
  [238] = 54,
  [239] = 51,
  [240] = 55,
  [241] = 60,
  [242] = 60,
  [243] = 58,
  [244] = 52,
  [245] = 58,
  [246] = 246,
  [247] = 50,
  [248] = 248,
  [249] = 249,
  [250] = 249,
  [251] = 55,
  [252] = 50,
  [253] = 52,
  [254] = 50,
  [255] = 246,
  [256] = 256,
  [257] = 246,
  [258] = 50,
  [259] = 256,
  [260] = 256,
  [261] = 256,
  [262] = 256,
  [263] = 50,
  [264] = 256,
  [265] = 265,
  [266] = 56,
  [267] = 246,
  [268] = 246,
  [269] = 60,
  [270] = 58,
  [271] = 59,
  [272] = 246,
  [273] = 50,
  [274] = 256,
  [275] = 246,
  [276] = 53,
  [277] = 246,
  [278] = 57,
  [279] = 256,
  [280] = 256,
  [281] = 51,
  [282] = 249,
  [283] = 246,
  [284] = 246,
  [285] = 256,
  [286] = 249,
  [287] = 54,
  [288] = 256,
  [289] = 249,
  [290] = 246,
  [291] = 55,
  [292] = 53,
  [293] = 53,
  [294] = 56,
  [295] = 52,
  [296] = 59,
  [297] = 60,
  [298] = 58,
  [299] = 56,
  [300] = 55,
  [301] = 52,
  [302] = 51,
  [303] = 52,
  [304] = 53,
  [305] = 59,
  [306] = 209,
  [307] = 57,
  [308] = 55,
  [309] = 50,
  [310] = 56,
  [311] = 57,
  [312] = 58,
  [313] = 54,
  [314] = 60,
  [315] = 58,
  [316] = 60,
  [317] = 54,
  [318] = 54,
  [319] = 51,
  [320] = 209,
  [321] = 50,
  [322] = 57,
  [323] = 59,
  [324] = 209,
  [325] = 51,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 52,
  [331] = 55,
  [332] = 332,
  [333] = 333,
  [334] = 329,
  [335] = 335,
  [336] = 53,
  [337] = 59,
  [338] = 56,
  [339] = 57,
  [340] = 54,
  [341] = 51,
  [342] = 60,
  [343] = 58,
  [344] = 344,
  [345] = 345,
  [346] = 345,
  [347] = 347,
  [348] = 344,
  [349] = 345,
  [350] = 50,
  [351] = 344,
  [352] = 344,
  [353] = 353,
  [354] = 354,
  [355] = 347,
  [356] = 347,
  [357] = 347,
  [358] = 358,
  [359] = 354,
  [360] = 347,
  [361] = 347,
  [362] = 345,
  [363] = 358,
  [364] = 358,
  [365] = 344,
  [366] = 347,
  [367] = 347,
  [368] = 368,
  [369] = 358,
  [370] = 345,
  [371] = 347,
  [372] = 358,
  [373] = 347,
  [374] = 347,
  [375] = 375,
  [376] = 376,
  [377] = 375,
  [378] = 376,
  [379] = 379,
  [380] = 375,
  [381] = 376,
  [382] = 375,
  [383] = 375,
  [384] = 379,
  [385] = 385,
  [386] = 385,
  [387] = 376,
  [388] = 376,
  [389] = 376,
  [390] = 376,
  [391] = 376,
  [392] = 392,
  [393] = 375,
  [394] = 375,
  [395] = 375,
  [396] = 375,
  [397] = 375,
  [398] = 376,
  [399] = 376,
  [400] = 400,
  [401] = 335,
  [402] = 400,
  [403] = 400,
  [404] = 400,
  [405] = 400,
  [406] = 400,
  [407] = 400,
  [408] = 332,
  [409] = 326,
  [410] = 400,
  [411] = 411,
  [412] = 328,
  [413] = 333,
  [414] = 400,
  [415] = 332,
  [416] = 400,
  [417] = 332,
  [418] = 335,
  [419] = 333,
  [420] = 326,
  [421] = 327,
  [422] = 328,
  [423] = 328,
  [424] = 326,
  [425] = 327,
  [426] = 335,
  [427] = 333,
  [428] = 332,
  [429] = 429,
  [430] = 429,
  [431] = 429,
  [432] = 429,
  [433] = 429,
  [434] = 429,
  [435] = 429,
  [436] = 429,
  [437] = 429,
  [438] = 429,
  [439] = 429,
  [440] = 429,
  [441] = 429,
  [442] = 429,
  [443] = 429,
  [444] = 429,
  [445] = 429,
  [446] = 429,
  [447] = 429,
  [448] = 429,
  [449] = 429,
  [450] = 429,
  [451] = 429,
  [452] = 429,
  [453] = 429,
  [454] = 429,
  [455] = 429,
  [456] = 429,
  [457] = 429,
  [458] = 429,
  [459] = 429,
  [460] = 429,
  [461] = 429,
  [462] = 429,
  [463] = 429,
  [464] = 429,
  [465] = 429,
  [466] = 429,
  [467] = 429,
  [468] = 429,
  [469] = 429,
  [470] = 429,
  [471] = 429,
  [472] = 429,
  [473] = 429,
  [474] = 429,
  [475] = 429,
  [476] = 429,
  [477] = 333,
  [478] = 327,
  [479] = 335,
  [480] = 327,
  [481] = 326,
  [482] = 328,
  [483] = 333,
  [484] = 333,
  [485] = 328,
  [486] = 327,
  [487] = 326,
  [488] = 332,
  [489] = 328,
  [490] = 333,
  [491] = 335,
  [492] = 335,
  [493] = 335,
  [494] = 332,
  [495] = 328,
  [496] = 326,
  [497] = 332,
  [498] = 326,
  [499] = 332,
  [500] = 327,
  [501] = 333,
  [502] = 332,
  [503] = 326,
  [504] = 328,
  [505] = 326,
  [506] = 332,
  [507] = 335,
  [508] = 327,
  [509] = 335,
  [510] = 328,
  [511] = 327,
  [512] = 333,
  [513] = 411,
  [514] = 328,
  [515] = 332,
  [516] = 335,
  [517] = 326,
  [518] = 333,
  [519] = 332,
  [520] = 332,
  [521] = 328,
  [522] = 326,
  [523] = 335,
  [524] = 333,
  [525] = 327,
  [526] = 326,
  [527] = 333,
  [528] = 335,
  [529] = 335,
  [530] = 332,
  [531] = 411,
  [532] = 333,
  [533] = 411,
  [534] = 332,
  [535] = 326,
  [536] = 332,
  [537] = 335,
  [538] = 328,
  [539] = 332,
  [540] = 333,
  [541] = 326,
  [542] = 332,
  [543] = 328,
  [544] = 328,
  [545] = 411,
  [546] = 332,
  [547] = 332,
  [548] = 335,
  [549] = 333,
  [550] = 328,
  [551] = 326,
  [552] = 332,
  [553] = 411,
  [554] = 328,
  [555] = 411,
  [556] = 335,
  [557] = 326,
  [558] = 328,
  [559] = 411,
  [560] = 333,
  [561] = 411,
  [562] = 332,
  [563] = 326,
  [564] = 332,
  [565] = 332,
  [566] = 326,
  [567] = 333,
  [568] = 332,
  [569] = 333,
  [570] = 335,
  [571] = 332,
  [572] = 335,
  [573] = 328,
  [574] = 332,
  [575] = 332,
  [576] = 411,
  [577] = 332,
  [578] = 332,
  [579] = 328,
  [580] = 328,
  [581] = 333,
  [582] = 326,
  [583] = 335,
  [584] = 335,
  [585] = 332,
  [586] = 326,
  [587] = 333,
  [588] = 588,
  [589] = 588,
  [590] = 588,
  [591] = 588,
  [592] = 588,
  [593] = 588,
  [594] = 588,
  [595] = 588,
  [596] = 588,
  [597] = 588,
  [598] = 588,
  [599] = 588,
  [600] = 588,
  [601] = 588,
  [602] = 588,
  [603] = 588,
  [604] = 588,
  [605] = 588,
  [606] = 588,
  [607] = 588,
  [608] = 588,
  [609] = 588,
  [610] = 588,
  [611] = 588,
  [612] = 588,
  [613] = 588,
  [614] = 588,
  [615] = 588,
  [616] = 588,
  [617] = 588,
  [618] = 588,
  [619] = 588,
  [620] = 588,
  [621] = 588,
  [622] = 588,
  [623] = 588,
  [624] = 588,
  [625] = 588,
  [626] = 588,
  [627] = 588,
  [628] = 588,
  [629] = 588,
  [630] = 588,
  [631] = 588,
  [632] = 588,
  [633] = 588,
  [634] = 588,
  [635] = 588,
  [636] = 588,
  [637] = 588,
  [638] = 588,
  [639] = 588,
  [640] = 588,
  [641] = 588,
  [642] = 588,
  [643] = 588,
  [644] = 588,
  [645] = 588,
  [646] = 588,
  [647] = 588,
  [648] = 333,
  [649] = 335,
  [650] = 328,
  [651] = 332,
  [652] = 326,
  [653] = 332,
  [654] = 332,
  [655] = 328,
  [656] = 333,
  [657] = 327,
  [658] = 326,
  [659] = 326,
  [660] = 335,
  [661] = 335,
  [662] = 335,
  [663] = 332,
  [664] = 332,
  [665] = 332,
  [666] = 327,
  [667] = 333,
  [668] = 328,
  [669] = 333,
  [670] = 326,
  [671] = 328,
  [672] = 672,
  [673] = 328,
  [674] = 326,
  [675] = 675,
  [676] = 675,
  [677] = 675,
  [678] = 675,
  [679] = 675,
  [680] = 675,
  [681] = 675,
  [682] = 675,
  [683] = 675,
  [684] = 332,
  [685] = 326,
  [686] = 675,
  [687] = 675,
  [688] = 332,
  [689] = 675,
  [690] = 675,
  [691] = 675,
  [692] = 675,
  [693] = 675,
  [694] = 675,
  [695] = 675,
  [696] = 675,
  [697] = 675,
  [698] = 335,
  [699] = 675,
  [700] = 675,
  [701] = 675,
  [702] = 675,
  [703] = 333,
  [704] = 328,
  [705] = 675,
  [706] = 675,
  [707] = 675,
  [708] = 675,
  [709] = 675,
  [710] = 675,
  [711] = 675,
  [712] = 675,
  [713] = 675,
  [714] = 675,
  [715] = 332,
  [716] = 675,
  [717] = 675,
  [718] = 675,
  [719] = 675,
  [720] = 333,
  [721] = 675,
  [722] = 675,
  [723] = 675,
  [724] = 675,
  [725] = 675,
  [726] = 335,
  [727] = 675,
  [728] = 675,
  [729] = 675,
  [730] = 332,
  [731] = 675,
  [732] = 675,
  [733] = 733,
  [734] = 733,
  [735] = 735,
  [736] = 328,
  [737] = 733,
  [738] = 327,
  [739] = 332,
  [740] = 733,
  [741] = 741,
  [742] = 742,
  [743] = 733,
  [744] = 733,
  [745] = 335,
  [746] = 741,
  [747] = 333,
  [748] = 748,
  [749] = 733,
  [750] = 333,
  [751] = 328,
  [752] = 733,
  [753] = 733,
  [754] = 327,
  [755] = 733,
  [756] = 333,
  [757] = 733,
  [758] = 335,
  [759] = 741,
  [760] = 741,
  [761] = 741,
  [762] = 733,
  [763] = 733,
  [764] = 733,
  [765] = 733,
  [766] = 328,
  [767] = 332,
  [768] = 733,
  [769] = 733,
  [770] = 733,
  [771] = 733,
  [772] = 733,
  [773] = 327,
  [774] = 741,
  [775] = 326,
  [776] = 776,
  [777] = 332,
  [778] = 733,
  [779] = 328,
  [780] = 332,
  [781] = 733,
  [782] = 335,
  [783] = 332,
  [784] = 733,
  [785] = 333,
  [786] = 733,
  [787] = 733,
  [788] = 733,
  [789] = 733,
  [790] = 328,
  [791] = 326,
  [792] = 733,
  [793] = 733,
  [794] = 733,
  [795] = 733,
  [796] = 332,
  [797] = 797,
  [798] = 741,
  [799] = 733,
  [800] = 741,
  [801] = 801,
  [802] = 733,
  [803] = 733,
  [804] = 733,
  [805] = 733,
  [806] = 733,
  [807] = 335,
  [808] = 808,
  [809] = 326,
  [810] = 733,
  [811] = 333,
  [812] = 328,
  [813] = 733,
  [814] = 333,
  [815] = 733,
  [816] = 326,
  [817] = 733,
  [818] = 335,
  [819] = 332,
  [820] = 733,
  [821] = 326,
  [822] = 327,
  [823] = 335,
  [824] = 733,
  [825] = 733,
  [826] = 733,
  [827] = 733,
  [828] = 741,
  [829] = 733,
  [830] = 326,
  [831] = 733,
  [832] = 741,
  [833] = 333,
  [834] = 834,
  [835] = 326,
  [836] = 332,
  [837] = 837,
  [838] = 328,
  [839] = 335,
  [840] = 332,
  [841] = 841,
  [842] = 332,
  [843] = 328,
  [844] = 332,
  [845] = 841,
  [846] = 841,
  [847] = 841,
  [848] = 326,
  [849] = 333,
  [850] = 841,
  [851] = 328,
  [852] = 333,
  [853] = 853,
  [854] = 327,
  [855] = 841,
  [856] = 856,
  [857] = 857,
  [858] = 858,
  [859] = 859,
  [860] = 841,
  [861] = 841,
  [862] = 862,
  [863] = 327,
  [864] = 326,
  [865] = 335,
  [866] = 841,
  [867] = 841,
  [868] = 868,
  [869] = 335,
  [870] = 870,
  [871] = 326,
  [872] = 872,
  [873] = 872,
  [874] = 332,
  [875] = 872,
  [876] = 872,
  [877] = 332,
  [878] = 872,
  [879] = 879,
  [880] = 879,
  [881] = 327,
  [882] = 328,
  [883] = 333,
  [884] = 335,
  [885] = 885,
  [886] = 886,
  [887] = 328,
  [888] = 332,
  [889] = 879,
  [890] = 879,
  [891] = 326,
  [892] = 872,
  [893] = 879,
  [894] = 879,
  [895] = 879,
  [896] = 872,
  [897] = 332,
  [898] = 879,
  [899] = 872,
  [900] = 879,
  [901] = 872,
  [902] = 879,
  [903] = 872,
  [904] = 879,
  [905] = 879,
  [906] = 872,
  [907] = 879,
  [908] = 872,
  [909] = 879,
  [910] = 327,
  [911] = 333,
  [912] = 879,
  [913] = 872,
  [914] = 335,
  [915] = 326,
  [916] = 879,
  [917] = 872,
  [918] = 872,
  [919] = 879,
  [920] = 920,
  [921] = 335,
  [922] = 872,
  [923] = 879,
  [924] = 872,
  [925] = 333,
  [926] = 879,
  [927] = 328,
  [928] = 332,
  [929] = 332,
  [930] = 930,
  [931] = 931,
  [932] = 932,
  [933] = 326,
  [934] = 934,
  [935] = 935,
  [936] = 936,
  [937] = 937,
  [938] = 327,
  [939] = 885,
  [940] = 335,
  [941] = 335,
  [942] = 333,
  [943] = 797,
  [944] = 801,
  [945] = 326,
  [946] = 797,
  [947] = 801,
  [948] = 328,
  [949] = 333,
  [950] = 328,
  [951] = 951,
  [952] = 952,
  [953] = 953,
  [954] = 951,
  [955] = 955,
  [956] = 956,
  [957] = 957,
  [958] = 332,
  [959] = 959,
  [960] = 960,
  [961] = 951,
  [962] = 955,
  [963] = 955,
  [964] = 955,
  [965] = 955,
  [966] = 955,
  [967] = 957,
  [968] = 968,
  [969] = 332,
  [970] = 957,
  [971] = 955,
  [972] = 959,
  [973] = 968,
  [974] = 974,
  [975] = 975,
  [976] = 955,
  [977] = 977,
  [978] = 974,
  [979] = 977,
  [980] = 959,
  [981] = 956,
  [982] = 955,
  [983] = 326,
  [984] = 984,
  [985] = 960,
  [986] = 955,
  [987] = 955,
  [988] = 988,
  [989] = 984,
  [990] = 955,
  [991] = 984,
  [992] = 977,
  [993] = 975,
  [994] = 994,
  [995] = 955,
  [996] = 960,
  [997] = 997,
  [998] = 955,
  [999] = 956,
  [1000] = 1000,
  [1001] = 984,
  [1002] = 957,
  [1003] = 328,
  [1004] = 959,
  [1005] = 1005,
  [1006] = 333,
  [1007] = 955,
  [1008] = 951,
  [1009] = 955,
  [1010] = 974,
  [1011] = 1011,
  [1012] = 335,
  [1013] = 333,
  [1014] = 328,
  [1015] = 977,
  [1016] = 957,
  [1017] = 955,
  [1018] = 335,
  [1019] = 974,
  [1020] = 974,
  [1021] = 977,
  [1022] = 951,
  [1023] = 959,
  [1024] = 1024,
  [1025] = 968,
  [1026] = 974,
  [1027] = 955,
  [1028] = 955,
  [1029] = 955,
  [1030] = 968,
  [1031] = 1031,
  [1032] = 974,
  [1033] = 1033,
  [1034] = 956,
  [1035] = 977,
  [1036] = 959,
  [1037] = 955,
  [1038] = 956,
  [1039] = 977,
  [1040] = 968,
  [1041] = 955,
  [1042] = 955,
  [1043] = 956,
  [1044] = 959,
  [1045] = 955,
  [1046] = 984,
  [1047] = 955,
  [1048] = 960,
  [1049] = 956,
  [1050] = 955,
  [1051] = 960,
  [1052] = 951,
  [1053] = 984,
  [1054] = 1054,
  [1055] = 955,
  [1056] = 1056,
  [1057] = 1057,
  [1058] = 1058,
  [1059] = 957,
  [1060] = 984,
  [1061] = 955,
  [1062] = 1062,
  [1063] = 955,
  [1064] = 960,
  [1065] = 957,
  [1066] = 955,
  [1067] = 955,
  [1068] = 957,
  [1069] = 955,
  [1070] = 951,
  [1071] = 955,
  [1072] = 955,
  [1073] = 955,
  [1074] = 984,
  [1075] = 951,
  [1076] = 984,
  [1077] = 960,
  [1078] = 955,
  [1079] = 955,
  [1080] = 1080,
  [1081] = 951,
  [1082] = 955,
  [1083] = 968,
  [1084] = 955,
  [1085] = 957,
  [1086] = 960,
  [1087] = 332,
  [1088] = 968,
  [1089] = 1089,
  [1090] = 955,
  [1091] = 968,
  [1092] = 332,
  [1093] = 951,
  [1094] = 328,
  [1095] = 326,
  [1096] = 326,
  [1097] = 974,
  [1098] = 960,
  [1099] = 977,
  [1100] = 956,
  [1101] = 955,
  [1102] = 959,
  [1103] = 956,
  [1104] = 955,
  [1105] = 956,
  [1106] = 959,
  [1107] = 977,
  [1108] = 974,
  [1109] = 960,
  [1110] = 968,
  [1111] = 1111,
  [1112] = 959,
  [1113] = 955,
  [1114] = 1114,
  [1115] = 968,
  [1116] = 984,
  [1117] = 332,
  [1118] = 957,
  [1119] = 1119,
  [1120] = 955,
  [1121] = 977,
  [1122] = 955,
  [1123] = 332,
  [1124] = 955,
  [1125] = 1125,
  [1126] = 1126,
  [1127] = 333,
  [1128] = 974,
  [1129] = 335,
  [1130] = 955,
  [1131] = 955,
  [1132] = 1132,
  [1133] = 335,
  [1134] = 1134,
  [1135] = 1135,
  [1136] = 1132,
  [1137] = 837,
  [1138] = 1138,
  [1139] = 1138,
  [1140] = 1132,
  [1141] = 333,
  [1142] = 1134,
  [1143] = 1143,
  [1144] = 332,
  [1145] = 1134,
  [1146] = 1146,
  [1147] = 1134,
  [1148] = 1138,
  [1149] = 1132,
  [1150] = 1126,
  [1151] = 1125,
  [1152] = 1119,
  [1153] = 1138,
  [1154] = 1138,
  [1155] = 1134,
  [1156] = 1132,
  [1157] = 1138,
  [1158] = 1054,
  [1159] = 1132,
  [1160] = 1134,
  [1161] = 1138,
  [1162] = 1162,
  [1163] = 1132,
  [1164] = 328,
  [1165] = 1134,
  [1166] = 326,
  [1167] = 332,
  [1168] = 1134,
  [1169] = 1132,
  [1170] = 1138,
  [1171] = 1171,
  [1172] = 1138,
  [1173] = 1173,
  [1174] = 1132,
  [1175] = 1138,
  [1176] = 1132,
  [1177] = 1134,
  [1178] = 1134,
  [1179] = 1179,
  [1180] = 1180,
  [1181] = 1181,
  [1182] = 1182,
  [1183] = 1183,
  [1184] = 1184,
  [1185] = 1185,
  [1186] = 333,
  [1187] = 335,
  [1188] = 1188,
  [1189] = 1188,
  [1190] = 1190,
  [1191] = 1188,
  [1192] = 1192,
  [1193] = 1184,
  [1194] = 1194,
  [1195] = 1195,
  [1196] = 1196,
  [1197] = 1197,
  [1198] = 1198,
  [1199] = 1199,
  [1200] = 1200,
  [1201] = 1198,
  [1202] = 1180,
  [1203] = 1184,
  [1204] = 1197,
  [1205] = 1205,
  [1206] = 1182,
  [1207] = 1197,
  [1208] = 1058,
  [1209] = 1057,
  [1210] = 1190,
  [1211] = 1190,
  [1212] = 1197,
  [1213] = 1188,
  [1214] = 1194,
  [1215] = 1215,
  [1216] = 1216,
  [1217] = 1205,
  [1218] = 1215,
  [1219] = 1181,
  [1220] = 1197,
  [1221] = 1182,
  [1222] = 1188,
  [1223] = 1184,
  [1224] = 1181,
  [1225] = 1225,
  [1226] = 1226,
  [1227] = 1188,
  [1228] = 1185,
  [1229] = 1198,
  [1230] = 1197,
  [1231] = 1216,
  [1232] = 1232,
  [1233] = 1233,
  [1234] = 1056,
  [1235] = 1235,
  [1236] = 1236,
  [1237] = 1190,
  [1238] = 1205,
  [1239] = 1239,
  [1240] = 1182,
  [1241] = 1239,
  [1242] = 1216,
  [1243] = 1194,
  [1244] = 1185,
  [1245] = 1245,
  [1246] = 332,
  [1247] = 1205,
  [1248] = 1239,
  [1249] = 1239,
  [1250] = 1216,
  [1251] = 1215,
  [1252] = 1182,
  [1253] = 994,
  [1254] = 1215,
  [1255] = 997,
  [1256] = 1181,
  [1257] = 1198,
  [1258] = 1198,
  [1259] = 1259,
  [1260] = 1197,
  [1261] = 1194,
  [1262] = 1181,
  [1263] = 1181,
  [1264] = 326,
  [1265] = 952,
  [1266] = 1236,
  [1267] = 837,
  [1268] = 1205,
  [1269] = 1180,
  [1270] = 1197,
  [1271] = 1180,
  [1272] = 1205,
  [1273] = 1181,
  [1274] = 1194,
  [1275] = 1185,
  [1276] = 1239,
  [1277] = 1181,
  [1278] = 1216,
  [1279] = 1198,
  [1280] = 1188,
  [1281] = 1197,
  [1282] = 1197,
  [1283] = 1182,
  [1284] = 1197,
  [1285] = 1194,
  [1286] = 1180,
  [1287] = 1184,
  [1288] = 1205,
  [1289] = 1182,
  [1290] = 1198,
  [1291] = 1190,
  [1292] = 1194,
  [1293] = 328,
  [1294] = 1184,
  [1295] = 1190,
  [1296] = 332,
  [1297] = 1297,
  [1298] = 1194,
  [1299] = 1299,
  [1300] = 1239,
  [1301] = 1216,
  [1302] = 1197,
  [1303] = 1188,
  [1304] = 953,
  [1305] = 1197,
  [1306] = 1188,
  [1307] = 1184,
  [1308] = 1181,
  [1309] = 1197,
  [1310] = 1184,
  [1311] = 1190,
  [1312] = 1216,
  [1313] = 1215,
  [1314] = 1239,
  [1315] = 1216,
  [1316] = 1216,
  [1317] = 1239,
  [1318] = 1197,
  [1319] = 1198,
  [1320] = 1194,
  [1321] = 1188,
  [1322] = 1215,
  [1323] = 1180,
  [1324] = 1215,
  [1325] = 1239,
  [1326] = 1182,
  [1327] = 1181,
  [1328] = 1197,
  [1329] = 1180,
  [1330] = 1190,
  [1331] = 1198,
  [1332] = 1205,
  [1333] = 1333,
  [1334] = 1194,
  [1335] = 1190,
  [1336] = 1180,
  [1337] = 1205,
  [1338] = 1182,
  [1339] = 1339,
  [1340] = 1215,
  [1341] = 1197,
  [1342] = 1184,
  [1343] = 1197,
  [1344] = 1197,
  [1345] = 1190,
  [1346] = 1089,
  [1347] = 1180,
  [1348] = 1180,
  [1349] = 1245,
  [1350] = 1226,
  [1351] = 1184,
  [1352] = 1215,
  [1353] = 1205,
  [1354] = 1182,
  [1355] = 1355,
  [1356] = 1215,
  [1357] = 1198,
  [1358] = 1239,
  [1359] = 1216,
  [1360] = 326,
  [1361] = 1361,
  [1362] = 1058,
  [1363] = 1057,
  [1364] = 1056,
  [1365] = 328,
  [1366] = 1366,
  [1367] = 1367,
  [1368] = 837,
  [1369] = 1369,
  [1370] = 1370,
  [1371] = 837,
  [1372] = 1372,
  [1373] = 1373,
  [1374] = 1374,
  [1375] = 332,
  [1376] = 994,
  [1377] = 997,
  [1378] = 1089,
  [1379] = 1379,
  [1380] = 1380,
  [1381] = 1366,
  [1382] = 333,
  [1383] = 1383,
  [1384] = 335,
  [1385] = 952,
  [1386] = 1366,
  [1387] = 1387,
  [1388] = 1366,
  [1389] = 1389,
  [1390] = 1390,
  [1391] = 1374,
  [1392] = 332,
  [1393] = 953,
  [1394] = 1394,
  [1395] = 1395,
  [1396] = 1394,
  [1397] = 1397,
  [1398] = 1398,
  [1399] = 1399,
  [1400] = 1400,
  [1401] = 1401,
  [1402] = 1402,
  [1403] = 1403,
  [1404] = 1404,
  [1405] = 1405,
  [1406] = 1406,
  [1407] = 1407,
  [1408] = 1400,
  [1409] = 1401,
  [1410] = 1410,
  [1411] = 1411,
  [1412] = 1412,
  [1413] = 1413,
  [1414] = 1414,
  [1415] = 1405,
  [1416] = 1416,
  [1417] = 1413,
  [1418] = 1412,
  [1419] = 1413,
  [1420] = 1402,
  [1421] = 1421,
  [1422] = 1422,
  [1423] = 1414,
  [1424] = 1422,
  [1425] = 1413,
  [1426] = 326,
  [1427] = 332,
  [1428] = 1428,
  [1429] = 1416,
  [1430] = 1422,
  [1431] = 1416,
  [1432] = 1412,
  [1433] = 1411,
  [1434] = 1407,
  [1435] = 1422,
  [1436] = 1414,
  [1437] = 1437,
  [1438] = 1438,
  [1439] = 1413,
  [1440] = 1402,
  [1441] = 1441,
  [1442] = 1401,
  [1443] = 1422,
  [1444] = 1444,
  [1445] = 1445,
  [1446] = 1446,
  [1447] = 1422,
  [1448] = 1438,
  [1449] = 1413,
  [1450] = 1400,
  [1451] = 1441,
  [1452] = 1410,
  [1453] = 1406,
  [1454] = 1413,
  [1455] = 1399,
  [1456] = 1422,
  [1457] = 1457,
  [1458] = 1437,
  [1459] = 1438,
  [1460] = 1441,
  [1461] = 1398,
  [1462] = 1462,
  [1463] = 1463,
  [1464] = 1397,
  [1465] = 1403,
  [1466] = 1394,
  [1467] = 1403,
  [1468] = 1397,
  [1469] = 1398,
  [1470] = 1394,
  [1471] = 1421,
  [1472] = 1399,
  [1473] = 1400,
  [1474] = 1401,
  [1475] = 1402,
  [1476] = 1422,
  [1477] = 1410,
  [1478] = 1405,
  [1479] = 1479,
  [1480] = 1480,
  [1481] = 1422,
  [1482] = 1405,
  [1483] = 1402,
  [1484] = 1414,
  [1485] = 1394,
  [1486] = 1411,
  [1487] = 1404,
  [1488] = 1406,
  [1489] = 1403,
  [1490] = 1407,
  [1491] = 1407,
  [1492] = 1421,
  [1493] = 1397,
  [1494] = 1402,
  [1495] = 1401,
  [1496] = 1404,
  [1497] = 1402,
  [1498] = 1400,
  [1499] = 1416,
  [1500] = 1412,
  [1501] = 1399,
  [1502] = 1398,
  [1503] = 1401,
  [1504] = 1400,
  [1505] = 1399,
  [1506] = 1398,
  [1507] = 328,
  [1508] = 1397,
  [1509] = 1398,
  [1510] = 1397,
  [1511] = 333,
  [1512] = 1394,
  [1513] = 1411,
  [1514] = 1394,
  [1515] = 1399,
  [1516] = 1414,
  [1517] = 1437,
  [1518] = 1438,
  [1519] = 1400,
  [1520] = 1441,
  [1521] = 1457,
  [1522] = 1414,
  [1523] = 1523,
  [1524] = 1437,
  [1525] = 1416,
  [1526] = 1401,
  [1527] = 1422,
  [1528] = 1402,
  [1529] = 1529,
  [1530] = 1530,
  [1531] = 1411,
  [1532] = 1407,
  [1533] = 1412,
  [1534] = 1416,
  [1535] = 1405,
  [1536] = 1536,
  [1537] = 1404,
  [1538] = 1538,
  [1539] = 1412,
  [1540] = 1540,
  [1541] = 1404,
  [1542] = 1397,
  [1543] = 1416,
  [1544] = 1398,
  [1545] = 1411,
  [1546] = 1407,
  [1547] = 1412,
  [1548] = 1404,
  [1549] = 1404,
  [1550] = 1416,
  [1551] = 1402,
  [1552] = 1401,
  [1553] = 1407,
  [1554] = 1399,
  [1555] = 1400,
  [1556] = 1399,
  [1557] = 1557,
  [1558] = 1413,
  [1559] = 1398,
  [1560] = 1421,
  [1561] = 1397,
  [1562] = 1562,
  [1563] = 1563,
  [1564] = 1437,
  [1565] = 1565,
  [1566] = 1438,
  [1567] = 1407,
  [1568] = 1394,
  [1569] = 1480,
  [1570] = 1411,
  [1571] = 1403,
  [1572] = 1572,
  [1573] = 1404,
  [1574] = 1574,
  [1575] = 1421,
  [1576] = 1394,
  [1577] = 1397,
  [1578] = 1398,
  [1579] = 1399,
  [1580] = 1400,
  [1581] = 1401,
  [1582] = 1402,
  [1583] = 1441,
  [1584] = 1397,
  [1585] = 1401,
  [1586] = 1400,
  [1587] = 1399,
  [1588] = 1398,
  [1589] = 1397,
  [1590] = 1394,
  [1591] = 1591,
  [1592] = 1410,
  [1593] = 1593,
  [1594] = 1594,
  [1595] = 1404,
  [1596] = 1406,
  [1597] = 1597,
  [1598] = 1407,
  [1599] = 1599,
  [1600] = 1600,
  [1601] = 1421,
  [1602] = 1403,
  [1603] = 1406,
  [1604] = 1410,
  [1605] = 1407,
  [1606] = 1606,
  [1607] = 1607,
  [1608] = 1480,
  [1609] = 1412,
  [1610] = 1411,
  [1611] = 1410,
  [1612] = 1457,
  [1613] = 1406,
  [1614] = 1414,
  [1615] = 1403,
  [1616] = 1421,
  [1617] = 1617,
  [1618] = 1410,
  [1619] = 1428,
  [1620] = 1410,
  [1621] = 1413,
  [1622] = 1405,
  [1623] = 1398,
  [1624] = 1405,
  [1625] = 1394,
  [1626] = 1399,
  [1627] = 1397,
  [1628] = 1398,
  [1629] = 335,
  [1630] = 1399,
  [1631] = 1407,
  [1632] = 1404,
  [1633] = 1400,
  [1634] = 1402,
  [1635] = 1401,
  [1636] = 1400,
  [1637] = 1399,
  [1638] = 1398,
  [1639] = 1410,
  [1640] = 1640,
  [1641] = 1402,
  [1642] = 1394,
  [1643] = 1397,
  [1644] = 1405,
  [1645] = 1406,
  [1646] = 1397,
  [1647] = 1394,
  [1648] = 1398,
  [1649] = 1406,
  [1650] = 1399,
  [1651] = 1401,
  [1652] = 1400,
  [1653] = 1653,
  [1654] = 1401,
  [1655] = 1655,
  [1656] = 1402,
  [1657] = 1403,
  [1658] = 1407,
  [1659] = 1421,
  [1660] = 1402,
  [1661] = 1655,
  [1662] = 1662,
  [1663] = 1663,
  [1664] = 1407,
  [1665] = 1404,
  [1666] = 1407,
  [1667] = 1402,
  [1668] = 1401,
  [1669] = 1400,
  [1670] = 1399,
  [1671] = 1421,
  [1672] = 1403,
  [1673] = 1195,
  [1674] = 1398,
  [1675] = 1397,
  [1676] = 1394,
  [1677] = 1397,
  [1678] = 1406,
  [1679] = 1402,
  [1680] = 1394,
  [1681] = 1397,
  [1682] = 1398,
  [1683] = 1394,
  [1684] = 1399,
  [1685] = 1394,
  [1686] = 1400,
  [1687] = 1401,
  [1688] = 1402,
  [1689] = 1416,
  [1690] = 1412,
  [1691] = 1411,
  [1692] = 1410,
  [1693] = 1407,
  [1694] = 1404,
  [1695] = 1402,
  [1696] = 1401,
  [1697] = 1400,
  [1698] = 1404,
  [1699] = 1399,
  [1700] = 1398,
  [1701] = 1411,
  [1702] = 1397,
  [1703] = 1398,
  [1704] = 1394,
  [1705] = 1400,
  [1706] = 1412,
  [1707] = 1416,
  [1708] = 1407,
  [1709] = 1404,
  [1710] = 1399,
  [1711] = 1402,
  [1712] = 1400,
  [1713] = 1401,
  [1714] = 1400,
  [1715] = 1399,
  [1716] = 1414,
  [1717] = 1398,
  [1718] = 1397,
  [1719] = 1401,
  [1720] = 1402,
  [1721] = 1407,
  [1722] = 1722,
  [1723] = 1401,
  [1724] = 1407,
  [1725] = 1404,
  [1726] = 1406,
  [1727] = 1404,
  [1728] = 1728,
  [1729] = 1407,
  [1730] = 1414,
  [1731] = 1402,
  [1732] = 1401,
  [1733] = 1400,
  [1734] = 1399,
  [1735] = 1398,
  [1736] = 1397,
  [1737] = 1394,
  [1738] = 1401,
  [1739] = 1457,
  [1740] = 1394,
  [1741] = 1400,
  [1742] = 1407,
  [1743] = 1743,
  [1744] = 1744,
  [1745] = 1402,
  [1746] = 1413,
  [1747] = 1414,
  [1748] = 1404,
  [1749] = 1407,
  [1750] = 1536,
  [1751] = 1407,
  [1752] = 1404,
  [1753] = 1402,
  [1754] = 1401,
  [1755] = 1400,
  [1756] = 1399,
  [1757] = 1398,
  [1758] = 1397,
  [1759] = 1397,
  [1760] = 1394,
  [1761] = 1399,
  [1762] = 1405,
  [1763] = 1398,
  [1764] = 1403,
  [1765] = 1394,
  [1766] = 1421,
  [1767] = 1767,
  [1768] = 1767,
  [1769] = 1056,
  [1770] = 1057,
  [1771] = 1058,
  [1772] = 1195,
  [1773] = 1767,
  [1774] = 1767,
  [1775] = 1767,
  [1776] = 1767,
  [1777] = 1767,
  [1778] = 1767,
  [1779] = 952,
  [1780] = 1780,
  [1781] = 1781,
  [1782] = 1782,
  [1783] = 1767,
  [1784] = 1767,
  [1785] = 1767,
  [1786] = 1767,
  [1787] = 953,
  [1788] = 1767,
  [1789] = 1767,
  [1790] = 997,
  [1791] = 994,
  [1792] = 1767,
  [1793] = 1767,
  [1794] = 1767,
  [1795] = 1089,
  [1796] = 1796,
  [1797] = 997,
  [1798] = 1058,
  [1799] = 1799,
  [1800] = 1800,
  [1801] = 1801,
  [1802] = 1802,
  [1803] = 994,
  [1804] = 1056,
  [1805] = 953,
  [1806] = 1806,
  [1807] = 1089,
  [1808] = 1195,
  [1809] = 1057,
  [1810] = 952,
  [1811] = 953,
  [1812] = 1812,
  [1813] = 1813,
  [1814] = 1056,
  [1815] = 1057,
  [1816] = 1058,
  [1817] = 952,
  [1818] = 797,
  [1819] = 997,
  [1820] = 994,
  [1821] = 1813,
  [1822] = 1089,
  [1823] = 1812,
  [1824] = 1824,
  [1825] = 1812,
  [1826] = 1812,
  [1827] = 1812,
  [1828] = 801,
  [1829] = 1829,
  [1830] = 1830,
  [1831] = 1831,
  [1832] = 1832,
  [1833] = 1830,
  [1834] = 1834,
  [1835] = 1830,
  [1836] = 1836,
  [1837] = 1837,
  [1838] = 1838,
  [1839] = 1839,
  [1840] = 1839,
  [1841] = 1841,
  [1842] = 1842,
  [1843] = 1843,
  [1844] = 1844,
  [1845] = 1843,
  [1846] = 1846,
  [1847] = 1847,
  [1848] = 1841,
  [1849] = 1849,
  [1850] = 1846,
  [1851] = 1841,
  [1852] = 1839,
  [1853] = 1843,
  [1854] = 1846,
  [1855] = 1855,
  [1856] = 1856,
  [1857] = 1857,
  [1858] = 1858,
  [1859] = 1834,
  [1860] = 1860,
  [1861] = 1861,
  [1862] = 1862,
  [1863] = 1863,
  [1864] = 1863,
  [1865] = 1862,
  [1866] = 1863,
  [1867] = 1862,
  [1868] = 1868,
  [1869] = 1861,
  [1870] = 1868,
  [1871] = 1861,
  [1872] = 1868,
  [1873] = 1873,
  [1874] = 1874,
  [1875] = 1873,
  [1876] = 1858,
  [1877] = 1874,
  [1878] = 1873,
  [1879] = 1873,
  [1880] = 1874,
  [1881] = 1873,
  [1882] = 1882,
  [1883] = 1860,
  [1884] = 1873,
  [1885] = 1873,
  [1886] = 1856,
  [1887] = 1873,
  [1888] = 1873,
  [1889] = 1857,
  [1890] = 1873,
  [1891] = 1891,
  [1892] = 1892,
  [1893] = 1892,
  [1894] = 1894,
  [1895] = 1891,
  [1896] = 1896,
  [1897] = 1897,
  [1898] = 1894,
  [1899] = 1892,
  [1900] = 1891,
  [1901] = 1897,
  [1902] = 1897,
  [1903] = 1897,
  [1904] = 1904,
  [1905] = 1892,
  [1906] = 1904,
  [1907] = 1896,
  [1908] = 1896,
  [1909] = 1891,
  [1910] = 1894,
  [1911] = 1891,
  [1912] = 1892,
  [1913] = 1894,
  [1914] = 1896,
  [1915] = 1894,
  [1916] = 1897,
  [1917] = 1904,
  [1918] = 1897,
  [1919] = 1896,
  [1920] = 1894,
  [1921] = 1891,
  [1922] = 1894,
  [1923] = 1904,
  [1924] = 1897,
  [1925] = 1897,
  [1926] = 1894,
  [1927] = 1892,
  [1928] = 1891,
  [1929] = 1897,
  [1930] = 1894,
  [1931] = 1896,
  [1932] = 1891,
  [1933] = 1904,
  [1934] = 1891,
  [1935] = 1904,
  [1936] = 1892,
  [1937] = 1891,
  [1938] = 1894,
  [1939] = 1896,
  [1940] = 1896,
  [1941] = 1904,
  [1942] = 1904,
  [1943] = 1896,
  [1944] = 1897,
  [1945] = 1896,
  [1946] = 1892,
  [1947] = 1892,
  [1948] = 1904,
  [1949] = 1892,
  [1950] = 1904,
  [1951] = 1951,
  [1952] = 1952,
  [1953] = 1951,
  [1954] = 1951,
  [1955] = 1955,
  [1956] = 1956,
  [1957] = 1956,
  [1958] = 1958,
  [1959] = 1958,
  [1960] = 1956,
  [1961] = 1961,
  [1962] = 1962,
  [1963] = 1963,
  [1964] = 1963,
  [1965] = 1961,
  [1966] = 1961,
  [1967] = 1963,
  [1968] = 1956,
  [1969] = 1963,
  [1970] = 1956,
  [1971] = 1956,
  [1972] = 1963,
  [1973] = 1955,
  [1974] = 1961,
  [1975] = 1961,
  [1976] = 1955,
  [1977] = 1956,
  [1978] = 1962,
  [1979] = 1958,
  [1980] = 1958,
  [1981] = 1981,
  [1982] = 1955,
  [1983] = 1962,
  [1984] = 1961,
  [1985] = 1961,
  [1986] = 1962,
  [1987] = 1958,
  [1988] = 1962,
  [1989] = 1955,
  [1990] = 1961,
  [1991] = 1955,
  [1992] = 1992,
  [1993] = 1993,
  [1994] = 1994,
  [1995] = 1963,
  [1996] = 1962,
  [1997] = 1962,
  [1998] = 1958,
  [1999] = 1955,
  [2000] = 1955,
  [2001] = 1958,
  [2002] = 2002,
  [2003] = 1956,
  [2004] = 1958,
  [2005] = 1956,
  [2006] = 1961,
  [2007] = 1962,
  [2008] = 1963,
  [2009] = 1961,
  [2010] = 1963,
  [2011] = 1958,
  [2012] = 1962,
  [2013] = 1958,
  [2014] = 1955,
  [2015] = 1956,
  [2016] = 1963,
  [2017] = 1962,
  [2018] = 1955,
  [2019] = 1963,
  [2020] = 2020,
  [2021] = 2021,
  [2022] = 2021,
  [2023] = 2021,
  [2024] = 2024,
  [2025] = 2021,
  [2026] = 2026,
  [2027] = 2027,
  [2028] = 2027,
  [2029] = 2027,
  [2030] = 2021,
  [2031] = 2027,
  [2032] = 2027,
  [2033] = 2027,
  [2034] = 2021,
  [2035] = 2035,
  [2036] = 2036,
  [2037] = 2021,
  [2038] = 2038,
  [2039] = 2027,
  [2040] = 2040,
  [2041] = 2027,
  [2042] = 2042,
  [2043] = 2021,
  [2044] = 2044,
  [2045] = 2021,
  [2046] = 2021,
  [2047] = 2027,
  [2048] = 2027,
  [2049] = 2049,
  [2050] = 2049,
  [2051] = 2051,
  [2052] = 2051,
  [2053] = 2053,
  [2054] = 2049,
  [2055] = 2055,
  [2056] = 2053,
  [2057] = 2055,
  [2058] = 2058,
  [2059] = 2055,
  [2060] = 2053,
  [2061] = 2049,
  [2062] = 2049,
  [2063] = 2053,
  [2064] = 2053,
  [2065] = 2049,
  [2066] = 2058,
  [2067] = 2049,
  [2068] = 2055,
  [2069] = 2053,
  [2070] = 2055,
  [2071] = 2055,
  [2072] = 2053,
  [2073] = 2049,
  [2074] = 2053,
  [2075] = 2051,
  [2076] = 2058,
  [2077] = 1992,
  [2078] = 2055,
  [2079] = 2051,
  [2080] = 2058,
  [2081] = 2049,
  [2082] = 2051,
  [2083] = 2055,
  [2084] = 2051,
  [2085] = 2002,
  [2086] = 2055,
  [2087] = 2053,
  [2088] = 2058,
  [2089] = 2089,
  [2090] = 2051,
  [2091] = 2091,
  [2092] = 2058,
  [2093] = 2058,
  [2094] = 2051,
  [2095] = 2058,
  [2096] = 2049,
  [2097] = 2053,
  [2098] = 2051,
  [2099] = 2055,
  [2100] = 2058,
  [2101] = 2058,
  [2102] = 2051,
  [2103] = 2103,
  [2104] = 2104,
  [2105] = 2105,
  [2106] = 2106,
  [2107] = 2106,
  [2108] = 2108,
  [2109] = 2106,
  [2110] = 2106,
  [2111] = 2111,
  [2112] = 2106,
  [2113] = 2106,
  [2114] = 2106,
  [2115] = 2115,
  [2116] = 2106,
  [2117] = 2106,
  [2118] = 2118,
  [2119] = 2119,
  [2120] = 2106,
  [2121] = 2121,
  [2122] = 2122,
  [2123] = 2123,
  [2124] = 2124,
  [2125] = 2125,
  [2126] = 2124,
  [2127] = 2124,
  [2128] = 2128,
  [2129] = 2121,
  [2130] = 2130,
  [2131] = 2125,
  [2132] = 2123,
  [2133] = 2121,
  [2134] = 2124,
  [2135] = 2125,
  [2136] = 2124,
  [2137] = 2137,
  [2138] = 2138,
  [2139] = 2124,
  [2140] = 2123,
  [2141] = 2123,
  [2142] = 2123,
  [2143] = 2143,
  [2144] = 2125,
  [2145] = 2145,
  [2146] = 2146,
  [2147] = 2147,
  [2148] = 2121,
  [2149] = 2125,
  [2150] = 2125,
  [2151] = 2123,
  [2152] = 2121,
  [2153] = 2123,
  [2154] = 2154,
  [2155] = 2155,
  [2156] = 2125,
  [2157] = 2121,
  [2158] = 2121,
  [2159] = 2124,
  [2160] = 2124,
  [2161] = 2123,
  [2162] = 2121,
  [2163] = 2163,
  [2164] = 2125,
  [2165] = 2123,
  [2166] = 2121,
  [2167] = 2125,
  [2168] = 2124,
  [2169] = 2124,
  [2170] = 2123,
  [2171] = 2125,
  [2172] = 2121,
  [2173] = 2173,
  [2174] = 2174,
  [2175] = 2174,
  [2176] = 2173,
  [2177] = 2173,
  [2178] = 2173,
  [2179] = 2173,
  [2180] = 2173,
  [2181] = 1981,
  [2182] = 2182,
  [2183] = 2173,
  [2184] = 2173,
  [2185] = 1993,
  [2186] = 2173,
  [2187] = 2174,
  [2188] = 2174,
  [2189] = 2174,
  [2190] = 2173,
  [2191] = 2191,
  [2192] = 2192,
  [2193] = 2192,
  [2194] = 2145,
  [2195] = 2192,
  [2196] = 2147,
  [2197] = 1993,
  [2198] = 2192,
  [2199] = 2192,
  [2200] = 2192,
  [2201] = 2143,
  [2202] = 2192,
  [2203] = 1981,
  [2204] = 2204,
  [2205] = 2192,
  [2206] = 2163,
  [2207] = 2192,
  [2208] = 2192,
  [2209] = 2209,
  [2210] = 2210,
  [2211] = 1993,
  [2212] = 2209,
  [2213] = 2213,
  [2214] = 1981,
  [2215] = 2209,
  [2216] = 2209,
  [2217] = 2209,
  [2218] = 2209,
  [2219] = 1993,
  [2220] = 2209,
  [2221] = 1981,
  [2222] = 2209,
  [2223] = 2209,
  [2224] = 2209,
  [2225] = 2225,
  [2226] = 2226,
  [2227] = 2227,
  [2228] = 2228,
  [2229] = 2229,
  [2230] = 2230,
  [2231] = 2231,
  [2232] = 2232,
  [2233] = 2233,
  [2234] = 2234,
  [2235] = 2235,
  [2236] = 2236,
  [2237] = 2237,
  [2238] = 2238,
  [2239] = 2238,
  [2240] = 2238,
  [2241] = 2241,
  [2242] = 2242,
  [2243] = 2236,
  [2244] = 2244,
  [2245] = 2245,
  [2246] = 2244,
  [2247] = 2238,
  [2248] = 2237,
  [2249] = 2241,
  [2250] = 2238,
  [2251] = 2251,
  [2252] = 2252,
  [2253] = 2253,
  [2254] = 2254,
  [2255] = 2255,
  [2256] = 2252,
  [2257] = 2252,
  [2258] = 2253,
  [2259] = 2254,
  [2260] = 2260,
  [2261] = 2261,
  [2262] = 2260,
  [2263] = 2260,
  [2264] = 2264,
  [2265] = 2253,
  [2266] = 2252,
  [2267] = 2254,
  [2268] = 2255,
  [2269] = 2269,
  [2270] = 2254,
  [2271] = 2271,
  [2272] = 2253,
  [2273] = 2251,
  [2274] = 2264,
  [2275] = 2251,
  [2276] = 2264,
  [2277] = 2260,
  [2278] = 2278,
  [2279] = 2279,
  [2280] = 2251,
  [2281] = 2252,
  [2282] = 2253,
  [2283] = 2253,
  [2284] = 2255,
  [2285] = 2269,
  [2286] = 2254,
  [2287] = 2271,
  [2288] = 2252,
  [2289] = 2264,
  [2290] = 2255,
  [2291] = 2254,
  [2292] = 2278,
  [2293] = 2264,
  [2294] = 2251,
  [2295] = 2260,
  [2296] = 2251,
  [2297] = 2260,
  [2298] = 2261,
  [2299] = 2264,
  [2300] = 2255,
  [2301] = 2255,
  [2302] = 2302,
  [2303] = 2303,
  [2304] = 2304,
  [2305] = 2305,
  [2306] = 2306,
  [2307] = 2307,
  [2308] = 2308,
  [2309] = 2309,
  [2310] = 2310,
  [2311] = 2311,
  [2312] = 2312,
  [2313] = 2313,
  [2314] = 2314,
  [2315] = 2315,
  [2316] = 2316,
  [2317] = 2317,
  [2318] = 2318,
  [2319] = 2319,
  [2320] = 2320,
  [2321] = 2321,
  [2322] = 2322,
  [2323] = 2323,
  [2324] = 2324,
  [2325] = 2325,
  [2326] = 2326,
  [2327] = 2327,
  [2328] = 2328,
  [2329] = 2329,
  [2330] = 2330,
  [2331] = 2331,
  [2332] = 2332,
  [2333] = 2333,
  [2334] = 2334,
  [2335] = 2335,
  [2336] = 2336,
  [2337] = 2337,
  [2338] = 2338,
  [2339] = 2339,
  [2340] = 2340,
  [2341] = 2341,
  [2342] = 2342,
  [2343] = 2343,
  [2344] = 2344,
  [2345] = 2345,
  [2346] = 2346,
  [2347] = 2347,
  [2348] = 2348,
  [2349] = 2349,
  [2350] = 2350,
  [2351] = 2351,
  [2352] = 2352,
  [2353] = 2353,
  [2354] = 2354,
  [2355] = 2355,
  [2356] = 2356,
  [2357] = 2357,
  [2358] = 2358,
  [2359] = 2359,
  [2360] = 2241,
  [2361] = 2242,
  [2362] = 2231,
  [2363] = 2237,
  [2364] = 2227,
  [2365] = 2236,
  [2366] = 2237,
  [2367] = 2233,
  [2368] = 2225,
  [2369] = 2235,
  [2370] = 2228,
  [2371] = 2230,
  [2372] = 2244,
  [2373] = 2229,
  [2374] = 2236,
  [2375] = 2244,
  [2376] = 2232,
  [2377] = 2241,
  [2378] = 2236,
  [2379] = 2237,
  [2380] = 2242,
  [2381] = 2381,
  [2382] = 2236,
  [2383] = 2383,
  [2384] = 2241,
  [2385] = 2241,
  [2386] = 2386,
  [2387] = 2387,
  [2388] = 2244,
  [2389] = 2237,
  [2390] = 2390,
  [2391] = 2391,
  [2392] = 2244,
  [2393] = 2393,
  [2394] = 2394,
  [2395] = 2395,
  [2396] = 2393,
  [2397] = 2397,
  [2398] = 2393,
  [2399] = 2399,
  [2400] = 2394,
  [2401] = 2401,
  [2402] = 2402,
  [2403] = 2397,
  [2404] = 2397,
  [2405] = 2402,
  [2406] = 2401,
  [2407] = 2393,
  [2408] = 2401,
  [2409] = 2402,
  [2410] = 2395,
  [2411] = 2411,
  [2412] = 2397,
  [2413] = 2393,
  [2414] = 2393,
  [2415] = 2415,
  [2416] = 2416,
  [2417] = 2393,
  [2418] = 2228,
  [2419] = 2401,
  [2420] = 2402,
  [2421] = 2397,
  [2422] = 2393,
  [2423] = 2423,
  [2424] = 2401,
  [2425] = 2402,
  [2426] = 2397,
  [2427] = 2397,
  [2428] = 2401,
  [2429] = 2402,
  [2430] = 2393,
  [2431] = 2401,
  [2432] = 2395,
  [2433] = 2393,
  [2434] = 2401,
  [2435] = 2402,
  [2436] = 2397,
  [2437] = 2393,
  [2438] = 2397,
  [2439] = 2402,
  [2440] = 2401,
  [2441] = 2402,
  [2442] = 2397,
  [2443] = 2401,
  [2444] = 2402,
  [2445] = 2397,
  [2446] = 2402,
  [2447] = 2401,
  [2448] = 2395,
  [2449] = 2423,
  [2450] = 2395,
  [2451] = 2423,
  [2452] = 2423,
  [2453] = 2423,
  [2454] = 2423,
  [2455] = 2455,
  [2456] = 2393,
  [2457] = 2457,
  [2458] = 2397,
  [2459] = 2459,
  [2460] = 2460,
  [2461] = 2461,
  [2462] = 2462,
  [2463] = 2393,
  [2464] = 2423,
  [2465] = 2402,
  [2466] = 2466,
  [2467] = 2393,
  [2468] = 2235,
  [2469] = 2397,
  [2470] = 2416,
  [2471] = 2397,
  [2472] = 2402,
  [2473] = 2401,
  [2474] = 2395,
  [2475] = 2393,
  [2476] = 2393,
  [2477] = 2395,
  [2478] = 2401,
  [2479] = 2460,
  [2480] = 2423,
  [2481] = 2481,
  [2482] = 2401,
  [2483] = 2423,
  [2484] = 2397,
  [2485] = 2402,
  [2486] = 2486,
  [2487] = 2402,
  [2488] = 2461,
  [2489] = 2397,
  [2490] = 2393,
  [2491] = 2462,
  [2492] = 2401,
  [2493] = 2402,
  [2494] = 2402,
  [2495] = 2423,
  [2496] = 2397,
  [2497] = 2393,
  [2498] = 2393,
  [2499] = 2402,
  [2500] = 2401,
  [2501] = 2402,
  [2502] = 2401,
  [2503] = 2397,
  [2504] = 2397,
  [2505] = 2397,
  [2506] = 2402,
  [2507] = 2393,
  [2508] = 2401,
  [2509] = 2393,
  [2510] = 2402,
  [2511] = 2397,
  [2512] = 2393,
  [2513] = 2401,
  [2514] = 2402,
  [2515] = 2401,
  [2516] = 2516,
  [2517] = 2397,
  [2518] = 2393,
  [2519] = 2393,
  [2520] = 2401,
  [2521] = 2402,
  [2522] = 2397,
  [2523] = 2523,
  [2524] = 2402,
  [2525] = 2401,
  [2526] = 2393,
  [2527] = 2397,
  [2528] = 2401,
  [2529] = 2402,
  [2530] = 2397,
  [2531] = 2402,
  [2532] = 2401,
  [2533] = 2397,
  [2534] = 2393,
  [2535] = 2401,
  [2536] = 2402,
  [2537] = 2401,
  [2538] = 2393,
  [2539] = 2539,
  [2540] = 2397,
  [2541] = 2402,
  [2542] = 2401,
  [2543] = 2393,
  [2544] = 2393,
  [2545] = 2423,
  [2546] = 2546,
  [2547] = 2393,
  [2548] = 2423,
  [2549] = 2397,
  [2550] = 2393,
  [2551] = 2393,
  [2552] = 2401,
  [2553] = 2242,
  [2554] = 2393,
  [2555] = 2397,
  [2556] = 2397,
  [2557] = 2402,
  [2558] = 2411,
  [2559] = 2402,
  [2560] = 2401,
  [2561] = 2393,
  [2562] = 2423,
  [2563] = 2397,
  [2564] = 2402,
  [2565] = 2416,
  [2566] = 2415,
  [2567] = 2401,
  [2568] = 2397,
  [2569] = 2393,
  [2570] = 2393,
  [2571] = 2401,
  [2572] = 2394,
  [2573] = 2402,
  [2574] = 2402,
  [2575] = 2423,
  [2576] = 2393,
  [2577] = 2393,
  [2578] = 2394,
  [2579] = 2397,
  [2580] = 2423,
  [2581] = 2394,
  [2582] = 2401,
  [2583] = 2399,
  [2584] = 2584,
  [2585] = 2585,
  [2586] = 2393,
  [2587] = 2393,
  [2588] = 2588,
  [2589] = 2589,
  [2590] = 2395,
  [2591] = 2591,
  [2592] = 2592,
  [2593] = 2397,
  [2594] = 2402,
  [2595] = 2401,
  [2596] = 2393,
  [2597] = 2393,
  [2598] = 2397,
  [2599] = 2402,
  [2600] = 2401,
  [2601] = 2393,
  [2602] = 2393,
  [2603] = 2401,
  [2604] = 2423,
  [2605] = 2402,
  [2606] = 2393,
  [2607] = 2393,
  [2608] = 2393,
  [2609] = 2397,
  [2610] = 2393,
  [2611] = 2611,
  [2612] = 2397,
  [2613] = 2402,
  [2614] = 2401,
  [2615] = 2423,
  [2616] = 2584,
  [2617] = 2393,
  [2618] = 2393,
  [2619] = 2401,
  [2620] = 2402,
  [2621] = 2397,
  [2622] = 2393,
  [2623] = 2393,
  [2624] = 2241,
  [2625] = 2393,
  [2626] = 2523,
  [2627] = 2397,
  [2628] = 2402,
  [2629] = 2401,
  [2630] = 2393,
  [2631] = 2393,
  [2632] = 2632,
  [2633] = 2232,
  [2634] = 2397,
  [2635] = 2402,
  [2636] = 2401,
  [2637] = 2393,
  [2638] = 2393,
  [2639] = 2227,
  [2640] = 2393,
  [2641] = 2397,
  [2642] = 2393,
  [2643] = 2402,
  [2644] = 2395,
  [2645] = 2401,
  [2646] = 2401,
  [2647] = 2401,
  [2648] = 2393,
  [2649] = 2397,
  [2650] = 2402,
  [2651] = 2401,
  [2652] = 2229,
  [2653] = 2402,
  [2654] = 2481,
  [2655] = 2393,
  [2656] = 2393,
  [2657] = 2397,
  [2658] = 2402,
  [2659] = 2401,
  [2660] = 2393,
  [2661] = 2397,
  [2662] = 2402,
  [2663] = 2395,
  [2664] = 2397,
  [2665] = 2415,
  [2666] = 2401,
  [2667] = 2393,
  [2668] = 2230,
  [2669] = 2231,
  [2670] = 2233,
  [2671] = 2393,
  [2672] = 2397,
  [2673] = 2402,
  [2674] = 2416,
  [2675] = 2401,
  [2676] = 2393,
  [2677] = 2393,
  [2678] = 2397,
  [2679] = 2401,
  [2680] = 2402,
  [2681] = 2393,
  [2682] = 2225,
  [2683] = 2415,
  [2684] = 2401,
  [2685] = 2393,
  [2686] = 2402,
  [2687] = 2397,
  [2688] = 2393,
  [2689] = 2393,
  [2690] = 2393,
  [2691] = 2321,
  [2692] = 2319,
  [2693] = 2350,
  [2694] = 2348,
  [2695] = 2308,
  [2696] = 2324,
  [2697] = 2343,
  [2698] = 2241,
  [2699] = 2347,
  [2700] = 2323,
  [2701] = 2332,
  [2702] = 2328,
  [2703] = 2307,
  [2704] = 2310,
  [2705] = 2339,
  [2706] = 2242,
  [2707] = 2331,
  [2708] = 2309,
  [2709] = 2320,
  [2710] = 2327,
  [2711] = 2236,
  [2712] = 2316,
  [2713] = 2352,
  [2714] = 2244,
  [2715] = 2333,
  [2716] = 2306,
  [2717] = 2359,
  [2718] = 2312,
  [2719] = 2322,
  [2720] = 2237,
  [2721] = 2244,
  [2722] = 2241,
  [2723] = 2314,
  [2724] = 2325,
  [2725] = 2315,
  [2726] = 2303,
  [2727] = 2237,
  [2728] = 2313,
  [2729] = 2337,
  [2730] = 2311,
  [2731] = 2349,
  [2732] = 2236,
  [2733] = 2335,
  [2734] = 2318,
  [2735] = 2358,
  [2736] = 2355,
  [2737] = 2305,
  [2738] = 2340,
  [2739] = 2326,
  [2740] = 2336,
  [2741] = 2346,
  [2742] = 2334,
  [2743] = 2351,
  [2744] = 2344,
  [2745] = 2353,
  [2746] = 2341,
  [2747] = 2302,
  [2748] = 2345,
  [2749] = 2342,
  [2750] = 2354,
  [2751] = 2338,
  [2752] = 2348,
  [2753] = 2336,
  [2754] = 2354,
  [2755] = 2311,
  [2756] = 2235,
  [2757] = 2228,
  [2758] = 2339,
  [2759] = 2343,
  [2760] = 2355,
  [2761] = 2349,
  [2762] = 2347,
  [2763] = 2323,
  [2764] = 2328,
  [2765] = 2351,
  [2766] = 2316,
  [2767] = 2341,
  [2768] = 2232,
  [2769] = 2228,
  [2770] = 2227,
  [2771] = 2310,
  [2772] = 2229,
  [2773] = 2309,
  [2774] = 2352,
  [2775] = 2303,
  [2776] = 2325,
  [2777] = 2350,
  [2778] = 2321,
  [2779] = 2322,
  [2780] = 2229,
  [2781] = 2318,
  [2782] = 2230,
  [2783] = 2231,
  [2784] = 2233,
  [2785] = 2225,
  [2786] = 2333,
  [2787] = 2344,
  [2788] = 2338,
  [2789] = 2315,
  [2790] = 2232,
  [2791] = 2235,
  [2792] = 2313,
  [2793] = 2227,
  [2794] = 2230,
  [2795] = 2359,
  [2796] = 2327,
  [2797] = 2307,
  [2798] = 2231,
  [2799] = 2233,
  [2800] = 2231,
  [2801] = 2233,
  [2802] = 2228,
  [2803] = 2230,
  [2804] = 2229,
  [2805] = 2225,
  [2806] = 2319,
  [2807] = 2227,
  [2808] = 2337,
  [2809] = 2324,
  [2810] = 2340,
  [2811] = 2305,
  [2812] = 2314,
  [2813] = 2358,
  [2814] = 2332,
  [2815] = 2312,
  [2816] = 2308,
  [2817] = 2334,
  [2818] = 2235,
  [2819] = 2326,
  [2820] = 2345,
  [2821] = 2302,
  [2822] = 2346,
  [2823] = 2353,
  [2824] = 2228,
  [2825] = 2335,
  [2826] = 2235,
  [2827] = 2225,
  [2828] = 2233,
  [2829] = 2231,
  [2830] = 2320,
  [2831] = 2230,
  [2832] = 2225,
  [2833] = 2229,
  [2834] = 2227,
  [2835] = 2306,
  [2836] = 2232,
  [2837] = 2331,
  [2838] = 2232,
  [2839] = 2342,
  [2840] = 2840,
  [2841] = 2841,
  [2842] = 2237,
  [2843] = 2349,
  [2844] = 2844,
  [2845] = 2845,
  [2846] = 2236,
  [2847] = 2351,
  [2848] = 2848,
  [2849] = 2849,
  [2850] = 2850,
  [2851] = 2358,
  [2852] = 2334,
  [2853] = 2242,
  [2854] = 2241,
  [2855] = 2244,
  [2856] = 2355,
  [2857] = 2241,
  [2858] = 2858,
  [2859] = 2859,
  [2860] = 2860,
  [2861] = 2861,
  [2862] = 2862,
  [2863] = 2237,
  [2864] = 2347,
  [2865] = 2323,
  [2866] = 2332,
  [2867] = 2328,
  [2868] = 2241,
  [2869] = 2237,
  [2870] = 2870,
  [2871] = 2871,
  [2872] = 2241,
  [2873] = 2241,
  [2874] = 2236,
  [2875] = 2875,
  [2876] = 2244,
  [2877] = 2877,
  [2878] = 2878,
  [2879] = 2244,
  [2880] = 2880,
  [2881] = 2881,
  [2882] = 2882,
  [2883] = 2333,
  [2884] = 2884,
  [2885] = 2885,
  [2886] = 2321,
  [2887] = 2322,
  [2888] = 2888,
  [2889] = 2889,
  [2890] = 2890,
  [2891] = 2241,
  [2892] = 2892,
  [2893] = 2236,
  [2894] = 2894,
  [2895] = 2303,
  [2896] = 2896,
  [2897] = 2897,
  [2898] = 2898,
  [2899] = 2236,
  [2900] = 2900,
  [2901] = 2901,
  [2902] = 2310,
  [2903] = 2237,
  [2904] = 2904,
  [2905] = 2339,
  [2906] = 2906,
  [2907] = 2907,
  [2908] = 2908,
  [2909] = 2237,
  [2910] = 2237,
  [2911] = 2235,
  [2912] = 2912,
  [2913] = 2913,
  [2914] = 2914,
  [2915] = 2244,
  [2916] = 2309,
  [2917] = 2318,
  [2918] = 2242,
  [2919] = 2354,
  [2920] = 2232,
  [2921] = 2921,
  [2922] = 2922,
  [2923] = 2311,
  [2924] = 2924,
  [2925] = 2925,
  [2926] = 2926,
  [2927] = 2927,
  [2928] = 2928,
  [2929] = 2929,
  [2930] = 2228,
  [2931] = 2931,
  [2932] = 2242,
  [2933] = 2359,
  [2934] = 2241,
  [2935] = 2935,
  [2936] = 2228,
  [2937] = 2937,
  [2938] = 2938,
  [2939] = 2225,
  [2940] = 2233,
  [2941] = 2941,
  [2942] = 2244,
  [2943] = 2943,
  [2944] = 2236,
  [2945] = 2945,
  [2946] = 2946,
  [2947] = 2231,
  [2948] = 2948,
  [2949] = 2230,
  [2950] = 2950,
  [2951] = 2951,
  [2952] = 2952,
  [2953] = 2237,
  [2954] = 2954,
  [2955] = 2229,
  [2956] = 2956,
  [2957] = 2957,
  [2958] = 2227,
  [2959] = 2959,
  [2960] = 2236,
  [2961] = 2242,
  [2962] = 2962,
  [2963] = 2963,
  [2964] = 2237,
  [2965] = 2965,
  [2966] = 2966,
  [2967] = 2241,
  [2968] = 2968,
  [2969] = 2307,
  [2970] = 2970,
  [2971] = 2971,
  [2972] = 2972,
  [2973] = 2973,
  [2974] = 2974,
  [2975] = 2975,
  [2976] = 2976,
  [2977] = 2977,
  [2978] = 2244,
  [2979] = 2244,
  [2980] = 2980,
  [2981] = 2981,
  [2982] = 2982,
  [2983] = 2983,
  [2984] = 2241,
  [2985] = 2985,
  [2986] = 2986,
  [2987] = 2987,
  [2988] = 2988,
  [2989] = 2989,
  [2990] = 2990,
  [2991] = 2991,
  [2992] = 2306,
  [2993] = 2993,
  [2994] = 2994,
  [2995] = 2995,
  [2996] = 2996,
  [2997] = 2997,
  [2998] = 2998,
  [2999] = 2999,
  [3000] = 3000,
  [3001] = 3001,
  [3002] = 3002,
  [3003] = 3003,
  [3004] = 3004,
  [3005] = 3005,
  [3006] = 3006,
  [3007] = 2235,
  [3008] = 2244,
  [3009] = 3009,
  [3010] = 3010,
  [3011] = 3011,
  [3012] = 3012,
  [3013] = 3013,
  [3014] = 3014,
  [3015] = 3015,
  [3016] = 3016,
  [3017] = 3017,
  [3018] = 3018,
  [3019] = 3019,
  [3020] = 2242,
  [3021] = 3021,
  [3022] = 2313,
  [3023] = 3023,
  [3024] = 3024,
  [3025] = 3025,
  [3026] = 3026,
  [3027] = 3027,
  [3028] = 3028,
  [3029] = 3029,
  [3030] = 3030,
  [3031] = 3031,
  [3032] = 3032,
  [3033] = 3033,
  [3034] = 3034,
  [3035] = 3035,
  [3036] = 3036,
  [3037] = 3037,
  [3038] = 2232,
  [3039] = 2227,
  [3040] = 3040,
  [3041] = 2229,
  [3042] = 3042,
  [3043] = 2236,
  [3044] = 2230,
  [3045] = 3045,
  [3046] = 2231,
  [3047] = 2233,
  [3048] = 2225,
  [3049] = 3049,
  [3050] = 2236,
  [3051] = 3051,
  [3052] = 2322,
  [3053] = 2244,
  [3054] = 2241,
  [3055] = 2236,
  [3056] = 2242,
  [3057] = 2241,
  [3058] = 2313,
  [3059] = 2892,
  [3060] = 2316,
  [3061] = 2332,
  [3062] = 2242,
  [3063] = 2311,
  [3064] = 2310,
  [3065] = 2309,
  [3066] = 2320,
  [3067] = 2302,
  [3068] = 2892,
  [3069] = 2244,
  [3070] = 2344,
  [3071] = 2348,
  [3072] = 2336,
  [3073] = 2303,
  [3074] = 2241,
  [3075] = 2346,
  [3076] = 2326,
  [3077] = 2241,
  [3078] = 2242,
  [3079] = 2237,
  [3080] = 2237,
  [3081] = 2892,
  [3082] = 2350,
  [3083] = 2343,
  [3084] = 2352,
  [3085] = 2892,
  [3086] = 2324,
  [3087] = 2319,
  [3088] = 2325,
  [3089] = 2241,
  [3090] = 2333,
  [3091] = 2337,
  [3092] = 2338,
  [3093] = 2244,
  [3094] = 2244,
  [3095] = 2341,
  [3096] = 2331,
  [3097] = 2339,
  [3098] = 2892,
  [3099] = 2353,
  [3100] = 2342,
  [3101] = 2892,
  [3102] = 2306,
  [3103] = 2315,
  [3104] = 2354,
  [3105] = 2241,
  [3106] = 2305,
  [3107] = 2892,
  [3108] = 2236,
  [3109] = 2351,
  [3110] = 2334,
  [3111] = 2335,
  [3112] = 2308,
  [3113] = 2236,
  [3114] = 2340,
  [3115] = 2391,
  [3116] = 2359,
  [3117] = 2237,
  [3118] = 2318,
  [3119] = 2242,
  [3120] = 2242,
  [3121] = 2358,
  [3122] = 2321,
  [3123] = 2327,
  [3124] = 2242,
  [3125] = 2355,
  [3126] = 2349,
  [3127] = 2241,
  [3128] = 2347,
  [3129] = 2323,
  [3130] = 2328,
  [3131] = 2390,
  [3132] = 2387,
  [3133] = 2241,
  [3134] = 2307,
  [3135] = 2386,
  [3136] = 2383,
  [3137] = 2236,
  [3138] = 2381,
  [3139] = 2345,
  [3140] = 2312,
  [3141] = 2314,
  [3142] = 2237,
  [3143] = 3143,
  [3144] = 2244,
  [3145] = 3143,
  [3146] = 2237,
  [3147] = 2306,
  [3148] = 2242,
  [3149] = 2241,
  [3150] = 2237,
  [3151] = 2236,
  [3152] = 3143,
  [3153] = 3153,
  [3154] = 2241,
  [3155] = 2334,
  [3156] = 2244,
  [3157] = 2241,
  [3158] = 2892,
  [3159] = 3143,
  [3160] = 3143,
  [3161] = 2244,
  [3162] = 3143,
  [3163] = 2237,
  [3164] = 2236,
  [3165] = 3143,
  [3166] = 2892,
  [3167] = 3167,
  [3168] = 2236,
  [3169] = 2242,
  [3170] = 2236,
  [3171] = 2242,
  [3172] = 2241,
  [3173] = 2244,
  [3174] = 2241,
  [3175] = 2241,
  [3176] = 2237,
  [3177] = 2350,
  [3178] = 2309,
  [3179] = 2358,
  [3180] = 2351,
  [3181] = 2303,
  [3182] = 2336,
  [3183] = 2348,
  [3184] = 2338,
  [3185] = 2350,
  [3186] = 2325,
  [3187] = 2339,
  [3188] = 2341,
  [3189] = 2352,
  [3190] = 2354,
  [3191] = 2303,
  [3192] = 2332,
  [3193] = 2359,
  [3194] = 2313,
  [3195] = 2353,
  [3196] = 2353,
  [3197] = 2351,
  [3198] = 2342,
  [3199] = 2358,
  [3200] = 2355,
  [3201] = 2349,
  [3202] = 2334,
  [3203] = 2316,
  [3204] = 2347,
  [3205] = 2323,
  [3206] = 2332,
  [3207] = 2334,
  [3208] = 2328,
  [3209] = 2341,
  [3210] = 2337,
  [3211] = 2342,
  [3212] = 2319,
  [3213] = 2307,
  [3214] = 2338,
  [3215] = 2337,
  [3216] = 2324,
  [3217] = 2335,
  [3218] = 2316,
  [3219] = 2327,
  [3220] = 2335,
  [3221] = 2332,
  [3222] = 2320,
  [3223] = 2310,
  [3224] = 2333,
  [3225] = 2352,
  [3226] = 2309,
  [3227] = 2307,
  [3228] = 3228,
  [3229] = 3229,
  [3230] = 2333,
  [3231] = 2339,
  [3232] = 2348,
  [3233] = 2354,
  [3234] = 2354,
  [3235] = 3235,
  [3236] = 2359,
  [3237] = 2302,
  [3238] = 2358,
  [3239] = 2241,
  [3240] = 2311,
  [3241] = 2345,
  [3242] = 2318,
  [3243] = 2355,
  [3244] = 2308,
  [3245] = 2312,
  [3246] = 2349,
  [3247] = 2314,
  [3248] = 2315,
  [3249] = 2343,
  [3250] = 2321,
  [3251] = 2322,
  [3252] = 3252,
  [3253] = 2346,
  [3254] = 2311,
  [3255] = 2339,
  [3256] = 2347,
  [3257] = 2322,
  [3258] = 2339,
  [3259] = 2305,
  [3260] = 2323,
  [3261] = 2321,
  [3262] = 2343,
  [3263] = 3263,
  [3264] = 2328,
  [3265] = 2307,
  [3266] = 2354,
  [3267] = 2359,
  [3268] = 2358,
  [3269] = 2318,
  [3270] = 2355,
  [3271] = 2349,
  [3272] = 2311,
  [3273] = 2316,
  [3274] = 2347,
  [3275] = 2326,
  [3276] = 2313,
  [3277] = 2333,
  [3278] = 2326,
  [3279] = 2306,
  [3280] = 2323,
  [3281] = 2321,
  [3282] = 2322,
  [3283] = 2340,
  [3284] = 2340,
  [3285] = 2324,
  [3286] = 2318,
  [3287] = 2305,
  [3288] = 2339,
  [3289] = 2303,
  [3290] = 2320,
  [3291] = 2319,
  [3292] = 2327,
  [3293] = 2311,
  [3294] = 2335,
  [3295] = 2337,
  [3296] = 2338,
  [3297] = 2325,
  [3298] = 2341,
  [3299] = 2328,
  [3300] = 2351,
  [3301] = 2309,
  [3302] = 2328,
  [3303] = 2310,
  [3304] = 2334,
  [3305] = 2332,
  [3306] = 2331,
  [3307] = 2323,
  [3308] = 2347,
  [3309] = 2351,
  [3310] = 2331,
  [3311] = 2342,
  [3312] = 2354,
  [3313] = 2353,
  [3314] = 2352,
  [3315] = 2359,
  [3316] = 2315,
  [3317] = 2333,
  [3318] = 2350,
  [3319] = 2305,
  [3320] = 2348,
  [3321] = 2325,
  [3322] = 2306,
  [3323] = 2340,
  [3324] = 2314,
  [3325] = 2319,
  [3326] = 2312,
  [3327] = 2306,
  [3328] = 2307,
  [3329] = 2306,
  [3330] = 2318,
  [3331] = 2336,
  [3332] = 2308,
  [3333] = 2324,
  [3334] = 2311,
  [3335] = 2316,
  [3336] = 2307,
  [3337] = 2349,
  [3338] = 2336,
  [3339] = 2346,
  [3340] = 2302,
  [3341] = 2345,
  [3342] = 2334,
  [3343] = 2345,
  [3344] = 2322,
  [3345] = 2326,
  [3346] = 2346,
  [3347] = 2302,
  [3348] = 2302,
  [3349] = 2346,
  [3350] = 2336,
  [3351] = 2321,
  [3352] = 2345,
  [3353] = 2359,
  [3354] = 2348,
  [3355] = 2344,
  [3356] = 2313,
  [3357] = 2350,
  [3358] = 2352,
  [3359] = 2353,
  [3360] = 2892,
  [3361] = 2342,
  [3362] = 2355,
  [3363] = 2391,
  [3364] = 2327,
  [3365] = 2310,
  [3366] = 2390,
  [3367] = 2309,
  [3368] = 2303,
  [3369] = 2341,
  [3370] = 2338,
  [3371] = 2308,
  [3372] = 2303,
  [3373] = 2333,
  [3374] = 2387,
  [3375] = 2312,
  [3376] = 2320,
  [3377] = 2337,
  [3378] = 2332,
  [3379] = 2335,
  [3380] = 2309,
  [3381] = 2386,
  [3382] = 2310,
  [3383] = 2327,
  [3384] = 2314,
  [3385] = 2320,
  [3386] = 2315,
  [3387] = 2383,
  [3388] = 2321,
  [3389] = 2322,
  [3390] = 2381,
  [3391] = 2358,
  [3392] = 3143,
  [3393] = 2355,
  [3394] = 2344,
  [3395] = 2344,
  [3396] = 2328,
  [3397] = 2318,
  [3398] = 2323,
  [3399] = 2347,
  [3400] = 2315,
  [3401] = 2314,
  [3402] = 2326,
  [3403] = 2892,
  [3404] = 2313,
  [3405] = 2312,
  [3406] = 2313,
  [3407] = 2308,
  [3408] = 2324,
  [3409] = 2344,
  [3410] = 2343,
  [3411] = 2319,
  [3412] = 2325,
  [3413] = 2331,
  [3414] = 2340,
  [3415] = 2305,
  [3416] = 2349,
  [3417] = 2331,
  [3418] = 2351,
  [3419] = 2310,
  [3420] = 2343,
  [3421] = 2321,
  [3422] = 2332,
  [3423] = 2323,
  [3424] = 2314,
  [3425] = 2328,
  [3426] = 2332,
  [3427] = 2307,
  [3428] = 2237,
  [3429] = 3252,
  [3430] = 2242,
  [3431] = 2322,
  [3432] = 2321,
  [3433] = 2322,
  [3434] = 2333,
  [3435] = 2318,
  [3436] = 2315,
  [3437] = 3437,
  [3438] = 2316,
  [3439] = 3263,
  [3440] = 2312,
  [3441] = 2308,
  [3442] = 2322,
  [3443] = 2237,
  [3444] = 2314,
  [3445] = 2313,
  [3446] = 2333,
  [3447] = 2321,
  [3448] = 2354,
  [3449] = 2315,
  [3450] = 2319,
  [3451] = 3252,
  [3452] = 2311,
  [3453] = 2244,
  [3454] = 2326,
  [3455] = 2236,
  [3456] = 3235,
  [3457] = 2237,
  [3458] = 2307,
  [3459] = 2324,
  [3460] = 3229,
  [3461] = 2325,
  [3462] = 2313,
  [3463] = 2237,
  [3464] = 2334,
  [3465] = 2311,
  [3466] = 2307,
  [3467] = 2312,
  [3468] = 2308,
  [3469] = 2309,
  [3470] = 2241,
  [3471] = 2351,
  [3472] = 2237,
  [3473] = 2244,
  [3474] = 2336,
  [3475] = 2354,
  [3476] = 2244,
  [3477] = 2241,
  [3478] = 2236,
  [3479] = 3437,
  [3480] = 2241,
  [3481] = 2236,
  [3482] = 3228,
  [3483] = 2349,
  [3484] = 2242,
  [3485] = 2355,
  [3486] = 2241,
  [3487] = 2310,
  [3488] = 2358,
  [3489] = 2359,
  [3490] = 3437,
  [3491] = 2244,
  [3492] = 2324,
  [3493] = 2319,
  [3494] = 2325,
  [3495] = 2309,
  [3496] = 2328,
  [3497] = 2332,
  [3498] = 2323,
  [3499] = 2331,
  [3500] = 2347,
  [3501] = 2354,
  [3502] = 2339,
  [3503] = 2358,
  [3504] = 2331,
  [3505] = 2318,
  [3506] = 2355,
  [3507] = 2236,
  [3508] = 2349,
  [3509] = 2318,
  [3510] = 2310,
  [3511] = 3228,
  [3512] = 3228,
  [3513] = 3229,
  [3514] = 3229,
  [3515] = 2358,
  [3516] = 2355,
  [3517] = 3235,
  [3518] = 2349,
  [3519] = 2345,
  [3520] = 3252,
  [3521] = 2302,
  [3522] = 3235,
  [3523] = 2328,
  [3524] = 2351,
  [3525] = 2346,
  [3526] = 2334,
  [3527] = 2516,
  [3528] = 2336,
  [3529] = 2306,
  [3530] = 2345,
  [3531] = 2242,
  [3532] = 2306,
  [3533] = 2333,
  [3534] = 3228,
  [3535] = 2302,
  [3536] = 2346,
  [3537] = 2318,
  [3538] = 2349,
  [3539] = 2306,
  [3540] = 3229,
  [3541] = 2359,
  [3542] = 2323,
  [3543] = 2347,
  [3544] = 2349,
  [3545] = 2322,
  [3546] = 2326,
  [3547] = 2321,
  [3548] = 2333,
  [3549] = 2305,
  [3550] = 2340,
  [3551] = 2310,
  [3552] = 2347,
  [3553] = 2355,
  [3554] = 2358,
  [3555] = 3235,
  [3556] = 2348,
  [3557] = 2335,
  [3558] = 2307,
  [3559] = 2350,
  [3560] = 2359,
  [3561] = 2352,
  [3562] = 2354,
  [3563] = 2354,
  [3564] = 2236,
  [3565] = 2328,
  [3566] = 2359,
  [3567] = 2353,
  [3568] = 2323,
  [3569] = 2342,
  [3570] = 2341,
  [3571] = 2339,
  [3572] = 2338,
  [3573] = 2311,
  [3574] = 2305,
  [3575] = 2347,
  [3576] = 2337,
  [3577] = 2340,
  [3578] = 2347,
  [3579] = 2335,
  [3580] = 2339,
  [3581] = 2333,
  [3582] = 2327,
  [3583] = 2348,
  [3584] = 2349,
  [3585] = 2320,
  [3586] = 2355,
  [3587] = 2332,
  [3588] = 2316,
  [3589] = 2358,
  [3590] = 2323,
  [3591] = 2328,
  [3592] = 2306,
  [3593] = 2339,
  [3594] = 2303,
  [3595] = 2241,
  [3596] = 2303,
  [3597] = 2350,
  [3598] = 2339,
  [3599] = 3235,
  [3600] = 2311,
  [3601] = 2313,
  [3602] = 2352,
  [3603] = 2237,
  [3604] = 2353,
  [3605] = 2342,
  [3606] = 2341,
  [3607] = 2338,
  [3608] = 3229,
  [3609] = 2311,
  [3610] = 2343,
  [3611] = 3228,
  [3612] = 2337,
  [3613] = 2306,
  [3614] = 3614,
  [3615] = 2355,
  [3616] = 2244,
  [3617] = 2309,
  [3618] = 2307,
  [3619] = 2334,
  [3620] = 2351,
  [3621] = 2310,
  [3622] = 2310,
  [3623] = 2351,
  [3624] = 2332,
  [3625] = 2306,
  [3626] = 2347,
  [3627] = 2358,
  [3628] = 3228,
  [3629] = 3229,
  [3630] = 3252,
  [3631] = 2323,
  [3632] = 2332,
  [3633] = 2328,
  [3634] = 3235,
  [3635] = 3235,
  [3636] = 3437,
  [3637] = 2303,
  [3638] = 2327,
  [3639] = 2309,
  [3640] = 2303,
  [3641] = 3229,
  [3642] = 3228,
  [3643] = 2343,
  [3644] = 2320,
  [3645] = 2359,
  [3646] = 2334,
  [3647] = 3252,
  [3648] = 2313,
  [3649] = 2589,
  [3650] = 3252,
  [3651] = 2313,
  [3652] = 2321,
  [3653] = 3437,
  [3654] = 3437,
  [3655] = 2303,
  [3656] = 2322,
  [3657] = 2351,
  [3658] = 2333,
  [3659] = 3437,
  [3660] = 2321,
  [3661] = 2322,
  [3662] = 2539,
  [3663] = 2546,
  [3664] = 2334,
  [3665] = 2359,
  [3666] = 2318,
  [3667] = 2244,
  [3668] = 2313,
  [3669] = 2354,
  [3670] = 2309,
  [3671] = 2466,
  [3672] = 2334,
  [3673] = 2303,
  [3674] = 2309,
  [3675] = 2310,
  [3676] = 2339,
  [3677] = 2351,
  [3678] = 2311,
  [3679] = 2344,
  [3680] = 2344,
  [3681] = 2307,
  [3682] = 2241,
  [3683] = 2318,
  [3684] = 2236,
  [3685] = 2354,
  [3686] = 2236,
  [3687] = 2331,
  [3688] = 2311,
  [3689] = 2242,
  [3690] = 2318,
  [3691] = 2328,
  [3692] = 2323,
  [3693] = 2347,
  [3694] = 2310,
  [3695] = 2332,
  [3696] = 2359,
  [3697] = 2354,
  [3698] = 2320,
  [3699] = 2327,
  [3700] = 2306,
  [3701] = 2335,
  [3702] = 2337,
  [3703] = 2343,
  [3704] = 2334,
  [3705] = 3235,
  [3706] = 3229,
  [3707] = 2344,
  [3708] = 3228,
  [3709] = 2338,
  [3710] = 2351,
  [3711] = 2341,
  [3712] = 2342,
  [3713] = 3228,
  [3714] = 3229,
  [3715] = 2353,
  [3716] = 2358,
  [3717] = 2352,
  [3718] = 2350,
  [3719] = 3235,
  [3720] = 2391,
  [3721] = 2348,
  [3722] = 2339,
  [3723] = 2349,
  [3724] = 2303,
  [3725] = 2336,
  [3726] = 2381,
  [3727] = 2383,
  [3728] = 2386,
  [3729] = 2387,
  [3730] = 2390,
  [3731] = 3252,
  [3732] = 2346,
  [3733] = 2321,
  [3734] = 2322,
  [3735] = 2241,
  [3736] = 3252,
  [3737] = 2311,
  [3738] = 2355,
  [3739] = 2313,
  [3740] = 2322,
  [3741] = 2358,
  [3742] = 2307,
  [3743] = 2345,
  [3744] = 2321,
  [3745] = 2340,
  [3746] = 2305,
  [3747] = 2308,
  [3748] = 2312,
  [3749] = 2314,
  [3750] = 2333,
  [3751] = 2333,
  [3752] = 2334,
  [3753] = 2315,
  [3754] = 2307,
  [3755] = 2324,
  [3756] = 2355,
  [3757] = 2381,
  [3758] = 2383,
  [3759] = 2316,
  [3760] = 2310,
  [3761] = 2302,
  [3762] = 2386,
  [3763] = 2381,
  [3764] = 2383,
  [3765] = 2386,
  [3766] = 2387,
  [3767] = 2387,
  [3768] = 2390,
  [3769] = 2390,
  [3770] = 2391,
  [3771] = 2309,
  [3772] = 2303,
  [3773] = 2319,
  [3774] = 2326,
  [3775] = 2339,
  [3776] = 3776,
  [3777] = 2237,
  [3778] = 2244,
  [3779] = 2328,
  [3780] = 2237,
  [3781] = 2318,
  [3782] = 2332,
  [3783] = 2351,
  [3784] = 2359,
  [3785] = 2323,
  [3786] = 2347,
  [3787] = 2244,
  [3788] = 2391,
  [3789] = 2313,
  [3790] = 2236,
  [3791] = 2381,
  [3792] = 2241,
  [3793] = 2383,
  [3794] = 2386,
  [3795] = 3437,
  [3796] = 2349,
  [3797] = 2387,
  [3798] = 2390,
  [3799] = 2391,
  [3800] = 2306,
  [3801] = 2309,
  [3802] = 2325,
  [3803] = 2350,
  [3804] = 3804,
  [3805] = 2340,
  [3806] = 2305,
  [3807] = 2348,
  [3808] = 2323,
  [3809] = 2241,
  [3810] = 2332,
  [3811] = 2328,
  [3812] = 2237,
  [3813] = 2589,
  [3814] = 2306,
  [3815] = 2539,
  [3816] = 2244,
  [3817] = 3804,
  [3818] = 2546,
  [3819] = 2347,
  [3820] = 2236,
  [3821] = 2390,
  [3822] = 2353,
  [3823] = 2387,
  [3824] = 2386,
  [3825] = 2325,
  [3826] = 2341,
  [3827] = 2344,
  [3828] = 2589,
  [3829] = 2383,
  [3830] = 2241,
  [3831] = 2236,
  [3832] = 2381,
  [3833] = 2244,
  [3834] = 2236,
  [3835] = 3835,
  [3836] = 2589,
  [3837] = 2244,
  [3838] = 2391,
  [3839] = 2244,
  [3840] = 2315,
  [3841] = 2314,
  [3842] = 2333,
  [3843] = 2338,
  [3844] = 2309,
  [3845] = 2311,
  [3846] = 2337,
  [3847] = 3804,
  [3848] = 2321,
  [3849] = 2322,
  [3850] = 2237,
  [3851] = 2335,
  [3852] = 2516,
  [3853] = 2237,
  [3854] = 3854,
  [3855] = 2327,
  [3856] = 2546,
  [3857] = 2539,
  [3858] = 2339,
  [3859] = 2516,
  [3860] = 2359,
  [3861] = 3861,
  [3862] = 2516,
  [3863] = 3804,
  [3864] = 2241,
  [3865] = 2242,
  [3866] = 2349,
  [3867] = 2241,
  [3868] = 2326,
  [3869] = 2320,
  [3870] = 3776,
  [3871] = 2546,
  [3872] = 2242,
  [3873] = 2241,
  [3874] = 3874,
  [3875] = 2539,
  [3876] = 2236,
  [3877] = 2237,
  [3878] = 2242,
  [3879] = 2236,
  [3880] = 2244,
  [3881] = 2241,
  [3882] = 2244,
  [3883] = 2466,
  [3884] = 2236,
  [3885] = 3804,
  [3886] = 2318,
  [3887] = 2342,
  [3888] = 2352,
  [3889] = 2381,
  [3890] = 2466,
  [3891] = 2336,
  [3892] = 2346,
  [3893] = 2237,
  [3894] = 2302,
  [3895] = 2237,
  [3896] = 2345,
  [3897] = 2331,
  [3898] = 2343,
  [3899] = 2237,
  [3900] = 2355,
  [3901] = 2383,
  [3902] = 2386,
  [3903] = 2316,
  [3904] = 2241,
  [3905] = 2387,
  [3906] = 2334,
  [3907] = 3252,
  [3908] = 2351,
  [3909] = 2390,
  [3910] = 2391,
  [3911] = 2358,
  [3912] = 2319,
  [3913] = 2312,
  [3914] = 2303,
  [3915] = 2466,
  [3916] = 2310,
  [3917] = 2241,
  [3918] = 2307,
  [3919] = 2308,
  [3920] = 2237,
  [3921] = 2236,
  [3922] = 2324,
  [3923] = 3235,
  [3924] = 2244,
  [3925] = 2313,
  [3926] = 2244,
  [3927] = 2236,
  [3928] = 2354,
  [3929] = 3229,
  [3930] = 3228,
  [3931] = 2242,
  [3932] = 2307,
  [3933] = 2589,
  [3934] = 2359,
  [3935] = 2959,
  [3936] = 2965,
  [3937] = 2970,
  [3938] = 2971,
  [3939] = 2972,
  [3940] = 2974,
  [3941] = 2977,
  [3942] = 2981,
  [3943] = 2987,
  [3944] = 2237,
  [3945] = 2995,
  [3946] = 2999,
  [3947] = 3000,
  [3948] = 3001,
  [3949] = 3002,
  [3950] = 3003,
  [3951] = 3004,
  [3952] = 3005,
  [3953] = 2339,
  [3954] = 2359,
  [3955] = 3006,
  [3956] = 3010,
  [3957] = 3012,
  [3958] = 3013,
  [3959] = 3014,
  [3960] = 3016,
  [3961] = 3018,
  [3962] = 3024,
  [3963] = 2334,
  [3964] = 2320,
  [3965] = 3029,
  [3966] = 3030,
  [3967] = 3031,
  [3968] = 3032,
  [3969] = 3034,
  [3970] = 3035,
  [3971] = 3036,
  [3972] = 3037,
  [3973] = 3040,
  [3974] = 2358,
  [3975] = 2327,
  [3976] = 3051,
  [3977] = 3042,
  [3978] = 3027,
  [3979] = 3023,
  [3980] = 3019,
  [3981] = 3009,
  [3982] = 2998,
  [3983] = 2997,
  [3984] = 2996,
  [3985] = 2991,
  [3986] = 2976,
  [3987] = 2355,
  [3988] = 2338,
  [3989] = 2337,
  [3990] = 2975,
  [3991] = 2973,
  [3992] = 2968,
  [3993] = 2963,
  [3994] = 2344,
  [3995] = 2347,
  [3996] = 2335,
  [3997] = 2348,
  [3998] = 2914,
  [3999] = 2912,
  [4000] = 2338,
  [4001] = 2341,
  [4002] = 2323,
  [4003] = 2342,
  [4004] = 2353,
  [4005] = 2352,
  [4006] = 2350,
  [4007] = 2907,
  [4008] = 2332,
  [4009] = 2904,
  [4010] = 2901,
  [4011] = 2900,
  [4012] = 2898,
  [4013] = 2897,
  [4014] = 2896,
  [4015] = 2888,
  [4016] = 2328,
  [4017] = 2885,
  [4018] = 2309,
  [4019] = 2882,
  [4020] = 2337,
  [4021] = 2311,
  [4022] = 2241,
  [4023] = 2871,
  [4024] = 2926,
  [4025] = 2870,
  [4026] = 2862,
  [4027] = 2335,
  [4028] = 2244,
  [4029] = 2327,
  [4030] = 2336,
  [4031] = 2308,
  [4032] = 2320,
  [4033] = 2346,
  [4034] = 2302,
  [4035] = 2345,
  [4036] = 2331,
  [4037] = 2312,
  [4038] = 2333,
  [4039] = 2236,
  [4040] = 2321,
  [4041] = 2350,
  [4042] = 2354,
  [4043] = 2309,
  [4044] = 2312,
  [4045] = 2308,
  [4046] = 2348,
  [4047] = 2353,
  [4048] = 2355,
  [4049] = 2315,
  [4050] = 2861,
  [4051] = 3021,
  [4052] = 3015,
  [4053] = 2322,
  [4054] = 2306,
  [4055] = 3045,
  [4056] = 2342,
  [4057] = 2314,
  [4058] = 2326,
  [4059] = 2966,
  [4060] = 2306,
  [4061] = 2343,
  [4062] = 2354,
  [4063] = 2924,
  [4064] = 2313,
  [4065] = 2345,
  [4066] = 2358,
  [4067] = 2318,
  [4068] = 2355,
  [4069] = 2906,
  [4070] = 2319,
  [4071] = 2314,
  [4072] = 2881,
  [4073] = 2349,
  [4074] = 2320,
  [4075] = 2327,
  [4076] = 2310,
  [4077] = 2921,
  [4078] = 2335,
  [4079] = 2242,
  [4080] = 2337,
  [4081] = 2338,
  [4082] = 2341,
  [4083] = 2349,
  [4084] = 2342,
  [4085] = 2353,
  [4086] = 2324,
  [4087] = 2319,
  [4088] = 2352,
  [4089] = 2344,
  [4090] = 2347,
  [4091] = 2244,
  [4092] = 2323,
  [4093] = 2332,
  [4094] = 2328,
  [4095] = 2325,
  [4096] = 2922,
  [4097] = 2350,
  [4098] = 2348,
  [4099] = 2928,
  [4100] = 2880,
  [4101] = 2929,
  [4102] = 2878,
  [4103] = 2303,
  [4104] = 2331,
  [4105] = 2877,
  [4106] = 2344,
  [4107] = 2306,
  [4108] = 2931,
  [4109] = 2875,
  [4110] = 2860,
  [4111] = 2315,
  [4112] = 2339,
  [4113] = 2859,
  [4114] = 2303,
  [4115] = 2303,
  [4116] = 2336,
  [4117] = 2858,
  [4118] = 2346,
  [4119] = 2351,
  [4120] = 2333,
  [4121] = 2994,
  [4122] = 2321,
  [4123] = 2331,
  [4124] = 2302,
  [4125] = 2322,
  [4126] = 2850,
  [4127] = 2311,
  [4128] = 2313,
  [4129] = 2849,
  [4130] = 2848,
  [4131] = 2952,
  [4132] = 2345,
  [4133] = 2352,
  [4134] = 2845,
  [4135] = 3049,
  [4136] = 2908,
  [4137] = 3033,
  [4138] = 2343,
  [4139] = 2358,
  [4140] = 2957,
  [4141] = 3017,
  [4142] = 2840,
  [4143] = 2951,
  [4144] = 2343,
  [4145] = 2950,
  [4146] = 2305,
  [4147] = 2340,
  [4148] = 2318,
  [4149] = 3011,
  [4150] = 2339,
  [4151] = 2305,
  [4152] = 2841,
  [4153] = 2516,
  [4154] = 2993,
  [4155] = 2340,
  [4156] = 2938,
  [4157] = 2326,
  [4158] = 2937,
  [4159] = 2310,
  [4160] = 2988,
  [4161] = 2986,
  [4162] = 2347,
  [4163] = 2985,
  [4164] = 2323,
  [4165] = 2307,
  [4166] = 2935,
  [4167] = 2332,
  [4168] = 2328,
  [4169] = 2927,
  [4170] = 2349,
  [4171] = 2325,
  [4172] = 2324,
  [4173] = 2983,
  [4174] = 4174,
  [4175] = 2324,
  [4176] = 2982,
  [4177] = 2341,
  [4178] = 2956,
  [4179] = 2333,
  [4180] = 2321,
  [4181] = 2980,
  [4182] = 2322,
  [4183] = 2308,
  [4184] = 2307,
  [4185] = 2316,
  [4186] = 2312,
  [4187] = 2319,
  [4188] = 2336,
  [4189] = 2316,
  [4190] = 2989,
  [4191] = 2334,
  [4192] = 2913,
  [4193] = 2318,
  [4194] = 2894,
  [4195] = 2310,
  [4196] = 2311,
  [4197] = 2890,
  [4198] = 2889,
  [4199] = 2962,
  [4200] = 2309,
  [4201] = 2237,
  [4202] = 2948,
  [4203] = 2884,
  [4204] = 2946,
  [4205] = 2354,
  [4206] = 2466,
  [4207] = 2945,
  [4208] = 2990,
  [4209] = 2351,
  [4210] = 2314,
  [4211] = 2316,
  [4212] = 2241,
  [4213] = 2351,
  [4214] = 3025,
  [4215] = 2325,
  [4216] = 2326,
  [4217] = 2941,
  [4218] = 2943,
  [4219] = 2359,
  [4220] = 2954,
  [4221] = 2236,
  [4222] = 2340,
  [4223] = 2844,
  [4224] = 2334,
  [4225] = 2305,
  [4226] = 2302,
  [4227] = 2346,
  [4228] = 3026,
  [4229] = 2539,
  [4230] = 2546,
  [4231] = 3028,
  [4232] = 2315,
  [4233] = 2313,
  [4234] = 2925,
  [4235] = 2350,
  [4236] = 2589,
  [4237] = 2349,
  [4238] = 2539,
  [4239] = 2546,
  [4240] = 2316,
  [4241] = 2352,
  [4242] = 2351,
  [4243] = 2334,
  [4244] = 2336,
  [4245] = 2355,
  [4246] = 2358,
  [4247] = 4247,
  [4248] = 2343,
  [4249] = 2347,
  [4250] = 2323,
  [4251] = 2354,
  [4252] = 2306,
  [4253] = 2322,
  [4254] = 4254,
  [4255] = 2320,
  [4256] = 2344,
  [4257] = 2327,
  [4258] = 2335,
  [4259] = 2589,
  [4260] = 4260,
  [4261] = 2337,
  [4262] = 2338,
  [4263] = 2341,
  [4264] = 2342,
  [4265] = 2353,
  [4266] = 2326,
  [4267] = 2340,
  [4268] = 2305,
  [4269] = 2339,
  [4270] = 2466,
  [4271] = 2303,
  [4272] = 2346,
  [4273] = 2302,
  [4274] = 2309,
  [4275] = 2348,
  [4276] = 2345,
  [4277] = 2466,
  [4278] = 2332,
  [4279] = 2331,
  [4280] = 2328,
  [4281] = 2516,
  [4282] = 2318,
  [4283] = 2539,
  [4284] = 2311,
  [4285] = 2546,
  [4286] = 2315,
  [4287] = 2325,
  [4288] = 2307,
  [4289] = 2546,
  [4290] = 2539,
  [4291] = 2319,
  [4292] = 2516,
  [4293] = 2310,
  [4294] = 2321,
  [4295] = 2333,
  [4296] = 2516,
  [4297] = 2312,
  [4298] = 2359,
  [4299] = 2313,
  [4300] = 2466,
  [4301] = 2308,
  [4302] = 2324,
  [4303] = 2589,
  [4304] = 2314,
  [4305] = 2962,
  [4306] = 3034,
  [4307] = 2948,
  [4308] = 2946,
  [4309] = 2945,
  [4310] = 2516,
  [4311] = 2340,
  [4312] = 2952,
  [4313] = 2359,
  [4314] = 2331,
  [4315] = 2320,
  [4316] = 2305,
  [4317] = 2327,
  [4318] = 2335,
  [4319] = 2337,
  [4320] = 2844,
  [4321] = 2331,
  [4322] = 2343,
  [4323] = 2325,
  [4324] = 2338,
  [4325] = 2341,
  [4326] = 2342,
  [4327] = 2353,
  [4328] = 2352,
  [4329] = 2350,
  [4330] = 2348,
  [4331] = 2319,
  [4332] = 2889,
  [4333] = 2890,
  [4334] = 2894,
  [4335] = 2324,
  [4336] = 2913,
  [4337] = 2994,
  [4338] = 2307,
  [4339] = 2339,
  [4340] = 2927,
  [4341] = 2935,
  [4342] = 2346,
  [4343] = 2302,
  [4344] = 2884,
  [4345] = 2305,
  [4346] = 2340,
  [4347] = 2326,
  [4348] = 2345,
  [4349] = 2336,
  [4350] = 2307,
  [4351] = 2303,
  [4352] = 2359,
  [4353] = 2937,
  [4354] = 2339,
  [4355] = 2308,
  [4356] = 2312,
  [4357] = 2319,
  [4358] = 2938,
  [4359] = 2324,
  [4360] = 2325,
  [4361] = 2315,
  [4362] = 2314,
  [4363] = 2950,
  [4364] = 2951,
  [4365] = 2840,
  [4366] = 2318,
  [4367] = 2957,
  [4368] = 2354,
  [4369] = 2358,
  [4370] = 2926,
  [4371] = 2326,
  [4372] = 2320,
  [4373] = 2327,
  [4374] = 2335,
  [4375] = 2337,
  [4376] = 2338,
  [4377] = 2341,
  [4378] = 2354,
  [4379] = 2342,
  [4380] = 2353,
  [4381] = 2352,
  [4382] = 2350,
  [4383] = 2348,
  [4384] = 2344,
  [4385] = 2336,
  [4386] = 2346,
  [4387] = 2302,
  [4388] = 2345,
  [4389] = 2343,
  [4390] = 2308,
  [4391] = 2312,
  [4392] = 2314,
  [4393] = 2931,
  [4394] = 2315,
  [4395] = 2322,
  [4396] = 2321,
  [4397] = 2929,
  [4398] = 2333,
  [4399] = 2326,
  [4400] = 2324,
  [4401] = 2334,
  [4402] = 2351,
  [4403] = 2926,
  [4404] = 2319,
  [4405] = 2309,
  [4406] = 2325,
  [4407] = 2328,
  [4408] = 2332,
  [4409] = 2928,
  [4410] = 3015,
  [4411] = 2331,
  [4412] = 2323,
  [4413] = 2347,
  [4414] = 2344,
  [4415] = 2349,
  [4416] = 2355,
  [4417] = 3021,
  [4418] = 2922,
  [4419] = 2921,
  [4420] = 2956,
  [4421] = 3045,
  [4422] = 2303,
  [4423] = 2305,
  [4424] = 2861,
  [4425] = 2862,
  [4426] = 2870,
  [4427] = 2871,
  [4428] = 2340,
  [4429] = 2976,
  [4430] = 2882,
  [4431] = 2885,
  [4432] = 3017,
  [4433] = 2888,
  [4434] = 2896,
  [4435] = 2897,
  [4436] = 2898,
  [4437] = 2900,
  [4438] = 2901,
  [4439] = 2904,
  [4440] = 2966,
  [4441] = 2924,
  [4442] = 2952,
  [4443] = 2907,
  [4444] = 2315,
  [4445] = 2912,
  [4446] = 2906,
  [4447] = 2313,
  [4448] = 2914,
  [4449] = 2881,
  [4450] = 2880,
  [4451] = 2941,
  [4452] = 2306,
  [4453] = 2351,
  [4454] = 2516,
  [4455] = 2943,
  [4456] = 2954,
  [4457] = 2959,
  [4458] = 2965,
  [4459] = 2970,
  [4460] = 2971,
  [4461] = 2972,
  [4462] = 2974,
  [4463] = 2977,
  [4464] = 2981,
  [4465] = 2987,
  [4466] = 2989,
  [4467] = 2990,
  [4468] = 2995,
  [4469] = 2999,
  [4470] = 3000,
  [4471] = 3001,
  [4472] = 3002,
  [4473] = 3003,
  [4474] = 3004,
  [4475] = 3005,
  [4476] = 3006,
  [4477] = 3010,
  [4478] = 3012,
  [4479] = 2334,
  [4480] = 2306,
  [4481] = 2963,
  [4482] = 2314,
  [4483] = 3013,
  [4484] = 3014,
  [4485] = 3016,
  [4486] = 3018,
  [4487] = 3024,
  [4488] = 3025,
  [4489] = 3026,
  [4490] = 2925,
  [4491] = 3028,
  [4492] = 3029,
  [4493] = 3030,
  [4494] = 3031,
  [4495] = 3032,
  [4496] = 3034,
  [4497] = 3035,
  [4498] = 3036,
  [4499] = 3037,
  [4500] = 2968,
  [4501] = 2973,
  [4502] = 3040,
  [4503] = 2975,
  [4504] = 3051,
  [4505] = 3042,
  [4506] = 3027,
  [4507] = 3023,
  [4508] = 3019,
  [4509] = 3009,
  [4510] = 2998,
  [4511] = 2997,
  [4512] = 2996,
  [4513] = 2991,
  [4514] = 2976,
  [4515] = 2991,
  [4516] = 2878,
  [4517] = 2311,
  [4518] = 2313,
  [4519] = 2877,
  [4520] = 2311,
  [4521] = 2310,
  [4522] = 2309,
  [4523] = 2303,
  [4524] = 2313,
  [4525] = 2875,
  [4526] = 2860,
  [4527] = 2859,
  [4528] = 2858,
  [4529] = 2850,
  [4530] = 2849,
  [4531] = 2306,
  [4532] = 2848,
  [4533] = 2310,
  [4534] = 2845,
  [4535] = 3049,
  [4536] = 2316,
  [4537] = 2908,
  [4538] = 3033,
  [4539] = 2921,
  [4540] = 2975,
  [4541] = 3045,
  [4542] = 2973,
  [4543] = 2968,
  [4544] = 2963,
  [4545] = 2954,
  [4546] = 3011,
  [4547] = 2466,
  [4548] = 2316,
  [4549] = 2943,
  [4550] = 2332,
  [4551] = 2351,
  [4552] = 2841,
  [4553] = 2993,
  [4554] = 2941,
  [4555] = 2914,
  [4556] = 2912,
  [4557] = 2988,
  [4558] = 2986,
  [4559] = 2316,
  [4560] = 2985,
  [4561] = 2907,
  [4562] = 2904,
  [4563] = 2901,
  [4564] = 2900,
  [4565] = 2983,
  [4566] = 2898,
  [4567] = 2897,
  [4568] = 2982,
  [4569] = 2539,
  [4570] = 2546,
  [4571] = 2896,
  [4572] = 2888,
  [4573] = 2952,
  [4574] = 2333,
  [4575] = 2884,
  [4576] = 2885,
  [4577] = 2882,
  [4578] = 2980,
  [4579] = 2871,
  [4580] = 2959,
  [4581] = 2965,
  [4582] = 2970,
  [4583] = 2870,
  [4584] = 2862,
  [4585] = 2861,
  [4586] = 3045,
  [4587] = 2956,
  [4588] = 2338,
  [4589] = 2922,
  [4590] = 2971,
  [4591] = 2972,
  [4592] = 2928,
  [4593] = 2929,
  [4594] = 2931,
  [4595] = 2974,
  [4596] = 2977,
  [4597] = 2318,
  [4598] = 2981,
  [4599] = 2987,
  [4600] = 2339,
  [4601] = 2989,
  [4602] = 2990,
  [4603] = 2322,
  [4604] = 2321,
  [4605] = 2995,
  [4606] = 2999,
  [4607] = 2957,
  [4608] = 2840,
  [4609] = 2951,
  [4610] = 2354,
  [4611] = 2950,
  [4612] = 2938,
  [4613] = 2937,
  [4614] = 2359,
  [4615] = 3000,
  [4616] = 3001,
  [4617] = 2358,
  [4618] = 2935,
  [4619] = 2328,
  [4620] = 3002,
  [4621] = 2589,
  [4622] = 3003,
  [4623] = 2927,
  [4624] = 2926,
  [4625] = 2994,
  [4626] = 2913,
  [4627] = 2894,
  [4628] = 2890,
  [4629] = 3004,
  [4630] = 3005,
  [4631] = 2889,
  [4632] = 3006,
  [4633] = 3010,
  [4634] = 3012,
  [4635] = 2323,
  [4636] = 2347,
  [4637] = 2349,
  [4638] = 3013,
  [4639] = 2355,
  [4640] = 2349,
  [4641] = 2355,
  [4642] = 3014,
  [4643] = 2358,
  [4644] = 3016,
  [4645] = 2347,
  [4646] = 2323,
  [4647] = 2328,
  [4648] = 2844,
  [4649] = 3018,
  [4650] = 4174,
  [4651] = 2320,
  [4652] = 2327,
  [4653] = 2335,
  [4654] = 2337,
  [4655] = 2302,
  [4656] = 3024,
  [4657] = 2341,
  [4658] = 2945,
  [4659] = 3025,
  [4660] = 2946,
  [4661] = 2307,
  [4662] = 2321,
  [4663] = 2322,
  [4664] = 3026,
  [4665] = 2948,
  [4666] = 2925,
  [4667] = 2342,
  [4668] = 2962,
  [4669] = 2353,
  [4670] = 3015,
  [4671] = 3021,
  [4672] = 2352,
  [4673] = 2350,
  [4674] = 2348,
  [4675] = 3028,
  [4676] = 3029,
  [4677] = 2996,
  [4678] = 2997,
  [4679] = 2312,
  [4680] = 3030,
  [4681] = 3031,
  [4682] = 3032,
  [4683] = 2884,
  [4684] = 3034,
  [4685] = 3035,
  [4686] = 3036,
  [4687] = 3037,
  [4688] = 3040,
  [4689] = 2998,
  [4690] = 2318,
  [4691] = 3009,
  [4692] = 2308,
  [4693] = 2333,
  [4694] = 2336,
  [4695] = 2346,
  [4696] = 3019,
  [4697] = 3017,
  [4698] = 2345,
  [4699] = 3023,
  [4700] = 3027,
  [4701] = 3051,
  [4702] = 3042,
  [4703] = 3027,
  [4704] = 3023,
  [4705] = 2966,
  [4706] = 2924,
  [4707] = 2332,
  [4708] = 2906,
  [4709] = 2881,
  [4710] = 2880,
  [4711] = 3019,
  [4712] = 2309,
  [4713] = 3009,
  [4714] = 2998,
  [4715] = 2997,
  [4716] = 2310,
  [4717] = 2996,
  [4718] = 2991,
  [4719] = 2976,
  [4720] = 2975,
  [4721] = 2973,
  [4722] = 2968,
  [4723] = 2963,
  [4724] = 3042,
  [4725] = 3051,
  [4726] = 2878,
  [4727] = 2954,
  [4728] = 3040,
  [4729] = 2943,
  [4730] = 2941,
  [4731] = 2914,
  [4732] = 2912,
  [4733] = 2907,
  [4734] = 2904,
  [4735] = 2901,
  [4736] = 2877,
  [4737] = 2875,
  [4738] = 2860,
  [4739] = 2859,
  [4740] = 2858,
  [4741] = 2850,
  [4742] = 2900,
  [4743] = 2898,
  [4744] = 3036,
  [4745] = 2897,
  [4746] = 2896,
  [4747] = 3035,
  [4748] = 2962,
  [4749] = 3032,
  [4750] = 3031,
  [4751] = 3030,
  [4752] = 3029,
  [4753] = 2888,
  [4754] = 2885,
  [4755] = 2882,
  [4756] = 2871,
  [4757] = 3028,
  [4758] = 2849,
  [4759] = 2848,
  [4760] = 2845,
  [4761] = 2925,
  [4762] = 2870,
  [4763] = 3026,
  [4764] = 2862,
  [4765] = 3025,
  [4766] = 2861,
  [4767] = 3024,
  [4768] = 2956,
  [4769] = 2921,
  [4770] = 3049,
  [4771] = 2908,
  [4772] = 3033,
  [4773] = 2922,
  [4774] = 2334,
  [4775] = 3018,
  [4776] = 2928,
  [4777] = 2929,
  [4778] = 3016,
  [4779] = 2931,
  [4780] = 3014,
  [4781] = 2957,
  [4782] = 2840,
  [4783] = 3013,
  [4784] = 3012,
  [4785] = 2980,
  [4786] = 2982,
  [4787] = 2983,
  [4788] = 2985,
  [4789] = 2986,
  [4790] = 2988,
  [4791] = 2993,
  [4792] = 2841,
  [4793] = 3011,
  [4794] = 3017,
  [4795] = 3033,
  [4796] = 2908,
  [4797] = 3049,
  [4798] = 3037,
  [4799] = 3011,
  [4800] = 2845,
  [4801] = 2841,
  [4802] = 2848,
  [4803] = 2993,
  [4804] = 2988,
  [4805] = 2849,
  [4806] = 2986,
  [4807] = 2850,
  [4808] = 2985,
  [4809] = 3010,
  [4810] = 2983,
  [4811] = 2982,
  [4812] = 2980,
  [4813] = 2858,
  [4814] = 2859,
  [4815] = 2860,
  [4816] = 2875,
  [4817] = 2877,
  [4818] = 2878,
  [4819] = 2880,
  [4820] = 2881,
  [4821] = 2906,
  [4822] = 2924,
  [4823] = 2966,
  [4824] = 3006,
  [4825] = 2959,
  [4826] = 3021,
  [4827] = 3015,
  [4828] = 2965,
  [4829] = 2970,
  [4830] = 2971,
  [4831] = 2972,
  [4832] = 2948,
  [4833] = 2946,
  [4834] = 2945,
  [4835] = 2974,
  [4836] = 2977,
  [4837] = 3005,
  [4838] = 2981,
  [4839] = 2844,
  [4840] = 2344,
  [4841] = 2343,
  [4842] = 3004,
  [4843] = 2889,
  [4844] = 2987,
  [4845] = 2989,
  [4846] = 2990,
  [4847] = 2890,
  [4848] = 2894,
  [4849] = 2995,
  [4850] = 2913,
  [4851] = 2994,
  [4852] = 2927,
  [4853] = 2935,
  [4854] = 2999,
  [4855] = 2311,
  [4856] = 2937,
  [4857] = 2938,
  [4858] = 2950,
  [4859] = 3000,
  [4860] = 3003,
  [4861] = 3001,
  [4862] = 2951,
  [4863] = 3002,
  [4864] = 2315,
  [4865] = 2316,
  [4866] = 2959,
  [4867] = 2334,
  [4868] = 2326,
  [4869] = 3025,
  [4870] = 2965,
  [4871] = 2970,
  [4872] = 2971,
  [4873] = 2972,
  [4874] = 2974,
  [4875] = 2977,
  [4876] = 2981,
  [4877] = 2320,
  [4878] = 2344,
  [4879] = 2327,
  [4880] = 2335,
  [4881] = 2337,
  [4882] = 2338,
  [4883] = 2314,
  [4884] = 2311,
  [4885] = 2341,
  [4886] = 2342,
  [4887] = 2353,
  [4888] = 2312,
  [4889] = 2308,
  [4890] = 2352,
  [4891] = 2350,
  [4892] = 2348,
  [4893] = 2987,
  [4894] = 2989,
  [4895] = 2990,
  [4896] = 2995,
  [4897] = 2999,
  [4898] = 3000,
  [4899] = 2351,
  [4900] = 3001,
  [4901] = 2336,
  [4902] = 2346,
  [4903] = 2302,
  [4904] = 3002,
  [4905] = 3003,
  [4906] = 3004,
  [4907] = 2345,
  [4908] = 3005,
  [4909] = 3006,
  [4910] = 3010,
  [4911] = 3012,
  [4912] = 3013,
  [4913] = 3014,
  [4914] = 3016,
  [4915] = 3018,
  [4916] = 3024,
  [4917] = 2334,
  [4918] = 3026,
  [4919] = 2925,
  [4920] = 3028,
  [4921] = 3029,
  [4922] = 3030,
  [4923] = 3031,
  [4924] = 3032,
  [4925] = 3034,
  [4926] = 3035,
  [4927] = 3036,
  [4928] = 3037,
  [4929] = 3040,
  [4930] = 2324,
  [4931] = 2308,
  [4932] = 2312,
  [4933] = 2319,
  [4934] = 3051,
  [4935] = 3042,
  [4936] = 3027,
  [4937] = 3023,
  [4938] = 3019,
  [4939] = 3009,
  [4940] = 2998,
  [4941] = 2324,
  [4942] = 2319,
  [4943] = 2997,
  [4944] = 2314,
  [4945] = 2325,
  [4946] = 2315,
  [4947] = 2996,
  [4948] = 2991,
  [4949] = 2976,
  [4950] = 2975,
  [4951] = 2973,
  [4952] = 2331,
  [4953] = 2968,
  [4954] = 2963,
  [4955] = 2954,
  [4956] = 2943,
  [4957] = 2941,
  [4958] = 2914,
  [4959] = 2912,
  [4960] = 2325,
  [4961] = 2331,
  [4962] = 2351,
  [4963] = 2343,
  [4964] = 2907,
  [4965] = 2904,
  [4966] = 2332,
  [4967] = 2305,
  [4968] = 2340,
  [4969] = 2326,
  [4970] = 2901,
  [4971] = 2900,
  [4972] = 2898,
  [4973] = 2897,
  [4974] = 2896,
  [4975] = 2333,
  [4976] = 2888,
  [4977] = 2885,
  [4978] = 2358,
  [4979] = 2305,
  [4980] = 2340,
  [4981] = 2355,
  [4982] = 2882,
  [4983] = 2871,
  [4984] = 2870,
  [4985] = 2862,
  [4986] = 2861,
  [4987] = 3045,
  [4988] = 2935,
  [4989] = 2956,
  [4990] = 2921,
  [4991] = 2922,
  [4992] = 2349,
  [4993] = 2928,
  [4994] = 2347,
  [4995] = 2929,
  [4996] = 2931,
  [4997] = 2957,
  [4998] = 2840,
  [4999] = 2951,
  [5000] = 2950,
  [5001] = 2938,
  [5002] = 2937,
  [5003] = 2844,
  [5004] = 2927,
  [5005] = 2994,
  [5006] = 2913,
  [5007] = 2894,
  [5008] = 2890,
  [5009] = 2889,
  [5010] = 2988,
  [5011] = 2242,
  [5012] = 2241,
  [5013] = 2945,
  [5014] = 2323,
  [5015] = 2345,
  [5016] = 2946,
  [5017] = 2948,
  [5018] = 2962,
  [5019] = 2306,
  [5020] = 3015,
  [5021] = 3021,
  [5022] = 2966,
  [5023] = 2302,
  [5024] = 2346,
  [5025] = 2336,
  [5026] = 2924,
  [5027] = 2906,
  [5028] = 2881,
  [5029] = 2880,
  [5030] = 2878,
  [5031] = 2877,
  [5032] = 2884,
  [5033] = 2348,
  [5034] = 2350,
  [5035] = 2352,
  [5036] = 2353,
  [5037] = 2875,
  [5038] = 2342,
  [5039] = 2341,
  [5040] = 2860,
  [5041] = 2338,
  [5042] = 2337,
  [5043] = 2859,
  [5044] = 2335,
  [5045] = 2858,
  [5046] = 2327,
  [5047] = 2307,
  [5048] = 2850,
  [5049] = 2320,
  [5050] = 2849,
  [5051] = 2848,
  [5052] = 2310,
  [5053] = 2845,
  [5054] = 3049,
  [5055] = 2908,
  [5056] = 3033,
  [5057] = 2303,
  [5058] = 2313,
  [5059] = 3017,
  [5060] = 3011,
  [5061] = 2841,
  [5062] = 2993,
  [5063] = 2986,
  [5064] = 2328,
  [5065] = 2985,
  [5066] = 2983,
  [5067] = 2982,
  [5068] = 2952,
  [5069] = 2980,
  [5070] = 2321,
  [5071] = 2322,
  [5072] = 2359,
  [5073] = 2354,
  [5074] = 2311,
  [5075] = 2306,
  [5076] = 2310,
  [5077] = 2309,
  [5078] = 2343,
  [5079] = 2313,
  [5080] = 2344,
  [5081] = 2303,
  [5082] = 2354,
  [5083] = 2339,
  [5084] = 2318,
  [5085] = 2316,
  [5086] = 2926,
  [5087] = 5087,
  [5088] = 2339,
  [5089] = 2359,
  [5090] = 2358,
  [5091] = 2355,
  [5092] = 2349,
  [5093] = 5093,
  [5094] = 2347,
  [5095] = 2323,
  [5096] = 2309,
  [5097] = 2332,
  [5098] = 2328,
  [5099] = 2307,
  [5100] = 2318,
  [5101] = 2322,
  [5102] = 2321,
  [5103] = 2333,
  [5104] = 2986,
  [5105] = 2906,
  [5106] = 2982,
  [5107] = 2941,
  [5108] = 2943,
  [5109] = 2954,
  [5110] = 2983,
  [5111] = 3028,
  [5112] = 2925,
  [5113] = 3026,
  [5114] = 3025,
  [5115] = 2990,
  [5116] = 2989,
  [5117] = 2931,
  [5118] = 2959,
  [5119] = 2985,
  [5120] = 2986,
  [5121] = 2988,
  [5122] = 2993,
  [5123] = 2841,
  [5124] = 3011,
  [5125] = 3017,
  [5126] = 3033,
  [5127] = 2956,
  [5128] = 2242,
  [5129] = 2908,
  [5130] = 3049,
  [5131] = 2845,
  [5132] = 2848,
  [5133] = 2849,
  [5134] = 2850,
  [5135] = 2241,
  [5136] = 2858,
  [5137] = 2859,
  [5138] = 2860,
  [5139] = 2875,
  [5140] = 2877,
  [5141] = 2878,
  [5142] = 2880,
  [5143] = 2881,
  [5144] = 2906,
  [5145] = 2924,
  [5146] = 2966,
  [5147] = 5147,
  [5148] = 2980,
  [5149] = 2965,
  [5150] = 2970,
  [5151] = 2971,
  [5152] = 2972,
  [5153] = 2974,
  [5154] = 2977,
  [5155] = 2981,
  [5156] = 2987,
  [5157] = 2995,
  [5158] = 2999,
  [5159] = 3000,
  [5160] = 3001,
  [5161] = 3002,
  [5162] = 2994,
  [5163] = 3003,
  [5164] = 3004,
  [5165] = 3005,
  [5166] = 2912,
  [5167] = 3006,
  [5168] = 3010,
  [5169] = 2962,
  [5170] = 2926,
  [5171] = 3012,
  [5172] = 3013,
  [5173] = 3014,
  [5174] = 2948,
  [5175] = 2946,
  [5176] = 3016,
  [5177] = 2945,
  [5178] = 2959,
  [5179] = 2965,
  [5180] = 3024,
  [5181] = 2844,
  [5182] = 3029,
  [5183] = 2970,
  [5184] = 2971,
  [5185] = 2972,
  [5186] = 2974,
  [5187] = 2977,
  [5188] = 2981,
  [5189] = 2987,
  [5190] = 3030,
  [5191] = 3031,
  [5192] = 2995,
  [5193] = 3032,
  [5194] = 3034,
  [5195] = 3035,
  [5196] = 2999,
  [5197] = 3000,
  [5198] = 3001,
  [5199] = 3002,
  [5200] = 3003,
  [5201] = 3004,
  [5202] = 3005,
  [5203] = 3006,
  [5204] = 3010,
  [5205] = 3012,
  [5206] = 3036,
  [5207] = 3013,
  [5208] = 2889,
  [5209] = 3014,
  [5210] = 3016,
  [5211] = 3018,
  [5212] = 3024,
  [5213] = 2890,
  [5214] = 2894,
  [5215] = 3037,
  [5216] = 2994,
  [5217] = 3029,
  [5218] = 3030,
  [5219] = 3031,
  [5220] = 3032,
  [5221] = 3034,
  [5222] = 3035,
  [5223] = 3036,
  [5224] = 3037,
  [5225] = 3040,
  [5226] = 2926,
  [5227] = 3051,
  [5228] = 3042,
  [5229] = 3027,
  [5230] = 3023,
  [5231] = 3019,
  [5232] = 3009,
  [5233] = 2998,
  [5234] = 2927,
  [5235] = 2997,
  [5236] = 2996,
  [5237] = 2991,
  [5238] = 2976,
  [5239] = 2975,
  [5240] = 2973,
  [5241] = 2913,
  [5242] = 2968,
  [5243] = 2963,
  [5244] = 3040,
  [5245] = 3051,
  [5246] = 3042,
  [5247] = 2914,
  [5248] = 3027,
  [5249] = 2937,
  [5250] = 2938,
  [5251] = 2950,
  [5252] = 2951,
  [5253] = 2840,
  [5254] = 2907,
  [5255] = 3023,
  [5256] = 2904,
  [5257] = 2901,
  [5258] = 2900,
  [5259] = 2898,
  [5260] = 2897,
  [5261] = 2896,
  [5262] = 2888,
  [5263] = 2957,
  [5264] = 2885,
  [5265] = 2935,
  [5266] = 2882,
  [5267] = 2871,
  [5268] = 2870,
  [5269] = 2862,
  [5270] = 2861,
  [5271] = 3019,
  [5272] = 3009,
  [5273] = 2998,
  [5274] = 3045,
  [5275] = 2931,
  [5276] = 2929,
  [5277] = 2921,
  [5278] = 2928,
  [5279] = 2922,
  [5280] = 2928,
  [5281] = 2929,
  [5282] = 2931,
  [5283] = 2922,
  [5284] = 2921,
  [5285] = 2997,
  [5286] = 2996,
  [5287] = 2957,
  [5288] = 2840,
  [5289] = 2951,
  [5290] = 2950,
  [5291] = 2938,
  [5292] = 2937,
  [5293] = 2956,
  [5294] = 2861,
  [5295] = 2862,
  [5296] = 2935,
  [5297] = 2870,
  [5298] = 2927,
  [5299] = 2871,
  [5300] = 2913,
  [5301] = 2894,
  [5302] = 2890,
  [5303] = 2889,
  [5304] = 2882,
  [5305] = 2885,
  [5306] = 2888,
  [5307] = 2896,
  [5308] = 2897,
  [5309] = 2898,
  [5310] = 2900,
  [5311] = 2901,
  [5312] = 2904,
  [5313] = 2907,
  [5314] = 3045,
  [5315] = 2952,
  [5316] = 2844,
  [5317] = 2991,
  [5318] = 2976,
  [5319] = 2912,
  [5320] = 2914,
  [5321] = 3018,
  [5322] = 2943,
  [5323] = 2954,
  [5324] = 2963,
  [5325] = 2968,
  [5326] = 2973,
  [5327] = 2975,
  [5328] = 2976,
  [5329] = 2945,
  [5330] = 2946,
  [5331] = 2991,
  [5332] = 2996,
  [5333] = 2948,
  [5334] = 2962,
  [5335] = 3015,
  [5336] = 3021,
  [5337] = 2997,
  [5338] = 2998,
  [5339] = 2941,
  [5340] = 3009,
  [5341] = 3023,
  [5342] = 3027,
  [5343] = 3042,
  [5344] = 3051,
  [5345] = 3040,
  [5346] = 3037,
  [5347] = 3036,
  [5348] = 3035,
  [5349] = 3034,
  [5350] = 3032,
  [5351] = 3031,
  [5352] = 3030,
  [5353] = 3029,
  [5354] = 3019,
  [5355] = 3028,
  [5356] = 2994,
  [5357] = 2237,
  [5358] = 2925,
  [5359] = 2966,
  [5360] = 2924,
  [5361] = 3026,
  [5362] = 2906,
  [5363] = 2881,
  [5364] = 2880,
  [5365] = 2878,
  [5366] = 2877,
  [5367] = 2875,
  [5368] = 2860,
  [5369] = 2859,
  [5370] = 2858,
  [5371] = 2850,
  [5372] = 2849,
  [5373] = 2848,
  [5374] = 2845,
  [5375] = 2884,
  [5376] = 3049,
  [5377] = 2908,
  [5378] = 3033,
  [5379] = 3017,
  [5380] = 3011,
  [5381] = 2841,
  [5382] = 2993,
  [5383] = 2988,
  [5384] = 3025,
  [5385] = 2985,
  [5386] = 2983,
  [5387] = 2982,
  [5388] = 2980,
  [5389] = 3024,
  [5390] = 3018,
  [5391] = 3016,
  [5392] = 3014,
  [5393] = 3013,
  [5394] = 3012,
  [5395] = 5147,
  [5396] = 3006,
  [5397] = 3005,
  [5398] = 3004,
  [5399] = 3003,
  [5400] = 3002,
  [5401] = 3001,
  [5402] = 3000,
  [5403] = 2999,
  [5404] = 2995,
  [5405] = 5147,
  [5406] = 2990,
  [5407] = 2973,
  [5408] = 2989,
  [5409] = 2987,
  [5410] = 3010,
  [5411] = 2977,
  [5412] = 2974,
  [5413] = 2972,
  [5414] = 2971,
  [5415] = 2970,
  [5416] = 2965,
  [5417] = 2959,
  [5418] = 5147,
  [5419] = 2981,
  [5420] = 2241,
  [5421] = 2968,
  [5422] = 2963,
  [5423] = 2914,
  [5424] = 2912,
  [5425] = 2907,
  [5426] = 5147,
  [5427] = 2904,
  [5428] = 2901,
  [5429] = 2900,
  [5430] = 2898,
  [5431] = 2897,
  [5432] = 2896,
  [5433] = 2888,
  [5434] = 2885,
  [5435] = 2882,
  [5436] = 2871,
  [5437] = 2870,
  [5438] = 2862,
  [5439] = 2861,
  [5440] = 3045,
  [5441] = 2237,
  [5442] = 2921,
  [5443] = 2922,
  [5444] = 2928,
  [5445] = 2975,
  [5446] = 2244,
  [5447] = 3021,
  [5448] = 3015,
  [5449] = 2236,
  [5450] = 2937,
  [5451] = 2957,
  [5452] = 2840,
  [5453] = 2951,
  [5454] = 2950,
  [5455] = 2938,
  [5456] = 2875,
  [5457] = 2952,
  [5458] = 2935,
  [5459] = 2927,
  [5460] = 2913,
  [5461] = 2894,
  [5462] = 2890,
  [5463] = 2889,
  [5464] = 2956,
  [5465] = 2844,
  [5466] = 2945,
  [5467] = 2236,
  [5468] = 2929,
  [5469] = 2948,
  [5470] = 2884,
  [5471] = 2962,
  [5472] = 2966,
  [5473] = 2924,
  [5474] = 2881,
  [5475] = 2880,
  [5476] = 2878,
  [5477] = 2877,
  [5478] = 2860,
  [5479] = 2859,
  [5480] = 2858,
  [5481] = 2850,
  [5482] = 2849,
  [5483] = 2946,
  [5484] = 2845,
  [5485] = 3049,
  [5486] = 2908,
  [5487] = 3033,
  [5488] = 3017,
  [5489] = 3011,
  [5490] = 2941,
  [5491] = 2943,
  [5492] = 2884,
  [5493] = 2954,
  [5494] = 2841,
  [5495] = 2926,
  [5496] = 2516,
  [5497] = 2993,
  [5498] = 2988,
  [5499] = 2986,
  [5500] = 5147,
  [5501] = 2985,
  [5502] = 2983,
  [5503] = 2982,
  [5504] = 2952,
  [5505] = 2980,
  [5506] = 3028,
  [5507] = 2925,
  [5508] = 3026,
  [5509] = 3025,
  [5510] = 2990,
  [5511] = 2989,
  [5512] = 2848,
  [5513] = 2244,
  [5514] = 3021,
  [5515] = 3015,
  [5516] = 3040,
  [5517] = 2244,
  [5518] = 2948,
  [5519] = 2962,
  [5520] = 2945,
  [5521] = 3021,
  [5522] = 3015,
  [5523] = 2860,
  [5524] = 3003,
  [5525] = 3002,
  [5526] = 2882,
  [5527] = 2975,
  [5528] = 2973,
  [5529] = 2968,
  [5530] = 2963,
  [5531] = 3001,
  [5532] = 3000,
  [5533] = 2999,
  [5534] = 2991,
  [5535] = 2966,
  [5536] = 2924,
  [5537] = 2884,
  [5538] = 2906,
  [5539] = 2881,
  [5540] = 2880,
  [5541] = 2241,
  [5542] = 2996,
  [5543] = 2878,
  [5544] = 2997,
  [5545] = 2877,
  [5546] = 2995,
  [5547] = 2875,
  [5548] = 2998,
  [5549] = 3009,
  [5550] = 2236,
  [5551] = 2926,
  [5552] = 2241,
  [5553] = 2844,
  [5554] = 2859,
  [5555] = 2858,
  [5556] = 2914,
  [5557] = 2912,
  [5558] = 2237,
  [5559] = 2850,
  [5560] = 3019,
  [5561] = 3023,
  [5562] = 2849,
  [5563] = 2848,
  [5564] = 2845,
  [5565] = 3049,
  [5566] = 2908,
  [5567] = 2871,
  [5568] = 3033,
  [5569] = 2956,
  [5570] = 3017,
  [5571] = 3011,
  [5572] = 2841,
  [5573] = 2907,
  [5574] = 2236,
  [5575] = 2242,
  [5576] = 2993,
  [5577] = 2987,
  [5578] = 2988,
  [5579] = 2986,
  [5580] = 3004,
  [5581] = 2904,
  [5582] = 2985,
  [5583] = 2983,
  [5584] = 2982,
  [5585] = 2241,
  [5586] = 2980,
  [5587] = 2901,
  [5588] = 2900,
  [5589] = 2237,
  [5590] = 2237,
  [5591] = 3051,
  [5592] = 2244,
  [5593] = 2989,
  [5594] = 2241,
  [5595] = 2870,
  [5596] = 2990,
  [5597] = 3025,
  [5598] = 2237,
  [5599] = 3026,
  [5600] = 2925,
  [5601] = 3028,
  [5602] = 2236,
  [5603] = 2954,
  [5604] = 2943,
  [5605] = 2941,
  [5606] = 3042,
  [5607] = 2946,
  [5608] = 3027,
  [5609] = 2889,
  [5610] = 2890,
  [5611] = 3037,
  [5612] = 2894,
  [5613] = 2913,
  [5614] = 2927,
  [5615] = 2935,
  [5616] = 3036,
  [5617] = 2981,
  [5618] = 2242,
  [5619] = 2977,
  [5620] = 2994,
  [5621] = 3035,
  [5622] = 2244,
  [5623] = 2937,
  [5624] = 2974,
  [5625] = 2938,
  [5626] = 2244,
  [5627] = 2236,
  [5628] = 3032,
  [5629] = 2950,
  [5630] = 2885,
  [5631] = 3005,
  [5632] = 2237,
  [5633] = 2244,
  [5634] = 2244,
  [5635] = 2236,
  [5636] = 2951,
  [5637] = 2840,
  [5638] = 2241,
  [5639] = 2957,
  [5640] = 2931,
  [5641] = 2862,
  [5642] = 2952,
  [5643] = 3031,
  [5644] = 3030,
  [5645] = 2236,
  [5646] = 2929,
  [5647] = 3006,
  [5648] = 2928,
  [5649] = 3029,
  [5650] = 3024,
  [5651] = 3034,
  [5652] = 2922,
  [5653] = 2237,
  [5654] = 2972,
  [5655] = 2888,
  [5656] = 3018,
  [5657] = 3016,
  [5658] = 3010,
  [5659] = 3014,
  [5660] = 2898,
  [5661] = 3013,
  [5662] = 2921,
  [5663] = 2897,
  [5664] = 2976,
  [5665] = 2241,
  [5666] = 2242,
  [5667] = 3012,
  [5668] = 2959,
  [5669] = 2965,
  [5670] = 2970,
  [5671] = 2896,
  [5672] = 3045,
  [5673] = 2971,
  [5674] = 2861,
  [5675] = 5675,
  [5676] = 2236,
  [5677] = 5677,
  [5678] = 2237,
  [5679] = 4174,
  [5680] = 5680,
  [5681] = 5681,
  [5682] = 2244,
  [5683] = 2241,
  [5684] = 2244,
  [5685] = 2236,
  [5686] = 2241,
  [5687] = 2237,
  [5688] = 2237,
  [5689] = 2244,
  [5690] = 2244,
  [5691] = 2236,
  [5692] = 2241,
  [5693] = 2241,
  [5694] = 2237,
  [5695] = 2242,
  [5696] = 2242,
  [5697] = 2236,
  [5698] = 5698,
  [5699] = 2237,
  [5700] = 5700,
  [5701] = 2244,
  [5702] = 2236,
  [5703] = 2244,
  [5704] = 2236,
  [5705] = 5705,
  [5706] = 2237,
  [5707] = 2236,
  [5708] = 5708,
  [5709] = 5709,
  [5710] = 5710,
  [5711] = 5711,
  [5712] = 5712,
  [5713] = 2236,
  [5714] = 5714,
  [5715] = 5715,
  [5716] = 2242,
  [5717] = 5717,
  [5718] = 5718,
  [5719] = 5719,
  [5720] = 5720,
  [5721] = 2318,
  [5722] = 2358,
  [5723] = 2237,
  [5724] = 2244,
  [5725] = 2359,
  [5726] = 2303,
  [5727] = 2313,
  [5728] = 2334,
  [5729] = 2241,
  [5730] = 5730,
  [5731] = 2241,
  [5732] = 2241,
  [5733] = 2237,
  [5734] = 2307,
  [5735] = 2242,
  [5736] = 2241,
  [5737] = 2306,
  [5738] = 2236,
  [5739] = 2241,
  [5740] = 2244,
  [5741] = 2309,
  [5742] = 5742,
  [5743] = 2349,
  [5744] = 2310,
  [5745] = 2244,
  [5746] = 2311,
  [5747] = 2241,
  [5748] = 2236,
  [5749] = 2244,
  [5750] = 2354,
  [5751] = 5751,
  [5752] = 2236,
  [5753] = 5753,
  [5754] = 2237,
  [5755] = 5755,
  [5756] = 2236,
  [5757] = 2241,
  [5758] = 2237,
  [5759] = 2237,
  [5760] = 2244,
  [5761] = 2237,
  [5762] = 2244,
  [5763] = 2236,
  [5764] = 2236,
  [5765] = 2884,
  [5766] = 2322,
  [5767] = 5767,
  [5768] = 5768,
  [5769] = 2321,
  [5770] = 5770,
  [5771] = 2244,
  [5772] = 5772,
  [5773] = 2241,
  [5774] = 2333,
  [5775] = 2237,
  [5776] = 5776,
  [5777] = 5777,
  [5778] = 2241,
  [5779] = 2236,
  [5780] = 5780,
  [5781] = 5781,
  [5782] = 2236,
  [5783] = 2237,
  [5784] = 5784,
  [5785] = 5785,
  [5786] = 5786,
  [5787] = 2241,
  [5788] = 5788,
  [5789] = 2339,
  [5790] = 5790,
  [5791] = 5791,
  [5792] = 5792,
  [5793] = 5793,
  [5794] = 2244,
  [5795] = 2351,
  [5796] = 2237,
  [5797] = 2241,
  [5798] = 2328,
  [5799] = 2332,
  [5800] = 2323,
  [5801] = 2244,
  [5802] = 2347,
  [5803] = 2237,
  [5804] = 2242,
  [5805] = 2242,
  [5806] = 2241,
  [5807] = 2242,
  [5808] = 5808,
  [5809] = 2355,
  [5810] = 2244,
  [5811] = 2242,
  [5812] = 2337,
  [5813] = 2336,
  [5814] = 2307,
  [5815] = 2328,
  [5816] = 2323,
  [5817] = 2244,
  [5818] = 2322,
  [5819] = 2321,
  [5820] = 2347,
  [5821] = 2349,
  [5822] = 2355,
  [5823] = 2359,
  [5824] = 5093,
  [5825] = 2354,
  [5826] = 2339,
  [5827] = 2333,
  [5828] = 2237,
  [5829] = 2334,
  [5830] = 2331,
  [5831] = 2325,
  [5832] = 2319,
  [5833] = 2324,
  [5834] = 2332,
  [5835] = 5835,
  [5836] = 2351,
  [5837] = 2326,
  [5838] = 2358,
  [5839] = 2305,
  [5840] = 2315,
  [5841] = 2346,
  [5842] = 2306,
  [5843] = 2314,
  [5844] = 2312,
  [5845] = 2318,
  [5846] = 2241,
  [5847] = 2308,
  [5848] = 2313,
  [5849] = 4174,
  [5850] = 2303,
  [5851] = 2309,
  [5852] = 2310,
  [5853] = 2343,
  [5854] = 2345,
  [5855] = 2237,
  [5856] = 2316,
  [5857] = 2241,
  [5858] = 2340,
  [5859] = 2342,
  [5860] = 2353,
  [5861] = 2344,
  [5862] = 2352,
  [5863] = 2244,
  [5864] = 2350,
  [5865] = 2320,
  [5866] = 2327,
  [5867] = 2236,
  [5868] = 2236,
  [5869] = 2348,
  [5870] = 2311,
  [5871] = 2335,
  [5872] = 2302,
  [5873] = 2242,
  [5874] = 2338,
  [5875] = 2341,
  [5876] = 2306,
  [5877] = 2315,
  [5878] = 2244,
  [5879] = 2236,
  [5880] = 2332,
  [5881] = 2237,
  [5882] = 2244,
  [5883] = 2241,
  [5884] = 2302,
  [5885] = 2351,
  [5886] = 2336,
  [5887] = 2328,
  [5888] = 2310,
  [5889] = 2323,
  [5890] = 2347,
  [5891] = 2309,
  [5892] = 2316,
  [5893] = 2241,
  [5894] = 2348,
  [5895] = 2339,
  [5896] = 2349,
  [5897] = 2237,
  [5898] = 2244,
  [5899] = 2355,
  [5900] = 2350,
  [5901] = 2333,
  [5902] = 2318,
  [5903] = 2326,
  [5904] = 2303,
  [5905] = 2358,
  [5906] = 2343,
  [5907] = 2303,
  [5908] = 2311,
  [5909] = 2236,
  [5910] = 2358,
  [5911] = 2355,
  [5912] = 2352,
  [5913] = 2334,
  [5914] = 2313,
  [5915] = 2241,
  [5916] = 2313,
  [5917] = 2353,
  [5918] = 2322,
  [5919] = 2321,
  [5920] = 2324,
  [5921] = 2349,
  [5922] = 2333,
  [5923] = 2342,
  [5924] = 2319,
  [5925] = 2318,
  [5926] = 2334,
  [5927] = 2341,
  [5928] = 2338,
  [5929] = 2337,
  [5930] = 2316,
  [5931] = 2306,
  [5932] = 2332,
  [5933] = 2325,
  [5934] = 5093,
  [5935] = 2344,
  [5936] = 2306,
  [5937] = 2311,
  [5938] = 2335,
  [5939] = 2340,
  [5940] = 2331,
  [5941] = 2320,
  [5942] = 2327,
  [5943] = 2308,
  [5944] = 2335,
  [5945] = 2337,
  [5946] = 2338,
  [5947] = 2341,
  [5948] = 2342,
  [5949] = 2353,
  [5950] = 2352,
  [5951] = 2350,
  [5952] = 2348,
  [5953] = 2305,
  [5954] = 2354,
  [5955] = 2359,
  [5956] = 2303,
  [5957] = 2322,
  [5958] = 2327,
  [5959] = 2320,
  [5960] = 2242,
  [5961] = 5961,
  [5962] = 2307,
  [5963] = 2336,
  [5964] = 2346,
  [5965] = 2302,
  [5966] = 2305,
  [5967] = 2340,
  [5968] = 2339,
  [5969] = 2345,
  [5970] = 2315,
  [5971] = 2333,
  [5972] = 2328,
  [5973] = 2332,
  [5974] = 2323,
  [5975] = 2331,
  [5976] = 2343,
  [5977] = 2314,
  [5978] = 2354,
  [5979] = 2347,
  [5980] = 2244,
  [5981] = 2359,
  [5982] = 2344,
  [5983] = 2343,
  [5984] = 2325,
  [5985] = 2340,
  [5986] = 2237,
  [5987] = 2305,
  [5988] = 2320,
  [5989] = 2308,
  [5990] = 2312,
  [5991] = 2310,
  [5992] = 2309,
  [5993] = 2327,
  [5994] = 2314,
  [5995] = 2242,
  [5996] = 2315,
  [5997] = 2339,
  [5998] = 2319,
  [5999] = 2335,
  [6000] = 2324,
  [6001] = 2345,
  [6002] = 2337,
  [6003] = 2334,
  [6004] = 2338,
  [6005] = 2311,
  [6006] = 2341,
  [6007] = 2342,
  [6008] = 2353,
  [6009] = 2352,
  [6010] = 2350,
  [6011] = 2237,
  [6012] = 2326,
  [6013] = 2318,
  [6014] = 2348,
  [6015] = 2241,
  [6016] = 2349,
  [6017] = 2322,
  [6018] = 2321,
  [6019] = 2346,
  [6020] = 2313,
  [6021] = 2316,
  [6022] = 2354,
  [6023] = 2336,
  [6024] = 2346,
  [6025] = 2351,
  [6026] = 2236,
  [6027] = 2302,
  [6028] = 2331,
  [6029] = 5961,
  [6030] = 2345,
  [6031] = 5961,
  [6032] = 2326,
  [6033] = 2321,
  [6034] = 5961,
  [6035] = 2306,
  [6036] = 2307,
  [6037] = 2312,
  [6038] = 2355,
  [6039] = 2314,
  [6040] = 2334,
  [6041] = 2351,
  [6042] = 2312,
  [6043] = 2307,
  [6044] = 2308,
  [6045] = 2347,
  [6046] = 2325,
  [6047] = 2309,
  [6048] = 2328,
  [6049] = 2310,
  [6050] = 2358,
  [6051] = 2359,
  [6052] = 2324,
  [6053] = 2344,
  [6054] = 2323,
  [6055] = 2319,
  [6056] = 2236,
  [6057] = 5961,
  [6058] = 2328,
  [6059] = 2309,
  [6060] = 2307,
  [6061] = 2244,
  [6062] = 2310,
  [6063] = 2328,
  [6064] = 2352,
  [6065] = 2323,
  [6066] = 2340,
  [6067] = 2351,
  [6068] = 2305,
  [6069] = 2315,
  [6070] = 2325,
  [6071] = 2347,
  [6072] = 2314,
  [6073] = 2311,
  [6074] = 2303,
  [6075] = 2242,
  [6076] = 2241,
  [6077] = 2331,
  [6078] = 2355,
  [6079] = 2319,
  [6080] = 2312,
  [6081] = 2308,
  [6082] = 2242,
  [6083] = 2343,
  [6084] = 2324,
  [6085] = 2337,
  [6086] = 2307,
  [6087] = 2310,
  [6088] = 2349,
  [6089] = 2345,
  [6090] = 2302,
  [6091] = 2346,
  [6092] = 2336,
  [6093] = 2241,
  [6094] = 2244,
  [6095] = 2331,
  [6096] = 2316,
  [6097] = 2236,
  [6098] = 2241,
  [6099] = 2344,
  [6100] = 2335,
  [6101] = 2355,
  [6102] = 2349,
  [6103] = 2358,
  [6104] = 2237,
  [6105] = 2325,
  [6106] = 2339,
  [6107] = 2305,
  [6108] = 2319,
  [6109] = 2306,
  [6110] = 2340,
  [6111] = 2242,
  [6112] = 2348,
  [6113] = 2237,
  [6114] = 2241,
  [6115] = 2324,
  [6116] = 2350,
  [6117] = 2313,
  [6118] = 2353,
  [6119] = 2326,
  [6120] = 2342,
  [6121] = 2351,
  [6122] = 2341,
  [6123] = 2338,
  [6124] = 2316,
  [6125] = 2318,
  [6126] = 2354,
  [6127] = 2339,
  [6128] = 2318,
  [6129] = 2327,
  [6130] = 2320,
  [6131] = 2320,
  [6132] = 2327,
  [6133] = 2358,
  [6134] = 2335,
  [6135] = 2337,
  [6136] = 2338,
  [6137] = 2341,
  [6138] = 2342,
  [6139] = 2353,
  [6140] = 2352,
  [6141] = 2350,
  [6142] = 2348,
  [6143] = 2359,
  [6144] = 2311,
  [6145] = 2303,
  [6146] = 2326,
  [6147] = 2344,
  [6148] = 2236,
  [6149] = 2244,
  [6150] = 2236,
  [6151] = 2336,
  [6152] = 2346,
  [6153] = 2302,
  [6154] = 2345,
  [6155] = 2236,
  [6156] = 2332,
  [6157] = 2322,
  [6158] = 2359,
  [6159] = 2354,
  [6160] = 2321,
  [6161] = 2333,
  [6162] = 6162,
  [6163] = 2237,
  [6164] = 2322,
  [6165] = 2244,
  [6166] = 2308,
  [6167] = 2312,
  [6168] = 2314,
  [6169] = 2315,
  [6170] = 2321,
  [6171] = 2343,
  [6172] = 2244,
  [6173] = 2236,
  [6174] = 2332,
  [6175] = 2333,
  [6176] = 5835,
  [6177] = 2309,
  [6178] = 2323,
  [6179] = 2347,
  [6180] = 2236,
  [6181] = 2244,
  [6182] = 2334,
  [6183] = 2241,
  [6184] = 2237,
  [6185] = 2237,
  [6186] = 2237,
  [6187] = 2236,
  [6188] = 2313,
  [6189] = 2241,
  [6190] = 2237,
  [6191] = 2324,
  [6192] = 6192,
  [6193] = 2319,
  [6194] = 2323,
  [6195] = 2347,
  [6196] = 6196,
  [6197] = 2324,
  [6198] = 2307,
  [6199] = 2340,
  [6200] = 2316,
  [6201] = 2351,
  [6202] = 2333,
  [6203] = 2334,
  [6204] = 2309,
  [6205] = 2349,
  [6206] = 2339,
  [6207] = 2328,
  [6208] = 2326,
  [6209] = 2305,
  [6210] = 2355,
  [6211] = 2332,
  [6212] = 2313,
  [6213] = 2358,
  [6214] = 2331,
  [6215] = 2305,
  [6216] = 2359,
  [6217] = 6192,
  [6218] = 2354,
  [6219] = 2340,
  [6220] = 2306,
  [6221] = 2321,
  [6222] = 2322,
  [6223] = 2354,
  [6224] = 2331,
  [6225] = 2303,
  [6226] = 2358,
  [6227] = 2355,
  [6228] = 2236,
  [6229] = 2349,
  [6230] = 2309,
  [6231] = 2318,
  [6232] = 2310,
  [6233] = 2344,
  [6234] = 2347,
  [6235] = 2325,
  [6236] = 2315,
  [6237] = 2323,
  [6238] = 2314,
  [6239] = 2319,
  [6240] = 2332,
  [6241] = 2312,
  [6242] = 2324,
  [6243] = 2308,
  [6244] = 2236,
  [6245] = 2343,
  [6246] = 2244,
  [6247] = 2328,
  [6248] = 2344,
  [6249] = 2333,
  [6250] = 6192,
  [6251] = 2321,
  [6252] = 2237,
  [6253] = 2322,
  [6254] = 2241,
  [6255] = 2306,
  [6256] = 2343,
  [6257] = 2326,
  [6258] = 2318,
  [6259] = 2316,
  [6260] = 6192,
  [6261] = 2345,
  [6262] = 2303,
  [6263] = 6192,
  [6264] = 2302,
  [6265] = 2346,
  [6266] = 2241,
  [6267] = 2336,
  [6268] = 2344,
  [6269] = 2318,
  [6270] = 2322,
  [6271] = 2242,
  [6272] = 2321,
  [6273] = 2348,
  [6274] = 2311,
  [6275] = 2350,
  [6276] = 2352,
  [6277] = 2353,
  [6278] = 2342,
  [6279] = 2341,
  [6280] = 2338,
  [6281] = 2337,
  [6282] = 2335,
  [6283] = 2327,
  [6284] = 2320,
  [6285] = 2328,
  [6286] = 2343,
  [6287] = 2323,
  [6288] = 2347,
  [6289] = 2349,
  [6290] = 6192,
  [6291] = 2355,
  [6292] = 2358,
  [6293] = 2315,
  [6294] = 2333,
  [6295] = 2314,
  [6296] = 2332,
  [6297] = 2236,
  [6298] = 2244,
  [6299] = 2236,
  [6300] = 2312,
  [6301] = 2308,
  [6302] = 2237,
  [6303] = 2241,
  [6304] = 6192,
  [6305] = 2307,
  [6306] = 2316,
  [6307] = 2306,
  [6308] = 2359,
  [6309] = 2354,
  [6310] = 2343,
  [6311] = 2339,
  [6312] = 6192,
  [6313] = 2326,
  [6314] = 2340,
  [6315] = 2305,
  [6316] = 2345,
  [6317] = 2302,
  [6318] = 2346,
  [6319] = 2336,
  [6320] = 2320,
  [6321] = 2327,
  [6322] = 2237,
  [6323] = 2335,
  [6324] = 2337,
  [6325] = 2338,
  [6326] = 2341,
  [6327] = 2342,
  [6328] = 2353,
  [6329] = 2352,
  [6330] = 2350,
  [6331] = 2348,
  [6332] = 2344,
  [6333] = 2306,
  [6334] = 2351,
  [6335] = 6192,
  [6336] = 6192,
  [6337] = 2337,
  [6338] = 2318,
  [6339] = 6192,
  [6340] = 2331,
  [6341] = 2348,
  [6342] = 2336,
  [6343] = 2346,
  [6344] = 2302,
  [6345] = 2350,
  [6346] = 2352,
  [6347] = 2353,
  [6348] = 2345,
  [6349] = 2342,
  [6350] = 2341,
  [6351] = 2338,
  [6352] = 6192,
  [6353] = 2334,
  [6354] = 2351,
  [6355] = 2313,
  [6356] = 2244,
  [6357] = 2322,
  [6358] = 2321,
  [6359] = 2244,
  [6360] = 6192,
  [6361] = 2315,
  [6362] = 2325,
  [6363] = 2335,
  [6364] = 2327,
  [6365] = 2320,
  [6366] = 2303,
  [6367] = 2314,
  [6368] = 2308,
  [6369] = 2312,
  [6370] = 2328,
  [6371] = 2307,
  [6372] = 2314,
  [6373] = 2323,
  [6374] = 2315,
  [6375] = 2347,
  [6376] = 2319,
  [6377] = 6192,
  [6378] = 6192,
  [6379] = 2349,
  [6380] = 6192,
  [6381] = 6192,
  [6382] = 2314,
  [6383] = 2306,
  [6384] = 6192,
  [6385] = 2312,
  [6386] = 2310,
  [6387] = 2355,
  [6388] = 2358,
  [6389] = 2308,
  [6390] = 2324,
  [6391] = 2344,
  [6392] = 6192,
  [6393] = 2345,
  [6394] = 2302,
  [6395] = 2346,
  [6396] = 2359,
  [6397] = 2242,
  [6398] = 2336,
  [6399] = 2351,
  [6400] = 6192,
  [6401] = 2311,
  [6402] = 6192,
  [6403] = 6192,
  [6404] = 2352,
  [6405] = 6192,
  [6406] = 2313,
  [6407] = 2333,
  [6408] = 2348,
  [6409] = 2339,
  [6410] = 2326,
  [6411] = 6192,
  [6412] = 2325,
  [6413] = 2354,
  [6414] = 2359,
  [6415] = 2339,
  [6416] = 2310,
  [6417] = 2309,
  [6418] = 2303,
  [6419] = 2334,
  [6420] = 2311,
  [6421] = 2313,
  [6422] = 6192,
  [6423] = 2241,
  [6424] = 2350,
  [6425] = 2353,
  [6426] = 2358,
  [6427] = 2355,
  [6428] = 6192,
  [6429] = 2349,
  [6430] = 2342,
  [6431] = 2341,
  [6432] = 2338,
  [6433] = 2319,
  [6434] = 2242,
  [6435] = 2337,
  [6436] = 2325,
  [6437] = 2306,
  [6438] = 2309,
  [6439] = 6192,
  [6440] = 5835,
  [6441] = 6192,
  [6442] = 6192,
  [6443] = 2351,
  [6444] = 2343,
  [6445] = 2331,
  [6446] = 6192,
  [6447] = 2335,
  [6448] = 2310,
  [6449] = 2340,
  [6450] = 2305,
  [6451] = 2332,
  [6452] = 2327,
  [6453] = 2320,
  [6454] = 6192,
  [6455] = 2316,
  [6456] = 2343,
  [6457] = 6192,
  [6458] = 6192,
  [6459] = 2352,
  [6460] = 6192,
  [6461] = 6192,
  [6462] = 6192,
  [6463] = 2332,
  [6464] = 2313,
  [6465] = 6192,
  [6466] = 2347,
  [6467] = 2323,
  [6468] = 2334,
  [6469] = 2320,
  [6470] = 2327,
  [6471] = 2305,
  [6472] = 2340,
  [6473] = 2335,
  [6474] = 2333,
  [6475] = 2332,
  [6476] = 2328,
  [6477] = 2337,
  [6478] = 2311,
  [6479] = 2338,
  [6480] = 2341,
  [6481] = 2342,
  [6482] = 2309,
  [6483] = 2353,
  [6484] = 2310,
  [6485] = 2339,
  [6486] = 2354,
  [6487] = 2359,
  [6488] = 2358,
  [6489] = 2344,
  [6490] = 2350,
  [6491] = 2334,
  [6492] = 2307,
  [6493] = 2355,
  [6494] = 2348,
  [6495] = 2349,
  [6496] = 2331,
  [6497] = 5093,
  [6498] = 2347,
  [6499] = 2323,
  [6500] = 2328,
  [6501] = 6192,
  [6502] = 6192,
  [6503] = 2307,
  [6504] = 2311,
  [6505] = 2325,
  [6506] = 6192,
  [6507] = 2319,
  [6508] = 2321,
  [6509] = 2320,
  [6510] = 2327,
  [6511] = 2322,
  [6512] = 2335,
  [6513] = 2337,
  [6514] = 2338,
  [6515] = 2341,
  [6516] = 2342,
  [6517] = 2353,
  [6518] = 2352,
  [6519] = 2350,
  [6520] = 2348,
  [6521] = 2324,
  [6522] = 2241,
  [6523] = 2307,
  [6524] = 6192,
  [6525] = 2326,
  [6526] = 2311,
  [6527] = 2336,
  [6528] = 2340,
  [6529] = 2346,
  [6530] = 2302,
  [6531] = 2336,
  [6532] = 2346,
  [6533] = 2302,
  [6534] = 2345,
  [6535] = 2318,
  [6536] = 2351,
  [6537] = 2345,
  [6538] = 2333,
  [6539] = 2321,
  [6540] = 6192,
  [6541] = 2316,
  [6542] = 2322,
  [6543] = 6192,
  [6544] = 2310,
  [6545] = 2309,
  [6546] = 2334,
  [6547] = 2318,
  [6548] = 2305,
  [6549] = 2326,
  [6550] = 6192,
  [6551] = 2359,
  [6552] = 2354,
  [6553] = 6192,
  [6554] = 2303,
  [6555] = 6192,
  [6556] = 2339,
  [6557] = 2308,
  [6558] = 2312,
  [6559] = 2331,
  [6560] = 6192,
  [6561] = 2314,
  [6562] = 6192,
  [6563] = 2315,
  [6564] = 2303,
  [6565] = 2237,
  [6566] = 2316,
  [6567] = 2324,
  [6568] = 2313,
  [6569] = 2308,
  [6570] = 2312,
  [6571] = 2319,
  [6572] = 2325,
  [6573] = 2315,
  [6574] = 2342,
  [6575] = 2884,
  [6576] = 2316,
  [6577] = 2358,
  [6578] = 2355,
  [6579] = 2349,
  [6580] = 2236,
  [6581] = 2344,
  [6582] = 2310,
  [6583] = 2309,
  [6584] = 2236,
  [6585] = 5768,
  [6586] = 2313,
  [6587] = 5776,
  [6588] = 2241,
  [6589] = 2242,
  [6590] = 5767,
  [6591] = 2311,
  [6592] = 5730,
  [6593] = 2244,
  [6594] = 2237,
  [6595] = 2343,
  [6596] = 2326,
  [6597] = 2242,
  [6598] = 2244,
  [6599] = 2347,
  [6600] = 2340,
  [6601] = 2305,
  [6602] = 2323,
  [6603] = 2237,
  [6604] = 2307,
  [6605] = 2332,
  [6606] = 2236,
  [6607] = 2328,
  [6608] = 2244,
  [6609] = 5705,
  [6610] = 2333,
  [6611] = 2321,
  [6612] = 2237,
  [6613] = 2322,
  [6614] = 2306,
  [6615] = 2312,
  [6616] = 2331,
  [6617] = 6617,
  [6618] = 5755,
  [6619] = 2237,
  [6620] = 2241,
  [6621] = 2315,
  [6622] = 5700,
  [6623] = 2241,
  [6624] = 2325,
  [6625] = 2236,
  [6626] = 2314,
  [6627] = 5712,
  [6628] = 5776,
  [6629] = 2241,
  [6630] = 2244,
  [6631] = 2359,
  [6632] = 2354,
  [6633] = 5714,
  [6634] = 2318,
  [6635] = 5698,
  [6636] = 5777,
  [6637] = 5715,
  [6638] = 5780,
  [6639] = 2319,
  [6640] = 5781,
  [6641] = 5742,
  [6642] = 2308,
  [6643] = 2324,
  [6644] = 5793,
  [6645] = 5711,
  [6646] = 5710,
  [6647] = 2339,
  [6648] = 5709,
  [6649] = 5718,
  [6650] = 5717,
  [6651] = 5719,
  [6652] = 5792,
  [6653] = 2244,
  [6654] = 5791,
  [6655] = 5790,
  [6656] = 5788,
  [6657] = 5786,
  [6658] = 2237,
  [6659] = 5785,
  [6660] = 5784,
  [6661] = 5772,
  [6662] = 2345,
  [6663] = 5708,
  [6664] = 2236,
  [6665] = 5720,
  [6666] = 5770,
  [6667] = 5753,
  [6668] = 2302,
  [6669] = 2303,
  [6670] = 2346,
  [6671] = 5751,
  [6672] = 2336,
  [6673] = 5808,
  [6674] = 2242,
  [6675] = 2236,
  [6676] = 2241,
  [6677] = 5093,
  [6678] = 2241,
  [6679] = 6617,
  [6680] = 2348,
  [6681] = 2350,
  [6682] = 2352,
  [6683] = 2353,
  [6684] = 2242,
  [6685] = 2341,
  [6686] = 2338,
  [6687] = 2337,
  [6688] = 2335,
  [6689] = 2327,
  [6690] = 2320,
  [6691] = 2244,
  [6692] = 2237,
  [6693] = 2334,
  [6694] = 2241,
  [6695] = 2351,
  [6696] = 6696,
  [6697] = 2322,
  [6698] = 2353,
  [6699] = 5790,
  [6700] = 5788,
  [6701] = 5786,
  [6702] = 5785,
  [6703] = 5784,
  [6704] = 5772,
  [6705] = 5770,
  [6706] = 5753,
  [6707] = 5751,
  [6708] = 5742,
  [6709] = 5808,
  [6710] = 2318,
  [6711] = 5792,
  [6712] = 2321,
  [6713] = 2307,
  [6714] = 2328,
  [6715] = 5793,
  [6716] = 2323,
  [6717] = 2347,
  [6718] = 2316,
  [6719] = 2349,
  [6720] = 2355,
  [6721] = 2313,
  [6722] = 2359,
  [6723] = 2354,
  [6724] = 2339,
  [6725] = 2333,
  [6726] = 2331,
  [6727] = 2332,
  [6728] = 5781,
  [6729] = 5780,
  [6730] = 2331,
  [6731] = 5777,
  [6732] = 2303,
  [6733] = 2309,
  [6734] = 2311,
  [6735] = 5768,
  [6736] = 2310,
  [6737] = 2311,
  [6738] = 5767,
  [6739] = 2334,
  [6740] = 2244,
  [6741] = 2884,
  [6742] = 2351,
  [6743] = 2236,
  [6744] = 2306,
  [6745] = 2344,
  [6746] = 2310,
  [6747] = 2309,
  [6748] = 5755,
  [6749] = 2313,
  [6750] = 2306,
  [6751] = 5719,
  [6752] = 5717,
  [6753] = 5700,
  [6754] = 2318,
  [6755] = 5705,
  [6756] = 2343,
  [6757] = 2358,
  [6758] = 5712,
  [6759] = 5709,
  [6760] = 5710,
  [6761] = 5711,
  [6762] = 5730,
  [6763] = 2303,
  [6764] = 2320,
  [6765] = 2327,
  [6766] = 2335,
  [6767] = 2337,
  [6768] = 2338,
  [6769] = 2341,
  [6770] = 2342,
  [6771] = 5714,
  [6772] = 5791,
  [6773] = 5698,
  [6774] = 5715,
  [6775] = 5718,
  [6776] = 2322,
  [6777] = 2321,
  [6778] = 2320,
  [6779] = 2242,
  [6780] = 2352,
  [6781] = 2327,
  [6782] = 2350,
  [6783] = 2348,
  [6784] = 2335,
  [6785] = 2337,
  [6786] = 2338,
  [6787] = 2341,
  [6788] = 5835,
  [6789] = 2342,
  [6790] = 2353,
  [6791] = 2352,
  [6792] = 2350,
  [6793] = 2348,
  [6794] = 2336,
  [6795] = 2339,
  [6796] = 2346,
  [6797] = 2302,
  [6798] = 2328,
  [6799] = 2345,
  [6800] = 5720,
  [6801] = 2323,
  [6802] = 2347,
  [6803] = 2343,
  [6804] = 2326,
  [6805] = 2241,
  [6806] = 2336,
  [6807] = 2354,
  [6808] = 2359,
  [6809] = 2346,
  [6810] = 2302,
  [6811] = 2308,
  [6812] = 2349,
  [6813] = 2312,
  [6814] = 2345,
  [6815] = 2334,
  [6816] = 2355,
  [6817] = 2314,
  [6818] = 2358,
  [6819] = 2315,
  [6820] = 2237,
  [6821] = 2308,
  [6822] = 2312,
  [6823] = 2244,
  [6824] = 2241,
  [6825] = 2314,
  [6826] = 2316,
  [6827] = 2315,
  [6828] = 2307,
  [6829] = 2236,
  [6830] = 2340,
  [6831] = 2305,
  [6832] = 5708,
  [6833] = 2237,
  [6834] = 2344,
  [6835] = 2351,
  [6836] = 2340,
  [6837] = 2333,
  [6838] = 2305,
  [6839] = 2325,
  [6840] = 2319,
  [6841] = 2326,
  [6842] = 2324,
  [6843] = 2319,
  [6844] = 2332,
  [6845] = 2324,
  [6846] = 6846,
  [6847] = 2326,
  [6848] = 2325,
  [6849] = 2351,
  [6850] = 2312,
  [6851] = 2324,
  [6852] = 6852,
  [6853] = 2354,
  [6854] = 2339,
  [6855] = 2306,
  [6856] = 2322,
  [6857] = 2359,
  [6858] = 2358,
  [6859] = 2355,
  [6860] = 2349,
  [6861] = 2347,
  [6862] = 2236,
  [6863] = 2323,
  [6864] = 2332,
  [6865] = 2244,
  [6866] = 2308,
  [6867] = 2328,
  [6868] = 2346,
  [6869] = 2302,
  [6870] = 2303,
  [6871] = 2237,
  [6872] = 2307,
  [6873] = 2334,
  [6874] = 2354,
  [6875] = 2241,
  [6876] = 2312,
  [6877] = 2333,
  [6878] = 2321,
  [6879] = 2322,
  [6880] = 2339,
  [6881] = 2319,
  [6882] = 2336,
  [6883] = 2337,
  [6884] = 2348,
  [6885] = 2359,
  [6886] = 2358,
  [6887] = 2318,
  [6888] = 2355,
  [6889] = 2350,
  [6890] = 2353,
  [6891] = 2342,
  [6892] = 2341,
  [6893] = 2349,
  [6894] = 2314,
  [6895] = 2236,
  [6896] = 2316,
  [6897] = 2347,
  [6898] = 2323,
  [6899] = 2332,
  [6900] = 2306,
  [6901] = 2325,
  [6902] = 2328,
  [6903] = 2338,
  [6904] = 5835,
  [6905] = 2315,
  [6906] = 2351,
  [6907] = 2307,
  [6908] = 2344,
  [6909] = 2335,
  [6910] = 2334,
  [6911] = 2327,
  [6912] = 2320,
  [6913] = 2320,
  [6914] = 2321,
  [6915] = 2242,
  [6916] = 2311,
  [6917] = 2313,
  [6918] = 2310,
  [6919] = 2327,
  [6920] = 2309,
  [6921] = 2303,
  [6922] = 2335,
  [6923] = 2309,
  [6924] = 2313,
  [6925] = 2331,
  [6926] = 2310,
  [6927] = 2352,
  [6928] = 2318,
  [6929] = 2337,
  [6930] = 2333,
  [6931] = 2343,
  [6932] = 2338,
  [6933] = 2343,
  [6934] = 2341,
  [6935] = 2342,
  [6936] = 2353,
  [6937] = 2352,
  [6938] = 2345,
  [6939] = 2350,
  [6940] = 2348,
  [6941] = 2336,
  [6942] = 2346,
  [6943] = 2302,
  [6944] = 2305,
  [6945] = 2316,
  [6946] = 2345,
  [6947] = 2340,
  [6948] = 2326,
  [6949] = 2303,
  [6950] = 2308,
  [6951] = 2312,
  [6952] = 2332,
  [6953] = 2314,
  [6954] = 2315,
  [6955] = 2311,
  [6956] = 6956,
  [6957] = 2313,
  [6958] = 2333,
  [6959] = 2352,
  [6960] = 2339,
  [6961] = 2354,
  [6962] = 2351,
  [6963] = 2326,
  [6964] = 2359,
  [6965] = 2358,
  [6966] = 2334,
  [6967] = 2355,
  [6968] = 2349,
  [6969] = 2347,
  [6970] = 2324,
  [6971] = 2323,
  [6972] = 2328,
  [6973] = 2237,
  [6974] = 2307,
  [6975] = 2321,
  [6976] = 2322,
  [6977] = 2319,
  [6978] = 2306,
  [6979] = 2244,
  [6980] = 2318,
  [6981] = 2325,
  [6982] = 2331,
  [6983] = 6983,
  [6984] = 2305,
  [6985] = 2340,
  [6986] = 2320,
  [6987] = 2327,
  [6988] = 2309,
  [6989] = 2335,
  [6990] = 2310,
  [6991] = 2337,
  [6992] = 2338,
  [6993] = 2341,
  [6994] = 2342,
  [6995] = 2353,
  [6996] = 2350,
  [6997] = 2348,
  [6998] = 2241,
  [6999] = 2326,
  [7000] = 2340,
  [7001] = 2305,
  [7002] = 2345,
  [7003] = 2315,
  [7004] = 2325,
  [7005] = 2314,
  [7006] = 2308,
  [7007] = 2324,
  [7008] = 2316,
  [7009] = 2336,
  [7010] = 2302,
  [7011] = 2344,
  [7012] = 2331,
  [7013] = 2311,
  [7014] = 2344,
  [7015] = 7015,
  [7016] = 2346,
  [7017] = 7017,
  [7018] = 2343,
  [7019] = 2319,
  [7020] = 2327,
  [7021] = 2346,
  [7022] = 2358,
  [7023] = 2355,
  [7024] = 2349,
  [7025] = 2316,
  [7026] = 2347,
  [7027] = 2323,
  [7028] = 2345,
  [7029] = 2328,
  [7030] = 2307,
  [7031] = 2349,
  [7032] = 2311,
  [7033] = 2321,
  [7034] = 2322,
  [7035] = 2355,
  [7036] = 2318,
  [7037] = 2358,
  [7038] = 2347,
  [7039] = 2242,
  [7040] = 5742,
  [7041] = 5808,
  [7042] = 5751,
  [7043] = 5753,
  [7044] = 5770,
  [7045] = 5772,
  [7046] = 5784,
  [7047] = 5785,
  [7048] = 5786,
  [7049] = 5788,
  [7050] = 5790,
  [7051] = 5791,
  [7052] = 5792,
  [7053] = 5793,
  [7054] = 7054,
  [7055] = 2331,
  [7056] = 2307,
  [7057] = 5781,
  [7058] = 5780,
  [7059] = 5777,
  [7060] = 2359,
  [7061] = 2354,
  [7062] = 5767,
  [7063] = 2339,
  [7064] = 5768,
  [7065] = 5755,
  [7066] = 5719,
  [7067] = 5717,
  [7068] = 5700,
  [7069] = 2324,
  [7070] = 5705,
  [7071] = 2308,
  [7072] = 2344,
  [7073] = 2312,
  [7074] = 2303,
  [7075] = 5712,
  [7076] = 5709,
  [7077] = 5710,
  [7078] = 5711,
  [7079] = 2343,
  [7080] = 2319,
  [7081] = 5730,
  [7082] = 5714,
  [7083] = 2336,
  [7084] = 2354,
  [7085] = 7085,
  [7086] = 2339,
  [7087] = 2323,
  [7088] = 2332,
  [7089] = 2333,
  [7090] = 5698,
  [7091] = 5715,
  [7092] = 5718,
  [7093] = 2302,
  [7094] = 5720,
  [7095] = 2314,
  [7096] = 2328,
  [7097] = 2332,
  [7098] = 5708,
  [7099] = 7099,
  [7100] = 2241,
  [7101] = 2313,
  [7102] = 2309,
  [7103] = 2310,
  [7104] = 2303,
  [7105] = 7105,
  [7106] = 7106,
  [7107] = 2306,
  [7108] = 2351,
  [7109] = 2334,
  [7110] = 2311,
  [7111] = 2359,
  [7112] = 2325,
  [7113] = 2334,
  [7114] = 2315,
  [7115] = 2316,
  [7116] = 7116,
  [7117] = 7117,
  [7118] = 2244,
  [7119] = 2237,
  [7120] = 2884,
  [7121] = 2333,
  [7122] = 2348,
  [7123] = 2321,
  [7124] = 2350,
  [7125] = 2322,
  [7126] = 2313,
  [7127] = 2326,
  [7128] = 2340,
  [7129] = 2306,
  [7130] = 2352,
  [7131] = 2305,
  [7132] = 2353,
  [7133] = 2342,
  [7134] = 2340,
  [7135] = 2341,
  [7136] = 2305,
  [7137] = 2338,
  [7138] = 2337,
  [7139] = 2320,
  [7140] = 2327,
  [7141] = 2339,
  [7142] = 2335,
  [7143] = 2337,
  [7144] = 2338,
  [7145] = 2341,
  [7146] = 2342,
  [7147] = 2353,
  [7148] = 2352,
  [7149] = 2350,
  [7150] = 2348,
  [7151] = 2313,
  [7152] = 2335,
  [7153] = 2359,
  [7154] = 2303,
  [7155] = 2320,
  [7156] = 2309,
  [7157] = 2310,
  [7158] = 7158,
  [7159] = 2318,
  [7160] = 2343,
  [7161] = 2336,
  [7162] = 2346,
  [7163] = 2302,
  [7164] = 2311,
  [7165] = 7165,
  [7166] = 2307,
  [7167] = 2345,
  [7168] = 2331,
  [7169] = 5835,
  [7170] = 2334,
  [7171] = 2325,
  [7172] = 2358,
  [7173] = 2319,
  [7174] = 2351,
  [7175] = 2355,
  [7176] = 2324,
  [7177] = 2351,
  [7178] = 2237,
  [7179] = 2349,
  [7180] = 2306,
  [7181] = 2236,
  [7182] = 2344,
  [7183] = 2347,
  [7184] = 2323,
  [7185] = 2332,
  [7186] = 2328,
  [7187] = 2308,
  [7188] = 2312,
  [7189] = 2354,
  [7190] = 2333,
  [7191] = 2314,
  [7192] = 2321,
  [7193] = 2315,
  [7194] = 2322,
  [7195] = 2326,
  [7196] = 2310,
  [7197] = 2241,
  [7198] = 2237,
  [7199] = 2318,
  [7200] = 2309,
  [7201] = 2244,
  [7202] = 2236,
  [7203] = 2306,
  [7204] = 5785,
  [7205] = 2354,
  [7206] = 2318,
  [7207] = 2352,
  [7208] = 7208,
  [7209] = 2350,
  [7210] = 2348,
  [7211] = 7208,
  [7212] = 2344,
  [7213] = 7208,
  [7214] = 2355,
  [7215] = 2355,
  [7216] = 2358,
  [7217] = 7208,
  [7218] = 2359,
  [7219] = 2331,
  [7220] = 2349,
  [7221] = 7208,
  [7222] = 2347,
  [7223] = 2349,
  [7224] = 2322,
  [7225] = 2321,
  [7226] = 2336,
  [7227] = 7208,
  [7228] = 2346,
  [7229] = 2343,
  [7230] = 2315,
  [7231] = 7208,
  [7232] = 2325,
  [7233] = 2314,
  [7234] = 2302,
  [7235] = 2345,
  [7236] = 5708,
  [7237] = 2353,
  [7238] = 5712,
  [7239] = 2328,
  [7240] = 2352,
  [7241] = 5709,
  [7242] = 2323,
  [7243] = 2347,
  [7244] = 5710,
  [7245] = 2332,
  [7246] = 2341,
  [7247] = 2342,
  [7248] = 5711,
  [7249] = 2308,
  [7250] = 7208,
  [7251] = 2312,
  [7252] = 2314,
  [7253] = 2349,
  [7254] = 7208,
  [7255] = 2328,
  [7256] = 2309,
  [7257] = 2355,
  [7258] = 2338,
  [7259] = 2358,
  [7260] = 7208,
  [7261] = 2315,
  [7262] = 2337,
  [7263] = 7208,
  [7264] = 2241,
  [7265] = 2321,
  [7266] = 7208,
  [7267] = 2343,
  [7268] = 2335,
  [7269] = 2327,
  [7270] = 7208,
  [7271] = 2351,
  [7272] = 7208,
  [7273] = 2311,
  [7274] = 2318,
  [7275] = 2316,
  [7276] = 2311,
  [7277] = 2339,
  [7278] = 2241,
  [7279] = 7208,
  [7280] = 2334,
  [7281] = 5781,
  [7282] = 5780,
  [7283] = 2244,
  [7284] = 2333,
  [7285] = 2320,
  [7286] = 5777,
  [7287] = 2313,
  [7288] = 2306,
  [7289] = 7208,
  [7290] = 2313,
  [7291] = 5730,
  [7292] = 7208,
  [7293] = 7208,
  [7294] = 2326,
  [7295] = 5714,
  [7296] = 5698,
  [7297] = 2320,
  [7298] = 5715,
  [7299] = 2303,
  [7300] = 2327,
  [7301] = 5772,
  [7302] = 2335,
  [7303] = 7208,
  [7304] = 2332,
  [7305] = 2337,
  [7306] = 7208,
  [7307] = 2316,
  [7308] = 2338,
  [7309] = 2351,
  [7310] = 7208,
  [7311] = 7208,
  [7312] = 2333,
  [7313] = 7208,
  [7314] = 2310,
  [7315] = 2307,
  [7316] = 2334,
  [7317] = 7208,
  [7318] = 2341,
  [7319] = 5768,
  [7320] = 2351,
  [7321] = 5793,
  [7322] = 7208,
  [7323] = 7208,
  [7324] = 5792,
  [7325] = 5791,
  [7326] = 5790,
  [7327] = 5788,
  [7328] = 7208,
  [7329] = 5720,
  [7330] = 2319,
  [7331] = 2358,
  [7332] = 2307,
  [7333] = 2312,
  [7334] = 7208,
  [7335] = 5705,
  [7336] = 2236,
  [7337] = 5700,
  [7338] = 2308,
  [7339] = 2324,
  [7340] = 2324,
  [7341] = 5786,
  [7342] = 5767,
  [7343] = 7208,
  [7344] = 5718,
  [7345] = 7208,
  [7346] = 7208,
  [7347] = 7208,
  [7348] = 2347,
  [7349] = 2319,
  [7350] = 7208,
  [7351] = 2325,
  [7352] = 2354,
  [7353] = 2342,
  [7354] = 2344,
  [7355] = 2316,
  [7356] = 2313,
  [7357] = 7208,
  [7358] = 5717,
  [7359] = 2353,
  [7360] = 2331,
  [7361] = 2318,
  [7362] = 5719,
  [7363] = 2333,
  [7364] = 7208,
  [7365] = 2321,
  [7366] = 2322,
  [7367] = 5784,
  [7368] = 2352,
  [7369] = 7208,
  [7370] = 2323,
  [7371] = 2339,
  [7372] = 2303,
  [7373] = 5770,
  [7374] = 2343,
  [7375] = 5755,
  [7376] = 2345,
  [7377] = 2332,
  [7378] = 7208,
  [7379] = 5753,
  [7380] = 2242,
  [7381] = 2334,
  [7382] = 2334,
  [7383] = 2350,
  [7384] = 2339,
  [7385] = 7208,
  [7386] = 7208,
  [7387] = 2318,
  [7388] = 2323,
  [7389] = 2237,
  [7390] = 7208,
  [7391] = 2354,
  [7392] = 2884,
  [7393] = 2309,
  [7394] = 2322,
  [7395] = 5751,
  [7396] = 7208,
  [7397] = 2310,
  [7398] = 2309,
  [7399] = 2326,
  [7400] = 2309,
  [7401] = 7208,
  [7402] = 2358,
  [7403] = 2326,
  [7404] = 2340,
  [7405] = 2305,
  [7406] = 2351,
  [7407] = 7208,
  [7408] = 2303,
  [7409] = 2306,
  [7410] = 2340,
  [7411] = 7208,
  [7412] = 5808,
  [7413] = 2305,
  [7414] = 2320,
  [7415] = 2327,
  [7416] = 2335,
  [7417] = 2337,
  [7418] = 2331,
  [7419] = 2313,
  [7420] = 2302,
  [7421] = 7208,
  [7422] = 7208,
  [7423] = 2307,
  [7424] = 2338,
  [7425] = 2346,
  [7426] = 2341,
  [7427] = 2342,
  [7428] = 2353,
  [7429] = 2350,
  [7430] = 7208,
  [7431] = 2328,
  [7432] = 2355,
  [7433] = 2315,
  [7434] = 2325,
  [7435] = 2314,
  [7436] = 2336,
  [7437] = 2344,
  [7438] = 2348,
  [7439] = 2348,
  [7440] = 7208,
  [7441] = 2322,
  [7442] = 2321,
  [7443] = 2237,
  [7444] = 2349,
  [7445] = 2319,
  [7446] = 2312,
  [7447] = 2333,
  [7448] = 2308,
  [7449] = 7208,
  [7450] = 2359,
  [7451] = 2354,
  [7452] = 2324,
  [7453] = 5742,
  [7454] = 2307,
  [7455] = 2311,
  [7456] = 7208,
  [7457] = 7208,
  [7458] = 2310,
  [7459] = 2236,
  [7460] = 7208,
  [7461] = 2305,
  [7462] = 2328,
  [7463] = 2336,
  [7464] = 2340,
  [7465] = 2306,
  [7466] = 2339,
  [7467] = 7208,
  [7468] = 2303,
  [7469] = 7208,
  [7470] = 2311,
  [7471] = 7208,
  [7472] = 2244,
  [7473] = 2302,
  [7474] = 7208,
  [7475] = 2359,
  [7476] = 2345,
  [7477] = 2310,
  [7478] = 7208,
  [7479] = 7208,
  [7480] = 7208,
  [7481] = 2346,
  [7482] = 2359,
  [7483] = 2347,
  [7484] = 2323,
  [7485] = 2332,
  [7486] = 7208,
  [7487] = 7487,
  [7488] = 2328,
  [7489] = 2354,
  [7490] = 2315,
  [7491] = 2327,
  [7492] = 2341,
  [7493] = 7493,
  [7494] = 2310,
  [7495] = 7495,
  [7496] = 7496,
  [7497] = 2338,
  [7498] = 2307,
  [7499] = 7499,
  [7500] = 2314,
  [7501] = 2326,
  [7502] = 2332,
  [7503] = 2337,
  [7504] = 7504,
  [7505] = 2335,
  [7506] = 2349,
  [7507] = 6617,
  [7508] = 7508,
  [7509] = 5776,
  [7510] = 2309,
  [7511] = 2348,
  [7512] = 2313,
  [7513] = 2351,
  [7514] = 2355,
  [7515] = 2334,
  [7516] = 2344,
  [7517] = 2324,
  [7518] = 2350,
  [7519] = 2305,
  [7520] = 2340,
  [7521] = 7521,
  [7522] = 2303,
  [7523] = 2320,
  [7524] = 2336,
  [7525] = 2358,
  [7526] = 2308,
  [7527] = 2346,
  [7528] = 2342,
  [7529] = 6617,
  [7530] = 2312,
  [7531] = 7531,
  [7532] = 7532,
  [7533] = 2333,
  [7534] = 2352,
  [7535] = 7535,
  [7536] = 2359,
  [7537] = 2316,
  [7538] = 2319,
  [7539] = 2302,
  [7540] = 2321,
  [7541] = 2343,
  [7542] = 2318,
  [7543] = 7543,
  [7544] = 2323,
  [7545] = 2306,
  [7546] = 2322,
  [7547] = 7547,
  [7548] = 2347,
  [7549] = 2311,
  [7550] = 2353,
  [7551] = 2339,
  [7552] = 2331,
  [7553] = 2325,
  [7554] = 2345,
  [7555] = 2327,
  [7556] = 2305,
  [7557] = 7557,
  [7558] = 7558,
  [7559] = 2355,
  [7560] = 2351,
  [7561] = 2324,
  [7562] = 2323,
  [7563] = 2322,
  [7564] = 2312,
  [7565] = 7565,
  [7566] = 2303,
  [7567] = 2314,
  [7568] = 2321,
  [7569] = 2348,
  [7570] = 7570,
  [7571] = 2320,
  [7572] = 2316,
  [7573] = 2326,
  [7574] = 2358,
  [7575] = 7575,
  [7576] = 2334,
  [7577] = 2313,
  [7578] = 2332,
  [7579] = 2350,
  [7580] = 2352,
  [7581] = 2353,
  [7582] = 2308,
  [7583] = 2331,
  [7584] = 2306,
  [7585] = 2335,
  [7586] = 2328,
  [7587] = 2343,
  [7588] = 7588,
  [7589] = 2342,
  [7590] = 2309,
  [7591] = 2341,
  [7592] = 2345,
  [7593] = 2310,
  [7594] = 2307,
  [7595] = 2318,
  [7596] = 7596,
  [7597] = 7565,
  [7598] = 2325,
  [7599] = 7599,
  [7600] = 2349,
  [7601] = 2302,
  [7602] = 2337,
  [7603] = 2346,
  [7604] = 2315,
  [7605] = 7605,
  [7606] = 7565,
  [7607] = 2347,
  [7608] = 7608,
  [7609] = 2333,
  [7610] = 2339,
  [7611] = 2359,
  [7612] = 2336,
  [7613] = 2340,
  [7614] = 2311,
  [7615] = 2338,
  [7616] = 2354,
  [7617] = 2319,
  [7618] = 7565,
  [7619] = 2344,
  [7620] = 7565,
  [7621] = 7496,
  [7622] = 2325,
  [7623] = 2319,
  [7624] = 2241,
  [7625] = 2230,
  [7626] = 2312,
  [7627] = 2345,
  [7628] = 2308,
  [7629] = 2324,
  [7630] = 2307,
  [7631] = 2316,
  [7632] = 2314,
  [7633] = 2227,
  [7634] = 2303,
  [7635] = 2237,
  [7636] = 2346,
  [7637] = 2311,
  [7638] = 7547,
  [7639] = 2244,
  [7640] = 7015,
  [7641] = 7641,
  [7642] = 2336,
  [7643] = 7643,
  [7644] = 2315,
  [7645] = 7495,
  [7646] = 2344,
  [7647] = 7647,
  [7648] = 2331,
  [7649] = 7649,
  [7650] = 2359,
  [7651] = 2354,
  [7652] = 2306,
  [7653] = 2318,
  [7654] = 2351,
  [7655] = 2305,
  [7656] = 2302,
  [7657] = 2358,
  [7658] = 7658,
  [7659] = 2340,
  [7660] = 2355,
  [7661] = 2326,
  [7662] = 7662,
  [7663] = 7663,
  [7664] = 2348,
  [7665] = 2320,
  [7666] = 2334,
  [7667] = 2231,
  [7668] = 2349,
  [7669] = 2233,
  [7670] = 2327,
  [7671] = 2225,
  [7672] = 2310,
  [7673] = 2228,
  [7674] = 7674,
  [7675] = 2347,
  [7676] = 2350,
  [7677] = 2343,
  [7678] = 2323,
  [7679] = 2332,
  [7680] = 2328,
  [7681] = 2351,
  [7682] = 5776,
  [7683] = 2316,
  [7684] = 7684,
  [7685] = 7685,
  [7686] = 2338,
  [7687] = 2309,
  [7688] = 2229,
  [7689] = 7689,
  [7690] = 2353,
  [7691] = 7691,
  [7692] = 7692,
  [7693] = 7693,
  [7694] = 2344,
  [7695] = 2313,
  [7696] = 2342,
  [7697] = 2343,
  [7698] = 7698,
  [7699] = 2333,
  [7700] = 7700,
  [7701] = 7701,
  [7702] = 2306,
  [7703] = 2341,
  [7704] = 2321,
  [7705] = 2339,
  [7706] = 2309,
  [7707] = 7647,
  [7708] = 2242,
  [7709] = 7709,
  [7710] = 2334,
  [7711] = 7535,
  [7712] = 7712,
  [7713] = 2232,
  [7714] = 2322,
  [7715] = 7715,
  [7716] = 2352,
  [7717] = 2306,
  [7718] = 2303,
  [7719] = 2237,
  [7720] = 2351,
  [7721] = 2337,
  [7722] = 2335,
  [7723] = 7723,
  [7724] = 7724,
  [7725] = 7725,
  [7726] = 2328,
  [7727] = 7727,
  [7728] = 7728,
  [7729] = 2307,
  [7730] = 2349,
  [7731] = 2316,
  [7732] = 2332,
  [7733] = 2334,
  [7734] = 2359,
  [7735] = 2354,
  [7736] = 2333,
  [7737] = 2242,
  [7738] = 2343,
  [7739] = 7739,
  [7740] = 2326,
  [7741] = 2306,
  [7742] = 2339,
  [7743] = 2241,
  [7744] = 2324,
  [7745] = 2319,
  [7746] = 2325,
  [7747] = 2358,
  [7748] = 2355,
  [7749] = 7054,
  [7750] = 2331,
  [7751] = 2320,
  [7752] = 7752,
  [7753] = 2237,
  [7754] = 2327,
  [7755] = 2335,
  [7756] = 2305,
  [7757] = 2340,
  [7758] = 7758,
  [7759] = 2337,
  [7760] = 2338,
  [7761] = 2341,
  [7762] = 2318,
  [7763] = 2342,
  [7764] = 2353,
  [7765] = 2352,
  [7766] = 2350,
  [7767] = 2348,
  [7768] = 2303,
  [7769] = 7015,
  [7770] = 2347,
  [7771] = 7771,
  [7772] = 2315,
  [7773] = 2314,
  [7774] = 2323,
  [7775] = 2336,
  [7776] = 2346,
  [7777] = 7777,
  [7778] = 2302,
  [7779] = 2313,
  [7780] = 2312,
  [7781] = 2308,
  [7782] = 2344,
  [7783] = 2322,
  [7784] = 2345,
  [7785] = 2351,
  [7786] = 7786,
  [7787] = 2309,
  [7788] = 7715,
  [7789] = 2321,
  [7790] = 7790,
  [7791] = 2311,
  [7792] = 2244,
  [7793] = 2310,
  [7794] = 7794,
  [7795] = 7794,
  [7796] = 7796,
  [7797] = 7797,
  [7798] = 7798,
  [7799] = 7797,
  [7800] = 7798,
  [7801] = 7801,
  [7802] = 7794,
  [7803] = 7798,
  [7804] = 2237,
  [7805] = 7801,
  [7806] = 7794,
  [7807] = 7794,
  [7808] = 7801,
  [7809] = 7798,
  [7810] = 7798,
  [7811] = 7797,
  [7812] = 7801,
  [7813] = 7798,
  [7814] = 7794,
  [7815] = 7797,
  [7816] = 7801,
  [7817] = 7801,
  [7818] = 7797,
  [7819] = 7794,
  [7820] = 7820,
  [7821] = 7798,
  [7822] = 7798,
  [7823] = 7801,
  [7824] = 7794,
  [7825] = 7798,
  [7826] = 7798,
  [7827] = 7794,
  [7828] = 7801,
  [7829] = 7797,
  [7830] = 7797,
  [7831] = 7797,
  [7832] = 7798,
  [7833] = 7798,
  [7834] = 7798,
  [7835] = 7835,
  [7836] = 7836,
  [7837] = 7798,
  [7838] = 7801,
  [7839] = 7797,
  [7840] = 7801,
  [7841] = 7801,
  [7842] = 7054,
  [7843] = 7794,
  [7844] = 7798,
  [7845] = 7794,
  [7846] = 7794,
  [7847] = 7794,
  [7848] = 7801,
  [7849] = 7794,
  [7850] = 7801,
  [7851] = 7798,
  [7852] = 7794,
  [7853] = 7801,
  [7854] = 7801,
  [7855] = 7801,
  [7856] = 7856,
  [7857] = 7794,
  [7858] = 7794,
  [7859] = 7798,
  [7860] = 7797,
  [7861] = 7801,
  [7862] = 7715,
  [7863] = 7543,
  [7864] = 7864,
  [7865] = 2237,
  [7866] = 2381,
  [7867] = 7867,
  [7868] = 7868,
  [7869] = 2391,
  [7870] = 2390,
  [7871] = 2383,
  [7872] = 7864,
  [7873] = 7054,
  [7874] = 5776,
  [7875] = 7875,
  [7876] = 2387,
  [7877] = 7877,
  [7878] = 7878,
  [7879] = 7879,
  [7880] = 2386,
  [7881] = 7881,
  [7882] = 7596,
  [7883] = 2237,
  [7884] = 7543,
  [7885] = 2307,
  [7886] = 2331,
  [7887] = 7887,
  [7888] = 7888,
  [7889] = 2332,
  [7890] = 2359,
  [7891] = 7596,
  [7892] = 2354,
  [7893] = 2318,
  [7894] = 7894,
  [7895] = 7887,
  [7896] = 2305,
  [7897] = 2340,
  [7898] = 7898,
  [7899] = 2303,
  [7900] = 7900,
  [7901] = 2344,
  [7902] = 2334,
  [7903] = 7887,
  [7904] = 2306,
  [7905] = 2339,
  [7906] = 2309,
  [7907] = 7907,
  [7908] = 7887,
  [7909] = 7909,
  [7910] = 7910,
  [7911] = 2334,
  [7912] = 2309,
  [7913] = 2306,
  [7914] = 2316,
  [7915] = 7915,
  [7916] = 2351,
  [7917] = 7054,
  [7918] = 2333,
  [7919] = 7919,
  [7920] = 7920,
  [7921] = 7887,
  [7922] = 7922,
  [7923] = 7887,
  [7924] = 2351,
  [7925] = 2306,
  [7926] = 7926,
  [7927] = 7927,
  [7928] = 7928,
  [7929] = 7887,
  [7930] = 7930,
  [7931] = 7931,
  [7932] = 7900,
  [7933] = 7887,
  [7934] = 7934,
  [7935] = 2343,
  [7936] = 7936,
  [7937] = 7937,
  [7938] = 2358,
  [7939] = 2311,
  [7940] = 7887,
  [7941] = 7941,
  [7942] = 7942,
  [7943] = 2884,
  [7944] = 7944,
  [7945] = 2355,
  [7946] = 2349,
  [7947] = 2303,
  [7948] = 2316,
  [7949] = 7887,
  [7950] = 2347,
  [7951] = 2323,
  [7952] = 2328,
  [7953] = 2343,
  [7954] = 7954,
  [7955] = 7955,
  [7956] = 2321,
  [7957] = 2344,
  [7958] = 2322,
  [7959] = 7920,
  [7960] = 7960,
  [7961] = 2334,
  [7962] = 7962,
  [7963] = 2331,
  [7964] = 7693,
  [7965] = 7692,
  [7966] = 7685,
  [7967] = 2339,
  [7968] = 7888,
  [7969] = 7649,
  [7970] = 2344,
  [7971] = 7971,
  [7972] = 7972,
  [7973] = 2311,
  [7974] = 7974,
  [7975] = 7975,
  [7976] = 2351,
  [7977] = 2358,
  [7978] = 7663,
  [7979] = 2235,
  [7980] = 7931,
  [7981] = 2305,
  [7982] = 2340,
  [7983] = 7919,
  [7984] = 7662,
  [7985] = 2355,
  [7986] = 2359,
  [7987] = 2322,
  [7988] = 4174,
  [7989] = 7989,
  [7990] = 2321,
  [7991] = 7689,
  [7992] = 2309,
  [7993] = 2303,
  [7994] = 7641,
  [7995] = 2354,
  [7996] = 2333,
  [7997] = 2318,
  [7998] = 2307,
  [7999] = 2349,
  [8000] = 7942,
  [8001] = 2343,
  [8002] = 2306,
  [8003] = 2347,
  [8004] = 7691,
  [8005] = 7930,
  [8006] = 2328,
  [8007] = 7927,
  [8008] = 2332,
  [8009] = 2323,
  [8010] = 2316,
  [8011] = 7926,
  [8012] = 8012,
  [8013] = 7685,
  [8014] = 7689,
  [8015] = 8015,
  [8016] = 2344,
  [8017] = 8017,
  [8018] = 7691,
  [8019] = 7054,
  [8020] = 8015,
  [8021] = 7649,
  [8022] = 2303,
  [8023] = 2351,
  [8024] = 2334,
  [8025] = 7693,
  [8026] = 7955,
  [8027] = 7692,
  [8028] = 8028,
  [8029] = 2306,
  [8030] = 2343,
  [8031] = 7662,
  [8032] = 8032,
  [8033] = 7663,
  [8034] = 8034,
  [8035] = 7641,
  [8036] = 2306,
  [8037] = 2309,
  [8038] = 2316,
  [8039] = 2884,
  [8040] = 8040,
  [8041] = 8040,
  [8042] = 8040,
  [8043] = 8043,
  [8044] = 2343,
  [8045] = 8040,
  [8046] = 7649,
  [8047] = 7641,
  [8048] = 7663,
  [8049] = 2351,
  [8050] = 7692,
  [8051] = 8051,
  [8052] = 7662,
  [8053] = 2306,
  [8054] = 2334,
  [8055] = 7910,
  [8056] = 8040,
  [8057] = 2344,
  [8058] = 7641,
  [8059] = 8059,
  [8060] = 7643,
  [8061] = 8061,
  [8062] = 7685,
  [8063] = 7689,
  [8064] = 2303,
  [8065] = 7649,
  [8066] = 2309,
  [8067] = 7691,
  [8068] = 7689,
  [8069] = 4174,
  [8070] = 7691,
  [8071] = 7662,
  [8072] = 7663,
  [8073] = 2316,
  [8074] = 8040,
  [8075] = 7693,
  [8076] = 7692,
  [8077] = 7685,
  [8078] = 7693,
  [8079] = 7727,
  [8080] = 8080,
  [8081] = 8081,
  [8082] = 8082,
  [8083] = 8083,
  [8084] = 8084,
  [8085] = 8085,
  [8086] = 8086,
  [8087] = 8087,
  [8088] = 8088,
  [8089] = 8089,
  [8090] = 8090,
  [8091] = 8091,
  [8092] = 8092,
  [8093] = 8093,
  [8094] = 8094,
  [8095] = 8095,
  [8096] = 8096,
  [8097] = 8097,
  [8098] = 2235,
  [8099] = 2230,
  [8100] = 2229,
  [8101] = 2227,
  [8102] = 8102,
  [8103] = 2232,
  [8104] = 2228,
  [8105] = 8105,
  [8106] = 2233,
  [8107] = 8107,
  [8108] = 2232,
  [8109] = 8109,
  [8110] = 8110,
  [8111] = 8111,
  [8112] = 8107,
  [8113] = 2225,
  [8114] = 8059,
  [8115] = 8107,
  [8116] = 8110,
  [8117] = 8107,
  [8118] = 2231,
  [8119] = 8119,
  [8120] = 2233,
  [8121] = 2225,
  [8122] = 8107,
  [8123] = 8123,
  [8124] = 8107,
  [8125] = 8125,
  [8126] = 8107,
  [8127] = 8127,
  [8128] = 8107,
  [8129] = 8107,
  [8130] = 8123,
  [8131] = 8107,
  [8132] = 2227,
  [8133] = 2229,
  [8134] = 2230,
  [8135] = 8051,
  [8136] = 2231,
  [8137] = 2228,
  [8138] = 8138,
  [8139] = 8139,
  [8140] = 8140,
  [8141] = 8140,
  [8142] = 8105,
  [8143] = 7934,
  [8144] = 8140,
  [8145] = 8140,
  [8146] = 7674,
  [8147] = 8147,
  [8148] = 7684,
  [8149] = 8149,
  [8150] = 8150,
  [8151] = 8140,
  [8152] = 7724,
  [8153] = 8140,
  [8154] = 7881,
  [8155] = 7709,
  [8156] = 8140,
  [8157] = 8105,
  [8158] = 8158,
  [8159] = 7727,
  [8160] = 7907,
  [8161] = 8161,
  [8162] = 8140,
  [8163] = 8140,
  [8164] = 8164,
  [8165] = 8165,
  [8166] = 8166,
  [8167] = 8059,
  [8168] = 8051,
  [8169] = 7698,
  [8170] = 8140,
  [8171] = 2228,
  [8172] = 8172,
  [8173] = 8172,
  [8174] = 2231,
  [8175] = 8172,
  [8176] = 2230,
  [8177] = 2229,
  [8178] = 2227,
  [8179] = 8172,
  [8180] = 2228,
  [8181] = 8181,
  [8182] = 8172,
  [8183] = 8183,
  [8184] = 2232,
  [8185] = 2231,
  [8186] = 8172,
  [8187] = 8187,
  [8188] = 8172,
  [8189] = 8172,
  [8190] = 8172,
  [8191] = 8059,
  [8192] = 8187,
  [8193] = 8172,
  [8194] = 2230,
  [8195] = 8172,
  [8196] = 2233,
  [8197] = 8172,
  [8198] = 2225,
  [8199] = 8172,
  [8200] = 8051,
  [8201] = 2227,
  [8202] = 2229,
  [8203] = 8172,
  [8204] = 8172,
  [8205] = 2229,
  [8206] = 2230,
  [8207] = 2225,
  [8208] = 8187,
  [8209] = 8187,
  [8210] = 8172,
  [8211] = 2233,
  [8212] = 2231,
  [8213] = 2230,
  [8214] = 8187,
  [8215] = 2229,
  [8216] = 2227,
  [8217] = 8172,
  [8218] = 2228,
  [8219] = 8172,
  [8220] = 2225,
  [8221] = 2232,
  [8222] = 2306,
  [8223] = 8172,
  [8224] = 8172,
  [8225] = 2351,
  [8226] = 8187,
  [8227] = 2231,
  [8228] = 8181,
  [8229] = 2233,
  [8230] = 8172,
  [8231] = 2225,
  [8232] = 8172,
  [8233] = 8172,
  [8234] = 8172,
  [8235] = 8172,
  [8236] = 8236,
  [8237] = 2235,
  [8238] = 8238,
  [8239] = 8187,
  [8240] = 8172,
  [8241] = 8172,
  [8242] = 8172,
  [8243] = 8172,
  [8244] = 8172,
  [8245] = 8187,
  [8246] = 8172,
  [8247] = 2227,
  [8248] = 8172,
  [8249] = 8187,
  [8250] = 2233,
  [8251] = 8251,
  [8252] = 2232,
  [8253] = 8172,
  [8254] = 8172,
  [8255] = 8172,
  [8256] = 8172,
  [8257] = 8172,
  [8258] = 8172,
  [8259] = 8172,
  [8260] = 8172,
  [8261] = 8172,
  [8262] = 2232,
  [8263] = 8172,
  [8264] = 8172,
  [8265] = 8172,
  [8266] = 8187,
  [8267] = 8172,
  [8268] = 8181,
  [8269] = 8172,
  [8270] = 2228,
  [8271] = 8172,
  [8272] = 8187,
  [8273] = 8172,
  [8274] = 8097,
  [8275] = 8275,
  [8276] = 8276,
  [8277] = 8158,
  [8278] = 8278,
  [8279] = 8279,
  [8280] = 8280,
  [8281] = 8281,
  [8282] = 5776,
  [8283] = 8283,
  [8284] = 8284,
  [8285] = 8285,
  [8286] = 8286,
  [8287] = 8166,
  [8288] = 8288,
  [8289] = 8161,
  [8290] = 8290,
  [8291] = 8275,
  [8292] = 8292,
  [8293] = 8293,
  [8294] = 8294,
  [8295] = 8138,
  [8296] = 8296,
  [8297] = 8297,
  [8298] = 8298,
  [8299] = 8299,
  [8300] = 8300,
  [8301] = 8301,
  [8302] = 8302,
  [8303] = 8303,
  [8304] = 8304,
  [8305] = 8051,
  [8306] = 2231,
  [8307] = 2230,
  [8308] = 2235,
  [8309] = 2235,
  [8310] = 2228,
  [8311] = 8311,
  [8312] = 8312,
  [8313] = 2952,
  [8314] = 2228,
  [8315] = 8315,
  [8316] = 8316,
  [8317] = 8317,
  [8318] = 8318,
  [8319] = 8319,
  [8320] = 8320,
  [8321] = 2225,
  [8322] = 2233,
  [8323] = 2235,
  [8324] = 8324,
  [8325] = 2228,
  [8326] = 2231,
  [8327] = 2230,
  [8328] = 8328,
  [8329] = 8329,
  [8330] = 8300,
  [8331] = 2229,
  [8332] = 2227,
  [8333] = 2232,
  [8334] = 8059,
  [8335] = 2229,
  [8336] = 8336,
  [8337] = 8300,
  [8338] = 8338,
  [8339] = 8339,
  [8340] = 2225,
  [8341] = 8097,
  [8342] = 8342,
  [8343] = 8343,
  [8344] = 8344,
  [8345] = 8345,
  [8346] = 8346,
  [8347] = 8347,
  [8348] = 2235,
  [8349] = 2233,
  [8350] = 8350,
  [8351] = 8351,
  [8352] = 2232,
  [8353] = 8353,
  [8354] = 2227,
  [8355] = 8355,
  [8356] = 2233,
  [8357] = 8357,
  [8358] = 8358,
  [8359] = 8359,
  [8360] = 8360,
  [8361] = 8361,
  [8362] = 2225,
  [8363] = 8363,
  [8364] = 2233,
  [8365] = 2231,
  [8366] = 2230,
  [8367] = 2229,
  [8368] = 2227,
  [8369] = 2228,
  [8370] = 8370,
  [8371] = 8371,
  [8372] = 2232,
  [8373] = 8097,
  [8374] = 8374,
  [8375] = 8375,
  [8376] = 2316,
  [8377] = 8377,
  [8378] = 8059,
  [8379] = 8051,
  [8380] = 8380,
  [8381] = 8381,
  [8382] = 8382,
  [8383] = 8383,
  [8384] = 2311,
  [8385] = 2313,
  [8386] = 2306,
  [8387] = 2310,
  [8388] = 8388,
  [8389] = 8389,
  [8390] = 8390,
  [8391] = 2334,
  [8392] = 2351,
  [8393] = 2231,
  [8394] = 2230,
  [8395] = 2228,
  [8396] = 2229,
  [8397] = 2227,
  [8398] = 2235,
  [8399] = 8383,
  [8400] = 2232,
  [8401] = 8401,
  [8402] = 2225,
  [8403] = 8403,
  [8404] = 8404,
  [8405] = 8404,
  [8406] = 8404,
  [8407] = 8407,
  [8408] = 8404,
  [8409] = 8409,
  [8410] = 8404,
  [8411] = 8411,
  [8412] = 8404,
  [8413] = 8403,
  [8414] = 8409,
  [8415] = 8411,
  [8416] = 8403,
  [8417] = 8411,
  [8418] = 8127,
  [8419] = 8419,
  [8420] = 8420,
  [8421] = 8411,
  [8422] = 8422,
  [8423] = 8404,
  [8424] = 8419,
  [8425] = 8404,
  [8426] = 8411,
  [8427] = 8404,
  [8428] = 8411,
  [8429] = 8411,
  [8430] = 8404,
  [8431] = 8411,
  [8432] = 8404,
  [8433] = 8411,
  [8434] = 8411,
  [8435] = 8404,
  [8436] = 8404,
  [8437] = 8404,
  [8438] = 8411,
  [8439] = 8404,
  [8440] = 8440,
  [8441] = 8411,
  [8442] = 8411,
  [8443] = 8404,
  [8444] = 8444,
  [8445] = 8404,
  [8446] = 8411,
  [8447] = 8447,
  [8448] = 8404,
  [8449] = 8404,
  [8450] = 8411,
  [8451] = 8404,
  [8452] = 8452,
  [8453] = 8404,
  [8454] = 8409,
  [8455] = 8411,
  [8456] = 8404,
  [8457] = 8411,
  [8458] = 8411,
  [8459] = 8404,
  [8460] = 8460,
  [8461] = 8404,
  [8462] = 8404,
  [8463] = 8404,
  [8464] = 8403,
  [8465] = 8404,
  [8466] = 8411,
  [8467] = 8411,
  [8468] = 8411,
  [8469] = 8419,
  [8470] = 8404,
  [8471] = 8411,
  [8472] = 8411,
  [8473] = 8404,
  [8474] = 8404,
  [8475] = 8411,
  [8476] = 8411,
  [8477] = 2232,
  [8478] = 8404,
  [8479] = 8411,
  [8480] = 8404,
  [8481] = 2227,
  [8482] = 2229,
  [8483] = 8411,
  [8484] = 8404,
  [8485] = 8404,
  [8486] = 8411,
  [8487] = 2230,
  [8488] = 2231,
  [8489] = 8404,
  [8490] = 2233,
  [8491] = 8411,
  [8492] = 8411,
  [8493] = 8411,
  [8494] = 2225,
  [8495] = 8404,
  [8496] = 8411,
  [8497] = 8460,
  [8498] = 8404,
  [8499] = 8411,
  [8500] = 8500,
  [8501] = 8500,
  [8502] = 2391,
  [8503] = 8500,
  [8504] = 8403,
  [8505] = 8409,
  [8506] = 8409,
  [8507] = 8411,
  [8508] = 8404,
  [8509] = 2228,
  [8510] = 8419,
  [8511] = 2390,
  [8512] = 8404,
  [8513] = 2381,
  [8514] = 2387,
  [8515] = 8411,
  [8516] = 8411,
  [8517] = 8419,
  [8518] = 8411,
  [8519] = 2386,
  [8520] = 2383,
  [8521] = 8521,
  [8522] = 8411,
  [8523] = 8404,
  [8524] = 8411,
  [8525] = 8411,
  [8526] = 2383,
  [8527] = 2386,
  [8528] = 2387,
  [8529] = 8404,
  [8530] = 2390,
  [8531] = 8404,
  [8532] = 2381,
  [8533] = 8411,
  [8534] = 8404,
  [8535] = 8460,
  [8536] = 8411,
  [8537] = 2391,
  [8538] = 8411,
  [8539] = 8404,
  [8540] = 8411,
  [8541] = 8460,
  [8542] = 8411,
  [8543] = 8404,
  [8544] = 8411,
  [8545] = 8460,
  [8546] = 8404,
  [8547] = 8404,
  [8548] = 8411,
  [8549] = 8411,
  [8550] = 8404,
  [8551] = 8460,
  [8552] = 8552,
  [8553] = 8375,
  [8554] = 8552,
  [8555] = 8552,
  [8556] = 8374,
  [8557] = 8552,
  [8558] = 8377,
  [8559] = 8380,
  [8560] = 8355,
  [8561] = 8370,
  [8562] = 2231,
  [8563] = 8357,
  [8564] = 8358,
  [8565] = 8381,
  [8566] = 8359,
  [8567] = 2316,
  [8568] = 8552,
  [8569] = 8569,
  [8570] = 8360,
  [8571] = 8571,
  [8572] = 8382,
  [8573] = 2225,
  [8574] = 8574,
  [8575] = 8552,
  [8576] = 2228,
  [8577] = 8577,
  [8578] = 8552,
  [8579] = 8552,
  [8580] = 8552,
  [8581] = 5776,
  [8582] = 2232,
  [8583] = 2311,
  [8584] = 8552,
  [8585] = 2313,
  [8586] = 8552,
  [8587] = 2227,
  [8588] = 8361,
  [8589] = 2229,
  [8590] = 8552,
  [8591] = 2230,
  [8592] = 2310,
  [8593] = 8552,
  [8594] = 8552,
  [8595] = 8595,
  [8596] = 2235,
  [8597] = 8552,
  [8598] = 8552,
  [8599] = 8552,
  [8600] = 8552,
  [8601] = 8371,
  [8602] = 8238,
  [8603] = 2334,
  [8604] = 2306,
  [8605] = 2351,
  [8606] = 8552,
  [8607] = 2233,
  [8608] = 8608,
  [8609] = 8609,
  [8610] = 8610,
  [8611] = 8610,
  [8612] = 8608,
  [8613] = 8608,
  [8614] = 8360,
  [8615] = 8608,
  [8616] = 8359,
  [8617] = 8617,
  [8618] = 8358,
  [8619] = 8357,
  [8620] = 8617,
  [8621] = 8621,
  [8622] = 8610,
  [8623] = 8382,
  [8624] = 8608,
  [8625] = 8381,
  [8626] = 8355,
  [8627] = 2316,
  [8628] = 8380,
  [8629] = 8608,
  [8630] = 8617,
  [8631] = 8617,
  [8632] = 2391,
  [8633] = 2390,
  [8634] = 8608,
  [8635] = 2387,
  [8636] = 8377,
  [8637] = 8637,
  [8638] = 2386,
  [8639] = 8639,
  [8640] = 2383,
  [8641] = 8641,
  [8642] = 2237,
  [8643] = 8610,
  [8644] = 2381,
  [8645] = 8370,
  [8646] = 8371,
  [8647] = 2386,
  [8648] = 8617,
  [8649] = 2306,
  [8650] = 8608,
  [8651] = 8651,
  [8652] = 2351,
  [8653] = 8610,
  [8654] = 2334,
  [8655] = 2306,
  [8656] = 8608,
  [8657] = 8375,
  [8658] = 8617,
  [8659] = 8608,
  [8660] = 8374,
  [8661] = 2391,
  [8662] = 8610,
  [8663] = 8610,
  [8664] = 8664,
  [8665] = 2390,
  [8666] = 8666,
  [8667] = 8610,
  [8668] = 8608,
  [8669] = 8371,
  [8670] = 8608,
  [8671] = 2387,
  [8672] = 8610,
  [8673] = 2383,
  [8674] = 2381,
  [8675] = 8675,
  [8676] = 8361,
  [8677] = 8360,
  [8678] = 8610,
  [8679] = 8359,
  [8680] = 2306,
  [8681] = 8608,
  [8682] = 8608,
  [8683] = 8357,
  [8684] = 8617,
  [8685] = 8358,
  [8686] = 8608,
  [8687] = 8361,
  [8688] = 8617,
  [8689] = 8359,
  [8690] = 8358,
  [8691] = 2310,
  [8692] = 8360,
  [8693] = 8617,
  [8694] = 8361,
  [8695] = 2387,
  [8696] = 8696,
  [8697] = 8617,
  [8698] = 2391,
  [8699] = 8617,
  [8700] = 8608,
  [8701] = 2390,
  [8702] = 2311,
  [8703] = 8608,
  [8704] = 8371,
  [8705] = 2313,
  [8706] = 8608,
  [8707] = 8707,
  [8708] = 8608,
  [8709] = 8608,
  [8710] = 8710,
  [8711] = 8608,
  [8712] = 8357,
  [8713] = 8713,
  [8714] = 8608,
  [8715] = 8617,
  [8716] = 2381,
  [8717] = 2383,
  [8718] = 2386,
  [8719] = 8617,
  [8720] = 8720,
  [8721] = 8721,
  [8722] = 8722,
  [8723] = 8723,
  [8724] = 8721,
  [8725] = 8375,
  [8726] = 8726,
  [8727] = 8374,
  [8728] = 2306,
  [8729] = 2306,
  [8730] = 2310,
  [8731] = 8721,
  [8732] = 8732,
  [8733] = 8733,
  [8734] = 8721,
  [8735] = 8735,
  [8736] = 8370,
  [8737] = 8737,
  [8738] = 8721,
  [8739] = 8723,
  [8740] = 8377,
  [8741] = 2316,
  [8742] = 8357,
  [8743] = 8743,
  [8744] = 8721,
  [8745] = 8745,
  [8746] = 8380,
  [8747] = 2313,
  [8748] = 8371,
  [8749] = 8361,
  [8750] = 2311,
  [8751] = 8360,
  [8752] = 8721,
  [8753] = 8359,
  [8754] = 8358,
  [8755] = 8755,
  [8756] = 2334,
  [8757] = 8757,
  [8758] = 8758,
  [8759] = 2351,
  [8760] = 8760,
  [8761] = 8358,
  [8762] = 8762,
  [8763] = 8359,
  [8764] = 8360,
  [8765] = 2306,
  [8766] = 8361,
  [8767] = 8357,
  [8768] = 8355,
  [8769] = 8381,
  [8770] = 8770,
  [8771] = 8371,
  [8772] = 5776,
  [8773] = 8382,
  [8774] = 8774,
  [8775] = 8775,
  [8776] = 8776,
  [8777] = 2383,
  [8778] = 8778,
  [8779] = 2386,
  [8780] = 8780,
  [8781] = 8781,
  [8782] = 8782,
  [8783] = 8675,
  [8784] = 8774,
  [8785] = 8785,
  [8786] = 8786,
  [8787] = 8787,
  [8788] = 8781,
  [8789] = 8786,
  [8790] = 8787,
  [8791] = 2390,
  [8792] = 8780,
  [8793] = 8775,
  [8794] = 2391,
  [8795] = 8795,
  [8796] = 8787,
  [8797] = 8774,
  [8798] = 8775,
  [8799] = 8787,
  [8800] = 8795,
  [8801] = 8795,
  [8802] = 8802,
  [8803] = 8780,
  [8804] = 8775,
  [8805] = 8786,
  [8806] = 8774,
  [8807] = 8795,
  [8808] = 8785,
  [8809] = 8781,
  [8810] = 8786,
  [8811] = 8781,
  [8812] = 8787,
  [8813] = 8813,
  [8814] = 8786,
  [8815] = 8775,
  [8816] = 8816,
  [8817] = 8785,
  [8818] = 8795,
  [8819] = 8775,
  [8820] = 8774,
  [8821] = 8785,
  [8822] = 8781,
  [8823] = 8795,
  [8824] = 8786,
  [8825] = 8787,
  [8826] = 2381,
  [8827] = 8827,
  [8828] = 8774,
  [8829] = 8785,
  [8830] = 8785,
  [8831] = 8795,
  [8832] = 8781,
  [8833] = 8833,
  [8834] = 8834,
  [8835] = 8795,
  [8836] = 2381,
  [8837] = 8795,
  [8838] = 2387,
  [8839] = 2383,
  [8840] = 8795,
  [8841] = 8795,
  [8842] = 8639,
  [8843] = 8795,
  [8844] = 8844,
  [8845] = 8845,
  [8846] = 8846,
  [8847] = 8847,
  [8848] = 8780,
  [8849] = 8849,
  [8850] = 2386,
  [8851] = 8795,
  [8852] = 8852,
  [8853] = 8853,
  [8854] = 2387,
  [8855] = 2390,
  [8856] = 8780,
  [8857] = 2391,
  [8858] = 8858,
  [8859] = 8371,
  [8860] = 8375,
  [8861] = 2386,
  [8862] = 8755,
  [8863] = 8863,
  [8864] = 8864,
  [8865] = 8865,
  [8866] = 8866,
  [8867] = 2387,
  [8868] = 2391,
  [8869] = 8869,
  [8870] = 8870,
  [8871] = 8871,
  [8872] = 8872,
  [8873] = 2383,
  [8874] = 8874,
  [8875] = 8760,
  [8876] = 8876,
  [8877] = 8762,
  [8878] = 8770,
  [8879] = 8870,
  [8880] = 2310,
  [8881] = 8382,
  [8882] = 8733,
  [8883] = 8883,
  [8884] = 8361,
  [8885] = 2306,
  [8886] = 8886,
  [8887] = 2381,
  [8888] = 8888,
  [8889] = 2311,
  [8890] = 2313,
  [8891] = 8870,
  [8892] = 8892,
  [8893] = 8893,
  [8894] = 8894,
  [8895] = 8381,
  [8896] = 2306,
  [8897] = 8897,
  [8898] = 8355,
  [8899] = 8380,
  [8900] = 8360,
  [8901] = 8359,
  [8902] = 8358,
  [8903] = 8357,
  [8904] = 2390,
  [8905] = 8905,
  [8906] = 8906,
  [8907] = 8870,
  [8908] = 2334,
  [8909] = 2351,
  [8910] = 8910,
  [8911] = 8911,
  [8912] = 8912,
  [8913] = 8870,
  [8914] = 8914,
  [8915] = 8915,
  [8916] = 2351,
  [8917] = 8370,
  [8918] = 8377,
  [8919] = 2316,
  [8920] = 2334,
  [8921] = 8921,
  [8922] = 2387,
  [8923] = 8923,
  [8924] = 5776,
  [8925] = 8757,
  [8926] = 8926,
  [8927] = 2391,
  [8928] = 8870,
  [8929] = 8929,
  [8930] = 2390,
  [8931] = 2386,
  [8932] = 2383,
  [8933] = 4174,
  [8934] = 8923,
  [8935] = 8935,
  [8936] = 8936,
  [8937] = 2381,
  [8938] = 8938,
  [8939] = 8939,
  [8940] = 8940,
  [8941] = 8870,
  [8942] = 8374,
  [8943] = 8943,
  [8944] = 8371,
  [8945] = 8359,
  [8946] = 8361,
  [8947] = 8360,
  [8948] = 8358,
  [8949] = 8357,
  [8950] = 8950,
  [8951] = 8951,
  [8952] = 8952,
  [8953] = 8953,
  [8954] = 8954,
  [8955] = 8955,
  [8956] = 2313,
  [8957] = 2310,
  [8958] = 2311,
  [8959] = 8959,
  [8960] = 8371,
  [8961] = 8961,
  [8962] = 8962,
  [8963] = 8963,
  [8964] = 8361,
  [8965] = 2952,
  [8966] = 8360,
  [8967] = 8359,
  [8968] = 8358,
  [8969] = 8969,
  [8970] = 8970,
  [8971] = 8357,
  [8972] = 8972,
  [8973] = 2381,
  [8974] = 8970,
  [8975] = 8380,
  [8976] = 8976,
  [8977] = 8972,
  [8978] = 8355,
  [8979] = 8381,
  [8980] = 8980,
  [8981] = 2386,
  [8982] = 8982,
  [8983] = 2387,
  [8984] = 2390,
  [8985] = 2391,
  [8986] = 8986,
  [8987] = 2310,
  [8988] = 8382,
  [8989] = 8989,
  [8990] = 8990,
  [8991] = 8991,
  [8992] = 8992,
  [8993] = 2343,
  [8994] = 8994,
  [8995] = 8995,
  [8996] = 8996,
  [8997] = 8997,
  [8998] = 8998,
  [8999] = 8970,
  [9000] = 8370,
  [9001] = 8755,
  [9002] = 8757,
  [9003] = 9003,
  [9004] = 9004,
  [9005] = 9005,
  [9006] = 9006,
  [9007] = 9007,
  [9008] = 9008,
  [9009] = 9009,
  [9010] = 9010,
  [9011] = 9011,
  [9012] = 8760,
  [9013] = 9013,
  [9014] = 9014,
  [9015] = 8972,
  [9016] = 9016,
  [9017] = 9017,
  [9018] = 9018,
  [9019] = 9019,
  [9020] = 9020,
  [9021] = 8762,
  [9022] = 8733,
  [9023] = 9023,
  [9024] = 9024,
  [9025] = 9025,
  [9026] = 9026,
  [9027] = 9027,
  [9028] = 9028,
  [9029] = 9029,
  [9030] = 9030,
  [9031] = 9031,
  [9032] = 9032,
  [9033] = 9033,
  [9034] = 8970,
  [9035] = 8970,
  [9036] = 8972,
  [9037] = 9037,
  [9038] = 9038,
  [9039] = 9039,
  [9040] = 9040,
  [9041] = 9041,
  [9042] = 9042,
  [9043] = 9043,
  [9044] = 9044,
  [9045] = 8970,
  [9046] = 9046,
  [9047] = 9047,
  [9048] = 9048,
  [9049] = 8970,
  [9050] = 9050,
  [9051] = 2383,
  [9052] = 2313,
  [9053] = 2311,
  [9054] = 9054,
  [9055] = 9055,
  [9056] = 9056,
  [9057] = 9057,
  [9058] = 8972,
  [9059] = 9059,
  [9060] = 9060,
  [9061] = 8827,
  [9062] = 9062,
  [9063] = 9063,
  [9064] = 9064,
  [9065] = 9065,
  [9066] = 8834,
  [9067] = 9067,
  [9068] = 9068,
  [9069] = 9069,
  [9070] = 9070,
  [9071] = 8970,
  [9072] = 8802,
  [9073] = 8770,
  [9074] = 9074,
  [9075] = 8374,
  [9076] = 9076,
  [9077] = 9077,
  [9078] = 8833,
  [9079] = 9079,
  [9080] = 9080,
  [9081] = 9081,
  [9082] = 9082,
  [9083] = 9083,
  [9084] = 9084,
  [9085] = 2332,
  [9086] = 9086,
  [9087] = 9087,
  [9088] = 2333,
  [9089] = 2316,
  [9090] = 9090,
  [9091] = 9091,
  [9092] = 8375,
  [9093] = 2324,
  [9094] = 8972,
  [9095] = 9095,
  [9096] = 8970,
  [9097] = 2319,
  [9098] = 8959,
  [9099] = 9099,
  [9100] = 9100,
  [9101] = 9101,
  [9102] = 8377,
  [9103] = 9103,
  [9104] = 2306,
  [9105] = 9105,
  [9106] = 2358,
  [9107] = 9107,
  [9108] = 2351,
  [9109] = 9109,
  [9110] = 9110,
  [9111] = 2306,
  [9112] = 9112,
  [9113] = 9113,
  [9114] = 9114,
  [9115] = 2325,
  [9116] = 9116,
  [9117] = 9117,
  [9118] = 9118,
  [9119] = 2334,
  [9120] = 9120,
  [9121] = 9121,
  [9122] = 9122,
  [9123] = 9123,
  [9124] = 9124,
  [9125] = 9125,
  [9126] = 9126,
  [9127] = 9127,
  [9128] = 9128,
  [9129] = 9129,
  [9130] = 9130,
  [9131] = 9131,
  [9132] = 9132,
  [9133] = 9133,
  [9134] = 8923,
  [9135] = 9135,
  [9136] = 9136,
  [9137] = 8972,
  [9138] = 9138,
  [9139] = 9139,
  [9140] = 8970,
  [9141] = 9141,
  [9142] = 9142,
  [9143] = 9143,
  [9144] = 9144,
  [9145] = 9145,
  [9146] = 9146,
  [9147] = 9147,
  [9148] = 9148,
  [9149] = 9148,
  [9150] = 9150,
  [9151] = 9151,
  [9152] = 9152,
  [9153] = 9153,
  [9154] = 9150,
  [9155] = 9150,
  [9156] = 9150,
  [9157] = 9157,
  [9158] = 9158,
  [9159] = 9159,
  [9160] = 9160,
  [9161] = 9144,
  [9162] = 9153,
  [9163] = 9163,
  [9164] = 9150,
  [9165] = 9165,
  [9166] = 9166,
  [9167] = 9167,
  [9168] = 9168,
  [9169] = 9144,
  [9170] = 9144,
  [9171] = 9142,
  [9172] = 9172,
  [9173] = 9158,
  [9174] = 9144,
  [9175] = 9150,
  [9176] = 9176,
  [9177] = 9177,
  [9178] = 9144,
  [9179] = 9159,
  [9180] = 9180,
  [9181] = 9163,
  [9182] = 9182,
  [9183] = 9150,
  [9184] = 9184,
  [9185] = 9151,
  [9186] = 9159,
  [9187] = 9158,
  [9188] = 9150,
  [9189] = 9144,
  [9190] = 9157,
  [9191] = 9191,
  [9192] = 9192,
  [9193] = 9157,
  [9194] = 9141,
  [9195] = 9195,
  [9196] = 9150,
  [9197] = 9150,
  [9198] = 9198,
  [9199] = 9141,
  [9200] = 9200,
  [9201] = 9151,
  [9202] = 9184,
  [9203] = 9148,
  [9204] = 9144,
  [9205] = 9167,
  [9206] = 9143,
  [9207] = 9141,
  [9208] = 9157,
  [9209] = 9146,
  [9210] = 9146,
  [9211] = 9143,
  [9212] = 9150,
  [9213] = 9151,
  [9214] = 9214,
  [9215] = 9159,
  [9216] = 9167,
  [9217] = 9217,
  [9218] = 9184,
  [9219] = 9144,
  [9220] = 9150,
  [9221] = 9150,
  [9222] = 9144,
  [9223] = 9191,
  [9224] = 9224,
  [9225] = 9225,
  [9226] = 8929,
  [9227] = 9144,
  [9228] = 9228,
  [9229] = 9158,
  [9230] = 9144,
  [9231] = 9191,
  [9232] = 9150,
  [9233] = 9172,
  [9234] = 9150,
  [9235] = 9148,
  [9236] = 9142,
  [9237] = 9150,
  [9238] = 9191,
  [9239] = 9142,
  [9240] = 9240,
  [9241] = 9159,
  [9242] = 9242,
  [9243] = 9157,
  [9244] = 9144,
  [9245] = 9228,
  [9246] = 9246,
  [9247] = 9144,
  [9248] = 4174,
  [9249] = 9150,
  [9250] = 9144,
  [9251] = 8390,
  [9252] = 9150,
  [9253] = 9200,
  [9254] = 9144,
  [9255] = 9153,
  [9256] = 9256,
  [9257] = 9257,
  [9258] = 9258,
  [9259] = 9166,
  [9260] = 9142,
  [9261] = 9166,
  [9262] = 9144,
  [9263] = 9144,
  [9264] = 9264,
  [9265] = 8361,
  [9266] = 9150,
  [9267] = 9153,
  [9268] = 9145,
  [9269] = 9150,
  [9270] = 9150,
  [9271] = 9144,
  [9272] = 9141,
  [9273] = 5776,
  [9274] = 9274,
  [9275] = 9275,
  [9276] = 9276,
  [9277] = 9151,
  [9278] = 9150,
  [9279] = 9144,
  [9280] = 9145,
  [9281] = 9150,
  [9282] = 9184,
  [9283] = 9148,
  [9284] = 9200,
  [9285] = 9166,
  [9286] = 9172,
  [9287] = 9150,
  [9288] = 9144,
  [9289] = 9142,
  [9290] = 9214,
  [9291] = 9291,
  [9292] = 2303,
  [9293] = 9142,
  [9294] = 9184,
  [9295] = 9172,
  [9296] = 9144,
  [9297] = 9172,
  [9298] = 8893,
  [9299] = 9184,
  [9300] = 9172,
  [9301] = 9301,
  [9302] = 9302,
  [9303] = 9224,
  [9304] = 9304,
  [9305] = 9158,
  [9306] = 2309,
  [9307] = 9167,
  [9308] = 9308,
  [9309] = 9146,
  [9310] = 9143,
  [9311] = 8675,
  [9312] = 9144,
  [9313] = 9200,
  [9314] = 9167,
  [9315] = 9315,
  [9316] = 9144,
  [9317] = 9158,
  [9318] = 9144,
  [9319] = 9180,
  [9320] = 9200,
  [9321] = 9172,
  [9322] = 9145,
  [9323] = 9145,
  [9324] = 9200,
  [9325] = 9325,
  [9326] = 9142,
  [9327] = 9148,
  [9328] = 9151,
  [9329] = 9167,
  [9330] = 9330,
  [9331] = 7727,
  [9332] = 9141,
  [9333] = 9333,
  [9334] = 9150,
  [9335] = 9157,
  [9336] = 9336,
  [9337] = 9144,
  [9338] = 8357,
  [9339] = 9159,
  [9340] = 9143,
  [9341] = 8755,
  [9342] = 9157,
  [9343] = 9141,
  [9344] = 9159,
  [9345] = 9145,
  [9346] = 9151,
  [9347] = 9148,
  [9348] = 9144,
  [9349] = 9148,
  [9350] = 9146,
  [9351] = 8358,
  [9352] = 9184,
  [9353] = 9150,
  [9354] = 9142,
  [9355] = 8757,
  [9356] = 8760,
  [9357] = 9150,
  [9358] = 9192,
  [9359] = 9145,
  [9360] = 9151,
  [9361] = 8762,
  [9362] = 9172,
  [9363] = 8733,
  [9364] = 8770,
  [9365] = 9144,
  [9366] = 9141,
  [9367] = 9200,
  [9368] = 9150,
  [9369] = 9191,
  [9370] = 9370,
  [9371] = 8359,
  [9372] = 9145,
  [9373] = 9157,
  [9374] = 9146,
  [9375] = 9144,
  [9376] = 9143,
  [9377] = 9159,
  [9378] = 9200,
  [9379] = 2391,
  [9380] = 9191,
  [9381] = 9144,
  [9382] = 9158,
  [9383] = 9150,
  [9384] = 9384,
  [9385] = 9142,
  [9386] = 2390,
  [9387] = 9167,
  [9388] = 9388,
  [9389] = 2387,
  [9390] = 2386,
  [9391] = 9143,
  [9392] = 9146,
  [9393] = 9142,
  [9394] = 9394,
  [9395] = 2383,
  [9396] = 2381,
  [9397] = 9397,
  [9398] = 9142,
  [9399] = 9399,
  [9400] = 9191,
  [9401] = 9172,
  [9402] = 9402,
  [9403] = 9166,
  [9404] = 8936,
  [9405] = 9142,
  [9406] = 8935,
  [9407] = 9407,
  [9408] = 9408,
  [9409] = 9144,
  [9410] = 9410,
  [9411] = 9411,
  [9412] = 9150,
  [9413] = 8360,
  [9414] = 9191,
  [9415] = 9158,
  [9416] = 9416,
  [9417] = 9417,
  [9418] = 9418,
  [9419] = 9142,
  [9420] = 9144,
  [9421] = 9200,
  [9422] = 9422,
  [9423] = 9153,
  [9424] = 9184,
  [9425] = 9425,
  [9426] = 9426,
  [9427] = 9150,
  [9428] = 9150,
  [9429] = 9184,
  [9430] = 9150,
  [9431] = 9150,
  [9432] = 9432,
  [9433] = 9150,
  [9434] = 9150,
  [9435] = 9150,
  [9436] = 9150,
  [9437] = 9437,
  [9438] = 9163,
  [9439] = 9150,
  [9440] = 9144,
  [9441] = 9150,
  [9442] = 9150,
  [9443] = 9443,
  [9444] = 8923,
  [9445] = 9145,
  [9446] = 9146,
  [9447] = 9150,
  [9448] = 9150,
  [9449] = 9449,
  [9450] = 9450,
  [9451] = 9214,
  [9452] = 9167,
  [9453] = 8639,
  [9454] = 9158,
  [9455] = 9455,
  [9456] = 9456,
  [9457] = 9150,
  [9458] = 9153,
  [9459] = 9144,
  [9460] = 9150,
  [9461] = 9148,
  [9462] = 9462,
  [9463] = 9150,
  [9464] = 9150,
  [9465] = 9465,
  [9466] = 9144,
  [9467] = 9467,
  [9468] = 9144,
  [9469] = 9191,
  [9470] = 9166,
  [9471] = 9144,
  [9472] = 9144,
  [9473] = 9166,
  [9474] = 9151,
  [9475] = 9144,
  [9476] = 9476,
  [9477] = 9142,
  [9478] = 9166,
  [9479] = 9153,
  [9480] = 9150,
  [9481] = 9153,
  [9482] = 9482,
  [9483] = 9145,
  [9484] = 9144,
  [9485] = 9485,
  [9486] = 2306,
  [9487] = 9153,
  [9488] = 9153,
  [9489] = 9153,
  [9490] = 9150,
  [9491] = 9142,
  [9492] = 9167,
  [9493] = 9200,
  [9494] = 9224,
  [9495] = 9184,
  [9496] = 9172,
  [9497] = 9142,
  [9498] = 9166,
  [9499] = 4174,
  [9500] = 9166,
  [9501] = 9184,
  [9502] = 9144,
  [9503] = 9141,
  [9504] = 9142,
  [9505] = 9505,
  [9506] = 9506,
  [9507] = 2241,
  [9508] = 9144,
  [9509] = 9144,
  [9510] = 9510,
  [9511] = 9150,
  [9512] = 9150,
  [9513] = 9146,
  [9514] = 9143,
  [9515] = 9146,
  [9516] = 9144,
  [9517] = 9143,
  [9518] = 9167,
  [9519] = 9167,
  [9520] = 9228,
  [9521] = 9158,
  [9522] = 9148,
  [9523] = 9523,
  [9524] = 9158,
  [9525] = 9151,
  [9526] = 9144,
  [9527] = 9150,
  [9528] = 9157,
  [9529] = 9150,
  [9530] = 9141,
  [9531] = 9191,
  [9532] = 9157,
  [9533] = 9533,
  [9534] = 9144,
  [9535] = 9144,
  [9536] = 9144,
  [9537] = 9143,
  [9538] = 9159,
  [9539] = 9159,
  [9540] = 8371,
  [9541] = 9541,
  [9542] = 9542,
  [9543] = 9543,
  [9544] = 9544,
  [9545] = 9545,
  [9546] = 9546,
  [9547] = 9547,
  [9548] = 2952,
  [9549] = 9549,
  [9550] = 9542,
  [9551] = 9551,
  [9552] = 9552,
  [9553] = 9542,
  [9554] = 9554,
  [9555] = 9555,
  [9556] = 9556,
  [9557] = 9557,
  [9558] = 9558,
  [9559] = 9559,
  [9560] = 9065,
  [9561] = 9561,
  [9562] = 9549,
  [9563] = 9559,
  [9564] = 9564,
  [9565] = 9565,
  [9566] = 9566,
  [9567] = 9032,
  [9568] = 9559,
  [9569] = 9554,
  [9570] = 9559,
  [9571] = 9549,
  [9572] = 9541,
  [9573] = 9573,
  [9574] = 9574,
  [9575] = 9575,
  [9576] = 9559,
  [9577] = 9577,
  [9578] = 9578,
  [9579] = 9579,
  [9580] = 9554,
  [9581] = 9551,
  [9582] = 9582,
  [9583] = 8963,
  [9584] = 9584,
  [9585] = 9585,
  [9586] = 9575,
  [9587] = 9587,
  [9588] = 2952,
  [9589] = 9589,
  [9590] = 8962,
  [9591] = 9541,
  [9592] = 8969,
  [9593] = 9559,
  [9594] = 8961,
  [9595] = 9595,
  [9596] = 9596,
  [9597] = 9597,
  [9598] = 9542,
  [9599] = 9551,
  [9600] = 9541,
  [9601] = 9601,
  [9602] = 9602,
  [9603] = 9566,
  [9604] = 8722,
  [9605] = 9605,
  [9606] = 9606,
  [9607] = 9607,
  [9608] = 9608,
  [9609] = 9573,
  [9610] = 9610,
  [9611] = 9611,
  [9612] = 9612,
  [9613] = 9613,
  [9614] = 4174,
  [9615] = 9615,
  [9616] = 9616,
  [9617] = 9617,
  [9618] = 9618,
  [9619] = 9619,
  [9620] = 9620,
  [9621] = 9543,
  [9622] = 9622,
  [9623] = 9623,
  [9624] = 8995,
  [9625] = 9575,
  [9626] = 9566,
  [9627] = 9627,
  [9628] = 9057,
  [9629] = 9606,
  [9630] = 9615,
  [9631] = 9056,
  [9632] = 9541,
  [9633] = 9633,
  [9634] = 9133,
  [9635] = 9635,
  [9636] = 9636,
  [9637] = 9637,
  [9638] = 9636,
  [9639] = 9606,
  [9640] = 9595,
  [9641] = 7881,
  [9642] = 9117,
  [9643] = 9559,
  [9644] = 9579,
  [9645] = 9645,
  [9646] = 9635,
  [9647] = 9647,
  [9648] = 9138,
  [9649] = 9139,
  [9650] = 9650,
  [9651] = 8639,
  [9652] = 9652,
  [9653] = 9559,
  [9654] = 9654,
  [9655] = 9542,
  [9656] = 8864,
  [9657] = 9559,
  [9658] = 9658,
  [9659] = 9659,
  [9660] = 9660,
  [9661] = 9661,
  [9662] = 8998,
  [9663] = 9542,
  [9664] = 8390,
  [9665] = 9665,
  [9666] = 9579,
  [9667] = 9573,
  [9668] = 9668,
  [9669] = 9669,
  [9670] = 9602,
  [9671] = 9602,
  [9672] = 9672,
  [9673] = 9566,
  [9674] = 8675,
  [9675] = 9620,
  [9676] = 9543,
  [9677] = 9620,
  [9678] = 9055,
  [9679] = 9541,
  [9680] = 9680,
  [9681] = 9585,
  [9682] = 9682,
  [9683] = 9683,
  [9684] = 9684,
  [9685] = 9685,
  [9686] = 9573,
  [9687] = 9541,
  [9688] = 9688,
  [9689] = 9689,
  [9690] = 9690,
  [9691] = 6617,
  [9692] = 9692,
  [9693] = 9559,
  [9694] = 9694,
  [9695] = 7727,
  [9696] = 9573,
  [9697] = 9697,
  [9698] = 9636,
  [9699] = 9566,
  [9700] = 9700,
  [9701] = 9585,
  [9702] = 9048,
  [9703] = 9703,
  [9704] = 9704,
  [9705] = 9705,
  [9706] = 9706,
  [9707] = 9707,
  [9708] = 9707,
  [9709] = 9709,
  [9710] = 9710,
  [9711] = 9710,
  [9712] = 9712,
  [9713] = 9706,
  [9714] = 9714,
  [9715] = 9706,
  [9716] = 9716,
  [9717] = 9717,
  [9718] = 9718,
  [9719] = 9718,
  [9720] = 9718,
  [9721] = 9721,
  [9722] = 9722,
  [9723] = 9723,
  [9724] = 9724,
  [9725] = 9706,
  [9726] = 9706,
  [9727] = 9727,
  [9728] = 9714,
  [9729] = 9706,
  [9730] = 9706,
  [9731] = 9731,
  [9732] = 9732,
  [9733] = 9733,
  [9734] = 9718,
  [9735] = 9735,
  [9736] = 9718,
  [9737] = 9737,
  [9738] = 9724,
  [9739] = 9716,
  [9740] = 9740,
  [9741] = 9722,
  [9742] = 9742,
  [9743] = 7684,
  [9744] = 9744,
  [9745] = 9745,
  [9746] = 7674,
  [9747] = 9718,
  [9748] = 9748,
  [9749] = 8770,
  [9750] = 9750,
  [9751] = 9751,
  [9752] = 8733,
  [9753] = 9718,
  [9754] = 8762,
  [9755] = 8760,
  [9756] = 9706,
  [9757] = 9757,
  [9758] = 9758,
  [9759] = 8757,
  [9760] = 9706,
  [9761] = 9761,
  [9762] = 9762,
  [9763] = 7910,
  [9764] = 9706,
  [9765] = 7907,
  [9766] = 9717,
  [9767] = 9706,
  [9768] = 9718,
  [9769] = 9769,
  [9770] = 9770,
  [9771] = 9770,
  [9772] = 9772,
  [9773] = 9733,
  [9774] = 9774,
  [9775] = 9718,
  [9776] = 9706,
  [9777] = 8371,
  [9778] = 2926,
  [9779] = 9723,
  [9780] = 9718,
  [9781] = 9718,
  [9782] = 9706,
  [9783] = 9735,
  [9784] = 9718,
  [9785] = 9706,
  [9786] = 9724,
  [9787] = 8722,
  [9788] = 9716,
  [9789] = 9714,
  [9790] = 9718,
  [9791] = 9710,
  [9792] = 9727,
  [9793] = 9716,
  [9794] = 9714,
  [9795] = 9706,
  [9796] = 9710,
  [9797] = 7709,
  [9798] = 9718,
  [9799] = 9740,
  [9800] = 9724,
  [9801] = 9732,
  [9802] = 9732,
  [9803] = 7596,
  [9804] = 9732,
  [9805] = 9706,
  [9806] = 9722,
  [9807] = 9706,
  [9808] = 9706,
  [9809] = 9706,
  [9810] = 9718,
  [9811] = 9732,
  [9812] = 9718,
  [9813] = 9718,
  [9814] = 9814,
  [9815] = 8361,
  [9816] = 9735,
  [9817] = 9735,
  [9818] = 9770,
  [9819] = 9707,
  [9820] = 9820,
  [9821] = 9722,
  [9822] = 8755,
  [9823] = 2306,
  [9824] = 9707,
  [9825] = 9733,
  [9826] = 9718,
  [9827] = 9722,
  [9828] = 9733,
  [9829] = 9706,
  [9830] = 9707,
  [9831] = 9706,
  [9832] = 9733,
  [9833] = 9718,
  [9834] = 9707,
  [9835] = 9772,
  [9836] = 9718,
  [9837] = 9718,
  [9838] = 9838,
  [9839] = 9733,
  [9840] = 9840,
  [9841] = 9706,
  [9842] = 9718,
  [9843] = 8360,
  [9844] = 8359,
  [9845] = 8358,
  [9846] = 8357,
  [9847] = 9733,
  [9848] = 9718,
  [9849] = 9722,
  [9850] = 9850,
  [9851] = 9707,
  [9852] = 9772,
  [9853] = 9740,
  [9854] = 9733,
  [9855] = 9727,
  [9856] = 9722,
  [9857] = 9706,
  [9858] = 9706,
  [9859] = 9770,
  [9860] = 9718,
  [9861] = 9706,
  [9862] = 9735,
  [9863] = 8371,
  [9864] = 9735,
  [9865] = 9724,
  [9866] = 9718,
  [9867] = 9595,
  [9868] = 9724,
  [9869] = 9742,
  [9870] = 9870,
  [9871] = 9717,
  [9872] = 9872,
  [9873] = 9718,
  [9874] = 8361,
  [9875] = 9718,
  [9876] = 2339,
  [9877] = 9706,
  [9878] = 9724,
  [9879] = 8360,
  [9880] = 8359,
  [9881] = 9770,
  [9882] = 9732,
  [9883] = 8358,
  [9884] = 9732,
  [9885] = 8357,
  [9886] = 2359,
  [9887] = 9872,
  [9888] = 9770,
  [9889] = 9710,
  [9890] = 9706,
  [9891] = 9710,
  [9892] = 8595,
  [9893] = 9706,
  [9894] = 9714,
  [9895] = 9718,
  [9896] = 9716,
  [9897] = 9710,
  [9898] = 9714,
  [9899] = 9706,
  [9900] = 9718,
  [9901] = 9901,
  [9902] = 9718,
  [9903] = 9903,
  [9904] = 9718,
  [9905] = 9737,
  [9906] = 9732,
  [9907] = 9717,
  [9908] = 9706,
  [9909] = 9745,
  [9910] = 9716,
  [9911] = 9737,
  [9912] = 9714,
  [9913] = 9710,
  [9914] = 9718,
  [9915] = 9732,
  [9916] = 9706,
  [9917] = 9706,
  [9918] = 9723,
  [9919] = 9717,
  [9920] = 9718,
  [9921] = 9706,
  [9922] = 9735,
  [9923] = 9770,
  [9924] = 9718,
  [9925] = 9714,
  [9926] = 9706,
  [9927] = 9727,
  [9928] = 9706,
  [9929] = 9929,
  [9930] = 9716,
  [9931] = 9770,
  [9932] = 9745,
  [9933] = 9740,
  [9934] = 9722,
  [9935] = 9735,
  [9936] = 9737,
  [9937] = 9718,
  [9938] = 9938,
  [9939] = 9707,
  [9940] = 9710,
  [9941] = 9941,
  [9942] = 9731,
  [9943] = 9733,
  [9944] = 8574,
  [9945] = 9718,
  [9946] = 9718,
  [9947] = 9716,
  [9948] = 9714,
  [9949] = 9737,
  [9950] = 9770,
  [9951] = 7643,
  [9952] = 9745,
  [9953] = 9953,
  [9954] = 9706,
  [9955] = 7724,
  [9956] = 9938,
  [9957] = 9718,
  [9958] = 9716,
  [9959] = 9716,
  [9960] = 9714,
  [9961] = 9961,
  [9962] = 9710,
  [9963] = 9745,
  [9964] = 9718,
  [9965] = 9718,
  [9966] = 9718,
  [9967] = 9706,
  [9968] = 9968,
  [9969] = 9735,
  [9970] = 9718,
  [9971] = 9706,
  [9972] = 9706,
  [9973] = 9718,
  [9974] = 9718,
  [9975] = 9706,
  [9976] = 9732,
  [9977] = 9977,
  [9978] = 9724,
  [9979] = 9724,
  [9980] = 9980,
  [9981] = 9981,
  [9982] = 9706,
  [9983] = 9706,
  [9984] = 9984,
  [9985] = 9718,
  [9986] = 9724,
  [9987] = 9706,
  [9988] = 9727,
  [9989] = 9989,
  [9990] = 9990,
  [9991] = 9718,
  [9992] = 9706,
  [9993] = 9735,
  [9994] = 9706,
  [9995] = 9995,
  [9996] = 9718,
  [9997] = 9740,
  [9998] = 9722,
  [9999] = 9999,
  [10000] = 9718,
  [10001] = 10001,
  [10002] = 8569,
  [10003] = 9718,
  [10004] = 8571,
  [10005] = 9718,
  [10006] = 9770,
  [10007] = 10007,
  [10008] = 9706,
  [10009] = 9733,
  [10010] = 9706,
  [10011] = 9707,
  [10012] = 9706,
  [10013] = 9707,
  [10014] = 9722,
  [10015] = 9769,
  [10016] = 10016,
  [10017] = 10017,
  [10018] = 2952,
  [10019] = 2316,
  [10020] = 5776,
  [10021] = 10021,
  [10022] = 2952,
  [10023] = 10023,
  [10024] = 2989,
  [10025] = 2994,
  [10026] = 10026,
  [10027] = 3025,
  [10028] = 10028,
  [10029] = 3026,
  [10030] = 10030,
  [10031] = 10031,
  [10032] = 2925,
  [10033] = 10033,
  [10034] = 10034,
  [10035] = 3028,
  [10036] = 2954,
  [10037] = 2943,
  [10038] = 10038,
  [10039] = 2941,
  [10040] = 2956,
  [10041] = 2990,
  [10042] = 7674,
  [10043] = 7684,
  [10044] = 7881,
  [10045] = 10045,
  [10046] = 10046,
  [10047] = 7643,
  [10048] = 7724,
  [10049] = 10049,
  [10050] = 10050,
  [10051] = 10051,
  [10052] = 10052,
  [10053] = 2952,
  [10054] = 2344,
  [10055] = 10055,
  [10056] = 7698,
  [10057] = 7701,
  [10058] = 10058,
  [10059] = 2926,
  [10060] = 10060,
  [10061] = 9618,
  [10062] = 10016,
  [10063] = 10063,
  [10064] = 10064,
  [10065] = 10017,
  [10066] = 7709,
  [10067] = 10067,
  [10068] = 10068,
  [10069] = 10069,
  [10070] = 10016,
  [10071] = 10071,
  [10072] = 10072,
  [10073] = 10064,
  [10074] = 10074,
  [10075] = 10075,
  [10076] = 8595,
  [10077] = 10077,
  [10078] = 10078,
  [10079] = 10079,
  [10080] = 10080,
  [10081] = 10081,
  [10082] = 10082,
  [10083] = 10082,
  [10084] = 10084,
  [10085] = 10085,
  [10086] = 10082,
  [10087] = 10087,
  [10088] = 10088,
  [10089] = 10082,
  [10090] = 10090,
  [10091] = 10082,
  [10092] = 10092,
  [10093] = 10093,
  [10094] = 10094,
  [10095] = 10082,
  [10096] = 10096,
  [10097] = 10021,
  [10098] = 10098,
  [10099] = 10082,
  [10100] = 10100,
  [10101] = 10101,
  [10102] = 10102,
  [10103] = 10103,
  [10104] = 10082,
  [10105] = 10105,
  [10106] = 10023,
  [10107] = 10026,
  [10108] = 10028,
  [10109] = 10082,
  [10110] = 10110,
  [10111] = 10111,
  [10112] = 10112,
  [10113] = 10082,
  [10114] = 10114,
  [10115] = 10016,
  [10116] = 10116,
  [10117] = 10082,
  [10118] = 10118,
  [10119] = 10119,
  [10120] = 10120,
  [10121] = 10071,
  [10122] = 10082,
  [10123] = 10123,
  [10124] = 10124,
  [10125] = 10063,
  [10126] = 10030,
  [10127] = 10031,
  [10128] = 10128,
  [10129] = 10129,
  [10130] = 10130,
  [10131] = 10033,
  [10132] = 10132,
  [10133] = 10034,
  [10134] = 10082,
  [10135] = 10135,
  [10136] = 10016,
  [10137] = 10137,
  [10138] = 10138,
  [10139] = 10139,
  [10140] = 10140,
  [10141] = 10141,
  [10142] = 10142,
  [10143] = 10143,
  [10144] = 10052,
  [10145] = 10051,
  [10146] = 10146,
  [10147] = 10123,
  [10148] = 10017,
  [10149] = 10149,
  [10150] = 10150,
  [10151] = 10151,
  [10152] = 8864,
  [10153] = 10153,
  [10154] = 10154,
  [10155] = 10155,
  [10156] = 10082,
  [10157] = 10051,
  [10158] = 10052,
  [10159] = 10159,
  [10160] = 10160,
  [10161] = 10161,
  [10162] = 10123,
  [10163] = 10034,
  [10164] = 10033,
  [10165] = 10031,
  [10166] = 10166,
  [10167] = 10167,
  [10168] = 10030,
  [10169] = 10169,
  [10170] = 10170,
  [10171] = 10082,
  [10172] = 10172,
  [10173] = 10173,
  [10174] = 10123,
  [10175] = 10068,
  [10176] = 10176,
  [10177] = 10071,
  [10178] = 10082,
  [10179] = 10179,
  [10180] = 10180,
  [10181] = 10021,
  [10182] = 10182,
  [10183] = 10023,
  [10184] = 10026,
  [10185] = 10185,
  [10186] = 10028,
  [10187] = 10187,
  [10188] = 10028,
  [10189] = 10026,
  [10190] = 10023,
  [10191] = 10191,
  [10192] = 10192,
  [10193] = 10193,
  [10194] = 10021,
  [10195] = 10195,
  [10196] = 10123,
  [10197] = 10197,
  [10198] = 10198,
  [10199] = 10199,
  [10200] = 10195,
  [10201] = 10201,
  [10202] = 10102,
  [10203] = 10098,
  [10204] = 10030,
  [10205] = 10031,
  [10206] = 10082,
  [10207] = 10033,
  [10208] = 10034,
  [10209] = 10093,
  [10210] = 10050,
  [10211] = 10055,
  [10212] = 10212,
  [10213] = 8294,
  [10214] = 10214,
  [10215] = 10123,
  [10216] = 10216,
  [10217] = 10082,
  [10218] = 8297,
  [10219] = 10055,
  [10220] = 10220,
  [10221] = 10221,
  [10222] = 10222,
  [10223] = 10223,
  [10224] = 10224,
  [10225] = 10051,
  [10226] = 10052,
  [10227] = 8574,
  [10228] = 10123,
  [10229] = 10064,
  [10230] = 10082,
  [10231] = 9595,
  [10232] = 9574,
  [10233] = 10233,
  [10234] = 10234,
  [10235] = 10235,
  [10236] = 10236,
  [10237] = 10237,
  [10238] = 10238,
  [10239] = 10239,
  [10240] = 10240,
  [10241] = 10241,
  [10242] = 10242,
  [10243] = 10243,
  [10244] = 10123,
  [10245] = 10071,
  [10246] = 9619,
  [10247] = 9622,
  [10248] = 7015,
  [10249] = 7658,
  [10250] = 10250,
  [10251] = 10251,
  [10252] = 10252,
  [10253] = 10082,
  [10254] = 10254,
  [10255] = 10016,
  [10256] = 9023,
  [10257] = 10074,
  [10258] = 10258,
  [10259] = 10259,
  [10260] = 7596,
  [10261] = 10261,
  [10262] = 10262,
  [10263] = 10075,
  [10264] = 10264,
  [10265] = 10265,
  [10266] = 10266,
  [10267] = 10267,
  [10268] = 10268,
  [10269] = 10269,
  [10270] = 10240,
  [10271] = 10241,
  [10272] = 10272,
  [10273] = 10123,
  [10274] = 10078,
  [10275] = 10275,
  [10276] = 10276,
  [10277] = 10277,
  [10278] = 10278,
  [10279] = 10279,
  [10280] = 10280,
  [10281] = 10281,
  [10282] = 10282,
  [10283] = 10283,
  [10284] = 9682,
  [10285] = 10285,
  [10286] = 10286,
  [10287] = 10287,
  [10288] = 10082,
  [10289] = 8290,
  [10290] = 10290,
  [10291] = 10291,
  [10292] = 10292,
  [10293] = 10293,
  [10294] = 10294,
  [10295] = 10295,
  [10296] = 10296,
  [10297] = 10297,
  [10298] = 10298,
  [10299] = 10016,
  [10300] = 10300,
  [10301] = 10301,
  [10302] = 10016,
  [10303] = 10017,
  [10304] = 10304,
  [10305] = 10305,
  [10306] = 10071,
  [10307] = 10307,
  [10308] = 10308,
  [10309] = 10309,
  [10310] = 10016,
  [10311] = 10016,
  [10312] = 10312,
  [10313] = 10016,
  [10314] = 10016,
  [10315] = 10016,
  [10316] = 10316,
  [10317] = 10016,
  [10318] = 10016,
  [10319] = 10319,
  [10320] = 10016,
  [10321] = 10028,
  [10322] = 10023,
  [10323] = 10016,
  [10324] = 10028,
  [10325] = 10023,
  [10326] = 10016,
  [10327] = 10028,
  [10328] = 10023,
  [10329] = 10016,
  [10330] = 10021,
  [10331] = 10331,
  [10332] = 10023,
  [10333] = 10026,
  [10334] = 10028,
  [10335] = 10028,
  [10336] = 10023,
  [10337] = 10016,
  [10338] = 10052,
  [10339] = 10240,
  [10340] = 10028,
  [10341] = 10023,
  [10342] = 10016,
  [10343] = 10052,
  [10344] = 10051,
  [10345] = 10028,
  [10346] = 10346,
  [10347] = 10026,
  [10348] = 10123,
  [10349] = 10051,
  [10350] = 10052,
  [10351] = 10023,
  [10352] = 10071,
  [10353] = 10021,
  [10354] = 10064,
  [10355] = 10016,
  [10356] = 10052,
  [10357] = 10051,
  [10358] = 10074,
  [10359] = 10028,
  [10360] = 10360,
  [10361] = 10026,
  [10362] = 10362,
  [10363] = 10363,
  [10364] = 10023,
  [10365] = 10052,
  [10366] = 10021,
  [10367] = 10075,
  [10368] = 9968,
  [10369] = 10051,
  [10370] = 10016,
  [10371] = 9977,
  [10372] = 10016,
  [10373] = 10373,
  [10374] = 10078,
  [10375] = 10052,
  [10376] = 10051,
  [10377] = 10028,
  [10378] = 10026,
  [10379] = 10379,
  [10380] = 10023,
  [10381] = 10381,
  [10382] = 10034,
  [10383] = 10021,
  [10384] = 10384,
  [10385] = 10385,
  [10386] = 10386,
  [10387] = 10016,
  [10388] = 10388,
  [10389] = 10389,
  [10390] = 10021,
  [10391] = 10391,
  [10392] = 10052,
  [10393] = 10051,
  [10394] = 10023,
  [10395] = 10026,
  [10396] = 10396,
  [10397] = 10016,
  [10398] = 10028,
  [10399] = 10021,
  [10400] = 10033,
  [10401] = 10023,
  [10402] = 10026,
  [10403] = 10031,
  [10404] = 10028,
  [10405] = 10030,
  [10406] = 10028,
  [10407] = 10026,
  [10408] = 10023,
  [10409] = 10021,
  [10410] = 10410,
  [10411] = 10411,
  [10412] = 10082,
  [10413] = 10413,
  [10414] = 10414,
  [10415] = 10016,
  [10416] = 10063,
  [10417] = 10051,
  [10418] = 10052,
  [10419] = 10052,
  [10420] = 10051,
  [10421] = 10421,
  [10422] = 10028,
  [10423] = 10026,
  [10424] = 10424,
  [10425] = 10023,
  [10426] = 10021,
  [10427] = 10028,
  [10428] = 10030,
  [10429] = 10016,
  [10430] = 10026,
  [10431] = 10023,
  [10432] = 10432,
  [10433] = 10021,
  [10434] = 10031,
  [10435] = 10128,
  [10436] = 10033,
  [10437] = 10021,
  [10438] = 10132,
  [10439] = 10034,
  [10440] = 10016,
  [10441] = 10026,
  [10442] = 10442,
  [10443] = 10028,
  [10444] = 10444,
  [10445] = 10052,
  [10446] = 10446,
  [10447] = 10051,
  [10448] = 10028,
  [10449] = 10026,
  [10450] = 10023,
  [10451] = 10021,
  [10452] = 10452,
  [10453] = 10453,
  [10454] = 10454,
  [10455] = 10455,
  [10456] = 10021,
  [10457] = 10457,
  [10458] = 10023,
  [10459] = 10026,
  [10460] = 10016,
  [10461] = 10028,
  [10462] = 10067,
  [10463] = 10463,
  [10464] = 10464,
  [10465] = 10465,
  [10466] = 10052,
  [10467] = 10051,
  [10468] = 10468,
  [10469] = 10469,
  [10470] = 10028,
  [10471] = 10471,
  [10472] = 10026,
  [10473] = 10473,
  [10474] = 10051,
  [10475] = 10052,
  [10476] = 10023,
  [10477] = 10477,
  [10478] = 10021,
  [10479] = 10052,
  [10480] = 10480,
  [10481] = 10481,
  [10482] = 10482,
  [10483] = 10483,
  [10484] = 10016,
  [10485] = 10016,
  [10486] = 10486,
  [10487] = 10487,
  [10488] = 10488,
  [10489] = 10119,
  [10490] = 10052,
  [10491] = 10051,
  [10492] = 10028,
  [10493] = 10026,
  [10494] = 10023,
  [10495] = 10495,
  [10496] = 10021,
  [10497] = 10216,
  [10498] = 10498,
  [10499] = 10071,
  [10500] = 10120,
  [10501] = 10023,
  [10502] = 10016,
  [10503] = 10503,
  [10504] = 10052,
  [10505] = 10051,
  [10506] = 10506,
  [10507] = 10507,
  [10508] = 10028,
  [10509] = 10509,
  [10510] = 10026,
  [10511] = 10021,
  [10512] = 10023,
  [10513] = 10023,
  [10514] = 10026,
  [10515] = 10021,
  [10516] = 10028,
  [10517] = 10517,
  [10518] = 10518,
  [10519] = 10519,
  [10520] = 10016,
  [10521] = 10521,
  [10522] = 10522,
  [10523] = 10523,
  [10524] = 10524,
  [10525] = 10525,
  [10526] = 10526,
  [10527] = 10527,
  [10528] = 10052,
  [10529] = 10051,
  [10530] = 10052,
  [10531] = 10051,
  [10532] = 10532,
  [10533] = 10028,
  [10534] = 10534,
  [10535] = 10026,
  [10536] = 10536,
  [10537] = 10537,
  [10538] = 10023,
  [10539] = 10021,
  [10540] = 10016,
  [10541] = 10541,
  [10542] = 10542,
  [10543] = 10543,
  [10544] = 10051,
  [10545] = 10545,
  [10546] = 10546,
  [10547] = 10547,
  [10548] = 10548,
  [10549] = 10549,
  [10550] = 10550,
  [10551] = 10551,
  [10552] = 10552,
  [10553] = 10016,
  [10554] = 10554,
  [10555] = 10555,
  [10556] = 10052,
  [10557] = 10051,
  [10558] = 10558,
  [10559] = 10028,
  [10560] = 10026,
  [10561] = 10023,
  [10562] = 10021,
  [10563] = 10563,
  [10564] = 10016,
  [10565] = 10565,
  [10566] = 10021,
  [10567] = 10241,
  [10568] = 10023,
  [10569] = 10026,
  [10570] = 10052,
  [10571] = 10028,
  [10572] = 10051,
  [10573] = 10028,
  [10574] = 10026,
  [10575] = 10023,
  [10576] = 10021,
  [10577] = 10071,
  [10578] = 10016,
  [10579] = 10579,
  [10580] = 10580,
  [10581] = 10016,
  [10582] = 10052,
  [10583] = 10051,
  [10584] = 10051,
  [10585] = 10052,
  [10586] = 10028,
  [10587] = 10052,
  [10588] = 10026,
  [10589] = 10051,
  [10590] = 10023,
  [10591] = 10021,
  [10592] = 10592,
  [10593] = 10593,
  [10594] = 10594,
  [10595] = 10016,
  [10596] = 10596,
  [10597] = 10034,
  [10598] = 10033,
  [10599] = 10031,
  [10600] = 10030,
  [10601] = 10016,
  [10602] = 10602,
  [10603] = 10603,
  [10604] = 10052,
  [10605] = 10051,
  [10606] = 10606,
  [10607] = 10028,
  [10608] = 10026,
  [10609] = 10023,
  [10610] = 10028,
  [10611] = 10611,
  [10612] = 10021,
  [10613] = 10026,
  [10614] = 10023,
  [10615] = 10021,
  [10616] = 10064,
  [10617] = 10016,
  [10618] = 10618,
  [10619] = 10619,
  [10620] = 10074,
  [10621] = 10021,
  [10622] = 10622,
  [10623] = 10023,
  [10624] = 10026,
  [10625] = 10625,
  [10626] = 10028,
  [10627] = 10052,
  [10628] = 10051,
  [10629] = 10075,
  [10630] = 10028,
  [10631] = 10026,
  [10632] = 10023,
  [10633] = 10021,
  [10634] = 10634,
  [10635] = 10635,
  [10636] = 10636,
  [10637] = 10637,
  [10638] = 10638,
  [10639] = 10051,
  [10640] = 10052,
  [10641] = 10016,
  [10642] = 10052,
  [10643] = 10051,
  [10644] = 10028,
  [10645] = 10021,
  [10646] = 10026,
  [10647] = 10023,
  [10648] = 10021,
  [10649] = 10016,
  [10650] = 10650,
  [10651] = 10651,
  [10652] = 10167,
  [10653] = 10023,
  [10654] = 10016,
  [10655] = 10655,
  [10656] = 10026,
  [10657] = 8569,
  [10658] = 10028,
  [10659] = 10052,
  [10660] = 10051,
  [10661] = 10028,
  [10662] = 10662,
  [10663] = 10166,
  [10664] = 10026,
  [10665] = 10023,
  [10666] = 10021,
  [10667] = 8571,
  [10668] = 10668,
  [10669] = 10016,
  [10670] = 10670,
  [10671] = 10063,
  [10672] = 10052,
  [10673] = 10051,
  [10674] = 10674,
  [10675] = 10021,
  [10676] = 10161,
  [10677] = 10023,
  [10678] = 10026,
  [10679] = 10679,
  [10680] = 10028,
  [10681] = 10681,
  [10682] = 10682,
  [10683] = 10028,
  [10684] = 10684,
  [10685] = 10026,
  [10686] = 10023,
  [10687] = 10021,
  [10688] = 10159,
  [10689] = 10030,
  [10690] = 10690,
  [10691] = 10016,
  [10692] = 10031,
  [10693] = 10051,
  [10694] = 10052,
  [10695] = 10128,
  [10696] = 10696,
  [10697] = 10033,
  [10698] = 10132,
  [10699] = 10699,
  [10700] = 10034,
  [10701] = 10016,
  [10702] = 10702,
  [10703] = 10016,
  [10704] = 10704,
  [10705] = 10705,
  [10706] = 10052,
  [10707] = 10051,
  [10708] = 10708,
  [10709] = 10709,
  [10710] = 10028,
  [10711] = 10026,
  [10712] = 10023,
  [10713] = 10021,
  [10714] = 10063,
  [10715] = 10715,
  [10716] = 10716,
  [10717] = 10717,
  [10718] = 10718,
  [10719] = 10719,
  [10720] = 10720,
  [10721] = 10721,
  [10722] = 10052,
  [10723] = 10723,
  [10724] = 10051,
  [10725] = 10021,
  [10726] = 10051,
  [10727] = 10023,
  [10728] = 10026,
  [10729] = 10052,
  [10730] = 10028,
  [10731] = 10028,
  [10732] = 10026,
  [10733] = 10023,
  [10734] = 10021,
  [10735] = 10735,
  [10736] = 10736,
  [10737] = 10737,
  [10738] = 10738,
  [10739] = 10016,
  [10740] = 10052,
  [10741] = 10051,
  [10742] = 10742,
  [10743] = 10051,
  [10744] = 10052,
  [10745] = 10745,
  [10746] = 10052,
  [10747] = 10747,
  [10748] = 10051,
  [10749] = 10749,
  [10750] = 10750,
  [10751] = 10016,
  [10752] = 10028,
  [10753] = 10753,
  [10754] = 10754,
  [10755] = 10071,
  [10756] = 10756,
  [10757] = 10026,
  [10758] = 10758,
  [10759] = 10023,
  [10760] = 10021,
  [10761] = 10016,
  [10762] = 10762,
  [10763] = 10763,
  [10764] = 10052,
  [10765] = 10051,
  [10766] = 10766,
  [10767] = 10028,
  [10768] = 10026,
  [10769] = 10023,
  [10770] = 10021,
  [10771] = 10771,
  [10772] = 10772,
  [10773] = 10021,
  [10774] = 10774,
  [10775] = 10023,
  [10776] = 10026,
  [10777] = 10777,
  [10778] = 10028,
  [10779] = 10016,
  [10780] = 10780,
  [10781] = 10030,
  [10782] = 10782,
  [10783] = 10783,
  [10784] = 10052,
  [10785] = 10051,
  [10786] = 10786,
  [10787] = 10028,
  [10788] = 10026,
  [10789] = 10023,
  [10790] = 10051,
  [10791] = 10052,
  [10792] = 10021,
  [10793] = 10031,
  [10794] = 10128,
  [10795] = 10071,
  [10796] = 10796,
  [10797] = 10033,
  [10798] = 10016,
  [10799] = 10016,
  [10800] = 10016,
  [10801] = 10132,
  [10802] = 10802,
  [10803] = 10052,
  [10804] = 10051,
  [10805] = 10805,
  [10806] = 10028,
  [10807] = 10026,
  [10808] = 10023,
  [10809] = 10021,
  [10810] = 10810,
  [10811] = 10034,
  [10812] = 10812,
  [10813] = 10813,
  [10814] = 10016,
  [10815] = 10815,
  [10816] = 10816,
  [10817] = 10052,
  [10818] = 10021,
  [10819] = 10819,
  [10820] = 10023,
  [10821] = 10026,
  [10822] = 10051,
  [10823] = 10028,
  [10824] = 10824,
  [10825] = 10028,
  [10826] = 10026,
  [10827] = 10023,
  [10828] = 10828,
  [10829] = 10021,
  [10830] = 10064,
  [10831] = 10831,
  [10832] = 10052,
  [10833] = 10051,
  [10834] = 10834,
  [10835] = 10051,
  [10836] = 10052,
  [10837] = 10074,
  [10838] = 10016,
  [10839] = 10839,
  [10840] = 10052,
  [10841] = 10051,
  [10842] = 10075,
  [10843] = 10016,
  [10844] = 10028,
  [10845] = 10026,
  [10846] = 10846,
  [10847] = 10847,
  [10848] = 10848,
  [10849] = 10023,
  [10850] = 10021,
  [10851] = 10851,
  [10852] = 10852,
  [10853] = 10016,
  [10854] = 10052,
  [10855] = 10051,
  [10856] = 10856,
  [10857] = 10028,
  [10858] = 10026,
  [10859] = 10023,
  [10860] = 10034,
  [10861] = 10132,
  [10862] = 10021,
  [10863] = 10021,
  [10864] = 10864,
  [10865] = 10023,
  [10866] = 10026,
  [10867] = 10033,
  [10868] = 10028,
  [10869] = 10128,
  [10870] = 10021,
  [10871] = 10023,
  [10872] = 10031,
  [10873] = 8770,
  [10874] = 8733,
  [10875] = 8762,
  [10876] = 8760,
  [10877] = 8757,
  [10878] = 8755,
  [10879] = 10026,
  [10880] = 10051,
  [10881] = 10052,
  [10882] = 10030,
  [10883] = 10028,
  [10884] = 10884,
  [10885] = 10063,
  [10886] = 10016,
  [10887] = 10887,
  [10888] = 10888,
  [10889] = 10889,
  [10890] = 2952,
  [10891] = 2354,
  [10892] = 10892,
  [10893] = 10893,
  [10894] = 10887,
  [10895] = 10893,
  [10896] = 7596,
  [10897] = 7727,
  [10898] = 9057,
  [10899] = 9056,
  [10900] = 9055,
  [10901] = 9048,
  [10902] = 9032,
  [10903] = 10903,
  [10904] = 10904,
  [10905] = 10903,
  [10906] = 10906,
  [10907] = 10904,
  [10908] = 10903,
  [10909] = 10904,
  [10910] = 10903,
  [10911] = 9065,
  [10912] = 10904,
  [10913] = 10903,
  [10914] = 10914,
  [10915] = 10904,
  [10916] = 10893,
  [10917] = 10903,
  [10918] = 10904,
  [10919] = 10903,
  [10920] = 10904,
  [10921] = 10903,
  [10922] = 10904,
  [10923] = 10923,
  [10924] = 10924,
  [10925] = 10887,
  [10926] = 10926,
  [10927] = 10903,
  [10928] = 10928,
  [10929] = 10928,
  [10930] = 10887,
  [10931] = 10893,
  [10932] = 10904,
  [10933] = 10889,
  [10934] = 10889,
  [10935] = 10935,
  [10936] = 10889,
  [10937] = 10923,
  [10938] = 10938,
  [10939] = 10887,
  [10940] = 10940,
  [10941] = 10941,
  [10942] = 10942,
  [10943] = 10923,
  [10944] = 10942,
  [10945] = 10942,
  [10946] = 10924,
  [10947] = 10942,
  [10948] = 10948,
  [10949] = 10949,
  [10950] = 10942,
  [10951] = 10951,
  [10952] = 10952,
  [10953] = 10942,
  [10954] = 10887,
  [10955] = 8986,
  [10956] = 10942,
  [10957] = 10889,
  [10958] = 10958,
  [10959] = 10959,
  [10960] = 10893,
  [10961] = 10893,
  [10962] = 10942,
  [10963] = 10963,
  [10964] = 10964,
  [10965] = 10942,
  [10966] = 10949,
  [10967] = 10948,
  [10968] = 10949,
  [10969] = 10942,
  [10970] = 10970,
  [10971] = 10892,
  [10972] = 10889,
  [10973] = 10948,
  [10974] = 10942,
  [10975] = 10888,
  [10976] = 10906,
  [10977] = 10887,
  [10978] = 10942,
  [10979] = 10979,
  [10980] = 10942,
  [10981] = 10981,
  [10982] = 10982,
  [10983] = 10983,
  [10984] = 10984,
  [10985] = 10923,
  [10986] = 10942,
  [10987] = 10889,
  [10988] = 10906,
  [10989] = 7881,
  [10990] = 10928,
  [10991] = 10887,
  [10992] = 10982,
  [10993] = 10893,
  [10994] = 10994,
  [10995] = 10983,
  [10996] = 10893,
  [10997] = 10997,
  [10998] = 10893,
  [10999] = 9618,
  [11000] = 10889,
  [11001] = 10893,
  [11002] = 10942,
  [11003] = 10906,
  [11004] = 11004,
  [11005] = 10982,
  [11006] = 11006,
  [11007] = 10983,
  [11008] = 11008,
  [11009] = 10889,
  [11010] = 10928,
  [11011] = 11011,
  [11012] = 10887,
  [11013] = 11013,
  [11014] = 10887,
  [11015] = 10904,
  [11016] = 11016,
  [11017] = 10942,
  [11018] = 10362,
  [11019] = 10982,
  [11020] = 10983,
  [11021] = 10234,
  [11022] = 10942,
  [11023] = 10888,
  [11024] = 10888,
  [11025] = 10982,
  [11026] = 10983,
  [11027] = 10129,
  [11028] = 10948,
  [11029] = 10949,
  [11030] = 10963,
  [11031] = 10959,
  [11032] = 10942,
  [11033] = 11033,
  [11034] = 10952,
  [11035] = 10893,
  [11036] = 10887,
  [11037] = 10887,
  [11038] = 10940,
  [11039] = 10928,
  [11040] = 9870,
  [11041] = 11041,
  [11042] = 10982,
  [11043] = 10889,
  [11044] = 10892,
  [11045] = 11045,
  [11046] = 10889,
  [11047] = 10889,
  [11048] = 10983,
  [11049] = 10893,
  [11050] = 11050,
  [11051] = 10887,
  [11052] = 11052,
  [11053] = 11053,
  [11054] = 11054,
  [11055] = 10942,
  [11056] = 11056,
  [11057] = 10914,
  [11058] = 10935,
  [11059] = 11041,
  [11060] = 10982,
  [11061] = 11041,
  [11062] = 11045,
  [11063] = 10983,
  [11064] = 10958,
  [11065] = 11065,
  [11066] = 10982,
  [11067] = 10432,
  [11068] = 10923,
  [11069] = 10942,
  [11070] = 10906,
  [11071] = 11071,
  [11072] = 10893,
  [11073] = 11073,
  [11074] = 11033,
  [11075] = 11041,
  [11076] = 10982,
  [11077] = 11077,
  [11078] = 10887,
  [11079] = 10893,
  [11080] = 11045,
  [11081] = 10983,
  [11082] = 10948,
  [11083] = 10889,
  [11084] = 10949,
  [11085] = 11085,
  [11086] = 10928,
  [11087] = 9133,
  [11088] = 10887,
  [11089] = 11089,
  [11090] = 10942,
  [11091] = 10889,
  [11092] = 9977,
  [11093] = 9968,
  [11094] = 10923,
  [11095] = 10948,
  [11096] = 10949,
  [11097] = 11097,
  [11098] = 11098,
  [11099] = 11099,
  [11100] = 10892,
  [11101] = 11101,
  [11102] = 11102,
  [11103] = 11103,
  [11104] = 11073,
  [11105] = 11033,
  [11106] = 11106,
  [11107] = 11041,
  [11108] = 10982,
  [11109] = 10893,
  [11110] = 11045,
  [11111] = 10983,
  [11112] = 10892,
  [11113] = 10949,
  [11114] = 11114,
  [11115] = 10948,
  [11116] = 11116,
  [11117] = 10942,
  [11118] = 10892,
  [11119] = 11119,
  [11120] = 10889,
  [11121] = 10923,
  [11122] = 10924,
  [11123] = 11123,
  [11124] = 10889,
  [11125] = 10887,
  [11126] = 10889,
  [11127] = 10887,
  [11128] = 10928,
  [11129] = 10893,
  [11130] = 10887,
  [11131] = 10893,
  [11132] = 11056,
  [11133] = 10893,
  [11134] = 10893,
  [11135] = 10949,
  [11136] = 10893,
  [11137] = 10948,
  [11138] = 11138,
  [11139] = 10893,
  [11140] = 10889,
  [11141] = 10887,
  [11142] = 10893,
  [11143] = 10889,
  [11144] = 10887,
  [11145] = 10889,
  [11146] = 10893,
  [11147] = 11147,
  [11148] = 11148,
  [11149] = 10893,
  [11150] = 10887,
  [11151] = 10889,
  [11152] = 10893,
  [11153] = 10887,
  [11154] = 10889,
  [11155] = 10892,
  [11156] = 10893,
  [11157] = 10889,
  [11158] = 11158,
  [11159] = 11159,
  [11160] = 10887,
  [11161] = 10889,
  [11162] = 10887,
  [11163] = 10893,
  [11164] = 10887,
  [11165] = 10889,
  [11166] = 11166,
  [11167] = 10893,
  [11168] = 10893,
  [11169] = 10887,
  [11170] = 10889,
  [11171] = 11171,
  [11172] = 11172,
  [11173] = 10893,
  [11174] = 11174,
  [11175] = 10887,
  [11176] = 10893,
  [11177] = 11177,
  [11178] = 10889,
  [11179] = 10906,
  [11180] = 10893,
  [11181] = 10906,
  [11182] = 11182,
  [11183] = 10893,
  [11184] = 10926,
  [11185] = 10887,
  [11186] = 11186,
  [11187] = 11187,
  [11188] = 11188,
  [11189] = 10889,
  [11190] = 11106,
  [11191] = 10889,
  [11192] = 10893,
  [11193] = 10893,
  [11194] = 10889,
  [11195] = 11195,
  [11196] = 10887,
  [11197] = 10887,
  [11198] = 10889,
  [11199] = 10887,
  [11200] = 10942,
  [11201] = 10893,
  [11202] = 10893,
  [11203] = 10888,
  [11204] = 10887,
  [11205] = 11205,
  [11206] = 10888,
  [11207] = 11045,
  [11208] = 10889,
  [11209] = 11209,
  [11210] = 10893,
  [11211] = 10893,
  [11212] = 11212,
  [11213] = 10889,
  [11214] = 10983,
  [11215] = 10887,
  [11216] = 10887,
  [11217] = 10906,
  [11218] = 10887,
  [11219] = 10889,
  [11220] = 10893,
  [11221] = 10893,
  [11222] = 9744,
  [11223] = 11223,
  [11224] = 10893,
  [11225] = 10887,
  [11226] = 11116,
  [11227] = 10889,
  [11228] = 10889,
  [11229] = 11229,
  [11230] = 10893,
  [11231] = 10889,
  [11232] = 9721,
  [11233] = 10923,
  [11234] = 10893,
  [11235] = 10981,
  [11236] = 10887,
  [11237] = 10903,
  [11238] = 10888,
  [11239] = 10887,
  [11240] = 10906,
  [11241] = 10889,
  [11242] = 10889,
  [11243] = 8982,
  [11244] = 10892,
  [11245] = 10887,
  [11246] = 10893,
  [11247] = 10887,
  [11248] = 10928,
  [11249] = 11050,
  [11250] = 11004,
  [11251] = 10889,
  [11252] = 10889,
  [11253] = 10893,
  [11254] = 10887,
  [11255] = 10928,
  [11256] = 10889,
  [11257] = 10893,
  [11258] = 10893,
  [11259] = 10887,
  [11260] = 11008,
  [11261] = 10923,
  [11262] = 10948,
  [11263] = 10887,
  [11264] = 10981,
  [11265] = 10949,
  [11266] = 10889,
  [11267] = 10893,
  [11268] = 10889,
  [11269] = 10981,
  [11270] = 11052,
  [11271] = 11053,
  [11272] = 11272,
  [11273] = 10887,
  [11274] = 11054,
  [11275] = 10893,
  [11276] = 11073,
  [11277] = 10889,
  [11278] = 10892,
  [11279] = 10887,
  [11280] = 11280,
  [11281] = 10887,
  [11282] = 10889,
  [11283] = 10949,
  [11284] = 10893,
  [11285] = 10888,
  [11286] = 10892,
  [11287] = 10887,
  [11288] = 10948,
  [11289] = 10889,
  [11290] = 11290,
  [11291] = 10979,
  [11292] = 11292,
  [11293] = 10893,
  [11294] = 10893,
  [11295] = 10893,
  [11296] = 10887,
  [11297] = 10923,
  [11298] = 11065,
  [11299] = 10924,
  [11300] = 11013,
  [11301] = 10889,
  [11302] = 11302,
  [11303] = 10887,
  [11304] = 10893,
  [11305] = 10889,
  [11306] = 11306,
  [11307] = 10906,
  [11308] = 10889,
  [11309] = 11309,
  [11310] = 10887,
  [11311] = 10889,
  [11312] = 10893,
  [11313] = 10928,
  [11314] = 10887,
  [11315] = 10887,
  [11316] = 11316,
  [11317] = 10889,
  [11318] = 10889,
  [11319] = 10887,
  [11320] = 10888,
  [11321] = 10893,
  [11322] = 10893,
  [11323] = 11323,
  [11324] = 10893,
  [11325] = 10889,
  [11326] = 10887,
  [11327] = 10893,
  [11328] = 10889,
  [11329] = 10888,
  [11330] = 11330,
  [11331] = 11331,
  [11332] = 11332,
  [11333] = 11333,
  [11334] = 10237,
  [11335] = 2306,
  [11336] = 11336,
  [11337] = 11337,
  [11338] = 11332,
  [11339] = 11339,
  [11340] = 11340,
  [11341] = 11341,
  [11342] = 5776,
  [11343] = 11343,
  [11344] = 11341,
  [11345] = 11345,
  [11346] = 11346,
  [11347] = 11347,
  [11348] = 11339,
  [11349] = 11349,
  [11350] = 11331,
  [11351] = 11341,
  [11352] = 11352,
  [11353] = 11353,
  [11354] = 11332,
  [11355] = 11337,
  [11356] = 11353,
  [11357] = 11357,
  [11358] = 11353,
  [11359] = 11352,
  [11360] = 11331,
  [11361] = 11346,
  [11362] = 11343,
  [11363] = 11339,
  [11364] = 11352,
  [11365] = 11332,
  [11366] = 11352,
  [11367] = 11331,
  [11368] = 11349,
  [11369] = 11369,
  [11370] = 11331,
  [11371] = 11339,
  [11372] = 11339,
  [11373] = 11347,
  [11374] = 11346,
  [11375] = 11349,
  [11376] = 11341,
  [11377] = 11343,
  [11378] = 11337,
  [11379] = 11332,
  [11380] = 11332,
  [11381] = 11343,
  [11382] = 11336,
  [11383] = 11383,
  [11384] = 11346,
  [11385] = 11343,
  [11386] = 10191,
  [11387] = 11337,
  [11388] = 11337,
  [11389] = 11336,
  [11390] = 11353,
  [11391] = 11352,
  [11392] = 11331,
  [11393] = 11346,
  [11394] = 11343,
  [11395] = 11337,
  [11396] = 11346,
  [11397] = 11332,
  [11398] = 11331,
  [11399] = 11352,
  [11400] = 11353,
  [11401] = 11353,
  [11402] = 11352,
  [11403] = 11337,
  [11404] = 11339,
  [11405] = 11346,
  [11406] = 11406,
  [11407] = 11331,
  [11408] = 11357,
  [11409] = 11346,
  [11410] = 11341,
  [11411] = 11411,
  [11412] = 11333,
  [11413] = 11339,
  [11414] = 11343,
  [11415] = 11343,
  [11416] = 11346,
  [11417] = 11331,
  [11418] = 11383,
  [11419] = 11352,
  [11420] = 10180,
  [11421] = 11353,
  [11422] = 11339,
  [11423] = 11332,
  [11424] = 11337,
  [11425] = 11332,
  [11426] = 11406,
  [11427] = 11353,
  [11428] = 11352,
  [11429] = 11331,
  [11430] = 11346,
  [11431] = 11343,
  [11432] = 11332,
  [11433] = 11343,
  [11434] = 11332,
  [11435] = 11337,
  [11436] = 11436,
  [11437] = 11341,
  [11438] = 11411,
  [11439] = 11439,
  [11440] = 11406,
  [11441] = 11339,
  [11442] = 11442,
  [11443] = 11443,
  [11444] = 11343,
  [11445] = 11445,
  [11446] = 11446,
  [11447] = 11341,
  [11448] = 11448,
  [11449] = 11449,
  [11450] = 11450,
  [11451] = 11346,
  [11452] = 10118,
  [11453] = 10238,
  [11454] = 11454,
  [11455] = 11341,
  [11456] = 10096,
  [11457] = 11457,
  [11458] = 11411,
  [11459] = 11331,
  [11460] = 11339,
  [11461] = 11337,
  [11462] = 11346,
  [11463] = 11347,
  [11464] = 11353,
  [11465] = 11352,
  [11466] = 11331,
  [11467] = 11346,
  [11468] = 11343,
  [11469] = 10094,
  [11470] = 11349,
  [11471] = 11332,
  [11472] = 11472,
  [11473] = 11337,
  [11474] = 11339,
  [11475] = 10090,
  [11476] = 11352,
  [11477] = 10088,
  [11478] = 11339,
  [11479] = 11479,
  [11480] = 11331,
  [11481] = 11481,
  [11482] = 11482,
  [11483] = 11483,
  [11484] = 11341,
  [11485] = 11485,
  [11486] = 11339,
  [11487] = 10182,
  [11488] = 11332,
  [11489] = 11341,
  [11490] = 11490,
  [11491] = 11352,
  [11492] = 11353,
  [11493] = 11448,
  [11494] = 11445,
  [11495] = 11443,
  [11496] = 11446,
  [11497] = 11449,
  [11498] = 11337,
  [11499] = 11353,
  [11500] = 11341,
  [11501] = 11353,
  [11502] = 11352,
  [11503] = 11331,
  [11504] = 11346,
  [11505] = 11343,
  [11506] = 11357,
  [11507] = 10116,
  [11508] = 11332,
  [11509] = 11343,
  [11510] = 11346,
  [11511] = 11331,
  [11512] = 11450,
  [11513] = 11352,
  [11514] = 10239,
  [11515] = 11339,
  [11516] = 11332,
  [11517] = 11353,
  [11518] = 11353,
  [11519] = 11519,
  [11520] = 11520,
  [11521] = 11341,
  [11522] = 11411,
  [11523] = 10114,
  [11524] = 11524,
  [11525] = 11353,
  [11526] = 10150,
  [11527] = 11343,
  [11528] = 11337,
  [11529] = 11383,
  [11530] = 11333,
  [11531] = 11331,
  [11532] = 11352,
  [11533] = 11353,
  [11534] = 11337,
  [11535] = 11337,
  [11536] = 11536,
  [11537] = 11406,
  [11538] = 11353,
  [11539] = 11352,
  [11540] = 11331,
  [11541] = 11346,
  [11542] = 11343,
  [11543] = 10140,
  [11544] = 11333,
  [11545] = 11332,
  [11546] = 11448,
  [11547] = 11520,
  [11548] = 10176,
  [11549] = 11549,
  [11550] = 11341,
  [11551] = 11472,
  [11552] = 11339,
  [11553] = 11337,
  [11554] = 10143,
  [11555] = 10111,
  [11556] = 11556,
  [11557] = 10149,
  [11558] = 11341,
  [11559] = 11336,
  [11560] = 10151,
  [11561] = 11352,
  [11562] = 10154,
  [11563] = 11330,
  [11564] = 11331,
  [11565] = 11337,
  [11566] = 11481,
  [11567] = 11339,
  [11568] = 11357,
  [11569] = 11346,
  [11570] = 11482,
  [11571] = 11485,
  [11572] = 11337,
  [11573] = 11341,
  [11574] = 11337,
  [11575] = 11353,
  [11576] = 11352,
  [11577] = 11331,
  [11578] = 11346,
  [11579] = 11343,
  [11580] = 11343,
  [11581] = 11341,
  [11582] = 11332,
  [11583] = 10155,
  [11584] = 10192,
  [11585] = 11332,
  [11586] = 11448,
  [11587] = 11353,
  [11588] = 11343,
  [11589] = 11339,
  [11590] = 11339,
  [11591] = 11346,
  [11592] = 11331,
  [11593] = 11352,
  [11594] = 11353,
  [11595] = 11341,
  [11596] = 11341,
  [11597] = 11485,
  [11598] = 11482,
  [11599] = 10254,
  [11600] = 11443,
  [11601] = 11332,
  [11602] = 11481,
  [11603] = 11352,
  [11604] = 11331,
  [11605] = 11349,
  [11606] = 11339,
  [11607] = 11472,
  [11608] = 11353,
  [11609] = 11337,
  [11610] = 11347,
  [11611] = 11346,
  [11612] = 11353,
  [11613] = 11352,
  [11614] = 11331,
  [11615] = 11346,
  [11616] = 11343,
  [11617] = 11339,
  [11618] = 10242,
  [11619] = 11332,
  [11620] = 11337,
  [11621] = 11332,
  [11622] = 11352,
  [11623] = 11450,
  [11624] = 11443,
  [11625] = 11449,
  [11626] = 11339,
  [11627] = 11448,
  [11628] = 11446,
  [11629] = 11343,
  [11630] = 11346,
  [11631] = 11445,
  [11632] = 11341,
  [11633] = 11331,
  [11634] = 11331,
  [11635] = 11520,
  [11636] = 11352,
  [11637] = 11411,
  [11638] = 11353,
  [11639] = 11346,
  [11640] = 11640,
  [11641] = 11343,
  [11642] = 11406,
  [11643] = 10072,
  [11644] = 11337,
  [11645] = 11332,
  [11646] = 11337,
  [11647] = 10197,
  [11648] = 11383,
  [11649] = 11353,
  [11650] = 11352,
  [11651] = 11331,
  [11652] = 11346,
  [11653] = 11343,
  [11654] = 11654,
  [11655] = 11333,
  [11656] = 11332,
  [11657] = 11341,
  [11658] = 11343,
  [11659] = 11336,
  [11660] = 11660,
  [11661] = 10236,
  [11662] = 10233,
  [11663] = 11339,
  [11664] = 11357,
  [11665] = 11341,
  [11666] = 11339,
  [11667] = 11337,
  [11668] = 10199,
  [11669] = 11341,
  [11670] = 11339,
  [11671] = 10258,
  [11672] = 11672,
  [11673] = 11332,
  [11674] = 11674,
  [11675] = 11436,
  [11676] = 11332,
  [11677] = 10201,
  [11678] = 11436,
  [11679] = 11343,
  [11680] = 11383,
  [11681] = 11436,
  [11682] = 10110,
  [11683] = 11337,
  [11684] = 11337,
  [11685] = 10142,
  [11686] = 11353,
  [11687] = 11352,
  [11688] = 11331,
  [11689] = 11346,
  [11690] = 11343,
  [11691] = 11691,
  [11692] = 11692,
  [11693] = 11332,
  [11694] = 11346,
  [11695] = 11349,
  [11696] = 11331,
  [11697] = 11341,
  [11698] = 11352,
  [11699] = 11341,
  [11700] = 11339,
  [11701] = 10137,
  [11702] = 11702,
  [11703] = 11353,
  [11704] = 11704,
  [11705] = 11705,
  [11706] = 11341,
  [11707] = 11707,
  [11708] = 11353,
  [11709] = 11352,
  [11710] = 11331,
  [11711] = 11337,
  [11712] = 11712,
  [11713] = 11383,
  [11714] = 11349,
  [11715] = 11330,
  [11716] = 11520,
  [11717] = 11339,
  [11718] = 11718,
  [11719] = 11341,
  [11720] = 11337,
  [11721] = 11485,
  [11722] = 11336,
  [11723] = 11353,
  [11724] = 11352,
  [11725] = 11331,
  [11726] = 11346,
  [11727] = 11343,
  [11728] = 11482,
  [11729] = 11481,
  [11730] = 11332,
  [11731] = 11346,
  [11732] = 11343,
  [11733] = 11472,
  [11734] = 11332,
  [11735] = 11337,
  [11736] = 11337,
  [11737] = 11339,
  [11738] = 11332,
  [11739] = 11341,
  [11740] = 11357,
  [11741] = 11353,
  [11742] = 11339,
  [11743] = 11341,
  [11744] = 11450,
  [11745] = 11352,
  [11746] = 11357,
  [11747] = 11343,
  [11748] = 11748,
  [11749] = 11343,
  [11750] = 11449,
  [11751] = 11346,
  [11752] = 11331,
  [11753] = 11352,
  [11754] = 11353,
  [11755] = 11755,
  [11756] = 11660,
  [11757] = 11337,
  [11758] = 11339,
  [11759] = 11446,
  [11760] = 11353,
  [11761] = 11352,
  [11762] = 11331,
  [11763] = 11346,
  [11764] = 11343,
  [11765] = 11332,
  [11766] = 11445,
  [11767] = 11332,
  [11768] = 11357,
  [11769] = 11331,
  [11770] = 11339,
  [11771] = 11339,
  [11772] = 11332,
  [11773] = 11343,
  [11774] = 11339,
  [11775] = 11337,
  [11776] = 11346,
  [11777] = 11349,
  [11778] = 11331,
  [11779] = 11352,
  [11780] = 11341,
  [11781] = 11353,
  [11782] = 11346,
  [11783] = 11332,
  [11784] = 11448,
  [11785] = 11343,
  [11786] = 11383,
  [11787] = 11787,
  [11788] = 11383,
  [11789] = 11343,
  [11790] = 11346,
  [11791] = 11436,
  [11792] = 11347,
  [11793] = 11448,
  [11794] = 11337,
  [11795] = 11332,
  [11796] = 11796,
  [11797] = 11353,
  [11798] = 11352,
  [11799] = 11331,
  [11800] = 11346,
  [11801] = 11343,
  [11802] = 11349,
  [11803] = 11331,
  [11804] = 11332,
  [11805] = 11337,
  [11806] = 11443,
  [11807] = 10101,
  [11808] = 11352,
  [11809] = 11339,
  [11810] = 11353,
  [11811] = 11339,
  [11812] = 11812,
  [11813] = 11333,
  [11814] = 11445,
  [11815] = 11446,
  [11816] = 11353,
  [11817] = 11341,
  [11818] = 11352,
  [11819] = 10085,
  [11820] = 11339,
  [11821] = 11406,
  [11822] = 11411,
  [11823] = 11331,
  [11824] = 11346,
  [11825] = 11449,
  [11826] = 11341,
  [11827] = 11343,
  [11828] = 11436,
  [11829] = 11829,
  [11830] = 11332,
  [11831] = 11337,
  [11832] = 11406,
  [11833] = 11333,
  [11834] = 11353,
  [11835] = 11352,
  [11836] = 11331,
  [11837] = 11346,
  [11838] = 11343,
  [11839] = 10100,
  [11840] = 11337,
  [11841] = 11332,
  [11842] = 11332,
  [11843] = 11339,
  [11844] = 11341,
  [11845] = 11445,
  [11846] = 11446,
  [11847] = 11787,
  [11848] = 11339,
  [11849] = 11849,
  [11850] = 11330,
  [11851] = 11341,
  [11852] = 11449,
  [11853] = 11336,
  [11854] = 11341,
  [11855] = 11336,
  [11856] = 11450,
  [11857] = 11857,
  [11858] = 11411,
  [11859] = 11337,
  [11860] = 11860,
  [11861] = 11861,
  [11862] = 11339,
  [11863] = 11333,
  [11864] = 11383,
  [11865] = 11337,
  [11866] = 11343,
  [11867] = 11346,
  [11868] = 11353,
  [11869] = 11352,
  [11870] = 11331,
  [11871] = 11346,
  [11872] = 11343,
  [11873] = 11406,
  [11874] = 11536,
  [11875] = 11332,
  [11876] = 11876,
  [11877] = 11472,
  [11878] = 11332,
  [11879] = 11331,
  [11880] = 11880,
  [11881] = 11442,
  [11882] = 11339,
  [11883] = 11520,
  [11884] = 11341,
  [11885] = 11337,
  [11886] = 11450,
  [11887] = 11411,
  [11888] = 11341,
  [11889] = 11343,
  [11890] = 11346,
  [11891] = 11331,
  [11892] = 11445,
  [11893] = 11787,
  [11894] = 11337,
  [11895] = 11353,
  [11896] = 11352,
  [11897] = 11353,
  [11898] = 11352,
  [11899] = 11331,
  [11900] = 11346,
  [11901] = 11343,
  [11902] = 11332,
  [11903] = 11446,
  [11904] = 11352,
  [11905] = 11339,
  [11906] = 11339,
  [11907] = 11353,
  [11908] = 11481,
  [11909] = 11341,
  [11910] = 11449,
  [11911] = 11450,
  [11912] = 11337,
  [11913] = 11353,
  [11914] = 11331,
  [11915] = 11337,
  [11916] = 11352,
  [11917] = 11349,
  [11918] = 11353,
  [11919] = 11352,
  [11920] = 11331,
  [11921] = 11346,
  [11922] = 11343,
  [11923] = 11482,
  [11924] = 11485,
  [11925] = 11341,
  [11926] = 11339,
  [11927] = 11346,
  [11928] = 11341,
  [11929] = 11332,
  [11930] = 11343,
  [11931] = 11472,
  [11932] = 11481,
  [11933] = 11482,
  [11934] = 11337,
  [11935] = 11935,
  [11936] = 11936,
  [11937] = 11353,
  [11938] = 11352,
  [11939] = 11331,
  [11940] = 11346,
  [11941] = 11343,
  [11942] = 11942,
  [11943] = 11943,
  [11944] = 11339,
  [11945] = 11445,
  [11946] = 11341,
  [11947] = 11343,
  [11948] = 11948,
  [11949] = 11339,
  [11950] = 11346,
  [11951] = 11485,
  [11952] = 11337,
  [11953] = 11339,
  [11954] = 11346,
  [11955] = 11353,
  [11956] = 11352,
  [11957] = 11331,
  [11958] = 11346,
  [11959] = 11343,
  [11960] = 11346,
  [11961] = 11349,
  [11962] = 11339,
  [11963] = 11446,
  [11964] = 11341,
  [11965] = 11331,
  [11966] = 11449,
  [11967] = 11341,
  [11968] = 11347,
  [11969] = 11341,
  [11970] = 11337,
  [11971] = 11787,
  [11972] = 11357,
  [11973] = 11353,
  [11974] = 11352,
  [11975] = 11331,
  [11976] = 11346,
  [11977] = 11343,
  [11978] = 11352,
  [11979] = 11353,
  [11980] = 11339,
  [11981] = 11450,
  [11982] = 11341,
  [11983] = 11341,
  [11984] = 11332,
  [11985] = 11339,
  [11986] = 11343,
  [11987] = 11352,
  [11988] = 11337,
  [11989] = 11332,
  [11990] = 11353,
  [11991] = 11353,
  [11992] = 11352,
  [11993] = 11331,
  [11994] = 11346,
  [11995] = 11343,
  [11996] = 11339,
  [11997] = 11346,
  [11998] = 11341,
  [11999] = 11343,
  [12000] = 11332,
  [12001] = 11349,
  [12002] = 11346,
  [12003] = 11337,
  [12004] = 11357,
  [12005] = 11339,
  [12006] = 11353,
  [12007] = 11352,
  [12008] = 11331,
  [12009] = 11346,
  [12010] = 11343,
  [12011] = 11339,
  [12012] = 11349,
  [12013] = 11341,
  [12014] = 11337,
  [12015] = 11332,
  [12016] = 11331,
  [12017] = 11337,
  [12018] = 11352,
  [12019] = 11353,
  [12020] = 11353,
  [12021] = 11352,
  [12022] = 11331,
  [12023] = 11346,
  [12024] = 11339,
  [12025] = 11472,
  [12026] = 11341,
  [12027] = 11339,
  [12028] = 12028,
  [12029] = 11383,
  [12030] = 11337,
  [12031] = 11787,
  [12032] = 11445,
  [12033] = 11353,
  [12034] = 11352,
  [12035] = 11331,
  [12036] = 11346,
  [12037] = 11339,
  [12038] = 11343,
  [12039] = 11341,
  [12040] = 11337,
  [12041] = 7596,
  [12042] = 12042,
  [12043] = 11337,
  [12044] = 11341,
  [12045] = 11446,
  [12046] = 11353,
  [12047] = 11352,
  [12048] = 11331,
  [12049] = 11346,
  [12050] = 11339,
  [12051] = 11341,
  [12052] = 11341,
  [12053] = 12053,
  [12054] = 11331,
  [12055] = 11449,
  [12056] = 11337,
  [12057] = 11443,
  [12058] = 11450,
  [12059] = 11353,
  [12060] = 11352,
  [12061] = 11331,
  [12062] = 11346,
  [12063] = 11339,
  [12064] = 11352,
  [12065] = 11341,
  [12066] = 12066,
  [12067] = 11353,
  [12068] = 11448,
  [12069] = 11337,
  [12070] = 11472,
  [12071] = 11411,
  [12072] = 11353,
  [12073] = 11352,
  [12074] = 11331,
  [12075] = 11346,
  [12076] = 11339,
  [12077] = 11337,
  [12078] = 11341,
  [12079] = 12079,
  [12080] = 11520,
  [12081] = 12081,
  [12082] = 11337,
  [12083] = 11787,
  [12084] = 11337,
  [12085] = 11353,
  [12086] = 11352,
  [12087] = 11331,
  [12088] = 11346,
  [12089] = 12089,
  [12090] = 11353,
  [12091] = 11337,
  [12092] = 11352,
  [12093] = 11353,
  [12094] = 11352,
  [12095] = 12095,
  [12096] = 11337,
  [12097] = 11331,
  [12098] = 11337,
  [12099] = 11346,
  [12100] = 11353,
  [12101] = 11352,
  [12102] = 11331,
  [12103] = 11343,
  [12104] = 11336,
  [12105] = 11337,
  [12106] = 11341,
  [12107] = 11353,
  [12108] = 11352,
  [12109] = 11331,
  [12110] = 12110,
  [12111] = 12081,
  [12112] = 11337,
  [12113] = 11332,
  [12114] = 11353,
  [12115] = 11352,
  [12116] = 11331,
  [12117] = 12117,
  [12118] = 11536,
  [12119] = 11337,
  [12120] = 11352,
  [12121] = 11406,
  [12122] = 11481,
  [12123] = 11337,
  [12124] = 11352,
  [12125] = 11481,
  [12126] = 11333,
  [12127] = 11337,
  [12128] = 11352,
  [12129] = 11443,
  [12130] = 11482,
  [12131] = 11337,
  [12132] = 11352,
  [12133] = 12133,
  [12134] = 11485,
  [12135] = 11337,
  [12136] = 11352,
  [12137] = 11556,
  [12138] = 11337,
  [12139] = 11352,
  [12140] = 11339,
  [12141] = 11352,
  [12142] = 11787,
  [12143] = 11352,
  [12144] = 11333,
  [12145] = 11331,
  [12146] = 11406,
  [12147] = 11411,
  [12148] = 11445,
  [12149] = 12149,
  [12150] = 11446,
  [12151] = 11449,
  [12152] = 12152,
  [12153] = 12153,
  [12154] = 11450,
  [12155] = 12155,
  [12156] = 11448,
  [12157] = 12157,
  [12158] = 12158,
  [12159] = 11482,
  [12160] = 12160,
  [12161] = 12161,
  [12162] = 11341,
  [12163] = 12163,
  [12164] = 11485,
  [12165] = 12165,
  [12166] = 11339,
  [12167] = 12167,
  [12168] = 11787,
  [12169] = 11332,
  [12170] = 11520,
  [12171] = 11472,
  [12172] = 11481,
  [12173] = 12173,
  [12174] = 11341,
  [12175] = 11482,
  [12176] = 11337,
  [12177] = 11485,
  [12178] = 11331,
  [12179] = 11341,
  [12180] = 11520,
  [12181] = 7898,
  [12182] = 11520,
  [12183] = 11352,
  [12184] = 12184,
  [12185] = 11353,
  [12186] = 12186,
  [12187] = 11337,
  [12188] = 12188,
  [12189] = 11341,
  [12190] = 12190,
  [12191] = 11336,
  [12192] = 12192,
  [12193] = 12193,
  [12194] = 12194,
  [12195] = 12195,
  [12196] = 11787,
  [12197] = 11472,
  [12198] = 11448,
  [12199] = 11330,
  [12200] = 11672,
  [12201] = 11353,
  [12202] = 11353,
  [12203] = 12203,
  [12204] = 11352,
  [12205] = 11337,
  [12206] = 11331,
  [12207] = 11352,
  [12208] = 11339,
  [12209] = 11346,
  [12210] = 11481,
  [12211] = 11343,
  [12212] = 11331,
  [12213] = 11482,
  [12214] = 11332,
  [12215] = 11485,
  [12216] = 11341,
  [12217] = 11520,
  [12218] = 11787,
  [12219] = 12219,
  [12220] = 12220,
  [12221] = 12221,
  [12222] = 11343,
  [12223] = 11346,
  [12224] = 12224,
  [12225] = 12225,
  [12226] = 12226,
  [12227] = 12227,
  [12228] = 12228,
  [12229] = 12229,
  [12230] = 12230,
  [12231] = 12231,
  [12232] = 12232,
  [12233] = 12226,
  [12234] = 12234,
  [12235] = 12235,
  [12236] = 12236,
  [12237] = 12225,
  [12238] = 12238,
  [12239] = 7709,
  [12240] = 12240,
  [12241] = 7543,
  [12242] = 7928,
  [12243] = 12243,
  [12244] = 12244,
  [12245] = 12232,
  [12246] = 12246,
  [12247] = 12247,
  [12248] = 12248,
  [12249] = 12249,
  [12250] = 12236,
  [12251] = 12251,
  [12252] = 12227,
  [12253] = 12228,
  [12254] = 12240,
  [12255] = 12251,
  [12256] = 12256,
  [12257] = 12257,
  [12258] = 12235,
  [12259] = 9177,
  [12260] = 12232,
  [12261] = 12261,
  [12262] = 12257,
  [12263] = 12230,
  [12264] = 12235,
  [12265] = 12230,
  [12266] = 12266,
  [12267] = 12267,
  [12268] = 7877,
  [12269] = 7698,
  [12270] = 12251,
  [12271] = 12248,
  [12272] = 12240,
  [12273] = 12273,
  [12274] = 12228,
  [12275] = 12275,
  [12276] = 12276,
  [12277] = 12227,
  [12278] = 12236,
  [12279] = 12279,
  [12280] = 12225,
  [12281] = 12229,
  [12282] = 12282,
  [12283] = 12247,
  [12284] = 12225,
  [12285] = 12231,
  [12286] = 12257,
  [12287] = 12257,
  [12288] = 12288,
  [12289] = 12257,
  [12290] = 12257,
  [12291] = 12257,
  [12292] = 12257,
  [12293] = 12224,
  [12294] = 12294,
  [12295] = 12257,
  [12296] = 12257,
  [12297] = 12257,
  [12298] = 12257,
  [12299] = 12236,
  [12300] = 12257,
  [12301] = 12227,
  [12302] = 12228,
  [12303] = 12240,
  [12304] = 12251,
  [12305] = 12257,
  [12306] = 12306,
  [12307] = 12257,
  [12308] = 12225,
  [12309] = 12309,
  [12310] = 12257,
  [12311] = 12238,
  [12312] = 12257,
  [12313] = 12313,
  [12314] = 12257,
  [12315] = 12315,
  [12316] = 12316,
  [12317] = 12317,
  [12318] = 12257,
  [12319] = 12319,
  [12320] = 12257,
  [12321] = 12321,
  [12322] = 12248,
  [12323] = 12257,
  [12324] = 12235,
  [12325] = 12257,
  [12326] = 12235,
  [12327] = 12257,
  [12328] = 12328,
  [12329] = 12226,
  [12330] = 12235,
  [12331] = 12331,
  [12332] = 12226,
  [12333] = 12257,
  [12334] = 12235,
  [12335] = 7937,
  [12336] = 12257,
  [12337] = 12232,
  [12338] = 12282,
  [12339] = 12235,
  [12340] = 12236,
  [12341] = 12235,
  [12342] = 12227,
  [12343] = 12228,
  [12344] = 12240,
  [12345] = 12251,
  [12346] = 12257,
  [12347] = 12235,
  [12348] = 12232,
  [12349] = 12232,
  [12350] = 12267,
  [12351] = 12230,
  [12352] = 12352,
  [12353] = 12235,
  [12354] = 12354,
  [12355] = 12232,
  [12356] = 12257,
  [12357] = 12247,
  [12358] = 12358,
  [12359] = 12232,
  [12360] = 12235,
  [12361] = 12361,
  [12362] = 12362,
  [12363] = 12363,
  [12364] = 12257,
  [12365] = 12257,
  [12366] = 12244,
  [12367] = 12232,
  [12368] = 7701,
  [12369] = 12235,
  [12370] = 12257,
  [12371] = 12232,
  [12372] = 12229,
  [12373] = 12226,
  [12374] = 12256,
  [12375] = 12235,
  [12376] = 12257,
  [12377] = 12232,
  [12378] = 12236,
  [12379] = 12235,
  [12380] = 12227,
  [12381] = 12228,
  [12382] = 12240,
  [12383] = 12251,
  [12384] = 12257,
  [12385] = 12248,
  [12386] = 12232,
  [12387] = 12257,
  [12388] = 12235,
  [12389] = 12321,
  [12390] = 12390,
  [12391] = 12257,
  [12392] = 12229,
  [12393] = 12235,
  [12394] = 12257,
  [12395] = 12232,
  [12396] = 12235,
  [12397] = 12257,
  [12398] = 12232,
  [12399] = 12399,
  [12400] = 12235,
  [12401] = 12232,
  [12402] = 12235,
  [12403] = 12257,
  [12404] = 12404,
  [12405] = 12232,
  [12406] = 12406,
  [12407] = 12232,
  [12408] = 12236,
  [12409] = 12235,
  [12410] = 12227,
  [12411] = 12228,
  [12412] = 12240,
  [12413] = 12251,
  [12414] = 12257,
  [12415] = 12232,
  [12416] = 12235,
  [12417] = 12257,
  [12418] = 12232,
  [12419] = 12235,
  [12420] = 8388,
  [12421] = 12257,
  [12422] = 12422,
  [12423] = 12248,
  [12424] = 12230,
  [12425] = 12224,
  [12426] = 12426,
  [12427] = 12257,
  [12428] = 12232,
  [12429] = 12235,
  [12430] = 12257,
  [12431] = 12294,
  [12432] = 12235,
  [12433] = 12232,
  [12434] = 12232,
  [12435] = 12248,
  [12436] = 12232,
  [12437] = 12235,
  [12438] = 12236,
  [12439] = 12257,
  [12440] = 12227,
  [12441] = 12228,
  [12442] = 12240,
  [12443] = 12251,
  [12444] = 12390,
  [12445] = 12235,
  [12446] = 12256,
  [12447] = 12422,
  [12448] = 12267,
  [12449] = 12224,
  [12450] = 12294,
  [12451] = 12358,
  [12452] = 12232,
  [12453] = 12331,
  [12454] = 12328,
  [12455] = 12235,
  [12456] = 12232,
  [12457] = 12294,
  [12458] = 12390,
  [12459] = 12235,
  [12460] = 12257,
  [12461] = 12267,
  [12462] = 12315,
  [12463] = 12422,
  [12464] = 12244,
  [12465] = 12273,
  [12466] = 12466,
  [12467] = 12257,
  [12468] = 12236,
  [12469] = 12469,
  [12470] = 12227,
  [12471] = 12228,
  [12472] = 12240,
  [12473] = 12251,
  [12474] = 12257,
  [12475] = 12224,
  [12476] = 12476,
  [12477] = 12232,
  [12478] = 12235,
  [12479] = 12257,
  [12480] = 12235,
  [12481] = 12224,
  [12482] = 12249,
  [12483] = 12483,
  [12484] = 12230,
  [12485] = 12294,
  [12486] = 12486,
  [12487] = 12232,
  [12488] = 12244,
  [12489] = 12256,
  [12490] = 12244,
  [12491] = 12232,
  [12492] = 12257,
  [12493] = 12232,
  [12494] = 12494,
  [12495] = 12235,
  [12496] = 12257,
  [12497] = 12257,
  [12498] = 12236,
  [12499] = 12313,
  [12500] = 12227,
  [12501] = 12235,
  [12502] = 12240,
  [12503] = 12251,
  [12504] = 12257,
  [12505] = 12235,
  [12506] = 12247,
  [12507] = 12224,
  [12508] = 12232,
  [12509] = 12257,
  [12510] = 12225,
  [12511] = 12235,
  [12512] = 12232,
  [12513] = 12232,
  [12514] = 12235,
  [12515] = 12257,
  [12516] = 12516,
  [12517] = 12517,
  [12518] = 12518,
  [12519] = 12517,
  [12520] = 12422,
  [12521] = 12235,
  [12522] = 12522,
  [12523] = 12232,
  [12524] = 12251,
  [12525] = 12525,
  [12526] = 12235,
  [12527] = 12257,
  [12528] = 12516,
  [12529] = 12225,
  [12530] = 12230,
  [12531] = 12248,
  [12532] = 12532,
  [12533] = 12251,
  [12534] = 12257,
  [12535] = 12257,
  [12536] = 12244,
  [12537] = 12232,
  [12538] = 12538,
  [12539] = 12257,
  [12540] = 12251,
  [12541] = 12257,
  [12542] = 12235,
  [12543] = 12543,
  [12544] = 12228,
  [12545] = 12232,
  [12546] = 12247,
  [12547] = 12251,
  [12548] = 12244,
  [12549] = 12232,
  [12550] = 12234,
  [12551] = 12235,
  [12552] = 12257,
  [12553] = 12251,
  [12554] = 12256,
  [12555] = 12235,
  [12556] = 12331,
  [12557] = 12517,
  [12558] = 12256,
  [12559] = 12251,
  [12560] = 12518,
  [12561] = 12226,
  [12562] = 12232,
  [12563] = 12235,
  [12564] = 12225,
  [12565] = 12251,
  [12566] = 11071,
  [12567] = 12226,
  [12568] = 12257,
  [12569] = 12257,
  [12570] = 12570,
  [12571] = 12251,
  [12572] = 12232,
  [12573] = 12232,
  [12574] = 12235,
  [12575] = 12257,
  [12576] = 12251,
  [12577] = 12235,
  [12578] = 12578,
  [12579] = 12232,
  [12580] = 12580,
  [12581] = 12251,
  [12582] = 12224,
  [12583] = 12230,
  [12584] = 12294,
  [12585] = 12422,
  [12586] = 12251,
  [12587] = 12257,
  [12588] = 12225,
  [12589] = 12232,
  [12590] = 12235,
  [12591] = 12251,
  [12592] = 12257,
  [12593] = 12232,
  [12594] = 12248,
  [12595] = 12235,
  [12596] = 12251,
  [12597] = 12235,
  [12598] = 12232,
  [12599] = 12251,
  [12600] = 12226,
  [12601] = 12251,
  [12602] = 12247,
  [12603] = 12251,
  [12604] = 12232,
  [12605] = 12251,
  [12606] = 12257,
  [12607] = 12251,
  [12608] = 12256,
  [12609] = 12251,
  [12610] = 12247,
  [12611] = 12251,
  [12612] = 12235,
  [12613] = 12251,
  [12614] = 12614,
  [12615] = 12251,
  [12616] = 12257,
  [12617] = 12251,
  [12618] = 12257,
  [12619] = 12251,
  [12620] = 12232,
  [12621] = 12251,
  [12622] = 12225,
  [12623] = 12251,
  [12624] = 12226,
  [12625] = 12251,
  [12626] = 12235,
  [12627] = 12251,
  [12628] = 12229,
  [12629] = 12251,
  [12630] = 12248,
  [12631] = 12251,
  [12632] = 12516,
  [12633] = 12251,
  [12634] = 12247,
  [12635] = 12251,
  [12636] = 12257,
  [12637] = 12251,
  [12638] = 12273,
  [12639] = 12251,
  [12640] = 12257,
  [12641] = 12251,
  [12642] = 12235,
  [12643] = 12251,
  [12644] = 12230,
  [12645] = 12251,
  [12646] = 12232,
  [12647] = 12251,
  [12648] = 12232,
  [12649] = 12251,
  [12650] = 12235,
  [12651] = 12251,
  [12652] = 12328,
  [12653] = 12251,
  [12654] = 12257,
  [12655] = 12251,
  [12656] = 12257,
  [12657] = 12251,
  [12658] = 12225,
  [12659] = 12251,
  [12660] = 12266,
  [12661] = 12251,
  [12662] = 12230,
  [12663] = 12251,
  [12664] = 12235,
  [12665] = 12251,
  [12666] = 12358,
  [12667] = 12251,
  [12668] = 12267,
  [12669] = 12251,
  [12670] = 12232,
  [12671] = 12251,
  [12672] = 12672,
  [12673] = 12390,
  [12674] = 12321,
  [12675] = 12235,
  [12676] = 12319,
  [12677] = 12306,
  [12678] = 12294,
  [12679] = 12244,
  [12680] = 12317,
  [12681] = 12316,
  [12682] = 12232,
  [12683] = 12235,
  [12684] = 12309,
  [12685] = 12685,
  [12686] = 12257,
  [12687] = 12315,
  [12688] = 12232,
  [12689] = 12532,
  [12690] = 12690,
  [12691] = 12691,
  [12692] = 12692,
  [12693] = 12235,
  [12694] = 12224,
  [12695] = 12695,
  [12696] = 12232,
  [12697] = 12697,
  [12698] = 12247,
  [12699] = 12313,
  [12700] = 12238,
  [12701] = 12225,
  [12702] = 12672,
  [12703] = 12266,
  [12704] = 12294,
  [12705] = 12319,
  [12706] = 12306,
  [12707] = 12672,
  [12708] = 12316,
  [12709] = 12317,
  [12710] = 12685,
  [12711] = 12690,
  [12712] = 12672,
  [12713] = 12248,
  [12714] = 12319,
  [12715] = 12306,
  [12716] = 12716,
  [12717] = 12691,
  [12718] = 12718,
  [12719] = 12672,
  [12720] = 12266,
  [12721] = 12319,
  [12722] = 12306,
  [12723] = 12723,
  [12724] = 12692,
  [12725] = 12232,
  [12726] = 12672,
  [12727] = 12235,
  [12728] = 12319,
  [12729] = 12729,
  [12730] = 12695,
  [12731] = 12257,
  [12732] = 12672,
  [12733] = 12225,
  [12734] = 12319,
  [12735] = 12257,
  [12736] = 12226,
  [12737] = 12247,
  [12738] = 12672,
  [12739] = 12224,
  [12740] = 12319,
  [12741] = 12294,
  [12742] = 12257,
  [12743] = 12244,
  [12744] = 12672,
  [12745] = 12235,
  [12746] = 12319,
  [12747] = 12232,
  [12748] = 12235,
  [12749] = 12257,
  [12750] = 12672,
  [12751] = 12232,
  [12752] = 12319,
  [12753] = 12753,
  [12754] = 7934,
  [12755] = 12294,
  [12756] = 12672,
  [12757] = 12390,
  [12758] = 12672,
  [12759] = 12257,
  [12760] = 12672,
  [12761] = 12761,
  [12762] = 12672,
  [12763] = 12235,
  [12764] = 12672,
  [12765] = 12232,
  [12766] = 12672,
  [12767] = 12232,
  [12768] = 12672,
  [12769] = 7674,
  [12770] = 7724,
  [12771] = 7643,
  [12772] = 12235,
  [12773] = 9968,
  [12774] = 9977,
  [12775] = 7684,
  [12776] = 12257,
  [12777] = 12257,
  [12778] = 7907,
  [12779] = 7910,
  [12780] = 12232,
  [12781] = 12235,
  [12782] = 12257,
  [12783] = 12235,
  [12784] = 12232,
  [12785] = 12257,
  [12786] = 12244,
  [12787] = 7596,
  [12788] = 12483,
  [12789] = 12789,
  [12790] = 12685,
  [12791] = 12516,
  [12792] = 12525,
  [12793] = 12235,
  [12794] = 12232,
  [12795] = 12256,
  [12796] = 12256,
  [12797] = 12232,
  [12798] = 12235,
  [12799] = 12257,
  [12800] = 7596,
  [12801] = 12256,
  [12802] = 9177,
  [12803] = 12232,
  [12804] = 12235,
  [12805] = 2952,
  [12806] = 12672,
  [12807] = 12466,
  [12808] = 12231,
  [12809] = 12257,
  [12810] = 12672,
  [12811] = 12466,
  [12812] = 12466,
  [12813] = 12466,
  [12814] = 12466,
  [12815] = 12466,
  [12816] = 12466,
  [12817] = 12466,
  [12818] = 12466,
  [12819] = 12466,
  [12820] = 12466,
  [12821] = 12466,
  [12822] = 12466,
  [12823] = 12466,
  [12824] = 12466,
  [12825] = 12466,
  [12826] = 12466,
  [12827] = 12466,
  [12828] = 12466,
  [12829] = 12466,
  [12830] = 12466,
  [12831] = 12466,
  [12832] = 12466,
  [12833] = 12466,
  [12834] = 12466,
  [12835] = 12466,
  [12836] = 12466,
  [12837] = 12466,
  [12838] = 12466,
  [12839] = 12466,
  [12840] = 12466,
  [12841] = 12466,
  [12842] = 12466,
  [12843] = 12466,
  [12844] = 12466,
  [12845] = 12466,
  [12846] = 12466,
  [12847] = 12466,
  [12848] = 12466,
  [12849] = 12466,
  [12850] = 12466,
  [12851] = 12466,
  [12852] = 12466,
  [12853] = 12466,
  [12854] = 12466,
  [12855] = 12466,
  [12856] = 12466,
  [12857] = 12466,
  [12858] = 12466,
  [12859] = 12466,
  [12860] = 12466,
  [12861] = 12466,
};

static TSCharacterRange sym_variable_character_set_1[] = {
  {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba}, {0xdf, 0xf6}, {0xf8, 0xff}, {0x101, 0x101},
  {0x103, 0x103}, {0x105, 0x105}, {0x107, 0x107}, {0x109, 0x109}, {0x10b, 0x10b}, {0x10d, 0x10d}, {0x10f, 0x10f}, {0x111, 0x111},
  {0x113, 0x113}, {0x115, 0x115}, {0x117, 0x117}, {0x119, 0x119}, {0x11b, 0x11b}, {0x11d, 0x11d}, {0x11f, 0x11f}, {0x121, 0x121},
  {0x123, 0x123}, {0x125, 0x125}, {0x127, 0x127}, {0x129, 0x129}, {0x12b, 0x12b}, {0x12d, 0x12d}, {0x12f, 0x12f}, {0x131, 0x131},
  {0x133, 0x133}, {0x135, 0x135}, {0x137, 0x138}, {0x13a, 0x13a}, {0x13c, 0x13c}, {0x13e, 0x13e}, {0x140, 0x140}, {0x142, 0x142},
  {0x144, 0x144}, {0x146, 0x146}, {0x148, 0x149}, {0x14b, 0x14b}, {0x14d, 0x14d}, {0x14f, 0x14f}, {0x151, 0x151}, {0x153, 0x153},
  {0x155, 0x155}, {0x157, 0x157}, {0x159, 0x159}, {0x15b, 0x15b}, {0x15d, 0x15d}, {0x15f, 0x15f}, {0x161, 0x161}, {0x163, 0x163},
  {0x165, 0x165}, {0x167, 0x167}, {0x169, 0x169}, {0x16b, 0x16b}, {0x16d, 0x16d}, {0x16f, 0x16f}, {0x171, 0x171}, {0x173, 0x173},
  {0x175, 0x175}, {0x177, 0x177}, {0x17a, 0x17a}, {0x17c, 0x17c}, {0x17e, 0x180}, {0x183, 0x183}, {0x185, 0x185}, {0x188, 0x188},
  {0x18c, 0x18d}, {0x192, 0x192}, {0x195, 0x195}, {0x199, 0x19b}, {0x19e, 0x19e}, {0x1a1, 0x1a1}, {0x1a3, 0x1a3}, {0x1a5, 0x1a5},
  {0x1a8, 0x1a8}, {0x1aa, 0x1ab}, {0x1ad, 0x1ad}, {0x1b0, 0x1b0}, {0x1b4, 0x1b4}, {0x1b6, 0x1b6}, {0x1b9, 0x1bb}, {0x1bd, 0x1c3},
  {0x1c6, 0x1c6}, {0x1c9, 0x1c9}, {0x1cc, 0x1cc}, {0x1ce, 0x1ce}, {0x1d0, 0x1d0}, {0x1d2, 0x1d2}, {0x1d4, 0x1d4}, {0x1d6, 0x1d6},
  {0x1d8, 0x1d8}, {0x1da, 0x1da}, {0x1dc, 0x1dd}, {0x1df, 0x1df}, {0x1e1, 0x1e1}, {0x1e3, 0x1e3}, {0x1e5, 0x1e5}, {0x1e7, 0x1e7},
  {0x1e9, 0x1e9}, {0x1eb, 0x1eb}, {0x1ed, 0x1ed}, {0x1ef, 0x1f0}, {0x1f3, 0x1f3}, {0x1f5, 0x1f5}, {0x1f9, 0x1f9}, {0x1fb, 0x1fb},
  {0x1fd, 0x1fd}, {0x1ff, 0x1ff}, {0x201, 0x201}, {0x203, 0x203}, {0x205, 0x205}, {0x207, 0x207}, {0x209, 0x209}, {0x20b, 0x20b},
  {0x20d, 0x20d}, {0x20f, 0x20f}, {0x211, 0x211}, {0x213, 0x213}, {0x215, 0x215}, {0x217, 0x217}, {0x219, 0x219}, {0x21b, 0x21b},
  {0x21d, 0x21d}, {0x21f, 0x21f}, {0x221, 0x221}, {0x223, 0x223}, {0x225, 0x225}, {0x227, 0x227}, {0x229, 0x229}, {0x22b, 0x22b},
  {0x22d, 0x22d}, {0x22f, 0x22f}, {0x231, 0x231}, {0x233, 0x239}, {0x23c, 0x23c}, {0x23f, 0x240}, {0x242, 0x242}, {0x247, 0x247},
  {0x249, 0x249}, {0x24b, 0x24b}, {0x24d, 0x24d}, {0x24f, 0x2af}, {0x371, 0x371}, {0x373, 0x373}, {0x377, 0x377}, {0x37b, 0x37d},
  {0x390, 0x390}, {0x3ac, 0x3ce}, {0x3d0, 0x3d1}, {0x3d5, 0x3d7}, {0x3d9, 0x3d9}, {0x3db, 0x3db}, {0x3dd, 0x3dd}, {0x3df, 0x3df},
  {0x3e1, 0x3e1}, {0x3e3, 0x3e3}, {0x3e5, 0x3e5}, {0x3e7, 0x3e7}, {0x3e9, 0x3e9}, {0x3eb, 0x3eb}, {0x3ed, 0x3ed}, {0x3ef, 0x3f3},
  {0x3f5, 0x3f5}, {0x3f8, 0x3f8}, {0x3fb, 0x3fc}, {0x430, 0x45f}, {0x461, 0x461}, {0x463, 0x463}, {0x465, 0x465}, {0x467, 0x467},
  {0x469, 0x469}, {0x46b, 0x46b}, {0x46d, 0x46d}, {0x46f, 0x46f}, {0x471, 0x471}, {0x473, 0x473}, {0x475, 0x475}, {0x477, 0x477},
  {0x479, 0x479}, {0x47b, 0x47b}, {0x47d, 0x47d}, {0x47f, 0x47f}, {0x481, 0x481}, {0x48b, 0x48b}, {0x48d, 0x48d}, {0x48f, 0x48f},
  {0x491, 0x491}, {0x493, 0x493}, {0x495, 0x495}, {0x497, 0x497}, {0x499, 0x499}, {0x49b, 0x49b}, {0x49d, 0x49d}, {0x49f, 0x49f},
  {0x4a1, 0x4a1}, {0x4a3, 0x4a3}, {0x4a5, 0x4a5}, {0x4a7, 0x4a7}, {0x4a9, 0x4a9}, {0x4ab, 0x4ab}, {0x4ad, 0x4ad}, {0x4af, 0x4af},
  {0x4b1, 0x4b1}, {0x4b3, 0x4b3}, {0x4b5, 0x4b5}, {0x4b7, 0x4b7}, {0x4b9, 0x4b9}, {0x4bb, 0x4bb}, {0x4bd, 0x4bd}, {0x4bf, 0x4bf},
  {0x4c2, 0x4c2}, {0x4c4, 0x4c4}, {0x4c6, 0x4c6}, {0x4c8, 0x4c8}, {0x4ca, 0x4ca}, {0x4cc, 0x4cc}, {0x4ce, 0x4cf}, {0x4d1, 0x4d1},
  {0x4d3, 0x4d3}, {0x4d5, 0x4d5}, {0x4d7, 0x4d7}, {0x4d9, 0x4d9}, {0x4db, 0x4db}, {0x4dd, 0x4dd}, {0x4df, 0x4df}, {0x4e1, 0x4e1},
  {0x4e3, 0x4e3}, {0x4e5, 0x4e5}, {0x4e7, 0x4e7}, {0x4e9, 0x4e9}, {0x4eb, 0x4eb}, {0x4ed, 0x4ed}, {0x4ef, 0x4ef}, {0x4f1, 0x4f1},
  {0x4f3, 0x4f3}, {0x4f5, 0x4f5}, {0x4f7, 0x4f7}, {0x4f9, 0x4f9}, {0x4fb, 0x4fb}, {0x4fd, 0x4fd}, {0x4ff, 0x4ff}, {0x501, 0x501},
  {0x503, 0x503}, {0x505, 0x505}, {0x507, 0x507}, {0x509, 0x509}, {0x50b, 0x50b}, {0x50d, 0x50d}, {0x50f, 0x50f}, {0x511, 0x511},
  {0x513, 0x513}, {0x515, 0x515}, {0x517, 0x517}, {0x519, 0x519}, {0x51b, 0x51b}, {0x51d, 0x51d}, {0x51f, 0x51f}, {0x521, 0x521},
  {0x523, 0x523}, {0x525, 0x525}, {0x527, 0x527}, {0x529, 0x529}, {0x52b, 0x52b}, {0x52d, 0x52d}, {0x52f, 0x52f}, {0x560, 0x588},
  {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x63f}, {0x641, 0x64a}, {0x66e, 0x66f}, {0x671, 0x6d3}, {0x6d5, 0x6d5}, {0x6ee, 0x6ef},
  {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710}, {0x712, 0x72f}, {0x74d, 0x7a5}, {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x800, 0x815},
  {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c8}, {0x904, 0x939}, {0x93d, 0x93d}, {0x950, 0x950},
  {0x958, 0x961}, {0x972, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9},
  {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc}, {0xa05, 0xa0a}, {0xa0f, 0xa10},
  {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa72, 0xa74},
  {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabd, 0xabd}, {0xad0, 0xad0},
  {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39},
  {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95},
  {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbd0, 0xbd0}, {0xc05, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc61}, {0xc80, 0xc80},
  {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd}, {0xcdd, 0xcde}, {0xce0, 0xce1},
  {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e}, {0xd54, 0xd56}, {0xd5f, 0xd61},
  {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xe01, 0xe30}, {0xe32, 0xe33},
  {0xe40, 0xe45}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xeb0}, {0xeb2, 0xeb3},
  {0xebd, 0xebd}, {0xec0, 0xec4}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47}, {0xf49, 0xf6c}, {0xf88, 0xf8c}, {0x1000, 0x102a},
  {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066}, {0x106e, 0x1070}, {0x1075, 0x1081}, {0x108e, 0x108e},
  {0x10d0, 0x10fa}, {0x10fd, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d},
  {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315},
  {0x1318, 0x135a}, {0x1380, 0x138f}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16f1, 0x16f8},
  {0x1700, 0x1711}, {0x171f, 0x1731}, {0x1740, 0x1751}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17dc, 0x17dc}, {0x1820, 0x1842},
  {0x1844, 0x1878}, {0x1880, 0x1884}, {0x1887, 0x18a8}, {0x18aa, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974},
  {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x1a00, 0x1a16}, {0x1a20, 0x1a54}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf},
  {0x1bba, 0x1be5}, {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f}, {0x1c5a, 0x1c77}, {0x1c80, 0x1c88}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3}, {0x1cf5, 0x1cf6},
  {0x1cfa, 0x1cfa}, {0x1d00, 0x1d2b}, {0x1d6b, 0x1d77}, {0x1d79, 0x1d9a}, {0x1e01, 0x1e01}, {0x1e03, 0x1e03}, {0x1e05, 0x1e05}, {0x1e07, 0x1e07},
  {0x1e09, 0x1e09}, {0x1e0b, 0x1e0b}, {0x1e0d, 0x1e0d}, {0x1e0f, 0x1e0f}, {0x1e11, 0x1e11}, {0x1e13, 0x1e13}, {0x1e15, 0x1e15}, {0x1e17, 0x1e17},
  {0x1e19, 0x1e19}, {0x1e1b, 0x1e1b}, {0x1e1d, 0x1e1d}, {0x1e1f, 0x1e1f}, {0x1e21, 0x1e21}, {0x1e23, 0x1e23}, {0x1e25, 0x1e25}, {0x1e27, 0x1e27},
  {0x1e29, 0x1e29}, {0x1e2b, 0x1e2b}, {0x1e2d, 0x1e2d}, {0x1e2f, 0x1e2f}, {0x1e31, 0x1e31}, {0x1e33, 0x1e33}, {0x1e35, 0x1e35}, {0x1e37, 0x1e37},
  {0x1e39, 0x1e39}, {0x1e3b, 0x1e3b}, {0x1e3d, 0x1e3d}, {0x1e3f, 0x1e3f}, {0x1e41, 0x1e41}, {0x1e43, 0x1e43}, {0x1e45, 0x1e45}, {0x1e47, 0x1e47},
  {0x1e49, 0x1e49}, {0x1e4b, 0x1e4b}, {0x1e4d, 0x1e4d}, {0x1e4f, 0x1e4f}, {0x1e51, 0x1e51}, {0x1e53, 0x1e53}, {0x1e55, 0x1e55}, {0x1e57, 0x1e57},
  {0x1e59, 0x1e59}, {0x1e5b, 0x1e5b}, {0x1e5d, 0x1e5d}, {0x1e5f, 0x1e5f}, {0x1e61, 0x1e61}, {0x1e63, 0x1e63}, {0x1e65, 0x1e65}, {0x1e67, 0x1e67},
  {0x1e69, 0x1e69}, {0x1e6b, 0x1e6b}, {0x1e6d, 0x1e6d}, {0x1e6f, 0x1e6f}, {0x1e71, 0x1e71}, {0x1e73, 0x1e73}, {0x1e75, 0x1e75}, {0x1e77, 0x1e77},
  {0x1e79, 0x1e79}, {0x1e7b, 0x1e7b}, {0x1e7d, 0x1e7d}, {0x1e7f, 0x1e7f}, {0x1e81, 0x1e81}, {0x1e83, 0x1e83}, {0x1e85, 0x1e85}, {0x1e87, 0x1e87},
  {0x1e89, 0x1e89}, {0x1e8b, 0x1e8b}, {0x1e8d, 0x1e8d}, {0x1e8f, 0x1e8f}, {0x1e91, 0x1e91}, {0x1e93, 0x1e93}, {0x1e95, 0x1e9d}, {0x1e9f, 0x1e9f},
  {0x1ea1, 0x1ea1}, {0x1ea3, 0x1ea3}, {0x1ea5, 0x1ea5}, {0x1ea7, 0x1ea7}, {0x1ea9, 0x1ea9}, {0x1eab, 0x1eab}, {0x1ead, 0x1ead}, {0x1eaf, 0x1eaf},
  {0x1eb1, 0x1eb1}, {0x1eb3, 0x1eb3}, {0x1eb5, 0x1eb5}, {0x1eb7, 0x1eb7}, {0x1eb9, 0x1eb9}, {0x1ebb, 0x1ebb}, {0x1ebd, 0x1ebd}, {0x1ebf, 0x1ebf},
  {0x1ec1, 0x1ec1}, {0x1ec3, 0x1ec3}, {0x1ec5, 0x1ec5}, {0x1ec7, 0x1ec7}, {0x1ec9, 0x1ec9}, {0x1ecb, 0x1ecb}, {0x1ecd, 0x1ecd}, {0x1ecf, 0x1ecf},
  {0x1ed1, 0x1ed1}, {0x1ed3, 0x1ed3}, {0x1ed5, 0x1ed5}, {0x1ed7, 0x1ed7}, {0x1ed9, 0x1ed9}, {0x1edb, 0x1edb}, {0x1edd, 0x1edd}, {0x1edf, 0x1edf},
  {0x1ee1, 0x1ee1}, {0x1ee3, 0x1ee3}, {0x1ee5, 0x1ee5}, {0x1ee7, 0x1ee7}, {0x1ee9, 0x1ee9}, {0x1eeb, 0x1eeb}, {0x1eed, 0x1eed}, {0x1eef, 0x1eef},
  {0x1ef1, 0x1ef1}, {0x1ef3, 0x1ef3}, {0x1ef5, 0x1ef5}, {0x1ef7, 0x1ef7}, {0x1ef9, 0x1ef9}, {0x1efb, 0x1efb}, {0x1efd, 0x1efd}, {0x1eff, 0x1f07},
  {0x1f10, 0x1f15}, {0x1f20, 0x1f27}, {0x1f30, 0x1f37}, {0x1f40, 0x1f45}, {0x1f50, 0x1f57}, {0x1f60, 0x1f67}, {0x1f70, 0x1f7d}, {0x1f80, 0x1f87},
  {0x1f90, 0x1f97}, {0x1fa0, 0x1fa7}, {0x1fb0, 0x1fb4}, {0x1fb6, 0x1fb7}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fc7}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fd7}, {0x1fe0, 0x1fe7}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ff7}, {0x210a, 0x210a}, {0x210e, 0x210f}, {0x2113, 0x2113}, {0x212f, 0x212f},
  {0x2134, 0x2139}, {0x213c, 0x213d}, {0x2146, 0x2149}, {0x214e, 0x214e}, {0x2184, 0x2184}, {0x2c30, 0x2c5f}, {0x2c61, 0x2c61}, {0x2c65, 0x2c66},
  {0x2c68, 0x2c68}, {0x2c6a, 0x2c6a}, {0x2c6c, 0x2c6c}, {0x2c71, 0x2c71}, {0x2c73, 0x2c74}, {0x2c76, 0x2c7b}, {0x2c81, 0x2c81}, {0x2c83, 0x2c83},
  {0x2c85, 0x2c85}, {0x2c87, 0x2c87}, {0x2c89, 0x2c89}, {0x2c8b, 0x2c8b}, {0x2c8d, 0x2c8d}, {0x2c8f, 0x2c8f}, {0x2c91, 0x2c91}, {0x2c93, 0x2c93},
  {0x2c95, 0x2c95}, {0x2c97, 0x2c97}, {0x2c99, 0x2c99}, {0x2c9b, 0x2c9b}, {0x2c9d, 0x2c9d}, {0x2c9f, 0x2c9f}, {0x2ca1, 0x2ca1}, {0x2ca3, 0x2ca3},
  {0x2ca5, 0x2ca5}, {0x2ca7, 0x2ca7}, {0x2ca9, 0x2ca9}, {0x2cab, 0x2cab}, {0x2cad, 0x2cad}, {0x2caf, 0x2caf}, {0x2cb1, 0x2cb1}, {0x2cb3, 0x2cb3},
  {0x2cb5, 0x2cb5}, {0x2cb7, 0x2cb7}, {0x2cb9, 0x2cb9}, {0x2cbb, 0x2cbb}, {0x2cbd, 0x2cbd}, {0x2cbf, 0x2cbf}, {0x2cc1, 0x2cc1}, {0x2cc3, 0x2cc3},
  {0x2cc5, 0x2cc5}, {0x2cc7, 0x2cc7}, {0x2cc9, 0x2cc9}, {0x2ccb, 0x2ccb}, {0x2ccd, 0x2ccd}, {0x2ccf, 0x2ccf}, {0x2cd1, 0x2cd1}, {0x2cd3, 0x2cd3},
  {0x2cd5, 0x2cd5}, {0x2cd7, 0x2cd7}, {0x2cd9, 0x2cd9}, {0x2cdb, 0x2cdb}, {0x2cdd, 0x2cdd}, {0x2cdf, 0x2cdf}, {0x2ce1, 0x2ce1}, {0x2ce3, 0x2ce4},
  {0x2cec, 0x2cec}, {0x2cee, 0x2cee}, {0x2cf3, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d80, 0x2d96},
  {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde},
  {0x3006, 0x3006}, {0x303c, 0x303c}, {0x3041, 0x3096}, {0x309f, 0x309f}, {0x30a1, 0x30fa}, {0x30ff, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e},
  {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x3400}, {0x4dbf, 0x4dbf}, {0x4e00, 0x4e00}, {0x9fff, 0xa014}, {0xa016, 0xa48c}, {0xa4d0, 0xa4f7},
  {0xa500, 0xa60b}, {0xa610, 0xa61f}, {0xa62a, 0xa62b}, {0xa641, 0xa641}, {0xa643, 0xa643}, {0xa645, 0xa645}, {0xa647, 0xa647}, {0xa649, 0xa649},
  {0xa64b, 0xa64b}, {0xa64d, 0xa64d}, {0xa64f, 0xa64f}, {0xa651, 0xa651}, {0xa653, 0xa653}, {0xa655, 0xa655}, {0xa657, 0xa657}, {0xa659, 0xa659},
  {0xa65b, 0xa65b}, {0xa65d, 0xa65d}, {0xa65f, 0xa65f}, {0xa661, 0xa661}, {0xa663, 0xa663}, {0xa665, 0xa665}, {0xa667, 0xa667}, {0xa669, 0xa669},
  {0xa66b, 0xa66b}, {0xa66d, 0xa66e}, {0xa681, 0xa681}, {0xa683, 0xa683}, {0xa685, 0xa685}, {0xa687, 0xa687}, {0xa689, 0xa689}, {0xa68b, 0xa68b},
  {0xa68d, 0xa68d}, {0xa68f, 0xa68f}, {0xa691, 0xa691}, {0xa693, 0xa693}, {0xa695, 0xa695}, {0xa697, 0xa697}, {0xa699, 0xa699}, {0xa69b, 0xa69b},
  {0xa6a0, 0xa6e5}, {0xa723, 0xa723}, {0xa725, 0xa725}, {0xa727, 0xa727}, {0xa729, 0xa729}, {0xa72b, 0xa72b}, {0xa72d, 0xa72d}, {0xa72f, 0xa731},
  {0xa733, 0xa733}, {0xa735, 0xa735}, {0xa737, 0xa737}, {0xa739, 0xa739}, {0xa73b, 0xa73b}, {0xa73d, 0xa73d}, {0xa73f, 0xa73f}, {0xa741, 0xa741},
  {0xa743, 0xa743}, {0xa745, 0xa745}, {0xa747, 0xa747}, {0xa749, 0xa749}, {0xa74b, 0xa74b}, {0xa74d, 0xa74d}, {0xa74f, 0xa74f}, {0xa751, 0xa751},
  {0xa753, 0xa753}, {0xa755, 0xa755}, {0xa757, 0xa757}, {0xa759, 0xa759}, {0xa75b, 0xa75b}, {0xa75d, 0xa75d}, {0xa75f, 0xa75f}, {0xa761, 0xa761},
  {0xa763, 0xa763}, {0xa765, 0xa765}, {0xa767, 0xa767}, {0xa769, 0xa769}, {0xa76b, 0xa76b}, {0xa76d, 0xa76d}, {0xa76f, 0xa76f}, {0xa771, 0xa778},
  {0xa77a, 0xa77a}, {0xa77c, 0xa77c}, {0xa77f, 0xa77f}, {0xa781, 0xa781}, {0xa783, 0xa783}, {0xa785, 0xa785}, {0xa787, 0xa787}, {0xa78c, 0xa78c},
  {0xa78e, 0xa78f}, {0xa791, 0xa791}, {0xa793, 0xa795}, {0xa797, 0xa797}, {0xa799, 0xa799}, {0xa79b, 0xa79b}, {0xa79d, 0xa79d}, {0xa79f, 0xa79f},
  {0xa7a1, 0xa7a1}, {0xa7a3, 0xa7a3}, {0xa7a5, 0xa7a5}, {0xa7a7, 0xa7a7}, {0xa7a9, 0xa7a9}, {0xa7af, 0xa7af}, {0xa7b5, 0xa7b5}, {0xa7b7, 0xa7b7},
  {0xa7b9, 0xa7b9}, {0xa7bb, 0xa7bb}, {0xa7bd, 0xa7bd}, {0xa7bf, 0xa7bf}, {0xa7c1, 0xa7c1}, {0xa7c3, 0xa7c3}, {0xa7c8, 0xa7c8}, {0xa7ca, 0xa7ca},
  {0xa7d1, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d5}, {0xa7d7, 0xa7d7}, {0xa7d9, 0xa7d9}, {0xa7f6, 0xa7f7}, {0xa7fa, 0xa801}, {0xa803, 0xa805},
  {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3}, {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa8fe}, {0xa90a, 0xa925},
  {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9e0, 0xa9e4}, {0xa9e7, 0xa9ef}, {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42},
  {0xaa44, 0xaa4b}, {0xaa60, 0xaa6f}, {0xaa71, 0xaa76}, {0xaa7a, 0xaa7a}, {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1}, {0xaab5, 0xaab6}, {0xaab9, 0xaabd},
  {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadc}, {0xaae0, 0xaaea}, {0xaaf2, 0xaaf2}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16},
  {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab60, 0xab68}, {0xab70, 0xabe2}, {0xac00, 0xac00}, {0xd7a3, 0xd7a3}, {0xd7b0, 0xd7c6},
  {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28}, {0xfb2a, 0xfb36},
  {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7},
  {0xfdf0, 0xfdfb}, {0xfe70, 0xfe74}, {0xfe76, 0xfefc}, {0xff41, 0xff5a}, {0xff66, 0xff6f}, {0xff71, 0xff9d}, {0xffa0, 0xffbe}, {0xffc2, 0xffc7},
  {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d},
  {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x10340}, {0x10342, 0x10349}, {0x10350, 0x10375},
  {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x10428, 0x1049d}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10597, 0x105a1},
  {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10800, 0x10805}, {0x10808, 0x10808},
  {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5},
  {0x10900, 0x10915}, {0x10920, 0x1092b},
};

static TSCharacterRange sym_implicit_variable_character_set_1[] = {
  {'\'', '\''}, {'0', '9'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb2, 0xb3}, {0xb5, 0xb5},
  {0xb9, 0xba}, {0xbc, 0xbe}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec},
  {0x2ee, 0x2ee}, {0x300, 0x374}, {0x376, 0x377}, {0x37a, 0x37d}, {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c},
  {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588},
  {0x591, 0x5bd}, {0x5bf, 0x5bf}, {0x5c1, 0x5c2}, {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a},
  {0x620, 0x669}, {0x66e, 0x6d3}, {0x6d5, 0x6dc}, {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1},
  {0x7c0, 0x7f5}, {0x7fa, 0x7fa}, {0x7fd, 0x7fd}, {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e},
  {0x898, 0x8e1}, {0x8e3, 0x902}, {0x904, 0x93a}, {0x93c, 0x93d}, {0x941, 0x948}, {0x94d, 0x94d}, {0x950, 0x963}, {0x966, 0x96f},
  {0x971, 0x981}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bc, 0x9bd},
  {0x9c1, 0x9c4}, {0x9cd, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1}, {0x9f4, 0x9f9}, {0x9fc, 0x9fc}, {0x9fe, 0x9fe},
  {0xa01, 0xa02}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39},
  {0xa3c, 0xa3c}, {0xa41, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa66, 0xa75},
  {0xa81, 0xa82}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabc, 0xabd},
  {0xac1, 0xac5}, {0xac7, 0xac8}, {0xacd, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff}, {0xb01, 0xb01},
  {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb3d}, {0xb3f, 0xb3f},
  {0xb41, 0xb44}, {0xb4d, 0xb4d}, {0xb55, 0xb56}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb77}, {0xb82, 0xb83},
  {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa},
  {0xbae, 0xbb9}, {0xbc0, 0xbc0}, {0xbcd, 0xbcd}, {0xbd0, 0xbd0}, {0xbe6, 0xbf2}, {0xc00, 0xc00}, {0xc04, 0xc0c}, {0xc0e, 0xc10},
  {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3c, 0xc40}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a}, {0xc5d, 0xc5d},
  {0xc60, 0xc63}, {0xc66, 0xc6f}, {0xc78, 0xc7e}, {0xc80, 0xc81}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3},
  {0xcb5, 0xcb9}, {0xcbc, 0xcbd}, {0xcbf, 0xcbf}, {0xcc6, 0xcc6}, {0xccc, 0xccd}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef},
  {0xcf1, 0xcf2}, {0xd00, 0xd01}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3d}, {0xd41, 0xd44}, {0xd4d, 0xd4e}, {0xd54, 0xd56},
  {0xd58, 0xd63}, {0xd66, 0xd78}, {0xd7a, 0xd7f}, {0xd81, 0xd81}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd},
  {0xdc0, 0xdc6}, {0xdca, 0xdca}, {0xdd2, 0xdd4}, {0xdd6, 0xdd6}, {0xde6, 0xdef}, {0xe01, 0xe3a}, {0xe40, 0xe4e}, {0xe50, 0xe59},
  {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6},
  {0xec8, 0xecd}, {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf33}, {0xf35, 0xf35}, {0xf37, 0xf37},
  {0xf39, 0xf39}, {0xf40, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf7e}, {0xf80, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6},
  {0x1000, 0x102a}, {0x102d, 0x1030}, {0x1032, 0x1037}, {0x1039, 0x103a}, {0x103d, 0x1049}, {0x1050, 0x1055}, {0x1058, 0x1061}, {0x1065, 0x1066},
  {0x106e, 0x1082}, {0x1085, 0x1086}, {0x108d, 0x108e}, {0x1090, 0x1099}, {0x109d, 0x109d}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd},
  {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d},
  {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315},
  {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x137c}, {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f},
  {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1714}, {0x171f, 0x1733}, {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770},
  {0x1772, 0x1773}, {0x1780, 0x17b5}, {0x17b7, 0x17bd}, {0x17c6, 0x17c6}, {0x17c9, 0x17d3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dd}, {0x17e0, 0x17e9},
  {0x17f0, 0x17f9}, {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1920, 0x1922},
  {0x1927, 0x1928}, {0x1932, 0x1932}, {0x1939, 0x193b}, {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da},
  {0x1a00, 0x1a18}, {0x1a1b, 0x1a1b}, {0x1a20, 0x1a54}, {0x1a56, 0x1a56}, {0x1a58, 0x1a5e}, {0x1a60, 0x1a60}, {0x1a62, 0x1a62}, {0x1a65, 0x1a6c},
  {0x1a73, 0x1a7c}, {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b03}, {0x1b05, 0x1b34},
  {0x1b36, 0x1b3a}, {0x1b3c, 0x1b3c}, {0x1b42, 0x1b42}, {0x1b45, 0x1b4c}, {0x1b50, 0x1b59}, {0x1b6b, 0x1b73}, {0x1b80, 0x1b81}, {0x1b83, 0x1ba0},
  {0x1ba2, 0x1ba5}, {0x1ba8, 0x1ba9}, {0x1bab, 0x1be6}, {0x1be8, 0x1be9}, {0x1bed, 0x1bed}, {0x1bef, 0x1bf1}, {0x1c00, 0x1c23}, {0x1c2c, 0x1c33},
  {0x1c36, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1cd0, 0x1cd2}, {0x1cd4, 0x1ce0},
  {0x1ce2, 0x1cf6}, {0x1cf8, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59},
  {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc},
  {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2070, 0x2071}, {0x2074, 0x2079}, {0x207f, 0x2089},
  {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115},
  {0x2119, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x212d}, {0x212f, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149},
  {0x214e, 0x214e}, {0x2150, 0x2189}, {0x2460, 0x249b}, {0x24ea, 0x24ff}, {0x2776, 0x2793}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2cfd, 0x2cfd},
  {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae},
  {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x2e2f, 0x2e2f},
  {0x3005, 0x3007}, {0x3021, 0x302d}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096}, {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30fa},
  {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x3192, 0x3195}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3220, 0x3229}, {0x3248, 0x324f},
  {0x3251, 0x325f}, {0x3280, 0x3289}, {0x32b1, 0x32bf}, {0x3400, 0x3400}, {0x4dbf, 0x4dbf}, {0x4e00, 0x4e00}, {0x9fff, 0xa48c}, {0xa4d0, 0xa4fd},
  {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d}, {0xa67f, 0xa6f1}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca},
  {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa822}, {0xa825, 0xa826}, {0xa82c, 0xa82c}, {0xa830, 0xa835}, {0xa840, 0xa873},
  {0xa882, 0xa8b3}, {0xa8c4, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa951}, {0xa960, 0xa97c},
  {0xa980, 0xa982}, {0xa984, 0xa9b3}, {0xa9b6, 0xa9b9}, {0xa9bc, 0xa9bd}, {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa2e}, {0xaa31, 0xaa32},
  {0xaa35, 0xaa36}, {0xaa40, 0xaa4c}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a}, {0xaa7c, 0xaa7c}, {0xaa7e, 0xaac2}, {0xaadb, 0xaadd},
  {0xaae0, 0xaaea}, {0xaaec, 0xaaed}, {0xaaf2, 0xaaf4}, {0xaaf6, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26},
  {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabe2}, {0xabe5, 0xabe5}, {0xabe8, 0xabe8}, {0xabed, 0xabed}, {0xabf0, 0xabf9},
  {0xac00, 0xac00}, {0xd7a3, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17},
  {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfd3d},
  {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdfb}, {0xfe00, 0xfe0f}, {0xfe20, 0xfe2f}, {0xfe70, 0xfe74}, {0xfe76, 0xfefc}, {0xff10, 0xff19},
  {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b},
  {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10107, 0x10133}, {0x10140, 0x10178},
  {0x1018a, 0x1018b}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x102e0, 0x102fb}, {0x10300, 0x10323}, {0x1032d, 0x1034a}, {0x10350, 0x1037a},
  {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb},
  {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1},
  {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba},
  {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10858, 0x10876}, {0x10879, 0x1089e},
  {0x108a7, 0x108af}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x108fb, 0x1091b}, {0x10920, 0x1092b},
};

static TSCharacterRange sym_name_character_set_1[] = {
  {'A', 'Z'}, {0xc0, 0xd6}, {0xd8, 0xde}, {0x100, 0x100}, {0x102, 0x102}, {0x104, 0x104}, {0x106, 0x106}, {0x108, 0x108},
  {0x10a, 0x10a}, {0x10c, 0x10c}, {0x10e, 0x10e}, {0x110, 0x110}, {0x112, 0x112}, {0x114, 0x114}, {0x116, 0x116}, {0x118, 0x118},
  {0x11a, 0x11a}, {0x11c, 0x11c}, {0x11e, 0x11e}, {0x120, 0x120}, {0x122, 0x122}, {0x124, 0x124}, {0x126, 0x126}, {0x128, 0x128},
  {0x12a, 0x12a}, {0x12c, 0x12c}, {0x12e, 0x12e}, {0x130, 0x130}, {0x132, 0x132}, {0x134, 0x134}, {0x136, 0x136}, {0x139, 0x139},
  {0x13b, 0x13b}, {0x13d, 0x13d}, {0x13f, 0x13f}, {0x141, 0x141}, {0x143, 0x143}, {0x145, 0x145}, {0x147, 0x147}, {0x14a, 0x14a},
  {0x14c, 0x14c}, {0x14e, 0x14e}, {0x150, 0x150}, {0x152, 0x152}, {0x154, 0x154}, {0x156, 0x156}, {0x158, 0x158}, {0x15a, 0x15a},
  {0x15c, 0x15c}, {0x15e, 0x15e}, {0x160, 0x160}, {0x162, 0x162}, {0x164, 0x164}, {0x166, 0x166}, {0x168, 0x168}, {0x16a, 0x16a},
  {0x16c, 0x16c}, {0x16e, 0x16e}, {0x170, 0x170}, {0x172, 0x172}, {0x174, 0x174}, {0x176, 0x176}, {0x178, 0x179}, {0x17b, 0x17b},
  {0x17d, 0x17d}, {0x181, 0x182}, {0x184, 0x184}, {0x186, 0x187}, {0x189, 0x18b}, {0x18e, 0x191}, {0x193, 0x194}, {0x196, 0x198},
  {0x19c, 0x19d}, {0x19f, 0x1a0}, {0x1a2, 0x1a2}, {0x1a4, 0x1a4}, {0x1a6, 0x1a7}, {0x1a9, 0x1a9}, {0x1ac, 0x1ac}, {0x1ae, 0x1af},
  {0x1b1, 0x1b3}, {0x1b5, 0x1b5}, {0x1b7, 0x1b8}, {0x1bc, 0x1bc}, {0x1c4, 0x1c5}, {0x1c7, 0x1c8}, {0x1ca, 0x1cb}, {0x1cd, 0x1cd},
  {0x1cf, 0x1cf}, {0x1d1, 0x1d1}, {0x1d3, 0x1d3}, {0x1d5, 0x1d5}, {0x1d7, 0x1d7}, {0x1d9, 0x1d9}, {0x1db, 0x1db}, {0x1de, 0x1de},
  {0x1e0, 0x1e0}, {0x1e2, 0x1e2}, {0x1e4, 0x1e4}, {0x1e6, 0x1e6}, {0x1e8, 0x1e8}, {0x1ea, 0x1ea}, {0x1ec, 0x1ec}, {0x1ee, 0x1ee},
  {0x1f1, 0x1f2}, {0x1f4, 0x1f4}, {0x1f6, 0x1f8}, {0x1fa, 0x1fa}, {0x1fc, 0x1fc}, {0x1fe, 0x1fe}, {0x200, 0x200}, {0x202, 0x202},
  {0x204, 0x204}, {0x206, 0x206}, {0x208, 0x208}, {0x20a, 0x20a}, {0x20c, 0x20c}, {0x20e, 0x20e}, {0x210, 0x210}, {0x212, 0x212},
  {0x214, 0x214}, {0x216, 0x216}, {0x218, 0x218}, {0x21a, 0x21a}, {0x21c, 0x21c}, {0x21e, 0x21e}, {0x220, 0x220}, {0x222, 0x222},
  {0x224, 0x224}, {0x226, 0x226}, {0x228, 0x228}, {0x22a, 0x22a}, {0x22c, 0x22c}, {0x22e, 0x22e}, {0x230, 0x230}, {0x232, 0x232},
  {0x23a, 0x23b}, {0x23d, 0x23e}, {0x241, 0x241}, {0x243, 0x246}, {0x248, 0x248}, {0x24a, 0x24a}, {0x24c, 0x24c}, {0x24e, 0x24e},
  {0x370, 0x370}, {0x372, 0x372}, {0x376, 0x376}, {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x38f},
  {0x391, 0x3a1}, {0x3a3, 0x3ab}, {0x3cf, 0x3cf}, {0x3d2, 0x3d4}, {0x3d8, 0x3d8}, {0x3da, 0x3da}, {0x3dc, 0x3dc}, {0x3de, 0x3de},
  {0x3e0, 0x3e0}, {0x3e2, 0x3e2}, {0x3e4, 0x3e4}, {0x3e6, 0x3e6}, {0x3e8, 0x3e8}, {0x3ea, 0x3ea}, {0x3ec, 0x3ec}, {0x3ee, 0x3ee},
  {0x3f4, 0x3f4}, {0x3f7, 0x3f7}, {0x3f9, 0x3fa}, {0x3fd, 0x42f}, {0x460, 0x460}, {0x462, 0x462}, {0x464, 0x464}, {0x466, 0x466},
  {0x468, 0x468}, {0x46a, 0x46a}, {0x46c, 0x46c}, {0x46e, 0x46e}, {0x470, 0x470}, {0x472, 0x472}, {0x474, 0x474}, {0x476, 0x476},
  {0x478, 0x478}, {0x47a, 0x47a}, {0x47c, 0x47c}, {0x47e, 0x47e}, {0x480, 0x480}, {0x48a, 0x48a}, {0x48c, 0x48c}, {0x48e, 0x48e},
  {0x490, 0x490}, {0x492, 0x492}, {0x494, 0x494}, {0x496, 0x496}, {0x498, 0x498}, {0x49a, 0x49a}, {0x49c, 0x49c}, {0x49e, 0x49e},
  {0x4a0, 0x4a0}, {0x4a2, 0x4a2}, {0x4a4, 0x4a4}, {0x4a6, 0x4a6}, {0x4a8, 0x4a8}, {0x4aa, 0x4aa}, {0x4ac, 0x4ac}, {0x4ae, 0x4ae},
  {0x4b0, 0x4b0}, {0x4b2, 0x4b2}, {0x4b4, 0x4b4}, {0x4b6, 0x4b6}, {0x4b8, 0x4b8}, {0x4ba, 0x4ba}, {0x4bc, 0x4bc}, {0x4be, 0x4be},
  {0x4c0, 0x4c1}, {0x4c3, 0x4c3}, {0x4c5, 0x4c5}, {0x4c7, 0x4c7}, {0x4c9, 0x4c9}, {0x4cb, 0x4cb}, {0x4cd, 0x4cd}, {0x4d0, 0x4d0},
  {0x4d2, 0x4d2}, {0x4d4, 0x4d4}, {0x4d6, 0x4d6}, {0x4d8, 0x4d8}, {0x4da, 0x4da}, {0x4dc, 0x4dc}, {0x4de, 0x4de}, {0x4e0, 0x4e0},
  {0x4e2, 0x4e2}, {0x4e4, 0x4e4}, {0x4e6, 0x4e6}, {0x4e8, 0x4e8}, {0x4ea, 0x4ea}, {0x4ec, 0x4ec}, {0x4ee, 0x4ee}, {0x4f0, 0x4f0},
  {0x4f2, 0x4f2}, {0x4f4, 0x4f4}, {0x4f6, 0x4f6}, {0x4f8, 0x4f8}, {0x4fa, 0x4fa}, {0x4fc, 0x4fc}, {0x4fe, 0x4fe}, {0x500, 0x500},
  {0x502, 0x502}, {0x504, 0x504}, {0x506, 0x506}, {0x508, 0x508}, {0x50a, 0x50a}, {0x50c, 0x50c}, {0x50e, 0x50e}, {0x510, 0x510},
  {0x512, 0x512}, {0x514, 0x514}, {0x516, 0x516}, {0x518, 0x518}, {0x51a, 0x51a}, {0x51c, 0x51c}, {0x51e, 0x51e}, {0x520, 0x520},
  {0x522, 0x522}, {0x524, 0x524}, {0x526, 0x526}, {0x528, 0x528}, {0x52a, 0x52a}, {0x52c, 0x52c}, {0x52e, 0x52e}, {0x531, 0x556},
  {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x13a0, 0x13f5}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1e00, 0x1e00}, {0x1e02, 0x1e02},
  {0x1e04, 0x1e04}, {0x1e06, 0x1e06}, {0x1e08, 0x1e08}, {0x1e0a, 0x1e0a}, {0x1e0c, 0x1e0c}, {0x1e0e, 0x1e0e}, {0x1e10, 0x1e10}, {0x1e12, 0x1e12},
  {0x1e14, 0x1e14}, {0x1e16, 0x1e16}, {0x1e18, 0x1e18}, {0x1e1a, 0x1e1a}, {0x1e1c, 0x1e1c}, {0x1e1e, 0x1e1e}, {0x1e20, 0x1e20}, {0x1e22, 0x1e22},
  {0x1e24, 0x1e24}, {0x1e26, 0x1e26}, {0x1e28, 0x1e28}, {0x1e2a, 0x1e2a}, {0x1e2c, 0x1e2c}, {0x1e2e, 0x1e2e}, {0x1e30, 0x1e30}, {0x1e32, 0x1e32},
  {0x1e34, 0x1e34}, {0x1e36, 0x1e36}, {0x1e38, 0x1e38}, {0x1e3a, 0x1e3a}, {0x1e3c, 0x1e3c}, {0x1e3e, 0x1e3e}, {0x1e40, 0x1e40}, {0x1e42, 0x1e42},
  {0x1e44, 0x1e44}, {0x1e46, 0x1e46}, {0x1e48, 0x1e48}, {0x1e4a, 0x1e4a}, {0x1e4c, 0x1e4c}, {0x1e4e, 0x1e4e}, {0x1e50, 0x1e50}, {0x1e52, 0x1e52},
  {0x1e54, 0x1e54}, {0x1e56, 0x1e56}, {0x1e58, 0x1e58}, {0x1e5a, 0x1e5a}, {0x1e5c, 0x1e5c}, {0x1e5e, 0x1e5e}, {0x1e60, 0x1e60}, {0x1e62, 0x1e62},
  {0x1e64, 0x1e64}, {0x1e66, 0x1e66}, {0x1e68, 0x1e68}, {0x1e6a, 0x1e6a}, {0x1e6c, 0x1e6c}, {0x1e6e, 0x1e6e}, {0x1e70, 0x1e70}, {0x1e72, 0x1e72},
  {0x1e74, 0x1e74}, {0x1e76, 0x1e76}, {0x1e78, 0x1e78}, {0x1e7a, 0x1e7a}, {0x1e7c, 0x1e7c}, {0x1e7e, 0x1e7e}, {0x1e80, 0x1e80}, {0x1e82, 0x1e82},
  {0x1e84, 0x1e84}, {0x1e86, 0x1e86}, {0x1e88, 0x1e88}, {0x1e8a, 0x1e8a}, {0x1e8c, 0x1e8c}, {0x1e8e, 0x1e8e}, {0x1e90, 0x1e90}, {0x1e92, 0x1e92},
  {0x1e94, 0x1e94}, {0x1e9e, 0x1e9e}, {0x1ea0, 0x1ea0}, {0x1ea2, 0x1ea2}, {0x1ea4, 0x1ea4}, {0x1ea6, 0x1ea6}, {0x1ea8, 0x1ea8}, {0x1eaa, 0x1eaa},
  {0x1eac, 0x1eac}, {0x1eae, 0x1eae}, {0x1eb0, 0x1eb0}, {0x1eb2, 0x1eb2}, {0x1eb4, 0x1eb4}, {0x1eb6, 0x1eb6}, {0x1eb8, 0x1eb8}, {0x1eba, 0x1eba},
  {0x1ebc, 0x1ebc}, {0x1ebe, 0x1ebe}, {0x1ec0, 0x1ec0}, {0x1ec2, 0x1ec2}, {0x1ec4, 0x1ec4}, {0x1ec6, 0x1ec6}, {0x1ec8, 0x1ec8}, {0x1eca, 0x1eca},
  {0x1ecc, 0x1ecc}, {0x1ece, 0x1ece}, {0x1ed0, 0x1ed0}, {0x1ed2, 0x1ed2}, {0x1ed4, 0x1ed4}, {0x1ed6, 0x1ed6}, {0x1ed8, 0x1ed8}, {0x1eda, 0x1eda},
  {0x1edc, 0x1edc}, {0x1ede, 0x1ede}, {0x1ee0, 0x1ee0}, {0x1ee2, 0x1ee2}, {0x1ee4, 0x1ee4}, {0x1ee6, 0x1ee6}, {0x1ee8, 0x1ee8}, {0x1eea, 0x1eea},
  {0x1eec, 0x1eec}, {0x1eee, 0x1eee}, {0x1ef0, 0x1ef0}, {0x1ef2, 0x1ef2}, {0x1ef4, 0x1ef4}, {0x1ef6, 0x1ef6}, {0x1ef8, 0x1ef8}, {0x1efa, 0x1efa},
  {0x1efc, 0x1efc}, {0x1efe, 0x1efe}, {0x1f08, 0x1f0f}, {0x1f18, 0x1f1d}, {0x1f28, 0x1f2f}, {0x1f38, 0x1f3f}, {0x1f48, 0x1f4d}, {0x1f59, 0x1f59},
  {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f5f}, {0x1f68, 0x1f6f}, {0x1f88, 0x1f8f}, {0x1f98, 0x1f9f}, {0x1fa8, 0x1faf}, {0x1fb8, 0x1fbc},
  {0x1fc8, 0x1fcc}, {0x1fd8, 0x1fdb}, {0x1fe8, 0x1fec}, {0x1ff8, 0x1ffc}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210b, 0x210d}, {0x2110, 0x2112},
  {0x2115, 0x2115}, {0x2119, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x212d}, {0x2130, 0x2133}, {0x213e, 0x213f},
  {0x2145, 0x2145}, {0x2183, 0x2183}, {0x2c00, 0x2c2f}, {0x2c60, 0x2c60}, {0x2c62, 0x2c64}, {0x2c67, 0x2c67}, {0x2c69, 0x2c69}, {0x2c6b, 0x2c6b},
  {0x2c6d, 0x2c70}, {0x2c72, 0x2c72}, {0x2c75, 0x2c75}, {0x2c7e, 0x2c80}, {0x2c82, 0x2c82}, {0x2c84, 0x2c84}, {0x2c86, 0x2c86}, {0x2c88, 0x2c88},
  {0x2c8a, 0x2c8a}, {0x2c8c, 0x2c8c}, {0x2c8e, 0x2c8e}, {0x2c90, 0x2c90}, {0x2c92, 0x2c92}, {0x2c94, 0x2c94}, {0x2c96, 0x2c96}, {0x2c98, 0x2c98},
  {0x2c9a, 0x2c9a}, {0x2c9c, 0x2c9c}, {0x2c9e, 0x2c9e}, {0x2ca0, 0x2ca0}, {0x2ca2, 0x2ca2}, {0x2ca4, 0x2ca4}, {0x2ca6, 0x2ca6}, {0x2ca8, 0x2ca8},
  {0x2caa, 0x2caa}, {0x2cac, 0x2cac}, {0x2cae, 0x2cae}, {0x2cb0, 0x2cb0}, {0x2cb2, 0x2cb2}, {0x2cb4, 0x2cb4}, {0x2cb6, 0x2cb6}, {0x2cb8, 0x2cb8},
  {0x2cba, 0x2cba}, {0x2cbc, 0x2cbc}, {0x2cbe, 0x2cbe}, {0x2cc0, 0x2cc0}, {0x2cc2, 0x2cc2}, {0x2cc4, 0x2cc4}, {0x2cc6, 0x2cc6}, {0x2cc8, 0x2cc8},
  {0x2cca, 0x2cca}, {0x2ccc, 0x2ccc}, {0x2cce, 0x2cce}, {0x2cd0, 0x2cd0}, {0x2cd2, 0x2cd2}, {0x2cd4, 0x2cd4}, {0x2cd6, 0x2cd6}, {0x2cd8, 0x2cd8},
  {0x2cda, 0x2cda}, {0x2cdc, 0x2cdc}, {0x2cde, 0x2cde}, {0x2ce0, 0x2ce0}, {0x2ce2, 0x2ce2}, {0x2ceb, 0x2ceb}, {0x2ced, 0x2ced}, {0x2cf2, 0x2cf2},
  {0xa640, 0xa640}, {0xa642, 0xa642}, {0xa644, 0xa644}, {0xa646, 0xa646}, {0xa648, 0xa648}, {0xa64a, 0xa64a}, {0xa64c, 0xa64c}, {0xa64e, 0xa64e},
  {0xa650, 0xa650}, {0xa652, 0xa652}, {0xa654, 0xa654}, {0xa656, 0xa656}, {0xa658, 0xa658}, {0xa65a, 0xa65a}, {0xa65c, 0xa65c}, {0xa65e, 0xa65e},
  {0xa660, 0xa660}, {0xa662, 0xa662}, {0xa664, 0xa664}, {0xa666, 0xa666}, {0xa668, 0xa668}, {0xa66a, 0xa66a}, {0xa66c, 0xa66c}, {0xa680, 0xa680},
  {0xa682, 0xa682}, {0xa684, 0xa684}, {0xa686, 0xa686}, {0xa688, 0xa688}, {0xa68a, 0xa68a}, {0xa68c, 0xa68c}, {0xa68e, 0xa68e}, {0xa690, 0xa690},
  {0xa692, 0xa692}, {0xa694, 0xa694}, {0xa696, 0xa696}, {0xa698, 0xa698}, {0xa69a, 0xa69a}, {0xa722, 0xa722}, {0xa724, 0xa724}, {0xa726, 0xa726},
  {0xa728, 0xa728}, {0xa72a, 0xa72a}, {0xa72c, 0xa72c}, {0xa72e, 0xa72e}, {0xa732, 0xa732}, {0xa734, 0xa734}, {0xa736, 0xa736}, {0xa738, 0xa738},
  {0xa73a, 0xa73a}, {0xa73c, 0xa73c}, {0xa73e, 0xa73e}, {0xa740, 0xa740}, {0xa742, 0xa742}, {0xa744, 0xa744}, {0xa746, 0xa746}, {0xa748, 0xa748},
  {0xa74a, 0xa74a}, {0xa74c, 0xa74c}, {0xa74e, 0xa74e}, {0xa750, 0xa750}, {0xa752, 0xa752}, {0xa754, 0xa754}, {0xa756, 0xa756}, {0xa758, 0xa758},
  {0xa75a, 0xa75a}, {0xa75c, 0xa75c}, {0xa75e, 0xa75e}, {0xa760, 0xa760}, {0xa762, 0xa762}, {0xa764, 0xa764}, {0xa766, 0xa766}, {0xa768, 0xa768},
  {0xa76a, 0xa76a}, {0xa76c, 0xa76c}, {0xa76e, 0xa76e}, {0xa779, 0xa779}, {0xa77b, 0xa77b}, {0xa77d, 0xa77e}, {0xa780, 0xa780}, {0xa782, 0xa782},
  {0xa784, 0xa784}, {0xa786, 0xa786}, {0xa78b, 0xa78b}, {0xa78d, 0xa78d}, {0xa790, 0xa790}, {0xa792, 0xa792}, {0xa796, 0xa796}, {0xa798, 0xa798},
  {0xa79a, 0xa79a}, {0xa79c, 0xa79c}, {0xa79e, 0xa79e}, {0xa7a0, 0xa7a0}, {0xa7a2, 0xa7a2}, {0xa7a4, 0xa7a4}, {0xa7a6, 0xa7a6}, {0xa7a8, 0xa7a8},
  {0xa7aa, 0xa7ae}, {0xa7b0, 0xa7b4}, {0xa7b6, 0xa7b6}, {0xa7b8, 0xa7b8}, {0xa7ba, 0xa7ba}, {0xa7bc, 0xa7bc}, {0xa7be, 0xa7be}, {0xa7c0, 0xa7c0},
  {0xa7c2, 0xa7c2}, {0xa7c4, 0xa7c7}, {0xa7c9, 0xa7c9}, {0xa7d0, 0xa7d0}, {0xa7d6, 0xa7d6}, {0xa7d8, 0xa7d8}, {0xa7f5, 0xa7f5}, {0xff21, 0xff3a},
  {0x10400, 0x10427}, {0x104b0, 0x104d3}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(72);
      ADVANCE_MAP(
        '\n', 174,
        '!', 167,
        '"', 26,
        '#', 147,
        '$', 99,
        '%', 169,
        '\'', 77,
        '(', 170,
        ')', 171,
        '*', 79,
        ',', 74,
        '-', 93,
        '.', 83,
        '0', 124,
        '1', 95,
        ':', 33,
        ';', 73,
        '<', 31,
        '=', 85,
        '?', 70,
        '@', 166,
        '[', 101,
        '\\', 91,
        ']', 172,
        '`', 140,
        '{', 75,
        '|', 150,
        '}', 76,
        '~', 168,
        0x2190, 163,
        0x2192, 159,
        0x21d2, 158,
        0x2200, 81,
        0x2237, 165,
        0x22b8, 161,
        0x2605, 80,
        0x27e6, 104,
        0x27e7, 103,
      );
      if (('2' <= lookahead && lookahead <= '9')) ADVANCE(125);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(71);
      if (set_contains(sym_name_character_set_1, 614, lookahead)) ADVANCE(155);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(152);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '\n', 174,
        '"', 26,
        '#', 147,
        '\'', 77,
        '(', 170,
        ')', 171,
        '*', 79,
        ',', 74,
        '-', 93,
        '0', 124,
        ':', 33,
        '=', 34,
        '?', 70,
        '[', 101,
        '\\', 91,
        ']', 172,
        '`', 140,
        '{', 75,
        '|', 149,
        '}', 76,
        0x2192, 159,
        0x21d2, 158,
        0x2200, 81,
        0x2237, 165,
        0x22b8, 161,
        0x2605, 80,
        0x27e6, 104,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(2);
      if (set_contains(sym_name_character_set_1, 614, lookahead)) ADVANCE(155);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(152);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '\n', 174,
        '"', 26,
        '#', 143,
        '\'', 77,
        '(', 170,
        ')', 171,
        '*', 79,
        ',', 74,
        '-', 93,
        '0', 124,
        ':', 33,
        '=', 34,
        '?', 70,
        '[', 101,
        '\\', 91,
        ']', 172,
        '`', 140,
        '{', 75,
        '|', 88,
        '}', 76,
        0x2192, 159,
        0x21d2, 158,
        0x2200, 81,
        0x2237, 165,
        0x22b8, 161,
        0x2605, 80,
        0x27e6, 104,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(2);
      if (set_contains(sym_name_character_set_1, 614, lookahead)) ADVANCE(155);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(152);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '\n', 174,
        '"', 26,
        '#', 148,
        '\'', 77,
        '(', 170,
        ')', 171,
        '*', 79,
        ',', 74,
        '-', 93,
        '.', 32,
        '0', 124,
        ':', 33,
        ';', 73,
        '<', 31,
        '=', 84,
        '?', 70,
        '[', 101,
        '\\', 91,
        ']', 172,
        '`', 140,
        '{', 75,
        '|', 37,
        '}', 76,
        0x2190, 163,
        0x2192, 159,
        0x2200, 81,
        0x2237, 165,
        0x22b8, 161,
        0x2605, 80,
        0x27e6, 104,
        0x27e7, 103,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(6);
      if (set_contains(sym_name_character_set_1, 614, lookahead)) ADVANCE(155);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(152);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '\n', 174,
        '"', 26,
        '#', 148,
        '\'', 77,
        '(', 170,
        ')', 171,
        '*', 79,
        ',', 74,
        '-', 93,
        '.', 82,
        '0', 124,
        ':', 33,
        ';', 73,
        '<', 31,
        '=', 84,
        '?', 70,
        '[', 101,
        '\\', 91,
        ']', 172,
        '`', 140,
        '{', 75,
        '|', 88,
        '}', 76,
        0x2190, 163,
        0x2192, 159,
        0x2237, 165,
        0x22b8, 161,
        0x2605, 80,
        0x27e6, 104,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(7);
      if (set_contains(sym_name_character_set_1, 614, lookahead)) ADVANCE(155);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(152);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        '\n', 174,
        '"', 26,
        '#', 148,
        '\'', 77,
        '(', 170,
        ')', 171,
        '-', 92,
        '0', 124,
        '?', 70,
        '[', 101,
        '\\', 91,
        '|', 149,
        0x27e6, 104,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(20);
      if (set_contains(sym_name_character_set_1, 614, lookahead)) ADVANCE(155);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(152);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '\n', 174,
        '"', 26,
        '#', 144,
        '\'', 77,
        '(', 170,
        ')', 171,
        '*', 79,
        ',', 74,
        '-', 93,
        '.', 32,
        '0', 124,
        ':', 33,
        ';', 73,
        '<', 31,
        '=', 84,
        '?', 70,
        '[', 101,
        '\\', 91,
        ']', 172,
        '`', 140,
        '{', 75,
        '|', 37,
        '}', 76,
        0x2190, 163,
        0x2192, 159,
        0x2200, 81,
        0x2237, 165,
        0x22b8, 161,
        0x2605, 80,
        0x27e6, 104,
        0x27e7, 103,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(6);
      if (set_contains(sym_name_character_set_1, 614, lookahead)) ADVANCE(155);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(152);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '\n', 174,
        '"', 26,
        '#', 144,
        '\'', 77,
        '(', 170,
        ')', 171,
        '*', 79,
        ',', 74,
        '-', 93,
        '.', 82,
        '0', 124,
        ':', 33,
        ';', 73,
        '<', 31,
        '=', 84,
        '?', 70,
        '[', 101,
        '\\', 91,
        ']', 172,
        '`', 140,
        '{', 75,
        '|', 88,
        '}', 76,
        0x2190, 163,
        0x2192, 159,
        0x2237, 165,
        0x22b8, 161,
        0x2605, 80,
        0x27e6, 104,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(7);
      if (set_contains(sym_name_character_set_1, 614, lookahead)) ADVANCE(155);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(152);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '\n', 174,
        '"', 26,
        '#', 145,
        '\'', 78,
        '(', 170,
        ')', 171,
        '*', 79,
        ',', 74,
        '-', 93,
        '0', 124,
        ':', 33,
        ';', 73,
        '<', 31,
        '=', 84,
        '?', 70,
        '[', 101,
        ']', 172,
        '`', 140,
        '{', 75,
        '|', 37,
        '}', 76,
        0x2190, 163,
        0x2192, 159,
        0x2200, 81,
        0x2237, 165,
        0x22b8, 161,
        0x2605, 80,
        0x27e7, 103,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(12);
      if (set_contains(sym_name_character_set_1, 614, lookahead)) ADVANCE(155);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(152);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '\n', 174,
        '"', 26,
        '#', 145,
        '\'', 78,
        '(', 170,
        ')', 171,
        '*', 79,
        ',', 74,
        '-', 92,
        '0', 124,
        ':', 33,
        ';', 73,
        '=', 85,
        '[', 101,
        '`', 140,
        '|', 149,
        0x21d2, 158,
        0x2237, 165,
        0x2605, 80,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(13);
      if (set_contains(sym_name_character_set_1, 614, lookahead)) ADVANCE(155);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(152);
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '\n', 174,
        '"', 26,
        '#', 145,
        '\'', 78,
        '(', 170,
        ')', 171,
        '*', 79,
        ',', 74,
        '-', 92,
        '0', 124,
        ':', 33,
        '=', 34,
        '[', 101,
        '`', 140,
        '|', 90,
        0x21d2, 158,
        0x2237, 165,
        0x2605, 80,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(14);
      if (set_contains(sym_name_character_set_1, 614, lookahead)) ADVANCE(155);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(152);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '\n', 174,
        '"', 26,
        '#', 145,
        '\'', 78,
        '(', 170,
        '*', 79,
        ',', 74,
        '-', 93,
        '0', 124,
        ':', 33,
        ';', 73,
        '=', 84,
        '[', 101,
        ']', 172,
        '`', 140,
        '{', 75,
        '|', 88,
        0x2192, 159,
        0x2237, 165,
        0x22b8, 161,
        0x2605, 80,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(15);
      if (set_contains(sym_name_character_set_1, 614, lookahead)) ADVANCE(155);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(152);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        '\n', 174,
        '"', 26,
        '#', 141,
        '\'', 78,
        '(', 170,
        ')', 171,
        '*', 79,
        ',', 74,
        '-', 93,
        '0', 124,
        ':', 33,
        ';', 73,
        '<', 31,
        '=', 84,
        '?', 70,
        '[', 101,
        ']', 172,
        '`', 140,
        '{', 75,
        '|', 37,
        '}', 76,
        0x2190, 163,
        0x2192, 159,
        0x2200, 81,
        0x2237, 165,
        0x22b8, 161,
        0x2605, 80,
        0x27e7, 103,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(12);
      if (set_contains(sym_name_character_set_1, 614, lookahead)) ADVANCE(155);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(152);
      END_STATE();
    case 13:
      ADVANCE_MAP(
        '\n', 174,
        '"', 26,
        '#', 141,
        '\'', 78,
        '(', 170,
        ')', 171,
        '*', 79,
        ',', 74,
        '-', 92,
        '0', 124,
        ':', 33,
        ';', 73,
        '=', 85,
        '[', 101,
        '`', 140,
        0x21d2, 158,
        0x2237, 165,
        0x2605, 80,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(13);
      if (set_contains(sym_name_character_set_1, 614, lookahead)) ADVANCE(155);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(152);
      END_STATE();
    case 14:
      ADVANCE_MAP(
        '\n', 174,
        '"', 26,
        '#', 141,
        '\'', 78,
        '(', 170,
        ')', 171,
        '*', 79,
        ',', 74,
        '-', 92,
        '0', 124,
        ':', 33,
        '=', 34,
        '[', 101,
        '`', 140,
        '|', 90,
        0x21d2, 158,
        0x2237, 165,
        0x2605, 80,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(14);
      if (set_contains(sym_name_character_set_1, 614, lookahead)) ADVANCE(155);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(152);
      END_STATE();
    case 15:
      ADVANCE_MAP(
        '\n', 174,
        '"', 26,
        '#', 141,
        '\'', 78,
        '(', 170,
        '*', 79,
        ',', 74,
        '-', 93,
        '0', 124,
        ':', 33,
        ';', 73,
        '=', 84,
        '[', 101,
        ']', 172,
        '`', 140,
        '{', 75,
        '|', 88,
        0x2192, 159,
        0x2237, 165,
        0x22b8, 161,
        0x2605, 80,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(15);
      if (set_contains(sym_name_character_set_1, 614, lookahead)) ADVANCE(155);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(152);
      END_STATE();
    case 16:
      ADVANCE_MAP(
        '\n', 174,
        '"', 26,
        '#', 146,
        '\'', 78,
        '(', 170,
        ')', 171,
        '*', 79,
        ',', 74,
        '-', 93,
        '0', 124,
        ':', 33,
        '=', 85,
        '?', 70,
        '[', 101,
        '`', 140,
        '{', 75,
        '|', 149,
        0x2192, 159,
        0x21d2, 158,
        0x2200, 81,
        0x2237, 165,
        0x22b8, 161,
        0x2605, 80,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(17);
      if (set_contains(sym_name_character_set_1, 614, lookahead)) ADVANCE(155);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(152);
      END_STATE();
    case 17:
      ADVANCE_MAP(
        '\n', 174,
        '"', 26,
        '#', 142,
        '\'', 78,
        '(', 170,
        ')', 171,
        '*', 79,
        ',', 74,
        '-', 93,
        '0', 124,
        ':', 33,
        '=', 85,
        '?', 70,
        '[', 101,
        '`', 140,
        '{', 75,
        '|', 88,
        0x2192, 159,
        0x21d2, 158,
        0x2200, 81,
        0x2237, 165,
        0x22b8, 161,
        0x2605, 80,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(17);
      if (set_contains(sym_name_character_set_1, 614, lookahead)) ADVANCE(155);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(152);
      END_STATE();
    case 18:
      ADVANCE_MAP(
        '\n', 174,
        '"', 26,
        '#', 30,
        '\'', 36,
        '(', 170,
        ')', 171,
        ',', 74,
        '-', 93,
        '0', 124,
        ':', 33,
        ';', 73,
        '<', 31,
        '=', 84,
        '[', 101,
        ']', 172,
        '`', 140,
        '{', 75,
        '|', 150,
        '}', 76,
        0x2190, 163,
        0x2192, 159,
        0x2237, 165,
        0x22b8, 161,
        0x27e7, 103,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(19);
      if (set_contains(sym_name_character_set_1, 614, lookahead)) ADVANCE(155);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(152);
      END_STATE();
    case 19:
      ADVANCE_MAP(
        '\n', 174,
        '"', 26,
        '#', 30,
        '\'', 36,
        '(', 170,
        ')', 171,
        ',', 74,
        '-', 93,
        '0', 124,
        ':', 33,
        ';', 73,
        '<', 31,
        '=', 84,
        '[', 101,
        ']', 172,
        '`', 140,
        '{', 75,
        '|', 89,
        '}', 76,
        0x2190, 163,
        0x2192, 159,
        0x2237, 165,
        0x22b8, 161,
        0x27e7, 103,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(19);
      if (set_contains(sym_name_character_set_1, 614, lookahead)) ADVANCE(155);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(152);
      END_STATE();
    case 20:
      ADVANCE_MAP(
        '\n', 174,
        '"', 26,
        '#', 69,
        '\'', 77,
        '(', 170,
        ')', 171,
        '-', 92,
        '0', 124,
        '?', 70,
        '[', 101,
        '\\', 91,
        0x27e6, 104,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(20);
      if (set_contains(sym_name_character_set_1, 614, lookahead)) ADVANCE(155);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(152);
      END_STATE();
    case 21:
      ADVANCE_MAP(
        '\n', 174,
        '#', 145,
        '*', 79,
        '-', 92,
        '0', 126,
        '`', 140,
        'c', 39,
        'j', 40,
        'p', 54,
        's', 57,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(127);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(22);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(98);
      END_STATE();
    case 22:
      ADVANCE_MAP(
        '\n', 174,
        '#', 141,
        '*', 79,
        '-', 92,
        '0', 126,
        '`', 140,
        'c', 39,
        'j', 40,
        'p', 54,
        's', 57,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(127);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(22);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(98);
      END_STATE();
    case 23:
      if (lookahead == '\n') ADVANCE(174);
      if (lookahead == ',') ADVANCE(74);
      if (lookahead == '1') ADVANCE(94);
      if (lookahead == ';') ADVANCE(73);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(23);
      END_STATE();
    case 24:
      if (lookahead == '\n') ADVANCE(35);
      if (lookahead == '"') ADVANCE(119);
      if (lookahead == '\\') ADVANCE(24);
      if (lookahead == '^') ADVANCE(27);
      if (lookahead != 0) ADVANCE(26);
      END_STATE();
    case 25:
      if (lookahead == '\n') ADVANCE(35);
      if (lookahead == '^') ADVANCE(27);
      if (lookahead != 0) ADVANCE(26);
      END_STATE();
    case 26:
      if (lookahead == '"') ADVANCE(122);
      if (lookahead == '\\') ADVANCE(25);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(26);
      END_STATE();
    case 27:
      if (lookahead == '"') ADVANCE(119);
      if (lookahead == '\\') ADVANCE(24);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(26);
      END_STATE();
    case 28:
      if (lookahead == '\'') ADVANCE(114);
      if (lookahead != 0 &&
          lookahead != ' ') ADVANCE(28);
      END_STATE();
    case 29:
      if (lookahead == '\'') ADVANCE(115);
      END_STATE();
    case 30:
      if (lookahead == ')') ADVANCE(173);
      END_STATE();
    case 31:
      if (lookahead == '-') ADVANCE(162);
      END_STATE();
    case 32:
      if (lookahead == '.') ADVANCE(86);
      END_STATE();
    case 33:
      if (lookahead == ':') ADVANCE(164);
      END_STATE();
    case 34:
      if (lookahead == '>') ADVANCE(157);
      END_STATE();
    case 35:
      if (lookahead == '\\') ADVANCE(26);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(35);
      END_STATE();
    case 36:
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(29);
      END_STATE();
    case 37:
      if (lookahead == ']') ADVANCE(102);
      if (lookahead == '|') ADVANCE(38);
      END_STATE();
    case 38:
      if (lookahead == ']') ADVANCE(106);
      END_STATE();
    case 39:
      if (lookahead == 'a') ADVANCE(53);
      if (lookahead == 'c') ADVANCE(41);
      END_STATE();
    case 40:
      if (lookahead == 'a') ADVANCE(59);
      END_STATE();
    case 41:
      if (lookahead == 'a') ADVANCE(50);
      END_STATE();
    case 42:
      if (lookahead == 'a') ADVANCE(56);
      END_STATE();
    case 43:
      if (lookahead == 'c') ADVANCE(41);
      END_STATE();
    case 44:
      if (lookahead == 'c') ADVANCE(55);
      END_STATE();
    case 45:
      if (lookahead == 'd') ADVANCE(43);
      END_STATE();
    case 46:
      if (lookahead == 'i') ADVANCE(51);
      END_STATE();
    case 47:
      if (lookahead == 'i') ADVANCE(97);
      END_STATE();
    case 48:
      if (lookahead == 'i') ADVANCE(52);
      END_STATE();
    case 49:
      if (lookahead == 'l') ADVANCE(97);
      END_STATE();
    case 50:
      if (lookahead == 'l') ADVANCE(49);
      END_STATE();
    case 51:
      if (lookahead == 'm') ADVANCE(97);
      END_STATE();
    case 52:
      if (lookahead == 'p') ADVANCE(58);
      END_STATE();
    case 53:
      if (lookahead == 'p') ADVANCE(47);
      END_STATE();
    case 54:
      if (lookahead == 'r') ADVANCE(46);
      END_STATE();
    case 55:
      if (lookahead == 'r') ADVANCE(48);
      END_STATE();
    case 56:
      if (lookahead == 's') ADVANCE(44);
      END_STATE();
    case 57:
      if (lookahead == 't') ADVANCE(45);
      END_STATE();
    case 58:
      if (lookahead == 't') ADVANCE(97);
      END_STATE();
    case 59:
      if (lookahead == 'v') ADVANCE(42);
      END_STATE();
    case 60:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(65);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(109);
      END_STATE();
    case 61:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(138);
      END_STATE();
    case 62:
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(130);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(133);
      END_STATE();
    case 64:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(108);
      END_STATE();
    case 65:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(109);
      END_STATE();
    case 66:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(136);
      END_STATE();
    case 67:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(137);
      END_STATE();
    case 68:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(138);
      END_STATE();
    case 69:
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(156);
      END_STATE();
    case 70:
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(153);
      END_STATE();
    case 71:
      if (eof) ADVANCE(72);
      ADVANCE_MAP(
        '\n', 174,
        '!', 167,
        '"', 26,
        '#', 143,
        '$', 99,
        '%', 169,
        '\'', 77,
        '(', 170,
        ')', 171,
        '*', 79,
        ',', 74,
        '-', 93,
        '.', 83,
        '0', 124,
        '1', 95,
        ':', 33,
        ';', 73,
        '<', 31,
        '=', 85,
        '?', 70,
        '@', 166,
        '[', 101,
        '\\', 91,
        ']', 172,
        '`', 140,
        '{', 75,
        '|', 89,
        '}', 76,
        '~', 168,
        0x2190, 163,
        0x2192, 159,
        0x21d2, 158,
        0x2200, 81,
        0x2237, 165,
        0x22b8, 161,
        0x2605, 80,
        0x27e6, 104,
        0x27e7, 103,
      );
      if (('2' <= lookahead && lookahead <= '9')) ADVANCE(125);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(71);
      if (set_contains(sym_name_character_set_1, 614, lookahead)) ADVANCE(155);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(152);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead == '\'') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead != 0) ADVANCE(29);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(29);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_u2605);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_u2200);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(86);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(157);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_SQUOTE_SQUOTE);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == ']') ADVANCE(102);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(105);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(96);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_1);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_1);
      if (lookahead == '#') ADVANCE(128);
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(125);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      if (lookahead == '.') ADVANCE(160);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_calling_convention);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_calling_convention);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(98);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '$') ADVANCE(100);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_DOLLAR_DOLLAR);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACK);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_u27e7);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_u27e6);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_RBRACK);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_float);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '#') ADVANCE(110);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(108);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '#') ADVANCE(110);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(109);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '#') ADVANCE(107);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_char);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_char);
      if (lookahead == '#') ADVANCE(116);
      if (lookahead == '\'') ADVANCE(114);
      if (lookahead != 0 &&
          lookahead != ' ') ADVANCE(28);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_char);
      if (lookahead == '#') ADVANCE(111);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_char);
      if (lookahead == '#') ADVANCE(112);
      if (lookahead == '\'') ADVANCE(114);
      if (lookahead != 0 &&
          lookahead != ' ') ADVANCE(28);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_char);
      if (lookahead == '#') ADVANCE(113);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_char);
      if (lookahead == '\'') ADVANCE(114);
      if (lookahead != 0 &&
          lookahead != ' ') ADVANCE(28);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_string);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == '"') ADVANCE(122);
      if (lookahead == '#') ADVANCE(120);
      if (lookahead == '\\') ADVANCE(25);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(26);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == '"') ADVANCE(122);
      if (lookahead == '#') ADVANCE(118);
      if (lookahead == '\\') ADVANCE(25);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(26);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == '"') ADVANCE(122);
      if (lookahead == '\\') ADVANCE(25);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(26);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == '#') ADVANCE(117);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == '#') ADVANCE(121);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym__integer_literal);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym__integer_literal);
      ADVANCE_MAP(
        '#', 128,
        '.', 64,
        'B', 62,
        'b', 62,
        'E', 60,
        'e', 60,
        'O', 63,
        'o', 63,
        'X', 66,
        'x', 66,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(125);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym__integer_literal);
      if (lookahead == '#') ADVANCE(128);
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(125);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym__integer_literal);
      if (lookahead == '#') ADVANCE(128);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(62);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(63);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(66);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(127);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym__integer_literal);
      if (lookahead == '#') ADVANCE(128);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(127);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym__integer_literal);
      if (lookahead == '#') ADVANCE(123);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym__binary_literal);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym__binary_literal);
      if (lookahead == '#') ADVANCE(131);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(130);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym__binary_literal);
      if (lookahead == '#') ADVANCE(129);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym__octal_literal);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym__octal_literal);
      if (lookahead == '#') ADVANCE(134);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(133);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym__octal_literal);
      if (lookahead == '#') ADVANCE(132);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym__hex_literal);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym__hex_literal);
      if (lookahead == '#') ADVANCE(139);
      if (lookahead == '.') ADVANCE(67);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(61);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(136);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym__hex_literal);
      if (lookahead == '#') ADVANCE(139);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(61);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(137);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym__hex_literal);
      if (lookahead == '#') ADVANCE(139);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(138);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym__hex_literal);
      if (lookahead == '#') ADVANCE(135);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == ')') ADVANCE(173);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == ')') ADVANCE(173);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(156);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(156);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_POUND2);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_POUND2);
      if (lookahead == ')') ADVANCE(173);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_POUND2);
      if (lookahead == ')') ADVANCE(173);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(156);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_POUND2);
      if (set_contains(sym_variable_character_set_1, 938, lookahead)) ADVANCE(156);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_PIPE2);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_PIPE2);
      if (lookahead == ']') ADVANCE(102);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_variable);
      if (lookahead == '#') ADVANCE(151);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_variable);
      if (lookahead == '#') ADVANCE(151);
      if (set_contains(sym_implicit_variable_character_set_1, 557, lookahead)) ADVANCE(152);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_implicit_variable);
      if (set_contains(sym_implicit_variable_character_set_1, 557, lookahead)) ADVANCE(153);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == '#') ADVANCE(154);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == '#') ADVANCE(154);
      if (set_contains(sym_implicit_variable_character_set_1, 557, lookahead)) ADVANCE(155);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_label);
      if (set_contains(sym_implicit_variable_character_set_1, 557, lookahead)) ADVANCE(156);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_u21d2);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_u2192);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_DASH_GT_DOT);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_u22b8);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_u2190);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_u2237);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(aux_sym__paren_open_token1);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(aux_sym__paren_close_token1);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_POUND_RPAREN);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(aux_sym__token1);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        '_', 1,
        'a', 2,
        'b', 3,
        'c', 4,
        'd', 5,
        'e', 6,
        'f', 7,
        'g', 8,
        'h', 9,
        'i', 10,
        'l', 11,
        'm', 12,
        'n', 13,
        'o', 14,
        'p', 15,
        'q', 16,
        'r', 17,
        's', 18,
        't', 19,
        'u', 20,
        'v', 21,
        'w', 22,
      );
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x1680 ||
          (0x2000 <= lookahead && lookahead <= 0x200a) ||
          lookahead == 0x202f ||
          lookahead == 0x205f ||
          lookahead == 0x3000) SKIP(0);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 2:
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      END_STATE();
    case 3:
      if (lookahead == 'y') ADVANCE(25);
      END_STATE();
    case 4:
      if (lookahead == 'a') ADVANCE(26);
      if (lookahead == 'l') ADVANCE(27);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(anon_sym_d);
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'e') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_e);
      if (lookahead == 'l') ADVANCE(31);
      if (lookahead == 'x') ADVANCE(32);
      END_STATE();
    case 7:
      if (lookahead == 'a') ADVANCE(33);
      if (lookahead == 'o') ADVANCE(34);
      END_STATE();
    case 8:
      if (lookahead == 'r') ADVANCE(35);
      END_STATE();
    case 9:
      if (lookahead == 'i') ADVANCE(36);
      END_STATE();
    case 10:
      if (lookahead == 'f') ADVANCE(37);
      if (lookahead == 'm') ADVANCE(38);
      if (lookahead == 'n') ADVANCE(39);
      END_STATE();
    case 11:
      if (lookahead == 'e') ADVANCE(40);
      END_STATE();
    case 12:
      if (lookahead == 'd') ADVANCE(41);
      if (lookahead == 'o') ADVANCE(42);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(43);
      if (lookahead == 'o') ADVANCE(44);
      END_STATE();
    case 14:
      if (lookahead == 'f') ADVANCE(45);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_p);
      if (lookahead == 'a') ADVANCE(46);
      if (lookahead == 'h') ADVANCE(47);
      END_STATE();
    case 16:
      if (lookahead == 'u') ADVANCE(48);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(49);
      if (lookahead == 'o') ADVANCE(50);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(51);
      if (lookahead == 't') ADVANCE(52);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_t);
      if (lookahead == 'h') ADVANCE(53);
      if (lookahead == 'y') ADVANCE(54);
      END_STATE();
    case 20:
      if (lookahead == 'n') ADVANCE(55);
      if (lookahead == 's') ADVANCE(56);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(57);
      END_STATE();
    case 22:
      if (lookahead == 'h') ADVANCE(58);
      END_STATE();
    case 23:
      if (lookahead == 'y') ADVANCE(59);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_by);
      END_STATE();
    case 26:
      if (lookahead == 's') ADVANCE(60);
      END_STATE();
    case 27:
      if (lookahead == 'a') ADVANCE(61);
      END_STATE();
    case 28:
      if (lookahead == 't') ADVANCE(62);
      END_STATE();
    case 29:
      if (lookahead == 'f') ADVANCE(63);
      if (lookahead == 'r') ADVANCE(64);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 31:
      if (lookahead == 's') ADVANCE(65);
      END_STATE();
    case 32:
      if (lookahead == 'p') ADVANCE(66);
      END_STATE();
    case 33:
      if (lookahead == 'm') ADVANCE(67);
      END_STATE();
    case 34:
      if (lookahead == 'r') ADVANCE(68);
      END_STATE();
    case 35:
      if (lookahead == 'o') ADVANCE(69);
      END_STATE();
    case 36:
      if (lookahead == 'd') ADVANCE(70);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 38:
      if (lookahead == 'p') ADVANCE(71);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'f') ADVANCE(72);
      if (lookahead == 's') ADVANCE(73);
      if (lookahead == 't') ADVANCE(74);
      END_STATE();
    case 40:
      if (lookahead == 't') ADVANCE(75);
      END_STATE();
    case 41:
      if (lookahead == 'o') ADVANCE(76);
      END_STATE();
    case 42:
      if (lookahead == 'd') ADVANCE(77);
      END_STATE();
    case 43:
      if (lookahead == 'w') ADVANCE(78);
      END_STATE();
    case 44:
      if (lookahead == 'm') ADVANCE(79);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 46:
      if (lookahead == 't') ADVANCE(80);
      END_STATE();
    case 47:
      if (lookahead == 'a') ADVANCE(81);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(82);
      END_STATE();
    case 49:
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'p') ADVANCE(84);
      END_STATE();
    case 50:
      if (lookahead == 'l') ADVANCE(85);
      END_STATE();
    case 51:
      if (lookahead == 'f') ADVANCE(86);
      END_STATE();
    case 52:
      if (lookahead == 'o') ADVANCE(87);
      END_STATE();
    case 53:
      if (lookahead == 'e') ADVANCE(88);
      END_STATE();
    case 54:
      if (lookahead == 'p') ADVANCE(89);
      END_STATE();
    case 55:
      if (lookahead == 's') ADVANCE(90);
      END_STATE();
    case 56:
      if (lookahead == 'i') ADVANCE(91);
      END_STATE();
    case 57:
      if (lookahead == 'a') ADVANCE(92);
      END_STATE();
    case 58:
      if (lookahead == 'e') ADVANCE(93);
      END_STATE();
    case 59:
      if (lookahead == 'c') ADVANCE(94);
      END_STATE();
    case 60:
      if (lookahead == 'e') ADVANCE(95);
      END_STATE();
    case 61:
      if (lookahead == 's') ADVANCE(96);
      END_STATE();
    case 62:
      if (lookahead == 'a') ADVANCE(97);
      END_STATE();
    case 63:
      if (lookahead == 'a') ADVANCE(98);
      END_STATE();
    case 64:
      if (lookahead == 'i') ADVANCE(99);
      END_STATE();
    case 65:
      if (lookahead == 'e') ADVANCE(100);
      END_STATE();
    case 66:
      if (lookahead == 'o') ADVANCE(101);
      END_STATE();
    case 67:
      if (lookahead == 'i') ADVANCE(102);
      END_STATE();
    case 68:
      if (lookahead == 'a') ADVANCE(103);
      if (lookahead == 'e') ADVANCE(104);
      END_STATE();
    case 69:
      if (lookahead == 'u') ADVANCE(105);
      END_STATE();
    case 70:
      if (lookahead == 'i') ADVANCE(106);
      END_STATE();
    case 71:
      if (lookahead == 'o') ADVANCE(107);
      END_STATE();
    case 72:
      if (lookahead == 'i') ADVANCE(108);
      END_STATE();
    case 73:
      if (lookahead == 't') ADVANCE(109);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(110);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_mdo);
      END_STATE();
    case 77:
      if (lookahead == 'u') ADVANCE(111);
      END_STATE();
    case 78:
      if (lookahead == 't') ADVANCE(112);
      END_STATE();
    case 79:
      if (lookahead == 'i') ADVANCE(113);
      END_STATE();
    case 80:
      if (lookahead == 't') ADVANCE(114);
      END_STATE();
    case 81:
      if (lookahead == 'n') ADVANCE(115);
      END_STATE();
    case 82:
      if (lookahead == 'l') ADVANCE(116);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_rec);
      END_STATE();
    case 84:
      if (lookahead == 'r') ADVANCE(117);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(118);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(119);
      END_STATE();
    case 87:
      if (lookahead == 'c') ADVANCE(120);
      END_STATE();
    case 88:
      if (lookahead == 'n') ADVANCE(121);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(122);
      END_STATE();
    case 90:
      if (lookahead == 'a') ADVANCE(123);
      END_STATE();
    case 91:
      if (lookahead == 'n') ADVANCE(124);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_via);
      END_STATE();
    case 93:
      if (lookahead == 'r') ADVANCE(125);
      END_STATE();
    case 94:
      if (lookahead == 'l') ADVANCE(126);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_case);
      if (lookahead == 's') ADVANCE(127);
      END_STATE();
    case 96:
      if (lookahead == 's') ADVANCE(128);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_data);
      END_STATE();
    case 98:
      if (lookahead == 'u') ADVANCE(129);
      END_STATE();
    case 99:
      if (lookahead == 'v') ADVANCE(130);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 101:
      if (lookahead == 'r') ADVANCE(131);
      END_STATE();
    case 102:
      if (lookahead == 'l') ADVANCE(132);
      END_STATE();
    case 103:
      if (lookahead == 'l') ADVANCE(133);
      END_STATE();
    case 104:
      if (lookahead == 'i') ADVANCE(134);
      END_STATE();
    case 105:
      if (lookahead == 'p') ADVANCE(135);
      END_STATE();
    case 106:
      if (lookahead == 'n') ADVANCE(136);
      END_STATE();
    case 107:
      if (lookahead == 'r') ADVANCE(137);
      END_STATE();
    case 108:
      if (lookahead == 'x') ADVANCE(138);
      END_STATE();
    case 109:
      if (lookahead == 'a') ADVANCE(139);
      END_STATE();
    case 110:
      if (lookahead == 'r') ADVANCE(140);
      END_STATE();
    case 111:
      if (lookahead == 'l') ADVANCE(141);
      END_STATE();
    case 112:
      if (lookahead == 'y') ADVANCE(142);
      END_STATE();
    case 113:
      if (lookahead == 'n') ADVANCE(143);
      END_STATE();
    case 114:
      if (lookahead == 'e') ADVANCE(144);
      END_STATE();
    case 115:
      if (lookahead == 't') ADVANCE(145);
      END_STATE();
    case 116:
      if (lookahead == 'i') ADVANCE(146);
      END_STATE();
    case 117:
      if (lookahead == 'e') ADVANCE(147);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_role);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_safety);
      END_STATE();
    case 120:
      if (lookahead == 'k') ADVANCE(148);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 123:
      if (lookahead == 'f') ADVANCE(149);
      END_STATE();
    case 124:
      if (lookahead == 'g') ADVANCE(150);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(151);
      END_STATE();
    case 126:
      if (lookahead == 'a') ADVANCE(152);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_cases);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 129:
      if (lookahead == 'l') ADVANCE(153);
      END_STATE();
    case 130:
      if (lookahead == 'i') ADVANCE(154);
      END_STATE();
    case 131:
      if (lookahead == 't') ADVANCE(155);
      END_STATE();
    case 132:
      if (lookahead == 'y') ADVANCE(156);
      END_STATE();
    case 133:
      if (lookahead == 'l') ADVANCE(157);
      END_STATE();
    case 134:
      if (lookahead == 'g') ADVANCE(158);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_group);
      END_STATE();
    case 136:
      if (lookahead == 'g') ADVANCE(159);
      END_STATE();
    case 137:
      if (lookahead == 't') ADVANCE(160);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_infix);
      if (lookahead == 'l') ADVANCE(161);
      if (lookahead == 'r') ADVANCE(162);
      END_STATE();
    case 139:
      if (lookahead == 'n') ADVANCE(163);
      END_STATE();
    case 140:
      if (lookahead == 'r') ADVANCE(164);
      END_STATE();
    case 141:
      if (lookahead == 'e') ADVANCE(165);
      END_STATE();
    case 142:
      if (lookahead == 'p') ADVANCE(166);
      END_STATE();
    case 143:
      if (lookahead == 'a') ADVANCE(167);
      END_STATE();
    case 144:
      if (lookahead == 'r') ADVANCE(168);
      END_STATE();
    case 145:
      if (lookahead == 'o') ADVANCE(169);
      END_STATE();
    case 146:
      if (lookahead == 'f') ADVANCE(170);
      END_STATE();
    case 147:
      if (lookahead == 's') ADVANCE(171);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_stock);
      END_STATE();
    case 149:
      if (lookahead == 'e') ADVANCE(119);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 152:
      if (lookahead == 's') ADVANCE(172);
      END_STATE();
    case 153:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 154:
      if (lookahead == 'n') ADVANCE(174);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_family);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_forall);
      END_STATE();
    case 158:
      if (lookahead == 'n') ADVANCE(175);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_hiding);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_infixl);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_infixr);
      END_STATE();
    case 163:
      if (lookahead == 'c') ADVANCE(176);
      END_STATE();
    case 164:
      if (lookahead == 'u') ADVANCE(177);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 166:
      if (lookahead == 'e') ADVANCE(178);
      END_STATE();
    case 167:
      if (lookahead == 'l') ADVANCE(179);
      END_STATE();
    case 168:
      if (lookahead == 'n') ADVANCE(180);
      END_STATE();
    case 169:
      if (lookahead == 'm') ADVANCE(181);
      END_STATE();
    case 170:
      if (lookahead == 'i') ADVANCE(182);
      END_STATE();
    case 171:
      if (lookahead == 'e') ADVANCE(183);
      END_STATE();
    case 172:
      if (lookahead == 's') ADVANCE(184);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 174:
      if (lookahead == 'g') ADVANCE(185);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_foreign);
      END_STATE();
    case 176:
      if (lookahead == 'e') ADVANCE(186);
      END_STATE();
    case 177:
      if (lookahead == 'p') ADVANCE(187);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_newtype);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_nominal);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_pattern);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_phantom);
      END_STATE();
    case 182:
      if (lookahead == 'e') ADVANCE(188);
      END_STATE();
    case 183:
      if (lookahead == 'n') ADVANCE(189);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_anyclass);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_deriving);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_instance);
      END_STATE();
    case 187:
      if (lookahead == 't') ADVANCE(190);
      END_STATE();
    case 188:
      if (lookahead == 'd') ADVANCE(191);
      END_STATE();
    case 189:
      if (lookahead == 't') ADVANCE(192);
      END_STATE();
    case 190:
      if (lookahead == 'i') ADVANCE(193);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_qualified);
      END_STATE();
    case 192:
      if (lookahead == 'a') ADVANCE(194);
      END_STATE();
    case 193:
      if (lookahead == 'b') ADVANCE(195);
      END_STATE();
    case 194:
      if (lookahead == 't') ADVANCE(196);
      END_STATE();
    case 195:
      if (lookahead == 'l') ADVANCE(197);
      END_STATE();
    case 196:
      if (lookahead == 'i') ADVANCE(198);
      END_STATE();
    case 197:
      if (lookahead == 'e') ADVANCE(119);
      END_STATE();
    case 198:
      if (lookahead == 'o') ADVANCE(199);
      END_STATE();
    case 199:
      if (lookahead == 'n') ADVANCE(200);
      END_STATE();
    case 200:
      if (lookahead == 'a') ADVANCE(201);
      END_STATE();
    case 201:
      if (lookahead == 'l') ADVANCE(202);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_representational);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 0, .external_lex_state = 2},
  [2] = {.lex_state = 3, .external_lex_state = 3},
  [3] = {.lex_state = 3, .external_lex_state = 4},
  [4] = {.lex_state = 3, .external_lex_state = 4},
  [5] = {.lex_state = 3, .external_lex_state = 4},
  [6] = {.lex_state = 3, .external_lex_state = 3},
  [7] = {.lex_state = 3, .external_lex_state = 4},
  [8] = {.lex_state = 3, .external_lex_state = 4},
  [9] = {.lex_state = 3, .external_lex_state = 4},
  [10] = {.lex_state = 3, .external_lex_state = 4},
  [11] = {.lex_state = 3, .external_lex_state = 4},
  [12] = {.lex_state = 3, .external_lex_state = 5},
  [13] = {.lex_state = 3, .external_lex_state = 4},
  [14] = {.lex_state = 3, .external_lex_state = 4},
  [15] = {.lex_state = 3, .external_lex_state = 4},
  [16] = {.lex_state = 3, .external_lex_state = 4},
  [17] = {.lex_state = 3, .external_lex_state = 4},
  [18] = {.lex_state = 3, .external_lex_state = 4},
  [19] = {.lex_state = 3, .external_lex_state = 4},
  [20] = {.lex_state = 3, .external_lex_state = 4},
  [21] = {.lex_state = 3, .external_lex_state = 5},
  [22] = {.lex_state = 3, .external_lex_state = 5},
  [23] = {.lex_state = 3, .external_lex_state = 5},
  [24] = {.lex_state = 3, .external_lex_state = 5},
  [25] = {.lex_state = 3, .external_lex_state = 5},
  [26] = {.lex_state = 3, .external_lex_state = 6},
  [27] = {.lex_state = 3, .external_lex_state = 6},
  [28] = {.lex_state = 3, .external_lex_state = 6},
  [29] = {.lex_state = 3, .external_lex_state = 6},
  [30] = {.lex_state = 3, .external_lex_state = 6},
  [31] = {.lex_state = 3, .external_lex_state = 6},
  [32] = {.lex_state = 3, .external_lex_state = 6},
  [33] = {.lex_state = 3, .external_lex_state = 6},
  [34] = {.lex_state = 3, .external_lex_state = 6},
  [35] = {.lex_state = 3, .external_lex_state = 6},
  [36] = {.lex_state = 3, .external_lex_state = 6},
  [37] = {.lex_state = 3, .external_lex_state = 6},
  [38] = {.lex_state = 3, .external_lex_state = 6},
  [39] = {.lex_state = 3, .external_lex_state = 6},
  [40] = {.lex_state = 3, .external_lex_state = 6},
  [41] = {.lex_state = 3, .external_lex_state = 6},
  [42] = {.lex_state = 3, .external_lex_state = 6},
  [43] = {.lex_state = 3, .external_lex_state = 6},
  [44] = {.lex_state = 3, .external_lex_state = 6},
  [45] = {.lex_state = 3, .external_lex_state = 6},
  [46] = {.lex_state = 3, .external_lex_state = 6},
  [47] = {.lex_state = 3, .external_lex_state = 6},
  [48] = {.lex_state = 3, .external_lex_state = 6},
  [49] = {.lex_state = 3, .external_lex_state = 6},
  [50] = {.lex_state = 3, .external_lex_state = 7},
  [51] = {.lex_state = 3, .external_lex_state = 7},
  [52] = {.lex_state = 3, .external_lex_state = 7},
  [53] = {.lex_state = 3, .external_lex_state = 7},
  [54] = {.lex_state = 3, .external_lex_state = 7},
  [55] = {.lex_state = 3, .external_lex_state = 7},
  [56] = {.lex_state = 3, .external_lex_state = 7},
  [57] = {.lex_state = 3, .external_lex_state = 7},
  [58] = {.lex_state = 3, .external_lex_state = 7},
  [59] = {.lex_state = 3, .external_lex_state = 7},
  [60] = {.lex_state = 3, .external_lex_state = 7},
  [61] = {.lex_state = 3, .external_lex_state = 7},
  [62] = {.lex_state = 3, .external_lex_state = 8},
  [63] = {.lex_state = 3, .external_lex_state = 8},
  [64] = {.lex_state = 3, .external_lex_state = 8},
  [65] = {.lex_state = 3, .external_lex_state = 8},
  [66] = {.lex_state = 3, .external_lex_state = 8},
  [67] = {.lex_state = 3, .external_lex_state = 8},
  [68] = {.lex_state = 3, .external_lex_state = 8},
  [69] = {.lex_state = 3, .external_lex_state = 8},
  [70] = {.lex_state = 3, .external_lex_state = 8},
  [71] = {.lex_state = 3, .external_lex_state = 8},
  [72] = {.lex_state = 3, .external_lex_state = 8},
  [73] = {.lex_state = 3, .external_lex_state = 9},
  [74] = {.lex_state = 3, .external_lex_state = 9},
  [75] = {.lex_state = 3, .external_lex_state = 9},
  [76] = {.lex_state = 3, .external_lex_state = 9},
  [77] = {.lex_state = 3, .external_lex_state = 9},
  [78] = {.lex_state = 3, .external_lex_state = 9},
  [79] = {.lex_state = 3, .external_lex_state = 9},
  [80] = {.lex_state = 3, .external_lex_state = 9},
  [81] = {.lex_state = 3, .external_lex_state = 9},
  [82] = {.lex_state = 3, .external_lex_state = 9},
  [83] = {.lex_state = 3, .external_lex_state = 9},
  [84] = {.lex_state = 3, .external_lex_state = 9},
  [85] = {.lex_state = 3, .external_lex_state = 9},
  [86] = {.lex_state = 3, .external_lex_state = 9},
  [87] = {.lex_state = 3, .external_lex_state = 9},
  [88] = {.lex_state = 3, .external_lex_state = 9},
  [89] = {.lex_state = 3, .external_lex_state = 9},
  [90] = {.lex_state = 3, .external_lex_state = 9},
  [91] = {.lex_state = 3, .external_lex_state = 9},
  [92] = {.lex_state = 3, .external_lex_state = 9},
  [93] = {.lex_state = 3, .external_lex_state = 9},
  [94] = {.lex_state = 3, .external_lex_state = 9},
  [95] = {.lex_state = 3, .external_lex_state = 9},
  [96] = {.lex_state = 3, .external_lex_state = 9},
  [97] = {.lex_state = 3, .external_lex_state = 9},
  [98] = {.lex_state = 3, .external_lex_state = 9},
  [99] = {.lex_state = 3, .external_lex_state = 9},
  [100] = {.lex_state = 3, .external_lex_state = 9},
  [101] = {.lex_state = 3, .external_lex_state = 9},
  [102] = {.lex_state = 3, .external_lex_state = 9},
  [103] = {.lex_state = 3, .external_lex_state = 9},
  [104] = {.lex_state = 3, .external_lex_state = 9},
  [105] = {.lex_state = 3, .external_lex_state = 9},
  [106] = {.lex_state = 3, .external_lex_state = 9},
  [107] = {.lex_state = 3, .external_lex_state = 9},
  [108] = {.lex_state = 3, .external_lex_state = 9},
  [109] = {.lex_state = 3, .external_lex_state = 9},
  [110] = {.lex_state = 3, .external_lex_state = 9},
  [111] = {.lex_state = 3, .external_lex_state = 9},
  [112] = {.lex_state = 3, .external_lex_state = 9},
  [113] = {.lex_state = 3, .external_lex_state = 9},
  [114] = {.lex_state = 3, .external_lex_state = 9},
  [115] = {.lex_state = 3, .external_lex_state = 9},
  [116] = {.lex_state = 3, .external_lex_state = 9},
  [117] = {.lex_state = 4, .external_lex_state = 10},
  [118] = {.lex_state = 4, .external_lex_state = 10},
  [119] = {.lex_state = 4, .external_lex_state = 10},
  [120] = {.lex_state = 3, .external_lex_state = 9},
  [121] = {.lex_state = 3, .external_lex_state = 9},
  [122] = {.lex_state = 3, .external_lex_state = 9},
  [123] = {.lex_state = 3, .external_lex_state = 9},
  [124] = {.lex_state = 3, .external_lex_state = 9},
  [125] = {.lex_state = 4, .external_lex_state = 10},
  [126] = {.lex_state = 3, .external_lex_state = 9},
  [127] = {.lex_state = 3, .external_lex_state = 9},
  [128] = {.lex_state = 3, .external_lex_state = 9},
  [129] = {.lex_state = 3, .external_lex_state = 9},
  [130] = {.lex_state = 3, .external_lex_state = 9},
  [131] = {.lex_state = 3, .external_lex_state = 9},
  [132] = {.lex_state = 3, .external_lex_state = 9},
  [133] = {.lex_state = 3, .external_lex_state = 9},
  [134] = {.lex_state = 3, .external_lex_state = 9},
  [135] = {.lex_state = 3, .external_lex_state = 9},
  [136] = {.lex_state = 4, .external_lex_state = 10},
  [137] = {.lex_state = 3, .external_lex_state = 9},
  [138] = {.lex_state = 3, .external_lex_state = 9},
  [139] = {.lex_state = 4, .external_lex_state = 10},
  [140] = {.lex_state = 3, .external_lex_state = 9},
  [141] = {.lex_state = 4, .external_lex_state = 10},
  [142] = {.lex_state = 3, .external_lex_state = 9},
  [143] = {.lex_state = 3, .external_lex_state = 9},
  [144] = {.lex_state = 4, .external_lex_state = 10},
  [145] = {.lex_state = 3, .external_lex_state = 9},
  [146] = {.lex_state = 3, .external_lex_state = 9},
  [147] = {.lex_state = 3, .external_lex_state = 9},
  [148] = {.lex_state = 3, .external_lex_state = 9},
  [149] = {.lex_state = 3, .external_lex_state = 9},
  [150] = {.lex_state = 3, .external_lex_state = 9},
  [151] = {.lex_state = 4, .external_lex_state = 10},
  [152] = {.lex_state = 3, .external_lex_state = 9},
  [153] = {.lex_state = 3, .external_lex_state = 9},
  [154] = {.lex_state = 4, .external_lex_state = 10},
  [155] = {.lex_state = 3, .external_lex_state = 9},
  [156] = {.lex_state = 3, .external_lex_state = 9},
  [157] = {.lex_state = 3, .external_lex_state = 9},
  [158] = {.lex_state = 3, .external_lex_state = 9},
  [159] = {.lex_state = 3, .external_lex_state = 9},
  [160] = {.lex_state = 3, .external_lex_state = 9},
  [161] = {.lex_state = 3, .external_lex_state = 9},
  [162] = {.lex_state = 3, .external_lex_state = 9},
  [163] = {.lex_state = 4, .external_lex_state = 10},
  [164] = {.lex_state = 3, .external_lex_state = 9},
  [165] = {.lex_state = 3, .external_lex_state = 9},
  [166] = {.lex_state = 3, .external_lex_state = 9},
  [167] = {.lex_state = 3, .external_lex_state = 9},
  [168] = {.lex_state = 3, .external_lex_state = 9},
  [169] = {.lex_state = 3, .external_lex_state = 9},
  [170] = {.lex_state = 3, .external_lex_state = 9},
  [171] = {.lex_state = 4, .external_lex_state = 10},
  [172] = {.lex_state = 3, .external_lex_state = 9},
  [173] = {.lex_state = 3, .external_lex_state = 11},
  [174] = {.lex_state = 3, .external_lex_state = 11},
  [175] = {.lex_state = 1, .external_lex_state = 11},
  [176] = {.lex_state = 3, .external_lex_state = 12},
  [177] = {.lex_state = 3, .external_lex_state = 12},
  [178] = {.lex_state = 4, .external_lex_state = 13},
  [179] = {.lex_state = 3, .external_lex_state = 11},
  [180] = {.lex_state = 3, .external_lex_state = 11},
  [181] = {.lex_state = 4, .external_lex_state = 13},
  [182] = {.lex_state = 1, .external_lex_state = 7},
  [183] = {.lex_state = 1, .external_lex_state = 7},
  [184] = {.lex_state = 3, .external_lex_state = 11},
  [185] = {.lex_state = 1, .external_lex_state = 11},
  [186] = {.lex_state = 1, .external_lex_state = 11},
  [187] = {.lex_state = 3, .external_lex_state = 11},
  [188] = {.lex_state = 3, .external_lex_state = 11},
  [189] = {.lex_state = 1, .external_lex_state = 11},
  [190] = {.lex_state = 1, .external_lex_state = 11},
  [191] = {.lex_state = 1, .external_lex_state = 11},
  [192] = {.lex_state = 3, .external_lex_state = 11},
  [193] = {.lex_state = 1, .external_lex_state = 11},
  [194] = {.lex_state = 3, .external_lex_state = 11},
  [195] = {.lex_state = 1, .external_lex_state = 11},
  [196] = {.lex_state = 1, .external_lex_state = 11},
  [197] = {.lex_state = 1, .external_lex_state = 11},
  [198] = {.lex_state = 3, .external_lex_state = 11},
  [199] = {.lex_state = 3, .external_lex_state = 11},
  [200] = {.lex_state = 3, .external_lex_state = 11},
  [201] = {.lex_state = 1, .external_lex_state = 11},
  [202] = {.lex_state = 1, .external_lex_state = 11},
  [203] = {.lex_state = 1, .external_lex_state = 11},
  [204] = {.lex_state = 1, .external_lex_state = 11},
  [205] = {.lex_state = 1, .external_lex_state = 11},
  [206] = {.lex_state = 1, .external_lex_state = 11},
  [207] = {.lex_state = 1, .external_lex_state = 7},
  [208] = {.lex_state = 1, .external_lex_state = 7},
  [209] = {.lex_state = 3, .external_lex_state = 14},
  [210] = {.lex_state = 1, .external_lex_state = 7},
  [211] = {.lex_state = 3, .external_lex_state = 12},
  [212] = {.lex_state = 1, .external_lex_state = 7},
  [213] = {.lex_state = 3, .external_lex_state = 14},
  [214] = {.lex_state = 3, .external_lex_state = 14},
  [215] = {.lex_state = 3, .external_lex_state = 14},
  [216] = {.lex_state = 1, .external_lex_state = 7},
  [217] = {.lex_state = 1, .external_lex_state = 7},
  [218] = {.lex_state = 3, .external_lex_state = 14},
  [219] = {.lex_state = 4, .external_lex_state = 13},
  [220] = {.lex_state = 3, .external_lex_state = 14},
  [221] = {.lex_state = 4, .external_lex_state = 13},
  [222] = {.lex_state = 4, .external_lex_state = 13},
  [223] = {.lex_state = 3, .external_lex_state = 14},
  [224] = {.lex_state = 4, .external_lex_state = 13},
  [225] = {.lex_state = 3, .external_lex_state = 12},
  [226] = {.lex_state = 3, .external_lex_state = 12},
  [227] = {.lex_state = 4, .external_lex_state = 13},
  [228] = {.lex_state = 4, .external_lex_state = 13},
  [229] = {.lex_state = 3, .external_lex_state = 12},
  [230] = {.lex_state = 4, .external_lex_state = 13},
  [231] = {.lex_state = 3, .external_lex_state = 14},
  [232] = {.lex_state = 4, .external_lex_state = 13},
  [233] = {.lex_state = 3, .external_lex_state = 12},
  [234] = {.lex_state = 3, .external_lex_state = 12},
  [235] = {.lex_state = 3, .external_lex_state = 12},
  [236] = {.lex_state = 3, .external_lex_state = 11},
  [237] = {.lex_state = 3, .external_lex_state = 12},
  [238] = {.lex_state = 4, .external_lex_state = 13},
  [239] = {.lex_state = 4, .external_lex_state = 13},
  [240] = {.lex_state = 1, .external_lex_state = 7},
  [241] = {.lex_state = 3, .external_lex_state = 12},
  [242] = {.lex_state = 1, .external_lex_state = 7},
  [243] = {.lex_state = 3, .external_lex_state = 12},
  [244] = {.lex_state = 1, .external_lex_state = 7},
  [245] = {.lex_state = 1, .external_lex_state = 7},
  [246] = {.lex_state = 3, .external_lex_state = 11},
  [247] = {.lex_state = 3, .external_lex_state = 15},
  [248] = {.lex_state = 3, .external_lex_state = 11},
  [249] = {.lex_state = 1, .external_lex_state = 11},
  [250] = {.lex_state = 1, .external_lex_state = 11},
  [251] = {.lex_state = 3, .external_lex_state = 14},
  [252] = {.lex_state = 4, .external_lex_state = 7},
  [253] = {.lex_state = 3, .external_lex_state = 14},
  [254] = {.lex_state = 3, .external_lex_state = 15},
  [255] = {.lex_state = 3, .external_lex_state = 11},
  [256] = {.lex_state = 1, .external_lex_state = 11},
  [257] = {.lex_state = 3, .external_lex_state = 11},
  [258] = {.lex_state = 3, .external_lex_state = 16},
  [259] = {.lex_state = 1, .external_lex_state = 11},
  [260] = {.lex_state = 1, .external_lex_state = 11},
  [261] = {.lex_state = 1, .external_lex_state = 11},
  [262] = {.lex_state = 1, .external_lex_state = 11},
  [263] = {.lex_state = 4, .external_lex_state = 7},
  [264] = {.lex_state = 1, .external_lex_state = 11},
  [265] = {.lex_state = 3, .external_lex_state = 11},
  [266] = {.lex_state = 3, .external_lex_state = 14},
  [267] = {.lex_state = 3, .external_lex_state = 11},
  [268] = {.lex_state = 3, .external_lex_state = 11},
  [269] = {.lex_state = 3, .external_lex_state = 14},
  [270] = {.lex_state = 3, .external_lex_state = 14},
  [271] = {.lex_state = 3, .external_lex_state = 14},
  [272] = {.lex_state = 3, .external_lex_state = 11},
  [273] = {.lex_state = 3, .external_lex_state = 16},
  [274] = {.lex_state = 1, .external_lex_state = 11},
  [275] = {.lex_state = 3, .external_lex_state = 11},
  [276] = {.lex_state = 3, .external_lex_state = 14},
  [277] = {.lex_state = 3, .external_lex_state = 11},
  [278] = {.lex_state = 3, .external_lex_state = 14},
  [279] = {.lex_state = 1, .external_lex_state = 11},
  [280] = {.lex_state = 1, .external_lex_state = 11},
  [281] = {.lex_state = 3, .external_lex_state = 14},
  [282] = {.lex_state = 1, .external_lex_state = 11},
  [283] = {.lex_state = 3, .external_lex_state = 11},
  [284] = {.lex_state = 3, .external_lex_state = 11},
  [285] = {.lex_state = 1, .external_lex_state = 11},
  [286] = {.lex_state = 1, .external_lex_state = 11},
  [287] = {.lex_state = 3, .external_lex_state = 14},
  [288] = {.lex_state = 1, .external_lex_state = 11},
  [289] = {.lex_state = 1, .external_lex_state = 11},
  [290] = {.lex_state = 3, .external_lex_state = 11},
  [291] = {.lex_state = 3, .external_lex_state = 16},
  [292] = {.lex_state = 4, .external_lex_state = 7},
  [293] = {.lex_state = 3, .external_lex_state = 16},
  [294] = {.lex_state = 4, .external_lex_state = 7},
  [295] = {.lex_state = 3, .external_lex_state = 16},
  [296] = {.lex_state = 3, .external_lex_state = 16},
  [297] = {.lex_state = 3, .external_lex_state = 15},
  [298] = {.lex_state = 3, .external_lex_state = 15},
  [299] = {.lex_state = 3, .external_lex_state = 15},
  [300] = {.lex_state = 4, .external_lex_state = 7},
  [301] = {.lex_state = 4, .external_lex_state = 7},
  [302] = {.lex_state = 3, .external_lex_state = 16},
  [303] = {.lex_state = 3, .external_lex_state = 15},
  [304] = {.lex_state = 3, .external_lex_state = 15},
  [305] = {.lex_state = 4, .external_lex_state = 7},
  [306] = {.lex_state = 3, .external_lex_state = 14},
  [307] = {.lex_state = 3, .external_lex_state = 15},
  [308] = {.lex_state = 3, .external_lex_state = 15},
  [309] = {.lex_state = 4, .external_lex_state = 17},
  [310] = {.lex_state = 3, .external_lex_state = 16},
  [311] = {.lex_state = 3, .external_lex_state = 16},
  [312] = {.lex_state = 3, .external_lex_state = 16},
  [313] = {.lex_state = 3, .external_lex_state = 16},
  [314] = {.lex_state = 3, .external_lex_state = 16},
  [315] = {.lex_state = 4, .external_lex_state = 7},
  [316] = {.lex_state = 4, .external_lex_state = 7},
  [317] = {.lex_state = 4, .external_lex_state = 7},
  [318] = {.lex_state = 3, .external_lex_state = 15},
  [319] = {.lex_state = 4, .external_lex_state = 7},
  [320] = {.lex_state = 3, .external_lex_state = 14},
  [321] = {.lex_state = 4, .external_lex_state = 17},
  [322] = {.lex_state = 4, .external_lex_state = 7},
  [323] = {.lex_state = 3, .external_lex_state = 15},
  [324] = {.lex_state = 3, .external_lex_state = 14},
  [325] = {.lex_state = 3, .external_lex_state = 15},
  [326] = {.lex_state = 3, .external_lex_state = 18},
  [327] = {.lex_state = 3, .external_lex_state = 18},
  [328] = {.lex_state = 3, .external_lex_state = 18},
  [329] = {.lex_state = 3, .external_lex_state = 11},
  [330] = {.lex_state = 4, .external_lex_state = 17},
  [331] = {.lex_state = 4, .external_lex_state = 17},
  [332] = {.lex_state = 3, .external_lex_state = 18},
  [333] = {.lex_state = 3, .external_lex_state = 18},
  [334] = {.lex_state = 3, .external_lex_state = 11},
  [335] = {.lex_state = 3, .external_lex_state = 18},
  [336] = {.lex_state = 4, .external_lex_state = 17},
  [337] = {.lex_state = 4, .external_lex_state = 17},
  [338] = {.lex_state = 4, .external_lex_state = 17},
  [339] = {.lex_state = 4, .external_lex_state = 17},
  [340] = {.lex_state = 4, .external_lex_state = 17},
  [341] = {.lex_state = 4, .external_lex_state = 17},
  [342] = {.lex_state = 4, .external_lex_state = 17},
  [343] = {.lex_state = 4, .external_lex_state = 17},
  [344] = {.lex_state = 3, .external_lex_state = 11},
  [345] = {.lex_state = 3, .external_lex_state = 11},
  [346] = {.lex_state = 3, .external_lex_state = 11},
  [347] = {.lex_state = 3, .external_lex_state = 11},
  [348] = {.lex_state = 3, .external_lex_state = 11},
  [349] = {.lex_state = 3, .external_lex_state = 11},
  [350] = {.lex_state = 3, .external_lex_state = 7},
  [351] = {.lex_state = 3, .external_lex_state = 11},
  [352] = {.lex_state = 3, .external_lex_state = 11},
  [353] = {.lex_state = 3, .external_lex_state = 7},
  [354] = {.lex_state = 3, .external_lex_state = 11},
  [355] = {.lex_state = 3, .external_lex_state = 11},
  [356] = {.lex_state = 3, .external_lex_state = 11},
  [357] = {.lex_state = 3, .external_lex_state = 11},
  [358] = {.lex_state = 3, .external_lex_state = 11},
  [359] = {.lex_state = 3, .external_lex_state = 11},
  [360] = {.lex_state = 3, .external_lex_state = 11},
  [361] = {.lex_state = 3, .external_lex_state = 11},
  [362] = {.lex_state = 3, .external_lex_state = 11},
  [363] = {.lex_state = 3, .external_lex_state = 11},
  [364] = {.lex_state = 3, .external_lex_state = 11},
  [365] = {.lex_state = 3, .external_lex_state = 11},
  [366] = {.lex_state = 3, .external_lex_state = 11},
  [367] = {.lex_state = 3, .external_lex_state = 11},
  [368] = {.lex_state = 3, .external_lex_state = 16},
  [369] = {.lex_state = 3, .external_lex_state = 11},
  [370] = {.lex_state = 3, .external_lex_state = 11},
  [371] = {.lex_state = 3, .external_lex_state = 11},
  [372] = {.lex_state = 3, .external_lex_state = 11},
  [373] = {.lex_state = 3, .external_lex_state = 11},
  [374] = {.lex_state = 3, .external_lex_state = 11},
  [375] = {.lex_state = 3, .external_lex_state = 19},
  [376] = {.lex_state = 3, .external_lex_state = 7},
  [377] = {.lex_state = 3, .external_lex_state = 19},
  [378] = {.lex_state = 3, .external_lex_state = 7},
  [379] = {.lex_state = 3, .external_lex_state = 11},
  [380] = {.lex_state = 3, .external_lex_state = 19},
  [381] = {.lex_state = 3, .external_lex_state = 7},
  [382] = {.lex_state = 3, .external_lex_state = 19},
  [383] = {.lex_state = 3, .external_lex_state = 19},
  [384] = {.lex_state = 3, .external_lex_state = 11},
  [385] = {.lex_state = 3, .external_lex_state = 11},
  [386] = {.lex_state = 3, .external_lex_state = 11},
  [387] = {.lex_state = 3, .external_lex_state = 7},
  [388] = {.lex_state = 3, .external_lex_state = 7},
  [389] = {.lex_state = 3, .external_lex_state = 7},
  [390] = {.lex_state = 3, .external_lex_state = 7},
  [391] = {.lex_state = 3, .external_lex_state = 7},
  [392] = {.lex_state = 3, .external_lex_state = 11},
  [393] = {.lex_state = 3, .external_lex_state = 19},
  [394] = {.lex_state = 3, .external_lex_state = 19},
  [395] = {.lex_state = 3, .external_lex_state = 19},
  [396] = {.lex_state = 3, .external_lex_state = 19},
  [397] = {.lex_state = 3, .external_lex_state = 19},
  [398] = {.lex_state = 3, .external_lex_state = 7},
  [399] = {.lex_state = 3, .external_lex_state = 7},
  [400] = {.lex_state = 3, .external_lex_state = 19},
  [401] = {.lex_state = 3, .external_lex_state = 7},
  [402] = {.lex_state = 3, .external_lex_state = 19},
  [403] = {.lex_state = 3, .external_lex_state = 19},
  [404] = {.lex_state = 3, .external_lex_state = 19},
  [405] = {.lex_state = 3, .external_lex_state = 19},
  [406] = {.lex_state = 3, .external_lex_state = 19},
  [407] = {.lex_state = 3, .external_lex_state = 19},
  [408] = {.lex_state = 3, .external_lex_state = 7},
  [409] = {.lex_state = 3, .external_lex_state = 7},
  [410] = {.lex_state = 3, .external_lex_state = 19},
  [411] = {.lex_state = 3, .external_lex_state = 7},
  [412] = {.lex_state = 3, .external_lex_state = 7},
  [413] = {.lex_state = 3, .external_lex_state = 7},
  [414] = {.lex_state = 3, .external_lex_state = 19},
  [415] = {.lex_state = 3, .external_lex_state = 7},
  [416] = {.lex_state = 3, .external_lex_state = 19},
  [417] = {.lex_state = 4, .external_lex_state = 20},
  [418] = {.lex_state = 4, .external_lex_state = 20},
  [419] = {.lex_state = 4, .external_lex_state = 20},
  [420] = {.lex_state = 4, .external_lex_state = 20},
  [421] = {.lex_state = 4, .external_lex_state = 20},
  [422] = {.lex_state = 4, .external_lex_state = 20},
  [423] = {.lex_state = 3, .external_lex_state = 21},
  [424] = {.lex_state = 3, .external_lex_state = 21},
  [425] = {.lex_state = 3, .external_lex_state = 21},
  [426] = {.lex_state = 3, .external_lex_state = 21},
  [427] = {.lex_state = 3, .external_lex_state = 21},
  [428] = {.lex_state = 3, .external_lex_state = 21},
  [429] = {.lex_state = 8, .external_lex_state = 22},
  [430] = {.lex_state = 8, .external_lex_state = 22},
  [431] = {.lex_state = 8, .external_lex_state = 22},
  [432] = {.lex_state = 8, .external_lex_state = 22},
  [433] = {.lex_state = 8, .external_lex_state = 22},
  [434] = {.lex_state = 8, .external_lex_state = 22},
  [435] = {.lex_state = 8, .external_lex_state = 22},
  [436] = {.lex_state = 8, .external_lex_state = 22},
  [437] = {.lex_state = 8, .external_lex_state = 22},
  [438] = {.lex_state = 8, .external_lex_state = 22},
  [439] = {.lex_state = 8, .external_lex_state = 22},
  [440] = {.lex_state = 8, .external_lex_state = 22},
  [441] = {.lex_state = 8, .external_lex_state = 22},
  [442] = {.lex_state = 8, .external_lex_state = 22},
  [443] = {.lex_state = 8, .external_lex_state = 22},
  [444] = {.lex_state = 8, .external_lex_state = 22},
  [445] = {.lex_state = 8, .external_lex_state = 22},
  [446] = {.lex_state = 8, .external_lex_state = 22},
  [447] = {.lex_state = 8, .external_lex_state = 22},
  [448] = {.lex_state = 8, .external_lex_state = 22},
  [449] = {.lex_state = 8, .external_lex_state = 22},
  [450] = {.lex_state = 8, .external_lex_state = 22},
  [451] = {.lex_state = 8, .external_lex_state = 22},
  [452] = {.lex_state = 8, .external_lex_state = 22},
  [453] = {.lex_state = 8, .external_lex_state = 22},
  [454] = {.lex_state = 8, .external_lex_state = 22},
  [455] = {.lex_state = 8, .external_lex_state = 22},
  [456] = {.lex_state = 8, .external_lex_state = 22},
  [457] = {.lex_state = 8, .external_lex_state = 22},
  [458] = {.lex_state = 8, .external_lex_state = 22},
  [459] = {.lex_state = 8, .external_lex_state = 22},
  [460] = {.lex_state = 8, .external_lex_state = 22},
  [461] = {.lex_state = 8, .external_lex_state = 22},
  [462] = {.lex_state = 8, .external_lex_state = 22},
  [463] = {.lex_state = 8, .external_lex_state = 22},
  [464] = {.lex_state = 8, .external_lex_state = 22},
  [465] = {.lex_state = 8, .external_lex_state = 22},
  [466] = {.lex_state = 8, .external_lex_state = 22},
  [467] = {.lex_state = 8, .external_lex_state = 22},
  [468] = {.lex_state = 8, .external_lex_state = 22},
  [469] = {.lex_state = 8, .external_lex_state = 22},
  [470] = {.lex_state = 8, .external_lex_state = 22},
  [471] = {.lex_state = 8, .external_lex_state = 22},
  [472] = {.lex_state = 8, .external_lex_state = 22},
  [473] = {.lex_state = 8, .external_lex_state = 22},
  [474] = {.lex_state = 8, .external_lex_state = 22},
  [475] = {.lex_state = 8, .external_lex_state = 22},
  [476] = {.lex_state = 8, .external_lex_state = 22},
  [477] = {.lex_state = 4, .external_lex_state = 23},
  [478] = {.lex_state = 4, .external_lex_state = 18},
  [479] = {.lex_state = 4, .external_lex_state = 18},
  [480] = {.lex_state = 4, .external_lex_state = 23},
  [481] = {.lex_state = 1, .external_lex_state = 18},
  [482] = {.lex_state = 1, .external_lex_state = 18},
  [483] = {.lex_state = 4, .external_lex_state = 18},
  [484] = {.lex_state = 1, .external_lex_state = 18},
  [485] = {.lex_state = 4, .external_lex_state = 18},
  [486] = {.lex_state = 1, .external_lex_state = 18},
  [487] = {.lex_state = 3, .external_lex_state = 24},
  [488] = {.lex_state = 4, .external_lex_state = 23},
  [489] = {.lex_state = 3, .external_lex_state = 24},
  [490] = {.lex_state = 3, .external_lex_state = 24},
  [491] = {.lex_state = 3, .external_lex_state = 24},
  [492] = {.lex_state = 1, .external_lex_state = 18},
  [493] = {.lex_state = 4, .external_lex_state = 23},
  [494] = {.lex_state = 3, .external_lex_state = 24},
  [495] = {.lex_state = 4, .external_lex_state = 23},
  [496] = {.lex_state = 4, .external_lex_state = 23},
  [497] = {.lex_state = 1, .external_lex_state = 18},
  [498] = {.lex_state = 4, .external_lex_state = 18},
  [499] = {.lex_state = 4, .external_lex_state = 18},
  [500] = {.lex_state = 3, .external_lex_state = 24},
  [501] = {.lex_state = 3, .external_lex_state = 25},
  [502] = {.lex_state = 4, .external_lex_state = 26},
  [503] = {.lex_state = 4, .external_lex_state = 26},
  [504] = {.lex_state = 3, .external_lex_state = 25},
  [505] = {.lex_state = 3, .external_lex_state = 25},
  [506] = {.lex_state = 3, .external_lex_state = 25},
  [507] = {.lex_state = 4, .external_lex_state = 26},
  [508] = {.lex_state = 4, .external_lex_state = 26},
  [509] = {.lex_state = 3, .external_lex_state = 25},
  [510] = {.lex_state = 4, .external_lex_state = 26},
  [511] = {.lex_state = 3, .external_lex_state = 25},
  [512] = {.lex_state = 4, .external_lex_state = 26},
  [513] = {.lex_state = 4, .external_lex_state = 10},
  [514] = {.lex_state = 4, .external_lex_state = 10},
  [515] = {.lex_state = 4, .external_lex_state = 10},
  [516] = {.lex_state = 4, .external_lex_state = 10},
  [517] = {.lex_state = 4, .external_lex_state = 10},
  [518] = {.lex_state = 4, .external_lex_state = 10},
  [519] = {.lex_state = 4, .external_lex_state = 10},
  [520] = {.lex_state = 8, .external_lex_state = 27},
  [521] = {.lex_state = 8, .external_lex_state = 27},
  [522] = {.lex_state = 8, .external_lex_state = 27},
  [523] = {.lex_state = 8, .external_lex_state = 27},
  [524] = {.lex_state = 8, .external_lex_state = 27},
  [525] = {.lex_state = 8, .external_lex_state = 27},
  [526] = {.lex_state = 3, .external_lex_state = 12},
  [527] = {.lex_state = 3, .external_lex_state = 12},
  [528] = {.lex_state = 4, .external_lex_state = 13},
  [529] = {.lex_state = 3, .external_lex_state = 12},
  [530] = {.lex_state = 4, .external_lex_state = 13},
  [531] = {.lex_state = 1, .external_lex_state = 7},
  [532] = {.lex_state = 1, .external_lex_state = 7},
  [533] = {.lex_state = 3, .external_lex_state = 12},
  [534] = {.lex_state = 3, .external_lex_state = 12},
  [535] = {.lex_state = 1, .external_lex_state = 7},
  [536] = {.lex_state = 4, .external_lex_state = 13},
  [537] = {.lex_state = 1, .external_lex_state = 7},
  [538] = {.lex_state = 1, .external_lex_state = 7},
  [539] = {.lex_state = 3, .external_lex_state = 12},
  [540] = {.lex_state = 4, .external_lex_state = 13},
  [541] = {.lex_state = 4, .external_lex_state = 13},
  [542] = {.lex_state = 1, .external_lex_state = 7},
  [543] = {.lex_state = 3, .external_lex_state = 12},
  [544] = {.lex_state = 4, .external_lex_state = 13},
  [545] = {.lex_state = 4, .external_lex_state = 13},
  [546] = {.lex_state = 1, .external_lex_state = 7},
  [547] = {.lex_state = 3, .external_lex_state = 14},
  [548] = {.lex_state = 3, .external_lex_state = 14},
  [549] = {.lex_state = 3, .external_lex_state = 14},
  [550] = {.lex_state = 3, .external_lex_state = 14},
  [551] = {.lex_state = 3, .external_lex_state = 14},
  [552] = {.lex_state = 3, .external_lex_state = 14},
  [553] = {.lex_state = 3, .external_lex_state = 14},
  [554] = {.lex_state = 4, .external_lex_state = 7},
  [555] = {.lex_state = 3, .external_lex_state = 16},
  [556] = {.lex_state = 3, .external_lex_state = 16},
  [557] = {.lex_state = 4, .external_lex_state = 7},
  [558] = {.lex_state = 3, .external_lex_state = 15},
  [559] = {.lex_state = 4, .external_lex_state = 7},
  [560] = {.lex_state = 4, .external_lex_state = 7},
  [561] = {.lex_state = 3, .external_lex_state = 15},
  [562] = {.lex_state = 3, .external_lex_state = 16},
  [563] = {.lex_state = 3, .external_lex_state = 16},
  [564] = {.lex_state = 4, .external_lex_state = 7},
  [565] = {.lex_state = 3, .external_lex_state = 15},
  [566] = {.lex_state = 3, .external_lex_state = 15},
  [567] = {.lex_state = 3, .external_lex_state = 15},
  [568] = {.lex_state = 3, .external_lex_state = 15},
  [569] = {.lex_state = 3, .external_lex_state = 16},
  [570] = {.lex_state = 4, .external_lex_state = 7},
  [571] = {.lex_state = 4, .external_lex_state = 7},
  [572] = {.lex_state = 3, .external_lex_state = 15},
  [573] = {.lex_state = 3, .external_lex_state = 16},
  [574] = {.lex_state = 3, .external_lex_state = 16},
  [575] = {.lex_state = 8, .external_lex_state = 28},
  [576] = {.lex_state = 4, .external_lex_state = 17},
  [577] = {.lex_state = 4, .external_lex_state = 17},
  [578] = {.lex_state = 8, .external_lex_state = 28},
  [579] = {.lex_state = 8, .external_lex_state = 28},
  [580] = {.lex_state = 4, .external_lex_state = 17},
  [581] = {.lex_state = 4, .external_lex_state = 17},
  [582] = {.lex_state = 4, .external_lex_state = 17},
  [583] = {.lex_state = 4, .external_lex_state = 17},
  [584] = {.lex_state = 8, .external_lex_state = 28},
  [585] = {.lex_state = 4, .external_lex_state = 17},
  [586] = {.lex_state = 8, .external_lex_state = 28},
  [587] = {.lex_state = 8, .external_lex_state = 28},
  [588] = {.lex_state = 3, .external_lex_state = 19},
  [589] = {.lex_state = 3, .external_lex_state = 19},
  [590] = {.lex_state = 3, .external_lex_state = 19},
  [591] = {.lex_state = 3, .external_lex_state = 19},
  [592] = {.lex_state = 3, .external_lex_state = 19},
  [593] = {.lex_state = 3, .external_lex_state = 19},
  [594] = {.lex_state = 3, .external_lex_state = 19},
  [595] = {.lex_state = 3, .external_lex_state = 19},
  [596] = {.lex_state = 3, .external_lex_state = 19},
  [597] = {.lex_state = 3, .external_lex_state = 19},
  [598] = {.lex_state = 3, .external_lex_state = 19},
  [599] = {.lex_state = 3, .external_lex_state = 19},
  [600] = {.lex_state = 3, .external_lex_state = 19},
  [601] = {.lex_state = 3, .external_lex_state = 19},
  [602] = {.lex_state = 3, .external_lex_state = 19},
  [603] = {.lex_state = 3, .external_lex_state = 19},
  [604] = {.lex_state = 3, .external_lex_state = 19},
  [605] = {.lex_state = 3, .external_lex_state = 19},
  [606] = {.lex_state = 3, .external_lex_state = 19},
  [607] = {.lex_state = 3, .external_lex_state = 19},
  [608] = {.lex_state = 3, .external_lex_state = 19},
  [609] = {.lex_state = 3, .external_lex_state = 19},
  [610] = {.lex_state = 3, .external_lex_state = 19},
  [611] = {.lex_state = 3, .external_lex_state = 19},
  [612] = {.lex_state = 3, .external_lex_state = 19},
  [613] = {.lex_state = 3, .external_lex_state = 19},
  [614] = {.lex_state = 3, .external_lex_state = 19},
  [615] = {.lex_state = 3, .external_lex_state = 19},
  [616] = {.lex_state = 3, .external_lex_state = 19},
  [617] = {.lex_state = 3, .external_lex_state = 19},
  [618] = {.lex_state = 3, .external_lex_state = 19},
  [619] = {.lex_state = 3, .external_lex_state = 19},
  [620] = {.lex_state = 3, .external_lex_state = 19},
  [621] = {.lex_state = 3, .external_lex_state = 19},
  [622] = {.lex_state = 3, .external_lex_state = 19},
  [623] = {.lex_state = 3, .external_lex_state = 19},
  [624] = {.lex_state = 3, .external_lex_state = 19},
  [625] = {.lex_state = 3, .external_lex_state = 19},
  [626] = {.lex_state = 3, .external_lex_state = 19},
  [627] = {.lex_state = 3, .external_lex_state = 19},
  [628] = {.lex_state = 3, .external_lex_state = 19},
  [629] = {.lex_state = 3, .external_lex_state = 19},
  [630] = {.lex_state = 3, .external_lex_state = 19},
  [631] = {.lex_state = 3, .external_lex_state = 19},
  [632] = {.lex_state = 3, .external_lex_state = 19},
  [633] = {.lex_state = 3, .external_lex_state = 19},
  [634] = {.lex_state = 3, .external_lex_state = 19},
  [635] = {.lex_state = 3, .external_lex_state = 19},
  [636] = {.lex_state = 3, .external_lex_state = 19},
  [637] = {.lex_state = 3, .external_lex_state = 19},
  [638] = {.lex_state = 3, .external_lex_state = 19},
  [639] = {.lex_state = 3, .external_lex_state = 19},
  [640] = {.lex_state = 3, .external_lex_state = 19},
  [641] = {.lex_state = 3, .external_lex_state = 19},
  [642] = {.lex_state = 3, .external_lex_state = 19},
  [643] = {.lex_state = 3, .external_lex_state = 19},
  [644] = {.lex_state = 3, .external_lex_state = 19},
  [645] = {.lex_state = 3, .external_lex_state = 19},
  [646] = {.lex_state = 3, .external_lex_state = 19},
  [647] = {.lex_state = 3, .external_lex_state = 19},
  [648] = {.lex_state = 8, .external_lex_state = 29},
  [649] = {.lex_state = 8, .external_lex_state = 29},
  [650] = {.lex_state = 8, .external_lex_state = 29},
  [651] = {.lex_state = 8, .external_lex_state = 29},
  [652] = {.lex_state = 8, .external_lex_state = 29},
  [653] = {.lex_state = 8, .external_lex_state = 29},
  [654] = {.lex_state = 8, .external_lex_state = 30},
  [655] = {.lex_state = 11, .external_lex_state = 31},
  [656] = {.lex_state = 11, .external_lex_state = 31},
  [657] = {.lex_state = 8, .external_lex_state = 30},
  [658] = {.lex_state = 11, .external_lex_state = 32},
  [659] = {.lex_state = 8, .external_lex_state = 30},
  [660] = {.lex_state = 11, .external_lex_state = 32},
  [661] = {.lex_state = 8, .external_lex_state = 30},
  [662] = {.lex_state = 11, .external_lex_state = 31},
  [663] = {.lex_state = 11, .external_lex_state = 32},
  [664] = {.lex_state = 11, .external_lex_state = 31},
  [665] = {.lex_state = 11, .external_lex_state = 32},
  [666] = {.lex_state = 11, .external_lex_state = 31},
  [667] = {.lex_state = 8, .external_lex_state = 30},
  [668] = {.lex_state = 8, .external_lex_state = 30},
  [669] = {.lex_state = 11, .external_lex_state = 32},
  [670] = {.lex_state = 11, .external_lex_state = 31},
  [671] = {.lex_state = 11, .external_lex_state = 32},
  [672] = {.lex_state = 3, .external_lex_state = 8},
  [673] = {.lex_state = 11, .external_lex_state = 33},
  [674] = {.lex_state = 16, .external_lex_state = 28},
  [675] = {.lex_state = 3, .external_lex_state = 34},
  [676] = {.lex_state = 3, .external_lex_state = 34},
  [677] = {.lex_state = 3, .external_lex_state = 34},
  [678] = {.lex_state = 3, .external_lex_state = 34},
  [679] = {.lex_state = 3, .external_lex_state = 34},
  [680] = {.lex_state = 3, .external_lex_state = 34},
  [681] = {.lex_state = 3, .external_lex_state = 34},
  [682] = {.lex_state = 3, .external_lex_state = 34},
  [683] = {.lex_state = 3, .external_lex_state = 34},
  [684] = {.lex_state = 11, .external_lex_state = 33},
  [685] = {.lex_state = 11, .external_lex_state = 33},
  [686] = {.lex_state = 3, .external_lex_state = 34},
  [687] = {.lex_state = 3, .external_lex_state = 34},
  [688] = {.lex_state = 16, .external_lex_state = 28},
  [689] = {.lex_state = 3, .external_lex_state = 34},
  [690] = {.lex_state = 3, .external_lex_state = 34},
  [691] = {.lex_state = 3, .external_lex_state = 34},
  [692] = {.lex_state = 3, .external_lex_state = 34},
  [693] = {.lex_state = 3, .external_lex_state = 34},
  [694] = {.lex_state = 3, .external_lex_state = 34},
  [695] = {.lex_state = 3, .external_lex_state = 34},
  [696] = {.lex_state = 3, .external_lex_state = 34},
  [697] = {.lex_state = 3, .external_lex_state = 34},
  [698] = {.lex_state = 16, .external_lex_state = 28},
  [699] = {.lex_state = 3, .external_lex_state = 34},
  [700] = {.lex_state = 3, .external_lex_state = 34},
  [701] = {.lex_state = 3, .external_lex_state = 34},
  [702] = {.lex_state = 3, .external_lex_state = 34},
  [703] = {.lex_state = 16, .external_lex_state = 28},
  [704] = {.lex_state = 16, .external_lex_state = 28},
  [705] = {.lex_state = 3, .external_lex_state = 34},
  [706] = {.lex_state = 3, .external_lex_state = 34},
  [707] = {.lex_state = 3, .external_lex_state = 34},
  [708] = {.lex_state = 3, .external_lex_state = 34},
  [709] = {.lex_state = 3, .external_lex_state = 34},
  [710] = {.lex_state = 3, .external_lex_state = 34},
  [711] = {.lex_state = 3, .external_lex_state = 34},
  [712] = {.lex_state = 3, .external_lex_state = 34},
  [713] = {.lex_state = 3, .external_lex_state = 34},
  [714] = {.lex_state = 3, .external_lex_state = 34},
  [715] = {.lex_state = 11, .external_lex_state = 33},
  [716] = {.lex_state = 3, .external_lex_state = 34},
  [717] = {.lex_state = 3, .external_lex_state = 34},
  [718] = {.lex_state = 3, .external_lex_state = 34},
  [719] = {.lex_state = 3, .external_lex_state = 34},
  [720] = {.lex_state = 11, .external_lex_state = 33},
  [721] = {.lex_state = 3, .external_lex_state = 34},
  [722] = {.lex_state = 3, .external_lex_state = 34},
  [723] = {.lex_state = 3, .external_lex_state = 34},
  [724] = {.lex_state = 3, .external_lex_state = 34},
  [725] = {.lex_state = 3, .external_lex_state = 34},
  [726] = {.lex_state = 11, .external_lex_state = 33},
  [727] = {.lex_state = 3, .external_lex_state = 34},
  [728] = {.lex_state = 3, .external_lex_state = 34},
  [729] = {.lex_state = 3, .external_lex_state = 34},
  [730] = {.lex_state = 16, .external_lex_state = 28},
  [731] = {.lex_state = 3, .external_lex_state = 34},
  [732] = {.lex_state = 3, .external_lex_state = 34},
  [733] = {.lex_state = 1, .external_lex_state = 35},
  [734] = {.lex_state = 1, .external_lex_state = 35},
  [735] = {.lex_state = 3, .external_lex_state = 9},
  [736] = {.lex_state = 16, .external_lex_state = 27},
  [737] = {.lex_state = 1, .external_lex_state = 35},
  [738] = {.lex_state = 8, .external_lex_state = 36},
  [739] = {.lex_state = 8, .external_lex_state = 37},
  [740] = {.lex_state = 1, .external_lex_state = 35},
  [741] = {.lex_state = 1, .external_lex_state = 38},
  [742] = {.lex_state = 3, .external_lex_state = 9},
  [743] = {.lex_state = 1, .external_lex_state = 35},
  [744] = {.lex_state = 1, .external_lex_state = 35},
  [745] = {.lex_state = 8, .external_lex_state = 36},
  [746] = {.lex_state = 1, .external_lex_state = 38},
  [747] = {.lex_state = 8, .external_lex_state = 36},
  [748] = {.lex_state = 11, .external_lex_state = 39},
  [749] = {.lex_state = 1, .external_lex_state = 35},
  [750] = {.lex_state = 11, .external_lex_state = 39},
  [751] = {.lex_state = 8, .external_lex_state = 36},
  [752] = {.lex_state = 1, .external_lex_state = 35},
  [753] = {.lex_state = 1, .external_lex_state = 35},
  [754] = {.lex_state = 8, .external_lex_state = 40},
  [755] = {.lex_state = 1, .external_lex_state = 35},
  [756] = {.lex_state = 16, .external_lex_state = 27},
  [757] = {.lex_state = 1, .external_lex_state = 35},
  [758] = {.lex_state = 16, .external_lex_state = 27},
  [759] = {.lex_state = 1, .external_lex_state = 38},
  [760] = {.lex_state = 1, .external_lex_state = 38},
  [761] = {.lex_state = 1, .external_lex_state = 38},
  [762] = {.lex_state = 1, .external_lex_state = 35},
  [763] = {.lex_state = 1, .external_lex_state = 35},
  [764] = {.lex_state = 1, .external_lex_state = 35},
  [765] = {.lex_state = 1, .external_lex_state = 35},
  [766] = {.lex_state = 8, .external_lex_state = 40},
  [767] = {.lex_state = 16, .external_lex_state = 27},
  [768] = {.lex_state = 1, .external_lex_state = 35},
  [769] = {.lex_state = 1, .external_lex_state = 35},
  [770] = {.lex_state = 1, .external_lex_state = 35},
  [771] = {.lex_state = 1, .external_lex_state = 35},
  [772] = {.lex_state = 1, .external_lex_state = 35},
  [773] = {.lex_state = 16, .external_lex_state = 27},
  [774] = {.lex_state = 1, .external_lex_state = 38},
  [775] = {.lex_state = 16, .external_lex_state = 27},
  [776] = {.lex_state = 3, .external_lex_state = 9},
  [777] = {.lex_state = 8, .external_lex_state = 37},
  [778] = {.lex_state = 1, .external_lex_state = 35},
  [779] = {.lex_state = 11, .external_lex_state = 39},
  [780] = {.lex_state = 8, .external_lex_state = 40},
  [781] = {.lex_state = 1, .external_lex_state = 35},
  [782] = {.lex_state = 8, .external_lex_state = 41},
  [783] = {.lex_state = 11, .external_lex_state = 39},
  [784] = {.lex_state = 1, .external_lex_state = 35},
  [785] = {.lex_state = 8, .external_lex_state = 41},
  [786] = {.lex_state = 1, .external_lex_state = 35},
  [787] = {.lex_state = 1, .external_lex_state = 35},
  [788] = {.lex_state = 1, .external_lex_state = 35},
  [789] = {.lex_state = 1, .external_lex_state = 35},
  [790] = {.lex_state = 8, .external_lex_state = 41},
  [791] = {.lex_state = 8, .external_lex_state = 36},
  [792] = {.lex_state = 1, .external_lex_state = 35},
  [793] = {.lex_state = 1, .external_lex_state = 35},
  [794] = {.lex_state = 1, .external_lex_state = 35},
  [795] = {.lex_state = 1, .external_lex_state = 35},
  [796] = {.lex_state = 8, .external_lex_state = 41},
  [797] = {.lex_state = 11, .external_lex_state = 39},
  [798] = {.lex_state = 1, .external_lex_state = 38},
  [799] = {.lex_state = 1, .external_lex_state = 35},
  [800] = {.lex_state = 1, .external_lex_state = 38},
  [801] = {.lex_state = 11, .external_lex_state = 39},
  [802] = {.lex_state = 1, .external_lex_state = 35},
  [803] = {.lex_state = 1, .external_lex_state = 35},
  [804] = {.lex_state = 1, .external_lex_state = 35},
  [805] = {.lex_state = 1, .external_lex_state = 35},
  [806] = {.lex_state = 1, .external_lex_state = 35},
  [807] = {.lex_state = 8, .external_lex_state = 37},
  [808] = {.lex_state = 3, .external_lex_state = 9},
  [809] = {.lex_state = 8, .external_lex_state = 40},
  [810] = {.lex_state = 1, .external_lex_state = 35},
  [811] = {.lex_state = 8, .external_lex_state = 37},
  [812] = {.lex_state = 8, .external_lex_state = 37},
  [813] = {.lex_state = 1, .external_lex_state = 35},
  [814] = {.lex_state = 8, .external_lex_state = 40},
  [815] = {.lex_state = 1, .external_lex_state = 35},
  [816] = {.lex_state = 11, .external_lex_state = 39},
  [817] = {.lex_state = 1, .external_lex_state = 35},
  [818] = {.lex_state = 8, .external_lex_state = 40},
  [819] = {.lex_state = 8, .external_lex_state = 36},
  [820] = {.lex_state = 1, .external_lex_state = 35},
  [821] = {.lex_state = 8, .external_lex_state = 37},
  [822] = {.lex_state = 8, .external_lex_state = 41},
  [823] = {.lex_state = 11, .external_lex_state = 39},
  [824] = {.lex_state = 1, .external_lex_state = 35},
  [825] = {.lex_state = 1, .external_lex_state = 35},
  [826] = {.lex_state = 1, .external_lex_state = 35},
  [827] = {.lex_state = 1, .external_lex_state = 35},
  [828] = {.lex_state = 1, .external_lex_state = 38},
  [829] = {.lex_state = 1, .external_lex_state = 35},
  [830] = {.lex_state = 8, .external_lex_state = 41},
  [831] = {.lex_state = 1, .external_lex_state = 35},
  [832] = {.lex_state = 1, .external_lex_state = 38},
  [833] = {.lex_state = 8, .external_lex_state = 42},
  [834] = {.lex_state = 8, .external_lex_state = 34},
  [835] = {.lex_state = 8, .external_lex_state = 42},
  [836] = {.lex_state = 8, .external_lex_state = 42},
  [837] = {.lex_state = 8, .external_lex_state = 42},
  [838] = {.lex_state = 8, .external_lex_state = 42},
  [839] = {.lex_state = 8, .external_lex_state = 42},
  [840] = {.lex_state = 8, .external_lex_state = 42},
  [841] = {.lex_state = 1, .external_lex_state = 38},
  [842] = {.lex_state = 11, .external_lex_state = 27},
  [843] = {.lex_state = 11, .external_lex_state = 27},
  [844] = {.lex_state = 11, .external_lex_state = 43},
  [845] = {.lex_state = 1, .external_lex_state = 38},
  [846] = {.lex_state = 1, .external_lex_state = 38},
  [847] = {.lex_state = 1, .external_lex_state = 38},
  [848] = {.lex_state = 11, .external_lex_state = 43},
  [849] = {.lex_state = 11, .external_lex_state = 27},
  [850] = {.lex_state = 1, .external_lex_state = 38},
  [851] = {.lex_state = 11, .external_lex_state = 43},
  [852] = {.lex_state = 11, .external_lex_state = 43},
  [853] = {.lex_state = 3, .external_lex_state = 9},
  [854] = {.lex_state = 11, .external_lex_state = 27},
  [855] = {.lex_state = 1, .external_lex_state = 38},
  [856] = {.lex_state = 3, .external_lex_state = 9},
  [857] = {.lex_state = 3, .external_lex_state = 35},
  [858] = {.lex_state = 3, .external_lex_state = 9},
  [859] = {.lex_state = 3, .external_lex_state = 9},
  [860] = {.lex_state = 1, .external_lex_state = 38},
  [861] = {.lex_state = 1, .external_lex_state = 38},
  [862] = {.lex_state = 3, .external_lex_state = 35},
  [863] = {.lex_state = 11, .external_lex_state = 43},
  [864] = {.lex_state = 11, .external_lex_state = 27},
  [865] = {.lex_state = 11, .external_lex_state = 27},
  [866] = {.lex_state = 1, .external_lex_state = 38},
  [867] = {.lex_state = 1, .external_lex_state = 38},
  [868] = {.lex_state = 3, .external_lex_state = 35},
  [869] = {.lex_state = 11, .external_lex_state = 43},
  [870] = {.lex_state = 1, .external_lex_state = 35},
  [871] = {.lex_state = 11, .external_lex_state = 44},
  [872] = {.lex_state = 3, .external_lex_state = 38},
  [873] = {.lex_state = 3, .external_lex_state = 38},
  [874] = {.lex_state = 11, .external_lex_state = 45},
  [875] = {.lex_state = 3, .external_lex_state = 38},
  [876] = {.lex_state = 3, .external_lex_state = 38},
  [877] = {.lex_state = 11, .external_lex_state = 46},
  [878] = {.lex_state = 3, .external_lex_state = 38},
  [879] = {.lex_state = 1, .external_lex_state = 38},
  [880] = {.lex_state = 1, .external_lex_state = 38},
  [881] = {.lex_state = 11, .external_lex_state = 44},
  [882] = {.lex_state = 11, .external_lex_state = 46},
  [883] = {.lex_state = 11, .external_lex_state = 46},
  [884] = {.lex_state = 11, .external_lex_state = 46},
  [885] = {.lex_state = 11, .external_lex_state = 33},
  [886] = {.lex_state = 3, .external_lex_state = 11},
  [887] = {.lex_state = 11, .external_lex_state = 44},
  [888] = {.lex_state = 11, .external_lex_state = 45},
  [889] = {.lex_state = 1, .external_lex_state = 38},
  [890] = {.lex_state = 1, .external_lex_state = 38},
  [891] = {.lex_state = 11, .external_lex_state = 46},
  [892] = {.lex_state = 3, .external_lex_state = 38},
  [893] = {.lex_state = 1, .external_lex_state = 38},
  [894] = {.lex_state = 1, .external_lex_state = 38},
  [895] = {.lex_state = 1, .external_lex_state = 38},
  [896] = {.lex_state = 3, .external_lex_state = 38},
  [897] = {.lex_state = 11, .external_lex_state = 44},
  [898] = {.lex_state = 1, .external_lex_state = 38},
  [899] = {.lex_state = 3, .external_lex_state = 38},
  [900] = {.lex_state = 1, .external_lex_state = 38},
  [901] = {.lex_state = 3, .external_lex_state = 38},
  [902] = {.lex_state = 1, .external_lex_state = 38},
  [903] = {.lex_state = 3, .external_lex_state = 38},
  [904] = {.lex_state = 1, .external_lex_state = 38},
  [905] = {.lex_state = 1, .external_lex_state = 38},
  [906] = {.lex_state = 3, .external_lex_state = 38},
  [907] = {.lex_state = 1, .external_lex_state = 38},
  [908] = {.lex_state = 3, .external_lex_state = 38},
  [909] = {.lex_state = 1, .external_lex_state = 38},
  [910] = {.lex_state = 11, .external_lex_state = 46},
  [911] = {.lex_state = 11, .external_lex_state = 44},
  [912] = {.lex_state = 1, .external_lex_state = 38},
  [913] = {.lex_state = 3, .external_lex_state = 38},
  [914] = {.lex_state = 11, .external_lex_state = 44},
  [915] = {.lex_state = 11, .external_lex_state = 45},
  [916] = {.lex_state = 1, .external_lex_state = 38},
  [917] = {.lex_state = 3, .external_lex_state = 38},
  [918] = {.lex_state = 3, .external_lex_state = 38},
  [919] = {.lex_state = 1, .external_lex_state = 38},
  [920] = {.lex_state = 3, .external_lex_state = 11},
  [921] = {.lex_state = 11, .external_lex_state = 45},
  [922] = {.lex_state = 3, .external_lex_state = 38},
  [923] = {.lex_state = 1, .external_lex_state = 38},
  [924] = {.lex_state = 3, .external_lex_state = 38},
  [925] = {.lex_state = 11, .external_lex_state = 45},
  [926] = {.lex_state = 1, .external_lex_state = 38},
  [927] = {.lex_state = 11, .external_lex_state = 45},
  [928] = {.lex_state = 8, .external_lex_state = 47},
  [929] = {.lex_state = 11, .external_lex_state = 48},
  [930] = {.lex_state = 3, .external_lex_state = 35},
  [931] = {.lex_state = 3, .external_lex_state = 35},
  [932] = {.lex_state = 3, .external_lex_state = 38},
  [933] = {.lex_state = 8, .external_lex_state = 47},
  [934] = {.lex_state = 3, .external_lex_state = 35},
  [935] = {.lex_state = 3, .external_lex_state = 35},
  [936] = {.lex_state = 11, .external_lex_state = 48},
  [937] = {.lex_state = 11, .external_lex_state = 48},
  [938] = {.lex_state = 8, .external_lex_state = 47},
  [939] = {.lex_state = 8, .external_lex_state = 37},
  [940] = {.lex_state = 11, .external_lex_state = 48},
  [941] = {.lex_state = 8, .external_lex_state = 47},
  [942] = {.lex_state = 11, .external_lex_state = 48},
  [943] = {.lex_state = 8, .external_lex_state = 27},
  [944] = {.lex_state = 8, .external_lex_state = 27},
  [945] = {.lex_state = 11, .external_lex_state = 48},
  [946] = {.lex_state = 11, .external_lex_state = 48},
  [947] = {.lex_state = 11, .external_lex_state = 48},
  [948] = {.lex_state = 8, .external_lex_state = 47},
  [949] = {.lex_state = 8, .external_lex_state = 47},
  [950] = {.lex_state = 11, .external_lex_state = 48},
  [951] = {.lex_state = 3, .external_lex_state = 38},
  [952] = {.lex_state = 3, .external_lex_state = 49},
  [953] = {.lex_state = 3, .external_lex_state = 49},
  [954] = {.lex_state = 3, .external_lex_state = 38},
  [955] = {.lex_state = 3, .external_lex_state = 35},
  [956] = {.lex_state = 3, .external_lex_state = 35},
  [957] = {.lex_state = 3, .external_lex_state = 38},
  [958] = {.lex_state = 8, .external_lex_state = 50},
  [959] = {.lex_state = 3, .external_lex_state = 38},
  [960] = {.lex_state = 3, .external_lex_state = 38},
  [961] = {.lex_state = 3, .external_lex_state = 38},
  [962] = {.lex_state = 3, .external_lex_state = 35},
  [963] = {.lex_state = 3, .external_lex_state = 35},
  [964] = {.lex_state = 3, .external_lex_state = 35},
  [965] = {.lex_state = 3, .external_lex_state = 35},
  [966] = {.lex_state = 3, .external_lex_state = 35},
  [967] = {.lex_state = 3, .external_lex_state = 38},
  [968] = {.lex_state = 3, .external_lex_state = 38},
  [969] = {.lex_state = 8, .external_lex_state = 51},
  [970] = {.lex_state = 3, .external_lex_state = 38},
  [971] = {.lex_state = 3, .external_lex_state = 35},
  [972] = {.lex_state = 3, .external_lex_state = 38},
  [973] = {.lex_state = 3, .external_lex_state = 38},
  [974] = {.lex_state = 3, .external_lex_state = 38},
  [975] = {.lex_state = 1, .external_lex_state = 38},
  [976] = {.lex_state = 3, .external_lex_state = 35},
  [977] = {.lex_state = 3, .external_lex_state = 38},
  [978] = {.lex_state = 3, .external_lex_state = 38},
  [979] = {.lex_state = 3, .external_lex_state = 38},
  [980] = {.lex_state = 3, .external_lex_state = 38},
  [981] = {.lex_state = 3, .external_lex_state = 35},
  [982] = {.lex_state = 3, .external_lex_state = 35},
  [983] = {.lex_state = 8, .external_lex_state = 51},
  [984] = {.lex_state = 3, .external_lex_state = 38},
  [985] = {.lex_state = 3, .external_lex_state = 38},
  [986] = {.lex_state = 3, .external_lex_state = 35},
  [987] = {.lex_state = 3, .external_lex_state = 35},
  [988] = {.lex_state = 3, .external_lex_state = 11},
  [989] = {.lex_state = 3, .external_lex_state = 38},
  [990] = {.lex_state = 3, .external_lex_state = 35},
  [991] = {.lex_state = 3, .external_lex_state = 38},
  [992] = {.lex_state = 3, .external_lex_state = 38},
  [993] = {.lex_state = 3, .external_lex_state = 38},
  [994] = {.lex_state = 3, .external_lex_state = 49},
  [995] = {.lex_state = 3, .external_lex_state = 35},
  [996] = {.lex_state = 3, .external_lex_state = 38},
  [997] = {.lex_state = 3, .external_lex_state = 49},
  [998] = {.lex_state = 3, .external_lex_state = 35},
  [999] = {.lex_state = 3, .external_lex_state = 35},
  [1000] = {.lex_state = 3, .external_lex_state = 8},
  [1001] = {.lex_state = 3, .external_lex_state = 38},
  [1002] = {.lex_state = 3, .external_lex_state = 38},
  [1003] = {.lex_state = 9, .external_lex_state = 52},
  [1004] = {.lex_state = 3, .external_lex_state = 38},
  [1005] = {.lex_state = 3, .external_lex_state = 35},
  [1006] = {.lex_state = 9, .external_lex_state = 52},
  [1007] = {.lex_state = 3, .external_lex_state = 35},
  [1008] = {.lex_state = 3, .external_lex_state = 38},
  [1009] = {.lex_state = 3, .external_lex_state = 35},
  [1010] = {.lex_state = 3, .external_lex_state = 38},
  [1011] = {.lex_state = 3, .external_lex_state = 35},
  [1012] = {.lex_state = 8, .external_lex_state = 50},
  [1013] = {.lex_state = 8, .external_lex_state = 50},
  [1014] = {.lex_state = 8, .external_lex_state = 50},
  [1015] = {.lex_state = 3, .external_lex_state = 38},
  [1016] = {.lex_state = 3, .external_lex_state = 38},
  [1017] = {.lex_state = 3, .external_lex_state = 35},
  [1018] = {.lex_state = 9, .external_lex_state = 52},
  [1019] = {.lex_state = 3, .external_lex_state = 38},
  [1020] = {.lex_state = 3, .external_lex_state = 38},
  [1021] = {.lex_state = 3, .external_lex_state = 38},
  [1022] = {.lex_state = 3, .external_lex_state = 38},
  [1023] = {.lex_state = 3, .external_lex_state = 38},
  [1024] = {.lex_state = 3, .external_lex_state = 35},
  [1025] = {.lex_state = 3, .external_lex_state = 38},
  [1026] = {.lex_state = 3, .external_lex_state = 38},
  [1027] = {.lex_state = 3, .external_lex_state = 35},
  [1028] = {.lex_state = 3, .external_lex_state = 35},
  [1029] = {.lex_state = 3, .external_lex_state = 35},
  [1030] = {.lex_state = 3, .external_lex_state = 38},
  [1031] = {.lex_state = 3, .external_lex_state = 35},
  [1032] = {.lex_state = 3, .external_lex_state = 38},
  [1033] = {.lex_state = 3, .external_lex_state = 35},
  [1034] = {.lex_state = 3, .external_lex_state = 35},
  [1035] = {.lex_state = 3, .external_lex_state = 38},
  [1036] = {.lex_state = 3, .external_lex_state = 38},
  [1037] = {.lex_state = 3, .external_lex_state = 35},
  [1038] = {.lex_state = 3, .external_lex_state = 35},
  [1039] = {.lex_state = 3, .external_lex_state = 38},
  [1040] = {.lex_state = 3, .external_lex_state = 38},
  [1041] = {.lex_state = 3, .external_lex_state = 35},
  [1042] = {.lex_state = 3, .external_lex_state = 35},
  [1043] = {.lex_state = 3, .external_lex_state = 35},
  [1044] = {.lex_state = 3, .external_lex_state = 38},
  [1045] = {.lex_state = 3, .external_lex_state = 35},
  [1046] = {.lex_state = 3, .external_lex_state = 38},
  [1047] = {.lex_state = 3, .external_lex_state = 35},
  [1048] = {.lex_state = 3, .external_lex_state = 38},
  [1049] = {.lex_state = 3, .external_lex_state = 35},
  [1050] = {.lex_state = 3, .external_lex_state = 35},
  [1051] = {.lex_state = 3, .external_lex_state = 38},
  [1052] = {.lex_state = 3, .external_lex_state = 38},
  [1053] = {.lex_state = 3, .external_lex_state = 38},
  [1054] = {.lex_state = 8, .external_lex_state = 50},
  [1055] = {.lex_state = 3, .external_lex_state = 35},
  [1056] = {.lex_state = 3, .external_lex_state = 49},
  [1057] = {.lex_state = 3, .external_lex_state = 49},
  [1058] = {.lex_state = 3, .external_lex_state = 49},
  [1059] = {.lex_state = 3, .external_lex_state = 38},
  [1060] = {.lex_state = 3, .external_lex_state = 38},
  [1061] = {.lex_state = 3, .external_lex_state = 35},
  [1062] = {.lex_state = 3, .external_lex_state = 35},
  [1063] = {.lex_state = 3, .external_lex_state = 35},
  [1064] = {.lex_state = 3, .external_lex_state = 38},
  [1065] = {.lex_state = 3, .external_lex_state = 38},
  [1066] = {.lex_state = 3, .external_lex_state = 35},
  [1067] = {.lex_state = 3, .external_lex_state = 35},
  [1068] = {.lex_state = 3, .external_lex_state = 38},
  [1069] = {.lex_state = 3, .external_lex_state = 35},
  [1070] = {.lex_state = 3, .external_lex_state = 38},
  [1071] = {.lex_state = 3, .external_lex_state = 35},
  [1072] = {.lex_state = 3, .external_lex_state = 35},
  [1073] = {.lex_state = 3, .external_lex_state = 35},
  [1074] = {.lex_state = 3, .external_lex_state = 38},
  [1075] = {.lex_state = 3, .external_lex_state = 38},
  [1076] = {.lex_state = 3, .external_lex_state = 38},
  [1077] = {.lex_state = 3, .external_lex_state = 38},
  [1078] = {.lex_state = 3, .external_lex_state = 35},
  [1079] = {.lex_state = 3, .external_lex_state = 35},
  [1080] = {.lex_state = 3, .external_lex_state = 11},
  [1081] = {.lex_state = 3, .external_lex_state = 38},
  [1082] = {.lex_state = 3, .external_lex_state = 35},
  [1083] = {.lex_state = 3, .external_lex_state = 38},
  [1084] = {.lex_state = 3, .external_lex_state = 35},
  [1085] = {.lex_state = 3, .external_lex_state = 38},
  [1086] = {.lex_state = 3, .external_lex_state = 38},
  [1087] = {.lex_state = 9, .external_lex_state = 52},
  [1088] = {.lex_state = 3, .external_lex_state = 38},
  [1089] = {.lex_state = 3, .external_lex_state = 49},
  [1090] = {.lex_state = 3, .external_lex_state = 35},
  [1091] = {.lex_state = 3, .external_lex_state = 38},
  [1092] = {.lex_state = 8, .external_lex_state = 51},
  [1093] = {.lex_state = 3, .external_lex_state = 38},
  [1094] = {.lex_state = 8, .external_lex_state = 51},
  [1095] = {.lex_state = 8, .external_lex_state = 50},
  [1096] = {.lex_state = 9, .external_lex_state = 52},
  [1097] = {.lex_state = 3, .external_lex_state = 38},
  [1098] = {.lex_state = 3, .external_lex_state = 38},
  [1099] = {.lex_state = 3, .external_lex_state = 38},
  [1100] = {.lex_state = 3, .external_lex_state = 35},
  [1101] = {.lex_state = 3, .external_lex_state = 35},
  [1102] = {.lex_state = 3, .external_lex_state = 38},
  [1103] = {.lex_state = 3, .external_lex_state = 35},
  [1104] = {.lex_state = 3, .external_lex_state = 35},
  [1105] = {.lex_state = 3, .external_lex_state = 35},
  [1106] = {.lex_state = 3, .external_lex_state = 38},
  [1107] = {.lex_state = 3, .external_lex_state = 38},
  [1108] = {.lex_state = 3, .external_lex_state = 38},
  [1109] = {.lex_state = 3, .external_lex_state = 38},
  [1110] = {.lex_state = 3, .external_lex_state = 38},
  [1111] = {.lex_state = 3, .external_lex_state = 35},
  [1112] = {.lex_state = 3, .external_lex_state = 38},
  [1113] = {.lex_state = 3, .external_lex_state = 35},
  [1114] = {.lex_state = 3, .external_lex_state = 35},
  [1115] = {.lex_state = 3, .external_lex_state = 38},
  [1116] = {.lex_state = 3, .external_lex_state = 38},
  [1117] = {.lex_state = 8, .external_lex_state = 50},
  [1118] = {.lex_state = 3, .external_lex_state = 38},
  [1119] = {.lex_state = 8, .external_lex_state = 50},
  [1120] = {.lex_state = 3, .external_lex_state = 35},
  [1121] = {.lex_state = 3, .external_lex_state = 38},
  [1122] = {.lex_state = 3, .external_lex_state = 35},
  [1123] = {.lex_state = 9, .external_lex_state = 52},
  [1124] = {.lex_state = 3, .external_lex_state = 35},
  [1125] = {.lex_state = 8, .external_lex_state = 50},
  [1126] = {.lex_state = 8, .external_lex_state = 50},
  [1127] = {.lex_state = 8, .external_lex_state = 51},
  [1128] = {.lex_state = 3, .external_lex_state = 38},
  [1129] = {.lex_state = 8, .external_lex_state = 51},
  [1130] = {.lex_state = 3, .external_lex_state = 35},
  [1131] = {.lex_state = 3, .external_lex_state = 35},
  [1132] = {.lex_state = 3, .external_lex_state = 38},
  [1133] = {.lex_state = 8, .external_lex_state = 53},
  [1134] = {.lex_state = 3, .external_lex_state = 54},
  [1135] = {.lex_state = 3, .external_lex_state = 9},
  [1136] = {.lex_state = 3, .external_lex_state = 38},
  [1137] = {.lex_state = 8, .external_lex_state = 53},
  [1138] = {.lex_state = 3, .external_lex_state = 38},
  [1139] = {.lex_state = 3, .external_lex_state = 38},
  [1140] = {.lex_state = 3, .external_lex_state = 38},
  [1141] = {.lex_state = 8, .external_lex_state = 53},
  [1142] = {.lex_state = 3, .external_lex_state = 54},
  [1143] = {.lex_state = 3, .external_lex_state = 9},
  [1144] = {.lex_state = 8, .external_lex_state = 53},
  [1145] = {.lex_state = 3, .external_lex_state = 54},
  [1146] = {.lex_state = 1, .external_lex_state = 35},
  [1147] = {.lex_state = 3, .external_lex_state = 54},
  [1148] = {.lex_state = 3, .external_lex_state = 38},
  [1149] = {.lex_state = 3, .external_lex_state = 38},
  [1150] = {.lex_state = 10, .external_lex_state = 52},
  [1151] = {.lex_state = 10, .external_lex_state = 52},
  [1152] = {.lex_state = 10, .external_lex_state = 52},
  [1153] = {.lex_state = 3, .external_lex_state = 38},
  [1154] = {.lex_state = 3, .external_lex_state = 38},
  [1155] = {.lex_state = 3, .external_lex_state = 54},
  [1156] = {.lex_state = 3, .external_lex_state = 38},
  [1157] = {.lex_state = 3, .external_lex_state = 38},
  [1158] = {.lex_state = 10, .external_lex_state = 52},
  [1159] = {.lex_state = 3, .external_lex_state = 38},
  [1160] = {.lex_state = 3, .external_lex_state = 54},
  [1161] = {.lex_state = 3, .external_lex_state = 38},
  [1162] = {.lex_state = 8, .external_lex_state = 50},
  [1163] = {.lex_state = 3, .external_lex_state = 38},
  [1164] = {.lex_state = 8, .external_lex_state = 53},
  [1165] = {.lex_state = 3, .external_lex_state = 54},
  [1166] = {.lex_state = 8, .external_lex_state = 53},
  [1167] = {.lex_state = 8, .external_lex_state = 53},
  [1168] = {.lex_state = 3, .external_lex_state = 54},
  [1169] = {.lex_state = 3, .external_lex_state = 38},
  [1170] = {.lex_state = 3, .external_lex_state = 38},
  [1171] = {.lex_state = 3, .external_lex_state = 9},
  [1172] = {.lex_state = 3, .external_lex_state = 38},
  [1173] = {.lex_state = 3, .external_lex_state = 9},
  [1174] = {.lex_state = 3, .external_lex_state = 38},
  [1175] = {.lex_state = 3, .external_lex_state = 38},
  [1176] = {.lex_state = 3, .external_lex_state = 38},
  [1177] = {.lex_state = 3, .external_lex_state = 54},
  [1178] = {.lex_state = 3, .external_lex_state = 54},
  [1179] = {.lex_state = 3, .external_lex_state = 38},
  [1180] = {.lex_state = 3, .external_lex_state = 38},
  [1181] = {.lex_state = 3, .external_lex_state = 38},
  [1182] = {.lex_state = 3, .external_lex_state = 38},
  [1183] = {.lex_state = 3, .external_lex_state = 35},
  [1184] = {.lex_state = 3, .external_lex_state = 38},
  [1185] = {.lex_state = 3, .external_lex_state = 38},
  [1186] = {.lex_state = 8, .external_lex_state = 55},
  [1187] = {.lex_state = 8, .external_lex_state = 55},
  [1188] = {.lex_state = 3, .external_lex_state = 38},
  [1189] = {.lex_state = 3, .external_lex_state = 38},
  [1190] = {.lex_state = 3, .external_lex_state = 38},
  [1191] = {.lex_state = 3, .external_lex_state = 38},
  [1192] = {.lex_state = 3, .external_lex_state = 38},
  [1193] = {.lex_state = 3, .external_lex_state = 38},
  [1194] = {.lex_state = 3, .external_lex_state = 38},
  [1195] = {.lex_state = 3, .external_lex_state = 49},
  [1196] = {.lex_state = 3, .external_lex_state = 38},
  [1197] = {.lex_state = 3, .external_lex_state = 38},
  [1198] = {.lex_state = 3, .external_lex_state = 38},
  [1199] = {.lex_state = 3, .external_lex_state = 35},
  [1200] = {.lex_state = 3, .external_lex_state = 38},
  [1201] = {.lex_state = 3, .external_lex_state = 38},
  [1202] = {.lex_state = 3, .external_lex_state = 38},
  [1203] = {.lex_state = 3, .external_lex_state = 38},
  [1204] = {.lex_state = 3, .external_lex_state = 38},
  [1205] = {.lex_state = 3, .external_lex_state = 38},
  [1206] = {.lex_state = 3, .external_lex_state = 38},
  [1207] = {.lex_state = 3, .external_lex_state = 38},
  [1208] = {.lex_state = 11, .external_lex_state = 33},
  [1209] = {.lex_state = 11, .external_lex_state = 33},
  [1210] = {.lex_state = 3, .external_lex_state = 38},
  [1211] = {.lex_state = 3, .external_lex_state = 38},
  [1212] = {.lex_state = 3, .external_lex_state = 38},
  [1213] = {.lex_state = 3, .external_lex_state = 38},
  [1214] = {.lex_state = 3, .external_lex_state = 38},
  [1215] = {.lex_state = 3, .external_lex_state = 38},
  [1216] = {.lex_state = 3, .external_lex_state = 38},
  [1217] = {.lex_state = 3, .external_lex_state = 38},
  [1218] = {.lex_state = 3, .external_lex_state = 38},
  [1219] = {.lex_state = 3, .external_lex_state = 38},
  [1220] = {.lex_state = 3, .external_lex_state = 38},
  [1221] = {.lex_state = 3, .external_lex_state = 38},
  [1222] = {.lex_state = 3, .external_lex_state = 38},
  [1223] = {.lex_state = 3, .external_lex_state = 38},
  [1224] = {.lex_state = 3, .external_lex_state = 38},
  [1225] = {.lex_state = 3, .external_lex_state = 38},
  [1226] = {.lex_state = 3, .external_lex_state = 35},
  [1227] = {.lex_state = 3, .external_lex_state = 38},
  [1228] = {.lex_state = 3, .external_lex_state = 38},
  [1229] = {.lex_state = 3, .external_lex_state = 38},
  [1230] = {.lex_state = 3, .external_lex_state = 38},
  [1231] = {.lex_state = 3, .external_lex_state = 38},
  [1232] = {.lex_state = 3, .external_lex_state = 35},
  [1233] = {.lex_state = 3, .external_lex_state = 38},
  [1234] = {.lex_state = 11, .external_lex_state = 33},
  [1235] = {.lex_state = 3, .external_lex_state = 38},
  [1236] = {.lex_state = 3, .external_lex_state = 38},
  [1237] = {.lex_state = 3, .external_lex_state = 38},
  [1238] = {.lex_state = 3, .external_lex_state = 38},
  [1239] = {.lex_state = 3, .external_lex_state = 38},
  [1240] = {.lex_state = 3, .external_lex_state = 38},
  [1241] = {.lex_state = 3, .external_lex_state = 38},
  [1242] = {.lex_state = 3, .external_lex_state = 38},
  [1243] = {.lex_state = 3, .external_lex_state = 38},
  [1244] = {.lex_state = 3, .external_lex_state = 38},
  [1245] = {.lex_state = 3, .external_lex_state = 38},
  [1246] = {.lex_state = 8, .external_lex_state = 55},
  [1247] = {.lex_state = 3, .external_lex_state = 38},
  [1248] = {.lex_state = 3, .external_lex_state = 38},
  [1249] = {.lex_state = 3, .external_lex_state = 38},
  [1250] = {.lex_state = 3, .external_lex_state = 38},
  [1251] = {.lex_state = 3, .external_lex_state = 38},
  [1252] = {.lex_state = 3, .external_lex_state = 38},
  [1253] = {.lex_state = 11, .external_lex_state = 33},
  [1254] = {.lex_state = 3, .external_lex_state = 38},
  [1255] = {.lex_state = 11, .external_lex_state = 33},
  [1256] = {.lex_state = 3, .external_lex_state = 38},
  [1257] = {.lex_state = 3, .external_lex_state = 38},
  [1258] = {.lex_state = 3, .external_lex_state = 38},
  [1259] = {.lex_state = 3, .external_lex_state = 38},
  [1260] = {.lex_state = 3, .external_lex_state = 38},
  [1261] = {.lex_state = 3, .external_lex_state = 38},
  [1262] = {.lex_state = 3, .external_lex_state = 38},
  [1263] = {.lex_state = 3, .external_lex_state = 38},
  [1264] = {.lex_state = 8, .external_lex_state = 55},
  [1265] = {.lex_state = 11, .external_lex_state = 33},
  [1266] = {.lex_state = 3, .external_lex_state = 38},
  [1267] = {.lex_state = 8, .external_lex_state = 55},
  [1268] = {.lex_state = 3, .external_lex_state = 38},
  [1269] = {.lex_state = 3, .external_lex_state = 38},
  [1270] = {.lex_state = 3, .external_lex_state = 38},
  [1271] = {.lex_state = 3, .external_lex_state = 38},
  [1272] = {.lex_state = 3, .external_lex_state = 38},
  [1273] = {.lex_state = 3, .external_lex_state = 38},
  [1274] = {.lex_state = 3, .external_lex_state = 38},
  [1275] = {.lex_state = 3, .external_lex_state = 38},
  [1276] = {.lex_state = 3, .external_lex_state = 38},
  [1277] = {.lex_state = 3, .external_lex_state = 38},
  [1278] = {.lex_state = 3, .external_lex_state = 38},
  [1279] = {.lex_state = 3, .external_lex_state = 38},
  [1280] = {.lex_state = 3, .external_lex_state = 38},
  [1281] = {.lex_state = 3, .external_lex_state = 38},
  [1282] = {.lex_state = 3, .external_lex_state = 38},
  [1283] = {.lex_state = 3, .external_lex_state = 38},
  [1284] = {.lex_state = 3, .external_lex_state = 38},
  [1285] = {.lex_state = 3, .external_lex_state = 38},
  [1286] = {.lex_state = 3, .external_lex_state = 38},
  [1287] = {.lex_state = 3, .external_lex_state = 38},
  [1288] = {.lex_state = 3, .external_lex_state = 38},
  [1289] = {.lex_state = 3, .external_lex_state = 38},
  [1290] = {.lex_state = 3, .external_lex_state = 38},
  [1291] = {.lex_state = 3, .external_lex_state = 38},
  [1292] = {.lex_state = 3, .external_lex_state = 38},
  [1293] = {.lex_state = 8, .external_lex_state = 55},
  [1294] = {.lex_state = 3, .external_lex_state = 38},
  [1295] = {.lex_state = 3, .external_lex_state = 38},
  [1296] = {.lex_state = 8, .external_lex_state = 55},
  [1297] = {.lex_state = 3, .external_lex_state = 8},
  [1298] = {.lex_state = 3, .external_lex_state = 38},
  [1299] = {.lex_state = 3, .external_lex_state = 38},
  [1300] = {.lex_state = 3, .external_lex_state = 38},
  [1301] = {.lex_state = 3, .external_lex_state = 38},
  [1302] = {.lex_state = 3, .external_lex_state = 38},
  [1303] = {.lex_state = 3, .external_lex_state = 38},
  [1304] = {.lex_state = 11, .external_lex_state = 33},
  [1305] = {.lex_state = 3, .external_lex_state = 38},
  [1306] = {.lex_state = 3, .external_lex_state = 38},
  [1307] = {.lex_state = 3, .external_lex_state = 38},
  [1308] = {.lex_state = 3, .external_lex_state = 38},
  [1309] = {.lex_state = 3, .external_lex_state = 38},
  [1310] = {.lex_state = 3, .external_lex_state = 38},
  [1311] = {.lex_state = 3, .external_lex_state = 38},
  [1312] = {.lex_state = 3, .external_lex_state = 38},
  [1313] = {.lex_state = 3, .external_lex_state = 38},
  [1314] = {.lex_state = 3, .external_lex_state = 38},
  [1315] = {.lex_state = 3, .external_lex_state = 38},
  [1316] = {.lex_state = 3, .external_lex_state = 38},
  [1317] = {.lex_state = 3, .external_lex_state = 38},
  [1318] = {.lex_state = 3, .external_lex_state = 38},
  [1319] = {.lex_state = 3, .external_lex_state = 38},
  [1320] = {.lex_state = 3, .external_lex_state = 38},
  [1321] = {.lex_state = 3, .external_lex_state = 38},
  [1322] = {.lex_state = 3, .external_lex_state = 38},
  [1323] = {.lex_state = 3, .external_lex_state = 38},
  [1324] = {.lex_state = 3, .external_lex_state = 38},
  [1325] = {.lex_state = 3, .external_lex_state = 38},
  [1326] = {.lex_state = 3, .external_lex_state = 38},
  [1327] = {.lex_state = 3, .external_lex_state = 38},
  [1328] = {.lex_state = 3, .external_lex_state = 38},
  [1329] = {.lex_state = 3, .external_lex_state = 38},
  [1330] = {.lex_state = 3, .external_lex_state = 38},
  [1331] = {.lex_state = 3, .external_lex_state = 38},
  [1332] = {.lex_state = 3, .external_lex_state = 38},
  [1333] = {.lex_state = 3, .external_lex_state = 35},
  [1334] = {.lex_state = 3, .external_lex_state = 38},
  [1335] = {.lex_state = 3, .external_lex_state = 38},
  [1336] = {.lex_state = 3, .external_lex_state = 38},
  [1337] = {.lex_state = 3, .external_lex_state = 38},
  [1338] = {.lex_state = 3, .external_lex_state = 38},
  [1339] = {.lex_state = 3, .external_lex_state = 38},
  [1340] = {.lex_state = 3, .external_lex_state = 38},
  [1341] = {.lex_state = 3, .external_lex_state = 38},
  [1342] = {.lex_state = 3, .external_lex_state = 38},
  [1343] = {.lex_state = 3, .external_lex_state = 38},
  [1344] = {.lex_state = 3, .external_lex_state = 38},
  [1345] = {.lex_state = 3, .external_lex_state = 38},
  [1346] = {.lex_state = 11, .external_lex_state = 33},
  [1347] = {.lex_state = 3, .external_lex_state = 38},
  [1348] = {.lex_state = 3, .external_lex_state = 38},
  [1349] = {.lex_state = 3, .external_lex_state = 38},
  [1350] = {.lex_state = 3, .external_lex_state = 35},
  [1351] = {.lex_state = 3, .external_lex_state = 38},
  [1352] = {.lex_state = 3, .external_lex_state = 38},
  [1353] = {.lex_state = 3, .external_lex_state = 38},
  [1354] = {.lex_state = 3, .external_lex_state = 38},
  [1355] = {.lex_state = 3, .external_lex_state = 35},
  [1356] = {.lex_state = 3, .external_lex_state = 38},
  [1357] = {.lex_state = 3, .external_lex_state = 38},
  [1358] = {.lex_state = 3, .external_lex_state = 38},
  [1359] = {.lex_state = 3, .external_lex_state = 38},
  [1360] = {.lex_state = 8, .external_lex_state = 56},
  [1361] = {.lex_state = 3, .external_lex_state = 35},
  [1362] = {.lex_state = 8, .external_lex_state = 37},
  [1363] = {.lex_state = 8, .external_lex_state = 37},
  [1364] = {.lex_state = 8, .external_lex_state = 37},
  [1365] = {.lex_state = 8, .external_lex_state = 56},
  [1366] = {.lex_state = 3, .external_lex_state = 38},
  [1367] = {.lex_state = 3, .external_lex_state = 35},
  [1368] = {.lex_state = 8, .external_lex_state = 56},
  [1369] = {.lex_state = 3, .external_lex_state = 9},
  [1370] = {.lex_state = 3, .external_lex_state = 9},
  [1371] = {.lex_state = 8, .external_lex_state = 52},
  [1372] = {.lex_state = 3, .external_lex_state = 35},
  [1373] = {.lex_state = 3, .external_lex_state = 9},
  [1374] = {.lex_state = 3, .external_lex_state = 38},
  [1375] = {.lex_state = 8, .external_lex_state = 56},
  [1376] = {.lex_state = 8, .external_lex_state = 37},
  [1377] = {.lex_state = 8, .external_lex_state = 37},
  [1378] = {.lex_state = 8, .external_lex_state = 37},
  [1379] = {.lex_state = 3, .external_lex_state = 38},
  [1380] = {.lex_state = 3, .external_lex_state = 9},
  [1381] = {.lex_state = 3, .external_lex_state = 38},
  [1382] = {.lex_state = 8, .external_lex_state = 56},
  [1383] = {.lex_state = 3, .external_lex_state = 9},
  [1384] = {.lex_state = 8, .external_lex_state = 56},
  [1385] = {.lex_state = 8, .external_lex_state = 37},
  [1386] = {.lex_state = 3, .external_lex_state = 38},
  [1387] = {.lex_state = 3, .external_lex_state = 9},
  [1388] = {.lex_state = 3, .external_lex_state = 38},
  [1389] = {.lex_state = 3, .external_lex_state = 9},
  [1390] = {.lex_state = 3, .external_lex_state = 9},
  [1391] = {.lex_state = 3, .external_lex_state = 38},
  [1392] = {.lex_state = 8, .external_lex_state = 56},
  [1393] = {.lex_state = 8, .external_lex_state = 37},
  [1394] = {.lex_state = 3, .external_lex_state = 35},
  [1395] = {.lex_state = 3, .external_lex_state = 35},
  [1396] = {.lex_state = 3, .external_lex_state = 35},
  [1397] = {.lex_state = 3, .external_lex_state = 35},
  [1398] = {.lex_state = 3, .external_lex_state = 35},
  [1399] = {.lex_state = 3, .external_lex_state = 35},
  [1400] = {.lex_state = 3, .external_lex_state = 35},
  [1401] = {.lex_state = 3, .external_lex_state = 35},
  [1402] = {.lex_state = 3, .external_lex_state = 35},
  [1403] = {.lex_state = 3, .external_lex_state = 38},
  [1404] = {.lex_state = 3, .external_lex_state = 35},
  [1405] = {.lex_state = 3, .external_lex_state = 38},
  [1406] = {.lex_state = 3, .external_lex_state = 38},
  [1407] = {.lex_state = 3, .external_lex_state = 35},
  [1408] = {.lex_state = 3, .external_lex_state = 35},
  [1409] = {.lex_state = 3, .external_lex_state = 35},
  [1410] = {.lex_state = 3, .external_lex_state = 38},
  [1411] = {.lex_state = 3, .external_lex_state = 38},
  [1412] = {.lex_state = 3, .external_lex_state = 38},
  [1413] = {.lex_state = 3, .external_lex_state = 38},
  [1414] = {.lex_state = 3, .external_lex_state = 38},
  [1415] = {.lex_state = 3, .external_lex_state = 38},
  [1416] = {.lex_state = 3, .external_lex_state = 38},
  [1417] = {.lex_state = 3, .external_lex_state = 38},
  [1418] = {.lex_state = 3, .external_lex_state = 38},
  [1419] = {.lex_state = 3, .external_lex_state = 38},
  [1420] = {.lex_state = 3, .external_lex_state = 35},
  [1421] = {.lex_state = 3, .external_lex_state = 38},
  [1422] = {.lex_state = 3, .external_lex_state = 38},
  [1423] = {.lex_state = 3, .external_lex_state = 38},
  [1424] = {.lex_state = 3, .external_lex_state = 38},
  [1425] = {.lex_state = 3, .external_lex_state = 38},
  [1426] = {.lex_state = 8, .external_lex_state = 57},
  [1427] = {.lex_state = 8, .external_lex_state = 57},
  [1428] = {.lex_state = 3, .external_lex_state = 35},
  [1429] = {.lex_state = 3, .external_lex_state = 38},
  [1430] = {.lex_state = 3, .external_lex_state = 38},
  [1431] = {.lex_state = 3, .external_lex_state = 38},
  [1432] = {.lex_state = 3, .external_lex_state = 38},
  [1433] = {.lex_state = 3, .external_lex_state = 38},
  [1434] = {.lex_state = 3, .external_lex_state = 35},
  [1435] = {.lex_state = 3, .external_lex_state = 38},
  [1436] = {.lex_state = 3, .external_lex_state = 38},
  [1437] = {.lex_state = 3, .external_lex_state = 35},
  [1438] = {.lex_state = 3, .external_lex_state = 35},
  [1439] = {.lex_state = 3, .external_lex_state = 38},
  [1440] = {.lex_state = 3, .external_lex_state = 35},
  [1441] = {.lex_state = 3, .external_lex_state = 35},
  [1442] = {.lex_state = 3, .external_lex_state = 35},
  [1443] = {.lex_state = 3, .external_lex_state = 38},
  [1444] = {.lex_state = 3, .external_lex_state = 35},
  [1445] = {.lex_state = 3, .external_lex_state = 35},
  [1446] = {.lex_state = 3, .external_lex_state = 35},
  [1447] = {.lex_state = 3, .external_lex_state = 38},
  [1448] = {.lex_state = 3, .external_lex_state = 35},
  [1449] = {.lex_state = 3, .external_lex_state = 38},
  [1450] = {.lex_state = 3, .external_lex_state = 35},
  [1451] = {.lex_state = 3, .external_lex_state = 35},
  [1452] = {.lex_state = 3, .external_lex_state = 38},
  [1453] = {.lex_state = 3, .external_lex_state = 38},
  [1454] = {.lex_state = 3, .external_lex_state = 38},
  [1455] = {.lex_state = 3, .external_lex_state = 35},
  [1456] = {.lex_state = 3, .external_lex_state = 38},
  [1457] = {.lex_state = 3, .external_lex_state = 35},
  [1458] = {.lex_state = 3, .external_lex_state = 35},
  [1459] = {.lex_state = 3, .external_lex_state = 35},
  [1460] = {.lex_state = 3, .external_lex_state = 35},
  [1461] = {.lex_state = 3, .external_lex_state = 35},
  [1462] = {.lex_state = 3, .external_lex_state = 35},
  [1463] = {.lex_state = 3, .external_lex_state = 35},
  [1464] = {.lex_state = 3, .external_lex_state = 35},
  [1465] = {.lex_state = 3, .external_lex_state = 38},
  [1466] = {.lex_state = 3, .external_lex_state = 35},
  [1467] = {.lex_state = 3, .external_lex_state = 38},
  [1468] = {.lex_state = 3, .external_lex_state = 35},
  [1469] = {.lex_state = 3, .external_lex_state = 35},
  [1470] = {.lex_state = 3, .external_lex_state = 35},
  [1471] = {.lex_state = 3, .external_lex_state = 38},
  [1472] = {.lex_state = 3, .external_lex_state = 35},
  [1473] = {.lex_state = 3, .external_lex_state = 35},
  [1474] = {.lex_state = 3, .external_lex_state = 35},
  [1475] = {.lex_state = 3, .external_lex_state = 35},
  [1476] = {.lex_state = 3, .external_lex_state = 38},
  [1477] = {.lex_state = 3, .external_lex_state = 38},
  [1478] = {.lex_state = 3, .external_lex_state = 38},
  [1479] = {.lex_state = 3, .external_lex_state = 35},
  [1480] = {.lex_state = 3, .external_lex_state = 35},
  [1481] = {.lex_state = 3, .external_lex_state = 38},
  [1482] = {.lex_state = 3, .external_lex_state = 38},
  [1483] = {.lex_state = 3, .external_lex_state = 35},
  [1484] = {.lex_state = 3, .external_lex_state = 38},
  [1485] = {.lex_state = 3, .external_lex_state = 35},
  [1486] = {.lex_state = 3, .external_lex_state = 38},
  [1487] = {.lex_state = 3, .external_lex_state = 35},
  [1488] = {.lex_state = 3, .external_lex_state = 38},
  [1489] = {.lex_state = 3, .external_lex_state = 38},
  [1490] = {.lex_state = 3, .external_lex_state = 35},
  [1491] = {.lex_state = 3, .external_lex_state = 35},
  [1492] = {.lex_state = 3, .external_lex_state = 38},
  [1493] = {.lex_state = 3, .external_lex_state = 35},
  [1494] = {.lex_state = 3, .external_lex_state = 35},
  [1495] = {.lex_state = 3, .external_lex_state = 35},
  [1496] = {.lex_state = 3, .external_lex_state = 35},
  [1497] = {.lex_state = 3, .external_lex_state = 35},
  [1498] = {.lex_state = 3, .external_lex_state = 35},
  [1499] = {.lex_state = 3, .external_lex_state = 38},
  [1500] = {.lex_state = 3, .external_lex_state = 38},
  [1501] = {.lex_state = 3, .external_lex_state = 35},
  [1502] = {.lex_state = 3, .external_lex_state = 35},
  [1503] = {.lex_state = 3, .external_lex_state = 35},
  [1504] = {.lex_state = 3, .external_lex_state = 35},
  [1505] = {.lex_state = 3, .external_lex_state = 35},
  [1506] = {.lex_state = 3, .external_lex_state = 35},
  [1507] = {.lex_state = 8, .external_lex_state = 57},
  [1508] = {.lex_state = 3, .external_lex_state = 35},
  [1509] = {.lex_state = 3, .external_lex_state = 35},
  [1510] = {.lex_state = 3, .external_lex_state = 35},
  [1511] = {.lex_state = 8, .external_lex_state = 57},
  [1512] = {.lex_state = 3, .external_lex_state = 35},
  [1513] = {.lex_state = 3, .external_lex_state = 38},
  [1514] = {.lex_state = 3, .external_lex_state = 35},
  [1515] = {.lex_state = 3, .external_lex_state = 35},
  [1516] = {.lex_state = 3, .external_lex_state = 38},
  [1517] = {.lex_state = 3, .external_lex_state = 35},
  [1518] = {.lex_state = 3, .external_lex_state = 35},
  [1519] = {.lex_state = 3, .external_lex_state = 35},
  [1520] = {.lex_state = 3, .external_lex_state = 35},
  [1521] = {.lex_state = 3, .external_lex_state = 35},
  [1522] = {.lex_state = 3, .external_lex_state = 38},
  [1523] = {.lex_state = 3, .external_lex_state = 35},
  [1524] = {.lex_state = 3, .external_lex_state = 35},
  [1525] = {.lex_state = 3, .external_lex_state = 38},
  [1526] = {.lex_state = 3, .external_lex_state = 35},
  [1527] = {.lex_state = 3, .external_lex_state = 38},
  [1528] = {.lex_state = 3, .external_lex_state = 35},
  [1529] = {.lex_state = 3, .external_lex_state = 35},
  [1530] = {.lex_state = 3, .external_lex_state = 35},
  [1531] = {.lex_state = 3, .external_lex_state = 38},
  [1532] = {.lex_state = 3, .external_lex_state = 35},
  [1533] = {.lex_state = 3, .external_lex_state = 38},
  [1534] = {.lex_state = 3, .external_lex_state = 38},
  [1535] = {.lex_state = 3, .external_lex_state = 38},
  [1536] = {.lex_state = 8, .external_lex_state = 58},
  [1537] = {.lex_state = 3, .external_lex_state = 35},
  [1538] = {.lex_state = 3, .external_lex_state = 35},
  [1539] = {.lex_state = 3, .external_lex_state = 38},
  [1540] = {.lex_state = 3, .external_lex_state = 35},
  [1541] = {.lex_state = 3, .external_lex_state = 35},
  [1542] = {.lex_state = 3, .external_lex_state = 35},
  [1543] = {.lex_state = 3, .external_lex_state = 38},
  [1544] = {.lex_state = 3, .external_lex_state = 35},
  [1545] = {.lex_state = 3, .external_lex_state = 38},
  [1546] = {.lex_state = 3, .external_lex_state = 35},
  [1547] = {.lex_state = 3, .external_lex_state = 38},
  [1548] = {.lex_state = 3, .external_lex_state = 35},
  [1549] = {.lex_state = 3, .external_lex_state = 35},
  [1550] = {.lex_state = 3, .external_lex_state = 38},
  [1551] = {.lex_state = 3, .external_lex_state = 35},
  [1552] = {.lex_state = 3, .external_lex_state = 35},
  [1553] = {.lex_state = 3, .external_lex_state = 35},
  [1554] = {.lex_state = 3, .external_lex_state = 35},
  [1555] = {.lex_state = 3, .external_lex_state = 35},
  [1556] = {.lex_state = 3, .external_lex_state = 35},
  [1557] = {.lex_state = 3, .external_lex_state = 35},
  [1558] = {.lex_state = 3, .external_lex_state = 38},
  [1559] = {.lex_state = 3, .external_lex_state = 35},
  [1560] = {.lex_state = 3, .external_lex_state = 38},
  [1561] = {.lex_state = 3, .external_lex_state = 35},
  [1562] = {.lex_state = 3, .external_lex_state = 35},
  [1563] = {.lex_state = 8, .external_lex_state = 57},
  [1564] = {.lex_state = 3, .external_lex_state = 35},
  [1565] = {.lex_state = 3, .external_lex_state = 35},
  [1566] = {.lex_state = 3, .external_lex_state = 35},
  [1567] = {.lex_state = 3, .external_lex_state = 35},
  [1568] = {.lex_state = 3, .external_lex_state = 35},
  [1569] = {.lex_state = 3, .external_lex_state = 35},
  [1570] = {.lex_state = 3, .external_lex_state = 38},
  [1571] = {.lex_state = 3, .external_lex_state = 38},
  [1572] = {.lex_state = 3, .external_lex_state = 35},
  [1573] = {.lex_state = 3, .external_lex_state = 35},
  [1574] = {.lex_state = 3, .external_lex_state = 35},
  [1575] = {.lex_state = 3, .external_lex_state = 38},
  [1576] = {.lex_state = 3, .external_lex_state = 35},
  [1577] = {.lex_state = 3, .external_lex_state = 35},
  [1578] = {.lex_state = 3, .external_lex_state = 35},
  [1579] = {.lex_state = 3, .external_lex_state = 35},
  [1580] = {.lex_state = 3, .external_lex_state = 35},
  [1581] = {.lex_state = 3, .external_lex_state = 35},
  [1582] = {.lex_state = 3, .external_lex_state = 35},
  [1583] = {.lex_state = 3, .external_lex_state = 35},
  [1584] = {.lex_state = 3, .external_lex_state = 35},
  [1585] = {.lex_state = 3, .external_lex_state = 35},
  [1586] = {.lex_state = 3, .external_lex_state = 35},
  [1587] = {.lex_state = 3, .external_lex_state = 35},
  [1588] = {.lex_state = 3, .external_lex_state = 35},
  [1589] = {.lex_state = 3, .external_lex_state = 35},
  [1590] = {.lex_state = 3, .external_lex_state = 35},
  [1591] = {.lex_state = 3, .external_lex_state = 35},
  [1592] = {.lex_state = 3, .external_lex_state = 38},
  [1593] = {.lex_state = 3, .external_lex_state = 35},
  [1594] = {.lex_state = 3, .external_lex_state = 35},
  [1595] = {.lex_state = 3, .external_lex_state = 35},
  [1596] = {.lex_state = 3, .external_lex_state = 38},
  [1597] = {.lex_state = 3, .external_lex_state = 35},
  [1598] = {.lex_state = 3, .external_lex_state = 35},
  [1599] = {.lex_state = 3, .external_lex_state = 35},
  [1600] = {.lex_state = 3, .external_lex_state = 35},
  [1601] = {.lex_state = 3, .external_lex_state = 38},
  [1602] = {.lex_state = 3, .external_lex_state = 38},
  [1603] = {.lex_state = 3, .external_lex_state = 38},
  [1604] = {.lex_state = 3, .external_lex_state = 38},
  [1605] = {.lex_state = 3, .external_lex_state = 35},
  [1606] = {.lex_state = 3, .external_lex_state = 35},
  [1607] = {.lex_state = 3, .external_lex_state = 35},
  [1608] = {.lex_state = 3, .external_lex_state = 35},
  [1609] = {.lex_state = 3, .external_lex_state = 38},
  [1610] = {.lex_state = 3, .external_lex_state = 38},
  [1611] = {.lex_state = 3, .external_lex_state = 38},
  [1612] = {.lex_state = 3, .external_lex_state = 35},
  [1613] = {.lex_state = 3, .external_lex_state = 38},
  [1614] = {.lex_state = 3, .external_lex_state = 38},
  [1615] = {.lex_state = 3, .external_lex_state = 38},
  [1616] = {.lex_state = 3, .external_lex_state = 38},
  [1617] = {.lex_state = 3, .external_lex_state = 11},
  [1618] = {.lex_state = 3, .external_lex_state = 38},
  [1619] = {.lex_state = 3, .external_lex_state = 35},
  [1620] = {.lex_state = 3, .external_lex_state = 38},
  [1621] = {.lex_state = 3, .external_lex_state = 38},
  [1622] = {.lex_state = 3, .external_lex_state = 38},
  [1623] = {.lex_state = 3, .external_lex_state = 35},
  [1624] = {.lex_state = 3, .external_lex_state = 38},
  [1625] = {.lex_state = 3, .external_lex_state = 35},
  [1626] = {.lex_state = 3, .external_lex_state = 35},
  [1627] = {.lex_state = 3, .external_lex_state = 35},
  [1628] = {.lex_state = 3, .external_lex_state = 35},
  [1629] = {.lex_state = 8, .external_lex_state = 57},
  [1630] = {.lex_state = 3, .external_lex_state = 35},
  [1631] = {.lex_state = 3, .external_lex_state = 35},
  [1632] = {.lex_state = 3, .external_lex_state = 35},
  [1633] = {.lex_state = 3, .external_lex_state = 35},
  [1634] = {.lex_state = 3, .external_lex_state = 35},
  [1635] = {.lex_state = 3, .external_lex_state = 35},
  [1636] = {.lex_state = 3, .external_lex_state = 35},
  [1637] = {.lex_state = 3, .external_lex_state = 35},
  [1638] = {.lex_state = 3, .external_lex_state = 35},
  [1639] = {.lex_state = 3, .external_lex_state = 38},
  [1640] = {.lex_state = 3, .external_lex_state = 35},
  [1641] = {.lex_state = 3, .external_lex_state = 35},
  [1642] = {.lex_state = 3, .external_lex_state = 35},
  [1643] = {.lex_state = 3, .external_lex_state = 35},
  [1644] = {.lex_state = 3, .external_lex_state = 38},
  [1645] = {.lex_state = 3, .external_lex_state = 38},
  [1646] = {.lex_state = 3, .external_lex_state = 35},
  [1647] = {.lex_state = 3, .external_lex_state = 35},
  [1648] = {.lex_state = 3, .external_lex_state = 35},
  [1649] = {.lex_state = 3, .external_lex_state = 38},
  [1650] = {.lex_state = 3, .external_lex_state = 35},
  [1651] = {.lex_state = 3, .external_lex_state = 35},
  [1652] = {.lex_state = 3, .external_lex_state = 35},
  [1653] = {.lex_state = 3, .external_lex_state = 35},
  [1654] = {.lex_state = 3, .external_lex_state = 35},
  [1655] = {.lex_state = 3, .external_lex_state = 35},
  [1656] = {.lex_state = 3, .external_lex_state = 35},
  [1657] = {.lex_state = 3, .external_lex_state = 38},
  [1658] = {.lex_state = 3, .external_lex_state = 35},
  [1659] = {.lex_state = 3, .external_lex_state = 38},
  [1660] = {.lex_state = 3, .external_lex_state = 35},
  [1661] = {.lex_state = 3, .external_lex_state = 35},
  [1662] = {.lex_state = 3, .external_lex_state = 11},
  [1663] = {.lex_state = 3, .external_lex_state = 35},
  [1664] = {.lex_state = 3, .external_lex_state = 35},
  [1665] = {.lex_state = 3, .external_lex_state = 35},
  [1666] = {.lex_state = 3, .external_lex_state = 35},
  [1667] = {.lex_state = 3, .external_lex_state = 35},
  [1668] = {.lex_state = 3, .external_lex_state = 35},
  [1669] = {.lex_state = 3, .external_lex_state = 35},
  [1670] = {.lex_state = 3, .external_lex_state = 35},
  [1671] = {.lex_state = 3, .external_lex_state = 38},
  [1672] = {.lex_state = 3, .external_lex_state = 38},
  [1673] = {.lex_state = 3, .external_lex_state = 59},
  [1674] = {.lex_state = 3, .external_lex_state = 35},
  [1675] = {.lex_state = 3, .external_lex_state = 35},
  [1676] = {.lex_state = 3, .external_lex_state = 35},
  [1677] = {.lex_state = 3, .external_lex_state = 35},
  [1678] = {.lex_state = 3, .external_lex_state = 38},
  [1679] = {.lex_state = 3, .external_lex_state = 35},
  [1680] = {.lex_state = 3, .external_lex_state = 35},
  [1681] = {.lex_state = 3, .external_lex_state = 35},
  [1682] = {.lex_state = 3, .external_lex_state = 35},
  [1683] = {.lex_state = 3, .external_lex_state = 35},
  [1684] = {.lex_state = 3, .external_lex_state = 35},
  [1685] = {.lex_state = 3, .external_lex_state = 35},
  [1686] = {.lex_state = 3, .external_lex_state = 35},
  [1687] = {.lex_state = 3, .external_lex_state = 35},
  [1688] = {.lex_state = 3, .external_lex_state = 35},
  [1689] = {.lex_state = 3, .external_lex_state = 38},
  [1690] = {.lex_state = 3, .external_lex_state = 38},
  [1691] = {.lex_state = 3, .external_lex_state = 38},
  [1692] = {.lex_state = 3, .external_lex_state = 38},
  [1693] = {.lex_state = 3, .external_lex_state = 35},
  [1694] = {.lex_state = 3, .external_lex_state = 35},
  [1695] = {.lex_state = 3, .external_lex_state = 35},
  [1696] = {.lex_state = 3, .external_lex_state = 35},
  [1697] = {.lex_state = 3, .external_lex_state = 35},
  [1698] = {.lex_state = 3, .external_lex_state = 35},
  [1699] = {.lex_state = 3, .external_lex_state = 35},
  [1700] = {.lex_state = 3, .external_lex_state = 35},
  [1701] = {.lex_state = 3, .external_lex_state = 38},
  [1702] = {.lex_state = 3, .external_lex_state = 35},
  [1703] = {.lex_state = 3, .external_lex_state = 35},
  [1704] = {.lex_state = 3, .external_lex_state = 35},
  [1705] = {.lex_state = 3, .external_lex_state = 35},
  [1706] = {.lex_state = 3, .external_lex_state = 38},
  [1707] = {.lex_state = 3, .external_lex_state = 38},
  [1708] = {.lex_state = 3, .external_lex_state = 35},
  [1709] = {.lex_state = 3, .external_lex_state = 35},
  [1710] = {.lex_state = 3, .external_lex_state = 35},
  [1711] = {.lex_state = 3, .external_lex_state = 35},
  [1712] = {.lex_state = 3, .external_lex_state = 35},
  [1713] = {.lex_state = 3, .external_lex_state = 35},
  [1714] = {.lex_state = 3, .external_lex_state = 35},
  [1715] = {.lex_state = 3, .external_lex_state = 35},
  [1716] = {.lex_state = 3, .external_lex_state = 38},
  [1717] = {.lex_state = 3, .external_lex_state = 35},
  [1718] = {.lex_state = 3, .external_lex_state = 35},
  [1719] = {.lex_state = 3, .external_lex_state = 35},
  [1720] = {.lex_state = 3, .external_lex_state = 35},
  [1721] = {.lex_state = 3, .external_lex_state = 35},
  [1722] = {.lex_state = 3, .external_lex_state = 35},
  [1723] = {.lex_state = 3, .external_lex_state = 35},
  [1724] = {.lex_state = 3, .external_lex_state = 35},
  [1725] = {.lex_state = 3, .external_lex_state = 35},
  [1726] = {.lex_state = 3, .external_lex_state = 38},
  [1727] = {.lex_state = 3, .external_lex_state = 35},
  [1728] = {.lex_state = 3, .external_lex_state = 35},
  [1729] = {.lex_state = 3, .external_lex_state = 35},
  [1730] = {.lex_state = 3, .external_lex_state = 38},
  [1731] = {.lex_state = 3, .external_lex_state = 35},
  [1732] = {.lex_state = 3, .external_lex_state = 35},
  [1733] = {.lex_state = 3, .external_lex_state = 35},
  [1734] = {.lex_state = 3, .external_lex_state = 35},
  [1735] = {.lex_state = 3, .external_lex_state = 35},
  [1736] = {.lex_state = 3, .external_lex_state = 35},
  [1737] = {.lex_state = 3, .external_lex_state = 35},
  [1738] = {.lex_state = 3, .external_lex_state = 35},
  [1739] = {.lex_state = 3, .external_lex_state = 35},
  [1740] = {.lex_state = 3, .external_lex_state = 35},
  [1741] = {.lex_state = 3, .external_lex_state = 35},
  [1742] = {.lex_state = 3, .external_lex_state = 35},
  [1743] = {.lex_state = 3, .external_lex_state = 35},
  [1744] = {.lex_state = 3, .external_lex_state = 35},
  [1745] = {.lex_state = 3, .external_lex_state = 35},
  [1746] = {.lex_state = 3, .external_lex_state = 38},
  [1747] = {.lex_state = 3, .external_lex_state = 38},
  [1748] = {.lex_state = 3, .external_lex_state = 35},
  [1749] = {.lex_state = 3, .external_lex_state = 35},
  [1750] = {.lex_state = 8, .external_lex_state = 58},
  [1751] = {.lex_state = 3, .external_lex_state = 35},
  [1752] = {.lex_state = 3, .external_lex_state = 35},
  [1753] = {.lex_state = 3, .external_lex_state = 35},
  [1754] = {.lex_state = 3, .external_lex_state = 35},
  [1755] = {.lex_state = 3, .external_lex_state = 35},
  [1756] = {.lex_state = 3, .external_lex_state = 35},
  [1757] = {.lex_state = 3, .external_lex_state = 35},
  [1758] = {.lex_state = 3, .external_lex_state = 35},
  [1759] = {.lex_state = 3, .external_lex_state = 35},
  [1760] = {.lex_state = 3, .external_lex_state = 35},
  [1761] = {.lex_state = 3, .external_lex_state = 35},
  [1762] = {.lex_state = 3, .external_lex_state = 38},
  [1763] = {.lex_state = 3, .external_lex_state = 35},
  [1764] = {.lex_state = 3, .external_lex_state = 38},
  [1765] = {.lex_state = 3, .external_lex_state = 35},
  [1766] = {.lex_state = 3, .external_lex_state = 38},
  [1767] = {.lex_state = 8, .external_lex_state = 52},
  [1768] = {.lex_state = 8, .external_lex_state = 52},
  [1769] = {.lex_state = 3, .external_lex_state = 59},
  [1770] = {.lex_state = 3, .external_lex_state = 59},
  [1771] = {.lex_state = 3, .external_lex_state = 59},
  [1772] = {.lex_state = 4, .external_lex_state = 60},
  [1773] = {.lex_state = 8, .external_lex_state = 52},
  [1774] = {.lex_state = 8, .external_lex_state = 52},
  [1775] = {.lex_state = 8, .external_lex_state = 52},
  [1776] = {.lex_state = 8, .external_lex_state = 52},
  [1777] = {.lex_state = 8, .external_lex_state = 52},
  [1778] = {.lex_state = 8, .external_lex_state = 52},
  [1779] = {.lex_state = 3, .external_lex_state = 59},
  [1780] = {.lex_state = 3, .external_lex_state = 9},
  [1781] = {.lex_state = 3, .external_lex_state = 9},
  [1782] = {.lex_state = 3, .external_lex_state = 9},
  [1783] = {.lex_state = 8, .external_lex_state = 52},
  [1784] = {.lex_state = 8, .external_lex_state = 52},
  [1785] = {.lex_state = 8, .external_lex_state = 52},
  [1786] = {.lex_state = 8, .external_lex_state = 52},
  [1787] = {.lex_state = 3, .external_lex_state = 59},
  [1788] = {.lex_state = 8, .external_lex_state = 52},
  [1789] = {.lex_state = 8, .external_lex_state = 52},
  [1790] = {.lex_state = 3, .external_lex_state = 59},
  [1791] = {.lex_state = 3, .external_lex_state = 59},
  [1792] = {.lex_state = 8, .external_lex_state = 52},
  [1793] = {.lex_state = 8, .external_lex_state = 52},
  [1794] = {.lex_state = 8, .external_lex_state = 52},
  [1795] = {.lex_state = 3, .external_lex_state = 59},
  [1796] = {.lex_state = 3, .external_lex_state = 9},
  [1797] = {.lex_state = 4, .external_lex_state = 60},
  [1798] = {.lex_state = 4, .external_lex_state = 60},
  [1799] = {.lex_state = 3, .external_lex_state = 11},
  [1800] = {.lex_state = 3, .external_lex_state = 11},
  [1801] = {.lex_state = 3, .external_lex_state = 11},
  [1802] = {.lex_state = 3, .external_lex_state = 11},
  [1803] = {.lex_state = 4, .external_lex_state = 60},
  [1804] = {.lex_state = 4, .external_lex_state = 60},
  [1805] = {.lex_state = 4, .external_lex_state = 60},
  [1806] = {.lex_state = 8, .external_lex_state = 52},
  [1807] = {.lex_state = 4, .external_lex_state = 60},
  [1808] = {.lex_state = 1, .external_lex_state = 49},
  [1809] = {.lex_state = 4, .external_lex_state = 60},
  [1810] = {.lex_state = 4, .external_lex_state = 60},
  [1811] = {.lex_state = 1, .external_lex_state = 49},
  [1812] = {.lex_state = 8, .external_lex_state = 52},
  [1813] = {.lex_state = 8, .external_lex_state = 52},
  [1814] = {.lex_state = 1, .external_lex_state = 49},
  [1815] = {.lex_state = 1, .external_lex_state = 49},
  [1816] = {.lex_state = 1, .external_lex_state = 49},
  [1817] = {.lex_state = 1, .external_lex_state = 49},
  [1818] = {.lex_state = 8, .external_lex_state = 52},
  [1819] = {.lex_state = 1, .external_lex_state = 49},
  [1820] = {.lex_state = 1, .external_lex_state = 49},
  [1821] = {.lex_state = 8, .external_lex_state = 52},
  [1822] = {.lex_state = 1, .external_lex_state = 49},
  [1823] = {.lex_state = 8, .external_lex_state = 52},
  [1824] = {.lex_state = 4, .external_lex_state = 61},
  [1825] = {.lex_state = 8, .external_lex_state = 52},
  [1826] = {.lex_state = 8, .external_lex_state = 52},
  [1827] = {.lex_state = 8, .external_lex_state = 52},
  [1828] = {.lex_state = 8, .external_lex_state = 52},
  [1829] = {.lex_state = 3, .external_lex_state = 62},
  [1830] = {.lex_state = 3, .external_lex_state = 8},
  [1831] = {.lex_state = 3, .external_lex_state = 62},
  [1832] = {.lex_state = 3, .external_lex_state = 62},
  [1833] = {.lex_state = 3, .external_lex_state = 8},
  [1834] = {.lex_state = 4, .external_lex_state = 60},
  [1835] = {.lex_state = 3, .external_lex_state = 8},
  [1836] = {.lex_state = 3, .external_lex_state = 11},
  [1837] = {.lex_state = 3, .external_lex_state = 11},
  [1838] = {.lex_state = 3, .external_lex_state = 62},
  [1839] = {.lex_state = 3, .external_lex_state = 9},
  [1840] = {.lex_state = 3, .external_lex_state = 9},
  [1841] = {.lex_state = 3, .external_lex_state = 9},
  [1842] = {.lex_state = 4, .external_lex_state = 61},
  [1843] = {.lex_state = 3, .external_lex_state = 9},
  [1844] = {.lex_state = 3, .external_lex_state = 49},
  [1845] = {.lex_state = 3, .external_lex_state = 9},
  [1846] = {.lex_state = 3, .external_lex_state = 9},
  [1847] = {.lex_state = 4, .external_lex_state = 61},
  [1848] = {.lex_state = 3, .external_lex_state = 9},
  [1849] = {.lex_state = 4, .external_lex_state = 61},
  [1850] = {.lex_state = 3, .external_lex_state = 9},
  [1851] = {.lex_state = 3, .external_lex_state = 9},
  [1852] = {.lex_state = 3, .external_lex_state = 9},
  [1853] = {.lex_state = 3, .external_lex_state = 9},
  [1854] = {.lex_state = 3, .external_lex_state = 9},
  [1855] = {.lex_state = 4, .external_lex_state = 61},
  [1856] = {.lex_state = 4, .external_lex_state = 60},
  [1857] = {.lex_state = 4, .external_lex_state = 60},
  [1858] = {.lex_state = 4, .external_lex_state = 60},
  [1859] = {.lex_state = 3, .external_lex_state = 49},
  [1860] = {.lex_state = 4, .external_lex_state = 60},
  [1861] = {.lex_state = 3, .external_lex_state = 9},
  [1862] = {.lex_state = 3, .external_lex_state = 9},
  [1863] = {.lex_state = 3, .external_lex_state = 9},
  [1864] = {.lex_state = 3, .external_lex_state = 9},
  [1865] = {.lex_state = 3, .external_lex_state = 9},
  [1866] = {.lex_state = 3, .external_lex_state = 9},
  [1867] = {.lex_state = 3, .external_lex_state = 9},
  [1868] = {.lex_state = 3, .external_lex_state = 9},
  [1869] = {.lex_state = 3, .external_lex_state = 9},
  [1870] = {.lex_state = 3, .external_lex_state = 9},
  [1871] = {.lex_state = 3, .external_lex_state = 9},
  [1872] = {.lex_state = 3, .external_lex_state = 9},
  [1873] = {.lex_state = 3, .external_lex_state = 63},
  [1874] = {.lex_state = 3, .external_lex_state = 11},
  [1875] = {.lex_state = 3, .external_lex_state = 63},
  [1876] = {.lex_state = 3, .external_lex_state = 49},
  [1877] = {.lex_state = 3, .external_lex_state = 11},
  [1878] = {.lex_state = 3, .external_lex_state = 63},
  [1879] = {.lex_state = 3, .external_lex_state = 63},
  [1880] = {.lex_state = 3, .external_lex_state = 11},
  [1881] = {.lex_state = 3, .external_lex_state = 63},
  [1882] = {.lex_state = 3, .external_lex_state = 11},
  [1883] = {.lex_state = 3, .external_lex_state = 49},
  [1884] = {.lex_state = 3, .external_lex_state = 63},
  [1885] = {.lex_state = 3, .external_lex_state = 63},
  [1886] = {.lex_state = 3, .external_lex_state = 49},
  [1887] = {.lex_state = 3, .external_lex_state = 63},
  [1888] = {.lex_state = 3, .external_lex_state = 63},
  [1889] = {.lex_state = 3, .external_lex_state = 49},
  [1890] = {.lex_state = 3, .external_lex_state = 63},
  [1891] = {.lex_state = 3, .external_lex_state = 64},
  [1892] = {.lex_state = 3, .external_lex_state = 64},
  [1893] = {.lex_state = 3, .external_lex_state = 64},
  [1894] = {.lex_state = 3, .external_lex_state = 64},
  [1895] = {.lex_state = 3, .external_lex_state = 64},
  [1896] = {.lex_state = 3, .external_lex_state = 64},
  [1897] = {.lex_state = 3, .external_lex_state = 64},
  [1898] = {.lex_state = 3, .external_lex_state = 64},
  [1899] = {.lex_state = 3, .external_lex_state = 64},
  [1900] = {.lex_state = 3, .external_lex_state = 64},
  [1901] = {.lex_state = 3, .external_lex_state = 64},
  [1902] = {.lex_state = 3, .external_lex_state = 64},
  [1903] = {.lex_state = 3, .external_lex_state = 64},
  [1904] = {.lex_state = 3, .external_lex_state = 64},
  [1905] = {.lex_state = 3, .external_lex_state = 64},
  [1906] = {.lex_state = 3, .external_lex_state = 64},
  [1907] = {.lex_state = 3, .external_lex_state = 64},
  [1908] = {.lex_state = 3, .external_lex_state = 64},
  [1909] = {.lex_state = 3, .external_lex_state = 64},
  [1910] = {.lex_state = 3, .external_lex_state = 64},
  [1911] = {.lex_state = 3, .external_lex_state = 64},
  [1912] = {.lex_state = 3, .external_lex_state = 64},
  [1913] = {.lex_state = 3, .external_lex_state = 64},
  [1914] = {.lex_state = 3, .external_lex_state = 64},
  [1915] = {.lex_state = 3, .external_lex_state = 64},
  [1916] = {.lex_state = 3, .external_lex_state = 64},
  [1917] = {.lex_state = 3, .external_lex_state = 64},
  [1918] = {.lex_state = 3, .external_lex_state = 64},
  [1919] = {.lex_state = 3, .external_lex_state = 64},
  [1920] = {.lex_state = 3, .external_lex_state = 64},
  [1921] = {.lex_state = 3, .external_lex_state = 64},
  [1922] = {.lex_state = 3, .external_lex_state = 64},
  [1923] = {.lex_state = 3, .external_lex_state = 64},
  [1924] = {.lex_state = 3, .external_lex_state = 64},
  [1925] = {.lex_state = 3, .external_lex_state = 64},
  [1926] = {.lex_state = 3, .external_lex_state = 64},
  [1927] = {.lex_state = 3, .external_lex_state = 64},
  [1928] = {.lex_state = 3, .external_lex_state = 64},
  [1929] = {.lex_state = 3, .external_lex_state = 64},
  [1930] = {.lex_state = 3, .external_lex_state = 64},
  [1931] = {.lex_state = 3, .external_lex_state = 64},
  [1932] = {.lex_state = 3, .external_lex_state = 64},
  [1933] = {.lex_state = 3, .external_lex_state = 64},
  [1934] = {.lex_state = 3, .external_lex_state = 64},
  [1935] = {.lex_state = 3, .external_lex_state = 64},
  [1936] = {.lex_state = 3, .external_lex_state = 64},
  [1937] = {.lex_state = 3, .external_lex_state = 64},
  [1938] = {.lex_state = 3, .external_lex_state = 64},
  [1939] = {.lex_state = 3, .external_lex_state = 64},
  [1940] = {.lex_state = 3, .external_lex_state = 64},
  [1941] = {.lex_state = 3, .external_lex_state = 64},
  [1942] = {.lex_state = 3, .external_lex_state = 64},
  [1943] = {.lex_state = 3, .external_lex_state = 64},
  [1944] = {.lex_state = 3, .external_lex_state = 64},
  [1945] = {.lex_state = 3, .external_lex_state = 64},
  [1946] = {.lex_state = 3, .external_lex_state = 64},
  [1947] = {.lex_state = 3, .external_lex_state = 64},
  [1948] = {.lex_state = 3, .external_lex_state = 64},
  [1949] = {.lex_state = 3, .external_lex_state = 64},
  [1950] = {.lex_state = 3, .external_lex_state = 64},
  [1951] = {.lex_state = 3, .external_lex_state = 11},
  [1952] = {.lex_state = 3, .external_lex_state = 11},
  [1953] = {.lex_state = 3, .external_lex_state = 11},
  [1954] = {.lex_state = 3, .external_lex_state = 11},
  [1955] = {.lex_state = 3, .external_lex_state = 64},
  [1956] = {.lex_state = 3, .external_lex_state = 64},
  [1957] = {.lex_state = 3, .external_lex_state = 64},
  [1958] = {.lex_state = 3, .external_lex_state = 64},
  [1959] = {.lex_state = 3, .external_lex_state = 64},
  [1960] = {.lex_state = 3, .external_lex_state = 64},
  [1961] = {.lex_state = 3, .external_lex_state = 64},
  [1962] = {.lex_state = 3, .external_lex_state = 64},
  [1963] = {.lex_state = 3, .external_lex_state = 64},
  [1964] = {.lex_state = 3, .external_lex_state = 64},
  [1965] = {.lex_state = 3, .external_lex_state = 64},
  [1966] = {.lex_state = 3, .external_lex_state = 64},
  [1967] = {.lex_state = 3, .external_lex_state = 64},
  [1968] = {.lex_state = 3, .external_lex_state = 64},
  [1969] = {.lex_state = 3, .external_lex_state = 64},
  [1970] = {.lex_state = 3, .external_lex_state = 64},
  [1971] = {.lex_state = 3, .external_lex_state = 64},
  [1972] = {.lex_state = 3, .external_lex_state = 64},
  [1973] = {.lex_state = 3, .external_lex_state = 64},
  [1974] = {.lex_state = 3, .external_lex_state = 64},
  [1975] = {.lex_state = 3, .external_lex_state = 64},
  [1976] = {.lex_state = 3, .external_lex_state = 64},
  [1977] = {.lex_state = 3, .external_lex_state = 64},
  [1978] = {.lex_state = 3, .external_lex_state = 64},
  [1979] = {.lex_state = 3, .external_lex_state = 64},
  [1980] = {.lex_state = 3, .external_lex_state = 64},
  [1981] = {.lex_state = 3, .external_lex_state = 62},
  [1982] = {.lex_state = 3, .external_lex_state = 64},
  [1983] = {.lex_state = 3, .external_lex_state = 64},
  [1984] = {.lex_state = 3, .external_lex_state = 64},
  [1985] = {.lex_state = 3, .external_lex_state = 64},
  [1986] = {.lex_state = 3, .external_lex_state = 64},
  [1987] = {.lex_state = 3, .external_lex_state = 64},
  [1988] = {.lex_state = 3, .external_lex_state = 64},
  [1989] = {.lex_state = 3, .external_lex_state = 64},
  [1990] = {.lex_state = 3, .external_lex_state = 64},
  [1991] = {.lex_state = 3, .external_lex_state = 64},
  [1992] = {.lex_state = 4, .external_lex_state = 65},
  [1993] = {.lex_state = 3, .external_lex_state = 62},
  [1994] = {.lex_state = 3, .external_lex_state = 8},
  [1995] = {.lex_state = 3, .external_lex_state = 64},
  [1996] = {.lex_state = 3, .external_lex_state = 64},
  [1997] = {.lex_state = 3, .external_lex_state = 64},
  [1998] = {.lex_state = 3, .external_lex_state = 64},
  [1999] = {.lex_state = 3, .external_lex_state = 64},
  [2000] = {.lex_state = 3, .external_lex_state = 64},
  [2001] = {.lex_state = 3, .external_lex_state = 64},
  [2002] = {.lex_state = 4, .external_lex_state = 65},
  [2003] = {.lex_state = 3, .external_lex_state = 64},
  [2004] = {.lex_state = 3, .external_lex_state = 64},
  [2005] = {.lex_state = 3, .external_lex_state = 64},
  [2006] = {.lex_state = 3, .external_lex_state = 64},
  [2007] = {.lex_state = 3, .external_lex_state = 64},
  [2008] = {.lex_state = 3, .external_lex_state = 64},
  [2009] = {.lex_state = 3, .external_lex_state = 64},
  [2010] = {.lex_state = 3, .external_lex_state = 64},
  [2011] = {.lex_state = 3, .external_lex_state = 64},
  [2012] = {.lex_state = 3, .external_lex_state = 64},
  [2013] = {.lex_state = 3, .external_lex_state = 64},
  [2014] = {.lex_state = 3, .external_lex_state = 64},
  [2015] = {.lex_state = 3, .external_lex_state = 64},
  [2016] = {.lex_state = 3, .external_lex_state = 64},
  [2017] = {.lex_state = 3, .external_lex_state = 64},
  [2018] = {.lex_state = 3, .external_lex_state = 64},
  [2019] = {.lex_state = 3, .external_lex_state = 64},
  [2020] = {.lex_state = 3, .external_lex_state = 9},
  [2021] = {.lex_state = 3, .external_lex_state = 8},
  [2022] = {.lex_state = 3, .external_lex_state = 8},
  [2023] = {.lex_state = 3, .external_lex_state = 8},
  [2024] = {.lex_state = 3, .external_lex_state = 66},
  [2025] = {.lex_state = 3, .external_lex_state = 8},
  [2026] = {.lex_state = 3, .external_lex_state = 9},
  [2027] = {.lex_state = 3, .external_lex_state = 67},
  [2028] = {.lex_state = 3, .external_lex_state = 67},
  [2029] = {.lex_state = 3, .external_lex_state = 67},
  [2030] = {.lex_state = 3, .external_lex_state = 8},
  [2031] = {.lex_state = 3, .external_lex_state = 67},
  [2032] = {.lex_state = 3, .external_lex_state = 67},
  [2033] = {.lex_state = 3, .external_lex_state = 67},
  [2034] = {.lex_state = 3, .external_lex_state = 8},
  [2035] = {.lex_state = 3, .external_lex_state = 66},
  [2036] = {.lex_state = 3, .external_lex_state = 66},
  [2037] = {.lex_state = 3, .external_lex_state = 8},
  [2038] = {.lex_state = 3, .external_lex_state = 67},
  [2039] = {.lex_state = 3, .external_lex_state = 67},
  [2040] = {.lex_state = 3, .external_lex_state = 9},
  [2041] = {.lex_state = 3, .external_lex_state = 67},
  [2042] = {.lex_state = 3, .external_lex_state = 66},
  [2043] = {.lex_state = 3, .external_lex_state = 8},
  [2044] = {.lex_state = 3, .external_lex_state = 9},
  [2045] = {.lex_state = 3, .external_lex_state = 8},
  [2046] = {.lex_state = 3, .external_lex_state = 8},
  [2047] = {.lex_state = 3, .external_lex_state = 67},
  [2048] = {.lex_state = 3, .external_lex_state = 67},
  [2049] = {.lex_state = 3, .external_lex_state = 9},
  [2050] = {.lex_state = 3, .external_lex_state = 9},
  [2051] = {.lex_state = 3, .external_lex_state = 9},
  [2052] = {.lex_state = 3, .external_lex_state = 9},
  [2053] = {.lex_state = 3, .external_lex_state = 9},
  [2054] = {.lex_state = 3, .external_lex_state = 9},
  [2055] = {.lex_state = 3, .external_lex_state = 9},
  [2056] = {.lex_state = 3, .external_lex_state = 9},
  [2057] = {.lex_state = 3, .external_lex_state = 9},
  [2058] = {.lex_state = 3, .external_lex_state = 67},
  [2059] = {.lex_state = 3, .external_lex_state = 9},
  [2060] = {.lex_state = 3, .external_lex_state = 9},
  [2061] = {.lex_state = 3, .external_lex_state = 9},
  [2062] = {.lex_state = 3, .external_lex_state = 9},
  [2063] = {.lex_state = 3, .external_lex_state = 9},
  [2064] = {.lex_state = 3, .external_lex_state = 9},
  [2065] = {.lex_state = 3, .external_lex_state = 9},
  [2066] = {.lex_state = 3, .external_lex_state = 67},
  [2067] = {.lex_state = 3, .external_lex_state = 9},
  [2068] = {.lex_state = 3, .external_lex_state = 9},
  [2069] = {.lex_state = 3, .external_lex_state = 9},
  [2070] = {.lex_state = 3, .external_lex_state = 9},
  [2071] = {.lex_state = 3, .external_lex_state = 9},
  [2072] = {.lex_state = 3, .external_lex_state = 9},
  [2073] = {.lex_state = 3, .external_lex_state = 9},
  [2074] = {.lex_state = 3, .external_lex_state = 9},
  [2075] = {.lex_state = 3, .external_lex_state = 9},
  [2076] = {.lex_state = 3, .external_lex_state = 67},
  [2077] = {.lex_state = 3, .external_lex_state = 67},
  [2078] = {.lex_state = 3, .external_lex_state = 9},
  [2079] = {.lex_state = 3, .external_lex_state = 9},
  [2080] = {.lex_state = 3, .external_lex_state = 67},
  [2081] = {.lex_state = 3, .external_lex_state = 9},
  [2082] = {.lex_state = 3, .external_lex_state = 9},
  [2083] = {.lex_state = 3, .external_lex_state = 9},
  [2084] = {.lex_state = 3, .external_lex_state = 9},
  [2085] = {.lex_state = 3, .external_lex_state = 67},
  [2086] = {.lex_state = 3, .external_lex_state = 9},
  [2087] = {.lex_state = 3, .external_lex_state = 9},
  [2088] = {.lex_state = 3, .external_lex_state = 67},
  [2089] = {.lex_state = 3, .external_lex_state = 67},
  [2090] = {.lex_state = 3, .external_lex_state = 9},
  [2091] = {.lex_state = 3, .external_lex_state = 67},
  [2092] = {.lex_state = 3, .external_lex_state = 67},
  [2093] = {.lex_state = 3, .external_lex_state = 67},
  [2094] = {.lex_state = 3, .external_lex_state = 9},
  [2095] = {.lex_state = 3, .external_lex_state = 67},
  [2096] = {.lex_state = 3, .external_lex_state = 9},
  [2097] = {.lex_state = 3, .external_lex_state = 9},
  [2098] = {.lex_state = 3, .external_lex_state = 9},
  [2099] = {.lex_state = 3, .external_lex_state = 9},
  [2100] = {.lex_state = 3, .external_lex_state = 67},
  [2101] = {.lex_state = 3, .external_lex_state = 67},
  [2102] = {.lex_state = 3, .external_lex_state = 9},
  [2103] = {.lex_state = 3, .external_lex_state = 11},
  [2104] = {.lex_state = 3, .external_lex_state = 9},
  [2105] = {.lex_state = 3, .external_lex_state = 9},
  [2106] = {.lex_state = 3, .external_lex_state = 67},
  [2107] = {.lex_state = 3, .external_lex_state = 67},
  [2108] = {.lex_state = 3, .external_lex_state = 11},
  [2109] = {.lex_state = 3, .external_lex_state = 67},
  [2110] = {.lex_state = 3, .external_lex_state = 67},
  [2111] = {.lex_state = 3, .external_lex_state = 9},
  [2112] = {.lex_state = 3, .external_lex_state = 67},
  [2113] = {.lex_state = 3, .external_lex_state = 67},
  [2114] = {.lex_state = 3, .external_lex_state = 67},
  [2115] = {.lex_state = 3, .external_lex_state = 9},
  [2116] = {.lex_state = 3, .external_lex_state = 67},
  [2117] = {.lex_state = 3, .external_lex_state = 67},
  [2118] = {.lex_state = 3, .external_lex_state = 11},
  [2119] = {.lex_state = 3, .external_lex_state = 67},
  [2120] = {.lex_state = 3, .external_lex_state = 67},
  [2121] = {.lex_state = 3, .external_lex_state = 9},
  [2122] = {.lex_state = 3, .external_lex_state = 68},
  [2123] = {.lex_state = 3, .external_lex_state = 9},
  [2124] = {.lex_state = 3, .external_lex_state = 9},
  [2125] = {.lex_state = 3, .external_lex_state = 9},
  [2126] = {.lex_state = 3, .external_lex_state = 9},
  [2127] = {.lex_state = 3, .external_lex_state = 9},
  [2128] = {.lex_state = 3, .external_lex_state = 67},
  [2129] = {.lex_state = 3, .external_lex_state = 9},
  [2130] = {.lex_state = 3, .external_lex_state = 67},
  [2131] = {.lex_state = 3, .external_lex_state = 9},
  [2132] = {.lex_state = 3, .external_lex_state = 9},
  [2133] = {.lex_state = 3, .external_lex_state = 9},
  [2134] = {.lex_state = 3, .external_lex_state = 9},
  [2135] = {.lex_state = 3, .external_lex_state = 9},
  [2136] = {.lex_state = 3, .external_lex_state = 9},
  [2137] = {.lex_state = 3, .external_lex_state = 11},
  [2138] = {.lex_state = 3, .external_lex_state = 68},
  [2139] = {.lex_state = 3, .external_lex_state = 9},
  [2140] = {.lex_state = 3, .external_lex_state = 9},
  [2141] = {.lex_state = 3, .external_lex_state = 9},
  [2142] = {.lex_state = 3, .external_lex_state = 9},
  [2143] = {.lex_state = 3, .external_lex_state = 69},
  [2144] = {.lex_state = 3, .external_lex_state = 9},
  [2145] = {.lex_state = 3, .external_lex_state = 69},
  [2146] = {.lex_state = 3, .external_lex_state = 11},
  [2147] = {.lex_state = 3, .external_lex_state = 69},
  [2148] = {.lex_state = 3, .external_lex_state = 9},
  [2149] = {.lex_state = 3, .external_lex_state = 9},
  [2150] = {.lex_state = 3, .external_lex_state = 9},
  [2151] = {.lex_state = 3, .external_lex_state = 9},
  [2152] = {.lex_state = 3, .external_lex_state = 9},
  [2153] = {.lex_state = 3, .external_lex_state = 9},
  [2154] = {.lex_state = 3, .external_lex_state = 68},
  [2155] = {.lex_state = 3, .external_lex_state = 68},
  [2156] = {.lex_state = 3, .external_lex_state = 9},
  [2157] = {.lex_state = 3, .external_lex_state = 9},
  [2158] = {.lex_state = 3, .external_lex_state = 9},
  [2159] = {.lex_state = 3, .external_lex_state = 9},
  [2160] = {.lex_state = 3, .external_lex_state = 9},
  [2161] = {.lex_state = 3, .external_lex_state = 9},
  [2162] = {.lex_state = 3, .external_lex_state = 9},
  [2163] = {.lex_state = 3, .external_lex_state = 69},
  [2164] = {.lex_state = 3, .external_lex_state = 9},
  [2165] = {.lex_state = 3, .external_lex_state = 9},
  [2166] = {.lex_state = 3, .external_lex_state = 9},
  [2167] = {.lex_state = 3, .external_lex_state = 9},
  [2168] = {.lex_state = 3, .external_lex_state = 9},
  [2169] = {.lex_state = 3, .external_lex_state = 9},
  [2170] = {.lex_state = 3, .external_lex_state = 9},
  [2171] = {.lex_state = 3, .external_lex_state = 9},
  [2172] = {.lex_state = 3, .external_lex_state = 9},
  [2173] = {.lex_state = 3, .external_lex_state = 11},
  [2174] = {.lex_state = 3, .external_lex_state = 70},
  [2175] = {.lex_state = 3, .external_lex_state = 70},
  [2176] = {.lex_state = 3, .external_lex_state = 11},
  [2177] = {.lex_state = 3, .external_lex_state = 11},
  [2178] = {.lex_state = 3, .external_lex_state = 11},
  [2179] = {.lex_state = 3, .external_lex_state = 11},
  [2180] = {.lex_state = 3, .external_lex_state = 11},
  [2181] = {.lex_state = 3, .external_lex_state = 69},
  [2182] = {.lex_state = 3, .external_lex_state = 11},
  [2183] = {.lex_state = 3, .external_lex_state = 11},
  [2184] = {.lex_state = 3, .external_lex_state = 11},
  [2185] = {.lex_state = 3, .external_lex_state = 69},
  [2186] = {.lex_state = 3, .external_lex_state = 11},
  [2187] = {.lex_state = 3, .external_lex_state = 70},
  [2188] = {.lex_state = 3, .external_lex_state = 70},
  [2189] = {.lex_state = 3, .external_lex_state = 70},
  [2190] = {.lex_state = 3, .external_lex_state = 11},
  [2191] = {.lex_state = 3, .external_lex_state = 11},
  [2192] = {.lex_state = 3, .external_lex_state = 11},
  [2193] = {.lex_state = 3, .external_lex_state = 11},
  [2194] = {.lex_state = 3, .external_lex_state = 71},
  [2195] = {.lex_state = 3, .external_lex_state = 11},
  [2196] = {.lex_state = 3, .external_lex_state = 71},
  [2197] = {.lex_state = 3, .external_lex_state = 66},
  [2198] = {.lex_state = 3, .external_lex_state = 11},
  [2199] = {.lex_state = 3, .external_lex_state = 11},
  [2200] = {.lex_state = 3, .external_lex_state = 11},
  [2201] = {.lex_state = 3, .external_lex_state = 71},
  [2202] = {.lex_state = 3, .external_lex_state = 11},
  [2203] = {.lex_state = 3, .external_lex_state = 66},
  [2204] = {.lex_state = 3, .external_lex_state = 11},
  [2205] = {.lex_state = 3, .external_lex_state = 11},
  [2206] = {.lex_state = 3, .external_lex_state = 71},
  [2207] = {.lex_state = 3, .external_lex_state = 11},
  [2208] = {.lex_state = 3, .external_lex_state = 11},
  [2209] = {.lex_state = 3, .external_lex_state = 11},
  [2210] = {.lex_state = 3, .external_lex_state = 11},
  [2211] = {.lex_state = 3, .external_lex_state = 71},
  [2212] = {.lex_state = 3, .external_lex_state = 11},
  [2213] = {.lex_state = 3, .external_lex_state = 11},
  [2214] = {.lex_state = 3, .external_lex_state = 71},
  [2215] = {.lex_state = 3, .external_lex_state = 11},
  [2216] = {.lex_state = 3, .external_lex_state = 11},
  [2217] = {.lex_state = 3, .external_lex_state = 11},
  [2218] = {.lex_state = 3, .external_lex_state = 11},
  [2219] = {.lex_state = 3, .external_lex_state = 70},
  [2220] = {.lex_state = 3, .external_lex_state = 11},
  [2221] = {.lex_state = 3, .external_lex_state = 70},
  [2222] = {.lex_state = 3, .external_lex_state = 11},
  [2223] = {.lex_state = 3, .external_lex_state = 11},
  [2224] = {.lex_state = 3, .external_lex_state = 11},
  [2225] = {.lex_state = 3, .external_lex_state = 18},
  [2226] = {.lex_state = 3, .external_lex_state = 11},
  [2227] = {.lex_state = 3, .external_lex_state = 18},
  [2228] = {.lex_state = 3, .external_lex_state = 18},
  [2229] = {.lex_state = 3, .external_lex_state = 18},
  [2230] = {.lex_state = 3, .external_lex_state = 18},
  [2231] = {.lex_state = 3, .external_lex_state = 18},
  [2232] = {.lex_state = 3, .external_lex_state = 18},
  [2233] = {.lex_state = 3, .external_lex_state = 18},
  [2234] = {.lex_state = 3, .external_lex_state = 70},
  [2235] = {.lex_state = 3, .external_lex_state = 18},
  [2236] = {.lex_state = 3, .external_lex_state = 72},
  [2237] = {.lex_state = 3, .external_lex_state = 72},
  [2238] = {.lex_state = 1, .external_lex_state = 70},
  [2239] = {.lex_state = 1, .external_lex_state = 70},
  [2240] = {.lex_state = 1, .external_lex_state = 70},
  [2241] = {.lex_state = 3, .external_lex_state = 72},
  [2242] = {.lex_state = 3, .external_lex_state = 72},
  [2243] = {.lex_state = 3, .external_lex_state = 72},
  [2244] = {.lex_state = 3, .external_lex_state = 72},
  [2245] = {.lex_state = 3, .external_lex_state = 70},
  [2246] = {.lex_state = 3, .external_lex_state = 72},
  [2247] = {.lex_state = 1, .external_lex_state = 70},
  [2248] = {.lex_state = 3, .external_lex_state = 72},
  [2249] = {.lex_state = 3, .external_lex_state = 72},
  [2250] = {.lex_state = 1, .external_lex_state = 70},
  [2251] = {.lex_state = 3, .external_lex_state = 11},
  [2252] = {.lex_state = 3, .external_lex_state = 11},
  [2253] = {.lex_state = 3, .external_lex_state = 11},
  [2254] = {.lex_state = 3, .external_lex_state = 11},
  [2255] = {.lex_state = 3, .external_lex_state = 11},
  [2256] = {.lex_state = 3, .external_lex_state = 11},
  [2257] = {.lex_state = 3, .external_lex_state = 11},
  [2258] = {.lex_state = 3, .external_lex_state = 11},
  [2259] = {.lex_state = 3, .external_lex_state = 11},
  [2260] = {.lex_state = 3, .external_lex_state = 11},
  [2261] = {.lex_state = 3, .external_lex_state = 11},
  [2262] = {.lex_state = 3, .external_lex_state = 11},
  [2263] = {.lex_state = 3, .external_lex_state = 11},
  [2264] = {.lex_state = 3, .external_lex_state = 11},
  [2265] = {.lex_state = 3, .external_lex_state = 11},
  [2266] = {.lex_state = 3, .external_lex_state = 11},
  [2267] = {.lex_state = 3, .external_lex_state = 11},
  [2268] = {.lex_state = 3, .external_lex_state = 11},
  [2269] = {.lex_state = 3, .external_lex_state = 11},
  [2270] = {.lex_state = 3, .external_lex_state = 11},
  [2271] = {.lex_state = 3, .external_lex_state = 11},
  [2272] = {.lex_state = 3, .external_lex_state = 11},
  [2273] = {.lex_state = 3, .external_lex_state = 11},
  [2274] = {.lex_state = 3, .external_lex_state = 11},
  [2275] = {.lex_state = 3, .external_lex_state = 11},
  [2276] = {.lex_state = 3, .external_lex_state = 11},
  [2277] = {.lex_state = 3, .external_lex_state = 11},
  [2278] = {.lex_state = 3, .external_lex_state = 11},
  [2279] = {.lex_state = 4, .external_lex_state = 73},
  [2280] = {.lex_state = 3, .external_lex_state = 11},
  [2281] = {.lex_state = 3, .external_lex_state = 11},
  [2282] = {.lex_state = 3, .external_lex_state = 11},
  [2283] = {.lex_state = 3, .external_lex_state = 11},
  [2284] = {.lex_state = 3, .external_lex_state = 11},
  [2285] = {.lex_state = 3, .external_lex_state = 11},
  [2286] = {.lex_state = 3, .external_lex_state = 11},
  [2287] = {.lex_state = 3, .external_lex_state = 11},
  [2288] = {.lex_state = 3, .external_lex_state = 11},
  [2289] = {.lex_state = 3, .external_lex_state = 11},
  [2290] = {.lex_state = 3, .external_lex_state = 11},
  [2291] = {.lex_state = 3, .external_lex_state = 11},
  [2292] = {.lex_state = 3, .external_lex_state = 11},
  [2293] = {.lex_state = 3, .external_lex_state = 11},
  [2294] = {.lex_state = 3, .external_lex_state = 11},
  [2295] = {.lex_state = 3, .external_lex_state = 11},
  [2296] = {.lex_state = 3, .external_lex_state = 11},
  [2297] = {.lex_state = 3, .external_lex_state = 11},
  [2298] = {.lex_state = 3, .external_lex_state = 11},
  [2299] = {.lex_state = 3, .external_lex_state = 11},
  [2300] = {.lex_state = 3, .external_lex_state = 11},
  [2301] = {.lex_state = 3, .external_lex_state = 11},
  [2302] = {.lex_state = 3, .external_lex_state = 18},
  [2303] = {.lex_state = 3, .external_lex_state = 18},
  [2304] = {.lex_state = 3, .external_lex_state = 74},
  [2305] = {.lex_state = 3, .external_lex_state = 18},
  [2306] = {.lex_state = 3, .external_lex_state = 18},
  [2307] = {.lex_state = 3, .external_lex_state = 18},
  [2308] = {.lex_state = 3, .external_lex_state = 18},
  [2309] = {.lex_state = 3, .external_lex_state = 18},
  [2310] = {.lex_state = 3, .external_lex_state = 18},
  [2311] = {.lex_state = 3, .external_lex_state = 18},
  [2312] = {.lex_state = 3, .external_lex_state = 18},
  [2313] = {.lex_state = 3, .external_lex_state = 18},
  [2314] = {.lex_state = 3, .external_lex_state = 18},
  [2315] = {.lex_state = 3, .external_lex_state = 18},
  [2316] = {.lex_state = 3, .external_lex_state = 18},
  [2317] = {.lex_state = 4, .external_lex_state = 75},
  [2318] = {.lex_state = 3, .external_lex_state = 18},
  [2319] = {.lex_state = 3, .external_lex_state = 18},
  [2320] = {.lex_state = 3, .external_lex_state = 18},
  [2321] = {.lex_state = 3, .external_lex_state = 18},
  [2322] = {.lex_state = 3, .external_lex_state = 18},
  [2323] = {.lex_state = 3, .external_lex_state = 18},
  [2324] = {.lex_state = 3, .external_lex_state = 18},
  [2325] = {.lex_state = 3, .external_lex_state = 18},
  [2326] = {.lex_state = 3, .external_lex_state = 18},
  [2327] = {.lex_state = 3, .external_lex_state = 18},
  [2328] = {.lex_state = 3, .external_lex_state = 18},
  [2329] = {.lex_state = 3, .external_lex_state = 38},
  [2330] = {.lex_state = 3, .external_lex_state = 38},
  [2331] = {.lex_state = 3, .external_lex_state = 18},
  [2332] = {.lex_state = 3, .external_lex_state = 18},
  [2333] = {.lex_state = 3, .external_lex_state = 18},
  [2334] = {.lex_state = 3, .external_lex_state = 18},
  [2335] = {.lex_state = 3, .external_lex_state = 18},
  [2336] = {.lex_state = 3, .external_lex_state = 18},
  [2337] = {.lex_state = 3, .external_lex_state = 18},
  [2338] = {.lex_state = 3, .external_lex_state = 18},
  [2339] = {.lex_state = 3, .external_lex_state = 18},
  [2340] = {.lex_state = 3, .external_lex_state = 18},
  [2341] = {.lex_state = 3, .external_lex_state = 18},
  [2342] = {.lex_state = 3, .external_lex_state = 18},
  [2343] = {.lex_state = 3, .external_lex_state = 18},
  [2344] = {.lex_state = 3, .external_lex_state = 18},
  [2345] = {.lex_state = 3, .external_lex_state = 18},
  [2346] = {.lex_state = 3, .external_lex_state = 18},
  [2347] = {.lex_state = 3, .external_lex_state = 18},
  [2348] = {.lex_state = 3, .external_lex_state = 18},
  [2349] = {.lex_state = 3, .external_lex_state = 18},
  [2350] = {.lex_state = 3, .external_lex_state = 18},
  [2351] = {.lex_state = 3, .external_lex_state = 18},
  [2352] = {.lex_state = 3, .external_lex_state = 18},
  [2353] = {.lex_state = 3, .external_lex_state = 18},
  [2354] = {.lex_state = 3, .external_lex_state = 18},
  [2355] = {.lex_state = 3, .external_lex_state = 18},
  [2356] = {.lex_state = 3, .external_lex_state = 74},
  [2357] = {.lex_state = 3, .external_lex_state = 74},
  [2358] = {.lex_state = 3, .external_lex_state = 18},
  [2359] = {.lex_state = 3, .external_lex_state = 18},
  [2360] = {.lex_state = 3, .external_lex_state = 76},
  [2361] = {.lex_state = 3, .external_lex_state = 76},
  [2362] = {.lex_state = 4, .external_lex_state = 20},
  [2363] = {.lex_state = 3, .external_lex_state = 76},
  [2364] = {.lex_state = 4, .external_lex_state = 20},
  [2365] = {.lex_state = 3, .external_lex_state = 76},
  [2366] = {.lex_state = 3, .external_lex_state = 76},
  [2367] = {.lex_state = 4, .external_lex_state = 20},
  [2368] = {.lex_state = 4, .external_lex_state = 20},
  [2369] = {.lex_state = 4, .external_lex_state = 20},
  [2370] = {.lex_state = 4, .external_lex_state = 20},
  [2371] = {.lex_state = 4, .external_lex_state = 20},
  [2372] = {.lex_state = 3, .external_lex_state = 76},
  [2373] = {.lex_state = 4, .external_lex_state = 20},
  [2374] = {.lex_state = 3, .external_lex_state = 76},
  [2375] = {.lex_state = 3, .external_lex_state = 76},
  [2376] = {.lex_state = 4, .external_lex_state = 20},
  [2377] = {.lex_state = 3, .external_lex_state = 76},
  [2378] = {.lex_state = 4, .external_lex_state = 77},
  [2379] = {.lex_state = 4, .external_lex_state = 77},
  [2380] = {.lex_state = 4, .external_lex_state = 77},
  [2381] = {.lex_state = 3, .external_lex_state = 18},
  [2382] = {.lex_state = 4, .external_lex_state = 77},
  [2383] = {.lex_state = 3, .external_lex_state = 18},
  [2384] = {.lex_state = 4, .external_lex_state = 77},
  [2385] = {.lex_state = 4, .external_lex_state = 77},
  [2386] = {.lex_state = 3, .external_lex_state = 18},
  [2387] = {.lex_state = 3, .external_lex_state = 18},
  [2388] = {.lex_state = 4, .external_lex_state = 77},
  [2389] = {.lex_state = 4, .external_lex_state = 77},
  [2390] = {.lex_state = 3, .external_lex_state = 18},
  [2391] = {.lex_state = 3, .external_lex_state = 18},
  [2392] = {.lex_state = 4, .external_lex_state = 77},
  [2393] = {.lex_state = 3, .external_lex_state = 38},
  [2394] = {.lex_state = 3, .external_lex_state = 38},
  [2395] = {.lex_state = 3, .external_lex_state = 38},
  [2396] = {.lex_state = 3, .external_lex_state = 38},
  [2397] = {.lex_state = 3, .external_lex_state = 38},
  [2398] = {.lex_state = 3, .external_lex_state = 38},
  [2399] = {.lex_state = 3, .external_lex_state = 38},
  [2400] = {.lex_state = 3, .external_lex_state = 38},
  [2401] = {.lex_state = 3, .external_lex_state = 38},
  [2402] = {.lex_state = 3, .external_lex_state = 38},
  [2403] = {.lex_state = 3, .external_lex_state = 38},
  [2404] = {.lex_state = 3, .external_lex_state = 38},
  [2405] = {.lex_state = 3, .external_lex_state = 38},
  [2406] = {.lex_state = 3, .external_lex_state = 38},
  [2407] = {.lex_state = 3, .external_lex_state = 38},
  [2408] = {.lex_state = 3, .external_lex_state = 38},
  [2409] = {.lex_state = 3, .external_lex_state = 38},
  [2410] = {.lex_state = 3, .external_lex_state = 38},
  [2411] = {.lex_state = 3, .external_lex_state = 38},
  [2412] = {.lex_state = 3, .external_lex_state = 38},
  [2413] = {.lex_state = 3, .external_lex_state = 38},
  [2414] = {.lex_state = 3, .external_lex_state = 38},
  [2415] = {.lex_state = 3, .external_lex_state = 38},
  [2416] = {.lex_state = 3, .external_lex_state = 38},
  [2417] = {.lex_state = 3, .external_lex_state = 38},
  [2418] = {.lex_state = 3, .external_lex_state = 21},
  [2419] = {.lex_state = 3, .external_lex_state = 38},
  [2420] = {.lex_state = 3, .external_lex_state = 38},
  [2421] = {.lex_state = 3, .external_lex_state = 38},
  [2422] = {.lex_state = 3, .external_lex_state = 38},
  [2423] = {.lex_state = 3, .external_lex_state = 38},
  [2424] = {.lex_state = 3, .external_lex_state = 38},
  [2425] = {.lex_state = 3, .external_lex_state = 38},
  [2426] = {.lex_state = 3, .external_lex_state = 38},
  [2427] = {.lex_state = 3, .external_lex_state = 38},
  [2428] = {.lex_state = 3, .external_lex_state = 38},
  [2429] = {.lex_state = 3, .external_lex_state = 38},
  [2430] = {.lex_state = 3, .external_lex_state = 38},
  [2431] = {.lex_state = 3, .external_lex_state = 38},
  [2432] = {.lex_state = 3, .external_lex_state = 38},
  [2433] = {.lex_state = 3, .external_lex_state = 38},
  [2434] = {.lex_state = 3, .external_lex_state = 38},
  [2435] = {.lex_state = 3, .external_lex_state = 38},
  [2436] = {.lex_state = 3, .external_lex_state = 38},
  [2437] = {.lex_state = 3, .external_lex_state = 38},
  [2438] = {.lex_state = 3, .external_lex_state = 38},
  [2439] = {.lex_state = 3, .external_lex_state = 38},
  [2440] = {.lex_state = 3, .external_lex_state = 38},
  [2441] = {.lex_state = 3, .external_lex_state = 38},
  [2442] = {.lex_state = 3, .external_lex_state = 38},
  [2443] = {.lex_state = 3, .external_lex_state = 38},
  [2444] = {.lex_state = 3, .external_lex_state = 38},
  [2445] = {.lex_state = 3, .external_lex_state = 38},
  [2446] = {.lex_state = 3, .external_lex_state = 38},
  [2447] = {.lex_state = 3, .external_lex_state = 38},
  [2448] = {.lex_state = 3, .external_lex_state = 38},
  [2449] = {.lex_state = 3, .external_lex_state = 38},
  [2450] = {.lex_state = 3, .external_lex_state = 38},
  [2451] = {.lex_state = 3, .external_lex_state = 38},
  [2452] = {.lex_state = 3, .external_lex_state = 38},
  [2453] = {.lex_state = 3, .external_lex_state = 38},
  [2454] = {.lex_state = 3, .external_lex_state = 38},
  [2455] = {.lex_state = 3, .external_lex_state = 38},
  [2456] = {.lex_state = 3, .external_lex_state = 38},
  [2457] = {.lex_state = 3, .external_lex_state = 38},
  [2458] = {.lex_state = 3, .external_lex_state = 38},
  [2459] = {.lex_state = 3, .external_lex_state = 38},
  [2460] = {.lex_state = 3, .external_lex_state = 38},
  [2461] = {.lex_state = 3, .external_lex_state = 38},
  [2462] = {.lex_state = 3, .external_lex_state = 38},
  [2463] = {.lex_state = 3, .external_lex_state = 38},
  [2464] = {.lex_state = 3, .external_lex_state = 38},
  [2465] = {.lex_state = 3, .external_lex_state = 38},
  [2466] = {.lex_state = 3, .external_lex_state = 76},
  [2467] = {.lex_state = 3, .external_lex_state = 38},
  [2468] = {.lex_state = 3, .external_lex_state = 21},
  [2469] = {.lex_state = 3, .external_lex_state = 38},
  [2470] = {.lex_state = 3, .external_lex_state = 38},
  [2471] = {.lex_state = 3, .external_lex_state = 38},
  [2472] = {.lex_state = 3, .external_lex_state = 38},
  [2473] = {.lex_state = 3, .external_lex_state = 38},
  [2474] = {.lex_state = 3, .external_lex_state = 38},
  [2475] = {.lex_state = 3, .external_lex_state = 38},
  [2476] = {.lex_state = 3, .external_lex_state = 38},
  [2477] = {.lex_state = 3, .external_lex_state = 38},
  [2478] = {.lex_state = 3, .external_lex_state = 38},
  [2479] = {.lex_state = 3, .external_lex_state = 38},
  [2480] = {.lex_state = 3, .external_lex_state = 38},
  [2481] = {.lex_state = 3, .external_lex_state = 38},
  [2482] = {.lex_state = 3, .external_lex_state = 38},
  [2483] = {.lex_state = 3, .external_lex_state = 38},
  [2484] = {.lex_state = 3, .external_lex_state = 38},
  [2485] = {.lex_state = 3, .external_lex_state = 38},
  [2486] = {.lex_state = 3, .external_lex_state = 38},
  [2487] = {.lex_state = 3, .external_lex_state = 38},
  [2488] = {.lex_state = 3, .external_lex_state = 38},
  [2489] = {.lex_state = 3, .external_lex_state = 38},
  [2490] = {.lex_state = 3, .external_lex_state = 38},
  [2491] = {.lex_state = 3, .external_lex_state = 38},
  [2492] = {.lex_state = 3, .external_lex_state = 38},
  [2493] = {.lex_state = 3, .external_lex_state = 38},
  [2494] = {.lex_state = 3, .external_lex_state = 38},
  [2495] = {.lex_state = 3, .external_lex_state = 38},
  [2496] = {.lex_state = 3, .external_lex_state = 38},
  [2497] = {.lex_state = 3, .external_lex_state = 38},
  [2498] = {.lex_state = 3, .external_lex_state = 38},
  [2499] = {.lex_state = 3, .external_lex_state = 38},
  [2500] = {.lex_state = 3, .external_lex_state = 38},
  [2501] = {.lex_state = 3, .external_lex_state = 38},
  [2502] = {.lex_state = 3, .external_lex_state = 38},
  [2503] = {.lex_state = 3, .external_lex_state = 38},
  [2504] = {.lex_state = 3, .external_lex_state = 38},
  [2505] = {.lex_state = 3, .external_lex_state = 38},
  [2506] = {.lex_state = 3, .external_lex_state = 38},
  [2507] = {.lex_state = 3, .external_lex_state = 38},
  [2508] = {.lex_state = 3, .external_lex_state = 38},
  [2509] = {.lex_state = 3, .external_lex_state = 38},
  [2510] = {.lex_state = 3, .external_lex_state = 38},
  [2511] = {.lex_state = 3, .external_lex_state = 38},
  [2512] = {.lex_state = 3, .external_lex_state = 38},
  [2513] = {.lex_state = 3, .external_lex_state = 38},
  [2514] = {.lex_state = 3, .external_lex_state = 38},
  [2515] = {.lex_state = 3, .external_lex_state = 38},
  [2516] = {.lex_state = 3, .external_lex_state = 76},
  [2517] = {.lex_state = 3, .external_lex_state = 38},
  [2518] = {.lex_state = 3, .external_lex_state = 38},
  [2519] = {.lex_state = 3, .external_lex_state = 38},
  [2520] = {.lex_state = 3, .external_lex_state = 38},
  [2521] = {.lex_state = 3, .external_lex_state = 38},
  [2522] = {.lex_state = 3, .external_lex_state = 38},
  [2523] = {.lex_state = 3, .external_lex_state = 38},
  [2524] = {.lex_state = 3, .external_lex_state = 38},
  [2525] = {.lex_state = 3, .external_lex_state = 38},
  [2526] = {.lex_state = 3, .external_lex_state = 38},
  [2527] = {.lex_state = 3, .external_lex_state = 38},
  [2528] = {.lex_state = 3, .external_lex_state = 38},
  [2529] = {.lex_state = 3, .external_lex_state = 38},
  [2530] = {.lex_state = 3, .external_lex_state = 38},
  [2531] = {.lex_state = 3, .external_lex_state = 38},
  [2532] = {.lex_state = 3, .external_lex_state = 38},
  [2533] = {.lex_state = 3, .external_lex_state = 38},
  [2534] = {.lex_state = 3, .external_lex_state = 38},
  [2535] = {.lex_state = 3, .external_lex_state = 38},
  [2536] = {.lex_state = 3, .external_lex_state = 38},
  [2537] = {.lex_state = 3, .external_lex_state = 38},
  [2538] = {.lex_state = 3, .external_lex_state = 38},
  [2539] = {.lex_state = 3, .external_lex_state = 78},
  [2540] = {.lex_state = 3, .external_lex_state = 38},
  [2541] = {.lex_state = 3, .external_lex_state = 38},
  [2542] = {.lex_state = 3, .external_lex_state = 38},
  [2543] = {.lex_state = 3, .external_lex_state = 38},
  [2544] = {.lex_state = 3, .external_lex_state = 38},
  [2545] = {.lex_state = 3, .external_lex_state = 38},
  [2546] = {.lex_state = 3, .external_lex_state = 78},
  [2547] = {.lex_state = 3, .external_lex_state = 38},
  [2548] = {.lex_state = 3, .external_lex_state = 38},
  [2549] = {.lex_state = 3, .external_lex_state = 38},
  [2550] = {.lex_state = 3, .external_lex_state = 38},
  [2551] = {.lex_state = 3, .external_lex_state = 38},
  [2552] = {.lex_state = 3, .external_lex_state = 38},
  [2553] = {.lex_state = 4, .external_lex_state = 79},
  [2554] = {.lex_state = 3, .external_lex_state = 38},
  [2555] = {.lex_state = 3, .external_lex_state = 38},
  [2556] = {.lex_state = 3, .external_lex_state = 38},
  [2557] = {.lex_state = 3, .external_lex_state = 38},
  [2558] = {.lex_state = 3, .external_lex_state = 38},
  [2559] = {.lex_state = 3, .external_lex_state = 38},
  [2560] = {.lex_state = 3, .external_lex_state = 38},
  [2561] = {.lex_state = 3, .external_lex_state = 38},
  [2562] = {.lex_state = 3, .external_lex_state = 38},
  [2563] = {.lex_state = 3, .external_lex_state = 38},
  [2564] = {.lex_state = 3, .external_lex_state = 38},
  [2565] = {.lex_state = 3, .external_lex_state = 38},
  [2566] = {.lex_state = 3, .external_lex_state = 38},
  [2567] = {.lex_state = 3, .external_lex_state = 38},
  [2568] = {.lex_state = 3, .external_lex_state = 38},
  [2569] = {.lex_state = 3, .external_lex_state = 38},
  [2570] = {.lex_state = 3, .external_lex_state = 38},
  [2571] = {.lex_state = 3, .external_lex_state = 38},
  [2572] = {.lex_state = 3, .external_lex_state = 38},
  [2573] = {.lex_state = 3, .external_lex_state = 38},
  [2574] = {.lex_state = 3, .external_lex_state = 38},
  [2575] = {.lex_state = 3, .external_lex_state = 38},
  [2576] = {.lex_state = 3, .external_lex_state = 38},
  [2577] = {.lex_state = 3, .external_lex_state = 38},
  [2578] = {.lex_state = 3, .external_lex_state = 38},
  [2579] = {.lex_state = 3, .external_lex_state = 38},
  [2580] = {.lex_state = 3, .external_lex_state = 38},
  [2581] = {.lex_state = 3, .external_lex_state = 38},
  [2582] = {.lex_state = 3, .external_lex_state = 38},
  [2583] = {.lex_state = 3, .external_lex_state = 38},
  [2584] = {.lex_state = 3, .external_lex_state = 38},
  [2585] = {.lex_state = 3, .external_lex_state = 38},
  [2586] = {.lex_state = 3, .external_lex_state = 38},
  [2587] = {.lex_state = 3, .external_lex_state = 38},
  [2588] = {.lex_state = 3, .external_lex_state = 38},
  [2589] = {.lex_state = 3, .external_lex_state = 78},
  [2590] = {.lex_state = 3, .external_lex_state = 38},
  [2591] = {.lex_state = 3, .external_lex_state = 38},
  [2592] = {.lex_state = 3, .external_lex_state = 38},
  [2593] = {.lex_state = 3, .external_lex_state = 38},
  [2594] = {.lex_state = 3, .external_lex_state = 38},
  [2595] = {.lex_state = 3, .external_lex_state = 38},
  [2596] = {.lex_state = 3, .external_lex_state = 38},
  [2597] = {.lex_state = 3, .external_lex_state = 38},
  [2598] = {.lex_state = 3, .external_lex_state = 38},
  [2599] = {.lex_state = 3, .external_lex_state = 38},
  [2600] = {.lex_state = 3, .external_lex_state = 38},
  [2601] = {.lex_state = 3, .external_lex_state = 38},
  [2602] = {.lex_state = 3, .external_lex_state = 38},
  [2603] = {.lex_state = 3, .external_lex_state = 38},
  [2604] = {.lex_state = 3, .external_lex_state = 38},
  [2605] = {.lex_state = 3, .external_lex_state = 38},
  [2606] = {.lex_state = 3, .external_lex_state = 38},
  [2607] = {.lex_state = 3, .external_lex_state = 38},
  [2608] = {.lex_state = 3, .external_lex_state = 38},
  [2609] = {.lex_state = 3, .external_lex_state = 38},
  [2610] = {.lex_state = 3, .external_lex_state = 38},
  [2611] = {.lex_state = 3, .external_lex_state = 38},
  [2612] = {.lex_state = 3, .external_lex_state = 38},
  [2613] = {.lex_state = 3, .external_lex_state = 38},
  [2614] = {.lex_state = 3, .external_lex_state = 38},
  [2615] = {.lex_state = 3, .external_lex_state = 38},
  [2616] = {.lex_state = 3, .external_lex_state = 38},
  [2617] = {.lex_state = 3, .external_lex_state = 38},
  [2618] = {.lex_state = 3, .external_lex_state = 38},
  [2619] = {.lex_state = 3, .external_lex_state = 38},
  [2620] = {.lex_state = 3, .external_lex_state = 38},
  [2621] = {.lex_state = 3, .external_lex_state = 38},
  [2622] = {.lex_state = 3, .external_lex_state = 38},
  [2623] = {.lex_state = 3, .external_lex_state = 38},
  [2624] = {.lex_state = 4, .external_lex_state = 79},
  [2625] = {.lex_state = 3, .external_lex_state = 38},
  [2626] = {.lex_state = 3, .external_lex_state = 38},
  [2627] = {.lex_state = 3, .external_lex_state = 38},
  [2628] = {.lex_state = 3, .external_lex_state = 38},
  [2629] = {.lex_state = 3, .external_lex_state = 38},
  [2630] = {.lex_state = 3, .external_lex_state = 38},
  [2631] = {.lex_state = 3, .external_lex_state = 38},
  [2632] = {.lex_state = 3, .external_lex_state = 38},
  [2633] = {.lex_state = 3, .external_lex_state = 21},
  [2634] = {.lex_state = 3, .external_lex_state = 38},
  [2635] = {.lex_state = 3, .external_lex_state = 38},
  [2636] = {.lex_state = 3, .external_lex_state = 38},
  [2637] = {.lex_state = 3, .external_lex_state = 38},
  [2638] = {.lex_state = 3, .external_lex_state = 38},
  [2639] = {.lex_state = 3, .external_lex_state = 21},
  [2640] = {.lex_state = 3, .external_lex_state = 38},
  [2641] = {.lex_state = 3, .external_lex_state = 38},
  [2642] = {.lex_state = 3, .external_lex_state = 38},
  [2643] = {.lex_state = 3, .external_lex_state = 38},
  [2644] = {.lex_state = 3, .external_lex_state = 38},
  [2645] = {.lex_state = 3, .external_lex_state = 38},
  [2646] = {.lex_state = 3, .external_lex_state = 38},
  [2647] = {.lex_state = 3, .external_lex_state = 38},
  [2648] = {.lex_state = 3, .external_lex_state = 38},
  [2649] = {.lex_state = 3, .external_lex_state = 38},
  [2650] = {.lex_state = 3, .external_lex_state = 38},
  [2651] = {.lex_state = 3, .external_lex_state = 38},
  [2652] = {.lex_state = 3, .external_lex_state = 21},
  [2653] = {.lex_state = 3, .external_lex_state = 38},
  [2654] = {.lex_state = 3, .external_lex_state = 38},
  [2655] = {.lex_state = 3, .external_lex_state = 38},
  [2656] = {.lex_state = 3, .external_lex_state = 38},
  [2657] = {.lex_state = 3, .external_lex_state = 38},
  [2658] = {.lex_state = 3, .external_lex_state = 38},
  [2659] = {.lex_state = 3, .external_lex_state = 38},
  [2660] = {.lex_state = 3, .external_lex_state = 38},
  [2661] = {.lex_state = 3, .external_lex_state = 38},
  [2662] = {.lex_state = 3, .external_lex_state = 38},
  [2663] = {.lex_state = 3, .external_lex_state = 38},
  [2664] = {.lex_state = 3, .external_lex_state = 38},
  [2665] = {.lex_state = 3, .external_lex_state = 38},
  [2666] = {.lex_state = 3, .external_lex_state = 38},
  [2667] = {.lex_state = 3, .external_lex_state = 38},
  [2668] = {.lex_state = 3, .external_lex_state = 21},
  [2669] = {.lex_state = 3, .external_lex_state = 21},
  [2670] = {.lex_state = 3, .external_lex_state = 21},
  [2671] = {.lex_state = 3, .external_lex_state = 38},
  [2672] = {.lex_state = 3, .external_lex_state = 38},
  [2673] = {.lex_state = 3, .external_lex_state = 38},
  [2674] = {.lex_state = 3, .external_lex_state = 38},
  [2675] = {.lex_state = 3, .external_lex_state = 38},
  [2676] = {.lex_state = 3, .external_lex_state = 38},
  [2677] = {.lex_state = 3, .external_lex_state = 38},
  [2678] = {.lex_state = 3, .external_lex_state = 38},
  [2679] = {.lex_state = 3, .external_lex_state = 38},
  [2680] = {.lex_state = 3, .external_lex_state = 38},
  [2681] = {.lex_state = 3, .external_lex_state = 38},
  [2682] = {.lex_state = 3, .external_lex_state = 21},
  [2683] = {.lex_state = 3, .external_lex_state = 38},
  [2684] = {.lex_state = 3, .external_lex_state = 38},
  [2685] = {.lex_state = 3, .external_lex_state = 38},
  [2686] = {.lex_state = 3, .external_lex_state = 38},
  [2687] = {.lex_state = 3, .external_lex_state = 38},
  [2688] = {.lex_state = 3, .external_lex_state = 38},
  [2689] = {.lex_state = 3, .external_lex_state = 38},
  [2690] = {.lex_state = 3, .external_lex_state = 38},
  [2691] = {.lex_state = 3, .external_lex_state = 7},
  [2692] = {.lex_state = 3, .external_lex_state = 7},
  [2693] = {.lex_state = 3, .external_lex_state = 7},
  [2694] = {.lex_state = 3, .external_lex_state = 7},
  [2695] = {.lex_state = 3, .external_lex_state = 7},
  [2696] = {.lex_state = 3, .external_lex_state = 7},
  [2697] = {.lex_state = 3, .external_lex_state = 7},
  [2698] = {.lex_state = 3, .external_lex_state = 80},
  [2699] = {.lex_state = 3, .external_lex_state = 7},
  [2700] = {.lex_state = 3, .external_lex_state = 7},
  [2701] = {.lex_state = 3, .external_lex_state = 7},
  [2702] = {.lex_state = 3, .external_lex_state = 7},
  [2703] = {.lex_state = 3, .external_lex_state = 7},
  [2704] = {.lex_state = 3, .external_lex_state = 7},
  [2705] = {.lex_state = 3, .external_lex_state = 7},
  [2706] = {.lex_state = 3, .external_lex_state = 80},
  [2707] = {.lex_state = 3, .external_lex_state = 7},
  [2708] = {.lex_state = 3, .external_lex_state = 7},
  [2709] = {.lex_state = 3, .external_lex_state = 7},
  [2710] = {.lex_state = 3, .external_lex_state = 7},
  [2711] = {.lex_state = 3, .external_lex_state = 80},
  [2712] = {.lex_state = 3, .external_lex_state = 7},
  [2713] = {.lex_state = 3, .external_lex_state = 7},
  [2714] = {.lex_state = 3, .external_lex_state = 80},
  [2715] = {.lex_state = 3, .external_lex_state = 7},
  [2716] = {.lex_state = 3, .external_lex_state = 7},
  [2717] = {.lex_state = 3, .external_lex_state = 7},
  [2718] = {.lex_state = 3, .external_lex_state = 7},
  [2719] = {.lex_state = 3, .external_lex_state = 7},
  [2720] = {.lex_state = 3, .external_lex_state = 80},
  [2721] = {.lex_state = 3, .external_lex_state = 80},
  [2722] = {.lex_state = 3, .external_lex_state = 80},
  [2723] = {.lex_state = 3, .external_lex_state = 7},
  [2724] = {.lex_state = 3, .external_lex_state = 7},
  [2725] = {.lex_state = 3, .external_lex_state = 7},
  [2726] = {.lex_state = 3, .external_lex_state = 7},
  [2727] = {.lex_state = 3, .external_lex_state = 80},
  [2728] = {.lex_state = 3, .external_lex_state = 7},
  [2729] = {.lex_state = 3, .external_lex_state = 7},
  [2730] = {.lex_state = 3, .external_lex_state = 7},
  [2731] = {.lex_state = 3, .external_lex_state = 7},
  [2732] = {.lex_state = 3, .external_lex_state = 80},
  [2733] = {.lex_state = 3, .external_lex_state = 7},
  [2734] = {.lex_state = 3, .external_lex_state = 7},
  [2735] = {.lex_state = 3, .external_lex_state = 7},
  [2736] = {.lex_state = 3, .external_lex_state = 7},
  [2737] = {.lex_state = 3, .external_lex_state = 7},
  [2738] = {.lex_state = 3, .external_lex_state = 7},
  [2739] = {.lex_state = 3, .external_lex_state = 7},
  [2740] = {.lex_state = 3, .external_lex_state = 7},
  [2741] = {.lex_state = 3, .external_lex_state = 7},
  [2742] = {.lex_state = 3, .external_lex_state = 7},
  [2743] = {.lex_state = 3, .external_lex_state = 7},
  [2744] = {.lex_state = 3, .external_lex_state = 7},
  [2745] = {.lex_state = 3, .external_lex_state = 7},
  [2746] = {.lex_state = 3, .external_lex_state = 7},
  [2747] = {.lex_state = 3, .external_lex_state = 7},
  [2748] = {.lex_state = 3, .external_lex_state = 7},
  [2749] = {.lex_state = 3, .external_lex_state = 7},
  [2750] = {.lex_state = 3, .external_lex_state = 7},
  [2751] = {.lex_state = 3, .external_lex_state = 7},
  [2752] = {.lex_state = 4, .external_lex_state = 20},
  [2753] = {.lex_state = 4, .external_lex_state = 20},
  [2754] = {.lex_state = 4, .external_lex_state = 20},
  [2755] = {.lex_state = 4, .external_lex_state = 20},
  [2756] = {.lex_state = 4, .external_lex_state = 23},
  [2757] = {.lex_state = 4, .external_lex_state = 18},
  [2758] = {.lex_state = 4, .external_lex_state = 20},
  [2759] = {.lex_state = 4, .external_lex_state = 20},
  [2760] = {.lex_state = 4, .external_lex_state = 20},
  [2761] = {.lex_state = 4, .external_lex_state = 20},
  [2762] = {.lex_state = 4, .external_lex_state = 20},
  [2763] = {.lex_state = 4, .external_lex_state = 20},
  [2764] = {.lex_state = 4, .external_lex_state = 20},
  [2765] = {.lex_state = 4, .external_lex_state = 20},
  [2766] = {.lex_state = 4, .external_lex_state = 20},
  [2767] = {.lex_state = 4, .external_lex_state = 20},
  [2768] = {.lex_state = 1, .external_lex_state = 18},
  [2769] = {.lex_state = 4, .external_lex_state = 23},
  [2770] = {.lex_state = 1, .external_lex_state = 18},
  [2771] = {.lex_state = 4, .external_lex_state = 20},
  [2772] = {.lex_state = 1, .external_lex_state = 18},
  [2773] = {.lex_state = 4, .external_lex_state = 20},
  [2774] = {.lex_state = 4, .external_lex_state = 20},
  [2775] = {.lex_state = 4, .external_lex_state = 20},
  [2776] = {.lex_state = 4, .external_lex_state = 20},
  [2777] = {.lex_state = 4, .external_lex_state = 20},
  [2778] = {.lex_state = 4, .external_lex_state = 20},
  [2779] = {.lex_state = 4, .external_lex_state = 20},
  [2780] = {.lex_state = 4, .external_lex_state = 23},
  [2781] = {.lex_state = 4, .external_lex_state = 20},
  [2782] = {.lex_state = 1, .external_lex_state = 18},
  [2783] = {.lex_state = 1, .external_lex_state = 18},
  [2784] = {.lex_state = 1, .external_lex_state = 18},
  [2785] = {.lex_state = 1, .external_lex_state = 18},
  [2786] = {.lex_state = 4, .external_lex_state = 20},
  [2787] = {.lex_state = 4, .external_lex_state = 20},
  [2788] = {.lex_state = 4, .external_lex_state = 20},
  [2789] = {.lex_state = 4, .external_lex_state = 20},
  [2790] = {.lex_state = 4, .external_lex_state = 23},
  [2791] = {.lex_state = 1, .external_lex_state = 18},
  [2792] = {.lex_state = 4, .external_lex_state = 20},
  [2793] = {.lex_state = 4, .external_lex_state = 23},
  [2794] = {.lex_state = 4, .external_lex_state = 23},
  [2795] = {.lex_state = 4, .external_lex_state = 20},
  [2796] = {.lex_state = 4, .external_lex_state = 20},
  [2797] = {.lex_state = 4, .external_lex_state = 20},
  [2798] = {.lex_state = 4, .external_lex_state = 23},
  [2799] = {.lex_state = 3, .external_lex_state = 24},
  [2800] = {.lex_state = 3, .external_lex_state = 24},
  [2801] = {.lex_state = 4, .external_lex_state = 23},
  [2802] = {.lex_state = 3, .external_lex_state = 24},
  [2803] = {.lex_state = 3, .external_lex_state = 24},
  [2804] = {.lex_state = 3, .external_lex_state = 24},
  [2805] = {.lex_state = 4, .external_lex_state = 23},
  [2806] = {.lex_state = 4, .external_lex_state = 20},
  [2807] = {.lex_state = 3, .external_lex_state = 24},
  [2808] = {.lex_state = 4, .external_lex_state = 20},
  [2809] = {.lex_state = 4, .external_lex_state = 20},
  [2810] = {.lex_state = 4, .external_lex_state = 20},
  [2811] = {.lex_state = 4, .external_lex_state = 20},
  [2812] = {.lex_state = 4, .external_lex_state = 20},
  [2813] = {.lex_state = 4, .external_lex_state = 20},
  [2814] = {.lex_state = 4, .external_lex_state = 20},
  [2815] = {.lex_state = 4, .external_lex_state = 20},
  [2816] = {.lex_state = 4, .external_lex_state = 20},
  [2817] = {.lex_state = 4, .external_lex_state = 20},
  [2818] = {.lex_state = 3, .external_lex_state = 24},
  [2819] = {.lex_state = 4, .external_lex_state = 20},
  [2820] = {.lex_state = 4, .external_lex_state = 20},
  [2821] = {.lex_state = 4, .external_lex_state = 20},
  [2822] = {.lex_state = 4, .external_lex_state = 20},
  [2823] = {.lex_state = 4, .external_lex_state = 20},
  [2824] = {.lex_state = 1, .external_lex_state = 18},
  [2825] = {.lex_state = 4, .external_lex_state = 20},
  [2826] = {.lex_state = 4, .external_lex_state = 18},
  [2827] = {.lex_state = 4, .external_lex_state = 18},
  [2828] = {.lex_state = 4, .external_lex_state = 18},
  [2829] = {.lex_state = 4, .external_lex_state = 18},
  [2830] = {.lex_state = 4, .external_lex_state = 20},
  [2831] = {.lex_state = 4, .external_lex_state = 18},
  [2832] = {.lex_state = 3, .external_lex_state = 24},
  [2833] = {.lex_state = 4, .external_lex_state = 18},
  [2834] = {.lex_state = 4, .external_lex_state = 18},
  [2835] = {.lex_state = 4, .external_lex_state = 20},
  [2836] = {.lex_state = 3, .external_lex_state = 24},
  [2837] = {.lex_state = 4, .external_lex_state = 20},
  [2838] = {.lex_state = 4, .external_lex_state = 18},
  [2839] = {.lex_state = 4, .external_lex_state = 20},
  [2840] = {.lex_state = 3, .external_lex_state = 7},
  [2841] = {.lex_state = 3, .external_lex_state = 7},
  [2842] = {.lex_state = 3, .external_lex_state = 81},
  [2843] = {.lex_state = 4, .external_lex_state = 82},
  [2844] = {.lex_state = 3, .external_lex_state = 7},
  [2845] = {.lex_state = 3, .external_lex_state = 7},
  [2846] = {.lex_state = 4, .external_lex_state = 72},
  [2847] = {.lex_state = 4, .external_lex_state = 82},
  [2848] = {.lex_state = 3, .external_lex_state = 7},
  [2849] = {.lex_state = 3, .external_lex_state = 7},
  [2850] = {.lex_state = 3, .external_lex_state = 7},
  [2851] = {.lex_state = 4, .external_lex_state = 82},
  [2852] = {.lex_state = 4, .external_lex_state = 82},
  [2853] = {.lex_state = 4, .external_lex_state = 72},
  [2854] = {.lex_state = 4, .external_lex_state = 72},
  [2855] = {.lex_state = 4, .external_lex_state = 83},
  [2856] = {.lex_state = 4, .external_lex_state = 82},
  [2857] = {.lex_state = 3, .external_lex_state = 81},
  [2858] = {.lex_state = 3, .external_lex_state = 7},
  [2859] = {.lex_state = 3, .external_lex_state = 7},
  [2860] = {.lex_state = 3, .external_lex_state = 7},
  [2861] = {.lex_state = 3, .external_lex_state = 7},
  [2862] = {.lex_state = 3, .external_lex_state = 7},
  [2863] = {.lex_state = 1, .external_lex_state = 72},
  [2864] = {.lex_state = 4, .external_lex_state = 82},
  [2865] = {.lex_state = 4, .external_lex_state = 82},
  [2866] = {.lex_state = 4, .external_lex_state = 82},
  [2867] = {.lex_state = 4, .external_lex_state = 82},
  [2868] = {.lex_state = 4, .external_lex_state = 72},
  [2869] = {.lex_state = 4, .external_lex_state = 72},
  [2870] = {.lex_state = 3, .external_lex_state = 7},
  [2871] = {.lex_state = 3, .external_lex_state = 7},
  [2872] = {.lex_state = 1, .external_lex_state = 72},
  [2873] = {.lex_state = 1, .external_lex_state = 72},
  [2874] = {.lex_state = 3, .external_lex_state = 81},
  [2875] = {.lex_state = 3, .external_lex_state = 7},
  [2876] = {.lex_state = 3, .external_lex_state = 81},
  [2877] = {.lex_state = 3, .external_lex_state = 7},
  [2878] = {.lex_state = 3, .external_lex_state = 7},
  [2879] = {.lex_state = 1, .external_lex_state = 72},
  [2880] = {.lex_state = 3, .external_lex_state = 7},
  [2881] = {.lex_state = 3, .external_lex_state = 7},
  [2882] = {.lex_state = 3, .external_lex_state = 7},
  [2883] = {.lex_state = 4, .external_lex_state = 82},
  [2884] = {.lex_state = 3, .external_lex_state = 7},
  [2885] = {.lex_state = 3, .external_lex_state = 7},
  [2886] = {.lex_state = 4, .external_lex_state = 82},
  [2887] = {.lex_state = 4, .external_lex_state = 82},
  [2888] = {.lex_state = 3, .external_lex_state = 7},
  [2889] = {.lex_state = 3, .external_lex_state = 7},
  [2890] = {.lex_state = 3, .external_lex_state = 7},
  [2891] = {.lex_state = 4, .external_lex_state = 83},
  [2892] = {.lex_state = 4, .external_lex_state = 84},
  [2893] = {.lex_state = 4, .external_lex_state = 83},
  [2894] = {.lex_state = 3, .external_lex_state = 7},
  [2895] = {.lex_state = 4, .external_lex_state = 82},
  [2896] = {.lex_state = 3, .external_lex_state = 7},
  [2897] = {.lex_state = 3, .external_lex_state = 7},
  [2898] = {.lex_state = 3, .external_lex_state = 7},
  [2899] = {.lex_state = 3, .external_lex_state = 81},
  [2900] = {.lex_state = 3, .external_lex_state = 7},
  [2901] = {.lex_state = 3, .external_lex_state = 7},
  [2902] = {.lex_state = 4, .external_lex_state = 82},
  [2903] = {.lex_state = 1, .external_lex_state = 72},
  [2904] = {.lex_state = 3, .external_lex_state = 7},
  [2905] = {.lex_state = 4, .external_lex_state = 82},
  [2906] = {.lex_state = 3, .external_lex_state = 7},
  [2907] = {.lex_state = 3, .external_lex_state = 7},
  [2908] = {.lex_state = 3, .external_lex_state = 7},
  [2909] = {.lex_state = 4, .external_lex_state = 83},
  [2910] = {.lex_state = 4, .external_lex_state = 83},
  [2911] = {.lex_state = 3, .external_lex_state = 25},
  [2912] = {.lex_state = 3, .external_lex_state = 7},
  [2913] = {.lex_state = 3, .external_lex_state = 7},
  [2914] = {.lex_state = 3, .external_lex_state = 7},
  [2915] = {.lex_state = 4, .external_lex_state = 72},
  [2916] = {.lex_state = 4, .external_lex_state = 82},
  [2917] = {.lex_state = 4, .external_lex_state = 82},
  [2918] = {.lex_state = 3, .external_lex_state = 81},
  [2919] = {.lex_state = 4, .external_lex_state = 82},
  [2920] = {.lex_state = 4, .external_lex_state = 26},
  [2921] = {.lex_state = 3, .external_lex_state = 7},
  [2922] = {.lex_state = 3, .external_lex_state = 7},
  [2923] = {.lex_state = 4, .external_lex_state = 82},
  [2924] = {.lex_state = 3, .external_lex_state = 7},
  [2925] = {.lex_state = 3, .external_lex_state = 7},
  [2926] = {.lex_state = 3, .external_lex_state = 7},
  [2927] = {.lex_state = 3, .external_lex_state = 7},
  [2928] = {.lex_state = 3, .external_lex_state = 7},
  [2929] = {.lex_state = 3, .external_lex_state = 7},
  [2930] = {.lex_state = 4, .external_lex_state = 26},
  [2931] = {.lex_state = 3, .external_lex_state = 7},
  [2932] = {.lex_state = 1, .external_lex_state = 72},
  [2933] = {.lex_state = 4, .external_lex_state = 82},
  [2934] = {.lex_state = 4, .external_lex_state = 83},
  [2935] = {.lex_state = 3, .external_lex_state = 7},
  [2936] = {.lex_state = 3, .external_lex_state = 25},
  [2937] = {.lex_state = 3, .external_lex_state = 7},
  [2938] = {.lex_state = 3, .external_lex_state = 7},
  [2939] = {.lex_state = 4, .external_lex_state = 26},
  [2940] = {.lex_state = 4, .external_lex_state = 26},
  [2941] = {.lex_state = 3, .external_lex_state = 7},
  [2942] = {.lex_state = 3, .external_lex_state = 81},
  [2943] = {.lex_state = 3, .external_lex_state = 7},
  [2944] = {.lex_state = 4, .external_lex_state = 72},
  [2945] = {.lex_state = 3, .external_lex_state = 7},
  [2946] = {.lex_state = 3, .external_lex_state = 7},
  [2947] = {.lex_state = 4, .external_lex_state = 26},
  [2948] = {.lex_state = 3, .external_lex_state = 7},
  [2949] = {.lex_state = 4, .external_lex_state = 26},
  [2950] = {.lex_state = 3, .external_lex_state = 7},
  [2951] = {.lex_state = 3, .external_lex_state = 7},
  [2952] = {.lex_state = 3, .external_lex_state = 7},
  [2953] = {.lex_state = 4, .external_lex_state = 72},
  [2954] = {.lex_state = 3, .external_lex_state = 7},
  [2955] = {.lex_state = 4, .external_lex_state = 26},
  [2956] = {.lex_state = 3, .external_lex_state = 7},
  [2957] = {.lex_state = 3, .external_lex_state = 7},
  [2958] = {.lex_state = 4, .external_lex_state = 26},
  [2959] = {.lex_state = 3, .external_lex_state = 7},
  [2960] = {.lex_state = 1, .external_lex_state = 72},
  [2961] = {.lex_state = 4, .external_lex_state = 84},
  [2962] = {.lex_state = 3, .external_lex_state = 7},
  [2963] = {.lex_state = 3, .external_lex_state = 7},
  [2964] = {.lex_state = 3, .external_lex_state = 81},
  [2965] = {.lex_state = 3, .external_lex_state = 7},
  [2966] = {.lex_state = 3, .external_lex_state = 7},
  [2967] = {.lex_state = 4, .external_lex_state = 84},
  [2968] = {.lex_state = 3, .external_lex_state = 7},
  [2969] = {.lex_state = 4, .external_lex_state = 82},
  [2970] = {.lex_state = 3, .external_lex_state = 7},
  [2971] = {.lex_state = 3, .external_lex_state = 7},
  [2972] = {.lex_state = 3, .external_lex_state = 7},
  [2973] = {.lex_state = 3, .external_lex_state = 7},
  [2974] = {.lex_state = 3, .external_lex_state = 7},
  [2975] = {.lex_state = 3, .external_lex_state = 7},
  [2976] = {.lex_state = 3, .external_lex_state = 7},
  [2977] = {.lex_state = 3, .external_lex_state = 7},
  [2978] = {.lex_state = 1, .external_lex_state = 72},
  [2979] = {.lex_state = 4, .external_lex_state = 83},
  [2980] = {.lex_state = 3, .external_lex_state = 7},
  [2981] = {.lex_state = 3, .external_lex_state = 7},
  [2982] = {.lex_state = 3, .external_lex_state = 7},
  [2983] = {.lex_state = 3, .external_lex_state = 7},
  [2984] = {.lex_state = 3, .external_lex_state = 81},
  [2985] = {.lex_state = 3, .external_lex_state = 7},
  [2986] = {.lex_state = 3, .external_lex_state = 7},
  [2987] = {.lex_state = 3, .external_lex_state = 7},
  [2988] = {.lex_state = 3, .external_lex_state = 7},
  [2989] = {.lex_state = 3, .external_lex_state = 7},
  [2990] = {.lex_state = 3, .external_lex_state = 7},
  [2991] = {.lex_state = 3, .external_lex_state = 7},
  [2992] = {.lex_state = 4, .external_lex_state = 82},
  [2993] = {.lex_state = 3, .external_lex_state = 7},
  [2994] = {.lex_state = 3, .external_lex_state = 7},
  [2995] = {.lex_state = 3, .external_lex_state = 7},
  [2996] = {.lex_state = 3, .external_lex_state = 7},
  [2997] = {.lex_state = 3, .external_lex_state = 7},
  [2998] = {.lex_state = 3, .external_lex_state = 7},
  [2999] = {.lex_state = 3, .external_lex_state = 7},
  [3000] = {.lex_state = 3, .external_lex_state = 7},
  [3001] = {.lex_state = 3, .external_lex_state = 7},
  [3002] = {.lex_state = 3, .external_lex_state = 7},
  [3003] = {.lex_state = 3, .external_lex_state = 7},
  [3004] = {.lex_state = 3, .external_lex_state = 7},
  [3005] = {.lex_state = 3, .external_lex_state = 7},
  [3006] = {.lex_state = 3, .external_lex_state = 7},
  [3007] = {.lex_state = 4, .external_lex_state = 26},
  [3008] = {.lex_state = 4, .external_lex_state = 72},
  [3009] = {.lex_state = 3, .external_lex_state = 7},
  [3010] = {.lex_state = 3, .external_lex_state = 7},
  [3011] = {.lex_state = 3, .external_lex_state = 7},
  [3012] = {.lex_state = 3, .external_lex_state = 7},
  [3013] = {.lex_state = 3, .external_lex_state = 7},
  [3014] = {.lex_state = 3, .external_lex_state = 7},
  [3015] = {.lex_state = 3, .external_lex_state = 7},
  [3016] = {.lex_state = 3, .external_lex_state = 7},
  [3017] = {.lex_state = 3, .external_lex_state = 7},
  [3018] = {.lex_state = 3, .external_lex_state = 7},
  [3019] = {.lex_state = 3, .external_lex_state = 7},
  [3020] = {.lex_state = 4, .external_lex_state = 83},
  [3021] = {.lex_state = 3, .external_lex_state = 7},
  [3022] = {.lex_state = 4, .external_lex_state = 82},
  [3023] = {.lex_state = 3, .external_lex_state = 7},
  [3024] = {.lex_state = 3, .external_lex_state = 7},
  [3025] = {.lex_state = 3, .external_lex_state = 7},
  [3026] = {.lex_state = 3, .external_lex_state = 7},
  [3027] = {.lex_state = 3, .external_lex_state = 7},
  [3028] = {.lex_state = 3, .external_lex_state = 7},
  [3029] = {.lex_state = 3, .external_lex_state = 7},
  [3030] = {.lex_state = 3, .external_lex_state = 7},
  [3031] = {.lex_state = 3, .external_lex_state = 7},
  [3032] = {.lex_state = 3, .external_lex_state = 7},
  [3033] = {.lex_state = 3, .external_lex_state = 7},
  [3034] = {.lex_state = 3, .external_lex_state = 7},
  [3035] = {.lex_state = 3, .external_lex_state = 7},
  [3036] = {.lex_state = 3, .external_lex_state = 7},
  [3037] = {.lex_state = 3, .external_lex_state = 7},
  [3038] = {.lex_state = 3, .external_lex_state = 25},
  [3039] = {.lex_state = 3, .external_lex_state = 25},
  [3040] = {.lex_state = 3, .external_lex_state = 7},
  [3041] = {.lex_state = 3, .external_lex_state = 25},
  [3042] = {.lex_state = 3, .external_lex_state = 7},
  [3043] = {.lex_state = 4, .external_lex_state = 83},
  [3044] = {.lex_state = 3, .external_lex_state = 25},
  [3045] = {.lex_state = 3, .external_lex_state = 7},
  [3046] = {.lex_state = 3, .external_lex_state = 25},
  [3047] = {.lex_state = 3, .external_lex_state = 25},
  [3048] = {.lex_state = 3, .external_lex_state = 25},
  [3049] = {.lex_state = 3, .external_lex_state = 7},
  [3050] = {.lex_state = 1, .external_lex_state = 72},
  [3051] = {.lex_state = 3, .external_lex_state = 7},
  [3052] = {.lex_state = 3, .external_lex_state = 21},
  [3053] = {.lex_state = 4, .external_lex_state = 85},
  [3054] = {.lex_state = 4, .external_lex_state = 85},
  [3055] = {.lex_state = 3, .external_lex_state = 86},
  [3056] = {.lex_state = 4, .external_lex_state = 85},
  [3057] = {.lex_state = 3, .external_lex_state = 86},
  [3058] = {.lex_state = 3, .external_lex_state = 21},
  [3059] = {.lex_state = 3, .external_lex_state = 87},
  [3060] = {.lex_state = 3, .external_lex_state = 21},
  [3061] = {.lex_state = 3, .external_lex_state = 21},
  [3062] = {.lex_state = 3, .external_lex_state = 86},
  [3063] = {.lex_state = 3, .external_lex_state = 21},
  [3064] = {.lex_state = 3, .external_lex_state = 21},
  [3065] = {.lex_state = 3, .external_lex_state = 21},
  [3066] = {.lex_state = 3, .external_lex_state = 21},
  [3067] = {.lex_state = 3, .external_lex_state = 21},
  [3068] = {.lex_state = 1, .external_lex_state = 79},
  [3069] = {.lex_state = 3, .external_lex_state = 86},
  [3070] = {.lex_state = 3, .external_lex_state = 21},
  [3071] = {.lex_state = 3, .external_lex_state = 21},
  [3072] = {.lex_state = 3, .external_lex_state = 21},
  [3073] = {.lex_state = 3, .external_lex_state = 21},
  [3074] = {.lex_state = 1, .external_lex_state = 79},
  [3075] = {.lex_state = 3, .external_lex_state = 21},
  [3076] = {.lex_state = 3, .external_lex_state = 21},
  [3077] = {.lex_state = 3, .external_lex_state = 87},
  [3078] = {.lex_state = 1, .external_lex_state = 79},
  [3079] = {.lex_state = 4, .external_lex_state = 85},
  [3080] = {.lex_state = 3, .external_lex_state = 86},
  [3081] = {.lex_state = 3, .external_lex_state = 88},
  [3082] = {.lex_state = 3, .external_lex_state = 21},
  [3083] = {.lex_state = 3, .external_lex_state = 21},
  [3084] = {.lex_state = 3, .external_lex_state = 21},
  [3085] = {.lex_state = 4, .external_lex_state = 89},
  [3086] = {.lex_state = 3, .external_lex_state = 21},
  [3087] = {.lex_state = 3, .external_lex_state = 21},
  [3088] = {.lex_state = 3, .external_lex_state = 21},
  [3089] = {.lex_state = 3, .external_lex_state = 88},
  [3090] = {.lex_state = 3, .external_lex_state = 21},
  [3091] = {.lex_state = 3, .external_lex_state = 21},
  [3092] = {.lex_state = 3, .external_lex_state = 21},
  [3093] = {.lex_state = 4, .external_lex_state = 85},
  [3094] = {.lex_state = 3, .external_lex_state = 86},
  [3095] = {.lex_state = 3, .external_lex_state = 21},
  [3096] = {.lex_state = 3, .external_lex_state = 21},
  [3097] = {.lex_state = 3, .external_lex_state = 21},
  [3098] = {.lex_state = 4, .external_lex_state = 79},
  [3099] = {.lex_state = 3, .external_lex_state = 21},
  [3100] = {.lex_state = 3, .external_lex_state = 21},
  [3101] = {.lex_state = 1, .external_lex_state = 79},
  [3102] = {.lex_state = 3, .external_lex_state = 21},
  [3103] = {.lex_state = 3, .external_lex_state = 21},
  [3104] = {.lex_state = 3, .external_lex_state = 21},
  [3105] = {.lex_state = 3, .external_lex_state = 86},
  [3106] = {.lex_state = 3, .external_lex_state = 21},
  [3107] = {.lex_state = 3, .external_lex_state = 79},
  [3108] = {.lex_state = 4, .external_lex_state = 85},
  [3109] = {.lex_state = 3, .external_lex_state = 21},
  [3110] = {.lex_state = 3, .external_lex_state = 21},
  [3111] = {.lex_state = 3, .external_lex_state = 21},
  [3112] = {.lex_state = 3, .external_lex_state = 21},
  [3113] = {.lex_state = 4, .external_lex_state = 85},
  [3114] = {.lex_state = 3, .external_lex_state = 21},
  [3115] = {.lex_state = 4, .external_lex_state = 20},
  [3116] = {.lex_state = 3, .external_lex_state = 21},
  [3117] = {.lex_state = 3, .external_lex_state = 86},
  [3118] = {.lex_state = 3, .external_lex_state = 21},
  [3119] = {.lex_state = 3, .external_lex_state = 88},
  [3120] = {.lex_state = 3, .external_lex_state = 87},
  [3121] = {.lex_state = 3, .external_lex_state = 21},
  [3122] = {.lex_state = 3, .external_lex_state = 21},
  [3123] = {.lex_state = 3, .external_lex_state = 21},
  [3124] = {.lex_state = 4, .external_lex_state = 89},
  [3125] = {.lex_state = 3, .external_lex_state = 21},
  [3126] = {.lex_state = 3, .external_lex_state = 21},
  [3127] = {.lex_state = 4, .external_lex_state = 89},
  [3128] = {.lex_state = 3, .external_lex_state = 21},
  [3129] = {.lex_state = 3, .external_lex_state = 21},
  [3130] = {.lex_state = 3, .external_lex_state = 21},
  [3131] = {.lex_state = 4, .external_lex_state = 20},
  [3132] = {.lex_state = 4, .external_lex_state = 20},
  [3133] = {.lex_state = 4, .external_lex_state = 85},
  [3134] = {.lex_state = 3, .external_lex_state = 21},
  [3135] = {.lex_state = 4, .external_lex_state = 20},
  [3136] = {.lex_state = 4, .external_lex_state = 20},
  [3137] = {.lex_state = 3, .external_lex_state = 86},
  [3138] = {.lex_state = 4, .external_lex_state = 20},
  [3139] = {.lex_state = 3, .external_lex_state = 21},
  [3140] = {.lex_state = 3, .external_lex_state = 21},
  [3141] = {.lex_state = 3, .external_lex_state = 21},
  [3142] = {.lex_state = 4, .external_lex_state = 85},
  [3143] = {.lex_state = 1, .external_lex_state = 90},
  [3144] = {.lex_state = 8, .external_lex_state = 91},
  [3145] = {.lex_state = 3, .external_lex_state = 92},
  [3146] = {.lex_state = 8, .external_lex_state = 91},
  [3147] = {.lex_state = 4, .external_lex_state = 75},
  [3148] = {.lex_state = 3, .external_lex_state = 93},
  [3149] = {.lex_state = 3, .external_lex_state = 93},
  [3150] = {.lex_state = 4, .external_lex_state = 94},
  [3151] = {.lex_state = 8, .external_lex_state = 91},
  [3152] = {.lex_state = 4, .external_lex_state = 90},
  [3153] = {.lex_state = 3, .external_lex_state = 95},
  [3154] = {.lex_state = 8, .external_lex_state = 91},
  [3155] = {.lex_state = 4, .external_lex_state = 75},
  [3156] = {.lex_state = 4, .external_lex_state = 94},
  [3157] = {.lex_state = 3, .external_lex_state = 93},
  [3158] = {.lex_state = 3, .external_lex_state = 93},
  [3159] = {.lex_state = 3, .external_lex_state = 90},
  [3160] = {.lex_state = 4, .external_lex_state = 96},
  [3161] = {.lex_state = 8, .external_lex_state = 91},
  [3162] = {.lex_state = 1, .external_lex_state = 90},
  [3163] = {.lex_state = 4, .external_lex_state = 94},
  [3164] = {.lex_state = 4, .external_lex_state = 94},
  [3165] = {.lex_state = 3, .external_lex_state = 97},
  [3166] = {.lex_state = 3, .external_lex_state = 93},
  [3167] = {.lex_state = 3, .external_lex_state = 95},
  [3168] = {.lex_state = 4, .external_lex_state = 94},
  [3169] = {.lex_state = 4, .external_lex_state = 94},
  [3170] = {.lex_state = 8, .external_lex_state = 91},
  [3171] = {.lex_state = 8, .external_lex_state = 91},
  [3172] = {.lex_state = 8, .external_lex_state = 91},
  [3173] = {.lex_state = 4, .external_lex_state = 94},
  [3174] = {.lex_state = 4, .external_lex_state = 94},
  [3175] = {.lex_state = 4, .external_lex_state = 94},
  [3176] = {.lex_state = 8, .external_lex_state = 91},
  [3177] = {.lex_state = 4, .external_lex_state = 23},
  [3178] = {.lex_state = 3, .external_lex_state = 24},
  [3179] = {.lex_state = 4, .external_lex_state = 75},
  [3180] = {.lex_state = 1, .external_lex_state = 18},
  [3181] = {.lex_state = 4, .external_lex_state = 75},
  [3182] = {.lex_state = 3, .external_lex_state = 24},
  [3183] = {.lex_state = 3, .external_lex_state = 24},
  [3184] = {.lex_state = 4, .external_lex_state = 23},
  [3185] = {.lex_state = 3, .external_lex_state = 24},
  [3186] = {.lex_state = 1, .external_lex_state = 18},
  [3187] = {.lex_state = 1, .external_lex_state = 18},
  [3188] = {.lex_state = 4, .external_lex_state = 23},
  [3189] = {.lex_state = 3, .external_lex_state = 24},
  [3190] = {.lex_state = 1, .external_lex_state = 18},
  [3191] = {.lex_state = 4, .external_lex_state = 18},
  [3192] = {.lex_state = 1, .external_lex_state = 18},
  [3193] = {.lex_state = 1, .external_lex_state = 18},
  [3194] = {.lex_state = 4, .external_lex_state = 18},
  [3195] = {.lex_state = 3, .external_lex_state = 24},
  [3196] = {.lex_state = 4, .external_lex_state = 23},
  [3197] = {.lex_state = 4, .external_lex_state = 23},
  [3198] = {.lex_state = 3, .external_lex_state = 24},
  [3199] = {.lex_state = 1, .external_lex_state = 18},
  [3200] = {.lex_state = 1, .external_lex_state = 18},
  [3201] = {.lex_state = 1, .external_lex_state = 18},
  [3202] = {.lex_state = 1, .external_lex_state = 18},
  [3203] = {.lex_state = 1, .external_lex_state = 18},
  [3204] = {.lex_state = 1, .external_lex_state = 18},
  [3205] = {.lex_state = 1, .external_lex_state = 18},
  [3206] = {.lex_state = 4, .external_lex_state = 23},
  [3207] = {.lex_state = 4, .external_lex_state = 23},
  [3208] = {.lex_state = 1, .external_lex_state = 18},
  [3209] = {.lex_state = 3, .external_lex_state = 24},
  [3210] = {.lex_state = 4, .external_lex_state = 23},
  [3211] = {.lex_state = 4, .external_lex_state = 23},
  [3212] = {.lex_state = 1, .external_lex_state = 18},
  [3213] = {.lex_state = 1, .external_lex_state = 18},
  [3214] = {.lex_state = 3, .external_lex_state = 24},
  [3215] = {.lex_state = 3, .external_lex_state = 24},
  [3216] = {.lex_state = 1, .external_lex_state = 18},
  [3217] = {.lex_state = 3, .external_lex_state = 24},
  [3218] = {.lex_state = 4, .external_lex_state = 18},
  [3219] = {.lex_state = 3, .external_lex_state = 24},
  [3220] = {.lex_state = 4, .external_lex_state = 23},
  [3221] = {.lex_state = 4, .external_lex_state = 18},
  [3222] = {.lex_state = 3, .external_lex_state = 24},
  [3223] = {.lex_state = 4, .external_lex_state = 18},
  [3224] = {.lex_state = 4, .external_lex_state = 18},
  [3225] = {.lex_state = 4, .external_lex_state = 23},
  [3226] = {.lex_state = 4, .external_lex_state = 18},
  [3227] = {.lex_state = 4, .external_lex_state = 75},
  [3228] = {.lex_state = 4, .external_lex_state = 75},
  [3229] = {.lex_state = 4, .external_lex_state = 75},
  [3230] = {.lex_state = 4, .external_lex_state = 23},
  [3231] = {.lex_state = 4, .external_lex_state = 18},
  [3232] = {.lex_state = 4, .external_lex_state = 23},
  [3233] = {.lex_state = 4, .external_lex_state = 18},
  [3234] = {.lex_state = 4, .external_lex_state = 75},
  [3235] = {.lex_state = 4, .external_lex_state = 75},
  [3236] = {.lex_state = 4, .external_lex_state = 18},
  [3237] = {.lex_state = 3, .external_lex_state = 24},
  [3238] = {.lex_state = 4, .external_lex_state = 18},
  [3239] = {.lex_state = 3, .external_lex_state = 79},
  [3240] = {.lex_state = 3, .external_lex_state = 24},
  [3241] = {.lex_state = 3, .external_lex_state = 24},
  [3242] = {.lex_state = 4, .external_lex_state = 75},
  [3243] = {.lex_state = 4, .external_lex_state = 18},
  [3244] = {.lex_state = 3, .external_lex_state = 24},
  [3245] = {.lex_state = 3, .external_lex_state = 24},
  [3246] = {.lex_state = 4, .external_lex_state = 18},
  [3247] = {.lex_state = 3, .external_lex_state = 24},
  [3248] = {.lex_state = 3, .external_lex_state = 24},
  [3249] = {.lex_state = 4, .external_lex_state = 18},
  [3250] = {.lex_state = 1, .external_lex_state = 18},
  [3251] = {.lex_state = 1, .external_lex_state = 18},
  [3252] = {.lex_state = 4, .external_lex_state = 75},
  [3253] = {.lex_state = 3, .external_lex_state = 24},
  [3254] = {.lex_state = 4, .external_lex_state = 18},
  [3255] = {.lex_state = 4, .external_lex_state = 75},
  [3256] = {.lex_state = 4, .external_lex_state = 18},
  [3257] = {.lex_state = 4, .external_lex_state = 75},
  [3258] = {.lex_state = 4, .external_lex_state = 23},
  [3259] = {.lex_state = 1, .external_lex_state = 18},
  [3260] = {.lex_state = 4, .external_lex_state = 18},
  [3261] = {.lex_state = 4, .external_lex_state = 75},
  [3262] = {.lex_state = 4, .external_lex_state = 23},
  [3263] = {.lex_state = 3, .external_lex_state = 98},
  [3264] = {.lex_state = 4, .external_lex_state = 18},
  [3265] = {.lex_state = 4, .external_lex_state = 18},
  [3266] = {.lex_state = 4, .external_lex_state = 23},
  [3267] = {.lex_state = 4, .external_lex_state = 23},
  [3268] = {.lex_state = 4, .external_lex_state = 23},
  [3269] = {.lex_state = 1, .external_lex_state = 18},
  [3270] = {.lex_state = 4, .external_lex_state = 23},
  [3271] = {.lex_state = 4, .external_lex_state = 23},
  [3272] = {.lex_state = 4, .external_lex_state = 75},
  [3273] = {.lex_state = 4, .external_lex_state = 23},
  [3274] = {.lex_state = 4, .external_lex_state = 23},
  [3275] = {.lex_state = 3, .external_lex_state = 24},
  [3276] = {.lex_state = 4, .external_lex_state = 75},
  [3277] = {.lex_state = 4, .external_lex_state = 75},
  [3278] = {.lex_state = 1, .external_lex_state = 18},
  [3279] = {.lex_state = 3, .external_lex_state = 24},
  [3280] = {.lex_state = 4, .external_lex_state = 23},
  [3281] = {.lex_state = 4, .external_lex_state = 18},
  [3282] = {.lex_state = 4, .external_lex_state = 18},
  [3283] = {.lex_state = 1, .external_lex_state = 18},
  [3284] = {.lex_state = 4, .external_lex_state = 23},
  [3285] = {.lex_state = 3, .external_lex_state = 24},
  [3286] = {.lex_state = 4, .external_lex_state = 18},
  [3287] = {.lex_state = 4, .external_lex_state = 23},
  [3288] = {.lex_state = 3, .external_lex_state = 24},
  [3289] = {.lex_state = 3, .external_lex_state = 24},
  [3290] = {.lex_state = 4, .external_lex_state = 18},
  [3291] = {.lex_state = 3, .external_lex_state = 24},
  [3292] = {.lex_state = 4, .external_lex_state = 18},
  [3293] = {.lex_state = 1, .external_lex_state = 18},
  [3294] = {.lex_state = 4, .external_lex_state = 18},
  [3295] = {.lex_state = 4, .external_lex_state = 18},
  [3296] = {.lex_state = 4, .external_lex_state = 18},
  [3297] = {.lex_state = 3, .external_lex_state = 24},
  [3298] = {.lex_state = 4, .external_lex_state = 18},
  [3299] = {.lex_state = 4, .external_lex_state = 23},
  [3300] = {.lex_state = 4, .external_lex_state = 75},
  [3301] = {.lex_state = 4, .external_lex_state = 75},
  [3302] = {.lex_state = 4, .external_lex_state = 75},
  [3303] = {.lex_state = 4, .external_lex_state = 75},
  [3304] = {.lex_state = 4, .external_lex_state = 18},
  [3305] = {.lex_state = 4, .external_lex_state = 75},
  [3306] = {.lex_state = 3, .external_lex_state = 24},
  [3307] = {.lex_state = 4, .external_lex_state = 75},
  [3308] = {.lex_state = 4, .external_lex_state = 75},
  [3309] = {.lex_state = 4, .external_lex_state = 18},
  [3310] = {.lex_state = 4, .external_lex_state = 23},
  [3311] = {.lex_state = 4, .external_lex_state = 18},
  [3312] = {.lex_state = 3, .external_lex_state = 24},
  [3313] = {.lex_state = 4, .external_lex_state = 18},
  [3314] = {.lex_state = 4, .external_lex_state = 18},
  [3315] = {.lex_state = 3, .external_lex_state = 24},
  [3316] = {.lex_state = 1, .external_lex_state = 18},
  [3317] = {.lex_state = 3, .external_lex_state = 24},
  [3318] = {.lex_state = 4, .external_lex_state = 18},
  [3319] = {.lex_state = 3, .external_lex_state = 24},
  [3320] = {.lex_state = 4, .external_lex_state = 18},
  [3321] = {.lex_state = 4, .external_lex_state = 23},
  [3322] = {.lex_state = 4, .external_lex_state = 23},
  [3323] = {.lex_state = 3, .external_lex_state = 24},
  [3324] = {.lex_state = 1, .external_lex_state = 18},
  [3325] = {.lex_state = 4, .external_lex_state = 23},
  [3326] = {.lex_state = 1, .external_lex_state = 18},
  [3327] = {.lex_state = 1, .external_lex_state = 18},
  [3328] = {.lex_state = 4, .external_lex_state = 23},
  [3329] = {.lex_state = 4, .external_lex_state = 18},
  [3330] = {.lex_state = 3, .external_lex_state = 24},
  [3331] = {.lex_state = 4, .external_lex_state = 23},
  [3332] = {.lex_state = 1, .external_lex_state = 18},
  [3333] = {.lex_state = 4, .external_lex_state = 23},
  [3334] = {.lex_state = 4, .external_lex_state = 23},
  [3335] = {.lex_state = 3, .external_lex_state = 24},
  [3336] = {.lex_state = 3, .external_lex_state = 24},
  [3337] = {.lex_state = 4, .external_lex_state = 75},
  [3338] = {.lex_state = 4, .external_lex_state = 18},
  [3339] = {.lex_state = 4, .external_lex_state = 18},
  [3340] = {.lex_state = 4, .external_lex_state = 18},
  [3341] = {.lex_state = 4, .external_lex_state = 18},
  [3342] = {.lex_state = 3, .external_lex_state = 24},
  [3343] = {.lex_state = 1, .external_lex_state = 18},
  [3344] = {.lex_state = 3, .external_lex_state = 24},
  [3345] = {.lex_state = 4, .external_lex_state = 23},
  [3346] = {.lex_state = 4, .external_lex_state = 23},
  [3347] = {.lex_state = 4, .external_lex_state = 23},
  [3348] = {.lex_state = 1, .external_lex_state = 18},
  [3349] = {.lex_state = 1, .external_lex_state = 18},
  [3350] = {.lex_state = 1, .external_lex_state = 18},
  [3351] = {.lex_state = 3, .external_lex_state = 24},
  [3352] = {.lex_state = 4, .external_lex_state = 23},
  [3353] = {.lex_state = 4, .external_lex_state = 75},
  [3354] = {.lex_state = 1, .external_lex_state = 18},
  [3355] = {.lex_state = 4, .external_lex_state = 18},
  [3356] = {.lex_state = 4, .external_lex_state = 23},
  [3357] = {.lex_state = 1, .external_lex_state = 18},
  [3358] = {.lex_state = 1, .external_lex_state = 18},
  [3359] = {.lex_state = 1, .external_lex_state = 18},
  [3360] = {.lex_state = 3, .external_lex_state = 79},
  [3361] = {.lex_state = 1, .external_lex_state = 18},
  [3362] = {.lex_state = 4, .external_lex_state = 75},
  [3363] = {.lex_state = 3, .external_lex_state = 21},
  [3364] = {.lex_state = 4, .external_lex_state = 23},
  [3365] = {.lex_state = 1, .external_lex_state = 18},
  [3366] = {.lex_state = 3, .external_lex_state = 21},
  [3367] = {.lex_state = 1, .external_lex_state = 18},
  [3368] = {.lex_state = 4, .external_lex_state = 23},
  [3369] = {.lex_state = 1, .external_lex_state = 18},
  [3370] = {.lex_state = 1, .external_lex_state = 18},
  [3371] = {.lex_state = 4, .external_lex_state = 18},
  [3372] = {.lex_state = 1, .external_lex_state = 18},
  [3373] = {.lex_state = 1, .external_lex_state = 18},
  [3374] = {.lex_state = 3, .external_lex_state = 21},
  [3375] = {.lex_state = 4, .external_lex_state = 18},
  [3376] = {.lex_state = 4, .external_lex_state = 23},
  [3377] = {.lex_state = 1, .external_lex_state = 18},
  [3378] = {.lex_state = 3, .external_lex_state = 24},
  [3379] = {.lex_state = 1, .external_lex_state = 18},
  [3380] = {.lex_state = 4, .external_lex_state = 23},
  [3381] = {.lex_state = 3, .external_lex_state = 21},
  [3382] = {.lex_state = 4, .external_lex_state = 23},
  [3383] = {.lex_state = 1, .external_lex_state = 18},
  [3384] = {.lex_state = 4, .external_lex_state = 18},
  [3385] = {.lex_state = 1, .external_lex_state = 18},
  [3386] = {.lex_state = 4, .external_lex_state = 18},
  [3387] = {.lex_state = 3, .external_lex_state = 21},
  [3388] = {.lex_state = 4, .external_lex_state = 23},
  [3389] = {.lex_state = 4, .external_lex_state = 23},
  [3390] = {.lex_state = 3, .external_lex_state = 21},
  [3391] = {.lex_state = 3, .external_lex_state = 24},
  [3392] = {.lex_state = 3, .external_lex_state = 98},
  [3393] = {.lex_state = 3, .external_lex_state = 24},
  [3394] = {.lex_state = 1, .external_lex_state = 18},
  [3395] = {.lex_state = 3, .external_lex_state = 24},
  [3396] = {.lex_state = 3, .external_lex_state = 24},
  [3397] = {.lex_state = 4, .external_lex_state = 23},
  [3398] = {.lex_state = 3, .external_lex_state = 24},
  [3399] = {.lex_state = 3, .external_lex_state = 24},
  [3400] = {.lex_state = 4, .external_lex_state = 23},
  [3401] = {.lex_state = 4, .external_lex_state = 23},
  [3402] = {.lex_state = 4, .external_lex_state = 18},
  [3403] = {.lex_state = 3, .external_lex_state = 79},
  [3404] = {.lex_state = 1, .external_lex_state = 18},
  [3405] = {.lex_state = 4, .external_lex_state = 23},
  [3406] = {.lex_state = 3, .external_lex_state = 24},
  [3407] = {.lex_state = 4, .external_lex_state = 23},
  [3408] = {.lex_state = 4, .external_lex_state = 18},
  [3409] = {.lex_state = 4, .external_lex_state = 23},
  [3410] = {.lex_state = 1, .external_lex_state = 18},
  [3411] = {.lex_state = 4, .external_lex_state = 18},
  [3412] = {.lex_state = 4, .external_lex_state = 18},
  [3413] = {.lex_state = 4, .external_lex_state = 18},
  [3414] = {.lex_state = 4, .external_lex_state = 18},
  [3415] = {.lex_state = 4, .external_lex_state = 18},
  [3416] = {.lex_state = 3, .external_lex_state = 24},
  [3417] = {.lex_state = 1, .external_lex_state = 18},
  [3418] = {.lex_state = 3, .external_lex_state = 24},
  [3419] = {.lex_state = 3, .external_lex_state = 24},
  [3420] = {.lex_state = 3, .external_lex_state = 24},
  [3421] = {.lex_state = 3, .external_lex_state = 25},
  [3422] = {.lex_state = 3, .external_lex_state = 99},
  [3423] = {.lex_state = 3, .external_lex_state = 25},
  [3424] = {.lex_state = 4, .external_lex_state = 26},
  [3425] = {.lex_state = 3, .external_lex_state = 25},
  [3426] = {.lex_state = 3, .external_lex_state = 100},
  [3427] = {.lex_state = 3, .external_lex_state = 25},
  [3428] = {.lex_state = 1, .external_lex_state = 76},
  [3429] = {.lex_state = 4, .external_lex_state = 82},
  [3430] = {.lex_state = 3, .external_lex_state = 101},
  [3431] = {.lex_state = 1, .external_lex_state = 82},
  [3432] = {.lex_state = 1, .external_lex_state = 82},
  [3433] = {.lex_state = 3, .external_lex_state = 25},
  [3434] = {.lex_state = 1, .external_lex_state = 82},
  [3435] = {.lex_state = 3, .external_lex_state = 25},
  [3436] = {.lex_state = 4, .external_lex_state = 26},
  [3437] = {.lex_state = 4, .external_lex_state = 82},
  [3438] = {.lex_state = 3, .external_lex_state = 25},
  [3439] = {.lex_state = 3, .external_lex_state = 90},
  [3440] = {.lex_state = 4, .external_lex_state = 26},
  [3441] = {.lex_state = 4, .external_lex_state = 26},
  [3442] = {.lex_state = 4, .external_lex_state = 26},
  [3443] = {.lex_state = 3, .external_lex_state = 101},
  [3444] = {.lex_state = 3, .external_lex_state = 25},
  [3445] = {.lex_state = 3, .external_lex_state = 100},
  [3446] = {.lex_state = 3, .external_lex_state = 100},
  [3447] = {.lex_state = 4, .external_lex_state = 26},
  [3448] = {.lex_state = 1, .external_lex_state = 82},
  [3449] = {.lex_state = 3, .external_lex_state = 25},
  [3450] = {.lex_state = 3, .external_lex_state = 25},
  [3451] = {.lex_state = 3, .external_lex_state = 82},
  [3452] = {.lex_state = 3, .external_lex_state = 25},
  [3453] = {.lex_state = 3, .external_lex_state = 101},
  [3454] = {.lex_state = 4, .external_lex_state = 26},
  [3455] = {.lex_state = 3, .external_lex_state = 101},
  [3456] = {.lex_state = 3, .external_lex_state = 82},
  [3457] = {.lex_state = 1, .external_lex_state = 76},
  [3458] = {.lex_state = 4, .external_lex_state = 26},
  [3459] = {.lex_state = 3, .external_lex_state = 25},
  [3460] = {.lex_state = 3, .external_lex_state = 82},
  [3461] = {.lex_state = 3, .external_lex_state = 25},
  [3462] = {.lex_state = 4, .external_lex_state = 102},
  [3463] = {.lex_state = 4, .external_lex_state = 103},
  [3464] = {.lex_state = 3, .external_lex_state = 99},
  [3465] = {.lex_state = 4, .external_lex_state = 102},
  [3466] = {.lex_state = 4, .external_lex_state = 102},
  [3467] = {.lex_state = 3, .external_lex_state = 25},
  [3468] = {.lex_state = 3, .external_lex_state = 25},
  [3469] = {.lex_state = 3, .external_lex_state = 100},
  [3470] = {.lex_state = 4, .external_lex_state = 103},
  [3471] = {.lex_state = 3, .external_lex_state = 99},
  [3472] = {.lex_state = 4, .external_lex_state = 103},
  [3473] = {.lex_state = 1, .external_lex_state = 76},
  [3474] = {.lex_state = 3, .external_lex_state = 25},
  [3475] = {.lex_state = 3, .external_lex_state = 99},
  [3476] = {.lex_state = 4, .external_lex_state = 103},
  [3477] = {.lex_state = 3, .external_lex_state = 101},
  [3478] = {.lex_state = 1, .external_lex_state = 76},
  [3479] = {.lex_state = 3, .external_lex_state = 99},
  [3480] = {.lex_state = 1, .external_lex_state = 76},
  [3481] = {.lex_state = 4, .external_lex_state = 103},
  [3482] = {.lex_state = 3, .external_lex_state = 82},
  [3483] = {.lex_state = 3, .external_lex_state = 25},
  [3484] = {.lex_state = 1, .external_lex_state = 76},
  [3485] = {.lex_state = 3, .external_lex_state = 25},
  [3486] = {.lex_state = 4, .external_lex_state = 103},
  [3487] = {.lex_state = 3, .external_lex_state = 100},
  [3488] = {.lex_state = 3, .external_lex_state = 25},
  [3489] = {.lex_state = 3, .external_lex_state = 25},
  [3490] = {.lex_state = 1, .external_lex_state = 82},
  [3491] = {.lex_state = 1, .external_lex_state = 76},
  [3492] = {.lex_state = 4, .external_lex_state = 26},
  [3493] = {.lex_state = 4, .external_lex_state = 26},
  [3494] = {.lex_state = 4, .external_lex_state = 26},
  [3495] = {.lex_state = 4, .external_lex_state = 102},
  [3496] = {.lex_state = 1, .external_lex_state = 82},
  [3497] = {.lex_state = 1, .external_lex_state = 82},
  [3498] = {.lex_state = 1, .external_lex_state = 82},
  [3499] = {.lex_state = 4, .external_lex_state = 26},
  [3500] = {.lex_state = 1, .external_lex_state = 82},
  [3501] = {.lex_state = 3, .external_lex_state = 25},
  [3502] = {.lex_state = 3, .external_lex_state = 25},
  [3503] = {.lex_state = 4, .external_lex_state = 102},
  [3504] = {.lex_state = 3, .external_lex_state = 25},
  [3505] = {.lex_state = 1, .external_lex_state = 82},
  [3506] = {.lex_state = 4, .external_lex_state = 102},
  [3507] = {.lex_state = 3, .external_lex_state = 101},
  [3508] = {.lex_state = 4, .external_lex_state = 102},
  [3509] = {.lex_state = 4, .external_lex_state = 26},
  [3510] = {.lex_state = 4, .external_lex_state = 102},
  [3511] = {.lex_state = 3, .external_lex_state = 99},
  [3512] = {.lex_state = 1, .external_lex_state = 82},
  [3513] = {.lex_state = 1, .external_lex_state = 82},
  [3514] = {.lex_state = 3, .external_lex_state = 99},
  [3515] = {.lex_state = 3, .external_lex_state = 100},
  [3516] = {.lex_state = 3, .external_lex_state = 100},
  [3517] = {.lex_state = 3, .external_lex_state = 99},
  [3518] = {.lex_state = 3, .external_lex_state = 100},
  [3519] = {.lex_state = 4, .external_lex_state = 26},
  [3520] = {.lex_state = 3, .external_lex_state = 99},
  [3521] = {.lex_state = 4, .external_lex_state = 26},
  [3522] = {.lex_state = 1, .external_lex_state = 82},
  [3523] = {.lex_state = 4, .external_lex_state = 26},
  [3524] = {.lex_state = 1, .external_lex_state = 82},
  [3525] = {.lex_state = 4, .external_lex_state = 26},
  [3526] = {.lex_state = 1, .external_lex_state = 82},
  [3527] = {.lex_state = 4, .external_lex_state = 94},
  [3528] = {.lex_state = 4, .external_lex_state = 26},
  [3529] = {.lex_state = 1, .external_lex_state = 82},
  [3530] = {.lex_state = 3, .external_lex_state = 25},
  [3531] = {.lex_state = 4, .external_lex_state = 103},
  [3532] = {.lex_state = 3, .external_lex_state = 99},
  [3533] = {.lex_state = 3, .external_lex_state = 25},
  [3534] = {.lex_state = 4, .external_lex_state = 102},
  [3535] = {.lex_state = 3, .external_lex_state = 25},
  [3536] = {.lex_state = 3, .external_lex_state = 25},
  [3537] = {.lex_state = 3, .external_lex_state = 99},
  [3538] = {.lex_state = 1, .external_lex_state = 82},
  [3539] = {.lex_state = 4, .external_lex_state = 102},
  [3540] = {.lex_state = 4, .external_lex_state = 102},
  [3541] = {.lex_state = 4, .external_lex_state = 102},
  [3542] = {.lex_state = 4, .external_lex_state = 26},
  [3543] = {.lex_state = 4, .external_lex_state = 26},
  [3544] = {.lex_state = 4, .external_lex_state = 26},
  [3545] = {.lex_state = 3, .external_lex_state = 99},
  [3546] = {.lex_state = 3, .external_lex_state = 25},
  [3547] = {.lex_state = 3, .external_lex_state = 99},
  [3548] = {.lex_state = 3, .external_lex_state = 99},
  [3549] = {.lex_state = 3, .external_lex_state = 25},
  [3550] = {.lex_state = 3, .external_lex_state = 25},
  [3551] = {.lex_state = 3, .external_lex_state = 25},
  [3552] = {.lex_state = 3, .external_lex_state = 25},
  [3553] = {.lex_state = 4, .external_lex_state = 26},
  [3554] = {.lex_state = 4, .external_lex_state = 26},
  [3555] = {.lex_state = 4, .external_lex_state = 102},
  [3556] = {.lex_state = 3, .external_lex_state = 25},
  [3557] = {.lex_state = 4, .external_lex_state = 26},
  [3558] = {.lex_state = 3, .external_lex_state = 99},
  [3559] = {.lex_state = 3, .external_lex_state = 25},
  [3560] = {.lex_state = 4, .external_lex_state = 26},
  [3561] = {.lex_state = 3, .external_lex_state = 25},
  [3562] = {.lex_state = 3, .external_lex_state = 100},
  [3563] = {.lex_state = 4, .external_lex_state = 26},
  [3564] = {.lex_state = 4, .external_lex_state = 103},
  [3565] = {.lex_state = 3, .external_lex_state = 99},
  [3566] = {.lex_state = 3, .external_lex_state = 99},
  [3567] = {.lex_state = 3, .external_lex_state = 25},
  [3568] = {.lex_state = 3, .external_lex_state = 99},
  [3569] = {.lex_state = 3, .external_lex_state = 25},
  [3570] = {.lex_state = 3, .external_lex_state = 25},
  [3571] = {.lex_state = 4, .external_lex_state = 26},
  [3572] = {.lex_state = 3, .external_lex_state = 25},
  [3573] = {.lex_state = 3, .external_lex_state = 100},
  [3574] = {.lex_state = 4, .external_lex_state = 26},
  [3575] = {.lex_state = 3, .external_lex_state = 99},
  [3576] = {.lex_state = 3, .external_lex_state = 25},
  [3577] = {.lex_state = 4, .external_lex_state = 26},
  [3578] = {.lex_state = 3, .external_lex_state = 100},
  [3579] = {.lex_state = 3, .external_lex_state = 25},
  [3580] = {.lex_state = 3, .external_lex_state = 100},
  [3581] = {.lex_state = 4, .external_lex_state = 26},
  [3582] = {.lex_state = 3, .external_lex_state = 25},
  [3583] = {.lex_state = 4, .external_lex_state = 26},
  [3584] = {.lex_state = 3, .external_lex_state = 99},
  [3585] = {.lex_state = 3, .external_lex_state = 25},
  [3586] = {.lex_state = 3, .external_lex_state = 99},
  [3587] = {.lex_state = 4, .external_lex_state = 26},
  [3588] = {.lex_state = 4, .external_lex_state = 26},
  [3589] = {.lex_state = 3, .external_lex_state = 99},
  [3590] = {.lex_state = 3, .external_lex_state = 100},
  [3591] = {.lex_state = 3, .external_lex_state = 100},
  [3592] = {.lex_state = 4, .external_lex_state = 26},
  [3593] = {.lex_state = 4, .external_lex_state = 102},
  [3594] = {.lex_state = 3, .external_lex_state = 99},
  [3595] = {.lex_state = 1, .external_lex_state = 76},
  [3596] = {.lex_state = 3, .external_lex_state = 100},
  [3597] = {.lex_state = 4, .external_lex_state = 26},
  [3598] = {.lex_state = 3, .external_lex_state = 99},
  [3599] = {.lex_state = 1, .external_lex_state = 82},
  [3600] = {.lex_state = 1, .external_lex_state = 82},
  [3601] = {.lex_state = 1, .external_lex_state = 82},
  [3602] = {.lex_state = 4, .external_lex_state = 26},
  [3603] = {.lex_state = 3, .external_lex_state = 101},
  [3604] = {.lex_state = 4, .external_lex_state = 26},
  [3605] = {.lex_state = 4, .external_lex_state = 26},
  [3606] = {.lex_state = 4, .external_lex_state = 26},
  [3607] = {.lex_state = 4, .external_lex_state = 26},
  [3608] = {.lex_state = 1, .external_lex_state = 82},
  [3609] = {.lex_state = 3, .external_lex_state = 99},
  [3610] = {.lex_state = 3, .external_lex_state = 25},
  [3611] = {.lex_state = 1, .external_lex_state = 82},
  [3612] = {.lex_state = 4, .external_lex_state = 26},
  [3613] = {.lex_state = 3, .external_lex_state = 25},
  [3614] = {.lex_state = 4, .external_lex_state = 104},
  [3615] = {.lex_state = 1, .external_lex_state = 82},
  [3616] = {.lex_state = 3, .external_lex_state = 101},
  [3617] = {.lex_state = 3, .external_lex_state = 25},
  [3618] = {.lex_state = 1, .external_lex_state = 82},
  [3619] = {.lex_state = 4, .external_lex_state = 102},
  [3620] = {.lex_state = 4, .external_lex_state = 102},
  [3621] = {.lex_state = 3, .external_lex_state = 99},
  [3622] = {.lex_state = 1, .external_lex_state = 82},
  [3623] = {.lex_state = 4, .external_lex_state = 26},
  [3624] = {.lex_state = 3, .external_lex_state = 25},
  [3625] = {.lex_state = 3, .external_lex_state = 100},
  [3626] = {.lex_state = 4, .external_lex_state = 102},
  [3627] = {.lex_state = 1, .external_lex_state = 82},
  [3628] = {.lex_state = 4, .external_lex_state = 82},
  [3629] = {.lex_state = 4, .external_lex_state = 82},
  [3630] = {.lex_state = 4, .external_lex_state = 102},
  [3631] = {.lex_state = 4, .external_lex_state = 102},
  [3632] = {.lex_state = 4, .external_lex_state = 102},
  [3633] = {.lex_state = 4, .external_lex_state = 102},
  [3634] = {.lex_state = 3, .external_lex_state = 100},
  [3635] = {.lex_state = 4, .external_lex_state = 82},
  [3636] = {.lex_state = 4, .external_lex_state = 102},
  [3637] = {.lex_state = 3, .external_lex_state = 25},
  [3638] = {.lex_state = 4, .external_lex_state = 26},
  [3639] = {.lex_state = 3, .external_lex_state = 99},
  [3640] = {.lex_state = 1, .external_lex_state = 82},
  [3641] = {.lex_state = 3, .external_lex_state = 100},
  [3642] = {.lex_state = 3, .external_lex_state = 100},
  [3643] = {.lex_state = 4, .external_lex_state = 26},
  [3644] = {.lex_state = 4, .external_lex_state = 26},
  [3645] = {.lex_state = 3, .external_lex_state = 100},
  [3646] = {.lex_state = 4, .external_lex_state = 26},
  [3647] = {.lex_state = 1, .external_lex_state = 82},
  [3648] = {.lex_state = 3, .external_lex_state = 25},
  [3649] = {.lex_state = 4, .external_lex_state = 105},
  [3650] = {.lex_state = 3, .external_lex_state = 100},
  [3651] = {.lex_state = 3, .external_lex_state = 99},
  [3652] = {.lex_state = 3, .external_lex_state = 100},
  [3653] = {.lex_state = 1, .external_lex_state = 82},
  [3654] = {.lex_state = 3, .external_lex_state = 82},
  [3655] = {.lex_state = 4, .external_lex_state = 102},
  [3656] = {.lex_state = 3, .external_lex_state = 100},
  [3657] = {.lex_state = 3, .external_lex_state = 100},
  [3658] = {.lex_state = 4, .external_lex_state = 102},
  [3659] = {.lex_state = 3, .external_lex_state = 100},
  [3660] = {.lex_state = 4, .external_lex_state = 102},
  [3661] = {.lex_state = 4, .external_lex_state = 102},
  [3662] = {.lex_state = 4, .external_lex_state = 105},
  [3663] = {.lex_state = 4, .external_lex_state = 105},
  [3664] = {.lex_state = 3, .external_lex_state = 25},
  [3665] = {.lex_state = 1, .external_lex_state = 82},
  [3666] = {.lex_state = 4, .external_lex_state = 102},
  [3667] = {.lex_state = 4, .external_lex_state = 103},
  [3668] = {.lex_state = 4, .external_lex_state = 26},
  [3669] = {.lex_state = 4, .external_lex_state = 102},
  [3670] = {.lex_state = 1, .external_lex_state = 82},
  [3671] = {.lex_state = 4, .external_lex_state = 94},
  [3672] = {.lex_state = 3, .external_lex_state = 100},
  [3673] = {.lex_state = 4, .external_lex_state = 26},
  [3674] = {.lex_state = 4, .external_lex_state = 26},
  [3675] = {.lex_state = 4, .external_lex_state = 26},
  [3676] = {.lex_state = 1, .external_lex_state = 82},
  [3677] = {.lex_state = 3, .external_lex_state = 25},
  [3678] = {.lex_state = 4, .external_lex_state = 26},
  [3679] = {.lex_state = 4, .external_lex_state = 26},
  [3680] = {.lex_state = 3, .external_lex_state = 25},
  [3681] = {.lex_state = 3, .external_lex_state = 100},
  [3682] = {.lex_state = 3, .external_lex_state = 101},
  [3683] = {.lex_state = 3, .external_lex_state = 100},
  [3684] = {.lex_state = 1, .external_lex_state = 76},
  [3685] = {.lex_state = 3, .external_lex_state = 106},
  [3686] = {.lex_state = 3, .external_lex_state = 107},
  [3687] = {.lex_state = 4, .external_lex_state = 10},
  [3688] = {.lex_state = 4, .external_lex_state = 10},
  [3689] = {.lex_state = 3, .external_lex_state = 107},
  [3690] = {.lex_state = 3, .external_lex_state = 106},
  [3691] = {.lex_state = 4, .external_lex_state = 10},
  [3692] = {.lex_state = 4, .external_lex_state = 10},
  [3693] = {.lex_state = 4, .external_lex_state = 10},
  [3694] = {.lex_state = 3, .external_lex_state = 106},
  [3695] = {.lex_state = 4, .external_lex_state = 10},
  [3696] = {.lex_state = 4, .external_lex_state = 10},
  [3697] = {.lex_state = 4, .external_lex_state = 10},
  [3698] = {.lex_state = 4, .external_lex_state = 10},
  [3699] = {.lex_state = 4, .external_lex_state = 10},
  [3700] = {.lex_state = 4, .external_lex_state = 10},
  [3701] = {.lex_state = 4, .external_lex_state = 10},
  [3702] = {.lex_state = 4, .external_lex_state = 10},
  [3703] = {.lex_state = 4, .external_lex_state = 10},
  [3704] = {.lex_state = 3, .external_lex_state = 106},
  [3705] = {.lex_state = 3, .external_lex_state = 106},
  [3706] = {.lex_state = 3, .external_lex_state = 106},
  [3707] = {.lex_state = 4, .external_lex_state = 10},
  [3708] = {.lex_state = 3, .external_lex_state = 106},
  [3709] = {.lex_state = 4, .external_lex_state = 10},
  [3710] = {.lex_state = 3, .external_lex_state = 106},
  [3711] = {.lex_state = 4, .external_lex_state = 10},
  [3712] = {.lex_state = 4, .external_lex_state = 10},
  [3713] = {.lex_state = 3, .external_lex_state = 106},
  [3714] = {.lex_state = 3, .external_lex_state = 106},
  [3715] = {.lex_state = 4, .external_lex_state = 10},
  [3716] = {.lex_state = 3, .external_lex_state = 106},
  [3717] = {.lex_state = 4, .external_lex_state = 10},
  [3718] = {.lex_state = 4, .external_lex_state = 10},
  [3719] = {.lex_state = 3, .external_lex_state = 106},
  [3720] = {.lex_state = 4, .external_lex_state = 18},
  [3721] = {.lex_state = 4, .external_lex_state = 10},
  [3722] = {.lex_state = 4, .external_lex_state = 10},
  [3723] = {.lex_state = 4, .external_lex_state = 10},
  [3724] = {.lex_state = 3, .external_lex_state = 106},
  [3725] = {.lex_state = 4, .external_lex_state = 10},
  [3726] = {.lex_state = 4, .external_lex_state = 18},
  [3727] = {.lex_state = 4, .external_lex_state = 18},
  [3728] = {.lex_state = 4, .external_lex_state = 18},
  [3729] = {.lex_state = 4, .external_lex_state = 18},
  [3730] = {.lex_state = 4, .external_lex_state = 18},
  [3731] = {.lex_state = 3, .external_lex_state = 106},
  [3732] = {.lex_state = 4, .external_lex_state = 10},
  [3733] = {.lex_state = 4, .external_lex_state = 10},
  [3734] = {.lex_state = 3, .external_lex_state = 106},
  [3735] = {.lex_state = 3, .external_lex_state = 107},
  [3736] = {.lex_state = 3, .external_lex_state = 106},
  [3737] = {.lex_state = 3, .external_lex_state = 106},
  [3738] = {.lex_state = 4, .external_lex_state = 10},
  [3739] = {.lex_state = 3, .external_lex_state = 106},
  [3740] = {.lex_state = 4, .external_lex_state = 10},
  [3741] = {.lex_state = 4, .external_lex_state = 10},
  [3742] = {.lex_state = 4, .external_lex_state = 10},
  [3743] = {.lex_state = 4, .external_lex_state = 10},
  [3744] = {.lex_state = 3, .external_lex_state = 106},
  [3745] = {.lex_state = 4, .external_lex_state = 10},
  [3746] = {.lex_state = 4, .external_lex_state = 10},
  [3747] = {.lex_state = 4, .external_lex_state = 10},
  [3748] = {.lex_state = 4, .external_lex_state = 10},
  [3749] = {.lex_state = 4, .external_lex_state = 10},
  [3750] = {.lex_state = 4, .external_lex_state = 10},
  [3751] = {.lex_state = 3, .external_lex_state = 106},
  [3752] = {.lex_state = 4, .external_lex_state = 10},
  [3753] = {.lex_state = 4, .external_lex_state = 10},
  [3754] = {.lex_state = 3, .external_lex_state = 106},
  [3755] = {.lex_state = 4, .external_lex_state = 10},
  [3756] = {.lex_state = 3, .external_lex_state = 106},
  [3757] = {.lex_state = 1, .external_lex_state = 18},
  [3758] = {.lex_state = 1, .external_lex_state = 18},
  [3759] = {.lex_state = 4, .external_lex_state = 10},
  [3760] = {.lex_state = 4, .external_lex_state = 10},
  [3761] = {.lex_state = 4, .external_lex_state = 10},
  [3762] = {.lex_state = 1, .external_lex_state = 18},
  [3763] = {.lex_state = 3, .external_lex_state = 24},
  [3764] = {.lex_state = 3, .external_lex_state = 24},
  [3765] = {.lex_state = 3, .external_lex_state = 24},
  [3766] = {.lex_state = 3, .external_lex_state = 24},
  [3767] = {.lex_state = 1, .external_lex_state = 18},
  [3768] = {.lex_state = 1, .external_lex_state = 18},
  [3769] = {.lex_state = 3, .external_lex_state = 24},
  [3770] = {.lex_state = 3, .external_lex_state = 24},
  [3771] = {.lex_state = 4, .external_lex_state = 10},
  [3772] = {.lex_state = 4, .external_lex_state = 10},
  [3773] = {.lex_state = 4, .external_lex_state = 10},
  [3774] = {.lex_state = 4, .external_lex_state = 10},
  [3775] = {.lex_state = 3, .external_lex_state = 106},
  [3776] = {.lex_state = 3, .external_lex_state = 106},
  [3777] = {.lex_state = 3, .external_lex_state = 107},
  [3778] = {.lex_state = 3, .external_lex_state = 107},
  [3779] = {.lex_state = 3, .external_lex_state = 106},
  [3780] = {.lex_state = 3, .external_lex_state = 107},
  [3781] = {.lex_state = 4, .external_lex_state = 10},
  [3782] = {.lex_state = 3, .external_lex_state = 106},
  [3783] = {.lex_state = 4, .external_lex_state = 10},
  [3784] = {.lex_state = 3, .external_lex_state = 106},
  [3785] = {.lex_state = 3, .external_lex_state = 106},
  [3786] = {.lex_state = 3, .external_lex_state = 106},
  [3787] = {.lex_state = 3, .external_lex_state = 107},
  [3788] = {.lex_state = 1, .external_lex_state = 18},
  [3789] = {.lex_state = 4, .external_lex_state = 10},
  [3790] = {.lex_state = 3, .external_lex_state = 107},
  [3791] = {.lex_state = 4, .external_lex_state = 23},
  [3792] = {.lex_state = 3, .external_lex_state = 107},
  [3793] = {.lex_state = 4, .external_lex_state = 23},
  [3794] = {.lex_state = 4, .external_lex_state = 23},
  [3795] = {.lex_state = 3, .external_lex_state = 106},
  [3796] = {.lex_state = 3, .external_lex_state = 106},
  [3797] = {.lex_state = 4, .external_lex_state = 23},
  [3798] = {.lex_state = 4, .external_lex_state = 23},
  [3799] = {.lex_state = 4, .external_lex_state = 23},
  [3800] = {.lex_state = 3, .external_lex_state = 106},
  [3801] = {.lex_state = 3, .external_lex_state = 106},
  [3802] = {.lex_state = 4, .external_lex_state = 10},
  [3803] = {.lex_state = 8, .external_lex_state = 27},
  [3804] = {.lex_state = 3, .external_lex_state = 95},
  [3805] = {.lex_state = 8, .external_lex_state = 27},
  [3806] = {.lex_state = 8, .external_lex_state = 27},
  [3807] = {.lex_state = 8, .external_lex_state = 27},
  [3808] = {.lex_state = 8, .external_lex_state = 27},
  [3809] = {.lex_state = 3, .external_lex_state = 108},
  [3810] = {.lex_state = 8, .external_lex_state = 27},
  [3811] = {.lex_state = 8, .external_lex_state = 27},
  [3812] = {.lex_state = 3, .external_lex_state = 108},
  [3813] = {.lex_state = 4, .external_lex_state = 109},
  [3814] = {.lex_state = 8, .external_lex_state = 27},
  [3815] = {.lex_state = 4, .external_lex_state = 109},
  [3816] = {.lex_state = 3, .external_lex_state = 108},
  [3817] = {.lex_state = 3, .external_lex_state = 95},
  [3818] = {.lex_state = 4, .external_lex_state = 109},
  [3819] = {.lex_state = 8, .external_lex_state = 27},
  [3820] = {.lex_state = 4, .external_lex_state = 76},
  [3821] = {.lex_state = 4, .external_lex_state = 26},
  [3822] = {.lex_state = 8, .external_lex_state = 27},
  [3823] = {.lex_state = 4, .external_lex_state = 26},
  [3824] = {.lex_state = 4, .external_lex_state = 26},
  [3825] = {.lex_state = 8, .external_lex_state = 27},
  [3826] = {.lex_state = 8, .external_lex_state = 27},
  [3827] = {.lex_state = 8, .external_lex_state = 27},
  [3828] = {.lex_state = 3, .external_lex_state = 110},
  [3829] = {.lex_state = 4, .external_lex_state = 26},
  [3830] = {.lex_state = 8, .external_lex_state = 111},
  [3831] = {.lex_state = 8, .external_lex_state = 111},
  [3832] = {.lex_state = 4, .external_lex_state = 26},
  [3833] = {.lex_state = 3, .external_lex_state = 108},
  [3834] = {.lex_state = 8, .external_lex_state = 111},
  [3835] = {.lex_state = 3, .external_lex_state = 4},
  [3836] = {.lex_state = 1, .external_lex_state = 78},
  [3837] = {.lex_state = 4, .external_lex_state = 76},
  [3838] = {.lex_state = 4, .external_lex_state = 26},
  [3839] = {.lex_state = 8, .external_lex_state = 111},
  [3840] = {.lex_state = 8, .external_lex_state = 27},
  [3841] = {.lex_state = 8, .external_lex_state = 27},
  [3842] = {.lex_state = 8, .external_lex_state = 27},
  [3843] = {.lex_state = 8, .external_lex_state = 27},
  [3844] = {.lex_state = 8, .external_lex_state = 27},
  [3845] = {.lex_state = 8, .external_lex_state = 27},
  [3846] = {.lex_state = 8, .external_lex_state = 27},
  [3847] = {.lex_state = 3, .external_lex_state = 95},
  [3848] = {.lex_state = 8, .external_lex_state = 27},
  [3849] = {.lex_state = 8, .external_lex_state = 27},
  [3850] = {.lex_state = 8, .external_lex_state = 111},
  [3851] = {.lex_state = 8, .external_lex_state = 27},
  [3852] = {.lex_state = 3, .external_lex_state = 101},
  [3853] = {.lex_state = 3, .external_lex_state = 108},
  [3854] = {.lex_state = 3, .external_lex_state = 95},
  [3855] = {.lex_state = 8, .external_lex_state = 27},
  [3856] = {.lex_state = 3, .external_lex_state = 110},
  [3857] = {.lex_state = 3, .external_lex_state = 110},
  [3858] = {.lex_state = 8, .external_lex_state = 27},
  [3859] = {.lex_state = 4, .external_lex_state = 103},
  [3860] = {.lex_state = 8, .external_lex_state = 27},
  [3861] = {.lex_state = 3, .external_lex_state = 4},
  [3862] = {.lex_state = 1, .external_lex_state = 76},
  [3863] = {.lex_state = 3, .external_lex_state = 95},
  [3864] = {.lex_state = 8, .external_lex_state = 111},
  [3865] = {.lex_state = 3, .external_lex_state = 112},
  [3866] = {.lex_state = 8, .external_lex_state = 27},
  [3867] = {.lex_state = 3, .external_lex_state = 112},
  [3868] = {.lex_state = 8, .external_lex_state = 27},
  [3869] = {.lex_state = 8, .external_lex_state = 27},
  [3870] = {.lex_state = 3, .external_lex_state = 82},
  [3871] = {.lex_state = 1, .external_lex_state = 78},
  [3872] = {.lex_state = 3, .external_lex_state = 108},
  [3873] = {.lex_state = 3, .external_lex_state = 108},
  [3874] = {.lex_state = 3, .external_lex_state = 95},
  [3875] = {.lex_state = 1, .external_lex_state = 78},
  [3876] = {.lex_state = 3, .external_lex_state = 112},
  [3877] = {.lex_state = 3, .external_lex_state = 112},
  [3878] = {.lex_state = 4, .external_lex_state = 76},
  [3879] = {.lex_state = 3, .external_lex_state = 108},
  [3880] = {.lex_state = 8, .external_lex_state = 111},
  [3881] = {.lex_state = 4, .external_lex_state = 76},
  [3882] = {.lex_state = 3, .external_lex_state = 112},
  [3883] = {.lex_state = 3, .external_lex_state = 101},
  [3884] = {.lex_state = 3, .external_lex_state = 108},
  [3885] = {.lex_state = 3, .external_lex_state = 95},
  [3886] = {.lex_state = 8, .external_lex_state = 27},
  [3887] = {.lex_state = 8, .external_lex_state = 27},
  [3888] = {.lex_state = 8, .external_lex_state = 27},
  [3889] = {.lex_state = 3, .external_lex_state = 25},
  [3890] = {.lex_state = 4, .external_lex_state = 103},
  [3891] = {.lex_state = 8, .external_lex_state = 27},
  [3892] = {.lex_state = 8, .external_lex_state = 27},
  [3893] = {.lex_state = 3, .external_lex_state = 112},
  [3894] = {.lex_state = 8, .external_lex_state = 27},
  [3895] = {.lex_state = 4, .external_lex_state = 76},
  [3896] = {.lex_state = 8, .external_lex_state = 27},
  [3897] = {.lex_state = 8, .external_lex_state = 27},
  [3898] = {.lex_state = 8, .external_lex_state = 27},
  [3899] = {.lex_state = 8, .external_lex_state = 111},
  [3900] = {.lex_state = 8, .external_lex_state = 27},
  [3901] = {.lex_state = 3, .external_lex_state = 25},
  [3902] = {.lex_state = 3, .external_lex_state = 25},
  [3903] = {.lex_state = 8, .external_lex_state = 27},
  [3904] = {.lex_state = 3, .external_lex_state = 112},
  [3905] = {.lex_state = 3, .external_lex_state = 25},
  [3906] = {.lex_state = 8, .external_lex_state = 27},
  [3907] = {.lex_state = 3, .external_lex_state = 82},
  [3908] = {.lex_state = 8, .external_lex_state = 27},
  [3909] = {.lex_state = 3, .external_lex_state = 25},
  [3910] = {.lex_state = 3, .external_lex_state = 25},
  [3911] = {.lex_state = 8, .external_lex_state = 27},
  [3912] = {.lex_state = 8, .external_lex_state = 27},
  [3913] = {.lex_state = 8, .external_lex_state = 27},
  [3914] = {.lex_state = 8, .external_lex_state = 27},
  [3915] = {.lex_state = 1, .external_lex_state = 76},
  [3916] = {.lex_state = 8, .external_lex_state = 27},
  [3917] = {.lex_state = 4, .external_lex_state = 76},
  [3918] = {.lex_state = 8, .external_lex_state = 27},
  [3919] = {.lex_state = 8, .external_lex_state = 27},
  [3920] = {.lex_state = 4, .external_lex_state = 76},
  [3921] = {.lex_state = 3, .external_lex_state = 112},
  [3922] = {.lex_state = 8, .external_lex_state = 27},
  [3923] = {.lex_state = 3, .external_lex_state = 82},
  [3924] = {.lex_state = 3, .external_lex_state = 112},
  [3925] = {.lex_state = 8, .external_lex_state = 27},
  [3926] = {.lex_state = 4, .external_lex_state = 76},
  [3927] = {.lex_state = 4, .external_lex_state = 76},
  [3928] = {.lex_state = 8, .external_lex_state = 27},
  [3929] = {.lex_state = 3, .external_lex_state = 82},
  [3930] = {.lex_state = 3, .external_lex_state = 82},
  [3931] = {.lex_state = 8, .external_lex_state = 111},
  [3932] = {.lex_state = 1, .external_lex_state = 7},
  [3933] = {.lex_state = 3, .external_lex_state = 113},
  [3934] = {.lex_state = 4, .external_lex_state = 13},
  [3935] = {.lex_state = 4, .external_lex_state = 10},
  [3936] = {.lex_state = 4, .external_lex_state = 10},
  [3937] = {.lex_state = 4, .external_lex_state = 10},
  [3938] = {.lex_state = 4, .external_lex_state = 10},
  [3939] = {.lex_state = 4, .external_lex_state = 10},
  [3940] = {.lex_state = 4, .external_lex_state = 10},
  [3941] = {.lex_state = 4, .external_lex_state = 10},
  [3942] = {.lex_state = 4, .external_lex_state = 10},
  [3943] = {.lex_state = 4, .external_lex_state = 10},
  [3944] = {.lex_state = 4, .external_lex_state = 114},
  [3945] = {.lex_state = 4, .external_lex_state = 10},
  [3946] = {.lex_state = 4, .external_lex_state = 10},
  [3947] = {.lex_state = 4, .external_lex_state = 10},
  [3948] = {.lex_state = 4, .external_lex_state = 10},
  [3949] = {.lex_state = 4, .external_lex_state = 10},
  [3950] = {.lex_state = 4, .external_lex_state = 10},
  [3951] = {.lex_state = 4, .external_lex_state = 10},
  [3952] = {.lex_state = 4, .external_lex_state = 10},
  [3953] = {.lex_state = 3, .external_lex_state = 12},
  [3954] = {.lex_state = 3, .external_lex_state = 12},
  [3955] = {.lex_state = 4, .external_lex_state = 10},
  [3956] = {.lex_state = 4, .external_lex_state = 10},
  [3957] = {.lex_state = 4, .external_lex_state = 10},
  [3958] = {.lex_state = 4, .external_lex_state = 10},
  [3959] = {.lex_state = 4, .external_lex_state = 10},
  [3960] = {.lex_state = 4, .external_lex_state = 10},
  [3961] = {.lex_state = 4, .external_lex_state = 10},
  [3962] = {.lex_state = 4, .external_lex_state = 10},
  [3963] = {.lex_state = 3, .external_lex_state = 12},
  [3964] = {.lex_state = 3, .external_lex_state = 12},
  [3965] = {.lex_state = 4, .external_lex_state = 10},
  [3966] = {.lex_state = 4, .external_lex_state = 10},
  [3967] = {.lex_state = 4, .external_lex_state = 10},
  [3968] = {.lex_state = 4, .external_lex_state = 10},
  [3969] = {.lex_state = 4, .external_lex_state = 10},
  [3970] = {.lex_state = 4, .external_lex_state = 10},
  [3971] = {.lex_state = 4, .external_lex_state = 10},
  [3972] = {.lex_state = 4, .external_lex_state = 10},
  [3973] = {.lex_state = 4, .external_lex_state = 10},
  [3974] = {.lex_state = 3, .external_lex_state = 12},
  [3975] = {.lex_state = 3, .external_lex_state = 12},
  [3976] = {.lex_state = 4, .external_lex_state = 10},
  [3977] = {.lex_state = 4, .external_lex_state = 10},
  [3978] = {.lex_state = 4, .external_lex_state = 10},
  [3979] = {.lex_state = 4, .external_lex_state = 10},
  [3980] = {.lex_state = 4, .external_lex_state = 10},
  [3981] = {.lex_state = 4, .external_lex_state = 10},
  [3982] = {.lex_state = 4, .external_lex_state = 10},
  [3983] = {.lex_state = 4, .external_lex_state = 10},
  [3984] = {.lex_state = 4, .external_lex_state = 10},
  [3985] = {.lex_state = 4, .external_lex_state = 10},
  [3986] = {.lex_state = 4, .external_lex_state = 10},
  [3987] = {.lex_state = 3, .external_lex_state = 12},
  [3988] = {.lex_state = 1, .external_lex_state = 7},
  [3989] = {.lex_state = 3, .external_lex_state = 12},
  [3990] = {.lex_state = 4, .external_lex_state = 10},
  [3991] = {.lex_state = 4, .external_lex_state = 10},
  [3992] = {.lex_state = 4, .external_lex_state = 10},
  [3993] = {.lex_state = 4, .external_lex_state = 10},
  [3994] = {.lex_state = 1, .external_lex_state = 7},
  [3995] = {.lex_state = 3, .external_lex_state = 12},
  [3996] = {.lex_state = 3, .external_lex_state = 12},
  [3997] = {.lex_state = 3, .external_lex_state = 12},
  [3998] = {.lex_state = 4, .external_lex_state = 10},
  [3999] = {.lex_state = 4, .external_lex_state = 10},
  [4000] = {.lex_state = 3, .external_lex_state = 12},
  [4001] = {.lex_state = 3, .external_lex_state = 12},
  [4002] = {.lex_state = 3, .external_lex_state = 12},
  [4003] = {.lex_state = 3, .external_lex_state = 12},
  [4004] = {.lex_state = 3, .external_lex_state = 12},
  [4005] = {.lex_state = 3, .external_lex_state = 12},
  [4006] = {.lex_state = 3, .external_lex_state = 12},
  [4007] = {.lex_state = 4, .external_lex_state = 10},
  [4008] = {.lex_state = 3, .external_lex_state = 12},
  [4009] = {.lex_state = 4, .external_lex_state = 10},
  [4010] = {.lex_state = 4, .external_lex_state = 10},
  [4011] = {.lex_state = 4, .external_lex_state = 10},
  [4012] = {.lex_state = 4, .external_lex_state = 10},
  [4013] = {.lex_state = 4, .external_lex_state = 10},
  [4014] = {.lex_state = 4, .external_lex_state = 10},
  [4015] = {.lex_state = 4, .external_lex_state = 10},
  [4016] = {.lex_state = 3, .external_lex_state = 12},
  [4017] = {.lex_state = 4, .external_lex_state = 10},
  [4018] = {.lex_state = 4, .external_lex_state = 13},
  [4019] = {.lex_state = 4, .external_lex_state = 10},
  [4020] = {.lex_state = 1, .external_lex_state = 7},
  [4021] = {.lex_state = 3, .external_lex_state = 12},
  [4022] = {.lex_state = 4, .external_lex_state = 114},
  [4023] = {.lex_state = 4, .external_lex_state = 10},
  [4024] = {.lex_state = 4, .external_lex_state = 10},
  [4025] = {.lex_state = 4, .external_lex_state = 10},
  [4026] = {.lex_state = 4, .external_lex_state = 10},
  [4027] = {.lex_state = 1, .external_lex_state = 7},
  [4028] = {.lex_state = 4, .external_lex_state = 114},
  [4029] = {.lex_state = 1, .external_lex_state = 7},
  [4030] = {.lex_state = 3, .external_lex_state = 12},
  [4031] = {.lex_state = 1, .external_lex_state = 7},
  [4032] = {.lex_state = 1, .external_lex_state = 7},
  [4033] = {.lex_state = 3, .external_lex_state = 12},
  [4034] = {.lex_state = 3, .external_lex_state = 12},
  [4035] = {.lex_state = 3, .external_lex_state = 12},
  [4036] = {.lex_state = 4, .external_lex_state = 13},
  [4037] = {.lex_state = 1, .external_lex_state = 7},
  [4038] = {.lex_state = 3, .external_lex_state = 12},
  [4039] = {.lex_state = 4, .external_lex_state = 114},
  [4040] = {.lex_state = 3, .external_lex_state = 12},
  [4041] = {.lex_state = 1, .external_lex_state = 7},
  [4042] = {.lex_state = 3, .external_lex_state = 12},
  [4043] = {.lex_state = 1, .external_lex_state = 7},
  [4044] = {.lex_state = 3, .external_lex_state = 12},
  [4045] = {.lex_state = 3, .external_lex_state = 12},
  [4046] = {.lex_state = 1, .external_lex_state = 7},
  [4047] = {.lex_state = 1, .external_lex_state = 7},
  [4048] = {.lex_state = 4, .external_lex_state = 13},
  [4049] = {.lex_state = 3, .external_lex_state = 12},
  [4050] = {.lex_state = 4, .external_lex_state = 10},
  [4051] = {.lex_state = 4, .external_lex_state = 10},
  [4052] = {.lex_state = 4, .external_lex_state = 10},
  [4053] = {.lex_state = 3, .external_lex_state = 12},
  [4054] = {.lex_state = 3, .external_lex_state = 12},
  [4055] = {.lex_state = 4, .external_lex_state = 10},
  [4056] = {.lex_state = 1, .external_lex_state = 7},
  [4057] = {.lex_state = 3, .external_lex_state = 12},
  [4058] = {.lex_state = 3, .external_lex_state = 12},
  [4059] = {.lex_state = 4, .external_lex_state = 10},
  [4060] = {.lex_state = 1, .external_lex_state = 7},
  [4061] = {.lex_state = 1, .external_lex_state = 7},
  [4062] = {.lex_state = 1, .external_lex_state = 7},
  [4063] = {.lex_state = 4, .external_lex_state = 10},
  [4064] = {.lex_state = 4, .external_lex_state = 13},
  [4065] = {.lex_state = 1, .external_lex_state = 7},
  [4066] = {.lex_state = 1, .external_lex_state = 7},
  [4067] = {.lex_state = 3, .external_lex_state = 12},
  [4068] = {.lex_state = 1, .external_lex_state = 7},
  [4069] = {.lex_state = 4, .external_lex_state = 10},
  [4070] = {.lex_state = 1, .external_lex_state = 7},
  [4071] = {.lex_state = 1, .external_lex_state = 7},
  [4072] = {.lex_state = 4, .external_lex_state = 10},
  [4073] = {.lex_state = 1, .external_lex_state = 7},
  [4074] = {.lex_state = 4, .external_lex_state = 13},
  [4075] = {.lex_state = 4, .external_lex_state = 13},
  [4076] = {.lex_state = 4, .external_lex_state = 13},
  [4077] = {.lex_state = 4, .external_lex_state = 10},
  [4078] = {.lex_state = 4, .external_lex_state = 13},
  [4079] = {.lex_state = 4, .external_lex_state = 114},
  [4080] = {.lex_state = 4, .external_lex_state = 13},
  [4081] = {.lex_state = 4, .external_lex_state = 13},
  [4082] = {.lex_state = 4, .external_lex_state = 13},
  [4083] = {.lex_state = 3, .external_lex_state = 12},
  [4084] = {.lex_state = 4, .external_lex_state = 13},
  [4085] = {.lex_state = 4, .external_lex_state = 13},
  [4086] = {.lex_state = 3, .external_lex_state = 12},
  [4087] = {.lex_state = 3, .external_lex_state = 12},
  [4088] = {.lex_state = 1, .external_lex_state = 7},
  [4089] = {.lex_state = 4, .external_lex_state = 13},
  [4090] = {.lex_state = 1, .external_lex_state = 7},
  [4091] = {.lex_state = 4, .external_lex_state = 114},
  [4092] = {.lex_state = 1, .external_lex_state = 7},
  [4093] = {.lex_state = 1, .external_lex_state = 7},
  [4094] = {.lex_state = 1, .external_lex_state = 7},
  [4095] = {.lex_state = 3, .external_lex_state = 12},
  [4096] = {.lex_state = 4, .external_lex_state = 10},
  [4097] = {.lex_state = 4, .external_lex_state = 13},
  [4098] = {.lex_state = 4, .external_lex_state = 13},
  [4099] = {.lex_state = 4, .external_lex_state = 10},
  [4100] = {.lex_state = 4, .external_lex_state = 10},
  [4101] = {.lex_state = 4, .external_lex_state = 10},
  [4102] = {.lex_state = 4, .external_lex_state = 10},
  [4103] = {.lex_state = 3, .external_lex_state = 12},
  [4104] = {.lex_state = 3, .external_lex_state = 12},
  [4105] = {.lex_state = 4, .external_lex_state = 10},
  [4106] = {.lex_state = 3, .external_lex_state = 12},
  [4107] = {.lex_state = 4, .external_lex_state = 13},
  [4108] = {.lex_state = 4, .external_lex_state = 10},
  [4109] = {.lex_state = 4, .external_lex_state = 10},
  [4110] = {.lex_state = 4, .external_lex_state = 10},
  [4111] = {.lex_state = 1, .external_lex_state = 7},
  [4112] = {.lex_state = 4, .external_lex_state = 13},
  [4113] = {.lex_state = 4, .external_lex_state = 10},
  [4114] = {.lex_state = 1, .external_lex_state = 7},
  [4115] = {.lex_state = 4, .external_lex_state = 13},
  [4116] = {.lex_state = 4, .external_lex_state = 13},
  [4117] = {.lex_state = 4, .external_lex_state = 10},
  [4118] = {.lex_state = 4, .external_lex_state = 13},
  [4119] = {.lex_state = 3, .external_lex_state = 12},
  [4120] = {.lex_state = 1, .external_lex_state = 7},
  [4121] = {.lex_state = 4, .external_lex_state = 10},
  [4122] = {.lex_state = 1, .external_lex_state = 7},
  [4123] = {.lex_state = 1, .external_lex_state = 7},
  [4124] = {.lex_state = 4, .external_lex_state = 13},
  [4125] = {.lex_state = 1, .external_lex_state = 7},
  [4126] = {.lex_state = 4, .external_lex_state = 10},
  [4127] = {.lex_state = 4, .external_lex_state = 13},
  [4128] = {.lex_state = 1, .external_lex_state = 7},
  [4129] = {.lex_state = 4, .external_lex_state = 10},
  [4130] = {.lex_state = 4, .external_lex_state = 10},
  [4131] = {.lex_state = 4, .external_lex_state = 10},
  [4132] = {.lex_state = 4, .external_lex_state = 13},
  [4133] = {.lex_state = 4, .external_lex_state = 13},
  [4134] = {.lex_state = 4, .external_lex_state = 10},
  [4135] = {.lex_state = 4, .external_lex_state = 10},
  [4136] = {.lex_state = 4, .external_lex_state = 10},
  [4137] = {.lex_state = 4, .external_lex_state = 10},
  [4138] = {.lex_state = 4, .external_lex_state = 13},
  [4139] = {.lex_state = 4, .external_lex_state = 13},
  [4140] = {.lex_state = 4, .external_lex_state = 10},
  [4141] = {.lex_state = 4, .external_lex_state = 10},
  [4142] = {.lex_state = 4, .external_lex_state = 10},
  [4143] = {.lex_state = 4, .external_lex_state = 10},
  [4144] = {.lex_state = 3, .external_lex_state = 12},
  [4145] = {.lex_state = 4, .external_lex_state = 10},
  [4146] = {.lex_state = 3, .external_lex_state = 12},
  [4147] = {.lex_state = 3, .external_lex_state = 12},
  [4148] = {.lex_state = 1, .external_lex_state = 7},
  [4149] = {.lex_state = 4, .external_lex_state = 10},
  [4150] = {.lex_state = 1, .external_lex_state = 7},
  [4151] = {.lex_state = 1, .external_lex_state = 7},
  [4152] = {.lex_state = 4, .external_lex_state = 10},
  [4153] = {.lex_state = 3, .external_lex_state = 107},
  [4154] = {.lex_state = 4, .external_lex_state = 10},
  [4155] = {.lex_state = 1, .external_lex_state = 7},
  [4156] = {.lex_state = 4, .external_lex_state = 10},
  [4157] = {.lex_state = 1, .external_lex_state = 7},
  [4158] = {.lex_state = 4, .external_lex_state = 10},
  [4159] = {.lex_state = 1, .external_lex_state = 7},
  [4160] = {.lex_state = 4, .external_lex_state = 10},
  [4161] = {.lex_state = 4, .external_lex_state = 10},
  [4162] = {.lex_state = 4, .external_lex_state = 13},
  [4163] = {.lex_state = 4, .external_lex_state = 10},
  [4164] = {.lex_state = 4, .external_lex_state = 13},
  [4165] = {.lex_state = 3, .external_lex_state = 12},
  [4166] = {.lex_state = 4, .external_lex_state = 10},
  [4167] = {.lex_state = 4, .external_lex_state = 13},
  [4168] = {.lex_state = 4, .external_lex_state = 13},
  [4169] = {.lex_state = 4, .external_lex_state = 10},
  [4170] = {.lex_state = 4, .external_lex_state = 13},
  [4171] = {.lex_state = 1, .external_lex_state = 7},
  [4172] = {.lex_state = 1, .external_lex_state = 7},
  [4173] = {.lex_state = 4, .external_lex_state = 10},
  [4174] = {.lex_state = 3, .external_lex_state = 4},
  [4175] = {.lex_state = 4, .external_lex_state = 13},
  [4176] = {.lex_state = 4, .external_lex_state = 10},
  [4177] = {.lex_state = 1, .external_lex_state = 7},
  [4178] = {.lex_state = 4, .external_lex_state = 10},
  [4179] = {.lex_state = 4, .external_lex_state = 13},
  [4180] = {.lex_state = 4, .external_lex_state = 13},
  [4181] = {.lex_state = 4, .external_lex_state = 10},
  [4182] = {.lex_state = 4, .external_lex_state = 13},
  [4183] = {.lex_state = 4, .external_lex_state = 13},
  [4184] = {.lex_state = 4, .external_lex_state = 13},
  [4185] = {.lex_state = 3, .external_lex_state = 12},
  [4186] = {.lex_state = 4, .external_lex_state = 13},
  [4187] = {.lex_state = 4, .external_lex_state = 13},
  [4188] = {.lex_state = 1, .external_lex_state = 7},
  [4189] = {.lex_state = 4, .external_lex_state = 13},
  [4190] = {.lex_state = 4, .external_lex_state = 10},
  [4191] = {.lex_state = 1, .external_lex_state = 7},
  [4192] = {.lex_state = 4, .external_lex_state = 10},
  [4193] = {.lex_state = 4, .external_lex_state = 13},
  [4194] = {.lex_state = 4, .external_lex_state = 10},
  [4195] = {.lex_state = 3, .external_lex_state = 12},
  [4196] = {.lex_state = 1, .external_lex_state = 7},
  [4197] = {.lex_state = 4, .external_lex_state = 10},
  [4198] = {.lex_state = 4, .external_lex_state = 10},
  [4199] = {.lex_state = 4, .external_lex_state = 10},
  [4200] = {.lex_state = 3, .external_lex_state = 12},
  [4201] = {.lex_state = 4, .external_lex_state = 114},
  [4202] = {.lex_state = 4, .external_lex_state = 10},
  [4203] = {.lex_state = 4, .external_lex_state = 10},
  [4204] = {.lex_state = 4, .external_lex_state = 10},
  [4205] = {.lex_state = 4, .external_lex_state = 13},
  [4206] = {.lex_state = 3, .external_lex_state = 107},
  [4207] = {.lex_state = 4, .external_lex_state = 10},
  [4208] = {.lex_state = 4, .external_lex_state = 10},
  [4209] = {.lex_state = 4, .external_lex_state = 13},
  [4210] = {.lex_state = 4, .external_lex_state = 13},
  [4211] = {.lex_state = 1, .external_lex_state = 7},
  [4212] = {.lex_state = 4, .external_lex_state = 114},
  [4213] = {.lex_state = 1, .external_lex_state = 7},
  [4214] = {.lex_state = 4, .external_lex_state = 10},
  [4215] = {.lex_state = 4, .external_lex_state = 13},
  [4216] = {.lex_state = 4, .external_lex_state = 13},
  [4217] = {.lex_state = 4, .external_lex_state = 10},
  [4218] = {.lex_state = 4, .external_lex_state = 10},
  [4219] = {.lex_state = 1, .external_lex_state = 7},
  [4220] = {.lex_state = 4, .external_lex_state = 10},
  [4221] = {.lex_state = 4, .external_lex_state = 114},
  [4222] = {.lex_state = 4, .external_lex_state = 13},
  [4223] = {.lex_state = 4, .external_lex_state = 10},
  [4224] = {.lex_state = 4, .external_lex_state = 13},
  [4225] = {.lex_state = 4, .external_lex_state = 13},
  [4226] = {.lex_state = 1, .external_lex_state = 7},
  [4227] = {.lex_state = 1, .external_lex_state = 7},
  [4228] = {.lex_state = 4, .external_lex_state = 10},
  [4229] = {.lex_state = 3, .external_lex_state = 113},
  [4230] = {.lex_state = 3, .external_lex_state = 113},
  [4231] = {.lex_state = 4, .external_lex_state = 10},
  [4232] = {.lex_state = 4, .external_lex_state = 13},
  [4233] = {.lex_state = 3, .external_lex_state = 12},
  [4234] = {.lex_state = 4, .external_lex_state = 10},
  [4235] = {.lex_state = 3, .external_lex_state = 14},
  [4236] = {.lex_state = 3, .external_lex_state = 115},
  [4237] = {.lex_state = 3, .external_lex_state = 14},
  [4238] = {.lex_state = 3, .external_lex_state = 116},
  [4239] = {.lex_state = 3, .external_lex_state = 116},
  [4240] = {.lex_state = 3, .external_lex_state = 14},
  [4241] = {.lex_state = 3, .external_lex_state = 14},
  [4242] = {.lex_state = 3, .external_lex_state = 14},
  [4243] = {.lex_state = 3, .external_lex_state = 14},
  [4244] = {.lex_state = 3, .external_lex_state = 14},
  [4245] = {.lex_state = 3, .external_lex_state = 14},
  [4246] = {.lex_state = 3, .external_lex_state = 14},
  [4247] = {.lex_state = 3, .external_lex_state = 4},
  [4248] = {.lex_state = 3, .external_lex_state = 14},
  [4249] = {.lex_state = 3, .external_lex_state = 14},
  [4250] = {.lex_state = 3, .external_lex_state = 14},
  [4251] = {.lex_state = 3, .external_lex_state = 14},
  [4252] = {.lex_state = 3, .external_lex_state = 14},
  [4253] = {.lex_state = 3, .external_lex_state = 14},
  [4254] = {.lex_state = 11, .external_lex_state = 117},
  [4255] = {.lex_state = 3, .external_lex_state = 14},
  [4256] = {.lex_state = 3, .external_lex_state = 14},
  [4257] = {.lex_state = 3, .external_lex_state = 14},
  [4258] = {.lex_state = 3, .external_lex_state = 14},
  [4259] = {.lex_state = 3, .external_lex_state = 116},
  [4260] = {.lex_state = 3, .external_lex_state = 4},
  [4261] = {.lex_state = 3, .external_lex_state = 14},
  [4262] = {.lex_state = 3, .external_lex_state = 14},
  [4263] = {.lex_state = 3, .external_lex_state = 14},
  [4264] = {.lex_state = 3, .external_lex_state = 14},
  [4265] = {.lex_state = 3, .external_lex_state = 14},
  [4266] = {.lex_state = 3, .external_lex_state = 14},
  [4267] = {.lex_state = 3, .external_lex_state = 14},
  [4268] = {.lex_state = 3, .external_lex_state = 14},
  [4269] = {.lex_state = 3, .external_lex_state = 14},
  [4270] = {.lex_state = 3, .external_lex_state = 108},
  [4271] = {.lex_state = 3, .external_lex_state = 14},
  [4272] = {.lex_state = 3, .external_lex_state = 14},
  [4273] = {.lex_state = 3, .external_lex_state = 14},
  [4274] = {.lex_state = 3, .external_lex_state = 14},
  [4275] = {.lex_state = 3, .external_lex_state = 14},
  [4276] = {.lex_state = 3, .external_lex_state = 14},
  [4277] = {.lex_state = 4, .external_lex_state = 76},
  [4278] = {.lex_state = 3, .external_lex_state = 14},
  [4279] = {.lex_state = 3, .external_lex_state = 14},
  [4280] = {.lex_state = 3, .external_lex_state = 14},
  [4281] = {.lex_state = 3, .external_lex_state = 108},
  [4282] = {.lex_state = 3, .external_lex_state = 14},
  [4283] = {.lex_state = 4, .external_lex_state = 78},
  [4284] = {.lex_state = 3, .external_lex_state = 14},
  [4285] = {.lex_state = 4, .external_lex_state = 78},
  [4286] = {.lex_state = 3, .external_lex_state = 14},
  [4287] = {.lex_state = 3, .external_lex_state = 14},
  [4288] = {.lex_state = 3, .external_lex_state = 14},
  [4289] = {.lex_state = 3, .external_lex_state = 115},
  [4290] = {.lex_state = 3, .external_lex_state = 115},
  [4291] = {.lex_state = 3, .external_lex_state = 14},
  [4292] = {.lex_state = 4, .external_lex_state = 76},
  [4293] = {.lex_state = 3, .external_lex_state = 14},
  [4294] = {.lex_state = 3, .external_lex_state = 14},
  [4295] = {.lex_state = 3, .external_lex_state = 14},
  [4296] = {.lex_state = 3, .external_lex_state = 112},
  [4297] = {.lex_state = 3, .external_lex_state = 14},
  [4298] = {.lex_state = 3, .external_lex_state = 14},
  [4299] = {.lex_state = 3, .external_lex_state = 14},
  [4300] = {.lex_state = 3, .external_lex_state = 112},
  [4301] = {.lex_state = 3, .external_lex_state = 14},
  [4302] = {.lex_state = 3, .external_lex_state = 14},
  [4303] = {.lex_state = 4, .external_lex_state = 78},
  [4304] = {.lex_state = 3, .external_lex_state = 14},
  [4305] = {.lex_state = 4, .external_lex_state = 13},
  [4306] = {.lex_state = 1, .external_lex_state = 7},
  [4307] = {.lex_state = 1, .external_lex_state = 7},
  [4308] = {.lex_state = 1, .external_lex_state = 7},
  [4309] = {.lex_state = 1, .external_lex_state = 7},
  [4310] = {.lex_state = 4, .external_lex_state = 114},
  [4311] = {.lex_state = 4, .external_lex_state = 7},
  [4312] = {.lex_state = 4, .external_lex_state = 13},
  [4313] = {.lex_state = 3, .external_lex_state = 16},
  [4314] = {.lex_state = 3, .external_lex_state = 16},
  [4315] = {.lex_state = 3, .external_lex_state = 16},
  [4316] = {.lex_state = 4, .external_lex_state = 7},
  [4317] = {.lex_state = 3, .external_lex_state = 16},
  [4318] = {.lex_state = 3, .external_lex_state = 16},
  [4319] = {.lex_state = 3, .external_lex_state = 16},
  [4320] = {.lex_state = 1, .external_lex_state = 7},
  [4321] = {.lex_state = 4, .external_lex_state = 7},
  [4322] = {.lex_state = 3, .external_lex_state = 15},
  [4323] = {.lex_state = 4, .external_lex_state = 7},
  [4324] = {.lex_state = 3, .external_lex_state = 16},
  [4325] = {.lex_state = 3, .external_lex_state = 16},
  [4326] = {.lex_state = 3, .external_lex_state = 16},
  [4327] = {.lex_state = 3, .external_lex_state = 16},
  [4328] = {.lex_state = 3, .external_lex_state = 16},
  [4329] = {.lex_state = 3, .external_lex_state = 16},
  [4330] = {.lex_state = 3, .external_lex_state = 16},
  [4331] = {.lex_state = 4, .external_lex_state = 7},
  [4332] = {.lex_state = 1, .external_lex_state = 7},
  [4333] = {.lex_state = 1, .external_lex_state = 7},
  [4334] = {.lex_state = 1, .external_lex_state = 7},
  [4335] = {.lex_state = 4, .external_lex_state = 7},
  [4336] = {.lex_state = 1, .external_lex_state = 7},
  [4337] = {.lex_state = 1, .external_lex_state = 7},
  [4338] = {.lex_state = 3, .external_lex_state = 15},
  [4339] = {.lex_state = 3, .external_lex_state = 16},
  [4340] = {.lex_state = 1, .external_lex_state = 7},
  [4341] = {.lex_state = 1, .external_lex_state = 7},
  [4342] = {.lex_state = 3, .external_lex_state = 16},
  [4343] = {.lex_state = 3, .external_lex_state = 16},
  [4344] = {.lex_state = 1, .external_lex_state = 7},
  [4345] = {.lex_state = 3, .external_lex_state = 16},
  [4346] = {.lex_state = 3, .external_lex_state = 16},
  [4347] = {.lex_state = 3, .external_lex_state = 16},
  [4348] = {.lex_state = 3, .external_lex_state = 16},
  [4349] = {.lex_state = 3, .external_lex_state = 16},
  [4350] = {.lex_state = 3, .external_lex_state = 16},
  [4351] = {.lex_state = 3, .external_lex_state = 16},
  [4352] = {.lex_state = 3, .external_lex_state = 15},
  [4353] = {.lex_state = 1, .external_lex_state = 7},
  [4354] = {.lex_state = 3, .external_lex_state = 15},
  [4355] = {.lex_state = 3, .external_lex_state = 16},
  [4356] = {.lex_state = 3, .external_lex_state = 16},
  [4357] = {.lex_state = 3, .external_lex_state = 16},
  [4358] = {.lex_state = 1, .external_lex_state = 7},
  [4359] = {.lex_state = 3, .external_lex_state = 16},
  [4360] = {.lex_state = 3, .external_lex_state = 16},
  [4361] = {.lex_state = 3, .external_lex_state = 16},
  [4362] = {.lex_state = 3, .external_lex_state = 16},
  [4363] = {.lex_state = 1, .external_lex_state = 7},
  [4364] = {.lex_state = 1, .external_lex_state = 7},
  [4365] = {.lex_state = 1, .external_lex_state = 7},
  [4366] = {.lex_state = 3, .external_lex_state = 16},
  [4367] = {.lex_state = 1, .external_lex_state = 7},
  [4368] = {.lex_state = 3, .external_lex_state = 15},
  [4369] = {.lex_state = 3, .external_lex_state = 16},
  [4370] = {.lex_state = 3, .external_lex_state = 12},
  [4371] = {.lex_state = 4, .external_lex_state = 7},
  [4372] = {.lex_state = 3, .external_lex_state = 15},
  [4373] = {.lex_state = 3, .external_lex_state = 15},
  [4374] = {.lex_state = 3, .external_lex_state = 15},
  [4375] = {.lex_state = 3, .external_lex_state = 15},
  [4376] = {.lex_state = 3, .external_lex_state = 15},
  [4377] = {.lex_state = 3, .external_lex_state = 15},
  [4378] = {.lex_state = 3, .external_lex_state = 16},
  [4379] = {.lex_state = 3, .external_lex_state = 15},
  [4380] = {.lex_state = 3, .external_lex_state = 15},
  [4381] = {.lex_state = 3, .external_lex_state = 15},
  [4382] = {.lex_state = 3, .external_lex_state = 15},
  [4383] = {.lex_state = 3, .external_lex_state = 15},
  [4384] = {.lex_state = 3, .external_lex_state = 15},
  [4385] = {.lex_state = 3, .external_lex_state = 15},
  [4386] = {.lex_state = 3, .external_lex_state = 15},
  [4387] = {.lex_state = 3, .external_lex_state = 15},
  [4388] = {.lex_state = 3, .external_lex_state = 15},
  [4389] = {.lex_state = 3, .external_lex_state = 16},
  [4390] = {.lex_state = 3, .external_lex_state = 15},
  [4391] = {.lex_state = 3, .external_lex_state = 15},
  [4392] = {.lex_state = 3, .external_lex_state = 15},
  [4393] = {.lex_state = 1, .external_lex_state = 7},
  [4394] = {.lex_state = 3, .external_lex_state = 15},
  [4395] = {.lex_state = 3, .external_lex_state = 16},
  [4396] = {.lex_state = 3, .external_lex_state = 16},
  [4397] = {.lex_state = 1, .external_lex_state = 7},
  [4398] = {.lex_state = 3, .external_lex_state = 16},
  [4399] = {.lex_state = 3, .external_lex_state = 15},
  [4400] = {.lex_state = 3, .external_lex_state = 15},
  [4401] = {.lex_state = 3, .external_lex_state = 16},
  [4402] = {.lex_state = 3, .external_lex_state = 16},
  [4403] = {.lex_state = 1, .external_lex_state = 7},
  [4404] = {.lex_state = 3, .external_lex_state = 15},
  [4405] = {.lex_state = 3, .external_lex_state = 16},
  [4406] = {.lex_state = 3, .external_lex_state = 15},
  [4407] = {.lex_state = 3, .external_lex_state = 16},
  [4408] = {.lex_state = 3, .external_lex_state = 16},
  [4409] = {.lex_state = 1, .external_lex_state = 7},
  [4410] = {.lex_state = 1, .external_lex_state = 7},
  [4411] = {.lex_state = 3, .external_lex_state = 15},
  [4412] = {.lex_state = 3, .external_lex_state = 16},
  [4413] = {.lex_state = 3, .external_lex_state = 16},
  [4414] = {.lex_state = 3, .external_lex_state = 16},
  [4415] = {.lex_state = 3, .external_lex_state = 16},
  [4416] = {.lex_state = 3, .external_lex_state = 16},
  [4417] = {.lex_state = 1, .external_lex_state = 7},
  [4418] = {.lex_state = 1, .external_lex_state = 7},
  [4419] = {.lex_state = 1, .external_lex_state = 7},
  [4420] = {.lex_state = 1, .external_lex_state = 7},
  [4421] = {.lex_state = 1, .external_lex_state = 7},
  [4422] = {.lex_state = 3, .external_lex_state = 15},
  [4423] = {.lex_state = 3, .external_lex_state = 15},
  [4424] = {.lex_state = 1, .external_lex_state = 7},
  [4425] = {.lex_state = 1, .external_lex_state = 7},
  [4426] = {.lex_state = 1, .external_lex_state = 7},
  [4427] = {.lex_state = 1, .external_lex_state = 7},
  [4428] = {.lex_state = 3, .external_lex_state = 15},
  [4429] = {.lex_state = 3, .external_lex_state = 12},
  [4430] = {.lex_state = 1, .external_lex_state = 7},
  [4431] = {.lex_state = 1, .external_lex_state = 7},
  [4432] = {.lex_state = 1, .external_lex_state = 7},
  [4433] = {.lex_state = 1, .external_lex_state = 7},
  [4434] = {.lex_state = 1, .external_lex_state = 7},
  [4435] = {.lex_state = 1, .external_lex_state = 7},
  [4436] = {.lex_state = 1, .external_lex_state = 7},
  [4437] = {.lex_state = 1, .external_lex_state = 7},
  [4438] = {.lex_state = 1, .external_lex_state = 7},
  [4439] = {.lex_state = 1, .external_lex_state = 7},
  [4440] = {.lex_state = 1, .external_lex_state = 7},
  [4441] = {.lex_state = 1, .external_lex_state = 7},
  [4442] = {.lex_state = 3, .external_lex_state = 12},
  [4443] = {.lex_state = 1, .external_lex_state = 7},
  [4444] = {.lex_state = 4, .external_lex_state = 7},
  [4445] = {.lex_state = 1, .external_lex_state = 7},
  [4446] = {.lex_state = 1, .external_lex_state = 7},
  [4447] = {.lex_state = 3, .external_lex_state = 15},
  [4448] = {.lex_state = 1, .external_lex_state = 7},
  [4449] = {.lex_state = 1, .external_lex_state = 7},
  [4450] = {.lex_state = 1, .external_lex_state = 7},
  [4451] = {.lex_state = 1, .external_lex_state = 7},
  [4452] = {.lex_state = 4, .external_lex_state = 7},
  [4453] = {.lex_state = 4, .external_lex_state = 7},
  [4454] = {.lex_state = 3, .external_lex_state = 107},
  [4455] = {.lex_state = 1, .external_lex_state = 7},
  [4456] = {.lex_state = 1, .external_lex_state = 7},
  [4457] = {.lex_state = 3, .external_lex_state = 12},
  [4458] = {.lex_state = 3, .external_lex_state = 12},
  [4459] = {.lex_state = 3, .external_lex_state = 12},
  [4460] = {.lex_state = 3, .external_lex_state = 12},
  [4461] = {.lex_state = 3, .external_lex_state = 12},
  [4462] = {.lex_state = 3, .external_lex_state = 12},
  [4463] = {.lex_state = 3, .external_lex_state = 12},
  [4464] = {.lex_state = 3, .external_lex_state = 12},
  [4465] = {.lex_state = 3, .external_lex_state = 12},
  [4466] = {.lex_state = 3, .external_lex_state = 12},
  [4467] = {.lex_state = 3, .external_lex_state = 12},
  [4468] = {.lex_state = 3, .external_lex_state = 12},
  [4469] = {.lex_state = 3, .external_lex_state = 12},
  [4470] = {.lex_state = 3, .external_lex_state = 12},
  [4471] = {.lex_state = 3, .external_lex_state = 12},
  [4472] = {.lex_state = 3, .external_lex_state = 12},
  [4473] = {.lex_state = 3, .external_lex_state = 12},
  [4474] = {.lex_state = 3, .external_lex_state = 12},
  [4475] = {.lex_state = 3, .external_lex_state = 12},
  [4476] = {.lex_state = 3, .external_lex_state = 12},
  [4477] = {.lex_state = 3, .external_lex_state = 12},
  [4478] = {.lex_state = 3, .external_lex_state = 12},
  [4479] = {.lex_state = 4, .external_lex_state = 7},
  [4480] = {.lex_state = 3, .external_lex_state = 15},
  [4481] = {.lex_state = 1, .external_lex_state = 7},
  [4482] = {.lex_state = 4, .external_lex_state = 7},
  [4483] = {.lex_state = 3, .external_lex_state = 12},
  [4484] = {.lex_state = 3, .external_lex_state = 12},
  [4485] = {.lex_state = 3, .external_lex_state = 12},
  [4486] = {.lex_state = 3, .external_lex_state = 12},
  [4487] = {.lex_state = 3, .external_lex_state = 12},
  [4488] = {.lex_state = 3, .external_lex_state = 12},
  [4489] = {.lex_state = 3, .external_lex_state = 12},
  [4490] = {.lex_state = 3, .external_lex_state = 12},
  [4491] = {.lex_state = 3, .external_lex_state = 12},
  [4492] = {.lex_state = 3, .external_lex_state = 12},
  [4493] = {.lex_state = 3, .external_lex_state = 12},
  [4494] = {.lex_state = 3, .external_lex_state = 12},
  [4495] = {.lex_state = 3, .external_lex_state = 12},
  [4496] = {.lex_state = 3, .external_lex_state = 12},
  [4497] = {.lex_state = 3, .external_lex_state = 12},
  [4498] = {.lex_state = 3, .external_lex_state = 12},
  [4499] = {.lex_state = 3, .external_lex_state = 12},
  [4500] = {.lex_state = 1, .external_lex_state = 7},
  [4501] = {.lex_state = 1, .external_lex_state = 7},
  [4502] = {.lex_state = 3, .external_lex_state = 12},
  [4503] = {.lex_state = 1, .external_lex_state = 7},
  [4504] = {.lex_state = 3, .external_lex_state = 12},
  [4505] = {.lex_state = 3, .external_lex_state = 12},
  [4506] = {.lex_state = 3, .external_lex_state = 12},
  [4507] = {.lex_state = 3, .external_lex_state = 12},
  [4508] = {.lex_state = 3, .external_lex_state = 12},
  [4509] = {.lex_state = 3, .external_lex_state = 12},
  [4510] = {.lex_state = 3, .external_lex_state = 12},
  [4511] = {.lex_state = 3, .external_lex_state = 12},
  [4512] = {.lex_state = 3, .external_lex_state = 12},
  [4513] = {.lex_state = 3, .external_lex_state = 12},
  [4514] = {.lex_state = 1, .external_lex_state = 7},
  [4515] = {.lex_state = 1, .external_lex_state = 7},
  [4516] = {.lex_state = 1, .external_lex_state = 7},
  [4517] = {.lex_state = 3, .external_lex_state = 16},
  [4518] = {.lex_state = 3, .external_lex_state = 16},
  [4519] = {.lex_state = 1, .external_lex_state = 7},
  [4520] = {.lex_state = 4, .external_lex_state = 7},
  [4521] = {.lex_state = 4, .external_lex_state = 7},
  [4522] = {.lex_state = 4, .external_lex_state = 7},
  [4523] = {.lex_state = 4, .external_lex_state = 7},
  [4524] = {.lex_state = 4, .external_lex_state = 7},
  [4525] = {.lex_state = 1, .external_lex_state = 7},
  [4526] = {.lex_state = 1, .external_lex_state = 7},
  [4527] = {.lex_state = 1, .external_lex_state = 7},
  [4528] = {.lex_state = 1, .external_lex_state = 7},
  [4529] = {.lex_state = 1, .external_lex_state = 7},
  [4530] = {.lex_state = 1, .external_lex_state = 7},
  [4531] = {.lex_state = 3, .external_lex_state = 16},
  [4532] = {.lex_state = 1, .external_lex_state = 7},
  [4533] = {.lex_state = 3, .external_lex_state = 16},
  [4534] = {.lex_state = 1, .external_lex_state = 7},
  [4535] = {.lex_state = 1, .external_lex_state = 7},
  [4536] = {.lex_state = 4, .external_lex_state = 7},
  [4537] = {.lex_state = 1, .external_lex_state = 7},
  [4538] = {.lex_state = 1, .external_lex_state = 7},
  [4539] = {.lex_state = 3, .external_lex_state = 12},
  [4540] = {.lex_state = 3, .external_lex_state = 12},
  [4541] = {.lex_state = 4, .external_lex_state = 13},
  [4542] = {.lex_state = 3, .external_lex_state = 12},
  [4543] = {.lex_state = 3, .external_lex_state = 12},
  [4544] = {.lex_state = 3, .external_lex_state = 12},
  [4545] = {.lex_state = 3, .external_lex_state = 12},
  [4546] = {.lex_state = 1, .external_lex_state = 7},
  [4547] = {.lex_state = 4, .external_lex_state = 114},
  [4548] = {.lex_state = 3, .external_lex_state = 16},
  [4549] = {.lex_state = 3, .external_lex_state = 12},
  [4550] = {.lex_state = 4, .external_lex_state = 7},
  [4551] = {.lex_state = 3, .external_lex_state = 15},
  [4552] = {.lex_state = 1, .external_lex_state = 7},
  [4553] = {.lex_state = 1, .external_lex_state = 7},
  [4554] = {.lex_state = 3, .external_lex_state = 12},
  [4555] = {.lex_state = 3, .external_lex_state = 12},
  [4556] = {.lex_state = 3, .external_lex_state = 12},
  [4557] = {.lex_state = 1, .external_lex_state = 7},
  [4558] = {.lex_state = 1, .external_lex_state = 7},
  [4559] = {.lex_state = 3, .external_lex_state = 15},
  [4560] = {.lex_state = 1, .external_lex_state = 7},
  [4561] = {.lex_state = 3, .external_lex_state = 12},
  [4562] = {.lex_state = 3, .external_lex_state = 12},
  [4563] = {.lex_state = 3, .external_lex_state = 12},
  [4564] = {.lex_state = 3, .external_lex_state = 12},
  [4565] = {.lex_state = 1, .external_lex_state = 7},
  [4566] = {.lex_state = 3, .external_lex_state = 12},
  [4567] = {.lex_state = 3, .external_lex_state = 12},
  [4568] = {.lex_state = 1, .external_lex_state = 7},
  [4569] = {.lex_state = 4, .external_lex_state = 118},
  [4570] = {.lex_state = 4, .external_lex_state = 118},
  [4571] = {.lex_state = 3, .external_lex_state = 12},
  [4572] = {.lex_state = 3, .external_lex_state = 12},
  [4573] = {.lex_state = 1, .external_lex_state = 7},
  [4574] = {.lex_state = 4, .external_lex_state = 7},
  [4575] = {.lex_state = 3, .external_lex_state = 12},
  [4576] = {.lex_state = 3, .external_lex_state = 12},
  [4577] = {.lex_state = 3, .external_lex_state = 12},
  [4578] = {.lex_state = 1, .external_lex_state = 7},
  [4579] = {.lex_state = 3, .external_lex_state = 12},
  [4580] = {.lex_state = 4, .external_lex_state = 13},
  [4581] = {.lex_state = 4, .external_lex_state = 13},
  [4582] = {.lex_state = 4, .external_lex_state = 13},
  [4583] = {.lex_state = 3, .external_lex_state = 12},
  [4584] = {.lex_state = 3, .external_lex_state = 12},
  [4585] = {.lex_state = 3, .external_lex_state = 12},
  [4586] = {.lex_state = 3, .external_lex_state = 12},
  [4587] = {.lex_state = 3, .external_lex_state = 12},
  [4588] = {.lex_state = 4, .external_lex_state = 7},
  [4589] = {.lex_state = 3, .external_lex_state = 12},
  [4590] = {.lex_state = 4, .external_lex_state = 13},
  [4591] = {.lex_state = 4, .external_lex_state = 13},
  [4592] = {.lex_state = 3, .external_lex_state = 12},
  [4593] = {.lex_state = 3, .external_lex_state = 12},
  [4594] = {.lex_state = 3, .external_lex_state = 12},
  [4595] = {.lex_state = 4, .external_lex_state = 13},
  [4596] = {.lex_state = 4, .external_lex_state = 13},
  [4597] = {.lex_state = 3, .external_lex_state = 15},
  [4598] = {.lex_state = 4, .external_lex_state = 13},
  [4599] = {.lex_state = 4, .external_lex_state = 13},
  [4600] = {.lex_state = 4, .external_lex_state = 7},
  [4601] = {.lex_state = 4, .external_lex_state = 13},
  [4602] = {.lex_state = 4, .external_lex_state = 13},
  [4603] = {.lex_state = 3, .external_lex_state = 15},
  [4604] = {.lex_state = 3, .external_lex_state = 15},
  [4605] = {.lex_state = 4, .external_lex_state = 13},
  [4606] = {.lex_state = 4, .external_lex_state = 13},
  [4607] = {.lex_state = 3, .external_lex_state = 12},
  [4608] = {.lex_state = 3, .external_lex_state = 12},
  [4609] = {.lex_state = 3, .external_lex_state = 12},
  [4610] = {.lex_state = 4, .external_lex_state = 7},
  [4611] = {.lex_state = 3, .external_lex_state = 12},
  [4612] = {.lex_state = 3, .external_lex_state = 12},
  [4613] = {.lex_state = 3, .external_lex_state = 12},
  [4614] = {.lex_state = 4, .external_lex_state = 7},
  [4615] = {.lex_state = 4, .external_lex_state = 13},
  [4616] = {.lex_state = 4, .external_lex_state = 13},
  [4617] = {.lex_state = 4, .external_lex_state = 7},
  [4618] = {.lex_state = 3, .external_lex_state = 12},
  [4619] = {.lex_state = 3, .external_lex_state = 15},
  [4620] = {.lex_state = 4, .external_lex_state = 13},
  [4621] = {.lex_state = 4, .external_lex_state = 118},
  [4622] = {.lex_state = 4, .external_lex_state = 13},
  [4623] = {.lex_state = 3, .external_lex_state = 12},
  [4624] = {.lex_state = 4, .external_lex_state = 13},
  [4625] = {.lex_state = 3, .external_lex_state = 12},
  [4626] = {.lex_state = 3, .external_lex_state = 12},
  [4627] = {.lex_state = 3, .external_lex_state = 12},
  [4628] = {.lex_state = 3, .external_lex_state = 12},
  [4629] = {.lex_state = 4, .external_lex_state = 13},
  [4630] = {.lex_state = 4, .external_lex_state = 13},
  [4631] = {.lex_state = 3, .external_lex_state = 12},
  [4632] = {.lex_state = 4, .external_lex_state = 13},
  [4633] = {.lex_state = 4, .external_lex_state = 13},
  [4634] = {.lex_state = 4, .external_lex_state = 13},
  [4635] = {.lex_state = 3, .external_lex_state = 15},
  [4636] = {.lex_state = 3, .external_lex_state = 15},
  [4637] = {.lex_state = 3, .external_lex_state = 15},
  [4638] = {.lex_state = 4, .external_lex_state = 13},
  [4639] = {.lex_state = 4, .external_lex_state = 7},
  [4640] = {.lex_state = 4, .external_lex_state = 7},
  [4641] = {.lex_state = 3, .external_lex_state = 15},
  [4642] = {.lex_state = 4, .external_lex_state = 13},
  [4643] = {.lex_state = 3, .external_lex_state = 15},
  [4644] = {.lex_state = 4, .external_lex_state = 13},
  [4645] = {.lex_state = 4, .external_lex_state = 7},
  [4646] = {.lex_state = 4, .external_lex_state = 7},
  [4647] = {.lex_state = 4, .external_lex_state = 7},
  [4648] = {.lex_state = 3, .external_lex_state = 12},
  [4649] = {.lex_state = 4, .external_lex_state = 13},
  [4650] = {.lex_state = 3, .external_lex_state = 5},
  [4651] = {.lex_state = 4, .external_lex_state = 7},
  [4652] = {.lex_state = 4, .external_lex_state = 7},
  [4653] = {.lex_state = 4, .external_lex_state = 7},
  [4654] = {.lex_state = 4, .external_lex_state = 7},
  [4655] = {.lex_state = 4, .external_lex_state = 7},
  [4656] = {.lex_state = 4, .external_lex_state = 13},
  [4657] = {.lex_state = 4, .external_lex_state = 7},
  [4658] = {.lex_state = 3, .external_lex_state = 12},
  [4659] = {.lex_state = 4, .external_lex_state = 13},
  [4660] = {.lex_state = 3, .external_lex_state = 12},
  [4661] = {.lex_state = 4, .external_lex_state = 7},
  [4662] = {.lex_state = 4, .external_lex_state = 7},
  [4663] = {.lex_state = 4, .external_lex_state = 7},
  [4664] = {.lex_state = 4, .external_lex_state = 13},
  [4665] = {.lex_state = 3, .external_lex_state = 12},
  [4666] = {.lex_state = 4, .external_lex_state = 13},
  [4667] = {.lex_state = 4, .external_lex_state = 7},
  [4668] = {.lex_state = 3, .external_lex_state = 12},
  [4669] = {.lex_state = 4, .external_lex_state = 7},
  [4670] = {.lex_state = 3, .external_lex_state = 12},
  [4671] = {.lex_state = 3, .external_lex_state = 12},
  [4672] = {.lex_state = 4, .external_lex_state = 7},
  [4673] = {.lex_state = 4, .external_lex_state = 7},
  [4674] = {.lex_state = 4, .external_lex_state = 7},
  [4675] = {.lex_state = 4, .external_lex_state = 13},
  [4676] = {.lex_state = 4, .external_lex_state = 13},
  [4677] = {.lex_state = 1, .external_lex_state = 7},
  [4678] = {.lex_state = 1, .external_lex_state = 7},
  [4679] = {.lex_state = 4, .external_lex_state = 7},
  [4680] = {.lex_state = 4, .external_lex_state = 13},
  [4681] = {.lex_state = 4, .external_lex_state = 13},
  [4682] = {.lex_state = 4, .external_lex_state = 13},
  [4683] = {.lex_state = 4, .external_lex_state = 13},
  [4684] = {.lex_state = 4, .external_lex_state = 13},
  [4685] = {.lex_state = 4, .external_lex_state = 13},
  [4686] = {.lex_state = 4, .external_lex_state = 13},
  [4687] = {.lex_state = 4, .external_lex_state = 13},
  [4688] = {.lex_state = 4, .external_lex_state = 13},
  [4689] = {.lex_state = 1, .external_lex_state = 7},
  [4690] = {.lex_state = 4, .external_lex_state = 7},
  [4691] = {.lex_state = 1, .external_lex_state = 7},
  [4692] = {.lex_state = 4, .external_lex_state = 7},
  [4693] = {.lex_state = 3, .external_lex_state = 15},
  [4694] = {.lex_state = 4, .external_lex_state = 7},
  [4695] = {.lex_state = 4, .external_lex_state = 7},
  [4696] = {.lex_state = 1, .external_lex_state = 7},
  [4697] = {.lex_state = 3, .external_lex_state = 12},
  [4698] = {.lex_state = 4, .external_lex_state = 7},
  [4699] = {.lex_state = 1, .external_lex_state = 7},
  [4700] = {.lex_state = 1, .external_lex_state = 7},
  [4701] = {.lex_state = 4, .external_lex_state = 13},
  [4702] = {.lex_state = 4, .external_lex_state = 13},
  [4703] = {.lex_state = 4, .external_lex_state = 13},
  [4704] = {.lex_state = 4, .external_lex_state = 13},
  [4705] = {.lex_state = 3, .external_lex_state = 12},
  [4706] = {.lex_state = 3, .external_lex_state = 12},
  [4707] = {.lex_state = 3, .external_lex_state = 15},
  [4708] = {.lex_state = 3, .external_lex_state = 12},
  [4709] = {.lex_state = 3, .external_lex_state = 12},
  [4710] = {.lex_state = 3, .external_lex_state = 12},
  [4711] = {.lex_state = 4, .external_lex_state = 13},
  [4712] = {.lex_state = 3, .external_lex_state = 15},
  [4713] = {.lex_state = 4, .external_lex_state = 13},
  [4714] = {.lex_state = 4, .external_lex_state = 13},
  [4715] = {.lex_state = 4, .external_lex_state = 13},
  [4716] = {.lex_state = 3, .external_lex_state = 15},
  [4717] = {.lex_state = 4, .external_lex_state = 13},
  [4718] = {.lex_state = 4, .external_lex_state = 13},
  [4719] = {.lex_state = 4, .external_lex_state = 13},
  [4720] = {.lex_state = 4, .external_lex_state = 13},
  [4721] = {.lex_state = 4, .external_lex_state = 13},
  [4722] = {.lex_state = 4, .external_lex_state = 13},
  [4723] = {.lex_state = 4, .external_lex_state = 13},
  [4724] = {.lex_state = 1, .external_lex_state = 7},
  [4725] = {.lex_state = 1, .external_lex_state = 7},
  [4726] = {.lex_state = 3, .external_lex_state = 12},
  [4727] = {.lex_state = 4, .external_lex_state = 13},
  [4728] = {.lex_state = 1, .external_lex_state = 7},
  [4729] = {.lex_state = 4, .external_lex_state = 13},
  [4730] = {.lex_state = 4, .external_lex_state = 13},
  [4731] = {.lex_state = 4, .external_lex_state = 13},
  [4732] = {.lex_state = 4, .external_lex_state = 13},
  [4733] = {.lex_state = 4, .external_lex_state = 13},
  [4734] = {.lex_state = 4, .external_lex_state = 13},
  [4735] = {.lex_state = 4, .external_lex_state = 13},
  [4736] = {.lex_state = 3, .external_lex_state = 12},
  [4737] = {.lex_state = 3, .external_lex_state = 12},
  [4738] = {.lex_state = 3, .external_lex_state = 12},
  [4739] = {.lex_state = 3, .external_lex_state = 12},
  [4740] = {.lex_state = 3, .external_lex_state = 12},
  [4741] = {.lex_state = 3, .external_lex_state = 12},
  [4742] = {.lex_state = 4, .external_lex_state = 13},
  [4743] = {.lex_state = 4, .external_lex_state = 13},
  [4744] = {.lex_state = 1, .external_lex_state = 7},
  [4745] = {.lex_state = 4, .external_lex_state = 13},
  [4746] = {.lex_state = 4, .external_lex_state = 13},
  [4747] = {.lex_state = 1, .external_lex_state = 7},
  [4748] = {.lex_state = 1, .external_lex_state = 7},
  [4749] = {.lex_state = 1, .external_lex_state = 7},
  [4750] = {.lex_state = 1, .external_lex_state = 7},
  [4751] = {.lex_state = 1, .external_lex_state = 7},
  [4752] = {.lex_state = 1, .external_lex_state = 7},
  [4753] = {.lex_state = 4, .external_lex_state = 13},
  [4754] = {.lex_state = 4, .external_lex_state = 13},
  [4755] = {.lex_state = 4, .external_lex_state = 13},
  [4756] = {.lex_state = 4, .external_lex_state = 13},
  [4757] = {.lex_state = 1, .external_lex_state = 7},
  [4758] = {.lex_state = 3, .external_lex_state = 12},
  [4759] = {.lex_state = 3, .external_lex_state = 12},
  [4760] = {.lex_state = 3, .external_lex_state = 12},
  [4761] = {.lex_state = 1, .external_lex_state = 7},
  [4762] = {.lex_state = 4, .external_lex_state = 13},
  [4763] = {.lex_state = 1, .external_lex_state = 7},
  [4764] = {.lex_state = 4, .external_lex_state = 13},
  [4765] = {.lex_state = 1, .external_lex_state = 7},
  [4766] = {.lex_state = 4, .external_lex_state = 13},
  [4767] = {.lex_state = 1, .external_lex_state = 7},
  [4768] = {.lex_state = 4, .external_lex_state = 13},
  [4769] = {.lex_state = 4, .external_lex_state = 13},
  [4770] = {.lex_state = 3, .external_lex_state = 12},
  [4771] = {.lex_state = 3, .external_lex_state = 12},
  [4772] = {.lex_state = 3, .external_lex_state = 12},
  [4773] = {.lex_state = 4, .external_lex_state = 13},
  [4774] = {.lex_state = 3, .external_lex_state = 15},
  [4775] = {.lex_state = 1, .external_lex_state = 7},
  [4776] = {.lex_state = 4, .external_lex_state = 13},
  [4777] = {.lex_state = 4, .external_lex_state = 13},
  [4778] = {.lex_state = 1, .external_lex_state = 7},
  [4779] = {.lex_state = 4, .external_lex_state = 13},
  [4780] = {.lex_state = 1, .external_lex_state = 7},
  [4781] = {.lex_state = 4, .external_lex_state = 13},
  [4782] = {.lex_state = 4, .external_lex_state = 13},
  [4783] = {.lex_state = 1, .external_lex_state = 7},
  [4784] = {.lex_state = 1, .external_lex_state = 7},
  [4785] = {.lex_state = 4, .external_lex_state = 13},
  [4786] = {.lex_state = 4, .external_lex_state = 13},
  [4787] = {.lex_state = 4, .external_lex_state = 13},
  [4788] = {.lex_state = 4, .external_lex_state = 13},
  [4789] = {.lex_state = 4, .external_lex_state = 13},
  [4790] = {.lex_state = 4, .external_lex_state = 13},
  [4791] = {.lex_state = 4, .external_lex_state = 13},
  [4792] = {.lex_state = 4, .external_lex_state = 13},
  [4793] = {.lex_state = 4, .external_lex_state = 13},
  [4794] = {.lex_state = 4, .external_lex_state = 13},
  [4795] = {.lex_state = 4, .external_lex_state = 13},
  [4796] = {.lex_state = 4, .external_lex_state = 13},
  [4797] = {.lex_state = 4, .external_lex_state = 13},
  [4798] = {.lex_state = 1, .external_lex_state = 7},
  [4799] = {.lex_state = 3, .external_lex_state = 12},
  [4800] = {.lex_state = 4, .external_lex_state = 13},
  [4801] = {.lex_state = 3, .external_lex_state = 12},
  [4802] = {.lex_state = 4, .external_lex_state = 13},
  [4803] = {.lex_state = 3, .external_lex_state = 12},
  [4804] = {.lex_state = 3, .external_lex_state = 12},
  [4805] = {.lex_state = 4, .external_lex_state = 13},
  [4806] = {.lex_state = 3, .external_lex_state = 12},
  [4807] = {.lex_state = 4, .external_lex_state = 13},
  [4808] = {.lex_state = 3, .external_lex_state = 12},
  [4809] = {.lex_state = 1, .external_lex_state = 7},
  [4810] = {.lex_state = 3, .external_lex_state = 12},
  [4811] = {.lex_state = 3, .external_lex_state = 12},
  [4812] = {.lex_state = 3, .external_lex_state = 12},
  [4813] = {.lex_state = 4, .external_lex_state = 13},
  [4814] = {.lex_state = 4, .external_lex_state = 13},
  [4815] = {.lex_state = 4, .external_lex_state = 13},
  [4816] = {.lex_state = 4, .external_lex_state = 13},
  [4817] = {.lex_state = 4, .external_lex_state = 13},
  [4818] = {.lex_state = 4, .external_lex_state = 13},
  [4819] = {.lex_state = 4, .external_lex_state = 13},
  [4820] = {.lex_state = 4, .external_lex_state = 13},
  [4821] = {.lex_state = 4, .external_lex_state = 13},
  [4822] = {.lex_state = 4, .external_lex_state = 13},
  [4823] = {.lex_state = 4, .external_lex_state = 13},
  [4824] = {.lex_state = 1, .external_lex_state = 7},
  [4825] = {.lex_state = 1, .external_lex_state = 7},
  [4826] = {.lex_state = 4, .external_lex_state = 13},
  [4827] = {.lex_state = 4, .external_lex_state = 13},
  [4828] = {.lex_state = 1, .external_lex_state = 7},
  [4829] = {.lex_state = 1, .external_lex_state = 7},
  [4830] = {.lex_state = 1, .external_lex_state = 7},
  [4831] = {.lex_state = 1, .external_lex_state = 7},
  [4832] = {.lex_state = 4, .external_lex_state = 13},
  [4833] = {.lex_state = 4, .external_lex_state = 13},
  [4834] = {.lex_state = 4, .external_lex_state = 13},
  [4835] = {.lex_state = 1, .external_lex_state = 7},
  [4836] = {.lex_state = 1, .external_lex_state = 7},
  [4837] = {.lex_state = 1, .external_lex_state = 7},
  [4838] = {.lex_state = 1, .external_lex_state = 7},
  [4839] = {.lex_state = 4, .external_lex_state = 13},
  [4840] = {.lex_state = 4, .external_lex_state = 7},
  [4841] = {.lex_state = 4, .external_lex_state = 7},
  [4842] = {.lex_state = 1, .external_lex_state = 7},
  [4843] = {.lex_state = 4, .external_lex_state = 13},
  [4844] = {.lex_state = 1, .external_lex_state = 7},
  [4845] = {.lex_state = 1, .external_lex_state = 7},
  [4846] = {.lex_state = 1, .external_lex_state = 7},
  [4847] = {.lex_state = 4, .external_lex_state = 13},
  [4848] = {.lex_state = 4, .external_lex_state = 13},
  [4849] = {.lex_state = 1, .external_lex_state = 7},
  [4850] = {.lex_state = 4, .external_lex_state = 13},
  [4851] = {.lex_state = 4, .external_lex_state = 13},
  [4852] = {.lex_state = 4, .external_lex_state = 13},
  [4853] = {.lex_state = 4, .external_lex_state = 13},
  [4854] = {.lex_state = 1, .external_lex_state = 7},
  [4855] = {.lex_state = 3, .external_lex_state = 15},
  [4856] = {.lex_state = 4, .external_lex_state = 13},
  [4857] = {.lex_state = 4, .external_lex_state = 13},
  [4858] = {.lex_state = 4, .external_lex_state = 13},
  [4859] = {.lex_state = 1, .external_lex_state = 7},
  [4860] = {.lex_state = 1, .external_lex_state = 7},
  [4861] = {.lex_state = 1, .external_lex_state = 7},
  [4862] = {.lex_state = 4, .external_lex_state = 13},
  [4863] = {.lex_state = 1, .external_lex_state = 7},
  [4864] = {.lex_state = 4, .external_lex_state = 17},
  [4865] = {.lex_state = 4, .external_lex_state = 17},
  [4866] = {.lex_state = 3, .external_lex_state = 14},
  [4867] = {.lex_state = 4, .external_lex_state = 17},
  [4868] = {.lex_state = 4, .external_lex_state = 17},
  [4869] = {.lex_state = 3, .external_lex_state = 14},
  [4870] = {.lex_state = 3, .external_lex_state = 14},
  [4871] = {.lex_state = 3, .external_lex_state = 14},
  [4872] = {.lex_state = 3, .external_lex_state = 14},
  [4873] = {.lex_state = 3, .external_lex_state = 14},
  [4874] = {.lex_state = 3, .external_lex_state = 14},
  [4875] = {.lex_state = 3, .external_lex_state = 14},
  [4876] = {.lex_state = 3, .external_lex_state = 14},
  [4877] = {.lex_state = 8, .external_lex_state = 28},
  [4878] = {.lex_state = 4, .external_lex_state = 17},
  [4879] = {.lex_state = 8, .external_lex_state = 28},
  [4880] = {.lex_state = 8, .external_lex_state = 28},
  [4881] = {.lex_state = 8, .external_lex_state = 28},
  [4882] = {.lex_state = 8, .external_lex_state = 28},
  [4883] = {.lex_state = 4, .external_lex_state = 17},
  [4884] = {.lex_state = 4, .external_lex_state = 17},
  [4885] = {.lex_state = 8, .external_lex_state = 28},
  [4886] = {.lex_state = 8, .external_lex_state = 28},
  [4887] = {.lex_state = 8, .external_lex_state = 28},
  [4888] = {.lex_state = 4, .external_lex_state = 17},
  [4889] = {.lex_state = 4, .external_lex_state = 17},
  [4890] = {.lex_state = 8, .external_lex_state = 28},
  [4891] = {.lex_state = 8, .external_lex_state = 28},
  [4892] = {.lex_state = 8, .external_lex_state = 28},
  [4893] = {.lex_state = 3, .external_lex_state = 14},
  [4894] = {.lex_state = 3, .external_lex_state = 14},
  [4895] = {.lex_state = 3, .external_lex_state = 14},
  [4896] = {.lex_state = 3, .external_lex_state = 14},
  [4897] = {.lex_state = 3, .external_lex_state = 14},
  [4898] = {.lex_state = 3, .external_lex_state = 14},
  [4899] = {.lex_state = 8, .external_lex_state = 28},
  [4900] = {.lex_state = 3, .external_lex_state = 14},
  [4901] = {.lex_state = 8, .external_lex_state = 28},
  [4902] = {.lex_state = 8, .external_lex_state = 28},
  [4903] = {.lex_state = 8, .external_lex_state = 28},
  [4904] = {.lex_state = 3, .external_lex_state = 14},
  [4905] = {.lex_state = 3, .external_lex_state = 14},
  [4906] = {.lex_state = 3, .external_lex_state = 14},
  [4907] = {.lex_state = 8, .external_lex_state = 28},
  [4908] = {.lex_state = 3, .external_lex_state = 14},
  [4909] = {.lex_state = 3, .external_lex_state = 14},
  [4910] = {.lex_state = 3, .external_lex_state = 14},
  [4911] = {.lex_state = 3, .external_lex_state = 14},
  [4912] = {.lex_state = 3, .external_lex_state = 14},
  [4913] = {.lex_state = 3, .external_lex_state = 14},
  [4914] = {.lex_state = 3, .external_lex_state = 14},
  [4915] = {.lex_state = 3, .external_lex_state = 14},
  [4916] = {.lex_state = 3, .external_lex_state = 14},
  [4917] = {.lex_state = 8, .external_lex_state = 28},
  [4918] = {.lex_state = 3, .external_lex_state = 14},
  [4919] = {.lex_state = 3, .external_lex_state = 14},
  [4920] = {.lex_state = 3, .external_lex_state = 14},
  [4921] = {.lex_state = 3, .external_lex_state = 14},
  [4922] = {.lex_state = 3, .external_lex_state = 14},
  [4923] = {.lex_state = 3, .external_lex_state = 14},
  [4924] = {.lex_state = 3, .external_lex_state = 14},
  [4925] = {.lex_state = 3, .external_lex_state = 14},
  [4926] = {.lex_state = 3, .external_lex_state = 14},
  [4927] = {.lex_state = 3, .external_lex_state = 14},
  [4928] = {.lex_state = 3, .external_lex_state = 14},
  [4929] = {.lex_state = 3, .external_lex_state = 14},
  [4930] = {.lex_state = 8, .external_lex_state = 28},
  [4931] = {.lex_state = 8, .external_lex_state = 28},
  [4932] = {.lex_state = 8, .external_lex_state = 28},
  [4933] = {.lex_state = 8, .external_lex_state = 28},
  [4934] = {.lex_state = 3, .external_lex_state = 14},
  [4935] = {.lex_state = 3, .external_lex_state = 14},
  [4936] = {.lex_state = 3, .external_lex_state = 14},
  [4937] = {.lex_state = 3, .external_lex_state = 14},
  [4938] = {.lex_state = 3, .external_lex_state = 14},
  [4939] = {.lex_state = 3, .external_lex_state = 14},
  [4940] = {.lex_state = 3, .external_lex_state = 14},
  [4941] = {.lex_state = 4, .external_lex_state = 17},
  [4942] = {.lex_state = 4, .external_lex_state = 17},
  [4943] = {.lex_state = 3, .external_lex_state = 14},
  [4944] = {.lex_state = 8, .external_lex_state = 28},
  [4945] = {.lex_state = 8, .external_lex_state = 28},
  [4946] = {.lex_state = 8, .external_lex_state = 28},
  [4947] = {.lex_state = 3, .external_lex_state = 14},
  [4948] = {.lex_state = 3, .external_lex_state = 14},
  [4949] = {.lex_state = 3, .external_lex_state = 14},
  [4950] = {.lex_state = 3, .external_lex_state = 14},
  [4951] = {.lex_state = 3, .external_lex_state = 14},
  [4952] = {.lex_state = 8, .external_lex_state = 28},
  [4953] = {.lex_state = 3, .external_lex_state = 14},
  [4954] = {.lex_state = 3, .external_lex_state = 14},
  [4955] = {.lex_state = 3, .external_lex_state = 14},
  [4956] = {.lex_state = 3, .external_lex_state = 14},
  [4957] = {.lex_state = 3, .external_lex_state = 14},
  [4958] = {.lex_state = 3, .external_lex_state = 14},
  [4959] = {.lex_state = 3, .external_lex_state = 14},
  [4960] = {.lex_state = 4, .external_lex_state = 17},
  [4961] = {.lex_state = 4, .external_lex_state = 17},
  [4962] = {.lex_state = 4, .external_lex_state = 17},
  [4963] = {.lex_state = 4, .external_lex_state = 17},
  [4964] = {.lex_state = 3, .external_lex_state = 14},
  [4965] = {.lex_state = 3, .external_lex_state = 14},
  [4966] = {.lex_state = 4, .external_lex_state = 17},
  [4967] = {.lex_state = 8, .external_lex_state = 28},
  [4968] = {.lex_state = 8, .external_lex_state = 28},
  [4969] = {.lex_state = 8, .external_lex_state = 28},
  [4970] = {.lex_state = 3, .external_lex_state = 14},
  [4971] = {.lex_state = 3, .external_lex_state = 14},
  [4972] = {.lex_state = 3, .external_lex_state = 14},
  [4973] = {.lex_state = 3, .external_lex_state = 14},
  [4974] = {.lex_state = 3, .external_lex_state = 14},
  [4975] = {.lex_state = 4, .external_lex_state = 17},
  [4976] = {.lex_state = 3, .external_lex_state = 14},
  [4977] = {.lex_state = 3, .external_lex_state = 14},
  [4978] = {.lex_state = 4, .external_lex_state = 17},
  [4979] = {.lex_state = 4, .external_lex_state = 17},
  [4980] = {.lex_state = 4, .external_lex_state = 17},
  [4981] = {.lex_state = 4, .external_lex_state = 17},
  [4982] = {.lex_state = 3, .external_lex_state = 14},
  [4983] = {.lex_state = 3, .external_lex_state = 14},
  [4984] = {.lex_state = 3, .external_lex_state = 14},
  [4985] = {.lex_state = 3, .external_lex_state = 14},
  [4986] = {.lex_state = 3, .external_lex_state = 14},
  [4987] = {.lex_state = 3, .external_lex_state = 14},
  [4988] = {.lex_state = 3, .external_lex_state = 14},
  [4989] = {.lex_state = 3, .external_lex_state = 14},
  [4990] = {.lex_state = 3, .external_lex_state = 14},
  [4991] = {.lex_state = 3, .external_lex_state = 14},
  [4992] = {.lex_state = 4, .external_lex_state = 17},
  [4993] = {.lex_state = 3, .external_lex_state = 14},
  [4994] = {.lex_state = 4, .external_lex_state = 17},
  [4995] = {.lex_state = 3, .external_lex_state = 14},
  [4996] = {.lex_state = 3, .external_lex_state = 14},
  [4997] = {.lex_state = 3, .external_lex_state = 14},
  [4998] = {.lex_state = 3, .external_lex_state = 14},
  [4999] = {.lex_state = 3, .external_lex_state = 14},
  [5000] = {.lex_state = 3, .external_lex_state = 14},
  [5001] = {.lex_state = 3, .external_lex_state = 14},
  [5002] = {.lex_state = 3, .external_lex_state = 14},
  [5003] = {.lex_state = 3, .external_lex_state = 14},
  [5004] = {.lex_state = 3, .external_lex_state = 14},
  [5005] = {.lex_state = 3, .external_lex_state = 14},
  [5006] = {.lex_state = 3, .external_lex_state = 14},
  [5007] = {.lex_state = 3, .external_lex_state = 14},
  [5008] = {.lex_state = 3, .external_lex_state = 14},
  [5009] = {.lex_state = 3, .external_lex_state = 14},
  [5010] = {.lex_state = 3, .external_lex_state = 14},
  [5011] = {.lex_state = 18, .external_lex_state = 119},
  [5012] = {.lex_state = 18, .external_lex_state = 119},
  [5013] = {.lex_state = 3, .external_lex_state = 14},
  [5014] = {.lex_state = 4, .external_lex_state = 17},
  [5015] = {.lex_state = 4, .external_lex_state = 17},
  [5016] = {.lex_state = 3, .external_lex_state = 14},
  [5017] = {.lex_state = 3, .external_lex_state = 14},
  [5018] = {.lex_state = 3, .external_lex_state = 14},
  [5019] = {.lex_state = 4, .external_lex_state = 17},
  [5020] = {.lex_state = 3, .external_lex_state = 14},
  [5021] = {.lex_state = 3, .external_lex_state = 14},
  [5022] = {.lex_state = 3, .external_lex_state = 14},
  [5023] = {.lex_state = 4, .external_lex_state = 17},
  [5024] = {.lex_state = 4, .external_lex_state = 17},
  [5025] = {.lex_state = 4, .external_lex_state = 17},
  [5026] = {.lex_state = 3, .external_lex_state = 14},
  [5027] = {.lex_state = 3, .external_lex_state = 14},
  [5028] = {.lex_state = 3, .external_lex_state = 14},
  [5029] = {.lex_state = 3, .external_lex_state = 14},
  [5030] = {.lex_state = 3, .external_lex_state = 14},
  [5031] = {.lex_state = 3, .external_lex_state = 14},
  [5032] = {.lex_state = 3, .external_lex_state = 14},
  [5033] = {.lex_state = 4, .external_lex_state = 17},
  [5034] = {.lex_state = 4, .external_lex_state = 17},
  [5035] = {.lex_state = 4, .external_lex_state = 17},
  [5036] = {.lex_state = 4, .external_lex_state = 17},
  [5037] = {.lex_state = 3, .external_lex_state = 14},
  [5038] = {.lex_state = 4, .external_lex_state = 17},
  [5039] = {.lex_state = 4, .external_lex_state = 17},
  [5040] = {.lex_state = 3, .external_lex_state = 14},
  [5041] = {.lex_state = 4, .external_lex_state = 17},
  [5042] = {.lex_state = 4, .external_lex_state = 17},
  [5043] = {.lex_state = 3, .external_lex_state = 14},
  [5044] = {.lex_state = 4, .external_lex_state = 17},
  [5045] = {.lex_state = 3, .external_lex_state = 14},
  [5046] = {.lex_state = 4, .external_lex_state = 17},
  [5047] = {.lex_state = 4, .external_lex_state = 17},
  [5048] = {.lex_state = 3, .external_lex_state = 14},
  [5049] = {.lex_state = 4, .external_lex_state = 17},
  [5050] = {.lex_state = 3, .external_lex_state = 14},
  [5051] = {.lex_state = 3, .external_lex_state = 14},
  [5052] = {.lex_state = 4, .external_lex_state = 17},
  [5053] = {.lex_state = 3, .external_lex_state = 14},
  [5054] = {.lex_state = 3, .external_lex_state = 14},
  [5055] = {.lex_state = 3, .external_lex_state = 14},
  [5056] = {.lex_state = 3, .external_lex_state = 14},
  [5057] = {.lex_state = 4, .external_lex_state = 17},
  [5058] = {.lex_state = 4, .external_lex_state = 17},
  [5059] = {.lex_state = 3, .external_lex_state = 14},
  [5060] = {.lex_state = 3, .external_lex_state = 14},
  [5061] = {.lex_state = 3, .external_lex_state = 14},
  [5062] = {.lex_state = 3, .external_lex_state = 14},
  [5063] = {.lex_state = 3, .external_lex_state = 14},
  [5064] = {.lex_state = 4, .external_lex_state = 17},
  [5065] = {.lex_state = 3, .external_lex_state = 14},
  [5066] = {.lex_state = 3, .external_lex_state = 14},
  [5067] = {.lex_state = 3, .external_lex_state = 14},
  [5068] = {.lex_state = 3, .external_lex_state = 14},
  [5069] = {.lex_state = 3, .external_lex_state = 14},
  [5070] = {.lex_state = 4, .external_lex_state = 17},
  [5071] = {.lex_state = 4, .external_lex_state = 17},
  [5072] = {.lex_state = 4, .external_lex_state = 17},
  [5073] = {.lex_state = 4, .external_lex_state = 17},
  [5074] = {.lex_state = 8, .external_lex_state = 28},
  [5075] = {.lex_state = 8, .external_lex_state = 28},
  [5076] = {.lex_state = 8, .external_lex_state = 28},
  [5077] = {.lex_state = 8, .external_lex_state = 28},
  [5078] = {.lex_state = 8, .external_lex_state = 28},
  [5079] = {.lex_state = 8, .external_lex_state = 28},
  [5080] = {.lex_state = 8, .external_lex_state = 28},
  [5081] = {.lex_state = 8, .external_lex_state = 28},
  [5082] = {.lex_state = 8, .external_lex_state = 28},
  [5083] = {.lex_state = 4, .external_lex_state = 17},
  [5084] = {.lex_state = 4, .external_lex_state = 17},
  [5085] = {.lex_state = 8, .external_lex_state = 28},
  [5086] = {.lex_state = 3, .external_lex_state = 14},
  [5087] = {.lex_state = 11, .external_lex_state = 33},
  [5088] = {.lex_state = 8, .external_lex_state = 28},
  [5089] = {.lex_state = 8, .external_lex_state = 28},
  [5090] = {.lex_state = 8, .external_lex_state = 28},
  [5091] = {.lex_state = 8, .external_lex_state = 28},
  [5092] = {.lex_state = 8, .external_lex_state = 28},
  [5093] = {.lex_state = 18, .external_lex_state = 119},
  [5094] = {.lex_state = 8, .external_lex_state = 28},
  [5095] = {.lex_state = 8, .external_lex_state = 28},
  [5096] = {.lex_state = 4, .external_lex_state = 17},
  [5097] = {.lex_state = 8, .external_lex_state = 28},
  [5098] = {.lex_state = 8, .external_lex_state = 28},
  [5099] = {.lex_state = 8, .external_lex_state = 28},
  [5100] = {.lex_state = 8, .external_lex_state = 28},
  [5101] = {.lex_state = 8, .external_lex_state = 28},
  [5102] = {.lex_state = 8, .external_lex_state = 28},
  [5103] = {.lex_state = 8, .external_lex_state = 28},
  [5104] = {.lex_state = 4, .external_lex_state = 7},
  [5105] = {.lex_state = 3, .external_lex_state = 15},
  [5106] = {.lex_state = 3, .external_lex_state = 16},
  [5107] = {.lex_state = 4, .external_lex_state = 7},
  [5108] = {.lex_state = 4, .external_lex_state = 7},
  [5109] = {.lex_state = 4, .external_lex_state = 7},
  [5110] = {.lex_state = 3, .external_lex_state = 16},
  [5111] = {.lex_state = 4, .external_lex_state = 7},
  [5112] = {.lex_state = 4, .external_lex_state = 7},
  [5113] = {.lex_state = 4, .external_lex_state = 7},
  [5114] = {.lex_state = 4, .external_lex_state = 7},
  [5115] = {.lex_state = 4, .external_lex_state = 7},
  [5116] = {.lex_state = 4, .external_lex_state = 7},
  [5117] = {.lex_state = 3, .external_lex_state = 15},
  [5118] = {.lex_state = 3, .external_lex_state = 15},
  [5119] = {.lex_state = 3, .external_lex_state = 16},
  [5120] = {.lex_state = 3, .external_lex_state = 16},
  [5121] = {.lex_state = 3, .external_lex_state = 16},
  [5122] = {.lex_state = 3, .external_lex_state = 16},
  [5123] = {.lex_state = 3, .external_lex_state = 16},
  [5124] = {.lex_state = 3, .external_lex_state = 16},
  [5125] = {.lex_state = 3, .external_lex_state = 16},
  [5126] = {.lex_state = 3, .external_lex_state = 16},
  [5127] = {.lex_state = 4, .external_lex_state = 7},
  [5128] = {.lex_state = 8, .external_lex_state = 120},
  [5129] = {.lex_state = 3, .external_lex_state = 16},
  [5130] = {.lex_state = 3, .external_lex_state = 16},
  [5131] = {.lex_state = 3, .external_lex_state = 16},
  [5132] = {.lex_state = 3, .external_lex_state = 16},
  [5133] = {.lex_state = 3, .external_lex_state = 16},
  [5134] = {.lex_state = 3, .external_lex_state = 16},
  [5135] = {.lex_state = 8, .external_lex_state = 120},
  [5136] = {.lex_state = 3, .external_lex_state = 16},
  [5137] = {.lex_state = 3, .external_lex_state = 16},
  [5138] = {.lex_state = 3, .external_lex_state = 16},
  [5139] = {.lex_state = 3, .external_lex_state = 16},
  [5140] = {.lex_state = 3, .external_lex_state = 16},
  [5141] = {.lex_state = 3, .external_lex_state = 16},
  [5142] = {.lex_state = 3, .external_lex_state = 16},
  [5143] = {.lex_state = 3, .external_lex_state = 16},
  [5144] = {.lex_state = 3, .external_lex_state = 16},
  [5145] = {.lex_state = 3, .external_lex_state = 16},
  [5146] = {.lex_state = 3, .external_lex_state = 16},
  [5147] = {.lex_state = 8, .external_lex_state = 121},
  [5148] = {.lex_state = 3, .external_lex_state = 16},
  [5149] = {.lex_state = 3, .external_lex_state = 15},
  [5150] = {.lex_state = 3, .external_lex_state = 15},
  [5151] = {.lex_state = 3, .external_lex_state = 15},
  [5152] = {.lex_state = 3, .external_lex_state = 15},
  [5153] = {.lex_state = 3, .external_lex_state = 15},
  [5154] = {.lex_state = 3, .external_lex_state = 15},
  [5155] = {.lex_state = 3, .external_lex_state = 15},
  [5156] = {.lex_state = 3, .external_lex_state = 15},
  [5157] = {.lex_state = 3, .external_lex_state = 15},
  [5158] = {.lex_state = 3, .external_lex_state = 15},
  [5159] = {.lex_state = 3, .external_lex_state = 15},
  [5160] = {.lex_state = 3, .external_lex_state = 15},
  [5161] = {.lex_state = 3, .external_lex_state = 15},
  [5162] = {.lex_state = 4, .external_lex_state = 7},
  [5163] = {.lex_state = 3, .external_lex_state = 15},
  [5164] = {.lex_state = 3, .external_lex_state = 15},
  [5165] = {.lex_state = 3, .external_lex_state = 15},
  [5166] = {.lex_state = 4, .external_lex_state = 7},
  [5167] = {.lex_state = 3, .external_lex_state = 15},
  [5168] = {.lex_state = 3, .external_lex_state = 15},
  [5169] = {.lex_state = 3, .external_lex_state = 16},
  [5170] = {.lex_state = 4, .external_lex_state = 7},
  [5171] = {.lex_state = 3, .external_lex_state = 15},
  [5172] = {.lex_state = 3, .external_lex_state = 15},
  [5173] = {.lex_state = 3, .external_lex_state = 15},
  [5174] = {.lex_state = 3, .external_lex_state = 16},
  [5175] = {.lex_state = 3, .external_lex_state = 16},
  [5176] = {.lex_state = 3, .external_lex_state = 15},
  [5177] = {.lex_state = 3, .external_lex_state = 16},
  [5178] = {.lex_state = 4, .external_lex_state = 7},
  [5179] = {.lex_state = 4, .external_lex_state = 7},
  [5180] = {.lex_state = 3, .external_lex_state = 15},
  [5181] = {.lex_state = 3, .external_lex_state = 16},
  [5182] = {.lex_state = 3, .external_lex_state = 15},
  [5183] = {.lex_state = 4, .external_lex_state = 7},
  [5184] = {.lex_state = 4, .external_lex_state = 7},
  [5185] = {.lex_state = 4, .external_lex_state = 7},
  [5186] = {.lex_state = 4, .external_lex_state = 7},
  [5187] = {.lex_state = 4, .external_lex_state = 7},
  [5188] = {.lex_state = 4, .external_lex_state = 7},
  [5189] = {.lex_state = 4, .external_lex_state = 7},
  [5190] = {.lex_state = 3, .external_lex_state = 15},
  [5191] = {.lex_state = 3, .external_lex_state = 15},
  [5192] = {.lex_state = 4, .external_lex_state = 7},
  [5193] = {.lex_state = 3, .external_lex_state = 15},
  [5194] = {.lex_state = 3, .external_lex_state = 15},
  [5195] = {.lex_state = 3, .external_lex_state = 15},
  [5196] = {.lex_state = 4, .external_lex_state = 7},
  [5197] = {.lex_state = 4, .external_lex_state = 7},
  [5198] = {.lex_state = 4, .external_lex_state = 7},
  [5199] = {.lex_state = 4, .external_lex_state = 7},
  [5200] = {.lex_state = 4, .external_lex_state = 7},
  [5201] = {.lex_state = 4, .external_lex_state = 7},
  [5202] = {.lex_state = 4, .external_lex_state = 7},
  [5203] = {.lex_state = 4, .external_lex_state = 7},
  [5204] = {.lex_state = 4, .external_lex_state = 7},
  [5205] = {.lex_state = 4, .external_lex_state = 7},
  [5206] = {.lex_state = 3, .external_lex_state = 15},
  [5207] = {.lex_state = 4, .external_lex_state = 7},
  [5208] = {.lex_state = 3, .external_lex_state = 16},
  [5209] = {.lex_state = 4, .external_lex_state = 7},
  [5210] = {.lex_state = 4, .external_lex_state = 7},
  [5211] = {.lex_state = 4, .external_lex_state = 7},
  [5212] = {.lex_state = 4, .external_lex_state = 7},
  [5213] = {.lex_state = 3, .external_lex_state = 16},
  [5214] = {.lex_state = 3, .external_lex_state = 16},
  [5215] = {.lex_state = 3, .external_lex_state = 15},
  [5216] = {.lex_state = 3, .external_lex_state = 16},
  [5217] = {.lex_state = 4, .external_lex_state = 7},
  [5218] = {.lex_state = 4, .external_lex_state = 7},
  [5219] = {.lex_state = 4, .external_lex_state = 7},
  [5220] = {.lex_state = 4, .external_lex_state = 7},
  [5221] = {.lex_state = 4, .external_lex_state = 7},
  [5222] = {.lex_state = 4, .external_lex_state = 7},
  [5223] = {.lex_state = 4, .external_lex_state = 7},
  [5224] = {.lex_state = 4, .external_lex_state = 7},
  [5225] = {.lex_state = 4, .external_lex_state = 7},
  [5226] = {.lex_state = 3, .external_lex_state = 16},
  [5227] = {.lex_state = 4, .external_lex_state = 7},
  [5228] = {.lex_state = 4, .external_lex_state = 7},
  [5229] = {.lex_state = 4, .external_lex_state = 7},
  [5230] = {.lex_state = 4, .external_lex_state = 7},
  [5231] = {.lex_state = 4, .external_lex_state = 7},
  [5232] = {.lex_state = 4, .external_lex_state = 7},
  [5233] = {.lex_state = 4, .external_lex_state = 7},
  [5234] = {.lex_state = 3, .external_lex_state = 16},
  [5235] = {.lex_state = 4, .external_lex_state = 7},
  [5236] = {.lex_state = 4, .external_lex_state = 7},
  [5237] = {.lex_state = 4, .external_lex_state = 7},
  [5238] = {.lex_state = 4, .external_lex_state = 7},
  [5239] = {.lex_state = 4, .external_lex_state = 7},
  [5240] = {.lex_state = 4, .external_lex_state = 7},
  [5241] = {.lex_state = 3, .external_lex_state = 16},
  [5242] = {.lex_state = 4, .external_lex_state = 7},
  [5243] = {.lex_state = 4, .external_lex_state = 7},
  [5244] = {.lex_state = 3, .external_lex_state = 15},
  [5245] = {.lex_state = 3, .external_lex_state = 15},
  [5246] = {.lex_state = 3, .external_lex_state = 15},
  [5247] = {.lex_state = 4, .external_lex_state = 7},
  [5248] = {.lex_state = 3, .external_lex_state = 15},
  [5249] = {.lex_state = 3, .external_lex_state = 16},
  [5250] = {.lex_state = 3, .external_lex_state = 16},
  [5251] = {.lex_state = 3, .external_lex_state = 16},
  [5252] = {.lex_state = 3, .external_lex_state = 16},
  [5253] = {.lex_state = 3, .external_lex_state = 16},
  [5254] = {.lex_state = 4, .external_lex_state = 7},
  [5255] = {.lex_state = 3, .external_lex_state = 15},
  [5256] = {.lex_state = 4, .external_lex_state = 7},
  [5257] = {.lex_state = 4, .external_lex_state = 7},
  [5258] = {.lex_state = 4, .external_lex_state = 7},
  [5259] = {.lex_state = 4, .external_lex_state = 7},
  [5260] = {.lex_state = 4, .external_lex_state = 7},
  [5261] = {.lex_state = 4, .external_lex_state = 7},
  [5262] = {.lex_state = 4, .external_lex_state = 7},
  [5263] = {.lex_state = 3, .external_lex_state = 16},
  [5264] = {.lex_state = 4, .external_lex_state = 7},
  [5265] = {.lex_state = 3, .external_lex_state = 16},
  [5266] = {.lex_state = 4, .external_lex_state = 7},
  [5267] = {.lex_state = 4, .external_lex_state = 7},
  [5268] = {.lex_state = 4, .external_lex_state = 7},
  [5269] = {.lex_state = 4, .external_lex_state = 7},
  [5270] = {.lex_state = 4, .external_lex_state = 7},
  [5271] = {.lex_state = 3, .external_lex_state = 15},
  [5272] = {.lex_state = 3, .external_lex_state = 15},
  [5273] = {.lex_state = 3, .external_lex_state = 15},
  [5274] = {.lex_state = 4, .external_lex_state = 7},
  [5275] = {.lex_state = 3, .external_lex_state = 16},
  [5276] = {.lex_state = 3, .external_lex_state = 16},
  [5277] = {.lex_state = 4, .external_lex_state = 7},
  [5278] = {.lex_state = 3, .external_lex_state = 16},
  [5279] = {.lex_state = 4, .external_lex_state = 7},
  [5280] = {.lex_state = 4, .external_lex_state = 7},
  [5281] = {.lex_state = 4, .external_lex_state = 7},
  [5282] = {.lex_state = 4, .external_lex_state = 7},
  [5283] = {.lex_state = 3, .external_lex_state = 16},
  [5284] = {.lex_state = 3, .external_lex_state = 16},
  [5285] = {.lex_state = 3, .external_lex_state = 15},
  [5286] = {.lex_state = 3, .external_lex_state = 15},
  [5287] = {.lex_state = 4, .external_lex_state = 7},
  [5288] = {.lex_state = 4, .external_lex_state = 7},
  [5289] = {.lex_state = 4, .external_lex_state = 7},
  [5290] = {.lex_state = 4, .external_lex_state = 7},
  [5291] = {.lex_state = 4, .external_lex_state = 7},
  [5292] = {.lex_state = 4, .external_lex_state = 7},
  [5293] = {.lex_state = 3, .external_lex_state = 16},
  [5294] = {.lex_state = 3, .external_lex_state = 16},
  [5295] = {.lex_state = 3, .external_lex_state = 16},
  [5296] = {.lex_state = 4, .external_lex_state = 7},
  [5297] = {.lex_state = 3, .external_lex_state = 16},
  [5298] = {.lex_state = 4, .external_lex_state = 7},
  [5299] = {.lex_state = 3, .external_lex_state = 16},
  [5300] = {.lex_state = 4, .external_lex_state = 7},
  [5301] = {.lex_state = 4, .external_lex_state = 7},
  [5302] = {.lex_state = 4, .external_lex_state = 7},
  [5303] = {.lex_state = 4, .external_lex_state = 7},
  [5304] = {.lex_state = 3, .external_lex_state = 16},
  [5305] = {.lex_state = 3, .external_lex_state = 16},
  [5306] = {.lex_state = 3, .external_lex_state = 16},
  [5307] = {.lex_state = 3, .external_lex_state = 16},
  [5308] = {.lex_state = 3, .external_lex_state = 16},
  [5309] = {.lex_state = 3, .external_lex_state = 16},
  [5310] = {.lex_state = 3, .external_lex_state = 16},
  [5311] = {.lex_state = 3, .external_lex_state = 16},
  [5312] = {.lex_state = 3, .external_lex_state = 16},
  [5313] = {.lex_state = 3, .external_lex_state = 16},
  [5314] = {.lex_state = 3, .external_lex_state = 16},
  [5315] = {.lex_state = 3, .external_lex_state = 15},
  [5316] = {.lex_state = 4, .external_lex_state = 7},
  [5317] = {.lex_state = 3, .external_lex_state = 15},
  [5318] = {.lex_state = 3, .external_lex_state = 15},
  [5319] = {.lex_state = 3, .external_lex_state = 16},
  [5320] = {.lex_state = 3, .external_lex_state = 16},
  [5321] = {.lex_state = 3, .external_lex_state = 15},
  [5322] = {.lex_state = 3, .external_lex_state = 16},
  [5323] = {.lex_state = 3, .external_lex_state = 16},
  [5324] = {.lex_state = 3, .external_lex_state = 16},
  [5325] = {.lex_state = 3, .external_lex_state = 16},
  [5326] = {.lex_state = 3, .external_lex_state = 16},
  [5327] = {.lex_state = 3, .external_lex_state = 16},
  [5328] = {.lex_state = 3, .external_lex_state = 16},
  [5329] = {.lex_state = 4, .external_lex_state = 7},
  [5330] = {.lex_state = 4, .external_lex_state = 7},
  [5331] = {.lex_state = 3, .external_lex_state = 16},
  [5332] = {.lex_state = 3, .external_lex_state = 16},
  [5333] = {.lex_state = 4, .external_lex_state = 7},
  [5334] = {.lex_state = 4, .external_lex_state = 7},
  [5335] = {.lex_state = 4, .external_lex_state = 7},
  [5336] = {.lex_state = 4, .external_lex_state = 7},
  [5337] = {.lex_state = 3, .external_lex_state = 16},
  [5338] = {.lex_state = 3, .external_lex_state = 16},
  [5339] = {.lex_state = 3, .external_lex_state = 16},
  [5340] = {.lex_state = 3, .external_lex_state = 16},
  [5341] = {.lex_state = 3, .external_lex_state = 16},
  [5342] = {.lex_state = 3, .external_lex_state = 16},
  [5343] = {.lex_state = 3, .external_lex_state = 16},
  [5344] = {.lex_state = 3, .external_lex_state = 16},
  [5345] = {.lex_state = 3, .external_lex_state = 16},
  [5346] = {.lex_state = 3, .external_lex_state = 16},
  [5347] = {.lex_state = 3, .external_lex_state = 16},
  [5348] = {.lex_state = 3, .external_lex_state = 16},
  [5349] = {.lex_state = 3, .external_lex_state = 16},
  [5350] = {.lex_state = 3, .external_lex_state = 16},
  [5351] = {.lex_state = 3, .external_lex_state = 16},
  [5352] = {.lex_state = 3, .external_lex_state = 16},
  [5353] = {.lex_state = 3, .external_lex_state = 16},
  [5354] = {.lex_state = 3, .external_lex_state = 16},
  [5355] = {.lex_state = 3, .external_lex_state = 16},
  [5356] = {.lex_state = 3, .external_lex_state = 15},
  [5357] = {.lex_state = 8, .external_lex_state = 120},
  [5358] = {.lex_state = 3, .external_lex_state = 16},
  [5359] = {.lex_state = 4, .external_lex_state = 7},
  [5360] = {.lex_state = 4, .external_lex_state = 7},
  [5361] = {.lex_state = 3, .external_lex_state = 16},
  [5362] = {.lex_state = 4, .external_lex_state = 7},
  [5363] = {.lex_state = 4, .external_lex_state = 7},
  [5364] = {.lex_state = 4, .external_lex_state = 7},
  [5365] = {.lex_state = 4, .external_lex_state = 7},
  [5366] = {.lex_state = 4, .external_lex_state = 7},
  [5367] = {.lex_state = 4, .external_lex_state = 7},
  [5368] = {.lex_state = 4, .external_lex_state = 7},
  [5369] = {.lex_state = 4, .external_lex_state = 7},
  [5370] = {.lex_state = 4, .external_lex_state = 7},
  [5371] = {.lex_state = 4, .external_lex_state = 7},
  [5372] = {.lex_state = 4, .external_lex_state = 7},
  [5373] = {.lex_state = 4, .external_lex_state = 7},
  [5374] = {.lex_state = 4, .external_lex_state = 7},
  [5375] = {.lex_state = 3, .external_lex_state = 15},
  [5376] = {.lex_state = 4, .external_lex_state = 7},
  [5377] = {.lex_state = 4, .external_lex_state = 7},
  [5378] = {.lex_state = 4, .external_lex_state = 7},
  [5379] = {.lex_state = 4, .external_lex_state = 7},
  [5380] = {.lex_state = 4, .external_lex_state = 7},
  [5381] = {.lex_state = 4, .external_lex_state = 7},
  [5382] = {.lex_state = 4, .external_lex_state = 7},
  [5383] = {.lex_state = 4, .external_lex_state = 7},
  [5384] = {.lex_state = 3, .external_lex_state = 16},
  [5385] = {.lex_state = 4, .external_lex_state = 7},
  [5386] = {.lex_state = 4, .external_lex_state = 7},
  [5387] = {.lex_state = 4, .external_lex_state = 7},
  [5388] = {.lex_state = 4, .external_lex_state = 7},
  [5389] = {.lex_state = 3, .external_lex_state = 16},
  [5390] = {.lex_state = 3, .external_lex_state = 16},
  [5391] = {.lex_state = 3, .external_lex_state = 16},
  [5392] = {.lex_state = 3, .external_lex_state = 16},
  [5393] = {.lex_state = 3, .external_lex_state = 16},
  [5394] = {.lex_state = 3, .external_lex_state = 16},
  [5395] = {.lex_state = 8, .external_lex_state = 121},
  [5396] = {.lex_state = 3, .external_lex_state = 16},
  [5397] = {.lex_state = 3, .external_lex_state = 16},
  [5398] = {.lex_state = 3, .external_lex_state = 16},
  [5399] = {.lex_state = 3, .external_lex_state = 16},
  [5400] = {.lex_state = 3, .external_lex_state = 16},
  [5401] = {.lex_state = 3, .external_lex_state = 16},
  [5402] = {.lex_state = 3, .external_lex_state = 16},
  [5403] = {.lex_state = 3, .external_lex_state = 16},
  [5404] = {.lex_state = 3, .external_lex_state = 16},
  [5405] = {.lex_state = 8, .external_lex_state = 121},
  [5406] = {.lex_state = 3, .external_lex_state = 16},
  [5407] = {.lex_state = 3, .external_lex_state = 15},
  [5408] = {.lex_state = 3, .external_lex_state = 16},
  [5409] = {.lex_state = 3, .external_lex_state = 16},
  [5410] = {.lex_state = 3, .external_lex_state = 16},
  [5411] = {.lex_state = 3, .external_lex_state = 16},
  [5412] = {.lex_state = 3, .external_lex_state = 16},
  [5413] = {.lex_state = 3, .external_lex_state = 16},
  [5414] = {.lex_state = 3, .external_lex_state = 16},
  [5415] = {.lex_state = 3, .external_lex_state = 16},
  [5416] = {.lex_state = 3, .external_lex_state = 16},
  [5417] = {.lex_state = 3, .external_lex_state = 16},
  [5418] = {.lex_state = 8, .external_lex_state = 121},
  [5419] = {.lex_state = 3, .external_lex_state = 16},
  [5420] = {.lex_state = 8, .external_lex_state = 120},
  [5421] = {.lex_state = 3, .external_lex_state = 15},
  [5422] = {.lex_state = 3, .external_lex_state = 15},
  [5423] = {.lex_state = 3, .external_lex_state = 15},
  [5424] = {.lex_state = 3, .external_lex_state = 15},
  [5425] = {.lex_state = 3, .external_lex_state = 15},
  [5426] = {.lex_state = 8, .external_lex_state = 121},
  [5427] = {.lex_state = 3, .external_lex_state = 15},
  [5428] = {.lex_state = 3, .external_lex_state = 15},
  [5429] = {.lex_state = 3, .external_lex_state = 15},
  [5430] = {.lex_state = 3, .external_lex_state = 15},
  [5431] = {.lex_state = 3, .external_lex_state = 15},
  [5432] = {.lex_state = 3, .external_lex_state = 15},
  [5433] = {.lex_state = 3, .external_lex_state = 15},
  [5434] = {.lex_state = 3, .external_lex_state = 15},
  [5435] = {.lex_state = 3, .external_lex_state = 15},
  [5436] = {.lex_state = 3, .external_lex_state = 15},
  [5437] = {.lex_state = 3, .external_lex_state = 15},
  [5438] = {.lex_state = 3, .external_lex_state = 15},
  [5439] = {.lex_state = 3, .external_lex_state = 15},
  [5440] = {.lex_state = 3, .external_lex_state = 15},
  [5441] = {.lex_state = 8, .external_lex_state = 120},
  [5442] = {.lex_state = 3, .external_lex_state = 15},
  [5443] = {.lex_state = 3, .external_lex_state = 15},
  [5444] = {.lex_state = 3, .external_lex_state = 15},
  [5445] = {.lex_state = 3, .external_lex_state = 15},
  [5446] = {.lex_state = 8, .external_lex_state = 120},
  [5447] = {.lex_state = 3, .external_lex_state = 16},
  [5448] = {.lex_state = 3, .external_lex_state = 16},
  [5449] = {.lex_state = 8, .external_lex_state = 120},
  [5450] = {.lex_state = 3, .external_lex_state = 15},
  [5451] = {.lex_state = 3, .external_lex_state = 15},
  [5452] = {.lex_state = 3, .external_lex_state = 15},
  [5453] = {.lex_state = 3, .external_lex_state = 15},
  [5454] = {.lex_state = 3, .external_lex_state = 15},
  [5455] = {.lex_state = 3, .external_lex_state = 15},
  [5456] = {.lex_state = 3, .external_lex_state = 15},
  [5457] = {.lex_state = 4, .external_lex_state = 7},
  [5458] = {.lex_state = 3, .external_lex_state = 15},
  [5459] = {.lex_state = 3, .external_lex_state = 15},
  [5460] = {.lex_state = 3, .external_lex_state = 15},
  [5461] = {.lex_state = 3, .external_lex_state = 15},
  [5462] = {.lex_state = 3, .external_lex_state = 15},
  [5463] = {.lex_state = 3, .external_lex_state = 15},
  [5464] = {.lex_state = 3, .external_lex_state = 15},
  [5465] = {.lex_state = 3, .external_lex_state = 15},
  [5466] = {.lex_state = 3, .external_lex_state = 15},
  [5467] = {.lex_state = 8, .external_lex_state = 120},
  [5468] = {.lex_state = 3, .external_lex_state = 15},
  [5469] = {.lex_state = 3, .external_lex_state = 15},
  [5470] = {.lex_state = 3, .external_lex_state = 16},
  [5471] = {.lex_state = 3, .external_lex_state = 15},
  [5472] = {.lex_state = 3, .external_lex_state = 15},
  [5473] = {.lex_state = 3, .external_lex_state = 15},
  [5474] = {.lex_state = 3, .external_lex_state = 15},
  [5475] = {.lex_state = 3, .external_lex_state = 15},
  [5476] = {.lex_state = 3, .external_lex_state = 15},
  [5477] = {.lex_state = 3, .external_lex_state = 15},
  [5478] = {.lex_state = 3, .external_lex_state = 15},
  [5479] = {.lex_state = 3, .external_lex_state = 15},
  [5480] = {.lex_state = 3, .external_lex_state = 15},
  [5481] = {.lex_state = 3, .external_lex_state = 15},
  [5482] = {.lex_state = 3, .external_lex_state = 15},
  [5483] = {.lex_state = 3, .external_lex_state = 15},
  [5484] = {.lex_state = 3, .external_lex_state = 15},
  [5485] = {.lex_state = 3, .external_lex_state = 15},
  [5486] = {.lex_state = 3, .external_lex_state = 15},
  [5487] = {.lex_state = 3, .external_lex_state = 15},
  [5488] = {.lex_state = 3, .external_lex_state = 15},
  [5489] = {.lex_state = 3, .external_lex_state = 15},
  [5490] = {.lex_state = 3, .external_lex_state = 15},
  [5491] = {.lex_state = 3, .external_lex_state = 15},
  [5492] = {.lex_state = 4, .external_lex_state = 7},
  [5493] = {.lex_state = 3, .external_lex_state = 15},
  [5494] = {.lex_state = 3, .external_lex_state = 15},
  [5495] = {.lex_state = 3, .external_lex_state = 15},
  [5496] = {.lex_state = 3, .external_lex_state = 76},
  [5497] = {.lex_state = 3, .external_lex_state = 15},
  [5498] = {.lex_state = 3, .external_lex_state = 15},
  [5499] = {.lex_state = 3, .external_lex_state = 15},
  [5500] = {.lex_state = 8, .external_lex_state = 121},
  [5501] = {.lex_state = 3, .external_lex_state = 15},
  [5502] = {.lex_state = 3, .external_lex_state = 15},
  [5503] = {.lex_state = 3, .external_lex_state = 15},
  [5504] = {.lex_state = 3, .external_lex_state = 16},
  [5505] = {.lex_state = 3, .external_lex_state = 15},
  [5506] = {.lex_state = 3, .external_lex_state = 15},
  [5507] = {.lex_state = 3, .external_lex_state = 15},
  [5508] = {.lex_state = 3, .external_lex_state = 15},
  [5509] = {.lex_state = 3, .external_lex_state = 15},
  [5510] = {.lex_state = 3, .external_lex_state = 15},
  [5511] = {.lex_state = 3, .external_lex_state = 15},
  [5512] = {.lex_state = 3, .external_lex_state = 15},
  [5513] = {.lex_state = 8, .external_lex_state = 120},
  [5514] = {.lex_state = 3, .external_lex_state = 15},
  [5515] = {.lex_state = 3, .external_lex_state = 15},
  [5516] = {.lex_state = 4, .external_lex_state = 17},
  [5517] = {.lex_state = 11, .external_lex_state = 122},
  [5518] = {.lex_state = 4, .external_lex_state = 17},
  [5519] = {.lex_state = 4, .external_lex_state = 17},
  [5520] = {.lex_state = 4, .external_lex_state = 17},
  [5521] = {.lex_state = 4, .external_lex_state = 17},
  [5522] = {.lex_state = 4, .external_lex_state = 17},
  [5523] = {.lex_state = 4, .external_lex_state = 17},
  [5524] = {.lex_state = 4, .external_lex_state = 17},
  [5525] = {.lex_state = 4, .external_lex_state = 17},
  [5526] = {.lex_state = 4, .external_lex_state = 17},
  [5527] = {.lex_state = 4, .external_lex_state = 17},
  [5528] = {.lex_state = 4, .external_lex_state = 17},
  [5529] = {.lex_state = 4, .external_lex_state = 17},
  [5530] = {.lex_state = 4, .external_lex_state = 17},
  [5531] = {.lex_state = 4, .external_lex_state = 17},
  [5532] = {.lex_state = 4, .external_lex_state = 17},
  [5533] = {.lex_state = 4, .external_lex_state = 17},
  [5534] = {.lex_state = 4, .external_lex_state = 17},
  [5535] = {.lex_state = 4, .external_lex_state = 17},
  [5536] = {.lex_state = 4, .external_lex_state = 17},
  [5537] = {.lex_state = 4, .external_lex_state = 17},
  [5538] = {.lex_state = 4, .external_lex_state = 17},
  [5539] = {.lex_state = 4, .external_lex_state = 17},
  [5540] = {.lex_state = 4, .external_lex_state = 17},
  [5541] = {.lex_state = 11, .external_lex_state = 122},
  [5542] = {.lex_state = 4, .external_lex_state = 17},
  [5543] = {.lex_state = 4, .external_lex_state = 17},
  [5544] = {.lex_state = 4, .external_lex_state = 17},
  [5545] = {.lex_state = 4, .external_lex_state = 17},
  [5546] = {.lex_state = 4, .external_lex_state = 17},
  [5547] = {.lex_state = 4, .external_lex_state = 17},
  [5548] = {.lex_state = 4, .external_lex_state = 17},
  [5549] = {.lex_state = 4, .external_lex_state = 17},
  [5550] = {.lex_state = 8, .external_lex_state = 123},
  [5551] = {.lex_state = 4, .external_lex_state = 17},
  [5552] = {.lex_state = 8, .external_lex_state = 123},
  [5553] = {.lex_state = 4, .external_lex_state = 17},
  [5554] = {.lex_state = 4, .external_lex_state = 17},
  [5555] = {.lex_state = 4, .external_lex_state = 17},
  [5556] = {.lex_state = 4, .external_lex_state = 17},
  [5557] = {.lex_state = 4, .external_lex_state = 17},
  [5558] = {.lex_state = 11, .external_lex_state = 124},
  [5559] = {.lex_state = 4, .external_lex_state = 17},
  [5560] = {.lex_state = 4, .external_lex_state = 17},
  [5561] = {.lex_state = 4, .external_lex_state = 17},
  [5562] = {.lex_state = 4, .external_lex_state = 17},
  [5563] = {.lex_state = 4, .external_lex_state = 17},
  [5564] = {.lex_state = 4, .external_lex_state = 17},
  [5565] = {.lex_state = 4, .external_lex_state = 17},
  [5566] = {.lex_state = 4, .external_lex_state = 17},
  [5567] = {.lex_state = 4, .external_lex_state = 17},
  [5568] = {.lex_state = 4, .external_lex_state = 17},
  [5569] = {.lex_state = 4, .external_lex_state = 17},
  [5570] = {.lex_state = 4, .external_lex_state = 17},
  [5571] = {.lex_state = 4, .external_lex_state = 17},
  [5572] = {.lex_state = 4, .external_lex_state = 17},
  [5573] = {.lex_state = 4, .external_lex_state = 17},
  [5574] = {.lex_state = 11, .external_lex_state = 124},
  [5575] = {.lex_state = 11, .external_lex_state = 124},
  [5576] = {.lex_state = 4, .external_lex_state = 17},
  [5577] = {.lex_state = 4, .external_lex_state = 17},
  [5578] = {.lex_state = 4, .external_lex_state = 17},
  [5579] = {.lex_state = 4, .external_lex_state = 17},
  [5580] = {.lex_state = 4, .external_lex_state = 17},
  [5581] = {.lex_state = 4, .external_lex_state = 17},
  [5582] = {.lex_state = 4, .external_lex_state = 17},
  [5583] = {.lex_state = 4, .external_lex_state = 17},
  [5584] = {.lex_state = 4, .external_lex_state = 17},
  [5585] = {.lex_state = 8, .external_lex_state = 123},
  [5586] = {.lex_state = 4, .external_lex_state = 17},
  [5587] = {.lex_state = 4, .external_lex_state = 17},
  [5588] = {.lex_state = 4, .external_lex_state = 17},
  [5589] = {.lex_state = 8, .external_lex_state = 123},
  [5590] = {.lex_state = 11, .external_lex_state = 122},
  [5591] = {.lex_state = 4, .external_lex_state = 17},
  [5592] = {.lex_state = 11, .external_lex_state = 124},
  [5593] = {.lex_state = 4, .external_lex_state = 17},
  [5594] = {.lex_state = 11, .external_lex_state = 124},
  [5595] = {.lex_state = 4, .external_lex_state = 17},
  [5596] = {.lex_state = 4, .external_lex_state = 17},
  [5597] = {.lex_state = 4, .external_lex_state = 17},
  [5598] = {.lex_state = 8, .external_lex_state = 123},
  [5599] = {.lex_state = 4, .external_lex_state = 17},
  [5600] = {.lex_state = 4, .external_lex_state = 17},
  [5601] = {.lex_state = 4, .external_lex_state = 17},
  [5602] = {.lex_state = 11, .external_lex_state = 124},
  [5603] = {.lex_state = 4, .external_lex_state = 17},
  [5604] = {.lex_state = 4, .external_lex_state = 17},
  [5605] = {.lex_state = 4, .external_lex_state = 17},
  [5606] = {.lex_state = 4, .external_lex_state = 17},
  [5607] = {.lex_state = 4, .external_lex_state = 17},
  [5608] = {.lex_state = 4, .external_lex_state = 17},
  [5609] = {.lex_state = 4, .external_lex_state = 17},
  [5610] = {.lex_state = 4, .external_lex_state = 17},
  [5611] = {.lex_state = 4, .external_lex_state = 17},
  [5612] = {.lex_state = 4, .external_lex_state = 17},
  [5613] = {.lex_state = 4, .external_lex_state = 17},
  [5614] = {.lex_state = 4, .external_lex_state = 17},
  [5615] = {.lex_state = 4, .external_lex_state = 17},
  [5616] = {.lex_state = 4, .external_lex_state = 17},
  [5617] = {.lex_state = 4, .external_lex_state = 17},
  [5618] = {.lex_state = 8, .external_lex_state = 123},
  [5619] = {.lex_state = 4, .external_lex_state = 17},
  [5620] = {.lex_state = 4, .external_lex_state = 17},
  [5621] = {.lex_state = 4, .external_lex_state = 17},
  [5622] = {.lex_state = 11, .external_lex_state = 122},
  [5623] = {.lex_state = 4, .external_lex_state = 17},
  [5624] = {.lex_state = 4, .external_lex_state = 17},
  [5625] = {.lex_state = 4, .external_lex_state = 17},
  [5626] = {.lex_state = 8, .external_lex_state = 123},
  [5627] = {.lex_state = 11, .external_lex_state = 122},
  [5628] = {.lex_state = 4, .external_lex_state = 17},
  [5629] = {.lex_state = 4, .external_lex_state = 17},
  [5630] = {.lex_state = 4, .external_lex_state = 17},
  [5631] = {.lex_state = 4, .external_lex_state = 17},
  [5632] = {.lex_state = 11, .external_lex_state = 122},
  [5633] = {.lex_state = 8, .external_lex_state = 123},
  [5634] = {.lex_state = 11, .external_lex_state = 124},
  [5635] = {.lex_state = 8, .external_lex_state = 123},
  [5636] = {.lex_state = 4, .external_lex_state = 17},
  [5637] = {.lex_state = 4, .external_lex_state = 17},
  [5638] = {.lex_state = 11, .external_lex_state = 124},
  [5639] = {.lex_state = 4, .external_lex_state = 17},
  [5640] = {.lex_state = 4, .external_lex_state = 17},
  [5641] = {.lex_state = 4, .external_lex_state = 17},
  [5642] = {.lex_state = 4, .external_lex_state = 17},
  [5643] = {.lex_state = 4, .external_lex_state = 17},
  [5644] = {.lex_state = 4, .external_lex_state = 17},
  [5645] = {.lex_state = 11, .external_lex_state = 122},
  [5646] = {.lex_state = 4, .external_lex_state = 17},
  [5647] = {.lex_state = 4, .external_lex_state = 17},
  [5648] = {.lex_state = 4, .external_lex_state = 17},
  [5649] = {.lex_state = 4, .external_lex_state = 17},
  [5650] = {.lex_state = 4, .external_lex_state = 17},
  [5651] = {.lex_state = 4, .external_lex_state = 17},
  [5652] = {.lex_state = 4, .external_lex_state = 17},
  [5653] = {.lex_state = 11, .external_lex_state = 124},
  [5654] = {.lex_state = 4, .external_lex_state = 17},
  [5655] = {.lex_state = 4, .external_lex_state = 17},
  [5656] = {.lex_state = 4, .external_lex_state = 17},
  [5657] = {.lex_state = 4, .external_lex_state = 17},
  [5658] = {.lex_state = 4, .external_lex_state = 17},
  [5659] = {.lex_state = 4, .external_lex_state = 17},
  [5660] = {.lex_state = 4, .external_lex_state = 17},
  [5661] = {.lex_state = 4, .external_lex_state = 17},
  [5662] = {.lex_state = 4, .external_lex_state = 17},
  [5663] = {.lex_state = 4, .external_lex_state = 17},
  [5664] = {.lex_state = 4, .external_lex_state = 17},
  [5665] = {.lex_state = 11, .external_lex_state = 122},
  [5666] = {.lex_state = 11, .external_lex_state = 122},
  [5667] = {.lex_state = 4, .external_lex_state = 17},
  [5668] = {.lex_state = 4, .external_lex_state = 17},
  [5669] = {.lex_state = 4, .external_lex_state = 17},
  [5670] = {.lex_state = 4, .external_lex_state = 17},
  [5671] = {.lex_state = 4, .external_lex_state = 17},
  [5672] = {.lex_state = 4, .external_lex_state = 17},
  [5673] = {.lex_state = 4, .external_lex_state = 17},
  [5674] = {.lex_state = 4, .external_lex_state = 17},
  [5675] = {.lex_state = 8, .external_lex_state = 42},
  [5676] = {.lex_state = 16, .external_lex_state = 111},
  [5677] = {.lex_state = 8, .external_lex_state = 42},
  [5678] = {.lex_state = 11, .external_lex_state = 125},
  [5679] = {.lex_state = 3, .external_lex_state = 9},
  [5680] = {.lex_state = 8, .external_lex_state = 42},
  [5681] = {.lex_state = 8, .external_lex_state = 42},
  [5682] = {.lex_state = 16, .external_lex_state = 111},
  [5683] = {.lex_state = 16, .external_lex_state = 111},
  [5684] = {.lex_state = 11, .external_lex_state = 125},
  [5685] = {.lex_state = 11, .external_lex_state = 125},
  [5686] = {.lex_state = 11, .external_lex_state = 125},
  [5687] = {.lex_state = 11, .external_lex_state = 125},
  [5688] = {.lex_state = 16, .external_lex_state = 111},
  [5689] = {.lex_state = 11, .external_lex_state = 125},
  [5690] = {.lex_state = 16, .external_lex_state = 111},
  [5691] = {.lex_state = 16, .external_lex_state = 111},
  [5692] = {.lex_state = 11, .external_lex_state = 125},
  [5693] = {.lex_state = 16, .external_lex_state = 111},
  [5694] = {.lex_state = 16, .external_lex_state = 111},
  [5695] = {.lex_state = 16, .external_lex_state = 111},
  [5696] = {.lex_state = 11, .external_lex_state = 125},
  [5697] = {.lex_state = 11, .external_lex_state = 125},
  [5698] = {.lex_state = 18, .external_lex_state = 49},
  [5699] = {.lex_state = 16, .external_lex_state = 91},
  [5700] = {.lex_state = 18, .external_lex_state = 49},
  [5701] = {.lex_state = 16, .external_lex_state = 91},
  [5702] = {.lex_state = 11, .external_lex_state = 126},
  [5703] = {.lex_state = 8, .external_lex_state = 127},
  [5704] = {.lex_state = 8, .external_lex_state = 127},
  [5705] = {.lex_state = 18, .external_lex_state = 49},
  [5706] = {.lex_state = 8, .external_lex_state = 79},
  [5707] = {.lex_state = 16, .external_lex_state = 91},
  [5708] = {.lex_state = 18, .external_lex_state = 49},
  [5709] = {.lex_state = 18, .external_lex_state = 49},
  [5710] = {.lex_state = 18, .external_lex_state = 49},
  [5711] = {.lex_state = 18, .external_lex_state = 49},
  [5712] = {.lex_state = 18, .external_lex_state = 49},
  [5713] = {.lex_state = 8, .external_lex_state = 127},
  [5714] = {.lex_state = 18, .external_lex_state = 49},
  [5715] = {.lex_state = 18, .external_lex_state = 49},
  [5716] = {.lex_state = 8, .external_lex_state = 127},
  [5717] = {.lex_state = 18, .external_lex_state = 49},
  [5718] = {.lex_state = 18, .external_lex_state = 49},
  [5719] = {.lex_state = 18, .external_lex_state = 49},
  [5720] = {.lex_state = 18, .external_lex_state = 49},
  [5721] = {.lex_state = 18, .external_lex_state = 49},
  [5722] = {.lex_state = 18, .external_lex_state = 49},
  [5723] = {.lex_state = 8, .external_lex_state = 127},
  [5724] = {.lex_state = 8, .external_lex_state = 128},
  [5725] = {.lex_state = 18, .external_lex_state = 49},
  [5726] = {.lex_state = 18, .external_lex_state = 49},
  [5727] = {.lex_state = 18, .external_lex_state = 49},
  [5728] = {.lex_state = 18, .external_lex_state = 49},
  [5729] = {.lex_state = 8, .external_lex_state = 79},
  [5730] = {.lex_state = 18, .external_lex_state = 49},
  [5731] = {.lex_state = 8, .external_lex_state = 129},
  [5732] = {.lex_state = 16, .external_lex_state = 91},
  [5733] = {.lex_state = 8, .external_lex_state = 127},
  [5734] = {.lex_state = 18, .external_lex_state = 49},
  [5735] = {.lex_state = 16, .external_lex_state = 91},
  [5736] = {.lex_state = 16, .external_lex_state = 91},
  [5737] = {.lex_state = 18, .external_lex_state = 49},
  [5738] = {.lex_state = 8, .external_lex_state = 79},
  [5739] = {.lex_state = 11, .external_lex_state = 126},
  [5740] = {.lex_state = 11, .external_lex_state = 126},
  [5741] = {.lex_state = 18, .external_lex_state = 49},
  [5742] = {.lex_state = 18, .external_lex_state = 49},
  [5743] = {.lex_state = 18, .external_lex_state = 49},
  [5744] = {.lex_state = 18, .external_lex_state = 49},
  [5745] = {.lex_state = 16, .external_lex_state = 91},
  [5746] = {.lex_state = 18, .external_lex_state = 49},
  [5747] = {.lex_state = 8, .external_lex_state = 127},
  [5748] = {.lex_state = 8, .external_lex_state = 79},
  [5749] = {.lex_state = 8, .external_lex_state = 79},
  [5750] = {.lex_state = 18, .external_lex_state = 49},
  [5751] = {.lex_state = 18, .external_lex_state = 49},
  [5752] = {.lex_state = 8, .external_lex_state = 128},
  [5753] = {.lex_state = 18, .external_lex_state = 49},
  [5754] = {.lex_state = 11, .external_lex_state = 126},
  [5755] = {.lex_state = 18, .external_lex_state = 49},
  [5756] = {.lex_state = 8, .external_lex_state = 128},
  [5757] = {.lex_state = 8, .external_lex_state = 128},
  [5758] = {.lex_state = 8, .external_lex_state = 129},
  [5759] = {.lex_state = 16, .external_lex_state = 91},
  [5760] = {.lex_state = 8, .external_lex_state = 127},
  [5761] = {.lex_state = 8, .external_lex_state = 79},
  [5762] = {.lex_state = 8, .external_lex_state = 128},
  [5763] = {.lex_state = 11, .external_lex_state = 126},
  [5764] = {.lex_state = 8, .external_lex_state = 129},
  [5765] = {.lex_state = 18, .external_lex_state = 49},
  [5766] = {.lex_state = 18, .external_lex_state = 49},
  [5767] = {.lex_state = 18, .external_lex_state = 49},
  [5768] = {.lex_state = 18, .external_lex_state = 49},
  [5769] = {.lex_state = 18, .external_lex_state = 49},
  [5770] = {.lex_state = 18, .external_lex_state = 49},
  [5771] = {.lex_state = 11, .external_lex_state = 126},
  [5772] = {.lex_state = 18, .external_lex_state = 49},
  [5773] = {.lex_state = 11, .external_lex_state = 126},
  [5774] = {.lex_state = 18, .external_lex_state = 49},
  [5775] = {.lex_state = 8, .external_lex_state = 128},
  [5776] = {.lex_state = 3, .external_lex_state = 6},
  [5777] = {.lex_state = 18, .external_lex_state = 49},
  [5778] = {.lex_state = 8, .external_lex_state = 79},
  [5779] = {.lex_state = 8, .external_lex_state = 129},
  [5780] = {.lex_state = 18, .external_lex_state = 49},
  [5781] = {.lex_state = 18, .external_lex_state = 49},
  [5782] = {.lex_state = 16, .external_lex_state = 91},
  [5783] = {.lex_state = 8, .external_lex_state = 128},
  [5784] = {.lex_state = 18, .external_lex_state = 49},
  [5785] = {.lex_state = 18, .external_lex_state = 49},
  [5786] = {.lex_state = 18, .external_lex_state = 49},
  [5787] = {.lex_state = 8, .external_lex_state = 129},
  [5788] = {.lex_state = 18, .external_lex_state = 49},
  [5789] = {.lex_state = 18, .external_lex_state = 49},
  [5790] = {.lex_state = 18, .external_lex_state = 49},
  [5791] = {.lex_state = 18, .external_lex_state = 49},
  [5792] = {.lex_state = 18, .external_lex_state = 49},
  [5793] = {.lex_state = 18, .external_lex_state = 49},
  [5794] = {.lex_state = 8, .external_lex_state = 129},
  [5795] = {.lex_state = 18, .external_lex_state = 49},
  [5796] = {.lex_state = 8, .external_lex_state = 129},
  [5797] = {.lex_state = 8, .external_lex_state = 128},
  [5798] = {.lex_state = 18, .external_lex_state = 49},
  [5799] = {.lex_state = 18, .external_lex_state = 49},
  [5800] = {.lex_state = 18, .external_lex_state = 49},
  [5801] = {.lex_state = 8, .external_lex_state = 129},
  [5802] = {.lex_state = 18, .external_lex_state = 49},
  [5803] = {.lex_state = 11, .external_lex_state = 126},
  [5804] = {.lex_state = 8, .external_lex_state = 128},
  [5805] = {.lex_state = 11, .external_lex_state = 126},
  [5806] = {.lex_state = 8, .external_lex_state = 127},
  [5807] = {.lex_state = 8, .external_lex_state = 79},
  [5808] = {.lex_state = 18, .external_lex_state = 49},
  [5809] = {.lex_state = 18, .external_lex_state = 49},
  [5810] = {.lex_state = 8, .external_lex_state = 79},
  [5811] = {.lex_state = 8, .external_lex_state = 129},
  [5812] = {.lex_state = 8, .external_lex_state = 29},
  [5813] = {.lex_state = 8, .external_lex_state = 29},
  [5814] = {.lex_state = 8, .external_lex_state = 29},
  [5815] = {.lex_state = 8, .external_lex_state = 29},
  [5816] = {.lex_state = 8, .external_lex_state = 29},
  [5817] = {.lex_state = 8, .external_lex_state = 130},
  [5818] = {.lex_state = 8, .external_lex_state = 29},
  [5819] = {.lex_state = 8, .external_lex_state = 29},
  [5820] = {.lex_state = 8, .external_lex_state = 29},
  [5821] = {.lex_state = 8, .external_lex_state = 29},
  [5822] = {.lex_state = 8, .external_lex_state = 29},
  [5823] = {.lex_state = 8, .external_lex_state = 29},
  [5824] = {.lex_state = 11, .external_lex_state = 125},
  [5825] = {.lex_state = 8, .external_lex_state = 29},
  [5826] = {.lex_state = 8, .external_lex_state = 29},
  [5827] = {.lex_state = 8, .external_lex_state = 29},
  [5828] = {.lex_state = 8, .external_lex_state = 130},
  [5829] = {.lex_state = 8, .external_lex_state = 29},
  [5830] = {.lex_state = 8, .external_lex_state = 29},
  [5831] = {.lex_state = 8, .external_lex_state = 29},
  [5832] = {.lex_state = 8, .external_lex_state = 29},
  [5833] = {.lex_state = 8, .external_lex_state = 29},
  [5834] = {.lex_state = 8, .external_lex_state = 29},
  [5835] = {.lex_state = 3, .external_lex_state = 131},
  [5836] = {.lex_state = 8, .external_lex_state = 29},
  [5837] = {.lex_state = 8, .external_lex_state = 29},
  [5838] = {.lex_state = 8, .external_lex_state = 29},
  [5839] = {.lex_state = 8, .external_lex_state = 29},
  [5840] = {.lex_state = 8, .external_lex_state = 29},
  [5841] = {.lex_state = 8, .external_lex_state = 29},
  [5842] = {.lex_state = 8, .external_lex_state = 29},
  [5843] = {.lex_state = 8, .external_lex_state = 29},
  [5844] = {.lex_state = 8, .external_lex_state = 29},
  [5845] = {.lex_state = 8, .external_lex_state = 29},
  [5846] = {.lex_state = 8, .external_lex_state = 130},
  [5847] = {.lex_state = 8, .external_lex_state = 29},
  [5848] = {.lex_state = 8, .external_lex_state = 29},
  [5849] = {.lex_state = 3, .external_lex_state = 11},
  [5850] = {.lex_state = 8, .external_lex_state = 29},
  [5851] = {.lex_state = 8, .external_lex_state = 29},
  [5852] = {.lex_state = 8, .external_lex_state = 29},
  [5853] = {.lex_state = 8, .external_lex_state = 29},
  [5854] = {.lex_state = 8, .external_lex_state = 29},
  [5855] = {.lex_state = 8, .external_lex_state = 130},
  [5856] = {.lex_state = 8, .external_lex_state = 29},
  [5857] = {.lex_state = 8, .external_lex_state = 130},
  [5858] = {.lex_state = 8, .external_lex_state = 29},
  [5859] = {.lex_state = 8, .external_lex_state = 29},
  [5860] = {.lex_state = 8, .external_lex_state = 29},
  [5861] = {.lex_state = 8, .external_lex_state = 29},
  [5862] = {.lex_state = 8, .external_lex_state = 29},
  [5863] = {.lex_state = 8, .external_lex_state = 130},
  [5864] = {.lex_state = 8, .external_lex_state = 29},
  [5865] = {.lex_state = 8, .external_lex_state = 29},
  [5866] = {.lex_state = 8, .external_lex_state = 29},
  [5867] = {.lex_state = 8, .external_lex_state = 130},
  [5868] = {.lex_state = 8, .external_lex_state = 130},
  [5869] = {.lex_state = 8, .external_lex_state = 29},
  [5870] = {.lex_state = 8, .external_lex_state = 29},
  [5871] = {.lex_state = 8, .external_lex_state = 29},
  [5872] = {.lex_state = 8, .external_lex_state = 29},
  [5873] = {.lex_state = 8, .external_lex_state = 130},
  [5874] = {.lex_state = 8, .external_lex_state = 29},
  [5875] = {.lex_state = 8, .external_lex_state = 29},
  [5876] = {.lex_state = 11, .external_lex_state = 33},
  [5877] = {.lex_state = 11, .external_lex_state = 31},
  [5878] = {.lex_state = 11, .external_lex_state = 91},
  [5879] = {.lex_state = 11, .external_lex_state = 132},
  [5880] = {.lex_state = 11, .external_lex_state = 31},
  [5881] = {.lex_state = 11, .external_lex_state = 91},
  [5882] = {.lex_state = 11, .external_lex_state = 132},
  [5883] = {.lex_state = 11, .external_lex_state = 91},
  [5884] = {.lex_state = 8, .external_lex_state = 30},
  [5885] = {.lex_state = 11, .external_lex_state = 32},
  [5886] = {.lex_state = 8, .external_lex_state = 30},
  [5887] = {.lex_state = 8, .external_lex_state = 30},
  [5888] = {.lex_state = 11, .external_lex_state = 32},
  [5889] = {.lex_state = 8, .external_lex_state = 30},
  [5890] = {.lex_state = 8, .external_lex_state = 30},
  [5891] = {.lex_state = 11, .external_lex_state = 32},
  [5892] = {.lex_state = 8, .external_lex_state = 30},
  [5893] = {.lex_state = 11, .external_lex_state = 132},
  [5894] = {.lex_state = 8, .external_lex_state = 30},
  [5895] = {.lex_state = 11, .external_lex_state = 32},
  [5896] = {.lex_state = 8, .external_lex_state = 30},
  [5897] = {.lex_state = 11, .external_lex_state = 132},
  [5898] = {.lex_state = 11, .external_lex_state = 91},
  [5899] = {.lex_state = 8, .external_lex_state = 30},
  [5900] = {.lex_state = 8, .external_lex_state = 30},
  [5901] = {.lex_state = 11, .external_lex_state = 31},
  [5902] = {.lex_state = 11, .external_lex_state = 32},
  [5903] = {.lex_state = 8, .external_lex_state = 30},
  [5904] = {.lex_state = 11, .external_lex_state = 32},
  [5905] = {.lex_state = 8, .external_lex_state = 30},
  [5906] = {.lex_state = 11, .external_lex_state = 31},
  [5907] = {.lex_state = 11, .external_lex_state = 31},
  [5908] = {.lex_state = 11, .external_lex_state = 31},
  [5909] = {.lex_state = 11, .external_lex_state = 91},
  [5910] = {.lex_state = 11, .external_lex_state = 31},
  [5911] = {.lex_state = 11, .external_lex_state = 31},
  [5912] = {.lex_state = 8, .external_lex_state = 30},
  [5913] = {.lex_state = 11, .external_lex_state = 32},
  [5914] = {.lex_state = 11, .external_lex_state = 31},
  [5915] = {.lex_state = 11, .external_lex_state = 91},
  [5916] = {.lex_state = 11, .external_lex_state = 32},
  [5917] = {.lex_state = 8, .external_lex_state = 30},
  [5918] = {.lex_state = 11, .external_lex_state = 32},
  [5919] = {.lex_state = 11, .external_lex_state = 32},
  [5920] = {.lex_state = 8, .external_lex_state = 30},
  [5921] = {.lex_state = 11, .external_lex_state = 31},
  [5922] = {.lex_state = 8, .external_lex_state = 30},
  [5923] = {.lex_state = 8, .external_lex_state = 30},
  [5924] = {.lex_state = 8, .external_lex_state = 30},
  [5925] = {.lex_state = 11, .external_lex_state = 31},
  [5926] = {.lex_state = 11, .external_lex_state = 31},
  [5927] = {.lex_state = 8, .external_lex_state = 30},
  [5928] = {.lex_state = 8, .external_lex_state = 30},
  [5929] = {.lex_state = 8, .external_lex_state = 30},
  [5930] = {.lex_state = 11, .external_lex_state = 32},
  [5931] = {.lex_state = 11, .external_lex_state = 31},
  [5932] = {.lex_state = 11, .external_lex_state = 32},
  [5933] = {.lex_state = 8, .external_lex_state = 30},
  [5934] = {.lex_state = 8, .external_lex_state = 79},
  [5935] = {.lex_state = 11, .external_lex_state = 32},
  [5936] = {.lex_state = 8, .external_lex_state = 30},
  [5937] = {.lex_state = 11, .external_lex_state = 32},
  [5938] = {.lex_state = 8, .external_lex_state = 30},
  [5939] = {.lex_state = 11, .external_lex_state = 31},
  [5940] = {.lex_state = 8, .external_lex_state = 30},
  [5941] = {.lex_state = 11, .external_lex_state = 32},
  [5942] = {.lex_state = 11, .external_lex_state = 32},
  [5943] = {.lex_state = 8, .external_lex_state = 30},
  [5944] = {.lex_state = 11, .external_lex_state = 32},
  [5945] = {.lex_state = 11, .external_lex_state = 32},
  [5946] = {.lex_state = 11, .external_lex_state = 32},
  [5947] = {.lex_state = 11, .external_lex_state = 32},
  [5948] = {.lex_state = 11, .external_lex_state = 32},
  [5949] = {.lex_state = 11, .external_lex_state = 32},
  [5950] = {.lex_state = 11, .external_lex_state = 32},
  [5951] = {.lex_state = 11, .external_lex_state = 32},
  [5952] = {.lex_state = 11, .external_lex_state = 32},
  [5953] = {.lex_state = 11, .external_lex_state = 31},
  [5954] = {.lex_state = 11, .external_lex_state = 32},
  [5955] = {.lex_state = 11, .external_lex_state = 32},
  [5956] = {.lex_state = 8, .external_lex_state = 30},
  [5957] = {.lex_state = 8, .external_lex_state = 30},
  [5958] = {.lex_state = 8, .external_lex_state = 30},
  [5959] = {.lex_state = 8, .external_lex_state = 30},
  [5960] = {.lex_state = 11, .external_lex_state = 91},
  [5961] = {.lex_state = 8, .external_lex_state = 133},
  [5962] = {.lex_state = 8, .external_lex_state = 30},
  [5963] = {.lex_state = 11, .external_lex_state = 32},
  [5964] = {.lex_state = 11, .external_lex_state = 32},
  [5965] = {.lex_state = 11, .external_lex_state = 32},
  [5966] = {.lex_state = 8, .external_lex_state = 30},
  [5967] = {.lex_state = 8, .external_lex_state = 30},
  [5968] = {.lex_state = 11, .external_lex_state = 31},
  [5969] = {.lex_state = 11, .external_lex_state = 32},
  [5970] = {.lex_state = 8, .external_lex_state = 30},
  [5971] = {.lex_state = 11, .external_lex_state = 32},
  [5972] = {.lex_state = 11, .external_lex_state = 32},
  [5973] = {.lex_state = 8, .external_lex_state = 30},
  [5974] = {.lex_state = 11, .external_lex_state = 32},
  [5975] = {.lex_state = 11, .external_lex_state = 31},
  [5976] = {.lex_state = 11, .external_lex_state = 32},
  [5977] = {.lex_state = 8, .external_lex_state = 30},
  [5978] = {.lex_state = 11, .external_lex_state = 31},
  [5979] = {.lex_state = 11, .external_lex_state = 32},
  [5980] = {.lex_state = 11, .external_lex_state = 132},
  [5981] = {.lex_state = 11, .external_lex_state = 31},
  [5982] = {.lex_state = 11, .external_lex_state = 31},
  [5983] = {.lex_state = 8, .external_lex_state = 30},
  [5984] = {.lex_state = 11, .external_lex_state = 31},
  [5985] = {.lex_state = 11, .external_lex_state = 32},
  [5986] = {.lex_state = 11, .external_lex_state = 91},
  [5987] = {.lex_state = 11, .external_lex_state = 32},
  [5988] = {.lex_state = 11, .external_lex_state = 31},
  [5989] = {.lex_state = 11, .external_lex_state = 32},
  [5990] = {.lex_state = 11, .external_lex_state = 32},
  [5991] = {.lex_state = 11, .external_lex_state = 31},
  [5992] = {.lex_state = 11, .external_lex_state = 31},
  [5993] = {.lex_state = 11, .external_lex_state = 31},
  [5994] = {.lex_state = 11, .external_lex_state = 32},
  [5995] = {.lex_state = 11, .external_lex_state = 132},
  [5996] = {.lex_state = 11, .external_lex_state = 32},
  [5997] = {.lex_state = 8, .external_lex_state = 30},
  [5998] = {.lex_state = 11, .external_lex_state = 31},
  [5999] = {.lex_state = 11, .external_lex_state = 31},
  [6000] = {.lex_state = 11, .external_lex_state = 31},
  [6001] = {.lex_state = 8, .external_lex_state = 30},
  [6002] = {.lex_state = 11, .external_lex_state = 31},
  [6003] = {.lex_state = 11, .external_lex_state = 33},
  [6004] = {.lex_state = 11, .external_lex_state = 31},
  [6005] = {.lex_state = 8, .external_lex_state = 30},
  [6006] = {.lex_state = 11, .external_lex_state = 31},
  [6007] = {.lex_state = 11, .external_lex_state = 31},
  [6008] = {.lex_state = 11, .external_lex_state = 31},
  [6009] = {.lex_state = 11, .external_lex_state = 31},
  [6010] = {.lex_state = 11, .external_lex_state = 31},
  [6011] = {.lex_state = 11, .external_lex_state = 132},
  [6012] = {.lex_state = 11, .external_lex_state = 31},
  [6013] = {.lex_state = 8, .external_lex_state = 30},
  [6014] = {.lex_state = 11, .external_lex_state = 31},
  [6015] = {.lex_state = 11, .external_lex_state = 132},
  [6016] = {.lex_state = 11, .external_lex_state = 32},
  [6017] = {.lex_state = 11, .external_lex_state = 31},
  [6018] = {.lex_state = 11, .external_lex_state = 31},
  [6019] = {.lex_state = 8, .external_lex_state = 30},
  [6020] = {.lex_state = 8, .external_lex_state = 30},
  [6021] = {.lex_state = 11, .external_lex_state = 31},
  [6022] = {.lex_state = 8, .external_lex_state = 30},
  [6023] = {.lex_state = 11, .external_lex_state = 31},
  [6024] = {.lex_state = 11, .external_lex_state = 31},
  [6025] = {.lex_state = 11, .external_lex_state = 31},
  [6026] = {.lex_state = 11, .external_lex_state = 132},
  [6027] = {.lex_state = 11, .external_lex_state = 31},
  [6028] = {.lex_state = 11, .external_lex_state = 32},
  [6029] = {.lex_state = 8, .external_lex_state = 133},
  [6030] = {.lex_state = 11, .external_lex_state = 31},
  [6031] = {.lex_state = 8, .external_lex_state = 133},
  [6032] = {.lex_state = 11, .external_lex_state = 32},
  [6033] = {.lex_state = 8, .external_lex_state = 30},
  [6034] = {.lex_state = 8, .external_lex_state = 133},
  [6035] = {.lex_state = 11, .external_lex_state = 32},
  [6036] = {.lex_state = 11, .external_lex_state = 31},
  [6037] = {.lex_state = 8, .external_lex_state = 30},
  [6038] = {.lex_state = 11, .external_lex_state = 32},
  [6039] = {.lex_state = 11, .external_lex_state = 31},
  [6040] = {.lex_state = 8, .external_lex_state = 30},
  [6041] = {.lex_state = 8, .external_lex_state = 30},
  [6042] = {.lex_state = 11, .external_lex_state = 31},
  [6043] = {.lex_state = 11, .external_lex_state = 32},
  [6044] = {.lex_state = 11, .external_lex_state = 31},
  [6045] = {.lex_state = 11, .external_lex_state = 31},
  [6046] = {.lex_state = 11, .external_lex_state = 32},
  [6047] = {.lex_state = 8, .external_lex_state = 30},
  [6048] = {.lex_state = 11, .external_lex_state = 31},
  [6049] = {.lex_state = 8, .external_lex_state = 30},
  [6050] = {.lex_state = 11, .external_lex_state = 32},
  [6051] = {.lex_state = 8, .external_lex_state = 30},
  [6052] = {.lex_state = 11, .external_lex_state = 32},
  [6053] = {.lex_state = 8, .external_lex_state = 30},
  [6054] = {.lex_state = 11, .external_lex_state = 31},
  [6055] = {.lex_state = 11, .external_lex_state = 32},
  [6056] = {.lex_state = 11, .external_lex_state = 91},
  [6057] = {.lex_state = 8, .external_lex_state = 133},
  [6058] = {.lex_state = 11, .external_lex_state = 33},
  [6059] = {.lex_state = 11, .external_lex_state = 33},
  [6060] = {.lex_state = 16, .external_lex_state = 28},
  [6061] = {.lex_state = 11, .external_lex_state = 134},
  [6062] = {.lex_state = 16, .external_lex_state = 28},
  [6063] = {.lex_state = 16, .external_lex_state = 28},
  [6064] = {.lex_state = 11, .external_lex_state = 33},
  [6065] = {.lex_state = 16, .external_lex_state = 28},
  [6066] = {.lex_state = 16, .external_lex_state = 28},
  [6067] = {.lex_state = 11, .external_lex_state = 33},
  [6068] = {.lex_state = 16, .external_lex_state = 28},
  [6069] = {.lex_state = 11, .external_lex_state = 33},
  [6070] = {.lex_state = 11, .external_lex_state = 33},
  [6071] = {.lex_state = 16, .external_lex_state = 28},
  [6072] = {.lex_state = 11, .external_lex_state = 33},
  [6073] = {.lex_state = 11, .external_lex_state = 33},
  [6074] = {.lex_state = 16, .external_lex_state = 28},
  [6075] = {.lex_state = 11, .external_lex_state = 135},
  [6076] = {.lex_state = 11, .external_lex_state = 134},
  [6077] = {.lex_state = 11, .external_lex_state = 33},
  [6078] = {.lex_state = 11, .external_lex_state = 33},
  [6079] = {.lex_state = 11, .external_lex_state = 33},
  [6080] = {.lex_state = 11, .external_lex_state = 33},
  [6081] = {.lex_state = 11, .external_lex_state = 33},
  [6082] = {.lex_state = 11, .external_lex_state = 134},
  [6083] = {.lex_state = 16, .external_lex_state = 28},
  [6084] = {.lex_state = 11, .external_lex_state = 33},
  [6085] = {.lex_state = 11, .external_lex_state = 33},
  [6086] = {.lex_state = 11, .external_lex_state = 33},
  [6087] = {.lex_state = 11, .external_lex_state = 33},
  [6088] = {.lex_state = 16, .external_lex_state = 28},
  [6089] = {.lex_state = 11, .external_lex_state = 33},
  [6090] = {.lex_state = 11, .external_lex_state = 33},
  [6091] = {.lex_state = 11, .external_lex_state = 33},
  [6092] = {.lex_state = 11, .external_lex_state = 33},
  [6093] = {.lex_state = 11, .external_lex_state = 134},
  [6094] = {.lex_state = 11, .external_lex_state = 135},
  [6095] = {.lex_state = 16, .external_lex_state = 28},
  [6096] = {.lex_state = 11, .external_lex_state = 33},
  [6097] = {.lex_state = 11, .external_lex_state = 134},
  [6098] = {.lex_state = 11, .external_lex_state = 135},
  [6099] = {.lex_state = 16, .external_lex_state = 28},
  [6100] = {.lex_state = 11, .external_lex_state = 33},
  [6101] = {.lex_state = 16, .external_lex_state = 28},
  [6102] = {.lex_state = 11, .external_lex_state = 33},
  [6103] = {.lex_state = 16, .external_lex_state = 28},
  [6104] = {.lex_state = 11, .external_lex_state = 134},
  [6105] = {.lex_state = 16, .external_lex_state = 28},
  [6106] = {.lex_state = 11, .external_lex_state = 33},
  [6107] = {.lex_state = 11, .external_lex_state = 33},
  [6108] = {.lex_state = 16, .external_lex_state = 28},
  [6109] = {.lex_state = 16, .external_lex_state = 28},
  [6110] = {.lex_state = 11, .external_lex_state = 33},
  [6111] = {.lex_state = 11, .external_lex_state = 136},
  [6112] = {.lex_state = 11, .external_lex_state = 33},
  [6113] = {.lex_state = 11, .external_lex_state = 136},
  [6114] = {.lex_state = 11, .external_lex_state = 136},
  [6115] = {.lex_state = 16, .external_lex_state = 28},
  [6116] = {.lex_state = 11, .external_lex_state = 33},
  [6117] = {.lex_state = 16, .external_lex_state = 28},
  [6118] = {.lex_state = 11, .external_lex_state = 33},
  [6119] = {.lex_state = 11, .external_lex_state = 33},
  [6120] = {.lex_state = 11, .external_lex_state = 33},
  [6121] = {.lex_state = 16, .external_lex_state = 28},
  [6122] = {.lex_state = 11, .external_lex_state = 33},
  [6123] = {.lex_state = 11, .external_lex_state = 33},
  [6124] = {.lex_state = 16, .external_lex_state = 28},
  [6125] = {.lex_state = 11, .external_lex_state = 33},
  [6126] = {.lex_state = 11, .external_lex_state = 33},
  [6127] = {.lex_state = 16, .external_lex_state = 28},
  [6128] = {.lex_state = 16, .external_lex_state = 28},
  [6129] = {.lex_state = 11, .external_lex_state = 33},
  [6130] = {.lex_state = 11, .external_lex_state = 33},
  [6131] = {.lex_state = 16, .external_lex_state = 28},
  [6132] = {.lex_state = 16, .external_lex_state = 28},
  [6133] = {.lex_state = 11, .external_lex_state = 33},
  [6134] = {.lex_state = 16, .external_lex_state = 28},
  [6135] = {.lex_state = 16, .external_lex_state = 28},
  [6136] = {.lex_state = 16, .external_lex_state = 28},
  [6137] = {.lex_state = 16, .external_lex_state = 28},
  [6138] = {.lex_state = 16, .external_lex_state = 28},
  [6139] = {.lex_state = 16, .external_lex_state = 28},
  [6140] = {.lex_state = 16, .external_lex_state = 28},
  [6141] = {.lex_state = 16, .external_lex_state = 28},
  [6142] = {.lex_state = 16, .external_lex_state = 28},
  [6143] = {.lex_state = 11, .external_lex_state = 33},
  [6144] = {.lex_state = 16, .external_lex_state = 28},
  [6145] = {.lex_state = 11, .external_lex_state = 33},
  [6146] = {.lex_state = 16, .external_lex_state = 28},
  [6147] = {.lex_state = 11, .external_lex_state = 33},
  [6148] = {.lex_state = 11, .external_lex_state = 135},
  [6149] = {.lex_state = 11, .external_lex_state = 136},
  [6150] = {.lex_state = 11, .external_lex_state = 136},
  [6151] = {.lex_state = 16, .external_lex_state = 28},
  [6152] = {.lex_state = 16, .external_lex_state = 28},
  [6153] = {.lex_state = 16, .external_lex_state = 28},
  [6154] = {.lex_state = 16, .external_lex_state = 28},
  [6155] = {.lex_state = 11, .external_lex_state = 135},
  [6156] = {.lex_state = 16, .external_lex_state = 28},
  [6157] = {.lex_state = 11, .external_lex_state = 33},
  [6158] = {.lex_state = 16, .external_lex_state = 28},
  [6159] = {.lex_state = 16, .external_lex_state = 28},
  [6160] = {.lex_state = 11, .external_lex_state = 33},
  [6161] = {.lex_state = 11, .external_lex_state = 33},
  [6162] = {.lex_state = 4, .external_lex_state = 137},
  [6163] = {.lex_state = 11, .external_lex_state = 135},
  [6164] = {.lex_state = 16, .external_lex_state = 28},
  [6165] = {.lex_state = 11, .external_lex_state = 136},
  [6166] = {.lex_state = 16, .external_lex_state = 28},
  [6167] = {.lex_state = 16, .external_lex_state = 28},
  [6168] = {.lex_state = 16, .external_lex_state = 28},
  [6169] = {.lex_state = 16, .external_lex_state = 28},
  [6170] = {.lex_state = 16, .external_lex_state = 28},
  [6171] = {.lex_state = 11, .external_lex_state = 33},
  [6172] = {.lex_state = 11, .external_lex_state = 135},
  [6173] = {.lex_state = 11, .external_lex_state = 136},
  [6174] = {.lex_state = 11, .external_lex_state = 33},
  [6175] = {.lex_state = 16, .external_lex_state = 28},
  [6176] = {.lex_state = 11, .external_lex_state = 117},
  [6177] = {.lex_state = 16, .external_lex_state = 28},
  [6178] = {.lex_state = 11, .external_lex_state = 33},
  [6179] = {.lex_state = 11, .external_lex_state = 33},
  [6180] = {.lex_state = 11, .external_lex_state = 134},
  [6181] = {.lex_state = 11, .external_lex_state = 134},
  [6182] = {.lex_state = 16, .external_lex_state = 28},
  [6183] = {.lex_state = 11, .external_lex_state = 135},
  [6184] = {.lex_state = 11, .external_lex_state = 135},
  [6185] = {.lex_state = 11, .external_lex_state = 134},
  [6186] = {.lex_state = 8, .external_lex_state = 91},
  [6187] = {.lex_state = 8, .external_lex_state = 91},
  [6188] = {.lex_state = 11, .external_lex_state = 33},
  [6189] = {.lex_state = 11, .external_lex_state = 136},
  [6190] = {.lex_state = 11, .external_lex_state = 136},
  [6191] = {.lex_state = 8, .external_lex_state = 40},
  [6192] = {.lex_state = 8, .external_lex_state = 138},
  [6193] = {.lex_state = 8, .external_lex_state = 41},
  [6194] = {.lex_state = 8, .external_lex_state = 37},
  [6195] = {.lex_state = 8, .external_lex_state = 37},
  [6196] = {.lex_state = 3, .external_lex_state = 119},
  [6197] = {.lex_state = 8, .external_lex_state = 41},
  [6198] = {.lex_state = 8, .external_lex_state = 37},
  [6199] = {.lex_state = 8, .external_lex_state = 37},
  [6200] = {.lex_state = 8, .external_lex_state = 37},
  [6201] = {.lex_state = 8, .external_lex_state = 37},
  [6202] = {.lex_state = 8, .external_lex_state = 37},
  [6203] = {.lex_state = 8, .external_lex_state = 37},
  [6204] = {.lex_state = 16, .external_lex_state = 27},
  [6205] = {.lex_state = 8, .external_lex_state = 37},
  [6206] = {.lex_state = 8, .external_lex_state = 37},
  [6207] = {.lex_state = 8, .external_lex_state = 37},
  [6208] = {.lex_state = 8, .external_lex_state = 41},
  [6209] = {.lex_state = 8, .external_lex_state = 37},
  [6210] = {.lex_state = 8, .external_lex_state = 37},
  [6211] = {.lex_state = 8, .external_lex_state = 37},
  [6212] = {.lex_state = 8, .external_lex_state = 36},
  [6213] = {.lex_state = 8, .external_lex_state = 37},
  [6214] = {.lex_state = 8, .external_lex_state = 41},
  [6215] = {.lex_state = 8, .external_lex_state = 41},
  [6216] = {.lex_state = 8, .external_lex_state = 37},
  [6217] = {.lex_state = 8, .external_lex_state = 138},
  [6218] = {.lex_state = 8, .external_lex_state = 36},
  [6219] = {.lex_state = 8, .external_lex_state = 41},
  [6220] = {.lex_state = 8, .external_lex_state = 37},
  [6221] = {.lex_state = 8, .external_lex_state = 37},
  [6222] = {.lex_state = 8, .external_lex_state = 37},
  [6223] = {.lex_state = 8, .external_lex_state = 37},
  [6224] = {.lex_state = 8, .external_lex_state = 37},
  [6225] = {.lex_state = 16, .external_lex_state = 27},
  [6226] = {.lex_state = 16, .external_lex_state = 27},
  [6227] = {.lex_state = 16, .external_lex_state = 27},
  [6228] = {.lex_state = 8, .external_lex_state = 139},
  [6229] = {.lex_state = 16, .external_lex_state = 27},
  [6230] = {.lex_state = 8, .external_lex_state = 36},
  [6231] = {.lex_state = 8, .external_lex_state = 37},
  [6232] = {.lex_state = 8, .external_lex_state = 36},
  [6233] = {.lex_state = 8, .external_lex_state = 36},
  [6234] = {.lex_state = 16, .external_lex_state = 27},
  [6235] = {.lex_state = 8, .external_lex_state = 37},
  [6236] = {.lex_state = 8, .external_lex_state = 41},
  [6237] = {.lex_state = 16, .external_lex_state = 27},
  [6238] = {.lex_state = 8, .external_lex_state = 41},
  [6239] = {.lex_state = 8, .external_lex_state = 37},
  [6240] = {.lex_state = 16, .external_lex_state = 27},
  [6241] = {.lex_state = 8, .external_lex_state = 41},
  [6242] = {.lex_state = 8, .external_lex_state = 37},
  [6243] = {.lex_state = 8, .external_lex_state = 41},
  [6244] = {.lex_state = 8, .external_lex_state = 139},
  [6245] = {.lex_state = 11, .external_lex_state = 39},
  [6246] = {.lex_state = 8, .external_lex_state = 139},
  [6247] = {.lex_state = 16, .external_lex_state = 27},
  [6248] = {.lex_state = 8, .external_lex_state = 40},
  [6249] = {.lex_state = 16, .external_lex_state = 27},
  [6250] = {.lex_state = 8, .external_lex_state = 138},
  [6251] = {.lex_state = 16, .external_lex_state = 27},
  [6252] = {.lex_state = 8, .external_lex_state = 139},
  [6253] = {.lex_state = 16, .external_lex_state = 27},
  [6254] = {.lex_state = 8, .external_lex_state = 139},
  [6255] = {.lex_state = 16, .external_lex_state = 27},
  [6256] = {.lex_state = 8, .external_lex_state = 36},
  [6257] = {.lex_state = 8, .external_lex_state = 37},
  [6258] = {.lex_state = 16, .external_lex_state = 27},
  [6259] = {.lex_state = 16, .external_lex_state = 27},
  [6260] = {.lex_state = 8, .external_lex_state = 138},
  [6261] = {.lex_state = 8, .external_lex_state = 41},
  [6262] = {.lex_state = 8, .external_lex_state = 37},
  [6263] = {.lex_state = 8, .external_lex_state = 138},
  [6264] = {.lex_state = 8, .external_lex_state = 41},
  [6265] = {.lex_state = 8, .external_lex_state = 41},
  [6266] = {.lex_state = 3, .external_lex_state = 140},
  [6267] = {.lex_state = 8, .external_lex_state = 41},
  [6268] = {.lex_state = 11, .external_lex_state = 39},
  [6269] = {.lex_state = 8, .external_lex_state = 40},
  [6270] = {.lex_state = 8, .external_lex_state = 40},
  [6271] = {.lex_state = 3, .external_lex_state = 140},
  [6272] = {.lex_state = 8, .external_lex_state = 40},
  [6273] = {.lex_state = 8, .external_lex_state = 41},
  [6274] = {.lex_state = 8, .external_lex_state = 36},
  [6275] = {.lex_state = 8, .external_lex_state = 41},
  [6276] = {.lex_state = 8, .external_lex_state = 41},
  [6277] = {.lex_state = 8, .external_lex_state = 41},
  [6278] = {.lex_state = 8, .external_lex_state = 41},
  [6279] = {.lex_state = 8, .external_lex_state = 41},
  [6280] = {.lex_state = 8, .external_lex_state = 41},
  [6281] = {.lex_state = 8, .external_lex_state = 41},
  [6282] = {.lex_state = 8, .external_lex_state = 41},
  [6283] = {.lex_state = 8, .external_lex_state = 41},
  [6284] = {.lex_state = 8, .external_lex_state = 41},
  [6285] = {.lex_state = 8, .external_lex_state = 40},
  [6286] = {.lex_state = 8, .external_lex_state = 40},
  [6287] = {.lex_state = 8, .external_lex_state = 40},
  [6288] = {.lex_state = 8, .external_lex_state = 40},
  [6289] = {.lex_state = 8, .external_lex_state = 40},
  [6290] = {.lex_state = 8, .external_lex_state = 138},
  [6291] = {.lex_state = 8, .external_lex_state = 40},
  [6292] = {.lex_state = 8, .external_lex_state = 40},
  [6293] = {.lex_state = 8, .external_lex_state = 37},
  [6294] = {.lex_state = 8, .external_lex_state = 40},
  [6295] = {.lex_state = 8, .external_lex_state = 37},
  [6296] = {.lex_state = 8, .external_lex_state = 40},
  [6297] = {.lex_state = 11, .external_lex_state = 141},
  [6298] = {.lex_state = 11, .external_lex_state = 141},
  [6299] = {.lex_state = 11, .external_lex_state = 141},
  [6300] = {.lex_state = 8, .external_lex_state = 37},
  [6301] = {.lex_state = 8, .external_lex_state = 37},
  [6302] = {.lex_state = 11, .external_lex_state = 141},
  [6303] = {.lex_state = 11, .external_lex_state = 141},
  [6304] = {.lex_state = 8, .external_lex_state = 138},
  [6305] = {.lex_state = 8, .external_lex_state = 40},
  [6306] = {.lex_state = 8, .external_lex_state = 40},
  [6307] = {.lex_state = 8, .external_lex_state = 41},
  [6308] = {.lex_state = 8, .external_lex_state = 40},
  [6309] = {.lex_state = 8, .external_lex_state = 40},
  [6310] = {.lex_state = 8, .external_lex_state = 41},
  [6311] = {.lex_state = 8, .external_lex_state = 40},
  [6312] = {.lex_state = 8, .external_lex_state = 138},
  [6313] = {.lex_state = 8, .external_lex_state = 36},
  [6314] = {.lex_state = 8, .external_lex_state = 36},
  [6315] = {.lex_state = 8, .external_lex_state = 36},
  [6316] = {.lex_state = 8, .external_lex_state = 37},
  [6317] = {.lex_state = 8, .external_lex_state = 37},
  [6318] = {.lex_state = 8, .external_lex_state = 37},
  [6319] = {.lex_state = 8, .external_lex_state = 37},
  [6320] = {.lex_state = 8, .external_lex_state = 40},
  [6321] = {.lex_state = 8, .external_lex_state = 40},
  [6322] = {.lex_state = 8, .external_lex_state = 139},
  [6323] = {.lex_state = 8, .external_lex_state = 40},
  [6324] = {.lex_state = 8, .external_lex_state = 40},
  [6325] = {.lex_state = 8, .external_lex_state = 40},
  [6326] = {.lex_state = 8, .external_lex_state = 40},
  [6327] = {.lex_state = 8, .external_lex_state = 40},
  [6328] = {.lex_state = 8, .external_lex_state = 40},
  [6329] = {.lex_state = 8, .external_lex_state = 40},
  [6330] = {.lex_state = 8, .external_lex_state = 40},
  [6331] = {.lex_state = 8, .external_lex_state = 40},
  [6332] = {.lex_state = 8, .external_lex_state = 41},
  [6333] = {.lex_state = 11, .external_lex_state = 39},
  [6334] = {.lex_state = 8, .external_lex_state = 41},
  [6335] = {.lex_state = 8, .external_lex_state = 138},
  [6336] = {.lex_state = 8, .external_lex_state = 138},
  [6337] = {.lex_state = 8, .external_lex_state = 37},
  [6338] = {.lex_state = 11, .external_lex_state = 39},
  [6339] = {.lex_state = 8, .external_lex_state = 138},
  [6340] = {.lex_state = 8, .external_lex_state = 36},
  [6341] = {.lex_state = 8, .external_lex_state = 37},
  [6342] = {.lex_state = 8, .external_lex_state = 40},
  [6343] = {.lex_state = 8, .external_lex_state = 40},
  [6344] = {.lex_state = 8, .external_lex_state = 40},
  [6345] = {.lex_state = 8, .external_lex_state = 37},
  [6346] = {.lex_state = 8, .external_lex_state = 37},
  [6347] = {.lex_state = 8, .external_lex_state = 37},
  [6348] = {.lex_state = 8, .external_lex_state = 40},
  [6349] = {.lex_state = 8, .external_lex_state = 37},
  [6350] = {.lex_state = 8, .external_lex_state = 37},
  [6351] = {.lex_state = 8, .external_lex_state = 37},
  [6352] = {.lex_state = 8, .external_lex_state = 138},
  [6353] = {.lex_state = 8, .external_lex_state = 41},
  [6354] = {.lex_state = 16, .external_lex_state = 27},
  [6355] = {.lex_state = 16, .external_lex_state = 27},
  [6356] = {.lex_state = 8, .external_lex_state = 139},
  [6357] = {.lex_state = 11, .external_lex_state = 39},
  [6358] = {.lex_state = 11, .external_lex_state = 39},
  [6359] = {.lex_state = 11, .external_lex_state = 141},
  [6360] = {.lex_state = 8, .external_lex_state = 138},
  [6361] = {.lex_state = 8, .external_lex_state = 36},
  [6362] = {.lex_state = 8, .external_lex_state = 36},
  [6363] = {.lex_state = 8, .external_lex_state = 37},
  [6364] = {.lex_state = 8, .external_lex_state = 37},
  [6365] = {.lex_state = 8, .external_lex_state = 37},
  [6366] = {.lex_state = 8, .external_lex_state = 40},
  [6367] = {.lex_state = 8, .external_lex_state = 36},
  [6368] = {.lex_state = 8, .external_lex_state = 40},
  [6369] = {.lex_state = 8, .external_lex_state = 40},
  [6370] = {.lex_state = 11, .external_lex_state = 39},
  [6371] = {.lex_state = 16, .external_lex_state = 27},
  [6372] = {.lex_state = 8, .external_lex_state = 40},
  [6373] = {.lex_state = 11, .external_lex_state = 39},
  [6374] = {.lex_state = 8, .external_lex_state = 40},
  [6375] = {.lex_state = 11, .external_lex_state = 39},
  [6376] = {.lex_state = 8, .external_lex_state = 36},
  [6377] = {.lex_state = 8, .external_lex_state = 138},
  [6378] = {.lex_state = 8, .external_lex_state = 138},
  [6379] = {.lex_state = 11, .external_lex_state = 39},
  [6380] = {.lex_state = 8, .external_lex_state = 138},
  [6381] = {.lex_state = 8, .external_lex_state = 138},
  [6382] = {.lex_state = 16, .external_lex_state = 27},
  [6383] = {.lex_state = 8, .external_lex_state = 40},
  [6384] = {.lex_state = 8, .external_lex_state = 138},
  [6385] = {.lex_state = 8, .external_lex_state = 36},
  [6386] = {.lex_state = 16, .external_lex_state = 27},
  [6387] = {.lex_state = 11, .external_lex_state = 39},
  [6388] = {.lex_state = 11, .external_lex_state = 39},
  [6389] = {.lex_state = 8, .external_lex_state = 36},
  [6390] = {.lex_state = 8, .external_lex_state = 36},
  [6391] = {.lex_state = 16, .external_lex_state = 27},
  [6392] = {.lex_state = 8, .external_lex_state = 138},
  [6393] = {.lex_state = 8, .external_lex_state = 36},
  [6394] = {.lex_state = 8, .external_lex_state = 36},
  [6395] = {.lex_state = 8, .external_lex_state = 36},
  [6396] = {.lex_state = 16, .external_lex_state = 27},
  [6397] = {.lex_state = 8, .external_lex_state = 139},
  [6398] = {.lex_state = 8, .external_lex_state = 36},
  [6399] = {.lex_state = 11, .external_lex_state = 39},
  [6400] = {.lex_state = 8, .external_lex_state = 138},
  [6401] = {.lex_state = 8, .external_lex_state = 41},
  [6402] = {.lex_state = 8, .external_lex_state = 138},
  [6403] = {.lex_state = 8, .external_lex_state = 138},
  [6404] = {.lex_state = 16, .external_lex_state = 27},
  [6405] = {.lex_state = 8, .external_lex_state = 138},
  [6406] = {.lex_state = 8, .external_lex_state = 40},
  [6407] = {.lex_state = 11, .external_lex_state = 39},
  [6408] = {.lex_state = 8, .external_lex_state = 36},
  [6409] = {.lex_state = 8, .external_lex_state = 36},
  [6410] = {.lex_state = 8, .external_lex_state = 40},
  [6411] = {.lex_state = 8, .external_lex_state = 138},
  [6412] = {.lex_state = 8, .external_lex_state = 41},
  [6413] = {.lex_state = 16, .external_lex_state = 27},
  [6414] = {.lex_state = 8, .external_lex_state = 36},
  [6415] = {.lex_state = 16, .external_lex_state = 27},
  [6416] = {.lex_state = 8, .external_lex_state = 41},
  [6417] = {.lex_state = 8, .external_lex_state = 41},
  [6418] = {.lex_state = 8, .external_lex_state = 41},
  [6419] = {.lex_state = 11, .external_lex_state = 39},
  [6420] = {.lex_state = 16, .external_lex_state = 27},
  [6421] = {.lex_state = 8, .external_lex_state = 41},
  [6422] = {.lex_state = 8, .external_lex_state = 138},
  [6423] = {.lex_state = 11, .external_lex_state = 141},
  [6424] = {.lex_state = 8, .external_lex_state = 36},
  [6425] = {.lex_state = 8, .external_lex_state = 36},
  [6426] = {.lex_state = 8, .external_lex_state = 36},
  [6427] = {.lex_state = 8, .external_lex_state = 36},
  [6428] = {.lex_state = 8, .external_lex_state = 138},
  [6429] = {.lex_state = 8, .external_lex_state = 36},
  [6430] = {.lex_state = 8, .external_lex_state = 36},
  [6431] = {.lex_state = 8, .external_lex_state = 36},
  [6432] = {.lex_state = 8, .external_lex_state = 36},
  [6433] = {.lex_state = 8, .external_lex_state = 40},
  [6434] = {.lex_state = 11, .external_lex_state = 141},
  [6435] = {.lex_state = 8, .external_lex_state = 36},
  [6436] = {.lex_state = 8, .external_lex_state = 40},
  [6437] = {.lex_state = 8, .external_lex_state = 36},
  [6438] = {.lex_state = 8, .external_lex_state = 40},
  [6439] = {.lex_state = 8, .external_lex_state = 138},
  [6440] = {.lex_state = 8, .external_lex_state = 142},
  [6441] = {.lex_state = 8, .external_lex_state = 138},
  [6442] = {.lex_state = 8, .external_lex_state = 138},
  [6443] = {.lex_state = 8, .external_lex_state = 40},
  [6444] = {.lex_state = 8, .external_lex_state = 37},
  [6445] = {.lex_state = 8, .external_lex_state = 40},
  [6446] = {.lex_state = 8, .external_lex_state = 138},
  [6447] = {.lex_state = 8, .external_lex_state = 36},
  [6448] = {.lex_state = 8, .external_lex_state = 40},
  [6449] = {.lex_state = 11, .external_lex_state = 39},
  [6450] = {.lex_state = 11, .external_lex_state = 39},
  [6451] = {.lex_state = 11, .external_lex_state = 39},
  [6452] = {.lex_state = 8, .external_lex_state = 36},
  [6453] = {.lex_state = 8, .external_lex_state = 36},
  [6454] = {.lex_state = 8, .external_lex_state = 138},
  [6455] = {.lex_state = 11, .external_lex_state = 39},
  [6456] = {.lex_state = 16, .external_lex_state = 27},
  [6457] = {.lex_state = 8, .external_lex_state = 138},
  [6458] = {.lex_state = 8, .external_lex_state = 138},
  [6459] = {.lex_state = 8, .external_lex_state = 36},
  [6460] = {.lex_state = 8, .external_lex_state = 138},
  [6461] = {.lex_state = 8, .external_lex_state = 138},
  [6462] = {.lex_state = 8, .external_lex_state = 138},
  [6463] = {.lex_state = 8, .external_lex_state = 41},
  [6464] = {.lex_state = 8, .external_lex_state = 37},
  [6465] = {.lex_state = 8, .external_lex_state = 138},
  [6466] = {.lex_state = 8, .external_lex_state = 36},
  [6467] = {.lex_state = 8, .external_lex_state = 36},
  [6468] = {.lex_state = 8, .external_lex_state = 40},
  [6469] = {.lex_state = 16, .external_lex_state = 27},
  [6470] = {.lex_state = 16, .external_lex_state = 27},
  [6471] = {.lex_state = 8, .external_lex_state = 40},
  [6472] = {.lex_state = 8, .external_lex_state = 40},
  [6473] = {.lex_state = 16, .external_lex_state = 27},
  [6474] = {.lex_state = 8, .external_lex_state = 41},
  [6475] = {.lex_state = 8, .external_lex_state = 36},
  [6476] = {.lex_state = 8, .external_lex_state = 36},
  [6477] = {.lex_state = 16, .external_lex_state = 27},
  [6478] = {.lex_state = 11, .external_lex_state = 39},
  [6479] = {.lex_state = 16, .external_lex_state = 27},
  [6480] = {.lex_state = 16, .external_lex_state = 27},
  [6481] = {.lex_state = 16, .external_lex_state = 27},
  [6482] = {.lex_state = 8, .external_lex_state = 37},
  [6483] = {.lex_state = 16, .external_lex_state = 27},
  [6484] = {.lex_state = 8, .external_lex_state = 37},
  [6485] = {.lex_state = 8, .external_lex_state = 41},
  [6486] = {.lex_state = 8, .external_lex_state = 41},
  [6487] = {.lex_state = 8, .external_lex_state = 41},
  [6488] = {.lex_state = 8, .external_lex_state = 41},
  [6489] = {.lex_state = 8, .external_lex_state = 37},
  [6490] = {.lex_state = 16, .external_lex_state = 27},
  [6491] = {.lex_state = 16, .external_lex_state = 27},
  [6492] = {.lex_state = 8, .external_lex_state = 36},
  [6493] = {.lex_state = 8, .external_lex_state = 41},
  [6494] = {.lex_state = 16, .external_lex_state = 27},
  [6495] = {.lex_state = 8, .external_lex_state = 41},
  [6496] = {.lex_state = 11, .external_lex_state = 39},
  [6497] = {.lex_state = 3, .external_lex_state = 140},
  [6498] = {.lex_state = 8, .external_lex_state = 41},
  [6499] = {.lex_state = 8, .external_lex_state = 41},
  [6500] = {.lex_state = 8, .external_lex_state = 41},
  [6501] = {.lex_state = 8, .external_lex_state = 138},
  [6502] = {.lex_state = 8, .external_lex_state = 138},
  [6503] = {.lex_state = 8, .external_lex_state = 41},
  [6504] = {.lex_state = 8, .external_lex_state = 40},
  [6505] = {.lex_state = 11, .external_lex_state = 39},
  [6506] = {.lex_state = 8, .external_lex_state = 138},
  [6507] = {.lex_state = 11, .external_lex_state = 39},
  [6508] = {.lex_state = 8, .external_lex_state = 41},
  [6509] = {.lex_state = 11, .external_lex_state = 39},
  [6510] = {.lex_state = 11, .external_lex_state = 39},
  [6511] = {.lex_state = 8, .external_lex_state = 41},
  [6512] = {.lex_state = 11, .external_lex_state = 39},
  [6513] = {.lex_state = 11, .external_lex_state = 39},
  [6514] = {.lex_state = 11, .external_lex_state = 39},
  [6515] = {.lex_state = 11, .external_lex_state = 39},
  [6516] = {.lex_state = 11, .external_lex_state = 39},
  [6517] = {.lex_state = 11, .external_lex_state = 39},
  [6518] = {.lex_state = 11, .external_lex_state = 39},
  [6519] = {.lex_state = 11, .external_lex_state = 39},
  [6520] = {.lex_state = 11, .external_lex_state = 39},
  [6521] = {.lex_state = 11, .external_lex_state = 39},
  [6522] = {.lex_state = 8, .external_lex_state = 139},
  [6523] = {.lex_state = 11, .external_lex_state = 39},
  [6524] = {.lex_state = 8, .external_lex_state = 138},
  [6525] = {.lex_state = 16, .external_lex_state = 27},
  [6526] = {.lex_state = 8, .external_lex_state = 37},
  [6527] = {.lex_state = 16, .external_lex_state = 27},
  [6528] = {.lex_state = 16, .external_lex_state = 27},
  [6529] = {.lex_state = 16, .external_lex_state = 27},
  [6530] = {.lex_state = 16, .external_lex_state = 27},
  [6531] = {.lex_state = 11, .external_lex_state = 39},
  [6532] = {.lex_state = 11, .external_lex_state = 39},
  [6533] = {.lex_state = 11, .external_lex_state = 39},
  [6534] = {.lex_state = 16, .external_lex_state = 27},
  [6535] = {.lex_state = 8, .external_lex_state = 41},
  [6536] = {.lex_state = 8, .external_lex_state = 36},
  [6537] = {.lex_state = 11, .external_lex_state = 39},
  [6538] = {.lex_state = 8, .external_lex_state = 36},
  [6539] = {.lex_state = 8, .external_lex_state = 36},
  [6540] = {.lex_state = 8, .external_lex_state = 138},
  [6541] = {.lex_state = 8, .external_lex_state = 41},
  [6542] = {.lex_state = 8, .external_lex_state = 36},
  [6543] = {.lex_state = 8, .external_lex_state = 138},
  [6544] = {.lex_state = 11, .external_lex_state = 39},
  [6545] = {.lex_state = 11, .external_lex_state = 39},
  [6546] = {.lex_state = 8, .external_lex_state = 36},
  [6547] = {.lex_state = 8, .external_lex_state = 36},
  [6548] = {.lex_state = 16, .external_lex_state = 27},
  [6549] = {.lex_state = 11, .external_lex_state = 39},
  [6550] = {.lex_state = 8, .external_lex_state = 138},
  [6551] = {.lex_state = 11, .external_lex_state = 39},
  [6552] = {.lex_state = 11, .external_lex_state = 39},
  [6553] = {.lex_state = 8, .external_lex_state = 138},
  [6554] = {.lex_state = 11, .external_lex_state = 39},
  [6555] = {.lex_state = 8, .external_lex_state = 138},
  [6556] = {.lex_state = 11, .external_lex_state = 39},
  [6557] = {.lex_state = 11, .external_lex_state = 39},
  [6558] = {.lex_state = 11, .external_lex_state = 39},
  [6559] = {.lex_state = 16, .external_lex_state = 27},
  [6560] = {.lex_state = 8, .external_lex_state = 138},
  [6561] = {.lex_state = 11, .external_lex_state = 39},
  [6562] = {.lex_state = 8, .external_lex_state = 138},
  [6563] = {.lex_state = 11, .external_lex_state = 39},
  [6564] = {.lex_state = 8, .external_lex_state = 36},
  [6565] = {.lex_state = 11, .external_lex_state = 141},
  [6566] = {.lex_state = 8, .external_lex_state = 36},
  [6567] = {.lex_state = 16, .external_lex_state = 27},
  [6568] = {.lex_state = 11, .external_lex_state = 39},
  [6569] = {.lex_state = 16, .external_lex_state = 27},
  [6570] = {.lex_state = 16, .external_lex_state = 27},
  [6571] = {.lex_state = 16, .external_lex_state = 27},
  [6572] = {.lex_state = 16, .external_lex_state = 27},
  [6573] = {.lex_state = 16, .external_lex_state = 27},
  [6574] = {.lex_state = 8, .external_lex_state = 42},
  [6575] = {.lex_state = 11, .external_lex_state = 33},
  [6576] = {.lex_state = 8, .external_lex_state = 42},
  [6577] = {.lex_state = 8, .external_lex_state = 42},
  [6578] = {.lex_state = 8, .external_lex_state = 42},
  [6579] = {.lex_state = 8, .external_lex_state = 42},
  [6580] = {.lex_state = 8, .external_lex_state = 143},
  [6581] = {.lex_state = 8, .external_lex_state = 42},
  [6582] = {.lex_state = 8, .external_lex_state = 42},
  [6583] = {.lex_state = 8, .external_lex_state = 42},
  [6584] = {.lex_state = 9, .external_lex_state = 144},
  [6585] = {.lex_state = 11, .external_lex_state = 33},
  [6586] = {.lex_state = 8, .external_lex_state = 42},
  [6587] = {.lex_state = 3, .external_lex_state = 19},
  [6588] = {.lex_state = 4, .external_lex_state = 145},
  [6589] = {.lex_state = 4, .external_lex_state = 145},
  [6590] = {.lex_state = 11, .external_lex_state = 33},
  [6591] = {.lex_state = 8, .external_lex_state = 42},
  [6592] = {.lex_state = 11, .external_lex_state = 33},
  [6593] = {.lex_state = 8, .external_lex_state = 146},
  [6594] = {.lex_state = 8, .external_lex_state = 146},
  [6595] = {.lex_state = 8, .external_lex_state = 42},
  [6596] = {.lex_state = 8, .external_lex_state = 42},
  [6597] = {.lex_state = 8, .external_lex_state = 143},
  [6598] = {.lex_state = 9, .external_lex_state = 144},
  [6599] = {.lex_state = 8, .external_lex_state = 42},
  [6600] = {.lex_state = 8, .external_lex_state = 42},
  [6601] = {.lex_state = 8, .external_lex_state = 42},
  [6602] = {.lex_state = 8, .external_lex_state = 42},
  [6603] = {.lex_state = 9, .external_lex_state = 144},
  [6604] = {.lex_state = 8, .external_lex_state = 42},
  [6605] = {.lex_state = 8, .external_lex_state = 42},
  [6606] = {.lex_state = 8, .external_lex_state = 143},
  [6607] = {.lex_state = 8, .external_lex_state = 42},
  [6608] = {.lex_state = 8, .external_lex_state = 143},
  [6609] = {.lex_state = 11, .external_lex_state = 33},
  [6610] = {.lex_state = 8, .external_lex_state = 42},
  [6611] = {.lex_state = 8, .external_lex_state = 42},
  [6612] = {.lex_state = 8, .external_lex_state = 143},
  [6613] = {.lex_state = 8, .external_lex_state = 42},
  [6614] = {.lex_state = 8, .external_lex_state = 42},
  [6615] = {.lex_state = 8, .external_lex_state = 42},
  [6616] = {.lex_state = 8, .external_lex_state = 42},
  [6617] = {.lex_state = 1, .external_lex_state = 11},
  [6618] = {.lex_state = 11, .external_lex_state = 33},
  [6619] = {.lex_state = 9, .external_lex_state = 144},
  [6620] = {.lex_state = 9, .external_lex_state = 144},
  [6621] = {.lex_state = 8, .external_lex_state = 42},
  [6622] = {.lex_state = 11, .external_lex_state = 33},
  [6623] = {.lex_state = 8, .external_lex_state = 143},
  [6624] = {.lex_state = 8, .external_lex_state = 42},
  [6625] = {.lex_state = 8, .external_lex_state = 146},
  [6626] = {.lex_state = 8, .external_lex_state = 42},
  [6627] = {.lex_state = 11, .external_lex_state = 33},
  [6628] = {.lex_state = 8, .external_lex_state = 22},
  [6629] = {.lex_state = 8, .external_lex_state = 146},
  [6630] = {.lex_state = 8, .external_lex_state = 146},
  [6631] = {.lex_state = 8, .external_lex_state = 42},
  [6632] = {.lex_state = 8, .external_lex_state = 42},
  [6633] = {.lex_state = 11, .external_lex_state = 33},
  [6634] = {.lex_state = 8, .external_lex_state = 42},
  [6635] = {.lex_state = 11, .external_lex_state = 33},
  [6636] = {.lex_state = 11, .external_lex_state = 33},
  [6637] = {.lex_state = 11, .external_lex_state = 33},
  [6638] = {.lex_state = 11, .external_lex_state = 33},
  [6639] = {.lex_state = 8, .external_lex_state = 42},
  [6640] = {.lex_state = 11, .external_lex_state = 33},
  [6641] = {.lex_state = 11, .external_lex_state = 33},
  [6642] = {.lex_state = 8, .external_lex_state = 42},
  [6643] = {.lex_state = 8, .external_lex_state = 42},
  [6644] = {.lex_state = 11, .external_lex_state = 33},
  [6645] = {.lex_state = 11, .external_lex_state = 33},
  [6646] = {.lex_state = 11, .external_lex_state = 33},
  [6647] = {.lex_state = 8, .external_lex_state = 42},
  [6648] = {.lex_state = 11, .external_lex_state = 33},
  [6649] = {.lex_state = 11, .external_lex_state = 33},
  [6650] = {.lex_state = 11, .external_lex_state = 33},
  [6651] = {.lex_state = 11, .external_lex_state = 33},
  [6652] = {.lex_state = 11, .external_lex_state = 33},
  [6653] = {.lex_state = 8, .external_lex_state = 143},
  [6654] = {.lex_state = 11, .external_lex_state = 33},
  [6655] = {.lex_state = 11, .external_lex_state = 33},
  [6656] = {.lex_state = 11, .external_lex_state = 33},
  [6657] = {.lex_state = 11, .external_lex_state = 33},
  [6658] = {.lex_state = 8, .external_lex_state = 146},
  [6659] = {.lex_state = 11, .external_lex_state = 33},
  [6660] = {.lex_state = 11, .external_lex_state = 33},
  [6661] = {.lex_state = 11, .external_lex_state = 33},
  [6662] = {.lex_state = 8, .external_lex_state = 42},
  [6663] = {.lex_state = 11, .external_lex_state = 33},
  [6664] = {.lex_state = 8, .external_lex_state = 146},
  [6665] = {.lex_state = 11, .external_lex_state = 33},
  [6666] = {.lex_state = 11, .external_lex_state = 33},
  [6667] = {.lex_state = 11, .external_lex_state = 33},
  [6668] = {.lex_state = 8, .external_lex_state = 42},
  [6669] = {.lex_state = 8, .external_lex_state = 42},
  [6670] = {.lex_state = 8, .external_lex_state = 42},
  [6671] = {.lex_state = 11, .external_lex_state = 33},
  [6672] = {.lex_state = 8, .external_lex_state = 42},
  [6673] = {.lex_state = 11, .external_lex_state = 33},
  [6674] = {.lex_state = 9, .external_lex_state = 144},
  [6675] = {.lex_state = 9, .external_lex_state = 144},
  [6676] = {.lex_state = 8, .external_lex_state = 146},
  [6677] = {.lex_state = 4, .external_lex_state = 145},
  [6678] = {.lex_state = 9, .external_lex_state = 144},
  [6679] = {.lex_state = 1, .external_lex_state = 11},
  [6680] = {.lex_state = 8, .external_lex_state = 42},
  [6681] = {.lex_state = 8, .external_lex_state = 42},
  [6682] = {.lex_state = 8, .external_lex_state = 42},
  [6683] = {.lex_state = 8, .external_lex_state = 42},
  [6684] = {.lex_state = 8, .external_lex_state = 146},
  [6685] = {.lex_state = 8, .external_lex_state = 42},
  [6686] = {.lex_state = 8, .external_lex_state = 42},
  [6687] = {.lex_state = 8, .external_lex_state = 42},
  [6688] = {.lex_state = 8, .external_lex_state = 42},
  [6689] = {.lex_state = 8, .external_lex_state = 42},
  [6690] = {.lex_state = 8, .external_lex_state = 42},
  [6691] = {.lex_state = 9, .external_lex_state = 144},
  [6692] = {.lex_state = 8, .external_lex_state = 143},
  [6693] = {.lex_state = 8, .external_lex_state = 42},
  [6694] = {.lex_state = 8, .external_lex_state = 143},
  [6695] = {.lex_state = 8, .external_lex_state = 42},
  [6696] = {.lex_state = 4, .external_lex_state = 60},
  [6697] = {.lex_state = 11, .external_lex_state = 27},
  [6698] = {.lex_state = 11, .external_lex_state = 43},
  [6699] = {.lex_state = 8, .external_lex_state = 37},
  [6700] = {.lex_state = 8, .external_lex_state = 37},
  [6701] = {.lex_state = 8, .external_lex_state = 37},
  [6702] = {.lex_state = 8, .external_lex_state = 37},
  [6703] = {.lex_state = 8, .external_lex_state = 37},
  [6704] = {.lex_state = 8, .external_lex_state = 37},
  [6705] = {.lex_state = 8, .external_lex_state = 37},
  [6706] = {.lex_state = 8, .external_lex_state = 37},
  [6707] = {.lex_state = 8, .external_lex_state = 37},
  [6708] = {.lex_state = 8, .external_lex_state = 37},
  [6709] = {.lex_state = 8, .external_lex_state = 37},
  [6710] = {.lex_state = 11, .external_lex_state = 27},
  [6711] = {.lex_state = 8, .external_lex_state = 37},
  [6712] = {.lex_state = 11, .external_lex_state = 27},
  [6713] = {.lex_state = 11, .external_lex_state = 27},
  [6714] = {.lex_state = 11, .external_lex_state = 27},
  [6715] = {.lex_state = 8, .external_lex_state = 37},
  [6716] = {.lex_state = 11, .external_lex_state = 27},
  [6717] = {.lex_state = 11, .external_lex_state = 27},
  [6718] = {.lex_state = 11, .external_lex_state = 27},
  [6719] = {.lex_state = 11, .external_lex_state = 27},
  [6720] = {.lex_state = 11, .external_lex_state = 27},
  [6721] = {.lex_state = 11, .external_lex_state = 27},
  [6722] = {.lex_state = 11, .external_lex_state = 27},
  [6723] = {.lex_state = 11, .external_lex_state = 27},
  [6724] = {.lex_state = 11, .external_lex_state = 27},
  [6725] = {.lex_state = 11, .external_lex_state = 27},
  [6726] = {.lex_state = 11, .external_lex_state = 27},
  [6727] = {.lex_state = 11, .external_lex_state = 27},
  [6728] = {.lex_state = 8, .external_lex_state = 37},
  [6729] = {.lex_state = 8, .external_lex_state = 37},
  [6730] = {.lex_state = 11, .external_lex_state = 43},
  [6731] = {.lex_state = 8, .external_lex_state = 37},
  [6732] = {.lex_state = 11, .external_lex_state = 27},
  [6733] = {.lex_state = 11, .external_lex_state = 27},
  [6734] = {.lex_state = 11, .external_lex_state = 43},
  [6735] = {.lex_state = 8, .external_lex_state = 37},
  [6736] = {.lex_state = 11, .external_lex_state = 27},
  [6737] = {.lex_state = 11, .external_lex_state = 27},
  [6738] = {.lex_state = 8, .external_lex_state = 37},
  [6739] = {.lex_state = 11, .external_lex_state = 27},
  [6740] = {.lex_state = 8, .external_lex_state = 147},
  [6741] = {.lex_state = 8, .external_lex_state = 37},
  [6742] = {.lex_state = 11, .external_lex_state = 27},
  [6743] = {.lex_state = 8, .external_lex_state = 147},
  [6744] = {.lex_state = 11, .external_lex_state = 27},
  [6745] = {.lex_state = 11, .external_lex_state = 27},
  [6746] = {.lex_state = 11, .external_lex_state = 43},
  [6747] = {.lex_state = 11, .external_lex_state = 43},
  [6748] = {.lex_state = 8, .external_lex_state = 37},
  [6749] = {.lex_state = 11, .external_lex_state = 43},
  [6750] = {.lex_state = 11, .external_lex_state = 43},
  [6751] = {.lex_state = 8, .external_lex_state = 37},
  [6752] = {.lex_state = 8, .external_lex_state = 37},
  [6753] = {.lex_state = 8, .external_lex_state = 37},
  [6754] = {.lex_state = 11, .external_lex_state = 43},
  [6755] = {.lex_state = 8, .external_lex_state = 37},
  [6756] = {.lex_state = 11, .external_lex_state = 27},
  [6757] = {.lex_state = 11, .external_lex_state = 27},
  [6758] = {.lex_state = 8, .external_lex_state = 37},
  [6759] = {.lex_state = 8, .external_lex_state = 37},
  [6760] = {.lex_state = 8, .external_lex_state = 37},
  [6761] = {.lex_state = 8, .external_lex_state = 37},
  [6762] = {.lex_state = 8, .external_lex_state = 37},
  [6763] = {.lex_state = 11, .external_lex_state = 43},
  [6764] = {.lex_state = 11, .external_lex_state = 43},
  [6765] = {.lex_state = 11, .external_lex_state = 43},
  [6766] = {.lex_state = 11, .external_lex_state = 43},
  [6767] = {.lex_state = 11, .external_lex_state = 43},
  [6768] = {.lex_state = 11, .external_lex_state = 43},
  [6769] = {.lex_state = 11, .external_lex_state = 43},
  [6770] = {.lex_state = 11, .external_lex_state = 43},
  [6771] = {.lex_state = 8, .external_lex_state = 37},
  [6772] = {.lex_state = 8, .external_lex_state = 37},
  [6773] = {.lex_state = 8, .external_lex_state = 37},
  [6774] = {.lex_state = 8, .external_lex_state = 37},
  [6775] = {.lex_state = 8, .external_lex_state = 37},
  [6776] = {.lex_state = 11, .external_lex_state = 43},
  [6777] = {.lex_state = 11, .external_lex_state = 43},
  [6778] = {.lex_state = 11, .external_lex_state = 27},
  [6779] = {.lex_state = 8, .external_lex_state = 147},
  [6780] = {.lex_state = 11, .external_lex_state = 43},
  [6781] = {.lex_state = 11, .external_lex_state = 27},
  [6782] = {.lex_state = 11, .external_lex_state = 43},
  [6783] = {.lex_state = 11, .external_lex_state = 43},
  [6784] = {.lex_state = 11, .external_lex_state = 27},
  [6785] = {.lex_state = 11, .external_lex_state = 27},
  [6786] = {.lex_state = 11, .external_lex_state = 27},
  [6787] = {.lex_state = 11, .external_lex_state = 27},
  [6788] = {.lex_state = 3, .external_lex_state = 148},
  [6789] = {.lex_state = 11, .external_lex_state = 27},
  [6790] = {.lex_state = 11, .external_lex_state = 27},
  [6791] = {.lex_state = 11, .external_lex_state = 27},
  [6792] = {.lex_state = 11, .external_lex_state = 27},
  [6793] = {.lex_state = 11, .external_lex_state = 27},
  [6794] = {.lex_state = 11, .external_lex_state = 43},
  [6795] = {.lex_state = 11, .external_lex_state = 43},
  [6796] = {.lex_state = 11, .external_lex_state = 43},
  [6797] = {.lex_state = 11, .external_lex_state = 43},
  [6798] = {.lex_state = 11, .external_lex_state = 43},
  [6799] = {.lex_state = 11, .external_lex_state = 43},
  [6800] = {.lex_state = 8, .external_lex_state = 37},
  [6801] = {.lex_state = 11, .external_lex_state = 43},
  [6802] = {.lex_state = 11, .external_lex_state = 43},
  [6803] = {.lex_state = 11, .external_lex_state = 43},
  [6804] = {.lex_state = 8, .external_lex_state = 27},
  [6805] = {.lex_state = 8, .external_lex_state = 147},
  [6806] = {.lex_state = 11, .external_lex_state = 27},
  [6807] = {.lex_state = 11, .external_lex_state = 43},
  [6808] = {.lex_state = 11, .external_lex_state = 43},
  [6809] = {.lex_state = 11, .external_lex_state = 27},
  [6810] = {.lex_state = 11, .external_lex_state = 27},
  [6811] = {.lex_state = 11, .external_lex_state = 43},
  [6812] = {.lex_state = 11, .external_lex_state = 43},
  [6813] = {.lex_state = 11, .external_lex_state = 43},
  [6814] = {.lex_state = 11, .external_lex_state = 27},
  [6815] = {.lex_state = 11, .external_lex_state = 43},
  [6816] = {.lex_state = 11, .external_lex_state = 43},
  [6817] = {.lex_state = 11, .external_lex_state = 43},
  [6818] = {.lex_state = 11, .external_lex_state = 43},
  [6819] = {.lex_state = 11, .external_lex_state = 43},
  [6820] = {.lex_state = 8, .external_lex_state = 147},
  [6821] = {.lex_state = 11, .external_lex_state = 27},
  [6822] = {.lex_state = 11, .external_lex_state = 27},
  [6823] = {.lex_state = 8, .external_lex_state = 147},
  [6824] = {.lex_state = 8, .external_lex_state = 147},
  [6825] = {.lex_state = 11, .external_lex_state = 27},
  [6826] = {.lex_state = 11, .external_lex_state = 43},
  [6827] = {.lex_state = 11, .external_lex_state = 27},
  [6828] = {.lex_state = 11, .external_lex_state = 43},
  [6829] = {.lex_state = 8, .external_lex_state = 147},
  [6830] = {.lex_state = 11, .external_lex_state = 43},
  [6831] = {.lex_state = 11, .external_lex_state = 43},
  [6832] = {.lex_state = 8, .external_lex_state = 37},
  [6833] = {.lex_state = 8, .external_lex_state = 147},
  [6834] = {.lex_state = 11, .external_lex_state = 43},
  [6835] = {.lex_state = 11, .external_lex_state = 43},
  [6836] = {.lex_state = 11, .external_lex_state = 27},
  [6837] = {.lex_state = 11, .external_lex_state = 43},
  [6838] = {.lex_state = 11, .external_lex_state = 27},
  [6839] = {.lex_state = 11, .external_lex_state = 43},
  [6840] = {.lex_state = 11, .external_lex_state = 43},
  [6841] = {.lex_state = 11, .external_lex_state = 27},
  [6842] = {.lex_state = 11, .external_lex_state = 27},
  [6843] = {.lex_state = 11, .external_lex_state = 27},
  [6844] = {.lex_state = 11, .external_lex_state = 43},
  [6845] = {.lex_state = 11, .external_lex_state = 43},
  [6846] = {.lex_state = 3, .external_lex_state = 149},
  [6847] = {.lex_state = 11, .external_lex_state = 43},
  [6848] = {.lex_state = 11, .external_lex_state = 27},
  [6849] = {.lex_state = 11, .external_lex_state = 44},
  [6850] = {.lex_state = 11, .external_lex_state = 45},
  [6851] = {.lex_state = 11, .external_lex_state = 44},
  [6852] = {.lex_state = 8, .external_lex_state = 55},
  [6853] = {.lex_state = 11, .external_lex_state = 44},
  [6854] = {.lex_state = 11, .external_lex_state = 45},
  [6855] = {.lex_state = 11, .external_lex_state = 45},
  [6856] = {.lex_state = 11, .external_lex_state = 44},
  [6857] = {.lex_state = 11, .external_lex_state = 45},
  [6858] = {.lex_state = 11, .external_lex_state = 45},
  [6859] = {.lex_state = 11, .external_lex_state = 45},
  [6860] = {.lex_state = 11, .external_lex_state = 45},
  [6861] = {.lex_state = 11, .external_lex_state = 45},
  [6862] = {.lex_state = 8, .external_lex_state = 150},
  [6863] = {.lex_state = 11, .external_lex_state = 45},
  [6864] = {.lex_state = 11, .external_lex_state = 45},
  [6865] = {.lex_state = 8, .external_lex_state = 150},
  [6866] = {.lex_state = 11, .external_lex_state = 44},
  [6867] = {.lex_state = 11, .external_lex_state = 45},
  [6868] = {.lex_state = 11, .external_lex_state = 44},
  [6869] = {.lex_state = 11, .external_lex_state = 44},
  [6870] = {.lex_state = 11, .external_lex_state = 45},
  [6871] = {.lex_state = 8, .external_lex_state = 150},
  [6872] = {.lex_state = 11, .external_lex_state = 45},
  [6873] = {.lex_state = 11, .external_lex_state = 44},
  [6874] = {.lex_state = 11, .external_lex_state = 45},
  [6875] = {.lex_state = 8, .external_lex_state = 150},
  [6876] = {.lex_state = 11, .external_lex_state = 44},
  [6877] = {.lex_state = 11, .external_lex_state = 45},
  [6878] = {.lex_state = 11, .external_lex_state = 45},
  [6879] = {.lex_state = 11, .external_lex_state = 45},
  [6880] = {.lex_state = 11, .external_lex_state = 44},
  [6881] = {.lex_state = 11, .external_lex_state = 44},
  [6882] = {.lex_state = 11, .external_lex_state = 44},
  [6883] = {.lex_state = 11, .external_lex_state = 44},
  [6884] = {.lex_state = 11, .external_lex_state = 44},
  [6885] = {.lex_state = 11, .external_lex_state = 44},
  [6886] = {.lex_state = 11, .external_lex_state = 44},
  [6887] = {.lex_state = 11, .external_lex_state = 45},
  [6888] = {.lex_state = 11, .external_lex_state = 44},
  [6889] = {.lex_state = 11, .external_lex_state = 44},
  [6890] = {.lex_state = 11, .external_lex_state = 44},
  [6891] = {.lex_state = 11, .external_lex_state = 44},
  [6892] = {.lex_state = 11, .external_lex_state = 44},
  [6893] = {.lex_state = 11, .external_lex_state = 44},
  [6894] = {.lex_state = 11, .external_lex_state = 44},
  [6895] = {.lex_state = 8, .external_lex_state = 150},
  [6896] = {.lex_state = 11, .external_lex_state = 45},
  [6897] = {.lex_state = 11, .external_lex_state = 44},
  [6898] = {.lex_state = 11, .external_lex_state = 44},
  [6899] = {.lex_state = 11, .external_lex_state = 44},
  [6900] = {.lex_state = 11, .external_lex_state = 46},
  [6901] = {.lex_state = 11, .external_lex_state = 44},
  [6902] = {.lex_state = 11, .external_lex_state = 44},
  [6903] = {.lex_state = 11, .external_lex_state = 44},
  [6904] = {.lex_state = 4, .external_lex_state = 137},
  [6905] = {.lex_state = 11, .external_lex_state = 44},
  [6906] = {.lex_state = 11, .external_lex_state = 46},
  [6907] = {.lex_state = 11, .external_lex_state = 44},
  [6908] = {.lex_state = 11, .external_lex_state = 44},
  [6909] = {.lex_state = 11, .external_lex_state = 44},
  [6910] = {.lex_state = 11, .external_lex_state = 46},
  [6911] = {.lex_state = 11, .external_lex_state = 44},
  [6912] = {.lex_state = 11, .external_lex_state = 44},
  [6913] = {.lex_state = 11, .external_lex_state = 46},
  [6914] = {.lex_state = 11, .external_lex_state = 44},
  [6915] = {.lex_state = 8, .external_lex_state = 150},
  [6916] = {.lex_state = 11, .external_lex_state = 46},
  [6917] = {.lex_state = 11, .external_lex_state = 44},
  [6918] = {.lex_state = 11, .external_lex_state = 46},
  [6919] = {.lex_state = 11, .external_lex_state = 46},
  [6920] = {.lex_state = 11, .external_lex_state = 46},
  [6921] = {.lex_state = 11, .external_lex_state = 46},
  [6922] = {.lex_state = 11, .external_lex_state = 46},
  [6923] = {.lex_state = 11, .external_lex_state = 44},
  [6924] = {.lex_state = 11, .external_lex_state = 46},
  [6925] = {.lex_state = 11, .external_lex_state = 44},
  [6926] = {.lex_state = 11, .external_lex_state = 44},
  [6927] = {.lex_state = 11, .external_lex_state = 45},
  [6928] = {.lex_state = 11, .external_lex_state = 44},
  [6929] = {.lex_state = 11, .external_lex_state = 46},
  [6930] = {.lex_state = 11, .external_lex_state = 44},
  [6931] = {.lex_state = 11, .external_lex_state = 45},
  [6932] = {.lex_state = 11, .external_lex_state = 46},
  [6933] = {.lex_state = 11, .external_lex_state = 44},
  [6934] = {.lex_state = 11, .external_lex_state = 46},
  [6935] = {.lex_state = 11, .external_lex_state = 46},
  [6936] = {.lex_state = 11, .external_lex_state = 46},
  [6937] = {.lex_state = 11, .external_lex_state = 46},
  [6938] = {.lex_state = 11, .external_lex_state = 44},
  [6939] = {.lex_state = 11, .external_lex_state = 46},
  [6940] = {.lex_state = 11, .external_lex_state = 46},
  [6941] = {.lex_state = 11, .external_lex_state = 46},
  [6942] = {.lex_state = 11, .external_lex_state = 46},
  [6943] = {.lex_state = 11, .external_lex_state = 46},
  [6944] = {.lex_state = 11, .external_lex_state = 44},
  [6945] = {.lex_state = 11, .external_lex_state = 46},
  [6946] = {.lex_state = 11, .external_lex_state = 46},
  [6947] = {.lex_state = 11, .external_lex_state = 44},
  [6948] = {.lex_state = 11, .external_lex_state = 44},
  [6949] = {.lex_state = 11, .external_lex_state = 44},
  [6950] = {.lex_state = 11, .external_lex_state = 46},
  [6951] = {.lex_state = 11, .external_lex_state = 46},
  [6952] = {.lex_state = 11, .external_lex_state = 46},
  [6953] = {.lex_state = 11, .external_lex_state = 46},
  [6954] = {.lex_state = 11, .external_lex_state = 46},
  [6955] = {.lex_state = 11, .external_lex_state = 44},
  [6956] = {.lex_state = 8, .external_lex_state = 55},
  [6957] = {.lex_state = 11, .external_lex_state = 45},
  [6958] = {.lex_state = 11, .external_lex_state = 46},
  [6959] = {.lex_state = 11, .external_lex_state = 44},
  [6960] = {.lex_state = 11, .external_lex_state = 46},
  [6961] = {.lex_state = 11, .external_lex_state = 46},
  [6962] = {.lex_state = 11, .external_lex_state = 45},
  [6963] = {.lex_state = 11, .external_lex_state = 46},
  [6964] = {.lex_state = 11, .external_lex_state = 46},
  [6965] = {.lex_state = 11, .external_lex_state = 46},
  [6966] = {.lex_state = 11, .external_lex_state = 45},
  [6967] = {.lex_state = 11, .external_lex_state = 46},
  [6968] = {.lex_state = 11, .external_lex_state = 46},
  [6969] = {.lex_state = 11, .external_lex_state = 46},
  [6970] = {.lex_state = 11, .external_lex_state = 46},
  [6971] = {.lex_state = 11, .external_lex_state = 46},
  [6972] = {.lex_state = 11, .external_lex_state = 46},
  [6973] = {.lex_state = 8, .external_lex_state = 150},
  [6974] = {.lex_state = 11, .external_lex_state = 46},
  [6975] = {.lex_state = 11, .external_lex_state = 46},
  [6976] = {.lex_state = 11, .external_lex_state = 46},
  [6977] = {.lex_state = 11, .external_lex_state = 46},
  [6978] = {.lex_state = 11, .external_lex_state = 44},
  [6979] = {.lex_state = 8, .external_lex_state = 150},
  [6980] = {.lex_state = 11, .external_lex_state = 46},
  [6981] = {.lex_state = 11, .external_lex_state = 46},
  [6982] = {.lex_state = 11, .external_lex_state = 46},
  [6983] = {.lex_state = 8, .external_lex_state = 55},
  [6984] = {.lex_state = 11, .external_lex_state = 46},
  [6985] = {.lex_state = 11, .external_lex_state = 46},
  [6986] = {.lex_state = 11, .external_lex_state = 45},
  [6987] = {.lex_state = 11, .external_lex_state = 45},
  [6988] = {.lex_state = 11, .external_lex_state = 45},
  [6989] = {.lex_state = 11, .external_lex_state = 45},
  [6990] = {.lex_state = 11, .external_lex_state = 45},
  [6991] = {.lex_state = 11, .external_lex_state = 45},
  [6992] = {.lex_state = 11, .external_lex_state = 45},
  [6993] = {.lex_state = 11, .external_lex_state = 45},
  [6994] = {.lex_state = 11, .external_lex_state = 45},
  [6995] = {.lex_state = 11, .external_lex_state = 45},
  [6996] = {.lex_state = 11, .external_lex_state = 45},
  [6997] = {.lex_state = 11, .external_lex_state = 45},
  [6998] = {.lex_state = 8, .external_lex_state = 150},
  [6999] = {.lex_state = 11, .external_lex_state = 45},
  [7000] = {.lex_state = 11, .external_lex_state = 45},
  [7001] = {.lex_state = 11, .external_lex_state = 45},
  [7002] = {.lex_state = 11, .external_lex_state = 45},
  [7003] = {.lex_state = 11, .external_lex_state = 45},
  [7004] = {.lex_state = 11, .external_lex_state = 45},
  [7005] = {.lex_state = 11, .external_lex_state = 45},
  [7006] = {.lex_state = 11, .external_lex_state = 45},
  [7007] = {.lex_state = 11, .external_lex_state = 45},
  [7008] = {.lex_state = 11, .external_lex_state = 44},
  [7009] = {.lex_state = 11, .external_lex_state = 45},
  [7010] = {.lex_state = 11, .external_lex_state = 45},
  [7011] = {.lex_state = 11, .external_lex_state = 46},
  [7012] = {.lex_state = 11, .external_lex_state = 45},
  [7013] = {.lex_state = 11, .external_lex_state = 45},
  [7014] = {.lex_state = 11, .external_lex_state = 45},
  [7015] = {.lex_state = 1, .external_lex_state = 11},
  [7016] = {.lex_state = 11, .external_lex_state = 45},
  [7017] = {.lex_state = 8, .external_lex_state = 55},
  [7018] = {.lex_state = 11, .external_lex_state = 46},
  [7019] = {.lex_state = 11, .external_lex_state = 45},
  [7020] = {.lex_state = 8, .external_lex_state = 47},
  [7021] = {.lex_state = 8, .external_lex_state = 47},
  [7022] = {.lex_state = 11, .external_lex_state = 48},
  [7023] = {.lex_state = 11, .external_lex_state = 48},
  [7024] = {.lex_state = 11, .external_lex_state = 48},
  [7025] = {.lex_state = 8, .external_lex_state = 47},
  [7026] = {.lex_state = 11, .external_lex_state = 48},
  [7027] = {.lex_state = 11, .external_lex_state = 48},
  [7028] = {.lex_state = 8, .external_lex_state = 47},
  [7029] = {.lex_state = 11, .external_lex_state = 48},
  [7030] = {.lex_state = 11, .external_lex_state = 48},
  [7031] = {.lex_state = 8, .external_lex_state = 47},
  [7032] = {.lex_state = 8, .external_lex_state = 47},
  [7033] = {.lex_state = 11, .external_lex_state = 48},
  [7034] = {.lex_state = 11, .external_lex_state = 48},
  [7035] = {.lex_state = 8, .external_lex_state = 47},
  [7036] = {.lex_state = 11, .external_lex_state = 48},
  [7037] = {.lex_state = 8, .external_lex_state = 47},
  [7038] = {.lex_state = 8, .external_lex_state = 47},
  [7039] = {.lex_state = 8, .external_lex_state = 151},
  [7040] = {.lex_state = 3, .external_lex_state = 59},
  [7041] = {.lex_state = 3, .external_lex_state = 59},
  [7042] = {.lex_state = 3, .external_lex_state = 59},
  [7043] = {.lex_state = 3, .external_lex_state = 59},
  [7044] = {.lex_state = 3, .external_lex_state = 59},
  [7045] = {.lex_state = 3, .external_lex_state = 59},
  [7046] = {.lex_state = 3, .external_lex_state = 59},
  [7047] = {.lex_state = 3, .external_lex_state = 59},
  [7048] = {.lex_state = 3, .external_lex_state = 59},
  [7049] = {.lex_state = 3, .external_lex_state = 59},
  [7050] = {.lex_state = 3, .external_lex_state = 59},
  [7051] = {.lex_state = 3, .external_lex_state = 59},
  [7052] = {.lex_state = 3, .external_lex_state = 59},
  [7053] = {.lex_state = 3, .external_lex_state = 59},
  [7054] = {.lex_state = 3, .external_lex_state = 152},
  [7055] = {.lex_state = 8, .external_lex_state = 47},
  [7056] = {.lex_state = 8, .external_lex_state = 47},
  [7057] = {.lex_state = 3, .external_lex_state = 59},
  [7058] = {.lex_state = 3, .external_lex_state = 59},
  [7059] = {.lex_state = 3, .external_lex_state = 59},
  [7060] = {.lex_state = 8, .external_lex_state = 47},
  [7061] = {.lex_state = 8, .external_lex_state = 47},
  [7062] = {.lex_state = 3, .external_lex_state = 59},
  [7063] = {.lex_state = 8, .external_lex_state = 47},
  [7064] = {.lex_state = 3, .external_lex_state = 59},
  [7065] = {.lex_state = 3, .external_lex_state = 59},
  [7066] = {.lex_state = 3, .external_lex_state = 59},
  [7067] = {.lex_state = 3, .external_lex_state = 59},
  [7068] = {.lex_state = 3, .external_lex_state = 59},
  [7069] = {.lex_state = 8, .external_lex_state = 47},
  [7070] = {.lex_state = 3, .external_lex_state = 59},
  [7071] = {.lex_state = 8, .external_lex_state = 47},
  [7072] = {.lex_state = 11, .external_lex_state = 48},
  [7073] = {.lex_state = 8, .external_lex_state = 47},
  [7074] = {.lex_state = 8, .external_lex_state = 47},
  [7075] = {.lex_state = 3, .external_lex_state = 59},
  [7076] = {.lex_state = 3, .external_lex_state = 59},
  [7077] = {.lex_state = 3, .external_lex_state = 59},
  [7078] = {.lex_state = 3, .external_lex_state = 59},
  [7079] = {.lex_state = 11, .external_lex_state = 48},
  [7080] = {.lex_state = 8, .external_lex_state = 47},
  [7081] = {.lex_state = 3, .external_lex_state = 59},
  [7082] = {.lex_state = 3, .external_lex_state = 59},
  [7083] = {.lex_state = 8, .external_lex_state = 47},
  [7084] = {.lex_state = 11, .external_lex_state = 48},
  [7085] = {.lex_state = 0, .external_lex_state = 153},
  [7086] = {.lex_state = 11, .external_lex_state = 48},
  [7087] = {.lex_state = 8, .external_lex_state = 47},
  [7088] = {.lex_state = 8, .external_lex_state = 47},
  [7089] = {.lex_state = 11, .external_lex_state = 48},
  [7090] = {.lex_state = 3, .external_lex_state = 59},
  [7091] = {.lex_state = 3, .external_lex_state = 59},
  [7092] = {.lex_state = 3, .external_lex_state = 59},
  [7093] = {.lex_state = 8, .external_lex_state = 47},
  [7094] = {.lex_state = 3, .external_lex_state = 59},
  [7095] = {.lex_state = 8, .external_lex_state = 47},
  [7096] = {.lex_state = 8, .external_lex_state = 47},
  [7097] = {.lex_state = 11, .external_lex_state = 48},
  [7098] = {.lex_state = 3, .external_lex_state = 59},
  [7099] = {.lex_state = 0, .external_lex_state = 153},
  [7100] = {.lex_state = 8, .external_lex_state = 151},
  [7101] = {.lex_state = 3, .external_lex_state = 59},
  [7102] = {.lex_state = 3, .external_lex_state = 59},
  [7103] = {.lex_state = 3, .external_lex_state = 59},
  [7104] = {.lex_state = 3, .external_lex_state = 59},
  [7105] = {.lex_state = 0, .external_lex_state = 154},
  [7106] = {.lex_state = 0, .external_lex_state = 153},
  [7107] = {.lex_state = 3, .external_lex_state = 59},
  [7108] = {.lex_state = 3, .external_lex_state = 59},
  [7109] = {.lex_state = 8, .external_lex_state = 47},
  [7110] = {.lex_state = 3, .external_lex_state = 59},
  [7111] = {.lex_state = 11, .external_lex_state = 48},
  [7112] = {.lex_state = 8, .external_lex_state = 47},
  [7113] = {.lex_state = 3, .external_lex_state = 59},
  [7114] = {.lex_state = 8, .external_lex_state = 47},
  [7115] = {.lex_state = 11, .external_lex_state = 48},
  [7116] = {.lex_state = 3, .external_lex_state = 49},
  [7117] = {.lex_state = 0, .external_lex_state = 153},
  [7118] = {.lex_state = 8, .external_lex_state = 151},
  [7119] = {.lex_state = 3, .external_lex_state = 152},
  [7120] = {.lex_state = 3, .external_lex_state = 59},
  [7121] = {.lex_state = 8, .external_lex_state = 47},
  [7122] = {.lex_state = 8, .external_lex_state = 47},
  [7123] = {.lex_state = 8, .external_lex_state = 47},
  [7124] = {.lex_state = 8, .external_lex_state = 47},
  [7125] = {.lex_state = 8, .external_lex_state = 47},
  [7126] = {.lex_state = 8, .external_lex_state = 47},
  [7127] = {.lex_state = 8, .external_lex_state = 47},
  [7128] = {.lex_state = 8, .external_lex_state = 47},
  [7129] = {.lex_state = 8, .external_lex_state = 47},
  [7130] = {.lex_state = 8, .external_lex_state = 47},
  [7131] = {.lex_state = 8, .external_lex_state = 47},
  [7132] = {.lex_state = 8, .external_lex_state = 47},
  [7133] = {.lex_state = 8, .external_lex_state = 47},
  [7134] = {.lex_state = 11, .external_lex_state = 48},
  [7135] = {.lex_state = 8, .external_lex_state = 47},
  [7136] = {.lex_state = 11, .external_lex_state = 48},
  [7137] = {.lex_state = 8, .external_lex_state = 47},
  [7138] = {.lex_state = 8, .external_lex_state = 47},
  [7139] = {.lex_state = 11, .external_lex_state = 48},
  [7140] = {.lex_state = 11, .external_lex_state = 48},
  [7141] = {.lex_state = 3, .external_lex_state = 59},
  [7142] = {.lex_state = 11, .external_lex_state = 48},
  [7143] = {.lex_state = 11, .external_lex_state = 48},
  [7144] = {.lex_state = 11, .external_lex_state = 48},
  [7145] = {.lex_state = 11, .external_lex_state = 48},
  [7146] = {.lex_state = 11, .external_lex_state = 48},
  [7147] = {.lex_state = 11, .external_lex_state = 48},
  [7148] = {.lex_state = 11, .external_lex_state = 48},
  [7149] = {.lex_state = 11, .external_lex_state = 48},
  [7150] = {.lex_state = 11, .external_lex_state = 48},
  [7151] = {.lex_state = 11, .external_lex_state = 48},
  [7152] = {.lex_state = 8, .external_lex_state = 47},
  [7153] = {.lex_state = 3, .external_lex_state = 59},
  [7154] = {.lex_state = 11, .external_lex_state = 48},
  [7155] = {.lex_state = 8, .external_lex_state = 47},
  [7156] = {.lex_state = 11, .external_lex_state = 48},
  [7157] = {.lex_state = 11, .external_lex_state = 48},
  [7158] = {.lex_state = 0, .external_lex_state = 153},
  [7159] = {.lex_state = 8, .external_lex_state = 47},
  [7160] = {.lex_state = 8, .external_lex_state = 47},
  [7161] = {.lex_state = 11, .external_lex_state = 48},
  [7162] = {.lex_state = 11, .external_lex_state = 48},
  [7163] = {.lex_state = 11, .external_lex_state = 48},
  [7164] = {.lex_state = 11, .external_lex_state = 48},
  [7165] = {.lex_state = 0, .external_lex_state = 153},
  [7166] = {.lex_state = 3, .external_lex_state = 59},
  [7167] = {.lex_state = 11, .external_lex_state = 48},
  [7168] = {.lex_state = 11, .external_lex_state = 48},
  [7169] = {.lex_state = 1, .external_lex_state = 131},
  [7170] = {.lex_state = 11, .external_lex_state = 48},
  [7171] = {.lex_state = 11, .external_lex_state = 48},
  [7172] = {.lex_state = 3, .external_lex_state = 59},
  [7173] = {.lex_state = 11, .external_lex_state = 48},
  [7174] = {.lex_state = 8, .external_lex_state = 47},
  [7175] = {.lex_state = 3, .external_lex_state = 59},
  [7176] = {.lex_state = 11, .external_lex_state = 48},
  [7177] = {.lex_state = 11, .external_lex_state = 48},
  [7178] = {.lex_state = 8, .external_lex_state = 151},
  [7179] = {.lex_state = 3, .external_lex_state = 59},
  [7180] = {.lex_state = 11, .external_lex_state = 48},
  [7181] = {.lex_state = 8, .external_lex_state = 151},
  [7182] = {.lex_state = 8, .external_lex_state = 47},
  [7183] = {.lex_state = 3, .external_lex_state = 59},
  [7184] = {.lex_state = 3, .external_lex_state = 59},
  [7185] = {.lex_state = 3, .external_lex_state = 59},
  [7186] = {.lex_state = 3, .external_lex_state = 59},
  [7187] = {.lex_state = 11, .external_lex_state = 48},
  [7188] = {.lex_state = 11, .external_lex_state = 48},
  [7189] = {.lex_state = 3, .external_lex_state = 59},
  [7190] = {.lex_state = 3, .external_lex_state = 59},
  [7191] = {.lex_state = 11, .external_lex_state = 48},
  [7192] = {.lex_state = 3, .external_lex_state = 59},
  [7193] = {.lex_state = 11, .external_lex_state = 48},
  [7194] = {.lex_state = 3, .external_lex_state = 59},
  [7195] = {.lex_state = 11, .external_lex_state = 48},
  [7196] = {.lex_state = 8, .external_lex_state = 47},
  [7197] = {.lex_state = 8, .external_lex_state = 151},
  [7198] = {.lex_state = 8, .external_lex_state = 151},
  [7199] = {.lex_state = 3, .external_lex_state = 59},
  [7200] = {.lex_state = 8, .external_lex_state = 47},
  [7201] = {.lex_state = 8, .external_lex_state = 151},
  [7202] = {.lex_state = 8, .external_lex_state = 151},
  [7203] = {.lex_state = 8, .external_lex_state = 50},
  [7204] = {.lex_state = 4, .external_lex_state = 60},
  [7205] = {.lex_state = 8, .external_lex_state = 51},
  [7206] = {.lex_state = 8, .external_lex_state = 50},
  [7207] = {.lex_state = 8, .external_lex_state = 50},
  [7208] = {.lex_state = 3, .external_lex_state = 155},
  [7209] = {.lex_state = 8, .external_lex_state = 50},
  [7210] = {.lex_state = 8, .external_lex_state = 50},
  [7211] = {.lex_state = 3, .external_lex_state = 155},
  [7212] = {.lex_state = 8, .external_lex_state = 51},
  [7213] = {.lex_state = 3, .external_lex_state = 155},
  [7214] = {.lex_state = 9, .external_lex_state = 52},
  [7215] = {.lex_state = 8, .external_lex_state = 51},
  [7216] = {.lex_state = 8, .external_lex_state = 51},
  [7217] = {.lex_state = 3, .external_lex_state = 155},
  [7218] = {.lex_state = 9, .external_lex_state = 52},
  [7219] = {.lex_state = 9, .external_lex_state = 52},
  [7220] = {.lex_state = 9, .external_lex_state = 52},
  [7221] = {.lex_state = 3, .external_lex_state = 155},
  [7222] = {.lex_state = 9, .external_lex_state = 52},
  [7223] = {.lex_state = 8, .external_lex_state = 51},
  [7224] = {.lex_state = 8, .external_lex_state = 50},
  [7225] = {.lex_state = 8, .external_lex_state = 50},
  [7226] = {.lex_state = 8, .external_lex_state = 50},
  [7227] = {.lex_state = 3, .external_lex_state = 155},
  [7228] = {.lex_state = 8, .external_lex_state = 50},
  [7229] = {.lex_state = 9, .external_lex_state = 52},
  [7230] = {.lex_state = 9, .external_lex_state = 52},
  [7231] = {.lex_state = 3, .external_lex_state = 155},
  [7232] = {.lex_state = 9, .external_lex_state = 52},
  [7233] = {.lex_state = 9, .external_lex_state = 52},
  [7234] = {.lex_state = 8, .external_lex_state = 50},
  [7235] = {.lex_state = 8, .external_lex_state = 50},
  [7236] = {.lex_state = 4, .external_lex_state = 60},
  [7237] = {.lex_state = 8, .external_lex_state = 50},
  [7238] = {.lex_state = 4, .external_lex_state = 60},
  [7239] = {.lex_state = 8, .external_lex_state = 50},
  [7240] = {.lex_state = 8, .external_lex_state = 51},
  [7241] = {.lex_state = 4, .external_lex_state = 60},
  [7242] = {.lex_state = 8, .external_lex_state = 50},
  [7243] = {.lex_state = 8, .external_lex_state = 50},
  [7244] = {.lex_state = 4, .external_lex_state = 60},
  [7245] = {.lex_state = 9, .external_lex_state = 52},
  [7246] = {.lex_state = 8, .external_lex_state = 50},
  [7247] = {.lex_state = 8, .external_lex_state = 50},
  [7248] = {.lex_state = 4, .external_lex_state = 60},
  [7249] = {.lex_state = 8, .external_lex_state = 50},
  [7250] = {.lex_state = 3, .external_lex_state = 155},
  [7251] = {.lex_state = 8, .external_lex_state = 50},
  [7252] = {.lex_state = 8, .external_lex_state = 50},
  [7253] = {.lex_state = 8, .external_lex_state = 50},
  [7254] = {.lex_state = 3, .external_lex_state = 155},
  [7255] = {.lex_state = 9, .external_lex_state = 52},
  [7256] = {.lex_state = 8, .external_lex_state = 51},
  [7257] = {.lex_state = 8, .external_lex_state = 50},
  [7258] = {.lex_state = 8, .external_lex_state = 50},
  [7259] = {.lex_state = 8, .external_lex_state = 50},
  [7260] = {.lex_state = 3, .external_lex_state = 155},
  [7261] = {.lex_state = 8, .external_lex_state = 50},
  [7262] = {.lex_state = 8, .external_lex_state = 50},
  [7263] = {.lex_state = 3, .external_lex_state = 155},
  [7264] = {.lex_state = 8, .external_lex_state = 156},
  [7265] = {.lex_state = 8, .external_lex_state = 51},
  [7266] = {.lex_state = 3, .external_lex_state = 155},
  [7267] = {.lex_state = 8, .external_lex_state = 51},
  [7268] = {.lex_state = 8, .external_lex_state = 50},
  [7269] = {.lex_state = 8, .external_lex_state = 50},
  [7270] = {.lex_state = 3, .external_lex_state = 155},
  [7271] = {.lex_state = 4, .external_lex_state = 60},
  [7272] = {.lex_state = 3, .external_lex_state = 155},
  [7273] = {.lex_state = 8, .external_lex_state = 50},
  [7274] = {.lex_state = 8, .external_lex_state = 51},
  [7275] = {.lex_state = 8, .external_lex_state = 51},
  [7276] = {.lex_state = 4, .external_lex_state = 60},
  [7277] = {.lex_state = 8, .external_lex_state = 51},
  [7278] = {.lex_state = 8, .external_lex_state = 156},
  [7279] = {.lex_state = 3, .external_lex_state = 155},
  [7280] = {.lex_state = 4, .external_lex_state = 60},
  [7281] = {.lex_state = 4, .external_lex_state = 60},
  [7282] = {.lex_state = 4, .external_lex_state = 60},
  [7283] = {.lex_state = 8, .external_lex_state = 156},
  [7284] = {.lex_state = 8, .external_lex_state = 50},
  [7285] = {.lex_state = 8, .external_lex_state = 50},
  [7286] = {.lex_state = 4, .external_lex_state = 60},
  [7287] = {.lex_state = 4, .external_lex_state = 60},
  [7288] = {.lex_state = 4, .external_lex_state = 60},
  [7289] = {.lex_state = 3, .external_lex_state = 155},
  [7290] = {.lex_state = 9, .external_lex_state = 52},
  [7291] = {.lex_state = 4, .external_lex_state = 60},
  [7292] = {.lex_state = 3, .external_lex_state = 155},
  [7293] = {.lex_state = 3, .external_lex_state = 155},
  [7294] = {.lex_state = 8, .external_lex_state = 50},
  [7295] = {.lex_state = 4, .external_lex_state = 60},
  [7296] = {.lex_state = 4, .external_lex_state = 60},
  [7297] = {.lex_state = 9, .external_lex_state = 52},
  [7298] = {.lex_state = 4, .external_lex_state = 60},
  [7299] = {.lex_state = 9, .external_lex_state = 52},
  [7300] = {.lex_state = 9, .external_lex_state = 52},
  [7301] = {.lex_state = 4, .external_lex_state = 60},
  [7302] = {.lex_state = 9, .external_lex_state = 52},
  [7303] = {.lex_state = 3, .external_lex_state = 155},
  [7304] = {.lex_state = 8, .external_lex_state = 50},
  [7305] = {.lex_state = 9, .external_lex_state = 52},
  [7306] = {.lex_state = 3, .external_lex_state = 155},
  [7307] = {.lex_state = 8, .external_lex_state = 50},
  [7308] = {.lex_state = 9, .external_lex_state = 52},
  [7309] = {.lex_state = 8, .external_lex_state = 51},
  [7310] = {.lex_state = 3, .external_lex_state = 155},
  [7311] = {.lex_state = 3, .external_lex_state = 155},
  [7312] = {.lex_state = 8, .external_lex_state = 51},
  [7313] = {.lex_state = 3, .external_lex_state = 155},
  [7314] = {.lex_state = 4, .external_lex_state = 60},
  [7315] = {.lex_state = 9, .external_lex_state = 52},
  [7316] = {.lex_state = 9, .external_lex_state = 52},
  [7317] = {.lex_state = 3, .external_lex_state = 155},
  [7318] = {.lex_state = 9, .external_lex_state = 52},
  [7319] = {.lex_state = 4, .external_lex_state = 60},
  [7320] = {.lex_state = 9, .external_lex_state = 52},
  [7321] = {.lex_state = 4, .external_lex_state = 60},
  [7322] = {.lex_state = 3, .external_lex_state = 155},
  [7323] = {.lex_state = 3, .external_lex_state = 155},
  [7324] = {.lex_state = 4, .external_lex_state = 60},
  [7325] = {.lex_state = 4, .external_lex_state = 60},
  [7326] = {.lex_state = 4, .external_lex_state = 60},
  [7327] = {.lex_state = 4, .external_lex_state = 60},
  [7328] = {.lex_state = 3, .external_lex_state = 155},
  [7329] = {.lex_state = 4, .external_lex_state = 60},
  [7330] = {.lex_state = 9, .external_lex_state = 52},
  [7331] = {.lex_state = 9, .external_lex_state = 52},
  [7332] = {.lex_state = 4, .external_lex_state = 60},
  [7333] = {.lex_state = 9, .external_lex_state = 52},
  [7334] = {.lex_state = 3, .external_lex_state = 155},
  [7335] = {.lex_state = 4, .external_lex_state = 60},
  [7336] = {.lex_state = 8, .external_lex_state = 156},
  [7337] = {.lex_state = 4, .external_lex_state = 60},
  [7338] = {.lex_state = 9, .external_lex_state = 52},
  [7339] = {.lex_state = 9, .external_lex_state = 52},
  [7340] = {.lex_state = 8, .external_lex_state = 50},
  [7341] = {.lex_state = 4, .external_lex_state = 60},
  [7342] = {.lex_state = 4, .external_lex_state = 60},
  [7343] = {.lex_state = 3, .external_lex_state = 155},
  [7344] = {.lex_state = 4, .external_lex_state = 60},
  [7345] = {.lex_state = 3, .external_lex_state = 155},
  [7346] = {.lex_state = 3, .external_lex_state = 155},
  [7347] = {.lex_state = 3, .external_lex_state = 155},
  [7348] = {.lex_state = 8, .external_lex_state = 51},
  [7349] = {.lex_state = 8, .external_lex_state = 50},
  [7350] = {.lex_state = 3, .external_lex_state = 155},
  [7351] = {.lex_state = 8, .external_lex_state = 50},
  [7352] = {.lex_state = 9, .external_lex_state = 52},
  [7353] = {.lex_state = 9, .external_lex_state = 52},
  [7354] = {.lex_state = 9, .external_lex_state = 52},
  [7355] = {.lex_state = 9, .external_lex_state = 52},
  [7356] = {.lex_state = 8, .external_lex_state = 51},
  [7357] = {.lex_state = 3, .external_lex_state = 155},
  [7358] = {.lex_state = 4, .external_lex_state = 60},
  [7359] = {.lex_state = 9, .external_lex_state = 52},
  [7360] = {.lex_state = 8, .external_lex_state = 50},
  [7361] = {.lex_state = 9, .external_lex_state = 52},
  [7362] = {.lex_state = 4, .external_lex_state = 60},
  [7363] = {.lex_state = 9, .external_lex_state = 52},
  [7364] = {.lex_state = 3, .external_lex_state = 155},
  [7365] = {.lex_state = 9, .external_lex_state = 52},
  [7366] = {.lex_state = 9, .external_lex_state = 52},
  [7367] = {.lex_state = 4, .external_lex_state = 60},
  [7368] = {.lex_state = 9, .external_lex_state = 52},
  [7369] = {.lex_state = 3, .external_lex_state = 155},
  [7370] = {.lex_state = 8, .external_lex_state = 51},
  [7371] = {.lex_state = 4, .external_lex_state = 60},
  [7372] = {.lex_state = 8, .external_lex_state = 51},
  [7373] = {.lex_state = 4, .external_lex_state = 60},
  [7374] = {.lex_state = 8, .external_lex_state = 50},
  [7375] = {.lex_state = 4, .external_lex_state = 60},
  [7376] = {.lex_state = 9, .external_lex_state = 52},
  [7377] = {.lex_state = 8, .external_lex_state = 51},
  [7378] = {.lex_state = 3, .external_lex_state = 155},
  [7379] = {.lex_state = 4, .external_lex_state = 60},
  [7380] = {.lex_state = 8, .external_lex_state = 156},
  [7381] = {.lex_state = 8, .external_lex_state = 51},
  [7382] = {.lex_state = 8, .external_lex_state = 50},
  [7383] = {.lex_state = 9, .external_lex_state = 52},
  [7384] = {.lex_state = 9, .external_lex_state = 52},
  [7385] = {.lex_state = 3, .external_lex_state = 155},
  [7386] = {.lex_state = 3, .external_lex_state = 155},
  [7387] = {.lex_state = 4, .external_lex_state = 60},
  [7388] = {.lex_state = 9, .external_lex_state = 52},
  [7389] = {.lex_state = 8, .external_lex_state = 156},
  [7390] = {.lex_state = 3, .external_lex_state = 155},
  [7391] = {.lex_state = 4, .external_lex_state = 60},
  [7392] = {.lex_state = 4, .external_lex_state = 60},
  [7393] = {.lex_state = 9, .external_lex_state = 52},
  [7394] = {.lex_state = 8, .external_lex_state = 51},
  [7395] = {.lex_state = 4, .external_lex_state = 60},
  [7396] = {.lex_state = 3, .external_lex_state = 155},
  [7397] = {.lex_state = 8, .external_lex_state = 50},
  [7398] = {.lex_state = 4, .external_lex_state = 60},
  [7399] = {.lex_state = 9, .external_lex_state = 52},
  [7400] = {.lex_state = 8, .external_lex_state = 50},
  [7401] = {.lex_state = 3, .external_lex_state = 155},
  [7402] = {.lex_state = 4, .external_lex_state = 60},
  [7403] = {.lex_state = 8, .external_lex_state = 51},
  [7404] = {.lex_state = 8, .external_lex_state = 51},
  [7405] = {.lex_state = 8, .external_lex_state = 51},
  [7406] = {.lex_state = 8, .external_lex_state = 50},
  [7407] = {.lex_state = 3, .external_lex_state = 155},
  [7408] = {.lex_state = 8, .external_lex_state = 50},
  [7409] = {.lex_state = 9, .external_lex_state = 52},
  [7410] = {.lex_state = 9, .external_lex_state = 52},
  [7411] = {.lex_state = 3, .external_lex_state = 155},
  [7412] = {.lex_state = 4, .external_lex_state = 60},
  [7413] = {.lex_state = 9, .external_lex_state = 52},
  [7414] = {.lex_state = 8, .external_lex_state = 51},
  [7415] = {.lex_state = 8, .external_lex_state = 51},
  [7416] = {.lex_state = 8, .external_lex_state = 51},
  [7417] = {.lex_state = 8, .external_lex_state = 51},
  [7418] = {.lex_state = 8, .external_lex_state = 51},
  [7419] = {.lex_state = 8, .external_lex_state = 50},
  [7420] = {.lex_state = 9, .external_lex_state = 52},
  [7421] = {.lex_state = 3, .external_lex_state = 155},
  [7422] = {.lex_state = 3, .external_lex_state = 155},
  [7423] = {.lex_state = 8, .external_lex_state = 50},
  [7424] = {.lex_state = 8, .external_lex_state = 51},
  [7425] = {.lex_state = 9, .external_lex_state = 52},
  [7426] = {.lex_state = 8, .external_lex_state = 51},
  [7427] = {.lex_state = 8, .external_lex_state = 51},
  [7428] = {.lex_state = 8, .external_lex_state = 51},
  [7429] = {.lex_state = 8, .external_lex_state = 51},
  [7430] = {.lex_state = 3, .external_lex_state = 155},
  [7431] = {.lex_state = 4, .external_lex_state = 60},
  [7432] = {.lex_state = 4, .external_lex_state = 60},
  [7433] = {.lex_state = 8, .external_lex_state = 51},
  [7434] = {.lex_state = 8, .external_lex_state = 51},
  [7435] = {.lex_state = 8, .external_lex_state = 51},
  [7436] = {.lex_state = 9, .external_lex_state = 52},
  [7437] = {.lex_state = 8, .external_lex_state = 50},
  [7438] = {.lex_state = 8, .external_lex_state = 51},
  [7439] = {.lex_state = 9, .external_lex_state = 52},
  [7440] = {.lex_state = 3, .external_lex_state = 155},
  [7441] = {.lex_state = 4, .external_lex_state = 60},
  [7442] = {.lex_state = 4, .external_lex_state = 60},
  [7443] = {.lex_state = 8, .external_lex_state = 156},
  [7444] = {.lex_state = 4, .external_lex_state = 60},
  [7445] = {.lex_state = 8, .external_lex_state = 51},
  [7446] = {.lex_state = 8, .external_lex_state = 51},
  [7447] = {.lex_state = 4, .external_lex_state = 60},
  [7448] = {.lex_state = 8, .external_lex_state = 51},
  [7449] = {.lex_state = 3, .external_lex_state = 155},
  [7450] = {.lex_state = 8, .external_lex_state = 50},
  [7451] = {.lex_state = 8, .external_lex_state = 50},
  [7452] = {.lex_state = 8, .external_lex_state = 51},
  [7453] = {.lex_state = 4, .external_lex_state = 60},
  [7454] = {.lex_state = 8, .external_lex_state = 51},
  [7455] = {.lex_state = 9, .external_lex_state = 52},
  [7456] = {.lex_state = 3, .external_lex_state = 155},
  [7457] = {.lex_state = 3, .external_lex_state = 155},
  [7458] = {.lex_state = 8, .external_lex_state = 51},
  [7459] = {.lex_state = 8, .external_lex_state = 156},
  [7460] = {.lex_state = 3, .external_lex_state = 155},
  [7461] = {.lex_state = 8, .external_lex_state = 50},
  [7462] = {.lex_state = 8, .external_lex_state = 51},
  [7463] = {.lex_state = 8, .external_lex_state = 51},
  [7464] = {.lex_state = 8, .external_lex_state = 50},
  [7465] = {.lex_state = 8, .external_lex_state = 51},
  [7466] = {.lex_state = 8, .external_lex_state = 50},
  [7467] = {.lex_state = 3, .external_lex_state = 155},
  [7468] = {.lex_state = 4, .external_lex_state = 60},
  [7469] = {.lex_state = 3, .external_lex_state = 155},
  [7470] = {.lex_state = 8, .external_lex_state = 51},
  [7471] = {.lex_state = 3, .external_lex_state = 155},
  [7472] = {.lex_state = 8, .external_lex_state = 156},
  [7473] = {.lex_state = 8, .external_lex_state = 51},
  [7474] = {.lex_state = 3, .external_lex_state = 155},
  [7475] = {.lex_state = 4, .external_lex_state = 60},
  [7476] = {.lex_state = 8, .external_lex_state = 51},
  [7477] = {.lex_state = 9, .external_lex_state = 52},
  [7478] = {.lex_state = 3, .external_lex_state = 155},
  [7479] = {.lex_state = 3, .external_lex_state = 155},
  [7480] = {.lex_state = 3, .external_lex_state = 155},
  [7481] = {.lex_state = 8, .external_lex_state = 51},
  [7482] = {.lex_state = 8, .external_lex_state = 51},
  [7483] = {.lex_state = 4, .external_lex_state = 60},
  [7484] = {.lex_state = 4, .external_lex_state = 60},
  [7485] = {.lex_state = 4, .external_lex_state = 60},
  [7486] = {.lex_state = 3, .external_lex_state = 155},
  [7487] = {.lex_state = 0, .external_lex_state = 153},
  [7488] = {.lex_state = 8, .external_lex_state = 53},
  [7489] = {.lex_state = 8, .external_lex_state = 53},
  [7490] = {.lex_state = 8, .external_lex_state = 53},
  [7491] = {.lex_state = 8, .external_lex_state = 53},
  [7492] = {.lex_state = 8, .external_lex_state = 53},
  [7493] = {.lex_state = 0, .external_lex_state = 153},
  [7494] = {.lex_state = 8, .external_lex_state = 53},
  [7495] = {.lex_state = 8, .external_lex_state = 53},
  [7496] = {.lex_state = 8, .external_lex_state = 53},
  [7497] = {.lex_state = 8, .external_lex_state = 53},
  [7498] = {.lex_state = 8, .external_lex_state = 53},
  [7499] = {.lex_state = 0, .external_lex_state = 153},
  [7500] = {.lex_state = 8, .external_lex_state = 53},
  [7501] = {.lex_state = 8, .external_lex_state = 53},
  [7502] = {.lex_state = 8, .external_lex_state = 53},
  [7503] = {.lex_state = 8, .external_lex_state = 53},
  [7504] = {.lex_state = 0, .external_lex_state = 153},
  [7505] = {.lex_state = 8, .external_lex_state = 53},
  [7506] = {.lex_state = 8, .external_lex_state = 53},
  [7507] = {.lex_state = 16, .external_lex_state = 35},
  [7508] = {.lex_state = 0, .external_lex_state = 153},
  [7509] = {.lex_state = 8, .external_lex_state = 58},
  [7510] = {.lex_state = 8, .external_lex_state = 53},
  [7511] = {.lex_state = 8, .external_lex_state = 53},
  [7512] = {.lex_state = 8, .external_lex_state = 53},
  [7513] = {.lex_state = 8, .external_lex_state = 53},
  [7514] = {.lex_state = 8, .external_lex_state = 53},
  [7515] = {.lex_state = 8, .external_lex_state = 53},
  [7516] = {.lex_state = 8, .external_lex_state = 53},
  [7517] = {.lex_state = 8, .external_lex_state = 53},
  [7518] = {.lex_state = 8, .external_lex_state = 53},
  [7519] = {.lex_state = 8, .external_lex_state = 53},
  [7520] = {.lex_state = 8, .external_lex_state = 53},
  [7521] = {.lex_state = 0, .external_lex_state = 153},
  [7522] = {.lex_state = 8, .external_lex_state = 53},
  [7523] = {.lex_state = 8, .external_lex_state = 53},
  [7524] = {.lex_state = 8, .external_lex_state = 53},
  [7525] = {.lex_state = 8, .external_lex_state = 53},
  [7526] = {.lex_state = 8, .external_lex_state = 53},
  [7527] = {.lex_state = 8, .external_lex_state = 53},
  [7528] = {.lex_state = 8, .external_lex_state = 53},
  [7529] = {.lex_state = 1, .external_lex_state = 38},
  [7530] = {.lex_state = 8, .external_lex_state = 53},
  [7531] = {.lex_state = 0, .external_lex_state = 157},
  [7532] = {.lex_state = 0, .external_lex_state = 157},
  [7533] = {.lex_state = 8, .external_lex_state = 53},
  [7534] = {.lex_state = 8, .external_lex_state = 53},
  [7535] = {.lex_state = 8, .external_lex_state = 53},
  [7536] = {.lex_state = 8, .external_lex_state = 53},
  [7537] = {.lex_state = 8, .external_lex_state = 53},
  [7538] = {.lex_state = 8, .external_lex_state = 53},
  [7539] = {.lex_state = 8, .external_lex_state = 53},
  [7540] = {.lex_state = 8, .external_lex_state = 53},
  [7541] = {.lex_state = 8, .external_lex_state = 53},
  [7542] = {.lex_state = 8, .external_lex_state = 53},
  [7543] = {.lex_state = 3, .external_lex_state = 11},
  [7544] = {.lex_state = 8, .external_lex_state = 53},
  [7545] = {.lex_state = 8, .external_lex_state = 53},
  [7546] = {.lex_state = 8, .external_lex_state = 53},
  [7547] = {.lex_state = 8, .external_lex_state = 53},
  [7548] = {.lex_state = 8, .external_lex_state = 53},
  [7549] = {.lex_state = 8, .external_lex_state = 53},
  [7550] = {.lex_state = 8, .external_lex_state = 53},
  [7551] = {.lex_state = 8, .external_lex_state = 53},
  [7552] = {.lex_state = 8, .external_lex_state = 53},
  [7553] = {.lex_state = 8, .external_lex_state = 53},
  [7554] = {.lex_state = 8, .external_lex_state = 53},
  [7555] = {.lex_state = 8, .external_lex_state = 55},
  [7556] = {.lex_state = 8, .external_lex_state = 55},
  [7557] = {.lex_state = 0, .external_lex_state = 157},
  [7558] = {.lex_state = 0, .external_lex_state = 157},
  [7559] = {.lex_state = 8, .external_lex_state = 55},
  [7560] = {.lex_state = 8, .external_lex_state = 55},
  [7561] = {.lex_state = 8, .external_lex_state = 55},
  [7562] = {.lex_state = 8, .external_lex_state = 55},
  [7563] = {.lex_state = 8, .external_lex_state = 55},
  [7564] = {.lex_state = 8, .external_lex_state = 55},
  [7565] = {.lex_state = 8, .external_lex_state = 52},
  [7566] = {.lex_state = 8, .external_lex_state = 55},
  [7567] = {.lex_state = 8, .external_lex_state = 55},
  [7568] = {.lex_state = 8, .external_lex_state = 55},
  [7569] = {.lex_state = 8, .external_lex_state = 55},
  [7570] = {.lex_state = 0, .external_lex_state = 157},
  [7571] = {.lex_state = 8, .external_lex_state = 55},
  [7572] = {.lex_state = 8, .external_lex_state = 55},
  [7573] = {.lex_state = 8, .external_lex_state = 55},
  [7574] = {.lex_state = 8, .external_lex_state = 55},
  [7575] = {.lex_state = 0, .external_lex_state = 158},
  [7576] = {.lex_state = 8, .external_lex_state = 55},
  [7577] = {.lex_state = 8, .external_lex_state = 55},
  [7578] = {.lex_state = 8, .external_lex_state = 55},
  [7579] = {.lex_state = 8, .external_lex_state = 55},
  [7580] = {.lex_state = 8, .external_lex_state = 55},
  [7581] = {.lex_state = 8, .external_lex_state = 55},
  [7582] = {.lex_state = 8, .external_lex_state = 55},
  [7583] = {.lex_state = 8, .external_lex_state = 55},
  [7584] = {.lex_state = 8, .external_lex_state = 55},
  [7585] = {.lex_state = 8, .external_lex_state = 55},
  [7586] = {.lex_state = 8, .external_lex_state = 55},
  [7587] = {.lex_state = 8, .external_lex_state = 55},
  [7588] = {.lex_state = 0, .external_lex_state = 159},
  [7589] = {.lex_state = 8, .external_lex_state = 55},
  [7590] = {.lex_state = 8, .external_lex_state = 55},
  [7591] = {.lex_state = 8, .external_lex_state = 55},
  [7592] = {.lex_state = 8, .external_lex_state = 55},
  [7593] = {.lex_state = 8, .external_lex_state = 55},
  [7594] = {.lex_state = 8, .external_lex_state = 55},
  [7595] = {.lex_state = 8, .external_lex_state = 55},
  [7596] = {.lex_state = 3, .external_lex_state = 11},
  [7597] = {.lex_state = 8, .external_lex_state = 52},
  [7598] = {.lex_state = 8, .external_lex_state = 55},
  [7599] = {.lex_state = 0, .external_lex_state = 159},
  [7600] = {.lex_state = 8, .external_lex_state = 55},
  [7601] = {.lex_state = 8, .external_lex_state = 55},
  [7602] = {.lex_state = 8, .external_lex_state = 55},
  [7603] = {.lex_state = 8, .external_lex_state = 55},
  [7604] = {.lex_state = 8, .external_lex_state = 55},
  [7605] = {.lex_state = 0, .external_lex_state = 157},
  [7606] = {.lex_state = 8, .external_lex_state = 52},
  [7607] = {.lex_state = 8, .external_lex_state = 55},
  [7608] = {.lex_state = 0, .external_lex_state = 160},
  [7609] = {.lex_state = 8, .external_lex_state = 55},
  [7610] = {.lex_state = 8, .external_lex_state = 55},
  [7611] = {.lex_state = 8, .external_lex_state = 55},
  [7612] = {.lex_state = 8, .external_lex_state = 55},
  [7613] = {.lex_state = 8, .external_lex_state = 55},
  [7614] = {.lex_state = 8, .external_lex_state = 55},
  [7615] = {.lex_state = 8, .external_lex_state = 55},
  [7616] = {.lex_state = 8, .external_lex_state = 55},
  [7617] = {.lex_state = 8, .external_lex_state = 55},
  [7618] = {.lex_state = 8, .external_lex_state = 52},
  [7619] = {.lex_state = 8, .external_lex_state = 55},
  [7620] = {.lex_state = 8, .external_lex_state = 52},
  [7621] = {.lex_state = 8, .external_lex_state = 56},
  [7622] = {.lex_state = 8, .external_lex_state = 56},
  [7623] = {.lex_state = 8, .external_lex_state = 56},
  [7624] = {.lex_state = 3, .external_lex_state = 161},
  [7625] = {.lex_state = 3, .external_lex_state = 162},
  [7626] = {.lex_state = 8, .external_lex_state = 56},
  [7627] = {.lex_state = 8, .external_lex_state = 56},
  [7628] = {.lex_state = 8, .external_lex_state = 56},
  [7629] = {.lex_state = 8, .external_lex_state = 56},
  [7630] = {.lex_state = 8, .external_lex_state = 56},
  [7631] = {.lex_state = 3, .external_lex_state = 62},
  [7632] = {.lex_state = 8, .external_lex_state = 56},
  [7633] = {.lex_state = 3, .external_lex_state = 162},
  [7634] = {.lex_state = 3, .external_lex_state = 62},
  [7635] = {.lex_state = 3, .external_lex_state = 161},
  [7636] = {.lex_state = 8, .external_lex_state = 56},
  [7637] = {.lex_state = 8, .external_lex_state = 56},
  [7638] = {.lex_state = 8, .external_lex_state = 56},
  [7639] = {.lex_state = 3, .external_lex_state = 161},
  [7640] = {.lex_state = 1, .external_lex_state = 38},
  [7641] = {.lex_state = 3, .external_lex_state = 62},
  [7642] = {.lex_state = 8, .external_lex_state = 56},
  [7643] = {.lex_state = 3, .external_lex_state = 38},
  [7644] = {.lex_state = 8, .external_lex_state = 56},
  [7645] = {.lex_state = 8, .external_lex_state = 56},
  [7646] = {.lex_state = 8, .external_lex_state = 56},
  [7647] = {.lex_state = 0, .external_lex_state = 157},
  [7648] = {.lex_state = 8, .external_lex_state = 56},
  [7649] = {.lex_state = 3, .external_lex_state = 62},
  [7650] = {.lex_state = 8, .external_lex_state = 56},
  [7651] = {.lex_state = 8, .external_lex_state = 56},
  [7652] = {.lex_state = 8, .external_lex_state = 56},
  [7653] = {.lex_state = 8, .external_lex_state = 56},
  [7654] = {.lex_state = 4, .external_lex_state = 61},
  [7655] = {.lex_state = 8, .external_lex_state = 56},
  [7656] = {.lex_state = 8, .external_lex_state = 56},
  [7657] = {.lex_state = 8, .external_lex_state = 56},
  [7658] = {.lex_state = 1, .external_lex_state = 38},
  [7659] = {.lex_state = 8, .external_lex_state = 56},
  [7660] = {.lex_state = 8, .external_lex_state = 56},
  [7661] = {.lex_state = 8, .external_lex_state = 56},
  [7662] = {.lex_state = 3, .external_lex_state = 62},
  [7663] = {.lex_state = 3, .external_lex_state = 62},
  [7664] = {.lex_state = 8, .external_lex_state = 56},
  [7665] = {.lex_state = 8, .external_lex_state = 56},
  [7666] = {.lex_state = 8, .external_lex_state = 56},
  [7667] = {.lex_state = 3, .external_lex_state = 162},
  [7668] = {.lex_state = 8, .external_lex_state = 56},
  [7669] = {.lex_state = 3, .external_lex_state = 162},
  [7670] = {.lex_state = 8, .external_lex_state = 56},
  [7671] = {.lex_state = 3, .external_lex_state = 162},
  [7672] = {.lex_state = 8, .external_lex_state = 56},
  [7673] = {.lex_state = 3, .external_lex_state = 162},
  [7674] = {.lex_state = 3, .external_lex_state = 38},
  [7675] = {.lex_state = 8, .external_lex_state = 56},
  [7676] = {.lex_state = 8, .external_lex_state = 56},
  [7677] = {.lex_state = 8, .external_lex_state = 56},
  [7678] = {.lex_state = 8, .external_lex_state = 56},
  [7679] = {.lex_state = 8, .external_lex_state = 56},
  [7680] = {.lex_state = 8, .external_lex_state = 56},
  [7681] = {.lex_state = 8, .external_lex_state = 56},
  [7682] = {.lex_state = 8, .external_lex_state = 34},
  [7683] = {.lex_state = 8, .external_lex_state = 56},
  [7684] = {.lex_state = 3, .external_lex_state = 38},
  [7685] = {.lex_state = 3, .external_lex_state = 62},
  [7686] = {.lex_state = 8, .external_lex_state = 56},
  [7687] = {.lex_state = 8, .external_lex_state = 56},
  [7688] = {.lex_state = 3, .external_lex_state = 162},
  [7689] = {.lex_state = 3, .external_lex_state = 62},
  [7690] = {.lex_state = 8, .external_lex_state = 56},
  [7691] = {.lex_state = 3, .external_lex_state = 62},
  [7692] = {.lex_state = 3, .external_lex_state = 62},
  [7693] = {.lex_state = 3, .external_lex_state = 62},
  [7694] = {.lex_state = 3, .external_lex_state = 62},
  [7695] = {.lex_state = 8, .external_lex_state = 56},
  [7696] = {.lex_state = 8, .external_lex_state = 56},
  [7697] = {.lex_state = 3, .external_lex_state = 62},
  [7698] = {.lex_state = 3, .external_lex_state = 38},
  [7699] = {.lex_state = 8, .external_lex_state = 56},
  [7700] = {.lex_state = 3, .external_lex_state = 163},
  [7701] = {.lex_state = 3, .external_lex_state = 38},
  [7702] = {.lex_state = 3, .external_lex_state = 62},
  [7703] = {.lex_state = 8, .external_lex_state = 56},
  [7704] = {.lex_state = 8, .external_lex_state = 56},
  [7705] = {.lex_state = 8, .external_lex_state = 56},
  [7706] = {.lex_state = 3, .external_lex_state = 62},
  [7707] = {.lex_state = 0, .external_lex_state = 157},
  [7708] = {.lex_state = 3, .external_lex_state = 161},
  [7709] = {.lex_state = 3, .external_lex_state = 38},
  [7710] = {.lex_state = 3, .external_lex_state = 62},
  [7711] = {.lex_state = 8, .external_lex_state = 56},
  [7712] = {.lex_state = 4, .external_lex_state = 61},
  [7713] = {.lex_state = 3, .external_lex_state = 162},
  [7714] = {.lex_state = 8, .external_lex_state = 56},
  [7715] = {.lex_state = 3, .external_lex_state = 161},
  [7716] = {.lex_state = 8, .external_lex_state = 56},
  [7717] = {.lex_state = 4, .external_lex_state = 61},
  [7718] = {.lex_state = 8, .external_lex_state = 56},
  [7719] = {.lex_state = 16, .external_lex_state = 164},
  [7720] = {.lex_state = 3, .external_lex_state = 62},
  [7721] = {.lex_state = 8, .external_lex_state = 56},
  [7722] = {.lex_state = 8, .external_lex_state = 56},
  [7723] = {.lex_state = 0, .external_lex_state = 158},
  [7724] = {.lex_state = 3, .external_lex_state = 38},
  [7725] = {.lex_state = 3, .external_lex_state = 163},
  [7726] = {.lex_state = 8, .external_lex_state = 57},
  [7727] = {.lex_state = 5, .external_lex_state = 38},
  [7728] = {.lex_state = 0, .external_lex_state = 159},
  [7729] = {.lex_state = 8, .external_lex_state = 57},
  [7730] = {.lex_state = 8, .external_lex_state = 57},
  [7731] = {.lex_state = 8, .external_lex_state = 57},
  [7732] = {.lex_state = 8, .external_lex_state = 57},
  [7733] = {.lex_state = 8, .external_lex_state = 57},
  [7734] = {.lex_state = 8, .external_lex_state = 57},
  [7735] = {.lex_state = 8, .external_lex_state = 57},
  [7736] = {.lex_state = 8, .external_lex_state = 57},
  [7737] = {.lex_state = 1, .external_lex_state = 164},
  [7738] = {.lex_state = 8, .external_lex_state = 57},
  [7739] = {.lex_state = 0, .external_lex_state = 155},
  [7740] = {.lex_state = 8, .external_lex_state = 57},
  [7741] = {.lex_state = 8, .external_lex_state = 57},
  [7742] = {.lex_state = 8, .external_lex_state = 57},
  [7743] = {.lex_state = 1, .external_lex_state = 164},
  [7744] = {.lex_state = 8, .external_lex_state = 57},
  [7745] = {.lex_state = 8, .external_lex_state = 57},
  [7746] = {.lex_state = 8, .external_lex_state = 57},
  [7747] = {.lex_state = 8, .external_lex_state = 57},
  [7748] = {.lex_state = 8, .external_lex_state = 57},
  [7749] = {.lex_state = 3, .external_lex_state = 165},
  [7750] = {.lex_state = 8, .external_lex_state = 57},
  [7751] = {.lex_state = 8, .external_lex_state = 57},
  [7752] = {.lex_state = 0, .external_lex_state = 166},
  [7753] = {.lex_state = 3, .external_lex_state = 165},
  [7754] = {.lex_state = 8, .external_lex_state = 57},
  [7755] = {.lex_state = 8, .external_lex_state = 57},
  [7756] = {.lex_state = 8, .external_lex_state = 57},
  [7757] = {.lex_state = 8, .external_lex_state = 57},
  [7758] = {.lex_state = 0, .external_lex_state = 160},
  [7759] = {.lex_state = 8, .external_lex_state = 57},
  [7760] = {.lex_state = 8, .external_lex_state = 57},
  [7761] = {.lex_state = 8, .external_lex_state = 57},
  [7762] = {.lex_state = 8, .external_lex_state = 57},
  [7763] = {.lex_state = 8, .external_lex_state = 57},
  [7764] = {.lex_state = 8, .external_lex_state = 57},
  [7765] = {.lex_state = 8, .external_lex_state = 57},
  [7766] = {.lex_state = 8, .external_lex_state = 57},
  [7767] = {.lex_state = 8, .external_lex_state = 57},
  [7768] = {.lex_state = 8, .external_lex_state = 57},
  [7769] = {.lex_state = 1, .external_lex_state = 35},
  [7770] = {.lex_state = 8, .external_lex_state = 57},
  [7771] = {.lex_state = 0, .external_lex_state = 160},
  [7772] = {.lex_state = 8, .external_lex_state = 57},
  [7773] = {.lex_state = 8, .external_lex_state = 57},
  [7774] = {.lex_state = 8, .external_lex_state = 57},
  [7775] = {.lex_state = 8, .external_lex_state = 57},
  [7776] = {.lex_state = 8, .external_lex_state = 57},
  [7777] = {.lex_state = 0, .external_lex_state = 159},
  [7778] = {.lex_state = 8, .external_lex_state = 57},
  [7779] = {.lex_state = 8, .external_lex_state = 57},
  [7780] = {.lex_state = 8, .external_lex_state = 57},
  [7781] = {.lex_state = 8, .external_lex_state = 57},
  [7782] = {.lex_state = 8, .external_lex_state = 57},
  [7783] = {.lex_state = 8, .external_lex_state = 57},
  [7784] = {.lex_state = 8, .external_lex_state = 57},
  [7785] = {.lex_state = 8, .external_lex_state = 57},
  [7786] = {.lex_state = 0, .external_lex_state = 159},
  [7787] = {.lex_state = 8, .external_lex_state = 57},
  [7788] = {.lex_state = 1, .external_lex_state = 164},
  [7789] = {.lex_state = 8, .external_lex_state = 57},
  [7790] = {.lex_state = 1, .external_lex_state = 35},
  [7791] = {.lex_state = 8, .external_lex_state = 57},
  [7792] = {.lex_state = 1, .external_lex_state = 164},
  [7793] = {.lex_state = 8, .external_lex_state = 57},
  [7794] = {.lex_state = 3, .external_lex_state = 38},
  [7795] = {.lex_state = 3, .external_lex_state = 38},
  [7796] = {.lex_state = 0, .external_lex_state = 155},
  [7797] = {.lex_state = 3, .external_lex_state = 38},
  [7798] = {.lex_state = 3, .external_lex_state = 38},
  [7799] = {.lex_state = 3, .external_lex_state = 38},
  [7800] = {.lex_state = 3, .external_lex_state = 38},
  [7801] = {.lex_state = 3, .external_lex_state = 38},
  [7802] = {.lex_state = 3, .external_lex_state = 38},
  [7803] = {.lex_state = 3, .external_lex_state = 38},
  [7804] = {.lex_state = 3, .external_lex_state = 167},
  [7805] = {.lex_state = 3, .external_lex_state = 38},
  [7806] = {.lex_state = 3, .external_lex_state = 38},
  [7807] = {.lex_state = 3, .external_lex_state = 38},
  [7808] = {.lex_state = 3, .external_lex_state = 38},
  [7809] = {.lex_state = 3, .external_lex_state = 38},
  [7810] = {.lex_state = 3, .external_lex_state = 38},
  [7811] = {.lex_state = 3, .external_lex_state = 38},
  [7812] = {.lex_state = 3, .external_lex_state = 38},
  [7813] = {.lex_state = 3, .external_lex_state = 38},
  [7814] = {.lex_state = 3, .external_lex_state = 38},
  [7815] = {.lex_state = 3, .external_lex_state = 38},
  [7816] = {.lex_state = 3, .external_lex_state = 38},
  [7817] = {.lex_state = 3, .external_lex_state = 38},
  [7818] = {.lex_state = 3, .external_lex_state = 38},
  [7819] = {.lex_state = 3, .external_lex_state = 38},
  [7820] = {.lex_state = 0, .external_lex_state = 155},
  [7821] = {.lex_state = 3, .external_lex_state = 38},
  [7822] = {.lex_state = 3, .external_lex_state = 38},
  [7823] = {.lex_state = 3, .external_lex_state = 38},
  [7824] = {.lex_state = 3, .external_lex_state = 38},
  [7825] = {.lex_state = 3, .external_lex_state = 38},
  [7826] = {.lex_state = 3, .external_lex_state = 38},
  [7827] = {.lex_state = 3, .external_lex_state = 38},
  [7828] = {.lex_state = 3, .external_lex_state = 38},
  [7829] = {.lex_state = 3, .external_lex_state = 38},
  [7830] = {.lex_state = 3, .external_lex_state = 38},
  [7831] = {.lex_state = 3, .external_lex_state = 38},
  [7832] = {.lex_state = 3, .external_lex_state = 38},
  [7833] = {.lex_state = 3, .external_lex_state = 38},
  [7834] = {.lex_state = 3, .external_lex_state = 38},
  [7835] = {.lex_state = 0, .external_lex_state = 155},
  [7836] = {.lex_state = 0, .external_lex_state = 155},
  [7837] = {.lex_state = 3, .external_lex_state = 38},
  [7838] = {.lex_state = 3, .external_lex_state = 38},
  [7839] = {.lex_state = 3, .external_lex_state = 38},
  [7840] = {.lex_state = 3, .external_lex_state = 38},
  [7841] = {.lex_state = 3, .external_lex_state = 38},
  [7842] = {.lex_state = 3, .external_lex_state = 167},
  [7843] = {.lex_state = 3, .external_lex_state = 38},
  [7844] = {.lex_state = 3, .external_lex_state = 38},
  [7845] = {.lex_state = 3, .external_lex_state = 38},
  [7846] = {.lex_state = 3, .external_lex_state = 38},
  [7847] = {.lex_state = 3, .external_lex_state = 38},
  [7848] = {.lex_state = 3, .external_lex_state = 38},
  [7849] = {.lex_state = 3, .external_lex_state = 38},
  [7850] = {.lex_state = 3, .external_lex_state = 38},
  [7851] = {.lex_state = 3, .external_lex_state = 38},
  [7852] = {.lex_state = 3, .external_lex_state = 38},
  [7853] = {.lex_state = 3, .external_lex_state = 38},
  [7854] = {.lex_state = 3, .external_lex_state = 38},
  [7855] = {.lex_state = 3, .external_lex_state = 38},
  [7856] = {.lex_state = 0, .external_lex_state = 160},
  [7857] = {.lex_state = 3, .external_lex_state = 38},
  [7858] = {.lex_state = 3, .external_lex_state = 38},
  [7859] = {.lex_state = 3, .external_lex_state = 38},
  [7860] = {.lex_state = 3, .external_lex_state = 38},
  [7861] = {.lex_state = 3, .external_lex_state = 38},
  [7862] = {.lex_state = 3, .external_lex_state = 164},
  [7863] = {.lex_state = 3, .external_lex_state = 38},
  [7864] = {.lex_state = 0, .external_lex_state = 155},
  [7865] = {.lex_state = 3, .external_lex_state = 164},
  [7866] = {.lex_state = 18, .external_lex_state = 162},
  [7867] = {.lex_state = 0, .external_lex_state = 166},
  [7868] = {.lex_state = 8, .external_lex_state = 138},
  [7869] = {.lex_state = 18, .external_lex_state = 162},
  [7870] = {.lex_state = 18, .external_lex_state = 162},
  [7871] = {.lex_state = 18, .external_lex_state = 162},
  [7872] = {.lex_state = 0, .external_lex_state = 155},
  [7873] = {.lex_state = 3, .external_lex_state = 168},
  [7874] = {.lex_state = 3, .external_lex_state = 35},
  [7875] = {.lex_state = 8, .external_lex_state = 52},
  [7876] = {.lex_state = 18, .external_lex_state = 162},
  [7877] = {.lex_state = 3, .external_lex_state = 38},
  [7878] = {.lex_state = 3, .external_lex_state = 38},
  [7879] = {.lex_state = 3, .external_lex_state = 155},
  [7880] = {.lex_state = 18, .external_lex_state = 162},
  [7881] = {.lex_state = 3, .external_lex_state = 35},
  [7882] = {.lex_state = 3, .external_lex_state = 35},
  [7883] = {.lex_state = 3, .external_lex_state = 168},
  [7884] = {.lex_state = 3, .external_lex_state = 35},
  [7885] = {.lex_state = 3, .external_lex_state = 68},
  [7886] = {.lex_state = 3, .external_lex_state = 68},
  [7887] = {.lex_state = 8, .external_lex_state = 138},
  [7888] = {.lex_state = 3, .external_lex_state = 68},
  [7889] = {.lex_state = 3, .external_lex_state = 68},
  [7890] = {.lex_state = 3, .external_lex_state = 68},
  [7891] = {.lex_state = 3, .external_lex_state = 38},
  [7892] = {.lex_state = 3, .external_lex_state = 68},
  [7893] = {.lex_state = 3, .external_lex_state = 68},
  [7894] = {.lex_state = 3, .external_lex_state = 35},
  [7895] = {.lex_state = 8, .external_lex_state = 138},
  [7896] = {.lex_state = 3, .external_lex_state = 68},
  [7897] = {.lex_state = 3, .external_lex_state = 68},
  [7898] = {.lex_state = 3, .external_lex_state = 38},
  [7899] = {.lex_state = 16, .external_lex_state = 70},
  [7900] = {.lex_state = 0, .external_lex_state = 155},
  [7901] = {.lex_state = 3, .external_lex_state = 68},
  [7902] = {.lex_state = 16, .external_lex_state = 70},
  [7903] = {.lex_state = 8, .external_lex_state = 138},
  [7904] = {.lex_state = 4, .external_lex_state = 65},
  [7905] = {.lex_state = 3, .external_lex_state = 68},
  [7906] = {.lex_state = 3, .external_lex_state = 68},
  [7907] = {.lex_state = 3, .external_lex_state = 38},
  [7908] = {.lex_state = 8, .external_lex_state = 138},
  [7909] = {.lex_state = 0, .external_lex_state = 166},
  [7910] = {.lex_state = 3, .external_lex_state = 38},
  [7911] = {.lex_state = 3, .external_lex_state = 68},
  [7912] = {.lex_state = 16, .external_lex_state = 70},
  [7913] = {.lex_state = 3, .external_lex_state = 68},
  [7914] = {.lex_state = 16, .external_lex_state = 70},
  [7915] = {.lex_state = 0, .external_lex_state = 166},
  [7916] = {.lex_state = 16, .external_lex_state = 70},
  [7917] = {.lex_state = 3, .external_lex_state = 164},
  [7918] = {.lex_state = 3, .external_lex_state = 68},
  [7919] = {.lex_state = 3, .external_lex_state = 68},
  [7920] = {.lex_state = 0, .external_lex_state = 155},
  [7921] = {.lex_state = 8, .external_lex_state = 138},
  [7922] = {.lex_state = 3, .external_lex_state = 35},
  [7923] = {.lex_state = 8, .external_lex_state = 138},
  [7924] = {.lex_state = 3, .external_lex_state = 68},
  [7925] = {.lex_state = 16, .external_lex_state = 70},
  [7926] = {.lex_state = 3, .external_lex_state = 68},
  [7927] = {.lex_state = 3, .external_lex_state = 68},
  [7928] = {.lex_state = 3, .external_lex_state = 38},
  [7929] = {.lex_state = 8, .external_lex_state = 138},
  [7930] = {.lex_state = 3, .external_lex_state = 68},
  [7931] = {.lex_state = 3, .external_lex_state = 68},
  [7932] = {.lex_state = 0, .external_lex_state = 155},
  [7933] = {.lex_state = 8, .external_lex_state = 138},
  [7934] = {.lex_state = 3, .external_lex_state = 38},
  [7935] = {.lex_state = 3, .external_lex_state = 68},
  [7936] = {.lex_state = 3, .external_lex_state = 35},
  [7937] = {.lex_state = 3, .external_lex_state = 38},
  [7938] = {.lex_state = 3, .external_lex_state = 68},
  [7939] = {.lex_state = 3, .external_lex_state = 68},
  [7940] = {.lex_state = 8, .external_lex_state = 138},
  [7941] = {.lex_state = 3, .external_lex_state = 35},
  [7942] = {.lex_state = 3, .external_lex_state = 68},
  [7943] = {.lex_state = 4, .external_lex_state = 65},
  [7944] = {.lex_state = 3, .external_lex_state = 35},
  [7945] = {.lex_state = 3, .external_lex_state = 68},
  [7946] = {.lex_state = 3, .external_lex_state = 68},
  [7947] = {.lex_state = 3, .external_lex_state = 68},
  [7948] = {.lex_state = 3, .external_lex_state = 68},
  [7949] = {.lex_state = 8, .external_lex_state = 138},
  [7950] = {.lex_state = 3, .external_lex_state = 68},
  [7951] = {.lex_state = 3, .external_lex_state = 68},
  [7952] = {.lex_state = 3, .external_lex_state = 68},
  [7953] = {.lex_state = 16, .external_lex_state = 70},
  [7954] = {.lex_state = 0, .external_lex_state = 155},
  [7955] = {.lex_state = 4, .external_lex_state = 65},
  [7956] = {.lex_state = 3, .external_lex_state = 68},
  [7957] = {.lex_state = 16, .external_lex_state = 70},
  [7958] = {.lex_state = 3, .external_lex_state = 68},
  [7959] = {.lex_state = 0, .external_lex_state = 155},
  [7960] = {.lex_state = 0, .external_lex_state = 166},
  [7961] = {.lex_state = 3, .external_lex_state = 69},
  [7962] = {.lex_state = 3, .external_lex_state = 169},
  [7963] = {.lex_state = 1, .external_lex_state = 70},
  [7964] = {.lex_state = 3, .external_lex_state = 69},
  [7965] = {.lex_state = 3, .external_lex_state = 69},
  [7966] = {.lex_state = 3, .external_lex_state = 69},
  [7967] = {.lex_state = 1, .external_lex_state = 70},
  [7968] = {.lex_state = 1, .external_lex_state = 70},
  [7969] = {.lex_state = 3, .external_lex_state = 69},
  [7970] = {.lex_state = 3, .external_lex_state = 69},
  [7971] = {.lex_state = 0, .external_lex_state = 166},
  [7972] = {.lex_state = 3, .external_lex_state = 155},
  [7973] = {.lex_state = 1, .external_lex_state = 70},
  [7974] = {.lex_state = 0, .external_lex_state = 166},
  [7975] = {.lex_state = 0, .external_lex_state = 166},
  [7976] = {.lex_state = 3, .external_lex_state = 69},
  [7977] = {.lex_state = 1, .external_lex_state = 70},
  [7978] = {.lex_state = 3, .external_lex_state = 69},
  [7979] = {.lex_state = 3, .external_lex_state = 162},
  [7980] = {.lex_state = 1, .external_lex_state = 70},
  [7981] = {.lex_state = 1, .external_lex_state = 70},
  [7982] = {.lex_state = 1, .external_lex_state = 70},
  [7983] = {.lex_state = 1, .external_lex_state = 70},
  [7984] = {.lex_state = 3, .external_lex_state = 69},
  [7985] = {.lex_state = 1, .external_lex_state = 70},
  [7986] = {.lex_state = 1, .external_lex_state = 70},
  [7987] = {.lex_state = 1, .external_lex_state = 70},
  [7988] = {.lex_state = 3, .external_lex_state = 64},
  [7989] = {.lex_state = 0, .external_lex_state = 166},
  [7990] = {.lex_state = 1, .external_lex_state = 70},
  [7991] = {.lex_state = 3, .external_lex_state = 69},
  [7992] = {.lex_state = 3, .external_lex_state = 69},
  [7993] = {.lex_state = 3, .external_lex_state = 69},
  [7994] = {.lex_state = 3, .external_lex_state = 69},
  [7995] = {.lex_state = 1, .external_lex_state = 70},
  [7996] = {.lex_state = 1, .external_lex_state = 70},
  [7997] = {.lex_state = 1, .external_lex_state = 70},
  [7998] = {.lex_state = 1, .external_lex_state = 70},
  [7999] = {.lex_state = 1, .external_lex_state = 70},
  [8000] = {.lex_state = 1, .external_lex_state = 70},
  [8001] = {.lex_state = 3, .external_lex_state = 69},
  [8002] = {.lex_state = 3, .external_lex_state = 69},
  [8003] = {.lex_state = 1, .external_lex_state = 70},
  [8004] = {.lex_state = 3, .external_lex_state = 69},
  [8005] = {.lex_state = 1, .external_lex_state = 70},
  [8006] = {.lex_state = 1, .external_lex_state = 70},
  [8007] = {.lex_state = 1, .external_lex_state = 70},
  [8008] = {.lex_state = 1, .external_lex_state = 70},
  [8009] = {.lex_state = 1, .external_lex_state = 70},
  [8010] = {.lex_state = 3, .external_lex_state = 69},
  [8011] = {.lex_state = 1, .external_lex_state = 70},
  [8012] = {.lex_state = 0, .external_lex_state = 155},
  [8013] = {.lex_state = 3, .external_lex_state = 66},
  [8014] = {.lex_state = 3, .external_lex_state = 66},
  [8015] = {.lex_state = 0, .external_lex_state = 157},
  [8016] = {.lex_state = 3, .external_lex_state = 66},
  [8017] = {.lex_state = 0, .external_lex_state = 157},
  [8018] = {.lex_state = 3, .external_lex_state = 66},
  [8019] = {.lex_state = 3, .external_lex_state = 164},
  [8020] = {.lex_state = 0, .external_lex_state = 157},
  [8021] = {.lex_state = 3, .external_lex_state = 66},
  [8022] = {.lex_state = 3, .external_lex_state = 66},
  [8023] = {.lex_state = 3, .external_lex_state = 66},
  [8024] = {.lex_state = 3, .external_lex_state = 66},
  [8025] = {.lex_state = 3, .external_lex_state = 66},
  [8026] = {.lex_state = 3, .external_lex_state = 67},
  [8027] = {.lex_state = 3, .external_lex_state = 66},
  [8028] = {.lex_state = 0, .external_lex_state = 157},
  [8029] = {.lex_state = 3, .external_lex_state = 66},
  [8030] = {.lex_state = 3, .external_lex_state = 66},
  [8031] = {.lex_state = 3, .external_lex_state = 66},
  [8032] = {.lex_state = 4, .external_lex_state = 170},
  [8033] = {.lex_state = 3, .external_lex_state = 66},
  [8034] = {.lex_state = 4, .external_lex_state = 170},
  [8035] = {.lex_state = 3, .external_lex_state = 66},
  [8036] = {.lex_state = 3, .external_lex_state = 67},
  [8037] = {.lex_state = 3, .external_lex_state = 66},
  [8038] = {.lex_state = 3, .external_lex_state = 66},
  [8039] = {.lex_state = 3, .external_lex_state = 67},
  [8040] = {.lex_state = 8, .external_lex_state = 138},
  [8041] = {.lex_state = 8, .external_lex_state = 138},
  [8042] = {.lex_state = 8, .external_lex_state = 138},
  [8043] = {.lex_state = 8, .external_lex_state = 171},
  [8044] = {.lex_state = 3, .external_lex_state = 71},
  [8045] = {.lex_state = 8, .external_lex_state = 138},
  [8046] = {.lex_state = 3, .external_lex_state = 70},
  [8047] = {.lex_state = 3, .external_lex_state = 70},
  [8048] = {.lex_state = 3, .external_lex_state = 70},
  [8049] = {.lex_state = 3, .external_lex_state = 71},
  [8050] = {.lex_state = 3, .external_lex_state = 71},
  [8051] = {.lex_state = 3, .external_lex_state = 163},
  [8052] = {.lex_state = 3, .external_lex_state = 70},
  [8053] = {.lex_state = 3, .external_lex_state = 71},
  [8054] = {.lex_state = 3, .external_lex_state = 71},
  [8055] = {.lex_state = 3, .external_lex_state = 11},
  [8056] = {.lex_state = 8, .external_lex_state = 138},
  [8057] = {.lex_state = 3, .external_lex_state = 71},
  [8058] = {.lex_state = 3, .external_lex_state = 71},
  [8059] = {.lex_state = 3, .external_lex_state = 163},
  [8060] = {.lex_state = 3, .external_lex_state = 11},
  [8061] = {.lex_state = 0, .external_lex_state = 158},
  [8062] = {.lex_state = 3, .external_lex_state = 70},
  [8063] = {.lex_state = 3, .external_lex_state = 70},
  [8064] = {.lex_state = 3, .external_lex_state = 71},
  [8065] = {.lex_state = 3, .external_lex_state = 71},
  [8066] = {.lex_state = 3, .external_lex_state = 71},
  [8067] = {.lex_state = 3, .external_lex_state = 70},
  [8068] = {.lex_state = 3, .external_lex_state = 71},
  [8069] = {.lex_state = 3, .external_lex_state = 67},
  [8070] = {.lex_state = 3, .external_lex_state = 71},
  [8071] = {.lex_state = 3, .external_lex_state = 71},
  [8072] = {.lex_state = 3, .external_lex_state = 71},
  [8073] = {.lex_state = 3, .external_lex_state = 71},
  [8074] = {.lex_state = 8, .external_lex_state = 138},
  [8075] = {.lex_state = 3, .external_lex_state = 70},
  [8076] = {.lex_state = 3, .external_lex_state = 70},
  [8077] = {.lex_state = 3, .external_lex_state = 71},
  [8078] = {.lex_state = 3, .external_lex_state = 71},
  [8079] = {.lex_state = 9, .external_lex_state = 11},
  [8080] = {.lex_state = 3, .external_lex_state = 67},
  [8081] = {.lex_state = 0, .external_lex_state = 159},
  [8082] = {.lex_state = 3, .external_lex_state = 67},
  [8083] = {.lex_state = 0, .external_lex_state = 159},
  [8084] = {.lex_state = 3, .external_lex_state = 172},
  [8085] = {.lex_state = 3, .external_lex_state = 67},
  [8086] = {.lex_state = 3, .external_lex_state = 11},
  [8087] = {.lex_state = 0, .external_lex_state = 159},
  [8088] = {.lex_state = 3, .external_lex_state = 172},
  [8089] = {.lex_state = 21, .external_lex_state = 138},
  [8090] = {.lex_state = 0, .external_lex_state = 159},
  [8091] = {.lex_state = 0, .external_lex_state = 159},
  [8092] = {.lex_state = 3, .external_lex_state = 173},
  [8093] = {.lex_state = 3, .external_lex_state = 67},
  [8094] = {.lex_state = 0, .external_lex_state = 174},
  [8095] = {.lex_state = 3, .external_lex_state = 67},
  [8096] = {.lex_state = 3, .external_lex_state = 173},
  [8097] = {.lex_state = 3, .external_lex_state = 162},
  [8098] = {.lex_state = 4, .external_lex_state = 175},
  [8099] = {.lex_state = 4, .external_lex_state = 175},
  [8100] = {.lex_state = 4, .external_lex_state = 175},
  [8101] = {.lex_state = 4, .external_lex_state = 175},
  [8102] = {.lex_state = 0, .external_lex_state = 159},
  [8103] = {.lex_state = 4, .external_lex_state = 175},
  [8104] = {.lex_state = 4, .external_lex_state = 175},
  [8105] = {.lex_state = 3, .external_lex_state = 162},
  [8106] = {.lex_state = 4, .external_lex_state = 175},
  [8107] = {.lex_state = 8, .external_lex_state = 176},
  [8108] = {.lex_state = 0, .external_lex_state = 174},
  [8109] = {.lex_state = 0, .external_lex_state = 159},
  [8110] = {.lex_state = 0, .external_lex_state = 159},
  [8111] = {.lex_state = 0, .external_lex_state = 159},
  [8112] = {.lex_state = 8, .external_lex_state = 176},
  [8113] = {.lex_state = 4, .external_lex_state = 175},
  [8114] = {.lex_state = 3, .external_lex_state = 169},
  [8115] = {.lex_state = 8, .external_lex_state = 176},
  [8116] = {.lex_state = 0, .external_lex_state = 159},
  [8117] = {.lex_state = 8, .external_lex_state = 176},
  [8118] = {.lex_state = 4, .external_lex_state = 175},
  [8119] = {.lex_state = 21, .external_lex_state = 138},
  [8120] = {.lex_state = 0, .external_lex_state = 174},
  [8121] = {.lex_state = 0, .external_lex_state = 174},
  [8122] = {.lex_state = 8, .external_lex_state = 176},
  [8123] = {.lex_state = 0, .external_lex_state = 159},
  [8124] = {.lex_state = 8, .external_lex_state = 176},
  [8125] = {.lex_state = 0, .external_lex_state = 159},
  [8126] = {.lex_state = 8, .external_lex_state = 176},
  [8127] = {.lex_state = 4, .external_lex_state = 175},
  [8128] = {.lex_state = 8, .external_lex_state = 176},
  [8129] = {.lex_state = 8, .external_lex_state = 176},
  [8130] = {.lex_state = 0, .external_lex_state = 159},
  [8131] = {.lex_state = 8, .external_lex_state = 176},
  [8132] = {.lex_state = 0, .external_lex_state = 174},
  [8133] = {.lex_state = 0, .external_lex_state = 174},
  [8134] = {.lex_state = 0, .external_lex_state = 174},
  [8135] = {.lex_state = 3, .external_lex_state = 169},
  [8136] = {.lex_state = 0, .external_lex_state = 174},
  [8137] = {.lex_state = 0, .external_lex_state = 174},
  [8138] = {.lex_state = 3, .external_lex_state = 11},
  [8139] = {.lex_state = 3, .external_lex_state = 11},
  [8140] = {.lex_state = 0, .external_lex_state = 155},
  [8141] = {.lex_state = 0, .external_lex_state = 155},
  [8142] = {.lex_state = 1, .external_lex_state = 162},
  [8143] = {.lex_state = 3, .external_lex_state = 11},
  [8144] = {.lex_state = 0, .external_lex_state = 155},
  [8145] = {.lex_state = 0, .external_lex_state = 155},
  [8146] = {.lex_state = 3, .external_lex_state = 11},
  [8147] = {.lex_state = 0, .external_lex_state = 155},
  [8148] = {.lex_state = 3, .external_lex_state = 11},
  [8149] = {.lex_state = 0, .external_lex_state = 173},
  [8150] = {.lex_state = 0, .external_lex_state = 177},
  [8151] = {.lex_state = 0, .external_lex_state = 155},
  [8152] = {.lex_state = 3, .external_lex_state = 11},
  [8153] = {.lex_state = 0, .external_lex_state = 155},
  [8154] = {.lex_state = 3, .external_lex_state = 74},
  [8155] = {.lex_state = 3, .external_lex_state = 11},
  [8156] = {.lex_state = 0, .external_lex_state = 155},
  [8157] = {.lex_state = 0, .external_lex_state = 178},
  [8158] = {.lex_state = 3, .external_lex_state = 11},
  [8159] = {.lex_state = 9, .external_lex_state = 38},
  [8160] = {.lex_state = 3, .external_lex_state = 11},
  [8161] = {.lex_state = 3, .external_lex_state = 11},
  [8162] = {.lex_state = 0, .external_lex_state = 155},
  [8163] = {.lex_state = 0, .external_lex_state = 155},
  [8164] = {.lex_state = 1, .external_lex_state = 162},
  [8165] = {.lex_state = 0, .external_lex_state = 177},
  [8166] = {.lex_state = 3, .external_lex_state = 11},
  [8167] = {.lex_state = 4, .external_lex_state = 170},
  [8168] = {.lex_state = 4, .external_lex_state = 170},
  [8169] = {.lex_state = 3, .external_lex_state = 11},
  [8170] = {.lex_state = 0, .external_lex_state = 155},
  [8171] = {.lex_state = 0, .external_lex_state = 179},
  [8172] = {.lex_state = 0, .external_lex_state = 155},
  [8173] = {.lex_state = 0, .external_lex_state = 155},
  [8174] = {.lex_state = 1, .external_lex_state = 162},
  [8175] = {.lex_state = 0, .external_lex_state = 155},
  [8176] = {.lex_state = 1, .external_lex_state = 162},
  [8177] = {.lex_state = 1, .external_lex_state = 162},
  [8178] = {.lex_state = 1, .external_lex_state = 162},
  [8179] = {.lex_state = 0, .external_lex_state = 155},
  [8180] = {.lex_state = 1, .external_lex_state = 162},
  [8181] = {.lex_state = 8, .external_lex_state = 138},
  [8182] = {.lex_state = 0, .external_lex_state = 155},
  [8183] = {.lex_state = 0, .external_lex_state = 179},
  [8184] = {.lex_state = 0, .external_lex_state = 179},
  [8185] = {.lex_state = 0, .external_lex_state = 180},
  [8186] = {.lex_state = 0, .external_lex_state = 155},
  [8187] = {.lex_state = 8, .external_lex_state = 171},
  [8188] = {.lex_state = 0, .external_lex_state = 155},
  [8189] = {.lex_state = 0, .external_lex_state = 155},
  [8190] = {.lex_state = 0, .external_lex_state = 155},
  [8191] = {.lex_state = 3, .external_lex_state = 173},
  [8192] = {.lex_state = 8, .external_lex_state = 171},
  [8193] = {.lex_state = 0, .external_lex_state = 155},
  [8194] = {.lex_state = 0, .external_lex_state = 180},
  [8195] = {.lex_state = 0, .external_lex_state = 155},
  [8196] = {.lex_state = 1, .external_lex_state = 162},
  [8197] = {.lex_state = 0, .external_lex_state = 155},
  [8198] = {.lex_state = 1, .external_lex_state = 162},
  [8199] = {.lex_state = 0, .external_lex_state = 155},
  [8200] = {.lex_state = 3, .external_lex_state = 173},
  [8201] = {.lex_state = 0, .external_lex_state = 179},
  [8202] = {.lex_state = 0, .external_lex_state = 180},
  [8203] = {.lex_state = 0, .external_lex_state = 155},
  [8204] = {.lex_state = 0, .external_lex_state = 155},
  [8205] = {.lex_state = 0, .external_lex_state = 179},
  [8206] = {.lex_state = 0, .external_lex_state = 179},
  [8207] = {.lex_state = 0, .external_lex_state = 178},
  [8208] = {.lex_state = 8, .external_lex_state = 171},
  [8209] = {.lex_state = 8, .external_lex_state = 171},
  [8210] = {.lex_state = 0, .external_lex_state = 155},
  [8211] = {.lex_state = 0, .external_lex_state = 178},
  [8212] = {.lex_state = 0, .external_lex_state = 178},
  [8213] = {.lex_state = 0, .external_lex_state = 178},
  [8214] = {.lex_state = 8, .external_lex_state = 171},
  [8215] = {.lex_state = 0, .external_lex_state = 178},
  [8216] = {.lex_state = 0, .external_lex_state = 178},
  [8217] = {.lex_state = 0, .external_lex_state = 155},
  [8218] = {.lex_state = 0, .external_lex_state = 178},
  [8219] = {.lex_state = 0, .external_lex_state = 155},
  [8220] = {.lex_state = 0, .external_lex_state = 180},
  [8221] = {.lex_state = 0, .external_lex_state = 180},
  [8222] = {.lex_state = 3, .external_lex_state = 38},
  [8223] = {.lex_state = 0, .external_lex_state = 155},
  [8224] = {.lex_state = 0, .external_lex_state = 155},
  [8225] = {.lex_state = 3, .external_lex_state = 38},
  [8226] = {.lex_state = 8, .external_lex_state = 171},
  [8227] = {.lex_state = 0, .external_lex_state = 179},
  [8228] = {.lex_state = 8, .external_lex_state = 138},
  [8229] = {.lex_state = 0, .external_lex_state = 179},
  [8230] = {.lex_state = 0, .external_lex_state = 155},
  [8231] = {.lex_state = 0, .external_lex_state = 179},
  [8232] = {.lex_state = 0, .external_lex_state = 155},
  [8233] = {.lex_state = 0, .external_lex_state = 155},
  [8234] = {.lex_state = 0, .external_lex_state = 155},
  [8235] = {.lex_state = 0, .external_lex_state = 155},
  [8236] = {.lex_state = 0, .external_lex_state = 179},
  [8237] = {.lex_state = 0, .external_lex_state = 179},
  [8238] = {.lex_state = 0, .external_lex_state = 180},
  [8239] = {.lex_state = 8, .external_lex_state = 171},
  [8240] = {.lex_state = 0, .external_lex_state = 155},
  [8241] = {.lex_state = 0, .external_lex_state = 155},
  [8242] = {.lex_state = 0, .external_lex_state = 155},
  [8243] = {.lex_state = 0, .external_lex_state = 155},
  [8244] = {.lex_state = 0, .external_lex_state = 155},
  [8245] = {.lex_state = 8, .external_lex_state = 171},
  [8246] = {.lex_state = 0, .external_lex_state = 155},
  [8247] = {.lex_state = 0, .external_lex_state = 180},
  [8248] = {.lex_state = 0, .external_lex_state = 155},
  [8249] = {.lex_state = 8, .external_lex_state = 171},
  [8250] = {.lex_state = 0, .external_lex_state = 180},
  [8251] = {.lex_state = 0, .external_lex_state = 179},
  [8252] = {.lex_state = 1, .external_lex_state = 162},
  [8253] = {.lex_state = 0, .external_lex_state = 155},
  [8254] = {.lex_state = 0, .external_lex_state = 155},
  [8255] = {.lex_state = 0, .external_lex_state = 155},
  [8256] = {.lex_state = 0, .external_lex_state = 155},
  [8257] = {.lex_state = 0, .external_lex_state = 155},
  [8258] = {.lex_state = 0, .external_lex_state = 155},
  [8259] = {.lex_state = 0, .external_lex_state = 155},
  [8260] = {.lex_state = 0, .external_lex_state = 155},
  [8261] = {.lex_state = 0, .external_lex_state = 155},
  [8262] = {.lex_state = 0, .external_lex_state = 178},
  [8263] = {.lex_state = 0, .external_lex_state = 155},
  [8264] = {.lex_state = 0, .external_lex_state = 155},
  [8265] = {.lex_state = 0, .external_lex_state = 155},
  [8266] = {.lex_state = 8, .external_lex_state = 171},
  [8267] = {.lex_state = 0, .external_lex_state = 155},
  [8268] = {.lex_state = 8, .external_lex_state = 138},
  [8269] = {.lex_state = 0, .external_lex_state = 155},
  [8270] = {.lex_state = 0, .external_lex_state = 180},
  [8271] = {.lex_state = 0, .external_lex_state = 155},
  [8272] = {.lex_state = 8, .external_lex_state = 171},
  [8273] = {.lex_state = 0, .external_lex_state = 155},
  [8274] = {.lex_state = 0, .external_lex_state = 179},
  [8275] = {.lex_state = 8, .external_lex_state = 138},
  [8276] = {.lex_state = 3, .external_lex_state = 181},
  [8277] = {.lex_state = 3, .external_lex_state = 38},
  [8278] = {.lex_state = 3, .external_lex_state = 181},
  [8279] = {.lex_state = 8, .external_lex_state = 138},
  [8280] = {.lex_state = 3, .external_lex_state = 181},
  [8281] = {.lex_state = 3, .external_lex_state = 38},
  [8282] = {.lex_state = 8, .external_lex_state = 121},
  [8283] = {.lex_state = 3, .external_lex_state = 38},
  [8284] = {.lex_state = 3, .external_lex_state = 38},
  [8285] = {.lex_state = 4, .external_lex_state = 166},
  [8286] = {.lex_state = 3, .external_lex_state = 38},
  [8287] = {.lex_state = 3, .external_lex_state = 38},
  [8288] = {.lex_state = 3, .external_lex_state = 181},
  [8289] = {.lex_state = 3, .external_lex_state = 38},
  [8290] = {.lex_state = 3, .external_lex_state = 38},
  [8291] = {.lex_state = 8, .external_lex_state = 138},
  [8292] = {.lex_state = 3, .external_lex_state = 181},
  [8293] = {.lex_state = 3, .external_lex_state = 181},
  [8294] = {.lex_state = 3, .external_lex_state = 38},
  [8295] = {.lex_state = 3, .external_lex_state = 38},
  [8296] = {.lex_state = 3, .external_lex_state = 181},
  [8297] = {.lex_state = 3, .external_lex_state = 38},
  [8298] = {.lex_state = 3, .external_lex_state = 181},
  [8299] = {.lex_state = 0, .external_lex_state = 155},
  [8300] = {.lex_state = 3, .external_lex_state = 162},
  [8301] = {.lex_state = 1, .external_lex_state = 162},
  [8302] = {.lex_state = 0, .external_lex_state = 178},
  [8303] = {.lex_state = 3, .external_lex_state = 166},
  [8304] = {.lex_state = 0, .external_lex_state = 178},
  [8305] = {.lex_state = 3, .external_lex_state = 172},
  [8306] = {.lex_state = 4, .external_lex_state = 162},
  [8307] = {.lex_state = 4, .external_lex_state = 162},
  [8308] = {.lex_state = 0, .external_lex_state = 178},
  [8309] = {.lex_state = 1, .external_lex_state = 162},
  [8310] = {.lex_state = 0, .external_lex_state = 162},
  [8311] = {.lex_state = 0, .external_lex_state = 178},
  [8312] = {.lex_state = 0, .external_lex_state = 162},
  [8313] = {.lex_state = 18, .external_lex_state = 155},
  [8314] = {.lex_state = 4, .external_lex_state = 182},
  [8315] = {.lex_state = 0, .external_lex_state = 178},
  [8316] = {.lex_state = 0, .external_lex_state = 178},
  [8317] = {.lex_state = 0, .external_lex_state = 178},
  [8318] = {.lex_state = 0, .external_lex_state = 178},
  [8319] = {.lex_state = 0, .external_lex_state = 178},
  [8320] = {.lex_state = 0, .external_lex_state = 178},
  [8321] = {.lex_state = 4, .external_lex_state = 182},
  [8322] = {.lex_state = 4, .external_lex_state = 182},
  [8323] = {.lex_state = 4, .external_lex_state = 162},
  [8324] = {.lex_state = 0, .external_lex_state = 178},
  [8325] = {.lex_state = 4, .external_lex_state = 162},
  [8326] = {.lex_state = 4, .external_lex_state = 182},
  [8327] = {.lex_state = 4, .external_lex_state = 182},
  [8328] = {.lex_state = 0, .external_lex_state = 178},
  [8329] = {.lex_state = 0, .external_lex_state = 178},
  [8330] = {.lex_state = 0, .external_lex_state = 178},
  [8331] = {.lex_state = 4, .external_lex_state = 182},
  [8332] = {.lex_state = 4, .external_lex_state = 182},
  [8333] = {.lex_state = 4, .external_lex_state = 182},
  [8334] = {.lex_state = 3, .external_lex_state = 172},
  [8335] = {.lex_state = 4, .external_lex_state = 162},
  [8336] = {.lex_state = 0, .external_lex_state = 178},
  [8337] = {.lex_state = 1, .external_lex_state = 162},
  [8338] = {.lex_state = 4, .external_lex_state = 166},
  [8339] = {.lex_state = 0, .external_lex_state = 178},
  [8340] = {.lex_state = 4, .external_lex_state = 162},
  [8341] = {.lex_state = 1, .external_lex_state = 162},
  [8342] = {.lex_state = 4, .external_lex_state = 166},
  [8343] = {.lex_state = 0, .external_lex_state = 178},
  [8344] = {.lex_state = 0, .external_lex_state = 178},
  [8345] = {.lex_state = 0, .external_lex_state = 178},
  [8346] = {.lex_state = 0, .external_lex_state = 178},
  [8347] = {.lex_state = 0, .external_lex_state = 178},
  [8348] = {.lex_state = 4, .external_lex_state = 182},
  [8349] = {.lex_state = 4, .external_lex_state = 162},
  [8350] = {.lex_state = 0, .external_lex_state = 178},
  [8351] = {.lex_state = 0, .external_lex_state = 178},
  [8352] = {.lex_state = 4, .external_lex_state = 162},
  [8353] = {.lex_state = 0, .external_lex_state = 178},
  [8354] = {.lex_state = 4, .external_lex_state = 162},
  [8355] = {.lex_state = 3, .external_lex_state = 163},
  [8356] = {.lex_state = 4, .external_lex_state = 183},
  [8357] = {.lex_state = 3, .external_lex_state = 163},
  [8358] = {.lex_state = 3, .external_lex_state = 163},
  [8359] = {.lex_state = 3, .external_lex_state = 163},
  [8360] = {.lex_state = 3, .external_lex_state = 163},
  [8361] = {.lex_state = 3, .external_lex_state = 163},
  [8362] = {.lex_state = 4, .external_lex_state = 184},
  [8363] = {.lex_state = 8, .external_lex_state = 138},
  [8364] = {.lex_state = 4, .external_lex_state = 184},
  [8365] = {.lex_state = 4, .external_lex_state = 184},
  [8366] = {.lex_state = 4, .external_lex_state = 184},
  [8367] = {.lex_state = 4, .external_lex_state = 184},
  [8368] = {.lex_state = 4, .external_lex_state = 184},
  [8369] = {.lex_state = 4, .external_lex_state = 184},
  [8370] = {.lex_state = 3, .external_lex_state = 163},
  [8371] = {.lex_state = 3, .external_lex_state = 163},
  [8372] = {.lex_state = 4, .external_lex_state = 184},
  [8373] = {.lex_state = 4, .external_lex_state = 184},
  [8374] = {.lex_state = 3, .external_lex_state = 163},
  [8375] = {.lex_state = 3, .external_lex_state = 163},
  [8376] = {.lex_state = 3, .external_lex_state = 163},
  [8377] = {.lex_state = 3, .external_lex_state = 163},
  [8378] = {.lex_state = 3, .external_lex_state = 166},
  [8379] = {.lex_state = 3, .external_lex_state = 166},
  [8380] = {.lex_state = 3, .external_lex_state = 163},
  [8381] = {.lex_state = 3, .external_lex_state = 163},
  [8382] = {.lex_state = 3, .external_lex_state = 163},
  [8383] = {.lex_state = 8, .external_lex_state = 176},
  [8384] = {.lex_state = 3, .external_lex_state = 163},
  [8385] = {.lex_state = 3, .external_lex_state = 163},
  [8386] = {.lex_state = 3, .external_lex_state = 163},
  [8387] = {.lex_state = 3, .external_lex_state = 163},
  [8388] = {.lex_state = 3, .external_lex_state = 95},
  [8389] = {.lex_state = 0, .external_lex_state = 185},
  [8390] = {.lex_state = 8, .external_lex_state = 138},
  [8391] = {.lex_state = 3, .external_lex_state = 163},
  [8392] = {.lex_state = 3, .external_lex_state = 163},
  [8393] = {.lex_state = 4, .external_lex_state = 183},
  [8394] = {.lex_state = 4, .external_lex_state = 183},
  [8395] = {.lex_state = 4, .external_lex_state = 183},
  [8396] = {.lex_state = 4, .external_lex_state = 183},
  [8397] = {.lex_state = 4, .external_lex_state = 183},
  [8398] = {.lex_state = 4, .external_lex_state = 183},
  [8399] = {.lex_state = 8, .external_lex_state = 176},
  [8400] = {.lex_state = 4, .external_lex_state = 183},
  [8401] = {.lex_state = 8, .external_lex_state = 138},
  [8402] = {.lex_state = 4, .external_lex_state = 183},
  [8403] = {.lex_state = 0, .external_lex_state = 162},
  [8404] = {.lex_state = 8, .external_lex_state = 138},
  [8405] = {.lex_state = 8, .external_lex_state = 138},
  [8406] = {.lex_state = 8, .external_lex_state = 138},
  [8407] = {.lex_state = 0, .external_lex_state = 162},
  [8408] = {.lex_state = 8, .external_lex_state = 138},
  [8409] = {.lex_state = 0, .external_lex_state = 162},
  [8410] = {.lex_state = 8, .external_lex_state = 138},
  [8411] = {.lex_state = 8, .external_lex_state = 138},
  [8412] = {.lex_state = 8, .external_lex_state = 138},
  [8413] = {.lex_state = 0, .external_lex_state = 162},
  [8414] = {.lex_state = 0, .external_lex_state = 162},
  [8415] = {.lex_state = 8, .external_lex_state = 138},
  [8416] = {.lex_state = 0, .external_lex_state = 162},
  [8417] = {.lex_state = 8, .external_lex_state = 138},
  [8418] = {.lex_state = 4, .external_lex_state = 184},
  [8419] = {.lex_state = 0, .external_lex_state = 162},
  [8420] = {.lex_state = 0, .external_lex_state = 162},
  [8421] = {.lex_state = 8, .external_lex_state = 138},
  [8422] = {.lex_state = 4, .external_lex_state = 186},
  [8423] = {.lex_state = 8, .external_lex_state = 138},
  [8424] = {.lex_state = 0, .external_lex_state = 162},
  [8425] = {.lex_state = 8, .external_lex_state = 138},
  [8426] = {.lex_state = 8, .external_lex_state = 138},
  [8427] = {.lex_state = 8, .external_lex_state = 138},
  [8428] = {.lex_state = 8, .external_lex_state = 138},
  [8429] = {.lex_state = 8, .external_lex_state = 138},
  [8430] = {.lex_state = 8, .external_lex_state = 138},
  [8431] = {.lex_state = 8, .external_lex_state = 138},
  [8432] = {.lex_state = 8, .external_lex_state = 138},
  [8433] = {.lex_state = 8, .external_lex_state = 138},
  [8434] = {.lex_state = 8, .external_lex_state = 138},
  [8435] = {.lex_state = 8, .external_lex_state = 138},
  [8436] = {.lex_state = 8, .external_lex_state = 138},
  [8437] = {.lex_state = 8, .external_lex_state = 138},
  [8438] = {.lex_state = 8, .external_lex_state = 138},
  [8439] = {.lex_state = 8, .external_lex_state = 138},
  [8440] = {.lex_state = 0, .external_lex_state = 162},
  [8441] = {.lex_state = 8, .external_lex_state = 138},
  [8442] = {.lex_state = 8, .external_lex_state = 138},
  [8443] = {.lex_state = 8, .external_lex_state = 138},
  [8444] = {.lex_state = 0, .external_lex_state = 162},
  [8445] = {.lex_state = 8, .external_lex_state = 138},
  [8446] = {.lex_state = 8, .external_lex_state = 138},
  [8447] = {.lex_state = 0, .external_lex_state = 162},
  [8448] = {.lex_state = 8, .external_lex_state = 138},
  [8449] = {.lex_state = 8, .external_lex_state = 138},
  [8450] = {.lex_state = 8, .external_lex_state = 138},
  [8451] = {.lex_state = 8, .external_lex_state = 138},
  [8452] = {.lex_state = 0, .external_lex_state = 162},
  [8453] = {.lex_state = 8, .external_lex_state = 138},
  [8454] = {.lex_state = 0, .external_lex_state = 162},
  [8455] = {.lex_state = 8, .external_lex_state = 138},
  [8456] = {.lex_state = 8, .external_lex_state = 138},
  [8457] = {.lex_state = 8, .external_lex_state = 138},
  [8458] = {.lex_state = 8, .external_lex_state = 138},
  [8459] = {.lex_state = 8, .external_lex_state = 138},
  [8460] = {.lex_state = 0, .external_lex_state = 166},
  [8461] = {.lex_state = 8, .external_lex_state = 138},
  [8462] = {.lex_state = 8, .external_lex_state = 138},
  [8463] = {.lex_state = 8, .external_lex_state = 138},
  [8464] = {.lex_state = 0, .external_lex_state = 162},
  [8465] = {.lex_state = 8, .external_lex_state = 138},
  [8466] = {.lex_state = 8, .external_lex_state = 138},
  [8467] = {.lex_state = 8, .external_lex_state = 138},
  [8468] = {.lex_state = 8, .external_lex_state = 138},
  [8469] = {.lex_state = 0, .external_lex_state = 162},
  [8470] = {.lex_state = 8, .external_lex_state = 138},
  [8471] = {.lex_state = 8, .external_lex_state = 138},
  [8472] = {.lex_state = 8, .external_lex_state = 138},
  [8473] = {.lex_state = 8, .external_lex_state = 138},
  [8474] = {.lex_state = 8, .external_lex_state = 138},
  [8475] = {.lex_state = 8, .external_lex_state = 138},
  [8476] = {.lex_state = 8, .external_lex_state = 138},
  [8477] = {.lex_state = 0, .external_lex_state = 185},
  [8478] = {.lex_state = 8, .external_lex_state = 138},
  [8479] = {.lex_state = 8, .external_lex_state = 138},
  [8480] = {.lex_state = 8, .external_lex_state = 138},
  [8481] = {.lex_state = 0, .external_lex_state = 185},
  [8482] = {.lex_state = 0, .external_lex_state = 185},
  [8483] = {.lex_state = 8, .external_lex_state = 138},
  [8484] = {.lex_state = 8, .external_lex_state = 138},
  [8485] = {.lex_state = 8, .external_lex_state = 138},
  [8486] = {.lex_state = 8, .external_lex_state = 138},
  [8487] = {.lex_state = 0, .external_lex_state = 185},
  [8488] = {.lex_state = 0, .external_lex_state = 185},
  [8489] = {.lex_state = 8, .external_lex_state = 138},
  [8490] = {.lex_state = 0, .external_lex_state = 185},
  [8491] = {.lex_state = 8, .external_lex_state = 138},
  [8492] = {.lex_state = 8, .external_lex_state = 138},
  [8493] = {.lex_state = 8, .external_lex_state = 138},
  [8494] = {.lex_state = 0, .external_lex_state = 185},
  [8495] = {.lex_state = 8, .external_lex_state = 138},
  [8496] = {.lex_state = 8, .external_lex_state = 138},
  [8497] = {.lex_state = 0, .external_lex_state = 166},
  [8498] = {.lex_state = 8, .external_lex_state = 138},
  [8499] = {.lex_state = 8, .external_lex_state = 138},
  [8500] = {.lex_state = 8, .external_lex_state = 138},
  [8501] = {.lex_state = 8, .external_lex_state = 138},
  [8502] = {.lex_state = 4, .external_lex_state = 175},
  [8503] = {.lex_state = 8, .external_lex_state = 138},
  [8504] = {.lex_state = 0, .external_lex_state = 162},
  [8505] = {.lex_state = 0, .external_lex_state = 162},
  [8506] = {.lex_state = 0, .external_lex_state = 162},
  [8507] = {.lex_state = 8, .external_lex_state = 138},
  [8508] = {.lex_state = 8, .external_lex_state = 138},
  [8509] = {.lex_state = 0, .external_lex_state = 185},
  [8510] = {.lex_state = 0, .external_lex_state = 162},
  [8511] = {.lex_state = 4, .external_lex_state = 175},
  [8512] = {.lex_state = 8, .external_lex_state = 138},
  [8513] = {.lex_state = 0, .external_lex_state = 174},
  [8514] = {.lex_state = 4, .external_lex_state = 175},
  [8515] = {.lex_state = 8, .external_lex_state = 138},
  [8516] = {.lex_state = 8, .external_lex_state = 138},
  [8517] = {.lex_state = 0, .external_lex_state = 162},
  [8518] = {.lex_state = 8, .external_lex_state = 138},
  [8519] = {.lex_state = 4, .external_lex_state = 175},
  [8520] = {.lex_state = 4, .external_lex_state = 175},
  [8521] = {.lex_state = 0, .external_lex_state = 162},
  [8522] = {.lex_state = 8, .external_lex_state = 138},
  [8523] = {.lex_state = 8, .external_lex_state = 138},
  [8524] = {.lex_state = 8, .external_lex_state = 138},
  [8525] = {.lex_state = 8, .external_lex_state = 138},
  [8526] = {.lex_state = 0, .external_lex_state = 174},
  [8527] = {.lex_state = 0, .external_lex_state = 174},
  [8528] = {.lex_state = 0, .external_lex_state = 174},
  [8529] = {.lex_state = 8, .external_lex_state = 138},
  [8530] = {.lex_state = 0, .external_lex_state = 174},
  [8531] = {.lex_state = 8, .external_lex_state = 138},
  [8532] = {.lex_state = 4, .external_lex_state = 175},
  [8533] = {.lex_state = 8, .external_lex_state = 138},
  [8534] = {.lex_state = 8, .external_lex_state = 138},
  [8535] = {.lex_state = 0, .external_lex_state = 166},
  [8536] = {.lex_state = 8, .external_lex_state = 138},
  [8537] = {.lex_state = 0, .external_lex_state = 174},
  [8538] = {.lex_state = 8, .external_lex_state = 138},
  [8539] = {.lex_state = 8, .external_lex_state = 138},
  [8540] = {.lex_state = 8, .external_lex_state = 138},
  [8541] = {.lex_state = 0, .external_lex_state = 166},
  [8542] = {.lex_state = 8, .external_lex_state = 138},
  [8543] = {.lex_state = 8, .external_lex_state = 138},
  [8544] = {.lex_state = 8, .external_lex_state = 138},
  [8545] = {.lex_state = 0, .external_lex_state = 166},
  [8546] = {.lex_state = 8, .external_lex_state = 138},
  [8547] = {.lex_state = 8, .external_lex_state = 138},
  [8548] = {.lex_state = 8, .external_lex_state = 138},
  [8549] = {.lex_state = 8, .external_lex_state = 138},
  [8550] = {.lex_state = 8, .external_lex_state = 138},
  [8551] = {.lex_state = 0, .external_lex_state = 166},
  [8552] = {.lex_state = 10, .external_lex_state = 155},
  [8553] = {.lex_state = 3, .external_lex_state = 169},
  [8554] = {.lex_state = 10, .external_lex_state = 155},
  [8555] = {.lex_state = 10, .external_lex_state = 155},
  [8556] = {.lex_state = 3, .external_lex_state = 169},
  [8557] = {.lex_state = 10, .external_lex_state = 155},
  [8558] = {.lex_state = 3, .external_lex_state = 169},
  [8559] = {.lex_state = 3, .external_lex_state = 169},
  [8560] = {.lex_state = 3, .external_lex_state = 169},
  [8561] = {.lex_state = 3, .external_lex_state = 169},
  [8562] = {.lex_state = 3, .external_lex_state = 162},
  [8563] = {.lex_state = 3, .external_lex_state = 169},
  [8564] = {.lex_state = 3, .external_lex_state = 169},
  [8565] = {.lex_state = 3, .external_lex_state = 169},
  [8566] = {.lex_state = 3, .external_lex_state = 169},
  [8567] = {.lex_state = 3, .external_lex_state = 169},
  [8568] = {.lex_state = 10, .external_lex_state = 155},
  [8569] = {.lex_state = 8, .external_lex_state = 138},
  [8570] = {.lex_state = 3, .external_lex_state = 169},
  [8571] = {.lex_state = 8, .external_lex_state = 138},
  [8572] = {.lex_state = 3, .external_lex_state = 169},
  [8573] = {.lex_state = 3, .external_lex_state = 162},
  [8574] = {.lex_state = 8, .external_lex_state = 138},
  [8575] = {.lex_state = 10, .external_lex_state = 155},
  [8576] = {.lex_state = 3, .external_lex_state = 162},
  [8577] = {.lex_state = 0, .external_lex_state = 187},
  [8578] = {.lex_state = 10, .external_lex_state = 155},
  [8579] = {.lex_state = 10, .external_lex_state = 155},
  [8580] = {.lex_state = 10, .external_lex_state = 155},
  [8581] = {.lex_state = 8, .external_lex_state = 133},
  [8582] = {.lex_state = 3, .external_lex_state = 162},
  [8583] = {.lex_state = 3, .external_lex_state = 169},
  [8584] = {.lex_state = 10, .external_lex_state = 155},
  [8585] = {.lex_state = 3, .external_lex_state = 169},
  [8586] = {.lex_state = 10, .external_lex_state = 155},
  [8587] = {.lex_state = 3, .external_lex_state = 162},
  [8588] = {.lex_state = 3, .external_lex_state = 169},
  [8589] = {.lex_state = 3, .external_lex_state = 162},
  [8590] = {.lex_state = 10, .external_lex_state = 155},
  [8591] = {.lex_state = 3, .external_lex_state = 162},
  [8592] = {.lex_state = 3, .external_lex_state = 169},
  [8593] = {.lex_state = 10, .external_lex_state = 155},
  [8594] = {.lex_state = 10, .external_lex_state = 155},
  [8595] = {.lex_state = 8, .external_lex_state = 138},
  [8596] = {.lex_state = 3, .external_lex_state = 162},
  [8597] = {.lex_state = 10, .external_lex_state = 155},
  [8598] = {.lex_state = 10, .external_lex_state = 155},
  [8599] = {.lex_state = 10, .external_lex_state = 155},
  [8600] = {.lex_state = 10, .external_lex_state = 155},
  [8601] = {.lex_state = 3, .external_lex_state = 169},
  [8602] = {.lex_state = 0, .external_lex_state = 162},
  [8603] = {.lex_state = 3, .external_lex_state = 169},
  [8604] = {.lex_state = 3, .external_lex_state = 169},
  [8605] = {.lex_state = 3, .external_lex_state = 169},
  [8606] = {.lex_state = 10, .external_lex_state = 155},
  [8607] = {.lex_state = 3, .external_lex_state = 162},
  [8608] = {.lex_state = 0, .external_lex_state = 162},
  [8609] = {.lex_state = 0, .external_lex_state = 188},
  [8610] = {.lex_state = 3, .external_lex_state = 155},
  [8611] = {.lex_state = 3, .external_lex_state = 155},
  [8612] = {.lex_state = 0, .external_lex_state = 162},
  [8613] = {.lex_state = 0, .external_lex_state = 162},
  [8614] = {.lex_state = 4, .external_lex_state = 166},
  [8615] = {.lex_state = 0, .external_lex_state = 162},
  [8616] = {.lex_state = 4, .external_lex_state = 166},
  [8617] = {.lex_state = 0, .external_lex_state = 166},
  [8618] = {.lex_state = 4, .external_lex_state = 166},
  [8619] = {.lex_state = 4, .external_lex_state = 166},
  [8620] = {.lex_state = 0, .external_lex_state = 166},
  [8621] = {.lex_state = 0, .external_lex_state = 188},
  [8622] = {.lex_state = 3, .external_lex_state = 155},
  [8623] = {.lex_state = 4, .external_lex_state = 170},
  [8624] = {.lex_state = 0, .external_lex_state = 162},
  [8625] = {.lex_state = 4, .external_lex_state = 170},
  [8626] = {.lex_state = 4, .external_lex_state = 170},
  [8627] = {.lex_state = 4, .external_lex_state = 170},
  [8628] = {.lex_state = 4, .external_lex_state = 170},
  [8629] = {.lex_state = 0, .external_lex_state = 162},
  [8630] = {.lex_state = 0, .external_lex_state = 166},
  [8631] = {.lex_state = 0, .external_lex_state = 166},
  [8632] = {.lex_state = 0, .external_lex_state = 180},
  [8633] = {.lex_state = 0, .external_lex_state = 180},
  [8634] = {.lex_state = 0, .external_lex_state = 162},
  [8635] = {.lex_state = 0, .external_lex_state = 180},
  [8636] = {.lex_state = 4, .external_lex_state = 170},
  [8637] = {.lex_state = 0, .external_lex_state = 166},
  [8638] = {.lex_state = 0, .external_lex_state = 180},
  [8639] = {.lex_state = 0, .external_lex_state = 189},
  [8640] = {.lex_state = 0, .external_lex_state = 180},
  [8641] = {.lex_state = 4, .external_lex_state = 186},
  [8642] = {.lex_state = 0, .external_lex_state = 190},
  [8643] = {.lex_state = 3, .external_lex_state = 155},
  [8644] = {.lex_state = 0, .external_lex_state = 180},
  [8645] = {.lex_state = 4, .external_lex_state = 170},
  [8646] = {.lex_state = 8, .external_lex_state = 138},
  [8647] = {.lex_state = 0, .external_lex_state = 179},
  [8648] = {.lex_state = 0, .external_lex_state = 166},
  [8649] = {.lex_state = 8, .external_lex_state = 138},
  [8650] = {.lex_state = 0, .external_lex_state = 162},
  [8651] = {.lex_state = 4, .external_lex_state = 186},
  [8652] = {.lex_state = 4, .external_lex_state = 170},
  [8653] = {.lex_state = 3, .external_lex_state = 155},
  [8654] = {.lex_state = 4, .external_lex_state = 170},
  [8655] = {.lex_state = 4, .external_lex_state = 170},
  [8656] = {.lex_state = 0, .external_lex_state = 162},
  [8657] = {.lex_state = 4, .external_lex_state = 170},
  [8658] = {.lex_state = 0, .external_lex_state = 166},
  [8659] = {.lex_state = 0, .external_lex_state = 162},
  [8660] = {.lex_state = 4, .external_lex_state = 170},
  [8661] = {.lex_state = 0, .external_lex_state = 179},
  [8662] = {.lex_state = 3, .external_lex_state = 155},
  [8663] = {.lex_state = 3, .external_lex_state = 155},
  [8664] = {.lex_state = 4, .external_lex_state = 186},
  [8665] = {.lex_state = 0, .external_lex_state = 179},
  [8666] = {.lex_state = 3, .external_lex_state = 191},
  [8667] = {.lex_state = 3, .external_lex_state = 155},
  [8668] = {.lex_state = 0, .external_lex_state = 162},
  [8669] = {.lex_state = 4, .external_lex_state = 166},
  [8670] = {.lex_state = 0, .external_lex_state = 162},
  [8671] = {.lex_state = 0, .external_lex_state = 179},
  [8672] = {.lex_state = 3, .external_lex_state = 155},
  [8673] = {.lex_state = 0, .external_lex_state = 179},
  [8674] = {.lex_state = 0, .external_lex_state = 179},
  [8675] = {.lex_state = 0, .external_lex_state = 189},
  [8676] = {.lex_state = 4, .external_lex_state = 166},
  [8677] = {.lex_state = 8, .external_lex_state = 138},
  [8678] = {.lex_state = 3, .external_lex_state = 155},
  [8679] = {.lex_state = 8, .external_lex_state = 138},
  [8680] = {.lex_state = 4, .external_lex_state = 166},
  [8681] = {.lex_state = 0, .external_lex_state = 162},
  [8682] = {.lex_state = 0, .external_lex_state = 162},
  [8683] = {.lex_state = 4, .external_lex_state = 170},
  [8684] = {.lex_state = 0, .external_lex_state = 166},
  [8685] = {.lex_state = 4, .external_lex_state = 170},
  [8686] = {.lex_state = 0, .external_lex_state = 162},
  [8687] = {.lex_state = 8, .external_lex_state = 138},
  [8688] = {.lex_state = 0, .external_lex_state = 166},
  [8689] = {.lex_state = 4, .external_lex_state = 170},
  [8690] = {.lex_state = 8, .external_lex_state = 138},
  [8691] = {.lex_state = 4, .external_lex_state = 170},
  [8692] = {.lex_state = 4, .external_lex_state = 170},
  [8693] = {.lex_state = 0, .external_lex_state = 166},
  [8694] = {.lex_state = 4, .external_lex_state = 170},
  [8695] = {.lex_state = 0, .external_lex_state = 178},
  [8696] = {.lex_state = 3, .external_lex_state = 191},
  [8697] = {.lex_state = 0, .external_lex_state = 166},
  [8698] = {.lex_state = 0, .external_lex_state = 178},
  [8699] = {.lex_state = 0, .external_lex_state = 166},
  [8700] = {.lex_state = 0, .external_lex_state = 162},
  [8701] = {.lex_state = 0, .external_lex_state = 178},
  [8702] = {.lex_state = 4, .external_lex_state = 170},
  [8703] = {.lex_state = 0, .external_lex_state = 162},
  [8704] = {.lex_state = 4, .external_lex_state = 170},
  [8705] = {.lex_state = 4, .external_lex_state = 170},
  [8706] = {.lex_state = 0, .external_lex_state = 162},
  [8707] = {.lex_state = 3, .external_lex_state = 155},
  [8708] = {.lex_state = 0, .external_lex_state = 162},
  [8709] = {.lex_state = 0, .external_lex_state = 162},
  [8710] = {.lex_state = 0, .external_lex_state = 188},
  [8711] = {.lex_state = 0, .external_lex_state = 162},
  [8712] = {.lex_state = 8, .external_lex_state = 138},
  [8713] = {.lex_state = 0, .external_lex_state = 188},
  [8714] = {.lex_state = 0, .external_lex_state = 162},
  [8715] = {.lex_state = 0, .external_lex_state = 166},
  [8716] = {.lex_state = 0, .external_lex_state = 178},
  [8717] = {.lex_state = 0, .external_lex_state = 178},
  [8718] = {.lex_state = 0, .external_lex_state = 178},
  [8719] = {.lex_state = 0, .external_lex_state = 166},
  [8720] = {.lex_state = 4, .external_lex_state = 186},
  [8721] = {.lex_state = 4, .external_lex_state = 192},
  [8722] = {.lex_state = 0, .external_lex_state = 155},
  [8723] = {.lex_state = 0, .external_lex_state = 155},
  [8724] = {.lex_state = 4, .external_lex_state = 192},
  [8725] = {.lex_state = 3, .external_lex_state = 173},
  [8726] = {.lex_state = 3, .external_lex_state = 155},
  [8727] = {.lex_state = 3, .external_lex_state = 173},
  [8728] = {.lex_state = 3, .external_lex_state = 181},
  [8729] = {.lex_state = 3, .external_lex_state = 155},
  [8730] = {.lex_state = 3, .external_lex_state = 173},
  [8731] = {.lex_state = 4, .external_lex_state = 192},
  [8732] = {.lex_state = 4, .external_lex_state = 193},
  [8733] = {.lex_state = 3, .external_lex_state = 181},
  [8734] = {.lex_state = 4, .external_lex_state = 192},
  [8735] = {.lex_state = 4, .external_lex_state = 193},
  [8736] = {.lex_state = 3, .external_lex_state = 173},
  [8737] = {.lex_state = 4, .external_lex_state = 186},
  [8738] = {.lex_state = 4, .external_lex_state = 192},
  [8739] = {.lex_state = 0, .external_lex_state = 155},
  [8740] = {.lex_state = 3, .external_lex_state = 173},
  [8741] = {.lex_state = 3, .external_lex_state = 173},
  [8742] = {.lex_state = 3, .external_lex_state = 173},
  [8743] = {.lex_state = 4, .external_lex_state = 186},
  [8744] = {.lex_state = 4, .external_lex_state = 192},
  [8745] = {.lex_state = 4, .external_lex_state = 186},
  [8746] = {.lex_state = 3, .external_lex_state = 173},
  [8747] = {.lex_state = 3, .external_lex_state = 173},
  [8748] = {.lex_state = 3, .external_lex_state = 181},
  [8749] = {.lex_state = 3, .external_lex_state = 181},
  [8750] = {.lex_state = 3, .external_lex_state = 173},
  [8751] = {.lex_state = 3, .external_lex_state = 181},
  [8752] = {.lex_state = 4, .external_lex_state = 192},
  [8753] = {.lex_state = 3, .external_lex_state = 181},
  [8754] = {.lex_state = 3, .external_lex_state = 181},
  [8755] = {.lex_state = 3, .external_lex_state = 181},
  [8756] = {.lex_state = 3, .external_lex_state = 173},
  [8757] = {.lex_state = 3, .external_lex_state = 181},
  [8758] = {.lex_state = 8, .external_lex_state = 194},
  [8759] = {.lex_state = 3, .external_lex_state = 173},
  [8760] = {.lex_state = 3, .external_lex_state = 181},
  [8761] = {.lex_state = 3, .external_lex_state = 173},
  [8762] = {.lex_state = 3, .external_lex_state = 181},
  [8763] = {.lex_state = 3, .external_lex_state = 173},
  [8764] = {.lex_state = 3, .external_lex_state = 173},
  [8765] = {.lex_state = 3, .external_lex_state = 173},
  [8766] = {.lex_state = 3, .external_lex_state = 173},
  [8767] = {.lex_state = 3, .external_lex_state = 181},
  [8768] = {.lex_state = 3, .external_lex_state = 173},
  [8769] = {.lex_state = 3, .external_lex_state = 173},
  [8770] = {.lex_state = 3, .external_lex_state = 181},
  [8771] = {.lex_state = 3, .external_lex_state = 173},
  [8772] = {.lex_state = 8, .external_lex_state = 171},
  [8773] = {.lex_state = 3, .external_lex_state = 173},
  [8774] = {.lex_state = 0, .external_lex_state = 166},
  [8775] = {.lex_state = 0, .external_lex_state = 166},
  [8776] = {.lex_state = 0, .external_lex_state = 190},
  [8777] = {.lex_state = 4, .external_lex_state = 162},
  [8778] = {.lex_state = 0, .external_lex_state = 187},
  [8779] = {.lex_state = 4, .external_lex_state = 162},
  [8780] = {.lex_state = 3, .external_lex_state = 155},
  [8781] = {.lex_state = 0, .external_lex_state = 166},
  [8782] = {.lex_state = 0, .external_lex_state = 187},
  [8783] = {.lex_state = 0, .external_lex_state = 195},
  [8784] = {.lex_state = 0, .external_lex_state = 166},
  [8785] = {.lex_state = 0, .external_lex_state = 166},
  [8786] = {.lex_state = 0, .external_lex_state = 166},
  [8787] = {.lex_state = 0, .external_lex_state = 166},
  [8788] = {.lex_state = 0, .external_lex_state = 166},
  [8789] = {.lex_state = 0, .external_lex_state = 166},
  [8790] = {.lex_state = 0, .external_lex_state = 166},
  [8791] = {.lex_state = 4, .external_lex_state = 162},
  [8792] = {.lex_state = 3, .external_lex_state = 155},
  [8793] = {.lex_state = 0, .external_lex_state = 166},
  [8794] = {.lex_state = 4, .external_lex_state = 162},
  [8795] = {.lex_state = 0, .external_lex_state = 166},
  [8796] = {.lex_state = 0, .external_lex_state = 166},
  [8797] = {.lex_state = 0, .external_lex_state = 166},
  [8798] = {.lex_state = 0, .external_lex_state = 166},
  [8799] = {.lex_state = 0, .external_lex_state = 166},
  [8800] = {.lex_state = 0, .external_lex_state = 166},
  [8801] = {.lex_state = 0, .external_lex_state = 166},
  [8802] = {.lex_state = 0, .external_lex_state = 187},
  [8803] = {.lex_state = 3, .external_lex_state = 155},
  [8804] = {.lex_state = 0, .external_lex_state = 166},
  [8805] = {.lex_state = 0, .external_lex_state = 166},
  [8806] = {.lex_state = 0, .external_lex_state = 166},
  [8807] = {.lex_state = 0, .external_lex_state = 166},
  [8808] = {.lex_state = 0, .external_lex_state = 166},
  [8809] = {.lex_state = 0, .external_lex_state = 166},
  [8810] = {.lex_state = 0, .external_lex_state = 166},
  [8811] = {.lex_state = 0, .external_lex_state = 166},
  [8812] = {.lex_state = 0, .external_lex_state = 166},
  [8813] = {.lex_state = 0, .external_lex_state = 155},
  [8814] = {.lex_state = 0, .external_lex_state = 166},
  [8815] = {.lex_state = 0, .external_lex_state = 166},
  [8816] = {.lex_state = 4, .external_lex_state = 186},
  [8817] = {.lex_state = 0, .external_lex_state = 166},
  [8818] = {.lex_state = 0, .external_lex_state = 166},
  [8819] = {.lex_state = 0, .external_lex_state = 166},
  [8820] = {.lex_state = 0, .external_lex_state = 166},
  [8821] = {.lex_state = 0, .external_lex_state = 166},
  [8822] = {.lex_state = 0, .external_lex_state = 166},
  [8823] = {.lex_state = 0, .external_lex_state = 166},
  [8824] = {.lex_state = 0, .external_lex_state = 166},
  [8825] = {.lex_state = 0, .external_lex_state = 166},
  [8826] = {.lex_state = 4, .external_lex_state = 162},
  [8827] = {.lex_state = 0, .external_lex_state = 187},
  [8828] = {.lex_state = 0, .external_lex_state = 166},
  [8829] = {.lex_state = 0, .external_lex_state = 166},
  [8830] = {.lex_state = 0, .external_lex_state = 166},
  [8831] = {.lex_state = 0, .external_lex_state = 166},
  [8832] = {.lex_state = 0, .external_lex_state = 166},
  [8833] = {.lex_state = 0, .external_lex_state = 187},
  [8834] = {.lex_state = 0, .external_lex_state = 187},
  [8835] = {.lex_state = 0, .external_lex_state = 166},
  [8836] = {.lex_state = 4, .external_lex_state = 182},
  [8837] = {.lex_state = 0, .external_lex_state = 166},
  [8838] = {.lex_state = 4, .external_lex_state = 162},
  [8839] = {.lex_state = 4, .external_lex_state = 182},
  [8840] = {.lex_state = 0, .external_lex_state = 166},
  [8841] = {.lex_state = 0, .external_lex_state = 166},
  [8842] = {.lex_state = 0, .external_lex_state = 195},
  [8843] = {.lex_state = 0, .external_lex_state = 166},
  [8844] = {.lex_state = 0, .external_lex_state = 188},
  [8845] = {.lex_state = 0, .external_lex_state = 188},
  [8846] = {.lex_state = 4, .external_lex_state = 196},
  [8847] = {.lex_state = 0, .external_lex_state = 188},
  [8848] = {.lex_state = 3, .external_lex_state = 155},
  [8849] = {.lex_state = 0, .external_lex_state = 188},
  [8850] = {.lex_state = 4, .external_lex_state = 182},
  [8851] = {.lex_state = 0, .external_lex_state = 166},
  [8852] = {.lex_state = 0, .external_lex_state = 187},
  [8853] = {.lex_state = 4, .external_lex_state = 196},
  [8854] = {.lex_state = 4, .external_lex_state = 182},
  [8855] = {.lex_state = 4, .external_lex_state = 182},
  [8856] = {.lex_state = 3, .external_lex_state = 155},
  [8857] = {.lex_state = 4, .external_lex_state = 182},
  [8858] = {.lex_state = 4, .external_lex_state = 196},
  [8859] = {.lex_state = 3, .external_lex_state = 172},
  [8860] = {.lex_state = 3, .external_lex_state = 172},
  [8861] = {.lex_state = 4, .external_lex_state = 184},
  [8862] = {.lex_state = 3, .external_lex_state = 191},
  [8863] = {.lex_state = 0, .external_lex_state = 197},
  [8864] = {.lex_state = 0, .external_lex_state = 191},
  [8865] = {.lex_state = 0, .external_lex_state = 155},
  [8866] = {.lex_state = 3, .external_lex_state = 187},
  [8867] = {.lex_state = 4, .external_lex_state = 184},
  [8868] = {.lex_state = 4, .external_lex_state = 184},
  [8869] = {.lex_state = 3, .external_lex_state = 198},
  [8870] = {.lex_state = 1, .external_lex_state = 155},
  [8871] = {.lex_state = 3, .external_lex_state = 187},
  [8872] = {.lex_state = 3, .external_lex_state = 187},
  [8873] = {.lex_state = 4, .external_lex_state = 184},
  [8874] = {.lex_state = 0, .external_lex_state = 190},
  [8875] = {.lex_state = 3, .external_lex_state = 191},
  [8876] = {.lex_state = 3, .external_lex_state = 198},
  [8877] = {.lex_state = 3, .external_lex_state = 191},
  [8878] = {.lex_state = 3, .external_lex_state = 191},
  [8879] = {.lex_state = 1, .external_lex_state = 155},
  [8880] = {.lex_state = 3, .external_lex_state = 172},
  [8881] = {.lex_state = 3, .external_lex_state = 172},
  [8882] = {.lex_state = 3, .external_lex_state = 191},
  [8883] = {.lex_state = 0, .external_lex_state = 197},
  [8884] = {.lex_state = 3, .external_lex_state = 172},
  [8885] = {.lex_state = 3, .external_lex_state = 191},
  [8886] = {.lex_state = 0, .external_lex_state = 199},
  [8887] = {.lex_state = 4, .external_lex_state = 184},
  [8888] = {.lex_state = 4, .external_lex_state = 193},
  [8889] = {.lex_state = 3, .external_lex_state = 172},
  [8890] = {.lex_state = 3, .external_lex_state = 172},
  [8891] = {.lex_state = 1, .external_lex_state = 155},
  [8892] = {.lex_state = 3, .external_lex_state = 198},
  [8893] = {.lex_state = 0, .external_lex_state = 187},
  [8894] = {.lex_state = 3, .external_lex_state = 198},
  [8895] = {.lex_state = 3, .external_lex_state = 172},
  [8896] = {.lex_state = 3, .external_lex_state = 172},
  [8897] = {.lex_state = 0, .external_lex_state = 155},
  [8898] = {.lex_state = 3, .external_lex_state = 172},
  [8899] = {.lex_state = 3, .external_lex_state = 172},
  [8900] = {.lex_state = 3, .external_lex_state = 172},
  [8901] = {.lex_state = 3, .external_lex_state = 172},
  [8902] = {.lex_state = 3, .external_lex_state = 172},
  [8903] = {.lex_state = 3, .external_lex_state = 172},
  [8904] = {.lex_state = 4, .external_lex_state = 184},
  [8905] = {.lex_state = 4, .external_lex_state = 193},
  [8906] = {.lex_state = 0, .external_lex_state = 191},
  [8907] = {.lex_state = 1, .external_lex_state = 155},
  [8908] = {.lex_state = 3, .external_lex_state = 172},
  [8909] = {.lex_state = 3, .external_lex_state = 172},
  [8910] = {.lex_state = 3, .external_lex_state = 198},
  [8911] = {.lex_state = 3, .external_lex_state = 198},
  [8912] = {.lex_state = 3, .external_lex_state = 187},
  [8913] = {.lex_state = 1, .external_lex_state = 155},
  [8914] = {.lex_state = 4, .external_lex_state = 193},
  [8915] = {.lex_state = 3, .external_lex_state = 198},
  [8916] = {.lex_state = 0, .external_lex_state = 155},
  [8917] = {.lex_state = 3, .external_lex_state = 172},
  [8918] = {.lex_state = 3, .external_lex_state = 172},
  [8919] = {.lex_state = 3, .external_lex_state = 172},
  [8920] = {.lex_state = 0, .external_lex_state = 155},
  [8921] = {.lex_state = 0, .external_lex_state = 155},
  [8922] = {.lex_state = 4, .external_lex_state = 183},
  [8923] = {.lex_state = 0, .external_lex_state = 200},
  [8924] = {.lex_state = 3, .external_lex_state = 155},
  [8925] = {.lex_state = 3, .external_lex_state = 191},
  [8926] = {.lex_state = 3, .external_lex_state = 198},
  [8927] = {.lex_state = 4, .external_lex_state = 183},
  [8928] = {.lex_state = 1, .external_lex_state = 155},
  [8929] = {.lex_state = 0, .external_lex_state = 187},
  [8930] = {.lex_state = 4, .external_lex_state = 183},
  [8931] = {.lex_state = 4, .external_lex_state = 183},
  [8932] = {.lex_state = 4, .external_lex_state = 183},
  [8933] = {.lex_state = 0, .external_lex_state = 153},
  [8934] = {.lex_state = 0, .external_lex_state = 201},
  [8935] = {.lex_state = 0, .external_lex_state = 187},
  [8936] = {.lex_state = 0, .external_lex_state = 187},
  [8937] = {.lex_state = 4, .external_lex_state = 183},
  [8938] = {.lex_state = 4, .external_lex_state = 193},
  [8939] = {.lex_state = 0, .external_lex_state = 155},
  [8940] = {.lex_state = 3, .external_lex_state = 155},
  [8941] = {.lex_state = 1, .external_lex_state = 155},
  [8942] = {.lex_state = 3, .external_lex_state = 172},
  [8943] = {.lex_state = 0, .external_lex_state = 190},
  [8944] = {.lex_state = 3, .external_lex_state = 191},
  [8945] = {.lex_state = 3, .external_lex_state = 191},
  [8946] = {.lex_state = 3, .external_lex_state = 191},
  [8947] = {.lex_state = 3, .external_lex_state = 191},
  [8948] = {.lex_state = 3, .external_lex_state = 191},
  [8949] = {.lex_state = 3, .external_lex_state = 191},
  [8950] = {.lex_state = 4, .external_lex_state = 193},
  [8951] = {.lex_state = 0, .external_lex_state = 202},
  [8952] = {.lex_state = 0, .external_lex_state = 202},
  [8953] = {.lex_state = 0, .external_lex_state = 202},
  [8954] = {.lex_state = 0, .external_lex_state = 202},
  [8955] = {.lex_state = 0, .external_lex_state = 202},
  [8956] = {.lex_state = 4, .external_lex_state = 196},
  [8957] = {.lex_state = 4, .external_lex_state = 196},
  [8958] = {.lex_state = 4, .external_lex_state = 196},
  [8959] = {.lex_state = 0, .external_lex_state = 155},
  [8960] = {.lex_state = 4, .external_lex_state = 186},
  [8961] = {.lex_state = 0, .external_lex_state = 187},
  [8962] = {.lex_state = 0, .external_lex_state = 187},
  [8963] = {.lex_state = 0, .external_lex_state = 187},
  [8964] = {.lex_state = 4, .external_lex_state = 186},
  [8965] = {.lex_state = 4, .external_lex_state = 186},
  [8966] = {.lex_state = 4, .external_lex_state = 186},
  [8967] = {.lex_state = 4, .external_lex_state = 186},
  [8968] = {.lex_state = 4, .external_lex_state = 186},
  [8969] = {.lex_state = 0, .external_lex_state = 187},
  [8970] = {.lex_state = 4, .external_lex_state = 192},
  [8971] = {.lex_state = 4, .external_lex_state = 186},
  [8972] = {.lex_state = 1, .external_lex_state = 155},
  [8973] = {.lex_state = 0, .external_lex_state = 185},
  [8974] = {.lex_state = 4, .external_lex_state = 192},
  [8975] = {.lex_state = 3, .external_lex_state = 166},
  [8976] = {.lex_state = 0, .external_lex_state = 203},
  [8977] = {.lex_state = 1, .external_lex_state = 155},
  [8978] = {.lex_state = 3, .external_lex_state = 166},
  [8979] = {.lex_state = 3, .external_lex_state = 166},
  [8980] = {.lex_state = 4, .external_lex_state = 196},
  [8981] = {.lex_state = 0, .external_lex_state = 185},
  [8982] = {.lex_state = 4, .external_lex_state = 186},
  [8983] = {.lex_state = 0, .external_lex_state = 185},
  [8984] = {.lex_state = 0, .external_lex_state = 185},
  [8985] = {.lex_state = 0, .external_lex_state = 185},
  [8986] = {.lex_state = 4, .external_lex_state = 186},
  [8987] = {.lex_state = 3, .external_lex_state = 166},
  [8988] = {.lex_state = 3, .external_lex_state = 166},
  [8989] = {.lex_state = 0, .external_lex_state = 191},
  [8990] = {.lex_state = 4, .external_lex_state = 186},
  [8991] = {.lex_state = 0, .external_lex_state = 202},
  [8992] = {.lex_state = 0, .external_lex_state = 202},
  [8993] = {.lex_state = 0, .external_lex_state = 155},
  [8994] = {.lex_state = 0, .external_lex_state = 202},
  [8995] = {.lex_state = 0, .external_lex_state = 191},
  [8996] = {.lex_state = 4, .external_lex_state = 196},
  [8997] = {.lex_state = 0, .external_lex_state = 202},
  [8998] = {.lex_state = 0, .external_lex_state = 187},
  [8999] = {.lex_state = 4, .external_lex_state = 192},
  [9000] = {.lex_state = 3, .external_lex_state = 166},
  [9001] = {.lex_state = 4, .external_lex_state = 186},
  [9002] = {.lex_state = 4, .external_lex_state = 186},
  [9003] = {.lex_state = 0, .external_lex_state = 202},
  [9004] = {.lex_state = 0, .external_lex_state = 202},
  [9005] = {.lex_state = 0, .external_lex_state = 202},
  [9006] = {.lex_state = 0, .external_lex_state = 202},
  [9007] = {.lex_state = 0, .external_lex_state = 202},
  [9008] = {.lex_state = 0, .external_lex_state = 202},
  [9009] = {.lex_state = 0, .external_lex_state = 202},
  [9010] = {.lex_state = 0, .external_lex_state = 202},
  [9011] = {.lex_state = 0, .external_lex_state = 202},
  [9012] = {.lex_state = 4, .external_lex_state = 186},
  [9013] = {.lex_state = 4, .external_lex_state = 196},
  [9014] = {.lex_state = 4, .external_lex_state = 196},
  [9015] = {.lex_state = 1, .external_lex_state = 155},
  [9016] = {.lex_state = 0, .external_lex_state = 202},
  [9017] = {.lex_state = 4, .external_lex_state = 196},
  [9018] = {.lex_state = 0, .external_lex_state = 202},
  [9019] = {.lex_state = 4, .external_lex_state = 196},
  [9020] = {.lex_state = 0, .external_lex_state = 202},
  [9021] = {.lex_state = 4, .external_lex_state = 186},
  [9022] = {.lex_state = 4, .external_lex_state = 186},
  [9023] = {.lex_state = 0, .external_lex_state = 155},
  [9024] = {.lex_state = 0, .external_lex_state = 202},
  [9025] = {.lex_state = 0, .external_lex_state = 202},
  [9026] = {.lex_state = 0, .external_lex_state = 202},
  [9027] = {.lex_state = 0, .external_lex_state = 202},
  [9028] = {.lex_state = 0, .external_lex_state = 202},
  [9029] = {.lex_state = 0, .external_lex_state = 202},
  [9030] = {.lex_state = 0, .external_lex_state = 155},
  [9031] = {.lex_state = 4, .external_lex_state = 196},
  [9032] = {.lex_state = 4, .external_lex_state = 196},
  [9033] = {.lex_state = 0, .external_lex_state = 202},
  [9034] = {.lex_state = 4, .external_lex_state = 192},
  [9035] = {.lex_state = 4, .external_lex_state = 192},
  [9036] = {.lex_state = 1, .external_lex_state = 155},
  [9037] = {.lex_state = 4, .external_lex_state = 186},
  [9038] = {.lex_state = 4, .external_lex_state = 196},
  [9039] = {.lex_state = 4, .external_lex_state = 196},
  [9040] = {.lex_state = 4, .external_lex_state = 196},
  [9041] = {.lex_state = 4, .external_lex_state = 196},
  [9042] = {.lex_state = 4, .external_lex_state = 196},
  [9043] = {.lex_state = 0, .external_lex_state = 202},
  [9044] = {.lex_state = 4, .external_lex_state = 196},
  [9045] = {.lex_state = 4, .external_lex_state = 192},
  [9046] = {.lex_state = 0, .external_lex_state = 202},
  [9047] = {.lex_state = 4, .external_lex_state = 196},
  [9048] = {.lex_state = 4, .external_lex_state = 196},
  [9049] = {.lex_state = 4, .external_lex_state = 192},
  [9050] = {.lex_state = 0, .external_lex_state = 191},
  [9051] = {.lex_state = 0, .external_lex_state = 185},
  [9052] = {.lex_state = 3, .external_lex_state = 166},
  [9053] = {.lex_state = 3, .external_lex_state = 166},
  [9054] = {.lex_state = 0, .external_lex_state = 191},
  [9055] = {.lex_state = 4, .external_lex_state = 196},
  [9056] = {.lex_state = 4, .external_lex_state = 196},
  [9057] = {.lex_state = 4, .external_lex_state = 196},
  [9058] = {.lex_state = 1, .external_lex_state = 155},
  [9059] = {.lex_state = 0, .external_lex_state = 202},
  [9060] = {.lex_state = 0, .external_lex_state = 202},
  [9061] = {.lex_state = 0, .external_lex_state = 204},
  [9062] = {.lex_state = 0, .external_lex_state = 202},
  [9063] = {.lex_state = 0, .external_lex_state = 191},
  [9064] = {.lex_state = 0, .external_lex_state = 191},
  [9065] = {.lex_state = 4, .external_lex_state = 196},
  [9066] = {.lex_state = 0, .external_lex_state = 204},
  [9067] = {.lex_state = 0, .external_lex_state = 202},
  [9068] = {.lex_state = 0, .external_lex_state = 202},
  [9069] = {.lex_state = 0, .external_lex_state = 191},
  [9070] = {.lex_state = 0, .external_lex_state = 202},
  [9071] = {.lex_state = 4, .external_lex_state = 192},
  [9072] = {.lex_state = 0, .external_lex_state = 204},
  [9073] = {.lex_state = 4, .external_lex_state = 186},
  [9074] = {.lex_state = 0, .external_lex_state = 202},
  [9075] = {.lex_state = 3, .external_lex_state = 166},
  [9076] = {.lex_state = 0, .external_lex_state = 202},
  [9077] = {.lex_state = 0, .external_lex_state = 155},
  [9078] = {.lex_state = 0, .external_lex_state = 204},
  [9079] = {.lex_state = 4, .external_lex_state = 196},
  [9080] = {.lex_state = 4, .external_lex_state = 196},
  [9081] = {.lex_state = 4, .external_lex_state = 196},
  [9082] = {.lex_state = 4, .external_lex_state = 196},
  [9083] = {.lex_state = 4, .external_lex_state = 196},
  [9084] = {.lex_state = 4, .external_lex_state = 196},
  [9085] = {.lex_state = 4, .external_lex_state = 196},
  [9086] = {.lex_state = 4, .external_lex_state = 196},
  [9087] = {.lex_state = 4, .external_lex_state = 196},
  [9088] = {.lex_state = 4, .external_lex_state = 196},
  [9089] = {.lex_state = 3, .external_lex_state = 166},
  [9090] = {.lex_state = 0, .external_lex_state = 202},
  [9091] = {.lex_state = 0, .external_lex_state = 202},
  [9092] = {.lex_state = 3, .external_lex_state = 166},
  [9093] = {.lex_state = 4, .external_lex_state = 196},
  [9094] = {.lex_state = 1, .external_lex_state = 155},
  [9095] = {.lex_state = 4, .external_lex_state = 166},
  [9096] = {.lex_state = 4, .external_lex_state = 192},
  [9097] = {.lex_state = 4, .external_lex_state = 196},
  [9098] = {.lex_state = 0, .external_lex_state = 155},
  [9099] = {.lex_state = 0, .external_lex_state = 187},
  [9100] = {.lex_state = 0, .external_lex_state = 187},
  [9101] = {.lex_state = 0, .external_lex_state = 205},
  [9102] = {.lex_state = 3, .external_lex_state = 166},
  [9103] = {.lex_state = 0, .external_lex_state = 202},
  [9104] = {.lex_state = 4, .external_lex_state = 186},
  [9105] = {.lex_state = 0, .external_lex_state = 202},
  [9106] = {.lex_state = 8, .external_lex_state = 138},
  [9107] = {.lex_state = 0, .external_lex_state = 202},
  [9108] = {.lex_state = 3, .external_lex_state = 166},
  [9109] = {.lex_state = 0, .external_lex_state = 202},
  [9110] = {.lex_state = 0, .external_lex_state = 202},
  [9111] = {.lex_state = 4, .external_lex_state = 196},
  [9112] = {.lex_state = 0, .external_lex_state = 202},
  [9113] = {.lex_state = 0, .external_lex_state = 202},
  [9114] = {.lex_state = 0, .external_lex_state = 202},
  [9115] = {.lex_state = 4, .external_lex_state = 196},
  [9116] = {.lex_state = 0, .external_lex_state = 202},
  [9117] = {.lex_state = 0, .external_lex_state = 187},
  [9118] = {.lex_state = 4, .external_lex_state = 196},
  [9119] = {.lex_state = 3, .external_lex_state = 166},
  [9120] = {.lex_state = 4, .external_lex_state = 196},
  [9121] = {.lex_state = 4, .external_lex_state = 196},
  [9122] = {.lex_state = 4, .external_lex_state = 196},
  [9123] = {.lex_state = 4, .external_lex_state = 196},
  [9124] = {.lex_state = 0, .external_lex_state = 202},
  [9125] = {.lex_state = 0, .external_lex_state = 202},
  [9126] = {.lex_state = 0, .external_lex_state = 202},
  [9127] = {.lex_state = 0, .external_lex_state = 202},
  [9128] = {.lex_state = 0, .external_lex_state = 202},
  [9129] = {.lex_state = 0, .external_lex_state = 202},
  [9130] = {.lex_state = 0, .external_lex_state = 202},
  [9131] = {.lex_state = 0, .external_lex_state = 202},
  [9132] = {.lex_state = 0, .external_lex_state = 202},
  [9133] = {.lex_state = 0, .external_lex_state = 197},
  [9134] = {.lex_state = 4, .external_lex_state = 206},
  [9135] = {.lex_state = 4, .external_lex_state = 166},
  [9136] = {.lex_state = 0, .external_lex_state = 202},
  [9137] = {.lex_state = 1, .external_lex_state = 155},
  [9138] = {.lex_state = 0, .external_lex_state = 187},
  [9139] = {.lex_state = 0, .external_lex_state = 187},
  [9140] = {.lex_state = 4, .external_lex_state = 192},
  [9141] = {.lex_state = 0, .external_lex_state = 187},
  [9142] = {.lex_state = 0, .external_lex_state = 155},
  [9143] = {.lex_state = 0, .external_lex_state = 187},
  [9144] = {.lex_state = 1, .external_lex_state = 155},
  [9145] = {.lex_state = 0, .external_lex_state = 187},
  [9146] = {.lex_state = 0, .external_lex_state = 187},
  [9147] = {.lex_state = 0, .external_lex_state = 187},
  [9148] = {.lex_state = 0, .external_lex_state = 187},
  [9149] = {.lex_state = 0, .external_lex_state = 187},
  [9150] = {.lex_state = 0, .external_lex_state = 155},
  [9151] = {.lex_state = 0, .external_lex_state = 187},
  [9152] = {.lex_state = 0, .external_lex_state = 187},
  [9153] = {.lex_state = 0, .external_lex_state = 187},
  [9154] = {.lex_state = 0, .external_lex_state = 155},
  [9155] = {.lex_state = 0, .external_lex_state = 155},
  [9156] = {.lex_state = 0, .external_lex_state = 155},
  [9157] = {.lex_state = 0, .external_lex_state = 187},
  [9158] = {.lex_state = 0, .external_lex_state = 187},
  [9159] = {.lex_state = 0, .external_lex_state = 187},
  [9160] = {.lex_state = 0, .external_lex_state = 191},
  [9161] = {.lex_state = 1, .external_lex_state = 155},
  [9162] = {.lex_state = 0, .external_lex_state = 187},
  [9163] = {.lex_state = 0, .external_lex_state = 187},
  [9164] = {.lex_state = 0, .external_lex_state = 155},
  [9165] = {.lex_state = 0, .external_lex_state = 205},
  [9166] = {.lex_state = 4, .external_lex_state = 207},
  [9167] = {.lex_state = 0, .external_lex_state = 187},
  [9168] = {.lex_state = 0, .external_lex_state = 155},
  [9169] = {.lex_state = 1, .external_lex_state = 155},
  [9170] = {.lex_state = 1, .external_lex_state = 155},
  [9171] = {.lex_state = 0, .external_lex_state = 155},
  [9172] = {.lex_state = 0, .external_lex_state = 187},
  [9173] = {.lex_state = 0, .external_lex_state = 187},
  [9174] = {.lex_state = 1, .external_lex_state = 155},
  [9175] = {.lex_state = 0, .external_lex_state = 155},
  [9176] = {.lex_state = 0, .external_lex_state = 187},
  [9177] = {.lex_state = 0, .external_lex_state = 158},
  [9178] = {.lex_state = 1, .external_lex_state = 155},
  [9179] = {.lex_state = 0, .external_lex_state = 187},
  [9180] = {.lex_state = 0, .external_lex_state = 155},
  [9181] = {.lex_state = 0, .external_lex_state = 187},
  [9182] = {.lex_state = 0, .external_lex_state = 187},
  [9183] = {.lex_state = 0, .external_lex_state = 155},
  [9184] = {.lex_state = 0, .external_lex_state = 187},
  [9185] = {.lex_state = 0, .external_lex_state = 187},
  [9186] = {.lex_state = 0, .external_lex_state = 187},
  [9187] = {.lex_state = 0, .external_lex_state = 187},
  [9188] = {.lex_state = 0, .external_lex_state = 155},
  [9189] = {.lex_state = 1, .external_lex_state = 155},
  [9190] = {.lex_state = 0, .external_lex_state = 187},
  [9191] = {.lex_state = 4, .external_lex_state = 207},
  [9192] = {.lex_state = 1, .external_lex_state = 155},
  [9193] = {.lex_state = 0, .external_lex_state = 187},
  [9194] = {.lex_state = 0, .external_lex_state = 187},
  [9195] = {.lex_state = 0, .external_lex_state = 187},
  [9196] = {.lex_state = 0, .external_lex_state = 155},
  [9197] = {.lex_state = 0, .external_lex_state = 155},
  [9198] = {.lex_state = 0, .external_lex_state = 187},
  [9199] = {.lex_state = 0, .external_lex_state = 187},
  [9200] = {.lex_state = 0, .external_lex_state = 187},
  [9201] = {.lex_state = 0, .external_lex_state = 187},
  [9202] = {.lex_state = 0, .external_lex_state = 187},
  [9203] = {.lex_state = 0, .external_lex_state = 187},
  [9204] = {.lex_state = 1, .external_lex_state = 155},
  [9205] = {.lex_state = 0, .external_lex_state = 187},
  [9206] = {.lex_state = 0, .external_lex_state = 187},
  [9207] = {.lex_state = 0, .external_lex_state = 187},
  [9208] = {.lex_state = 0, .external_lex_state = 187},
  [9209] = {.lex_state = 0, .external_lex_state = 187},
  [9210] = {.lex_state = 0, .external_lex_state = 187},
  [9211] = {.lex_state = 0, .external_lex_state = 187},
  [9212] = {.lex_state = 0, .external_lex_state = 155},
  [9213] = {.lex_state = 0, .external_lex_state = 187},
  [9214] = {.lex_state = 0, .external_lex_state = 187},
  [9215] = {.lex_state = 0, .external_lex_state = 187},
  [9216] = {.lex_state = 0, .external_lex_state = 187},
  [9217] = {.lex_state = 1, .external_lex_state = 155},
  [9218] = {.lex_state = 0, .external_lex_state = 187},
  [9219] = {.lex_state = 1, .external_lex_state = 155},
  [9220] = {.lex_state = 0, .external_lex_state = 155},
  [9221] = {.lex_state = 0, .external_lex_state = 155},
  [9222] = {.lex_state = 1, .external_lex_state = 155},
  [9223] = {.lex_state = 4, .external_lex_state = 207},
  [9224] = {.lex_state = 0, .external_lex_state = 187},
  [9225] = {.lex_state = 0, .external_lex_state = 191},
  [9226] = {.lex_state = 0, .external_lex_state = 204},
  [9227] = {.lex_state = 1, .external_lex_state = 155},
  [9228] = {.lex_state = 0, .external_lex_state = 187},
  [9229] = {.lex_state = 0, .external_lex_state = 187},
  [9230] = {.lex_state = 1, .external_lex_state = 155},
  [9231] = {.lex_state = 4, .external_lex_state = 207},
  [9232] = {.lex_state = 0, .external_lex_state = 155},
  [9233] = {.lex_state = 0, .external_lex_state = 187},
  [9234] = {.lex_state = 0, .external_lex_state = 155},
  [9235] = {.lex_state = 0, .external_lex_state = 187},
  [9236] = {.lex_state = 0, .external_lex_state = 155},
  [9237] = {.lex_state = 0, .external_lex_state = 155},
  [9238] = {.lex_state = 4, .external_lex_state = 207},
  [9239] = {.lex_state = 0, .external_lex_state = 155},
  [9240] = {.lex_state = 0, .external_lex_state = 187},
  [9241] = {.lex_state = 0, .external_lex_state = 187},
  [9242] = {.lex_state = 0, .external_lex_state = 187},
  [9243] = {.lex_state = 0, .external_lex_state = 187},
  [9244] = {.lex_state = 1, .external_lex_state = 155},
  [9245] = {.lex_state = 0, .external_lex_state = 187},
  [9246] = {.lex_state = 0, .external_lex_state = 205},
  [9247] = {.lex_state = 1, .external_lex_state = 155},
  [9248] = {.lex_state = 0, .external_lex_state = 155},
  [9249] = {.lex_state = 0, .external_lex_state = 155},
  [9250] = {.lex_state = 1, .external_lex_state = 155},
  [9251] = {.lex_state = 0, .external_lex_state = 199},
  [9252] = {.lex_state = 0, .external_lex_state = 155},
  [9253] = {.lex_state = 0, .external_lex_state = 187},
  [9254] = {.lex_state = 1, .external_lex_state = 155},
  [9255] = {.lex_state = 0, .external_lex_state = 187},
  [9256] = {.lex_state = 0, .external_lex_state = 155},
  [9257] = {.lex_state = 0, .external_lex_state = 187},
  [9258] = {.lex_state = 0, .external_lex_state = 191},
  [9259] = {.lex_state = 4, .external_lex_state = 207},
  [9260] = {.lex_state = 0, .external_lex_state = 155},
  [9261] = {.lex_state = 4, .external_lex_state = 207},
  [9262] = {.lex_state = 1, .external_lex_state = 155},
  [9263] = {.lex_state = 1, .external_lex_state = 155},
  [9264] = {.lex_state = 0, .external_lex_state = 187},
  [9265] = {.lex_state = 3, .external_lex_state = 187},
  [9266] = {.lex_state = 0, .external_lex_state = 155},
  [9267] = {.lex_state = 0, .external_lex_state = 187},
  [9268] = {.lex_state = 0, .external_lex_state = 187},
  [9269] = {.lex_state = 0, .external_lex_state = 155},
  [9270] = {.lex_state = 0, .external_lex_state = 155},
  [9271] = {.lex_state = 1, .external_lex_state = 155},
  [9272] = {.lex_state = 0, .external_lex_state = 187},
  [9273] = {.lex_state = 8, .external_lex_state = 194},
  [9274] = {.lex_state = 0, .external_lex_state = 187},
  [9275] = {.lex_state = 0, .external_lex_state = 187},
  [9276] = {.lex_state = 0, .external_lex_state = 205},
  [9277] = {.lex_state = 0, .external_lex_state = 187},
  [9278] = {.lex_state = 0, .external_lex_state = 155},
  [9279] = {.lex_state = 1, .external_lex_state = 155},
  [9280] = {.lex_state = 0, .external_lex_state = 187},
  [9281] = {.lex_state = 0, .external_lex_state = 155},
  [9282] = {.lex_state = 0, .external_lex_state = 187},
  [9283] = {.lex_state = 0, .external_lex_state = 187},
  [9284] = {.lex_state = 0, .external_lex_state = 187},
  [9285] = {.lex_state = 4, .external_lex_state = 207},
  [9286] = {.lex_state = 0, .external_lex_state = 187},
  [9287] = {.lex_state = 0, .external_lex_state = 155},
  [9288] = {.lex_state = 1, .external_lex_state = 155},
  [9289] = {.lex_state = 0, .external_lex_state = 155},
  [9290] = {.lex_state = 0, .external_lex_state = 187},
  [9291] = {.lex_state = 0, .external_lex_state = 187},
  [9292] = {.lex_state = 0, .external_lex_state = 155},
  [9293] = {.lex_state = 0, .external_lex_state = 155},
  [9294] = {.lex_state = 0, .external_lex_state = 187},
  [9295] = {.lex_state = 0, .external_lex_state = 187},
  [9296] = {.lex_state = 1, .external_lex_state = 155},
  [9297] = {.lex_state = 0, .external_lex_state = 187},
  [9298] = {.lex_state = 0, .external_lex_state = 204},
  [9299] = {.lex_state = 0, .external_lex_state = 187},
  [9300] = {.lex_state = 0, .external_lex_state = 187},
  [9301] = {.lex_state = 0, .external_lex_state = 187},
  [9302] = {.lex_state = 0, .external_lex_state = 187},
  [9303] = {.lex_state = 0, .external_lex_state = 187},
  [9304] = {.lex_state = 0, .external_lex_state = 187},
  [9305] = {.lex_state = 0, .external_lex_state = 187},
  [9306] = {.lex_state = 0, .external_lex_state = 155},
  [9307] = {.lex_state = 0, .external_lex_state = 187},
  [9308] = {.lex_state = 0, .external_lex_state = 205},
  [9309] = {.lex_state = 0, .external_lex_state = 187},
  [9310] = {.lex_state = 0, .external_lex_state = 187},
  [9311] = {.lex_state = 0, .external_lex_state = 208},
  [9312] = {.lex_state = 1, .external_lex_state = 155},
  [9313] = {.lex_state = 0, .external_lex_state = 187},
  [9314] = {.lex_state = 0, .external_lex_state = 187},
  [9315] = {.lex_state = 0, .external_lex_state = 205},
  [9316] = {.lex_state = 1, .external_lex_state = 155},
  [9317] = {.lex_state = 0, .external_lex_state = 187},
  [9318] = {.lex_state = 1, .external_lex_state = 155},
  [9319] = {.lex_state = 0, .external_lex_state = 155},
  [9320] = {.lex_state = 0, .external_lex_state = 187},
  [9321] = {.lex_state = 0, .external_lex_state = 187},
  [9322] = {.lex_state = 0, .external_lex_state = 187},
  [9323] = {.lex_state = 0, .external_lex_state = 187},
  [9324] = {.lex_state = 0, .external_lex_state = 187},
  [9325] = {.lex_state = 0, .external_lex_state = 187},
  [9326] = {.lex_state = 0, .external_lex_state = 155},
  [9327] = {.lex_state = 0, .external_lex_state = 187},
  [9328] = {.lex_state = 0, .external_lex_state = 187},
  [9329] = {.lex_state = 0, .external_lex_state = 187},
  [9330] = {.lex_state = 0, .external_lex_state = 155},
  [9331] = {.lex_state = 9, .external_lex_state = 187},
  [9332] = {.lex_state = 0, .external_lex_state = 187},
  [9333] = {.lex_state = 0, .external_lex_state = 155},
  [9334] = {.lex_state = 0, .external_lex_state = 155},
  [9335] = {.lex_state = 0, .external_lex_state = 187},
  [9336] = {.lex_state = 0, .external_lex_state = 155},
  [9337] = {.lex_state = 1, .external_lex_state = 155},
  [9338] = {.lex_state = 3, .external_lex_state = 187},
  [9339] = {.lex_state = 0, .external_lex_state = 187},
  [9340] = {.lex_state = 0, .external_lex_state = 187},
  [9341] = {.lex_state = 3, .external_lex_state = 187},
  [9342] = {.lex_state = 0, .external_lex_state = 187},
  [9343] = {.lex_state = 0, .external_lex_state = 187},
  [9344] = {.lex_state = 0, .external_lex_state = 187},
  [9345] = {.lex_state = 0, .external_lex_state = 187},
  [9346] = {.lex_state = 0, .external_lex_state = 187},
  [9347] = {.lex_state = 0, .external_lex_state = 187},
  [9348] = {.lex_state = 1, .external_lex_state = 155},
  [9349] = {.lex_state = 0, .external_lex_state = 187},
  [9350] = {.lex_state = 0, .external_lex_state = 187},
  [9351] = {.lex_state = 3, .external_lex_state = 187},
  [9352] = {.lex_state = 0, .external_lex_state = 187},
  [9353] = {.lex_state = 0, .external_lex_state = 155},
  [9354] = {.lex_state = 0, .external_lex_state = 155},
  [9355] = {.lex_state = 3, .external_lex_state = 187},
  [9356] = {.lex_state = 3, .external_lex_state = 187},
  [9357] = {.lex_state = 0, .external_lex_state = 155},
  [9358] = {.lex_state = 1, .external_lex_state = 155},
  [9359] = {.lex_state = 0, .external_lex_state = 187},
  [9360] = {.lex_state = 0, .external_lex_state = 187},
  [9361] = {.lex_state = 3, .external_lex_state = 187},
  [9362] = {.lex_state = 0, .external_lex_state = 187},
  [9363] = {.lex_state = 3, .external_lex_state = 187},
  [9364] = {.lex_state = 3, .external_lex_state = 187},
  [9365] = {.lex_state = 1, .external_lex_state = 155},
  [9366] = {.lex_state = 0, .external_lex_state = 187},
  [9367] = {.lex_state = 0, .external_lex_state = 187},
  [9368] = {.lex_state = 0, .external_lex_state = 155},
  [9369] = {.lex_state = 4, .external_lex_state = 207},
  [9370] = {.lex_state = 0, .external_lex_state = 187},
  [9371] = {.lex_state = 3, .external_lex_state = 187},
  [9372] = {.lex_state = 0, .external_lex_state = 187},
  [9373] = {.lex_state = 0, .external_lex_state = 187},
  [9374] = {.lex_state = 0, .external_lex_state = 187},
  [9375] = {.lex_state = 1, .external_lex_state = 155},
  [9376] = {.lex_state = 0, .external_lex_state = 187},
  [9377] = {.lex_state = 0, .external_lex_state = 187},
  [9378] = {.lex_state = 0, .external_lex_state = 187},
  [9379] = {.lex_state = 3, .external_lex_state = 162},
  [9380] = {.lex_state = 4, .external_lex_state = 207},
  [9381] = {.lex_state = 1, .external_lex_state = 155},
  [9382] = {.lex_state = 0, .external_lex_state = 187},
  [9383] = {.lex_state = 0, .external_lex_state = 155},
  [9384] = {.lex_state = 4, .external_lex_state = 207},
  [9385] = {.lex_state = 0, .external_lex_state = 155},
  [9386] = {.lex_state = 3, .external_lex_state = 162},
  [9387] = {.lex_state = 0, .external_lex_state = 187},
  [9388] = {.lex_state = 0, .external_lex_state = 187},
  [9389] = {.lex_state = 3, .external_lex_state = 162},
  [9390] = {.lex_state = 3, .external_lex_state = 162},
  [9391] = {.lex_state = 0, .external_lex_state = 187},
  [9392] = {.lex_state = 0, .external_lex_state = 187},
  [9393] = {.lex_state = 0, .external_lex_state = 155},
  [9394] = {.lex_state = 0, .external_lex_state = 187},
  [9395] = {.lex_state = 3, .external_lex_state = 162},
  [9396] = {.lex_state = 3, .external_lex_state = 162},
  [9397] = {.lex_state = 0, .external_lex_state = 191},
  [9398] = {.lex_state = 0, .external_lex_state = 155},
  [9399] = {.lex_state = 0, .external_lex_state = 187},
  [9400] = {.lex_state = 4, .external_lex_state = 207},
  [9401] = {.lex_state = 0, .external_lex_state = 187},
  [9402] = {.lex_state = 0, .external_lex_state = 205},
  [9403] = {.lex_state = 4, .external_lex_state = 207},
  [9404] = {.lex_state = 0, .external_lex_state = 204},
  [9405] = {.lex_state = 0, .external_lex_state = 155},
  [9406] = {.lex_state = 0, .external_lex_state = 204},
  [9407] = {.lex_state = 0, .external_lex_state = 187},
  [9408] = {.lex_state = 0, .external_lex_state = 187},
  [9409] = {.lex_state = 1, .external_lex_state = 155},
  [9410] = {.lex_state = 0, .external_lex_state = 205},
  [9411] = {.lex_state = 0, .external_lex_state = 191},
  [9412] = {.lex_state = 0, .external_lex_state = 155},
  [9413] = {.lex_state = 3, .external_lex_state = 187},
  [9414] = {.lex_state = 4, .external_lex_state = 207},
  [9415] = {.lex_state = 0, .external_lex_state = 187},
  [9416] = {.lex_state = 0, .external_lex_state = 191},
  [9417] = {.lex_state = 0, .external_lex_state = 187},
  [9418] = {.lex_state = 0, .external_lex_state = 205},
  [9419] = {.lex_state = 0, .external_lex_state = 155},
  [9420] = {.lex_state = 1, .external_lex_state = 155},
  [9421] = {.lex_state = 0, .external_lex_state = 187},
  [9422] = {.lex_state = 0, .external_lex_state = 191},
  [9423] = {.lex_state = 0, .external_lex_state = 187},
  [9424] = {.lex_state = 0, .external_lex_state = 187},
  [9425] = {.lex_state = 0, .external_lex_state = 205},
  [9426] = {.lex_state = 0, .external_lex_state = 187},
  [9427] = {.lex_state = 0, .external_lex_state = 155},
  [9428] = {.lex_state = 0, .external_lex_state = 155},
  [9429] = {.lex_state = 0, .external_lex_state = 187},
  [9430] = {.lex_state = 0, .external_lex_state = 155},
  [9431] = {.lex_state = 0, .external_lex_state = 155},
  [9432] = {.lex_state = 0, .external_lex_state = 205},
  [9433] = {.lex_state = 0, .external_lex_state = 155},
  [9434] = {.lex_state = 0, .external_lex_state = 155},
  [9435] = {.lex_state = 0, .external_lex_state = 155},
  [9436] = {.lex_state = 0, .external_lex_state = 155},
  [9437] = {.lex_state = 0, .external_lex_state = 191},
  [9438] = {.lex_state = 0, .external_lex_state = 187},
  [9439] = {.lex_state = 0, .external_lex_state = 155},
  [9440] = {.lex_state = 1, .external_lex_state = 155},
  [9441] = {.lex_state = 0, .external_lex_state = 155},
  [9442] = {.lex_state = 0, .external_lex_state = 155},
  [9443] = {.lex_state = 0, .external_lex_state = 187},
  [9444] = {.lex_state = 3, .external_lex_state = 206},
  [9445] = {.lex_state = 0, .external_lex_state = 187},
  [9446] = {.lex_state = 0, .external_lex_state = 187},
  [9447] = {.lex_state = 0, .external_lex_state = 155},
  [9448] = {.lex_state = 0, .external_lex_state = 155},
  [9449] = {.lex_state = 0, .external_lex_state = 205},
  [9450] = {.lex_state = 0, .external_lex_state = 191},
  [9451] = {.lex_state = 0, .external_lex_state = 187},
  [9452] = {.lex_state = 0, .external_lex_state = 187},
  [9453] = {.lex_state = 0, .external_lex_state = 208},
  [9454] = {.lex_state = 0, .external_lex_state = 187},
  [9455] = {.lex_state = 0, .external_lex_state = 187},
  [9456] = {.lex_state = 0, .external_lex_state = 205},
  [9457] = {.lex_state = 0, .external_lex_state = 155},
  [9458] = {.lex_state = 0, .external_lex_state = 187},
  [9459] = {.lex_state = 1, .external_lex_state = 155},
  [9460] = {.lex_state = 0, .external_lex_state = 155},
  [9461] = {.lex_state = 0, .external_lex_state = 187},
  [9462] = {.lex_state = 0, .external_lex_state = 205},
  [9463] = {.lex_state = 0, .external_lex_state = 155},
  [9464] = {.lex_state = 0, .external_lex_state = 155},
  [9465] = {.lex_state = 0, .external_lex_state = 155},
  [9466] = {.lex_state = 1, .external_lex_state = 155},
  [9467] = {.lex_state = 0, .external_lex_state = 205},
  [9468] = {.lex_state = 1, .external_lex_state = 155},
  [9469] = {.lex_state = 4, .external_lex_state = 207},
  [9470] = {.lex_state = 4, .external_lex_state = 207},
  [9471] = {.lex_state = 1, .external_lex_state = 155},
  [9472] = {.lex_state = 1, .external_lex_state = 155},
  [9473] = {.lex_state = 4, .external_lex_state = 207},
  [9474] = {.lex_state = 0, .external_lex_state = 187},
  [9475] = {.lex_state = 1, .external_lex_state = 155},
  [9476] = {.lex_state = 0, .external_lex_state = 191},
  [9477] = {.lex_state = 0, .external_lex_state = 155},
  [9478] = {.lex_state = 4, .external_lex_state = 207},
  [9479] = {.lex_state = 0, .external_lex_state = 187},
  [9480] = {.lex_state = 0, .external_lex_state = 155},
  [9481] = {.lex_state = 0, .external_lex_state = 187},
  [9482] = {.lex_state = 0, .external_lex_state = 187},
  [9483] = {.lex_state = 0, .external_lex_state = 187},
  [9484] = {.lex_state = 1, .external_lex_state = 155},
  [9485] = {.lex_state = 0, .external_lex_state = 187},
  [9486] = {.lex_state = 3, .external_lex_state = 187},
  [9487] = {.lex_state = 0, .external_lex_state = 187},
  [9488] = {.lex_state = 0, .external_lex_state = 187},
  [9489] = {.lex_state = 0, .external_lex_state = 187},
  [9490] = {.lex_state = 0, .external_lex_state = 155},
  [9491] = {.lex_state = 0, .external_lex_state = 155},
  [9492] = {.lex_state = 0, .external_lex_state = 187},
  [9493] = {.lex_state = 0, .external_lex_state = 187},
  [9494] = {.lex_state = 0, .external_lex_state = 187},
  [9495] = {.lex_state = 0, .external_lex_state = 187},
  [9496] = {.lex_state = 0, .external_lex_state = 187},
  [9497] = {.lex_state = 0, .external_lex_state = 155},
  [9498] = {.lex_state = 4, .external_lex_state = 207},
  [9499] = {.lex_state = 0, .external_lex_state = 159},
  [9500] = {.lex_state = 4, .external_lex_state = 207},
  [9501] = {.lex_state = 0, .external_lex_state = 187},
  [9502] = {.lex_state = 1, .external_lex_state = 155},
  [9503] = {.lex_state = 0, .external_lex_state = 187},
  [9504] = {.lex_state = 0, .external_lex_state = 155},
  [9505] = {.lex_state = 0, .external_lex_state = 187},
  [9506] = {.lex_state = 0, .external_lex_state = 203},
  [9507] = {.lex_state = 0, .external_lex_state = 190},
  [9508] = {.lex_state = 1, .external_lex_state = 155},
  [9509] = {.lex_state = 1, .external_lex_state = 155},
  [9510] = {.lex_state = 0, .external_lex_state = 205},
  [9511] = {.lex_state = 0, .external_lex_state = 155},
  [9512] = {.lex_state = 0, .external_lex_state = 155},
  [9513] = {.lex_state = 0, .external_lex_state = 187},
  [9514] = {.lex_state = 0, .external_lex_state = 187},
  [9515] = {.lex_state = 0, .external_lex_state = 187},
  [9516] = {.lex_state = 1, .external_lex_state = 155},
  [9517] = {.lex_state = 0, .external_lex_state = 187},
  [9518] = {.lex_state = 0, .external_lex_state = 187},
  [9519] = {.lex_state = 0, .external_lex_state = 187},
  [9520] = {.lex_state = 0, .external_lex_state = 187},
  [9521] = {.lex_state = 0, .external_lex_state = 187},
  [9522] = {.lex_state = 0, .external_lex_state = 187},
  [9523] = {.lex_state = 0, .external_lex_state = 187},
  [9524] = {.lex_state = 0, .external_lex_state = 187},
  [9525] = {.lex_state = 0, .external_lex_state = 187},
  [9526] = {.lex_state = 1, .external_lex_state = 155},
  [9527] = {.lex_state = 0, .external_lex_state = 155},
  [9528] = {.lex_state = 0, .external_lex_state = 187},
  [9529] = {.lex_state = 0, .external_lex_state = 155},
  [9530] = {.lex_state = 0, .external_lex_state = 187},
  [9531] = {.lex_state = 4, .external_lex_state = 207},
  [9532] = {.lex_state = 0, .external_lex_state = 187},
  [9533] = {.lex_state = 0, .external_lex_state = 187},
  [9534] = {.lex_state = 1, .external_lex_state = 155},
  [9535] = {.lex_state = 1, .external_lex_state = 155},
  [9536] = {.lex_state = 1, .external_lex_state = 155},
  [9537] = {.lex_state = 0, .external_lex_state = 187},
  [9538] = {.lex_state = 0, .external_lex_state = 187},
  [9539] = {.lex_state = 0, .external_lex_state = 187},
  [9540] = {.lex_state = 3, .external_lex_state = 187},
  [9541] = {.lex_state = 0, .external_lex_state = 155},
  [9542] = {.lex_state = 0, .external_lex_state = 209},
  [9543] = {.lex_state = 0, .external_lex_state = 210},
  [9544] = {.lex_state = 3, .external_lex_state = 211},
  [9545] = {.lex_state = 0, .external_lex_state = 202},
  [9546] = {.lex_state = 0, .external_lex_state = 191},
  [9547] = {.lex_state = 0, .external_lex_state = 191},
  [9548] = {.lex_state = 0, .external_lex_state = 191},
  [9549] = {.lex_state = 0, .external_lex_state = 212},
  [9550] = {.lex_state = 0, .external_lex_state = 209},
  [9551] = {.lex_state = 0, .external_lex_state = 210},
  [9552] = {.lex_state = 0, .external_lex_state = 202},
  [9553] = {.lex_state = 0, .external_lex_state = 209},
  [9554] = {.lex_state = 0, .external_lex_state = 210},
  [9555] = {.lex_state = 0, .external_lex_state = 202},
  [9556] = {.lex_state = 0, .external_lex_state = 202},
  [9557] = {.lex_state = 0, .external_lex_state = 187},
  [9558] = {.lex_state = 0, .external_lex_state = 202},
  [9559] = {.lex_state = 1, .external_lex_state = 155},
  [9560] = {.lex_state = 0, .external_lex_state = 202},
  [9561] = {.lex_state = 0, .external_lex_state = 187},
  [9562] = {.lex_state = 0, .external_lex_state = 210},
  [9563] = {.lex_state = 1, .external_lex_state = 155},
  [9564] = {.lex_state = 0, .external_lex_state = 187},
  [9565] = {.lex_state = 0, .external_lex_state = 187},
  [9566] = {.lex_state = 1, .external_lex_state = 155},
  [9567] = {.lex_state = 0, .external_lex_state = 202},
  [9568] = {.lex_state = 1, .external_lex_state = 155},
  [9569] = {.lex_state = 0, .external_lex_state = 212},
  [9570] = {.lex_state = 1, .external_lex_state = 155},
  [9571] = {.lex_state = 4, .external_lex_state = 213},
  [9572] = {.lex_state = 0, .external_lex_state = 155},
  [9573] = {.lex_state = 3, .external_lex_state = 155},
  [9574] = {.lex_state = 0, .external_lex_state = 191},
  [9575] = {.lex_state = 0, .external_lex_state = 212},
  [9576] = {.lex_state = 1, .external_lex_state = 155},
  [9577] = {.lex_state = 0, .external_lex_state = 198},
  [9578] = {.lex_state = 0, .external_lex_state = 202},
  [9579] = {.lex_state = 0, .external_lex_state = 210},
  [9580] = {.lex_state = 4, .external_lex_state = 213},
  [9581] = {.lex_state = 0, .external_lex_state = 212},
  [9582] = {.lex_state = 0, .external_lex_state = 202},
  [9583] = {.lex_state = 0, .external_lex_state = 204},
  [9584] = {.lex_state = 0, .external_lex_state = 202},
  [9585] = {.lex_state = 0, .external_lex_state = 210},
  [9586] = {.lex_state = 0, .external_lex_state = 210},
  [9587] = {.lex_state = 0, .external_lex_state = 187},
  [9588] = {.lex_state = 4, .external_lex_state = 192},
  [9589] = {.lex_state = 0, .external_lex_state = 187},
  [9590] = {.lex_state = 0, .external_lex_state = 204},
  [9591] = {.lex_state = 0, .external_lex_state = 155},
  [9592] = {.lex_state = 0, .external_lex_state = 204},
  [9593] = {.lex_state = 1, .external_lex_state = 155},
  [9594] = {.lex_state = 0, .external_lex_state = 204},
  [9595] = {.lex_state = 0, .external_lex_state = 212},
  [9596] = {.lex_state = 0, .external_lex_state = 187},
  [9597] = {.lex_state = 0, .external_lex_state = 187},
  [9598] = {.lex_state = 0, .external_lex_state = 209},
  [9599] = {.lex_state = 4, .external_lex_state = 213},
  [9600] = {.lex_state = 0, .external_lex_state = 155},
  [9601] = {.lex_state = 3, .external_lex_state = 211},
  [9602] = {.lex_state = 0, .external_lex_state = 210},
  [9603] = {.lex_state = 1, .external_lex_state = 155},
  [9604] = {.lex_state = 0, .external_lex_state = 191},
  [9605] = {.lex_state = 0, .external_lex_state = 187},
  [9606] = {.lex_state = 0, .external_lex_state = 212},
  [9607] = {.lex_state = 0, .external_lex_state = 187},
  [9608] = {.lex_state = 0, .external_lex_state = 191},
  [9609] = {.lex_state = 3, .external_lex_state = 155},
  [9610] = {.lex_state = 0, .external_lex_state = 202},
  [9611] = {.lex_state = 0, .external_lex_state = 155},
  [9612] = {.lex_state = 0, .external_lex_state = 187},
  [9613] = {.lex_state = 0, .external_lex_state = 187},
  [9614] = {.lex_state = 0, .external_lex_state = 188},
  [9615] = {.lex_state = 0, .external_lex_state = 155},
  [9616] = {.lex_state = 0, .external_lex_state = 190},
  [9617] = {.lex_state = 0, .external_lex_state = 187},
  [9618] = {.lex_state = 0, .external_lex_state = 166},
  [9619] = {.lex_state = 0, .external_lex_state = 191},
  [9620] = {.lex_state = 0, .external_lex_state = 210},
  [9621] = {.lex_state = 0, .external_lex_state = 212},
  [9622] = {.lex_state = 0, .external_lex_state = 191},
  [9623] = {.lex_state = 0, .external_lex_state = 191},
  [9624] = {.lex_state = 0, .external_lex_state = 187},
  [9625] = {.lex_state = 4, .external_lex_state = 213},
  [9626] = {.lex_state = 1, .external_lex_state = 155},
  [9627] = {.lex_state = 0, .external_lex_state = 190},
  [9628] = {.lex_state = 0, .external_lex_state = 202},
  [9629] = {.lex_state = 0, .external_lex_state = 210},
  [9630] = {.lex_state = 0, .external_lex_state = 155},
  [9631] = {.lex_state = 0, .external_lex_state = 202},
  [9632] = {.lex_state = 0, .external_lex_state = 155},
  [9633] = {.lex_state = 0, .external_lex_state = 191},
  [9634] = {.lex_state = 0, .external_lex_state = 205},
  [9635] = {.lex_state = 0, .external_lex_state = 199},
  [9636] = {.lex_state = 0, .external_lex_state = 210},
  [9637] = {.lex_state = 0, .external_lex_state = 187},
  [9638] = {.lex_state = 4, .external_lex_state = 213},
  [9639] = {.lex_state = 4, .external_lex_state = 213},
  [9640] = {.lex_state = 0, .external_lex_state = 210},
  [9641] = {.lex_state = 0, .external_lex_state = 166},
  [9642] = {.lex_state = 0, .external_lex_state = 204},
  [9643] = {.lex_state = 1, .external_lex_state = 155},
  [9644] = {.lex_state = 4, .external_lex_state = 213},
  [9645] = {.lex_state = 0, .external_lex_state = 202},
  [9646] = {.lex_state = 0, .external_lex_state = 199},
  [9647] = {.lex_state = 0, .external_lex_state = 202},
  [9648] = {.lex_state = 0, .external_lex_state = 204},
  [9649] = {.lex_state = 0, .external_lex_state = 204},
  [9650] = {.lex_state = 3, .external_lex_state = 211},
  [9651] = {.lex_state = 0, .external_lex_state = 190},
  [9652] = {.lex_state = 0, .external_lex_state = 202},
  [9653] = {.lex_state = 1, .external_lex_state = 155},
  [9654] = {.lex_state = 0, .external_lex_state = 202},
  [9655] = {.lex_state = 0, .external_lex_state = 209},
  [9656] = {.lex_state = 0, .external_lex_state = 187},
  [9657] = {.lex_state = 1, .external_lex_state = 155},
  [9658] = {.lex_state = 0, .external_lex_state = 155},
  [9659] = {.lex_state = 0, .external_lex_state = 187},
  [9660] = {.lex_state = 23, .external_lex_state = 187},
  [9661] = {.lex_state = 0, .external_lex_state = 191},
  [9662] = {.lex_state = 0, .external_lex_state = 204},
  [9663] = {.lex_state = 0, .external_lex_state = 209},
  [9664] = {.lex_state = 0, .external_lex_state = 155},
  [9665] = {.lex_state = 0, .external_lex_state = 191},
  [9666] = {.lex_state = 0, .external_lex_state = 212},
  [9667] = {.lex_state = 3, .external_lex_state = 155},
  [9668] = {.lex_state = 0, .external_lex_state = 202},
  [9669] = {.lex_state = 0, .external_lex_state = 202},
  [9670] = {.lex_state = 0, .external_lex_state = 212},
  [9671] = {.lex_state = 4, .external_lex_state = 213},
  [9672] = {.lex_state = 0, .external_lex_state = 187},
  [9673] = {.lex_state = 1, .external_lex_state = 155},
  [9674] = {.lex_state = 0, .external_lex_state = 190},
  [9675] = {.lex_state = 4, .external_lex_state = 213},
  [9676] = {.lex_state = 4, .external_lex_state = 213},
  [9677] = {.lex_state = 0, .external_lex_state = 212},
  [9678] = {.lex_state = 0, .external_lex_state = 202},
  [9679] = {.lex_state = 0, .external_lex_state = 155},
  [9680] = {.lex_state = 0, .external_lex_state = 155},
  [9681] = {.lex_state = 4, .external_lex_state = 213},
  [9682] = {.lex_state = 0, .external_lex_state = 191},
  [9683] = {.lex_state = 0, .external_lex_state = 187},
  [9684] = {.lex_state = 0, .external_lex_state = 202},
  [9685] = {.lex_state = 0, .external_lex_state = 202},
  [9686] = {.lex_state = 3, .external_lex_state = 155},
  [9687] = {.lex_state = 0, .external_lex_state = 155},
  [9688] = {.lex_state = 0, .external_lex_state = 202},
  [9689] = {.lex_state = 0, .external_lex_state = 202},
  [9690] = {.lex_state = 0, .external_lex_state = 187},
  [9691] = {.lex_state = 16, .external_lex_state = 155},
  [9692] = {.lex_state = 0, .external_lex_state = 202},
  [9693] = {.lex_state = 1, .external_lex_state = 155},
  [9694] = {.lex_state = 0, .external_lex_state = 187},
  [9695] = {.lex_state = 9, .external_lex_state = 166},
  [9696] = {.lex_state = 3, .external_lex_state = 155},
  [9697] = {.lex_state = 0, .external_lex_state = 202},
  [9698] = {.lex_state = 0, .external_lex_state = 212},
  [9699] = {.lex_state = 1, .external_lex_state = 155},
  [9700] = {.lex_state = 0, .external_lex_state = 202},
  [9701] = {.lex_state = 0, .external_lex_state = 212},
  [9702] = {.lex_state = 0, .external_lex_state = 202},
  [9703] = {.lex_state = 0, .external_lex_state = 202},
  [9704] = {.lex_state = 0, .external_lex_state = 202},
  [9705] = {.lex_state = 0, .external_lex_state = 155},
  [9706] = {.lex_state = 1, .external_lex_state = 155},
  [9707] = {.lex_state = 0, .external_lex_state = 211},
  [9708] = {.lex_state = 0, .external_lex_state = 211},
  [9709] = {.lex_state = 0, .external_lex_state = 155},
  [9710] = {.lex_state = 0, .external_lex_state = 211},
  [9711] = {.lex_state = 0, .external_lex_state = 211},
  [9712] = {.lex_state = 0, .external_lex_state = 155},
  [9713] = {.lex_state = 1, .external_lex_state = 155},
  [9714] = {.lex_state = 1, .external_lex_state = 155},
  [9715] = {.lex_state = 1, .external_lex_state = 155},
  [9716] = {.lex_state = 1, .external_lex_state = 155},
  [9717] = {.lex_state = 0, .external_lex_state = 155},
  [9718] = {.lex_state = 1, .external_lex_state = 155},
  [9719] = {.lex_state = 1, .external_lex_state = 155},
  [9720] = {.lex_state = 1, .external_lex_state = 155},
  [9721] = {.lex_state = 0, .external_lex_state = 214},
  [9722] = {.lex_state = 1, .external_lex_state = 155},
  [9723] = {.lex_state = 0, .external_lex_state = 155},
  [9724] = {.lex_state = 0, .external_lex_state = 155},
  [9725] = {.lex_state = 1, .external_lex_state = 155},
  [9726] = {.lex_state = 1, .external_lex_state = 155},
  [9727] = {.lex_state = 1, .external_lex_state = 155},
  [9728] = {.lex_state = 1, .external_lex_state = 155},
  [9729] = {.lex_state = 1, .external_lex_state = 155},
  [9730] = {.lex_state = 1, .external_lex_state = 155},
  [9731] = {.lex_state = 0, .external_lex_state = 190},
  [9732] = {.lex_state = 1, .external_lex_state = 155},
  [9733] = {.lex_state = 0, .external_lex_state = 155},
  [9734] = {.lex_state = 1, .external_lex_state = 155},
  [9735] = {.lex_state = 3, .external_lex_state = 215},
  [9736] = {.lex_state = 1, .external_lex_state = 155},
  [9737] = {.lex_state = 1, .external_lex_state = 155},
  [9738] = {.lex_state = 0, .external_lex_state = 155},
  [9739] = {.lex_state = 1, .external_lex_state = 155},
  [9740] = {.lex_state = 1, .external_lex_state = 155},
  [9741] = {.lex_state = 1, .external_lex_state = 155},
  [9742] = {.lex_state = 0, .external_lex_state = 155},
  [9743] = {.lex_state = 0, .external_lex_state = 187},
  [9744] = {.lex_state = 0, .external_lex_state = 214},
  [9745] = {.lex_state = 1, .external_lex_state = 155},
  [9746] = {.lex_state = 0, .external_lex_state = 187},
  [9747] = {.lex_state = 1, .external_lex_state = 155},
  [9748] = {.lex_state = 0, .external_lex_state = 155},
  [9749] = {.lex_state = 3, .external_lex_state = 198},
  [9750] = {.lex_state = 0, .external_lex_state = 155},
  [9751] = {.lex_state = 0, .external_lex_state = 155},
  [9752] = {.lex_state = 3, .external_lex_state = 198},
  [9753] = {.lex_state = 1, .external_lex_state = 155},
  [9754] = {.lex_state = 3, .external_lex_state = 198},
  [9755] = {.lex_state = 3, .external_lex_state = 198},
  [9756] = {.lex_state = 1, .external_lex_state = 155},
  [9757] = {.lex_state = 0, .external_lex_state = 155},
  [9758] = {.lex_state = 0, .external_lex_state = 155},
  [9759] = {.lex_state = 3, .external_lex_state = 198},
  [9760] = {.lex_state = 1, .external_lex_state = 155},
  [9761] = {.lex_state = 0, .external_lex_state = 155},
  [9762] = {.lex_state = 0, .external_lex_state = 187},
  [9763] = {.lex_state = 0, .external_lex_state = 187},
  [9764] = {.lex_state = 1, .external_lex_state = 155},
  [9765] = {.lex_state = 0, .external_lex_state = 187},
  [9766] = {.lex_state = 0, .external_lex_state = 155},
  [9767] = {.lex_state = 1, .external_lex_state = 155},
  [9768] = {.lex_state = 1, .external_lex_state = 155},
  [9769] = {.lex_state = 0, .external_lex_state = 199},
  [9770] = {.lex_state = 0, .external_lex_state = 206},
  [9771] = {.lex_state = 0, .external_lex_state = 206},
  [9772] = {.lex_state = 0, .external_lex_state = 190},
  [9773] = {.lex_state = 0, .external_lex_state = 155},
  [9774] = {.lex_state = 0, .external_lex_state = 155},
  [9775] = {.lex_state = 1, .external_lex_state = 155},
  [9776] = {.lex_state = 1, .external_lex_state = 155},
  [9777] = {.lex_state = 3, .external_lex_state = 198},
  [9778] = {.lex_state = 3, .external_lex_state = 155},
  [9779] = {.lex_state = 0, .external_lex_state = 155},
  [9780] = {.lex_state = 1, .external_lex_state = 155},
  [9781] = {.lex_state = 1, .external_lex_state = 155},
  [9782] = {.lex_state = 1, .external_lex_state = 155},
  [9783] = {.lex_state = 3, .external_lex_state = 215},
  [9784] = {.lex_state = 1, .external_lex_state = 155},
  [9785] = {.lex_state = 1, .external_lex_state = 155},
  [9786] = {.lex_state = 0, .external_lex_state = 155},
  [9787] = {.lex_state = 4, .external_lex_state = 193},
  [9788] = {.lex_state = 1, .external_lex_state = 155},
  [9789] = {.lex_state = 1, .external_lex_state = 155},
  [9790] = {.lex_state = 1, .external_lex_state = 155},
  [9791] = {.lex_state = 0, .external_lex_state = 211},
  [9792] = {.lex_state = 1, .external_lex_state = 155},
  [9793] = {.lex_state = 1, .external_lex_state = 155},
  [9794] = {.lex_state = 1, .external_lex_state = 155},
  [9795] = {.lex_state = 1, .external_lex_state = 155},
  [9796] = {.lex_state = 0, .external_lex_state = 211},
  [9797] = {.lex_state = 0, .external_lex_state = 187},
  [9798] = {.lex_state = 1, .external_lex_state = 155},
  [9799] = {.lex_state = 1, .external_lex_state = 155},
  [9800] = {.lex_state = 0, .external_lex_state = 155},
  [9801] = {.lex_state = 1, .external_lex_state = 155},
  [9802] = {.lex_state = 1, .external_lex_state = 155},
  [9803] = {.lex_state = 0, .external_lex_state = 158},
  [9804] = {.lex_state = 1, .external_lex_state = 155},
  [9805] = {.lex_state = 1, .external_lex_state = 155},
  [9806] = {.lex_state = 1, .external_lex_state = 155},
  [9807] = {.lex_state = 1, .external_lex_state = 155},
  [9808] = {.lex_state = 1, .external_lex_state = 155},
  [9809] = {.lex_state = 1, .external_lex_state = 155},
  [9810] = {.lex_state = 1, .external_lex_state = 155},
  [9811] = {.lex_state = 1, .external_lex_state = 155},
  [9812] = {.lex_state = 1, .external_lex_state = 155},
  [9813] = {.lex_state = 1, .external_lex_state = 155},
  [9814] = {.lex_state = 0, .external_lex_state = 155},
  [9815] = {.lex_state = 3, .external_lex_state = 198},
  [9816] = {.lex_state = 3, .external_lex_state = 215},
  [9817] = {.lex_state = 3, .external_lex_state = 215},
  [9818] = {.lex_state = 0, .external_lex_state = 206},
  [9819] = {.lex_state = 0, .external_lex_state = 211},
  [9820] = {.lex_state = 0, .external_lex_state = 155},
  [9821] = {.lex_state = 1, .external_lex_state = 155},
  [9822] = {.lex_state = 3, .external_lex_state = 198},
  [9823] = {.lex_state = 3, .external_lex_state = 198},
  [9824] = {.lex_state = 0, .external_lex_state = 211},
  [9825] = {.lex_state = 0, .external_lex_state = 155},
  [9826] = {.lex_state = 1, .external_lex_state = 155},
  [9827] = {.lex_state = 1, .external_lex_state = 155},
  [9828] = {.lex_state = 0, .external_lex_state = 155},
  [9829] = {.lex_state = 1, .external_lex_state = 155},
  [9830] = {.lex_state = 0, .external_lex_state = 211},
  [9831] = {.lex_state = 1, .external_lex_state = 155},
  [9832] = {.lex_state = 0, .external_lex_state = 155},
  [9833] = {.lex_state = 1, .external_lex_state = 155},
  [9834] = {.lex_state = 0, .external_lex_state = 211},
  [9835] = {.lex_state = 0, .external_lex_state = 190},
  [9836] = {.lex_state = 1, .external_lex_state = 155},
  [9837] = {.lex_state = 1, .external_lex_state = 155},
  [9838] = {.lex_state = 0, .external_lex_state = 155},
  [9839] = {.lex_state = 0, .external_lex_state = 155},
  [9840] = {.lex_state = 1, .external_lex_state = 155},
  [9841] = {.lex_state = 1, .external_lex_state = 155},
  [9842] = {.lex_state = 1, .external_lex_state = 155},
  [9843] = {.lex_state = 3, .external_lex_state = 198},
  [9844] = {.lex_state = 3, .external_lex_state = 198},
  [9845] = {.lex_state = 3, .external_lex_state = 198},
  [9846] = {.lex_state = 3, .external_lex_state = 198},
  [9847] = {.lex_state = 0, .external_lex_state = 155},
  [9848] = {.lex_state = 1, .external_lex_state = 155},
  [9849] = {.lex_state = 1, .external_lex_state = 155},
  [9850] = {.lex_state = 0, .external_lex_state = 155},
  [9851] = {.lex_state = 0, .external_lex_state = 211},
  [9852] = {.lex_state = 0, .external_lex_state = 190},
  [9853] = {.lex_state = 1, .external_lex_state = 155},
  [9854] = {.lex_state = 0, .external_lex_state = 155},
  [9855] = {.lex_state = 1, .external_lex_state = 155},
  [9856] = {.lex_state = 1, .external_lex_state = 155},
  [9857] = {.lex_state = 1, .external_lex_state = 155},
  [9858] = {.lex_state = 1, .external_lex_state = 155},
  [9859] = {.lex_state = 0, .external_lex_state = 206},
  [9860] = {.lex_state = 1, .external_lex_state = 155},
  [9861] = {.lex_state = 1, .external_lex_state = 155},
  [9862] = {.lex_state = 3, .external_lex_state = 215},
  [9863] = {.lex_state = 3, .external_lex_state = 155},
  [9864] = {.lex_state = 3, .external_lex_state = 215},
  [9865] = {.lex_state = 0, .external_lex_state = 155},
  [9866] = {.lex_state = 1, .external_lex_state = 155},
  [9867] = {.lex_state = 4, .external_lex_state = 213},
  [9868] = {.lex_state = 0, .external_lex_state = 155},
  [9869] = {.lex_state = 0, .external_lex_state = 155},
  [9870] = {.lex_state = 0, .external_lex_state = 214},
  [9871] = {.lex_state = 0, .external_lex_state = 155},
  [9872] = {.lex_state = 0, .external_lex_state = 155},
  [9873] = {.lex_state = 1, .external_lex_state = 155},
  [9874] = {.lex_state = 3, .external_lex_state = 155},
  [9875] = {.lex_state = 1, .external_lex_state = 155},
  [9876] = {.lex_state = 4, .external_lex_state = 155},
  [9877] = {.lex_state = 1, .external_lex_state = 155},
  [9878] = {.lex_state = 0, .external_lex_state = 155},
  [9879] = {.lex_state = 3, .external_lex_state = 155},
  [9880] = {.lex_state = 3, .external_lex_state = 155},
  [9881] = {.lex_state = 0, .external_lex_state = 206},
  [9882] = {.lex_state = 1, .external_lex_state = 155},
  [9883] = {.lex_state = 3, .external_lex_state = 155},
  [9884] = {.lex_state = 1, .external_lex_state = 155},
  [9885] = {.lex_state = 3, .external_lex_state = 155},
  [9886] = {.lex_state = 4, .external_lex_state = 155},
  [9887] = {.lex_state = 0, .external_lex_state = 155},
  [9888] = {.lex_state = 0, .external_lex_state = 206},
  [9889] = {.lex_state = 0, .external_lex_state = 211},
  [9890] = {.lex_state = 1, .external_lex_state = 155},
  [9891] = {.lex_state = 0, .external_lex_state = 211},
  [9892] = {.lex_state = 0, .external_lex_state = 199},
  [9893] = {.lex_state = 1, .external_lex_state = 155},
  [9894] = {.lex_state = 1, .external_lex_state = 155},
  [9895] = {.lex_state = 1, .external_lex_state = 155},
  [9896] = {.lex_state = 1, .external_lex_state = 155},
  [9897] = {.lex_state = 0, .external_lex_state = 211},
  [9898] = {.lex_state = 1, .external_lex_state = 155},
  [9899] = {.lex_state = 1, .external_lex_state = 155},
  [9900] = {.lex_state = 1, .external_lex_state = 155},
  [9901] = {.lex_state = 0, .external_lex_state = 214},
  [9902] = {.lex_state = 1, .external_lex_state = 155},
  [9903] = {.lex_state = 0, .external_lex_state = 199},
  [9904] = {.lex_state = 1, .external_lex_state = 155},
  [9905] = {.lex_state = 1, .external_lex_state = 155},
  [9906] = {.lex_state = 1, .external_lex_state = 155},
  [9907] = {.lex_state = 0, .external_lex_state = 155},
  [9908] = {.lex_state = 1, .external_lex_state = 155},
  [9909] = {.lex_state = 1, .external_lex_state = 155},
  [9910] = {.lex_state = 1, .external_lex_state = 155},
  [9911] = {.lex_state = 1, .external_lex_state = 155},
  [9912] = {.lex_state = 1, .external_lex_state = 155},
  [9913] = {.lex_state = 0, .external_lex_state = 211},
  [9914] = {.lex_state = 1, .external_lex_state = 155},
  [9915] = {.lex_state = 1, .external_lex_state = 155},
  [9916] = {.lex_state = 1, .external_lex_state = 155},
  [9917] = {.lex_state = 1, .external_lex_state = 155},
  [9918] = {.lex_state = 0, .external_lex_state = 155},
  [9919] = {.lex_state = 0, .external_lex_state = 155},
  [9920] = {.lex_state = 1, .external_lex_state = 155},
  [9921] = {.lex_state = 1, .external_lex_state = 155},
  [9922] = {.lex_state = 3, .external_lex_state = 215},
  [9923] = {.lex_state = 0, .external_lex_state = 206},
  [9924] = {.lex_state = 1, .external_lex_state = 155},
  [9925] = {.lex_state = 1, .external_lex_state = 155},
  [9926] = {.lex_state = 1, .external_lex_state = 155},
  [9927] = {.lex_state = 1, .external_lex_state = 155},
  [9928] = {.lex_state = 1, .external_lex_state = 155},
  [9929] = {.lex_state = 0, .external_lex_state = 155},
  [9930] = {.lex_state = 1, .external_lex_state = 155},
  [9931] = {.lex_state = 0, .external_lex_state = 206},
  [9932] = {.lex_state = 1, .external_lex_state = 155},
  [9933] = {.lex_state = 1, .external_lex_state = 155},
  [9934] = {.lex_state = 1, .external_lex_state = 155},
  [9935] = {.lex_state = 3, .external_lex_state = 215},
  [9936] = {.lex_state = 1, .external_lex_state = 155},
  [9937] = {.lex_state = 1, .external_lex_state = 155},
  [9938] = {.lex_state = 0, .external_lex_state = 155},
  [9939] = {.lex_state = 0, .external_lex_state = 211},
  [9940] = {.lex_state = 0, .external_lex_state = 211},
  [9941] = {.lex_state = 1, .external_lex_state = 155},
  [9942] = {.lex_state = 0, .external_lex_state = 190},
  [9943] = {.lex_state = 0, .external_lex_state = 155},
  [9944] = {.lex_state = 0, .external_lex_state = 199},
  [9945] = {.lex_state = 1, .external_lex_state = 155},
  [9946] = {.lex_state = 1, .external_lex_state = 155},
  [9947] = {.lex_state = 1, .external_lex_state = 155},
  [9948] = {.lex_state = 1, .external_lex_state = 155},
  [9949] = {.lex_state = 1, .external_lex_state = 155},
  [9950] = {.lex_state = 0, .external_lex_state = 206},
  [9951] = {.lex_state = 0, .external_lex_state = 187},
  [9952] = {.lex_state = 1, .external_lex_state = 155},
  [9953] = {.lex_state = 0, .external_lex_state = 199},
  [9954] = {.lex_state = 1, .external_lex_state = 155},
  [9955] = {.lex_state = 0, .external_lex_state = 187},
  [9956] = {.lex_state = 0, .external_lex_state = 155},
  [9957] = {.lex_state = 1, .external_lex_state = 155},
  [9958] = {.lex_state = 1, .external_lex_state = 155},
  [9959] = {.lex_state = 1, .external_lex_state = 155},
  [9960] = {.lex_state = 1, .external_lex_state = 155},
  [9961] = {.lex_state = 0, .external_lex_state = 155},
  [9962] = {.lex_state = 0, .external_lex_state = 211},
  [9963] = {.lex_state = 1, .external_lex_state = 155},
  [9964] = {.lex_state = 1, .external_lex_state = 155},
  [9965] = {.lex_state = 1, .external_lex_state = 155},
  [9966] = {.lex_state = 1, .external_lex_state = 155},
  [9967] = {.lex_state = 1, .external_lex_state = 155},
  [9968] = {.lex_state = 0, .external_lex_state = 158},
  [9969] = {.lex_state = 3, .external_lex_state = 215},
  [9970] = {.lex_state = 1, .external_lex_state = 155},
  [9971] = {.lex_state = 1, .external_lex_state = 155},
  [9972] = {.lex_state = 1, .external_lex_state = 155},
  [9973] = {.lex_state = 1, .external_lex_state = 155},
  [9974] = {.lex_state = 1, .external_lex_state = 155},
  [9975] = {.lex_state = 1, .external_lex_state = 155},
  [9976] = {.lex_state = 1, .external_lex_state = 155},
  [9977] = {.lex_state = 0, .external_lex_state = 158},
  [9978] = {.lex_state = 0, .external_lex_state = 155},
  [9979] = {.lex_state = 0, .external_lex_state = 155},
  [9980] = {.lex_state = 0, .external_lex_state = 155},
  [9981] = {.lex_state = 0, .external_lex_state = 155},
  [9982] = {.lex_state = 1, .external_lex_state = 155},
  [9983] = {.lex_state = 1, .external_lex_state = 155},
  [9984] = {.lex_state = 0, .external_lex_state = 155},
  [9985] = {.lex_state = 1, .external_lex_state = 155},
  [9986] = {.lex_state = 0, .external_lex_state = 155},
  [9987] = {.lex_state = 1, .external_lex_state = 155},
  [9988] = {.lex_state = 1, .external_lex_state = 155},
  [9989] = {.lex_state = 0, .external_lex_state = 190},
  [9990] = {.lex_state = 0, .external_lex_state = 155},
  [9991] = {.lex_state = 1, .external_lex_state = 155},
  [9992] = {.lex_state = 1, .external_lex_state = 155},
  [9993] = {.lex_state = 3, .external_lex_state = 215},
  [9994] = {.lex_state = 1, .external_lex_state = 155},
  [9995] = {.lex_state = 0, .external_lex_state = 155},
  [9996] = {.lex_state = 1, .external_lex_state = 155},
  [9997] = {.lex_state = 1, .external_lex_state = 155},
  [9998] = {.lex_state = 1, .external_lex_state = 155},
  [9999] = {.lex_state = 0, .external_lex_state = 214},
  [10000] = {.lex_state = 1, .external_lex_state = 155},
  [10001] = {.lex_state = 0, .external_lex_state = 155},
  [10002] = {.lex_state = 0, .external_lex_state = 199},
  [10003] = {.lex_state = 1, .external_lex_state = 155},
  [10004] = {.lex_state = 0, .external_lex_state = 199},
  [10005] = {.lex_state = 1, .external_lex_state = 155},
  [10006] = {.lex_state = 0, .external_lex_state = 206},
  [10007] = {.lex_state = 1, .external_lex_state = 155},
  [10008] = {.lex_state = 1, .external_lex_state = 155},
  [10009] = {.lex_state = 0, .external_lex_state = 155},
  [10010] = {.lex_state = 1, .external_lex_state = 155},
  [10011] = {.lex_state = 0, .external_lex_state = 211},
  [10012] = {.lex_state = 1, .external_lex_state = 155},
  [10013] = {.lex_state = 0, .external_lex_state = 211},
  [10014] = {.lex_state = 1, .external_lex_state = 155},
  [10015] = {.lex_state = 0, .external_lex_state = 199},
  [10016] = {.lex_state = 0, .external_lex_state = 155},
  [10017] = {.lex_state = 4, .external_lex_state = 155},
  [10018] = {.lex_state = 4, .external_lex_state = 155},
  [10019] = {.lex_state = 0, .external_lex_state = 155},
  [10020] = {.lex_state = 0, .external_lex_state = 166},
  [10021] = {.lex_state = 0, .external_lex_state = 155},
  [10022] = {.lex_state = 0, .external_lex_state = 214},
  [10023] = {.lex_state = 0, .external_lex_state = 155},
  [10024] = {.lex_state = 0, .external_lex_state = 187},
  [10025] = {.lex_state = 0, .external_lex_state = 187},
  [10026] = {.lex_state = 0, .external_lex_state = 155},
  [10027] = {.lex_state = 0, .external_lex_state = 187},
  [10028] = {.lex_state = 0, .external_lex_state = 155},
  [10029] = {.lex_state = 0, .external_lex_state = 187},
  [10030] = {.lex_state = 0, .external_lex_state = 155},
  [10031] = {.lex_state = 4, .external_lex_state = 155},
  [10032] = {.lex_state = 0, .external_lex_state = 187},
  [10033] = {.lex_state = 0, .external_lex_state = 155},
  [10034] = {.lex_state = 0, .external_lex_state = 155},
  [10035] = {.lex_state = 0, .external_lex_state = 187},
  [10036] = {.lex_state = 0, .external_lex_state = 187},
  [10037] = {.lex_state = 0, .external_lex_state = 187},
  [10038] = {.lex_state = 0, .external_lex_state = 187},
  [10039] = {.lex_state = 0, .external_lex_state = 187},
  [10040] = {.lex_state = 0, .external_lex_state = 187},
  [10041] = {.lex_state = 0, .external_lex_state = 187},
  [10042] = {.lex_state = 0, .external_lex_state = 166},
  [10043] = {.lex_state = 0, .external_lex_state = 166},
  [10044] = {.lex_state = 0, .external_lex_state = 177},
  [10045] = {.lex_state = 0, .external_lex_state = 187},
  [10046] = {.lex_state = 0, .external_lex_state = 187},
  [10047] = {.lex_state = 0, .external_lex_state = 166},
  [10048] = {.lex_state = 0, .external_lex_state = 166},
  [10049] = {.lex_state = 0, .external_lex_state = 187},
  [10050] = {.lex_state = 0, .external_lex_state = 155},
  [10051] = {.lex_state = 0, .external_lex_state = 155},
  [10052] = {.lex_state = 0, .external_lex_state = 155},
  [10053] = {.lex_state = 0, .external_lex_state = 187},
  [10054] = {.lex_state = 0, .external_lex_state = 155},
  [10055] = {.lex_state = 0, .external_lex_state = 214},
  [10056] = {.lex_state = 0, .external_lex_state = 166},
  [10057] = {.lex_state = 0, .external_lex_state = 166},
  [10058] = {.lex_state = 0, .external_lex_state = 155},
  [10059] = {.lex_state = 3, .external_lex_state = 211},
  [10060] = {.lex_state = 0, .external_lex_state = 2},
  [10061] = {.lex_state = 0, .external_lex_state = 177},
  [10062] = {.lex_state = 0, .external_lex_state = 155},
  [10063] = {.lex_state = 0, .external_lex_state = 155},
  [10064] = {.lex_state = 0, .external_lex_state = 155},
  [10065] = {.lex_state = 4, .external_lex_state = 155},
  [10066] = {.lex_state = 0, .external_lex_state = 166},
  [10067] = {.lex_state = 0, .external_lex_state = 214},
  [10068] = {.lex_state = 0, .external_lex_state = 155},
  [10069] = {.lex_state = 0, .external_lex_state = 187},
  [10070] = {.lex_state = 0, .external_lex_state = 155},
  [10071] = {.lex_state = 0, .external_lex_state = 155},
  [10072] = {.lex_state = 0, .external_lex_state = 187},
  [10073] = {.lex_state = 0, .external_lex_state = 155},
  [10074] = {.lex_state = 0, .external_lex_state = 155},
  [10075] = {.lex_state = 0, .external_lex_state = 155},
  [10076] = {.lex_state = 0, .external_lex_state = 155},
  [10077] = {.lex_state = 0, .external_lex_state = 204},
  [10078] = {.lex_state = 0, .external_lex_state = 190},
  [10079] = {.lex_state = 0, .external_lex_state = 187},
  [10080] = {.lex_state = 0, .external_lex_state = 187},
  [10081] = {.lex_state = 0, .external_lex_state = 187},
  [10082] = {.lex_state = 4, .external_lex_state = 155},
  [10083] = {.lex_state = 4, .external_lex_state = 155},
  [10084] = {.lex_state = 0, .external_lex_state = 187},
  [10085] = {.lex_state = 0, .external_lex_state = 187},
  [10086] = {.lex_state = 4, .external_lex_state = 155},
  [10087] = {.lex_state = 0, .external_lex_state = 187},
  [10088] = {.lex_state = 0, .external_lex_state = 187},
  [10089] = {.lex_state = 4, .external_lex_state = 155},
  [10090] = {.lex_state = 0, .external_lex_state = 187},
  [10091] = {.lex_state = 4, .external_lex_state = 155},
  [10092] = {.lex_state = 0, .external_lex_state = 155},
  [10093] = {.lex_state = 0, .external_lex_state = 155},
  [10094] = {.lex_state = 0, .external_lex_state = 187},
  [10095] = {.lex_state = 4, .external_lex_state = 155},
  [10096] = {.lex_state = 0, .external_lex_state = 187},
  [10097] = {.lex_state = 0, .external_lex_state = 155},
  [10098] = {.lex_state = 0, .external_lex_state = 155},
  [10099] = {.lex_state = 4, .external_lex_state = 155},
  [10100] = {.lex_state = 0, .external_lex_state = 187},
  [10101] = {.lex_state = 0, .external_lex_state = 187},
  [10102] = {.lex_state = 0, .external_lex_state = 155},
  [10103] = {.lex_state = 0, .external_lex_state = 187},
  [10104] = {.lex_state = 4, .external_lex_state = 155},
  [10105] = {.lex_state = 0, .external_lex_state = 187},
  [10106] = {.lex_state = 0, .external_lex_state = 155},
  [10107] = {.lex_state = 0, .external_lex_state = 155},
  [10108] = {.lex_state = 0, .external_lex_state = 155},
  [10109] = {.lex_state = 4, .external_lex_state = 155},
  [10110] = {.lex_state = 0, .external_lex_state = 187},
  [10111] = {.lex_state = 0, .external_lex_state = 187},
  [10112] = {.lex_state = 0, .external_lex_state = 187},
  [10113] = {.lex_state = 4, .external_lex_state = 155},
  [10114] = {.lex_state = 0, .external_lex_state = 187},
  [10115] = {.lex_state = 0, .external_lex_state = 155},
  [10116] = {.lex_state = 0, .external_lex_state = 187},
  [10117] = {.lex_state = 4, .external_lex_state = 155},
  [10118] = {.lex_state = 0, .external_lex_state = 187},
  [10119] = {.lex_state = 0, .external_lex_state = 155},
  [10120] = {.lex_state = 0, .external_lex_state = 155},
  [10121] = {.lex_state = 0, .external_lex_state = 155},
  [10122] = {.lex_state = 4, .external_lex_state = 155},
  [10123] = {.lex_state = 0, .external_lex_state = 192},
  [10124] = {.lex_state = 1, .external_lex_state = 155},
  [10125] = {.lex_state = 0, .external_lex_state = 155},
  [10126] = {.lex_state = 0, .external_lex_state = 155},
  [10127] = {.lex_state = 4, .external_lex_state = 155},
  [10128] = {.lex_state = 0, .external_lex_state = 155},
  [10129] = {.lex_state = 0, .external_lex_state = 155},
  [10130] = {.lex_state = 0, .external_lex_state = 155},
  [10131] = {.lex_state = 0, .external_lex_state = 155},
  [10132] = {.lex_state = 0, .external_lex_state = 155},
  [10133] = {.lex_state = 0, .external_lex_state = 155},
  [10134] = {.lex_state = 4, .external_lex_state = 155},
  [10135] = {.lex_state = 3, .external_lex_state = 155},
  [10136] = {.lex_state = 0, .external_lex_state = 155},
  [10137] = {.lex_state = 0, .external_lex_state = 214},
  [10138] = {.lex_state = 0, .external_lex_state = 187},
  [10139] = {.lex_state = 0, .external_lex_state = 187},
  [10140] = {.lex_state = 0, .external_lex_state = 187},
  [10141] = {.lex_state = 0, .external_lex_state = 187},
  [10142] = {.lex_state = 0, .external_lex_state = 187},
  [10143] = {.lex_state = 0, .external_lex_state = 187},
  [10144] = {.lex_state = 0, .external_lex_state = 155},
  [10145] = {.lex_state = 0, .external_lex_state = 155},
  [10146] = {.lex_state = 0, .external_lex_state = 187},
  [10147] = {.lex_state = 0, .external_lex_state = 192},
  [10148] = {.lex_state = 4, .external_lex_state = 155},
  [10149] = {.lex_state = 0, .external_lex_state = 187},
  [10150] = {.lex_state = 0, .external_lex_state = 187},
  [10151] = {.lex_state = 0, .external_lex_state = 187},
  [10152] = {.lex_state = 0, .external_lex_state = 155},
  [10153] = {.lex_state = 0, .external_lex_state = 187},
  [10154] = {.lex_state = 0, .external_lex_state = 187},
  [10155] = {.lex_state = 0, .external_lex_state = 187},
  [10156] = {.lex_state = 4, .external_lex_state = 155},
  [10157] = {.lex_state = 0, .external_lex_state = 155},
  [10158] = {.lex_state = 0, .external_lex_state = 155},
  [10159] = {.lex_state = 0, .external_lex_state = 155},
  [10160] = {.lex_state = 0, .external_lex_state = 187},
  [10161] = {.lex_state = 0, .external_lex_state = 155},
  [10162] = {.lex_state = 0, .external_lex_state = 192},
  [10163] = {.lex_state = 0, .external_lex_state = 155},
  [10164] = {.lex_state = 0, .external_lex_state = 155},
  [10165] = {.lex_state = 4, .external_lex_state = 155},
  [10166] = {.lex_state = 0, .external_lex_state = 155},
  [10167] = {.lex_state = 0, .external_lex_state = 155},
  [10168] = {.lex_state = 0, .external_lex_state = 155},
  [10169] = {.lex_state = 0, .external_lex_state = 187},
  [10170] = {.lex_state = 0, .external_lex_state = 187},
  [10171] = {.lex_state = 4, .external_lex_state = 155},
  [10172] = {.lex_state = 0, .external_lex_state = 187},
  [10173] = {.lex_state = 0, .external_lex_state = 187},
  [10174] = {.lex_state = 0, .external_lex_state = 192},
  [10175] = {.lex_state = 0, .external_lex_state = 155},
  [10176] = {.lex_state = 0, .external_lex_state = 187},
  [10177] = {.lex_state = 0, .external_lex_state = 155},
  [10178] = {.lex_state = 4, .external_lex_state = 155},
  [10179] = {.lex_state = 0, .external_lex_state = 187},
  [10180] = {.lex_state = 0, .external_lex_state = 187},
  [10181] = {.lex_state = 0, .external_lex_state = 155},
  [10182] = {.lex_state = 0, .external_lex_state = 187},
  [10183] = {.lex_state = 0, .external_lex_state = 155},
  [10184] = {.lex_state = 0, .external_lex_state = 155},
  [10185] = {.lex_state = 0, .external_lex_state = 187},
  [10186] = {.lex_state = 0, .external_lex_state = 155},
  [10187] = {.lex_state = 0, .external_lex_state = 187},
  [10188] = {.lex_state = 0, .external_lex_state = 155},
  [10189] = {.lex_state = 0, .external_lex_state = 155},
  [10190] = {.lex_state = 0, .external_lex_state = 155},
  [10191] = {.lex_state = 0, .external_lex_state = 187},
  [10192] = {.lex_state = 0, .external_lex_state = 187},
  [10193] = {.lex_state = 0, .external_lex_state = 187},
  [10194] = {.lex_state = 0, .external_lex_state = 155},
  [10195] = {.lex_state = 0, .external_lex_state = 155},
  [10196] = {.lex_state = 0, .external_lex_state = 192},
  [10197] = {.lex_state = 0, .external_lex_state = 187},
  [10198] = {.lex_state = 0, .external_lex_state = 187},
  [10199] = {.lex_state = 0, .external_lex_state = 187},
  [10200] = {.lex_state = 0, .external_lex_state = 155},
  [10201] = {.lex_state = 0, .external_lex_state = 187},
  [10202] = {.lex_state = 0, .external_lex_state = 155},
  [10203] = {.lex_state = 0, .external_lex_state = 155},
  [10204] = {.lex_state = 0, .external_lex_state = 155},
  [10205] = {.lex_state = 4, .external_lex_state = 155},
  [10206] = {.lex_state = 4, .external_lex_state = 155},
  [10207] = {.lex_state = 0, .external_lex_state = 155},
  [10208] = {.lex_state = 0, .external_lex_state = 155},
  [10209] = {.lex_state = 0, .external_lex_state = 155},
  [10210] = {.lex_state = 0, .external_lex_state = 155},
  [10211] = {.lex_state = 4, .external_lex_state = 155},
  [10212] = {.lex_state = 0, .external_lex_state = 187},
  [10213] = {.lex_state = 0, .external_lex_state = 166},
  [10214] = {.lex_state = 0, .external_lex_state = 187},
  [10215] = {.lex_state = 0, .external_lex_state = 192},
  [10216] = {.lex_state = 0, .external_lex_state = 155},
  [10217] = {.lex_state = 4, .external_lex_state = 155},
  [10218] = {.lex_state = 0, .external_lex_state = 166},
  [10219] = {.lex_state = 0, .external_lex_state = 187},
  [10220] = {.lex_state = 0, .external_lex_state = 187},
  [10221] = {.lex_state = 0, .external_lex_state = 187},
  [10222] = {.lex_state = 0, .external_lex_state = 187},
  [10223] = {.lex_state = 0, .external_lex_state = 155},
  [10224] = {.lex_state = 0, .external_lex_state = 187},
  [10225] = {.lex_state = 0, .external_lex_state = 155},
  [10226] = {.lex_state = 0, .external_lex_state = 155},
  [10227] = {.lex_state = 0, .external_lex_state = 155},
  [10228] = {.lex_state = 0, .external_lex_state = 192},
  [10229] = {.lex_state = 0, .external_lex_state = 155},
  [10230] = {.lex_state = 4, .external_lex_state = 155},
  [10231] = {.lex_state = 3, .external_lex_state = 213},
  [10232] = {.lex_state = 0, .external_lex_state = 187},
  [10233] = {.lex_state = 0, .external_lex_state = 214},
  [10234] = {.lex_state = 3, .external_lex_state = 211},
  [10235] = {.lex_state = 0, .external_lex_state = 187},
  [10236] = {.lex_state = 0, .external_lex_state = 214},
  [10237] = {.lex_state = 0, .external_lex_state = 187},
  [10238] = {.lex_state = 0, .external_lex_state = 187},
  [10239] = {.lex_state = 0, .external_lex_state = 187},
  [10240] = {.lex_state = 0, .external_lex_state = 155},
  [10241] = {.lex_state = 0, .external_lex_state = 155},
  [10242] = {.lex_state = 0, .external_lex_state = 187},
  [10243] = {.lex_state = 0, .external_lex_state = 204},
  [10244] = {.lex_state = 0, .external_lex_state = 192},
  [10245] = {.lex_state = 0, .external_lex_state = 155},
  [10246] = {.lex_state = 0, .external_lex_state = 187},
  [10247] = {.lex_state = 0, .external_lex_state = 187},
  [10248] = {.lex_state = 1, .external_lex_state = 155},
  [10249] = {.lex_state = 0, .external_lex_state = 155},
  [10250] = {.lex_state = 0, .external_lex_state = 187},
  [10251] = {.lex_state = 0, .external_lex_state = 187},
  [10252] = {.lex_state = 0, .external_lex_state = 155},
  [10253] = {.lex_state = 4, .external_lex_state = 155},
  [10254] = {.lex_state = 0, .external_lex_state = 187},
  [10255] = {.lex_state = 0, .external_lex_state = 155},
  [10256] = {.lex_state = 0, .external_lex_state = 187},
  [10257] = {.lex_state = 0, .external_lex_state = 155},
  [10258] = {.lex_state = 0, .external_lex_state = 214},
  [10259] = {.lex_state = 0, .external_lex_state = 187},
  [10260] = {.lex_state = 0, .external_lex_state = 157},
  [10261] = {.lex_state = 0, .external_lex_state = 187},
  [10262] = {.lex_state = 0, .external_lex_state = 187},
  [10263] = {.lex_state = 0, .external_lex_state = 155},
  [10264] = {.lex_state = 0, .external_lex_state = 187},
  [10265] = {.lex_state = 0, .external_lex_state = 187},
  [10266] = {.lex_state = 0, .external_lex_state = 187},
  [10267] = {.lex_state = 0, .external_lex_state = 187},
  [10268] = {.lex_state = 0, .external_lex_state = 187},
  [10269] = {.lex_state = 0, .external_lex_state = 187},
  [10270] = {.lex_state = 0, .external_lex_state = 155},
  [10271] = {.lex_state = 0, .external_lex_state = 155},
  [10272] = {.lex_state = 0, .external_lex_state = 187},
  [10273] = {.lex_state = 0, .external_lex_state = 192},
  [10274] = {.lex_state = 0, .external_lex_state = 190},
  [10275] = {.lex_state = 0, .external_lex_state = 155},
  [10276] = {.lex_state = 0, .external_lex_state = 187},
  [10277] = {.lex_state = 0, .external_lex_state = 155},
  [10278] = {.lex_state = 0, .external_lex_state = 211},
  [10279] = {.lex_state = 0, .external_lex_state = 187},
  [10280] = {.lex_state = 0, .external_lex_state = 155},
  [10281] = {.lex_state = 0, .external_lex_state = 187},
  [10282] = {.lex_state = 4, .external_lex_state = 155},
  [10283] = {.lex_state = 4, .external_lex_state = 155},
  [10284] = {.lex_state = 0, .external_lex_state = 187},
  [10285] = {.lex_state = 0, .external_lex_state = 187},
  [10286] = {.lex_state = 0, .external_lex_state = 187},
  [10287] = {.lex_state = 0, .external_lex_state = 187},
  [10288] = {.lex_state = 4, .external_lex_state = 155},
  [10289] = {.lex_state = 0, .external_lex_state = 166},
  [10290] = {.lex_state = 0, .external_lex_state = 187},
  [10291] = {.lex_state = 0, .external_lex_state = 187},
  [10292] = {.lex_state = 0, .external_lex_state = 155},
  [10293] = {.lex_state = 0, .external_lex_state = 187},
  [10294] = {.lex_state = 4, .external_lex_state = 193},
  [10295] = {.lex_state = 0, .external_lex_state = 187},
  [10296] = {.lex_state = 0, .external_lex_state = 187},
  [10297] = {.lex_state = 0, .external_lex_state = 155},
  [10298] = {.lex_state = 0, .external_lex_state = 187},
  [10299] = {.lex_state = 0, .external_lex_state = 155},
  [10300] = {.lex_state = 0, .external_lex_state = 187},
  [10301] = {.lex_state = 0, .external_lex_state = 187},
  [10302] = {.lex_state = 0, .external_lex_state = 155},
  [10303] = {.lex_state = 4, .external_lex_state = 155},
  [10304] = {.lex_state = 0, .external_lex_state = 187},
  [10305] = {.lex_state = 0, .external_lex_state = 187},
  [10306] = {.lex_state = 0, .external_lex_state = 155},
  [10307] = {.lex_state = 0, .external_lex_state = 187},
  [10308] = {.lex_state = 0, .external_lex_state = 187},
  [10309] = {.lex_state = 3, .external_lex_state = 155},
  [10310] = {.lex_state = 0, .external_lex_state = 155},
  [10311] = {.lex_state = 0, .external_lex_state = 155},
  [10312] = {.lex_state = 0, .external_lex_state = 187},
  [10313] = {.lex_state = 0, .external_lex_state = 155},
  [10314] = {.lex_state = 0, .external_lex_state = 155},
  [10315] = {.lex_state = 0, .external_lex_state = 155},
  [10316] = {.lex_state = 0, .external_lex_state = 187},
  [10317] = {.lex_state = 0, .external_lex_state = 155},
  [10318] = {.lex_state = 0, .external_lex_state = 155},
  [10319] = {.lex_state = 0, .external_lex_state = 187},
  [10320] = {.lex_state = 0, .external_lex_state = 155},
  [10321] = {.lex_state = 0, .external_lex_state = 155},
  [10322] = {.lex_state = 0, .external_lex_state = 155},
  [10323] = {.lex_state = 0, .external_lex_state = 155},
  [10324] = {.lex_state = 0, .external_lex_state = 155},
  [10325] = {.lex_state = 0, .external_lex_state = 155},
  [10326] = {.lex_state = 0, .external_lex_state = 155},
  [10327] = {.lex_state = 0, .external_lex_state = 155},
  [10328] = {.lex_state = 0, .external_lex_state = 155},
  [10329] = {.lex_state = 0, .external_lex_state = 155},
  [10330] = {.lex_state = 0, .external_lex_state = 155},
  [10331] = {.lex_state = 0, .external_lex_state = 187},
  [10332] = {.lex_state = 0, .external_lex_state = 155},
  [10333] = {.lex_state = 0, .external_lex_state = 155},
  [10334] = {.lex_state = 0, .external_lex_state = 155},
  [10335] = {.lex_state = 0, .external_lex_state = 155},
  [10336] = {.lex_state = 0, .external_lex_state = 155},
  [10337] = {.lex_state = 0, .external_lex_state = 155},
  [10338] = {.lex_state = 0, .external_lex_state = 155},
  [10339] = {.lex_state = 0, .external_lex_state = 155},
  [10340] = {.lex_state = 0, .external_lex_state = 155},
  [10341] = {.lex_state = 0, .external_lex_state = 155},
  [10342] = {.lex_state = 0, .external_lex_state = 155},
  [10343] = {.lex_state = 0, .external_lex_state = 155},
  [10344] = {.lex_state = 0, .external_lex_state = 155},
  [10345] = {.lex_state = 0, .external_lex_state = 155},
  [10346] = {.lex_state = 4, .external_lex_state = 155},
  [10347] = {.lex_state = 0, .external_lex_state = 155},
  [10348] = {.lex_state = 0, .external_lex_state = 192},
  [10349] = {.lex_state = 0, .external_lex_state = 155},
  [10350] = {.lex_state = 0, .external_lex_state = 155},
  [10351] = {.lex_state = 0, .external_lex_state = 155},
  [10352] = {.lex_state = 0, .external_lex_state = 155},
  [10353] = {.lex_state = 0, .external_lex_state = 155},
  [10354] = {.lex_state = 0, .external_lex_state = 155},
  [10355] = {.lex_state = 0, .external_lex_state = 155},
  [10356] = {.lex_state = 0, .external_lex_state = 155},
  [10357] = {.lex_state = 0, .external_lex_state = 155},
  [10358] = {.lex_state = 0, .external_lex_state = 155},
  [10359] = {.lex_state = 0, .external_lex_state = 155},
  [10360] = {.lex_state = 0, .external_lex_state = 155},
  [10361] = {.lex_state = 0, .external_lex_state = 155},
  [10362] = {.lex_state = 0, .external_lex_state = 155},
  [10363] = {.lex_state = 0, .external_lex_state = 155},
  [10364] = {.lex_state = 0, .external_lex_state = 155},
  [10365] = {.lex_state = 0, .external_lex_state = 155},
  [10366] = {.lex_state = 0, .external_lex_state = 155},
  [10367] = {.lex_state = 0, .external_lex_state = 155},
  [10368] = {.lex_state = 0, .external_lex_state = 157},
  [10369] = {.lex_state = 0, .external_lex_state = 155},
  [10370] = {.lex_state = 0, .external_lex_state = 155},
  [10371] = {.lex_state = 0, .external_lex_state = 157},
  [10372] = {.lex_state = 0, .external_lex_state = 155},
  [10373] = {.lex_state = 0, .external_lex_state = 187},
  [10374] = {.lex_state = 0, .external_lex_state = 190},
  [10375] = {.lex_state = 0, .external_lex_state = 155},
  [10376] = {.lex_state = 0, .external_lex_state = 155},
  [10377] = {.lex_state = 0, .external_lex_state = 155},
  [10378] = {.lex_state = 0, .external_lex_state = 155},
  [10379] = {.lex_state = 0, .external_lex_state = 187},
  [10380] = {.lex_state = 0, .external_lex_state = 155},
  [10381] = {.lex_state = 0, .external_lex_state = 187},
  [10382] = {.lex_state = 0, .external_lex_state = 155},
  [10383] = {.lex_state = 0, .external_lex_state = 155},
  [10384] = {.lex_state = 0, .external_lex_state = 187},
  [10385] = {.lex_state = 0, .external_lex_state = 187},
  [10386] = {.lex_state = 0, .external_lex_state = 187},
  [10387] = {.lex_state = 0, .external_lex_state = 155},
  [10388] = {.lex_state = 0, .external_lex_state = 187},
  [10389] = {.lex_state = 0, .external_lex_state = 187},
  [10390] = {.lex_state = 0, .external_lex_state = 155},
  [10391] = {.lex_state = 0, .external_lex_state = 187},
  [10392] = {.lex_state = 0, .external_lex_state = 155},
  [10393] = {.lex_state = 0, .external_lex_state = 155},
  [10394] = {.lex_state = 0, .external_lex_state = 155},
  [10395] = {.lex_state = 0, .external_lex_state = 155},
  [10396] = {.lex_state = 0, .external_lex_state = 187},
  [10397] = {.lex_state = 0, .external_lex_state = 155},
  [10398] = {.lex_state = 0, .external_lex_state = 155},
  [10399] = {.lex_state = 0, .external_lex_state = 155},
  [10400] = {.lex_state = 0, .external_lex_state = 155},
  [10401] = {.lex_state = 0, .external_lex_state = 155},
  [10402] = {.lex_state = 0, .external_lex_state = 155},
  [10403] = {.lex_state = 4, .external_lex_state = 155},
  [10404] = {.lex_state = 0, .external_lex_state = 155},
  [10405] = {.lex_state = 0, .external_lex_state = 155},
  [10406] = {.lex_state = 0, .external_lex_state = 155},
  [10407] = {.lex_state = 0, .external_lex_state = 155},
  [10408] = {.lex_state = 0, .external_lex_state = 155},
  [10409] = {.lex_state = 0, .external_lex_state = 155},
  [10410] = {.lex_state = 0, .external_lex_state = 187},
  [10411] = {.lex_state = 0, .external_lex_state = 155},
  [10412] = {.lex_state = 4, .external_lex_state = 155},
  [10413] = {.lex_state = 0, .external_lex_state = 187},
  [10414] = {.lex_state = 0, .external_lex_state = 187},
  [10415] = {.lex_state = 0, .external_lex_state = 155},
  [10416] = {.lex_state = 0, .external_lex_state = 155},
  [10417] = {.lex_state = 0, .external_lex_state = 155},
  [10418] = {.lex_state = 0, .external_lex_state = 155},
  [10419] = {.lex_state = 0, .external_lex_state = 155},
  [10420] = {.lex_state = 0, .external_lex_state = 155},
  [10421] = {.lex_state = 0, .external_lex_state = 187},
  [10422] = {.lex_state = 0, .external_lex_state = 155},
  [10423] = {.lex_state = 0, .external_lex_state = 155},
  [10424] = {.lex_state = 0, .external_lex_state = 187},
  [10425] = {.lex_state = 0, .external_lex_state = 155},
  [10426] = {.lex_state = 0, .external_lex_state = 155},
  [10427] = {.lex_state = 0, .external_lex_state = 155},
  [10428] = {.lex_state = 0, .external_lex_state = 155},
  [10429] = {.lex_state = 0, .external_lex_state = 155},
  [10430] = {.lex_state = 0, .external_lex_state = 155},
  [10431] = {.lex_state = 0, .external_lex_state = 155},
  [10432] = {.lex_state = 3, .external_lex_state = 211},
  [10433] = {.lex_state = 0, .external_lex_state = 155},
  [10434] = {.lex_state = 4, .external_lex_state = 155},
  [10435] = {.lex_state = 0, .external_lex_state = 155},
  [10436] = {.lex_state = 0, .external_lex_state = 155},
  [10437] = {.lex_state = 0, .external_lex_state = 155},
  [10438] = {.lex_state = 0, .external_lex_state = 155},
  [10439] = {.lex_state = 0, .external_lex_state = 155},
  [10440] = {.lex_state = 0, .external_lex_state = 155},
  [10441] = {.lex_state = 0, .external_lex_state = 155},
  [10442] = {.lex_state = 0, .external_lex_state = 187},
  [10443] = {.lex_state = 0, .external_lex_state = 155},
  [10444] = {.lex_state = 0, .external_lex_state = 187},
  [10445] = {.lex_state = 0, .external_lex_state = 155},
  [10446] = {.lex_state = 0, .external_lex_state = 187},
  [10447] = {.lex_state = 0, .external_lex_state = 155},
  [10448] = {.lex_state = 0, .external_lex_state = 155},
  [10449] = {.lex_state = 0, .external_lex_state = 155},
  [10450] = {.lex_state = 0, .external_lex_state = 155},
  [10451] = {.lex_state = 0, .external_lex_state = 155},
  [10452] = {.lex_state = 0, .external_lex_state = 187},
  [10453] = {.lex_state = 0, .external_lex_state = 187},
  [10454] = {.lex_state = 0, .external_lex_state = 187},
  [10455] = {.lex_state = 0, .external_lex_state = 187},
  [10456] = {.lex_state = 0, .external_lex_state = 155},
  [10457] = {.lex_state = 0, .external_lex_state = 187},
  [10458] = {.lex_state = 0, .external_lex_state = 155},
  [10459] = {.lex_state = 0, .external_lex_state = 155},
  [10460] = {.lex_state = 0, .external_lex_state = 155},
  [10461] = {.lex_state = 0, .external_lex_state = 155},
  [10462] = {.lex_state = 0, .external_lex_state = 214},
  [10463] = {.lex_state = 0, .external_lex_state = 187},
  [10464] = {.lex_state = 0, .external_lex_state = 187},
  [10465] = {.lex_state = 0, .external_lex_state = 187},
  [10466] = {.lex_state = 0, .external_lex_state = 155},
  [10467] = {.lex_state = 0, .external_lex_state = 155},
  [10468] = {.lex_state = 0, .external_lex_state = 187},
  [10469] = {.lex_state = 0, .external_lex_state = 187},
  [10470] = {.lex_state = 0, .external_lex_state = 155},
  [10471] = {.lex_state = 0, .external_lex_state = 187},
  [10472] = {.lex_state = 0, .external_lex_state = 155},
  [10473] = {.lex_state = 0, .external_lex_state = 187},
  [10474] = {.lex_state = 0, .external_lex_state = 155},
  [10475] = {.lex_state = 0, .external_lex_state = 155},
  [10476] = {.lex_state = 0, .external_lex_state = 155},
  [10477] = {.lex_state = 0, .external_lex_state = 187},
  [10478] = {.lex_state = 0, .external_lex_state = 155},
  [10479] = {.lex_state = 0, .external_lex_state = 155},
  [10480] = {.lex_state = 0, .external_lex_state = 187},
  [10481] = {.lex_state = 0, .external_lex_state = 187},
  [10482] = {.lex_state = 0, .external_lex_state = 187},
  [10483] = {.lex_state = 0, .external_lex_state = 187},
  [10484] = {.lex_state = 0, .external_lex_state = 155},
  [10485] = {.lex_state = 0, .external_lex_state = 155},
  [10486] = {.lex_state = 0, .external_lex_state = 155},
  [10487] = {.lex_state = 0, .external_lex_state = 155},
  [10488] = {.lex_state = 0, .external_lex_state = 187},
  [10489] = {.lex_state = 0, .external_lex_state = 155},
  [10490] = {.lex_state = 0, .external_lex_state = 155},
  [10491] = {.lex_state = 0, .external_lex_state = 155},
  [10492] = {.lex_state = 0, .external_lex_state = 155},
  [10493] = {.lex_state = 0, .external_lex_state = 155},
  [10494] = {.lex_state = 0, .external_lex_state = 155},
  [10495] = {.lex_state = 0, .external_lex_state = 187},
  [10496] = {.lex_state = 0, .external_lex_state = 155},
  [10497] = {.lex_state = 0, .external_lex_state = 155},
  [10498] = {.lex_state = 0, .external_lex_state = 187},
  [10499] = {.lex_state = 0, .external_lex_state = 155},
  [10500] = {.lex_state = 0, .external_lex_state = 155},
  [10501] = {.lex_state = 0, .external_lex_state = 155},
  [10502] = {.lex_state = 0, .external_lex_state = 155},
  [10503] = {.lex_state = 4, .external_lex_state = 193},
  [10504] = {.lex_state = 0, .external_lex_state = 155},
  [10505] = {.lex_state = 0, .external_lex_state = 155},
  [10506] = {.lex_state = 4, .external_lex_state = 193},
  [10507] = {.lex_state = 4, .external_lex_state = 193},
  [10508] = {.lex_state = 0, .external_lex_state = 155},
  [10509] = {.lex_state = 0, .external_lex_state = 187},
  [10510] = {.lex_state = 0, .external_lex_state = 155},
  [10511] = {.lex_state = 0, .external_lex_state = 155},
  [10512] = {.lex_state = 0, .external_lex_state = 155},
  [10513] = {.lex_state = 0, .external_lex_state = 155},
  [10514] = {.lex_state = 0, .external_lex_state = 155},
  [10515] = {.lex_state = 0, .external_lex_state = 155},
  [10516] = {.lex_state = 0, .external_lex_state = 155},
  [10517] = {.lex_state = 0, .external_lex_state = 187},
  [10518] = {.lex_state = 0, .external_lex_state = 187},
  [10519] = {.lex_state = 0, .external_lex_state = 187},
  [10520] = {.lex_state = 0, .external_lex_state = 155},
  [10521] = {.lex_state = 0, .external_lex_state = 187},
  [10522] = {.lex_state = 0, .external_lex_state = 187},
  [10523] = {.lex_state = 0, .external_lex_state = 187},
  [10524] = {.lex_state = 0, .external_lex_state = 187},
  [10525] = {.lex_state = 0, .external_lex_state = 187},
  [10526] = {.lex_state = 0, .external_lex_state = 187},
  [10527] = {.lex_state = 0, .external_lex_state = 187},
  [10528] = {.lex_state = 0, .external_lex_state = 155},
  [10529] = {.lex_state = 0, .external_lex_state = 155},
  [10530] = {.lex_state = 0, .external_lex_state = 155},
  [10531] = {.lex_state = 0, .external_lex_state = 155},
  [10532] = {.lex_state = 0, .external_lex_state = 187},
  [10533] = {.lex_state = 0, .external_lex_state = 155},
  [10534] = {.lex_state = 0, .external_lex_state = 187},
  [10535] = {.lex_state = 0, .external_lex_state = 155},
  [10536] = {.lex_state = 0, .external_lex_state = 155},
  [10537] = {.lex_state = 0, .external_lex_state = 187},
  [10538] = {.lex_state = 0, .external_lex_state = 155},
  [10539] = {.lex_state = 0, .external_lex_state = 155},
  [10540] = {.lex_state = 0, .external_lex_state = 155},
  [10541] = {.lex_state = 0, .external_lex_state = 187},
  [10542] = {.lex_state = 0, .external_lex_state = 187},
  [10543] = {.lex_state = 0, .external_lex_state = 187},
  [10544] = {.lex_state = 0, .external_lex_state = 155},
  [10545] = {.lex_state = 0, .external_lex_state = 187},
  [10546] = {.lex_state = 0, .external_lex_state = 187},
  [10547] = {.lex_state = 0, .external_lex_state = 187},
  [10548] = {.lex_state = 0, .external_lex_state = 187},
  [10549] = {.lex_state = 0, .external_lex_state = 187},
  [10550] = {.lex_state = 0, .external_lex_state = 187},
  [10551] = {.lex_state = 0, .external_lex_state = 187},
  [10552] = {.lex_state = 0, .external_lex_state = 187},
  [10553] = {.lex_state = 0, .external_lex_state = 155},
  [10554] = {.lex_state = 0, .external_lex_state = 187},
  [10555] = {.lex_state = 0, .external_lex_state = 187},
  [10556] = {.lex_state = 0, .external_lex_state = 155},
  [10557] = {.lex_state = 0, .external_lex_state = 155},
  [10558] = {.lex_state = 0, .external_lex_state = 187},
  [10559] = {.lex_state = 0, .external_lex_state = 155},
  [10560] = {.lex_state = 0, .external_lex_state = 155},
  [10561] = {.lex_state = 0, .external_lex_state = 155},
  [10562] = {.lex_state = 0, .external_lex_state = 155},
  [10563] = {.lex_state = 0, .external_lex_state = 187},
  [10564] = {.lex_state = 0, .external_lex_state = 155},
  [10565] = {.lex_state = 0, .external_lex_state = 187},
  [10566] = {.lex_state = 0, .external_lex_state = 155},
  [10567] = {.lex_state = 0, .external_lex_state = 155},
  [10568] = {.lex_state = 0, .external_lex_state = 155},
  [10569] = {.lex_state = 0, .external_lex_state = 155},
  [10570] = {.lex_state = 0, .external_lex_state = 155},
  [10571] = {.lex_state = 0, .external_lex_state = 155},
  [10572] = {.lex_state = 0, .external_lex_state = 155},
  [10573] = {.lex_state = 0, .external_lex_state = 155},
  [10574] = {.lex_state = 0, .external_lex_state = 155},
  [10575] = {.lex_state = 0, .external_lex_state = 155},
  [10576] = {.lex_state = 0, .external_lex_state = 155},
  [10577] = {.lex_state = 0, .external_lex_state = 155},
  [10578] = {.lex_state = 0, .external_lex_state = 155},
  [10579] = {.lex_state = 0, .external_lex_state = 155},
  [10580] = {.lex_state = 0, .external_lex_state = 187},
  [10581] = {.lex_state = 0, .external_lex_state = 155},
  [10582] = {.lex_state = 0, .external_lex_state = 155},
  [10583] = {.lex_state = 0, .external_lex_state = 155},
  [10584] = {.lex_state = 0, .external_lex_state = 155},
  [10585] = {.lex_state = 0, .external_lex_state = 155},
  [10586] = {.lex_state = 0, .external_lex_state = 155},
  [10587] = {.lex_state = 0, .external_lex_state = 155},
  [10588] = {.lex_state = 0, .external_lex_state = 155},
  [10589] = {.lex_state = 0, .external_lex_state = 155},
  [10590] = {.lex_state = 0, .external_lex_state = 155},
  [10591] = {.lex_state = 0, .external_lex_state = 155},
  [10592] = {.lex_state = 0, .external_lex_state = 187},
  [10593] = {.lex_state = 0, .external_lex_state = 187},
  [10594] = {.lex_state = 0, .external_lex_state = 187},
  [10595] = {.lex_state = 0, .external_lex_state = 155},
  [10596] = {.lex_state = 0, .external_lex_state = 187},
  [10597] = {.lex_state = 0, .external_lex_state = 155},
  [10598] = {.lex_state = 0, .external_lex_state = 155},
  [10599] = {.lex_state = 4, .external_lex_state = 155},
  [10600] = {.lex_state = 0, .external_lex_state = 155},
  [10601] = {.lex_state = 0, .external_lex_state = 155},
  [10602] = {.lex_state = 0, .external_lex_state = 187},
  [10603] = {.lex_state = 0, .external_lex_state = 187},
  [10604] = {.lex_state = 0, .external_lex_state = 155},
  [10605] = {.lex_state = 0, .external_lex_state = 155},
  [10606] = {.lex_state = 0, .external_lex_state = 187},
  [10607] = {.lex_state = 0, .external_lex_state = 155},
  [10608] = {.lex_state = 0, .external_lex_state = 155},
  [10609] = {.lex_state = 0, .external_lex_state = 155},
  [10610] = {.lex_state = 0, .external_lex_state = 155},
  [10611] = {.lex_state = 0, .external_lex_state = 187},
  [10612] = {.lex_state = 0, .external_lex_state = 155},
  [10613] = {.lex_state = 0, .external_lex_state = 155},
  [10614] = {.lex_state = 0, .external_lex_state = 155},
  [10615] = {.lex_state = 0, .external_lex_state = 155},
  [10616] = {.lex_state = 0, .external_lex_state = 155},
  [10617] = {.lex_state = 0, .external_lex_state = 155},
  [10618] = {.lex_state = 0, .external_lex_state = 187},
  [10619] = {.lex_state = 0, .external_lex_state = 187},
  [10620] = {.lex_state = 0, .external_lex_state = 155},
  [10621] = {.lex_state = 0, .external_lex_state = 155},
  [10622] = {.lex_state = 0, .external_lex_state = 187},
  [10623] = {.lex_state = 0, .external_lex_state = 155},
  [10624] = {.lex_state = 0, .external_lex_state = 155},
  [10625] = {.lex_state = 0, .external_lex_state = 187},
  [10626] = {.lex_state = 0, .external_lex_state = 155},
  [10627] = {.lex_state = 0, .external_lex_state = 155},
  [10628] = {.lex_state = 0, .external_lex_state = 155},
  [10629] = {.lex_state = 0, .external_lex_state = 155},
  [10630] = {.lex_state = 0, .external_lex_state = 155},
  [10631] = {.lex_state = 0, .external_lex_state = 155},
  [10632] = {.lex_state = 0, .external_lex_state = 155},
  [10633] = {.lex_state = 0, .external_lex_state = 155},
  [10634] = {.lex_state = 0, .external_lex_state = 187},
  [10635] = {.lex_state = 0, .external_lex_state = 187},
  [10636] = {.lex_state = 0, .external_lex_state = 187},
  [10637] = {.lex_state = 0, .external_lex_state = 187},
  [10638] = {.lex_state = 0, .external_lex_state = 187},
  [10639] = {.lex_state = 0, .external_lex_state = 155},
  [10640] = {.lex_state = 0, .external_lex_state = 155},
  [10641] = {.lex_state = 0, .external_lex_state = 155},
  [10642] = {.lex_state = 0, .external_lex_state = 155},
  [10643] = {.lex_state = 0, .external_lex_state = 155},
  [10644] = {.lex_state = 0, .external_lex_state = 155},
  [10645] = {.lex_state = 0, .external_lex_state = 155},
  [10646] = {.lex_state = 0, .external_lex_state = 155},
  [10647] = {.lex_state = 0, .external_lex_state = 155},
  [10648] = {.lex_state = 0, .external_lex_state = 155},
  [10649] = {.lex_state = 0, .external_lex_state = 155},
  [10650] = {.lex_state = 0, .external_lex_state = 187},
  [10651] = {.lex_state = 0, .external_lex_state = 155},
  [10652] = {.lex_state = 0, .external_lex_state = 155},
  [10653] = {.lex_state = 0, .external_lex_state = 155},
  [10654] = {.lex_state = 0, .external_lex_state = 155},
  [10655] = {.lex_state = 0, .external_lex_state = 187},
  [10656] = {.lex_state = 0, .external_lex_state = 155},
  [10657] = {.lex_state = 0, .external_lex_state = 155},
  [10658] = {.lex_state = 0, .external_lex_state = 155},
  [10659] = {.lex_state = 0, .external_lex_state = 155},
  [10660] = {.lex_state = 0, .external_lex_state = 155},
  [10661] = {.lex_state = 0, .external_lex_state = 155},
  [10662] = {.lex_state = 0, .external_lex_state = 187},
  [10663] = {.lex_state = 0, .external_lex_state = 155},
  [10664] = {.lex_state = 0, .external_lex_state = 155},
  [10665] = {.lex_state = 0, .external_lex_state = 155},
  [10666] = {.lex_state = 0, .external_lex_state = 155},
  [10667] = {.lex_state = 0, .external_lex_state = 155},
  [10668] = {.lex_state = 0, .external_lex_state = 187},
  [10669] = {.lex_state = 0, .external_lex_state = 155},
  [10670] = {.lex_state = 0, .external_lex_state = 187},
  [10671] = {.lex_state = 0, .external_lex_state = 155},
  [10672] = {.lex_state = 0, .external_lex_state = 155},
  [10673] = {.lex_state = 0, .external_lex_state = 155},
  [10674] = {.lex_state = 0, .external_lex_state = 187},
  [10675] = {.lex_state = 0, .external_lex_state = 155},
  [10676] = {.lex_state = 0, .external_lex_state = 155},
  [10677] = {.lex_state = 0, .external_lex_state = 155},
  [10678] = {.lex_state = 0, .external_lex_state = 155},
  [10679] = {.lex_state = 0, .external_lex_state = 187},
  [10680] = {.lex_state = 0, .external_lex_state = 155},
  [10681] = {.lex_state = 0, .external_lex_state = 187},
  [10682] = {.lex_state = 0, .external_lex_state = 187},
  [10683] = {.lex_state = 0, .external_lex_state = 155},
  [10684] = {.lex_state = 0, .external_lex_state = 187},
  [10685] = {.lex_state = 0, .external_lex_state = 155},
  [10686] = {.lex_state = 0, .external_lex_state = 155},
  [10687] = {.lex_state = 0, .external_lex_state = 155},
  [10688] = {.lex_state = 0, .external_lex_state = 155},
  [10689] = {.lex_state = 0, .external_lex_state = 155},
  [10690] = {.lex_state = 0, .external_lex_state = 187},
  [10691] = {.lex_state = 0, .external_lex_state = 155},
  [10692] = {.lex_state = 4, .external_lex_state = 155},
  [10693] = {.lex_state = 0, .external_lex_state = 155},
  [10694] = {.lex_state = 0, .external_lex_state = 155},
  [10695] = {.lex_state = 0, .external_lex_state = 155},
  [10696] = {.lex_state = 0, .external_lex_state = 187},
  [10697] = {.lex_state = 0, .external_lex_state = 155},
  [10698] = {.lex_state = 0, .external_lex_state = 155},
  [10699] = {.lex_state = 0, .external_lex_state = 155},
  [10700] = {.lex_state = 0, .external_lex_state = 155},
  [10701] = {.lex_state = 0, .external_lex_state = 155},
  [10702] = {.lex_state = 0, .external_lex_state = 187},
  [10703] = {.lex_state = 0, .external_lex_state = 155},
  [10704] = {.lex_state = 0, .external_lex_state = 187},
  [10705] = {.lex_state = 0, .external_lex_state = 187},
  [10706] = {.lex_state = 0, .external_lex_state = 155},
  [10707] = {.lex_state = 0, .external_lex_state = 155},
  [10708] = {.lex_state = 0, .external_lex_state = 187},
  [10709] = {.lex_state = 0, .external_lex_state = 187},
  [10710] = {.lex_state = 0, .external_lex_state = 155},
  [10711] = {.lex_state = 0, .external_lex_state = 155},
  [10712] = {.lex_state = 0, .external_lex_state = 155},
  [10713] = {.lex_state = 0, .external_lex_state = 155},
  [10714] = {.lex_state = 0, .external_lex_state = 155},
  [10715] = {.lex_state = 0, .external_lex_state = 187},
  [10716] = {.lex_state = 0, .external_lex_state = 187},
  [10717] = {.lex_state = 0, .external_lex_state = 187},
  [10718] = {.lex_state = 0, .external_lex_state = 204},
  [10719] = {.lex_state = 0, .external_lex_state = 187},
  [10720] = {.lex_state = 0, .external_lex_state = 187},
  [10721] = {.lex_state = 0, .external_lex_state = 187},
  [10722] = {.lex_state = 0, .external_lex_state = 155},
  [10723] = {.lex_state = 3, .external_lex_state = 211},
  [10724] = {.lex_state = 0, .external_lex_state = 155},
  [10725] = {.lex_state = 0, .external_lex_state = 155},
  [10726] = {.lex_state = 0, .external_lex_state = 155},
  [10727] = {.lex_state = 0, .external_lex_state = 155},
  [10728] = {.lex_state = 0, .external_lex_state = 155},
  [10729] = {.lex_state = 0, .external_lex_state = 155},
  [10730] = {.lex_state = 0, .external_lex_state = 155},
  [10731] = {.lex_state = 0, .external_lex_state = 155},
  [10732] = {.lex_state = 0, .external_lex_state = 155},
  [10733] = {.lex_state = 0, .external_lex_state = 155},
  [10734] = {.lex_state = 0, .external_lex_state = 155},
  [10735] = {.lex_state = 0, .external_lex_state = 187},
  [10736] = {.lex_state = 0, .external_lex_state = 187},
  [10737] = {.lex_state = 0, .external_lex_state = 187},
  [10738] = {.lex_state = 0, .external_lex_state = 187},
  [10739] = {.lex_state = 0, .external_lex_state = 155},
  [10740] = {.lex_state = 0, .external_lex_state = 155},
  [10741] = {.lex_state = 0, .external_lex_state = 155},
  [10742] = {.lex_state = 0, .external_lex_state = 187},
  [10743] = {.lex_state = 0, .external_lex_state = 155},
  [10744] = {.lex_state = 0, .external_lex_state = 155},
  [10745] = {.lex_state = 0, .external_lex_state = 187},
  [10746] = {.lex_state = 0, .external_lex_state = 155},
  [10747] = {.lex_state = 0, .external_lex_state = 187},
  [10748] = {.lex_state = 0, .external_lex_state = 155},
  [10749] = {.lex_state = 0, .external_lex_state = 187},
  [10750] = {.lex_state = 0, .external_lex_state = 187},
  [10751] = {.lex_state = 0, .external_lex_state = 155},
  [10752] = {.lex_state = 0, .external_lex_state = 155},
  [10753] = {.lex_state = 0, .external_lex_state = 187},
  [10754] = {.lex_state = 0, .external_lex_state = 187},
  [10755] = {.lex_state = 0, .external_lex_state = 155},
  [10756] = {.lex_state = 0, .external_lex_state = 187},
  [10757] = {.lex_state = 0, .external_lex_state = 155},
  [10758] = {.lex_state = 0, .external_lex_state = 187},
  [10759] = {.lex_state = 0, .external_lex_state = 155},
  [10760] = {.lex_state = 0, .external_lex_state = 155},
  [10761] = {.lex_state = 0, .external_lex_state = 155},
  [10762] = {.lex_state = 4, .external_lex_state = 193},
  [10763] = {.lex_state = 4, .external_lex_state = 193},
  [10764] = {.lex_state = 0, .external_lex_state = 155},
  [10765] = {.lex_state = 0, .external_lex_state = 155},
  [10766] = {.lex_state = 0, .external_lex_state = 187},
  [10767] = {.lex_state = 0, .external_lex_state = 155},
  [10768] = {.lex_state = 0, .external_lex_state = 155},
  [10769] = {.lex_state = 0, .external_lex_state = 155},
  [10770] = {.lex_state = 0, .external_lex_state = 155},
  [10771] = {.lex_state = 0, .external_lex_state = 187},
  [10772] = {.lex_state = 0, .external_lex_state = 187},
  [10773] = {.lex_state = 0, .external_lex_state = 155},
  [10774] = {.lex_state = 4, .external_lex_state = 155},
  [10775] = {.lex_state = 0, .external_lex_state = 155},
  [10776] = {.lex_state = 0, .external_lex_state = 155},
  [10777] = {.lex_state = 0, .external_lex_state = 187},
  [10778] = {.lex_state = 0, .external_lex_state = 155},
  [10779] = {.lex_state = 0, .external_lex_state = 155},
  [10780] = {.lex_state = 0, .external_lex_state = 187},
  [10781] = {.lex_state = 0, .external_lex_state = 155},
  [10782] = {.lex_state = 0, .external_lex_state = 187},
  [10783] = {.lex_state = 0, .external_lex_state = 187},
  [10784] = {.lex_state = 0, .external_lex_state = 155},
  [10785] = {.lex_state = 0, .external_lex_state = 155},
  [10786] = {.lex_state = 0, .external_lex_state = 187},
  [10787] = {.lex_state = 0, .external_lex_state = 155},
  [10788] = {.lex_state = 0, .external_lex_state = 155},
  [10789] = {.lex_state = 0, .external_lex_state = 155},
  [10790] = {.lex_state = 0, .external_lex_state = 155},
  [10791] = {.lex_state = 0, .external_lex_state = 155},
  [10792] = {.lex_state = 0, .external_lex_state = 155},
  [10793] = {.lex_state = 4, .external_lex_state = 155},
  [10794] = {.lex_state = 0, .external_lex_state = 155},
  [10795] = {.lex_state = 0, .external_lex_state = 155},
  [10796] = {.lex_state = 0, .external_lex_state = 155},
  [10797] = {.lex_state = 0, .external_lex_state = 155},
  [10798] = {.lex_state = 0, .external_lex_state = 155},
  [10799] = {.lex_state = 0, .external_lex_state = 155},
  [10800] = {.lex_state = 0, .external_lex_state = 155},
  [10801] = {.lex_state = 0, .external_lex_state = 155},
  [10802] = {.lex_state = 4, .external_lex_state = 155},
  [10803] = {.lex_state = 0, .external_lex_state = 155},
  [10804] = {.lex_state = 0, .external_lex_state = 155},
  [10805] = {.lex_state = 0, .external_lex_state = 155},
  [10806] = {.lex_state = 0, .external_lex_state = 155},
  [10807] = {.lex_state = 0, .external_lex_state = 155},
  [10808] = {.lex_state = 0, .external_lex_state = 155},
  [10809] = {.lex_state = 0, .external_lex_state = 155},
  [10810] = {.lex_state = 0, .external_lex_state = 187},
  [10811] = {.lex_state = 0, .external_lex_state = 155},
  [10812] = {.lex_state = 0, .external_lex_state = 187},
  [10813] = {.lex_state = 0, .external_lex_state = 187},
  [10814] = {.lex_state = 0, .external_lex_state = 155},
  [10815] = {.lex_state = 0, .external_lex_state = 155},
  [10816] = {.lex_state = 0, .external_lex_state = 155},
  [10817] = {.lex_state = 0, .external_lex_state = 155},
  [10818] = {.lex_state = 0, .external_lex_state = 155},
  [10819] = {.lex_state = 0, .external_lex_state = 155},
  [10820] = {.lex_state = 0, .external_lex_state = 155},
  [10821] = {.lex_state = 0, .external_lex_state = 155},
  [10822] = {.lex_state = 0, .external_lex_state = 155},
  [10823] = {.lex_state = 0, .external_lex_state = 155},
  [10824] = {.lex_state = 0, .external_lex_state = 155},
  [10825] = {.lex_state = 0, .external_lex_state = 155},
  [10826] = {.lex_state = 0, .external_lex_state = 155},
  [10827] = {.lex_state = 0, .external_lex_state = 155},
  [10828] = {.lex_state = 0, .external_lex_state = 155},
  [10829] = {.lex_state = 0, .external_lex_state = 155},
  [10830] = {.lex_state = 0, .external_lex_state = 155},
  [10831] = {.lex_state = 0, .external_lex_state = 155},
  [10832] = {.lex_state = 0, .external_lex_state = 155},
  [10833] = {.lex_state = 0, .external_lex_state = 155},
  [10834] = {.lex_state = 0, .external_lex_state = 155},
  [10835] = {.lex_state = 0, .external_lex_state = 155},
  [10836] = {.lex_state = 0, .external_lex_state = 155},
  [10837] = {.lex_state = 0, .external_lex_state = 155},
  [10838] = {.lex_state = 0, .external_lex_state = 155},
  [10839] = {.lex_state = 0, .external_lex_state = 155},
  [10840] = {.lex_state = 0, .external_lex_state = 155},
  [10841] = {.lex_state = 0, .external_lex_state = 155},
  [10842] = {.lex_state = 0, .external_lex_state = 155},
  [10843] = {.lex_state = 0, .external_lex_state = 155},
  [10844] = {.lex_state = 0, .external_lex_state = 155},
  [10845] = {.lex_state = 0, .external_lex_state = 155},
  [10846] = {.lex_state = 0, .external_lex_state = 187},
  [10847] = {.lex_state = 0, .external_lex_state = 187},
  [10848] = {.lex_state = 0, .external_lex_state = 187},
  [10849] = {.lex_state = 0, .external_lex_state = 155},
  [10850] = {.lex_state = 0, .external_lex_state = 155},
  [10851] = {.lex_state = 0, .external_lex_state = 187},
  [10852] = {.lex_state = 0, .external_lex_state = 187},
  [10853] = {.lex_state = 0, .external_lex_state = 155},
  [10854] = {.lex_state = 0, .external_lex_state = 155},
  [10855] = {.lex_state = 0, .external_lex_state = 155},
  [10856] = {.lex_state = 0, .external_lex_state = 187},
  [10857] = {.lex_state = 0, .external_lex_state = 155},
  [10858] = {.lex_state = 0, .external_lex_state = 155},
  [10859] = {.lex_state = 0, .external_lex_state = 155},
  [10860] = {.lex_state = 0, .external_lex_state = 155},
  [10861] = {.lex_state = 0, .external_lex_state = 155},
  [10862] = {.lex_state = 0, .external_lex_state = 155},
  [10863] = {.lex_state = 0, .external_lex_state = 155},
  [10864] = {.lex_state = 0, .external_lex_state = 187},
  [10865] = {.lex_state = 0, .external_lex_state = 155},
  [10866] = {.lex_state = 0, .external_lex_state = 155},
  [10867] = {.lex_state = 0, .external_lex_state = 155},
  [10868] = {.lex_state = 0, .external_lex_state = 155},
  [10869] = {.lex_state = 0, .external_lex_state = 155},
  [10870] = {.lex_state = 0, .external_lex_state = 155},
  [10871] = {.lex_state = 0, .external_lex_state = 155},
  [10872] = {.lex_state = 4, .external_lex_state = 155},
  [10873] = {.lex_state = 3, .external_lex_state = 155},
  [10874] = {.lex_state = 3, .external_lex_state = 155},
  [10875] = {.lex_state = 3, .external_lex_state = 155},
  [10876] = {.lex_state = 3, .external_lex_state = 155},
  [10877] = {.lex_state = 3, .external_lex_state = 155},
  [10878] = {.lex_state = 3, .external_lex_state = 155},
  [10879] = {.lex_state = 0, .external_lex_state = 155},
  [10880] = {.lex_state = 0, .external_lex_state = 155},
  [10881] = {.lex_state = 0, .external_lex_state = 155},
  [10882] = {.lex_state = 0, .external_lex_state = 155},
  [10883] = {.lex_state = 0, .external_lex_state = 155},
  [10884] = {.lex_state = 0, .external_lex_state = 187},
  [10885] = {.lex_state = 0, .external_lex_state = 155},
  [10886] = {.lex_state = 0, .external_lex_state = 155},
  [10887] = {.lex_state = 0, .external_lex_state = 155},
  [10888] = {.lex_state = 0, .external_lex_state = 155},
  [10889] = {.lex_state = 0, .external_lex_state = 155},
  [10890] = {.lex_state = 4, .external_lex_state = 207},
  [10891] = {.lex_state = 0, .external_lex_state = 155},
  [10892] = {.lex_state = 0, .external_lex_state = 155},
  [10893] = {.lex_state = 3, .external_lex_state = 216},
  [10894] = {.lex_state = 0, .external_lex_state = 155},
  [10895] = {.lex_state = 3, .external_lex_state = 216},
  [10896] = {.lex_state = 0, .external_lex_state = 159},
  [10897] = {.lex_state = 9, .external_lex_state = 155},
  [10898] = {.lex_state = 0, .external_lex_state = 214},
  [10899] = {.lex_state = 0, .external_lex_state = 214},
  [10900] = {.lex_state = 0, .external_lex_state = 214},
  [10901] = {.lex_state = 0, .external_lex_state = 214},
  [10902] = {.lex_state = 0, .external_lex_state = 214},
  [10903] = {.lex_state = 0, .external_lex_state = 155},
  [10904] = {.lex_state = 0, .external_lex_state = 155},
  [10905] = {.lex_state = 0, .external_lex_state = 155},
  [10906] = {.lex_state = 0, .external_lex_state = 155},
  [10907] = {.lex_state = 0, .external_lex_state = 155},
  [10908] = {.lex_state = 0, .external_lex_state = 155},
  [10909] = {.lex_state = 0, .external_lex_state = 155},
  [10910] = {.lex_state = 0, .external_lex_state = 155},
  [10911] = {.lex_state = 0, .external_lex_state = 214},
  [10912] = {.lex_state = 0, .external_lex_state = 155},
  [10913] = {.lex_state = 0, .external_lex_state = 155},
  [10914] = {.lex_state = 0, .external_lex_state = 155},
  [10915] = {.lex_state = 0, .external_lex_state = 155},
  [10916] = {.lex_state = 3, .external_lex_state = 216},
  [10917] = {.lex_state = 0, .external_lex_state = 155},
  [10918] = {.lex_state = 0, .external_lex_state = 155},
  [10919] = {.lex_state = 0, .external_lex_state = 155},
  [10920] = {.lex_state = 0, .external_lex_state = 155},
  [10921] = {.lex_state = 0, .external_lex_state = 155},
  [10922] = {.lex_state = 0, .external_lex_state = 155},
  [10923] = {.lex_state = 0, .external_lex_state = 217},
  [10924] = {.lex_state = 0, .external_lex_state = 155},
  [10925] = {.lex_state = 0, .external_lex_state = 155},
  [10926] = {.lex_state = 0, .external_lex_state = 155},
  [10927] = {.lex_state = 0, .external_lex_state = 155},
  [10928] = {.lex_state = 0, .external_lex_state = 155},
  [10929] = {.lex_state = 0, .external_lex_state = 155},
  [10930] = {.lex_state = 0, .external_lex_state = 155},
  [10931] = {.lex_state = 3, .external_lex_state = 216},
  [10932] = {.lex_state = 0, .external_lex_state = 155},
  [10933] = {.lex_state = 0, .external_lex_state = 155},
  [10934] = {.lex_state = 0, .external_lex_state = 155},
  [10935] = {.lex_state = 0, .external_lex_state = 155},
  [10936] = {.lex_state = 0, .external_lex_state = 155},
  [10937] = {.lex_state = 0, .external_lex_state = 217},
  [10938] = {.lex_state = 0, .external_lex_state = 188},
  [10939] = {.lex_state = 0, .external_lex_state = 155},
  [10940] = {.lex_state = 0, .external_lex_state = 155},
  [10941] = {.lex_state = 0, .external_lex_state = 155},
  [10942] = {.lex_state = 0, .external_lex_state = 155},
  [10943] = {.lex_state = 0, .external_lex_state = 217},
  [10944] = {.lex_state = 0, .external_lex_state = 155},
  [10945] = {.lex_state = 0, .external_lex_state = 155},
  [10946] = {.lex_state = 0, .external_lex_state = 155},
  [10947] = {.lex_state = 0, .external_lex_state = 155},
  [10948] = {.lex_state = 0, .external_lex_state = 155},
  [10949] = {.lex_state = 0, .external_lex_state = 155},
  [10950] = {.lex_state = 0, .external_lex_state = 155},
  [10951] = {.lex_state = 0, .external_lex_state = 188},
  [10952] = {.lex_state = 0, .external_lex_state = 155},
  [10953] = {.lex_state = 0, .external_lex_state = 155},
  [10954] = {.lex_state = 0, .external_lex_state = 155},
  [10955] = {.lex_state = 4, .external_lex_state = 207},
  [10956] = {.lex_state = 0, .external_lex_state = 155},
  [10957] = {.lex_state = 0, .external_lex_state = 155},
  [10958] = {.lex_state = 0, .external_lex_state = 155},
  [10959] = {.lex_state = 0, .external_lex_state = 155},
  [10960] = {.lex_state = 3, .external_lex_state = 216},
  [10961] = {.lex_state = 3, .external_lex_state = 216},
  [10962] = {.lex_state = 0, .external_lex_state = 155},
  [10963] = {.lex_state = 0, .external_lex_state = 155},
  [10964] = {.lex_state = 0, .external_lex_state = 155},
  [10965] = {.lex_state = 0, .external_lex_state = 155},
  [10966] = {.lex_state = 0, .external_lex_state = 155},
  [10967] = {.lex_state = 0, .external_lex_state = 155},
  [10968] = {.lex_state = 0, .external_lex_state = 155},
  [10969] = {.lex_state = 0, .external_lex_state = 155},
  [10970] = {.lex_state = 4, .external_lex_state = 155},
  [10971] = {.lex_state = 0, .external_lex_state = 155},
  [10972] = {.lex_state = 0, .external_lex_state = 155},
  [10973] = {.lex_state = 0, .external_lex_state = 155},
  [10974] = {.lex_state = 0, .external_lex_state = 155},
  [10975] = {.lex_state = 0, .external_lex_state = 155},
  [10976] = {.lex_state = 0, .external_lex_state = 155},
  [10977] = {.lex_state = 0, .external_lex_state = 155},
  [10978] = {.lex_state = 0, .external_lex_state = 155},
  [10979] = {.lex_state = 0, .external_lex_state = 155},
  [10980] = {.lex_state = 0, .external_lex_state = 155},
  [10981] = {.lex_state = 0, .external_lex_state = 155},
  [10982] = {.lex_state = 0, .external_lex_state = 155},
  [10983] = {.lex_state = 0, .external_lex_state = 155},
  [10984] = {.lex_state = 1, .external_lex_state = 155},
  [10985] = {.lex_state = 0, .external_lex_state = 217},
  [10986] = {.lex_state = 0, .external_lex_state = 155},
  [10987] = {.lex_state = 0, .external_lex_state = 155},
  [10988] = {.lex_state = 0, .external_lex_state = 155},
  [10989] = {.lex_state = 0, .external_lex_state = 159},
  [10990] = {.lex_state = 0, .external_lex_state = 155},
  [10991] = {.lex_state = 0, .external_lex_state = 155},
  [10992] = {.lex_state = 0, .external_lex_state = 155},
  [10993] = {.lex_state = 3, .external_lex_state = 216},
  [10994] = {.lex_state = 0, .external_lex_state = 155},
  [10995] = {.lex_state = 0, .external_lex_state = 155},
  [10996] = {.lex_state = 3, .external_lex_state = 216},
  [10997] = {.lex_state = 0, .external_lex_state = 155},
  [10998] = {.lex_state = 3, .external_lex_state = 216},
  [10999] = {.lex_state = 0, .external_lex_state = 159},
  [11000] = {.lex_state = 0, .external_lex_state = 155},
  [11001] = {.lex_state = 3, .external_lex_state = 216},
  [11002] = {.lex_state = 0, .external_lex_state = 155},
  [11003] = {.lex_state = 0, .external_lex_state = 155},
  [11004] = {.lex_state = 0, .external_lex_state = 155},
  [11005] = {.lex_state = 0, .external_lex_state = 155},
  [11006] = {.lex_state = 0, .external_lex_state = 155},
  [11007] = {.lex_state = 0, .external_lex_state = 155},
  [11008] = {.lex_state = 0, .external_lex_state = 155},
  [11009] = {.lex_state = 0, .external_lex_state = 155},
  [11010] = {.lex_state = 0, .external_lex_state = 155},
  [11011] = {.lex_state = 0, .external_lex_state = 2},
  [11012] = {.lex_state = 0, .external_lex_state = 155},
  [11013] = {.lex_state = 0, .external_lex_state = 155},
  [11014] = {.lex_state = 0, .external_lex_state = 155},
  [11015] = {.lex_state = 0, .external_lex_state = 155},
  [11016] = {.lex_state = 0, .external_lex_state = 155},
  [11017] = {.lex_state = 0, .external_lex_state = 155},
  [11018] = {.lex_state = 0, .external_lex_state = 155},
  [11019] = {.lex_state = 0, .external_lex_state = 155},
  [11020] = {.lex_state = 0, .external_lex_state = 155},
  [11021] = {.lex_state = 3, .external_lex_state = 155},
  [11022] = {.lex_state = 0, .external_lex_state = 155},
  [11023] = {.lex_state = 0, .external_lex_state = 155},
  [11024] = {.lex_state = 0, .external_lex_state = 155},
  [11025] = {.lex_state = 0, .external_lex_state = 155},
  [11026] = {.lex_state = 0, .external_lex_state = 155},
  [11027] = {.lex_state = 0, .external_lex_state = 155},
  [11028] = {.lex_state = 0, .external_lex_state = 155},
  [11029] = {.lex_state = 0, .external_lex_state = 155},
  [11030] = {.lex_state = 0, .external_lex_state = 155},
  [11031] = {.lex_state = 0, .external_lex_state = 155},
  [11032] = {.lex_state = 0, .external_lex_state = 155},
  [11033] = {.lex_state = 0, .external_lex_state = 155},
  [11034] = {.lex_state = 0, .external_lex_state = 155},
  [11035] = {.lex_state = 3, .external_lex_state = 216},
  [11036] = {.lex_state = 0, .external_lex_state = 155},
  [11037] = {.lex_state = 0, .external_lex_state = 155},
  [11038] = {.lex_state = 0, .external_lex_state = 155},
  [11039] = {.lex_state = 0, .external_lex_state = 155},
  [11040] = {.lex_state = 3, .external_lex_state = 155},
  [11041] = {.lex_state = 0, .external_lex_state = 155},
  [11042] = {.lex_state = 0, .external_lex_state = 155},
  [11043] = {.lex_state = 0, .external_lex_state = 155},
  [11044] = {.lex_state = 0, .external_lex_state = 155},
  [11045] = {.lex_state = 0, .external_lex_state = 155},
  [11046] = {.lex_state = 0, .external_lex_state = 155},
  [11047] = {.lex_state = 0, .external_lex_state = 155},
  [11048] = {.lex_state = 0, .external_lex_state = 155},
  [11049] = {.lex_state = 3, .external_lex_state = 216},
  [11050] = {.lex_state = 0, .external_lex_state = 155},
  [11051] = {.lex_state = 0, .external_lex_state = 155},
  [11052] = {.lex_state = 0, .external_lex_state = 155},
  [11053] = {.lex_state = 0, .external_lex_state = 155},
  [11054] = {.lex_state = 0, .external_lex_state = 155},
  [11055] = {.lex_state = 0, .external_lex_state = 155},
  [11056] = {.lex_state = 0, .external_lex_state = 155},
  [11057] = {.lex_state = 0, .external_lex_state = 155},
  [11058] = {.lex_state = 0, .external_lex_state = 155},
  [11059] = {.lex_state = 0, .external_lex_state = 155},
  [11060] = {.lex_state = 0, .external_lex_state = 155},
  [11061] = {.lex_state = 0, .external_lex_state = 155},
  [11062] = {.lex_state = 0, .external_lex_state = 155},
  [11063] = {.lex_state = 0, .external_lex_state = 155},
  [11064] = {.lex_state = 0, .external_lex_state = 155},
  [11065] = {.lex_state = 0, .external_lex_state = 155},
  [11066] = {.lex_state = 0, .external_lex_state = 155},
  [11067] = {.lex_state = 3, .external_lex_state = 155},
  [11068] = {.lex_state = 0, .external_lex_state = 217},
  [11069] = {.lex_state = 0, .external_lex_state = 155},
  [11070] = {.lex_state = 0, .external_lex_state = 155},
  [11071] = {.lex_state = 0, .external_lex_state = 214},
  [11072] = {.lex_state = 3, .external_lex_state = 216},
  [11073] = {.lex_state = 0, .external_lex_state = 155},
  [11074] = {.lex_state = 0, .external_lex_state = 155},
  [11075] = {.lex_state = 0, .external_lex_state = 155},
  [11076] = {.lex_state = 0, .external_lex_state = 155},
  [11077] = {.lex_state = 0, .external_lex_state = 188},
  [11078] = {.lex_state = 0, .external_lex_state = 155},
  [11079] = {.lex_state = 3, .external_lex_state = 216},
  [11080] = {.lex_state = 0, .external_lex_state = 155},
  [11081] = {.lex_state = 0, .external_lex_state = 155},
  [11082] = {.lex_state = 0, .external_lex_state = 155},
  [11083] = {.lex_state = 0, .external_lex_state = 155},
  [11084] = {.lex_state = 0, .external_lex_state = 155},
  [11085] = {.lex_state = 0, .external_lex_state = 155},
  [11086] = {.lex_state = 0, .external_lex_state = 155},
  [11087] = {.lex_state = 0, .external_lex_state = 2},
  [11088] = {.lex_state = 0, .external_lex_state = 155},
  [11089] = {.lex_state = 0, .external_lex_state = 188},
  [11090] = {.lex_state = 0, .external_lex_state = 155},
  [11091] = {.lex_state = 0, .external_lex_state = 155},
  [11092] = {.lex_state = 0, .external_lex_state = 159},
  [11093] = {.lex_state = 0, .external_lex_state = 159},
  [11094] = {.lex_state = 0, .external_lex_state = 217},
  [11095] = {.lex_state = 0, .external_lex_state = 155},
  [11096] = {.lex_state = 0, .external_lex_state = 155},
  [11097] = {.lex_state = 0, .external_lex_state = 155},
  [11098] = {.lex_state = 0, .external_lex_state = 155},
  [11099] = {.lex_state = 0, .external_lex_state = 198},
  [11100] = {.lex_state = 0, .external_lex_state = 155},
  [11101] = {.lex_state = 0, .external_lex_state = 2},
  [11102] = {.lex_state = 0, .external_lex_state = 155},
  [11103] = {.lex_state = 0, .external_lex_state = 188},
  [11104] = {.lex_state = 0, .external_lex_state = 155},
  [11105] = {.lex_state = 0, .external_lex_state = 155},
  [11106] = {.lex_state = 0, .external_lex_state = 155},
  [11107] = {.lex_state = 0, .external_lex_state = 155},
  [11108] = {.lex_state = 0, .external_lex_state = 155},
  [11109] = {.lex_state = 3, .external_lex_state = 216},
  [11110] = {.lex_state = 0, .external_lex_state = 155},
  [11111] = {.lex_state = 0, .external_lex_state = 155},
  [11112] = {.lex_state = 0, .external_lex_state = 155},
  [11113] = {.lex_state = 0, .external_lex_state = 155},
  [11114] = {.lex_state = 4, .external_lex_state = 155},
  [11115] = {.lex_state = 0, .external_lex_state = 155},
  [11116] = {.lex_state = 0, .external_lex_state = 155},
  [11117] = {.lex_state = 0, .external_lex_state = 155},
  [11118] = {.lex_state = 0, .external_lex_state = 155},
  [11119] = {.lex_state = 4, .external_lex_state = 155},
  [11120] = {.lex_state = 0, .external_lex_state = 155},
  [11121] = {.lex_state = 0, .external_lex_state = 217},
  [11122] = {.lex_state = 0, .external_lex_state = 155},
  [11123] = {.lex_state = 0, .external_lex_state = 155},
  [11124] = {.lex_state = 0, .external_lex_state = 155},
  [11125] = {.lex_state = 0, .external_lex_state = 155},
  [11126] = {.lex_state = 0, .external_lex_state = 155},
  [11127] = {.lex_state = 0, .external_lex_state = 155},
  [11128] = {.lex_state = 0, .external_lex_state = 155},
  [11129] = {.lex_state = 3, .external_lex_state = 216},
  [11130] = {.lex_state = 0, .external_lex_state = 155},
  [11131] = {.lex_state = 3, .external_lex_state = 216},
  [11132] = {.lex_state = 0, .external_lex_state = 155},
  [11133] = {.lex_state = 3, .external_lex_state = 216},
  [11134] = {.lex_state = 3, .external_lex_state = 216},
  [11135] = {.lex_state = 0, .external_lex_state = 155},
  [11136] = {.lex_state = 3, .external_lex_state = 216},
  [11137] = {.lex_state = 0, .external_lex_state = 155},
  [11138] = {.lex_state = 0, .external_lex_state = 155},
  [11139] = {.lex_state = 3, .external_lex_state = 216},
  [11140] = {.lex_state = 0, .external_lex_state = 155},
  [11141] = {.lex_state = 0, .external_lex_state = 155},
  [11142] = {.lex_state = 3, .external_lex_state = 216},
  [11143] = {.lex_state = 0, .external_lex_state = 155},
  [11144] = {.lex_state = 0, .external_lex_state = 155},
  [11145] = {.lex_state = 0, .external_lex_state = 155},
  [11146] = {.lex_state = 3, .external_lex_state = 216},
  [11147] = {.lex_state = 0, .external_lex_state = 155},
  [11148] = {.lex_state = 0, .external_lex_state = 155},
  [11149] = {.lex_state = 3, .external_lex_state = 216},
  [11150] = {.lex_state = 0, .external_lex_state = 155},
  [11151] = {.lex_state = 0, .external_lex_state = 155},
  [11152] = {.lex_state = 3, .external_lex_state = 216},
  [11153] = {.lex_state = 0, .external_lex_state = 155},
  [11154] = {.lex_state = 0, .external_lex_state = 155},
  [11155] = {.lex_state = 0, .external_lex_state = 155},
  [11156] = {.lex_state = 3, .external_lex_state = 216},
  [11157] = {.lex_state = 0, .external_lex_state = 155},
  [11158] = {.lex_state = 0, .external_lex_state = 155},
  [11159] = {.lex_state = 0, .external_lex_state = 155},
  [11160] = {.lex_state = 0, .external_lex_state = 155},
  [11161] = {.lex_state = 0, .external_lex_state = 155},
  [11162] = {.lex_state = 0, .external_lex_state = 155},
  [11163] = {.lex_state = 3, .external_lex_state = 216},
  [11164] = {.lex_state = 0, .external_lex_state = 155},
  [11165] = {.lex_state = 0, .external_lex_state = 155},
  [11166] = {.lex_state = 4, .external_lex_state = 155},
  [11167] = {.lex_state = 3, .external_lex_state = 216},
  [11168] = {.lex_state = 3, .external_lex_state = 216},
  [11169] = {.lex_state = 0, .external_lex_state = 155},
  [11170] = {.lex_state = 0, .external_lex_state = 155},
  [11171] = {.lex_state = 0, .external_lex_state = 155},
  [11172] = {.lex_state = 4, .external_lex_state = 155},
  [11173] = {.lex_state = 3, .external_lex_state = 216},
  [11174] = {.lex_state = 4, .external_lex_state = 155},
  [11175] = {.lex_state = 0, .external_lex_state = 155},
  [11176] = {.lex_state = 3, .external_lex_state = 216},
  [11177] = {.lex_state = 0, .external_lex_state = 155},
  [11178] = {.lex_state = 0, .external_lex_state = 155},
  [11179] = {.lex_state = 0, .external_lex_state = 155},
  [11180] = {.lex_state = 3, .external_lex_state = 216},
  [11181] = {.lex_state = 0, .external_lex_state = 155},
  [11182] = {.lex_state = 0, .external_lex_state = 155},
  [11183] = {.lex_state = 3, .external_lex_state = 216},
  [11184] = {.lex_state = 0, .external_lex_state = 155},
  [11185] = {.lex_state = 0, .external_lex_state = 155},
  [11186] = {.lex_state = 4, .external_lex_state = 155},
  [11187] = {.lex_state = 0, .external_lex_state = 155},
  [11188] = {.lex_state = 0, .external_lex_state = 155},
  [11189] = {.lex_state = 0, .external_lex_state = 155},
  [11190] = {.lex_state = 0, .external_lex_state = 155},
  [11191] = {.lex_state = 0, .external_lex_state = 155},
  [11192] = {.lex_state = 3, .external_lex_state = 216},
  [11193] = {.lex_state = 3, .external_lex_state = 216},
  [11194] = {.lex_state = 0, .external_lex_state = 155},
  [11195] = {.lex_state = 0, .external_lex_state = 155},
  [11196] = {.lex_state = 0, .external_lex_state = 155},
  [11197] = {.lex_state = 0, .external_lex_state = 155},
  [11198] = {.lex_state = 0, .external_lex_state = 155},
  [11199] = {.lex_state = 0, .external_lex_state = 155},
  [11200] = {.lex_state = 0, .external_lex_state = 155},
  [11201] = {.lex_state = 3, .external_lex_state = 216},
  [11202] = {.lex_state = 3, .external_lex_state = 216},
  [11203] = {.lex_state = 0, .external_lex_state = 155},
  [11204] = {.lex_state = 0, .external_lex_state = 155},
  [11205] = {.lex_state = 3, .external_lex_state = 155},
  [11206] = {.lex_state = 0, .external_lex_state = 155},
  [11207] = {.lex_state = 0, .external_lex_state = 155},
  [11208] = {.lex_state = 0, .external_lex_state = 155},
  [11209] = {.lex_state = 0, .external_lex_state = 155},
  [11210] = {.lex_state = 3, .external_lex_state = 216},
  [11211] = {.lex_state = 3, .external_lex_state = 216},
  [11212] = {.lex_state = 3, .external_lex_state = 155},
  [11213] = {.lex_state = 0, .external_lex_state = 155},
  [11214] = {.lex_state = 0, .external_lex_state = 155},
  [11215] = {.lex_state = 0, .external_lex_state = 155},
  [11216] = {.lex_state = 0, .external_lex_state = 155},
  [11217] = {.lex_state = 0, .external_lex_state = 155},
  [11218] = {.lex_state = 0, .external_lex_state = 155},
  [11219] = {.lex_state = 0, .external_lex_state = 155},
  [11220] = {.lex_state = 3, .external_lex_state = 216},
  [11221] = {.lex_state = 3, .external_lex_state = 216},
  [11222] = {.lex_state = 3, .external_lex_state = 155},
  [11223] = {.lex_state = 0, .external_lex_state = 155},
  [11224] = {.lex_state = 3, .external_lex_state = 216},
  [11225] = {.lex_state = 0, .external_lex_state = 155},
  [11226] = {.lex_state = 0, .external_lex_state = 155},
  [11227] = {.lex_state = 0, .external_lex_state = 155},
  [11228] = {.lex_state = 0, .external_lex_state = 155},
  [11229] = {.lex_state = 4, .external_lex_state = 207},
  [11230] = {.lex_state = 3, .external_lex_state = 216},
  [11231] = {.lex_state = 0, .external_lex_state = 155},
  [11232] = {.lex_state = 3, .external_lex_state = 155},
  [11233] = {.lex_state = 0, .external_lex_state = 217},
  [11234] = {.lex_state = 3, .external_lex_state = 216},
  [11235] = {.lex_state = 0, .external_lex_state = 155},
  [11236] = {.lex_state = 0, .external_lex_state = 155},
  [11237] = {.lex_state = 0, .external_lex_state = 155},
  [11238] = {.lex_state = 0, .external_lex_state = 155},
  [11239] = {.lex_state = 0, .external_lex_state = 155},
  [11240] = {.lex_state = 0, .external_lex_state = 155},
  [11241] = {.lex_state = 0, .external_lex_state = 155},
  [11242] = {.lex_state = 0, .external_lex_state = 155},
  [11243] = {.lex_state = 4, .external_lex_state = 207},
  [11244] = {.lex_state = 0, .external_lex_state = 155},
  [11245] = {.lex_state = 0, .external_lex_state = 155},
  [11246] = {.lex_state = 3, .external_lex_state = 216},
  [11247] = {.lex_state = 0, .external_lex_state = 155},
  [11248] = {.lex_state = 0, .external_lex_state = 155},
  [11249] = {.lex_state = 0, .external_lex_state = 155},
  [11250] = {.lex_state = 0, .external_lex_state = 155},
  [11251] = {.lex_state = 0, .external_lex_state = 155},
  [11252] = {.lex_state = 0, .external_lex_state = 155},
  [11253] = {.lex_state = 3, .external_lex_state = 216},
  [11254] = {.lex_state = 0, .external_lex_state = 155},
  [11255] = {.lex_state = 0, .external_lex_state = 155},
  [11256] = {.lex_state = 0, .external_lex_state = 155},
  [11257] = {.lex_state = 3, .external_lex_state = 216},
  [11258] = {.lex_state = 3, .external_lex_state = 216},
  [11259] = {.lex_state = 0, .external_lex_state = 155},
  [11260] = {.lex_state = 0, .external_lex_state = 155},
  [11261] = {.lex_state = 0, .external_lex_state = 217},
  [11262] = {.lex_state = 0, .external_lex_state = 155},
  [11263] = {.lex_state = 0, .external_lex_state = 155},
  [11264] = {.lex_state = 0, .external_lex_state = 155},
  [11265] = {.lex_state = 0, .external_lex_state = 155},
  [11266] = {.lex_state = 0, .external_lex_state = 155},
  [11267] = {.lex_state = 3, .external_lex_state = 216},
  [11268] = {.lex_state = 0, .external_lex_state = 155},
  [11269] = {.lex_state = 0, .external_lex_state = 155},
  [11270] = {.lex_state = 0, .external_lex_state = 155},
  [11271] = {.lex_state = 0, .external_lex_state = 155},
  [11272] = {.lex_state = 0, .external_lex_state = 217},
  [11273] = {.lex_state = 0, .external_lex_state = 155},
  [11274] = {.lex_state = 0, .external_lex_state = 155},
  [11275] = {.lex_state = 3, .external_lex_state = 216},
  [11276] = {.lex_state = 0, .external_lex_state = 155},
  [11277] = {.lex_state = 0, .external_lex_state = 155},
  [11278] = {.lex_state = 0, .external_lex_state = 155},
  [11279] = {.lex_state = 0, .external_lex_state = 155},
  [11280] = {.lex_state = 0, .external_lex_state = 155},
  [11281] = {.lex_state = 0, .external_lex_state = 155},
  [11282] = {.lex_state = 0, .external_lex_state = 155},
  [11283] = {.lex_state = 0, .external_lex_state = 155},
  [11284] = {.lex_state = 3, .external_lex_state = 216},
  [11285] = {.lex_state = 0, .external_lex_state = 155},
  [11286] = {.lex_state = 0, .external_lex_state = 155},
  [11287] = {.lex_state = 0, .external_lex_state = 155},
  [11288] = {.lex_state = 0, .external_lex_state = 155},
  [11289] = {.lex_state = 0, .external_lex_state = 155},
  [11290] = {.lex_state = 4, .external_lex_state = 155},
  [11291] = {.lex_state = 0, .external_lex_state = 155},
  [11292] = {.lex_state = 4, .external_lex_state = 155},
  [11293] = {.lex_state = 3, .external_lex_state = 216},
  [11294] = {.lex_state = 3, .external_lex_state = 216},
  [11295] = {.lex_state = 3, .external_lex_state = 216},
  [11296] = {.lex_state = 0, .external_lex_state = 155},
  [11297] = {.lex_state = 0, .external_lex_state = 217},
  [11298] = {.lex_state = 0, .external_lex_state = 155},
  [11299] = {.lex_state = 0, .external_lex_state = 155},
  [11300] = {.lex_state = 0, .external_lex_state = 155},
  [11301] = {.lex_state = 0, .external_lex_state = 155},
  [11302] = {.lex_state = 0, .external_lex_state = 155},
  [11303] = {.lex_state = 0, .external_lex_state = 155},
  [11304] = {.lex_state = 3, .external_lex_state = 216},
  [11305] = {.lex_state = 0, .external_lex_state = 155},
  [11306] = {.lex_state = 0, .external_lex_state = 155},
  [11307] = {.lex_state = 0, .external_lex_state = 155},
  [11308] = {.lex_state = 0, .external_lex_state = 155},
  [11309] = {.lex_state = 0, .external_lex_state = 155},
  [11310] = {.lex_state = 0, .external_lex_state = 155},
  [11311] = {.lex_state = 0, .external_lex_state = 155},
  [11312] = {.lex_state = 3, .external_lex_state = 216},
  [11313] = {.lex_state = 0, .external_lex_state = 155},
  [11314] = {.lex_state = 0, .external_lex_state = 155},
  [11315] = {.lex_state = 0, .external_lex_state = 155},
  [11316] = {.lex_state = 0, .external_lex_state = 155},
  [11317] = {.lex_state = 0, .external_lex_state = 155},
  [11318] = {.lex_state = 0, .external_lex_state = 155},
  [11319] = {.lex_state = 0, .external_lex_state = 155},
  [11320] = {.lex_state = 0, .external_lex_state = 155},
  [11321] = {.lex_state = 3, .external_lex_state = 216},
  [11322] = {.lex_state = 3, .external_lex_state = 216},
  [11323] = {.lex_state = 0, .external_lex_state = 155},
  [11324] = {.lex_state = 3, .external_lex_state = 216},
  [11325] = {.lex_state = 0, .external_lex_state = 155},
  [11326] = {.lex_state = 0, .external_lex_state = 155},
  [11327] = {.lex_state = 3, .external_lex_state = 216},
  [11328] = {.lex_state = 0, .external_lex_state = 155},
  [11329] = {.lex_state = 0, .external_lex_state = 155},
  [11330] = {.lex_state = 0, .external_lex_state = 155},
  [11331] = {.lex_state = 0, .external_lex_state = 155},
  [11332] = {.lex_state = 0, .external_lex_state = 155},
  [11333] = {.lex_state = 0, .external_lex_state = 155},
  [11334] = {.lex_state = 0, .external_lex_state = 204},
  [11335] = {.lex_state = 0, .external_lex_state = 204},
  [11336] = {.lex_state = 0, .external_lex_state = 155},
  [11337] = {.lex_state = 0, .external_lex_state = 155},
  [11338] = {.lex_state = 0, .external_lex_state = 155},
  [11339] = {.lex_state = 0, .external_lex_state = 155},
  [11340] = {.lex_state = 3, .external_lex_state = 155},
  [11341] = {.lex_state = 3, .external_lex_state = 155},
  [11342] = {.lex_state = 0, .external_lex_state = 199},
  [11343] = {.lex_state = 0, .external_lex_state = 155},
  [11344] = {.lex_state = 3, .external_lex_state = 155},
  [11345] = {.lex_state = 3, .external_lex_state = 155},
  [11346] = {.lex_state = 0, .external_lex_state = 155},
  [11347] = {.lex_state = 0, .external_lex_state = 155},
  [11348] = {.lex_state = 0, .external_lex_state = 155},
  [11349] = {.lex_state = 0, .external_lex_state = 155},
  [11350] = {.lex_state = 0, .external_lex_state = 155},
  [11351] = {.lex_state = 3, .external_lex_state = 155},
  [11352] = {.lex_state = 0, .external_lex_state = 155},
  [11353] = {.lex_state = 0, .external_lex_state = 155},
  [11354] = {.lex_state = 0, .external_lex_state = 155},
  [11355] = {.lex_state = 0, .external_lex_state = 155},
  [11356] = {.lex_state = 0, .external_lex_state = 155},
  [11357] = {.lex_state = 0, .external_lex_state = 155},
  [11358] = {.lex_state = 0, .external_lex_state = 155},
  [11359] = {.lex_state = 0, .external_lex_state = 155},
  [11360] = {.lex_state = 0, .external_lex_state = 155},
  [11361] = {.lex_state = 0, .external_lex_state = 155},
  [11362] = {.lex_state = 0, .external_lex_state = 155},
  [11363] = {.lex_state = 0, .external_lex_state = 155},
  [11364] = {.lex_state = 0, .external_lex_state = 155},
  [11365] = {.lex_state = 0, .external_lex_state = 155},
  [11366] = {.lex_state = 0, .external_lex_state = 155},
  [11367] = {.lex_state = 0, .external_lex_state = 155},
  [11368] = {.lex_state = 0, .external_lex_state = 155},
  [11369] = {.lex_state = 3, .external_lex_state = 155},
  [11370] = {.lex_state = 0, .external_lex_state = 155},
  [11371] = {.lex_state = 0, .external_lex_state = 155},
  [11372] = {.lex_state = 0, .external_lex_state = 155},
  [11373] = {.lex_state = 0, .external_lex_state = 155},
  [11374] = {.lex_state = 0, .external_lex_state = 155},
  [11375] = {.lex_state = 0, .external_lex_state = 155},
  [11376] = {.lex_state = 3, .external_lex_state = 155},
  [11377] = {.lex_state = 0, .external_lex_state = 155},
  [11378] = {.lex_state = 0, .external_lex_state = 155},
  [11379] = {.lex_state = 0, .external_lex_state = 155},
  [11380] = {.lex_state = 0, .external_lex_state = 155},
  [11381] = {.lex_state = 0, .external_lex_state = 155},
  [11382] = {.lex_state = 0, .external_lex_state = 155},
  [11383] = {.lex_state = 3, .external_lex_state = 155},
  [11384] = {.lex_state = 0, .external_lex_state = 155},
  [11385] = {.lex_state = 0, .external_lex_state = 155},
  [11386] = {.lex_state = 0, .external_lex_state = 204},
  [11387] = {.lex_state = 0, .external_lex_state = 155},
  [11388] = {.lex_state = 0, .external_lex_state = 155},
  [11389] = {.lex_state = 0, .external_lex_state = 155},
  [11390] = {.lex_state = 0, .external_lex_state = 155},
  [11391] = {.lex_state = 0, .external_lex_state = 155},
  [11392] = {.lex_state = 0, .external_lex_state = 155},
  [11393] = {.lex_state = 0, .external_lex_state = 155},
  [11394] = {.lex_state = 0, .external_lex_state = 155},
  [11395] = {.lex_state = 0, .external_lex_state = 155},
  [11396] = {.lex_state = 0, .external_lex_state = 155},
  [11397] = {.lex_state = 0, .external_lex_state = 155},
  [11398] = {.lex_state = 0, .external_lex_state = 155},
  [11399] = {.lex_state = 0, .external_lex_state = 155},
  [11400] = {.lex_state = 0, .external_lex_state = 155},
  [11401] = {.lex_state = 0, .external_lex_state = 155},
  [11402] = {.lex_state = 0, .external_lex_state = 155},
  [11403] = {.lex_state = 0, .external_lex_state = 155},
  [11404] = {.lex_state = 0, .external_lex_state = 155},
  [11405] = {.lex_state = 0, .external_lex_state = 155},
  [11406] = {.lex_state = 0, .external_lex_state = 155},
  [11407] = {.lex_state = 0, .external_lex_state = 155},
  [11408] = {.lex_state = 0, .external_lex_state = 155},
  [11409] = {.lex_state = 0, .external_lex_state = 155},
  [11410] = {.lex_state = 3, .external_lex_state = 155},
  [11411] = {.lex_state = 3, .external_lex_state = 155},
  [11412] = {.lex_state = 0, .external_lex_state = 155},
  [11413] = {.lex_state = 0, .external_lex_state = 155},
  [11414] = {.lex_state = 0, .external_lex_state = 155},
  [11415] = {.lex_state = 0, .external_lex_state = 155},
  [11416] = {.lex_state = 0, .external_lex_state = 155},
  [11417] = {.lex_state = 0, .external_lex_state = 155},
  [11418] = {.lex_state = 3, .external_lex_state = 155},
  [11419] = {.lex_state = 0, .external_lex_state = 155},
  [11420] = {.lex_state = 0, .external_lex_state = 204},
  [11421] = {.lex_state = 0, .external_lex_state = 155},
  [11422] = {.lex_state = 0, .external_lex_state = 155},
  [11423] = {.lex_state = 0, .external_lex_state = 155},
  [11424] = {.lex_state = 0, .external_lex_state = 155},
  [11425] = {.lex_state = 0, .external_lex_state = 155},
  [11426] = {.lex_state = 0, .external_lex_state = 155},
  [11427] = {.lex_state = 0, .external_lex_state = 155},
  [11428] = {.lex_state = 0, .external_lex_state = 155},
  [11429] = {.lex_state = 0, .external_lex_state = 155},
  [11430] = {.lex_state = 0, .external_lex_state = 155},
  [11431] = {.lex_state = 0, .external_lex_state = 155},
  [11432] = {.lex_state = 0, .external_lex_state = 155},
  [11433] = {.lex_state = 0, .external_lex_state = 155},
  [11434] = {.lex_state = 0, .external_lex_state = 155},
  [11435] = {.lex_state = 0, .external_lex_state = 155},
  [11436] = {.lex_state = 0, .external_lex_state = 155},
  [11437] = {.lex_state = 3, .external_lex_state = 155},
  [11438] = {.lex_state = 3, .external_lex_state = 155},
  [11439] = {.lex_state = 0, .external_lex_state = 155},
  [11440] = {.lex_state = 0, .external_lex_state = 155},
  [11441] = {.lex_state = 0, .external_lex_state = 155},
  [11442] = {.lex_state = 0, .external_lex_state = 155},
  [11443] = {.lex_state = 0, .external_lex_state = 155},
  [11444] = {.lex_state = 0, .external_lex_state = 155},
  [11445] = {.lex_state = 0, .external_lex_state = 155},
  [11446] = {.lex_state = 0, .external_lex_state = 155},
  [11447] = {.lex_state = 3, .external_lex_state = 155},
  [11448] = {.lex_state = 0, .external_lex_state = 213},
  [11449] = {.lex_state = 0, .external_lex_state = 155},
  [11450] = {.lex_state = 0, .external_lex_state = 155},
  [11451] = {.lex_state = 0, .external_lex_state = 155},
  [11452] = {.lex_state = 0, .external_lex_state = 204},
  [11453] = {.lex_state = 0, .external_lex_state = 204},
  [11454] = {.lex_state = 0, .external_lex_state = 155},
  [11455] = {.lex_state = 3, .external_lex_state = 155},
  [11456] = {.lex_state = 0, .external_lex_state = 204},
  [11457] = {.lex_state = 0, .external_lex_state = 155},
  [11458] = {.lex_state = 3, .external_lex_state = 155},
  [11459] = {.lex_state = 0, .external_lex_state = 155},
  [11460] = {.lex_state = 0, .external_lex_state = 155},
  [11461] = {.lex_state = 0, .external_lex_state = 155},
  [11462] = {.lex_state = 0, .external_lex_state = 155},
  [11463] = {.lex_state = 0, .external_lex_state = 155},
  [11464] = {.lex_state = 0, .external_lex_state = 155},
  [11465] = {.lex_state = 0, .external_lex_state = 155},
  [11466] = {.lex_state = 0, .external_lex_state = 155},
  [11467] = {.lex_state = 0, .external_lex_state = 155},
  [11468] = {.lex_state = 0, .external_lex_state = 155},
  [11469] = {.lex_state = 0, .external_lex_state = 204},
  [11470] = {.lex_state = 0, .external_lex_state = 155},
  [11471] = {.lex_state = 0, .external_lex_state = 155},
  [11472] = {.lex_state = 3, .external_lex_state = 155},
  [11473] = {.lex_state = 0, .external_lex_state = 155},
  [11474] = {.lex_state = 0, .external_lex_state = 155},
  [11475] = {.lex_state = 0, .external_lex_state = 204},
  [11476] = {.lex_state = 0, .external_lex_state = 155},
  [11477] = {.lex_state = 0, .external_lex_state = 204},
  [11478] = {.lex_state = 0, .external_lex_state = 155},
  [11479] = {.lex_state = 0, .external_lex_state = 155},
  [11480] = {.lex_state = 0, .external_lex_state = 155},
  [11481] = {.lex_state = 3, .external_lex_state = 155},
  [11482] = {.lex_state = 3, .external_lex_state = 155},
  [11483] = {.lex_state = 0, .external_lex_state = 155},
  [11484] = {.lex_state = 3, .external_lex_state = 155},
  [11485] = {.lex_state = 3, .external_lex_state = 155},
  [11486] = {.lex_state = 0, .external_lex_state = 155},
  [11487] = {.lex_state = 0, .external_lex_state = 204},
  [11488] = {.lex_state = 0, .external_lex_state = 155},
  [11489] = {.lex_state = 3, .external_lex_state = 155},
  [11490] = {.lex_state = 0, .external_lex_state = 198},
  [11491] = {.lex_state = 0, .external_lex_state = 155},
  [11492] = {.lex_state = 0, .external_lex_state = 155},
  [11493] = {.lex_state = 0, .external_lex_state = 213},
  [11494] = {.lex_state = 0, .external_lex_state = 155},
  [11495] = {.lex_state = 0, .external_lex_state = 155},
  [11496] = {.lex_state = 0, .external_lex_state = 155},
  [11497] = {.lex_state = 0, .external_lex_state = 155},
  [11498] = {.lex_state = 0, .external_lex_state = 155},
  [11499] = {.lex_state = 0, .external_lex_state = 155},
  [11500] = {.lex_state = 3, .external_lex_state = 155},
  [11501] = {.lex_state = 0, .external_lex_state = 155},
  [11502] = {.lex_state = 0, .external_lex_state = 155},
  [11503] = {.lex_state = 0, .external_lex_state = 155},
  [11504] = {.lex_state = 0, .external_lex_state = 155},
  [11505] = {.lex_state = 0, .external_lex_state = 155},
  [11506] = {.lex_state = 0, .external_lex_state = 155},
  [11507] = {.lex_state = 0, .external_lex_state = 204},
  [11508] = {.lex_state = 0, .external_lex_state = 155},
  [11509] = {.lex_state = 0, .external_lex_state = 155},
  [11510] = {.lex_state = 0, .external_lex_state = 155},
  [11511] = {.lex_state = 0, .external_lex_state = 155},
  [11512] = {.lex_state = 0, .external_lex_state = 155},
  [11513] = {.lex_state = 0, .external_lex_state = 155},
  [11514] = {.lex_state = 0, .external_lex_state = 204},
  [11515] = {.lex_state = 0, .external_lex_state = 155},
  [11516] = {.lex_state = 0, .external_lex_state = 155},
  [11517] = {.lex_state = 0, .external_lex_state = 155},
  [11518] = {.lex_state = 0, .external_lex_state = 155},
  [11519] = {.lex_state = 0, .external_lex_state = 155},
  [11520] = {.lex_state = 0, .external_lex_state = 155},
  [11521] = {.lex_state = 3, .external_lex_state = 155},
  [11522] = {.lex_state = 3, .external_lex_state = 155},
  [11523] = {.lex_state = 0, .external_lex_state = 204},
  [11524] = {.lex_state = 0, .external_lex_state = 155},
  [11525] = {.lex_state = 0, .external_lex_state = 155},
  [11526] = {.lex_state = 0, .external_lex_state = 204},
  [11527] = {.lex_state = 0, .external_lex_state = 155},
  [11528] = {.lex_state = 0, .external_lex_state = 155},
  [11529] = {.lex_state = 3, .external_lex_state = 155},
  [11530] = {.lex_state = 0, .external_lex_state = 155},
  [11531] = {.lex_state = 0, .external_lex_state = 155},
  [11532] = {.lex_state = 0, .external_lex_state = 155},
  [11533] = {.lex_state = 0, .external_lex_state = 155},
  [11534] = {.lex_state = 0, .external_lex_state = 155},
  [11535] = {.lex_state = 0, .external_lex_state = 155},
  [11536] = {.lex_state = 4, .external_lex_state = 218},
  [11537] = {.lex_state = 0, .external_lex_state = 155},
  [11538] = {.lex_state = 0, .external_lex_state = 155},
  [11539] = {.lex_state = 0, .external_lex_state = 155},
  [11540] = {.lex_state = 0, .external_lex_state = 155},
  [11541] = {.lex_state = 0, .external_lex_state = 155},
  [11542] = {.lex_state = 0, .external_lex_state = 155},
  [11543] = {.lex_state = 0, .external_lex_state = 204},
  [11544] = {.lex_state = 0, .external_lex_state = 155},
  [11545] = {.lex_state = 0, .external_lex_state = 155},
  [11546] = {.lex_state = 0, .external_lex_state = 213},
  [11547] = {.lex_state = 0, .external_lex_state = 155},
  [11548] = {.lex_state = 0, .external_lex_state = 204},
  [11549] = {.lex_state = 0, .external_lex_state = 155},
  [11550] = {.lex_state = 3, .external_lex_state = 155},
  [11551] = {.lex_state = 3, .external_lex_state = 155},
  [11552] = {.lex_state = 0, .external_lex_state = 155},
  [11553] = {.lex_state = 0, .external_lex_state = 155},
  [11554] = {.lex_state = 0, .external_lex_state = 204},
  [11555] = {.lex_state = 0, .external_lex_state = 204},
  [11556] = {.lex_state = 0, .external_lex_state = 155},
  [11557] = {.lex_state = 0, .external_lex_state = 204},
  [11558] = {.lex_state = 3, .external_lex_state = 155},
  [11559] = {.lex_state = 0, .external_lex_state = 155},
  [11560] = {.lex_state = 0, .external_lex_state = 204},
  [11561] = {.lex_state = 0, .external_lex_state = 155},
  [11562] = {.lex_state = 0, .external_lex_state = 204},
  [11563] = {.lex_state = 0, .external_lex_state = 155},
  [11564] = {.lex_state = 0, .external_lex_state = 155},
  [11565] = {.lex_state = 0, .external_lex_state = 155},
  [11566] = {.lex_state = 3, .external_lex_state = 155},
  [11567] = {.lex_state = 0, .external_lex_state = 155},
  [11568] = {.lex_state = 0, .external_lex_state = 155},
  [11569] = {.lex_state = 0, .external_lex_state = 155},
  [11570] = {.lex_state = 3, .external_lex_state = 155},
  [11571] = {.lex_state = 3, .external_lex_state = 155},
  [11572] = {.lex_state = 0, .external_lex_state = 155},
  [11573] = {.lex_state = 3, .external_lex_state = 155},
  [11574] = {.lex_state = 0, .external_lex_state = 155},
  [11575] = {.lex_state = 0, .external_lex_state = 155},
  [11576] = {.lex_state = 0, .external_lex_state = 155},
  [11577] = {.lex_state = 0, .external_lex_state = 155},
  [11578] = {.lex_state = 0, .external_lex_state = 155},
  [11579] = {.lex_state = 0, .external_lex_state = 155},
  [11580] = {.lex_state = 0, .external_lex_state = 155},
  [11581] = {.lex_state = 3, .external_lex_state = 155},
  [11582] = {.lex_state = 0, .external_lex_state = 155},
  [11583] = {.lex_state = 0, .external_lex_state = 204},
  [11584] = {.lex_state = 0, .external_lex_state = 204},
  [11585] = {.lex_state = 0, .external_lex_state = 155},
  [11586] = {.lex_state = 0, .external_lex_state = 213},
  [11587] = {.lex_state = 0, .external_lex_state = 155},
  [11588] = {.lex_state = 0, .external_lex_state = 155},
  [11589] = {.lex_state = 0, .external_lex_state = 155},
  [11590] = {.lex_state = 0, .external_lex_state = 155},
  [11591] = {.lex_state = 0, .external_lex_state = 155},
  [11592] = {.lex_state = 0, .external_lex_state = 155},
  [11593] = {.lex_state = 0, .external_lex_state = 155},
  [11594] = {.lex_state = 0, .external_lex_state = 155},
  [11595] = {.lex_state = 3, .external_lex_state = 155},
  [11596] = {.lex_state = 3, .external_lex_state = 155},
  [11597] = {.lex_state = 3, .external_lex_state = 155},
  [11598] = {.lex_state = 3, .external_lex_state = 155},
  [11599] = {.lex_state = 0, .external_lex_state = 204},
  [11600] = {.lex_state = 0, .external_lex_state = 155},
  [11601] = {.lex_state = 0, .external_lex_state = 155},
  [11602] = {.lex_state = 3, .external_lex_state = 155},
  [11603] = {.lex_state = 0, .external_lex_state = 155},
  [11604] = {.lex_state = 0, .external_lex_state = 155},
  [11605] = {.lex_state = 0, .external_lex_state = 155},
  [11606] = {.lex_state = 0, .external_lex_state = 155},
  [11607] = {.lex_state = 3, .external_lex_state = 155},
  [11608] = {.lex_state = 0, .external_lex_state = 155},
  [11609] = {.lex_state = 0, .external_lex_state = 155},
  [11610] = {.lex_state = 0, .external_lex_state = 155},
  [11611] = {.lex_state = 0, .external_lex_state = 155},
  [11612] = {.lex_state = 0, .external_lex_state = 155},
  [11613] = {.lex_state = 0, .external_lex_state = 155},
  [11614] = {.lex_state = 0, .external_lex_state = 155},
  [11615] = {.lex_state = 0, .external_lex_state = 155},
  [11616] = {.lex_state = 0, .external_lex_state = 155},
  [11617] = {.lex_state = 0, .external_lex_state = 155},
  [11618] = {.lex_state = 0, .external_lex_state = 204},
  [11619] = {.lex_state = 0, .external_lex_state = 155},
  [11620] = {.lex_state = 0, .external_lex_state = 155},
  [11621] = {.lex_state = 0, .external_lex_state = 155},
  [11622] = {.lex_state = 0, .external_lex_state = 155},
  [11623] = {.lex_state = 0, .external_lex_state = 155},
  [11624] = {.lex_state = 0, .external_lex_state = 155},
  [11625] = {.lex_state = 0, .external_lex_state = 155},
  [11626] = {.lex_state = 0, .external_lex_state = 155},
  [11627] = {.lex_state = 0, .external_lex_state = 213},
  [11628] = {.lex_state = 0, .external_lex_state = 155},
  [11629] = {.lex_state = 0, .external_lex_state = 155},
  [11630] = {.lex_state = 0, .external_lex_state = 155},
  [11631] = {.lex_state = 0, .external_lex_state = 155},
  [11632] = {.lex_state = 3, .external_lex_state = 155},
  [11633] = {.lex_state = 0, .external_lex_state = 155},
  [11634] = {.lex_state = 0, .external_lex_state = 155},
  [11635] = {.lex_state = 0, .external_lex_state = 155},
  [11636] = {.lex_state = 0, .external_lex_state = 155},
  [11637] = {.lex_state = 3, .external_lex_state = 155},
  [11638] = {.lex_state = 0, .external_lex_state = 155},
  [11639] = {.lex_state = 0, .external_lex_state = 155},
  [11640] = {.lex_state = 0, .external_lex_state = 155},
  [11641] = {.lex_state = 0, .external_lex_state = 155},
  [11642] = {.lex_state = 0, .external_lex_state = 155},
  [11643] = {.lex_state = 0, .external_lex_state = 204},
  [11644] = {.lex_state = 0, .external_lex_state = 155},
  [11645] = {.lex_state = 0, .external_lex_state = 155},
  [11646] = {.lex_state = 0, .external_lex_state = 155},
  [11647] = {.lex_state = 0, .external_lex_state = 204},
  [11648] = {.lex_state = 3, .external_lex_state = 155},
  [11649] = {.lex_state = 0, .external_lex_state = 155},
  [11650] = {.lex_state = 0, .external_lex_state = 155},
  [11651] = {.lex_state = 0, .external_lex_state = 155},
  [11652] = {.lex_state = 0, .external_lex_state = 155},
  [11653] = {.lex_state = 0, .external_lex_state = 155},
  [11654] = {.lex_state = 0, .external_lex_state = 155},
  [11655] = {.lex_state = 0, .external_lex_state = 155},
  [11656] = {.lex_state = 0, .external_lex_state = 155},
  [11657] = {.lex_state = 3, .external_lex_state = 155},
  [11658] = {.lex_state = 0, .external_lex_state = 155},
  [11659] = {.lex_state = 0, .external_lex_state = 155},
  [11660] = {.lex_state = 0, .external_lex_state = 155},
  [11661] = {.lex_state = 3, .external_lex_state = 155},
  [11662] = {.lex_state = 3, .external_lex_state = 155},
  [11663] = {.lex_state = 0, .external_lex_state = 155},
  [11664] = {.lex_state = 0, .external_lex_state = 155},
  [11665] = {.lex_state = 3, .external_lex_state = 155},
  [11666] = {.lex_state = 0, .external_lex_state = 155},
  [11667] = {.lex_state = 0, .external_lex_state = 155},
  [11668] = {.lex_state = 0, .external_lex_state = 204},
  [11669] = {.lex_state = 3, .external_lex_state = 155},
  [11670] = {.lex_state = 0, .external_lex_state = 155},
  [11671] = {.lex_state = 3, .external_lex_state = 155},
  [11672] = {.lex_state = 0, .external_lex_state = 199},
  [11673] = {.lex_state = 0, .external_lex_state = 155},
  [11674] = {.lex_state = 0, .external_lex_state = 155},
  [11675] = {.lex_state = 0, .external_lex_state = 155},
  [11676] = {.lex_state = 0, .external_lex_state = 155},
  [11677] = {.lex_state = 0, .external_lex_state = 204},
  [11678] = {.lex_state = 0, .external_lex_state = 155},
  [11679] = {.lex_state = 0, .external_lex_state = 155},
  [11680] = {.lex_state = 3, .external_lex_state = 155},
  [11681] = {.lex_state = 0, .external_lex_state = 155},
  [11682] = {.lex_state = 0, .external_lex_state = 204},
  [11683] = {.lex_state = 0, .external_lex_state = 155},
  [11684] = {.lex_state = 0, .external_lex_state = 155},
  [11685] = {.lex_state = 0, .external_lex_state = 204},
  [11686] = {.lex_state = 0, .external_lex_state = 155},
  [11687] = {.lex_state = 0, .external_lex_state = 155},
  [11688] = {.lex_state = 0, .external_lex_state = 155},
  [11689] = {.lex_state = 0, .external_lex_state = 155},
  [11690] = {.lex_state = 0, .external_lex_state = 155},
  [11691] = {.lex_state = 3, .external_lex_state = 155},
  [11692] = {.lex_state = 3, .external_lex_state = 155},
  [11693] = {.lex_state = 0, .external_lex_state = 155},
  [11694] = {.lex_state = 0, .external_lex_state = 155},
  [11695] = {.lex_state = 0, .external_lex_state = 155},
  [11696] = {.lex_state = 0, .external_lex_state = 155},
  [11697] = {.lex_state = 3, .external_lex_state = 155},
  [11698] = {.lex_state = 0, .external_lex_state = 155},
  [11699] = {.lex_state = 3, .external_lex_state = 155},
  [11700] = {.lex_state = 0, .external_lex_state = 155},
  [11701] = {.lex_state = 3, .external_lex_state = 155},
  [11702] = {.lex_state = 3, .external_lex_state = 155},
  [11703] = {.lex_state = 0, .external_lex_state = 155},
  [11704] = {.lex_state = 3, .external_lex_state = 155},
  [11705] = {.lex_state = 3, .external_lex_state = 155},
  [11706] = {.lex_state = 3, .external_lex_state = 155},
  [11707] = {.lex_state = 0, .external_lex_state = 198},
  [11708] = {.lex_state = 0, .external_lex_state = 155},
  [11709] = {.lex_state = 0, .external_lex_state = 155},
  [11710] = {.lex_state = 0, .external_lex_state = 155},
  [11711] = {.lex_state = 0, .external_lex_state = 155},
  [11712] = {.lex_state = 0, .external_lex_state = 155},
  [11713] = {.lex_state = 3, .external_lex_state = 155},
  [11714] = {.lex_state = 0, .external_lex_state = 155},
  [11715] = {.lex_state = 0, .external_lex_state = 155},
  [11716] = {.lex_state = 0, .external_lex_state = 155},
  [11717] = {.lex_state = 0, .external_lex_state = 155},
  [11718] = {.lex_state = 0, .external_lex_state = 155},
  [11719] = {.lex_state = 3, .external_lex_state = 155},
  [11720] = {.lex_state = 0, .external_lex_state = 155},
  [11721] = {.lex_state = 3, .external_lex_state = 155},
  [11722] = {.lex_state = 0, .external_lex_state = 155},
  [11723] = {.lex_state = 0, .external_lex_state = 155},
  [11724] = {.lex_state = 0, .external_lex_state = 155},
  [11725] = {.lex_state = 0, .external_lex_state = 155},
  [11726] = {.lex_state = 0, .external_lex_state = 155},
  [11727] = {.lex_state = 0, .external_lex_state = 155},
  [11728] = {.lex_state = 3, .external_lex_state = 155},
  [11729] = {.lex_state = 3, .external_lex_state = 155},
  [11730] = {.lex_state = 0, .external_lex_state = 155},
  [11731] = {.lex_state = 0, .external_lex_state = 155},
  [11732] = {.lex_state = 0, .external_lex_state = 155},
  [11733] = {.lex_state = 3, .external_lex_state = 155},
  [11734] = {.lex_state = 0, .external_lex_state = 155},
  [11735] = {.lex_state = 0, .external_lex_state = 155},
  [11736] = {.lex_state = 0, .external_lex_state = 155},
  [11737] = {.lex_state = 0, .external_lex_state = 155},
  [11738] = {.lex_state = 0, .external_lex_state = 155},
  [11739] = {.lex_state = 3, .external_lex_state = 155},
  [11740] = {.lex_state = 0, .external_lex_state = 155},
  [11741] = {.lex_state = 0, .external_lex_state = 155},
  [11742] = {.lex_state = 0, .external_lex_state = 155},
  [11743] = {.lex_state = 3, .external_lex_state = 155},
  [11744] = {.lex_state = 0, .external_lex_state = 155},
  [11745] = {.lex_state = 0, .external_lex_state = 155},
  [11746] = {.lex_state = 0, .external_lex_state = 155},
  [11747] = {.lex_state = 0, .external_lex_state = 155},
  [11748] = {.lex_state = 0, .external_lex_state = 155},
  [11749] = {.lex_state = 0, .external_lex_state = 155},
  [11750] = {.lex_state = 0, .external_lex_state = 155},
  [11751] = {.lex_state = 0, .external_lex_state = 155},
  [11752] = {.lex_state = 0, .external_lex_state = 155},
  [11753] = {.lex_state = 0, .external_lex_state = 155},
  [11754] = {.lex_state = 0, .external_lex_state = 155},
  [11755] = {.lex_state = 0, .external_lex_state = 155},
  [11756] = {.lex_state = 0, .external_lex_state = 155},
  [11757] = {.lex_state = 0, .external_lex_state = 155},
  [11758] = {.lex_state = 0, .external_lex_state = 155},
  [11759] = {.lex_state = 0, .external_lex_state = 155},
  [11760] = {.lex_state = 0, .external_lex_state = 155},
  [11761] = {.lex_state = 0, .external_lex_state = 155},
  [11762] = {.lex_state = 0, .external_lex_state = 155},
  [11763] = {.lex_state = 0, .external_lex_state = 155},
  [11764] = {.lex_state = 0, .external_lex_state = 155},
  [11765] = {.lex_state = 0, .external_lex_state = 155},
  [11766] = {.lex_state = 0, .external_lex_state = 155},
  [11767] = {.lex_state = 0, .external_lex_state = 155},
  [11768] = {.lex_state = 0, .external_lex_state = 155},
  [11769] = {.lex_state = 0, .external_lex_state = 155},
  [11770] = {.lex_state = 0, .external_lex_state = 155},
  [11771] = {.lex_state = 0, .external_lex_state = 155},
  [11772] = {.lex_state = 0, .external_lex_state = 155},
  [11773] = {.lex_state = 0, .external_lex_state = 155},
  [11774] = {.lex_state = 0, .external_lex_state = 155},
  [11775] = {.lex_state = 0, .external_lex_state = 155},
  [11776] = {.lex_state = 0, .external_lex_state = 155},
  [11777] = {.lex_state = 0, .external_lex_state = 155},
  [11778] = {.lex_state = 0, .external_lex_state = 155},
  [11779] = {.lex_state = 0, .external_lex_state = 155},
  [11780] = {.lex_state = 3, .external_lex_state = 155},
  [11781] = {.lex_state = 0, .external_lex_state = 155},
  [11782] = {.lex_state = 0, .external_lex_state = 155},
  [11783] = {.lex_state = 0, .external_lex_state = 155},
  [11784] = {.lex_state = 0, .external_lex_state = 213},
  [11785] = {.lex_state = 0, .external_lex_state = 155},
  [11786] = {.lex_state = 3, .external_lex_state = 155},
  [11787] = {.lex_state = 10, .external_lex_state = 155},
  [11788] = {.lex_state = 3, .external_lex_state = 155},
  [11789] = {.lex_state = 0, .external_lex_state = 155},
  [11790] = {.lex_state = 0, .external_lex_state = 155},
  [11791] = {.lex_state = 0, .external_lex_state = 155},
  [11792] = {.lex_state = 0, .external_lex_state = 155},
  [11793] = {.lex_state = 0, .external_lex_state = 213},
  [11794] = {.lex_state = 0, .external_lex_state = 155},
  [11795] = {.lex_state = 0, .external_lex_state = 155},
  [11796] = {.lex_state = 0, .external_lex_state = 198},
  [11797] = {.lex_state = 0, .external_lex_state = 155},
  [11798] = {.lex_state = 0, .external_lex_state = 155},
  [11799] = {.lex_state = 0, .external_lex_state = 155},
  [11800] = {.lex_state = 0, .external_lex_state = 155},
  [11801] = {.lex_state = 0, .external_lex_state = 155},
  [11802] = {.lex_state = 0, .external_lex_state = 155},
  [11803] = {.lex_state = 0, .external_lex_state = 155},
  [11804] = {.lex_state = 0, .external_lex_state = 155},
  [11805] = {.lex_state = 0, .external_lex_state = 155},
  [11806] = {.lex_state = 0, .external_lex_state = 155},
  [11807] = {.lex_state = 0, .external_lex_state = 204},
  [11808] = {.lex_state = 0, .external_lex_state = 155},
  [11809] = {.lex_state = 0, .external_lex_state = 155},
  [11810] = {.lex_state = 0, .external_lex_state = 155},
  [11811] = {.lex_state = 0, .external_lex_state = 155},
  [11812] = {.lex_state = 0, .external_lex_state = 204},
  [11813] = {.lex_state = 0, .external_lex_state = 155},
  [11814] = {.lex_state = 0, .external_lex_state = 155},
  [11815] = {.lex_state = 0, .external_lex_state = 155},
  [11816] = {.lex_state = 0, .external_lex_state = 155},
  [11817] = {.lex_state = 3, .external_lex_state = 155},
  [11818] = {.lex_state = 0, .external_lex_state = 155},
  [11819] = {.lex_state = 0, .external_lex_state = 204},
  [11820] = {.lex_state = 0, .external_lex_state = 155},
  [11821] = {.lex_state = 0, .external_lex_state = 155},
  [11822] = {.lex_state = 3, .external_lex_state = 155},
  [11823] = {.lex_state = 0, .external_lex_state = 155},
  [11824] = {.lex_state = 0, .external_lex_state = 155},
  [11825] = {.lex_state = 0, .external_lex_state = 155},
  [11826] = {.lex_state = 3, .external_lex_state = 155},
  [11827] = {.lex_state = 0, .external_lex_state = 155},
  [11828] = {.lex_state = 0, .external_lex_state = 155},
  [11829] = {.lex_state = 0, .external_lex_state = 155},
  [11830] = {.lex_state = 0, .external_lex_state = 155},
  [11831] = {.lex_state = 0, .external_lex_state = 155},
  [11832] = {.lex_state = 0, .external_lex_state = 155},
  [11833] = {.lex_state = 0, .external_lex_state = 155},
  [11834] = {.lex_state = 0, .external_lex_state = 155},
  [11835] = {.lex_state = 0, .external_lex_state = 155},
  [11836] = {.lex_state = 0, .external_lex_state = 155},
  [11837] = {.lex_state = 0, .external_lex_state = 155},
  [11838] = {.lex_state = 0, .external_lex_state = 155},
  [11839] = {.lex_state = 0, .external_lex_state = 204},
  [11840] = {.lex_state = 0, .external_lex_state = 155},
  [11841] = {.lex_state = 0, .external_lex_state = 155},
  [11842] = {.lex_state = 0, .external_lex_state = 155},
  [11843] = {.lex_state = 0, .external_lex_state = 155},
  [11844] = {.lex_state = 3, .external_lex_state = 155},
  [11845] = {.lex_state = 0, .external_lex_state = 155},
  [11846] = {.lex_state = 0, .external_lex_state = 155},
  [11847] = {.lex_state = 10, .external_lex_state = 155},
  [11848] = {.lex_state = 0, .external_lex_state = 155},
  [11849] = {.lex_state = 0, .external_lex_state = 155},
  [11850] = {.lex_state = 0, .external_lex_state = 155},
  [11851] = {.lex_state = 3, .external_lex_state = 155},
  [11852] = {.lex_state = 0, .external_lex_state = 155},
  [11853] = {.lex_state = 0, .external_lex_state = 155},
  [11854] = {.lex_state = 3, .external_lex_state = 155},
  [11855] = {.lex_state = 0, .external_lex_state = 155},
  [11856] = {.lex_state = 0, .external_lex_state = 155},
  [11857] = {.lex_state = 0, .external_lex_state = 155},
  [11858] = {.lex_state = 3, .external_lex_state = 155},
  [11859] = {.lex_state = 0, .external_lex_state = 155},
  [11860] = {.lex_state = 0, .external_lex_state = 155},
  [11861] = {.lex_state = 0, .external_lex_state = 155},
  [11862] = {.lex_state = 0, .external_lex_state = 155},
  [11863] = {.lex_state = 0, .external_lex_state = 155},
  [11864] = {.lex_state = 3, .external_lex_state = 155},
  [11865] = {.lex_state = 0, .external_lex_state = 155},
  [11866] = {.lex_state = 0, .external_lex_state = 155},
  [11867] = {.lex_state = 0, .external_lex_state = 155},
  [11868] = {.lex_state = 0, .external_lex_state = 155},
  [11869] = {.lex_state = 0, .external_lex_state = 155},
  [11870] = {.lex_state = 0, .external_lex_state = 155},
  [11871] = {.lex_state = 0, .external_lex_state = 155},
  [11872] = {.lex_state = 0, .external_lex_state = 155},
  [11873] = {.lex_state = 0, .external_lex_state = 155},
  [11874] = {.lex_state = 4, .external_lex_state = 218},
  [11875] = {.lex_state = 0, .external_lex_state = 155},
  [11876] = {.lex_state = 3, .external_lex_state = 155},
  [11877] = {.lex_state = 3, .external_lex_state = 155},
  [11878] = {.lex_state = 0, .external_lex_state = 155},
  [11879] = {.lex_state = 0, .external_lex_state = 155},
  [11880] = {.lex_state = 4, .external_lex_state = 155},
  [11881] = {.lex_state = 0, .external_lex_state = 155},
  [11882] = {.lex_state = 0, .external_lex_state = 155},
  [11883] = {.lex_state = 0, .external_lex_state = 155},
  [11884] = {.lex_state = 3, .external_lex_state = 155},
  [11885] = {.lex_state = 0, .external_lex_state = 155},
  [11886] = {.lex_state = 0, .external_lex_state = 155},
  [11887] = {.lex_state = 3, .external_lex_state = 155},
  [11888] = {.lex_state = 3, .external_lex_state = 155},
  [11889] = {.lex_state = 0, .external_lex_state = 155},
  [11890] = {.lex_state = 0, .external_lex_state = 155},
  [11891] = {.lex_state = 0, .external_lex_state = 155},
  [11892] = {.lex_state = 0, .external_lex_state = 155},
  [11893] = {.lex_state = 10, .external_lex_state = 155},
  [11894] = {.lex_state = 0, .external_lex_state = 155},
  [11895] = {.lex_state = 0, .external_lex_state = 155},
  [11896] = {.lex_state = 0, .external_lex_state = 155},
  [11897] = {.lex_state = 0, .external_lex_state = 155},
  [11898] = {.lex_state = 0, .external_lex_state = 155},
  [11899] = {.lex_state = 0, .external_lex_state = 155},
  [11900] = {.lex_state = 0, .external_lex_state = 155},
  [11901] = {.lex_state = 0, .external_lex_state = 155},
  [11902] = {.lex_state = 0, .external_lex_state = 155},
  [11903] = {.lex_state = 0, .external_lex_state = 155},
  [11904] = {.lex_state = 0, .external_lex_state = 155},
  [11905] = {.lex_state = 0, .external_lex_state = 155},
  [11906] = {.lex_state = 0, .external_lex_state = 155},
  [11907] = {.lex_state = 0, .external_lex_state = 155},
  [11908] = {.lex_state = 3, .external_lex_state = 155},
  [11909] = {.lex_state = 3, .external_lex_state = 155},
  [11910] = {.lex_state = 0, .external_lex_state = 155},
  [11911] = {.lex_state = 0, .external_lex_state = 155},
  [11912] = {.lex_state = 0, .external_lex_state = 155},
  [11913] = {.lex_state = 0, .external_lex_state = 155},
  [11914] = {.lex_state = 0, .external_lex_state = 155},
  [11915] = {.lex_state = 0, .external_lex_state = 155},
  [11916] = {.lex_state = 0, .external_lex_state = 155},
  [11917] = {.lex_state = 0, .external_lex_state = 155},
  [11918] = {.lex_state = 0, .external_lex_state = 155},
  [11919] = {.lex_state = 0, .external_lex_state = 155},
  [11920] = {.lex_state = 0, .external_lex_state = 155},
  [11921] = {.lex_state = 0, .external_lex_state = 155},
  [11922] = {.lex_state = 0, .external_lex_state = 155},
  [11923] = {.lex_state = 3, .external_lex_state = 155},
  [11924] = {.lex_state = 3, .external_lex_state = 155},
  [11925] = {.lex_state = 3, .external_lex_state = 155},
  [11926] = {.lex_state = 0, .external_lex_state = 155},
  [11927] = {.lex_state = 0, .external_lex_state = 155},
  [11928] = {.lex_state = 3, .external_lex_state = 155},
  [11929] = {.lex_state = 0, .external_lex_state = 155},
  [11930] = {.lex_state = 0, .external_lex_state = 155},
  [11931] = {.lex_state = 3, .external_lex_state = 155},
  [11932] = {.lex_state = 3, .external_lex_state = 155},
  [11933] = {.lex_state = 3, .external_lex_state = 155},
  [11934] = {.lex_state = 0, .external_lex_state = 155},
  [11935] = {.lex_state = 0, .external_lex_state = 155},
  [11936] = {.lex_state = 0, .external_lex_state = 155},
  [11937] = {.lex_state = 0, .external_lex_state = 155},
  [11938] = {.lex_state = 0, .external_lex_state = 155},
  [11939] = {.lex_state = 0, .external_lex_state = 155},
  [11940] = {.lex_state = 0, .external_lex_state = 155},
  [11941] = {.lex_state = 0, .external_lex_state = 155},
  [11942] = {.lex_state = 0, .external_lex_state = 198},
  [11943] = {.lex_state = 0, .external_lex_state = 198},
  [11944] = {.lex_state = 0, .external_lex_state = 155},
  [11945] = {.lex_state = 0, .external_lex_state = 155},
  [11946] = {.lex_state = 3, .external_lex_state = 155},
  [11947] = {.lex_state = 0, .external_lex_state = 155},
  [11948] = {.lex_state = 0, .external_lex_state = 155},
  [11949] = {.lex_state = 0, .external_lex_state = 155},
  [11950] = {.lex_state = 0, .external_lex_state = 155},
  [11951] = {.lex_state = 3, .external_lex_state = 155},
  [11952] = {.lex_state = 0, .external_lex_state = 155},
  [11953] = {.lex_state = 0, .external_lex_state = 155},
  [11954] = {.lex_state = 0, .external_lex_state = 155},
  [11955] = {.lex_state = 0, .external_lex_state = 155},
  [11956] = {.lex_state = 0, .external_lex_state = 155},
  [11957] = {.lex_state = 0, .external_lex_state = 155},
  [11958] = {.lex_state = 0, .external_lex_state = 155},
  [11959] = {.lex_state = 0, .external_lex_state = 155},
  [11960] = {.lex_state = 0, .external_lex_state = 155},
  [11961] = {.lex_state = 0, .external_lex_state = 155},
  [11962] = {.lex_state = 0, .external_lex_state = 155},
  [11963] = {.lex_state = 0, .external_lex_state = 155},
  [11964] = {.lex_state = 3, .external_lex_state = 155},
  [11965] = {.lex_state = 0, .external_lex_state = 155},
  [11966] = {.lex_state = 0, .external_lex_state = 155},
  [11967] = {.lex_state = 3, .external_lex_state = 155},
  [11968] = {.lex_state = 0, .external_lex_state = 155},
  [11969] = {.lex_state = 3, .external_lex_state = 155},
  [11970] = {.lex_state = 0, .external_lex_state = 155},
  [11971] = {.lex_state = 10, .external_lex_state = 155},
  [11972] = {.lex_state = 0, .external_lex_state = 155},
  [11973] = {.lex_state = 0, .external_lex_state = 155},
  [11974] = {.lex_state = 0, .external_lex_state = 155},
  [11975] = {.lex_state = 0, .external_lex_state = 155},
  [11976] = {.lex_state = 0, .external_lex_state = 155},
  [11977] = {.lex_state = 0, .external_lex_state = 155},
  [11978] = {.lex_state = 0, .external_lex_state = 155},
  [11979] = {.lex_state = 0, .external_lex_state = 155},
  [11980] = {.lex_state = 0, .external_lex_state = 155},
  [11981] = {.lex_state = 0, .external_lex_state = 155},
  [11982] = {.lex_state = 3, .external_lex_state = 155},
  [11983] = {.lex_state = 3, .external_lex_state = 155},
  [11984] = {.lex_state = 0, .external_lex_state = 155},
  [11985] = {.lex_state = 0, .external_lex_state = 155},
  [11986] = {.lex_state = 0, .external_lex_state = 155},
  [11987] = {.lex_state = 0, .external_lex_state = 155},
  [11988] = {.lex_state = 0, .external_lex_state = 155},
  [11989] = {.lex_state = 0, .external_lex_state = 155},
  [11990] = {.lex_state = 0, .external_lex_state = 155},
  [11991] = {.lex_state = 0, .external_lex_state = 155},
  [11992] = {.lex_state = 0, .external_lex_state = 155},
  [11993] = {.lex_state = 0, .external_lex_state = 155},
  [11994] = {.lex_state = 0, .external_lex_state = 155},
  [11995] = {.lex_state = 0, .external_lex_state = 155},
  [11996] = {.lex_state = 0, .external_lex_state = 155},
  [11997] = {.lex_state = 0, .external_lex_state = 155},
  [11998] = {.lex_state = 3, .external_lex_state = 155},
  [11999] = {.lex_state = 0, .external_lex_state = 155},
  [12000] = {.lex_state = 0, .external_lex_state = 155},
  [12001] = {.lex_state = 0, .external_lex_state = 155},
  [12002] = {.lex_state = 0, .external_lex_state = 155},
  [12003] = {.lex_state = 0, .external_lex_state = 155},
  [12004] = {.lex_state = 0, .external_lex_state = 155},
  [12005] = {.lex_state = 0, .external_lex_state = 155},
  [12006] = {.lex_state = 0, .external_lex_state = 155},
  [12007] = {.lex_state = 0, .external_lex_state = 155},
  [12008] = {.lex_state = 0, .external_lex_state = 155},
  [12009] = {.lex_state = 0, .external_lex_state = 155},
  [12010] = {.lex_state = 0, .external_lex_state = 155},
  [12011] = {.lex_state = 0, .external_lex_state = 155},
  [12012] = {.lex_state = 0, .external_lex_state = 155},
  [12013] = {.lex_state = 3, .external_lex_state = 155},
  [12014] = {.lex_state = 0, .external_lex_state = 155},
  [12015] = {.lex_state = 0, .external_lex_state = 155},
  [12016] = {.lex_state = 0, .external_lex_state = 155},
  [12017] = {.lex_state = 0, .external_lex_state = 155},
  [12018] = {.lex_state = 0, .external_lex_state = 155},
  [12019] = {.lex_state = 0, .external_lex_state = 155},
  [12020] = {.lex_state = 0, .external_lex_state = 155},
  [12021] = {.lex_state = 0, .external_lex_state = 155},
  [12022] = {.lex_state = 0, .external_lex_state = 155},
  [12023] = {.lex_state = 0, .external_lex_state = 155},
  [12024] = {.lex_state = 0, .external_lex_state = 155},
  [12025] = {.lex_state = 3, .external_lex_state = 155},
  [12026] = {.lex_state = 3, .external_lex_state = 155},
  [12027] = {.lex_state = 0, .external_lex_state = 155},
  [12028] = {.lex_state = 0, .external_lex_state = 155},
  [12029] = {.lex_state = 3, .external_lex_state = 155},
  [12030] = {.lex_state = 0, .external_lex_state = 155},
  [12031] = {.lex_state = 10, .external_lex_state = 155},
  [12032] = {.lex_state = 0, .external_lex_state = 155},
  [12033] = {.lex_state = 0, .external_lex_state = 155},
  [12034] = {.lex_state = 0, .external_lex_state = 155},
  [12035] = {.lex_state = 0, .external_lex_state = 155},
  [12036] = {.lex_state = 0, .external_lex_state = 155},
  [12037] = {.lex_state = 0, .external_lex_state = 155},
  [12038] = {.lex_state = 0, .external_lex_state = 155},
  [12039] = {.lex_state = 3, .external_lex_state = 155},
  [12040] = {.lex_state = 0, .external_lex_state = 155},
  [12041] = {.lex_state = 0, .external_lex_state = 155},
  [12042] = {.lex_state = 0, .external_lex_state = 155},
  [12043] = {.lex_state = 0, .external_lex_state = 155},
  [12044] = {.lex_state = 3, .external_lex_state = 155},
  [12045] = {.lex_state = 0, .external_lex_state = 155},
  [12046] = {.lex_state = 0, .external_lex_state = 155},
  [12047] = {.lex_state = 0, .external_lex_state = 155},
  [12048] = {.lex_state = 0, .external_lex_state = 155},
  [12049] = {.lex_state = 0, .external_lex_state = 155},
  [12050] = {.lex_state = 0, .external_lex_state = 155},
  [12051] = {.lex_state = 3, .external_lex_state = 155},
  [12052] = {.lex_state = 3, .external_lex_state = 155},
  [12053] = {.lex_state = 0, .external_lex_state = 198},
  [12054] = {.lex_state = 0, .external_lex_state = 155},
  [12055] = {.lex_state = 0, .external_lex_state = 155},
  [12056] = {.lex_state = 0, .external_lex_state = 155},
  [12057] = {.lex_state = 0, .external_lex_state = 155},
  [12058] = {.lex_state = 0, .external_lex_state = 155},
  [12059] = {.lex_state = 0, .external_lex_state = 155},
  [12060] = {.lex_state = 0, .external_lex_state = 155},
  [12061] = {.lex_state = 0, .external_lex_state = 155},
  [12062] = {.lex_state = 0, .external_lex_state = 155},
  [12063] = {.lex_state = 0, .external_lex_state = 155},
  [12064] = {.lex_state = 0, .external_lex_state = 155},
  [12065] = {.lex_state = 3, .external_lex_state = 155},
  [12066] = {.lex_state = 0, .external_lex_state = 155},
  [12067] = {.lex_state = 0, .external_lex_state = 155},
  [12068] = {.lex_state = 0, .external_lex_state = 213},
  [12069] = {.lex_state = 0, .external_lex_state = 155},
  [12070] = {.lex_state = 3, .external_lex_state = 155},
  [12071] = {.lex_state = 3, .external_lex_state = 155},
  [12072] = {.lex_state = 0, .external_lex_state = 155},
  [12073] = {.lex_state = 0, .external_lex_state = 155},
  [12074] = {.lex_state = 0, .external_lex_state = 155},
  [12075] = {.lex_state = 0, .external_lex_state = 155},
  [12076] = {.lex_state = 0, .external_lex_state = 155},
  [12077] = {.lex_state = 0, .external_lex_state = 155},
  [12078] = {.lex_state = 3, .external_lex_state = 155},
  [12079] = {.lex_state = 0, .external_lex_state = 198},
  [12080] = {.lex_state = 0, .external_lex_state = 155},
  [12081] = {.lex_state = 0, .external_lex_state = 155},
  [12082] = {.lex_state = 0, .external_lex_state = 155},
  [12083] = {.lex_state = 10, .external_lex_state = 155},
  [12084] = {.lex_state = 0, .external_lex_state = 155},
  [12085] = {.lex_state = 0, .external_lex_state = 155},
  [12086] = {.lex_state = 0, .external_lex_state = 155},
  [12087] = {.lex_state = 0, .external_lex_state = 155},
  [12088] = {.lex_state = 0, .external_lex_state = 155},
  [12089] = {.lex_state = 0, .external_lex_state = 155},
  [12090] = {.lex_state = 0, .external_lex_state = 155},
  [12091] = {.lex_state = 0, .external_lex_state = 155},
  [12092] = {.lex_state = 0, .external_lex_state = 155},
  [12093] = {.lex_state = 0, .external_lex_state = 155},
  [12094] = {.lex_state = 0, .external_lex_state = 155},
  [12095] = {.lex_state = 0, .external_lex_state = 155},
  [12096] = {.lex_state = 0, .external_lex_state = 155},
  [12097] = {.lex_state = 0, .external_lex_state = 155},
  [12098] = {.lex_state = 0, .external_lex_state = 155},
  [12099] = {.lex_state = 0, .external_lex_state = 155},
  [12100] = {.lex_state = 0, .external_lex_state = 155},
  [12101] = {.lex_state = 0, .external_lex_state = 155},
  [12102] = {.lex_state = 0, .external_lex_state = 155},
  [12103] = {.lex_state = 0, .external_lex_state = 155},
  [12104] = {.lex_state = 0, .external_lex_state = 155},
  [12105] = {.lex_state = 0, .external_lex_state = 155},
  [12106] = {.lex_state = 3, .external_lex_state = 155},
  [12107] = {.lex_state = 0, .external_lex_state = 155},
  [12108] = {.lex_state = 0, .external_lex_state = 155},
  [12109] = {.lex_state = 0, .external_lex_state = 155},
  [12110] = {.lex_state = 0, .external_lex_state = 155},
  [12111] = {.lex_state = 0, .external_lex_state = 155},
  [12112] = {.lex_state = 0, .external_lex_state = 155},
  [12113] = {.lex_state = 0, .external_lex_state = 155},
  [12114] = {.lex_state = 0, .external_lex_state = 155},
  [12115] = {.lex_state = 0, .external_lex_state = 155},
  [12116] = {.lex_state = 0, .external_lex_state = 155},
  [12117] = {.lex_state = 0, .external_lex_state = 155},
  [12118] = {.lex_state = 4, .external_lex_state = 218},
  [12119] = {.lex_state = 0, .external_lex_state = 155},
  [12120] = {.lex_state = 0, .external_lex_state = 155},
  [12121] = {.lex_state = 0, .external_lex_state = 155},
  [12122] = {.lex_state = 3, .external_lex_state = 155},
  [12123] = {.lex_state = 0, .external_lex_state = 155},
  [12124] = {.lex_state = 0, .external_lex_state = 155},
  [12125] = {.lex_state = 3, .external_lex_state = 155},
  [12126] = {.lex_state = 0, .external_lex_state = 155},
  [12127] = {.lex_state = 0, .external_lex_state = 155},
  [12128] = {.lex_state = 0, .external_lex_state = 155},
  [12129] = {.lex_state = 0, .external_lex_state = 155},
  [12130] = {.lex_state = 3, .external_lex_state = 155},
  [12131] = {.lex_state = 0, .external_lex_state = 155},
  [12132] = {.lex_state = 0, .external_lex_state = 155},
  [12133] = {.lex_state = 0, .external_lex_state = 155},
  [12134] = {.lex_state = 3, .external_lex_state = 155},
  [12135] = {.lex_state = 0, .external_lex_state = 155},
  [12136] = {.lex_state = 0, .external_lex_state = 155},
  [12137] = {.lex_state = 0, .external_lex_state = 155},
  [12138] = {.lex_state = 0, .external_lex_state = 155},
  [12139] = {.lex_state = 0, .external_lex_state = 155},
  [12140] = {.lex_state = 0, .external_lex_state = 155},
  [12141] = {.lex_state = 0, .external_lex_state = 155},
  [12142] = {.lex_state = 10, .external_lex_state = 155},
  [12143] = {.lex_state = 0, .external_lex_state = 155},
  [12144] = {.lex_state = 0, .external_lex_state = 155},
  [12145] = {.lex_state = 0, .external_lex_state = 155},
  [12146] = {.lex_state = 0, .external_lex_state = 155},
  [12147] = {.lex_state = 3, .external_lex_state = 155},
  [12148] = {.lex_state = 0, .external_lex_state = 155},
  [12149] = {.lex_state = 0, .external_lex_state = 217},
  [12150] = {.lex_state = 0, .external_lex_state = 155},
  [12151] = {.lex_state = 0, .external_lex_state = 155},
  [12152] = {.lex_state = 0, .external_lex_state = 155},
  [12153] = {.lex_state = 0, .external_lex_state = 155},
  [12154] = {.lex_state = 0, .external_lex_state = 155},
  [12155] = {.lex_state = 0, .external_lex_state = 155},
  [12156] = {.lex_state = 0, .external_lex_state = 213},
  [12157] = {.lex_state = 0, .external_lex_state = 155},
  [12158] = {.lex_state = 0, .external_lex_state = 155},
  [12159] = {.lex_state = 3, .external_lex_state = 155},
  [12160] = {.lex_state = 0, .external_lex_state = 198},
  [12161] = {.lex_state = 0, .external_lex_state = 155},
  [12162] = {.lex_state = 3, .external_lex_state = 155},
  [12163] = {.lex_state = 0, .external_lex_state = 155},
  [12164] = {.lex_state = 3, .external_lex_state = 155},
  [12165] = {.lex_state = 0, .external_lex_state = 155},
  [12166] = {.lex_state = 0, .external_lex_state = 155},
  [12167] = {.lex_state = 0, .external_lex_state = 155},
  [12168] = {.lex_state = 10, .external_lex_state = 155},
  [12169] = {.lex_state = 0, .external_lex_state = 155},
  [12170] = {.lex_state = 0, .external_lex_state = 155},
  [12171] = {.lex_state = 3, .external_lex_state = 155},
  [12172] = {.lex_state = 3, .external_lex_state = 155},
  [12173] = {.lex_state = 0, .external_lex_state = 155},
  [12174] = {.lex_state = 3, .external_lex_state = 155},
  [12175] = {.lex_state = 3, .external_lex_state = 155},
  [12176] = {.lex_state = 0, .external_lex_state = 155},
  [12177] = {.lex_state = 3, .external_lex_state = 155},
  [12178] = {.lex_state = 0, .external_lex_state = 155},
  [12179] = {.lex_state = 3, .external_lex_state = 155},
  [12180] = {.lex_state = 0, .external_lex_state = 155},
  [12181] = {.lex_state = 0, .external_lex_state = 155},
  [12182] = {.lex_state = 0, .external_lex_state = 155},
  [12183] = {.lex_state = 0, .external_lex_state = 155},
  [12184] = {.lex_state = 0, .external_lex_state = 155},
  [12185] = {.lex_state = 0, .external_lex_state = 155},
  [12186] = {.lex_state = 0, .external_lex_state = 155},
  [12187] = {.lex_state = 0, .external_lex_state = 155},
  [12188] = {.lex_state = 4, .external_lex_state = 218},
  [12189] = {.lex_state = 3, .external_lex_state = 155},
  [12190] = {.lex_state = 3, .external_lex_state = 155},
  [12191] = {.lex_state = 0, .external_lex_state = 155},
  [12192] = {.lex_state = 3, .external_lex_state = 155},
  [12193] = {.lex_state = 0, .external_lex_state = 198},
  [12194] = {.lex_state = 0, .external_lex_state = 155},
  [12195] = {.lex_state = 0, .external_lex_state = 155},
  [12196] = {.lex_state = 10, .external_lex_state = 155},
  [12197] = {.lex_state = 3, .external_lex_state = 155},
  [12198] = {.lex_state = 0, .external_lex_state = 213},
  [12199] = {.lex_state = 0, .external_lex_state = 155},
  [12200] = {.lex_state = 0, .external_lex_state = 199},
  [12201] = {.lex_state = 0, .external_lex_state = 155},
  [12202] = {.lex_state = 0, .external_lex_state = 155},
  [12203] = {.lex_state = 0, .external_lex_state = 211},
  [12204] = {.lex_state = 0, .external_lex_state = 155},
  [12205] = {.lex_state = 0, .external_lex_state = 155},
  [12206] = {.lex_state = 0, .external_lex_state = 155},
  [12207] = {.lex_state = 0, .external_lex_state = 155},
  [12208] = {.lex_state = 0, .external_lex_state = 155},
  [12209] = {.lex_state = 0, .external_lex_state = 155},
  [12210] = {.lex_state = 3, .external_lex_state = 155},
  [12211] = {.lex_state = 0, .external_lex_state = 155},
  [12212] = {.lex_state = 0, .external_lex_state = 155},
  [12213] = {.lex_state = 3, .external_lex_state = 155},
  [12214] = {.lex_state = 0, .external_lex_state = 155},
  [12215] = {.lex_state = 3, .external_lex_state = 155},
  [12216] = {.lex_state = 3, .external_lex_state = 155},
  [12217] = {.lex_state = 0, .external_lex_state = 155},
  [12218] = {.lex_state = 10, .external_lex_state = 155},
  [12219] = {.lex_state = 0, .external_lex_state = 155},
  [12220] = {.lex_state = 0, .external_lex_state = 155},
  [12221] = {.lex_state = 0, .external_lex_state = 155},
  [12222] = {.lex_state = 0, .external_lex_state = 155},
  [12223] = {.lex_state = 0, .external_lex_state = 155},
  [12224] = {.lex_state = 0, .external_lex_state = 219},
  [12225] = {.lex_state = 0, .external_lex_state = 220},
  [12226] = {.lex_state = 0, .external_lex_state = 219},
  [12227] = {.lex_state = 4, .external_lex_state = 155},
  [12228] = {.lex_state = 4, .external_lex_state = 155},
  [12229] = {.lex_state = 0, .external_lex_state = 219},
  [12230] = {.lex_state = 0, .external_lex_state = 219},
  [12231] = {.lex_state = 0, .external_lex_state = 155},
  [12232] = {.lex_state = 0, .external_lex_state = 221},
  [12233] = {.lex_state = 0, .external_lex_state = 219},
  [12234] = {.lex_state = 0, .external_lex_state = 221},
  [12235] = {.lex_state = 0, .external_lex_state = 221},
  [12236] = {.lex_state = 0, .external_lex_state = 155},
  [12237] = {.lex_state = 0, .external_lex_state = 220},
  [12238] = {.lex_state = 0, .external_lex_state = 219},
  [12239] = {.lex_state = 0, .external_lex_state = 155},
  [12240] = {.lex_state = 4, .external_lex_state = 155},
  [12241] = {.lex_state = 0, .external_lex_state = 155},
  [12242] = {.lex_state = 0, .external_lex_state = 155},
  [12243] = {.lex_state = 4, .external_lex_state = 155},
  [12244] = {.lex_state = 3, .external_lex_state = 155},
  [12245] = {.lex_state = 0, .external_lex_state = 221},
  [12246] = {.lex_state = 0, .external_lex_state = 203},
  [12247] = {.lex_state = 0, .external_lex_state = 155},
  [12248] = {.lex_state = 3, .external_lex_state = 155},
  [12249] = {.lex_state = 0, .external_lex_state = 221},
  [12250] = {.lex_state = 0, .external_lex_state = 155},
  [12251] = {.lex_state = 4, .external_lex_state = 155},
  [12252] = {.lex_state = 4, .external_lex_state = 155},
  [12253] = {.lex_state = 4, .external_lex_state = 155},
  [12254] = {.lex_state = 4, .external_lex_state = 155},
  [12255] = {.lex_state = 4, .external_lex_state = 155},
  [12256] = {.lex_state = 0, .external_lex_state = 155},
  [12257] = {.lex_state = 0, .external_lex_state = 221},
  [12258] = {.lex_state = 0, .external_lex_state = 221},
  [12259] = {.lex_state = 0, .external_lex_state = 155},
  [12260] = {.lex_state = 0, .external_lex_state = 221},
  [12261] = {.lex_state = 0, .external_lex_state = 218},
  [12262] = {.lex_state = 0, .external_lex_state = 221},
  [12263] = {.lex_state = 0, .external_lex_state = 219},
  [12264] = {.lex_state = 0, .external_lex_state = 221},
  [12265] = {.lex_state = 0, .external_lex_state = 219},
  [12266] = {.lex_state = 0, .external_lex_state = 220},
  [12267] = {.lex_state = 0, .external_lex_state = 219},
  [12268] = {.lex_state = 0, .external_lex_state = 155},
  [12269] = {.lex_state = 0, .external_lex_state = 155},
  [12270] = {.lex_state = 4, .external_lex_state = 155},
  [12271] = {.lex_state = 3, .external_lex_state = 155},
  [12272] = {.lex_state = 4, .external_lex_state = 155},
  [12273] = {.lex_state = 0, .external_lex_state = 155},
  [12274] = {.lex_state = 4, .external_lex_state = 155},
  [12275] = {.lex_state = 0, .external_lex_state = 155},
  [12276] = {.lex_state = 0, .external_lex_state = 155},
  [12277] = {.lex_state = 4, .external_lex_state = 155},
  [12278] = {.lex_state = 0, .external_lex_state = 155},
  [12279] = {.lex_state = 3, .external_lex_state = 155},
  [12280] = {.lex_state = 0, .external_lex_state = 220},
  [12281] = {.lex_state = 0, .external_lex_state = 219},
  [12282] = {.lex_state = 0, .external_lex_state = 220},
  [12283] = {.lex_state = 0, .external_lex_state = 155},
  [12284] = {.lex_state = 0, .external_lex_state = 220},
  [12285] = {.lex_state = 0, .external_lex_state = 155},
  [12286] = {.lex_state = 0, .external_lex_state = 221},
  [12287] = {.lex_state = 0, .external_lex_state = 221},
  [12288] = {.lex_state = 0, .external_lex_state = 155},
  [12289] = {.lex_state = 0, .external_lex_state = 221},
  [12290] = {.lex_state = 0, .external_lex_state = 221},
  [12291] = {.lex_state = 0, .external_lex_state = 221},
  [12292] = {.lex_state = 0, .external_lex_state = 221},
  [12293] = {.lex_state = 0, .external_lex_state = 219},
  [12294] = {.lex_state = 0, .external_lex_state = 155},
  [12295] = {.lex_state = 0, .external_lex_state = 221},
  [12296] = {.lex_state = 0, .external_lex_state = 221},
  [12297] = {.lex_state = 0, .external_lex_state = 221},
  [12298] = {.lex_state = 0, .external_lex_state = 221},
  [12299] = {.lex_state = 0, .external_lex_state = 155},
  [12300] = {.lex_state = 0, .external_lex_state = 221},
  [12301] = {.lex_state = 4, .external_lex_state = 155},
  [12302] = {.lex_state = 4, .external_lex_state = 155},
  [12303] = {.lex_state = 4, .external_lex_state = 155},
  [12304] = {.lex_state = 4, .external_lex_state = 155},
  [12305] = {.lex_state = 0, .external_lex_state = 221},
  [12306] = {.lex_state = 0, .external_lex_state = 222},
  [12307] = {.lex_state = 0, .external_lex_state = 221},
  [12308] = {.lex_state = 0, .external_lex_state = 220},
  [12309] = {.lex_state = 0, .external_lex_state = 155},
  [12310] = {.lex_state = 0, .external_lex_state = 221},
  [12311] = {.lex_state = 0, .external_lex_state = 219},
  [12312] = {.lex_state = 0, .external_lex_state = 221},
  [12313] = {.lex_state = 0, .external_lex_state = 219},
  [12314] = {.lex_state = 0, .external_lex_state = 221},
  [12315] = {.lex_state = 0, .external_lex_state = 219},
  [12316] = {.lex_state = 0, .external_lex_state = 219},
  [12317] = {.lex_state = 0, .external_lex_state = 219},
  [12318] = {.lex_state = 0, .external_lex_state = 221},
  [12319] = {.lex_state = 0, .external_lex_state = 222},
  [12320] = {.lex_state = 0, .external_lex_state = 221},
  [12321] = {.lex_state = 0, .external_lex_state = 219},
  [12322] = {.lex_state = 3, .external_lex_state = 155},
  [12323] = {.lex_state = 0, .external_lex_state = 221},
  [12324] = {.lex_state = 0, .external_lex_state = 221},
  [12325] = {.lex_state = 0, .external_lex_state = 221},
  [12326] = {.lex_state = 0, .external_lex_state = 221},
  [12327] = {.lex_state = 0, .external_lex_state = 221},
  [12328] = {.lex_state = 4, .external_lex_state = 155},
  [12329] = {.lex_state = 0, .external_lex_state = 219},
  [12330] = {.lex_state = 0, .external_lex_state = 221},
  [12331] = {.lex_state = 4, .external_lex_state = 155},
  [12332] = {.lex_state = 0, .external_lex_state = 219},
  [12333] = {.lex_state = 0, .external_lex_state = 221},
  [12334] = {.lex_state = 0, .external_lex_state = 221},
  [12335] = {.lex_state = 0, .external_lex_state = 155},
  [12336] = {.lex_state = 0, .external_lex_state = 221},
  [12337] = {.lex_state = 0, .external_lex_state = 221},
  [12338] = {.lex_state = 0, .external_lex_state = 220},
  [12339] = {.lex_state = 0, .external_lex_state = 221},
  [12340] = {.lex_state = 0, .external_lex_state = 155},
  [12341] = {.lex_state = 0, .external_lex_state = 221},
  [12342] = {.lex_state = 4, .external_lex_state = 155},
  [12343] = {.lex_state = 4, .external_lex_state = 155},
  [12344] = {.lex_state = 4, .external_lex_state = 155},
  [12345] = {.lex_state = 4, .external_lex_state = 155},
  [12346] = {.lex_state = 0, .external_lex_state = 221},
  [12347] = {.lex_state = 0, .external_lex_state = 221},
  [12348] = {.lex_state = 0, .external_lex_state = 221},
  [12349] = {.lex_state = 0, .external_lex_state = 221},
  [12350] = {.lex_state = 0, .external_lex_state = 219},
  [12351] = {.lex_state = 0, .external_lex_state = 219},
  [12352] = {.lex_state = 3, .external_lex_state = 155},
  [12353] = {.lex_state = 0, .external_lex_state = 221},
  [12354] = {.lex_state = 0, .external_lex_state = 155},
  [12355] = {.lex_state = 0, .external_lex_state = 221},
  [12356] = {.lex_state = 0, .external_lex_state = 221},
  [12357] = {.lex_state = 0, .external_lex_state = 155},
  [12358] = {.lex_state = 4, .external_lex_state = 155},
  [12359] = {.lex_state = 0, .external_lex_state = 221},
  [12360] = {.lex_state = 0, .external_lex_state = 221},
  [12361] = {.lex_state = 21, .external_lex_state = 155},
  [12362] = {.lex_state = 21, .external_lex_state = 155},
  [12363] = {.lex_state = 0, .external_lex_state = 155},
  [12364] = {.lex_state = 0, .external_lex_state = 221},
  [12365] = {.lex_state = 0, .external_lex_state = 221},
  [12366] = {.lex_state = 3, .external_lex_state = 155},
  [12367] = {.lex_state = 0, .external_lex_state = 221},
  [12368] = {.lex_state = 0, .external_lex_state = 155},
  [12369] = {.lex_state = 0, .external_lex_state = 221},
  [12370] = {.lex_state = 0, .external_lex_state = 221},
  [12371] = {.lex_state = 0, .external_lex_state = 221},
  [12372] = {.lex_state = 0, .external_lex_state = 219},
  [12373] = {.lex_state = 0, .external_lex_state = 219},
  [12374] = {.lex_state = 0, .external_lex_state = 155},
  [12375] = {.lex_state = 0, .external_lex_state = 221},
  [12376] = {.lex_state = 0, .external_lex_state = 221},
  [12377] = {.lex_state = 0, .external_lex_state = 221},
  [12378] = {.lex_state = 0, .external_lex_state = 155},
  [12379] = {.lex_state = 0, .external_lex_state = 221},
  [12380] = {.lex_state = 4, .external_lex_state = 155},
  [12381] = {.lex_state = 4, .external_lex_state = 155},
  [12382] = {.lex_state = 4, .external_lex_state = 155},
  [12383] = {.lex_state = 4, .external_lex_state = 155},
  [12384] = {.lex_state = 0, .external_lex_state = 221},
  [12385] = {.lex_state = 3, .external_lex_state = 155},
  [12386] = {.lex_state = 0, .external_lex_state = 221},
  [12387] = {.lex_state = 0, .external_lex_state = 221},
  [12388] = {.lex_state = 0, .external_lex_state = 221},
  [12389] = {.lex_state = 0, .external_lex_state = 219},
  [12390] = {.lex_state = 0, .external_lex_state = 218},
  [12391] = {.lex_state = 0, .external_lex_state = 221},
  [12392] = {.lex_state = 0, .external_lex_state = 219},
  [12393] = {.lex_state = 0, .external_lex_state = 221},
  [12394] = {.lex_state = 0, .external_lex_state = 221},
  [12395] = {.lex_state = 0, .external_lex_state = 221},
  [12396] = {.lex_state = 0, .external_lex_state = 221},
  [12397] = {.lex_state = 0, .external_lex_state = 221},
  [12398] = {.lex_state = 0, .external_lex_state = 221},
  [12399] = {.lex_state = 0, .external_lex_state = 155},
  [12400] = {.lex_state = 0, .external_lex_state = 221},
  [12401] = {.lex_state = 0, .external_lex_state = 221},
  [12402] = {.lex_state = 0, .external_lex_state = 221},
  [12403] = {.lex_state = 0, .external_lex_state = 221},
  [12404] = {.lex_state = 0, .external_lex_state = 155},
  [12405] = {.lex_state = 0, .external_lex_state = 221},
  [12406] = {.lex_state = 0, .external_lex_state = 155},
  [12407] = {.lex_state = 0, .external_lex_state = 221},
  [12408] = {.lex_state = 0, .external_lex_state = 155},
  [12409] = {.lex_state = 0, .external_lex_state = 221},
  [12410] = {.lex_state = 4, .external_lex_state = 155},
  [12411] = {.lex_state = 4, .external_lex_state = 155},
  [12412] = {.lex_state = 4, .external_lex_state = 155},
  [12413] = {.lex_state = 4, .external_lex_state = 155},
  [12414] = {.lex_state = 0, .external_lex_state = 221},
  [12415] = {.lex_state = 0, .external_lex_state = 221},
  [12416] = {.lex_state = 0, .external_lex_state = 221},
  [12417] = {.lex_state = 0, .external_lex_state = 221},
  [12418] = {.lex_state = 0, .external_lex_state = 221},
  [12419] = {.lex_state = 0, .external_lex_state = 221},
  [12420] = {.lex_state = 0, .external_lex_state = 155},
  [12421] = {.lex_state = 0, .external_lex_state = 221},
  [12422] = {.lex_state = 0, .external_lex_state = 219},
  [12423] = {.lex_state = 3, .external_lex_state = 155},
  [12424] = {.lex_state = 0, .external_lex_state = 219},
  [12425] = {.lex_state = 0, .external_lex_state = 219},
  [12426] = {.lex_state = 0, .external_lex_state = 203},
  [12427] = {.lex_state = 0, .external_lex_state = 221},
  [12428] = {.lex_state = 0, .external_lex_state = 221},
  [12429] = {.lex_state = 0, .external_lex_state = 221},
  [12430] = {.lex_state = 0, .external_lex_state = 221},
  [12431] = {.lex_state = 0, .external_lex_state = 155},
  [12432] = {.lex_state = 0, .external_lex_state = 221},
  [12433] = {.lex_state = 0, .external_lex_state = 221},
  [12434] = {.lex_state = 0, .external_lex_state = 221},
  [12435] = {.lex_state = 3, .external_lex_state = 155},
  [12436] = {.lex_state = 0, .external_lex_state = 221},
  [12437] = {.lex_state = 0, .external_lex_state = 221},
  [12438] = {.lex_state = 0, .external_lex_state = 155},
  [12439] = {.lex_state = 0, .external_lex_state = 221},
  [12440] = {.lex_state = 4, .external_lex_state = 155},
  [12441] = {.lex_state = 4, .external_lex_state = 155},
  [12442] = {.lex_state = 4, .external_lex_state = 155},
  [12443] = {.lex_state = 4, .external_lex_state = 155},
  [12444] = {.lex_state = 0, .external_lex_state = 218},
  [12445] = {.lex_state = 0, .external_lex_state = 221},
  [12446] = {.lex_state = 0, .external_lex_state = 155},
  [12447] = {.lex_state = 0, .external_lex_state = 219},
  [12448] = {.lex_state = 0, .external_lex_state = 219},
  [12449] = {.lex_state = 0, .external_lex_state = 219},
  [12450] = {.lex_state = 0, .external_lex_state = 155},
  [12451] = {.lex_state = 4, .external_lex_state = 155},
  [12452] = {.lex_state = 0, .external_lex_state = 221},
  [12453] = {.lex_state = 4, .external_lex_state = 155},
  [12454] = {.lex_state = 4, .external_lex_state = 155},
  [12455] = {.lex_state = 0, .external_lex_state = 221},
  [12456] = {.lex_state = 0, .external_lex_state = 221},
  [12457] = {.lex_state = 0, .external_lex_state = 155},
  [12458] = {.lex_state = 0, .external_lex_state = 218},
  [12459] = {.lex_state = 0, .external_lex_state = 221},
  [12460] = {.lex_state = 0, .external_lex_state = 221},
  [12461] = {.lex_state = 0, .external_lex_state = 219},
  [12462] = {.lex_state = 0, .external_lex_state = 219},
  [12463] = {.lex_state = 0, .external_lex_state = 219},
  [12464] = {.lex_state = 3, .external_lex_state = 155},
  [12465] = {.lex_state = 0, .external_lex_state = 155},
  [12466] = {.lex_state = 0, .external_lex_state = 155},
  [12467] = {.lex_state = 0, .external_lex_state = 221},
  [12468] = {.lex_state = 0, .external_lex_state = 155},
  [12469] = {.lex_state = 0, .external_lex_state = 155},
  [12470] = {.lex_state = 4, .external_lex_state = 155},
  [12471] = {.lex_state = 4, .external_lex_state = 155},
  [12472] = {.lex_state = 4, .external_lex_state = 155},
  [12473] = {.lex_state = 4, .external_lex_state = 155},
  [12474] = {.lex_state = 0, .external_lex_state = 221},
  [12475] = {.lex_state = 0, .external_lex_state = 219},
  [12476] = {.lex_state = 0, .external_lex_state = 222},
  [12477] = {.lex_state = 0, .external_lex_state = 221},
  [12478] = {.lex_state = 0, .external_lex_state = 221},
  [12479] = {.lex_state = 0, .external_lex_state = 221},
  [12480] = {.lex_state = 0, .external_lex_state = 221},
  [12481] = {.lex_state = 0, .external_lex_state = 219},
  [12482] = {.lex_state = 0, .external_lex_state = 221},
  [12483] = {.lex_state = 0, .external_lex_state = 155},
  [12484] = {.lex_state = 0, .external_lex_state = 219},
  [12485] = {.lex_state = 0, .external_lex_state = 155},
  [12486] = {.lex_state = 0, .external_lex_state = 155},
  [12487] = {.lex_state = 0, .external_lex_state = 221},
  [12488] = {.lex_state = 3, .external_lex_state = 155},
  [12489] = {.lex_state = 0, .external_lex_state = 155},
  [12490] = {.lex_state = 3, .external_lex_state = 155},
  [12491] = {.lex_state = 0, .external_lex_state = 221},
  [12492] = {.lex_state = 0, .external_lex_state = 221},
  [12493] = {.lex_state = 0, .external_lex_state = 221},
  [12494] = {.lex_state = 4, .external_lex_state = 155},
  [12495] = {.lex_state = 0, .external_lex_state = 221},
  [12496] = {.lex_state = 0, .external_lex_state = 221},
  [12497] = {.lex_state = 0, .external_lex_state = 221},
  [12498] = {.lex_state = 0, .external_lex_state = 155},
  [12499] = {.lex_state = 0, .external_lex_state = 219},
  [12500] = {.lex_state = 4, .external_lex_state = 155},
  [12501] = {.lex_state = 0, .external_lex_state = 221},
  [12502] = {.lex_state = 4, .external_lex_state = 155},
  [12503] = {.lex_state = 4, .external_lex_state = 155},
  [12504] = {.lex_state = 0, .external_lex_state = 221},
  [12505] = {.lex_state = 0, .external_lex_state = 221},
  [12506] = {.lex_state = 0, .external_lex_state = 155},
  [12507] = {.lex_state = 0, .external_lex_state = 219},
  [12508] = {.lex_state = 0, .external_lex_state = 221},
  [12509] = {.lex_state = 0, .external_lex_state = 221},
  [12510] = {.lex_state = 0, .external_lex_state = 220},
  [12511] = {.lex_state = 0, .external_lex_state = 221},
  [12512] = {.lex_state = 0, .external_lex_state = 221},
  [12513] = {.lex_state = 0, .external_lex_state = 221},
  [12514] = {.lex_state = 0, .external_lex_state = 221},
  [12515] = {.lex_state = 0, .external_lex_state = 221},
  [12516] = {.lex_state = 0, .external_lex_state = 155},
  [12517] = {.lex_state = 0, .external_lex_state = 155},
  [12518] = {.lex_state = 0, .external_lex_state = 155},
  [12519] = {.lex_state = 0, .external_lex_state = 155},
  [12520] = {.lex_state = 0, .external_lex_state = 219},
  [12521] = {.lex_state = 0, .external_lex_state = 221},
  [12522] = {.lex_state = 0, .external_lex_state = 219},
  [12523] = {.lex_state = 0, .external_lex_state = 221},
  [12524] = {.lex_state = 4, .external_lex_state = 155},
  [12525] = {.lex_state = 0, .external_lex_state = 155},
  [12526] = {.lex_state = 0, .external_lex_state = 221},
  [12527] = {.lex_state = 0, .external_lex_state = 221},
  [12528] = {.lex_state = 0, .external_lex_state = 155},
  [12529] = {.lex_state = 0, .external_lex_state = 220},
  [12530] = {.lex_state = 0, .external_lex_state = 219},
  [12531] = {.lex_state = 3, .external_lex_state = 155},
  [12532] = {.lex_state = 0, .external_lex_state = 155},
  [12533] = {.lex_state = 4, .external_lex_state = 155},
  [12534] = {.lex_state = 0, .external_lex_state = 221},
  [12535] = {.lex_state = 0, .external_lex_state = 221},
  [12536] = {.lex_state = 3, .external_lex_state = 155},
  [12537] = {.lex_state = 0, .external_lex_state = 221},
  [12538] = {.lex_state = 0, .external_lex_state = 155},
  [12539] = {.lex_state = 0, .external_lex_state = 221},
  [12540] = {.lex_state = 4, .external_lex_state = 155},
  [12541] = {.lex_state = 0, .external_lex_state = 221},
  [12542] = {.lex_state = 0, .external_lex_state = 221},
  [12543] = {.lex_state = 0, .external_lex_state = 155},
  [12544] = {.lex_state = 4, .external_lex_state = 155},
  [12545] = {.lex_state = 0, .external_lex_state = 221},
  [12546] = {.lex_state = 0, .external_lex_state = 155},
  [12547] = {.lex_state = 4, .external_lex_state = 155},
  [12548] = {.lex_state = 3, .external_lex_state = 155},
  [12549] = {.lex_state = 0, .external_lex_state = 221},
  [12550] = {.lex_state = 0, .external_lex_state = 221},
  [12551] = {.lex_state = 0, .external_lex_state = 221},
  [12552] = {.lex_state = 0, .external_lex_state = 221},
  [12553] = {.lex_state = 4, .external_lex_state = 155},
  [12554] = {.lex_state = 0, .external_lex_state = 155},
  [12555] = {.lex_state = 0, .external_lex_state = 221},
  [12556] = {.lex_state = 4, .external_lex_state = 155},
  [12557] = {.lex_state = 0, .external_lex_state = 155},
  [12558] = {.lex_state = 0, .external_lex_state = 155},
  [12559] = {.lex_state = 4, .external_lex_state = 155},
  [12560] = {.lex_state = 0, .external_lex_state = 155},
  [12561] = {.lex_state = 0, .external_lex_state = 219},
  [12562] = {.lex_state = 0, .external_lex_state = 221},
  [12563] = {.lex_state = 0, .external_lex_state = 221},
  [12564] = {.lex_state = 0, .external_lex_state = 220},
  [12565] = {.lex_state = 4, .external_lex_state = 155},
  [12566] = {.lex_state = 3, .external_lex_state = 155},
  [12567] = {.lex_state = 0, .external_lex_state = 219},
  [12568] = {.lex_state = 0, .external_lex_state = 221},
  [12569] = {.lex_state = 0, .external_lex_state = 221},
  [12570] = {.lex_state = 0, .external_lex_state = 155},
  [12571] = {.lex_state = 4, .external_lex_state = 155},
  [12572] = {.lex_state = 0, .external_lex_state = 221},
  [12573] = {.lex_state = 0, .external_lex_state = 221},
  [12574] = {.lex_state = 0, .external_lex_state = 221},
  [12575] = {.lex_state = 0, .external_lex_state = 221},
  [12576] = {.lex_state = 4, .external_lex_state = 155},
  [12577] = {.lex_state = 0, .external_lex_state = 221},
  [12578] = {.lex_state = 0, .external_lex_state = 155},
  [12579] = {.lex_state = 0, .external_lex_state = 221},
  [12580] = {.lex_state = 0, .external_lex_state = 155},
  [12581] = {.lex_state = 4, .external_lex_state = 155},
  [12582] = {.lex_state = 0, .external_lex_state = 219},
  [12583] = {.lex_state = 0, .external_lex_state = 219},
  [12584] = {.lex_state = 0, .external_lex_state = 155},
  [12585] = {.lex_state = 0, .external_lex_state = 219},
  [12586] = {.lex_state = 4, .external_lex_state = 155},
  [12587] = {.lex_state = 0, .external_lex_state = 221},
  [12588] = {.lex_state = 0, .external_lex_state = 220},
  [12589] = {.lex_state = 0, .external_lex_state = 221},
  [12590] = {.lex_state = 0, .external_lex_state = 221},
  [12591] = {.lex_state = 4, .external_lex_state = 155},
  [12592] = {.lex_state = 0, .external_lex_state = 221},
  [12593] = {.lex_state = 0, .external_lex_state = 221},
  [12594] = {.lex_state = 3, .external_lex_state = 155},
  [12595] = {.lex_state = 0, .external_lex_state = 221},
  [12596] = {.lex_state = 4, .external_lex_state = 155},
  [12597] = {.lex_state = 0, .external_lex_state = 221},
  [12598] = {.lex_state = 0, .external_lex_state = 221},
  [12599] = {.lex_state = 4, .external_lex_state = 155},
  [12600] = {.lex_state = 0, .external_lex_state = 219},
  [12601] = {.lex_state = 4, .external_lex_state = 155},
  [12602] = {.lex_state = 0, .external_lex_state = 155},
  [12603] = {.lex_state = 4, .external_lex_state = 155},
  [12604] = {.lex_state = 0, .external_lex_state = 221},
  [12605] = {.lex_state = 4, .external_lex_state = 155},
  [12606] = {.lex_state = 0, .external_lex_state = 221},
  [12607] = {.lex_state = 4, .external_lex_state = 155},
  [12608] = {.lex_state = 0, .external_lex_state = 155},
  [12609] = {.lex_state = 4, .external_lex_state = 155},
  [12610] = {.lex_state = 0, .external_lex_state = 155},
  [12611] = {.lex_state = 4, .external_lex_state = 155},
  [12612] = {.lex_state = 0, .external_lex_state = 221},
  [12613] = {.lex_state = 4, .external_lex_state = 155},
  [12614] = {.lex_state = 0, .external_lex_state = 155},
  [12615] = {.lex_state = 4, .external_lex_state = 155},
  [12616] = {.lex_state = 0, .external_lex_state = 221},
  [12617] = {.lex_state = 4, .external_lex_state = 155},
  [12618] = {.lex_state = 0, .external_lex_state = 221},
  [12619] = {.lex_state = 4, .external_lex_state = 155},
  [12620] = {.lex_state = 0, .external_lex_state = 221},
  [12621] = {.lex_state = 4, .external_lex_state = 155},
  [12622] = {.lex_state = 0, .external_lex_state = 220},
  [12623] = {.lex_state = 4, .external_lex_state = 155},
  [12624] = {.lex_state = 0, .external_lex_state = 219},
  [12625] = {.lex_state = 4, .external_lex_state = 155},
  [12626] = {.lex_state = 0, .external_lex_state = 221},
  [12627] = {.lex_state = 4, .external_lex_state = 155},
  [12628] = {.lex_state = 0, .external_lex_state = 219},
  [12629] = {.lex_state = 4, .external_lex_state = 155},
  [12630] = {.lex_state = 3, .external_lex_state = 155},
  [12631] = {.lex_state = 4, .external_lex_state = 155},
  [12632] = {.lex_state = 0, .external_lex_state = 155},
  [12633] = {.lex_state = 4, .external_lex_state = 155},
  [12634] = {.lex_state = 0, .external_lex_state = 155},
  [12635] = {.lex_state = 4, .external_lex_state = 155},
  [12636] = {.lex_state = 0, .external_lex_state = 221},
  [12637] = {.lex_state = 4, .external_lex_state = 155},
  [12638] = {.lex_state = 0, .external_lex_state = 155},
  [12639] = {.lex_state = 4, .external_lex_state = 155},
  [12640] = {.lex_state = 0, .external_lex_state = 221},
  [12641] = {.lex_state = 4, .external_lex_state = 155},
  [12642] = {.lex_state = 0, .external_lex_state = 221},
  [12643] = {.lex_state = 4, .external_lex_state = 155},
  [12644] = {.lex_state = 0, .external_lex_state = 219},
  [12645] = {.lex_state = 4, .external_lex_state = 155},
  [12646] = {.lex_state = 0, .external_lex_state = 221},
  [12647] = {.lex_state = 4, .external_lex_state = 155},
  [12648] = {.lex_state = 0, .external_lex_state = 221},
  [12649] = {.lex_state = 4, .external_lex_state = 155},
  [12650] = {.lex_state = 0, .external_lex_state = 221},
  [12651] = {.lex_state = 4, .external_lex_state = 155},
  [12652] = {.lex_state = 4, .external_lex_state = 155},
  [12653] = {.lex_state = 4, .external_lex_state = 155},
  [12654] = {.lex_state = 0, .external_lex_state = 221},
  [12655] = {.lex_state = 4, .external_lex_state = 155},
  [12656] = {.lex_state = 0, .external_lex_state = 221},
  [12657] = {.lex_state = 4, .external_lex_state = 155},
  [12658] = {.lex_state = 0, .external_lex_state = 220},
  [12659] = {.lex_state = 4, .external_lex_state = 155},
  [12660] = {.lex_state = 0, .external_lex_state = 220},
  [12661] = {.lex_state = 4, .external_lex_state = 155},
  [12662] = {.lex_state = 0, .external_lex_state = 219},
  [12663] = {.lex_state = 4, .external_lex_state = 155},
  [12664] = {.lex_state = 0, .external_lex_state = 221},
  [12665] = {.lex_state = 4, .external_lex_state = 155},
  [12666] = {.lex_state = 4, .external_lex_state = 155},
  [12667] = {.lex_state = 4, .external_lex_state = 155},
  [12668] = {.lex_state = 0, .external_lex_state = 219},
  [12669] = {.lex_state = 4, .external_lex_state = 155},
  [12670] = {.lex_state = 0, .external_lex_state = 221},
  [12671] = {.lex_state = 4, .external_lex_state = 155},
  [12672] = {.lex_state = 0, .external_lex_state = 155},
  [12673] = {.lex_state = 0, .external_lex_state = 218},
  [12674] = {.lex_state = 0, .external_lex_state = 219},
  [12675] = {.lex_state = 0, .external_lex_state = 221},
  [12676] = {.lex_state = 0, .external_lex_state = 222},
  [12677] = {.lex_state = 0, .external_lex_state = 222},
  [12678] = {.lex_state = 0, .external_lex_state = 155},
  [12679] = {.lex_state = 3, .external_lex_state = 155},
  [12680] = {.lex_state = 0, .external_lex_state = 219},
  [12681] = {.lex_state = 0, .external_lex_state = 219},
  [12682] = {.lex_state = 0, .external_lex_state = 221},
  [12683] = {.lex_state = 0, .external_lex_state = 221},
  [12684] = {.lex_state = 0, .external_lex_state = 155},
  [12685] = {.lex_state = 0, .external_lex_state = 222},
  [12686] = {.lex_state = 0, .external_lex_state = 221},
  [12687] = {.lex_state = 0, .external_lex_state = 219},
  [12688] = {.lex_state = 0, .external_lex_state = 221},
  [12689] = {.lex_state = 0, .external_lex_state = 155},
  [12690] = {.lex_state = 0, .external_lex_state = 155},
  [12691] = {.lex_state = 0, .external_lex_state = 155},
  [12692] = {.lex_state = 0, .external_lex_state = 155},
  [12693] = {.lex_state = 0, .external_lex_state = 221},
  [12694] = {.lex_state = 0, .external_lex_state = 219},
  [12695] = {.lex_state = 0, .external_lex_state = 155},
  [12696] = {.lex_state = 0, .external_lex_state = 221},
  [12697] = {.lex_state = 0, .external_lex_state = 155},
  [12698] = {.lex_state = 0, .external_lex_state = 155},
  [12699] = {.lex_state = 0, .external_lex_state = 219},
  [12700] = {.lex_state = 0, .external_lex_state = 219},
  [12701] = {.lex_state = 0, .external_lex_state = 220},
  [12702] = {.lex_state = 0, .external_lex_state = 155},
  [12703] = {.lex_state = 0, .external_lex_state = 220},
  [12704] = {.lex_state = 0, .external_lex_state = 155},
  [12705] = {.lex_state = 0, .external_lex_state = 222},
  [12706] = {.lex_state = 0, .external_lex_state = 222},
  [12707] = {.lex_state = 0, .external_lex_state = 155},
  [12708] = {.lex_state = 0, .external_lex_state = 219},
  [12709] = {.lex_state = 0, .external_lex_state = 219},
  [12710] = {.lex_state = 0, .external_lex_state = 222},
  [12711] = {.lex_state = 0, .external_lex_state = 155},
  [12712] = {.lex_state = 0, .external_lex_state = 155},
  [12713] = {.lex_state = 3, .external_lex_state = 155},
  [12714] = {.lex_state = 0, .external_lex_state = 222},
  [12715] = {.lex_state = 0, .external_lex_state = 222},
  [12716] = {.lex_state = 0, .external_lex_state = 155},
  [12717] = {.lex_state = 0, .external_lex_state = 155},
  [12718] = {.lex_state = 3, .external_lex_state = 155},
  [12719] = {.lex_state = 0, .external_lex_state = 155},
  [12720] = {.lex_state = 0, .external_lex_state = 220},
  [12721] = {.lex_state = 0, .external_lex_state = 222},
  [12722] = {.lex_state = 0, .external_lex_state = 222},
  [12723] = {.lex_state = 0, .external_lex_state = 155},
  [12724] = {.lex_state = 0, .external_lex_state = 155},
  [12725] = {.lex_state = 0, .external_lex_state = 221},
  [12726] = {.lex_state = 0, .external_lex_state = 155},
  [12727] = {.lex_state = 0, .external_lex_state = 221},
  [12728] = {.lex_state = 0, .external_lex_state = 222},
  [12729] = {.lex_state = 0, .external_lex_state = 155},
  [12730] = {.lex_state = 0, .external_lex_state = 155},
  [12731] = {.lex_state = 0, .external_lex_state = 221},
  [12732] = {.lex_state = 0, .external_lex_state = 155},
  [12733] = {.lex_state = 0, .external_lex_state = 220},
  [12734] = {.lex_state = 0, .external_lex_state = 222},
  [12735] = {.lex_state = 0, .external_lex_state = 221},
  [12736] = {.lex_state = 0, .external_lex_state = 219},
  [12737] = {.lex_state = 0, .external_lex_state = 155},
  [12738] = {.lex_state = 0, .external_lex_state = 155},
  [12739] = {.lex_state = 0, .external_lex_state = 219},
  [12740] = {.lex_state = 0, .external_lex_state = 222},
  [12741] = {.lex_state = 0, .external_lex_state = 155},
  [12742] = {.lex_state = 0, .external_lex_state = 221},
  [12743] = {.lex_state = 3, .external_lex_state = 155},
  [12744] = {.lex_state = 0, .external_lex_state = 155},
  [12745] = {.lex_state = 0, .external_lex_state = 221},
  [12746] = {.lex_state = 0, .external_lex_state = 222},
  [12747] = {.lex_state = 0, .external_lex_state = 221},
  [12748] = {.lex_state = 0, .external_lex_state = 221},
  [12749] = {.lex_state = 0, .external_lex_state = 221},
  [12750] = {.lex_state = 0, .external_lex_state = 155},
  [12751] = {.lex_state = 0, .external_lex_state = 221},
  [12752] = {.lex_state = 0, .external_lex_state = 222},
  [12753] = {.lex_state = 0, .external_lex_state = 155},
  [12754] = {.lex_state = 0, .external_lex_state = 155},
  [12755] = {.lex_state = 0, .external_lex_state = 155},
  [12756] = {.lex_state = 0, .external_lex_state = 155},
  [12757] = {.lex_state = 0, .external_lex_state = 218},
  [12758] = {.lex_state = 0, .external_lex_state = 155},
  [12759] = {.lex_state = 0, .external_lex_state = 221},
  [12760] = {.lex_state = 0, .external_lex_state = 155},
  [12761] = {.lex_state = 0, .external_lex_state = 221},
  [12762] = {.lex_state = 0, .external_lex_state = 155},
  [12763] = {.lex_state = 0, .external_lex_state = 221},
  [12764] = {.lex_state = 0, .external_lex_state = 155},
  [12765] = {.lex_state = 0, .external_lex_state = 221},
  [12766] = {.lex_state = 0, .external_lex_state = 155},
  [12767] = {.lex_state = 0, .external_lex_state = 221},
  [12768] = {.lex_state = 0, .external_lex_state = 155},
  [12769] = {.lex_state = 0, .external_lex_state = 155},
  [12770] = {.lex_state = 0, .external_lex_state = 155},
  [12771] = {.lex_state = 0, .external_lex_state = 155},
  [12772] = {.lex_state = 0, .external_lex_state = 221},
  [12773] = {.lex_state = 0, .external_lex_state = 203},
  [12774] = {.lex_state = 0, .external_lex_state = 203},
  [12775] = {.lex_state = 0, .external_lex_state = 155},
  [12776] = {.lex_state = 0, .external_lex_state = 221},
  [12777] = {.lex_state = 0, .external_lex_state = 221},
  [12778] = {.lex_state = 0, .external_lex_state = 155},
  [12779] = {.lex_state = 0, .external_lex_state = 155},
  [12780] = {.lex_state = 0, .external_lex_state = 221},
  [12781] = {.lex_state = 0, .external_lex_state = 221},
  [12782] = {.lex_state = 0, .external_lex_state = 221},
  [12783] = {.lex_state = 0, .external_lex_state = 221},
  [12784] = {.lex_state = 0, .external_lex_state = 221},
  [12785] = {.lex_state = 0, .external_lex_state = 221},
  [12786] = {.lex_state = 3, .external_lex_state = 155},
  [12787] = {.lex_state = 0, .external_lex_state = 221},
  [12788] = {.lex_state = 0, .external_lex_state = 155},
  [12789] = {.lex_state = 0, .external_lex_state = 155},
  [12790] = {.lex_state = 0, .external_lex_state = 222},
  [12791] = {.lex_state = 0, .external_lex_state = 155},
  [12792] = {.lex_state = 0, .external_lex_state = 155},
  [12793] = {.lex_state = 0, .external_lex_state = 221},
  [12794] = {.lex_state = 0, .external_lex_state = 221},
  [12795] = {.lex_state = 0, .external_lex_state = 155},
  [12796] = {.lex_state = 0, .external_lex_state = 155},
  [12797] = {.lex_state = 0, .external_lex_state = 221},
  [12798] = {.lex_state = 0, .external_lex_state = 221},
  [12799] = {.lex_state = 0, .external_lex_state = 221},
  [12800] = {.lex_state = 0, .external_lex_state = 203},
  [12801] = {.lex_state = 0, .external_lex_state = 155},
  [12802] = {.lex_state = 0, .external_lex_state = 220},
  [12803] = {.lex_state = 0, .external_lex_state = 221},
  [12804] = {.lex_state = 0, .external_lex_state = 221},
  [12805] = {.lex_state = 3, .external_lex_state = 155},
  [12806] = {.lex_state = 0, .external_lex_state = 155},
  [12807] = {.lex_state = 0, .external_lex_state = 155},
  [12808] = {.lex_state = 0, .external_lex_state = 155},
  [12809] = {.lex_state = 0, .external_lex_state = 221},
  [12810] = {.lex_state = 0, .external_lex_state = 155},
  [12811] = {.lex_state = 0, .external_lex_state = 155},
  [12812] = {.lex_state = 0, .external_lex_state = 155},
  [12813] = {.lex_state = 0, .external_lex_state = 155},
  [12814] = {.lex_state = 0, .external_lex_state = 155},
  [12815] = {.lex_state = 0, .external_lex_state = 155},
  [12816] = {.lex_state = 0, .external_lex_state = 155},
  [12817] = {.lex_state = 0, .external_lex_state = 155},
  [12818] = {.lex_state = 0, .external_lex_state = 155},
  [12819] = {.lex_state = 0, .external_lex_state = 155},
  [12820] = {.lex_state = 0, .external_lex_state = 155},
  [12821] = {.lex_state = 0, .external_lex_state = 155},
  [12822] = {.lex_state = 0, .external_lex_state = 155},
  [12823] = {.lex_state = 0, .external_lex_state = 155},
  [12824] = {.lex_state = 0, .external_lex_state = 155},
  [12825] = {.lex_state = 0, .external_lex_state = 155},
  [12826] = {.lex_state = 0, .external_lex_state = 155},
  [12827] = {.lex_state = 0, .external_lex_state = 155},
  [12828] = {.lex_state = 0, .external_lex_state = 155},
  [12829] = {.lex_state = 0, .external_lex_state = 155},
  [12830] = {.lex_state = 0, .external_lex_state = 155},
  [12831] = {.lex_state = 0, .external_lex_state = 155},
  [12832] = {.lex_state = 0, .external_lex_state = 155},
  [12833] = {.lex_state = 0, .external_lex_state = 155},
  [12834] = {.lex_state = 0, .external_lex_state = 155},
  [12835] = {.lex_state = 0, .external_lex_state = 155},
  [12836] = {.lex_state = 0, .external_lex_state = 155},
  [12837] = {.lex_state = 0, .external_lex_state = 155},
  [12838] = {.lex_state = 0, .external_lex_state = 155},
  [12839] = {.lex_state = 0, .external_lex_state = 155},
  [12840] = {.lex_state = 0, .external_lex_state = 155},
  [12841] = {.lex_state = 0, .external_lex_state = 155},
  [12842] = {.lex_state = 0, .external_lex_state = 155},
  [12843] = {.lex_state = 0, .external_lex_state = 155},
  [12844] = {.lex_state = 0, .external_lex_state = 155},
  [12845] = {.lex_state = 0, .external_lex_state = 155},
  [12846] = {.lex_state = 0, .external_lex_state = 155},
  [12847] = {.lex_state = 0, .external_lex_state = 155},
  [12848] = {.lex_state = 0, .external_lex_state = 155},
  [12849] = {.lex_state = 0, .external_lex_state = 155},
  [12850] = {.lex_state = 0, .external_lex_state = 155},
  [12851] = {.lex_state = 0, .external_lex_state = 155},
  [12852] = {.lex_state = 0, .external_lex_state = 155},
  [12853] = {.lex_state = 0, .external_lex_state = 155},
  [12854] = {.lex_state = 0, .external_lex_state = 155},
  [12855] = {.lex_state = 0, .external_lex_state = 155},
  [12856] = {.lex_state = 0, .external_lex_state = 155},
  [12857] = {.lex_state = 0, .external_lex_state = 155},
  [12858] = {.lex_state = 0, .external_lex_state = 155},
  [12859] = {.lex_state = 0, .external_lex_state = 155},
  [12860] = {.lex_state = 0, .external_lex_state = 155},
  [12861] = {.lex_state = 0, .external_lex_state = 155},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_variable] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_u2605] = ACTIONS(1),
    [anon_sym_forall] = ACTIONS(1),
    [anon_sym_u2200] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_instance] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_family] = ACTIONS(1),
    [anon_sym_representational] = ACTIONS(1),
    [anon_sym_nominal] = ACTIONS(1),
    [anon_sym_phantom] = ACTIONS(1),
    [anon_sym_role] = ACTIONS(1),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_group] = ACTIONS(1),
    [anon_sym_by] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_rec] = ACTIONS(1),
    [anon_sym_mdo] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_cases] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_pattern] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_qualified] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_hiding] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_via] = ACTIONS(1),
    [anon_sym_stock] = ACTIONS(1),
    [anon_sym_newtype] = ACTIONS(1),
    [anon_sym_anyclass] = ACTIONS(1),
    [anon_sym_deriving] = ACTIONS(1),
    [anon_sym_data] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_1] = ACTIONS(1),
    [anon_sym_infixr] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_infixl] = ACTIONS(1),
    [anon_sym_infix] = ACTIONS(1),
    [sym_safety] = ACTIONS(1),
    [anon_sym_foreign] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1),
    [anon_sym_u27e7] = ACTIONS(1),
    [anon_sym_u27e6] = ACTIONS(1),
    [anon_sym_e] = ACTIONS(1),
    [anon_sym_t] = ACTIONS(1),
    [anon_sym_p] = ACTIONS(1),
    [anon_sym_d] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [sym_char] = ACTIONS(1),
    [sym_string] = ACTIONS(1),
    [sym__integer_literal] = ACTIONS(1),
    [sym__binary_literal] = ACTIONS(1),
    [sym__octal_literal] = ACTIONS(1),
    [sym__hex_literal] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_POUND2] = ACTIONS(1),
    [anon_sym_PIPE2] = ACTIONS(1),
    [sym_implicit_variable] = ACTIONS(1),
    [sym_name] = ACTIONS(1),
    [sym_label] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_u21d2] = ACTIONS(1),
    [anon_sym_u2192] = ACTIONS(1),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1),
    [anon_sym_u22b8] = ACTIONS(1),
    [anon_sym_LT_DASH] = ACTIONS(1),
    [anon_sym_u2190] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_u2237] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [aux_sym__paren_open_token1] = ACTIONS(1),
    [aux_sym__paren_close_token1] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_POUND_RPAREN] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [aux_sym__token1] = ACTIONS(3),
    [sym_error_sentinel] = ACTIONS(1),
    [sym__cond_layout_semicolon] = ACTIONS(1),
    [sym__cmd_layout_start] = ACTIONS(1),
    [sym__cmd_layout_start_do] = ACTIONS(1),
    [sym__cmd_layout_start_case] = ACTIONS(1),
    [sym__cmd_layout_start_if] = ACTIONS(1),
    [sym__cmd_layout_start_let] = ACTIONS(1),
    [sym__cmd_layout_start_quote] = ACTIONS(1),
    [sym__cmd_layout_start_explicit] = ACTIONS(1),
    [sym__cond_layout_end] = ACTIONS(1),
    [sym__cond_layout_end_explicit] = ACTIONS(1),
    [sym__cmd_brace_open] = ACTIONS(1),
    [sym__cmd_brace_close] = ACTIONS(1),
    [sym__cmd_texp_start] = ACTIONS(1),
    [sym__cmd_texp_end] = ACTIONS(1),
    [sym__phantom_where] = ACTIONS(1),
    [sym__phantom_in] = ACTIONS(1),
    [sym__phantom_arrow] = ACTIONS(1),
    [sym__phantom_bar] = ACTIONS(1),
    [sym__phantom_deriving] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1),
    [sym_quasiquote_body] = ACTIONS(1),
    [sym__cond_splice] = ACTIONS(1),
    [sym__cond_qual_dot] = ACTIONS(1),
    [sym__cond_tight_dot] = ACTIONS(1),
    [sym__cond_prefix_dot] = ACTIONS(1),
    [sym__cond_dotdot] = ACTIONS(1),
    [sym__cond_tight_at] = ACTIONS(1),
    [sym__cond_prefix_at] = ACTIONS(1),
    [sym__cond_tight_bang] = ACTIONS(1),
    [sym__cond_prefix_bang] = ACTIONS(1),
    [sym__cond_tight_tilde] = ACTIONS(1),
    [sym__cond_prefix_tilde] = ACTIONS(1),
    [sym__cond_prefix_percent] = ACTIONS(1),
    [sym__cond_qualified_op] = ACTIONS(1),
    [sym__cond_left_section_op] = ACTIONS(1),
    [sym__cond_no_section_op] = ACTIONS(1),
    [sym__cond_minus] = ACTIONS(1),
    [sym__cond_context] = ACTIONS(1),
    [sym__cond_infix] = ACTIONS(1),
    [sym__cond_data_infix] = ACTIONS(1),
    [sym__cond_assoc_tyinst] = ACTIONS(1),
    [sym__varsym] = ACTIONS(1),
    [sym__consym] = ACTIONS(1),
  },
  [1] = {
    [sym_haskell] = STATE(12729),
    [sym_header] = STATE(10060),
    [sym__body] = STATE(12723),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_module] = ACTIONS(7),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cmd_layout_start] = ACTIONS(9),
    [sym__cmd_layout_start_explicit] = ACTIONS(9),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
  },
  [2] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym_import] = STATE(10077),
    [sym_imports] = STATE(16),
    [sym_declarations] = STATE(10938),
    [sym__layout_end] = STATE(12614),
    [sym_declaration] = STATE(9597),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [aux_sym__let_binds_repeat1] = STATE(3),
    [sym_variable] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(75),
    [sym__cond_layout_end] = ACTIONS(77),
    [sym__cond_layout_end_explicit] = ACTIONS(77),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [3] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym_import] = STATE(10077),
    [sym_imports] = STATE(14),
    [sym_declarations] = STATE(10951),
    [sym__layout_end] = STATE(12570),
    [sym_declaration] = STATE(9597),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [aux_sym__let_binds_repeat1] = STATE(4174),
    [sym_variable] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(95),
    [sym__cond_layout_end_explicit] = ACTIONS(95),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [4] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym_import] = STATE(10077),
    [sym_imports] = STATE(14),
    [sym_declarations] = STATE(10951),
    [sym__layout_end] = STATE(12570),
    [sym_declaration] = STATE(9597),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [sym_variable] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(39),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(95),
    [sym__cond_layout_end_explicit] = ACTIONS(95),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [5] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym_import] = STATE(10719),
    [sym_declaration] = STATE(10719),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [aux_sym__let_binds_repeat1] = STATE(4174),
    [sym_variable] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(97),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(99),
    [sym__cond_layout_end_explicit] = ACTIONS(99),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [6] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym__layout_end] = STATE(11876),
    [sym_declaration] = STATE(9195),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [aux_sym__let_binds_repeat1] = STATE(21),
    [sym_variable] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(103),
    [sym__cond_layout_end] = ACTIONS(105),
    [sym__cond_layout_end_explicit] = ACTIONS(105),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [7] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym_import] = STATE(10719),
    [sym_declaration] = STATE(10719),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [aux_sym__let_binds_repeat1] = STATE(4174),
    [sym_variable] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(97),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(107),
    [sym__cond_layout_end_explicit] = ACTIONS(107),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [8] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym__layout_end] = STATE(12192),
    [sym_declaration] = STATE(10635),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [aux_sym__let_binds_repeat1] = STATE(4174),
    [sym_variable] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(109),
    [sym__cond_layout_end_explicit] = ACTIONS(109),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [9] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym__layout_end] = STATE(11705),
    [sym_declaration] = STATE(10635),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [aux_sym__let_binds_repeat1] = STATE(4174),
    [sym_variable] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(111),
    [sym__cond_layout_end_explicit] = ACTIONS(111),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [10] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym__layout_end] = STATE(11691),
    [sym_declaration] = STATE(10635),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [aux_sym__let_binds_repeat1] = STATE(4174),
    [sym_variable] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(113),
    [sym__cond_layout_end_explicit] = ACTIONS(113),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [11] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym__layout_end] = STATE(11345),
    [sym_declaration] = STATE(10635),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [aux_sym__let_binds_repeat1] = STATE(4174),
    [sym_variable] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(115),
    [sym__cond_layout_end_explicit] = ACTIONS(115),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [12] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym_import] = STATE(10719),
    [sym_declaration] = STATE(10719),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [aux_sym__let_binds_repeat1] = STATE(4650),
    [sym_variable] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(97),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [13] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym_import] = STATE(10719),
    [sym_declaration] = STATE(10719),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [sym_variable] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(97),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(99),
    [sym__cond_layout_end_explicit] = ACTIONS(99),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [14] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym_declarations] = STATE(11103),
    [sym__layout_end] = STATE(12538),
    [sym_declaration] = STATE(9597),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [sym_variable] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(119),
    [sym__cond_layout_end_explicit] = ACTIONS(119),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [15] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym_import] = STATE(10719),
    [sym_declaration] = STATE(10719),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [sym_variable] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(97),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(107),
    [sym__cond_layout_end_explicit] = ACTIONS(107),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [16] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym_declarations] = STATE(11077),
    [sym__layout_end] = STATE(12276),
    [sym_declaration] = STATE(9597),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [sym_variable] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(121),
    [sym__cond_layout_end_explicit] = ACTIONS(121),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [17] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym__layout_end] = STATE(12190),
    [sym_declaration] = STATE(10635),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [sym_variable] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(123),
    [sym__cond_layout_end_explicit] = ACTIONS(123),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [18] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym__layout_end] = STATE(11345),
    [sym_declaration] = STATE(10635),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [sym_variable] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(115),
    [sym__cond_layout_end_explicit] = ACTIONS(115),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [19] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym__layout_end] = STATE(11691),
    [sym_declaration] = STATE(10635),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [sym_variable] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(113),
    [sym__cond_layout_end_explicit] = ACTIONS(113),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [20] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym__layout_end] = STATE(11702),
    [sym_declaration] = STATE(10635),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [sym_variable] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(125),
    [sym__cond_layout_end_explicit] = ACTIONS(125),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [21] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym_declaration] = STATE(9304),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [aux_sym__let_binds_repeat1] = STATE(4650),
    [sym_variable] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [22] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym_declaration] = STATE(10635),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [aux_sym__let_binds_repeat1] = STATE(4650),
    [sym_variable] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [23] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym_import] = STATE(10719),
    [sym_declaration] = STATE(10719),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [sym_variable] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_import] = ACTIONS(97),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [24] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym_declaration] = STATE(9304),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [sym_variable] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [25] = {
    [sym_type_synomym] = STATE(10069),
    [sym_kind_signature] = STATE(10069),
    [sym_type_instance] = STATE(10069),
    [sym_type_family] = STATE(10069),
    [sym_role_annotation] = STATE(10069),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(368),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9405),
    [sym_declaration] = STATE(10635),
    [sym_data_type] = STATE(10069),
    [sym_newtype] = STATE(10069),
    [sym_data_family] = STATE(10069),
    [sym_decl_inst_adt] = STATE(10079),
    [sym_decl_inst_newtype] = STATE(10079),
    [sym_data_instance] = STATE(10069),
    [sym_class] = STATE(10069),
    [sym__instance] = STATE(9450),
    [sym_instance] = STATE(10069),
    [sym_deriving_instance] = STATE(10069),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10069),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10069),
    [sym_foreign_import] = STATE(10069),
    [sym_foreign_export] = STATE(10069),
    [sym_default_types] = STATE(10069),
    [sym_pattern_synonym] = STATE(10069),
    [sym__splice_dollars] = STATE(7474),
    [sym_splice] = STATE(3228),
    [sym_top_splice] = STATE(10069),
    [sym_quasiquote] = STATE(3228),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3242),
    [sym__plist] = STATE(3229),
    [sym_unit] = STATE(3228),
    [sym_unboxed_unit] = STATE(3228),
    [sym_prefix_tuple] = STATE(3228),
    [sym_prefix_unboxed_tuple] = STATE(3228),
    [sym_prefix_unboxed_sum] = STATE(3228),
    [sym_literal] = STATE(3228),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3234),
    [sym__qconid] = STATE(3228),
    [sym__varsym_prefix] = STATE(2317),
    [sym__pvarsym] = STATE(2317),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3235),
    [sym__pconsym] = STATE(3235),
    [sym__qconsym_prefix] = STATE(3228),
    [sym__pqconsym] = STATE(3228),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(28),
    [sym__bracket_open] = STATE(357),
    [sym__unboxed_open] = STATE(186),
    [sym_variable] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_instance] = ACTIONS(23),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(35),
    [anon_sym_pattern] = ACTIONS(37),
    [anon_sym_newtype] = ACTIONS(41),
    [anon_sym_deriving] = ACTIONS(43),
    [anon_sym_data] = ACTIONS(45),
    [anon_sym_default] = ACTIONS(47),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_foreign] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(61),
    [sym_char] = ACTIONS(61),
    [sym_string] = ACTIONS(61),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(67),
    [sym_name] = ACTIONS(69),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_deriving] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(81),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [26] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11853),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(218),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9600),
    [sym__pat_parens] = STATE(6709),
    [sym__pat_tuple_elems] = STATE(11330),
    [sym__pat_tuple] = STATE(6707),
    [sym__pat_unboxed_tuple] = STATE(6706),
    [sym__pat_unboxed_sum] = STATE(6705),
    [sym__pat_list] = STATE(6704),
    [sym__pat_record] = STATE(6703),
    [sym__pat_as] = STATE(6702),
    [sym__pat_wildcard] = STATE(6701),
    [sym__pat_strict] = STATE(6700),
    [sym__pat_irrefutable] = STATE(6699),
    [sym__pat_apply] = STATE(6772),
    [sym__pat_negation] = STATE(6711),
    [sym__pat_infix] = STATE(6715),
    [sym_pattern] = STATE(939),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10620),
    [sym_view_pattern] = STATE(10620),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8228),
    [sym__function_name] = STATE(2089),
    [sym_function_head_parens] = STATE(2091),
    [sym__function_head_infix] = STATE(12219),
    [sym__splice_dollars] = STATE(7430),
    [sym_splice] = STATE(3713),
    [sym_quasiquote] = STATE(3713),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(3690),
    [sym__plist] = STATE(3714),
    [sym_unit] = STATE(3713),
    [sym_unboxed_unit] = STATE(3713),
    [sym_prefix_tuple] = STATE(3713),
    [sym_prefix_unboxed_tuple] = STATE(3713),
    [sym_prefix_unboxed_sum] = STATE(3713),
    [sym_literal] = STATE(3713),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1476),
    [sym__qvariable_ticked] = STATE(1476),
    [sym__qualified_constructor] = STATE(3685),
    [sym__qconid] = STATE(3713),
    [sym__constructor_ticked] = STATE(1476),
    [sym__qconstructor_ticked] = STATE(1476),
    [sym__ops] = STATE(1476),
    [sym__operator_qual_dot_head] = STATE(1302),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7803),
    [sym__operator_minus] = STATE(11805),
    [sym__varsym_prefix] = STATE(3776),
    [sym__pvarsym] = STATE(3776),
    [sym__qualified_varsym] = STATE(7831),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7823),
    [sym__consym_prefix] = STATE(3719),
    [sym__pconsym] = STATE(3719),
    [sym__qualified_consym] = STATE(7794),
    [sym__qconsym_prefix] = STATE(3713),
    [sym__pqconsym] = STATE(3713),
    [sym__qual_dot] = STATE(12250),
    [sym__prefix_dot] = STATE(12250),
    [sym__prefix_bang] = STATE(2257),
    [sym__tight_bang] = STATE(2257),
    [sym__any_prefix_bang] = STATE(2257),
    [sym__prefix_tilde] = STATE(2258),
    [sym__tight_tilde] = STATE(2258),
    [sym__any_prefix_tilde] = STATE(2258),
    [sym__paren_open] = STATE(26),
    [sym__paren_close] = STATE(3737),
    [sym__bracket_open] = STATE(355),
    [sym__unboxed_open] = STATE(205),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(908),
    [sym_variable] = ACTIONS(127),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym__] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(153),
    [sym_char] = ACTIONS(153),
    [sym_string] = ACTIONS(153),
    [sym__integer_literal] = ACTIONS(155),
    [sym__binary_literal] = ACTIONS(157),
    [sym__octal_literal] = ACTIONS(157),
    [sym__hex_literal] = ACTIONS(157),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(163),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(167),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(169),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(171),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [27] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11559),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(231),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9679),
    [sym__pat_parens] = STATE(6709),
    [sym__pat_tuple_elems] = STATE(11330),
    [sym__pat_tuple] = STATE(6707),
    [sym__pat_unboxed_tuple] = STATE(6706),
    [sym__pat_unboxed_sum] = STATE(6705),
    [sym__pat_list] = STATE(6704),
    [sym__pat_record] = STATE(6703),
    [sym__pat_as] = STATE(6702),
    [sym__pat_wildcard] = STATE(6701),
    [sym__pat_strict] = STATE(6700),
    [sym__pat_irrefutable] = STATE(6699),
    [sym__pat_apply] = STATE(6772),
    [sym__pat_negation] = STATE(6711),
    [sym__pat_infix] = STATE(6715),
    [sym_pattern] = STATE(939),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10620),
    [sym_view_pattern] = STATE(10620),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8228),
    [sym__function_name] = STATE(2089),
    [sym_function_head_parens] = STATE(2091),
    [sym__function_head_infix] = STATE(12219),
    [sym__splice_dollars] = STATE(7430),
    [sym_splice] = STATE(3713),
    [sym_quasiquote] = STATE(3713),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(3690),
    [sym__plist] = STATE(3714),
    [sym_unit] = STATE(3713),
    [sym_unboxed_unit] = STATE(3713),
    [sym_prefix_tuple] = STATE(3713),
    [sym_prefix_unboxed_tuple] = STATE(3713),
    [sym_prefix_unboxed_sum] = STATE(3713),
    [sym_literal] = STATE(3713),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1527),
    [sym__qvariable_ticked] = STATE(1527),
    [sym__qualified_constructor] = STATE(3685),
    [sym__qconid] = STATE(3713),
    [sym__constructor_ticked] = STATE(1527),
    [sym__qconstructor_ticked] = STATE(1527),
    [sym__ops] = STATE(1527),
    [sym__operator_qual_dot_head] = STATE(1260),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7813),
    [sym__operator_minus] = STATE(11574),
    [sym__varsym_prefix] = STATE(3776),
    [sym__pvarsym] = STATE(3776),
    [sym__qualified_varsym] = STATE(7799),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7808),
    [sym__consym_prefix] = STATE(3719),
    [sym__pconsym] = STATE(3719),
    [sym__qualified_consym] = STATE(7807),
    [sym__qconsym_prefix] = STATE(3713),
    [sym__pqconsym] = STATE(3713),
    [sym__qual_dot] = STATE(12278),
    [sym__prefix_dot] = STATE(12278),
    [sym__prefix_bang] = STATE(2257),
    [sym__tight_bang] = STATE(2257),
    [sym__any_prefix_bang] = STATE(2257),
    [sym__prefix_tilde] = STATE(2258),
    [sym__tight_tilde] = STATE(2258),
    [sym__any_prefix_tilde] = STATE(2258),
    [sym__paren_open] = STATE(26),
    [sym__paren_close] = STATE(2923),
    [sym__bracket_open] = STATE(355),
    [sym__unboxed_open] = STATE(205),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(896),
    [sym_variable] = ACTIONS(127),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym__] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(153),
    [sym_char] = ACTIONS(153),
    [sym_string] = ACTIONS(153),
    [sym__integer_literal] = ACTIONS(155),
    [sym__binary_literal] = ACTIONS(157),
    [sym__octal_literal] = ACTIONS(157),
    [sym__hex_literal] = ACTIONS(157),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(163),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(167),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(171),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [28] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(12191),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(223),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9572),
    [sym__pat_parens] = STATE(6709),
    [sym__pat_tuple_elems] = STATE(12199),
    [sym__pat_tuple] = STATE(6707),
    [sym__pat_unboxed_tuple] = STATE(6706),
    [sym__pat_unboxed_sum] = STATE(6705),
    [sym__pat_list] = STATE(6704),
    [sym__pat_record] = STATE(6703),
    [sym__pat_as] = STATE(6702),
    [sym__pat_wildcard] = STATE(6701),
    [sym__pat_strict] = STATE(6700),
    [sym__pat_irrefutable] = STATE(6699),
    [sym__pat_apply] = STATE(6772),
    [sym__pat_negation] = STATE(6711),
    [sym__pat_infix] = STATE(6715),
    [sym_pattern] = STATE(939),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10257),
    [sym_view_pattern] = STATE(10257),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8228),
    [sym__function_name] = STATE(2089),
    [sym_function_head_parens] = STATE(2091),
    [sym__function_head_infix] = STATE(12219),
    [sym__splice_dollars] = STATE(7430),
    [sym_splice] = STATE(3713),
    [sym_quasiquote] = STATE(3713),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(3690),
    [sym__plist] = STATE(3714),
    [sym_unit] = STATE(3713),
    [sym_unboxed_unit] = STATE(3713),
    [sym_prefix_tuple] = STATE(3713),
    [sym_prefix_unboxed_tuple] = STATE(3713),
    [sym_prefix_unboxed_sum] = STATE(3713),
    [sym_literal] = STATE(3713),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1481),
    [sym__qvariable_ticked] = STATE(1481),
    [sym__qualified_constructor] = STATE(3685),
    [sym__qconid] = STATE(3713),
    [sym__constructor_ticked] = STATE(1481),
    [sym__qconstructor_ticked] = STATE(1481),
    [sym__ops] = STATE(1481),
    [sym__operator_qual_dot_head] = STATE(1197),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7822),
    [sym__operator_minus] = STATE(12205),
    [sym__varsym_prefix] = STATE(3776),
    [sym__pvarsym] = STATE(3776),
    [sym__qualified_varsym] = STATE(7818),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7817),
    [sym__consym_prefix] = STATE(3719),
    [sym__pconsym] = STATE(3719),
    [sym__qualified_consym] = STATE(7814),
    [sym__qconsym_prefix] = STATE(3713),
    [sym__pqconsym] = STATE(3713),
    [sym__qual_dot] = STATE(12236),
    [sym__prefix_dot] = STATE(12236),
    [sym__prefix_bang] = STATE(2257),
    [sym__tight_bang] = STATE(2257),
    [sym__any_prefix_bang] = STATE(2257),
    [sym__prefix_tilde] = STATE(2258),
    [sym__tight_tilde] = STATE(2258),
    [sym__any_prefix_tilde] = STATE(2258),
    [sym__paren_open] = STATE(26),
    [sym__paren_close] = STATE(3272),
    [sym__bracket_open] = STATE(355),
    [sym__unboxed_open] = STATE(205),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(901),
    [sym_variable] = ACTIONS(127),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym__] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(153),
    [sym_char] = ACTIONS(153),
    [sym_string] = ACTIONS(153),
    [sym__integer_literal] = ACTIONS(155),
    [sym__binary_literal] = ACTIONS(157),
    [sym__octal_literal] = ACTIONS(157),
    [sym__hex_literal] = ACTIONS(157),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(163),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(167),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(185),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(171),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [29] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(12104),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(209),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9541),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple_elems] = STATE(11563),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10074),
    [sym_view_pattern] = STATE(10074),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8228),
    [sym__splice_dollars] = STATE(7430),
    [sym_splice] = STATE(3708),
    [sym_quasiquote] = STATE(3708),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(3690),
    [sym__plist] = STATE(3706),
    [sym_unit] = STATE(3708),
    [sym_unboxed_unit] = STATE(3708),
    [sym_prefix_tuple] = STATE(3708),
    [sym_prefix_unboxed_tuple] = STATE(3708),
    [sym_prefix_unboxed_sum] = STATE(3708),
    [sym_literal] = STATE(3708),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1424),
    [sym__qvariable_ticked] = STATE(1424),
    [sym__qualified_constructor] = STATE(3685),
    [sym__qconid] = STATE(3708),
    [sym__constructor_ticked] = STATE(1424),
    [sym__qconstructor_ticked] = STATE(1424),
    [sym__ops] = STATE(1424),
    [sym__operator_qual_dot_head] = STATE(1343),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7800),
    [sym__operator_minus] = STATE(11952),
    [sym__varsym_prefix] = STATE(3795),
    [sym__pvarsym] = STATE(3795),
    [sym__qualified_varsym] = STATE(7839),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7805),
    [sym__consym_prefix] = STATE(3705),
    [sym__pconsym] = STATE(3705),
    [sym__qualified_consym] = STATE(7806),
    [sym__qconsym_prefix] = STATE(3708),
    [sym__pqconsym] = STATE(3708),
    [sym__qual_dot] = STATE(12438),
    [sym__prefix_dot] = STATE(12438),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(33),
    [sym__paren_close] = STATE(3573),
    [sym__bracket_open] = STATE(371),
    [sym__unboxed_open] = STATE(189),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(913),
    [sym_variable] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(153),
    [sym_char] = ACTIONS(153),
    [sym_string] = ACTIONS(153),
    [sym__integer_literal] = ACTIONS(155),
    [sym__binary_literal] = ACTIONS(157),
    [sym__octal_literal] = ACTIONS(157),
    [sym__hex_literal] = ACTIONS(157),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(163),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(195),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(197),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(171),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [30] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(12191),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(223),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9572),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple_elems] = STATE(11563),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10074),
    [sym_view_pattern] = STATE(10074),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8228),
    [sym__splice_dollars] = STATE(7430),
    [sym_splice] = STATE(3708),
    [sym_quasiquote] = STATE(3708),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(3690),
    [sym__plist] = STATE(3706),
    [sym_unit] = STATE(3708),
    [sym_unboxed_unit] = STATE(3708),
    [sym_prefix_tuple] = STATE(3708),
    [sym_prefix_unboxed_tuple] = STATE(3708),
    [sym_prefix_unboxed_sum] = STATE(3708),
    [sym_literal] = STATE(3708),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1481),
    [sym__qvariable_ticked] = STATE(1481),
    [sym__qualified_constructor] = STATE(3685),
    [sym__qconid] = STATE(3708),
    [sym__constructor_ticked] = STATE(1481),
    [sym__qconstructor_ticked] = STATE(1481),
    [sym__ops] = STATE(1481),
    [sym__operator_qual_dot_head] = STATE(1281),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7810),
    [sym__operator_minus] = STATE(11435),
    [sym__varsym_prefix] = STATE(3795),
    [sym__pvarsym] = STATE(3795),
    [sym__qualified_varsym] = STATE(7818),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7853),
    [sym__consym_prefix] = STATE(3705),
    [sym__pconsym] = STATE(3705),
    [sym__qualified_consym] = STATE(7847),
    [sym__qconsym_prefix] = STATE(3708),
    [sym__pqconsym] = STATE(3708),
    [sym__qual_dot] = STATE(12236),
    [sym__prefix_dot] = STATE(12236),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(33),
    [sym__paren_close] = STATE(3609),
    [sym__bracket_open] = STATE(371),
    [sym__unboxed_open] = STATE(189),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(922),
    [sym_variable] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(199),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(153),
    [sym_char] = ACTIONS(153),
    [sym_string] = ACTIONS(153),
    [sym__integer_literal] = ACTIONS(155),
    [sym__binary_literal] = ACTIONS(157),
    [sym__octal_literal] = ACTIONS(157),
    [sym__hex_literal] = ACTIONS(157),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(163),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(195),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(201),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(171),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [31] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11722),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(214),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9632),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple_elems] = STATE(11563),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10074),
    [sym_view_pattern] = STATE(10074),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8228),
    [sym__splice_dollars] = STATE(7430),
    [sym_splice] = STATE(3708),
    [sym_quasiquote] = STATE(3708),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(3690),
    [sym__plist] = STATE(3706),
    [sym_unit] = STATE(3708),
    [sym_unboxed_unit] = STATE(3708),
    [sym_prefix_tuple] = STATE(3708),
    [sym_prefix_unboxed_tuple] = STATE(3708),
    [sym_prefix_unboxed_sum] = STATE(3708),
    [sym_literal] = STATE(3708),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1443),
    [sym__qvariable_ticked] = STATE(1443),
    [sym__qualified_constructor] = STATE(3685),
    [sym__qconid] = STATE(3708),
    [sym__constructor_ticked] = STATE(1443),
    [sym__qconstructor_ticked] = STATE(1443),
    [sym__ops] = STATE(1443),
    [sym__operator_qual_dot_head] = STATE(1328),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7859),
    [sym__operator_minus] = STATE(11620),
    [sym__varsym_prefix] = STATE(3795),
    [sym__pvarsym] = STATE(3795),
    [sym__qualified_varsym] = STATE(7815),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7861),
    [sym__consym_prefix] = STATE(3705),
    [sym__pconsym] = STATE(3705),
    [sym__qualified_consym] = STATE(7858),
    [sym__qconsym_prefix] = STATE(3708),
    [sym__pqconsym] = STATE(3708),
    [sym__qual_dot] = STATE(12340),
    [sym__prefix_dot] = STATE(12340),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(33),
    [sym__paren_close] = STATE(3600),
    [sym__bracket_open] = STATE(371),
    [sym__unboxed_open] = STATE(189),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(872),
    [sym_variable] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(203),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(153),
    [sym_char] = ACTIONS(153),
    [sym_string] = ACTIONS(153),
    [sym__integer_literal] = ACTIONS(155),
    [sym__binary_literal] = ACTIONS(157),
    [sym__octal_literal] = ACTIONS(157),
    [sym__hex_literal] = ACTIONS(157),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(163),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(195),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(205),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(171),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [32] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11382),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(215),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9687),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple_elems] = STATE(11563),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10074),
    [sym_view_pattern] = STATE(10074),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8228),
    [sym__splice_dollars] = STATE(7430),
    [sym_splice] = STATE(3708),
    [sym_quasiquote] = STATE(3708),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(3690),
    [sym__plist] = STATE(3706),
    [sym_unit] = STATE(3708),
    [sym_unboxed_unit] = STATE(3708),
    [sym_prefix_tuple] = STATE(3708),
    [sym_prefix_unboxed_tuple] = STATE(3708),
    [sym_prefix_unboxed_sum] = STATE(3708),
    [sym_literal] = STATE(3708),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1456),
    [sym__qvariable_ticked] = STATE(1456),
    [sym__qualified_constructor] = STATE(3685),
    [sym__qconid] = STATE(3708),
    [sym__constructor_ticked] = STATE(1456),
    [sym__qconstructor_ticked] = STATE(1456),
    [sym__ops] = STATE(1456),
    [sym__operator_qual_dot_head] = STATE(1309),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7809),
    [sym__operator_minus] = STATE(11711),
    [sym__varsym_prefix] = STATE(3795),
    [sym__pvarsym] = STATE(3795),
    [sym__qualified_varsym] = STATE(7797),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7816),
    [sym__consym_prefix] = STATE(3705),
    [sym__pconsym] = STATE(3705),
    [sym__qualified_consym] = STATE(7819),
    [sym__qconsym_prefix] = STATE(3708),
    [sym__pqconsym] = STATE(3708),
    [sym__qual_dot] = STATE(12299),
    [sym__prefix_dot] = STATE(12299),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(33),
    [sym__paren_close] = STATE(3465),
    [sym__bracket_open] = STATE(371),
    [sym__unboxed_open] = STATE(189),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(873),
    [sym_variable] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(207),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(153),
    [sym_char] = ACTIONS(153),
    [sym_string] = ACTIONS(153),
    [sym__integer_literal] = ACTIONS(155),
    [sym__binary_literal] = ACTIONS(157),
    [sym__octal_literal] = ACTIONS(157),
    [sym__hex_literal] = ACTIONS(157),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(163),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(195),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(209),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(171),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [33] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11853),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(218),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9600),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple_elems] = STATE(11563),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10074),
    [sym_view_pattern] = STATE(10074),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8228),
    [sym__splice_dollars] = STATE(7430),
    [sym_splice] = STATE(3708),
    [sym_quasiquote] = STATE(3708),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(3690),
    [sym__plist] = STATE(3706),
    [sym_unit] = STATE(3708),
    [sym_unboxed_unit] = STATE(3708),
    [sym_prefix_tuple] = STATE(3708),
    [sym_prefix_unboxed_tuple] = STATE(3708),
    [sym_prefix_unboxed_sum] = STATE(3708),
    [sym_literal] = STATE(3708),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1476),
    [sym__qvariable_ticked] = STATE(1476),
    [sym__qualified_constructor] = STATE(3685),
    [sym__qconid] = STATE(3708),
    [sym__constructor_ticked] = STATE(1476),
    [sym__qconstructor_ticked] = STATE(1476),
    [sym__ops] = STATE(1476),
    [sym__operator_qual_dot_head] = STATE(1302),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7803),
    [sym__operator_minus] = STATE(11805),
    [sym__varsym_prefix] = STATE(3795),
    [sym__pvarsym] = STATE(3795),
    [sym__qualified_varsym] = STATE(7831),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7823),
    [sym__consym_prefix] = STATE(3705),
    [sym__pconsym] = STATE(3705),
    [sym__qualified_consym] = STATE(7794),
    [sym__qconsym_prefix] = STATE(3708),
    [sym__pqconsym] = STATE(3708),
    [sym__qual_dot] = STATE(12250),
    [sym__prefix_dot] = STATE(12250),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(33),
    [sym__paren_close] = STATE(3737),
    [sym__bracket_open] = STATE(371),
    [sym__unboxed_open] = STATE(189),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(908),
    [sym_variable] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(153),
    [sym_char] = ACTIONS(153),
    [sym_string] = ACTIONS(153),
    [sym__integer_literal] = ACTIONS(155),
    [sym__binary_literal] = ACTIONS(157),
    [sym__octal_literal] = ACTIONS(157),
    [sym__hex_literal] = ACTIONS(157),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(163),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(195),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(169),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(171),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [34] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11559),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(231),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9679),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple_elems] = STATE(11563),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10074),
    [sym_view_pattern] = STATE(10074),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8228),
    [sym__splice_dollars] = STATE(7430),
    [sym_splice] = STATE(3708),
    [sym_quasiquote] = STATE(3708),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(3690),
    [sym__plist] = STATE(3706),
    [sym_unit] = STATE(3708),
    [sym_unboxed_unit] = STATE(3708),
    [sym_prefix_tuple] = STATE(3708),
    [sym_prefix_unboxed_tuple] = STATE(3708),
    [sym_prefix_unboxed_sum] = STATE(3708),
    [sym_literal] = STATE(3708),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1527),
    [sym__qvariable_ticked] = STATE(1527),
    [sym__qualified_constructor] = STATE(3685),
    [sym__qconid] = STATE(3708),
    [sym__constructor_ticked] = STATE(1527),
    [sym__qconstructor_ticked] = STATE(1527),
    [sym__ops] = STATE(1527),
    [sym__operator_qual_dot_head] = STATE(1207),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7859),
    [sym__operator_minus] = STATE(11620),
    [sym__varsym_prefix] = STATE(3795),
    [sym__pvarsym] = STATE(3795),
    [sym__qualified_varsym] = STATE(7799),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7861),
    [sym__consym_prefix] = STATE(3705),
    [sym__pconsym] = STATE(3705),
    [sym__qualified_consym] = STATE(7858),
    [sym__qconsym_prefix] = STATE(3708),
    [sym__pqconsym] = STATE(3708),
    [sym__qual_dot] = STATE(12278),
    [sym__prefix_dot] = STATE(12278),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(33),
    [sym__paren_close] = STATE(3600),
    [sym__bracket_open] = STATE(371),
    [sym__unboxed_open] = STATE(189),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(872),
    [sym_variable] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(203),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(153),
    [sym_char] = ACTIONS(153),
    [sym_string] = ACTIONS(153),
    [sym__integer_literal] = ACTIONS(155),
    [sym__binary_literal] = ACTIONS(157),
    [sym__octal_literal] = ACTIONS(157),
    [sym__hex_literal] = ACTIONS(157),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(163),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(195),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(205),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(171),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [35] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11659),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(213),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9591),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple_elems] = STATE(11563),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10074),
    [sym_view_pattern] = STATE(10074),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8228),
    [sym__splice_dollars] = STATE(7430),
    [sym_splice] = STATE(3708),
    [sym_quasiquote] = STATE(3708),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(3690),
    [sym__plist] = STATE(3706),
    [sym_unit] = STATE(3708),
    [sym_unboxed_unit] = STATE(3708),
    [sym_prefix_tuple] = STATE(3708),
    [sym_prefix_unboxed_tuple] = STATE(3708),
    [sym_prefix_unboxed_sum] = STATE(3708),
    [sym_literal] = STATE(3708),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1430),
    [sym__qvariable_ticked] = STATE(1430),
    [sym__qualified_constructor] = STATE(3685),
    [sym__qconid] = STATE(3708),
    [sym__constructor_ticked] = STATE(1430),
    [sym__qconstructor_ticked] = STATE(1430),
    [sym__ops] = STATE(1430),
    [sym__operator_qual_dot_head] = STATE(1305),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7813),
    [sym__operator_minus] = STATE(11574),
    [sym__varsym_prefix] = STATE(3795),
    [sym__pvarsym] = STATE(3795),
    [sym__qualified_varsym] = STATE(7811),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7808),
    [sym__consym_prefix] = STATE(3705),
    [sym__pconsym] = STATE(3705),
    [sym__qualified_consym] = STATE(7807),
    [sym__qconsym_prefix] = STATE(3708),
    [sym__pqconsym] = STATE(3708),
    [sym__qual_dot] = STATE(12408),
    [sym__prefix_dot] = STATE(12408),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(33),
    [sym__paren_close] = STATE(2923),
    [sym__bracket_open] = STATE(371),
    [sym__unboxed_open] = STATE(189),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(896),
    [sym_variable] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(153),
    [sym_char] = ACTIONS(153),
    [sym_string] = ACTIONS(153),
    [sym__integer_literal] = ACTIONS(155),
    [sym__binary_literal] = ACTIONS(157),
    [sym__octal_literal] = ACTIONS(157),
    [sym__hex_literal] = ACTIONS(157),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(163),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(195),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(171),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [36] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11559),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(231),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9679),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple_elems] = STATE(11563),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10074),
    [sym_view_pattern] = STATE(10074),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8228),
    [sym__splice_dollars] = STATE(7430),
    [sym_splice] = STATE(3708),
    [sym_quasiquote] = STATE(3708),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(3690),
    [sym__plist] = STATE(3706),
    [sym_unit] = STATE(3708),
    [sym_unboxed_unit] = STATE(3708),
    [sym_prefix_tuple] = STATE(3708),
    [sym_prefix_unboxed_tuple] = STATE(3708),
    [sym_prefix_unboxed_sum] = STATE(3708),
    [sym_literal] = STATE(3708),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1527),
    [sym__qvariable_ticked] = STATE(1527),
    [sym__qualified_constructor] = STATE(3685),
    [sym__qconid] = STATE(3708),
    [sym__constructor_ticked] = STATE(1527),
    [sym__qconstructor_ticked] = STATE(1527),
    [sym__ops] = STATE(1527),
    [sym__operator_qual_dot_head] = STATE(1260),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7813),
    [sym__operator_minus] = STATE(11574),
    [sym__varsym_prefix] = STATE(3795),
    [sym__pvarsym] = STATE(3795),
    [sym__qualified_varsym] = STATE(7799),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7808),
    [sym__consym_prefix] = STATE(3705),
    [sym__pconsym] = STATE(3705),
    [sym__qualified_consym] = STATE(7807),
    [sym__qconsym_prefix] = STATE(3708),
    [sym__pqconsym] = STATE(3708),
    [sym__qual_dot] = STATE(12278),
    [sym__prefix_dot] = STATE(12278),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(33),
    [sym__paren_close] = STATE(2923),
    [sym__bracket_open] = STATE(371),
    [sym__unboxed_open] = STATE(189),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(896),
    [sym_variable] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(179),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(193),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(153),
    [sym_char] = ACTIONS(153),
    [sym_string] = ACTIONS(153),
    [sym__integer_literal] = ACTIONS(155),
    [sym__binary_literal] = ACTIONS(157),
    [sym__octal_literal] = ACTIONS(157),
    [sym__hex_literal] = ACTIONS(157),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(163),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(195),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(171),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [37] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(6709),
    [sym__pat_tuple_elems] = STATE(12199),
    [sym__pat_tuple] = STATE(6707),
    [sym__pat_unboxed_tuple] = STATE(6706),
    [sym__pat_unboxed_sum] = STATE(6705),
    [sym__pat_list] = STATE(6704),
    [sym__pat_record] = STATE(6703),
    [sym__pat_as] = STATE(6702),
    [sym__pat_wildcard] = STATE(6701),
    [sym__pat_strict] = STATE(6700),
    [sym__pat_irrefutable] = STATE(6699),
    [sym__pat_apply] = STATE(6772),
    [sym__pat_negation] = STATE(6711),
    [sym__pat_infix] = STATE(6715),
    [sym_pattern] = STATE(939),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10257),
    [sym_view_pattern] = STATE(10257),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(8886),
    [sym__function_name] = STATE(2089),
    [sym_function_head_parens] = STATE(2091),
    [sym__function_head_infix] = STATE(12219),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3930),
    [sym_quasiquote] = STATE(3930),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3929),
    [sym_unit] = STATE(3930),
    [sym_unboxed_unit] = STATE(3930),
    [sym_prefix_tuple] = STATE(3930),
    [sym_prefix_unboxed_tuple] = STATE(3930),
    [sym_prefix_unboxed_sum] = STATE(3930),
    [sym_literal] = STATE(3930),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3930),
    [sym__operator_qual_dot_head] = STATE(11859),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11859),
    [sym__operator_minus] = STATE(11859),
    [sym__varsym_prefix] = STATE(3870),
    [sym__pvarsym] = STATE(3870),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12018),
    [sym__consym_prefix] = STATE(3923),
    [sym__pconsym] = STATE(3923),
    [sym__qualified_consym] = STATE(11350),
    [sym__qconsym_prefix] = STATE(3930),
    [sym__pqconsym] = STATE(3930),
    [sym__prefix_bang] = STATE(2257),
    [sym__tight_bang] = STATE(2257),
    [sym__any_prefix_bang] = STATE(2257),
    [sym__prefix_tilde] = STATE(2258),
    [sym__tight_tilde] = STATE(2258),
    [sym__any_prefix_tilde] = STATE(2258),
    [sym__paren_open] = STATE(27),
    [sym__paren_close] = STATE(6073),
    [sym__bracket_open] = STATE(347),
    [sym__unboxed_open] = STATE(197),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10394),
    [sym_variable] = ACTIONS(211),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym__] = ACTIONS(133),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(243),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(247),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(249),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [38] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple_elems] = STATE(11563),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10074),
    [sym_view_pattern] = STATE(10074),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(8886),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__operator_qual_dot_head] = STATE(11684),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11684),
    [sym__operator_minus] = STATE(11684),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11352),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qualified_consym] = STATE(11803),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__paren_close] = STATE(5746),
    [sym__bracket_open] = STATE(374),
    [sym__unboxed_open] = STATE(204),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10106),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(261),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_type] = ACTIONS(263),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(243),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(267),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [39] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple_elems] = STATE(11563),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10074),
    [sym_view_pattern] = STATE(10074),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(8886),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__operator_qual_dot_head] = STATE(11684),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11684),
    [sym__operator_minus] = STATE(11684),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11352),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qualified_consym] = STATE(11803),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__paren_close] = STATE(5746),
    [sym__bracket_open] = STATE(374),
    [sym__unboxed_open] = STATE(204),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10106),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(261),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_type] = ACTIONS(271),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(243),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(267),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [40] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple_elems] = STATE(11850),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10358),
    [sym_view_pattern] = STATE(10358),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(8886),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__operator_qual_dot_head] = STATE(12040),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12040),
    [sym__operator_minus] = STATE(12040),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11364),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qualified_consym] = STATE(11480),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__paren_close] = STATE(7276),
    [sym__bracket_open] = STATE(374),
    [sym__unboxed_open] = STATE(204),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10653),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_type] = ACTIONS(275),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(243),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(267),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(277),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [41] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple_elems] = STATE(11330),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10620),
    [sym_view_pattern] = STATE(10620),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(8886),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__operator_qual_dot_head] = STATE(11424),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11424),
    [sym__operator_minus] = STATE(11424),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12064),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qualified_consym] = STATE(11407),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__paren_close] = STATE(6526),
    [sym__bracket_open] = STATE(374),
    [sym__unboxed_open] = STATE(204),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10623),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_type] = ACTIONS(281),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(243),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(267),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(283),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [42] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple_elems] = STATE(11715),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10837),
    [sym_view_pattern] = STATE(10837),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(8886),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__operator_qual_dot_head] = STATE(11498),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11498),
    [sym__operator_minus] = STATE(11498),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11428),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qualified_consym] = STATE(11752),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__paren_close] = STATE(7110),
    [sym__bracket_open] = STATE(374),
    [sym__unboxed_open] = STATE(204),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10820),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(285),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_type] = ACTIONS(287),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(243),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(267),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [43] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple_elems] = STATE(11850),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10358),
    [sym_view_pattern] = STATE(10358),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(8886),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__operator_qual_dot_head] = STATE(12040),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12040),
    [sym__operator_minus] = STATE(12040),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11364),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qualified_consym] = STATE(11480),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__paren_close] = STATE(7276),
    [sym__bracket_open] = STATE(374),
    [sym__unboxed_open] = STATE(204),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10653),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_type] = ACTIONS(291),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(243),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(267),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(277),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [44] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple_elems] = STATE(12199),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10257),
    [sym_view_pattern] = STATE(10257),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(8886),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__operator_qual_dot_head] = STATE(11859),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11859),
    [sym__operator_minus] = STATE(11859),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12018),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qualified_consym] = STATE(11350),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__paren_close] = STATE(6073),
    [sym__bracket_open] = STATE(374),
    [sym__unboxed_open] = STATE(204),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10394),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_type] = ACTIONS(293),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(243),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(267),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(249),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [45] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple_elems] = STATE(11330),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10620),
    [sym_view_pattern] = STATE(10620),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(8886),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__operator_qual_dot_head] = STATE(11424),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11424),
    [sym__operator_minus] = STATE(11424),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12064),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qualified_consym] = STATE(11407),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__paren_close] = STATE(6526),
    [sym__bracket_open] = STATE(374),
    [sym__unboxed_open] = STATE(204),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10623),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(243),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(267),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(283),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [46] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple_elems] = STATE(11563),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10074),
    [sym_view_pattern] = STATE(10074),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(8886),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__operator_qual_dot_head] = STATE(11684),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11684),
    [sym__operator_minus] = STATE(11684),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11352),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qualified_consym] = STATE(11803),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__paren_close] = STATE(5746),
    [sym__bracket_open] = STATE(374),
    [sym__unboxed_open] = STATE(204),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10106),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(261),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(243),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(267),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [47] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple_elems] = STATE(11715),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10837),
    [sym_view_pattern] = STATE(10837),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(8886),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__operator_qual_dot_head] = STATE(11498),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11498),
    [sym__operator_minus] = STATE(11498),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11428),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qualified_consym] = STATE(11752),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__paren_close] = STATE(7110),
    [sym__bracket_open] = STATE(374),
    [sym__unboxed_open] = STATE(204),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10820),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(285),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(243),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(267),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [48] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple_elems] = STATE(12199),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10257),
    [sym_view_pattern] = STATE(10257),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(8886),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__operator_qual_dot_head] = STATE(11859),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11859),
    [sym__operator_minus] = STATE(11859),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12018),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qualified_consym] = STATE(11350),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__paren_close] = STATE(6073),
    [sym__bracket_open] = STATE(374),
    [sym__unboxed_open] = STATE(204),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10394),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(243),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(267),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(249),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [49] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple_elems] = STATE(11850),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10358),
    [sym_view_pattern] = STATE(10358),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(8886),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__operator_qual_dot_head] = STATE(12040),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12040),
    [sym__operator_minus] = STATE(12040),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11364),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qualified_consym] = STATE(11480),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__paren_close] = STATE(7276),
    [sym__bracket_open] = STATE(374),
    [sym__unboxed_open] = STATE(204),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10653),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(273),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(243),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(267),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(277),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [50] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__colon2] = STATE(1404),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_RBRACE] = ACTIONS(297),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_then] = ACTIONS(301),
    [anon_sym_using] = ACTIONS(301),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_else] = ACTIONS(301),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_of] = ACTIONS(301),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(297),
    [anon_sym_u27e7] = ACTIONS(297),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(297),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [anon_sym_u2192] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(315),
    [anon_sym_u2237] = ACTIONS(315),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(297),
    [anon_sym_RBRACK] = ACTIONS(297),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(327),
    [sym__cond_no_section_op] = ACTIONS(329),
    [sym__cond_minus] = ACTIONS(331),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [51] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_RBRACE] = ACTIONS(333),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_then] = ACTIONS(335),
    [anon_sym_using] = ACTIONS(335),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_else] = ACTIONS(335),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_of] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(333),
    [anon_sym_u27e7] = ACTIONS(333),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(333),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [anon_sym_u2192] = ACTIONS(333),
    [anon_sym_COLON_COLON] = ACTIONS(333),
    [anon_sym_u2237] = ACTIONS(333),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(333),
    [anon_sym_RBRACK] = ACTIONS(333),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(327),
    [sym__cond_no_section_op] = ACTIONS(329),
    [sym__cond_minus] = ACTIONS(331),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [52] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_let] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(339),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_RBRACE] = ACTIONS(339),
    [anon_sym_SQUOTE] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(339),
    [anon_sym_EQ] = ACTIONS(339),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(339),
    [anon_sym_then] = ACTIONS(337),
    [anon_sym_using] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(337),
    [anon_sym_else] = ACTIONS(337),
    [anon_sym_mdo] = ACTIONS(337),
    [anon_sym_do] = ACTIONS(337),
    [anon_sym_case] = ACTIONS(337),
    [anon_sym_of] = ACTIONS(337),
    [anon_sym_DASH] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(339),
    [anon_sym_PIPE_RBRACK] = ACTIONS(339),
    [anon_sym_u27e7] = ACTIONS(339),
    [anon_sym_u27e6] = ACTIONS(339),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(339),
    [sym_float] = ACTIONS(339),
    [sym_char] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym__integer_literal] = ACTIONS(337),
    [sym__binary_literal] = ACTIONS(339),
    [sym__octal_literal] = ACTIONS(339),
    [sym__hex_literal] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_POUND] = ACTIONS(337),
    [anon_sym_POUND2] = ACTIONS(337),
    [sym_implicit_variable] = ACTIONS(339),
    [sym_name] = ACTIONS(339),
    [sym_label] = ACTIONS(339),
    [anon_sym_u2192] = ACTIONS(339),
    [anon_sym_COLON_COLON] = ACTIONS(339),
    [anon_sym_u2237] = ACTIONS(339),
    [aux_sym__paren_open_token1] = ACTIONS(339),
    [aux_sym__paren_close_token1] = ACTIONS(339),
    [anon_sym_RBRACK] = ACTIONS(339),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(339),
    [sym__cond_splice] = ACTIONS(339),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(339),
    [sym__cond_prefix_at] = ACTIONS(339),
    [sym__cond_qualified_op] = ACTIONS(339),
    [sym__cond_no_section_op] = ACTIONS(339),
    [sym__cond_minus] = ACTIONS(339),
    [sym__varsym] = ACTIONS(339),
    [sym__consym] = ACTIONS(339),
  },
  [53] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_RBRACE] = ACTIONS(341),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(341),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_then] = ACTIONS(343),
    [anon_sym_using] = ACTIONS(343),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_else] = ACTIONS(343),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_of] = ACTIONS(343),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(341),
    [anon_sym_u27e7] = ACTIONS(341),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(341),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [anon_sym_u2192] = ACTIONS(341),
    [anon_sym_COLON_COLON] = ACTIONS(341),
    [anon_sym_u2237] = ACTIONS(341),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(341),
    [anon_sym_RBRACK] = ACTIONS(341),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(327),
    [sym__cond_no_section_op] = ACTIONS(329),
    [sym__cond_minus] = ACTIONS(331),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [54] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_RBRACE] = ACTIONS(333),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(333),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_then] = ACTIONS(335),
    [anon_sym_using] = ACTIONS(335),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_else] = ACTIONS(335),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_of] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(333),
    [anon_sym_u27e7] = ACTIONS(333),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(333),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [anon_sym_u2192] = ACTIONS(333),
    [anon_sym_COLON_COLON] = ACTIONS(333),
    [anon_sym_u2237] = ACTIONS(333),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(333),
    [anon_sym_RBRACK] = ACTIONS(333),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(327),
    [sym__cond_no_section_op] = ACTIONS(329),
    [sym__cond_minus] = ACTIONS(331),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [55] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_SEMI] = ACTIONS(345),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(345),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_RBRACE] = ACTIONS(345),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(345),
    [anon_sym_EQ] = ACTIONS(345),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_then] = ACTIONS(347),
    [anon_sym_using] = ACTIONS(347),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_else] = ACTIONS(347),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_of] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(345),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(345),
    [anon_sym_u27e7] = ACTIONS(345),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(345),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_POUND] = ACTIONS(347),
    [anon_sym_POUND2] = ACTIONS(347),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [anon_sym_u2192] = ACTIONS(345),
    [anon_sym_COLON_COLON] = ACTIONS(345),
    [anon_sym_u2237] = ACTIONS(345),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(345),
    [anon_sym_RBRACK] = ACTIONS(345),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(345),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(345),
    [sym__cond_no_section_op] = ACTIONS(345),
    [sym__cond_minus] = ACTIONS(345),
    [sym__varsym] = ACTIONS(345),
    [sym__consym] = ACTIONS(345),
  },
  [56] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_SEMI] = ACTIONS(349),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(349),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_RBRACE] = ACTIONS(349),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(349),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_then] = ACTIONS(351),
    [anon_sym_using] = ACTIONS(351),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_else] = ACTIONS(351),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_of] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(349),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(349),
    [anon_sym_u27e7] = ACTIONS(349),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(349),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [anon_sym_u2192] = ACTIONS(349),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [anon_sym_u2237] = ACTIONS(349),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(349),
    [anon_sym_RBRACK] = ACTIONS(349),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(327),
    [sym__cond_no_section_op] = ACTIONS(329),
    [sym__cond_minus] = ACTIONS(331),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [57] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_SEMI] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(353),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_RBRACE] = ACTIONS(353),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(353),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_then] = ACTIONS(355),
    [anon_sym_using] = ACTIONS(355),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_of] = ACTIONS(355),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(353),
    [anon_sym_u27e7] = ACTIONS(353),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(353),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [anon_sym_u2192] = ACTIONS(353),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_u2237] = ACTIONS(353),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(353),
    [anon_sym_RBRACK] = ACTIONS(353),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(327),
    [sym__cond_no_section_op] = ACTIONS(329),
    [sym__cond_minus] = ACTIONS(331),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [58] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_SEMI] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_RBRACE] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(357),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_then] = ACTIONS(359),
    [anon_sym_using] = ACTIONS(359),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_else] = ACTIONS(359),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_of] = ACTIONS(359),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(357),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(357),
    [anon_sym_u27e7] = ACTIONS(357),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(357),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [anon_sym_u2192] = ACTIONS(357),
    [anon_sym_COLON_COLON] = ACTIONS(357),
    [anon_sym_u2237] = ACTIONS(357),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(357),
    [anon_sym_RBRACK] = ACTIONS(357),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(327),
    [sym__cond_no_section_op] = ACTIONS(329),
    [sym__cond_minus] = ACTIONS(331),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [59] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_SEMI] = ACTIONS(361),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_RBRACE] = ACTIONS(361),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(361),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_then] = ACTIONS(363),
    [anon_sym_using] = ACTIONS(363),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_else] = ACTIONS(363),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_of] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(361),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(361),
    [anon_sym_u27e7] = ACTIONS(361),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(361),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [anon_sym_u2192] = ACTIONS(361),
    [anon_sym_COLON_COLON] = ACTIONS(361),
    [anon_sym_u2237] = ACTIONS(361),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(361),
    [anon_sym_RBRACK] = ACTIONS(361),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(327),
    [sym__cond_no_section_op] = ACTIONS(329),
    [sym__cond_minus] = ACTIONS(331),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [60] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_SEMI] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_RBRACE] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(357),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_then] = ACTIONS(359),
    [anon_sym_using] = ACTIONS(359),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_else] = ACTIONS(359),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_of] = ACTIONS(359),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(357),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(357),
    [anon_sym_u27e7] = ACTIONS(357),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(357),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [anon_sym_u2192] = ACTIONS(357),
    [anon_sym_COLON_COLON] = ACTIONS(357),
    [anon_sym_u2237] = ACTIONS(357),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(357),
    [anon_sym_RBRACK] = ACTIONS(357),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(327),
    [sym__cond_no_section_op] = ACTIONS(329),
    [sym__cond_minus] = ACTIONS(331),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [61] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__colon2] = STATE(1548),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_RBRACE] = ACTIONS(297),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(297),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_then] = ACTIONS(301),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_else] = ACTIONS(301),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_of] = ACTIONS(301),
    [anon_sym_DASH] = ACTIONS(303),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(297),
    [anon_sym_u27e7] = ACTIONS(297),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [anon_sym_u2192] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_u2237] = ACTIONS(365),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(297),
    [anon_sym_RBRACK] = ACTIONS(297),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(327),
    [sym__cond_no_section_op] = ACTIONS(329),
    [sym__cond_minus] = ACTIONS(331),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [62] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9487),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5216),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(200),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(369),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(385),
    [sym__cond_layout_end] = ACTIONS(387),
    [sym__cond_layout_end_explicit] = ACTIONS(387),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [63] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9267),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4337),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(179),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(391),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(393),
    [sym__cond_layout_end] = ACTIONS(395),
    [sym__cond_layout_end_explicit] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [64] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9423),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5005),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(173),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(397),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(399),
    [sym__cond_layout_end] = ACTIONS(401),
    [sym__cond_layout_end_explicit] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [65] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9489),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4121),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(192),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(405),
    [sym__cond_layout_end] = ACTIONS(407),
    [sym__cond_layout_end_explicit] = ACTIONS(407),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [66] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9153),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5356),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(180),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(409),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(411),
    [sym__cond_layout_end] = ACTIONS(413),
    [sym__cond_layout_end_explicit] = ACTIONS(413),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [67] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9488),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4851),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(194),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(417),
    [sym__cond_layout_end] = ACTIONS(419),
    [sym__cond_layout_end_explicit] = ACTIONS(419),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [68] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9255),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(10025),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(188),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(423),
    [sym__cond_layout_end] = ACTIONS(425),
    [sym__cond_layout_end_explicit] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [69] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9458),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5162),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(198),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(429),
    [sym__cond_layout_end] = ACTIONS(431),
    [sym__cond_layout_end_explicit] = ACTIONS(431),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [70] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9481),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(2994),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(187),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(433),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(435),
    [sym__cond_layout_end] = ACTIONS(437),
    [sym__cond_layout_end_explicit] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [71] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9479),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4625),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(174),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(441),
    [sym__cond_layout_end] = ACTIONS(443),
    [sym__cond_layout_end_explicit] = ACTIONS(443),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [72] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9162),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5620),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(199),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(445),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(447),
    [sym__cond_layout_end] = ACTIONS(449),
    [sym__cond_layout_end_explicit] = ACTIONS(449),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [73] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5511),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(453),
    [sym__cond_layout_end_explicit] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [74] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4894),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(455),
    [sym__cond_layout_end_explicit] = ACTIONS(455),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [75] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5491),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(457),
    [sym__cond_layout_end_explicit] = ACTIONS(457),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [76] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(3028),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(459),
    [sym__cond_layout_end_explicit] = ACTIONS(459),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [77] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4190),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(461),
    [sym__cond_layout_end_explicit] = ACTIONS(461),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [78] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4659),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(463),
    [sym__cond_layout_end_explicit] = ACTIONS(463),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [79] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4675),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(465),
    [sym__cond_layout_end_explicit] = ACTIONS(465),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [80] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4218),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(467),
    [sym__cond_layout_end_explicit] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [81] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5355),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(469),
    [sym__cond_layout_end_explicit] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [82] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5408),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(471),
    [sym__cond_layout_end_explicit] = ACTIONS(471),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [83] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(3025),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(473),
    [sym__cond_layout_end_explicit] = ACTIONS(473),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [84] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5384),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(475),
    [sym__cond_layout_end_explicit] = ACTIONS(475),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [85] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4845),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(477),
    [sym__cond_layout_end_explicit] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [86] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5506),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(479),
    [sym__cond_layout_end_explicit] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [87] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5509),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(481),
    [sym__cond_layout_end_explicit] = ACTIONS(481),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [88] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(10037),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(483),
    [sym__cond_layout_end_explicit] = ACTIONS(483),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [89] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(2943),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(485),
    [sym__cond_layout_end_explicit] = ACTIONS(485),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [90] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4491),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(487),
    [sym__cond_layout_end_explicit] = ACTIONS(487),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [91] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4601),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(489),
    [sym__cond_layout_end_explicit] = ACTIONS(489),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [92] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4231),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(491),
    [sym__cond_layout_end_explicit] = ACTIONS(491),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [93] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5116),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(493),
    [sym__cond_layout_end_explicit] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [94] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5604),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(495),
    [sym__cond_layout_end_explicit] = ACTIONS(495),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [95] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5601),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(497),
    [sym__cond_layout_end_explicit] = ACTIONS(497),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [96] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4214),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(499),
    [sym__cond_layout_end_explicit] = ACTIONS(499),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [97] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(10035),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(501),
    [sym__cond_layout_end_explicit] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [98] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5597),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(503),
    [sym__cond_layout_end_explicit] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [99] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(10027),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(505),
    [sym__cond_layout_end_explicit] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [100] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4956),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(507),
    [sym__cond_layout_end_explicit] = ACTIONS(507),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [101] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5593),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(509),
    [sym__cond_layout_end_explicit] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [102] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5114),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(511),
    [sym__cond_layout_end_explicit] = ACTIONS(511),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [103] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4488),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(513),
    [sym__cond_layout_end_explicit] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [104] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5322),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(515),
    [sym__cond_layout_end_explicit] = ACTIONS(515),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [105] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4765),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(517),
    [sym__cond_layout_end_explicit] = ACTIONS(517),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [106] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4920),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(519),
    [sym__cond_layout_end_explicit] = ACTIONS(519),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [107] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5111),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(521),
    [sym__cond_layout_end_explicit] = ACTIONS(521),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [108] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4729),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(523),
    [sym__cond_layout_end_explicit] = ACTIONS(523),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [109] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4757),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(525),
    [sym__cond_layout_end_explicit] = ACTIONS(525),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [110] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4869),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(527),
    [sym__cond_layout_end_explicit] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [111] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5108),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(529),
    [sym__cond_layout_end_explicit] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [112] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(2989),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(531),
    [sym__cond_layout_end_explicit] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [113] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4466),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(533),
    [sym__cond_layout_end_explicit] = ACTIONS(533),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [114] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4455),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(535),
    [sym__cond_layout_end_explicit] = ACTIONS(535),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [115] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4549),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(537),
    [sym__cond_layout_end_explicit] = ACTIONS(537),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [116] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(10024),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(539),
    [sym__cond_layout_end_explicit] = ACTIONS(539),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [117] = {
    [sym__at_type] = STATE(4204),
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym_explicit_type] = STATE(4207),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_op] = STATE(1425),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(139),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__variable_ticked] = STATE(1425),
    [sym__qvariable_ticked] = STATE(1425),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__constructor_ticked] = STATE(1425),
    [sym__qconstructor_ticked] = STATE(1425),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1425),
    [sym__operator_alias] = STATE(1425),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym_constructor_operator] = STATE(1425),
    [sym__constructor_operator_alias] = STATE(1425),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__colon2] = STATE(1709),
    [sym__tight_dot] = STATE(11412),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2577),
    [sym__paren_open] = STATE(377),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_LBRACE] = ACTIONS(545),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [anon_sym_COLON_COLON] = ACTIONS(573),
    [anon_sym_u2237] = ACTIONS(573),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_where] = ACTIONS(301),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(297),
    [sym__cond_layout_end] = ACTIONS(297),
    [sym__cond_layout_end_explicit] = ACTIONS(297),
    [sym__phantom_where] = ACTIONS(297),
    [sym__phantom_bar] = ACTIONS(297),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(577),
    [sym__cond_no_section_op] = ACTIONS(579),
    [sym__cond_minus] = ACTIONS(581),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [118] = {
    [sym__at_type] = STATE(4204),
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym_explicit_type] = STATE(4207),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_op] = STATE(1425),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(139),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__variable_ticked] = STATE(1425),
    [sym__qvariable_ticked] = STATE(1425),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__constructor_ticked] = STATE(1425),
    [sym__qconstructor_ticked] = STATE(1425),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1425),
    [sym__operator_alias] = STATE(1425),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym_constructor_operator] = STATE(1425),
    [sym__constructor_operator_alias] = STATE(1425),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__colon2] = STATE(1748),
    [sym__tight_dot] = STATE(11412),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2577),
    [sym__paren_open] = STATE(377),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_LBRACE] = ACTIONS(545),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [anon_sym_COLON_COLON] = ACTIONS(583),
    [anon_sym_u2237] = ACTIONS(583),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_where] = ACTIONS(301),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(297),
    [sym__cond_layout_end] = ACTIONS(297),
    [sym__cond_layout_end_explicit] = ACTIONS(297),
    [sym__phantom_where] = ACTIONS(297),
    [sym__phantom_bar] = ACTIONS(297),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(577),
    [sym__cond_no_section_op] = ACTIONS(579),
    [sym__cond_minus] = ACTIONS(581),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [119] = {
    [sym__at_type] = STATE(4204),
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym_explicit_type] = STATE(4207),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_op] = STATE(1425),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(139),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__variable_ticked] = STATE(1425),
    [sym__qvariable_ticked] = STATE(1425),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__constructor_ticked] = STATE(1425),
    [sym__qconstructor_ticked] = STATE(1425),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1425),
    [sym__operator_alias] = STATE(1425),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym_constructor_operator] = STATE(1425),
    [sym__constructor_operator_alias] = STATE(1425),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__tight_dot] = STATE(11412),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2577),
    [sym__paren_open] = STATE(377),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_SEMI] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_LBRACE] = ACTIONS(545),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(357),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [anon_sym_COLON_COLON] = ACTIONS(357),
    [anon_sym_u2237] = ACTIONS(357),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_where] = ACTIONS(359),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(357),
    [sym__cond_layout_end] = ACTIONS(357),
    [sym__cond_layout_end_explicit] = ACTIONS(357),
    [sym__phantom_where] = ACTIONS(357),
    [sym__phantom_bar] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(577),
    [sym__cond_no_section_op] = ACTIONS(579),
    [sym__cond_minus] = ACTIONS(581),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [120] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5508),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(585),
    [sym__cond_layout_end_explicit] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [121] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4491),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(487),
    [sym__cond_layout_end_explicit] = ACTIONS(487),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [122] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5108),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(529),
    [sym__cond_layout_end_explicit] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [123] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(3028),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(459),
    [sym__cond_layout_end_explicit] = ACTIONS(459),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [124] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4467),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(587),
    [sym__cond_layout_end_explicit] = ACTIONS(587),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [125] = {
    [sym__at_type] = STATE(4204),
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym_explicit_type] = STATE(4207),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_op] = STATE(1425),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(139),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__variable_ticked] = STATE(1425),
    [sym__qvariable_ticked] = STATE(1425),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__constructor_ticked] = STATE(1425),
    [sym__qconstructor_ticked] = STATE(1425),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1425),
    [sym__operator_alias] = STATE(1425),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym_constructor_operator] = STATE(1425),
    [sym__constructor_operator_alias] = STATE(1425),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__tight_dot] = STATE(11412),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2577),
    [sym__paren_open] = STATE(377),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_SEMI] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_LBRACE] = ACTIONS(545),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(353),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_u2237] = ACTIONS(353),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_where] = ACTIONS(355),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(353),
    [sym__cond_layout_end] = ACTIONS(353),
    [sym__cond_layout_end_explicit] = ACTIONS(353),
    [sym__phantom_where] = ACTIONS(353),
    [sym__phantom_bar] = ACTIONS(353),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(577),
    [sym__cond_no_section_op] = ACTIONS(579),
    [sym__cond_minus] = ACTIONS(581),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [126] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4729),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(523),
    [sym__cond_layout_end_explicit] = ACTIONS(523),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [127] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4455),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(535),
    [sym__cond_layout_end_explicit] = ACTIONS(535),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [128] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5510),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(589),
    [sym__cond_layout_end_explicit] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [129] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4757),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(525),
    [sym__cond_layout_end_explicit] = ACTIONS(525),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [130] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4918),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(591),
    [sym__cond_layout_end_explicit] = ACTIONS(591),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [131] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4489),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(593),
    [sym__cond_layout_end_explicit] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [132] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(10041),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(595),
    [sym__cond_layout_end_explicit] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [133] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4763),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(597),
    [sym__cond_layout_end_explicit] = ACTIONS(597),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [134] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5111),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(521),
    [sym__cond_layout_end_explicit] = ACTIONS(521),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [135] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4208),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(599),
    [sym__cond_layout_end_explicit] = ACTIONS(599),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [136] = {
    [sym__at_type] = STATE(4204),
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym_explicit_type] = STATE(4207),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_op] = STATE(1425),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(139),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__variable_ticked] = STATE(1425),
    [sym__qvariable_ticked] = STATE(1425),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__constructor_ticked] = STATE(1425),
    [sym__qconstructor_ticked] = STATE(1425),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1425),
    [sym__operator_alias] = STATE(1425),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym_constructor_operator] = STATE(1425),
    [sym__constructor_operator_alias] = STATE(1425),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__tight_dot] = STATE(11412),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2577),
    [sym__paren_open] = STATE(377),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_SEMI] = ACTIONS(345),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_LBRACE] = ACTIONS(545),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_STAR] = ACTIONS(345),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(345),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_POUND] = ACTIONS(347),
    [anon_sym_POUND2] = ACTIONS(347),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [anon_sym_COLON_COLON] = ACTIONS(345),
    [anon_sym_u2237] = ACTIONS(345),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_where] = ACTIONS(347),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(345),
    [sym__cond_layout_end] = ACTIONS(345),
    [sym__cond_layout_end_explicit] = ACTIONS(345),
    [sym__phantom_where] = ACTIONS(345),
    [sym__phantom_bar] = ACTIONS(345),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(345),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(345),
    [sym__cond_no_section_op] = ACTIONS(345),
    [sym__cond_minus] = ACTIONS(345),
    [sym__varsym] = ACTIONS(345),
    [sym__consym] = ACTIONS(345),
  },
  [137] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(3026),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(601),
    [sym__cond_layout_end_explicit] = ACTIONS(601),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [138] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4920),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(519),
    [sym__cond_layout_end_explicit] = ACTIONS(519),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [139] = {
    [sym__at_type] = STATE(4204),
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym_explicit_type] = STATE(4207),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_op] = STATE(1425),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(139),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__variable_ticked] = STATE(1425),
    [sym__qvariable_ticked] = STATE(1425),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__constructor_ticked] = STATE(1425),
    [sym__qconstructor_ticked] = STATE(1425),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1425),
    [sym__operator_alias] = STATE(1425),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym_constructor_operator] = STATE(1425),
    [sym__constructor_operator_alias] = STATE(1425),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__tight_dot] = STATE(11412),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2577),
    [sym__paren_open] = STATE(377),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_let] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(545),
    [anon_sym_SQUOTE] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(339),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(337),
    [anon_sym_mdo] = ACTIONS(337),
    [anon_sym_do] = ACTIONS(337),
    [anon_sym_case] = ACTIONS(337),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(339),
    [anon_sym_u27e6] = ACTIONS(339),
    [sym_float] = ACTIONS(339),
    [sym_char] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym__integer_literal] = ACTIONS(337),
    [sym__binary_literal] = ACTIONS(339),
    [sym__octal_literal] = ACTIONS(339),
    [sym__hex_literal] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_POUND] = ACTIONS(337),
    [anon_sym_POUND2] = ACTIONS(337),
    [sym_implicit_variable] = ACTIONS(339),
    [sym_name] = ACTIONS(339),
    [sym_label] = ACTIONS(339),
    [anon_sym_COLON_COLON] = ACTIONS(339),
    [anon_sym_u2237] = ACTIONS(339),
    [aux_sym__paren_open_token1] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(337),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(339),
    [sym__cond_layout_end] = ACTIONS(339),
    [sym__cond_layout_end_explicit] = ACTIONS(339),
    [sym__phantom_where] = ACTIONS(339),
    [sym__phantom_bar] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(339),
    [sym__cond_splice] = ACTIONS(339),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(339),
    [sym__cond_prefix_at] = ACTIONS(339),
    [sym__cond_qualified_op] = ACTIONS(339),
    [sym__cond_no_section_op] = ACTIONS(339),
    [sym__cond_minus] = ACTIONS(339),
    [sym__varsym] = ACTIONS(339),
    [sym__consym] = ACTIONS(339),
  },
  [140] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(2990),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(603),
    [sym__cond_layout_end_explicit] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [141] = {
    [sym__at_type] = STATE(4204),
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym_explicit_type] = STATE(4207),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_op] = STATE(1425),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(139),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__variable_ticked] = STATE(1425),
    [sym__qvariable_ticked] = STATE(1425),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__constructor_ticked] = STATE(1425),
    [sym__qconstructor_ticked] = STATE(1425),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1425),
    [sym__operator_alias] = STATE(1425),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym_constructor_operator] = STATE(1425),
    [sym__constructor_operator_alias] = STATE(1425),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__tight_dot] = STATE(11412),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2577),
    [sym__paren_open] = STATE(377),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_SEMI] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_LBRACE] = ACTIONS(545),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(357),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [anon_sym_COLON_COLON] = ACTIONS(357),
    [anon_sym_u2237] = ACTIONS(357),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_where] = ACTIONS(359),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(357),
    [sym__cond_layout_end] = ACTIONS(357),
    [sym__cond_layout_end_explicit] = ACTIONS(357),
    [sym__phantom_where] = ACTIONS(357),
    [sym__phantom_bar] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(577),
    [sym__cond_no_section_op] = ACTIONS(579),
    [sym__cond_minus] = ACTIONS(581),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [142] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4228),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(605),
    [sym__cond_layout_end_explicit] = ACTIONS(605),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [143] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5113),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(607),
    [sym__cond_layout_end_explicit] = ACTIONS(607),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [144] = {
    [sym__at_type] = STATE(4204),
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym_explicit_type] = STATE(4207),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_op] = STATE(1425),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(139),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__variable_ticked] = STATE(1425),
    [sym__qvariable_ticked] = STATE(1425),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__constructor_ticked] = STATE(1425),
    [sym__qconstructor_ticked] = STATE(1425),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1425),
    [sym__operator_alias] = STATE(1425),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym_constructor_operator] = STATE(1425),
    [sym__constructor_operator_alias] = STATE(1425),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__tight_dot] = STATE(11412),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2577),
    [sym__paren_open] = STATE(377),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_SEMI] = ACTIONS(349),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_LBRACE] = ACTIONS(545),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(349),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [anon_sym_u2237] = ACTIONS(349),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_where] = ACTIONS(351),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(349),
    [sym__cond_layout_end] = ACTIONS(349),
    [sym__cond_layout_end_explicit] = ACTIONS(349),
    [sym__phantom_where] = ACTIONS(349),
    [sym__phantom_bar] = ACTIONS(349),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(577),
    [sym__cond_no_section_op] = ACTIONS(579),
    [sym__cond_minus] = ACTIONS(581),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [145] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5322),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(515),
    [sym__cond_layout_end_explicit] = ACTIONS(515),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [146] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5355),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(469),
    [sym__cond_layout_end_explicit] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [147] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5406),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(609),
    [sym__cond_layout_end_explicit] = ACTIONS(609),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [148] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4231),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(491),
    [sym__cond_layout_end_explicit] = ACTIONS(491),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [149] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5506),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(479),
    [sym__cond_layout_end_explicit] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [150] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4675),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(465),
    [sym__cond_layout_end_explicit] = ACTIONS(465),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [151] = {
    [sym__at_type] = STATE(4204),
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym_explicit_type] = STATE(4207),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_op] = STATE(1425),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(139),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__variable_ticked] = STATE(1425),
    [sym__qvariable_ticked] = STATE(1425),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__constructor_ticked] = STATE(1425),
    [sym__qconstructor_ticked] = STATE(1425),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1425),
    [sym__operator_alias] = STATE(1425),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym_constructor_operator] = STATE(1425),
    [sym__constructor_operator_alias] = STATE(1425),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__tight_dot] = STATE(11412),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2577),
    [sym__paren_open] = STATE(377),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_LBRACE] = ACTIONS(545),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(341),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [anon_sym_COLON_COLON] = ACTIONS(341),
    [anon_sym_u2237] = ACTIONS(341),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_where] = ACTIONS(343),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(341),
    [sym__cond_layout_end] = ACTIONS(341),
    [sym__cond_layout_end_explicit] = ACTIONS(341),
    [sym__phantom_where] = ACTIONS(341),
    [sym__phantom_bar] = ACTIONS(341),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(577),
    [sym__cond_no_section_op] = ACTIONS(579),
    [sym__cond_minus] = ACTIONS(581),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [152] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5596),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(611),
    [sym__cond_layout_end_explicit] = ACTIONS(611),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [153] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4956),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(507),
    [sym__cond_layout_end_explicit] = ACTIONS(507),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [154] = {
    [sym__at_type] = STATE(4204),
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym_explicit_type] = STATE(4207),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_op] = STATE(1425),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(139),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__variable_ticked] = STATE(1425),
    [sym__qvariable_ticked] = STATE(1425),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__constructor_ticked] = STATE(1425),
    [sym__qconstructor_ticked] = STATE(1425),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1425),
    [sym__operator_alias] = STATE(1425),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym_constructor_operator] = STATE(1425),
    [sym__constructor_operator_alias] = STATE(1425),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__tight_dot] = STATE(11412),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2577),
    [sym__paren_open] = STATE(377),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_SEMI] = ACTIONS(361),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_LBRACE] = ACTIONS(545),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [anon_sym_COLON_COLON] = ACTIONS(361),
    [anon_sym_u2237] = ACTIONS(361),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_where] = ACTIONS(363),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(361),
    [sym__cond_layout_end] = ACTIONS(361),
    [sym__cond_layout_end_explicit] = ACTIONS(361),
    [sym__phantom_where] = ACTIONS(361),
    [sym__phantom_bar] = ACTIONS(361),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(577),
    [sym__cond_no_section_op] = ACTIONS(579),
    [sym__cond_minus] = ACTIONS(581),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [155] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(10029),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(613),
    [sym__cond_layout_end_explicit] = ACTIONS(613),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [156] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4664),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(615),
    [sym__cond_layout_end_explicit] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [157] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4895),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(617),
    [sym__cond_layout_end_explicit] = ACTIONS(617),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [158] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(10035),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(501),
    [sym__cond_layout_end_explicit] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [159] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5491),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(457),
    [sym__cond_layout_end_explicit] = ACTIONS(457),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [160] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(2943),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(485),
    [sym__cond_layout_end_explicit] = ACTIONS(485),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [161] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4549),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(537),
    [sym__cond_layout_end_explicit] = ACTIONS(537),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [162] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5599),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(619),
    [sym__cond_layout_end_explicit] = ACTIONS(619),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [163] = {
    [sym__at_type] = STATE(4204),
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym_explicit_type] = STATE(4207),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_op] = STATE(1425),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(139),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__variable_ticked] = STATE(1425),
    [sym__qvariable_ticked] = STATE(1425),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__constructor_ticked] = STATE(1425),
    [sym__qconstructor_ticked] = STATE(1425),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1425),
    [sym__operator_alias] = STATE(1425),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym_constructor_operator] = STATE(1425),
    [sym__constructor_operator_alias] = STATE(1425),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__tight_dot] = STATE(11412),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2577),
    [sym__paren_open] = STATE(377),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_LBRACE] = ACTIONS(545),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [anon_sym_COLON_COLON] = ACTIONS(333),
    [anon_sym_u2237] = ACTIONS(333),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_where] = ACTIONS(335),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(333),
    [sym__cond_layout_end] = ACTIONS(333),
    [sym__cond_layout_end_explicit] = ACTIONS(333),
    [sym__phantom_where] = ACTIONS(333),
    [sym__phantom_bar] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(577),
    [sym__cond_no_section_op] = ACTIONS(579),
    [sym__cond_minus] = ACTIONS(581),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [164] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5361),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(621),
    [sym__cond_layout_end_explicit] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [165] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5115),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(623),
    [sym__cond_layout_end_explicit] = ACTIONS(623),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [166] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5601),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(497),
    [sym__cond_layout_end_explicit] = ACTIONS(497),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [167] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(5604),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(495),
    [sym__cond_layout_end_explicit] = ACTIONS(495),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [168] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4846),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(625),
    [sym__cond_layout_end_explicit] = ACTIONS(625),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [169] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(10037),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(483),
    [sym__cond_layout_end_explicit] = ACTIONS(483),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [170] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4218),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(467),
    [sym__cond_layout_end_explicit] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [171] = {
    [sym__at_type] = STATE(4204),
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym_explicit_type] = STATE(4207),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_op] = STATE(1425),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(139),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__variable_ticked] = STATE(1425),
    [sym__qvariable_ticked] = STATE(1425),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__constructor_ticked] = STATE(1425),
    [sym__qconstructor_ticked] = STATE(1425),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1425),
    [sym__operator_alias] = STATE(1425),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym_constructor_operator] = STATE(1425),
    [sym__constructor_operator_alias] = STATE(1425),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__tight_dot] = STATE(11412),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2577),
    [sym__paren_open] = STATE(377),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_LBRACE] = ACTIONS(545),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [anon_sym_COLON_COLON] = ACTIONS(333),
    [anon_sym_u2237] = ACTIONS(333),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_where] = ACTIONS(335),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(333),
    [sym__cond_layout_end] = ACTIONS(333),
    [sym__cond_layout_end_explicit] = ACTIONS(333),
    [sym__phantom_where] = ACTIONS(333),
    [sym__phantom_bar] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(577),
    [sym__cond_no_section_op] = ACTIONS(579),
    [sym__cond_minus] = ACTIONS(581),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [172] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__layout_end] = STATE(4602),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(627),
    [sym__cond_layout_end_explicit] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [173] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9492),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [174] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9518),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [175] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11116),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9699),
    [sym_view_pattern] = STATE(9699),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9419),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3611),
    [sym_quasiquote] = STATE(3611),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3608),
    [sym_unit] = STATE(3611),
    [sym_unboxed_unit] = STATE(3611),
    [sym_prefix_tuple] = STATE(3611),
    [sym_prefix_unboxed_tuple] = STATE(3611),
    [sym_prefix_unboxed_sum] = STATE(3611),
    [sym_literal] = STATE(3611),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3611),
    [sym__varsym_prefix] = STATE(3653),
    [sym__pvarsym] = STATE(3653),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3599),
    [sym__pconsym] = STATE(3599),
    [sym__qconsym_prefix] = STATE(3611),
    [sym__pqconsym] = STATE(3611),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(34),
    [sym__bracket_open] = STATE(366),
    [sym__unboxed_open] = STATE(191),
    [sym__unboxed_close] = STATE(7447),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10658),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(249),
    [sym_variable] = ACTIONS(631),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(633),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(645),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(647),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(649),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(651),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [176] = {
    [sym__at_type] = STATE(4660),
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym_explicit_type] = STATE(4658),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_op] = STATE(1746),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(229),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__variable_ticked] = STATE(1746),
    [sym__qvariable_ticked] = STATE(1746),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__constructor_ticked] = STATE(1746),
    [sym__qconstructor_ticked] = STATE(1746),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1746),
    [sym__operator_alias] = STATE(1746),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym_constructor_operator] = STATE(1746),
    [sym__constructor_operator_alias] = STATE(1746),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__colon2] = STATE(1694),
    [sym__tight_dot] = STATE(11333),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2656),
    [sym__paren_open] = STATE(394),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(685),
    [anon_sym_u2237] = ACTIONS(685),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_where] = ACTIONS(301),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(297),
    [sym__cond_layout_end] = ACTIONS(297),
    [sym__cond_layout_end_explicit] = ACTIONS(297),
    [sym__phantom_where] = ACTIONS(297),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(689),
    [sym__cond_no_section_op] = ACTIONS(691),
    [sym__cond_minus] = ACTIONS(693),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [177] = {
    [sym__at_type] = STATE(4660),
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym_explicit_type] = STATE(4658),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_op] = STATE(1746),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(229),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__variable_ticked] = STATE(1746),
    [sym__qvariable_ticked] = STATE(1746),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__constructor_ticked] = STATE(1746),
    [sym__qconstructor_ticked] = STATE(1746),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1746),
    [sym__operator_alias] = STATE(1746),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym_constructor_operator] = STATE(1746),
    [sym__constructor_operator_alias] = STATE(1746),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__colon2] = STATE(1698),
    [sym__tight_dot] = STATE(11333),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2656),
    [sym__paren_open] = STATE(394),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(695),
    [anon_sym_u2237] = ACTIONS(695),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_where] = ACTIONS(301),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(297),
    [sym__cond_layout_end] = ACTIONS(297),
    [sym__cond_layout_end_explicit] = ACTIONS(297),
    [sym__phantom_where] = ACTIONS(297),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(689),
    [sym__cond_no_section_op] = ACTIONS(691),
    [sym__cond_minus] = ACTIONS(693),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [178] = {
    [sym__at_type] = STATE(4833),
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym_explicit_type] = STATE(4834),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_op] = STATE(1417),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(219),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__variable_ticked] = STATE(1417),
    [sym__qvariable_ticked] = STATE(1417),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__constructor_ticked] = STATE(1417),
    [sym__qconstructor_ticked] = STATE(1417),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1417),
    [sym__operator_alias] = STATE(1417),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym_constructor_operator] = STATE(1417),
    [sym__constructor_operator_alias] = STATE(1417),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__colon2] = STATE(1573),
    [sym__tight_dot] = STATE(11530),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2476),
    [sym__paren_open] = STATE(375),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [anon_sym_u2192] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(729),
    [anon_sym_u2237] = ACTIONS(729),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(297),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_dotdot] = ACTIONS(297),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(733),
    [sym__cond_no_section_op] = ACTIONS(735),
    [sym__cond_minus] = ACTIONS(737),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [179] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9314),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [180] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9216),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [181] = {
    [sym__at_type] = STATE(4833),
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym_explicit_type] = STATE(4834),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_op] = STATE(1417),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(219),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__variable_ticked] = STATE(1417),
    [sym__qvariable_ticked] = STATE(1417),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__constructor_ticked] = STATE(1417),
    [sym__qconstructor_ticked] = STATE(1417),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1417),
    [sym__operator_alias] = STATE(1417),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym_constructor_operator] = STATE(1417),
    [sym__constructor_operator_alias] = STATE(1417),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__colon2] = STATE(1727),
    [sym__tight_dot] = STATE(11530),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2476),
    [sym__paren_open] = STATE(375),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [anon_sym_u2192] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(739),
    [anon_sym_u2237] = ACTIONS(739),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(297),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_dotdot] = ACTIONS(297),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(733),
    [sym__cond_no_section_op] = ACTIONS(735),
    [sym__cond_minus] = ACTIONS(737),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [182] = {
    [sym__at_type] = STATE(4308),
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym_explicit_type] = STATE(4309),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_op] = STATE(1439),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(244),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__variable_ticked] = STATE(1439),
    [sym__qvariable_ticked] = STATE(1439),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__constructor_ticked] = STATE(1439),
    [sym__qconstructor_ticked] = STATE(1439),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1439),
    [sym__operator_alias] = STATE(1439),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym_constructor_operator] = STATE(1439),
    [sym__constructor_operator_alias] = STATE(1439),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__colon2] = STATE(1665),
    [sym__tight_dot] = STATE(11813),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2519),
    [sym__paren_open] = STATE(395),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(759),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [anon_sym_PIPE2] = ACTIONS(297),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [anon_sym_u2192] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(773),
    [anon_sym_u2237] = ACTIONS(773),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(297),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(777),
    [sym__cond_no_section_op] = ACTIONS(779),
    [sym__cond_minus] = ACTIONS(781),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [183] = {
    [sym__at_type] = STATE(4308),
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym_explicit_type] = STATE(4309),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_op] = STATE(1439),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(244),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__variable_ticked] = STATE(1439),
    [sym__qvariable_ticked] = STATE(1439),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__constructor_ticked] = STATE(1439),
    [sym__qconstructor_ticked] = STATE(1439),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1439),
    [sym__operator_alias] = STATE(1439),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym_constructor_operator] = STATE(1439),
    [sym__constructor_operator_alias] = STATE(1439),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__colon2] = STATE(1537),
    [sym__tight_dot] = STATE(11813),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2519),
    [sym__paren_open] = STATE(395),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(301),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(759),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [anon_sym_PIPE2] = ACTIONS(297),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [anon_sym_u2192] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(783),
    [anon_sym_u2237] = ACTIONS(783),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(297),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(777),
    [sym__cond_no_section_op] = ACTIONS(779),
    [sym__cond_minus] = ACTIONS(781),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [184] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [185] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11116),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9626),
    [sym_view_pattern] = STATE(9626),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9419),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3611),
    [sym_quasiquote] = STATE(3611),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3608),
    [sym_unit] = STATE(3611),
    [sym_unboxed_unit] = STATE(3611),
    [sym_prefix_tuple] = STATE(3611),
    [sym_prefix_unboxed_tuple] = STATE(3611),
    [sym_prefix_unboxed_sum] = STATE(3611),
    [sym_literal] = STATE(3611),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3611),
    [sym__varsym_prefix] = STATE(3653),
    [sym__pvarsym] = STATE(3653),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3599),
    [sym__pconsym] = STATE(3599),
    [sym__qconsym_prefix] = STATE(3611),
    [sym__pqconsym] = STATE(3611),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(34),
    [sym__bracket_open] = STATE(366),
    [sym__unboxed_open] = STATE(191),
    [sym__unboxed_close] = STATE(6161),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10406),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(286),
    [sym_variable] = ACTIONS(631),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(785),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_PIPE] = ACTIONS(787),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(789),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(647),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(791),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(651),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [186] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(8891),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9626),
    [sym_view_pattern] = STATE(9626),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9171),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3512),
    [sym_quasiquote] = STATE(3512),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3513),
    [sym_unit] = STATE(3512),
    [sym_unboxed_unit] = STATE(3512),
    [sym_prefix_tuple] = STATE(3512),
    [sym_prefix_unboxed_tuple] = STATE(3512),
    [sym_prefix_unboxed_sum] = STATE(3512),
    [sym_literal] = STATE(3512),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3512),
    [sym__varsym_prefix] = STATE(3490),
    [sym__pvarsym] = STATE(3490),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(3522),
    [sym__pconsym] = STATE(3522),
    [sym__qconsym_prefix] = STATE(3512),
    [sym__pqconsym] = STATE(3512),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(31),
    [sym__bracket_open] = STATE(367),
    [sym__unboxed_open] = STATE(196),
    [sym__unboxed_close] = STATE(3277),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(902),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(264),
    [sym_variable] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(801),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(803),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(805),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [187] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9452),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [188] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9205),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [189] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(8907),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9603),
    [sym_view_pattern] = STATE(9603),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9171),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3512),
    [sym_quasiquote] = STATE(3512),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3513),
    [sym_unit] = STATE(3512),
    [sym_unboxed_unit] = STATE(3512),
    [sym_prefix_tuple] = STATE(3512),
    [sym_prefix_unboxed_tuple] = STATE(3512),
    [sym_prefix_unboxed_sum] = STATE(3512),
    [sym_literal] = STATE(3512),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3512),
    [sym__varsym_prefix] = STATE(3490),
    [sym__pvarsym] = STATE(3490),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(3522),
    [sym__pconsym] = STATE(3522),
    [sym__qconsym_prefix] = STATE(3512),
    [sym__pqconsym] = STATE(3512),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(31),
    [sym__bracket_open] = STATE(367),
    [sym__unboxed_open] = STATE(196),
    [sym__unboxed_close] = STATE(3751),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(907),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(280),
    [sym_variable] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(809),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(811),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(813),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(803),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(815),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [190] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(8870),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9603),
    [sym_view_pattern] = STATE(9603),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9171),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3512),
    [sym_quasiquote] = STATE(3512),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3513),
    [sym_unit] = STATE(3512),
    [sym_unboxed_unit] = STATE(3512),
    [sym_prefix_tuple] = STATE(3512),
    [sym_prefix_unboxed_tuple] = STATE(3512),
    [sym_prefix_unboxed_sum] = STATE(3512),
    [sym_literal] = STATE(3512),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3512),
    [sym__varsym_prefix] = STATE(3490),
    [sym__pvarsym] = STATE(3490),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(3522),
    [sym__pconsym] = STATE(3522),
    [sym__qconsym_prefix] = STATE(3512),
    [sym__pqconsym] = STATE(3512),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(31),
    [sym__bracket_open] = STATE(367),
    [sym__unboxed_open] = STATE(196),
    [sym__unboxed_close] = STATE(3658),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(889),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(285),
    [sym_variable] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(817),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(819),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(821),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(803),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(823),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [191] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(8879),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9603),
    [sym_view_pattern] = STATE(9603),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9171),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3512),
    [sym_quasiquote] = STATE(3512),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3513),
    [sym_unit] = STATE(3512),
    [sym_unboxed_unit] = STATE(3512),
    [sym_prefix_tuple] = STATE(3512),
    [sym_prefix_unboxed_tuple] = STATE(3512),
    [sym_prefix_unboxed_sum] = STATE(3512),
    [sym_literal] = STATE(3512),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3512),
    [sym__varsym_prefix] = STATE(3490),
    [sym__pvarsym] = STATE(3490),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(3522),
    [sym__pconsym] = STATE(3522),
    [sym__qconsym_prefix] = STATE(3512),
    [sym__pqconsym] = STATE(3512),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(31),
    [sym__bracket_open] = STATE(367),
    [sym__unboxed_open] = STATE(196),
    [sym__unboxed_close] = STATE(3434),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(880),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(288),
    [sym_variable] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(825),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(827),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(829),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(803),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(831),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [192] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9519),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [193] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11116),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9566),
    [sym_view_pattern] = STATE(9566),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9419),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3611),
    [sym_quasiquote] = STATE(3611),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3608),
    [sym_unit] = STATE(3611),
    [sym_unboxed_unit] = STATE(3611),
    [sym_prefix_tuple] = STATE(3611),
    [sym_prefix_unboxed_tuple] = STATE(3611),
    [sym_prefix_unboxed_sum] = STATE(3611),
    [sym_literal] = STATE(3611),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3611),
    [sym__varsym_prefix] = STATE(3653),
    [sym__pvarsym] = STATE(3653),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3599),
    [sym__pconsym] = STATE(3599),
    [sym__qconsym_prefix] = STATE(3611),
    [sym__pqconsym] = STATE(3611),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(34),
    [sym__bracket_open] = STATE(366),
    [sym__unboxed_open] = STATE(191),
    [sym__unboxed_close] = STATE(6202),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10626),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(282),
    [sym_variable] = ACTIONS(631),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(833),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_PIPE] = ACTIONS(835),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(837),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(647),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(839),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(651),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [194] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9329),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [195] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(8941),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9603),
    [sym_view_pattern] = STATE(9603),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9171),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3512),
    [sym_quasiquote] = STATE(3512),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3513),
    [sym_unit] = STATE(3512),
    [sym_unboxed_unit] = STATE(3512),
    [sym_prefix_tuple] = STATE(3512),
    [sym_prefix_unboxed_tuple] = STATE(3512),
    [sym_prefix_unboxed_sum] = STATE(3512),
    [sym_literal] = STATE(3512),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3512),
    [sym__varsym_prefix] = STATE(3490),
    [sym__pvarsym] = STATE(3490),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(3522),
    [sym__pconsym] = STATE(3522),
    [sym__qconsym_prefix] = STATE(3512),
    [sym__pqconsym] = STATE(3512),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(31),
    [sym__bracket_open] = STATE(367),
    [sym__unboxed_open] = STATE(196),
    [sym__unboxed_close] = STATE(3446),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(898),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(256),
    [sym_variable] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(841),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(845),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(803),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(847),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [196] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(8928),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9603),
    [sym_view_pattern] = STATE(9603),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9171),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3512),
    [sym_quasiquote] = STATE(3512),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3513),
    [sym_unit] = STATE(3512),
    [sym_unboxed_unit] = STATE(3512),
    [sym_prefix_tuple] = STATE(3512),
    [sym_prefix_unboxed_tuple] = STATE(3512),
    [sym_prefix_unboxed_sum] = STATE(3512),
    [sym_literal] = STATE(3512),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3512),
    [sym__varsym_prefix] = STATE(3490),
    [sym__pvarsym] = STATE(3490),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(3522),
    [sym__pconsym] = STATE(3522),
    [sym__qconsym_prefix] = STATE(3512),
    [sym__pqconsym] = STATE(3512),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(31),
    [sym__bracket_open] = STATE(367),
    [sym__unboxed_open] = STATE(196),
    [sym__unboxed_close] = STATE(3434),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(909),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(260),
    [sym_variable] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(849),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(851),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(853),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(803),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(831),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [197] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(8879),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9566),
    [sym_view_pattern] = STATE(9566),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9171),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3512),
    [sym_quasiquote] = STATE(3512),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3513),
    [sym_unit] = STATE(3512),
    [sym_unboxed_unit] = STATE(3512),
    [sym_prefix_tuple] = STATE(3512),
    [sym_prefix_unboxed_tuple] = STATE(3512),
    [sym_prefix_unboxed_sum] = STATE(3512),
    [sym_literal] = STATE(3512),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3512),
    [sym__varsym_prefix] = STATE(3490),
    [sym__pvarsym] = STATE(3490),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(3522),
    [sym__pconsym] = STATE(3522),
    [sym__qconsym_prefix] = STATE(3512),
    [sym__pqconsym] = STATE(3512),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(31),
    [sym__bracket_open] = STATE(367),
    [sym__unboxed_open] = STATE(196),
    [sym__unboxed_close] = STATE(2883),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(895),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(259),
    [sym_variable] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(855),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(859),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(803),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(861),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [198] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9387),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [199] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9167),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [200] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9307),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(367),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [201] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(8891),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9603),
    [sym_view_pattern] = STATE(9603),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9171),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3512),
    [sym_quasiquote] = STATE(3512),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3513),
    [sym_unit] = STATE(3512),
    [sym_unboxed_unit] = STATE(3512),
    [sym_prefix_tuple] = STATE(3512),
    [sym_prefix_unboxed_tuple] = STATE(3512),
    [sym_prefix_unboxed_sum] = STATE(3512),
    [sym_literal] = STATE(3512),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3512),
    [sym__varsym_prefix] = STATE(3490),
    [sym__pvarsym] = STATE(3490),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(3522),
    [sym__pconsym] = STATE(3522),
    [sym__qconsym_prefix] = STATE(3512),
    [sym__pqconsym] = STATE(3512),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(31),
    [sym__bracket_open] = STATE(367),
    [sym__unboxed_open] = STATE(196),
    [sym__unboxed_close] = STATE(3548),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(912),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(279),
    [sym_variable] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(863),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(867),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(803),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(869),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [202] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11116),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9673),
    [sym_view_pattern] = STATE(9673),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9419),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3611),
    [sym_quasiquote] = STATE(3611),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3608),
    [sym_unit] = STATE(3611),
    [sym_unboxed_unit] = STATE(3611),
    [sym_prefix_tuple] = STATE(3611),
    [sym_prefix_unboxed_tuple] = STATE(3611),
    [sym_prefix_unboxed_sum] = STATE(3611),
    [sym_literal] = STATE(3611),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3611),
    [sym__varsym_prefix] = STATE(3653),
    [sym__pvarsym] = STATE(3653),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3599),
    [sym__pconsym] = STATE(3599),
    [sym__qconsym_prefix] = STATE(3611),
    [sym__pqconsym] = STATE(3611),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(34),
    [sym__bracket_open] = STATE(366),
    [sym__unboxed_open] = STATE(191),
    [sym__unboxed_close] = STATE(7190),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10823),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(289),
    [sym_variable] = ACTIONS(631),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(871),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_PIPE] = ACTIONS(873),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(875),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(647),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(877),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(651),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [203] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(8913),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9603),
    [sym_view_pattern] = STATE(9603),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9171),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3512),
    [sym_quasiquote] = STATE(3512),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3513),
    [sym_unit] = STATE(3512),
    [sym_unboxed_unit] = STATE(3512),
    [sym_prefix_tuple] = STATE(3512),
    [sym_prefix_unboxed_tuple] = STATE(3512),
    [sym_prefix_unboxed_sum] = STATE(3512),
    [sym_literal] = STATE(3512),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3512),
    [sym__varsym_prefix] = STATE(3490),
    [sym__pvarsym] = STATE(3490),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(3522),
    [sym__pconsym] = STATE(3522),
    [sym__qconsym_prefix] = STATE(3512),
    [sym__pqconsym] = STATE(3512),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(31),
    [sym__bracket_open] = STATE(367),
    [sym__unboxed_open] = STATE(196),
    [sym__unboxed_close] = STATE(2883),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(905),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(262),
    [sym_variable] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(879),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(881),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(883),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(803),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(861),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [204] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(8879),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9603),
    [sym_view_pattern] = STATE(9603),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9171),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3512),
    [sym_quasiquote] = STATE(3512),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3513),
    [sym_unit] = STATE(3512),
    [sym_unboxed_unit] = STATE(3512),
    [sym_prefix_tuple] = STATE(3512),
    [sym_prefix_unboxed_tuple] = STATE(3512),
    [sym_prefix_unboxed_sum] = STATE(3512),
    [sym_literal] = STATE(3512),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3512),
    [sym__varsym_prefix] = STATE(3490),
    [sym__pvarsym] = STATE(3490),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(3522),
    [sym__pconsym] = STATE(3522),
    [sym__qconsym_prefix] = STATE(3512),
    [sym__pqconsym] = STATE(3512),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(31),
    [sym__bracket_open] = STATE(367),
    [sym__unboxed_open] = STATE(196),
    [sym__unboxed_close] = STATE(2883),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(895),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(274),
    [sym_variable] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(855),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(885),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(887),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(803),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(861),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [205] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(8907),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9566),
    [sym_view_pattern] = STATE(9566),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9171),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3512),
    [sym_quasiquote] = STATE(3512),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3513),
    [sym_unit] = STATE(3512),
    [sym_unboxed_unit] = STATE(3512),
    [sym_prefix_tuple] = STATE(3512),
    [sym_prefix_unboxed_tuple] = STATE(3512),
    [sym_prefix_unboxed_sum] = STATE(3512),
    [sym_literal] = STATE(3512),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3512),
    [sym__varsym_prefix] = STATE(3490),
    [sym__pvarsym] = STATE(3490),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(3522),
    [sym__pconsym] = STATE(3522),
    [sym__qconsym_prefix] = STATE(3512),
    [sym__pqconsym] = STATE(3512),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(31),
    [sym__bracket_open] = STATE(367),
    [sym__unboxed_open] = STATE(196),
    [sym__unboxed_close] = STATE(3751),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(907),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(261),
    [sym_variable] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(809),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(891),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(803),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(815),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [206] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11116),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9603),
    [sym_view_pattern] = STATE(9603),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9419),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3611),
    [sym_quasiquote] = STATE(3611),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3608),
    [sym_unit] = STATE(3611),
    [sym_unboxed_unit] = STATE(3611),
    [sym_prefix_tuple] = STATE(3611),
    [sym_prefix_unboxed_tuple] = STATE(3611),
    [sym_prefix_unboxed_sum] = STATE(3611),
    [sym_literal] = STATE(3611),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3611),
    [sym__varsym_prefix] = STATE(3653),
    [sym__pvarsym] = STATE(3653),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3599),
    [sym__pconsym] = STATE(3599),
    [sym__qconsym_prefix] = STATE(3611),
    [sym__pqconsym] = STATE(3611),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(34),
    [sym__bracket_open] = STATE(366),
    [sym__unboxed_open] = STATE(191),
    [sym__unboxed_close] = STATE(5774),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10108),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(250),
    [sym_variable] = ACTIONS(631),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_PIPE] = ACTIONS(895),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(897),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(647),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(899),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(651),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [207] = {
    [sym__at_type] = STATE(4308),
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym_explicit_type] = STATE(4309),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_op] = STATE(1439),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(244),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__variable_ticked] = STATE(1439),
    [sym__qvariable_ticked] = STATE(1439),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__constructor_ticked] = STATE(1439),
    [sym__qconstructor_ticked] = STATE(1439),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1439),
    [sym__operator_alias] = STATE(1439),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym_constructor_operator] = STATE(1439),
    [sym__constructor_operator_alias] = STATE(1439),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__tight_dot] = STATE(11813),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2519),
    [sym__paren_open] = STATE(395),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(343),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(759),
    [anon_sym_DASH_GT] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [anon_sym_PIPE2] = ACTIONS(341),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [anon_sym_u2192] = ACTIONS(341),
    [anon_sym_COLON_COLON] = ACTIONS(341),
    [anon_sym_u2237] = ACTIONS(341),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(341),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(777),
    [sym__cond_no_section_op] = ACTIONS(779),
    [sym__cond_minus] = ACTIONS(781),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [208] = {
    [sym__at_type] = STATE(4308),
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym_explicit_type] = STATE(4309),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_op] = STATE(1439),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(244),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__variable_ticked] = STATE(1439),
    [sym__qvariable_ticked] = STATE(1439),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__constructor_ticked] = STATE(1439),
    [sym__qconstructor_ticked] = STATE(1439),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1439),
    [sym__operator_alias] = STATE(1439),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym_constructor_operator] = STATE(1439),
    [sym__constructor_operator_alias] = STATE(1439),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__tight_dot] = STATE(11813),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2519),
    [sym__paren_open] = STATE(395),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(363),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(759),
    [anon_sym_DASH_GT] = ACTIONS(361),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [anon_sym_PIPE2] = ACTIONS(361),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [anon_sym_u2192] = ACTIONS(361),
    [anon_sym_COLON_COLON] = ACTIONS(361),
    [anon_sym_u2237] = ACTIONS(361),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(361),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(777),
    [sym__cond_no_section_op] = ACTIONS(779),
    [sym__cond_minus] = ACTIONS(781),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [209] = {
    [sym__at_type] = STATE(5016),
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym_explicit_type] = STATE(5013),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_op] = STATE(1621),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1621),
    [sym__qvariable_ticked] = STATE(1621),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1621),
    [sym__qconstructor_ticked] = STATE(1621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1621),
    [sym__operator_alias] = STATE(1621),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(1621),
    [sym__constructor_operator_alias] = STATE(1621),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__colon2] = STATE(1548),
    [sym__tight_dot] = STATE(11863),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2433),
    [sym__paren_open] = STATE(397),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [anon_sym_u2192] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_u2237] = ACTIONS(365),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(297),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(917),
    [sym__cond_left_section_op] = ACTIONS(919),
    [sym__cond_no_section_op] = ACTIONS(921),
    [sym__cond_minus] = ACTIONS(923),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [210] = {
    [sym__at_type] = STATE(4308),
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym_explicit_type] = STATE(4309),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_op] = STATE(1439),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(244),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__variable_ticked] = STATE(1439),
    [sym__qvariable_ticked] = STATE(1439),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__constructor_ticked] = STATE(1439),
    [sym__qconstructor_ticked] = STATE(1439),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1439),
    [sym__operator_alias] = STATE(1439),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym_constructor_operator] = STATE(1439),
    [sym__constructor_operator_alias] = STATE(1439),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__tight_dot] = STATE(11813),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2519),
    [sym__paren_open] = STATE(395),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(349),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(351),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(759),
    [anon_sym_DASH_GT] = ACTIONS(349),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [anon_sym_PIPE2] = ACTIONS(349),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [anon_sym_u2192] = ACTIONS(349),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [anon_sym_u2237] = ACTIONS(349),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(349),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(777),
    [sym__cond_no_section_op] = ACTIONS(779),
    [sym__cond_minus] = ACTIONS(781),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [211] = {
    [sym__at_type] = STATE(4660),
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym_explicit_type] = STATE(4658),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_op] = STATE(1746),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(229),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__variable_ticked] = STATE(1746),
    [sym__qvariable_ticked] = STATE(1746),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__constructor_ticked] = STATE(1746),
    [sym__qconstructor_ticked] = STATE(1746),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1746),
    [sym__operator_alias] = STATE(1746),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym_constructor_operator] = STATE(1746),
    [sym__constructor_operator_alias] = STATE(1746),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__tight_dot] = STATE(11333),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2656),
    [sym__paren_open] = STATE(394),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_u2237] = ACTIONS(353),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_where] = ACTIONS(355),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(353),
    [sym__cond_layout_end] = ACTIONS(353),
    [sym__cond_layout_end_explicit] = ACTIONS(353),
    [sym__phantom_where] = ACTIONS(353),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(689),
    [sym__cond_no_section_op] = ACTIONS(691),
    [sym__cond_minus] = ACTIONS(693),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [212] = {
    [sym__at_type] = STATE(4308),
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym_explicit_type] = STATE(4309),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_op] = STATE(1439),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(244),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__variable_ticked] = STATE(1439),
    [sym__qvariable_ticked] = STATE(1439),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__constructor_ticked] = STATE(1439),
    [sym__qconstructor_ticked] = STATE(1439),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1439),
    [sym__operator_alias] = STATE(1439),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym_constructor_operator] = STATE(1439),
    [sym__constructor_operator_alias] = STATE(1439),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__tight_dot] = STATE(11813),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2519),
    [sym__paren_open] = STATE(395),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(353),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(759),
    [anon_sym_DASH_GT] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [anon_sym_PIPE2] = ACTIONS(353),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [anon_sym_u2192] = ACTIONS(353),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_u2237] = ACTIONS(353),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(353),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(777),
    [sym__cond_no_section_op] = ACTIONS(779),
    [sym__cond_minus] = ACTIONS(781),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [213] = {
    [sym__at_type] = STATE(5016),
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym_explicit_type] = STATE(5013),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_op] = STATE(1621),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1621),
    [sym__qvariable_ticked] = STATE(1621),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1621),
    [sym__qconstructor_ticked] = STATE(1621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1621),
    [sym__operator_alias] = STATE(1621),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(1621),
    [sym__constructor_operator_alias] = STATE(1621),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__colon2] = STATE(1548),
    [sym__tight_dot] = STATE(11863),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2433),
    [sym__paren_open] = STATE(397),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [anon_sym_u2192] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_u2237] = ACTIONS(365),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(297),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(917),
    [sym__cond_left_section_op] = ACTIONS(925),
    [sym__cond_no_section_op] = ACTIONS(921),
    [sym__cond_minus] = ACTIONS(923),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [214] = {
    [sym__at_type] = STATE(5016),
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym_explicit_type] = STATE(5013),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_op] = STATE(1621),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1621),
    [sym__qvariable_ticked] = STATE(1621),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1621),
    [sym__qconstructor_ticked] = STATE(1621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1621),
    [sym__operator_alias] = STATE(1621),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(1621),
    [sym__constructor_operator_alias] = STATE(1621),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__colon2] = STATE(1548),
    [sym__tight_dot] = STATE(11863),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2433),
    [sym__paren_open] = STATE(397),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [anon_sym_u2192] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_u2237] = ACTIONS(365),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(297),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(917),
    [sym__cond_left_section_op] = ACTIONS(927),
    [sym__cond_no_section_op] = ACTIONS(921),
    [sym__cond_minus] = ACTIONS(923),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [215] = {
    [sym__at_type] = STATE(5016),
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym_explicit_type] = STATE(5013),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_op] = STATE(1621),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1621),
    [sym__qvariable_ticked] = STATE(1621),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1621),
    [sym__qconstructor_ticked] = STATE(1621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1621),
    [sym__operator_alias] = STATE(1621),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(1621),
    [sym__constructor_operator_alias] = STATE(1621),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__colon2] = STATE(1548),
    [sym__tight_dot] = STATE(11863),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2433),
    [sym__paren_open] = STATE(397),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [anon_sym_u2192] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_u2237] = ACTIONS(365),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(297),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(917),
    [sym__cond_left_section_op] = ACTIONS(929),
    [sym__cond_no_section_op] = ACTIONS(921),
    [sym__cond_minus] = ACTIONS(923),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [216] = {
    [sym__at_type] = STATE(4308),
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym_explicit_type] = STATE(4309),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_op] = STATE(1439),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(244),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__variable_ticked] = STATE(1439),
    [sym__qvariable_ticked] = STATE(1439),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__constructor_ticked] = STATE(1439),
    [sym__qconstructor_ticked] = STATE(1439),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1439),
    [sym__operator_alias] = STATE(1439),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym_constructor_operator] = STATE(1439),
    [sym__constructor_operator_alias] = STATE(1439),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__tight_dot] = STATE(11813),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2519),
    [sym__paren_open] = STATE(395),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(335),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(759),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [anon_sym_PIPE2] = ACTIONS(333),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [anon_sym_u2192] = ACTIONS(333),
    [anon_sym_COLON_COLON] = ACTIONS(333),
    [anon_sym_u2237] = ACTIONS(333),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(333),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(777),
    [sym__cond_no_section_op] = ACTIONS(779),
    [sym__cond_minus] = ACTIONS(781),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [217] = {
    [sym__at_type] = STATE(4308),
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym_explicit_type] = STATE(4309),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_op] = STATE(1439),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(244),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__variable_ticked] = STATE(1439),
    [sym__qvariable_ticked] = STATE(1439),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__constructor_ticked] = STATE(1439),
    [sym__qconstructor_ticked] = STATE(1439),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1439),
    [sym__operator_alias] = STATE(1439),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym_constructor_operator] = STATE(1439),
    [sym__constructor_operator_alias] = STATE(1439),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__tight_dot] = STATE(11813),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2519),
    [sym__paren_open] = STATE(395),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(335),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(759),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [anon_sym_PIPE2] = ACTIONS(333),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [anon_sym_u2192] = ACTIONS(333),
    [anon_sym_COLON_COLON] = ACTIONS(333),
    [anon_sym_u2237] = ACTIONS(333),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(333),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(777),
    [sym__cond_no_section_op] = ACTIONS(779),
    [sym__cond_minus] = ACTIONS(781),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [218] = {
    [sym__at_type] = STATE(5016),
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym_explicit_type] = STATE(5013),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_op] = STATE(1621),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1621),
    [sym__qvariable_ticked] = STATE(1621),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1621),
    [sym__qconstructor_ticked] = STATE(1621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1621),
    [sym__operator_alias] = STATE(1621),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(1621),
    [sym__constructor_operator_alias] = STATE(1621),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__colon2] = STATE(1548),
    [sym__tight_dot] = STATE(11863),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2433),
    [sym__paren_open] = STATE(397),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [anon_sym_u2192] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_u2237] = ACTIONS(365),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(297),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(917),
    [sym__cond_left_section_op] = ACTIONS(931),
    [sym__cond_no_section_op] = ACTIONS(921),
    [sym__cond_minus] = ACTIONS(923),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [219] = {
    [sym__at_type] = STATE(4833),
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym_explicit_type] = STATE(4834),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_op] = STATE(1417),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(219),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__variable_ticked] = STATE(1417),
    [sym__qvariable_ticked] = STATE(1417),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__constructor_ticked] = STATE(1417),
    [sym__qconstructor_ticked] = STATE(1417),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1417),
    [sym__operator_alias] = STATE(1417),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym_constructor_operator] = STATE(1417),
    [sym__constructor_operator_alias] = STATE(1417),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__tight_dot] = STATE(11530),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2476),
    [sym__paren_open] = STATE(375),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(339),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_SQUOTE] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(339),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(337),
    [anon_sym_mdo] = ACTIONS(337),
    [anon_sym_do] = ACTIONS(337),
    [anon_sym_case] = ACTIONS(337),
    [anon_sym_DASH] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(339),
    [anon_sym_u27e6] = ACTIONS(339),
    [sym_float] = ACTIONS(339),
    [sym_char] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym__integer_literal] = ACTIONS(337),
    [sym__binary_literal] = ACTIONS(339),
    [sym__octal_literal] = ACTIONS(339),
    [sym__hex_literal] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_POUND] = ACTIONS(337),
    [anon_sym_POUND2] = ACTIONS(337),
    [sym_implicit_variable] = ACTIONS(339),
    [sym_name] = ACTIONS(339),
    [sym_label] = ACTIONS(339),
    [anon_sym_u2192] = ACTIONS(339),
    [anon_sym_COLON_COLON] = ACTIONS(339),
    [anon_sym_u2237] = ACTIONS(339),
    [aux_sym__paren_open_token1] = ACTIONS(339),
    [anon_sym_RBRACK] = ACTIONS(339),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(339),
    [sym__cond_splice] = ACTIONS(339),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(339),
    [sym__cond_dotdot] = ACTIONS(339),
    [sym__cond_prefix_at] = ACTIONS(339),
    [sym__cond_qualified_op] = ACTIONS(339),
    [sym__cond_no_section_op] = ACTIONS(339),
    [sym__cond_minus] = ACTIONS(339),
    [sym__varsym] = ACTIONS(339),
    [sym__consym] = ACTIONS(339),
  },
  [220] = {
    [sym__at_type] = STATE(5016),
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym_explicit_type] = STATE(5013),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_op] = STATE(1621),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1621),
    [sym__qvariable_ticked] = STATE(1621),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1621),
    [sym__qconstructor_ticked] = STATE(1621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1621),
    [sym__operator_alias] = STATE(1621),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(1621),
    [sym__constructor_operator_alias] = STATE(1621),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__colon2] = STATE(1496),
    [sym__tight_dot] = STATE(11863),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2433),
    [sym__paren_open] = STATE(397),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [anon_sym_u2192] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(933),
    [anon_sym_u2237] = ACTIONS(933),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(297),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(917),
    [sym__cond_left_section_op] = ACTIONS(297),
    [sym__cond_no_section_op] = ACTIONS(921),
    [sym__cond_minus] = ACTIONS(923),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [221] = {
    [sym__at_type] = STATE(4833),
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym_explicit_type] = STATE(4834),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_op] = STATE(1417),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(219),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__variable_ticked] = STATE(1417),
    [sym__qvariable_ticked] = STATE(1417),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__constructor_ticked] = STATE(1417),
    [sym__qconstructor_ticked] = STATE(1417),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1417),
    [sym__operator_alias] = STATE(1417),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym_constructor_operator] = STATE(1417),
    [sym__constructor_operator_alias] = STATE(1417),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__tight_dot] = STATE(11530),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2476),
    [sym__paren_open] = STATE(375),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(345),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_STAR] = ACTIONS(345),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_PIPE] = ACTIONS(345),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_DASH_GT] = ACTIONS(345),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_POUND] = ACTIONS(347),
    [anon_sym_POUND2] = ACTIONS(347),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [anon_sym_u2192] = ACTIONS(345),
    [anon_sym_COLON_COLON] = ACTIONS(345),
    [anon_sym_u2237] = ACTIONS(345),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(345),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(345),
    [sym__cond_dotdot] = ACTIONS(345),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(345),
    [sym__cond_no_section_op] = ACTIONS(345),
    [sym__cond_minus] = ACTIONS(345),
    [sym__varsym] = ACTIONS(345),
    [sym__consym] = ACTIONS(345),
  },
  [222] = {
    [sym__at_type] = STATE(4833),
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym_explicit_type] = STATE(4834),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_op] = STATE(1417),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(219),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__variable_ticked] = STATE(1417),
    [sym__qvariable_ticked] = STATE(1417),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__constructor_ticked] = STATE(1417),
    [sym__qconstructor_ticked] = STATE(1417),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1417),
    [sym__operator_alias] = STATE(1417),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym_constructor_operator] = STATE(1417),
    [sym__constructor_operator_alias] = STATE(1417),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__tight_dot] = STATE(11530),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2476),
    [sym__paren_open] = STATE(375),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_PIPE] = ACTIONS(341),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_DASH_GT] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [anon_sym_u2192] = ACTIONS(341),
    [anon_sym_COLON_COLON] = ACTIONS(341),
    [anon_sym_u2237] = ACTIONS(341),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(341),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_dotdot] = ACTIONS(341),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(733),
    [sym__cond_no_section_op] = ACTIONS(735),
    [sym__cond_minus] = ACTIONS(737),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [223] = {
    [sym__at_type] = STATE(5016),
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym_explicit_type] = STATE(5013),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_op] = STATE(1621),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1621),
    [sym__qvariable_ticked] = STATE(1621),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1621),
    [sym__qconstructor_ticked] = STATE(1621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1621),
    [sym__operator_alias] = STATE(1621),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(1621),
    [sym__constructor_operator_alias] = STATE(1621),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__colon2] = STATE(1548),
    [sym__tight_dot] = STATE(11863),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2433),
    [sym__paren_open] = STATE(397),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [anon_sym_u2192] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_u2237] = ACTIONS(365),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(297),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(917),
    [sym__cond_left_section_op] = ACTIONS(935),
    [sym__cond_no_section_op] = ACTIONS(921),
    [sym__cond_minus] = ACTIONS(923),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [224] = {
    [sym__at_type] = STATE(4833),
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym_explicit_type] = STATE(4834),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_op] = STATE(1417),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(219),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__variable_ticked] = STATE(1417),
    [sym__qvariable_ticked] = STATE(1417),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__constructor_ticked] = STATE(1417),
    [sym__qconstructor_ticked] = STATE(1417),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1417),
    [sym__operator_alias] = STATE(1417),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym_constructor_operator] = STATE(1417),
    [sym__constructor_operator_alias] = STATE(1417),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__tight_dot] = STATE(11530),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2476),
    [sym__paren_open] = STATE(375),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(349),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_PIPE] = ACTIONS(349),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_DASH_GT] = ACTIONS(349),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [anon_sym_u2192] = ACTIONS(349),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [anon_sym_u2237] = ACTIONS(349),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(349),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_dotdot] = ACTIONS(349),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(733),
    [sym__cond_no_section_op] = ACTIONS(735),
    [sym__cond_minus] = ACTIONS(737),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [225] = {
    [sym__at_type] = STATE(4660),
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym_explicit_type] = STATE(4658),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_op] = STATE(1746),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(229),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__variable_ticked] = STATE(1746),
    [sym__qvariable_ticked] = STATE(1746),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__constructor_ticked] = STATE(1746),
    [sym__qconstructor_ticked] = STATE(1746),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1746),
    [sym__operator_alias] = STATE(1746),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym_constructor_operator] = STATE(1746),
    [sym__constructor_operator_alias] = STATE(1746),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__tight_dot] = STATE(11333),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2656),
    [sym__paren_open] = STATE(394),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(349),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [anon_sym_u2237] = ACTIONS(349),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_where] = ACTIONS(351),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(349),
    [sym__cond_layout_end] = ACTIONS(349),
    [sym__cond_layout_end_explicit] = ACTIONS(349),
    [sym__phantom_where] = ACTIONS(349),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(689),
    [sym__cond_no_section_op] = ACTIONS(691),
    [sym__cond_minus] = ACTIONS(693),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [226] = {
    [sym__at_type] = STATE(4660),
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym_explicit_type] = STATE(4658),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_op] = STATE(1746),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(229),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__variable_ticked] = STATE(1746),
    [sym__qvariable_ticked] = STATE(1746),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__constructor_ticked] = STATE(1746),
    [sym__qconstructor_ticked] = STATE(1746),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1746),
    [sym__operator_alias] = STATE(1746),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym_constructor_operator] = STATE(1746),
    [sym__constructor_operator_alias] = STATE(1746),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__tight_dot] = STATE(11333),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2656),
    [sym__paren_open] = STATE(394),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(341),
    [anon_sym_u2237] = ACTIONS(341),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_where] = ACTIONS(343),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(341),
    [sym__cond_layout_end] = ACTIONS(341),
    [sym__cond_layout_end_explicit] = ACTIONS(341),
    [sym__phantom_where] = ACTIONS(341),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(689),
    [sym__cond_no_section_op] = ACTIONS(691),
    [sym__cond_minus] = ACTIONS(693),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [227] = {
    [sym__at_type] = STATE(4833),
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym_explicit_type] = STATE(4834),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_op] = STATE(1417),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(219),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__variable_ticked] = STATE(1417),
    [sym__qvariable_ticked] = STATE(1417),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__constructor_ticked] = STATE(1417),
    [sym__qconstructor_ticked] = STATE(1417),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1417),
    [sym__operator_alias] = STATE(1417),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym_constructor_operator] = STATE(1417),
    [sym__constructor_operator_alias] = STATE(1417),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__tight_dot] = STATE(11530),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2476),
    [sym__paren_open] = STATE(375),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_PIPE] = ACTIONS(357),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_DASH_GT] = ACTIONS(357),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [anon_sym_u2192] = ACTIONS(357),
    [anon_sym_COLON_COLON] = ACTIONS(357),
    [anon_sym_u2237] = ACTIONS(357),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(357),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_dotdot] = ACTIONS(357),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(733),
    [sym__cond_no_section_op] = ACTIONS(735),
    [sym__cond_minus] = ACTIONS(737),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [228] = {
    [sym__at_type] = STATE(4833),
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym_explicit_type] = STATE(4834),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_op] = STATE(1417),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(219),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__variable_ticked] = STATE(1417),
    [sym__qvariable_ticked] = STATE(1417),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__constructor_ticked] = STATE(1417),
    [sym__qconstructor_ticked] = STATE(1417),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1417),
    [sym__operator_alias] = STATE(1417),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym_constructor_operator] = STATE(1417),
    [sym__constructor_operator_alias] = STATE(1417),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__tight_dot] = STATE(11530),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2476),
    [sym__paren_open] = STATE(375),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(353),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_PIPE] = ACTIONS(353),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_DASH_GT] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [anon_sym_u2192] = ACTIONS(353),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_u2237] = ACTIONS(353),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(353),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_dotdot] = ACTIONS(353),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(733),
    [sym__cond_no_section_op] = ACTIONS(735),
    [sym__cond_minus] = ACTIONS(737),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [229] = {
    [sym__at_type] = STATE(4660),
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym_explicit_type] = STATE(4658),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_op] = STATE(1746),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(229),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__variable_ticked] = STATE(1746),
    [sym__qvariable_ticked] = STATE(1746),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__constructor_ticked] = STATE(1746),
    [sym__qconstructor_ticked] = STATE(1746),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1746),
    [sym__operator_alias] = STATE(1746),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym_constructor_operator] = STATE(1746),
    [sym__constructor_operator_alias] = STATE(1746),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__tight_dot] = STATE(11333),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2656),
    [sym__paren_open] = STATE(394),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_let] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(339),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(337),
    [anon_sym_mdo] = ACTIONS(337),
    [anon_sym_do] = ACTIONS(337),
    [anon_sym_case] = ACTIONS(337),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(339),
    [anon_sym_u27e6] = ACTIONS(339),
    [sym_float] = ACTIONS(339),
    [sym_char] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym__integer_literal] = ACTIONS(337),
    [sym__binary_literal] = ACTIONS(339),
    [sym__octal_literal] = ACTIONS(339),
    [sym__hex_literal] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_POUND] = ACTIONS(337),
    [anon_sym_POUND2] = ACTIONS(337),
    [sym_implicit_variable] = ACTIONS(339),
    [sym_name] = ACTIONS(339),
    [sym_label] = ACTIONS(339),
    [anon_sym_COLON_COLON] = ACTIONS(339),
    [anon_sym_u2237] = ACTIONS(339),
    [aux_sym__paren_open_token1] = ACTIONS(339),
    [anon_sym_where] = ACTIONS(337),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(339),
    [sym__cond_layout_end] = ACTIONS(339),
    [sym__cond_layout_end_explicit] = ACTIONS(339),
    [sym__phantom_where] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(339),
    [sym__cond_splice] = ACTIONS(339),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(339),
    [sym__cond_prefix_at] = ACTIONS(339),
    [sym__cond_qualified_op] = ACTIONS(339),
    [sym__cond_no_section_op] = ACTIONS(339),
    [sym__cond_minus] = ACTIONS(339),
    [sym__varsym] = ACTIONS(339),
    [sym__consym] = ACTIONS(339),
  },
  [230] = {
    [sym__at_type] = STATE(4833),
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym_explicit_type] = STATE(4834),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_op] = STATE(1417),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(219),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__variable_ticked] = STATE(1417),
    [sym__qvariable_ticked] = STATE(1417),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__constructor_ticked] = STATE(1417),
    [sym__qconstructor_ticked] = STATE(1417),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1417),
    [sym__operator_alias] = STATE(1417),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym_constructor_operator] = STATE(1417),
    [sym__constructor_operator_alias] = STATE(1417),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__tight_dot] = STATE(11530),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2476),
    [sym__paren_open] = STATE(375),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_PIPE] = ACTIONS(357),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_DASH_GT] = ACTIONS(357),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [anon_sym_u2192] = ACTIONS(357),
    [anon_sym_COLON_COLON] = ACTIONS(357),
    [anon_sym_u2237] = ACTIONS(357),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(357),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_dotdot] = ACTIONS(357),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(733),
    [sym__cond_no_section_op] = ACTIONS(735),
    [sym__cond_minus] = ACTIONS(737),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [231] = {
    [sym__at_type] = STATE(5016),
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym_explicit_type] = STATE(5013),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_op] = STATE(1621),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1621),
    [sym__qvariable_ticked] = STATE(1621),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1621),
    [sym__qconstructor_ticked] = STATE(1621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1621),
    [sym__operator_alias] = STATE(1621),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(1621),
    [sym__constructor_operator_alias] = STATE(1621),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__colon2] = STATE(1548),
    [sym__tight_dot] = STATE(11863),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2433),
    [sym__paren_open] = STATE(397),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [anon_sym_u2192] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_u2237] = ACTIONS(365),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(297),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(917),
    [sym__cond_left_section_op] = ACTIONS(937),
    [sym__cond_no_section_op] = ACTIONS(921),
    [sym__cond_minus] = ACTIONS(923),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [232] = {
    [sym__at_type] = STATE(4833),
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym_explicit_type] = STATE(4834),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_op] = STATE(1417),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(219),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__variable_ticked] = STATE(1417),
    [sym__qvariable_ticked] = STATE(1417),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__constructor_ticked] = STATE(1417),
    [sym__qconstructor_ticked] = STATE(1417),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1417),
    [sym__operator_alias] = STATE(1417),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym_constructor_operator] = STATE(1417),
    [sym__constructor_operator_alias] = STATE(1417),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__tight_dot] = STATE(11530),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2476),
    [sym__paren_open] = STATE(375),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_DASH_GT] = ACTIONS(361),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [anon_sym_u2192] = ACTIONS(361),
    [anon_sym_COLON_COLON] = ACTIONS(361),
    [anon_sym_u2237] = ACTIONS(361),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(361),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_dotdot] = ACTIONS(361),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(733),
    [sym__cond_no_section_op] = ACTIONS(735),
    [sym__cond_minus] = ACTIONS(737),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [233] = {
    [sym__at_type] = STATE(4660),
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym_explicit_type] = STATE(4658),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_op] = STATE(1746),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(229),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__variable_ticked] = STATE(1746),
    [sym__qvariable_ticked] = STATE(1746),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__constructor_ticked] = STATE(1746),
    [sym__qconstructor_ticked] = STATE(1746),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1746),
    [sym__operator_alias] = STATE(1746),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym_constructor_operator] = STATE(1746),
    [sym__constructor_operator_alias] = STATE(1746),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__tight_dot] = STATE(11333),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2656),
    [sym__paren_open] = STATE(394),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(345),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_STAR] = ACTIONS(345),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_POUND] = ACTIONS(347),
    [anon_sym_POUND2] = ACTIONS(347),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(345),
    [anon_sym_u2237] = ACTIONS(345),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_where] = ACTIONS(347),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(345),
    [sym__cond_layout_end] = ACTIONS(345),
    [sym__cond_layout_end_explicit] = ACTIONS(345),
    [sym__phantom_where] = ACTIONS(345),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(345),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(345),
    [sym__cond_no_section_op] = ACTIONS(345),
    [sym__cond_minus] = ACTIONS(345),
    [sym__varsym] = ACTIONS(345),
    [sym__consym] = ACTIONS(345),
  },
  [234] = {
    [sym__at_type] = STATE(4660),
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym_explicit_type] = STATE(4658),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_op] = STATE(1746),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(229),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__variable_ticked] = STATE(1746),
    [sym__qvariable_ticked] = STATE(1746),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__constructor_ticked] = STATE(1746),
    [sym__qconstructor_ticked] = STATE(1746),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1746),
    [sym__operator_alias] = STATE(1746),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym_constructor_operator] = STATE(1746),
    [sym__constructor_operator_alias] = STATE(1746),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__tight_dot] = STATE(11333),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2656),
    [sym__paren_open] = STATE(394),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(333),
    [anon_sym_u2237] = ACTIONS(333),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_where] = ACTIONS(335),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(333),
    [sym__cond_layout_end] = ACTIONS(333),
    [sym__cond_layout_end_explicit] = ACTIONS(333),
    [sym__phantom_where] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(689),
    [sym__cond_no_section_op] = ACTIONS(691),
    [sym__cond_minus] = ACTIONS(693),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [235] = {
    [sym__at_type] = STATE(4660),
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym_explicit_type] = STATE(4658),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_op] = STATE(1746),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(229),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__variable_ticked] = STATE(1746),
    [sym__qvariable_ticked] = STATE(1746),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__constructor_ticked] = STATE(1746),
    [sym__qconstructor_ticked] = STATE(1746),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1746),
    [sym__operator_alias] = STATE(1746),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym_constructor_operator] = STATE(1746),
    [sym__constructor_operator_alias] = STATE(1746),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__tight_dot] = STATE(11333),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2656),
    [sym__paren_open] = STATE(394),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(361),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(361),
    [anon_sym_u2237] = ACTIONS(361),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_where] = ACTIONS(363),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(361),
    [sym__cond_layout_end] = ACTIONS(361),
    [sym__cond_layout_end_explicit] = ACTIONS(361),
    [sym__phantom_where] = ACTIONS(361),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(689),
    [sym__cond_no_section_op] = ACTIONS(691),
    [sym__cond_minus] = ACTIONS(693),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [236] = {
    [sym_generator] = STATE(11174),
    [sym_let] = STATE(11174),
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym_group] = STATE(11174),
    [sym_transform] = STATE(11174),
    [sym_qualifier] = STATE(10346),
    [sym_qualifiers] = STATE(11880),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(252),
    [sym__exp_signature] = STATE(10018),
    [sym__exp] = STATE(11172),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11235),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9289),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3628),
    [sym_quasiquote] = STATE(3628),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3629),
    [sym_unit] = STATE(3628),
    [sym_unboxed_unit] = STATE(3628),
    [sym_prefix_tuple] = STATE(3628),
    [sym_prefix_unboxed_tuple] = STATE(3628),
    [sym_prefix_unboxed_sum] = STATE(3628),
    [sym_literal] = STATE(3628),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3628),
    [sym__varsym_prefix] = STATE(3437),
    [sym__pvarsym] = STATE(3437),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(3635),
    [sym__pconsym] = STATE(3635),
    [sym__qconsym_prefix] = STATE(3628),
    [sym__pqconsym] = STATE(3628),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(35),
    [sym__bracket_open] = STATE(361),
    [sym__unboxed_open] = STATE(203),
    [sym_variable] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_then] = ACTIONS(947),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(963),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(965),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [237] = {
    [sym__at_type] = STATE(4660),
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym_explicit_type] = STATE(4658),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_op] = STATE(1746),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(229),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__variable_ticked] = STATE(1746),
    [sym__qvariable_ticked] = STATE(1746),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__constructor_ticked] = STATE(1746),
    [sym__qconstructor_ticked] = STATE(1746),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1746),
    [sym__operator_alias] = STATE(1746),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym_constructor_operator] = STATE(1746),
    [sym__constructor_operator_alias] = STATE(1746),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__tight_dot] = STATE(11333),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2656),
    [sym__paren_open] = STATE(394),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(333),
    [anon_sym_u2237] = ACTIONS(333),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_where] = ACTIONS(335),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(333),
    [sym__cond_layout_end] = ACTIONS(333),
    [sym__cond_layout_end_explicit] = ACTIONS(333),
    [sym__phantom_where] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(689),
    [sym__cond_no_section_op] = ACTIONS(691),
    [sym__cond_minus] = ACTIONS(693),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [238] = {
    [sym__at_type] = STATE(4833),
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym_explicit_type] = STATE(4834),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_op] = STATE(1417),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(219),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__variable_ticked] = STATE(1417),
    [sym__qvariable_ticked] = STATE(1417),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__constructor_ticked] = STATE(1417),
    [sym__qconstructor_ticked] = STATE(1417),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1417),
    [sym__operator_alias] = STATE(1417),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym_constructor_operator] = STATE(1417),
    [sym__constructor_operator_alias] = STATE(1417),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__tight_dot] = STATE(11530),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2476),
    [sym__paren_open] = STATE(375),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [anon_sym_u2192] = ACTIONS(333),
    [anon_sym_COLON_COLON] = ACTIONS(333),
    [anon_sym_u2237] = ACTIONS(333),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(333),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_dotdot] = ACTIONS(333),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(733),
    [sym__cond_no_section_op] = ACTIONS(735),
    [sym__cond_minus] = ACTIONS(737),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [239] = {
    [sym__at_type] = STATE(4833),
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym_explicit_type] = STATE(4834),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_op] = STATE(1417),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(219),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__variable_ticked] = STATE(1417),
    [sym__qvariable_ticked] = STATE(1417),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__constructor_ticked] = STATE(1417),
    [sym__qconstructor_ticked] = STATE(1417),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1417),
    [sym__operator_alias] = STATE(1417),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym_constructor_operator] = STATE(1417),
    [sym__constructor_operator_alias] = STATE(1417),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__tight_dot] = STATE(11530),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2476),
    [sym__paren_open] = STATE(375),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(715),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [anon_sym_u2192] = ACTIONS(333),
    [anon_sym_COLON_COLON] = ACTIONS(333),
    [anon_sym_u2237] = ACTIONS(333),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(333),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_dotdot] = ACTIONS(333),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(733),
    [sym__cond_no_section_op] = ACTIONS(735),
    [sym__cond_minus] = ACTIONS(737),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [240] = {
    [sym__at_type] = STATE(4308),
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym_explicit_type] = STATE(4309),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_op] = STATE(1439),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(244),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__variable_ticked] = STATE(1439),
    [sym__qvariable_ticked] = STATE(1439),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__constructor_ticked] = STATE(1439),
    [sym__qconstructor_ticked] = STATE(1439),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1439),
    [sym__operator_alias] = STATE(1439),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym_constructor_operator] = STATE(1439),
    [sym__constructor_operator_alias] = STATE(1439),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__tight_dot] = STATE(11813),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2519),
    [sym__paren_open] = STATE(395),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(345),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_STAR] = ACTIONS(345),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(347),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(759),
    [anon_sym_DASH_GT] = ACTIONS(345),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_POUND] = ACTIONS(347),
    [anon_sym_POUND2] = ACTIONS(347),
    [anon_sym_PIPE2] = ACTIONS(345),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [anon_sym_u2192] = ACTIONS(345),
    [anon_sym_COLON_COLON] = ACTIONS(345),
    [anon_sym_u2237] = ACTIONS(345),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(345),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(345),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(345),
    [sym__cond_no_section_op] = ACTIONS(345),
    [sym__cond_minus] = ACTIONS(345),
    [sym__varsym] = ACTIONS(345),
    [sym__consym] = ACTIONS(345),
  },
  [241] = {
    [sym__at_type] = STATE(4660),
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym_explicit_type] = STATE(4658),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_op] = STATE(1746),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(229),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__variable_ticked] = STATE(1746),
    [sym__qvariable_ticked] = STATE(1746),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__constructor_ticked] = STATE(1746),
    [sym__qconstructor_ticked] = STATE(1746),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1746),
    [sym__operator_alias] = STATE(1746),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym_constructor_operator] = STATE(1746),
    [sym__constructor_operator_alias] = STATE(1746),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__tight_dot] = STATE(11333),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2656),
    [sym__paren_open] = STATE(394),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(357),
    [anon_sym_u2237] = ACTIONS(357),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_where] = ACTIONS(359),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(357),
    [sym__cond_layout_end] = ACTIONS(357),
    [sym__cond_layout_end_explicit] = ACTIONS(357),
    [sym__phantom_where] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(689),
    [sym__cond_no_section_op] = ACTIONS(691),
    [sym__cond_minus] = ACTIONS(693),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [242] = {
    [sym__at_type] = STATE(4308),
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym_explicit_type] = STATE(4309),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_op] = STATE(1439),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(244),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__variable_ticked] = STATE(1439),
    [sym__qvariable_ticked] = STATE(1439),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__constructor_ticked] = STATE(1439),
    [sym__qconstructor_ticked] = STATE(1439),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1439),
    [sym__operator_alias] = STATE(1439),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym_constructor_operator] = STATE(1439),
    [sym__constructor_operator_alias] = STATE(1439),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__tight_dot] = STATE(11813),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2519),
    [sym__paren_open] = STATE(395),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(359),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(759),
    [anon_sym_DASH_GT] = ACTIONS(357),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [anon_sym_PIPE2] = ACTIONS(357),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [anon_sym_u2192] = ACTIONS(357),
    [anon_sym_COLON_COLON] = ACTIONS(357),
    [anon_sym_u2237] = ACTIONS(357),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(357),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(777),
    [sym__cond_no_section_op] = ACTIONS(779),
    [sym__cond_minus] = ACTIONS(781),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [243] = {
    [sym__at_type] = STATE(4660),
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym_explicit_type] = STATE(4658),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_op] = STATE(1746),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(229),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__variable_ticked] = STATE(1746),
    [sym__qvariable_ticked] = STATE(1746),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__constructor_ticked] = STATE(1746),
    [sym__qconstructor_ticked] = STATE(1746),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1746),
    [sym__operator_alias] = STATE(1746),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym_constructor_operator] = STATE(1746),
    [sym__constructor_operator_alias] = STATE(1746),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__tight_dot] = STATE(11333),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2656),
    [sym__paren_open] = STATE(394),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(357),
    [anon_sym_u2237] = ACTIONS(357),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_where] = ACTIONS(359),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(357),
    [sym__cond_layout_end] = ACTIONS(357),
    [sym__cond_layout_end_explicit] = ACTIONS(357),
    [sym__phantom_where] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(689),
    [sym__cond_no_section_op] = ACTIONS(691),
    [sym__cond_minus] = ACTIONS(693),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [244] = {
    [sym__at_type] = STATE(4308),
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym_explicit_type] = STATE(4309),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_op] = STATE(1439),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(244),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__variable_ticked] = STATE(1439),
    [sym__qvariable_ticked] = STATE(1439),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__constructor_ticked] = STATE(1439),
    [sym__qconstructor_ticked] = STATE(1439),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1439),
    [sym__operator_alias] = STATE(1439),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym_constructor_operator] = STATE(1439),
    [sym__constructor_operator_alias] = STATE(1439),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__tight_dot] = STATE(11813),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2519),
    [sym__paren_open] = STATE(395),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(339),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(339),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(337),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(337),
    [anon_sym_mdo] = ACTIONS(337),
    [anon_sym_do] = ACTIONS(337),
    [anon_sym_case] = ACTIONS(337),
    [anon_sym_DASH] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(339),
    [anon_sym_u27e6] = ACTIONS(339),
    [sym_float] = ACTIONS(339),
    [sym_char] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym__integer_literal] = ACTIONS(337),
    [sym__binary_literal] = ACTIONS(339),
    [sym__octal_literal] = ACTIONS(339),
    [sym__hex_literal] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_POUND] = ACTIONS(337),
    [anon_sym_POUND2] = ACTIONS(337),
    [anon_sym_PIPE2] = ACTIONS(339),
    [sym_implicit_variable] = ACTIONS(339),
    [sym_name] = ACTIONS(339),
    [sym_label] = ACTIONS(339),
    [anon_sym_u2192] = ACTIONS(339),
    [anon_sym_COLON_COLON] = ACTIONS(339),
    [anon_sym_u2237] = ACTIONS(339),
    [aux_sym__paren_open_token1] = ACTIONS(339),
    [anon_sym_POUND_RPAREN] = ACTIONS(339),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(339),
    [sym__cond_splice] = ACTIONS(339),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(339),
    [sym__cond_prefix_at] = ACTIONS(339),
    [sym__cond_qualified_op] = ACTIONS(339),
    [sym__cond_no_section_op] = ACTIONS(339),
    [sym__cond_minus] = ACTIONS(339),
    [sym__varsym] = ACTIONS(339),
    [sym__consym] = ACTIONS(339),
  },
  [245] = {
    [sym__at_type] = STATE(4308),
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym_explicit_type] = STATE(4309),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_op] = STATE(1439),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(244),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__variable_ticked] = STATE(1439),
    [sym__qvariable_ticked] = STATE(1439),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__constructor_ticked] = STATE(1439),
    [sym__qconstructor_ticked] = STATE(1439),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1439),
    [sym__operator_alias] = STATE(1439),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym_constructor_operator] = STATE(1439),
    [sym__constructor_operator_alias] = STATE(1439),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__tight_dot] = STATE(11813),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2519),
    [sym__paren_open] = STATE(395),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(359),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(759),
    [anon_sym_DASH_GT] = ACTIONS(357),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [anon_sym_PIPE2] = ACTIONS(357),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [anon_sym_u2192] = ACTIONS(357),
    [anon_sym_COLON_COLON] = ACTIONS(357),
    [anon_sym_u2237] = ACTIONS(357),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(357),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(777),
    [sym__cond_no_section_op] = ACTIONS(779),
    [sym__cond_minus] = ACTIONS(781),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [246] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9216),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [247] = {
    [sym__at_type] = STATE(5483),
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym_explicit_type] = STATE(5466),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_op] = STATE(1413),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(303),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__variable_ticked] = STATE(1413),
    [sym__qvariable_ticked] = STATE(1413),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__constructor_ticked] = STATE(1413),
    [sym__qconstructor_ticked] = STATE(1413),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1413),
    [sym__operator_alias] = STATE(1413),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym_constructor_operator] = STATE(1413),
    [sym__constructor_operator_alias] = STATE(1413),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__colon2] = STATE(1548),
    [sym__tight_dot] = STATE(12144),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2551),
    [sym__paren_open] = STATE(383),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(971),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [anon_sym_u2192] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_u2237] = ACTIONS(365),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(297),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1001),
    [sym__cond_no_section_op] = ACTIONS(1003),
    [sym__cond_minus] = ACTIONS(1005),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [248] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(10214),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [249] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11116),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9792),
    [sym_view_pattern] = STATE(9792),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9419),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3611),
    [sym_quasiquote] = STATE(3611),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3608),
    [sym_unit] = STATE(3611),
    [sym_unboxed_unit] = STATE(3611),
    [sym_prefix_tuple] = STATE(3611),
    [sym_prefix_unboxed_tuple] = STATE(3611),
    [sym_prefix_unboxed_sum] = STATE(3611),
    [sym_literal] = STATE(3611),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3611),
    [sym__varsym_prefix] = STATE(3653),
    [sym__pvarsym] = STATE(3653),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3599),
    [sym__pconsym] = STATE(3599),
    [sym__qconsym_prefix] = STATE(3611),
    [sym__pqconsym] = STATE(3611),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(34),
    [sym__bracket_open] = STATE(366),
    [sym__unboxed_open] = STATE(191),
    [sym__unboxed_close] = STATE(7483),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7015),
    [sym_variable] = ACTIONS(631),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(1009),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(647),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(649),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(651),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [250] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11116),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9727),
    [sym_view_pattern] = STATE(9727),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9419),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3611),
    [sym_quasiquote] = STATE(3611),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3608),
    [sym_unit] = STATE(3611),
    [sym_unboxed_unit] = STATE(3611),
    [sym_prefix_tuple] = STATE(3611),
    [sym_prefix_unboxed_tuple] = STATE(3611),
    [sym_prefix_unboxed_sum] = STATE(3611),
    [sym_literal] = STATE(3611),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3611),
    [sym__varsym_prefix] = STATE(3653),
    [sym__pvarsym] = STATE(3653),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3599),
    [sym__pconsym] = STATE(3599),
    [sym__qconsym_prefix] = STATE(3611),
    [sym__pqconsym] = STATE(3611),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(34),
    [sym__bracket_open] = STATE(366),
    [sym__unboxed_open] = STATE(191),
    [sym__unboxed_close] = STATE(5802),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7015),
    [sym_variable] = ACTIONS(631),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(1009),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(647),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(899),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(651),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [251] = {
    [sym__at_type] = STATE(5016),
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym_explicit_type] = STATE(5013),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_op] = STATE(1621),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1621),
    [sym__qvariable_ticked] = STATE(1621),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1621),
    [sym__qconstructor_ticked] = STATE(1621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1621),
    [sym__operator_alias] = STATE(1621),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(1621),
    [sym__constructor_operator_alias] = STATE(1621),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__tight_dot] = STATE(11863),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2433),
    [sym__paren_open] = STATE(397),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(345),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(345),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT] = ACTIONS(345),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_POUND] = ACTIONS(347),
    [anon_sym_POUND2] = ACTIONS(347),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [anon_sym_u2192] = ACTIONS(345),
    [anon_sym_COLON_COLON] = ACTIONS(345),
    [anon_sym_u2237] = ACTIONS(345),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(345),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(345),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(345),
    [sym__cond_left_section_op] = ACTIONS(345),
    [sym__cond_no_section_op] = ACTIONS(345),
    [sym__cond_minus] = ACTIONS(345),
    [sym__varsym] = ACTIONS(345),
    [sym__consym] = ACTIONS(345),
  },
  [252] = {
    [sym__at_type] = STATE(5330),
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym_explicit_type] = STATE(5329),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_op] = STATE(1419),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(301),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__variable_ticked] = STATE(1419),
    [sym__qvariable_ticked] = STATE(1419),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__constructor_ticked] = STATE(1419),
    [sym__qconstructor_ticked] = STATE(1419),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1419),
    [sym__operator_alias] = STATE(1419),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym_constructor_operator] = STATE(1419),
    [sym__constructor_operator_alias] = STATE(1419),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__colon2] = STATE(1632),
    [sym__tight_dot] = STATE(11655),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2422),
    [sym__paren_open] = STATE(380),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_by] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [anon_sym_COLON_COLON] = ACTIONS(1027),
    [anon_sym_u2237] = ACTIONS(1027),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(297),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1031),
    [sym__cond_no_section_op] = ACTIONS(1033),
    [sym__cond_minus] = ACTIONS(1035),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [253] = {
    [sym__at_type] = STATE(5016),
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym_explicit_type] = STATE(5013),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_op] = STATE(1621),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1621),
    [sym__qvariable_ticked] = STATE(1621),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1621),
    [sym__qconstructor_ticked] = STATE(1621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1621),
    [sym__operator_alias] = STATE(1621),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(1621),
    [sym__constructor_operator_alias] = STATE(1621),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__tight_dot] = STATE(11863),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2433),
    [sym__paren_open] = STATE(397),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(339),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(339),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(337),
    [anon_sym_mdo] = ACTIONS(337),
    [anon_sym_do] = ACTIONS(337),
    [anon_sym_case] = ACTIONS(337),
    [anon_sym_DASH] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(339),
    [anon_sym_u27e6] = ACTIONS(339),
    [sym_float] = ACTIONS(339),
    [sym_char] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym__integer_literal] = ACTIONS(337),
    [sym__binary_literal] = ACTIONS(339),
    [sym__octal_literal] = ACTIONS(339),
    [sym__hex_literal] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_POUND] = ACTIONS(337),
    [anon_sym_POUND2] = ACTIONS(337),
    [sym_implicit_variable] = ACTIONS(339),
    [sym_name] = ACTIONS(339),
    [sym_label] = ACTIONS(339),
    [anon_sym_u2192] = ACTIONS(339),
    [anon_sym_COLON_COLON] = ACTIONS(339),
    [anon_sym_u2237] = ACTIONS(339),
    [aux_sym__paren_open_token1] = ACTIONS(339),
    [aux_sym__paren_close_token1] = ACTIONS(339),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(339),
    [sym__cond_splice] = ACTIONS(339),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(339),
    [sym__cond_prefix_at] = ACTIONS(339),
    [sym__cond_qualified_op] = ACTIONS(339),
    [sym__cond_left_section_op] = ACTIONS(339),
    [sym__cond_no_section_op] = ACTIONS(339),
    [sym__cond_minus] = ACTIONS(339),
    [sym__varsym] = ACTIONS(339),
    [sym__consym] = ACTIONS(339),
  },
  [254] = {
    [sym__at_type] = STATE(5483),
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym_explicit_type] = STATE(5466),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_op] = STATE(1413),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(303),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__variable_ticked] = STATE(1413),
    [sym__qvariable_ticked] = STATE(1413),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__constructor_ticked] = STATE(1413),
    [sym__qconstructor_ticked] = STATE(1413),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1413),
    [sym__operator_alias] = STATE(1413),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym_constructor_operator] = STATE(1413),
    [sym__constructor_operator_alias] = STATE(1413),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__colon2] = STATE(1404),
    [sym__tight_dot] = STATE(12144),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2551),
    [sym__paren_open] = STATE(383),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(971),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_DASH_GT] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [anon_sym_u2192] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(315),
    [anon_sym_u2237] = ACTIONS(315),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(297),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1001),
    [sym__cond_no_section_op] = ACTIONS(1003),
    [sym__cond_minus] = ACTIONS(1005),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [255] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9518),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [256] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(8972),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9727),
    [sym_view_pattern] = STATE(9727),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9171),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3512),
    [sym_quasiquote] = STATE(3512),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3513),
    [sym_unit] = STATE(3512),
    [sym_unboxed_unit] = STATE(3512),
    [sym_prefix_tuple] = STATE(3512),
    [sym_prefix_unboxed_tuple] = STATE(3512),
    [sym_prefix_unboxed_sum] = STATE(3512),
    [sym_literal] = STATE(3512),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3512),
    [sym__varsym_prefix] = STATE(3490),
    [sym__pvarsym] = STATE(3490),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(3522),
    [sym__pconsym] = STATE(3522),
    [sym__qconsym_prefix] = STATE(3512),
    [sym__pqconsym] = STATE(3512),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(31),
    [sym__bracket_open] = STATE(367),
    [sym__unboxed_open] = STATE(196),
    [sym__unboxed_close] = STATE(3578),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7015),
    [sym_variable] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(1009),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(803),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(847),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [257] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9387),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [258] = {
    [sym__at_type] = STATE(5175),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym_explicit_type] = STATE(5177),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_op] = STATE(1454),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(295),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__variable_ticked] = STATE(1454),
    [sym__qvariable_ticked] = STATE(1454),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__constructor_ticked] = STATE(1454),
    [sym__qconstructor_ticked] = STATE(1454),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1454),
    [sym__operator_alias] = STATE(1454),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym_constructor_operator] = STATE(1454),
    [sym__constructor_operator_alias] = STATE(1454),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__colon2] = STATE(1595),
    [sym__tight_dot] = STATE(12126),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2570),
    [sym__paren_open] = STATE(382),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [anon_sym_COLON_COLON] = ACTIONS(1051),
    [anon_sym_u2237] = ACTIONS(1051),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(297),
    [sym__cond_layout_end] = ACTIONS(297),
    [sym__cond_layout_end_explicit] = ACTIONS(297),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1055),
    [sym__cond_no_section_op] = ACTIONS(1057),
    [sym__cond_minus] = ACTIONS(1059),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [259] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9094),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9855),
    [sym_view_pattern] = STATE(9855),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9171),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3512),
    [sym_quasiquote] = STATE(3512),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3513),
    [sym_unit] = STATE(3512),
    [sym_unboxed_unit] = STATE(3512),
    [sym_prefix_tuple] = STATE(3512),
    [sym_prefix_unboxed_tuple] = STATE(3512),
    [sym_prefix_unboxed_sum] = STATE(3512),
    [sym_literal] = STATE(3512),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3512),
    [sym__varsym_prefix] = STATE(3490),
    [sym__pvarsym] = STATE(3490),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(3522),
    [sym__pconsym] = STATE(3522),
    [sym__qconsym_prefix] = STATE(3512),
    [sym__pqconsym] = STATE(3512),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(31),
    [sym__bracket_open] = STATE(367),
    [sym__unboxed_open] = STATE(196),
    [sym__unboxed_close] = STATE(2864),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7015),
    [sym_variable] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(1009),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(803),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(861),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [260] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9058),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9727),
    [sym_view_pattern] = STATE(9727),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9171),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3512),
    [sym_quasiquote] = STATE(3512),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3513),
    [sym_unit] = STATE(3512),
    [sym_unboxed_unit] = STATE(3512),
    [sym_prefix_tuple] = STATE(3512),
    [sym_prefix_unboxed_tuple] = STATE(3512),
    [sym_prefix_unboxed_sum] = STATE(3512),
    [sym_literal] = STATE(3512),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3512),
    [sym__varsym_prefix] = STATE(3490),
    [sym__pvarsym] = STATE(3490),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(3522),
    [sym__pconsym] = STATE(3522),
    [sym__qconsym_prefix] = STATE(3512),
    [sym__pqconsym] = STATE(3512),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(31),
    [sym__bracket_open] = STATE(367),
    [sym__unboxed_open] = STATE(196),
    [sym__unboxed_close] = STATE(3500),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7015),
    [sym_variable] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(1009),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(803),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(831),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [261] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(8977),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9855),
    [sym_view_pattern] = STATE(9855),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9171),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3512),
    [sym_quasiquote] = STATE(3512),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3513),
    [sym_unit] = STATE(3512),
    [sym_unboxed_unit] = STATE(3512),
    [sym_prefix_tuple] = STATE(3512),
    [sym_prefix_unboxed_tuple] = STATE(3512),
    [sym_prefix_unboxed_sum] = STATE(3512),
    [sym_literal] = STATE(3512),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3512),
    [sym__varsym_prefix] = STATE(3490),
    [sym__pvarsym] = STATE(3490),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(3522),
    [sym__pconsym] = STATE(3522),
    [sym__qconsym_prefix] = STATE(3512),
    [sym__pqconsym] = STATE(3512),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(31),
    [sym__bracket_open] = STATE(367),
    [sym__unboxed_open] = STATE(196),
    [sym__unboxed_close] = STATE(3786),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7015),
    [sym_variable] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(1009),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(803),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(815),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [262] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9036),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9727),
    [sym_view_pattern] = STATE(9727),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9171),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3512),
    [sym_quasiquote] = STATE(3512),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3513),
    [sym_unit] = STATE(3512),
    [sym_unboxed_unit] = STATE(3512),
    [sym_prefix_tuple] = STATE(3512),
    [sym_prefix_unboxed_tuple] = STATE(3512),
    [sym_prefix_unboxed_sum] = STATE(3512),
    [sym_literal] = STATE(3512),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3512),
    [sym__varsym_prefix] = STATE(3490),
    [sym__pvarsym] = STATE(3490),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(3522),
    [sym__pconsym] = STATE(3522),
    [sym__qconsym_prefix] = STATE(3512),
    [sym__pqconsym] = STATE(3512),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(31),
    [sym__bracket_open] = STATE(367),
    [sym__unboxed_open] = STATE(196),
    [sym__unboxed_close] = STATE(2864),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7015),
    [sym_variable] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(1009),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(803),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(861),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [263] = {
    [sym__at_type] = STATE(5330),
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym_explicit_type] = STATE(5329),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_op] = STATE(1419),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(301),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__variable_ticked] = STATE(1419),
    [sym__qvariable_ticked] = STATE(1419),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__constructor_ticked] = STATE(1419),
    [sym__qconstructor_ticked] = STATE(1419),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1419),
    [sym__operator_alias] = STATE(1419),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym_constructor_operator] = STATE(1419),
    [sym__constructor_operator_alias] = STATE(1419),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__colon2] = STATE(1752),
    [sym__tight_dot] = STATE(11655),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2422),
    [sym__paren_open] = STATE(380),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_by] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [anon_sym_COLON_COLON] = ACTIONS(1061),
    [anon_sym_u2237] = ACTIONS(1061),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(297),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1031),
    [sym__cond_no_section_op] = ACTIONS(1033),
    [sym__cond_minus] = ACTIONS(1035),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [264] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9137),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9988),
    [sym_view_pattern] = STATE(9988),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9171),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3512),
    [sym_quasiquote] = STATE(3512),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3513),
    [sym_unit] = STATE(3512),
    [sym_unboxed_unit] = STATE(3512),
    [sym_prefix_tuple] = STATE(3512),
    [sym_prefix_unboxed_tuple] = STATE(3512),
    [sym_prefix_unboxed_sum] = STATE(3512),
    [sym_literal] = STATE(3512),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3512),
    [sym__varsym_prefix] = STATE(3490),
    [sym__pvarsym] = STATE(3490),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(3522),
    [sym__pconsym] = STATE(3522),
    [sym__qconsym_prefix] = STATE(3512),
    [sym__pqconsym] = STATE(3512),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(31),
    [sym__bracket_open] = STATE(367),
    [sym__unboxed_open] = STATE(196),
    [sym__unboxed_close] = STATE(3308),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7015),
    [sym_variable] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(1009),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(803),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(805),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [265] = {
    [sym_generator] = STATE(11174),
    [sym_let] = STATE(11174),
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym_group] = STATE(11174),
    [sym_transform] = STATE(11174),
    [sym_qualifier] = STATE(10970),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(252),
    [sym__exp_signature] = STATE(10018),
    [sym__exp] = STATE(11172),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11235),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9289),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3628),
    [sym_quasiquote] = STATE(3628),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3629),
    [sym_unit] = STATE(3628),
    [sym_unboxed_unit] = STATE(3628),
    [sym_prefix_tuple] = STATE(3628),
    [sym_prefix_unboxed_tuple] = STATE(3628),
    [sym_prefix_unboxed_sum] = STATE(3628),
    [sym_literal] = STATE(3628),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3628),
    [sym__varsym_prefix] = STATE(3437),
    [sym__pvarsym] = STATE(3437),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(3635),
    [sym__pconsym] = STATE(3635),
    [sym__qconsym_prefix] = STATE(3628),
    [sym__pqconsym] = STATE(3628),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(35),
    [sym__bracket_open] = STATE(361),
    [sym__unboxed_open] = STATE(203),
    [sym_variable] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_then] = ACTIONS(947),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(963),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(965),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [266] = {
    [sym__at_type] = STATE(5016),
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym_explicit_type] = STATE(5013),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_op] = STATE(1621),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1621),
    [sym__qvariable_ticked] = STATE(1621),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1621),
    [sym__qconstructor_ticked] = STATE(1621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1621),
    [sym__operator_alias] = STATE(1621),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(1621),
    [sym__constructor_operator_alias] = STATE(1621),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__tight_dot] = STATE(11863),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2433),
    [sym__paren_open] = STATE(397),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(349),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT] = ACTIONS(349),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [anon_sym_u2192] = ACTIONS(349),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [anon_sym_u2237] = ACTIONS(349),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(349),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(917),
    [sym__cond_left_section_op] = ACTIONS(349),
    [sym__cond_no_section_op] = ACTIONS(921),
    [sym__cond_minus] = ACTIONS(923),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [267] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9314),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [268] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9307),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [269] = {
    [sym__at_type] = STATE(5016),
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym_explicit_type] = STATE(5013),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_op] = STATE(1621),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1621),
    [sym__qvariable_ticked] = STATE(1621),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1621),
    [sym__qconstructor_ticked] = STATE(1621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1621),
    [sym__operator_alias] = STATE(1621),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(1621),
    [sym__constructor_operator_alias] = STATE(1621),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__tight_dot] = STATE(11863),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2433),
    [sym__paren_open] = STATE(397),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT] = ACTIONS(357),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [anon_sym_u2192] = ACTIONS(357),
    [anon_sym_COLON_COLON] = ACTIONS(357),
    [anon_sym_u2237] = ACTIONS(357),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(357),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(917),
    [sym__cond_left_section_op] = ACTIONS(357),
    [sym__cond_no_section_op] = ACTIONS(921),
    [sym__cond_minus] = ACTIONS(923),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [270] = {
    [sym__at_type] = STATE(5016),
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym_explicit_type] = STATE(5013),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_op] = STATE(1621),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1621),
    [sym__qvariable_ticked] = STATE(1621),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1621),
    [sym__qconstructor_ticked] = STATE(1621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1621),
    [sym__operator_alias] = STATE(1621),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(1621),
    [sym__constructor_operator_alias] = STATE(1621),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__tight_dot] = STATE(11863),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2433),
    [sym__paren_open] = STATE(397),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT] = ACTIONS(357),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [anon_sym_u2192] = ACTIONS(357),
    [anon_sym_COLON_COLON] = ACTIONS(357),
    [anon_sym_u2237] = ACTIONS(357),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(357),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(917),
    [sym__cond_left_section_op] = ACTIONS(357),
    [sym__cond_no_section_op] = ACTIONS(921),
    [sym__cond_minus] = ACTIONS(923),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [271] = {
    [sym__at_type] = STATE(5016),
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym_explicit_type] = STATE(5013),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_op] = STATE(1621),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1621),
    [sym__qvariable_ticked] = STATE(1621),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1621),
    [sym__qconstructor_ticked] = STATE(1621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1621),
    [sym__operator_alias] = STATE(1621),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(1621),
    [sym__constructor_operator_alias] = STATE(1621),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__tight_dot] = STATE(11863),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2433),
    [sym__paren_open] = STATE(397),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT] = ACTIONS(361),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [anon_sym_u2192] = ACTIONS(361),
    [anon_sym_COLON_COLON] = ACTIONS(361),
    [anon_sym_u2237] = ACTIONS(361),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(361),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(917),
    [sym__cond_left_section_op] = ACTIONS(361),
    [sym__cond_no_section_op] = ACTIONS(921),
    [sym__cond_minus] = ACTIONS(923),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [272] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9205),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [273] = {
    [sym__at_type] = STATE(5175),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym_explicit_type] = STATE(5177),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_op] = STATE(1454),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(295),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__variable_ticked] = STATE(1454),
    [sym__qvariable_ticked] = STATE(1454),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__constructor_ticked] = STATE(1454),
    [sym__qconstructor_ticked] = STATE(1454),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1454),
    [sym__operator_alias] = STATE(1454),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym_constructor_operator] = STATE(1454),
    [sym__constructor_operator_alias] = STATE(1454),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__colon2] = STATE(1549),
    [sym__tight_dot] = STATE(12126),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2570),
    [sym__paren_open] = STATE(382),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [anon_sym_COLON_COLON] = ACTIONS(1063),
    [anon_sym_u2237] = ACTIONS(1063),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(297),
    [sym__cond_layout_end] = ACTIONS(297),
    [sym__cond_layout_end_explicit] = ACTIONS(297),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1055),
    [sym__cond_no_section_op] = ACTIONS(1057),
    [sym__cond_minus] = ACTIONS(1059),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [274] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9094),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9727),
    [sym_view_pattern] = STATE(9727),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9171),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3512),
    [sym_quasiquote] = STATE(3512),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3513),
    [sym_unit] = STATE(3512),
    [sym_unboxed_unit] = STATE(3512),
    [sym_prefix_tuple] = STATE(3512),
    [sym_prefix_unboxed_tuple] = STATE(3512),
    [sym_prefix_unboxed_sum] = STATE(3512),
    [sym_literal] = STATE(3512),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3512),
    [sym__varsym_prefix] = STATE(3490),
    [sym__pvarsym] = STATE(3490),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(3522),
    [sym__pconsym] = STATE(3522),
    [sym__qconsym_prefix] = STATE(3512),
    [sym__pqconsym] = STATE(3512),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(31),
    [sym__bracket_open] = STATE(367),
    [sym__unboxed_open] = STATE(196),
    [sym__unboxed_close] = STATE(2864),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7015),
    [sym_variable] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(1009),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(803),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(861),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [275] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9167),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [276] = {
    [sym__at_type] = STATE(5016),
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym_explicit_type] = STATE(5013),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_op] = STATE(1621),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1621),
    [sym__qvariable_ticked] = STATE(1621),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1621),
    [sym__qconstructor_ticked] = STATE(1621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1621),
    [sym__operator_alias] = STATE(1621),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(1621),
    [sym__constructor_operator_alias] = STATE(1621),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__tight_dot] = STATE(11863),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2433),
    [sym__paren_open] = STATE(397),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [anon_sym_u2192] = ACTIONS(341),
    [anon_sym_COLON_COLON] = ACTIONS(341),
    [anon_sym_u2237] = ACTIONS(341),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(341),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(917),
    [sym__cond_left_section_op] = ACTIONS(341),
    [sym__cond_no_section_op] = ACTIONS(921),
    [sym__cond_minus] = ACTIONS(923),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [277] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9452),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [278] = {
    [sym__at_type] = STATE(5016),
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym_explicit_type] = STATE(5013),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_op] = STATE(1621),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1621),
    [sym__qvariable_ticked] = STATE(1621),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1621),
    [sym__qconstructor_ticked] = STATE(1621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1621),
    [sym__operator_alias] = STATE(1621),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(1621),
    [sym__constructor_operator_alias] = STATE(1621),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__tight_dot] = STATE(11863),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2433),
    [sym__paren_open] = STATE(397),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(353),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [anon_sym_u2192] = ACTIONS(353),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_u2237] = ACTIONS(353),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(353),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(917),
    [sym__cond_left_section_op] = ACTIONS(353),
    [sym__cond_no_section_op] = ACTIONS(921),
    [sym__cond_minus] = ACTIONS(923),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [279] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9137),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9727),
    [sym_view_pattern] = STATE(9727),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9171),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3512),
    [sym_quasiquote] = STATE(3512),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3513),
    [sym_unit] = STATE(3512),
    [sym_unboxed_unit] = STATE(3512),
    [sym_prefix_tuple] = STATE(3512),
    [sym_prefix_unboxed_tuple] = STATE(3512),
    [sym_prefix_unboxed_sum] = STATE(3512),
    [sym_literal] = STATE(3512),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3512),
    [sym__varsym_prefix] = STATE(3490),
    [sym__pvarsym] = STATE(3490),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(3522),
    [sym__pconsym] = STATE(3522),
    [sym__qconsym_prefix] = STATE(3512),
    [sym__pqconsym] = STATE(3512),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(31),
    [sym__bracket_open] = STATE(367),
    [sym__unboxed_open] = STATE(196),
    [sym__unboxed_close] = STATE(3575),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7015),
    [sym_variable] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(1009),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(803),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(869),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [280] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(8977),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9727),
    [sym_view_pattern] = STATE(9727),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9171),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3512),
    [sym_quasiquote] = STATE(3512),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3513),
    [sym_unit] = STATE(3512),
    [sym_unboxed_unit] = STATE(3512),
    [sym_prefix_tuple] = STATE(3512),
    [sym_prefix_unboxed_tuple] = STATE(3512),
    [sym_prefix_unboxed_sum] = STATE(3512),
    [sym_literal] = STATE(3512),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3512),
    [sym__varsym_prefix] = STATE(3490),
    [sym__pvarsym] = STATE(3490),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(3522),
    [sym__pconsym] = STATE(3522),
    [sym__qconsym_prefix] = STATE(3512),
    [sym__pqconsym] = STATE(3512),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(31),
    [sym__bracket_open] = STATE(367),
    [sym__unboxed_open] = STATE(196),
    [sym__unboxed_close] = STATE(3786),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7015),
    [sym_variable] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(1009),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(803),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(815),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [281] = {
    [sym__at_type] = STATE(5016),
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym_explicit_type] = STATE(5013),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_op] = STATE(1621),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1621),
    [sym__qvariable_ticked] = STATE(1621),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1621),
    [sym__qconstructor_ticked] = STATE(1621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1621),
    [sym__operator_alias] = STATE(1621),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(1621),
    [sym__constructor_operator_alias] = STATE(1621),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__tight_dot] = STATE(11863),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2433),
    [sym__paren_open] = STATE(397),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [anon_sym_u2192] = ACTIONS(333),
    [anon_sym_COLON_COLON] = ACTIONS(333),
    [anon_sym_u2237] = ACTIONS(333),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(333),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(917),
    [sym__cond_left_section_op] = ACTIONS(333),
    [sym__cond_no_section_op] = ACTIONS(921),
    [sym__cond_minus] = ACTIONS(923),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [282] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11116),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9855),
    [sym_view_pattern] = STATE(9855),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9419),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3611),
    [sym_quasiquote] = STATE(3611),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3608),
    [sym_unit] = STATE(3611),
    [sym_unboxed_unit] = STATE(3611),
    [sym_prefix_tuple] = STATE(3611),
    [sym_prefix_unboxed_tuple] = STATE(3611),
    [sym_prefix_unboxed_sum] = STATE(3611),
    [sym_literal] = STATE(3611),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3611),
    [sym__varsym_prefix] = STATE(3653),
    [sym__pvarsym] = STATE(3653),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3599),
    [sym__pconsym] = STATE(3599),
    [sym__qconsym_prefix] = STATE(3611),
    [sym__pqconsym] = STATE(3611),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(34),
    [sym__bracket_open] = STATE(366),
    [sym__unboxed_open] = STATE(191),
    [sym__unboxed_close] = STATE(6195),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7015),
    [sym_variable] = ACTIONS(631),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(1009),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(647),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(839),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(651),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [283] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9492),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [284] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9329),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [285] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9015),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9727),
    [sym_view_pattern] = STATE(9727),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9171),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3512),
    [sym_quasiquote] = STATE(3512),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3513),
    [sym_unit] = STATE(3512),
    [sym_unboxed_unit] = STATE(3512),
    [sym_prefix_tuple] = STATE(3512),
    [sym_prefix_unboxed_tuple] = STATE(3512),
    [sym_prefix_unboxed_sum] = STATE(3512),
    [sym_literal] = STATE(3512),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3512),
    [sym__varsym_prefix] = STATE(3490),
    [sym__pvarsym] = STATE(3490),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(3522),
    [sym__pconsym] = STATE(3522),
    [sym__qconsym_prefix] = STATE(3512),
    [sym__pqconsym] = STATE(3512),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(31),
    [sym__bracket_open] = STATE(367),
    [sym__unboxed_open] = STATE(196),
    [sym__unboxed_close] = STATE(3626),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7015),
    [sym_variable] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(1009),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(803),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(823),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [286] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11116),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9988),
    [sym_view_pattern] = STATE(9988),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9419),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3611),
    [sym_quasiquote] = STATE(3611),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3608),
    [sym_unit] = STATE(3611),
    [sym_unboxed_unit] = STATE(3611),
    [sym_prefix_tuple] = STATE(3611),
    [sym_prefix_unboxed_tuple] = STATE(3611),
    [sym_prefix_unboxed_sum] = STATE(3611),
    [sym_literal] = STATE(3611),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3611),
    [sym__varsym_prefix] = STATE(3653),
    [sym__pvarsym] = STATE(3653),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3599),
    [sym__pconsym] = STATE(3599),
    [sym__qconsym_prefix] = STATE(3611),
    [sym__pqconsym] = STATE(3611),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(34),
    [sym__bracket_open] = STATE(366),
    [sym__unboxed_open] = STATE(191),
    [sym__unboxed_close] = STATE(6179),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7015),
    [sym_variable] = ACTIONS(631),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(1009),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(647),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(791),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(651),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [287] = {
    [sym__at_type] = STATE(5016),
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym_explicit_type] = STATE(5013),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_op] = STATE(1621),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1621),
    [sym__qvariable_ticked] = STATE(1621),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1621),
    [sym__qconstructor_ticked] = STATE(1621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1621),
    [sym__operator_alias] = STATE(1621),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(1621),
    [sym__constructor_operator_alias] = STATE(1621),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__tight_dot] = STATE(11863),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2433),
    [sym__paren_open] = STATE(397),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [anon_sym_u2192] = ACTIONS(333),
    [anon_sym_COLON_COLON] = ACTIONS(333),
    [anon_sym_u2237] = ACTIONS(333),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(333),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(917),
    [sym__cond_left_section_op] = ACTIONS(333),
    [sym__cond_no_section_op] = ACTIONS(921),
    [sym__cond_minus] = ACTIONS(923),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [288] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9094),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9727),
    [sym_view_pattern] = STATE(9727),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9171),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3512),
    [sym_quasiquote] = STATE(3512),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3513),
    [sym_unit] = STATE(3512),
    [sym_unboxed_unit] = STATE(3512),
    [sym_prefix_tuple] = STATE(3512),
    [sym_prefix_unboxed_tuple] = STATE(3512),
    [sym_prefix_unboxed_sum] = STATE(3512),
    [sym_literal] = STATE(3512),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3512),
    [sym__varsym_prefix] = STATE(3490),
    [sym__pvarsym] = STATE(3490),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(3522),
    [sym__pconsym] = STATE(3522),
    [sym__qconsym_prefix] = STATE(3512),
    [sym__pqconsym] = STATE(3512),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(31),
    [sym__bracket_open] = STATE(367),
    [sym__unboxed_open] = STATE(196),
    [sym__unboxed_close] = STATE(3500),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7015),
    [sym_variable] = ACTIONS(793),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(1009),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(803),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(831),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [289] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11116),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9927),
    [sym_view_pattern] = STATE(9927),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9419),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3611),
    [sym_quasiquote] = STATE(3611),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3608),
    [sym_unit] = STATE(3611),
    [sym_unboxed_unit] = STATE(3611),
    [sym_prefix_tuple] = STATE(3611),
    [sym_prefix_unboxed_tuple] = STATE(3611),
    [sym_prefix_unboxed_sum] = STATE(3611),
    [sym_literal] = STATE(3611),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3611),
    [sym__varsym_prefix] = STATE(3653),
    [sym__pvarsym] = STATE(3653),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3599),
    [sym__pconsym] = STATE(3599),
    [sym__qconsym_prefix] = STATE(3611),
    [sym__pqconsym] = STATE(3611),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(34),
    [sym__bracket_open] = STATE(366),
    [sym__unboxed_open] = STATE(191),
    [sym__unboxed_close] = STATE(7183),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7015),
    [sym_variable] = ACTIONS(631),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_PIPE] = ACTIONS(1007),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [anon_sym_PIPE2] = ACTIONS(1009),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(647),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(877),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(651),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [290] = {
    [sym_generator] = STATE(10668),
    [sym_let] = STATE(10704),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__exp_statement] = STATE(10704),
    [sym_statement] = STATE(9519),
    [sym_rec] = STATE(10704),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10670),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11264),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9293),
    [sym__splice_dollars] = STATE(7471),
    [sym_splice] = STATE(3511),
    [sym_quasiquote] = STATE(3511),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3537),
    [sym__plist] = STATE(3514),
    [sym_unit] = STATE(3511),
    [sym_unboxed_unit] = STATE(3511),
    [sym_prefix_tuple] = STATE(3511),
    [sym_prefix_unboxed_tuple] = STATE(3511),
    [sym_prefix_unboxed_sum] = STATE(3511),
    [sym_literal] = STATE(3511),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(3475),
    [sym__qconid] = STATE(3511),
    [sym__varsym_prefix] = STATE(3479),
    [sym__pvarsym] = STATE(3479),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(3517),
    [sym__pconsym] = STATE(3517),
    [sym__qconsym_prefix] = STATE(3511),
    [sym__pqconsym] = STATE(3511),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(30),
    [sym__bracket_open] = STATE(356),
    [sym__unboxed_open] = STATE(201),
    [sym_variable] = ACTIONS(367),
    [anon_sym_let] = ACTIONS(371),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_rec] = ACTIONS(373),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(377),
    [sym_char] = ACTIONS(377),
    [sym_string] = ACTIONS(377),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(383),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(389),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [291] = {
    [sym__at_type] = STATE(5175),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym_explicit_type] = STATE(5177),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_op] = STATE(1454),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(295),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__variable_ticked] = STATE(1454),
    [sym__qvariable_ticked] = STATE(1454),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__constructor_ticked] = STATE(1454),
    [sym__qconstructor_ticked] = STATE(1454),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1454),
    [sym__operator_alias] = STATE(1454),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym_constructor_operator] = STATE(1454),
    [sym__constructor_operator_alias] = STATE(1454),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__tight_dot] = STATE(12126),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2570),
    [sym__paren_open] = STATE(382),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(345),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(345),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_POUND] = ACTIONS(347),
    [anon_sym_POUND2] = ACTIONS(347),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [anon_sym_COLON_COLON] = ACTIONS(345),
    [anon_sym_u2237] = ACTIONS(345),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(345),
    [sym__cond_layout_end] = ACTIONS(345),
    [sym__cond_layout_end_explicit] = ACTIONS(345),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(345),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(345),
    [sym__cond_no_section_op] = ACTIONS(345),
    [sym__cond_minus] = ACTIONS(345),
    [sym__varsym] = ACTIONS(345),
    [sym__consym] = ACTIONS(345),
  },
  [292] = {
    [sym__at_type] = STATE(5330),
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym_explicit_type] = STATE(5329),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_op] = STATE(1419),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(301),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__variable_ticked] = STATE(1419),
    [sym__qvariable_ticked] = STATE(1419),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__constructor_ticked] = STATE(1419),
    [sym__qconstructor_ticked] = STATE(1419),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1419),
    [sym__operator_alias] = STATE(1419),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym_constructor_operator] = STATE(1419),
    [sym__constructor_operator_alias] = STATE(1419),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__tight_dot] = STATE(11655),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2422),
    [sym__paren_open] = STATE(380),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_COMMA] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_by] = ACTIONS(343),
    [anon_sym_PIPE] = ACTIONS(341),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [anon_sym_COLON_COLON] = ACTIONS(341),
    [anon_sym_u2237] = ACTIONS(341),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(341),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1031),
    [sym__cond_no_section_op] = ACTIONS(1033),
    [sym__cond_minus] = ACTIONS(1035),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [293] = {
    [sym__at_type] = STATE(5175),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym_explicit_type] = STATE(5177),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_op] = STATE(1454),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(295),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__variable_ticked] = STATE(1454),
    [sym__qvariable_ticked] = STATE(1454),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__constructor_ticked] = STATE(1454),
    [sym__qconstructor_ticked] = STATE(1454),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1454),
    [sym__operator_alias] = STATE(1454),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym_constructor_operator] = STATE(1454),
    [sym__constructor_operator_alias] = STATE(1454),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__tight_dot] = STATE(12126),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2570),
    [sym__paren_open] = STATE(382),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [anon_sym_COLON_COLON] = ACTIONS(341),
    [anon_sym_u2237] = ACTIONS(341),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(341),
    [sym__cond_layout_end] = ACTIONS(341),
    [sym__cond_layout_end_explicit] = ACTIONS(341),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1055),
    [sym__cond_no_section_op] = ACTIONS(1057),
    [sym__cond_minus] = ACTIONS(1059),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [294] = {
    [sym__at_type] = STATE(5330),
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym_explicit_type] = STATE(5329),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_op] = STATE(1419),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(301),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__variable_ticked] = STATE(1419),
    [sym__qvariable_ticked] = STATE(1419),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__constructor_ticked] = STATE(1419),
    [sym__qconstructor_ticked] = STATE(1419),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1419),
    [sym__operator_alias] = STATE(1419),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym_constructor_operator] = STATE(1419),
    [sym__constructor_operator_alias] = STATE(1419),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__tight_dot] = STATE(11655),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2422),
    [sym__paren_open] = STATE(380),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_COMMA] = ACTIONS(349),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_by] = ACTIONS(351),
    [anon_sym_PIPE] = ACTIONS(349),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [anon_sym_u2237] = ACTIONS(349),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(349),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1031),
    [sym__cond_no_section_op] = ACTIONS(1033),
    [sym__cond_minus] = ACTIONS(1035),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [295] = {
    [sym__at_type] = STATE(5175),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym_explicit_type] = STATE(5177),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_op] = STATE(1454),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(295),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__variable_ticked] = STATE(1454),
    [sym__qvariable_ticked] = STATE(1454),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__constructor_ticked] = STATE(1454),
    [sym__qconstructor_ticked] = STATE(1454),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1454),
    [sym__operator_alias] = STATE(1454),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym_constructor_operator] = STATE(1454),
    [sym__constructor_operator_alias] = STATE(1454),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__tight_dot] = STATE(12126),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2570),
    [sym__paren_open] = STATE(382),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_let] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(339),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(337),
    [anon_sym_mdo] = ACTIONS(337),
    [anon_sym_do] = ACTIONS(337),
    [anon_sym_case] = ACTIONS(337),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(339),
    [anon_sym_u27e6] = ACTIONS(339),
    [sym_float] = ACTIONS(339),
    [sym_char] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym__integer_literal] = ACTIONS(337),
    [sym__binary_literal] = ACTIONS(339),
    [sym__octal_literal] = ACTIONS(339),
    [sym__hex_literal] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_POUND] = ACTIONS(337),
    [anon_sym_POUND2] = ACTIONS(337),
    [sym_implicit_variable] = ACTIONS(339),
    [sym_name] = ACTIONS(339),
    [sym_label] = ACTIONS(339),
    [anon_sym_COLON_COLON] = ACTIONS(339),
    [anon_sym_u2237] = ACTIONS(339),
    [aux_sym__paren_open_token1] = ACTIONS(339),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(339),
    [sym__cond_layout_end] = ACTIONS(339),
    [sym__cond_layout_end_explicit] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(339),
    [sym__cond_splice] = ACTIONS(339),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(339),
    [sym__cond_prefix_at] = ACTIONS(339),
    [sym__cond_qualified_op] = ACTIONS(339),
    [sym__cond_no_section_op] = ACTIONS(339),
    [sym__cond_minus] = ACTIONS(339),
    [sym__varsym] = ACTIONS(339),
    [sym__consym] = ACTIONS(339),
  },
  [296] = {
    [sym__at_type] = STATE(5175),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym_explicit_type] = STATE(5177),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_op] = STATE(1454),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(295),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__variable_ticked] = STATE(1454),
    [sym__qvariable_ticked] = STATE(1454),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__constructor_ticked] = STATE(1454),
    [sym__qconstructor_ticked] = STATE(1454),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1454),
    [sym__operator_alias] = STATE(1454),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym_constructor_operator] = STATE(1454),
    [sym__constructor_operator_alias] = STATE(1454),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__tight_dot] = STATE(12126),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2570),
    [sym__paren_open] = STATE(382),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(361),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [anon_sym_COLON_COLON] = ACTIONS(361),
    [anon_sym_u2237] = ACTIONS(361),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(361),
    [sym__cond_layout_end] = ACTIONS(361),
    [sym__cond_layout_end_explicit] = ACTIONS(361),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1055),
    [sym__cond_no_section_op] = ACTIONS(1057),
    [sym__cond_minus] = ACTIONS(1059),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [297] = {
    [sym__at_type] = STATE(5483),
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym_explicit_type] = STATE(5466),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_op] = STATE(1413),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(303),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__variable_ticked] = STATE(1413),
    [sym__qvariable_ticked] = STATE(1413),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__constructor_ticked] = STATE(1413),
    [sym__qconstructor_ticked] = STATE(1413),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1413),
    [sym__operator_alias] = STATE(1413),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym_constructor_operator] = STATE(1413),
    [sym__constructor_operator_alias] = STATE(1413),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__tight_dot] = STATE(12144),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2551),
    [sym__paren_open] = STATE(383),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_COMMA] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(971),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_DASH_GT] = ACTIONS(357),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [anon_sym_u2192] = ACTIONS(357),
    [anon_sym_COLON_COLON] = ACTIONS(357),
    [anon_sym_u2237] = ACTIONS(357),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1001),
    [sym__cond_no_section_op] = ACTIONS(1003),
    [sym__cond_minus] = ACTIONS(1005),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [298] = {
    [sym__at_type] = STATE(5483),
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym_explicit_type] = STATE(5466),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_op] = STATE(1413),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(303),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__variable_ticked] = STATE(1413),
    [sym__qvariable_ticked] = STATE(1413),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__constructor_ticked] = STATE(1413),
    [sym__qconstructor_ticked] = STATE(1413),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1413),
    [sym__operator_alias] = STATE(1413),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym_constructor_operator] = STATE(1413),
    [sym__constructor_operator_alias] = STATE(1413),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__tight_dot] = STATE(12144),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2551),
    [sym__paren_open] = STATE(383),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_COMMA] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(971),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_DASH_GT] = ACTIONS(357),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [anon_sym_u2192] = ACTIONS(357),
    [anon_sym_COLON_COLON] = ACTIONS(357),
    [anon_sym_u2237] = ACTIONS(357),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1001),
    [sym__cond_no_section_op] = ACTIONS(1003),
    [sym__cond_minus] = ACTIONS(1005),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [299] = {
    [sym__at_type] = STATE(5483),
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym_explicit_type] = STATE(5466),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_op] = STATE(1413),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(303),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__variable_ticked] = STATE(1413),
    [sym__qvariable_ticked] = STATE(1413),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__constructor_ticked] = STATE(1413),
    [sym__qconstructor_ticked] = STATE(1413),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1413),
    [sym__operator_alias] = STATE(1413),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym_constructor_operator] = STATE(1413),
    [sym__constructor_operator_alias] = STATE(1413),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__tight_dot] = STATE(12144),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2551),
    [sym__paren_open] = STATE(383),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_COMMA] = ACTIONS(349),
    [anon_sym_LBRACE] = ACTIONS(971),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_DASH_GT] = ACTIONS(349),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [anon_sym_u2192] = ACTIONS(349),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [anon_sym_u2237] = ACTIONS(349),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(349),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1001),
    [sym__cond_no_section_op] = ACTIONS(1003),
    [sym__cond_minus] = ACTIONS(1005),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [300] = {
    [sym__at_type] = STATE(5330),
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym_explicit_type] = STATE(5329),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_op] = STATE(1419),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(301),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__variable_ticked] = STATE(1419),
    [sym__qvariable_ticked] = STATE(1419),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__constructor_ticked] = STATE(1419),
    [sym__qconstructor_ticked] = STATE(1419),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1419),
    [sym__operator_alias] = STATE(1419),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym_constructor_operator] = STATE(1419),
    [sym__constructor_operator_alias] = STATE(1419),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__tight_dot] = STATE(11655),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2422),
    [sym__paren_open] = STATE(380),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_COMMA] = ACTIONS(345),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(345),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_by] = ACTIONS(347),
    [anon_sym_PIPE] = ACTIONS(345),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_POUND] = ACTIONS(347),
    [anon_sym_POUND2] = ACTIONS(347),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [anon_sym_COLON_COLON] = ACTIONS(345),
    [anon_sym_u2237] = ACTIONS(345),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(345),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(345),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(345),
    [sym__cond_no_section_op] = ACTIONS(345),
    [sym__cond_minus] = ACTIONS(345),
    [sym__varsym] = ACTIONS(345),
    [sym__consym] = ACTIONS(345),
  },
  [301] = {
    [sym__at_type] = STATE(5330),
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym_explicit_type] = STATE(5329),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_op] = STATE(1419),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(301),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__variable_ticked] = STATE(1419),
    [sym__qvariable_ticked] = STATE(1419),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__constructor_ticked] = STATE(1419),
    [sym__qconstructor_ticked] = STATE(1419),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1419),
    [sym__operator_alias] = STATE(1419),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym_constructor_operator] = STATE(1419),
    [sym__constructor_operator_alias] = STATE(1419),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__tight_dot] = STATE(11655),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2422),
    [sym__paren_open] = STATE(380),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(339),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_SQUOTE] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(339),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(339),
    [anon_sym_by] = ACTIONS(337),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(337),
    [anon_sym_mdo] = ACTIONS(337),
    [anon_sym_do] = ACTIONS(337),
    [anon_sym_case] = ACTIONS(337),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(339),
    [anon_sym_u27e6] = ACTIONS(339),
    [sym_float] = ACTIONS(339),
    [sym_char] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym__integer_literal] = ACTIONS(337),
    [sym__binary_literal] = ACTIONS(339),
    [sym__octal_literal] = ACTIONS(339),
    [sym__hex_literal] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_POUND] = ACTIONS(337),
    [anon_sym_POUND2] = ACTIONS(337),
    [sym_implicit_variable] = ACTIONS(339),
    [sym_name] = ACTIONS(339),
    [sym_label] = ACTIONS(339),
    [anon_sym_COLON_COLON] = ACTIONS(339),
    [anon_sym_u2237] = ACTIONS(339),
    [aux_sym__paren_open_token1] = ACTIONS(339),
    [anon_sym_RBRACK] = ACTIONS(339),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(339),
    [sym__cond_splice] = ACTIONS(339),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(339),
    [sym__cond_prefix_at] = ACTIONS(339),
    [sym__cond_qualified_op] = ACTIONS(339),
    [sym__cond_no_section_op] = ACTIONS(339),
    [sym__cond_minus] = ACTIONS(339),
    [sym__varsym] = ACTIONS(339),
    [sym__consym] = ACTIONS(339),
  },
  [302] = {
    [sym__at_type] = STATE(5175),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym_explicit_type] = STATE(5177),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_op] = STATE(1454),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(295),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__variable_ticked] = STATE(1454),
    [sym__qvariable_ticked] = STATE(1454),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__constructor_ticked] = STATE(1454),
    [sym__qconstructor_ticked] = STATE(1454),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1454),
    [sym__operator_alias] = STATE(1454),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym_constructor_operator] = STATE(1454),
    [sym__constructor_operator_alias] = STATE(1454),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__tight_dot] = STATE(12126),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2570),
    [sym__paren_open] = STATE(382),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [anon_sym_COLON_COLON] = ACTIONS(333),
    [anon_sym_u2237] = ACTIONS(333),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(333),
    [sym__cond_layout_end] = ACTIONS(333),
    [sym__cond_layout_end_explicit] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1055),
    [sym__cond_no_section_op] = ACTIONS(1057),
    [sym__cond_minus] = ACTIONS(1059),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [303] = {
    [sym__at_type] = STATE(5483),
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym_explicit_type] = STATE(5466),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_op] = STATE(1413),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(303),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__variable_ticked] = STATE(1413),
    [sym__qvariable_ticked] = STATE(1413),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__constructor_ticked] = STATE(1413),
    [sym__qconstructor_ticked] = STATE(1413),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1413),
    [sym__operator_alias] = STATE(1413),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym_constructor_operator] = STATE(1413),
    [sym__constructor_operator_alias] = STATE(1413),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__tight_dot] = STATE(12144),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2551),
    [sym__paren_open] = STATE(383),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(339),
    [anon_sym_LBRACE] = ACTIONS(971),
    [anon_sym_SQUOTE] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(339),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(337),
    [anon_sym_mdo] = ACTIONS(337),
    [anon_sym_do] = ACTIONS(337),
    [anon_sym_case] = ACTIONS(337),
    [anon_sym_DASH] = ACTIONS(337),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(339),
    [anon_sym_u27e6] = ACTIONS(339),
    [sym_float] = ACTIONS(339),
    [sym_char] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym__integer_literal] = ACTIONS(337),
    [sym__binary_literal] = ACTIONS(339),
    [sym__octal_literal] = ACTIONS(339),
    [sym__hex_literal] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_POUND] = ACTIONS(337),
    [anon_sym_POUND2] = ACTIONS(337),
    [sym_implicit_variable] = ACTIONS(339),
    [sym_name] = ACTIONS(339),
    [sym_label] = ACTIONS(339),
    [anon_sym_u2192] = ACTIONS(339),
    [anon_sym_COLON_COLON] = ACTIONS(339),
    [anon_sym_u2237] = ACTIONS(339),
    [aux_sym__paren_open_token1] = ACTIONS(339),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(339),
    [sym__cond_splice] = ACTIONS(339),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(339),
    [sym__cond_prefix_at] = ACTIONS(339),
    [sym__cond_qualified_op] = ACTIONS(339),
    [sym__cond_no_section_op] = ACTIONS(339),
    [sym__cond_minus] = ACTIONS(339),
    [sym__varsym] = ACTIONS(339),
    [sym__consym] = ACTIONS(339),
  },
  [304] = {
    [sym__at_type] = STATE(5483),
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym_explicit_type] = STATE(5466),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_op] = STATE(1413),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(303),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__variable_ticked] = STATE(1413),
    [sym__qvariable_ticked] = STATE(1413),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__constructor_ticked] = STATE(1413),
    [sym__qconstructor_ticked] = STATE(1413),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1413),
    [sym__operator_alias] = STATE(1413),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym_constructor_operator] = STATE(1413),
    [sym__constructor_operator_alias] = STATE(1413),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__tight_dot] = STATE(12144),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2551),
    [sym__paren_open] = STATE(383),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_COMMA] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(971),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_DASH_GT] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [anon_sym_u2192] = ACTIONS(341),
    [anon_sym_COLON_COLON] = ACTIONS(341),
    [anon_sym_u2237] = ACTIONS(341),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(341),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1001),
    [sym__cond_no_section_op] = ACTIONS(1003),
    [sym__cond_minus] = ACTIONS(1005),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [305] = {
    [sym__at_type] = STATE(5330),
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym_explicit_type] = STATE(5329),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_op] = STATE(1419),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(301),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__variable_ticked] = STATE(1419),
    [sym__qvariable_ticked] = STATE(1419),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__constructor_ticked] = STATE(1419),
    [sym__qconstructor_ticked] = STATE(1419),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1419),
    [sym__operator_alias] = STATE(1419),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym_constructor_operator] = STATE(1419),
    [sym__constructor_operator_alias] = STATE(1419),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__tight_dot] = STATE(11655),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2422),
    [sym__paren_open] = STATE(380),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_by] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [anon_sym_COLON_COLON] = ACTIONS(361),
    [anon_sym_u2237] = ACTIONS(361),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(361),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1031),
    [sym__cond_no_section_op] = ACTIONS(1033),
    [sym__cond_minus] = ACTIONS(1035),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [306] = {
    [sym__at_type] = STATE(5016),
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym_explicit_type] = STATE(5013),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_op] = STATE(1621),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1621),
    [sym__qvariable_ticked] = STATE(1621),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1621),
    [sym__qconstructor_ticked] = STATE(1621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1621),
    [sym__operator_alias] = STATE(1621),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(1621),
    [sym__constructor_operator_alias] = STATE(1621),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__colon2] = STATE(1548),
    [sym__tight_dot] = STATE(11863),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2433),
    [sym__paren_open] = STATE(397),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_u2237] = ACTIONS(365),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(297),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(917),
    [sym__cond_left_section_op] = ACTIONS(1067),
    [sym__cond_no_section_op] = ACTIONS(921),
    [sym__cond_minus] = ACTIONS(923),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [307] = {
    [sym__at_type] = STATE(5483),
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym_explicit_type] = STATE(5466),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_op] = STATE(1413),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(303),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__variable_ticked] = STATE(1413),
    [sym__qvariable_ticked] = STATE(1413),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__constructor_ticked] = STATE(1413),
    [sym__qconstructor_ticked] = STATE(1413),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1413),
    [sym__operator_alias] = STATE(1413),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym_constructor_operator] = STATE(1413),
    [sym__constructor_operator_alias] = STATE(1413),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__tight_dot] = STATE(12144),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2551),
    [sym__paren_open] = STATE(383),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_COMMA] = ACTIONS(353),
    [anon_sym_LBRACE] = ACTIONS(971),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_DASH_GT] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [anon_sym_u2192] = ACTIONS(353),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_u2237] = ACTIONS(353),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(353),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1001),
    [sym__cond_no_section_op] = ACTIONS(1003),
    [sym__cond_minus] = ACTIONS(1005),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [308] = {
    [sym__at_type] = STATE(5483),
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym_explicit_type] = STATE(5466),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_op] = STATE(1413),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(303),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__variable_ticked] = STATE(1413),
    [sym__qvariable_ticked] = STATE(1413),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__constructor_ticked] = STATE(1413),
    [sym__qconstructor_ticked] = STATE(1413),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1413),
    [sym__operator_alias] = STATE(1413),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym_constructor_operator] = STATE(1413),
    [sym__constructor_operator_alias] = STATE(1413),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__tight_dot] = STATE(12144),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2551),
    [sym__paren_open] = STATE(383),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_COMMA] = ACTIONS(345),
    [anon_sym_LBRACE] = ACTIONS(971),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(345),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_DASH_GT] = ACTIONS(345),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_POUND] = ACTIONS(347),
    [anon_sym_POUND2] = ACTIONS(347),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [anon_sym_u2192] = ACTIONS(345),
    [anon_sym_COLON_COLON] = ACTIONS(345),
    [anon_sym_u2237] = ACTIONS(345),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(345),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(345),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(345),
    [sym__cond_no_section_op] = ACTIONS(345),
    [sym__cond_minus] = ACTIONS(345),
    [sym__varsym] = ACTIONS(345),
    [sym__consym] = ACTIONS(345),
  },
  [309] = {
    [sym__at_type] = STATE(5607),
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym_explicit_type] = STATE(5520),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_op] = STATE(1558),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(330),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__variable_ticked] = STATE(1558),
    [sym__qvariable_ticked] = STATE(1558),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__constructor_ticked] = STATE(1558),
    [sym__qconstructor_ticked] = STATE(1558),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1558),
    [sym__operator_alias] = STATE(1558),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym_constructor_operator] = STATE(1558),
    [sym__constructor_operator_alias] = STATE(1558),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__colon2] = STATE(1541),
    [sym__tight_dot] = STATE(11833),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2601),
    [sym__paren_open] = STATE(393),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(1073),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [anon_sym_COLON_COLON] = ACTIONS(1101),
    [anon_sym_u2237] = ACTIONS(1101),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(297),
    [sym__phantom_bar] = ACTIONS(297),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1105),
    [sym__cond_no_section_op] = ACTIONS(1107),
    [sym__cond_minus] = ACTIONS(1109),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [310] = {
    [sym__at_type] = STATE(5175),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym_explicit_type] = STATE(5177),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_op] = STATE(1454),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(295),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__variable_ticked] = STATE(1454),
    [sym__qvariable_ticked] = STATE(1454),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__constructor_ticked] = STATE(1454),
    [sym__qconstructor_ticked] = STATE(1454),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1454),
    [sym__operator_alias] = STATE(1454),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym_constructor_operator] = STATE(1454),
    [sym__constructor_operator_alias] = STATE(1454),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__tight_dot] = STATE(12126),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2570),
    [sym__paren_open] = STATE(382),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(349),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [anon_sym_u2237] = ACTIONS(349),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(349),
    [sym__cond_layout_end] = ACTIONS(349),
    [sym__cond_layout_end_explicit] = ACTIONS(349),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1055),
    [sym__cond_no_section_op] = ACTIONS(1057),
    [sym__cond_minus] = ACTIONS(1059),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [311] = {
    [sym__at_type] = STATE(5175),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym_explicit_type] = STATE(5177),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_op] = STATE(1454),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(295),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__variable_ticked] = STATE(1454),
    [sym__qvariable_ticked] = STATE(1454),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__constructor_ticked] = STATE(1454),
    [sym__qconstructor_ticked] = STATE(1454),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1454),
    [sym__operator_alias] = STATE(1454),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym_constructor_operator] = STATE(1454),
    [sym__constructor_operator_alias] = STATE(1454),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__tight_dot] = STATE(12126),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2570),
    [sym__paren_open] = STATE(382),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(353),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_u2237] = ACTIONS(353),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(353),
    [sym__cond_layout_end] = ACTIONS(353),
    [sym__cond_layout_end_explicit] = ACTIONS(353),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1055),
    [sym__cond_no_section_op] = ACTIONS(1057),
    [sym__cond_minus] = ACTIONS(1059),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [312] = {
    [sym__at_type] = STATE(5175),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym_explicit_type] = STATE(5177),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_op] = STATE(1454),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(295),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__variable_ticked] = STATE(1454),
    [sym__qvariable_ticked] = STATE(1454),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__constructor_ticked] = STATE(1454),
    [sym__qconstructor_ticked] = STATE(1454),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1454),
    [sym__operator_alias] = STATE(1454),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym_constructor_operator] = STATE(1454),
    [sym__constructor_operator_alias] = STATE(1454),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__tight_dot] = STATE(12126),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2570),
    [sym__paren_open] = STATE(382),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [anon_sym_COLON_COLON] = ACTIONS(357),
    [anon_sym_u2237] = ACTIONS(357),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(357),
    [sym__cond_layout_end] = ACTIONS(357),
    [sym__cond_layout_end_explicit] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1055),
    [sym__cond_no_section_op] = ACTIONS(1057),
    [sym__cond_minus] = ACTIONS(1059),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [313] = {
    [sym__at_type] = STATE(5175),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym_explicit_type] = STATE(5177),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_op] = STATE(1454),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(295),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__variable_ticked] = STATE(1454),
    [sym__qvariable_ticked] = STATE(1454),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__constructor_ticked] = STATE(1454),
    [sym__qconstructor_ticked] = STATE(1454),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1454),
    [sym__operator_alias] = STATE(1454),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym_constructor_operator] = STATE(1454),
    [sym__constructor_operator_alias] = STATE(1454),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__tight_dot] = STATE(12126),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2570),
    [sym__paren_open] = STATE(382),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [anon_sym_COLON_COLON] = ACTIONS(333),
    [anon_sym_u2237] = ACTIONS(333),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(333),
    [sym__cond_layout_end] = ACTIONS(333),
    [sym__cond_layout_end_explicit] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1055),
    [sym__cond_no_section_op] = ACTIONS(1057),
    [sym__cond_minus] = ACTIONS(1059),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [314] = {
    [sym__at_type] = STATE(5175),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym_explicit_type] = STATE(5177),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_op] = STATE(1454),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(295),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__variable_ticked] = STATE(1454),
    [sym__qvariable_ticked] = STATE(1454),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__constructor_ticked] = STATE(1454),
    [sym__qconstructor_ticked] = STATE(1454),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1454),
    [sym__operator_alias] = STATE(1454),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym_constructor_operator] = STATE(1454),
    [sym__constructor_operator_alias] = STATE(1454),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__tight_dot] = STATE(12126),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2570),
    [sym__paren_open] = STATE(382),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [anon_sym_COLON_COLON] = ACTIONS(357),
    [anon_sym_u2237] = ACTIONS(357),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(357),
    [sym__cond_layout_end] = ACTIONS(357),
    [sym__cond_layout_end_explicit] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1055),
    [sym__cond_no_section_op] = ACTIONS(1057),
    [sym__cond_minus] = ACTIONS(1059),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [315] = {
    [sym__at_type] = STATE(5330),
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym_explicit_type] = STATE(5329),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_op] = STATE(1419),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(301),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__variable_ticked] = STATE(1419),
    [sym__qvariable_ticked] = STATE(1419),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__constructor_ticked] = STATE(1419),
    [sym__qconstructor_ticked] = STATE(1419),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1419),
    [sym__operator_alias] = STATE(1419),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym_constructor_operator] = STATE(1419),
    [sym__constructor_operator_alias] = STATE(1419),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__tight_dot] = STATE(11655),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2422),
    [sym__paren_open] = STATE(380),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_COMMA] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_by] = ACTIONS(359),
    [anon_sym_PIPE] = ACTIONS(357),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [anon_sym_COLON_COLON] = ACTIONS(357),
    [anon_sym_u2237] = ACTIONS(357),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(357),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1031),
    [sym__cond_no_section_op] = ACTIONS(1033),
    [sym__cond_minus] = ACTIONS(1035),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [316] = {
    [sym__at_type] = STATE(5330),
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym_explicit_type] = STATE(5329),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_op] = STATE(1419),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(301),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__variable_ticked] = STATE(1419),
    [sym__qvariable_ticked] = STATE(1419),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__constructor_ticked] = STATE(1419),
    [sym__qconstructor_ticked] = STATE(1419),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1419),
    [sym__operator_alias] = STATE(1419),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym_constructor_operator] = STATE(1419),
    [sym__constructor_operator_alias] = STATE(1419),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__tight_dot] = STATE(11655),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2422),
    [sym__paren_open] = STATE(380),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_COMMA] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_by] = ACTIONS(359),
    [anon_sym_PIPE] = ACTIONS(357),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [anon_sym_COLON_COLON] = ACTIONS(357),
    [anon_sym_u2237] = ACTIONS(357),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(357),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1031),
    [sym__cond_no_section_op] = ACTIONS(1033),
    [sym__cond_minus] = ACTIONS(1035),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [317] = {
    [sym__at_type] = STATE(5330),
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym_explicit_type] = STATE(5329),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_op] = STATE(1419),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(301),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__variable_ticked] = STATE(1419),
    [sym__qvariable_ticked] = STATE(1419),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__constructor_ticked] = STATE(1419),
    [sym__qconstructor_ticked] = STATE(1419),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1419),
    [sym__operator_alias] = STATE(1419),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym_constructor_operator] = STATE(1419),
    [sym__constructor_operator_alias] = STATE(1419),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__tight_dot] = STATE(11655),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2422),
    [sym__paren_open] = STATE(380),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_by] = ACTIONS(335),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [anon_sym_COLON_COLON] = ACTIONS(333),
    [anon_sym_u2237] = ACTIONS(333),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(333),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1031),
    [sym__cond_no_section_op] = ACTIONS(1033),
    [sym__cond_minus] = ACTIONS(1035),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [318] = {
    [sym__at_type] = STATE(5483),
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym_explicit_type] = STATE(5466),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_op] = STATE(1413),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(303),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__variable_ticked] = STATE(1413),
    [sym__qvariable_ticked] = STATE(1413),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__constructor_ticked] = STATE(1413),
    [sym__qconstructor_ticked] = STATE(1413),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1413),
    [sym__operator_alias] = STATE(1413),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym_constructor_operator] = STATE(1413),
    [sym__constructor_operator_alias] = STATE(1413),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__tight_dot] = STATE(12144),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2551),
    [sym__paren_open] = STATE(383),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_LBRACE] = ACTIONS(971),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [anon_sym_u2192] = ACTIONS(333),
    [anon_sym_COLON_COLON] = ACTIONS(333),
    [anon_sym_u2237] = ACTIONS(333),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1001),
    [sym__cond_no_section_op] = ACTIONS(1003),
    [sym__cond_minus] = ACTIONS(1005),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [319] = {
    [sym__at_type] = STATE(5330),
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym_explicit_type] = STATE(5329),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_op] = STATE(1419),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(301),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__variable_ticked] = STATE(1419),
    [sym__qvariable_ticked] = STATE(1419),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__constructor_ticked] = STATE(1419),
    [sym__qconstructor_ticked] = STATE(1419),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1419),
    [sym__operator_alias] = STATE(1419),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym_constructor_operator] = STATE(1419),
    [sym__constructor_operator_alias] = STATE(1419),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__tight_dot] = STATE(11655),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2422),
    [sym__paren_open] = STATE(380),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_by] = ACTIONS(335),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [anon_sym_COLON_COLON] = ACTIONS(333),
    [anon_sym_u2237] = ACTIONS(333),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(333),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1031),
    [sym__cond_no_section_op] = ACTIONS(1033),
    [sym__cond_minus] = ACTIONS(1035),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [320] = {
    [sym__at_type] = STATE(5016),
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym_explicit_type] = STATE(5013),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_op] = STATE(1621),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1621),
    [sym__qvariable_ticked] = STATE(1621),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1621),
    [sym__qconstructor_ticked] = STATE(1621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1621),
    [sym__operator_alias] = STATE(1621),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(1621),
    [sym__constructor_operator_alias] = STATE(1621),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__colon2] = STATE(1548),
    [sym__tight_dot] = STATE(11863),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2433),
    [sym__paren_open] = STATE(397),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_u2237] = ACTIONS(365),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(297),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(917),
    [sym__cond_left_section_op] = ACTIONS(1111),
    [sym__cond_no_section_op] = ACTIONS(921),
    [sym__cond_minus] = ACTIONS(923),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [321] = {
    [sym__at_type] = STATE(5607),
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym_explicit_type] = STATE(5520),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_op] = STATE(1558),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(330),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__variable_ticked] = STATE(1558),
    [sym__qvariable_ticked] = STATE(1558),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__constructor_ticked] = STATE(1558),
    [sym__qconstructor_ticked] = STATE(1558),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1558),
    [sym__operator_alias] = STATE(1558),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym_constructor_operator] = STATE(1558),
    [sym__constructor_operator_alias] = STATE(1558),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__colon2] = STATE(1725),
    [sym__tight_dot] = STATE(11833),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2601),
    [sym__paren_open] = STATE(393),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(1073),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [anon_sym_COLON_COLON] = ACTIONS(1113),
    [anon_sym_u2237] = ACTIONS(1113),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(297),
    [sym__phantom_bar] = ACTIONS(297),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1105),
    [sym__cond_no_section_op] = ACTIONS(1107),
    [sym__cond_minus] = ACTIONS(1109),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [322] = {
    [sym__at_type] = STATE(5330),
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym_explicit_type] = STATE(5329),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_op] = STATE(1419),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(301),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__variable_ticked] = STATE(1419),
    [sym__qvariable_ticked] = STATE(1419),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__constructor_ticked] = STATE(1419),
    [sym__qconstructor_ticked] = STATE(1419),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1419),
    [sym__operator_alias] = STATE(1419),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym_constructor_operator] = STATE(1419),
    [sym__constructor_operator_alias] = STATE(1419),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__tight_dot] = STATE(11655),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2422),
    [sym__paren_open] = STATE(380),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_COMMA] = ACTIONS(353),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_by] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(353),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_u2237] = ACTIONS(353),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(353),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1031),
    [sym__cond_no_section_op] = ACTIONS(1033),
    [sym__cond_minus] = ACTIONS(1035),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [323] = {
    [sym__at_type] = STATE(5483),
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym_explicit_type] = STATE(5466),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_op] = STATE(1413),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(303),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__variable_ticked] = STATE(1413),
    [sym__qvariable_ticked] = STATE(1413),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__constructor_ticked] = STATE(1413),
    [sym__qconstructor_ticked] = STATE(1413),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1413),
    [sym__operator_alias] = STATE(1413),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym_constructor_operator] = STATE(1413),
    [sym__constructor_operator_alias] = STATE(1413),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__tight_dot] = STATE(12144),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2551),
    [sym__paren_open] = STATE(383),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(971),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_DASH_GT] = ACTIONS(361),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [anon_sym_u2192] = ACTIONS(361),
    [anon_sym_COLON_COLON] = ACTIONS(361),
    [anon_sym_u2237] = ACTIONS(361),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(361),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1001),
    [sym__cond_no_section_op] = ACTIONS(1003),
    [sym__cond_minus] = ACTIONS(1005),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [324] = {
    [sym__at_type] = STATE(5016),
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym_explicit_type] = STATE(5013),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_op] = STATE(1621),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1621),
    [sym__qvariable_ticked] = STATE(1621),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1621),
    [sym__qconstructor_ticked] = STATE(1621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1621),
    [sym__operator_alias] = STATE(1621),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(1621),
    [sym__constructor_operator_alias] = STATE(1621),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__colon2] = STATE(1548),
    [sym__tight_dot] = STATE(11863),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2433),
    [sym__paren_open] = STATE(397),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_u2237] = ACTIONS(365),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(297),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(917),
    [sym__cond_left_section_op] = ACTIONS(1115),
    [sym__cond_no_section_op] = ACTIONS(921),
    [sym__cond_minus] = ACTIONS(923),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [325] = {
    [sym__at_type] = STATE(5483),
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym_explicit_type] = STATE(5466),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_op] = STATE(1413),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(303),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__variable_ticked] = STATE(1413),
    [sym__qvariable_ticked] = STATE(1413),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__constructor_ticked] = STATE(1413),
    [sym__qconstructor_ticked] = STATE(1413),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1413),
    [sym__operator_alias] = STATE(1413),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym_constructor_operator] = STATE(1413),
    [sym__constructor_operator_alias] = STATE(1413),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__tight_dot] = STATE(12144),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2551),
    [sym__paren_open] = STATE(383),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_LBRACE] = ACTIONS(971),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_DASH_GT] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [anon_sym_u2192] = ACTIONS(333),
    [anon_sym_COLON_COLON] = ACTIONS(333),
    [anon_sym_u2237] = ACTIONS(333),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1001),
    [sym__cond_no_section_op] = ACTIONS(1003),
    [sym__cond_minus] = ACTIONS(1005),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [326] = {
    [sym__type_parens] = STATE(2335),
    [sym__type_tuple] = STATE(2337),
    [sym__type_unboxed_tuple] = STATE(2338),
    [sym__type_unboxed_sum] = STATE(2341),
    [sym__type_list] = STATE(2342),
    [sym__type_promoted] = STATE(2327),
    [sym__type_star] = STATE(2327),
    [sym__type_wildcard] = STATE(2327),
    [sym__at_type] = STATE(2345),
    [sym__type_apply] = STATE(2353),
    [sym__type_infix] = STATE(2352),
    [sym_type] = STATE(326),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8457),
    [sym__splice_dollars] = STATE(7396),
    [sym_splice] = STATE(2327),
    [sym_quasiquote] = STATE(2327),
    [sym_integer] = STATE(2318),
    [sym__plist] = STATE(2350),
    [sym_unit] = STATE(2327),
    [sym_unboxed_unit] = STATE(2327),
    [sym_prefix_tuple] = STATE(2327),
    [sym_prefix_unboxed_tuple] = STATE(2327),
    [sym_prefix_unboxed_sum] = STATE(2327),
    [sym_literal] = STATE(2327),
    [sym__qualified_type] = STATE(2343),
    [sym__qtyconid] = STATE(2348),
    [sym__tycon_arrow] = STATE(2348),
    [sym__qtycon_arrow] = STATE(2348),
    [sym__promoted_tycons_alias] = STATE(2327),
    [sym__promoted_tycons] = STATE(2327),
    [sym__tycon_ticked] = STATE(2549),
    [sym__qtycon_ticked] = STATE(2549),
    [sym__tyconids_ticked] = STATE(2549),
    [sym__promoted_tyconops_alias] = STATE(2549),
    [sym__promoted_tyconops] = STATE(2549),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2549),
    [sym__operator_alias] = STATE(2549),
    [sym__operator_minus] = STATE(2549),
    [sym__varsym_prefix] = STATE(2348),
    [sym__pvarsym] = STATE(2348),
    [sym__qualified_varsym] = STATE(2536),
    [sym__qvarsym_prefix] = STATE(2348),
    [sym__pqvarsym] = STATE(2348),
    [sym_constructor_operator] = STATE(2549),
    [sym__constructor_operator_alias] = STATE(2549),
    [sym__consym_prefix] = STATE(2348),
    [sym__pconsym] = STATE(2348),
    [sym__qualified_consym] = STATE(2535),
    [sym__qconsym_prefix] = STATE(2348),
    [sym__pqconsym] = STATE(2348),
    [sym__prefix_at] = STATE(2607),
    [sym__paren_open] = STATE(445),
    [sym__bracket_open] = STATE(1047),
    [sym__unboxed_open] = STATE(740),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_RBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_EQ] = ACTIONS(1119),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1119),
    [anon_sym_then] = ACTIONS(1117),
    [anon_sym_using] = ACTIONS(1117),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_else] = ACTIONS(1117),
    [anon_sym_mdo] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_of] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1119),
    [anon_sym_u27e7] = ACTIONS(1119),
    [anon_sym_u27e6] = ACTIONS(1119),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1117),
    [sym_implicit_variable] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [sym_label] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1119),
    [anon_sym_u22b8] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__paren_close_token1] = ACTIONS(1119),
    [anon_sym_RBRACK] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_tight_dot] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_prefix_percent] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__cond_minus] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [327] = {
    [sym__type_parens] = STATE(2335),
    [sym__type_tuple] = STATE(2337),
    [sym__type_unboxed_tuple] = STATE(2338),
    [sym__type_unboxed_sum] = STATE(2341),
    [sym__type_list] = STATE(2342),
    [sym__type_promoted] = STATE(2327),
    [sym__type_star] = STATE(2327),
    [sym__type_wildcard] = STATE(2327),
    [sym__at_type] = STATE(2345),
    [sym__type_apply] = STATE(2353),
    [sym__type_infix] = STATE(2352),
    [sym_type] = STATE(326),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8457),
    [sym__splice_dollars] = STATE(7396),
    [sym_splice] = STATE(2327),
    [sym_quasiquote] = STATE(2327),
    [sym_integer] = STATE(2318),
    [sym__plist] = STATE(2350),
    [sym_unit] = STATE(2327),
    [sym_unboxed_unit] = STATE(2327),
    [sym_prefix_tuple] = STATE(2327),
    [sym_prefix_unboxed_tuple] = STATE(2327),
    [sym_prefix_unboxed_sum] = STATE(2327),
    [sym_literal] = STATE(2327),
    [sym__qualified_type] = STATE(2343),
    [sym__qtyconid] = STATE(2348),
    [sym__tycon_arrow] = STATE(2348),
    [sym__qtycon_arrow] = STATE(2348),
    [sym__promoted_tycons_alias] = STATE(2327),
    [sym__promoted_tycons] = STATE(2327),
    [sym__tycon_ticked] = STATE(2549),
    [sym__qtycon_ticked] = STATE(2549),
    [sym__tyconids_ticked] = STATE(2549),
    [sym__promoted_tyconops_alias] = STATE(2549),
    [sym__promoted_tyconops] = STATE(2549),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2549),
    [sym__operator_alias] = STATE(2549),
    [sym__operator_minus] = STATE(2549),
    [sym__varsym_prefix] = STATE(2348),
    [sym__pvarsym] = STATE(2348),
    [sym__qualified_varsym] = STATE(2536),
    [sym__qvarsym_prefix] = STATE(2348),
    [sym__pqvarsym] = STATE(2348),
    [sym_constructor_operator] = STATE(2549),
    [sym__constructor_operator_alias] = STATE(2549),
    [sym__consym_prefix] = STATE(2348),
    [sym__pconsym] = STATE(2348),
    [sym__qualified_consym] = STATE(2535),
    [sym__qconsym_prefix] = STATE(2348),
    [sym__pqconsym] = STATE(2348),
    [sym__prefix_at] = STATE(2607),
    [sym__paren_open] = STATE(445),
    [sym__bracket_open] = STATE(1047),
    [sym__unboxed_open] = STATE(740),
    [sym_variable] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_let] = ACTIONS(1125),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym__] = ACTIONS(1127),
    [anon_sym_SQUOTE] = ACTIONS(1129),
    [anon_sym_STAR] = ACTIONS(1131),
    [anon_sym_u2605] = ACTIONS(1133),
    [anon_sym_EQ] = ACTIONS(1123),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1123),
    [anon_sym_then] = ACTIONS(1125),
    [anon_sym_using] = ACTIONS(1125),
    [anon_sym_BSLASH] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1125),
    [anon_sym_else] = ACTIONS(1125),
    [anon_sym_mdo] = ACTIONS(1125),
    [anon_sym_do] = ACTIONS(1125),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_of] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1123),
    [anon_sym_u27e7] = ACTIONS(1123),
    [anon_sym_u27e6] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(1123),
    [sym_float] = ACTIONS(1139),
    [sym_char] = ACTIONS(1139),
    [sym_string] = ACTIONS(1139),
    [sym__integer_literal] = ACTIONS(1141),
    [sym__binary_literal] = ACTIONS(1143),
    [sym__octal_literal] = ACTIONS(1143),
    [sym__hex_literal] = ACTIONS(1143),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1123),
    [sym_name] = ACTIONS(1149),
    [sym_label] = ACTIONS(1123),
    [anon_sym_u2192] = ACTIONS(1123),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1123),
    [anon_sym_u22b8] = ACTIONS(1123),
    [anon_sym_COLON_COLON] = ACTIONS(1123),
    [anon_sym_u2237] = ACTIONS(1123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1123),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1153),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1123),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1123),
    [sym__cond_qualified_op] = ACTIONS(1123),
    [sym__cond_no_section_op] = ACTIONS(1123),
    [sym__cond_minus] = ACTIONS(1123),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [328] = {
    [sym__type_parens] = STATE(2335),
    [sym__type_tuple] = STATE(2337),
    [sym__type_unboxed_tuple] = STATE(2338),
    [sym__type_unboxed_sum] = STATE(2341),
    [sym__type_list] = STATE(2342),
    [sym__type_promoted] = STATE(2327),
    [sym__type_star] = STATE(2327),
    [sym__type_wildcard] = STATE(2327),
    [sym__at_type] = STATE(2345),
    [sym__type_apply] = STATE(2353),
    [sym__type_infix] = STATE(2352),
    [sym_type] = STATE(326),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8457),
    [sym__splice_dollars] = STATE(7396),
    [sym_splice] = STATE(2327),
    [sym_quasiquote] = STATE(2327),
    [sym_integer] = STATE(2318),
    [sym__plist] = STATE(2350),
    [sym_unit] = STATE(2327),
    [sym_unboxed_unit] = STATE(2327),
    [sym_prefix_tuple] = STATE(2327),
    [sym_prefix_unboxed_tuple] = STATE(2327),
    [sym_prefix_unboxed_sum] = STATE(2327),
    [sym_literal] = STATE(2327),
    [sym__qualified_type] = STATE(2343),
    [sym__qtyconid] = STATE(2348),
    [sym__tycon_arrow] = STATE(2348),
    [sym__qtycon_arrow] = STATE(2348),
    [sym__promoted_tycons_alias] = STATE(2327),
    [sym__promoted_tycons] = STATE(2327),
    [sym__tycon_ticked] = STATE(2549),
    [sym__qtycon_ticked] = STATE(2549),
    [sym__tyconids_ticked] = STATE(2549),
    [sym__promoted_tyconops_alias] = STATE(2549),
    [sym__promoted_tyconops] = STATE(2549),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2549),
    [sym__operator_alias] = STATE(2549),
    [sym__operator_minus] = STATE(2549),
    [sym__varsym_prefix] = STATE(2348),
    [sym__pvarsym] = STATE(2348),
    [sym__qualified_varsym] = STATE(2536),
    [sym__qvarsym_prefix] = STATE(2348),
    [sym__pqvarsym] = STATE(2348),
    [sym_constructor_operator] = STATE(2549),
    [sym__constructor_operator_alias] = STATE(2549),
    [sym__consym_prefix] = STATE(2348),
    [sym__pconsym] = STATE(2348),
    [sym__qualified_consym] = STATE(2535),
    [sym__qconsym_prefix] = STATE(2348),
    [sym__pqconsym] = STATE(2348),
    [sym__prefix_at] = STATE(2607),
    [sym__paren_open] = STATE(445),
    [sym__bracket_open] = STATE(1047),
    [sym__unboxed_open] = STATE(740),
    [sym_variable] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym_let] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym_RBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1127),
    [anon_sym_SQUOTE] = ACTIONS(1129),
    [anon_sym_STAR] = ACTIONS(1131),
    [anon_sym_u2605] = ACTIONS(1133),
    [anon_sym_EQ] = ACTIONS(1157),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1157),
    [anon_sym_then] = ACTIONS(1159),
    [anon_sym_using] = ACTIONS(1159),
    [anon_sym_BSLASH] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_else] = ACTIONS(1159),
    [anon_sym_mdo] = ACTIONS(1159),
    [anon_sym_do] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1159),
    [anon_sym_of] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1157),
    [anon_sym_u27e7] = ACTIONS(1157),
    [anon_sym_u27e6] = ACTIONS(1157),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(1157),
    [sym_float] = ACTIONS(1139),
    [sym_char] = ACTIONS(1139),
    [sym_string] = ACTIONS(1139),
    [sym__integer_literal] = ACTIONS(1141),
    [sym__binary_literal] = ACTIONS(1143),
    [sym__octal_literal] = ACTIONS(1143),
    [sym__hex_literal] = ACTIONS(1143),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1157),
    [sym_name] = ACTIONS(1149),
    [sym_label] = ACTIONS(1157),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1157),
    [anon_sym_u22b8] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1157),
    [anon_sym_RBRACK] = ACTIONS(1157),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1153),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1157),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1157),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__cond_minus] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [329] = {
    [sym_generator] = STATE(10236),
    [sym_let] = STATE(10233),
    [sym_guard] = STATE(9721),
    [sym_guards] = STATE(11071),
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(247),
    [sym__exp_signature] = STATE(10022),
    [sym__exp] = STATE(10258),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11269),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9354),
    [sym__splice_dollars] = STATE(7293),
    [sym_splice] = STATE(3642),
    [sym_quasiquote] = STATE(3642),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(3683),
    [sym__plist] = STATE(3641),
    [sym_unit] = STATE(3642),
    [sym_unboxed_unit] = STATE(3642),
    [sym_prefix_tuple] = STATE(3642),
    [sym_prefix_unboxed_tuple] = STATE(3642),
    [sym_prefix_unboxed_sum] = STATE(3642),
    [sym_literal] = STATE(3642),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__qualified_constructor] = STATE(3562),
    [sym__qconid] = STATE(3642),
    [sym__varsym_prefix] = STATE(3659),
    [sym__pvarsym] = STATE(3659),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym__consym_prefix] = STATE(3634),
    [sym__pconsym] = STATE(3634),
    [sym__qconsym_prefix] = STATE(3642),
    [sym__pqconsym] = STATE(3642),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(29),
    [sym__bracket_open] = STATE(373),
    [sym__unboxed_open] = STATE(195),
    [sym_variable] = ACTIONS(1161),
    [anon_sym_let] = ACTIONS(1163),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(1167),
    [sym_char] = ACTIONS(1167),
    [sym_string] = ACTIONS(1167),
    [sym__integer_literal] = ACTIONS(1169),
    [sym__binary_literal] = ACTIONS(1171),
    [sym__octal_literal] = ACTIONS(1171),
    [sym__hex_literal] = ACTIONS(1171),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(1173),
    [sym_label] = ACTIONS(995),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1175),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [330] = {
    [sym__at_type] = STATE(5607),
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym_explicit_type] = STATE(5520),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_op] = STATE(1558),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(330),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__variable_ticked] = STATE(1558),
    [sym__qvariable_ticked] = STATE(1558),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__constructor_ticked] = STATE(1558),
    [sym__qconstructor_ticked] = STATE(1558),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1558),
    [sym__operator_alias] = STATE(1558),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym_constructor_operator] = STATE(1558),
    [sym__constructor_operator_alias] = STATE(1558),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__tight_dot] = STATE(11833),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2601),
    [sym__paren_open] = STATE(393),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(337),
    [anon_sym_let] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(1073),
    [anon_sym_SQUOTE] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(339),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(339),
    [anon_sym_BSLASH] = ACTIONS(339),
    [anon_sym_if] = ACTIONS(337),
    [anon_sym_mdo] = ACTIONS(337),
    [anon_sym_do] = ACTIONS(337),
    [anon_sym_case] = ACTIONS(337),
    [anon_sym_DASH] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(339),
    [anon_sym_u27e6] = ACTIONS(339),
    [sym_float] = ACTIONS(339),
    [sym_char] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym__integer_literal] = ACTIONS(337),
    [sym__binary_literal] = ACTIONS(339),
    [sym__octal_literal] = ACTIONS(339),
    [sym__hex_literal] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [anon_sym_POUND] = ACTIONS(337),
    [anon_sym_POUND2] = ACTIONS(337),
    [sym_implicit_variable] = ACTIONS(339),
    [sym_name] = ACTIONS(339),
    [sym_label] = ACTIONS(339),
    [anon_sym_COLON_COLON] = ACTIONS(339),
    [anon_sym_u2237] = ACTIONS(339),
    [aux_sym__paren_open_token1] = ACTIONS(339),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(339),
    [sym__phantom_bar] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(339),
    [sym__cond_splice] = ACTIONS(339),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(339),
    [sym__cond_prefix_at] = ACTIONS(339),
    [sym__cond_qualified_op] = ACTIONS(339),
    [sym__cond_no_section_op] = ACTIONS(339),
    [sym__cond_minus] = ACTIONS(339),
    [sym__varsym] = ACTIONS(339),
    [sym__consym] = ACTIONS(339),
  },
  [331] = {
    [sym__at_type] = STATE(5607),
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym_explicit_type] = STATE(5520),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_op] = STATE(1558),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(330),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__variable_ticked] = STATE(1558),
    [sym__qvariable_ticked] = STATE(1558),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__constructor_ticked] = STATE(1558),
    [sym__qconstructor_ticked] = STATE(1558),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1558),
    [sym__operator_alias] = STATE(1558),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym_constructor_operator] = STATE(1558),
    [sym__constructor_operator_alias] = STATE(1558),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__tight_dot] = STATE(11833),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2601),
    [sym__paren_open] = STATE(393),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(1073),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(345),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(345),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_POUND] = ACTIONS(347),
    [anon_sym_POUND2] = ACTIONS(347),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [anon_sym_COLON_COLON] = ACTIONS(345),
    [anon_sym_u2237] = ACTIONS(345),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(345),
    [sym__phantom_bar] = ACTIONS(345),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(345),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(345),
    [sym__cond_no_section_op] = ACTIONS(345),
    [sym__cond_minus] = ACTIONS(345),
    [sym__varsym] = ACTIONS(345),
    [sym__consym] = ACTIONS(345),
  },
  [332] = {
    [sym__type_parens] = STATE(2335),
    [sym__type_tuple] = STATE(2337),
    [sym__type_unboxed_tuple] = STATE(2338),
    [sym__type_unboxed_sum] = STATE(2341),
    [sym__type_list] = STATE(2342),
    [sym__type_promoted] = STATE(2327),
    [sym__type_star] = STATE(2327),
    [sym__type_wildcard] = STATE(2327),
    [sym__at_type] = STATE(2345),
    [sym__type_apply] = STATE(2353),
    [sym__type_infix] = STATE(2352),
    [sym_type] = STATE(326),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8457),
    [sym__splice_dollars] = STATE(7396),
    [sym_splice] = STATE(2327),
    [sym_quasiquote] = STATE(2327),
    [sym_integer] = STATE(2318),
    [sym__plist] = STATE(2350),
    [sym_unit] = STATE(2327),
    [sym_unboxed_unit] = STATE(2327),
    [sym_prefix_tuple] = STATE(2327),
    [sym_prefix_unboxed_tuple] = STATE(2327),
    [sym_prefix_unboxed_sum] = STATE(2327),
    [sym_literal] = STATE(2327),
    [sym__qualified_type] = STATE(2343),
    [sym__qtyconid] = STATE(2348),
    [sym__tycon_arrow] = STATE(2348),
    [sym__qtycon_arrow] = STATE(2348),
    [sym__promoted_tycons_alias] = STATE(2327),
    [sym__promoted_tycons] = STATE(2327),
    [sym__tycon_ticked] = STATE(2549),
    [sym__qtycon_ticked] = STATE(2549),
    [sym__tyconids_ticked] = STATE(2549),
    [sym__promoted_tyconops_alias] = STATE(2549),
    [sym__promoted_tyconops] = STATE(2549),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2549),
    [sym__operator_alias] = STATE(2549),
    [sym__operator_minus] = STATE(2549),
    [sym__varsym_prefix] = STATE(2348),
    [sym__pvarsym] = STATE(2348),
    [sym__qualified_varsym] = STATE(2536),
    [sym__qvarsym_prefix] = STATE(2348),
    [sym__pqvarsym] = STATE(2348),
    [sym_constructor_operator] = STATE(2549),
    [sym__constructor_operator_alias] = STATE(2549),
    [sym__consym_prefix] = STATE(2348),
    [sym__pconsym] = STATE(2348),
    [sym__qualified_consym] = STATE(2535),
    [sym__qconsym_prefix] = STATE(2348),
    [sym__pqconsym] = STATE(2348),
    [sym__prefix_at] = STATE(2607),
    [sym__paren_open] = STATE(445),
    [sym__bracket_open] = STATE(1047),
    [sym__unboxed_open] = STATE(740),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym_RBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_then] = ACTIONS(1177),
    [anon_sym_using] = ACTIONS(1177),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_else] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_of] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1179),
    [anon_sym_u27e7] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1179),
    [anon_sym_u22b8] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__paren_close_token1] = ACTIONS(1179),
    [anon_sym_RBRACK] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_prefix_percent] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [333] = {
    [sym__type_parens] = STATE(2335),
    [sym__type_tuple] = STATE(2337),
    [sym__type_unboxed_tuple] = STATE(2338),
    [sym__type_unboxed_sum] = STATE(2341),
    [sym__type_list] = STATE(2342),
    [sym__type_promoted] = STATE(2327),
    [sym__type_star] = STATE(2327),
    [sym__type_wildcard] = STATE(2327),
    [sym__at_type] = STATE(2345),
    [sym__type_apply] = STATE(2353),
    [sym__type_infix] = STATE(2352),
    [sym_type] = STATE(326),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8457),
    [sym__splice_dollars] = STATE(7396),
    [sym_splice] = STATE(2327),
    [sym_quasiquote] = STATE(2327),
    [sym_integer] = STATE(2318),
    [sym__plist] = STATE(2350),
    [sym_unit] = STATE(2327),
    [sym_unboxed_unit] = STATE(2327),
    [sym_prefix_tuple] = STATE(2327),
    [sym_prefix_unboxed_tuple] = STATE(2327),
    [sym_prefix_unboxed_sum] = STATE(2327),
    [sym_literal] = STATE(2327),
    [sym__qualified_type] = STATE(2343),
    [sym__qtyconid] = STATE(2348),
    [sym__tycon_arrow] = STATE(2348),
    [sym__qtycon_arrow] = STATE(2348),
    [sym__promoted_tycons_alias] = STATE(2327),
    [sym__promoted_tycons] = STATE(2327),
    [sym__tycon_ticked] = STATE(2549),
    [sym__qtycon_ticked] = STATE(2549),
    [sym__tyconids_ticked] = STATE(2549),
    [sym__promoted_tyconops_alias] = STATE(2549),
    [sym__promoted_tyconops] = STATE(2549),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2549),
    [sym__operator_alias] = STATE(2549),
    [sym__operator_minus] = STATE(2549),
    [sym__varsym_prefix] = STATE(2348),
    [sym__pvarsym] = STATE(2348),
    [sym__qualified_varsym] = STATE(2536),
    [sym__qvarsym_prefix] = STATE(2348),
    [sym__pqvarsym] = STATE(2348),
    [sym_constructor_operator] = STATE(2549),
    [sym__constructor_operator_alias] = STATE(2549),
    [sym__consym_prefix] = STATE(2348),
    [sym__pconsym] = STATE(2348),
    [sym__qualified_consym] = STATE(2535),
    [sym__qconsym_prefix] = STATE(2348),
    [sym__pqconsym] = STATE(2348),
    [sym__prefix_at] = STATE(2607),
    [sym__paren_open] = STATE(445),
    [sym__bracket_open] = STATE(1047),
    [sym__unboxed_open] = STATE(740),
    [sym_variable] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1127),
    [anon_sym_SQUOTE] = ACTIONS(1129),
    [anon_sym_STAR] = ACTIONS(1131),
    [anon_sym_u2605] = ACTIONS(1133),
    [anon_sym_EQ] = ACTIONS(1181),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_then] = ACTIONS(1183),
    [anon_sym_using] = ACTIONS(1183),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_else] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_of] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1181),
    [anon_sym_u27e7] = ACTIONS(1181),
    [anon_sym_u27e6] = ACTIONS(1181),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(1181),
    [sym_float] = ACTIONS(1139),
    [sym_char] = ACTIONS(1139),
    [sym_string] = ACTIONS(1139),
    [sym__integer_literal] = ACTIONS(1141),
    [sym__binary_literal] = ACTIONS(1143),
    [sym__octal_literal] = ACTIONS(1143),
    [sym__hex_literal] = ACTIONS(1143),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1149),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1181),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1153),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [334] = {
    [sym_generator] = STATE(11661),
    [sym_let] = STATE(11662),
    [sym_guard] = STATE(11232),
    [sym_guards] = STATE(12566),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11671),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10981),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9398),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3628),
    [sym_quasiquote] = STATE(3628),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3629),
    [sym_unit] = STATE(3628),
    [sym_unboxed_unit] = STATE(3628),
    [sym_prefix_tuple] = STATE(3628),
    [sym_prefix_unboxed_tuple] = STATE(3628),
    [sym_prefix_unboxed_sum] = STATE(3628),
    [sym_literal] = STATE(3628),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3628),
    [sym__varsym_prefix] = STATE(3437),
    [sym__pvarsym] = STATE(3437),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3635),
    [sym__pconsym] = STATE(3635),
    [sym__qconsym_prefix] = STATE(3628),
    [sym__pqconsym] = STATE(3628),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__bracket_open] = STATE(374),
    [sym__unboxed_open] = STATE(204),
    [sym_variable] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(1185),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1187),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(963),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [335] = {
    [sym__type_parens] = STATE(2335),
    [sym__type_tuple] = STATE(2337),
    [sym__type_unboxed_tuple] = STATE(2338),
    [sym__type_unboxed_sum] = STATE(2341),
    [sym__type_list] = STATE(2342),
    [sym__type_promoted] = STATE(2327),
    [sym__type_star] = STATE(2327),
    [sym__type_wildcard] = STATE(2327),
    [sym__at_type] = STATE(2345),
    [sym__type_apply] = STATE(2353),
    [sym__type_infix] = STATE(2352),
    [sym_type] = STATE(326),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8457),
    [sym__splice_dollars] = STATE(7396),
    [sym_splice] = STATE(2327),
    [sym_quasiquote] = STATE(2327),
    [sym_integer] = STATE(2318),
    [sym__plist] = STATE(2350),
    [sym_unit] = STATE(2327),
    [sym_unboxed_unit] = STATE(2327),
    [sym_prefix_tuple] = STATE(2327),
    [sym_prefix_unboxed_tuple] = STATE(2327),
    [sym_prefix_unboxed_sum] = STATE(2327),
    [sym_literal] = STATE(2327),
    [sym__qualified_type] = STATE(2343),
    [sym__qtyconid] = STATE(2348),
    [sym__tycon_arrow] = STATE(2348),
    [sym__qtycon_arrow] = STATE(2348),
    [sym__promoted_tycons_alias] = STATE(2327),
    [sym__promoted_tycons] = STATE(2327),
    [sym__tycon_ticked] = STATE(2549),
    [sym__qtycon_ticked] = STATE(2549),
    [sym__tyconids_ticked] = STATE(2549),
    [sym__promoted_tyconops_alias] = STATE(2549),
    [sym__promoted_tyconops] = STATE(2549),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2549),
    [sym__operator_alias] = STATE(2549),
    [sym__operator_minus] = STATE(2549),
    [sym__varsym_prefix] = STATE(2348),
    [sym__pvarsym] = STATE(2348),
    [sym__qualified_varsym] = STATE(2536),
    [sym__qvarsym_prefix] = STATE(2348),
    [sym__pqvarsym] = STATE(2348),
    [sym_constructor_operator] = STATE(2549),
    [sym__constructor_operator_alias] = STATE(2549),
    [sym__consym_prefix] = STATE(2348),
    [sym__pconsym] = STATE(2348),
    [sym__qualified_consym] = STATE(2535),
    [sym__qconsym_prefix] = STATE(2348),
    [sym__pqconsym] = STATE(2348),
    [sym__prefix_at] = STATE(2607),
    [sym__paren_open] = STATE(445),
    [sym__bracket_open] = STATE(1047),
    [sym__unboxed_open] = STATE(740),
    [sym_variable] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1127),
    [anon_sym_SQUOTE] = ACTIONS(1129),
    [anon_sym_STAR] = ACTIONS(1131),
    [anon_sym_u2605] = ACTIONS(1133),
    [anon_sym_EQ] = ACTIONS(1181),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_then] = ACTIONS(1183),
    [anon_sym_using] = ACTIONS(1183),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_else] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_of] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1181),
    [anon_sym_u27e7] = ACTIONS(1181),
    [anon_sym_u27e6] = ACTIONS(1181),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(1181),
    [sym_float] = ACTIONS(1139),
    [sym_char] = ACTIONS(1139),
    [sym_string] = ACTIONS(1139),
    [sym__integer_literal] = ACTIONS(1141),
    [sym__binary_literal] = ACTIONS(1143),
    [sym__octal_literal] = ACTIONS(1143),
    [sym__hex_literal] = ACTIONS(1143),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1149),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1181),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1153),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [336] = {
    [sym__at_type] = STATE(5607),
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym_explicit_type] = STATE(5520),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_op] = STATE(1558),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(330),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__variable_ticked] = STATE(1558),
    [sym__qvariable_ticked] = STATE(1558),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__constructor_ticked] = STATE(1558),
    [sym__qconstructor_ticked] = STATE(1558),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1558),
    [sym__operator_alias] = STATE(1558),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym_constructor_operator] = STATE(1558),
    [sym__constructor_operator_alias] = STATE(1558),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__tight_dot] = STATE(11833),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2601),
    [sym__paren_open] = STATE(393),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(1073),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(341),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [anon_sym_COLON_COLON] = ACTIONS(341),
    [anon_sym_u2237] = ACTIONS(341),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(341),
    [sym__phantom_bar] = ACTIONS(341),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1105),
    [sym__cond_no_section_op] = ACTIONS(1107),
    [sym__cond_minus] = ACTIONS(1109),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [337] = {
    [sym__at_type] = STATE(5607),
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym_explicit_type] = STATE(5520),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_op] = STATE(1558),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(330),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__variable_ticked] = STATE(1558),
    [sym__qvariable_ticked] = STATE(1558),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__constructor_ticked] = STATE(1558),
    [sym__qconstructor_ticked] = STATE(1558),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1558),
    [sym__operator_alias] = STATE(1558),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym_constructor_operator] = STATE(1558),
    [sym__constructor_operator_alias] = STATE(1558),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__tight_dot] = STATE(11833),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2601),
    [sym__paren_open] = STATE(393),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(1073),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [anon_sym_COLON_COLON] = ACTIONS(361),
    [anon_sym_u2237] = ACTIONS(361),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(361),
    [sym__phantom_bar] = ACTIONS(361),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1105),
    [sym__cond_no_section_op] = ACTIONS(1107),
    [sym__cond_minus] = ACTIONS(1109),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [338] = {
    [sym__at_type] = STATE(5607),
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym_explicit_type] = STATE(5520),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_op] = STATE(1558),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(330),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__variable_ticked] = STATE(1558),
    [sym__qvariable_ticked] = STATE(1558),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__constructor_ticked] = STATE(1558),
    [sym__qconstructor_ticked] = STATE(1558),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1558),
    [sym__operator_alias] = STATE(1558),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym_constructor_operator] = STATE(1558),
    [sym__constructor_operator_alias] = STATE(1558),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__tight_dot] = STATE(11833),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2601),
    [sym__paren_open] = STATE(393),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(1073),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(349),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [anon_sym_COLON_COLON] = ACTIONS(349),
    [anon_sym_u2237] = ACTIONS(349),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(349),
    [sym__phantom_bar] = ACTIONS(349),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1105),
    [sym__cond_no_section_op] = ACTIONS(1107),
    [sym__cond_minus] = ACTIONS(1109),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [339] = {
    [sym__at_type] = STATE(5607),
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym_explicit_type] = STATE(5520),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_op] = STATE(1558),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(330),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__variable_ticked] = STATE(1558),
    [sym__qvariable_ticked] = STATE(1558),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__constructor_ticked] = STATE(1558),
    [sym__qconstructor_ticked] = STATE(1558),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1558),
    [sym__operator_alias] = STATE(1558),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym_constructor_operator] = STATE(1558),
    [sym__constructor_operator_alias] = STATE(1558),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__tight_dot] = STATE(11833),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2601),
    [sym__paren_open] = STATE(393),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(1073),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(353),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [anon_sym_COLON_COLON] = ACTIONS(353),
    [anon_sym_u2237] = ACTIONS(353),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(353),
    [sym__phantom_bar] = ACTIONS(353),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1105),
    [sym__cond_no_section_op] = ACTIONS(1107),
    [sym__cond_minus] = ACTIONS(1109),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [340] = {
    [sym__at_type] = STATE(5607),
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym_explicit_type] = STATE(5520),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_op] = STATE(1558),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(330),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__variable_ticked] = STATE(1558),
    [sym__qvariable_ticked] = STATE(1558),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__constructor_ticked] = STATE(1558),
    [sym__qconstructor_ticked] = STATE(1558),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1558),
    [sym__operator_alias] = STATE(1558),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym_constructor_operator] = STATE(1558),
    [sym__constructor_operator_alias] = STATE(1558),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__tight_dot] = STATE(11833),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2601),
    [sym__paren_open] = STATE(393),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(1073),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [anon_sym_COLON_COLON] = ACTIONS(333),
    [anon_sym_u2237] = ACTIONS(333),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(333),
    [sym__phantom_bar] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1105),
    [sym__cond_no_section_op] = ACTIONS(1107),
    [sym__cond_minus] = ACTIONS(1109),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [341] = {
    [sym__at_type] = STATE(5607),
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym_explicit_type] = STATE(5520),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_op] = STATE(1558),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(330),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__variable_ticked] = STATE(1558),
    [sym__qvariable_ticked] = STATE(1558),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__constructor_ticked] = STATE(1558),
    [sym__qconstructor_ticked] = STATE(1558),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1558),
    [sym__operator_alias] = STATE(1558),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym_constructor_operator] = STATE(1558),
    [sym__constructor_operator_alias] = STATE(1558),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__tight_dot] = STATE(11833),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2601),
    [sym__paren_open] = STATE(393),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(1073),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [anon_sym_COLON_COLON] = ACTIONS(333),
    [anon_sym_u2237] = ACTIONS(333),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(333),
    [sym__phantom_bar] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1105),
    [sym__cond_no_section_op] = ACTIONS(1107),
    [sym__cond_minus] = ACTIONS(1109),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [342] = {
    [sym__at_type] = STATE(5607),
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym_explicit_type] = STATE(5520),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_op] = STATE(1558),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(330),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__variable_ticked] = STATE(1558),
    [sym__qvariable_ticked] = STATE(1558),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__constructor_ticked] = STATE(1558),
    [sym__qconstructor_ticked] = STATE(1558),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1558),
    [sym__operator_alias] = STATE(1558),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym_constructor_operator] = STATE(1558),
    [sym__constructor_operator_alias] = STATE(1558),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__tight_dot] = STATE(11833),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2601),
    [sym__paren_open] = STATE(393),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(1073),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(357),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [anon_sym_COLON_COLON] = ACTIONS(357),
    [anon_sym_u2237] = ACTIONS(357),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(357),
    [sym__phantom_bar] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1105),
    [sym__cond_no_section_op] = ACTIONS(1107),
    [sym__cond_minus] = ACTIONS(1109),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [343] = {
    [sym__at_type] = STATE(5607),
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym_explicit_type] = STATE(5520),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_op] = STATE(1558),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(330),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__variable_ticked] = STATE(1558),
    [sym__qvariable_ticked] = STATE(1558),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__constructor_ticked] = STATE(1558),
    [sym__qconstructor_ticked] = STATE(1558),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1558),
    [sym__operator_alias] = STATE(1558),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym_constructor_operator] = STATE(1558),
    [sym__constructor_operator_alias] = STATE(1558),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__tight_dot] = STATE(11833),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2601),
    [sym__paren_open] = STATE(393),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(1073),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_PIPE] = ACTIONS(357),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [anon_sym_COLON_COLON] = ACTIONS(357),
    [anon_sym_u2237] = ACTIONS(357),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(357),
    [sym__phantom_bar] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1105),
    [sym__cond_no_section_op] = ACTIONS(1107),
    [sym__cond_minus] = ACTIONS(1109),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [344] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10363),
    [sym_view_pattern] = STATE(10363),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9398),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__bracket_open] = STATE(374),
    [sym__bracket_close] = STATE(7098),
    [sym__unboxed_open] = STATE(204),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1191),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1193),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [345] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10363),
    [sym_view_pattern] = STATE(10363),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9398),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__bracket_open] = STATE(374),
    [sym__bracket_close] = STATE(7082),
    [sym__unboxed_open] = STATE(204),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1191),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1193),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [346] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10363),
    [sym_view_pattern] = STATE(10363),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9398),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__bracket_open] = STATE(374),
    [sym__bracket_close] = STATE(6633),
    [sym__unboxed_open] = STATE(204),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1191),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1195),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [347] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(8724),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10629),
    [sym_view_pattern] = STATE(10629),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9504),
    [sym__splice_dollars] = STATE(7334),
    [sym_splice] = STATE(3534),
    [sym_quasiquote] = STATE(3534),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(3666),
    [sym__plist] = STATE(3540),
    [sym_unit] = STATE(3534),
    [sym_unboxed_unit] = STATE(3534),
    [sym_prefix_tuple] = STATE(3534),
    [sym_prefix_unboxed_tuple] = STATE(3534),
    [sym_prefix_unboxed_sum] = STATE(3534),
    [sym_literal] = STATE(3534),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(3669),
    [sym__qconid] = STATE(3534),
    [sym__varsym_prefix] = STATE(3636),
    [sym__pvarsym] = STATE(3636),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(3555),
    [sym__pconsym] = STATE(3555),
    [sym__qconsym_prefix] = STATE(3534),
    [sym__pqconsym] = STATE(3534),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(32),
    [sym__bracket_open] = STATE(360),
    [sym__bracket_close] = STATE(3022),
    [sym__unboxed_open] = STATE(190),
    [sym_variable] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(1201),
    [sym_char] = ACTIONS(1201),
    [sym_string] = ACTIONS(1201),
    [sym__integer_literal] = ACTIONS(1203),
    [sym__binary_literal] = ACTIONS(1205),
    [sym__octal_literal] = ACTIONS(1205),
    [sym__hex_literal] = ACTIONS(1205),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(1207),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1211),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [348] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10363),
    [sym_view_pattern] = STATE(10363),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9398),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__bracket_open] = STATE(374),
    [sym__bracket_close] = STATE(7236),
    [sym__unboxed_open] = STATE(204),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1191),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1213),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [349] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10363),
    [sym_view_pattern] = STATE(10363),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9398),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__bracket_open] = STATE(374),
    [sym__bracket_close] = STATE(6771),
    [sym__unboxed_open] = STATE(204),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1191),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1215),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [350] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__colon2] = STATE(1487),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(297),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [anon_sym_COLON_COLON] = ACTIONS(1219),
    [anon_sym_u2237] = ACTIONS(1219),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(327),
    [sym__cond_no_section_op] = ACTIONS(329),
    [sym__cond_minus] = ACTIONS(331),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [351] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10363),
    [sym_view_pattern] = STATE(10363),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9398),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__bracket_open] = STATE(374),
    [sym__bracket_close] = STATE(6832),
    [sym__unboxed_open] = STATE(204),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1191),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1215),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [352] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10363),
    [sym_view_pattern] = STATE(10363),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9398),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__bracket_open] = STATE(374),
    [sym__bracket_close] = STATE(6663),
    [sym__unboxed_open] = STATE(204),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1191),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1195),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [353] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__colon2] = STATE(1548),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_using] = ACTIONS(1221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_u2237] = ACTIONS(365),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(327),
    [sym__cond_no_section_op] = ACTIONS(329),
    [sym__cond_minus] = ACTIONS(331),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [354] = {
    [sym_generator] = STATE(10236),
    [sym_let] = STATE(10233),
    [sym_guard] = STATE(10137),
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(247),
    [sym__exp_signature] = STATE(10022),
    [sym__exp] = STATE(10258),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11269),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9354),
    [sym__splice_dollars] = STATE(7293),
    [sym_splice] = STATE(3642),
    [sym_quasiquote] = STATE(3642),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(3683),
    [sym__plist] = STATE(3641),
    [sym_unit] = STATE(3642),
    [sym_unboxed_unit] = STATE(3642),
    [sym_prefix_tuple] = STATE(3642),
    [sym_prefix_unboxed_tuple] = STATE(3642),
    [sym_prefix_unboxed_sum] = STATE(3642),
    [sym_literal] = STATE(3642),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__qualified_constructor] = STATE(3562),
    [sym__qconid] = STATE(3642),
    [sym__varsym_prefix] = STATE(3659),
    [sym__pvarsym] = STATE(3659),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym__consym_prefix] = STATE(3634),
    [sym__pconsym] = STATE(3634),
    [sym__qconsym_prefix] = STATE(3642),
    [sym__pqconsym] = STATE(3642),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(29),
    [sym__bracket_open] = STATE(373),
    [sym__unboxed_open] = STATE(195),
    [sym_variable] = ACTIONS(1161),
    [anon_sym_let] = ACTIONS(1163),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(1167),
    [sym_char] = ACTIONS(1167),
    [sym_string] = ACTIONS(1167),
    [sym__integer_literal] = ACTIONS(1169),
    [sym__binary_literal] = ACTIONS(1171),
    [sym__octal_literal] = ACTIONS(1171),
    [sym__hex_literal] = ACTIONS(1171),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(1173),
    [sym_label] = ACTIONS(995),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1175),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [355] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(8738),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10629),
    [sym_view_pattern] = STATE(10629),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9504),
    [sym__splice_dollars] = STATE(7334),
    [sym_splice] = STATE(3534),
    [sym_quasiquote] = STATE(3534),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(3666),
    [sym__plist] = STATE(3540),
    [sym_unit] = STATE(3534),
    [sym_unboxed_unit] = STATE(3534),
    [sym_prefix_tuple] = STATE(3534),
    [sym_prefix_unboxed_tuple] = STATE(3534),
    [sym_prefix_unboxed_sum] = STATE(3534),
    [sym_literal] = STATE(3534),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(3669),
    [sym__qconid] = STATE(3534),
    [sym__varsym_prefix] = STATE(3636),
    [sym__pvarsym] = STATE(3636),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(3555),
    [sym__pconsym] = STATE(3555),
    [sym__qconsym_prefix] = STATE(3534),
    [sym__pqconsym] = STATE(3534),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(32),
    [sym__bracket_open] = STATE(360),
    [sym__bracket_close] = STATE(3739),
    [sym__unboxed_open] = STATE(190),
    [sym_variable] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(1201),
    [sym_char] = ACTIONS(1201),
    [sym_string] = ACTIONS(1201),
    [sym__integer_literal] = ACTIONS(1203),
    [sym__binary_literal] = ACTIONS(1205),
    [sym__octal_literal] = ACTIONS(1205),
    [sym__hex_literal] = ACTIONS(1205),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(1207),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1211),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [356] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(8734),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10075),
    [sym_view_pattern] = STATE(10075),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9504),
    [sym__splice_dollars] = STATE(7334),
    [sym_splice] = STATE(3534),
    [sym_quasiquote] = STATE(3534),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(3666),
    [sym__plist] = STATE(3540),
    [sym_unit] = STATE(3534),
    [sym_unboxed_unit] = STATE(3534),
    [sym_prefix_tuple] = STATE(3534),
    [sym_prefix_unboxed_tuple] = STATE(3534),
    [sym_prefix_unboxed_sum] = STATE(3534),
    [sym_literal] = STATE(3534),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(3669),
    [sym__qconid] = STATE(3534),
    [sym__varsym_prefix] = STATE(3636),
    [sym__pvarsym] = STATE(3636),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(3555),
    [sym__pconsym] = STATE(3555),
    [sym__qconsym_prefix] = STATE(3534),
    [sym__pqconsym] = STATE(3534),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(32),
    [sym__bracket_open] = STATE(360),
    [sym__bracket_close] = STATE(3651),
    [sym__unboxed_open] = STATE(190),
    [sym_variable] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(1201),
    [sym_char] = ACTIONS(1201),
    [sym_string] = ACTIONS(1201),
    [sym__integer_literal] = ACTIONS(1203),
    [sym__binary_literal] = ACTIONS(1205),
    [sym__octal_literal] = ACTIONS(1205),
    [sym__hex_literal] = ACTIONS(1205),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(1207),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1225),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1211),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [357] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(8734),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10263),
    [sym_view_pattern] = STATE(10263),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9504),
    [sym__splice_dollars] = STATE(7334),
    [sym_splice] = STATE(3534),
    [sym_quasiquote] = STATE(3534),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(3666),
    [sym__plist] = STATE(3540),
    [sym_unit] = STATE(3534),
    [sym_unboxed_unit] = STATE(3534),
    [sym_prefix_tuple] = STATE(3534),
    [sym_prefix_unboxed_tuple] = STATE(3534),
    [sym_prefix_unboxed_sum] = STATE(3534),
    [sym_literal] = STATE(3534),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(3669),
    [sym__qconid] = STATE(3534),
    [sym__varsym_prefix] = STATE(3636),
    [sym__pvarsym] = STATE(3636),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(3555),
    [sym__pconsym] = STATE(3555),
    [sym__qconsym_prefix] = STATE(3534),
    [sym__pqconsym] = STATE(3534),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(32),
    [sym__bracket_open] = STATE(360),
    [sym__bracket_close] = STATE(3276),
    [sym__unboxed_open] = STATE(190),
    [sym_variable] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(1201),
    [sym_char] = ACTIONS(1201),
    [sym_string] = ACTIONS(1201),
    [sym__integer_literal] = ACTIONS(1203),
    [sym__binary_literal] = ACTIONS(1205),
    [sym__octal_literal] = ACTIONS(1205),
    [sym__hex_literal] = ACTIONS(1205),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(1207),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1227),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1211),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [358] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10367),
    [sym_view_pattern] = STATE(10367),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9398),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__bracket_open] = STATE(374),
    [sym__bracket_close] = STATE(7287),
    [sym__unboxed_open] = STATE(204),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1191),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1213),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [359] = {
    [sym_generator] = STATE(11661),
    [sym_let] = STATE(11662),
    [sym_guard] = STATE(11701),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11671),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10981),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9398),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3628),
    [sym_quasiquote] = STATE(3628),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3629),
    [sym_unit] = STATE(3628),
    [sym_unboxed_unit] = STATE(3628),
    [sym_prefix_tuple] = STATE(3628),
    [sym_prefix_unboxed_tuple] = STATE(3628),
    [sym_prefix_unboxed_sum] = STATE(3628),
    [sym_literal] = STATE(3628),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3628),
    [sym__varsym_prefix] = STATE(3437),
    [sym__pvarsym] = STATE(3437),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3635),
    [sym__pconsym] = STATE(3635),
    [sym__qconsym_prefix] = STATE(3628),
    [sym__pqconsym] = STATE(3628),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__bracket_open] = STATE(374),
    [sym__unboxed_open] = STATE(204),
    [sym_variable] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(1185),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1187),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(963),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [360] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(8731),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10075),
    [sym_view_pattern] = STATE(10075),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9504),
    [sym__splice_dollars] = STATE(7334),
    [sym_splice] = STATE(3534),
    [sym_quasiquote] = STATE(3534),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(3666),
    [sym__plist] = STATE(3540),
    [sym_unit] = STATE(3534),
    [sym_unboxed_unit] = STATE(3534),
    [sym_prefix_tuple] = STATE(3534),
    [sym_prefix_unboxed_tuple] = STATE(3534),
    [sym_prefix_unboxed_sum] = STATE(3534),
    [sym_literal] = STATE(3534),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(3669),
    [sym__qconid] = STATE(3534),
    [sym__varsym_prefix] = STATE(3636),
    [sym__pvarsym] = STATE(3636),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(3555),
    [sym__pconsym] = STATE(3555),
    [sym__qconsym_prefix] = STATE(3534),
    [sym__pqconsym] = STATE(3534),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(32),
    [sym__bracket_open] = STATE(360),
    [sym__bracket_close] = STATE(3462),
    [sym__unboxed_open] = STATE(190),
    [sym_variable] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(1201),
    [sym_char] = ACTIONS(1201),
    [sym_string] = ACTIONS(1201),
    [sym__integer_literal] = ACTIONS(1203),
    [sym__binary_literal] = ACTIONS(1205),
    [sym__octal_literal] = ACTIONS(1205),
    [sym__hex_literal] = ACTIONS(1205),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(1207),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1229),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1211),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [361] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(8744),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10075),
    [sym_view_pattern] = STATE(10075),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9504),
    [sym__splice_dollars] = STATE(7334),
    [sym_splice] = STATE(3534),
    [sym_quasiquote] = STATE(3534),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(3666),
    [sym__plist] = STATE(3540),
    [sym_unit] = STATE(3534),
    [sym_unboxed_unit] = STATE(3534),
    [sym_prefix_tuple] = STATE(3534),
    [sym_prefix_unboxed_tuple] = STATE(3534),
    [sym_prefix_unboxed_sum] = STATE(3534),
    [sym_literal] = STATE(3534),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(3669),
    [sym__qconid] = STATE(3534),
    [sym__varsym_prefix] = STATE(3636),
    [sym__pvarsym] = STATE(3636),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(3555),
    [sym__pconsym] = STATE(3555),
    [sym__qconsym_prefix] = STATE(3534),
    [sym__pqconsym] = STATE(3534),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(32),
    [sym__bracket_open] = STATE(360),
    [sym__bracket_close] = STATE(3022),
    [sym__unboxed_open] = STATE(190),
    [sym_variable] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(1201),
    [sym_char] = ACTIONS(1201),
    [sym_string] = ACTIONS(1201),
    [sym__integer_literal] = ACTIONS(1203),
    [sym__binary_literal] = ACTIONS(1205),
    [sym__octal_literal] = ACTIONS(1205),
    [sym__hex_literal] = ACTIONS(1205),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(1207),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1211),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [362] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10363),
    [sym_view_pattern] = STATE(10363),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9398),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__bracket_open] = STATE(374),
    [sym__bracket_close] = STATE(5714),
    [sym__unboxed_open] = STATE(204),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1191),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1231),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [363] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10263),
    [sym_view_pattern] = STATE(10263),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9398),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__bracket_open] = STATE(374),
    [sym__bracket_close] = STATE(6188),
    [sym__unboxed_open] = STATE(204),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1191),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1195),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [364] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10842),
    [sym_view_pattern] = STATE(10842),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9398),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__bracket_open] = STATE(374),
    [sym__bracket_close] = STATE(7101),
    [sym__unboxed_open] = STATE(204),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1191),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1193),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [365] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10363),
    [sym_view_pattern] = STATE(10363),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9398),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__bracket_open] = STATE(374),
    [sym__bracket_close] = STATE(5708),
    [sym__unboxed_open] = STATE(204),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1191),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1231),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [366] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(8724),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10075),
    [sym_view_pattern] = STATE(10075),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9504),
    [sym__splice_dollars] = STATE(7334),
    [sym_splice] = STATE(3534),
    [sym_quasiquote] = STATE(3534),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(3666),
    [sym__plist] = STATE(3540),
    [sym_unit] = STATE(3534),
    [sym_unboxed_unit] = STATE(3534),
    [sym_prefix_tuple] = STATE(3534),
    [sym_prefix_unboxed_tuple] = STATE(3534),
    [sym_prefix_unboxed_sum] = STATE(3534),
    [sym_literal] = STATE(3534),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(3669),
    [sym__qconid] = STATE(3534),
    [sym__varsym_prefix] = STATE(3636),
    [sym__pvarsym] = STATE(3636),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(3555),
    [sym__pconsym] = STATE(3555),
    [sym__qconsym_prefix] = STATE(3534),
    [sym__pqconsym] = STATE(3534),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(32),
    [sym__bracket_open] = STATE(360),
    [sym__bracket_close] = STATE(3601),
    [sym__unboxed_open] = STATE(190),
    [sym_variable] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(1201),
    [sym_char] = ACTIONS(1201),
    [sym_string] = ACTIONS(1201),
    [sym__integer_literal] = ACTIONS(1203),
    [sym__binary_literal] = ACTIONS(1205),
    [sym__octal_literal] = ACTIONS(1205),
    [sym__hex_literal] = ACTIONS(1205),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(1207),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1233),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1211),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [367] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(8752),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10075),
    [sym_view_pattern] = STATE(10075),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9504),
    [sym__splice_dollars] = STATE(7334),
    [sym_splice] = STATE(3534),
    [sym_quasiquote] = STATE(3534),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(3666),
    [sym__plist] = STATE(3540),
    [sym_unit] = STATE(3534),
    [sym_unboxed_unit] = STATE(3534),
    [sym_prefix_tuple] = STATE(3534),
    [sym_prefix_unboxed_tuple] = STATE(3534),
    [sym_prefix_unboxed_sum] = STATE(3534),
    [sym_literal] = STATE(3534),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(3669),
    [sym__qconid] = STATE(3534),
    [sym__varsym_prefix] = STATE(3636),
    [sym__pvarsym] = STATE(3636),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(3555),
    [sym__pconsym] = STATE(3555),
    [sym__qconsym_prefix] = STATE(3534),
    [sym__pqconsym] = STATE(3534),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(32),
    [sym__bracket_open] = STATE(360),
    [sym__bracket_close] = STATE(3601),
    [sym__unboxed_open] = STATE(190),
    [sym_variable] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(1201),
    [sym_char] = ACTIONS(1201),
    [sym_string] = ACTIONS(1201),
    [sym__integer_literal] = ACTIONS(1203),
    [sym__binary_literal] = ACTIONS(1205),
    [sym__octal_literal] = ACTIONS(1205),
    [sym__hex_literal] = ACTIONS(1205),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(1207),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1233),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1211),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [368] = {
    [sym__at_type] = STATE(5175),
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym_explicit_type] = STATE(5177),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_op] = STATE(1454),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(295),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__variable_ticked] = STATE(1454),
    [sym__qvariable_ticked] = STATE(1454),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__constructor_ticked] = STATE(1454),
    [sym__qconstructor_ticked] = STATE(1454),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1454),
    [sym__operator_alias] = STATE(1454),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym_constructor_operator] = STATE(1454),
    [sym__constructor_operator_alias] = STATE(1454),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__tight_dot] = STATE(12126),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2570),
    [sym__paren_open] = STATE(382),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1235),
    [sym__cond_layout_end] = ACTIONS(1235),
    [sym__cond_layout_end_explicit] = ACTIONS(1235),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1055),
    [sym__cond_no_section_op] = ACTIONS(1057),
    [sym__cond_minus] = ACTIONS(1059),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [369] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10629),
    [sym_view_pattern] = STATE(10629),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9398),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__bracket_open] = STATE(374),
    [sym__bracket_close] = STATE(6464),
    [sym__unboxed_open] = STATE(204),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1191),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1215),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [370] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10363),
    [sym_view_pattern] = STATE(10363),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9398),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__bracket_open] = STATE(374),
    [sym__bracket_close] = STATE(7295),
    [sym__unboxed_open] = STATE(204),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1191),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1213),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [371] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(8738),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10075),
    [sym_view_pattern] = STATE(10075),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9504),
    [sym__splice_dollars] = STATE(7334),
    [sym_splice] = STATE(3534),
    [sym_quasiquote] = STATE(3534),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(3666),
    [sym__plist] = STATE(3540),
    [sym_unit] = STATE(3534),
    [sym_unboxed_unit] = STATE(3534),
    [sym_prefix_tuple] = STATE(3534),
    [sym_prefix_unboxed_tuple] = STATE(3534),
    [sym_prefix_unboxed_sum] = STATE(3534),
    [sym_literal] = STATE(3534),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(3669),
    [sym__qconid] = STATE(3534),
    [sym__varsym_prefix] = STATE(3636),
    [sym__pvarsym] = STATE(3636),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(3555),
    [sym__pconsym] = STATE(3555),
    [sym__qconsym_prefix] = STATE(3534),
    [sym__pqconsym] = STATE(3534),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(32),
    [sym__bracket_open] = STATE(360),
    [sym__bracket_close] = STATE(3739),
    [sym__unboxed_open] = STATE(190),
    [sym_variable] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(1201),
    [sym_char] = ACTIONS(1201),
    [sym_string] = ACTIONS(1201),
    [sym__integer_literal] = ACTIONS(1203),
    [sym__binary_literal] = ACTIONS(1205),
    [sym__octal_literal] = ACTIONS(1205),
    [sym__hex_literal] = ACTIONS(1205),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(1207),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1211),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [372] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10075),
    [sym_view_pattern] = STATE(10075),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9398),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__bracket_open] = STATE(374),
    [sym__bracket_close] = STATE(5727),
    [sym__unboxed_open] = STATE(204),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1191),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1231),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [373] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(8721),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10075),
    [sym_view_pattern] = STATE(10075),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9504),
    [sym__splice_dollars] = STATE(7334),
    [sym_splice] = STATE(3534),
    [sym_quasiquote] = STATE(3534),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(3666),
    [sym__plist] = STATE(3540),
    [sym_unit] = STATE(3534),
    [sym_unboxed_unit] = STATE(3534),
    [sym_prefix_tuple] = STATE(3534),
    [sym_prefix_unboxed_tuple] = STATE(3534),
    [sym_prefix_unboxed_sum] = STATE(3534),
    [sym_literal] = STATE(3534),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(3669),
    [sym__qconid] = STATE(3534),
    [sym__varsym_prefix] = STATE(3636),
    [sym__pvarsym] = STATE(3636),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(3555),
    [sym__pconsym] = STATE(3555),
    [sym__qconsym_prefix] = STATE(3534),
    [sym__pqconsym] = STATE(3534),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(32),
    [sym__bracket_open] = STATE(360),
    [sym__bracket_close] = STATE(3445),
    [sym__unboxed_open] = STATE(190),
    [sym_variable] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(1201),
    [sym_char] = ACTIONS(1201),
    [sym_string] = ACTIONS(1201),
    [sym__integer_literal] = ACTIONS(1203),
    [sym__binary_literal] = ACTIONS(1205),
    [sym__octal_literal] = ACTIONS(1205),
    [sym__hex_literal] = ACTIONS(1205),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(1207),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1237),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1211),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [374] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(8724),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10075),
    [sym_view_pattern] = STATE(10075),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9504),
    [sym__splice_dollars] = STATE(7334),
    [sym_splice] = STATE(3534),
    [sym_quasiquote] = STATE(3534),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(3666),
    [sym__plist] = STATE(3540),
    [sym_unit] = STATE(3534),
    [sym_unboxed_unit] = STATE(3534),
    [sym_prefix_tuple] = STATE(3534),
    [sym_prefix_unboxed_tuple] = STATE(3534),
    [sym_prefix_unboxed_sum] = STATE(3534),
    [sym_literal] = STATE(3534),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(3669),
    [sym__qconid] = STATE(3534),
    [sym__varsym_prefix] = STATE(3636),
    [sym__pvarsym] = STATE(3636),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(3555),
    [sym__pconsym] = STATE(3555),
    [sym__qconsym_prefix] = STATE(3534),
    [sym__pqconsym] = STATE(3534),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(32),
    [sym__bracket_open] = STATE(360),
    [sym__bracket_close] = STATE(3022),
    [sym__unboxed_open] = STATE(190),
    [sym_variable] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(1201),
    [sym_char] = ACTIONS(1201),
    [sym_string] = ACTIONS(1201),
    [sym__integer_literal] = ACTIONS(1203),
    [sym__binary_literal] = ACTIONS(1205),
    [sym__octal_literal] = ACTIONS(1205),
    [sym__hex_literal] = ACTIONS(1205),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(1207),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1211),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [375] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11382),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(215),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11285),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8181),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1456),
    [sym__qvariable_ticked] = STATE(1456),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1456),
    [sym__qconstructor_ticked] = STATE(1456),
    [sym__ops] = STATE(1456),
    [sym__operator_qual_dot_head] = STATE(1204),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7833),
    [sym__operator_minus] = STATE(11885),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qualified_varsym] = STATE(7797),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7812),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qualified_consym] = STATE(7795),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__qual_dot] = STATE(12299),
    [sym__prefix_dot] = STATE(12299),
    [sym__paren_open] = STATE(404),
    [sym__paren_close] = STATE(4127),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(892),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(1239),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_type] = ACTIONS(1241),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(1245),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(1247),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1249),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [376] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__paren_close] = STATE(4541),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1249),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(327),
    [sym__cond_no_section_op] = ACTIONS(329),
    [sym__cond_minus] = ACTIONS(331),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [377] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11389),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(324),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11203),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8181),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1422),
    [sym__qvariable_ticked] = STATE(1422),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1422),
    [sym__qconstructor_ticked] = STATE(1422),
    [sym__ops] = STATE(1422),
    [sym__operator_qual_dot_head] = STATE(1230),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7821),
    [sym__operator_minus] = STATE(12003),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qualified_varsym] = STATE(7829),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7841),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qualified_consym] = STATE(7845),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__qual_dot] = STATE(12468),
    [sym__prefix_dot] = STATE(12468),
    [sym__paren_open] = STATE(404),
    [sym__paren_close] = STATE(3688),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(906),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(1251),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_type] = ACTIONS(1253),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(1245),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(1247),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1255),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [378] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__paren_close] = STATE(5274),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1257),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(327),
    [sym__cond_no_section_op] = ACTIONS(329),
    [sym__cond_minus] = ACTIONS(331),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [379] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11116),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9217),
    [sym_view_pattern] = STATE(9217),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9419),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3611),
    [sym_quasiquote] = STATE(3611),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3608),
    [sym_unit] = STATE(3611),
    [sym_unboxed_unit] = STATE(3611),
    [sym_prefix_tuple] = STATE(3611),
    [sym_prefix_unboxed_tuple] = STATE(3611),
    [sym_prefix_unboxed_sum] = STATE(3611),
    [sym_literal] = STATE(3611),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3611),
    [sym__varsym_prefix] = STATE(3653),
    [sym__pvarsym] = STATE(3653),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3599),
    [sym__pconsym] = STATE(3599),
    [sym__qconsym_prefix] = STATE(3611),
    [sym__pqconsym] = STATE(3611),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(34),
    [sym__bracket_open] = STATE(366),
    [sym__unboxed_open] = STATE(191),
    [sym_variable] = ACTIONS(631),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(647),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(651),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [380] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11659),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(213),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11023),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8181),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1430),
    [sym__qvariable_ticked] = STATE(1430),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1430),
    [sym__qconstructor_ticked] = STATE(1430),
    [sym__ops] = STATE(1430),
    [sym__operator_qual_dot_head] = STATE(1318),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7837),
    [sym__operator_minus] = STATE(12017),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qualified_varsym] = STATE(7811),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7848),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qualified_consym] = STATE(7827),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__qual_dot] = STATE(12408),
    [sym__prefix_dot] = STATE(12408),
    [sym__paren_open] = STATE(404),
    [sym__paren_close] = STATE(4520),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(878),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_type] = ACTIONS(1261),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(1245),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(1247),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1257),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [381] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__paren_close] = STATE(5672),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1263),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(327),
    [sym__cond_no_section_op] = ACTIONS(329),
    [sym__cond_minus] = ACTIONS(331),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [382] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(12191),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(223),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10975),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8181),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1481),
    [sym__qvariable_ticked] = STATE(1481),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1481),
    [sym__qconstructor_ticked] = STATE(1481),
    [sym__ops] = STATE(1481),
    [sym__operator_qual_dot_head] = STATE(1220),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7832),
    [sym__operator_minus] = STATE(11565),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qualified_varsym] = STATE(7818),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7828),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qualified_consym] = STATE(7824),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__qual_dot] = STATE(12236),
    [sym__prefix_dot] = STATE(12236),
    [sym__paren_open] = STATE(404),
    [sym__paren_close] = STATE(4517),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(903),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_type] = ACTIONS(1267),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(1245),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(1247),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1269),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [383] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(12104),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(209),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11024),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8181),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1424),
    [sym__qvariable_ticked] = STATE(1424),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1424),
    [sym__qconstructor_ticked] = STATE(1424),
    [sym__ops] = STATE(1424),
    [sym__operator_qual_dot_head] = STATE(1341),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7851),
    [sym__operator_minus] = STATE(12043),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qualified_varsym] = STATE(7839),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7850),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qualified_consym] = STATE(7849),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__qual_dot] = STATE(12438),
    [sym__prefix_dot] = STATE(12438),
    [sym__paren_open] = STATE(404),
    [sym__paren_close] = STATE(4855),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(917),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(1271),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_type] = ACTIONS(1273),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(1245),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(1247),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1275),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [384] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(9217),
    [sym_view_pattern] = STATE(9217),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9398),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__bracket_open] = STATE(374),
    [sym__unboxed_open] = STATE(204),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1191),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [385] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10363),
    [sym_view_pattern] = STATE(10363),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9398),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__bracket_open] = STATE(374),
    [sym__unboxed_open] = STATE(204),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1191),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [386] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11116),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1808),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(10363),
    [sym_view_pattern] = STATE(10363),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9419),
    [sym__splice_dollars] = STATE(7250),
    [sym_splice] = STATE(3611),
    [sym_quasiquote] = STATE(3611),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(3505),
    [sym__plist] = STATE(3608),
    [sym_unit] = STATE(3611),
    [sym_unboxed_unit] = STATE(3611),
    [sym_prefix_tuple] = STATE(3611),
    [sym_prefix_unboxed_tuple] = STATE(3611),
    [sym_prefix_unboxed_sum] = STATE(3611),
    [sym_literal] = STATE(3611),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(3448),
    [sym__qconid] = STATE(3611),
    [sym__varsym_prefix] = STATE(3653),
    [sym__pvarsym] = STATE(3653),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3599),
    [sym__pconsym] = STATE(3599),
    [sym__qconsym_prefix] = STATE(3611),
    [sym__pqconsym] = STATE(3611),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(34),
    [sym__bracket_open] = STATE(366),
    [sym__unboxed_open] = STATE(191),
    [sym_variable] = ACTIONS(631),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(639),
    [sym_char] = ACTIONS(639),
    [sym_string] = ACTIONS(639),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(647),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(651),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [387] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__paren_close] = STATE(4987),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1277),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(327),
    [sym__cond_no_section_op] = ACTIONS(329),
    [sym__cond_minus] = ACTIONS(331),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [388] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__paren_close] = STATE(4055),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1255),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(327),
    [sym__cond_no_section_op] = ACTIONS(329),
    [sym__cond_minus] = ACTIONS(331),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [389] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__paren_close] = STATE(5314),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1269),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(327),
    [sym__cond_no_section_op] = ACTIONS(329),
    [sym__cond_minus] = ACTIONS(331),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [390] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__paren_close] = STATE(3045),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1279),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(327),
    [sym__cond_no_section_op] = ACTIONS(329),
    [sym__cond_minus] = ACTIONS(331),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [391] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__paren_close] = STATE(5440),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1275),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(327),
    [sym__cond_no_section_op] = ACTIONS(329),
    [sym__cond_minus] = ACTIONS(331),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [392] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11226),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11948),
    [sym_view_pattern] = STATE(11948),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9398),
    [sym__splice_dollars] = STATE(7217),
    [sym_splice] = STATE(3482),
    [sym_quasiquote] = STATE(3482),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2917),
    [sym__plist] = STATE(3460),
    [sym_unit] = STATE(3482),
    [sym_unboxed_unit] = STATE(3482),
    [sym_prefix_tuple] = STATE(3482),
    [sym_prefix_unboxed_tuple] = STATE(3482),
    [sym_prefix_unboxed_sum] = STATE(3482),
    [sym_literal] = STATE(3482),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2919),
    [sym__qconid] = STATE(3482),
    [sym__varsym_prefix] = STATE(3654),
    [sym__pvarsym] = STATE(3654),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3456),
    [sym__pconsym] = STATE(3456),
    [sym__qconsym_prefix] = STATE(3482),
    [sym__pqconsym] = STATE(3482),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(36),
    [sym__bracket_open] = STATE(374),
    [sym__unboxed_open] = STATE(204),
    [sym_variable] = ACTIONS(259),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(235),
    [sym_char] = ACTIONS(235),
    [sym_string] = ACTIONS(235),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1191),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(251),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [393] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11855),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(306),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10888),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8181),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1447),
    [sym__qvariable_ticked] = STATE(1447),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1447),
    [sym__qconstructor_ticked] = STATE(1447),
    [sym__ops] = STATE(1447),
    [sym__operator_qual_dot_head] = STATE(1282),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7834),
    [sym__operator_minus] = STATE(12030),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qualified_varsym] = STATE(7830),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7838),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qualified_consym] = STATE(7843),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__qual_dot] = STATE(12498),
    [sym__prefix_dot] = STATE(12498),
    [sym__paren_open] = STATE(404),
    [sym__paren_close] = STATE(4884),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(876),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(1281),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_type] = ACTIONS(1283),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(1245),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(1247),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1263),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [394] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11336),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(320),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11320),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8181),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1435),
    [sym__qvariable_ticked] = STATE(1435),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1435),
    [sym__qconstructor_ticked] = STATE(1435),
    [sym__ops] = STATE(1435),
    [sym__operator_qual_dot_head] = STATE(1212),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7844),
    [sym__operator_minus] = STATE(11644),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qualified_varsym] = STATE(7860),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7855),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qualified_consym] = STATE(7852),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__qual_dot] = STATE(12378),
    [sym__prefix_dot] = STATE(12378),
    [sym__paren_open] = STATE(404),
    [sym__paren_close] = STATE(4021),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(918),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(1285),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_type] = ACTIONS(1287),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(1245),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(1247),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [395] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11722),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(214),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11329),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8181),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1443),
    [sym__qvariable_ticked] = STATE(1443),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1443),
    [sym__qconstructor_ticked] = STATE(1443),
    [sym__ops] = STATE(1443),
    [sym__operator_qual_dot_head] = STATE(1270),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7825),
    [sym__operator_minus] = STATE(12077),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qualified_varsym] = STATE(7815),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7840),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qualified_consym] = STATE(7846),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__qual_dot] = STATE(12340),
    [sym__prefix_dot] = STATE(12340),
    [sym__paren_open] = STATE(404),
    [sym__paren_close] = STATE(4196),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(899),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(1245),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(1247),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1295),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [396] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11559),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(231),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11238),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8181),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1527),
    [sym__qvariable_ticked] = STATE(1527),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1527),
    [sym__qconstructor_ticked] = STATE(1527),
    [sym__ops] = STATE(1527),
    [sym__operator_qual_dot_head] = STATE(1344),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7798),
    [sym__operator_minus] = STATE(11337),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qualified_varsym] = STATE(7799),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7801),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qualified_consym] = STATE(7802),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__qual_dot] = STATE(12278),
    [sym__prefix_dot] = STATE(12278),
    [sym__paren_open] = STATE(404),
    [sym__paren_close] = STATE(2730),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(924),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(1297),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_type] = ACTIONS(1299),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(1245),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(1247),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1279),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [397] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11853),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(218),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11206),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8181),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1476),
    [sym__qvariable_ticked] = STATE(1476),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1476),
    [sym__qconstructor_ticked] = STATE(1476),
    [sym__ops] = STATE(1476),
    [sym__operator_qual_dot_head] = STATE(1284),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7826),
    [sym__operator_minus] = STATE(11735),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qualified_varsym] = STATE(7831),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7854),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qualified_consym] = STATE(7857),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__qual_dot] = STATE(12250),
    [sym__prefix_dot] = STATE(12250),
    [sym__paren_open] = STATE(404),
    [sym__paren_close] = STATE(4284),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(875),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(1301),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(1245),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(1247),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1277),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [398] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__paren_close] = STATE(4586),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(327),
    [sym__cond_no_section_op] = ACTIONS(329),
    [sym__cond_minus] = ACTIONS(331),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [399] = {
    [sym__at_type] = STATE(2946),
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym_explicit_type] = STATE(2945),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_op] = STATE(1449),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(52),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__variable_ticked] = STATE(1449),
    [sym__qvariable_ticked] = STATE(1449),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__constructor_ticked] = STATE(1449),
    [sym__qconstructor_ticked] = STATE(1449),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(1449),
    [sym__operator_alias] = STATE(1449),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(1449),
    [sym__constructor_operator_alias] = STATE(1449),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__tight_dot] = STATE(11544),
    [sym__prefix_dot] = STATE(7928),
    [sym__prefix_at] = STATE(2467),
    [sym__paren_open] = STATE(396),
    [sym__paren_close] = STATE(4421),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(161),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1295),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(323),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(327),
    [sym__cond_no_section_op] = ACTIONS(329),
    [sym__cond_minus] = ACTIONS(331),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [400] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11855),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(306),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10888),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8181),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1447),
    [sym__qvariable_ticked] = STATE(1447),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1447),
    [sym__qconstructor_ticked] = STATE(1447),
    [sym__ops] = STATE(1447),
    [sym__operator_qual_dot_head] = STATE(1282),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7834),
    [sym__operator_minus] = STATE(12030),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qualified_varsym] = STATE(7830),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7838),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qualified_consym] = STATE(7843),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__qual_dot] = STATE(12498),
    [sym__prefix_dot] = STATE(12498),
    [sym__paren_open] = STATE(404),
    [sym__paren_close] = STATE(4884),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(876),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(1281),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(1245),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(1247),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1263),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [401] = {
    [sym__type_parens] = STATE(2733),
    [sym__type_tuple] = STATE(2729),
    [sym__type_unboxed_tuple] = STATE(2751),
    [sym__type_unboxed_sum] = STATE(2746),
    [sym__type_list] = STATE(2749),
    [sym__type_promoted] = STATE(2710),
    [sym__type_star] = STATE(2710),
    [sym__type_wildcard] = STATE(2710),
    [sym__at_type] = STATE(2748),
    [sym__type_apply] = STATE(2745),
    [sym__type_infix] = STATE(2713),
    [sym_type] = STATE(409),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8471),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2710),
    [sym_quasiquote] = STATE(2710),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(2693),
    [sym_unit] = STATE(2710),
    [sym_unboxed_unit] = STATE(2710),
    [sym_prefix_tuple] = STATE(2710),
    [sym_prefix_unboxed_tuple] = STATE(2710),
    [sym_prefix_unboxed_sum] = STATE(2710),
    [sym_literal] = STATE(2710),
    [sym__qualified_type] = STATE(2697),
    [sym__qtyconid] = STATE(2694),
    [sym__tycon_arrow] = STATE(2694),
    [sym__qtycon_arrow] = STATE(2694),
    [sym__promoted_tycons_alias] = STATE(2710),
    [sym__promoted_tycons] = STATE(2710),
    [sym__tycon_ticked] = STATE(2504),
    [sym__qtycon_ticked] = STATE(2504),
    [sym__tyconids_ticked] = STATE(2504),
    [sym__promoted_tyconops_alias] = STATE(2504),
    [sym__promoted_tyconops] = STATE(2504),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2504),
    [sym__operator_alias] = STATE(2504),
    [sym__operator_minus] = STATE(2504),
    [sym__varsym_prefix] = STATE(2694),
    [sym__pvarsym] = STATE(2694),
    [sym__qualified_varsym] = STATE(2499),
    [sym__qvarsym_prefix] = STATE(2694),
    [sym__pqvarsym] = STATE(2694),
    [sym_constructor_operator] = STATE(2504),
    [sym__constructor_operator_alias] = STATE(2504),
    [sym__consym_prefix] = STATE(2694),
    [sym__pconsym] = STATE(2694),
    [sym__qualified_consym] = STATE(2478),
    [sym__qconsym_prefix] = STATE(2694),
    [sym__pqconsym] = STATE(2694),
    [sym__prefix_at] = STATE(2623),
    [sym__paren_open] = STATE(432),
    [sym__bracket_open] = STATE(1055),
    [sym__unboxed_open] = STATE(753),
    [sym_variable] = ACTIONS(1305),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_u2605] = ACTIONS(1313),
    [anon_sym_EQ] = ACTIONS(1181),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_then] = ACTIONS(1183),
    [anon_sym_using] = ACTIONS(1183),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_else] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_of] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1181),
    [anon_sym_u27e7] = ACTIONS(1181),
    [anon_sym_u27e6] = ACTIONS(1181),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(1181),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1315),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1181),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1317),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [402] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(12104),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(209),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11024),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8181),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1424),
    [sym__qvariable_ticked] = STATE(1424),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1424),
    [sym__qconstructor_ticked] = STATE(1424),
    [sym__ops] = STATE(1424),
    [sym__operator_qual_dot_head] = STATE(1341),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7851),
    [sym__operator_minus] = STATE(12043),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qualified_varsym] = STATE(7839),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7850),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qualified_consym] = STATE(7849),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__qual_dot] = STATE(12438),
    [sym__prefix_dot] = STATE(12438),
    [sym__paren_open] = STATE(404),
    [sym__paren_close] = STATE(4855),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(917),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(1271),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(1245),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(1247),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1275),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [403] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11722),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(214),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11329),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8181),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1443),
    [sym__qvariable_ticked] = STATE(1443),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1443),
    [sym__qconstructor_ticked] = STATE(1443),
    [sym__ops] = STATE(1443),
    [sym__operator_qual_dot_head] = STATE(1270),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7825),
    [sym__operator_minus] = STATE(12077),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qualified_varsym] = STATE(7815),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7840),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qualified_consym] = STATE(7846),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__qual_dot] = STATE(12340),
    [sym__prefix_dot] = STATE(12340),
    [sym__paren_open] = STATE(404),
    [sym__paren_close] = STATE(4196),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(899),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(1245),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(1247),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1295),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [404] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11853),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(218),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11206),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8181),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1476),
    [sym__qvariable_ticked] = STATE(1476),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1476),
    [sym__qconstructor_ticked] = STATE(1476),
    [sym__ops] = STATE(1476),
    [sym__operator_qual_dot_head] = STATE(1284),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7826),
    [sym__operator_minus] = STATE(11735),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qualified_varsym] = STATE(7831),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7854),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qualified_consym] = STATE(7857),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__qual_dot] = STATE(12250),
    [sym__prefix_dot] = STATE(12250),
    [sym__paren_open] = STATE(404),
    [sym__paren_close] = STATE(4284),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(875),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(1301),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(1245),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(1247),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1277),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [405] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(12191),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(223),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10975),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8181),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1481),
    [sym__qvariable_ticked] = STATE(1481),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1481),
    [sym__qconstructor_ticked] = STATE(1481),
    [sym__ops] = STATE(1481),
    [sym__operator_qual_dot_head] = STATE(1220),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7832),
    [sym__operator_minus] = STATE(11565),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qualified_varsym] = STATE(7818),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7828),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qualified_consym] = STATE(7824),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__qual_dot] = STATE(12236),
    [sym__prefix_dot] = STATE(12236),
    [sym__paren_open] = STATE(404),
    [sym__paren_close] = STATE(4517),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(903),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(1245),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(1247),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1269),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [406] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11389),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(324),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11203),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8181),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1422),
    [sym__qvariable_ticked] = STATE(1422),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1422),
    [sym__qconstructor_ticked] = STATE(1422),
    [sym__ops] = STATE(1422),
    [sym__operator_qual_dot_head] = STATE(1230),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7821),
    [sym__operator_minus] = STATE(12003),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qualified_varsym] = STATE(7829),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7841),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qualified_consym] = STATE(7845),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__qual_dot] = STATE(12468),
    [sym__prefix_dot] = STATE(12468),
    [sym__paren_open] = STATE(404),
    [sym__paren_close] = STATE(3688),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(906),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(1251),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(1245),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(1247),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1255),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [407] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11659),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(213),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11023),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8181),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1430),
    [sym__qvariable_ticked] = STATE(1430),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1430),
    [sym__qconstructor_ticked] = STATE(1430),
    [sym__ops] = STATE(1430),
    [sym__operator_qual_dot_head] = STATE(1318),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7837),
    [sym__operator_minus] = STATE(12017),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qualified_varsym] = STATE(7811),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7848),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qualified_consym] = STATE(7827),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__qual_dot] = STATE(12408),
    [sym__prefix_dot] = STATE(12408),
    [sym__paren_open] = STATE(404),
    [sym__paren_close] = STATE(4520),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(878),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(1245),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(1247),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1257),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [408] = {
    [sym__type_parens] = STATE(2733),
    [sym__type_tuple] = STATE(2729),
    [sym__type_unboxed_tuple] = STATE(2751),
    [sym__type_unboxed_sum] = STATE(2746),
    [sym__type_list] = STATE(2749),
    [sym__type_promoted] = STATE(2710),
    [sym__type_star] = STATE(2710),
    [sym__type_wildcard] = STATE(2710),
    [sym__at_type] = STATE(2748),
    [sym__type_apply] = STATE(2745),
    [sym__type_infix] = STATE(2713),
    [sym_type] = STATE(409),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8471),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2710),
    [sym_quasiquote] = STATE(2710),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(2693),
    [sym_unit] = STATE(2710),
    [sym_unboxed_unit] = STATE(2710),
    [sym_prefix_tuple] = STATE(2710),
    [sym_prefix_unboxed_tuple] = STATE(2710),
    [sym_prefix_unboxed_sum] = STATE(2710),
    [sym_literal] = STATE(2710),
    [sym__qualified_type] = STATE(2697),
    [sym__qtyconid] = STATE(2694),
    [sym__tycon_arrow] = STATE(2694),
    [sym__qtycon_arrow] = STATE(2694),
    [sym__promoted_tycons_alias] = STATE(2710),
    [sym__promoted_tycons] = STATE(2710),
    [sym__tycon_ticked] = STATE(2504),
    [sym__qtycon_ticked] = STATE(2504),
    [sym__tyconids_ticked] = STATE(2504),
    [sym__promoted_tyconops_alias] = STATE(2504),
    [sym__promoted_tyconops] = STATE(2504),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2504),
    [sym__operator_alias] = STATE(2504),
    [sym__operator_minus] = STATE(2504),
    [sym__varsym_prefix] = STATE(2694),
    [sym__pvarsym] = STATE(2694),
    [sym__qualified_varsym] = STATE(2499),
    [sym__qvarsym_prefix] = STATE(2694),
    [sym__pqvarsym] = STATE(2694),
    [sym_constructor_operator] = STATE(2504),
    [sym__constructor_operator_alias] = STATE(2504),
    [sym__consym_prefix] = STATE(2694),
    [sym__pconsym] = STATE(2694),
    [sym__qualified_consym] = STATE(2478),
    [sym__qconsym_prefix] = STATE(2694),
    [sym__pqconsym] = STATE(2694),
    [sym__prefix_at] = STATE(2623),
    [sym__paren_open] = STATE(432),
    [sym__bracket_open] = STATE(1055),
    [sym__unboxed_open] = STATE(753),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym_RBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1313),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_then] = ACTIONS(1177),
    [anon_sym_using] = ACTIONS(1177),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_else] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_of] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1179),
    [anon_sym_u27e7] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__paren_close_token1] = ACTIONS(1179),
    [anon_sym_RBRACK] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [409] = {
    [sym__type_parens] = STATE(2733),
    [sym__type_tuple] = STATE(2729),
    [sym__type_unboxed_tuple] = STATE(2751),
    [sym__type_unboxed_sum] = STATE(2746),
    [sym__type_list] = STATE(2749),
    [sym__type_promoted] = STATE(2710),
    [sym__type_star] = STATE(2710),
    [sym__type_wildcard] = STATE(2710),
    [sym__at_type] = STATE(2748),
    [sym__type_apply] = STATE(2745),
    [sym__type_infix] = STATE(2713),
    [sym_type] = STATE(409),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8471),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2710),
    [sym_quasiquote] = STATE(2710),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(2693),
    [sym_unit] = STATE(2710),
    [sym_unboxed_unit] = STATE(2710),
    [sym_prefix_tuple] = STATE(2710),
    [sym_prefix_unboxed_tuple] = STATE(2710),
    [sym_prefix_unboxed_sum] = STATE(2710),
    [sym_literal] = STATE(2710),
    [sym__qualified_type] = STATE(2697),
    [sym__qtyconid] = STATE(2694),
    [sym__tycon_arrow] = STATE(2694),
    [sym__qtycon_arrow] = STATE(2694),
    [sym__promoted_tycons_alias] = STATE(2710),
    [sym__promoted_tycons] = STATE(2710),
    [sym__tycon_ticked] = STATE(2504),
    [sym__qtycon_ticked] = STATE(2504),
    [sym__tyconids_ticked] = STATE(2504),
    [sym__promoted_tyconops_alias] = STATE(2504),
    [sym__promoted_tyconops] = STATE(2504),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2504),
    [sym__operator_alias] = STATE(2504),
    [sym__operator_minus] = STATE(2504),
    [sym__varsym_prefix] = STATE(2694),
    [sym__pvarsym] = STATE(2694),
    [sym__qualified_varsym] = STATE(2499),
    [sym__qvarsym_prefix] = STATE(2694),
    [sym__pqvarsym] = STATE(2694),
    [sym_constructor_operator] = STATE(2504),
    [sym__constructor_operator_alias] = STATE(2504),
    [sym__consym_prefix] = STATE(2694),
    [sym__pconsym] = STATE(2694),
    [sym__qualified_consym] = STATE(2478),
    [sym__qconsym_prefix] = STATE(2694),
    [sym__pqconsym] = STATE(2694),
    [sym__prefix_at] = STATE(2623),
    [sym__paren_open] = STATE(432),
    [sym__bracket_open] = STATE(1055),
    [sym__unboxed_open] = STATE(753),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_RBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_EQ] = ACTIONS(1119),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1119),
    [anon_sym_then] = ACTIONS(1117),
    [anon_sym_using] = ACTIONS(1117),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_else] = ACTIONS(1117),
    [anon_sym_mdo] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_of] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1119),
    [anon_sym_u27e7] = ACTIONS(1119),
    [anon_sym_u27e6] = ACTIONS(1119),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1117),
    [sym_implicit_variable] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [sym_label] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__paren_close_token1] = ACTIONS(1119),
    [anon_sym_RBRACK] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_tight_dot] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__cond_minus] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [410] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11382),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(215),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11285),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8181),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1456),
    [sym__qvariable_ticked] = STATE(1456),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1456),
    [sym__qconstructor_ticked] = STATE(1456),
    [sym__ops] = STATE(1456),
    [sym__operator_qual_dot_head] = STATE(1204),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7833),
    [sym__operator_minus] = STATE(11885),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qualified_varsym] = STATE(7797),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7812),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qualified_consym] = STATE(7795),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__qual_dot] = STATE(12299),
    [sym__prefix_dot] = STATE(12299),
    [sym__paren_open] = STATE(404),
    [sym__paren_close] = STATE(4127),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(892),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(1239),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(1245),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(1247),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1249),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [411] = {
    [sym__type_parens] = STATE(2733),
    [sym__type_tuple] = STATE(2729),
    [sym__type_unboxed_tuple] = STATE(2751),
    [sym__type_unboxed_sum] = STATE(2746),
    [sym__type_list] = STATE(2749),
    [sym__type_promoted] = STATE(2710),
    [sym__type_star] = STATE(2710),
    [sym__type_wildcard] = STATE(2710),
    [sym__at_type] = STATE(2748),
    [sym__type_apply] = STATE(2745),
    [sym__type_infix] = STATE(2713),
    [sym_type] = STATE(409),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8471),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2710),
    [sym_quasiquote] = STATE(2710),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(2693),
    [sym_unit] = STATE(2710),
    [sym_unboxed_unit] = STATE(2710),
    [sym_prefix_tuple] = STATE(2710),
    [sym_prefix_unboxed_tuple] = STATE(2710),
    [sym_prefix_unboxed_sum] = STATE(2710),
    [sym_literal] = STATE(2710),
    [sym__qualified_type] = STATE(2697),
    [sym__qtyconid] = STATE(2694),
    [sym__tycon_arrow] = STATE(2694),
    [sym__qtycon_arrow] = STATE(2694),
    [sym__promoted_tycons_alias] = STATE(2710),
    [sym__promoted_tycons] = STATE(2710),
    [sym__tycon_ticked] = STATE(2504),
    [sym__qtycon_ticked] = STATE(2504),
    [sym__tyconids_ticked] = STATE(2504),
    [sym__promoted_tyconops_alias] = STATE(2504),
    [sym__promoted_tyconops] = STATE(2504),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2504),
    [sym__operator_alias] = STATE(2504),
    [sym__operator_minus] = STATE(2504),
    [sym__varsym_prefix] = STATE(2694),
    [sym__pvarsym] = STATE(2694),
    [sym__qualified_varsym] = STATE(2499),
    [sym__qvarsym_prefix] = STATE(2694),
    [sym__pqvarsym] = STATE(2694),
    [sym_constructor_operator] = STATE(2504),
    [sym__constructor_operator_alias] = STATE(2504),
    [sym__consym_prefix] = STATE(2694),
    [sym__pconsym] = STATE(2694),
    [sym__qualified_consym] = STATE(2478),
    [sym__qconsym_prefix] = STATE(2694),
    [sym__pqconsym] = STATE(2694),
    [sym__prefix_at] = STATE(2623),
    [sym__paren_open] = STATE(432),
    [sym__bracket_open] = STATE(1055),
    [sym__unboxed_open] = STATE(753),
    [sym_variable] = ACTIONS(1319),
    [anon_sym_SEMI] = ACTIONS(1321),
    [anon_sym_let] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(1321),
    [anon_sym_RBRACE] = ACTIONS(1321),
    [anon_sym__] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1321),
    [anon_sym_u2605] = ACTIONS(1313),
    [anon_sym_EQ] = ACTIONS(1321),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1321),
    [anon_sym_then] = ACTIONS(1319),
    [anon_sym_using] = ACTIONS(1319),
    [anon_sym_BSLASH] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1319),
    [anon_sym_else] = ACTIONS(1319),
    [anon_sym_mdo] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1319),
    [anon_sym_case] = ACTIONS(1319),
    [anon_sym_of] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_DASH_GT] = ACTIONS(1321),
    [anon_sym_LBRACK] = ACTIONS(1321),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1321),
    [anon_sym_u27e7] = ACTIONS(1321),
    [anon_sym_u27e6] = ACTIONS(1321),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(1321),
    [sym_float] = ACTIONS(1321),
    [sym_char] = ACTIONS(1321),
    [sym_string] = ACTIONS(1321),
    [sym__integer_literal] = ACTIONS(1319),
    [sym__binary_literal] = ACTIONS(1321),
    [sym__octal_literal] = ACTIONS(1321),
    [sym__hex_literal] = ACTIONS(1321),
    [anon_sym_BQUOTE] = ACTIONS(1321),
    [anon_sym_POUND] = ACTIONS(1319),
    [anon_sym_POUND2] = ACTIONS(1319),
    [sym_implicit_variable] = ACTIONS(1321),
    [sym_name] = ACTIONS(1321),
    [sym_label] = ACTIONS(1321),
    [anon_sym_u2192] = ACTIONS(1321),
    [anon_sym_COLON_COLON] = ACTIONS(1321),
    [anon_sym_u2237] = ACTIONS(1321),
    [aux_sym__paren_open_token1] = ACTIONS(1321),
    [aux_sym__paren_close_token1] = ACTIONS(1321),
    [anon_sym_RBRACK] = ACTIONS(1321),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1321),
    [sym__cond_splice] = ACTIONS(1321),
    [sym__cond_tight_dot] = ACTIONS(1321),
    [sym__cond_prefix_dot] = ACTIONS(1321),
    [sym__cond_prefix_at] = ACTIONS(1321),
    [sym__cond_qualified_op] = ACTIONS(1321),
    [sym__cond_no_section_op] = ACTIONS(1321),
    [sym__cond_minus] = ACTIONS(1321),
    [sym__varsym] = ACTIONS(1321),
    [sym__consym] = ACTIONS(1321),
  },
  [412] = {
    [sym__type_parens] = STATE(2733),
    [sym__type_tuple] = STATE(2729),
    [sym__type_unboxed_tuple] = STATE(2751),
    [sym__type_unboxed_sum] = STATE(2746),
    [sym__type_list] = STATE(2749),
    [sym__type_promoted] = STATE(2710),
    [sym__type_star] = STATE(2710),
    [sym__type_wildcard] = STATE(2710),
    [sym__at_type] = STATE(2748),
    [sym__type_apply] = STATE(2745),
    [sym__type_infix] = STATE(2713),
    [sym_type] = STATE(409),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8471),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2710),
    [sym_quasiquote] = STATE(2710),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(2693),
    [sym_unit] = STATE(2710),
    [sym_unboxed_unit] = STATE(2710),
    [sym_prefix_tuple] = STATE(2710),
    [sym_prefix_unboxed_tuple] = STATE(2710),
    [sym_prefix_unboxed_sum] = STATE(2710),
    [sym_literal] = STATE(2710),
    [sym__qualified_type] = STATE(2697),
    [sym__qtyconid] = STATE(2694),
    [sym__tycon_arrow] = STATE(2694),
    [sym__qtycon_arrow] = STATE(2694),
    [sym__promoted_tycons_alias] = STATE(2710),
    [sym__promoted_tycons] = STATE(2710),
    [sym__tycon_ticked] = STATE(2504),
    [sym__qtycon_ticked] = STATE(2504),
    [sym__tyconids_ticked] = STATE(2504),
    [sym__promoted_tyconops_alias] = STATE(2504),
    [sym__promoted_tyconops] = STATE(2504),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2504),
    [sym__operator_alias] = STATE(2504),
    [sym__operator_minus] = STATE(2504),
    [sym__varsym_prefix] = STATE(2694),
    [sym__pvarsym] = STATE(2694),
    [sym__qualified_varsym] = STATE(2499),
    [sym__qvarsym_prefix] = STATE(2694),
    [sym__pqvarsym] = STATE(2694),
    [sym_constructor_operator] = STATE(2504),
    [sym__constructor_operator_alias] = STATE(2504),
    [sym__consym_prefix] = STATE(2694),
    [sym__pconsym] = STATE(2694),
    [sym__qualified_consym] = STATE(2478),
    [sym__qconsym_prefix] = STATE(2694),
    [sym__pqconsym] = STATE(2694),
    [sym__prefix_at] = STATE(2623),
    [sym__paren_open] = STATE(432),
    [sym__bracket_open] = STATE(1055),
    [sym__unboxed_open] = STATE(753),
    [sym_variable] = ACTIONS(1305),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym_let] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym_RBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_u2605] = ACTIONS(1313),
    [anon_sym_EQ] = ACTIONS(1157),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1157),
    [anon_sym_then] = ACTIONS(1159),
    [anon_sym_using] = ACTIONS(1159),
    [anon_sym_BSLASH] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_else] = ACTIONS(1159),
    [anon_sym_mdo] = ACTIONS(1159),
    [anon_sym_do] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1159),
    [anon_sym_of] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1157),
    [anon_sym_u27e7] = ACTIONS(1157),
    [anon_sym_u27e6] = ACTIONS(1157),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(1157),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1157),
    [sym_name] = ACTIONS(1315),
    [sym_label] = ACTIONS(1157),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1157),
    [anon_sym_RBRACK] = ACTIONS(1157),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1317),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1157),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__cond_minus] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [413] = {
    [sym__type_parens] = STATE(2733),
    [sym__type_tuple] = STATE(2729),
    [sym__type_unboxed_tuple] = STATE(2751),
    [sym__type_unboxed_sum] = STATE(2746),
    [sym__type_list] = STATE(2749),
    [sym__type_promoted] = STATE(2710),
    [sym__type_star] = STATE(2710),
    [sym__type_wildcard] = STATE(2710),
    [sym__at_type] = STATE(2748),
    [sym__type_apply] = STATE(2745),
    [sym__type_infix] = STATE(2713),
    [sym_type] = STATE(409),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8471),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2710),
    [sym_quasiquote] = STATE(2710),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(2693),
    [sym_unit] = STATE(2710),
    [sym_unboxed_unit] = STATE(2710),
    [sym_prefix_tuple] = STATE(2710),
    [sym_prefix_unboxed_tuple] = STATE(2710),
    [sym_prefix_unboxed_sum] = STATE(2710),
    [sym_literal] = STATE(2710),
    [sym__qualified_type] = STATE(2697),
    [sym__qtyconid] = STATE(2694),
    [sym__tycon_arrow] = STATE(2694),
    [sym__qtycon_arrow] = STATE(2694),
    [sym__promoted_tycons_alias] = STATE(2710),
    [sym__promoted_tycons] = STATE(2710),
    [sym__tycon_ticked] = STATE(2504),
    [sym__qtycon_ticked] = STATE(2504),
    [sym__tyconids_ticked] = STATE(2504),
    [sym__promoted_tyconops_alias] = STATE(2504),
    [sym__promoted_tyconops] = STATE(2504),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2504),
    [sym__operator_alias] = STATE(2504),
    [sym__operator_minus] = STATE(2504),
    [sym__varsym_prefix] = STATE(2694),
    [sym__pvarsym] = STATE(2694),
    [sym__qualified_varsym] = STATE(2499),
    [sym__qvarsym_prefix] = STATE(2694),
    [sym__pqvarsym] = STATE(2694),
    [sym_constructor_operator] = STATE(2504),
    [sym__constructor_operator_alias] = STATE(2504),
    [sym__consym_prefix] = STATE(2694),
    [sym__pconsym] = STATE(2694),
    [sym__qualified_consym] = STATE(2478),
    [sym__qconsym_prefix] = STATE(2694),
    [sym__pqconsym] = STATE(2694),
    [sym__prefix_at] = STATE(2623),
    [sym__paren_open] = STATE(432),
    [sym__bracket_open] = STATE(1055),
    [sym__unboxed_open] = STATE(753),
    [sym_variable] = ACTIONS(1305),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_u2605] = ACTIONS(1313),
    [anon_sym_EQ] = ACTIONS(1181),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_then] = ACTIONS(1183),
    [anon_sym_using] = ACTIONS(1183),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_else] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_of] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1181),
    [anon_sym_u27e7] = ACTIONS(1181),
    [anon_sym_u27e6] = ACTIONS(1181),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(1181),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1315),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1181),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1317),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [414] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11559),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(231),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11238),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8181),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1527),
    [sym__qvariable_ticked] = STATE(1527),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1527),
    [sym__qconstructor_ticked] = STATE(1527),
    [sym__ops] = STATE(1527),
    [sym__operator_qual_dot_head] = STATE(1344),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7798),
    [sym__operator_minus] = STATE(11337),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qualified_varsym] = STATE(7799),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7801),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qualified_consym] = STATE(7802),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__qual_dot] = STATE(12278),
    [sym__prefix_dot] = STATE(12278),
    [sym__paren_open] = STATE(404),
    [sym__paren_close] = STATE(2730),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(924),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(1297),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(1245),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(1247),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1279),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [415] = {
    [sym__type_parens] = STATE(2733),
    [sym__type_tuple] = STATE(2729),
    [sym__type_unboxed_tuple] = STATE(2751),
    [sym__type_unboxed_sum] = STATE(2746),
    [sym__type_list] = STATE(2749),
    [sym__type_promoted] = STATE(2710),
    [sym__type_star] = STATE(2710),
    [sym__type_wildcard] = STATE(2710),
    [sym__at_type] = STATE(2748),
    [sym__type_apply] = STATE(2745),
    [sym__type_infix] = STATE(2713),
    [sym_type] = STATE(409),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8471),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2710),
    [sym_quasiquote] = STATE(2710),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(2693),
    [sym_unit] = STATE(2710),
    [sym_unboxed_unit] = STATE(2710),
    [sym_prefix_tuple] = STATE(2710),
    [sym_prefix_unboxed_tuple] = STATE(2710),
    [sym_prefix_unboxed_sum] = STATE(2710),
    [sym_literal] = STATE(2710),
    [sym__qualified_type] = STATE(2697),
    [sym__qtyconid] = STATE(2694),
    [sym__tycon_arrow] = STATE(2694),
    [sym__qtycon_arrow] = STATE(2694),
    [sym__promoted_tycons_alias] = STATE(2710),
    [sym__promoted_tycons] = STATE(2710),
    [sym__tycon_ticked] = STATE(2504),
    [sym__qtycon_ticked] = STATE(2504),
    [sym__tyconids_ticked] = STATE(2504),
    [sym__promoted_tyconops_alias] = STATE(2504),
    [sym__promoted_tyconops] = STATE(2504),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2504),
    [sym__operator_alias] = STATE(2504),
    [sym__operator_minus] = STATE(2504),
    [sym__varsym_prefix] = STATE(2694),
    [sym__pvarsym] = STATE(2694),
    [sym__qualified_varsym] = STATE(2499),
    [sym__qvarsym_prefix] = STATE(2694),
    [sym__pqvarsym] = STATE(2694),
    [sym_constructor_operator] = STATE(2504),
    [sym__constructor_operator_alias] = STATE(2504),
    [sym__consym_prefix] = STATE(2694),
    [sym__pconsym] = STATE(2694),
    [sym__qualified_consym] = STATE(2478),
    [sym__qconsym_prefix] = STATE(2694),
    [sym__pqconsym] = STATE(2694),
    [sym__prefix_at] = STATE(2623),
    [sym__paren_open] = STATE(432),
    [sym__bracket_open] = STATE(1055),
    [sym__unboxed_open] = STATE(753),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym_RBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_then] = ACTIONS(1177),
    [anon_sym_using] = ACTIONS(1177),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_else] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_of] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1179),
    [anon_sym_u27e7] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__paren_close_token1] = ACTIONS(1179),
    [anon_sym_RBRACK] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [416] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple_elems] = STATE(11336),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(320),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11320),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8181),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__variable_ticked] = STATE(1435),
    [sym__qvariable_ticked] = STATE(1435),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__constructor_ticked] = STATE(1435),
    [sym__qconstructor_ticked] = STATE(1435),
    [sym__ops] = STATE(1435),
    [sym__operator_qual_dot_head] = STATE(1212),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(7844),
    [sym__operator_minus] = STATE(11644),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qualified_varsym] = STATE(7860),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym_constructor_operator] = STATE(7855),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qualified_consym] = STATE(7852),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__qual_dot] = STATE(12378),
    [sym__prefix_dot] = STATE(12378),
    [sym__paren_open] = STATE(404),
    [sym__paren_close] = STATE(4021),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(918),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(1285),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(161),
    [anon_sym_POUND2] = ACTIONS(1245),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(1247),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(173),
    [sym__cond_prefix_dot] = ACTIONS(175),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [417] = {
    [sym__type_parens] = STATE(2825),
    [sym__type_tuple] = STATE(2808),
    [sym__type_unboxed_tuple] = STATE(2788),
    [sym__type_unboxed_sum] = STATE(2767),
    [sym__type_list] = STATE(2839),
    [sym__type_promoted] = STATE(2796),
    [sym__type_star] = STATE(2796),
    [sym__type_wildcard] = STATE(2796),
    [sym__at_type] = STATE(2820),
    [sym__type_apply] = STATE(2823),
    [sym__type_infix] = STATE(2774),
    [sym_type] = STATE(420),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8525),
    [sym__splice_dollars] = STATE(7328),
    [sym_splice] = STATE(2796),
    [sym_quasiquote] = STATE(2796),
    [sym_integer] = STATE(2781),
    [sym__plist] = STATE(2777),
    [sym_unit] = STATE(2796),
    [sym_unboxed_unit] = STATE(2796),
    [sym_prefix_tuple] = STATE(2796),
    [sym_prefix_unboxed_tuple] = STATE(2796),
    [sym_prefix_unboxed_sum] = STATE(2796),
    [sym_literal] = STATE(2796),
    [sym__qualified_type] = STATE(2759),
    [sym__qtyconid] = STATE(2752),
    [sym__tycon_arrow] = STATE(2752),
    [sym__qtycon_arrow] = STATE(2752),
    [sym__promoted_tycons_alias] = STATE(2796),
    [sym__promoted_tycons] = STATE(2796),
    [sym__tycon_ticked] = STATE(2403),
    [sym__qtycon_ticked] = STATE(2403),
    [sym__tyconids_ticked] = STATE(2403),
    [sym__promoted_tyconops_alias] = STATE(2403),
    [sym__promoted_tyconops] = STATE(2403),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2403),
    [sym__operator_alias] = STATE(2403),
    [sym__operator_minus] = STATE(2403),
    [sym__varsym_prefix] = STATE(2752),
    [sym__pvarsym] = STATE(2752),
    [sym__qualified_varsym] = STATE(2402),
    [sym__qvarsym_prefix] = STATE(2752),
    [sym__pqvarsym] = STATE(2752),
    [sym_constructor_operator] = STATE(2403),
    [sym__constructor_operator_alias] = STATE(2403),
    [sym__consym_prefix] = STATE(2752),
    [sym__pconsym] = STATE(2752),
    [sym__qualified_consym] = STATE(2401),
    [sym__qconsym_prefix] = STATE(2752),
    [sym__pqconsym] = STATE(2752),
    [sym__prefix_at] = STATE(2690),
    [sym__paren_open] = STATE(467),
    [sym__bracket_open] = STATE(1130),
    [sym__unboxed_open] = STATE(765),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1179),
    [anon_sym_u22b8] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(1177),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym__phantom_where] = ACTIONS(1179),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym__phantom_bar] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_prefix_percent] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [418] = {
    [sym__type_parens] = STATE(2825),
    [sym__type_tuple] = STATE(2808),
    [sym__type_unboxed_tuple] = STATE(2788),
    [sym__type_unboxed_sum] = STATE(2767),
    [sym__type_list] = STATE(2839),
    [sym__type_promoted] = STATE(2796),
    [sym__type_star] = STATE(2796),
    [sym__type_wildcard] = STATE(2796),
    [sym__at_type] = STATE(2820),
    [sym__type_apply] = STATE(2823),
    [sym__type_infix] = STATE(2774),
    [sym_type] = STATE(420),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8525),
    [sym__splice_dollars] = STATE(7328),
    [sym_splice] = STATE(2796),
    [sym_quasiquote] = STATE(2796),
    [sym_integer] = STATE(2781),
    [sym__plist] = STATE(2777),
    [sym_unit] = STATE(2796),
    [sym_unboxed_unit] = STATE(2796),
    [sym_prefix_tuple] = STATE(2796),
    [sym_prefix_unboxed_tuple] = STATE(2796),
    [sym_prefix_unboxed_sum] = STATE(2796),
    [sym_literal] = STATE(2796),
    [sym__qualified_type] = STATE(2759),
    [sym__qtyconid] = STATE(2752),
    [sym__tycon_arrow] = STATE(2752),
    [sym__qtycon_arrow] = STATE(2752),
    [sym__promoted_tycons_alias] = STATE(2796),
    [sym__promoted_tycons] = STATE(2796),
    [sym__tycon_ticked] = STATE(2403),
    [sym__qtycon_ticked] = STATE(2403),
    [sym__tyconids_ticked] = STATE(2403),
    [sym__promoted_tyconops_alias] = STATE(2403),
    [sym__promoted_tyconops] = STATE(2403),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2403),
    [sym__operator_alias] = STATE(2403),
    [sym__operator_minus] = STATE(2403),
    [sym__varsym_prefix] = STATE(2752),
    [sym__pvarsym] = STATE(2752),
    [sym__qualified_varsym] = STATE(2402),
    [sym__qvarsym_prefix] = STATE(2752),
    [sym__pqvarsym] = STATE(2752),
    [sym_constructor_operator] = STATE(2403),
    [sym__constructor_operator_alias] = STATE(2403),
    [sym__consym_prefix] = STATE(2752),
    [sym__pconsym] = STATE(2752),
    [sym__qualified_consym] = STATE(2401),
    [sym__qconsym_prefix] = STATE(2752),
    [sym__pqconsym] = STATE(2752),
    [sym__prefix_at] = STATE(2690),
    [sym__paren_open] = STATE(467),
    [sym__bracket_open] = STATE(1130),
    [sym__unboxed_open] = STATE(765),
    [sym_variable] = ACTIONS(1323),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1325),
    [anon_sym_SQUOTE] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1329),
    [anon_sym_u2605] = ACTIONS(1331),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(1333),
    [sym_char] = ACTIONS(1333),
    [sym_string] = ACTIONS(1333),
    [sym__integer_literal] = ACTIONS(1335),
    [sym__binary_literal] = ACTIONS(1337),
    [sym__octal_literal] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1337),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1339),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_where] = ACTIONS(1181),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1341),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [419] = {
    [sym__type_parens] = STATE(2825),
    [sym__type_tuple] = STATE(2808),
    [sym__type_unboxed_tuple] = STATE(2788),
    [sym__type_unboxed_sum] = STATE(2767),
    [sym__type_list] = STATE(2839),
    [sym__type_promoted] = STATE(2796),
    [sym__type_star] = STATE(2796),
    [sym__type_wildcard] = STATE(2796),
    [sym__at_type] = STATE(2820),
    [sym__type_apply] = STATE(2823),
    [sym__type_infix] = STATE(2774),
    [sym_type] = STATE(420),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8525),
    [sym__splice_dollars] = STATE(7328),
    [sym_splice] = STATE(2796),
    [sym_quasiquote] = STATE(2796),
    [sym_integer] = STATE(2781),
    [sym__plist] = STATE(2777),
    [sym_unit] = STATE(2796),
    [sym_unboxed_unit] = STATE(2796),
    [sym_prefix_tuple] = STATE(2796),
    [sym_prefix_unboxed_tuple] = STATE(2796),
    [sym_prefix_unboxed_sum] = STATE(2796),
    [sym_literal] = STATE(2796),
    [sym__qualified_type] = STATE(2759),
    [sym__qtyconid] = STATE(2752),
    [sym__tycon_arrow] = STATE(2752),
    [sym__qtycon_arrow] = STATE(2752),
    [sym__promoted_tycons_alias] = STATE(2796),
    [sym__promoted_tycons] = STATE(2796),
    [sym__tycon_ticked] = STATE(2403),
    [sym__qtycon_ticked] = STATE(2403),
    [sym__tyconids_ticked] = STATE(2403),
    [sym__promoted_tyconops_alias] = STATE(2403),
    [sym__promoted_tyconops] = STATE(2403),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2403),
    [sym__operator_alias] = STATE(2403),
    [sym__operator_minus] = STATE(2403),
    [sym__varsym_prefix] = STATE(2752),
    [sym__pvarsym] = STATE(2752),
    [sym__qualified_varsym] = STATE(2402),
    [sym__qvarsym_prefix] = STATE(2752),
    [sym__pqvarsym] = STATE(2752),
    [sym_constructor_operator] = STATE(2403),
    [sym__constructor_operator_alias] = STATE(2403),
    [sym__consym_prefix] = STATE(2752),
    [sym__pconsym] = STATE(2752),
    [sym__qualified_consym] = STATE(2401),
    [sym__qconsym_prefix] = STATE(2752),
    [sym__pqconsym] = STATE(2752),
    [sym__prefix_at] = STATE(2690),
    [sym__paren_open] = STATE(467),
    [sym__bracket_open] = STATE(1130),
    [sym__unboxed_open] = STATE(765),
    [sym_variable] = ACTIONS(1323),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1325),
    [anon_sym_SQUOTE] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1329),
    [anon_sym_u2605] = ACTIONS(1331),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(1333),
    [sym_char] = ACTIONS(1333),
    [sym_string] = ACTIONS(1333),
    [sym__integer_literal] = ACTIONS(1335),
    [sym__binary_literal] = ACTIONS(1337),
    [sym__octal_literal] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1337),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1339),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_where] = ACTIONS(1181),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1341),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [420] = {
    [sym__type_parens] = STATE(2825),
    [sym__type_tuple] = STATE(2808),
    [sym__type_unboxed_tuple] = STATE(2788),
    [sym__type_unboxed_sum] = STATE(2767),
    [sym__type_list] = STATE(2839),
    [sym__type_promoted] = STATE(2796),
    [sym__type_star] = STATE(2796),
    [sym__type_wildcard] = STATE(2796),
    [sym__at_type] = STATE(2820),
    [sym__type_apply] = STATE(2823),
    [sym__type_infix] = STATE(2774),
    [sym_type] = STATE(420),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8525),
    [sym__splice_dollars] = STATE(7328),
    [sym_splice] = STATE(2796),
    [sym_quasiquote] = STATE(2796),
    [sym_integer] = STATE(2781),
    [sym__plist] = STATE(2777),
    [sym_unit] = STATE(2796),
    [sym_unboxed_unit] = STATE(2796),
    [sym_prefix_tuple] = STATE(2796),
    [sym_prefix_unboxed_tuple] = STATE(2796),
    [sym_prefix_unboxed_sum] = STATE(2796),
    [sym_literal] = STATE(2796),
    [sym__qualified_type] = STATE(2759),
    [sym__qtyconid] = STATE(2752),
    [sym__tycon_arrow] = STATE(2752),
    [sym__qtycon_arrow] = STATE(2752),
    [sym__promoted_tycons_alias] = STATE(2796),
    [sym__promoted_tycons] = STATE(2796),
    [sym__tycon_ticked] = STATE(2403),
    [sym__qtycon_ticked] = STATE(2403),
    [sym__tyconids_ticked] = STATE(2403),
    [sym__promoted_tyconops_alias] = STATE(2403),
    [sym__promoted_tyconops] = STATE(2403),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2403),
    [sym__operator_alias] = STATE(2403),
    [sym__operator_minus] = STATE(2403),
    [sym__varsym_prefix] = STATE(2752),
    [sym__pvarsym] = STATE(2752),
    [sym__qualified_varsym] = STATE(2402),
    [sym__qvarsym_prefix] = STATE(2752),
    [sym__pqvarsym] = STATE(2752),
    [sym_constructor_operator] = STATE(2403),
    [sym__constructor_operator_alias] = STATE(2403),
    [sym__consym_prefix] = STATE(2752),
    [sym__pconsym] = STATE(2752),
    [sym__qualified_consym] = STATE(2401),
    [sym__qconsym_prefix] = STATE(2752),
    [sym__pqconsym] = STATE(2752),
    [sym__prefix_at] = STATE(2690),
    [sym__paren_open] = STATE(467),
    [sym__bracket_open] = STATE(1130),
    [sym__unboxed_open] = STATE(765),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_mdo] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_u27e6] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1117),
    [sym_implicit_variable] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [sym_label] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1119),
    [anon_sym_u22b8] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [anon_sym_where] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1119),
    [sym__cond_layout_end] = ACTIONS(1119),
    [sym__cond_layout_end_explicit] = ACTIONS(1119),
    [sym__phantom_where] = ACTIONS(1119),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym__phantom_bar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_tight_dot] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_prefix_percent] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__cond_minus] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [421] = {
    [sym__type_parens] = STATE(2825),
    [sym__type_tuple] = STATE(2808),
    [sym__type_unboxed_tuple] = STATE(2788),
    [sym__type_unboxed_sum] = STATE(2767),
    [sym__type_list] = STATE(2839),
    [sym__type_promoted] = STATE(2796),
    [sym__type_star] = STATE(2796),
    [sym__type_wildcard] = STATE(2796),
    [sym__at_type] = STATE(2820),
    [sym__type_apply] = STATE(2823),
    [sym__type_infix] = STATE(2774),
    [sym_type] = STATE(420),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8525),
    [sym__splice_dollars] = STATE(7328),
    [sym_splice] = STATE(2796),
    [sym_quasiquote] = STATE(2796),
    [sym_integer] = STATE(2781),
    [sym__plist] = STATE(2777),
    [sym_unit] = STATE(2796),
    [sym_unboxed_unit] = STATE(2796),
    [sym_prefix_tuple] = STATE(2796),
    [sym_prefix_unboxed_tuple] = STATE(2796),
    [sym_prefix_unboxed_sum] = STATE(2796),
    [sym_literal] = STATE(2796),
    [sym__qualified_type] = STATE(2759),
    [sym__qtyconid] = STATE(2752),
    [sym__tycon_arrow] = STATE(2752),
    [sym__qtycon_arrow] = STATE(2752),
    [sym__promoted_tycons_alias] = STATE(2796),
    [sym__promoted_tycons] = STATE(2796),
    [sym__tycon_ticked] = STATE(2403),
    [sym__qtycon_ticked] = STATE(2403),
    [sym__tyconids_ticked] = STATE(2403),
    [sym__promoted_tyconops_alias] = STATE(2403),
    [sym__promoted_tyconops] = STATE(2403),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2403),
    [sym__operator_alias] = STATE(2403),
    [sym__operator_minus] = STATE(2403),
    [sym__varsym_prefix] = STATE(2752),
    [sym__pvarsym] = STATE(2752),
    [sym__qualified_varsym] = STATE(2402),
    [sym__qvarsym_prefix] = STATE(2752),
    [sym__pqvarsym] = STATE(2752),
    [sym_constructor_operator] = STATE(2403),
    [sym__constructor_operator_alias] = STATE(2403),
    [sym__consym_prefix] = STATE(2752),
    [sym__pconsym] = STATE(2752),
    [sym__qualified_consym] = STATE(2401),
    [sym__qconsym_prefix] = STATE(2752),
    [sym__pqconsym] = STATE(2752),
    [sym__prefix_at] = STATE(2690),
    [sym__paren_open] = STATE(467),
    [sym__bracket_open] = STATE(1130),
    [sym__unboxed_open] = STATE(765),
    [sym_variable] = ACTIONS(1323),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_let] = ACTIONS(1125),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym__] = ACTIONS(1325),
    [anon_sym_SQUOTE] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1329),
    [anon_sym_u2605] = ACTIONS(1331),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_BSLASH] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1125),
    [anon_sym_mdo] = ACTIONS(1125),
    [anon_sym_do] = ACTIONS(1125),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1123),
    [sym_float] = ACTIONS(1333),
    [sym_char] = ACTIONS(1333),
    [sym_string] = ACTIONS(1333),
    [sym__integer_literal] = ACTIONS(1335),
    [sym__binary_literal] = ACTIONS(1337),
    [sym__octal_literal] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1337),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1123),
    [sym_name] = ACTIONS(1339),
    [sym_label] = ACTIONS(1123),
    [anon_sym_u2192] = ACTIONS(1123),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1123),
    [anon_sym_u22b8] = ACTIONS(1123),
    [anon_sym_COLON_COLON] = ACTIONS(1123),
    [anon_sym_u2237] = ACTIONS(1123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1125),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1123),
    [sym__cond_layout_end] = ACTIONS(1123),
    [sym__cond_layout_end_explicit] = ACTIONS(1123),
    [sym__phantom_where] = ACTIONS(1123),
    [sym__phantom_arrow] = ACTIONS(1123),
    [sym__phantom_bar] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1341),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1123),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1123),
    [sym__cond_qualified_op] = ACTIONS(1123),
    [sym__cond_no_section_op] = ACTIONS(1123),
    [sym__cond_minus] = ACTIONS(1123),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [422] = {
    [sym__type_parens] = STATE(2825),
    [sym__type_tuple] = STATE(2808),
    [sym__type_unboxed_tuple] = STATE(2788),
    [sym__type_unboxed_sum] = STATE(2767),
    [sym__type_list] = STATE(2839),
    [sym__type_promoted] = STATE(2796),
    [sym__type_star] = STATE(2796),
    [sym__type_wildcard] = STATE(2796),
    [sym__at_type] = STATE(2820),
    [sym__type_apply] = STATE(2823),
    [sym__type_infix] = STATE(2774),
    [sym_type] = STATE(420),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8525),
    [sym__splice_dollars] = STATE(7328),
    [sym_splice] = STATE(2796),
    [sym_quasiquote] = STATE(2796),
    [sym_integer] = STATE(2781),
    [sym__plist] = STATE(2777),
    [sym_unit] = STATE(2796),
    [sym_unboxed_unit] = STATE(2796),
    [sym_prefix_tuple] = STATE(2796),
    [sym_prefix_unboxed_tuple] = STATE(2796),
    [sym_prefix_unboxed_sum] = STATE(2796),
    [sym_literal] = STATE(2796),
    [sym__qualified_type] = STATE(2759),
    [sym__qtyconid] = STATE(2752),
    [sym__tycon_arrow] = STATE(2752),
    [sym__qtycon_arrow] = STATE(2752),
    [sym__promoted_tycons_alias] = STATE(2796),
    [sym__promoted_tycons] = STATE(2796),
    [sym__tycon_ticked] = STATE(2403),
    [sym__qtycon_ticked] = STATE(2403),
    [sym__tyconids_ticked] = STATE(2403),
    [sym__promoted_tyconops_alias] = STATE(2403),
    [sym__promoted_tyconops] = STATE(2403),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2403),
    [sym__operator_alias] = STATE(2403),
    [sym__operator_minus] = STATE(2403),
    [sym__varsym_prefix] = STATE(2752),
    [sym__pvarsym] = STATE(2752),
    [sym__qualified_varsym] = STATE(2402),
    [sym__qvarsym_prefix] = STATE(2752),
    [sym__pqvarsym] = STATE(2752),
    [sym_constructor_operator] = STATE(2403),
    [sym__constructor_operator_alias] = STATE(2403),
    [sym__consym_prefix] = STATE(2752),
    [sym__pconsym] = STATE(2752),
    [sym__qualified_consym] = STATE(2401),
    [sym__qconsym_prefix] = STATE(2752),
    [sym__pqconsym] = STATE(2752),
    [sym__prefix_at] = STATE(2690),
    [sym__paren_open] = STATE(467),
    [sym__bracket_open] = STATE(1130),
    [sym__unboxed_open] = STATE(765),
    [sym_variable] = ACTIONS(1323),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym_let] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1325),
    [anon_sym_SQUOTE] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1329),
    [anon_sym_u2605] = ACTIONS(1331),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1157),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_BSLASH] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_mdo] = ACTIONS(1159),
    [anon_sym_do] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1157),
    [sym_float] = ACTIONS(1333),
    [sym_char] = ACTIONS(1333),
    [sym_string] = ACTIONS(1333),
    [sym__integer_literal] = ACTIONS(1335),
    [sym__binary_literal] = ACTIONS(1337),
    [sym__octal_literal] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1337),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1157),
    [sym_name] = ACTIONS(1339),
    [sym_label] = ACTIONS(1157),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1157),
    [anon_sym_u22b8] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1159),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1157),
    [sym__cond_layout_end] = ACTIONS(1157),
    [sym__cond_layout_end_explicit] = ACTIONS(1157),
    [sym__phantom_where] = ACTIONS(1157),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym__phantom_bar] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1341),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1157),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1157),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__cond_minus] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [423] = {
    [sym__type_parens] = STATE(3111),
    [sym__type_tuple] = STATE(3091),
    [sym__type_unboxed_tuple] = STATE(3092),
    [sym__type_unboxed_sum] = STATE(3095),
    [sym__type_list] = STATE(3100),
    [sym__type_promoted] = STATE(3123),
    [sym__type_star] = STATE(3123),
    [sym__type_wildcard] = STATE(3123),
    [sym__at_type] = STATE(3139),
    [sym__type_apply] = STATE(3099),
    [sym__type_infix] = STATE(3084),
    [sym_type] = STATE(424),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8468),
    [sym__splice_dollars] = STATE(7411),
    [sym_splice] = STATE(3123),
    [sym_quasiquote] = STATE(3123),
    [sym_integer] = STATE(3118),
    [sym__plist] = STATE(3082),
    [sym_unit] = STATE(3123),
    [sym_unboxed_unit] = STATE(3123),
    [sym_prefix_tuple] = STATE(3123),
    [sym_prefix_unboxed_tuple] = STATE(3123),
    [sym_prefix_unboxed_sum] = STATE(3123),
    [sym_literal] = STATE(3123),
    [sym__qualified_type] = STATE(3083),
    [sym__qtyconid] = STATE(3071),
    [sym__tycon_arrow] = STATE(3071),
    [sym__qtycon_arrow] = STATE(3071),
    [sym__promoted_tycons_alias] = STATE(3123),
    [sym__promoted_tycons] = STATE(3123),
    [sym__tycon_ticked] = STATE(2426),
    [sym__qtycon_ticked] = STATE(2426),
    [sym__tyconids_ticked] = STATE(2426),
    [sym__promoted_tyconops_alias] = STATE(2426),
    [sym__promoted_tyconops] = STATE(2426),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2426),
    [sym__operator_alias] = STATE(2426),
    [sym__operator_minus] = STATE(2426),
    [sym__varsym_prefix] = STATE(3071),
    [sym__pvarsym] = STATE(3071),
    [sym__qualified_varsym] = STATE(2425),
    [sym__qvarsym_prefix] = STATE(3071),
    [sym__pqvarsym] = STATE(3071),
    [sym_constructor_operator] = STATE(2426),
    [sym__constructor_operator_alias] = STATE(2426),
    [sym__consym_prefix] = STATE(3071),
    [sym__pconsym] = STATE(3071),
    [sym__qualified_consym] = STATE(2424),
    [sym__qconsym_prefix] = STATE(3071),
    [sym__pqconsym] = STATE(3071),
    [sym__prefix_at] = STATE(2677),
    [sym__paren_open] = STATE(441),
    [sym__bracket_open] = STATE(1101),
    [sym__unboxed_open] = STATE(764),
    [sym_variable] = ACTIONS(1343),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym_let] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1345),
    [anon_sym_SQUOTE] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_u2605] = ACTIONS(1351),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1157),
    [anon_sym_BSLASH] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_mdo] = ACTIONS(1159),
    [anon_sym_do] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1157),
    [sym_float] = ACTIONS(1353),
    [sym_char] = ACTIONS(1353),
    [sym_string] = ACTIONS(1353),
    [sym__integer_literal] = ACTIONS(1355),
    [sym__binary_literal] = ACTIONS(1357),
    [sym__octal_literal] = ACTIONS(1357),
    [sym__hex_literal] = ACTIONS(1357),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1157),
    [sym_name] = ACTIONS(1359),
    [sym_label] = ACTIONS(1157),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1157),
    [anon_sym_u22b8] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1159),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1157),
    [sym__cond_layout_end] = ACTIONS(1157),
    [sym__cond_layout_end_explicit] = ACTIONS(1157),
    [sym__phantom_where] = ACTIONS(1157),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1361),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1157),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1157),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__cond_minus] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [424] = {
    [sym__type_parens] = STATE(3111),
    [sym__type_tuple] = STATE(3091),
    [sym__type_unboxed_tuple] = STATE(3092),
    [sym__type_unboxed_sum] = STATE(3095),
    [sym__type_list] = STATE(3100),
    [sym__type_promoted] = STATE(3123),
    [sym__type_star] = STATE(3123),
    [sym__type_wildcard] = STATE(3123),
    [sym__at_type] = STATE(3139),
    [sym__type_apply] = STATE(3099),
    [sym__type_infix] = STATE(3084),
    [sym_type] = STATE(424),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8468),
    [sym__splice_dollars] = STATE(7411),
    [sym_splice] = STATE(3123),
    [sym_quasiquote] = STATE(3123),
    [sym_integer] = STATE(3118),
    [sym__plist] = STATE(3082),
    [sym_unit] = STATE(3123),
    [sym_unboxed_unit] = STATE(3123),
    [sym_prefix_tuple] = STATE(3123),
    [sym_prefix_unboxed_tuple] = STATE(3123),
    [sym_prefix_unboxed_sum] = STATE(3123),
    [sym_literal] = STATE(3123),
    [sym__qualified_type] = STATE(3083),
    [sym__qtyconid] = STATE(3071),
    [sym__tycon_arrow] = STATE(3071),
    [sym__qtycon_arrow] = STATE(3071),
    [sym__promoted_tycons_alias] = STATE(3123),
    [sym__promoted_tycons] = STATE(3123),
    [sym__tycon_ticked] = STATE(2426),
    [sym__qtycon_ticked] = STATE(2426),
    [sym__tyconids_ticked] = STATE(2426),
    [sym__promoted_tyconops_alias] = STATE(2426),
    [sym__promoted_tyconops] = STATE(2426),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2426),
    [sym__operator_alias] = STATE(2426),
    [sym__operator_minus] = STATE(2426),
    [sym__varsym_prefix] = STATE(3071),
    [sym__pvarsym] = STATE(3071),
    [sym__qualified_varsym] = STATE(2425),
    [sym__qvarsym_prefix] = STATE(3071),
    [sym__pqvarsym] = STATE(3071),
    [sym_constructor_operator] = STATE(2426),
    [sym__constructor_operator_alias] = STATE(2426),
    [sym__consym_prefix] = STATE(3071),
    [sym__pconsym] = STATE(3071),
    [sym__qualified_consym] = STATE(2424),
    [sym__qconsym_prefix] = STATE(3071),
    [sym__pqconsym] = STATE(3071),
    [sym__prefix_at] = STATE(2677),
    [sym__paren_open] = STATE(441),
    [sym__bracket_open] = STATE(1101),
    [sym__unboxed_open] = STATE(764),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1119),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_mdo] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_u27e6] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1117),
    [sym_implicit_variable] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [sym_label] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1119),
    [anon_sym_u22b8] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [anon_sym_where] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1119),
    [sym__cond_layout_end] = ACTIONS(1119),
    [sym__cond_layout_end_explicit] = ACTIONS(1119),
    [sym__phantom_where] = ACTIONS(1119),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_tight_dot] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_prefix_percent] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__cond_minus] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [425] = {
    [sym__type_parens] = STATE(3111),
    [sym__type_tuple] = STATE(3091),
    [sym__type_unboxed_tuple] = STATE(3092),
    [sym__type_unboxed_sum] = STATE(3095),
    [sym__type_list] = STATE(3100),
    [sym__type_promoted] = STATE(3123),
    [sym__type_star] = STATE(3123),
    [sym__type_wildcard] = STATE(3123),
    [sym__at_type] = STATE(3139),
    [sym__type_apply] = STATE(3099),
    [sym__type_infix] = STATE(3084),
    [sym_type] = STATE(424),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8468),
    [sym__splice_dollars] = STATE(7411),
    [sym_splice] = STATE(3123),
    [sym_quasiquote] = STATE(3123),
    [sym_integer] = STATE(3118),
    [sym__plist] = STATE(3082),
    [sym_unit] = STATE(3123),
    [sym_unboxed_unit] = STATE(3123),
    [sym_prefix_tuple] = STATE(3123),
    [sym_prefix_unboxed_tuple] = STATE(3123),
    [sym_prefix_unboxed_sum] = STATE(3123),
    [sym_literal] = STATE(3123),
    [sym__qualified_type] = STATE(3083),
    [sym__qtyconid] = STATE(3071),
    [sym__tycon_arrow] = STATE(3071),
    [sym__qtycon_arrow] = STATE(3071),
    [sym__promoted_tycons_alias] = STATE(3123),
    [sym__promoted_tycons] = STATE(3123),
    [sym__tycon_ticked] = STATE(2426),
    [sym__qtycon_ticked] = STATE(2426),
    [sym__tyconids_ticked] = STATE(2426),
    [sym__promoted_tyconops_alias] = STATE(2426),
    [sym__promoted_tyconops] = STATE(2426),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2426),
    [sym__operator_alias] = STATE(2426),
    [sym__operator_minus] = STATE(2426),
    [sym__varsym_prefix] = STATE(3071),
    [sym__pvarsym] = STATE(3071),
    [sym__qualified_varsym] = STATE(2425),
    [sym__qvarsym_prefix] = STATE(3071),
    [sym__pqvarsym] = STATE(3071),
    [sym_constructor_operator] = STATE(2426),
    [sym__constructor_operator_alias] = STATE(2426),
    [sym__consym_prefix] = STATE(3071),
    [sym__pconsym] = STATE(3071),
    [sym__qualified_consym] = STATE(2424),
    [sym__qconsym_prefix] = STATE(3071),
    [sym__pqconsym] = STATE(3071),
    [sym__prefix_at] = STATE(2677),
    [sym__paren_open] = STATE(441),
    [sym__bracket_open] = STATE(1101),
    [sym__unboxed_open] = STATE(764),
    [sym_variable] = ACTIONS(1343),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_let] = ACTIONS(1125),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym__] = ACTIONS(1345),
    [anon_sym_SQUOTE] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_u2605] = ACTIONS(1351),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1123),
    [anon_sym_BSLASH] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1125),
    [anon_sym_mdo] = ACTIONS(1125),
    [anon_sym_do] = ACTIONS(1125),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1123),
    [sym_float] = ACTIONS(1353),
    [sym_char] = ACTIONS(1353),
    [sym_string] = ACTIONS(1353),
    [sym__integer_literal] = ACTIONS(1355),
    [sym__binary_literal] = ACTIONS(1357),
    [sym__octal_literal] = ACTIONS(1357),
    [sym__hex_literal] = ACTIONS(1357),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1123),
    [sym_name] = ACTIONS(1359),
    [sym_label] = ACTIONS(1123),
    [anon_sym_u2192] = ACTIONS(1123),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1123),
    [anon_sym_u22b8] = ACTIONS(1123),
    [anon_sym_COLON_COLON] = ACTIONS(1123),
    [anon_sym_u2237] = ACTIONS(1123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1125),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1123),
    [sym__cond_layout_end] = ACTIONS(1123),
    [sym__cond_layout_end_explicit] = ACTIONS(1123),
    [sym__phantom_where] = ACTIONS(1123),
    [sym__phantom_arrow] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1361),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1123),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1123),
    [sym__cond_qualified_op] = ACTIONS(1123),
    [sym__cond_no_section_op] = ACTIONS(1123),
    [sym__cond_minus] = ACTIONS(1123),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [426] = {
    [sym__type_parens] = STATE(3111),
    [sym__type_tuple] = STATE(3091),
    [sym__type_unboxed_tuple] = STATE(3092),
    [sym__type_unboxed_sum] = STATE(3095),
    [sym__type_list] = STATE(3100),
    [sym__type_promoted] = STATE(3123),
    [sym__type_star] = STATE(3123),
    [sym__type_wildcard] = STATE(3123),
    [sym__at_type] = STATE(3139),
    [sym__type_apply] = STATE(3099),
    [sym__type_infix] = STATE(3084),
    [sym_type] = STATE(424),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8468),
    [sym__splice_dollars] = STATE(7411),
    [sym_splice] = STATE(3123),
    [sym_quasiquote] = STATE(3123),
    [sym_integer] = STATE(3118),
    [sym__plist] = STATE(3082),
    [sym_unit] = STATE(3123),
    [sym_unboxed_unit] = STATE(3123),
    [sym_prefix_tuple] = STATE(3123),
    [sym_prefix_unboxed_tuple] = STATE(3123),
    [sym_prefix_unboxed_sum] = STATE(3123),
    [sym_literal] = STATE(3123),
    [sym__qualified_type] = STATE(3083),
    [sym__qtyconid] = STATE(3071),
    [sym__tycon_arrow] = STATE(3071),
    [sym__qtycon_arrow] = STATE(3071),
    [sym__promoted_tycons_alias] = STATE(3123),
    [sym__promoted_tycons] = STATE(3123),
    [sym__tycon_ticked] = STATE(2426),
    [sym__qtycon_ticked] = STATE(2426),
    [sym__tyconids_ticked] = STATE(2426),
    [sym__promoted_tyconops_alias] = STATE(2426),
    [sym__promoted_tyconops] = STATE(2426),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2426),
    [sym__operator_alias] = STATE(2426),
    [sym__operator_minus] = STATE(2426),
    [sym__varsym_prefix] = STATE(3071),
    [sym__pvarsym] = STATE(3071),
    [sym__qualified_varsym] = STATE(2425),
    [sym__qvarsym_prefix] = STATE(3071),
    [sym__pqvarsym] = STATE(3071),
    [sym_constructor_operator] = STATE(2426),
    [sym__constructor_operator_alias] = STATE(2426),
    [sym__consym_prefix] = STATE(3071),
    [sym__pconsym] = STATE(3071),
    [sym__qualified_consym] = STATE(2424),
    [sym__qconsym_prefix] = STATE(3071),
    [sym__pqconsym] = STATE(3071),
    [sym__prefix_at] = STATE(2677),
    [sym__paren_open] = STATE(441),
    [sym__bracket_open] = STATE(1101),
    [sym__unboxed_open] = STATE(764),
    [sym_variable] = ACTIONS(1343),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1345),
    [anon_sym_SQUOTE] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_u2605] = ACTIONS(1351),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(1353),
    [sym_char] = ACTIONS(1353),
    [sym_string] = ACTIONS(1353),
    [sym__integer_literal] = ACTIONS(1355),
    [sym__binary_literal] = ACTIONS(1357),
    [sym__octal_literal] = ACTIONS(1357),
    [sym__hex_literal] = ACTIONS(1357),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1359),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_where] = ACTIONS(1181),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1361),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [427] = {
    [sym__type_parens] = STATE(3111),
    [sym__type_tuple] = STATE(3091),
    [sym__type_unboxed_tuple] = STATE(3092),
    [sym__type_unboxed_sum] = STATE(3095),
    [sym__type_list] = STATE(3100),
    [sym__type_promoted] = STATE(3123),
    [sym__type_star] = STATE(3123),
    [sym__type_wildcard] = STATE(3123),
    [sym__at_type] = STATE(3139),
    [sym__type_apply] = STATE(3099),
    [sym__type_infix] = STATE(3084),
    [sym_type] = STATE(424),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8468),
    [sym__splice_dollars] = STATE(7411),
    [sym_splice] = STATE(3123),
    [sym_quasiquote] = STATE(3123),
    [sym_integer] = STATE(3118),
    [sym__plist] = STATE(3082),
    [sym_unit] = STATE(3123),
    [sym_unboxed_unit] = STATE(3123),
    [sym_prefix_tuple] = STATE(3123),
    [sym_prefix_unboxed_tuple] = STATE(3123),
    [sym_prefix_unboxed_sum] = STATE(3123),
    [sym_literal] = STATE(3123),
    [sym__qualified_type] = STATE(3083),
    [sym__qtyconid] = STATE(3071),
    [sym__tycon_arrow] = STATE(3071),
    [sym__qtycon_arrow] = STATE(3071),
    [sym__promoted_tycons_alias] = STATE(3123),
    [sym__promoted_tycons] = STATE(3123),
    [sym__tycon_ticked] = STATE(2426),
    [sym__qtycon_ticked] = STATE(2426),
    [sym__tyconids_ticked] = STATE(2426),
    [sym__promoted_tyconops_alias] = STATE(2426),
    [sym__promoted_tyconops] = STATE(2426),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2426),
    [sym__operator_alias] = STATE(2426),
    [sym__operator_minus] = STATE(2426),
    [sym__varsym_prefix] = STATE(3071),
    [sym__pvarsym] = STATE(3071),
    [sym__qualified_varsym] = STATE(2425),
    [sym__qvarsym_prefix] = STATE(3071),
    [sym__pqvarsym] = STATE(3071),
    [sym_constructor_operator] = STATE(2426),
    [sym__constructor_operator_alias] = STATE(2426),
    [sym__consym_prefix] = STATE(3071),
    [sym__pconsym] = STATE(3071),
    [sym__qualified_consym] = STATE(2424),
    [sym__qconsym_prefix] = STATE(3071),
    [sym__pqconsym] = STATE(3071),
    [sym__prefix_at] = STATE(2677),
    [sym__paren_open] = STATE(441),
    [sym__bracket_open] = STATE(1101),
    [sym__unboxed_open] = STATE(764),
    [sym_variable] = ACTIONS(1343),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1345),
    [anon_sym_SQUOTE] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_u2605] = ACTIONS(1351),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(1353),
    [sym_char] = ACTIONS(1353),
    [sym_string] = ACTIONS(1353),
    [sym__integer_literal] = ACTIONS(1355),
    [sym__binary_literal] = ACTIONS(1357),
    [sym__octal_literal] = ACTIONS(1357),
    [sym__hex_literal] = ACTIONS(1357),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1359),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_where] = ACTIONS(1181),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1361),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [428] = {
    [sym__type_parens] = STATE(3111),
    [sym__type_tuple] = STATE(3091),
    [sym__type_unboxed_tuple] = STATE(3092),
    [sym__type_unboxed_sum] = STATE(3095),
    [sym__type_list] = STATE(3100),
    [sym__type_promoted] = STATE(3123),
    [sym__type_star] = STATE(3123),
    [sym__type_wildcard] = STATE(3123),
    [sym__at_type] = STATE(3139),
    [sym__type_apply] = STATE(3099),
    [sym__type_infix] = STATE(3084),
    [sym_type] = STATE(424),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8468),
    [sym__splice_dollars] = STATE(7411),
    [sym_splice] = STATE(3123),
    [sym_quasiquote] = STATE(3123),
    [sym_integer] = STATE(3118),
    [sym__plist] = STATE(3082),
    [sym_unit] = STATE(3123),
    [sym_unboxed_unit] = STATE(3123),
    [sym_prefix_tuple] = STATE(3123),
    [sym_prefix_unboxed_tuple] = STATE(3123),
    [sym_prefix_unboxed_sum] = STATE(3123),
    [sym_literal] = STATE(3123),
    [sym__qualified_type] = STATE(3083),
    [sym__qtyconid] = STATE(3071),
    [sym__tycon_arrow] = STATE(3071),
    [sym__qtycon_arrow] = STATE(3071),
    [sym__promoted_tycons_alias] = STATE(3123),
    [sym__promoted_tycons] = STATE(3123),
    [sym__tycon_ticked] = STATE(2426),
    [sym__qtycon_ticked] = STATE(2426),
    [sym__tyconids_ticked] = STATE(2426),
    [sym__promoted_tyconops_alias] = STATE(2426),
    [sym__promoted_tyconops] = STATE(2426),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2426),
    [sym__operator_alias] = STATE(2426),
    [sym__operator_minus] = STATE(2426),
    [sym__varsym_prefix] = STATE(3071),
    [sym__pvarsym] = STATE(3071),
    [sym__qualified_varsym] = STATE(2425),
    [sym__qvarsym_prefix] = STATE(3071),
    [sym__pqvarsym] = STATE(3071),
    [sym_constructor_operator] = STATE(2426),
    [sym__constructor_operator_alias] = STATE(2426),
    [sym__consym_prefix] = STATE(3071),
    [sym__pconsym] = STATE(3071),
    [sym__qualified_consym] = STATE(2424),
    [sym__qconsym_prefix] = STATE(3071),
    [sym__pqconsym] = STATE(3071),
    [sym__prefix_at] = STATE(2677),
    [sym__paren_open] = STATE(441),
    [sym__bracket_open] = STATE(1101),
    [sym__unboxed_open] = STATE(764),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1179),
    [anon_sym_u22b8] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(1177),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym__phantom_where] = ACTIONS(1179),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_prefix_percent] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [429] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11471),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10591),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11690),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(12082),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12082),
    [sym__operator_minus] = STATE(12082),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11973),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12086),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11975),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11900),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6401),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10494),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1365),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1395),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [430] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11354),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10021),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11509),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11355),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11355),
    [sym__operator_minus] = STATE(11355),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11816),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11916),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12212),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11451),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6955),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10458),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1409),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1411),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [431] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11516),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10687),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11505),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11988),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11988),
    [sym__operator_minus] = STATE(11988),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11834),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12007),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11836),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11726),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6478),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10590),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1413),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1415),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [432] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11734),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10426),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11930),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11337),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11337),
    [sym__operator_minus] = STATE(11337),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11781),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12207),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11592),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11510),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(2730),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10332),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1417),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1279),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [433] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11765),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10437),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11658),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11565),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11565),
    [sym__operator_minus] = STATE(11565),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(12185),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12183),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12178),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11790),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(4517),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10501),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1419),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1269),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [434] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11379),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10621),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11414),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11535),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11535),
    [sym__operator_minus] = STATE(11535),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11907),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11465),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11634),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11997),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(7614),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10865),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1421),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1423),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [435] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11804),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10409),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11959),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(12127),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12127),
    [sym__operator_minus] = STATE(12127),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(12093),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12136),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11331),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(12049),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6916),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10336),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1425),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1427),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [436] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(12113),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10809),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11527),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11831),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11831),
    [sym__operator_minus] = STATE(11831),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11575),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11898),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11614),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11504),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6144),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10712),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1429),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1431),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [437] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11989),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10194),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11588),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11553),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11553),
    [sym__operator_minus] = STATE(11553),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11400),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11745),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11823),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11867),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6274),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10401),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1433),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1435),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [438] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(12000),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10829),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11629),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11794),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11794),
    [sym__operator_minus] = STATE(11794),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11538),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11869),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11577),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11467),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6734),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10733),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1437),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1439),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [439] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11673),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10097),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11433),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11736),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11736),
    [sym__operator_minus] = STATE(11736),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11525),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11593),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11370),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11927),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(7455),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10609),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1441),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1443),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [440] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11332),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10666),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11542),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(12017),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12017),
    [sym__operator_minus] = STATE(12017),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11868),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12021),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11870),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11763),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(4520),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10575),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1257),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [441] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11767),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10433),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11941),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(12123),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12123),
    [sym__operator_minus] = STATE(12123),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(12085),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12132),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12087),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(12036),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(3063),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10341),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1447),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1449),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [442] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11795),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10850),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11749),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11424),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11424),
    [sym__operator_minus] = STATE(11424),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11501),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12064),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11407),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11430),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6526),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10623),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(283),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [443] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11365),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10648),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11579),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(12043),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12043),
    [sym__operator_minus] = STATE(12043),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11897),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12034),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11899),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11800),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(4855),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10561),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1451),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1275),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [444] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11676),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10456),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(12222),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11885),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11885),
    [sym__operator_minus] = STATE(11885),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11608),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11753),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11769),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11954),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(4127),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10677),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1453),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1249),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [445] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11397),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10633),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11616),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(12056),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12056),
    [sym__operator_minus] = STATE(12056),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11937),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12060),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11939),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11837),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(2311),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10538),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1455),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1457),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [446] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(12169),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10773),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11986),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11646),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11646),
    [sym__operator_minus] = STATE(11646),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11533),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11613),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11360),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11630),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6591),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10827),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1459),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1461),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [447] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(12214),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10792),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11415),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11865),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11865),
    [sym__operator_minus] = STATE(11865),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11612),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11919),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11651),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11541),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(3240),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10686),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1463),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1465),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [448] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11621),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10713),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11468),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11970),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11970),
    [sym__operator_minus] = STATE(11970),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11797),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11992),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11799),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11689),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(7273),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10614),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1467),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1469),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [449] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11423),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10870),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11999),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11534),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11534),
    [sym__operator_minus] = STATE(11534),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11356),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11561),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11778),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11694),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6420),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10023),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1471),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1473),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [450] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11730),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10451),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11922),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(12119),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12119),
    [sym__operator_minus] = STATE(12119),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(12072),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12128),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12074),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(12023),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(7164),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10351),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1477),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [451] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11693),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10478),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11901),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(12030),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12030),
    [sym__operator_minus] = STATE(12030),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(12059),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12124),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12061),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(12009),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(4884),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10364),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1479),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1263),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [452] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11425),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10863),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(12038),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11644),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11644),
    [sym__operator_minus] = STATE(11644),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11390),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11761),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11466),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11361),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(4021),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10769),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1481),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [453] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11984),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10181),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11381),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11859),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11859),
    [sym__operator_minus] = STATE(11859),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11518),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12018),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11350),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11409),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6073),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10394),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(249),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [454] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11434),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10615),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11653),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(12069),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12069),
    [sym__operator_minus] = STATE(12069),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11955),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12073),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11957),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11871),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(5870),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10512),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1483),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1485),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [455] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11783),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10390),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11377),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(12176),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12176),
    [sym__operator_minus] = STATE(12176),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11708),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11513),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11914),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11960),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(7549),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10425),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1487),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1489),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [456] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11338),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10645),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11732),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(12014),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12014),
    [sym__operator_minus] = STATE(12014),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(12019),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11399),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11965),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11776),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(3845),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10190),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1491),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1493),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [457] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11738),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10734),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11431),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11934),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11934),
    [sym__operator_minus] = STATE(11934),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11723),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11974),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11762),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11652),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(7791),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10632),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1495),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1497),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [458] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11841),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10383),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11977),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(12131),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12131),
    [sym__operator_minus] = STATE(12131),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(12100),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12139),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12102),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(12062),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(3254),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10328),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1499),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [459] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11929),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10330),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11580),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11387),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11387),
    [sym__operator_minus] = STATE(11387),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11990),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12092),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11879),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11639),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(7013),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10513),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1505),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [460] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11432),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10818),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(12211),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11720),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11720),
    [sym__operator_minus] = STATE(11720),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11358),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11724),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11429),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11416),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6005),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10789),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1507),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1509),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [461] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11902),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10353),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(12010),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(12138),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12138),
    [sym__operator_minus] = STATE(12138),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(12114),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12143),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12116),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(12088),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(3678),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10322),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1513),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [462] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11508),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10576),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11727),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(12003),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12003),
    [sym__operator_minus] = STATE(12003),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11991),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12094),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11993),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11921),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(3688),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10476),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1515),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1255),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [463] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11842),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10725),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11785),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11609),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11609),
    [sym__operator_minus] = STATE(11609),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11638),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11576),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11417),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11751),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(7637),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10849),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1517),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1519),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [464] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11656),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10496),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11872),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(12112),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12112),
    [sym__operator_minus] = STATE(12112),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(12046),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12120),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12048),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11994),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(3293),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10380),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1521),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1523),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [465] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11545),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10562),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11764),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(12091),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12091),
    [sym__operator_minus] = STATE(12091),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(12006),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12101),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12008),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11940),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(3452),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10450),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1525),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1527),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [466] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11582),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10539),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11801),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(12098),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12098),
    [sym__operator_minus] = STATE(12098),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(12020),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12108),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12022),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11958),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(3334),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10431),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1531),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [467] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11875),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10366),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11995),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(12135),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12135),
    [sym__operator_minus] = STATE(12135),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(12107),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12141),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12109),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(12075),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(2755),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10325),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1533),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1535),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [468] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(12015),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10770),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11362),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11894),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11894),
    [sym__operator_minus] = STATE(11894),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11649),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11938),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11688),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11578),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(5908),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10665),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1537),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1539),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [469] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11878),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10760),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11394),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11915),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11915),
    [sym__operator_minus] = STATE(11915),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11686),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11956),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11725),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11615),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6504),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10647),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1541),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1543),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [470] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11585),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10511),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11866),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(12077),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12077),
    [sym__operator_minus] = STATE(12077),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11913),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11532),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12097),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(12099),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(4196),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10727),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1545),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1295),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [471] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11772),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10399),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11827),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11735),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11735),
    [sym__operator_minus] = STATE(11735),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11492),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12204),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11459),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11782),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(4284),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10568),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1547),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1277),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [472] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11619),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10515),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11838),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(12105),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12105),
    [sym__operator_minus] = STATE(12105),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(12033),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12115),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12035),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11976),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6737),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10408),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1549),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1551),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [473] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11601),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10675),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11641),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11572),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11572),
    [sym__operator_minus] = STATE(11572),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11754),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11539),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11531),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11890),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(7032),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10859),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1553),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1555),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [474] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11380),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10612),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11385),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11395),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11395),
    [sym__operator_minus] = STATE(11395),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11979),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11818),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11696),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11591),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(7470),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10183),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1557),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1559),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [475] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11645),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10862),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11889),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11757),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11757),
    [sym__operator_minus] = STATE(11757),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(11464),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11835),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11540),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(11393),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(5937),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10759),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1561),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1563),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [476] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11488),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10566),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8291),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qualified_arrow] = STATE(11444),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__operator_qual_dot_head] = STATE(11461),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11461),
    [sym__operator_minus] = STATE(11461),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(12201),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11359),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12054),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__arrow] = STATE(12209),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(5074),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10775),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1565),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(1389),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1567),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [477] = {
    [sym__type_parens] = STATE(3220),
    [sym__type_tuple] = STATE(3210),
    [sym__type_unboxed_tuple] = STATE(3184),
    [sym__type_unboxed_sum] = STATE(3188),
    [sym__type_list] = STATE(3211),
    [sym__type_promoted] = STATE(3364),
    [sym__type_star] = STATE(3364),
    [sym__type_wildcard] = STATE(3364),
    [sym__at_type] = STATE(3352),
    [sym__type_apply] = STATE(3196),
    [sym__type_infix] = STATE(3225),
    [sym_type] = STATE(496),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8421),
    [sym__splice_dollars] = STATE(7401),
    [sym_splice] = STATE(3364),
    [sym_quasiquote] = STATE(3364),
    [sym_integer] = STATE(3397),
    [sym__plist] = STATE(3177),
    [sym_unit] = STATE(3364),
    [sym_unboxed_unit] = STATE(3364),
    [sym_prefix_tuple] = STATE(3364),
    [sym_prefix_unboxed_tuple] = STATE(3364),
    [sym_prefix_unboxed_sum] = STATE(3364),
    [sym_literal] = STATE(3364),
    [sym__qualified_type] = STATE(3262),
    [sym__qtyconid] = STATE(3232),
    [sym__tycon_arrow] = STATE(3232),
    [sym__qtycon_arrow] = STATE(3232),
    [sym__promoted_tycons_alias] = STATE(3364),
    [sym__promoted_tycons] = STATE(3364),
    [sym__tycon_ticked] = STATE(2496),
    [sym__qtycon_ticked] = STATE(2496),
    [sym__tyconids_ticked] = STATE(2496),
    [sym__promoted_tyconops_alias] = STATE(2496),
    [sym__promoted_tyconops] = STATE(2496),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2496),
    [sym__operator_alias] = STATE(2496),
    [sym__operator_minus] = STATE(2496),
    [sym__varsym_prefix] = STATE(3232),
    [sym__pvarsym] = STATE(3232),
    [sym__qualified_varsym] = STATE(2494),
    [sym__qvarsym_prefix] = STATE(3232),
    [sym__pqvarsym] = STATE(3232),
    [sym_constructor_operator] = STATE(2496),
    [sym__constructor_operator_alias] = STATE(2496),
    [sym__consym_prefix] = STATE(3232),
    [sym__pconsym] = STATE(3232),
    [sym__qualified_consym] = STATE(2492),
    [sym__qconsym_prefix] = STATE(3232),
    [sym__pqconsym] = STATE(3232),
    [sym__prefix_at] = STATE(2625),
    [sym__paren_open] = STATE(466),
    [sym__bracket_open] = STATE(1073),
    [sym__unboxed_open] = STATE(781),
    [sym_variable] = ACTIONS(1569),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_u2605] = ACTIONS(1577),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(1579),
    [sym_char] = ACTIONS(1579),
    [sym_string] = ACTIONS(1579),
    [sym__integer_literal] = ACTIONS(1581),
    [sym__binary_literal] = ACTIONS(1583),
    [sym__octal_literal] = ACTIONS(1583),
    [sym__hex_literal] = ACTIONS(1583),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1585),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1587),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_dotdot] = ACTIONS(1181),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [478] = {
    [sym__type_parens] = STATE(3294),
    [sym__type_tuple] = STATE(3295),
    [sym__type_unboxed_tuple] = STATE(3296),
    [sym__type_unboxed_sum] = STATE(3298),
    [sym__type_list] = STATE(3311),
    [sym__type_promoted] = STATE(3292),
    [sym__type_star] = STATE(3292),
    [sym__type_wildcard] = STATE(3292),
    [sym__at_type] = STATE(3341),
    [sym__type_apply] = STATE(3313),
    [sym__type_infix] = STATE(3314),
    [sym_type] = STATE(498),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8499),
    [sym__splice_dollars] = STATE(7231),
    [sym_splice] = STATE(3292),
    [sym_quasiquote] = STATE(3292),
    [sym_integer] = STATE(3286),
    [sym__plist] = STATE(3318),
    [sym_unit] = STATE(3292),
    [sym_unboxed_unit] = STATE(3292),
    [sym_prefix_tuple] = STATE(3292),
    [sym_prefix_unboxed_tuple] = STATE(3292),
    [sym_prefix_unboxed_sum] = STATE(3292),
    [sym_literal] = STATE(3292),
    [sym__qualified_type] = STATE(3249),
    [sym__qtyconid] = STATE(3320),
    [sym__tycon_arrow] = STATE(3320),
    [sym__qtycon_arrow] = STATE(3320),
    [sym__promoted_tycons_alias] = STATE(3292),
    [sym__promoted_tycons] = STATE(3292),
    [sym__tycon_ticked] = STATE(2412),
    [sym__qtycon_ticked] = STATE(2412),
    [sym__tyconids_ticked] = STATE(2412),
    [sym__promoted_tyconops_alias] = STATE(2412),
    [sym__promoted_tyconops] = STATE(2412),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2412),
    [sym__operator_alias] = STATE(2412),
    [sym__operator_minus] = STATE(2412),
    [sym__varsym_prefix] = STATE(3320),
    [sym__pvarsym] = STATE(3320),
    [sym__qualified_varsym] = STATE(2409),
    [sym__qvarsym_prefix] = STATE(3320),
    [sym__pqvarsym] = STATE(3320),
    [sym_constructor_operator] = STATE(2412),
    [sym__constructor_operator_alias] = STATE(2412),
    [sym__consym_prefix] = STATE(3320),
    [sym__pconsym] = STATE(3320),
    [sym__qualified_consym] = STATE(2408),
    [sym__qconsym_prefix] = STATE(3320),
    [sym__pqconsym] = STATE(3320),
    [sym__prefix_at] = STATE(2685),
    [sym__paren_open] = STATE(458),
    [sym__bracket_open] = STATE(1120),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = ACTIONS(1589),
    [anon_sym_let] = ACTIONS(1125),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym__] = ACTIONS(1591),
    [anon_sym_SQUOTE] = ACTIONS(1593),
    [anon_sym_STAR] = ACTIONS(1595),
    [anon_sym_u2605] = ACTIONS(1597),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1123),
    [anon_sym_by] = ACTIONS(1125),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_BSLASH] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1125),
    [anon_sym_mdo] = ACTIONS(1125),
    [anon_sym_do] = ACTIONS(1125),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1123),
    [sym_float] = ACTIONS(1599),
    [sym_char] = ACTIONS(1599),
    [sym_string] = ACTIONS(1599),
    [sym__integer_literal] = ACTIONS(1601),
    [sym__binary_literal] = ACTIONS(1603),
    [sym__octal_literal] = ACTIONS(1603),
    [sym__hex_literal] = ACTIONS(1603),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1123),
    [sym_name] = ACTIONS(1605),
    [sym_label] = ACTIONS(1123),
    [anon_sym_u2192] = ACTIONS(1123),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1123),
    [anon_sym_u22b8] = ACTIONS(1123),
    [anon_sym_COLON_COLON] = ACTIONS(1123),
    [anon_sym_u2237] = ACTIONS(1123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1607),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1123),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1123),
    [sym__cond_qualified_op] = ACTIONS(1123),
    [sym__cond_no_section_op] = ACTIONS(1123),
    [sym__cond_minus] = ACTIONS(1123),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [479] = {
    [sym__type_parens] = STATE(3294),
    [sym__type_tuple] = STATE(3295),
    [sym__type_unboxed_tuple] = STATE(3296),
    [sym__type_unboxed_sum] = STATE(3298),
    [sym__type_list] = STATE(3311),
    [sym__type_promoted] = STATE(3292),
    [sym__type_star] = STATE(3292),
    [sym__type_wildcard] = STATE(3292),
    [sym__at_type] = STATE(3341),
    [sym__type_apply] = STATE(3313),
    [sym__type_infix] = STATE(3314),
    [sym_type] = STATE(498),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8499),
    [sym__splice_dollars] = STATE(7231),
    [sym_splice] = STATE(3292),
    [sym_quasiquote] = STATE(3292),
    [sym_integer] = STATE(3286),
    [sym__plist] = STATE(3318),
    [sym_unit] = STATE(3292),
    [sym_unboxed_unit] = STATE(3292),
    [sym_prefix_tuple] = STATE(3292),
    [sym_prefix_unboxed_tuple] = STATE(3292),
    [sym_prefix_unboxed_sum] = STATE(3292),
    [sym_literal] = STATE(3292),
    [sym__qualified_type] = STATE(3249),
    [sym__qtyconid] = STATE(3320),
    [sym__tycon_arrow] = STATE(3320),
    [sym__qtycon_arrow] = STATE(3320),
    [sym__promoted_tycons_alias] = STATE(3292),
    [sym__promoted_tycons] = STATE(3292),
    [sym__tycon_ticked] = STATE(2412),
    [sym__qtycon_ticked] = STATE(2412),
    [sym__tyconids_ticked] = STATE(2412),
    [sym__promoted_tyconops_alias] = STATE(2412),
    [sym__promoted_tyconops] = STATE(2412),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2412),
    [sym__operator_alias] = STATE(2412),
    [sym__operator_minus] = STATE(2412),
    [sym__varsym_prefix] = STATE(3320),
    [sym__pvarsym] = STATE(3320),
    [sym__qualified_varsym] = STATE(2409),
    [sym__qvarsym_prefix] = STATE(3320),
    [sym__pqvarsym] = STATE(3320),
    [sym_constructor_operator] = STATE(2412),
    [sym__constructor_operator_alias] = STATE(2412),
    [sym__consym_prefix] = STATE(3320),
    [sym__pconsym] = STATE(3320),
    [sym__qualified_consym] = STATE(2408),
    [sym__qconsym_prefix] = STATE(3320),
    [sym__pqconsym] = STATE(3320),
    [sym__prefix_at] = STATE(2685),
    [sym__paren_open] = STATE(458),
    [sym__bracket_open] = STATE(1120),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = ACTIONS(1589),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1591),
    [anon_sym_SQUOTE] = ACTIONS(1593),
    [anon_sym_STAR] = ACTIONS(1595),
    [anon_sym_u2605] = ACTIONS(1597),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_by] = ACTIONS(1183),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(1599),
    [sym_char] = ACTIONS(1599),
    [sym_string] = ACTIONS(1599),
    [sym__integer_literal] = ACTIONS(1601),
    [sym__binary_literal] = ACTIONS(1603),
    [sym__octal_literal] = ACTIONS(1603),
    [sym__hex_literal] = ACTIONS(1603),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1605),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1607),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [480] = {
    [sym__type_parens] = STATE(3220),
    [sym__type_tuple] = STATE(3210),
    [sym__type_unboxed_tuple] = STATE(3184),
    [sym__type_unboxed_sum] = STATE(3188),
    [sym__type_list] = STATE(3211),
    [sym__type_promoted] = STATE(3364),
    [sym__type_star] = STATE(3364),
    [sym__type_wildcard] = STATE(3364),
    [sym__at_type] = STATE(3352),
    [sym__type_apply] = STATE(3196),
    [sym__type_infix] = STATE(3225),
    [sym_type] = STATE(496),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8421),
    [sym__splice_dollars] = STATE(7401),
    [sym_splice] = STATE(3364),
    [sym_quasiquote] = STATE(3364),
    [sym_integer] = STATE(3397),
    [sym__plist] = STATE(3177),
    [sym_unit] = STATE(3364),
    [sym_unboxed_unit] = STATE(3364),
    [sym_prefix_tuple] = STATE(3364),
    [sym_prefix_unboxed_tuple] = STATE(3364),
    [sym_prefix_unboxed_sum] = STATE(3364),
    [sym_literal] = STATE(3364),
    [sym__qualified_type] = STATE(3262),
    [sym__qtyconid] = STATE(3232),
    [sym__tycon_arrow] = STATE(3232),
    [sym__qtycon_arrow] = STATE(3232),
    [sym__promoted_tycons_alias] = STATE(3364),
    [sym__promoted_tycons] = STATE(3364),
    [sym__tycon_ticked] = STATE(2496),
    [sym__qtycon_ticked] = STATE(2496),
    [sym__tyconids_ticked] = STATE(2496),
    [sym__promoted_tyconops_alias] = STATE(2496),
    [sym__promoted_tyconops] = STATE(2496),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2496),
    [sym__operator_alias] = STATE(2496),
    [sym__operator_minus] = STATE(2496),
    [sym__varsym_prefix] = STATE(3232),
    [sym__pvarsym] = STATE(3232),
    [sym__qualified_varsym] = STATE(2494),
    [sym__qvarsym_prefix] = STATE(3232),
    [sym__pqvarsym] = STATE(3232),
    [sym_constructor_operator] = STATE(2496),
    [sym__constructor_operator_alias] = STATE(2496),
    [sym__consym_prefix] = STATE(3232),
    [sym__pconsym] = STATE(3232),
    [sym__qualified_consym] = STATE(2492),
    [sym__qconsym_prefix] = STATE(3232),
    [sym__pqconsym] = STATE(3232),
    [sym__prefix_at] = STATE(2625),
    [sym__paren_open] = STATE(466),
    [sym__bracket_open] = STATE(1073),
    [sym__unboxed_open] = STATE(781),
    [sym_variable] = ACTIONS(1569),
    [anon_sym_let] = ACTIONS(1125),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym__] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_u2605] = ACTIONS(1577),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_BSLASH] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1125),
    [anon_sym_mdo] = ACTIONS(1125),
    [anon_sym_do] = ACTIONS(1125),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1123),
    [sym_float] = ACTIONS(1579),
    [sym_char] = ACTIONS(1579),
    [sym_string] = ACTIONS(1579),
    [sym__integer_literal] = ACTIONS(1581),
    [sym__binary_literal] = ACTIONS(1583),
    [sym__octal_literal] = ACTIONS(1583),
    [sym__hex_literal] = ACTIONS(1583),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1123),
    [sym_name] = ACTIONS(1585),
    [sym_label] = ACTIONS(1123),
    [anon_sym_u2192] = ACTIONS(1123),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1123),
    [anon_sym_u22b8] = ACTIONS(1123),
    [anon_sym_COLON_COLON] = ACTIONS(1123),
    [anon_sym_u2237] = ACTIONS(1123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1587),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1123),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_dotdot] = ACTIONS(1123),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1123),
    [sym__cond_qualified_op] = ACTIONS(1123),
    [sym__cond_no_section_op] = ACTIONS(1123),
    [sym__cond_minus] = ACTIONS(1123),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [481] = {
    [sym__type_parens] = STATE(3379),
    [sym__type_tuple] = STATE(3377),
    [sym__type_unboxed_tuple] = STATE(3370),
    [sym__type_unboxed_sum] = STATE(3369),
    [sym__type_list] = STATE(3361),
    [sym__type_promoted] = STATE(3383),
    [sym__type_star] = STATE(3383),
    [sym__type_wildcard] = STATE(3383),
    [sym__at_type] = STATE(3343),
    [sym__type_apply] = STATE(3359),
    [sym__type_infix] = STATE(3358),
    [sym_type] = STATE(481),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8433),
    [sym__splice_dollars] = STATE(7460),
    [sym_splice] = STATE(3383),
    [sym_quasiquote] = STATE(3383),
    [sym_integer] = STATE(3269),
    [sym__plist] = STATE(3357),
    [sym_unit] = STATE(3383),
    [sym_unboxed_unit] = STATE(3383),
    [sym_prefix_tuple] = STATE(3383),
    [sym_prefix_unboxed_tuple] = STATE(3383),
    [sym_prefix_unboxed_sum] = STATE(3383),
    [sym_literal] = STATE(3383),
    [sym__qualified_type] = STATE(3410),
    [sym__qtyconid] = STATE(3354),
    [sym__tycon_arrow] = STATE(3354),
    [sym__qtycon_arrow] = STATE(3354),
    [sym__promoted_tycons_alias] = STATE(3383),
    [sym__promoted_tycons] = STATE(3383),
    [sym__tycon_ticked] = STATE(2469),
    [sym__qtycon_ticked] = STATE(2469),
    [sym__tyconids_ticked] = STATE(2469),
    [sym__promoted_tyconops_alias] = STATE(2469),
    [sym__promoted_tyconops] = STATE(2469),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2469),
    [sym__operator_alias] = STATE(2469),
    [sym__operator_minus] = STATE(2469),
    [sym__varsym_prefix] = STATE(3354),
    [sym__pvarsym] = STATE(3354),
    [sym__qualified_varsym] = STATE(2465),
    [sym__qvarsym_prefix] = STATE(3354),
    [sym__pqvarsym] = STATE(3354),
    [sym_constructor_operator] = STATE(2469),
    [sym__constructor_operator_alias] = STATE(2469),
    [sym__consym_prefix] = STATE(3354),
    [sym__pconsym] = STATE(3354),
    [sym__qualified_consym] = STATE(2571),
    [sym__qconsym_prefix] = STATE(3354),
    [sym__pqconsym] = STATE(3354),
    [sym__prefix_at] = STATE(2638),
    [sym__paren_open] = STATE(464),
    [sym__bracket_open] = STATE(1079),
    [sym__unboxed_open] = STATE(805),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1117),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_mdo] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_u27e6] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1117),
    [anon_sym_PIPE2] = ACTIONS(1119),
    [sym_implicit_variable] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [sym_label] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1119),
    [anon_sym_u22b8] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [anon_sym_POUND_RPAREN] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_tight_dot] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_prefix_percent] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__cond_minus] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [482] = {
    [sym__type_parens] = STATE(3379),
    [sym__type_tuple] = STATE(3377),
    [sym__type_unboxed_tuple] = STATE(3370),
    [sym__type_unboxed_sum] = STATE(3369),
    [sym__type_list] = STATE(3361),
    [sym__type_promoted] = STATE(3383),
    [sym__type_star] = STATE(3383),
    [sym__type_wildcard] = STATE(3383),
    [sym__at_type] = STATE(3343),
    [sym__type_apply] = STATE(3359),
    [sym__type_infix] = STATE(3358),
    [sym_type] = STATE(481),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8433),
    [sym__splice_dollars] = STATE(7460),
    [sym_splice] = STATE(3383),
    [sym_quasiquote] = STATE(3383),
    [sym_integer] = STATE(3269),
    [sym__plist] = STATE(3357),
    [sym_unit] = STATE(3383),
    [sym_unboxed_unit] = STATE(3383),
    [sym_prefix_tuple] = STATE(3383),
    [sym_prefix_unboxed_tuple] = STATE(3383),
    [sym_prefix_unboxed_sum] = STATE(3383),
    [sym_literal] = STATE(3383),
    [sym__qualified_type] = STATE(3410),
    [sym__qtyconid] = STATE(3354),
    [sym__tycon_arrow] = STATE(3354),
    [sym__qtycon_arrow] = STATE(3354),
    [sym__promoted_tycons_alias] = STATE(3383),
    [sym__promoted_tycons] = STATE(3383),
    [sym__tycon_ticked] = STATE(2469),
    [sym__qtycon_ticked] = STATE(2469),
    [sym__tyconids_ticked] = STATE(2469),
    [sym__promoted_tyconops_alias] = STATE(2469),
    [sym__promoted_tyconops] = STATE(2469),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2469),
    [sym__operator_alias] = STATE(2469),
    [sym__operator_minus] = STATE(2469),
    [sym__varsym_prefix] = STATE(3354),
    [sym__pvarsym] = STATE(3354),
    [sym__qualified_varsym] = STATE(2465),
    [sym__qvarsym_prefix] = STATE(3354),
    [sym__pqvarsym] = STATE(3354),
    [sym_constructor_operator] = STATE(2469),
    [sym__constructor_operator_alias] = STATE(2469),
    [sym__consym_prefix] = STATE(3354),
    [sym__pconsym] = STATE(3354),
    [sym__qualified_consym] = STATE(2571),
    [sym__qconsym_prefix] = STATE(3354),
    [sym__pqconsym] = STATE(3354),
    [sym__prefix_at] = STATE(2638),
    [sym__paren_open] = STATE(464),
    [sym__bracket_open] = STATE(1079),
    [sym__unboxed_open] = STATE(805),
    [sym_variable] = ACTIONS(1609),
    [anon_sym_let] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(1613),
    [anon_sym_STAR] = ACTIONS(1615),
    [anon_sym_u2605] = ACTIONS(1617),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1157),
    [anon_sym_PIPE] = ACTIONS(1159),
    [anon_sym_BSLASH] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_mdo] = ACTIONS(1159),
    [anon_sym_do] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1157),
    [sym_float] = ACTIONS(1619),
    [sym_char] = ACTIONS(1619),
    [sym_string] = ACTIONS(1619),
    [sym__integer_literal] = ACTIONS(1621),
    [sym__binary_literal] = ACTIONS(1623),
    [sym__octal_literal] = ACTIONS(1623),
    [sym__hex_literal] = ACTIONS(1623),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [anon_sym_PIPE2] = ACTIONS(1157),
    [sym_implicit_variable] = ACTIONS(1157),
    [sym_name] = ACTIONS(1625),
    [sym_label] = ACTIONS(1157),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1157),
    [anon_sym_u22b8] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(1157),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1627),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1157),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1157),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__cond_minus] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [483] = {
    [sym__type_parens] = STATE(3294),
    [sym__type_tuple] = STATE(3295),
    [sym__type_unboxed_tuple] = STATE(3296),
    [sym__type_unboxed_sum] = STATE(3298),
    [sym__type_list] = STATE(3311),
    [sym__type_promoted] = STATE(3292),
    [sym__type_star] = STATE(3292),
    [sym__type_wildcard] = STATE(3292),
    [sym__at_type] = STATE(3341),
    [sym__type_apply] = STATE(3313),
    [sym__type_infix] = STATE(3314),
    [sym_type] = STATE(498),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8499),
    [sym__splice_dollars] = STATE(7231),
    [sym_splice] = STATE(3292),
    [sym_quasiquote] = STATE(3292),
    [sym_integer] = STATE(3286),
    [sym__plist] = STATE(3318),
    [sym_unit] = STATE(3292),
    [sym_unboxed_unit] = STATE(3292),
    [sym_prefix_tuple] = STATE(3292),
    [sym_prefix_unboxed_tuple] = STATE(3292),
    [sym_prefix_unboxed_sum] = STATE(3292),
    [sym_literal] = STATE(3292),
    [sym__qualified_type] = STATE(3249),
    [sym__qtyconid] = STATE(3320),
    [sym__tycon_arrow] = STATE(3320),
    [sym__qtycon_arrow] = STATE(3320),
    [sym__promoted_tycons_alias] = STATE(3292),
    [sym__promoted_tycons] = STATE(3292),
    [sym__tycon_ticked] = STATE(2412),
    [sym__qtycon_ticked] = STATE(2412),
    [sym__tyconids_ticked] = STATE(2412),
    [sym__promoted_tyconops_alias] = STATE(2412),
    [sym__promoted_tyconops] = STATE(2412),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2412),
    [sym__operator_alias] = STATE(2412),
    [sym__operator_minus] = STATE(2412),
    [sym__varsym_prefix] = STATE(3320),
    [sym__pvarsym] = STATE(3320),
    [sym__qualified_varsym] = STATE(2409),
    [sym__qvarsym_prefix] = STATE(3320),
    [sym__pqvarsym] = STATE(3320),
    [sym_constructor_operator] = STATE(2412),
    [sym__constructor_operator_alias] = STATE(2412),
    [sym__consym_prefix] = STATE(3320),
    [sym__pconsym] = STATE(3320),
    [sym__qualified_consym] = STATE(2408),
    [sym__qconsym_prefix] = STATE(3320),
    [sym__pqconsym] = STATE(3320),
    [sym__prefix_at] = STATE(2685),
    [sym__paren_open] = STATE(458),
    [sym__bracket_open] = STATE(1120),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = ACTIONS(1589),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1591),
    [anon_sym_SQUOTE] = ACTIONS(1593),
    [anon_sym_STAR] = ACTIONS(1595),
    [anon_sym_u2605] = ACTIONS(1597),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_by] = ACTIONS(1183),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(1599),
    [sym_char] = ACTIONS(1599),
    [sym_string] = ACTIONS(1599),
    [sym__integer_literal] = ACTIONS(1601),
    [sym__binary_literal] = ACTIONS(1603),
    [sym__octal_literal] = ACTIONS(1603),
    [sym__hex_literal] = ACTIONS(1603),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1605),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1607),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [484] = {
    [sym__type_parens] = STATE(3379),
    [sym__type_tuple] = STATE(3377),
    [sym__type_unboxed_tuple] = STATE(3370),
    [sym__type_unboxed_sum] = STATE(3369),
    [sym__type_list] = STATE(3361),
    [sym__type_promoted] = STATE(3383),
    [sym__type_star] = STATE(3383),
    [sym__type_wildcard] = STATE(3383),
    [sym__at_type] = STATE(3343),
    [sym__type_apply] = STATE(3359),
    [sym__type_infix] = STATE(3358),
    [sym_type] = STATE(481),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8433),
    [sym__splice_dollars] = STATE(7460),
    [sym_splice] = STATE(3383),
    [sym_quasiquote] = STATE(3383),
    [sym_integer] = STATE(3269),
    [sym__plist] = STATE(3357),
    [sym_unit] = STATE(3383),
    [sym_unboxed_unit] = STATE(3383),
    [sym_prefix_tuple] = STATE(3383),
    [sym_prefix_unboxed_tuple] = STATE(3383),
    [sym_prefix_unboxed_sum] = STATE(3383),
    [sym_literal] = STATE(3383),
    [sym__qualified_type] = STATE(3410),
    [sym__qtyconid] = STATE(3354),
    [sym__tycon_arrow] = STATE(3354),
    [sym__qtycon_arrow] = STATE(3354),
    [sym__promoted_tycons_alias] = STATE(3383),
    [sym__promoted_tycons] = STATE(3383),
    [sym__tycon_ticked] = STATE(2469),
    [sym__qtycon_ticked] = STATE(2469),
    [sym__tyconids_ticked] = STATE(2469),
    [sym__promoted_tyconops_alias] = STATE(2469),
    [sym__promoted_tyconops] = STATE(2469),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2469),
    [sym__operator_alias] = STATE(2469),
    [sym__operator_minus] = STATE(2469),
    [sym__varsym_prefix] = STATE(3354),
    [sym__pvarsym] = STATE(3354),
    [sym__qualified_varsym] = STATE(2465),
    [sym__qvarsym_prefix] = STATE(3354),
    [sym__pqvarsym] = STATE(3354),
    [sym_constructor_operator] = STATE(2469),
    [sym__constructor_operator_alias] = STATE(2469),
    [sym__consym_prefix] = STATE(3354),
    [sym__pconsym] = STATE(3354),
    [sym__qualified_consym] = STATE(2571),
    [sym__qconsym_prefix] = STATE(3354),
    [sym__pqconsym] = STATE(3354),
    [sym__prefix_at] = STATE(2638),
    [sym__paren_open] = STATE(464),
    [sym__bracket_open] = STATE(1079),
    [sym__unboxed_open] = STATE(805),
    [sym_variable] = ACTIONS(1609),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(1613),
    [anon_sym_STAR] = ACTIONS(1615),
    [anon_sym_u2605] = ACTIONS(1617),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(1619),
    [sym_char] = ACTIONS(1619),
    [sym_string] = ACTIONS(1619),
    [sym__integer_literal] = ACTIONS(1621),
    [sym__binary_literal] = ACTIONS(1623),
    [sym__octal_literal] = ACTIONS(1623),
    [sym__hex_literal] = ACTIONS(1623),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [anon_sym_PIPE2] = ACTIONS(1181),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1625),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1627),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [485] = {
    [sym__type_parens] = STATE(3294),
    [sym__type_tuple] = STATE(3295),
    [sym__type_unboxed_tuple] = STATE(3296),
    [sym__type_unboxed_sum] = STATE(3298),
    [sym__type_list] = STATE(3311),
    [sym__type_promoted] = STATE(3292),
    [sym__type_star] = STATE(3292),
    [sym__type_wildcard] = STATE(3292),
    [sym__at_type] = STATE(3341),
    [sym__type_apply] = STATE(3313),
    [sym__type_infix] = STATE(3314),
    [sym_type] = STATE(498),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8499),
    [sym__splice_dollars] = STATE(7231),
    [sym_splice] = STATE(3292),
    [sym_quasiquote] = STATE(3292),
    [sym_integer] = STATE(3286),
    [sym__plist] = STATE(3318),
    [sym_unit] = STATE(3292),
    [sym_unboxed_unit] = STATE(3292),
    [sym_prefix_tuple] = STATE(3292),
    [sym_prefix_unboxed_tuple] = STATE(3292),
    [sym_prefix_unboxed_sum] = STATE(3292),
    [sym_literal] = STATE(3292),
    [sym__qualified_type] = STATE(3249),
    [sym__qtyconid] = STATE(3320),
    [sym__tycon_arrow] = STATE(3320),
    [sym__qtycon_arrow] = STATE(3320),
    [sym__promoted_tycons_alias] = STATE(3292),
    [sym__promoted_tycons] = STATE(3292),
    [sym__tycon_ticked] = STATE(2412),
    [sym__qtycon_ticked] = STATE(2412),
    [sym__tyconids_ticked] = STATE(2412),
    [sym__promoted_tyconops_alias] = STATE(2412),
    [sym__promoted_tyconops] = STATE(2412),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2412),
    [sym__operator_alias] = STATE(2412),
    [sym__operator_minus] = STATE(2412),
    [sym__varsym_prefix] = STATE(3320),
    [sym__pvarsym] = STATE(3320),
    [sym__qualified_varsym] = STATE(2409),
    [sym__qvarsym_prefix] = STATE(3320),
    [sym__pqvarsym] = STATE(3320),
    [sym_constructor_operator] = STATE(2412),
    [sym__constructor_operator_alias] = STATE(2412),
    [sym__consym_prefix] = STATE(3320),
    [sym__pconsym] = STATE(3320),
    [sym__qualified_consym] = STATE(2408),
    [sym__qconsym_prefix] = STATE(3320),
    [sym__pqconsym] = STATE(3320),
    [sym__prefix_at] = STATE(2685),
    [sym__paren_open] = STATE(458),
    [sym__bracket_open] = STATE(1120),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = ACTIONS(1589),
    [anon_sym_let] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1591),
    [anon_sym_SQUOTE] = ACTIONS(1593),
    [anon_sym_STAR] = ACTIONS(1595),
    [anon_sym_u2605] = ACTIONS(1597),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1157),
    [anon_sym_by] = ACTIONS(1159),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_BSLASH] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_mdo] = ACTIONS(1159),
    [anon_sym_do] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1157),
    [sym_float] = ACTIONS(1599),
    [sym_char] = ACTIONS(1599),
    [sym_string] = ACTIONS(1599),
    [sym__integer_literal] = ACTIONS(1601),
    [sym__binary_literal] = ACTIONS(1603),
    [sym__octal_literal] = ACTIONS(1603),
    [sym__hex_literal] = ACTIONS(1603),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1157),
    [sym_name] = ACTIONS(1605),
    [sym_label] = ACTIONS(1157),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1157),
    [anon_sym_u22b8] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1157),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1607),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1157),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1157),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__cond_minus] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [486] = {
    [sym__type_parens] = STATE(3379),
    [sym__type_tuple] = STATE(3377),
    [sym__type_unboxed_tuple] = STATE(3370),
    [sym__type_unboxed_sum] = STATE(3369),
    [sym__type_list] = STATE(3361),
    [sym__type_promoted] = STATE(3383),
    [sym__type_star] = STATE(3383),
    [sym__type_wildcard] = STATE(3383),
    [sym__at_type] = STATE(3343),
    [sym__type_apply] = STATE(3359),
    [sym__type_infix] = STATE(3358),
    [sym_type] = STATE(481),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8433),
    [sym__splice_dollars] = STATE(7460),
    [sym_splice] = STATE(3383),
    [sym_quasiquote] = STATE(3383),
    [sym_integer] = STATE(3269),
    [sym__plist] = STATE(3357),
    [sym_unit] = STATE(3383),
    [sym_unboxed_unit] = STATE(3383),
    [sym_prefix_tuple] = STATE(3383),
    [sym_prefix_unboxed_tuple] = STATE(3383),
    [sym_prefix_unboxed_sum] = STATE(3383),
    [sym_literal] = STATE(3383),
    [sym__qualified_type] = STATE(3410),
    [sym__qtyconid] = STATE(3354),
    [sym__tycon_arrow] = STATE(3354),
    [sym__qtycon_arrow] = STATE(3354),
    [sym__promoted_tycons_alias] = STATE(3383),
    [sym__promoted_tycons] = STATE(3383),
    [sym__tycon_ticked] = STATE(2469),
    [sym__qtycon_ticked] = STATE(2469),
    [sym__tyconids_ticked] = STATE(2469),
    [sym__promoted_tyconops_alias] = STATE(2469),
    [sym__promoted_tyconops] = STATE(2469),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2469),
    [sym__operator_alias] = STATE(2469),
    [sym__operator_minus] = STATE(2469),
    [sym__varsym_prefix] = STATE(3354),
    [sym__pvarsym] = STATE(3354),
    [sym__qualified_varsym] = STATE(2465),
    [sym__qvarsym_prefix] = STATE(3354),
    [sym__pqvarsym] = STATE(3354),
    [sym_constructor_operator] = STATE(2469),
    [sym__constructor_operator_alias] = STATE(2469),
    [sym__consym_prefix] = STATE(3354),
    [sym__pconsym] = STATE(3354),
    [sym__qualified_consym] = STATE(2571),
    [sym__qconsym_prefix] = STATE(3354),
    [sym__pqconsym] = STATE(3354),
    [sym__prefix_at] = STATE(2638),
    [sym__paren_open] = STATE(464),
    [sym__bracket_open] = STATE(1079),
    [sym__unboxed_open] = STATE(805),
    [sym_variable] = ACTIONS(1609),
    [anon_sym_let] = ACTIONS(1125),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym__] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(1613),
    [anon_sym_STAR] = ACTIONS(1615),
    [anon_sym_u2605] = ACTIONS(1617),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1125),
    [anon_sym_BSLASH] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1125),
    [anon_sym_mdo] = ACTIONS(1125),
    [anon_sym_do] = ACTIONS(1125),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1123),
    [sym_float] = ACTIONS(1619),
    [sym_char] = ACTIONS(1619),
    [sym_string] = ACTIONS(1619),
    [sym__integer_literal] = ACTIONS(1621),
    [sym__binary_literal] = ACTIONS(1623),
    [sym__octal_literal] = ACTIONS(1623),
    [sym__hex_literal] = ACTIONS(1623),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [anon_sym_PIPE2] = ACTIONS(1123),
    [sym_implicit_variable] = ACTIONS(1123),
    [sym_name] = ACTIONS(1625),
    [sym_label] = ACTIONS(1123),
    [anon_sym_u2192] = ACTIONS(1123),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1123),
    [anon_sym_u22b8] = ACTIONS(1123),
    [anon_sym_COLON_COLON] = ACTIONS(1123),
    [anon_sym_u2237] = ACTIONS(1123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(1123),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1627),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1123),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1123),
    [sym__cond_qualified_op] = ACTIONS(1123),
    [sym__cond_no_section_op] = ACTIONS(1123),
    [sym__cond_minus] = ACTIONS(1123),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [487] = {
    [sym__type_parens] = STATE(3217),
    [sym__type_tuple] = STATE(3215),
    [sym__type_unboxed_tuple] = STATE(3214),
    [sym__type_unboxed_sum] = STATE(3209),
    [sym__type_list] = STATE(3198),
    [sym__type_promoted] = STATE(3219),
    [sym__type_star] = STATE(3219),
    [sym__type_wildcard] = STATE(3219),
    [sym__at_type] = STATE(3241),
    [sym__type_apply] = STATE(3195),
    [sym__type_infix] = STATE(3189),
    [sym_type] = STATE(487),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8524),
    [sym__splice_dollars] = STATE(7385),
    [sym_splice] = STATE(3219),
    [sym_quasiquote] = STATE(3219),
    [sym_integer] = STATE(3330),
    [sym__plist] = STATE(3185),
    [sym_unit] = STATE(3219),
    [sym_unboxed_unit] = STATE(3219),
    [sym_prefix_tuple] = STATE(3219),
    [sym_prefix_unboxed_tuple] = STATE(3219),
    [sym_prefix_unboxed_sum] = STATE(3219),
    [sym_literal] = STATE(3219),
    [sym__qualified_type] = STATE(3420),
    [sym__qtyconid] = STATE(3183),
    [sym__tycon_arrow] = STATE(3183),
    [sym__qtycon_arrow] = STATE(3183),
    [sym__promoted_tycons_alias] = STATE(3219),
    [sym__promoted_tycons] = STATE(3219),
    [sym__tycon_ticked] = STATE(2661),
    [sym__qtycon_ticked] = STATE(2661),
    [sym__tyconids_ticked] = STATE(2661),
    [sym__promoted_tyconops_alias] = STATE(2661),
    [sym__promoted_tyconops] = STATE(2661),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2661),
    [sym__operator_alias] = STATE(2661),
    [sym__operator_minus] = STATE(2661),
    [sym__varsym_prefix] = STATE(3183),
    [sym__pvarsym] = STATE(3183),
    [sym__qualified_varsym] = STATE(2662),
    [sym__qvarsym_prefix] = STATE(3183),
    [sym__pqvarsym] = STATE(3183),
    [sym_constructor_operator] = STATE(2661),
    [sym__constructor_operator_alias] = STATE(2661),
    [sym__consym_prefix] = STATE(3183),
    [sym__pconsym] = STATE(3183),
    [sym__qualified_consym] = STATE(2647),
    [sym__qconsym_prefix] = STATE(3183),
    [sym__pqconsym] = STATE(3183),
    [sym__prefix_at] = STATE(2407),
    [sym__paren_open] = STATE(447),
    [sym__bracket_open] = STATE(976),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1119),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_mdo] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_u27e6] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1117),
    [sym_implicit_variable] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [sym_label] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1119),
    [anon_sym_u22b8] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1119),
    [sym__cond_layout_end] = ACTIONS(1119),
    [sym__cond_layout_end_explicit] = ACTIONS(1119),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_tight_dot] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_prefix_percent] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__cond_minus] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [488] = {
    [sym__type_parens] = STATE(3220),
    [sym__type_tuple] = STATE(3210),
    [sym__type_unboxed_tuple] = STATE(3184),
    [sym__type_unboxed_sum] = STATE(3188),
    [sym__type_list] = STATE(3211),
    [sym__type_promoted] = STATE(3364),
    [sym__type_star] = STATE(3364),
    [sym__type_wildcard] = STATE(3364),
    [sym__at_type] = STATE(3352),
    [sym__type_apply] = STATE(3196),
    [sym__type_infix] = STATE(3225),
    [sym_type] = STATE(496),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8421),
    [sym__splice_dollars] = STATE(7401),
    [sym_splice] = STATE(3364),
    [sym_quasiquote] = STATE(3364),
    [sym_integer] = STATE(3397),
    [sym__plist] = STATE(3177),
    [sym_unit] = STATE(3364),
    [sym_unboxed_unit] = STATE(3364),
    [sym_prefix_tuple] = STATE(3364),
    [sym_prefix_unboxed_tuple] = STATE(3364),
    [sym_prefix_unboxed_sum] = STATE(3364),
    [sym_literal] = STATE(3364),
    [sym__qualified_type] = STATE(3262),
    [sym__qtyconid] = STATE(3232),
    [sym__tycon_arrow] = STATE(3232),
    [sym__qtycon_arrow] = STATE(3232),
    [sym__promoted_tycons_alias] = STATE(3364),
    [sym__promoted_tycons] = STATE(3364),
    [sym__tycon_ticked] = STATE(2496),
    [sym__qtycon_ticked] = STATE(2496),
    [sym__tyconids_ticked] = STATE(2496),
    [sym__promoted_tyconops_alias] = STATE(2496),
    [sym__promoted_tyconops] = STATE(2496),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2496),
    [sym__operator_alias] = STATE(2496),
    [sym__operator_minus] = STATE(2496),
    [sym__varsym_prefix] = STATE(3232),
    [sym__pvarsym] = STATE(3232),
    [sym__qualified_varsym] = STATE(2494),
    [sym__qvarsym_prefix] = STATE(3232),
    [sym__pqvarsym] = STATE(3232),
    [sym_constructor_operator] = STATE(2496),
    [sym__constructor_operator_alias] = STATE(2496),
    [sym__consym_prefix] = STATE(3232),
    [sym__pconsym] = STATE(3232),
    [sym__qualified_consym] = STATE(2492),
    [sym__qconsym_prefix] = STATE(3232),
    [sym__pqconsym] = STATE(3232),
    [sym__prefix_at] = STATE(2625),
    [sym__paren_open] = STATE(466),
    [sym__bracket_open] = STATE(1073),
    [sym__unboxed_open] = STATE(781),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1179),
    [anon_sym_u22b8] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_RBRACK] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_dotdot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_prefix_percent] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [489] = {
    [sym__type_parens] = STATE(3217),
    [sym__type_tuple] = STATE(3215),
    [sym__type_unboxed_tuple] = STATE(3214),
    [sym__type_unboxed_sum] = STATE(3209),
    [sym__type_list] = STATE(3198),
    [sym__type_promoted] = STATE(3219),
    [sym__type_star] = STATE(3219),
    [sym__type_wildcard] = STATE(3219),
    [sym__at_type] = STATE(3241),
    [sym__type_apply] = STATE(3195),
    [sym__type_infix] = STATE(3189),
    [sym_type] = STATE(487),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8524),
    [sym__splice_dollars] = STATE(7385),
    [sym_splice] = STATE(3219),
    [sym_quasiquote] = STATE(3219),
    [sym_integer] = STATE(3330),
    [sym__plist] = STATE(3185),
    [sym_unit] = STATE(3219),
    [sym_unboxed_unit] = STATE(3219),
    [sym_prefix_tuple] = STATE(3219),
    [sym_prefix_unboxed_tuple] = STATE(3219),
    [sym_prefix_unboxed_sum] = STATE(3219),
    [sym_literal] = STATE(3219),
    [sym__qualified_type] = STATE(3420),
    [sym__qtyconid] = STATE(3183),
    [sym__tycon_arrow] = STATE(3183),
    [sym__qtycon_arrow] = STATE(3183),
    [sym__promoted_tycons_alias] = STATE(3219),
    [sym__promoted_tycons] = STATE(3219),
    [sym__tycon_ticked] = STATE(2661),
    [sym__qtycon_ticked] = STATE(2661),
    [sym__tyconids_ticked] = STATE(2661),
    [sym__promoted_tyconops_alias] = STATE(2661),
    [sym__promoted_tyconops] = STATE(2661),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2661),
    [sym__operator_alias] = STATE(2661),
    [sym__operator_minus] = STATE(2661),
    [sym__varsym_prefix] = STATE(3183),
    [sym__pvarsym] = STATE(3183),
    [sym__qualified_varsym] = STATE(2662),
    [sym__qvarsym_prefix] = STATE(3183),
    [sym__pqvarsym] = STATE(3183),
    [sym_constructor_operator] = STATE(2661),
    [sym__constructor_operator_alias] = STATE(2661),
    [sym__consym_prefix] = STATE(3183),
    [sym__pconsym] = STATE(3183),
    [sym__qualified_consym] = STATE(2647),
    [sym__qconsym_prefix] = STATE(3183),
    [sym__pqconsym] = STATE(3183),
    [sym__prefix_at] = STATE(2407),
    [sym__paren_open] = STATE(447),
    [sym__bracket_open] = STATE(976),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = ACTIONS(1629),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym_let] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1631),
    [anon_sym_SQUOTE] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1635),
    [anon_sym_u2605] = ACTIONS(1637),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1157),
    [anon_sym_BSLASH] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_mdo] = ACTIONS(1159),
    [anon_sym_do] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1157),
    [sym_float] = ACTIONS(1639),
    [sym_char] = ACTIONS(1639),
    [sym_string] = ACTIONS(1639),
    [sym__integer_literal] = ACTIONS(1641),
    [sym__binary_literal] = ACTIONS(1643),
    [sym__octal_literal] = ACTIONS(1643),
    [sym__hex_literal] = ACTIONS(1643),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1157),
    [sym_name] = ACTIONS(1645),
    [sym_label] = ACTIONS(1157),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1157),
    [anon_sym_u22b8] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1157),
    [sym__cond_layout_end] = ACTIONS(1157),
    [sym__cond_layout_end_explicit] = ACTIONS(1157),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1647),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1157),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1157),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__cond_minus] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [490] = {
    [sym__type_parens] = STATE(3217),
    [sym__type_tuple] = STATE(3215),
    [sym__type_unboxed_tuple] = STATE(3214),
    [sym__type_unboxed_sum] = STATE(3209),
    [sym__type_list] = STATE(3198),
    [sym__type_promoted] = STATE(3219),
    [sym__type_star] = STATE(3219),
    [sym__type_wildcard] = STATE(3219),
    [sym__at_type] = STATE(3241),
    [sym__type_apply] = STATE(3195),
    [sym__type_infix] = STATE(3189),
    [sym_type] = STATE(487),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8524),
    [sym__splice_dollars] = STATE(7385),
    [sym_splice] = STATE(3219),
    [sym_quasiquote] = STATE(3219),
    [sym_integer] = STATE(3330),
    [sym__plist] = STATE(3185),
    [sym_unit] = STATE(3219),
    [sym_unboxed_unit] = STATE(3219),
    [sym_prefix_tuple] = STATE(3219),
    [sym_prefix_unboxed_tuple] = STATE(3219),
    [sym_prefix_unboxed_sum] = STATE(3219),
    [sym_literal] = STATE(3219),
    [sym__qualified_type] = STATE(3420),
    [sym__qtyconid] = STATE(3183),
    [sym__tycon_arrow] = STATE(3183),
    [sym__qtycon_arrow] = STATE(3183),
    [sym__promoted_tycons_alias] = STATE(3219),
    [sym__promoted_tycons] = STATE(3219),
    [sym__tycon_ticked] = STATE(2661),
    [sym__qtycon_ticked] = STATE(2661),
    [sym__tyconids_ticked] = STATE(2661),
    [sym__promoted_tyconops_alias] = STATE(2661),
    [sym__promoted_tyconops] = STATE(2661),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2661),
    [sym__operator_alias] = STATE(2661),
    [sym__operator_minus] = STATE(2661),
    [sym__varsym_prefix] = STATE(3183),
    [sym__pvarsym] = STATE(3183),
    [sym__qualified_varsym] = STATE(2662),
    [sym__qvarsym_prefix] = STATE(3183),
    [sym__pqvarsym] = STATE(3183),
    [sym_constructor_operator] = STATE(2661),
    [sym__constructor_operator_alias] = STATE(2661),
    [sym__consym_prefix] = STATE(3183),
    [sym__pconsym] = STATE(3183),
    [sym__qualified_consym] = STATE(2647),
    [sym__qconsym_prefix] = STATE(3183),
    [sym__pqconsym] = STATE(3183),
    [sym__prefix_at] = STATE(2407),
    [sym__paren_open] = STATE(447),
    [sym__bracket_open] = STATE(976),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = ACTIONS(1629),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1631),
    [anon_sym_SQUOTE] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1635),
    [anon_sym_u2605] = ACTIONS(1637),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(1639),
    [sym_char] = ACTIONS(1639),
    [sym_string] = ACTIONS(1639),
    [sym__integer_literal] = ACTIONS(1641),
    [sym__binary_literal] = ACTIONS(1643),
    [sym__octal_literal] = ACTIONS(1643),
    [sym__hex_literal] = ACTIONS(1643),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1645),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1647),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [491] = {
    [sym__type_parens] = STATE(3217),
    [sym__type_tuple] = STATE(3215),
    [sym__type_unboxed_tuple] = STATE(3214),
    [sym__type_unboxed_sum] = STATE(3209),
    [sym__type_list] = STATE(3198),
    [sym__type_promoted] = STATE(3219),
    [sym__type_star] = STATE(3219),
    [sym__type_wildcard] = STATE(3219),
    [sym__at_type] = STATE(3241),
    [sym__type_apply] = STATE(3195),
    [sym__type_infix] = STATE(3189),
    [sym_type] = STATE(487),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8524),
    [sym__splice_dollars] = STATE(7385),
    [sym_splice] = STATE(3219),
    [sym_quasiquote] = STATE(3219),
    [sym_integer] = STATE(3330),
    [sym__plist] = STATE(3185),
    [sym_unit] = STATE(3219),
    [sym_unboxed_unit] = STATE(3219),
    [sym_prefix_tuple] = STATE(3219),
    [sym_prefix_unboxed_tuple] = STATE(3219),
    [sym_prefix_unboxed_sum] = STATE(3219),
    [sym_literal] = STATE(3219),
    [sym__qualified_type] = STATE(3420),
    [sym__qtyconid] = STATE(3183),
    [sym__tycon_arrow] = STATE(3183),
    [sym__qtycon_arrow] = STATE(3183),
    [sym__promoted_tycons_alias] = STATE(3219),
    [sym__promoted_tycons] = STATE(3219),
    [sym__tycon_ticked] = STATE(2661),
    [sym__qtycon_ticked] = STATE(2661),
    [sym__tyconids_ticked] = STATE(2661),
    [sym__promoted_tyconops_alias] = STATE(2661),
    [sym__promoted_tyconops] = STATE(2661),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2661),
    [sym__operator_alias] = STATE(2661),
    [sym__operator_minus] = STATE(2661),
    [sym__varsym_prefix] = STATE(3183),
    [sym__pvarsym] = STATE(3183),
    [sym__qualified_varsym] = STATE(2662),
    [sym__qvarsym_prefix] = STATE(3183),
    [sym__pqvarsym] = STATE(3183),
    [sym_constructor_operator] = STATE(2661),
    [sym__constructor_operator_alias] = STATE(2661),
    [sym__consym_prefix] = STATE(3183),
    [sym__pconsym] = STATE(3183),
    [sym__qualified_consym] = STATE(2647),
    [sym__qconsym_prefix] = STATE(3183),
    [sym__pqconsym] = STATE(3183),
    [sym__prefix_at] = STATE(2407),
    [sym__paren_open] = STATE(447),
    [sym__bracket_open] = STATE(976),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = ACTIONS(1629),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1631),
    [anon_sym_SQUOTE] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1635),
    [anon_sym_u2605] = ACTIONS(1637),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(1639),
    [sym_char] = ACTIONS(1639),
    [sym_string] = ACTIONS(1639),
    [sym__integer_literal] = ACTIONS(1641),
    [sym__binary_literal] = ACTIONS(1643),
    [sym__octal_literal] = ACTIONS(1643),
    [sym__hex_literal] = ACTIONS(1643),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1645),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1647),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [492] = {
    [sym__type_parens] = STATE(3379),
    [sym__type_tuple] = STATE(3377),
    [sym__type_unboxed_tuple] = STATE(3370),
    [sym__type_unboxed_sum] = STATE(3369),
    [sym__type_list] = STATE(3361),
    [sym__type_promoted] = STATE(3383),
    [sym__type_star] = STATE(3383),
    [sym__type_wildcard] = STATE(3383),
    [sym__at_type] = STATE(3343),
    [sym__type_apply] = STATE(3359),
    [sym__type_infix] = STATE(3358),
    [sym_type] = STATE(481),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8433),
    [sym__splice_dollars] = STATE(7460),
    [sym_splice] = STATE(3383),
    [sym_quasiquote] = STATE(3383),
    [sym_integer] = STATE(3269),
    [sym__plist] = STATE(3357),
    [sym_unit] = STATE(3383),
    [sym_unboxed_unit] = STATE(3383),
    [sym_prefix_tuple] = STATE(3383),
    [sym_prefix_unboxed_tuple] = STATE(3383),
    [sym_prefix_unboxed_sum] = STATE(3383),
    [sym_literal] = STATE(3383),
    [sym__qualified_type] = STATE(3410),
    [sym__qtyconid] = STATE(3354),
    [sym__tycon_arrow] = STATE(3354),
    [sym__qtycon_arrow] = STATE(3354),
    [sym__promoted_tycons_alias] = STATE(3383),
    [sym__promoted_tycons] = STATE(3383),
    [sym__tycon_ticked] = STATE(2469),
    [sym__qtycon_ticked] = STATE(2469),
    [sym__tyconids_ticked] = STATE(2469),
    [sym__promoted_tyconops_alias] = STATE(2469),
    [sym__promoted_tyconops] = STATE(2469),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2469),
    [sym__operator_alias] = STATE(2469),
    [sym__operator_minus] = STATE(2469),
    [sym__varsym_prefix] = STATE(3354),
    [sym__pvarsym] = STATE(3354),
    [sym__qualified_varsym] = STATE(2465),
    [sym__qvarsym_prefix] = STATE(3354),
    [sym__pqvarsym] = STATE(3354),
    [sym_constructor_operator] = STATE(2469),
    [sym__constructor_operator_alias] = STATE(2469),
    [sym__consym_prefix] = STATE(3354),
    [sym__pconsym] = STATE(3354),
    [sym__qualified_consym] = STATE(2571),
    [sym__qconsym_prefix] = STATE(3354),
    [sym__pqconsym] = STATE(3354),
    [sym__prefix_at] = STATE(2638),
    [sym__paren_open] = STATE(464),
    [sym__bracket_open] = STATE(1079),
    [sym__unboxed_open] = STATE(805),
    [sym_variable] = ACTIONS(1609),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(1613),
    [anon_sym_STAR] = ACTIONS(1615),
    [anon_sym_u2605] = ACTIONS(1617),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(1619),
    [sym_char] = ACTIONS(1619),
    [sym_string] = ACTIONS(1619),
    [sym__integer_literal] = ACTIONS(1621),
    [sym__binary_literal] = ACTIONS(1623),
    [sym__octal_literal] = ACTIONS(1623),
    [sym__hex_literal] = ACTIONS(1623),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [anon_sym_PIPE2] = ACTIONS(1181),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1625),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1627),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [493] = {
    [sym__type_parens] = STATE(3220),
    [sym__type_tuple] = STATE(3210),
    [sym__type_unboxed_tuple] = STATE(3184),
    [sym__type_unboxed_sum] = STATE(3188),
    [sym__type_list] = STATE(3211),
    [sym__type_promoted] = STATE(3364),
    [sym__type_star] = STATE(3364),
    [sym__type_wildcard] = STATE(3364),
    [sym__at_type] = STATE(3352),
    [sym__type_apply] = STATE(3196),
    [sym__type_infix] = STATE(3225),
    [sym_type] = STATE(496),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8421),
    [sym__splice_dollars] = STATE(7401),
    [sym_splice] = STATE(3364),
    [sym_quasiquote] = STATE(3364),
    [sym_integer] = STATE(3397),
    [sym__plist] = STATE(3177),
    [sym_unit] = STATE(3364),
    [sym_unboxed_unit] = STATE(3364),
    [sym_prefix_tuple] = STATE(3364),
    [sym_prefix_unboxed_tuple] = STATE(3364),
    [sym_prefix_unboxed_sum] = STATE(3364),
    [sym_literal] = STATE(3364),
    [sym__qualified_type] = STATE(3262),
    [sym__qtyconid] = STATE(3232),
    [sym__tycon_arrow] = STATE(3232),
    [sym__qtycon_arrow] = STATE(3232),
    [sym__promoted_tycons_alias] = STATE(3364),
    [sym__promoted_tycons] = STATE(3364),
    [sym__tycon_ticked] = STATE(2496),
    [sym__qtycon_ticked] = STATE(2496),
    [sym__tyconids_ticked] = STATE(2496),
    [sym__promoted_tyconops_alias] = STATE(2496),
    [sym__promoted_tyconops] = STATE(2496),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2496),
    [sym__operator_alias] = STATE(2496),
    [sym__operator_minus] = STATE(2496),
    [sym__varsym_prefix] = STATE(3232),
    [sym__pvarsym] = STATE(3232),
    [sym__qualified_varsym] = STATE(2494),
    [sym__qvarsym_prefix] = STATE(3232),
    [sym__pqvarsym] = STATE(3232),
    [sym_constructor_operator] = STATE(2496),
    [sym__constructor_operator_alias] = STATE(2496),
    [sym__consym_prefix] = STATE(3232),
    [sym__pconsym] = STATE(3232),
    [sym__qualified_consym] = STATE(2492),
    [sym__qconsym_prefix] = STATE(3232),
    [sym__pqconsym] = STATE(3232),
    [sym__prefix_at] = STATE(2625),
    [sym__paren_open] = STATE(466),
    [sym__bracket_open] = STATE(1073),
    [sym__unboxed_open] = STATE(781),
    [sym_variable] = ACTIONS(1569),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_u2605] = ACTIONS(1577),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(1579),
    [sym_char] = ACTIONS(1579),
    [sym_string] = ACTIONS(1579),
    [sym__integer_literal] = ACTIONS(1581),
    [sym__binary_literal] = ACTIONS(1583),
    [sym__octal_literal] = ACTIONS(1583),
    [sym__hex_literal] = ACTIONS(1583),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1585),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1587),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_dotdot] = ACTIONS(1181),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [494] = {
    [sym__type_parens] = STATE(3217),
    [sym__type_tuple] = STATE(3215),
    [sym__type_unboxed_tuple] = STATE(3214),
    [sym__type_unboxed_sum] = STATE(3209),
    [sym__type_list] = STATE(3198),
    [sym__type_promoted] = STATE(3219),
    [sym__type_star] = STATE(3219),
    [sym__type_wildcard] = STATE(3219),
    [sym__at_type] = STATE(3241),
    [sym__type_apply] = STATE(3195),
    [sym__type_infix] = STATE(3189),
    [sym_type] = STATE(487),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8524),
    [sym__splice_dollars] = STATE(7385),
    [sym_splice] = STATE(3219),
    [sym_quasiquote] = STATE(3219),
    [sym_integer] = STATE(3330),
    [sym__plist] = STATE(3185),
    [sym_unit] = STATE(3219),
    [sym_unboxed_unit] = STATE(3219),
    [sym_prefix_tuple] = STATE(3219),
    [sym_prefix_unboxed_tuple] = STATE(3219),
    [sym_prefix_unboxed_sum] = STATE(3219),
    [sym_literal] = STATE(3219),
    [sym__qualified_type] = STATE(3420),
    [sym__qtyconid] = STATE(3183),
    [sym__tycon_arrow] = STATE(3183),
    [sym__qtycon_arrow] = STATE(3183),
    [sym__promoted_tycons_alias] = STATE(3219),
    [sym__promoted_tycons] = STATE(3219),
    [sym__tycon_ticked] = STATE(2661),
    [sym__qtycon_ticked] = STATE(2661),
    [sym__tyconids_ticked] = STATE(2661),
    [sym__promoted_tyconops_alias] = STATE(2661),
    [sym__promoted_tyconops] = STATE(2661),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2661),
    [sym__operator_alias] = STATE(2661),
    [sym__operator_minus] = STATE(2661),
    [sym__varsym_prefix] = STATE(3183),
    [sym__pvarsym] = STATE(3183),
    [sym__qualified_varsym] = STATE(2662),
    [sym__qvarsym_prefix] = STATE(3183),
    [sym__pqvarsym] = STATE(3183),
    [sym_constructor_operator] = STATE(2661),
    [sym__constructor_operator_alias] = STATE(2661),
    [sym__consym_prefix] = STATE(3183),
    [sym__pconsym] = STATE(3183),
    [sym__qualified_consym] = STATE(2647),
    [sym__qconsym_prefix] = STATE(3183),
    [sym__pqconsym] = STATE(3183),
    [sym__prefix_at] = STATE(2407),
    [sym__paren_open] = STATE(447),
    [sym__bracket_open] = STATE(976),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1179),
    [anon_sym_u22b8] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_prefix_percent] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [495] = {
    [sym__type_parens] = STATE(3220),
    [sym__type_tuple] = STATE(3210),
    [sym__type_unboxed_tuple] = STATE(3184),
    [sym__type_unboxed_sum] = STATE(3188),
    [sym__type_list] = STATE(3211),
    [sym__type_promoted] = STATE(3364),
    [sym__type_star] = STATE(3364),
    [sym__type_wildcard] = STATE(3364),
    [sym__at_type] = STATE(3352),
    [sym__type_apply] = STATE(3196),
    [sym__type_infix] = STATE(3225),
    [sym_type] = STATE(496),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8421),
    [sym__splice_dollars] = STATE(7401),
    [sym_splice] = STATE(3364),
    [sym_quasiquote] = STATE(3364),
    [sym_integer] = STATE(3397),
    [sym__plist] = STATE(3177),
    [sym_unit] = STATE(3364),
    [sym_unboxed_unit] = STATE(3364),
    [sym_prefix_tuple] = STATE(3364),
    [sym_prefix_unboxed_tuple] = STATE(3364),
    [sym_prefix_unboxed_sum] = STATE(3364),
    [sym_literal] = STATE(3364),
    [sym__qualified_type] = STATE(3262),
    [sym__qtyconid] = STATE(3232),
    [sym__tycon_arrow] = STATE(3232),
    [sym__qtycon_arrow] = STATE(3232),
    [sym__promoted_tycons_alias] = STATE(3364),
    [sym__promoted_tycons] = STATE(3364),
    [sym__tycon_ticked] = STATE(2496),
    [sym__qtycon_ticked] = STATE(2496),
    [sym__tyconids_ticked] = STATE(2496),
    [sym__promoted_tyconops_alias] = STATE(2496),
    [sym__promoted_tyconops] = STATE(2496),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2496),
    [sym__operator_alias] = STATE(2496),
    [sym__operator_minus] = STATE(2496),
    [sym__varsym_prefix] = STATE(3232),
    [sym__pvarsym] = STATE(3232),
    [sym__qualified_varsym] = STATE(2494),
    [sym__qvarsym_prefix] = STATE(3232),
    [sym__pqvarsym] = STATE(3232),
    [sym_constructor_operator] = STATE(2496),
    [sym__constructor_operator_alias] = STATE(2496),
    [sym__consym_prefix] = STATE(3232),
    [sym__pconsym] = STATE(3232),
    [sym__qualified_consym] = STATE(2492),
    [sym__qconsym_prefix] = STATE(3232),
    [sym__pqconsym] = STATE(3232),
    [sym__prefix_at] = STATE(2625),
    [sym__paren_open] = STATE(466),
    [sym__bracket_open] = STATE(1073),
    [sym__unboxed_open] = STATE(781),
    [sym_variable] = ACTIONS(1569),
    [anon_sym_let] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_u2605] = ACTIONS(1577),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1157),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_BSLASH] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_mdo] = ACTIONS(1159),
    [anon_sym_do] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1157),
    [sym_float] = ACTIONS(1579),
    [sym_char] = ACTIONS(1579),
    [sym_string] = ACTIONS(1579),
    [sym__integer_literal] = ACTIONS(1581),
    [sym__binary_literal] = ACTIONS(1583),
    [sym__octal_literal] = ACTIONS(1583),
    [sym__hex_literal] = ACTIONS(1583),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1157),
    [sym_name] = ACTIONS(1585),
    [sym_label] = ACTIONS(1157),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1157),
    [anon_sym_u22b8] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1157),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1587),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1157),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_dotdot] = ACTIONS(1157),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1157),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__cond_minus] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [496] = {
    [sym__type_parens] = STATE(3220),
    [sym__type_tuple] = STATE(3210),
    [sym__type_unboxed_tuple] = STATE(3184),
    [sym__type_unboxed_sum] = STATE(3188),
    [sym__type_list] = STATE(3211),
    [sym__type_promoted] = STATE(3364),
    [sym__type_star] = STATE(3364),
    [sym__type_wildcard] = STATE(3364),
    [sym__at_type] = STATE(3352),
    [sym__type_apply] = STATE(3196),
    [sym__type_infix] = STATE(3225),
    [sym_type] = STATE(496),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8421),
    [sym__splice_dollars] = STATE(7401),
    [sym_splice] = STATE(3364),
    [sym_quasiquote] = STATE(3364),
    [sym_integer] = STATE(3397),
    [sym__plist] = STATE(3177),
    [sym_unit] = STATE(3364),
    [sym_unboxed_unit] = STATE(3364),
    [sym_prefix_tuple] = STATE(3364),
    [sym_prefix_unboxed_tuple] = STATE(3364),
    [sym_prefix_unboxed_sum] = STATE(3364),
    [sym_literal] = STATE(3364),
    [sym__qualified_type] = STATE(3262),
    [sym__qtyconid] = STATE(3232),
    [sym__tycon_arrow] = STATE(3232),
    [sym__qtycon_arrow] = STATE(3232),
    [sym__promoted_tycons_alias] = STATE(3364),
    [sym__promoted_tycons] = STATE(3364),
    [sym__tycon_ticked] = STATE(2496),
    [sym__qtycon_ticked] = STATE(2496),
    [sym__tyconids_ticked] = STATE(2496),
    [sym__promoted_tyconops_alias] = STATE(2496),
    [sym__promoted_tyconops] = STATE(2496),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2496),
    [sym__operator_alias] = STATE(2496),
    [sym__operator_minus] = STATE(2496),
    [sym__varsym_prefix] = STATE(3232),
    [sym__pvarsym] = STATE(3232),
    [sym__qualified_varsym] = STATE(2494),
    [sym__qvarsym_prefix] = STATE(3232),
    [sym__pqvarsym] = STATE(3232),
    [sym_constructor_operator] = STATE(2496),
    [sym__constructor_operator_alias] = STATE(2496),
    [sym__consym_prefix] = STATE(3232),
    [sym__pconsym] = STATE(3232),
    [sym__qualified_consym] = STATE(2492),
    [sym__qconsym_prefix] = STATE(3232),
    [sym__pqconsym] = STATE(3232),
    [sym__prefix_at] = STATE(2625),
    [sym__paren_open] = STATE(466),
    [sym__bracket_open] = STATE(1073),
    [sym__unboxed_open] = STATE(781),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_mdo] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_u27e6] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1117),
    [sym_implicit_variable] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [sym_label] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1119),
    [anon_sym_u22b8] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [anon_sym_RBRACK] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_tight_dot] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_dotdot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_prefix_percent] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__cond_minus] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [497] = {
    [sym__type_parens] = STATE(3379),
    [sym__type_tuple] = STATE(3377),
    [sym__type_unboxed_tuple] = STATE(3370),
    [sym__type_unboxed_sum] = STATE(3369),
    [sym__type_list] = STATE(3361),
    [sym__type_promoted] = STATE(3383),
    [sym__type_star] = STATE(3383),
    [sym__type_wildcard] = STATE(3383),
    [sym__at_type] = STATE(3343),
    [sym__type_apply] = STATE(3359),
    [sym__type_infix] = STATE(3358),
    [sym_type] = STATE(481),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8433),
    [sym__splice_dollars] = STATE(7460),
    [sym_splice] = STATE(3383),
    [sym_quasiquote] = STATE(3383),
    [sym_integer] = STATE(3269),
    [sym__plist] = STATE(3357),
    [sym_unit] = STATE(3383),
    [sym_unboxed_unit] = STATE(3383),
    [sym_prefix_tuple] = STATE(3383),
    [sym_prefix_unboxed_tuple] = STATE(3383),
    [sym_prefix_unboxed_sum] = STATE(3383),
    [sym_literal] = STATE(3383),
    [sym__qualified_type] = STATE(3410),
    [sym__qtyconid] = STATE(3354),
    [sym__tycon_arrow] = STATE(3354),
    [sym__qtycon_arrow] = STATE(3354),
    [sym__promoted_tycons_alias] = STATE(3383),
    [sym__promoted_tycons] = STATE(3383),
    [sym__tycon_ticked] = STATE(2469),
    [sym__qtycon_ticked] = STATE(2469),
    [sym__tyconids_ticked] = STATE(2469),
    [sym__promoted_tyconops_alias] = STATE(2469),
    [sym__promoted_tyconops] = STATE(2469),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2469),
    [sym__operator_alias] = STATE(2469),
    [sym__operator_minus] = STATE(2469),
    [sym__varsym_prefix] = STATE(3354),
    [sym__pvarsym] = STATE(3354),
    [sym__qualified_varsym] = STATE(2465),
    [sym__qvarsym_prefix] = STATE(3354),
    [sym__pqvarsym] = STATE(3354),
    [sym_constructor_operator] = STATE(2469),
    [sym__constructor_operator_alias] = STATE(2469),
    [sym__consym_prefix] = STATE(3354),
    [sym__pconsym] = STATE(3354),
    [sym__qualified_consym] = STATE(2571),
    [sym__qconsym_prefix] = STATE(3354),
    [sym__pqconsym] = STATE(3354),
    [sym__prefix_at] = STATE(2638),
    [sym__paren_open] = STATE(464),
    [sym__bracket_open] = STATE(1079),
    [sym__unboxed_open] = STATE(805),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1177),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [anon_sym_PIPE2] = ACTIONS(1179),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1179),
    [anon_sym_u22b8] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_POUND_RPAREN] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_prefix_percent] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [498] = {
    [sym__type_parens] = STATE(3294),
    [sym__type_tuple] = STATE(3295),
    [sym__type_unboxed_tuple] = STATE(3296),
    [sym__type_unboxed_sum] = STATE(3298),
    [sym__type_list] = STATE(3311),
    [sym__type_promoted] = STATE(3292),
    [sym__type_star] = STATE(3292),
    [sym__type_wildcard] = STATE(3292),
    [sym__at_type] = STATE(3341),
    [sym__type_apply] = STATE(3313),
    [sym__type_infix] = STATE(3314),
    [sym_type] = STATE(498),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8499),
    [sym__splice_dollars] = STATE(7231),
    [sym_splice] = STATE(3292),
    [sym_quasiquote] = STATE(3292),
    [sym_integer] = STATE(3286),
    [sym__plist] = STATE(3318),
    [sym_unit] = STATE(3292),
    [sym_unboxed_unit] = STATE(3292),
    [sym_prefix_tuple] = STATE(3292),
    [sym_prefix_unboxed_tuple] = STATE(3292),
    [sym_prefix_unboxed_sum] = STATE(3292),
    [sym_literal] = STATE(3292),
    [sym__qualified_type] = STATE(3249),
    [sym__qtyconid] = STATE(3320),
    [sym__tycon_arrow] = STATE(3320),
    [sym__qtycon_arrow] = STATE(3320),
    [sym__promoted_tycons_alias] = STATE(3292),
    [sym__promoted_tycons] = STATE(3292),
    [sym__tycon_ticked] = STATE(2412),
    [sym__qtycon_ticked] = STATE(2412),
    [sym__tyconids_ticked] = STATE(2412),
    [sym__promoted_tyconops_alias] = STATE(2412),
    [sym__promoted_tyconops] = STATE(2412),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2412),
    [sym__operator_alias] = STATE(2412),
    [sym__operator_minus] = STATE(2412),
    [sym__varsym_prefix] = STATE(3320),
    [sym__pvarsym] = STATE(3320),
    [sym__qualified_varsym] = STATE(2409),
    [sym__qvarsym_prefix] = STATE(3320),
    [sym__pqvarsym] = STATE(3320),
    [sym_constructor_operator] = STATE(2412),
    [sym__constructor_operator_alias] = STATE(2412),
    [sym__consym_prefix] = STATE(3320),
    [sym__pconsym] = STATE(3320),
    [sym__qualified_consym] = STATE(2408),
    [sym__qconsym_prefix] = STATE(3320),
    [sym__pqconsym] = STATE(3320),
    [sym__prefix_at] = STATE(2685),
    [sym__paren_open] = STATE(458),
    [sym__bracket_open] = STATE(1120),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1119),
    [anon_sym_by] = ACTIONS(1117),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_mdo] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_u27e6] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1117),
    [sym_implicit_variable] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [sym_label] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1119),
    [anon_sym_u22b8] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [anon_sym_RBRACK] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_tight_dot] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_prefix_percent] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__cond_minus] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [499] = {
    [sym__type_parens] = STATE(3294),
    [sym__type_tuple] = STATE(3295),
    [sym__type_unboxed_tuple] = STATE(3296),
    [sym__type_unboxed_sum] = STATE(3298),
    [sym__type_list] = STATE(3311),
    [sym__type_promoted] = STATE(3292),
    [sym__type_star] = STATE(3292),
    [sym__type_wildcard] = STATE(3292),
    [sym__at_type] = STATE(3341),
    [sym__type_apply] = STATE(3313),
    [sym__type_infix] = STATE(3314),
    [sym_type] = STATE(498),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8499),
    [sym__splice_dollars] = STATE(7231),
    [sym_splice] = STATE(3292),
    [sym_quasiquote] = STATE(3292),
    [sym_integer] = STATE(3286),
    [sym__plist] = STATE(3318),
    [sym_unit] = STATE(3292),
    [sym_unboxed_unit] = STATE(3292),
    [sym_prefix_tuple] = STATE(3292),
    [sym_prefix_unboxed_tuple] = STATE(3292),
    [sym_prefix_unboxed_sum] = STATE(3292),
    [sym_literal] = STATE(3292),
    [sym__qualified_type] = STATE(3249),
    [sym__qtyconid] = STATE(3320),
    [sym__tycon_arrow] = STATE(3320),
    [sym__qtycon_arrow] = STATE(3320),
    [sym__promoted_tycons_alias] = STATE(3292),
    [sym__promoted_tycons] = STATE(3292),
    [sym__tycon_ticked] = STATE(2412),
    [sym__qtycon_ticked] = STATE(2412),
    [sym__tyconids_ticked] = STATE(2412),
    [sym__promoted_tyconops_alias] = STATE(2412),
    [sym__promoted_tyconops] = STATE(2412),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2412),
    [sym__operator_alias] = STATE(2412),
    [sym__operator_minus] = STATE(2412),
    [sym__varsym_prefix] = STATE(3320),
    [sym__pvarsym] = STATE(3320),
    [sym__qualified_varsym] = STATE(2409),
    [sym__qvarsym_prefix] = STATE(3320),
    [sym__pqvarsym] = STATE(3320),
    [sym_constructor_operator] = STATE(2412),
    [sym__constructor_operator_alias] = STATE(2412),
    [sym__consym_prefix] = STATE(3320),
    [sym__pconsym] = STATE(3320),
    [sym__qualified_consym] = STATE(2408),
    [sym__qconsym_prefix] = STATE(3320),
    [sym__pqconsym] = STATE(3320),
    [sym__prefix_at] = STATE(2685),
    [sym__paren_open] = STATE(458),
    [sym__bracket_open] = STATE(1120),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_by] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1179),
    [anon_sym_u22b8] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_RBRACK] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_prefix_percent] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [500] = {
    [sym__type_parens] = STATE(3217),
    [sym__type_tuple] = STATE(3215),
    [sym__type_unboxed_tuple] = STATE(3214),
    [sym__type_unboxed_sum] = STATE(3209),
    [sym__type_list] = STATE(3198),
    [sym__type_promoted] = STATE(3219),
    [sym__type_star] = STATE(3219),
    [sym__type_wildcard] = STATE(3219),
    [sym__at_type] = STATE(3241),
    [sym__type_apply] = STATE(3195),
    [sym__type_infix] = STATE(3189),
    [sym_type] = STATE(487),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8524),
    [sym__splice_dollars] = STATE(7385),
    [sym_splice] = STATE(3219),
    [sym_quasiquote] = STATE(3219),
    [sym_integer] = STATE(3330),
    [sym__plist] = STATE(3185),
    [sym_unit] = STATE(3219),
    [sym_unboxed_unit] = STATE(3219),
    [sym_prefix_tuple] = STATE(3219),
    [sym_prefix_unboxed_tuple] = STATE(3219),
    [sym_prefix_unboxed_sum] = STATE(3219),
    [sym_literal] = STATE(3219),
    [sym__qualified_type] = STATE(3420),
    [sym__qtyconid] = STATE(3183),
    [sym__tycon_arrow] = STATE(3183),
    [sym__qtycon_arrow] = STATE(3183),
    [sym__promoted_tycons_alias] = STATE(3219),
    [sym__promoted_tycons] = STATE(3219),
    [sym__tycon_ticked] = STATE(2661),
    [sym__qtycon_ticked] = STATE(2661),
    [sym__tyconids_ticked] = STATE(2661),
    [sym__promoted_tyconops_alias] = STATE(2661),
    [sym__promoted_tyconops] = STATE(2661),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2661),
    [sym__operator_alias] = STATE(2661),
    [sym__operator_minus] = STATE(2661),
    [sym__varsym_prefix] = STATE(3183),
    [sym__pvarsym] = STATE(3183),
    [sym__qualified_varsym] = STATE(2662),
    [sym__qvarsym_prefix] = STATE(3183),
    [sym__pqvarsym] = STATE(3183),
    [sym_constructor_operator] = STATE(2661),
    [sym__constructor_operator_alias] = STATE(2661),
    [sym__consym_prefix] = STATE(3183),
    [sym__pconsym] = STATE(3183),
    [sym__qualified_consym] = STATE(2647),
    [sym__qconsym_prefix] = STATE(3183),
    [sym__pqconsym] = STATE(3183),
    [sym__prefix_at] = STATE(2407),
    [sym__paren_open] = STATE(447),
    [sym__bracket_open] = STATE(976),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = ACTIONS(1629),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_let] = ACTIONS(1125),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym__] = ACTIONS(1631),
    [anon_sym_SQUOTE] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1635),
    [anon_sym_u2605] = ACTIONS(1637),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1123),
    [anon_sym_BSLASH] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1125),
    [anon_sym_mdo] = ACTIONS(1125),
    [anon_sym_do] = ACTIONS(1125),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1123),
    [sym_float] = ACTIONS(1639),
    [sym_char] = ACTIONS(1639),
    [sym_string] = ACTIONS(1639),
    [sym__integer_literal] = ACTIONS(1641),
    [sym__binary_literal] = ACTIONS(1643),
    [sym__octal_literal] = ACTIONS(1643),
    [sym__hex_literal] = ACTIONS(1643),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1123),
    [sym_name] = ACTIONS(1645),
    [sym_label] = ACTIONS(1123),
    [anon_sym_u2192] = ACTIONS(1123),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1123),
    [anon_sym_u22b8] = ACTIONS(1123),
    [anon_sym_COLON_COLON] = ACTIONS(1123),
    [anon_sym_u2237] = ACTIONS(1123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1123),
    [sym__cond_layout_end] = ACTIONS(1123),
    [sym__cond_layout_end_explicit] = ACTIONS(1123),
    [sym__phantom_arrow] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1647),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1123),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1123),
    [sym__cond_qualified_op] = ACTIONS(1123),
    [sym__cond_no_section_op] = ACTIONS(1123),
    [sym__cond_minus] = ACTIONS(1123),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [501] = {
    [sym__type_parens] = STATE(3579),
    [sym__type_tuple] = STATE(3576),
    [sym__type_unboxed_tuple] = STATE(3572),
    [sym__type_unboxed_sum] = STATE(3570),
    [sym__type_list] = STATE(3569),
    [sym__type_promoted] = STATE(3582),
    [sym__type_star] = STATE(3582),
    [sym__type_wildcard] = STATE(3582),
    [sym__at_type] = STATE(3530),
    [sym__type_apply] = STATE(3567),
    [sym__type_infix] = STATE(3561),
    [sym_type] = STATE(505),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8434),
    [sym__splice_dollars] = STATE(7292),
    [sym_splice] = STATE(3582),
    [sym_quasiquote] = STATE(3582),
    [sym_integer] = STATE(3435),
    [sym__plist] = STATE(3559),
    [sym_unit] = STATE(3582),
    [sym_unboxed_unit] = STATE(3582),
    [sym_prefix_tuple] = STATE(3582),
    [sym_prefix_unboxed_tuple] = STATE(3582),
    [sym_prefix_unboxed_sum] = STATE(3582),
    [sym_literal] = STATE(3582),
    [sym__qualified_type] = STATE(3610),
    [sym__qtyconid] = STATE(3556),
    [sym__tycon_arrow] = STATE(3556),
    [sym__qtycon_arrow] = STATE(3556),
    [sym__promoted_tycons_alias] = STATE(3582),
    [sym__promoted_tycons] = STATE(3582),
    [sym__tycon_ticked] = STATE(2503),
    [sym__qtycon_ticked] = STATE(2503),
    [sym__tyconids_ticked] = STATE(2503),
    [sym__promoted_tyconops_alias] = STATE(2503),
    [sym__promoted_tyconops] = STATE(2503),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2503),
    [sym__operator_alias] = STATE(2503),
    [sym__operator_minus] = STATE(2503),
    [sym__varsym_prefix] = STATE(3556),
    [sym__pvarsym] = STATE(3556),
    [sym__qualified_varsym] = STATE(2501),
    [sym__qvarsym_prefix] = STATE(3556),
    [sym__pqvarsym] = STATE(3556),
    [sym_constructor_operator] = STATE(2503),
    [sym__constructor_operator_alias] = STATE(2503),
    [sym__consym_prefix] = STATE(3556),
    [sym__pconsym] = STATE(3556),
    [sym__qualified_consym] = STATE(2500),
    [sym__qconsym_prefix] = STATE(3556),
    [sym__pqconsym] = STATE(3556),
    [sym__prefix_at] = STATE(2622),
    [sym__paren_open] = STATE(465),
    [sym__bracket_open] = STATE(1069),
    [sym__unboxed_open] = STATE(772),
    [sym_variable] = ACTIONS(1649),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1651),
    [anon_sym_SQUOTE] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(1655),
    [anon_sym_u2605] = ACTIONS(1657),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(1659),
    [sym_char] = ACTIONS(1659),
    [sym_string] = ACTIONS(1659),
    [sym__integer_literal] = ACTIONS(1661),
    [sym__binary_literal] = ACTIONS(1663),
    [sym__octal_literal] = ACTIONS(1663),
    [sym__hex_literal] = ACTIONS(1663),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1665),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1667),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_left_section_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [502] = {
    [sym__type_parens] = STATE(3557),
    [sym__type_tuple] = STATE(3612),
    [sym__type_unboxed_tuple] = STATE(3607),
    [sym__type_unboxed_sum] = STATE(3606),
    [sym__type_list] = STATE(3605),
    [sym__type_promoted] = STATE(3638),
    [sym__type_star] = STATE(3638),
    [sym__type_wildcard] = STATE(3638),
    [sym__at_type] = STATE(3519),
    [sym__type_apply] = STATE(3604),
    [sym__type_infix] = STATE(3602),
    [sym_type] = STATE(503),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8544),
    [sym__splice_dollars] = STATE(7350),
    [sym_splice] = STATE(3638),
    [sym_quasiquote] = STATE(3638),
    [sym_integer] = STATE(3509),
    [sym__plist] = STATE(3597),
    [sym_unit] = STATE(3638),
    [sym_unboxed_unit] = STATE(3638),
    [sym_prefix_tuple] = STATE(3638),
    [sym_prefix_unboxed_tuple] = STATE(3638),
    [sym_prefix_unboxed_sum] = STATE(3638),
    [sym_literal] = STATE(3638),
    [sym__qualified_type] = STATE(3643),
    [sym__qtyconid] = STATE(3583),
    [sym__tycon_arrow] = STATE(3583),
    [sym__qtycon_arrow] = STATE(3583),
    [sym__promoted_tycons_alias] = STATE(3638),
    [sym__promoted_tycons] = STATE(3638),
    [sym__tycon_ticked] = STATE(2397),
    [sym__qtycon_ticked] = STATE(2397),
    [sym__tyconids_ticked] = STATE(2397),
    [sym__promoted_tyconops_alias] = STATE(2397),
    [sym__promoted_tyconops] = STATE(2397),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2397),
    [sym__operator_alias] = STATE(2397),
    [sym__operator_minus] = STATE(2397),
    [sym__varsym_prefix] = STATE(3583),
    [sym__pvarsym] = STATE(3583),
    [sym__qualified_varsym] = STATE(2493),
    [sym__qvarsym_prefix] = STATE(3583),
    [sym__pqvarsym] = STATE(3583),
    [sym_constructor_operator] = STATE(2397),
    [sym__constructor_operator_alias] = STATE(2397),
    [sym__consym_prefix] = STATE(3583),
    [sym__pconsym] = STATE(3583),
    [sym__qualified_consym] = STATE(2537),
    [sym__qconsym_prefix] = STATE(3583),
    [sym__pqconsym] = STATE(3583),
    [sym__prefix_at] = STATE(2688),
    [sym__paren_open] = STATE(461),
    [sym__bracket_open] = STATE(1131),
    [sym__unboxed_open] = STATE(829),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1179),
    [anon_sym_u22b8] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym__phantom_bar] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_prefix_percent] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [503] = {
    [sym__type_parens] = STATE(3557),
    [sym__type_tuple] = STATE(3612),
    [sym__type_unboxed_tuple] = STATE(3607),
    [sym__type_unboxed_sum] = STATE(3606),
    [sym__type_list] = STATE(3605),
    [sym__type_promoted] = STATE(3638),
    [sym__type_star] = STATE(3638),
    [sym__type_wildcard] = STATE(3638),
    [sym__at_type] = STATE(3519),
    [sym__type_apply] = STATE(3604),
    [sym__type_infix] = STATE(3602),
    [sym_type] = STATE(503),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8544),
    [sym__splice_dollars] = STATE(7350),
    [sym_splice] = STATE(3638),
    [sym_quasiquote] = STATE(3638),
    [sym_integer] = STATE(3509),
    [sym__plist] = STATE(3597),
    [sym_unit] = STATE(3638),
    [sym_unboxed_unit] = STATE(3638),
    [sym_prefix_tuple] = STATE(3638),
    [sym_prefix_unboxed_tuple] = STATE(3638),
    [sym_prefix_unboxed_sum] = STATE(3638),
    [sym_literal] = STATE(3638),
    [sym__qualified_type] = STATE(3643),
    [sym__qtyconid] = STATE(3583),
    [sym__tycon_arrow] = STATE(3583),
    [sym__qtycon_arrow] = STATE(3583),
    [sym__promoted_tycons_alias] = STATE(3638),
    [sym__promoted_tycons] = STATE(3638),
    [sym__tycon_ticked] = STATE(2397),
    [sym__qtycon_ticked] = STATE(2397),
    [sym__tyconids_ticked] = STATE(2397),
    [sym__promoted_tyconops_alias] = STATE(2397),
    [sym__promoted_tyconops] = STATE(2397),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2397),
    [sym__operator_alias] = STATE(2397),
    [sym__operator_minus] = STATE(2397),
    [sym__varsym_prefix] = STATE(3583),
    [sym__pvarsym] = STATE(3583),
    [sym__qualified_varsym] = STATE(2493),
    [sym__qvarsym_prefix] = STATE(3583),
    [sym__pqvarsym] = STATE(3583),
    [sym_constructor_operator] = STATE(2397),
    [sym__constructor_operator_alias] = STATE(2397),
    [sym__consym_prefix] = STATE(3583),
    [sym__pconsym] = STATE(3583),
    [sym__qualified_consym] = STATE(2537),
    [sym__qconsym_prefix] = STATE(3583),
    [sym__pqconsym] = STATE(3583),
    [sym__prefix_at] = STATE(2688),
    [sym__paren_open] = STATE(461),
    [sym__bracket_open] = STATE(1131),
    [sym__unboxed_open] = STATE(829),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_mdo] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_u27e6] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1117),
    [sym_implicit_variable] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [sym_label] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1119),
    [anon_sym_u22b8] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(1119),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym__phantom_bar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_tight_dot] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_prefix_percent] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__cond_minus] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [504] = {
    [sym__type_parens] = STATE(3579),
    [sym__type_tuple] = STATE(3576),
    [sym__type_unboxed_tuple] = STATE(3572),
    [sym__type_unboxed_sum] = STATE(3570),
    [sym__type_list] = STATE(3569),
    [sym__type_promoted] = STATE(3582),
    [sym__type_star] = STATE(3582),
    [sym__type_wildcard] = STATE(3582),
    [sym__at_type] = STATE(3530),
    [sym__type_apply] = STATE(3567),
    [sym__type_infix] = STATE(3561),
    [sym_type] = STATE(505),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8434),
    [sym__splice_dollars] = STATE(7292),
    [sym_splice] = STATE(3582),
    [sym_quasiquote] = STATE(3582),
    [sym_integer] = STATE(3435),
    [sym__plist] = STATE(3559),
    [sym_unit] = STATE(3582),
    [sym_unboxed_unit] = STATE(3582),
    [sym_prefix_tuple] = STATE(3582),
    [sym_prefix_unboxed_tuple] = STATE(3582),
    [sym_prefix_unboxed_sum] = STATE(3582),
    [sym_literal] = STATE(3582),
    [sym__qualified_type] = STATE(3610),
    [sym__qtyconid] = STATE(3556),
    [sym__tycon_arrow] = STATE(3556),
    [sym__qtycon_arrow] = STATE(3556),
    [sym__promoted_tycons_alias] = STATE(3582),
    [sym__promoted_tycons] = STATE(3582),
    [sym__tycon_ticked] = STATE(2503),
    [sym__qtycon_ticked] = STATE(2503),
    [sym__tyconids_ticked] = STATE(2503),
    [sym__promoted_tyconops_alias] = STATE(2503),
    [sym__promoted_tyconops] = STATE(2503),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2503),
    [sym__operator_alias] = STATE(2503),
    [sym__operator_minus] = STATE(2503),
    [sym__varsym_prefix] = STATE(3556),
    [sym__pvarsym] = STATE(3556),
    [sym__qualified_varsym] = STATE(2501),
    [sym__qvarsym_prefix] = STATE(3556),
    [sym__pqvarsym] = STATE(3556),
    [sym_constructor_operator] = STATE(2503),
    [sym__constructor_operator_alias] = STATE(2503),
    [sym__consym_prefix] = STATE(3556),
    [sym__pconsym] = STATE(3556),
    [sym__qualified_consym] = STATE(2500),
    [sym__qconsym_prefix] = STATE(3556),
    [sym__pqconsym] = STATE(3556),
    [sym__prefix_at] = STATE(2622),
    [sym__paren_open] = STATE(465),
    [sym__bracket_open] = STATE(1069),
    [sym__unboxed_open] = STATE(772),
    [sym_variable] = ACTIONS(1649),
    [anon_sym_let] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1651),
    [anon_sym_SQUOTE] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(1655),
    [anon_sym_u2605] = ACTIONS(1657),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1157),
    [anon_sym_BSLASH] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_mdo] = ACTIONS(1159),
    [anon_sym_do] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1157),
    [sym_float] = ACTIONS(1659),
    [sym_char] = ACTIONS(1659),
    [sym_string] = ACTIONS(1659),
    [sym__integer_literal] = ACTIONS(1661),
    [sym__binary_literal] = ACTIONS(1663),
    [sym__octal_literal] = ACTIONS(1663),
    [sym__hex_literal] = ACTIONS(1663),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1157),
    [sym_name] = ACTIONS(1665),
    [sym_label] = ACTIONS(1157),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1157),
    [anon_sym_u22b8] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1157),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1667),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1157),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1157),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_left_section_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__cond_minus] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [505] = {
    [sym__type_parens] = STATE(3579),
    [sym__type_tuple] = STATE(3576),
    [sym__type_unboxed_tuple] = STATE(3572),
    [sym__type_unboxed_sum] = STATE(3570),
    [sym__type_list] = STATE(3569),
    [sym__type_promoted] = STATE(3582),
    [sym__type_star] = STATE(3582),
    [sym__type_wildcard] = STATE(3582),
    [sym__at_type] = STATE(3530),
    [sym__type_apply] = STATE(3567),
    [sym__type_infix] = STATE(3561),
    [sym_type] = STATE(505),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8434),
    [sym__splice_dollars] = STATE(7292),
    [sym_splice] = STATE(3582),
    [sym_quasiquote] = STATE(3582),
    [sym_integer] = STATE(3435),
    [sym__plist] = STATE(3559),
    [sym_unit] = STATE(3582),
    [sym_unboxed_unit] = STATE(3582),
    [sym_prefix_tuple] = STATE(3582),
    [sym_prefix_unboxed_tuple] = STATE(3582),
    [sym_prefix_unboxed_sum] = STATE(3582),
    [sym_literal] = STATE(3582),
    [sym__qualified_type] = STATE(3610),
    [sym__qtyconid] = STATE(3556),
    [sym__tycon_arrow] = STATE(3556),
    [sym__qtycon_arrow] = STATE(3556),
    [sym__promoted_tycons_alias] = STATE(3582),
    [sym__promoted_tycons] = STATE(3582),
    [sym__tycon_ticked] = STATE(2503),
    [sym__qtycon_ticked] = STATE(2503),
    [sym__tyconids_ticked] = STATE(2503),
    [sym__promoted_tyconops_alias] = STATE(2503),
    [sym__promoted_tyconops] = STATE(2503),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2503),
    [sym__operator_alias] = STATE(2503),
    [sym__operator_minus] = STATE(2503),
    [sym__varsym_prefix] = STATE(3556),
    [sym__pvarsym] = STATE(3556),
    [sym__qualified_varsym] = STATE(2501),
    [sym__qvarsym_prefix] = STATE(3556),
    [sym__pqvarsym] = STATE(3556),
    [sym_constructor_operator] = STATE(2503),
    [sym__constructor_operator_alias] = STATE(2503),
    [sym__consym_prefix] = STATE(3556),
    [sym__pconsym] = STATE(3556),
    [sym__qualified_consym] = STATE(2500),
    [sym__qconsym_prefix] = STATE(3556),
    [sym__pqconsym] = STATE(3556),
    [sym__prefix_at] = STATE(2622),
    [sym__paren_open] = STATE(465),
    [sym__bracket_open] = STATE(1069),
    [sym__unboxed_open] = STATE(772),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1119),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_mdo] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_u27e6] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1117),
    [sym_implicit_variable] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [sym_label] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1119),
    [anon_sym_u22b8] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__paren_close_token1] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_tight_dot] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_prefix_percent] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_left_section_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__cond_minus] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [506] = {
    [sym__type_parens] = STATE(3579),
    [sym__type_tuple] = STATE(3576),
    [sym__type_unboxed_tuple] = STATE(3572),
    [sym__type_unboxed_sum] = STATE(3570),
    [sym__type_list] = STATE(3569),
    [sym__type_promoted] = STATE(3582),
    [sym__type_star] = STATE(3582),
    [sym__type_wildcard] = STATE(3582),
    [sym__at_type] = STATE(3530),
    [sym__type_apply] = STATE(3567),
    [sym__type_infix] = STATE(3561),
    [sym_type] = STATE(505),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8434),
    [sym__splice_dollars] = STATE(7292),
    [sym_splice] = STATE(3582),
    [sym_quasiquote] = STATE(3582),
    [sym_integer] = STATE(3435),
    [sym__plist] = STATE(3559),
    [sym_unit] = STATE(3582),
    [sym_unboxed_unit] = STATE(3582),
    [sym_prefix_tuple] = STATE(3582),
    [sym_prefix_unboxed_tuple] = STATE(3582),
    [sym_prefix_unboxed_sum] = STATE(3582),
    [sym_literal] = STATE(3582),
    [sym__qualified_type] = STATE(3610),
    [sym__qtyconid] = STATE(3556),
    [sym__tycon_arrow] = STATE(3556),
    [sym__qtycon_arrow] = STATE(3556),
    [sym__promoted_tycons_alias] = STATE(3582),
    [sym__promoted_tycons] = STATE(3582),
    [sym__tycon_ticked] = STATE(2503),
    [sym__qtycon_ticked] = STATE(2503),
    [sym__tyconids_ticked] = STATE(2503),
    [sym__promoted_tyconops_alias] = STATE(2503),
    [sym__promoted_tyconops] = STATE(2503),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2503),
    [sym__operator_alias] = STATE(2503),
    [sym__operator_minus] = STATE(2503),
    [sym__varsym_prefix] = STATE(3556),
    [sym__pvarsym] = STATE(3556),
    [sym__qualified_varsym] = STATE(2501),
    [sym__qvarsym_prefix] = STATE(3556),
    [sym__pqvarsym] = STATE(3556),
    [sym_constructor_operator] = STATE(2503),
    [sym__constructor_operator_alias] = STATE(2503),
    [sym__consym_prefix] = STATE(3556),
    [sym__pconsym] = STATE(3556),
    [sym__qualified_consym] = STATE(2500),
    [sym__qconsym_prefix] = STATE(3556),
    [sym__pqconsym] = STATE(3556),
    [sym__prefix_at] = STATE(2622),
    [sym__paren_open] = STATE(465),
    [sym__bracket_open] = STATE(1069),
    [sym__unboxed_open] = STATE(772),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1179),
    [anon_sym_u22b8] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__paren_close_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_prefix_percent] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_left_section_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [507] = {
    [sym__type_parens] = STATE(3557),
    [sym__type_tuple] = STATE(3612),
    [sym__type_unboxed_tuple] = STATE(3607),
    [sym__type_unboxed_sum] = STATE(3606),
    [sym__type_list] = STATE(3605),
    [sym__type_promoted] = STATE(3638),
    [sym__type_star] = STATE(3638),
    [sym__type_wildcard] = STATE(3638),
    [sym__at_type] = STATE(3519),
    [sym__type_apply] = STATE(3604),
    [sym__type_infix] = STATE(3602),
    [sym_type] = STATE(503),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8544),
    [sym__splice_dollars] = STATE(7350),
    [sym_splice] = STATE(3638),
    [sym_quasiquote] = STATE(3638),
    [sym_integer] = STATE(3509),
    [sym__plist] = STATE(3597),
    [sym_unit] = STATE(3638),
    [sym_unboxed_unit] = STATE(3638),
    [sym_prefix_tuple] = STATE(3638),
    [sym_prefix_unboxed_tuple] = STATE(3638),
    [sym_prefix_unboxed_sum] = STATE(3638),
    [sym_literal] = STATE(3638),
    [sym__qualified_type] = STATE(3643),
    [sym__qtyconid] = STATE(3583),
    [sym__tycon_arrow] = STATE(3583),
    [sym__qtycon_arrow] = STATE(3583),
    [sym__promoted_tycons_alias] = STATE(3638),
    [sym__promoted_tycons] = STATE(3638),
    [sym__tycon_ticked] = STATE(2397),
    [sym__qtycon_ticked] = STATE(2397),
    [sym__tyconids_ticked] = STATE(2397),
    [sym__promoted_tyconops_alias] = STATE(2397),
    [sym__promoted_tyconops] = STATE(2397),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2397),
    [sym__operator_alias] = STATE(2397),
    [sym__operator_minus] = STATE(2397),
    [sym__varsym_prefix] = STATE(3583),
    [sym__pvarsym] = STATE(3583),
    [sym__qualified_varsym] = STATE(2493),
    [sym__qvarsym_prefix] = STATE(3583),
    [sym__pqvarsym] = STATE(3583),
    [sym_constructor_operator] = STATE(2397),
    [sym__constructor_operator_alias] = STATE(2397),
    [sym__consym_prefix] = STATE(3583),
    [sym__pconsym] = STATE(3583),
    [sym__qualified_consym] = STATE(2537),
    [sym__qconsym_prefix] = STATE(3583),
    [sym__pqconsym] = STATE(3583),
    [sym__prefix_at] = STATE(2688),
    [sym__paren_open] = STATE(461),
    [sym__bracket_open] = STATE(1131),
    [sym__unboxed_open] = STATE(829),
    [sym_variable] = ACTIONS(1669),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1671),
    [anon_sym_SQUOTE] = ACTIONS(1673),
    [anon_sym_STAR] = ACTIONS(1675),
    [anon_sym_u2605] = ACTIONS(1677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(1679),
    [sym_char] = ACTIONS(1679),
    [sym_string] = ACTIONS(1679),
    [sym__integer_literal] = ACTIONS(1681),
    [sym__binary_literal] = ACTIONS(1683),
    [sym__octal_literal] = ACTIONS(1683),
    [sym__hex_literal] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1685),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [508] = {
    [sym__type_parens] = STATE(3557),
    [sym__type_tuple] = STATE(3612),
    [sym__type_unboxed_tuple] = STATE(3607),
    [sym__type_unboxed_sum] = STATE(3606),
    [sym__type_list] = STATE(3605),
    [sym__type_promoted] = STATE(3638),
    [sym__type_star] = STATE(3638),
    [sym__type_wildcard] = STATE(3638),
    [sym__at_type] = STATE(3519),
    [sym__type_apply] = STATE(3604),
    [sym__type_infix] = STATE(3602),
    [sym_type] = STATE(503),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8544),
    [sym__splice_dollars] = STATE(7350),
    [sym_splice] = STATE(3638),
    [sym_quasiquote] = STATE(3638),
    [sym_integer] = STATE(3509),
    [sym__plist] = STATE(3597),
    [sym_unit] = STATE(3638),
    [sym_unboxed_unit] = STATE(3638),
    [sym_prefix_tuple] = STATE(3638),
    [sym_prefix_unboxed_tuple] = STATE(3638),
    [sym_prefix_unboxed_sum] = STATE(3638),
    [sym_literal] = STATE(3638),
    [sym__qualified_type] = STATE(3643),
    [sym__qtyconid] = STATE(3583),
    [sym__tycon_arrow] = STATE(3583),
    [sym__qtycon_arrow] = STATE(3583),
    [sym__promoted_tycons_alias] = STATE(3638),
    [sym__promoted_tycons] = STATE(3638),
    [sym__tycon_ticked] = STATE(2397),
    [sym__qtycon_ticked] = STATE(2397),
    [sym__tyconids_ticked] = STATE(2397),
    [sym__promoted_tyconops_alias] = STATE(2397),
    [sym__promoted_tyconops] = STATE(2397),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2397),
    [sym__operator_alias] = STATE(2397),
    [sym__operator_minus] = STATE(2397),
    [sym__varsym_prefix] = STATE(3583),
    [sym__pvarsym] = STATE(3583),
    [sym__qualified_varsym] = STATE(2493),
    [sym__qvarsym_prefix] = STATE(3583),
    [sym__pqvarsym] = STATE(3583),
    [sym_constructor_operator] = STATE(2397),
    [sym__constructor_operator_alias] = STATE(2397),
    [sym__consym_prefix] = STATE(3583),
    [sym__pconsym] = STATE(3583),
    [sym__qualified_consym] = STATE(2537),
    [sym__qconsym_prefix] = STATE(3583),
    [sym__pqconsym] = STATE(3583),
    [sym__prefix_at] = STATE(2688),
    [sym__paren_open] = STATE(461),
    [sym__bracket_open] = STATE(1131),
    [sym__unboxed_open] = STATE(829),
    [sym_variable] = ACTIONS(1669),
    [anon_sym_let] = ACTIONS(1125),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym__] = ACTIONS(1671),
    [anon_sym_SQUOTE] = ACTIONS(1673),
    [anon_sym_STAR] = ACTIONS(1675),
    [anon_sym_u2605] = ACTIONS(1677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_BSLASH] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1125),
    [anon_sym_mdo] = ACTIONS(1125),
    [anon_sym_do] = ACTIONS(1125),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1123),
    [sym_float] = ACTIONS(1679),
    [sym_char] = ACTIONS(1679),
    [sym_string] = ACTIONS(1679),
    [sym__integer_literal] = ACTIONS(1681),
    [sym__binary_literal] = ACTIONS(1683),
    [sym__octal_literal] = ACTIONS(1683),
    [sym__hex_literal] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1123),
    [sym_name] = ACTIONS(1685),
    [sym_label] = ACTIONS(1123),
    [anon_sym_u2192] = ACTIONS(1123),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1123),
    [anon_sym_u22b8] = ACTIONS(1123),
    [anon_sym_COLON_COLON] = ACTIONS(1123),
    [anon_sym_u2237] = ACTIONS(1123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(1123),
    [sym__phantom_arrow] = ACTIONS(1123),
    [sym__phantom_bar] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1123),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1123),
    [sym__cond_qualified_op] = ACTIONS(1123),
    [sym__cond_no_section_op] = ACTIONS(1123),
    [sym__cond_minus] = ACTIONS(1123),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [509] = {
    [sym__type_parens] = STATE(3579),
    [sym__type_tuple] = STATE(3576),
    [sym__type_unboxed_tuple] = STATE(3572),
    [sym__type_unboxed_sum] = STATE(3570),
    [sym__type_list] = STATE(3569),
    [sym__type_promoted] = STATE(3582),
    [sym__type_star] = STATE(3582),
    [sym__type_wildcard] = STATE(3582),
    [sym__at_type] = STATE(3530),
    [sym__type_apply] = STATE(3567),
    [sym__type_infix] = STATE(3561),
    [sym_type] = STATE(505),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8434),
    [sym__splice_dollars] = STATE(7292),
    [sym_splice] = STATE(3582),
    [sym_quasiquote] = STATE(3582),
    [sym_integer] = STATE(3435),
    [sym__plist] = STATE(3559),
    [sym_unit] = STATE(3582),
    [sym_unboxed_unit] = STATE(3582),
    [sym_prefix_tuple] = STATE(3582),
    [sym_prefix_unboxed_tuple] = STATE(3582),
    [sym_prefix_unboxed_sum] = STATE(3582),
    [sym_literal] = STATE(3582),
    [sym__qualified_type] = STATE(3610),
    [sym__qtyconid] = STATE(3556),
    [sym__tycon_arrow] = STATE(3556),
    [sym__qtycon_arrow] = STATE(3556),
    [sym__promoted_tycons_alias] = STATE(3582),
    [sym__promoted_tycons] = STATE(3582),
    [sym__tycon_ticked] = STATE(2503),
    [sym__qtycon_ticked] = STATE(2503),
    [sym__tyconids_ticked] = STATE(2503),
    [sym__promoted_tyconops_alias] = STATE(2503),
    [sym__promoted_tyconops] = STATE(2503),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2503),
    [sym__operator_alias] = STATE(2503),
    [sym__operator_minus] = STATE(2503),
    [sym__varsym_prefix] = STATE(3556),
    [sym__pvarsym] = STATE(3556),
    [sym__qualified_varsym] = STATE(2501),
    [sym__qvarsym_prefix] = STATE(3556),
    [sym__pqvarsym] = STATE(3556),
    [sym_constructor_operator] = STATE(2503),
    [sym__constructor_operator_alias] = STATE(2503),
    [sym__consym_prefix] = STATE(3556),
    [sym__pconsym] = STATE(3556),
    [sym__qualified_consym] = STATE(2500),
    [sym__qconsym_prefix] = STATE(3556),
    [sym__pqconsym] = STATE(3556),
    [sym__prefix_at] = STATE(2622),
    [sym__paren_open] = STATE(465),
    [sym__bracket_open] = STATE(1069),
    [sym__unboxed_open] = STATE(772),
    [sym_variable] = ACTIONS(1649),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1651),
    [anon_sym_SQUOTE] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(1655),
    [anon_sym_u2605] = ACTIONS(1657),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(1659),
    [sym_char] = ACTIONS(1659),
    [sym_string] = ACTIONS(1659),
    [sym__integer_literal] = ACTIONS(1661),
    [sym__binary_literal] = ACTIONS(1663),
    [sym__octal_literal] = ACTIONS(1663),
    [sym__hex_literal] = ACTIONS(1663),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1665),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1667),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_left_section_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [510] = {
    [sym__type_parens] = STATE(3557),
    [sym__type_tuple] = STATE(3612),
    [sym__type_unboxed_tuple] = STATE(3607),
    [sym__type_unboxed_sum] = STATE(3606),
    [sym__type_list] = STATE(3605),
    [sym__type_promoted] = STATE(3638),
    [sym__type_star] = STATE(3638),
    [sym__type_wildcard] = STATE(3638),
    [sym__at_type] = STATE(3519),
    [sym__type_apply] = STATE(3604),
    [sym__type_infix] = STATE(3602),
    [sym_type] = STATE(503),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8544),
    [sym__splice_dollars] = STATE(7350),
    [sym_splice] = STATE(3638),
    [sym_quasiquote] = STATE(3638),
    [sym_integer] = STATE(3509),
    [sym__plist] = STATE(3597),
    [sym_unit] = STATE(3638),
    [sym_unboxed_unit] = STATE(3638),
    [sym_prefix_tuple] = STATE(3638),
    [sym_prefix_unboxed_tuple] = STATE(3638),
    [sym_prefix_unboxed_sum] = STATE(3638),
    [sym_literal] = STATE(3638),
    [sym__qualified_type] = STATE(3643),
    [sym__qtyconid] = STATE(3583),
    [sym__tycon_arrow] = STATE(3583),
    [sym__qtycon_arrow] = STATE(3583),
    [sym__promoted_tycons_alias] = STATE(3638),
    [sym__promoted_tycons] = STATE(3638),
    [sym__tycon_ticked] = STATE(2397),
    [sym__qtycon_ticked] = STATE(2397),
    [sym__tyconids_ticked] = STATE(2397),
    [sym__promoted_tyconops_alias] = STATE(2397),
    [sym__promoted_tyconops] = STATE(2397),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2397),
    [sym__operator_alias] = STATE(2397),
    [sym__operator_minus] = STATE(2397),
    [sym__varsym_prefix] = STATE(3583),
    [sym__pvarsym] = STATE(3583),
    [sym__qualified_varsym] = STATE(2493),
    [sym__qvarsym_prefix] = STATE(3583),
    [sym__pqvarsym] = STATE(3583),
    [sym_constructor_operator] = STATE(2397),
    [sym__constructor_operator_alias] = STATE(2397),
    [sym__consym_prefix] = STATE(3583),
    [sym__pconsym] = STATE(3583),
    [sym__qualified_consym] = STATE(2537),
    [sym__qconsym_prefix] = STATE(3583),
    [sym__pqconsym] = STATE(3583),
    [sym__prefix_at] = STATE(2688),
    [sym__paren_open] = STATE(461),
    [sym__bracket_open] = STATE(1131),
    [sym__unboxed_open] = STATE(829),
    [sym_variable] = ACTIONS(1669),
    [anon_sym_let] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1671),
    [anon_sym_SQUOTE] = ACTIONS(1673),
    [anon_sym_STAR] = ACTIONS(1675),
    [anon_sym_u2605] = ACTIONS(1677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1157),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_BSLASH] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_mdo] = ACTIONS(1159),
    [anon_sym_do] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1157),
    [sym_float] = ACTIONS(1679),
    [sym_char] = ACTIONS(1679),
    [sym_string] = ACTIONS(1679),
    [sym__integer_literal] = ACTIONS(1681),
    [sym__binary_literal] = ACTIONS(1683),
    [sym__octal_literal] = ACTIONS(1683),
    [sym__hex_literal] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1157),
    [sym_name] = ACTIONS(1685),
    [sym_label] = ACTIONS(1157),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1157),
    [anon_sym_u22b8] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(1157),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym__phantom_bar] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1157),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1157),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__cond_minus] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [511] = {
    [sym__type_parens] = STATE(3579),
    [sym__type_tuple] = STATE(3576),
    [sym__type_unboxed_tuple] = STATE(3572),
    [sym__type_unboxed_sum] = STATE(3570),
    [sym__type_list] = STATE(3569),
    [sym__type_promoted] = STATE(3582),
    [sym__type_star] = STATE(3582),
    [sym__type_wildcard] = STATE(3582),
    [sym__at_type] = STATE(3530),
    [sym__type_apply] = STATE(3567),
    [sym__type_infix] = STATE(3561),
    [sym_type] = STATE(505),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8434),
    [sym__splice_dollars] = STATE(7292),
    [sym_splice] = STATE(3582),
    [sym_quasiquote] = STATE(3582),
    [sym_integer] = STATE(3435),
    [sym__plist] = STATE(3559),
    [sym_unit] = STATE(3582),
    [sym_unboxed_unit] = STATE(3582),
    [sym_prefix_tuple] = STATE(3582),
    [sym_prefix_unboxed_tuple] = STATE(3582),
    [sym_prefix_unboxed_sum] = STATE(3582),
    [sym_literal] = STATE(3582),
    [sym__qualified_type] = STATE(3610),
    [sym__qtyconid] = STATE(3556),
    [sym__tycon_arrow] = STATE(3556),
    [sym__qtycon_arrow] = STATE(3556),
    [sym__promoted_tycons_alias] = STATE(3582),
    [sym__promoted_tycons] = STATE(3582),
    [sym__tycon_ticked] = STATE(2503),
    [sym__qtycon_ticked] = STATE(2503),
    [sym__tyconids_ticked] = STATE(2503),
    [sym__promoted_tyconops_alias] = STATE(2503),
    [sym__promoted_tyconops] = STATE(2503),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2503),
    [sym__operator_alias] = STATE(2503),
    [sym__operator_minus] = STATE(2503),
    [sym__varsym_prefix] = STATE(3556),
    [sym__pvarsym] = STATE(3556),
    [sym__qualified_varsym] = STATE(2501),
    [sym__qvarsym_prefix] = STATE(3556),
    [sym__pqvarsym] = STATE(3556),
    [sym_constructor_operator] = STATE(2503),
    [sym__constructor_operator_alias] = STATE(2503),
    [sym__consym_prefix] = STATE(3556),
    [sym__pconsym] = STATE(3556),
    [sym__qualified_consym] = STATE(2500),
    [sym__qconsym_prefix] = STATE(3556),
    [sym__pqconsym] = STATE(3556),
    [sym__prefix_at] = STATE(2622),
    [sym__paren_open] = STATE(465),
    [sym__bracket_open] = STATE(1069),
    [sym__unboxed_open] = STATE(772),
    [sym_variable] = ACTIONS(1649),
    [anon_sym_let] = ACTIONS(1125),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym__] = ACTIONS(1651),
    [anon_sym_SQUOTE] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(1655),
    [anon_sym_u2605] = ACTIONS(1657),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1123),
    [anon_sym_BSLASH] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1125),
    [anon_sym_mdo] = ACTIONS(1125),
    [anon_sym_do] = ACTIONS(1125),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1123),
    [sym_float] = ACTIONS(1659),
    [sym_char] = ACTIONS(1659),
    [sym_string] = ACTIONS(1659),
    [sym__integer_literal] = ACTIONS(1661),
    [sym__binary_literal] = ACTIONS(1663),
    [sym__octal_literal] = ACTIONS(1663),
    [sym__hex_literal] = ACTIONS(1663),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1123),
    [sym_name] = ACTIONS(1665),
    [sym_label] = ACTIONS(1123),
    [anon_sym_u2192] = ACTIONS(1123),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1123),
    [anon_sym_u22b8] = ACTIONS(1123),
    [anon_sym_COLON_COLON] = ACTIONS(1123),
    [anon_sym_u2237] = ACTIONS(1123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1123),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1667),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1123),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1123),
    [sym__cond_qualified_op] = ACTIONS(1123),
    [sym__cond_left_section_op] = ACTIONS(1123),
    [sym__cond_no_section_op] = ACTIONS(1123),
    [sym__cond_minus] = ACTIONS(1123),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [512] = {
    [sym__type_parens] = STATE(3557),
    [sym__type_tuple] = STATE(3612),
    [sym__type_unboxed_tuple] = STATE(3607),
    [sym__type_unboxed_sum] = STATE(3606),
    [sym__type_list] = STATE(3605),
    [sym__type_promoted] = STATE(3638),
    [sym__type_star] = STATE(3638),
    [sym__type_wildcard] = STATE(3638),
    [sym__at_type] = STATE(3519),
    [sym__type_apply] = STATE(3604),
    [sym__type_infix] = STATE(3602),
    [sym_type] = STATE(503),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8544),
    [sym__splice_dollars] = STATE(7350),
    [sym_splice] = STATE(3638),
    [sym_quasiquote] = STATE(3638),
    [sym_integer] = STATE(3509),
    [sym__plist] = STATE(3597),
    [sym_unit] = STATE(3638),
    [sym_unboxed_unit] = STATE(3638),
    [sym_prefix_tuple] = STATE(3638),
    [sym_prefix_unboxed_tuple] = STATE(3638),
    [sym_prefix_unboxed_sum] = STATE(3638),
    [sym_literal] = STATE(3638),
    [sym__qualified_type] = STATE(3643),
    [sym__qtyconid] = STATE(3583),
    [sym__tycon_arrow] = STATE(3583),
    [sym__qtycon_arrow] = STATE(3583),
    [sym__promoted_tycons_alias] = STATE(3638),
    [sym__promoted_tycons] = STATE(3638),
    [sym__tycon_ticked] = STATE(2397),
    [sym__qtycon_ticked] = STATE(2397),
    [sym__tyconids_ticked] = STATE(2397),
    [sym__promoted_tyconops_alias] = STATE(2397),
    [sym__promoted_tyconops] = STATE(2397),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2397),
    [sym__operator_alias] = STATE(2397),
    [sym__operator_minus] = STATE(2397),
    [sym__varsym_prefix] = STATE(3583),
    [sym__pvarsym] = STATE(3583),
    [sym__qualified_varsym] = STATE(2493),
    [sym__qvarsym_prefix] = STATE(3583),
    [sym__pqvarsym] = STATE(3583),
    [sym_constructor_operator] = STATE(2397),
    [sym__constructor_operator_alias] = STATE(2397),
    [sym__consym_prefix] = STATE(3583),
    [sym__pconsym] = STATE(3583),
    [sym__qualified_consym] = STATE(2537),
    [sym__qconsym_prefix] = STATE(3583),
    [sym__pqconsym] = STATE(3583),
    [sym__prefix_at] = STATE(2688),
    [sym__paren_open] = STATE(461),
    [sym__bracket_open] = STATE(1131),
    [sym__unboxed_open] = STATE(829),
    [sym_variable] = ACTIONS(1669),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1671),
    [anon_sym_SQUOTE] = ACTIONS(1673),
    [anon_sym_STAR] = ACTIONS(1675),
    [anon_sym_u2605] = ACTIONS(1677),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(1679),
    [sym_char] = ACTIONS(1679),
    [sym_string] = ACTIONS(1679),
    [sym__integer_literal] = ACTIONS(1681),
    [sym__binary_literal] = ACTIONS(1683),
    [sym__octal_literal] = ACTIONS(1683),
    [sym__hex_literal] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1685),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [513] = {
    [sym__type_parens] = STATE(3701),
    [sym__type_tuple] = STATE(3702),
    [sym__type_unboxed_tuple] = STATE(3709),
    [sym__type_unboxed_sum] = STATE(3711),
    [sym__type_list] = STATE(3712),
    [sym__type_promoted] = STATE(3699),
    [sym__type_star] = STATE(3699),
    [sym__type_wildcard] = STATE(3699),
    [sym__at_type] = STATE(3743),
    [sym__type_apply] = STATE(3715),
    [sym__type_infix] = STATE(3717),
    [sym_type] = STATE(517),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8438),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(3699),
    [sym_quasiquote] = STATE(3699),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(3718),
    [sym_unit] = STATE(3699),
    [sym_unboxed_unit] = STATE(3699),
    [sym_prefix_tuple] = STATE(3699),
    [sym_prefix_unboxed_tuple] = STATE(3699),
    [sym_prefix_unboxed_sum] = STATE(3699),
    [sym_literal] = STATE(3699),
    [sym__qualified_type] = STATE(3703),
    [sym__qtyconid] = STATE(3721),
    [sym__tycon_arrow] = STATE(3721),
    [sym__qtycon_arrow] = STATE(3721),
    [sym__promoted_tycons_alias] = STATE(3699),
    [sym__promoted_tycons] = STATE(3699),
    [sym__tycon_ticked] = STATE(2511),
    [sym__qtycon_ticked] = STATE(2511),
    [sym__tyconids_ticked] = STATE(2511),
    [sym__promoted_tyconops_alias] = STATE(2511),
    [sym__promoted_tyconops] = STATE(2511),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2511),
    [sym__operator_alias] = STATE(2511),
    [sym__operator_minus] = STATE(2511),
    [sym__varsym_prefix] = STATE(3721),
    [sym__pvarsym] = STATE(3721),
    [sym__qualified_varsym] = STATE(2510),
    [sym__qvarsym_prefix] = STATE(3721),
    [sym__pqvarsym] = STATE(3721),
    [sym_constructor_operator] = STATE(2511),
    [sym__constructor_operator_alias] = STATE(2511),
    [sym__consym_prefix] = STATE(3721),
    [sym__pconsym] = STATE(3721),
    [sym__qualified_consym] = STATE(2508),
    [sym__qconsym_prefix] = STATE(3721),
    [sym__pqconsym] = STATE(3721),
    [sym__prefix_at] = STATE(2618),
    [sym__paren_open] = STATE(462),
    [sym__bracket_open] = STATE(1063),
    [sym__unboxed_open] = STATE(768),
    [sym_variable] = ACTIONS(1319),
    [anon_sym_SEMI] = ACTIONS(1321),
    [anon_sym_let] = ACTIONS(1319),
    [anon_sym_LBRACE] = ACTIONS(1321),
    [anon_sym__] = ACTIONS(1689),
    [anon_sym_SQUOTE] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1321),
    [anon_sym_u2605] = ACTIONS(1691),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1321),
    [anon_sym_PIPE] = ACTIONS(1321),
    [anon_sym_BSLASH] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1319),
    [anon_sym_mdo] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1319),
    [anon_sym_case] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_LBRACK] = ACTIONS(1321),
    [anon_sym_u27e6] = ACTIONS(1321),
    [sym_float] = ACTIONS(1321),
    [sym_char] = ACTIONS(1321),
    [sym_string] = ACTIONS(1321),
    [sym__integer_literal] = ACTIONS(1319),
    [sym__binary_literal] = ACTIONS(1321),
    [sym__octal_literal] = ACTIONS(1321),
    [sym__hex_literal] = ACTIONS(1321),
    [anon_sym_BQUOTE] = ACTIONS(1321),
    [anon_sym_POUND] = ACTIONS(1319),
    [anon_sym_POUND2] = ACTIONS(1319),
    [sym_implicit_variable] = ACTIONS(1321),
    [sym_name] = ACTIONS(1321),
    [sym_label] = ACTIONS(1321),
    [anon_sym_COLON_COLON] = ACTIONS(1321),
    [anon_sym_u2237] = ACTIONS(1321),
    [aux_sym__paren_open_token1] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(1319),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1321),
    [sym__cond_layout_end] = ACTIONS(1321),
    [sym__cond_layout_end_explicit] = ACTIONS(1321),
    [sym__phantom_where] = ACTIONS(1321),
    [sym__phantom_bar] = ACTIONS(1321),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1321),
    [sym__cond_splice] = ACTIONS(1321),
    [sym__cond_tight_dot] = ACTIONS(1321),
    [sym__cond_prefix_dot] = ACTIONS(1321),
    [sym__cond_prefix_at] = ACTIONS(1321),
    [sym__cond_qualified_op] = ACTIONS(1321),
    [sym__cond_no_section_op] = ACTIONS(1321),
    [sym__cond_minus] = ACTIONS(1321),
    [sym__varsym] = ACTIONS(1321),
    [sym__consym] = ACTIONS(1321),
  },
  [514] = {
    [sym__type_parens] = STATE(3701),
    [sym__type_tuple] = STATE(3702),
    [sym__type_unboxed_tuple] = STATE(3709),
    [sym__type_unboxed_sum] = STATE(3711),
    [sym__type_list] = STATE(3712),
    [sym__type_promoted] = STATE(3699),
    [sym__type_star] = STATE(3699),
    [sym__type_wildcard] = STATE(3699),
    [sym__at_type] = STATE(3743),
    [sym__type_apply] = STATE(3715),
    [sym__type_infix] = STATE(3717),
    [sym_type] = STATE(517),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8438),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(3699),
    [sym_quasiquote] = STATE(3699),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(3718),
    [sym_unit] = STATE(3699),
    [sym_unboxed_unit] = STATE(3699),
    [sym_prefix_tuple] = STATE(3699),
    [sym_prefix_unboxed_tuple] = STATE(3699),
    [sym_prefix_unboxed_sum] = STATE(3699),
    [sym_literal] = STATE(3699),
    [sym__qualified_type] = STATE(3703),
    [sym__qtyconid] = STATE(3721),
    [sym__tycon_arrow] = STATE(3721),
    [sym__qtycon_arrow] = STATE(3721),
    [sym__promoted_tycons_alias] = STATE(3699),
    [sym__promoted_tycons] = STATE(3699),
    [sym__tycon_ticked] = STATE(2511),
    [sym__qtycon_ticked] = STATE(2511),
    [sym__tyconids_ticked] = STATE(2511),
    [sym__promoted_tyconops_alias] = STATE(2511),
    [sym__promoted_tyconops] = STATE(2511),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2511),
    [sym__operator_alias] = STATE(2511),
    [sym__operator_minus] = STATE(2511),
    [sym__varsym_prefix] = STATE(3721),
    [sym__pvarsym] = STATE(3721),
    [sym__qualified_varsym] = STATE(2510),
    [sym__qvarsym_prefix] = STATE(3721),
    [sym__pqvarsym] = STATE(3721),
    [sym_constructor_operator] = STATE(2511),
    [sym__constructor_operator_alias] = STATE(2511),
    [sym__consym_prefix] = STATE(3721),
    [sym__pconsym] = STATE(3721),
    [sym__qualified_consym] = STATE(2508),
    [sym__qconsym_prefix] = STATE(3721),
    [sym__pqconsym] = STATE(3721),
    [sym__prefix_at] = STATE(2618),
    [sym__paren_open] = STATE(462),
    [sym__bracket_open] = STATE(1063),
    [sym__unboxed_open] = STATE(768),
    [sym_variable] = ACTIONS(1693),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym_let] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1689),
    [anon_sym_SQUOTE] = ACTIONS(1695),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_u2605] = ACTIONS(1691),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1157),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_BSLASH] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_mdo] = ACTIONS(1159),
    [anon_sym_do] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1157),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1157),
    [sym_name] = ACTIONS(1701),
    [sym_label] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1159),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1157),
    [sym__cond_layout_end] = ACTIONS(1157),
    [sym__cond_layout_end_explicit] = ACTIONS(1157),
    [sym__phantom_where] = ACTIONS(1157),
    [sym__phantom_bar] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1703),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1157),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__cond_minus] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [515] = {
    [sym__type_parens] = STATE(3701),
    [sym__type_tuple] = STATE(3702),
    [sym__type_unboxed_tuple] = STATE(3709),
    [sym__type_unboxed_sum] = STATE(3711),
    [sym__type_list] = STATE(3712),
    [sym__type_promoted] = STATE(3699),
    [sym__type_star] = STATE(3699),
    [sym__type_wildcard] = STATE(3699),
    [sym__at_type] = STATE(3743),
    [sym__type_apply] = STATE(3715),
    [sym__type_infix] = STATE(3717),
    [sym_type] = STATE(517),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8438),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(3699),
    [sym_quasiquote] = STATE(3699),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(3718),
    [sym_unit] = STATE(3699),
    [sym_unboxed_unit] = STATE(3699),
    [sym_prefix_tuple] = STATE(3699),
    [sym_prefix_unboxed_tuple] = STATE(3699),
    [sym_prefix_unboxed_sum] = STATE(3699),
    [sym_literal] = STATE(3699),
    [sym__qualified_type] = STATE(3703),
    [sym__qtyconid] = STATE(3721),
    [sym__tycon_arrow] = STATE(3721),
    [sym__qtycon_arrow] = STATE(3721),
    [sym__promoted_tycons_alias] = STATE(3699),
    [sym__promoted_tycons] = STATE(3699),
    [sym__tycon_ticked] = STATE(2511),
    [sym__qtycon_ticked] = STATE(2511),
    [sym__tyconids_ticked] = STATE(2511),
    [sym__promoted_tyconops_alias] = STATE(2511),
    [sym__promoted_tyconops] = STATE(2511),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2511),
    [sym__operator_alias] = STATE(2511),
    [sym__operator_minus] = STATE(2511),
    [sym__varsym_prefix] = STATE(3721),
    [sym__pvarsym] = STATE(3721),
    [sym__qualified_varsym] = STATE(2510),
    [sym__qvarsym_prefix] = STATE(3721),
    [sym__pqvarsym] = STATE(3721),
    [sym_constructor_operator] = STATE(2511),
    [sym__constructor_operator_alias] = STATE(2511),
    [sym__consym_prefix] = STATE(3721),
    [sym__pconsym] = STATE(3721),
    [sym__qualified_consym] = STATE(2508),
    [sym__qconsym_prefix] = STATE(3721),
    [sym__pqconsym] = STATE(3721),
    [sym__prefix_at] = STATE(2618),
    [sym__paren_open] = STATE(462),
    [sym__bracket_open] = STATE(1063),
    [sym__unboxed_open] = STATE(768),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1689),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1691),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(1177),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym__phantom_where] = ACTIONS(1179),
    [sym__phantom_bar] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [516] = {
    [sym__type_parens] = STATE(3701),
    [sym__type_tuple] = STATE(3702),
    [sym__type_unboxed_tuple] = STATE(3709),
    [sym__type_unboxed_sum] = STATE(3711),
    [sym__type_list] = STATE(3712),
    [sym__type_promoted] = STATE(3699),
    [sym__type_star] = STATE(3699),
    [sym__type_wildcard] = STATE(3699),
    [sym__at_type] = STATE(3743),
    [sym__type_apply] = STATE(3715),
    [sym__type_infix] = STATE(3717),
    [sym_type] = STATE(517),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8438),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(3699),
    [sym_quasiquote] = STATE(3699),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(3718),
    [sym_unit] = STATE(3699),
    [sym_unboxed_unit] = STATE(3699),
    [sym_prefix_tuple] = STATE(3699),
    [sym_prefix_unboxed_tuple] = STATE(3699),
    [sym_prefix_unboxed_sum] = STATE(3699),
    [sym_literal] = STATE(3699),
    [sym__qualified_type] = STATE(3703),
    [sym__qtyconid] = STATE(3721),
    [sym__tycon_arrow] = STATE(3721),
    [sym__qtycon_arrow] = STATE(3721),
    [sym__promoted_tycons_alias] = STATE(3699),
    [sym__promoted_tycons] = STATE(3699),
    [sym__tycon_ticked] = STATE(2511),
    [sym__qtycon_ticked] = STATE(2511),
    [sym__tyconids_ticked] = STATE(2511),
    [sym__promoted_tyconops_alias] = STATE(2511),
    [sym__promoted_tyconops] = STATE(2511),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2511),
    [sym__operator_alias] = STATE(2511),
    [sym__operator_minus] = STATE(2511),
    [sym__varsym_prefix] = STATE(3721),
    [sym__pvarsym] = STATE(3721),
    [sym__qualified_varsym] = STATE(2510),
    [sym__qvarsym_prefix] = STATE(3721),
    [sym__pqvarsym] = STATE(3721),
    [sym_constructor_operator] = STATE(2511),
    [sym__constructor_operator_alias] = STATE(2511),
    [sym__consym_prefix] = STATE(3721),
    [sym__pconsym] = STATE(3721),
    [sym__qualified_consym] = STATE(2508),
    [sym__qconsym_prefix] = STATE(3721),
    [sym__pqconsym] = STATE(3721),
    [sym__prefix_at] = STATE(2618),
    [sym__paren_open] = STATE(462),
    [sym__bracket_open] = STATE(1063),
    [sym__unboxed_open] = STATE(768),
    [sym_variable] = ACTIONS(1693),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1689),
    [anon_sym_SQUOTE] = ACTIONS(1695),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_u2605] = ACTIONS(1691),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1701),
    [sym_label] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_where] = ACTIONS(1181),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1703),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [517] = {
    [sym__type_parens] = STATE(3701),
    [sym__type_tuple] = STATE(3702),
    [sym__type_unboxed_tuple] = STATE(3709),
    [sym__type_unboxed_sum] = STATE(3711),
    [sym__type_list] = STATE(3712),
    [sym__type_promoted] = STATE(3699),
    [sym__type_star] = STATE(3699),
    [sym__type_wildcard] = STATE(3699),
    [sym__at_type] = STATE(3743),
    [sym__type_apply] = STATE(3715),
    [sym__type_infix] = STATE(3717),
    [sym_type] = STATE(517),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8438),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(3699),
    [sym_quasiquote] = STATE(3699),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(3718),
    [sym_unit] = STATE(3699),
    [sym_unboxed_unit] = STATE(3699),
    [sym_prefix_tuple] = STATE(3699),
    [sym_prefix_unboxed_tuple] = STATE(3699),
    [sym_prefix_unboxed_sum] = STATE(3699),
    [sym_literal] = STATE(3699),
    [sym__qualified_type] = STATE(3703),
    [sym__qtyconid] = STATE(3721),
    [sym__tycon_arrow] = STATE(3721),
    [sym__qtycon_arrow] = STATE(3721),
    [sym__promoted_tycons_alias] = STATE(3699),
    [sym__promoted_tycons] = STATE(3699),
    [sym__tycon_ticked] = STATE(2511),
    [sym__qtycon_ticked] = STATE(2511),
    [sym__tyconids_ticked] = STATE(2511),
    [sym__promoted_tyconops_alias] = STATE(2511),
    [sym__promoted_tyconops] = STATE(2511),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2511),
    [sym__operator_alias] = STATE(2511),
    [sym__operator_minus] = STATE(2511),
    [sym__varsym_prefix] = STATE(3721),
    [sym__pvarsym] = STATE(3721),
    [sym__qualified_varsym] = STATE(2510),
    [sym__qvarsym_prefix] = STATE(3721),
    [sym__pqvarsym] = STATE(3721),
    [sym_constructor_operator] = STATE(2511),
    [sym__constructor_operator_alias] = STATE(2511),
    [sym__consym_prefix] = STATE(3721),
    [sym__pconsym] = STATE(3721),
    [sym__qualified_consym] = STATE(2508),
    [sym__qconsym_prefix] = STATE(3721),
    [sym__pqconsym] = STATE(3721),
    [sym__prefix_at] = STATE(2618),
    [sym__paren_open] = STATE(462),
    [sym__bracket_open] = STATE(1063),
    [sym__unboxed_open] = STATE(768),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_mdo] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_u27e6] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1117),
    [sym_implicit_variable] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [sym_label] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [anon_sym_where] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1119),
    [sym__cond_layout_end] = ACTIONS(1119),
    [sym__cond_layout_end_explicit] = ACTIONS(1119),
    [sym__phantom_where] = ACTIONS(1119),
    [sym__phantom_bar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_tight_dot] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__cond_minus] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [518] = {
    [sym__type_parens] = STATE(3701),
    [sym__type_tuple] = STATE(3702),
    [sym__type_unboxed_tuple] = STATE(3709),
    [sym__type_unboxed_sum] = STATE(3711),
    [sym__type_list] = STATE(3712),
    [sym__type_promoted] = STATE(3699),
    [sym__type_star] = STATE(3699),
    [sym__type_wildcard] = STATE(3699),
    [sym__at_type] = STATE(3743),
    [sym__type_apply] = STATE(3715),
    [sym__type_infix] = STATE(3717),
    [sym_type] = STATE(517),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8438),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(3699),
    [sym_quasiquote] = STATE(3699),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(3718),
    [sym_unit] = STATE(3699),
    [sym_unboxed_unit] = STATE(3699),
    [sym_prefix_tuple] = STATE(3699),
    [sym_prefix_unboxed_tuple] = STATE(3699),
    [sym_prefix_unboxed_sum] = STATE(3699),
    [sym_literal] = STATE(3699),
    [sym__qualified_type] = STATE(3703),
    [sym__qtyconid] = STATE(3721),
    [sym__tycon_arrow] = STATE(3721),
    [sym__qtycon_arrow] = STATE(3721),
    [sym__promoted_tycons_alias] = STATE(3699),
    [sym__promoted_tycons] = STATE(3699),
    [sym__tycon_ticked] = STATE(2511),
    [sym__qtycon_ticked] = STATE(2511),
    [sym__tyconids_ticked] = STATE(2511),
    [sym__promoted_tyconops_alias] = STATE(2511),
    [sym__promoted_tyconops] = STATE(2511),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2511),
    [sym__operator_alias] = STATE(2511),
    [sym__operator_minus] = STATE(2511),
    [sym__varsym_prefix] = STATE(3721),
    [sym__pvarsym] = STATE(3721),
    [sym__qualified_varsym] = STATE(2510),
    [sym__qvarsym_prefix] = STATE(3721),
    [sym__pqvarsym] = STATE(3721),
    [sym_constructor_operator] = STATE(2511),
    [sym__constructor_operator_alias] = STATE(2511),
    [sym__consym_prefix] = STATE(3721),
    [sym__pconsym] = STATE(3721),
    [sym__qualified_consym] = STATE(2508),
    [sym__qconsym_prefix] = STATE(3721),
    [sym__pqconsym] = STATE(3721),
    [sym__prefix_at] = STATE(2618),
    [sym__paren_open] = STATE(462),
    [sym__bracket_open] = STATE(1063),
    [sym__unboxed_open] = STATE(768),
    [sym_variable] = ACTIONS(1693),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1689),
    [anon_sym_SQUOTE] = ACTIONS(1695),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_u2605] = ACTIONS(1691),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1701),
    [sym_label] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_where] = ACTIONS(1181),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1703),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [519] = {
    [sym__type_parens] = STATE(3701),
    [sym__type_tuple] = STATE(3702),
    [sym__type_unboxed_tuple] = STATE(3709),
    [sym__type_unboxed_sum] = STATE(3711),
    [sym__type_list] = STATE(3712),
    [sym__type_promoted] = STATE(3699),
    [sym__type_star] = STATE(3699),
    [sym__type_wildcard] = STATE(3699),
    [sym__at_type] = STATE(3743),
    [sym__type_apply] = STATE(3715),
    [sym__type_infix] = STATE(3717),
    [sym_type] = STATE(517),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8438),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(3699),
    [sym_quasiquote] = STATE(3699),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(3718),
    [sym_unit] = STATE(3699),
    [sym_unboxed_unit] = STATE(3699),
    [sym_prefix_tuple] = STATE(3699),
    [sym_prefix_unboxed_tuple] = STATE(3699),
    [sym_prefix_unboxed_sum] = STATE(3699),
    [sym_literal] = STATE(3699),
    [sym__qualified_type] = STATE(3703),
    [sym__qtyconid] = STATE(3721),
    [sym__tycon_arrow] = STATE(3721),
    [sym__qtycon_arrow] = STATE(3721),
    [sym__promoted_tycons_alias] = STATE(3699),
    [sym__promoted_tycons] = STATE(3699),
    [sym__tycon_ticked] = STATE(2511),
    [sym__qtycon_ticked] = STATE(2511),
    [sym__tyconids_ticked] = STATE(2511),
    [sym__promoted_tyconops_alias] = STATE(2511),
    [sym__promoted_tyconops] = STATE(2511),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2511),
    [sym__operator_alias] = STATE(2511),
    [sym__operator_minus] = STATE(2511),
    [sym__varsym_prefix] = STATE(3721),
    [sym__pvarsym] = STATE(3721),
    [sym__qualified_varsym] = STATE(2510),
    [sym__qvarsym_prefix] = STATE(3721),
    [sym__pqvarsym] = STATE(3721),
    [sym_constructor_operator] = STATE(2511),
    [sym__constructor_operator_alias] = STATE(2511),
    [sym__consym_prefix] = STATE(3721),
    [sym__pconsym] = STATE(3721),
    [sym__qualified_consym] = STATE(2508),
    [sym__qconsym_prefix] = STATE(3721),
    [sym__pqconsym] = STATE(3721),
    [sym__prefix_at] = STATE(2618),
    [sym__paren_open] = STATE(462),
    [sym__bracket_open] = STATE(1063),
    [sym__unboxed_open] = STATE(768),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(1177),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym__phantom_where] = ACTIONS(1179),
    [sym__phantom_bar] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [520] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__at_type] = STATE(3896),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(522),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8466),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__tycon_ticked] = STATE(2438),
    [sym__qtycon_ticked] = STATE(2438),
    [sym__tyconids_ticked] = STATE(2438),
    [sym__promoted_tyconops_alias] = STATE(2438),
    [sym__promoted_tyconops] = STATE(2438),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2438),
    [sym__operator_alias] = STATE(2438),
    [sym__operator_minus] = STATE(2438),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(2439),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(2438),
    [sym__constructor_operator_alias] = STATE(2438),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(2440),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_at] = STATE(2586),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_RBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_instance] = ACTIONS(1177),
    [anon_sym_then] = ACTIONS(1177),
    [anon_sym_using] = ACTIONS(1177),
    [anon_sym_else] = ACTIONS(1177),
    [anon_sym_of] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1179),
    [anon_sym_u27e7] = ACTIONS(1179),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1179),
    [anon_sym_u22b8] = ACTIONS(1179),
    [anon_sym_LT_DASH] = ACTIONS(1179),
    [anon_sym_u2190] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__paren_close_token1] = ACTIONS(1179),
    [anon_sym_RBRACK] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_prefix_percent] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [521] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__at_type] = STATE(3896),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(522),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8466),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__tycon_ticked] = STATE(2438),
    [sym__qtycon_ticked] = STATE(2438),
    [sym__tyconids_ticked] = STATE(2438),
    [sym__promoted_tyconops_alias] = STATE(2438),
    [sym__promoted_tyconops] = STATE(2438),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2438),
    [sym__operator_alias] = STATE(2438),
    [sym__operator_minus] = STATE(2438),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(2439),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(2438),
    [sym__constructor_operator_alias] = STATE(2438),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(2440),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_at] = STATE(2586),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_RBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1707),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_EQ] = ACTIONS(1157),
    [anon_sym_instance] = ACTIONS(1159),
    [anon_sym_then] = ACTIONS(1159),
    [anon_sym_using] = ACTIONS(1159),
    [anon_sym_else] = ACTIONS(1159),
    [anon_sym_of] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1157),
    [anon_sym_u27e7] = ACTIONS(1157),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(1157),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1157),
    [anon_sym_u22b8] = ACTIONS(1157),
    [anon_sym_LT_DASH] = ACTIONS(1157),
    [anon_sym_u2190] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1157),
    [anon_sym_RBRACK] = ACTIONS(1157),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [522] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__at_type] = STATE(3896),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(522),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8466),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__tycon_ticked] = STATE(2438),
    [sym__qtycon_ticked] = STATE(2438),
    [sym__tyconids_ticked] = STATE(2438),
    [sym__promoted_tyconops_alias] = STATE(2438),
    [sym__promoted_tyconops] = STATE(2438),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2438),
    [sym__operator_alias] = STATE(2438),
    [sym__operator_minus] = STATE(2438),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(2439),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(2438),
    [sym__constructor_operator_alias] = STATE(2438),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(2440),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_at] = STATE(2586),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_RBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_EQ] = ACTIONS(1119),
    [anon_sym_instance] = ACTIONS(1117),
    [anon_sym_then] = ACTIONS(1117),
    [anon_sym_using] = ACTIONS(1117),
    [anon_sym_else] = ACTIONS(1117),
    [anon_sym_of] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1119),
    [anon_sym_u27e7] = ACTIONS(1119),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1119),
    [anon_sym_u22b8] = ACTIONS(1119),
    [anon_sym_LT_DASH] = ACTIONS(1119),
    [anon_sym_u2190] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__paren_close_token1] = ACTIONS(1119),
    [anon_sym_RBRACK] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_prefix_percent] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [523] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__at_type] = STATE(3896),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(522),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8466),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__tycon_ticked] = STATE(2438),
    [sym__qtycon_ticked] = STATE(2438),
    [sym__tyconids_ticked] = STATE(2438),
    [sym__promoted_tyconops_alias] = STATE(2438),
    [sym__promoted_tyconops] = STATE(2438),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2438),
    [sym__operator_alias] = STATE(2438),
    [sym__operator_minus] = STATE(2438),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(2439),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(2438),
    [sym__constructor_operator_alias] = STATE(2438),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(2440),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_at] = STATE(2586),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1707),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_EQ] = ACTIONS(1181),
    [anon_sym_instance] = ACTIONS(1183),
    [anon_sym_then] = ACTIONS(1183),
    [anon_sym_using] = ACTIONS(1183),
    [anon_sym_else] = ACTIONS(1183),
    [anon_sym_of] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1181),
    [anon_sym_u27e7] = ACTIONS(1181),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(1181),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_LT_DASH] = ACTIONS(1181),
    [anon_sym_u2190] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1181),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [524] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__at_type] = STATE(3896),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(522),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8466),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__tycon_ticked] = STATE(2438),
    [sym__qtycon_ticked] = STATE(2438),
    [sym__tyconids_ticked] = STATE(2438),
    [sym__promoted_tyconops_alias] = STATE(2438),
    [sym__promoted_tyconops] = STATE(2438),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2438),
    [sym__operator_alias] = STATE(2438),
    [sym__operator_minus] = STATE(2438),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(2439),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(2438),
    [sym__constructor_operator_alias] = STATE(2438),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(2440),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_at] = STATE(2586),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1707),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_EQ] = ACTIONS(1181),
    [anon_sym_instance] = ACTIONS(1183),
    [anon_sym_then] = ACTIONS(1183),
    [anon_sym_using] = ACTIONS(1183),
    [anon_sym_else] = ACTIONS(1183),
    [anon_sym_of] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1181),
    [anon_sym_u27e7] = ACTIONS(1181),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(1181),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_LT_DASH] = ACTIONS(1181),
    [anon_sym_u2190] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1181),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [525] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__at_type] = STATE(3896),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(522),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8466),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__tycon_ticked] = STATE(2438),
    [sym__qtycon_ticked] = STATE(2438),
    [sym__tyconids_ticked] = STATE(2438),
    [sym__promoted_tyconops_alias] = STATE(2438),
    [sym__promoted_tyconops] = STATE(2438),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2438),
    [sym__operator_alias] = STATE(2438),
    [sym__operator_minus] = STATE(2438),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(2439),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(2438),
    [sym__constructor_operator_alias] = STATE(2438),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(2440),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_at] = STATE(2586),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1707),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_EQ] = ACTIONS(1123),
    [anon_sym_instance] = ACTIONS(1125),
    [anon_sym_then] = ACTIONS(1125),
    [anon_sym_using] = ACTIONS(1125),
    [anon_sym_else] = ACTIONS(1125),
    [anon_sym_of] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1123),
    [anon_sym_u27e7] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(1123),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(1123),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1123),
    [anon_sym_u22b8] = ACTIONS(1123),
    [anon_sym_LT_DASH] = ACTIONS(1123),
    [anon_sym_u2190] = ACTIONS(1123),
    [anon_sym_COLON_COLON] = ACTIONS(1123),
    [anon_sym_u2237] = ACTIONS(1123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1123),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1123),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [526] = {
    [sym__type_parens] = STATE(3996),
    [sym__type_tuple] = STATE(3989),
    [sym__type_unboxed_tuple] = STATE(4000),
    [sym__type_unboxed_sum] = STATE(4001),
    [sym__type_list] = STATE(4003),
    [sym__type_promoted] = STATE(3975),
    [sym__type_star] = STATE(3975),
    [sym__type_wildcard] = STATE(3975),
    [sym__at_type] = STATE(4035),
    [sym__type_apply] = STATE(4004),
    [sym__type_infix] = STATE(4005),
    [sym_type] = STATE(526),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8507),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(3975),
    [sym_quasiquote] = STATE(3975),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4006),
    [sym_unit] = STATE(3975),
    [sym_unboxed_unit] = STATE(3975),
    [sym_prefix_tuple] = STATE(3975),
    [sym_prefix_unboxed_tuple] = STATE(3975),
    [sym_prefix_unboxed_sum] = STATE(3975),
    [sym_literal] = STATE(3975),
    [sym__qualified_type] = STATE(4144),
    [sym__qtyconid] = STATE(3997),
    [sym__tycon_arrow] = STATE(3997),
    [sym__qtycon_arrow] = STATE(3997),
    [sym__promoted_tycons_alias] = STATE(3975),
    [sym__promoted_tycons] = STATE(3975),
    [sym__tycon_ticked] = STATE(2627),
    [sym__qtycon_ticked] = STATE(2627),
    [sym__tyconids_ticked] = STATE(2627),
    [sym__promoted_tyconops_alias] = STATE(2627),
    [sym__promoted_tyconops] = STATE(2627),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2627),
    [sym__operator_alias] = STATE(2627),
    [sym__operator_minus] = STATE(2627),
    [sym__varsym_prefix] = STATE(3997),
    [sym__pvarsym] = STATE(3997),
    [sym__qualified_varsym] = STATE(2628),
    [sym__qvarsym_prefix] = STATE(3997),
    [sym__pqvarsym] = STATE(3997),
    [sym_constructor_operator] = STATE(2627),
    [sym__constructor_operator_alias] = STATE(2627),
    [sym__consym_prefix] = STATE(3997),
    [sym__pconsym] = STATE(3997),
    [sym__qualified_consym] = STATE(2629),
    [sym__qconsym_prefix] = STATE(3997),
    [sym__pqconsym] = STATE(3997),
    [sym__prefix_at] = STATE(2475),
    [sym__paren_open] = STATE(452),
    [sym__bracket_open] = STATE(1122),
    [sym__unboxed_open] = STATE(806),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1119),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_mdo] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_u27e6] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1117),
    [sym_implicit_variable] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [sym_label] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [anon_sym_where] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1119),
    [sym__cond_layout_end] = ACTIONS(1119),
    [sym__cond_layout_end_explicit] = ACTIONS(1119),
    [sym__phantom_where] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_tight_dot] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__cond_minus] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [527] = {
    [sym__type_parens] = STATE(3996),
    [sym__type_tuple] = STATE(3989),
    [sym__type_unboxed_tuple] = STATE(4000),
    [sym__type_unboxed_sum] = STATE(4001),
    [sym__type_list] = STATE(4003),
    [sym__type_promoted] = STATE(3975),
    [sym__type_star] = STATE(3975),
    [sym__type_wildcard] = STATE(3975),
    [sym__at_type] = STATE(4035),
    [sym__type_apply] = STATE(4004),
    [sym__type_infix] = STATE(4005),
    [sym_type] = STATE(526),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8507),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(3975),
    [sym_quasiquote] = STATE(3975),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4006),
    [sym_unit] = STATE(3975),
    [sym_unboxed_unit] = STATE(3975),
    [sym_prefix_tuple] = STATE(3975),
    [sym_prefix_unboxed_tuple] = STATE(3975),
    [sym_prefix_unboxed_sum] = STATE(3975),
    [sym_literal] = STATE(3975),
    [sym__qualified_type] = STATE(4144),
    [sym__qtyconid] = STATE(3997),
    [sym__tycon_arrow] = STATE(3997),
    [sym__qtycon_arrow] = STATE(3997),
    [sym__promoted_tycons_alias] = STATE(3975),
    [sym__promoted_tycons] = STATE(3975),
    [sym__tycon_ticked] = STATE(2627),
    [sym__qtycon_ticked] = STATE(2627),
    [sym__tyconids_ticked] = STATE(2627),
    [sym__promoted_tyconops_alias] = STATE(2627),
    [sym__promoted_tyconops] = STATE(2627),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2627),
    [sym__operator_alias] = STATE(2627),
    [sym__operator_minus] = STATE(2627),
    [sym__varsym_prefix] = STATE(3997),
    [sym__pvarsym] = STATE(3997),
    [sym__qualified_varsym] = STATE(2628),
    [sym__qvarsym_prefix] = STATE(3997),
    [sym__pqvarsym] = STATE(3997),
    [sym_constructor_operator] = STATE(2627),
    [sym__constructor_operator_alias] = STATE(2627),
    [sym__consym_prefix] = STATE(3997),
    [sym__pconsym] = STATE(3997),
    [sym__qualified_consym] = STATE(2629),
    [sym__qconsym_prefix] = STATE(3997),
    [sym__pqconsym] = STATE(3997),
    [sym__prefix_at] = STATE(2475),
    [sym__paren_open] = STATE(452),
    [sym__bracket_open] = STATE(1122),
    [sym__unboxed_open] = STATE(806),
    [sym_variable] = ACTIONS(1711),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1713),
    [anon_sym_SQUOTE] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1717),
    [anon_sym_u2605] = ACTIONS(1719),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1721),
    [sym_label] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_where] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1723),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [528] = {
    [sym__type_parens] = STATE(4078),
    [sym__type_tuple] = STATE(4080),
    [sym__type_unboxed_tuple] = STATE(4081),
    [sym__type_unboxed_sum] = STATE(4082),
    [sym__type_list] = STATE(4084),
    [sym__type_promoted] = STATE(4075),
    [sym__type_star] = STATE(4075),
    [sym__type_wildcard] = STATE(4075),
    [sym__at_type] = STATE(4132),
    [sym__type_apply] = STATE(4085),
    [sym__type_infix] = STATE(4133),
    [sym_type] = STATE(541),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8476),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4075),
    [sym_quasiquote] = STATE(4075),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4097),
    [sym_unit] = STATE(4075),
    [sym_unboxed_unit] = STATE(4075),
    [sym_prefix_tuple] = STATE(4075),
    [sym_prefix_unboxed_tuple] = STATE(4075),
    [sym_prefix_unboxed_sum] = STATE(4075),
    [sym_literal] = STATE(4075),
    [sym__qualified_type] = STATE(4138),
    [sym__qtyconid] = STATE(4098),
    [sym__tycon_arrow] = STATE(4098),
    [sym__qtycon_arrow] = STATE(4098),
    [sym__promoted_tycons_alias] = STATE(4075),
    [sym__promoted_tycons] = STATE(4075),
    [sym__tycon_ticked] = STATE(2522),
    [sym__qtycon_ticked] = STATE(2522),
    [sym__tyconids_ticked] = STATE(2522),
    [sym__promoted_tyconops_alias] = STATE(2522),
    [sym__promoted_tyconops] = STATE(2522),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2522),
    [sym__operator_alias] = STATE(2522),
    [sym__operator_minus] = STATE(2522),
    [sym__varsym_prefix] = STATE(4098),
    [sym__pvarsym] = STATE(4098),
    [sym__qualified_varsym] = STATE(2524),
    [sym__qvarsym_prefix] = STATE(4098),
    [sym__pqvarsym] = STATE(4098),
    [sym_constructor_operator] = STATE(2522),
    [sym__constructor_operator_alias] = STATE(2522),
    [sym__consym_prefix] = STATE(4098),
    [sym__pconsym] = STATE(4098),
    [sym__qualified_consym] = STATE(2525),
    [sym__qconsym_prefix] = STATE(4098),
    [sym__pqconsym] = STATE(4098),
    [sym__prefix_at] = STATE(2617),
    [sym__paren_open] = STATE(444),
    [sym__bracket_open] = STATE(1041),
    [sym__unboxed_open] = STATE(787),
    [sym_variable] = ACTIONS(1725),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1727),
    [anon_sym_SQUOTE] = ACTIONS(1729),
    [anon_sym_STAR] = ACTIONS(1731),
    [anon_sym_u2605] = ACTIONS(1733),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1735),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1737),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_dotdot] = ACTIONS(1181),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [529] = {
    [sym__type_parens] = STATE(3996),
    [sym__type_tuple] = STATE(3989),
    [sym__type_unboxed_tuple] = STATE(4000),
    [sym__type_unboxed_sum] = STATE(4001),
    [sym__type_list] = STATE(4003),
    [sym__type_promoted] = STATE(3975),
    [sym__type_star] = STATE(3975),
    [sym__type_wildcard] = STATE(3975),
    [sym__at_type] = STATE(4035),
    [sym__type_apply] = STATE(4004),
    [sym__type_infix] = STATE(4005),
    [sym_type] = STATE(526),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8507),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(3975),
    [sym_quasiquote] = STATE(3975),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4006),
    [sym_unit] = STATE(3975),
    [sym_unboxed_unit] = STATE(3975),
    [sym_prefix_tuple] = STATE(3975),
    [sym_prefix_unboxed_tuple] = STATE(3975),
    [sym_prefix_unboxed_sum] = STATE(3975),
    [sym_literal] = STATE(3975),
    [sym__qualified_type] = STATE(4144),
    [sym__qtyconid] = STATE(3997),
    [sym__tycon_arrow] = STATE(3997),
    [sym__qtycon_arrow] = STATE(3997),
    [sym__promoted_tycons_alias] = STATE(3975),
    [sym__promoted_tycons] = STATE(3975),
    [sym__tycon_ticked] = STATE(2627),
    [sym__qtycon_ticked] = STATE(2627),
    [sym__tyconids_ticked] = STATE(2627),
    [sym__promoted_tyconops_alias] = STATE(2627),
    [sym__promoted_tyconops] = STATE(2627),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2627),
    [sym__operator_alias] = STATE(2627),
    [sym__operator_minus] = STATE(2627),
    [sym__varsym_prefix] = STATE(3997),
    [sym__pvarsym] = STATE(3997),
    [sym__qualified_varsym] = STATE(2628),
    [sym__qvarsym_prefix] = STATE(3997),
    [sym__pqvarsym] = STATE(3997),
    [sym_constructor_operator] = STATE(2627),
    [sym__constructor_operator_alias] = STATE(2627),
    [sym__consym_prefix] = STATE(3997),
    [sym__pconsym] = STATE(3997),
    [sym__qualified_consym] = STATE(2629),
    [sym__qconsym_prefix] = STATE(3997),
    [sym__pqconsym] = STATE(3997),
    [sym__prefix_at] = STATE(2475),
    [sym__paren_open] = STATE(452),
    [sym__bracket_open] = STATE(1122),
    [sym__unboxed_open] = STATE(806),
    [sym_variable] = ACTIONS(1711),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1713),
    [anon_sym_SQUOTE] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1717),
    [anon_sym_u2605] = ACTIONS(1719),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1721),
    [sym_label] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_where] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1723),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [530] = {
    [sym__type_parens] = STATE(4078),
    [sym__type_tuple] = STATE(4080),
    [sym__type_unboxed_tuple] = STATE(4081),
    [sym__type_unboxed_sum] = STATE(4082),
    [sym__type_list] = STATE(4084),
    [sym__type_promoted] = STATE(4075),
    [sym__type_star] = STATE(4075),
    [sym__type_wildcard] = STATE(4075),
    [sym__at_type] = STATE(4132),
    [sym__type_apply] = STATE(4085),
    [sym__type_infix] = STATE(4133),
    [sym_type] = STATE(541),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8476),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4075),
    [sym_quasiquote] = STATE(4075),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4097),
    [sym_unit] = STATE(4075),
    [sym_unboxed_unit] = STATE(4075),
    [sym_prefix_tuple] = STATE(4075),
    [sym_prefix_unboxed_tuple] = STATE(4075),
    [sym_prefix_unboxed_sum] = STATE(4075),
    [sym_literal] = STATE(4075),
    [sym__qualified_type] = STATE(4138),
    [sym__qtyconid] = STATE(4098),
    [sym__tycon_arrow] = STATE(4098),
    [sym__qtycon_arrow] = STATE(4098),
    [sym__promoted_tycons_alias] = STATE(4075),
    [sym__promoted_tycons] = STATE(4075),
    [sym__tycon_ticked] = STATE(2522),
    [sym__qtycon_ticked] = STATE(2522),
    [sym__tyconids_ticked] = STATE(2522),
    [sym__promoted_tyconops_alias] = STATE(2522),
    [sym__promoted_tyconops] = STATE(2522),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2522),
    [sym__operator_alias] = STATE(2522),
    [sym__operator_minus] = STATE(2522),
    [sym__varsym_prefix] = STATE(4098),
    [sym__pvarsym] = STATE(4098),
    [sym__qualified_varsym] = STATE(2524),
    [sym__qvarsym_prefix] = STATE(4098),
    [sym__pqvarsym] = STATE(4098),
    [sym_constructor_operator] = STATE(2522),
    [sym__constructor_operator_alias] = STATE(2522),
    [sym__consym_prefix] = STATE(4098),
    [sym__pconsym] = STATE(4098),
    [sym__qualified_consym] = STATE(2525),
    [sym__qconsym_prefix] = STATE(4098),
    [sym__pqconsym] = STATE(4098),
    [sym__prefix_at] = STATE(2617),
    [sym__paren_open] = STATE(444),
    [sym__bracket_open] = STATE(1041),
    [sym__unboxed_open] = STATE(787),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1727),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1733),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_RBRACK] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_dotdot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [531] = {
    [sym__type_parens] = STATE(4027),
    [sym__type_tuple] = STATE(4020),
    [sym__type_unboxed_tuple] = STATE(3988),
    [sym__type_unboxed_sum] = STATE(4177),
    [sym__type_list] = STATE(4056),
    [sym__type_promoted] = STATE(4029),
    [sym__type_star] = STATE(4029),
    [sym__type_wildcard] = STATE(4029),
    [sym__at_type] = STATE(4065),
    [sym__type_apply] = STATE(4047),
    [sym__type_infix] = STATE(4088),
    [sym_type] = STATE(535),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8492),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4029),
    [sym_quasiquote] = STATE(4029),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4041),
    [sym_unit] = STATE(4029),
    [sym_unboxed_unit] = STATE(4029),
    [sym_prefix_tuple] = STATE(4029),
    [sym_prefix_unboxed_tuple] = STATE(4029),
    [sym_prefix_unboxed_sum] = STATE(4029),
    [sym_literal] = STATE(4029),
    [sym__qualified_type] = STATE(4061),
    [sym__qtyconid] = STATE(4046),
    [sym__tycon_arrow] = STATE(4046),
    [sym__qtycon_arrow] = STATE(4046),
    [sym__promoted_tycons_alias] = STATE(4029),
    [sym__promoted_tycons] = STATE(4029),
    [sym__tycon_ticked] = STATE(2530),
    [sym__qtycon_ticked] = STATE(2530),
    [sym__tyconids_ticked] = STATE(2530),
    [sym__promoted_tyconops_alias] = STATE(2530),
    [sym__promoted_tyconops] = STATE(2530),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2530),
    [sym__operator_alias] = STATE(2530),
    [sym__operator_minus] = STATE(2530),
    [sym__varsym_prefix] = STATE(4046),
    [sym__pvarsym] = STATE(4046),
    [sym__qualified_varsym] = STATE(2531),
    [sym__qvarsym_prefix] = STATE(4046),
    [sym__pqvarsym] = STATE(4046),
    [sym_constructor_operator] = STATE(2530),
    [sym__constructor_operator_alias] = STATE(2530),
    [sym__consym_prefix] = STATE(4046),
    [sym__pconsym] = STATE(4046),
    [sym__qualified_consym] = STATE(2532),
    [sym__qconsym_prefix] = STATE(4046),
    [sym__pqconsym] = STATE(4046),
    [sym__prefix_at] = STATE(2587),
    [sym__paren_open] = STATE(470),
    [sym__bracket_open] = STATE(1007),
    [sym__unboxed_open] = STATE(734),
    [sym_variable] = ACTIONS(1319),
    [anon_sym_let] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(1321),
    [anon_sym__] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1321),
    [anon_sym_u2605] = ACTIONS(1741),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1321),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_BSLASH] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1319),
    [anon_sym_mdo] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1319),
    [anon_sym_case] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_DASH_GT] = ACTIONS(1321),
    [anon_sym_LBRACK] = ACTIONS(1321),
    [anon_sym_u27e6] = ACTIONS(1321),
    [sym_float] = ACTIONS(1321),
    [sym_char] = ACTIONS(1321),
    [sym_string] = ACTIONS(1321),
    [sym__integer_literal] = ACTIONS(1319),
    [sym__binary_literal] = ACTIONS(1321),
    [sym__octal_literal] = ACTIONS(1321),
    [sym__hex_literal] = ACTIONS(1321),
    [anon_sym_BQUOTE] = ACTIONS(1321),
    [anon_sym_POUND] = ACTIONS(1319),
    [anon_sym_POUND2] = ACTIONS(1319),
    [anon_sym_PIPE2] = ACTIONS(1321),
    [sym_implicit_variable] = ACTIONS(1321),
    [sym_name] = ACTIONS(1321),
    [sym_label] = ACTIONS(1321),
    [anon_sym_u2192] = ACTIONS(1321),
    [anon_sym_COLON_COLON] = ACTIONS(1321),
    [anon_sym_u2237] = ACTIONS(1321),
    [aux_sym__paren_open_token1] = ACTIONS(1321),
    [anon_sym_POUND_RPAREN] = ACTIONS(1321),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1321),
    [sym__cond_splice] = ACTIONS(1321),
    [sym__cond_tight_dot] = ACTIONS(1321),
    [sym__cond_prefix_dot] = ACTIONS(1321),
    [sym__cond_prefix_at] = ACTIONS(1321),
    [sym__cond_qualified_op] = ACTIONS(1321),
    [sym__cond_no_section_op] = ACTIONS(1321),
    [sym__cond_minus] = ACTIONS(1321),
    [sym__varsym] = ACTIONS(1321),
    [sym__consym] = ACTIONS(1321),
  },
  [532] = {
    [sym__type_parens] = STATE(4027),
    [sym__type_tuple] = STATE(4020),
    [sym__type_unboxed_tuple] = STATE(3988),
    [sym__type_unboxed_sum] = STATE(4177),
    [sym__type_list] = STATE(4056),
    [sym__type_promoted] = STATE(4029),
    [sym__type_star] = STATE(4029),
    [sym__type_wildcard] = STATE(4029),
    [sym__at_type] = STATE(4065),
    [sym__type_apply] = STATE(4047),
    [sym__type_infix] = STATE(4088),
    [sym_type] = STATE(535),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8492),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4029),
    [sym_quasiquote] = STATE(4029),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4041),
    [sym_unit] = STATE(4029),
    [sym_unboxed_unit] = STATE(4029),
    [sym_prefix_tuple] = STATE(4029),
    [sym_prefix_unboxed_tuple] = STATE(4029),
    [sym_prefix_unboxed_sum] = STATE(4029),
    [sym_literal] = STATE(4029),
    [sym__qualified_type] = STATE(4061),
    [sym__qtyconid] = STATE(4046),
    [sym__tycon_arrow] = STATE(4046),
    [sym__qtycon_arrow] = STATE(4046),
    [sym__promoted_tycons_alias] = STATE(4029),
    [sym__promoted_tycons] = STATE(4029),
    [sym__tycon_ticked] = STATE(2530),
    [sym__qtycon_ticked] = STATE(2530),
    [sym__tyconids_ticked] = STATE(2530),
    [sym__promoted_tyconops_alias] = STATE(2530),
    [sym__promoted_tyconops] = STATE(2530),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2530),
    [sym__operator_alias] = STATE(2530),
    [sym__operator_minus] = STATE(2530),
    [sym__varsym_prefix] = STATE(4046),
    [sym__pvarsym] = STATE(4046),
    [sym__qualified_varsym] = STATE(2531),
    [sym__qvarsym_prefix] = STATE(4046),
    [sym__pqvarsym] = STATE(4046),
    [sym_constructor_operator] = STATE(2530),
    [sym__constructor_operator_alias] = STATE(2530),
    [sym__consym_prefix] = STATE(4046),
    [sym__pconsym] = STATE(4046),
    [sym__qualified_consym] = STATE(2532),
    [sym__qconsym_prefix] = STATE(4046),
    [sym__pqconsym] = STATE(4046),
    [sym__prefix_at] = STATE(2587),
    [sym__paren_open] = STATE(470),
    [sym__bracket_open] = STATE(1007),
    [sym__unboxed_open] = STATE(734),
    [sym_variable] = ACTIONS(1743),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1745),
    [anon_sym_STAR] = ACTIONS(1747),
    [anon_sym_u2605] = ACTIONS(1741),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [anon_sym_PIPE2] = ACTIONS(1181),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1749),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1751),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [533] = {
    [sym__type_parens] = STATE(3996),
    [sym__type_tuple] = STATE(3989),
    [sym__type_unboxed_tuple] = STATE(4000),
    [sym__type_unboxed_sum] = STATE(4001),
    [sym__type_list] = STATE(4003),
    [sym__type_promoted] = STATE(3975),
    [sym__type_star] = STATE(3975),
    [sym__type_wildcard] = STATE(3975),
    [sym__at_type] = STATE(4035),
    [sym__type_apply] = STATE(4004),
    [sym__type_infix] = STATE(4005),
    [sym_type] = STATE(526),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8507),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(3975),
    [sym_quasiquote] = STATE(3975),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4006),
    [sym_unit] = STATE(3975),
    [sym_unboxed_unit] = STATE(3975),
    [sym_prefix_tuple] = STATE(3975),
    [sym_prefix_unboxed_tuple] = STATE(3975),
    [sym_prefix_unboxed_sum] = STATE(3975),
    [sym_literal] = STATE(3975),
    [sym__qualified_type] = STATE(4144),
    [sym__qtyconid] = STATE(3997),
    [sym__tycon_arrow] = STATE(3997),
    [sym__qtycon_arrow] = STATE(3997),
    [sym__promoted_tycons_alias] = STATE(3975),
    [sym__promoted_tycons] = STATE(3975),
    [sym__tycon_ticked] = STATE(2627),
    [sym__qtycon_ticked] = STATE(2627),
    [sym__tyconids_ticked] = STATE(2627),
    [sym__promoted_tyconops_alias] = STATE(2627),
    [sym__promoted_tyconops] = STATE(2627),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2627),
    [sym__operator_alias] = STATE(2627),
    [sym__operator_minus] = STATE(2627),
    [sym__varsym_prefix] = STATE(3997),
    [sym__pvarsym] = STATE(3997),
    [sym__qualified_varsym] = STATE(2628),
    [sym__qvarsym_prefix] = STATE(3997),
    [sym__pqvarsym] = STATE(3997),
    [sym_constructor_operator] = STATE(2627),
    [sym__constructor_operator_alias] = STATE(2627),
    [sym__consym_prefix] = STATE(3997),
    [sym__pconsym] = STATE(3997),
    [sym__qualified_consym] = STATE(2629),
    [sym__qconsym_prefix] = STATE(3997),
    [sym__pqconsym] = STATE(3997),
    [sym__prefix_at] = STATE(2475),
    [sym__paren_open] = STATE(452),
    [sym__bracket_open] = STATE(1122),
    [sym__unboxed_open] = STATE(806),
    [sym_variable] = ACTIONS(1319),
    [anon_sym_SEMI] = ACTIONS(1321),
    [anon_sym_let] = ACTIONS(1319),
    [anon_sym_LBRACE] = ACTIONS(1321),
    [anon_sym__] = ACTIONS(1713),
    [anon_sym_SQUOTE] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1321),
    [anon_sym_u2605] = ACTIONS(1719),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1321),
    [anon_sym_BSLASH] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1319),
    [anon_sym_mdo] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1319),
    [anon_sym_case] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_LBRACK] = ACTIONS(1321),
    [anon_sym_u27e6] = ACTIONS(1321),
    [sym_float] = ACTIONS(1321),
    [sym_char] = ACTIONS(1321),
    [sym_string] = ACTIONS(1321),
    [sym__integer_literal] = ACTIONS(1319),
    [sym__binary_literal] = ACTIONS(1321),
    [sym__octal_literal] = ACTIONS(1321),
    [sym__hex_literal] = ACTIONS(1321),
    [anon_sym_BQUOTE] = ACTIONS(1321),
    [anon_sym_POUND] = ACTIONS(1319),
    [anon_sym_POUND2] = ACTIONS(1319),
    [sym_implicit_variable] = ACTIONS(1321),
    [sym_name] = ACTIONS(1321),
    [sym_label] = ACTIONS(1321),
    [anon_sym_COLON_COLON] = ACTIONS(1321),
    [anon_sym_u2237] = ACTIONS(1321),
    [aux_sym__paren_open_token1] = ACTIONS(1321),
    [anon_sym_where] = ACTIONS(1319),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1321),
    [sym__cond_layout_end] = ACTIONS(1321),
    [sym__cond_layout_end_explicit] = ACTIONS(1321),
    [sym__phantom_where] = ACTIONS(1321),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1321),
    [sym__cond_splice] = ACTIONS(1321),
    [sym__cond_tight_dot] = ACTIONS(1321),
    [sym__cond_prefix_dot] = ACTIONS(1321),
    [sym__cond_prefix_at] = ACTIONS(1321),
    [sym__cond_qualified_op] = ACTIONS(1321),
    [sym__cond_no_section_op] = ACTIONS(1321),
    [sym__cond_minus] = ACTIONS(1321),
    [sym__varsym] = ACTIONS(1321),
    [sym__consym] = ACTIONS(1321),
  },
  [534] = {
    [sym__type_parens] = STATE(3996),
    [sym__type_tuple] = STATE(3989),
    [sym__type_unboxed_tuple] = STATE(4000),
    [sym__type_unboxed_sum] = STATE(4001),
    [sym__type_list] = STATE(4003),
    [sym__type_promoted] = STATE(3975),
    [sym__type_star] = STATE(3975),
    [sym__type_wildcard] = STATE(3975),
    [sym__at_type] = STATE(4035),
    [sym__type_apply] = STATE(4004),
    [sym__type_infix] = STATE(4005),
    [sym_type] = STATE(526),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8507),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(3975),
    [sym_quasiquote] = STATE(3975),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4006),
    [sym_unit] = STATE(3975),
    [sym_unboxed_unit] = STATE(3975),
    [sym_prefix_tuple] = STATE(3975),
    [sym_prefix_unboxed_tuple] = STATE(3975),
    [sym_prefix_unboxed_sum] = STATE(3975),
    [sym_literal] = STATE(3975),
    [sym__qualified_type] = STATE(4144),
    [sym__qtyconid] = STATE(3997),
    [sym__tycon_arrow] = STATE(3997),
    [sym__qtycon_arrow] = STATE(3997),
    [sym__promoted_tycons_alias] = STATE(3975),
    [sym__promoted_tycons] = STATE(3975),
    [sym__tycon_ticked] = STATE(2627),
    [sym__qtycon_ticked] = STATE(2627),
    [sym__tyconids_ticked] = STATE(2627),
    [sym__promoted_tyconops_alias] = STATE(2627),
    [sym__promoted_tyconops] = STATE(2627),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2627),
    [sym__operator_alias] = STATE(2627),
    [sym__operator_minus] = STATE(2627),
    [sym__varsym_prefix] = STATE(3997),
    [sym__pvarsym] = STATE(3997),
    [sym__qualified_varsym] = STATE(2628),
    [sym__qvarsym_prefix] = STATE(3997),
    [sym__pqvarsym] = STATE(3997),
    [sym_constructor_operator] = STATE(2627),
    [sym__constructor_operator_alias] = STATE(2627),
    [sym__consym_prefix] = STATE(3997),
    [sym__pconsym] = STATE(3997),
    [sym__qualified_consym] = STATE(2629),
    [sym__qconsym_prefix] = STATE(3997),
    [sym__pqconsym] = STATE(3997),
    [sym__prefix_at] = STATE(2475),
    [sym__paren_open] = STATE(452),
    [sym__bracket_open] = STATE(1122),
    [sym__unboxed_open] = STATE(806),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1713),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1719),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(1177),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym__phantom_where] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [535] = {
    [sym__type_parens] = STATE(4027),
    [sym__type_tuple] = STATE(4020),
    [sym__type_unboxed_tuple] = STATE(3988),
    [sym__type_unboxed_sum] = STATE(4177),
    [sym__type_list] = STATE(4056),
    [sym__type_promoted] = STATE(4029),
    [sym__type_star] = STATE(4029),
    [sym__type_wildcard] = STATE(4029),
    [sym__at_type] = STATE(4065),
    [sym__type_apply] = STATE(4047),
    [sym__type_infix] = STATE(4088),
    [sym_type] = STATE(535),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8492),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4029),
    [sym_quasiquote] = STATE(4029),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4041),
    [sym_unit] = STATE(4029),
    [sym_unboxed_unit] = STATE(4029),
    [sym_prefix_tuple] = STATE(4029),
    [sym_prefix_unboxed_tuple] = STATE(4029),
    [sym_prefix_unboxed_sum] = STATE(4029),
    [sym_literal] = STATE(4029),
    [sym__qualified_type] = STATE(4061),
    [sym__qtyconid] = STATE(4046),
    [sym__tycon_arrow] = STATE(4046),
    [sym__qtycon_arrow] = STATE(4046),
    [sym__promoted_tycons_alias] = STATE(4029),
    [sym__promoted_tycons] = STATE(4029),
    [sym__tycon_ticked] = STATE(2530),
    [sym__qtycon_ticked] = STATE(2530),
    [sym__tyconids_ticked] = STATE(2530),
    [sym__promoted_tyconops_alias] = STATE(2530),
    [sym__promoted_tyconops] = STATE(2530),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2530),
    [sym__operator_alias] = STATE(2530),
    [sym__operator_minus] = STATE(2530),
    [sym__varsym_prefix] = STATE(4046),
    [sym__pvarsym] = STATE(4046),
    [sym__qualified_varsym] = STATE(2531),
    [sym__qvarsym_prefix] = STATE(4046),
    [sym__pqvarsym] = STATE(4046),
    [sym_constructor_operator] = STATE(2530),
    [sym__constructor_operator_alias] = STATE(2530),
    [sym__consym_prefix] = STATE(4046),
    [sym__pconsym] = STATE(4046),
    [sym__qualified_consym] = STATE(2532),
    [sym__qconsym_prefix] = STATE(4046),
    [sym__pqconsym] = STATE(4046),
    [sym__prefix_at] = STATE(2587),
    [sym__paren_open] = STATE(470),
    [sym__bracket_open] = STATE(1007),
    [sym__unboxed_open] = STATE(734),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1117),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_mdo] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_u27e6] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1117),
    [anon_sym_PIPE2] = ACTIONS(1119),
    [sym_implicit_variable] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [sym_label] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [anon_sym_POUND_RPAREN] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_tight_dot] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__cond_minus] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [536] = {
    [sym__type_parens] = STATE(4078),
    [sym__type_tuple] = STATE(4080),
    [sym__type_unboxed_tuple] = STATE(4081),
    [sym__type_unboxed_sum] = STATE(4082),
    [sym__type_list] = STATE(4084),
    [sym__type_promoted] = STATE(4075),
    [sym__type_star] = STATE(4075),
    [sym__type_wildcard] = STATE(4075),
    [sym__at_type] = STATE(4132),
    [sym__type_apply] = STATE(4085),
    [sym__type_infix] = STATE(4133),
    [sym_type] = STATE(541),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8476),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4075),
    [sym_quasiquote] = STATE(4075),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4097),
    [sym_unit] = STATE(4075),
    [sym_unboxed_unit] = STATE(4075),
    [sym_prefix_tuple] = STATE(4075),
    [sym_prefix_unboxed_tuple] = STATE(4075),
    [sym_prefix_unboxed_sum] = STATE(4075),
    [sym_literal] = STATE(4075),
    [sym__qualified_type] = STATE(4138),
    [sym__qtyconid] = STATE(4098),
    [sym__tycon_arrow] = STATE(4098),
    [sym__qtycon_arrow] = STATE(4098),
    [sym__promoted_tycons_alias] = STATE(4075),
    [sym__promoted_tycons] = STATE(4075),
    [sym__tycon_ticked] = STATE(2522),
    [sym__qtycon_ticked] = STATE(2522),
    [sym__tyconids_ticked] = STATE(2522),
    [sym__promoted_tyconops_alias] = STATE(2522),
    [sym__promoted_tyconops] = STATE(2522),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2522),
    [sym__operator_alias] = STATE(2522),
    [sym__operator_minus] = STATE(2522),
    [sym__varsym_prefix] = STATE(4098),
    [sym__pvarsym] = STATE(4098),
    [sym__qualified_varsym] = STATE(2524),
    [sym__qvarsym_prefix] = STATE(4098),
    [sym__pqvarsym] = STATE(4098),
    [sym_constructor_operator] = STATE(2522),
    [sym__constructor_operator_alias] = STATE(2522),
    [sym__consym_prefix] = STATE(4098),
    [sym__pconsym] = STATE(4098),
    [sym__qualified_consym] = STATE(2525),
    [sym__qconsym_prefix] = STATE(4098),
    [sym__pqconsym] = STATE(4098),
    [sym__prefix_at] = STATE(2617),
    [sym__paren_open] = STATE(444),
    [sym__bracket_open] = STATE(1041),
    [sym__unboxed_open] = STATE(787),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_RBRACK] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_dotdot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [537] = {
    [sym__type_parens] = STATE(4027),
    [sym__type_tuple] = STATE(4020),
    [sym__type_unboxed_tuple] = STATE(3988),
    [sym__type_unboxed_sum] = STATE(4177),
    [sym__type_list] = STATE(4056),
    [sym__type_promoted] = STATE(4029),
    [sym__type_star] = STATE(4029),
    [sym__type_wildcard] = STATE(4029),
    [sym__at_type] = STATE(4065),
    [sym__type_apply] = STATE(4047),
    [sym__type_infix] = STATE(4088),
    [sym_type] = STATE(535),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8492),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4029),
    [sym_quasiquote] = STATE(4029),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4041),
    [sym_unit] = STATE(4029),
    [sym_unboxed_unit] = STATE(4029),
    [sym_prefix_tuple] = STATE(4029),
    [sym_prefix_unboxed_tuple] = STATE(4029),
    [sym_prefix_unboxed_sum] = STATE(4029),
    [sym_literal] = STATE(4029),
    [sym__qualified_type] = STATE(4061),
    [sym__qtyconid] = STATE(4046),
    [sym__tycon_arrow] = STATE(4046),
    [sym__qtycon_arrow] = STATE(4046),
    [sym__promoted_tycons_alias] = STATE(4029),
    [sym__promoted_tycons] = STATE(4029),
    [sym__tycon_ticked] = STATE(2530),
    [sym__qtycon_ticked] = STATE(2530),
    [sym__tyconids_ticked] = STATE(2530),
    [sym__promoted_tyconops_alias] = STATE(2530),
    [sym__promoted_tyconops] = STATE(2530),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2530),
    [sym__operator_alias] = STATE(2530),
    [sym__operator_minus] = STATE(2530),
    [sym__varsym_prefix] = STATE(4046),
    [sym__pvarsym] = STATE(4046),
    [sym__qualified_varsym] = STATE(2531),
    [sym__qvarsym_prefix] = STATE(4046),
    [sym__pqvarsym] = STATE(4046),
    [sym_constructor_operator] = STATE(2530),
    [sym__constructor_operator_alias] = STATE(2530),
    [sym__consym_prefix] = STATE(4046),
    [sym__pconsym] = STATE(4046),
    [sym__qualified_consym] = STATE(2532),
    [sym__qconsym_prefix] = STATE(4046),
    [sym__pqconsym] = STATE(4046),
    [sym__prefix_at] = STATE(2587),
    [sym__paren_open] = STATE(470),
    [sym__bracket_open] = STATE(1007),
    [sym__unboxed_open] = STATE(734),
    [sym_variable] = ACTIONS(1743),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1745),
    [anon_sym_STAR] = ACTIONS(1747),
    [anon_sym_u2605] = ACTIONS(1741),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [anon_sym_PIPE2] = ACTIONS(1181),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1749),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1751),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [538] = {
    [sym__type_parens] = STATE(4027),
    [sym__type_tuple] = STATE(4020),
    [sym__type_unboxed_tuple] = STATE(3988),
    [sym__type_unboxed_sum] = STATE(4177),
    [sym__type_list] = STATE(4056),
    [sym__type_promoted] = STATE(4029),
    [sym__type_star] = STATE(4029),
    [sym__type_wildcard] = STATE(4029),
    [sym__at_type] = STATE(4065),
    [sym__type_apply] = STATE(4047),
    [sym__type_infix] = STATE(4088),
    [sym_type] = STATE(535),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8492),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4029),
    [sym_quasiquote] = STATE(4029),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4041),
    [sym_unit] = STATE(4029),
    [sym_unboxed_unit] = STATE(4029),
    [sym_prefix_tuple] = STATE(4029),
    [sym_prefix_unboxed_tuple] = STATE(4029),
    [sym_prefix_unboxed_sum] = STATE(4029),
    [sym_literal] = STATE(4029),
    [sym__qualified_type] = STATE(4061),
    [sym__qtyconid] = STATE(4046),
    [sym__tycon_arrow] = STATE(4046),
    [sym__qtycon_arrow] = STATE(4046),
    [sym__promoted_tycons_alias] = STATE(4029),
    [sym__promoted_tycons] = STATE(4029),
    [sym__tycon_ticked] = STATE(2530),
    [sym__qtycon_ticked] = STATE(2530),
    [sym__tyconids_ticked] = STATE(2530),
    [sym__promoted_tyconops_alias] = STATE(2530),
    [sym__promoted_tyconops] = STATE(2530),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2530),
    [sym__operator_alias] = STATE(2530),
    [sym__operator_minus] = STATE(2530),
    [sym__varsym_prefix] = STATE(4046),
    [sym__pvarsym] = STATE(4046),
    [sym__qualified_varsym] = STATE(2531),
    [sym__qvarsym_prefix] = STATE(4046),
    [sym__pqvarsym] = STATE(4046),
    [sym_constructor_operator] = STATE(2530),
    [sym__constructor_operator_alias] = STATE(2530),
    [sym__consym_prefix] = STATE(4046),
    [sym__pconsym] = STATE(4046),
    [sym__qualified_consym] = STATE(2532),
    [sym__qconsym_prefix] = STATE(4046),
    [sym__pqconsym] = STATE(4046),
    [sym__prefix_at] = STATE(2587),
    [sym__paren_open] = STATE(470),
    [sym__bracket_open] = STATE(1007),
    [sym__unboxed_open] = STATE(734),
    [sym_variable] = ACTIONS(1743),
    [anon_sym_let] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1745),
    [anon_sym_STAR] = ACTIONS(1747),
    [anon_sym_u2605] = ACTIONS(1741),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1157),
    [anon_sym_PIPE] = ACTIONS(1159),
    [anon_sym_BSLASH] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_mdo] = ACTIONS(1159),
    [anon_sym_do] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1157),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [anon_sym_PIPE2] = ACTIONS(1157),
    [sym_implicit_variable] = ACTIONS(1157),
    [sym_name] = ACTIONS(1749),
    [sym_label] = ACTIONS(1157),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(1157),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1751),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1157),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__cond_minus] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [539] = {
    [sym__type_parens] = STATE(3996),
    [sym__type_tuple] = STATE(3989),
    [sym__type_unboxed_tuple] = STATE(4000),
    [sym__type_unboxed_sum] = STATE(4001),
    [sym__type_list] = STATE(4003),
    [sym__type_promoted] = STATE(3975),
    [sym__type_star] = STATE(3975),
    [sym__type_wildcard] = STATE(3975),
    [sym__at_type] = STATE(4035),
    [sym__type_apply] = STATE(4004),
    [sym__type_infix] = STATE(4005),
    [sym_type] = STATE(526),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8507),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(3975),
    [sym_quasiquote] = STATE(3975),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4006),
    [sym_unit] = STATE(3975),
    [sym_unboxed_unit] = STATE(3975),
    [sym_prefix_tuple] = STATE(3975),
    [sym_prefix_unboxed_tuple] = STATE(3975),
    [sym_prefix_unboxed_sum] = STATE(3975),
    [sym_literal] = STATE(3975),
    [sym__qualified_type] = STATE(4144),
    [sym__qtyconid] = STATE(3997),
    [sym__tycon_arrow] = STATE(3997),
    [sym__qtycon_arrow] = STATE(3997),
    [sym__promoted_tycons_alias] = STATE(3975),
    [sym__promoted_tycons] = STATE(3975),
    [sym__tycon_ticked] = STATE(2627),
    [sym__qtycon_ticked] = STATE(2627),
    [sym__tyconids_ticked] = STATE(2627),
    [sym__promoted_tyconops_alias] = STATE(2627),
    [sym__promoted_tyconops] = STATE(2627),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2627),
    [sym__operator_alias] = STATE(2627),
    [sym__operator_minus] = STATE(2627),
    [sym__varsym_prefix] = STATE(3997),
    [sym__pvarsym] = STATE(3997),
    [sym__qualified_varsym] = STATE(2628),
    [sym__qvarsym_prefix] = STATE(3997),
    [sym__pqvarsym] = STATE(3997),
    [sym_constructor_operator] = STATE(2627),
    [sym__constructor_operator_alias] = STATE(2627),
    [sym__consym_prefix] = STATE(3997),
    [sym__pconsym] = STATE(3997),
    [sym__qualified_consym] = STATE(2629),
    [sym__qconsym_prefix] = STATE(3997),
    [sym__pqconsym] = STATE(3997),
    [sym__prefix_at] = STATE(2475),
    [sym__paren_open] = STATE(452),
    [sym__bracket_open] = STATE(1122),
    [sym__unboxed_open] = STATE(806),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(1177),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym__phantom_where] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [540] = {
    [sym__type_parens] = STATE(4078),
    [sym__type_tuple] = STATE(4080),
    [sym__type_unboxed_tuple] = STATE(4081),
    [sym__type_unboxed_sum] = STATE(4082),
    [sym__type_list] = STATE(4084),
    [sym__type_promoted] = STATE(4075),
    [sym__type_star] = STATE(4075),
    [sym__type_wildcard] = STATE(4075),
    [sym__at_type] = STATE(4132),
    [sym__type_apply] = STATE(4085),
    [sym__type_infix] = STATE(4133),
    [sym_type] = STATE(541),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8476),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4075),
    [sym_quasiquote] = STATE(4075),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4097),
    [sym_unit] = STATE(4075),
    [sym_unboxed_unit] = STATE(4075),
    [sym_prefix_tuple] = STATE(4075),
    [sym_prefix_unboxed_tuple] = STATE(4075),
    [sym_prefix_unboxed_sum] = STATE(4075),
    [sym_literal] = STATE(4075),
    [sym__qualified_type] = STATE(4138),
    [sym__qtyconid] = STATE(4098),
    [sym__tycon_arrow] = STATE(4098),
    [sym__qtycon_arrow] = STATE(4098),
    [sym__promoted_tycons_alias] = STATE(4075),
    [sym__promoted_tycons] = STATE(4075),
    [sym__tycon_ticked] = STATE(2522),
    [sym__qtycon_ticked] = STATE(2522),
    [sym__tyconids_ticked] = STATE(2522),
    [sym__promoted_tyconops_alias] = STATE(2522),
    [sym__promoted_tyconops] = STATE(2522),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2522),
    [sym__operator_alias] = STATE(2522),
    [sym__operator_minus] = STATE(2522),
    [sym__varsym_prefix] = STATE(4098),
    [sym__pvarsym] = STATE(4098),
    [sym__qualified_varsym] = STATE(2524),
    [sym__qvarsym_prefix] = STATE(4098),
    [sym__pqvarsym] = STATE(4098),
    [sym_constructor_operator] = STATE(2522),
    [sym__constructor_operator_alias] = STATE(2522),
    [sym__consym_prefix] = STATE(4098),
    [sym__pconsym] = STATE(4098),
    [sym__qualified_consym] = STATE(2525),
    [sym__qconsym_prefix] = STATE(4098),
    [sym__pqconsym] = STATE(4098),
    [sym__prefix_at] = STATE(2617),
    [sym__paren_open] = STATE(444),
    [sym__bracket_open] = STATE(1041),
    [sym__unboxed_open] = STATE(787),
    [sym_variable] = ACTIONS(1725),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1727),
    [anon_sym_SQUOTE] = ACTIONS(1729),
    [anon_sym_STAR] = ACTIONS(1731),
    [anon_sym_u2605] = ACTIONS(1733),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1735),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1737),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_dotdot] = ACTIONS(1181),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [541] = {
    [sym__type_parens] = STATE(4078),
    [sym__type_tuple] = STATE(4080),
    [sym__type_unboxed_tuple] = STATE(4081),
    [sym__type_unboxed_sum] = STATE(4082),
    [sym__type_list] = STATE(4084),
    [sym__type_promoted] = STATE(4075),
    [sym__type_star] = STATE(4075),
    [sym__type_wildcard] = STATE(4075),
    [sym__at_type] = STATE(4132),
    [sym__type_apply] = STATE(4085),
    [sym__type_infix] = STATE(4133),
    [sym_type] = STATE(541),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8476),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4075),
    [sym_quasiquote] = STATE(4075),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4097),
    [sym_unit] = STATE(4075),
    [sym_unboxed_unit] = STATE(4075),
    [sym_prefix_tuple] = STATE(4075),
    [sym_prefix_unboxed_tuple] = STATE(4075),
    [sym_prefix_unboxed_sum] = STATE(4075),
    [sym_literal] = STATE(4075),
    [sym__qualified_type] = STATE(4138),
    [sym__qtyconid] = STATE(4098),
    [sym__tycon_arrow] = STATE(4098),
    [sym__qtycon_arrow] = STATE(4098),
    [sym__promoted_tycons_alias] = STATE(4075),
    [sym__promoted_tycons] = STATE(4075),
    [sym__tycon_ticked] = STATE(2522),
    [sym__qtycon_ticked] = STATE(2522),
    [sym__tyconids_ticked] = STATE(2522),
    [sym__promoted_tyconops_alias] = STATE(2522),
    [sym__promoted_tyconops] = STATE(2522),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2522),
    [sym__operator_alias] = STATE(2522),
    [sym__operator_minus] = STATE(2522),
    [sym__varsym_prefix] = STATE(4098),
    [sym__pvarsym] = STATE(4098),
    [sym__qualified_varsym] = STATE(2524),
    [sym__qvarsym_prefix] = STATE(4098),
    [sym__pqvarsym] = STATE(4098),
    [sym_constructor_operator] = STATE(2522),
    [sym__constructor_operator_alias] = STATE(2522),
    [sym__consym_prefix] = STATE(4098),
    [sym__pconsym] = STATE(4098),
    [sym__qualified_consym] = STATE(2525),
    [sym__qconsym_prefix] = STATE(4098),
    [sym__pqconsym] = STATE(4098),
    [sym__prefix_at] = STATE(2617),
    [sym__paren_open] = STATE(444),
    [sym__bracket_open] = STATE(1041),
    [sym__unboxed_open] = STATE(787),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_mdo] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_u27e6] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1117),
    [sym_implicit_variable] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [sym_label] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [anon_sym_RBRACK] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_tight_dot] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_dotdot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__cond_minus] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [542] = {
    [sym__type_parens] = STATE(4027),
    [sym__type_tuple] = STATE(4020),
    [sym__type_unboxed_tuple] = STATE(3988),
    [sym__type_unboxed_sum] = STATE(4177),
    [sym__type_list] = STATE(4056),
    [sym__type_promoted] = STATE(4029),
    [sym__type_star] = STATE(4029),
    [sym__type_wildcard] = STATE(4029),
    [sym__at_type] = STATE(4065),
    [sym__type_apply] = STATE(4047),
    [sym__type_infix] = STATE(4088),
    [sym_type] = STATE(535),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8492),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4029),
    [sym_quasiquote] = STATE(4029),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4041),
    [sym_unit] = STATE(4029),
    [sym_unboxed_unit] = STATE(4029),
    [sym_prefix_tuple] = STATE(4029),
    [sym_prefix_unboxed_tuple] = STATE(4029),
    [sym_prefix_unboxed_sum] = STATE(4029),
    [sym_literal] = STATE(4029),
    [sym__qualified_type] = STATE(4061),
    [sym__qtyconid] = STATE(4046),
    [sym__tycon_arrow] = STATE(4046),
    [sym__qtycon_arrow] = STATE(4046),
    [sym__promoted_tycons_alias] = STATE(4029),
    [sym__promoted_tycons] = STATE(4029),
    [sym__tycon_ticked] = STATE(2530),
    [sym__qtycon_ticked] = STATE(2530),
    [sym__tyconids_ticked] = STATE(2530),
    [sym__promoted_tyconops_alias] = STATE(2530),
    [sym__promoted_tyconops] = STATE(2530),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2530),
    [sym__operator_alias] = STATE(2530),
    [sym__operator_minus] = STATE(2530),
    [sym__varsym_prefix] = STATE(4046),
    [sym__pvarsym] = STATE(4046),
    [sym__qualified_varsym] = STATE(2531),
    [sym__qvarsym_prefix] = STATE(4046),
    [sym__pqvarsym] = STATE(4046),
    [sym_constructor_operator] = STATE(2530),
    [sym__constructor_operator_alias] = STATE(2530),
    [sym__consym_prefix] = STATE(4046),
    [sym__pconsym] = STATE(4046),
    [sym__qualified_consym] = STATE(2532),
    [sym__qconsym_prefix] = STATE(4046),
    [sym__pqconsym] = STATE(4046),
    [sym__prefix_at] = STATE(2587),
    [sym__paren_open] = STATE(470),
    [sym__bracket_open] = STATE(1007),
    [sym__unboxed_open] = STATE(734),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1177),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [anon_sym_PIPE2] = ACTIONS(1179),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_POUND_RPAREN] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [543] = {
    [sym__type_parens] = STATE(3996),
    [sym__type_tuple] = STATE(3989),
    [sym__type_unboxed_tuple] = STATE(4000),
    [sym__type_unboxed_sum] = STATE(4001),
    [sym__type_list] = STATE(4003),
    [sym__type_promoted] = STATE(3975),
    [sym__type_star] = STATE(3975),
    [sym__type_wildcard] = STATE(3975),
    [sym__at_type] = STATE(4035),
    [sym__type_apply] = STATE(4004),
    [sym__type_infix] = STATE(4005),
    [sym_type] = STATE(526),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8507),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(3975),
    [sym_quasiquote] = STATE(3975),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4006),
    [sym_unit] = STATE(3975),
    [sym_unboxed_unit] = STATE(3975),
    [sym_prefix_tuple] = STATE(3975),
    [sym_prefix_unboxed_tuple] = STATE(3975),
    [sym_prefix_unboxed_sum] = STATE(3975),
    [sym_literal] = STATE(3975),
    [sym__qualified_type] = STATE(4144),
    [sym__qtyconid] = STATE(3997),
    [sym__tycon_arrow] = STATE(3997),
    [sym__qtycon_arrow] = STATE(3997),
    [sym__promoted_tycons_alias] = STATE(3975),
    [sym__promoted_tycons] = STATE(3975),
    [sym__tycon_ticked] = STATE(2627),
    [sym__qtycon_ticked] = STATE(2627),
    [sym__tyconids_ticked] = STATE(2627),
    [sym__promoted_tyconops_alias] = STATE(2627),
    [sym__promoted_tyconops] = STATE(2627),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2627),
    [sym__operator_alias] = STATE(2627),
    [sym__operator_minus] = STATE(2627),
    [sym__varsym_prefix] = STATE(3997),
    [sym__pvarsym] = STATE(3997),
    [sym__qualified_varsym] = STATE(2628),
    [sym__qvarsym_prefix] = STATE(3997),
    [sym__pqvarsym] = STATE(3997),
    [sym_constructor_operator] = STATE(2627),
    [sym__constructor_operator_alias] = STATE(2627),
    [sym__consym_prefix] = STATE(3997),
    [sym__pconsym] = STATE(3997),
    [sym__qualified_consym] = STATE(2629),
    [sym__qconsym_prefix] = STATE(3997),
    [sym__pqconsym] = STATE(3997),
    [sym__prefix_at] = STATE(2475),
    [sym__paren_open] = STATE(452),
    [sym__bracket_open] = STATE(1122),
    [sym__unboxed_open] = STATE(806),
    [sym_variable] = ACTIONS(1711),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym_let] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1713),
    [anon_sym_SQUOTE] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1717),
    [anon_sym_u2605] = ACTIONS(1719),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1157),
    [anon_sym_BSLASH] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_mdo] = ACTIONS(1159),
    [anon_sym_do] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1157),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1157),
    [sym_name] = ACTIONS(1721),
    [sym_label] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1159),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1157),
    [sym__cond_layout_end] = ACTIONS(1157),
    [sym__cond_layout_end_explicit] = ACTIONS(1157),
    [sym__phantom_where] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1723),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1157),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__cond_minus] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [544] = {
    [sym__type_parens] = STATE(4078),
    [sym__type_tuple] = STATE(4080),
    [sym__type_unboxed_tuple] = STATE(4081),
    [sym__type_unboxed_sum] = STATE(4082),
    [sym__type_list] = STATE(4084),
    [sym__type_promoted] = STATE(4075),
    [sym__type_star] = STATE(4075),
    [sym__type_wildcard] = STATE(4075),
    [sym__at_type] = STATE(4132),
    [sym__type_apply] = STATE(4085),
    [sym__type_infix] = STATE(4133),
    [sym_type] = STATE(541),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8476),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4075),
    [sym_quasiquote] = STATE(4075),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4097),
    [sym_unit] = STATE(4075),
    [sym_unboxed_unit] = STATE(4075),
    [sym_prefix_tuple] = STATE(4075),
    [sym_prefix_unboxed_tuple] = STATE(4075),
    [sym_prefix_unboxed_sum] = STATE(4075),
    [sym_literal] = STATE(4075),
    [sym__qualified_type] = STATE(4138),
    [sym__qtyconid] = STATE(4098),
    [sym__tycon_arrow] = STATE(4098),
    [sym__qtycon_arrow] = STATE(4098),
    [sym__promoted_tycons_alias] = STATE(4075),
    [sym__promoted_tycons] = STATE(4075),
    [sym__tycon_ticked] = STATE(2522),
    [sym__qtycon_ticked] = STATE(2522),
    [sym__tyconids_ticked] = STATE(2522),
    [sym__promoted_tyconops_alias] = STATE(2522),
    [sym__promoted_tyconops] = STATE(2522),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2522),
    [sym__operator_alias] = STATE(2522),
    [sym__operator_minus] = STATE(2522),
    [sym__varsym_prefix] = STATE(4098),
    [sym__pvarsym] = STATE(4098),
    [sym__qualified_varsym] = STATE(2524),
    [sym__qvarsym_prefix] = STATE(4098),
    [sym__pqvarsym] = STATE(4098),
    [sym_constructor_operator] = STATE(2522),
    [sym__constructor_operator_alias] = STATE(2522),
    [sym__consym_prefix] = STATE(4098),
    [sym__pconsym] = STATE(4098),
    [sym__qualified_consym] = STATE(2525),
    [sym__qconsym_prefix] = STATE(4098),
    [sym__pqconsym] = STATE(4098),
    [sym__prefix_at] = STATE(2617),
    [sym__paren_open] = STATE(444),
    [sym__bracket_open] = STATE(1041),
    [sym__unboxed_open] = STATE(787),
    [sym_variable] = ACTIONS(1725),
    [anon_sym_let] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1727),
    [anon_sym_SQUOTE] = ACTIONS(1729),
    [anon_sym_STAR] = ACTIONS(1731),
    [anon_sym_u2605] = ACTIONS(1733),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1157),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_BSLASH] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_mdo] = ACTIONS(1159),
    [anon_sym_do] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1157),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1157),
    [sym_name] = ACTIONS(1735),
    [sym_label] = ACTIONS(1157),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1157),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1737),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1157),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_dotdot] = ACTIONS(1157),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__cond_minus] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [545] = {
    [sym__type_parens] = STATE(4078),
    [sym__type_tuple] = STATE(4080),
    [sym__type_unboxed_tuple] = STATE(4081),
    [sym__type_unboxed_sum] = STATE(4082),
    [sym__type_list] = STATE(4084),
    [sym__type_promoted] = STATE(4075),
    [sym__type_star] = STATE(4075),
    [sym__type_wildcard] = STATE(4075),
    [sym__at_type] = STATE(4132),
    [sym__type_apply] = STATE(4085),
    [sym__type_infix] = STATE(4133),
    [sym_type] = STATE(541),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8476),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4075),
    [sym_quasiquote] = STATE(4075),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4097),
    [sym_unit] = STATE(4075),
    [sym_unboxed_unit] = STATE(4075),
    [sym_prefix_tuple] = STATE(4075),
    [sym_prefix_unboxed_tuple] = STATE(4075),
    [sym_prefix_unboxed_sum] = STATE(4075),
    [sym_literal] = STATE(4075),
    [sym__qualified_type] = STATE(4138),
    [sym__qtyconid] = STATE(4098),
    [sym__tycon_arrow] = STATE(4098),
    [sym__qtycon_arrow] = STATE(4098),
    [sym__promoted_tycons_alias] = STATE(4075),
    [sym__promoted_tycons] = STATE(4075),
    [sym__tycon_ticked] = STATE(2522),
    [sym__qtycon_ticked] = STATE(2522),
    [sym__tyconids_ticked] = STATE(2522),
    [sym__promoted_tyconops_alias] = STATE(2522),
    [sym__promoted_tyconops] = STATE(2522),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2522),
    [sym__operator_alias] = STATE(2522),
    [sym__operator_minus] = STATE(2522),
    [sym__varsym_prefix] = STATE(4098),
    [sym__pvarsym] = STATE(4098),
    [sym__qualified_varsym] = STATE(2524),
    [sym__qvarsym_prefix] = STATE(4098),
    [sym__pqvarsym] = STATE(4098),
    [sym_constructor_operator] = STATE(2522),
    [sym__constructor_operator_alias] = STATE(2522),
    [sym__consym_prefix] = STATE(4098),
    [sym__pconsym] = STATE(4098),
    [sym__qualified_consym] = STATE(2525),
    [sym__qconsym_prefix] = STATE(4098),
    [sym__pqconsym] = STATE(4098),
    [sym__prefix_at] = STATE(2617),
    [sym__paren_open] = STATE(444),
    [sym__bracket_open] = STATE(1041),
    [sym__unboxed_open] = STATE(787),
    [sym_variable] = ACTIONS(1319),
    [anon_sym_let] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(1321),
    [anon_sym__] = ACTIONS(1727),
    [anon_sym_SQUOTE] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1321),
    [anon_sym_u2605] = ACTIONS(1733),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1321),
    [anon_sym_PIPE] = ACTIONS(1321),
    [anon_sym_BSLASH] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1319),
    [anon_sym_mdo] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1319),
    [anon_sym_case] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_DASH_GT] = ACTIONS(1321),
    [anon_sym_LBRACK] = ACTIONS(1321),
    [anon_sym_u27e6] = ACTIONS(1321),
    [sym_float] = ACTIONS(1321),
    [sym_char] = ACTIONS(1321),
    [sym_string] = ACTIONS(1321),
    [sym__integer_literal] = ACTIONS(1319),
    [sym__binary_literal] = ACTIONS(1321),
    [sym__octal_literal] = ACTIONS(1321),
    [sym__hex_literal] = ACTIONS(1321),
    [anon_sym_BQUOTE] = ACTIONS(1321),
    [anon_sym_POUND] = ACTIONS(1319),
    [anon_sym_POUND2] = ACTIONS(1319),
    [sym_implicit_variable] = ACTIONS(1321),
    [sym_name] = ACTIONS(1321),
    [sym_label] = ACTIONS(1321),
    [anon_sym_u2192] = ACTIONS(1321),
    [anon_sym_COLON_COLON] = ACTIONS(1321),
    [anon_sym_u2237] = ACTIONS(1321),
    [aux_sym__paren_open_token1] = ACTIONS(1321),
    [anon_sym_RBRACK] = ACTIONS(1321),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1321),
    [sym__cond_splice] = ACTIONS(1321),
    [sym__cond_tight_dot] = ACTIONS(1321),
    [sym__cond_prefix_dot] = ACTIONS(1321),
    [sym__cond_dotdot] = ACTIONS(1321),
    [sym__cond_prefix_at] = ACTIONS(1321),
    [sym__cond_qualified_op] = ACTIONS(1321),
    [sym__cond_no_section_op] = ACTIONS(1321),
    [sym__cond_minus] = ACTIONS(1321),
    [sym__varsym] = ACTIONS(1321),
    [sym__consym] = ACTIONS(1321),
  },
  [546] = {
    [sym__type_parens] = STATE(4027),
    [sym__type_tuple] = STATE(4020),
    [sym__type_unboxed_tuple] = STATE(3988),
    [sym__type_unboxed_sum] = STATE(4177),
    [sym__type_list] = STATE(4056),
    [sym__type_promoted] = STATE(4029),
    [sym__type_star] = STATE(4029),
    [sym__type_wildcard] = STATE(4029),
    [sym__at_type] = STATE(4065),
    [sym__type_apply] = STATE(4047),
    [sym__type_infix] = STATE(4088),
    [sym_type] = STATE(535),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8492),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4029),
    [sym_quasiquote] = STATE(4029),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4041),
    [sym_unit] = STATE(4029),
    [sym_unboxed_unit] = STATE(4029),
    [sym_prefix_tuple] = STATE(4029),
    [sym_prefix_unboxed_tuple] = STATE(4029),
    [sym_prefix_unboxed_sum] = STATE(4029),
    [sym_literal] = STATE(4029),
    [sym__qualified_type] = STATE(4061),
    [sym__qtyconid] = STATE(4046),
    [sym__tycon_arrow] = STATE(4046),
    [sym__qtycon_arrow] = STATE(4046),
    [sym__promoted_tycons_alias] = STATE(4029),
    [sym__promoted_tycons] = STATE(4029),
    [sym__tycon_ticked] = STATE(2530),
    [sym__qtycon_ticked] = STATE(2530),
    [sym__tyconids_ticked] = STATE(2530),
    [sym__promoted_tyconops_alias] = STATE(2530),
    [sym__promoted_tyconops] = STATE(2530),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2530),
    [sym__operator_alias] = STATE(2530),
    [sym__operator_minus] = STATE(2530),
    [sym__varsym_prefix] = STATE(4046),
    [sym__pvarsym] = STATE(4046),
    [sym__qualified_varsym] = STATE(2531),
    [sym__qvarsym_prefix] = STATE(4046),
    [sym__pqvarsym] = STATE(4046),
    [sym_constructor_operator] = STATE(2530),
    [sym__constructor_operator_alias] = STATE(2530),
    [sym__consym_prefix] = STATE(4046),
    [sym__pconsym] = STATE(4046),
    [sym__qualified_consym] = STATE(2532),
    [sym__qconsym_prefix] = STATE(4046),
    [sym__pqconsym] = STATE(4046),
    [sym__prefix_at] = STATE(2587),
    [sym__paren_open] = STATE(470),
    [sym__bracket_open] = STATE(1007),
    [sym__unboxed_open] = STATE(734),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1741),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1177),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [anon_sym_PIPE2] = ACTIONS(1179),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_POUND_RPAREN] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [547] = {
    [sym__type_parens] = STATE(4258),
    [sym__type_tuple] = STATE(4261),
    [sym__type_unboxed_tuple] = STATE(4262),
    [sym__type_unboxed_sum] = STATE(4263),
    [sym__type_list] = STATE(4264),
    [sym__type_promoted] = STATE(4257),
    [sym__type_star] = STATE(4257),
    [sym__type_wildcard] = STATE(4257),
    [sym__at_type] = STATE(4276),
    [sym__type_apply] = STATE(4265),
    [sym__type_infix] = STATE(4241),
    [sym_type] = STATE(551),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8455),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(4257),
    [sym_quasiquote] = STATE(4257),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(4235),
    [sym_unit] = STATE(4257),
    [sym_unboxed_unit] = STATE(4257),
    [sym_prefix_tuple] = STATE(4257),
    [sym_prefix_unboxed_tuple] = STATE(4257),
    [sym_prefix_unboxed_sum] = STATE(4257),
    [sym_literal] = STATE(4257),
    [sym__qualified_type] = STATE(4248),
    [sym__qtyconid] = STATE(4275),
    [sym__tycon_arrow] = STATE(4275),
    [sym__qtycon_arrow] = STATE(4275),
    [sym__promoted_tycons_alias] = STATE(4257),
    [sym__promoted_tycons] = STATE(4257),
    [sym__tycon_ticked] = STATE(2505),
    [sym__qtycon_ticked] = STATE(2505),
    [sym__tyconids_ticked] = STATE(2505),
    [sym__promoted_tyconops_alias] = STATE(2505),
    [sym__promoted_tyconops] = STATE(2505),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2505),
    [sym__operator_alias] = STATE(2505),
    [sym__operator_minus] = STATE(2505),
    [sym__varsym_prefix] = STATE(4275),
    [sym__pvarsym] = STATE(4275),
    [sym__qualified_varsym] = STATE(2506),
    [sym__qvarsym_prefix] = STATE(4275),
    [sym__pqvarsym] = STATE(4275),
    [sym_constructor_operator] = STATE(2505),
    [sym__constructor_operator_alias] = STATE(2505),
    [sym__consym_prefix] = STATE(4275),
    [sym__pconsym] = STATE(4275),
    [sym__qualified_consym] = STATE(2515),
    [sym__qconsym_prefix] = STATE(4275),
    [sym__pqconsym] = STATE(4275),
    [sym__prefix_at] = STATE(2630),
    [sym__paren_open] = STATE(471),
    [sym__bracket_open] = STATE(1071),
    [sym__unboxed_open] = STATE(778),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1755),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__paren_close_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_left_section_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [548] = {
    [sym__type_parens] = STATE(4258),
    [sym__type_tuple] = STATE(4261),
    [sym__type_unboxed_tuple] = STATE(4262),
    [sym__type_unboxed_sum] = STATE(4263),
    [sym__type_list] = STATE(4264),
    [sym__type_promoted] = STATE(4257),
    [sym__type_star] = STATE(4257),
    [sym__type_wildcard] = STATE(4257),
    [sym__at_type] = STATE(4276),
    [sym__type_apply] = STATE(4265),
    [sym__type_infix] = STATE(4241),
    [sym_type] = STATE(551),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8455),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(4257),
    [sym_quasiquote] = STATE(4257),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(4235),
    [sym_unit] = STATE(4257),
    [sym_unboxed_unit] = STATE(4257),
    [sym_prefix_tuple] = STATE(4257),
    [sym_prefix_unboxed_tuple] = STATE(4257),
    [sym_prefix_unboxed_sum] = STATE(4257),
    [sym_literal] = STATE(4257),
    [sym__qualified_type] = STATE(4248),
    [sym__qtyconid] = STATE(4275),
    [sym__tycon_arrow] = STATE(4275),
    [sym__qtycon_arrow] = STATE(4275),
    [sym__promoted_tycons_alias] = STATE(4257),
    [sym__promoted_tycons] = STATE(4257),
    [sym__tycon_ticked] = STATE(2505),
    [sym__qtycon_ticked] = STATE(2505),
    [sym__tyconids_ticked] = STATE(2505),
    [sym__promoted_tyconops_alias] = STATE(2505),
    [sym__promoted_tyconops] = STATE(2505),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2505),
    [sym__operator_alias] = STATE(2505),
    [sym__operator_minus] = STATE(2505),
    [sym__varsym_prefix] = STATE(4275),
    [sym__pvarsym] = STATE(4275),
    [sym__qualified_varsym] = STATE(2506),
    [sym__qvarsym_prefix] = STATE(4275),
    [sym__pqvarsym] = STATE(4275),
    [sym_constructor_operator] = STATE(2505),
    [sym__constructor_operator_alias] = STATE(2505),
    [sym__consym_prefix] = STATE(4275),
    [sym__pconsym] = STATE(4275),
    [sym__qualified_consym] = STATE(2515),
    [sym__qconsym_prefix] = STATE(4275),
    [sym__pqconsym] = STATE(4275),
    [sym__prefix_at] = STATE(2630),
    [sym__paren_open] = STATE(471),
    [sym__bracket_open] = STATE(1071),
    [sym__unboxed_open] = STATE(778),
    [sym_variable] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(1759),
    [anon_sym_STAR] = ACTIONS(1761),
    [anon_sym_u2605] = ACTIONS(1755),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1763),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1765),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_left_section_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [549] = {
    [sym__type_parens] = STATE(4258),
    [sym__type_tuple] = STATE(4261),
    [sym__type_unboxed_tuple] = STATE(4262),
    [sym__type_unboxed_sum] = STATE(4263),
    [sym__type_list] = STATE(4264),
    [sym__type_promoted] = STATE(4257),
    [sym__type_star] = STATE(4257),
    [sym__type_wildcard] = STATE(4257),
    [sym__at_type] = STATE(4276),
    [sym__type_apply] = STATE(4265),
    [sym__type_infix] = STATE(4241),
    [sym_type] = STATE(551),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8455),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(4257),
    [sym_quasiquote] = STATE(4257),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(4235),
    [sym_unit] = STATE(4257),
    [sym_unboxed_unit] = STATE(4257),
    [sym_prefix_tuple] = STATE(4257),
    [sym_prefix_unboxed_tuple] = STATE(4257),
    [sym_prefix_unboxed_sum] = STATE(4257),
    [sym_literal] = STATE(4257),
    [sym__qualified_type] = STATE(4248),
    [sym__qtyconid] = STATE(4275),
    [sym__tycon_arrow] = STATE(4275),
    [sym__qtycon_arrow] = STATE(4275),
    [sym__promoted_tycons_alias] = STATE(4257),
    [sym__promoted_tycons] = STATE(4257),
    [sym__tycon_ticked] = STATE(2505),
    [sym__qtycon_ticked] = STATE(2505),
    [sym__tyconids_ticked] = STATE(2505),
    [sym__promoted_tyconops_alias] = STATE(2505),
    [sym__promoted_tyconops] = STATE(2505),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2505),
    [sym__operator_alias] = STATE(2505),
    [sym__operator_minus] = STATE(2505),
    [sym__varsym_prefix] = STATE(4275),
    [sym__pvarsym] = STATE(4275),
    [sym__qualified_varsym] = STATE(2506),
    [sym__qvarsym_prefix] = STATE(4275),
    [sym__pqvarsym] = STATE(4275),
    [sym_constructor_operator] = STATE(2505),
    [sym__constructor_operator_alias] = STATE(2505),
    [sym__consym_prefix] = STATE(4275),
    [sym__pconsym] = STATE(4275),
    [sym__qualified_consym] = STATE(2515),
    [sym__qconsym_prefix] = STATE(4275),
    [sym__pqconsym] = STATE(4275),
    [sym__prefix_at] = STATE(2630),
    [sym__paren_open] = STATE(471),
    [sym__bracket_open] = STATE(1071),
    [sym__unboxed_open] = STATE(778),
    [sym_variable] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(1759),
    [anon_sym_STAR] = ACTIONS(1761),
    [anon_sym_u2605] = ACTIONS(1755),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1763),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1765),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_left_section_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [550] = {
    [sym__type_parens] = STATE(4258),
    [sym__type_tuple] = STATE(4261),
    [sym__type_unboxed_tuple] = STATE(4262),
    [sym__type_unboxed_sum] = STATE(4263),
    [sym__type_list] = STATE(4264),
    [sym__type_promoted] = STATE(4257),
    [sym__type_star] = STATE(4257),
    [sym__type_wildcard] = STATE(4257),
    [sym__at_type] = STATE(4276),
    [sym__type_apply] = STATE(4265),
    [sym__type_infix] = STATE(4241),
    [sym_type] = STATE(551),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8455),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(4257),
    [sym_quasiquote] = STATE(4257),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(4235),
    [sym_unit] = STATE(4257),
    [sym_unboxed_unit] = STATE(4257),
    [sym_prefix_tuple] = STATE(4257),
    [sym_prefix_unboxed_tuple] = STATE(4257),
    [sym_prefix_unboxed_sum] = STATE(4257),
    [sym_literal] = STATE(4257),
    [sym__qualified_type] = STATE(4248),
    [sym__qtyconid] = STATE(4275),
    [sym__tycon_arrow] = STATE(4275),
    [sym__qtycon_arrow] = STATE(4275),
    [sym__promoted_tycons_alias] = STATE(4257),
    [sym__promoted_tycons] = STATE(4257),
    [sym__tycon_ticked] = STATE(2505),
    [sym__qtycon_ticked] = STATE(2505),
    [sym__tyconids_ticked] = STATE(2505),
    [sym__promoted_tyconops_alias] = STATE(2505),
    [sym__promoted_tyconops] = STATE(2505),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2505),
    [sym__operator_alias] = STATE(2505),
    [sym__operator_minus] = STATE(2505),
    [sym__varsym_prefix] = STATE(4275),
    [sym__pvarsym] = STATE(4275),
    [sym__qualified_varsym] = STATE(2506),
    [sym__qvarsym_prefix] = STATE(4275),
    [sym__pqvarsym] = STATE(4275),
    [sym_constructor_operator] = STATE(2505),
    [sym__constructor_operator_alias] = STATE(2505),
    [sym__consym_prefix] = STATE(4275),
    [sym__pconsym] = STATE(4275),
    [sym__qualified_consym] = STATE(2515),
    [sym__qconsym_prefix] = STATE(4275),
    [sym__pqconsym] = STATE(4275),
    [sym__prefix_at] = STATE(2630),
    [sym__paren_open] = STATE(471),
    [sym__bracket_open] = STATE(1071),
    [sym__unboxed_open] = STATE(778),
    [sym_variable] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(1759),
    [anon_sym_STAR] = ACTIONS(1761),
    [anon_sym_u2605] = ACTIONS(1755),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1157),
    [anon_sym_BSLASH] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_mdo] = ACTIONS(1159),
    [anon_sym_do] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1157),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1157),
    [sym_name] = ACTIONS(1763),
    [sym_label] = ACTIONS(1157),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1157),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1765),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1157),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_left_section_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__cond_minus] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [551] = {
    [sym__type_parens] = STATE(4258),
    [sym__type_tuple] = STATE(4261),
    [sym__type_unboxed_tuple] = STATE(4262),
    [sym__type_unboxed_sum] = STATE(4263),
    [sym__type_list] = STATE(4264),
    [sym__type_promoted] = STATE(4257),
    [sym__type_star] = STATE(4257),
    [sym__type_wildcard] = STATE(4257),
    [sym__at_type] = STATE(4276),
    [sym__type_apply] = STATE(4265),
    [sym__type_infix] = STATE(4241),
    [sym_type] = STATE(551),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8455),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(4257),
    [sym_quasiquote] = STATE(4257),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(4235),
    [sym_unit] = STATE(4257),
    [sym_unboxed_unit] = STATE(4257),
    [sym_prefix_tuple] = STATE(4257),
    [sym_prefix_unboxed_tuple] = STATE(4257),
    [sym_prefix_unboxed_sum] = STATE(4257),
    [sym_literal] = STATE(4257),
    [sym__qualified_type] = STATE(4248),
    [sym__qtyconid] = STATE(4275),
    [sym__tycon_arrow] = STATE(4275),
    [sym__qtycon_arrow] = STATE(4275),
    [sym__promoted_tycons_alias] = STATE(4257),
    [sym__promoted_tycons] = STATE(4257),
    [sym__tycon_ticked] = STATE(2505),
    [sym__qtycon_ticked] = STATE(2505),
    [sym__tyconids_ticked] = STATE(2505),
    [sym__promoted_tyconops_alias] = STATE(2505),
    [sym__promoted_tyconops] = STATE(2505),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2505),
    [sym__operator_alias] = STATE(2505),
    [sym__operator_minus] = STATE(2505),
    [sym__varsym_prefix] = STATE(4275),
    [sym__pvarsym] = STATE(4275),
    [sym__qualified_varsym] = STATE(2506),
    [sym__qvarsym_prefix] = STATE(4275),
    [sym__pqvarsym] = STATE(4275),
    [sym_constructor_operator] = STATE(2505),
    [sym__constructor_operator_alias] = STATE(2505),
    [sym__consym_prefix] = STATE(4275),
    [sym__pconsym] = STATE(4275),
    [sym__qualified_consym] = STATE(2515),
    [sym__qconsym_prefix] = STATE(4275),
    [sym__pqconsym] = STATE(4275),
    [sym__prefix_at] = STATE(2630),
    [sym__paren_open] = STATE(471),
    [sym__bracket_open] = STATE(1071),
    [sym__unboxed_open] = STATE(778),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1119),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_mdo] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_u27e6] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1117),
    [sym_implicit_variable] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [sym_label] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__paren_close_token1] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_tight_dot] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_left_section_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__cond_minus] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [552] = {
    [sym__type_parens] = STATE(4258),
    [sym__type_tuple] = STATE(4261),
    [sym__type_unboxed_tuple] = STATE(4262),
    [sym__type_unboxed_sum] = STATE(4263),
    [sym__type_list] = STATE(4264),
    [sym__type_promoted] = STATE(4257),
    [sym__type_star] = STATE(4257),
    [sym__type_wildcard] = STATE(4257),
    [sym__at_type] = STATE(4276),
    [sym__type_apply] = STATE(4265),
    [sym__type_infix] = STATE(4241),
    [sym_type] = STATE(551),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8455),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(4257),
    [sym_quasiquote] = STATE(4257),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(4235),
    [sym_unit] = STATE(4257),
    [sym_unboxed_unit] = STATE(4257),
    [sym_prefix_tuple] = STATE(4257),
    [sym_prefix_unboxed_tuple] = STATE(4257),
    [sym_prefix_unboxed_sum] = STATE(4257),
    [sym_literal] = STATE(4257),
    [sym__qualified_type] = STATE(4248),
    [sym__qtyconid] = STATE(4275),
    [sym__tycon_arrow] = STATE(4275),
    [sym__qtycon_arrow] = STATE(4275),
    [sym__promoted_tycons_alias] = STATE(4257),
    [sym__promoted_tycons] = STATE(4257),
    [sym__tycon_ticked] = STATE(2505),
    [sym__qtycon_ticked] = STATE(2505),
    [sym__tyconids_ticked] = STATE(2505),
    [sym__promoted_tyconops_alias] = STATE(2505),
    [sym__promoted_tyconops] = STATE(2505),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2505),
    [sym__operator_alias] = STATE(2505),
    [sym__operator_minus] = STATE(2505),
    [sym__varsym_prefix] = STATE(4275),
    [sym__pvarsym] = STATE(4275),
    [sym__qualified_varsym] = STATE(2506),
    [sym__qvarsym_prefix] = STATE(4275),
    [sym__pqvarsym] = STATE(4275),
    [sym_constructor_operator] = STATE(2505),
    [sym__constructor_operator_alias] = STATE(2505),
    [sym__consym_prefix] = STATE(4275),
    [sym__pconsym] = STATE(4275),
    [sym__qualified_consym] = STATE(2515),
    [sym__qconsym_prefix] = STATE(4275),
    [sym__pqconsym] = STATE(4275),
    [sym__prefix_at] = STATE(2630),
    [sym__paren_open] = STATE(471),
    [sym__bracket_open] = STATE(1071),
    [sym__unboxed_open] = STATE(778),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__paren_close_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_left_section_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [553] = {
    [sym__type_parens] = STATE(4258),
    [sym__type_tuple] = STATE(4261),
    [sym__type_unboxed_tuple] = STATE(4262),
    [sym__type_unboxed_sum] = STATE(4263),
    [sym__type_list] = STATE(4264),
    [sym__type_promoted] = STATE(4257),
    [sym__type_star] = STATE(4257),
    [sym__type_wildcard] = STATE(4257),
    [sym__at_type] = STATE(4276),
    [sym__type_apply] = STATE(4265),
    [sym__type_infix] = STATE(4241),
    [sym_type] = STATE(551),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8455),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(4257),
    [sym_quasiquote] = STATE(4257),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(4235),
    [sym_unit] = STATE(4257),
    [sym_unboxed_unit] = STATE(4257),
    [sym_prefix_tuple] = STATE(4257),
    [sym_prefix_unboxed_tuple] = STATE(4257),
    [sym_prefix_unboxed_sum] = STATE(4257),
    [sym_literal] = STATE(4257),
    [sym__qualified_type] = STATE(4248),
    [sym__qtyconid] = STATE(4275),
    [sym__tycon_arrow] = STATE(4275),
    [sym__qtycon_arrow] = STATE(4275),
    [sym__promoted_tycons_alias] = STATE(4257),
    [sym__promoted_tycons] = STATE(4257),
    [sym__tycon_ticked] = STATE(2505),
    [sym__qtycon_ticked] = STATE(2505),
    [sym__tyconids_ticked] = STATE(2505),
    [sym__promoted_tyconops_alias] = STATE(2505),
    [sym__promoted_tyconops] = STATE(2505),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2505),
    [sym__operator_alias] = STATE(2505),
    [sym__operator_minus] = STATE(2505),
    [sym__varsym_prefix] = STATE(4275),
    [sym__pvarsym] = STATE(4275),
    [sym__qualified_varsym] = STATE(2506),
    [sym__qvarsym_prefix] = STATE(4275),
    [sym__pqvarsym] = STATE(4275),
    [sym_constructor_operator] = STATE(2505),
    [sym__constructor_operator_alias] = STATE(2505),
    [sym__consym_prefix] = STATE(4275),
    [sym__pconsym] = STATE(4275),
    [sym__qualified_consym] = STATE(2515),
    [sym__qconsym_prefix] = STATE(4275),
    [sym__pqconsym] = STATE(4275),
    [sym__prefix_at] = STATE(2630),
    [sym__paren_open] = STATE(471),
    [sym__bracket_open] = STATE(1071),
    [sym__unboxed_open] = STATE(778),
    [sym_variable] = ACTIONS(1319),
    [anon_sym_let] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(1321),
    [anon_sym__] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1321),
    [anon_sym_u2605] = ACTIONS(1755),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1321),
    [anon_sym_BSLASH] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1319),
    [anon_sym_mdo] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1319),
    [anon_sym_case] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_DASH_GT] = ACTIONS(1321),
    [anon_sym_LBRACK] = ACTIONS(1321),
    [anon_sym_u27e6] = ACTIONS(1321),
    [sym_float] = ACTIONS(1321),
    [sym_char] = ACTIONS(1321),
    [sym_string] = ACTIONS(1321),
    [sym__integer_literal] = ACTIONS(1319),
    [sym__binary_literal] = ACTIONS(1321),
    [sym__octal_literal] = ACTIONS(1321),
    [sym__hex_literal] = ACTIONS(1321),
    [anon_sym_BQUOTE] = ACTIONS(1321),
    [anon_sym_POUND] = ACTIONS(1319),
    [anon_sym_POUND2] = ACTIONS(1319),
    [sym_implicit_variable] = ACTIONS(1321),
    [sym_name] = ACTIONS(1321),
    [sym_label] = ACTIONS(1321),
    [anon_sym_u2192] = ACTIONS(1321),
    [anon_sym_COLON_COLON] = ACTIONS(1321),
    [anon_sym_u2237] = ACTIONS(1321),
    [aux_sym__paren_open_token1] = ACTIONS(1321),
    [aux_sym__paren_close_token1] = ACTIONS(1321),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1321),
    [sym__cond_splice] = ACTIONS(1321),
    [sym__cond_tight_dot] = ACTIONS(1321),
    [sym__cond_prefix_dot] = ACTIONS(1321),
    [sym__cond_prefix_at] = ACTIONS(1321),
    [sym__cond_qualified_op] = ACTIONS(1321),
    [sym__cond_left_section_op] = ACTIONS(1321),
    [sym__cond_no_section_op] = ACTIONS(1321),
    [sym__cond_minus] = ACTIONS(1321),
    [sym__varsym] = ACTIONS(1321),
    [sym__consym] = ACTIONS(1321),
  },
  [554] = {
    [sym__type_parens] = STATE(4653),
    [sym__type_tuple] = STATE(4654),
    [sym__type_unboxed_tuple] = STATE(4588),
    [sym__type_unboxed_sum] = STATE(4657),
    [sym__type_list] = STATE(4667),
    [sym__type_promoted] = STATE(4652),
    [sym__type_star] = STATE(4652),
    [sym__type_wildcard] = STATE(4652),
    [sym__at_type] = STATE(4698),
    [sym__type_apply] = STATE(4669),
    [sym__type_infix] = STATE(4672),
    [sym_type] = STATE(557),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8472),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(4652),
    [sym_quasiquote] = STATE(4652),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(4673),
    [sym_unit] = STATE(4652),
    [sym_unboxed_unit] = STATE(4652),
    [sym_prefix_tuple] = STATE(4652),
    [sym_prefix_unboxed_tuple] = STATE(4652),
    [sym_prefix_unboxed_sum] = STATE(4652),
    [sym_literal] = STATE(4652),
    [sym__qualified_type] = STATE(4841),
    [sym__qtyconid] = STATE(4674),
    [sym__tycon_arrow] = STATE(4674),
    [sym__qtycon_arrow] = STATE(4674),
    [sym__promoted_tycons_alias] = STATE(4652),
    [sym__promoted_tycons] = STATE(4652),
    [sym__tycon_ticked] = STATE(2579),
    [sym__qtycon_ticked] = STATE(2579),
    [sym__tyconids_ticked] = STATE(2579),
    [sym__promoted_tyconops_alias] = STATE(2579),
    [sym__promoted_tyconops] = STATE(2579),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2579),
    [sym__operator_alias] = STATE(2579),
    [sym__operator_minus] = STATE(2579),
    [sym__varsym_prefix] = STATE(4674),
    [sym__pvarsym] = STATE(4674),
    [sym__qualified_varsym] = STATE(2574),
    [sym__qvarsym_prefix] = STATE(4674),
    [sym__pqvarsym] = STATE(4674),
    [sym_constructor_operator] = STATE(2579),
    [sym__constructor_operator_alias] = STATE(2579),
    [sym__consym_prefix] = STATE(4674),
    [sym__pconsym] = STATE(4674),
    [sym__qualified_consym] = STATE(2666),
    [sym__qconsym_prefix] = STATE(4674),
    [sym__pqconsym] = STATE(4674),
    [sym__prefix_at] = STATE(2596),
    [sym__paren_open] = STATE(440),
    [sym__bracket_open] = STATE(1037),
    [sym__unboxed_open] = STATE(804),
    [sym_variable] = ACTIONS(1767),
    [anon_sym_let] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1769),
    [anon_sym_SQUOTE] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1773),
    [anon_sym_u2605] = ACTIONS(1775),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1157),
    [anon_sym_by] = ACTIONS(1159),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_BSLASH] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_mdo] = ACTIONS(1159),
    [anon_sym_do] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1157),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1157),
    [sym_name] = ACTIONS(1777),
    [sym_label] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1157),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1779),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1157),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__cond_minus] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [555] = {
    [sym__type_parens] = STATE(4318),
    [sym__type_tuple] = STATE(4319),
    [sym__type_unboxed_tuple] = STATE(4324),
    [sym__type_unboxed_sum] = STATE(4325),
    [sym__type_list] = STATE(4326),
    [sym__type_promoted] = STATE(4317),
    [sym__type_star] = STATE(4317),
    [sym__type_wildcard] = STATE(4317),
    [sym__at_type] = STATE(4348),
    [sym__type_apply] = STATE(4327),
    [sym__type_infix] = STATE(4328),
    [sym_type] = STATE(563),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8493),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(4317),
    [sym_quasiquote] = STATE(4317),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(4329),
    [sym_unit] = STATE(4317),
    [sym_unboxed_unit] = STATE(4317),
    [sym_prefix_tuple] = STATE(4317),
    [sym_prefix_unboxed_tuple] = STATE(4317),
    [sym_prefix_unboxed_sum] = STATE(4317),
    [sym_literal] = STATE(4317),
    [sym__qualified_type] = STATE(4389),
    [sym__qtyconid] = STATE(4330),
    [sym__tycon_arrow] = STATE(4330),
    [sym__qtycon_arrow] = STATE(4330),
    [sym__promoted_tycons_alias] = STATE(4317),
    [sym__promoted_tycons] = STATE(4317),
    [sym__tycon_ticked] = STATE(2404),
    [sym__qtycon_ticked] = STATE(2404),
    [sym__tyconids_ticked] = STATE(2404),
    [sym__promoted_tyconops_alias] = STATE(2404),
    [sym__promoted_tyconops] = STATE(2404),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2404),
    [sym__operator_alias] = STATE(2404),
    [sym__operator_minus] = STATE(2404),
    [sym__varsym_prefix] = STATE(4330),
    [sym__pvarsym] = STATE(4330),
    [sym__qualified_varsym] = STATE(2405),
    [sym__qvarsym_prefix] = STATE(4330),
    [sym__pqvarsym] = STATE(4330),
    [sym_constructor_operator] = STATE(2404),
    [sym__constructor_operator_alias] = STATE(2404),
    [sym__consym_prefix] = STATE(4330),
    [sym__pconsym] = STATE(4330),
    [sym__qualified_consym] = STATE(2406),
    [sym__qconsym_prefix] = STATE(4330),
    [sym__pqconsym] = STATE(4330),
    [sym__prefix_at] = STATE(2413),
    [sym__paren_open] = STATE(433),
    [sym__bracket_open] = STATE(998),
    [sym__unboxed_open] = STATE(820),
    [sym_variable] = ACTIONS(1319),
    [anon_sym_SEMI] = ACTIONS(1321),
    [anon_sym_let] = ACTIONS(1319),
    [anon_sym_LBRACE] = ACTIONS(1321),
    [anon_sym__] = ACTIONS(1781),
    [anon_sym_SQUOTE] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1321),
    [anon_sym_u2605] = ACTIONS(1783),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1321),
    [anon_sym_BSLASH] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1319),
    [anon_sym_mdo] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1319),
    [anon_sym_case] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_LBRACK] = ACTIONS(1321),
    [anon_sym_u27e6] = ACTIONS(1321),
    [sym_float] = ACTIONS(1321),
    [sym_char] = ACTIONS(1321),
    [sym_string] = ACTIONS(1321),
    [sym__integer_literal] = ACTIONS(1319),
    [sym__binary_literal] = ACTIONS(1321),
    [sym__octal_literal] = ACTIONS(1321),
    [sym__hex_literal] = ACTIONS(1321),
    [anon_sym_BQUOTE] = ACTIONS(1321),
    [anon_sym_POUND] = ACTIONS(1319),
    [anon_sym_POUND2] = ACTIONS(1319),
    [sym_implicit_variable] = ACTIONS(1321),
    [sym_name] = ACTIONS(1321),
    [sym_label] = ACTIONS(1321),
    [anon_sym_COLON_COLON] = ACTIONS(1321),
    [anon_sym_u2237] = ACTIONS(1321),
    [aux_sym__paren_open_token1] = ACTIONS(1321),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1321),
    [sym__cond_layout_end] = ACTIONS(1321),
    [sym__cond_layout_end_explicit] = ACTIONS(1321),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1321),
    [sym__cond_splice] = ACTIONS(1321),
    [sym__cond_tight_dot] = ACTIONS(1321),
    [sym__cond_prefix_dot] = ACTIONS(1321),
    [sym__cond_prefix_at] = ACTIONS(1321),
    [sym__cond_qualified_op] = ACTIONS(1321),
    [sym__cond_no_section_op] = ACTIONS(1321),
    [sym__cond_minus] = ACTIONS(1321),
    [sym__varsym] = ACTIONS(1321),
    [sym__consym] = ACTIONS(1321),
  },
  [556] = {
    [sym__type_parens] = STATE(4318),
    [sym__type_tuple] = STATE(4319),
    [sym__type_unboxed_tuple] = STATE(4324),
    [sym__type_unboxed_sum] = STATE(4325),
    [sym__type_list] = STATE(4326),
    [sym__type_promoted] = STATE(4317),
    [sym__type_star] = STATE(4317),
    [sym__type_wildcard] = STATE(4317),
    [sym__at_type] = STATE(4348),
    [sym__type_apply] = STATE(4327),
    [sym__type_infix] = STATE(4328),
    [sym_type] = STATE(563),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8493),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(4317),
    [sym_quasiquote] = STATE(4317),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(4329),
    [sym_unit] = STATE(4317),
    [sym_unboxed_unit] = STATE(4317),
    [sym_prefix_tuple] = STATE(4317),
    [sym_prefix_unboxed_tuple] = STATE(4317),
    [sym_prefix_unboxed_sum] = STATE(4317),
    [sym_literal] = STATE(4317),
    [sym__qualified_type] = STATE(4389),
    [sym__qtyconid] = STATE(4330),
    [sym__tycon_arrow] = STATE(4330),
    [sym__qtycon_arrow] = STATE(4330),
    [sym__promoted_tycons_alias] = STATE(4317),
    [sym__promoted_tycons] = STATE(4317),
    [sym__tycon_ticked] = STATE(2404),
    [sym__qtycon_ticked] = STATE(2404),
    [sym__tyconids_ticked] = STATE(2404),
    [sym__promoted_tyconops_alias] = STATE(2404),
    [sym__promoted_tyconops] = STATE(2404),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2404),
    [sym__operator_alias] = STATE(2404),
    [sym__operator_minus] = STATE(2404),
    [sym__varsym_prefix] = STATE(4330),
    [sym__pvarsym] = STATE(4330),
    [sym__qualified_varsym] = STATE(2405),
    [sym__qvarsym_prefix] = STATE(4330),
    [sym__pqvarsym] = STATE(4330),
    [sym_constructor_operator] = STATE(2404),
    [sym__constructor_operator_alias] = STATE(2404),
    [sym__consym_prefix] = STATE(4330),
    [sym__pconsym] = STATE(4330),
    [sym__qualified_consym] = STATE(2406),
    [sym__qconsym_prefix] = STATE(4330),
    [sym__pqconsym] = STATE(4330),
    [sym__prefix_at] = STATE(2413),
    [sym__paren_open] = STATE(433),
    [sym__bracket_open] = STATE(998),
    [sym__unboxed_open] = STATE(820),
    [sym_variable] = ACTIONS(1785),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1781),
    [anon_sym_SQUOTE] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1789),
    [anon_sym_u2605] = ACTIONS(1783),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1791),
    [sym_label] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1793),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [557] = {
    [sym__type_parens] = STATE(4653),
    [sym__type_tuple] = STATE(4654),
    [sym__type_unboxed_tuple] = STATE(4588),
    [sym__type_unboxed_sum] = STATE(4657),
    [sym__type_list] = STATE(4667),
    [sym__type_promoted] = STATE(4652),
    [sym__type_star] = STATE(4652),
    [sym__type_wildcard] = STATE(4652),
    [sym__at_type] = STATE(4698),
    [sym__type_apply] = STATE(4669),
    [sym__type_infix] = STATE(4672),
    [sym_type] = STATE(557),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8472),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(4652),
    [sym_quasiquote] = STATE(4652),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(4673),
    [sym_unit] = STATE(4652),
    [sym_unboxed_unit] = STATE(4652),
    [sym_prefix_tuple] = STATE(4652),
    [sym_prefix_unboxed_tuple] = STATE(4652),
    [sym_prefix_unboxed_sum] = STATE(4652),
    [sym_literal] = STATE(4652),
    [sym__qualified_type] = STATE(4841),
    [sym__qtyconid] = STATE(4674),
    [sym__tycon_arrow] = STATE(4674),
    [sym__qtycon_arrow] = STATE(4674),
    [sym__promoted_tycons_alias] = STATE(4652),
    [sym__promoted_tycons] = STATE(4652),
    [sym__tycon_ticked] = STATE(2579),
    [sym__qtycon_ticked] = STATE(2579),
    [sym__tyconids_ticked] = STATE(2579),
    [sym__promoted_tyconops_alias] = STATE(2579),
    [sym__promoted_tyconops] = STATE(2579),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2579),
    [sym__operator_alias] = STATE(2579),
    [sym__operator_minus] = STATE(2579),
    [sym__varsym_prefix] = STATE(4674),
    [sym__pvarsym] = STATE(4674),
    [sym__qualified_varsym] = STATE(2574),
    [sym__qvarsym_prefix] = STATE(4674),
    [sym__pqvarsym] = STATE(4674),
    [sym_constructor_operator] = STATE(2579),
    [sym__constructor_operator_alias] = STATE(2579),
    [sym__consym_prefix] = STATE(4674),
    [sym__pconsym] = STATE(4674),
    [sym__qualified_consym] = STATE(2666),
    [sym__qconsym_prefix] = STATE(4674),
    [sym__pqconsym] = STATE(4674),
    [sym__prefix_at] = STATE(2596),
    [sym__paren_open] = STATE(440),
    [sym__bracket_open] = STATE(1037),
    [sym__unboxed_open] = STATE(804),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1119),
    [anon_sym_by] = ACTIONS(1117),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_mdo] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_u27e6] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1117),
    [sym_implicit_variable] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [sym_label] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [anon_sym_RBRACK] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_tight_dot] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__cond_minus] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [558] = {
    [sym__type_parens] = STATE(4374),
    [sym__type_tuple] = STATE(4375),
    [sym__type_unboxed_tuple] = STATE(4376),
    [sym__type_unboxed_sum] = STATE(4377),
    [sym__type_list] = STATE(4379),
    [sym__type_promoted] = STATE(4373),
    [sym__type_star] = STATE(4373),
    [sym__type_wildcard] = STATE(4373),
    [sym__at_type] = STATE(4388),
    [sym__type_apply] = STATE(4380),
    [sym__type_infix] = STATE(4381),
    [sym_type] = STATE(566),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8467),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(4373),
    [sym_quasiquote] = STATE(4373),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(4382),
    [sym_unit] = STATE(4373),
    [sym_unboxed_unit] = STATE(4373),
    [sym_prefix_tuple] = STATE(4373),
    [sym_prefix_unboxed_tuple] = STATE(4373),
    [sym_prefix_unboxed_sum] = STATE(4373),
    [sym_literal] = STATE(4373),
    [sym__qualified_type] = STATE(4322),
    [sym__qtyconid] = STATE(4383),
    [sym__tycon_arrow] = STATE(4383),
    [sym__qtycon_arrow] = STATE(4383),
    [sym__promoted_tycons_alias] = STATE(4373),
    [sym__promoted_tycons] = STATE(4373),
    [sym__tycon_ticked] = STATE(2568),
    [sym__qtycon_ticked] = STATE(2568),
    [sym__tyconids_ticked] = STATE(2568),
    [sym__promoted_tyconops_alias] = STATE(2568),
    [sym__promoted_tyconops] = STATE(2568),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2568),
    [sym__operator_alias] = STATE(2568),
    [sym__operator_minus] = STATE(2568),
    [sym__varsym_prefix] = STATE(4383),
    [sym__pvarsym] = STATE(4383),
    [sym__qualified_varsym] = STATE(2557),
    [sym__qvarsym_prefix] = STATE(4383),
    [sym__pqvarsym] = STATE(4383),
    [sym_constructor_operator] = STATE(2568),
    [sym__constructor_operator_alias] = STATE(2568),
    [sym__consym_prefix] = STATE(4383),
    [sym__pconsym] = STATE(4383),
    [sym__qualified_consym] = STATE(2552),
    [sym__qconsym_prefix] = STATE(4383),
    [sym__pqconsym] = STATE(4383),
    [sym__prefix_at] = STATE(2606),
    [sym__paren_open] = STATE(443),
    [sym__bracket_open] = STATE(1042),
    [sym__unboxed_open] = STATE(784),
    [sym_variable] = ACTIONS(1795),
    [anon_sym_let] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1797),
    [anon_sym_SQUOTE] = ACTIONS(1799),
    [anon_sym_STAR] = ACTIONS(1801),
    [anon_sym_u2605] = ACTIONS(1803),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1157),
    [anon_sym_BSLASH] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_mdo] = ACTIONS(1159),
    [anon_sym_do] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1157),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1157),
    [sym_name] = ACTIONS(1805),
    [sym_label] = ACTIONS(1157),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1157),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__cond_minus] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [559] = {
    [sym__type_parens] = STATE(4653),
    [sym__type_tuple] = STATE(4654),
    [sym__type_unboxed_tuple] = STATE(4588),
    [sym__type_unboxed_sum] = STATE(4657),
    [sym__type_list] = STATE(4667),
    [sym__type_promoted] = STATE(4652),
    [sym__type_star] = STATE(4652),
    [sym__type_wildcard] = STATE(4652),
    [sym__at_type] = STATE(4698),
    [sym__type_apply] = STATE(4669),
    [sym__type_infix] = STATE(4672),
    [sym_type] = STATE(557),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8472),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(4652),
    [sym_quasiquote] = STATE(4652),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(4673),
    [sym_unit] = STATE(4652),
    [sym_unboxed_unit] = STATE(4652),
    [sym_prefix_tuple] = STATE(4652),
    [sym_prefix_unboxed_tuple] = STATE(4652),
    [sym_prefix_unboxed_sum] = STATE(4652),
    [sym_literal] = STATE(4652),
    [sym__qualified_type] = STATE(4841),
    [sym__qtyconid] = STATE(4674),
    [sym__tycon_arrow] = STATE(4674),
    [sym__qtycon_arrow] = STATE(4674),
    [sym__promoted_tycons_alias] = STATE(4652),
    [sym__promoted_tycons] = STATE(4652),
    [sym__tycon_ticked] = STATE(2579),
    [sym__qtycon_ticked] = STATE(2579),
    [sym__tyconids_ticked] = STATE(2579),
    [sym__promoted_tyconops_alias] = STATE(2579),
    [sym__promoted_tyconops] = STATE(2579),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2579),
    [sym__operator_alias] = STATE(2579),
    [sym__operator_minus] = STATE(2579),
    [sym__varsym_prefix] = STATE(4674),
    [sym__pvarsym] = STATE(4674),
    [sym__qualified_varsym] = STATE(2574),
    [sym__qvarsym_prefix] = STATE(4674),
    [sym__pqvarsym] = STATE(4674),
    [sym_constructor_operator] = STATE(2579),
    [sym__constructor_operator_alias] = STATE(2579),
    [sym__consym_prefix] = STATE(4674),
    [sym__pconsym] = STATE(4674),
    [sym__qualified_consym] = STATE(2666),
    [sym__qconsym_prefix] = STATE(4674),
    [sym__pqconsym] = STATE(4674),
    [sym__prefix_at] = STATE(2596),
    [sym__paren_open] = STATE(440),
    [sym__bracket_open] = STATE(1037),
    [sym__unboxed_open] = STATE(804),
    [sym_variable] = ACTIONS(1319),
    [anon_sym_let] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(1321),
    [anon_sym__] = ACTIONS(1769),
    [anon_sym_SQUOTE] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1321),
    [anon_sym_u2605] = ACTIONS(1775),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1321),
    [anon_sym_by] = ACTIONS(1319),
    [anon_sym_PIPE] = ACTIONS(1321),
    [anon_sym_BSLASH] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1319),
    [anon_sym_mdo] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1319),
    [anon_sym_case] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_LBRACK] = ACTIONS(1321),
    [anon_sym_u27e6] = ACTIONS(1321),
    [sym_float] = ACTIONS(1321),
    [sym_char] = ACTIONS(1321),
    [sym_string] = ACTIONS(1321),
    [sym__integer_literal] = ACTIONS(1319),
    [sym__binary_literal] = ACTIONS(1321),
    [sym__octal_literal] = ACTIONS(1321),
    [sym__hex_literal] = ACTIONS(1321),
    [anon_sym_BQUOTE] = ACTIONS(1321),
    [anon_sym_POUND] = ACTIONS(1319),
    [anon_sym_POUND2] = ACTIONS(1319),
    [sym_implicit_variable] = ACTIONS(1321),
    [sym_name] = ACTIONS(1321),
    [sym_label] = ACTIONS(1321),
    [anon_sym_COLON_COLON] = ACTIONS(1321),
    [anon_sym_u2237] = ACTIONS(1321),
    [aux_sym__paren_open_token1] = ACTIONS(1321),
    [anon_sym_RBRACK] = ACTIONS(1321),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1321),
    [sym__cond_splice] = ACTIONS(1321),
    [sym__cond_tight_dot] = ACTIONS(1321),
    [sym__cond_prefix_dot] = ACTIONS(1321),
    [sym__cond_prefix_at] = ACTIONS(1321),
    [sym__cond_qualified_op] = ACTIONS(1321),
    [sym__cond_no_section_op] = ACTIONS(1321),
    [sym__cond_minus] = ACTIONS(1321),
    [sym__varsym] = ACTIONS(1321),
    [sym__consym] = ACTIONS(1321),
  },
  [560] = {
    [sym__type_parens] = STATE(4653),
    [sym__type_tuple] = STATE(4654),
    [sym__type_unboxed_tuple] = STATE(4588),
    [sym__type_unboxed_sum] = STATE(4657),
    [sym__type_list] = STATE(4667),
    [sym__type_promoted] = STATE(4652),
    [sym__type_star] = STATE(4652),
    [sym__type_wildcard] = STATE(4652),
    [sym__at_type] = STATE(4698),
    [sym__type_apply] = STATE(4669),
    [sym__type_infix] = STATE(4672),
    [sym_type] = STATE(557),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8472),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(4652),
    [sym_quasiquote] = STATE(4652),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(4673),
    [sym_unit] = STATE(4652),
    [sym_unboxed_unit] = STATE(4652),
    [sym_prefix_tuple] = STATE(4652),
    [sym_prefix_unboxed_tuple] = STATE(4652),
    [sym_prefix_unboxed_sum] = STATE(4652),
    [sym_literal] = STATE(4652),
    [sym__qualified_type] = STATE(4841),
    [sym__qtyconid] = STATE(4674),
    [sym__tycon_arrow] = STATE(4674),
    [sym__qtycon_arrow] = STATE(4674),
    [sym__promoted_tycons_alias] = STATE(4652),
    [sym__promoted_tycons] = STATE(4652),
    [sym__tycon_ticked] = STATE(2579),
    [sym__qtycon_ticked] = STATE(2579),
    [sym__tyconids_ticked] = STATE(2579),
    [sym__promoted_tyconops_alias] = STATE(2579),
    [sym__promoted_tyconops] = STATE(2579),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2579),
    [sym__operator_alias] = STATE(2579),
    [sym__operator_minus] = STATE(2579),
    [sym__varsym_prefix] = STATE(4674),
    [sym__pvarsym] = STATE(4674),
    [sym__qualified_varsym] = STATE(2574),
    [sym__qvarsym_prefix] = STATE(4674),
    [sym__pqvarsym] = STATE(4674),
    [sym_constructor_operator] = STATE(2579),
    [sym__constructor_operator_alias] = STATE(2579),
    [sym__consym_prefix] = STATE(4674),
    [sym__pconsym] = STATE(4674),
    [sym__qualified_consym] = STATE(2666),
    [sym__qconsym_prefix] = STATE(4674),
    [sym__pqconsym] = STATE(4674),
    [sym__prefix_at] = STATE(2596),
    [sym__paren_open] = STATE(440),
    [sym__bracket_open] = STATE(1037),
    [sym__unboxed_open] = STATE(804),
    [sym_variable] = ACTIONS(1767),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1769),
    [anon_sym_SQUOTE] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1773),
    [anon_sym_u2605] = ACTIONS(1775),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_by] = ACTIONS(1183),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1777),
    [sym_label] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1779),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [561] = {
    [sym__type_parens] = STATE(4374),
    [sym__type_tuple] = STATE(4375),
    [sym__type_unboxed_tuple] = STATE(4376),
    [sym__type_unboxed_sum] = STATE(4377),
    [sym__type_list] = STATE(4379),
    [sym__type_promoted] = STATE(4373),
    [sym__type_star] = STATE(4373),
    [sym__type_wildcard] = STATE(4373),
    [sym__at_type] = STATE(4388),
    [sym__type_apply] = STATE(4380),
    [sym__type_infix] = STATE(4381),
    [sym_type] = STATE(566),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8467),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(4373),
    [sym_quasiquote] = STATE(4373),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(4382),
    [sym_unit] = STATE(4373),
    [sym_unboxed_unit] = STATE(4373),
    [sym_prefix_tuple] = STATE(4373),
    [sym_prefix_unboxed_tuple] = STATE(4373),
    [sym_prefix_unboxed_sum] = STATE(4373),
    [sym_literal] = STATE(4373),
    [sym__qualified_type] = STATE(4322),
    [sym__qtyconid] = STATE(4383),
    [sym__tycon_arrow] = STATE(4383),
    [sym__qtycon_arrow] = STATE(4383),
    [sym__promoted_tycons_alias] = STATE(4373),
    [sym__promoted_tycons] = STATE(4373),
    [sym__tycon_ticked] = STATE(2568),
    [sym__qtycon_ticked] = STATE(2568),
    [sym__tyconids_ticked] = STATE(2568),
    [sym__promoted_tyconops_alias] = STATE(2568),
    [sym__promoted_tyconops] = STATE(2568),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2568),
    [sym__operator_alias] = STATE(2568),
    [sym__operator_minus] = STATE(2568),
    [sym__varsym_prefix] = STATE(4383),
    [sym__pvarsym] = STATE(4383),
    [sym__qualified_varsym] = STATE(2557),
    [sym__qvarsym_prefix] = STATE(4383),
    [sym__pqvarsym] = STATE(4383),
    [sym_constructor_operator] = STATE(2568),
    [sym__constructor_operator_alias] = STATE(2568),
    [sym__consym_prefix] = STATE(4383),
    [sym__pconsym] = STATE(4383),
    [sym__qualified_consym] = STATE(2552),
    [sym__qconsym_prefix] = STATE(4383),
    [sym__pqconsym] = STATE(4383),
    [sym__prefix_at] = STATE(2606),
    [sym__paren_open] = STATE(443),
    [sym__bracket_open] = STATE(1042),
    [sym__unboxed_open] = STATE(784),
    [sym_variable] = ACTIONS(1319),
    [anon_sym_let] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(1321),
    [anon_sym__] = ACTIONS(1797),
    [anon_sym_SQUOTE] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1321),
    [anon_sym_u2605] = ACTIONS(1803),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1321),
    [anon_sym_BSLASH] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1319),
    [anon_sym_mdo] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1319),
    [anon_sym_case] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_DASH_GT] = ACTIONS(1321),
    [anon_sym_LBRACK] = ACTIONS(1321),
    [anon_sym_u27e6] = ACTIONS(1321),
    [sym_float] = ACTIONS(1321),
    [sym_char] = ACTIONS(1321),
    [sym_string] = ACTIONS(1321),
    [sym__integer_literal] = ACTIONS(1319),
    [sym__binary_literal] = ACTIONS(1321),
    [sym__octal_literal] = ACTIONS(1321),
    [sym__hex_literal] = ACTIONS(1321),
    [anon_sym_BQUOTE] = ACTIONS(1321),
    [anon_sym_POUND] = ACTIONS(1319),
    [anon_sym_POUND2] = ACTIONS(1319),
    [sym_implicit_variable] = ACTIONS(1321),
    [sym_name] = ACTIONS(1321),
    [sym_label] = ACTIONS(1321),
    [anon_sym_u2192] = ACTIONS(1321),
    [anon_sym_COLON_COLON] = ACTIONS(1321),
    [anon_sym_u2237] = ACTIONS(1321),
    [aux_sym__paren_open_token1] = ACTIONS(1321),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1321),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1321),
    [sym__cond_splice] = ACTIONS(1321),
    [sym__cond_tight_dot] = ACTIONS(1321),
    [sym__cond_prefix_dot] = ACTIONS(1321),
    [sym__cond_prefix_at] = ACTIONS(1321),
    [sym__cond_qualified_op] = ACTIONS(1321),
    [sym__cond_no_section_op] = ACTIONS(1321),
    [sym__cond_minus] = ACTIONS(1321),
    [sym__varsym] = ACTIONS(1321),
    [sym__consym] = ACTIONS(1321),
  },
  [562] = {
    [sym__type_parens] = STATE(4318),
    [sym__type_tuple] = STATE(4319),
    [sym__type_unboxed_tuple] = STATE(4324),
    [sym__type_unboxed_sum] = STATE(4325),
    [sym__type_list] = STATE(4326),
    [sym__type_promoted] = STATE(4317),
    [sym__type_star] = STATE(4317),
    [sym__type_wildcard] = STATE(4317),
    [sym__at_type] = STATE(4348),
    [sym__type_apply] = STATE(4327),
    [sym__type_infix] = STATE(4328),
    [sym_type] = STATE(563),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8493),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(4317),
    [sym_quasiquote] = STATE(4317),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(4329),
    [sym_unit] = STATE(4317),
    [sym_unboxed_unit] = STATE(4317),
    [sym_prefix_tuple] = STATE(4317),
    [sym_prefix_unboxed_tuple] = STATE(4317),
    [sym_prefix_unboxed_sum] = STATE(4317),
    [sym_literal] = STATE(4317),
    [sym__qualified_type] = STATE(4389),
    [sym__qtyconid] = STATE(4330),
    [sym__tycon_arrow] = STATE(4330),
    [sym__qtycon_arrow] = STATE(4330),
    [sym__promoted_tycons_alias] = STATE(4317),
    [sym__promoted_tycons] = STATE(4317),
    [sym__tycon_ticked] = STATE(2404),
    [sym__qtycon_ticked] = STATE(2404),
    [sym__tyconids_ticked] = STATE(2404),
    [sym__promoted_tyconops_alias] = STATE(2404),
    [sym__promoted_tyconops] = STATE(2404),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2404),
    [sym__operator_alias] = STATE(2404),
    [sym__operator_minus] = STATE(2404),
    [sym__varsym_prefix] = STATE(4330),
    [sym__pvarsym] = STATE(4330),
    [sym__qualified_varsym] = STATE(2405),
    [sym__qvarsym_prefix] = STATE(4330),
    [sym__pqvarsym] = STATE(4330),
    [sym_constructor_operator] = STATE(2404),
    [sym__constructor_operator_alias] = STATE(2404),
    [sym__consym_prefix] = STATE(4330),
    [sym__pconsym] = STATE(4330),
    [sym__qualified_consym] = STATE(2406),
    [sym__qconsym_prefix] = STATE(4330),
    [sym__pqconsym] = STATE(4330),
    [sym__prefix_at] = STATE(2413),
    [sym__paren_open] = STATE(433),
    [sym__bracket_open] = STATE(998),
    [sym__unboxed_open] = STATE(820),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1781),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1783),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [563] = {
    [sym__type_parens] = STATE(4318),
    [sym__type_tuple] = STATE(4319),
    [sym__type_unboxed_tuple] = STATE(4324),
    [sym__type_unboxed_sum] = STATE(4325),
    [sym__type_list] = STATE(4326),
    [sym__type_promoted] = STATE(4317),
    [sym__type_star] = STATE(4317),
    [sym__type_wildcard] = STATE(4317),
    [sym__at_type] = STATE(4348),
    [sym__type_apply] = STATE(4327),
    [sym__type_infix] = STATE(4328),
    [sym_type] = STATE(563),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8493),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(4317),
    [sym_quasiquote] = STATE(4317),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(4329),
    [sym_unit] = STATE(4317),
    [sym_unboxed_unit] = STATE(4317),
    [sym_prefix_tuple] = STATE(4317),
    [sym_prefix_unboxed_tuple] = STATE(4317),
    [sym_prefix_unboxed_sum] = STATE(4317),
    [sym_literal] = STATE(4317),
    [sym__qualified_type] = STATE(4389),
    [sym__qtyconid] = STATE(4330),
    [sym__tycon_arrow] = STATE(4330),
    [sym__qtycon_arrow] = STATE(4330),
    [sym__promoted_tycons_alias] = STATE(4317),
    [sym__promoted_tycons] = STATE(4317),
    [sym__tycon_ticked] = STATE(2404),
    [sym__qtycon_ticked] = STATE(2404),
    [sym__tyconids_ticked] = STATE(2404),
    [sym__promoted_tyconops_alias] = STATE(2404),
    [sym__promoted_tyconops] = STATE(2404),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2404),
    [sym__operator_alias] = STATE(2404),
    [sym__operator_minus] = STATE(2404),
    [sym__varsym_prefix] = STATE(4330),
    [sym__pvarsym] = STATE(4330),
    [sym__qualified_varsym] = STATE(2405),
    [sym__qvarsym_prefix] = STATE(4330),
    [sym__pqvarsym] = STATE(4330),
    [sym_constructor_operator] = STATE(2404),
    [sym__constructor_operator_alias] = STATE(2404),
    [sym__consym_prefix] = STATE(4330),
    [sym__pconsym] = STATE(4330),
    [sym__qualified_consym] = STATE(2406),
    [sym__qconsym_prefix] = STATE(4330),
    [sym__pqconsym] = STATE(4330),
    [sym__prefix_at] = STATE(2413),
    [sym__paren_open] = STATE(433),
    [sym__bracket_open] = STATE(998),
    [sym__unboxed_open] = STATE(820),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1119),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_mdo] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_u27e6] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1117),
    [sym_implicit_variable] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [sym_label] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1119),
    [sym__cond_layout_end] = ACTIONS(1119),
    [sym__cond_layout_end_explicit] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_tight_dot] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__cond_minus] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [564] = {
    [sym__type_parens] = STATE(4653),
    [sym__type_tuple] = STATE(4654),
    [sym__type_unboxed_tuple] = STATE(4588),
    [sym__type_unboxed_sum] = STATE(4657),
    [sym__type_list] = STATE(4667),
    [sym__type_promoted] = STATE(4652),
    [sym__type_star] = STATE(4652),
    [sym__type_wildcard] = STATE(4652),
    [sym__at_type] = STATE(4698),
    [sym__type_apply] = STATE(4669),
    [sym__type_infix] = STATE(4672),
    [sym_type] = STATE(557),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8472),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(4652),
    [sym_quasiquote] = STATE(4652),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(4673),
    [sym_unit] = STATE(4652),
    [sym_unboxed_unit] = STATE(4652),
    [sym_prefix_tuple] = STATE(4652),
    [sym_prefix_unboxed_tuple] = STATE(4652),
    [sym_prefix_unboxed_sum] = STATE(4652),
    [sym_literal] = STATE(4652),
    [sym__qualified_type] = STATE(4841),
    [sym__qtyconid] = STATE(4674),
    [sym__tycon_arrow] = STATE(4674),
    [sym__qtycon_arrow] = STATE(4674),
    [sym__promoted_tycons_alias] = STATE(4652),
    [sym__promoted_tycons] = STATE(4652),
    [sym__tycon_ticked] = STATE(2579),
    [sym__qtycon_ticked] = STATE(2579),
    [sym__tyconids_ticked] = STATE(2579),
    [sym__promoted_tyconops_alias] = STATE(2579),
    [sym__promoted_tyconops] = STATE(2579),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2579),
    [sym__operator_alias] = STATE(2579),
    [sym__operator_minus] = STATE(2579),
    [sym__varsym_prefix] = STATE(4674),
    [sym__pvarsym] = STATE(4674),
    [sym__qualified_varsym] = STATE(2574),
    [sym__qvarsym_prefix] = STATE(4674),
    [sym__pqvarsym] = STATE(4674),
    [sym_constructor_operator] = STATE(2579),
    [sym__constructor_operator_alias] = STATE(2579),
    [sym__consym_prefix] = STATE(4674),
    [sym__pconsym] = STATE(4674),
    [sym__qualified_consym] = STATE(2666),
    [sym__qconsym_prefix] = STATE(4674),
    [sym__pqconsym] = STATE(4674),
    [sym__prefix_at] = STATE(2596),
    [sym__paren_open] = STATE(440),
    [sym__bracket_open] = STATE(1037),
    [sym__unboxed_open] = STATE(804),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_by] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_RBRACK] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [565] = {
    [sym__type_parens] = STATE(4374),
    [sym__type_tuple] = STATE(4375),
    [sym__type_unboxed_tuple] = STATE(4376),
    [sym__type_unboxed_sum] = STATE(4377),
    [sym__type_list] = STATE(4379),
    [sym__type_promoted] = STATE(4373),
    [sym__type_star] = STATE(4373),
    [sym__type_wildcard] = STATE(4373),
    [sym__at_type] = STATE(4388),
    [sym__type_apply] = STATE(4380),
    [sym__type_infix] = STATE(4381),
    [sym_type] = STATE(566),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8467),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(4373),
    [sym_quasiquote] = STATE(4373),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(4382),
    [sym_unit] = STATE(4373),
    [sym_unboxed_unit] = STATE(4373),
    [sym_prefix_tuple] = STATE(4373),
    [sym_prefix_unboxed_tuple] = STATE(4373),
    [sym_prefix_unboxed_sum] = STATE(4373),
    [sym_literal] = STATE(4373),
    [sym__qualified_type] = STATE(4322),
    [sym__qtyconid] = STATE(4383),
    [sym__tycon_arrow] = STATE(4383),
    [sym__qtycon_arrow] = STATE(4383),
    [sym__promoted_tycons_alias] = STATE(4373),
    [sym__promoted_tycons] = STATE(4373),
    [sym__tycon_ticked] = STATE(2568),
    [sym__qtycon_ticked] = STATE(2568),
    [sym__tyconids_ticked] = STATE(2568),
    [sym__promoted_tyconops_alias] = STATE(2568),
    [sym__promoted_tyconops] = STATE(2568),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2568),
    [sym__operator_alias] = STATE(2568),
    [sym__operator_minus] = STATE(2568),
    [sym__varsym_prefix] = STATE(4383),
    [sym__pvarsym] = STATE(4383),
    [sym__qualified_varsym] = STATE(2557),
    [sym__qvarsym_prefix] = STATE(4383),
    [sym__pqvarsym] = STATE(4383),
    [sym_constructor_operator] = STATE(2568),
    [sym__constructor_operator_alias] = STATE(2568),
    [sym__consym_prefix] = STATE(4383),
    [sym__pconsym] = STATE(4383),
    [sym__qualified_consym] = STATE(2552),
    [sym__qconsym_prefix] = STATE(4383),
    [sym__pqconsym] = STATE(4383),
    [sym__prefix_at] = STATE(2606),
    [sym__paren_open] = STATE(443),
    [sym__bracket_open] = STATE(1042),
    [sym__unboxed_open] = STATE(784),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [566] = {
    [sym__type_parens] = STATE(4374),
    [sym__type_tuple] = STATE(4375),
    [sym__type_unboxed_tuple] = STATE(4376),
    [sym__type_unboxed_sum] = STATE(4377),
    [sym__type_list] = STATE(4379),
    [sym__type_promoted] = STATE(4373),
    [sym__type_star] = STATE(4373),
    [sym__type_wildcard] = STATE(4373),
    [sym__at_type] = STATE(4388),
    [sym__type_apply] = STATE(4380),
    [sym__type_infix] = STATE(4381),
    [sym_type] = STATE(566),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8467),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(4373),
    [sym_quasiquote] = STATE(4373),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(4382),
    [sym_unit] = STATE(4373),
    [sym_unboxed_unit] = STATE(4373),
    [sym_prefix_tuple] = STATE(4373),
    [sym_prefix_unboxed_tuple] = STATE(4373),
    [sym_prefix_unboxed_sum] = STATE(4373),
    [sym_literal] = STATE(4373),
    [sym__qualified_type] = STATE(4322),
    [sym__qtyconid] = STATE(4383),
    [sym__tycon_arrow] = STATE(4383),
    [sym__qtycon_arrow] = STATE(4383),
    [sym__promoted_tycons_alias] = STATE(4373),
    [sym__promoted_tycons] = STATE(4373),
    [sym__tycon_ticked] = STATE(2568),
    [sym__qtycon_ticked] = STATE(2568),
    [sym__tyconids_ticked] = STATE(2568),
    [sym__promoted_tyconops_alias] = STATE(2568),
    [sym__promoted_tyconops] = STATE(2568),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2568),
    [sym__operator_alias] = STATE(2568),
    [sym__operator_minus] = STATE(2568),
    [sym__varsym_prefix] = STATE(4383),
    [sym__pvarsym] = STATE(4383),
    [sym__qualified_varsym] = STATE(2557),
    [sym__qvarsym_prefix] = STATE(4383),
    [sym__pqvarsym] = STATE(4383),
    [sym_constructor_operator] = STATE(2568),
    [sym__constructor_operator_alias] = STATE(2568),
    [sym__consym_prefix] = STATE(4383),
    [sym__pconsym] = STATE(4383),
    [sym__qualified_consym] = STATE(2552),
    [sym__qconsym_prefix] = STATE(4383),
    [sym__pqconsym] = STATE(4383),
    [sym__prefix_at] = STATE(2606),
    [sym__paren_open] = STATE(443),
    [sym__bracket_open] = STATE(1042),
    [sym__unboxed_open] = STATE(784),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1119),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_mdo] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_u27e6] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1117),
    [sym_implicit_variable] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [sym_label] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_tight_dot] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__cond_minus] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [567] = {
    [sym__type_parens] = STATE(4374),
    [sym__type_tuple] = STATE(4375),
    [sym__type_unboxed_tuple] = STATE(4376),
    [sym__type_unboxed_sum] = STATE(4377),
    [sym__type_list] = STATE(4379),
    [sym__type_promoted] = STATE(4373),
    [sym__type_star] = STATE(4373),
    [sym__type_wildcard] = STATE(4373),
    [sym__at_type] = STATE(4388),
    [sym__type_apply] = STATE(4380),
    [sym__type_infix] = STATE(4381),
    [sym_type] = STATE(566),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8467),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(4373),
    [sym_quasiquote] = STATE(4373),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(4382),
    [sym_unit] = STATE(4373),
    [sym_unboxed_unit] = STATE(4373),
    [sym_prefix_tuple] = STATE(4373),
    [sym_prefix_unboxed_tuple] = STATE(4373),
    [sym_prefix_unboxed_sum] = STATE(4373),
    [sym_literal] = STATE(4373),
    [sym__qualified_type] = STATE(4322),
    [sym__qtyconid] = STATE(4383),
    [sym__tycon_arrow] = STATE(4383),
    [sym__qtycon_arrow] = STATE(4383),
    [sym__promoted_tycons_alias] = STATE(4373),
    [sym__promoted_tycons] = STATE(4373),
    [sym__tycon_ticked] = STATE(2568),
    [sym__qtycon_ticked] = STATE(2568),
    [sym__tyconids_ticked] = STATE(2568),
    [sym__promoted_tyconops_alias] = STATE(2568),
    [sym__promoted_tyconops] = STATE(2568),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2568),
    [sym__operator_alias] = STATE(2568),
    [sym__operator_minus] = STATE(2568),
    [sym__varsym_prefix] = STATE(4383),
    [sym__pvarsym] = STATE(4383),
    [sym__qualified_varsym] = STATE(2557),
    [sym__qvarsym_prefix] = STATE(4383),
    [sym__pqvarsym] = STATE(4383),
    [sym_constructor_operator] = STATE(2568),
    [sym__constructor_operator_alias] = STATE(2568),
    [sym__consym_prefix] = STATE(4383),
    [sym__pconsym] = STATE(4383),
    [sym__qualified_consym] = STATE(2552),
    [sym__qconsym_prefix] = STATE(4383),
    [sym__pqconsym] = STATE(4383),
    [sym__prefix_at] = STATE(2606),
    [sym__paren_open] = STATE(443),
    [sym__bracket_open] = STATE(1042),
    [sym__unboxed_open] = STATE(784),
    [sym_variable] = ACTIONS(1795),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1797),
    [anon_sym_SQUOTE] = ACTIONS(1799),
    [anon_sym_STAR] = ACTIONS(1801),
    [anon_sym_u2605] = ACTIONS(1803),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1805),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [568] = {
    [sym__type_parens] = STATE(4374),
    [sym__type_tuple] = STATE(4375),
    [sym__type_unboxed_tuple] = STATE(4376),
    [sym__type_unboxed_sum] = STATE(4377),
    [sym__type_list] = STATE(4379),
    [sym__type_promoted] = STATE(4373),
    [sym__type_star] = STATE(4373),
    [sym__type_wildcard] = STATE(4373),
    [sym__at_type] = STATE(4388),
    [sym__type_apply] = STATE(4380),
    [sym__type_infix] = STATE(4381),
    [sym_type] = STATE(566),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8467),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(4373),
    [sym_quasiquote] = STATE(4373),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(4382),
    [sym_unit] = STATE(4373),
    [sym_unboxed_unit] = STATE(4373),
    [sym_prefix_tuple] = STATE(4373),
    [sym_prefix_unboxed_tuple] = STATE(4373),
    [sym_prefix_unboxed_sum] = STATE(4373),
    [sym_literal] = STATE(4373),
    [sym__qualified_type] = STATE(4322),
    [sym__qtyconid] = STATE(4383),
    [sym__tycon_arrow] = STATE(4383),
    [sym__qtycon_arrow] = STATE(4383),
    [sym__promoted_tycons_alias] = STATE(4373),
    [sym__promoted_tycons] = STATE(4373),
    [sym__tycon_ticked] = STATE(2568),
    [sym__qtycon_ticked] = STATE(2568),
    [sym__tyconids_ticked] = STATE(2568),
    [sym__promoted_tyconops_alias] = STATE(2568),
    [sym__promoted_tyconops] = STATE(2568),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2568),
    [sym__operator_alias] = STATE(2568),
    [sym__operator_minus] = STATE(2568),
    [sym__varsym_prefix] = STATE(4383),
    [sym__pvarsym] = STATE(4383),
    [sym__qualified_varsym] = STATE(2557),
    [sym__qvarsym_prefix] = STATE(4383),
    [sym__pqvarsym] = STATE(4383),
    [sym_constructor_operator] = STATE(2568),
    [sym__constructor_operator_alias] = STATE(2568),
    [sym__consym_prefix] = STATE(4383),
    [sym__pconsym] = STATE(4383),
    [sym__qualified_consym] = STATE(2552),
    [sym__qconsym_prefix] = STATE(4383),
    [sym__pqconsym] = STATE(4383),
    [sym__prefix_at] = STATE(2606),
    [sym__paren_open] = STATE(443),
    [sym__bracket_open] = STATE(1042),
    [sym__unboxed_open] = STATE(784),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1797),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1803),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [569] = {
    [sym__type_parens] = STATE(4318),
    [sym__type_tuple] = STATE(4319),
    [sym__type_unboxed_tuple] = STATE(4324),
    [sym__type_unboxed_sum] = STATE(4325),
    [sym__type_list] = STATE(4326),
    [sym__type_promoted] = STATE(4317),
    [sym__type_star] = STATE(4317),
    [sym__type_wildcard] = STATE(4317),
    [sym__at_type] = STATE(4348),
    [sym__type_apply] = STATE(4327),
    [sym__type_infix] = STATE(4328),
    [sym_type] = STATE(563),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8493),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(4317),
    [sym_quasiquote] = STATE(4317),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(4329),
    [sym_unit] = STATE(4317),
    [sym_unboxed_unit] = STATE(4317),
    [sym_prefix_tuple] = STATE(4317),
    [sym_prefix_unboxed_tuple] = STATE(4317),
    [sym_prefix_unboxed_sum] = STATE(4317),
    [sym_literal] = STATE(4317),
    [sym__qualified_type] = STATE(4389),
    [sym__qtyconid] = STATE(4330),
    [sym__tycon_arrow] = STATE(4330),
    [sym__qtycon_arrow] = STATE(4330),
    [sym__promoted_tycons_alias] = STATE(4317),
    [sym__promoted_tycons] = STATE(4317),
    [sym__tycon_ticked] = STATE(2404),
    [sym__qtycon_ticked] = STATE(2404),
    [sym__tyconids_ticked] = STATE(2404),
    [sym__promoted_tyconops_alias] = STATE(2404),
    [sym__promoted_tyconops] = STATE(2404),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2404),
    [sym__operator_alias] = STATE(2404),
    [sym__operator_minus] = STATE(2404),
    [sym__varsym_prefix] = STATE(4330),
    [sym__pvarsym] = STATE(4330),
    [sym__qualified_varsym] = STATE(2405),
    [sym__qvarsym_prefix] = STATE(4330),
    [sym__pqvarsym] = STATE(4330),
    [sym_constructor_operator] = STATE(2404),
    [sym__constructor_operator_alias] = STATE(2404),
    [sym__consym_prefix] = STATE(4330),
    [sym__pconsym] = STATE(4330),
    [sym__qualified_consym] = STATE(2406),
    [sym__qconsym_prefix] = STATE(4330),
    [sym__pqconsym] = STATE(4330),
    [sym__prefix_at] = STATE(2413),
    [sym__paren_open] = STATE(433),
    [sym__bracket_open] = STATE(998),
    [sym__unboxed_open] = STATE(820),
    [sym_variable] = ACTIONS(1785),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1781),
    [anon_sym_SQUOTE] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1789),
    [anon_sym_u2605] = ACTIONS(1783),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1791),
    [sym_label] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1793),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [570] = {
    [sym__type_parens] = STATE(4653),
    [sym__type_tuple] = STATE(4654),
    [sym__type_unboxed_tuple] = STATE(4588),
    [sym__type_unboxed_sum] = STATE(4657),
    [sym__type_list] = STATE(4667),
    [sym__type_promoted] = STATE(4652),
    [sym__type_star] = STATE(4652),
    [sym__type_wildcard] = STATE(4652),
    [sym__at_type] = STATE(4698),
    [sym__type_apply] = STATE(4669),
    [sym__type_infix] = STATE(4672),
    [sym_type] = STATE(557),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8472),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(4652),
    [sym_quasiquote] = STATE(4652),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(4673),
    [sym_unit] = STATE(4652),
    [sym_unboxed_unit] = STATE(4652),
    [sym_prefix_tuple] = STATE(4652),
    [sym_prefix_unboxed_tuple] = STATE(4652),
    [sym_prefix_unboxed_sum] = STATE(4652),
    [sym_literal] = STATE(4652),
    [sym__qualified_type] = STATE(4841),
    [sym__qtyconid] = STATE(4674),
    [sym__tycon_arrow] = STATE(4674),
    [sym__qtycon_arrow] = STATE(4674),
    [sym__promoted_tycons_alias] = STATE(4652),
    [sym__promoted_tycons] = STATE(4652),
    [sym__tycon_ticked] = STATE(2579),
    [sym__qtycon_ticked] = STATE(2579),
    [sym__tyconids_ticked] = STATE(2579),
    [sym__promoted_tyconops_alias] = STATE(2579),
    [sym__promoted_tyconops] = STATE(2579),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2579),
    [sym__operator_alias] = STATE(2579),
    [sym__operator_minus] = STATE(2579),
    [sym__varsym_prefix] = STATE(4674),
    [sym__pvarsym] = STATE(4674),
    [sym__qualified_varsym] = STATE(2574),
    [sym__qvarsym_prefix] = STATE(4674),
    [sym__pqvarsym] = STATE(4674),
    [sym_constructor_operator] = STATE(2579),
    [sym__constructor_operator_alias] = STATE(2579),
    [sym__consym_prefix] = STATE(4674),
    [sym__pconsym] = STATE(4674),
    [sym__qualified_consym] = STATE(2666),
    [sym__qconsym_prefix] = STATE(4674),
    [sym__pqconsym] = STATE(4674),
    [sym__prefix_at] = STATE(2596),
    [sym__paren_open] = STATE(440),
    [sym__bracket_open] = STATE(1037),
    [sym__unboxed_open] = STATE(804),
    [sym_variable] = ACTIONS(1767),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1769),
    [anon_sym_SQUOTE] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1773),
    [anon_sym_u2605] = ACTIONS(1775),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_by] = ACTIONS(1183),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1777),
    [sym_label] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1779),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [571] = {
    [sym__type_parens] = STATE(4653),
    [sym__type_tuple] = STATE(4654),
    [sym__type_unboxed_tuple] = STATE(4588),
    [sym__type_unboxed_sum] = STATE(4657),
    [sym__type_list] = STATE(4667),
    [sym__type_promoted] = STATE(4652),
    [sym__type_star] = STATE(4652),
    [sym__type_wildcard] = STATE(4652),
    [sym__at_type] = STATE(4698),
    [sym__type_apply] = STATE(4669),
    [sym__type_infix] = STATE(4672),
    [sym_type] = STATE(557),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8472),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(4652),
    [sym_quasiquote] = STATE(4652),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(4673),
    [sym_unit] = STATE(4652),
    [sym_unboxed_unit] = STATE(4652),
    [sym_prefix_tuple] = STATE(4652),
    [sym_prefix_unboxed_tuple] = STATE(4652),
    [sym_prefix_unboxed_sum] = STATE(4652),
    [sym_literal] = STATE(4652),
    [sym__qualified_type] = STATE(4841),
    [sym__qtyconid] = STATE(4674),
    [sym__tycon_arrow] = STATE(4674),
    [sym__qtycon_arrow] = STATE(4674),
    [sym__promoted_tycons_alias] = STATE(4652),
    [sym__promoted_tycons] = STATE(4652),
    [sym__tycon_ticked] = STATE(2579),
    [sym__qtycon_ticked] = STATE(2579),
    [sym__tyconids_ticked] = STATE(2579),
    [sym__promoted_tyconops_alias] = STATE(2579),
    [sym__promoted_tyconops] = STATE(2579),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2579),
    [sym__operator_alias] = STATE(2579),
    [sym__operator_minus] = STATE(2579),
    [sym__varsym_prefix] = STATE(4674),
    [sym__pvarsym] = STATE(4674),
    [sym__qualified_varsym] = STATE(2574),
    [sym__qvarsym_prefix] = STATE(4674),
    [sym__pqvarsym] = STATE(4674),
    [sym_constructor_operator] = STATE(2579),
    [sym__constructor_operator_alias] = STATE(2579),
    [sym__consym_prefix] = STATE(4674),
    [sym__pconsym] = STATE(4674),
    [sym__qualified_consym] = STATE(2666),
    [sym__qconsym_prefix] = STATE(4674),
    [sym__pqconsym] = STATE(4674),
    [sym__prefix_at] = STATE(2596),
    [sym__paren_open] = STATE(440),
    [sym__bracket_open] = STATE(1037),
    [sym__unboxed_open] = STATE(804),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1769),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1775),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_by] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_RBRACK] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [572] = {
    [sym__type_parens] = STATE(4374),
    [sym__type_tuple] = STATE(4375),
    [sym__type_unboxed_tuple] = STATE(4376),
    [sym__type_unboxed_sum] = STATE(4377),
    [sym__type_list] = STATE(4379),
    [sym__type_promoted] = STATE(4373),
    [sym__type_star] = STATE(4373),
    [sym__type_wildcard] = STATE(4373),
    [sym__at_type] = STATE(4388),
    [sym__type_apply] = STATE(4380),
    [sym__type_infix] = STATE(4381),
    [sym_type] = STATE(566),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8467),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(4373),
    [sym_quasiquote] = STATE(4373),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(4382),
    [sym_unit] = STATE(4373),
    [sym_unboxed_unit] = STATE(4373),
    [sym_prefix_tuple] = STATE(4373),
    [sym_prefix_unboxed_tuple] = STATE(4373),
    [sym_prefix_unboxed_sum] = STATE(4373),
    [sym_literal] = STATE(4373),
    [sym__qualified_type] = STATE(4322),
    [sym__qtyconid] = STATE(4383),
    [sym__tycon_arrow] = STATE(4383),
    [sym__qtycon_arrow] = STATE(4383),
    [sym__promoted_tycons_alias] = STATE(4373),
    [sym__promoted_tycons] = STATE(4373),
    [sym__tycon_ticked] = STATE(2568),
    [sym__qtycon_ticked] = STATE(2568),
    [sym__tyconids_ticked] = STATE(2568),
    [sym__promoted_tyconops_alias] = STATE(2568),
    [sym__promoted_tyconops] = STATE(2568),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2568),
    [sym__operator_alias] = STATE(2568),
    [sym__operator_minus] = STATE(2568),
    [sym__varsym_prefix] = STATE(4383),
    [sym__pvarsym] = STATE(4383),
    [sym__qualified_varsym] = STATE(2557),
    [sym__qvarsym_prefix] = STATE(4383),
    [sym__pqvarsym] = STATE(4383),
    [sym_constructor_operator] = STATE(2568),
    [sym__constructor_operator_alias] = STATE(2568),
    [sym__consym_prefix] = STATE(4383),
    [sym__pconsym] = STATE(4383),
    [sym__qualified_consym] = STATE(2552),
    [sym__qconsym_prefix] = STATE(4383),
    [sym__pqconsym] = STATE(4383),
    [sym__prefix_at] = STATE(2606),
    [sym__paren_open] = STATE(443),
    [sym__bracket_open] = STATE(1042),
    [sym__unboxed_open] = STATE(784),
    [sym_variable] = ACTIONS(1795),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1797),
    [anon_sym_SQUOTE] = ACTIONS(1799),
    [anon_sym_STAR] = ACTIONS(1801),
    [anon_sym_u2605] = ACTIONS(1803),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1805),
    [sym_label] = ACTIONS(1181),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1807),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [573] = {
    [sym__type_parens] = STATE(4318),
    [sym__type_tuple] = STATE(4319),
    [sym__type_unboxed_tuple] = STATE(4324),
    [sym__type_unboxed_sum] = STATE(4325),
    [sym__type_list] = STATE(4326),
    [sym__type_promoted] = STATE(4317),
    [sym__type_star] = STATE(4317),
    [sym__type_wildcard] = STATE(4317),
    [sym__at_type] = STATE(4348),
    [sym__type_apply] = STATE(4327),
    [sym__type_infix] = STATE(4328),
    [sym_type] = STATE(563),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8493),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(4317),
    [sym_quasiquote] = STATE(4317),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(4329),
    [sym_unit] = STATE(4317),
    [sym_unboxed_unit] = STATE(4317),
    [sym_prefix_tuple] = STATE(4317),
    [sym_prefix_unboxed_tuple] = STATE(4317),
    [sym_prefix_unboxed_sum] = STATE(4317),
    [sym_literal] = STATE(4317),
    [sym__qualified_type] = STATE(4389),
    [sym__qtyconid] = STATE(4330),
    [sym__tycon_arrow] = STATE(4330),
    [sym__qtycon_arrow] = STATE(4330),
    [sym__promoted_tycons_alias] = STATE(4317),
    [sym__promoted_tycons] = STATE(4317),
    [sym__tycon_ticked] = STATE(2404),
    [sym__qtycon_ticked] = STATE(2404),
    [sym__tyconids_ticked] = STATE(2404),
    [sym__promoted_tyconops_alias] = STATE(2404),
    [sym__promoted_tyconops] = STATE(2404),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2404),
    [sym__operator_alias] = STATE(2404),
    [sym__operator_minus] = STATE(2404),
    [sym__varsym_prefix] = STATE(4330),
    [sym__pvarsym] = STATE(4330),
    [sym__qualified_varsym] = STATE(2405),
    [sym__qvarsym_prefix] = STATE(4330),
    [sym__pqvarsym] = STATE(4330),
    [sym_constructor_operator] = STATE(2404),
    [sym__constructor_operator_alias] = STATE(2404),
    [sym__consym_prefix] = STATE(4330),
    [sym__pconsym] = STATE(4330),
    [sym__qualified_consym] = STATE(2406),
    [sym__qconsym_prefix] = STATE(4330),
    [sym__pqconsym] = STATE(4330),
    [sym__prefix_at] = STATE(2413),
    [sym__paren_open] = STATE(433),
    [sym__bracket_open] = STATE(998),
    [sym__unboxed_open] = STATE(820),
    [sym_variable] = ACTIONS(1785),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym_let] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1781),
    [anon_sym_SQUOTE] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1789),
    [anon_sym_u2605] = ACTIONS(1783),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1157),
    [anon_sym_BSLASH] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_mdo] = ACTIONS(1159),
    [anon_sym_do] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1157),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1157),
    [sym_name] = ACTIONS(1791),
    [sym_label] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1157),
    [sym__cond_layout_end] = ACTIONS(1157),
    [sym__cond_layout_end_explicit] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1793),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1157),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__cond_minus] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [574] = {
    [sym__type_parens] = STATE(4318),
    [sym__type_tuple] = STATE(4319),
    [sym__type_unboxed_tuple] = STATE(4324),
    [sym__type_unboxed_sum] = STATE(4325),
    [sym__type_list] = STATE(4326),
    [sym__type_promoted] = STATE(4317),
    [sym__type_star] = STATE(4317),
    [sym__type_wildcard] = STATE(4317),
    [sym__at_type] = STATE(4348),
    [sym__type_apply] = STATE(4327),
    [sym__type_infix] = STATE(4328),
    [sym_type] = STATE(563),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8493),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(4317),
    [sym_quasiquote] = STATE(4317),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(4329),
    [sym_unit] = STATE(4317),
    [sym_unboxed_unit] = STATE(4317),
    [sym_prefix_tuple] = STATE(4317),
    [sym_prefix_unboxed_tuple] = STATE(4317),
    [sym_prefix_unboxed_sum] = STATE(4317),
    [sym_literal] = STATE(4317),
    [sym__qualified_type] = STATE(4389),
    [sym__qtyconid] = STATE(4330),
    [sym__tycon_arrow] = STATE(4330),
    [sym__qtycon_arrow] = STATE(4330),
    [sym__promoted_tycons_alias] = STATE(4317),
    [sym__promoted_tycons] = STATE(4317),
    [sym__tycon_ticked] = STATE(2404),
    [sym__qtycon_ticked] = STATE(2404),
    [sym__tyconids_ticked] = STATE(2404),
    [sym__promoted_tyconops_alias] = STATE(2404),
    [sym__promoted_tyconops] = STATE(2404),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2404),
    [sym__operator_alias] = STATE(2404),
    [sym__operator_minus] = STATE(2404),
    [sym__varsym_prefix] = STATE(4330),
    [sym__pvarsym] = STATE(4330),
    [sym__qualified_varsym] = STATE(2405),
    [sym__qvarsym_prefix] = STATE(4330),
    [sym__pqvarsym] = STATE(4330),
    [sym_constructor_operator] = STATE(2404),
    [sym__constructor_operator_alias] = STATE(2404),
    [sym__consym_prefix] = STATE(4330),
    [sym__pconsym] = STATE(4330),
    [sym__qualified_consym] = STATE(2406),
    [sym__qconsym_prefix] = STATE(4330),
    [sym__pqconsym] = STATE(4330),
    [sym__prefix_at] = STATE(2413),
    [sym__paren_open] = STATE(433),
    [sym__bracket_open] = STATE(998),
    [sym__unboxed_open] = STATE(820),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [575] = {
    [sym__type_parens] = STATE(4880),
    [sym__type_tuple] = STATE(4881),
    [sym__type_unboxed_tuple] = STATE(4882),
    [sym__type_unboxed_sum] = STATE(4885),
    [sym__type_list] = STATE(4886),
    [sym__type_promoted] = STATE(4879),
    [sym__type_star] = STATE(4879),
    [sym__type_wildcard] = STATE(4879),
    [sym__at_type] = STATE(4907),
    [sym__type_apply] = STATE(4887),
    [sym__type_infix] = STATE(4890),
    [sym_type] = STATE(586),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8533),
    [sym__splice_dollars] = STATE(7289),
    [sym_splice] = STATE(4879),
    [sym_quasiquote] = STATE(4879),
    [sym_integer] = STATE(5100),
    [sym__plist] = STATE(4891),
    [sym_unit] = STATE(4879),
    [sym_unboxed_unit] = STATE(4879),
    [sym_prefix_tuple] = STATE(4879),
    [sym_prefix_unboxed_tuple] = STATE(4879),
    [sym_prefix_unboxed_sum] = STATE(4879),
    [sym_literal] = STATE(4879),
    [sym__qualified_type] = STATE(5078),
    [sym__qtyconid] = STATE(4892),
    [sym__tycon_arrow] = STATE(4892),
    [sym__qtycon_arrow] = STATE(4892),
    [sym__promoted_tycons_alias] = STATE(4879),
    [sym__promoted_tycons] = STATE(4879),
    [sym__tycon_ticked] = STATE(2540),
    [sym__qtycon_ticked] = STATE(2540),
    [sym__tyconids_ticked] = STATE(2540),
    [sym__promoted_tyconops_alias] = STATE(2540),
    [sym__promoted_tyconops] = STATE(2540),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2540),
    [sym__operator_alias] = STATE(2540),
    [sym__operator_minus] = STATE(2540),
    [sym__varsym_prefix] = STATE(4892),
    [sym__pvarsym] = STATE(4892),
    [sym__qualified_varsym] = STATE(2541),
    [sym__qvarsym_prefix] = STATE(4892),
    [sym__pqvarsym] = STATE(4892),
    [sym_constructor_operator] = STATE(2540),
    [sym__constructor_operator_alias] = STATE(2540),
    [sym__consym_prefix] = STATE(4892),
    [sym__pconsym] = STATE(4892),
    [sym__qualified_consym] = STATE(2542),
    [sym__qconsym_prefix] = STATE(4892),
    [sym__pqconsym] = STATE(4892),
    [sym__prefix_at] = STATE(2569),
    [sym__paren_open] = STATE(476),
    [sym__bracket_open] = STATE(987),
    [sym__unboxed_open] = STATE(802),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym_RBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1179),
    [anon_sym_u27e7] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_LT_DASH] = ACTIONS(1179),
    [anon_sym_u2190] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__paren_close_token1] = ACTIONS(1179),
    [anon_sym_RBRACK] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_tight_bang] = ACTIONS(1179),
    [sym__cond_prefix_bang] = ACTIONS(1179),
    [sym__cond_tight_tilde] = ACTIONS(1179),
    [sym__cond_prefix_tilde] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [576] = {
    [sym__type_parens] = STATE(5044),
    [sym__type_tuple] = STATE(5042),
    [sym__type_unboxed_tuple] = STATE(5041),
    [sym__type_unboxed_sum] = STATE(5039),
    [sym__type_list] = STATE(5038),
    [sym__type_promoted] = STATE(5046),
    [sym__type_star] = STATE(5046),
    [sym__type_wildcard] = STATE(5046),
    [sym__at_type] = STATE(5015),
    [sym__type_apply] = STATE(5036),
    [sym__type_infix] = STATE(5035),
    [sym_type] = STATE(582),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8446),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5046),
    [sym_quasiquote] = STATE(5046),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5034),
    [sym_unit] = STATE(5046),
    [sym_unboxed_unit] = STATE(5046),
    [sym_prefix_tuple] = STATE(5046),
    [sym_prefix_unboxed_tuple] = STATE(5046),
    [sym_prefix_unboxed_sum] = STATE(5046),
    [sym_literal] = STATE(5046),
    [sym__qualified_type] = STATE(4963),
    [sym__qtyconid] = STATE(5033),
    [sym__tycon_arrow] = STATE(5033),
    [sym__qtycon_arrow] = STATE(5033),
    [sym__promoted_tycons_alias] = STATE(5046),
    [sym__promoted_tycons] = STATE(5046),
    [sym__tycon_ticked] = STATE(2458),
    [sym__qtycon_ticked] = STATE(2458),
    [sym__tyconids_ticked] = STATE(2458),
    [sym__promoted_tyconops_alias] = STATE(2458),
    [sym__promoted_tyconops] = STATE(2458),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2458),
    [sym__operator_alias] = STATE(2458),
    [sym__operator_minus] = STATE(2458),
    [sym__varsym_prefix] = STATE(5033),
    [sym__pvarsym] = STATE(5033),
    [sym__qualified_varsym] = STATE(2444),
    [sym__qvarsym_prefix] = STATE(5033),
    [sym__pqvarsym] = STATE(5033),
    [sym_constructor_operator] = STATE(2458),
    [sym__constructor_operator_alias] = STATE(2458),
    [sym__consym_prefix] = STATE(5033),
    [sym__pconsym] = STATE(5033),
    [sym__qualified_consym] = STATE(2443),
    [sym__qconsym_prefix] = STATE(5033),
    [sym__pqconsym] = STATE(5033),
    [sym__prefix_at] = STATE(2648),
    [sym__paren_open] = STATE(451),
    [sym__bracket_open] = STATE(1084),
    [sym__unboxed_open] = STATE(817),
    [sym_variable] = ACTIONS(1319),
    [anon_sym_let] = ACTIONS(1319),
    [anon_sym_LBRACE] = ACTIONS(1321),
    [anon_sym__] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1321),
    [anon_sym_u2605] = ACTIONS(1811),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1321),
    [anon_sym_PIPE] = ACTIONS(1321),
    [anon_sym_BSLASH] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1319),
    [anon_sym_mdo] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1319),
    [anon_sym_case] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_LBRACK] = ACTIONS(1321),
    [anon_sym_u27e6] = ACTIONS(1321),
    [sym_float] = ACTIONS(1321),
    [sym_char] = ACTIONS(1321),
    [sym_string] = ACTIONS(1321),
    [sym__integer_literal] = ACTIONS(1319),
    [sym__binary_literal] = ACTIONS(1321),
    [sym__octal_literal] = ACTIONS(1321),
    [sym__hex_literal] = ACTIONS(1321),
    [anon_sym_BQUOTE] = ACTIONS(1321),
    [anon_sym_POUND] = ACTIONS(1319),
    [anon_sym_POUND2] = ACTIONS(1319),
    [sym_implicit_variable] = ACTIONS(1321),
    [sym_name] = ACTIONS(1321),
    [sym_label] = ACTIONS(1321),
    [anon_sym_COLON_COLON] = ACTIONS(1321),
    [anon_sym_u2237] = ACTIONS(1321),
    [aux_sym__paren_open_token1] = ACTIONS(1321),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(1321),
    [sym__phantom_bar] = ACTIONS(1321),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1321),
    [sym__cond_splice] = ACTIONS(1321),
    [sym__cond_tight_dot] = ACTIONS(1321),
    [sym__cond_prefix_dot] = ACTIONS(1321),
    [sym__cond_prefix_at] = ACTIONS(1321),
    [sym__cond_qualified_op] = ACTIONS(1321),
    [sym__cond_no_section_op] = ACTIONS(1321),
    [sym__cond_minus] = ACTIONS(1321),
    [sym__varsym] = ACTIONS(1321),
    [sym__consym] = ACTIONS(1321),
  },
  [577] = {
    [sym__type_parens] = STATE(5044),
    [sym__type_tuple] = STATE(5042),
    [sym__type_unboxed_tuple] = STATE(5041),
    [sym__type_unboxed_sum] = STATE(5039),
    [sym__type_list] = STATE(5038),
    [sym__type_promoted] = STATE(5046),
    [sym__type_star] = STATE(5046),
    [sym__type_wildcard] = STATE(5046),
    [sym__at_type] = STATE(5015),
    [sym__type_apply] = STATE(5036),
    [sym__type_infix] = STATE(5035),
    [sym_type] = STATE(582),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8446),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5046),
    [sym_quasiquote] = STATE(5046),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5034),
    [sym_unit] = STATE(5046),
    [sym_unboxed_unit] = STATE(5046),
    [sym_prefix_tuple] = STATE(5046),
    [sym_prefix_unboxed_tuple] = STATE(5046),
    [sym_prefix_unboxed_sum] = STATE(5046),
    [sym_literal] = STATE(5046),
    [sym__qualified_type] = STATE(4963),
    [sym__qtyconid] = STATE(5033),
    [sym__tycon_arrow] = STATE(5033),
    [sym__qtycon_arrow] = STATE(5033),
    [sym__promoted_tycons_alias] = STATE(5046),
    [sym__promoted_tycons] = STATE(5046),
    [sym__tycon_ticked] = STATE(2458),
    [sym__qtycon_ticked] = STATE(2458),
    [sym__tyconids_ticked] = STATE(2458),
    [sym__promoted_tyconops_alias] = STATE(2458),
    [sym__promoted_tyconops] = STATE(2458),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2458),
    [sym__operator_alias] = STATE(2458),
    [sym__operator_minus] = STATE(2458),
    [sym__varsym_prefix] = STATE(5033),
    [sym__pvarsym] = STATE(5033),
    [sym__qualified_varsym] = STATE(2444),
    [sym__qvarsym_prefix] = STATE(5033),
    [sym__pqvarsym] = STATE(5033),
    [sym_constructor_operator] = STATE(2458),
    [sym__constructor_operator_alias] = STATE(2458),
    [sym__consym_prefix] = STATE(5033),
    [sym__pconsym] = STATE(5033),
    [sym__qualified_consym] = STATE(2443),
    [sym__qconsym_prefix] = STATE(5033),
    [sym__pqconsym] = STATE(5033),
    [sym__prefix_at] = STATE(2648),
    [sym__paren_open] = STATE(451),
    [sym__bracket_open] = STATE(1084),
    [sym__unboxed_open] = STATE(817),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__phantom_bar] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [578] = {
    [sym__type_parens] = STATE(4880),
    [sym__type_tuple] = STATE(4881),
    [sym__type_unboxed_tuple] = STATE(4882),
    [sym__type_unboxed_sum] = STATE(4885),
    [sym__type_list] = STATE(4886),
    [sym__type_promoted] = STATE(4879),
    [sym__type_star] = STATE(4879),
    [sym__type_wildcard] = STATE(4879),
    [sym__at_type] = STATE(4907),
    [sym__type_apply] = STATE(4887),
    [sym__type_infix] = STATE(4890),
    [sym_type] = STATE(586),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8533),
    [sym__splice_dollars] = STATE(7289),
    [sym_splice] = STATE(4879),
    [sym_quasiquote] = STATE(4879),
    [sym_integer] = STATE(5100),
    [sym__plist] = STATE(4891),
    [sym_unit] = STATE(4879),
    [sym_unboxed_unit] = STATE(4879),
    [sym_prefix_tuple] = STATE(4879),
    [sym_prefix_unboxed_tuple] = STATE(4879),
    [sym_prefix_unboxed_sum] = STATE(4879),
    [sym_literal] = STATE(4879),
    [sym__qualified_type] = STATE(5078),
    [sym__qtyconid] = STATE(4892),
    [sym__tycon_arrow] = STATE(4892),
    [sym__qtycon_arrow] = STATE(4892),
    [sym__promoted_tycons_alias] = STATE(4879),
    [sym__promoted_tycons] = STATE(4879),
    [sym__tycon_ticked] = STATE(2540),
    [sym__qtycon_ticked] = STATE(2540),
    [sym__tyconids_ticked] = STATE(2540),
    [sym__promoted_tyconops_alias] = STATE(2540),
    [sym__promoted_tyconops] = STATE(2540),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2540),
    [sym__operator_alias] = STATE(2540),
    [sym__operator_minus] = STATE(2540),
    [sym__varsym_prefix] = STATE(4892),
    [sym__pvarsym] = STATE(4892),
    [sym__qualified_varsym] = STATE(2541),
    [sym__qvarsym_prefix] = STATE(4892),
    [sym__pqvarsym] = STATE(4892),
    [sym_constructor_operator] = STATE(2540),
    [sym__constructor_operator_alias] = STATE(2540),
    [sym__consym_prefix] = STATE(4892),
    [sym__pconsym] = STATE(4892),
    [sym__qualified_consym] = STATE(2542),
    [sym__qconsym_prefix] = STATE(4892),
    [sym__pqconsym] = STATE(4892),
    [sym__prefix_at] = STATE(2569),
    [sym__paren_open] = STATE(476),
    [sym__bracket_open] = STATE(987),
    [sym__unboxed_open] = STATE(802),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym_RBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1813),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_u2605] = ACTIONS(1817),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1179),
    [anon_sym_u27e7] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_LT_DASH] = ACTIONS(1179),
    [anon_sym_u2190] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__paren_close_token1] = ACTIONS(1179),
    [anon_sym_RBRACK] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_tight_bang] = ACTIONS(1179),
    [sym__cond_prefix_bang] = ACTIONS(1179),
    [sym__cond_tight_tilde] = ACTIONS(1179),
    [sym__cond_prefix_tilde] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(1179),
  },
  [579] = {
    [sym__type_parens] = STATE(4880),
    [sym__type_tuple] = STATE(4881),
    [sym__type_unboxed_tuple] = STATE(4882),
    [sym__type_unboxed_sum] = STATE(4885),
    [sym__type_list] = STATE(4886),
    [sym__type_promoted] = STATE(4879),
    [sym__type_star] = STATE(4879),
    [sym__type_wildcard] = STATE(4879),
    [sym__at_type] = STATE(4907),
    [sym__type_apply] = STATE(4887),
    [sym__type_infix] = STATE(4890),
    [sym_type] = STATE(586),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8533),
    [sym__splice_dollars] = STATE(7289),
    [sym_splice] = STATE(4879),
    [sym_quasiquote] = STATE(4879),
    [sym_integer] = STATE(5100),
    [sym__plist] = STATE(4891),
    [sym_unit] = STATE(4879),
    [sym_unboxed_unit] = STATE(4879),
    [sym_prefix_tuple] = STATE(4879),
    [sym_prefix_unboxed_tuple] = STATE(4879),
    [sym_prefix_unboxed_sum] = STATE(4879),
    [sym_literal] = STATE(4879),
    [sym__qualified_type] = STATE(5078),
    [sym__qtyconid] = STATE(4892),
    [sym__tycon_arrow] = STATE(4892),
    [sym__qtycon_arrow] = STATE(4892),
    [sym__promoted_tycons_alias] = STATE(4879),
    [sym__promoted_tycons] = STATE(4879),
    [sym__tycon_ticked] = STATE(2540),
    [sym__qtycon_ticked] = STATE(2540),
    [sym__tyconids_ticked] = STATE(2540),
    [sym__promoted_tyconops_alias] = STATE(2540),
    [sym__promoted_tyconops] = STATE(2540),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2540),
    [sym__operator_alias] = STATE(2540),
    [sym__operator_minus] = STATE(2540),
    [sym__varsym_prefix] = STATE(4892),
    [sym__pvarsym] = STATE(4892),
    [sym__qualified_varsym] = STATE(2541),
    [sym__qvarsym_prefix] = STATE(4892),
    [sym__pqvarsym] = STATE(4892),
    [sym_constructor_operator] = STATE(2540),
    [sym__constructor_operator_alias] = STATE(2540),
    [sym__consym_prefix] = STATE(4892),
    [sym__pconsym] = STATE(4892),
    [sym__qualified_consym] = STATE(2542),
    [sym__qconsym_prefix] = STATE(4892),
    [sym__pqconsym] = STATE(4892),
    [sym__prefix_at] = STATE(2569),
    [sym__paren_open] = STATE(476),
    [sym__bracket_open] = STATE(987),
    [sym__unboxed_open] = STATE(802),
    [sym_variable] = ACTIONS(1819),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym_RBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1821),
    [anon_sym_SQUOTE] = ACTIONS(1813),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_u2605] = ACTIONS(1817),
    [anon_sym_EQ] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1157),
    [anon_sym_u27e7] = ACTIONS(1157),
    [sym_float] = ACTIONS(1823),
    [sym_char] = ACTIONS(1823),
    [sym_string] = ACTIONS(1823),
    [sym__integer_literal] = ACTIONS(1825),
    [sym__binary_literal] = ACTIONS(1827),
    [sym__octal_literal] = ACTIONS(1827),
    [sym__hex_literal] = ACTIONS(1827),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1829),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_LT_DASH] = ACTIONS(1157),
    [anon_sym_u2190] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1157),
    [anon_sym_RBRACK] = ACTIONS(1157),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1831),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1157),
    [sym__cond_prefix_bang] = ACTIONS(1157),
    [sym__cond_tight_tilde] = ACTIONS(1157),
    [sym__cond_prefix_tilde] = ACTIONS(1157),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [580] = {
    [sym__type_parens] = STATE(5044),
    [sym__type_tuple] = STATE(5042),
    [sym__type_unboxed_tuple] = STATE(5041),
    [sym__type_unboxed_sum] = STATE(5039),
    [sym__type_list] = STATE(5038),
    [sym__type_promoted] = STATE(5046),
    [sym__type_star] = STATE(5046),
    [sym__type_wildcard] = STATE(5046),
    [sym__at_type] = STATE(5015),
    [sym__type_apply] = STATE(5036),
    [sym__type_infix] = STATE(5035),
    [sym_type] = STATE(582),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8446),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5046),
    [sym_quasiquote] = STATE(5046),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5034),
    [sym_unit] = STATE(5046),
    [sym_unboxed_unit] = STATE(5046),
    [sym_prefix_tuple] = STATE(5046),
    [sym_prefix_unboxed_tuple] = STATE(5046),
    [sym_prefix_unboxed_sum] = STATE(5046),
    [sym_literal] = STATE(5046),
    [sym__qualified_type] = STATE(4963),
    [sym__qtyconid] = STATE(5033),
    [sym__tycon_arrow] = STATE(5033),
    [sym__qtycon_arrow] = STATE(5033),
    [sym__promoted_tycons_alias] = STATE(5046),
    [sym__promoted_tycons] = STATE(5046),
    [sym__tycon_ticked] = STATE(2458),
    [sym__qtycon_ticked] = STATE(2458),
    [sym__tyconids_ticked] = STATE(2458),
    [sym__promoted_tyconops_alias] = STATE(2458),
    [sym__promoted_tyconops] = STATE(2458),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2458),
    [sym__operator_alias] = STATE(2458),
    [sym__operator_minus] = STATE(2458),
    [sym__varsym_prefix] = STATE(5033),
    [sym__pvarsym] = STATE(5033),
    [sym__qualified_varsym] = STATE(2444),
    [sym__qvarsym_prefix] = STATE(5033),
    [sym__pqvarsym] = STATE(5033),
    [sym_constructor_operator] = STATE(2458),
    [sym__constructor_operator_alias] = STATE(2458),
    [sym__consym_prefix] = STATE(5033),
    [sym__pconsym] = STATE(5033),
    [sym__qualified_consym] = STATE(2443),
    [sym__qconsym_prefix] = STATE(5033),
    [sym__pqconsym] = STATE(5033),
    [sym__prefix_at] = STATE(2648),
    [sym__paren_open] = STATE(451),
    [sym__bracket_open] = STATE(1084),
    [sym__unboxed_open] = STATE(817),
    [sym_variable] = ACTIONS(1833),
    [anon_sym_let] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1835),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_u2605] = ACTIONS(1811),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1157),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_BSLASH] = ACTIONS(1157),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_mdo] = ACTIONS(1159),
    [anon_sym_do] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1157),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1157),
    [sym_name] = ACTIONS(1839),
    [sym_label] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(1157),
    [sym__phantom_bar] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1841),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1157),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__cond_minus] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [581] = {
    [sym__type_parens] = STATE(5044),
    [sym__type_tuple] = STATE(5042),
    [sym__type_unboxed_tuple] = STATE(5041),
    [sym__type_unboxed_sum] = STATE(5039),
    [sym__type_list] = STATE(5038),
    [sym__type_promoted] = STATE(5046),
    [sym__type_star] = STATE(5046),
    [sym__type_wildcard] = STATE(5046),
    [sym__at_type] = STATE(5015),
    [sym__type_apply] = STATE(5036),
    [sym__type_infix] = STATE(5035),
    [sym_type] = STATE(582),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8446),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5046),
    [sym_quasiquote] = STATE(5046),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5034),
    [sym_unit] = STATE(5046),
    [sym_unboxed_unit] = STATE(5046),
    [sym_prefix_tuple] = STATE(5046),
    [sym_prefix_unboxed_tuple] = STATE(5046),
    [sym_prefix_unboxed_sum] = STATE(5046),
    [sym_literal] = STATE(5046),
    [sym__qualified_type] = STATE(4963),
    [sym__qtyconid] = STATE(5033),
    [sym__tycon_arrow] = STATE(5033),
    [sym__qtycon_arrow] = STATE(5033),
    [sym__promoted_tycons_alias] = STATE(5046),
    [sym__promoted_tycons] = STATE(5046),
    [sym__tycon_ticked] = STATE(2458),
    [sym__qtycon_ticked] = STATE(2458),
    [sym__tyconids_ticked] = STATE(2458),
    [sym__promoted_tyconops_alias] = STATE(2458),
    [sym__promoted_tyconops] = STATE(2458),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2458),
    [sym__operator_alias] = STATE(2458),
    [sym__operator_minus] = STATE(2458),
    [sym__varsym_prefix] = STATE(5033),
    [sym__pvarsym] = STATE(5033),
    [sym__qualified_varsym] = STATE(2444),
    [sym__qvarsym_prefix] = STATE(5033),
    [sym__pqvarsym] = STATE(5033),
    [sym_constructor_operator] = STATE(2458),
    [sym__constructor_operator_alias] = STATE(2458),
    [sym__consym_prefix] = STATE(5033),
    [sym__pconsym] = STATE(5033),
    [sym__qualified_consym] = STATE(2443),
    [sym__qconsym_prefix] = STATE(5033),
    [sym__pqconsym] = STATE(5033),
    [sym__prefix_at] = STATE(2648),
    [sym__paren_open] = STATE(451),
    [sym__bracket_open] = STATE(1084),
    [sym__unboxed_open] = STATE(817),
    [sym_variable] = ACTIONS(1833),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1835),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_u2605] = ACTIONS(1811),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1839),
    [sym_label] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1841),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [582] = {
    [sym__type_parens] = STATE(5044),
    [sym__type_tuple] = STATE(5042),
    [sym__type_unboxed_tuple] = STATE(5041),
    [sym__type_unboxed_sum] = STATE(5039),
    [sym__type_list] = STATE(5038),
    [sym__type_promoted] = STATE(5046),
    [sym__type_star] = STATE(5046),
    [sym__type_wildcard] = STATE(5046),
    [sym__at_type] = STATE(5015),
    [sym__type_apply] = STATE(5036),
    [sym__type_infix] = STATE(5035),
    [sym_type] = STATE(582),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8446),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5046),
    [sym_quasiquote] = STATE(5046),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5034),
    [sym_unit] = STATE(5046),
    [sym_unboxed_unit] = STATE(5046),
    [sym_prefix_tuple] = STATE(5046),
    [sym_prefix_unboxed_tuple] = STATE(5046),
    [sym_prefix_unboxed_sum] = STATE(5046),
    [sym_literal] = STATE(5046),
    [sym__qualified_type] = STATE(4963),
    [sym__qtyconid] = STATE(5033),
    [sym__tycon_arrow] = STATE(5033),
    [sym__qtycon_arrow] = STATE(5033),
    [sym__promoted_tycons_alias] = STATE(5046),
    [sym__promoted_tycons] = STATE(5046),
    [sym__tycon_ticked] = STATE(2458),
    [sym__qtycon_ticked] = STATE(2458),
    [sym__tyconids_ticked] = STATE(2458),
    [sym__promoted_tyconops_alias] = STATE(2458),
    [sym__promoted_tyconops] = STATE(2458),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2458),
    [sym__operator_alias] = STATE(2458),
    [sym__operator_minus] = STATE(2458),
    [sym__varsym_prefix] = STATE(5033),
    [sym__pvarsym] = STATE(5033),
    [sym__qualified_varsym] = STATE(2444),
    [sym__qvarsym_prefix] = STATE(5033),
    [sym__pqvarsym] = STATE(5033),
    [sym_constructor_operator] = STATE(2458),
    [sym__constructor_operator_alias] = STATE(2458),
    [sym__consym_prefix] = STATE(5033),
    [sym__pconsym] = STATE(5033),
    [sym__qualified_consym] = STATE(2443),
    [sym__qconsym_prefix] = STATE(5033),
    [sym__pqconsym] = STATE(5033),
    [sym__prefix_at] = STATE(2648),
    [sym__paren_open] = STATE(451),
    [sym__bracket_open] = STATE(1084),
    [sym__unboxed_open] = STATE(817),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_let] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_BSLASH] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1117),
    [anon_sym_mdo] = ACTIONS(1117),
    [anon_sym_do] = ACTIONS(1117),
    [anon_sym_case] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_u27e6] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1117),
    [sym_implicit_variable] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [sym_label] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(1119),
    [sym__phantom_bar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_tight_dot] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__cond_minus] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [583] = {
    [sym__type_parens] = STATE(5044),
    [sym__type_tuple] = STATE(5042),
    [sym__type_unboxed_tuple] = STATE(5041),
    [sym__type_unboxed_sum] = STATE(5039),
    [sym__type_list] = STATE(5038),
    [sym__type_promoted] = STATE(5046),
    [sym__type_star] = STATE(5046),
    [sym__type_wildcard] = STATE(5046),
    [sym__at_type] = STATE(5015),
    [sym__type_apply] = STATE(5036),
    [sym__type_infix] = STATE(5035),
    [sym_type] = STATE(582),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8446),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5046),
    [sym_quasiquote] = STATE(5046),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5034),
    [sym_unit] = STATE(5046),
    [sym_unboxed_unit] = STATE(5046),
    [sym_prefix_tuple] = STATE(5046),
    [sym_prefix_unboxed_tuple] = STATE(5046),
    [sym_prefix_unboxed_sum] = STATE(5046),
    [sym_literal] = STATE(5046),
    [sym__qualified_type] = STATE(4963),
    [sym__qtyconid] = STATE(5033),
    [sym__tycon_arrow] = STATE(5033),
    [sym__qtycon_arrow] = STATE(5033),
    [sym__promoted_tycons_alias] = STATE(5046),
    [sym__promoted_tycons] = STATE(5046),
    [sym__tycon_ticked] = STATE(2458),
    [sym__qtycon_ticked] = STATE(2458),
    [sym__tyconids_ticked] = STATE(2458),
    [sym__promoted_tyconops_alias] = STATE(2458),
    [sym__promoted_tyconops] = STATE(2458),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2458),
    [sym__operator_alias] = STATE(2458),
    [sym__operator_minus] = STATE(2458),
    [sym__varsym_prefix] = STATE(5033),
    [sym__pvarsym] = STATE(5033),
    [sym__qualified_varsym] = STATE(2444),
    [sym__qvarsym_prefix] = STATE(5033),
    [sym__pqvarsym] = STATE(5033),
    [sym_constructor_operator] = STATE(2458),
    [sym__constructor_operator_alias] = STATE(2458),
    [sym__consym_prefix] = STATE(5033),
    [sym__pconsym] = STATE(5033),
    [sym__qualified_consym] = STATE(2443),
    [sym__qconsym_prefix] = STATE(5033),
    [sym__pqconsym] = STATE(5033),
    [sym__prefix_at] = STATE(2648),
    [sym__paren_open] = STATE(451),
    [sym__bracket_open] = STATE(1084),
    [sym__unboxed_open] = STATE(817),
    [sym_variable] = ACTIONS(1833),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1835),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_u2605] = ACTIONS(1811),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_BSLASH] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_mdo] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_u27e6] = ACTIONS(1181),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [sym_implicit_variable] = ACTIONS(1181),
    [sym_name] = ACTIONS(1839),
    [sym_label] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1841),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_dot] = ACTIONS(1181),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [584] = {
    [sym__type_parens] = STATE(4880),
    [sym__type_tuple] = STATE(4881),
    [sym__type_unboxed_tuple] = STATE(4882),
    [sym__type_unboxed_sum] = STATE(4885),
    [sym__type_list] = STATE(4886),
    [sym__type_promoted] = STATE(4879),
    [sym__type_star] = STATE(4879),
    [sym__type_wildcard] = STATE(4879),
    [sym__at_type] = STATE(4907),
    [sym__type_apply] = STATE(4887),
    [sym__type_infix] = STATE(4890),
    [sym_type] = STATE(586),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8533),
    [sym__splice_dollars] = STATE(7289),
    [sym_splice] = STATE(4879),
    [sym_quasiquote] = STATE(4879),
    [sym_integer] = STATE(5100),
    [sym__plist] = STATE(4891),
    [sym_unit] = STATE(4879),
    [sym_unboxed_unit] = STATE(4879),
    [sym_prefix_tuple] = STATE(4879),
    [sym_prefix_unboxed_tuple] = STATE(4879),
    [sym_prefix_unboxed_sum] = STATE(4879),
    [sym_literal] = STATE(4879),
    [sym__qualified_type] = STATE(5078),
    [sym__qtyconid] = STATE(4892),
    [sym__tycon_arrow] = STATE(4892),
    [sym__qtycon_arrow] = STATE(4892),
    [sym__promoted_tycons_alias] = STATE(4879),
    [sym__promoted_tycons] = STATE(4879),
    [sym__tycon_ticked] = STATE(2540),
    [sym__qtycon_ticked] = STATE(2540),
    [sym__tyconids_ticked] = STATE(2540),
    [sym__promoted_tyconops_alias] = STATE(2540),
    [sym__promoted_tyconops] = STATE(2540),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2540),
    [sym__operator_alias] = STATE(2540),
    [sym__operator_minus] = STATE(2540),
    [sym__varsym_prefix] = STATE(4892),
    [sym__pvarsym] = STATE(4892),
    [sym__qualified_varsym] = STATE(2541),
    [sym__qvarsym_prefix] = STATE(4892),
    [sym__pqvarsym] = STATE(4892),
    [sym_constructor_operator] = STATE(2540),
    [sym__constructor_operator_alias] = STATE(2540),
    [sym__consym_prefix] = STATE(4892),
    [sym__pconsym] = STATE(4892),
    [sym__qualified_consym] = STATE(2542),
    [sym__qconsym_prefix] = STATE(4892),
    [sym__pqconsym] = STATE(4892),
    [sym__prefix_at] = STATE(2569),
    [sym__paren_open] = STATE(476),
    [sym__bracket_open] = STATE(987),
    [sym__unboxed_open] = STATE(802),
    [sym_variable] = ACTIONS(1819),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1821),
    [anon_sym_SQUOTE] = ACTIONS(1813),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_u2605] = ACTIONS(1817),
    [anon_sym_EQ] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1181),
    [anon_sym_u27e7] = ACTIONS(1181),
    [sym_float] = ACTIONS(1823),
    [sym_char] = ACTIONS(1823),
    [sym_string] = ACTIONS(1823),
    [sym__integer_literal] = ACTIONS(1825),
    [sym__binary_literal] = ACTIONS(1827),
    [sym__octal_literal] = ACTIONS(1827),
    [sym__hex_literal] = ACTIONS(1827),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1829),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_LT_DASH] = ACTIONS(1181),
    [anon_sym_u2190] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1181),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1831),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1181),
    [sym__cond_prefix_bang] = ACTIONS(1181),
    [sym__cond_tight_tilde] = ACTIONS(1181),
    [sym__cond_prefix_tilde] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [585] = {
    [sym__type_parens] = STATE(5044),
    [sym__type_tuple] = STATE(5042),
    [sym__type_unboxed_tuple] = STATE(5041),
    [sym__type_unboxed_sum] = STATE(5039),
    [sym__type_list] = STATE(5038),
    [sym__type_promoted] = STATE(5046),
    [sym__type_star] = STATE(5046),
    [sym__type_wildcard] = STATE(5046),
    [sym__at_type] = STATE(5015),
    [sym__type_apply] = STATE(5036),
    [sym__type_infix] = STATE(5035),
    [sym_type] = STATE(582),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8446),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5046),
    [sym_quasiquote] = STATE(5046),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5034),
    [sym_unit] = STATE(5046),
    [sym_unboxed_unit] = STATE(5046),
    [sym_prefix_tuple] = STATE(5046),
    [sym_prefix_unboxed_tuple] = STATE(5046),
    [sym_prefix_unboxed_sum] = STATE(5046),
    [sym_literal] = STATE(5046),
    [sym__qualified_type] = STATE(4963),
    [sym__qtyconid] = STATE(5033),
    [sym__tycon_arrow] = STATE(5033),
    [sym__qtycon_arrow] = STATE(5033),
    [sym__promoted_tycons_alias] = STATE(5046),
    [sym__promoted_tycons] = STATE(5046),
    [sym__tycon_ticked] = STATE(2458),
    [sym__qtycon_ticked] = STATE(2458),
    [sym__tyconids_ticked] = STATE(2458),
    [sym__promoted_tyconops_alias] = STATE(2458),
    [sym__promoted_tyconops] = STATE(2458),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2458),
    [sym__operator_alias] = STATE(2458),
    [sym__operator_minus] = STATE(2458),
    [sym__varsym_prefix] = STATE(5033),
    [sym__pvarsym] = STATE(5033),
    [sym__qualified_varsym] = STATE(2444),
    [sym__qvarsym_prefix] = STATE(5033),
    [sym__pqvarsym] = STATE(5033),
    [sym_constructor_operator] = STATE(2458),
    [sym__constructor_operator_alias] = STATE(2458),
    [sym__consym_prefix] = STATE(5033),
    [sym__pconsym] = STATE(5033),
    [sym__qualified_consym] = STATE(2443),
    [sym__qconsym_prefix] = STATE(5033),
    [sym__pqconsym] = STATE(5033),
    [sym__prefix_at] = STATE(2648),
    [sym__paren_open] = STATE(451),
    [sym__bracket_open] = STATE(1084),
    [sym__unboxed_open] = STATE(817),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1811),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_BSLASH] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_mdo] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [anon_sym_u27e6] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [sym_implicit_variable] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [sym_label] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__phantom_bar] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_tight_dot] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [586] = {
    [sym__type_parens] = STATE(4880),
    [sym__type_tuple] = STATE(4881),
    [sym__type_unboxed_tuple] = STATE(4882),
    [sym__type_unboxed_sum] = STATE(4885),
    [sym__type_list] = STATE(4886),
    [sym__type_promoted] = STATE(4879),
    [sym__type_star] = STATE(4879),
    [sym__type_wildcard] = STATE(4879),
    [sym__at_type] = STATE(4907),
    [sym__type_apply] = STATE(4887),
    [sym__type_infix] = STATE(4890),
    [sym_type] = STATE(586),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8533),
    [sym__splice_dollars] = STATE(7289),
    [sym_splice] = STATE(4879),
    [sym_quasiquote] = STATE(4879),
    [sym_integer] = STATE(5100),
    [sym__plist] = STATE(4891),
    [sym_unit] = STATE(4879),
    [sym_unboxed_unit] = STATE(4879),
    [sym_prefix_tuple] = STATE(4879),
    [sym_prefix_unboxed_tuple] = STATE(4879),
    [sym_prefix_unboxed_sum] = STATE(4879),
    [sym_literal] = STATE(4879),
    [sym__qualified_type] = STATE(5078),
    [sym__qtyconid] = STATE(4892),
    [sym__tycon_arrow] = STATE(4892),
    [sym__qtycon_arrow] = STATE(4892),
    [sym__promoted_tycons_alias] = STATE(4879),
    [sym__promoted_tycons] = STATE(4879),
    [sym__tycon_ticked] = STATE(2540),
    [sym__qtycon_ticked] = STATE(2540),
    [sym__tyconids_ticked] = STATE(2540),
    [sym__promoted_tyconops_alias] = STATE(2540),
    [sym__promoted_tyconops] = STATE(2540),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2540),
    [sym__operator_alias] = STATE(2540),
    [sym__operator_minus] = STATE(2540),
    [sym__varsym_prefix] = STATE(4892),
    [sym__pvarsym] = STATE(4892),
    [sym__qualified_varsym] = STATE(2541),
    [sym__qvarsym_prefix] = STATE(4892),
    [sym__pqvarsym] = STATE(4892),
    [sym_constructor_operator] = STATE(2540),
    [sym__constructor_operator_alias] = STATE(2540),
    [sym__consym_prefix] = STATE(4892),
    [sym__pconsym] = STATE(4892),
    [sym__qualified_consym] = STATE(2542),
    [sym__qconsym_prefix] = STATE(4892),
    [sym__pqconsym] = STATE(4892),
    [sym__prefix_at] = STATE(2569),
    [sym__paren_open] = STATE(476),
    [sym__bracket_open] = STATE(987),
    [sym__unboxed_open] = STATE(802),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_RBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_EQ] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1119),
    [anon_sym_u27e7] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_LT_DASH] = ACTIONS(1119),
    [anon_sym_u2190] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__paren_close_token1] = ACTIONS(1119),
    [anon_sym_RBRACK] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_tight_bang] = ACTIONS(1119),
    [sym__cond_prefix_bang] = ACTIONS(1119),
    [sym__cond_tight_tilde] = ACTIONS(1119),
    [sym__cond_prefix_tilde] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [587] = {
    [sym__type_parens] = STATE(4880),
    [sym__type_tuple] = STATE(4881),
    [sym__type_unboxed_tuple] = STATE(4882),
    [sym__type_unboxed_sum] = STATE(4885),
    [sym__type_list] = STATE(4886),
    [sym__type_promoted] = STATE(4879),
    [sym__type_star] = STATE(4879),
    [sym__type_wildcard] = STATE(4879),
    [sym__at_type] = STATE(4907),
    [sym__type_apply] = STATE(4887),
    [sym__type_infix] = STATE(4890),
    [sym_type] = STATE(586),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8533),
    [sym__splice_dollars] = STATE(7289),
    [sym_splice] = STATE(4879),
    [sym_quasiquote] = STATE(4879),
    [sym_integer] = STATE(5100),
    [sym__plist] = STATE(4891),
    [sym_unit] = STATE(4879),
    [sym_unboxed_unit] = STATE(4879),
    [sym_prefix_tuple] = STATE(4879),
    [sym_prefix_unboxed_tuple] = STATE(4879),
    [sym_prefix_unboxed_sum] = STATE(4879),
    [sym_literal] = STATE(4879),
    [sym__qualified_type] = STATE(5078),
    [sym__qtyconid] = STATE(4892),
    [sym__tycon_arrow] = STATE(4892),
    [sym__qtycon_arrow] = STATE(4892),
    [sym__promoted_tycons_alias] = STATE(4879),
    [sym__promoted_tycons] = STATE(4879),
    [sym__tycon_ticked] = STATE(2540),
    [sym__qtycon_ticked] = STATE(2540),
    [sym__tyconids_ticked] = STATE(2540),
    [sym__promoted_tyconops_alias] = STATE(2540),
    [sym__promoted_tyconops] = STATE(2540),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2540),
    [sym__operator_alias] = STATE(2540),
    [sym__operator_minus] = STATE(2540),
    [sym__varsym_prefix] = STATE(4892),
    [sym__pvarsym] = STATE(4892),
    [sym__qualified_varsym] = STATE(2541),
    [sym__qvarsym_prefix] = STATE(4892),
    [sym__pqvarsym] = STATE(4892),
    [sym_constructor_operator] = STATE(2540),
    [sym__constructor_operator_alias] = STATE(2540),
    [sym__consym_prefix] = STATE(4892),
    [sym__pconsym] = STATE(4892),
    [sym__qualified_consym] = STATE(2542),
    [sym__qconsym_prefix] = STATE(4892),
    [sym__pqconsym] = STATE(4892),
    [sym__prefix_at] = STATE(2569),
    [sym__paren_open] = STATE(476),
    [sym__bracket_open] = STATE(987),
    [sym__unboxed_open] = STATE(802),
    [sym_variable] = ACTIONS(1819),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1821),
    [anon_sym_SQUOTE] = ACTIONS(1813),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_u2605] = ACTIONS(1817),
    [anon_sym_EQ] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1181),
    [anon_sym_u27e7] = ACTIONS(1181),
    [sym_float] = ACTIONS(1823),
    [sym_char] = ACTIONS(1823),
    [sym_string] = ACTIONS(1823),
    [sym__integer_literal] = ACTIONS(1825),
    [sym__binary_literal] = ACTIONS(1827),
    [sym__octal_literal] = ACTIONS(1827),
    [sym__hex_literal] = ACTIONS(1827),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1829),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_LT_DASH] = ACTIONS(1181),
    [anon_sym_u2190] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1181),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1831),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1181),
    [sym__cond_prefix_bang] = ACTIONS(1181),
    [sym__cond_tight_tilde] = ACTIONS(1181),
    [sym__cond_prefix_tilde] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [588] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11926),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(12082),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12082),
    [sym__operator_minus] = STATE(12082),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11973),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12086),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11975),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [589] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11363),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11620),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11620),
    [sym__operator_minus] = STATE(11620),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(12090),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11419),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(12206),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [590] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11862),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11885),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11885),
    [sym__operator_minus] = STATE(11885),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11608),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11753),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11769),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [591] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11770),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(12176),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12176),
    [sym__operator_minus] = STATE(12176),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11708),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11513),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11914),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [592] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11590),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11337),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11337),
    [sym__operator_minus] = STATE(11337),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11781),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12207),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11592),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [593] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11949),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(12205),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12205),
    [sym__operator_minus] = STATE(12205),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11810),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11896),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11367),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [594] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11882),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(12056),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12056),
    [sym__operator_minus] = STATE(12056),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11937),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12060),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11939),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [595] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11670),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(12014),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12014),
    [sym__operator_minus] = STATE(12014),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(12019),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11399),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11965),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [596] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11567),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11534),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11534),
    [sym__operator_minus] = STATE(11534),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11356),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11561),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11778),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [597] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11848),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(12043),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12043),
    [sym__operator_minus] = STATE(12043),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11897),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12034),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11899),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [598] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11811),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(12030),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12030),
    [sym__operator_minus] = STATE(12030),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(12059),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12124),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(12061),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [599] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11371),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11757),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11757),
    [sym__operator_minus] = STATE(11757),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11464),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11835),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11540),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [600] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11474),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11395),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11395),
    [sym__operator_minus] = STATE(11395),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11979),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11818),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11696),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [601] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11774),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(12017),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12017),
    [sym__operator_minus] = STATE(12017),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11868),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12021),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11870),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [602] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11413),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(12040),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12040),
    [sym__operator_minus] = STATE(12040),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(12202),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11364),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11480),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [603] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11737),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(12003),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12003),
    [sym__operator_minus] = STATE(12003),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11991),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12094),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11993),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [604] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11905),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11736),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11736),
    [sym__operator_minus] = STATE(11736),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11525),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11593),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11370),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [605] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12076),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(12138),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12138),
    [sym__operator_minus] = STATE(12138),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(12114),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12143),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(12116),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [606] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12063),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(12135),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12135),
    [sym__operator_minus] = STATE(12135),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(12107),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12141),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(12109),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [607] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11339),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11720),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11720),
    [sym__operator_minus] = STATE(11720),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11358),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11724),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11429),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [608] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11348),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11859),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11859),
    [sym__operator_minus] = STATE(11859),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11518),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12018),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11350),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [609] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11372),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11574),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11574),
    [sym__operator_minus] = STATE(11574),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(12067),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11391),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11891),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [610] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11663),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11970),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11970),
    [sym__operator_minus] = STATE(11970),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11797),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11992),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11799),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [611] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11626),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11952),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11952),
    [sym__operator_minus] = STATE(11952),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11918),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12047),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11920),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [612] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11589),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11934),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11934),
    [sym__operator_minus] = STATE(11934),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11723),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11974),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11762),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [613] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11552),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11915),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11915),
    [sym__operator_minus] = STATE(11915),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11686),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11956),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11725),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [614] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11617),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11735),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11735),
    [sym__operator_minus] = STATE(11735),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11492),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12204),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11459),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [615] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11515),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11894),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11894),
    [sym__operator_minus] = STATE(11894),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11649),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11938),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11688),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [616] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11478),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11865),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11865),
    [sym__operator_minus] = STATE(11865),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11612),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11919),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11651),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [617] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12050),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(12131),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12131),
    [sym__operator_minus] = STATE(12131),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(12100),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12139),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(12102),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [618] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12005),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11528),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11528),
    [sym__operator_minus] = STATE(11528),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11353),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11978),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11710),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [619] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11486),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11683),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11683),
    [sym__operator_minus] = STATE(11683),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11421),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11687),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11392),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [620] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11441),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11831),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11831),
    [sym__operator_minus] = STATE(11831),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11575),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11898),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11614),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [621] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11944),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(12091),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12091),
    [sym__operator_minus] = STATE(12091),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(12006),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12101),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(12008),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [622] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11700),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11988),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11988),
    [sym__operator_minus] = STATE(11988),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11834),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12007),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11836),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [623] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12037),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(12127),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12127),
    [sym__operator_minus] = STATE(12127),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(12093),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12136),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11331),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [624] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11606),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11646),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11646),
    [sym__operator_minus] = STATE(11646),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11533),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11613),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11360),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [625] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11717),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11609),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11609),
    [sym__operator_minus] = STATE(11609),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11638),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11576),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11417),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [626] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11843),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11572),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11572),
    [sym__operator_minus] = STATE(11572),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11754),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11539),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11531),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [627] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11985),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11535),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11535),
    [sym__operator_minus] = STATE(11535),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11907),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11465),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11634),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [628] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11771),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11805),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11805),
    [sym__operator_minus] = STATE(11805),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11401),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11904),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11633),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [629] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11906),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(12069),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12069),
    [sym__operator_minus] = STATE(12069),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11955),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12073),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11957),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [630] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11404),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11794),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11794),
    [sym__operator_minus] = STATE(11794),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11538),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11869),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11577),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [631] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11962),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(12098),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12098),
    [sym__operator_minus] = STATE(12098),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(12020),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12108),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(12022),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [632] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11980),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(12105),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12105),
    [sym__operator_minus] = STATE(12105),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(12033),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12115),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(12035),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [633] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12166),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(12077),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12077),
    [sym__operator_minus] = STATE(12077),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11913),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11532),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(12097),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [634] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12208),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11498),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11498),
    [sym__operator_minus] = STATE(11498),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11760),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11428),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11752),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [635] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11809),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11644),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11644),
    [sym__operator_minus] = STATE(11644),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11390),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11761),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11466),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [636] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11422),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11553),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11553),
    [sym__operator_minus] = STATE(11553),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11400),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11745),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11823),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [637] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11460),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11435),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11435),
    [sym__operator_minus] = STATE(11435),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11427),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11798),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11503),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [638] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11758),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11565),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11565),
    [sym__operator_minus] = STATE(11565),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(12185),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12183),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(12178),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [639] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11953),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11711),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11711),
    [sym__operator_minus] = STATE(11711),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11741),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11636),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(12145),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [640] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11996),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(12112),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12112),
    [sym__operator_minus] = STATE(12112),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(12046),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12120),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(12048),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [641] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11742),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11684),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11684),
    [sym__operator_minus] = STATE(11684),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11895),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11352),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11803),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [642] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12011),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(12119),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12119),
    [sym__operator_minus] = STATE(12119),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(12072),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12128),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(12074),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [643] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12140),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11461),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11461),
    [sym__operator_minus] = STATE(11461),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(12201),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11359),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(12054),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [644] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12027),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11424),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11424),
    [sym__operator_minus] = STATE(11424),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11501),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12064),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11407),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [645] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11820),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11387),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11387),
    [sym__operator_minus] = STATE(11387),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11990),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12092),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(11879),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [646] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12024),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(12123),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(12123),
    [sym__operator_minus] = STATE(12123),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(12085),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(12132),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(12087),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [647] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11666),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8268),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__operator_qual_dot_head] = STATE(11355),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11355),
    [sym__operator_minus] = STATE(11355),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qualified_varsym] = STATE(11816),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym_constructor_operator] = STATE(11916),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qualified_consym] = STATE(12212),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(241),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(1845),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [648] = {
    [sym__type_parens] = STATE(5871),
    [sym__type_tuple] = STATE(5812),
    [sym__type_unboxed_tuple] = STATE(5874),
    [sym__type_unboxed_sum] = STATE(5875),
    [sym__type_list] = STATE(5859),
    [sym__type_promoted] = STATE(5866),
    [sym__type_star] = STATE(5866),
    [sym__type_wildcard] = STATE(5866),
    [sym__at_type] = STATE(5854),
    [sym__type_apply] = STATE(5860),
    [sym__type_infix] = STATE(5862),
    [sym_type] = STATE(652),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8450),
    [sym__splice_dollars] = STATE(7272),
    [sym_splice] = STATE(5866),
    [sym_quasiquote] = STATE(5866),
    [sym_integer] = STATE(5845),
    [sym__plist] = STATE(5864),
    [sym_unit] = STATE(5866),
    [sym_unboxed_unit] = STATE(5866),
    [sym_prefix_tuple] = STATE(5866),
    [sym_prefix_unboxed_tuple] = STATE(5866),
    [sym_prefix_unboxed_sum] = STATE(5866),
    [sym_literal] = STATE(5866),
    [sym__qualified_type] = STATE(5853),
    [sym__qtyconid] = STATE(5869),
    [sym__tycon_arrow] = STATE(5869),
    [sym__qtycon_arrow] = STATE(5869),
    [sym__promoted_tycons_alias] = STATE(5866),
    [sym__promoted_tycons] = STATE(5866),
    [sym__tycon_ticked] = STATE(2527),
    [sym__qtycon_ticked] = STATE(2527),
    [sym__tyconids_ticked] = STATE(2527),
    [sym__promoted_tyconops_alias] = STATE(2527),
    [sym__promoted_tyconops] = STATE(2527),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2527),
    [sym__operator_alias] = STATE(2527),
    [sym__operator_minus] = STATE(2527),
    [sym__varsym_prefix] = STATE(5869),
    [sym__pvarsym] = STATE(5869),
    [sym__qualified_varsym] = STATE(2521),
    [sym__qvarsym_prefix] = STATE(5869),
    [sym__pqvarsym] = STATE(5869),
    [sym_constructor_operator] = STATE(2527),
    [sym__constructor_operator_alias] = STATE(2527),
    [sym__consym_prefix] = STATE(5869),
    [sym__pconsym] = STATE(5869),
    [sym__qualified_consym] = STATE(2520),
    [sym__qconsym_prefix] = STATE(5869),
    [sym__pqconsym] = STATE(5869),
    [sym__prefix_at] = STATE(2608),
    [sym__paren_open] = STATE(454),
    [sym__bracket_open] = STATE(1050),
    [sym__unboxed_open] = STATE(749),
    [sym_variable] = ACTIONS(1847),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1849),
    [anon_sym_SQUOTE] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1853),
    [anon_sym_u2605] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1857),
    [sym_char] = ACTIONS(1857),
    [sym_string] = ACTIONS(1857),
    [sym__integer_literal] = ACTIONS(1859),
    [sym__binary_literal] = ACTIONS(1861),
    [sym__octal_literal] = ACTIONS(1861),
    [sym__hex_literal] = ACTIONS(1861),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1863),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_where] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1865),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1181),
    [sym__cond_prefix_bang] = ACTIONS(1181),
    [sym__cond_tight_tilde] = ACTIONS(1181),
    [sym__cond_prefix_tilde] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [649] = {
    [sym__type_parens] = STATE(5871),
    [sym__type_tuple] = STATE(5812),
    [sym__type_unboxed_tuple] = STATE(5874),
    [sym__type_unboxed_sum] = STATE(5875),
    [sym__type_list] = STATE(5859),
    [sym__type_promoted] = STATE(5866),
    [sym__type_star] = STATE(5866),
    [sym__type_wildcard] = STATE(5866),
    [sym__at_type] = STATE(5854),
    [sym__type_apply] = STATE(5860),
    [sym__type_infix] = STATE(5862),
    [sym_type] = STATE(652),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8450),
    [sym__splice_dollars] = STATE(7272),
    [sym_splice] = STATE(5866),
    [sym_quasiquote] = STATE(5866),
    [sym_integer] = STATE(5845),
    [sym__plist] = STATE(5864),
    [sym_unit] = STATE(5866),
    [sym_unboxed_unit] = STATE(5866),
    [sym_prefix_tuple] = STATE(5866),
    [sym_prefix_unboxed_tuple] = STATE(5866),
    [sym_prefix_unboxed_sum] = STATE(5866),
    [sym_literal] = STATE(5866),
    [sym__qualified_type] = STATE(5853),
    [sym__qtyconid] = STATE(5869),
    [sym__tycon_arrow] = STATE(5869),
    [sym__qtycon_arrow] = STATE(5869),
    [sym__promoted_tycons_alias] = STATE(5866),
    [sym__promoted_tycons] = STATE(5866),
    [sym__tycon_ticked] = STATE(2527),
    [sym__qtycon_ticked] = STATE(2527),
    [sym__tyconids_ticked] = STATE(2527),
    [sym__promoted_tyconops_alias] = STATE(2527),
    [sym__promoted_tyconops] = STATE(2527),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2527),
    [sym__operator_alias] = STATE(2527),
    [sym__operator_minus] = STATE(2527),
    [sym__varsym_prefix] = STATE(5869),
    [sym__pvarsym] = STATE(5869),
    [sym__qualified_varsym] = STATE(2521),
    [sym__qvarsym_prefix] = STATE(5869),
    [sym__pqvarsym] = STATE(5869),
    [sym_constructor_operator] = STATE(2527),
    [sym__constructor_operator_alias] = STATE(2527),
    [sym__consym_prefix] = STATE(5869),
    [sym__pconsym] = STATE(5869),
    [sym__qualified_consym] = STATE(2520),
    [sym__qconsym_prefix] = STATE(5869),
    [sym__pqconsym] = STATE(5869),
    [sym__prefix_at] = STATE(2608),
    [sym__paren_open] = STATE(454),
    [sym__bracket_open] = STATE(1050),
    [sym__unboxed_open] = STATE(749),
    [sym_variable] = ACTIONS(1847),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1849),
    [anon_sym_SQUOTE] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1853),
    [anon_sym_u2605] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1857),
    [sym_char] = ACTIONS(1857),
    [sym_string] = ACTIONS(1857),
    [sym__integer_literal] = ACTIONS(1859),
    [sym__binary_literal] = ACTIONS(1861),
    [sym__octal_literal] = ACTIONS(1861),
    [sym__hex_literal] = ACTIONS(1861),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1863),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_where] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1865),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1181),
    [sym__cond_prefix_bang] = ACTIONS(1181),
    [sym__cond_tight_tilde] = ACTIONS(1181),
    [sym__cond_prefix_tilde] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [650] = {
    [sym__type_parens] = STATE(5871),
    [sym__type_tuple] = STATE(5812),
    [sym__type_unboxed_tuple] = STATE(5874),
    [sym__type_unboxed_sum] = STATE(5875),
    [sym__type_list] = STATE(5859),
    [sym__type_promoted] = STATE(5866),
    [sym__type_star] = STATE(5866),
    [sym__type_wildcard] = STATE(5866),
    [sym__at_type] = STATE(5854),
    [sym__type_apply] = STATE(5860),
    [sym__type_infix] = STATE(5862),
    [sym_type] = STATE(652),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8450),
    [sym__splice_dollars] = STATE(7272),
    [sym_splice] = STATE(5866),
    [sym_quasiquote] = STATE(5866),
    [sym_integer] = STATE(5845),
    [sym__plist] = STATE(5864),
    [sym_unit] = STATE(5866),
    [sym_unboxed_unit] = STATE(5866),
    [sym_prefix_tuple] = STATE(5866),
    [sym_prefix_unboxed_tuple] = STATE(5866),
    [sym_prefix_unboxed_sum] = STATE(5866),
    [sym_literal] = STATE(5866),
    [sym__qualified_type] = STATE(5853),
    [sym__qtyconid] = STATE(5869),
    [sym__tycon_arrow] = STATE(5869),
    [sym__qtycon_arrow] = STATE(5869),
    [sym__promoted_tycons_alias] = STATE(5866),
    [sym__promoted_tycons] = STATE(5866),
    [sym__tycon_ticked] = STATE(2527),
    [sym__qtycon_ticked] = STATE(2527),
    [sym__tyconids_ticked] = STATE(2527),
    [sym__promoted_tyconops_alias] = STATE(2527),
    [sym__promoted_tyconops] = STATE(2527),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2527),
    [sym__operator_alias] = STATE(2527),
    [sym__operator_minus] = STATE(2527),
    [sym__varsym_prefix] = STATE(5869),
    [sym__pvarsym] = STATE(5869),
    [sym__qualified_varsym] = STATE(2521),
    [sym__qvarsym_prefix] = STATE(5869),
    [sym__pqvarsym] = STATE(5869),
    [sym_constructor_operator] = STATE(2527),
    [sym__constructor_operator_alias] = STATE(2527),
    [sym__consym_prefix] = STATE(5869),
    [sym__pconsym] = STATE(5869),
    [sym__qualified_consym] = STATE(2520),
    [sym__qconsym_prefix] = STATE(5869),
    [sym__pqconsym] = STATE(5869),
    [sym__prefix_at] = STATE(2608),
    [sym__paren_open] = STATE(454),
    [sym__bracket_open] = STATE(1050),
    [sym__unboxed_open] = STATE(749),
    [sym_variable] = ACTIONS(1847),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1849),
    [anon_sym_SQUOTE] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1853),
    [anon_sym_u2605] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1857),
    [sym_char] = ACTIONS(1857),
    [sym_string] = ACTIONS(1857),
    [sym__integer_literal] = ACTIONS(1859),
    [sym__binary_literal] = ACTIONS(1861),
    [sym__octal_literal] = ACTIONS(1861),
    [sym__hex_literal] = ACTIONS(1861),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1863),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1159),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1157),
    [sym__cond_layout_end] = ACTIONS(1157),
    [sym__cond_layout_end_explicit] = ACTIONS(1157),
    [sym__phantom_where] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1865),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1157),
    [sym__cond_prefix_bang] = ACTIONS(1157),
    [sym__cond_tight_tilde] = ACTIONS(1157),
    [sym__cond_prefix_tilde] = ACTIONS(1157),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [651] = {
    [sym__type_parens] = STATE(5871),
    [sym__type_tuple] = STATE(5812),
    [sym__type_unboxed_tuple] = STATE(5874),
    [sym__type_unboxed_sum] = STATE(5875),
    [sym__type_list] = STATE(5859),
    [sym__type_promoted] = STATE(5866),
    [sym__type_star] = STATE(5866),
    [sym__type_wildcard] = STATE(5866),
    [sym__at_type] = STATE(5854),
    [sym__type_apply] = STATE(5860),
    [sym__type_infix] = STATE(5862),
    [sym_type] = STATE(652),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8450),
    [sym__splice_dollars] = STATE(7272),
    [sym_splice] = STATE(5866),
    [sym_quasiquote] = STATE(5866),
    [sym_integer] = STATE(5845),
    [sym__plist] = STATE(5864),
    [sym_unit] = STATE(5866),
    [sym_unboxed_unit] = STATE(5866),
    [sym_prefix_tuple] = STATE(5866),
    [sym_prefix_unboxed_tuple] = STATE(5866),
    [sym_prefix_unboxed_sum] = STATE(5866),
    [sym_literal] = STATE(5866),
    [sym__qualified_type] = STATE(5853),
    [sym__qtyconid] = STATE(5869),
    [sym__tycon_arrow] = STATE(5869),
    [sym__qtycon_arrow] = STATE(5869),
    [sym__promoted_tycons_alias] = STATE(5866),
    [sym__promoted_tycons] = STATE(5866),
    [sym__tycon_ticked] = STATE(2527),
    [sym__qtycon_ticked] = STATE(2527),
    [sym__tyconids_ticked] = STATE(2527),
    [sym__promoted_tyconops_alias] = STATE(2527),
    [sym__promoted_tyconops] = STATE(2527),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2527),
    [sym__operator_alias] = STATE(2527),
    [sym__operator_minus] = STATE(2527),
    [sym__varsym_prefix] = STATE(5869),
    [sym__pvarsym] = STATE(5869),
    [sym__qualified_varsym] = STATE(2521),
    [sym__qvarsym_prefix] = STATE(5869),
    [sym__pqvarsym] = STATE(5869),
    [sym_constructor_operator] = STATE(2527),
    [sym__constructor_operator_alias] = STATE(2527),
    [sym__consym_prefix] = STATE(5869),
    [sym__pconsym] = STATE(5869),
    [sym__qualified_consym] = STATE(2520),
    [sym__qconsym_prefix] = STATE(5869),
    [sym__pqconsym] = STATE(5869),
    [sym__prefix_at] = STATE(2608),
    [sym__paren_open] = STATE(454),
    [sym__bracket_open] = STATE(1050),
    [sym__unboxed_open] = STATE(749),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1853),
    [anon_sym_u2605] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(1177),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym__phantom_where] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_tight_bang] = ACTIONS(1179),
    [sym__cond_prefix_bang] = ACTIONS(1179),
    [sym__cond_tight_tilde] = ACTIONS(1179),
    [sym__cond_prefix_tilde] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(1179),
  },
  [652] = {
    [sym__type_parens] = STATE(5871),
    [sym__type_tuple] = STATE(5812),
    [sym__type_unboxed_tuple] = STATE(5874),
    [sym__type_unboxed_sum] = STATE(5875),
    [sym__type_list] = STATE(5859),
    [sym__type_promoted] = STATE(5866),
    [sym__type_star] = STATE(5866),
    [sym__type_wildcard] = STATE(5866),
    [sym__at_type] = STATE(5854),
    [sym__type_apply] = STATE(5860),
    [sym__type_infix] = STATE(5862),
    [sym_type] = STATE(652),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8450),
    [sym__splice_dollars] = STATE(7272),
    [sym_splice] = STATE(5866),
    [sym_quasiquote] = STATE(5866),
    [sym_integer] = STATE(5845),
    [sym__plist] = STATE(5864),
    [sym_unit] = STATE(5866),
    [sym_unboxed_unit] = STATE(5866),
    [sym_prefix_tuple] = STATE(5866),
    [sym_prefix_unboxed_tuple] = STATE(5866),
    [sym_prefix_unboxed_sum] = STATE(5866),
    [sym_literal] = STATE(5866),
    [sym__qualified_type] = STATE(5853),
    [sym__qtyconid] = STATE(5869),
    [sym__tycon_arrow] = STATE(5869),
    [sym__qtycon_arrow] = STATE(5869),
    [sym__promoted_tycons_alias] = STATE(5866),
    [sym__promoted_tycons] = STATE(5866),
    [sym__tycon_ticked] = STATE(2527),
    [sym__qtycon_ticked] = STATE(2527),
    [sym__tyconids_ticked] = STATE(2527),
    [sym__promoted_tyconops_alias] = STATE(2527),
    [sym__promoted_tyconops] = STATE(2527),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2527),
    [sym__operator_alias] = STATE(2527),
    [sym__operator_minus] = STATE(2527),
    [sym__varsym_prefix] = STATE(5869),
    [sym__pvarsym] = STATE(5869),
    [sym__qualified_varsym] = STATE(2521),
    [sym__qvarsym_prefix] = STATE(5869),
    [sym__pqvarsym] = STATE(5869),
    [sym_constructor_operator] = STATE(2527),
    [sym__constructor_operator_alias] = STATE(2527),
    [sym__consym_prefix] = STATE(5869),
    [sym__pconsym] = STATE(5869),
    [sym__qualified_consym] = STATE(2520),
    [sym__qconsym_prefix] = STATE(5869),
    [sym__pqconsym] = STATE(5869),
    [sym__prefix_at] = STATE(2608),
    [sym__paren_open] = STATE(454),
    [sym__bracket_open] = STATE(1050),
    [sym__unboxed_open] = STATE(749),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [anon_sym_where] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1119),
    [sym__cond_layout_end] = ACTIONS(1119),
    [sym__cond_layout_end_explicit] = ACTIONS(1119),
    [sym__phantom_where] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_tight_bang] = ACTIONS(1119),
    [sym__cond_prefix_bang] = ACTIONS(1119),
    [sym__cond_tight_tilde] = ACTIONS(1119),
    [sym__cond_prefix_tilde] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [653] = {
    [sym__type_parens] = STATE(5871),
    [sym__type_tuple] = STATE(5812),
    [sym__type_unboxed_tuple] = STATE(5874),
    [sym__type_unboxed_sum] = STATE(5875),
    [sym__type_list] = STATE(5859),
    [sym__type_promoted] = STATE(5866),
    [sym__type_star] = STATE(5866),
    [sym__type_wildcard] = STATE(5866),
    [sym__at_type] = STATE(5854),
    [sym__type_apply] = STATE(5860),
    [sym__type_infix] = STATE(5862),
    [sym_type] = STATE(652),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8450),
    [sym__splice_dollars] = STATE(7272),
    [sym_splice] = STATE(5866),
    [sym_quasiquote] = STATE(5866),
    [sym_integer] = STATE(5845),
    [sym__plist] = STATE(5864),
    [sym_unit] = STATE(5866),
    [sym_unboxed_unit] = STATE(5866),
    [sym_prefix_tuple] = STATE(5866),
    [sym_prefix_unboxed_tuple] = STATE(5866),
    [sym_prefix_unboxed_sum] = STATE(5866),
    [sym_literal] = STATE(5866),
    [sym__qualified_type] = STATE(5853),
    [sym__qtyconid] = STATE(5869),
    [sym__tycon_arrow] = STATE(5869),
    [sym__qtycon_arrow] = STATE(5869),
    [sym__promoted_tycons_alias] = STATE(5866),
    [sym__promoted_tycons] = STATE(5866),
    [sym__tycon_ticked] = STATE(2527),
    [sym__qtycon_ticked] = STATE(2527),
    [sym__tyconids_ticked] = STATE(2527),
    [sym__promoted_tyconops_alias] = STATE(2527),
    [sym__promoted_tyconops] = STATE(2527),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2527),
    [sym__operator_alias] = STATE(2527),
    [sym__operator_minus] = STATE(2527),
    [sym__varsym_prefix] = STATE(5869),
    [sym__pvarsym] = STATE(5869),
    [sym__qualified_varsym] = STATE(2521),
    [sym__qvarsym_prefix] = STATE(5869),
    [sym__pqvarsym] = STATE(5869),
    [sym_constructor_operator] = STATE(2527),
    [sym__constructor_operator_alias] = STATE(2527),
    [sym__consym_prefix] = STATE(5869),
    [sym__pconsym] = STATE(5869),
    [sym__qualified_consym] = STATE(2520),
    [sym__qconsym_prefix] = STATE(5869),
    [sym__pqconsym] = STATE(5869),
    [sym__prefix_at] = STATE(2608),
    [sym__paren_open] = STATE(454),
    [sym__bracket_open] = STATE(1050),
    [sym__unboxed_open] = STATE(749),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(1177),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym__phantom_where] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_tight_bang] = ACTIONS(1179),
    [sym__cond_prefix_bang] = ACTIONS(1179),
    [sym__cond_tight_tilde] = ACTIONS(1179),
    [sym__cond_prefix_tilde] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [654] = {
    [sym__type_parens] = STATE(5938),
    [sym__type_tuple] = STATE(5929),
    [sym__type_unboxed_tuple] = STATE(5928),
    [sym__type_unboxed_sum] = STATE(5927),
    [sym__type_list] = STATE(5923),
    [sym__type_promoted] = STATE(5958),
    [sym__type_star] = STATE(5958),
    [sym__type_wildcard] = STATE(5958),
    [sym__at_type] = STATE(6001),
    [sym__type_apply] = STATE(5917),
    [sym__type_infix] = STATE(5912),
    [sym_type] = STATE(659),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8429),
    [sym__splice_dollars] = STATE(7467),
    [sym_splice] = STATE(5958),
    [sym_quasiquote] = STATE(5958),
    [sym_integer] = STATE(6013),
    [sym__plist] = STATE(5900),
    [sym_unit] = STATE(5958),
    [sym_unboxed_unit] = STATE(5958),
    [sym_prefix_tuple] = STATE(5958),
    [sym_prefix_unboxed_tuple] = STATE(5958),
    [sym_prefix_unboxed_sum] = STATE(5958),
    [sym_literal] = STATE(5958),
    [sym__qualified_type] = STATE(5983),
    [sym__qtyconid] = STATE(5894),
    [sym__tycon_arrow] = STATE(5894),
    [sym__qtycon_arrow] = STATE(5894),
    [sym__promoted_tycons_alias] = STATE(5958),
    [sym__promoted_tycons] = STATE(5958),
    [sym__tycon_ticked] = STATE(2612),
    [sym__qtycon_ticked] = STATE(2612),
    [sym__tyconids_ticked] = STATE(2612),
    [sym__promoted_tyconops_alias] = STATE(2612),
    [sym__promoted_tyconops] = STATE(2612),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2612),
    [sym__operator_alias] = STATE(2612),
    [sym__operator_minus] = STATE(2612),
    [sym__varsym_prefix] = STATE(5894),
    [sym__pvarsym] = STATE(5894),
    [sym__qualified_varsym] = STATE(2613),
    [sym__qvarsym_prefix] = STATE(5894),
    [sym__pqvarsym] = STATE(5894),
    [sym_constructor_operator] = STATE(2612),
    [sym__constructor_operator_alias] = STATE(2612),
    [sym__consym_prefix] = STATE(5894),
    [sym__pconsym] = STATE(5894),
    [sym__qualified_consym] = STATE(2614),
    [sym__qconsym_prefix] = STATE(5894),
    [sym__pqconsym] = STATE(5894),
    [sym__prefix_at] = STATE(2490),
    [sym__paren_open] = STATE(460),
    [sym__bracket_open] = STATE(1045),
    [sym__unboxed_open] = STATE(826),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_deriving] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1179),
    [anon_sym_u22b8] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(1177),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym__phantom_where] = ACTIONS(1179),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym__phantom_deriving] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_prefix_percent] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [655] = {
    [sym__type_parens] = STATE(5999),
    [sym__type_tuple] = STATE(6002),
    [sym__type_unboxed_tuple] = STATE(6004),
    [sym__type_unboxed_sum] = STATE(6006),
    [sym__type_list] = STATE(6007),
    [sym__type_promoted] = STATE(5993),
    [sym__type_star] = STATE(5993),
    [sym__type_wildcard] = STATE(5993),
    [sym__at_type] = STATE(6030),
    [sym__type_apply] = STATE(6008),
    [sym__type_infix] = STATE(6009),
    [sym_type] = STATE(670),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8515),
    [sym__splice_dollars] = STATE(7346),
    [sym_splice] = STATE(5993),
    [sym_quasiquote] = STATE(5993),
    [sym_integer] = STATE(5925),
    [sym__plist] = STATE(6010),
    [sym_unit] = STATE(5993),
    [sym_unboxed_unit] = STATE(5993),
    [sym_prefix_tuple] = STATE(5993),
    [sym_prefix_unboxed_tuple] = STATE(5993),
    [sym_prefix_unboxed_sum] = STATE(5993),
    [sym_literal] = STATE(5993),
    [sym__qualified_type] = STATE(5906),
    [sym__qtyconid] = STATE(6014),
    [sym__tycon_arrow] = STATE(6014),
    [sym__qtycon_arrow] = STATE(6014),
    [sym__promoted_tycons_alias] = STATE(5993),
    [sym__promoted_tycons] = STATE(5993),
    [sym__tycon_ticked] = STATE(2672),
    [sym__qtycon_ticked] = STATE(2672),
    [sym__tyconids_ticked] = STATE(2672),
    [sym__promoted_tyconops_alias] = STATE(2672),
    [sym__promoted_tyconops] = STATE(2672),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2672),
    [sym__operator_alias] = STATE(2672),
    [sym__operator_minus] = STATE(2672),
    [sym__varsym_prefix] = STATE(6014),
    [sym__pvarsym] = STATE(6014),
    [sym__qualified_varsym] = STATE(2673),
    [sym__qvarsym_prefix] = STATE(6014),
    [sym__pqvarsym] = STATE(6014),
    [sym_constructor_operator] = STATE(2672),
    [sym__constructor_operator_alias] = STATE(2672),
    [sym__consym_prefix] = STATE(6014),
    [sym__pconsym] = STATE(6014),
    [sym__qualified_consym] = STATE(2675),
    [sym__qconsym_prefix] = STATE(6014),
    [sym__pqconsym] = STATE(6014),
    [sym__prefix_at] = STATE(2398),
    [sym__paren_open] = STATE(468),
    [sym__bracket_open] = STATE(986),
    [sym__unboxed_open] = STATE(795),
    [sym_variable] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1871),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_u2605] = ACTIONS(1875),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1877),
    [sym_char] = ACTIONS(1877),
    [sym_string] = ACTIONS(1877),
    [sym__integer_literal] = ACTIONS(1879),
    [sym__binary_literal] = ACTIONS(1881),
    [sym__octal_literal] = ACTIONS(1881),
    [sym__hex_literal] = ACTIONS(1881),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1883),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1157),
    [anon_sym_u22b8] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1159),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1157),
    [sym__cond_layout_end] = ACTIONS(1157),
    [sym__cond_layout_end_explicit] = ACTIONS(1157),
    [sym__phantom_where] = ACTIONS(1157),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym__phantom_bar] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1885),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [656] = {
    [sym__type_parens] = STATE(5999),
    [sym__type_tuple] = STATE(6002),
    [sym__type_unboxed_tuple] = STATE(6004),
    [sym__type_unboxed_sum] = STATE(6006),
    [sym__type_list] = STATE(6007),
    [sym__type_promoted] = STATE(5993),
    [sym__type_star] = STATE(5993),
    [sym__type_wildcard] = STATE(5993),
    [sym__at_type] = STATE(6030),
    [sym__type_apply] = STATE(6008),
    [sym__type_infix] = STATE(6009),
    [sym_type] = STATE(670),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8515),
    [sym__splice_dollars] = STATE(7346),
    [sym_splice] = STATE(5993),
    [sym_quasiquote] = STATE(5993),
    [sym_integer] = STATE(5925),
    [sym__plist] = STATE(6010),
    [sym_unit] = STATE(5993),
    [sym_unboxed_unit] = STATE(5993),
    [sym_prefix_tuple] = STATE(5993),
    [sym_prefix_unboxed_tuple] = STATE(5993),
    [sym_prefix_unboxed_sum] = STATE(5993),
    [sym_literal] = STATE(5993),
    [sym__qualified_type] = STATE(5906),
    [sym__qtyconid] = STATE(6014),
    [sym__tycon_arrow] = STATE(6014),
    [sym__qtycon_arrow] = STATE(6014),
    [sym__promoted_tycons_alias] = STATE(5993),
    [sym__promoted_tycons] = STATE(5993),
    [sym__tycon_ticked] = STATE(2672),
    [sym__qtycon_ticked] = STATE(2672),
    [sym__tyconids_ticked] = STATE(2672),
    [sym__promoted_tyconops_alias] = STATE(2672),
    [sym__promoted_tyconops] = STATE(2672),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2672),
    [sym__operator_alias] = STATE(2672),
    [sym__operator_minus] = STATE(2672),
    [sym__varsym_prefix] = STATE(6014),
    [sym__pvarsym] = STATE(6014),
    [sym__qualified_varsym] = STATE(2673),
    [sym__qvarsym_prefix] = STATE(6014),
    [sym__pqvarsym] = STATE(6014),
    [sym_constructor_operator] = STATE(2672),
    [sym__constructor_operator_alias] = STATE(2672),
    [sym__consym_prefix] = STATE(6014),
    [sym__pconsym] = STATE(6014),
    [sym__qualified_consym] = STATE(2675),
    [sym__qconsym_prefix] = STATE(6014),
    [sym__pqconsym] = STATE(6014),
    [sym__prefix_at] = STATE(2398),
    [sym__paren_open] = STATE(468),
    [sym__bracket_open] = STATE(986),
    [sym__unboxed_open] = STATE(795),
    [sym_variable] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1871),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_u2605] = ACTIONS(1875),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1877),
    [sym_char] = ACTIONS(1877),
    [sym_string] = ACTIONS(1877),
    [sym__integer_literal] = ACTIONS(1879),
    [sym__binary_literal] = ACTIONS(1881),
    [sym__octal_literal] = ACTIONS(1881),
    [sym__hex_literal] = ACTIONS(1881),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1883),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_where] = ACTIONS(1181),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1885),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [657] = {
    [sym__type_parens] = STATE(5938),
    [sym__type_tuple] = STATE(5929),
    [sym__type_unboxed_tuple] = STATE(5928),
    [sym__type_unboxed_sum] = STATE(5927),
    [sym__type_list] = STATE(5923),
    [sym__type_promoted] = STATE(5958),
    [sym__type_star] = STATE(5958),
    [sym__type_wildcard] = STATE(5958),
    [sym__at_type] = STATE(6001),
    [sym__type_apply] = STATE(5917),
    [sym__type_infix] = STATE(5912),
    [sym_type] = STATE(659),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8429),
    [sym__splice_dollars] = STATE(7467),
    [sym_splice] = STATE(5958),
    [sym_quasiquote] = STATE(5958),
    [sym_integer] = STATE(6013),
    [sym__plist] = STATE(5900),
    [sym_unit] = STATE(5958),
    [sym_unboxed_unit] = STATE(5958),
    [sym_prefix_tuple] = STATE(5958),
    [sym_prefix_unboxed_tuple] = STATE(5958),
    [sym_prefix_unboxed_sum] = STATE(5958),
    [sym_literal] = STATE(5958),
    [sym__qualified_type] = STATE(5983),
    [sym__qtyconid] = STATE(5894),
    [sym__tycon_arrow] = STATE(5894),
    [sym__qtycon_arrow] = STATE(5894),
    [sym__promoted_tycons_alias] = STATE(5958),
    [sym__promoted_tycons] = STATE(5958),
    [sym__tycon_ticked] = STATE(2612),
    [sym__qtycon_ticked] = STATE(2612),
    [sym__tyconids_ticked] = STATE(2612),
    [sym__promoted_tyconops_alias] = STATE(2612),
    [sym__promoted_tyconops] = STATE(2612),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2612),
    [sym__operator_alias] = STATE(2612),
    [sym__operator_minus] = STATE(2612),
    [sym__varsym_prefix] = STATE(5894),
    [sym__pvarsym] = STATE(5894),
    [sym__qualified_varsym] = STATE(2613),
    [sym__qvarsym_prefix] = STATE(5894),
    [sym__pqvarsym] = STATE(5894),
    [sym_constructor_operator] = STATE(2612),
    [sym__constructor_operator_alias] = STATE(2612),
    [sym__consym_prefix] = STATE(5894),
    [sym__pconsym] = STATE(5894),
    [sym__qualified_consym] = STATE(2614),
    [sym__qconsym_prefix] = STATE(5894),
    [sym__pqconsym] = STATE(5894),
    [sym__prefix_at] = STATE(2490),
    [sym__paren_open] = STATE(460),
    [sym__bracket_open] = STATE(1045),
    [sym__unboxed_open] = STATE(826),
    [sym_variable] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym__] = ACTIONS(1889),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1893),
    [anon_sym_u2605] = ACTIONS(1895),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_deriving] = ACTIONS(1125),
    [anon_sym_DASH_GT] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1897),
    [sym_char] = ACTIONS(1897),
    [sym_string] = ACTIONS(1897),
    [sym__integer_literal] = ACTIONS(1899),
    [sym__binary_literal] = ACTIONS(1901),
    [sym__octal_literal] = ACTIONS(1901),
    [sym__hex_literal] = ACTIONS(1901),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1903),
    [anon_sym_u2192] = ACTIONS(1123),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1123),
    [anon_sym_u22b8] = ACTIONS(1123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1125),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1123),
    [sym__cond_layout_end] = ACTIONS(1123),
    [sym__cond_layout_end_explicit] = ACTIONS(1123),
    [sym__phantom_where] = ACTIONS(1123),
    [sym__phantom_arrow] = ACTIONS(1123),
    [sym__phantom_deriving] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1905),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1123),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [658] = {
    [sym__type_parens] = STATE(5944),
    [sym__type_tuple] = STATE(5945),
    [sym__type_unboxed_tuple] = STATE(5946),
    [sym__type_unboxed_sum] = STATE(5947),
    [sym__type_list] = STATE(5948),
    [sym__type_promoted] = STATE(5942),
    [sym__type_star] = STATE(5942),
    [sym__type_wildcard] = STATE(5942),
    [sym__at_type] = STATE(5969),
    [sym__type_apply] = STATE(5949),
    [sym__type_infix] = STATE(5950),
    [sym_type] = STATE(658),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8522),
    [sym__splice_dollars] = STATE(7347),
    [sym_splice] = STATE(5942),
    [sym_quasiquote] = STATE(5942),
    [sym_integer] = STATE(5902),
    [sym__plist] = STATE(5951),
    [sym_unit] = STATE(5942),
    [sym_unboxed_unit] = STATE(5942),
    [sym_prefix_tuple] = STATE(5942),
    [sym_prefix_unboxed_tuple] = STATE(5942),
    [sym_prefix_unboxed_sum] = STATE(5942),
    [sym_literal] = STATE(5942),
    [sym__qualified_type] = STATE(5976),
    [sym__qtyconid] = STATE(5952),
    [sym__tycon_arrow] = STATE(5952),
    [sym__qtycon_arrow] = STATE(5952),
    [sym__promoted_tycons_alias] = STATE(5942),
    [sym__promoted_tycons] = STATE(5942),
    [sym__tycon_ticked] = STATE(2634),
    [sym__qtycon_ticked] = STATE(2634),
    [sym__tyconids_ticked] = STATE(2634),
    [sym__promoted_tyconops_alias] = STATE(2634),
    [sym__promoted_tyconops] = STATE(2634),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2634),
    [sym__operator_alias] = STATE(2634),
    [sym__operator_minus] = STATE(2634),
    [sym__varsym_prefix] = STATE(5952),
    [sym__pvarsym] = STATE(5952),
    [sym__qualified_varsym] = STATE(2635),
    [sym__qvarsym_prefix] = STATE(5952),
    [sym__pqvarsym] = STATE(5952),
    [sym_constructor_operator] = STATE(2634),
    [sym__constructor_operator_alias] = STATE(2634),
    [sym__consym_prefix] = STATE(5952),
    [sym__pconsym] = STATE(5952),
    [sym__qualified_consym] = STATE(2636),
    [sym__qconsym_prefix] = STATE(5952),
    [sym__pqconsym] = STATE(5952),
    [sym__prefix_at] = STATE(2463),
    [sym__paren_open] = STATE(475),
    [sym__bracket_open] = STATE(1067),
    [sym__unboxed_open] = STATE(788),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_EQ] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_tight_bang] = ACTIONS(1119),
    [sym__cond_prefix_bang] = ACTIONS(1119),
    [sym__cond_tight_tilde] = ACTIONS(1119),
    [sym__cond_prefix_tilde] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [659] = {
    [sym__type_parens] = STATE(5938),
    [sym__type_tuple] = STATE(5929),
    [sym__type_unboxed_tuple] = STATE(5928),
    [sym__type_unboxed_sum] = STATE(5927),
    [sym__type_list] = STATE(5923),
    [sym__type_promoted] = STATE(5958),
    [sym__type_star] = STATE(5958),
    [sym__type_wildcard] = STATE(5958),
    [sym__at_type] = STATE(6001),
    [sym__type_apply] = STATE(5917),
    [sym__type_infix] = STATE(5912),
    [sym_type] = STATE(659),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8429),
    [sym__splice_dollars] = STATE(7467),
    [sym_splice] = STATE(5958),
    [sym_quasiquote] = STATE(5958),
    [sym_integer] = STATE(6013),
    [sym__plist] = STATE(5900),
    [sym_unit] = STATE(5958),
    [sym_unboxed_unit] = STATE(5958),
    [sym_prefix_tuple] = STATE(5958),
    [sym_prefix_unboxed_tuple] = STATE(5958),
    [sym_prefix_unboxed_sum] = STATE(5958),
    [sym_literal] = STATE(5958),
    [sym__qualified_type] = STATE(5983),
    [sym__qtyconid] = STATE(5894),
    [sym__tycon_arrow] = STATE(5894),
    [sym__qtycon_arrow] = STATE(5894),
    [sym__promoted_tycons_alias] = STATE(5958),
    [sym__promoted_tycons] = STATE(5958),
    [sym__tycon_ticked] = STATE(2612),
    [sym__qtycon_ticked] = STATE(2612),
    [sym__tyconids_ticked] = STATE(2612),
    [sym__promoted_tyconops_alias] = STATE(2612),
    [sym__promoted_tyconops] = STATE(2612),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2612),
    [sym__operator_alias] = STATE(2612),
    [sym__operator_minus] = STATE(2612),
    [sym__varsym_prefix] = STATE(5894),
    [sym__pvarsym] = STATE(5894),
    [sym__qualified_varsym] = STATE(2613),
    [sym__qvarsym_prefix] = STATE(5894),
    [sym__pqvarsym] = STATE(5894),
    [sym_constructor_operator] = STATE(2612),
    [sym__constructor_operator_alias] = STATE(2612),
    [sym__consym_prefix] = STATE(5894),
    [sym__pconsym] = STATE(5894),
    [sym__qualified_consym] = STATE(2614),
    [sym__qconsym_prefix] = STATE(5894),
    [sym__pqconsym] = STATE(5894),
    [sym__prefix_at] = STATE(2490),
    [sym__paren_open] = STATE(460),
    [sym__bracket_open] = STATE(1045),
    [sym__unboxed_open] = STATE(826),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_deriving] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1119),
    [anon_sym_u22b8] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [anon_sym_where] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1119),
    [sym__cond_layout_end] = ACTIONS(1119),
    [sym__cond_layout_end_explicit] = ACTIONS(1119),
    [sym__phantom_where] = ACTIONS(1119),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym__phantom_deriving] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_prefix_percent] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [660] = {
    [sym__type_parens] = STATE(5944),
    [sym__type_tuple] = STATE(5945),
    [sym__type_unboxed_tuple] = STATE(5946),
    [sym__type_unboxed_sum] = STATE(5947),
    [sym__type_list] = STATE(5948),
    [sym__type_promoted] = STATE(5942),
    [sym__type_star] = STATE(5942),
    [sym__type_wildcard] = STATE(5942),
    [sym__at_type] = STATE(5969),
    [sym__type_apply] = STATE(5949),
    [sym__type_infix] = STATE(5950),
    [sym_type] = STATE(658),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8522),
    [sym__splice_dollars] = STATE(7347),
    [sym_splice] = STATE(5942),
    [sym_quasiquote] = STATE(5942),
    [sym_integer] = STATE(5902),
    [sym__plist] = STATE(5951),
    [sym_unit] = STATE(5942),
    [sym_unboxed_unit] = STATE(5942),
    [sym_prefix_tuple] = STATE(5942),
    [sym_prefix_unboxed_tuple] = STATE(5942),
    [sym_prefix_unboxed_sum] = STATE(5942),
    [sym_literal] = STATE(5942),
    [sym__qualified_type] = STATE(5976),
    [sym__qtyconid] = STATE(5952),
    [sym__tycon_arrow] = STATE(5952),
    [sym__qtycon_arrow] = STATE(5952),
    [sym__promoted_tycons_alias] = STATE(5942),
    [sym__promoted_tycons] = STATE(5942),
    [sym__tycon_ticked] = STATE(2634),
    [sym__qtycon_ticked] = STATE(2634),
    [sym__tyconids_ticked] = STATE(2634),
    [sym__promoted_tyconops_alias] = STATE(2634),
    [sym__promoted_tyconops] = STATE(2634),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2634),
    [sym__operator_alias] = STATE(2634),
    [sym__operator_minus] = STATE(2634),
    [sym__varsym_prefix] = STATE(5952),
    [sym__pvarsym] = STATE(5952),
    [sym__qualified_varsym] = STATE(2635),
    [sym__qvarsym_prefix] = STATE(5952),
    [sym__pqvarsym] = STATE(5952),
    [sym_constructor_operator] = STATE(2634),
    [sym__constructor_operator_alias] = STATE(2634),
    [sym__consym_prefix] = STATE(5952),
    [sym__pconsym] = STATE(5952),
    [sym__qualified_consym] = STATE(2636),
    [sym__qconsym_prefix] = STATE(5952),
    [sym__pqconsym] = STATE(5952),
    [sym__prefix_at] = STATE(2463),
    [sym__paren_open] = STATE(475),
    [sym__bracket_open] = STATE(1067),
    [sym__unboxed_open] = STATE(788),
    [sym_variable] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_u2605] = ACTIONS(1915),
    [anon_sym_EQ] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1917),
    [sym_char] = ACTIONS(1917),
    [sym_string] = ACTIONS(1917),
    [sym__integer_literal] = ACTIONS(1919),
    [sym__binary_literal] = ACTIONS(1921),
    [sym__octal_literal] = ACTIONS(1921),
    [sym__hex_literal] = ACTIONS(1921),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1923),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1925),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1181),
    [sym__cond_prefix_bang] = ACTIONS(1181),
    [sym__cond_tight_tilde] = ACTIONS(1181),
    [sym__cond_prefix_tilde] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [661] = {
    [sym__type_parens] = STATE(5938),
    [sym__type_tuple] = STATE(5929),
    [sym__type_unboxed_tuple] = STATE(5928),
    [sym__type_unboxed_sum] = STATE(5927),
    [sym__type_list] = STATE(5923),
    [sym__type_promoted] = STATE(5958),
    [sym__type_star] = STATE(5958),
    [sym__type_wildcard] = STATE(5958),
    [sym__at_type] = STATE(6001),
    [sym__type_apply] = STATE(5917),
    [sym__type_infix] = STATE(5912),
    [sym_type] = STATE(659),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8429),
    [sym__splice_dollars] = STATE(7467),
    [sym_splice] = STATE(5958),
    [sym_quasiquote] = STATE(5958),
    [sym_integer] = STATE(6013),
    [sym__plist] = STATE(5900),
    [sym_unit] = STATE(5958),
    [sym_unboxed_unit] = STATE(5958),
    [sym_prefix_tuple] = STATE(5958),
    [sym_prefix_unboxed_tuple] = STATE(5958),
    [sym_prefix_unboxed_sum] = STATE(5958),
    [sym_literal] = STATE(5958),
    [sym__qualified_type] = STATE(5983),
    [sym__qtyconid] = STATE(5894),
    [sym__tycon_arrow] = STATE(5894),
    [sym__qtycon_arrow] = STATE(5894),
    [sym__promoted_tycons_alias] = STATE(5958),
    [sym__promoted_tycons] = STATE(5958),
    [sym__tycon_ticked] = STATE(2612),
    [sym__qtycon_ticked] = STATE(2612),
    [sym__tyconids_ticked] = STATE(2612),
    [sym__promoted_tyconops_alias] = STATE(2612),
    [sym__promoted_tyconops] = STATE(2612),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2612),
    [sym__operator_alias] = STATE(2612),
    [sym__operator_minus] = STATE(2612),
    [sym__varsym_prefix] = STATE(5894),
    [sym__pvarsym] = STATE(5894),
    [sym__qualified_varsym] = STATE(2613),
    [sym__qvarsym_prefix] = STATE(5894),
    [sym__pqvarsym] = STATE(5894),
    [sym_constructor_operator] = STATE(2612),
    [sym__constructor_operator_alias] = STATE(2612),
    [sym__consym_prefix] = STATE(5894),
    [sym__pconsym] = STATE(5894),
    [sym__qualified_consym] = STATE(2614),
    [sym__qconsym_prefix] = STATE(5894),
    [sym__pqconsym] = STATE(5894),
    [sym__prefix_at] = STATE(2490),
    [sym__paren_open] = STATE(460),
    [sym__bracket_open] = STATE(1045),
    [sym__unboxed_open] = STATE(826),
    [sym_variable] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1889),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1893),
    [anon_sym_u2605] = ACTIONS(1895),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_deriving] = ACTIONS(1183),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1897),
    [sym_char] = ACTIONS(1897),
    [sym_string] = ACTIONS(1897),
    [sym__integer_literal] = ACTIONS(1899),
    [sym__binary_literal] = ACTIONS(1901),
    [sym__octal_literal] = ACTIONS(1901),
    [sym__hex_literal] = ACTIONS(1901),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1903),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_where] = ACTIONS(1181),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym__phantom_deriving] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1905),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [662] = {
    [sym__type_parens] = STATE(5999),
    [sym__type_tuple] = STATE(6002),
    [sym__type_unboxed_tuple] = STATE(6004),
    [sym__type_unboxed_sum] = STATE(6006),
    [sym__type_list] = STATE(6007),
    [sym__type_promoted] = STATE(5993),
    [sym__type_star] = STATE(5993),
    [sym__type_wildcard] = STATE(5993),
    [sym__at_type] = STATE(6030),
    [sym__type_apply] = STATE(6008),
    [sym__type_infix] = STATE(6009),
    [sym_type] = STATE(670),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8515),
    [sym__splice_dollars] = STATE(7346),
    [sym_splice] = STATE(5993),
    [sym_quasiquote] = STATE(5993),
    [sym_integer] = STATE(5925),
    [sym__plist] = STATE(6010),
    [sym_unit] = STATE(5993),
    [sym_unboxed_unit] = STATE(5993),
    [sym_prefix_tuple] = STATE(5993),
    [sym_prefix_unboxed_tuple] = STATE(5993),
    [sym_prefix_unboxed_sum] = STATE(5993),
    [sym_literal] = STATE(5993),
    [sym__qualified_type] = STATE(5906),
    [sym__qtyconid] = STATE(6014),
    [sym__tycon_arrow] = STATE(6014),
    [sym__qtycon_arrow] = STATE(6014),
    [sym__promoted_tycons_alias] = STATE(5993),
    [sym__promoted_tycons] = STATE(5993),
    [sym__tycon_ticked] = STATE(2672),
    [sym__qtycon_ticked] = STATE(2672),
    [sym__tyconids_ticked] = STATE(2672),
    [sym__promoted_tyconops_alias] = STATE(2672),
    [sym__promoted_tyconops] = STATE(2672),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2672),
    [sym__operator_alias] = STATE(2672),
    [sym__operator_minus] = STATE(2672),
    [sym__varsym_prefix] = STATE(6014),
    [sym__pvarsym] = STATE(6014),
    [sym__qualified_varsym] = STATE(2673),
    [sym__qvarsym_prefix] = STATE(6014),
    [sym__pqvarsym] = STATE(6014),
    [sym_constructor_operator] = STATE(2672),
    [sym__constructor_operator_alias] = STATE(2672),
    [sym__consym_prefix] = STATE(6014),
    [sym__pconsym] = STATE(6014),
    [sym__qualified_consym] = STATE(2675),
    [sym__qconsym_prefix] = STATE(6014),
    [sym__pqconsym] = STATE(6014),
    [sym__prefix_at] = STATE(2398),
    [sym__paren_open] = STATE(468),
    [sym__bracket_open] = STATE(986),
    [sym__unboxed_open] = STATE(795),
    [sym_variable] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1871),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_u2605] = ACTIONS(1875),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1877),
    [sym_char] = ACTIONS(1877),
    [sym_string] = ACTIONS(1877),
    [sym__integer_literal] = ACTIONS(1879),
    [sym__binary_literal] = ACTIONS(1881),
    [sym__octal_literal] = ACTIONS(1881),
    [sym__hex_literal] = ACTIONS(1881),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1883),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_where] = ACTIONS(1181),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1885),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [663] = {
    [sym__type_parens] = STATE(5944),
    [sym__type_tuple] = STATE(5945),
    [sym__type_unboxed_tuple] = STATE(5946),
    [sym__type_unboxed_sum] = STATE(5947),
    [sym__type_list] = STATE(5948),
    [sym__type_promoted] = STATE(5942),
    [sym__type_star] = STATE(5942),
    [sym__type_wildcard] = STATE(5942),
    [sym__at_type] = STATE(5969),
    [sym__type_apply] = STATE(5949),
    [sym__type_infix] = STATE(5950),
    [sym_type] = STATE(658),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8522),
    [sym__splice_dollars] = STATE(7347),
    [sym_splice] = STATE(5942),
    [sym_quasiquote] = STATE(5942),
    [sym_integer] = STATE(5902),
    [sym__plist] = STATE(5951),
    [sym_unit] = STATE(5942),
    [sym_unboxed_unit] = STATE(5942),
    [sym_prefix_tuple] = STATE(5942),
    [sym_prefix_unboxed_tuple] = STATE(5942),
    [sym_prefix_unboxed_sum] = STATE(5942),
    [sym_literal] = STATE(5942),
    [sym__qualified_type] = STATE(5976),
    [sym__qtyconid] = STATE(5952),
    [sym__tycon_arrow] = STATE(5952),
    [sym__qtycon_arrow] = STATE(5952),
    [sym__promoted_tycons_alias] = STATE(5942),
    [sym__promoted_tycons] = STATE(5942),
    [sym__tycon_ticked] = STATE(2634),
    [sym__qtycon_ticked] = STATE(2634),
    [sym__tyconids_ticked] = STATE(2634),
    [sym__promoted_tyconops_alias] = STATE(2634),
    [sym__promoted_tyconops] = STATE(2634),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2634),
    [sym__operator_alias] = STATE(2634),
    [sym__operator_minus] = STATE(2634),
    [sym__varsym_prefix] = STATE(5952),
    [sym__pvarsym] = STATE(5952),
    [sym__qualified_varsym] = STATE(2635),
    [sym__qvarsym_prefix] = STATE(5952),
    [sym__pqvarsym] = STATE(5952),
    [sym_constructor_operator] = STATE(2634),
    [sym__constructor_operator_alias] = STATE(2634),
    [sym__consym_prefix] = STATE(5952),
    [sym__pconsym] = STATE(5952),
    [sym__qualified_consym] = STATE(2636),
    [sym__qconsym_prefix] = STATE(5952),
    [sym__pqconsym] = STATE(5952),
    [sym__prefix_at] = STATE(2463),
    [sym__paren_open] = STATE(475),
    [sym__bracket_open] = STATE(1067),
    [sym__unboxed_open] = STATE(788),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_tight_bang] = ACTIONS(1179),
    [sym__cond_prefix_bang] = ACTIONS(1179),
    [sym__cond_tight_tilde] = ACTIONS(1179),
    [sym__cond_prefix_tilde] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [664] = {
    [sym__type_parens] = STATE(5999),
    [sym__type_tuple] = STATE(6002),
    [sym__type_unboxed_tuple] = STATE(6004),
    [sym__type_unboxed_sum] = STATE(6006),
    [sym__type_list] = STATE(6007),
    [sym__type_promoted] = STATE(5993),
    [sym__type_star] = STATE(5993),
    [sym__type_wildcard] = STATE(5993),
    [sym__at_type] = STATE(6030),
    [sym__type_apply] = STATE(6008),
    [sym__type_infix] = STATE(6009),
    [sym_type] = STATE(670),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8515),
    [sym__splice_dollars] = STATE(7346),
    [sym_splice] = STATE(5993),
    [sym_quasiquote] = STATE(5993),
    [sym_integer] = STATE(5925),
    [sym__plist] = STATE(6010),
    [sym_unit] = STATE(5993),
    [sym_unboxed_unit] = STATE(5993),
    [sym_prefix_tuple] = STATE(5993),
    [sym_prefix_unboxed_tuple] = STATE(5993),
    [sym_prefix_unboxed_sum] = STATE(5993),
    [sym_literal] = STATE(5993),
    [sym__qualified_type] = STATE(5906),
    [sym__qtyconid] = STATE(6014),
    [sym__tycon_arrow] = STATE(6014),
    [sym__qtycon_arrow] = STATE(6014),
    [sym__promoted_tycons_alias] = STATE(5993),
    [sym__promoted_tycons] = STATE(5993),
    [sym__tycon_ticked] = STATE(2672),
    [sym__qtycon_ticked] = STATE(2672),
    [sym__tyconids_ticked] = STATE(2672),
    [sym__promoted_tyconops_alias] = STATE(2672),
    [sym__promoted_tyconops] = STATE(2672),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2672),
    [sym__operator_alias] = STATE(2672),
    [sym__operator_minus] = STATE(2672),
    [sym__varsym_prefix] = STATE(6014),
    [sym__pvarsym] = STATE(6014),
    [sym__qualified_varsym] = STATE(2673),
    [sym__qvarsym_prefix] = STATE(6014),
    [sym__pqvarsym] = STATE(6014),
    [sym_constructor_operator] = STATE(2672),
    [sym__constructor_operator_alias] = STATE(2672),
    [sym__consym_prefix] = STATE(6014),
    [sym__pconsym] = STATE(6014),
    [sym__qualified_consym] = STATE(2675),
    [sym__qconsym_prefix] = STATE(6014),
    [sym__pqconsym] = STATE(6014),
    [sym__prefix_at] = STATE(2398),
    [sym__paren_open] = STATE(468),
    [sym__bracket_open] = STATE(986),
    [sym__unboxed_open] = STATE(795),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1179),
    [anon_sym_u22b8] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(1177),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym__phantom_where] = ACTIONS(1179),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym__phantom_bar] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_prefix_percent] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [665] = {
    [sym__type_parens] = STATE(5944),
    [sym__type_tuple] = STATE(5945),
    [sym__type_unboxed_tuple] = STATE(5946),
    [sym__type_unboxed_sum] = STATE(5947),
    [sym__type_list] = STATE(5948),
    [sym__type_promoted] = STATE(5942),
    [sym__type_star] = STATE(5942),
    [sym__type_wildcard] = STATE(5942),
    [sym__at_type] = STATE(5969),
    [sym__type_apply] = STATE(5949),
    [sym__type_infix] = STATE(5950),
    [sym_type] = STATE(658),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8522),
    [sym__splice_dollars] = STATE(7347),
    [sym_splice] = STATE(5942),
    [sym_quasiquote] = STATE(5942),
    [sym_integer] = STATE(5902),
    [sym__plist] = STATE(5951),
    [sym_unit] = STATE(5942),
    [sym_unboxed_unit] = STATE(5942),
    [sym_prefix_tuple] = STATE(5942),
    [sym_prefix_unboxed_tuple] = STATE(5942),
    [sym_prefix_unboxed_sum] = STATE(5942),
    [sym_literal] = STATE(5942),
    [sym__qualified_type] = STATE(5976),
    [sym__qtyconid] = STATE(5952),
    [sym__tycon_arrow] = STATE(5952),
    [sym__qtycon_arrow] = STATE(5952),
    [sym__promoted_tycons_alias] = STATE(5942),
    [sym__promoted_tycons] = STATE(5942),
    [sym__tycon_ticked] = STATE(2634),
    [sym__qtycon_ticked] = STATE(2634),
    [sym__tyconids_ticked] = STATE(2634),
    [sym__promoted_tyconops_alias] = STATE(2634),
    [sym__promoted_tyconops] = STATE(2634),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2634),
    [sym__operator_alias] = STATE(2634),
    [sym__operator_minus] = STATE(2634),
    [sym__varsym_prefix] = STATE(5952),
    [sym__pvarsym] = STATE(5952),
    [sym__qualified_varsym] = STATE(2635),
    [sym__qvarsym_prefix] = STATE(5952),
    [sym__pqvarsym] = STATE(5952),
    [sym_constructor_operator] = STATE(2634),
    [sym__constructor_operator_alias] = STATE(2634),
    [sym__consym_prefix] = STATE(5952),
    [sym__pconsym] = STATE(5952),
    [sym__qualified_consym] = STATE(2636),
    [sym__qconsym_prefix] = STATE(5952),
    [sym__pqconsym] = STATE(5952),
    [sym__prefix_at] = STATE(2463),
    [sym__paren_open] = STATE(475),
    [sym__bracket_open] = STATE(1067),
    [sym__unboxed_open] = STATE(788),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_u2605] = ACTIONS(1915),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_tight_bang] = ACTIONS(1179),
    [sym__cond_prefix_bang] = ACTIONS(1179),
    [sym__cond_tight_tilde] = ACTIONS(1179),
    [sym__cond_prefix_tilde] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(1179),
  },
  [666] = {
    [sym__type_parens] = STATE(5999),
    [sym__type_tuple] = STATE(6002),
    [sym__type_unboxed_tuple] = STATE(6004),
    [sym__type_unboxed_sum] = STATE(6006),
    [sym__type_list] = STATE(6007),
    [sym__type_promoted] = STATE(5993),
    [sym__type_star] = STATE(5993),
    [sym__type_wildcard] = STATE(5993),
    [sym__at_type] = STATE(6030),
    [sym__type_apply] = STATE(6008),
    [sym__type_infix] = STATE(6009),
    [sym_type] = STATE(670),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8515),
    [sym__splice_dollars] = STATE(7346),
    [sym_splice] = STATE(5993),
    [sym_quasiquote] = STATE(5993),
    [sym_integer] = STATE(5925),
    [sym__plist] = STATE(6010),
    [sym_unit] = STATE(5993),
    [sym_unboxed_unit] = STATE(5993),
    [sym_prefix_tuple] = STATE(5993),
    [sym_prefix_unboxed_tuple] = STATE(5993),
    [sym_prefix_unboxed_sum] = STATE(5993),
    [sym_literal] = STATE(5993),
    [sym__qualified_type] = STATE(5906),
    [sym__qtyconid] = STATE(6014),
    [sym__tycon_arrow] = STATE(6014),
    [sym__qtycon_arrow] = STATE(6014),
    [sym__promoted_tycons_alias] = STATE(5993),
    [sym__promoted_tycons] = STATE(5993),
    [sym__tycon_ticked] = STATE(2672),
    [sym__qtycon_ticked] = STATE(2672),
    [sym__tyconids_ticked] = STATE(2672),
    [sym__promoted_tyconops_alias] = STATE(2672),
    [sym__promoted_tyconops] = STATE(2672),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2672),
    [sym__operator_alias] = STATE(2672),
    [sym__operator_minus] = STATE(2672),
    [sym__varsym_prefix] = STATE(6014),
    [sym__pvarsym] = STATE(6014),
    [sym__qualified_varsym] = STATE(2673),
    [sym__qvarsym_prefix] = STATE(6014),
    [sym__pqvarsym] = STATE(6014),
    [sym_constructor_operator] = STATE(2672),
    [sym__constructor_operator_alias] = STATE(2672),
    [sym__consym_prefix] = STATE(6014),
    [sym__pconsym] = STATE(6014),
    [sym__qualified_consym] = STATE(2675),
    [sym__qconsym_prefix] = STATE(6014),
    [sym__pqconsym] = STATE(6014),
    [sym__prefix_at] = STATE(2398),
    [sym__paren_open] = STATE(468),
    [sym__bracket_open] = STATE(986),
    [sym__unboxed_open] = STATE(795),
    [sym_variable] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym__] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1871),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_u2605] = ACTIONS(1875),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1877),
    [sym_char] = ACTIONS(1877),
    [sym_string] = ACTIONS(1877),
    [sym__integer_literal] = ACTIONS(1879),
    [sym__binary_literal] = ACTIONS(1881),
    [sym__octal_literal] = ACTIONS(1881),
    [sym__hex_literal] = ACTIONS(1881),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1883),
    [anon_sym_u2192] = ACTIONS(1123),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1123),
    [anon_sym_u22b8] = ACTIONS(1123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1125),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1123),
    [sym__cond_layout_end] = ACTIONS(1123),
    [sym__cond_layout_end_explicit] = ACTIONS(1123),
    [sym__phantom_where] = ACTIONS(1123),
    [sym__phantom_arrow] = ACTIONS(1123),
    [sym__phantom_bar] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1885),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1123),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [667] = {
    [sym__type_parens] = STATE(5938),
    [sym__type_tuple] = STATE(5929),
    [sym__type_unboxed_tuple] = STATE(5928),
    [sym__type_unboxed_sum] = STATE(5927),
    [sym__type_list] = STATE(5923),
    [sym__type_promoted] = STATE(5958),
    [sym__type_star] = STATE(5958),
    [sym__type_wildcard] = STATE(5958),
    [sym__at_type] = STATE(6001),
    [sym__type_apply] = STATE(5917),
    [sym__type_infix] = STATE(5912),
    [sym_type] = STATE(659),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8429),
    [sym__splice_dollars] = STATE(7467),
    [sym_splice] = STATE(5958),
    [sym_quasiquote] = STATE(5958),
    [sym_integer] = STATE(6013),
    [sym__plist] = STATE(5900),
    [sym_unit] = STATE(5958),
    [sym_unboxed_unit] = STATE(5958),
    [sym_prefix_tuple] = STATE(5958),
    [sym_prefix_unboxed_tuple] = STATE(5958),
    [sym_prefix_unboxed_sum] = STATE(5958),
    [sym_literal] = STATE(5958),
    [sym__qualified_type] = STATE(5983),
    [sym__qtyconid] = STATE(5894),
    [sym__tycon_arrow] = STATE(5894),
    [sym__qtycon_arrow] = STATE(5894),
    [sym__promoted_tycons_alias] = STATE(5958),
    [sym__promoted_tycons] = STATE(5958),
    [sym__tycon_ticked] = STATE(2612),
    [sym__qtycon_ticked] = STATE(2612),
    [sym__tyconids_ticked] = STATE(2612),
    [sym__promoted_tyconops_alias] = STATE(2612),
    [sym__promoted_tyconops] = STATE(2612),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2612),
    [sym__operator_alias] = STATE(2612),
    [sym__operator_minus] = STATE(2612),
    [sym__varsym_prefix] = STATE(5894),
    [sym__pvarsym] = STATE(5894),
    [sym__qualified_varsym] = STATE(2613),
    [sym__qvarsym_prefix] = STATE(5894),
    [sym__pqvarsym] = STATE(5894),
    [sym_constructor_operator] = STATE(2612),
    [sym__constructor_operator_alias] = STATE(2612),
    [sym__consym_prefix] = STATE(5894),
    [sym__pconsym] = STATE(5894),
    [sym__qualified_consym] = STATE(2614),
    [sym__qconsym_prefix] = STATE(5894),
    [sym__pqconsym] = STATE(5894),
    [sym__prefix_at] = STATE(2490),
    [sym__paren_open] = STATE(460),
    [sym__bracket_open] = STATE(1045),
    [sym__unboxed_open] = STATE(826),
    [sym_variable] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1889),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1893),
    [anon_sym_u2605] = ACTIONS(1895),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_deriving] = ACTIONS(1183),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1897),
    [sym_char] = ACTIONS(1897),
    [sym_string] = ACTIONS(1897),
    [sym__integer_literal] = ACTIONS(1899),
    [sym__binary_literal] = ACTIONS(1901),
    [sym__octal_literal] = ACTIONS(1901),
    [sym__hex_literal] = ACTIONS(1901),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1903),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_where] = ACTIONS(1181),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym__phantom_deriving] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1905),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [668] = {
    [sym__type_parens] = STATE(5938),
    [sym__type_tuple] = STATE(5929),
    [sym__type_unboxed_tuple] = STATE(5928),
    [sym__type_unboxed_sum] = STATE(5927),
    [sym__type_list] = STATE(5923),
    [sym__type_promoted] = STATE(5958),
    [sym__type_star] = STATE(5958),
    [sym__type_wildcard] = STATE(5958),
    [sym__at_type] = STATE(6001),
    [sym__type_apply] = STATE(5917),
    [sym__type_infix] = STATE(5912),
    [sym_type] = STATE(659),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8429),
    [sym__splice_dollars] = STATE(7467),
    [sym_splice] = STATE(5958),
    [sym_quasiquote] = STATE(5958),
    [sym_integer] = STATE(6013),
    [sym__plist] = STATE(5900),
    [sym_unit] = STATE(5958),
    [sym_unboxed_unit] = STATE(5958),
    [sym_prefix_tuple] = STATE(5958),
    [sym_prefix_unboxed_tuple] = STATE(5958),
    [sym_prefix_unboxed_sum] = STATE(5958),
    [sym_literal] = STATE(5958),
    [sym__qualified_type] = STATE(5983),
    [sym__qtyconid] = STATE(5894),
    [sym__tycon_arrow] = STATE(5894),
    [sym__qtycon_arrow] = STATE(5894),
    [sym__promoted_tycons_alias] = STATE(5958),
    [sym__promoted_tycons] = STATE(5958),
    [sym__tycon_ticked] = STATE(2612),
    [sym__qtycon_ticked] = STATE(2612),
    [sym__tyconids_ticked] = STATE(2612),
    [sym__promoted_tyconops_alias] = STATE(2612),
    [sym__promoted_tyconops] = STATE(2612),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2612),
    [sym__operator_alias] = STATE(2612),
    [sym__operator_minus] = STATE(2612),
    [sym__varsym_prefix] = STATE(5894),
    [sym__pvarsym] = STATE(5894),
    [sym__qualified_varsym] = STATE(2613),
    [sym__qvarsym_prefix] = STATE(5894),
    [sym__pqvarsym] = STATE(5894),
    [sym_constructor_operator] = STATE(2612),
    [sym__constructor_operator_alias] = STATE(2612),
    [sym__consym_prefix] = STATE(5894),
    [sym__pconsym] = STATE(5894),
    [sym__qualified_consym] = STATE(2614),
    [sym__qconsym_prefix] = STATE(5894),
    [sym__pqconsym] = STATE(5894),
    [sym__prefix_at] = STATE(2490),
    [sym__paren_open] = STATE(460),
    [sym__bracket_open] = STATE(1045),
    [sym__unboxed_open] = STATE(826),
    [sym_variable] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1889),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1893),
    [anon_sym_u2605] = ACTIONS(1895),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_deriving] = ACTIONS(1159),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1897),
    [sym_char] = ACTIONS(1897),
    [sym_string] = ACTIONS(1897),
    [sym__integer_literal] = ACTIONS(1899),
    [sym__binary_literal] = ACTIONS(1901),
    [sym__octal_literal] = ACTIONS(1901),
    [sym__hex_literal] = ACTIONS(1901),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1903),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1157),
    [anon_sym_u22b8] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1159),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1157),
    [sym__cond_layout_end] = ACTIONS(1157),
    [sym__cond_layout_end_explicit] = ACTIONS(1157),
    [sym__phantom_where] = ACTIONS(1157),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym__phantom_deriving] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1905),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [669] = {
    [sym__type_parens] = STATE(5944),
    [sym__type_tuple] = STATE(5945),
    [sym__type_unboxed_tuple] = STATE(5946),
    [sym__type_unboxed_sum] = STATE(5947),
    [sym__type_list] = STATE(5948),
    [sym__type_promoted] = STATE(5942),
    [sym__type_star] = STATE(5942),
    [sym__type_wildcard] = STATE(5942),
    [sym__at_type] = STATE(5969),
    [sym__type_apply] = STATE(5949),
    [sym__type_infix] = STATE(5950),
    [sym_type] = STATE(658),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8522),
    [sym__splice_dollars] = STATE(7347),
    [sym_splice] = STATE(5942),
    [sym_quasiquote] = STATE(5942),
    [sym_integer] = STATE(5902),
    [sym__plist] = STATE(5951),
    [sym_unit] = STATE(5942),
    [sym_unboxed_unit] = STATE(5942),
    [sym_prefix_tuple] = STATE(5942),
    [sym_prefix_unboxed_tuple] = STATE(5942),
    [sym_prefix_unboxed_sum] = STATE(5942),
    [sym_literal] = STATE(5942),
    [sym__qualified_type] = STATE(5976),
    [sym__qtyconid] = STATE(5952),
    [sym__tycon_arrow] = STATE(5952),
    [sym__qtycon_arrow] = STATE(5952),
    [sym__promoted_tycons_alias] = STATE(5942),
    [sym__promoted_tycons] = STATE(5942),
    [sym__tycon_ticked] = STATE(2634),
    [sym__qtycon_ticked] = STATE(2634),
    [sym__tyconids_ticked] = STATE(2634),
    [sym__promoted_tyconops_alias] = STATE(2634),
    [sym__promoted_tyconops] = STATE(2634),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2634),
    [sym__operator_alias] = STATE(2634),
    [sym__operator_minus] = STATE(2634),
    [sym__varsym_prefix] = STATE(5952),
    [sym__pvarsym] = STATE(5952),
    [sym__qualified_varsym] = STATE(2635),
    [sym__qvarsym_prefix] = STATE(5952),
    [sym__pqvarsym] = STATE(5952),
    [sym_constructor_operator] = STATE(2634),
    [sym__constructor_operator_alias] = STATE(2634),
    [sym__consym_prefix] = STATE(5952),
    [sym__pconsym] = STATE(5952),
    [sym__qualified_consym] = STATE(2636),
    [sym__qconsym_prefix] = STATE(5952),
    [sym__pqconsym] = STATE(5952),
    [sym__prefix_at] = STATE(2463),
    [sym__paren_open] = STATE(475),
    [sym__bracket_open] = STATE(1067),
    [sym__unboxed_open] = STATE(788),
    [sym_variable] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_u2605] = ACTIONS(1915),
    [anon_sym_EQ] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1917),
    [sym_char] = ACTIONS(1917),
    [sym_string] = ACTIONS(1917),
    [sym__integer_literal] = ACTIONS(1919),
    [sym__binary_literal] = ACTIONS(1921),
    [sym__octal_literal] = ACTIONS(1921),
    [sym__hex_literal] = ACTIONS(1921),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1923),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1925),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1181),
    [sym__cond_prefix_bang] = ACTIONS(1181),
    [sym__cond_tight_tilde] = ACTIONS(1181),
    [sym__cond_prefix_tilde] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [670] = {
    [sym__type_parens] = STATE(5999),
    [sym__type_tuple] = STATE(6002),
    [sym__type_unboxed_tuple] = STATE(6004),
    [sym__type_unboxed_sum] = STATE(6006),
    [sym__type_list] = STATE(6007),
    [sym__type_promoted] = STATE(5993),
    [sym__type_star] = STATE(5993),
    [sym__type_wildcard] = STATE(5993),
    [sym__at_type] = STATE(6030),
    [sym__type_apply] = STATE(6008),
    [sym__type_infix] = STATE(6009),
    [sym_type] = STATE(670),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8515),
    [sym__splice_dollars] = STATE(7346),
    [sym_splice] = STATE(5993),
    [sym_quasiquote] = STATE(5993),
    [sym_integer] = STATE(5925),
    [sym__plist] = STATE(6010),
    [sym_unit] = STATE(5993),
    [sym_unboxed_unit] = STATE(5993),
    [sym_prefix_tuple] = STATE(5993),
    [sym_prefix_unboxed_tuple] = STATE(5993),
    [sym_prefix_unboxed_sum] = STATE(5993),
    [sym_literal] = STATE(5993),
    [sym__qualified_type] = STATE(5906),
    [sym__qtyconid] = STATE(6014),
    [sym__tycon_arrow] = STATE(6014),
    [sym__qtycon_arrow] = STATE(6014),
    [sym__promoted_tycons_alias] = STATE(5993),
    [sym__promoted_tycons] = STATE(5993),
    [sym__tycon_ticked] = STATE(2672),
    [sym__qtycon_ticked] = STATE(2672),
    [sym__tyconids_ticked] = STATE(2672),
    [sym__promoted_tyconops_alias] = STATE(2672),
    [sym__promoted_tyconops] = STATE(2672),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2672),
    [sym__operator_alias] = STATE(2672),
    [sym__operator_minus] = STATE(2672),
    [sym__varsym_prefix] = STATE(6014),
    [sym__pvarsym] = STATE(6014),
    [sym__qualified_varsym] = STATE(2673),
    [sym__qvarsym_prefix] = STATE(6014),
    [sym__pqvarsym] = STATE(6014),
    [sym_constructor_operator] = STATE(2672),
    [sym__constructor_operator_alias] = STATE(2672),
    [sym__consym_prefix] = STATE(6014),
    [sym__pconsym] = STATE(6014),
    [sym__qualified_consym] = STATE(2675),
    [sym__qconsym_prefix] = STATE(6014),
    [sym__pqconsym] = STATE(6014),
    [sym__prefix_at] = STATE(2398),
    [sym__paren_open] = STATE(468),
    [sym__bracket_open] = STATE(986),
    [sym__unboxed_open] = STATE(795),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1119),
    [anon_sym_u22b8] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [anon_sym_where] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1119),
    [sym__cond_layout_end] = ACTIONS(1119),
    [sym__cond_layout_end_explicit] = ACTIONS(1119),
    [sym__phantom_where] = ACTIONS(1119),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym__phantom_bar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_prefix_percent] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [671] = {
    [sym__type_parens] = STATE(5944),
    [sym__type_tuple] = STATE(5945),
    [sym__type_unboxed_tuple] = STATE(5946),
    [sym__type_unboxed_sum] = STATE(5947),
    [sym__type_list] = STATE(5948),
    [sym__type_promoted] = STATE(5942),
    [sym__type_star] = STATE(5942),
    [sym__type_wildcard] = STATE(5942),
    [sym__at_type] = STATE(5969),
    [sym__type_apply] = STATE(5949),
    [sym__type_infix] = STATE(5950),
    [sym_type] = STATE(658),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8522),
    [sym__splice_dollars] = STATE(7347),
    [sym_splice] = STATE(5942),
    [sym_quasiquote] = STATE(5942),
    [sym_integer] = STATE(5902),
    [sym__plist] = STATE(5951),
    [sym_unit] = STATE(5942),
    [sym_unboxed_unit] = STATE(5942),
    [sym_prefix_tuple] = STATE(5942),
    [sym_prefix_unboxed_tuple] = STATE(5942),
    [sym_prefix_unboxed_sum] = STATE(5942),
    [sym_literal] = STATE(5942),
    [sym__qualified_type] = STATE(5976),
    [sym__qtyconid] = STATE(5952),
    [sym__tycon_arrow] = STATE(5952),
    [sym__qtycon_arrow] = STATE(5952),
    [sym__promoted_tycons_alias] = STATE(5942),
    [sym__promoted_tycons] = STATE(5942),
    [sym__tycon_ticked] = STATE(2634),
    [sym__qtycon_ticked] = STATE(2634),
    [sym__tyconids_ticked] = STATE(2634),
    [sym__promoted_tyconops_alias] = STATE(2634),
    [sym__promoted_tyconops] = STATE(2634),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2634),
    [sym__operator_alias] = STATE(2634),
    [sym__operator_minus] = STATE(2634),
    [sym__varsym_prefix] = STATE(5952),
    [sym__pvarsym] = STATE(5952),
    [sym__qualified_varsym] = STATE(2635),
    [sym__qvarsym_prefix] = STATE(5952),
    [sym__pqvarsym] = STATE(5952),
    [sym_constructor_operator] = STATE(2634),
    [sym__constructor_operator_alias] = STATE(2634),
    [sym__consym_prefix] = STATE(5952),
    [sym__pconsym] = STATE(5952),
    [sym__qualified_consym] = STATE(2636),
    [sym__qconsym_prefix] = STATE(5952),
    [sym__pqconsym] = STATE(5952),
    [sym__prefix_at] = STATE(2463),
    [sym__paren_open] = STATE(475),
    [sym__bracket_open] = STATE(1067),
    [sym__unboxed_open] = STATE(788),
    [sym_variable] = ACTIONS(1907),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_u2605] = ACTIONS(1915),
    [anon_sym_EQ] = ACTIONS(1157),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1917),
    [sym_char] = ACTIONS(1917),
    [sym_string] = ACTIONS(1917),
    [sym__integer_literal] = ACTIONS(1919),
    [sym__binary_literal] = ACTIONS(1921),
    [sym__octal_literal] = ACTIONS(1921),
    [sym__hex_literal] = ACTIONS(1921),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1923),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1925),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1157),
    [sym__cond_prefix_bang] = ACTIONS(1157),
    [sym__cond_tight_tilde] = ACTIONS(1157),
    [sym__cond_prefix_tilde] = ACTIONS(1157),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [672] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10087),
    [sym__assoc_tyfam] = STATE(10138),
    [sym__assoc_tyinst] = STATE(10139),
    [sym__assoc_datafam] = STATE(10141),
    [sym_default_signature] = STATE(10146),
    [sym_class_decl] = STATE(9407),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10146),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10146),
    [sym__local_decl] = STATE(10146),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(886),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(1929),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_data] = ACTIONS(1935),
    [anon_sym_default] = ACTIONS(1937),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1949),
    [sym__cond_layout_end] = ACTIONS(1951),
    [sym__cond_layout_end_explicit] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [673] = {
    [sym__type_parens] = STATE(6100),
    [sym__type_tuple] = STATE(6085),
    [sym__type_unboxed_tuple] = STATE(6123),
    [sym__type_unboxed_sum] = STATE(6122),
    [sym__type_list] = STATE(6120),
    [sym__type_promoted] = STATE(6129),
    [sym__type_star] = STATE(6129),
    [sym__type_wildcard] = STATE(6129),
    [sym__at_type] = STATE(6089),
    [sym__type_apply] = STATE(6118),
    [sym__type_infix] = STATE(6064),
    [sym_type] = STATE(685),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8415),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6129),
    [sym_quasiquote] = STATE(6129),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6116),
    [sym_unit] = STATE(6129),
    [sym_unboxed_unit] = STATE(6129),
    [sym_prefix_tuple] = STATE(6129),
    [sym_prefix_unboxed_tuple] = STATE(6129),
    [sym_prefix_unboxed_sum] = STATE(6129),
    [sym_literal] = STATE(6129),
    [sym__qualified_type] = STATE(6171),
    [sym__qtyconid] = STATE(6112),
    [sym__tycon_arrow] = STATE(6112),
    [sym__qtycon_arrow] = STATE(6112),
    [sym__promoted_tycons_alias] = STATE(6129),
    [sym__promoted_tycons] = STATE(6129),
    [sym__tycon_ticked] = STATE(2445),
    [sym__qtycon_ticked] = STATE(2445),
    [sym__tyconids_ticked] = STATE(2445),
    [sym__promoted_tyconops_alias] = STATE(2445),
    [sym__promoted_tyconops] = STATE(2445),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2445),
    [sym__operator_alias] = STATE(2445),
    [sym__operator_minus] = STATE(2445),
    [sym__varsym_prefix] = STATE(6112),
    [sym__pvarsym] = STATE(6112),
    [sym__qualified_varsym] = STATE(2446),
    [sym__qvarsym_prefix] = STATE(6112),
    [sym__pqvarsym] = STATE(6112),
    [sym_constructor_operator] = STATE(2445),
    [sym__constructor_operator_alias] = STATE(2445),
    [sym__consym_prefix] = STATE(6112),
    [sym__pconsym] = STATE(6112),
    [sym__qualified_consym] = STATE(2447),
    [sym__qconsym_prefix] = STATE(6112),
    [sym__pqconsym] = STATE(6112),
    [sym__prefix_at] = STATE(2676),
    [sym__paren_open] = STATE(453),
    [sym__bracket_open] = STATE(1072),
    [sym__unboxed_open] = STATE(815),
    [sym_variable] = ACTIONS(1955),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1957),
    [anon_sym_SQUOTE] = ACTIONS(1959),
    [anon_sym_STAR] = ACTIONS(1961),
    [anon_sym_u2605] = ACTIONS(1963),
    [anon_sym_EQ] = ACTIONS(1157),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1965),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1157),
    [sym__cond_prefix_bang] = ACTIONS(1157),
    [sym__cond_tight_tilde] = ACTIONS(1157),
    [sym__cond_prefix_tilde] = ACTIONS(1157),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__cond_minus] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [674] = {
    [sym__type_parens] = STATE(6134),
    [sym__type_tuple] = STATE(6135),
    [sym__type_unboxed_tuple] = STATE(6136),
    [sym__type_unboxed_sum] = STATE(6137),
    [sym__type_list] = STATE(6138),
    [sym__type_promoted] = STATE(6132),
    [sym__type_star] = STATE(6132),
    [sym__type_wildcard] = STATE(6132),
    [sym__at_type] = STATE(6154),
    [sym__type_apply] = STATE(6139),
    [sym__type_infix] = STATE(6140),
    [sym_type] = STATE(674),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8536),
    [sym__splice_dollars] = STATE(7279),
    [sym_splice] = STATE(6132),
    [sym_quasiquote] = STATE(6132),
    [sym_integer] = STATE(6128),
    [sym__plist] = STATE(6141),
    [sym_unit] = STATE(6132),
    [sym_unboxed_unit] = STATE(6132),
    [sym_prefix_tuple] = STATE(6132),
    [sym_prefix_unboxed_tuple] = STATE(6132),
    [sym_prefix_unboxed_sum] = STATE(6132),
    [sym_literal] = STATE(6132),
    [sym__qualified_type] = STATE(6083),
    [sym__qtyconid] = STATE(6142),
    [sym__tycon_arrow] = STATE(6142),
    [sym__qtycon_arrow] = STATE(6142),
    [sym__promoted_tycons_alias] = STATE(6132),
    [sym__promoted_tycons] = STATE(6132),
    [sym__tycon_ticked] = STATE(2657),
    [sym__qtycon_ticked] = STATE(2657),
    [sym__tyconids_ticked] = STATE(2657),
    [sym__promoted_tyconops_alias] = STATE(2657),
    [sym__promoted_tyconops] = STATE(2657),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2657),
    [sym__operator_alias] = STATE(2657),
    [sym__operator_minus] = STATE(2657),
    [sym__varsym_prefix] = STATE(6142),
    [sym__pvarsym] = STATE(6142),
    [sym__qualified_varsym] = STATE(2658),
    [sym__qvarsym_prefix] = STATE(6142),
    [sym__pqvarsym] = STATE(6142),
    [sym_constructor_operator] = STATE(2657),
    [sym__constructor_operator_alias] = STATE(2657),
    [sym__consym_prefix] = STATE(6142),
    [sym__pconsym] = STATE(6142),
    [sym__qualified_consym] = STATE(2659),
    [sym__qconsym_prefix] = STATE(6142),
    [sym__pqconsym] = STATE(6142),
    [sym__prefix_at] = STATE(2414),
    [sym__paren_open] = STATE(436),
    [sym__bracket_open] = STATE(971),
    [sym__unboxed_open] = STATE(752),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1117),
    [anon_sym_PIPE2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [anon_sym_POUND_RPAREN] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_tight_bang] = ACTIONS(1119),
    [sym__cond_prefix_bang] = ACTIONS(1119),
    [sym__cond_tight_tilde] = ACTIONS(1119),
    [sym__cond_prefix_tilde] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [675] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11585),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11532),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12097),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(4196),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10727),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1545),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1295),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [676] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11676),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11753),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11769),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(4127),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10677),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1453),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1249),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [677] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11332),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12021),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11870),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(4520),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10575),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1257),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [678] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11804),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12136),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11331),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6916),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10336),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1425),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1427),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [679] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11929),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12092),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11879),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(7013),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10513),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1505),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [680] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11738),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11974),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11762),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(7791),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10632),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1495),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1497),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [681] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11767),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12132),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12087),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(3063),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10341),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1447),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1449),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [682] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11730),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12128),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12074),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(7164),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10351),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1477),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [683] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(12169),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11613),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11360),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6591),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10827),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1459),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1461),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [684] = {
    [sym__type_parens] = STATE(6100),
    [sym__type_tuple] = STATE(6085),
    [sym__type_unboxed_tuple] = STATE(6123),
    [sym__type_unboxed_sum] = STATE(6122),
    [sym__type_list] = STATE(6120),
    [sym__type_promoted] = STATE(6129),
    [sym__type_star] = STATE(6129),
    [sym__type_wildcard] = STATE(6129),
    [sym__at_type] = STATE(6089),
    [sym__type_apply] = STATE(6118),
    [sym__type_infix] = STATE(6064),
    [sym_type] = STATE(685),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8415),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6129),
    [sym_quasiquote] = STATE(6129),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6116),
    [sym_unit] = STATE(6129),
    [sym_unboxed_unit] = STATE(6129),
    [sym_prefix_tuple] = STATE(6129),
    [sym_prefix_unboxed_tuple] = STATE(6129),
    [sym_prefix_unboxed_sum] = STATE(6129),
    [sym_literal] = STATE(6129),
    [sym__qualified_type] = STATE(6171),
    [sym__qtyconid] = STATE(6112),
    [sym__tycon_arrow] = STATE(6112),
    [sym__qtycon_arrow] = STATE(6112),
    [sym__promoted_tycons_alias] = STATE(6129),
    [sym__promoted_tycons] = STATE(6129),
    [sym__tycon_ticked] = STATE(2445),
    [sym__qtycon_ticked] = STATE(2445),
    [sym__tyconids_ticked] = STATE(2445),
    [sym__promoted_tyconops_alias] = STATE(2445),
    [sym__promoted_tyconops] = STATE(2445),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2445),
    [sym__operator_alias] = STATE(2445),
    [sym__operator_minus] = STATE(2445),
    [sym__varsym_prefix] = STATE(6112),
    [sym__pvarsym] = STATE(6112),
    [sym__qualified_varsym] = STATE(2446),
    [sym__qvarsym_prefix] = STATE(6112),
    [sym__pqvarsym] = STATE(6112),
    [sym_constructor_operator] = STATE(2445),
    [sym__constructor_operator_alias] = STATE(2445),
    [sym__consym_prefix] = STATE(6112),
    [sym__pconsym] = STATE(6112),
    [sym__qualified_consym] = STATE(2447),
    [sym__qconsym_prefix] = STATE(6112),
    [sym__pqconsym] = STATE(6112),
    [sym__prefix_at] = STATE(2676),
    [sym__paren_open] = STATE(453),
    [sym__bracket_open] = STATE(1072),
    [sym__unboxed_open] = STATE(815),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_tight_bang] = ACTIONS(1179),
    [sym__cond_prefix_bang] = ACTIONS(1179),
    [sym__cond_tight_tilde] = ACTIONS(1179),
    [sym__cond_prefix_tilde] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [685] = {
    [sym__type_parens] = STATE(6100),
    [sym__type_tuple] = STATE(6085),
    [sym__type_unboxed_tuple] = STATE(6123),
    [sym__type_unboxed_sum] = STATE(6122),
    [sym__type_list] = STATE(6120),
    [sym__type_promoted] = STATE(6129),
    [sym__type_star] = STATE(6129),
    [sym__type_wildcard] = STATE(6129),
    [sym__at_type] = STATE(6089),
    [sym__type_apply] = STATE(6118),
    [sym__type_infix] = STATE(6064),
    [sym_type] = STATE(685),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8415),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6129),
    [sym_quasiquote] = STATE(6129),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6116),
    [sym_unit] = STATE(6129),
    [sym_unboxed_unit] = STATE(6129),
    [sym_prefix_tuple] = STATE(6129),
    [sym_prefix_unboxed_tuple] = STATE(6129),
    [sym_prefix_unboxed_sum] = STATE(6129),
    [sym_literal] = STATE(6129),
    [sym__qualified_type] = STATE(6171),
    [sym__qtyconid] = STATE(6112),
    [sym__tycon_arrow] = STATE(6112),
    [sym__qtycon_arrow] = STATE(6112),
    [sym__promoted_tycons_alias] = STATE(6129),
    [sym__promoted_tycons] = STATE(6129),
    [sym__tycon_ticked] = STATE(2445),
    [sym__qtycon_ticked] = STATE(2445),
    [sym__tyconids_ticked] = STATE(2445),
    [sym__promoted_tyconops_alias] = STATE(2445),
    [sym__promoted_tyconops] = STATE(2445),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2445),
    [sym__operator_alias] = STATE(2445),
    [sym__operator_minus] = STATE(2445),
    [sym__varsym_prefix] = STATE(6112),
    [sym__pvarsym] = STATE(6112),
    [sym__qualified_varsym] = STATE(2446),
    [sym__qvarsym_prefix] = STATE(6112),
    [sym__pqvarsym] = STATE(6112),
    [sym_constructor_operator] = STATE(2445),
    [sym__constructor_operator_alias] = STATE(2445),
    [sym__consym_prefix] = STATE(6112),
    [sym__pconsym] = STATE(6112),
    [sym__qualified_consym] = STATE(2447),
    [sym__qconsym_prefix] = STATE(6112),
    [sym__pqconsym] = STATE(6112),
    [sym__prefix_at] = STATE(2676),
    [sym__paren_open] = STATE(453),
    [sym__bracket_open] = STATE(1072),
    [sym__unboxed_open] = STATE(815),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_EQ] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_tight_bang] = ACTIONS(1119),
    [sym__cond_prefix_bang] = ACTIONS(1119),
    [sym__cond_tight_tilde] = ACTIONS(1119),
    [sym__cond_prefix_tilde] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__cond_minus] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [686] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11516),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12007),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11836),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6478),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10590),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1413),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1415),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [687] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11842),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11576),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11417),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(7637),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10849),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1517),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1519),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [688] = {
    [sym__type_parens] = STATE(6134),
    [sym__type_tuple] = STATE(6135),
    [sym__type_unboxed_tuple] = STATE(6136),
    [sym__type_unboxed_sum] = STATE(6137),
    [sym__type_list] = STATE(6138),
    [sym__type_promoted] = STATE(6132),
    [sym__type_star] = STATE(6132),
    [sym__type_wildcard] = STATE(6132),
    [sym__at_type] = STATE(6154),
    [sym__type_apply] = STATE(6139),
    [sym__type_infix] = STATE(6140),
    [sym_type] = STATE(674),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8536),
    [sym__splice_dollars] = STATE(7279),
    [sym_splice] = STATE(6132),
    [sym_quasiquote] = STATE(6132),
    [sym_integer] = STATE(6128),
    [sym__plist] = STATE(6141),
    [sym_unit] = STATE(6132),
    [sym_unboxed_unit] = STATE(6132),
    [sym_prefix_tuple] = STATE(6132),
    [sym_prefix_unboxed_tuple] = STATE(6132),
    [sym_prefix_unboxed_sum] = STATE(6132),
    [sym_literal] = STATE(6132),
    [sym__qualified_type] = STATE(6083),
    [sym__qtyconid] = STATE(6142),
    [sym__tycon_arrow] = STATE(6142),
    [sym__qtycon_arrow] = STATE(6142),
    [sym__promoted_tycons_alias] = STATE(6132),
    [sym__promoted_tycons] = STATE(6132),
    [sym__tycon_ticked] = STATE(2657),
    [sym__qtycon_ticked] = STATE(2657),
    [sym__tyconids_ticked] = STATE(2657),
    [sym__promoted_tyconops_alias] = STATE(2657),
    [sym__promoted_tyconops] = STATE(2657),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2657),
    [sym__operator_alias] = STATE(2657),
    [sym__operator_minus] = STATE(2657),
    [sym__varsym_prefix] = STATE(6142),
    [sym__pvarsym] = STATE(6142),
    [sym__qualified_varsym] = STATE(2658),
    [sym__qvarsym_prefix] = STATE(6142),
    [sym__pqvarsym] = STATE(6142),
    [sym_constructor_operator] = STATE(2657),
    [sym__constructor_operator_alias] = STATE(2657),
    [sym__consym_prefix] = STATE(6142),
    [sym__pconsym] = STATE(6142),
    [sym__qualified_consym] = STATE(2659),
    [sym__qconsym_prefix] = STATE(6142),
    [sym__pqconsym] = STATE(6142),
    [sym__prefix_at] = STATE(2414),
    [sym__paren_open] = STATE(436),
    [sym__bracket_open] = STATE(971),
    [sym__unboxed_open] = STATE(752),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1969),
    [anon_sym_STAR] = ACTIONS(1971),
    [anon_sym_u2605] = ACTIONS(1973),
    [anon_sym_PIPE] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [anon_sym_PIPE2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_POUND_RPAREN] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_tight_bang] = ACTIONS(1179),
    [sym__cond_prefix_bang] = ACTIONS(1179),
    [sym__cond_tight_tilde] = ACTIONS(1179),
    [sym__cond_prefix_tilde] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(1179),
  },
  [689] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11621),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11992),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11799),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(7273),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10614),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1467),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1469),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [690] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11338),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11399),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11965),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(3845),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10190),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1491),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1493),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [691] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11878),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11956),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11725),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6504),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10647),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1541),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1543),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [692] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11432),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11724),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11429),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6005),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10789),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1507),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1509),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [693] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11984),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12018),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11350),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6073),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10394),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(249),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [694] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11765),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12183),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12178),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(4517),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10501),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1419),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1269),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [695] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11693),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12124),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12061),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(4884),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10364),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1479),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1263),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [696] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11380),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11818),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11696),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(7470),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10183),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1557),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1559),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [697] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11656),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12120),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12048),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(3293),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10380),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1521),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1523),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [698] = {
    [sym__type_parens] = STATE(6134),
    [sym__type_tuple] = STATE(6135),
    [sym__type_unboxed_tuple] = STATE(6136),
    [sym__type_unboxed_sum] = STATE(6137),
    [sym__type_list] = STATE(6138),
    [sym__type_promoted] = STATE(6132),
    [sym__type_star] = STATE(6132),
    [sym__type_wildcard] = STATE(6132),
    [sym__at_type] = STATE(6154),
    [sym__type_apply] = STATE(6139),
    [sym__type_infix] = STATE(6140),
    [sym_type] = STATE(674),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8536),
    [sym__splice_dollars] = STATE(7279),
    [sym_splice] = STATE(6132),
    [sym_quasiquote] = STATE(6132),
    [sym_integer] = STATE(6128),
    [sym__plist] = STATE(6141),
    [sym_unit] = STATE(6132),
    [sym_unboxed_unit] = STATE(6132),
    [sym_prefix_tuple] = STATE(6132),
    [sym_prefix_unboxed_tuple] = STATE(6132),
    [sym_prefix_unboxed_sum] = STATE(6132),
    [sym_literal] = STATE(6132),
    [sym__qualified_type] = STATE(6083),
    [sym__qtyconid] = STATE(6142),
    [sym__tycon_arrow] = STATE(6142),
    [sym__qtycon_arrow] = STATE(6142),
    [sym__promoted_tycons_alias] = STATE(6132),
    [sym__promoted_tycons] = STATE(6132),
    [sym__tycon_ticked] = STATE(2657),
    [sym__qtycon_ticked] = STATE(2657),
    [sym__tyconids_ticked] = STATE(2657),
    [sym__promoted_tyconops_alias] = STATE(2657),
    [sym__promoted_tyconops] = STATE(2657),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2657),
    [sym__operator_alias] = STATE(2657),
    [sym__operator_minus] = STATE(2657),
    [sym__varsym_prefix] = STATE(6142),
    [sym__pvarsym] = STATE(6142),
    [sym__qualified_varsym] = STATE(2658),
    [sym__qvarsym_prefix] = STATE(6142),
    [sym__pqvarsym] = STATE(6142),
    [sym_constructor_operator] = STATE(2657),
    [sym__constructor_operator_alias] = STATE(2657),
    [sym__consym_prefix] = STATE(6142),
    [sym__pconsym] = STATE(6142),
    [sym__qualified_consym] = STATE(2659),
    [sym__qconsym_prefix] = STATE(6142),
    [sym__pqconsym] = STATE(6142),
    [sym__prefix_at] = STATE(2414),
    [sym__paren_open] = STATE(436),
    [sym__bracket_open] = STATE(971),
    [sym__unboxed_open] = STATE(752),
    [sym_variable] = ACTIONS(1975),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1969),
    [anon_sym_STAR] = ACTIONS(1971),
    [anon_sym_u2605] = ACTIONS(1973),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1979),
    [sym_char] = ACTIONS(1979),
    [sym_string] = ACTIONS(1979),
    [sym__integer_literal] = ACTIONS(1981),
    [sym__binary_literal] = ACTIONS(1983),
    [sym__octal_literal] = ACTIONS(1983),
    [sym__hex_literal] = ACTIONS(1983),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [anon_sym_PIPE2] = ACTIONS(1181),
    [sym_name] = ACTIONS(1985),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1987),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1181),
    [sym__cond_prefix_bang] = ACTIONS(1181),
    [sym__cond_tight_tilde] = ACTIONS(1181),
    [sym__cond_prefix_tilde] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [699] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11354),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11916),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12212),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6955),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10458),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1409),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1411),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [700] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11601),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11539),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11531),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(7032),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10859),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1553),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1555),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [701] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11783),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11513),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11914),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(7549),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10425),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1487),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1489),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [702] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11425),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11761),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11466),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(4021),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10769),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1481),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [703] = {
    [sym__type_parens] = STATE(6134),
    [sym__type_tuple] = STATE(6135),
    [sym__type_unboxed_tuple] = STATE(6136),
    [sym__type_unboxed_sum] = STATE(6137),
    [sym__type_list] = STATE(6138),
    [sym__type_promoted] = STATE(6132),
    [sym__type_star] = STATE(6132),
    [sym__type_wildcard] = STATE(6132),
    [sym__at_type] = STATE(6154),
    [sym__type_apply] = STATE(6139),
    [sym__type_infix] = STATE(6140),
    [sym_type] = STATE(674),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8536),
    [sym__splice_dollars] = STATE(7279),
    [sym_splice] = STATE(6132),
    [sym_quasiquote] = STATE(6132),
    [sym_integer] = STATE(6128),
    [sym__plist] = STATE(6141),
    [sym_unit] = STATE(6132),
    [sym_unboxed_unit] = STATE(6132),
    [sym_prefix_tuple] = STATE(6132),
    [sym_prefix_unboxed_tuple] = STATE(6132),
    [sym_prefix_unboxed_sum] = STATE(6132),
    [sym_literal] = STATE(6132),
    [sym__qualified_type] = STATE(6083),
    [sym__qtyconid] = STATE(6142),
    [sym__tycon_arrow] = STATE(6142),
    [sym__qtycon_arrow] = STATE(6142),
    [sym__promoted_tycons_alias] = STATE(6132),
    [sym__promoted_tycons] = STATE(6132),
    [sym__tycon_ticked] = STATE(2657),
    [sym__qtycon_ticked] = STATE(2657),
    [sym__tyconids_ticked] = STATE(2657),
    [sym__promoted_tyconops_alias] = STATE(2657),
    [sym__promoted_tyconops] = STATE(2657),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2657),
    [sym__operator_alias] = STATE(2657),
    [sym__operator_minus] = STATE(2657),
    [sym__varsym_prefix] = STATE(6142),
    [sym__pvarsym] = STATE(6142),
    [sym__qualified_varsym] = STATE(2658),
    [sym__qvarsym_prefix] = STATE(6142),
    [sym__pqvarsym] = STATE(6142),
    [sym_constructor_operator] = STATE(2657),
    [sym__constructor_operator_alias] = STATE(2657),
    [sym__consym_prefix] = STATE(6142),
    [sym__pconsym] = STATE(6142),
    [sym__qualified_consym] = STATE(2659),
    [sym__qconsym_prefix] = STATE(6142),
    [sym__pqconsym] = STATE(6142),
    [sym__prefix_at] = STATE(2414),
    [sym__paren_open] = STATE(436),
    [sym__bracket_open] = STATE(971),
    [sym__unboxed_open] = STATE(752),
    [sym_variable] = ACTIONS(1975),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1969),
    [anon_sym_STAR] = ACTIONS(1971),
    [anon_sym_u2605] = ACTIONS(1973),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1979),
    [sym_char] = ACTIONS(1979),
    [sym_string] = ACTIONS(1979),
    [sym__integer_literal] = ACTIONS(1981),
    [sym__binary_literal] = ACTIONS(1983),
    [sym__octal_literal] = ACTIONS(1983),
    [sym__hex_literal] = ACTIONS(1983),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [anon_sym_PIPE2] = ACTIONS(1181),
    [sym_name] = ACTIONS(1985),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1987),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1181),
    [sym__cond_prefix_bang] = ACTIONS(1181),
    [sym__cond_tight_tilde] = ACTIONS(1181),
    [sym__cond_prefix_tilde] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [704] = {
    [sym__type_parens] = STATE(6134),
    [sym__type_tuple] = STATE(6135),
    [sym__type_unboxed_tuple] = STATE(6136),
    [sym__type_unboxed_sum] = STATE(6137),
    [sym__type_list] = STATE(6138),
    [sym__type_promoted] = STATE(6132),
    [sym__type_star] = STATE(6132),
    [sym__type_wildcard] = STATE(6132),
    [sym__at_type] = STATE(6154),
    [sym__type_apply] = STATE(6139),
    [sym__type_infix] = STATE(6140),
    [sym_type] = STATE(674),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8536),
    [sym__splice_dollars] = STATE(7279),
    [sym_splice] = STATE(6132),
    [sym_quasiquote] = STATE(6132),
    [sym_integer] = STATE(6128),
    [sym__plist] = STATE(6141),
    [sym_unit] = STATE(6132),
    [sym_unboxed_unit] = STATE(6132),
    [sym_prefix_tuple] = STATE(6132),
    [sym_prefix_unboxed_tuple] = STATE(6132),
    [sym_prefix_unboxed_sum] = STATE(6132),
    [sym_literal] = STATE(6132),
    [sym__qualified_type] = STATE(6083),
    [sym__qtyconid] = STATE(6142),
    [sym__tycon_arrow] = STATE(6142),
    [sym__qtycon_arrow] = STATE(6142),
    [sym__promoted_tycons_alias] = STATE(6132),
    [sym__promoted_tycons] = STATE(6132),
    [sym__tycon_ticked] = STATE(2657),
    [sym__qtycon_ticked] = STATE(2657),
    [sym__tyconids_ticked] = STATE(2657),
    [sym__promoted_tyconops_alias] = STATE(2657),
    [sym__promoted_tyconops] = STATE(2657),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2657),
    [sym__operator_alias] = STATE(2657),
    [sym__operator_minus] = STATE(2657),
    [sym__varsym_prefix] = STATE(6142),
    [sym__pvarsym] = STATE(6142),
    [sym__qualified_varsym] = STATE(2658),
    [sym__qvarsym_prefix] = STATE(6142),
    [sym__pqvarsym] = STATE(6142),
    [sym_constructor_operator] = STATE(2657),
    [sym__constructor_operator_alias] = STATE(2657),
    [sym__consym_prefix] = STATE(6142),
    [sym__pconsym] = STATE(6142),
    [sym__qualified_consym] = STATE(2659),
    [sym__qconsym_prefix] = STATE(6142),
    [sym__pqconsym] = STATE(6142),
    [sym__prefix_at] = STATE(2414),
    [sym__paren_open] = STATE(436),
    [sym__bracket_open] = STATE(971),
    [sym__unboxed_open] = STATE(752),
    [sym_variable] = ACTIONS(1975),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1969),
    [anon_sym_STAR] = ACTIONS(1971),
    [anon_sym_u2605] = ACTIONS(1973),
    [anon_sym_PIPE] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1979),
    [sym_char] = ACTIONS(1979),
    [sym_string] = ACTIONS(1979),
    [sym__integer_literal] = ACTIONS(1981),
    [sym__binary_literal] = ACTIONS(1983),
    [sym__octal_literal] = ACTIONS(1983),
    [sym__hex_literal] = ACTIONS(1983),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [anon_sym_PIPE2] = ACTIONS(1157),
    [sym_name] = ACTIONS(1985),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(1157),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1987),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1157),
    [sym__cond_prefix_bang] = ACTIONS(1157),
    [sym__cond_tight_tilde] = ACTIONS(1157),
    [sym__cond_prefix_tilde] = ACTIONS(1157),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [705] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(12015),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11938),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11688),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(5908),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10665),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1537),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1539),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [706] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11989),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11745),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11823),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6274),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10401),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1433),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1435),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [707] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11619),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12115),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12035),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6737),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10408),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1549),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1551),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [708] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11488),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11359),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12054),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(5074),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10775),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1565),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1567),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [709] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11841),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12139),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12102),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(3254),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10328),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1499),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [710] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11645),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11835),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11540),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(5937),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10759),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1561),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1563),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [711] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11582),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12108),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12022),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(3334),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10431),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1531),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [712] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11365),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12034),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11899),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(4855),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10561),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1451),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1275),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [713] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11545),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12101),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12008),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(3452),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10450),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1525),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1527),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [714] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11902),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12143),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12116),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(3678),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10322),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1511),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1513),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [715] = {
    [sym__type_parens] = STATE(6100),
    [sym__type_tuple] = STATE(6085),
    [sym__type_unboxed_tuple] = STATE(6123),
    [sym__type_unboxed_sum] = STATE(6122),
    [sym__type_list] = STATE(6120),
    [sym__type_promoted] = STATE(6129),
    [sym__type_star] = STATE(6129),
    [sym__type_wildcard] = STATE(6129),
    [sym__at_type] = STATE(6089),
    [sym__type_apply] = STATE(6118),
    [sym__type_infix] = STATE(6064),
    [sym_type] = STATE(685),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8415),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6129),
    [sym_quasiquote] = STATE(6129),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6116),
    [sym_unit] = STATE(6129),
    [sym_unboxed_unit] = STATE(6129),
    [sym_prefix_tuple] = STATE(6129),
    [sym_prefix_unboxed_tuple] = STATE(6129),
    [sym_prefix_unboxed_sum] = STATE(6129),
    [sym_literal] = STATE(6129),
    [sym__qualified_type] = STATE(6171),
    [sym__qtyconid] = STATE(6112),
    [sym__tycon_arrow] = STATE(6112),
    [sym__qtycon_arrow] = STATE(6112),
    [sym__promoted_tycons_alias] = STATE(6129),
    [sym__promoted_tycons] = STATE(6129),
    [sym__tycon_ticked] = STATE(2445),
    [sym__qtycon_ticked] = STATE(2445),
    [sym__tyconids_ticked] = STATE(2445),
    [sym__promoted_tyconops_alias] = STATE(2445),
    [sym__promoted_tyconops] = STATE(2445),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2445),
    [sym__operator_alias] = STATE(2445),
    [sym__operator_minus] = STATE(2445),
    [sym__varsym_prefix] = STATE(6112),
    [sym__pvarsym] = STATE(6112),
    [sym__qualified_varsym] = STATE(2446),
    [sym__qvarsym_prefix] = STATE(6112),
    [sym__pqvarsym] = STATE(6112),
    [sym_constructor_operator] = STATE(2445),
    [sym__constructor_operator_alias] = STATE(2445),
    [sym__consym_prefix] = STATE(6112),
    [sym__pconsym] = STATE(6112),
    [sym__qualified_consym] = STATE(2447),
    [sym__qconsym_prefix] = STATE(6112),
    [sym__pqconsym] = STATE(6112),
    [sym__prefix_at] = STATE(2676),
    [sym__paren_open] = STATE(453),
    [sym__bracket_open] = STATE(1072),
    [sym__unboxed_open] = STATE(815),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1959),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1963),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_tight_bang] = ACTIONS(1179),
    [sym__cond_prefix_bang] = ACTIONS(1179),
    [sym__cond_tight_tilde] = ACTIONS(1179),
    [sym__cond_prefix_tilde] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [716] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(12113),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11898),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11614),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6144),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10712),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1429),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1431),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [717] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11471),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12086),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11975),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6401),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10494),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1365),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1395),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [718] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11772),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12204),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11459),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(4284),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10568),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1547),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1277),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [719] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11423),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11561),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11778),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6420),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10023),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1471),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1473),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [720] = {
    [sym__type_parens] = STATE(6100),
    [sym__type_tuple] = STATE(6085),
    [sym__type_unboxed_tuple] = STATE(6123),
    [sym__type_unboxed_sum] = STATE(6122),
    [sym__type_list] = STATE(6120),
    [sym__type_promoted] = STATE(6129),
    [sym__type_star] = STATE(6129),
    [sym__type_wildcard] = STATE(6129),
    [sym__at_type] = STATE(6089),
    [sym__type_apply] = STATE(6118),
    [sym__type_infix] = STATE(6064),
    [sym_type] = STATE(685),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8415),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6129),
    [sym_quasiquote] = STATE(6129),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6116),
    [sym_unit] = STATE(6129),
    [sym_unboxed_unit] = STATE(6129),
    [sym_prefix_tuple] = STATE(6129),
    [sym_prefix_unboxed_tuple] = STATE(6129),
    [sym_prefix_unboxed_sum] = STATE(6129),
    [sym_literal] = STATE(6129),
    [sym__qualified_type] = STATE(6171),
    [sym__qtyconid] = STATE(6112),
    [sym__tycon_arrow] = STATE(6112),
    [sym__qtycon_arrow] = STATE(6112),
    [sym__promoted_tycons_alias] = STATE(6129),
    [sym__promoted_tycons] = STATE(6129),
    [sym__tycon_ticked] = STATE(2445),
    [sym__qtycon_ticked] = STATE(2445),
    [sym__tyconids_ticked] = STATE(2445),
    [sym__promoted_tyconops_alias] = STATE(2445),
    [sym__promoted_tyconops] = STATE(2445),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2445),
    [sym__operator_alias] = STATE(2445),
    [sym__operator_minus] = STATE(2445),
    [sym__varsym_prefix] = STATE(6112),
    [sym__pvarsym] = STATE(6112),
    [sym__qualified_varsym] = STATE(2446),
    [sym__qvarsym_prefix] = STATE(6112),
    [sym__pqvarsym] = STATE(6112),
    [sym_constructor_operator] = STATE(2445),
    [sym__constructor_operator_alias] = STATE(2445),
    [sym__consym_prefix] = STATE(6112),
    [sym__pconsym] = STATE(6112),
    [sym__qualified_consym] = STATE(2447),
    [sym__qconsym_prefix] = STATE(6112),
    [sym__pqconsym] = STATE(6112),
    [sym__prefix_at] = STATE(2676),
    [sym__paren_open] = STATE(453),
    [sym__bracket_open] = STATE(1072),
    [sym__unboxed_open] = STATE(815),
    [sym_variable] = ACTIONS(1955),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1957),
    [anon_sym_SQUOTE] = ACTIONS(1959),
    [anon_sym_STAR] = ACTIONS(1961),
    [anon_sym_u2605] = ACTIONS(1963),
    [anon_sym_EQ] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1965),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1181),
    [sym__cond_prefix_bang] = ACTIONS(1181),
    [sym__cond_tight_tilde] = ACTIONS(1181),
    [sym__cond_prefix_tilde] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [721] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11434),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12073),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11957),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(5870),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10512),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1483),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1485),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [722] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11875),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12141),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(12109),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(2755),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10325),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1533),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1535),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [723] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11397),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12060),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11939),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(2311),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10538),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1455),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1457),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [724] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(12214),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11919),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11651),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(3240),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10686),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1463),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1465),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [725] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11734),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12207),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11592),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(2730),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10332),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1417),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1279),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [726] = {
    [sym__type_parens] = STATE(6100),
    [sym__type_tuple] = STATE(6085),
    [sym__type_unboxed_tuple] = STATE(6123),
    [sym__type_unboxed_sum] = STATE(6122),
    [sym__type_list] = STATE(6120),
    [sym__type_promoted] = STATE(6129),
    [sym__type_star] = STATE(6129),
    [sym__type_wildcard] = STATE(6129),
    [sym__at_type] = STATE(6089),
    [sym__type_apply] = STATE(6118),
    [sym__type_infix] = STATE(6064),
    [sym_type] = STATE(685),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8415),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6129),
    [sym_quasiquote] = STATE(6129),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6116),
    [sym_unit] = STATE(6129),
    [sym_unboxed_unit] = STATE(6129),
    [sym_prefix_tuple] = STATE(6129),
    [sym_prefix_unboxed_tuple] = STATE(6129),
    [sym_prefix_unboxed_sum] = STATE(6129),
    [sym_literal] = STATE(6129),
    [sym__qualified_type] = STATE(6171),
    [sym__qtyconid] = STATE(6112),
    [sym__tycon_arrow] = STATE(6112),
    [sym__qtycon_arrow] = STATE(6112),
    [sym__promoted_tycons_alias] = STATE(6129),
    [sym__promoted_tycons] = STATE(6129),
    [sym__tycon_ticked] = STATE(2445),
    [sym__qtycon_ticked] = STATE(2445),
    [sym__tyconids_ticked] = STATE(2445),
    [sym__promoted_tyconops_alias] = STATE(2445),
    [sym__promoted_tyconops] = STATE(2445),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2445),
    [sym__operator_alias] = STATE(2445),
    [sym__operator_minus] = STATE(2445),
    [sym__varsym_prefix] = STATE(6112),
    [sym__pvarsym] = STATE(6112),
    [sym__qualified_varsym] = STATE(2446),
    [sym__qvarsym_prefix] = STATE(6112),
    [sym__pqvarsym] = STATE(6112),
    [sym_constructor_operator] = STATE(2445),
    [sym__constructor_operator_alias] = STATE(2445),
    [sym__consym_prefix] = STATE(6112),
    [sym__pconsym] = STATE(6112),
    [sym__qualified_consym] = STATE(2447),
    [sym__qconsym_prefix] = STATE(6112),
    [sym__pqconsym] = STATE(6112),
    [sym__prefix_at] = STATE(2676),
    [sym__paren_open] = STATE(453),
    [sym__bracket_open] = STATE(1072),
    [sym__unboxed_open] = STATE(815),
    [sym_variable] = ACTIONS(1955),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1957),
    [anon_sym_SQUOTE] = ACTIONS(1959),
    [anon_sym_STAR] = ACTIONS(1961),
    [anon_sym_u2605] = ACTIONS(1963),
    [anon_sym_EQ] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1965),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1181),
    [sym__cond_prefix_bang] = ACTIONS(1181),
    [sym__cond_tight_tilde] = ACTIONS(1181),
    [sym__cond_prefix_tilde] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [727] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11379),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11465),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11634),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(7614),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10865),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1421),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1423),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [728] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11795),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12064),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11407),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6526),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10623),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(279),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(283),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [729] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11673),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11593),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11370),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(7455),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10609),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1441),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1443),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [730] = {
    [sym__type_parens] = STATE(6134),
    [sym__type_tuple] = STATE(6135),
    [sym__type_unboxed_tuple] = STATE(6136),
    [sym__type_unboxed_sum] = STATE(6137),
    [sym__type_list] = STATE(6138),
    [sym__type_promoted] = STATE(6132),
    [sym__type_star] = STATE(6132),
    [sym__type_wildcard] = STATE(6132),
    [sym__at_type] = STATE(6154),
    [sym__type_apply] = STATE(6139),
    [sym__type_infix] = STATE(6140),
    [sym_type] = STATE(674),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8536),
    [sym__splice_dollars] = STATE(7279),
    [sym_splice] = STATE(6132),
    [sym_quasiquote] = STATE(6132),
    [sym_integer] = STATE(6128),
    [sym__plist] = STATE(6141),
    [sym_unit] = STATE(6132),
    [sym_unboxed_unit] = STATE(6132),
    [sym_prefix_tuple] = STATE(6132),
    [sym_prefix_unboxed_tuple] = STATE(6132),
    [sym_prefix_unboxed_sum] = STATE(6132),
    [sym_literal] = STATE(6132),
    [sym__qualified_type] = STATE(6083),
    [sym__qtyconid] = STATE(6142),
    [sym__tycon_arrow] = STATE(6142),
    [sym__qtycon_arrow] = STATE(6142),
    [sym__promoted_tycons_alias] = STATE(6132),
    [sym__promoted_tycons] = STATE(6132),
    [sym__tycon_ticked] = STATE(2657),
    [sym__qtycon_ticked] = STATE(2657),
    [sym__tyconids_ticked] = STATE(2657),
    [sym__promoted_tyconops_alias] = STATE(2657),
    [sym__promoted_tyconops] = STATE(2657),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2657),
    [sym__operator_alias] = STATE(2657),
    [sym__operator_minus] = STATE(2657),
    [sym__varsym_prefix] = STATE(6142),
    [sym__pvarsym] = STATE(6142),
    [sym__qualified_varsym] = STATE(2658),
    [sym__qvarsym_prefix] = STATE(6142),
    [sym__pqvarsym] = STATE(6142),
    [sym_constructor_operator] = STATE(2657),
    [sym__constructor_operator_alias] = STATE(2657),
    [sym__consym_prefix] = STATE(6142),
    [sym__pconsym] = STATE(6142),
    [sym__qualified_consym] = STATE(2659),
    [sym__qconsym_prefix] = STATE(6142),
    [sym__pqconsym] = STATE(6142),
    [sym__prefix_at] = STATE(2414),
    [sym__paren_open] = STATE(436),
    [sym__bracket_open] = STATE(971),
    [sym__unboxed_open] = STATE(752),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [anon_sym_PIPE2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_POUND_RPAREN] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_tight_bang] = ACTIONS(1179),
    [sym__cond_prefix_bang] = ACTIONS(1179),
    [sym__cond_tight_tilde] = ACTIONS(1179),
    [sym__cond_prefix_tilde] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [731] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(12000),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11869),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11577),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(6734),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10733),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1437),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1439),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [732] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11508),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(9892),
    [aux_sym__qualifying_module] = STATE(9903),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(12094),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(11993),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(3688),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10476),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(1515),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(1967),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1255),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [733] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9468),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(7312),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10186),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9718),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2007),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2013),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [734] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9420),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(4120),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10730),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9790),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2017),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2021),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2023),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [735] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10783),
    [sym__assoc_tyfam] = STATE(10138),
    [sym__assoc_tyinst] = STATE(10139),
    [sym__assoc_datafam] = STATE(10141),
    [sym_default_signature] = STATE(10146),
    [sym_class_decl] = STATE(10736),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10146),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10146),
    [sym__local_decl] = STATE(10146),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_data] = ACTIONS(1935),
    [anon_sym_default] = ACTIONS(1937),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(2025),
    [sym__cond_layout_end_explicit] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [736] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__at_type] = STATE(6534),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(775),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8518),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__tycon_ticked] = STATE(2555),
    [sym__qtycon_ticked] = STATE(2555),
    [sym__tyconids_ticked] = STATE(2555),
    [sym__promoted_tyconops_alias] = STATE(2555),
    [sym__promoted_tyconops] = STATE(2555),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2555),
    [sym__operator_alias] = STATE(2555),
    [sym__operator_minus] = STATE(2555),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qualified_varsym] = STATE(2573),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym_constructor_operator] = STATE(2555),
    [sym__constructor_operator_alias] = STATE(2555),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qualified_consym] = STATE(2582),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_at] = STATE(2538),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(2027),
    [anon_sym_STAR] = ACTIONS(2029),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [anon_sym_PIPE2] = ACTIONS(1157),
    [sym_name] = ACTIONS(2031),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1157),
    [anon_sym_u22b8] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(1157),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [737] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9170),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(6930),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10461),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9836),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2033),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2035),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2037),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2039),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [738] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__at_type] = STATE(6393),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(791),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8417),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__tycon_ticked] = STATE(2442),
    [sym__qtycon_ticked] = STATE(2442),
    [sym__tyconids_ticked] = STATE(2442),
    [sym__promoted_tyconops_alias] = STATE(2442),
    [sym__promoted_tyconops] = STATE(2442),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2442),
    [sym__operator_alias] = STATE(2442),
    [sym__operator_minus] = STATE(2442),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qualified_varsym] = STATE(2441),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym_constructor_operator] = STATE(2442),
    [sym__constructor_operator_alias] = STATE(2442),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qualified_consym] = STATE(2428),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_at] = STATE(2660),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2057),
    [anon_sym_u2192] = ACTIONS(1123),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1123),
    [anon_sym_u22b8] = ACTIONS(1123),
    [anon_sym_COLON_COLON] = ACTIONS(1123),
    [anon_sym_u2237] = ACTIONS(1123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1123),
    [sym__cond_layout_end] = ACTIONS(1123),
    [sym__cond_layout_end_explicit] = ACTIONS(1123),
    [sym__phantom_arrow] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1123),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [739] = {
    [sym__type_parens] = STATE(6363),
    [sym__type_tuple] = STATE(6337),
    [sym__type_unboxed_tuple] = STATE(6351),
    [sym__type_unboxed_sum] = STATE(6350),
    [sym__type_list] = STATE(6349),
    [sym__type_promoted] = STATE(6364),
    [sym__type_star] = STATE(6364),
    [sym__type_wildcard] = STATE(6364),
    [sym__at_type] = STATE(6316),
    [sym__type_apply] = STATE(6347),
    [sym__type_infix] = STATE(6346),
    [sym_type] = STATE(821),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8548),
    [sym__splice_dollars] = STATE(7313),
    [sym_splice] = STATE(6364),
    [sym_quasiquote] = STATE(6364),
    [sym_integer] = STATE(6231),
    [sym__plist] = STATE(6345),
    [sym_unit] = STATE(6364),
    [sym_unboxed_unit] = STATE(6364),
    [sym_prefix_tuple] = STATE(6364),
    [sym_prefix_unboxed_tuple] = STATE(6364),
    [sym_prefix_unboxed_sum] = STATE(6364),
    [sym_literal] = STATE(6364),
    [sym__qualified_type] = STATE(6444),
    [sym__qtyconid] = STATE(6341),
    [sym__tycon_arrow] = STATE(6341),
    [sym__qtycon_arrow] = STATE(6341),
    [sym__promoted_tycons_alias] = STATE(6364),
    [sym__promoted_tycons] = STATE(6364),
    [sym__tycon_ticked] = STATE(2641),
    [sym__qtycon_ticked] = STATE(2641),
    [sym__tyconids_ticked] = STATE(2641),
    [sym__promoted_tyconops_alias] = STATE(2641),
    [sym__promoted_tyconops] = STATE(2641),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2641),
    [sym__operator_alias] = STATE(2641),
    [sym__operator_minus] = STATE(2641),
    [sym__varsym_prefix] = STATE(6341),
    [sym__pvarsym] = STATE(6341),
    [sym__qualified_varsym] = STATE(2643),
    [sym__qvarsym_prefix] = STATE(6341),
    [sym__pqvarsym] = STATE(6341),
    [sym_constructor_operator] = STATE(2641),
    [sym__constructor_operator_alias] = STATE(2641),
    [sym__consym_prefix] = STATE(6341),
    [sym__pconsym] = STATE(6341),
    [sym__qualified_consym] = STATE(2646),
    [sym__qconsym_prefix] = STATE(6341),
    [sym__pqconsym] = STATE(6341),
    [sym__prefix_at] = STATE(2437),
    [sym__paren_open] = STATE(442),
    [sym__bracket_open] = STATE(962),
    [sym__unboxed_open] = STATE(762),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(2063),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__paren_close_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_tight_bang] = ACTIONS(1179),
    [sym__cond_prefix_bang] = ACTIONS(1179),
    [sym__cond_tight_tilde] = ACTIONS(1179),
    [sym__cond_prefix_tilde] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [740] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9484),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(2333),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10533),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9747),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2065),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2069),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2071),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [741] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9643),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(2715),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(926),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(845),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2073),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(2075),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_PIPE2] = ACTIONS(2079),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2081),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [742] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10469),
    [sym__assoc_tyfam] = STATE(10138),
    [sym__assoc_tyinst] = STATE(10139),
    [sym__assoc_datafam] = STATE(10141),
    [sym_default_signature] = STATE(10146),
    [sym_class_decl] = STATE(10736),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10146),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10146),
    [sym__local_decl] = STATE(10146),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_data] = ACTIONS(1935),
    [anon_sym_default] = ACTIONS(1937),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(2083),
    [sym__cond_layout_end_explicit] = ACTIONS(2083),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [743] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9169),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(3317),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10683),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9945),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2085),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2087),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2089),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2091),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [744] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9296),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(6958),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10334),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9996),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2093),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2095),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2097),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2099),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [745] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__at_type] = STATE(6393),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(791),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8417),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__tycon_ticked] = STATE(2442),
    [sym__qtycon_ticked] = STATE(2442),
    [sym__tyconids_ticked] = STATE(2442),
    [sym__promoted_tyconops_alias] = STATE(2442),
    [sym__promoted_tyconops] = STATE(2442),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2442),
    [sym__operator_alias] = STATE(2442),
    [sym__operator_minus] = STATE(2442),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qualified_varsym] = STATE(2441),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym_constructor_operator] = STATE(2442),
    [sym__constructor_operator_alias] = STATE(2442),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qualified_consym] = STATE(2428),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_at] = STATE(2660),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2057),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [746] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9570),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(4038),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(923),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(866),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2101),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(2103),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_PIPE2] = ACTIONS(2105),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2107),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [747] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__at_type] = STATE(6393),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(791),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8417),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__tycon_ticked] = STATE(2442),
    [sym__qtycon_ticked] = STATE(2442),
    [sym__tyconids_ticked] = STATE(2442),
    [sym__promoted_tyconops_alias] = STATE(2442),
    [sym__promoted_tyconops] = STATE(2442),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2442),
    [sym__operator_alias] = STATE(2442),
    [sym__operator_minus] = STATE(2442),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qualified_varsym] = STATE(2441),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym_constructor_operator] = STATE(2442),
    [sym__constructor_operator_alias] = STATE(2442),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qualified_consym] = STATE(2428),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_at] = STATE(2660),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2057),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [748] = {
    [sym__type_parens] = STATE(6512),
    [sym__type_tuple] = STATE(6513),
    [sym__type_unboxed_tuple] = STATE(6514),
    [sym__type_unboxed_sum] = STATE(6515),
    [sym__type_list] = STATE(6516),
    [sym__type_promoted] = STATE(6510),
    [sym__type_star] = STATE(6510),
    [sym__type_wildcard] = STATE(6510),
    [sym__at_type] = STATE(6537),
    [sym__type_apply] = STATE(6517),
    [sym__type_infix] = STATE(6518),
    [sym_type] = STATE(816),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8475),
    [sym__splice_dollars] = STATE(7260),
    [sym_splice] = STATE(6510),
    [sym_quasiquote] = STATE(6510),
    [sym_integer] = STATE(6338),
    [sym__plist] = STATE(6519),
    [sym_unit] = STATE(6510),
    [sym_unboxed_unit] = STATE(6510),
    [sym_prefix_tuple] = STATE(6510),
    [sym_prefix_unboxed_tuple] = STATE(6510),
    [sym_prefix_unboxed_sum] = STATE(6510),
    [sym_literal] = STATE(6510),
    [sym__qualified_type] = STATE(6245),
    [sym__qtyconid] = STATE(6520),
    [sym__tycon_arrow] = STATE(6520),
    [sym__qtycon_arrow] = STATE(6520),
    [sym__promoted_tycons_alias] = STATE(6510),
    [sym__promoted_tycons] = STATE(6510),
    [sym__tycon_ticked] = STATE(2609),
    [sym__qtycon_ticked] = STATE(2609),
    [sym__tyconids_ticked] = STATE(2609),
    [sym__promoted_tyconops_alias] = STATE(2609),
    [sym__promoted_tyconops] = STATE(2609),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2609),
    [sym__operator_alias] = STATE(2609),
    [sym__operator_minus] = STATE(2609),
    [sym__varsym_prefix] = STATE(6520),
    [sym__pvarsym] = STATE(6520),
    [sym__qualified_varsym] = STATE(2605),
    [sym__qvarsym_prefix] = STATE(6520),
    [sym__pqvarsym] = STATE(6520),
    [sym_constructor_operator] = STATE(2609),
    [sym__constructor_operator_alias] = STATE(2609),
    [sym__consym_prefix] = STATE(6520),
    [sym__pconsym] = STATE(6520),
    [sym__qualified_consym] = STATE(2603),
    [sym__qconsym_prefix] = STATE(6520),
    [sym__pqconsym] = STATE(6520),
    [sym__prefix_at] = STATE(2576),
    [sym__paren_open] = STATE(431),
    [sym__bracket_open] = STATE(1029),
    [sym__unboxed_open] = STATE(771),
    [sym_variable] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym__] = ACTIONS(2109),
    [anon_sym_SQUOTE] = ACTIONS(2109),
    [anon_sym_STAR] = ACTIONS(2111),
    [anon_sym_u2605] = ACTIONS(2111),
    [anon_sym_PIPE] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_deriving] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [sym_float] = ACTIONS(2111),
    [sym_char] = ACTIONS(2111),
    [sym_string] = ACTIONS(2111),
    [sym__integer_literal] = ACTIONS(2109),
    [sym__binary_literal] = ACTIONS(2111),
    [sym__octal_literal] = ACTIONS(2111),
    [sym__hex_literal] = ACTIONS(2111),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2111),
    [aux_sym__paren_open_token1] = ACTIONS(2111),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(2111),
    [sym__cond_layout_end] = ACTIONS(2111),
    [sym__cond_layout_end_explicit] = ACTIONS(2111),
    [sym__phantom_bar] = ACTIONS(2111),
    [sym__phantom_deriving] = ACTIONS(2111),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2111),
    [sym__cond_splice] = ACTIONS(2111),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(2111),
    [sym__cond_prefix_bang] = ACTIONS(2111),
    [sym__cond_tight_tilde] = ACTIONS(2111),
    [sym__cond_prefix_tilde] = ACTIONS(2111),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [749] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9271),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(5827),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10508),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9813),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2113),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2115),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2117),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2119),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [750] = {
    [sym__type_parens] = STATE(6512),
    [sym__type_tuple] = STATE(6513),
    [sym__type_unboxed_tuple] = STATE(6514),
    [sym__type_unboxed_sum] = STATE(6515),
    [sym__type_list] = STATE(6516),
    [sym__type_promoted] = STATE(6510),
    [sym__type_star] = STATE(6510),
    [sym__type_wildcard] = STATE(6510),
    [sym__at_type] = STATE(6537),
    [sym__type_apply] = STATE(6517),
    [sym__type_infix] = STATE(6518),
    [sym_type] = STATE(816),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8475),
    [sym__splice_dollars] = STATE(7260),
    [sym_splice] = STATE(6510),
    [sym_quasiquote] = STATE(6510),
    [sym_integer] = STATE(6338),
    [sym__plist] = STATE(6519),
    [sym_unit] = STATE(6510),
    [sym_unboxed_unit] = STATE(6510),
    [sym_prefix_tuple] = STATE(6510),
    [sym_prefix_unboxed_tuple] = STATE(6510),
    [sym_prefix_unboxed_sum] = STATE(6510),
    [sym_literal] = STATE(6510),
    [sym__qualified_type] = STATE(6245),
    [sym__qtyconid] = STATE(6520),
    [sym__tycon_arrow] = STATE(6520),
    [sym__qtycon_arrow] = STATE(6520),
    [sym__promoted_tycons_alias] = STATE(6510),
    [sym__promoted_tycons] = STATE(6510),
    [sym__tycon_ticked] = STATE(2609),
    [sym__qtycon_ticked] = STATE(2609),
    [sym__tyconids_ticked] = STATE(2609),
    [sym__promoted_tyconops_alias] = STATE(2609),
    [sym__promoted_tyconops] = STATE(2609),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2609),
    [sym__operator_alias] = STATE(2609),
    [sym__operator_minus] = STATE(2609),
    [sym__varsym_prefix] = STATE(6520),
    [sym__pvarsym] = STATE(6520),
    [sym__qualified_varsym] = STATE(2605),
    [sym__qvarsym_prefix] = STATE(6520),
    [sym__pqvarsym] = STATE(6520),
    [sym_constructor_operator] = STATE(2609),
    [sym__constructor_operator_alias] = STATE(2609),
    [sym__consym_prefix] = STATE(6520),
    [sym__pconsym] = STATE(6520),
    [sym__qualified_consym] = STATE(2603),
    [sym__qconsym_prefix] = STATE(6520),
    [sym__pqconsym] = STATE(6520),
    [sym__prefix_at] = STATE(2576),
    [sym__paren_open] = STATE(431),
    [sym__bracket_open] = STATE(1029),
    [sym__unboxed_open] = STATE(771),
    [sym_variable] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2125),
    [anon_sym_STAR] = ACTIONS(2127),
    [anon_sym_u2605] = ACTIONS(2129),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_deriving] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2131),
    [sym_char] = ACTIONS(2131),
    [sym_string] = ACTIONS(2131),
    [sym__integer_literal] = ACTIONS(2133),
    [sym__binary_literal] = ACTIONS(2135),
    [sym__octal_literal] = ACTIONS(2135),
    [sym__hex_literal] = ACTIONS(2135),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2137),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym__phantom_deriving] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2139),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1181),
    [sym__cond_prefix_bang] = ACTIONS(1181),
    [sym__cond_tight_tilde] = ACTIONS(1181),
    [sym__cond_prefix_tilde] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [751] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__at_type] = STATE(6393),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(791),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8417),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__tycon_ticked] = STATE(2442),
    [sym__qtycon_ticked] = STATE(2442),
    [sym__tyconids_ticked] = STATE(2442),
    [sym__promoted_tyconops_alias] = STATE(2442),
    [sym__promoted_tyconops] = STATE(2442),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2442),
    [sym__operator_alias] = STATE(2442),
    [sym__operator_minus] = STATE(2442),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qualified_varsym] = STATE(2441),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym_constructor_operator] = STATE(2442),
    [sym__constructor_operator_alias] = STATE(2442),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qualified_consym] = STATE(2428),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_at] = STATE(2660),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2057),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1157),
    [anon_sym_u22b8] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1157),
    [sym__cond_layout_end] = ACTIONS(1157),
    [sym__cond_layout_end_explicit] = ACTIONS(1157),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [752] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9189),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(6175),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10710),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9902),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2141),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2143),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2145),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2147),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [753] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9263),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(2715),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10335),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9837),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2149),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2151),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2153),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2081),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [754] = {
    [sym__type_parens] = STATE(6323),
    [sym__type_tuple] = STATE(6324),
    [sym__type_unboxed_tuple] = STATE(6325),
    [sym__type_unboxed_sum] = STATE(6326),
    [sym__type_list] = STATE(6327),
    [sym__type_promoted] = STATE(6321),
    [sym__type_star] = STATE(6321),
    [sym__type_wildcard] = STATE(6321),
    [sym__at_type] = STATE(6348),
    [sym__type_apply] = STATE(6328),
    [sym__type_infix] = STATE(6329),
    [sym_type] = STATE(809),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8496),
    [sym__splice_dollars] = STATE(7407),
    [sym_splice] = STATE(6321),
    [sym_quasiquote] = STATE(6321),
    [sym_integer] = STATE(6269),
    [sym__plist] = STATE(6330),
    [sym_unit] = STATE(6321),
    [sym_unboxed_unit] = STATE(6321),
    [sym_prefix_tuple] = STATE(6321),
    [sym_prefix_unboxed_tuple] = STATE(6321),
    [sym_prefix_unboxed_sum] = STATE(6321),
    [sym_literal] = STATE(6321),
    [sym__qualified_type] = STATE(6286),
    [sym__qtyconid] = STATE(6331),
    [sym__tycon_arrow] = STATE(6331),
    [sym__qtycon_arrow] = STATE(6331),
    [sym__promoted_tycons_alias] = STATE(6321),
    [sym__promoted_tycons] = STATE(6321),
    [sym__tycon_ticked] = STATE(2678),
    [sym__qtycon_ticked] = STATE(2678),
    [sym__tyconids_ticked] = STATE(2678),
    [sym__promoted_tyconops_alias] = STATE(2678),
    [sym__promoted_tyconops] = STATE(2678),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2678),
    [sym__operator_alias] = STATE(2678),
    [sym__operator_minus] = STATE(2678),
    [sym__varsym_prefix] = STATE(6331),
    [sym__pvarsym] = STATE(6331),
    [sym__qualified_varsym] = STATE(2680),
    [sym__qvarsym_prefix] = STATE(6331),
    [sym__pqvarsym] = STATE(6331),
    [sym_constructor_operator] = STATE(2678),
    [sym__constructor_operator_alias] = STATE(2678),
    [sym__consym_prefix] = STATE(6331),
    [sym__pconsym] = STATE(6331),
    [sym__qualified_consym] = STATE(2684),
    [sym__qconsym_prefix] = STATE(6331),
    [sym__pqconsym] = STATE(6331),
    [sym__prefix_at] = STATE(2544),
    [sym__paren_open] = STATE(469),
    [sym__bracket_open] = STATE(990),
    [sym__unboxed_open] = STATE(810),
    [sym_variable] = ACTIONS(2155),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym__] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2161),
    [anon_sym_u2605] = ACTIONS(2163),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2165),
    [sym_char] = ACTIONS(2165),
    [sym_string] = ACTIONS(2165),
    [sym__integer_literal] = ACTIONS(2167),
    [sym__binary_literal] = ACTIONS(2169),
    [sym__octal_literal] = ACTIONS(2169),
    [sym__hex_literal] = ACTIONS(2169),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2171),
    [anon_sym_u2192] = ACTIONS(1123),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1123),
    [anon_sym_u22b8] = ACTIONS(1123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1125),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1123),
    [sym__cond_layout_end] = ACTIONS(1123),
    [sym__cond_layout_end_explicit] = ACTIONS(1123),
    [sym__phantom_where] = ACTIONS(1123),
    [sym__phantom_arrow] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2173),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1123),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [755] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9318),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(6474),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10492),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9924),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2175),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2177),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2179),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [756] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__at_type] = STATE(6534),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(775),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8518),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__tycon_ticked] = STATE(2555),
    [sym__qtycon_ticked] = STATE(2555),
    [sym__tyconids_ticked] = STATE(2555),
    [sym__promoted_tyconops_alias] = STATE(2555),
    [sym__promoted_tyconops] = STATE(2555),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2555),
    [sym__operator_alias] = STATE(2555),
    [sym__operator_minus] = STATE(2555),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qualified_varsym] = STATE(2573),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym_constructor_operator] = STATE(2555),
    [sym__constructor_operator_alias] = STATE(2555),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qualified_consym] = STATE(2582),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_at] = STATE(2538),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(2027),
    [anon_sym_STAR] = ACTIONS(2029),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [anon_sym_PIPE2] = ACTIONS(1181),
    [sym_name] = ACTIONS(2031),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [757] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9204),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(6837),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10731),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(10003),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2183),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2185),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2187),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2189),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [758] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__at_type] = STATE(6534),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(775),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8518),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__tycon_ticked] = STATE(2555),
    [sym__qtycon_ticked] = STATE(2555),
    [sym__tyconids_ticked] = STATE(2555),
    [sym__promoted_tyconops_alias] = STATE(2555),
    [sym__promoted_tyconops] = STATE(2555),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2555),
    [sym__operator_alias] = STATE(2555),
    [sym__operator_minus] = STATE(2555),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qualified_varsym] = STATE(2573),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym_constructor_operator] = STATE(2555),
    [sym__constructor_operator_alias] = STATE(2555),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qualified_consym] = STATE(2582),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_at] = STATE(2538),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(2027),
    [anon_sym_STAR] = ACTIONS(2029),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [anon_sym_PIPE2] = ACTIONS(1181),
    [sym_name] = ACTIONS(2031),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [759] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9576),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(4574),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(916),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(867),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2191),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(2193),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_PIPE2] = ACTIONS(2195),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2197),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [760] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9653),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(4120),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(919),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(846),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2199),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(2201),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_PIPE2] = ACTIONS(2203),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2023),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [761] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9593),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(4295),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(894),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(861),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2205),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_PIPE2] = ACTIONS(2209),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2211),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [762] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9222),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(6202),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10626),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9991),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(833),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2213),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2215),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(839),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [763] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9459),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(7609),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10868),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9873),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2217),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2219),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2221),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2223),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [764] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9509),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(3090),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10340),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9970),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2225),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2227),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2229),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2231),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [765] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9178),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(2786),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10324),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9965),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2233),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2237),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2239),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [766] = {
    [sym__type_parens] = STATE(6323),
    [sym__type_tuple] = STATE(6324),
    [sym__type_unboxed_tuple] = STATE(6325),
    [sym__type_unboxed_sum] = STATE(6326),
    [sym__type_list] = STATE(6327),
    [sym__type_promoted] = STATE(6321),
    [sym__type_star] = STATE(6321),
    [sym__type_wildcard] = STATE(6321),
    [sym__at_type] = STATE(6348),
    [sym__type_apply] = STATE(6328),
    [sym__type_infix] = STATE(6329),
    [sym_type] = STATE(809),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8496),
    [sym__splice_dollars] = STATE(7407),
    [sym_splice] = STATE(6321),
    [sym_quasiquote] = STATE(6321),
    [sym_integer] = STATE(6269),
    [sym__plist] = STATE(6330),
    [sym_unit] = STATE(6321),
    [sym_unboxed_unit] = STATE(6321),
    [sym_prefix_tuple] = STATE(6321),
    [sym_prefix_unboxed_tuple] = STATE(6321),
    [sym_prefix_unboxed_sum] = STATE(6321),
    [sym_literal] = STATE(6321),
    [sym__qualified_type] = STATE(6286),
    [sym__qtyconid] = STATE(6331),
    [sym__tycon_arrow] = STATE(6331),
    [sym__qtycon_arrow] = STATE(6331),
    [sym__promoted_tycons_alias] = STATE(6321),
    [sym__promoted_tycons] = STATE(6321),
    [sym__tycon_ticked] = STATE(2678),
    [sym__qtycon_ticked] = STATE(2678),
    [sym__tyconids_ticked] = STATE(2678),
    [sym__promoted_tyconops_alias] = STATE(2678),
    [sym__promoted_tyconops] = STATE(2678),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2678),
    [sym__operator_alias] = STATE(2678),
    [sym__operator_minus] = STATE(2678),
    [sym__varsym_prefix] = STATE(6331),
    [sym__pvarsym] = STATE(6331),
    [sym__qualified_varsym] = STATE(2680),
    [sym__qvarsym_prefix] = STATE(6331),
    [sym__pqvarsym] = STATE(6331),
    [sym_constructor_operator] = STATE(2678),
    [sym__constructor_operator_alias] = STATE(2678),
    [sym__consym_prefix] = STATE(6331),
    [sym__pconsym] = STATE(6331),
    [sym__qualified_consym] = STATE(2684),
    [sym__qconsym_prefix] = STATE(6331),
    [sym__pqconsym] = STATE(6331),
    [sym__prefix_at] = STATE(2544),
    [sym__paren_open] = STATE(469),
    [sym__bracket_open] = STATE(990),
    [sym__unboxed_open] = STATE(810),
    [sym_variable] = ACTIONS(2155),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2161),
    [anon_sym_u2605] = ACTIONS(2163),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2165),
    [sym_char] = ACTIONS(2165),
    [sym_string] = ACTIONS(2165),
    [sym__integer_literal] = ACTIONS(2167),
    [sym__binary_literal] = ACTIONS(2169),
    [sym__octal_literal] = ACTIONS(2169),
    [sym__hex_literal] = ACTIONS(2169),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2171),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1157),
    [anon_sym_u22b8] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1159),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1157),
    [sym__cond_layout_end] = ACTIONS(1157),
    [sym__cond_layout_end_explicit] = ACTIONS(1157),
    [sym__phantom_where] = ACTIONS(1157),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2173),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [767] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__at_type] = STATE(6534),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(775),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8518),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__tycon_ticked] = STATE(2555),
    [sym__qtycon_ticked] = STATE(2555),
    [sym__tyconids_ticked] = STATE(2555),
    [sym__promoted_tyconops_alias] = STATE(2555),
    [sym__promoted_tyconops] = STATE(2555),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2555),
    [sym__operator_alias] = STATE(2555),
    [sym__operator_minus] = STATE(2555),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qualified_varsym] = STATE(2573),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym_constructor_operator] = STATE(2555),
    [sym__constructor_operator_alias] = STATE(2555),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qualified_consym] = STATE(2582),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_at] = STATE(2538),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1177),
    [anon_sym_PIPE2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1179),
    [anon_sym_u22b8] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_POUND_RPAREN] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_prefix_percent] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [768] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9502),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(3750),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10470),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9966),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2241),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2243),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2245),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2247),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [769] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9254),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(6249),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10028),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9842),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2249),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2251),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2253),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2255),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [770] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9337),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(7533),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10422),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9810),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2257),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2259),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2261),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2263),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [771] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9475),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(6407),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10586),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9798),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2265),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2269),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2271),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [772] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9288),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(3533),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10448),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(10005),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2273),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2275),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2277),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2279),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [773] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__at_type] = STATE(6534),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(775),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8518),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__tycon_ticked] = STATE(2555),
    [sym__qtycon_ticked] = STATE(2555),
    [sym__tyconids_ticked] = STATE(2555),
    [sym__promoted_tyconops_alias] = STATE(2555),
    [sym__promoted_tyconops] = STATE(2555),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2555),
    [sym__operator_alias] = STATE(2555),
    [sym__operator_minus] = STATE(2555),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qualified_varsym] = STATE(2573),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym_constructor_operator] = STATE(2555),
    [sym__constructor_operator_alias] = STATE(2555),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qualified_consym] = STATE(2582),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_at] = STATE(2538),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(2027),
    [anon_sym_STAR] = ACTIONS(2029),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1147),
    [anon_sym_PIPE2] = ACTIONS(1123),
    [sym_name] = ACTIONS(2031),
    [anon_sym_u2192] = ACTIONS(1123),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1123),
    [anon_sym_u22b8] = ACTIONS(1123),
    [anon_sym_COLON_COLON] = ACTIONS(1123),
    [anon_sym_u2237] = ACTIONS(1123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(1123),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1123),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [774] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9693),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(4975),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(893),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(860),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2281),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(2283),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_PIPE2] = ACTIONS(2285),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2287),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [775] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__at_type] = STATE(6534),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(775),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8518),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__tycon_ticked] = STATE(2555),
    [sym__qtycon_ticked] = STATE(2555),
    [sym__tyconids_ticked] = STATE(2555),
    [sym__promoted_tyconops_alias] = STATE(2555),
    [sym__promoted_tyconops] = STATE(2555),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2555),
    [sym__operator_alias] = STATE(2555),
    [sym__operator_minus] = STATE(2555),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qualified_varsym] = STATE(2573),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym_constructor_operator] = STATE(2555),
    [sym__constructor_operator_alias] = STATE(2555),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qualified_consym] = STATE(2582),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_at] = STATE(2538),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1117),
    [anon_sym_PIPE2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1119),
    [anon_sym_u22b8] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [anon_sym_POUND_RPAREN] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_prefix_percent] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [776] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10295),
    [sym__assoc_tyfam] = STATE(10138),
    [sym__assoc_tyinst] = STATE(10139),
    [sym__assoc_datafam] = STATE(10141),
    [sym_default_signature] = STATE(10146),
    [sym_class_decl] = STATE(10736),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10146),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10146),
    [sym__local_decl] = STATE(10146),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_data] = ACTIONS(1935),
    [anon_sym_default] = ACTIONS(1937),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(2289),
    [sym__cond_layout_end_explicit] = ACTIONS(2289),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [777] = {
    [sym__type_parens] = STATE(6363),
    [sym__type_tuple] = STATE(6337),
    [sym__type_unboxed_tuple] = STATE(6351),
    [sym__type_unboxed_sum] = STATE(6350),
    [sym__type_list] = STATE(6349),
    [sym__type_promoted] = STATE(6364),
    [sym__type_star] = STATE(6364),
    [sym__type_wildcard] = STATE(6364),
    [sym__at_type] = STATE(6316),
    [sym__type_apply] = STATE(6347),
    [sym__type_infix] = STATE(6346),
    [sym_type] = STATE(821),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8548),
    [sym__splice_dollars] = STATE(7313),
    [sym_splice] = STATE(6364),
    [sym_quasiquote] = STATE(6364),
    [sym_integer] = STATE(6231),
    [sym__plist] = STATE(6345),
    [sym_unit] = STATE(6364),
    [sym_unboxed_unit] = STATE(6364),
    [sym_prefix_tuple] = STATE(6364),
    [sym_prefix_unboxed_tuple] = STATE(6364),
    [sym_prefix_unboxed_sum] = STATE(6364),
    [sym_literal] = STATE(6364),
    [sym__qualified_type] = STATE(6444),
    [sym__qtyconid] = STATE(6341),
    [sym__tycon_arrow] = STATE(6341),
    [sym__qtycon_arrow] = STATE(6341),
    [sym__promoted_tycons_alias] = STATE(6364),
    [sym__promoted_tycons] = STATE(6364),
    [sym__tycon_ticked] = STATE(2641),
    [sym__qtycon_ticked] = STATE(2641),
    [sym__tyconids_ticked] = STATE(2641),
    [sym__promoted_tyconops_alias] = STATE(2641),
    [sym__promoted_tyconops] = STATE(2641),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2641),
    [sym__operator_alias] = STATE(2641),
    [sym__operator_minus] = STATE(2641),
    [sym__varsym_prefix] = STATE(6341),
    [sym__pvarsym] = STATE(6341),
    [sym__qualified_varsym] = STATE(2643),
    [sym__qvarsym_prefix] = STATE(6341),
    [sym__pqvarsym] = STATE(6341),
    [sym_constructor_operator] = STATE(2641),
    [sym__constructor_operator_alias] = STATE(2641),
    [sym__consym_prefix] = STATE(6341),
    [sym__pconsym] = STATE(6341),
    [sym__qualified_consym] = STATE(2646),
    [sym__qconsym_prefix] = STATE(6341),
    [sym__pqconsym] = STATE(6341),
    [sym__prefix_at] = STATE(2437),
    [sym__paren_open] = STATE(442),
    [sym__bracket_open] = STATE(962),
    [sym__unboxed_open] = STATE(762),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__paren_close_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_tight_bang] = ACTIONS(1179),
    [sym__cond_prefix_bang] = ACTIONS(1179),
    [sym__cond_tight_tilde] = ACTIONS(1179),
    [sym__cond_prefix_tilde] = ACTIONS(1179),
    [sym__cond_qualified_op] = ACTIONS(1179),
    [sym__cond_no_section_op] = ACTIONS(1179),
    [sym__cond_minus] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [778] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9250),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(4295),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10571),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9753),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2291),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2295),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2211),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [779] = {
    [sym__type_parens] = STATE(6512),
    [sym__type_tuple] = STATE(6513),
    [sym__type_unboxed_tuple] = STATE(6514),
    [sym__type_unboxed_sum] = STATE(6515),
    [sym__type_list] = STATE(6516),
    [sym__type_promoted] = STATE(6510),
    [sym__type_star] = STATE(6510),
    [sym__type_wildcard] = STATE(6510),
    [sym__at_type] = STATE(6537),
    [sym__type_apply] = STATE(6517),
    [sym__type_infix] = STATE(6518),
    [sym_type] = STATE(816),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8475),
    [sym__splice_dollars] = STATE(7260),
    [sym_splice] = STATE(6510),
    [sym_quasiquote] = STATE(6510),
    [sym_integer] = STATE(6338),
    [sym__plist] = STATE(6519),
    [sym_unit] = STATE(6510),
    [sym_unboxed_unit] = STATE(6510),
    [sym_prefix_tuple] = STATE(6510),
    [sym_prefix_unboxed_tuple] = STATE(6510),
    [sym_prefix_unboxed_sum] = STATE(6510),
    [sym_literal] = STATE(6510),
    [sym__qualified_type] = STATE(6245),
    [sym__qtyconid] = STATE(6520),
    [sym__tycon_arrow] = STATE(6520),
    [sym__qtycon_arrow] = STATE(6520),
    [sym__promoted_tycons_alias] = STATE(6510),
    [sym__promoted_tycons] = STATE(6510),
    [sym__tycon_ticked] = STATE(2609),
    [sym__qtycon_ticked] = STATE(2609),
    [sym__tyconids_ticked] = STATE(2609),
    [sym__promoted_tyconops_alias] = STATE(2609),
    [sym__promoted_tyconops] = STATE(2609),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2609),
    [sym__operator_alias] = STATE(2609),
    [sym__operator_minus] = STATE(2609),
    [sym__varsym_prefix] = STATE(6520),
    [sym__pvarsym] = STATE(6520),
    [sym__qualified_varsym] = STATE(2605),
    [sym__qvarsym_prefix] = STATE(6520),
    [sym__pqvarsym] = STATE(6520),
    [sym_constructor_operator] = STATE(2609),
    [sym__constructor_operator_alias] = STATE(2609),
    [sym__consym_prefix] = STATE(6520),
    [sym__pconsym] = STATE(6520),
    [sym__qualified_consym] = STATE(2603),
    [sym__qconsym_prefix] = STATE(6520),
    [sym__pqconsym] = STATE(6520),
    [sym__prefix_at] = STATE(2576),
    [sym__paren_open] = STATE(431),
    [sym__bracket_open] = STATE(1029),
    [sym__unboxed_open] = STATE(771),
    [sym_variable] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2125),
    [anon_sym_STAR] = ACTIONS(2127),
    [anon_sym_u2605] = ACTIONS(2129),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_deriving] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2131),
    [sym_char] = ACTIONS(2131),
    [sym_string] = ACTIONS(2131),
    [sym__integer_literal] = ACTIONS(2133),
    [sym__binary_literal] = ACTIONS(2135),
    [sym__octal_literal] = ACTIONS(2135),
    [sym__hex_literal] = ACTIONS(2135),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2137),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1157),
    [sym__cond_layout_end] = ACTIONS(1157),
    [sym__cond_layout_end_explicit] = ACTIONS(1157),
    [sym__phantom_bar] = ACTIONS(1157),
    [sym__phantom_deriving] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2139),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1157),
    [sym__cond_prefix_bang] = ACTIONS(1157),
    [sym__cond_tight_tilde] = ACTIONS(1157),
    [sym__cond_prefix_tilde] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [780] = {
    [sym__type_parens] = STATE(6323),
    [sym__type_tuple] = STATE(6324),
    [sym__type_unboxed_tuple] = STATE(6325),
    [sym__type_unboxed_sum] = STATE(6326),
    [sym__type_list] = STATE(6327),
    [sym__type_promoted] = STATE(6321),
    [sym__type_star] = STATE(6321),
    [sym__type_wildcard] = STATE(6321),
    [sym__at_type] = STATE(6348),
    [sym__type_apply] = STATE(6328),
    [sym__type_infix] = STATE(6329),
    [sym_type] = STATE(809),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8496),
    [sym__splice_dollars] = STATE(7407),
    [sym_splice] = STATE(6321),
    [sym_quasiquote] = STATE(6321),
    [sym_integer] = STATE(6269),
    [sym__plist] = STATE(6330),
    [sym_unit] = STATE(6321),
    [sym_unboxed_unit] = STATE(6321),
    [sym_prefix_tuple] = STATE(6321),
    [sym_prefix_unboxed_tuple] = STATE(6321),
    [sym_prefix_unboxed_sum] = STATE(6321),
    [sym_literal] = STATE(6321),
    [sym__qualified_type] = STATE(6286),
    [sym__qtyconid] = STATE(6331),
    [sym__tycon_arrow] = STATE(6331),
    [sym__qtycon_arrow] = STATE(6331),
    [sym__promoted_tycons_alias] = STATE(6321),
    [sym__promoted_tycons] = STATE(6321),
    [sym__tycon_ticked] = STATE(2678),
    [sym__qtycon_ticked] = STATE(2678),
    [sym__tyconids_ticked] = STATE(2678),
    [sym__promoted_tyconops_alias] = STATE(2678),
    [sym__promoted_tyconops] = STATE(2678),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2678),
    [sym__operator_alias] = STATE(2678),
    [sym__operator_minus] = STATE(2678),
    [sym__varsym_prefix] = STATE(6331),
    [sym__pvarsym] = STATE(6331),
    [sym__qualified_varsym] = STATE(2680),
    [sym__qvarsym_prefix] = STATE(6331),
    [sym__pqvarsym] = STATE(6331),
    [sym_constructor_operator] = STATE(2678),
    [sym__constructor_operator_alias] = STATE(2678),
    [sym__consym_prefix] = STATE(6331),
    [sym__pconsym] = STATE(6331),
    [sym__qualified_consym] = STATE(2684),
    [sym__qconsym_prefix] = STATE(6331),
    [sym__pqconsym] = STATE(6331),
    [sym__prefix_at] = STATE(2544),
    [sym__paren_open] = STATE(469),
    [sym__bracket_open] = STATE(990),
    [sym__unboxed_open] = STATE(810),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1179),
    [anon_sym_u22b8] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(1177),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym__phantom_where] = ACTIONS(1179),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_prefix_percent] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [781] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9230),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(3230),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10427),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9866),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2297),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2299),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2301),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2303),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [782] = {
    [sym__type_parens] = STATE(6282),
    [sym__type_tuple] = STATE(6281),
    [sym__type_unboxed_tuple] = STATE(6280),
    [sym__type_unboxed_sum] = STATE(6279),
    [sym__type_list] = STATE(6278),
    [sym__type_promoted] = STATE(6283),
    [sym__type_star] = STATE(6283),
    [sym__type_wildcard] = STATE(6283),
    [sym__at_type] = STATE(6261),
    [sym__type_apply] = STATE(6277),
    [sym__type_infix] = STATE(6276),
    [sym_type] = STATE(830),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8442),
    [sym__splice_dollars] = STATE(7421),
    [sym_splice] = STATE(6283),
    [sym_quasiquote] = STATE(6283),
    [sym_integer] = STATE(6535),
    [sym__plist] = STATE(6275),
    [sym_unit] = STATE(6283),
    [sym_unboxed_unit] = STATE(6283),
    [sym_prefix_tuple] = STATE(6283),
    [sym_prefix_unboxed_tuple] = STATE(6283),
    [sym_prefix_unboxed_sum] = STATE(6283),
    [sym_literal] = STATE(6283),
    [sym__qualified_type] = STATE(6310),
    [sym__qtyconid] = STATE(6273),
    [sym__tycon_arrow] = STATE(6273),
    [sym__qtycon_arrow] = STATE(6273),
    [sym__promoted_tycons_alias] = STATE(6283),
    [sym__promoted_tycons] = STATE(6283),
    [sym__tycon_ticked] = STATE(2517),
    [sym__qtycon_ticked] = STATE(2517),
    [sym__tyconids_ticked] = STATE(2517),
    [sym__promoted_tyconops_alias] = STATE(2517),
    [sym__promoted_tyconops] = STATE(2517),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2517),
    [sym__operator_alias] = STATE(2517),
    [sym__operator_minus] = STATE(2517),
    [sym__varsym_prefix] = STATE(6273),
    [sym__pvarsym] = STATE(6273),
    [sym__qualified_varsym] = STATE(2514),
    [sym__qvarsym_prefix] = STATE(6273),
    [sym__pqvarsym] = STATE(6273),
    [sym_constructor_operator] = STATE(2517),
    [sym__constructor_operator_alias] = STATE(2517),
    [sym__consym_prefix] = STATE(6273),
    [sym__pconsym] = STATE(6273),
    [sym__qualified_consym] = STATE(2513),
    [sym__qconsym_prefix] = STATE(6273),
    [sym__pqconsym] = STATE(6273),
    [sym__prefix_at] = STATE(2610),
    [sym__paren_open] = STATE(429),
    [sym__bracket_open] = STATE(1061),
    [sym__unboxed_open] = STATE(755),
    [sym_variable] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(2307),
    [anon_sym_SQUOTE] = ACTIONS(2309),
    [anon_sym_STAR] = ACTIONS(2311),
    [anon_sym_u2605] = ACTIONS(2313),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_deriving] = ACTIONS(1183),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym__integer_literal] = ACTIONS(2317),
    [sym__binary_literal] = ACTIONS(2319),
    [sym__octal_literal] = ACTIONS(2319),
    [sym__hex_literal] = ACTIONS(2319),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2321),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym__phantom_deriving] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2323),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [783] = {
    [sym__type_parens] = STATE(6512),
    [sym__type_tuple] = STATE(6513),
    [sym__type_unboxed_tuple] = STATE(6514),
    [sym__type_unboxed_sum] = STATE(6515),
    [sym__type_list] = STATE(6516),
    [sym__type_promoted] = STATE(6510),
    [sym__type_star] = STATE(6510),
    [sym__type_wildcard] = STATE(6510),
    [sym__at_type] = STATE(6537),
    [sym__type_apply] = STATE(6517),
    [sym__type_infix] = STATE(6518),
    [sym_type] = STATE(816),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8475),
    [sym__splice_dollars] = STATE(7260),
    [sym_splice] = STATE(6510),
    [sym_quasiquote] = STATE(6510),
    [sym_integer] = STATE(6338),
    [sym__plist] = STATE(6519),
    [sym_unit] = STATE(6510),
    [sym_unboxed_unit] = STATE(6510),
    [sym_prefix_tuple] = STATE(6510),
    [sym_prefix_unboxed_tuple] = STATE(6510),
    [sym_prefix_unboxed_sum] = STATE(6510),
    [sym_literal] = STATE(6510),
    [sym__qualified_type] = STATE(6245),
    [sym__qtyconid] = STATE(6520),
    [sym__tycon_arrow] = STATE(6520),
    [sym__qtycon_arrow] = STATE(6520),
    [sym__promoted_tycons_alias] = STATE(6510),
    [sym__promoted_tycons] = STATE(6510),
    [sym__tycon_ticked] = STATE(2609),
    [sym__qtycon_ticked] = STATE(2609),
    [sym__tyconids_ticked] = STATE(2609),
    [sym__promoted_tyconops_alias] = STATE(2609),
    [sym__promoted_tyconops] = STATE(2609),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2609),
    [sym__operator_alias] = STATE(2609),
    [sym__operator_minus] = STATE(2609),
    [sym__varsym_prefix] = STATE(6520),
    [sym__pvarsym] = STATE(6520),
    [sym__qualified_varsym] = STATE(2605),
    [sym__qvarsym_prefix] = STATE(6520),
    [sym__pqvarsym] = STATE(6520),
    [sym_constructor_operator] = STATE(2609),
    [sym__constructor_operator_alias] = STATE(2609),
    [sym__consym_prefix] = STATE(6520),
    [sym__pconsym] = STATE(6520),
    [sym__qualified_consym] = STATE(2603),
    [sym__qconsym_prefix] = STATE(6520),
    [sym__pqconsym] = STATE(6520),
    [sym__prefix_at] = STATE(2576),
    [sym__paren_open] = STATE(431),
    [sym__bracket_open] = STATE(1029),
    [sym__unboxed_open] = STATE(771),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_deriving] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym__phantom_bar] = ACTIONS(1179),
    [sym__phantom_deriving] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_tight_bang] = ACTIONS(1179),
    [sym__cond_prefix_bang] = ACTIONS(1179),
    [sym__cond_tight_tilde] = ACTIONS(1179),
    [sym__cond_prefix_tilde] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [784] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9516),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(4693),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10559),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9734),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2325),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2327),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2329),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2331),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [785] = {
    [sym__type_parens] = STATE(6282),
    [sym__type_tuple] = STATE(6281),
    [sym__type_unboxed_tuple] = STATE(6280),
    [sym__type_unboxed_sum] = STATE(6279),
    [sym__type_list] = STATE(6278),
    [sym__type_promoted] = STATE(6283),
    [sym__type_star] = STATE(6283),
    [sym__type_wildcard] = STATE(6283),
    [sym__at_type] = STATE(6261),
    [sym__type_apply] = STATE(6277),
    [sym__type_infix] = STATE(6276),
    [sym_type] = STATE(830),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8442),
    [sym__splice_dollars] = STATE(7421),
    [sym_splice] = STATE(6283),
    [sym_quasiquote] = STATE(6283),
    [sym_integer] = STATE(6535),
    [sym__plist] = STATE(6275),
    [sym_unit] = STATE(6283),
    [sym_unboxed_unit] = STATE(6283),
    [sym_prefix_tuple] = STATE(6283),
    [sym_prefix_unboxed_tuple] = STATE(6283),
    [sym_prefix_unboxed_sum] = STATE(6283),
    [sym_literal] = STATE(6283),
    [sym__qualified_type] = STATE(6310),
    [sym__qtyconid] = STATE(6273),
    [sym__tycon_arrow] = STATE(6273),
    [sym__qtycon_arrow] = STATE(6273),
    [sym__promoted_tycons_alias] = STATE(6283),
    [sym__promoted_tycons] = STATE(6283),
    [sym__tycon_ticked] = STATE(2517),
    [sym__qtycon_ticked] = STATE(2517),
    [sym__tyconids_ticked] = STATE(2517),
    [sym__promoted_tyconops_alias] = STATE(2517),
    [sym__promoted_tyconops] = STATE(2517),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2517),
    [sym__operator_alias] = STATE(2517),
    [sym__operator_minus] = STATE(2517),
    [sym__varsym_prefix] = STATE(6273),
    [sym__pvarsym] = STATE(6273),
    [sym__qualified_varsym] = STATE(2514),
    [sym__qvarsym_prefix] = STATE(6273),
    [sym__pqvarsym] = STATE(6273),
    [sym_constructor_operator] = STATE(2517),
    [sym__constructor_operator_alias] = STATE(2517),
    [sym__consym_prefix] = STATE(6273),
    [sym__pconsym] = STATE(6273),
    [sym__qualified_consym] = STATE(2513),
    [sym__qconsym_prefix] = STATE(6273),
    [sym__pqconsym] = STATE(6273),
    [sym__prefix_at] = STATE(2610),
    [sym__paren_open] = STATE(429),
    [sym__bracket_open] = STATE(1061),
    [sym__unboxed_open] = STATE(755),
    [sym_variable] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(2307),
    [anon_sym_SQUOTE] = ACTIONS(2309),
    [anon_sym_STAR] = ACTIONS(2311),
    [anon_sym_u2605] = ACTIONS(2313),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_deriving] = ACTIONS(1183),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym__integer_literal] = ACTIONS(2317),
    [sym__binary_literal] = ACTIONS(2319),
    [sym__octal_literal] = ACTIONS(2319),
    [sym__hex_literal] = ACTIONS(2319),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2321),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym__phantom_deriving] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2323),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [786] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9536),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(7363),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10607),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9895),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2333),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2335),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2337),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2339),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [787] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9312),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(4179),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10680),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9768),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2341),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2343),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2345),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2347),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [788] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9244),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(5971),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10752),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9985),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2349),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2351),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2353),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2355),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [789] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9174),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(6725),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10398),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9720),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2357),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2361),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2363),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [790] = {
    [sym__type_parens] = STATE(6282),
    [sym__type_tuple] = STATE(6281),
    [sym__type_unboxed_tuple] = STATE(6280),
    [sym__type_unboxed_sum] = STATE(6279),
    [sym__type_list] = STATE(6278),
    [sym__type_promoted] = STATE(6283),
    [sym__type_star] = STATE(6283),
    [sym__type_wildcard] = STATE(6283),
    [sym__at_type] = STATE(6261),
    [sym__type_apply] = STATE(6277),
    [sym__type_infix] = STATE(6276),
    [sym_type] = STATE(830),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8442),
    [sym__splice_dollars] = STATE(7421),
    [sym_splice] = STATE(6283),
    [sym_quasiquote] = STATE(6283),
    [sym_integer] = STATE(6535),
    [sym__plist] = STATE(6275),
    [sym_unit] = STATE(6283),
    [sym_unboxed_unit] = STATE(6283),
    [sym_prefix_tuple] = STATE(6283),
    [sym_prefix_unboxed_tuple] = STATE(6283),
    [sym_prefix_unboxed_sum] = STATE(6283),
    [sym_literal] = STATE(6283),
    [sym__qualified_type] = STATE(6310),
    [sym__qtyconid] = STATE(6273),
    [sym__tycon_arrow] = STATE(6273),
    [sym__qtycon_arrow] = STATE(6273),
    [sym__promoted_tycons_alias] = STATE(6283),
    [sym__promoted_tycons] = STATE(6283),
    [sym__tycon_ticked] = STATE(2517),
    [sym__qtycon_ticked] = STATE(2517),
    [sym__tyconids_ticked] = STATE(2517),
    [sym__promoted_tyconops_alias] = STATE(2517),
    [sym__promoted_tyconops] = STATE(2517),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2517),
    [sym__operator_alias] = STATE(2517),
    [sym__operator_minus] = STATE(2517),
    [sym__varsym_prefix] = STATE(6273),
    [sym__pvarsym] = STATE(6273),
    [sym__qualified_varsym] = STATE(2514),
    [sym__qvarsym_prefix] = STATE(6273),
    [sym__pqvarsym] = STATE(6273),
    [sym_constructor_operator] = STATE(2517),
    [sym__constructor_operator_alias] = STATE(2517),
    [sym__consym_prefix] = STATE(6273),
    [sym__pconsym] = STATE(6273),
    [sym__qualified_consym] = STATE(2513),
    [sym__qconsym_prefix] = STATE(6273),
    [sym__pqconsym] = STATE(6273),
    [sym__prefix_at] = STATE(2610),
    [sym__paren_open] = STATE(429),
    [sym__bracket_open] = STATE(1061),
    [sym__unboxed_open] = STATE(755),
    [sym_variable] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(2307),
    [anon_sym_SQUOTE] = ACTIONS(2309),
    [anon_sym_STAR] = ACTIONS(2311),
    [anon_sym_u2605] = ACTIONS(2313),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_deriving] = ACTIONS(1159),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym__integer_literal] = ACTIONS(2317),
    [sym__binary_literal] = ACTIONS(2319),
    [sym__octal_literal] = ACTIONS(2319),
    [sym__hex_literal] = ACTIONS(2319),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2321),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1157),
    [anon_sym_u22b8] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1157),
    [sym__cond_layout_end] = ACTIONS(1157),
    [sym__cond_layout_end_explicit] = ACTIONS(1157),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym__phantom_deriving] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2323),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [791] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__at_type] = STATE(6393),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(791),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8417),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__tycon_ticked] = STATE(2442),
    [sym__qtycon_ticked] = STATE(2442),
    [sym__tyconids_ticked] = STATE(2442),
    [sym__promoted_tyconops_alias] = STATE(2442),
    [sym__promoted_tyconops] = STATE(2442),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2442),
    [sym__operator_alias] = STATE(2442),
    [sym__operator_minus] = STATE(2442),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qualified_varsym] = STATE(2441),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym_constructor_operator] = STATE(2442),
    [sym__constructor_operator_alias] = STATE(2442),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qualified_consym] = STATE(2428),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_at] = STATE(2660),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1119),
    [anon_sym_u22b8] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1119),
    [sym__cond_layout_end] = ACTIONS(1119),
    [sym__cond_layout_end_explicit] = ACTIONS(1119),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_prefix_percent] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [792] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9227),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(3224),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10327),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9974),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2365),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2367),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2369),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2371),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [793] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9161),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(6877),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10516),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9736),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2373),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2375),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2377),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2379),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [794] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9508),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(3842),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10188),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9946),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2381),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2383),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2385),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2387),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [795] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9144),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(5901),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10661),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9900),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2389),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2391),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2393),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2395),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [796] = {
    [sym__type_parens] = STATE(6282),
    [sym__type_tuple] = STATE(6281),
    [sym__type_unboxed_tuple] = STATE(6280),
    [sym__type_unboxed_sum] = STATE(6279),
    [sym__type_list] = STATE(6278),
    [sym__type_promoted] = STATE(6283),
    [sym__type_star] = STATE(6283),
    [sym__type_wildcard] = STATE(6283),
    [sym__at_type] = STATE(6261),
    [sym__type_apply] = STATE(6277),
    [sym__type_infix] = STATE(6276),
    [sym_type] = STATE(830),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8442),
    [sym__splice_dollars] = STATE(7421),
    [sym_splice] = STATE(6283),
    [sym_quasiquote] = STATE(6283),
    [sym_integer] = STATE(6535),
    [sym__plist] = STATE(6275),
    [sym_unit] = STATE(6283),
    [sym_unboxed_unit] = STATE(6283),
    [sym_prefix_tuple] = STATE(6283),
    [sym_prefix_unboxed_tuple] = STATE(6283),
    [sym_prefix_unboxed_sum] = STATE(6283),
    [sym_literal] = STATE(6283),
    [sym__qualified_type] = STATE(6310),
    [sym__qtyconid] = STATE(6273),
    [sym__tycon_arrow] = STATE(6273),
    [sym__qtycon_arrow] = STATE(6273),
    [sym__promoted_tycons_alias] = STATE(6283),
    [sym__promoted_tycons] = STATE(6283),
    [sym__tycon_ticked] = STATE(2517),
    [sym__qtycon_ticked] = STATE(2517),
    [sym__tyconids_ticked] = STATE(2517),
    [sym__promoted_tyconops_alias] = STATE(2517),
    [sym__promoted_tyconops] = STATE(2517),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2517),
    [sym__operator_alias] = STATE(2517),
    [sym__operator_minus] = STATE(2517),
    [sym__varsym_prefix] = STATE(6273),
    [sym__pvarsym] = STATE(6273),
    [sym__qualified_varsym] = STATE(2514),
    [sym__qvarsym_prefix] = STATE(6273),
    [sym__pqvarsym] = STATE(6273),
    [sym_constructor_operator] = STATE(2517),
    [sym__constructor_operator_alias] = STATE(2517),
    [sym__consym_prefix] = STATE(6273),
    [sym__pconsym] = STATE(6273),
    [sym__qualified_consym] = STATE(2513),
    [sym__qconsym_prefix] = STATE(6273),
    [sym__pqconsym] = STATE(6273),
    [sym__prefix_at] = STATE(2610),
    [sym__paren_open] = STATE(429),
    [sym__bracket_open] = STATE(1061),
    [sym__unboxed_open] = STATE(755),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_deriving] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1179),
    [anon_sym_u22b8] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym__phantom_deriving] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_prefix_percent] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [797] = {
    [sym__type_parens] = STATE(6512),
    [sym__type_tuple] = STATE(6513),
    [sym__type_unboxed_tuple] = STATE(6514),
    [sym__type_unboxed_sum] = STATE(6515),
    [sym__type_list] = STATE(6516),
    [sym__type_promoted] = STATE(6510),
    [sym__type_star] = STATE(6510),
    [sym__type_wildcard] = STATE(6510),
    [sym__at_type] = STATE(6537),
    [sym__type_apply] = STATE(6517),
    [sym__type_infix] = STATE(6518),
    [sym_type] = STATE(816),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8475),
    [sym__splice_dollars] = STATE(7260),
    [sym_splice] = STATE(6510),
    [sym_quasiquote] = STATE(6510),
    [sym_integer] = STATE(6338),
    [sym__plist] = STATE(6519),
    [sym_unit] = STATE(6510),
    [sym_unboxed_unit] = STATE(6510),
    [sym_prefix_tuple] = STATE(6510),
    [sym_prefix_unboxed_tuple] = STATE(6510),
    [sym_prefix_unboxed_sum] = STATE(6510),
    [sym_literal] = STATE(6510),
    [sym__qualified_type] = STATE(6245),
    [sym__qtyconid] = STATE(6520),
    [sym__tycon_arrow] = STATE(6520),
    [sym__qtycon_arrow] = STATE(6520),
    [sym__promoted_tycons_alias] = STATE(6510),
    [sym__promoted_tycons] = STATE(6510),
    [sym__tycon_ticked] = STATE(2609),
    [sym__qtycon_ticked] = STATE(2609),
    [sym__tyconids_ticked] = STATE(2609),
    [sym__promoted_tyconops_alias] = STATE(2609),
    [sym__promoted_tyconops] = STATE(2609),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2609),
    [sym__operator_alias] = STATE(2609),
    [sym__operator_minus] = STATE(2609),
    [sym__varsym_prefix] = STATE(6520),
    [sym__pvarsym] = STATE(6520),
    [sym__qualified_varsym] = STATE(2605),
    [sym__qvarsym_prefix] = STATE(6520),
    [sym__pqvarsym] = STATE(6520),
    [sym_constructor_operator] = STATE(2609),
    [sym__constructor_operator_alias] = STATE(2609),
    [sym__consym_prefix] = STATE(6520),
    [sym__pconsym] = STATE(6520),
    [sym__qualified_consym] = STATE(2603),
    [sym__qconsym_prefix] = STATE(6520),
    [sym__pqconsym] = STATE(6520),
    [sym__prefix_at] = STATE(2576),
    [sym__paren_open] = STATE(431),
    [sym__bracket_open] = STATE(1029),
    [sym__unboxed_open] = STATE(771),
    [sym_variable] = ACTIONS(2397),
    [anon_sym_SEMI] = ACTIONS(2399),
    [anon_sym__] = ACTIONS(2397),
    [anon_sym_SQUOTE] = ACTIONS(2397),
    [anon_sym_STAR] = ACTIONS(2399),
    [anon_sym_u2605] = ACTIONS(2399),
    [anon_sym_PIPE] = ACTIONS(2399),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_deriving] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(2399),
    [sym_float] = ACTIONS(2399),
    [sym_char] = ACTIONS(2399),
    [sym_string] = ACTIONS(2399),
    [sym__integer_literal] = ACTIONS(2397),
    [sym__binary_literal] = ACTIONS(2399),
    [sym__octal_literal] = ACTIONS(2399),
    [sym__hex_literal] = ACTIONS(2399),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2399),
    [aux_sym__paren_open_token1] = ACTIONS(2399),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(2399),
    [sym__cond_layout_end] = ACTIONS(2399),
    [sym__cond_layout_end_explicit] = ACTIONS(2399),
    [sym__phantom_bar] = ACTIONS(2399),
    [sym__phantom_deriving] = ACTIONS(2399),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2399),
    [sym__cond_splice] = ACTIONS(2399),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(2399),
    [sym__cond_prefix_bang] = ACTIONS(2399),
    [sym__cond_tight_tilde] = ACTIONS(2399),
    [sym__cond_prefix_tilde] = ACTIONS(2399),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [798] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9657),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(3750),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(879),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(850),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2401),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_PIPE2] = ACTIONS(2405),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2247),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [799] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9409),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(7121),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10857),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9875),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2407),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2409),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2411),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2413),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [800] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9563),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(4179),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(900),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(855),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2415),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(2417),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_PIPE2] = ACTIONS(2419),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2347),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [801] = {
    [sym__type_parens] = STATE(6512),
    [sym__type_tuple] = STATE(6513),
    [sym__type_unboxed_tuple] = STATE(6514),
    [sym__type_unboxed_sum] = STATE(6515),
    [sym__type_list] = STATE(6516),
    [sym__type_promoted] = STATE(6510),
    [sym__type_star] = STATE(6510),
    [sym__type_wildcard] = STATE(6510),
    [sym__at_type] = STATE(6537),
    [sym__type_apply] = STATE(6517),
    [sym__type_infix] = STATE(6518),
    [sym_type] = STATE(816),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8475),
    [sym__splice_dollars] = STATE(7260),
    [sym_splice] = STATE(6510),
    [sym_quasiquote] = STATE(6510),
    [sym_integer] = STATE(6338),
    [sym__plist] = STATE(6519),
    [sym_unit] = STATE(6510),
    [sym_unboxed_unit] = STATE(6510),
    [sym_prefix_tuple] = STATE(6510),
    [sym_prefix_unboxed_tuple] = STATE(6510),
    [sym_prefix_unboxed_sum] = STATE(6510),
    [sym_literal] = STATE(6510),
    [sym__qualified_type] = STATE(6245),
    [sym__qtyconid] = STATE(6520),
    [sym__tycon_arrow] = STATE(6520),
    [sym__qtycon_arrow] = STATE(6520),
    [sym__promoted_tycons_alias] = STATE(6510),
    [sym__promoted_tycons] = STATE(6510),
    [sym__tycon_ticked] = STATE(2609),
    [sym__qtycon_ticked] = STATE(2609),
    [sym__tyconids_ticked] = STATE(2609),
    [sym__promoted_tyconops_alias] = STATE(2609),
    [sym__promoted_tyconops] = STATE(2609),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2609),
    [sym__operator_alias] = STATE(2609),
    [sym__operator_minus] = STATE(2609),
    [sym__varsym_prefix] = STATE(6520),
    [sym__pvarsym] = STATE(6520),
    [sym__qualified_varsym] = STATE(2605),
    [sym__qvarsym_prefix] = STATE(6520),
    [sym__pqvarsym] = STATE(6520),
    [sym_constructor_operator] = STATE(2609),
    [sym__constructor_operator_alias] = STATE(2609),
    [sym__consym_prefix] = STATE(6520),
    [sym__pconsym] = STATE(6520),
    [sym__qualified_consym] = STATE(2603),
    [sym__qconsym_prefix] = STATE(6520),
    [sym__pqconsym] = STATE(6520),
    [sym__prefix_at] = STATE(2576),
    [sym__paren_open] = STATE(431),
    [sym__bracket_open] = STATE(1029),
    [sym__unboxed_open] = STATE(771),
    [sym_variable] = ACTIONS(2421),
    [anon_sym_SEMI] = ACTIONS(2423),
    [anon_sym__] = ACTIONS(2421),
    [anon_sym_SQUOTE] = ACTIONS(2421),
    [anon_sym_STAR] = ACTIONS(2423),
    [anon_sym_u2605] = ACTIONS(2423),
    [anon_sym_PIPE] = ACTIONS(2423),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_deriving] = ACTIONS(2421),
    [anon_sym_LBRACK] = ACTIONS(2423),
    [sym_float] = ACTIONS(2423),
    [sym_char] = ACTIONS(2423),
    [sym_string] = ACTIONS(2423),
    [sym__integer_literal] = ACTIONS(2421),
    [sym__binary_literal] = ACTIONS(2423),
    [sym__octal_literal] = ACTIONS(2423),
    [sym__hex_literal] = ACTIONS(2423),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2423),
    [aux_sym__paren_open_token1] = ACTIONS(2423),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(2423),
    [sym__cond_layout_end] = ACTIONS(2423),
    [sym__cond_layout_end_explicit] = ACTIONS(2423),
    [sym__phantom_bar] = ACTIONS(2423),
    [sym__phantom_deriving] = ACTIONS(2423),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2423),
    [sym__cond_splice] = ACTIONS(2423),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(2423),
    [sym__cond_prefix_bang] = ACTIONS(2423),
    [sym__cond_tight_tilde] = ACTIONS(2423),
    [sym__cond_prefix_tilde] = ACTIONS(2423),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [802] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9534),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(5103),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10778),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9848),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2425),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2427),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2429),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2431),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [803] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9348),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(6610),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10825),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9914),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2433),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2435),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2437),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2439),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [804] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9375),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(4574),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10573),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9775),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2441),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2443),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2445),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2197),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [805] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9466),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(3373),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10377),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9784),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2447),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2449),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2451),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2453),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [806] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9279),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(4038),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10767),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9973),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2455),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2459),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2107),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [807] = {
    [sym__type_parens] = STATE(6363),
    [sym__type_tuple] = STATE(6337),
    [sym__type_unboxed_tuple] = STATE(6351),
    [sym__type_unboxed_sum] = STATE(6350),
    [sym__type_list] = STATE(6349),
    [sym__type_promoted] = STATE(6364),
    [sym__type_star] = STATE(6364),
    [sym__type_wildcard] = STATE(6364),
    [sym__at_type] = STATE(6316),
    [sym__type_apply] = STATE(6347),
    [sym__type_infix] = STATE(6346),
    [sym_type] = STATE(821),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8548),
    [sym__splice_dollars] = STATE(7313),
    [sym_splice] = STATE(6364),
    [sym_quasiquote] = STATE(6364),
    [sym_integer] = STATE(6231),
    [sym__plist] = STATE(6345),
    [sym_unit] = STATE(6364),
    [sym_unboxed_unit] = STATE(6364),
    [sym_prefix_tuple] = STATE(6364),
    [sym_prefix_unboxed_tuple] = STATE(6364),
    [sym_prefix_unboxed_sum] = STATE(6364),
    [sym_literal] = STATE(6364),
    [sym__qualified_type] = STATE(6444),
    [sym__qtyconid] = STATE(6341),
    [sym__tycon_arrow] = STATE(6341),
    [sym__qtycon_arrow] = STATE(6341),
    [sym__promoted_tycons_alias] = STATE(6364),
    [sym__promoted_tycons] = STATE(6364),
    [sym__tycon_ticked] = STATE(2641),
    [sym__qtycon_ticked] = STATE(2641),
    [sym__tyconids_ticked] = STATE(2641),
    [sym__promoted_tyconops_alias] = STATE(2641),
    [sym__promoted_tyconops] = STATE(2641),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2641),
    [sym__operator_alias] = STATE(2641),
    [sym__operator_minus] = STATE(2641),
    [sym__varsym_prefix] = STATE(6341),
    [sym__pvarsym] = STATE(6341),
    [sym__qualified_varsym] = STATE(2643),
    [sym__qvarsym_prefix] = STATE(6341),
    [sym__pqvarsym] = STATE(6341),
    [sym_constructor_operator] = STATE(2641),
    [sym__constructor_operator_alias] = STATE(2641),
    [sym__consym_prefix] = STATE(6341),
    [sym__pconsym] = STATE(6341),
    [sym__qualified_consym] = STATE(2646),
    [sym__qconsym_prefix] = STATE(6341),
    [sym__pqconsym] = STATE(6341),
    [sym__prefix_at] = STATE(2437),
    [sym__paren_open] = STATE(442),
    [sym__bracket_open] = STATE(962),
    [sym__unboxed_open] = STATE(762),
    [sym_variable] = ACTIONS(2461),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(2463),
    [anon_sym_SQUOTE] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2465),
    [anon_sym_u2605] = ACTIONS(2063),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2467),
    [sym_char] = ACTIONS(2467),
    [sym_string] = ACTIONS(2467),
    [sym__integer_literal] = ACTIONS(2469),
    [sym__binary_literal] = ACTIONS(2471),
    [sym__octal_literal] = ACTIONS(2471),
    [sym__hex_literal] = ACTIONS(2471),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2473),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2475),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1181),
    [sym__cond_prefix_bang] = ACTIONS(1181),
    [sym__cond_tight_tilde] = ACTIONS(1181),
    [sym__cond_prefix_tilde] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [808] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10517),
    [sym__assoc_tyfam] = STATE(10138),
    [sym__assoc_tyinst] = STATE(10139),
    [sym__assoc_datafam] = STATE(10141),
    [sym_default_signature] = STATE(10146),
    [sym_class_decl] = STATE(10736),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10146),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10146),
    [sym__local_decl] = STATE(10146),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_data] = ACTIONS(1935),
    [anon_sym_default] = ACTIONS(1937),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(2477),
    [sym__cond_layout_end_explicit] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [809] = {
    [sym__type_parens] = STATE(6323),
    [sym__type_tuple] = STATE(6324),
    [sym__type_unboxed_tuple] = STATE(6325),
    [sym__type_unboxed_sum] = STATE(6326),
    [sym__type_list] = STATE(6327),
    [sym__type_promoted] = STATE(6321),
    [sym__type_star] = STATE(6321),
    [sym__type_wildcard] = STATE(6321),
    [sym__at_type] = STATE(6348),
    [sym__type_apply] = STATE(6328),
    [sym__type_infix] = STATE(6329),
    [sym_type] = STATE(809),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8496),
    [sym__splice_dollars] = STATE(7407),
    [sym_splice] = STATE(6321),
    [sym_quasiquote] = STATE(6321),
    [sym_integer] = STATE(6269),
    [sym__plist] = STATE(6330),
    [sym_unit] = STATE(6321),
    [sym_unboxed_unit] = STATE(6321),
    [sym_prefix_tuple] = STATE(6321),
    [sym_prefix_unboxed_tuple] = STATE(6321),
    [sym_prefix_unboxed_sum] = STATE(6321),
    [sym_literal] = STATE(6321),
    [sym__qualified_type] = STATE(6286),
    [sym__qtyconid] = STATE(6331),
    [sym__tycon_arrow] = STATE(6331),
    [sym__qtycon_arrow] = STATE(6331),
    [sym__promoted_tycons_alias] = STATE(6321),
    [sym__promoted_tycons] = STATE(6321),
    [sym__tycon_ticked] = STATE(2678),
    [sym__qtycon_ticked] = STATE(2678),
    [sym__tyconids_ticked] = STATE(2678),
    [sym__promoted_tyconops_alias] = STATE(2678),
    [sym__promoted_tyconops] = STATE(2678),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2678),
    [sym__operator_alias] = STATE(2678),
    [sym__operator_minus] = STATE(2678),
    [sym__varsym_prefix] = STATE(6331),
    [sym__pvarsym] = STATE(6331),
    [sym__qualified_varsym] = STATE(2680),
    [sym__qvarsym_prefix] = STATE(6331),
    [sym__pqvarsym] = STATE(6331),
    [sym_constructor_operator] = STATE(2678),
    [sym__constructor_operator_alias] = STATE(2678),
    [sym__consym_prefix] = STATE(6331),
    [sym__pconsym] = STATE(6331),
    [sym__qualified_consym] = STATE(2684),
    [sym__qconsym_prefix] = STATE(6331),
    [sym__pqconsym] = STATE(6331),
    [sym__prefix_at] = STATE(2544),
    [sym__paren_open] = STATE(469),
    [sym__bracket_open] = STATE(990),
    [sym__unboxed_open] = STATE(810),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1119),
    [anon_sym_u22b8] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [anon_sym_where] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1119),
    [sym__cond_layout_end] = ACTIONS(1119),
    [sym__cond_layout_end_explicit] = ACTIONS(1119),
    [sym__phantom_where] = ACTIONS(1119),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_prefix_percent] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [810] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9262),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(6294),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10644),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9860),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2479),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2481),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2483),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2485),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [811] = {
    [sym__type_parens] = STATE(6363),
    [sym__type_tuple] = STATE(6337),
    [sym__type_unboxed_tuple] = STATE(6351),
    [sym__type_unboxed_sum] = STATE(6350),
    [sym__type_list] = STATE(6349),
    [sym__type_promoted] = STATE(6364),
    [sym__type_star] = STATE(6364),
    [sym__type_wildcard] = STATE(6364),
    [sym__at_type] = STATE(6316),
    [sym__type_apply] = STATE(6347),
    [sym__type_infix] = STATE(6346),
    [sym_type] = STATE(821),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8548),
    [sym__splice_dollars] = STATE(7313),
    [sym_splice] = STATE(6364),
    [sym_quasiquote] = STATE(6364),
    [sym_integer] = STATE(6231),
    [sym__plist] = STATE(6345),
    [sym_unit] = STATE(6364),
    [sym_unboxed_unit] = STATE(6364),
    [sym_prefix_tuple] = STATE(6364),
    [sym_prefix_unboxed_tuple] = STATE(6364),
    [sym_prefix_unboxed_sum] = STATE(6364),
    [sym_literal] = STATE(6364),
    [sym__qualified_type] = STATE(6444),
    [sym__qtyconid] = STATE(6341),
    [sym__tycon_arrow] = STATE(6341),
    [sym__qtycon_arrow] = STATE(6341),
    [sym__promoted_tycons_alias] = STATE(6364),
    [sym__promoted_tycons] = STATE(6364),
    [sym__tycon_ticked] = STATE(2641),
    [sym__qtycon_ticked] = STATE(2641),
    [sym__tyconids_ticked] = STATE(2641),
    [sym__promoted_tyconops_alias] = STATE(2641),
    [sym__promoted_tyconops] = STATE(2641),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2641),
    [sym__operator_alias] = STATE(2641),
    [sym__operator_minus] = STATE(2641),
    [sym__varsym_prefix] = STATE(6341),
    [sym__pvarsym] = STATE(6341),
    [sym__qualified_varsym] = STATE(2643),
    [sym__qvarsym_prefix] = STATE(6341),
    [sym__pqvarsym] = STATE(6341),
    [sym_constructor_operator] = STATE(2641),
    [sym__constructor_operator_alias] = STATE(2641),
    [sym__consym_prefix] = STATE(6341),
    [sym__pconsym] = STATE(6341),
    [sym__qualified_consym] = STATE(2646),
    [sym__qconsym_prefix] = STATE(6341),
    [sym__pqconsym] = STATE(6341),
    [sym__prefix_at] = STATE(2437),
    [sym__paren_open] = STATE(442),
    [sym__bracket_open] = STATE(962),
    [sym__unboxed_open] = STATE(762),
    [sym_variable] = ACTIONS(2461),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(2463),
    [anon_sym_SQUOTE] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2465),
    [anon_sym_u2605] = ACTIONS(2063),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2467),
    [sym_char] = ACTIONS(2467),
    [sym_string] = ACTIONS(2467),
    [sym__integer_literal] = ACTIONS(2469),
    [sym__binary_literal] = ACTIONS(2471),
    [sym__octal_literal] = ACTIONS(2471),
    [sym__hex_literal] = ACTIONS(2471),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2473),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2475),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1181),
    [sym__cond_prefix_bang] = ACTIONS(1181),
    [sym__cond_tight_tilde] = ACTIONS(1181),
    [sym__cond_prefix_tilde] = ACTIONS(1181),
    [sym__cond_qualified_op] = ACTIONS(1181),
    [sym__cond_no_section_op] = ACTIONS(1181),
    [sym__cond_minus] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [812] = {
    [sym__type_parens] = STATE(6363),
    [sym__type_tuple] = STATE(6337),
    [sym__type_unboxed_tuple] = STATE(6351),
    [sym__type_unboxed_sum] = STATE(6350),
    [sym__type_list] = STATE(6349),
    [sym__type_promoted] = STATE(6364),
    [sym__type_star] = STATE(6364),
    [sym__type_wildcard] = STATE(6364),
    [sym__at_type] = STATE(6316),
    [sym__type_apply] = STATE(6347),
    [sym__type_infix] = STATE(6346),
    [sym_type] = STATE(821),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8548),
    [sym__splice_dollars] = STATE(7313),
    [sym_splice] = STATE(6364),
    [sym_quasiquote] = STATE(6364),
    [sym_integer] = STATE(6231),
    [sym__plist] = STATE(6345),
    [sym_unit] = STATE(6364),
    [sym_unboxed_unit] = STATE(6364),
    [sym_prefix_tuple] = STATE(6364),
    [sym_prefix_unboxed_tuple] = STATE(6364),
    [sym_prefix_unboxed_sum] = STATE(6364),
    [sym_literal] = STATE(6364),
    [sym__qualified_type] = STATE(6444),
    [sym__qtyconid] = STATE(6341),
    [sym__tycon_arrow] = STATE(6341),
    [sym__qtycon_arrow] = STATE(6341),
    [sym__promoted_tycons_alias] = STATE(6364),
    [sym__promoted_tycons] = STATE(6364),
    [sym__tycon_ticked] = STATE(2641),
    [sym__qtycon_ticked] = STATE(2641),
    [sym__tyconids_ticked] = STATE(2641),
    [sym__promoted_tyconops_alias] = STATE(2641),
    [sym__promoted_tyconops] = STATE(2641),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2641),
    [sym__operator_alias] = STATE(2641),
    [sym__operator_minus] = STATE(2641),
    [sym__varsym_prefix] = STATE(6341),
    [sym__pvarsym] = STATE(6341),
    [sym__qualified_varsym] = STATE(2643),
    [sym__qvarsym_prefix] = STATE(6341),
    [sym__pqvarsym] = STATE(6341),
    [sym_constructor_operator] = STATE(2641),
    [sym__constructor_operator_alias] = STATE(2641),
    [sym__consym_prefix] = STATE(6341),
    [sym__pconsym] = STATE(6341),
    [sym__qualified_consym] = STATE(2646),
    [sym__qconsym_prefix] = STATE(6341),
    [sym__pqconsym] = STATE(6341),
    [sym__prefix_at] = STATE(2437),
    [sym__paren_open] = STATE(442),
    [sym__bracket_open] = STATE(962),
    [sym__unboxed_open] = STATE(762),
    [sym_variable] = ACTIONS(2461),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(2463),
    [anon_sym_SQUOTE] = ACTIONS(2061),
    [anon_sym_STAR] = ACTIONS(2465),
    [anon_sym_u2605] = ACTIONS(2063),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2467),
    [sym_char] = ACTIONS(2467),
    [sym_string] = ACTIONS(2467),
    [sym__integer_literal] = ACTIONS(2469),
    [sym__binary_literal] = ACTIONS(2471),
    [sym__octal_literal] = ACTIONS(2471),
    [sym__hex_literal] = ACTIONS(2471),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2473),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1157),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2475),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1157),
    [sym__cond_prefix_bang] = ACTIONS(1157),
    [sym__cond_tight_tilde] = ACTIONS(1157),
    [sym__cond_prefix_tilde] = ACTIONS(1157),
    [sym__cond_qualified_op] = ACTIONS(1157),
    [sym__cond_no_section_op] = ACTIONS(1157),
    [sym__cond_minus] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [813] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9365),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(7736),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10630),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9833),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2487),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2489),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2491),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2493),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [814] = {
    [sym__type_parens] = STATE(6323),
    [sym__type_tuple] = STATE(6324),
    [sym__type_unboxed_tuple] = STATE(6325),
    [sym__type_unboxed_sum] = STATE(6326),
    [sym__type_list] = STATE(6327),
    [sym__type_promoted] = STATE(6321),
    [sym__type_star] = STATE(6321),
    [sym__type_wildcard] = STATE(6321),
    [sym__at_type] = STATE(6348),
    [sym__type_apply] = STATE(6328),
    [sym__type_infix] = STATE(6329),
    [sym_type] = STATE(809),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8496),
    [sym__splice_dollars] = STATE(7407),
    [sym_splice] = STATE(6321),
    [sym_quasiquote] = STATE(6321),
    [sym_integer] = STATE(6269),
    [sym__plist] = STATE(6330),
    [sym_unit] = STATE(6321),
    [sym_unboxed_unit] = STATE(6321),
    [sym_prefix_tuple] = STATE(6321),
    [sym_prefix_unboxed_tuple] = STATE(6321),
    [sym_prefix_unboxed_sum] = STATE(6321),
    [sym_literal] = STATE(6321),
    [sym__qualified_type] = STATE(6286),
    [sym__qtyconid] = STATE(6331),
    [sym__tycon_arrow] = STATE(6331),
    [sym__qtycon_arrow] = STATE(6331),
    [sym__promoted_tycons_alias] = STATE(6321),
    [sym__promoted_tycons] = STATE(6321),
    [sym__tycon_ticked] = STATE(2678),
    [sym__qtycon_ticked] = STATE(2678),
    [sym__tyconids_ticked] = STATE(2678),
    [sym__promoted_tyconops_alias] = STATE(2678),
    [sym__promoted_tyconops] = STATE(2678),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2678),
    [sym__operator_alias] = STATE(2678),
    [sym__operator_minus] = STATE(2678),
    [sym__varsym_prefix] = STATE(6331),
    [sym__pvarsym] = STATE(6331),
    [sym__qualified_varsym] = STATE(2680),
    [sym__qvarsym_prefix] = STATE(6331),
    [sym__pqvarsym] = STATE(6331),
    [sym_constructor_operator] = STATE(2678),
    [sym__constructor_operator_alias] = STATE(2678),
    [sym__consym_prefix] = STATE(6331),
    [sym__pconsym] = STATE(6331),
    [sym__qualified_consym] = STATE(2684),
    [sym__qconsym_prefix] = STATE(6331),
    [sym__pqconsym] = STATE(6331),
    [sym__prefix_at] = STATE(2544),
    [sym__paren_open] = STATE(469),
    [sym__bracket_open] = STATE(990),
    [sym__unboxed_open] = STATE(810),
    [sym_variable] = ACTIONS(2155),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2161),
    [anon_sym_u2605] = ACTIONS(2163),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2165),
    [sym_char] = ACTIONS(2165),
    [sym_string] = ACTIONS(2165),
    [sym__integer_literal] = ACTIONS(2167),
    [sym__binary_literal] = ACTIONS(2169),
    [sym__octal_literal] = ACTIONS(2169),
    [sym__hex_literal] = ACTIONS(2169),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2171),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_where] = ACTIONS(1181),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2173),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [815] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9471),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(6161),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10406),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9719),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(785),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2497),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(791),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [816] = {
    [sym__type_parens] = STATE(6512),
    [sym__type_tuple] = STATE(6513),
    [sym__type_unboxed_tuple] = STATE(6514),
    [sym__type_unboxed_sum] = STATE(6515),
    [sym__type_list] = STATE(6516),
    [sym__type_promoted] = STATE(6510),
    [sym__type_star] = STATE(6510),
    [sym__type_wildcard] = STATE(6510),
    [sym__at_type] = STATE(6537),
    [sym__type_apply] = STATE(6517),
    [sym__type_infix] = STATE(6518),
    [sym_type] = STATE(816),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8475),
    [sym__splice_dollars] = STATE(7260),
    [sym_splice] = STATE(6510),
    [sym_quasiquote] = STATE(6510),
    [sym_integer] = STATE(6338),
    [sym__plist] = STATE(6519),
    [sym_unit] = STATE(6510),
    [sym_unboxed_unit] = STATE(6510),
    [sym_prefix_tuple] = STATE(6510),
    [sym_prefix_unboxed_tuple] = STATE(6510),
    [sym_prefix_unboxed_sum] = STATE(6510),
    [sym_literal] = STATE(6510),
    [sym__qualified_type] = STATE(6245),
    [sym__qtyconid] = STATE(6520),
    [sym__tycon_arrow] = STATE(6520),
    [sym__qtycon_arrow] = STATE(6520),
    [sym__promoted_tycons_alias] = STATE(6510),
    [sym__promoted_tycons] = STATE(6510),
    [sym__tycon_ticked] = STATE(2609),
    [sym__qtycon_ticked] = STATE(2609),
    [sym__tyconids_ticked] = STATE(2609),
    [sym__promoted_tyconops_alias] = STATE(2609),
    [sym__promoted_tyconops] = STATE(2609),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2609),
    [sym__operator_alias] = STATE(2609),
    [sym__operator_minus] = STATE(2609),
    [sym__varsym_prefix] = STATE(6520),
    [sym__pvarsym] = STATE(6520),
    [sym__qualified_varsym] = STATE(2605),
    [sym__qvarsym_prefix] = STATE(6520),
    [sym__pqvarsym] = STATE(6520),
    [sym_constructor_operator] = STATE(2609),
    [sym__constructor_operator_alias] = STATE(2609),
    [sym__consym_prefix] = STATE(6520),
    [sym__pconsym] = STATE(6520),
    [sym__qualified_consym] = STATE(2603),
    [sym__qconsym_prefix] = STATE(6520),
    [sym__pqconsym] = STATE(6520),
    [sym__prefix_at] = STATE(2576),
    [sym__paren_open] = STATE(431),
    [sym__bracket_open] = STATE(1029),
    [sym__unboxed_open] = STATE(771),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_deriving] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1119),
    [sym__cond_layout_end] = ACTIONS(1119),
    [sym__cond_layout_end_explicit] = ACTIONS(1119),
    [sym__phantom_bar] = ACTIONS(1119),
    [sym__phantom_deriving] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_tight_bang] = ACTIONS(1119),
    [sym__cond_prefix_bang] = ACTIONS(1119),
    [sym__cond_tight_tilde] = ACTIONS(1119),
    [sym__cond_prefix_tilde] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [817] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9247),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(4975),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10359),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9826),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2499),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2501),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2503),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2287),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [818] = {
    [sym__type_parens] = STATE(6323),
    [sym__type_tuple] = STATE(6324),
    [sym__type_unboxed_tuple] = STATE(6325),
    [sym__type_unboxed_sum] = STATE(6326),
    [sym__type_list] = STATE(6327),
    [sym__type_promoted] = STATE(6321),
    [sym__type_star] = STATE(6321),
    [sym__type_wildcard] = STATE(6321),
    [sym__at_type] = STATE(6348),
    [sym__type_apply] = STATE(6328),
    [sym__type_infix] = STATE(6329),
    [sym_type] = STATE(809),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8496),
    [sym__splice_dollars] = STATE(7407),
    [sym_splice] = STATE(6321),
    [sym_quasiquote] = STATE(6321),
    [sym_integer] = STATE(6269),
    [sym__plist] = STATE(6330),
    [sym_unit] = STATE(6321),
    [sym_unboxed_unit] = STATE(6321),
    [sym_prefix_tuple] = STATE(6321),
    [sym_prefix_unboxed_tuple] = STATE(6321),
    [sym_prefix_unboxed_sum] = STATE(6321),
    [sym_literal] = STATE(6321),
    [sym__qualified_type] = STATE(6286),
    [sym__qtyconid] = STATE(6331),
    [sym__tycon_arrow] = STATE(6331),
    [sym__qtycon_arrow] = STATE(6331),
    [sym__promoted_tycons_alias] = STATE(6321),
    [sym__promoted_tycons] = STATE(6321),
    [sym__tycon_ticked] = STATE(2678),
    [sym__qtycon_ticked] = STATE(2678),
    [sym__tyconids_ticked] = STATE(2678),
    [sym__promoted_tyconops_alias] = STATE(2678),
    [sym__promoted_tyconops] = STATE(2678),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2678),
    [sym__operator_alias] = STATE(2678),
    [sym__operator_minus] = STATE(2678),
    [sym__varsym_prefix] = STATE(6331),
    [sym__pvarsym] = STATE(6331),
    [sym__qualified_varsym] = STATE(2680),
    [sym__qvarsym_prefix] = STATE(6331),
    [sym__pqvarsym] = STATE(6331),
    [sym_constructor_operator] = STATE(2678),
    [sym__constructor_operator_alias] = STATE(2678),
    [sym__consym_prefix] = STATE(6331),
    [sym__pconsym] = STATE(6331),
    [sym__qualified_consym] = STATE(2684),
    [sym__qconsym_prefix] = STATE(6331),
    [sym__pqconsym] = STATE(6331),
    [sym__prefix_at] = STATE(2544),
    [sym__paren_open] = STATE(469),
    [sym__bracket_open] = STATE(990),
    [sym__unboxed_open] = STATE(810),
    [sym_variable] = ACTIONS(2155),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2161),
    [anon_sym_u2605] = ACTIONS(2163),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2165),
    [sym_char] = ACTIONS(2165),
    [sym_string] = ACTIONS(2165),
    [sym__integer_literal] = ACTIONS(2167),
    [sym__binary_literal] = ACTIONS(2169),
    [sym__octal_literal] = ACTIONS(2169),
    [sym__hex_literal] = ACTIONS(2169),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2171),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_where] = ACTIONS(1181),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2173),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [819] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__at_type] = STATE(6393),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(791),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8417),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__tycon_ticked] = STATE(2442),
    [sym__qtycon_ticked] = STATE(2442),
    [sym__tyconids_ticked] = STATE(2442),
    [sym__promoted_tyconops_alias] = STATE(2442),
    [sym__promoted_tyconops] = STATE(2442),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2442),
    [sym__operator_alias] = STATE(2442),
    [sym__operator_minus] = STATE(2442),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qualified_varsym] = STATE(2441),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym_constructor_operator] = STATE(2442),
    [sym__constructor_operator_alias] = STATE(2442),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qualified_consym] = STATE(2428),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_at] = STATE(2660),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1179),
    [anon_sym_u22b8] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_prefix_percent] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [820] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9535),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(4398),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10443),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9781),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2505),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2509),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2511),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [821] = {
    [sym__type_parens] = STATE(6363),
    [sym__type_tuple] = STATE(6337),
    [sym__type_unboxed_tuple] = STATE(6351),
    [sym__type_unboxed_sum] = STATE(6350),
    [sym__type_list] = STATE(6349),
    [sym__type_promoted] = STATE(6364),
    [sym__type_star] = STATE(6364),
    [sym__type_wildcard] = STATE(6364),
    [sym__at_type] = STATE(6316),
    [sym__type_apply] = STATE(6347),
    [sym__type_infix] = STATE(6346),
    [sym_type] = STATE(821),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8548),
    [sym__splice_dollars] = STATE(7313),
    [sym_splice] = STATE(6364),
    [sym_quasiquote] = STATE(6364),
    [sym_integer] = STATE(6231),
    [sym__plist] = STATE(6345),
    [sym_unit] = STATE(6364),
    [sym_unboxed_unit] = STATE(6364),
    [sym_prefix_tuple] = STATE(6364),
    [sym_prefix_unboxed_tuple] = STATE(6364),
    [sym_prefix_unboxed_sum] = STATE(6364),
    [sym_literal] = STATE(6364),
    [sym__qualified_type] = STATE(6444),
    [sym__qtyconid] = STATE(6341),
    [sym__tycon_arrow] = STATE(6341),
    [sym__qtycon_arrow] = STATE(6341),
    [sym__promoted_tycons_alias] = STATE(6364),
    [sym__promoted_tycons] = STATE(6364),
    [sym__tycon_ticked] = STATE(2641),
    [sym__qtycon_ticked] = STATE(2641),
    [sym__tyconids_ticked] = STATE(2641),
    [sym__promoted_tyconops_alias] = STATE(2641),
    [sym__promoted_tyconops] = STATE(2641),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2641),
    [sym__operator_alias] = STATE(2641),
    [sym__operator_minus] = STATE(2641),
    [sym__varsym_prefix] = STATE(6341),
    [sym__pvarsym] = STATE(6341),
    [sym__qualified_varsym] = STATE(2643),
    [sym__qvarsym_prefix] = STATE(6341),
    [sym__pqvarsym] = STATE(6341),
    [sym_constructor_operator] = STATE(2641),
    [sym__constructor_operator_alias] = STATE(2641),
    [sym__consym_prefix] = STATE(6341),
    [sym__pconsym] = STATE(6341),
    [sym__qualified_consym] = STATE(2646),
    [sym__qconsym_prefix] = STATE(6341),
    [sym__pqconsym] = STATE(6341),
    [sym__prefix_at] = STATE(2437),
    [sym__paren_open] = STATE(442),
    [sym__bracket_open] = STATE(962),
    [sym__unboxed_open] = STATE(762),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__paren_close_token1] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_tight_bang] = ACTIONS(1119),
    [sym__cond_prefix_bang] = ACTIONS(1119),
    [sym__cond_tight_tilde] = ACTIONS(1119),
    [sym__cond_prefix_tilde] = ACTIONS(1119),
    [sym__cond_qualified_op] = ACTIONS(1119),
    [sym__cond_no_section_op] = ACTIONS(1119),
    [sym__cond_minus] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [822] = {
    [sym__type_parens] = STATE(6282),
    [sym__type_tuple] = STATE(6281),
    [sym__type_unboxed_tuple] = STATE(6280),
    [sym__type_unboxed_sum] = STATE(6279),
    [sym__type_list] = STATE(6278),
    [sym__type_promoted] = STATE(6283),
    [sym__type_star] = STATE(6283),
    [sym__type_wildcard] = STATE(6283),
    [sym__at_type] = STATE(6261),
    [sym__type_apply] = STATE(6277),
    [sym__type_infix] = STATE(6276),
    [sym_type] = STATE(830),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8442),
    [sym__splice_dollars] = STATE(7421),
    [sym_splice] = STATE(6283),
    [sym_quasiquote] = STATE(6283),
    [sym_integer] = STATE(6535),
    [sym__plist] = STATE(6275),
    [sym_unit] = STATE(6283),
    [sym_unboxed_unit] = STATE(6283),
    [sym_prefix_tuple] = STATE(6283),
    [sym_prefix_unboxed_tuple] = STATE(6283),
    [sym_prefix_unboxed_sum] = STATE(6283),
    [sym_literal] = STATE(6283),
    [sym__qualified_type] = STATE(6310),
    [sym__qtyconid] = STATE(6273),
    [sym__tycon_arrow] = STATE(6273),
    [sym__qtycon_arrow] = STATE(6273),
    [sym__promoted_tycons_alias] = STATE(6283),
    [sym__promoted_tycons] = STATE(6283),
    [sym__tycon_ticked] = STATE(2517),
    [sym__qtycon_ticked] = STATE(2517),
    [sym__tyconids_ticked] = STATE(2517),
    [sym__promoted_tyconops_alias] = STATE(2517),
    [sym__promoted_tyconops] = STATE(2517),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2517),
    [sym__operator_alias] = STATE(2517),
    [sym__operator_minus] = STATE(2517),
    [sym__varsym_prefix] = STATE(6273),
    [sym__pvarsym] = STATE(6273),
    [sym__qualified_varsym] = STATE(2514),
    [sym__qvarsym_prefix] = STATE(6273),
    [sym__pqvarsym] = STATE(6273),
    [sym_constructor_operator] = STATE(2517),
    [sym__constructor_operator_alias] = STATE(2517),
    [sym__consym_prefix] = STATE(6273),
    [sym__pconsym] = STATE(6273),
    [sym__qualified_consym] = STATE(2513),
    [sym__qconsym_prefix] = STATE(6273),
    [sym__pqconsym] = STATE(6273),
    [sym__prefix_at] = STATE(2610),
    [sym__paren_open] = STATE(429),
    [sym__bracket_open] = STATE(1061),
    [sym__unboxed_open] = STATE(755),
    [sym_variable] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym__] = ACTIONS(2307),
    [anon_sym_SQUOTE] = ACTIONS(2309),
    [anon_sym_STAR] = ACTIONS(2311),
    [anon_sym_u2605] = ACTIONS(2313),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_deriving] = ACTIONS(1125),
    [anon_sym_DASH_GT] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym__integer_literal] = ACTIONS(2317),
    [sym__binary_literal] = ACTIONS(2319),
    [sym__octal_literal] = ACTIONS(2319),
    [sym__hex_literal] = ACTIONS(2319),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2321),
    [anon_sym_u2192] = ACTIONS(1123),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1123),
    [anon_sym_u22b8] = ACTIONS(1123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1123),
    [sym__cond_layout_end] = ACTIONS(1123),
    [sym__cond_layout_end_explicit] = ACTIONS(1123),
    [sym__phantom_arrow] = ACTIONS(1123),
    [sym__phantom_deriving] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2323),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1123),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [823] = {
    [sym__type_parens] = STATE(6512),
    [sym__type_tuple] = STATE(6513),
    [sym__type_unboxed_tuple] = STATE(6514),
    [sym__type_unboxed_sum] = STATE(6515),
    [sym__type_list] = STATE(6516),
    [sym__type_promoted] = STATE(6510),
    [sym__type_star] = STATE(6510),
    [sym__type_wildcard] = STATE(6510),
    [sym__at_type] = STATE(6537),
    [sym__type_apply] = STATE(6517),
    [sym__type_infix] = STATE(6518),
    [sym_type] = STATE(816),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8475),
    [sym__splice_dollars] = STATE(7260),
    [sym_splice] = STATE(6510),
    [sym_quasiquote] = STATE(6510),
    [sym_integer] = STATE(6338),
    [sym__plist] = STATE(6519),
    [sym_unit] = STATE(6510),
    [sym_unboxed_unit] = STATE(6510),
    [sym_prefix_tuple] = STATE(6510),
    [sym_prefix_unboxed_tuple] = STATE(6510),
    [sym_prefix_unboxed_sum] = STATE(6510),
    [sym_literal] = STATE(6510),
    [sym__qualified_type] = STATE(6245),
    [sym__qtyconid] = STATE(6520),
    [sym__tycon_arrow] = STATE(6520),
    [sym__qtycon_arrow] = STATE(6520),
    [sym__promoted_tycons_alias] = STATE(6510),
    [sym__promoted_tycons] = STATE(6510),
    [sym__tycon_ticked] = STATE(2609),
    [sym__qtycon_ticked] = STATE(2609),
    [sym__tyconids_ticked] = STATE(2609),
    [sym__promoted_tyconops_alias] = STATE(2609),
    [sym__promoted_tyconops] = STATE(2609),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2609),
    [sym__operator_alias] = STATE(2609),
    [sym__operator_minus] = STATE(2609),
    [sym__varsym_prefix] = STATE(6520),
    [sym__pvarsym] = STATE(6520),
    [sym__qualified_varsym] = STATE(2605),
    [sym__qvarsym_prefix] = STATE(6520),
    [sym__pqvarsym] = STATE(6520),
    [sym_constructor_operator] = STATE(2609),
    [sym__constructor_operator_alias] = STATE(2609),
    [sym__consym_prefix] = STATE(6520),
    [sym__pconsym] = STATE(6520),
    [sym__qualified_consym] = STATE(2603),
    [sym__qconsym_prefix] = STATE(6520),
    [sym__pqconsym] = STATE(6520),
    [sym__prefix_at] = STATE(2576),
    [sym__paren_open] = STATE(431),
    [sym__bracket_open] = STATE(1029),
    [sym__unboxed_open] = STATE(771),
    [sym_variable] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2125),
    [anon_sym_STAR] = ACTIONS(2127),
    [anon_sym_u2605] = ACTIONS(2129),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_deriving] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2131),
    [sym_char] = ACTIONS(2131),
    [sym_string] = ACTIONS(2131),
    [sym__integer_literal] = ACTIONS(2133),
    [sym__binary_literal] = ACTIONS(2135),
    [sym__octal_literal] = ACTIONS(2135),
    [sym__hex_literal] = ACTIONS(2135),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2137),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym__phantom_deriving] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2139),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1181),
    [sym__cond_prefix_bang] = ACTIONS(1181),
    [sym__cond_tight_tilde] = ACTIONS(1181),
    [sym__cond_prefix_tilde] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [824] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9440),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(7284),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10610),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9812),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2513),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2515),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2517),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2519),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [825] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9381),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(7699),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10844),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9904),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2521),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2523),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2525),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2527),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [826] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9316),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(5922),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10787),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9957),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2531),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2533),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2535),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [827] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9472),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(6538),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10404),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(10000),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2537),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2541),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2543),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [828] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9559),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(4398),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(904),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(841),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2545),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(2547),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_PIPE2] = ACTIONS(2549),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2511),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [829] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9219),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(3581),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10321),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9964),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2551),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2555),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2557),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [830] = {
    [sym__type_parens] = STATE(6282),
    [sym__type_tuple] = STATE(6281),
    [sym__type_unboxed_tuple] = STATE(6280),
    [sym__type_unboxed_sum] = STATE(6279),
    [sym__type_list] = STATE(6278),
    [sym__type_promoted] = STATE(6283),
    [sym__type_star] = STATE(6283),
    [sym__type_wildcard] = STATE(6283),
    [sym__at_type] = STATE(6261),
    [sym__type_apply] = STATE(6277),
    [sym__type_infix] = STATE(6276),
    [sym_type] = STATE(830),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8442),
    [sym__splice_dollars] = STATE(7421),
    [sym_splice] = STATE(6283),
    [sym_quasiquote] = STATE(6283),
    [sym_integer] = STATE(6535),
    [sym__plist] = STATE(6275),
    [sym_unit] = STATE(6283),
    [sym_unboxed_unit] = STATE(6283),
    [sym_prefix_tuple] = STATE(6283),
    [sym_prefix_unboxed_tuple] = STATE(6283),
    [sym_prefix_unboxed_sum] = STATE(6283),
    [sym_literal] = STATE(6283),
    [sym__qualified_type] = STATE(6310),
    [sym__qtyconid] = STATE(6273),
    [sym__tycon_arrow] = STATE(6273),
    [sym__qtycon_arrow] = STATE(6273),
    [sym__promoted_tycons_alias] = STATE(6283),
    [sym__promoted_tycons] = STATE(6283),
    [sym__tycon_ticked] = STATE(2517),
    [sym__qtycon_ticked] = STATE(2517),
    [sym__tyconids_ticked] = STATE(2517),
    [sym__promoted_tyconops_alias] = STATE(2517),
    [sym__promoted_tyconops] = STATE(2517),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2517),
    [sym__operator_alias] = STATE(2517),
    [sym__operator_minus] = STATE(2517),
    [sym__varsym_prefix] = STATE(6273),
    [sym__pvarsym] = STATE(6273),
    [sym__qualified_varsym] = STATE(2514),
    [sym__qvarsym_prefix] = STATE(6273),
    [sym__pqvarsym] = STATE(6273),
    [sym_constructor_operator] = STATE(2517),
    [sym__constructor_operator_alias] = STATE(2517),
    [sym__consym_prefix] = STATE(6273),
    [sym__pconsym] = STATE(6273),
    [sym__qualified_consym] = STATE(2513),
    [sym__qconsym_prefix] = STATE(6273),
    [sym__pqconsym] = STATE(6273),
    [sym__prefix_at] = STATE(2610),
    [sym__paren_open] = STATE(429),
    [sym__bracket_open] = STATE(1061),
    [sym__unboxed_open] = STATE(755),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_deriving] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1119),
    [anon_sym_u22b8] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1119),
    [sym__cond_layout_end] = ACTIONS(1119),
    [sym__cond_layout_end_explicit] = ACTIONS(1119),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym__phantom_deriving] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_prefix_percent] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [831] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(9526),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(7089),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10345),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(9920),
    [sym_variable] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(2559),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2561),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2563),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2565),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [832] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9568),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(4693),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(890),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(847),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2567),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(2569),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_PIPE2] = ACTIONS(2571),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2331),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [833] = {
    [sym__type_parens] = STATE(6688),
    [sym__type_tuple] = STATE(6687),
    [sym__type_unboxed_tuple] = STATE(6686),
    [sym__type_unboxed_sum] = STATE(6685),
    [sym__type_list] = STATE(6574),
    [sym__type_promoted] = STATE(6689),
    [sym__type_star] = STATE(6689),
    [sym__type_wildcard] = STATE(6689),
    [sym__at_type] = STATE(6662),
    [sym__type_apply] = STATE(6683),
    [sym__type_infix] = STATE(6682),
    [sym_type] = STATE(835),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8411),
    [sym__splice_dollars] = STATE(7266),
    [sym_splice] = STATE(6689),
    [sym_quasiquote] = STATE(6689),
    [sym_integer] = STATE(6634),
    [sym__plist] = STATE(6681),
    [sym_unit] = STATE(6689),
    [sym_unboxed_unit] = STATE(6689),
    [sym_prefix_tuple] = STATE(6689),
    [sym_prefix_unboxed_tuple] = STATE(6689),
    [sym_prefix_unboxed_sum] = STATE(6689),
    [sym_literal] = STATE(6689),
    [sym__qualified_type] = STATE(6595),
    [sym__qtyconid] = STATE(6680),
    [sym__tycon_arrow] = STATE(6680),
    [sym__qtycon_arrow] = STATE(6680),
    [sym__promoted_tycons_alias] = STATE(6689),
    [sym__promoted_tycons] = STATE(6689),
    [sym__tycon_ticked] = STATE(2598),
    [sym__qtycon_ticked] = STATE(2598),
    [sym__tyconids_ticked] = STATE(2598),
    [sym__promoted_tyconops_alias] = STATE(2598),
    [sym__promoted_tyconops] = STATE(2598),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2598),
    [sym__operator_alias] = STATE(2598),
    [sym__operator_minus] = STATE(2598),
    [sym__varsym_prefix] = STATE(6680),
    [sym__pvarsym] = STATE(6680),
    [sym__qualified_varsym] = STATE(2599),
    [sym__qvarsym_prefix] = STATE(6680),
    [sym__pqvarsym] = STATE(6680),
    [sym_constructor_operator] = STATE(2598),
    [sym__constructor_operator_alias] = STATE(2598),
    [sym__consym_prefix] = STATE(6680),
    [sym__pconsym] = STATE(6680),
    [sym__qualified_consym] = STATE(2600),
    [sym__qconsym_prefix] = STATE(6680),
    [sym__pqconsym] = STATE(6680),
    [sym__prefix_at] = STATE(2507),
    [sym__paren_open] = STATE(446),
    [sym__bracket_open] = STATE(965),
    [sym__unboxed_open] = STATE(803),
    [sym_variable] = ACTIONS(2573),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(2575),
    [anon_sym_SQUOTE] = ACTIONS(2577),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_u2605] = ACTIONS(2581),
    [anon_sym_EQ] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_deriving] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2583),
    [sym_char] = ACTIONS(2583),
    [sym_string] = ACTIONS(2583),
    [sym__integer_literal] = ACTIONS(2585),
    [sym__binary_literal] = ACTIONS(2587),
    [sym__octal_literal] = ACTIONS(2587),
    [sym__hex_literal] = ACTIONS(2587),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2589),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_where] = ACTIONS(1181),
    [sym__phantom_deriving] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2591),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [834] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple_elems] = STATE(11830),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12157),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(11650),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(8958),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_POUND2] = ACTIONS(2593),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(2597),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
    [sym__consym] = ACTIONS(257),
  },
  [835] = {
    [sym__type_parens] = STATE(6688),
    [sym__type_tuple] = STATE(6687),
    [sym__type_unboxed_tuple] = STATE(6686),
    [sym__type_unboxed_sum] = STATE(6685),
    [sym__type_list] = STATE(6574),
    [sym__type_promoted] = STATE(6689),
    [sym__type_star] = STATE(6689),
    [sym__type_wildcard] = STATE(6689),
    [sym__at_type] = STATE(6662),
    [sym__type_apply] = STATE(6683),
    [sym__type_infix] = STATE(6682),
    [sym_type] = STATE(835),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8411),
    [sym__splice_dollars] = STATE(7266),
    [sym_splice] = STATE(6689),
    [sym_quasiquote] = STATE(6689),
    [sym_integer] = STATE(6634),
    [sym__plist] = STATE(6681),
    [sym_unit] = STATE(6689),
    [sym_unboxed_unit] = STATE(6689),
    [sym_prefix_tuple] = STATE(6689),
    [sym_prefix_unboxed_tuple] = STATE(6689),
    [sym_prefix_unboxed_sum] = STATE(6689),
    [sym_literal] = STATE(6689),
    [sym__qualified_type] = STATE(6595),
    [sym__qtyconid] = STATE(6680),
    [sym__tycon_arrow] = STATE(6680),
    [sym__qtycon_arrow] = STATE(6680),
    [sym__promoted_tycons_alias] = STATE(6689),
    [sym__promoted_tycons] = STATE(6689),
    [sym__tycon_ticked] = STATE(2598),
    [sym__qtycon_ticked] = STATE(2598),
    [sym__tyconids_ticked] = STATE(2598),
    [sym__promoted_tyconops_alias] = STATE(2598),
    [sym__promoted_tyconops] = STATE(2598),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2598),
    [sym__operator_alias] = STATE(2598),
    [sym__operator_minus] = STATE(2598),
    [sym__varsym_prefix] = STATE(6680),
    [sym__pvarsym] = STATE(6680),
    [sym__qualified_varsym] = STATE(2599),
    [sym__qvarsym_prefix] = STATE(6680),
    [sym__pqvarsym] = STATE(6680),
    [sym_constructor_operator] = STATE(2598),
    [sym__constructor_operator_alias] = STATE(2598),
    [sym__consym_prefix] = STATE(6680),
    [sym__pconsym] = STATE(6680),
    [sym__qualified_consym] = STATE(2600),
    [sym__qconsym_prefix] = STATE(6680),
    [sym__pqconsym] = STATE(6680),
    [sym__prefix_at] = STATE(2507),
    [sym__paren_open] = STATE(446),
    [sym__bracket_open] = STATE(965),
    [sym__unboxed_open] = STATE(803),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_EQ] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_deriving] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [anon_sym_where] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1119),
    [sym__cond_layout_end] = ACTIONS(1119),
    [sym__cond_layout_end_explicit] = ACTIONS(1119),
    [sym__phantom_where] = ACTIONS(1119),
    [sym__phantom_deriving] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [836] = {
    [sym__type_parens] = STATE(6688),
    [sym__type_tuple] = STATE(6687),
    [sym__type_unboxed_tuple] = STATE(6686),
    [sym__type_unboxed_sum] = STATE(6685),
    [sym__type_list] = STATE(6574),
    [sym__type_promoted] = STATE(6689),
    [sym__type_star] = STATE(6689),
    [sym__type_wildcard] = STATE(6689),
    [sym__at_type] = STATE(6662),
    [sym__type_apply] = STATE(6683),
    [sym__type_infix] = STATE(6682),
    [sym_type] = STATE(835),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8411),
    [sym__splice_dollars] = STATE(7266),
    [sym_splice] = STATE(6689),
    [sym_quasiquote] = STATE(6689),
    [sym_integer] = STATE(6634),
    [sym__plist] = STATE(6681),
    [sym_unit] = STATE(6689),
    [sym_unboxed_unit] = STATE(6689),
    [sym_prefix_tuple] = STATE(6689),
    [sym_prefix_unboxed_tuple] = STATE(6689),
    [sym_prefix_unboxed_sum] = STATE(6689),
    [sym_literal] = STATE(6689),
    [sym__qualified_type] = STATE(6595),
    [sym__qtyconid] = STATE(6680),
    [sym__tycon_arrow] = STATE(6680),
    [sym__qtycon_arrow] = STATE(6680),
    [sym__promoted_tycons_alias] = STATE(6689),
    [sym__promoted_tycons] = STATE(6689),
    [sym__tycon_ticked] = STATE(2598),
    [sym__qtycon_ticked] = STATE(2598),
    [sym__tyconids_ticked] = STATE(2598),
    [sym__promoted_tyconops_alias] = STATE(2598),
    [sym__promoted_tyconops] = STATE(2598),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2598),
    [sym__operator_alias] = STATE(2598),
    [sym__operator_minus] = STATE(2598),
    [sym__varsym_prefix] = STATE(6680),
    [sym__pvarsym] = STATE(6680),
    [sym__qualified_varsym] = STATE(2599),
    [sym__qvarsym_prefix] = STATE(6680),
    [sym__pqvarsym] = STATE(6680),
    [sym_constructor_operator] = STATE(2598),
    [sym__constructor_operator_alias] = STATE(2598),
    [sym__consym_prefix] = STATE(6680),
    [sym__pconsym] = STATE(6680),
    [sym__qualified_consym] = STATE(2600),
    [sym__qconsym_prefix] = STATE(6680),
    [sym__pqconsym] = STATE(6680),
    [sym__prefix_at] = STATE(2507),
    [sym__paren_open] = STATE(446),
    [sym__bracket_open] = STATE(965),
    [sym__unboxed_open] = STATE(803),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_deriving] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(1177),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym__phantom_where] = ACTIONS(1179),
    [sym__phantom_deriving] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [837] = {
    [sym__type_parens] = STATE(6688),
    [sym__type_tuple] = STATE(6687),
    [sym__type_unboxed_tuple] = STATE(6686),
    [sym__type_unboxed_sum] = STATE(6685),
    [sym__type_list] = STATE(6574),
    [sym__type_promoted] = STATE(6689),
    [sym__type_star] = STATE(6689),
    [sym__type_wildcard] = STATE(6689),
    [sym__at_type] = STATE(6662),
    [sym__type_apply] = STATE(6683),
    [sym__type_infix] = STATE(6682),
    [sym_type] = STATE(835),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8411),
    [sym__splice_dollars] = STATE(7266),
    [sym_splice] = STATE(6689),
    [sym_quasiquote] = STATE(6689),
    [sym_integer] = STATE(6634),
    [sym__plist] = STATE(6681),
    [sym_unit] = STATE(6689),
    [sym_unboxed_unit] = STATE(6689),
    [sym_prefix_tuple] = STATE(6689),
    [sym_prefix_unboxed_tuple] = STATE(6689),
    [sym_prefix_unboxed_sum] = STATE(6689),
    [sym_literal] = STATE(6689),
    [sym__qualified_type] = STATE(6595),
    [sym__qtyconid] = STATE(6680),
    [sym__tycon_arrow] = STATE(6680),
    [sym__qtycon_arrow] = STATE(6680),
    [sym__promoted_tycons_alias] = STATE(6689),
    [sym__promoted_tycons] = STATE(6689),
    [sym__tycon_ticked] = STATE(2598),
    [sym__qtycon_ticked] = STATE(2598),
    [sym__tyconids_ticked] = STATE(2598),
    [sym__promoted_tyconops_alias] = STATE(2598),
    [sym__promoted_tyconops] = STATE(2598),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2598),
    [sym__operator_alias] = STATE(2598),
    [sym__operator_minus] = STATE(2598),
    [sym__varsym_prefix] = STATE(6680),
    [sym__pvarsym] = STATE(6680),
    [sym__qualified_varsym] = STATE(2599),
    [sym__qvarsym_prefix] = STATE(6680),
    [sym__pqvarsym] = STATE(6680),
    [sym_constructor_operator] = STATE(2598),
    [sym__constructor_operator_alias] = STATE(2598),
    [sym__consym_prefix] = STATE(6680),
    [sym__pconsym] = STATE(6680),
    [sym__qualified_consym] = STATE(2600),
    [sym__qconsym_prefix] = STATE(6680),
    [sym__pqconsym] = STATE(6680),
    [sym__prefix_at] = STATE(2507),
    [sym__paren_open] = STATE(446),
    [sym__bracket_open] = STATE(965),
    [sym__unboxed_open] = STATE(803),
    [sym_variable] = ACTIONS(2599),
    [anon_sym_SEMI] = ACTIONS(2601),
    [anon_sym__] = ACTIONS(2599),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [anon_sym_STAR] = ACTIONS(2601),
    [anon_sym_u2605] = ACTIONS(2601),
    [anon_sym_EQ] = ACTIONS(2601),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_deriving] = ACTIONS(2599),
    [anon_sym_LBRACK] = ACTIONS(2601),
    [sym_float] = ACTIONS(2601),
    [sym_char] = ACTIONS(2601),
    [sym_string] = ACTIONS(2601),
    [sym__integer_literal] = ACTIONS(2599),
    [sym__binary_literal] = ACTIONS(2601),
    [sym__octal_literal] = ACTIONS(2601),
    [sym__hex_literal] = ACTIONS(2601),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2601),
    [anon_sym_COLON_COLON] = ACTIONS(2601),
    [anon_sym_u2237] = ACTIONS(2601),
    [aux_sym__paren_open_token1] = ACTIONS(2601),
    [anon_sym_where] = ACTIONS(2599),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(2601),
    [sym__cond_layout_end] = ACTIONS(2601),
    [sym__cond_layout_end_explicit] = ACTIONS(2601),
    [sym__phantom_where] = ACTIONS(2601),
    [sym__phantom_deriving] = ACTIONS(2601),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2601),
    [sym__cond_splice] = ACTIONS(2601),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(2601),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [838] = {
    [sym__type_parens] = STATE(6688),
    [sym__type_tuple] = STATE(6687),
    [sym__type_unboxed_tuple] = STATE(6686),
    [sym__type_unboxed_sum] = STATE(6685),
    [sym__type_list] = STATE(6574),
    [sym__type_promoted] = STATE(6689),
    [sym__type_star] = STATE(6689),
    [sym__type_wildcard] = STATE(6689),
    [sym__at_type] = STATE(6662),
    [sym__type_apply] = STATE(6683),
    [sym__type_infix] = STATE(6682),
    [sym_type] = STATE(835),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8411),
    [sym__splice_dollars] = STATE(7266),
    [sym_splice] = STATE(6689),
    [sym_quasiquote] = STATE(6689),
    [sym_integer] = STATE(6634),
    [sym__plist] = STATE(6681),
    [sym_unit] = STATE(6689),
    [sym_unboxed_unit] = STATE(6689),
    [sym_prefix_tuple] = STATE(6689),
    [sym_prefix_unboxed_tuple] = STATE(6689),
    [sym_prefix_unboxed_sum] = STATE(6689),
    [sym_literal] = STATE(6689),
    [sym__qualified_type] = STATE(6595),
    [sym__qtyconid] = STATE(6680),
    [sym__tycon_arrow] = STATE(6680),
    [sym__qtycon_arrow] = STATE(6680),
    [sym__promoted_tycons_alias] = STATE(6689),
    [sym__promoted_tycons] = STATE(6689),
    [sym__tycon_ticked] = STATE(2598),
    [sym__qtycon_ticked] = STATE(2598),
    [sym__tyconids_ticked] = STATE(2598),
    [sym__promoted_tyconops_alias] = STATE(2598),
    [sym__promoted_tyconops] = STATE(2598),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2598),
    [sym__operator_alias] = STATE(2598),
    [sym__operator_minus] = STATE(2598),
    [sym__varsym_prefix] = STATE(6680),
    [sym__pvarsym] = STATE(6680),
    [sym__qualified_varsym] = STATE(2599),
    [sym__qvarsym_prefix] = STATE(6680),
    [sym__pqvarsym] = STATE(6680),
    [sym_constructor_operator] = STATE(2598),
    [sym__constructor_operator_alias] = STATE(2598),
    [sym__consym_prefix] = STATE(6680),
    [sym__pconsym] = STATE(6680),
    [sym__qualified_consym] = STATE(2600),
    [sym__qconsym_prefix] = STATE(6680),
    [sym__pqconsym] = STATE(6680),
    [sym__prefix_at] = STATE(2507),
    [sym__paren_open] = STATE(446),
    [sym__bracket_open] = STATE(965),
    [sym__unboxed_open] = STATE(803),
    [sym_variable] = ACTIONS(2573),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(2575),
    [anon_sym_SQUOTE] = ACTIONS(2577),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_u2605] = ACTIONS(2581),
    [anon_sym_EQ] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_deriving] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2583),
    [sym_char] = ACTIONS(2583),
    [sym_string] = ACTIONS(2583),
    [sym__integer_literal] = ACTIONS(2585),
    [sym__binary_literal] = ACTIONS(2587),
    [sym__octal_literal] = ACTIONS(2587),
    [sym__hex_literal] = ACTIONS(2587),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2589),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1159),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1157),
    [sym__cond_layout_end] = ACTIONS(1157),
    [sym__cond_layout_end_explicit] = ACTIONS(1157),
    [sym__phantom_where] = ACTIONS(1157),
    [sym__phantom_deriving] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2591),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [839] = {
    [sym__type_parens] = STATE(6688),
    [sym__type_tuple] = STATE(6687),
    [sym__type_unboxed_tuple] = STATE(6686),
    [sym__type_unboxed_sum] = STATE(6685),
    [sym__type_list] = STATE(6574),
    [sym__type_promoted] = STATE(6689),
    [sym__type_star] = STATE(6689),
    [sym__type_wildcard] = STATE(6689),
    [sym__at_type] = STATE(6662),
    [sym__type_apply] = STATE(6683),
    [sym__type_infix] = STATE(6682),
    [sym_type] = STATE(835),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8411),
    [sym__splice_dollars] = STATE(7266),
    [sym_splice] = STATE(6689),
    [sym_quasiquote] = STATE(6689),
    [sym_integer] = STATE(6634),
    [sym__plist] = STATE(6681),
    [sym_unit] = STATE(6689),
    [sym_unboxed_unit] = STATE(6689),
    [sym_prefix_tuple] = STATE(6689),
    [sym_prefix_unboxed_tuple] = STATE(6689),
    [sym_prefix_unboxed_sum] = STATE(6689),
    [sym_literal] = STATE(6689),
    [sym__qualified_type] = STATE(6595),
    [sym__qtyconid] = STATE(6680),
    [sym__tycon_arrow] = STATE(6680),
    [sym__qtycon_arrow] = STATE(6680),
    [sym__promoted_tycons_alias] = STATE(6689),
    [sym__promoted_tycons] = STATE(6689),
    [sym__tycon_ticked] = STATE(2598),
    [sym__qtycon_ticked] = STATE(2598),
    [sym__tyconids_ticked] = STATE(2598),
    [sym__promoted_tyconops_alias] = STATE(2598),
    [sym__promoted_tyconops] = STATE(2598),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2598),
    [sym__operator_alias] = STATE(2598),
    [sym__operator_minus] = STATE(2598),
    [sym__varsym_prefix] = STATE(6680),
    [sym__pvarsym] = STATE(6680),
    [sym__qualified_varsym] = STATE(2599),
    [sym__qvarsym_prefix] = STATE(6680),
    [sym__pqvarsym] = STATE(6680),
    [sym_constructor_operator] = STATE(2598),
    [sym__constructor_operator_alias] = STATE(2598),
    [sym__consym_prefix] = STATE(6680),
    [sym__pconsym] = STATE(6680),
    [sym__qualified_consym] = STATE(2600),
    [sym__qconsym_prefix] = STATE(6680),
    [sym__pqconsym] = STATE(6680),
    [sym__prefix_at] = STATE(2507),
    [sym__paren_open] = STATE(446),
    [sym__bracket_open] = STATE(965),
    [sym__unboxed_open] = STATE(803),
    [sym_variable] = ACTIONS(2573),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(2575),
    [anon_sym_SQUOTE] = ACTIONS(2577),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_u2605] = ACTIONS(2581),
    [anon_sym_EQ] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_deriving] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2583),
    [sym_char] = ACTIONS(2583),
    [sym_string] = ACTIONS(2583),
    [sym__integer_literal] = ACTIONS(2585),
    [sym__binary_literal] = ACTIONS(2587),
    [sym__octal_literal] = ACTIONS(2587),
    [sym__hex_literal] = ACTIONS(2587),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2589),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_where] = ACTIONS(1181),
    [sym__phantom_deriving] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2591),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [840] = {
    [sym__type_parens] = STATE(6688),
    [sym__type_tuple] = STATE(6687),
    [sym__type_unboxed_tuple] = STATE(6686),
    [sym__type_unboxed_sum] = STATE(6685),
    [sym__type_list] = STATE(6574),
    [sym__type_promoted] = STATE(6689),
    [sym__type_star] = STATE(6689),
    [sym__type_wildcard] = STATE(6689),
    [sym__at_type] = STATE(6662),
    [sym__type_apply] = STATE(6683),
    [sym__type_infix] = STATE(6682),
    [sym_type] = STATE(835),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8411),
    [sym__splice_dollars] = STATE(7266),
    [sym_splice] = STATE(6689),
    [sym_quasiquote] = STATE(6689),
    [sym_integer] = STATE(6634),
    [sym__plist] = STATE(6681),
    [sym_unit] = STATE(6689),
    [sym_unboxed_unit] = STATE(6689),
    [sym_prefix_tuple] = STATE(6689),
    [sym_prefix_unboxed_tuple] = STATE(6689),
    [sym_prefix_unboxed_sum] = STATE(6689),
    [sym_literal] = STATE(6689),
    [sym__qualified_type] = STATE(6595),
    [sym__qtyconid] = STATE(6680),
    [sym__tycon_arrow] = STATE(6680),
    [sym__qtycon_arrow] = STATE(6680),
    [sym__promoted_tycons_alias] = STATE(6689),
    [sym__promoted_tycons] = STATE(6689),
    [sym__tycon_ticked] = STATE(2598),
    [sym__qtycon_ticked] = STATE(2598),
    [sym__tyconids_ticked] = STATE(2598),
    [sym__promoted_tyconops_alias] = STATE(2598),
    [sym__promoted_tyconops] = STATE(2598),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2598),
    [sym__operator_alias] = STATE(2598),
    [sym__operator_minus] = STATE(2598),
    [sym__varsym_prefix] = STATE(6680),
    [sym__pvarsym] = STATE(6680),
    [sym__qualified_varsym] = STATE(2599),
    [sym__qvarsym_prefix] = STATE(6680),
    [sym__pqvarsym] = STATE(6680),
    [sym_constructor_operator] = STATE(2598),
    [sym__constructor_operator_alias] = STATE(2598),
    [sym__consym_prefix] = STATE(6680),
    [sym__pconsym] = STATE(6680),
    [sym__qualified_consym] = STATE(2600),
    [sym__qconsym_prefix] = STATE(6680),
    [sym__pqconsym] = STATE(6680),
    [sym__prefix_at] = STATE(2507),
    [sym__paren_open] = STATE(446),
    [sym__bracket_open] = STATE(965),
    [sym__unboxed_open] = STATE(803),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_deriving] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(1177),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym__phantom_where] = ACTIONS(1179),
    [sym__phantom_deriving] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [841] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9801),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(4413),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7640),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(2603),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_PIPE2] = ACTIONS(2605),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2511),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [842] = {
    [sym__type_parens] = STATE(6784),
    [sym__type_tuple] = STATE(6785),
    [sym__type_unboxed_tuple] = STATE(6786),
    [sym__type_unboxed_sum] = STATE(6787),
    [sym__type_list] = STATE(6789),
    [sym__type_promoted] = STATE(6781),
    [sym__type_star] = STATE(6781),
    [sym__type_wildcard] = STATE(6781),
    [sym__at_type] = STATE(6814),
    [sym__type_apply] = STATE(6790),
    [sym__type_infix] = STATE(6791),
    [sym_type] = STATE(864),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8516),
    [sym__splice_dollars] = STATE(7457),
    [sym_splice] = STATE(6781),
    [sym_quasiquote] = STATE(6781),
    [sym_integer] = STATE(6710),
    [sym__plist] = STATE(6792),
    [sym_unit] = STATE(6781),
    [sym_unboxed_unit] = STATE(6781),
    [sym_prefix_tuple] = STATE(6781),
    [sym_prefix_unboxed_tuple] = STATE(6781),
    [sym_prefix_unboxed_sum] = STATE(6781),
    [sym_literal] = STATE(6781),
    [sym__qualified_type] = STATE(6756),
    [sym__qtyconid] = STATE(6793),
    [sym__tycon_arrow] = STATE(6793),
    [sym__qtycon_arrow] = STATE(6793),
    [sym__promoted_tycons_alias] = STATE(6781),
    [sym__promoted_tycons] = STATE(6781),
    [sym__tycon_ticked] = STATE(2489),
    [sym__qtycon_ticked] = STATE(2489),
    [sym__tyconids_ticked] = STATE(2489),
    [sym__promoted_tyconops_alias] = STATE(2489),
    [sym__promoted_tyconops] = STATE(2489),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2489),
    [sym__operator_alias] = STATE(2489),
    [sym__operator_minus] = STATE(2489),
    [sym__varsym_prefix] = STATE(6793),
    [sym__pvarsym] = STATE(6793),
    [sym__qualified_varsym] = STATE(2487),
    [sym__qvarsym_prefix] = STATE(6793),
    [sym__pqvarsym] = STATE(6793),
    [sym_constructor_operator] = STATE(2489),
    [sym__constructor_operator_alias] = STATE(2489),
    [sym__consym_prefix] = STATE(6793),
    [sym__pconsym] = STATE(6793),
    [sym__qualified_consym] = STATE(2482),
    [sym__qconsym_prefix] = STATE(6793),
    [sym__pqconsym] = STATE(6793),
    [sym__prefix_at] = STATE(2393),
    [sym__paren_open] = STATE(472),
    [sym__bracket_open] = STATE(1078),
    [sym__unboxed_open] = STATE(789),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_by] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1179),
    [anon_sym_u22b8] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_RBRACK] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_prefix_percent] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [843] = {
    [sym__type_parens] = STATE(6784),
    [sym__type_tuple] = STATE(6785),
    [sym__type_unboxed_tuple] = STATE(6786),
    [sym__type_unboxed_sum] = STATE(6787),
    [sym__type_list] = STATE(6789),
    [sym__type_promoted] = STATE(6781),
    [sym__type_star] = STATE(6781),
    [sym__type_wildcard] = STATE(6781),
    [sym__at_type] = STATE(6814),
    [sym__type_apply] = STATE(6790),
    [sym__type_infix] = STATE(6791),
    [sym_type] = STATE(864),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8516),
    [sym__splice_dollars] = STATE(7457),
    [sym_splice] = STATE(6781),
    [sym_quasiquote] = STATE(6781),
    [sym_integer] = STATE(6710),
    [sym__plist] = STATE(6792),
    [sym_unit] = STATE(6781),
    [sym_unboxed_unit] = STATE(6781),
    [sym_prefix_tuple] = STATE(6781),
    [sym_prefix_unboxed_tuple] = STATE(6781),
    [sym_prefix_unboxed_sum] = STATE(6781),
    [sym_literal] = STATE(6781),
    [sym__qualified_type] = STATE(6756),
    [sym__qtyconid] = STATE(6793),
    [sym__tycon_arrow] = STATE(6793),
    [sym__qtycon_arrow] = STATE(6793),
    [sym__promoted_tycons_alias] = STATE(6781),
    [sym__promoted_tycons] = STATE(6781),
    [sym__tycon_ticked] = STATE(2489),
    [sym__qtycon_ticked] = STATE(2489),
    [sym__tyconids_ticked] = STATE(2489),
    [sym__promoted_tyconops_alias] = STATE(2489),
    [sym__promoted_tyconops] = STATE(2489),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2489),
    [sym__operator_alias] = STATE(2489),
    [sym__operator_minus] = STATE(2489),
    [sym__varsym_prefix] = STATE(6793),
    [sym__pvarsym] = STATE(6793),
    [sym__qualified_varsym] = STATE(2487),
    [sym__qvarsym_prefix] = STATE(6793),
    [sym__pqvarsym] = STATE(6793),
    [sym_constructor_operator] = STATE(2489),
    [sym__constructor_operator_alias] = STATE(2489),
    [sym__consym_prefix] = STATE(6793),
    [sym__pconsym] = STATE(6793),
    [sym__qualified_consym] = STATE(2482),
    [sym__qconsym_prefix] = STATE(6793),
    [sym__pqconsym] = STATE(6793),
    [sym__prefix_at] = STATE(2393),
    [sym__paren_open] = STATE(472),
    [sym__bracket_open] = STATE(1078),
    [sym__unboxed_open] = STATE(789),
    [sym_variable] = ACTIONS(2607),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(2609),
    [anon_sym_SQUOTE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_u2605] = ACTIONS(2615),
    [anon_sym_by] = ACTIONS(1159),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2617),
    [sym_char] = ACTIONS(2617),
    [sym_string] = ACTIONS(2617),
    [sym__integer_literal] = ACTIONS(2619),
    [sym__binary_literal] = ACTIONS(2621),
    [sym__octal_literal] = ACTIONS(2621),
    [sym__hex_literal] = ACTIONS(2621),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2623),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1157),
    [anon_sym_u22b8] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1157),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2625),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [844] = {
    [sym__type_parens] = STATE(6766),
    [sym__type_tuple] = STATE(6767),
    [sym__type_unboxed_tuple] = STATE(6768),
    [sym__type_unboxed_sum] = STATE(6769),
    [sym__type_list] = STATE(6770),
    [sym__type_promoted] = STATE(6765),
    [sym__type_star] = STATE(6765),
    [sym__type_wildcard] = STATE(6765),
    [sym__at_type] = STATE(6799),
    [sym__type_apply] = STATE(6698),
    [sym__type_infix] = STATE(6780),
    [sym_type] = STATE(848),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8540),
    [sym__splice_dollars] = STATE(7306),
    [sym_splice] = STATE(6765),
    [sym_quasiquote] = STATE(6765),
    [sym_integer] = STATE(6754),
    [sym__plist] = STATE(6782),
    [sym_unit] = STATE(6765),
    [sym_unboxed_unit] = STATE(6765),
    [sym_prefix_tuple] = STATE(6765),
    [sym_prefix_unboxed_tuple] = STATE(6765),
    [sym_prefix_unboxed_sum] = STATE(6765),
    [sym_literal] = STATE(6765),
    [sym__qualified_type] = STATE(6803),
    [sym__qtyconid] = STATE(6783),
    [sym__tycon_arrow] = STATE(6783),
    [sym__qtycon_arrow] = STATE(6783),
    [sym__promoted_tycons_alias] = STATE(6765),
    [sym__promoted_tycons] = STATE(6765),
    [sym__tycon_ticked] = STATE(2649),
    [sym__qtycon_ticked] = STATE(2649),
    [sym__tyconids_ticked] = STATE(2649),
    [sym__promoted_tyconops_alias] = STATE(2649),
    [sym__promoted_tyconops] = STATE(2649),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2649),
    [sym__operator_alias] = STATE(2649),
    [sym__operator_minus] = STATE(2649),
    [sym__varsym_prefix] = STATE(6783),
    [sym__pvarsym] = STATE(6783),
    [sym__qualified_varsym] = STATE(2650),
    [sym__qvarsym_prefix] = STATE(6783),
    [sym__pqvarsym] = STATE(6783),
    [sym_constructor_operator] = STATE(2649),
    [sym__constructor_operator_alias] = STATE(2649),
    [sym__consym_prefix] = STATE(6783),
    [sym__pconsym] = STATE(6783),
    [sym__qualified_consym] = STATE(2651),
    [sym__qconsym_prefix] = STATE(6783),
    [sym__pqconsym] = STATE(6783),
    [sym__prefix_at] = STATE(2430),
    [sym__paren_open] = STATE(438),
    [sym__bracket_open] = STATE(966),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1179),
    [anon_sym_u22b8] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_RBRACK] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_dotdot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_prefix_percent] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [845] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9884),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(2699),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7640),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(2603),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_PIPE2] = ACTIONS(2605),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2081),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [846] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9915),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(4090),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7640),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(2603),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_PIPE2] = ACTIONS(2605),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2023),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [847] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9802),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(4636),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7640),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(2603),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_PIPE2] = ACTIONS(2605),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2331),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [848] = {
    [sym__type_parens] = STATE(6766),
    [sym__type_tuple] = STATE(6767),
    [sym__type_unboxed_tuple] = STATE(6768),
    [sym__type_unboxed_sum] = STATE(6769),
    [sym__type_list] = STATE(6770),
    [sym__type_promoted] = STATE(6765),
    [sym__type_star] = STATE(6765),
    [sym__type_wildcard] = STATE(6765),
    [sym__at_type] = STATE(6799),
    [sym__type_apply] = STATE(6698),
    [sym__type_infix] = STATE(6780),
    [sym_type] = STATE(848),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8540),
    [sym__splice_dollars] = STATE(7306),
    [sym_splice] = STATE(6765),
    [sym_quasiquote] = STATE(6765),
    [sym_integer] = STATE(6754),
    [sym__plist] = STATE(6782),
    [sym_unit] = STATE(6765),
    [sym_unboxed_unit] = STATE(6765),
    [sym_prefix_tuple] = STATE(6765),
    [sym_prefix_unboxed_tuple] = STATE(6765),
    [sym_prefix_unboxed_sum] = STATE(6765),
    [sym_literal] = STATE(6765),
    [sym__qualified_type] = STATE(6803),
    [sym__qtyconid] = STATE(6783),
    [sym__tycon_arrow] = STATE(6783),
    [sym__qtycon_arrow] = STATE(6783),
    [sym__promoted_tycons_alias] = STATE(6765),
    [sym__promoted_tycons] = STATE(6765),
    [sym__tycon_ticked] = STATE(2649),
    [sym__qtycon_ticked] = STATE(2649),
    [sym__tyconids_ticked] = STATE(2649),
    [sym__promoted_tyconops_alias] = STATE(2649),
    [sym__promoted_tyconops] = STATE(2649),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2649),
    [sym__operator_alias] = STATE(2649),
    [sym__operator_minus] = STATE(2649),
    [sym__varsym_prefix] = STATE(6783),
    [sym__pvarsym] = STATE(6783),
    [sym__qualified_varsym] = STATE(2650),
    [sym__qvarsym_prefix] = STATE(6783),
    [sym__pqvarsym] = STATE(6783),
    [sym_constructor_operator] = STATE(2649),
    [sym__constructor_operator_alias] = STATE(2649),
    [sym__consym_prefix] = STATE(6783),
    [sym__pconsym] = STATE(6783),
    [sym__qualified_consym] = STATE(2651),
    [sym__qconsym_prefix] = STATE(6783),
    [sym__pqconsym] = STATE(6783),
    [sym__prefix_at] = STATE(2430),
    [sym__paren_open] = STATE(438),
    [sym__bracket_open] = STATE(966),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1119),
    [anon_sym_u22b8] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [anon_sym_RBRACK] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_dotdot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_prefix_percent] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [849] = {
    [sym__type_parens] = STATE(6784),
    [sym__type_tuple] = STATE(6785),
    [sym__type_unboxed_tuple] = STATE(6786),
    [sym__type_unboxed_sum] = STATE(6787),
    [sym__type_list] = STATE(6789),
    [sym__type_promoted] = STATE(6781),
    [sym__type_star] = STATE(6781),
    [sym__type_wildcard] = STATE(6781),
    [sym__at_type] = STATE(6814),
    [sym__type_apply] = STATE(6790),
    [sym__type_infix] = STATE(6791),
    [sym_type] = STATE(864),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8516),
    [sym__splice_dollars] = STATE(7457),
    [sym_splice] = STATE(6781),
    [sym_quasiquote] = STATE(6781),
    [sym_integer] = STATE(6710),
    [sym__plist] = STATE(6792),
    [sym_unit] = STATE(6781),
    [sym_unboxed_unit] = STATE(6781),
    [sym_prefix_tuple] = STATE(6781),
    [sym_prefix_unboxed_tuple] = STATE(6781),
    [sym_prefix_unboxed_sum] = STATE(6781),
    [sym_literal] = STATE(6781),
    [sym__qualified_type] = STATE(6756),
    [sym__qtyconid] = STATE(6793),
    [sym__tycon_arrow] = STATE(6793),
    [sym__qtycon_arrow] = STATE(6793),
    [sym__promoted_tycons_alias] = STATE(6781),
    [sym__promoted_tycons] = STATE(6781),
    [sym__tycon_ticked] = STATE(2489),
    [sym__qtycon_ticked] = STATE(2489),
    [sym__tyconids_ticked] = STATE(2489),
    [sym__promoted_tyconops_alias] = STATE(2489),
    [sym__promoted_tyconops] = STATE(2489),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2489),
    [sym__operator_alias] = STATE(2489),
    [sym__operator_minus] = STATE(2489),
    [sym__varsym_prefix] = STATE(6793),
    [sym__pvarsym] = STATE(6793),
    [sym__qualified_varsym] = STATE(2487),
    [sym__qvarsym_prefix] = STATE(6793),
    [sym__pqvarsym] = STATE(6793),
    [sym_constructor_operator] = STATE(2489),
    [sym__constructor_operator_alias] = STATE(2489),
    [sym__consym_prefix] = STATE(6793),
    [sym__pconsym] = STATE(6793),
    [sym__qualified_consym] = STATE(2482),
    [sym__qconsym_prefix] = STATE(6793),
    [sym__pqconsym] = STATE(6793),
    [sym__prefix_at] = STATE(2393),
    [sym__paren_open] = STATE(472),
    [sym__bracket_open] = STATE(1078),
    [sym__unboxed_open] = STATE(789),
    [sym_variable] = ACTIONS(2607),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(2609),
    [anon_sym_SQUOTE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_u2605] = ACTIONS(2615),
    [anon_sym_by] = ACTIONS(1183),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2617),
    [sym_char] = ACTIONS(2617),
    [sym_string] = ACTIONS(2617),
    [sym__integer_literal] = ACTIONS(2619),
    [sym__binary_literal] = ACTIONS(2621),
    [sym__octal_literal] = ACTIONS(2621),
    [sym__hex_literal] = ACTIONS(2621),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2623),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2625),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [850] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(3693),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7640),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(2603),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_PIPE2] = ACTIONS(2605),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2247),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [851] = {
    [sym__type_parens] = STATE(6766),
    [sym__type_tuple] = STATE(6767),
    [sym__type_unboxed_tuple] = STATE(6768),
    [sym__type_unboxed_sum] = STATE(6769),
    [sym__type_list] = STATE(6770),
    [sym__type_promoted] = STATE(6765),
    [sym__type_star] = STATE(6765),
    [sym__type_wildcard] = STATE(6765),
    [sym__at_type] = STATE(6799),
    [sym__type_apply] = STATE(6698),
    [sym__type_infix] = STATE(6780),
    [sym_type] = STATE(848),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8540),
    [sym__splice_dollars] = STATE(7306),
    [sym_splice] = STATE(6765),
    [sym_quasiquote] = STATE(6765),
    [sym_integer] = STATE(6754),
    [sym__plist] = STATE(6782),
    [sym_unit] = STATE(6765),
    [sym_unboxed_unit] = STATE(6765),
    [sym_prefix_tuple] = STATE(6765),
    [sym_prefix_unboxed_tuple] = STATE(6765),
    [sym_prefix_unboxed_sum] = STATE(6765),
    [sym_literal] = STATE(6765),
    [sym__qualified_type] = STATE(6803),
    [sym__qtyconid] = STATE(6783),
    [sym__tycon_arrow] = STATE(6783),
    [sym__qtycon_arrow] = STATE(6783),
    [sym__promoted_tycons_alias] = STATE(6765),
    [sym__promoted_tycons] = STATE(6765),
    [sym__tycon_ticked] = STATE(2649),
    [sym__qtycon_ticked] = STATE(2649),
    [sym__tyconids_ticked] = STATE(2649),
    [sym__promoted_tyconops_alias] = STATE(2649),
    [sym__promoted_tyconops] = STATE(2649),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2649),
    [sym__operator_alias] = STATE(2649),
    [sym__operator_minus] = STATE(2649),
    [sym__varsym_prefix] = STATE(6783),
    [sym__pvarsym] = STATE(6783),
    [sym__qualified_varsym] = STATE(2650),
    [sym__qvarsym_prefix] = STATE(6783),
    [sym__pqvarsym] = STATE(6783),
    [sym_constructor_operator] = STATE(2649),
    [sym__constructor_operator_alias] = STATE(2649),
    [sym__consym_prefix] = STATE(6783),
    [sym__pconsym] = STATE(6783),
    [sym__qualified_consym] = STATE(2651),
    [sym__qconsym_prefix] = STATE(6783),
    [sym__pqconsym] = STATE(6783),
    [sym__prefix_at] = STATE(2430),
    [sym__paren_open] = STATE(438),
    [sym__bracket_open] = STATE(966),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = ACTIONS(2627),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(2629),
    [anon_sym_SQUOTE] = ACTIONS(2631),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_u2605] = ACTIONS(2635),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2637),
    [sym_char] = ACTIONS(2637),
    [sym_string] = ACTIONS(2637),
    [sym__integer_literal] = ACTIONS(2639),
    [sym__binary_literal] = ACTIONS(2641),
    [sym__octal_literal] = ACTIONS(2641),
    [sym__hex_literal] = ACTIONS(2641),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2643),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1157),
    [anon_sym_u22b8] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1157),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2645),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_dotdot] = ACTIONS(1157),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [852] = {
    [sym__type_parens] = STATE(6766),
    [sym__type_tuple] = STATE(6767),
    [sym__type_unboxed_tuple] = STATE(6768),
    [sym__type_unboxed_sum] = STATE(6769),
    [sym__type_list] = STATE(6770),
    [sym__type_promoted] = STATE(6765),
    [sym__type_star] = STATE(6765),
    [sym__type_wildcard] = STATE(6765),
    [sym__at_type] = STATE(6799),
    [sym__type_apply] = STATE(6698),
    [sym__type_infix] = STATE(6780),
    [sym_type] = STATE(848),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8540),
    [sym__splice_dollars] = STATE(7306),
    [sym_splice] = STATE(6765),
    [sym_quasiquote] = STATE(6765),
    [sym_integer] = STATE(6754),
    [sym__plist] = STATE(6782),
    [sym_unit] = STATE(6765),
    [sym_unboxed_unit] = STATE(6765),
    [sym_prefix_tuple] = STATE(6765),
    [sym_prefix_unboxed_tuple] = STATE(6765),
    [sym_prefix_unboxed_sum] = STATE(6765),
    [sym_literal] = STATE(6765),
    [sym__qualified_type] = STATE(6803),
    [sym__qtyconid] = STATE(6783),
    [sym__tycon_arrow] = STATE(6783),
    [sym__qtycon_arrow] = STATE(6783),
    [sym__promoted_tycons_alias] = STATE(6765),
    [sym__promoted_tycons] = STATE(6765),
    [sym__tycon_ticked] = STATE(2649),
    [sym__qtycon_ticked] = STATE(2649),
    [sym__tyconids_ticked] = STATE(2649),
    [sym__promoted_tyconops_alias] = STATE(2649),
    [sym__promoted_tyconops] = STATE(2649),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2649),
    [sym__operator_alias] = STATE(2649),
    [sym__operator_minus] = STATE(2649),
    [sym__varsym_prefix] = STATE(6783),
    [sym__pvarsym] = STATE(6783),
    [sym__qualified_varsym] = STATE(2650),
    [sym__qvarsym_prefix] = STATE(6783),
    [sym__pqvarsym] = STATE(6783),
    [sym_constructor_operator] = STATE(2649),
    [sym__constructor_operator_alias] = STATE(2649),
    [sym__consym_prefix] = STATE(6783),
    [sym__pconsym] = STATE(6783),
    [sym__qualified_consym] = STATE(2651),
    [sym__qconsym_prefix] = STATE(6783),
    [sym__pqconsym] = STATE(6783),
    [sym__prefix_at] = STATE(2430),
    [sym__paren_open] = STATE(438),
    [sym__bracket_open] = STATE(966),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = ACTIONS(2627),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(2629),
    [anon_sym_SQUOTE] = ACTIONS(2631),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_u2605] = ACTIONS(2635),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2637),
    [sym_char] = ACTIONS(2637),
    [sym_string] = ACTIONS(2637),
    [sym__integer_literal] = ACTIONS(2639),
    [sym__binary_literal] = ACTIONS(2641),
    [sym__octal_literal] = ACTIONS(2641),
    [sym__hex_literal] = ACTIONS(2641),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2643),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2645),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_dotdot] = ACTIONS(1181),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [853] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10783),
    [sym__assoc_tyfam] = STATE(10138),
    [sym__assoc_tyinst] = STATE(10139),
    [sym__assoc_datafam] = STATE(10141),
    [sym_default_signature] = STATE(10146),
    [sym_class_decl] = STATE(10736),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10146),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10146),
    [sym__local_decl] = STATE(10146),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_data] = ACTIONS(1935),
    [anon_sym_default] = ACTIONS(1937),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(2025),
    [sym__cond_layout_end_explicit] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [854] = {
    [sym__type_parens] = STATE(6784),
    [sym__type_tuple] = STATE(6785),
    [sym__type_unboxed_tuple] = STATE(6786),
    [sym__type_unboxed_sum] = STATE(6787),
    [sym__type_list] = STATE(6789),
    [sym__type_promoted] = STATE(6781),
    [sym__type_star] = STATE(6781),
    [sym__type_wildcard] = STATE(6781),
    [sym__at_type] = STATE(6814),
    [sym__type_apply] = STATE(6790),
    [sym__type_infix] = STATE(6791),
    [sym_type] = STATE(864),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8516),
    [sym__splice_dollars] = STATE(7457),
    [sym_splice] = STATE(6781),
    [sym_quasiquote] = STATE(6781),
    [sym_integer] = STATE(6710),
    [sym__plist] = STATE(6792),
    [sym_unit] = STATE(6781),
    [sym_unboxed_unit] = STATE(6781),
    [sym_prefix_tuple] = STATE(6781),
    [sym_prefix_unboxed_tuple] = STATE(6781),
    [sym_prefix_unboxed_sum] = STATE(6781),
    [sym_literal] = STATE(6781),
    [sym__qualified_type] = STATE(6756),
    [sym__qtyconid] = STATE(6793),
    [sym__tycon_arrow] = STATE(6793),
    [sym__qtycon_arrow] = STATE(6793),
    [sym__promoted_tycons_alias] = STATE(6781),
    [sym__promoted_tycons] = STATE(6781),
    [sym__tycon_ticked] = STATE(2489),
    [sym__qtycon_ticked] = STATE(2489),
    [sym__tyconids_ticked] = STATE(2489),
    [sym__promoted_tyconops_alias] = STATE(2489),
    [sym__promoted_tyconops] = STATE(2489),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2489),
    [sym__operator_alias] = STATE(2489),
    [sym__operator_minus] = STATE(2489),
    [sym__varsym_prefix] = STATE(6793),
    [sym__pvarsym] = STATE(6793),
    [sym__qualified_varsym] = STATE(2487),
    [sym__qvarsym_prefix] = STATE(6793),
    [sym__pqvarsym] = STATE(6793),
    [sym_constructor_operator] = STATE(2489),
    [sym__constructor_operator_alias] = STATE(2489),
    [sym__consym_prefix] = STATE(6793),
    [sym__pconsym] = STATE(6793),
    [sym__qualified_consym] = STATE(2482),
    [sym__qconsym_prefix] = STATE(6793),
    [sym__pqconsym] = STATE(6793),
    [sym__prefix_at] = STATE(2393),
    [sym__paren_open] = STATE(472),
    [sym__bracket_open] = STATE(1078),
    [sym__unboxed_open] = STATE(789),
    [sym_variable] = ACTIONS(2607),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym__] = ACTIONS(2609),
    [anon_sym_SQUOTE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_u2605] = ACTIONS(2615),
    [anon_sym_by] = ACTIONS(1125),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2617),
    [sym_char] = ACTIONS(2617),
    [sym_string] = ACTIONS(2617),
    [sym__integer_literal] = ACTIONS(2619),
    [sym__binary_literal] = ACTIONS(2621),
    [sym__octal_literal] = ACTIONS(2621),
    [sym__hex_literal] = ACTIONS(2621),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2623),
    [anon_sym_u2192] = ACTIONS(1123),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1123),
    [anon_sym_u22b8] = ACTIONS(1123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2625),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1123),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [855] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9906),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(4162),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7640),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(2603),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_PIPE2] = ACTIONS(2605),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2347),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [856] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10517),
    [sym__assoc_tyfam] = STATE(10138),
    [sym__assoc_tyinst] = STATE(10139),
    [sym__assoc_datafam] = STATE(10141),
    [sym_default_signature] = STATE(10146),
    [sym_class_decl] = STATE(10736),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10146),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10146),
    [sym__local_decl] = STATE(10146),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_data] = ACTIONS(1935),
    [anon_sym_default] = ACTIONS(1937),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(2477),
    [sym__cond_layout_end_explicit] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [857] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10802),
    [sym_forall] = STATE(934),
    [sym_forall_required] = STATE(934),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8328),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1361),
    [sym_context] = STATE(1062),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__record_fields] = STATE(9999),
    [sym__gadt_con_prefix] = STATE(10766),
    [sym__gadt_con_record] = STATE(10786),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [858] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10296),
    [sym__assoc_tyfam] = STATE(10138),
    [sym__assoc_tyinst] = STATE(10139),
    [sym__assoc_datafam] = STATE(10141),
    [sym_default_signature] = STATE(10146),
    [sym_class_decl] = STATE(10736),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10146),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10146),
    [sym__local_decl] = STATE(10146),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_data] = ACTIONS(1935),
    [anon_sym_default] = ACTIONS(1937),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(2655),
    [sym__cond_layout_end_explicit] = ACTIONS(2655),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [859] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10481),
    [sym__assoc_tyfam] = STATE(10138),
    [sym__assoc_tyinst] = STATE(10139),
    [sym__assoc_datafam] = STATE(10141),
    [sym_default_signature] = STATE(10146),
    [sym_class_decl] = STATE(10736),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10146),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10146),
    [sym__local_decl] = STATE(10146),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_data] = ACTIONS(1935),
    [anon_sym_default] = ACTIONS(1937),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(2657),
    [sym__cond_layout_end_explicit] = ACTIONS(2657),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [860] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9976),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(4994),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7640),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(2603),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_PIPE2] = ACTIONS(2605),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2287),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [861] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9811),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(4249),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7640),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(2603),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_PIPE2] = ACTIONS(2605),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2211),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [862] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10802),
    [sym_forall] = STATE(935),
    [sym_forall_required] = STATE(935),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8328),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1361),
    [sym_context] = STATE(1111),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__record_fields] = STATE(9999),
    [sym__gadt_con_prefix] = STATE(10777),
    [sym__gadt_con_record] = STATE(10772),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [863] = {
    [sym__type_parens] = STATE(6766),
    [sym__type_tuple] = STATE(6767),
    [sym__type_unboxed_tuple] = STATE(6768),
    [sym__type_unboxed_sum] = STATE(6769),
    [sym__type_list] = STATE(6770),
    [sym__type_promoted] = STATE(6765),
    [sym__type_star] = STATE(6765),
    [sym__type_wildcard] = STATE(6765),
    [sym__at_type] = STATE(6799),
    [sym__type_apply] = STATE(6698),
    [sym__type_infix] = STATE(6780),
    [sym_type] = STATE(848),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8540),
    [sym__splice_dollars] = STATE(7306),
    [sym_splice] = STATE(6765),
    [sym_quasiquote] = STATE(6765),
    [sym_integer] = STATE(6754),
    [sym__plist] = STATE(6782),
    [sym_unit] = STATE(6765),
    [sym_unboxed_unit] = STATE(6765),
    [sym_prefix_tuple] = STATE(6765),
    [sym_prefix_unboxed_tuple] = STATE(6765),
    [sym_prefix_unboxed_sum] = STATE(6765),
    [sym_literal] = STATE(6765),
    [sym__qualified_type] = STATE(6803),
    [sym__qtyconid] = STATE(6783),
    [sym__tycon_arrow] = STATE(6783),
    [sym__qtycon_arrow] = STATE(6783),
    [sym__promoted_tycons_alias] = STATE(6765),
    [sym__promoted_tycons] = STATE(6765),
    [sym__tycon_ticked] = STATE(2649),
    [sym__qtycon_ticked] = STATE(2649),
    [sym__tyconids_ticked] = STATE(2649),
    [sym__promoted_tyconops_alias] = STATE(2649),
    [sym__promoted_tyconops] = STATE(2649),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2649),
    [sym__operator_alias] = STATE(2649),
    [sym__operator_minus] = STATE(2649),
    [sym__varsym_prefix] = STATE(6783),
    [sym__pvarsym] = STATE(6783),
    [sym__qualified_varsym] = STATE(2650),
    [sym__qvarsym_prefix] = STATE(6783),
    [sym__pqvarsym] = STATE(6783),
    [sym_constructor_operator] = STATE(2649),
    [sym__constructor_operator_alias] = STATE(2649),
    [sym__consym_prefix] = STATE(6783),
    [sym__pconsym] = STATE(6783),
    [sym__qualified_consym] = STATE(2651),
    [sym__qconsym_prefix] = STATE(6783),
    [sym__pqconsym] = STATE(6783),
    [sym__prefix_at] = STATE(2430),
    [sym__paren_open] = STATE(438),
    [sym__bracket_open] = STATE(966),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = ACTIONS(2627),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym__] = ACTIONS(2629),
    [anon_sym_SQUOTE] = ACTIONS(2631),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_u2605] = ACTIONS(2635),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2637),
    [sym_char] = ACTIONS(2637),
    [sym_string] = ACTIONS(2637),
    [sym__integer_literal] = ACTIONS(2639),
    [sym__binary_literal] = ACTIONS(2641),
    [sym__octal_literal] = ACTIONS(2641),
    [sym__hex_literal] = ACTIONS(2641),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2643),
    [anon_sym_u2192] = ACTIONS(1123),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1123),
    [anon_sym_u22b8] = ACTIONS(1123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2645),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_dotdot] = ACTIONS(1123),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1123),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [864] = {
    [sym__type_parens] = STATE(6784),
    [sym__type_tuple] = STATE(6785),
    [sym__type_unboxed_tuple] = STATE(6786),
    [sym__type_unboxed_sum] = STATE(6787),
    [sym__type_list] = STATE(6789),
    [sym__type_promoted] = STATE(6781),
    [sym__type_star] = STATE(6781),
    [sym__type_wildcard] = STATE(6781),
    [sym__at_type] = STATE(6814),
    [sym__type_apply] = STATE(6790),
    [sym__type_infix] = STATE(6791),
    [sym_type] = STATE(864),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8516),
    [sym__splice_dollars] = STATE(7457),
    [sym_splice] = STATE(6781),
    [sym_quasiquote] = STATE(6781),
    [sym_integer] = STATE(6710),
    [sym__plist] = STATE(6792),
    [sym_unit] = STATE(6781),
    [sym_unboxed_unit] = STATE(6781),
    [sym_prefix_tuple] = STATE(6781),
    [sym_prefix_unboxed_tuple] = STATE(6781),
    [sym_prefix_unboxed_sum] = STATE(6781),
    [sym_literal] = STATE(6781),
    [sym__qualified_type] = STATE(6756),
    [sym__qtyconid] = STATE(6793),
    [sym__tycon_arrow] = STATE(6793),
    [sym__qtycon_arrow] = STATE(6793),
    [sym__promoted_tycons_alias] = STATE(6781),
    [sym__promoted_tycons] = STATE(6781),
    [sym__tycon_ticked] = STATE(2489),
    [sym__qtycon_ticked] = STATE(2489),
    [sym__tyconids_ticked] = STATE(2489),
    [sym__promoted_tyconops_alias] = STATE(2489),
    [sym__promoted_tyconops] = STATE(2489),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2489),
    [sym__operator_alias] = STATE(2489),
    [sym__operator_minus] = STATE(2489),
    [sym__varsym_prefix] = STATE(6793),
    [sym__pvarsym] = STATE(6793),
    [sym__qualified_varsym] = STATE(2487),
    [sym__qvarsym_prefix] = STATE(6793),
    [sym__pqvarsym] = STATE(6793),
    [sym_constructor_operator] = STATE(2489),
    [sym__constructor_operator_alias] = STATE(2489),
    [sym__consym_prefix] = STATE(6793),
    [sym__pconsym] = STATE(6793),
    [sym__qualified_consym] = STATE(2482),
    [sym__qconsym_prefix] = STATE(6793),
    [sym__pqconsym] = STATE(6793),
    [sym__prefix_at] = STATE(2393),
    [sym__paren_open] = STATE(472),
    [sym__bracket_open] = STATE(1078),
    [sym__unboxed_open] = STATE(789),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_by] = ACTIONS(1117),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1119),
    [anon_sym_u22b8] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [anon_sym_RBRACK] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_prefix_percent] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [865] = {
    [sym__type_parens] = STATE(6784),
    [sym__type_tuple] = STATE(6785),
    [sym__type_unboxed_tuple] = STATE(6786),
    [sym__type_unboxed_sum] = STATE(6787),
    [sym__type_list] = STATE(6789),
    [sym__type_promoted] = STATE(6781),
    [sym__type_star] = STATE(6781),
    [sym__type_wildcard] = STATE(6781),
    [sym__at_type] = STATE(6814),
    [sym__type_apply] = STATE(6790),
    [sym__type_infix] = STATE(6791),
    [sym_type] = STATE(864),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8516),
    [sym__splice_dollars] = STATE(7457),
    [sym_splice] = STATE(6781),
    [sym_quasiquote] = STATE(6781),
    [sym_integer] = STATE(6710),
    [sym__plist] = STATE(6792),
    [sym_unit] = STATE(6781),
    [sym_unboxed_unit] = STATE(6781),
    [sym_prefix_tuple] = STATE(6781),
    [sym_prefix_unboxed_tuple] = STATE(6781),
    [sym_prefix_unboxed_sum] = STATE(6781),
    [sym_literal] = STATE(6781),
    [sym__qualified_type] = STATE(6756),
    [sym__qtyconid] = STATE(6793),
    [sym__tycon_arrow] = STATE(6793),
    [sym__qtycon_arrow] = STATE(6793),
    [sym__promoted_tycons_alias] = STATE(6781),
    [sym__promoted_tycons] = STATE(6781),
    [sym__tycon_ticked] = STATE(2489),
    [sym__qtycon_ticked] = STATE(2489),
    [sym__tyconids_ticked] = STATE(2489),
    [sym__promoted_tyconops_alias] = STATE(2489),
    [sym__promoted_tyconops] = STATE(2489),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2489),
    [sym__operator_alias] = STATE(2489),
    [sym__operator_minus] = STATE(2489),
    [sym__varsym_prefix] = STATE(6793),
    [sym__pvarsym] = STATE(6793),
    [sym__qualified_varsym] = STATE(2487),
    [sym__qvarsym_prefix] = STATE(6793),
    [sym__pqvarsym] = STATE(6793),
    [sym_constructor_operator] = STATE(2489),
    [sym__constructor_operator_alias] = STATE(2489),
    [sym__consym_prefix] = STATE(6793),
    [sym__pconsym] = STATE(6793),
    [sym__qualified_consym] = STATE(2482),
    [sym__qconsym_prefix] = STATE(6793),
    [sym__pqconsym] = STATE(6793),
    [sym__prefix_at] = STATE(2393),
    [sym__paren_open] = STATE(472),
    [sym__bracket_open] = STATE(1078),
    [sym__unboxed_open] = STATE(789),
    [sym_variable] = ACTIONS(2607),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(2609),
    [anon_sym_SQUOTE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_u2605] = ACTIONS(2615),
    [anon_sym_by] = ACTIONS(1183),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2617),
    [sym_char] = ACTIONS(2617),
    [sym_string] = ACTIONS(2617),
    [sym__integer_literal] = ACTIONS(2619),
    [sym__binary_literal] = ACTIONS(2621),
    [sym__octal_literal] = ACTIONS(2621),
    [sym__hex_literal] = ACTIONS(2621),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2623),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2625),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [866] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9804),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(3995),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7640),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(2603),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_PIPE2] = ACTIONS(2605),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2107),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [867] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(9882),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(4645),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7640),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(2603),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [anon_sym_PIPE2] = ACTIONS(2605),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2197),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [868] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10802),
    [sym_forall] = STATE(930),
    [sym_forall_required] = STATE(931),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8328),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1361),
    [sym_context] = STATE(1114),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__record_fields] = STATE(9999),
    [sym__gadt_con_prefix] = STATE(10782),
    [sym__gadt_con_record] = STATE(10780),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [869] = {
    [sym__type_parens] = STATE(6766),
    [sym__type_tuple] = STATE(6767),
    [sym__type_unboxed_tuple] = STATE(6768),
    [sym__type_unboxed_sum] = STATE(6769),
    [sym__type_list] = STATE(6770),
    [sym__type_promoted] = STATE(6765),
    [sym__type_star] = STATE(6765),
    [sym__type_wildcard] = STATE(6765),
    [sym__at_type] = STATE(6799),
    [sym__type_apply] = STATE(6698),
    [sym__type_infix] = STATE(6780),
    [sym_type] = STATE(848),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8540),
    [sym__splice_dollars] = STATE(7306),
    [sym_splice] = STATE(6765),
    [sym_quasiquote] = STATE(6765),
    [sym_integer] = STATE(6754),
    [sym__plist] = STATE(6782),
    [sym_unit] = STATE(6765),
    [sym_unboxed_unit] = STATE(6765),
    [sym_prefix_tuple] = STATE(6765),
    [sym_prefix_unboxed_tuple] = STATE(6765),
    [sym_prefix_unboxed_sum] = STATE(6765),
    [sym_literal] = STATE(6765),
    [sym__qualified_type] = STATE(6803),
    [sym__qtyconid] = STATE(6783),
    [sym__tycon_arrow] = STATE(6783),
    [sym__qtycon_arrow] = STATE(6783),
    [sym__promoted_tycons_alias] = STATE(6765),
    [sym__promoted_tycons] = STATE(6765),
    [sym__tycon_ticked] = STATE(2649),
    [sym__qtycon_ticked] = STATE(2649),
    [sym__tyconids_ticked] = STATE(2649),
    [sym__promoted_tyconops_alias] = STATE(2649),
    [sym__promoted_tyconops] = STATE(2649),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2649),
    [sym__operator_alias] = STATE(2649),
    [sym__operator_minus] = STATE(2649),
    [sym__varsym_prefix] = STATE(6783),
    [sym__pvarsym] = STATE(6783),
    [sym__qualified_varsym] = STATE(2650),
    [sym__qvarsym_prefix] = STATE(6783),
    [sym__pqvarsym] = STATE(6783),
    [sym_constructor_operator] = STATE(2649),
    [sym__constructor_operator_alias] = STATE(2649),
    [sym__consym_prefix] = STATE(6783),
    [sym__pconsym] = STATE(6783),
    [sym__qualified_consym] = STATE(2651),
    [sym__qconsym_prefix] = STATE(6783),
    [sym__pqconsym] = STATE(6783),
    [sym__prefix_at] = STATE(2430),
    [sym__paren_open] = STATE(438),
    [sym__bracket_open] = STATE(966),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = ACTIONS(2627),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(2629),
    [anon_sym_SQUOTE] = ACTIONS(2631),
    [anon_sym_STAR] = ACTIONS(2633),
    [anon_sym_u2605] = ACTIONS(2635),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2637),
    [sym_char] = ACTIONS(2637),
    [sym_string] = ACTIONS(2637),
    [sym__integer_literal] = ACTIONS(2639),
    [sym__binary_literal] = ACTIONS(2641),
    [sym__octal_literal] = ACTIONS(2641),
    [sym__hex_literal] = ACTIONS(2641),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2643),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2645),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_dotdot] = ACTIONS(1181),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [870] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8164),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10092),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym__unboxed_close] = STATE(9088),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(1146),
    [sym_variable] = ACTIONS(1989),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(2659),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(2661),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_POUND_RPAREN] = ACTIONS(2663),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [871] = {
    [sym__type_parens] = STATE(6909),
    [sym__type_tuple] = STATE(6883),
    [sym__type_unboxed_tuple] = STATE(6903),
    [sym__type_unboxed_sum] = STATE(6892),
    [sym__type_list] = STATE(6891),
    [sym__type_promoted] = STATE(6911),
    [sym__type_star] = STATE(6911),
    [sym__type_wildcard] = STATE(6911),
    [sym__at_type] = STATE(6938),
    [sym__type_apply] = STATE(6890),
    [sym__type_infix] = STATE(6959),
    [sym_type] = STATE(871),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8431),
    [sym__splice_dollars] = STATE(7211),
    [sym_splice] = STATE(6911),
    [sym_quasiquote] = STATE(6911),
    [sym_integer] = STATE(6928),
    [sym__plist] = STATE(6889),
    [sym_unit] = STATE(6911),
    [sym_unboxed_unit] = STATE(6911),
    [sym_prefix_tuple] = STATE(6911),
    [sym_prefix_unboxed_tuple] = STATE(6911),
    [sym_prefix_unboxed_sum] = STATE(6911),
    [sym_literal] = STATE(6911),
    [sym__qualified_type] = STATE(6933),
    [sym__qtyconid] = STATE(6884),
    [sym__tycon_arrow] = STATE(6884),
    [sym__qtycon_arrow] = STATE(6884),
    [sym__promoted_tycons_alias] = STATE(6911),
    [sym__promoted_tycons] = STATE(6911),
    [sym__tycon_ticked] = STATE(2427),
    [sym__qtycon_ticked] = STATE(2427),
    [sym__tyconids_ticked] = STATE(2427),
    [sym__promoted_tyconops_alias] = STATE(2427),
    [sym__promoted_tyconops] = STATE(2427),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2427),
    [sym__operator_alias] = STATE(2427),
    [sym__operator_minus] = STATE(2427),
    [sym__varsym_prefix] = STATE(6884),
    [sym__pvarsym] = STATE(6884),
    [sym__qualified_varsym] = STATE(2429),
    [sym__qvarsym_prefix] = STATE(6884),
    [sym__pqvarsym] = STATE(6884),
    [sym_constructor_operator] = STATE(2427),
    [sym__constructor_operator_alias] = STATE(2427),
    [sym__consym_prefix] = STATE(6884),
    [sym__pconsym] = STATE(6884),
    [sym__qualified_consym] = STATE(2431),
    [sym__qconsym_prefix] = STATE(6884),
    [sym__pqconsym] = STATE(6884),
    [sym__prefix_at] = STATE(2671),
    [sym__paren_open] = STATE(430),
    [sym__bracket_open] = STATE(1017),
    [sym__unboxed_open] = STATE(737),
    [sym_variable] = ACTIONS(1117),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_EQ] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1119),
    [anon_sym_u22b8] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym__phantom_bar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_prefix_percent] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [872] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11085),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(3496),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(205),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [873] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11085),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(3633),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(209),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [874] = {
    [sym__type_parens] = STATE(6989),
    [sym__type_tuple] = STATE(6991),
    [sym__type_unboxed_tuple] = STATE(6992),
    [sym__type_unboxed_sum] = STATE(6993),
    [sym__type_list] = STATE(6994),
    [sym__type_promoted] = STATE(6987),
    [sym__type_star] = STATE(6987),
    [sym__type_wildcard] = STATE(6987),
    [sym__at_type] = STATE(7002),
    [sym__type_apply] = STATE(6995),
    [sym__type_infix] = STATE(6927),
    [sym_type] = STATE(915),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8441),
    [sym__splice_dollars] = STATE(7369),
    [sym_splice] = STATE(6987),
    [sym_quasiquote] = STATE(6987),
    [sym_integer] = STATE(6887),
    [sym__plist] = STATE(6996),
    [sym_unit] = STATE(6987),
    [sym_unboxed_unit] = STATE(6987),
    [sym_prefix_tuple] = STATE(6987),
    [sym_prefix_unboxed_tuple] = STATE(6987),
    [sym_prefix_unboxed_sum] = STATE(6987),
    [sym_literal] = STATE(6987),
    [sym__qualified_type] = STATE(6931),
    [sym__qtyconid] = STATE(6997),
    [sym__tycon_arrow] = STATE(6997),
    [sym__qtycon_arrow] = STATE(6997),
    [sym__promoted_tycons_alias] = STATE(6987),
    [sym__promoted_tycons] = STATE(6987),
    [sym__tycon_ticked] = STATE(2471),
    [sym__qtycon_ticked] = STATE(2471),
    [sym__tyconids_ticked] = STATE(2471),
    [sym__promoted_tyconops_alias] = STATE(2471),
    [sym__promoted_tyconops] = STATE(2471),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2471),
    [sym__operator_alias] = STATE(2471),
    [sym__operator_minus] = STATE(2471),
    [sym__varsym_prefix] = STATE(6997),
    [sym__pvarsym] = STATE(6997),
    [sym__qualified_varsym] = STATE(2472),
    [sym__qvarsym_prefix] = STATE(6997),
    [sym__pqvarsym] = STATE(6997),
    [sym_constructor_operator] = STATE(2471),
    [sym__constructor_operator_alias] = STATE(2471),
    [sym__consym_prefix] = STATE(6997),
    [sym__pconsym] = STATE(6997),
    [sym__qualified_consym] = STATE(2473),
    [sym__qconsym_prefix] = STATE(6997),
    [sym__pqconsym] = STATE(6997),
    [sym__prefix_at] = STATE(2689),
    [sym__paren_open] = STATE(459),
    [sym__bracket_open] = STATE(1113),
    [sym__unboxed_open] = STATE(793),
    [sym_variable] = ACTIONS(1177),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(2667),
    [anon_sym_STAR] = ACTIONS(2669),
    [anon_sym_u2605] = ACTIONS(2671),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_tight_bang] = ACTIONS(1179),
    [sym__cond_prefix_bang] = ACTIONS(1179),
    [sym__cond_tight_tilde] = ACTIONS(1179),
    [sym__cond_prefix_tilde] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [875] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11085),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(4280),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1277),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [876] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11085),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(5064),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1263),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [877] = {
    [sym__type_parens] = STATE(6922),
    [sym__type_tuple] = STATE(6929),
    [sym__type_unboxed_tuple] = STATE(6932),
    [sym__type_unboxed_sum] = STATE(6934),
    [sym__type_list] = STATE(6935),
    [sym__type_promoted] = STATE(6919),
    [sym__type_star] = STATE(6919),
    [sym__type_wildcard] = STATE(6919),
    [sym__at_type] = STATE(6946),
    [sym__type_apply] = STATE(6936),
    [sym__type_infix] = STATE(6937),
    [sym_type] = STATE(891),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8483),
    [sym__splice_dollars] = STATE(7213),
    [sym_splice] = STATE(6919),
    [sym_quasiquote] = STATE(6919),
    [sym_integer] = STATE(6980),
    [sym__plist] = STATE(6939),
    [sym_unit] = STATE(6919),
    [sym_unboxed_unit] = STATE(6919),
    [sym_prefix_tuple] = STATE(6919),
    [sym_prefix_unboxed_tuple] = STATE(6919),
    [sym_prefix_unboxed_sum] = STATE(6919),
    [sym_literal] = STATE(6919),
    [sym__qualified_type] = STATE(7018),
    [sym__qtyconid] = STATE(6940),
    [sym__tycon_arrow] = STATE(6940),
    [sym__qtycon_arrow] = STATE(6940),
    [sym__promoted_tycons_alias] = STATE(6919),
    [sym__promoted_tycons] = STATE(6919),
    [sym__tycon_ticked] = STATE(2421),
    [sym__qtycon_ticked] = STATE(2421),
    [sym__tyconids_ticked] = STATE(2421),
    [sym__promoted_tyconops_alias] = STATE(2421),
    [sym__promoted_tyconops] = STATE(2421),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2421),
    [sym__operator_alias] = STATE(2421),
    [sym__operator_minus] = STATE(2421),
    [sym__varsym_prefix] = STATE(6940),
    [sym__pvarsym] = STATE(6940),
    [sym__qualified_varsym] = STATE(2420),
    [sym__qvarsym_prefix] = STATE(6940),
    [sym__pqvarsym] = STATE(6940),
    [sym_constructor_operator] = STATE(2421),
    [sym__constructor_operator_alias] = STATE(2421),
    [sym__consym_prefix] = STATE(6940),
    [sym__pconsym] = STATE(6940),
    [sym__qualified_consym] = STATE(2419),
    [sym__qconsym_prefix] = STATE(6940),
    [sym__pqconsym] = STATE(6940),
    [sym__prefix_at] = STATE(2681),
    [sym__paren_open] = STATE(435),
    [sym__bracket_open] = STATE(1104),
    [sym__unboxed_open] = STATE(744),
    [sym_variable] = ACTIONS(1177),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1179),
    [anon_sym_u22b8] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym__phantom_bar] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_prefix_percent] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [878] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11085),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(4647),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1257),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [879] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10034),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(3692),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2247),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [880] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10133),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(3498),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(831),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [881] = {
    [sym__type_parens] = STATE(6909),
    [sym__type_tuple] = STATE(6883),
    [sym__type_unboxed_tuple] = STATE(6903),
    [sym__type_unboxed_sum] = STATE(6892),
    [sym__type_list] = STATE(6891),
    [sym__type_promoted] = STATE(6911),
    [sym__type_star] = STATE(6911),
    [sym__type_wildcard] = STATE(6911),
    [sym__at_type] = STATE(6938),
    [sym__type_apply] = STATE(6890),
    [sym__type_infix] = STATE(6959),
    [sym_type] = STATE(871),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8431),
    [sym__splice_dollars] = STATE(7211),
    [sym_splice] = STATE(6911),
    [sym_quasiquote] = STATE(6911),
    [sym_integer] = STATE(6928),
    [sym__plist] = STATE(6889),
    [sym_unit] = STATE(6911),
    [sym_unboxed_unit] = STATE(6911),
    [sym_prefix_tuple] = STATE(6911),
    [sym_prefix_unboxed_tuple] = STATE(6911),
    [sym_prefix_unboxed_sum] = STATE(6911),
    [sym_literal] = STATE(6911),
    [sym__qualified_type] = STATE(6933),
    [sym__qtyconid] = STATE(6884),
    [sym__tycon_arrow] = STATE(6884),
    [sym__qtycon_arrow] = STATE(6884),
    [sym__promoted_tycons_alias] = STATE(6911),
    [sym__promoted_tycons] = STATE(6911),
    [sym__tycon_ticked] = STATE(2427),
    [sym__qtycon_ticked] = STATE(2427),
    [sym__tyconids_ticked] = STATE(2427),
    [sym__promoted_tyconops_alias] = STATE(2427),
    [sym__promoted_tyconops] = STATE(2427),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2427),
    [sym__operator_alias] = STATE(2427),
    [sym__operator_minus] = STATE(2427),
    [sym__varsym_prefix] = STATE(6884),
    [sym__pvarsym] = STATE(6884),
    [sym__qualified_varsym] = STATE(2429),
    [sym__qvarsym_prefix] = STATE(6884),
    [sym__pqvarsym] = STATE(6884),
    [sym_constructor_operator] = STATE(2427),
    [sym__constructor_operator_alias] = STATE(2427),
    [sym__consym_prefix] = STATE(6884),
    [sym__pconsym] = STATE(6884),
    [sym__qualified_consym] = STATE(2431),
    [sym__qconsym_prefix] = STATE(6884),
    [sym__pqconsym] = STATE(6884),
    [sym__prefix_at] = STATE(2671),
    [sym__paren_open] = STATE(430),
    [sym__bracket_open] = STATE(1017),
    [sym__unboxed_open] = STATE(737),
    [sym_variable] = ACTIONS(2673),
    [anon_sym__] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(2677),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_u2605] = ACTIONS(2681),
    [anon_sym_EQ] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2683),
    [sym_char] = ACTIONS(2683),
    [sym_string] = ACTIONS(2683),
    [sym__integer_literal] = ACTIONS(2685),
    [sym__binary_literal] = ACTIONS(2687),
    [sym__octal_literal] = ACTIONS(2687),
    [sym__hex_literal] = ACTIONS(2687),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2689),
    [anon_sym_u2192] = ACTIONS(1123),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1123),
    [anon_sym_u22b8] = ACTIONS(1123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1123),
    [sym__phantom_bar] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2691),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1123),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [882] = {
    [sym__type_parens] = STATE(6922),
    [sym__type_tuple] = STATE(6929),
    [sym__type_unboxed_tuple] = STATE(6932),
    [sym__type_unboxed_sum] = STATE(6934),
    [sym__type_list] = STATE(6935),
    [sym__type_promoted] = STATE(6919),
    [sym__type_star] = STATE(6919),
    [sym__type_wildcard] = STATE(6919),
    [sym__at_type] = STATE(6946),
    [sym__type_apply] = STATE(6936),
    [sym__type_infix] = STATE(6937),
    [sym_type] = STATE(891),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8483),
    [sym__splice_dollars] = STATE(7213),
    [sym_splice] = STATE(6919),
    [sym_quasiquote] = STATE(6919),
    [sym_integer] = STATE(6980),
    [sym__plist] = STATE(6939),
    [sym_unit] = STATE(6919),
    [sym_unboxed_unit] = STATE(6919),
    [sym_prefix_tuple] = STATE(6919),
    [sym_prefix_unboxed_tuple] = STATE(6919),
    [sym_prefix_unboxed_sum] = STATE(6919),
    [sym_literal] = STATE(6919),
    [sym__qualified_type] = STATE(7018),
    [sym__qtyconid] = STATE(6940),
    [sym__tycon_arrow] = STATE(6940),
    [sym__qtycon_arrow] = STATE(6940),
    [sym__promoted_tycons_alias] = STATE(6919),
    [sym__promoted_tycons] = STATE(6919),
    [sym__tycon_ticked] = STATE(2421),
    [sym__qtycon_ticked] = STATE(2421),
    [sym__tyconids_ticked] = STATE(2421),
    [sym__promoted_tyconops_alias] = STATE(2421),
    [sym__promoted_tyconops] = STATE(2421),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2421),
    [sym__operator_alias] = STATE(2421),
    [sym__operator_minus] = STATE(2421),
    [sym__varsym_prefix] = STATE(6940),
    [sym__pvarsym] = STATE(6940),
    [sym__qualified_varsym] = STATE(2420),
    [sym__qvarsym_prefix] = STATE(6940),
    [sym__pqvarsym] = STATE(6940),
    [sym_constructor_operator] = STATE(2421),
    [sym__constructor_operator_alias] = STATE(2421),
    [sym__consym_prefix] = STATE(6940),
    [sym__pconsym] = STATE(6940),
    [sym__qualified_consym] = STATE(2419),
    [sym__qconsym_prefix] = STATE(6940),
    [sym__pqconsym] = STATE(6940),
    [sym__prefix_at] = STATE(2681),
    [sym__paren_open] = STATE(435),
    [sym__bracket_open] = STATE(1104),
    [sym__unboxed_open] = STATE(744),
    [sym_variable] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(2695),
    [anon_sym_SQUOTE] = ACTIONS(2697),
    [anon_sym_STAR] = ACTIONS(2699),
    [anon_sym_u2605] = ACTIONS(2701),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2703),
    [sym_char] = ACTIONS(2703),
    [sym_string] = ACTIONS(2703),
    [sym__integer_literal] = ACTIONS(2705),
    [sym__binary_literal] = ACTIONS(2707),
    [sym__octal_literal] = ACTIONS(2707),
    [sym__hex_literal] = ACTIONS(2707),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2709),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1157),
    [anon_sym_u22b8] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(1157),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym__phantom_bar] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2711),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [883] = {
    [sym__type_parens] = STATE(6922),
    [sym__type_tuple] = STATE(6929),
    [sym__type_unboxed_tuple] = STATE(6932),
    [sym__type_unboxed_sum] = STATE(6934),
    [sym__type_list] = STATE(6935),
    [sym__type_promoted] = STATE(6919),
    [sym__type_star] = STATE(6919),
    [sym__type_wildcard] = STATE(6919),
    [sym__at_type] = STATE(6946),
    [sym__type_apply] = STATE(6936),
    [sym__type_infix] = STATE(6937),
    [sym_type] = STATE(891),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8483),
    [sym__splice_dollars] = STATE(7213),
    [sym_splice] = STATE(6919),
    [sym_quasiquote] = STATE(6919),
    [sym_integer] = STATE(6980),
    [sym__plist] = STATE(6939),
    [sym_unit] = STATE(6919),
    [sym_unboxed_unit] = STATE(6919),
    [sym_prefix_tuple] = STATE(6919),
    [sym_prefix_unboxed_tuple] = STATE(6919),
    [sym_prefix_unboxed_sum] = STATE(6919),
    [sym_literal] = STATE(6919),
    [sym__qualified_type] = STATE(7018),
    [sym__qtyconid] = STATE(6940),
    [sym__tycon_arrow] = STATE(6940),
    [sym__qtycon_arrow] = STATE(6940),
    [sym__promoted_tycons_alias] = STATE(6919),
    [sym__promoted_tycons] = STATE(6919),
    [sym__tycon_ticked] = STATE(2421),
    [sym__qtycon_ticked] = STATE(2421),
    [sym__tyconids_ticked] = STATE(2421),
    [sym__promoted_tyconops_alias] = STATE(2421),
    [sym__promoted_tyconops] = STATE(2421),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2421),
    [sym__operator_alias] = STATE(2421),
    [sym__operator_minus] = STATE(2421),
    [sym__varsym_prefix] = STATE(6940),
    [sym__pvarsym] = STATE(6940),
    [sym__qualified_varsym] = STATE(2420),
    [sym__qvarsym_prefix] = STATE(6940),
    [sym__pqvarsym] = STATE(6940),
    [sym_constructor_operator] = STATE(2421),
    [sym__constructor_operator_alias] = STATE(2421),
    [sym__consym_prefix] = STATE(6940),
    [sym__pconsym] = STATE(6940),
    [sym__qualified_consym] = STATE(2419),
    [sym__qconsym_prefix] = STATE(6940),
    [sym__pqconsym] = STATE(6940),
    [sym__prefix_at] = STATE(2681),
    [sym__paren_open] = STATE(435),
    [sym__bracket_open] = STATE(1104),
    [sym__unboxed_open] = STATE(744),
    [sym_variable] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(2695),
    [anon_sym_SQUOTE] = ACTIONS(2697),
    [anon_sym_STAR] = ACTIONS(2699),
    [anon_sym_u2605] = ACTIONS(2701),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2703),
    [sym_char] = ACTIONS(2703),
    [sym_string] = ACTIONS(2703),
    [sym__integer_literal] = ACTIONS(2705),
    [sym__binary_literal] = ACTIONS(2707),
    [sym__octal_literal] = ACTIONS(2707),
    [sym__hex_literal] = ACTIONS(2707),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2709),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2711),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [884] = {
    [sym__type_parens] = STATE(6922),
    [sym__type_tuple] = STATE(6929),
    [sym__type_unboxed_tuple] = STATE(6932),
    [sym__type_unboxed_sum] = STATE(6934),
    [sym__type_list] = STATE(6935),
    [sym__type_promoted] = STATE(6919),
    [sym__type_star] = STATE(6919),
    [sym__type_wildcard] = STATE(6919),
    [sym__at_type] = STATE(6946),
    [sym__type_apply] = STATE(6936),
    [sym__type_infix] = STATE(6937),
    [sym_type] = STATE(891),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8483),
    [sym__splice_dollars] = STATE(7213),
    [sym_splice] = STATE(6919),
    [sym_quasiquote] = STATE(6919),
    [sym_integer] = STATE(6980),
    [sym__plist] = STATE(6939),
    [sym_unit] = STATE(6919),
    [sym_unboxed_unit] = STATE(6919),
    [sym_prefix_tuple] = STATE(6919),
    [sym_prefix_unboxed_tuple] = STATE(6919),
    [sym_prefix_unboxed_sum] = STATE(6919),
    [sym_literal] = STATE(6919),
    [sym__qualified_type] = STATE(7018),
    [sym__qtyconid] = STATE(6940),
    [sym__tycon_arrow] = STATE(6940),
    [sym__qtycon_arrow] = STATE(6940),
    [sym__promoted_tycons_alias] = STATE(6919),
    [sym__promoted_tycons] = STATE(6919),
    [sym__tycon_ticked] = STATE(2421),
    [sym__qtycon_ticked] = STATE(2421),
    [sym__tyconids_ticked] = STATE(2421),
    [sym__promoted_tyconops_alias] = STATE(2421),
    [sym__promoted_tyconops] = STATE(2421),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2421),
    [sym__operator_alias] = STATE(2421),
    [sym__operator_minus] = STATE(2421),
    [sym__varsym_prefix] = STATE(6940),
    [sym__pvarsym] = STATE(6940),
    [sym__qualified_varsym] = STATE(2420),
    [sym__qvarsym_prefix] = STATE(6940),
    [sym__pqvarsym] = STATE(6940),
    [sym_constructor_operator] = STATE(2421),
    [sym__constructor_operator_alias] = STATE(2421),
    [sym__consym_prefix] = STATE(6940),
    [sym__pconsym] = STATE(6940),
    [sym__qualified_consym] = STATE(2419),
    [sym__qconsym_prefix] = STATE(6940),
    [sym__pqconsym] = STATE(6940),
    [sym__prefix_at] = STATE(2681),
    [sym__paren_open] = STATE(435),
    [sym__bracket_open] = STATE(1104),
    [sym__unboxed_open] = STATE(744),
    [sym_variable] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(2695),
    [anon_sym_SQUOTE] = ACTIONS(2697),
    [anon_sym_STAR] = ACTIONS(2699),
    [anon_sym_u2605] = ACTIONS(2701),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2703),
    [sym_char] = ACTIONS(2703),
    [sym_string] = ACTIONS(2703),
    [sym__integer_literal] = ACTIONS(2705),
    [sym__binary_literal] = ACTIONS(2707),
    [sym__octal_literal] = ACTIONS(2707),
    [sym__hex_literal] = ACTIONS(2707),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2709),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2711),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [885] = {
    [sym__at_type] = STATE(6585),
    [sym_explicit_type] = STATE(6590),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(1234),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__variable_ticked] = STATE(2292),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__constructor_ticked] = STATE(2296),
    [sym__qconstructor_ticked] = STATE(2296),
    [sym__operator_hash_head] = STATE(8152),
    [sym_operator] = STATE(2292),
    [sym__varsym_prefix] = STATE(6638),
    [sym__pvarsym] = STATE(6638),
    [sym_constructor_operator] = STATE(2296),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__colon2] = STATE(1457),
    [sym__prefix_at] = STATE(2637),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(44),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(2713),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_EQ] = ACTIONS(2719),
    [anon_sym_PIPE] = ACTIONS(2719),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [anon_sym_BQUOTE] = ACTIONS(2721),
    [anon_sym_POUND] = ACTIONS(2723),
    [anon_sym_POUND2] = ACTIONS(2725),
    [sym_name] = ACTIONS(1947),
    [anon_sym_COLON_COLON] = ACTIONS(2727),
    [anon_sym_u2237] = ACTIONS(2727),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(2719),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(2729),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(2731),
    [sym__cond_no_section_op] = ACTIONS(2733),
    [sym__cond_minus] = ACTIONS(2735),
    [sym__varsym] = ACTIONS(2717),
    [sym__consym] = ACTIONS(2737),
  },
  [886] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__assoc_tyfam] = STATE(10138),
    [sym__assoc_tyinst] = STATE(10139),
    [sym__assoc_datafam] = STATE(10141),
    [sym_default_signature] = STATE(10146),
    [sym_class_decl] = STATE(9443),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10146),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10146),
    [sym__local_decl] = STATE(10146),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_data] = ACTIONS(1935),
    [anon_sym_default] = ACTIONS(1937),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [887] = {
    [sym__type_parens] = STATE(6909),
    [sym__type_tuple] = STATE(6883),
    [sym__type_unboxed_tuple] = STATE(6903),
    [sym__type_unboxed_sum] = STATE(6892),
    [sym__type_list] = STATE(6891),
    [sym__type_promoted] = STATE(6911),
    [sym__type_star] = STATE(6911),
    [sym__type_wildcard] = STATE(6911),
    [sym__at_type] = STATE(6938),
    [sym__type_apply] = STATE(6890),
    [sym__type_infix] = STATE(6959),
    [sym_type] = STATE(871),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8431),
    [sym__splice_dollars] = STATE(7211),
    [sym_splice] = STATE(6911),
    [sym_quasiquote] = STATE(6911),
    [sym_integer] = STATE(6928),
    [sym__plist] = STATE(6889),
    [sym_unit] = STATE(6911),
    [sym_unboxed_unit] = STATE(6911),
    [sym_prefix_tuple] = STATE(6911),
    [sym_prefix_unboxed_tuple] = STATE(6911),
    [sym_prefix_unboxed_sum] = STATE(6911),
    [sym_literal] = STATE(6911),
    [sym__qualified_type] = STATE(6933),
    [sym__qtyconid] = STATE(6884),
    [sym__tycon_arrow] = STATE(6884),
    [sym__qtycon_arrow] = STATE(6884),
    [sym__promoted_tycons_alias] = STATE(6911),
    [sym__promoted_tycons] = STATE(6911),
    [sym__tycon_ticked] = STATE(2427),
    [sym__qtycon_ticked] = STATE(2427),
    [sym__tyconids_ticked] = STATE(2427),
    [sym__promoted_tyconops_alias] = STATE(2427),
    [sym__promoted_tyconops] = STATE(2427),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2427),
    [sym__operator_alias] = STATE(2427),
    [sym__operator_minus] = STATE(2427),
    [sym__varsym_prefix] = STATE(6884),
    [sym__pvarsym] = STATE(6884),
    [sym__qualified_varsym] = STATE(2429),
    [sym__qvarsym_prefix] = STATE(6884),
    [sym__pqvarsym] = STATE(6884),
    [sym_constructor_operator] = STATE(2427),
    [sym__constructor_operator_alias] = STATE(2427),
    [sym__consym_prefix] = STATE(6884),
    [sym__pconsym] = STATE(6884),
    [sym__qualified_consym] = STATE(2431),
    [sym__qconsym_prefix] = STATE(6884),
    [sym__pqconsym] = STATE(6884),
    [sym__prefix_at] = STATE(2671),
    [sym__paren_open] = STATE(430),
    [sym__bracket_open] = STATE(1017),
    [sym__unboxed_open] = STATE(737),
    [sym_variable] = ACTIONS(2673),
    [anon_sym__] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(2677),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_u2605] = ACTIONS(2681),
    [anon_sym_EQ] = ACTIONS(1157),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2683),
    [sym_char] = ACTIONS(2683),
    [sym_string] = ACTIONS(2683),
    [sym__integer_literal] = ACTIONS(2685),
    [sym__binary_literal] = ACTIONS(2687),
    [sym__octal_literal] = ACTIONS(2687),
    [sym__hex_literal] = ACTIONS(2687),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2689),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1157),
    [anon_sym_u22b8] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym__phantom_bar] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2691),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [888] = {
    [sym__type_parens] = STATE(6989),
    [sym__type_tuple] = STATE(6991),
    [sym__type_unboxed_tuple] = STATE(6992),
    [sym__type_unboxed_sum] = STATE(6993),
    [sym__type_list] = STATE(6994),
    [sym__type_promoted] = STATE(6987),
    [sym__type_star] = STATE(6987),
    [sym__type_wildcard] = STATE(6987),
    [sym__at_type] = STATE(7002),
    [sym__type_apply] = STATE(6995),
    [sym__type_infix] = STATE(6927),
    [sym_type] = STATE(915),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8441),
    [sym__splice_dollars] = STATE(7369),
    [sym_splice] = STATE(6987),
    [sym_quasiquote] = STATE(6987),
    [sym_integer] = STATE(6887),
    [sym__plist] = STATE(6996),
    [sym_unit] = STATE(6987),
    [sym_unboxed_unit] = STATE(6987),
    [sym_prefix_tuple] = STATE(6987),
    [sym_prefix_unboxed_tuple] = STATE(6987),
    [sym_prefix_unboxed_sum] = STATE(6987),
    [sym_literal] = STATE(6987),
    [sym__qualified_type] = STATE(6931),
    [sym__qtyconid] = STATE(6997),
    [sym__tycon_arrow] = STATE(6997),
    [sym__qtycon_arrow] = STATE(6997),
    [sym__promoted_tycons_alias] = STATE(6987),
    [sym__promoted_tycons] = STATE(6987),
    [sym__tycon_ticked] = STATE(2471),
    [sym__qtycon_ticked] = STATE(2471),
    [sym__tyconids_ticked] = STATE(2471),
    [sym__promoted_tyconops_alias] = STATE(2471),
    [sym__promoted_tyconops] = STATE(2471),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2471),
    [sym__operator_alias] = STATE(2471),
    [sym__operator_minus] = STATE(2471),
    [sym__varsym_prefix] = STATE(6997),
    [sym__pvarsym] = STATE(6997),
    [sym__qualified_varsym] = STATE(2472),
    [sym__qvarsym_prefix] = STATE(6997),
    [sym__pqvarsym] = STATE(6997),
    [sym_constructor_operator] = STATE(2471),
    [sym__constructor_operator_alias] = STATE(2471),
    [sym__consym_prefix] = STATE(6997),
    [sym__pconsym] = STATE(6997),
    [sym__qualified_consym] = STATE(2473),
    [sym__qconsym_prefix] = STATE(6997),
    [sym__pqconsym] = STATE(6997),
    [sym__prefix_at] = STATE(2689),
    [sym__paren_open] = STATE(459),
    [sym__bracket_open] = STATE(1113),
    [sym__unboxed_open] = STATE(793),
    [sym_variable] = ACTIONS(1177),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_tight_bang] = ACTIONS(1179),
    [sym__cond_prefix_bang] = ACTIONS(1179),
    [sym__cond_tight_tilde] = ACTIONS(1179),
    [sym__cond_prefix_tilde] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [889] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10700),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(3631),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(823),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [890] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10163),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(4635),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2331),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [891] = {
    [sym__type_parens] = STATE(6922),
    [sym__type_tuple] = STATE(6929),
    [sym__type_unboxed_tuple] = STATE(6932),
    [sym__type_unboxed_sum] = STATE(6934),
    [sym__type_list] = STATE(6935),
    [sym__type_promoted] = STATE(6919),
    [sym__type_star] = STATE(6919),
    [sym__type_wildcard] = STATE(6919),
    [sym__at_type] = STATE(6946),
    [sym__type_apply] = STATE(6936),
    [sym__type_infix] = STATE(6937),
    [sym_type] = STATE(891),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8483),
    [sym__splice_dollars] = STATE(7213),
    [sym_splice] = STATE(6919),
    [sym_quasiquote] = STATE(6919),
    [sym_integer] = STATE(6980),
    [sym__plist] = STATE(6939),
    [sym_unit] = STATE(6919),
    [sym_unboxed_unit] = STATE(6919),
    [sym_prefix_tuple] = STATE(6919),
    [sym_prefix_unboxed_tuple] = STATE(6919),
    [sym_prefix_unboxed_sum] = STATE(6919),
    [sym_literal] = STATE(6919),
    [sym__qualified_type] = STATE(7018),
    [sym__qtyconid] = STATE(6940),
    [sym__tycon_arrow] = STATE(6940),
    [sym__qtycon_arrow] = STATE(6940),
    [sym__promoted_tycons_alias] = STATE(6919),
    [sym__promoted_tycons] = STATE(6919),
    [sym__tycon_ticked] = STATE(2421),
    [sym__qtycon_ticked] = STATE(2421),
    [sym__tyconids_ticked] = STATE(2421),
    [sym__promoted_tyconops_alias] = STATE(2421),
    [sym__promoted_tyconops] = STATE(2421),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2421),
    [sym__operator_alias] = STATE(2421),
    [sym__operator_minus] = STATE(2421),
    [sym__varsym_prefix] = STATE(6940),
    [sym__pvarsym] = STATE(6940),
    [sym__qualified_varsym] = STATE(2420),
    [sym__qvarsym_prefix] = STATE(6940),
    [sym__pqvarsym] = STATE(6940),
    [sym_constructor_operator] = STATE(2421),
    [sym__constructor_operator_alias] = STATE(2421),
    [sym__consym_prefix] = STATE(6940),
    [sym__pconsym] = STATE(6940),
    [sym__qualified_consym] = STATE(2419),
    [sym__qconsym_prefix] = STATE(6940),
    [sym__pqconsym] = STATE(6940),
    [sym__prefix_at] = STATE(2681),
    [sym__paren_open] = STATE(435),
    [sym__bracket_open] = STATE(1104),
    [sym__unboxed_open] = STATE(744),
    [sym_variable] = ACTIONS(1117),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1119),
    [anon_sym_u22b8] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(1119),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym__phantom_bar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_prefix_percent] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [892] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11085),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(4168),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1249),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [893] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10208),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(5014),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2287),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [894] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10439),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(4250),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2211),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [895] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10133),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(2865),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(861),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [896] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11085),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(2867),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [897] = {
    [sym__type_parens] = STATE(6909),
    [sym__type_tuple] = STATE(6883),
    [sym__type_unboxed_tuple] = STATE(6903),
    [sym__type_unboxed_sum] = STATE(6892),
    [sym__type_list] = STATE(6891),
    [sym__type_promoted] = STATE(6911),
    [sym__type_star] = STATE(6911),
    [sym__type_wildcard] = STATE(6911),
    [sym__at_type] = STATE(6938),
    [sym__type_apply] = STATE(6890),
    [sym__type_infix] = STATE(6959),
    [sym_type] = STATE(871),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8431),
    [sym__splice_dollars] = STATE(7211),
    [sym_splice] = STATE(6911),
    [sym_quasiquote] = STATE(6911),
    [sym_integer] = STATE(6928),
    [sym__plist] = STATE(6889),
    [sym_unit] = STATE(6911),
    [sym_unboxed_unit] = STATE(6911),
    [sym_prefix_tuple] = STATE(6911),
    [sym_prefix_unboxed_tuple] = STATE(6911),
    [sym_prefix_unboxed_sum] = STATE(6911),
    [sym_literal] = STATE(6911),
    [sym__qualified_type] = STATE(6933),
    [sym__qtyconid] = STATE(6884),
    [sym__tycon_arrow] = STATE(6884),
    [sym__qtycon_arrow] = STATE(6884),
    [sym__promoted_tycons_alias] = STATE(6911),
    [sym__promoted_tycons] = STATE(6911),
    [sym__tycon_ticked] = STATE(2427),
    [sym__qtycon_ticked] = STATE(2427),
    [sym__tyconids_ticked] = STATE(2427),
    [sym__promoted_tyconops_alias] = STATE(2427),
    [sym__promoted_tyconops] = STATE(2427),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2427),
    [sym__operator_alias] = STATE(2427),
    [sym__operator_minus] = STATE(2427),
    [sym__varsym_prefix] = STATE(6884),
    [sym__pvarsym] = STATE(6884),
    [sym__qualified_varsym] = STATE(2429),
    [sym__qvarsym_prefix] = STATE(6884),
    [sym__pqvarsym] = STATE(6884),
    [sym_constructor_operator] = STATE(2427),
    [sym__constructor_operator_alias] = STATE(2427),
    [sym__consym_prefix] = STATE(6884),
    [sym__pconsym] = STATE(6884),
    [sym__qualified_consym] = STATE(2431),
    [sym__qconsym_prefix] = STATE(6884),
    [sym__pqconsym] = STATE(6884),
    [sym__prefix_at] = STATE(2671),
    [sym__paren_open] = STATE(430),
    [sym__bracket_open] = STATE(1017),
    [sym__unboxed_open] = STATE(737),
    [sym_variable] = ACTIONS(1177),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1179),
    [anon_sym_u22b8] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym__phantom_bar] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_prefix_percent] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [898] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10163),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(3590),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(847),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [899] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11085),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(4094),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1295),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [900] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10700),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(4164),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2347),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [901] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11085),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(3302),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(185),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [902] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10811),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(3307),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(805),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [903] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11085),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(4407),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1269),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [904] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10811),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(4412),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2511),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [905] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10382),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(2865),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(861),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [906] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11085),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(3691),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1255),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [907] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10439),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(3785),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(815),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [908] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11085),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(3779),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(169),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [909] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10860),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(3498),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(831),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [910] = {
    [sym__type_parens] = STATE(6922),
    [sym__type_tuple] = STATE(6929),
    [sym__type_unboxed_tuple] = STATE(6932),
    [sym__type_unboxed_sum] = STATE(6934),
    [sym__type_list] = STATE(6935),
    [sym__type_promoted] = STATE(6919),
    [sym__type_star] = STATE(6919),
    [sym__type_wildcard] = STATE(6919),
    [sym__at_type] = STATE(6946),
    [sym__type_apply] = STATE(6936),
    [sym__type_infix] = STATE(6937),
    [sym_type] = STATE(891),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8483),
    [sym__splice_dollars] = STATE(7213),
    [sym_splice] = STATE(6919),
    [sym_quasiquote] = STATE(6919),
    [sym_integer] = STATE(6980),
    [sym__plist] = STATE(6939),
    [sym_unit] = STATE(6919),
    [sym_unboxed_unit] = STATE(6919),
    [sym_prefix_tuple] = STATE(6919),
    [sym_prefix_unboxed_tuple] = STATE(6919),
    [sym_prefix_unboxed_sum] = STATE(6919),
    [sym_literal] = STATE(6919),
    [sym__qualified_type] = STATE(7018),
    [sym__qtyconid] = STATE(6940),
    [sym__tycon_arrow] = STATE(6940),
    [sym__qtycon_arrow] = STATE(6940),
    [sym__promoted_tycons_alias] = STATE(6919),
    [sym__promoted_tycons] = STATE(6919),
    [sym__tycon_ticked] = STATE(2421),
    [sym__qtycon_ticked] = STATE(2421),
    [sym__tyconids_ticked] = STATE(2421),
    [sym__promoted_tyconops_alias] = STATE(2421),
    [sym__promoted_tyconops] = STATE(2421),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2421),
    [sym__operator_alias] = STATE(2421),
    [sym__operator_minus] = STATE(2421),
    [sym__varsym_prefix] = STATE(6940),
    [sym__pvarsym] = STATE(6940),
    [sym__qualified_varsym] = STATE(2420),
    [sym__qvarsym_prefix] = STATE(6940),
    [sym__pqvarsym] = STATE(6940),
    [sym_constructor_operator] = STATE(2421),
    [sym__constructor_operator_alias] = STATE(2421),
    [sym__consym_prefix] = STATE(6940),
    [sym__pconsym] = STATE(6940),
    [sym__qualified_consym] = STATE(2419),
    [sym__qconsym_prefix] = STATE(6940),
    [sym__pqconsym] = STATE(6940),
    [sym__prefix_at] = STATE(2681),
    [sym__paren_open] = STATE(435),
    [sym__bracket_open] = STATE(1104),
    [sym__unboxed_open] = STATE(744),
    [sym_variable] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(2695),
    [anon_sym_SQUOTE] = ACTIONS(2697),
    [anon_sym_STAR] = ACTIONS(2699),
    [anon_sym_u2605] = ACTIONS(2701),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2703),
    [sym_char] = ACTIONS(2703),
    [sym_string] = ACTIONS(2703),
    [sym__integer_literal] = ACTIONS(2705),
    [sym__binary_literal] = ACTIONS(2707),
    [sym__octal_literal] = ACTIONS(2707),
    [sym__hex_literal] = ACTIONS(2707),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2709),
    [anon_sym_u2192] = ACTIONS(1123),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1123),
    [anon_sym_u22b8] = ACTIONS(1123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(1123),
    [sym__phantom_arrow] = ACTIONS(1123),
    [sym__phantom_bar] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2711),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1123),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [911] = {
    [sym__type_parens] = STATE(6909),
    [sym__type_tuple] = STATE(6883),
    [sym__type_unboxed_tuple] = STATE(6903),
    [sym__type_unboxed_sum] = STATE(6892),
    [sym__type_list] = STATE(6891),
    [sym__type_promoted] = STATE(6911),
    [sym__type_star] = STATE(6911),
    [sym__type_wildcard] = STATE(6911),
    [sym__at_type] = STATE(6938),
    [sym__type_apply] = STATE(6890),
    [sym__type_infix] = STATE(6959),
    [sym_type] = STATE(871),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8431),
    [sym__splice_dollars] = STATE(7211),
    [sym_splice] = STATE(6911),
    [sym_quasiquote] = STATE(6911),
    [sym_integer] = STATE(6928),
    [sym__plist] = STATE(6889),
    [sym_unit] = STATE(6911),
    [sym_unboxed_unit] = STATE(6911),
    [sym_prefix_tuple] = STATE(6911),
    [sym_prefix_unboxed_tuple] = STATE(6911),
    [sym_prefix_unboxed_sum] = STATE(6911),
    [sym_literal] = STATE(6911),
    [sym__qualified_type] = STATE(6933),
    [sym__qtyconid] = STATE(6884),
    [sym__tycon_arrow] = STATE(6884),
    [sym__qtycon_arrow] = STATE(6884),
    [sym__promoted_tycons_alias] = STATE(6911),
    [sym__promoted_tycons] = STATE(6911),
    [sym__tycon_ticked] = STATE(2427),
    [sym__qtycon_ticked] = STATE(2427),
    [sym__tyconids_ticked] = STATE(2427),
    [sym__promoted_tyconops_alias] = STATE(2427),
    [sym__promoted_tyconops] = STATE(2427),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2427),
    [sym__operator_alias] = STATE(2427),
    [sym__operator_minus] = STATE(2427),
    [sym__varsym_prefix] = STATE(6884),
    [sym__pvarsym] = STATE(6884),
    [sym__qualified_varsym] = STATE(2429),
    [sym__qvarsym_prefix] = STATE(6884),
    [sym__pqvarsym] = STATE(6884),
    [sym_constructor_operator] = STATE(2427),
    [sym__constructor_operator_alias] = STATE(2427),
    [sym__consym_prefix] = STATE(6884),
    [sym__pconsym] = STATE(6884),
    [sym__qualified_consym] = STATE(2431),
    [sym__qconsym_prefix] = STATE(6884),
    [sym__pqconsym] = STATE(6884),
    [sym__prefix_at] = STATE(2671),
    [sym__paren_open] = STATE(430),
    [sym__bracket_open] = STATE(1017),
    [sym__unboxed_open] = STATE(737),
    [sym_variable] = ACTIONS(2673),
    [anon_sym__] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(2677),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_u2605] = ACTIONS(2681),
    [anon_sym_EQ] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2683),
    [sym_char] = ACTIONS(2683),
    [sym_string] = ACTIONS(2683),
    [sym__integer_literal] = ACTIONS(2685),
    [sym__binary_literal] = ACTIONS(2687),
    [sym__octal_literal] = ACTIONS(2687),
    [sym__hex_literal] = ACTIONS(2687),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2689),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2691),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [912] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10811),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(3568),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(869),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [913] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11085),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(3591),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(197),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [914] = {
    [sym__type_parens] = STATE(6909),
    [sym__type_tuple] = STATE(6883),
    [sym__type_unboxed_tuple] = STATE(6903),
    [sym__type_unboxed_sum] = STATE(6892),
    [sym__type_list] = STATE(6891),
    [sym__type_promoted] = STATE(6911),
    [sym__type_star] = STATE(6911),
    [sym__type_wildcard] = STATE(6911),
    [sym__at_type] = STATE(6938),
    [sym__type_apply] = STATE(6890),
    [sym__type_infix] = STATE(6959),
    [sym_type] = STATE(871),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8431),
    [sym__splice_dollars] = STATE(7211),
    [sym_splice] = STATE(6911),
    [sym_quasiquote] = STATE(6911),
    [sym_integer] = STATE(6928),
    [sym__plist] = STATE(6889),
    [sym_unit] = STATE(6911),
    [sym_unboxed_unit] = STATE(6911),
    [sym_prefix_tuple] = STATE(6911),
    [sym_prefix_unboxed_tuple] = STATE(6911),
    [sym_prefix_unboxed_sum] = STATE(6911),
    [sym_literal] = STATE(6911),
    [sym__qualified_type] = STATE(6933),
    [sym__qtyconid] = STATE(6884),
    [sym__tycon_arrow] = STATE(6884),
    [sym__qtycon_arrow] = STATE(6884),
    [sym__promoted_tycons_alias] = STATE(6911),
    [sym__promoted_tycons] = STATE(6911),
    [sym__tycon_ticked] = STATE(2427),
    [sym__qtycon_ticked] = STATE(2427),
    [sym__tyconids_ticked] = STATE(2427),
    [sym__promoted_tyconops_alias] = STATE(2427),
    [sym__promoted_tyconops] = STATE(2427),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2427),
    [sym__operator_alias] = STATE(2427),
    [sym__operator_minus] = STATE(2427),
    [sym__varsym_prefix] = STATE(6884),
    [sym__pvarsym] = STATE(6884),
    [sym__qualified_varsym] = STATE(2429),
    [sym__qvarsym_prefix] = STATE(6884),
    [sym__pqvarsym] = STATE(6884),
    [sym_constructor_operator] = STATE(2427),
    [sym__constructor_operator_alias] = STATE(2427),
    [sym__consym_prefix] = STATE(6884),
    [sym__pconsym] = STATE(6884),
    [sym__qualified_consym] = STATE(2431),
    [sym__qconsym_prefix] = STATE(6884),
    [sym__pqconsym] = STATE(6884),
    [sym__prefix_at] = STATE(2671),
    [sym__paren_open] = STATE(430),
    [sym__bracket_open] = STATE(1017),
    [sym__unboxed_open] = STATE(737),
    [sym_variable] = ACTIONS(2673),
    [anon_sym__] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(2677),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_u2605] = ACTIONS(2681),
    [anon_sym_EQ] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2683),
    [sym_char] = ACTIONS(2683),
    [sym_string] = ACTIONS(2683),
    [sym__integer_literal] = ACTIONS(2685),
    [sym__binary_literal] = ACTIONS(2687),
    [sym__octal_literal] = ACTIONS(2687),
    [sym__hex_literal] = ACTIONS(2687),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2689),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2691),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [915] = {
    [sym__type_parens] = STATE(6989),
    [sym__type_tuple] = STATE(6991),
    [sym__type_unboxed_tuple] = STATE(6992),
    [sym__type_unboxed_sum] = STATE(6993),
    [sym__type_list] = STATE(6994),
    [sym__type_promoted] = STATE(6987),
    [sym__type_star] = STATE(6987),
    [sym__type_wildcard] = STATE(6987),
    [sym__at_type] = STATE(7002),
    [sym__type_apply] = STATE(6995),
    [sym__type_infix] = STATE(6927),
    [sym_type] = STATE(915),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8441),
    [sym__splice_dollars] = STATE(7369),
    [sym_splice] = STATE(6987),
    [sym_quasiquote] = STATE(6987),
    [sym_integer] = STATE(6887),
    [sym__plist] = STATE(6996),
    [sym_unit] = STATE(6987),
    [sym_unboxed_unit] = STATE(6987),
    [sym_prefix_tuple] = STATE(6987),
    [sym_prefix_unboxed_tuple] = STATE(6987),
    [sym_prefix_unboxed_sum] = STATE(6987),
    [sym_literal] = STATE(6987),
    [sym__qualified_type] = STATE(6931),
    [sym__qtyconid] = STATE(6997),
    [sym__tycon_arrow] = STATE(6997),
    [sym__qtycon_arrow] = STATE(6997),
    [sym__promoted_tycons_alias] = STATE(6987),
    [sym__promoted_tycons] = STATE(6987),
    [sym__tycon_ticked] = STATE(2471),
    [sym__qtycon_ticked] = STATE(2471),
    [sym__tyconids_ticked] = STATE(2471),
    [sym__promoted_tyconops_alias] = STATE(2471),
    [sym__promoted_tyconops] = STATE(2471),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2471),
    [sym__operator_alias] = STATE(2471),
    [sym__operator_minus] = STATE(2471),
    [sym__varsym_prefix] = STATE(6997),
    [sym__pvarsym] = STATE(6997),
    [sym__qualified_varsym] = STATE(2472),
    [sym__qvarsym_prefix] = STATE(6997),
    [sym__pqvarsym] = STATE(6997),
    [sym_constructor_operator] = STATE(2471),
    [sym__constructor_operator_alias] = STATE(2471),
    [sym__consym_prefix] = STATE(6997),
    [sym__pconsym] = STATE(6997),
    [sym__qualified_consym] = STATE(2473),
    [sym__qconsym_prefix] = STATE(6997),
    [sym__pqconsym] = STATE(6997),
    [sym__prefix_at] = STATE(2689),
    [sym__paren_open] = STATE(459),
    [sym__bracket_open] = STATE(1113),
    [sym__unboxed_open] = STATE(793),
    [sym_variable] = ACTIONS(1117),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_EQ] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_tight_bang] = ACTIONS(1119),
    [sym__cond_prefix_bang] = ACTIONS(1119),
    [sym__cond_tight_tilde] = ACTIONS(1119),
    [sym__cond_prefix_tilde] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [916] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10382),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(4646),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2197),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [917] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11085),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(4619),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1275),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [918] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11085),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(4016),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [919] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10860),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(4092),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2023),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [920] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__assoc_tyfam] = STATE(10138),
    [sym__assoc_tyinst] = STATE(10139),
    [sym__assoc_datafam] = STATE(10141),
    [sym_default_signature] = STATE(10146),
    [sym_class_decl] = STATE(10736),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10146),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10146),
    [sym__local_decl] = STATE(10146),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_data] = ACTIONS(1935),
    [anon_sym_default] = ACTIONS(1937),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [921] = {
    [sym__type_parens] = STATE(6989),
    [sym__type_tuple] = STATE(6991),
    [sym__type_unboxed_tuple] = STATE(6992),
    [sym__type_unboxed_sum] = STATE(6993),
    [sym__type_list] = STATE(6994),
    [sym__type_promoted] = STATE(6987),
    [sym__type_star] = STATE(6987),
    [sym__type_wildcard] = STATE(6987),
    [sym__at_type] = STATE(7002),
    [sym__type_apply] = STATE(6995),
    [sym__type_infix] = STATE(6927),
    [sym_type] = STATE(915),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8441),
    [sym__splice_dollars] = STATE(7369),
    [sym_splice] = STATE(6987),
    [sym_quasiquote] = STATE(6987),
    [sym_integer] = STATE(6887),
    [sym__plist] = STATE(6996),
    [sym_unit] = STATE(6987),
    [sym_unboxed_unit] = STATE(6987),
    [sym_prefix_tuple] = STATE(6987),
    [sym_prefix_unboxed_tuple] = STATE(6987),
    [sym_prefix_unboxed_sum] = STATE(6987),
    [sym_literal] = STATE(6987),
    [sym__qualified_type] = STATE(6931),
    [sym__qtyconid] = STATE(6997),
    [sym__tycon_arrow] = STATE(6997),
    [sym__qtycon_arrow] = STATE(6997),
    [sym__promoted_tycons_alias] = STATE(6987),
    [sym__promoted_tycons] = STATE(6987),
    [sym__tycon_ticked] = STATE(2471),
    [sym__qtycon_ticked] = STATE(2471),
    [sym__tyconids_ticked] = STATE(2471),
    [sym__promoted_tyconops_alias] = STATE(2471),
    [sym__promoted_tyconops] = STATE(2471),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2471),
    [sym__operator_alias] = STATE(2471),
    [sym__operator_minus] = STATE(2471),
    [sym__varsym_prefix] = STATE(6997),
    [sym__pvarsym] = STATE(6997),
    [sym__qualified_varsym] = STATE(2472),
    [sym__qvarsym_prefix] = STATE(6997),
    [sym__pqvarsym] = STATE(6997),
    [sym_constructor_operator] = STATE(2471),
    [sym__constructor_operator_alias] = STATE(2471),
    [sym__consym_prefix] = STATE(6997),
    [sym__pconsym] = STATE(6997),
    [sym__qualified_consym] = STATE(2473),
    [sym__qconsym_prefix] = STATE(6997),
    [sym__pqconsym] = STATE(6997),
    [sym__prefix_at] = STATE(2689),
    [sym__paren_open] = STATE(459),
    [sym__bracket_open] = STATE(1113),
    [sym__unboxed_open] = STATE(793),
    [sym_variable] = ACTIONS(2739),
    [anon_sym__] = ACTIONS(2741),
    [anon_sym_SQUOTE] = ACTIONS(2667),
    [anon_sym_STAR] = ACTIONS(2669),
    [anon_sym_u2605] = ACTIONS(2671),
    [anon_sym_EQ] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2743),
    [sym_char] = ACTIONS(2743),
    [sym_string] = ACTIONS(2743),
    [sym__integer_literal] = ACTIONS(2745),
    [sym__binary_literal] = ACTIONS(2747),
    [sym__octal_literal] = ACTIONS(2747),
    [sym__hex_literal] = ACTIONS(2747),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2749),
    [anon_sym_u2192] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2751),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1181),
    [sym__cond_prefix_bang] = ACTIONS(1181),
    [sym__cond_tight_tilde] = ACTIONS(1181),
    [sym__cond_prefix_tilde] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [922] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11085),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(3565),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(201),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [923] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10597),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(4002),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2107),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [924] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11085),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(2702),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1279),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [925] = {
    [sym__type_parens] = STATE(6989),
    [sym__type_tuple] = STATE(6991),
    [sym__type_unboxed_tuple] = STATE(6992),
    [sym__type_unboxed_sum] = STATE(6993),
    [sym__type_list] = STATE(6994),
    [sym__type_promoted] = STATE(6987),
    [sym__type_star] = STATE(6987),
    [sym__type_wildcard] = STATE(6987),
    [sym__at_type] = STATE(7002),
    [sym__type_apply] = STATE(6995),
    [sym__type_infix] = STATE(6927),
    [sym_type] = STATE(915),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8441),
    [sym__splice_dollars] = STATE(7369),
    [sym_splice] = STATE(6987),
    [sym_quasiquote] = STATE(6987),
    [sym_integer] = STATE(6887),
    [sym__plist] = STATE(6996),
    [sym_unit] = STATE(6987),
    [sym_unboxed_unit] = STATE(6987),
    [sym_prefix_tuple] = STATE(6987),
    [sym_prefix_unboxed_tuple] = STATE(6987),
    [sym_prefix_unboxed_sum] = STATE(6987),
    [sym_literal] = STATE(6987),
    [sym__qualified_type] = STATE(6931),
    [sym__qtyconid] = STATE(6997),
    [sym__tycon_arrow] = STATE(6997),
    [sym__qtycon_arrow] = STATE(6997),
    [sym__promoted_tycons_alias] = STATE(6987),
    [sym__promoted_tycons] = STATE(6987),
    [sym__tycon_ticked] = STATE(2471),
    [sym__qtycon_ticked] = STATE(2471),
    [sym__tyconids_ticked] = STATE(2471),
    [sym__promoted_tyconops_alias] = STATE(2471),
    [sym__promoted_tyconops] = STATE(2471),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2471),
    [sym__operator_alias] = STATE(2471),
    [sym__operator_minus] = STATE(2471),
    [sym__varsym_prefix] = STATE(6997),
    [sym__pvarsym] = STATE(6997),
    [sym__qualified_varsym] = STATE(2472),
    [sym__qvarsym_prefix] = STATE(6997),
    [sym__pqvarsym] = STATE(6997),
    [sym_constructor_operator] = STATE(2471),
    [sym__constructor_operator_alias] = STATE(2471),
    [sym__consym_prefix] = STATE(6997),
    [sym__pconsym] = STATE(6997),
    [sym__qualified_consym] = STATE(2473),
    [sym__qconsym_prefix] = STATE(6997),
    [sym__pqconsym] = STATE(6997),
    [sym__prefix_at] = STATE(2689),
    [sym__paren_open] = STATE(459),
    [sym__bracket_open] = STATE(1113),
    [sym__unboxed_open] = STATE(793),
    [sym_variable] = ACTIONS(2739),
    [anon_sym__] = ACTIONS(2741),
    [anon_sym_SQUOTE] = ACTIONS(2667),
    [anon_sym_STAR] = ACTIONS(2669),
    [anon_sym_u2605] = ACTIONS(2671),
    [anon_sym_EQ] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2743),
    [sym_char] = ACTIONS(2743),
    [sym_string] = ACTIONS(2743),
    [sym__integer_literal] = ACTIONS(2745),
    [sym__binary_literal] = ACTIONS(2747),
    [sym__octal_literal] = ACTIONS(2747),
    [sym__hex_literal] = ACTIONS(2747),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2749),
    [anon_sym_u2192] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2751),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1181),
    [sym__cond_prefix_bang] = ACTIONS(1181),
    [sym__cond_tight_tilde] = ACTIONS(1181),
    [sym__cond_prefix_tilde] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [926] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10133),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym__unboxed_close] = STATE(2700),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(7658),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2081),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [927] = {
    [sym__type_parens] = STATE(6989),
    [sym__type_tuple] = STATE(6991),
    [sym__type_unboxed_tuple] = STATE(6992),
    [sym__type_unboxed_sum] = STATE(6993),
    [sym__type_list] = STATE(6994),
    [sym__type_promoted] = STATE(6987),
    [sym__type_star] = STATE(6987),
    [sym__type_wildcard] = STATE(6987),
    [sym__at_type] = STATE(7002),
    [sym__type_apply] = STATE(6995),
    [sym__type_infix] = STATE(6927),
    [sym_type] = STATE(915),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8441),
    [sym__splice_dollars] = STATE(7369),
    [sym_splice] = STATE(6987),
    [sym_quasiquote] = STATE(6987),
    [sym_integer] = STATE(6887),
    [sym__plist] = STATE(6996),
    [sym_unit] = STATE(6987),
    [sym_unboxed_unit] = STATE(6987),
    [sym_prefix_tuple] = STATE(6987),
    [sym_prefix_unboxed_tuple] = STATE(6987),
    [sym_prefix_unboxed_sum] = STATE(6987),
    [sym_literal] = STATE(6987),
    [sym__qualified_type] = STATE(6931),
    [sym__qtyconid] = STATE(6997),
    [sym__tycon_arrow] = STATE(6997),
    [sym__qtycon_arrow] = STATE(6997),
    [sym__promoted_tycons_alias] = STATE(6987),
    [sym__promoted_tycons] = STATE(6987),
    [sym__tycon_ticked] = STATE(2471),
    [sym__qtycon_ticked] = STATE(2471),
    [sym__tyconids_ticked] = STATE(2471),
    [sym__promoted_tyconops_alias] = STATE(2471),
    [sym__promoted_tyconops] = STATE(2471),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2471),
    [sym__operator_alias] = STATE(2471),
    [sym__operator_minus] = STATE(2471),
    [sym__varsym_prefix] = STATE(6997),
    [sym__pvarsym] = STATE(6997),
    [sym__qualified_varsym] = STATE(2472),
    [sym__qvarsym_prefix] = STATE(6997),
    [sym__pqvarsym] = STATE(6997),
    [sym_constructor_operator] = STATE(2471),
    [sym__constructor_operator_alias] = STATE(2471),
    [sym__consym_prefix] = STATE(6997),
    [sym__pconsym] = STATE(6997),
    [sym__qualified_consym] = STATE(2473),
    [sym__qconsym_prefix] = STATE(6997),
    [sym__pqconsym] = STATE(6997),
    [sym__prefix_at] = STATE(2689),
    [sym__paren_open] = STATE(459),
    [sym__bracket_open] = STATE(1113),
    [sym__unboxed_open] = STATE(793),
    [sym_variable] = ACTIONS(2739),
    [anon_sym__] = ACTIONS(2741),
    [anon_sym_SQUOTE] = ACTIONS(2667),
    [anon_sym_STAR] = ACTIONS(2669),
    [anon_sym_u2605] = ACTIONS(2671),
    [anon_sym_EQ] = ACTIONS(1157),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2743),
    [sym_char] = ACTIONS(2743),
    [sym_string] = ACTIONS(2743),
    [sym__integer_literal] = ACTIONS(2745),
    [sym__binary_literal] = ACTIONS(2747),
    [sym__octal_literal] = ACTIONS(2747),
    [sym__hex_literal] = ACTIONS(2747),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2749),
    [anon_sym_u2192] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2751),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1157),
    [sym__cond_prefix_bang] = ACTIONS(1157),
    [sym__cond_tight_tilde] = ACTIONS(1157),
    [sym__cond_prefix_tilde] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [928] = {
    [sym__type_parens] = STATE(7152),
    [sym__type_tuple] = STATE(7138),
    [sym__type_unboxed_tuple] = STATE(7137),
    [sym__type_unboxed_sum] = STATE(7135),
    [sym__type_list] = STATE(7133),
    [sym__type_promoted] = STATE(7020),
    [sym__type_star] = STATE(7020),
    [sym__type_wildcard] = STATE(7020),
    [sym__at_type] = STATE(7028),
    [sym__type_apply] = STATE(7132),
    [sym__type_infix] = STATE(7130),
    [sym_type] = STATE(933),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8428),
    [sym__splice_dollars] = STATE(7456),
    [sym_splice] = STATE(7020),
    [sym_quasiquote] = STATE(7020),
    [sym_integer] = STATE(7159),
    [sym__plist] = STATE(7124),
    [sym_unit] = STATE(7020),
    [sym_unboxed_unit] = STATE(7020),
    [sym_prefix_tuple] = STATE(7020),
    [sym_prefix_unboxed_tuple] = STATE(7020),
    [sym_prefix_unboxed_sum] = STATE(7020),
    [sym_literal] = STATE(7020),
    [sym__qualified_type] = STATE(7160),
    [sym__qtyconid] = STATE(7122),
    [sym__tycon_arrow] = STATE(7122),
    [sym__qtycon_arrow] = STATE(7122),
    [sym__promoted_tycons_alias] = STATE(7020),
    [sym__promoted_tycons] = STATE(7020),
    [sym__tycon_ticked] = STATE(2563),
    [sym__qtycon_ticked] = STATE(2563),
    [sym__tyconids_ticked] = STATE(2563),
    [sym__promoted_tyconops_alias] = STATE(2563),
    [sym__promoted_tyconops] = STATE(2563),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2563),
    [sym__operator_alias] = STATE(2563),
    [sym__operator_minus] = STATE(2563),
    [sym__varsym_prefix] = STATE(7122),
    [sym__pvarsym] = STATE(7122),
    [sym__qualified_varsym] = STATE(2564),
    [sym__qvarsym_prefix] = STATE(7122),
    [sym__pqvarsym] = STATE(7122),
    [sym_constructor_operator] = STATE(2563),
    [sym__constructor_operator_alias] = STATE(2563),
    [sym__consym_prefix] = STATE(7122),
    [sym__pconsym] = STATE(7122),
    [sym__qualified_consym] = STATE(2567),
    [sym__qconsym_prefix] = STATE(7122),
    [sym__pqconsym] = STATE(7122),
    [sym__prefix_at] = STATE(2518),
    [sym__paren_open] = STATE(473),
    [sym__bracket_open] = STATE(1082),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = ACTIONS(1177),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1179),
    [anon_sym_u22b8] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(1177),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_where] = ACTIONS(1179),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_prefix_percent] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [929] = {
    [sym__type_parens] = STATE(7142),
    [sym__type_tuple] = STATE(7143),
    [sym__type_unboxed_tuple] = STATE(7144),
    [sym__type_unboxed_sum] = STATE(7145),
    [sym__type_list] = STATE(7146),
    [sym__type_promoted] = STATE(7140),
    [sym__type_star] = STATE(7140),
    [sym__type_wildcard] = STATE(7140),
    [sym__at_type] = STATE(7167),
    [sym__type_apply] = STATE(7147),
    [sym__type_infix] = STATE(7148),
    [sym_type] = STATE(945),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8458),
    [sym__splice_dollars] = STATE(7440),
    [sym_splice] = STATE(7140),
    [sym_quasiquote] = STATE(7140),
    [sym_integer] = STATE(7036),
    [sym__plist] = STATE(7149),
    [sym_unit] = STATE(7140),
    [sym_unboxed_unit] = STATE(7140),
    [sym_prefix_tuple] = STATE(7140),
    [sym_prefix_unboxed_tuple] = STATE(7140),
    [sym_prefix_unboxed_sum] = STATE(7140),
    [sym_literal] = STATE(7140),
    [sym__qualified_type] = STATE(7079),
    [sym__qtyconid] = STATE(7150),
    [sym__tycon_arrow] = STATE(7150),
    [sym__qtycon_arrow] = STATE(7150),
    [sym__promoted_tycons_alias] = STATE(7140),
    [sym__promoted_tycons] = STATE(7140),
    [sym__tycon_ticked] = STATE(2436),
    [sym__qtycon_ticked] = STATE(2436),
    [sym__tyconids_ticked] = STATE(2436),
    [sym__promoted_tyconops_alias] = STATE(2436),
    [sym__promoted_tyconops] = STATE(2436),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2436),
    [sym__operator_alias] = STATE(2436),
    [sym__operator_minus] = STATE(2436),
    [sym__varsym_prefix] = STATE(7150),
    [sym__pvarsym] = STATE(7150),
    [sym__qualified_varsym] = STATE(2435),
    [sym__qvarsym_prefix] = STATE(7150),
    [sym__pqvarsym] = STATE(7150),
    [sym_constructor_operator] = STATE(2436),
    [sym__constructor_operator_alias] = STATE(2436),
    [sym__consym_prefix] = STATE(7150),
    [sym__pconsym] = STATE(7150),
    [sym__qualified_consym] = STATE(2434),
    [sym__qconsym_prefix] = STATE(7150),
    [sym__pqconsym] = STATE(7150),
    [sym__prefix_at] = STATE(2655),
    [sym__paren_open] = STATE(450),
    [sym__bracket_open] = STATE(1027),
    [sym__unboxed_open] = STATE(831),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_deriving] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym__phantom_bar] = ACTIONS(1179),
    [sym__phantom_deriving] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [930] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8328),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1361),
    [sym_context] = STATE(1024),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__record_fields] = STATE(9999),
    [sym__gadt_con_prefix] = STATE(10543),
    [sym__gadt_con_record] = STATE(10542),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [931] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8328),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1361),
    [sym_context] = STATE(1011),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__record_fields] = STATE(9999),
    [sym__gadt_con_prefix] = STATE(10541),
    [sym__gadt_con_record] = STATE(10534),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [932] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11187),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [aux_sym__exp_tuple_elems_repeat2] = STATE(11182),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(2753),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(2755),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [933] = {
    [sym__type_parens] = STATE(7152),
    [sym__type_tuple] = STATE(7138),
    [sym__type_unboxed_tuple] = STATE(7137),
    [sym__type_unboxed_sum] = STATE(7135),
    [sym__type_list] = STATE(7133),
    [sym__type_promoted] = STATE(7020),
    [sym__type_star] = STATE(7020),
    [sym__type_wildcard] = STATE(7020),
    [sym__at_type] = STATE(7028),
    [sym__type_apply] = STATE(7132),
    [sym__type_infix] = STATE(7130),
    [sym_type] = STATE(933),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8428),
    [sym__splice_dollars] = STATE(7456),
    [sym_splice] = STATE(7020),
    [sym_quasiquote] = STATE(7020),
    [sym_integer] = STATE(7159),
    [sym__plist] = STATE(7124),
    [sym_unit] = STATE(7020),
    [sym_unboxed_unit] = STATE(7020),
    [sym_prefix_tuple] = STATE(7020),
    [sym_prefix_unboxed_tuple] = STATE(7020),
    [sym_prefix_unboxed_sum] = STATE(7020),
    [sym_literal] = STATE(7020),
    [sym__qualified_type] = STATE(7160),
    [sym__qtyconid] = STATE(7122),
    [sym__tycon_arrow] = STATE(7122),
    [sym__qtycon_arrow] = STATE(7122),
    [sym__promoted_tycons_alias] = STATE(7020),
    [sym__promoted_tycons] = STATE(7020),
    [sym__tycon_ticked] = STATE(2563),
    [sym__qtycon_ticked] = STATE(2563),
    [sym__tyconids_ticked] = STATE(2563),
    [sym__promoted_tyconops_alias] = STATE(2563),
    [sym__promoted_tyconops] = STATE(2563),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2563),
    [sym__operator_alias] = STATE(2563),
    [sym__operator_minus] = STATE(2563),
    [sym__varsym_prefix] = STATE(7122),
    [sym__pvarsym] = STATE(7122),
    [sym__qualified_varsym] = STATE(2564),
    [sym__qvarsym_prefix] = STATE(7122),
    [sym__pqvarsym] = STATE(7122),
    [sym_constructor_operator] = STATE(2563),
    [sym__constructor_operator_alias] = STATE(2563),
    [sym__consym_prefix] = STATE(7122),
    [sym__pconsym] = STATE(7122),
    [sym__qualified_consym] = STATE(2567),
    [sym__qconsym_prefix] = STATE(7122),
    [sym__pqconsym] = STATE(7122),
    [sym__prefix_at] = STATE(2518),
    [sym__paren_open] = STATE(473),
    [sym__bracket_open] = STATE(1082),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = ACTIONS(1117),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1119),
    [anon_sym_u22b8] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [anon_sym_where] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_where] = ACTIONS(1119),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_prefix_percent] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [934] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8328),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1361),
    [sym_context] = STATE(1005),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__record_fields] = STATE(9999),
    [sym__gadt_con_prefix] = STATE(10606),
    [sym__gadt_con_record] = STATE(10558),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [935] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8328),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1361),
    [sym_context] = STATE(1033),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__record_fields] = STATE(9999),
    [sym__gadt_con_prefix] = STATE(10526),
    [sym__gadt_con_record] = STATE(10525),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [936] = {
    [sym__type_parens] = STATE(7142),
    [sym__type_tuple] = STATE(7143),
    [sym__type_unboxed_tuple] = STATE(7144),
    [sym__type_unboxed_sum] = STATE(7145),
    [sym__type_list] = STATE(7146),
    [sym__type_promoted] = STATE(7140),
    [sym__type_star] = STATE(7140),
    [sym__type_wildcard] = STATE(7140),
    [sym__at_type] = STATE(7167),
    [sym__type_apply] = STATE(7147),
    [sym__type_infix] = STATE(7148),
    [sym_type] = STATE(945),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8458),
    [sym__splice_dollars] = STATE(7440),
    [sym_splice] = STATE(7140),
    [sym_quasiquote] = STATE(7140),
    [sym_integer] = STATE(7036),
    [sym__plist] = STATE(7149),
    [sym_unit] = STATE(7140),
    [sym_unboxed_unit] = STATE(7140),
    [sym_prefix_tuple] = STATE(7140),
    [sym_prefix_unboxed_tuple] = STATE(7140),
    [sym_prefix_unboxed_sum] = STATE(7140),
    [sym_literal] = STATE(7140),
    [sym__qualified_type] = STATE(7079),
    [sym__qtyconid] = STATE(7150),
    [sym__tycon_arrow] = STATE(7150),
    [sym__qtycon_arrow] = STATE(7150),
    [sym__promoted_tycons_alias] = STATE(7140),
    [sym__promoted_tycons] = STATE(7140),
    [sym__tycon_ticked] = STATE(2436),
    [sym__qtycon_ticked] = STATE(2436),
    [sym__tyconids_ticked] = STATE(2436),
    [sym__promoted_tyconops_alias] = STATE(2436),
    [sym__promoted_tyconops] = STATE(2436),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2436),
    [sym__operator_alias] = STATE(2436),
    [sym__operator_minus] = STATE(2436),
    [sym__varsym_prefix] = STATE(7150),
    [sym__pvarsym] = STATE(7150),
    [sym__qualified_varsym] = STATE(2435),
    [sym__qvarsym_prefix] = STATE(7150),
    [sym__pqvarsym] = STATE(7150),
    [sym_constructor_operator] = STATE(2436),
    [sym__constructor_operator_alias] = STATE(2436),
    [sym__consym_prefix] = STATE(7150),
    [sym__pconsym] = STATE(7150),
    [sym__qualified_consym] = STATE(2434),
    [sym__qconsym_prefix] = STATE(7150),
    [sym__pqconsym] = STATE(7150),
    [sym__prefix_at] = STATE(2655),
    [sym__paren_open] = STATE(450),
    [sym__bracket_open] = STATE(1027),
    [sym__unboxed_open] = STATE(831),
    [sym_variable] = ACTIONS(2757),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym__] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2765),
    [anon_sym_u2605] = ACTIONS(2767),
    [anon_sym_PIPE] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_deriving] = ACTIONS(2769),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2771),
    [sym_char] = ACTIONS(2771),
    [sym_string] = ACTIONS(2771),
    [sym__integer_literal] = ACTIONS(2773),
    [sym__binary_literal] = ACTIONS(2775),
    [sym__octal_literal] = ACTIONS(2775),
    [sym__hex_literal] = ACTIONS(2775),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2777),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(2759),
    [sym__cond_layout_end] = ACTIONS(2759),
    [sym__cond_layout_end_explicit] = ACTIONS(2759),
    [sym__phantom_bar] = ACTIONS(2759),
    [sym__phantom_deriving] = ACTIONS(2759),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2779),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [937] = {
    [sym__type_parens] = STATE(7142),
    [sym__type_tuple] = STATE(7143),
    [sym__type_unboxed_tuple] = STATE(7144),
    [sym__type_unboxed_sum] = STATE(7145),
    [sym__type_list] = STATE(7146),
    [sym__type_promoted] = STATE(7140),
    [sym__type_star] = STATE(7140),
    [sym__type_wildcard] = STATE(7140),
    [sym__at_type] = STATE(7167),
    [sym__type_apply] = STATE(7147),
    [sym__type_infix] = STATE(7148),
    [sym_type] = STATE(945),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8458),
    [sym__splice_dollars] = STATE(7440),
    [sym_splice] = STATE(7140),
    [sym_quasiquote] = STATE(7140),
    [sym_integer] = STATE(7036),
    [sym__plist] = STATE(7149),
    [sym_unit] = STATE(7140),
    [sym_unboxed_unit] = STATE(7140),
    [sym_prefix_tuple] = STATE(7140),
    [sym_prefix_unboxed_tuple] = STATE(7140),
    [sym_prefix_unboxed_sum] = STATE(7140),
    [sym_literal] = STATE(7140),
    [sym__qualified_type] = STATE(7079),
    [sym__qtyconid] = STATE(7150),
    [sym__tycon_arrow] = STATE(7150),
    [sym__qtycon_arrow] = STATE(7150),
    [sym__promoted_tycons_alias] = STATE(7140),
    [sym__promoted_tycons] = STATE(7140),
    [sym__tycon_ticked] = STATE(2436),
    [sym__qtycon_ticked] = STATE(2436),
    [sym__tyconids_ticked] = STATE(2436),
    [sym__promoted_tyconops_alias] = STATE(2436),
    [sym__promoted_tyconops] = STATE(2436),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2436),
    [sym__operator_alias] = STATE(2436),
    [sym__operator_minus] = STATE(2436),
    [sym__varsym_prefix] = STATE(7150),
    [sym__pvarsym] = STATE(7150),
    [sym__qualified_varsym] = STATE(2435),
    [sym__qvarsym_prefix] = STATE(7150),
    [sym__pqvarsym] = STATE(7150),
    [sym_constructor_operator] = STATE(2436),
    [sym__constructor_operator_alias] = STATE(2436),
    [sym__consym_prefix] = STATE(7150),
    [sym__pconsym] = STATE(7150),
    [sym__qualified_consym] = STATE(2434),
    [sym__qconsym_prefix] = STATE(7150),
    [sym__pqconsym] = STATE(7150),
    [sym__prefix_at] = STATE(2655),
    [sym__paren_open] = STATE(450),
    [sym__bracket_open] = STATE(1027),
    [sym__unboxed_open] = STATE(831),
    [sym_variable] = ACTIONS(2757),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym__] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2765),
    [anon_sym_u2605] = ACTIONS(2767),
    [anon_sym_PIPE] = ACTIONS(2759),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_deriving] = ACTIONS(2769),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2771),
    [sym_char] = ACTIONS(2771),
    [sym_string] = ACTIONS(2771),
    [sym__integer_literal] = ACTIONS(2773),
    [sym__binary_literal] = ACTIONS(2775),
    [sym__octal_literal] = ACTIONS(2775),
    [sym__hex_literal] = ACTIONS(2775),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2777),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(2759),
    [sym__cond_layout_end] = ACTIONS(2759),
    [sym__cond_layout_end_explicit] = ACTIONS(2759),
    [sym__phantom_bar] = ACTIONS(2759),
    [sym__phantom_deriving] = ACTIONS(2759),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2779),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [938] = {
    [sym__type_parens] = STATE(7152),
    [sym__type_tuple] = STATE(7138),
    [sym__type_unboxed_tuple] = STATE(7137),
    [sym__type_unboxed_sum] = STATE(7135),
    [sym__type_list] = STATE(7133),
    [sym__type_promoted] = STATE(7020),
    [sym__type_star] = STATE(7020),
    [sym__type_wildcard] = STATE(7020),
    [sym__at_type] = STATE(7028),
    [sym__type_apply] = STATE(7132),
    [sym__type_infix] = STATE(7130),
    [sym_type] = STATE(933),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8428),
    [sym__splice_dollars] = STATE(7456),
    [sym_splice] = STATE(7020),
    [sym_quasiquote] = STATE(7020),
    [sym_integer] = STATE(7159),
    [sym__plist] = STATE(7124),
    [sym_unit] = STATE(7020),
    [sym_unboxed_unit] = STATE(7020),
    [sym_prefix_tuple] = STATE(7020),
    [sym_prefix_unboxed_tuple] = STATE(7020),
    [sym_prefix_unboxed_sum] = STATE(7020),
    [sym_literal] = STATE(7020),
    [sym__qualified_type] = STATE(7160),
    [sym__qtyconid] = STATE(7122),
    [sym__tycon_arrow] = STATE(7122),
    [sym__qtycon_arrow] = STATE(7122),
    [sym__promoted_tycons_alias] = STATE(7020),
    [sym__promoted_tycons] = STATE(7020),
    [sym__tycon_ticked] = STATE(2563),
    [sym__qtycon_ticked] = STATE(2563),
    [sym__tyconids_ticked] = STATE(2563),
    [sym__promoted_tyconops_alias] = STATE(2563),
    [sym__promoted_tyconops] = STATE(2563),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2563),
    [sym__operator_alias] = STATE(2563),
    [sym__operator_minus] = STATE(2563),
    [sym__varsym_prefix] = STATE(7122),
    [sym__pvarsym] = STATE(7122),
    [sym__qualified_varsym] = STATE(2564),
    [sym__qvarsym_prefix] = STATE(7122),
    [sym__pqvarsym] = STATE(7122),
    [sym_constructor_operator] = STATE(2563),
    [sym__constructor_operator_alias] = STATE(2563),
    [sym__consym_prefix] = STATE(7122),
    [sym__pconsym] = STATE(7122),
    [sym__qualified_consym] = STATE(2567),
    [sym__qconsym_prefix] = STATE(7122),
    [sym__pqconsym] = STATE(7122),
    [sym__prefix_at] = STATE(2518),
    [sym__paren_open] = STATE(473),
    [sym__bracket_open] = STATE(1082),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = ACTIONS(2781),
    [anon_sym__] = ACTIONS(2783),
    [anon_sym_SQUOTE] = ACTIONS(2785),
    [anon_sym_STAR] = ACTIONS(2787),
    [anon_sym_u2605] = ACTIONS(2789),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2791),
    [sym_char] = ACTIONS(2791),
    [sym_string] = ACTIONS(2791),
    [sym__integer_literal] = ACTIONS(2793),
    [sym__binary_literal] = ACTIONS(2795),
    [sym__octal_literal] = ACTIONS(2795),
    [sym__hex_literal] = ACTIONS(2795),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2797),
    [anon_sym_u2192] = ACTIONS(1123),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1123),
    [anon_sym_u22b8] = ACTIONS(1123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1125),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_where] = ACTIONS(1123),
    [sym__phantom_arrow] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2799),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1123),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [939] = {
    [sym__at_type] = STATE(6735),
    [sym_explicit_type] = STATE(6738),
    [sym__pat_parens] = STATE(6709),
    [sym__pat_tuple] = STATE(6707),
    [sym__pat_unboxed_tuple] = STATE(6706),
    [sym__pat_unboxed_sum] = STATE(6705),
    [sym__pat_list] = STATE(6704),
    [sym__pat_record] = STATE(6703),
    [sym__pat_as] = STATE(6702),
    [sym__pat_wildcard] = STATE(6701),
    [sym__pat_strict] = STATE(6700),
    [sym__pat_irrefutable] = STATE(6699),
    [sym__pat_apply] = STATE(6772),
    [sym__pat_negation] = STATE(6711),
    [sym__pat_infix] = STATE(6715),
    [sym_pattern] = STATE(1364),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11259),
    [sym__splice_dollars] = STATE(7313),
    [sym_splice] = STATE(6701),
    [sym_quasiquote] = STATE(6701),
    [sym_integer] = STATE(6231),
    [sym__plist] = STATE(6728),
    [sym_unit] = STATE(6701),
    [sym_unboxed_unit] = STATE(6701),
    [sym_prefix_tuple] = STATE(6701),
    [sym_prefix_unboxed_tuple] = STATE(6701),
    [sym_prefix_unboxed_sum] = STATE(6701),
    [sym_literal] = STATE(6701),
    [sym__variable_ticked] = STATE(2278),
    [sym__qualified_constructor] = STATE(6223),
    [sym__qconid] = STATE(6701),
    [sym__constructor_ticked] = STATE(2251),
    [sym__qconstructor_ticked] = STATE(2251),
    [sym__operator_hash_head] = STATE(8152),
    [sym_operator] = STATE(2278),
    [sym__varsym_prefix] = STATE(6729),
    [sym__pvarsym] = STATE(6729),
    [sym_constructor_operator] = STATE(2251),
    [sym__consym_prefix] = STATE(6731),
    [sym__pconsym] = STATE(6731),
    [sym__qconsym_prefix] = STATE(6701),
    [sym__pqconsym] = STATE(6701),
    [sym__colon2] = STATE(1612),
    [sym__prefix_at] = STATE(2417),
    [sym__prefix_bang] = STATE(2257),
    [sym__tight_bang] = STATE(2257),
    [sym__any_prefix_bang] = STATE(2257),
    [sym__prefix_tilde] = STATE(2258),
    [sym__tight_tilde] = STATE(2258),
    [sym__any_prefix_tilde] = STATE(2258),
    [sym__paren_open] = STATE(41),
    [sym__bracket_open] = STATE(369),
    [sym__unboxed_open] = STATE(193),
    [sym_variable] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(2719),
    [anon_sym_LBRACE] = ACTIONS(2803),
    [anon_sym__] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(2717),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2467),
    [sym_char] = ACTIONS(2467),
    [sym_string] = ACTIONS(2467),
    [sym__integer_literal] = ACTIONS(2469),
    [sym__binary_literal] = ACTIONS(2471),
    [sym__octal_literal] = ACTIONS(2471),
    [sym__hex_literal] = ACTIONS(2471),
    [anon_sym_BQUOTE] = ACTIONS(2721),
    [anon_sym_POUND] = ACTIONS(2723),
    [anon_sym_POUND2] = ACTIONS(2725),
    [sym_name] = ACTIONS(2807),
    [anon_sym_COLON_COLON] = ACTIONS(2809),
    [anon_sym_u2237] = ACTIONS(2809),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(2719),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2475),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(2729),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(2811),
    [sym__cond_no_section_op] = ACTIONS(2813),
    [sym__cond_minus] = ACTIONS(2815),
    [sym__varsym] = ACTIONS(2717),
    [sym__consym] = ACTIONS(2737),
  },
  [940] = {
    [sym__type_parens] = STATE(7142),
    [sym__type_tuple] = STATE(7143),
    [sym__type_unboxed_tuple] = STATE(7144),
    [sym__type_unboxed_sum] = STATE(7145),
    [sym__type_list] = STATE(7146),
    [sym__type_promoted] = STATE(7140),
    [sym__type_star] = STATE(7140),
    [sym__type_wildcard] = STATE(7140),
    [sym__at_type] = STATE(7167),
    [sym__type_apply] = STATE(7147),
    [sym__type_infix] = STATE(7148),
    [sym_type] = STATE(945),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8458),
    [sym__splice_dollars] = STATE(7440),
    [sym_splice] = STATE(7140),
    [sym_quasiquote] = STATE(7140),
    [sym_integer] = STATE(7036),
    [sym__plist] = STATE(7149),
    [sym_unit] = STATE(7140),
    [sym_unboxed_unit] = STATE(7140),
    [sym_prefix_tuple] = STATE(7140),
    [sym_prefix_unboxed_tuple] = STATE(7140),
    [sym_prefix_unboxed_sum] = STATE(7140),
    [sym_literal] = STATE(7140),
    [sym__qualified_type] = STATE(7079),
    [sym__qtyconid] = STATE(7150),
    [sym__tycon_arrow] = STATE(7150),
    [sym__qtycon_arrow] = STATE(7150),
    [sym__promoted_tycons_alias] = STATE(7140),
    [sym__promoted_tycons] = STATE(7140),
    [sym__tycon_ticked] = STATE(2436),
    [sym__qtycon_ticked] = STATE(2436),
    [sym__tyconids_ticked] = STATE(2436),
    [sym__promoted_tyconops_alias] = STATE(2436),
    [sym__promoted_tyconops] = STATE(2436),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2436),
    [sym__operator_alias] = STATE(2436),
    [sym__operator_minus] = STATE(2436),
    [sym__varsym_prefix] = STATE(7150),
    [sym__pvarsym] = STATE(7150),
    [sym__qualified_varsym] = STATE(2435),
    [sym__qvarsym_prefix] = STATE(7150),
    [sym__pqvarsym] = STATE(7150),
    [sym_constructor_operator] = STATE(2436),
    [sym__constructor_operator_alias] = STATE(2436),
    [sym__consym_prefix] = STATE(7150),
    [sym__pconsym] = STATE(7150),
    [sym__qualified_consym] = STATE(2434),
    [sym__qconsym_prefix] = STATE(7150),
    [sym__pqconsym] = STATE(7150),
    [sym__prefix_at] = STATE(2655),
    [sym__paren_open] = STATE(450),
    [sym__bracket_open] = STATE(1027),
    [sym__unboxed_open] = STATE(831),
    [sym_variable] = ACTIONS(2757),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2765),
    [anon_sym_u2605] = ACTIONS(2767),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_deriving] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2771),
    [sym_char] = ACTIONS(2771),
    [sym_string] = ACTIONS(2771),
    [sym__integer_literal] = ACTIONS(2773),
    [sym__binary_literal] = ACTIONS(2775),
    [sym__octal_literal] = ACTIONS(2775),
    [sym__hex_literal] = ACTIONS(2775),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2777),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym__phantom_deriving] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2779),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [941] = {
    [sym__type_parens] = STATE(7152),
    [sym__type_tuple] = STATE(7138),
    [sym__type_unboxed_tuple] = STATE(7137),
    [sym__type_unboxed_sum] = STATE(7135),
    [sym__type_list] = STATE(7133),
    [sym__type_promoted] = STATE(7020),
    [sym__type_star] = STATE(7020),
    [sym__type_wildcard] = STATE(7020),
    [sym__at_type] = STATE(7028),
    [sym__type_apply] = STATE(7132),
    [sym__type_infix] = STATE(7130),
    [sym_type] = STATE(933),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8428),
    [sym__splice_dollars] = STATE(7456),
    [sym_splice] = STATE(7020),
    [sym_quasiquote] = STATE(7020),
    [sym_integer] = STATE(7159),
    [sym__plist] = STATE(7124),
    [sym_unit] = STATE(7020),
    [sym_unboxed_unit] = STATE(7020),
    [sym_prefix_tuple] = STATE(7020),
    [sym_prefix_unboxed_tuple] = STATE(7020),
    [sym_prefix_unboxed_sum] = STATE(7020),
    [sym_literal] = STATE(7020),
    [sym__qualified_type] = STATE(7160),
    [sym__qtyconid] = STATE(7122),
    [sym__tycon_arrow] = STATE(7122),
    [sym__qtycon_arrow] = STATE(7122),
    [sym__promoted_tycons_alias] = STATE(7020),
    [sym__promoted_tycons] = STATE(7020),
    [sym__tycon_ticked] = STATE(2563),
    [sym__qtycon_ticked] = STATE(2563),
    [sym__tyconids_ticked] = STATE(2563),
    [sym__promoted_tyconops_alias] = STATE(2563),
    [sym__promoted_tyconops] = STATE(2563),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2563),
    [sym__operator_alias] = STATE(2563),
    [sym__operator_minus] = STATE(2563),
    [sym__varsym_prefix] = STATE(7122),
    [sym__pvarsym] = STATE(7122),
    [sym__qualified_varsym] = STATE(2564),
    [sym__qvarsym_prefix] = STATE(7122),
    [sym__pqvarsym] = STATE(7122),
    [sym_constructor_operator] = STATE(2563),
    [sym__constructor_operator_alias] = STATE(2563),
    [sym__consym_prefix] = STATE(7122),
    [sym__pconsym] = STATE(7122),
    [sym__qualified_consym] = STATE(2567),
    [sym__qconsym_prefix] = STATE(7122),
    [sym__pqconsym] = STATE(7122),
    [sym__prefix_at] = STATE(2518),
    [sym__paren_open] = STATE(473),
    [sym__bracket_open] = STATE(1082),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = ACTIONS(2781),
    [anon_sym__] = ACTIONS(2783),
    [anon_sym_SQUOTE] = ACTIONS(2785),
    [anon_sym_STAR] = ACTIONS(2787),
    [anon_sym_u2605] = ACTIONS(2789),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2791),
    [sym_char] = ACTIONS(2791),
    [sym_string] = ACTIONS(2791),
    [sym__integer_literal] = ACTIONS(2793),
    [sym__binary_literal] = ACTIONS(2795),
    [sym__octal_literal] = ACTIONS(2795),
    [sym__hex_literal] = ACTIONS(2795),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2797),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_where] = ACTIONS(1181),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2799),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [942] = {
    [sym__type_parens] = STATE(7142),
    [sym__type_tuple] = STATE(7143),
    [sym__type_unboxed_tuple] = STATE(7144),
    [sym__type_unboxed_sum] = STATE(7145),
    [sym__type_list] = STATE(7146),
    [sym__type_promoted] = STATE(7140),
    [sym__type_star] = STATE(7140),
    [sym__type_wildcard] = STATE(7140),
    [sym__at_type] = STATE(7167),
    [sym__type_apply] = STATE(7147),
    [sym__type_infix] = STATE(7148),
    [sym_type] = STATE(945),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8458),
    [sym__splice_dollars] = STATE(7440),
    [sym_splice] = STATE(7140),
    [sym_quasiquote] = STATE(7140),
    [sym_integer] = STATE(7036),
    [sym__plist] = STATE(7149),
    [sym_unit] = STATE(7140),
    [sym_unboxed_unit] = STATE(7140),
    [sym_prefix_tuple] = STATE(7140),
    [sym_prefix_unboxed_tuple] = STATE(7140),
    [sym_prefix_unboxed_sum] = STATE(7140),
    [sym_literal] = STATE(7140),
    [sym__qualified_type] = STATE(7079),
    [sym__qtyconid] = STATE(7150),
    [sym__tycon_arrow] = STATE(7150),
    [sym__qtycon_arrow] = STATE(7150),
    [sym__promoted_tycons_alias] = STATE(7140),
    [sym__promoted_tycons] = STATE(7140),
    [sym__tycon_ticked] = STATE(2436),
    [sym__qtycon_ticked] = STATE(2436),
    [sym__tyconids_ticked] = STATE(2436),
    [sym__promoted_tyconops_alias] = STATE(2436),
    [sym__promoted_tyconops] = STATE(2436),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2436),
    [sym__operator_alias] = STATE(2436),
    [sym__operator_minus] = STATE(2436),
    [sym__varsym_prefix] = STATE(7150),
    [sym__pvarsym] = STATE(7150),
    [sym__qualified_varsym] = STATE(2435),
    [sym__qvarsym_prefix] = STATE(7150),
    [sym__pqvarsym] = STATE(7150),
    [sym_constructor_operator] = STATE(2436),
    [sym__constructor_operator_alias] = STATE(2436),
    [sym__consym_prefix] = STATE(7150),
    [sym__pconsym] = STATE(7150),
    [sym__qualified_consym] = STATE(2434),
    [sym__qconsym_prefix] = STATE(7150),
    [sym__pqconsym] = STATE(7150),
    [sym__prefix_at] = STATE(2655),
    [sym__paren_open] = STATE(450),
    [sym__bracket_open] = STATE(1027),
    [sym__unboxed_open] = STATE(831),
    [sym_variable] = ACTIONS(2757),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2765),
    [anon_sym_u2605] = ACTIONS(2767),
    [anon_sym_PIPE] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_deriving] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2771),
    [sym_char] = ACTIONS(2771),
    [sym_string] = ACTIONS(2771),
    [sym__integer_literal] = ACTIONS(2773),
    [sym__binary_literal] = ACTIONS(2775),
    [sym__octal_literal] = ACTIONS(2775),
    [sym__hex_literal] = ACTIONS(2775),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2777),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_bar] = ACTIONS(1181),
    [sym__phantom_deriving] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2779),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [943] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__at_type] = STATE(3896),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(522),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8466),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__tycon_ticked] = STATE(2438),
    [sym__qtycon_ticked] = STATE(2438),
    [sym__tyconids_ticked] = STATE(2438),
    [sym__promoted_tyconops_alias] = STATE(2438),
    [sym__promoted_tyconops] = STATE(2438),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2438),
    [sym__operator_alias] = STATE(2438),
    [sym__operator_minus] = STATE(2438),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(2439),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(2438),
    [sym__constructor_operator_alias] = STATE(2438),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(2440),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_at] = STATE(2586),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(2399),
    [anon_sym_RBRACE] = ACTIONS(2399),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1707),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(2399),
    [anon_sym_DASH_GT_DOT] = ACTIONS(2399),
    [anon_sym_u22b8] = ACTIONS(2399),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(2399),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(2399),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [944] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__at_type] = STATE(3896),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(522),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8466),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__tycon_ticked] = STATE(2438),
    [sym__qtycon_ticked] = STATE(2438),
    [sym__tyconids_ticked] = STATE(2438),
    [sym__promoted_tyconops_alias] = STATE(2438),
    [sym__promoted_tyconops] = STATE(2438),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2438),
    [sym__operator_alias] = STATE(2438),
    [sym__operator_minus] = STATE(2438),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qualified_varsym] = STATE(2439),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym_constructor_operator] = STATE(2438),
    [sym__constructor_operator_alias] = STATE(2438),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qualified_consym] = STATE(2440),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_at] = STATE(2586),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym_COMMA] = ACTIONS(2423),
    [anon_sym_RBRACE] = ACTIONS(2423),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1705),
    [anon_sym_STAR] = ACTIONS(1707),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(2421),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1393),
    [anon_sym_u2192] = ACTIONS(2423),
    [anon_sym_DASH_GT_DOT] = ACTIONS(2423),
    [anon_sym_u22b8] = ACTIONS(2423),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(2423),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(2423),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [945] = {
    [sym__type_parens] = STATE(7142),
    [sym__type_tuple] = STATE(7143),
    [sym__type_unboxed_tuple] = STATE(7144),
    [sym__type_unboxed_sum] = STATE(7145),
    [sym__type_list] = STATE(7146),
    [sym__type_promoted] = STATE(7140),
    [sym__type_star] = STATE(7140),
    [sym__type_wildcard] = STATE(7140),
    [sym__at_type] = STATE(7167),
    [sym__type_apply] = STATE(7147),
    [sym__type_infix] = STATE(7148),
    [sym_type] = STATE(945),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8458),
    [sym__splice_dollars] = STATE(7440),
    [sym_splice] = STATE(7140),
    [sym_quasiquote] = STATE(7140),
    [sym_integer] = STATE(7036),
    [sym__plist] = STATE(7149),
    [sym_unit] = STATE(7140),
    [sym_unboxed_unit] = STATE(7140),
    [sym_prefix_tuple] = STATE(7140),
    [sym_prefix_unboxed_tuple] = STATE(7140),
    [sym_prefix_unboxed_sum] = STATE(7140),
    [sym_literal] = STATE(7140),
    [sym__qualified_type] = STATE(7079),
    [sym__qtyconid] = STATE(7150),
    [sym__tycon_arrow] = STATE(7150),
    [sym__qtycon_arrow] = STATE(7150),
    [sym__promoted_tycons_alias] = STATE(7140),
    [sym__promoted_tycons] = STATE(7140),
    [sym__tycon_ticked] = STATE(2436),
    [sym__qtycon_ticked] = STATE(2436),
    [sym__tyconids_ticked] = STATE(2436),
    [sym__promoted_tyconops_alias] = STATE(2436),
    [sym__promoted_tyconops] = STATE(2436),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2436),
    [sym__operator_alias] = STATE(2436),
    [sym__operator_minus] = STATE(2436),
    [sym__varsym_prefix] = STATE(7150),
    [sym__pvarsym] = STATE(7150),
    [sym__qualified_varsym] = STATE(2435),
    [sym__qvarsym_prefix] = STATE(7150),
    [sym__pqvarsym] = STATE(7150),
    [sym_constructor_operator] = STATE(2436),
    [sym__constructor_operator_alias] = STATE(2436),
    [sym__consym_prefix] = STATE(7150),
    [sym__pconsym] = STATE(7150),
    [sym__qualified_consym] = STATE(2434),
    [sym__qconsym_prefix] = STATE(7150),
    [sym__pqconsym] = STATE(7150),
    [sym__prefix_at] = STATE(2655),
    [sym__paren_open] = STATE(450),
    [sym__bracket_open] = STATE(1027),
    [sym__unboxed_open] = STATE(831),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_deriving] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1119),
    [sym__cond_layout_end] = ACTIONS(1119),
    [sym__cond_layout_end_explicit] = ACTIONS(1119),
    [sym__phantom_bar] = ACTIONS(1119),
    [sym__phantom_deriving] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [946] = {
    [sym__type_parens] = STATE(7142),
    [sym__type_tuple] = STATE(7143),
    [sym__type_unboxed_tuple] = STATE(7144),
    [sym__type_unboxed_sum] = STATE(7145),
    [sym__type_list] = STATE(7146),
    [sym__type_promoted] = STATE(7140),
    [sym__type_star] = STATE(7140),
    [sym__type_wildcard] = STATE(7140),
    [sym__at_type] = STATE(7167),
    [sym__type_apply] = STATE(7147),
    [sym__type_infix] = STATE(7148),
    [sym_type] = STATE(945),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8458),
    [sym__splice_dollars] = STATE(7440),
    [sym_splice] = STATE(7140),
    [sym_quasiquote] = STATE(7140),
    [sym_integer] = STATE(7036),
    [sym__plist] = STATE(7149),
    [sym_unit] = STATE(7140),
    [sym_unboxed_unit] = STATE(7140),
    [sym_prefix_tuple] = STATE(7140),
    [sym_prefix_unboxed_tuple] = STATE(7140),
    [sym_prefix_unboxed_sum] = STATE(7140),
    [sym_literal] = STATE(7140),
    [sym__qualified_type] = STATE(7079),
    [sym__qtyconid] = STATE(7150),
    [sym__tycon_arrow] = STATE(7150),
    [sym__qtycon_arrow] = STATE(7150),
    [sym__promoted_tycons_alias] = STATE(7140),
    [sym__promoted_tycons] = STATE(7140),
    [sym__tycon_ticked] = STATE(2436),
    [sym__qtycon_ticked] = STATE(2436),
    [sym__tyconids_ticked] = STATE(2436),
    [sym__promoted_tyconops_alias] = STATE(2436),
    [sym__promoted_tyconops] = STATE(2436),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2436),
    [sym__operator_alias] = STATE(2436),
    [sym__operator_minus] = STATE(2436),
    [sym__varsym_prefix] = STATE(7150),
    [sym__pvarsym] = STATE(7150),
    [sym__qualified_varsym] = STATE(2435),
    [sym__qvarsym_prefix] = STATE(7150),
    [sym__pqvarsym] = STATE(7150),
    [sym_constructor_operator] = STATE(2436),
    [sym__constructor_operator_alias] = STATE(2436),
    [sym__consym_prefix] = STATE(7150),
    [sym__pconsym] = STATE(7150),
    [sym__qualified_consym] = STATE(2434),
    [sym__qconsym_prefix] = STATE(7150),
    [sym__pqconsym] = STATE(7150),
    [sym__prefix_at] = STATE(2655),
    [sym__paren_open] = STATE(450),
    [sym__bracket_open] = STATE(1027),
    [sym__unboxed_open] = STATE(831),
    [sym_variable] = ACTIONS(2757),
    [anon_sym_SEMI] = ACTIONS(2399),
    [anon_sym__] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2765),
    [anon_sym_u2605] = ACTIONS(2767),
    [anon_sym_PIPE] = ACTIONS(2399),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_deriving] = ACTIONS(2397),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2771),
    [sym_char] = ACTIONS(2771),
    [sym_string] = ACTIONS(2771),
    [sym__integer_literal] = ACTIONS(2773),
    [sym__binary_literal] = ACTIONS(2775),
    [sym__octal_literal] = ACTIONS(2775),
    [sym__hex_literal] = ACTIONS(2775),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2777),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(2399),
    [sym__cond_layout_end] = ACTIONS(2399),
    [sym__cond_layout_end_explicit] = ACTIONS(2399),
    [sym__phantom_bar] = ACTIONS(2399),
    [sym__phantom_deriving] = ACTIONS(2399),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2779),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [947] = {
    [sym__type_parens] = STATE(7142),
    [sym__type_tuple] = STATE(7143),
    [sym__type_unboxed_tuple] = STATE(7144),
    [sym__type_unboxed_sum] = STATE(7145),
    [sym__type_list] = STATE(7146),
    [sym__type_promoted] = STATE(7140),
    [sym__type_star] = STATE(7140),
    [sym__type_wildcard] = STATE(7140),
    [sym__at_type] = STATE(7167),
    [sym__type_apply] = STATE(7147),
    [sym__type_infix] = STATE(7148),
    [sym_type] = STATE(945),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8458),
    [sym__splice_dollars] = STATE(7440),
    [sym_splice] = STATE(7140),
    [sym_quasiquote] = STATE(7140),
    [sym_integer] = STATE(7036),
    [sym__plist] = STATE(7149),
    [sym_unit] = STATE(7140),
    [sym_unboxed_unit] = STATE(7140),
    [sym_prefix_tuple] = STATE(7140),
    [sym_prefix_unboxed_tuple] = STATE(7140),
    [sym_prefix_unboxed_sum] = STATE(7140),
    [sym_literal] = STATE(7140),
    [sym__qualified_type] = STATE(7079),
    [sym__qtyconid] = STATE(7150),
    [sym__tycon_arrow] = STATE(7150),
    [sym__qtycon_arrow] = STATE(7150),
    [sym__promoted_tycons_alias] = STATE(7140),
    [sym__promoted_tycons] = STATE(7140),
    [sym__tycon_ticked] = STATE(2436),
    [sym__qtycon_ticked] = STATE(2436),
    [sym__tyconids_ticked] = STATE(2436),
    [sym__promoted_tyconops_alias] = STATE(2436),
    [sym__promoted_tyconops] = STATE(2436),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2436),
    [sym__operator_alias] = STATE(2436),
    [sym__operator_minus] = STATE(2436),
    [sym__varsym_prefix] = STATE(7150),
    [sym__pvarsym] = STATE(7150),
    [sym__qualified_varsym] = STATE(2435),
    [sym__qvarsym_prefix] = STATE(7150),
    [sym__pqvarsym] = STATE(7150),
    [sym_constructor_operator] = STATE(2436),
    [sym__constructor_operator_alias] = STATE(2436),
    [sym__consym_prefix] = STATE(7150),
    [sym__pconsym] = STATE(7150),
    [sym__qualified_consym] = STATE(2434),
    [sym__qconsym_prefix] = STATE(7150),
    [sym__pqconsym] = STATE(7150),
    [sym__prefix_at] = STATE(2655),
    [sym__paren_open] = STATE(450),
    [sym__bracket_open] = STATE(1027),
    [sym__unboxed_open] = STATE(831),
    [sym_variable] = ACTIONS(2757),
    [anon_sym_SEMI] = ACTIONS(2423),
    [anon_sym__] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2765),
    [anon_sym_u2605] = ACTIONS(2767),
    [anon_sym_PIPE] = ACTIONS(2423),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_deriving] = ACTIONS(2421),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2771),
    [sym_char] = ACTIONS(2771),
    [sym_string] = ACTIONS(2771),
    [sym__integer_literal] = ACTIONS(2773),
    [sym__binary_literal] = ACTIONS(2775),
    [sym__octal_literal] = ACTIONS(2775),
    [sym__hex_literal] = ACTIONS(2775),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2777),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(2423),
    [sym__cond_layout_end] = ACTIONS(2423),
    [sym__cond_layout_end_explicit] = ACTIONS(2423),
    [sym__phantom_bar] = ACTIONS(2423),
    [sym__phantom_deriving] = ACTIONS(2423),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2779),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [948] = {
    [sym__type_parens] = STATE(7152),
    [sym__type_tuple] = STATE(7138),
    [sym__type_unboxed_tuple] = STATE(7137),
    [sym__type_unboxed_sum] = STATE(7135),
    [sym__type_list] = STATE(7133),
    [sym__type_promoted] = STATE(7020),
    [sym__type_star] = STATE(7020),
    [sym__type_wildcard] = STATE(7020),
    [sym__at_type] = STATE(7028),
    [sym__type_apply] = STATE(7132),
    [sym__type_infix] = STATE(7130),
    [sym_type] = STATE(933),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8428),
    [sym__splice_dollars] = STATE(7456),
    [sym_splice] = STATE(7020),
    [sym_quasiquote] = STATE(7020),
    [sym_integer] = STATE(7159),
    [sym__plist] = STATE(7124),
    [sym_unit] = STATE(7020),
    [sym_unboxed_unit] = STATE(7020),
    [sym_prefix_tuple] = STATE(7020),
    [sym_prefix_unboxed_tuple] = STATE(7020),
    [sym_prefix_unboxed_sum] = STATE(7020),
    [sym_literal] = STATE(7020),
    [sym__qualified_type] = STATE(7160),
    [sym__qtyconid] = STATE(7122),
    [sym__tycon_arrow] = STATE(7122),
    [sym__qtycon_arrow] = STATE(7122),
    [sym__promoted_tycons_alias] = STATE(7020),
    [sym__promoted_tycons] = STATE(7020),
    [sym__tycon_ticked] = STATE(2563),
    [sym__qtycon_ticked] = STATE(2563),
    [sym__tyconids_ticked] = STATE(2563),
    [sym__promoted_tyconops_alias] = STATE(2563),
    [sym__promoted_tyconops] = STATE(2563),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2563),
    [sym__operator_alias] = STATE(2563),
    [sym__operator_minus] = STATE(2563),
    [sym__varsym_prefix] = STATE(7122),
    [sym__pvarsym] = STATE(7122),
    [sym__qualified_varsym] = STATE(2564),
    [sym__qvarsym_prefix] = STATE(7122),
    [sym__pqvarsym] = STATE(7122),
    [sym_constructor_operator] = STATE(2563),
    [sym__constructor_operator_alias] = STATE(2563),
    [sym__consym_prefix] = STATE(7122),
    [sym__pconsym] = STATE(7122),
    [sym__qualified_consym] = STATE(2567),
    [sym__qconsym_prefix] = STATE(7122),
    [sym__pqconsym] = STATE(7122),
    [sym__prefix_at] = STATE(2518),
    [sym__paren_open] = STATE(473),
    [sym__bracket_open] = STATE(1082),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = ACTIONS(2781),
    [anon_sym__] = ACTIONS(2783),
    [anon_sym_SQUOTE] = ACTIONS(2785),
    [anon_sym_STAR] = ACTIONS(2787),
    [anon_sym_u2605] = ACTIONS(2789),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2791),
    [sym_char] = ACTIONS(2791),
    [sym_string] = ACTIONS(2791),
    [sym__integer_literal] = ACTIONS(2793),
    [sym__binary_literal] = ACTIONS(2795),
    [sym__octal_literal] = ACTIONS(2795),
    [sym__hex_literal] = ACTIONS(2795),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2797),
    [anon_sym_u2192] = ACTIONS(1157),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1157),
    [anon_sym_u22b8] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1159),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_where] = ACTIONS(1157),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2799),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [949] = {
    [sym__type_parens] = STATE(7152),
    [sym__type_tuple] = STATE(7138),
    [sym__type_unboxed_tuple] = STATE(7137),
    [sym__type_unboxed_sum] = STATE(7135),
    [sym__type_list] = STATE(7133),
    [sym__type_promoted] = STATE(7020),
    [sym__type_star] = STATE(7020),
    [sym__type_wildcard] = STATE(7020),
    [sym__at_type] = STATE(7028),
    [sym__type_apply] = STATE(7132),
    [sym__type_infix] = STATE(7130),
    [sym_type] = STATE(933),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8428),
    [sym__splice_dollars] = STATE(7456),
    [sym_splice] = STATE(7020),
    [sym_quasiquote] = STATE(7020),
    [sym_integer] = STATE(7159),
    [sym__plist] = STATE(7124),
    [sym_unit] = STATE(7020),
    [sym_unboxed_unit] = STATE(7020),
    [sym_prefix_tuple] = STATE(7020),
    [sym_prefix_unboxed_tuple] = STATE(7020),
    [sym_prefix_unboxed_sum] = STATE(7020),
    [sym_literal] = STATE(7020),
    [sym__qualified_type] = STATE(7160),
    [sym__qtyconid] = STATE(7122),
    [sym__tycon_arrow] = STATE(7122),
    [sym__qtycon_arrow] = STATE(7122),
    [sym__promoted_tycons_alias] = STATE(7020),
    [sym__promoted_tycons] = STATE(7020),
    [sym__tycon_ticked] = STATE(2563),
    [sym__qtycon_ticked] = STATE(2563),
    [sym__tyconids_ticked] = STATE(2563),
    [sym__promoted_tyconops_alias] = STATE(2563),
    [sym__promoted_tyconops] = STATE(2563),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2563),
    [sym__operator_alias] = STATE(2563),
    [sym__operator_minus] = STATE(2563),
    [sym__varsym_prefix] = STATE(7122),
    [sym__pvarsym] = STATE(7122),
    [sym__qualified_varsym] = STATE(2564),
    [sym__qvarsym_prefix] = STATE(7122),
    [sym__pqvarsym] = STATE(7122),
    [sym_constructor_operator] = STATE(2563),
    [sym__constructor_operator_alias] = STATE(2563),
    [sym__consym_prefix] = STATE(7122),
    [sym__pconsym] = STATE(7122),
    [sym__qualified_consym] = STATE(2567),
    [sym__qconsym_prefix] = STATE(7122),
    [sym__pqconsym] = STATE(7122),
    [sym__prefix_at] = STATE(2518),
    [sym__paren_open] = STATE(473),
    [sym__bracket_open] = STATE(1082),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = ACTIONS(2781),
    [anon_sym__] = ACTIONS(2783),
    [anon_sym_SQUOTE] = ACTIONS(2785),
    [anon_sym_STAR] = ACTIONS(2787),
    [anon_sym_u2605] = ACTIONS(2789),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2791),
    [sym_char] = ACTIONS(2791),
    [sym_string] = ACTIONS(2791),
    [sym__integer_literal] = ACTIONS(2793),
    [sym__binary_literal] = ACTIONS(2795),
    [sym__octal_literal] = ACTIONS(2795),
    [sym__hex_literal] = ACTIONS(2795),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2797),
    [anon_sym_u2192] = ACTIONS(1181),
    [anon_sym_DASH_GT_DOT] = ACTIONS(1181),
    [anon_sym_u22b8] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_where] = ACTIONS(1181),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2799),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_prefix_percent] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [950] = {
    [sym__type_parens] = STATE(7142),
    [sym__type_tuple] = STATE(7143),
    [sym__type_unboxed_tuple] = STATE(7144),
    [sym__type_unboxed_sum] = STATE(7145),
    [sym__type_list] = STATE(7146),
    [sym__type_promoted] = STATE(7140),
    [sym__type_star] = STATE(7140),
    [sym__type_wildcard] = STATE(7140),
    [sym__at_type] = STATE(7167),
    [sym__type_apply] = STATE(7147),
    [sym__type_infix] = STATE(7148),
    [sym_type] = STATE(945),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8458),
    [sym__splice_dollars] = STATE(7440),
    [sym_splice] = STATE(7140),
    [sym_quasiquote] = STATE(7140),
    [sym_integer] = STATE(7036),
    [sym__plist] = STATE(7149),
    [sym_unit] = STATE(7140),
    [sym_unboxed_unit] = STATE(7140),
    [sym_prefix_tuple] = STATE(7140),
    [sym_prefix_unboxed_tuple] = STATE(7140),
    [sym_prefix_unboxed_sum] = STATE(7140),
    [sym_literal] = STATE(7140),
    [sym__qualified_type] = STATE(7079),
    [sym__qtyconid] = STATE(7150),
    [sym__tycon_arrow] = STATE(7150),
    [sym__qtycon_arrow] = STATE(7150),
    [sym__promoted_tycons_alias] = STATE(7140),
    [sym__promoted_tycons] = STATE(7140),
    [sym__tycon_ticked] = STATE(2436),
    [sym__qtycon_ticked] = STATE(2436),
    [sym__tyconids_ticked] = STATE(2436),
    [sym__promoted_tyconops_alias] = STATE(2436),
    [sym__promoted_tyconops] = STATE(2436),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2436),
    [sym__operator_alias] = STATE(2436),
    [sym__operator_minus] = STATE(2436),
    [sym__varsym_prefix] = STATE(7150),
    [sym__pvarsym] = STATE(7150),
    [sym__qualified_varsym] = STATE(2435),
    [sym__qvarsym_prefix] = STATE(7150),
    [sym__pqvarsym] = STATE(7150),
    [sym_constructor_operator] = STATE(2436),
    [sym__constructor_operator_alias] = STATE(2436),
    [sym__consym_prefix] = STATE(7150),
    [sym__pconsym] = STATE(7150),
    [sym__qualified_consym] = STATE(2434),
    [sym__qconsym_prefix] = STATE(7150),
    [sym__pqconsym] = STATE(7150),
    [sym__prefix_at] = STATE(2655),
    [sym__paren_open] = STATE(450),
    [sym__bracket_open] = STATE(1027),
    [sym__unboxed_open] = STATE(831),
    [sym_variable] = ACTIONS(2757),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2765),
    [anon_sym_u2605] = ACTIONS(2767),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_deriving] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2771),
    [sym_char] = ACTIONS(2771),
    [sym_string] = ACTIONS(2771),
    [sym__integer_literal] = ACTIONS(2773),
    [sym__binary_literal] = ACTIONS(2775),
    [sym__octal_literal] = ACTIONS(2775),
    [sym__hex_literal] = ACTIONS(2775),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2777),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1157),
    [sym__cond_layout_end] = ACTIONS(1157),
    [sym__cond_layout_end_explicit] = ACTIONS(1157),
    [sym__phantom_bar] = ACTIONS(1157),
    [sym__phantom_deriving] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2779),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [951] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(9045),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__bracket_close] = STATE(4233),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2819),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [952] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1056),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2280),
    [sym__qconstructor_ticked] = STATE(2280),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2280),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2642),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2821),
    [anon_sym_COMMA] = ACTIONS(2823),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym_RBRACE] = ACTIONS(2823),
    [anon_sym__] = ACTIONS(2821),
    [anon_sym_EQ] = ACTIONS(2823),
    [anon_sym_DASH] = ACTIONS(2821),
    [anon_sym_DASH_GT] = ACTIONS(2823),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2823),
    [anon_sym_u27e7] = ACTIONS(2823),
    [sym_float] = ACTIONS(2823),
    [sym_char] = ACTIONS(2823),
    [sym_string] = ACTIONS(2823),
    [sym__integer_literal] = ACTIONS(2821),
    [sym__binary_literal] = ACTIONS(2823),
    [sym__octal_literal] = ACTIONS(2823),
    [sym__hex_literal] = ACTIONS(2823),
    [anon_sym_BQUOTE] = ACTIONS(2823),
    [sym_name] = ACTIONS(2823),
    [anon_sym_u2192] = ACTIONS(2823),
    [anon_sym_LT_DASH] = ACTIONS(2823),
    [anon_sym_u2190] = ACTIONS(2823),
    [anon_sym_COLON_COLON] = ACTIONS(2823),
    [anon_sym_u2237] = ACTIONS(2823),
    [aux_sym__paren_open_token1] = ACTIONS(2823),
    [aux_sym__paren_close_token1] = ACTIONS(2823),
    [anon_sym_RBRACK] = ACTIONS(2823),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2823),
    [sym__cond_splice] = ACTIONS(2823),
    [sym__cond_prefix_at] = ACTIONS(2823),
    [sym__cond_tight_bang] = ACTIONS(2823),
    [sym__cond_prefix_bang] = ACTIONS(2823),
    [sym__cond_tight_tilde] = ACTIONS(2823),
    [sym__cond_prefix_tilde] = ACTIONS(2823),
    [sym__cond_qualified_op] = ACTIONS(2823),
    [sym__cond_no_section_op] = ACTIONS(2823),
    [sym__consym] = ACTIONS(2823),
  },
  [953] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1056),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2280),
    [sym__qconstructor_ticked] = STATE(2280),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2280),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2642),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_EQ] = ACTIONS(2829),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2829),
    [anon_sym_u27e7] = ACTIONS(2829),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(2841),
    [anon_sym_u2192] = ACTIONS(2829),
    [anon_sym_LT_DASH] = ACTIONS(2829),
    [anon_sym_u2190] = ACTIONS(2829),
    [anon_sym_COLON_COLON] = ACTIONS(2829),
    [anon_sym_u2237] = ACTIONS(2829),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(2829),
    [anon_sym_RBRACK] = ACTIONS(2829),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(2845),
    [sym__cond_no_section_op] = ACTIONS(2847),
    [sym__consym] = ACTIONS(2737),
  },
  [954] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(9049),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__bracket_close] = STATE(4524),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2849),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [955] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10107),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(7290),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2851),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [956] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12210),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2853),
    [anon_sym_u27e7] = ACTIONS(2853),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [957] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12071),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2855),
    [anon_sym_u27e7] = ACTIONS(2855),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [958] = {
    [sym__type_parens] = STATE(7268),
    [sym__type_tuple] = STATE(7262),
    [sym__type_unboxed_tuple] = STATE(7258),
    [sym__type_unboxed_sum] = STATE(7246),
    [sym__type_list] = STATE(7247),
    [sym__type_promoted] = STATE(7269),
    [sym__type_star] = STATE(7269),
    [sym__type_wildcard] = STATE(7269),
    [sym__at_type] = STATE(7235),
    [sym__type_apply] = STATE(7237),
    [sym__type_infix] = STATE(7207),
    [sym_type] = STATE(1095),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8479),
    [sym__splice_dollars] = STATE(7208),
    [sym_splice] = STATE(7269),
    [sym_quasiquote] = STATE(7269),
    [sym_integer] = STATE(7206),
    [sym__plist] = STATE(7209),
    [sym_unit] = STATE(7269),
    [sym_unboxed_unit] = STATE(7269),
    [sym_prefix_tuple] = STATE(7269),
    [sym_prefix_unboxed_tuple] = STATE(7269),
    [sym_prefix_unboxed_sum] = STATE(7269),
    [sym_literal] = STATE(7269),
    [sym__qualified_type] = STATE(7374),
    [sym__qtyconid] = STATE(7210),
    [sym__tycon_arrow] = STATE(7210),
    [sym__qtycon_arrow] = STATE(7210),
    [sym__promoted_tycons_alias] = STATE(7269),
    [sym__promoted_tycons] = STATE(7269),
    [sym__tycon_ticked] = STATE(2621),
    [sym__qtycon_ticked] = STATE(2621),
    [sym__tyconids_ticked] = STATE(2621),
    [sym__promoted_tyconops_alias] = STATE(2621),
    [sym__promoted_tyconops] = STATE(2621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2621),
    [sym__operator_alias] = STATE(2621),
    [sym__operator_minus] = STATE(2621),
    [sym__varsym_prefix] = STATE(7210),
    [sym__pvarsym] = STATE(7210),
    [sym__qualified_varsym] = STATE(2620),
    [sym__qvarsym_prefix] = STATE(7210),
    [sym__pqvarsym] = STATE(7210),
    [sym_constructor_operator] = STATE(2621),
    [sym__constructor_operator_alias] = STATE(2621),
    [sym__consym_prefix] = STATE(7210),
    [sym__pconsym] = STATE(7210),
    [sym__qualified_consym] = STATE(2619),
    [sym__qconsym_prefix] = STATE(7210),
    [sym__pqconsym] = STATE(7210),
    [sym__prefix_at] = STATE(2554),
    [sym__paren_open] = STATE(448),
    [sym__bracket_open] = STATE(1009),
    [sym__unboxed_open] = STATE(824),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_via] = ACTIONS(1177),
    [anon_sym_deriving] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym__phantom_deriving] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [959] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12197),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2853),
    [anon_sym_u27e7] = ACTIONS(2853),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [960] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12186),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(4717),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2857),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [961] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(9096),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__bracket_close] = STATE(4128),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2859),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [962] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10845),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(6464),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1215),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [963] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10624),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(7577),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2861),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [964] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10656),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(3925),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2863),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [965] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10776),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(6586),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2865),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [966] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10826),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(6749),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2867),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [967] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11522),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2869),
    [anon_sym_u27e7] = ACTIONS(2869),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [968] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11864),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2871),
    [anon_sym_u27e7] = ACTIONS(2871),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [969] = {
    [sym__type_parens] = STATE(7416),
    [sym__type_tuple] = STATE(7417),
    [sym__type_unboxed_tuple] = STATE(7424),
    [sym__type_unboxed_sum] = STATE(7426),
    [sym__type_list] = STATE(7427),
    [sym__type_promoted] = STATE(7415),
    [sym__type_star] = STATE(7415),
    [sym__type_wildcard] = STATE(7415),
    [sym__at_type] = STATE(7476),
    [sym__type_apply] = STATE(7428),
    [sym__type_infix] = STATE(7240),
    [sym_type] = STATE(983),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8549),
    [sym__splice_dollars] = STATE(7270),
    [sym_splice] = STATE(7415),
    [sym_quasiquote] = STATE(7415),
    [sym_integer] = STATE(7274),
    [sym__plist] = STATE(7429),
    [sym_unit] = STATE(7415),
    [sym_unboxed_unit] = STATE(7415),
    [sym_prefix_tuple] = STATE(7415),
    [sym_prefix_unboxed_tuple] = STATE(7415),
    [sym_prefix_unboxed_sum] = STATE(7415),
    [sym_literal] = STATE(7415),
    [sym__qualified_type] = STATE(7267),
    [sym__qtyconid] = STATE(7438),
    [sym__tycon_arrow] = STATE(7438),
    [sym__qtycon_arrow] = STATE(7438),
    [sym__promoted_tycons_alias] = STATE(7415),
    [sym__promoted_tycons] = STATE(7415),
    [sym__tycon_ticked] = STATE(2664),
    [sym__qtycon_ticked] = STATE(2664),
    [sym__tyconids_ticked] = STATE(2664),
    [sym__promoted_tyconops_alias] = STATE(2664),
    [sym__promoted_tyconops] = STATE(2664),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2664),
    [sym__operator_alias] = STATE(2664),
    [sym__operator_minus] = STATE(2664),
    [sym__varsym_prefix] = STATE(7438),
    [sym__pvarsym] = STATE(7438),
    [sym__qualified_varsym] = STATE(2653),
    [sym__qvarsym_prefix] = STATE(7438),
    [sym__pqvarsym] = STATE(7438),
    [sym_constructor_operator] = STATE(2664),
    [sym__constructor_operator_alias] = STATE(2664),
    [sym__consym_prefix] = STATE(7438),
    [sym__pconsym] = STATE(7438),
    [sym__qualified_consym] = STATE(2645),
    [sym__qconsym_prefix] = STATE(7438),
    [sym__pqconsym] = STATE(7438),
    [sym__prefix_at] = STATE(2602),
    [sym__paren_open] = STATE(474),
    [sym__bracket_open] = STATE(1124),
    [sym__unboxed_open] = STATE(733),
    [sym_variable] = ACTIONS(1177),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__paren_close_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_tight_bang] = ACTIONS(1179),
    [sym__cond_prefix_bang] = ACTIONS(1179),
    [sym__cond_tight_tilde] = ACTIONS(1179),
    [sym__cond_prefix_tilde] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [970] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12147),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2873),
    [anon_sym_u27e7] = ACTIONS(2873),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [971] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10807),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(6117),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2875),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [972] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12025),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2877),
    [anon_sym_u27e7] = ACTIONS(2877),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [973] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11648),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2879),
    [anon_sym_u27e7] = ACTIONS(2879),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [974] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(10162),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__bracket_close] = STATE(5438),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2881),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [975] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(183),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11147),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_COMMA] = ACTIONS(2883),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_POUND_RPAREN] = ACTIONS(2883),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [976] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10788),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(3406),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2885),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [977] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11886),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(5297),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2887),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [978] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(10348),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__bracket_close] = STATE(5295),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2887),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [979] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11744),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(5437),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2881),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [980] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11733),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2889),
    [anon_sym_u27e7] = ACTIONS(2889),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [981] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(11729),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2889),
    [anon_sym_u27e7] = ACTIONS(2889),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [982] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10189),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(6212),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2891),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [983] = {
    [sym__type_parens] = STATE(7416),
    [sym__type_tuple] = STATE(7417),
    [sym__type_unboxed_tuple] = STATE(7424),
    [sym__type_unboxed_sum] = STATE(7426),
    [sym__type_list] = STATE(7427),
    [sym__type_promoted] = STATE(7415),
    [sym__type_star] = STATE(7415),
    [sym__type_wildcard] = STATE(7415),
    [sym__at_type] = STATE(7476),
    [sym__type_apply] = STATE(7428),
    [sym__type_infix] = STATE(7240),
    [sym_type] = STATE(983),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8549),
    [sym__splice_dollars] = STATE(7270),
    [sym_splice] = STATE(7415),
    [sym_quasiquote] = STATE(7415),
    [sym_integer] = STATE(7274),
    [sym__plist] = STATE(7429),
    [sym_unit] = STATE(7415),
    [sym_unboxed_unit] = STATE(7415),
    [sym_prefix_tuple] = STATE(7415),
    [sym_prefix_unboxed_tuple] = STATE(7415),
    [sym_prefix_unboxed_sum] = STATE(7415),
    [sym_literal] = STATE(7415),
    [sym__qualified_type] = STATE(7267),
    [sym__qtyconid] = STATE(7438),
    [sym__tycon_arrow] = STATE(7438),
    [sym__qtycon_arrow] = STATE(7438),
    [sym__promoted_tycons_alias] = STATE(7415),
    [sym__promoted_tycons] = STATE(7415),
    [sym__tycon_ticked] = STATE(2664),
    [sym__qtycon_ticked] = STATE(2664),
    [sym__tyconids_ticked] = STATE(2664),
    [sym__promoted_tyconops_alias] = STATE(2664),
    [sym__promoted_tyconops] = STATE(2664),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2664),
    [sym__operator_alias] = STATE(2664),
    [sym__operator_minus] = STATE(2664),
    [sym__varsym_prefix] = STATE(7438),
    [sym__pvarsym] = STATE(7438),
    [sym__qualified_varsym] = STATE(2653),
    [sym__qvarsym_prefix] = STATE(7438),
    [sym__pqvarsym] = STATE(7438),
    [sym_constructor_operator] = STATE(2664),
    [sym__constructor_operator_alias] = STATE(2664),
    [sym__consym_prefix] = STATE(7438),
    [sym__pconsym] = STATE(7438),
    [sym__qualified_consym] = STATE(2645),
    [sym__qconsym_prefix] = STATE(7438),
    [sym__pqconsym] = STATE(7438),
    [sym__prefix_at] = STATE(2602),
    [sym__paren_open] = STATE(474),
    [sym__bracket_open] = STATE(1124),
    [sym__unboxed_open] = STATE(733),
    [sym_variable] = ACTIONS(1117),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__paren_close_token1] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__cond_tight_bang] = ACTIONS(1119),
    [sym__cond_prefix_bang] = ACTIONS(1119),
    [sym__cond_tight_tilde] = ACTIONS(1119),
    [sym__cond_prefix_tilde] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [984] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12217),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(5390),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2887),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [985] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12186),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(5286),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2881),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [986] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10768),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(5914),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2893),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [987] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10569),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(5079),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2895),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [988] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__assoc_tyfam] = STATE(10138),
    [sym__assoc_tyinst] = STATE(10139),
    [sym__assoc_datafam] = STATE(10141),
    [sym_default_signature] = STATE(10146),
    [sym_class_decl] = STATE(9443),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10146),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10146),
    [sym__local_decl] = STATE(10146),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_data] = ACTIONS(1935),
    [anon_sym_default] = ACTIONS(1937),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [989] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11635),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(5321),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2881),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [990] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10757),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(6406),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2897),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [991] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12182),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(5211),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2849),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [992] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11981),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(4762),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2857),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [993] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11147),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(2883),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(2883),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [994] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1056),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2280),
    [sym__qconstructor_ticked] = STATE(2280),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2280),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2642),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym_COMMA] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym_RBRACE] = ACTIONS(2899),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_EQ] = ACTIONS(2899),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_DASH_GT] = ACTIONS(2899),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2899),
    [anon_sym_u27e7] = ACTIONS(2899),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(2841),
    [anon_sym_u2192] = ACTIONS(2899),
    [anon_sym_LT_DASH] = ACTIONS(2899),
    [anon_sym_u2190] = ACTIONS(2899),
    [anon_sym_COLON_COLON] = ACTIONS(2899),
    [anon_sym_u2237] = ACTIONS(2899),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(2899),
    [anon_sym_RBRACK] = ACTIONS(2899),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(2845),
    [sym__cond_no_section_op] = ACTIONS(2847),
    [sym__consym] = ACTIONS(2737),
  },
  [995] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10732),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(7779),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2901),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [996] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12186),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(5236),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2849),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [997] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1056),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2280),
    [sym__qconstructor_ticked] = STATE(2280),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2280),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2642),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym_COMMA] = ACTIONS(2903),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym_RBRACE] = ACTIONS(2903),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_EQ] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_DASH_GT] = ACTIONS(2903),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2903),
    [anon_sym_u27e7] = ACTIONS(2903),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(2841),
    [anon_sym_u2192] = ACTIONS(2903),
    [anon_sym_LT_DASH] = ACTIONS(2903),
    [anon_sym_u2190] = ACTIONS(2903),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_u2237] = ACTIONS(2903),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(2903),
    [anon_sym_RBRACK] = ACTIONS(2903),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(2845),
    [sym__cond_no_section_op] = ACTIONS(2847),
    [sym__consym] = ACTIONS(2737),
  },
  [998] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10441),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(4518),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2887),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [999] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(11908),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2905),
    [anon_sym_u27e7] = ACTIONS(2905),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1000] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10396),
    [sym__assoc_tyinst] = STATE(10389),
    [sym__assoc_datainst_adt] = STATE(10386),
    [sym__assoc_datainst_newtype] = STATE(10381),
    [sym__assoc_datainst] = STATE(10379),
    [sym_instance_decl] = STATE(9240),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10379),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(1662),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_newtype] = ACTIONS(2911),
    [anon_sym_data] = ACTIONS(2913),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(2915),
    [sym__cond_layout_end] = ACTIONS(2917),
    [sym__cond_layout_end_explicit] = ACTIONS(2917),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1001] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12080),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(3018),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2919),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1002] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11411),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2921),
    [anon_sym_u27e7] = ACTIONS(2921),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1003] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_EQ] = ACTIONS(1159),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [anon_sym_EQ_GT] = ACTIONS(1157),
    [anon_sym_u21d2] = ACTIONS(1157),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1157),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1004] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11877),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2905),
    [anon_sym_u27e7] = ACTIONS(2905),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1005] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8328),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__record_fields] = STATE(9999),
    [sym__gadt_con_prefix] = STATE(10319),
    [sym__gadt_con_record] = STATE(10316),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1006] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_EQ] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [anon_sym_EQ_GT] = ACTIONS(1181),
    [anon_sym_u21d2] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1007] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10514),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(4128),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2859),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1008] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(8970),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__bracket_close] = STATE(2728),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2919),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1009] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10711),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(7419),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2943),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1010] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(10273),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__bracket_close] = STATE(2862),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2919),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1011] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8328),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__record_fields] = STATE(9999),
    [sym__gadt_con_prefix] = STATE(10307),
    [sym__gadt_con_record] = STATE(10305),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1012] = {
    [sym__type_parens] = STATE(7268),
    [sym__type_tuple] = STATE(7262),
    [sym__type_unboxed_tuple] = STATE(7258),
    [sym__type_unboxed_sum] = STATE(7246),
    [sym__type_list] = STATE(7247),
    [sym__type_promoted] = STATE(7269),
    [sym__type_star] = STATE(7269),
    [sym__type_wildcard] = STATE(7269),
    [sym__at_type] = STATE(7235),
    [sym__type_apply] = STATE(7237),
    [sym__type_infix] = STATE(7207),
    [sym_type] = STATE(1095),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8479),
    [sym__splice_dollars] = STATE(7208),
    [sym_splice] = STATE(7269),
    [sym_quasiquote] = STATE(7269),
    [sym_integer] = STATE(7206),
    [sym__plist] = STATE(7209),
    [sym_unit] = STATE(7269),
    [sym_unboxed_unit] = STATE(7269),
    [sym_prefix_tuple] = STATE(7269),
    [sym_prefix_unboxed_tuple] = STATE(7269),
    [sym_prefix_unboxed_sum] = STATE(7269),
    [sym_literal] = STATE(7269),
    [sym__qualified_type] = STATE(7374),
    [sym__qtyconid] = STATE(7210),
    [sym__tycon_arrow] = STATE(7210),
    [sym__qtycon_arrow] = STATE(7210),
    [sym__promoted_tycons_alias] = STATE(7269),
    [sym__promoted_tycons] = STATE(7269),
    [sym__tycon_ticked] = STATE(2621),
    [sym__qtycon_ticked] = STATE(2621),
    [sym__tyconids_ticked] = STATE(2621),
    [sym__promoted_tyconops_alias] = STATE(2621),
    [sym__promoted_tyconops] = STATE(2621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2621),
    [sym__operator_alias] = STATE(2621),
    [sym__operator_minus] = STATE(2621),
    [sym__varsym_prefix] = STATE(7210),
    [sym__pvarsym] = STATE(7210),
    [sym__qualified_varsym] = STATE(2620),
    [sym__qvarsym_prefix] = STATE(7210),
    [sym__pqvarsym] = STATE(7210),
    [sym_constructor_operator] = STATE(2621),
    [sym__constructor_operator_alias] = STATE(2621),
    [sym__consym_prefix] = STATE(7210),
    [sym__pconsym] = STATE(7210),
    [sym__qualified_consym] = STATE(2619),
    [sym__qconsym_prefix] = STATE(7210),
    [sym__pqconsym] = STATE(7210),
    [sym__prefix_at] = STATE(2554),
    [sym__paren_open] = STATE(448),
    [sym__bracket_open] = STATE(1009),
    [sym__unboxed_open] = STATE(824),
    [sym_variable] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(2949),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_u2605] = ACTIONS(2953),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_via] = ACTIONS(1183),
    [anon_sym_deriving] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2955),
    [sym_char] = ACTIONS(2955),
    [sym_string] = ACTIONS(2955),
    [sym__integer_literal] = ACTIONS(2957),
    [sym__binary_literal] = ACTIONS(2959),
    [sym__octal_literal] = ACTIONS(2959),
    [sym__hex_literal] = ACTIONS(2959),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2961),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_deriving] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2963),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1013] = {
    [sym__type_parens] = STATE(7268),
    [sym__type_tuple] = STATE(7262),
    [sym__type_unboxed_tuple] = STATE(7258),
    [sym__type_unboxed_sum] = STATE(7246),
    [sym__type_list] = STATE(7247),
    [sym__type_promoted] = STATE(7269),
    [sym__type_star] = STATE(7269),
    [sym__type_wildcard] = STATE(7269),
    [sym__at_type] = STATE(7235),
    [sym__type_apply] = STATE(7237),
    [sym__type_infix] = STATE(7207),
    [sym_type] = STATE(1095),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8479),
    [sym__splice_dollars] = STATE(7208),
    [sym_splice] = STATE(7269),
    [sym_quasiquote] = STATE(7269),
    [sym_integer] = STATE(7206),
    [sym__plist] = STATE(7209),
    [sym_unit] = STATE(7269),
    [sym_unboxed_unit] = STATE(7269),
    [sym_prefix_tuple] = STATE(7269),
    [sym_prefix_unboxed_tuple] = STATE(7269),
    [sym_prefix_unboxed_sum] = STATE(7269),
    [sym_literal] = STATE(7269),
    [sym__qualified_type] = STATE(7374),
    [sym__qtyconid] = STATE(7210),
    [sym__tycon_arrow] = STATE(7210),
    [sym__qtycon_arrow] = STATE(7210),
    [sym__promoted_tycons_alias] = STATE(7269),
    [sym__promoted_tycons] = STATE(7269),
    [sym__tycon_ticked] = STATE(2621),
    [sym__qtycon_ticked] = STATE(2621),
    [sym__tyconids_ticked] = STATE(2621),
    [sym__promoted_tyconops_alias] = STATE(2621),
    [sym__promoted_tyconops] = STATE(2621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2621),
    [sym__operator_alias] = STATE(2621),
    [sym__operator_minus] = STATE(2621),
    [sym__varsym_prefix] = STATE(7210),
    [sym__pvarsym] = STATE(7210),
    [sym__qualified_varsym] = STATE(2620),
    [sym__qvarsym_prefix] = STATE(7210),
    [sym__pqvarsym] = STATE(7210),
    [sym_constructor_operator] = STATE(2621),
    [sym__constructor_operator_alias] = STATE(2621),
    [sym__consym_prefix] = STATE(7210),
    [sym__pconsym] = STATE(7210),
    [sym__qualified_consym] = STATE(2619),
    [sym__qconsym_prefix] = STATE(7210),
    [sym__pqconsym] = STATE(7210),
    [sym__prefix_at] = STATE(2554),
    [sym__paren_open] = STATE(448),
    [sym__bracket_open] = STATE(1009),
    [sym__unboxed_open] = STATE(824),
    [sym_variable] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(2949),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_u2605] = ACTIONS(2953),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_via] = ACTIONS(1183),
    [anon_sym_deriving] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2955),
    [sym_char] = ACTIONS(2955),
    [sym_string] = ACTIONS(2955),
    [sym__integer_literal] = ACTIONS(2957),
    [sym__binary_literal] = ACTIONS(2959),
    [sym__octal_literal] = ACTIONS(2959),
    [sym__hex_literal] = ACTIONS(2959),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2961),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_deriving] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2963),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1014] = {
    [sym__type_parens] = STATE(7268),
    [sym__type_tuple] = STATE(7262),
    [sym__type_unboxed_tuple] = STATE(7258),
    [sym__type_unboxed_sum] = STATE(7246),
    [sym__type_list] = STATE(7247),
    [sym__type_promoted] = STATE(7269),
    [sym__type_star] = STATE(7269),
    [sym__type_wildcard] = STATE(7269),
    [sym__at_type] = STATE(7235),
    [sym__type_apply] = STATE(7237),
    [sym__type_infix] = STATE(7207),
    [sym_type] = STATE(1095),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8479),
    [sym__splice_dollars] = STATE(7208),
    [sym_splice] = STATE(7269),
    [sym_quasiquote] = STATE(7269),
    [sym_integer] = STATE(7206),
    [sym__plist] = STATE(7209),
    [sym_unit] = STATE(7269),
    [sym_unboxed_unit] = STATE(7269),
    [sym_prefix_tuple] = STATE(7269),
    [sym_prefix_unboxed_tuple] = STATE(7269),
    [sym_prefix_unboxed_sum] = STATE(7269),
    [sym_literal] = STATE(7269),
    [sym__qualified_type] = STATE(7374),
    [sym__qtyconid] = STATE(7210),
    [sym__tycon_arrow] = STATE(7210),
    [sym__qtycon_arrow] = STATE(7210),
    [sym__promoted_tycons_alias] = STATE(7269),
    [sym__promoted_tycons] = STATE(7269),
    [sym__tycon_ticked] = STATE(2621),
    [sym__qtycon_ticked] = STATE(2621),
    [sym__tyconids_ticked] = STATE(2621),
    [sym__promoted_tyconops_alias] = STATE(2621),
    [sym__promoted_tyconops] = STATE(2621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2621),
    [sym__operator_alias] = STATE(2621),
    [sym__operator_minus] = STATE(2621),
    [sym__varsym_prefix] = STATE(7210),
    [sym__pvarsym] = STATE(7210),
    [sym__qualified_varsym] = STATE(2620),
    [sym__qvarsym_prefix] = STATE(7210),
    [sym__pqvarsym] = STATE(7210),
    [sym_constructor_operator] = STATE(2621),
    [sym__constructor_operator_alias] = STATE(2621),
    [sym__consym_prefix] = STATE(7210),
    [sym__pconsym] = STATE(7210),
    [sym__qualified_consym] = STATE(2619),
    [sym__qconsym_prefix] = STATE(7210),
    [sym__pqconsym] = STATE(7210),
    [sym__prefix_at] = STATE(2554),
    [sym__paren_open] = STATE(448),
    [sym__bracket_open] = STATE(1009),
    [sym__unboxed_open] = STATE(824),
    [sym_variable] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(2949),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_u2605] = ACTIONS(2953),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_via] = ACTIONS(1159),
    [anon_sym_deriving] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2955),
    [sym_char] = ACTIONS(2955),
    [sym_string] = ACTIONS(2955),
    [sym__integer_literal] = ACTIONS(2957),
    [sym__binary_literal] = ACTIONS(2959),
    [sym__octal_literal] = ACTIONS(2959),
    [sym__hex_literal] = ACTIONS(2959),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2961),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1157),
    [sym__cond_layout_end] = ACTIONS(1157),
    [sym__cond_layout_end_explicit] = ACTIONS(1157),
    [sym__phantom_deriving] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2963),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1015] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11856),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(5268),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2849),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1016] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11438),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2965),
    [anon_sym_u27e7] = ACTIONS(2965),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1017] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10026),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(6917),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2967),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1018] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_EQ] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [anon_sym_EQ_GT] = ACTIONS(1181),
    [anon_sym_u21d2] = ACTIONS(1181),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1019] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(10174),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__bracket_close] = STATE(5269),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2849),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1020] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(10215),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__bracket_close] = STATE(4425),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2859),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1021] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12058),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(4426),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2859),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1022] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(9140),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__bracket_close] = STATE(5058),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2969),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1023] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12070),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2971),
    [anon_sym_u27e7] = ACTIONS(2971),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1024] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8328),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__record_fields] = STATE(9999),
    [sym__gadt_con_prefix] = STATE(10331),
    [sym__gadt_con_record] = STATE(10308),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1025] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11786),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2973),
    [anon_sym_u27e7] = ACTIONS(2973),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1026] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(10228),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__bracket_close] = STATE(4764),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2857),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1027] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10449),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(7151),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2975),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1028] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10879),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(6355),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2977),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1029] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10685),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(6568),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2979),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1030] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11383),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2981),
    [anon_sym_u27e7] = ACTIONS(2981),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1031] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10579),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__paren_close] = STATE(10580),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(2983),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1032] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(10147),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__bracket_close] = STATE(4026),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2985),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1033] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8328),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__record_fields] = STATE(9999),
    [sym__gadt_con_prefix] = STATE(10301),
    [sym__gadt_con_record] = STATE(10298),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1034] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12122),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2971),
    [anon_sym_u27e7] = ACTIONS(2971),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1035] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11512),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(4025),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2985),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1036] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11551),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2987),
    [anon_sym_u27e7] = ACTIONS(2987),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1037] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10664),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(4524),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2849),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1038] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(11566),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2987),
    [anon_sym_u27e7] = ACTIONS(2987),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1039] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11911),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(2870),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2919),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1040] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11788),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2989),
    [anon_sym_u27e7] = ACTIONS(2989),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1041] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10459),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(4064),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2857),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1042] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10646),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(4447),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2881),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1043] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12125),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2877),
    [anon_sym_u27e7] = ACTIONS(2877),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1044] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11931),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2991),
    [anon_sym_u27e7] = ACTIONS(2991),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1045] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10821),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(6020),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2993),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1046] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11520),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(4915),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2995),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1047] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10631),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(2313),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2997),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1048] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12186),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(3984),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2985),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1049] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(11932),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2991),
    [anon_sym_u27e7] = ACTIONS(2991),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1050] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10613),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(5848),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2999),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1051] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12186),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(4677),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2859),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1052] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(8974),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__bracket_close] = STATE(3789),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2985),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1053] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11716),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(3961),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2985),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1054] = {
    [sym__type_parens] = STATE(7268),
    [sym__type_tuple] = STATE(7262),
    [sym__type_unboxed_tuple] = STATE(7258),
    [sym__type_unboxed_sum] = STATE(7246),
    [sym__type_list] = STATE(7247),
    [sym__type_promoted] = STATE(7269),
    [sym__type_star] = STATE(7269),
    [sym__type_wildcard] = STATE(7269),
    [sym__at_type] = STATE(7235),
    [sym__type_apply] = STATE(7237),
    [sym__type_infix] = STATE(7207),
    [sym_type] = STATE(1095),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8479),
    [sym__splice_dollars] = STATE(7208),
    [sym_splice] = STATE(7269),
    [sym_quasiquote] = STATE(7269),
    [sym_integer] = STATE(7206),
    [sym__plist] = STATE(7209),
    [sym_unit] = STATE(7269),
    [sym_unboxed_unit] = STATE(7269),
    [sym_prefix_tuple] = STATE(7269),
    [sym_prefix_unboxed_tuple] = STATE(7269),
    [sym_prefix_unboxed_sum] = STATE(7269),
    [sym_literal] = STATE(7269),
    [sym__qualified_type] = STATE(7374),
    [sym__qtyconid] = STATE(7210),
    [sym__tycon_arrow] = STATE(7210),
    [sym__qtycon_arrow] = STATE(7210),
    [sym__promoted_tycons_alias] = STATE(7269),
    [sym__promoted_tycons] = STATE(7269),
    [sym__tycon_ticked] = STATE(2621),
    [sym__qtycon_ticked] = STATE(2621),
    [sym__tyconids_ticked] = STATE(2621),
    [sym__promoted_tyconops_alias] = STATE(2621),
    [sym__promoted_tyconops] = STATE(2621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2621),
    [sym__operator_alias] = STATE(2621),
    [sym__operator_minus] = STATE(2621),
    [sym__varsym_prefix] = STATE(7210),
    [sym__pvarsym] = STATE(7210),
    [sym__qualified_varsym] = STATE(2620),
    [sym__qvarsym_prefix] = STATE(7210),
    [sym__pqvarsym] = STATE(7210),
    [sym_constructor_operator] = STATE(2621),
    [sym__constructor_operator_alias] = STATE(2621),
    [sym__consym_prefix] = STATE(7210),
    [sym__pconsym] = STATE(7210),
    [sym__qualified_consym] = STATE(2619),
    [sym__qconsym_prefix] = STATE(7210),
    [sym__pqconsym] = STATE(7210),
    [sym__prefix_at] = STATE(2554),
    [sym__paren_open] = STATE(448),
    [sym__bracket_open] = STATE(1009),
    [sym__unboxed_open] = STATE(824),
    [sym_variable] = ACTIONS(3001),
    [anon_sym_SEMI] = ACTIONS(3003),
    [anon_sym__] = ACTIONS(3001),
    [anon_sym_SQUOTE] = ACTIONS(3001),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_u2605] = ACTIONS(3003),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_via] = ACTIONS(3001),
    [anon_sym_deriving] = ACTIONS(3001),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [sym_float] = ACTIONS(3003),
    [sym_char] = ACTIONS(3003),
    [sym_string] = ACTIONS(3003),
    [sym__integer_literal] = ACTIONS(3001),
    [sym__binary_literal] = ACTIONS(3003),
    [sym__octal_literal] = ACTIONS(3003),
    [sym__hex_literal] = ACTIONS(3003),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(3003),
    [aux_sym__paren_open_token1] = ACTIONS(3003),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3003),
    [sym__cond_layout_end] = ACTIONS(3003),
    [sym__cond_layout_end_explicit] = ACTIONS(3003),
    [sym__phantom_deriving] = ACTIONS(3003),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3003),
    [sym__cond_splice] = ACTIONS(3003),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(3003),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1055] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10423),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(2728),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2919),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1056] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1056),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2280),
    [sym__qconstructor_ticked] = STATE(2280),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2280),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2642),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(3005),
    [anon_sym_COMMA] = ACTIONS(3007),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym_RBRACE] = ACTIONS(3007),
    [anon_sym__] = ACTIONS(3005),
    [anon_sym_EQ] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3005),
    [anon_sym_DASH_GT] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3007),
    [anon_sym_u27e7] = ACTIONS(3007),
    [sym_float] = ACTIONS(3007),
    [sym_char] = ACTIONS(3007),
    [sym_string] = ACTIONS(3007),
    [sym__integer_literal] = ACTIONS(3005),
    [sym__binary_literal] = ACTIONS(3007),
    [sym__octal_literal] = ACTIONS(3007),
    [sym__hex_literal] = ACTIONS(3007),
    [anon_sym_BQUOTE] = ACTIONS(3007),
    [sym_name] = ACTIONS(3007),
    [anon_sym_u2192] = ACTIONS(3007),
    [anon_sym_LT_DASH] = ACTIONS(3007),
    [anon_sym_u2190] = ACTIONS(3007),
    [anon_sym_COLON_COLON] = ACTIONS(3007),
    [anon_sym_u2237] = ACTIONS(3007),
    [aux_sym__paren_open_token1] = ACTIONS(3007),
    [aux_sym__paren_close_token1] = ACTIONS(3007),
    [anon_sym_RBRACK] = ACTIONS(3007),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3007),
    [sym__cond_splice] = ACTIONS(3007),
    [sym__cond_prefix_at] = ACTIONS(3007),
    [sym__cond_tight_bang] = ACTIONS(3007),
    [sym__cond_prefix_bang] = ACTIONS(3007),
    [sym__cond_tight_tilde] = ACTIONS(3007),
    [sym__cond_prefix_tilde] = ACTIONS(3007),
    [sym__cond_qualified_op] = ACTIONS(3007),
    [sym__cond_no_section_op] = ACTIONS(3007),
    [sym__consym] = ACTIONS(3007),
  },
  [1057] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1056),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2280),
    [sym__qconstructor_ticked] = STATE(2280),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2280),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2642),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(3009),
    [anon_sym_COMMA] = ACTIONS(3011),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym_RBRACE] = ACTIONS(3011),
    [anon_sym__] = ACTIONS(3009),
    [anon_sym_EQ] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3009),
    [anon_sym_DASH_GT] = ACTIONS(3011),
    [anon_sym_LBRACK] = ACTIONS(3011),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3011),
    [anon_sym_u27e7] = ACTIONS(3011),
    [sym_float] = ACTIONS(3011),
    [sym_char] = ACTIONS(3011),
    [sym_string] = ACTIONS(3011),
    [sym__integer_literal] = ACTIONS(3009),
    [sym__binary_literal] = ACTIONS(3011),
    [sym__octal_literal] = ACTIONS(3011),
    [sym__hex_literal] = ACTIONS(3011),
    [anon_sym_BQUOTE] = ACTIONS(3011),
    [sym_name] = ACTIONS(3011),
    [anon_sym_u2192] = ACTIONS(3011),
    [anon_sym_LT_DASH] = ACTIONS(3011),
    [anon_sym_u2190] = ACTIONS(3011),
    [anon_sym_COLON_COLON] = ACTIONS(3011),
    [anon_sym_u2237] = ACTIONS(3011),
    [aux_sym__paren_open_token1] = ACTIONS(3011),
    [aux_sym__paren_close_token1] = ACTIONS(3011),
    [anon_sym_RBRACK] = ACTIONS(3011),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3011),
    [sym__cond_splice] = ACTIONS(3011),
    [sym__cond_prefix_at] = ACTIONS(3011),
    [sym__cond_tight_bang] = ACTIONS(3011),
    [sym__cond_prefix_bang] = ACTIONS(3011),
    [sym__cond_tight_tilde] = ACTIONS(3011),
    [sym__cond_prefix_tilde] = ACTIONS(3011),
    [sym__cond_qualified_op] = ACTIONS(3011),
    [sym__cond_no_section_op] = ACTIONS(3011),
    [sym__consym] = ACTIONS(3011),
  },
  [1058] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1056),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2280),
    [sym__qconstructor_ticked] = STATE(2280),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2280),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2642),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(3013),
    [anon_sym_COMMA] = ACTIONS(3015),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym_RBRACE] = ACTIONS(3015),
    [anon_sym__] = ACTIONS(3013),
    [anon_sym_EQ] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3013),
    [anon_sym_DASH_GT] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3015),
    [anon_sym_u27e7] = ACTIONS(3015),
    [sym_float] = ACTIONS(3015),
    [sym_char] = ACTIONS(3015),
    [sym_string] = ACTIONS(3015),
    [sym__integer_literal] = ACTIONS(3013),
    [sym__binary_literal] = ACTIONS(3015),
    [sym__octal_literal] = ACTIONS(3015),
    [sym__hex_literal] = ACTIONS(3015),
    [anon_sym_BQUOTE] = ACTIONS(3015),
    [sym_name] = ACTIONS(3015),
    [anon_sym_u2192] = ACTIONS(3015),
    [anon_sym_LT_DASH] = ACTIONS(3015),
    [anon_sym_u2190] = ACTIONS(3015),
    [anon_sym_COLON_COLON] = ACTIONS(3015),
    [anon_sym_u2237] = ACTIONS(3015),
    [aux_sym__paren_open_token1] = ACTIONS(3015),
    [aux_sym__paren_close_token1] = ACTIONS(3015),
    [anon_sym_RBRACK] = ACTIONS(3015),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3015),
    [sym__cond_splice] = ACTIONS(3015),
    [sym__cond_prefix_at] = ACTIONS(3015),
    [sym__cond_tight_bang] = ACTIONS(3015),
    [sym__cond_prefix_bang] = ACTIONS(3015),
    [sym__cond_tight_tilde] = ACTIONS(3015),
    [sym__cond_prefix_tilde] = ACTIONS(3015),
    [sym__cond_qualified_op] = ACTIONS(3015),
    [sym__cond_no_section_op] = ACTIONS(3015),
    [sym__consym] = ACTIONS(3015),
  },
  [1059] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11637),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3017),
    [anon_sym_u27e7] = ACTIONS(3017),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1060] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11547),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(4486),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2819),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1061] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10588),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(6421),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(3019),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1062] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8328),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__record_fields] = STATE(9999),
    [sym__gadt_con_prefix] = STATE(10554),
    [sym__gadt_con_record] = STATE(10551),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1063] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10574),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(3789),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2985),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1064] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12186),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(2996),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2919),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1065] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11858),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3021),
    [anon_sym_u27e7] = ACTIONS(3021),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1066] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10728),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(7695),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(3023),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1067] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10858),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(5916),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(3025),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1068] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11822),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3027),
    [anon_sym_u27e7] = ACTIONS(3027),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1069] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10560),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(3648),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(3029),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1070] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(9035),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__bracket_close] = STATE(4064),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2857),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1071] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10402),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(4299),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2995),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1072] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10184),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(6188),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(1195),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1073] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10535),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(3356),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(3031),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1074] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11883),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(4775),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2859),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1075] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(9034),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__bracket_close] = STATE(4447),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2881),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1076] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12170),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(4649),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2857),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1077] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12186),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(4947),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2995),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1078] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10510),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(6721),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(3033),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1079] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10493),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(3404),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(3035),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1080] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__assoc_tyfam] = STATE(10138),
    [sym__assoc_tyinst] = STATE(10139),
    [sym__assoc_datafam] = STATE(10141),
    [sym_default_signature] = STATE(10146),
    [sym_class_decl] = STATE(10736),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10146),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10146),
    [sym__local_decl] = STATE(10146),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_data] = ACTIONS(1935),
    [anon_sym_default] = ACTIONS(1937),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1081] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(8999),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__bracket_close] = STATE(4518),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2887),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1082] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10678),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(7126),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(3037),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1083] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12029),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3039),
    [anon_sym_u27e7] = ACTIONS(3039),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1084] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10472),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(5058),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2969),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1085] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11887),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3041),
    [anon_sym_u27e7] = ACTIONS(3041),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1086] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12186),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(4512),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2819),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1087] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_EQ] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1179),
    [anon_sym_EQ_GT] = ACTIONS(1179),
    [anon_sym_u21d2] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__paren_close_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1088] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11680),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3043),
    [anon_sym_u27e7] = ACTIONS(3043),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1089] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1056),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2280),
    [sym__qconstructor_ticked] = STATE(2280),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2280),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2642),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym_RBRACE] = ACTIONS(3045),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_DASH_GT] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3045),
    [anon_sym_u27e7] = ACTIONS(3045),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(2841),
    [anon_sym_u2192] = ACTIONS(3045),
    [anon_sym_LT_DASH] = ACTIONS(3045),
    [anon_sym_u2190] = ACTIONS(3045),
    [anon_sym_COLON_COLON] = ACTIONS(3045),
    [anon_sym_u2237] = ACTIONS(3045),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(3045),
    [anon_sym_RBRACK] = ACTIONS(3045),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(2845),
    [sym__cond_no_section_op] = ACTIONS(2847),
    [sym__consym] = ACTIONS(2737),
  },
  [1090] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10395),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(7512),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(3047),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1091] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11529),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3049),
    [anon_sym_u27e7] = ACTIONS(3049),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1092] = {
    [sym__type_parens] = STATE(7416),
    [sym__type_tuple] = STATE(7417),
    [sym__type_unboxed_tuple] = STATE(7424),
    [sym__type_unboxed_sum] = STATE(7426),
    [sym__type_list] = STATE(7427),
    [sym__type_promoted] = STATE(7415),
    [sym__type_star] = STATE(7415),
    [sym__type_wildcard] = STATE(7415),
    [sym__at_type] = STATE(7476),
    [sym__type_apply] = STATE(7428),
    [sym__type_infix] = STATE(7240),
    [sym_type] = STATE(983),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8549),
    [sym__splice_dollars] = STATE(7270),
    [sym_splice] = STATE(7415),
    [sym_quasiquote] = STATE(7415),
    [sym_integer] = STATE(7274),
    [sym__plist] = STATE(7429),
    [sym_unit] = STATE(7415),
    [sym_unboxed_unit] = STATE(7415),
    [sym_prefix_tuple] = STATE(7415),
    [sym_prefix_unboxed_tuple] = STATE(7415),
    [sym_prefix_unboxed_sum] = STATE(7415),
    [sym_literal] = STATE(7415),
    [sym__qualified_type] = STATE(7267),
    [sym__qtyconid] = STATE(7438),
    [sym__tycon_arrow] = STATE(7438),
    [sym__qtycon_arrow] = STATE(7438),
    [sym__promoted_tycons_alias] = STATE(7415),
    [sym__promoted_tycons] = STATE(7415),
    [sym__tycon_ticked] = STATE(2664),
    [sym__qtycon_ticked] = STATE(2664),
    [sym__tyconids_ticked] = STATE(2664),
    [sym__promoted_tyconops_alias] = STATE(2664),
    [sym__promoted_tyconops] = STATE(2664),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2664),
    [sym__operator_alias] = STATE(2664),
    [sym__operator_minus] = STATE(2664),
    [sym__varsym_prefix] = STATE(7438),
    [sym__pvarsym] = STATE(7438),
    [sym__qualified_varsym] = STATE(2653),
    [sym__qvarsym_prefix] = STATE(7438),
    [sym__pqvarsym] = STATE(7438),
    [sym_constructor_operator] = STATE(2664),
    [sym__constructor_operator_alias] = STATE(2664),
    [sym__consym_prefix] = STATE(7438),
    [sym__pconsym] = STATE(7438),
    [sym__qualified_consym] = STATE(2645),
    [sym__qconsym_prefix] = STATE(7438),
    [sym__pqconsym] = STATE(7438),
    [sym__prefix_at] = STATE(2602),
    [sym__paren_open] = STATE(474),
    [sym__bracket_open] = STATE(1124),
    [sym__unboxed_open] = STATE(733),
    [sym_variable] = ACTIONS(1177),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(3051),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_u2605] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__paren_close_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__cond_tight_bang] = ACTIONS(1179),
    [sym__cond_prefix_bang] = ACTIONS(1179),
    [sym__cond_tight_tilde] = ACTIONS(1179),
    [sym__cond_prefix_tilde] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1093] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(9071),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__bracket_close] = STATE(4299),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2995),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1094] = {
    [sym__type_parens] = STATE(7416),
    [sym__type_tuple] = STATE(7417),
    [sym__type_unboxed_tuple] = STATE(7424),
    [sym__type_unboxed_sum] = STATE(7426),
    [sym__type_list] = STATE(7427),
    [sym__type_promoted] = STATE(7415),
    [sym__type_star] = STATE(7415),
    [sym__type_wildcard] = STATE(7415),
    [sym__at_type] = STATE(7476),
    [sym__type_apply] = STATE(7428),
    [sym__type_infix] = STATE(7240),
    [sym_type] = STATE(983),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8549),
    [sym__splice_dollars] = STATE(7270),
    [sym_splice] = STATE(7415),
    [sym_quasiquote] = STATE(7415),
    [sym_integer] = STATE(7274),
    [sym__plist] = STATE(7429),
    [sym_unit] = STATE(7415),
    [sym_unboxed_unit] = STATE(7415),
    [sym_prefix_tuple] = STATE(7415),
    [sym_prefix_unboxed_tuple] = STATE(7415),
    [sym_prefix_unboxed_sum] = STATE(7415),
    [sym_literal] = STATE(7415),
    [sym__qualified_type] = STATE(7267),
    [sym__qtyconid] = STATE(7438),
    [sym__tycon_arrow] = STATE(7438),
    [sym__qtycon_arrow] = STATE(7438),
    [sym__promoted_tycons_alias] = STATE(7415),
    [sym__promoted_tycons] = STATE(7415),
    [sym__tycon_ticked] = STATE(2664),
    [sym__qtycon_ticked] = STATE(2664),
    [sym__tyconids_ticked] = STATE(2664),
    [sym__promoted_tyconops_alias] = STATE(2664),
    [sym__promoted_tyconops] = STATE(2664),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2664),
    [sym__operator_alias] = STATE(2664),
    [sym__operator_minus] = STATE(2664),
    [sym__varsym_prefix] = STATE(7438),
    [sym__pvarsym] = STATE(7438),
    [sym__qualified_varsym] = STATE(2653),
    [sym__qvarsym_prefix] = STATE(7438),
    [sym__pqvarsym] = STATE(7438),
    [sym_constructor_operator] = STATE(2664),
    [sym__constructor_operator_alias] = STATE(2664),
    [sym__consym_prefix] = STATE(7438),
    [sym__pconsym] = STATE(7438),
    [sym__qualified_consym] = STATE(2645),
    [sym__qconsym_prefix] = STATE(7438),
    [sym__pqconsym] = STATE(7438),
    [sym__prefix_at] = STATE(2602),
    [sym__paren_open] = STATE(474),
    [sym__bracket_open] = STATE(1124),
    [sym__unboxed_open] = STATE(733),
    [sym_variable] = ACTIONS(3057),
    [anon_sym__] = ACTIONS(3059),
    [anon_sym_SQUOTE] = ACTIONS(3051),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_u2605] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3061),
    [sym_char] = ACTIONS(3061),
    [sym_string] = ACTIONS(3061),
    [sym__integer_literal] = ACTIONS(3063),
    [sym__binary_literal] = ACTIONS(3065),
    [sym__octal_literal] = ACTIONS(3065),
    [sym__hex_literal] = ACTIONS(3065),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(3067),
    [anon_sym_u2192] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1157),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3069),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1157),
    [sym__cond_prefix_bang] = ACTIONS(1157),
    [sym__cond_tight_tilde] = ACTIONS(1157),
    [sym__cond_prefix_tilde] = ACTIONS(1157),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1095] = {
    [sym__type_parens] = STATE(7268),
    [sym__type_tuple] = STATE(7262),
    [sym__type_unboxed_tuple] = STATE(7258),
    [sym__type_unboxed_sum] = STATE(7246),
    [sym__type_list] = STATE(7247),
    [sym__type_promoted] = STATE(7269),
    [sym__type_star] = STATE(7269),
    [sym__type_wildcard] = STATE(7269),
    [sym__at_type] = STATE(7235),
    [sym__type_apply] = STATE(7237),
    [sym__type_infix] = STATE(7207),
    [sym_type] = STATE(1095),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8479),
    [sym__splice_dollars] = STATE(7208),
    [sym_splice] = STATE(7269),
    [sym_quasiquote] = STATE(7269),
    [sym_integer] = STATE(7206),
    [sym__plist] = STATE(7209),
    [sym_unit] = STATE(7269),
    [sym_unboxed_unit] = STATE(7269),
    [sym_prefix_tuple] = STATE(7269),
    [sym_prefix_unboxed_tuple] = STATE(7269),
    [sym_prefix_unboxed_sum] = STATE(7269),
    [sym_literal] = STATE(7269),
    [sym__qualified_type] = STATE(7374),
    [sym__qtyconid] = STATE(7210),
    [sym__tycon_arrow] = STATE(7210),
    [sym__qtycon_arrow] = STATE(7210),
    [sym__promoted_tycons_alias] = STATE(7269),
    [sym__promoted_tycons] = STATE(7269),
    [sym__tycon_ticked] = STATE(2621),
    [sym__qtycon_ticked] = STATE(2621),
    [sym__tyconids_ticked] = STATE(2621),
    [sym__promoted_tyconops_alias] = STATE(2621),
    [sym__promoted_tyconops] = STATE(2621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2621),
    [sym__operator_alias] = STATE(2621),
    [sym__operator_minus] = STATE(2621),
    [sym__varsym_prefix] = STATE(7210),
    [sym__pvarsym] = STATE(7210),
    [sym__qualified_varsym] = STATE(2620),
    [sym__qvarsym_prefix] = STATE(7210),
    [sym__pqvarsym] = STATE(7210),
    [sym_constructor_operator] = STATE(2621),
    [sym__constructor_operator_alias] = STATE(2621),
    [sym__consym_prefix] = STATE(7210),
    [sym__pconsym] = STATE(7210),
    [sym__qualified_consym] = STATE(2619),
    [sym__qconsym_prefix] = STATE(7210),
    [sym__pqconsym] = STATE(7210),
    [sym__prefix_at] = STATE(2554),
    [sym__paren_open] = STATE(448),
    [sym__bracket_open] = STATE(1009),
    [sym__unboxed_open] = STATE(824),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_via] = ACTIONS(1117),
    [anon_sym_deriving] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1119),
    [sym__cond_layout_end] = ACTIONS(1119),
    [sym__cond_layout_end_explicit] = ACTIONS(1119),
    [sym__phantom_deriving] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [1096] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_EQ] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_EQ_GT] = ACTIONS(1119),
    [anon_sym_u21d2] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__paren_close_token1] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [1097] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(10123),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__bracket_close] = STATE(5641),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2969),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1098] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12186),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(5332),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2887),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1099] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12154),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(5595),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2969),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1100] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(11602),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3071),
    [anon_sym_u27e7] = ACTIONS(3071),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1101] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10430),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(3058),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(3073),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1102] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12171),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3075),
    [anon_sym_u27e7] = ACTIONS(3075),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1103] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(12172),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3075),
    [anon_sym_u27e7] = ACTIONS(3075),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1104] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10407),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(6924),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(3077),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1105] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(11481),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3079),
    [anon_sym_u27e7] = ACTIONS(3079),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1106] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11472),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3079),
    [anon_sym_u27e7] = ACTIONS(3079),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1107] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11450),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(4583),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2819),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1108] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(10196),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__bracket_close] = STATE(4584),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2819),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1109] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12186),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(5542),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2969),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1110] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11418),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3081),
    [anon_sym_u27e7] = ACTIONS(3081),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1111] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8328),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__record_fields] = STATE(9999),
    [sym__gadt_con_prefix] = STATE(10522),
    [sym__gadt_con_record] = STATE(10519),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1112] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11607),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3071),
    [anon_sym_u27e7] = ACTIONS(3071),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1113] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10333),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(6957),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(3083),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1114] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8328),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__record_fields] = STATE(9999),
    [sym__gadt_con_prefix] = STATE(10421),
    [sym__gadt_con_record] = STATE(10532),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1115] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11713),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3085),
    [anon_sym_u27e7] = ACTIONS(3085),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1116] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12180),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(5656),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2969),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1117] = {
    [sym__type_parens] = STATE(7268),
    [sym__type_tuple] = STATE(7262),
    [sym__type_unboxed_tuple] = STATE(7258),
    [sym__type_unboxed_sum] = STATE(7246),
    [sym__type_list] = STATE(7247),
    [sym__type_promoted] = STATE(7269),
    [sym__type_star] = STATE(7269),
    [sym__type_wildcard] = STATE(7269),
    [sym__at_type] = STATE(7235),
    [sym__type_apply] = STATE(7237),
    [sym__type_infix] = STATE(7207),
    [sym_type] = STATE(1095),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8479),
    [sym__splice_dollars] = STATE(7208),
    [sym_splice] = STATE(7269),
    [sym_quasiquote] = STATE(7269),
    [sym_integer] = STATE(7206),
    [sym__plist] = STATE(7209),
    [sym_unit] = STATE(7269),
    [sym_unboxed_unit] = STATE(7269),
    [sym_prefix_tuple] = STATE(7269),
    [sym_prefix_unboxed_tuple] = STATE(7269),
    [sym_prefix_unboxed_sum] = STATE(7269),
    [sym_literal] = STATE(7269),
    [sym__qualified_type] = STATE(7374),
    [sym__qtyconid] = STATE(7210),
    [sym__tycon_arrow] = STATE(7210),
    [sym__qtycon_arrow] = STATE(7210),
    [sym__promoted_tycons_alias] = STATE(7269),
    [sym__promoted_tycons] = STATE(7269),
    [sym__tycon_ticked] = STATE(2621),
    [sym__qtycon_ticked] = STATE(2621),
    [sym__tyconids_ticked] = STATE(2621),
    [sym__promoted_tyconops_alias] = STATE(2621),
    [sym__promoted_tyconops] = STATE(2621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2621),
    [sym__operator_alias] = STATE(2621),
    [sym__operator_minus] = STATE(2621),
    [sym__varsym_prefix] = STATE(7210),
    [sym__pvarsym] = STATE(7210),
    [sym__qualified_varsym] = STATE(2620),
    [sym__qvarsym_prefix] = STATE(7210),
    [sym__pqvarsym] = STATE(7210),
    [sym_constructor_operator] = STATE(2621),
    [sym__constructor_operator_alias] = STATE(2621),
    [sym__consym_prefix] = STATE(7210),
    [sym__pconsym] = STATE(7210),
    [sym__qualified_consym] = STATE(2619),
    [sym__qconsym_prefix] = STATE(7210),
    [sym__pqconsym] = STATE(7210),
    [sym__prefix_at] = STATE(2554),
    [sym__paren_open] = STATE(448),
    [sym__bracket_open] = STATE(1009),
    [sym__unboxed_open] = STATE(824),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_via] = ACTIONS(1177),
    [anon_sym_deriving] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym__phantom_deriving] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1118] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11458),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3087),
    [anon_sym_u27e7] = ACTIONS(3087),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1119] = {
    [sym__type_parens] = STATE(7268),
    [sym__type_tuple] = STATE(7262),
    [sym__type_unboxed_tuple] = STATE(7258),
    [sym__type_unboxed_sum] = STATE(7246),
    [sym__type_list] = STATE(7247),
    [sym__type_promoted] = STATE(7269),
    [sym__type_star] = STATE(7269),
    [sym__type_wildcard] = STATE(7269),
    [sym__at_type] = STATE(7235),
    [sym__type_apply] = STATE(7237),
    [sym__type_infix] = STATE(7207),
    [sym_type] = STATE(1095),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8479),
    [sym__splice_dollars] = STATE(7208),
    [sym_splice] = STATE(7269),
    [sym_quasiquote] = STATE(7269),
    [sym_integer] = STATE(7206),
    [sym__plist] = STATE(7209),
    [sym_unit] = STATE(7269),
    [sym_unboxed_unit] = STATE(7269),
    [sym_prefix_tuple] = STATE(7269),
    [sym_prefix_unboxed_tuple] = STATE(7269),
    [sym_prefix_unboxed_sum] = STATE(7269),
    [sym_literal] = STATE(7269),
    [sym__qualified_type] = STATE(7374),
    [sym__qtyconid] = STATE(7210),
    [sym__tycon_arrow] = STATE(7210),
    [sym__qtycon_arrow] = STATE(7210),
    [sym__promoted_tycons_alias] = STATE(7269),
    [sym__promoted_tycons] = STATE(7269),
    [sym__tycon_ticked] = STATE(2621),
    [sym__qtycon_ticked] = STATE(2621),
    [sym__tyconids_ticked] = STATE(2621),
    [sym__promoted_tyconops_alias] = STATE(2621),
    [sym__promoted_tyconops] = STATE(2621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2621),
    [sym__operator_alias] = STATE(2621),
    [sym__operator_minus] = STATE(2621),
    [sym__varsym_prefix] = STATE(7210),
    [sym__pvarsym] = STATE(7210),
    [sym__qualified_varsym] = STATE(2620),
    [sym__qvarsym_prefix] = STATE(7210),
    [sym__pqvarsym] = STATE(7210),
    [sym_constructor_operator] = STATE(2621),
    [sym__constructor_operator_alias] = STATE(2621),
    [sym__consym_prefix] = STATE(7210),
    [sym__pconsym] = STATE(7210),
    [sym__qualified_consym] = STATE(2619),
    [sym__qconsym_prefix] = STATE(7210),
    [sym__pqconsym] = STATE(7210),
    [sym__prefix_at] = STATE(2554),
    [sym__paren_open] = STATE(448),
    [sym__bracket_open] = STATE(1009),
    [sym__unboxed_open] = STATE(824),
    [sym_variable] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(3089),
    [anon_sym__] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(2949),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_u2605] = ACTIONS(2953),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_via] = ACTIONS(3091),
    [anon_sym_deriving] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2955),
    [sym_char] = ACTIONS(2955),
    [sym_string] = ACTIONS(2955),
    [sym__integer_literal] = ACTIONS(2957),
    [sym__binary_literal] = ACTIONS(2959),
    [sym__octal_literal] = ACTIONS(2959),
    [sym__hex_literal] = ACTIONS(2959),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2961),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3089),
    [sym__cond_layout_end] = ACTIONS(3089),
    [sym__cond_layout_end_explicit] = ACTIONS(3089),
    [sym__phantom_deriving] = ACTIONS(3089),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2963),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1120] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10378),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(3194),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(3093),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1121] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11623),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__bracket_close] = STATE(4984),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2995),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1122] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10866),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(4233),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(2819),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1123] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_EQ] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_EQ_GT] = ACTIONS(1179),
    [anon_sym_u21d2] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__paren_close_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [1124] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10608),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(7356),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(3095),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1125] = {
    [sym__type_parens] = STATE(7268),
    [sym__type_tuple] = STATE(7262),
    [sym__type_unboxed_tuple] = STATE(7258),
    [sym__type_unboxed_sum] = STATE(7246),
    [sym__type_list] = STATE(7247),
    [sym__type_promoted] = STATE(7269),
    [sym__type_star] = STATE(7269),
    [sym__type_wildcard] = STATE(7269),
    [sym__at_type] = STATE(7235),
    [sym__type_apply] = STATE(7237),
    [sym__type_infix] = STATE(7207),
    [sym_type] = STATE(1095),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8479),
    [sym__splice_dollars] = STATE(7208),
    [sym_splice] = STATE(7269),
    [sym_quasiquote] = STATE(7269),
    [sym_integer] = STATE(7206),
    [sym__plist] = STATE(7209),
    [sym_unit] = STATE(7269),
    [sym_unboxed_unit] = STATE(7269),
    [sym_prefix_tuple] = STATE(7269),
    [sym_prefix_unboxed_tuple] = STATE(7269),
    [sym_prefix_unboxed_sum] = STATE(7269),
    [sym_literal] = STATE(7269),
    [sym__qualified_type] = STATE(7374),
    [sym__qtyconid] = STATE(7210),
    [sym__tycon_arrow] = STATE(7210),
    [sym__qtycon_arrow] = STATE(7210),
    [sym__promoted_tycons_alias] = STATE(7269),
    [sym__promoted_tycons] = STATE(7269),
    [sym__tycon_ticked] = STATE(2621),
    [sym__qtycon_ticked] = STATE(2621),
    [sym__tyconids_ticked] = STATE(2621),
    [sym__promoted_tyconops_alias] = STATE(2621),
    [sym__promoted_tyconops] = STATE(2621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2621),
    [sym__operator_alias] = STATE(2621),
    [sym__operator_minus] = STATE(2621),
    [sym__varsym_prefix] = STATE(7210),
    [sym__pvarsym] = STATE(7210),
    [sym__qualified_varsym] = STATE(2620),
    [sym__qvarsym_prefix] = STATE(7210),
    [sym__pqvarsym] = STATE(7210),
    [sym_constructor_operator] = STATE(2621),
    [sym__constructor_operator_alias] = STATE(2621),
    [sym__consym_prefix] = STATE(7210),
    [sym__pconsym] = STATE(7210),
    [sym__qualified_consym] = STATE(2619),
    [sym__qconsym_prefix] = STATE(7210),
    [sym__pqconsym] = STATE(7210),
    [sym__prefix_at] = STATE(2554),
    [sym__paren_open] = STATE(448),
    [sym__bracket_open] = STATE(1009),
    [sym__unboxed_open] = STATE(824),
    [sym_variable] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(3089),
    [anon_sym__] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(2949),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_u2605] = ACTIONS(2953),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_via] = ACTIONS(3091),
    [anon_sym_deriving] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2955),
    [sym_char] = ACTIONS(2955),
    [sym_string] = ACTIONS(2955),
    [sym__integer_literal] = ACTIONS(2957),
    [sym__binary_literal] = ACTIONS(2959),
    [sym__octal_literal] = ACTIONS(2959),
    [sym__hex_literal] = ACTIONS(2959),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2961),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3089),
    [sym__cond_layout_end] = ACTIONS(3089),
    [sym__cond_layout_end_explicit] = ACTIONS(3089),
    [sym__phantom_deriving] = ACTIONS(3089),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2963),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1126] = {
    [sym__type_parens] = STATE(7268),
    [sym__type_tuple] = STATE(7262),
    [sym__type_unboxed_tuple] = STATE(7258),
    [sym__type_unboxed_sum] = STATE(7246),
    [sym__type_list] = STATE(7247),
    [sym__type_promoted] = STATE(7269),
    [sym__type_star] = STATE(7269),
    [sym__type_wildcard] = STATE(7269),
    [sym__at_type] = STATE(7235),
    [sym__type_apply] = STATE(7237),
    [sym__type_infix] = STATE(7207),
    [sym_type] = STATE(1095),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8479),
    [sym__splice_dollars] = STATE(7208),
    [sym_splice] = STATE(7269),
    [sym_quasiquote] = STATE(7269),
    [sym_integer] = STATE(7206),
    [sym__plist] = STATE(7209),
    [sym_unit] = STATE(7269),
    [sym_unboxed_unit] = STATE(7269),
    [sym_prefix_tuple] = STATE(7269),
    [sym_prefix_unboxed_tuple] = STATE(7269),
    [sym_prefix_unboxed_sum] = STATE(7269),
    [sym_literal] = STATE(7269),
    [sym__qualified_type] = STATE(7374),
    [sym__qtyconid] = STATE(7210),
    [sym__tycon_arrow] = STATE(7210),
    [sym__qtycon_arrow] = STATE(7210),
    [sym__promoted_tycons_alias] = STATE(7269),
    [sym__promoted_tycons] = STATE(7269),
    [sym__tycon_ticked] = STATE(2621),
    [sym__qtycon_ticked] = STATE(2621),
    [sym__tyconids_ticked] = STATE(2621),
    [sym__promoted_tyconops_alias] = STATE(2621),
    [sym__promoted_tyconops] = STATE(2621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2621),
    [sym__operator_alias] = STATE(2621),
    [sym__operator_minus] = STATE(2621),
    [sym__varsym_prefix] = STATE(7210),
    [sym__pvarsym] = STATE(7210),
    [sym__qualified_varsym] = STATE(2620),
    [sym__qvarsym_prefix] = STATE(7210),
    [sym__pqvarsym] = STATE(7210),
    [sym_constructor_operator] = STATE(2621),
    [sym__constructor_operator_alias] = STATE(2621),
    [sym__consym_prefix] = STATE(7210),
    [sym__pconsym] = STATE(7210),
    [sym__qualified_consym] = STATE(2619),
    [sym__qconsym_prefix] = STATE(7210),
    [sym__pqconsym] = STATE(7210),
    [sym__prefix_at] = STATE(2554),
    [sym__paren_open] = STATE(448),
    [sym__bracket_open] = STATE(1009),
    [sym__unboxed_open] = STATE(824),
    [sym_variable] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(3097),
    [anon_sym__] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(2949),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_u2605] = ACTIONS(2953),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_via] = ACTIONS(3099),
    [anon_sym_deriving] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2955),
    [sym_char] = ACTIONS(2955),
    [sym_string] = ACTIONS(2955),
    [sym__integer_literal] = ACTIONS(2957),
    [sym__binary_literal] = ACTIONS(2959),
    [sym__octal_literal] = ACTIONS(2959),
    [sym__hex_literal] = ACTIONS(2959),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2961),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3097),
    [sym__cond_layout_end] = ACTIONS(3097),
    [sym__cond_layout_end_explicit] = ACTIONS(3097),
    [sym__phantom_deriving] = ACTIONS(3097),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2963),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1127] = {
    [sym__type_parens] = STATE(7416),
    [sym__type_tuple] = STATE(7417),
    [sym__type_unboxed_tuple] = STATE(7424),
    [sym__type_unboxed_sum] = STATE(7426),
    [sym__type_list] = STATE(7427),
    [sym__type_promoted] = STATE(7415),
    [sym__type_star] = STATE(7415),
    [sym__type_wildcard] = STATE(7415),
    [sym__at_type] = STATE(7476),
    [sym__type_apply] = STATE(7428),
    [sym__type_infix] = STATE(7240),
    [sym_type] = STATE(983),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8549),
    [sym__splice_dollars] = STATE(7270),
    [sym_splice] = STATE(7415),
    [sym_quasiquote] = STATE(7415),
    [sym_integer] = STATE(7274),
    [sym__plist] = STATE(7429),
    [sym_unit] = STATE(7415),
    [sym_unboxed_unit] = STATE(7415),
    [sym_prefix_tuple] = STATE(7415),
    [sym_prefix_unboxed_tuple] = STATE(7415),
    [sym_prefix_unboxed_sum] = STATE(7415),
    [sym_literal] = STATE(7415),
    [sym__qualified_type] = STATE(7267),
    [sym__qtyconid] = STATE(7438),
    [sym__tycon_arrow] = STATE(7438),
    [sym__qtycon_arrow] = STATE(7438),
    [sym__promoted_tycons_alias] = STATE(7415),
    [sym__promoted_tycons] = STATE(7415),
    [sym__tycon_ticked] = STATE(2664),
    [sym__qtycon_ticked] = STATE(2664),
    [sym__tyconids_ticked] = STATE(2664),
    [sym__promoted_tyconops_alias] = STATE(2664),
    [sym__promoted_tyconops] = STATE(2664),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2664),
    [sym__operator_alias] = STATE(2664),
    [sym__operator_minus] = STATE(2664),
    [sym__varsym_prefix] = STATE(7438),
    [sym__pvarsym] = STATE(7438),
    [sym__qualified_varsym] = STATE(2653),
    [sym__qvarsym_prefix] = STATE(7438),
    [sym__pqvarsym] = STATE(7438),
    [sym_constructor_operator] = STATE(2664),
    [sym__constructor_operator_alias] = STATE(2664),
    [sym__consym_prefix] = STATE(7438),
    [sym__pconsym] = STATE(7438),
    [sym__qualified_consym] = STATE(2645),
    [sym__qconsym_prefix] = STATE(7438),
    [sym__pqconsym] = STATE(7438),
    [sym__prefix_at] = STATE(2602),
    [sym__paren_open] = STATE(474),
    [sym__bracket_open] = STATE(1124),
    [sym__unboxed_open] = STATE(733),
    [sym_variable] = ACTIONS(3057),
    [anon_sym__] = ACTIONS(3059),
    [anon_sym_SQUOTE] = ACTIONS(3051),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_u2605] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3061),
    [sym_char] = ACTIONS(3061),
    [sym_string] = ACTIONS(3061),
    [sym__integer_literal] = ACTIONS(3063),
    [sym__binary_literal] = ACTIONS(3065),
    [sym__octal_literal] = ACTIONS(3065),
    [sym__hex_literal] = ACTIONS(3065),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(3067),
    [anon_sym_u2192] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3069),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1181),
    [sym__cond_prefix_bang] = ACTIONS(1181),
    [sym__cond_tight_tilde] = ACTIONS(1181),
    [sym__cond_prefix_tilde] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1128] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(181),
    [sym__exp_signature] = STATE(9588),
    [sym__exp] = STATE(10244),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__bracket_close] = STATE(4985),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(2995),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1129] = {
    [sym__type_parens] = STATE(7416),
    [sym__type_tuple] = STATE(7417),
    [sym__type_unboxed_tuple] = STATE(7424),
    [sym__type_unboxed_sum] = STATE(7426),
    [sym__type_list] = STATE(7427),
    [sym__type_promoted] = STATE(7415),
    [sym__type_star] = STATE(7415),
    [sym__type_wildcard] = STATE(7415),
    [sym__at_type] = STATE(7476),
    [sym__type_apply] = STATE(7428),
    [sym__type_infix] = STATE(7240),
    [sym_type] = STATE(983),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8549),
    [sym__splice_dollars] = STATE(7270),
    [sym_splice] = STATE(7415),
    [sym_quasiquote] = STATE(7415),
    [sym_integer] = STATE(7274),
    [sym__plist] = STATE(7429),
    [sym_unit] = STATE(7415),
    [sym_unboxed_unit] = STATE(7415),
    [sym_prefix_tuple] = STATE(7415),
    [sym_prefix_unboxed_tuple] = STATE(7415),
    [sym_prefix_unboxed_sum] = STATE(7415),
    [sym_literal] = STATE(7415),
    [sym__qualified_type] = STATE(7267),
    [sym__qtyconid] = STATE(7438),
    [sym__tycon_arrow] = STATE(7438),
    [sym__qtycon_arrow] = STATE(7438),
    [sym__promoted_tycons_alias] = STATE(7415),
    [sym__promoted_tycons] = STATE(7415),
    [sym__tycon_ticked] = STATE(2664),
    [sym__qtycon_ticked] = STATE(2664),
    [sym__tyconids_ticked] = STATE(2664),
    [sym__promoted_tyconops_alias] = STATE(2664),
    [sym__promoted_tyconops] = STATE(2664),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2664),
    [sym__operator_alias] = STATE(2664),
    [sym__operator_minus] = STATE(2664),
    [sym__varsym_prefix] = STATE(7438),
    [sym__pvarsym] = STATE(7438),
    [sym__qualified_varsym] = STATE(2653),
    [sym__qvarsym_prefix] = STATE(7438),
    [sym__pqvarsym] = STATE(7438),
    [sym_constructor_operator] = STATE(2664),
    [sym__constructor_operator_alias] = STATE(2664),
    [sym__consym_prefix] = STATE(7438),
    [sym__pconsym] = STATE(7438),
    [sym__qualified_consym] = STATE(2645),
    [sym__qconsym_prefix] = STATE(7438),
    [sym__pqconsym] = STATE(7438),
    [sym__prefix_at] = STATE(2602),
    [sym__paren_open] = STATE(474),
    [sym__bracket_open] = STATE(1124),
    [sym__unboxed_open] = STATE(733),
    [sym_variable] = ACTIONS(3057),
    [anon_sym__] = ACTIONS(3059),
    [anon_sym_SQUOTE] = ACTIONS(3051),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_u2605] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3061),
    [sym_char] = ACTIONS(3061),
    [sym_string] = ACTIONS(3061),
    [sym__integer_literal] = ACTIONS(3063),
    [sym__binary_literal] = ACTIONS(3065),
    [sym__octal_literal] = ACTIONS(3065),
    [sym__hex_literal] = ACTIONS(3065),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(3067),
    [anon_sym_u2192] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3069),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(1181),
    [sym__cond_prefix_bang] = ACTIONS(1181),
    [sym__cond_tight_tilde] = ACTIONS(1181),
    [sym__cond_prefix_tilde] = ACTIONS(1181),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1130] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10361),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(2792),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(3101),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1131] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10347),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__bracket_close] = STATE(3668),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_RBRACK] = ACTIONS(3103),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1132] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(350),
    [sym__exp_signature] = STATE(12805),
    [sym__exp] = STATE(12385),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(3105),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1133] = {
    [sym__type_parens] = STATE(7505),
    [sym__type_tuple] = STATE(7503),
    [sym__type_unboxed_tuple] = STATE(7497),
    [sym__type_unboxed_sum] = STATE(7492),
    [sym__type_list] = STATE(7528),
    [sym__type_promoted] = STATE(7491),
    [sym__type_star] = STATE(7491),
    [sym__type_wildcard] = STATE(7491),
    [sym__at_type] = STATE(7554),
    [sym__type_apply] = STATE(7550),
    [sym__type_infix] = STATE(7534),
    [sym_type] = STATE(1166),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8491),
    [sym__splice_dollars] = STATE(7345),
    [sym_splice] = STATE(7491),
    [sym_quasiquote] = STATE(7491),
    [sym_integer] = STATE(7542),
    [sym__plist] = STATE(7518),
    [sym_unit] = STATE(7491),
    [sym_unboxed_unit] = STATE(7491),
    [sym_prefix_tuple] = STATE(7491),
    [sym_prefix_unboxed_tuple] = STATE(7491),
    [sym_prefix_unboxed_sum] = STATE(7491),
    [sym_literal] = STATE(7491),
    [sym__qualified_type] = STATE(7541),
    [sym__qtyconid] = STATE(7511),
    [sym__tycon_arrow] = STATE(7511),
    [sym__qtycon_arrow] = STATE(7511),
    [sym__promoted_tycons_alias] = STATE(7491),
    [sym__promoted_tycons] = STATE(7491),
    [sym__tycon_ticked] = STATE(2484),
    [sym__qtycon_ticked] = STATE(2484),
    [sym__tyconids_ticked] = STATE(2484),
    [sym__promoted_tyconops_alias] = STATE(2484),
    [sym__promoted_tyconops] = STATE(2484),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2484),
    [sym__operator_alias] = STATE(2484),
    [sym__operator_minus] = STATE(2484),
    [sym__varsym_prefix] = STATE(7511),
    [sym__pvarsym] = STATE(7511),
    [sym__qualified_varsym] = STATE(2485),
    [sym__qvarsym_prefix] = STATE(7511),
    [sym__pqvarsym] = STATE(7511),
    [sym_constructor_operator] = STATE(2484),
    [sym__constructor_operator_alias] = STATE(2484),
    [sym__consym_prefix] = STATE(7511),
    [sym__pconsym] = STATE(7511),
    [sym__qualified_consym] = STATE(2502),
    [sym__qconsym_prefix] = STATE(7511),
    [sym__pqconsym] = STATE(7511),
    [sym__prefix_at] = STATE(2561),
    [sym__paren_open] = STATE(455),
    [sym__bracket_open] = STATE(1090),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(3109),
    [anon_sym_SQUOTE] = ACTIONS(3111),
    [anon_sym_STAR] = ACTIONS(3113),
    [anon_sym_u2605] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3117),
    [sym_char] = ACTIONS(3117),
    [sym_string] = ACTIONS(3117),
    [sym__integer_literal] = ACTIONS(3119),
    [sym__binary_literal] = ACTIONS(3121),
    [sym__octal_literal] = ACTIONS(3121),
    [sym__hex_literal] = ACTIONS(3121),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(3123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_where] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3125),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1134] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11015),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cmd_layout_start_if] = ACTIONS(3127),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1135] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10754),
    [sym__assoc_tyinst] = STATE(10389),
    [sym__assoc_datainst_adt] = STATE(10386),
    [sym__assoc_datainst_newtype] = STATE(10381),
    [sym__assoc_datainst] = STATE(10379),
    [sym_instance_decl] = STATE(10756),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10379),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_newtype] = ACTIONS(2911),
    [anon_sym_data] = ACTIONS(2913),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3129),
    [sym__cond_layout_end_explicit] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1136] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(350),
    [sym__exp_signature] = STATE(12805),
    [sym__exp] = STATE(12248),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(3131),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1137] = {
    [sym__type_parens] = STATE(7505),
    [sym__type_tuple] = STATE(7503),
    [sym__type_unboxed_tuple] = STATE(7497),
    [sym__type_unboxed_sum] = STATE(7492),
    [sym__type_list] = STATE(7528),
    [sym__type_promoted] = STATE(7491),
    [sym__type_star] = STATE(7491),
    [sym__type_wildcard] = STATE(7491),
    [sym__at_type] = STATE(7554),
    [sym__type_apply] = STATE(7550),
    [sym__type_infix] = STATE(7534),
    [sym_type] = STATE(1166),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8491),
    [sym__splice_dollars] = STATE(7345),
    [sym_splice] = STATE(7491),
    [sym_quasiquote] = STATE(7491),
    [sym_integer] = STATE(7542),
    [sym__plist] = STATE(7518),
    [sym_unit] = STATE(7491),
    [sym_unboxed_unit] = STATE(7491),
    [sym_prefix_tuple] = STATE(7491),
    [sym_prefix_unboxed_tuple] = STATE(7491),
    [sym_prefix_unboxed_sum] = STATE(7491),
    [sym_literal] = STATE(7491),
    [sym__qualified_type] = STATE(7541),
    [sym__qtyconid] = STATE(7511),
    [sym__tycon_arrow] = STATE(7511),
    [sym__qtycon_arrow] = STATE(7511),
    [sym__promoted_tycons_alias] = STATE(7491),
    [sym__promoted_tycons] = STATE(7491),
    [sym__tycon_ticked] = STATE(2484),
    [sym__qtycon_ticked] = STATE(2484),
    [sym__tyconids_ticked] = STATE(2484),
    [sym__promoted_tyconops_alias] = STATE(2484),
    [sym__promoted_tyconops] = STATE(2484),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2484),
    [sym__operator_alias] = STATE(2484),
    [sym__operator_minus] = STATE(2484),
    [sym__varsym_prefix] = STATE(7511),
    [sym__pvarsym] = STATE(7511),
    [sym__qualified_varsym] = STATE(2485),
    [sym__qvarsym_prefix] = STATE(7511),
    [sym__pqvarsym] = STATE(7511),
    [sym_constructor_operator] = STATE(2484),
    [sym__constructor_operator_alias] = STATE(2484),
    [sym__consym_prefix] = STATE(7511),
    [sym__pconsym] = STATE(7511),
    [sym__qualified_consym] = STATE(2502),
    [sym__qconsym_prefix] = STATE(7511),
    [sym__pqconsym] = STATE(7511),
    [sym__prefix_at] = STATE(2561),
    [sym__paren_open] = STATE(455),
    [sym__bracket_open] = STATE(1090),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = ACTIONS(2599),
    [anon_sym_SEMI] = ACTIONS(2601),
    [anon_sym__] = ACTIONS(2599),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [anon_sym_STAR] = ACTIONS(2601),
    [anon_sym_u2605] = ACTIONS(2601),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(2601),
    [sym_float] = ACTIONS(2601),
    [sym_char] = ACTIONS(2601),
    [sym_string] = ACTIONS(2601),
    [sym__integer_literal] = ACTIONS(2599),
    [sym__binary_literal] = ACTIONS(2601),
    [sym__octal_literal] = ACTIONS(2601),
    [sym__hex_literal] = ACTIONS(2601),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2601),
    [aux_sym__paren_open_token1] = ACTIONS(2601),
    [anon_sym_where] = ACTIONS(2599),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(2601),
    [sym__cond_layout_end] = ACTIONS(2601),
    [sym__cond_layout_end_explicit] = ACTIONS(2601),
    [sym__phantom_where] = ACTIONS(2601),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2601),
    [sym__cond_splice] = ACTIONS(2601),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(2601),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1138] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(350),
    [sym__exp_signature] = STATE(12805),
    [sym__exp] = STATE(12464),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(3133),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1139] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(350),
    [sym__exp_signature] = STATE(12805),
    [sym__exp] = STATE(12244),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(3135),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1140] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(350),
    [sym__exp_signature] = STATE(12805),
    [sym__exp] = STATE(12531),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(3137),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1141] = {
    [sym__type_parens] = STATE(7505),
    [sym__type_tuple] = STATE(7503),
    [sym__type_unboxed_tuple] = STATE(7497),
    [sym__type_unboxed_sum] = STATE(7492),
    [sym__type_list] = STATE(7528),
    [sym__type_promoted] = STATE(7491),
    [sym__type_star] = STATE(7491),
    [sym__type_wildcard] = STATE(7491),
    [sym__at_type] = STATE(7554),
    [sym__type_apply] = STATE(7550),
    [sym__type_infix] = STATE(7534),
    [sym_type] = STATE(1166),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8491),
    [sym__splice_dollars] = STATE(7345),
    [sym_splice] = STATE(7491),
    [sym_quasiquote] = STATE(7491),
    [sym_integer] = STATE(7542),
    [sym__plist] = STATE(7518),
    [sym_unit] = STATE(7491),
    [sym_unboxed_unit] = STATE(7491),
    [sym_prefix_tuple] = STATE(7491),
    [sym_prefix_unboxed_tuple] = STATE(7491),
    [sym_prefix_unboxed_sum] = STATE(7491),
    [sym_literal] = STATE(7491),
    [sym__qualified_type] = STATE(7541),
    [sym__qtyconid] = STATE(7511),
    [sym__tycon_arrow] = STATE(7511),
    [sym__qtycon_arrow] = STATE(7511),
    [sym__promoted_tycons_alias] = STATE(7491),
    [sym__promoted_tycons] = STATE(7491),
    [sym__tycon_ticked] = STATE(2484),
    [sym__qtycon_ticked] = STATE(2484),
    [sym__tyconids_ticked] = STATE(2484),
    [sym__promoted_tyconops_alias] = STATE(2484),
    [sym__promoted_tyconops] = STATE(2484),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2484),
    [sym__operator_alias] = STATE(2484),
    [sym__operator_minus] = STATE(2484),
    [sym__varsym_prefix] = STATE(7511),
    [sym__pvarsym] = STATE(7511),
    [sym__qualified_varsym] = STATE(2485),
    [sym__qvarsym_prefix] = STATE(7511),
    [sym__pqvarsym] = STATE(7511),
    [sym_constructor_operator] = STATE(2484),
    [sym__constructor_operator_alias] = STATE(2484),
    [sym__consym_prefix] = STATE(7511),
    [sym__pconsym] = STATE(7511),
    [sym__qualified_consym] = STATE(2502),
    [sym__qconsym_prefix] = STATE(7511),
    [sym__pqconsym] = STATE(7511),
    [sym__prefix_at] = STATE(2561),
    [sym__paren_open] = STATE(455),
    [sym__bracket_open] = STATE(1090),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(3109),
    [anon_sym_SQUOTE] = ACTIONS(3111),
    [anon_sym_STAR] = ACTIONS(3113),
    [anon_sym_u2605] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3117),
    [sym_char] = ACTIONS(3117),
    [sym_string] = ACTIONS(3117),
    [sym__integer_literal] = ACTIONS(3119),
    [sym__binary_literal] = ACTIONS(3121),
    [sym__octal_literal] = ACTIONS(3121),
    [sym__hex_literal] = ACTIONS(3121),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(3123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym__phantom_where] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3125),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1142] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10932),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cmd_layout_start_if] = ACTIONS(3139),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1143] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10453),
    [sym__assoc_tyinst] = STATE(10389),
    [sym__assoc_datainst_adt] = STATE(10386),
    [sym__assoc_datainst_newtype] = STATE(10381),
    [sym__assoc_datainst] = STATE(10379),
    [sym_instance_decl] = STATE(10756),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10379),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_newtype] = ACTIONS(2911),
    [anon_sym_data] = ACTIONS(2913),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3141),
    [sym__cond_layout_end_explicit] = ACTIONS(3141),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1144] = {
    [sym__type_parens] = STATE(7505),
    [sym__type_tuple] = STATE(7503),
    [sym__type_unboxed_tuple] = STATE(7497),
    [sym__type_unboxed_sum] = STATE(7492),
    [sym__type_list] = STATE(7528),
    [sym__type_promoted] = STATE(7491),
    [sym__type_star] = STATE(7491),
    [sym__type_wildcard] = STATE(7491),
    [sym__at_type] = STATE(7554),
    [sym__type_apply] = STATE(7550),
    [sym__type_infix] = STATE(7534),
    [sym_type] = STATE(1166),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8491),
    [sym__splice_dollars] = STATE(7345),
    [sym_splice] = STATE(7491),
    [sym_quasiquote] = STATE(7491),
    [sym_integer] = STATE(7542),
    [sym__plist] = STATE(7518),
    [sym_unit] = STATE(7491),
    [sym_unboxed_unit] = STATE(7491),
    [sym_prefix_tuple] = STATE(7491),
    [sym_prefix_unboxed_tuple] = STATE(7491),
    [sym_prefix_unboxed_sum] = STATE(7491),
    [sym_literal] = STATE(7491),
    [sym__qualified_type] = STATE(7541),
    [sym__qtyconid] = STATE(7511),
    [sym__tycon_arrow] = STATE(7511),
    [sym__qtycon_arrow] = STATE(7511),
    [sym__promoted_tycons_alias] = STATE(7491),
    [sym__promoted_tycons] = STATE(7491),
    [sym__tycon_ticked] = STATE(2484),
    [sym__qtycon_ticked] = STATE(2484),
    [sym__tyconids_ticked] = STATE(2484),
    [sym__promoted_tyconops_alias] = STATE(2484),
    [sym__promoted_tyconops] = STATE(2484),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2484),
    [sym__operator_alias] = STATE(2484),
    [sym__operator_minus] = STATE(2484),
    [sym__varsym_prefix] = STATE(7511),
    [sym__pvarsym] = STATE(7511),
    [sym__qualified_varsym] = STATE(2485),
    [sym__qvarsym_prefix] = STATE(7511),
    [sym__pqvarsym] = STATE(7511),
    [sym_constructor_operator] = STATE(2484),
    [sym__constructor_operator_alias] = STATE(2484),
    [sym__consym_prefix] = STATE(7511),
    [sym__pconsym] = STATE(7511),
    [sym__qualified_consym] = STATE(2502),
    [sym__qconsym_prefix] = STATE(7511),
    [sym__pqconsym] = STATE(7511),
    [sym__prefix_at] = STATE(2561),
    [sym__paren_open] = STATE(455),
    [sym__bracket_open] = STATE(1090),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(1177),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym__phantom_where] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [1145] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10904),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cmd_layout_start_if] = ACTIONS(3143),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1146] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8301),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(7769),
    [sym_variable] = ACTIONS(1989),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(3145),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [anon_sym_PIPE2] = ACTIONS(3147),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1147] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10907),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cmd_layout_start_if] = ACTIONS(3149),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1148] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(350),
    [sym__exp_signature] = STATE(12805),
    [sym__exp] = STATE(12548),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(3151),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1149] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(350),
    [sym__exp_signature] = STATE(12805),
    [sym__exp] = STATE(12435),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(3153),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1150] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(3097),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [anon_sym_EQ_GT] = ACTIONS(3097),
    [anon_sym_u21d2] = ACTIONS(3097),
    [anon_sym_COLON_COLON] = ACTIONS(3097),
    [anon_sym_u2237] = ACTIONS(3097),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(3097),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1151] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(3089),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [anon_sym_EQ_GT] = ACTIONS(3089),
    [anon_sym_u21d2] = ACTIONS(3089),
    [anon_sym_COLON_COLON] = ACTIONS(3089),
    [anon_sym_u2237] = ACTIONS(3089),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(3089),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1152] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(3089),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [anon_sym_EQ_GT] = ACTIONS(3089),
    [anon_sym_u21d2] = ACTIONS(3089),
    [anon_sym_COLON_COLON] = ACTIONS(3089),
    [anon_sym_u2237] = ACTIONS(3089),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(3089),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1153] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(350),
    [sym__exp_signature] = STATE(12805),
    [sym__exp] = STATE(12488),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(3155),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1154] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(350),
    [sym__exp_signature] = STATE(12805),
    [sym__exp] = STATE(12743),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(3157),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1155] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10909),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cmd_layout_start_if] = ACTIONS(3159),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1156] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(350),
    [sym__exp_signature] = STATE(12805),
    [sym__exp] = STATE(12322),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(3161),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1157] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(350),
    [sym__exp_signature] = STATE(12805),
    [sym__exp] = STATE(12786),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(3163),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1158] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(3001),
    [anon_sym_COMMA] = ACTIONS(3003),
    [anon_sym__] = ACTIONS(3001),
    [anon_sym_SQUOTE] = ACTIONS(3001),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_u2605] = ACTIONS(3003),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [sym_float] = ACTIONS(3003),
    [sym_char] = ACTIONS(3003),
    [sym_string] = ACTIONS(3003),
    [sym__integer_literal] = ACTIONS(3001),
    [sym__binary_literal] = ACTIONS(3003),
    [sym__octal_literal] = ACTIONS(3003),
    [sym__hex_literal] = ACTIONS(3003),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(3003),
    [anon_sym_EQ_GT] = ACTIONS(3003),
    [anon_sym_u21d2] = ACTIONS(3003),
    [anon_sym_COLON_COLON] = ACTIONS(3003),
    [anon_sym_u2237] = ACTIONS(3003),
    [aux_sym__paren_open_token1] = ACTIONS(3003),
    [aux_sym__paren_close_token1] = ACTIONS(3003),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3003),
    [sym__cond_splice] = ACTIONS(3003),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(3003),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1159] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(350),
    [sym__exp_signature] = STATE(12805),
    [sym__exp] = STATE(12594),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(3165),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1160] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10912),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cmd_layout_start_if] = ACTIONS(3167),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1161] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(350),
    [sym__exp_signature] = STATE(12805),
    [sym__exp] = STATE(12490),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(3169),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1162] = {
    [sym__type_parens] = STATE(7268),
    [sym__type_tuple] = STATE(7262),
    [sym__type_unboxed_tuple] = STATE(7258),
    [sym__type_unboxed_sum] = STATE(7246),
    [sym__type_list] = STATE(7247),
    [sym__type_promoted] = STATE(7269),
    [sym__type_star] = STATE(7269),
    [sym__type_wildcard] = STATE(7269),
    [sym__at_type] = STATE(7235),
    [sym__type_apply] = STATE(7237),
    [sym__type_infix] = STATE(7207),
    [sym_type] = STATE(1095),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8479),
    [sym__splice_dollars] = STATE(7208),
    [sym_splice] = STATE(7269),
    [sym_quasiquote] = STATE(7269),
    [sym_integer] = STATE(7206),
    [sym__plist] = STATE(7209),
    [sym_unit] = STATE(7269),
    [sym_unboxed_unit] = STATE(7269),
    [sym_prefix_tuple] = STATE(7269),
    [sym_prefix_unboxed_tuple] = STATE(7269),
    [sym_prefix_unboxed_sum] = STATE(7269),
    [sym_literal] = STATE(7269),
    [sym__qualified_type] = STATE(7374),
    [sym__qtyconid] = STATE(7210),
    [sym__tycon_arrow] = STATE(7210),
    [sym__qtycon_arrow] = STATE(7210),
    [sym__promoted_tycons_alias] = STATE(7269),
    [sym__promoted_tycons] = STATE(7269),
    [sym__tycon_ticked] = STATE(2621),
    [sym__qtycon_ticked] = STATE(2621),
    [sym__tyconids_ticked] = STATE(2621),
    [sym__promoted_tyconops_alias] = STATE(2621),
    [sym__promoted_tyconops] = STATE(2621),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2621),
    [sym__operator_alias] = STATE(2621),
    [sym__operator_minus] = STATE(2621),
    [sym__varsym_prefix] = STATE(7210),
    [sym__pvarsym] = STATE(7210),
    [sym__qualified_varsym] = STATE(2620),
    [sym__qvarsym_prefix] = STATE(7210),
    [sym__pqvarsym] = STATE(7210),
    [sym_constructor_operator] = STATE(2621),
    [sym__constructor_operator_alias] = STATE(2621),
    [sym__consym_prefix] = STATE(7210),
    [sym__pconsym] = STATE(7210),
    [sym__qualified_consym] = STATE(2619),
    [sym__qconsym_prefix] = STATE(7210),
    [sym__pqconsym] = STATE(7210),
    [sym__prefix_at] = STATE(2554),
    [sym__paren_open] = STATE(448),
    [sym__bracket_open] = STATE(1009),
    [sym__unboxed_open] = STATE(824),
    [sym_variable] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(3171),
    [anon_sym__] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(2949),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_u2605] = ACTIONS(2953),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_deriving] = ACTIONS(3173),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2955),
    [sym_char] = ACTIONS(2955),
    [sym_string] = ACTIONS(2955),
    [sym__integer_literal] = ACTIONS(2957),
    [sym__binary_literal] = ACTIONS(2959),
    [sym__octal_literal] = ACTIONS(2959),
    [sym__hex_literal] = ACTIONS(2959),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2961),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3171),
    [sym__cond_layout_end] = ACTIONS(3171),
    [sym__cond_layout_end_explicit] = ACTIONS(3171),
    [sym__phantom_deriving] = ACTIONS(3171),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2963),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1163] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(350),
    [sym__exp_signature] = STATE(12805),
    [sym__exp] = STATE(12630),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(3175),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1164] = {
    [sym__type_parens] = STATE(7505),
    [sym__type_tuple] = STATE(7503),
    [sym__type_unboxed_tuple] = STATE(7497),
    [sym__type_unboxed_sum] = STATE(7492),
    [sym__type_list] = STATE(7528),
    [sym__type_promoted] = STATE(7491),
    [sym__type_star] = STATE(7491),
    [sym__type_wildcard] = STATE(7491),
    [sym__at_type] = STATE(7554),
    [sym__type_apply] = STATE(7550),
    [sym__type_infix] = STATE(7534),
    [sym_type] = STATE(1166),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8491),
    [sym__splice_dollars] = STATE(7345),
    [sym_splice] = STATE(7491),
    [sym_quasiquote] = STATE(7491),
    [sym_integer] = STATE(7542),
    [sym__plist] = STATE(7518),
    [sym_unit] = STATE(7491),
    [sym_unboxed_unit] = STATE(7491),
    [sym_prefix_tuple] = STATE(7491),
    [sym_prefix_unboxed_tuple] = STATE(7491),
    [sym_prefix_unboxed_sum] = STATE(7491),
    [sym_literal] = STATE(7491),
    [sym__qualified_type] = STATE(7541),
    [sym__qtyconid] = STATE(7511),
    [sym__tycon_arrow] = STATE(7511),
    [sym__qtycon_arrow] = STATE(7511),
    [sym__promoted_tycons_alias] = STATE(7491),
    [sym__promoted_tycons] = STATE(7491),
    [sym__tycon_ticked] = STATE(2484),
    [sym__qtycon_ticked] = STATE(2484),
    [sym__tyconids_ticked] = STATE(2484),
    [sym__promoted_tyconops_alias] = STATE(2484),
    [sym__promoted_tyconops] = STATE(2484),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2484),
    [sym__operator_alias] = STATE(2484),
    [sym__operator_minus] = STATE(2484),
    [sym__varsym_prefix] = STATE(7511),
    [sym__pvarsym] = STATE(7511),
    [sym__qualified_varsym] = STATE(2485),
    [sym__qvarsym_prefix] = STATE(7511),
    [sym__pqvarsym] = STATE(7511),
    [sym_constructor_operator] = STATE(2484),
    [sym__constructor_operator_alias] = STATE(2484),
    [sym__consym_prefix] = STATE(7511),
    [sym__pconsym] = STATE(7511),
    [sym__qualified_consym] = STATE(2502),
    [sym__qconsym_prefix] = STATE(7511),
    [sym__pqconsym] = STATE(7511),
    [sym__prefix_at] = STATE(2561),
    [sym__paren_open] = STATE(455),
    [sym__bracket_open] = STATE(1090),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(3109),
    [anon_sym_SQUOTE] = ACTIONS(3111),
    [anon_sym_STAR] = ACTIONS(3113),
    [anon_sym_u2605] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3117),
    [sym_char] = ACTIONS(3117),
    [sym_string] = ACTIONS(3117),
    [sym__integer_literal] = ACTIONS(3119),
    [sym__binary_literal] = ACTIONS(3121),
    [sym__octal_literal] = ACTIONS(3121),
    [sym__hex_literal] = ACTIONS(3121),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(3123),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1159),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1157),
    [sym__cond_layout_end] = ACTIONS(1157),
    [sym__cond_layout_end_explicit] = ACTIONS(1157),
    [sym__phantom_where] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3125),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1165] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10915),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cmd_layout_start_if] = ACTIONS(3177),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1166] = {
    [sym__type_parens] = STATE(7505),
    [sym__type_tuple] = STATE(7503),
    [sym__type_unboxed_tuple] = STATE(7497),
    [sym__type_unboxed_sum] = STATE(7492),
    [sym__type_list] = STATE(7528),
    [sym__type_promoted] = STATE(7491),
    [sym__type_star] = STATE(7491),
    [sym__type_wildcard] = STATE(7491),
    [sym__at_type] = STATE(7554),
    [sym__type_apply] = STATE(7550),
    [sym__type_infix] = STATE(7534),
    [sym_type] = STATE(1166),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8491),
    [sym__splice_dollars] = STATE(7345),
    [sym_splice] = STATE(7491),
    [sym_quasiquote] = STATE(7491),
    [sym_integer] = STATE(7542),
    [sym__plist] = STATE(7518),
    [sym_unit] = STATE(7491),
    [sym_unboxed_unit] = STATE(7491),
    [sym_prefix_tuple] = STATE(7491),
    [sym_prefix_unboxed_tuple] = STATE(7491),
    [sym_prefix_unboxed_sum] = STATE(7491),
    [sym_literal] = STATE(7491),
    [sym__qualified_type] = STATE(7541),
    [sym__qtyconid] = STATE(7511),
    [sym__tycon_arrow] = STATE(7511),
    [sym__qtycon_arrow] = STATE(7511),
    [sym__promoted_tycons_alias] = STATE(7491),
    [sym__promoted_tycons] = STATE(7491),
    [sym__tycon_ticked] = STATE(2484),
    [sym__qtycon_ticked] = STATE(2484),
    [sym__tyconids_ticked] = STATE(2484),
    [sym__promoted_tyconops_alias] = STATE(2484),
    [sym__promoted_tyconops] = STATE(2484),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2484),
    [sym__operator_alias] = STATE(2484),
    [sym__operator_minus] = STATE(2484),
    [sym__varsym_prefix] = STATE(7511),
    [sym__pvarsym] = STATE(7511),
    [sym__qualified_varsym] = STATE(2485),
    [sym__qvarsym_prefix] = STATE(7511),
    [sym__pqvarsym] = STATE(7511),
    [sym_constructor_operator] = STATE(2484),
    [sym__constructor_operator_alias] = STATE(2484),
    [sym__consym_prefix] = STATE(7511),
    [sym__pconsym] = STATE(7511),
    [sym__qualified_consym] = STATE(2502),
    [sym__qconsym_prefix] = STATE(7511),
    [sym__pqconsym] = STATE(7511),
    [sym__prefix_at] = STATE(2561),
    [sym__paren_open] = STATE(455),
    [sym__bracket_open] = STATE(1090),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [anon_sym_where] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1119),
    [sym__cond_layout_end] = ACTIONS(1119),
    [sym__cond_layout_end_explicit] = ACTIONS(1119),
    [sym__phantom_where] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [1167] = {
    [sym__type_parens] = STATE(7505),
    [sym__type_tuple] = STATE(7503),
    [sym__type_unboxed_tuple] = STATE(7497),
    [sym__type_unboxed_sum] = STATE(7492),
    [sym__type_list] = STATE(7528),
    [sym__type_promoted] = STATE(7491),
    [sym__type_star] = STATE(7491),
    [sym__type_wildcard] = STATE(7491),
    [sym__at_type] = STATE(7554),
    [sym__type_apply] = STATE(7550),
    [sym__type_infix] = STATE(7534),
    [sym_type] = STATE(1166),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8491),
    [sym__splice_dollars] = STATE(7345),
    [sym_splice] = STATE(7491),
    [sym_quasiquote] = STATE(7491),
    [sym_integer] = STATE(7542),
    [sym__plist] = STATE(7518),
    [sym_unit] = STATE(7491),
    [sym_unboxed_unit] = STATE(7491),
    [sym_prefix_tuple] = STATE(7491),
    [sym_prefix_unboxed_tuple] = STATE(7491),
    [sym_prefix_unboxed_sum] = STATE(7491),
    [sym_literal] = STATE(7491),
    [sym__qualified_type] = STATE(7541),
    [sym__qtyconid] = STATE(7511),
    [sym__tycon_arrow] = STATE(7511),
    [sym__qtycon_arrow] = STATE(7511),
    [sym__promoted_tycons_alias] = STATE(7491),
    [sym__promoted_tycons] = STATE(7491),
    [sym__tycon_ticked] = STATE(2484),
    [sym__qtycon_ticked] = STATE(2484),
    [sym__tyconids_ticked] = STATE(2484),
    [sym__promoted_tyconops_alias] = STATE(2484),
    [sym__promoted_tyconops] = STATE(2484),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2484),
    [sym__operator_alias] = STATE(2484),
    [sym__operator_minus] = STATE(2484),
    [sym__varsym_prefix] = STATE(7511),
    [sym__pvarsym] = STATE(7511),
    [sym__qualified_varsym] = STATE(2485),
    [sym__qvarsym_prefix] = STATE(7511),
    [sym__pqvarsym] = STATE(7511),
    [sym_constructor_operator] = STATE(2484),
    [sym__constructor_operator_alias] = STATE(2484),
    [sym__consym_prefix] = STATE(7511),
    [sym__pconsym] = STATE(7511),
    [sym__qualified_consym] = STATE(2502),
    [sym__qconsym_prefix] = STATE(7511),
    [sym__pqconsym] = STATE(7511),
    [sym__prefix_at] = STATE(2561),
    [sym__paren_open] = STATE(455),
    [sym__bracket_open] = STATE(1090),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(1177),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym__phantom_where] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1168] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10920),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cmd_layout_start_if] = ACTIONS(3179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1169] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(350),
    [sym__exp_signature] = STATE(12805),
    [sym__exp] = STATE(12713),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(3181),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1170] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(350),
    [sym__exp_signature] = STATE(12805),
    [sym__exp] = STATE(12366),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(3183),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1171] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10709),
    [sym__assoc_tyinst] = STATE(10389),
    [sym__assoc_datainst_adt] = STATE(10386),
    [sym__assoc_datainst_newtype] = STATE(10381),
    [sym__assoc_datainst] = STATE(10379),
    [sym_instance_decl] = STATE(10756),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10379),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_newtype] = ACTIONS(2911),
    [anon_sym_data] = ACTIONS(2913),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3185),
    [sym__cond_layout_end_explicit] = ACTIONS(3185),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1172] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(350),
    [sym__exp_signature] = STATE(12805),
    [sym__exp] = STATE(12679),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(3187),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1173] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10565),
    [sym__assoc_tyinst] = STATE(10389),
    [sym__assoc_datainst_adt] = STATE(10386),
    [sym__assoc_datainst_newtype] = STATE(10381),
    [sym__assoc_datainst] = STATE(10379),
    [sym_instance_decl] = STATE(10756),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10379),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_newtype] = ACTIONS(2911),
    [anon_sym_data] = ACTIONS(2913),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3189),
    [sym__cond_layout_end_explicit] = ACTIONS(3189),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1174] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(350),
    [sym__exp_signature] = STATE(12805),
    [sym__exp] = STATE(12271),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(3191),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1175] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(350),
    [sym__exp_signature] = STATE(12805),
    [sym__exp] = STATE(12536),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(3193),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1176] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(350),
    [sym__exp_signature] = STATE(12805),
    [sym__exp] = STATE(12423),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(3195),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1177] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10922),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cmd_layout_start_if] = ACTIONS(3197),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1178] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10918),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cmd_layout_start_if] = ACTIONS(3199),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1179] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(252),
    [sym__exp_signature] = STATE(10018),
    [sym__exp] = STATE(10282),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_group] = ACTIONS(3201),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1180] = {
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(176),
    [sym__exp_signature] = STATE(4442),
    [sym__exp] = STATE(4561),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__paren_open] = STATE(416),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1181] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11135),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1182] = {
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(309),
    [sym__exp_signature] = STATE(5642),
    [sym__exp] = STATE(5637),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__paren_open] = STATE(400),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1183] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8157),
    [sym__type_signature] = STATE(10256),
    [sym__ktype] = STATE(10212),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1184] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(50),
    [sym__exp_signature] = STATE(2952),
    [sym__exp] = STATE(2844),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1185] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(252),
    [sym__exp_signature] = STATE(10018),
    [sym__exp] = STATE(10211),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1186] = {
    [sym__type_parens] = STATE(7585),
    [sym__type_tuple] = STATE(7602),
    [sym__type_unboxed_tuple] = STATE(7615),
    [sym__type_unboxed_sum] = STATE(7591),
    [sym__type_list] = STATE(7589),
    [sym__type_promoted] = STATE(7555),
    [sym__type_star] = STATE(7555),
    [sym__type_wildcard] = STATE(7555),
    [sym__at_type] = STATE(7592),
    [sym__type_apply] = STATE(7581),
    [sym__type_infix] = STATE(7580),
    [sym_type] = STATE(1264),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8542),
    [sym__splice_dollars] = STATE(7479),
    [sym_splice] = STATE(7555),
    [sym_quasiquote] = STATE(7555),
    [sym_integer] = STATE(7595),
    [sym__plist] = STATE(7579),
    [sym_unit] = STATE(7555),
    [sym_unboxed_unit] = STATE(7555),
    [sym_prefix_tuple] = STATE(7555),
    [sym_prefix_unboxed_tuple] = STATE(7555),
    [sym_prefix_unboxed_sum] = STATE(7555),
    [sym_literal] = STATE(7555),
    [sym__qualified_type] = STATE(7587),
    [sym__qtyconid] = STATE(7569),
    [sym__tycon_arrow] = STATE(7569),
    [sym__qtycon_arrow] = STATE(7569),
    [sym__promoted_tycons_alias] = STATE(7555),
    [sym__promoted_tycons] = STATE(7555),
    [sym__tycon_ticked] = STATE(2556),
    [sym__qtycon_ticked] = STATE(2556),
    [sym__tyconids_ticked] = STATE(2556),
    [sym__promoted_tyconops_alias] = STATE(2556),
    [sym__promoted_tyconops] = STATE(2556),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2556),
    [sym__operator_alias] = STATE(2556),
    [sym__operator_minus] = STATE(2556),
    [sym__varsym_prefix] = STATE(7569),
    [sym__pvarsym] = STATE(7569),
    [sym__qualified_varsym] = STATE(2559),
    [sym__qvarsym_prefix] = STATE(7569),
    [sym__pqvarsym] = STATE(7569),
    [sym_constructor_operator] = STATE(2556),
    [sym__constructor_operator_alias] = STATE(2556),
    [sym__consym_prefix] = STATE(7569),
    [sym__pconsym] = STATE(7569),
    [sym__qualified_consym] = STATE(2560),
    [sym__qconsym_prefix] = STATE(7569),
    [sym__pqconsym] = STATE(7569),
    [sym__prefix_at] = STATE(2534),
    [sym__paren_open] = STATE(434),
    [sym__bracket_open] = STATE(963),
    [sym__unboxed_open] = STATE(763),
    [sym_variable] = ACTIONS(3203),
    [anon_sym__] = ACTIONS(3205),
    [anon_sym_SQUOTE] = ACTIONS(3207),
    [anon_sym_STAR] = ACTIONS(3209),
    [anon_sym_u2605] = ACTIONS(3211),
    [anon_sym_EQ] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3213),
    [sym_char] = ACTIONS(3213),
    [sym_string] = ACTIONS(3213),
    [sym__integer_literal] = ACTIONS(3215),
    [sym__binary_literal] = ACTIONS(3217),
    [sym__octal_literal] = ACTIONS(3217),
    [sym__hex_literal] = ACTIONS(3217),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(3219),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_where] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3221),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1187] = {
    [sym__type_parens] = STATE(7585),
    [sym__type_tuple] = STATE(7602),
    [sym__type_unboxed_tuple] = STATE(7615),
    [sym__type_unboxed_sum] = STATE(7591),
    [sym__type_list] = STATE(7589),
    [sym__type_promoted] = STATE(7555),
    [sym__type_star] = STATE(7555),
    [sym__type_wildcard] = STATE(7555),
    [sym__at_type] = STATE(7592),
    [sym__type_apply] = STATE(7581),
    [sym__type_infix] = STATE(7580),
    [sym_type] = STATE(1264),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8542),
    [sym__splice_dollars] = STATE(7479),
    [sym_splice] = STATE(7555),
    [sym_quasiquote] = STATE(7555),
    [sym_integer] = STATE(7595),
    [sym__plist] = STATE(7579),
    [sym_unit] = STATE(7555),
    [sym_unboxed_unit] = STATE(7555),
    [sym_prefix_tuple] = STATE(7555),
    [sym_prefix_unboxed_tuple] = STATE(7555),
    [sym_prefix_unboxed_sum] = STATE(7555),
    [sym_literal] = STATE(7555),
    [sym__qualified_type] = STATE(7587),
    [sym__qtyconid] = STATE(7569),
    [sym__tycon_arrow] = STATE(7569),
    [sym__qtycon_arrow] = STATE(7569),
    [sym__promoted_tycons_alias] = STATE(7555),
    [sym__promoted_tycons] = STATE(7555),
    [sym__tycon_ticked] = STATE(2556),
    [sym__qtycon_ticked] = STATE(2556),
    [sym__tyconids_ticked] = STATE(2556),
    [sym__promoted_tyconops_alias] = STATE(2556),
    [sym__promoted_tyconops] = STATE(2556),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2556),
    [sym__operator_alias] = STATE(2556),
    [sym__operator_minus] = STATE(2556),
    [sym__varsym_prefix] = STATE(7569),
    [sym__pvarsym] = STATE(7569),
    [sym__qualified_varsym] = STATE(2559),
    [sym__qvarsym_prefix] = STATE(7569),
    [sym__pqvarsym] = STATE(7569),
    [sym_constructor_operator] = STATE(2556),
    [sym__constructor_operator_alias] = STATE(2556),
    [sym__consym_prefix] = STATE(7569),
    [sym__pconsym] = STATE(7569),
    [sym__qualified_consym] = STATE(2560),
    [sym__qconsym_prefix] = STATE(7569),
    [sym__pqconsym] = STATE(7569),
    [sym__prefix_at] = STATE(2534),
    [sym__paren_open] = STATE(434),
    [sym__bracket_open] = STATE(963),
    [sym__unboxed_open] = STATE(763),
    [sym_variable] = ACTIONS(3203),
    [anon_sym__] = ACTIONS(3205),
    [anon_sym_SQUOTE] = ACTIONS(3207),
    [anon_sym_STAR] = ACTIONS(3209),
    [anon_sym_u2605] = ACTIONS(3211),
    [anon_sym_EQ] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3213),
    [sym_char] = ACTIONS(3213),
    [sym_string] = ACTIONS(3213),
    [sym__integer_literal] = ACTIONS(3215),
    [sym__binary_literal] = ACTIONS(3217),
    [sym__octal_literal] = ACTIONS(3217),
    [sym__hex_literal] = ACTIONS(3217),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(3219),
    [anon_sym_COLON_COLON] = ACTIONS(1181),
    [anon_sym_u2237] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1183),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_where] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3221),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1188] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(263),
    [sym__exp_signature] = STATE(5457),
    [sym__exp] = STATE(5280),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1189] = {
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(273),
    [sym__exp_signature] = STATE(5504),
    [sym__exp] = STATE(5278),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__paren_open] = STATE(405),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1190] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(182),
    [sym__exp_signature] = STATE(4573),
    [sym__exp] = STATE(4752),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1191] = {
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(309),
    [sym__exp_signature] = STATE(5642),
    [sym__exp] = STATE(5648),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__paren_open] = STATE(400),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1192] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(252),
    [sym__exp_signature] = STATE(10018),
    [sym__exp] = STATE(11119),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1193] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(220),
    [sym__exp_signature] = STATE(5068),
    [sym__exp] = STATE(5003),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__paren_open] = STATE(404),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1194] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11217),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1195] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1056),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2280),
    [sym__qconstructor_ticked] = STATE(2280),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2280),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__colon2] = STATE(1612),
    [sym__prefix_at] = STATE(2642),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym_COMMA] = ACTIONS(2719),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym_RBRACE] = ACTIONS(2719),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2719),
    [anon_sym_u27e7] = ACTIONS(2719),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(2841),
    [anon_sym_LT_DASH] = ACTIONS(2719),
    [anon_sym_u2190] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2809),
    [anon_sym_u2237] = ACTIONS(2809),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(2719),
    [anon_sym_RBRACK] = ACTIONS(2719),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(2845),
    [sym__cond_no_section_op] = ACTIONS(2847),
    [sym__consym] = ACTIONS(2737),
  },
  [1196] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(252),
    [sym__exp_signature] = STATE(10018),
    [sym__exp] = STATE(11114),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1197] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(389),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(3155),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(185),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1198] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12431),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1199] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8157),
    [sym__type_signature] = STATE(10256),
    [sym__ktype] = STATE(10847),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1200] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11849),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1201] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12450),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1202] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(220),
    [sym__exp_signature] = STATE(5068),
    [sym__exp] = STATE(4964),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__paren_open] = STATE(404),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1203] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(263),
    [sym__exp_signature] = STATE(5457),
    [sym__exp] = STATE(5316),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1204] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(376),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(4224),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1249),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1205] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(50),
    [sym__exp_signature] = STATE(2952),
    [sym__exp] = STATE(2957),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1206] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(50),
    [sym__exp_signature] = STATE(2952),
    [sym__exp] = STATE(2840),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1207] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(390),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(3526),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(205),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1208] = {
    [sym__at_type] = STATE(6585),
    [sym_explicit_type] = STATE(6590),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(1234),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__constructor_ticked] = STATE(2296),
    [sym__qconstructor_ticked] = STATE(2296),
    [sym__varsym_prefix] = STATE(6638),
    [sym__pvarsym] = STATE(6638),
    [sym_constructor_operator] = STATE(2296),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_at] = STATE(2637),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(44),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym__] = ACTIONS(3013),
    [anon_sym_STAR] = ACTIONS(3015),
    [anon_sym_EQ] = ACTIONS(3015),
    [anon_sym_PIPE] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [sym_float] = ACTIONS(3015),
    [sym_char] = ACTIONS(3015),
    [sym_string] = ACTIONS(3015),
    [sym__integer_literal] = ACTIONS(3013),
    [sym__binary_literal] = ACTIONS(3015),
    [sym__octal_literal] = ACTIONS(3015),
    [sym__hex_literal] = ACTIONS(3015),
    [anon_sym_BQUOTE] = ACTIONS(3015),
    [anon_sym_POUND] = ACTIONS(3013),
    [anon_sym_POUND2] = ACTIONS(3015),
    [sym_name] = ACTIONS(3015),
    [anon_sym_COLON_COLON] = ACTIONS(3015),
    [anon_sym_u2237] = ACTIONS(3015),
    [aux_sym__paren_open_token1] = ACTIONS(3015),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(3015),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3015),
    [sym__cond_splice] = ACTIONS(3015),
    [sym__cond_prefix_dot] = ACTIONS(3015),
    [sym__cond_prefix_at] = ACTIONS(3015),
    [sym__cond_tight_bang] = ACTIONS(3015),
    [sym__cond_prefix_bang] = ACTIONS(3015),
    [sym__cond_tight_tilde] = ACTIONS(3015),
    [sym__cond_prefix_tilde] = ACTIONS(3015),
    [sym__cond_qualified_op] = ACTIONS(3015),
    [sym__cond_no_section_op] = ACTIONS(3015),
    [sym__cond_minus] = ACTIONS(3015),
    [sym__varsym] = ACTIONS(3015),
    [sym__consym] = ACTIONS(3015),
  },
  [1209] = {
    [sym__at_type] = STATE(6585),
    [sym_explicit_type] = STATE(6590),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(1234),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__constructor_ticked] = STATE(2296),
    [sym__qconstructor_ticked] = STATE(2296),
    [sym__varsym_prefix] = STATE(6638),
    [sym__pvarsym] = STATE(6638),
    [sym_constructor_operator] = STATE(2296),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_at] = STATE(2637),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(44),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym__] = ACTIONS(3009),
    [anon_sym_STAR] = ACTIONS(3011),
    [anon_sym_EQ] = ACTIONS(3011),
    [anon_sym_PIPE] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3011),
    [anon_sym_LBRACK] = ACTIONS(3011),
    [sym_float] = ACTIONS(3011),
    [sym_char] = ACTIONS(3011),
    [sym_string] = ACTIONS(3011),
    [sym__integer_literal] = ACTIONS(3009),
    [sym__binary_literal] = ACTIONS(3011),
    [sym__octal_literal] = ACTIONS(3011),
    [sym__hex_literal] = ACTIONS(3011),
    [anon_sym_BQUOTE] = ACTIONS(3011),
    [anon_sym_POUND] = ACTIONS(3009),
    [anon_sym_POUND2] = ACTIONS(3011),
    [sym_name] = ACTIONS(3011),
    [anon_sym_COLON_COLON] = ACTIONS(3011),
    [anon_sym_u2237] = ACTIONS(3011),
    [aux_sym__paren_open_token1] = ACTIONS(3011),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(3011),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3011),
    [sym__cond_splice] = ACTIONS(3011),
    [sym__cond_prefix_dot] = ACTIONS(3011),
    [sym__cond_prefix_at] = ACTIONS(3011),
    [sym__cond_tight_bang] = ACTIONS(3011),
    [sym__cond_prefix_bang] = ACTIONS(3011),
    [sym__cond_tight_tilde] = ACTIONS(3011),
    [sym__cond_prefix_tilde] = ACTIONS(3011),
    [sym__cond_qualified_op] = ACTIONS(3011),
    [sym__cond_no_section_op] = ACTIONS(3011),
    [sym__cond_minus] = ACTIONS(3011),
    [sym__varsym] = ACTIONS(3011),
    [sym__consym] = ACTIONS(3011),
  },
  [1210] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(220),
    [sym__exp_signature] = STATE(5068),
    [sym__exp] = STATE(4921),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__paren_open] = STATE(404),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1211] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(263),
    [sym__exp_signature] = STATE(5457),
    [sym__exp] = STATE(5217),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1212] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(398),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(3963),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1213] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(182),
    [sym__exp_signature] = STATE(4573),
    [sym__exp] = STATE(4409),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1214] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11240),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1215] = {
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(176),
    [sym__exp_signature] = STATE(4442),
    [sym__exp] = STATE(4457),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__paren_open] = STATE(416),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1216] = {
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(254),
    [sym__exp_signature] = STATE(5315),
    [sym__exp] = STATE(5158),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__paren_open] = STATE(402),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1217] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(263),
    [sym__exp_signature] = STATE(5457),
    [sym__exp] = STATE(5287),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1218] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(182),
    [sym__exp_signature] = STATE(4573),
    [sym__exp] = STATE(4825),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1219] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11265),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1220] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(389),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(4401),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1269),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1221] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(263),
    [sym__exp_signature] = STATE(5457),
    [sym__exp] = STATE(5288),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1222] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(220),
    [sym__exp_signature] = STATE(5068),
    [sym__exp] = STATE(4993),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__paren_open] = STATE(404),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1223] = {
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(118),
    [sym__exp_signature] = STATE(4131),
    [sym__exp] = STATE(4223),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__paren_open] = STATE(406),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1224] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10966),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1225] = {
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(177),
    [sym__exp_signature] = STATE(9548),
    [sym__exp] = STATE(9633),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__paren_open] = STATE(416),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1226] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10130),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1227] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(178),
    [sym__exp_signature] = STATE(4312),
    [sym__exp] = STATE(4776),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1228] = {
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(247),
    [sym__exp_signature] = STATE(10022),
    [sym__exp] = STATE(10055),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__paren_open] = STATE(402),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1229] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12755),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1230] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(388),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(3752),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1255),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1231] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(182),
    [sym__exp_signature] = STATE(4573),
    [sym__exp] = STATE(4854),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1232] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10984),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = ACTIONS(1989),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1233] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(252),
    [sym__exp_signature] = STATE(10018),
    [sym__exp] = STATE(11290),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1234] = {
    [sym__at_type] = STATE(6585),
    [sym_explicit_type] = STATE(6590),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(1234),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__constructor_ticked] = STATE(2296),
    [sym__qconstructor_ticked] = STATE(2296),
    [sym__varsym_prefix] = STATE(6638),
    [sym__pvarsym] = STATE(6638),
    [sym_constructor_operator] = STATE(2296),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_at] = STATE(2637),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(44),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(3005),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym__] = ACTIONS(3005),
    [anon_sym_STAR] = ACTIONS(3007),
    [anon_sym_EQ] = ACTIONS(3007),
    [anon_sym_PIPE] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [sym_float] = ACTIONS(3007),
    [sym_char] = ACTIONS(3007),
    [sym_string] = ACTIONS(3007),
    [sym__integer_literal] = ACTIONS(3005),
    [sym__binary_literal] = ACTIONS(3007),
    [sym__octal_literal] = ACTIONS(3007),
    [sym__hex_literal] = ACTIONS(3007),
    [anon_sym_BQUOTE] = ACTIONS(3007),
    [anon_sym_POUND] = ACTIONS(3005),
    [anon_sym_POUND2] = ACTIONS(3007),
    [sym_name] = ACTIONS(3007),
    [anon_sym_COLON_COLON] = ACTIONS(3007),
    [anon_sym_u2237] = ACTIONS(3007),
    [aux_sym__paren_open_token1] = ACTIONS(3007),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3007),
    [sym__cond_splice] = ACTIONS(3007),
    [sym__cond_prefix_dot] = ACTIONS(3007),
    [sym__cond_prefix_at] = ACTIONS(3007),
    [sym__cond_tight_bang] = ACTIONS(3007),
    [sym__cond_prefix_bang] = ACTIONS(3007),
    [sym__cond_tight_tilde] = ACTIONS(3007),
    [sym__cond_prefix_tilde] = ACTIONS(3007),
    [sym__cond_qualified_op] = ACTIONS(3007),
    [sym__cond_no_section_op] = ACTIONS(3007),
    [sym__cond_minus] = ACTIONS(3007),
    [sym__varsym] = ACTIONS(3007),
    [sym__consym] = ACTIONS(3007),
  },
  [1235] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(252),
    [sym__exp_signature] = STATE(10018),
    [sym__exp] = STATE(11292),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1236] = {
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(321),
    [sym__exp_signature] = STATE(10890),
    [sym__exp] = STATE(11243),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__paren_open] = STATE(400),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1237] = {
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(273),
    [sym__exp_signature] = STATE(5504),
    [sym__exp] = STATE(5353),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__paren_open] = STATE(405),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1238] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(182),
    [sym__exp_signature] = STATE(4573),
    [sym__exp] = STATE(4367),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1239] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(182),
    [sym__exp_signature] = STATE(4573),
    [sym__exp] = STATE(4849),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1240] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(182),
    [sym__exp_signature] = STATE(4573),
    [sym__exp] = STATE(4365),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1241] = {
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(273),
    [sym__exp_signature] = STATE(5504),
    [sym__exp] = STATE(5404),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__paren_open] = STATE(405),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1242] = {
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(273),
    [sym__exp_signature] = STATE(5504),
    [sym__exp] = STATE(5403),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__paren_open] = STATE(405),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1243] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11179),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1244] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10211),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1245] = {
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(321),
    [sym__exp_signature] = STATE(10890),
    [sym__exp] = STATE(10955),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__paren_open] = STATE(400),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1246] = {
    [sym__type_parens] = STATE(7585),
    [sym__type_tuple] = STATE(7602),
    [sym__type_unboxed_tuple] = STATE(7615),
    [sym__type_unboxed_sum] = STATE(7591),
    [sym__type_list] = STATE(7589),
    [sym__type_promoted] = STATE(7555),
    [sym__type_star] = STATE(7555),
    [sym__type_wildcard] = STATE(7555),
    [sym__at_type] = STATE(7592),
    [sym__type_apply] = STATE(7581),
    [sym__type_infix] = STATE(7580),
    [sym_type] = STATE(1264),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8542),
    [sym__splice_dollars] = STATE(7479),
    [sym_splice] = STATE(7555),
    [sym_quasiquote] = STATE(7555),
    [sym_integer] = STATE(7595),
    [sym__plist] = STATE(7579),
    [sym_unit] = STATE(7555),
    [sym_unboxed_unit] = STATE(7555),
    [sym_prefix_tuple] = STATE(7555),
    [sym_prefix_unboxed_tuple] = STATE(7555),
    [sym_prefix_unboxed_sum] = STATE(7555),
    [sym_literal] = STATE(7555),
    [sym__qualified_type] = STATE(7587),
    [sym__qtyconid] = STATE(7569),
    [sym__tycon_arrow] = STATE(7569),
    [sym__qtycon_arrow] = STATE(7569),
    [sym__promoted_tycons_alias] = STATE(7555),
    [sym__promoted_tycons] = STATE(7555),
    [sym__tycon_ticked] = STATE(2556),
    [sym__qtycon_ticked] = STATE(2556),
    [sym__tyconids_ticked] = STATE(2556),
    [sym__promoted_tyconops_alias] = STATE(2556),
    [sym__promoted_tyconops] = STATE(2556),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2556),
    [sym__operator_alias] = STATE(2556),
    [sym__operator_minus] = STATE(2556),
    [sym__varsym_prefix] = STATE(7569),
    [sym__pvarsym] = STATE(7569),
    [sym__qualified_varsym] = STATE(2559),
    [sym__qvarsym_prefix] = STATE(7569),
    [sym__pqvarsym] = STATE(7569),
    [sym_constructor_operator] = STATE(2556),
    [sym__constructor_operator_alias] = STATE(2556),
    [sym__consym_prefix] = STATE(7569),
    [sym__pconsym] = STATE(7569),
    [sym__qualified_consym] = STATE(2560),
    [sym__qconsym_prefix] = STATE(7569),
    [sym__pqconsym] = STATE(7569),
    [sym__prefix_at] = STATE(2534),
    [sym__paren_open] = STATE(434),
    [sym__bracket_open] = STATE(963),
    [sym__unboxed_open] = STATE(763),
    [sym_variable] = ACTIONS(1177),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(1177),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_where] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [1247] = {
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(118),
    [sym__exp_signature] = STATE(4131),
    [sym__exp] = STATE(4140),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__paren_open] = STATE(406),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1248] = {
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(254),
    [sym__exp_signature] = STATE(5315),
    [sym__exp] = STATE(5157),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__paren_open] = STATE(402),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1249] = {
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(176),
    [sym__exp_signature] = STATE(4442),
    [sym__exp] = STATE(4468),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__paren_open] = STATE(416),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1250] = {
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(176),
    [sym__exp_signature] = STATE(4442),
    [sym__exp] = STATE(4469),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__paren_open] = STATE(416),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1251] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(220),
    [sym__exp_signature] = STATE(5068),
    [sym__exp] = STATE(4866),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__paren_open] = STATE(404),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1252] = {
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(118),
    [sym__exp_signature] = STATE(4131),
    [sym__exp] = STATE(4142),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__paren_open] = STATE(406),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1253] = {
    [sym__at_type] = STATE(6585),
    [sym_explicit_type] = STATE(6590),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(1234),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__constructor_ticked] = STATE(2296),
    [sym__qconstructor_ticked] = STATE(2296),
    [sym__varsym_prefix] = STATE(6638),
    [sym__pvarsym] = STATE(6638),
    [sym_constructor_operator] = STATE(2296),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_at] = STATE(2637),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(44),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(2713),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_EQ] = ACTIONS(2899),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [anon_sym_POUND] = ACTIONS(3227),
    [anon_sym_POUND2] = ACTIONS(2899),
    [sym_name] = ACTIONS(1947),
    [anon_sym_COLON_COLON] = ACTIONS(2899),
    [anon_sym_u2237] = ACTIONS(2899),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(2899),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(2899),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(2731),
    [sym__cond_no_section_op] = ACTIONS(3229),
    [sym__cond_minus] = ACTIONS(2899),
    [sym__varsym] = ACTIONS(2899),
    [sym__consym] = ACTIONS(2737),
  },
  [1254] = {
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(254),
    [sym__exp_signature] = STATE(5315),
    [sym__exp] = STATE(5118),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__paren_open] = STATE(402),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1255] = {
    [sym__at_type] = STATE(6585),
    [sym_explicit_type] = STATE(6590),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(1234),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__constructor_ticked] = STATE(2296),
    [sym__qconstructor_ticked] = STATE(2296),
    [sym__varsym_prefix] = STATE(6638),
    [sym__pvarsym] = STATE(6638),
    [sym_constructor_operator] = STATE(2296),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_at] = STATE(2637),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(44),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(2713),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_EQ] = ACTIONS(2903),
    [anon_sym_PIPE] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [anon_sym_POUND] = ACTIONS(3231),
    [anon_sym_POUND2] = ACTIONS(2903),
    [sym_name] = ACTIONS(1947),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_u2237] = ACTIONS(2903),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(2903),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(2903),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(2731),
    [sym__cond_no_section_op] = ACTIONS(3229),
    [sym__cond_minus] = ACTIONS(2903),
    [sym__varsym] = ACTIONS(2903),
    [sym__consym] = ACTIONS(2737),
  },
  [1256] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11113),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1257] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12457),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1258] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12704),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1259] = {
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(177),
    [sym__exp_signature] = STATE(9548),
    [sym__exp] = STATE(9623),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__paren_open] = STATE(416),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1260] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(390),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(2852),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1261] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10976),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1262] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11029),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1263] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11084),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1264] = {
    [sym__type_parens] = STATE(7585),
    [sym__type_tuple] = STATE(7602),
    [sym__type_unboxed_tuple] = STATE(7615),
    [sym__type_unboxed_sum] = STATE(7591),
    [sym__type_list] = STATE(7589),
    [sym__type_promoted] = STATE(7555),
    [sym__type_star] = STATE(7555),
    [sym__type_wildcard] = STATE(7555),
    [sym__at_type] = STATE(7592),
    [sym__type_apply] = STATE(7581),
    [sym__type_infix] = STATE(7580),
    [sym_type] = STATE(1264),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8542),
    [sym__splice_dollars] = STATE(7479),
    [sym_splice] = STATE(7555),
    [sym_quasiquote] = STATE(7555),
    [sym_integer] = STATE(7595),
    [sym__plist] = STATE(7579),
    [sym_unit] = STATE(7555),
    [sym_unboxed_unit] = STATE(7555),
    [sym_prefix_tuple] = STATE(7555),
    [sym_prefix_unboxed_tuple] = STATE(7555),
    [sym_prefix_unboxed_sum] = STATE(7555),
    [sym_literal] = STATE(7555),
    [sym__qualified_type] = STATE(7587),
    [sym__qtyconid] = STATE(7569),
    [sym__tycon_arrow] = STATE(7569),
    [sym__qtycon_arrow] = STATE(7569),
    [sym__promoted_tycons_alias] = STATE(7555),
    [sym__promoted_tycons] = STATE(7555),
    [sym__tycon_ticked] = STATE(2556),
    [sym__qtycon_ticked] = STATE(2556),
    [sym__tyconids_ticked] = STATE(2556),
    [sym__promoted_tyconops_alias] = STATE(2556),
    [sym__promoted_tyconops] = STATE(2556),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2556),
    [sym__operator_alias] = STATE(2556),
    [sym__operator_minus] = STATE(2556),
    [sym__varsym_prefix] = STATE(7569),
    [sym__pvarsym] = STATE(7569),
    [sym__qualified_varsym] = STATE(2559),
    [sym__qvarsym_prefix] = STATE(7569),
    [sym__pqvarsym] = STATE(7569),
    [sym_constructor_operator] = STATE(2556),
    [sym__constructor_operator_alias] = STATE(2556),
    [sym__consym_prefix] = STATE(7569),
    [sym__pconsym] = STATE(7569),
    [sym__qualified_consym] = STATE(2560),
    [sym__qconsym_prefix] = STATE(7569),
    [sym__pqconsym] = STATE(7569),
    [sym__prefix_at] = STATE(2534),
    [sym__paren_open] = STATE(434),
    [sym__bracket_open] = STATE(963),
    [sym__unboxed_open] = STATE(763),
    [sym_variable] = ACTIONS(1117),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_EQ] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_COLON_COLON] = ACTIONS(1119),
    [anon_sym_u2237] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [anon_sym_where] = ACTIONS(1117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_where] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [1265] = {
    [sym__at_type] = STATE(6585),
    [sym_explicit_type] = STATE(6590),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(1234),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__constructor_ticked] = STATE(2296),
    [sym__qconstructor_ticked] = STATE(2296),
    [sym__varsym_prefix] = STATE(6638),
    [sym__pvarsym] = STATE(6638),
    [sym_constructor_operator] = STATE(2296),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_at] = STATE(2637),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(44),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(2821),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym__] = ACTIONS(2821),
    [anon_sym_STAR] = ACTIONS(2823),
    [anon_sym_EQ] = ACTIONS(2823),
    [anon_sym_PIPE] = ACTIONS(2823),
    [anon_sym_DASH] = ACTIONS(2823),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [sym_float] = ACTIONS(2823),
    [sym_char] = ACTIONS(2823),
    [sym_string] = ACTIONS(2823),
    [sym__integer_literal] = ACTIONS(2821),
    [sym__binary_literal] = ACTIONS(2823),
    [sym__octal_literal] = ACTIONS(2823),
    [sym__hex_literal] = ACTIONS(2823),
    [anon_sym_BQUOTE] = ACTIONS(2823),
    [anon_sym_POUND] = ACTIONS(2821),
    [anon_sym_POUND2] = ACTIONS(2823),
    [sym_name] = ACTIONS(2823),
    [anon_sym_COLON_COLON] = ACTIONS(2823),
    [anon_sym_u2237] = ACTIONS(2823),
    [aux_sym__paren_open_token1] = ACTIONS(2823),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(2823),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2823),
    [sym__cond_splice] = ACTIONS(2823),
    [sym__cond_prefix_dot] = ACTIONS(2823),
    [sym__cond_prefix_at] = ACTIONS(2823),
    [sym__cond_tight_bang] = ACTIONS(2823),
    [sym__cond_prefix_bang] = ACTIONS(2823),
    [sym__cond_tight_tilde] = ACTIONS(2823),
    [sym__cond_prefix_tilde] = ACTIONS(2823),
    [sym__cond_qualified_op] = ACTIONS(2823),
    [sym__cond_no_section_op] = ACTIONS(2823),
    [sym__cond_minus] = ACTIONS(2823),
    [sym__varsym] = ACTIONS(2823),
    [sym__consym] = ACTIONS(2823),
  },
  [1266] = {
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(117),
    [sym__exp_signature] = STATE(8965),
    [sym__exp] = STATE(8982),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__paren_open] = STATE(406),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1267] = {
    [sym__type_parens] = STATE(7585),
    [sym__type_tuple] = STATE(7602),
    [sym__type_unboxed_tuple] = STATE(7615),
    [sym__type_unboxed_sum] = STATE(7591),
    [sym__type_list] = STATE(7589),
    [sym__type_promoted] = STATE(7555),
    [sym__type_star] = STATE(7555),
    [sym__type_wildcard] = STATE(7555),
    [sym__at_type] = STATE(7592),
    [sym__type_apply] = STATE(7581),
    [sym__type_infix] = STATE(7580),
    [sym_type] = STATE(1264),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8542),
    [sym__splice_dollars] = STATE(7479),
    [sym_splice] = STATE(7555),
    [sym_quasiquote] = STATE(7555),
    [sym_integer] = STATE(7595),
    [sym__plist] = STATE(7579),
    [sym_unit] = STATE(7555),
    [sym_unboxed_unit] = STATE(7555),
    [sym_prefix_tuple] = STATE(7555),
    [sym_prefix_unboxed_tuple] = STATE(7555),
    [sym_prefix_unboxed_sum] = STATE(7555),
    [sym_literal] = STATE(7555),
    [sym__qualified_type] = STATE(7587),
    [sym__qtyconid] = STATE(7569),
    [sym__tycon_arrow] = STATE(7569),
    [sym__qtycon_arrow] = STATE(7569),
    [sym__promoted_tycons_alias] = STATE(7555),
    [sym__promoted_tycons] = STATE(7555),
    [sym__tycon_ticked] = STATE(2556),
    [sym__qtycon_ticked] = STATE(2556),
    [sym__tyconids_ticked] = STATE(2556),
    [sym__promoted_tyconops_alias] = STATE(2556),
    [sym__promoted_tyconops] = STATE(2556),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2556),
    [sym__operator_alias] = STATE(2556),
    [sym__operator_minus] = STATE(2556),
    [sym__varsym_prefix] = STATE(7569),
    [sym__pvarsym] = STATE(7569),
    [sym__qualified_varsym] = STATE(2559),
    [sym__qvarsym_prefix] = STATE(7569),
    [sym__pqvarsym] = STATE(7569),
    [sym_constructor_operator] = STATE(2556),
    [sym__constructor_operator_alias] = STATE(2556),
    [sym__consym_prefix] = STATE(7569),
    [sym__pconsym] = STATE(7569),
    [sym__qualified_consym] = STATE(2560),
    [sym__qconsym_prefix] = STATE(7569),
    [sym__pqconsym] = STATE(7569),
    [sym__prefix_at] = STATE(2534),
    [sym__paren_open] = STATE(434),
    [sym__bracket_open] = STATE(963),
    [sym__unboxed_open] = STATE(763),
    [sym_variable] = ACTIONS(2599),
    [anon_sym__] = ACTIONS(2599),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [anon_sym_STAR] = ACTIONS(2601),
    [anon_sym_u2605] = ACTIONS(2601),
    [anon_sym_EQ] = ACTIONS(2601),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(2601),
    [sym_float] = ACTIONS(2601),
    [sym_char] = ACTIONS(2601),
    [sym_string] = ACTIONS(2601),
    [sym__integer_literal] = ACTIONS(2599),
    [sym__binary_literal] = ACTIONS(2601),
    [sym__octal_literal] = ACTIONS(2601),
    [sym__hex_literal] = ACTIONS(2601),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2601),
    [anon_sym_COLON_COLON] = ACTIONS(2601),
    [anon_sym_u2237] = ACTIONS(2601),
    [aux_sym__paren_open_token1] = ACTIONS(2601),
    [anon_sym_where] = ACTIONS(2599),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_where] = ACTIONS(2601),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2601),
    [sym__cond_splice] = ACTIONS(2601),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(2601),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1268] = {
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(309),
    [sym__exp_signature] = STATE(5642),
    [sym__exp] = STATE(5639),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__paren_open] = STATE(400),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1269] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(263),
    [sym__exp_signature] = STATE(5457),
    [sym__exp] = STATE(5254),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1270] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(399),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(4191),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1295),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1271] = {
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(309),
    [sym__exp_signature] = STATE(5642),
    [sym__exp] = STATE(5573),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__paren_open] = STATE(400),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1272] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(220),
    [sym__exp_signature] = STATE(5068),
    [sym__exp] = STATE(4997),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__paren_open] = STATE(404),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1273] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11096),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1274] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11307),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1275] = {
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(258),
    [sym__exp_signature] = STATE(10053),
    [sym__exp] = STATE(10219),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__paren_open] = STATE(405),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1276] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(220),
    [sym__exp_signature] = STATE(5068),
    [sym__exp] = STATE(4896),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__paren_open] = STATE(404),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1277] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11283),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1278] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(220),
    [sym__exp_signature] = STATE(5068),
    [sym__exp] = STATE(4897),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__paren_open] = STATE(404),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1279] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12584),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1280] = {
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(254),
    [sym__exp_signature] = STATE(5315),
    [sym__exp] = STATE(5444),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__paren_open] = STATE(402),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1281] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(389),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(3464),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(201),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1282] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(381),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(4867),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1263),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1283] = {
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(273),
    [sym__exp_signature] = STATE(5504),
    [sym__exp] = STATE(5253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__paren_open] = STATE(405),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1284] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(387),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(4243),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1277),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1285] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11181),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1286] = {
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(273),
    [sym__exp_signature] = STATE(5504),
    [sym__exp] = STATE(5313),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__paren_open] = STATE(405),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1287] = {
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(309),
    [sym__exp_signature] = STATE(5642),
    [sym__exp] = STATE(5553),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__paren_open] = STATE(400),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1288] = {
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(273),
    [sym__exp_signature] = STATE(5504),
    [sym__exp] = STATE(5263),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__paren_open] = STATE(405),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1289] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(220),
    [sym__exp_signature] = STATE(5068),
    [sym__exp] = STATE(4998),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__paren_open] = STATE(404),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1290] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12294),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1291] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(50),
    [sym__exp_signature] = STATE(2952),
    [sym__exp] = STATE(3029),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1292] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11003),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1293] = {
    [sym__type_parens] = STATE(7585),
    [sym__type_tuple] = STATE(7602),
    [sym__type_unboxed_tuple] = STATE(7615),
    [sym__type_unboxed_sum] = STATE(7591),
    [sym__type_list] = STATE(7589),
    [sym__type_promoted] = STATE(7555),
    [sym__type_star] = STATE(7555),
    [sym__type_wildcard] = STATE(7555),
    [sym__at_type] = STATE(7592),
    [sym__type_apply] = STATE(7581),
    [sym__type_infix] = STATE(7580),
    [sym_type] = STATE(1264),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8542),
    [sym__splice_dollars] = STATE(7479),
    [sym_splice] = STATE(7555),
    [sym_quasiquote] = STATE(7555),
    [sym_integer] = STATE(7595),
    [sym__plist] = STATE(7579),
    [sym_unit] = STATE(7555),
    [sym_unboxed_unit] = STATE(7555),
    [sym_prefix_tuple] = STATE(7555),
    [sym_prefix_unboxed_tuple] = STATE(7555),
    [sym_prefix_unboxed_sum] = STATE(7555),
    [sym_literal] = STATE(7555),
    [sym__qualified_type] = STATE(7587),
    [sym__qtyconid] = STATE(7569),
    [sym__tycon_arrow] = STATE(7569),
    [sym__qtycon_arrow] = STATE(7569),
    [sym__promoted_tycons_alias] = STATE(7555),
    [sym__promoted_tycons] = STATE(7555),
    [sym__tycon_ticked] = STATE(2556),
    [sym__qtycon_ticked] = STATE(2556),
    [sym__tyconids_ticked] = STATE(2556),
    [sym__promoted_tyconops_alias] = STATE(2556),
    [sym__promoted_tyconops] = STATE(2556),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2556),
    [sym__operator_alias] = STATE(2556),
    [sym__operator_minus] = STATE(2556),
    [sym__varsym_prefix] = STATE(7569),
    [sym__pvarsym] = STATE(7569),
    [sym__qualified_varsym] = STATE(2559),
    [sym__qvarsym_prefix] = STATE(7569),
    [sym__pqvarsym] = STATE(7569),
    [sym_constructor_operator] = STATE(2556),
    [sym__constructor_operator_alias] = STATE(2556),
    [sym__consym_prefix] = STATE(7569),
    [sym__pconsym] = STATE(7569),
    [sym__qualified_consym] = STATE(2560),
    [sym__qconsym_prefix] = STATE(7569),
    [sym__pqconsym] = STATE(7569),
    [sym__prefix_at] = STATE(2534),
    [sym__paren_open] = STATE(434),
    [sym__bracket_open] = STATE(963),
    [sym__unboxed_open] = STATE(763),
    [sym_variable] = ACTIONS(3203),
    [anon_sym__] = ACTIONS(3205),
    [anon_sym_SQUOTE] = ACTIONS(3207),
    [anon_sym_STAR] = ACTIONS(3209),
    [anon_sym_u2605] = ACTIONS(3211),
    [anon_sym_EQ] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3213),
    [sym_char] = ACTIONS(3213),
    [sym_string] = ACTIONS(3213),
    [sym__integer_literal] = ACTIONS(3215),
    [sym__binary_literal] = ACTIONS(3217),
    [sym__octal_literal] = ACTIONS(3217),
    [sym__hex_literal] = ACTIONS(3217),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(3219),
    [anon_sym_COLON_COLON] = ACTIONS(1157),
    [anon_sym_u2237] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(1159),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_where] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3221),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1294] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(182),
    [sym__exp_signature] = STATE(4573),
    [sym__exp] = STATE(4320),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1295] = {
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(254),
    [sym__exp_signature] = STATE(5315),
    [sym__exp] = STATE(5182),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__paren_open] = STATE(402),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1296] = {
    [sym__type_parens] = STATE(7585),
    [sym__type_tuple] = STATE(7602),
    [sym__type_unboxed_tuple] = STATE(7615),
    [sym__type_unboxed_sum] = STATE(7591),
    [sym__type_list] = STATE(7589),
    [sym__type_promoted] = STATE(7555),
    [sym__type_star] = STATE(7555),
    [sym__type_wildcard] = STATE(7555),
    [sym__at_type] = STATE(7592),
    [sym__type_apply] = STATE(7581),
    [sym__type_infix] = STATE(7580),
    [sym_type] = STATE(1264),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8542),
    [sym__splice_dollars] = STATE(7479),
    [sym_splice] = STATE(7555),
    [sym_quasiquote] = STATE(7555),
    [sym_integer] = STATE(7595),
    [sym__plist] = STATE(7579),
    [sym_unit] = STATE(7555),
    [sym_unboxed_unit] = STATE(7555),
    [sym_prefix_tuple] = STATE(7555),
    [sym_prefix_unboxed_tuple] = STATE(7555),
    [sym_prefix_unboxed_sum] = STATE(7555),
    [sym_literal] = STATE(7555),
    [sym__qualified_type] = STATE(7587),
    [sym__qtyconid] = STATE(7569),
    [sym__tycon_arrow] = STATE(7569),
    [sym__qtycon_arrow] = STATE(7569),
    [sym__promoted_tycons_alias] = STATE(7555),
    [sym__promoted_tycons] = STATE(7555),
    [sym__tycon_ticked] = STATE(2556),
    [sym__qtycon_ticked] = STATE(2556),
    [sym__tyconids_ticked] = STATE(2556),
    [sym__promoted_tyconops_alias] = STATE(2556),
    [sym__promoted_tyconops] = STATE(2556),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2556),
    [sym__operator_alias] = STATE(2556),
    [sym__operator_minus] = STATE(2556),
    [sym__varsym_prefix] = STATE(7569),
    [sym__pvarsym] = STATE(7569),
    [sym__qualified_varsym] = STATE(2559),
    [sym__qvarsym_prefix] = STATE(7569),
    [sym__pqvarsym] = STATE(7569),
    [sym_constructor_operator] = STATE(2556),
    [sym__constructor_operator_alias] = STATE(2556),
    [sym__consym_prefix] = STATE(7569),
    [sym__pconsym] = STATE(7569),
    [sym__qualified_consym] = STATE(2560),
    [sym__qconsym_prefix] = STATE(7569),
    [sym__pqconsym] = STATE(7569),
    [sym__prefix_at] = STATE(2534),
    [sym__paren_open] = STATE(434),
    [sym__bracket_open] = STATE(963),
    [sym__unboxed_open] = STATE(763),
    [sym_variable] = ACTIONS(1177),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_EQ] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1179),
    [anon_sym_COLON_COLON] = ACTIONS(1179),
    [anon_sym_u2237] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(1177),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_where] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1297] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10193),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(9485),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(9485),
    [sym__local_decl] = STATE(9485),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(1801),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(3233),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3235),
    [sym__cond_layout_end] = ACTIONS(3237),
    [sym__cond_layout_end_explicit] = ACTIONS(3237),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1298] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10988),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1299] = {
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(117),
    [sym__exp_signature] = STATE(8965),
    [sym__exp] = STATE(9037),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__paren_open] = STATE(406),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1300] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(50),
    [sym__exp_signature] = STATE(2952),
    [sym__exp] = STATE(2995),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1301] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(50),
    [sym__exp_signature] = STATE(2952),
    [sym__exp] = STATE(2999),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1302] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(387),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(3704),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(169),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1303] = {
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(118),
    [sym__exp_signature] = STATE(4131),
    [sym__exp] = STATE(4099),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__paren_open] = STATE(406),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1304] = {
    [sym__at_type] = STATE(6585),
    [sym_explicit_type] = STATE(6590),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(1234),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__constructor_ticked] = STATE(2296),
    [sym__qconstructor_ticked] = STATE(2296),
    [sym__varsym_prefix] = STATE(6638),
    [sym__pvarsym] = STATE(6638),
    [sym_constructor_operator] = STATE(2296),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_at] = STATE(2637),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(44),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(2713),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(2829),
    [anon_sym_EQ] = ACTIONS(2829),
    [anon_sym_PIPE] = ACTIONS(2829),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [anon_sym_POUND] = ACTIONS(3239),
    [anon_sym_POUND2] = ACTIONS(2829),
    [sym_name] = ACTIONS(1947),
    [anon_sym_COLON_COLON] = ACTIONS(2829),
    [anon_sym_u2237] = ACTIONS(2829),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(2829),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(2829),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(2731),
    [sym__cond_no_section_op] = ACTIONS(3229),
    [sym__cond_minus] = ACTIONS(2829),
    [sym__varsym] = ACTIONS(2829),
    [sym__consym] = ACTIONS(2737),
  },
  [1305] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(378),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(2852),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(181),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1306] = {
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(176),
    [sym__exp_signature] = STATE(4442),
    [sym__exp] = STATE(4592),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__paren_open] = STATE(416),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1307] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(178),
    [sym__exp_signature] = STATE(4312),
    [sym__exp] = STATE(4839),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1308] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10968),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1309] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(376),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(3619),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(209),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1310] = {
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(254),
    [sym__exp_signature] = STATE(5315),
    [sym__exp] = STATE(5465),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__paren_open] = STATE(402),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1311] = {
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(309),
    [sym__exp_signature] = STATE(5642),
    [sym__exp] = STATE(5649),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__paren_open] = STATE(400),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1312] = {
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(309),
    [sym__exp_signature] = STATE(5642),
    [sym__exp] = STATE(5533),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__paren_open] = STATE(400),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1313] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(178),
    [sym__exp_signature] = STATE(4312),
    [sym__exp] = STATE(4580),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1314] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(178),
    [sym__exp_signature] = STATE(4312),
    [sym__exp] = STATE(4605),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1315] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(178),
    [sym__exp_signature] = STATE(4312),
    [sym__exp] = STATE(4606),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1316] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(263),
    [sym__exp_signature] = STATE(5457),
    [sym__exp] = STATE(5196),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1317] = {
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(309),
    [sym__exp_signature] = STATE(5642),
    [sym__exp] = STATE(5546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__paren_open] = STATE(400),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1318] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(378),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(4479),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1257),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1319] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12741),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1320] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10906),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1321] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(50),
    [sym__exp_signature] = STATE(2952),
    [sym__exp] = STATE(2928),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1322] = {
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(309),
    [sym__exp_signature] = STATE(5642),
    [sym__exp] = STATE(5668),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__paren_open] = STATE(400),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1323] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(50),
    [sym__exp_signature] = STATE(2952),
    [sym__exp] = STATE(2907),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1324] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(263),
    [sym__exp_signature] = STATE(5457),
    [sym__exp] = STATE(5178),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1325] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(263),
    [sym__exp_signature] = STATE(5457),
    [sym__exp] = STATE(5192),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1326] = {
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(176),
    [sym__exp_signature] = STATE(4442),
    [sym__exp] = STATE(4608),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__paren_open] = STATE(416),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1327] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(10949),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1328] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(399),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(3526),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(205),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1329] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(182),
    [sym__exp_signature] = STATE(4573),
    [sym__exp] = STATE(4443),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1330] = {
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(176),
    [sym__exp_signature] = STATE(4442),
    [sym__exp] = STATE(4492),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__paren_open] = STATE(416),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1331] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12485),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1332] = {
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(176),
    [sym__exp_signature] = STATE(4442),
    [sym__exp] = STATE(4607),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__paren_open] = STATE(416),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1333] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8105),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(11654),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1334] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(11070),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1335] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(178),
    [sym__exp_signature] = STATE(4312),
    [sym__exp] = STATE(4676),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1336] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(178),
    [sym__exp_signature] = STATE(4312),
    [sym__exp] = STATE(4733),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1337] = {
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(254),
    [sym__exp_signature] = STATE(5315),
    [sym__exp] = STATE(5451),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__paren_open] = STATE(402),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1338] = {
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(254),
    [sym__exp_signature] = STATE(5315),
    [sym__exp] = STATE(5452),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__paren_open] = STATE(402),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1339] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12186),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1340] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(50),
    [sym__exp_signature] = STATE(2952),
    [sym__exp] = STATE(2959),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1341] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(391),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(4774),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1275),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1342] = {
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(273),
    [sym__exp_signature] = STATE(5504),
    [sym__exp] = STATE(5181),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__paren_open] = STATE(405),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1343] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(391),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(3672),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(197),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1344] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(390),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__paren_close] = STATE(2742),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(1279),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1345] = {
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(118),
    [sym__exp_signature] = STATE(4131),
    [sym__exp] = STATE(3965),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__paren_open] = STATE(406),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1346] = {
    [sym__at_type] = STATE(6585),
    [sym_explicit_type] = STATE(6590),
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(1234),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__constructor_ticked] = STATE(2296),
    [sym__qconstructor_ticked] = STATE(2296),
    [sym__varsym_prefix] = STATE(6638),
    [sym__pvarsym] = STATE(6638),
    [sym_constructor_operator] = STATE(2296),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_at] = STATE(2637),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(44),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(2713),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(3045),
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym_PIPE] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [anon_sym_POUND] = ACTIONS(3241),
    [anon_sym_POUND2] = ACTIONS(3045),
    [sym_name] = ACTIONS(1947),
    [anon_sym_COLON_COLON] = ACTIONS(3045),
    [anon_sym_u2237] = ACTIONS(3045),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(3045),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(2731),
    [sym__cond_no_section_op] = ACTIONS(3229),
    [sym__cond_minus] = ACTIONS(3045),
    [sym__varsym] = ACTIONS(3045),
    [sym__consym] = ACTIONS(2737),
  },
  [1347] = {
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(118),
    [sym__exp_signature] = STATE(4131),
    [sym__exp] = STATE(4007),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__paren_open] = STATE(406),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1348] = {
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(254),
    [sym__exp_signature] = STATE(5315),
    [sym__exp] = STATE(5425),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__paren_open] = STATE(402),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1349] = {
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(117),
    [sym__exp_signature] = STATE(8965),
    [sym__exp] = STATE(8986),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__paren_open] = STATE(406),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1350] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8142),
    [sym__type_signature] = STATE(9023),
    [sym__ktype] = STATE(10130),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = ACTIONS(1989),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1351] = {
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(176),
    [sym__exp_signature] = STATE(4442),
    [sym__exp] = STATE(4648),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__paren_open] = STATE(416),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1352] = {
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(273),
    [sym__exp_signature] = STATE(5504),
    [sym__exp] = STATE(5417),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__paren_open] = STATE(405),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1353] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(178),
    [sym__exp_signature] = STATE(4312),
    [sym__exp] = STATE(4781),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1354] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(178),
    [sym__exp_signature] = STATE(4312),
    [sym__exp] = STATE(4782),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1355] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8157),
    [sym__type_signature] = STATE(10256),
    [sym__ktype] = STATE(10864),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1356] = {
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(118),
    [sym__exp_signature] = STATE(4131),
    [sym__exp] = STATE(3935),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__paren_open] = STATE(406),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1357] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(61),
    [sym__exp_signature] = STATE(8313),
    [sym__exp] = STATE(12678),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1358] = {
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(118),
    [sym__exp_signature] = STATE(4131),
    [sym__exp] = STATE(3945),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__paren_open] = STATE(406),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1359] = {
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(118),
    [sym__exp_signature] = STATE(4131),
    [sym__exp] = STATE(3946),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__paren_open] = STATE(406),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1360] = {
    [sym__type_parens] = STATE(7722),
    [sym__type_tuple] = STATE(7721),
    [sym__type_unboxed_tuple] = STATE(7686),
    [sym__type_unboxed_sum] = STATE(7703),
    [sym__type_list] = STATE(7696),
    [sym__type_promoted] = STATE(7670),
    [sym__type_star] = STATE(7670),
    [sym__type_wildcard] = STATE(7670),
    [sym__at_type] = STATE(7627),
    [sym__type_apply] = STATE(7690),
    [sym__type_infix] = STATE(7716),
    [sym_type] = STATE(1360),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8426),
    [sym__splice_dollars] = STATE(7311),
    [sym_splice] = STATE(7670),
    [sym_quasiquote] = STATE(7670),
    [sym_integer] = STATE(7653),
    [sym__plist] = STATE(7676),
    [sym_unit] = STATE(7670),
    [sym_unboxed_unit] = STATE(7670),
    [sym_prefix_tuple] = STATE(7670),
    [sym_prefix_unboxed_tuple] = STATE(7670),
    [sym_prefix_unboxed_sum] = STATE(7670),
    [sym_literal] = STATE(7670),
    [sym__qualified_type] = STATE(7677),
    [sym__qtyconid] = STATE(7664),
    [sym__tycon_arrow] = STATE(7664),
    [sym__qtycon_arrow] = STATE(7664),
    [sym__promoted_tycons_alias] = STATE(7670),
    [sym__promoted_tycons] = STATE(7670),
    [sym__tycon_ticked] = STATE(2593),
    [sym__qtycon_ticked] = STATE(2593),
    [sym__tyconids_ticked] = STATE(2593),
    [sym__promoted_tyconops_alias] = STATE(2593),
    [sym__promoted_tyconops] = STATE(2593),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2593),
    [sym__operator_alias] = STATE(2593),
    [sym__operator_minus] = STATE(2593),
    [sym__varsym_prefix] = STATE(7664),
    [sym__pvarsym] = STATE(7664),
    [sym__qualified_varsym] = STATE(2594),
    [sym__qvarsym_prefix] = STATE(7664),
    [sym__pqvarsym] = STATE(7664),
    [sym_constructor_operator] = STATE(2593),
    [sym__constructor_operator_alias] = STATE(2593),
    [sym__consym_prefix] = STATE(7664),
    [sym__pconsym] = STATE(7664),
    [sym__qualified_consym] = STATE(2595),
    [sym__qconsym_prefix] = STATE(7664),
    [sym__pqconsym] = STATE(7664),
    [sym__prefix_at] = STATE(2512),
    [sym__paren_open] = STATE(463),
    [sym__bracket_open] = STATE(1066),
    [sym__unboxed_open] = STATE(825),
    [sym_variable] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1119),
    [sym__cond_layout_end] = ACTIONS(1119),
    [sym__cond_layout_end_explicit] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [1361] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8262),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(3243),
    [anon_sym_LBRACE] = ACTIONS(3245),
    [anon_sym__] = ACTIONS(3243),
    [anon_sym_SQUOTE] = ACTIONS(3243),
    [anon_sym_STAR] = ACTIONS(3245),
    [anon_sym_u2605] = ACTIONS(3245),
    [anon_sym_forall] = ACTIONS(3243),
    [anon_sym_u2200] = ACTIONS(3245),
    [anon_sym_LBRACK] = ACTIONS(3245),
    [sym_float] = ACTIONS(3245),
    [sym_char] = ACTIONS(3245),
    [sym_string] = ACTIONS(3245),
    [sym__integer_literal] = ACTIONS(3243),
    [sym__binary_literal] = ACTIONS(3245),
    [sym__octal_literal] = ACTIONS(3245),
    [sym__hex_literal] = ACTIONS(3245),
    [sym_implicit_variable] = ACTIONS(3245),
    [sym_name] = ACTIONS(3245),
    [aux_sym__paren_open_token1] = ACTIONS(3245),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3245),
    [sym__cond_splice] = ACTIONS(3245),
    [sym__cond_tight_bang] = ACTIONS(3245),
    [sym__cond_prefix_bang] = ACTIONS(3245),
    [sym__cond_tight_tilde] = ACTIONS(3245),
    [sym__cond_prefix_tilde] = ACTIONS(3245),
    [sym__cond_context] = ACTIONS(3245),
  },
  [1362] = {
    [sym__at_type] = STATE(6735),
    [sym_explicit_type] = STATE(6738),
    [sym__pat_parens] = STATE(6709),
    [sym__pat_tuple] = STATE(6707),
    [sym__pat_unboxed_tuple] = STATE(6706),
    [sym__pat_unboxed_sum] = STATE(6705),
    [sym__pat_list] = STATE(6704),
    [sym__pat_record] = STATE(6703),
    [sym__pat_as] = STATE(6702),
    [sym__pat_wildcard] = STATE(6701),
    [sym__pat_strict] = STATE(6700),
    [sym__pat_irrefutable] = STATE(6699),
    [sym__pat_apply] = STATE(6772),
    [sym__pat_negation] = STATE(6711),
    [sym__pat_infix] = STATE(6715),
    [sym_pattern] = STATE(1364),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11259),
    [sym__splice_dollars] = STATE(7313),
    [sym_splice] = STATE(6701),
    [sym_quasiquote] = STATE(6701),
    [sym_integer] = STATE(6231),
    [sym__plist] = STATE(6728),
    [sym_unit] = STATE(6701),
    [sym_unboxed_unit] = STATE(6701),
    [sym_prefix_tuple] = STATE(6701),
    [sym_prefix_unboxed_tuple] = STATE(6701),
    [sym_prefix_unboxed_sum] = STATE(6701),
    [sym_literal] = STATE(6701),
    [sym__qualified_constructor] = STATE(6223),
    [sym__qconid] = STATE(6701),
    [sym__constructor_ticked] = STATE(2251),
    [sym__qconstructor_ticked] = STATE(2251),
    [sym__varsym_prefix] = STATE(6729),
    [sym__pvarsym] = STATE(6729),
    [sym_constructor_operator] = STATE(2251),
    [sym__consym_prefix] = STATE(6731),
    [sym__pconsym] = STATE(6731),
    [sym__qconsym_prefix] = STATE(6701),
    [sym__pqconsym] = STATE(6701),
    [sym__prefix_at] = STATE(2417),
    [sym__prefix_bang] = STATE(2257),
    [sym__tight_bang] = STATE(2257),
    [sym__any_prefix_bang] = STATE(2257),
    [sym__prefix_tilde] = STATE(2258),
    [sym__tight_tilde] = STATE(2258),
    [sym__any_prefix_tilde] = STATE(2258),
    [sym__paren_open] = STATE(41),
    [sym__bracket_open] = STATE(369),
    [sym__unboxed_open] = STATE(193),
    [sym_variable] = ACTIONS(3013),
    [anon_sym_COMMA] = ACTIONS(3015),
    [anon_sym_LBRACE] = ACTIONS(2803),
    [anon_sym__] = ACTIONS(3013),
    [anon_sym_STAR] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [sym_float] = ACTIONS(3015),
    [sym_char] = ACTIONS(3015),
    [sym_string] = ACTIONS(3015),
    [sym__integer_literal] = ACTIONS(3013),
    [sym__binary_literal] = ACTIONS(3015),
    [sym__octal_literal] = ACTIONS(3015),
    [sym__hex_literal] = ACTIONS(3015),
    [anon_sym_BQUOTE] = ACTIONS(3015),
    [anon_sym_POUND] = ACTIONS(3013),
    [anon_sym_POUND2] = ACTIONS(3015),
    [sym_name] = ACTIONS(3015),
    [anon_sym_COLON_COLON] = ACTIONS(3015),
    [anon_sym_u2237] = ACTIONS(3015),
    [aux_sym__paren_open_token1] = ACTIONS(3015),
    [aux_sym__paren_close_token1] = ACTIONS(3015),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3015),
    [sym__cond_splice] = ACTIONS(3015),
    [sym__cond_prefix_dot] = ACTIONS(3015),
    [sym__cond_prefix_at] = ACTIONS(3015),
    [sym__cond_tight_bang] = ACTIONS(3015),
    [sym__cond_prefix_bang] = ACTIONS(3015),
    [sym__cond_tight_tilde] = ACTIONS(3015),
    [sym__cond_prefix_tilde] = ACTIONS(3015),
    [sym__cond_qualified_op] = ACTIONS(3015),
    [sym__cond_no_section_op] = ACTIONS(3015),
    [sym__cond_minus] = ACTIONS(3015),
    [sym__varsym] = ACTIONS(3015),
    [sym__consym] = ACTIONS(3015),
  },
  [1363] = {
    [sym__at_type] = STATE(6735),
    [sym_explicit_type] = STATE(6738),
    [sym__pat_parens] = STATE(6709),
    [sym__pat_tuple] = STATE(6707),
    [sym__pat_unboxed_tuple] = STATE(6706),
    [sym__pat_unboxed_sum] = STATE(6705),
    [sym__pat_list] = STATE(6704),
    [sym__pat_record] = STATE(6703),
    [sym__pat_as] = STATE(6702),
    [sym__pat_wildcard] = STATE(6701),
    [sym__pat_strict] = STATE(6700),
    [sym__pat_irrefutable] = STATE(6699),
    [sym__pat_apply] = STATE(6772),
    [sym__pat_negation] = STATE(6711),
    [sym__pat_infix] = STATE(6715),
    [sym_pattern] = STATE(1364),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11259),
    [sym__splice_dollars] = STATE(7313),
    [sym_splice] = STATE(6701),
    [sym_quasiquote] = STATE(6701),
    [sym_integer] = STATE(6231),
    [sym__plist] = STATE(6728),
    [sym_unit] = STATE(6701),
    [sym_unboxed_unit] = STATE(6701),
    [sym_prefix_tuple] = STATE(6701),
    [sym_prefix_unboxed_tuple] = STATE(6701),
    [sym_prefix_unboxed_sum] = STATE(6701),
    [sym_literal] = STATE(6701),
    [sym__qualified_constructor] = STATE(6223),
    [sym__qconid] = STATE(6701),
    [sym__constructor_ticked] = STATE(2251),
    [sym__qconstructor_ticked] = STATE(2251),
    [sym__varsym_prefix] = STATE(6729),
    [sym__pvarsym] = STATE(6729),
    [sym_constructor_operator] = STATE(2251),
    [sym__consym_prefix] = STATE(6731),
    [sym__pconsym] = STATE(6731),
    [sym__qconsym_prefix] = STATE(6701),
    [sym__pqconsym] = STATE(6701),
    [sym__prefix_at] = STATE(2417),
    [sym__prefix_bang] = STATE(2257),
    [sym__tight_bang] = STATE(2257),
    [sym__any_prefix_bang] = STATE(2257),
    [sym__prefix_tilde] = STATE(2258),
    [sym__tight_tilde] = STATE(2258),
    [sym__any_prefix_tilde] = STATE(2258),
    [sym__paren_open] = STATE(41),
    [sym__bracket_open] = STATE(369),
    [sym__unboxed_open] = STATE(193),
    [sym_variable] = ACTIONS(3009),
    [anon_sym_COMMA] = ACTIONS(3011),
    [anon_sym_LBRACE] = ACTIONS(2803),
    [anon_sym__] = ACTIONS(3009),
    [anon_sym_STAR] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3011),
    [anon_sym_LBRACK] = ACTIONS(3011),
    [sym_float] = ACTIONS(3011),
    [sym_char] = ACTIONS(3011),
    [sym_string] = ACTIONS(3011),
    [sym__integer_literal] = ACTIONS(3009),
    [sym__binary_literal] = ACTIONS(3011),
    [sym__octal_literal] = ACTIONS(3011),
    [sym__hex_literal] = ACTIONS(3011),
    [anon_sym_BQUOTE] = ACTIONS(3011),
    [anon_sym_POUND] = ACTIONS(3009),
    [anon_sym_POUND2] = ACTIONS(3011),
    [sym_name] = ACTIONS(3011),
    [anon_sym_COLON_COLON] = ACTIONS(3011),
    [anon_sym_u2237] = ACTIONS(3011),
    [aux_sym__paren_open_token1] = ACTIONS(3011),
    [aux_sym__paren_close_token1] = ACTIONS(3011),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3011),
    [sym__cond_splice] = ACTIONS(3011),
    [sym__cond_prefix_dot] = ACTIONS(3011),
    [sym__cond_prefix_at] = ACTIONS(3011),
    [sym__cond_tight_bang] = ACTIONS(3011),
    [sym__cond_prefix_bang] = ACTIONS(3011),
    [sym__cond_tight_tilde] = ACTIONS(3011),
    [sym__cond_prefix_tilde] = ACTIONS(3011),
    [sym__cond_qualified_op] = ACTIONS(3011),
    [sym__cond_no_section_op] = ACTIONS(3011),
    [sym__cond_minus] = ACTIONS(3011),
    [sym__varsym] = ACTIONS(3011),
    [sym__consym] = ACTIONS(3011),
  },
  [1364] = {
    [sym__at_type] = STATE(6735),
    [sym_explicit_type] = STATE(6738),
    [sym__pat_parens] = STATE(6709),
    [sym__pat_tuple] = STATE(6707),
    [sym__pat_unboxed_tuple] = STATE(6706),
    [sym__pat_unboxed_sum] = STATE(6705),
    [sym__pat_list] = STATE(6704),
    [sym__pat_record] = STATE(6703),
    [sym__pat_as] = STATE(6702),
    [sym__pat_wildcard] = STATE(6701),
    [sym__pat_strict] = STATE(6700),
    [sym__pat_irrefutable] = STATE(6699),
    [sym__pat_apply] = STATE(6772),
    [sym__pat_negation] = STATE(6711),
    [sym__pat_infix] = STATE(6715),
    [sym_pattern] = STATE(1364),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11259),
    [sym__splice_dollars] = STATE(7313),
    [sym_splice] = STATE(6701),
    [sym_quasiquote] = STATE(6701),
    [sym_integer] = STATE(6231),
    [sym__plist] = STATE(6728),
    [sym_unit] = STATE(6701),
    [sym_unboxed_unit] = STATE(6701),
    [sym_prefix_tuple] = STATE(6701),
    [sym_prefix_unboxed_tuple] = STATE(6701),
    [sym_prefix_unboxed_sum] = STATE(6701),
    [sym_literal] = STATE(6701),
    [sym__qualified_constructor] = STATE(6223),
    [sym__qconid] = STATE(6701),
    [sym__constructor_ticked] = STATE(2251),
    [sym__qconstructor_ticked] = STATE(2251),
    [sym__varsym_prefix] = STATE(6729),
    [sym__pvarsym] = STATE(6729),
    [sym_constructor_operator] = STATE(2251),
    [sym__consym_prefix] = STATE(6731),
    [sym__pconsym] = STATE(6731),
    [sym__qconsym_prefix] = STATE(6701),
    [sym__pqconsym] = STATE(6701),
    [sym__prefix_at] = STATE(2417),
    [sym__prefix_bang] = STATE(2257),
    [sym__tight_bang] = STATE(2257),
    [sym__any_prefix_bang] = STATE(2257),
    [sym__prefix_tilde] = STATE(2258),
    [sym__tight_tilde] = STATE(2258),
    [sym__any_prefix_tilde] = STATE(2258),
    [sym__paren_open] = STATE(41),
    [sym__bracket_open] = STATE(369),
    [sym__unboxed_open] = STATE(193),
    [sym_variable] = ACTIONS(3005),
    [anon_sym_COMMA] = ACTIONS(3007),
    [anon_sym_LBRACE] = ACTIONS(2803),
    [anon_sym__] = ACTIONS(3005),
    [anon_sym_STAR] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [sym_float] = ACTIONS(3007),
    [sym_char] = ACTIONS(3007),
    [sym_string] = ACTIONS(3007),
    [sym__integer_literal] = ACTIONS(3005),
    [sym__binary_literal] = ACTIONS(3007),
    [sym__octal_literal] = ACTIONS(3007),
    [sym__hex_literal] = ACTIONS(3007),
    [anon_sym_BQUOTE] = ACTIONS(3007),
    [anon_sym_POUND] = ACTIONS(3005),
    [anon_sym_POUND2] = ACTIONS(3007),
    [sym_name] = ACTIONS(3007),
    [anon_sym_COLON_COLON] = ACTIONS(3007),
    [anon_sym_u2237] = ACTIONS(3007),
    [aux_sym__paren_open_token1] = ACTIONS(3007),
    [aux_sym__paren_close_token1] = ACTIONS(3007),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3007),
    [sym__cond_splice] = ACTIONS(3007),
    [sym__cond_prefix_dot] = ACTIONS(3007),
    [sym__cond_prefix_at] = ACTIONS(3007),
    [sym__cond_tight_bang] = ACTIONS(3007),
    [sym__cond_prefix_bang] = ACTIONS(3007),
    [sym__cond_tight_tilde] = ACTIONS(3007),
    [sym__cond_prefix_tilde] = ACTIONS(3007),
    [sym__cond_qualified_op] = ACTIONS(3007),
    [sym__cond_no_section_op] = ACTIONS(3007),
    [sym__cond_minus] = ACTIONS(3007),
    [sym__varsym] = ACTIONS(3007),
    [sym__consym] = ACTIONS(3007),
  },
  [1365] = {
    [sym__type_parens] = STATE(7722),
    [sym__type_tuple] = STATE(7721),
    [sym__type_unboxed_tuple] = STATE(7686),
    [sym__type_unboxed_sum] = STATE(7703),
    [sym__type_list] = STATE(7696),
    [sym__type_promoted] = STATE(7670),
    [sym__type_star] = STATE(7670),
    [sym__type_wildcard] = STATE(7670),
    [sym__at_type] = STATE(7627),
    [sym__type_apply] = STATE(7690),
    [sym__type_infix] = STATE(7716),
    [sym_type] = STATE(1360),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8426),
    [sym__splice_dollars] = STATE(7311),
    [sym_splice] = STATE(7670),
    [sym_quasiquote] = STATE(7670),
    [sym_integer] = STATE(7653),
    [sym__plist] = STATE(7676),
    [sym_unit] = STATE(7670),
    [sym_unboxed_unit] = STATE(7670),
    [sym_prefix_tuple] = STATE(7670),
    [sym_prefix_unboxed_tuple] = STATE(7670),
    [sym_prefix_unboxed_sum] = STATE(7670),
    [sym_literal] = STATE(7670),
    [sym__qualified_type] = STATE(7677),
    [sym__qtyconid] = STATE(7664),
    [sym__tycon_arrow] = STATE(7664),
    [sym__qtycon_arrow] = STATE(7664),
    [sym__promoted_tycons_alias] = STATE(7670),
    [sym__promoted_tycons] = STATE(7670),
    [sym__tycon_ticked] = STATE(2593),
    [sym__qtycon_ticked] = STATE(2593),
    [sym__tyconids_ticked] = STATE(2593),
    [sym__promoted_tyconops_alias] = STATE(2593),
    [sym__promoted_tyconops] = STATE(2593),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2593),
    [sym__operator_alias] = STATE(2593),
    [sym__operator_minus] = STATE(2593),
    [sym__varsym_prefix] = STATE(7664),
    [sym__pvarsym] = STATE(7664),
    [sym__qualified_varsym] = STATE(2594),
    [sym__qvarsym_prefix] = STATE(7664),
    [sym__pqvarsym] = STATE(7664),
    [sym_constructor_operator] = STATE(2593),
    [sym__constructor_operator_alias] = STATE(2593),
    [sym__consym_prefix] = STATE(7664),
    [sym__pconsym] = STATE(7664),
    [sym__qualified_consym] = STATE(2595),
    [sym__qconsym_prefix] = STATE(7664),
    [sym__pqconsym] = STATE(7664),
    [sym__prefix_at] = STATE(2512),
    [sym__paren_open] = STATE(463),
    [sym__bracket_open] = STATE(1066),
    [sym__unboxed_open] = STATE(825),
    [sym_variable] = ACTIONS(3247),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym__] = ACTIONS(3249),
    [anon_sym_SQUOTE] = ACTIONS(3251),
    [anon_sym_STAR] = ACTIONS(3253),
    [anon_sym_u2605] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3257),
    [sym_char] = ACTIONS(3257),
    [sym_string] = ACTIONS(3257),
    [sym__integer_literal] = ACTIONS(3259),
    [sym__binary_literal] = ACTIONS(3261),
    [sym__octal_literal] = ACTIONS(3261),
    [sym__hex_literal] = ACTIONS(3261),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(3263),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1157),
    [sym__cond_layout_end] = ACTIONS(1157),
    [sym__cond_layout_end_explicit] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3265),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1366] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(251),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(3731),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__paren_open] = STATE(404),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(3267),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(155),
    [sym__binary_literal] = ACTIONS(157),
    [sym__octal_literal] = ACTIONS(157),
    [sym__hex_literal] = ACTIONS(157),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(3269),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1367] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8216),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(3271),
    [anon_sym_LBRACE] = ACTIONS(3273),
    [anon_sym__] = ACTIONS(3271),
    [anon_sym_SQUOTE] = ACTIONS(3271),
    [anon_sym_STAR] = ACTIONS(3273),
    [anon_sym_u2605] = ACTIONS(3273),
    [anon_sym_forall] = ACTIONS(3271),
    [anon_sym_u2200] = ACTIONS(3273),
    [anon_sym_LBRACK] = ACTIONS(3273),
    [sym_float] = ACTIONS(3273),
    [sym_char] = ACTIONS(3273),
    [sym_string] = ACTIONS(3273),
    [sym__integer_literal] = ACTIONS(3271),
    [sym__binary_literal] = ACTIONS(3273),
    [sym__octal_literal] = ACTIONS(3273),
    [sym__hex_literal] = ACTIONS(3273),
    [sym_implicit_variable] = ACTIONS(3273),
    [sym_name] = ACTIONS(3273),
    [aux_sym__paren_open_token1] = ACTIONS(3273),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3273),
    [sym__cond_splice] = ACTIONS(3273),
    [sym__cond_tight_bang] = ACTIONS(3273),
    [sym__cond_prefix_bang] = ACTIONS(3273),
    [sym__cond_tight_tilde] = ACTIONS(3273),
    [sym__cond_prefix_tilde] = ACTIONS(3273),
    [sym__cond_context] = ACTIONS(3273),
  },
  [1368] = {
    [sym__type_parens] = STATE(7722),
    [sym__type_tuple] = STATE(7721),
    [sym__type_unboxed_tuple] = STATE(7686),
    [sym__type_unboxed_sum] = STATE(7703),
    [sym__type_list] = STATE(7696),
    [sym__type_promoted] = STATE(7670),
    [sym__type_star] = STATE(7670),
    [sym__type_wildcard] = STATE(7670),
    [sym__at_type] = STATE(7627),
    [sym__type_apply] = STATE(7690),
    [sym__type_infix] = STATE(7716),
    [sym_type] = STATE(1360),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8426),
    [sym__splice_dollars] = STATE(7311),
    [sym_splice] = STATE(7670),
    [sym_quasiquote] = STATE(7670),
    [sym_integer] = STATE(7653),
    [sym__plist] = STATE(7676),
    [sym_unit] = STATE(7670),
    [sym_unboxed_unit] = STATE(7670),
    [sym_prefix_tuple] = STATE(7670),
    [sym_prefix_unboxed_tuple] = STATE(7670),
    [sym_prefix_unboxed_sum] = STATE(7670),
    [sym_literal] = STATE(7670),
    [sym__qualified_type] = STATE(7677),
    [sym__qtyconid] = STATE(7664),
    [sym__tycon_arrow] = STATE(7664),
    [sym__qtycon_arrow] = STATE(7664),
    [sym__promoted_tycons_alias] = STATE(7670),
    [sym__promoted_tycons] = STATE(7670),
    [sym__tycon_ticked] = STATE(2593),
    [sym__qtycon_ticked] = STATE(2593),
    [sym__tyconids_ticked] = STATE(2593),
    [sym__promoted_tyconops_alias] = STATE(2593),
    [sym__promoted_tyconops] = STATE(2593),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2593),
    [sym__operator_alias] = STATE(2593),
    [sym__operator_minus] = STATE(2593),
    [sym__varsym_prefix] = STATE(7664),
    [sym__pvarsym] = STATE(7664),
    [sym__qualified_varsym] = STATE(2594),
    [sym__qvarsym_prefix] = STATE(7664),
    [sym__pqvarsym] = STATE(7664),
    [sym_constructor_operator] = STATE(2593),
    [sym__constructor_operator_alias] = STATE(2593),
    [sym__consym_prefix] = STATE(7664),
    [sym__pconsym] = STATE(7664),
    [sym__qualified_consym] = STATE(2595),
    [sym__qconsym_prefix] = STATE(7664),
    [sym__pqconsym] = STATE(7664),
    [sym__prefix_at] = STATE(2512),
    [sym__paren_open] = STATE(463),
    [sym__bracket_open] = STATE(1066),
    [sym__unboxed_open] = STATE(825),
    [sym_variable] = ACTIONS(2599),
    [anon_sym_SEMI] = ACTIONS(2601),
    [anon_sym__] = ACTIONS(2599),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [anon_sym_STAR] = ACTIONS(2601),
    [anon_sym_u2605] = ACTIONS(2601),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(2601),
    [sym_float] = ACTIONS(2601),
    [sym_char] = ACTIONS(2601),
    [sym_string] = ACTIONS(2601),
    [sym__integer_literal] = ACTIONS(2599),
    [sym__binary_literal] = ACTIONS(2601),
    [sym__octal_literal] = ACTIONS(2601),
    [sym__hex_literal] = ACTIONS(2601),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2601),
    [aux_sym__paren_open_token1] = ACTIONS(2601),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(2601),
    [sym__cond_layout_end] = ACTIONS(2601),
    [sym__cond_layout_end_explicit] = ACTIONS(2601),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2601),
    [sym__cond_splice] = ACTIONS(2601),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(2601),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1369] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10717),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10716),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10716),
    [sym__local_decl] = STATE(10716),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3275),
    [sym__cond_layout_end_explicit] = ACTIONS(3275),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1370] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10754),
    [sym__assoc_tyinst] = STATE(10389),
    [sym__assoc_datainst_adt] = STATE(10386),
    [sym__assoc_datainst_newtype] = STATE(10381),
    [sym__assoc_datainst] = STATE(10379),
    [sym_instance_decl] = STATE(10756),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10379),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_newtype] = ACTIONS(2911),
    [anon_sym_data] = ACTIONS(2913),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3129),
    [sym__cond_layout_end_explicit] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1371] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2599),
    [anon_sym__] = ACTIONS(2599),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [anon_sym_STAR] = ACTIONS(2601),
    [anon_sym_u2605] = ACTIONS(2601),
    [anon_sym_EQ] = ACTIONS(2601),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(2601),
    [sym_float] = ACTIONS(2601),
    [sym_char] = ACTIONS(2601),
    [sym_string] = ACTIONS(2601),
    [sym__integer_literal] = ACTIONS(2599),
    [sym__binary_literal] = ACTIONS(2601),
    [sym__octal_literal] = ACTIONS(2601),
    [sym__hex_literal] = ACTIONS(2601),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2601),
    [anon_sym_COLON_COLON] = ACTIONS(2601),
    [anon_sym_u2237] = ACTIONS(2601),
    [aux_sym__paren_open_token1] = ACTIONS(2601),
    [aux_sym__paren_close_token1] = ACTIONS(2601),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2601),
    [sym__cond_splice] = ACTIONS(2601),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(2601),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1372] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8215),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(3277),
    [anon_sym_LBRACE] = ACTIONS(3279),
    [anon_sym__] = ACTIONS(3277),
    [anon_sym_SQUOTE] = ACTIONS(3277),
    [anon_sym_STAR] = ACTIONS(3279),
    [anon_sym_u2605] = ACTIONS(3279),
    [anon_sym_forall] = ACTIONS(3277),
    [anon_sym_u2200] = ACTIONS(3279),
    [anon_sym_LBRACK] = ACTIONS(3279),
    [sym_float] = ACTIONS(3279),
    [sym_char] = ACTIONS(3279),
    [sym_string] = ACTIONS(3279),
    [sym__integer_literal] = ACTIONS(3277),
    [sym__binary_literal] = ACTIONS(3279),
    [sym__octal_literal] = ACTIONS(3279),
    [sym__hex_literal] = ACTIONS(3279),
    [sym_implicit_variable] = ACTIONS(3279),
    [sym_name] = ACTIONS(3279),
    [aux_sym__paren_open_token1] = ACTIONS(3279),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3279),
    [sym__cond_splice] = ACTIONS(3279),
    [sym__cond_tight_bang] = ACTIONS(3279),
    [sym__cond_prefix_bang] = ACTIONS(3279),
    [sym__cond_tight_tilde] = ACTIONS(3279),
    [sym__cond_prefix_tilde] = ACTIONS(3279),
    [sym__cond_context] = ACTIONS(3279),
  },
  [1373] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10455),
    [sym__assoc_tyinst] = STATE(10389),
    [sym__assoc_datainst_adt] = STATE(10386),
    [sym__assoc_datainst_newtype] = STATE(10381),
    [sym__assoc_datainst] = STATE(10379),
    [sym_instance_decl] = STATE(10756),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10379),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_newtype] = ACTIONS(2911),
    [anon_sym_data] = ACTIONS(2913),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3281),
    [sym__cond_layout_end_explicit] = ACTIONS(3281),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1374] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(55),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(3269),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1375] = {
    [sym__type_parens] = STATE(7722),
    [sym__type_tuple] = STATE(7721),
    [sym__type_unboxed_tuple] = STATE(7686),
    [sym__type_unboxed_sum] = STATE(7703),
    [sym__type_list] = STATE(7696),
    [sym__type_promoted] = STATE(7670),
    [sym__type_star] = STATE(7670),
    [sym__type_wildcard] = STATE(7670),
    [sym__at_type] = STATE(7627),
    [sym__type_apply] = STATE(7690),
    [sym__type_infix] = STATE(7716),
    [sym_type] = STATE(1360),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8426),
    [sym__splice_dollars] = STATE(7311),
    [sym_splice] = STATE(7670),
    [sym_quasiquote] = STATE(7670),
    [sym_integer] = STATE(7653),
    [sym__plist] = STATE(7676),
    [sym_unit] = STATE(7670),
    [sym_unboxed_unit] = STATE(7670),
    [sym_prefix_tuple] = STATE(7670),
    [sym_prefix_unboxed_tuple] = STATE(7670),
    [sym_prefix_unboxed_sum] = STATE(7670),
    [sym_literal] = STATE(7670),
    [sym__qualified_type] = STATE(7677),
    [sym__qtyconid] = STATE(7664),
    [sym__tycon_arrow] = STATE(7664),
    [sym__qtycon_arrow] = STATE(7664),
    [sym__promoted_tycons_alias] = STATE(7670),
    [sym__promoted_tycons] = STATE(7670),
    [sym__tycon_ticked] = STATE(2593),
    [sym__qtycon_ticked] = STATE(2593),
    [sym__tyconids_ticked] = STATE(2593),
    [sym__promoted_tyconops_alias] = STATE(2593),
    [sym__promoted_tyconops] = STATE(2593),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2593),
    [sym__operator_alias] = STATE(2593),
    [sym__operator_minus] = STATE(2593),
    [sym__varsym_prefix] = STATE(7664),
    [sym__pvarsym] = STATE(7664),
    [sym__qualified_varsym] = STATE(2594),
    [sym__qvarsym_prefix] = STATE(7664),
    [sym__pqvarsym] = STATE(7664),
    [sym_constructor_operator] = STATE(2593),
    [sym__constructor_operator_alias] = STATE(2593),
    [sym__consym_prefix] = STATE(7664),
    [sym__pconsym] = STATE(7664),
    [sym__qualified_consym] = STATE(2595),
    [sym__qconsym_prefix] = STATE(7664),
    [sym__pqconsym] = STATE(7664),
    [sym__prefix_at] = STATE(2512),
    [sym__paren_open] = STATE(463),
    [sym__bracket_open] = STATE(1066),
    [sym__unboxed_open] = STATE(825),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1376] = {
    [sym__at_type] = STATE(6735),
    [sym_explicit_type] = STATE(6738),
    [sym__pat_parens] = STATE(6709),
    [sym__pat_tuple] = STATE(6707),
    [sym__pat_unboxed_tuple] = STATE(6706),
    [sym__pat_unboxed_sum] = STATE(6705),
    [sym__pat_list] = STATE(6704),
    [sym__pat_record] = STATE(6703),
    [sym__pat_as] = STATE(6702),
    [sym__pat_wildcard] = STATE(6701),
    [sym__pat_strict] = STATE(6700),
    [sym__pat_irrefutable] = STATE(6699),
    [sym__pat_apply] = STATE(6772),
    [sym__pat_negation] = STATE(6711),
    [sym__pat_infix] = STATE(6715),
    [sym_pattern] = STATE(1364),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11259),
    [sym__splice_dollars] = STATE(7313),
    [sym_splice] = STATE(6701),
    [sym_quasiquote] = STATE(6701),
    [sym_integer] = STATE(6231),
    [sym__plist] = STATE(6728),
    [sym_unit] = STATE(6701),
    [sym_unboxed_unit] = STATE(6701),
    [sym_prefix_tuple] = STATE(6701),
    [sym_prefix_unboxed_tuple] = STATE(6701),
    [sym_prefix_unboxed_sum] = STATE(6701),
    [sym_literal] = STATE(6701),
    [sym__qualified_constructor] = STATE(6223),
    [sym__qconid] = STATE(6701),
    [sym__constructor_ticked] = STATE(2251),
    [sym__qconstructor_ticked] = STATE(2251),
    [sym__varsym_prefix] = STATE(6729),
    [sym__pvarsym] = STATE(6729),
    [sym_constructor_operator] = STATE(2251),
    [sym__consym_prefix] = STATE(6731),
    [sym__pconsym] = STATE(6731),
    [sym__qconsym_prefix] = STATE(6701),
    [sym__pqconsym] = STATE(6701),
    [sym__prefix_at] = STATE(2417),
    [sym__prefix_bang] = STATE(2257),
    [sym__tight_bang] = STATE(2257),
    [sym__any_prefix_bang] = STATE(2257),
    [sym__prefix_tilde] = STATE(2258),
    [sym__tight_tilde] = STATE(2258),
    [sym__any_prefix_tilde] = STATE(2258),
    [sym__paren_open] = STATE(41),
    [sym__bracket_open] = STATE(369),
    [sym__unboxed_open] = STATE(193),
    [sym_variable] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2803),
    [anon_sym__] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2467),
    [sym_char] = ACTIONS(2467),
    [sym_string] = ACTIONS(2467),
    [sym__integer_literal] = ACTIONS(2469),
    [sym__binary_literal] = ACTIONS(2471),
    [sym__octal_literal] = ACTIONS(2471),
    [sym__hex_literal] = ACTIONS(2471),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [anon_sym_POUND] = ACTIONS(3227),
    [anon_sym_POUND2] = ACTIONS(2899),
    [sym_name] = ACTIONS(2807),
    [anon_sym_COLON_COLON] = ACTIONS(2899),
    [anon_sym_u2237] = ACTIONS(2899),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(2899),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2475),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(2899),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(2811),
    [sym__cond_no_section_op] = ACTIONS(3283),
    [sym__cond_minus] = ACTIONS(2899),
    [sym__varsym] = ACTIONS(2899),
    [sym__consym] = ACTIONS(2737),
  },
  [1377] = {
    [sym__at_type] = STATE(6735),
    [sym_explicit_type] = STATE(6738),
    [sym__pat_parens] = STATE(6709),
    [sym__pat_tuple] = STATE(6707),
    [sym__pat_unboxed_tuple] = STATE(6706),
    [sym__pat_unboxed_sum] = STATE(6705),
    [sym__pat_list] = STATE(6704),
    [sym__pat_record] = STATE(6703),
    [sym__pat_as] = STATE(6702),
    [sym__pat_wildcard] = STATE(6701),
    [sym__pat_strict] = STATE(6700),
    [sym__pat_irrefutable] = STATE(6699),
    [sym__pat_apply] = STATE(6772),
    [sym__pat_negation] = STATE(6711),
    [sym__pat_infix] = STATE(6715),
    [sym_pattern] = STATE(1364),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11259),
    [sym__splice_dollars] = STATE(7313),
    [sym_splice] = STATE(6701),
    [sym_quasiquote] = STATE(6701),
    [sym_integer] = STATE(6231),
    [sym__plist] = STATE(6728),
    [sym_unit] = STATE(6701),
    [sym_unboxed_unit] = STATE(6701),
    [sym_prefix_tuple] = STATE(6701),
    [sym_prefix_unboxed_tuple] = STATE(6701),
    [sym_prefix_unboxed_sum] = STATE(6701),
    [sym_literal] = STATE(6701),
    [sym__qualified_constructor] = STATE(6223),
    [sym__qconid] = STATE(6701),
    [sym__constructor_ticked] = STATE(2251),
    [sym__qconstructor_ticked] = STATE(2251),
    [sym__varsym_prefix] = STATE(6729),
    [sym__pvarsym] = STATE(6729),
    [sym_constructor_operator] = STATE(2251),
    [sym__consym_prefix] = STATE(6731),
    [sym__pconsym] = STATE(6731),
    [sym__qconsym_prefix] = STATE(6701),
    [sym__pqconsym] = STATE(6701),
    [sym__prefix_at] = STATE(2417),
    [sym__prefix_bang] = STATE(2257),
    [sym__tight_bang] = STATE(2257),
    [sym__any_prefix_bang] = STATE(2257),
    [sym__prefix_tilde] = STATE(2258),
    [sym__tight_tilde] = STATE(2258),
    [sym__any_prefix_tilde] = STATE(2258),
    [sym__paren_open] = STATE(41),
    [sym__bracket_open] = STATE(369),
    [sym__unboxed_open] = STATE(193),
    [sym_variable] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(2903),
    [anon_sym_LBRACE] = ACTIONS(2803),
    [anon_sym__] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2467),
    [sym_char] = ACTIONS(2467),
    [sym_string] = ACTIONS(2467),
    [sym__integer_literal] = ACTIONS(2469),
    [sym__binary_literal] = ACTIONS(2471),
    [sym__octal_literal] = ACTIONS(2471),
    [sym__hex_literal] = ACTIONS(2471),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [anon_sym_POUND] = ACTIONS(3231),
    [anon_sym_POUND2] = ACTIONS(2903),
    [sym_name] = ACTIONS(2807),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_u2237] = ACTIONS(2903),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(2903),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2475),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(2903),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(2811),
    [sym__cond_no_section_op] = ACTIONS(3283),
    [sym__cond_minus] = ACTIONS(2903),
    [sym__varsym] = ACTIONS(2903),
    [sym__consym] = ACTIONS(2737),
  },
  [1378] = {
    [sym__at_type] = STATE(6735),
    [sym_explicit_type] = STATE(6738),
    [sym__pat_parens] = STATE(6709),
    [sym__pat_tuple] = STATE(6707),
    [sym__pat_unboxed_tuple] = STATE(6706),
    [sym__pat_unboxed_sum] = STATE(6705),
    [sym__pat_list] = STATE(6704),
    [sym__pat_record] = STATE(6703),
    [sym__pat_as] = STATE(6702),
    [sym__pat_wildcard] = STATE(6701),
    [sym__pat_strict] = STATE(6700),
    [sym__pat_irrefutable] = STATE(6699),
    [sym__pat_apply] = STATE(6772),
    [sym__pat_negation] = STATE(6711),
    [sym__pat_infix] = STATE(6715),
    [sym_pattern] = STATE(1364),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11259),
    [sym__splice_dollars] = STATE(7313),
    [sym_splice] = STATE(6701),
    [sym_quasiquote] = STATE(6701),
    [sym_integer] = STATE(6231),
    [sym__plist] = STATE(6728),
    [sym_unit] = STATE(6701),
    [sym_unboxed_unit] = STATE(6701),
    [sym_prefix_tuple] = STATE(6701),
    [sym_prefix_unboxed_tuple] = STATE(6701),
    [sym_prefix_unboxed_sum] = STATE(6701),
    [sym_literal] = STATE(6701),
    [sym__qualified_constructor] = STATE(6223),
    [sym__qconid] = STATE(6701),
    [sym__constructor_ticked] = STATE(2251),
    [sym__qconstructor_ticked] = STATE(2251),
    [sym__varsym_prefix] = STATE(6729),
    [sym__pvarsym] = STATE(6729),
    [sym_constructor_operator] = STATE(2251),
    [sym__consym_prefix] = STATE(6731),
    [sym__pconsym] = STATE(6731),
    [sym__qconsym_prefix] = STATE(6701),
    [sym__pqconsym] = STATE(6701),
    [sym__prefix_at] = STATE(2417),
    [sym__prefix_bang] = STATE(2257),
    [sym__tight_bang] = STATE(2257),
    [sym__any_prefix_bang] = STATE(2257),
    [sym__prefix_tilde] = STATE(2258),
    [sym__tight_tilde] = STATE(2258),
    [sym__any_prefix_tilde] = STATE(2258),
    [sym__paren_open] = STATE(41),
    [sym__bracket_open] = STATE(369),
    [sym__unboxed_open] = STATE(193),
    [sym_variable] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(2803),
    [anon_sym__] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2467),
    [sym_char] = ACTIONS(2467),
    [sym_string] = ACTIONS(2467),
    [sym__integer_literal] = ACTIONS(2469),
    [sym__binary_literal] = ACTIONS(2471),
    [sym__octal_literal] = ACTIONS(2471),
    [sym__hex_literal] = ACTIONS(2471),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [anon_sym_POUND] = ACTIONS(3241),
    [anon_sym_POUND2] = ACTIONS(3045),
    [sym_name] = ACTIONS(2807),
    [anon_sym_COLON_COLON] = ACTIONS(3045),
    [anon_sym_u2237] = ACTIONS(3045),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(3045),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2475),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(3045),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(2811),
    [sym__cond_no_section_op] = ACTIONS(3283),
    [sym__cond_minus] = ACTIONS(3045),
    [sym__varsym] = ACTIONS(3045),
    [sym__consym] = ACTIONS(2737),
  },
  [1379] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(353),
    [sym__exp_signature] = STATE(12406),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1380] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10468),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10716),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10716),
    [sym__local_decl] = STATE(10716),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3285),
    [sym__cond_layout_end_explicit] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1381] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(55),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(3907),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(3287),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(3269),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1382] = {
    [sym__type_parens] = STATE(7722),
    [sym__type_tuple] = STATE(7721),
    [sym__type_unboxed_tuple] = STATE(7686),
    [sym__type_unboxed_sum] = STATE(7703),
    [sym__type_list] = STATE(7696),
    [sym__type_promoted] = STATE(7670),
    [sym__type_star] = STATE(7670),
    [sym__type_wildcard] = STATE(7670),
    [sym__at_type] = STATE(7627),
    [sym__type_apply] = STATE(7690),
    [sym__type_infix] = STATE(7716),
    [sym_type] = STATE(1360),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8426),
    [sym__splice_dollars] = STATE(7311),
    [sym_splice] = STATE(7670),
    [sym_quasiquote] = STATE(7670),
    [sym_integer] = STATE(7653),
    [sym__plist] = STATE(7676),
    [sym_unit] = STATE(7670),
    [sym_unboxed_unit] = STATE(7670),
    [sym_prefix_tuple] = STATE(7670),
    [sym_prefix_unboxed_tuple] = STATE(7670),
    [sym_prefix_unboxed_sum] = STATE(7670),
    [sym_literal] = STATE(7670),
    [sym__qualified_type] = STATE(7677),
    [sym__qtyconid] = STATE(7664),
    [sym__tycon_arrow] = STATE(7664),
    [sym__qtycon_arrow] = STATE(7664),
    [sym__promoted_tycons_alias] = STATE(7670),
    [sym__promoted_tycons] = STATE(7670),
    [sym__tycon_ticked] = STATE(2593),
    [sym__qtycon_ticked] = STATE(2593),
    [sym__tyconids_ticked] = STATE(2593),
    [sym__promoted_tyconops_alias] = STATE(2593),
    [sym__promoted_tyconops] = STATE(2593),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2593),
    [sym__operator_alias] = STATE(2593),
    [sym__operator_minus] = STATE(2593),
    [sym__varsym_prefix] = STATE(7664),
    [sym__pvarsym] = STATE(7664),
    [sym__qualified_varsym] = STATE(2594),
    [sym__qvarsym_prefix] = STATE(7664),
    [sym__pqvarsym] = STATE(7664),
    [sym_constructor_operator] = STATE(2593),
    [sym__constructor_operator_alias] = STATE(2593),
    [sym__consym_prefix] = STATE(7664),
    [sym__pconsym] = STATE(7664),
    [sym__qualified_consym] = STATE(2595),
    [sym__qconsym_prefix] = STATE(7664),
    [sym__pqconsym] = STATE(7664),
    [sym__prefix_at] = STATE(2512),
    [sym__paren_open] = STATE(463),
    [sym__bracket_open] = STATE(1066),
    [sym__unboxed_open] = STATE(825),
    [sym_variable] = ACTIONS(3247),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(3249),
    [anon_sym_SQUOTE] = ACTIONS(3251),
    [anon_sym_STAR] = ACTIONS(3253),
    [anon_sym_u2605] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3257),
    [sym_char] = ACTIONS(3257),
    [sym_string] = ACTIONS(3257),
    [sym__integer_literal] = ACTIONS(3259),
    [sym__binary_literal] = ACTIONS(3261),
    [sym__octal_literal] = ACTIONS(3261),
    [sym__hex_literal] = ACTIONS(3261),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(3263),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3265),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1383] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10463),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10716),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10716),
    [sym__local_decl] = STATE(10716),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3289),
    [sym__cond_layout_end_explicit] = ACTIONS(3289),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1384] = {
    [sym__type_parens] = STATE(7722),
    [sym__type_tuple] = STATE(7721),
    [sym__type_unboxed_tuple] = STATE(7686),
    [sym__type_unboxed_sum] = STATE(7703),
    [sym__type_list] = STATE(7696),
    [sym__type_promoted] = STATE(7670),
    [sym__type_star] = STATE(7670),
    [sym__type_wildcard] = STATE(7670),
    [sym__at_type] = STATE(7627),
    [sym__type_apply] = STATE(7690),
    [sym__type_infix] = STATE(7716),
    [sym_type] = STATE(1360),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8426),
    [sym__splice_dollars] = STATE(7311),
    [sym_splice] = STATE(7670),
    [sym_quasiquote] = STATE(7670),
    [sym_integer] = STATE(7653),
    [sym__plist] = STATE(7676),
    [sym_unit] = STATE(7670),
    [sym_unboxed_unit] = STATE(7670),
    [sym_prefix_tuple] = STATE(7670),
    [sym_prefix_unboxed_tuple] = STATE(7670),
    [sym_prefix_unboxed_sum] = STATE(7670),
    [sym_literal] = STATE(7670),
    [sym__qualified_type] = STATE(7677),
    [sym__qtyconid] = STATE(7664),
    [sym__tycon_arrow] = STATE(7664),
    [sym__qtycon_arrow] = STATE(7664),
    [sym__promoted_tycons_alias] = STATE(7670),
    [sym__promoted_tycons] = STATE(7670),
    [sym__tycon_ticked] = STATE(2593),
    [sym__qtycon_ticked] = STATE(2593),
    [sym__tyconids_ticked] = STATE(2593),
    [sym__promoted_tyconops_alias] = STATE(2593),
    [sym__promoted_tyconops] = STATE(2593),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2593),
    [sym__operator_alias] = STATE(2593),
    [sym__operator_minus] = STATE(2593),
    [sym__varsym_prefix] = STATE(7664),
    [sym__pvarsym] = STATE(7664),
    [sym__qualified_varsym] = STATE(2594),
    [sym__qvarsym_prefix] = STATE(7664),
    [sym__pqvarsym] = STATE(7664),
    [sym_constructor_operator] = STATE(2593),
    [sym__constructor_operator_alias] = STATE(2593),
    [sym__consym_prefix] = STATE(7664),
    [sym__pconsym] = STATE(7664),
    [sym__qualified_consym] = STATE(2595),
    [sym__qconsym_prefix] = STATE(7664),
    [sym__pqconsym] = STATE(7664),
    [sym__prefix_at] = STATE(2512),
    [sym__paren_open] = STATE(463),
    [sym__bracket_open] = STATE(1066),
    [sym__unboxed_open] = STATE(825),
    [sym_variable] = ACTIONS(3247),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym__] = ACTIONS(3249),
    [anon_sym_SQUOTE] = ACTIONS(3251),
    [anon_sym_STAR] = ACTIONS(3253),
    [anon_sym_u2605] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3257),
    [sym_char] = ACTIONS(3257),
    [sym_string] = ACTIONS(3257),
    [sym__integer_literal] = ACTIONS(3259),
    [sym__binary_literal] = ACTIONS(3261),
    [sym__octal_literal] = ACTIONS(3261),
    [sym__hex_literal] = ACTIONS(3261),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(3263),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1181),
    [sym__cond_layout_end] = ACTIONS(1181),
    [sym__cond_layout_end_explicit] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3265),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1385] = {
    [sym__at_type] = STATE(6735),
    [sym_explicit_type] = STATE(6738),
    [sym__pat_parens] = STATE(6709),
    [sym__pat_tuple] = STATE(6707),
    [sym__pat_unboxed_tuple] = STATE(6706),
    [sym__pat_unboxed_sum] = STATE(6705),
    [sym__pat_list] = STATE(6704),
    [sym__pat_record] = STATE(6703),
    [sym__pat_as] = STATE(6702),
    [sym__pat_wildcard] = STATE(6701),
    [sym__pat_strict] = STATE(6700),
    [sym__pat_irrefutable] = STATE(6699),
    [sym__pat_apply] = STATE(6772),
    [sym__pat_negation] = STATE(6711),
    [sym__pat_infix] = STATE(6715),
    [sym_pattern] = STATE(1364),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11259),
    [sym__splice_dollars] = STATE(7313),
    [sym_splice] = STATE(6701),
    [sym_quasiquote] = STATE(6701),
    [sym_integer] = STATE(6231),
    [sym__plist] = STATE(6728),
    [sym_unit] = STATE(6701),
    [sym_unboxed_unit] = STATE(6701),
    [sym_prefix_tuple] = STATE(6701),
    [sym_prefix_unboxed_tuple] = STATE(6701),
    [sym_prefix_unboxed_sum] = STATE(6701),
    [sym_literal] = STATE(6701),
    [sym__qualified_constructor] = STATE(6223),
    [sym__qconid] = STATE(6701),
    [sym__constructor_ticked] = STATE(2251),
    [sym__qconstructor_ticked] = STATE(2251),
    [sym__varsym_prefix] = STATE(6729),
    [sym__pvarsym] = STATE(6729),
    [sym_constructor_operator] = STATE(2251),
    [sym__consym_prefix] = STATE(6731),
    [sym__pconsym] = STATE(6731),
    [sym__qconsym_prefix] = STATE(6701),
    [sym__pqconsym] = STATE(6701),
    [sym__prefix_at] = STATE(2417),
    [sym__prefix_bang] = STATE(2257),
    [sym__tight_bang] = STATE(2257),
    [sym__any_prefix_bang] = STATE(2257),
    [sym__prefix_tilde] = STATE(2258),
    [sym__tight_tilde] = STATE(2258),
    [sym__any_prefix_tilde] = STATE(2258),
    [sym__paren_open] = STATE(41),
    [sym__bracket_open] = STATE(369),
    [sym__unboxed_open] = STATE(193),
    [sym_variable] = ACTIONS(2821),
    [anon_sym_COMMA] = ACTIONS(2823),
    [anon_sym_LBRACE] = ACTIONS(2803),
    [anon_sym__] = ACTIONS(2821),
    [anon_sym_STAR] = ACTIONS(2823),
    [anon_sym_DASH] = ACTIONS(2823),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [sym_float] = ACTIONS(2823),
    [sym_char] = ACTIONS(2823),
    [sym_string] = ACTIONS(2823),
    [sym__integer_literal] = ACTIONS(2821),
    [sym__binary_literal] = ACTIONS(2823),
    [sym__octal_literal] = ACTIONS(2823),
    [sym__hex_literal] = ACTIONS(2823),
    [anon_sym_BQUOTE] = ACTIONS(2823),
    [anon_sym_POUND] = ACTIONS(2821),
    [anon_sym_POUND2] = ACTIONS(2823),
    [sym_name] = ACTIONS(2823),
    [anon_sym_COLON_COLON] = ACTIONS(2823),
    [anon_sym_u2237] = ACTIONS(2823),
    [aux_sym__paren_open_token1] = ACTIONS(2823),
    [aux_sym__paren_close_token1] = ACTIONS(2823),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2823),
    [sym__cond_splice] = ACTIONS(2823),
    [sym__cond_prefix_dot] = ACTIONS(2823),
    [sym__cond_prefix_at] = ACTIONS(2823),
    [sym__cond_tight_bang] = ACTIONS(2823),
    [sym__cond_prefix_bang] = ACTIONS(2823),
    [sym__cond_tight_tilde] = ACTIONS(2823),
    [sym__cond_prefix_tilde] = ACTIONS(2823),
    [sym__cond_qualified_op] = ACTIONS(2823),
    [sym__cond_no_section_op] = ACTIONS(2823),
    [sym__cond_minus] = ACTIONS(2823),
    [sym__varsym] = ACTIONS(2823),
    [sym__consym] = ACTIONS(2823),
  },
  [1386] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(55),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(3451),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(3291),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(3269),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1387] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10679),
    [sym__assoc_tyinst] = STATE(10389),
    [sym__assoc_datainst_adt] = STATE(10386),
    [sym__assoc_datainst_newtype] = STATE(10381),
    [sym__assoc_datainst] = STATE(10379),
    [sym_instance_decl] = STATE(10756),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10379),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_newtype] = ACTIONS(2911),
    [anon_sym_data] = ACTIONS(2913),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3293),
    [sym__cond_layout_end_explicit] = ACTIONS(3293),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1388] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(251),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(3736),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__paren_open] = STATE(404),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(3295),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(155),
    [sym__binary_literal] = ACTIONS(157),
    [sym__octal_literal] = ACTIONS(157),
    [sym__hex_literal] = ACTIONS(157),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(3269),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1389] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10709),
    [sym__assoc_tyinst] = STATE(10389),
    [sym__assoc_datainst_adt] = STATE(10386),
    [sym__assoc_datainst_newtype] = STATE(10381),
    [sym__assoc_datainst] = STATE(10379),
    [sym_instance_decl] = STATE(10756),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10379),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_newtype] = ACTIONS(2911),
    [anon_sym_data] = ACTIONS(2913),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3185),
    [sym__cond_layout_end_explicit] = ACTIONS(3185),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1390] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10285),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10716),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10716),
    [sym__local_decl] = STATE(10716),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3297),
    [sym__cond_layout_end_explicit] = ACTIONS(3297),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1391] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(251),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__paren_open] = STATE(404),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__paren_close_token1] = ACTIONS(3269),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1392] = {
    [sym__type_parens] = STATE(7722),
    [sym__type_tuple] = STATE(7721),
    [sym__type_unboxed_tuple] = STATE(7686),
    [sym__type_unboxed_sum] = STATE(7703),
    [sym__type_list] = STATE(7696),
    [sym__type_promoted] = STATE(7670),
    [sym__type_star] = STATE(7670),
    [sym__type_wildcard] = STATE(7670),
    [sym__at_type] = STATE(7627),
    [sym__type_apply] = STATE(7690),
    [sym__type_infix] = STATE(7716),
    [sym_type] = STATE(1360),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8426),
    [sym__splice_dollars] = STATE(7311),
    [sym_splice] = STATE(7670),
    [sym_quasiquote] = STATE(7670),
    [sym_integer] = STATE(7653),
    [sym__plist] = STATE(7676),
    [sym_unit] = STATE(7670),
    [sym_unboxed_unit] = STATE(7670),
    [sym_prefix_tuple] = STATE(7670),
    [sym_prefix_unboxed_tuple] = STATE(7670),
    [sym_prefix_unboxed_sum] = STATE(7670),
    [sym_literal] = STATE(7670),
    [sym__qualified_type] = STATE(7677),
    [sym__qtyconid] = STATE(7664),
    [sym__tycon_arrow] = STATE(7664),
    [sym__qtycon_arrow] = STATE(7664),
    [sym__promoted_tycons_alias] = STATE(7670),
    [sym__promoted_tycons] = STATE(7670),
    [sym__tycon_ticked] = STATE(2593),
    [sym__qtycon_ticked] = STATE(2593),
    [sym__tyconids_ticked] = STATE(2593),
    [sym__promoted_tyconops_alias] = STATE(2593),
    [sym__promoted_tyconops] = STATE(2593),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2593),
    [sym__operator_alias] = STATE(2593),
    [sym__operator_minus] = STATE(2593),
    [sym__varsym_prefix] = STATE(7664),
    [sym__pvarsym] = STATE(7664),
    [sym__qualified_varsym] = STATE(2594),
    [sym__qvarsym_prefix] = STATE(7664),
    [sym__pqvarsym] = STATE(7664),
    [sym_constructor_operator] = STATE(2593),
    [sym__constructor_operator_alias] = STATE(2593),
    [sym__consym_prefix] = STATE(7664),
    [sym__pconsym] = STATE(7664),
    [sym__qualified_consym] = STATE(2595),
    [sym__qconsym_prefix] = STATE(7664),
    [sym__pqconsym] = STATE(7664),
    [sym__prefix_at] = STATE(2512),
    [sym__paren_open] = STATE(463),
    [sym__bracket_open] = STATE(1066),
    [sym__unboxed_open] = STATE(825),
    [sym_variable] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(1179),
    [sym__cond_layout_end] = ACTIONS(1179),
    [sym__cond_layout_end_explicit] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [1393] = {
    [sym__at_type] = STATE(6735),
    [sym_explicit_type] = STATE(6738),
    [sym__pat_parens] = STATE(6709),
    [sym__pat_tuple] = STATE(6707),
    [sym__pat_unboxed_tuple] = STATE(6706),
    [sym__pat_unboxed_sum] = STATE(6705),
    [sym__pat_list] = STATE(6704),
    [sym__pat_record] = STATE(6703),
    [sym__pat_as] = STATE(6702),
    [sym__pat_wildcard] = STATE(6701),
    [sym__pat_strict] = STATE(6700),
    [sym__pat_irrefutable] = STATE(6699),
    [sym__pat_apply] = STATE(6772),
    [sym__pat_negation] = STATE(6711),
    [sym__pat_infix] = STATE(6715),
    [sym_pattern] = STATE(1364),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11259),
    [sym__splice_dollars] = STATE(7313),
    [sym_splice] = STATE(6701),
    [sym_quasiquote] = STATE(6701),
    [sym_integer] = STATE(6231),
    [sym__plist] = STATE(6728),
    [sym_unit] = STATE(6701),
    [sym_unboxed_unit] = STATE(6701),
    [sym_prefix_tuple] = STATE(6701),
    [sym_prefix_unboxed_tuple] = STATE(6701),
    [sym_prefix_unboxed_sum] = STATE(6701),
    [sym_literal] = STATE(6701),
    [sym__qualified_constructor] = STATE(6223),
    [sym__qconid] = STATE(6701),
    [sym__constructor_ticked] = STATE(2251),
    [sym__qconstructor_ticked] = STATE(2251),
    [sym__varsym_prefix] = STATE(6729),
    [sym__pvarsym] = STATE(6729),
    [sym_constructor_operator] = STATE(2251),
    [sym__consym_prefix] = STATE(6731),
    [sym__pconsym] = STATE(6731),
    [sym__qconsym_prefix] = STATE(6701),
    [sym__pqconsym] = STATE(6701),
    [sym__prefix_at] = STATE(2417),
    [sym__prefix_bang] = STATE(2257),
    [sym__tight_bang] = STATE(2257),
    [sym__any_prefix_bang] = STATE(2257),
    [sym__prefix_tilde] = STATE(2258),
    [sym__tight_tilde] = STATE(2258),
    [sym__any_prefix_tilde] = STATE(2258),
    [sym__paren_open] = STATE(41),
    [sym__bracket_open] = STATE(369),
    [sym__unboxed_open] = STATE(193),
    [sym_variable] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2803),
    [anon_sym__] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(2829),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2467),
    [sym_char] = ACTIONS(2467),
    [sym_string] = ACTIONS(2467),
    [sym__integer_literal] = ACTIONS(2469),
    [sym__binary_literal] = ACTIONS(2471),
    [sym__octal_literal] = ACTIONS(2471),
    [sym__hex_literal] = ACTIONS(2471),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [anon_sym_POUND] = ACTIONS(3239),
    [anon_sym_POUND2] = ACTIONS(2829),
    [sym_name] = ACTIONS(2807),
    [anon_sym_COLON_COLON] = ACTIONS(2829),
    [anon_sym_u2237] = ACTIONS(2829),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(2829),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2475),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(2829),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(2811),
    [sym__cond_no_section_op] = ACTIONS(3283),
    [sym__cond_minus] = ACTIONS(2829),
    [sym__varsym] = ACTIONS(2829),
    [sym__consym] = ACTIONS(2737),
  },
  [1394] = {
    [sym__type_parens] = STATE(5938),
    [sym__type_tuple] = STATE(5929),
    [sym__type_unboxed_tuple] = STATE(5928),
    [sym__type_unboxed_sum] = STATE(5927),
    [sym__type_list] = STATE(5923),
    [sym__type_promoted] = STATE(5958),
    [sym__type_star] = STATE(5958),
    [sym__type_wildcard] = STATE(5958),
    [sym__type_apply] = STATE(5917),
    [sym__type_infix] = STATE(5912),
    [sym_type] = STATE(657),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10206),
    [sym__qtype_forall] = STATE(8513),
    [sym__qtype_forall_required] = STATE(8526),
    [sym_strict_field] = STATE(8613),
    [sym_lazy_field] = STATE(8613),
    [sym__qtype_function] = STATE(8527),
    [sym__qtype_linear_function] = STATE(8528),
    [sym__qtype_context] = STATE(8530),
    [sym_quantified_type] = STATE(8121),
    [sym_implicit_parameter] = STATE(8537),
    [sym__context_inline] = STATE(1598),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11083),
    [sym__splice_dollars] = STATE(7467),
    [sym_splice] = STATE(5958),
    [sym_quasiquote] = STATE(5958),
    [sym_integer] = STATE(6013),
    [sym__plist] = STATE(5900),
    [sym_unit] = STATE(5958),
    [sym_unboxed_unit] = STATE(5958),
    [sym_prefix_tuple] = STATE(5958),
    [sym_prefix_unboxed_tuple] = STATE(5958),
    [sym_prefix_unboxed_sum] = STATE(5958),
    [sym_literal] = STATE(5958),
    [sym__qualified_type] = STATE(5983),
    [sym__qtyconid] = STATE(5894),
    [sym__tycon_arrow] = STATE(5894),
    [sym__qtycon_arrow] = STATE(5894),
    [sym__promoted_tycons_alias] = STATE(5958),
    [sym__promoted_tycons] = STATE(5958),
    [sym__varsym_prefix] = STATE(5894),
    [sym__pvarsym] = STATE(5894),
    [sym__qvarsym_prefix] = STATE(5894),
    [sym__pqvarsym] = STATE(5894),
    [sym__consym_prefix] = STATE(5894),
    [sym__pconsym] = STATE(5894),
    [sym__qconsym_prefix] = STATE(5894),
    [sym__pqconsym] = STATE(5894),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(460),
    [sym__bracket_open] = STATE(1045),
    [sym__unboxed_open] = STATE(826),
    [sym_variable] = ACTIONS(1887),
    [anon_sym__] = ACTIONS(1889),
    [anon_sym_SQUOTE] = ACTIONS(3299),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_u2605] = ACTIONS(1895),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1897),
    [sym_char] = ACTIONS(1897),
    [sym_string] = ACTIONS(1897),
    [sym__integer_literal] = ACTIONS(1899),
    [sym__binary_literal] = ACTIONS(1901),
    [sym__octal_literal] = ACTIONS(1901),
    [sym__hex_literal] = ACTIONS(1901),
    [sym_implicit_variable] = ACTIONS(3301),
    [sym_name] = ACTIONS(3303),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1905),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1395] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8319),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1396] = {
    [sym__type_parens] = STATE(3217),
    [sym__type_tuple] = STATE(3215),
    [sym__type_unboxed_tuple] = STATE(3214),
    [sym__type_unboxed_sum] = STATE(3209),
    [sym__type_list] = STATE(3198),
    [sym__type_promoted] = STATE(3219),
    [sym__type_star] = STATE(3219),
    [sym__type_wildcard] = STATE(3219),
    [sym__type_apply] = STATE(3195),
    [sym__type_infix] = STATE(3189),
    [sym_type] = STATE(500),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10171),
    [sym__qtype_forall] = STATE(3763),
    [sym__qtype_forall_required] = STATE(3764),
    [sym_strict_field] = STATE(8629),
    [sym_lazy_field] = STATE(8629),
    [sym__qtype_function] = STATE(3765),
    [sym__qtype_linear_function] = STATE(3766),
    [sym__qtype_context] = STATE(3769),
    [sym_quantified_type] = STATE(2832),
    [sym_implicit_parameter] = STATE(3770),
    [sym__context_inline] = STATE(1407),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11305),
    [sym__splice_dollars] = STATE(7385),
    [sym_splice] = STATE(3219),
    [sym_quasiquote] = STATE(3219),
    [sym_integer] = STATE(3330),
    [sym__plist] = STATE(3185),
    [sym_unit] = STATE(3219),
    [sym_unboxed_unit] = STATE(3219),
    [sym_prefix_tuple] = STATE(3219),
    [sym_prefix_unboxed_tuple] = STATE(3219),
    [sym_prefix_unboxed_sum] = STATE(3219),
    [sym_literal] = STATE(3219),
    [sym__qualified_type] = STATE(3420),
    [sym__qtyconid] = STATE(3183),
    [sym__tycon_arrow] = STATE(3183),
    [sym__qtycon_arrow] = STATE(3183),
    [sym__promoted_tycons_alias] = STATE(3219),
    [sym__promoted_tycons] = STATE(3219),
    [sym__varsym_prefix] = STATE(3183),
    [sym__pvarsym] = STATE(3183),
    [sym__qvarsym_prefix] = STATE(3183),
    [sym__pqvarsym] = STATE(3183),
    [sym__consym_prefix] = STATE(3183),
    [sym__pconsym] = STATE(3183),
    [sym__qconsym_prefix] = STATE(3183),
    [sym__pqconsym] = STATE(3183),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(447),
    [sym__bracket_open] = STATE(976),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = ACTIONS(1629),
    [anon_sym__] = ACTIONS(1631),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_STAR] = ACTIONS(1637),
    [anon_sym_u2605] = ACTIONS(1637),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1639),
    [sym_char] = ACTIONS(1639),
    [sym_string] = ACTIONS(1639),
    [sym__integer_literal] = ACTIONS(1641),
    [sym__binary_literal] = ACTIONS(1643),
    [sym__octal_literal] = ACTIONS(1643),
    [sym__hex_literal] = ACTIONS(1643),
    [sym_implicit_variable] = ACTIONS(3307),
    [sym_name] = ACTIONS(3309),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1647),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1397] = {
    [sym__type_parens] = STATE(3217),
    [sym__type_tuple] = STATE(3215),
    [sym__type_unboxed_tuple] = STATE(3214),
    [sym__type_unboxed_sum] = STATE(3209),
    [sym__type_list] = STATE(3198),
    [sym__type_promoted] = STATE(3219),
    [sym__type_star] = STATE(3219),
    [sym__type_wildcard] = STATE(3219),
    [sym__type_apply] = STATE(3195),
    [sym__type_infix] = STATE(3189),
    [sym_type] = STATE(500),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10171),
    [sym__qtype_forall] = STATE(3763),
    [sym__qtype_forall_required] = STATE(3764),
    [sym_strict_field] = STATE(8629),
    [sym_lazy_field] = STATE(8629),
    [sym__qtype_function] = STATE(3765),
    [sym__qtype_linear_function] = STATE(3766),
    [sym__qtype_context] = STATE(3769),
    [sym_quantified_type] = STATE(2799),
    [sym_implicit_parameter] = STATE(3770),
    [sym__context_inline] = STATE(1407),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11305),
    [sym__splice_dollars] = STATE(7385),
    [sym_splice] = STATE(3219),
    [sym_quasiquote] = STATE(3219),
    [sym_integer] = STATE(3330),
    [sym__plist] = STATE(3185),
    [sym_unit] = STATE(3219),
    [sym_unboxed_unit] = STATE(3219),
    [sym_prefix_tuple] = STATE(3219),
    [sym_prefix_unboxed_tuple] = STATE(3219),
    [sym_prefix_unboxed_sum] = STATE(3219),
    [sym_literal] = STATE(3219),
    [sym__qualified_type] = STATE(3420),
    [sym__qtyconid] = STATE(3183),
    [sym__tycon_arrow] = STATE(3183),
    [sym__qtycon_arrow] = STATE(3183),
    [sym__promoted_tycons_alias] = STATE(3219),
    [sym__promoted_tycons] = STATE(3219),
    [sym__varsym_prefix] = STATE(3183),
    [sym__pvarsym] = STATE(3183),
    [sym__qvarsym_prefix] = STATE(3183),
    [sym__pqvarsym] = STATE(3183),
    [sym__consym_prefix] = STATE(3183),
    [sym__pconsym] = STATE(3183),
    [sym__qconsym_prefix] = STATE(3183),
    [sym__pqconsym] = STATE(3183),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(447),
    [sym__bracket_open] = STATE(976),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = ACTIONS(1629),
    [anon_sym__] = ACTIONS(1631),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_STAR] = ACTIONS(1637),
    [anon_sym_u2605] = ACTIONS(1637),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1639),
    [sym_char] = ACTIONS(1639),
    [sym_string] = ACTIONS(1639),
    [sym__integer_literal] = ACTIONS(1641),
    [sym__binary_literal] = ACTIONS(1643),
    [sym__octal_literal] = ACTIONS(1643),
    [sym__hex_literal] = ACTIONS(1643),
    [sym_implicit_variable] = ACTIONS(3307),
    [sym_name] = ACTIONS(3309),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1647),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1398] = {
    [sym__type_parens] = STATE(3217),
    [sym__type_tuple] = STATE(3215),
    [sym__type_unboxed_tuple] = STATE(3214),
    [sym__type_unboxed_sum] = STATE(3209),
    [sym__type_list] = STATE(3198),
    [sym__type_promoted] = STATE(3219),
    [sym__type_star] = STATE(3219),
    [sym__type_wildcard] = STATE(3219),
    [sym__type_apply] = STATE(3195),
    [sym__type_infix] = STATE(3189),
    [sym_type] = STATE(500),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10171),
    [sym__qtype_forall] = STATE(3763),
    [sym__qtype_forall_required] = STATE(3764),
    [sym_strict_field] = STATE(8629),
    [sym_lazy_field] = STATE(8629),
    [sym__qtype_function] = STATE(3765),
    [sym__qtype_linear_function] = STATE(3766),
    [sym__qtype_context] = STATE(3769),
    [sym_quantified_type] = STATE(2800),
    [sym_implicit_parameter] = STATE(3770),
    [sym__context_inline] = STATE(1407),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11305),
    [sym__splice_dollars] = STATE(7385),
    [sym_splice] = STATE(3219),
    [sym_quasiquote] = STATE(3219),
    [sym_integer] = STATE(3330),
    [sym__plist] = STATE(3185),
    [sym_unit] = STATE(3219),
    [sym_unboxed_unit] = STATE(3219),
    [sym_prefix_tuple] = STATE(3219),
    [sym_prefix_unboxed_tuple] = STATE(3219),
    [sym_prefix_unboxed_sum] = STATE(3219),
    [sym_literal] = STATE(3219),
    [sym__qualified_type] = STATE(3420),
    [sym__qtyconid] = STATE(3183),
    [sym__tycon_arrow] = STATE(3183),
    [sym__qtycon_arrow] = STATE(3183),
    [sym__promoted_tycons_alias] = STATE(3219),
    [sym__promoted_tycons] = STATE(3219),
    [sym__varsym_prefix] = STATE(3183),
    [sym__pvarsym] = STATE(3183),
    [sym__qvarsym_prefix] = STATE(3183),
    [sym__pqvarsym] = STATE(3183),
    [sym__consym_prefix] = STATE(3183),
    [sym__pconsym] = STATE(3183),
    [sym__qconsym_prefix] = STATE(3183),
    [sym__pqconsym] = STATE(3183),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(447),
    [sym__bracket_open] = STATE(976),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = ACTIONS(1629),
    [anon_sym__] = ACTIONS(1631),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_STAR] = ACTIONS(1637),
    [anon_sym_u2605] = ACTIONS(1637),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1639),
    [sym_char] = ACTIONS(1639),
    [sym_string] = ACTIONS(1639),
    [sym__integer_literal] = ACTIONS(1641),
    [sym__binary_literal] = ACTIONS(1643),
    [sym__octal_literal] = ACTIONS(1643),
    [sym__hex_literal] = ACTIONS(1643),
    [sym_implicit_variable] = ACTIONS(3307),
    [sym_name] = ACTIONS(3309),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1647),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1399] = {
    [sym__type_parens] = STATE(3217),
    [sym__type_tuple] = STATE(3215),
    [sym__type_unboxed_tuple] = STATE(3214),
    [sym__type_unboxed_sum] = STATE(3209),
    [sym__type_list] = STATE(3198),
    [sym__type_promoted] = STATE(3219),
    [sym__type_star] = STATE(3219),
    [sym__type_wildcard] = STATE(3219),
    [sym__type_apply] = STATE(3195),
    [sym__type_infix] = STATE(3189),
    [sym_type] = STATE(500),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10171),
    [sym__qtype_forall] = STATE(3763),
    [sym__qtype_forall_required] = STATE(3764),
    [sym_strict_field] = STATE(8629),
    [sym_lazy_field] = STATE(8629),
    [sym__qtype_function] = STATE(3765),
    [sym__qtype_linear_function] = STATE(3766),
    [sym__qtype_context] = STATE(3769),
    [sym_quantified_type] = STATE(2803),
    [sym_implicit_parameter] = STATE(3770),
    [sym__context_inline] = STATE(1407),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11305),
    [sym__splice_dollars] = STATE(7385),
    [sym_splice] = STATE(3219),
    [sym_quasiquote] = STATE(3219),
    [sym_integer] = STATE(3330),
    [sym__plist] = STATE(3185),
    [sym_unit] = STATE(3219),
    [sym_unboxed_unit] = STATE(3219),
    [sym_prefix_tuple] = STATE(3219),
    [sym_prefix_unboxed_tuple] = STATE(3219),
    [sym_prefix_unboxed_sum] = STATE(3219),
    [sym_literal] = STATE(3219),
    [sym__qualified_type] = STATE(3420),
    [sym__qtyconid] = STATE(3183),
    [sym__tycon_arrow] = STATE(3183),
    [sym__qtycon_arrow] = STATE(3183),
    [sym__promoted_tycons_alias] = STATE(3219),
    [sym__promoted_tycons] = STATE(3219),
    [sym__varsym_prefix] = STATE(3183),
    [sym__pvarsym] = STATE(3183),
    [sym__qvarsym_prefix] = STATE(3183),
    [sym__pqvarsym] = STATE(3183),
    [sym__consym_prefix] = STATE(3183),
    [sym__pconsym] = STATE(3183),
    [sym__qconsym_prefix] = STATE(3183),
    [sym__pqconsym] = STATE(3183),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(447),
    [sym__bracket_open] = STATE(976),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = ACTIONS(1629),
    [anon_sym__] = ACTIONS(1631),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_STAR] = ACTIONS(1637),
    [anon_sym_u2605] = ACTIONS(1637),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1639),
    [sym_char] = ACTIONS(1639),
    [sym_string] = ACTIONS(1639),
    [sym__integer_literal] = ACTIONS(1641),
    [sym__binary_literal] = ACTIONS(1643),
    [sym__octal_literal] = ACTIONS(1643),
    [sym__hex_literal] = ACTIONS(1643),
    [sym_implicit_variable] = ACTIONS(3307),
    [sym_name] = ACTIONS(3309),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1647),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1400] = {
    [sym__type_parens] = STATE(3217),
    [sym__type_tuple] = STATE(3215),
    [sym__type_unboxed_tuple] = STATE(3214),
    [sym__type_unboxed_sum] = STATE(3209),
    [sym__type_list] = STATE(3198),
    [sym__type_promoted] = STATE(3219),
    [sym__type_star] = STATE(3219),
    [sym__type_wildcard] = STATE(3219),
    [sym__type_apply] = STATE(3195),
    [sym__type_infix] = STATE(3189),
    [sym_type] = STATE(500),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10171),
    [sym__qtype_forall] = STATE(3763),
    [sym__qtype_forall_required] = STATE(3764),
    [sym_strict_field] = STATE(8629),
    [sym_lazy_field] = STATE(8629),
    [sym__qtype_function] = STATE(3765),
    [sym__qtype_linear_function] = STATE(3766),
    [sym__qtype_context] = STATE(3769),
    [sym_quantified_type] = STATE(2804),
    [sym_implicit_parameter] = STATE(3770),
    [sym__context_inline] = STATE(1407),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11305),
    [sym__splice_dollars] = STATE(7385),
    [sym_splice] = STATE(3219),
    [sym_quasiquote] = STATE(3219),
    [sym_integer] = STATE(3330),
    [sym__plist] = STATE(3185),
    [sym_unit] = STATE(3219),
    [sym_unboxed_unit] = STATE(3219),
    [sym_prefix_tuple] = STATE(3219),
    [sym_prefix_unboxed_tuple] = STATE(3219),
    [sym_prefix_unboxed_sum] = STATE(3219),
    [sym_literal] = STATE(3219),
    [sym__qualified_type] = STATE(3420),
    [sym__qtyconid] = STATE(3183),
    [sym__tycon_arrow] = STATE(3183),
    [sym__qtycon_arrow] = STATE(3183),
    [sym__promoted_tycons_alias] = STATE(3219),
    [sym__promoted_tycons] = STATE(3219),
    [sym__varsym_prefix] = STATE(3183),
    [sym__pvarsym] = STATE(3183),
    [sym__qvarsym_prefix] = STATE(3183),
    [sym__pqvarsym] = STATE(3183),
    [sym__consym_prefix] = STATE(3183),
    [sym__pconsym] = STATE(3183),
    [sym__qconsym_prefix] = STATE(3183),
    [sym__pqconsym] = STATE(3183),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(447),
    [sym__bracket_open] = STATE(976),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = ACTIONS(1629),
    [anon_sym__] = ACTIONS(1631),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_STAR] = ACTIONS(1637),
    [anon_sym_u2605] = ACTIONS(1637),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1639),
    [sym_char] = ACTIONS(1639),
    [sym_string] = ACTIONS(1639),
    [sym__integer_literal] = ACTIONS(1641),
    [sym__binary_literal] = ACTIONS(1643),
    [sym__octal_literal] = ACTIONS(1643),
    [sym__hex_literal] = ACTIONS(1643),
    [sym_implicit_variable] = ACTIONS(3307),
    [sym_name] = ACTIONS(3309),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1647),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1401] = {
    [sym__type_parens] = STATE(3217),
    [sym__type_tuple] = STATE(3215),
    [sym__type_unboxed_tuple] = STATE(3214),
    [sym__type_unboxed_sum] = STATE(3209),
    [sym__type_list] = STATE(3198),
    [sym__type_promoted] = STATE(3219),
    [sym__type_star] = STATE(3219),
    [sym__type_wildcard] = STATE(3219),
    [sym__type_apply] = STATE(3195),
    [sym__type_infix] = STATE(3189),
    [sym_type] = STATE(500),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10171),
    [sym__qtype_forall] = STATE(3763),
    [sym__qtype_forall_required] = STATE(3764),
    [sym_strict_field] = STATE(8629),
    [sym_lazy_field] = STATE(8629),
    [sym__qtype_function] = STATE(3765),
    [sym__qtype_linear_function] = STATE(3766),
    [sym__qtype_context] = STATE(3769),
    [sym_quantified_type] = STATE(2807),
    [sym_implicit_parameter] = STATE(3770),
    [sym__context_inline] = STATE(1407),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11305),
    [sym__splice_dollars] = STATE(7385),
    [sym_splice] = STATE(3219),
    [sym_quasiquote] = STATE(3219),
    [sym_integer] = STATE(3330),
    [sym__plist] = STATE(3185),
    [sym_unit] = STATE(3219),
    [sym_unboxed_unit] = STATE(3219),
    [sym_prefix_tuple] = STATE(3219),
    [sym_prefix_unboxed_tuple] = STATE(3219),
    [sym_prefix_unboxed_sum] = STATE(3219),
    [sym_literal] = STATE(3219),
    [sym__qualified_type] = STATE(3420),
    [sym__qtyconid] = STATE(3183),
    [sym__tycon_arrow] = STATE(3183),
    [sym__qtycon_arrow] = STATE(3183),
    [sym__promoted_tycons_alias] = STATE(3219),
    [sym__promoted_tycons] = STATE(3219),
    [sym__varsym_prefix] = STATE(3183),
    [sym__pvarsym] = STATE(3183),
    [sym__qvarsym_prefix] = STATE(3183),
    [sym__pqvarsym] = STATE(3183),
    [sym__consym_prefix] = STATE(3183),
    [sym__pconsym] = STATE(3183),
    [sym__qconsym_prefix] = STATE(3183),
    [sym__pqconsym] = STATE(3183),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(447),
    [sym__bracket_open] = STATE(976),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = ACTIONS(1629),
    [anon_sym__] = ACTIONS(1631),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_STAR] = ACTIONS(1637),
    [anon_sym_u2605] = ACTIONS(1637),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1639),
    [sym_char] = ACTIONS(1639),
    [sym_string] = ACTIONS(1639),
    [sym__integer_literal] = ACTIONS(1641),
    [sym__binary_literal] = ACTIONS(1643),
    [sym__octal_literal] = ACTIONS(1643),
    [sym__hex_literal] = ACTIONS(1643),
    [sym_implicit_variable] = ACTIONS(3307),
    [sym_name] = ACTIONS(3309),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1647),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1402] = {
    [sym__type_parens] = STATE(6766),
    [sym__type_tuple] = STATE(6767),
    [sym__type_unboxed_tuple] = STATE(6768),
    [sym__type_unboxed_sum] = STATE(6769),
    [sym__type_list] = STATE(6770),
    [sym__type_promoted] = STATE(6765),
    [sym__type_star] = STATE(6765),
    [sym__type_wildcard] = STATE(6765),
    [sym__type_apply] = STATE(6698),
    [sym__type_infix] = STATE(6780),
    [sym_type] = STATE(863),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10178),
    [sym__qtype_forall] = STATE(8836),
    [sym__qtype_forall_required] = STATE(8839),
    [sym_strict_field] = STATE(8670),
    [sym_lazy_field] = STATE(8670),
    [sym__qtype_function] = STATE(8850),
    [sym__qtype_linear_function] = STATE(8854),
    [sym__qtype_context] = STATE(8855),
    [sym_quantified_type] = STATE(8314),
    [sym_implicit_parameter] = STATE(8857),
    [sym__context_inline] = STATE(1490),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11231),
    [sym__splice_dollars] = STATE(7306),
    [sym_splice] = STATE(6765),
    [sym_quasiquote] = STATE(6765),
    [sym_integer] = STATE(6754),
    [sym__plist] = STATE(6782),
    [sym_unit] = STATE(6765),
    [sym_unboxed_unit] = STATE(6765),
    [sym_prefix_tuple] = STATE(6765),
    [sym_prefix_unboxed_tuple] = STATE(6765),
    [sym_prefix_unboxed_sum] = STATE(6765),
    [sym_literal] = STATE(6765),
    [sym__qualified_type] = STATE(6803),
    [sym__qtyconid] = STATE(6783),
    [sym__tycon_arrow] = STATE(6783),
    [sym__qtycon_arrow] = STATE(6783),
    [sym__promoted_tycons_alias] = STATE(6765),
    [sym__promoted_tycons] = STATE(6765),
    [sym__varsym_prefix] = STATE(6783),
    [sym__pvarsym] = STATE(6783),
    [sym__qvarsym_prefix] = STATE(6783),
    [sym__pqvarsym] = STATE(6783),
    [sym__consym_prefix] = STATE(6783),
    [sym__pconsym] = STATE(6783),
    [sym__qconsym_prefix] = STATE(6783),
    [sym__pqconsym] = STATE(6783),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(438),
    [sym__bracket_open] = STATE(966),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = ACTIONS(2627),
    [anon_sym__] = ACTIONS(2629),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_u2605] = ACTIONS(2635),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2637),
    [sym_char] = ACTIONS(2637),
    [sym_string] = ACTIONS(2637),
    [sym__integer_literal] = ACTIONS(2639),
    [sym__binary_literal] = ACTIONS(2641),
    [sym__octal_literal] = ACTIONS(2641),
    [sym__hex_literal] = ACTIONS(2641),
    [sym_implicit_variable] = ACTIONS(3313),
    [sym_name] = ACTIONS(3315),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2645),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1403] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(228),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1404] = {
    [sym__type_parens] = STATE(2335),
    [sym__type_tuple] = STATE(2337),
    [sym__type_unboxed_tuple] = STATE(2338),
    [sym__type_unboxed_sum] = STATE(2341),
    [sym__type_list] = STATE(2342),
    [sym__type_promoted] = STATE(2327),
    [sym__type_star] = STATE(2327),
    [sym__type_wildcard] = STATE(2327),
    [sym__type_apply] = STATE(2353),
    [sym__type_infix] = STATE(2352),
    [sym_type] = STATE(327),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10117),
    [sym__qtype_forall] = STATE(2381),
    [sym__qtype_forall_required] = STATE(2383),
    [sym_strict_field] = STATE(8708),
    [sym_lazy_field] = STATE(8708),
    [sym__qtype_function] = STATE(2386),
    [sym__qtype_linear_function] = STATE(2387),
    [sym__qtype_context] = STATE(2390),
    [sym_quantified_type] = STATE(2235),
    [sym_implicit_parameter] = STATE(2391),
    [sym__context_inline] = STATE(1664),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11256),
    [sym__splice_dollars] = STATE(7396),
    [sym_splice] = STATE(2327),
    [sym_quasiquote] = STATE(2327),
    [sym_integer] = STATE(2318),
    [sym__plist] = STATE(2350),
    [sym_unit] = STATE(2327),
    [sym_unboxed_unit] = STATE(2327),
    [sym_prefix_tuple] = STATE(2327),
    [sym_prefix_unboxed_tuple] = STATE(2327),
    [sym_prefix_unboxed_sum] = STATE(2327),
    [sym_literal] = STATE(2327),
    [sym__qualified_type] = STATE(2343),
    [sym__qtyconid] = STATE(2348),
    [sym__tycon_arrow] = STATE(2348),
    [sym__qtycon_arrow] = STATE(2348),
    [sym__promoted_tycons_alias] = STATE(2327),
    [sym__promoted_tycons] = STATE(2327),
    [sym__varsym_prefix] = STATE(2348),
    [sym__pvarsym] = STATE(2348),
    [sym__qvarsym_prefix] = STATE(2348),
    [sym__pqvarsym] = STATE(2348),
    [sym__consym_prefix] = STATE(2348),
    [sym__pconsym] = STATE(2348),
    [sym__qconsym_prefix] = STATE(2348),
    [sym__pqconsym] = STATE(2348),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(445),
    [sym__bracket_open] = STATE(1047),
    [sym__unboxed_open] = STATE(740),
    [sym_variable] = ACTIONS(1121),
    [anon_sym__] = ACTIONS(1127),
    [anon_sym_SQUOTE] = ACTIONS(3317),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_u2605] = ACTIONS(1133),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1139),
    [sym_char] = ACTIONS(1139),
    [sym_string] = ACTIONS(1139),
    [sym__integer_literal] = ACTIONS(1141),
    [sym__binary_literal] = ACTIONS(1143),
    [sym__octal_literal] = ACTIONS(1143),
    [sym__hex_literal] = ACTIONS(1143),
    [sym_implicit_variable] = ACTIONS(3319),
    [sym_name] = ACTIONS(3321),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1153),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1405] = {
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(291),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3252),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__paren_open] = STATE(405),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(3323),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(63),
    [sym__binary_literal] = ACTIONS(65),
    [sym__octal_literal] = ACTIONS(65),
    [sym__hex_literal] = ACTIONS(65),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1406] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(238),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1407] = {
    [sym__type_parens] = STATE(3217),
    [sym__type_tuple] = STATE(3215),
    [sym__type_unboxed_tuple] = STATE(3214),
    [sym__type_unboxed_sum] = STATE(3209),
    [sym__type_list] = STATE(3198),
    [sym__type_promoted] = STATE(3219),
    [sym__type_star] = STATE(3219),
    [sym__type_wildcard] = STATE(3219),
    [sym__type_apply] = STATE(3195),
    [sym__type_infix] = STATE(3189),
    [sym_type] = STATE(500),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10171),
    [sym__qtype_forall] = STATE(3763),
    [sym__qtype_forall_required] = STATE(3764),
    [sym_strict_field] = STATE(8629),
    [sym_lazy_field] = STATE(8629),
    [sym__qtype_function] = STATE(3765),
    [sym__qtype_linear_function] = STATE(3766),
    [sym__qtype_context] = STATE(3769),
    [sym_quantified_type] = STATE(2836),
    [sym_implicit_parameter] = STATE(3770),
    [sym__context_inline] = STATE(1407),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11305),
    [sym__splice_dollars] = STATE(7385),
    [sym_splice] = STATE(3219),
    [sym_quasiquote] = STATE(3219),
    [sym_integer] = STATE(3330),
    [sym__plist] = STATE(3185),
    [sym_unit] = STATE(3219),
    [sym_unboxed_unit] = STATE(3219),
    [sym_prefix_tuple] = STATE(3219),
    [sym_prefix_unboxed_tuple] = STATE(3219),
    [sym_prefix_unboxed_sum] = STATE(3219),
    [sym_literal] = STATE(3219),
    [sym__qualified_type] = STATE(3420),
    [sym__qtyconid] = STATE(3183),
    [sym__tycon_arrow] = STATE(3183),
    [sym__qtycon_arrow] = STATE(3183),
    [sym__promoted_tycons_alias] = STATE(3219),
    [sym__promoted_tycons] = STATE(3219),
    [sym__varsym_prefix] = STATE(3183),
    [sym__pvarsym] = STATE(3183),
    [sym__qvarsym_prefix] = STATE(3183),
    [sym__pqvarsym] = STATE(3183),
    [sym__consym_prefix] = STATE(3183),
    [sym__pconsym] = STATE(3183),
    [sym__qconsym_prefix] = STATE(3183),
    [sym__pqconsym] = STATE(3183),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(447),
    [sym__bracket_open] = STATE(976),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = ACTIONS(1629),
    [anon_sym__] = ACTIONS(1631),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_STAR] = ACTIONS(1637),
    [anon_sym_u2605] = ACTIONS(1637),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1639),
    [sym_char] = ACTIONS(1639),
    [sym_string] = ACTIONS(1639),
    [sym__integer_literal] = ACTIONS(1641),
    [sym__binary_literal] = ACTIONS(1643),
    [sym__octal_literal] = ACTIONS(1643),
    [sym__hex_literal] = ACTIONS(1643),
    [sym_implicit_variable] = ACTIONS(3307),
    [sym_name] = ACTIONS(3309),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1647),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1408] = {
    [sym__type_parens] = STATE(6922),
    [sym__type_tuple] = STATE(6929),
    [sym__type_unboxed_tuple] = STATE(6932),
    [sym__type_unboxed_sum] = STATE(6934),
    [sym__type_list] = STATE(6935),
    [sym__type_promoted] = STATE(6919),
    [sym__type_star] = STATE(6919),
    [sym__type_wildcard] = STATE(6919),
    [sym__type_apply] = STATE(6936),
    [sym__type_infix] = STATE(6937),
    [sym_type] = STATE(910),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10089),
    [sym__qtype_forall] = STATE(8937),
    [sym__qtype_forall_required] = STATE(8932),
    [sym_strict_field] = STATE(8700),
    [sym_lazy_field] = STATE(8700),
    [sym__qtype_function] = STATE(8931),
    [sym__qtype_linear_function] = STATE(8922),
    [sym__qtype_context] = STATE(8930),
    [sym_quantified_type] = STATE(8396),
    [sym_implicit_parameter] = STATE(8927),
    [sym__context_inline] = STATE(1434),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11154),
    [sym__splice_dollars] = STATE(7213),
    [sym_splice] = STATE(6919),
    [sym_quasiquote] = STATE(6919),
    [sym_integer] = STATE(6980),
    [sym__plist] = STATE(6939),
    [sym_unit] = STATE(6919),
    [sym_unboxed_unit] = STATE(6919),
    [sym_prefix_tuple] = STATE(6919),
    [sym_prefix_unboxed_tuple] = STATE(6919),
    [sym_prefix_unboxed_sum] = STATE(6919),
    [sym_literal] = STATE(6919),
    [sym__qualified_type] = STATE(7018),
    [sym__qtyconid] = STATE(6940),
    [sym__tycon_arrow] = STATE(6940),
    [sym__qtycon_arrow] = STATE(6940),
    [sym__promoted_tycons_alias] = STATE(6919),
    [sym__promoted_tycons] = STATE(6919),
    [sym__varsym_prefix] = STATE(6940),
    [sym__pvarsym] = STATE(6940),
    [sym__qvarsym_prefix] = STATE(6940),
    [sym__pqvarsym] = STATE(6940),
    [sym__consym_prefix] = STATE(6940),
    [sym__pconsym] = STATE(6940),
    [sym__qconsym_prefix] = STATE(6940),
    [sym__pqconsym] = STATE(6940),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(435),
    [sym__bracket_open] = STATE(1104),
    [sym__unboxed_open] = STATE(744),
    [sym_variable] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(2695),
    [anon_sym_SQUOTE] = ACTIONS(3325),
    [anon_sym_STAR] = ACTIONS(2701),
    [anon_sym_u2605] = ACTIONS(2701),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2703),
    [sym_char] = ACTIONS(2703),
    [sym_string] = ACTIONS(2703),
    [sym__integer_literal] = ACTIONS(2705),
    [sym__binary_literal] = ACTIONS(2707),
    [sym__octal_literal] = ACTIONS(2707),
    [sym__hex_literal] = ACTIONS(2707),
    [sym_implicit_variable] = ACTIONS(3327),
    [sym_name] = ACTIONS(3329),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2711),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1409] = {
    [sym__type_parens] = STATE(6922),
    [sym__type_tuple] = STATE(6929),
    [sym__type_unboxed_tuple] = STATE(6932),
    [sym__type_unboxed_sum] = STATE(6934),
    [sym__type_list] = STATE(6935),
    [sym__type_promoted] = STATE(6919),
    [sym__type_star] = STATE(6919),
    [sym__type_wildcard] = STATE(6919),
    [sym__type_apply] = STATE(6936),
    [sym__type_infix] = STATE(6937),
    [sym_type] = STATE(910),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10089),
    [sym__qtype_forall] = STATE(8937),
    [sym__qtype_forall_required] = STATE(8932),
    [sym_strict_field] = STATE(8700),
    [sym_lazy_field] = STATE(8700),
    [sym__qtype_function] = STATE(8931),
    [sym__qtype_linear_function] = STATE(8922),
    [sym__qtype_context] = STATE(8930),
    [sym_quantified_type] = STATE(8397),
    [sym_implicit_parameter] = STATE(8927),
    [sym__context_inline] = STATE(1434),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11154),
    [sym__splice_dollars] = STATE(7213),
    [sym_splice] = STATE(6919),
    [sym_quasiquote] = STATE(6919),
    [sym_integer] = STATE(6980),
    [sym__plist] = STATE(6939),
    [sym_unit] = STATE(6919),
    [sym_unboxed_unit] = STATE(6919),
    [sym_prefix_tuple] = STATE(6919),
    [sym_prefix_unboxed_tuple] = STATE(6919),
    [sym_prefix_unboxed_sum] = STATE(6919),
    [sym_literal] = STATE(6919),
    [sym__qualified_type] = STATE(7018),
    [sym__qtyconid] = STATE(6940),
    [sym__tycon_arrow] = STATE(6940),
    [sym__qtycon_arrow] = STATE(6940),
    [sym__promoted_tycons_alias] = STATE(6919),
    [sym__promoted_tycons] = STATE(6919),
    [sym__varsym_prefix] = STATE(6940),
    [sym__pvarsym] = STATE(6940),
    [sym__qvarsym_prefix] = STATE(6940),
    [sym__pqvarsym] = STATE(6940),
    [sym__consym_prefix] = STATE(6940),
    [sym__pconsym] = STATE(6940),
    [sym__qconsym_prefix] = STATE(6940),
    [sym__pqconsym] = STATE(6940),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(435),
    [sym__bracket_open] = STATE(1104),
    [sym__unboxed_open] = STATE(744),
    [sym_variable] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(2695),
    [anon_sym_SQUOTE] = ACTIONS(3325),
    [anon_sym_STAR] = ACTIONS(2701),
    [anon_sym_u2605] = ACTIONS(2701),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2703),
    [sym_char] = ACTIONS(2703),
    [sym_string] = ACTIONS(2703),
    [sym__integer_literal] = ACTIONS(2705),
    [sym__binary_literal] = ACTIONS(2707),
    [sym__octal_literal] = ACTIONS(2707),
    [sym__hex_literal] = ACTIONS(2707),
    [sym_implicit_variable] = ACTIONS(3327),
    [sym_name] = ACTIONS(3329),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2711),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1410] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(239),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1411] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(227),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1412] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(230),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1413] = {
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(304),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__paren_open] = STATE(402),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1414] = {
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(331),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__paren_open] = STATE(400),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1415] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(300),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(3429),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(3331),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1416] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(232),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1417] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(222),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1418] = {
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(298),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__paren_open] = STATE(402),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1419] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(292),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1420] = {
    [sym__type_parens] = STATE(3111),
    [sym__type_tuple] = STATE(3091),
    [sym__type_unboxed_tuple] = STATE(3092),
    [sym__type_unboxed_sum] = STATE(3095),
    [sym__type_list] = STATE(3100),
    [sym__type_promoted] = STATE(3123),
    [sym__type_star] = STATE(3123),
    [sym__type_wildcard] = STATE(3123),
    [sym__type_apply] = STATE(3099),
    [sym__type_infix] = STATE(3084),
    [sym_type] = STATE(425),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10091),
    [sym__qtype_forall] = STATE(3390),
    [sym__qtype_forall_required] = STATE(3387),
    [sym_strict_field] = STATE(8703),
    [sym_lazy_field] = STATE(8703),
    [sym__qtype_function] = STATE(3381),
    [sym__qtype_linear_function] = STATE(3374),
    [sym__qtype_context] = STATE(3366),
    [sym_quantified_type] = STATE(2418),
    [sym_implicit_parameter] = STATE(3363),
    [sym__context_inline] = STATE(1553),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11161),
    [sym__splice_dollars] = STATE(7411),
    [sym_splice] = STATE(3123),
    [sym_quasiquote] = STATE(3123),
    [sym_integer] = STATE(3118),
    [sym__plist] = STATE(3082),
    [sym_unit] = STATE(3123),
    [sym_unboxed_unit] = STATE(3123),
    [sym_prefix_tuple] = STATE(3123),
    [sym_prefix_unboxed_tuple] = STATE(3123),
    [sym_prefix_unboxed_sum] = STATE(3123),
    [sym_literal] = STATE(3123),
    [sym__qualified_type] = STATE(3083),
    [sym__qtyconid] = STATE(3071),
    [sym__tycon_arrow] = STATE(3071),
    [sym__qtycon_arrow] = STATE(3071),
    [sym__promoted_tycons_alias] = STATE(3123),
    [sym__promoted_tycons] = STATE(3123),
    [sym__varsym_prefix] = STATE(3071),
    [sym__pvarsym] = STATE(3071),
    [sym__qvarsym_prefix] = STATE(3071),
    [sym__pqvarsym] = STATE(3071),
    [sym__consym_prefix] = STATE(3071),
    [sym__pconsym] = STATE(3071),
    [sym__qconsym_prefix] = STATE(3071),
    [sym__pqconsym] = STATE(3071),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(441),
    [sym__bracket_open] = STATE(1101),
    [sym__unboxed_open] = STATE(764),
    [sym_variable] = ACTIONS(1343),
    [anon_sym__] = ACTIONS(1345),
    [anon_sym_SQUOTE] = ACTIONS(3333),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_u2605] = ACTIONS(1351),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1353),
    [sym_char] = ACTIONS(1353),
    [sym_string] = ACTIONS(1353),
    [sym__integer_literal] = ACTIONS(1355),
    [sym__binary_literal] = ACTIONS(1357),
    [sym__octal_literal] = ACTIONS(1357),
    [sym__hex_literal] = ACTIONS(1357),
    [sym_implicit_variable] = ACTIONS(3335),
    [sym_name] = ACTIONS(3337),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1361),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1421] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(224),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1422] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(388),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1423] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(55),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1424] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(391),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1425] = {
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(151),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__paren_open] = STATE(406),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1426] = {
    [sym__type_parens] = STATE(7755),
    [sym__type_tuple] = STATE(7759),
    [sym__type_unboxed_tuple] = STATE(7760),
    [sym__type_unboxed_sum] = STATE(7761),
    [sym__type_list] = STATE(7763),
    [sym__type_promoted] = STATE(7754),
    [sym__type_star] = STATE(7754),
    [sym__type_wildcard] = STATE(7754),
    [sym__at_type] = STATE(7784),
    [sym__type_apply] = STATE(7764),
    [sym__type_infix] = STATE(7765),
    [sym_type] = STATE(1426),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8486),
    [sym__splice_dollars] = STATE(7310),
    [sym_splice] = STATE(7754),
    [sym_quasiquote] = STATE(7754),
    [sym_integer] = STATE(7762),
    [sym__plist] = STATE(7766),
    [sym_unit] = STATE(7754),
    [sym_unboxed_unit] = STATE(7754),
    [sym_prefix_tuple] = STATE(7754),
    [sym_prefix_unboxed_tuple] = STATE(7754),
    [sym_prefix_unboxed_sum] = STATE(7754),
    [sym_literal] = STATE(7754),
    [sym__qualified_type] = STATE(7738),
    [sym__qtyconid] = STATE(7767),
    [sym__tycon_arrow] = STATE(7767),
    [sym__qtycon_arrow] = STATE(7767),
    [sym__promoted_tycons_alias] = STATE(7754),
    [sym__promoted_tycons] = STATE(7754),
    [sym__tycon_ticked] = STATE(2687),
    [sym__qtycon_ticked] = STATE(2687),
    [sym__tyconids_ticked] = STATE(2687),
    [sym__promoted_tyconops_alias] = STATE(2687),
    [sym__promoted_tyconops] = STATE(2687),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2687),
    [sym__operator_alias] = STATE(2687),
    [sym__operator_minus] = STATE(2687),
    [sym__varsym_prefix] = STATE(7767),
    [sym__pvarsym] = STATE(7767),
    [sym__qualified_varsym] = STATE(2686),
    [sym__qvarsym_prefix] = STATE(7767),
    [sym__pqvarsym] = STATE(7767),
    [sym_constructor_operator] = STATE(2687),
    [sym__constructor_operator_alias] = STATE(2687),
    [sym__consym_prefix] = STATE(7767),
    [sym__pconsym] = STATE(7767),
    [sym__qualified_consym] = STATE(2679),
    [sym__qconsym_prefix] = STATE(7767),
    [sym__pqconsym] = STATE(7767),
    [sym__prefix_at] = STATE(2547),
    [sym__paren_open] = STATE(457),
    [sym__bracket_open] = STATE(995),
    [sym__unboxed_open] = STATE(813),
    [sym_variable] = ACTIONS(1117),
    [anon_sym__] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_u2605] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_DASH_GT] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [sym_float] = ACTIONS(1119),
    [sym_char] = ACTIONS(1119),
    [sym_string] = ACTIONS(1119),
    [sym__integer_literal] = ACTIONS(1117),
    [sym__binary_literal] = ACTIONS(1119),
    [sym__octal_literal] = ACTIONS(1119),
    [sym__hex_literal] = ACTIONS(1119),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1117),
    [anon_sym_POUND2] = ACTIONS(1119),
    [sym_name] = ACTIONS(1119),
    [anon_sym_u2192] = ACTIONS(1119),
    [aux_sym__paren_open_token1] = ACTIONS(1119),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1119),
    [sym__cond_splice] = ACTIONS(1119),
    [sym__cond_prefix_dot] = ACTIONS(1119),
    [sym__cond_prefix_at] = ACTIONS(1119),
    [sym__varsym] = ACTIONS(1119),
    [sym__consym] = ACTIONS(1119),
  },
  [1427] = {
    [sym__type_parens] = STATE(7755),
    [sym__type_tuple] = STATE(7759),
    [sym__type_unboxed_tuple] = STATE(7760),
    [sym__type_unboxed_sum] = STATE(7761),
    [sym__type_list] = STATE(7763),
    [sym__type_promoted] = STATE(7754),
    [sym__type_star] = STATE(7754),
    [sym__type_wildcard] = STATE(7754),
    [sym__at_type] = STATE(7784),
    [sym__type_apply] = STATE(7764),
    [sym__type_infix] = STATE(7765),
    [sym_type] = STATE(1426),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8486),
    [sym__splice_dollars] = STATE(7310),
    [sym_splice] = STATE(7754),
    [sym_quasiquote] = STATE(7754),
    [sym_integer] = STATE(7762),
    [sym__plist] = STATE(7766),
    [sym_unit] = STATE(7754),
    [sym_unboxed_unit] = STATE(7754),
    [sym_prefix_tuple] = STATE(7754),
    [sym_prefix_unboxed_tuple] = STATE(7754),
    [sym_prefix_unboxed_sum] = STATE(7754),
    [sym_literal] = STATE(7754),
    [sym__qualified_type] = STATE(7738),
    [sym__qtyconid] = STATE(7767),
    [sym__tycon_arrow] = STATE(7767),
    [sym__qtycon_arrow] = STATE(7767),
    [sym__promoted_tycons_alias] = STATE(7754),
    [sym__promoted_tycons] = STATE(7754),
    [sym__tycon_ticked] = STATE(2687),
    [sym__qtycon_ticked] = STATE(2687),
    [sym__tyconids_ticked] = STATE(2687),
    [sym__promoted_tyconops_alias] = STATE(2687),
    [sym__promoted_tyconops] = STATE(2687),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2687),
    [sym__operator_alias] = STATE(2687),
    [sym__operator_minus] = STATE(2687),
    [sym__varsym_prefix] = STATE(7767),
    [sym__pvarsym] = STATE(7767),
    [sym__qualified_varsym] = STATE(2686),
    [sym__qvarsym_prefix] = STATE(7767),
    [sym__pqvarsym] = STATE(7767),
    [sym_constructor_operator] = STATE(2687),
    [sym__constructor_operator_alias] = STATE(2687),
    [sym__consym_prefix] = STATE(7767),
    [sym__pconsym] = STATE(7767),
    [sym__qualified_consym] = STATE(2679),
    [sym__qconsym_prefix] = STATE(7767),
    [sym__pqconsym] = STATE(7767),
    [sym__prefix_at] = STATE(2547),
    [sym__paren_open] = STATE(457),
    [sym__bracket_open] = STATE(995),
    [sym__unboxed_open] = STATE(813),
    [sym_variable] = ACTIONS(1177),
    [anon_sym__] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_u2605] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_DASH_GT] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1179),
    [sym_float] = ACTIONS(1179),
    [sym_char] = ACTIONS(1179),
    [sym_string] = ACTIONS(1179),
    [sym__integer_literal] = ACTIONS(1177),
    [sym__binary_literal] = ACTIONS(1179),
    [sym__octal_literal] = ACTIONS(1179),
    [sym__hex_literal] = ACTIONS(1179),
    [anon_sym_BQUOTE] = ACTIONS(1179),
    [anon_sym_POUND] = ACTIONS(1177),
    [anon_sym_POUND2] = ACTIONS(1179),
    [sym_name] = ACTIONS(1179),
    [anon_sym_u2192] = ACTIONS(1179),
    [aux_sym__paren_open_token1] = ACTIONS(1179),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1179),
    [sym__cond_splice] = ACTIONS(1179),
    [sym__cond_prefix_dot] = ACTIONS(1179),
    [sym__cond_prefix_at] = ACTIONS(1179),
    [sym__varsym] = ACTIONS(1179),
    [sym__consym] = ACTIONS(1179),
  },
  [1428] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8602),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1429] = {
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(235),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__paren_open] = STATE(416),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1430] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(378),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1431] = {
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(323),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__paren_open] = STATE(402),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1432] = {
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(243),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__paren_open] = STATE(416),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1433] = {
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(241),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__paren_open] = STATE(416),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1434] = {
    [sym__type_parens] = STATE(6922),
    [sym__type_tuple] = STATE(6929),
    [sym__type_unboxed_tuple] = STATE(6932),
    [sym__type_unboxed_sum] = STATE(6934),
    [sym__type_list] = STATE(6935),
    [sym__type_promoted] = STATE(6919),
    [sym__type_star] = STATE(6919),
    [sym__type_wildcard] = STATE(6919),
    [sym__type_apply] = STATE(6936),
    [sym__type_infix] = STATE(6937),
    [sym_type] = STATE(910),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10089),
    [sym__qtype_forall] = STATE(8937),
    [sym__qtype_forall_required] = STATE(8932),
    [sym_strict_field] = STATE(8700),
    [sym_lazy_field] = STATE(8700),
    [sym__qtype_function] = STATE(8931),
    [sym__qtype_linear_function] = STATE(8922),
    [sym__qtype_context] = STATE(8930),
    [sym_quantified_type] = STATE(8400),
    [sym_implicit_parameter] = STATE(8927),
    [sym__context_inline] = STATE(1434),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11154),
    [sym__splice_dollars] = STATE(7213),
    [sym_splice] = STATE(6919),
    [sym_quasiquote] = STATE(6919),
    [sym_integer] = STATE(6980),
    [sym__plist] = STATE(6939),
    [sym_unit] = STATE(6919),
    [sym_unboxed_unit] = STATE(6919),
    [sym_prefix_tuple] = STATE(6919),
    [sym_prefix_unboxed_tuple] = STATE(6919),
    [sym_prefix_unboxed_sum] = STATE(6919),
    [sym_literal] = STATE(6919),
    [sym__qualified_type] = STATE(7018),
    [sym__qtyconid] = STATE(6940),
    [sym__tycon_arrow] = STATE(6940),
    [sym__qtycon_arrow] = STATE(6940),
    [sym__promoted_tycons_alias] = STATE(6919),
    [sym__promoted_tycons] = STATE(6919),
    [sym__varsym_prefix] = STATE(6940),
    [sym__pvarsym] = STATE(6940),
    [sym__qvarsym_prefix] = STATE(6940),
    [sym__pqvarsym] = STATE(6940),
    [sym__consym_prefix] = STATE(6940),
    [sym__pconsym] = STATE(6940),
    [sym__qconsym_prefix] = STATE(6940),
    [sym__pqconsym] = STATE(6940),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(435),
    [sym__bracket_open] = STATE(1104),
    [sym__unboxed_open] = STATE(744),
    [sym_variable] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(2695),
    [anon_sym_SQUOTE] = ACTIONS(3325),
    [anon_sym_STAR] = ACTIONS(2701),
    [anon_sym_u2605] = ACTIONS(2701),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2703),
    [sym_char] = ACTIONS(2703),
    [sym_string] = ACTIONS(2703),
    [sym__integer_literal] = ACTIONS(2705),
    [sym__binary_literal] = ACTIONS(2707),
    [sym__octal_literal] = ACTIONS(2707),
    [sym__hex_literal] = ACTIONS(2707),
    [sym_implicit_variable] = ACTIONS(3327),
    [sym_name] = ACTIONS(3329),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2711),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1435] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(398),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1436] = {
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(291),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__paren_open] = STATE(405),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1437] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8424),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1438] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8416),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1439] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(207),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1440] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(7673),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1441] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8409),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1442] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(7633),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1443] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(399),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1444] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8347),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1445] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8440),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1446] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8407),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1447] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(381),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1448] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8403),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1449] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(53),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1450] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(7688),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1451] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8505),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1452] = {
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(325),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__paren_open] = STATE(402),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1453] = {
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(318),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__paren_open] = STATE(402),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1454] = {
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(293),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__paren_open] = STATE(405),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1455] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(7625),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1456] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(376),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1457] = {
    [sym__type_parens] = STATE(6909),
    [sym__type_tuple] = STATE(6883),
    [sym__type_unboxed_tuple] = STATE(6903),
    [sym__type_unboxed_sum] = STATE(6892),
    [sym__type_list] = STATE(6891),
    [sym__type_promoted] = STATE(6911),
    [sym__type_star] = STATE(6911),
    [sym__type_wildcard] = STATE(6911),
    [sym__type_apply] = STATE(6890),
    [sym__type_infix] = STATE(6959),
    [sym_type] = STATE(881),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10230),
    [sym__qtype_forall] = STATE(8887),
    [sym__qtype_forall_required] = STATE(8873),
    [sym_strict_field] = STATE(8624),
    [sym_lazy_field] = STATE(8624),
    [sym__qtype_function] = STATE(8861),
    [sym__qtype_linear_function] = STATE(8867),
    [sym__qtype_context] = STATE(8904),
    [sym_quantified_type] = STATE(8373),
    [sym_implicit_parameter] = STATE(8868),
    [sym__context_inline] = STATE(1605),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11277),
    [sym__splice_dollars] = STATE(7211),
    [sym_splice] = STATE(6911),
    [sym_quasiquote] = STATE(6911),
    [sym_integer] = STATE(6928),
    [sym__plist] = STATE(6889),
    [sym_unit] = STATE(6911),
    [sym_unboxed_unit] = STATE(6911),
    [sym_prefix_tuple] = STATE(6911),
    [sym_prefix_unboxed_tuple] = STATE(6911),
    [sym_prefix_unboxed_sum] = STATE(6911),
    [sym_literal] = STATE(6911),
    [sym__qualified_type] = STATE(6933),
    [sym__qtyconid] = STATE(6884),
    [sym__tycon_arrow] = STATE(6884),
    [sym__qtycon_arrow] = STATE(6884),
    [sym__promoted_tycons_alias] = STATE(6911),
    [sym__promoted_tycons] = STATE(6911),
    [sym__varsym_prefix] = STATE(6884),
    [sym__pvarsym] = STATE(6884),
    [sym__qvarsym_prefix] = STATE(6884),
    [sym__pqvarsym] = STATE(6884),
    [sym__consym_prefix] = STATE(6884),
    [sym__pconsym] = STATE(6884),
    [sym__qconsym_prefix] = STATE(6884),
    [sym__pqconsym] = STATE(6884),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(430),
    [sym__bracket_open] = STATE(1017),
    [sym__unboxed_open] = STATE(737),
    [sym_variable] = ACTIONS(2673),
    [anon_sym__] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(3339),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_u2605] = ACTIONS(2681),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2683),
    [sym_char] = ACTIONS(2683),
    [sym_string] = ACTIONS(2683),
    [sym__integer_literal] = ACTIONS(2685),
    [sym__binary_literal] = ACTIONS(2687),
    [sym__octal_literal] = ACTIONS(2687),
    [sym__hex_literal] = ACTIONS(2687),
    [sym_implicit_variable] = ACTIONS(3341),
    [sym_name] = ACTIONS(3343),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2691),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1458] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8419),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1459] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8413),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1460] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8506),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1461] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(7667),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1462] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8318),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1463] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8304),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1464] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(7669),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1465] = {
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(307),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__paren_open] = STATE(402),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1466] = {
    [sym__type_parens] = STATE(6766),
    [sym__type_tuple] = STATE(6767),
    [sym__type_unboxed_tuple] = STATE(6768),
    [sym__type_unboxed_sum] = STATE(6769),
    [sym__type_list] = STATE(6770),
    [sym__type_promoted] = STATE(6765),
    [sym__type_star] = STATE(6765),
    [sym__type_wildcard] = STATE(6765),
    [sym__type_apply] = STATE(6698),
    [sym__type_infix] = STATE(6780),
    [sym_type] = STATE(863),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10178),
    [sym__qtype_forall] = STATE(8836),
    [sym__qtype_forall_required] = STATE(8839),
    [sym_strict_field] = STATE(8670),
    [sym_lazy_field] = STATE(8670),
    [sym__qtype_function] = STATE(8850),
    [sym__qtype_linear_function] = STATE(8854),
    [sym__qtype_context] = STATE(8855),
    [sym_quantified_type] = STATE(8321),
    [sym_implicit_parameter] = STATE(8857),
    [sym__context_inline] = STATE(1490),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11231),
    [sym__splice_dollars] = STATE(7306),
    [sym_splice] = STATE(6765),
    [sym_quasiquote] = STATE(6765),
    [sym_integer] = STATE(6754),
    [sym__plist] = STATE(6782),
    [sym_unit] = STATE(6765),
    [sym_unboxed_unit] = STATE(6765),
    [sym_prefix_tuple] = STATE(6765),
    [sym_prefix_unboxed_tuple] = STATE(6765),
    [sym_prefix_unboxed_sum] = STATE(6765),
    [sym_literal] = STATE(6765),
    [sym__qualified_type] = STATE(6803),
    [sym__qtyconid] = STATE(6783),
    [sym__tycon_arrow] = STATE(6783),
    [sym__qtycon_arrow] = STATE(6783),
    [sym__promoted_tycons_alias] = STATE(6765),
    [sym__promoted_tycons] = STATE(6765),
    [sym__varsym_prefix] = STATE(6783),
    [sym__pvarsym] = STATE(6783),
    [sym__qvarsym_prefix] = STATE(6783),
    [sym__pqvarsym] = STATE(6783),
    [sym__consym_prefix] = STATE(6783),
    [sym__pconsym] = STATE(6783),
    [sym__qconsym_prefix] = STATE(6783),
    [sym__pqconsym] = STATE(6783),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(438),
    [sym__bracket_open] = STATE(966),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = ACTIONS(2627),
    [anon_sym__] = ACTIONS(2629),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_u2605] = ACTIONS(2635),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2637),
    [sym_char] = ACTIONS(2637),
    [sym_string] = ACTIONS(2637),
    [sym__integer_literal] = ACTIONS(2639),
    [sym__binary_literal] = ACTIONS(2641),
    [sym__octal_literal] = ACTIONS(2641),
    [sym__hex_literal] = ACTIONS(2641),
    [sym_implicit_variable] = ACTIONS(3313),
    [sym_name] = ACTIONS(3315),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2645),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1467] = {
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(125),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__paren_open] = STATE(406),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1468] = {
    [sym__type_parens] = STATE(6766),
    [sym__type_tuple] = STATE(6767),
    [sym__type_unboxed_tuple] = STATE(6768),
    [sym__type_unboxed_sum] = STATE(6769),
    [sym__type_list] = STATE(6770),
    [sym__type_promoted] = STATE(6765),
    [sym__type_star] = STATE(6765),
    [sym__type_wildcard] = STATE(6765),
    [sym__type_apply] = STATE(6698),
    [sym__type_infix] = STATE(6780),
    [sym_type] = STATE(863),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10178),
    [sym__qtype_forall] = STATE(8836),
    [sym__qtype_forall_required] = STATE(8839),
    [sym_strict_field] = STATE(8670),
    [sym_lazy_field] = STATE(8670),
    [sym__qtype_function] = STATE(8850),
    [sym__qtype_linear_function] = STATE(8854),
    [sym__qtype_context] = STATE(8855),
    [sym_quantified_type] = STATE(8322),
    [sym_implicit_parameter] = STATE(8857),
    [sym__context_inline] = STATE(1490),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11231),
    [sym__splice_dollars] = STATE(7306),
    [sym_splice] = STATE(6765),
    [sym_quasiquote] = STATE(6765),
    [sym_integer] = STATE(6754),
    [sym__plist] = STATE(6782),
    [sym_unit] = STATE(6765),
    [sym_unboxed_unit] = STATE(6765),
    [sym_prefix_tuple] = STATE(6765),
    [sym_prefix_unboxed_tuple] = STATE(6765),
    [sym_prefix_unboxed_sum] = STATE(6765),
    [sym_literal] = STATE(6765),
    [sym__qualified_type] = STATE(6803),
    [sym__qtyconid] = STATE(6783),
    [sym__tycon_arrow] = STATE(6783),
    [sym__qtycon_arrow] = STATE(6783),
    [sym__promoted_tycons_alias] = STATE(6765),
    [sym__promoted_tycons] = STATE(6765),
    [sym__varsym_prefix] = STATE(6783),
    [sym__pvarsym] = STATE(6783),
    [sym__qvarsym_prefix] = STATE(6783),
    [sym__pqvarsym] = STATE(6783),
    [sym__consym_prefix] = STATE(6783),
    [sym__pconsym] = STATE(6783),
    [sym__qconsym_prefix] = STATE(6783),
    [sym__pqconsym] = STATE(6783),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(438),
    [sym__bracket_open] = STATE(966),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = ACTIONS(2627),
    [anon_sym__] = ACTIONS(2629),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_u2605] = ACTIONS(2635),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2637),
    [sym_char] = ACTIONS(2637),
    [sym_string] = ACTIONS(2637),
    [sym__integer_literal] = ACTIONS(2639),
    [sym__binary_literal] = ACTIONS(2641),
    [sym__octal_literal] = ACTIONS(2641),
    [sym__hex_literal] = ACTIONS(2641),
    [sym_implicit_variable] = ACTIONS(3313),
    [sym_name] = ACTIONS(3315),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2645),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1469] = {
    [sym__type_parens] = STATE(6766),
    [sym__type_tuple] = STATE(6767),
    [sym__type_unboxed_tuple] = STATE(6768),
    [sym__type_unboxed_sum] = STATE(6769),
    [sym__type_list] = STATE(6770),
    [sym__type_promoted] = STATE(6765),
    [sym__type_star] = STATE(6765),
    [sym__type_wildcard] = STATE(6765),
    [sym__type_apply] = STATE(6698),
    [sym__type_infix] = STATE(6780),
    [sym_type] = STATE(863),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10178),
    [sym__qtype_forall] = STATE(8836),
    [sym__qtype_forall_required] = STATE(8839),
    [sym_strict_field] = STATE(8670),
    [sym_lazy_field] = STATE(8670),
    [sym__qtype_function] = STATE(8850),
    [sym__qtype_linear_function] = STATE(8854),
    [sym__qtype_context] = STATE(8855),
    [sym_quantified_type] = STATE(8326),
    [sym_implicit_parameter] = STATE(8857),
    [sym__context_inline] = STATE(1490),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11231),
    [sym__splice_dollars] = STATE(7306),
    [sym_splice] = STATE(6765),
    [sym_quasiquote] = STATE(6765),
    [sym_integer] = STATE(6754),
    [sym__plist] = STATE(6782),
    [sym_unit] = STATE(6765),
    [sym_unboxed_unit] = STATE(6765),
    [sym_prefix_tuple] = STATE(6765),
    [sym_prefix_unboxed_tuple] = STATE(6765),
    [sym_prefix_unboxed_sum] = STATE(6765),
    [sym_literal] = STATE(6765),
    [sym__qualified_type] = STATE(6803),
    [sym__qtyconid] = STATE(6783),
    [sym__tycon_arrow] = STATE(6783),
    [sym__qtycon_arrow] = STATE(6783),
    [sym__promoted_tycons_alias] = STATE(6765),
    [sym__promoted_tycons] = STATE(6765),
    [sym__varsym_prefix] = STATE(6783),
    [sym__pvarsym] = STATE(6783),
    [sym__qvarsym_prefix] = STATE(6783),
    [sym__pqvarsym] = STATE(6783),
    [sym__consym_prefix] = STATE(6783),
    [sym__pconsym] = STATE(6783),
    [sym__qconsym_prefix] = STATE(6783),
    [sym__pqconsym] = STATE(6783),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(438),
    [sym__bracket_open] = STATE(966),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = ACTIONS(2627),
    [anon_sym__] = ACTIONS(2629),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_u2605] = ACTIONS(2635),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2637),
    [sym_char] = ACTIONS(2637),
    [sym_string] = ACTIONS(2637),
    [sym__integer_literal] = ACTIONS(2639),
    [sym__binary_literal] = ACTIONS(2641),
    [sym__octal_literal] = ACTIONS(2641),
    [sym__hex_literal] = ACTIONS(2641),
    [sym_implicit_variable] = ACTIONS(3313),
    [sym_name] = ACTIONS(3315),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2645),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1470] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(7671),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1471] = {
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(299),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__paren_open] = STATE(402),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1472] = {
    [sym__type_parens] = STATE(6766),
    [sym__type_tuple] = STATE(6767),
    [sym__type_unboxed_tuple] = STATE(6768),
    [sym__type_unboxed_sum] = STATE(6769),
    [sym__type_list] = STATE(6770),
    [sym__type_promoted] = STATE(6765),
    [sym__type_star] = STATE(6765),
    [sym__type_wildcard] = STATE(6765),
    [sym__type_apply] = STATE(6698),
    [sym__type_infix] = STATE(6780),
    [sym_type] = STATE(863),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10178),
    [sym__qtype_forall] = STATE(8836),
    [sym__qtype_forall_required] = STATE(8839),
    [sym_strict_field] = STATE(8670),
    [sym_lazy_field] = STATE(8670),
    [sym__qtype_function] = STATE(8850),
    [sym__qtype_linear_function] = STATE(8854),
    [sym__qtype_context] = STATE(8855),
    [sym_quantified_type] = STATE(8327),
    [sym_implicit_parameter] = STATE(8857),
    [sym__context_inline] = STATE(1490),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11231),
    [sym__splice_dollars] = STATE(7306),
    [sym_splice] = STATE(6765),
    [sym_quasiquote] = STATE(6765),
    [sym_integer] = STATE(6754),
    [sym__plist] = STATE(6782),
    [sym_unit] = STATE(6765),
    [sym_unboxed_unit] = STATE(6765),
    [sym_prefix_tuple] = STATE(6765),
    [sym_prefix_unboxed_tuple] = STATE(6765),
    [sym_prefix_unboxed_sum] = STATE(6765),
    [sym_literal] = STATE(6765),
    [sym__qualified_type] = STATE(6803),
    [sym__qtyconid] = STATE(6783),
    [sym__tycon_arrow] = STATE(6783),
    [sym__qtycon_arrow] = STATE(6783),
    [sym__promoted_tycons_alias] = STATE(6765),
    [sym__promoted_tycons] = STATE(6765),
    [sym__varsym_prefix] = STATE(6783),
    [sym__pvarsym] = STATE(6783),
    [sym__qvarsym_prefix] = STATE(6783),
    [sym__pqvarsym] = STATE(6783),
    [sym__consym_prefix] = STATE(6783),
    [sym__pconsym] = STATE(6783),
    [sym__qconsym_prefix] = STATE(6783),
    [sym__pqconsym] = STATE(6783),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(438),
    [sym__bracket_open] = STATE(966),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = ACTIONS(2627),
    [anon_sym__] = ACTIONS(2629),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_u2605] = ACTIONS(2635),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2637),
    [sym_char] = ACTIONS(2637),
    [sym_string] = ACTIONS(2637),
    [sym__integer_literal] = ACTIONS(2639),
    [sym__binary_literal] = ACTIONS(2641),
    [sym__octal_literal] = ACTIONS(2641),
    [sym__hex_literal] = ACTIONS(2641),
    [sym_implicit_variable] = ACTIONS(3313),
    [sym_name] = ACTIONS(3315),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2645),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1473] = {
    [sym__type_parens] = STATE(6766),
    [sym__type_tuple] = STATE(6767),
    [sym__type_unboxed_tuple] = STATE(6768),
    [sym__type_unboxed_sum] = STATE(6769),
    [sym__type_list] = STATE(6770),
    [sym__type_promoted] = STATE(6765),
    [sym__type_star] = STATE(6765),
    [sym__type_wildcard] = STATE(6765),
    [sym__type_apply] = STATE(6698),
    [sym__type_infix] = STATE(6780),
    [sym_type] = STATE(863),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10178),
    [sym__qtype_forall] = STATE(8836),
    [sym__qtype_forall_required] = STATE(8839),
    [sym_strict_field] = STATE(8670),
    [sym_lazy_field] = STATE(8670),
    [sym__qtype_function] = STATE(8850),
    [sym__qtype_linear_function] = STATE(8854),
    [sym__qtype_context] = STATE(8855),
    [sym_quantified_type] = STATE(8331),
    [sym_implicit_parameter] = STATE(8857),
    [sym__context_inline] = STATE(1490),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11231),
    [sym__splice_dollars] = STATE(7306),
    [sym_splice] = STATE(6765),
    [sym_quasiquote] = STATE(6765),
    [sym_integer] = STATE(6754),
    [sym__plist] = STATE(6782),
    [sym_unit] = STATE(6765),
    [sym_unboxed_unit] = STATE(6765),
    [sym_prefix_tuple] = STATE(6765),
    [sym_prefix_unboxed_tuple] = STATE(6765),
    [sym_prefix_unboxed_sum] = STATE(6765),
    [sym_literal] = STATE(6765),
    [sym__qualified_type] = STATE(6803),
    [sym__qtyconid] = STATE(6783),
    [sym__tycon_arrow] = STATE(6783),
    [sym__qtycon_arrow] = STATE(6783),
    [sym__promoted_tycons_alias] = STATE(6765),
    [sym__promoted_tycons] = STATE(6765),
    [sym__varsym_prefix] = STATE(6783),
    [sym__pvarsym] = STATE(6783),
    [sym__qvarsym_prefix] = STATE(6783),
    [sym__pqvarsym] = STATE(6783),
    [sym__consym_prefix] = STATE(6783),
    [sym__pconsym] = STATE(6783),
    [sym__qconsym_prefix] = STATE(6783),
    [sym__pqconsym] = STATE(6783),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(438),
    [sym__bracket_open] = STATE(966),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = ACTIONS(2627),
    [anon_sym__] = ACTIONS(2629),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_u2605] = ACTIONS(2635),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2637),
    [sym_char] = ACTIONS(2637),
    [sym_string] = ACTIONS(2637),
    [sym__integer_literal] = ACTIONS(2639),
    [sym__binary_literal] = ACTIONS(2641),
    [sym__octal_literal] = ACTIONS(2641),
    [sym__hex_literal] = ACTIONS(2641),
    [sym_implicit_variable] = ACTIONS(3313),
    [sym_name] = ACTIONS(3315),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2645),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1474] = {
    [sym__type_parens] = STATE(6766),
    [sym__type_tuple] = STATE(6767),
    [sym__type_unboxed_tuple] = STATE(6768),
    [sym__type_unboxed_sum] = STATE(6769),
    [sym__type_list] = STATE(6770),
    [sym__type_promoted] = STATE(6765),
    [sym__type_star] = STATE(6765),
    [sym__type_wildcard] = STATE(6765),
    [sym__type_apply] = STATE(6698),
    [sym__type_infix] = STATE(6780),
    [sym_type] = STATE(863),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10178),
    [sym__qtype_forall] = STATE(8836),
    [sym__qtype_forall_required] = STATE(8839),
    [sym_strict_field] = STATE(8670),
    [sym_lazy_field] = STATE(8670),
    [sym__qtype_function] = STATE(8850),
    [sym__qtype_linear_function] = STATE(8854),
    [sym__qtype_context] = STATE(8855),
    [sym_quantified_type] = STATE(8332),
    [sym_implicit_parameter] = STATE(8857),
    [sym__context_inline] = STATE(1490),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11231),
    [sym__splice_dollars] = STATE(7306),
    [sym_splice] = STATE(6765),
    [sym_quasiquote] = STATE(6765),
    [sym_integer] = STATE(6754),
    [sym__plist] = STATE(6782),
    [sym_unit] = STATE(6765),
    [sym_unboxed_unit] = STATE(6765),
    [sym_prefix_tuple] = STATE(6765),
    [sym_prefix_unboxed_tuple] = STATE(6765),
    [sym_prefix_unboxed_sum] = STATE(6765),
    [sym_literal] = STATE(6765),
    [sym__qualified_type] = STATE(6803),
    [sym__qtyconid] = STATE(6783),
    [sym__tycon_arrow] = STATE(6783),
    [sym__qtycon_arrow] = STATE(6783),
    [sym__promoted_tycons_alias] = STATE(6765),
    [sym__promoted_tycons] = STATE(6765),
    [sym__varsym_prefix] = STATE(6783),
    [sym__pvarsym] = STATE(6783),
    [sym__qvarsym_prefix] = STATE(6783),
    [sym__pqvarsym] = STATE(6783),
    [sym__consym_prefix] = STATE(6783),
    [sym__pconsym] = STATE(6783),
    [sym__qconsym_prefix] = STATE(6783),
    [sym__pqconsym] = STATE(6783),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(438),
    [sym__bracket_open] = STATE(966),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = ACTIONS(2627),
    [anon_sym__] = ACTIONS(2629),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_u2605] = ACTIONS(2635),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2637),
    [sym_char] = ACTIONS(2637),
    [sym_string] = ACTIONS(2637),
    [sym__integer_literal] = ACTIONS(2639),
    [sym__binary_literal] = ACTIONS(2641),
    [sym__octal_literal] = ACTIONS(2641),
    [sym__hex_literal] = ACTIONS(2641),
    [sym_implicit_variable] = ACTIONS(3313),
    [sym_name] = ACTIONS(3315),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2645),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1475] = {
    [sym__type_parens] = STATE(5938),
    [sym__type_tuple] = STATE(5929),
    [sym__type_unboxed_tuple] = STATE(5928),
    [sym__type_unboxed_sum] = STATE(5927),
    [sym__type_list] = STATE(5923),
    [sym__type_promoted] = STATE(5958),
    [sym__type_star] = STATE(5958),
    [sym__type_wildcard] = STATE(5958),
    [sym__type_apply] = STATE(5917),
    [sym__type_infix] = STATE(5912),
    [sym_type] = STATE(657),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10206),
    [sym__qtype_forall] = STATE(8513),
    [sym__qtype_forall_required] = STATE(8526),
    [sym_strict_field] = STATE(8613),
    [sym_lazy_field] = STATE(8613),
    [sym__qtype_function] = STATE(8527),
    [sym__qtype_linear_function] = STATE(8528),
    [sym__qtype_context] = STATE(8530),
    [sym_quantified_type] = STATE(8137),
    [sym_implicit_parameter] = STATE(8537),
    [sym__context_inline] = STATE(1598),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11083),
    [sym__splice_dollars] = STATE(7467),
    [sym_splice] = STATE(5958),
    [sym_quasiquote] = STATE(5958),
    [sym_integer] = STATE(6013),
    [sym__plist] = STATE(5900),
    [sym_unit] = STATE(5958),
    [sym_unboxed_unit] = STATE(5958),
    [sym_prefix_tuple] = STATE(5958),
    [sym_prefix_unboxed_tuple] = STATE(5958),
    [sym_prefix_unboxed_sum] = STATE(5958),
    [sym_literal] = STATE(5958),
    [sym__qualified_type] = STATE(5983),
    [sym__qtyconid] = STATE(5894),
    [sym__tycon_arrow] = STATE(5894),
    [sym__qtycon_arrow] = STATE(5894),
    [sym__promoted_tycons_alias] = STATE(5958),
    [sym__promoted_tycons] = STATE(5958),
    [sym__varsym_prefix] = STATE(5894),
    [sym__pvarsym] = STATE(5894),
    [sym__qvarsym_prefix] = STATE(5894),
    [sym__pqvarsym] = STATE(5894),
    [sym__consym_prefix] = STATE(5894),
    [sym__pconsym] = STATE(5894),
    [sym__qconsym_prefix] = STATE(5894),
    [sym__pqconsym] = STATE(5894),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(460),
    [sym__bracket_open] = STATE(1045),
    [sym__unboxed_open] = STATE(826),
    [sym_variable] = ACTIONS(1887),
    [anon_sym__] = ACTIONS(1889),
    [anon_sym_SQUOTE] = ACTIONS(3299),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_u2605] = ACTIONS(1895),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1897),
    [sym_char] = ACTIONS(1897),
    [sym_string] = ACTIONS(1897),
    [sym__integer_literal] = ACTIONS(1899),
    [sym__binary_literal] = ACTIONS(1901),
    [sym__octal_literal] = ACTIONS(1901),
    [sym__hex_literal] = ACTIONS(1901),
    [sym_implicit_variable] = ACTIONS(3301),
    [sym_name] = ACTIONS(3303),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1905),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1476] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(387),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1477] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(217),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1478] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(240),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(3647),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(3345),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1479] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8353),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1480] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8300),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1481] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(389),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1482] = {
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(308),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(3650),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__paren_open] = STATE(402),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(3347),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(1169),
    [sym__binary_literal] = ACTIONS(1171),
    [sym__octal_literal] = ACTIONS(1171),
    [sym__hex_literal] = ACTIONS(1171),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1483] = {
    [sym__type_parens] = STATE(5999),
    [sym__type_tuple] = STATE(6002),
    [sym__type_unboxed_tuple] = STATE(6004),
    [sym__type_unboxed_sum] = STATE(6006),
    [sym__type_list] = STATE(6007),
    [sym__type_promoted] = STATE(5993),
    [sym__type_star] = STATE(5993),
    [sym__type_wildcard] = STATE(5993),
    [sym__type_apply] = STATE(6008),
    [sym__type_infix] = STATE(6009),
    [sym_type] = STATE(666),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10156),
    [sym__qtype_forall] = STATE(8532),
    [sym__qtype_forall_required] = STATE(8520),
    [sym_strict_field] = STATE(8634),
    [sym_lazy_field] = STATE(8634),
    [sym__qtype_function] = STATE(8519),
    [sym__qtype_linear_function] = STATE(8514),
    [sym__qtype_context] = STATE(8511),
    [sym_quantified_type] = STATE(8104),
    [sym_implicit_parameter] = STATE(8502),
    [sym__context_inline] = STATE(1491),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11325),
    [sym__splice_dollars] = STATE(7346),
    [sym_splice] = STATE(5993),
    [sym_quasiquote] = STATE(5993),
    [sym_integer] = STATE(5925),
    [sym__plist] = STATE(6010),
    [sym_unit] = STATE(5993),
    [sym_unboxed_unit] = STATE(5993),
    [sym_prefix_tuple] = STATE(5993),
    [sym_prefix_unboxed_tuple] = STATE(5993),
    [sym_prefix_unboxed_sum] = STATE(5993),
    [sym_literal] = STATE(5993),
    [sym__qualified_type] = STATE(5906),
    [sym__qtyconid] = STATE(6014),
    [sym__tycon_arrow] = STATE(6014),
    [sym__qtycon_arrow] = STATE(6014),
    [sym__promoted_tycons_alias] = STATE(5993),
    [sym__promoted_tycons] = STATE(5993),
    [sym__varsym_prefix] = STATE(6014),
    [sym__pvarsym] = STATE(6014),
    [sym__qvarsym_prefix] = STATE(6014),
    [sym__pqvarsym] = STATE(6014),
    [sym__consym_prefix] = STATE(6014),
    [sym__pconsym] = STATE(6014),
    [sym__qconsym_prefix] = STATE(6014),
    [sym__pqconsym] = STATE(6014),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(468),
    [sym__bracket_open] = STATE(986),
    [sym__unboxed_open] = STATE(795),
    [sym_variable] = ACTIONS(1867),
    [anon_sym__] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(1875),
    [anon_sym_u2605] = ACTIONS(1875),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1877),
    [sym_char] = ACTIONS(1877),
    [sym_string] = ACTIONS(1877),
    [sym__integer_literal] = ACTIONS(1879),
    [sym__binary_literal] = ACTIONS(1881),
    [sym__octal_literal] = ACTIONS(1881),
    [sym__hex_literal] = ACTIONS(1881),
    [sym_implicit_variable] = ACTIONS(3351),
    [sym_name] = ACTIONS(3353),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1885),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1484] = {
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(308),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__paren_open] = STATE(402),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1485] = {
    [sym__type_parens] = STATE(3111),
    [sym__type_tuple] = STATE(3091),
    [sym__type_unboxed_tuple] = STATE(3092),
    [sym__type_unboxed_sum] = STATE(3095),
    [sym__type_list] = STATE(3100),
    [sym__type_promoted] = STATE(3123),
    [sym__type_star] = STATE(3123),
    [sym__type_wildcard] = STATE(3123),
    [sym__type_apply] = STATE(3099),
    [sym__type_infix] = STATE(3084),
    [sym_type] = STATE(425),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10091),
    [sym__qtype_forall] = STATE(3390),
    [sym__qtype_forall_required] = STATE(3387),
    [sym_strict_field] = STATE(8703),
    [sym_lazy_field] = STATE(8703),
    [sym__qtype_function] = STATE(3381),
    [sym__qtype_linear_function] = STATE(3374),
    [sym__qtype_context] = STATE(3366),
    [sym_quantified_type] = STATE(2682),
    [sym_implicit_parameter] = STATE(3363),
    [sym__context_inline] = STATE(1553),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11161),
    [sym__splice_dollars] = STATE(7411),
    [sym_splice] = STATE(3123),
    [sym_quasiquote] = STATE(3123),
    [sym_integer] = STATE(3118),
    [sym__plist] = STATE(3082),
    [sym_unit] = STATE(3123),
    [sym_unboxed_unit] = STATE(3123),
    [sym_prefix_tuple] = STATE(3123),
    [sym_prefix_unboxed_tuple] = STATE(3123),
    [sym_prefix_unboxed_sum] = STATE(3123),
    [sym_literal] = STATE(3123),
    [sym__qualified_type] = STATE(3083),
    [sym__qtyconid] = STATE(3071),
    [sym__tycon_arrow] = STATE(3071),
    [sym__qtycon_arrow] = STATE(3071),
    [sym__promoted_tycons_alias] = STATE(3123),
    [sym__promoted_tycons] = STATE(3123),
    [sym__varsym_prefix] = STATE(3071),
    [sym__pvarsym] = STATE(3071),
    [sym__qvarsym_prefix] = STATE(3071),
    [sym__pqvarsym] = STATE(3071),
    [sym__consym_prefix] = STATE(3071),
    [sym__pconsym] = STATE(3071),
    [sym__qconsym_prefix] = STATE(3071),
    [sym__pqconsym] = STATE(3071),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(441),
    [sym__bracket_open] = STATE(1101),
    [sym__unboxed_open] = STATE(764),
    [sym_variable] = ACTIONS(1343),
    [anon_sym__] = ACTIONS(1345),
    [anon_sym_SQUOTE] = ACTIONS(3333),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_u2605] = ACTIONS(1351),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1353),
    [sym_char] = ACTIONS(1353),
    [sym_string] = ACTIONS(1353),
    [sym__integer_literal] = ACTIONS(1355),
    [sym__binary_literal] = ACTIONS(1357),
    [sym__octal_literal] = ACTIONS(1357),
    [sym__hex_literal] = ACTIONS(1357),
    [sym_implicit_variable] = ACTIONS(3335),
    [sym_name] = ACTIONS(3337),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1361),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1486] = {
    [sym__exp_th_quoted_name] = STATE(5503),
    [sym__exp_parens] = STATE(5502),
    [sym__exp_tuple] = STATE(5501),
    [sym__exp_unboxed_tuple] = STATE(5499),
    [sym__exp_unboxed_sum] = STATE(5498),
    [sym__exp_list] = STATE(5497),
    [sym__exp_arithmetic_sequence] = STATE(5494),
    [sym__exp_list_comprehension] = STATE(5489),
    [sym__exp_lambda] = STATE(5488),
    [sym__exp_let_in] = STATE(5487),
    [sym__exp_conditional] = STATE(5486),
    [sym__do_keyword] = STATE(11094),
    [sym_do_module] = STATE(11094),
    [sym__do] = STATE(11094),
    [sym__exp_do] = STATE(5485),
    [sym__exp_case] = STATE(5484),
    [sym__exp_lambda_case] = STATE(5512),
    [sym__exp_lambda_cases] = STATE(5482),
    [sym__exp_multi_way_if] = STATE(5481),
    [sym__exp_record] = STATE(5480),
    [sym__exp_projection_selector] = STATE(5479),
    [sym__exp_projection] = STATE(5478),
    [sym__exp_apply] = STATE(5456),
    [sym__exp_section_left] = STATE(5477),
    [sym__exp_section_right] = STATE(5476),
    [sym__exp_negation] = STATE(5475),
    [sym__exp_infix] = STATE(5474),
    [sym_expression] = STATE(297),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9393),
    [sym__splice_dollars] = STATE(7263),
    [sym_splice] = STATE(5505),
    [sym_quasiquote] = STATE(5505),
    [sym__exp_quote] = STATE(5105),
    [sym__exp_typed_quote] = STATE(5505),
    [sym_integer] = STATE(4597),
    [sym__plist] = STATE(5514),
    [sym_unit] = STATE(5505),
    [sym_unboxed_unit] = STATE(5505),
    [sym_prefix_tuple] = STATE(5505),
    [sym_prefix_unboxed_tuple] = STATE(5505),
    [sym_prefix_unboxed_sum] = STATE(5505),
    [sym_literal] = STATE(5505),
    [sym__qualified_variable] = STATE(4352),
    [sym__qvarid] = STATE(5505),
    [sym__qvar] = STATE(5505),
    [sym__qualified_constructor] = STATE(4368),
    [sym__qconid] = STATE(5505),
    [sym__varsym_prefix] = STATE(5505),
    [sym__pvarsym] = STATE(5505),
    [sym__qvarsym_prefix] = STATE(5505),
    [sym__pqvarsym] = STATE(5505),
    [sym__consym_prefix] = STATE(5515),
    [sym__pconsym] = STATE(5515),
    [sym__qconsym_prefix] = STATE(5505),
    [sym__pqconsym] = STATE(5505),
    [sym__paren_open] = STATE(402),
    [sym__bracket_open] = STATE(1075),
    [sym__unboxed_open] = STATE(832),
    [sym_variable] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_mdo] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(981),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(987),
    [sym_float] = ACTIONS(989),
    [sym_char] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym__integer_literal] = ACTIONS(991),
    [sym__binary_literal] = ACTIONS(993),
    [sym__octal_literal] = ACTIONS(993),
    [sym__hex_literal] = ACTIONS(993),
    [sym_implicit_variable] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [sym_label] = ACTIONS(995),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(999),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1487] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10122),
    [sym__qtype_forall] = STATE(9396),
    [sym__qtype_forall_required] = STATE(9395),
    [sym_strict_field] = STATE(8608),
    [sym_lazy_field] = STATE(8608),
    [sym__qtype_function] = STATE(9390),
    [sym__qtype_linear_function] = STATE(9389),
    [sym__qtype_context] = STATE(9386),
    [sym_quantified_type] = STATE(8596),
    [sym_implicit_parameter] = STATE(9379),
    [sym__context_inline] = STATE(1631),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(3355),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1488] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(216),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1489] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(212),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1490] = {
    [sym__type_parens] = STATE(6766),
    [sym__type_tuple] = STATE(6767),
    [sym__type_unboxed_tuple] = STATE(6768),
    [sym__type_unboxed_sum] = STATE(6769),
    [sym__type_list] = STATE(6770),
    [sym__type_promoted] = STATE(6765),
    [sym__type_star] = STATE(6765),
    [sym__type_wildcard] = STATE(6765),
    [sym__type_apply] = STATE(6698),
    [sym__type_infix] = STATE(6780),
    [sym_type] = STATE(863),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10178),
    [sym__qtype_forall] = STATE(8836),
    [sym__qtype_forall_required] = STATE(8839),
    [sym_strict_field] = STATE(8670),
    [sym_lazy_field] = STATE(8670),
    [sym__qtype_function] = STATE(8850),
    [sym__qtype_linear_function] = STATE(8854),
    [sym__qtype_context] = STATE(8855),
    [sym_quantified_type] = STATE(8333),
    [sym_implicit_parameter] = STATE(8857),
    [sym__context_inline] = STATE(1490),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11231),
    [sym__splice_dollars] = STATE(7306),
    [sym_splice] = STATE(6765),
    [sym_quasiquote] = STATE(6765),
    [sym_integer] = STATE(6754),
    [sym__plist] = STATE(6782),
    [sym_unit] = STATE(6765),
    [sym_unboxed_unit] = STATE(6765),
    [sym_prefix_tuple] = STATE(6765),
    [sym_prefix_unboxed_tuple] = STATE(6765),
    [sym_prefix_unboxed_sum] = STATE(6765),
    [sym_literal] = STATE(6765),
    [sym__qualified_type] = STATE(6803),
    [sym__qtyconid] = STATE(6783),
    [sym__tycon_arrow] = STATE(6783),
    [sym__qtycon_arrow] = STATE(6783),
    [sym__promoted_tycons_alias] = STATE(6765),
    [sym__promoted_tycons] = STATE(6765),
    [sym__varsym_prefix] = STATE(6783),
    [sym__pvarsym] = STATE(6783),
    [sym__qvarsym_prefix] = STATE(6783),
    [sym__pqvarsym] = STATE(6783),
    [sym__consym_prefix] = STATE(6783),
    [sym__pconsym] = STATE(6783),
    [sym__qconsym_prefix] = STATE(6783),
    [sym__pqconsym] = STATE(6783),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(438),
    [sym__bracket_open] = STATE(966),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = ACTIONS(2627),
    [anon_sym__] = ACTIONS(2629),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_u2605] = ACTIONS(2635),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2637),
    [sym_char] = ACTIONS(2637),
    [sym_string] = ACTIONS(2637),
    [sym__integer_literal] = ACTIONS(2639),
    [sym__binary_literal] = ACTIONS(2641),
    [sym__octal_literal] = ACTIONS(2641),
    [sym__hex_literal] = ACTIONS(2641),
    [sym_implicit_variable] = ACTIONS(3313),
    [sym_name] = ACTIONS(3315),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2645),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1491] = {
    [sym__type_parens] = STATE(5999),
    [sym__type_tuple] = STATE(6002),
    [sym__type_unboxed_tuple] = STATE(6004),
    [sym__type_unboxed_sum] = STATE(6006),
    [sym__type_list] = STATE(6007),
    [sym__type_promoted] = STATE(5993),
    [sym__type_star] = STATE(5993),
    [sym__type_wildcard] = STATE(5993),
    [sym__type_apply] = STATE(6008),
    [sym__type_infix] = STATE(6009),
    [sym_type] = STATE(666),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10156),
    [sym__qtype_forall] = STATE(8532),
    [sym__qtype_forall_required] = STATE(8520),
    [sym_strict_field] = STATE(8634),
    [sym_lazy_field] = STATE(8634),
    [sym__qtype_function] = STATE(8519),
    [sym__qtype_linear_function] = STATE(8514),
    [sym__qtype_context] = STATE(8511),
    [sym_quantified_type] = STATE(8103),
    [sym_implicit_parameter] = STATE(8502),
    [sym__context_inline] = STATE(1491),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11325),
    [sym__splice_dollars] = STATE(7346),
    [sym_splice] = STATE(5993),
    [sym_quasiquote] = STATE(5993),
    [sym_integer] = STATE(5925),
    [sym__plist] = STATE(6010),
    [sym_unit] = STATE(5993),
    [sym_unboxed_unit] = STATE(5993),
    [sym_prefix_tuple] = STATE(5993),
    [sym_prefix_unboxed_tuple] = STATE(5993),
    [sym_prefix_unboxed_sum] = STATE(5993),
    [sym_literal] = STATE(5993),
    [sym__qualified_type] = STATE(5906),
    [sym__qtyconid] = STATE(6014),
    [sym__tycon_arrow] = STATE(6014),
    [sym__qtycon_arrow] = STATE(6014),
    [sym__promoted_tycons_alias] = STATE(5993),
    [sym__promoted_tycons] = STATE(5993),
    [sym__varsym_prefix] = STATE(6014),
    [sym__pvarsym] = STATE(6014),
    [sym__qvarsym_prefix] = STATE(6014),
    [sym__pqvarsym] = STATE(6014),
    [sym__consym_prefix] = STATE(6014),
    [sym__pconsym] = STATE(6014),
    [sym__qconsym_prefix] = STATE(6014),
    [sym__pqconsym] = STATE(6014),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(468),
    [sym__bracket_open] = STATE(986),
    [sym__unboxed_open] = STATE(795),
    [sym_variable] = ACTIONS(1867),
    [anon_sym__] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(1875),
    [anon_sym_u2605] = ACTIONS(1875),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1877),
    [sym_char] = ACTIONS(1877),
    [sym_string] = ACTIONS(1877),
    [sym__integer_literal] = ACTIONS(1879),
    [sym__binary_literal] = ACTIONS(1881),
    [sym__octal_literal] = ACTIONS(1881),
    [sym__hex_literal] = ACTIONS(1881),
    [sym_implicit_variable] = ACTIONS(3351),
    [sym_name] = ACTIONS(3353),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1885),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1492] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(210),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1493] = {
    [sym__type_parens] = STATE(3111),
    [sym__type_tuple] = STATE(3091),
    [sym__type_unboxed_tuple] = STATE(3092),
    [sym__type_unboxed_sum] = STATE(3095),
    [sym__type_list] = STATE(3100),
    [sym__type_promoted] = STATE(3123),
    [sym__type_star] = STATE(3123),
    [sym__type_wildcard] = STATE(3123),
    [sym__type_apply] = STATE(3099),
    [sym__type_infix] = STATE(3084),
    [sym_type] = STATE(425),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10091),
    [sym__qtype_forall] = STATE(3390),
    [sym__qtype_forall_required] = STATE(3387),
    [sym_strict_field] = STATE(8703),
    [sym_lazy_field] = STATE(8703),
    [sym__qtype_function] = STATE(3381),
    [sym__qtype_linear_function] = STATE(3374),
    [sym__qtype_context] = STATE(3366),
    [sym_quantified_type] = STATE(2670),
    [sym_implicit_parameter] = STATE(3363),
    [sym__context_inline] = STATE(1553),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11161),
    [sym__splice_dollars] = STATE(7411),
    [sym_splice] = STATE(3123),
    [sym_quasiquote] = STATE(3123),
    [sym_integer] = STATE(3118),
    [sym__plist] = STATE(3082),
    [sym_unit] = STATE(3123),
    [sym_unboxed_unit] = STATE(3123),
    [sym_prefix_tuple] = STATE(3123),
    [sym_prefix_unboxed_tuple] = STATE(3123),
    [sym_prefix_unboxed_sum] = STATE(3123),
    [sym_literal] = STATE(3123),
    [sym__qualified_type] = STATE(3083),
    [sym__qtyconid] = STATE(3071),
    [sym__tycon_arrow] = STATE(3071),
    [sym__qtycon_arrow] = STATE(3071),
    [sym__promoted_tycons_alias] = STATE(3123),
    [sym__promoted_tycons] = STATE(3123),
    [sym__varsym_prefix] = STATE(3071),
    [sym__pvarsym] = STATE(3071),
    [sym__qvarsym_prefix] = STATE(3071),
    [sym__pqvarsym] = STATE(3071),
    [sym__consym_prefix] = STATE(3071),
    [sym__pconsym] = STATE(3071),
    [sym__qconsym_prefix] = STATE(3071),
    [sym__pqconsym] = STATE(3071),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(441),
    [sym__bracket_open] = STATE(1101),
    [sym__unboxed_open] = STATE(764),
    [sym_variable] = ACTIONS(1343),
    [anon_sym__] = ACTIONS(1345),
    [anon_sym_SQUOTE] = ACTIONS(3333),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_u2605] = ACTIONS(1351),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1353),
    [sym_char] = ACTIONS(1353),
    [sym_string] = ACTIONS(1353),
    [sym__integer_literal] = ACTIONS(1355),
    [sym__binary_literal] = ACTIONS(1357),
    [sym__octal_literal] = ACTIONS(1357),
    [sym__hex_literal] = ACTIONS(1357),
    [sym_implicit_variable] = ACTIONS(3335),
    [sym_name] = ACTIONS(3337),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1361),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1494] = {
    [sym__type_parens] = STATE(6909),
    [sym__type_tuple] = STATE(6883),
    [sym__type_unboxed_tuple] = STATE(6903),
    [sym__type_unboxed_sum] = STATE(6892),
    [sym__type_list] = STATE(6891),
    [sym__type_promoted] = STATE(6911),
    [sym__type_star] = STATE(6911),
    [sym__type_wildcard] = STATE(6911),
    [sym__type_apply] = STATE(6890),
    [sym__type_infix] = STATE(6959),
    [sym_type] = STATE(881),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10230),
    [sym__qtype_forall] = STATE(8887),
    [sym__qtype_forall_required] = STATE(8873),
    [sym_strict_field] = STATE(8624),
    [sym_lazy_field] = STATE(8624),
    [sym__qtype_function] = STATE(8861),
    [sym__qtype_linear_function] = STATE(8867),
    [sym__qtype_context] = STATE(8904),
    [sym_quantified_type] = STATE(8369),
    [sym_implicit_parameter] = STATE(8868),
    [sym__context_inline] = STATE(1605),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11277),
    [sym__splice_dollars] = STATE(7211),
    [sym_splice] = STATE(6911),
    [sym_quasiquote] = STATE(6911),
    [sym_integer] = STATE(6928),
    [sym__plist] = STATE(6889),
    [sym_unit] = STATE(6911),
    [sym_unboxed_unit] = STATE(6911),
    [sym_prefix_tuple] = STATE(6911),
    [sym_prefix_unboxed_tuple] = STATE(6911),
    [sym_prefix_unboxed_sum] = STATE(6911),
    [sym_literal] = STATE(6911),
    [sym__qualified_type] = STATE(6933),
    [sym__qtyconid] = STATE(6884),
    [sym__tycon_arrow] = STATE(6884),
    [sym__qtycon_arrow] = STATE(6884),
    [sym__promoted_tycons_alias] = STATE(6911),
    [sym__promoted_tycons] = STATE(6911),
    [sym__varsym_prefix] = STATE(6884),
    [sym__pvarsym] = STATE(6884),
    [sym__qvarsym_prefix] = STATE(6884),
    [sym__pqvarsym] = STATE(6884),
    [sym__consym_prefix] = STATE(6884),
    [sym__pconsym] = STATE(6884),
    [sym__qconsym_prefix] = STATE(6884),
    [sym__pqconsym] = STATE(6884),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(430),
    [sym__bracket_open] = STATE(1017),
    [sym__unboxed_open] = STATE(737),
    [sym_variable] = ACTIONS(2673),
    [anon_sym__] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(3339),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_u2605] = ACTIONS(2681),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2683),
    [sym_char] = ACTIONS(2683),
    [sym_string] = ACTIONS(2683),
    [sym__integer_literal] = ACTIONS(2685),
    [sym__binary_literal] = ACTIONS(2687),
    [sym__octal_literal] = ACTIONS(2687),
    [sym__hex_literal] = ACTIONS(2687),
    [sym_implicit_variable] = ACTIONS(3341),
    [sym_name] = ACTIONS(3343),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2691),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1495] = {
    [sym__type_parens] = STATE(6909),
    [sym__type_tuple] = STATE(6883),
    [sym__type_unboxed_tuple] = STATE(6903),
    [sym__type_unboxed_sum] = STATE(6892),
    [sym__type_list] = STATE(6891),
    [sym__type_promoted] = STATE(6911),
    [sym__type_star] = STATE(6911),
    [sym__type_wildcard] = STATE(6911),
    [sym__type_apply] = STATE(6890),
    [sym__type_infix] = STATE(6959),
    [sym_type] = STATE(881),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10230),
    [sym__qtype_forall] = STATE(8887),
    [sym__qtype_forall_required] = STATE(8873),
    [sym_strict_field] = STATE(8624),
    [sym_lazy_field] = STATE(8624),
    [sym__qtype_function] = STATE(8861),
    [sym__qtype_linear_function] = STATE(8867),
    [sym__qtype_context] = STATE(8904),
    [sym_quantified_type] = STATE(8368),
    [sym_implicit_parameter] = STATE(8868),
    [sym__context_inline] = STATE(1605),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11277),
    [sym__splice_dollars] = STATE(7211),
    [sym_splice] = STATE(6911),
    [sym_quasiquote] = STATE(6911),
    [sym_integer] = STATE(6928),
    [sym__plist] = STATE(6889),
    [sym_unit] = STATE(6911),
    [sym_unboxed_unit] = STATE(6911),
    [sym_prefix_tuple] = STATE(6911),
    [sym_prefix_unboxed_tuple] = STATE(6911),
    [sym_prefix_unboxed_sum] = STATE(6911),
    [sym_literal] = STATE(6911),
    [sym__qualified_type] = STATE(6933),
    [sym__qtyconid] = STATE(6884),
    [sym__tycon_arrow] = STATE(6884),
    [sym__qtycon_arrow] = STATE(6884),
    [sym__promoted_tycons_alias] = STATE(6911),
    [sym__promoted_tycons] = STATE(6911),
    [sym__varsym_prefix] = STATE(6884),
    [sym__pvarsym] = STATE(6884),
    [sym__qvarsym_prefix] = STATE(6884),
    [sym__pqvarsym] = STATE(6884),
    [sym__consym_prefix] = STATE(6884),
    [sym__pconsym] = STATE(6884),
    [sym__qconsym_prefix] = STATE(6884),
    [sym__pqconsym] = STATE(6884),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(430),
    [sym__bracket_open] = STATE(1017),
    [sym__unboxed_open] = STATE(737),
    [sym_variable] = ACTIONS(2673),
    [anon_sym__] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(3339),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_u2605] = ACTIONS(2681),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2683),
    [sym_char] = ACTIONS(2683),
    [sym_string] = ACTIONS(2683),
    [sym__integer_literal] = ACTIONS(2685),
    [sym__binary_literal] = ACTIONS(2687),
    [sym__octal_literal] = ACTIONS(2687),
    [sym__hex_literal] = ACTIONS(2687),
    [sym_implicit_variable] = ACTIONS(3341),
    [sym_name] = ACTIONS(3343),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2691),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1496] = {
    [sym__type_parens] = STATE(3579),
    [sym__type_tuple] = STATE(3576),
    [sym__type_unboxed_tuple] = STATE(3572),
    [sym__type_unboxed_sum] = STATE(3570),
    [sym__type_list] = STATE(3569),
    [sym__type_promoted] = STATE(3582),
    [sym__type_star] = STATE(3582),
    [sym__type_wildcard] = STATE(3582),
    [sym__type_apply] = STATE(3567),
    [sym__type_infix] = STATE(3561),
    [sym_type] = STATE(511),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10109),
    [sym__qtype_forall] = STATE(3889),
    [sym__qtype_forall_required] = STATE(3901),
    [sym_strict_field] = STATE(8615),
    [sym_lazy_field] = STATE(8615),
    [sym__qtype_function] = STATE(3902),
    [sym__qtype_linear_function] = STATE(3905),
    [sym__qtype_context] = STATE(3909),
    [sym_quantified_type] = STATE(2911),
    [sym_implicit_parameter] = STATE(3910),
    [sym__context_inline] = STATE(1708),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11208),
    [sym__splice_dollars] = STATE(7292),
    [sym_splice] = STATE(3582),
    [sym_quasiquote] = STATE(3582),
    [sym_integer] = STATE(3435),
    [sym__plist] = STATE(3559),
    [sym_unit] = STATE(3582),
    [sym_unboxed_unit] = STATE(3582),
    [sym_prefix_tuple] = STATE(3582),
    [sym_prefix_unboxed_tuple] = STATE(3582),
    [sym_prefix_unboxed_sum] = STATE(3582),
    [sym_literal] = STATE(3582),
    [sym__qualified_type] = STATE(3610),
    [sym__qtyconid] = STATE(3556),
    [sym__tycon_arrow] = STATE(3556),
    [sym__qtycon_arrow] = STATE(3556),
    [sym__promoted_tycons_alias] = STATE(3582),
    [sym__promoted_tycons] = STATE(3582),
    [sym__varsym_prefix] = STATE(3556),
    [sym__pvarsym] = STATE(3556),
    [sym__qvarsym_prefix] = STATE(3556),
    [sym__pqvarsym] = STATE(3556),
    [sym__consym_prefix] = STATE(3556),
    [sym__pconsym] = STATE(3556),
    [sym__qconsym_prefix] = STATE(3556),
    [sym__pqconsym] = STATE(3556),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(465),
    [sym__bracket_open] = STATE(1069),
    [sym__unboxed_open] = STATE(772),
    [sym_variable] = ACTIONS(1649),
    [anon_sym__] = ACTIONS(1651),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_u2605] = ACTIONS(1657),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1659),
    [sym_char] = ACTIONS(1659),
    [sym_string] = ACTIONS(1659),
    [sym__integer_literal] = ACTIONS(1661),
    [sym__binary_literal] = ACTIONS(1663),
    [sym__octal_literal] = ACTIONS(1663),
    [sym__hex_literal] = ACTIONS(1663),
    [sym_implicit_variable] = ACTIONS(3359),
    [sym_name] = ACTIONS(3361),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1667),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1497] = {
    [sym__type_parens] = STATE(3217),
    [sym__type_tuple] = STATE(3215),
    [sym__type_unboxed_tuple] = STATE(3214),
    [sym__type_unboxed_sum] = STATE(3209),
    [sym__type_list] = STATE(3198),
    [sym__type_promoted] = STATE(3219),
    [sym__type_star] = STATE(3219),
    [sym__type_wildcard] = STATE(3219),
    [sym__type_apply] = STATE(3195),
    [sym__type_infix] = STATE(3189),
    [sym_type] = STATE(500),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10171),
    [sym__qtype_forall] = STATE(3763),
    [sym__qtype_forall_required] = STATE(3764),
    [sym_strict_field] = STATE(8629),
    [sym_lazy_field] = STATE(8629),
    [sym__qtype_function] = STATE(3765),
    [sym__qtype_linear_function] = STATE(3766),
    [sym__qtype_context] = STATE(3769),
    [sym_quantified_type] = STATE(2802),
    [sym_implicit_parameter] = STATE(3770),
    [sym__context_inline] = STATE(1407),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11305),
    [sym__splice_dollars] = STATE(7385),
    [sym_splice] = STATE(3219),
    [sym_quasiquote] = STATE(3219),
    [sym_integer] = STATE(3330),
    [sym__plist] = STATE(3185),
    [sym_unit] = STATE(3219),
    [sym_unboxed_unit] = STATE(3219),
    [sym_prefix_tuple] = STATE(3219),
    [sym_prefix_unboxed_tuple] = STATE(3219),
    [sym_prefix_unboxed_sum] = STATE(3219),
    [sym_literal] = STATE(3219),
    [sym__qualified_type] = STATE(3420),
    [sym__qtyconid] = STATE(3183),
    [sym__tycon_arrow] = STATE(3183),
    [sym__qtycon_arrow] = STATE(3183),
    [sym__promoted_tycons_alias] = STATE(3219),
    [sym__promoted_tycons] = STATE(3219),
    [sym__varsym_prefix] = STATE(3183),
    [sym__pvarsym] = STATE(3183),
    [sym__qvarsym_prefix] = STATE(3183),
    [sym__pqvarsym] = STATE(3183),
    [sym__consym_prefix] = STATE(3183),
    [sym__pconsym] = STATE(3183),
    [sym__qconsym_prefix] = STATE(3183),
    [sym__pqconsym] = STATE(3183),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(447),
    [sym__bracket_open] = STATE(976),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = ACTIONS(1629),
    [anon_sym__] = ACTIONS(1631),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_STAR] = ACTIONS(1637),
    [anon_sym_u2605] = ACTIONS(1637),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1639),
    [sym_char] = ACTIONS(1639),
    [sym_string] = ACTIONS(1639),
    [sym__integer_literal] = ACTIONS(1641),
    [sym__binary_literal] = ACTIONS(1643),
    [sym__octal_literal] = ACTIONS(1643),
    [sym__hex_literal] = ACTIONS(1643),
    [sym_implicit_variable] = ACTIONS(3307),
    [sym_name] = ACTIONS(3309),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1647),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1498] = {
    [sym__type_parens] = STATE(6909),
    [sym__type_tuple] = STATE(6883),
    [sym__type_unboxed_tuple] = STATE(6903),
    [sym__type_unboxed_sum] = STATE(6892),
    [sym__type_list] = STATE(6891),
    [sym__type_promoted] = STATE(6911),
    [sym__type_star] = STATE(6911),
    [sym__type_wildcard] = STATE(6911),
    [sym__type_apply] = STATE(6890),
    [sym__type_infix] = STATE(6959),
    [sym_type] = STATE(881),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10230),
    [sym__qtype_forall] = STATE(8887),
    [sym__qtype_forall_required] = STATE(8873),
    [sym_strict_field] = STATE(8624),
    [sym_lazy_field] = STATE(8624),
    [sym__qtype_function] = STATE(8861),
    [sym__qtype_linear_function] = STATE(8867),
    [sym__qtype_context] = STATE(8904),
    [sym_quantified_type] = STATE(8367),
    [sym_implicit_parameter] = STATE(8868),
    [sym__context_inline] = STATE(1605),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11277),
    [sym__splice_dollars] = STATE(7211),
    [sym_splice] = STATE(6911),
    [sym_quasiquote] = STATE(6911),
    [sym_integer] = STATE(6928),
    [sym__plist] = STATE(6889),
    [sym_unit] = STATE(6911),
    [sym_unboxed_unit] = STATE(6911),
    [sym_prefix_tuple] = STATE(6911),
    [sym_prefix_unboxed_tuple] = STATE(6911),
    [sym_prefix_unboxed_sum] = STATE(6911),
    [sym_literal] = STATE(6911),
    [sym__qualified_type] = STATE(6933),
    [sym__qtyconid] = STATE(6884),
    [sym__tycon_arrow] = STATE(6884),
    [sym__qtycon_arrow] = STATE(6884),
    [sym__promoted_tycons_alias] = STATE(6911),
    [sym__promoted_tycons] = STATE(6911),
    [sym__varsym_prefix] = STATE(6884),
    [sym__pvarsym] = STATE(6884),
    [sym__qvarsym_prefix] = STATE(6884),
    [sym__pqvarsym] = STATE(6884),
    [sym__consym_prefix] = STATE(6884),
    [sym__pconsym] = STATE(6884),
    [sym__qconsym_prefix] = STATE(6884),
    [sym__pqconsym] = STATE(6884),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(430),
    [sym__bracket_open] = STATE(1017),
    [sym__unboxed_open] = STATE(737),
    [sym_variable] = ACTIONS(2673),
    [anon_sym__] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(3339),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_u2605] = ACTIONS(2681),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2683),
    [sym_char] = ACTIONS(2683),
    [sym_string] = ACTIONS(2683),
    [sym__integer_literal] = ACTIONS(2685),
    [sym__binary_literal] = ACTIONS(2687),
    [sym__octal_literal] = ACTIONS(2687),
    [sym__hex_literal] = ACTIONS(2687),
    [sym_implicit_variable] = ACTIONS(3341),
    [sym_name] = ACTIONS(3343),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2691),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1499] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(59),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1500] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(58),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1501] = {
    [sym__type_parens] = STATE(6909),
    [sym__type_tuple] = STATE(6883),
    [sym__type_unboxed_tuple] = STATE(6903),
    [sym__type_unboxed_sum] = STATE(6892),
    [sym__type_list] = STATE(6891),
    [sym__type_promoted] = STATE(6911),
    [sym__type_star] = STATE(6911),
    [sym__type_wildcard] = STATE(6911),
    [sym__type_apply] = STATE(6890),
    [sym__type_infix] = STATE(6959),
    [sym_type] = STATE(881),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10230),
    [sym__qtype_forall] = STATE(8887),
    [sym__qtype_forall_required] = STATE(8873),
    [sym_strict_field] = STATE(8624),
    [sym_lazy_field] = STATE(8624),
    [sym__qtype_function] = STATE(8861),
    [sym__qtype_linear_function] = STATE(8867),
    [sym__qtype_context] = STATE(8904),
    [sym_quantified_type] = STATE(8366),
    [sym_implicit_parameter] = STATE(8868),
    [sym__context_inline] = STATE(1605),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11277),
    [sym__splice_dollars] = STATE(7211),
    [sym_splice] = STATE(6911),
    [sym_quasiquote] = STATE(6911),
    [sym_integer] = STATE(6928),
    [sym__plist] = STATE(6889),
    [sym_unit] = STATE(6911),
    [sym_unboxed_unit] = STATE(6911),
    [sym_prefix_tuple] = STATE(6911),
    [sym_prefix_unboxed_tuple] = STATE(6911),
    [sym_prefix_unboxed_sum] = STATE(6911),
    [sym_literal] = STATE(6911),
    [sym__qualified_type] = STATE(6933),
    [sym__qtyconid] = STATE(6884),
    [sym__tycon_arrow] = STATE(6884),
    [sym__qtycon_arrow] = STATE(6884),
    [sym__promoted_tycons_alias] = STATE(6911),
    [sym__promoted_tycons] = STATE(6911),
    [sym__varsym_prefix] = STATE(6884),
    [sym__pvarsym] = STATE(6884),
    [sym__qvarsym_prefix] = STATE(6884),
    [sym__pqvarsym] = STATE(6884),
    [sym__consym_prefix] = STATE(6884),
    [sym__pconsym] = STATE(6884),
    [sym__qconsym_prefix] = STATE(6884),
    [sym__pqconsym] = STATE(6884),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(430),
    [sym__bracket_open] = STATE(1017),
    [sym__unboxed_open] = STATE(737),
    [sym_variable] = ACTIONS(2673),
    [anon_sym__] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(3339),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_u2605] = ACTIONS(2681),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2683),
    [sym_char] = ACTIONS(2683),
    [sym_string] = ACTIONS(2683),
    [sym__integer_literal] = ACTIONS(2685),
    [sym__binary_literal] = ACTIONS(2687),
    [sym__octal_literal] = ACTIONS(2687),
    [sym__hex_literal] = ACTIONS(2687),
    [sym_implicit_variable] = ACTIONS(3341),
    [sym_name] = ACTIONS(3343),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2691),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1502] = {
    [sym__type_parens] = STATE(3111),
    [sym__type_tuple] = STATE(3091),
    [sym__type_unboxed_tuple] = STATE(3092),
    [sym__type_unboxed_sum] = STATE(3095),
    [sym__type_list] = STATE(3100),
    [sym__type_promoted] = STATE(3123),
    [sym__type_star] = STATE(3123),
    [sym__type_wildcard] = STATE(3123),
    [sym__type_apply] = STATE(3099),
    [sym__type_infix] = STATE(3084),
    [sym_type] = STATE(425),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10091),
    [sym__qtype_forall] = STATE(3390),
    [sym__qtype_forall_required] = STATE(3387),
    [sym_strict_field] = STATE(8703),
    [sym_lazy_field] = STATE(8703),
    [sym__qtype_function] = STATE(3381),
    [sym__qtype_linear_function] = STATE(3374),
    [sym__qtype_context] = STATE(3366),
    [sym_quantified_type] = STATE(2669),
    [sym_implicit_parameter] = STATE(3363),
    [sym__context_inline] = STATE(1553),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11161),
    [sym__splice_dollars] = STATE(7411),
    [sym_splice] = STATE(3123),
    [sym_quasiquote] = STATE(3123),
    [sym_integer] = STATE(3118),
    [sym__plist] = STATE(3082),
    [sym_unit] = STATE(3123),
    [sym_unboxed_unit] = STATE(3123),
    [sym_prefix_tuple] = STATE(3123),
    [sym_prefix_unboxed_tuple] = STATE(3123),
    [sym_prefix_unboxed_sum] = STATE(3123),
    [sym_literal] = STATE(3123),
    [sym__qualified_type] = STATE(3083),
    [sym__qtyconid] = STATE(3071),
    [sym__tycon_arrow] = STATE(3071),
    [sym__qtycon_arrow] = STATE(3071),
    [sym__promoted_tycons_alias] = STATE(3123),
    [sym__promoted_tycons] = STATE(3123),
    [sym__varsym_prefix] = STATE(3071),
    [sym__pvarsym] = STATE(3071),
    [sym__qvarsym_prefix] = STATE(3071),
    [sym__pqvarsym] = STATE(3071),
    [sym__consym_prefix] = STATE(3071),
    [sym__pconsym] = STATE(3071),
    [sym__qconsym_prefix] = STATE(3071),
    [sym__pqconsym] = STATE(3071),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(441),
    [sym__bracket_open] = STATE(1101),
    [sym__unboxed_open] = STATE(764),
    [sym_variable] = ACTIONS(1343),
    [anon_sym__] = ACTIONS(1345),
    [anon_sym_SQUOTE] = ACTIONS(3333),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_u2605] = ACTIONS(1351),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1353),
    [sym_char] = ACTIONS(1353),
    [sym_string] = ACTIONS(1353),
    [sym__integer_literal] = ACTIONS(1355),
    [sym__binary_literal] = ACTIONS(1357),
    [sym__octal_literal] = ACTIONS(1357),
    [sym__hex_literal] = ACTIONS(1357),
    [sym_implicit_variable] = ACTIONS(3335),
    [sym_name] = ACTIONS(3337),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1361),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1503] = {
    [sym__type_parens] = STATE(5999),
    [sym__type_tuple] = STATE(6002),
    [sym__type_unboxed_tuple] = STATE(6004),
    [sym__type_unboxed_sum] = STATE(6006),
    [sym__type_list] = STATE(6007),
    [sym__type_promoted] = STATE(5993),
    [sym__type_star] = STATE(5993),
    [sym__type_wildcard] = STATE(5993),
    [sym__type_apply] = STATE(6008),
    [sym__type_infix] = STATE(6009),
    [sym_type] = STATE(666),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10156),
    [sym__qtype_forall] = STATE(8532),
    [sym__qtype_forall_required] = STATE(8520),
    [sym_strict_field] = STATE(8634),
    [sym_lazy_field] = STATE(8634),
    [sym__qtype_function] = STATE(8519),
    [sym__qtype_linear_function] = STATE(8514),
    [sym__qtype_context] = STATE(8511),
    [sym_quantified_type] = STATE(8101),
    [sym_implicit_parameter] = STATE(8502),
    [sym__context_inline] = STATE(1491),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11325),
    [sym__splice_dollars] = STATE(7346),
    [sym_splice] = STATE(5993),
    [sym_quasiquote] = STATE(5993),
    [sym_integer] = STATE(5925),
    [sym__plist] = STATE(6010),
    [sym_unit] = STATE(5993),
    [sym_unboxed_unit] = STATE(5993),
    [sym_prefix_tuple] = STATE(5993),
    [sym_prefix_unboxed_tuple] = STATE(5993),
    [sym_prefix_unboxed_sum] = STATE(5993),
    [sym_literal] = STATE(5993),
    [sym__qualified_type] = STATE(5906),
    [sym__qtyconid] = STATE(6014),
    [sym__tycon_arrow] = STATE(6014),
    [sym__qtycon_arrow] = STATE(6014),
    [sym__promoted_tycons_alias] = STATE(5993),
    [sym__promoted_tycons] = STATE(5993),
    [sym__varsym_prefix] = STATE(6014),
    [sym__pvarsym] = STATE(6014),
    [sym__qvarsym_prefix] = STATE(6014),
    [sym__pqvarsym] = STATE(6014),
    [sym__consym_prefix] = STATE(6014),
    [sym__pconsym] = STATE(6014),
    [sym__qconsym_prefix] = STATE(6014),
    [sym__pqconsym] = STATE(6014),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(468),
    [sym__bracket_open] = STATE(986),
    [sym__unboxed_open] = STATE(795),
    [sym_variable] = ACTIONS(1867),
    [anon_sym__] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(1875),
    [anon_sym_u2605] = ACTIONS(1875),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1877),
    [sym_char] = ACTIONS(1877),
    [sym_string] = ACTIONS(1877),
    [sym__integer_literal] = ACTIONS(1879),
    [sym__binary_literal] = ACTIONS(1881),
    [sym__octal_literal] = ACTIONS(1881),
    [sym__hex_literal] = ACTIONS(1881),
    [sym_implicit_variable] = ACTIONS(3351),
    [sym_name] = ACTIONS(3353),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1885),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1504] = {
    [sym__type_parens] = STATE(5999),
    [sym__type_tuple] = STATE(6002),
    [sym__type_unboxed_tuple] = STATE(6004),
    [sym__type_unboxed_sum] = STATE(6006),
    [sym__type_list] = STATE(6007),
    [sym__type_promoted] = STATE(5993),
    [sym__type_star] = STATE(5993),
    [sym__type_wildcard] = STATE(5993),
    [sym__type_apply] = STATE(6008),
    [sym__type_infix] = STATE(6009),
    [sym_type] = STATE(666),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10156),
    [sym__qtype_forall] = STATE(8532),
    [sym__qtype_forall_required] = STATE(8520),
    [sym_strict_field] = STATE(8634),
    [sym_lazy_field] = STATE(8634),
    [sym__qtype_function] = STATE(8519),
    [sym__qtype_linear_function] = STATE(8514),
    [sym__qtype_context] = STATE(8511),
    [sym_quantified_type] = STATE(8100),
    [sym_implicit_parameter] = STATE(8502),
    [sym__context_inline] = STATE(1491),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11325),
    [sym__splice_dollars] = STATE(7346),
    [sym_splice] = STATE(5993),
    [sym_quasiquote] = STATE(5993),
    [sym_integer] = STATE(5925),
    [sym__plist] = STATE(6010),
    [sym_unit] = STATE(5993),
    [sym_unboxed_unit] = STATE(5993),
    [sym_prefix_tuple] = STATE(5993),
    [sym_prefix_unboxed_tuple] = STATE(5993),
    [sym_prefix_unboxed_sum] = STATE(5993),
    [sym_literal] = STATE(5993),
    [sym__qualified_type] = STATE(5906),
    [sym__qtyconid] = STATE(6014),
    [sym__tycon_arrow] = STATE(6014),
    [sym__qtycon_arrow] = STATE(6014),
    [sym__promoted_tycons_alias] = STATE(5993),
    [sym__promoted_tycons] = STATE(5993),
    [sym__varsym_prefix] = STATE(6014),
    [sym__pvarsym] = STATE(6014),
    [sym__qvarsym_prefix] = STATE(6014),
    [sym__pqvarsym] = STATE(6014),
    [sym__consym_prefix] = STATE(6014),
    [sym__pconsym] = STATE(6014),
    [sym__qconsym_prefix] = STATE(6014),
    [sym__pqconsym] = STATE(6014),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(468),
    [sym__bracket_open] = STATE(986),
    [sym__unboxed_open] = STATE(795),
    [sym_variable] = ACTIONS(1867),
    [anon_sym__] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(1875),
    [anon_sym_u2605] = ACTIONS(1875),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1877),
    [sym_char] = ACTIONS(1877),
    [sym_string] = ACTIONS(1877),
    [sym__integer_literal] = ACTIONS(1879),
    [sym__binary_literal] = ACTIONS(1881),
    [sym__octal_literal] = ACTIONS(1881),
    [sym__hex_literal] = ACTIONS(1881),
    [sym_implicit_variable] = ACTIONS(3351),
    [sym_name] = ACTIONS(3353),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1885),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1505] = {
    [sym__type_parens] = STATE(5999),
    [sym__type_tuple] = STATE(6002),
    [sym__type_unboxed_tuple] = STATE(6004),
    [sym__type_unboxed_sum] = STATE(6006),
    [sym__type_list] = STATE(6007),
    [sym__type_promoted] = STATE(5993),
    [sym__type_star] = STATE(5993),
    [sym__type_wildcard] = STATE(5993),
    [sym__type_apply] = STATE(6008),
    [sym__type_infix] = STATE(6009),
    [sym_type] = STATE(666),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10156),
    [sym__qtype_forall] = STATE(8532),
    [sym__qtype_forall_required] = STATE(8520),
    [sym_strict_field] = STATE(8634),
    [sym_lazy_field] = STATE(8634),
    [sym__qtype_function] = STATE(8519),
    [sym__qtype_linear_function] = STATE(8514),
    [sym__qtype_context] = STATE(8511),
    [sym_quantified_type] = STATE(8099),
    [sym_implicit_parameter] = STATE(8502),
    [sym__context_inline] = STATE(1491),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11325),
    [sym__splice_dollars] = STATE(7346),
    [sym_splice] = STATE(5993),
    [sym_quasiquote] = STATE(5993),
    [sym_integer] = STATE(5925),
    [sym__plist] = STATE(6010),
    [sym_unit] = STATE(5993),
    [sym_unboxed_unit] = STATE(5993),
    [sym_prefix_tuple] = STATE(5993),
    [sym_prefix_unboxed_tuple] = STATE(5993),
    [sym_prefix_unboxed_sum] = STATE(5993),
    [sym_literal] = STATE(5993),
    [sym__qualified_type] = STATE(5906),
    [sym__qtyconid] = STATE(6014),
    [sym__tycon_arrow] = STATE(6014),
    [sym__qtycon_arrow] = STATE(6014),
    [sym__promoted_tycons_alias] = STATE(5993),
    [sym__promoted_tycons] = STATE(5993),
    [sym__varsym_prefix] = STATE(6014),
    [sym__pvarsym] = STATE(6014),
    [sym__qvarsym_prefix] = STATE(6014),
    [sym__pqvarsym] = STATE(6014),
    [sym__consym_prefix] = STATE(6014),
    [sym__pconsym] = STATE(6014),
    [sym__qconsym_prefix] = STATE(6014),
    [sym__pqconsym] = STATE(6014),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(468),
    [sym__bracket_open] = STATE(986),
    [sym__unboxed_open] = STATE(795),
    [sym_variable] = ACTIONS(1867),
    [anon_sym__] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(1875),
    [anon_sym_u2605] = ACTIONS(1875),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1877),
    [sym_char] = ACTIONS(1877),
    [sym_string] = ACTIONS(1877),
    [sym__integer_literal] = ACTIONS(1879),
    [sym__binary_literal] = ACTIONS(1881),
    [sym__octal_literal] = ACTIONS(1881),
    [sym__hex_literal] = ACTIONS(1881),
    [sym_implicit_variable] = ACTIONS(3351),
    [sym_name] = ACTIONS(3353),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1885),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1506] = {
    [sym__type_parens] = STATE(6909),
    [sym__type_tuple] = STATE(6883),
    [sym__type_unboxed_tuple] = STATE(6903),
    [sym__type_unboxed_sum] = STATE(6892),
    [sym__type_list] = STATE(6891),
    [sym__type_promoted] = STATE(6911),
    [sym__type_star] = STATE(6911),
    [sym__type_wildcard] = STATE(6911),
    [sym__type_apply] = STATE(6890),
    [sym__type_infix] = STATE(6959),
    [sym_type] = STATE(881),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10230),
    [sym__qtype_forall] = STATE(8887),
    [sym__qtype_forall_required] = STATE(8873),
    [sym_strict_field] = STATE(8624),
    [sym_lazy_field] = STATE(8624),
    [sym__qtype_function] = STATE(8861),
    [sym__qtype_linear_function] = STATE(8867),
    [sym__qtype_context] = STATE(8904),
    [sym_quantified_type] = STATE(8365),
    [sym_implicit_parameter] = STATE(8868),
    [sym__context_inline] = STATE(1605),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11277),
    [sym__splice_dollars] = STATE(7211),
    [sym_splice] = STATE(6911),
    [sym_quasiquote] = STATE(6911),
    [sym_integer] = STATE(6928),
    [sym__plist] = STATE(6889),
    [sym_unit] = STATE(6911),
    [sym_unboxed_unit] = STATE(6911),
    [sym_prefix_tuple] = STATE(6911),
    [sym_prefix_unboxed_tuple] = STATE(6911),
    [sym_prefix_unboxed_sum] = STATE(6911),
    [sym_literal] = STATE(6911),
    [sym__qualified_type] = STATE(6933),
    [sym__qtyconid] = STATE(6884),
    [sym__tycon_arrow] = STATE(6884),
    [sym__qtycon_arrow] = STATE(6884),
    [sym__promoted_tycons_alias] = STATE(6911),
    [sym__promoted_tycons] = STATE(6911),
    [sym__varsym_prefix] = STATE(6884),
    [sym__pvarsym] = STATE(6884),
    [sym__qvarsym_prefix] = STATE(6884),
    [sym__pqvarsym] = STATE(6884),
    [sym__consym_prefix] = STATE(6884),
    [sym__pconsym] = STATE(6884),
    [sym__qconsym_prefix] = STATE(6884),
    [sym__pqconsym] = STATE(6884),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(430),
    [sym__bracket_open] = STATE(1017),
    [sym__unboxed_open] = STATE(737),
    [sym_variable] = ACTIONS(2673),
    [anon_sym__] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(3339),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_u2605] = ACTIONS(2681),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2683),
    [sym_char] = ACTIONS(2683),
    [sym_string] = ACTIONS(2683),
    [sym__integer_literal] = ACTIONS(2685),
    [sym__binary_literal] = ACTIONS(2687),
    [sym__octal_literal] = ACTIONS(2687),
    [sym__hex_literal] = ACTIONS(2687),
    [sym_implicit_variable] = ACTIONS(3341),
    [sym_name] = ACTIONS(3343),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2691),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1507] = {
    [sym__type_parens] = STATE(7755),
    [sym__type_tuple] = STATE(7759),
    [sym__type_unboxed_tuple] = STATE(7760),
    [sym__type_unboxed_sum] = STATE(7761),
    [sym__type_list] = STATE(7763),
    [sym__type_promoted] = STATE(7754),
    [sym__type_star] = STATE(7754),
    [sym__type_wildcard] = STATE(7754),
    [sym__at_type] = STATE(7784),
    [sym__type_apply] = STATE(7764),
    [sym__type_infix] = STATE(7765),
    [sym_type] = STATE(1426),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8486),
    [sym__splice_dollars] = STATE(7310),
    [sym_splice] = STATE(7754),
    [sym_quasiquote] = STATE(7754),
    [sym_integer] = STATE(7762),
    [sym__plist] = STATE(7766),
    [sym_unit] = STATE(7754),
    [sym_unboxed_unit] = STATE(7754),
    [sym_prefix_tuple] = STATE(7754),
    [sym_prefix_unboxed_tuple] = STATE(7754),
    [sym_prefix_unboxed_sum] = STATE(7754),
    [sym_literal] = STATE(7754),
    [sym__qualified_type] = STATE(7738),
    [sym__qtyconid] = STATE(7767),
    [sym__tycon_arrow] = STATE(7767),
    [sym__qtycon_arrow] = STATE(7767),
    [sym__promoted_tycons_alias] = STATE(7754),
    [sym__promoted_tycons] = STATE(7754),
    [sym__tycon_ticked] = STATE(2687),
    [sym__qtycon_ticked] = STATE(2687),
    [sym__tyconids_ticked] = STATE(2687),
    [sym__promoted_tyconops_alias] = STATE(2687),
    [sym__promoted_tyconops] = STATE(2687),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2687),
    [sym__operator_alias] = STATE(2687),
    [sym__operator_minus] = STATE(2687),
    [sym__varsym_prefix] = STATE(7767),
    [sym__pvarsym] = STATE(7767),
    [sym__qualified_varsym] = STATE(2686),
    [sym__qvarsym_prefix] = STATE(7767),
    [sym__pqvarsym] = STATE(7767),
    [sym_constructor_operator] = STATE(2687),
    [sym__constructor_operator_alias] = STATE(2687),
    [sym__consym_prefix] = STATE(7767),
    [sym__pconsym] = STATE(7767),
    [sym__qualified_consym] = STATE(2679),
    [sym__qconsym_prefix] = STATE(7767),
    [sym__pqconsym] = STATE(7767),
    [sym__prefix_at] = STATE(2547),
    [sym__paren_open] = STATE(457),
    [sym__bracket_open] = STATE(995),
    [sym__unboxed_open] = STATE(813),
    [sym_variable] = ACTIONS(3363),
    [anon_sym__] = ACTIONS(3365),
    [anon_sym_SQUOTE] = ACTIONS(3367),
    [anon_sym_STAR] = ACTIONS(3369),
    [anon_sym_u2605] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3373),
    [sym_char] = ACTIONS(3373),
    [sym_string] = ACTIONS(3373),
    [sym__integer_literal] = ACTIONS(3375),
    [sym__binary_literal] = ACTIONS(3377),
    [sym__octal_literal] = ACTIONS(3377),
    [sym__hex_literal] = ACTIONS(3377),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(3379),
    [anon_sym_u2192] = ACTIONS(1157),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3381),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1508] = {
    [sym__type_parens] = STATE(6909),
    [sym__type_tuple] = STATE(6883),
    [sym__type_unboxed_tuple] = STATE(6903),
    [sym__type_unboxed_sum] = STATE(6892),
    [sym__type_list] = STATE(6891),
    [sym__type_promoted] = STATE(6911),
    [sym__type_star] = STATE(6911),
    [sym__type_wildcard] = STATE(6911),
    [sym__type_apply] = STATE(6890),
    [sym__type_infix] = STATE(6959),
    [sym_type] = STATE(881),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10230),
    [sym__qtype_forall] = STATE(8887),
    [sym__qtype_forall_required] = STATE(8873),
    [sym_strict_field] = STATE(8624),
    [sym_lazy_field] = STATE(8624),
    [sym__qtype_function] = STATE(8861),
    [sym__qtype_linear_function] = STATE(8867),
    [sym__qtype_context] = STATE(8904),
    [sym_quantified_type] = STATE(8364),
    [sym_implicit_parameter] = STATE(8868),
    [sym__context_inline] = STATE(1605),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11277),
    [sym__splice_dollars] = STATE(7211),
    [sym_splice] = STATE(6911),
    [sym_quasiquote] = STATE(6911),
    [sym_integer] = STATE(6928),
    [sym__plist] = STATE(6889),
    [sym_unit] = STATE(6911),
    [sym_unboxed_unit] = STATE(6911),
    [sym_prefix_tuple] = STATE(6911),
    [sym_prefix_unboxed_tuple] = STATE(6911),
    [sym_prefix_unboxed_sum] = STATE(6911),
    [sym_literal] = STATE(6911),
    [sym__qualified_type] = STATE(6933),
    [sym__qtyconid] = STATE(6884),
    [sym__tycon_arrow] = STATE(6884),
    [sym__qtycon_arrow] = STATE(6884),
    [sym__promoted_tycons_alias] = STATE(6911),
    [sym__promoted_tycons] = STATE(6911),
    [sym__varsym_prefix] = STATE(6884),
    [sym__pvarsym] = STATE(6884),
    [sym__qvarsym_prefix] = STATE(6884),
    [sym__pqvarsym] = STATE(6884),
    [sym__consym_prefix] = STATE(6884),
    [sym__pconsym] = STATE(6884),
    [sym__qconsym_prefix] = STATE(6884),
    [sym__pqconsym] = STATE(6884),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(430),
    [sym__bracket_open] = STATE(1017),
    [sym__unboxed_open] = STATE(737),
    [sym_variable] = ACTIONS(2673),
    [anon_sym__] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(3339),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_u2605] = ACTIONS(2681),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2683),
    [sym_char] = ACTIONS(2683),
    [sym_string] = ACTIONS(2683),
    [sym__integer_literal] = ACTIONS(2685),
    [sym__binary_literal] = ACTIONS(2687),
    [sym__octal_literal] = ACTIONS(2687),
    [sym__hex_literal] = ACTIONS(2687),
    [sym_implicit_variable] = ACTIONS(3341),
    [sym_name] = ACTIONS(3343),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2691),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1509] = {
    [sym__type_parens] = STATE(5999),
    [sym__type_tuple] = STATE(6002),
    [sym__type_unboxed_tuple] = STATE(6004),
    [sym__type_unboxed_sum] = STATE(6006),
    [sym__type_list] = STATE(6007),
    [sym__type_promoted] = STATE(5993),
    [sym__type_star] = STATE(5993),
    [sym__type_wildcard] = STATE(5993),
    [sym__type_apply] = STATE(6008),
    [sym__type_infix] = STATE(6009),
    [sym_type] = STATE(666),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10156),
    [sym__qtype_forall] = STATE(8532),
    [sym__qtype_forall_required] = STATE(8520),
    [sym_strict_field] = STATE(8634),
    [sym_lazy_field] = STATE(8634),
    [sym__qtype_function] = STATE(8519),
    [sym__qtype_linear_function] = STATE(8514),
    [sym__qtype_context] = STATE(8511),
    [sym_quantified_type] = STATE(8118),
    [sym_implicit_parameter] = STATE(8502),
    [sym__context_inline] = STATE(1491),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11325),
    [sym__splice_dollars] = STATE(7346),
    [sym_splice] = STATE(5993),
    [sym_quasiquote] = STATE(5993),
    [sym_integer] = STATE(5925),
    [sym__plist] = STATE(6010),
    [sym_unit] = STATE(5993),
    [sym_unboxed_unit] = STATE(5993),
    [sym_prefix_tuple] = STATE(5993),
    [sym_prefix_unboxed_tuple] = STATE(5993),
    [sym_prefix_unboxed_sum] = STATE(5993),
    [sym_literal] = STATE(5993),
    [sym__qualified_type] = STATE(5906),
    [sym__qtyconid] = STATE(6014),
    [sym__tycon_arrow] = STATE(6014),
    [sym__qtycon_arrow] = STATE(6014),
    [sym__promoted_tycons_alias] = STATE(5993),
    [sym__promoted_tycons] = STATE(5993),
    [sym__varsym_prefix] = STATE(6014),
    [sym__pvarsym] = STATE(6014),
    [sym__qvarsym_prefix] = STATE(6014),
    [sym__pqvarsym] = STATE(6014),
    [sym__consym_prefix] = STATE(6014),
    [sym__pconsym] = STATE(6014),
    [sym__qconsym_prefix] = STATE(6014),
    [sym__pqconsym] = STATE(6014),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(468),
    [sym__bracket_open] = STATE(986),
    [sym__unboxed_open] = STATE(795),
    [sym_variable] = ACTIONS(1867),
    [anon_sym__] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(1875),
    [anon_sym_u2605] = ACTIONS(1875),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1877),
    [sym_char] = ACTIONS(1877),
    [sym_string] = ACTIONS(1877),
    [sym__integer_literal] = ACTIONS(1879),
    [sym__binary_literal] = ACTIONS(1881),
    [sym__octal_literal] = ACTIONS(1881),
    [sym__hex_literal] = ACTIONS(1881),
    [sym_implicit_variable] = ACTIONS(3351),
    [sym_name] = ACTIONS(3353),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1885),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1510] = {
    [sym__type_parens] = STATE(5999),
    [sym__type_tuple] = STATE(6002),
    [sym__type_unboxed_tuple] = STATE(6004),
    [sym__type_unboxed_sum] = STATE(6006),
    [sym__type_list] = STATE(6007),
    [sym__type_promoted] = STATE(5993),
    [sym__type_star] = STATE(5993),
    [sym__type_wildcard] = STATE(5993),
    [sym__type_apply] = STATE(6008),
    [sym__type_infix] = STATE(6009),
    [sym_type] = STATE(666),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10156),
    [sym__qtype_forall] = STATE(8532),
    [sym__qtype_forall_required] = STATE(8520),
    [sym_strict_field] = STATE(8634),
    [sym_lazy_field] = STATE(8634),
    [sym__qtype_function] = STATE(8519),
    [sym__qtype_linear_function] = STATE(8514),
    [sym__qtype_context] = STATE(8511),
    [sym_quantified_type] = STATE(8106),
    [sym_implicit_parameter] = STATE(8502),
    [sym__context_inline] = STATE(1491),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11325),
    [sym__splice_dollars] = STATE(7346),
    [sym_splice] = STATE(5993),
    [sym_quasiquote] = STATE(5993),
    [sym_integer] = STATE(5925),
    [sym__plist] = STATE(6010),
    [sym_unit] = STATE(5993),
    [sym_unboxed_unit] = STATE(5993),
    [sym_prefix_tuple] = STATE(5993),
    [sym_prefix_unboxed_tuple] = STATE(5993),
    [sym_prefix_unboxed_sum] = STATE(5993),
    [sym_literal] = STATE(5993),
    [sym__qualified_type] = STATE(5906),
    [sym__qtyconid] = STATE(6014),
    [sym__tycon_arrow] = STATE(6014),
    [sym__qtycon_arrow] = STATE(6014),
    [sym__promoted_tycons_alias] = STATE(5993),
    [sym__promoted_tycons] = STATE(5993),
    [sym__varsym_prefix] = STATE(6014),
    [sym__pvarsym] = STATE(6014),
    [sym__qvarsym_prefix] = STATE(6014),
    [sym__pqvarsym] = STATE(6014),
    [sym__consym_prefix] = STATE(6014),
    [sym__pconsym] = STATE(6014),
    [sym__qconsym_prefix] = STATE(6014),
    [sym__pqconsym] = STATE(6014),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(468),
    [sym__bracket_open] = STATE(986),
    [sym__unboxed_open] = STATE(795),
    [sym_variable] = ACTIONS(1867),
    [anon_sym__] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(1875),
    [anon_sym_u2605] = ACTIONS(1875),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1877),
    [sym_char] = ACTIONS(1877),
    [sym_string] = ACTIONS(1877),
    [sym__integer_literal] = ACTIONS(1879),
    [sym__binary_literal] = ACTIONS(1881),
    [sym__octal_literal] = ACTIONS(1881),
    [sym__hex_literal] = ACTIONS(1881),
    [sym_implicit_variable] = ACTIONS(3351),
    [sym_name] = ACTIONS(3353),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1885),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1511] = {
    [sym__type_parens] = STATE(7755),
    [sym__type_tuple] = STATE(7759),
    [sym__type_unboxed_tuple] = STATE(7760),
    [sym__type_unboxed_sum] = STATE(7761),
    [sym__type_list] = STATE(7763),
    [sym__type_promoted] = STATE(7754),
    [sym__type_star] = STATE(7754),
    [sym__type_wildcard] = STATE(7754),
    [sym__at_type] = STATE(7784),
    [sym__type_apply] = STATE(7764),
    [sym__type_infix] = STATE(7765),
    [sym_type] = STATE(1426),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8486),
    [sym__splice_dollars] = STATE(7310),
    [sym_splice] = STATE(7754),
    [sym_quasiquote] = STATE(7754),
    [sym_integer] = STATE(7762),
    [sym__plist] = STATE(7766),
    [sym_unit] = STATE(7754),
    [sym_unboxed_unit] = STATE(7754),
    [sym_prefix_tuple] = STATE(7754),
    [sym_prefix_unboxed_tuple] = STATE(7754),
    [sym_prefix_unboxed_sum] = STATE(7754),
    [sym_literal] = STATE(7754),
    [sym__qualified_type] = STATE(7738),
    [sym__qtyconid] = STATE(7767),
    [sym__tycon_arrow] = STATE(7767),
    [sym__qtycon_arrow] = STATE(7767),
    [sym__promoted_tycons_alias] = STATE(7754),
    [sym__promoted_tycons] = STATE(7754),
    [sym__tycon_ticked] = STATE(2687),
    [sym__qtycon_ticked] = STATE(2687),
    [sym__tyconids_ticked] = STATE(2687),
    [sym__promoted_tyconops_alias] = STATE(2687),
    [sym__promoted_tyconops] = STATE(2687),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2687),
    [sym__operator_alias] = STATE(2687),
    [sym__operator_minus] = STATE(2687),
    [sym__varsym_prefix] = STATE(7767),
    [sym__pvarsym] = STATE(7767),
    [sym__qualified_varsym] = STATE(2686),
    [sym__qvarsym_prefix] = STATE(7767),
    [sym__pqvarsym] = STATE(7767),
    [sym_constructor_operator] = STATE(2687),
    [sym__constructor_operator_alias] = STATE(2687),
    [sym__consym_prefix] = STATE(7767),
    [sym__pconsym] = STATE(7767),
    [sym__qualified_consym] = STATE(2679),
    [sym__qconsym_prefix] = STATE(7767),
    [sym__pqconsym] = STATE(7767),
    [sym__prefix_at] = STATE(2547),
    [sym__paren_open] = STATE(457),
    [sym__bracket_open] = STATE(995),
    [sym__unboxed_open] = STATE(813),
    [sym_variable] = ACTIONS(3363),
    [anon_sym__] = ACTIONS(3365),
    [anon_sym_SQUOTE] = ACTIONS(3367),
    [anon_sym_STAR] = ACTIONS(3369),
    [anon_sym_u2605] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3373),
    [sym_char] = ACTIONS(3373),
    [sym_string] = ACTIONS(3373),
    [sym__integer_literal] = ACTIONS(3375),
    [sym__binary_literal] = ACTIONS(3377),
    [sym__octal_literal] = ACTIONS(3377),
    [sym__hex_literal] = ACTIONS(3377),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(3379),
    [anon_sym_u2192] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3381),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1512] = {
    [sym__type_parens] = STATE(5999),
    [sym__type_tuple] = STATE(6002),
    [sym__type_unboxed_tuple] = STATE(6004),
    [sym__type_unboxed_sum] = STATE(6006),
    [sym__type_list] = STATE(6007),
    [sym__type_promoted] = STATE(5993),
    [sym__type_star] = STATE(5993),
    [sym__type_wildcard] = STATE(5993),
    [sym__type_apply] = STATE(6008),
    [sym__type_infix] = STATE(6009),
    [sym_type] = STATE(666),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10156),
    [sym__qtype_forall] = STATE(8532),
    [sym__qtype_forall_required] = STATE(8520),
    [sym_strict_field] = STATE(8634),
    [sym_lazy_field] = STATE(8634),
    [sym__qtype_function] = STATE(8519),
    [sym__qtype_linear_function] = STATE(8514),
    [sym__qtype_context] = STATE(8511),
    [sym_quantified_type] = STATE(8113),
    [sym_implicit_parameter] = STATE(8502),
    [sym__context_inline] = STATE(1491),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11325),
    [sym__splice_dollars] = STATE(7346),
    [sym_splice] = STATE(5993),
    [sym_quasiquote] = STATE(5993),
    [sym_integer] = STATE(5925),
    [sym__plist] = STATE(6010),
    [sym_unit] = STATE(5993),
    [sym_unboxed_unit] = STATE(5993),
    [sym_prefix_tuple] = STATE(5993),
    [sym_prefix_unboxed_tuple] = STATE(5993),
    [sym_prefix_unboxed_sum] = STATE(5993),
    [sym_literal] = STATE(5993),
    [sym__qualified_type] = STATE(5906),
    [sym__qtyconid] = STATE(6014),
    [sym__tycon_arrow] = STATE(6014),
    [sym__qtycon_arrow] = STATE(6014),
    [sym__promoted_tycons_alias] = STATE(5993),
    [sym__promoted_tycons] = STATE(5993),
    [sym__varsym_prefix] = STATE(6014),
    [sym__pvarsym] = STATE(6014),
    [sym__qvarsym_prefix] = STATE(6014),
    [sym__pqvarsym] = STATE(6014),
    [sym__consym_prefix] = STATE(6014),
    [sym__pconsym] = STATE(6014),
    [sym__qconsym_prefix] = STATE(6014),
    [sym__pqconsym] = STATE(6014),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(468),
    [sym__bracket_open] = STATE(986),
    [sym__unboxed_open] = STATE(795),
    [sym_variable] = ACTIONS(1867),
    [anon_sym__] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(1875),
    [anon_sym_u2605] = ACTIONS(1875),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1877),
    [sym_char] = ACTIONS(1877),
    [sym_string] = ACTIONS(1877),
    [sym__integer_literal] = ACTIONS(1879),
    [sym__binary_literal] = ACTIONS(1881),
    [sym__octal_literal] = ACTIONS(1881),
    [sym__hex_literal] = ACTIONS(1881),
    [sym_implicit_variable] = ACTIONS(3351),
    [sym_name] = ACTIONS(3353),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1885),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1513] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(60),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1514] = {
    [sym__type_parens] = STATE(6909),
    [sym__type_tuple] = STATE(6883),
    [sym__type_unboxed_tuple] = STATE(6903),
    [sym__type_unboxed_sum] = STATE(6892),
    [sym__type_list] = STATE(6891),
    [sym__type_promoted] = STATE(6911),
    [sym__type_star] = STATE(6911),
    [sym__type_wildcard] = STATE(6911),
    [sym__type_apply] = STATE(6890),
    [sym__type_infix] = STATE(6959),
    [sym_type] = STATE(881),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10230),
    [sym__qtype_forall] = STATE(8887),
    [sym__qtype_forall_required] = STATE(8873),
    [sym_strict_field] = STATE(8624),
    [sym_lazy_field] = STATE(8624),
    [sym__qtype_function] = STATE(8861),
    [sym__qtype_linear_function] = STATE(8867),
    [sym__qtype_context] = STATE(8904),
    [sym_quantified_type] = STATE(8362),
    [sym_implicit_parameter] = STATE(8868),
    [sym__context_inline] = STATE(1605),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11277),
    [sym__splice_dollars] = STATE(7211),
    [sym_splice] = STATE(6911),
    [sym_quasiquote] = STATE(6911),
    [sym_integer] = STATE(6928),
    [sym__plist] = STATE(6889),
    [sym_unit] = STATE(6911),
    [sym_unboxed_unit] = STATE(6911),
    [sym_prefix_tuple] = STATE(6911),
    [sym_prefix_unboxed_tuple] = STATE(6911),
    [sym_prefix_unboxed_sum] = STATE(6911),
    [sym_literal] = STATE(6911),
    [sym__qualified_type] = STATE(6933),
    [sym__qtyconid] = STATE(6884),
    [sym__tycon_arrow] = STATE(6884),
    [sym__qtycon_arrow] = STATE(6884),
    [sym__promoted_tycons_alias] = STATE(6911),
    [sym__promoted_tycons] = STATE(6911),
    [sym__varsym_prefix] = STATE(6884),
    [sym__pvarsym] = STATE(6884),
    [sym__qvarsym_prefix] = STATE(6884),
    [sym__pqvarsym] = STATE(6884),
    [sym__consym_prefix] = STATE(6884),
    [sym__pconsym] = STATE(6884),
    [sym__qconsym_prefix] = STATE(6884),
    [sym__pqconsym] = STATE(6884),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(430),
    [sym__bracket_open] = STATE(1017),
    [sym__unboxed_open] = STATE(737),
    [sym_variable] = ACTIONS(2673),
    [anon_sym__] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(3339),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_u2605] = ACTIONS(2681),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2683),
    [sym_char] = ACTIONS(2683),
    [sym_string] = ACTIONS(2683),
    [sym__integer_literal] = ACTIONS(2685),
    [sym__binary_literal] = ACTIONS(2687),
    [sym__octal_literal] = ACTIONS(2687),
    [sym__hex_literal] = ACTIONS(2687),
    [sym_implicit_variable] = ACTIONS(3341),
    [sym_name] = ACTIONS(3343),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2691),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1515] = {
    [sym__type_parens] = STATE(3111),
    [sym__type_tuple] = STATE(3091),
    [sym__type_unboxed_tuple] = STATE(3092),
    [sym__type_unboxed_sum] = STATE(3095),
    [sym__type_list] = STATE(3100),
    [sym__type_promoted] = STATE(3123),
    [sym__type_star] = STATE(3123),
    [sym__type_wildcard] = STATE(3123),
    [sym__type_apply] = STATE(3099),
    [sym__type_infix] = STATE(3084),
    [sym_type] = STATE(425),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10091),
    [sym__qtype_forall] = STATE(3390),
    [sym__qtype_forall_required] = STATE(3387),
    [sym_strict_field] = STATE(8703),
    [sym_lazy_field] = STATE(8703),
    [sym__qtype_function] = STATE(3381),
    [sym__qtype_linear_function] = STATE(3374),
    [sym__qtype_context] = STATE(3366),
    [sym_quantified_type] = STATE(2668),
    [sym_implicit_parameter] = STATE(3363),
    [sym__context_inline] = STATE(1553),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11161),
    [sym__splice_dollars] = STATE(7411),
    [sym_splice] = STATE(3123),
    [sym_quasiquote] = STATE(3123),
    [sym_integer] = STATE(3118),
    [sym__plist] = STATE(3082),
    [sym_unit] = STATE(3123),
    [sym_unboxed_unit] = STATE(3123),
    [sym_prefix_tuple] = STATE(3123),
    [sym_prefix_unboxed_tuple] = STATE(3123),
    [sym_prefix_unboxed_sum] = STATE(3123),
    [sym_literal] = STATE(3123),
    [sym__qualified_type] = STATE(3083),
    [sym__qtyconid] = STATE(3071),
    [sym__tycon_arrow] = STATE(3071),
    [sym__qtycon_arrow] = STATE(3071),
    [sym__promoted_tycons_alias] = STATE(3123),
    [sym__promoted_tycons] = STATE(3123),
    [sym__varsym_prefix] = STATE(3071),
    [sym__pvarsym] = STATE(3071),
    [sym__qvarsym_prefix] = STATE(3071),
    [sym__pqvarsym] = STATE(3071),
    [sym__consym_prefix] = STATE(3071),
    [sym__pconsym] = STATE(3071),
    [sym__qconsym_prefix] = STATE(3071),
    [sym__pqconsym] = STATE(3071),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(441),
    [sym__bracket_open] = STATE(1101),
    [sym__unboxed_open] = STATE(764),
    [sym_variable] = ACTIONS(1343),
    [anon_sym__] = ACTIONS(1345),
    [anon_sym_SQUOTE] = ACTIONS(3333),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_u2605] = ACTIONS(1351),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1353),
    [sym_char] = ACTIONS(1353),
    [sym_string] = ACTIONS(1353),
    [sym__integer_literal] = ACTIONS(1355),
    [sym__binary_literal] = ACTIONS(1357),
    [sym__octal_literal] = ACTIONS(1357),
    [sym__hex_literal] = ACTIONS(1357),
    [sym_implicit_variable] = ACTIONS(3335),
    [sym_name] = ACTIONS(3337),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1361),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1516] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(240),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1517] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8510),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1518] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8504),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1519] = {
    [sym__type_parens] = STATE(3111),
    [sym__type_tuple] = STATE(3091),
    [sym__type_unboxed_tuple] = STATE(3092),
    [sym__type_unboxed_sum] = STATE(3095),
    [sym__type_list] = STATE(3100),
    [sym__type_promoted] = STATE(3123),
    [sym__type_star] = STATE(3123),
    [sym__type_wildcard] = STATE(3123),
    [sym__type_apply] = STATE(3099),
    [sym__type_infix] = STATE(3084),
    [sym_type] = STATE(425),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10091),
    [sym__qtype_forall] = STATE(3390),
    [sym__qtype_forall_required] = STATE(3387),
    [sym_strict_field] = STATE(8703),
    [sym_lazy_field] = STATE(8703),
    [sym__qtype_function] = STATE(3381),
    [sym__qtype_linear_function] = STATE(3374),
    [sym__qtype_context] = STATE(3366),
    [sym_quantified_type] = STATE(2652),
    [sym_implicit_parameter] = STATE(3363),
    [sym__context_inline] = STATE(1553),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11161),
    [sym__splice_dollars] = STATE(7411),
    [sym_splice] = STATE(3123),
    [sym_quasiquote] = STATE(3123),
    [sym_integer] = STATE(3118),
    [sym__plist] = STATE(3082),
    [sym_unit] = STATE(3123),
    [sym_unboxed_unit] = STATE(3123),
    [sym_prefix_tuple] = STATE(3123),
    [sym_prefix_unboxed_tuple] = STATE(3123),
    [sym_prefix_unboxed_sum] = STATE(3123),
    [sym_literal] = STATE(3123),
    [sym__qualified_type] = STATE(3083),
    [sym__qtyconid] = STATE(3071),
    [sym__tycon_arrow] = STATE(3071),
    [sym__qtycon_arrow] = STATE(3071),
    [sym__promoted_tycons_alias] = STATE(3123),
    [sym__promoted_tycons] = STATE(3123),
    [sym__varsym_prefix] = STATE(3071),
    [sym__pvarsym] = STATE(3071),
    [sym__qvarsym_prefix] = STATE(3071),
    [sym__pqvarsym] = STATE(3071),
    [sym__consym_prefix] = STATE(3071),
    [sym__pconsym] = STATE(3071),
    [sym__qconsym_prefix] = STATE(3071),
    [sym__pqconsym] = STATE(3071),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(441),
    [sym__bracket_open] = STATE(1101),
    [sym__unboxed_open] = STATE(764),
    [sym_variable] = ACTIONS(1343),
    [anon_sym__] = ACTIONS(1345),
    [anon_sym_SQUOTE] = ACTIONS(3333),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_u2605] = ACTIONS(1351),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1353),
    [sym_char] = ACTIONS(1353),
    [sym_string] = ACTIONS(1353),
    [sym__integer_literal] = ACTIONS(1355),
    [sym__binary_literal] = ACTIONS(1357),
    [sym__octal_literal] = ACTIONS(1357),
    [sym__hex_literal] = ACTIONS(1357),
    [sym_implicit_variable] = ACTIONS(3335),
    [sym_name] = ACTIONS(3337),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1361),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1520] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8454),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1521] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8341),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = ACTIONS(1989),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1522] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(300),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1523] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8452),
    [sym_lazy_field] = STATE(8447),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8444),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1524] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8517),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1525] = {
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(154),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__paren_open] = STATE(406),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1526] = {
    [sym__type_parens] = STATE(3111),
    [sym__type_tuple] = STATE(3091),
    [sym__type_unboxed_tuple] = STATE(3092),
    [sym__type_unboxed_sum] = STATE(3095),
    [sym__type_list] = STATE(3100),
    [sym__type_promoted] = STATE(3123),
    [sym__type_star] = STATE(3123),
    [sym__type_wildcard] = STATE(3123),
    [sym__type_apply] = STATE(3099),
    [sym__type_infix] = STATE(3084),
    [sym_type] = STATE(425),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10091),
    [sym__qtype_forall] = STATE(3390),
    [sym__qtype_forall_required] = STATE(3387),
    [sym_strict_field] = STATE(8703),
    [sym_lazy_field] = STATE(8703),
    [sym__qtype_function] = STATE(3381),
    [sym__qtype_linear_function] = STATE(3374),
    [sym__qtype_context] = STATE(3366),
    [sym_quantified_type] = STATE(2639),
    [sym_implicit_parameter] = STATE(3363),
    [sym__context_inline] = STATE(1553),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11161),
    [sym__splice_dollars] = STATE(7411),
    [sym_splice] = STATE(3123),
    [sym_quasiquote] = STATE(3123),
    [sym_integer] = STATE(3118),
    [sym__plist] = STATE(3082),
    [sym_unit] = STATE(3123),
    [sym_unboxed_unit] = STATE(3123),
    [sym_prefix_tuple] = STATE(3123),
    [sym_prefix_unboxed_tuple] = STATE(3123),
    [sym_prefix_unboxed_sum] = STATE(3123),
    [sym_literal] = STATE(3123),
    [sym__qualified_type] = STATE(3083),
    [sym__qtyconid] = STATE(3071),
    [sym__tycon_arrow] = STATE(3071),
    [sym__qtycon_arrow] = STATE(3071),
    [sym__promoted_tycons_alias] = STATE(3123),
    [sym__promoted_tycons] = STATE(3123),
    [sym__varsym_prefix] = STATE(3071),
    [sym__pvarsym] = STATE(3071),
    [sym__qvarsym_prefix] = STATE(3071),
    [sym__pqvarsym] = STATE(3071),
    [sym__consym_prefix] = STATE(3071),
    [sym__pconsym] = STATE(3071),
    [sym__qconsym_prefix] = STATE(3071),
    [sym__pqconsym] = STATE(3071),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(441),
    [sym__bracket_open] = STATE(1101),
    [sym__unboxed_open] = STATE(764),
    [sym_variable] = ACTIONS(1343),
    [anon_sym__] = ACTIONS(1345),
    [anon_sym_SQUOTE] = ACTIONS(3333),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_u2605] = ACTIONS(1351),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1353),
    [sym_char] = ACTIONS(1353),
    [sym_string] = ACTIONS(1353),
    [sym__integer_literal] = ACTIONS(1355),
    [sym__binary_literal] = ACTIONS(1357),
    [sym__octal_literal] = ACTIONS(1357),
    [sym__hex_literal] = ACTIONS(1357),
    [sym_implicit_variable] = ACTIONS(3335),
    [sym_name] = ACTIONS(3337),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1361),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1527] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(390),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1528] = {
    [sym__type_parens] = STATE(3379),
    [sym__type_tuple] = STATE(3377),
    [sym__type_unboxed_tuple] = STATE(3370),
    [sym__type_unboxed_sum] = STATE(3369),
    [sym__type_list] = STATE(3361),
    [sym__type_promoted] = STATE(3383),
    [sym__type_star] = STATE(3383),
    [sym__type_wildcard] = STATE(3383),
    [sym__type_apply] = STATE(3359),
    [sym__type_infix] = STATE(3358),
    [sym_type] = STATE(486),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10095),
    [sym__qtype_forall] = STATE(3757),
    [sym__qtype_forall_required] = STATE(3758),
    [sym_strict_field] = STATE(8706),
    [sym_lazy_field] = STATE(8706),
    [sym__qtype_function] = STATE(3762),
    [sym__qtype_linear_function] = STATE(3767),
    [sym__qtype_context] = STATE(3768),
    [sym_quantified_type] = STATE(2824),
    [sym_implicit_parameter] = STATE(3788),
    [sym__context_inline] = STATE(1749),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11178),
    [sym__splice_dollars] = STATE(7460),
    [sym_splice] = STATE(3383),
    [sym_quasiquote] = STATE(3383),
    [sym_integer] = STATE(3269),
    [sym__plist] = STATE(3357),
    [sym_unit] = STATE(3383),
    [sym_unboxed_unit] = STATE(3383),
    [sym_prefix_tuple] = STATE(3383),
    [sym_prefix_unboxed_tuple] = STATE(3383),
    [sym_prefix_unboxed_sum] = STATE(3383),
    [sym_literal] = STATE(3383),
    [sym__qualified_type] = STATE(3410),
    [sym__qtyconid] = STATE(3354),
    [sym__tycon_arrow] = STATE(3354),
    [sym__qtycon_arrow] = STATE(3354),
    [sym__promoted_tycons_alias] = STATE(3383),
    [sym__promoted_tycons] = STATE(3383),
    [sym__varsym_prefix] = STATE(3354),
    [sym__pvarsym] = STATE(3354),
    [sym__qvarsym_prefix] = STATE(3354),
    [sym__pqvarsym] = STATE(3354),
    [sym__consym_prefix] = STATE(3354),
    [sym__pconsym] = STATE(3354),
    [sym__qconsym_prefix] = STATE(3354),
    [sym__pqconsym] = STATE(3354),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(464),
    [sym__bracket_open] = STATE(1079),
    [sym__unboxed_open] = STATE(805),
    [sym_variable] = ACTIONS(1609),
    [anon_sym__] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_u2605] = ACTIONS(1617),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1619),
    [sym_char] = ACTIONS(1619),
    [sym_string] = ACTIONS(1619),
    [sym__integer_literal] = ACTIONS(1621),
    [sym__binary_literal] = ACTIONS(1623),
    [sym__octal_literal] = ACTIONS(1623),
    [sym__hex_literal] = ACTIONS(1623),
    [sym_implicit_variable] = ACTIONS(3385),
    [sym_name] = ACTIONS(3387),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1627),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1529] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8345),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1530] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8344),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1531] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(242),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1532] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8262),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1533] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(245),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1534] = {
    [sym__exp_th_quoted_name] = STATE(4568),
    [sym__exp_parens] = STATE(4565),
    [sym__exp_tuple] = STATE(4560),
    [sym__exp_unboxed_tuple] = STATE(4558),
    [sym__exp_unboxed_sum] = STATE(4557),
    [sym__exp_list] = STATE(4553),
    [sym__exp_arithmetic_sequence] = STATE(4552),
    [sym__exp_list_comprehension] = STATE(4546),
    [sym__exp_lambda] = STATE(4432),
    [sym__exp_let_in] = STATE(4538),
    [sym__exp_conditional] = STATE(4537),
    [sym__do_keyword] = STATE(11068),
    [sym_do_module] = STATE(11068),
    [sym__do] = STATE(11068),
    [sym__exp_do] = STATE(4535),
    [sym__exp_case] = STATE(4534),
    [sym__exp_lambda_case] = STATE(4532),
    [sym__exp_lambda_cases] = STATE(4530),
    [sym__exp_multi_way_if] = STATE(4529),
    [sym__exp_record] = STATE(4528),
    [sym__exp_projection_selector] = STATE(4527),
    [sym__exp_projection] = STATE(4526),
    [sym__exp_apply] = STATE(4525),
    [sym__exp_section_left] = STATE(4519),
    [sym__exp_section_right] = STATE(4516),
    [sym__exp_negation] = STATE(4450),
    [sym__exp_infix] = STATE(4449),
    [sym_expression] = STATE(208),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9239),
    [sym__splice_dollars] = STATE(7343),
    [sym_splice] = STATE(4578),
    [sym_quasiquote] = STATE(4578),
    [sym__exp_quote] = STATE(4446),
    [sym__exp_typed_quote] = STATE(4578),
    [sym_integer] = STATE(4148),
    [sym__plist] = STATE(4417),
    [sym_unit] = STATE(4578),
    [sym_unboxed_unit] = STATE(4578),
    [sym_prefix_tuple] = STATE(4578),
    [sym_prefix_unboxed_tuple] = STATE(4578),
    [sym_prefix_unboxed_sum] = STATE(4578),
    [sym_literal] = STATE(4578),
    [sym__qualified_variable] = STATE(4219),
    [sym__qvarid] = STATE(4578),
    [sym__qvar] = STATE(4578),
    [sym__qualified_constructor] = STATE(4062),
    [sym__qconid] = STATE(4578),
    [sym__varsym_prefix] = STATE(4578),
    [sym__pvarsym] = STATE(4578),
    [sym__qvarsym_prefix] = STATE(4578),
    [sym__pqvarsym] = STATE(4578),
    [sym__consym_prefix] = STATE(4410),
    [sym__pconsym] = STATE(4410),
    [sym__qconsym_prefix] = STATE(4578),
    [sym__pqconsym] = STATE(4578),
    [sym__paren_open] = STATE(403),
    [sym__bracket_open] = STATE(961),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = ACTIONS(741),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(751),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_mdo] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(761),
    [sym_float] = ACTIONS(763),
    [sym_char] = ACTIONS(763),
    [sym_string] = ACTIONS(763),
    [sym__integer_literal] = ACTIONS(765),
    [sym__binary_literal] = ACTIONS(767),
    [sym__octal_literal] = ACTIONS(767),
    [sym__hex_literal] = ACTIONS(767),
    [sym_implicit_variable] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [sym_label] = ACTIONS(769),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(775),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1535] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(55),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(3429),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(3331),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1536] = {
    [sym__type_wildcard] = STATE(7980),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(12494),
    [sym__class_apply] = STATE(8005),
    [sym__class_infix] = STATE(8007),
    [sym__ctr_parens] = STATE(7980),
    [sym__ctr_tuple] = STATE(7980),
    [sym_implicit_parameter] = STATE(10828),
    [sym_constraint] = STATE(2234),
    [sym__ctr_forall] = STATE(10819),
    [sym__ctr_context] = STATE(10815),
    [sym__ctr_signature] = STATE(10805),
    [sym_constraints] = STATE(9319),
    [sym__context_inline] = STATE(2304),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8275),
    [sym__splice_dollars] = STATE(7254),
    [sym_splice] = STATE(7980),
    [sym_quasiquote] = STATE(7980),
    [sym_integer] = STATE(7997),
    [sym_unit] = STATE(7980),
    [sym_unboxed_unit] = STATE(7980),
    [sym_prefix_tuple] = STATE(7980),
    [sym_prefix_unboxed_tuple] = STATE(7980),
    [sym_prefix_unboxed_sum] = STATE(7980),
    [sym_literal] = STATE(7980),
    [sym__qualified_type] = STATE(7953),
    [sym__qtyconid] = STATE(8011),
    [sym__tycon_arrow] = STATE(8011),
    [sym__qualified_arrow] = STATE(11747),
    [sym__qtycon_arrow] = STATE(8011),
    [sym__promoted_tycons_alias] = STATE(7980),
    [sym__promoted_tycons] = STATE(7980),
    [sym__operator_qual_dot_head] = STATE(11528),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11528),
    [sym__operator_minus] = STATE(11528),
    [sym__varsym_prefix] = STATE(8011),
    [sym__pvarsym] = STATE(8011),
    [sym__qualified_varsym] = STATE(11353),
    [sym__qvarsym_prefix] = STATE(8011),
    [sym__pqvarsym] = STATE(8011),
    [sym_constructor_operator] = STATE(11978),
    [sym__consym_prefix] = STATE(8011),
    [sym__pconsym] = STATE(8011),
    [sym__qualified_consym] = STATE(11710),
    [sym__qconsym_prefix] = STATE(8011),
    [sym__pqconsym] = STATE(8011),
    [sym__arrow] = STATE(11731),
    [sym__paren_open] = STATE(1536),
    [sym__paren_close] = STATE(7973),
    [sym__unboxed_open] = STATE(9192),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10871),
    [sym_variable] = ACTIONS(3389),
    [anon_sym_COMMA] = ACTIONS(3391),
    [anon_sym__] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3395),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [sym_float] = ACTIONS(3397),
    [sym_char] = ACTIONS(3397),
    [sym_string] = ACTIONS(3397),
    [sym__integer_literal] = ACTIONS(3399),
    [sym__binary_literal] = ACTIONS(3401),
    [sym__octal_literal] = ACTIONS(3401),
    [sym__hex_literal] = ACTIONS(3401),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(3403),
    [sym_implicit_variable] = ACTIONS(3405),
    [sym_name] = ACTIONS(3407),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(3409),
    [aux_sym__paren_close_token1] = ACTIONS(3411),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3413),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_context] = ACTIONS(3415),
    [sym__cond_infix] = ACTIONS(3417),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [1537] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8309),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = ACTIONS(1989),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1538] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8336),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1539] = {
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(119),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__paren_open] = STATE(406),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1540] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8317),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1541] = {
    [sym__type_parens] = STATE(3557),
    [sym__type_tuple] = STATE(3612),
    [sym__type_unboxed_tuple] = STATE(3607),
    [sym__type_unboxed_sum] = STATE(3606),
    [sym__type_list] = STATE(3605),
    [sym__type_promoted] = STATE(3638),
    [sym__type_star] = STATE(3638),
    [sym__type_wildcard] = STATE(3638),
    [sym__type_apply] = STATE(3604),
    [sym__type_infix] = STATE(3602),
    [sym_type] = STATE(508),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10082),
    [sym__qtype_forall] = STATE(3832),
    [sym__qtype_forall_required] = STATE(3829),
    [sym_strict_field] = STATE(8659),
    [sym_lazy_field] = STATE(8659),
    [sym__qtype_function] = STATE(3824),
    [sym__qtype_linear_function] = STATE(3823),
    [sym__qtype_context] = STATE(3821),
    [sym_quantified_type] = STATE(3007),
    [sym_implicit_parameter] = STATE(3838),
    [sym__context_inline] = STATE(1658),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11140),
    [sym__splice_dollars] = STATE(7350),
    [sym_splice] = STATE(3638),
    [sym_quasiquote] = STATE(3638),
    [sym_integer] = STATE(3509),
    [sym__plist] = STATE(3597),
    [sym_unit] = STATE(3638),
    [sym_unboxed_unit] = STATE(3638),
    [sym_prefix_tuple] = STATE(3638),
    [sym_prefix_unboxed_tuple] = STATE(3638),
    [sym_prefix_unboxed_sum] = STATE(3638),
    [sym_literal] = STATE(3638),
    [sym__qualified_type] = STATE(3643),
    [sym__qtyconid] = STATE(3583),
    [sym__tycon_arrow] = STATE(3583),
    [sym__qtycon_arrow] = STATE(3583),
    [sym__promoted_tycons_alias] = STATE(3638),
    [sym__promoted_tycons] = STATE(3638),
    [sym__varsym_prefix] = STATE(3583),
    [sym__pvarsym] = STATE(3583),
    [sym__qvarsym_prefix] = STATE(3583),
    [sym__pqvarsym] = STATE(3583),
    [sym__consym_prefix] = STATE(3583),
    [sym__pconsym] = STATE(3583),
    [sym__qconsym_prefix] = STATE(3583),
    [sym__pqconsym] = STATE(3583),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(461),
    [sym__bracket_open] = STATE(1131),
    [sym__unboxed_open] = STATE(829),
    [sym_variable] = ACTIONS(1669),
    [anon_sym__] = ACTIONS(1671),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(1677),
    [anon_sym_u2605] = ACTIONS(1677),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1679),
    [sym_char] = ACTIONS(1679),
    [sym_string] = ACTIONS(1679),
    [sym__integer_literal] = ACTIONS(1681),
    [sym__binary_literal] = ACTIONS(1683),
    [sym__octal_literal] = ACTIONS(1683),
    [sym__hex_literal] = ACTIONS(1683),
    [sym_implicit_variable] = ACTIONS(3421),
    [sym_name] = ACTIONS(3423),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1542] = {
    [sym__type_parens] = STATE(6922),
    [sym__type_tuple] = STATE(6929),
    [sym__type_unboxed_tuple] = STATE(6932),
    [sym__type_unboxed_sum] = STATE(6934),
    [sym__type_list] = STATE(6935),
    [sym__type_promoted] = STATE(6919),
    [sym__type_star] = STATE(6919),
    [sym__type_wildcard] = STATE(6919),
    [sym__type_apply] = STATE(6936),
    [sym__type_infix] = STATE(6937),
    [sym_type] = STATE(910),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10089),
    [sym__qtype_forall] = STATE(8937),
    [sym__qtype_forall_required] = STATE(8932),
    [sym_strict_field] = STATE(8700),
    [sym_lazy_field] = STATE(8700),
    [sym__qtype_function] = STATE(8931),
    [sym__qtype_linear_function] = STATE(8922),
    [sym__qtype_context] = STATE(8930),
    [sym_quantified_type] = STATE(8356),
    [sym_implicit_parameter] = STATE(8927),
    [sym__context_inline] = STATE(1434),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11154),
    [sym__splice_dollars] = STATE(7213),
    [sym_splice] = STATE(6919),
    [sym_quasiquote] = STATE(6919),
    [sym_integer] = STATE(6980),
    [sym__plist] = STATE(6939),
    [sym_unit] = STATE(6919),
    [sym_unboxed_unit] = STATE(6919),
    [sym_prefix_tuple] = STATE(6919),
    [sym_prefix_unboxed_tuple] = STATE(6919),
    [sym_prefix_unboxed_sum] = STATE(6919),
    [sym_literal] = STATE(6919),
    [sym__qualified_type] = STATE(7018),
    [sym__qtyconid] = STATE(6940),
    [sym__tycon_arrow] = STATE(6940),
    [sym__qtycon_arrow] = STATE(6940),
    [sym__promoted_tycons_alias] = STATE(6919),
    [sym__promoted_tycons] = STATE(6919),
    [sym__varsym_prefix] = STATE(6940),
    [sym__pvarsym] = STATE(6940),
    [sym__qvarsym_prefix] = STATE(6940),
    [sym__pqvarsym] = STATE(6940),
    [sym__consym_prefix] = STATE(6940),
    [sym__pconsym] = STATE(6940),
    [sym__qconsym_prefix] = STATE(6940),
    [sym__pqconsym] = STATE(6940),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(435),
    [sym__bracket_open] = STATE(1104),
    [sym__unboxed_open] = STATE(744),
    [sym_variable] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(2695),
    [anon_sym_SQUOTE] = ACTIONS(3325),
    [anon_sym_STAR] = ACTIONS(2701),
    [anon_sym_u2605] = ACTIONS(2701),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2703),
    [sym_char] = ACTIONS(2703),
    [sym_string] = ACTIONS(2703),
    [sym__integer_literal] = ACTIONS(2705),
    [sym__binary_literal] = ACTIONS(2707),
    [sym__octal_literal] = ACTIONS(2707),
    [sym__hex_literal] = ACTIONS(2707),
    [sym_implicit_variable] = ACTIONS(3327),
    [sym_name] = ACTIONS(3329),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2711),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1543] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(271),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__paren_open] = STATE(404),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1544] = {
    [sym__type_parens] = STATE(6922),
    [sym__type_tuple] = STATE(6929),
    [sym__type_unboxed_tuple] = STATE(6932),
    [sym__type_unboxed_sum] = STATE(6934),
    [sym__type_list] = STATE(6935),
    [sym__type_promoted] = STATE(6919),
    [sym__type_star] = STATE(6919),
    [sym__type_wildcard] = STATE(6919),
    [sym__type_apply] = STATE(6936),
    [sym__type_infix] = STATE(6937),
    [sym_type] = STATE(910),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10089),
    [sym__qtype_forall] = STATE(8937),
    [sym__qtype_forall_required] = STATE(8932),
    [sym_strict_field] = STATE(8700),
    [sym_lazy_field] = STATE(8700),
    [sym__qtype_function] = STATE(8931),
    [sym__qtype_linear_function] = STATE(8922),
    [sym__qtype_context] = STATE(8930),
    [sym_quantified_type] = STATE(8393),
    [sym_implicit_parameter] = STATE(8927),
    [sym__context_inline] = STATE(1434),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11154),
    [sym__splice_dollars] = STATE(7213),
    [sym_splice] = STATE(6919),
    [sym_quasiquote] = STATE(6919),
    [sym_integer] = STATE(6980),
    [sym__plist] = STATE(6939),
    [sym_unit] = STATE(6919),
    [sym_unboxed_unit] = STATE(6919),
    [sym_prefix_tuple] = STATE(6919),
    [sym_prefix_unboxed_tuple] = STATE(6919),
    [sym_prefix_unboxed_sum] = STATE(6919),
    [sym_literal] = STATE(6919),
    [sym__qualified_type] = STATE(7018),
    [sym__qtyconid] = STATE(6940),
    [sym__tycon_arrow] = STATE(6940),
    [sym__qtycon_arrow] = STATE(6940),
    [sym__promoted_tycons_alias] = STATE(6919),
    [sym__promoted_tycons] = STATE(6919),
    [sym__varsym_prefix] = STATE(6940),
    [sym__pvarsym] = STATE(6940),
    [sym__qvarsym_prefix] = STATE(6940),
    [sym__pqvarsym] = STATE(6940),
    [sym__consym_prefix] = STATE(6940),
    [sym__pconsym] = STATE(6940),
    [sym__qconsym_prefix] = STATE(6940),
    [sym__pqconsym] = STATE(6940),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(435),
    [sym__bracket_open] = STATE(1104),
    [sym__unboxed_open] = STATE(744),
    [sym_variable] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(2695),
    [anon_sym_SQUOTE] = ACTIONS(3325),
    [anon_sym_STAR] = ACTIONS(2701),
    [anon_sym_u2605] = ACTIONS(2701),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2703),
    [sym_char] = ACTIONS(2703),
    [sym_string] = ACTIONS(2703),
    [sym__integer_literal] = ACTIONS(2705),
    [sym__binary_literal] = ACTIONS(2707),
    [sym__octal_literal] = ACTIONS(2707),
    [sym__hex_literal] = ACTIONS(2707),
    [sym_implicit_variable] = ACTIONS(3327),
    [sym_name] = ACTIONS(3329),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2711),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1545] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(269),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__paren_open] = STATE(404),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1546] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(7713),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1547] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(270),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__paren_open] = STATE(404),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1548] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(7979),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1549] = {
    [sym__type_parens] = STATE(3217),
    [sym__type_tuple] = STATE(3215),
    [sym__type_unboxed_tuple] = STATE(3214),
    [sym__type_unboxed_sum] = STATE(3209),
    [sym__type_list] = STATE(3198),
    [sym__type_promoted] = STATE(3219),
    [sym__type_star] = STATE(3219),
    [sym__type_wildcard] = STATE(3219),
    [sym__type_apply] = STATE(3195),
    [sym__type_infix] = STATE(3189),
    [sym_type] = STATE(500),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10171),
    [sym__qtype_forall] = STATE(3763),
    [sym__qtype_forall_required] = STATE(3764),
    [sym_strict_field] = STATE(8629),
    [sym_lazy_field] = STATE(8629),
    [sym__qtype_function] = STATE(3765),
    [sym__qtype_linear_function] = STATE(3766),
    [sym__qtype_context] = STATE(3769),
    [sym_quantified_type] = STATE(2818),
    [sym_implicit_parameter] = STATE(3770),
    [sym__context_inline] = STATE(1407),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11305),
    [sym__splice_dollars] = STATE(7385),
    [sym_splice] = STATE(3219),
    [sym_quasiquote] = STATE(3219),
    [sym_integer] = STATE(3330),
    [sym__plist] = STATE(3185),
    [sym_unit] = STATE(3219),
    [sym_unboxed_unit] = STATE(3219),
    [sym_prefix_tuple] = STATE(3219),
    [sym_prefix_unboxed_tuple] = STATE(3219),
    [sym_prefix_unboxed_sum] = STATE(3219),
    [sym_literal] = STATE(3219),
    [sym__qualified_type] = STATE(3420),
    [sym__qtyconid] = STATE(3183),
    [sym__tycon_arrow] = STATE(3183),
    [sym__qtycon_arrow] = STATE(3183),
    [sym__promoted_tycons_alias] = STATE(3219),
    [sym__promoted_tycons] = STATE(3219),
    [sym__varsym_prefix] = STATE(3183),
    [sym__pvarsym] = STATE(3183),
    [sym__qvarsym_prefix] = STATE(3183),
    [sym__pqvarsym] = STATE(3183),
    [sym__consym_prefix] = STATE(3183),
    [sym__pconsym] = STATE(3183),
    [sym__qconsym_prefix] = STATE(3183),
    [sym__pqconsym] = STATE(3183),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(447),
    [sym__bracket_open] = STATE(976),
    [sym__unboxed_open] = STATE(743),
    [sym_variable] = ACTIONS(1629),
    [anon_sym__] = ACTIONS(1631),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_STAR] = ACTIONS(1637),
    [anon_sym_u2605] = ACTIONS(1637),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1639),
    [sym_char] = ACTIONS(1639),
    [sym_string] = ACTIONS(1639),
    [sym__integer_literal] = ACTIONS(1641),
    [sym__binary_literal] = ACTIONS(1643),
    [sym__octal_literal] = ACTIONS(1643),
    [sym__hex_literal] = ACTIONS(1643),
    [sym_implicit_variable] = ACTIONS(3307),
    [sym_name] = ACTIONS(3309),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1647),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1550] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(305),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1551] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8218),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1552] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8216),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1553] = {
    [sym__type_parens] = STATE(3111),
    [sym__type_tuple] = STATE(3091),
    [sym__type_unboxed_tuple] = STATE(3092),
    [sym__type_unboxed_sum] = STATE(3095),
    [sym__type_list] = STATE(3100),
    [sym__type_promoted] = STATE(3123),
    [sym__type_star] = STATE(3123),
    [sym__type_wildcard] = STATE(3123),
    [sym__type_apply] = STATE(3099),
    [sym__type_infix] = STATE(3084),
    [sym_type] = STATE(425),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10091),
    [sym__qtype_forall] = STATE(3390),
    [sym__qtype_forall_required] = STATE(3387),
    [sym_strict_field] = STATE(8703),
    [sym_lazy_field] = STATE(8703),
    [sym__qtype_function] = STATE(3381),
    [sym__qtype_linear_function] = STATE(3374),
    [sym__qtype_context] = STATE(3366),
    [sym_quantified_type] = STATE(2633),
    [sym_implicit_parameter] = STATE(3363),
    [sym__context_inline] = STATE(1553),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11161),
    [sym__splice_dollars] = STATE(7411),
    [sym_splice] = STATE(3123),
    [sym_quasiquote] = STATE(3123),
    [sym_integer] = STATE(3118),
    [sym__plist] = STATE(3082),
    [sym_unit] = STATE(3123),
    [sym_unboxed_unit] = STATE(3123),
    [sym_prefix_tuple] = STATE(3123),
    [sym_prefix_unboxed_tuple] = STATE(3123),
    [sym_prefix_unboxed_sum] = STATE(3123),
    [sym_literal] = STATE(3123),
    [sym__qualified_type] = STATE(3083),
    [sym__qtyconid] = STATE(3071),
    [sym__tycon_arrow] = STATE(3071),
    [sym__qtycon_arrow] = STATE(3071),
    [sym__promoted_tycons_alias] = STATE(3123),
    [sym__promoted_tycons] = STATE(3123),
    [sym__varsym_prefix] = STATE(3071),
    [sym__pvarsym] = STATE(3071),
    [sym__qvarsym_prefix] = STATE(3071),
    [sym__pqvarsym] = STATE(3071),
    [sym__consym_prefix] = STATE(3071),
    [sym__pconsym] = STATE(3071),
    [sym__qconsym_prefix] = STATE(3071),
    [sym__pqconsym] = STATE(3071),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(441),
    [sym__bracket_open] = STATE(1101),
    [sym__unboxed_open] = STATE(764),
    [sym_variable] = ACTIONS(1343),
    [anon_sym__] = ACTIONS(1345),
    [anon_sym_SQUOTE] = ACTIONS(3333),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_u2605] = ACTIONS(1351),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1353),
    [sym_char] = ACTIONS(1353),
    [sym_string] = ACTIONS(1353),
    [sym__integer_literal] = ACTIONS(1355),
    [sym__binary_literal] = ACTIONS(1357),
    [sym__octal_literal] = ACTIONS(1357),
    [sym__hex_literal] = ACTIONS(1357),
    [sym_implicit_variable] = ACTIONS(3335),
    [sym_name] = ACTIONS(3337),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1361),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1554] = {
    [sym__type_parens] = STATE(6922),
    [sym__type_tuple] = STATE(6929),
    [sym__type_unboxed_tuple] = STATE(6932),
    [sym__type_unboxed_sum] = STATE(6934),
    [sym__type_list] = STATE(6935),
    [sym__type_promoted] = STATE(6919),
    [sym__type_star] = STATE(6919),
    [sym__type_wildcard] = STATE(6919),
    [sym__type_apply] = STATE(6936),
    [sym__type_infix] = STATE(6937),
    [sym_type] = STATE(910),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10089),
    [sym__qtype_forall] = STATE(8937),
    [sym__qtype_forall_required] = STATE(8932),
    [sym_strict_field] = STATE(8700),
    [sym_lazy_field] = STATE(8700),
    [sym__qtype_function] = STATE(8931),
    [sym__qtype_linear_function] = STATE(8922),
    [sym__qtype_context] = STATE(8930),
    [sym_quantified_type] = STATE(8394),
    [sym_implicit_parameter] = STATE(8927),
    [sym__context_inline] = STATE(1434),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11154),
    [sym__splice_dollars] = STATE(7213),
    [sym_splice] = STATE(6919),
    [sym_quasiquote] = STATE(6919),
    [sym_integer] = STATE(6980),
    [sym__plist] = STATE(6939),
    [sym_unit] = STATE(6919),
    [sym_unboxed_unit] = STATE(6919),
    [sym_prefix_tuple] = STATE(6919),
    [sym_prefix_unboxed_tuple] = STATE(6919),
    [sym_prefix_unboxed_sum] = STATE(6919),
    [sym_literal] = STATE(6919),
    [sym__qualified_type] = STATE(7018),
    [sym__qtyconid] = STATE(6940),
    [sym__tycon_arrow] = STATE(6940),
    [sym__qtycon_arrow] = STATE(6940),
    [sym__promoted_tycons_alias] = STATE(6919),
    [sym__promoted_tycons] = STATE(6919),
    [sym__varsym_prefix] = STATE(6940),
    [sym__pvarsym] = STATE(6940),
    [sym__qvarsym_prefix] = STATE(6940),
    [sym__pqvarsym] = STATE(6940),
    [sym__consym_prefix] = STATE(6940),
    [sym__pconsym] = STATE(6940),
    [sym__qconsym_prefix] = STATE(6940),
    [sym__pqconsym] = STATE(6940),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(435),
    [sym__bracket_open] = STATE(1104),
    [sym__unboxed_open] = STATE(744),
    [sym_variable] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(2695),
    [anon_sym_SQUOTE] = ACTIONS(3325),
    [anon_sym_STAR] = ACTIONS(2701),
    [anon_sym_u2605] = ACTIONS(2701),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2703),
    [sym_char] = ACTIONS(2703),
    [sym_string] = ACTIONS(2703),
    [sym__integer_literal] = ACTIONS(2705),
    [sym__binary_literal] = ACTIONS(2707),
    [sym__octal_literal] = ACTIONS(2707),
    [sym__hex_literal] = ACTIONS(2707),
    [sym_implicit_variable] = ACTIONS(3327),
    [sym_name] = ACTIONS(3329),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2711),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1555] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8215),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1556] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8213),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1557] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8316),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1558] = {
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(336),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__paren_open] = STATE(400),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1559] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8212),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1560] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(294),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1561] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8211),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1562] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8315),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1563] = {
    [sym__type_parens] = STATE(7755),
    [sym__type_tuple] = STATE(7759),
    [sym__type_unboxed_tuple] = STATE(7760),
    [sym__type_unboxed_sum] = STATE(7761),
    [sym__type_list] = STATE(7763),
    [sym__type_promoted] = STATE(7754),
    [sym__type_star] = STATE(7754),
    [sym__type_wildcard] = STATE(7754),
    [sym__at_type] = STATE(7784),
    [sym__type_apply] = STATE(7764),
    [sym__type_infix] = STATE(7765),
    [sym_type] = STATE(1426),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8486),
    [sym__splice_dollars] = STATE(7310),
    [sym_splice] = STATE(7754),
    [sym_quasiquote] = STATE(7754),
    [sym_integer] = STATE(7762),
    [sym__plist] = STATE(7766),
    [sym_unit] = STATE(7754),
    [sym_unboxed_unit] = STATE(7754),
    [sym_prefix_tuple] = STATE(7754),
    [sym_prefix_unboxed_tuple] = STATE(7754),
    [sym_prefix_unboxed_sum] = STATE(7754),
    [sym_literal] = STATE(7754),
    [sym__qualified_type] = STATE(7738),
    [sym__qtyconid] = STATE(7767),
    [sym__tycon_arrow] = STATE(7767),
    [sym__qtycon_arrow] = STATE(7767),
    [sym__promoted_tycons_alias] = STATE(7754),
    [sym__promoted_tycons] = STATE(7754),
    [sym__tycon_ticked] = STATE(2687),
    [sym__qtycon_ticked] = STATE(2687),
    [sym__tyconids_ticked] = STATE(2687),
    [sym__promoted_tyconops_alias] = STATE(2687),
    [sym__promoted_tyconops] = STATE(2687),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2687),
    [sym__operator_alias] = STATE(2687),
    [sym__operator_minus] = STATE(2687),
    [sym__varsym_prefix] = STATE(7767),
    [sym__pvarsym] = STATE(7767),
    [sym__qualified_varsym] = STATE(2686),
    [sym__qvarsym_prefix] = STATE(7767),
    [sym__pqvarsym] = STATE(7767),
    [sym_constructor_operator] = STATE(2687),
    [sym__constructor_operator_alias] = STATE(2687),
    [sym__consym_prefix] = STATE(7767),
    [sym__pconsym] = STATE(7767),
    [sym__qualified_consym] = STATE(2679),
    [sym__qconsym_prefix] = STATE(7767),
    [sym__pqconsym] = STATE(7767),
    [sym__prefix_at] = STATE(2547),
    [sym__paren_open] = STATE(457),
    [sym__bracket_open] = STATE(995),
    [sym__unboxed_open] = STATE(813),
    [sym_variable] = ACTIONS(3363),
    [anon_sym__] = ACTIONS(3365),
    [anon_sym_SQUOTE] = ACTIONS(3367),
    [anon_sym_STAR] = ACTIONS(3369),
    [anon_sym_u2605] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(3425),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3373),
    [sym_char] = ACTIONS(3373),
    [sym_string] = ACTIONS(3373),
    [sym__integer_literal] = ACTIONS(3375),
    [sym__binary_literal] = ACTIONS(3377),
    [sym__octal_literal] = ACTIONS(3377),
    [sym__hex_literal] = ACTIONS(3377),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(3379),
    [anon_sym_u2192] = ACTIONS(3425),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(3425),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3381),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1564] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8469),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1565] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8302),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1566] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8464),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1567] = {
    [sym__type_parens] = STATE(6323),
    [sym__type_tuple] = STATE(6324),
    [sym__type_unboxed_tuple] = STATE(6325),
    [sym__type_unboxed_sum] = STATE(6326),
    [sym__type_list] = STATE(6327),
    [sym__type_promoted] = STATE(6321),
    [sym__type_star] = STATE(6321),
    [sym__type_wildcard] = STATE(6321),
    [sym__type_apply] = STATE(6328),
    [sym__type_infix] = STATE(6329),
    [sym_type] = STATE(754),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10134),
    [sym__qtype_forall] = STATE(8674),
    [sym__qtype_forall_required] = STATE(8673),
    [sym_strict_field] = STATE(8650),
    [sym_lazy_field] = STATE(8650),
    [sym__qtype_function] = STATE(8647),
    [sym__qtype_linear_function] = STATE(8671),
    [sym__qtype_context] = STATE(8665),
    [sym_quantified_type] = STATE(8184),
    [sym_implicit_parameter] = STATE(8661),
    [sym__context_inline] = STATE(1567),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11328),
    [sym__splice_dollars] = STATE(7407),
    [sym_splice] = STATE(6321),
    [sym_quasiquote] = STATE(6321),
    [sym_integer] = STATE(6269),
    [sym__plist] = STATE(6330),
    [sym_unit] = STATE(6321),
    [sym_unboxed_unit] = STATE(6321),
    [sym_prefix_tuple] = STATE(6321),
    [sym_prefix_unboxed_tuple] = STATE(6321),
    [sym_prefix_unboxed_sum] = STATE(6321),
    [sym_literal] = STATE(6321),
    [sym__qualified_type] = STATE(6286),
    [sym__qtyconid] = STATE(6331),
    [sym__tycon_arrow] = STATE(6331),
    [sym__qtycon_arrow] = STATE(6331),
    [sym__promoted_tycons_alias] = STATE(6321),
    [sym__promoted_tycons] = STATE(6321),
    [sym__varsym_prefix] = STATE(6331),
    [sym__pvarsym] = STATE(6331),
    [sym__qvarsym_prefix] = STATE(6331),
    [sym__pqvarsym] = STATE(6331),
    [sym__consym_prefix] = STATE(6331),
    [sym__pconsym] = STATE(6331),
    [sym__qconsym_prefix] = STATE(6331),
    [sym__pqconsym] = STATE(6331),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(469),
    [sym__bracket_open] = STATE(990),
    [sym__unboxed_open] = STATE(810),
    [sym_variable] = ACTIONS(2155),
    [anon_sym__] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_u2605] = ACTIONS(2163),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2165),
    [sym_char] = ACTIONS(2165),
    [sym_string] = ACTIONS(2165),
    [sym__integer_literal] = ACTIONS(2167),
    [sym__binary_literal] = ACTIONS(2169),
    [sym__octal_literal] = ACTIONS(2169),
    [sym__hex_literal] = ACTIONS(2169),
    [sym_implicit_variable] = ACTIONS(3429),
    [sym_name] = ACTIONS(3431),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2173),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1568] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8207),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1569] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8330),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1570] = {
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(141),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__paren_open] = STATE(406),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1571] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(322),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1572] = {
    [sym__type_parens] = STATE(7152),
    [sym__type_tuple] = STATE(7138),
    [sym__type_unboxed_tuple] = STATE(7137),
    [sym__type_unboxed_sum] = STATE(7135),
    [sym__type_list] = STATE(7133),
    [sym__type_promoted] = STATE(7020),
    [sym__type_star] = STATE(7020),
    [sym__type_wildcard] = STATE(7020),
    [sym__type_apply] = STATE(7132),
    [sym__type_infix] = STATE(7130),
    [sym_type] = STATE(938),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10217),
    [sym__qtype_forall] = STATE(8973),
    [sym__qtype_forall_required] = STATE(9051),
    [sym_strict_field] = STATE(8612),
    [sym_lazy_field] = STATE(8612),
    [sym__qtype_function] = STATE(8981),
    [sym__qtype_linear_function] = STATE(8983),
    [sym__qtype_context] = STATE(8984),
    [sym_quantified_type] = STATE(8389),
    [sym_implicit_parameter] = STATE(8985),
    [sym__context_inline] = STATE(1729),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10934),
    [sym__splice_dollars] = STATE(7456),
    [sym_splice] = STATE(7020),
    [sym_quasiquote] = STATE(7020),
    [sym_integer] = STATE(7159),
    [sym__plist] = STATE(7124),
    [sym_unit] = STATE(7020),
    [sym_unboxed_unit] = STATE(7020),
    [sym_prefix_tuple] = STATE(7020),
    [sym_prefix_unboxed_tuple] = STATE(7020),
    [sym_prefix_unboxed_sum] = STATE(7020),
    [sym_literal] = STATE(7020),
    [sym__qualified_type] = STATE(7160),
    [sym__qtyconid] = STATE(7122),
    [sym__tycon_arrow] = STATE(7122),
    [sym__qtycon_arrow] = STATE(7122),
    [sym__promoted_tycons_alias] = STATE(7020),
    [sym__promoted_tycons] = STATE(7020),
    [sym__varsym_prefix] = STATE(7122),
    [sym__pvarsym] = STATE(7122),
    [sym__qvarsym_prefix] = STATE(7122),
    [sym__pqvarsym] = STATE(7122),
    [sym__consym_prefix] = STATE(7122),
    [sym__pconsym] = STATE(7122),
    [sym__qconsym_prefix] = STATE(7122),
    [sym__pqconsym] = STATE(7122),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(473),
    [sym__bracket_open] = STATE(1082),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = ACTIONS(2781),
    [anon_sym__] = ACTIONS(2783),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [anon_sym_STAR] = ACTIONS(2789),
    [anon_sym_u2605] = ACTIONS(2789),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2791),
    [sym_char] = ACTIONS(2791),
    [sym_string] = ACTIONS(2791),
    [sym__integer_literal] = ACTIONS(2793),
    [sym__binary_literal] = ACTIONS(2795),
    [sym__octal_literal] = ACTIONS(2795),
    [sym__hex_literal] = ACTIONS(2795),
    [sym_implicit_variable] = ACTIONS(3435),
    [sym_name] = ACTIONS(3437),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2799),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1573] = {
    [sym__type_parens] = STATE(3220),
    [sym__type_tuple] = STATE(3210),
    [sym__type_unboxed_tuple] = STATE(3184),
    [sym__type_unboxed_sum] = STATE(3188),
    [sym__type_list] = STATE(3211),
    [sym__type_promoted] = STATE(3364),
    [sym__type_star] = STATE(3364),
    [sym__type_wildcard] = STATE(3364),
    [sym__type_apply] = STATE(3196),
    [sym__type_infix] = STATE(3225),
    [sym_type] = STATE(480),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10104),
    [sym__qtype_forall] = STATE(3791),
    [sym__qtype_forall_required] = STATE(3793),
    [sym_strict_field] = STATE(8711),
    [sym_lazy_field] = STATE(8711),
    [sym__qtype_function] = STATE(3794),
    [sym__qtype_linear_function] = STATE(3797),
    [sym__qtype_context] = STATE(3798),
    [sym_quantified_type] = STATE(2756),
    [sym_implicit_parameter] = STATE(3799),
    [sym__context_inline] = STATE(1724),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11198),
    [sym__splice_dollars] = STATE(7401),
    [sym_splice] = STATE(3364),
    [sym_quasiquote] = STATE(3364),
    [sym_integer] = STATE(3397),
    [sym__plist] = STATE(3177),
    [sym_unit] = STATE(3364),
    [sym_unboxed_unit] = STATE(3364),
    [sym_prefix_tuple] = STATE(3364),
    [sym_prefix_unboxed_tuple] = STATE(3364),
    [sym_prefix_unboxed_sum] = STATE(3364),
    [sym_literal] = STATE(3364),
    [sym__qualified_type] = STATE(3262),
    [sym__qtyconid] = STATE(3232),
    [sym__tycon_arrow] = STATE(3232),
    [sym__qtycon_arrow] = STATE(3232),
    [sym__promoted_tycons_alias] = STATE(3364),
    [sym__promoted_tycons] = STATE(3364),
    [sym__varsym_prefix] = STATE(3232),
    [sym__pvarsym] = STATE(3232),
    [sym__qvarsym_prefix] = STATE(3232),
    [sym__pqvarsym] = STATE(3232),
    [sym__consym_prefix] = STATE(3232),
    [sym__pconsym] = STATE(3232),
    [sym__qconsym_prefix] = STATE(3232),
    [sym__pqconsym] = STATE(3232),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(466),
    [sym__bracket_open] = STATE(1073),
    [sym__unboxed_open] = STATE(781),
    [sym_variable] = ACTIONS(1569),
    [anon_sym__] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(1577),
    [anon_sym_u2605] = ACTIONS(1577),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1579),
    [sym_char] = ACTIONS(1579),
    [sym_string] = ACTIONS(1579),
    [sym__integer_literal] = ACTIONS(1581),
    [sym__binary_literal] = ACTIONS(1583),
    [sym__octal_literal] = ACTIONS(1583),
    [sym__hex_literal] = ACTIONS(1583),
    [sym_implicit_variable] = ACTIONS(3441),
    [sym_name] = ACTIONS(3443),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1587),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1574] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8312),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1575] = {
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(144),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__paren_open] = STATE(406),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1576] = {
    [sym__type_parens] = STATE(3379),
    [sym__type_tuple] = STATE(3377),
    [sym__type_unboxed_tuple] = STATE(3370),
    [sym__type_unboxed_sum] = STATE(3369),
    [sym__type_list] = STATE(3361),
    [sym__type_promoted] = STATE(3383),
    [sym__type_star] = STATE(3383),
    [sym__type_wildcard] = STATE(3383),
    [sym__type_apply] = STATE(3359),
    [sym__type_infix] = STATE(3358),
    [sym_type] = STATE(486),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10095),
    [sym__qtype_forall] = STATE(3757),
    [sym__qtype_forall_required] = STATE(3758),
    [sym_strict_field] = STATE(8706),
    [sym_lazy_field] = STATE(8706),
    [sym__qtype_function] = STATE(3762),
    [sym__qtype_linear_function] = STATE(3767),
    [sym__qtype_context] = STATE(3768),
    [sym_quantified_type] = STATE(2785),
    [sym_implicit_parameter] = STATE(3788),
    [sym__context_inline] = STATE(1749),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11178),
    [sym__splice_dollars] = STATE(7460),
    [sym_splice] = STATE(3383),
    [sym_quasiquote] = STATE(3383),
    [sym_integer] = STATE(3269),
    [sym__plist] = STATE(3357),
    [sym_unit] = STATE(3383),
    [sym_unboxed_unit] = STATE(3383),
    [sym_prefix_tuple] = STATE(3383),
    [sym_prefix_unboxed_tuple] = STATE(3383),
    [sym_prefix_unboxed_sum] = STATE(3383),
    [sym_literal] = STATE(3383),
    [sym__qualified_type] = STATE(3410),
    [sym__qtyconid] = STATE(3354),
    [sym__tycon_arrow] = STATE(3354),
    [sym__qtycon_arrow] = STATE(3354),
    [sym__promoted_tycons_alias] = STATE(3383),
    [sym__promoted_tycons] = STATE(3383),
    [sym__varsym_prefix] = STATE(3354),
    [sym__pvarsym] = STATE(3354),
    [sym__qvarsym_prefix] = STATE(3354),
    [sym__pqvarsym] = STATE(3354),
    [sym__consym_prefix] = STATE(3354),
    [sym__pconsym] = STATE(3354),
    [sym__qconsym_prefix] = STATE(3354),
    [sym__pqconsym] = STATE(3354),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(464),
    [sym__bracket_open] = STATE(1079),
    [sym__unboxed_open] = STATE(805),
    [sym_variable] = ACTIONS(1609),
    [anon_sym__] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_u2605] = ACTIONS(1617),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1619),
    [sym_char] = ACTIONS(1619),
    [sym_string] = ACTIONS(1619),
    [sym__integer_literal] = ACTIONS(1621),
    [sym__binary_literal] = ACTIONS(1623),
    [sym__octal_literal] = ACTIONS(1623),
    [sym__hex_literal] = ACTIONS(1623),
    [sym_implicit_variable] = ACTIONS(3385),
    [sym_name] = ACTIONS(3387),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1627),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1577] = {
    [sym__type_parens] = STATE(5938),
    [sym__type_tuple] = STATE(5929),
    [sym__type_unboxed_tuple] = STATE(5928),
    [sym__type_unboxed_sum] = STATE(5927),
    [sym__type_list] = STATE(5923),
    [sym__type_promoted] = STATE(5958),
    [sym__type_star] = STATE(5958),
    [sym__type_wildcard] = STATE(5958),
    [sym__type_apply] = STATE(5917),
    [sym__type_infix] = STATE(5912),
    [sym_type] = STATE(657),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10206),
    [sym__qtype_forall] = STATE(8513),
    [sym__qtype_forall_required] = STATE(8526),
    [sym_strict_field] = STATE(8613),
    [sym_lazy_field] = STATE(8613),
    [sym__qtype_function] = STATE(8527),
    [sym__qtype_linear_function] = STATE(8528),
    [sym__qtype_context] = STATE(8530),
    [sym_quantified_type] = STATE(8120),
    [sym_implicit_parameter] = STATE(8537),
    [sym__context_inline] = STATE(1598),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11083),
    [sym__splice_dollars] = STATE(7467),
    [sym_splice] = STATE(5958),
    [sym_quasiquote] = STATE(5958),
    [sym_integer] = STATE(6013),
    [sym__plist] = STATE(5900),
    [sym_unit] = STATE(5958),
    [sym_unboxed_unit] = STATE(5958),
    [sym_prefix_tuple] = STATE(5958),
    [sym_prefix_unboxed_tuple] = STATE(5958),
    [sym_prefix_unboxed_sum] = STATE(5958),
    [sym_literal] = STATE(5958),
    [sym__qualified_type] = STATE(5983),
    [sym__qtyconid] = STATE(5894),
    [sym__tycon_arrow] = STATE(5894),
    [sym__qtycon_arrow] = STATE(5894),
    [sym__promoted_tycons_alias] = STATE(5958),
    [sym__promoted_tycons] = STATE(5958),
    [sym__varsym_prefix] = STATE(5894),
    [sym__pvarsym] = STATE(5894),
    [sym__qvarsym_prefix] = STATE(5894),
    [sym__pqvarsym] = STATE(5894),
    [sym__consym_prefix] = STATE(5894),
    [sym__pconsym] = STATE(5894),
    [sym__qconsym_prefix] = STATE(5894),
    [sym__pqconsym] = STATE(5894),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(460),
    [sym__bracket_open] = STATE(1045),
    [sym__unboxed_open] = STATE(826),
    [sym_variable] = ACTIONS(1887),
    [anon_sym__] = ACTIONS(1889),
    [anon_sym_SQUOTE] = ACTIONS(3299),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_u2605] = ACTIONS(1895),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1897),
    [sym_char] = ACTIONS(1897),
    [sym_string] = ACTIONS(1897),
    [sym__integer_literal] = ACTIONS(1899),
    [sym__binary_literal] = ACTIONS(1901),
    [sym__octal_literal] = ACTIONS(1901),
    [sym__hex_literal] = ACTIONS(1901),
    [sym_implicit_variable] = ACTIONS(3301),
    [sym_name] = ACTIONS(3303),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1905),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1578] = {
    [sym__type_parens] = STATE(5938),
    [sym__type_tuple] = STATE(5929),
    [sym__type_unboxed_tuple] = STATE(5928),
    [sym__type_unboxed_sum] = STATE(5927),
    [sym__type_list] = STATE(5923),
    [sym__type_promoted] = STATE(5958),
    [sym__type_star] = STATE(5958),
    [sym__type_wildcard] = STATE(5958),
    [sym__type_apply] = STATE(5917),
    [sym__type_infix] = STATE(5912),
    [sym_type] = STATE(657),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10206),
    [sym__qtype_forall] = STATE(8513),
    [sym__qtype_forall_required] = STATE(8526),
    [sym_strict_field] = STATE(8613),
    [sym_lazy_field] = STATE(8613),
    [sym__qtype_function] = STATE(8527),
    [sym__qtype_linear_function] = STATE(8528),
    [sym__qtype_context] = STATE(8530),
    [sym_quantified_type] = STATE(8136),
    [sym_implicit_parameter] = STATE(8537),
    [sym__context_inline] = STATE(1598),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11083),
    [sym__splice_dollars] = STATE(7467),
    [sym_splice] = STATE(5958),
    [sym_quasiquote] = STATE(5958),
    [sym_integer] = STATE(6013),
    [sym__plist] = STATE(5900),
    [sym_unit] = STATE(5958),
    [sym_unboxed_unit] = STATE(5958),
    [sym_prefix_tuple] = STATE(5958),
    [sym_prefix_unboxed_tuple] = STATE(5958),
    [sym_prefix_unboxed_sum] = STATE(5958),
    [sym_literal] = STATE(5958),
    [sym__qualified_type] = STATE(5983),
    [sym__qtyconid] = STATE(5894),
    [sym__tycon_arrow] = STATE(5894),
    [sym__qtycon_arrow] = STATE(5894),
    [sym__promoted_tycons_alias] = STATE(5958),
    [sym__promoted_tycons] = STATE(5958),
    [sym__varsym_prefix] = STATE(5894),
    [sym__pvarsym] = STATE(5894),
    [sym__qvarsym_prefix] = STATE(5894),
    [sym__pqvarsym] = STATE(5894),
    [sym__consym_prefix] = STATE(5894),
    [sym__pconsym] = STATE(5894),
    [sym__qconsym_prefix] = STATE(5894),
    [sym__pqconsym] = STATE(5894),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(460),
    [sym__bracket_open] = STATE(1045),
    [sym__unboxed_open] = STATE(826),
    [sym_variable] = ACTIONS(1887),
    [anon_sym__] = ACTIONS(1889),
    [anon_sym_SQUOTE] = ACTIONS(3299),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_u2605] = ACTIONS(1895),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1897),
    [sym_char] = ACTIONS(1897),
    [sym_string] = ACTIONS(1897),
    [sym__integer_literal] = ACTIONS(1899),
    [sym__binary_literal] = ACTIONS(1901),
    [sym__octal_literal] = ACTIONS(1901),
    [sym__hex_literal] = ACTIONS(1901),
    [sym_implicit_variable] = ACTIONS(3301),
    [sym_name] = ACTIONS(3303),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1905),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1579] = {
    [sym__type_parens] = STATE(5938),
    [sym__type_tuple] = STATE(5929),
    [sym__type_unboxed_tuple] = STATE(5928),
    [sym__type_unboxed_sum] = STATE(5927),
    [sym__type_list] = STATE(5923),
    [sym__type_promoted] = STATE(5958),
    [sym__type_star] = STATE(5958),
    [sym__type_wildcard] = STATE(5958),
    [sym__type_apply] = STATE(5917),
    [sym__type_infix] = STATE(5912),
    [sym_type] = STATE(657),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10206),
    [sym__qtype_forall] = STATE(8513),
    [sym__qtype_forall_required] = STATE(8526),
    [sym_strict_field] = STATE(8613),
    [sym_lazy_field] = STATE(8613),
    [sym__qtype_function] = STATE(8527),
    [sym__qtype_linear_function] = STATE(8528),
    [sym__qtype_context] = STATE(8530),
    [sym_quantified_type] = STATE(8134),
    [sym_implicit_parameter] = STATE(8537),
    [sym__context_inline] = STATE(1598),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11083),
    [sym__splice_dollars] = STATE(7467),
    [sym_splice] = STATE(5958),
    [sym_quasiquote] = STATE(5958),
    [sym_integer] = STATE(6013),
    [sym__plist] = STATE(5900),
    [sym_unit] = STATE(5958),
    [sym_unboxed_unit] = STATE(5958),
    [sym_prefix_tuple] = STATE(5958),
    [sym_prefix_unboxed_tuple] = STATE(5958),
    [sym_prefix_unboxed_sum] = STATE(5958),
    [sym_literal] = STATE(5958),
    [sym__qualified_type] = STATE(5983),
    [sym__qtyconid] = STATE(5894),
    [sym__tycon_arrow] = STATE(5894),
    [sym__qtycon_arrow] = STATE(5894),
    [sym__promoted_tycons_alias] = STATE(5958),
    [sym__promoted_tycons] = STATE(5958),
    [sym__varsym_prefix] = STATE(5894),
    [sym__pvarsym] = STATE(5894),
    [sym__qvarsym_prefix] = STATE(5894),
    [sym__pqvarsym] = STATE(5894),
    [sym__consym_prefix] = STATE(5894),
    [sym__pconsym] = STATE(5894),
    [sym__qconsym_prefix] = STATE(5894),
    [sym__pqconsym] = STATE(5894),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(460),
    [sym__bracket_open] = STATE(1045),
    [sym__unboxed_open] = STATE(826),
    [sym_variable] = ACTIONS(1887),
    [anon_sym__] = ACTIONS(1889),
    [anon_sym_SQUOTE] = ACTIONS(3299),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_u2605] = ACTIONS(1895),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1897),
    [sym_char] = ACTIONS(1897),
    [sym_string] = ACTIONS(1897),
    [sym__integer_literal] = ACTIONS(1899),
    [sym__binary_literal] = ACTIONS(1901),
    [sym__octal_literal] = ACTIONS(1901),
    [sym__hex_literal] = ACTIONS(1901),
    [sym_implicit_variable] = ACTIONS(3301),
    [sym_name] = ACTIONS(3303),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1905),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1580] = {
    [sym__type_parens] = STATE(5938),
    [sym__type_tuple] = STATE(5929),
    [sym__type_unboxed_tuple] = STATE(5928),
    [sym__type_unboxed_sum] = STATE(5927),
    [sym__type_list] = STATE(5923),
    [sym__type_promoted] = STATE(5958),
    [sym__type_star] = STATE(5958),
    [sym__type_wildcard] = STATE(5958),
    [sym__type_apply] = STATE(5917),
    [sym__type_infix] = STATE(5912),
    [sym_type] = STATE(657),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10206),
    [sym__qtype_forall] = STATE(8513),
    [sym__qtype_forall_required] = STATE(8526),
    [sym_strict_field] = STATE(8613),
    [sym_lazy_field] = STATE(8613),
    [sym__qtype_function] = STATE(8527),
    [sym__qtype_linear_function] = STATE(8528),
    [sym__qtype_context] = STATE(8530),
    [sym_quantified_type] = STATE(8133),
    [sym_implicit_parameter] = STATE(8537),
    [sym__context_inline] = STATE(1598),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11083),
    [sym__splice_dollars] = STATE(7467),
    [sym_splice] = STATE(5958),
    [sym_quasiquote] = STATE(5958),
    [sym_integer] = STATE(6013),
    [sym__plist] = STATE(5900),
    [sym_unit] = STATE(5958),
    [sym_unboxed_unit] = STATE(5958),
    [sym_prefix_tuple] = STATE(5958),
    [sym_prefix_unboxed_tuple] = STATE(5958),
    [sym_prefix_unboxed_sum] = STATE(5958),
    [sym_literal] = STATE(5958),
    [sym__qualified_type] = STATE(5983),
    [sym__qtyconid] = STATE(5894),
    [sym__tycon_arrow] = STATE(5894),
    [sym__qtycon_arrow] = STATE(5894),
    [sym__promoted_tycons_alias] = STATE(5958),
    [sym__promoted_tycons] = STATE(5958),
    [sym__varsym_prefix] = STATE(5894),
    [sym__pvarsym] = STATE(5894),
    [sym__qvarsym_prefix] = STATE(5894),
    [sym__pqvarsym] = STATE(5894),
    [sym__consym_prefix] = STATE(5894),
    [sym__pconsym] = STATE(5894),
    [sym__qconsym_prefix] = STATE(5894),
    [sym__pqconsym] = STATE(5894),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(460),
    [sym__bracket_open] = STATE(1045),
    [sym__unboxed_open] = STATE(826),
    [sym_variable] = ACTIONS(1887),
    [anon_sym__] = ACTIONS(1889),
    [anon_sym_SQUOTE] = ACTIONS(3299),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_u2605] = ACTIONS(1895),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1897),
    [sym_char] = ACTIONS(1897),
    [sym_string] = ACTIONS(1897),
    [sym__integer_literal] = ACTIONS(1899),
    [sym__binary_literal] = ACTIONS(1901),
    [sym__octal_literal] = ACTIONS(1901),
    [sym__hex_literal] = ACTIONS(1901),
    [sym_implicit_variable] = ACTIONS(3301),
    [sym_name] = ACTIONS(3303),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1905),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1581] = {
    [sym__type_parens] = STATE(5938),
    [sym__type_tuple] = STATE(5929),
    [sym__type_unboxed_tuple] = STATE(5928),
    [sym__type_unboxed_sum] = STATE(5927),
    [sym__type_list] = STATE(5923),
    [sym__type_promoted] = STATE(5958),
    [sym__type_star] = STATE(5958),
    [sym__type_wildcard] = STATE(5958),
    [sym__type_apply] = STATE(5917),
    [sym__type_infix] = STATE(5912),
    [sym_type] = STATE(657),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10206),
    [sym__qtype_forall] = STATE(8513),
    [sym__qtype_forall_required] = STATE(8526),
    [sym_strict_field] = STATE(8613),
    [sym_lazy_field] = STATE(8613),
    [sym__qtype_function] = STATE(8527),
    [sym__qtype_linear_function] = STATE(8528),
    [sym__qtype_context] = STATE(8530),
    [sym_quantified_type] = STATE(8132),
    [sym_implicit_parameter] = STATE(8537),
    [sym__context_inline] = STATE(1598),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11083),
    [sym__splice_dollars] = STATE(7467),
    [sym_splice] = STATE(5958),
    [sym_quasiquote] = STATE(5958),
    [sym_integer] = STATE(6013),
    [sym__plist] = STATE(5900),
    [sym_unit] = STATE(5958),
    [sym_unboxed_unit] = STATE(5958),
    [sym_prefix_tuple] = STATE(5958),
    [sym_prefix_unboxed_tuple] = STATE(5958),
    [sym_prefix_unboxed_sum] = STATE(5958),
    [sym_literal] = STATE(5958),
    [sym__qualified_type] = STATE(5983),
    [sym__qtyconid] = STATE(5894),
    [sym__tycon_arrow] = STATE(5894),
    [sym__qtycon_arrow] = STATE(5894),
    [sym__promoted_tycons_alias] = STATE(5958),
    [sym__promoted_tycons] = STATE(5958),
    [sym__varsym_prefix] = STATE(5894),
    [sym__pvarsym] = STATE(5894),
    [sym__qvarsym_prefix] = STATE(5894),
    [sym__pqvarsym] = STATE(5894),
    [sym__consym_prefix] = STATE(5894),
    [sym__pconsym] = STATE(5894),
    [sym__qconsym_prefix] = STATE(5894),
    [sym__pqconsym] = STATE(5894),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(460),
    [sym__bracket_open] = STATE(1045),
    [sym__unboxed_open] = STATE(826),
    [sym_variable] = ACTIONS(1887),
    [anon_sym__] = ACTIONS(1889),
    [anon_sym_SQUOTE] = ACTIONS(3299),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_u2605] = ACTIONS(1895),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1897),
    [sym_char] = ACTIONS(1897),
    [sym_string] = ACTIONS(1897),
    [sym__integer_literal] = ACTIONS(1899),
    [sym__binary_literal] = ACTIONS(1901),
    [sym__octal_literal] = ACTIONS(1901),
    [sym__hex_literal] = ACTIONS(1901),
    [sym_implicit_variable] = ACTIONS(3301),
    [sym_name] = ACTIONS(3303),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1905),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1582] = {
    [sym__type_parens] = STATE(7152),
    [sym__type_tuple] = STATE(7138),
    [sym__type_unboxed_tuple] = STATE(7137),
    [sym__type_unboxed_sum] = STATE(7135),
    [sym__type_list] = STATE(7133),
    [sym__type_promoted] = STATE(7020),
    [sym__type_star] = STATE(7020),
    [sym__type_wildcard] = STATE(7020),
    [sym__type_apply] = STATE(7132),
    [sym__type_infix] = STATE(7130),
    [sym_type] = STATE(938),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10217),
    [sym__qtype_forall] = STATE(8973),
    [sym__qtype_forall_required] = STATE(9051),
    [sym_strict_field] = STATE(8612),
    [sym_lazy_field] = STATE(8612),
    [sym__qtype_function] = STATE(8981),
    [sym__qtype_linear_function] = STATE(8983),
    [sym__qtype_context] = STATE(8984),
    [sym_quantified_type] = STATE(8509),
    [sym_implicit_parameter] = STATE(8985),
    [sym__context_inline] = STATE(1729),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10934),
    [sym__splice_dollars] = STATE(7456),
    [sym_splice] = STATE(7020),
    [sym_quasiquote] = STATE(7020),
    [sym_integer] = STATE(7159),
    [sym__plist] = STATE(7124),
    [sym_unit] = STATE(7020),
    [sym_unboxed_unit] = STATE(7020),
    [sym_prefix_tuple] = STATE(7020),
    [sym_prefix_unboxed_tuple] = STATE(7020),
    [sym_prefix_unboxed_sum] = STATE(7020),
    [sym_literal] = STATE(7020),
    [sym__qualified_type] = STATE(7160),
    [sym__qtyconid] = STATE(7122),
    [sym__tycon_arrow] = STATE(7122),
    [sym__qtycon_arrow] = STATE(7122),
    [sym__promoted_tycons_alias] = STATE(7020),
    [sym__promoted_tycons] = STATE(7020),
    [sym__varsym_prefix] = STATE(7122),
    [sym__pvarsym] = STATE(7122),
    [sym__qvarsym_prefix] = STATE(7122),
    [sym__pqvarsym] = STATE(7122),
    [sym__consym_prefix] = STATE(7122),
    [sym__pconsym] = STATE(7122),
    [sym__qconsym_prefix] = STATE(7122),
    [sym__pqconsym] = STATE(7122),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(473),
    [sym__bracket_open] = STATE(1082),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = ACTIONS(2781),
    [anon_sym__] = ACTIONS(2783),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [anon_sym_STAR] = ACTIONS(2789),
    [anon_sym_u2605] = ACTIONS(2789),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2791),
    [sym_char] = ACTIONS(2791),
    [sym_string] = ACTIONS(2791),
    [sym__integer_literal] = ACTIONS(2793),
    [sym__binary_literal] = ACTIONS(2795),
    [sym__octal_literal] = ACTIONS(2795),
    [sym__hex_literal] = ACTIONS(2795),
    [sym_implicit_variable] = ACTIONS(3435),
    [sym_name] = ACTIONS(3437),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2799),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1583] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8414),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1584] = {
    [sym__type_parens] = STATE(3379),
    [sym__type_tuple] = STATE(3377),
    [sym__type_unboxed_tuple] = STATE(3370),
    [sym__type_unboxed_sum] = STATE(3369),
    [sym__type_list] = STATE(3361),
    [sym__type_promoted] = STATE(3383),
    [sym__type_star] = STATE(3383),
    [sym__type_wildcard] = STATE(3383),
    [sym__type_apply] = STATE(3359),
    [sym__type_infix] = STATE(3358),
    [sym_type] = STATE(486),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10095),
    [sym__qtype_forall] = STATE(3757),
    [sym__qtype_forall_required] = STATE(3758),
    [sym_strict_field] = STATE(8706),
    [sym_lazy_field] = STATE(8706),
    [sym__qtype_function] = STATE(3762),
    [sym__qtype_linear_function] = STATE(3767),
    [sym__qtype_context] = STATE(3768),
    [sym_quantified_type] = STATE(2784),
    [sym_implicit_parameter] = STATE(3788),
    [sym__context_inline] = STATE(1749),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11178),
    [sym__splice_dollars] = STATE(7460),
    [sym_splice] = STATE(3383),
    [sym_quasiquote] = STATE(3383),
    [sym_integer] = STATE(3269),
    [sym__plist] = STATE(3357),
    [sym_unit] = STATE(3383),
    [sym_unboxed_unit] = STATE(3383),
    [sym_prefix_tuple] = STATE(3383),
    [sym_prefix_unboxed_tuple] = STATE(3383),
    [sym_prefix_unboxed_sum] = STATE(3383),
    [sym_literal] = STATE(3383),
    [sym__qualified_type] = STATE(3410),
    [sym__qtyconid] = STATE(3354),
    [sym__tycon_arrow] = STATE(3354),
    [sym__qtycon_arrow] = STATE(3354),
    [sym__promoted_tycons_alias] = STATE(3383),
    [sym__promoted_tycons] = STATE(3383),
    [sym__varsym_prefix] = STATE(3354),
    [sym__pvarsym] = STATE(3354),
    [sym__qvarsym_prefix] = STATE(3354),
    [sym__pqvarsym] = STATE(3354),
    [sym__consym_prefix] = STATE(3354),
    [sym__pconsym] = STATE(3354),
    [sym__qconsym_prefix] = STATE(3354),
    [sym__pqconsym] = STATE(3354),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(464),
    [sym__bracket_open] = STATE(1079),
    [sym__unboxed_open] = STATE(805),
    [sym_variable] = ACTIONS(1609),
    [anon_sym__] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_u2605] = ACTIONS(1617),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1619),
    [sym_char] = ACTIONS(1619),
    [sym_string] = ACTIONS(1619),
    [sym__integer_literal] = ACTIONS(1621),
    [sym__binary_literal] = ACTIONS(1623),
    [sym__octal_literal] = ACTIONS(1623),
    [sym__hex_literal] = ACTIONS(1623),
    [sym_implicit_variable] = ACTIONS(3385),
    [sym_name] = ACTIONS(3387),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1627),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1585] = {
    [sym__type_parens] = STATE(6323),
    [sym__type_tuple] = STATE(6324),
    [sym__type_unboxed_tuple] = STATE(6325),
    [sym__type_unboxed_sum] = STATE(6326),
    [sym__type_list] = STATE(6327),
    [sym__type_promoted] = STATE(6321),
    [sym__type_star] = STATE(6321),
    [sym__type_wildcard] = STATE(6321),
    [sym__type_apply] = STATE(6328),
    [sym__type_infix] = STATE(6329),
    [sym_type] = STATE(754),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10134),
    [sym__qtype_forall] = STATE(8674),
    [sym__qtype_forall_required] = STATE(8673),
    [sym_strict_field] = STATE(8650),
    [sym_lazy_field] = STATE(8650),
    [sym__qtype_function] = STATE(8647),
    [sym__qtype_linear_function] = STATE(8671),
    [sym__qtype_context] = STATE(8665),
    [sym_quantified_type] = STATE(8201),
    [sym_implicit_parameter] = STATE(8661),
    [sym__context_inline] = STATE(1567),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11328),
    [sym__splice_dollars] = STATE(7407),
    [sym_splice] = STATE(6321),
    [sym_quasiquote] = STATE(6321),
    [sym_integer] = STATE(6269),
    [sym__plist] = STATE(6330),
    [sym_unit] = STATE(6321),
    [sym_unboxed_unit] = STATE(6321),
    [sym_prefix_tuple] = STATE(6321),
    [sym_prefix_unboxed_tuple] = STATE(6321),
    [sym_prefix_unboxed_sum] = STATE(6321),
    [sym_literal] = STATE(6321),
    [sym__qualified_type] = STATE(6286),
    [sym__qtyconid] = STATE(6331),
    [sym__tycon_arrow] = STATE(6331),
    [sym__qtycon_arrow] = STATE(6331),
    [sym__promoted_tycons_alias] = STATE(6321),
    [sym__promoted_tycons] = STATE(6321),
    [sym__varsym_prefix] = STATE(6331),
    [sym__pvarsym] = STATE(6331),
    [sym__qvarsym_prefix] = STATE(6331),
    [sym__pqvarsym] = STATE(6331),
    [sym__consym_prefix] = STATE(6331),
    [sym__pconsym] = STATE(6331),
    [sym__qconsym_prefix] = STATE(6331),
    [sym__pqconsym] = STATE(6331),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(469),
    [sym__bracket_open] = STATE(990),
    [sym__unboxed_open] = STATE(810),
    [sym_variable] = ACTIONS(2155),
    [anon_sym__] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_u2605] = ACTIONS(2163),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2165),
    [sym_char] = ACTIONS(2165),
    [sym_string] = ACTIONS(2165),
    [sym__integer_literal] = ACTIONS(2167),
    [sym__binary_literal] = ACTIONS(2169),
    [sym__octal_literal] = ACTIONS(2169),
    [sym__hex_literal] = ACTIONS(2169),
    [sym_implicit_variable] = ACTIONS(3429),
    [sym_name] = ACTIONS(3431),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2173),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1586] = {
    [sym__type_parens] = STATE(6323),
    [sym__type_tuple] = STATE(6324),
    [sym__type_unboxed_tuple] = STATE(6325),
    [sym__type_unboxed_sum] = STATE(6326),
    [sym__type_list] = STATE(6327),
    [sym__type_promoted] = STATE(6321),
    [sym__type_star] = STATE(6321),
    [sym__type_wildcard] = STATE(6321),
    [sym__type_apply] = STATE(6328),
    [sym__type_infix] = STATE(6329),
    [sym_type] = STATE(754),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10134),
    [sym__qtype_forall] = STATE(8674),
    [sym__qtype_forall_required] = STATE(8673),
    [sym_strict_field] = STATE(8650),
    [sym_lazy_field] = STATE(8650),
    [sym__qtype_function] = STATE(8647),
    [sym__qtype_linear_function] = STATE(8671),
    [sym__qtype_context] = STATE(8665),
    [sym_quantified_type] = STATE(8205),
    [sym_implicit_parameter] = STATE(8661),
    [sym__context_inline] = STATE(1567),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11328),
    [sym__splice_dollars] = STATE(7407),
    [sym_splice] = STATE(6321),
    [sym_quasiquote] = STATE(6321),
    [sym_integer] = STATE(6269),
    [sym__plist] = STATE(6330),
    [sym_unit] = STATE(6321),
    [sym_unboxed_unit] = STATE(6321),
    [sym_prefix_tuple] = STATE(6321),
    [sym_prefix_unboxed_tuple] = STATE(6321),
    [sym_prefix_unboxed_sum] = STATE(6321),
    [sym_literal] = STATE(6321),
    [sym__qualified_type] = STATE(6286),
    [sym__qtyconid] = STATE(6331),
    [sym__tycon_arrow] = STATE(6331),
    [sym__qtycon_arrow] = STATE(6331),
    [sym__promoted_tycons_alias] = STATE(6321),
    [sym__promoted_tycons] = STATE(6321),
    [sym__varsym_prefix] = STATE(6331),
    [sym__pvarsym] = STATE(6331),
    [sym__qvarsym_prefix] = STATE(6331),
    [sym__pqvarsym] = STATE(6331),
    [sym__consym_prefix] = STATE(6331),
    [sym__pconsym] = STATE(6331),
    [sym__qconsym_prefix] = STATE(6331),
    [sym__pqconsym] = STATE(6331),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(469),
    [sym__bracket_open] = STATE(990),
    [sym__unboxed_open] = STATE(810),
    [sym_variable] = ACTIONS(2155),
    [anon_sym__] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_u2605] = ACTIONS(2163),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2165),
    [sym_char] = ACTIONS(2165),
    [sym_string] = ACTIONS(2165),
    [sym__integer_literal] = ACTIONS(2167),
    [sym__binary_literal] = ACTIONS(2169),
    [sym__octal_literal] = ACTIONS(2169),
    [sym__hex_literal] = ACTIONS(2169),
    [sym_implicit_variable] = ACTIONS(3429),
    [sym_name] = ACTIONS(3431),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2173),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1587] = {
    [sym__type_parens] = STATE(6323),
    [sym__type_tuple] = STATE(6324),
    [sym__type_unboxed_tuple] = STATE(6325),
    [sym__type_unboxed_sum] = STATE(6326),
    [sym__type_list] = STATE(6327),
    [sym__type_promoted] = STATE(6321),
    [sym__type_star] = STATE(6321),
    [sym__type_wildcard] = STATE(6321),
    [sym__type_apply] = STATE(6328),
    [sym__type_infix] = STATE(6329),
    [sym_type] = STATE(754),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10134),
    [sym__qtype_forall] = STATE(8674),
    [sym__qtype_forall_required] = STATE(8673),
    [sym_strict_field] = STATE(8650),
    [sym_lazy_field] = STATE(8650),
    [sym__qtype_function] = STATE(8647),
    [sym__qtype_linear_function] = STATE(8671),
    [sym__qtype_context] = STATE(8665),
    [sym_quantified_type] = STATE(8206),
    [sym_implicit_parameter] = STATE(8661),
    [sym__context_inline] = STATE(1567),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11328),
    [sym__splice_dollars] = STATE(7407),
    [sym_splice] = STATE(6321),
    [sym_quasiquote] = STATE(6321),
    [sym_integer] = STATE(6269),
    [sym__plist] = STATE(6330),
    [sym_unit] = STATE(6321),
    [sym_unboxed_unit] = STATE(6321),
    [sym_prefix_tuple] = STATE(6321),
    [sym_prefix_unboxed_tuple] = STATE(6321),
    [sym_prefix_unboxed_sum] = STATE(6321),
    [sym_literal] = STATE(6321),
    [sym__qualified_type] = STATE(6286),
    [sym__qtyconid] = STATE(6331),
    [sym__tycon_arrow] = STATE(6331),
    [sym__qtycon_arrow] = STATE(6331),
    [sym__promoted_tycons_alias] = STATE(6321),
    [sym__promoted_tycons] = STATE(6321),
    [sym__varsym_prefix] = STATE(6331),
    [sym__pvarsym] = STATE(6331),
    [sym__qvarsym_prefix] = STATE(6331),
    [sym__pqvarsym] = STATE(6331),
    [sym__consym_prefix] = STATE(6331),
    [sym__pconsym] = STATE(6331),
    [sym__qconsym_prefix] = STATE(6331),
    [sym__pqconsym] = STATE(6331),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(469),
    [sym__bracket_open] = STATE(990),
    [sym__unboxed_open] = STATE(810),
    [sym_variable] = ACTIONS(2155),
    [anon_sym__] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_u2605] = ACTIONS(2163),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2165),
    [sym_char] = ACTIONS(2165),
    [sym_string] = ACTIONS(2165),
    [sym__integer_literal] = ACTIONS(2167),
    [sym__binary_literal] = ACTIONS(2169),
    [sym__octal_literal] = ACTIONS(2169),
    [sym__hex_literal] = ACTIONS(2169),
    [sym_implicit_variable] = ACTIONS(3429),
    [sym_name] = ACTIONS(3431),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2173),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1588] = {
    [sym__type_parens] = STATE(6323),
    [sym__type_tuple] = STATE(6324),
    [sym__type_unboxed_tuple] = STATE(6325),
    [sym__type_unboxed_sum] = STATE(6326),
    [sym__type_list] = STATE(6327),
    [sym__type_promoted] = STATE(6321),
    [sym__type_star] = STATE(6321),
    [sym__type_wildcard] = STATE(6321),
    [sym__type_apply] = STATE(6328),
    [sym__type_infix] = STATE(6329),
    [sym_type] = STATE(754),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10134),
    [sym__qtype_forall] = STATE(8674),
    [sym__qtype_forall_required] = STATE(8673),
    [sym_strict_field] = STATE(8650),
    [sym_lazy_field] = STATE(8650),
    [sym__qtype_function] = STATE(8647),
    [sym__qtype_linear_function] = STATE(8671),
    [sym__qtype_context] = STATE(8665),
    [sym_quantified_type] = STATE(8227),
    [sym_implicit_parameter] = STATE(8661),
    [sym__context_inline] = STATE(1567),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11328),
    [sym__splice_dollars] = STATE(7407),
    [sym_splice] = STATE(6321),
    [sym_quasiquote] = STATE(6321),
    [sym_integer] = STATE(6269),
    [sym__plist] = STATE(6330),
    [sym_unit] = STATE(6321),
    [sym_unboxed_unit] = STATE(6321),
    [sym_prefix_tuple] = STATE(6321),
    [sym_prefix_unboxed_tuple] = STATE(6321),
    [sym_prefix_unboxed_sum] = STATE(6321),
    [sym_literal] = STATE(6321),
    [sym__qualified_type] = STATE(6286),
    [sym__qtyconid] = STATE(6331),
    [sym__tycon_arrow] = STATE(6331),
    [sym__qtycon_arrow] = STATE(6331),
    [sym__promoted_tycons_alias] = STATE(6321),
    [sym__promoted_tycons] = STATE(6321),
    [sym__varsym_prefix] = STATE(6331),
    [sym__pvarsym] = STATE(6331),
    [sym__qvarsym_prefix] = STATE(6331),
    [sym__pqvarsym] = STATE(6331),
    [sym__consym_prefix] = STATE(6331),
    [sym__pconsym] = STATE(6331),
    [sym__qconsym_prefix] = STATE(6331),
    [sym__pqconsym] = STATE(6331),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(469),
    [sym__bracket_open] = STATE(990),
    [sym__unboxed_open] = STATE(810),
    [sym_variable] = ACTIONS(2155),
    [anon_sym__] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_u2605] = ACTIONS(2163),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2165),
    [sym_char] = ACTIONS(2165),
    [sym_string] = ACTIONS(2165),
    [sym__integer_literal] = ACTIONS(2167),
    [sym__binary_literal] = ACTIONS(2169),
    [sym__octal_literal] = ACTIONS(2169),
    [sym__hex_literal] = ACTIONS(2169),
    [sym_implicit_variable] = ACTIONS(3429),
    [sym_name] = ACTIONS(3431),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2173),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1589] = {
    [sym__type_parens] = STATE(6323),
    [sym__type_tuple] = STATE(6324),
    [sym__type_unboxed_tuple] = STATE(6325),
    [sym__type_unboxed_sum] = STATE(6326),
    [sym__type_list] = STATE(6327),
    [sym__type_promoted] = STATE(6321),
    [sym__type_star] = STATE(6321),
    [sym__type_wildcard] = STATE(6321),
    [sym__type_apply] = STATE(6328),
    [sym__type_infix] = STATE(6329),
    [sym_type] = STATE(754),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10134),
    [sym__qtype_forall] = STATE(8674),
    [sym__qtype_forall_required] = STATE(8673),
    [sym_strict_field] = STATE(8650),
    [sym_lazy_field] = STATE(8650),
    [sym__qtype_function] = STATE(8647),
    [sym__qtype_linear_function] = STATE(8671),
    [sym__qtype_context] = STATE(8665),
    [sym_quantified_type] = STATE(8229),
    [sym_implicit_parameter] = STATE(8661),
    [sym__context_inline] = STATE(1567),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11328),
    [sym__splice_dollars] = STATE(7407),
    [sym_splice] = STATE(6321),
    [sym_quasiquote] = STATE(6321),
    [sym_integer] = STATE(6269),
    [sym__plist] = STATE(6330),
    [sym_unit] = STATE(6321),
    [sym_unboxed_unit] = STATE(6321),
    [sym_prefix_tuple] = STATE(6321),
    [sym_prefix_unboxed_tuple] = STATE(6321),
    [sym_prefix_unboxed_sum] = STATE(6321),
    [sym_literal] = STATE(6321),
    [sym__qualified_type] = STATE(6286),
    [sym__qtyconid] = STATE(6331),
    [sym__tycon_arrow] = STATE(6331),
    [sym__qtycon_arrow] = STATE(6331),
    [sym__promoted_tycons_alias] = STATE(6321),
    [sym__promoted_tycons] = STATE(6321),
    [sym__varsym_prefix] = STATE(6331),
    [sym__pvarsym] = STATE(6331),
    [sym__qvarsym_prefix] = STATE(6331),
    [sym__pqvarsym] = STATE(6331),
    [sym__consym_prefix] = STATE(6331),
    [sym__pconsym] = STATE(6331),
    [sym__qconsym_prefix] = STATE(6331),
    [sym__pqconsym] = STATE(6331),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(469),
    [sym__bracket_open] = STATE(990),
    [sym__unboxed_open] = STATE(810),
    [sym_variable] = ACTIONS(2155),
    [anon_sym__] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_u2605] = ACTIONS(2163),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2165),
    [sym_char] = ACTIONS(2165),
    [sym_string] = ACTIONS(2165),
    [sym__integer_literal] = ACTIONS(2167),
    [sym__binary_literal] = ACTIONS(2169),
    [sym__octal_literal] = ACTIONS(2169),
    [sym__hex_literal] = ACTIONS(2169),
    [sym_implicit_variable] = ACTIONS(3429),
    [sym_name] = ACTIONS(3431),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2173),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1590] = {
    [sym__type_parens] = STATE(6323),
    [sym__type_tuple] = STATE(6324),
    [sym__type_unboxed_tuple] = STATE(6325),
    [sym__type_unboxed_sum] = STATE(6326),
    [sym__type_list] = STATE(6327),
    [sym__type_promoted] = STATE(6321),
    [sym__type_star] = STATE(6321),
    [sym__type_wildcard] = STATE(6321),
    [sym__type_apply] = STATE(6328),
    [sym__type_infix] = STATE(6329),
    [sym_type] = STATE(754),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10134),
    [sym__qtype_forall] = STATE(8674),
    [sym__qtype_forall_required] = STATE(8673),
    [sym_strict_field] = STATE(8650),
    [sym_lazy_field] = STATE(8650),
    [sym__qtype_function] = STATE(8647),
    [sym__qtype_linear_function] = STATE(8671),
    [sym__qtype_context] = STATE(8665),
    [sym_quantified_type] = STATE(8231),
    [sym_implicit_parameter] = STATE(8661),
    [sym__context_inline] = STATE(1567),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11328),
    [sym__splice_dollars] = STATE(7407),
    [sym_splice] = STATE(6321),
    [sym_quasiquote] = STATE(6321),
    [sym_integer] = STATE(6269),
    [sym__plist] = STATE(6330),
    [sym_unit] = STATE(6321),
    [sym_unboxed_unit] = STATE(6321),
    [sym_prefix_tuple] = STATE(6321),
    [sym_prefix_unboxed_tuple] = STATE(6321),
    [sym_prefix_unboxed_sum] = STATE(6321),
    [sym_literal] = STATE(6321),
    [sym__qualified_type] = STATE(6286),
    [sym__qtyconid] = STATE(6331),
    [sym__tycon_arrow] = STATE(6331),
    [sym__qtycon_arrow] = STATE(6331),
    [sym__promoted_tycons_alias] = STATE(6321),
    [sym__promoted_tycons] = STATE(6321),
    [sym__varsym_prefix] = STATE(6331),
    [sym__pvarsym] = STATE(6331),
    [sym__qvarsym_prefix] = STATE(6331),
    [sym__pqvarsym] = STATE(6331),
    [sym__consym_prefix] = STATE(6331),
    [sym__pconsym] = STATE(6331),
    [sym__qconsym_prefix] = STATE(6331),
    [sym__pqconsym] = STATE(6331),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(469),
    [sym__bracket_open] = STATE(990),
    [sym__unboxed_open] = STATE(810),
    [sym_variable] = ACTIONS(2155),
    [anon_sym__] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_u2605] = ACTIONS(2163),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2165),
    [sym_char] = ACTIONS(2165),
    [sym_string] = ACTIONS(2165),
    [sym__integer_literal] = ACTIONS(2167),
    [sym__binary_literal] = ACTIONS(2169),
    [sym__octal_literal] = ACTIONS(2169),
    [sym__hex_literal] = ACTIONS(2169),
    [sym_implicit_variable] = ACTIONS(3429),
    [sym_name] = ACTIONS(3431),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2173),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1591] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8311),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1592] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(51),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1593] = {
    [sym__type_parens] = STATE(6323),
    [sym__type_tuple] = STATE(6324),
    [sym__type_unboxed_tuple] = STATE(6325),
    [sym__type_unboxed_sum] = STATE(6326),
    [sym__type_list] = STATE(6327),
    [sym__type_promoted] = STATE(6321),
    [sym__type_star] = STATE(6321),
    [sym__type_wildcard] = STATE(6321),
    [sym__type_apply] = STATE(6328),
    [sym__type_infix] = STATE(6329),
    [sym_type] = STATE(754),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10134),
    [sym__qtype_forall] = STATE(8674),
    [sym__qtype_forall_required] = STATE(8673),
    [sym_strict_field] = STATE(8650),
    [sym_lazy_field] = STATE(8650),
    [sym__qtype_function] = STATE(8647),
    [sym__qtype_linear_function] = STATE(8671),
    [sym__qtype_context] = STATE(8665),
    [sym_quantified_type] = STATE(8236),
    [sym_implicit_parameter] = STATE(8661),
    [sym__context_inline] = STATE(1567),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11328),
    [sym__splice_dollars] = STATE(7407),
    [sym_splice] = STATE(6321),
    [sym_quasiquote] = STATE(6321),
    [sym_integer] = STATE(6269),
    [sym__plist] = STATE(6330),
    [sym_unit] = STATE(6321),
    [sym_unboxed_unit] = STATE(6321),
    [sym_prefix_tuple] = STATE(6321),
    [sym_prefix_unboxed_tuple] = STATE(6321),
    [sym_prefix_unboxed_sum] = STATE(6321),
    [sym_literal] = STATE(6321),
    [sym__qualified_type] = STATE(6286),
    [sym__qtyconid] = STATE(6331),
    [sym__tycon_arrow] = STATE(6331),
    [sym__qtycon_arrow] = STATE(6331),
    [sym__promoted_tycons_alias] = STATE(6321),
    [sym__promoted_tycons] = STATE(6321),
    [sym__varsym_prefix] = STATE(6331),
    [sym__pvarsym] = STATE(6331),
    [sym__qvarsym_prefix] = STATE(6331),
    [sym__pqvarsym] = STATE(6331),
    [sym__consym_prefix] = STATE(6331),
    [sym__pconsym] = STATE(6331),
    [sym__qconsym_prefix] = STATE(6331),
    [sym__pqconsym] = STATE(6331),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(469),
    [sym__bracket_open] = STATE(990),
    [sym__unboxed_open] = STATE(810),
    [sym_variable] = ACTIONS(2155),
    [anon_sym__] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_u2605] = ACTIONS(2163),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2165),
    [sym_char] = ACTIONS(2165),
    [sym_string] = ACTIONS(2165),
    [sym__integer_literal] = ACTIONS(2167),
    [sym__binary_literal] = ACTIONS(2169),
    [sym__octal_literal] = ACTIONS(2169),
    [sym__hex_literal] = ACTIONS(2169),
    [sym_implicit_variable] = ACTIONS(3429),
    [sym_name] = ACTIONS(3431),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2173),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1594] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8346),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1595] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8308),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1596] = {
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(163),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__paren_open] = STATE(406),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1597] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8350),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1598] = {
    [sym__type_parens] = STATE(5938),
    [sym__type_tuple] = STATE(5929),
    [sym__type_unboxed_tuple] = STATE(5928),
    [sym__type_unboxed_sum] = STATE(5927),
    [sym__type_list] = STATE(5923),
    [sym__type_promoted] = STATE(5958),
    [sym__type_star] = STATE(5958),
    [sym__type_wildcard] = STATE(5958),
    [sym__type_apply] = STATE(5917),
    [sym__type_infix] = STATE(5912),
    [sym_type] = STATE(657),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10206),
    [sym__qtype_forall] = STATE(8513),
    [sym__qtype_forall_required] = STATE(8526),
    [sym_strict_field] = STATE(8613),
    [sym_lazy_field] = STATE(8613),
    [sym__qtype_function] = STATE(8527),
    [sym__qtype_linear_function] = STATE(8528),
    [sym__qtype_context] = STATE(8530),
    [sym_quantified_type] = STATE(8108),
    [sym_implicit_parameter] = STATE(8537),
    [sym__context_inline] = STATE(1598),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11083),
    [sym__splice_dollars] = STATE(7467),
    [sym_splice] = STATE(5958),
    [sym_quasiquote] = STATE(5958),
    [sym_integer] = STATE(6013),
    [sym__plist] = STATE(5900),
    [sym_unit] = STATE(5958),
    [sym_unboxed_unit] = STATE(5958),
    [sym_prefix_tuple] = STATE(5958),
    [sym_prefix_unboxed_tuple] = STATE(5958),
    [sym_prefix_unboxed_sum] = STATE(5958),
    [sym_literal] = STATE(5958),
    [sym__qualified_type] = STATE(5983),
    [sym__qtyconid] = STATE(5894),
    [sym__tycon_arrow] = STATE(5894),
    [sym__qtycon_arrow] = STATE(5894),
    [sym__promoted_tycons_alias] = STATE(5958),
    [sym__promoted_tycons] = STATE(5958),
    [sym__varsym_prefix] = STATE(5894),
    [sym__pvarsym] = STATE(5894),
    [sym__qvarsym_prefix] = STATE(5894),
    [sym__pqvarsym] = STATE(5894),
    [sym__consym_prefix] = STATE(5894),
    [sym__pconsym] = STATE(5894),
    [sym__qconsym_prefix] = STATE(5894),
    [sym__pqconsym] = STATE(5894),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(460),
    [sym__bracket_open] = STATE(1045),
    [sym__unboxed_open] = STATE(826),
    [sym_variable] = ACTIONS(1887),
    [anon_sym__] = ACTIONS(1889),
    [anon_sym_SQUOTE] = ACTIONS(3299),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_u2605] = ACTIONS(1895),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1897),
    [sym_char] = ACTIONS(1897),
    [sym_string] = ACTIONS(1897),
    [sym__integer_literal] = ACTIONS(1899),
    [sym__binary_literal] = ACTIONS(1901),
    [sym__octal_literal] = ACTIONS(1901),
    [sym__hex_literal] = ACTIONS(1901),
    [sym_implicit_variable] = ACTIONS(3301),
    [sym_name] = ACTIONS(3303),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1905),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1599] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8329),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1600] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8343),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1601] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(266),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__paren_open] = STATE(404),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1602] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(278),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__paren_open] = STATE(404),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1603] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(287),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__paren_open] = STATE(404),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1604] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(281),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__paren_open] = STATE(404),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1605] = {
    [sym__type_parens] = STATE(6909),
    [sym__type_tuple] = STATE(6883),
    [sym__type_unboxed_tuple] = STATE(6903),
    [sym__type_unboxed_sum] = STATE(6892),
    [sym__type_list] = STATE(6891),
    [sym__type_promoted] = STATE(6911),
    [sym__type_star] = STATE(6911),
    [sym__type_wildcard] = STATE(6911),
    [sym__type_apply] = STATE(6890),
    [sym__type_infix] = STATE(6959),
    [sym_type] = STATE(881),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10230),
    [sym__qtype_forall] = STATE(8887),
    [sym__qtype_forall_required] = STATE(8873),
    [sym_strict_field] = STATE(8624),
    [sym_lazy_field] = STATE(8624),
    [sym__qtype_function] = STATE(8861),
    [sym__qtype_linear_function] = STATE(8867),
    [sym__qtype_context] = STATE(8904),
    [sym_quantified_type] = STATE(8372),
    [sym_implicit_parameter] = STATE(8868),
    [sym__context_inline] = STATE(1605),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11277),
    [sym__splice_dollars] = STATE(7211),
    [sym_splice] = STATE(6911),
    [sym_quasiquote] = STATE(6911),
    [sym_integer] = STATE(6928),
    [sym__plist] = STATE(6889),
    [sym_unit] = STATE(6911),
    [sym_unboxed_unit] = STATE(6911),
    [sym_prefix_tuple] = STATE(6911),
    [sym_prefix_unboxed_tuple] = STATE(6911),
    [sym_prefix_unboxed_sum] = STATE(6911),
    [sym_literal] = STATE(6911),
    [sym__qualified_type] = STATE(6933),
    [sym__qtyconid] = STATE(6884),
    [sym__tycon_arrow] = STATE(6884),
    [sym__qtycon_arrow] = STATE(6884),
    [sym__promoted_tycons_alias] = STATE(6911),
    [sym__promoted_tycons] = STATE(6911),
    [sym__varsym_prefix] = STATE(6884),
    [sym__pvarsym] = STATE(6884),
    [sym__qvarsym_prefix] = STATE(6884),
    [sym__pqvarsym] = STATE(6884),
    [sym__consym_prefix] = STATE(6884),
    [sym__pconsym] = STATE(6884),
    [sym__qconsym_prefix] = STATE(6884),
    [sym__pqconsym] = STATE(6884),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(430),
    [sym__bracket_open] = STATE(1017),
    [sym__unboxed_open] = STATE(737),
    [sym_variable] = ACTIONS(2673),
    [anon_sym__] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(3339),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_u2605] = ACTIONS(2681),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2683),
    [sym_char] = ACTIONS(2683),
    [sym_string] = ACTIONS(2683),
    [sym__integer_literal] = ACTIONS(2685),
    [sym__binary_literal] = ACTIONS(2687),
    [sym__octal_literal] = ACTIONS(2687),
    [sym__hex_literal] = ACTIONS(2687),
    [sym_implicit_variable] = ACTIONS(3341),
    [sym_name] = ACTIONS(3343),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2691),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1606] = {
    [sym__type_parens] = STATE(5938),
    [sym__type_tuple] = STATE(5929),
    [sym__type_unboxed_tuple] = STATE(5928),
    [sym__type_unboxed_sum] = STATE(5927),
    [sym__type_list] = STATE(5923),
    [sym__type_promoted] = STATE(5958),
    [sym__type_star] = STATE(5958),
    [sym__type_wildcard] = STATE(5958),
    [sym__type_apply] = STATE(5917),
    [sym__type_infix] = STATE(5912),
    [sym_type] = STATE(657),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10206),
    [sym__qtype_forall] = STATE(8513),
    [sym__qtype_forall_required] = STATE(8526),
    [sym_strict_field] = STATE(8613),
    [sym_lazy_field] = STATE(8613),
    [sym__qtype_function] = STATE(8527),
    [sym__qtype_linear_function] = STATE(8528),
    [sym__qtype_context] = STATE(8530),
    [sym_quantified_type] = STATE(8094),
    [sym_implicit_parameter] = STATE(8537),
    [sym__context_inline] = STATE(1598),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11083),
    [sym__splice_dollars] = STATE(7467),
    [sym_splice] = STATE(5958),
    [sym_quasiquote] = STATE(5958),
    [sym_integer] = STATE(6013),
    [sym__plist] = STATE(5900),
    [sym_unit] = STATE(5958),
    [sym_unboxed_unit] = STATE(5958),
    [sym_prefix_tuple] = STATE(5958),
    [sym_prefix_unboxed_tuple] = STATE(5958),
    [sym_prefix_unboxed_sum] = STATE(5958),
    [sym_literal] = STATE(5958),
    [sym__qualified_type] = STATE(5983),
    [sym__qtyconid] = STATE(5894),
    [sym__tycon_arrow] = STATE(5894),
    [sym__qtycon_arrow] = STATE(5894),
    [sym__promoted_tycons_alias] = STATE(5958),
    [sym__promoted_tycons] = STATE(5958),
    [sym__varsym_prefix] = STATE(5894),
    [sym__pvarsym] = STATE(5894),
    [sym__qvarsym_prefix] = STATE(5894),
    [sym__pqvarsym] = STATE(5894),
    [sym__consym_prefix] = STATE(5894),
    [sym__pconsym] = STATE(5894),
    [sym__qconsym_prefix] = STATE(5894),
    [sym__pqconsym] = STATE(5894),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(460),
    [sym__bracket_open] = STATE(1045),
    [sym__unboxed_open] = STATE(826),
    [sym_variable] = ACTIONS(1887),
    [anon_sym__] = ACTIONS(1889),
    [anon_sym_SQUOTE] = ACTIONS(3299),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_u2605] = ACTIONS(1895),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1897),
    [sym_char] = ACTIONS(1897),
    [sym_string] = ACTIONS(1897),
    [sym__integer_literal] = ACTIONS(1899),
    [sym__binary_literal] = ACTIONS(1901),
    [sym__octal_literal] = ACTIONS(1901),
    [sym__hex_literal] = ACTIONS(1901),
    [sym_implicit_variable] = ACTIONS(3301),
    [sym_name] = ACTIONS(3303),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1905),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1607] = {
    [sym__type_parens] = STATE(6323),
    [sym__type_tuple] = STATE(6324),
    [sym__type_unboxed_tuple] = STATE(6325),
    [sym__type_unboxed_sum] = STATE(6326),
    [sym__type_list] = STATE(6327),
    [sym__type_promoted] = STATE(6321),
    [sym__type_star] = STATE(6321),
    [sym__type_wildcard] = STATE(6321),
    [sym__type_apply] = STATE(6328),
    [sym__type_infix] = STATE(6329),
    [sym_type] = STATE(754),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10134),
    [sym__qtype_forall] = STATE(8674),
    [sym__qtype_forall_required] = STATE(8673),
    [sym_strict_field] = STATE(8650),
    [sym_lazy_field] = STATE(8650),
    [sym__qtype_function] = STATE(8647),
    [sym__qtype_linear_function] = STATE(8671),
    [sym__qtype_context] = STATE(8665),
    [sym_quantified_type] = STATE(8183),
    [sym_implicit_parameter] = STATE(8661),
    [sym__context_inline] = STATE(1567),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11328),
    [sym__splice_dollars] = STATE(7407),
    [sym_splice] = STATE(6321),
    [sym_quasiquote] = STATE(6321),
    [sym_integer] = STATE(6269),
    [sym__plist] = STATE(6330),
    [sym_unit] = STATE(6321),
    [sym_unboxed_unit] = STATE(6321),
    [sym_prefix_tuple] = STATE(6321),
    [sym_prefix_unboxed_tuple] = STATE(6321),
    [sym_prefix_unboxed_sum] = STATE(6321),
    [sym_literal] = STATE(6321),
    [sym__qualified_type] = STATE(6286),
    [sym__qtyconid] = STATE(6331),
    [sym__tycon_arrow] = STATE(6331),
    [sym__qtycon_arrow] = STATE(6331),
    [sym__promoted_tycons_alias] = STATE(6321),
    [sym__promoted_tycons] = STATE(6321),
    [sym__varsym_prefix] = STATE(6331),
    [sym__pvarsym] = STATE(6331),
    [sym__qvarsym_prefix] = STATE(6331),
    [sym__pqvarsym] = STATE(6331),
    [sym__consym_prefix] = STATE(6331),
    [sym__pconsym] = STATE(6331),
    [sym__qconsym_prefix] = STATE(6331),
    [sym__pqconsym] = STATE(6331),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(469),
    [sym__bracket_open] = STATE(990),
    [sym__unboxed_open] = STATE(810),
    [sym_variable] = ACTIONS(2155),
    [anon_sym__] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_u2605] = ACTIONS(2163),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2165),
    [sym_char] = ACTIONS(2165),
    [sym_string] = ACTIONS(2165),
    [sym__integer_literal] = ACTIONS(2167),
    [sym__binary_literal] = ACTIONS(2169),
    [sym__octal_literal] = ACTIONS(2169),
    [sym__hex_literal] = ACTIONS(2169),
    [sym_implicit_variable] = ACTIONS(3429),
    [sym_name] = ACTIONS(3431),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2173),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1608] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8337),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = ACTIONS(1989),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1609] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(315),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1610] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(316),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1611] = {
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(302),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__paren_open] = STATE(405),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1612] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8097),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1613] = {
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(313),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__paren_open] = STATE(405),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1614] = {
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(136),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__paren_open] = STATE(406),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1615] = {
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(311),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__paren_open] = STATE(405),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1616] = {
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(310),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__paren_open] = STATE(405),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1617] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__assoc_tyinst] = STATE(10389),
    [sym__assoc_datainst_adt] = STATE(10386),
    [sym__assoc_datainst_newtype] = STATE(10381),
    [sym__assoc_datainst] = STATE(10379),
    [sym_instance_decl] = STATE(10756),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10379),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_newtype] = ACTIONS(2911),
    [anon_sym_data] = ACTIONS(2913),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1618] = {
    [sym__exp_th_quoted_name] = STATE(4176),
    [sym__exp_parens] = STATE(4173),
    [sym__exp_tuple] = STATE(4163),
    [sym__exp_unboxed_tuple] = STATE(4161),
    [sym__exp_unboxed_sum] = STATE(4160),
    [sym__exp_list] = STATE(4154),
    [sym__exp_arithmetic_sequence] = STATE(4152),
    [sym__exp_list_comprehension] = STATE(4149),
    [sym__exp_lambda] = STATE(4141),
    [sym__exp_let_in] = STATE(4137),
    [sym__exp_conditional] = STATE(4136),
    [sym__do_keyword] = STATE(10943),
    [sym_do_module] = STATE(10943),
    [sym__do] = STATE(10943),
    [sym__exp_do] = STATE(4135),
    [sym__exp_case] = STATE(4134),
    [sym__exp_lambda_case] = STATE(4130),
    [sym__exp_lambda_cases] = STATE(4129),
    [sym__exp_multi_way_if] = STATE(4126),
    [sym__exp_record] = STATE(4117),
    [sym__exp_projection_selector] = STATE(4113),
    [sym__exp_projection] = STATE(4110),
    [sym__exp_apply] = STATE(4109),
    [sym__exp_section_left] = STATE(4105),
    [sym__exp_section_right] = STATE(4102),
    [sym__exp_negation] = STATE(4100),
    [sym__exp_infix] = STATE(4072),
    [sym_expression] = STATE(171),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9477),
    [sym__splice_dollars] = STATE(7323),
    [sym_splice] = STATE(4181),
    [sym_quasiquote] = STATE(4181),
    [sym__exp_quote] = STATE(4069),
    [sym__exp_typed_quote] = STATE(4181),
    [sym_integer] = STATE(3781),
    [sym__plist] = STATE(4051),
    [sym_unit] = STATE(4181),
    [sym_unboxed_unit] = STATE(4181),
    [sym_prefix_tuple] = STATE(4181),
    [sym_prefix_unboxed_tuple] = STATE(4181),
    [sym_prefix_unboxed_sum] = STATE(4181),
    [sym_literal] = STATE(4181),
    [sym__qualified_variable] = STATE(3696),
    [sym__qvarid] = STATE(4181),
    [sym__qvar] = STATE(4181),
    [sym__qualified_constructor] = STATE(3697),
    [sym__qconid] = STATE(4181),
    [sym__varsym_prefix] = STATE(4181),
    [sym__pvarsym] = STATE(4181),
    [sym__qvarsym_prefix] = STATE(4181),
    [sym__pqvarsym] = STATE(4181),
    [sym__consym_prefix] = STATE(4052),
    [sym__pconsym] = STATE(4052),
    [sym__qconsym_prefix] = STATE(4181),
    [sym__pqconsym] = STATE(4181),
    [sym__paren_open] = STATE(406),
    [sym__bracket_open] = STATE(1052),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(543),
    [anon_sym_SQUOTE] = ACTIONS(547),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(549),
    [anon_sym_BSLASH] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_mdo] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_case] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(561),
    [sym_float] = ACTIONS(563),
    [sym_char] = ACTIONS(563),
    [sym_string] = ACTIONS(563),
    [sym__integer_literal] = ACTIONS(565),
    [sym__binary_literal] = ACTIONS(567),
    [sym__octal_literal] = ACTIONS(567),
    [sym__hex_literal] = ACTIONS(567),
    [sym_implicit_variable] = ACTIONS(569),
    [sym_name] = ACTIONS(571),
    [sym_label] = ACTIONS(569),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(575),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1619] = {
    [sym__type_parens] = STATE(6282),
    [sym__type_tuple] = STATE(6281),
    [sym__type_unboxed_tuple] = STATE(6280),
    [sym__type_unboxed_sum] = STATE(6279),
    [sym__type_list] = STATE(6278),
    [sym__type_promoted] = STATE(6283),
    [sym__type_star] = STATE(6283),
    [sym__type_wildcard] = STATE(6283),
    [sym__type_apply] = STATE(6277),
    [sym__type_infix] = STATE(6276),
    [sym_type] = STATE(822),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10113),
    [sym__qtype_forall] = STATE(8644),
    [sym__qtype_forall_required] = STATE(8640),
    [sym_strict_field] = STATE(8714),
    [sym_lazy_field] = STATE(8714),
    [sym__qtype_function] = STATE(8638),
    [sym__qtype_linear_function] = STATE(8635),
    [sym__qtype_context] = STATE(8633),
    [sym_quantified_type] = STATE(8238),
    [sym_implicit_parameter] = STATE(8632),
    [sym__context_inline] = STATE(1693),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11228),
    [sym__splice_dollars] = STATE(7421),
    [sym_splice] = STATE(6283),
    [sym_quasiquote] = STATE(6283),
    [sym_integer] = STATE(6535),
    [sym__plist] = STATE(6275),
    [sym_unit] = STATE(6283),
    [sym_unboxed_unit] = STATE(6283),
    [sym_prefix_tuple] = STATE(6283),
    [sym_prefix_unboxed_tuple] = STATE(6283),
    [sym_prefix_unboxed_sum] = STATE(6283),
    [sym_literal] = STATE(6283),
    [sym__qualified_type] = STATE(6310),
    [sym__qtyconid] = STATE(6273),
    [sym__tycon_arrow] = STATE(6273),
    [sym__qtycon_arrow] = STATE(6273),
    [sym__promoted_tycons_alias] = STATE(6283),
    [sym__promoted_tycons] = STATE(6283),
    [sym__varsym_prefix] = STATE(6273),
    [sym__pvarsym] = STATE(6273),
    [sym__qvarsym_prefix] = STATE(6273),
    [sym__pqvarsym] = STATE(6273),
    [sym__consym_prefix] = STATE(6273),
    [sym__pconsym] = STATE(6273),
    [sym__qconsym_prefix] = STATE(6273),
    [sym__pqconsym] = STATE(6273),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(429),
    [sym__bracket_open] = STATE(1061),
    [sym__unboxed_open] = STATE(755),
    [sym_variable] = ACTIONS(2305),
    [anon_sym__] = ACTIONS(2307),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(2313),
    [anon_sym_u2605] = ACTIONS(2313),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym__integer_literal] = ACTIONS(2317),
    [sym__binary_literal] = ACTIONS(2319),
    [sym__octal_literal] = ACTIONS(2319),
    [sym__hex_literal] = ACTIONS(2319),
    [sym_implicit_variable] = ACTIONS(3447),
    [sym_name] = ACTIONS(3449),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2323),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1620] = {
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(234),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__paren_open] = STATE(416),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1621] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(276),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__paren_open] = STATE(404),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1622] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(221),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(3630),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(3451),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(1203),
    [sym__binary_literal] = ACTIONS(1205),
    [sym__octal_literal] = ACTIONS(1205),
    [sym__hex_literal] = ACTIONS(1205),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1623] = {
    [sym__type_parens] = STATE(3379),
    [sym__type_tuple] = STATE(3377),
    [sym__type_unboxed_tuple] = STATE(3370),
    [sym__type_unboxed_sum] = STATE(3369),
    [sym__type_list] = STATE(3361),
    [sym__type_promoted] = STATE(3383),
    [sym__type_star] = STATE(3383),
    [sym__type_wildcard] = STATE(3383),
    [sym__type_apply] = STATE(3359),
    [sym__type_infix] = STATE(3358),
    [sym_type] = STATE(486),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10095),
    [sym__qtype_forall] = STATE(3757),
    [sym__qtype_forall_required] = STATE(3758),
    [sym_strict_field] = STATE(8706),
    [sym_lazy_field] = STATE(8706),
    [sym__qtype_function] = STATE(3762),
    [sym__qtype_linear_function] = STATE(3767),
    [sym__qtype_context] = STATE(3768),
    [sym_quantified_type] = STATE(2783),
    [sym_implicit_parameter] = STATE(3788),
    [sym__context_inline] = STATE(1749),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11178),
    [sym__splice_dollars] = STATE(7460),
    [sym_splice] = STATE(3383),
    [sym_quasiquote] = STATE(3383),
    [sym_integer] = STATE(3269),
    [sym__plist] = STATE(3357),
    [sym_unit] = STATE(3383),
    [sym_unboxed_unit] = STATE(3383),
    [sym_prefix_tuple] = STATE(3383),
    [sym_prefix_unboxed_tuple] = STATE(3383),
    [sym_prefix_unboxed_sum] = STATE(3383),
    [sym_literal] = STATE(3383),
    [sym__qualified_type] = STATE(3410),
    [sym__qtyconid] = STATE(3354),
    [sym__tycon_arrow] = STATE(3354),
    [sym__qtycon_arrow] = STATE(3354),
    [sym__promoted_tycons_alias] = STATE(3383),
    [sym__promoted_tycons] = STATE(3383),
    [sym__varsym_prefix] = STATE(3354),
    [sym__pvarsym] = STATE(3354),
    [sym__qvarsym_prefix] = STATE(3354),
    [sym__pqvarsym] = STATE(3354),
    [sym__consym_prefix] = STATE(3354),
    [sym__pconsym] = STATE(3354),
    [sym__qconsym_prefix] = STATE(3354),
    [sym__pqconsym] = STATE(3354),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(464),
    [sym__bracket_open] = STATE(1079),
    [sym__unboxed_open] = STATE(805),
    [sym_variable] = ACTIONS(1609),
    [anon_sym__] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_u2605] = ACTIONS(1617),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1619),
    [sym_char] = ACTIONS(1619),
    [sym_string] = ACTIONS(1619),
    [sym__integer_literal] = ACTIONS(1621),
    [sym__binary_literal] = ACTIONS(1623),
    [sym__octal_literal] = ACTIONS(1623),
    [sym__hex_literal] = ACTIONS(1623),
    [sym_implicit_variable] = ACTIONS(3385),
    [sym_name] = ACTIONS(3387),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1627),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1624] = {
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(291),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(3520),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__paren_open] = STATE(405),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(3453),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(379),
    [sym__binary_literal] = ACTIONS(381),
    [sym__octal_literal] = ACTIONS(381),
    [sym__hex_literal] = ACTIONS(381),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1625] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8198),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = ACTIONS(1989),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1626] = {
    [sym__type_parens] = STATE(3379),
    [sym__type_tuple] = STATE(3377),
    [sym__type_unboxed_tuple] = STATE(3370),
    [sym__type_unboxed_sum] = STATE(3369),
    [sym__type_list] = STATE(3361),
    [sym__type_promoted] = STATE(3383),
    [sym__type_star] = STATE(3383),
    [sym__type_wildcard] = STATE(3383),
    [sym__type_apply] = STATE(3359),
    [sym__type_infix] = STATE(3358),
    [sym_type] = STATE(486),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10095),
    [sym__qtype_forall] = STATE(3757),
    [sym__qtype_forall_required] = STATE(3758),
    [sym_strict_field] = STATE(8706),
    [sym_lazy_field] = STATE(8706),
    [sym__qtype_function] = STATE(3762),
    [sym__qtype_linear_function] = STATE(3767),
    [sym__qtype_context] = STATE(3768),
    [sym_quantified_type] = STATE(2782),
    [sym_implicit_parameter] = STATE(3788),
    [sym__context_inline] = STATE(1749),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11178),
    [sym__splice_dollars] = STATE(7460),
    [sym_splice] = STATE(3383),
    [sym_quasiquote] = STATE(3383),
    [sym_integer] = STATE(3269),
    [sym__plist] = STATE(3357),
    [sym_unit] = STATE(3383),
    [sym_unboxed_unit] = STATE(3383),
    [sym_prefix_tuple] = STATE(3383),
    [sym_prefix_unboxed_tuple] = STATE(3383),
    [sym_prefix_unboxed_sum] = STATE(3383),
    [sym_literal] = STATE(3383),
    [sym__qualified_type] = STATE(3410),
    [sym__qtyconid] = STATE(3354),
    [sym__tycon_arrow] = STATE(3354),
    [sym__qtycon_arrow] = STATE(3354),
    [sym__promoted_tycons_alias] = STATE(3383),
    [sym__promoted_tycons] = STATE(3383),
    [sym__varsym_prefix] = STATE(3354),
    [sym__pvarsym] = STATE(3354),
    [sym__qvarsym_prefix] = STATE(3354),
    [sym__pqvarsym] = STATE(3354),
    [sym__consym_prefix] = STATE(3354),
    [sym__pconsym] = STATE(3354),
    [sym__qconsym_prefix] = STATE(3354),
    [sym__pqconsym] = STATE(3354),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(464),
    [sym__bracket_open] = STATE(1079),
    [sym__unboxed_open] = STATE(805),
    [sym_variable] = ACTIONS(1609),
    [anon_sym__] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_u2605] = ACTIONS(1617),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1619),
    [sym_char] = ACTIONS(1619),
    [sym_string] = ACTIONS(1619),
    [sym__integer_literal] = ACTIONS(1621),
    [sym__binary_literal] = ACTIONS(1623),
    [sym__octal_literal] = ACTIONS(1623),
    [sym__hex_literal] = ACTIONS(1623),
    [sym_implicit_variable] = ACTIONS(3385),
    [sym_name] = ACTIONS(3387),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1627),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1627] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8196),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = ACTIONS(1989),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1628] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8174),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = ACTIONS(1989),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1629] = {
    [sym__type_parens] = STATE(7755),
    [sym__type_tuple] = STATE(7759),
    [sym__type_unboxed_tuple] = STATE(7760),
    [sym__type_unboxed_sum] = STATE(7761),
    [sym__type_list] = STATE(7763),
    [sym__type_promoted] = STATE(7754),
    [sym__type_star] = STATE(7754),
    [sym__type_wildcard] = STATE(7754),
    [sym__at_type] = STATE(7784),
    [sym__type_apply] = STATE(7764),
    [sym__type_infix] = STATE(7765),
    [sym_type] = STATE(1426),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8486),
    [sym__splice_dollars] = STATE(7310),
    [sym_splice] = STATE(7754),
    [sym_quasiquote] = STATE(7754),
    [sym_integer] = STATE(7762),
    [sym__plist] = STATE(7766),
    [sym_unit] = STATE(7754),
    [sym_unboxed_unit] = STATE(7754),
    [sym_prefix_tuple] = STATE(7754),
    [sym_prefix_unboxed_tuple] = STATE(7754),
    [sym_prefix_unboxed_sum] = STATE(7754),
    [sym_literal] = STATE(7754),
    [sym__qualified_type] = STATE(7738),
    [sym__qtyconid] = STATE(7767),
    [sym__tycon_arrow] = STATE(7767),
    [sym__qtycon_arrow] = STATE(7767),
    [sym__promoted_tycons_alias] = STATE(7754),
    [sym__promoted_tycons] = STATE(7754),
    [sym__tycon_ticked] = STATE(2687),
    [sym__qtycon_ticked] = STATE(2687),
    [sym__tyconids_ticked] = STATE(2687),
    [sym__promoted_tyconops_alias] = STATE(2687),
    [sym__promoted_tyconops] = STATE(2687),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2687),
    [sym__operator_alias] = STATE(2687),
    [sym__operator_minus] = STATE(2687),
    [sym__varsym_prefix] = STATE(7767),
    [sym__pvarsym] = STATE(7767),
    [sym__qualified_varsym] = STATE(2686),
    [sym__qvarsym_prefix] = STATE(7767),
    [sym__pqvarsym] = STATE(7767),
    [sym_constructor_operator] = STATE(2687),
    [sym__constructor_operator_alias] = STATE(2687),
    [sym__consym_prefix] = STATE(7767),
    [sym__pconsym] = STATE(7767),
    [sym__qualified_consym] = STATE(2679),
    [sym__qconsym_prefix] = STATE(7767),
    [sym__pqconsym] = STATE(7767),
    [sym__prefix_at] = STATE(2547),
    [sym__paren_open] = STATE(457),
    [sym__bracket_open] = STATE(995),
    [sym__unboxed_open] = STATE(813),
    [sym_variable] = ACTIONS(3363),
    [anon_sym__] = ACTIONS(3365),
    [anon_sym_SQUOTE] = ACTIONS(3367),
    [anon_sym_STAR] = ACTIONS(3369),
    [anon_sym_u2605] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_DASH_GT] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3373),
    [sym_char] = ACTIONS(3373),
    [sym_string] = ACTIONS(3373),
    [sym__integer_literal] = ACTIONS(3375),
    [sym__binary_literal] = ACTIONS(3377),
    [sym__octal_literal] = ACTIONS(3377),
    [sym__hex_literal] = ACTIONS(3377),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(3379),
    [anon_sym_u2192] = ACTIONS(1181),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3381),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1630] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8176),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = ACTIONS(1989),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1631] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10122),
    [sym__qtype_forall] = STATE(9396),
    [sym__qtype_forall_required] = STATE(9395),
    [sym_strict_field] = STATE(8608),
    [sym_lazy_field] = STATE(8608),
    [sym__qtype_function] = STATE(9390),
    [sym__qtype_linear_function] = STATE(9389),
    [sym__qtype_context] = STATE(9386),
    [sym_quantified_type] = STATE(8582),
    [sym_implicit_parameter] = STATE(9379),
    [sym__context_inline] = STATE(1631),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(3355),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1632] = {
    [sym__type_parens] = STATE(6784),
    [sym__type_tuple] = STATE(6785),
    [sym__type_unboxed_tuple] = STATE(6786),
    [sym__type_unboxed_sum] = STATE(6787),
    [sym__type_list] = STATE(6789),
    [sym__type_promoted] = STATE(6781),
    [sym__type_star] = STATE(6781),
    [sym__type_wildcard] = STATE(6781),
    [sym__type_apply] = STATE(6790),
    [sym__type_infix] = STATE(6791),
    [sym_type] = STATE(854),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10099),
    [sym__qtype_forall] = STATE(8826),
    [sym__qtype_forall_required] = STATE(8777),
    [sym_strict_field] = STATE(8709),
    [sym_lazy_field] = STATE(8709),
    [sym__qtype_function] = STATE(8779),
    [sym__qtype_linear_function] = STATE(8838),
    [sym__qtype_context] = STATE(8791),
    [sym_quantified_type] = STATE(8323),
    [sym_implicit_parameter] = STATE(8794),
    [sym__context_inline] = STATE(1751),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11189),
    [sym__splice_dollars] = STATE(7457),
    [sym_splice] = STATE(6781),
    [sym_quasiquote] = STATE(6781),
    [sym_integer] = STATE(6710),
    [sym__plist] = STATE(6792),
    [sym_unit] = STATE(6781),
    [sym_unboxed_unit] = STATE(6781),
    [sym_prefix_tuple] = STATE(6781),
    [sym_prefix_unboxed_tuple] = STATE(6781),
    [sym_prefix_unboxed_sum] = STATE(6781),
    [sym_literal] = STATE(6781),
    [sym__qualified_type] = STATE(6756),
    [sym__qtyconid] = STATE(6793),
    [sym__tycon_arrow] = STATE(6793),
    [sym__qtycon_arrow] = STATE(6793),
    [sym__promoted_tycons_alias] = STATE(6781),
    [sym__promoted_tycons] = STATE(6781),
    [sym__varsym_prefix] = STATE(6793),
    [sym__pvarsym] = STATE(6793),
    [sym__qvarsym_prefix] = STATE(6793),
    [sym__pqvarsym] = STATE(6793),
    [sym__consym_prefix] = STATE(6793),
    [sym__pconsym] = STATE(6793),
    [sym__qconsym_prefix] = STATE(6793),
    [sym__pqconsym] = STATE(6793),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(472),
    [sym__bracket_open] = STATE(1078),
    [sym__unboxed_open] = STATE(789),
    [sym_variable] = ACTIONS(2607),
    [anon_sym__] = ACTIONS(2609),
    [anon_sym_SQUOTE] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_u2605] = ACTIONS(2615),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2617),
    [sym_char] = ACTIONS(2617),
    [sym_string] = ACTIONS(2617),
    [sym__integer_literal] = ACTIONS(2619),
    [sym__binary_literal] = ACTIONS(2621),
    [sym__octal_literal] = ACTIONS(2621),
    [sym__hex_literal] = ACTIONS(2621),
    [sym_implicit_variable] = ACTIONS(3457),
    [sym_name] = ACTIONS(3459),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2625),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1633] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8177),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = ACTIONS(1989),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1634] = {
    [sym__type_parens] = STATE(6323),
    [sym__type_tuple] = STATE(6324),
    [sym__type_unboxed_tuple] = STATE(6325),
    [sym__type_unboxed_sum] = STATE(6326),
    [sym__type_list] = STATE(6327),
    [sym__type_promoted] = STATE(6321),
    [sym__type_star] = STATE(6321),
    [sym__type_wildcard] = STATE(6321),
    [sym__type_apply] = STATE(6328),
    [sym__type_infix] = STATE(6329),
    [sym_type] = STATE(754),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10134),
    [sym__qtype_forall] = STATE(8674),
    [sym__qtype_forall_required] = STATE(8673),
    [sym_strict_field] = STATE(8650),
    [sym_lazy_field] = STATE(8650),
    [sym__qtype_function] = STATE(8647),
    [sym__qtype_linear_function] = STATE(8671),
    [sym__qtype_context] = STATE(8665),
    [sym_quantified_type] = STATE(8171),
    [sym_implicit_parameter] = STATE(8661),
    [sym__context_inline] = STATE(1567),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11328),
    [sym__splice_dollars] = STATE(7407),
    [sym_splice] = STATE(6321),
    [sym_quasiquote] = STATE(6321),
    [sym_integer] = STATE(6269),
    [sym__plist] = STATE(6330),
    [sym_unit] = STATE(6321),
    [sym_unboxed_unit] = STATE(6321),
    [sym_prefix_tuple] = STATE(6321),
    [sym_prefix_unboxed_tuple] = STATE(6321),
    [sym_prefix_unboxed_sum] = STATE(6321),
    [sym_literal] = STATE(6321),
    [sym__qualified_type] = STATE(6286),
    [sym__qtyconid] = STATE(6331),
    [sym__tycon_arrow] = STATE(6331),
    [sym__qtycon_arrow] = STATE(6331),
    [sym__promoted_tycons_alias] = STATE(6321),
    [sym__promoted_tycons] = STATE(6321),
    [sym__varsym_prefix] = STATE(6331),
    [sym__pvarsym] = STATE(6331),
    [sym__qvarsym_prefix] = STATE(6331),
    [sym__pqvarsym] = STATE(6331),
    [sym__consym_prefix] = STATE(6331),
    [sym__pconsym] = STATE(6331),
    [sym__qconsym_prefix] = STATE(6331),
    [sym__pqconsym] = STATE(6331),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(469),
    [sym__bracket_open] = STATE(990),
    [sym__unboxed_open] = STATE(810),
    [sym_variable] = ACTIONS(2155),
    [anon_sym__] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_u2605] = ACTIONS(2163),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2165),
    [sym_char] = ACTIONS(2165),
    [sym_string] = ACTIONS(2165),
    [sym__integer_literal] = ACTIONS(2167),
    [sym__binary_literal] = ACTIONS(2169),
    [sym__octal_literal] = ACTIONS(2169),
    [sym__hex_literal] = ACTIONS(2169),
    [sym_implicit_variable] = ACTIONS(3429),
    [sym_name] = ACTIONS(3431),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2173),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1635] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10122),
    [sym__qtype_forall] = STATE(9396),
    [sym__qtype_forall_required] = STATE(9395),
    [sym_strict_field] = STATE(8608),
    [sym_lazy_field] = STATE(8608),
    [sym__qtype_function] = STATE(9390),
    [sym__qtype_linear_function] = STATE(9389),
    [sym__qtype_context] = STATE(9386),
    [sym_quantified_type] = STATE(8587),
    [sym_implicit_parameter] = STATE(9379),
    [sym__context_inline] = STATE(1631),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(3355),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1636] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10122),
    [sym__qtype_forall] = STATE(9396),
    [sym__qtype_forall_required] = STATE(9395),
    [sym_strict_field] = STATE(8608),
    [sym_lazy_field] = STATE(8608),
    [sym__qtype_function] = STATE(9390),
    [sym__qtype_linear_function] = STATE(9389),
    [sym__qtype_context] = STATE(9386),
    [sym_quantified_type] = STATE(8589),
    [sym_implicit_parameter] = STATE(9379),
    [sym__context_inline] = STATE(1631),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(3355),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1637] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10122),
    [sym__qtype_forall] = STATE(9396),
    [sym__qtype_forall_required] = STATE(9395),
    [sym_strict_field] = STATE(8608),
    [sym_lazy_field] = STATE(8608),
    [sym__qtype_function] = STATE(9390),
    [sym__qtype_linear_function] = STATE(9389),
    [sym__qtype_context] = STATE(9386),
    [sym_quantified_type] = STATE(8591),
    [sym_implicit_parameter] = STATE(9379),
    [sym__context_inline] = STATE(1631),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(3355),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1638] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10122),
    [sym__qtype_forall] = STATE(9396),
    [sym__qtype_forall_required] = STATE(9395),
    [sym_strict_field] = STATE(8608),
    [sym_lazy_field] = STATE(8608),
    [sym__qtype_function] = STATE(9390),
    [sym__qtype_linear_function] = STATE(9389),
    [sym__qtype_context] = STATE(9386),
    [sym_quantified_type] = STATE(8562),
    [sym_implicit_parameter] = STATE(9379),
    [sym__context_inline] = STATE(1631),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(3355),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1639] = {
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(341),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__paren_open] = STATE(400),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1640] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8521),
    [sym_lazy_field] = STATE(8521),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8521),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1641] = {
    [sym__type_parens] = STATE(3557),
    [sym__type_tuple] = STATE(3612),
    [sym__type_unboxed_tuple] = STATE(3607),
    [sym__type_unboxed_sum] = STATE(3606),
    [sym__type_list] = STATE(3605),
    [sym__type_promoted] = STATE(3638),
    [sym__type_star] = STATE(3638),
    [sym__type_wildcard] = STATE(3638),
    [sym__type_apply] = STATE(3604),
    [sym__type_infix] = STATE(3602),
    [sym_type] = STATE(508),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10082),
    [sym__qtype_forall] = STATE(3832),
    [sym__qtype_forall_required] = STATE(3829),
    [sym_strict_field] = STATE(8659),
    [sym_lazy_field] = STATE(8659),
    [sym__qtype_function] = STATE(3824),
    [sym__qtype_linear_function] = STATE(3823),
    [sym__qtype_context] = STATE(3821),
    [sym_quantified_type] = STATE(2930),
    [sym_implicit_parameter] = STATE(3838),
    [sym__context_inline] = STATE(1658),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11140),
    [sym__splice_dollars] = STATE(7350),
    [sym_splice] = STATE(3638),
    [sym_quasiquote] = STATE(3638),
    [sym_integer] = STATE(3509),
    [sym__plist] = STATE(3597),
    [sym_unit] = STATE(3638),
    [sym_unboxed_unit] = STATE(3638),
    [sym_prefix_tuple] = STATE(3638),
    [sym_prefix_unboxed_tuple] = STATE(3638),
    [sym_prefix_unboxed_sum] = STATE(3638),
    [sym_literal] = STATE(3638),
    [sym__qualified_type] = STATE(3643),
    [sym__qtyconid] = STATE(3583),
    [sym__tycon_arrow] = STATE(3583),
    [sym__qtycon_arrow] = STATE(3583),
    [sym__promoted_tycons_alias] = STATE(3638),
    [sym__promoted_tycons] = STATE(3638),
    [sym__varsym_prefix] = STATE(3583),
    [sym__pvarsym] = STATE(3583),
    [sym__qvarsym_prefix] = STATE(3583),
    [sym__pqvarsym] = STATE(3583),
    [sym__consym_prefix] = STATE(3583),
    [sym__pconsym] = STATE(3583),
    [sym__qconsym_prefix] = STATE(3583),
    [sym__pqconsym] = STATE(3583),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(461),
    [sym__bracket_open] = STATE(1131),
    [sym__unboxed_open] = STATE(829),
    [sym_variable] = ACTIONS(1669),
    [anon_sym__] = ACTIONS(1671),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(1677),
    [anon_sym_u2605] = ACTIONS(1677),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1679),
    [sym_char] = ACTIONS(1679),
    [sym_string] = ACTIONS(1679),
    [sym__integer_literal] = ACTIONS(1681),
    [sym__binary_literal] = ACTIONS(1683),
    [sym__octal_literal] = ACTIONS(1683),
    [sym__hex_literal] = ACTIONS(1683),
    [sym_implicit_variable] = ACTIONS(3421),
    [sym_name] = ACTIONS(3423),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1642] = {
    [sym__type_parens] = STATE(3557),
    [sym__type_tuple] = STATE(3612),
    [sym__type_unboxed_tuple] = STATE(3607),
    [sym__type_unboxed_sum] = STATE(3606),
    [sym__type_list] = STATE(3605),
    [sym__type_promoted] = STATE(3638),
    [sym__type_star] = STATE(3638),
    [sym__type_wildcard] = STATE(3638),
    [sym__type_apply] = STATE(3604),
    [sym__type_infix] = STATE(3602),
    [sym_type] = STATE(508),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10082),
    [sym__qtype_forall] = STATE(3832),
    [sym__qtype_forall_required] = STATE(3829),
    [sym_strict_field] = STATE(8659),
    [sym_lazy_field] = STATE(8659),
    [sym__qtype_function] = STATE(3824),
    [sym__qtype_linear_function] = STATE(3823),
    [sym__qtype_context] = STATE(3821),
    [sym_quantified_type] = STATE(2939),
    [sym_implicit_parameter] = STATE(3838),
    [sym__context_inline] = STATE(1658),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11140),
    [sym__splice_dollars] = STATE(7350),
    [sym_splice] = STATE(3638),
    [sym_quasiquote] = STATE(3638),
    [sym_integer] = STATE(3509),
    [sym__plist] = STATE(3597),
    [sym_unit] = STATE(3638),
    [sym_unboxed_unit] = STATE(3638),
    [sym_prefix_tuple] = STATE(3638),
    [sym_prefix_unboxed_tuple] = STATE(3638),
    [sym_prefix_unboxed_sum] = STATE(3638),
    [sym_literal] = STATE(3638),
    [sym__qualified_type] = STATE(3643),
    [sym__qtyconid] = STATE(3583),
    [sym__tycon_arrow] = STATE(3583),
    [sym__qtycon_arrow] = STATE(3583),
    [sym__promoted_tycons_alias] = STATE(3638),
    [sym__promoted_tycons] = STATE(3638),
    [sym__varsym_prefix] = STATE(3583),
    [sym__pvarsym] = STATE(3583),
    [sym__qvarsym_prefix] = STATE(3583),
    [sym__pqvarsym] = STATE(3583),
    [sym__consym_prefix] = STATE(3583),
    [sym__pconsym] = STATE(3583),
    [sym__qconsym_prefix] = STATE(3583),
    [sym__pqconsym] = STATE(3583),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(461),
    [sym__bracket_open] = STATE(1131),
    [sym__unboxed_open] = STATE(829),
    [sym_variable] = ACTIONS(1669),
    [anon_sym__] = ACTIONS(1671),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(1677),
    [anon_sym_u2605] = ACTIONS(1677),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1679),
    [sym_char] = ACTIONS(1679),
    [sym_string] = ACTIONS(1679),
    [sym__integer_literal] = ACTIONS(1681),
    [sym__binary_literal] = ACTIONS(1683),
    [sym__octal_literal] = ACTIONS(1683),
    [sym__hex_literal] = ACTIONS(1683),
    [sym_implicit_variable] = ACTIONS(3421),
    [sym_name] = ACTIONS(3423),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1643] = {
    [sym__type_parens] = STATE(3557),
    [sym__type_tuple] = STATE(3612),
    [sym__type_unboxed_tuple] = STATE(3607),
    [sym__type_unboxed_sum] = STATE(3606),
    [sym__type_list] = STATE(3605),
    [sym__type_promoted] = STATE(3638),
    [sym__type_star] = STATE(3638),
    [sym__type_wildcard] = STATE(3638),
    [sym__type_apply] = STATE(3604),
    [sym__type_infix] = STATE(3602),
    [sym_type] = STATE(508),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10082),
    [sym__qtype_forall] = STATE(3832),
    [sym__qtype_forall_required] = STATE(3829),
    [sym_strict_field] = STATE(8659),
    [sym_lazy_field] = STATE(8659),
    [sym__qtype_function] = STATE(3824),
    [sym__qtype_linear_function] = STATE(3823),
    [sym__qtype_context] = STATE(3821),
    [sym_quantified_type] = STATE(2940),
    [sym_implicit_parameter] = STATE(3838),
    [sym__context_inline] = STATE(1658),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11140),
    [sym__splice_dollars] = STATE(7350),
    [sym_splice] = STATE(3638),
    [sym_quasiquote] = STATE(3638),
    [sym_integer] = STATE(3509),
    [sym__plist] = STATE(3597),
    [sym_unit] = STATE(3638),
    [sym_unboxed_unit] = STATE(3638),
    [sym_prefix_tuple] = STATE(3638),
    [sym_prefix_unboxed_tuple] = STATE(3638),
    [sym_prefix_unboxed_sum] = STATE(3638),
    [sym_literal] = STATE(3638),
    [sym__qualified_type] = STATE(3643),
    [sym__qtyconid] = STATE(3583),
    [sym__tycon_arrow] = STATE(3583),
    [sym__qtycon_arrow] = STATE(3583),
    [sym__promoted_tycons_alias] = STATE(3638),
    [sym__promoted_tycons] = STATE(3638),
    [sym__varsym_prefix] = STATE(3583),
    [sym__pvarsym] = STATE(3583),
    [sym__qvarsym_prefix] = STATE(3583),
    [sym__pqvarsym] = STATE(3583),
    [sym__consym_prefix] = STATE(3583),
    [sym__pconsym] = STATE(3583),
    [sym__qconsym_prefix] = STATE(3583),
    [sym__pqconsym] = STATE(3583),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(461),
    [sym__bracket_open] = STATE(1131),
    [sym__unboxed_open] = STATE(829),
    [sym_variable] = ACTIONS(1669),
    [anon_sym__] = ACTIONS(1671),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(1677),
    [anon_sym_u2605] = ACTIONS(1677),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1679),
    [sym_char] = ACTIONS(1679),
    [sym_string] = ACTIONS(1679),
    [sym__integer_literal] = ACTIONS(1681),
    [sym__binary_literal] = ACTIONS(1683),
    [sym__octal_literal] = ACTIONS(1683),
    [sym__hex_literal] = ACTIONS(1683),
    [sym_implicit_variable] = ACTIONS(3421),
    [sym_name] = ACTIONS(3423),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1644] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(55),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(3451),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(3291),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(237),
    [sym__binary_literal] = ACTIONS(239),
    [sym__octal_literal] = ACTIONS(239),
    [sym__hex_literal] = ACTIONS(239),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1645] = {
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(340),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__paren_open] = STATE(400),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1646] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10122),
    [sym__qtype_forall] = STATE(9396),
    [sym__qtype_forall_required] = STATE(9395),
    [sym_strict_field] = STATE(8608),
    [sym_lazy_field] = STATE(8608),
    [sym__qtype_function] = STATE(9390),
    [sym__qtype_linear_function] = STATE(9389),
    [sym__qtype_context] = STATE(9386),
    [sym_quantified_type] = STATE(8607),
    [sym_implicit_parameter] = STATE(9379),
    [sym__context_inline] = STATE(1631),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(3355),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1647] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10122),
    [sym__qtype_forall] = STATE(9396),
    [sym__qtype_forall_required] = STATE(9395),
    [sym_strict_field] = STATE(8608),
    [sym_lazy_field] = STATE(8608),
    [sym__qtype_function] = STATE(9390),
    [sym__qtype_linear_function] = STATE(9389),
    [sym__qtype_context] = STATE(9386),
    [sym_quantified_type] = STATE(8573),
    [sym_implicit_parameter] = STATE(9379),
    [sym__context_inline] = STATE(1631),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(3355),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1648] = {
    [sym__type_parens] = STATE(3557),
    [sym__type_tuple] = STATE(3612),
    [sym__type_unboxed_tuple] = STATE(3607),
    [sym__type_unboxed_sum] = STATE(3606),
    [sym__type_list] = STATE(3605),
    [sym__type_promoted] = STATE(3638),
    [sym__type_star] = STATE(3638),
    [sym__type_wildcard] = STATE(3638),
    [sym__type_apply] = STATE(3604),
    [sym__type_infix] = STATE(3602),
    [sym_type] = STATE(508),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10082),
    [sym__qtype_forall] = STATE(3832),
    [sym__qtype_forall_required] = STATE(3829),
    [sym_strict_field] = STATE(8659),
    [sym_lazy_field] = STATE(8659),
    [sym__qtype_function] = STATE(3824),
    [sym__qtype_linear_function] = STATE(3823),
    [sym__qtype_context] = STATE(3821),
    [sym_quantified_type] = STATE(2947),
    [sym_implicit_parameter] = STATE(3838),
    [sym__context_inline] = STATE(1658),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11140),
    [sym__splice_dollars] = STATE(7350),
    [sym_splice] = STATE(3638),
    [sym_quasiquote] = STATE(3638),
    [sym_integer] = STATE(3509),
    [sym__plist] = STATE(3597),
    [sym_unit] = STATE(3638),
    [sym_unboxed_unit] = STATE(3638),
    [sym_prefix_tuple] = STATE(3638),
    [sym_prefix_unboxed_tuple] = STATE(3638),
    [sym_prefix_unboxed_sum] = STATE(3638),
    [sym_literal] = STATE(3638),
    [sym__qualified_type] = STATE(3643),
    [sym__qtyconid] = STATE(3583),
    [sym__tycon_arrow] = STATE(3583),
    [sym__qtycon_arrow] = STATE(3583),
    [sym__promoted_tycons_alias] = STATE(3638),
    [sym__promoted_tycons] = STATE(3638),
    [sym__varsym_prefix] = STATE(3583),
    [sym__pvarsym] = STATE(3583),
    [sym__qvarsym_prefix] = STATE(3583),
    [sym__pqvarsym] = STATE(3583),
    [sym__consym_prefix] = STATE(3583),
    [sym__pconsym] = STATE(3583),
    [sym__qconsym_prefix] = STATE(3583),
    [sym__pqconsym] = STATE(3583),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(461),
    [sym__bracket_open] = STATE(1131),
    [sym__unboxed_open] = STATE(829),
    [sym_variable] = ACTIONS(1669),
    [anon_sym__] = ACTIONS(1671),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(1677),
    [anon_sym_u2605] = ACTIONS(1677),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1679),
    [sym_char] = ACTIONS(1679),
    [sym_string] = ACTIONS(1679),
    [sym__integer_literal] = ACTIONS(1681),
    [sym__binary_literal] = ACTIONS(1683),
    [sym__octal_literal] = ACTIONS(1683),
    [sym__hex_literal] = ACTIONS(1683),
    [sym_implicit_variable] = ACTIONS(3421),
    [sym_name] = ACTIONS(3423),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1649] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(54),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1650] = {
    [sym__type_parens] = STATE(3557),
    [sym__type_tuple] = STATE(3612),
    [sym__type_unboxed_tuple] = STATE(3607),
    [sym__type_unboxed_sum] = STATE(3606),
    [sym__type_list] = STATE(3605),
    [sym__type_promoted] = STATE(3638),
    [sym__type_star] = STATE(3638),
    [sym__type_wildcard] = STATE(3638),
    [sym__type_apply] = STATE(3604),
    [sym__type_infix] = STATE(3602),
    [sym_type] = STATE(508),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10082),
    [sym__qtype_forall] = STATE(3832),
    [sym__qtype_forall_required] = STATE(3829),
    [sym_strict_field] = STATE(8659),
    [sym_lazy_field] = STATE(8659),
    [sym__qtype_function] = STATE(3824),
    [sym__qtype_linear_function] = STATE(3823),
    [sym__qtype_context] = STATE(3821),
    [sym_quantified_type] = STATE(2949),
    [sym_implicit_parameter] = STATE(3838),
    [sym__context_inline] = STATE(1658),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11140),
    [sym__splice_dollars] = STATE(7350),
    [sym_splice] = STATE(3638),
    [sym_quasiquote] = STATE(3638),
    [sym_integer] = STATE(3509),
    [sym__plist] = STATE(3597),
    [sym_unit] = STATE(3638),
    [sym_unboxed_unit] = STATE(3638),
    [sym_prefix_tuple] = STATE(3638),
    [sym_prefix_unboxed_tuple] = STATE(3638),
    [sym_prefix_unboxed_sum] = STATE(3638),
    [sym_literal] = STATE(3638),
    [sym__qualified_type] = STATE(3643),
    [sym__qtyconid] = STATE(3583),
    [sym__tycon_arrow] = STATE(3583),
    [sym__qtycon_arrow] = STATE(3583),
    [sym__promoted_tycons_alias] = STATE(3638),
    [sym__promoted_tycons] = STATE(3638),
    [sym__varsym_prefix] = STATE(3583),
    [sym__pvarsym] = STATE(3583),
    [sym__qvarsym_prefix] = STATE(3583),
    [sym__pqvarsym] = STATE(3583),
    [sym__consym_prefix] = STATE(3583),
    [sym__pconsym] = STATE(3583),
    [sym__qconsym_prefix] = STATE(3583),
    [sym__pqconsym] = STATE(3583),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(461),
    [sym__bracket_open] = STATE(1131),
    [sym__unboxed_open] = STATE(829),
    [sym_variable] = ACTIONS(1669),
    [anon_sym__] = ACTIONS(1671),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(1677),
    [anon_sym_u2605] = ACTIONS(1677),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1679),
    [sym_char] = ACTIONS(1679),
    [sym_string] = ACTIONS(1679),
    [sym__integer_literal] = ACTIONS(1681),
    [sym__binary_literal] = ACTIONS(1683),
    [sym__octal_literal] = ACTIONS(1683),
    [sym__hex_literal] = ACTIONS(1683),
    [sym_implicit_variable] = ACTIONS(3421),
    [sym_name] = ACTIONS(3423),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1651] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8178),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = ACTIONS(1989),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1652] = {
    [sym__type_parens] = STATE(3557),
    [sym__type_tuple] = STATE(3612),
    [sym__type_unboxed_tuple] = STATE(3607),
    [sym__type_unboxed_sum] = STATE(3606),
    [sym__type_list] = STATE(3605),
    [sym__type_promoted] = STATE(3638),
    [sym__type_star] = STATE(3638),
    [sym__type_wildcard] = STATE(3638),
    [sym__type_apply] = STATE(3604),
    [sym__type_infix] = STATE(3602),
    [sym_type] = STATE(508),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10082),
    [sym__qtype_forall] = STATE(3832),
    [sym__qtype_forall_required] = STATE(3829),
    [sym_strict_field] = STATE(8659),
    [sym_lazy_field] = STATE(8659),
    [sym__qtype_function] = STATE(3824),
    [sym__qtype_linear_function] = STATE(3823),
    [sym__qtype_context] = STATE(3821),
    [sym_quantified_type] = STATE(2955),
    [sym_implicit_parameter] = STATE(3838),
    [sym__context_inline] = STATE(1658),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11140),
    [sym__splice_dollars] = STATE(7350),
    [sym_splice] = STATE(3638),
    [sym_quasiquote] = STATE(3638),
    [sym_integer] = STATE(3509),
    [sym__plist] = STATE(3597),
    [sym_unit] = STATE(3638),
    [sym_unboxed_unit] = STATE(3638),
    [sym_prefix_tuple] = STATE(3638),
    [sym_prefix_unboxed_tuple] = STATE(3638),
    [sym_prefix_unboxed_sum] = STATE(3638),
    [sym_literal] = STATE(3638),
    [sym__qualified_type] = STATE(3643),
    [sym__qtyconid] = STATE(3583),
    [sym__tycon_arrow] = STATE(3583),
    [sym__qtycon_arrow] = STATE(3583),
    [sym__promoted_tycons_alias] = STATE(3638),
    [sym__promoted_tycons] = STATE(3638),
    [sym__varsym_prefix] = STATE(3583),
    [sym__pvarsym] = STATE(3583),
    [sym__qvarsym_prefix] = STATE(3583),
    [sym__pqvarsym] = STATE(3583),
    [sym__consym_prefix] = STATE(3583),
    [sym__pconsym] = STATE(3583),
    [sym__qconsym_prefix] = STATE(3583),
    [sym__pqconsym] = STATE(3583),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(461),
    [sym__bracket_open] = STATE(1131),
    [sym__unboxed_open] = STATE(829),
    [sym_variable] = ACTIONS(1669),
    [anon_sym__] = ACTIONS(1671),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(1677),
    [anon_sym_u2605] = ACTIONS(1677),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1679),
    [sym_char] = ACTIONS(1679),
    [sym_string] = ACTIONS(1679),
    [sym__integer_literal] = ACTIONS(1681),
    [sym__binary_literal] = ACTIONS(1683),
    [sym__octal_literal] = ACTIONS(1683),
    [sym__hex_literal] = ACTIONS(1683),
    [sym_implicit_variable] = ACTIONS(3421),
    [sym_name] = ACTIONS(3423),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1653] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8339),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1654] = {
    [sym__type_parens] = STATE(3557),
    [sym__type_tuple] = STATE(3612),
    [sym__type_unboxed_tuple] = STATE(3607),
    [sym__type_unboxed_sum] = STATE(3606),
    [sym__type_list] = STATE(3605),
    [sym__type_promoted] = STATE(3638),
    [sym__type_star] = STATE(3638),
    [sym__type_wildcard] = STATE(3638),
    [sym__type_apply] = STATE(3604),
    [sym__type_infix] = STATE(3602),
    [sym_type] = STATE(508),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10082),
    [sym__qtype_forall] = STATE(3832),
    [sym__qtype_forall_required] = STATE(3829),
    [sym_strict_field] = STATE(8659),
    [sym_lazy_field] = STATE(8659),
    [sym__qtype_function] = STATE(3824),
    [sym__qtype_linear_function] = STATE(3823),
    [sym__qtype_context] = STATE(3821),
    [sym_quantified_type] = STATE(2958),
    [sym_implicit_parameter] = STATE(3838),
    [sym__context_inline] = STATE(1658),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11140),
    [sym__splice_dollars] = STATE(7350),
    [sym_splice] = STATE(3638),
    [sym_quasiquote] = STATE(3638),
    [sym_integer] = STATE(3509),
    [sym__plist] = STATE(3597),
    [sym_unit] = STATE(3638),
    [sym_unboxed_unit] = STATE(3638),
    [sym_prefix_tuple] = STATE(3638),
    [sym_prefix_unboxed_tuple] = STATE(3638),
    [sym_prefix_unboxed_sum] = STATE(3638),
    [sym_literal] = STATE(3638),
    [sym__qualified_type] = STATE(3643),
    [sym__qtyconid] = STATE(3583),
    [sym__tycon_arrow] = STATE(3583),
    [sym__qtycon_arrow] = STATE(3583),
    [sym__promoted_tycons_alias] = STATE(3638),
    [sym__promoted_tycons] = STATE(3638),
    [sym__varsym_prefix] = STATE(3583),
    [sym__pvarsym] = STATE(3583),
    [sym__qvarsym_prefix] = STATE(3583),
    [sym__pqvarsym] = STATE(3583),
    [sym__consym_prefix] = STATE(3583),
    [sym__pconsym] = STATE(3583),
    [sym__qconsym_prefix] = STATE(3583),
    [sym__pqconsym] = STATE(3583),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(461),
    [sym__bracket_open] = STATE(1131),
    [sym__unboxed_open] = STATE(829),
    [sym_variable] = ACTIONS(1669),
    [anon_sym__] = ACTIONS(1671),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(1677),
    [anon_sym_u2605] = ACTIONS(1677),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1679),
    [sym_char] = ACTIONS(1679),
    [sym_string] = ACTIONS(1679),
    [sym__integer_literal] = ACTIONS(1681),
    [sym__binary_literal] = ACTIONS(1683),
    [sym__octal_literal] = ACTIONS(1683),
    [sym__hex_literal] = ACTIONS(1683),
    [sym_implicit_variable] = ACTIONS(3421),
    [sym_name] = ACTIONS(3423),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1655] = {
    [sym__type_parens] = STATE(5999),
    [sym__type_tuple] = STATE(6002),
    [sym__type_unboxed_tuple] = STATE(6004),
    [sym__type_unboxed_sum] = STATE(6006),
    [sym__type_list] = STATE(6007),
    [sym__type_promoted] = STATE(5993),
    [sym__type_star] = STATE(5993),
    [sym__type_wildcard] = STATE(5993),
    [sym__type_apply] = STATE(6008),
    [sym__type_infix] = STATE(6009),
    [sym_type] = STATE(666),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10156),
    [sym__qtype_forall] = STATE(8532),
    [sym__qtype_forall_required] = STATE(8520),
    [sym_strict_field] = STATE(8634),
    [sym_lazy_field] = STATE(8634),
    [sym__qtype_function] = STATE(8519),
    [sym__qtype_linear_function] = STATE(8514),
    [sym__qtype_context] = STATE(8511),
    [sym_quantified_type] = STATE(8127),
    [sym_implicit_parameter] = STATE(8502),
    [sym__context_inline] = STATE(1491),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11325),
    [sym__splice_dollars] = STATE(7346),
    [sym_splice] = STATE(5993),
    [sym_quasiquote] = STATE(5993),
    [sym_integer] = STATE(5925),
    [sym__plist] = STATE(6010),
    [sym_unit] = STATE(5993),
    [sym_unboxed_unit] = STATE(5993),
    [sym_prefix_tuple] = STATE(5993),
    [sym_prefix_unboxed_tuple] = STATE(5993),
    [sym_prefix_unboxed_sum] = STATE(5993),
    [sym_literal] = STATE(5993),
    [sym__qualified_type] = STATE(5906),
    [sym__qtyconid] = STATE(6014),
    [sym__tycon_arrow] = STATE(6014),
    [sym__qtycon_arrow] = STATE(6014),
    [sym__promoted_tycons_alias] = STATE(5993),
    [sym__promoted_tycons] = STATE(5993),
    [sym__varsym_prefix] = STATE(6014),
    [sym__pvarsym] = STATE(6014),
    [sym__qvarsym_prefix] = STATE(6014),
    [sym__pqvarsym] = STATE(6014),
    [sym__consym_prefix] = STATE(6014),
    [sym__pconsym] = STATE(6014),
    [sym__qconsym_prefix] = STATE(6014),
    [sym__pqconsym] = STATE(6014),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(468),
    [sym__bracket_open] = STATE(986),
    [sym__unboxed_open] = STATE(795),
    [sym_variable] = ACTIONS(1867),
    [anon_sym__] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(1875),
    [anon_sym_u2605] = ACTIONS(1875),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1877),
    [sym_char] = ACTIONS(1877),
    [sym_string] = ACTIONS(1877),
    [sym__integer_literal] = ACTIONS(1879),
    [sym__binary_literal] = ACTIONS(1881),
    [sym__octal_literal] = ACTIONS(1881),
    [sym__hex_literal] = ACTIONS(1881),
    [sym_implicit_variable] = ACTIONS(3351),
    [sym_name] = ACTIONS(3353),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1885),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1656] = {
    [sym__type_parens] = STATE(2825),
    [sym__type_tuple] = STATE(2808),
    [sym__type_unboxed_tuple] = STATE(2788),
    [sym__type_unboxed_sum] = STATE(2767),
    [sym__type_list] = STATE(2839),
    [sym__type_promoted] = STATE(2796),
    [sym__type_star] = STATE(2796),
    [sym__type_wildcard] = STATE(2796),
    [sym__type_apply] = STATE(2823),
    [sym__type_infix] = STATE(2774),
    [sym_type] = STATE(421),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10083),
    [sym__qtype_forall] = STATE(3138),
    [sym__qtype_forall_required] = STATE(3136),
    [sym_strict_field] = STATE(8681),
    [sym_lazy_field] = STATE(8681),
    [sym__qtype_function] = STATE(3135),
    [sym__qtype_linear_function] = STATE(3132),
    [sym__qtype_context] = STATE(3131),
    [sym_quantified_type] = STATE(2370),
    [sym_implicit_parameter] = STATE(3115),
    [sym__context_inline] = STATE(1721),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11145),
    [sym__splice_dollars] = STATE(7328),
    [sym_splice] = STATE(2796),
    [sym_quasiquote] = STATE(2796),
    [sym_integer] = STATE(2781),
    [sym__plist] = STATE(2777),
    [sym_unit] = STATE(2796),
    [sym_unboxed_unit] = STATE(2796),
    [sym_prefix_tuple] = STATE(2796),
    [sym_prefix_unboxed_tuple] = STATE(2796),
    [sym_prefix_unboxed_sum] = STATE(2796),
    [sym_literal] = STATE(2796),
    [sym__qualified_type] = STATE(2759),
    [sym__qtyconid] = STATE(2752),
    [sym__tycon_arrow] = STATE(2752),
    [sym__qtycon_arrow] = STATE(2752),
    [sym__promoted_tycons_alias] = STATE(2796),
    [sym__promoted_tycons] = STATE(2796),
    [sym__varsym_prefix] = STATE(2752),
    [sym__pvarsym] = STATE(2752),
    [sym__qvarsym_prefix] = STATE(2752),
    [sym__pqvarsym] = STATE(2752),
    [sym__consym_prefix] = STATE(2752),
    [sym__pconsym] = STATE(2752),
    [sym__qconsym_prefix] = STATE(2752),
    [sym__pqconsym] = STATE(2752),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(467),
    [sym__bracket_open] = STATE(1130),
    [sym__unboxed_open] = STATE(765),
    [sym_variable] = ACTIONS(1323),
    [anon_sym__] = ACTIONS(1325),
    [anon_sym_SQUOTE] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_u2605] = ACTIONS(1331),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1333),
    [sym_char] = ACTIONS(1333),
    [sym_string] = ACTIONS(1333),
    [sym__integer_literal] = ACTIONS(1335),
    [sym__binary_literal] = ACTIONS(1337),
    [sym__octal_literal] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1337),
    [sym_implicit_variable] = ACTIONS(3463),
    [sym_name] = ACTIONS(3465),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1341),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1657] = {
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(339),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__paren_open] = STATE(400),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1658] = {
    [sym__type_parens] = STATE(3557),
    [sym__type_tuple] = STATE(3612),
    [sym__type_unboxed_tuple] = STATE(3607),
    [sym__type_unboxed_sum] = STATE(3606),
    [sym__type_list] = STATE(3605),
    [sym__type_promoted] = STATE(3638),
    [sym__type_star] = STATE(3638),
    [sym__type_wildcard] = STATE(3638),
    [sym__type_apply] = STATE(3604),
    [sym__type_infix] = STATE(3602),
    [sym_type] = STATE(508),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10082),
    [sym__qtype_forall] = STATE(3832),
    [sym__qtype_forall_required] = STATE(3829),
    [sym_strict_field] = STATE(8659),
    [sym_lazy_field] = STATE(8659),
    [sym__qtype_function] = STATE(3824),
    [sym__qtype_linear_function] = STATE(3823),
    [sym__qtype_context] = STATE(3821),
    [sym_quantified_type] = STATE(2920),
    [sym_implicit_parameter] = STATE(3838),
    [sym__context_inline] = STATE(1658),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11140),
    [sym__splice_dollars] = STATE(7350),
    [sym_splice] = STATE(3638),
    [sym_quasiquote] = STATE(3638),
    [sym_integer] = STATE(3509),
    [sym__plist] = STATE(3597),
    [sym_unit] = STATE(3638),
    [sym_unboxed_unit] = STATE(3638),
    [sym_prefix_tuple] = STATE(3638),
    [sym_prefix_unboxed_tuple] = STATE(3638),
    [sym_prefix_unboxed_sum] = STATE(3638),
    [sym_literal] = STATE(3638),
    [sym__qualified_type] = STATE(3643),
    [sym__qtyconid] = STATE(3583),
    [sym__tycon_arrow] = STATE(3583),
    [sym__qtycon_arrow] = STATE(3583),
    [sym__promoted_tycons_alias] = STATE(3638),
    [sym__promoted_tycons] = STATE(3638),
    [sym__varsym_prefix] = STATE(3583),
    [sym__pvarsym] = STATE(3583),
    [sym__qvarsym_prefix] = STATE(3583),
    [sym__pqvarsym] = STATE(3583),
    [sym__consym_prefix] = STATE(3583),
    [sym__pconsym] = STATE(3583),
    [sym__qconsym_prefix] = STATE(3583),
    [sym__pqconsym] = STATE(3583),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(461),
    [sym__bracket_open] = STATE(1131),
    [sym__unboxed_open] = STATE(829),
    [sym_variable] = ACTIONS(1669),
    [anon_sym__] = ACTIONS(1671),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(1677),
    [anon_sym_u2605] = ACTIONS(1677),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1679),
    [sym_char] = ACTIONS(1679),
    [sym_string] = ACTIONS(1679),
    [sym__integer_literal] = ACTIONS(1681),
    [sym__binary_literal] = ACTIONS(1683),
    [sym__octal_literal] = ACTIONS(1683),
    [sym__hex_literal] = ACTIONS(1683),
    [sym_implicit_variable] = ACTIONS(3421),
    [sym_name] = ACTIONS(3423),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1687),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1659] = {
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(338),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__paren_open] = STATE(400),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1660] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8180),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = ACTIONS(1989),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1661] = {
    [sym__type_parens] = STATE(6909),
    [sym__type_tuple] = STATE(6883),
    [sym__type_unboxed_tuple] = STATE(6903),
    [sym__type_unboxed_sum] = STATE(6892),
    [sym__type_list] = STATE(6891),
    [sym__type_promoted] = STATE(6911),
    [sym__type_star] = STATE(6911),
    [sym__type_wildcard] = STATE(6911),
    [sym__type_apply] = STATE(6890),
    [sym__type_infix] = STATE(6959),
    [sym_type] = STATE(881),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10230),
    [sym__qtype_forall] = STATE(8887),
    [sym__qtype_forall_required] = STATE(8873),
    [sym_strict_field] = STATE(8624),
    [sym_lazy_field] = STATE(8624),
    [sym__qtype_function] = STATE(8861),
    [sym__qtype_linear_function] = STATE(8867),
    [sym__qtype_context] = STATE(8904),
    [sym_quantified_type] = STATE(8418),
    [sym_implicit_parameter] = STATE(8868),
    [sym__context_inline] = STATE(1605),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11277),
    [sym__splice_dollars] = STATE(7211),
    [sym_splice] = STATE(6911),
    [sym_quasiquote] = STATE(6911),
    [sym_integer] = STATE(6928),
    [sym__plist] = STATE(6889),
    [sym_unit] = STATE(6911),
    [sym_unboxed_unit] = STATE(6911),
    [sym_prefix_tuple] = STATE(6911),
    [sym_prefix_unboxed_tuple] = STATE(6911),
    [sym_prefix_unboxed_sum] = STATE(6911),
    [sym_literal] = STATE(6911),
    [sym__qualified_type] = STATE(6933),
    [sym__qtyconid] = STATE(6884),
    [sym__tycon_arrow] = STATE(6884),
    [sym__qtycon_arrow] = STATE(6884),
    [sym__promoted_tycons_alias] = STATE(6911),
    [sym__promoted_tycons] = STATE(6911),
    [sym__varsym_prefix] = STATE(6884),
    [sym__pvarsym] = STATE(6884),
    [sym__qvarsym_prefix] = STATE(6884),
    [sym__pqvarsym] = STATE(6884),
    [sym__consym_prefix] = STATE(6884),
    [sym__pconsym] = STATE(6884),
    [sym__qconsym_prefix] = STATE(6884),
    [sym__pqconsym] = STATE(6884),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(430),
    [sym__bracket_open] = STATE(1017),
    [sym__unboxed_open] = STATE(737),
    [sym_variable] = ACTIONS(2673),
    [anon_sym__] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(3339),
    [anon_sym_STAR] = ACTIONS(2681),
    [anon_sym_u2605] = ACTIONS(2681),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2683),
    [sym_char] = ACTIONS(2683),
    [sym_string] = ACTIONS(2683),
    [sym__integer_literal] = ACTIONS(2685),
    [sym__binary_literal] = ACTIONS(2687),
    [sym__octal_literal] = ACTIONS(2687),
    [sym__hex_literal] = ACTIONS(2687),
    [sym_implicit_variable] = ACTIONS(3341),
    [sym_name] = ACTIONS(3343),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2691),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1662] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__assoc_tyinst] = STATE(10389),
    [sym__assoc_datainst_adt] = STATE(10386),
    [sym__assoc_datainst_newtype] = STATE(10381),
    [sym__assoc_datainst] = STATE(10379),
    [sym_instance_decl] = STATE(9533),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10379),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_newtype] = ACTIONS(2911),
    [anon_sym_data] = ACTIONS(2913),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1663] = {
    [sym__type_parens] = STATE(6323),
    [sym__type_tuple] = STATE(6324),
    [sym__type_unboxed_tuple] = STATE(6325),
    [sym__type_unboxed_sum] = STATE(6326),
    [sym__type_list] = STATE(6327),
    [sym__type_promoted] = STATE(6321),
    [sym__type_star] = STATE(6321),
    [sym__type_wildcard] = STATE(6321),
    [sym__type_apply] = STATE(6328),
    [sym__type_infix] = STATE(6329),
    [sym_type] = STATE(754),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10134),
    [sym__qtype_forall] = STATE(8674),
    [sym__qtype_forall_required] = STATE(8673),
    [sym_strict_field] = STATE(8650),
    [sym_lazy_field] = STATE(8650),
    [sym__qtype_function] = STATE(8647),
    [sym__qtype_linear_function] = STATE(8671),
    [sym__qtype_context] = STATE(8665),
    [sym_quantified_type] = STATE(8251),
    [sym_implicit_parameter] = STATE(8661),
    [sym__context_inline] = STATE(1567),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11328),
    [sym__splice_dollars] = STATE(7407),
    [sym_splice] = STATE(6321),
    [sym_quasiquote] = STATE(6321),
    [sym_integer] = STATE(6269),
    [sym__plist] = STATE(6330),
    [sym_unit] = STATE(6321),
    [sym_unboxed_unit] = STATE(6321),
    [sym_prefix_tuple] = STATE(6321),
    [sym_prefix_unboxed_tuple] = STATE(6321),
    [sym_prefix_unboxed_sum] = STATE(6321),
    [sym_literal] = STATE(6321),
    [sym__qualified_type] = STATE(6286),
    [sym__qtyconid] = STATE(6331),
    [sym__tycon_arrow] = STATE(6331),
    [sym__qtycon_arrow] = STATE(6331),
    [sym__promoted_tycons_alias] = STATE(6321),
    [sym__promoted_tycons] = STATE(6321),
    [sym__varsym_prefix] = STATE(6331),
    [sym__pvarsym] = STATE(6331),
    [sym__qvarsym_prefix] = STATE(6331),
    [sym__pqvarsym] = STATE(6331),
    [sym__consym_prefix] = STATE(6331),
    [sym__pconsym] = STATE(6331),
    [sym__qconsym_prefix] = STATE(6331),
    [sym__pqconsym] = STATE(6331),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(469),
    [sym__bracket_open] = STATE(990),
    [sym__unboxed_open] = STATE(810),
    [sym_variable] = ACTIONS(2155),
    [anon_sym__] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_u2605] = ACTIONS(2163),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2165),
    [sym_char] = ACTIONS(2165),
    [sym_string] = ACTIONS(2165),
    [sym__integer_literal] = ACTIONS(2167),
    [sym__binary_literal] = ACTIONS(2169),
    [sym__octal_literal] = ACTIONS(2169),
    [sym__hex_literal] = ACTIONS(2169),
    [sym_implicit_variable] = ACTIONS(3429),
    [sym_name] = ACTIONS(3431),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2173),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1664] = {
    [sym__type_parens] = STATE(2335),
    [sym__type_tuple] = STATE(2337),
    [sym__type_unboxed_tuple] = STATE(2338),
    [sym__type_unboxed_sum] = STATE(2341),
    [sym__type_list] = STATE(2342),
    [sym__type_promoted] = STATE(2327),
    [sym__type_star] = STATE(2327),
    [sym__type_wildcard] = STATE(2327),
    [sym__type_apply] = STATE(2353),
    [sym__type_infix] = STATE(2352),
    [sym_type] = STATE(327),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10117),
    [sym__qtype_forall] = STATE(2381),
    [sym__qtype_forall_required] = STATE(2383),
    [sym_strict_field] = STATE(8708),
    [sym_lazy_field] = STATE(8708),
    [sym__qtype_function] = STATE(2386),
    [sym__qtype_linear_function] = STATE(2387),
    [sym__qtype_context] = STATE(2390),
    [sym_quantified_type] = STATE(2232),
    [sym_implicit_parameter] = STATE(2391),
    [sym__context_inline] = STATE(1664),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11256),
    [sym__splice_dollars] = STATE(7396),
    [sym_splice] = STATE(2327),
    [sym_quasiquote] = STATE(2327),
    [sym_integer] = STATE(2318),
    [sym__plist] = STATE(2350),
    [sym_unit] = STATE(2327),
    [sym_unboxed_unit] = STATE(2327),
    [sym_prefix_tuple] = STATE(2327),
    [sym_prefix_unboxed_tuple] = STATE(2327),
    [sym_prefix_unboxed_sum] = STATE(2327),
    [sym_literal] = STATE(2327),
    [sym__qualified_type] = STATE(2343),
    [sym__qtyconid] = STATE(2348),
    [sym__tycon_arrow] = STATE(2348),
    [sym__qtycon_arrow] = STATE(2348),
    [sym__promoted_tycons_alias] = STATE(2327),
    [sym__promoted_tycons] = STATE(2327),
    [sym__varsym_prefix] = STATE(2348),
    [sym__pvarsym] = STATE(2348),
    [sym__qvarsym_prefix] = STATE(2348),
    [sym__pqvarsym] = STATE(2348),
    [sym__consym_prefix] = STATE(2348),
    [sym__pconsym] = STATE(2348),
    [sym__qconsym_prefix] = STATE(2348),
    [sym__pqconsym] = STATE(2348),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(445),
    [sym__bracket_open] = STATE(1047),
    [sym__unboxed_open] = STATE(740),
    [sym_variable] = ACTIONS(1121),
    [anon_sym__] = ACTIONS(1127),
    [anon_sym_SQUOTE] = ACTIONS(3317),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_u2605] = ACTIONS(1133),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1139),
    [sym_char] = ACTIONS(1139),
    [sym_string] = ACTIONS(1139),
    [sym__integer_literal] = ACTIONS(1141),
    [sym__binary_literal] = ACTIONS(1143),
    [sym__octal_literal] = ACTIONS(1143),
    [sym__hex_literal] = ACTIONS(1143),
    [sym_implicit_variable] = ACTIONS(3319),
    [sym_name] = ACTIONS(3321),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1153),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1665] = {
    [sym__type_parens] = STATE(3379),
    [sym__type_tuple] = STATE(3377),
    [sym__type_unboxed_tuple] = STATE(3370),
    [sym__type_unboxed_sum] = STATE(3369),
    [sym__type_list] = STATE(3361),
    [sym__type_promoted] = STATE(3383),
    [sym__type_star] = STATE(3383),
    [sym__type_wildcard] = STATE(3383),
    [sym__type_apply] = STATE(3359),
    [sym__type_infix] = STATE(3358),
    [sym_type] = STATE(486),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10095),
    [sym__qtype_forall] = STATE(3757),
    [sym__qtype_forall_required] = STATE(3758),
    [sym_strict_field] = STATE(8706),
    [sym_lazy_field] = STATE(8706),
    [sym__qtype_function] = STATE(3762),
    [sym__qtype_linear_function] = STATE(3767),
    [sym__qtype_context] = STATE(3768),
    [sym_quantified_type] = STATE(2791),
    [sym_implicit_parameter] = STATE(3788),
    [sym__context_inline] = STATE(1749),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11178),
    [sym__splice_dollars] = STATE(7460),
    [sym_splice] = STATE(3383),
    [sym_quasiquote] = STATE(3383),
    [sym_integer] = STATE(3269),
    [sym__plist] = STATE(3357),
    [sym_unit] = STATE(3383),
    [sym_unboxed_unit] = STATE(3383),
    [sym_prefix_tuple] = STATE(3383),
    [sym_prefix_unboxed_tuple] = STATE(3383),
    [sym_prefix_unboxed_sum] = STATE(3383),
    [sym_literal] = STATE(3383),
    [sym__qualified_type] = STATE(3410),
    [sym__qtyconid] = STATE(3354),
    [sym__tycon_arrow] = STATE(3354),
    [sym__qtycon_arrow] = STATE(3354),
    [sym__promoted_tycons_alias] = STATE(3383),
    [sym__promoted_tycons] = STATE(3383),
    [sym__varsym_prefix] = STATE(3354),
    [sym__pvarsym] = STATE(3354),
    [sym__qvarsym_prefix] = STATE(3354),
    [sym__pqvarsym] = STATE(3354),
    [sym__consym_prefix] = STATE(3354),
    [sym__pconsym] = STATE(3354),
    [sym__qconsym_prefix] = STATE(3354),
    [sym__pqconsym] = STATE(3354),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(464),
    [sym__bracket_open] = STATE(1079),
    [sym__unboxed_open] = STATE(805),
    [sym_variable] = ACTIONS(1609),
    [anon_sym__] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_u2605] = ACTIONS(1617),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1619),
    [sym_char] = ACTIONS(1619),
    [sym_string] = ACTIONS(1619),
    [sym__integer_literal] = ACTIONS(1621),
    [sym__binary_literal] = ACTIONS(1623),
    [sym__octal_literal] = ACTIONS(1623),
    [sym__hex_literal] = ACTIONS(1623),
    [sym_implicit_variable] = ACTIONS(3385),
    [sym_name] = ACTIONS(3387),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1627),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1666] = {
    [sym__type_parens] = STATE(3294),
    [sym__type_tuple] = STATE(3295),
    [sym__type_unboxed_tuple] = STATE(3296),
    [sym__type_unboxed_sum] = STATE(3298),
    [sym__type_list] = STATE(3311),
    [sym__type_promoted] = STATE(3292),
    [sym__type_star] = STATE(3292),
    [sym__type_wildcard] = STATE(3292),
    [sym__type_apply] = STATE(3313),
    [sym__type_infix] = STATE(3314),
    [sym_type] = STATE(478),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10086),
    [sym__qtype_forall] = STATE(3726),
    [sym__qtype_forall_required] = STATE(3727),
    [sym_strict_field] = STATE(8686),
    [sym_lazy_field] = STATE(8686),
    [sym__qtype_function] = STATE(3728),
    [sym__qtype_linear_function] = STATE(3729),
    [sym__qtype_context] = STATE(3730),
    [sym_quantified_type] = STATE(2838),
    [sym_implicit_parameter] = STATE(3720),
    [sym__context_inline] = STATE(1666),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11151),
    [sym__splice_dollars] = STATE(7231),
    [sym_splice] = STATE(3292),
    [sym_quasiquote] = STATE(3292),
    [sym_integer] = STATE(3286),
    [sym__plist] = STATE(3318),
    [sym_unit] = STATE(3292),
    [sym_unboxed_unit] = STATE(3292),
    [sym_prefix_tuple] = STATE(3292),
    [sym_prefix_unboxed_tuple] = STATE(3292),
    [sym_prefix_unboxed_sum] = STATE(3292),
    [sym_literal] = STATE(3292),
    [sym__qualified_type] = STATE(3249),
    [sym__qtyconid] = STATE(3320),
    [sym__tycon_arrow] = STATE(3320),
    [sym__qtycon_arrow] = STATE(3320),
    [sym__promoted_tycons_alias] = STATE(3292),
    [sym__promoted_tycons] = STATE(3292),
    [sym__varsym_prefix] = STATE(3320),
    [sym__pvarsym] = STATE(3320),
    [sym__qvarsym_prefix] = STATE(3320),
    [sym__pqvarsym] = STATE(3320),
    [sym__consym_prefix] = STATE(3320),
    [sym__pconsym] = STATE(3320),
    [sym__qconsym_prefix] = STATE(3320),
    [sym__pqconsym] = STATE(3320),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(458),
    [sym__bracket_open] = STATE(1120),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = ACTIONS(1589),
    [anon_sym__] = ACTIONS(1591),
    [anon_sym_SQUOTE] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(1597),
    [anon_sym_u2605] = ACTIONS(1597),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1599),
    [sym_char] = ACTIONS(1599),
    [sym_string] = ACTIONS(1599),
    [sym__integer_literal] = ACTIONS(1601),
    [sym__binary_literal] = ACTIONS(1603),
    [sym__octal_literal] = ACTIONS(1603),
    [sym__hex_literal] = ACTIONS(1603),
    [sym_implicit_variable] = ACTIONS(3469),
    [sym_name] = ACTIONS(3471),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1607),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1667] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10122),
    [sym__qtype_forall] = STATE(9396),
    [sym__qtype_forall_required] = STATE(9395),
    [sym_strict_field] = STATE(8608),
    [sym_lazy_field] = STATE(8608),
    [sym__qtype_function] = STATE(9390),
    [sym__qtype_linear_function] = STATE(9389),
    [sym__qtype_context] = STATE(9386),
    [sym_quantified_type] = STATE(8576),
    [sym_implicit_parameter] = STATE(9379),
    [sym__context_inline] = STATE(1631),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(3355),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1668] = {
    [sym__type_parens] = STATE(2335),
    [sym__type_tuple] = STATE(2337),
    [sym__type_unboxed_tuple] = STATE(2338),
    [sym__type_unboxed_sum] = STATE(2341),
    [sym__type_list] = STATE(2342),
    [sym__type_promoted] = STATE(2327),
    [sym__type_star] = STATE(2327),
    [sym__type_wildcard] = STATE(2327),
    [sym__type_apply] = STATE(2353),
    [sym__type_infix] = STATE(2352),
    [sym_type] = STATE(327),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10117),
    [sym__qtype_forall] = STATE(2381),
    [sym__qtype_forall_required] = STATE(2383),
    [sym_strict_field] = STATE(8708),
    [sym_lazy_field] = STATE(8708),
    [sym__qtype_function] = STATE(2386),
    [sym__qtype_linear_function] = STATE(2387),
    [sym__qtype_context] = STATE(2390),
    [sym_quantified_type] = STATE(2227),
    [sym_implicit_parameter] = STATE(2391),
    [sym__context_inline] = STATE(1664),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11256),
    [sym__splice_dollars] = STATE(7396),
    [sym_splice] = STATE(2327),
    [sym_quasiquote] = STATE(2327),
    [sym_integer] = STATE(2318),
    [sym__plist] = STATE(2350),
    [sym_unit] = STATE(2327),
    [sym_unboxed_unit] = STATE(2327),
    [sym_prefix_tuple] = STATE(2327),
    [sym_prefix_unboxed_tuple] = STATE(2327),
    [sym_prefix_unboxed_sum] = STATE(2327),
    [sym_literal] = STATE(2327),
    [sym__qualified_type] = STATE(2343),
    [sym__qtyconid] = STATE(2348),
    [sym__tycon_arrow] = STATE(2348),
    [sym__qtycon_arrow] = STATE(2348),
    [sym__promoted_tycons_alias] = STATE(2327),
    [sym__promoted_tycons] = STATE(2327),
    [sym__varsym_prefix] = STATE(2348),
    [sym__pvarsym] = STATE(2348),
    [sym__qvarsym_prefix] = STATE(2348),
    [sym__pqvarsym] = STATE(2348),
    [sym__consym_prefix] = STATE(2348),
    [sym__pconsym] = STATE(2348),
    [sym__qconsym_prefix] = STATE(2348),
    [sym__pqconsym] = STATE(2348),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(445),
    [sym__bracket_open] = STATE(1047),
    [sym__unboxed_open] = STATE(740),
    [sym_variable] = ACTIONS(1121),
    [anon_sym__] = ACTIONS(1127),
    [anon_sym_SQUOTE] = ACTIONS(3317),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_u2605] = ACTIONS(1133),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1139),
    [sym_char] = ACTIONS(1139),
    [sym_string] = ACTIONS(1139),
    [sym__integer_literal] = ACTIONS(1141),
    [sym__binary_literal] = ACTIONS(1143),
    [sym__octal_literal] = ACTIONS(1143),
    [sym__hex_literal] = ACTIONS(1143),
    [sym_implicit_variable] = ACTIONS(3319),
    [sym_name] = ACTIONS(3321),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1153),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1669] = {
    [sym__type_parens] = STATE(2335),
    [sym__type_tuple] = STATE(2337),
    [sym__type_unboxed_tuple] = STATE(2338),
    [sym__type_unboxed_sum] = STATE(2341),
    [sym__type_list] = STATE(2342),
    [sym__type_promoted] = STATE(2327),
    [sym__type_star] = STATE(2327),
    [sym__type_wildcard] = STATE(2327),
    [sym__type_apply] = STATE(2353),
    [sym__type_infix] = STATE(2352),
    [sym_type] = STATE(327),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10117),
    [sym__qtype_forall] = STATE(2381),
    [sym__qtype_forall_required] = STATE(2383),
    [sym_strict_field] = STATE(8708),
    [sym_lazy_field] = STATE(8708),
    [sym__qtype_function] = STATE(2386),
    [sym__qtype_linear_function] = STATE(2387),
    [sym__qtype_context] = STATE(2390),
    [sym_quantified_type] = STATE(2229),
    [sym_implicit_parameter] = STATE(2391),
    [sym__context_inline] = STATE(1664),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11256),
    [sym__splice_dollars] = STATE(7396),
    [sym_splice] = STATE(2327),
    [sym_quasiquote] = STATE(2327),
    [sym_integer] = STATE(2318),
    [sym__plist] = STATE(2350),
    [sym_unit] = STATE(2327),
    [sym_unboxed_unit] = STATE(2327),
    [sym_prefix_tuple] = STATE(2327),
    [sym_prefix_unboxed_tuple] = STATE(2327),
    [sym_prefix_unboxed_sum] = STATE(2327),
    [sym_literal] = STATE(2327),
    [sym__qualified_type] = STATE(2343),
    [sym__qtyconid] = STATE(2348),
    [sym__tycon_arrow] = STATE(2348),
    [sym__qtycon_arrow] = STATE(2348),
    [sym__promoted_tycons_alias] = STATE(2327),
    [sym__promoted_tycons] = STATE(2327),
    [sym__varsym_prefix] = STATE(2348),
    [sym__pvarsym] = STATE(2348),
    [sym__qvarsym_prefix] = STATE(2348),
    [sym__pqvarsym] = STATE(2348),
    [sym__consym_prefix] = STATE(2348),
    [sym__pconsym] = STATE(2348),
    [sym__qconsym_prefix] = STATE(2348),
    [sym__pqconsym] = STATE(2348),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(445),
    [sym__bracket_open] = STATE(1047),
    [sym__unboxed_open] = STATE(740),
    [sym_variable] = ACTIONS(1121),
    [anon_sym__] = ACTIONS(1127),
    [anon_sym_SQUOTE] = ACTIONS(3317),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_u2605] = ACTIONS(1133),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1139),
    [sym_char] = ACTIONS(1139),
    [sym_string] = ACTIONS(1139),
    [sym__integer_literal] = ACTIONS(1141),
    [sym__binary_literal] = ACTIONS(1143),
    [sym__octal_literal] = ACTIONS(1143),
    [sym__hex_literal] = ACTIONS(1143),
    [sym_implicit_variable] = ACTIONS(3319),
    [sym_name] = ACTIONS(3321),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1153),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1670] = {
    [sym__type_parens] = STATE(2335),
    [sym__type_tuple] = STATE(2337),
    [sym__type_unboxed_tuple] = STATE(2338),
    [sym__type_unboxed_sum] = STATE(2341),
    [sym__type_list] = STATE(2342),
    [sym__type_promoted] = STATE(2327),
    [sym__type_star] = STATE(2327),
    [sym__type_wildcard] = STATE(2327),
    [sym__type_apply] = STATE(2353),
    [sym__type_infix] = STATE(2352),
    [sym_type] = STATE(327),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10117),
    [sym__qtype_forall] = STATE(2381),
    [sym__qtype_forall_required] = STATE(2383),
    [sym_strict_field] = STATE(8708),
    [sym_lazy_field] = STATE(8708),
    [sym__qtype_function] = STATE(2386),
    [sym__qtype_linear_function] = STATE(2387),
    [sym__qtype_context] = STATE(2390),
    [sym_quantified_type] = STATE(2230),
    [sym_implicit_parameter] = STATE(2391),
    [sym__context_inline] = STATE(1664),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11256),
    [sym__splice_dollars] = STATE(7396),
    [sym_splice] = STATE(2327),
    [sym_quasiquote] = STATE(2327),
    [sym_integer] = STATE(2318),
    [sym__plist] = STATE(2350),
    [sym_unit] = STATE(2327),
    [sym_unboxed_unit] = STATE(2327),
    [sym_prefix_tuple] = STATE(2327),
    [sym_prefix_unboxed_tuple] = STATE(2327),
    [sym_prefix_unboxed_sum] = STATE(2327),
    [sym_literal] = STATE(2327),
    [sym__qualified_type] = STATE(2343),
    [sym__qtyconid] = STATE(2348),
    [sym__tycon_arrow] = STATE(2348),
    [sym__qtycon_arrow] = STATE(2348),
    [sym__promoted_tycons_alias] = STATE(2327),
    [sym__promoted_tycons] = STATE(2327),
    [sym__varsym_prefix] = STATE(2348),
    [sym__pvarsym] = STATE(2348),
    [sym__qvarsym_prefix] = STATE(2348),
    [sym__pqvarsym] = STATE(2348),
    [sym__consym_prefix] = STATE(2348),
    [sym__pconsym] = STATE(2348),
    [sym__qconsym_prefix] = STATE(2348),
    [sym__pqconsym] = STATE(2348),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(445),
    [sym__bracket_open] = STATE(1047),
    [sym__unboxed_open] = STATE(740),
    [sym_variable] = ACTIONS(1121),
    [anon_sym__] = ACTIONS(1127),
    [anon_sym_SQUOTE] = ACTIONS(3317),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_u2605] = ACTIONS(1133),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1139),
    [sym_char] = ACTIONS(1139),
    [sym_string] = ACTIONS(1139),
    [sym__integer_literal] = ACTIONS(1141),
    [sym__binary_literal] = ACTIONS(1143),
    [sym__octal_literal] = ACTIONS(1143),
    [sym__hex_literal] = ACTIONS(1143),
    [sym_implicit_variable] = ACTIONS(3319),
    [sym_name] = ACTIONS(3321),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1153),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1671] = {
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(225),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__paren_open] = STATE(416),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1672] = {
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(211),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__paren_open] = STATE(416),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1673] = {
    [sym__at_type] = STATE(7064),
    [sym_explicit_type] = STATE(7062),
    [sym__pat_parens] = STATE(7041),
    [sym__pat_tuple] = STATE(7042),
    [sym__pat_unboxed_tuple] = STATE(7043),
    [sym__pat_unboxed_sum] = STATE(7044),
    [sym__pat_list] = STATE(7045),
    [sym__pat_record] = STATE(7046),
    [sym__pat_as] = STATE(7047),
    [sym__pat_wildcard] = STATE(7048),
    [sym__pat_strict] = STATE(7049),
    [sym__pat_irrefutable] = STATE(7050),
    [sym__pat_apply] = STATE(7051),
    [sym__pat_negation] = STATE(7052),
    [sym__pat_infix] = STATE(7053),
    [sym_pattern] = STATE(1769),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11245),
    [sym__splice_dollars] = STATE(7422),
    [sym_splice] = STATE(7048),
    [sym_quasiquote] = STATE(7048),
    [sym_integer] = STATE(7199),
    [sym__plist] = STATE(7057),
    [sym_unit] = STATE(7048),
    [sym_unboxed_unit] = STATE(7048),
    [sym_prefix_tuple] = STATE(7048),
    [sym_prefix_unboxed_tuple] = STATE(7048),
    [sym_prefix_unboxed_sum] = STATE(7048),
    [sym_literal] = STATE(7048),
    [sym__qualified_constructor] = STATE(7189),
    [sym__qconid] = STATE(7048),
    [sym__constructor_ticked] = STATE(2275),
    [sym__qconstructor_ticked] = STATE(2275),
    [sym__varsym_prefix] = STATE(7058),
    [sym__pvarsym] = STATE(7058),
    [sym_constructor_operator] = STATE(2275),
    [sym__consym_prefix] = STATE(7059),
    [sym__pconsym] = STATE(7059),
    [sym__qconsym_prefix] = STATE(7048),
    [sym__pqconsym] = STATE(7048),
    [sym__colon2] = STATE(1739),
    [sym__prefix_at] = STATE(2550),
    [sym__prefix_bang] = STATE(2256),
    [sym__tight_bang] = STATE(2256),
    [sym__any_prefix_bang] = STATE(2256),
    [sym__prefix_tilde] = STATE(2253),
    [sym__tight_tilde] = STATE(2253),
    [sym__any_prefix_tilde] = STATE(2253),
    [sym__paren_open] = STATE(42),
    [sym__bracket_open] = STATE(364),
    [sym__unboxed_open] = STATE(202),
    [sym_variable] = ACTIONS(3473),
    [anon_sym_SEMI] = ACTIONS(2719),
    [anon_sym_LBRACE] = ACTIONS(3475),
    [anon_sym__] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3481),
    [sym_char] = ACTIONS(3481),
    [sym_string] = ACTIONS(3481),
    [sym__integer_literal] = ACTIONS(3483),
    [sym__binary_literal] = ACTIONS(3485),
    [sym__octal_literal] = ACTIONS(3485),
    [sym__hex_literal] = ACTIONS(3485),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3489),
    [anon_sym_u2237] = ACTIONS(3489),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_where] = ACTIONS(3491),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(2719),
    [sym__cond_layout_end] = ACTIONS(2719),
    [sym__cond_layout_end_explicit] = ACTIONS(2719),
    [sym__phantom_where] = ACTIONS(2719),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3493),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(3495),
    [sym__cond_no_section_op] = ACTIONS(3497),
    [sym__consym] = ACTIONS(2737),
  },
  [1674] = {
    [sym__type_parens] = STATE(2335),
    [sym__type_tuple] = STATE(2337),
    [sym__type_unboxed_tuple] = STATE(2338),
    [sym__type_unboxed_sum] = STATE(2341),
    [sym__type_list] = STATE(2342),
    [sym__type_promoted] = STATE(2327),
    [sym__type_star] = STATE(2327),
    [sym__type_wildcard] = STATE(2327),
    [sym__type_apply] = STATE(2353),
    [sym__type_infix] = STATE(2352),
    [sym_type] = STATE(327),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10117),
    [sym__qtype_forall] = STATE(2381),
    [sym__qtype_forall_required] = STATE(2383),
    [sym_strict_field] = STATE(8708),
    [sym_lazy_field] = STATE(8708),
    [sym__qtype_function] = STATE(2386),
    [sym__qtype_linear_function] = STATE(2387),
    [sym__qtype_context] = STATE(2390),
    [sym_quantified_type] = STATE(2231),
    [sym_implicit_parameter] = STATE(2391),
    [sym__context_inline] = STATE(1664),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11256),
    [sym__splice_dollars] = STATE(7396),
    [sym_splice] = STATE(2327),
    [sym_quasiquote] = STATE(2327),
    [sym_integer] = STATE(2318),
    [sym__plist] = STATE(2350),
    [sym_unit] = STATE(2327),
    [sym_unboxed_unit] = STATE(2327),
    [sym_prefix_tuple] = STATE(2327),
    [sym_prefix_unboxed_tuple] = STATE(2327),
    [sym_prefix_unboxed_sum] = STATE(2327),
    [sym_literal] = STATE(2327),
    [sym__qualified_type] = STATE(2343),
    [sym__qtyconid] = STATE(2348),
    [sym__tycon_arrow] = STATE(2348),
    [sym__qtycon_arrow] = STATE(2348),
    [sym__promoted_tycons_alias] = STATE(2327),
    [sym__promoted_tycons] = STATE(2327),
    [sym__varsym_prefix] = STATE(2348),
    [sym__pvarsym] = STATE(2348),
    [sym__qvarsym_prefix] = STATE(2348),
    [sym__pqvarsym] = STATE(2348),
    [sym__consym_prefix] = STATE(2348),
    [sym__pconsym] = STATE(2348),
    [sym__qconsym_prefix] = STATE(2348),
    [sym__pqconsym] = STATE(2348),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(445),
    [sym__bracket_open] = STATE(1047),
    [sym__unboxed_open] = STATE(740),
    [sym_variable] = ACTIONS(1121),
    [anon_sym__] = ACTIONS(1127),
    [anon_sym_SQUOTE] = ACTIONS(3317),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_u2605] = ACTIONS(1133),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1139),
    [sym_char] = ACTIONS(1139),
    [sym_string] = ACTIONS(1139),
    [sym__integer_literal] = ACTIONS(1141),
    [sym__binary_literal] = ACTIONS(1143),
    [sym__octal_literal] = ACTIONS(1143),
    [sym__hex_literal] = ACTIONS(1143),
    [sym_implicit_variable] = ACTIONS(3319),
    [sym_name] = ACTIONS(3321),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1153),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1675] = {
    [sym__type_parens] = STATE(2335),
    [sym__type_tuple] = STATE(2337),
    [sym__type_unboxed_tuple] = STATE(2338),
    [sym__type_unboxed_sum] = STATE(2341),
    [sym__type_list] = STATE(2342),
    [sym__type_promoted] = STATE(2327),
    [sym__type_star] = STATE(2327),
    [sym__type_wildcard] = STATE(2327),
    [sym__type_apply] = STATE(2353),
    [sym__type_infix] = STATE(2352),
    [sym_type] = STATE(327),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10117),
    [sym__qtype_forall] = STATE(2381),
    [sym__qtype_forall_required] = STATE(2383),
    [sym_strict_field] = STATE(8708),
    [sym_lazy_field] = STATE(8708),
    [sym__qtype_function] = STATE(2386),
    [sym__qtype_linear_function] = STATE(2387),
    [sym__qtype_context] = STATE(2390),
    [sym_quantified_type] = STATE(2233),
    [sym_implicit_parameter] = STATE(2391),
    [sym__context_inline] = STATE(1664),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11256),
    [sym__splice_dollars] = STATE(7396),
    [sym_splice] = STATE(2327),
    [sym_quasiquote] = STATE(2327),
    [sym_integer] = STATE(2318),
    [sym__plist] = STATE(2350),
    [sym_unit] = STATE(2327),
    [sym_unboxed_unit] = STATE(2327),
    [sym_prefix_tuple] = STATE(2327),
    [sym_prefix_unboxed_tuple] = STATE(2327),
    [sym_prefix_unboxed_sum] = STATE(2327),
    [sym_literal] = STATE(2327),
    [sym__qualified_type] = STATE(2343),
    [sym__qtyconid] = STATE(2348),
    [sym__tycon_arrow] = STATE(2348),
    [sym__qtycon_arrow] = STATE(2348),
    [sym__promoted_tycons_alias] = STATE(2327),
    [sym__promoted_tycons] = STATE(2327),
    [sym__varsym_prefix] = STATE(2348),
    [sym__pvarsym] = STATE(2348),
    [sym__qvarsym_prefix] = STATE(2348),
    [sym__pqvarsym] = STATE(2348),
    [sym__consym_prefix] = STATE(2348),
    [sym__pconsym] = STATE(2348),
    [sym__qconsym_prefix] = STATE(2348),
    [sym__pqconsym] = STATE(2348),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(445),
    [sym__bracket_open] = STATE(1047),
    [sym__unboxed_open] = STATE(740),
    [sym_variable] = ACTIONS(1121),
    [anon_sym__] = ACTIONS(1127),
    [anon_sym_SQUOTE] = ACTIONS(3317),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_u2605] = ACTIONS(1133),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1139),
    [sym_char] = ACTIONS(1139),
    [sym_string] = ACTIONS(1139),
    [sym__integer_literal] = ACTIONS(1141),
    [sym__binary_literal] = ACTIONS(1143),
    [sym__octal_literal] = ACTIONS(1143),
    [sym__hex_literal] = ACTIONS(1143),
    [sym_implicit_variable] = ACTIONS(3319),
    [sym_name] = ACTIONS(3321),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1153),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1676] = {
    [sym__type_parens] = STATE(2825),
    [sym__type_tuple] = STATE(2808),
    [sym__type_unboxed_tuple] = STATE(2788),
    [sym__type_unboxed_sum] = STATE(2767),
    [sym__type_list] = STATE(2839),
    [sym__type_promoted] = STATE(2796),
    [sym__type_star] = STATE(2796),
    [sym__type_wildcard] = STATE(2796),
    [sym__type_apply] = STATE(2823),
    [sym__type_infix] = STATE(2774),
    [sym_type] = STATE(421),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10083),
    [sym__qtype_forall] = STATE(3138),
    [sym__qtype_forall_required] = STATE(3136),
    [sym_strict_field] = STATE(8681),
    [sym_lazy_field] = STATE(8681),
    [sym__qtype_function] = STATE(3135),
    [sym__qtype_linear_function] = STATE(3132),
    [sym__qtype_context] = STATE(3131),
    [sym_quantified_type] = STATE(2368),
    [sym_implicit_parameter] = STATE(3115),
    [sym__context_inline] = STATE(1721),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11145),
    [sym__splice_dollars] = STATE(7328),
    [sym_splice] = STATE(2796),
    [sym_quasiquote] = STATE(2796),
    [sym_integer] = STATE(2781),
    [sym__plist] = STATE(2777),
    [sym_unit] = STATE(2796),
    [sym_unboxed_unit] = STATE(2796),
    [sym_prefix_tuple] = STATE(2796),
    [sym_prefix_unboxed_tuple] = STATE(2796),
    [sym_prefix_unboxed_sum] = STATE(2796),
    [sym_literal] = STATE(2796),
    [sym__qualified_type] = STATE(2759),
    [sym__qtyconid] = STATE(2752),
    [sym__tycon_arrow] = STATE(2752),
    [sym__qtycon_arrow] = STATE(2752),
    [sym__promoted_tycons_alias] = STATE(2796),
    [sym__promoted_tycons] = STATE(2796),
    [sym__varsym_prefix] = STATE(2752),
    [sym__pvarsym] = STATE(2752),
    [sym__qvarsym_prefix] = STATE(2752),
    [sym__pqvarsym] = STATE(2752),
    [sym__consym_prefix] = STATE(2752),
    [sym__pconsym] = STATE(2752),
    [sym__qconsym_prefix] = STATE(2752),
    [sym__pqconsym] = STATE(2752),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(467),
    [sym__bracket_open] = STATE(1130),
    [sym__unboxed_open] = STATE(765),
    [sym_variable] = ACTIONS(1323),
    [anon_sym__] = ACTIONS(1325),
    [anon_sym_SQUOTE] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_u2605] = ACTIONS(1331),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1333),
    [sym_char] = ACTIONS(1333),
    [sym_string] = ACTIONS(1333),
    [sym__integer_literal] = ACTIONS(1335),
    [sym__binary_literal] = ACTIONS(1337),
    [sym__octal_literal] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1337),
    [sym_implicit_variable] = ACTIONS(3463),
    [sym_name] = ACTIONS(3465),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1341),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1677] = {
    [sym__type_parens] = STATE(2825),
    [sym__type_tuple] = STATE(2808),
    [sym__type_unboxed_tuple] = STATE(2788),
    [sym__type_unboxed_sum] = STATE(2767),
    [sym__type_list] = STATE(2839),
    [sym__type_promoted] = STATE(2796),
    [sym__type_star] = STATE(2796),
    [sym__type_wildcard] = STATE(2796),
    [sym__type_apply] = STATE(2823),
    [sym__type_infix] = STATE(2774),
    [sym_type] = STATE(421),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10083),
    [sym__qtype_forall] = STATE(3138),
    [sym__qtype_forall_required] = STATE(3136),
    [sym_strict_field] = STATE(8681),
    [sym_lazy_field] = STATE(8681),
    [sym__qtype_function] = STATE(3135),
    [sym__qtype_linear_function] = STATE(3132),
    [sym__qtype_context] = STATE(3131),
    [sym_quantified_type] = STATE(2367),
    [sym_implicit_parameter] = STATE(3115),
    [sym__context_inline] = STATE(1721),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11145),
    [sym__splice_dollars] = STATE(7328),
    [sym_splice] = STATE(2796),
    [sym_quasiquote] = STATE(2796),
    [sym_integer] = STATE(2781),
    [sym__plist] = STATE(2777),
    [sym_unit] = STATE(2796),
    [sym_unboxed_unit] = STATE(2796),
    [sym_prefix_tuple] = STATE(2796),
    [sym_prefix_unboxed_tuple] = STATE(2796),
    [sym_prefix_unboxed_sum] = STATE(2796),
    [sym_literal] = STATE(2796),
    [sym__qualified_type] = STATE(2759),
    [sym__qtyconid] = STATE(2752),
    [sym__tycon_arrow] = STATE(2752),
    [sym__qtycon_arrow] = STATE(2752),
    [sym__promoted_tycons_alias] = STATE(2796),
    [sym__promoted_tycons] = STATE(2796),
    [sym__varsym_prefix] = STATE(2752),
    [sym__pvarsym] = STATE(2752),
    [sym__qvarsym_prefix] = STATE(2752),
    [sym__pqvarsym] = STATE(2752),
    [sym__consym_prefix] = STATE(2752),
    [sym__pconsym] = STATE(2752),
    [sym__qconsym_prefix] = STATE(2752),
    [sym__pqconsym] = STATE(2752),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(467),
    [sym__bracket_open] = STATE(1130),
    [sym__unboxed_open] = STATE(765),
    [sym_variable] = ACTIONS(1323),
    [anon_sym__] = ACTIONS(1325),
    [anon_sym_SQUOTE] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_u2605] = ACTIONS(1331),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1333),
    [sym_char] = ACTIONS(1333),
    [sym_string] = ACTIONS(1333),
    [sym__integer_literal] = ACTIONS(1335),
    [sym__binary_literal] = ACTIONS(1337),
    [sym__octal_literal] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1337),
    [sym_implicit_variable] = ACTIONS(3463),
    [sym_name] = ACTIONS(3465),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1341),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1678] = {
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(237),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__paren_open] = STATE(416),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1679] = {
    [sym__type_parens] = STATE(6922),
    [sym__type_tuple] = STATE(6929),
    [sym__type_unboxed_tuple] = STATE(6932),
    [sym__type_unboxed_sum] = STATE(6934),
    [sym__type_list] = STATE(6935),
    [sym__type_promoted] = STATE(6919),
    [sym__type_star] = STATE(6919),
    [sym__type_wildcard] = STATE(6919),
    [sym__type_apply] = STATE(6936),
    [sym__type_infix] = STATE(6937),
    [sym_type] = STATE(910),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10089),
    [sym__qtype_forall] = STATE(8937),
    [sym__qtype_forall_required] = STATE(8932),
    [sym_strict_field] = STATE(8700),
    [sym_lazy_field] = STATE(8700),
    [sym__qtype_function] = STATE(8931),
    [sym__qtype_linear_function] = STATE(8922),
    [sym__qtype_context] = STATE(8930),
    [sym_quantified_type] = STATE(8395),
    [sym_implicit_parameter] = STATE(8927),
    [sym__context_inline] = STATE(1434),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11154),
    [sym__splice_dollars] = STATE(7213),
    [sym_splice] = STATE(6919),
    [sym_quasiquote] = STATE(6919),
    [sym_integer] = STATE(6980),
    [sym__plist] = STATE(6939),
    [sym_unit] = STATE(6919),
    [sym_unboxed_unit] = STATE(6919),
    [sym_prefix_tuple] = STATE(6919),
    [sym_prefix_unboxed_tuple] = STATE(6919),
    [sym_prefix_unboxed_sum] = STATE(6919),
    [sym_literal] = STATE(6919),
    [sym__qualified_type] = STATE(7018),
    [sym__qtyconid] = STATE(6940),
    [sym__tycon_arrow] = STATE(6940),
    [sym__qtycon_arrow] = STATE(6940),
    [sym__promoted_tycons_alias] = STATE(6919),
    [sym__promoted_tycons] = STATE(6919),
    [sym__varsym_prefix] = STATE(6940),
    [sym__pvarsym] = STATE(6940),
    [sym__qvarsym_prefix] = STATE(6940),
    [sym__pqvarsym] = STATE(6940),
    [sym__consym_prefix] = STATE(6940),
    [sym__pconsym] = STATE(6940),
    [sym__qconsym_prefix] = STATE(6940),
    [sym__pqconsym] = STATE(6940),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(435),
    [sym__bracket_open] = STATE(1104),
    [sym__unboxed_open] = STATE(744),
    [sym_variable] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(2695),
    [anon_sym_SQUOTE] = ACTIONS(3325),
    [anon_sym_STAR] = ACTIONS(2701),
    [anon_sym_u2605] = ACTIONS(2701),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2703),
    [sym_char] = ACTIONS(2703),
    [sym_string] = ACTIONS(2703),
    [sym__integer_literal] = ACTIONS(2705),
    [sym__binary_literal] = ACTIONS(2707),
    [sym__octal_literal] = ACTIONS(2707),
    [sym__hex_literal] = ACTIONS(2707),
    [sym_implicit_variable] = ACTIONS(3327),
    [sym_name] = ACTIONS(3329),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2711),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1680] = {
    [sym__type_parens] = STATE(7152),
    [sym__type_tuple] = STATE(7138),
    [sym__type_unboxed_tuple] = STATE(7137),
    [sym__type_unboxed_sum] = STATE(7135),
    [sym__type_list] = STATE(7133),
    [sym__type_promoted] = STATE(7020),
    [sym__type_star] = STATE(7020),
    [sym__type_wildcard] = STATE(7020),
    [sym__type_apply] = STATE(7132),
    [sym__type_infix] = STATE(7130),
    [sym_type] = STATE(938),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10217),
    [sym__qtype_forall] = STATE(8973),
    [sym__qtype_forall_required] = STATE(9051),
    [sym_strict_field] = STATE(8612),
    [sym_lazy_field] = STATE(8612),
    [sym__qtype_function] = STATE(8981),
    [sym__qtype_linear_function] = STATE(8983),
    [sym__qtype_context] = STATE(8984),
    [sym_quantified_type] = STATE(8494),
    [sym_implicit_parameter] = STATE(8985),
    [sym__context_inline] = STATE(1729),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10934),
    [sym__splice_dollars] = STATE(7456),
    [sym_splice] = STATE(7020),
    [sym_quasiquote] = STATE(7020),
    [sym_integer] = STATE(7159),
    [sym__plist] = STATE(7124),
    [sym_unit] = STATE(7020),
    [sym_unboxed_unit] = STATE(7020),
    [sym_prefix_tuple] = STATE(7020),
    [sym_prefix_unboxed_tuple] = STATE(7020),
    [sym_prefix_unboxed_sum] = STATE(7020),
    [sym_literal] = STATE(7020),
    [sym__qualified_type] = STATE(7160),
    [sym__qtyconid] = STATE(7122),
    [sym__tycon_arrow] = STATE(7122),
    [sym__qtycon_arrow] = STATE(7122),
    [sym__promoted_tycons_alias] = STATE(7020),
    [sym__promoted_tycons] = STATE(7020),
    [sym__varsym_prefix] = STATE(7122),
    [sym__pvarsym] = STATE(7122),
    [sym__qvarsym_prefix] = STATE(7122),
    [sym__pqvarsym] = STATE(7122),
    [sym__consym_prefix] = STATE(7122),
    [sym__pconsym] = STATE(7122),
    [sym__qconsym_prefix] = STATE(7122),
    [sym__pqconsym] = STATE(7122),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(473),
    [sym__bracket_open] = STATE(1082),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = ACTIONS(2781),
    [anon_sym__] = ACTIONS(2783),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [anon_sym_STAR] = ACTIONS(2789),
    [anon_sym_u2605] = ACTIONS(2789),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2791),
    [sym_char] = ACTIONS(2791),
    [sym_string] = ACTIONS(2791),
    [sym__integer_literal] = ACTIONS(2793),
    [sym__binary_literal] = ACTIONS(2795),
    [sym__octal_literal] = ACTIONS(2795),
    [sym__hex_literal] = ACTIONS(2795),
    [sym_implicit_variable] = ACTIONS(3435),
    [sym_name] = ACTIONS(3437),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2799),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1681] = {
    [sym__type_parens] = STATE(7152),
    [sym__type_tuple] = STATE(7138),
    [sym__type_unboxed_tuple] = STATE(7137),
    [sym__type_unboxed_sum] = STATE(7135),
    [sym__type_list] = STATE(7133),
    [sym__type_promoted] = STATE(7020),
    [sym__type_star] = STATE(7020),
    [sym__type_wildcard] = STATE(7020),
    [sym__type_apply] = STATE(7132),
    [sym__type_infix] = STATE(7130),
    [sym_type] = STATE(938),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10217),
    [sym__qtype_forall] = STATE(8973),
    [sym__qtype_forall_required] = STATE(9051),
    [sym_strict_field] = STATE(8612),
    [sym_lazy_field] = STATE(8612),
    [sym__qtype_function] = STATE(8981),
    [sym__qtype_linear_function] = STATE(8983),
    [sym__qtype_context] = STATE(8984),
    [sym_quantified_type] = STATE(8490),
    [sym_implicit_parameter] = STATE(8985),
    [sym__context_inline] = STATE(1729),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10934),
    [sym__splice_dollars] = STATE(7456),
    [sym_splice] = STATE(7020),
    [sym_quasiquote] = STATE(7020),
    [sym_integer] = STATE(7159),
    [sym__plist] = STATE(7124),
    [sym_unit] = STATE(7020),
    [sym_unboxed_unit] = STATE(7020),
    [sym_prefix_tuple] = STATE(7020),
    [sym_prefix_unboxed_tuple] = STATE(7020),
    [sym_prefix_unboxed_sum] = STATE(7020),
    [sym_literal] = STATE(7020),
    [sym__qualified_type] = STATE(7160),
    [sym__qtyconid] = STATE(7122),
    [sym__tycon_arrow] = STATE(7122),
    [sym__qtycon_arrow] = STATE(7122),
    [sym__promoted_tycons_alias] = STATE(7020),
    [sym__promoted_tycons] = STATE(7020),
    [sym__varsym_prefix] = STATE(7122),
    [sym__pvarsym] = STATE(7122),
    [sym__qvarsym_prefix] = STATE(7122),
    [sym__pqvarsym] = STATE(7122),
    [sym__consym_prefix] = STATE(7122),
    [sym__pconsym] = STATE(7122),
    [sym__qconsym_prefix] = STATE(7122),
    [sym__pqconsym] = STATE(7122),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(473),
    [sym__bracket_open] = STATE(1082),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = ACTIONS(2781),
    [anon_sym__] = ACTIONS(2783),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [anon_sym_STAR] = ACTIONS(2789),
    [anon_sym_u2605] = ACTIONS(2789),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2791),
    [sym_char] = ACTIONS(2791),
    [sym_string] = ACTIONS(2791),
    [sym__integer_literal] = ACTIONS(2793),
    [sym__binary_literal] = ACTIONS(2795),
    [sym__octal_literal] = ACTIONS(2795),
    [sym__hex_literal] = ACTIONS(2795),
    [sym_implicit_variable] = ACTIONS(3435),
    [sym_name] = ACTIONS(3437),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2799),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1682] = {
    [sym__type_parens] = STATE(7152),
    [sym__type_tuple] = STATE(7138),
    [sym__type_unboxed_tuple] = STATE(7137),
    [sym__type_unboxed_sum] = STATE(7135),
    [sym__type_list] = STATE(7133),
    [sym__type_promoted] = STATE(7020),
    [sym__type_star] = STATE(7020),
    [sym__type_wildcard] = STATE(7020),
    [sym__type_apply] = STATE(7132),
    [sym__type_infix] = STATE(7130),
    [sym_type] = STATE(938),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10217),
    [sym__qtype_forall] = STATE(8973),
    [sym__qtype_forall_required] = STATE(9051),
    [sym_strict_field] = STATE(8612),
    [sym_lazy_field] = STATE(8612),
    [sym__qtype_function] = STATE(8981),
    [sym__qtype_linear_function] = STATE(8983),
    [sym__qtype_context] = STATE(8984),
    [sym_quantified_type] = STATE(8488),
    [sym_implicit_parameter] = STATE(8985),
    [sym__context_inline] = STATE(1729),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10934),
    [sym__splice_dollars] = STATE(7456),
    [sym_splice] = STATE(7020),
    [sym_quasiquote] = STATE(7020),
    [sym_integer] = STATE(7159),
    [sym__plist] = STATE(7124),
    [sym_unit] = STATE(7020),
    [sym_unboxed_unit] = STATE(7020),
    [sym_prefix_tuple] = STATE(7020),
    [sym_prefix_unboxed_tuple] = STATE(7020),
    [sym_prefix_unboxed_sum] = STATE(7020),
    [sym_literal] = STATE(7020),
    [sym__qualified_type] = STATE(7160),
    [sym__qtyconid] = STATE(7122),
    [sym__tycon_arrow] = STATE(7122),
    [sym__qtycon_arrow] = STATE(7122),
    [sym__promoted_tycons_alias] = STATE(7020),
    [sym__promoted_tycons] = STATE(7020),
    [sym__varsym_prefix] = STATE(7122),
    [sym__pvarsym] = STATE(7122),
    [sym__qvarsym_prefix] = STATE(7122),
    [sym__pqvarsym] = STATE(7122),
    [sym__consym_prefix] = STATE(7122),
    [sym__pconsym] = STATE(7122),
    [sym__qconsym_prefix] = STATE(7122),
    [sym__pqconsym] = STATE(7122),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(473),
    [sym__bracket_open] = STATE(1082),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = ACTIONS(2781),
    [anon_sym__] = ACTIONS(2783),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [anon_sym_STAR] = ACTIONS(2789),
    [anon_sym_u2605] = ACTIONS(2789),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2791),
    [sym_char] = ACTIONS(2791),
    [sym_string] = ACTIONS(2791),
    [sym__integer_literal] = ACTIONS(2793),
    [sym__binary_literal] = ACTIONS(2795),
    [sym__octal_literal] = ACTIONS(2795),
    [sym__hex_literal] = ACTIONS(2795),
    [sym_implicit_variable] = ACTIONS(3435),
    [sym_name] = ACTIONS(3437),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2799),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1683] = {
    [sym__type_parens] = STATE(2335),
    [sym__type_tuple] = STATE(2337),
    [sym__type_unboxed_tuple] = STATE(2338),
    [sym__type_unboxed_sum] = STATE(2341),
    [sym__type_list] = STATE(2342),
    [sym__type_promoted] = STATE(2327),
    [sym__type_star] = STATE(2327),
    [sym__type_wildcard] = STATE(2327),
    [sym__type_apply] = STATE(2353),
    [sym__type_infix] = STATE(2352),
    [sym_type] = STATE(327),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10117),
    [sym__qtype_forall] = STATE(2381),
    [sym__qtype_forall_required] = STATE(2383),
    [sym_strict_field] = STATE(8708),
    [sym_lazy_field] = STATE(8708),
    [sym__qtype_function] = STATE(2386),
    [sym__qtype_linear_function] = STATE(2387),
    [sym__qtype_context] = STATE(2390),
    [sym_quantified_type] = STATE(2225),
    [sym_implicit_parameter] = STATE(2391),
    [sym__context_inline] = STATE(1664),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11256),
    [sym__splice_dollars] = STATE(7396),
    [sym_splice] = STATE(2327),
    [sym_quasiquote] = STATE(2327),
    [sym_integer] = STATE(2318),
    [sym__plist] = STATE(2350),
    [sym_unit] = STATE(2327),
    [sym_unboxed_unit] = STATE(2327),
    [sym_prefix_tuple] = STATE(2327),
    [sym_prefix_unboxed_tuple] = STATE(2327),
    [sym_prefix_unboxed_sum] = STATE(2327),
    [sym_literal] = STATE(2327),
    [sym__qualified_type] = STATE(2343),
    [sym__qtyconid] = STATE(2348),
    [sym__tycon_arrow] = STATE(2348),
    [sym__qtycon_arrow] = STATE(2348),
    [sym__promoted_tycons_alias] = STATE(2327),
    [sym__promoted_tycons] = STATE(2327),
    [sym__varsym_prefix] = STATE(2348),
    [sym__pvarsym] = STATE(2348),
    [sym__qvarsym_prefix] = STATE(2348),
    [sym__pqvarsym] = STATE(2348),
    [sym__consym_prefix] = STATE(2348),
    [sym__pconsym] = STATE(2348),
    [sym__qconsym_prefix] = STATE(2348),
    [sym__pqconsym] = STATE(2348),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(445),
    [sym__bracket_open] = STATE(1047),
    [sym__unboxed_open] = STATE(740),
    [sym_variable] = ACTIONS(1121),
    [anon_sym__] = ACTIONS(1127),
    [anon_sym_SQUOTE] = ACTIONS(3317),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_u2605] = ACTIONS(1133),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1139),
    [sym_char] = ACTIONS(1139),
    [sym_string] = ACTIONS(1139),
    [sym__integer_literal] = ACTIONS(1141),
    [sym__binary_literal] = ACTIONS(1143),
    [sym__octal_literal] = ACTIONS(1143),
    [sym__hex_literal] = ACTIONS(1143),
    [sym_implicit_variable] = ACTIONS(3319),
    [sym_name] = ACTIONS(3321),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1153),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1684] = {
    [sym__type_parens] = STATE(7152),
    [sym__type_tuple] = STATE(7138),
    [sym__type_unboxed_tuple] = STATE(7137),
    [sym__type_unboxed_sum] = STATE(7135),
    [sym__type_list] = STATE(7133),
    [sym__type_promoted] = STATE(7020),
    [sym__type_star] = STATE(7020),
    [sym__type_wildcard] = STATE(7020),
    [sym__type_apply] = STATE(7132),
    [sym__type_infix] = STATE(7130),
    [sym_type] = STATE(938),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10217),
    [sym__qtype_forall] = STATE(8973),
    [sym__qtype_forall_required] = STATE(9051),
    [sym_strict_field] = STATE(8612),
    [sym_lazy_field] = STATE(8612),
    [sym__qtype_function] = STATE(8981),
    [sym__qtype_linear_function] = STATE(8983),
    [sym__qtype_context] = STATE(8984),
    [sym_quantified_type] = STATE(8487),
    [sym_implicit_parameter] = STATE(8985),
    [sym__context_inline] = STATE(1729),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10934),
    [sym__splice_dollars] = STATE(7456),
    [sym_splice] = STATE(7020),
    [sym_quasiquote] = STATE(7020),
    [sym_integer] = STATE(7159),
    [sym__plist] = STATE(7124),
    [sym_unit] = STATE(7020),
    [sym_unboxed_unit] = STATE(7020),
    [sym_prefix_tuple] = STATE(7020),
    [sym_prefix_unboxed_tuple] = STATE(7020),
    [sym_prefix_unboxed_sum] = STATE(7020),
    [sym_literal] = STATE(7020),
    [sym__qualified_type] = STATE(7160),
    [sym__qtyconid] = STATE(7122),
    [sym__tycon_arrow] = STATE(7122),
    [sym__qtycon_arrow] = STATE(7122),
    [sym__promoted_tycons_alias] = STATE(7020),
    [sym__promoted_tycons] = STATE(7020),
    [sym__varsym_prefix] = STATE(7122),
    [sym__pvarsym] = STATE(7122),
    [sym__qvarsym_prefix] = STATE(7122),
    [sym__pqvarsym] = STATE(7122),
    [sym__consym_prefix] = STATE(7122),
    [sym__pconsym] = STATE(7122),
    [sym__qconsym_prefix] = STATE(7122),
    [sym__pqconsym] = STATE(7122),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(473),
    [sym__bracket_open] = STATE(1082),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = ACTIONS(2781),
    [anon_sym__] = ACTIONS(2783),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [anon_sym_STAR] = ACTIONS(2789),
    [anon_sym_u2605] = ACTIONS(2789),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2791),
    [sym_char] = ACTIONS(2791),
    [sym_string] = ACTIONS(2791),
    [sym__integer_literal] = ACTIONS(2793),
    [sym__binary_literal] = ACTIONS(2795),
    [sym__octal_literal] = ACTIONS(2795),
    [sym__hex_literal] = ACTIONS(2795),
    [sym_implicit_variable] = ACTIONS(3435),
    [sym_name] = ACTIONS(3437),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2799),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1685] = {
    [sym__type_parens] = STATE(3579),
    [sym__type_tuple] = STATE(3576),
    [sym__type_unboxed_tuple] = STATE(3572),
    [sym__type_unboxed_sum] = STATE(3570),
    [sym__type_list] = STATE(3569),
    [sym__type_promoted] = STATE(3582),
    [sym__type_star] = STATE(3582),
    [sym__type_wildcard] = STATE(3582),
    [sym__type_apply] = STATE(3567),
    [sym__type_infix] = STATE(3561),
    [sym_type] = STATE(511),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10109),
    [sym__qtype_forall] = STATE(3889),
    [sym__qtype_forall_required] = STATE(3901),
    [sym_strict_field] = STATE(8615),
    [sym_lazy_field] = STATE(8615),
    [sym__qtype_function] = STATE(3902),
    [sym__qtype_linear_function] = STATE(3905),
    [sym__qtype_context] = STATE(3909),
    [sym_quantified_type] = STATE(3048),
    [sym_implicit_parameter] = STATE(3910),
    [sym__context_inline] = STATE(1708),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11208),
    [sym__splice_dollars] = STATE(7292),
    [sym_splice] = STATE(3582),
    [sym_quasiquote] = STATE(3582),
    [sym_integer] = STATE(3435),
    [sym__plist] = STATE(3559),
    [sym_unit] = STATE(3582),
    [sym_unboxed_unit] = STATE(3582),
    [sym_prefix_tuple] = STATE(3582),
    [sym_prefix_unboxed_tuple] = STATE(3582),
    [sym_prefix_unboxed_sum] = STATE(3582),
    [sym_literal] = STATE(3582),
    [sym__qualified_type] = STATE(3610),
    [sym__qtyconid] = STATE(3556),
    [sym__tycon_arrow] = STATE(3556),
    [sym__qtycon_arrow] = STATE(3556),
    [sym__promoted_tycons_alias] = STATE(3582),
    [sym__promoted_tycons] = STATE(3582),
    [sym__varsym_prefix] = STATE(3556),
    [sym__pvarsym] = STATE(3556),
    [sym__qvarsym_prefix] = STATE(3556),
    [sym__pqvarsym] = STATE(3556),
    [sym__consym_prefix] = STATE(3556),
    [sym__pconsym] = STATE(3556),
    [sym__qconsym_prefix] = STATE(3556),
    [sym__pqconsym] = STATE(3556),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(465),
    [sym__bracket_open] = STATE(1069),
    [sym__unboxed_open] = STATE(772),
    [sym_variable] = ACTIONS(1649),
    [anon_sym__] = ACTIONS(1651),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_u2605] = ACTIONS(1657),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1659),
    [sym_char] = ACTIONS(1659),
    [sym_string] = ACTIONS(1659),
    [sym__integer_literal] = ACTIONS(1661),
    [sym__binary_literal] = ACTIONS(1663),
    [sym__octal_literal] = ACTIONS(1663),
    [sym__hex_literal] = ACTIONS(1663),
    [sym_implicit_variable] = ACTIONS(3359),
    [sym_name] = ACTIONS(3361),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1667),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1686] = {
    [sym__type_parens] = STATE(7152),
    [sym__type_tuple] = STATE(7138),
    [sym__type_unboxed_tuple] = STATE(7137),
    [sym__type_unboxed_sum] = STATE(7135),
    [sym__type_list] = STATE(7133),
    [sym__type_promoted] = STATE(7020),
    [sym__type_star] = STATE(7020),
    [sym__type_wildcard] = STATE(7020),
    [sym__type_apply] = STATE(7132),
    [sym__type_infix] = STATE(7130),
    [sym_type] = STATE(938),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10217),
    [sym__qtype_forall] = STATE(8973),
    [sym__qtype_forall_required] = STATE(9051),
    [sym_strict_field] = STATE(8612),
    [sym_lazy_field] = STATE(8612),
    [sym__qtype_function] = STATE(8981),
    [sym__qtype_linear_function] = STATE(8983),
    [sym__qtype_context] = STATE(8984),
    [sym_quantified_type] = STATE(8482),
    [sym_implicit_parameter] = STATE(8985),
    [sym__context_inline] = STATE(1729),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10934),
    [sym__splice_dollars] = STATE(7456),
    [sym_splice] = STATE(7020),
    [sym_quasiquote] = STATE(7020),
    [sym_integer] = STATE(7159),
    [sym__plist] = STATE(7124),
    [sym_unit] = STATE(7020),
    [sym_unboxed_unit] = STATE(7020),
    [sym_prefix_tuple] = STATE(7020),
    [sym_prefix_unboxed_tuple] = STATE(7020),
    [sym_prefix_unboxed_sum] = STATE(7020),
    [sym_literal] = STATE(7020),
    [sym__qualified_type] = STATE(7160),
    [sym__qtyconid] = STATE(7122),
    [sym__tycon_arrow] = STATE(7122),
    [sym__qtycon_arrow] = STATE(7122),
    [sym__promoted_tycons_alias] = STATE(7020),
    [sym__promoted_tycons] = STATE(7020),
    [sym__varsym_prefix] = STATE(7122),
    [sym__pvarsym] = STATE(7122),
    [sym__qvarsym_prefix] = STATE(7122),
    [sym__pqvarsym] = STATE(7122),
    [sym__consym_prefix] = STATE(7122),
    [sym__pconsym] = STATE(7122),
    [sym__qconsym_prefix] = STATE(7122),
    [sym__pqconsym] = STATE(7122),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(473),
    [sym__bracket_open] = STATE(1082),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = ACTIONS(2781),
    [anon_sym__] = ACTIONS(2783),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [anon_sym_STAR] = ACTIONS(2789),
    [anon_sym_u2605] = ACTIONS(2789),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2791),
    [sym_char] = ACTIONS(2791),
    [sym_string] = ACTIONS(2791),
    [sym__integer_literal] = ACTIONS(2793),
    [sym__binary_literal] = ACTIONS(2795),
    [sym__octal_literal] = ACTIONS(2795),
    [sym__hex_literal] = ACTIONS(2795),
    [sym_implicit_variable] = ACTIONS(3435),
    [sym_name] = ACTIONS(3437),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2799),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1687] = {
    [sym__type_parens] = STATE(7152),
    [sym__type_tuple] = STATE(7138),
    [sym__type_unboxed_tuple] = STATE(7137),
    [sym__type_unboxed_sum] = STATE(7135),
    [sym__type_list] = STATE(7133),
    [sym__type_promoted] = STATE(7020),
    [sym__type_star] = STATE(7020),
    [sym__type_wildcard] = STATE(7020),
    [sym__type_apply] = STATE(7132),
    [sym__type_infix] = STATE(7130),
    [sym_type] = STATE(938),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10217),
    [sym__qtype_forall] = STATE(8973),
    [sym__qtype_forall_required] = STATE(9051),
    [sym_strict_field] = STATE(8612),
    [sym_lazy_field] = STATE(8612),
    [sym__qtype_function] = STATE(8981),
    [sym__qtype_linear_function] = STATE(8983),
    [sym__qtype_context] = STATE(8984),
    [sym_quantified_type] = STATE(8481),
    [sym_implicit_parameter] = STATE(8985),
    [sym__context_inline] = STATE(1729),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10934),
    [sym__splice_dollars] = STATE(7456),
    [sym_splice] = STATE(7020),
    [sym_quasiquote] = STATE(7020),
    [sym_integer] = STATE(7159),
    [sym__plist] = STATE(7124),
    [sym_unit] = STATE(7020),
    [sym_unboxed_unit] = STATE(7020),
    [sym_prefix_tuple] = STATE(7020),
    [sym_prefix_unboxed_tuple] = STATE(7020),
    [sym_prefix_unboxed_sum] = STATE(7020),
    [sym_literal] = STATE(7020),
    [sym__qualified_type] = STATE(7160),
    [sym__qtyconid] = STATE(7122),
    [sym__tycon_arrow] = STATE(7122),
    [sym__qtycon_arrow] = STATE(7122),
    [sym__promoted_tycons_alias] = STATE(7020),
    [sym__promoted_tycons] = STATE(7020),
    [sym__varsym_prefix] = STATE(7122),
    [sym__pvarsym] = STATE(7122),
    [sym__qvarsym_prefix] = STATE(7122),
    [sym__pqvarsym] = STATE(7122),
    [sym__consym_prefix] = STATE(7122),
    [sym__pconsym] = STATE(7122),
    [sym__qconsym_prefix] = STATE(7122),
    [sym__pqconsym] = STATE(7122),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(473),
    [sym__bracket_open] = STATE(1082),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = ACTIONS(2781),
    [anon_sym__] = ACTIONS(2783),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [anon_sym_STAR] = ACTIONS(2789),
    [anon_sym_u2605] = ACTIONS(2789),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2791),
    [sym_char] = ACTIONS(2791),
    [sym_string] = ACTIONS(2791),
    [sym__integer_literal] = ACTIONS(2793),
    [sym__binary_literal] = ACTIONS(2795),
    [sym__octal_literal] = ACTIONS(2795),
    [sym__hex_literal] = ACTIONS(2795),
    [sym_implicit_variable] = ACTIONS(3435),
    [sym_name] = ACTIONS(3437),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2799),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1688] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8310),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1689] = {
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(296),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__paren_open] = STATE(405),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1690] = {
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(312),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__paren_open] = STATE(405),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1691] = {
    [sym__exp_th_quoted_name] = STATE(5106),
    [sym__exp_parens] = STATE(5110),
    [sym__exp_tuple] = STATE(5119),
    [sym__exp_unboxed_tuple] = STATE(5120),
    [sym__exp_unboxed_sum] = STATE(5121),
    [sym__exp_list] = STATE(5122),
    [sym__exp_arithmetic_sequence] = STATE(5123),
    [sym__exp_list_comprehension] = STATE(5124),
    [sym__exp_lambda] = STATE(5125),
    [sym__exp_let_in] = STATE(5126),
    [sym__exp_conditional] = STATE(5129),
    [sym__do_keyword] = STATE(10937),
    [sym_do_module] = STATE(10937),
    [sym__do] = STATE(10937),
    [sym__exp_do] = STATE(5130),
    [sym__exp_case] = STATE(5131),
    [sym__exp_lambda_case] = STATE(5132),
    [sym__exp_lambda_cases] = STATE(5133),
    [sym__exp_multi_way_if] = STATE(5134),
    [sym__exp_record] = STATE(5136),
    [sym__exp_projection_selector] = STATE(5137),
    [sym__exp_projection] = STATE(5138),
    [sym__exp_apply] = STATE(5139),
    [sym__exp_section_left] = STATE(5140),
    [sym__exp_section_right] = STATE(5141),
    [sym__exp_negation] = STATE(5142),
    [sym__exp_infix] = STATE(5143),
    [sym_expression] = STATE(314),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9260),
    [sym__splice_dollars] = STATE(7227),
    [sym_splice] = STATE(5148),
    [sym_quasiquote] = STATE(5148),
    [sym__exp_quote] = STATE(5144),
    [sym__exp_typed_quote] = STATE(5148),
    [sym_integer] = STATE(4366),
    [sym__plist] = STATE(5447),
    [sym_unit] = STATE(5148),
    [sym_unboxed_unit] = STATE(5148),
    [sym_prefix_tuple] = STATE(5148),
    [sym_prefix_unboxed_tuple] = STATE(5148),
    [sym_prefix_unboxed_sum] = STATE(5148),
    [sym_literal] = STATE(5148),
    [sym__qualified_variable] = STATE(4313),
    [sym__qvarid] = STATE(5148),
    [sym__qvar] = STATE(5148),
    [sym__qualified_constructor] = STATE(4378),
    [sym__qconid] = STATE(5148),
    [sym__varsym_prefix] = STATE(5148),
    [sym__pvarsym] = STATE(5148),
    [sym__qvarsym_prefix] = STATE(5148),
    [sym__pqvarsym] = STATE(5148),
    [sym__consym_prefix] = STATE(5448),
    [sym__pconsym] = STATE(5448),
    [sym__qconsym_prefix] = STATE(5148),
    [sym__pqconsym] = STATE(5148),
    [sym__paren_open] = STATE(405),
    [sym__bracket_open] = STATE(1081),
    [sym__unboxed_open] = STATE(828),
    [sym_variable] = ACTIONS(1037),
    [anon_sym_let] = ACTIONS(15),
    [anon_sym_SQUOTE] = ACTIONS(19),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_mdo] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(59),
    [sym_float] = ACTIONS(1043),
    [sym_char] = ACTIONS(1043),
    [sym_string] = ACTIONS(1043),
    [sym__integer_literal] = ACTIONS(1045),
    [sym__binary_literal] = ACTIONS(1047),
    [sym__octal_literal] = ACTIONS(1047),
    [sym__hex_literal] = ACTIONS(1047),
    [sym_implicit_variable] = ACTIONS(71),
    [sym_name] = ACTIONS(1049),
    [sym_label] = ACTIONS(71),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1053),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1692] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(319),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1693] = {
    [sym__type_parens] = STATE(6282),
    [sym__type_tuple] = STATE(6281),
    [sym__type_unboxed_tuple] = STATE(6280),
    [sym__type_unboxed_sum] = STATE(6279),
    [sym__type_list] = STATE(6278),
    [sym__type_promoted] = STATE(6283),
    [sym__type_star] = STATE(6283),
    [sym__type_wildcard] = STATE(6283),
    [sym__type_apply] = STATE(6277),
    [sym__type_infix] = STATE(6276),
    [sym_type] = STATE(822),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10113),
    [sym__qtype_forall] = STATE(8644),
    [sym__qtype_forall_required] = STATE(8640),
    [sym_strict_field] = STATE(8714),
    [sym_lazy_field] = STATE(8714),
    [sym__qtype_function] = STATE(8638),
    [sym__qtype_linear_function] = STATE(8635),
    [sym__qtype_context] = STATE(8633),
    [sym_quantified_type] = STATE(8221),
    [sym_implicit_parameter] = STATE(8632),
    [sym__context_inline] = STATE(1693),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11228),
    [sym__splice_dollars] = STATE(7421),
    [sym_splice] = STATE(6283),
    [sym_quasiquote] = STATE(6283),
    [sym_integer] = STATE(6535),
    [sym__plist] = STATE(6275),
    [sym_unit] = STATE(6283),
    [sym_unboxed_unit] = STATE(6283),
    [sym_prefix_tuple] = STATE(6283),
    [sym_prefix_unboxed_tuple] = STATE(6283),
    [sym_prefix_unboxed_sum] = STATE(6283),
    [sym_literal] = STATE(6283),
    [sym__qualified_type] = STATE(6310),
    [sym__qtyconid] = STATE(6273),
    [sym__tycon_arrow] = STATE(6273),
    [sym__qtycon_arrow] = STATE(6273),
    [sym__promoted_tycons_alias] = STATE(6283),
    [sym__promoted_tycons] = STATE(6283),
    [sym__varsym_prefix] = STATE(6273),
    [sym__pvarsym] = STATE(6273),
    [sym__qvarsym_prefix] = STATE(6273),
    [sym__pqvarsym] = STATE(6273),
    [sym__consym_prefix] = STATE(6273),
    [sym__pconsym] = STATE(6273),
    [sym__qconsym_prefix] = STATE(6273),
    [sym__pqconsym] = STATE(6273),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(429),
    [sym__bracket_open] = STATE(1061),
    [sym__unboxed_open] = STATE(755),
    [sym_variable] = ACTIONS(2305),
    [anon_sym__] = ACTIONS(2307),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(2313),
    [anon_sym_u2605] = ACTIONS(2313),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym__integer_literal] = ACTIONS(2317),
    [sym__binary_literal] = ACTIONS(2319),
    [sym__octal_literal] = ACTIONS(2319),
    [sym__hex_literal] = ACTIONS(2319),
    [sym_implicit_variable] = ACTIONS(3447),
    [sym_name] = ACTIONS(3449),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2323),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1694] = {
    [sym__type_parens] = STATE(3111),
    [sym__type_tuple] = STATE(3091),
    [sym__type_unboxed_tuple] = STATE(3092),
    [sym__type_unboxed_sum] = STATE(3095),
    [sym__type_list] = STATE(3100),
    [sym__type_promoted] = STATE(3123),
    [sym__type_star] = STATE(3123),
    [sym__type_wildcard] = STATE(3123),
    [sym__type_apply] = STATE(3099),
    [sym__type_infix] = STATE(3084),
    [sym_type] = STATE(425),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10091),
    [sym__qtype_forall] = STATE(3390),
    [sym__qtype_forall_required] = STATE(3387),
    [sym_strict_field] = STATE(8703),
    [sym_lazy_field] = STATE(8703),
    [sym__qtype_function] = STATE(3381),
    [sym__qtype_linear_function] = STATE(3374),
    [sym__qtype_context] = STATE(3366),
    [sym_quantified_type] = STATE(2468),
    [sym_implicit_parameter] = STATE(3363),
    [sym__context_inline] = STATE(1553),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11161),
    [sym__splice_dollars] = STATE(7411),
    [sym_splice] = STATE(3123),
    [sym_quasiquote] = STATE(3123),
    [sym_integer] = STATE(3118),
    [sym__plist] = STATE(3082),
    [sym_unit] = STATE(3123),
    [sym_unboxed_unit] = STATE(3123),
    [sym_prefix_tuple] = STATE(3123),
    [sym_prefix_unboxed_tuple] = STATE(3123),
    [sym_prefix_unboxed_sum] = STATE(3123),
    [sym_literal] = STATE(3123),
    [sym__qualified_type] = STATE(3083),
    [sym__qtyconid] = STATE(3071),
    [sym__tycon_arrow] = STATE(3071),
    [sym__qtycon_arrow] = STATE(3071),
    [sym__promoted_tycons_alias] = STATE(3123),
    [sym__promoted_tycons] = STATE(3123),
    [sym__varsym_prefix] = STATE(3071),
    [sym__pvarsym] = STATE(3071),
    [sym__qvarsym_prefix] = STATE(3071),
    [sym__pqvarsym] = STATE(3071),
    [sym__consym_prefix] = STATE(3071),
    [sym__pconsym] = STATE(3071),
    [sym__qconsym_prefix] = STATE(3071),
    [sym__pqconsym] = STATE(3071),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(441),
    [sym__bracket_open] = STATE(1101),
    [sym__unboxed_open] = STATE(764),
    [sym_variable] = ACTIONS(1343),
    [anon_sym__] = ACTIONS(1345),
    [anon_sym_SQUOTE] = ACTIONS(3333),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_u2605] = ACTIONS(1351),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1353),
    [sym_char] = ACTIONS(1353),
    [sym_string] = ACTIONS(1353),
    [sym__integer_literal] = ACTIONS(1355),
    [sym__binary_literal] = ACTIONS(1357),
    [sym__octal_literal] = ACTIONS(1357),
    [sym__hex_literal] = ACTIONS(1357),
    [sym_implicit_variable] = ACTIONS(3335),
    [sym_name] = ACTIONS(3337),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1361),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1695] = {
    [sym__type_parens] = STATE(2335),
    [sym__type_tuple] = STATE(2337),
    [sym__type_unboxed_tuple] = STATE(2338),
    [sym__type_unboxed_sum] = STATE(2341),
    [sym__type_list] = STATE(2342),
    [sym__type_promoted] = STATE(2327),
    [sym__type_star] = STATE(2327),
    [sym__type_wildcard] = STATE(2327),
    [sym__type_apply] = STATE(2353),
    [sym__type_infix] = STATE(2352),
    [sym_type] = STATE(327),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10117),
    [sym__qtype_forall] = STATE(2381),
    [sym__qtype_forall_required] = STATE(2383),
    [sym_strict_field] = STATE(8708),
    [sym_lazy_field] = STATE(8708),
    [sym__qtype_function] = STATE(2386),
    [sym__qtype_linear_function] = STATE(2387),
    [sym__qtype_context] = STATE(2390),
    [sym_quantified_type] = STATE(2228),
    [sym_implicit_parameter] = STATE(2391),
    [sym__context_inline] = STATE(1664),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11256),
    [sym__splice_dollars] = STATE(7396),
    [sym_splice] = STATE(2327),
    [sym_quasiquote] = STATE(2327),
    [sym_integer] = STATE(2318),
    [sym__plist] = STATE(2350),
    [sym_unit] = STATE(2327),
    [sym_unboxed_unit] = STATE(2327),
    [sym_prefix_tuple] = STATE(2327),
    [sym_prefix_unboxed_tuple] = STATE(2327),
    [sym_prefix_unboxed_sum] = STATE(2327),
    [sym_literal] = STATE(2327),
    [sym__qualified_type] = STATE(2343),
    [sym__qtyconid] = STATE(2348),
    [sym__tycon_arrow] = STATE(2348),
    [sym__qtycon_arrow] = STATE(2348),
    [sym__promoted_tycons_alias] = STATE(2327),
    [sym__promoted_tycons] = STATE(2327),
    [sym__varsym_prefix] = STATE(2348),
    [sym__pvarsym] = STATE(2348),
    [sym__qvarsym_prefix] = STATE(2348),
    [sym__pqvarsym] = STATE(2348),
    [sym__consym_prefix] = STATE(2348),
    [sym__pconsym] = STATE(2348),
    [sym__qconsym_prefix] = STATE(2348),
    [sym__pqconsym] = STATE(2348),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(445),
    [sym__bracket_open] = STATE(1047),
    [sym__unboxed_open] = STATE(740),
    [sym_variable] = ACTIONS(1121),
    [anon_sym__] = ACTIONS(1127),
    [anon_sym_SQUOTE] = ACTIONS(3317),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_u2605] = ACTIONS(1133),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1139),
    [sym_char] = ACTIONS(1139),
    [sym_string] = ACTIONS(1139),
    [sym__integer_literal] = ACTIONS(1141),
    [sym__binary_literal] = ACTIONS(1143),
    [sym__octal_literal] = ACTIONS(1143),
    [sym__hex_literal] = ACTIONS(1143),
    [sym_implicit_variable] = ACTIONS(3319),
    [sym_name] = ACTIONS(3321),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1153),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1696] = {
    [sym__type_parens] = STATE(6282),
    [sym__type_tuple] = STATE(6281),
    [sym__type_unboxed_tuple] = STATE(6280),
    [sym__type_unboxed_sum] = STATE(6279),
    [sym__type_list] = STATE(6278),
    [sym__type_promoted] = STATE(6283),
    [sym__type_star] = STATE(6283),
    [sym__type_wildcard] = STATE(6283),
    [sym__type_apply] = STATE(6277),
    [sym__type_infix] = STATE(6276),
    [sym_type] = STATE(822),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10113),
    [sym__qtype_forall] = STATE(8644),
    [sym__qtype_forall_required] = STATE(8640),
    [sym_strict_field] = STATE(8714),
    [sym_lazy_field] = STATE(8714),
    [sym__qtype_function] = STATE(8638),
    [sym__qtype_linear_function] = STATE(8635),
    [sym__qtype_context] = STATE(8633),
    [sym_quantified_type] = STATE(8247),
    [sym_implicit_parameter] = STATE(8632),
    [sym__context_inline] = STATE(1693),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11228),
    [sym__splice_dollars] = STATE(7421),
    [sym_splice] = STATE(6283),
    [sym_quasiquote] = STATE(6283),
    [sym_integer] = STATE(6535),
    [sym__plist] = STATE(6275),
    [sym_unit] = STATE(6283),
    [sym_unboxed_unit] = STATE(6283),
    [sym_prefix_tuple] = STATE(6283),
    [sym_prefix_unboxed_tuple] = STATE(6283),
    [sym_prefix_unboxed_sum] = STATE(6283),
    [sym_literal] = STATE(6283),
    [sym__qualified_type] = STATE(6310),
    [sym__qtyconid] = STATE(6273),
    [sym__tycon_arrow] = STATE(6273),
    [sym__qtycon_arrow] = STATE(6273),
    [sym__promoted_tycons_alias] = STATE(6283),
    [sym__promoted_tycons] = STATE(6283),
    [sym__varsym_prefix] = STATE(6273),
    [sym__pvarsym] = STATE(6273),
    [sym__qvarsym_prefix] = STATE(6273),
    [sym__pqvarsym] = STATE(6273),
    [sym__consym_prefix] = STATE(6273),
    [sym__pconsym] = STATE(6273),
    [sym__qconsym_prefix] = STATE(6273),
    [sym__pqconsym] = STATE(6273),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(429),
    [sym__bracket_open] = STATE(1061),
    [sym__unboxed_open] = STATE(755),
    [sym_variable] = ACTIONS(2305),
    [anon_sym__] = ACTIONS(2307),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(2313),
    [anon_sym_u2605] = ACTIONS(2313),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym__integer_literal] = ACTIONS(2317),
    [sym__binary_literal] = ACTIONS(2319),
    [sym__octal_literal] = ACTIONS(2319),
    [sym__hex_literal] = ACTIONS(2319),
    [sym_implicit_variable] = ACTIONS(3447),
    [sym_name] = ACTIONS(3449),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2323),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1697] = {
    [sym__type_parens] = STATE(6282),
    [sym__type_tuple] = STATE(6281),
    [sym__type_unboxed_tuple] = STATE(6280),
    [sym__type_unboxed_sum] = STATE(6279),
    [sym__type_list] = STATE(6278),
    [sym__type_promoted] = STATE(6283),
    [sym__type_star] = STATE(6283),
    [sym__type_wildcard] = STATE(6283),
    [sym__type_apply] = STATE(6277),
    [sym__type_infix] = STATE(6276),
    [sym_type] = STATE(822),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10113),
    [sym__qtype_forall] = STATE(8644),
    [sym__qtype_forall_required] = STATE(8640),
    [sym_strict_field] = STATE(8714),
    [sym_lazy_field] = STATE(8714),
    [sym__qtype_function] = STATE(8638),
    [sym__qtype_linear_function] = STATE(8635),
    [sym__qtype_context] = STATE(8633),
    [sym_quantified_type] = STATE(8202),
    [sym_implicit_parameter] = STATE(8632),
    [sym__context_inline] = STATE(1693),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11228),
    [sym__splice_dollars] = STATE(7421),
    [sym_splice] = STATE(6283),
    [sym_quasiquote] = STATE(6283),
    [sym_integer] = STATE(6535),
    [sym__plist] = STATE(6275),
    [sym_unit] = STATE(6283),
    [sym_unboxed_unit] = STATE(6283),
    [sym_prefix_tuple] = STATE(6283),
    [sym_prefix_unboxed_tuple] = STATE(6283),
    [sym_prefix_unboxed_sum] = STATE(6283),
    [sym_literal] = STATE(6283),
    [sym__qualified_type] = STATE(6310),
    [sym__qtyconid] = STATE(6273),
    [sym__tycon_arrow] = STATE(6273),
    [sym__qtycon_arrow] = STATE(6273),
    [sym__promoted_tycons_alias] = STATE(6283),
    [sym__promoted_tycons] = STATE(6283),
    [sym__varsym_prefix] = STATE(6273),
    [sym__pvarsym] = STATE(6273),
    [sym__qvarsym_prefix] = STATE(6273),
    [sym__pqvarsym] = STATE(6273),
    [sym__consym_prefix] = STATE(6273),
    [sym__pconsym] = STATE(6273),
    [sym__qconsym_prefix] = STATE(6273),
    [sym__pqconsym] = STATE(6273),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(429),
    [sym__bracket_open] = STATE(1061),
    [sym__unboxed_open] = STATE(755),
    [sym_variable] = ACTIONS(2305),
    [anon_sym__] = ACTIONS(2307),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(2313),
    [anon_sym_u2605] = ACTIONS(2313),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym__integer_literal] = ACTIONS(2317),
    [sym__binary_literal] = ACTIONS(2319),
    [sym__octal_literal] = ACTIONS(2319),
    [sym__hex_literal] = ACTIONS(2319),
    [sym_implicit_variable] = ACTIONS(3447),
    [sym_name] = ACTIONS(3449),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2323),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1698] = {
    [sym__type_parens] = STATE(6323),
    [sym__type_tuple] = STATE(6324),
    [sym__type_unboxed_tuple] = STATE(6325),
    [sym__type_unboxed_sum] = STATE(6326),
    [sym__type_list] = STATE(6327),
    [sym__type_promoted] = STATE(6321),
    [sym__type_star] = STATE(6321),
    [sym__type_wildcard] = STATE(6321),
    [sym__type_apply] = STATE(6328),
    [sym__type_infix] = STATE(6329),
    [sym_type] = STATE(754),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10134),
    [sym__qtype_forall] = STATE(8674),
    [sym__qtype_forall_required] = STATE(8673),
    [sym_strict_field] = STATE(8650),
    [sym_lazy_field] = STATE(8650),
    [sym__qtype_function] = STATE(8647),
    [sym__qtype_linear_function] = STATE(8671),
    [sym__qtype_context] = STATE(8665),
    [sym_quantified_type] = STATE(8237),
    [sym_implicit_parameter] = STATE(8661),
    [sym__context_inline] = STATE(1567),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11328),
    [sym__splice_dollars] = STATE(7407),
    [sym_splice] = STATE(6321),
    [sym_quasiquote] = STATE(6321),
    [sym_integer] = STATE(6269),
    [sym__plist] = STATE(6330),
    [sym_unit] = STATE(6321),
    [sym_unboxed_unit] = STATE(6321),
    [sym_prefix_tuple] = STATE(6321),
    [sym_prefix_unboxed_tuple] = STATE(6321),
    [sym_prefix_unboxed_sum] = STATE(6321),
    [sym_literal] = STATE(6321),
    [sym__qualified_type] = STATE(6286),
    [sym__qtyconid] = STATE(6331),
    [sym__tycon_arrow] = STATE(6331),
    [sym__qtycon_arrow] = STATE(6331),
    [sym__promoted_tycons_alias] = STATE(6321),
    [sym__promoted_tycons] = STATE(6321),
    [sym__varsym_prefix] = STATE(6331),
    [sym__pvarsym] = STATE(6331),
    [sym__qvarsym_prefix] = STATE(6331),
    [sym__pqvarsym] = STATE(6331),
    [sym__consym_prefix] = STATE(6331),
    [sym__pconsym] = STATE(6331),
    [sym__qconsym_prefix] = STATE(6331),
    [sym__pqconsym] = STATE(6331),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(469),
    [sym__bracket_open] = STATE(990),
    [sym__unboxed_open] = STATE(810),
    [sym_variable] = ACTIONS(2155),
    [anon_sym__] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_u2605] = ACTIONS(2163),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2165),
    [sym_char] = ACTIONS(2165),
    [sym_string] = ACTIONS(2165),
    [sym__integer_literal] = ACTIONS(2167),
    [sym__binary_literal] = ACTIONS(2169),
    [sym__octal_literal] = ACTIONS(2169),
    [sym__hex_literal] = ACTIONS(2169),
    [sym_implicit_variable] = ACTIONS(3429),
    [sym_name] = ACTIONS(3431),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2173),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1699] = {
    [sym__type_parens] = STATE(6282),
    [sym__type_tuple] = STATE(6281),
    [sym__type_unboxed_tuple] = STATE(6280),
    [sym__type_unboxed_sum] = STATE(6279),
    [sym__type_list] = STATE(6278),
    [sym__type_promoted] = STATE(6283),
    [sym__type_star] = STATE(6283),
    [sym__type_wildcard] = STATE(6283),
    [sym__type_apply] = STATE(6277),
    [sym__type_infix] = STATE(6276),
    [sym_type] = STATE(822),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10113),
    [sym__qtype_forall] = STATE(8644),
    [sym__qtype_forall_required] = STATE(8640),
    [sym_strict_field] = STATE(8714),
    [sym_lazy_field] = STATE(8714),
    [sym__qtype_function] = STATE(8638),
    [sym__qtype_linear_function] = STATE(8635),
    [sym__qtype_context] = STATE(8633),
    [sym_quantified_type] = STATE(8194),
    [sym_implicit_parameter] = STATE(8632),
    [sym__context_inline] = STATE(1693),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11228),
    [sym__splice_dollars] = STATE(7421),
    [sym_splice] = STATE(6283),
    [sym_quasiquote] = STATE(6283),
    [sym_integer] = STATE(6535),
    [sym__plist] = STATE(6275),
    [sym_unit] = STATE(6283),
    [sym_unboxed_unit] = STATE(6283),
    [sym_prefix_tuple] = STATE(6283),
    [sym_prefix_unboxed_tuple] = STATE(6283),
    [sym_prefix_unboxed_sum] = STATE(6283),
    [sym_literal] = STATE(6283),
    [sym__qualified_type] = STATE(6310),
    [sym__qtyconid] = STATE(6273),
    [sym__tycon_arrow] = STATE(6273),
    [sym__qtycon_arrow] = STATE(6273),
    [sym__promoted_tycons_alias] = STATE(6283),
    [sym__promoted_tycons] = STATE(6283),
    [sym__varsym_prefix] = STATE(6273),
    [sym__pvarsym] = STATE(6273),
    [sym__qvarsym_prefix] = STATE(6273),
    [sym__pqvarsym] = STATE(6273),
    [sym__consym_prefix] = STATE(6273),
    [sym__pconsym] = STATE(6273),
    [sym__qconsym_prefix] = STATE(6273),
    [sym__pqconsym] = STATE(6273),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(429),
    [sym__bracket_open] = STATE(1061),
    [sym__unboxed_open] = STATE(755),
    [sym_variable] = ACTIONS(2305),
    [anon_sym__] = ACTIONS(2307),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(2313),
    [anon_sym_u2605] = ACTIONS(2313),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym__integer_literal] = ACTIONS(2317),
    [sym__binary_literal] = ACTIONS(2319),
    [sym__octal_literal] = ACTIONS(2319),
    [sym__hex_literal] = ACTIONS(2319),
    [sym_implicit_variable] = ACTIONS(3447),
    [sym_name] = ACTIONS(3449),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2323),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1700] = {
    [sym__type_parens] = STATE(6282),
    [sym__type_tuple] = STATE(6281),
    [sym__type_unboxed_tuple] = STATE(6280),
    [sym__type_unboxed_sum] = STATE(6279),
    [sym__type_list] = STATE(6278),
    [sym__type_promoted] = STATE(6283),
    [sym__type_star] = STATE(6283),
    [sym__type_wildcard] = STATE(6283),
    [sym__type_apply] = STATE(6277),
    [sym__type_infix] = STATE(6276),
    [sym_type] = STATE(822),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10113),
    [sym__qtype_forall] = STATE(8644),
    [sym__qtype_forall_required] = STATE(8640),
    [sym_strict_field] = STATE(8714),
    [sym_lazy_field] = STATE(8714),
    [sym__qtype_function] = STATE(8638),
    [sym__qtype_linear_function] = STATE(8635),
    [sym__qtype_context] = STATE(8633),
    [sym_quantified_type] = STATE(8185),
    [sym_implicit_parameter] = STATE(8632),
    [sym__context_inline] = STATE(1693),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11228),
    [sym__splice_dollars] = STATE(7421),
    [sym_splice] = STATE(6283),
    [sym_quasiquote] = STATE(6283),
    [sym_integer] = STATE(6535),
    [sym__plist] = STATE(6275),
    [sym_unit] = STATE(6283),
    [sym_unboxed_unit] = STATE(6283),
    [sym_prefix_tuple] = STATE(6283),
    [sym_prefix_unboxed_tuple] = STATE(6283),
    [sym_prefix_unboxed_sum] = STATE(6283),
    [sym_literal] = STATE(6283),
    [sym__qualified_type] = STATE(6310),
    [sym__qtyconid] = STATE(6273),
    [sym__tycon_arrow] = STATE(6273),
    [sym__qtycon_arrow] = STATE(6273),
    [sym__promoted_tycons_alias] = STATE(6283),
    [sym__promoted_tycons] = STATE(6283),
    [sym__varsym_prefix] = STATE(6273),
    [sym__pvarsym] = STATE(6273),
    [sym__qvarsym_prefix] = STATE(6273),
    [sym__pqvarsym] = STATE(6273),
    [sym__consym_prefix] = STATE(6273),
    [sym__pconsym] = STATE(6273),
    [sym__qconsym_prefix] = STATE(6273),
    [sym__pqconsym] = STATE(6273),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(429),
    [sym__bracket_open] = STATE(1061),
    [sym__unboxed_open] = STATE(755),
    [sym_variable] = ACTIONS(2305),
    [anon_sym__] = ACTIONS(2307),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(2313),
    [anon_sym_u2605] = ACTIONS(2313),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym__integer_literal] = ACTIONS(2317),
    [sym__binary_literal] = ACTIONS(2319),
    [sym__octal_literal] = ACTIONS(2319),
    [sym__hex_literal] = ACTIONS(2319),
    [sym_implicit_variable] = ACTIONS(3447),
    [sym_name] = ACTIONS(3449),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2323),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1701] = {
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(342),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__paren_open] = STATE(400),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1702] = {
    [sym__type_parens] = STATE(6282),
    [sym__type_tuple] = STATE(6281),
    [sym__type_unboxed_tuple] = STATE(6280),
    [sym__type_unboxed_sum] = STATE(6279),
    [sym__type_list] = STATE(6278),
    [sym__type_promoted] = STATE(6283),
    [sym__type_star] = STATE(6283),
    [sym__type_wildcard] = STATE(6283),
    [sym__type_apply] = STATE(6277),
    [sym__type_infix] = STATE(6276),
    [sym_type] = STATE(822),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10113),
    [sym__qtype_forall] = STATE(8644),
    [sym__qtype_forall_required] = STATE(8640),
    [sym_strict_field] = STATE(8714),
    [sym_lazy_field] = STATE(8714),
    [sym__qtype_function] = STATE(8638),
    [sym__qtype_linear_function] = STATE(8635),
    [sym__qtype_context] = STATE(8633),
    [sym_quantified_type] = STATE(8250),
    [sym_implicit_parameter] = STATE(8632),
    [sym__context_inline] = STATE(1693),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11228),
    [sym__splice_dollars] = STATE(7421),
    [sym_splice] = STATE(6283),
    [sym_quasiquote] = STATE(6283),
    [sym_integer] = STATE(6535),
    [sym__plist] = STATE(6275),
    [sym_unit] = STATE(6283),
    [sym_unboxed_unit] = STATE(6283),
    [sym_prefix_tuple] = STATE(6283),
    [sym_prefix_unboxed_tuple] = STATE(6283),
    [sym_prefix_unboxed_sum] = STATE(6283),
    [sym_literal] = STATE(6283),
    [sym__qualified_type] = STATE(6310),
    [sym__qtyconid] = STATE(6273),
    [sym__tycon_arrow] = STATE(6273),
    [sym__qtycon_arrow] = STATE(6273),
    [sym__promoted_tycons_alias] = STATE(6283),
    [sym__promoted_tycons] = STATE(6283),
    [sym__varsym_prefix] = STATE(6273),
    [sym__pvarsym] = STATE(6273),
    [sym__qvarsym_prefix] = STATE(6273),
    [sym__pqvarsym] = STATE(6273),
    [sym__consym_prefix] = STATE(6273),
    [sym__pconsym] = STATE(6273),
    [sym__qconsym_prefix] = STATE(6273),
    [sym__pqconsym] = STATE(6273),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(429),
    [sym__bracket_open] = STATE(1061),
    [sym__unboxed_open] = STATE(755),
    [sym_variable] = ACTIONS(2305),
    [anon_sym__] = ACTIONS(2307),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(2313),
    [anon_sym_u2605] = ACTIONS(2313),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym__integer_literal] = ACTIONS(2317),
    [sym__binary_literal] = ACTIONS(2319),
    [sym__octal_literal] = ACTIONS(2319),
    [sym__hex_literal] = ACTIONS(2319),
    [sym_implicit_variable] = ACTIONS(3447),
    [sym_name] = ACTIONS(3449),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2323),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1703] = {
    [sym__type_parens] = STATE(2825),
    [sym__type_tuple] = STATE(2808),
    [sym__type_unboxed_tuple] = STATE(2788),
    [sym__type_unboxed_sum] = STATE(2767),
    [sym__type_list] = STATE(2839),
    [sym__type_promoted] = STATE(2796),
    [sym__type_star] = STATE(2796),
    [sym__type_wildcard] = STATE(2796),
    [sym__type_apply] = STATE(2823),
    [sym__type_infix] = STATE(2774),
    [sym_type] = STATE(421),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10083),
    [sym__qtype_forall] = STATE(3138),
    [sym__qtype_forall_required] = STATE(3136),
    [sym_strict_field] = STATE(8681),
    [sym_lazy_field] = STATE(8681),
    [sym__qtype_function] = STATE(3135),
    [sym__qtype_linear_function] = STATE(3132),
    [sym__qtype_context] = STATE(3131),
    [sym_quantified_type] = STATE(2362),
    [sym_implicit_parameter] = STATE(3115),
    [sym__context_inline] = STATE(1721),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11145),
    [sym__splice_dollars] = STATE(7328),
    [sym_splice] = STATE(2796),
    [sym_quasiquote] = STATE(2796),
    [sym_integer] = STATE(2781),
    [sym__plist] = STATE(2777),
    [sym_unit] = STATE(2796),
    [sym_unboxed_unit] = STATE(2796),
    [sym_prefix_tuple] = STATE(2796),
    [sym_prefix_unboxed_tuple] = STATE(2796),
    [sym_prefix_unboxed_sum] = STATE(2796),
    [sym_literal] = STATE(2796),
    [sym__qualified_type] = STATE(2759),
    [sym__qtyconid] = STATE(2752),
    [sym__tycon_arrow] = STATE(2752),
    [sym__qtycon_arrow] = STATE(2752),
    [sym__promoted_tycons_alias] = STATE(2796),
    [sym__promoted_tycons] = STATE(2796),
    [sym__varsym_prefix] = STATE(2752),
    [sym__pvarsym] = STATE(2752),
    [sym__qvarsym_prefix] = STATE(2752),
    [sym__pqvarsym] = STATE(2752),
    [sym__consym_prefix] = STATE(2752),
    [sym__pconsym] = STATE(2752),
    [sym__qconsym_prefix] = STATE(2752),
    [sym__pqconsym] = STATE(2752),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(467),
    [sym__bracket_open] = STATE(1130),
    [sym__unboxed_open] = STATE(765),
    [sym_variable] = ACTIONS(1323),
    [anon_sym__] = ACTIONS(1325),
    [anon_sym_SQUOTE] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_u2605] = ACTIONS(1331),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1333),
    [sym_char] = ACTIONS(1333),
    [sym_string] = ACTIONS(1333),
    [sym__integer_literal] = ACTIONS(1335),
    [sym__binary_literal] = ACTIONS(1337),
    [sym__octal_literal] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1337),
    [sym_implicit_variable] = ACTIONS(3463),
    [sym_name] = ACTIONS(3465),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1341),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1704] = {
    [sym__type_parens] = STATE(6282),
    [sym__type_tuple] = STATE(6281),
    [sym__type_unboxed_tuple] = STATE(6280),
    [sym__type_unboxed_sum] = STATE(6279),
    [sym__type_list] = STATE(6278),
    [sym__type_promoted] = STATE(6283),
    [sym__type_star] = STATE(6283),
    [sym__type_wildcard] = STATE(6283),
    [sym__type_apply] = STATE(6277),
    [sym__type_infix] = STATE(6276),
    [sym_type] = STATE(822),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10113),
    [sym__qtype_forall] = STATE(8644),
    [sym__qtype_forall_required] = STATE(8640),
    [sym_strict_field] = STATE(8714),
    [sym_lazy_field] = STATE(8714),
    [sym__qtype_function] = STATE(8638),
    [sym__qtype_linear_function] = STATE(8635),
    [sym__qtype_context] = STATE(8633),
    [sym_quantified_type] = STATE(8220),
    [sym_implicit_parameter] = STATE(8632),
    [sym__context_inline] = STATE(1693),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11228),
    [sym__splice_dollars] = STATE(7421),
    [sym_splice] = STATE(6283),
    [sym_quasiquote] = STATE(6283),
    [sym_integer] = STATE(6535),
    [sym__plist] = STATE(6275),
    [sym_unit] = STATE(6283),
    [sym_unboxed_unit] = STATE(6283),
    [sym_prefix_tuple] = STATE(6283),
    [sym_prefix_unboxed_tuple] = STATE(6283),
    [sym_prefix_unboxed_sum] = STATE(6283),
    [sym_literal] = STATE(6283),
    [sym__qualified_type] = STATE(6310),
    [sym__qtyconid] = STATE(6273),
    [sym__tycon_arrow] = STATE(6273),
    [sym__qtycon_arrow] = STATE(6273),
    [sym__promoted_tycons_alias] = STATE(6283),
    [sym__promoted_tycons] = STATE(6283),
    [sym__varsym_prefix] = STATE(6273),
    [sym__pvarsym] = STATE(6273),
    [sym__qvarsym_prefix] = STATE(6273),
    [sym__pqvarsym] = STATE(6273),
    [sym__consym_prefix] = STATE(6273),
    [sym__pconsym] = STATE(6273),
    [sym__qconsym_prefix] = STATE(6273),
    [sym__pqconsym] = STATE(6273),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(429),
    [sym__bracket_open] = STATE(1061),
    [sym__unboxed_open] = STATE(755),
    [sym_variable] = ACTIONS(2305),
    [anon_sym__] = ACTIONS(2307),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(2313),
    [anon_sym_u2605] = ACTIONS(2313),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym__integer_literal] = ACTIONS(2317),
    [sym__binary_literal] = ACTIONS(2319),
    [sym__octal_literal] = ACTIONS(2319),
    [sym__hex_literal] = ACTIONS(2319),
    [sym_implicit_variable] = ACTIONS(3447),
    [sym_name] = ACTIONS(3449),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2323),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1705] = {
    [sym__type_parens] = STATE(3379),
    [sym__type_tuple] = STATE(3377),
    [sym__type_unboxed_tuple] = STATE(3370),
    [sym__type_unboxed_sum] = STATE(3369),
    [sym__type_list] = STATE(3361),
    [sym__type_promoted] = STATE(3383),
    [sym__type_star] = STATE(3383),
    [sym__type_wildcard] = STATE(3383),
    [sym__type_apply] = STATE(3359),
    [sym__type_infix] = STATE(3358),
    [sym_type] = STATE(486),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10095),
    [sym__qtype_forall] = STATE(3757),
    [sym__qtype_forall_required] = STATE(3758),
    [sym_strict_field] = STATE(8706),
    [sym_lazy_field] = STATE(8706),
    [sym__qtype_function] = STATE(3762),
    [sym__qtype_linear_function] = STATE(3767),
    [sym__qtype_context] = STATE(3768),
    [sym_quantified_type] = STATE(2772),
    [sym_implicit_parameter] = STATE(3788),
    [sym__context_inline] = STATE(1749),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11178),
    [sym__splice_dollars] = STATE(7460),
    [sym_splice] = STATE(3383),
    [sym_quasiquote] = STATE(3383),
    [sym_integer] = STATE(3269),
    [sym__plist] = STATE(3357),
    [sym_unit] = STATE(3383),
    [sym_unboxed_unit] = STATE(3383),
    [sym_prefix_tuple] = STATE(3383),
    [sym_prefix_unboxed_tuple] = STATE(3383),
    [sym_prefix_unboxed_sum] = STATE(3383),
    [sym_literal] = STATE(3383),
    [sym__qualified_type] = STATE(3410),
    [sym__qtyconid] = STATE(3354),
    [sym__tycon_arrow] = STATE(3354),
    [sym__qtycon_arrow] = STATE(3354),
    [sym__promoted_tycons_alias] = STATE(3383),
    [sym__promoted_tycons] = STATE(3383),
    [sym__varsym_prefix] = STATE(3354),
    [sym__pvarsym] = STATE(3354),
    [sym__qvarsym_prefix] = STATE(3354),
    [sym__pqvarsym] = STATE(3354),
    [sym__consym_prefix] = STATE(3354),
    [sym__pconsym] = STATE(3354),
    [sym__qconsym_prefix] = STATE(3354),
    [sym__pqconsym] = STATE(3354),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(464),
    [sym__bracket_open] = STATE(1079),
    [sym__unboxed_open] = STATE(805),
    [sym_variable] = ACTIONS(1609),
    [anon_sym__] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_u2605] = ACTIONS(1617),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1619),
    [sym_char] = ACTIONS(1619),
    [sym_string] = ACTIONS(1619),
    [sym__integer_literal] = ACTIONS(1621),
    [sym__binary_literal] = ACTIONS(1623),
    [sym__octal_literal] = ACTIONS(1623),
    [sym__hex_literal] = ACTIONS(1623),
    [sym_implicit_variable] = ACTIONS(3385),
    [sym_name] = ACTIONS(3387),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1627),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1706] = {
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(343),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__paren_open] = STATE(400),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1707] = {
    [sym__exp_th_quoted_name] = STATE(5584),
    [sym__exp_parens] = STATE(5583),
    [sym__exp_tuple] = STATE(5582),
    [sym__exp_unboxed_tuple] = STATE(5579),
    [sym__exp_unboxed_sum] = STATE(5578),
    [sym__exp_list] = STATE(5576),
    [sym__exp_arithmetic_sequence] = STATE(5572),
    [sym__exp_list_comprehension] = STATE(5571),
    [sym__exp_lambda] = STATE(5570),
    [sym__exp_let_in] = STATE(5568),
    [sym__exp_conditional] = STATE(5566),
    [sym__do_keyword] = STATE(10985),
    [sym_do_module] = STATE(10985),
    [sym__do] = STATE(10985),
    [sym__exp_do] = STATE(5565),
    [sym__exp_case] = STATE(5564),
    [sym__exp_lambda_case] = STATE(5563),
    [sym__exp_lambda_cases] = STATE(5562),
    [sym__exp_multi_way_if] = STATE(5559),
    [sym__exp_record] = STATE(5555),
    [sym__exp_projection_selector] = STATE(5554),
    [sym__exp_projection] = STATE(5523),
    [sym__exp_apply] = STATE(5547),
    [sym__exp_section_left] = STATE(5545),
    [sym__exp_section_right] = STATE(5543),
    [sym__exp_negation] = STATE(5540),
    [sym__exp_infix] = STATE(5539),
    [sym_expression] = STATE(337),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9142),
    [sym__splice_dollars] = STATE(7449),
    [sym_splice] = STATE(5586),
    [sym_quasiquote] = STATE(5586),
    [sym__exp_quote] = STATE(5538),
    [sym__exp_typed_quote] = STATE(5586),
    [sym_integer] = STATE(5084),
    [sym__plist] = STATE(5521),
    [sym_unit] = STATE(5586),
    [sym_unboxed_unit] = STATE(5586),
    [sym_prefix_tuple] = STATE(5586),
    [sym_prefix_unboxed_tuple] = STATE(5586),
    [sym_prefix_unboxed_sum] = STATE(5586),
    [sym_literal] = STATE(5586),
    [sym__qualified_variable] = STATE(5072),
    [sym__qvarid] = STATE(5586),
    [sym__qvar] = STATE(5586),
    [sym__qualified_constructor] = STATE(5073),
    [sym__qconid] = STATE(5586),
    [sym__varsym_prefix] = STATE(5586),
    [sym__pvarsym] = STATE(5586),
    [sym__qvarsym_prefix] = STATE(5586),
    [sym__pqvarsym] = STATE(5586),
    [sym__consym_prefix] = STATE(5522),
    [sym__pconsym] = STATE(5522),
    [sym__qconsym_prefix] = STATE(5586),
    [sym__pqconsym] = STATE(5586),
    [sym__paren_open] = STATE(400),
    [sym__bracket_open] = STATE(1022),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1071),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1077),
    [anon_sym_BSLASH] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_mdo] = ACTIONS(1083),
    [anon_sym_do] = ACTIONS(1083),
    [anon_sym_case] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(1089),
    [sym_float] = ACTIONS(1091),
    [sym_char] = ACTIONS(1091),
    [sym_string] = ACTIONS(1091),
    [sym__integer_literal] = ACTIONS(1093),
    [sym__binary_literal] = ACTIONS(1095),
    [sym__octal_literal] = ACTIONS(1095),
    [sym__hex_literal] = ACTIONS(1095),
    [sym_implicit_variable] = ACTIONS(1097),
    [sym_name] = ACTIONS(1099),
    [sym_label] = ACTIONS(1097),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1103),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1708] = {
    [sym__type_parens] = STATE(3579),
    [sym__type_tuple] = STATE(3576),
    [sym__type_unboxed_tuple] = STATE(3572),
    [sym__type_unboxed_sum] = STATE(3570),
    [sym__type_list] = STATE(3569),
    [sym__type_promoted] = STATE(3582),
    [sym__type_star] = STATE(3582),
    [sym__type_wildcard] = STATE(3582),
    [sym__type_apply] = STATE(3567),
    [sym__type_infix] = STATE(3561),
    [sym_type] = STATE(511),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10109),
    [sym__qtype_forall] = STATE(3889),
    [sym__qtype_forall_required] = STATE(3901),
    [sym_strict_field] = STATE(8615),
    [sym_lazy_field] = STATE(8615),
    [sym__qtype_function] = STATE(3902),
    [sym__qtype_linear_function] = STATE(3905),
    [sym__qtype_context] = STATE(3909),
    [sym_quantified_type] = STATE(3038),
    [sym_implicit_parameter] = STATE(3910),
    [sym__context_inline] = STATE(1708),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11208),
    [sym__splice_dollars] = STATE(7292),
    [sym_splice] = STATE(3582),
    [sym_quasiquote] = STATE(3582),
    [sym_integer] = STATE(3435),
    [sym__plist] = STATE(3559),
    [sym_unit] = STATE(3582),
    [sym_unboxed_unit] = STATE(3582),
    [sym_prefix_tuple] = STATE(3582),
    [sym_prefix_unboxed_tuple] = STATE(3582),
    [sym_prefix_unboxed_sum] = STATE(3582),
    [sym_literal] = STATE(3582),
    [sym__qualified_type] = STATE(3610),
    [sym__qtyconid] = STATE(3556),
    [sym__tycon_arrow] = STATE(3556),
    [sym__qtycon_arrow] = STATE(3556),
    [sym__promoted_tycons_alias] = STATE(3582),
    [sym__promoted_tycons] = STATE(3582),
    [sym__varsym_prefix] = STATE(3556),
    [sym__pvarsym] = STATE(3556),
    [sym__qvarsym_prefix] = STATE(3556),
    [sym__pqvarsym] = STATE(3556),
    [sym__consym_prefix] = STATE(3556),
    [sym__pconsym] = STATE(3556),
    [sym__qconsym_prefix] = STATE(3556),
    [sym__pqconsym] = STATE(3556),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(465),
    [sym__bracket_open] = STATE(1069),
    [sym__unboxed_open] = STATE(772),
    [sym_variable] = ACTIONS(1649),
    [anon_sym__] = ACTIONS(1651),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_u2605] = ACTIONS(1657),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1659),
    [sym_char] = ACTIONS(1659),
    [sym_string] = ACTIONS(1659),
    [sym__integer_literal] = ACTIONS(1661),
    [sym__binary_literal] = ACTIONS(1663),
    [sym__octal_literal] = ACTIONS(1663),
    [sym__hex_literal] = ACTIONS(1663),
    [sym_implicit_variable] = ACTIONS(3359),
    [sym_name] = ACTIONS(3361),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1667),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1709] = {
    [sym__type_parens] = STATE(5999),
    [sym__type_tuple] = STATE(6002),
    [sym__type_unboxed_tuple] = STATE(6004),
    [sym__type_unboxed_sum] = STATE(6006),
    [sym__type_list] = STATE(6007),
    [sym__type_promoted] = STATE(5993),
    [sym__type_star] = STATE(5993),
    [sym__type_wildcard] = STATE(5993),
    [sym__type_apply] = STATE(6008),
    [sym__type_infix] = STATE(6009),
    [sym_type] = STATE(666),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10156),
    [sym__qtype_forall] = STATE(8532),
    [sym__qtype_forall_required] = STATE(8520),
    [sym_strict_field] = STATE(8634),
    [sym_lazy_field] = STATE(8634),
    [sym__qtype_function] = STATE(8519),
    [sym__qtype_linear_function] = STATE(8514),
    [sym__qtype_context] = STATE(8511),
    [sym_quantified_type] = STATE(8098),
    [sym_implicit_parameter] = STATE(8502),
    [sym__context_inline] = STATE(1491),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11325),
    [sym__splice_dollars] = STATE(7346),
    [sym_splice] = STATE(5993),
    [sym_quasiquote] = STATE(5993),
    [sym_integer] = STATE(5925),
    [sym__plist] = STATE(6010),
    [sym_unit] = STATE(5993),
    [sym_unboxed_unit] = STATE(5993),
    [sym_prefix_tuple] = STATE(5993),
    [sym_prefix_unboxed_tuple] = STATE(5993),
    [sym_prefix_unboxed_sum] = STATE(5993),
    [sym_literal] = STATE(5993),
    [sym__qualified_type] = STATE(5906),
    [sym__qtyconid] = STATE(6014),
    [sym__tycon_arrow] = STATE(6014),
    [sym__qtycon_arrow] = STATE(6014),
    [sym__promoted_tycons_alias] = STATE(5993),
    [sym__promoted_tycons] = STATE(5993),
    [sym__varsym_prefix] = STATE(6014),
    [sym__pvarsym] = STATE(6014),
    [sym__qvarsym_prefix] = STATE(6014),
    [sym__pqvarsym] = STATE(6014),
    [sym__consym_prefix] = STATE(6014),
    [sym__pconsym] = STATE(6014),
    [sym__qconsym_prefix] = STATE(6014),
    [sym__pqconsym] = STATE(6014),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(468),
    [sym__bracket_open] = STATE(986),
    [sym__unboxed_open] = STATE(795),
    [sym_variable] = ACTIONS(1867),
    [anon_sym__] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(1875),
    [anon_sym_u2605] = ACTIONS(1875),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1877),
    [sym_char] = ACTIONS(1877),
    [sym_string] = ACTIONS(1877),
    [sym__integer_literal] = ACTIONS(1879),
    [sym__binary_literal] = ACTIONS(1881),
    [sym__octal_literal] = ACTIONS(1881),
    [sym__hex_literal] = ACTIONS(1881),
    [sym_implicit_variable] = ACTIONS(3351),
    [sym_name] = ACTIONS(3353),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1885),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1710] = {
    [sym__type_parens] = STATE(2825),
    [sym__type_tuple] = STATE(2808),
    [sym__type_unboxed_tuple] = STATE(2788),
    [sym__type_unboxed_sum] = STATE(2767),
    [sym__type_list] = STATE(2839),
    [sym__type_promoted] = STATE(2796),
    [sym__type_star] = STATE(2796),
    [sym__type_wildcard] = STATE(2796),
    [sym__type_apply] = STATE(2823),
    [sym__type_infix] = STATE(2774),
    [sym_type] = STATE(421),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10083),
    [sym__qtype_forall] = STATE(3138),
    [sym__qtype_forall_required] = STATE(3136),
    [sym_strict_field] = STATE(8681),
    [sym_lazy_field] = STATE(8681),
    [sym__qtype_function] = STATE(3135),
    [sym__qtype_linear_function] = STATE(3132),
    [sym__qtype_context] = STATE(3131),
    [sym_quantified_type] = STATE(2371),
    [sym_implicit_parameter] = STATE(3115),
    [sym__context_inline] = STATE(1721),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11145),
    [sym__splice_dollars] = STATE(7328),
    [sym_splice] = STATE(2796),
    [sym_quasiquote] = STATE(2796),
    [sym_integer] = STATE(2781),
    [sym__plist] = STATE(2777),
    [sym_unit] = STATE(2796),
    [sym_unboxed_unit] = STATE(2796),
    [sym_prefix_tuple] = STATE(2796),
    [sym_prefix_unboxed_tuple] = STATE(2796),
    [sym_prefix_unboxed_sum] = STATE(2796),
    [sym_literal] = STATE(2796),
    [sym__qualified_type] = STATE(2759),
    [sym__qtyconid] = STATE(2752),
    [sym__tycon_arrow] = STATE(2752),
    [sym__qtycon_arrow] = STATE(2752),
    [sym__promoted_tycons_alias] = STATE(2796),
    [sym__promoted_tycons] = STATE(2796),
    [sym__varsym_prefix] = STATE(2752),
    [sym__pvarsym] = STATE(2752),
    [sym__qvarsym_prefix] = STATE(2752),
    [sym__pqvarsym] = STATE(2752),
    [sym__consym_prefix] = STATE(2752),
    [sym__pconsym] = STATE(2752),
    [sym__qconsym_prefix] = STATE(2752),
    [sym__pqconsym] = STATE(2752),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(467),
    [sym__bracket_open] = STATE(1130),
    [sym__unboxed_open] = STATE(765),
    [sym_variable] = ACTIONS(1323),
    [anon_sym__] = ACTIONS(1325),
    [anon_sym_SQUOTE] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_u2605] = ACTIONS(1331),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1333),
    [sym_char] = ACTIONS(1333),
    [sym_string] = ACTIONS(1333),
    [sym__integer_literal] = ACTIONS(1335),
    [sym__binary_literal] = ACTIONS(1337),
    [sym__octal_literal] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1337),
    [sym_implicit_variable] = ACTIONS(3463),
    [sym_name] = ACTIONS(3465),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1341),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1711] = {
    [sym__type_parens] = STATE(6282),
    [sym__type_tuple] = STATE(6281),
    [sym__type_unboxed_tuple] = STATE(6280),
    [sym__type_unboxed_sum] = STATE(6279),
    [sym__type_list] = STATE(6278),
    [sym__type_promoted] = STATE(6283),
    [sym__type_star] = STATE(6283),
    [sym__type_wildcard] = STATE(6283),
    [sym__type_apply] = STATE(6277),
    [sym__type_infix] = STATE(6276),
    [sym_type] = STATE(822),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10113),
    [sym__qtype_forall] = STATE(8644),
    [sym__qtype_forall_required] = STATE(8640),
    [sym_strict_field] = STATE(8714),
    [sym_lazy_field] = STATE(8714),
    [sym__qtype_function] = STATE(8638),
    [sym__qtype_linear_function] = STATE(8635),
    [sym__qtype_context] = STATE(8633),
    [sym_quantified_type] = STATE(8270),
    [sym_implicit_parameter] = STATE(8632),
    [sym__context_inline] = STATE(1693),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11228),
    [sym__splice_dollars] = STATE(7421),
    [sym_splice] = STATE(6283),
    [sym_quasiquote] = STATE(6283),
    [sym_integer] = STATE(6535),
    [sym__plist] = STATE(6275),
    [sym_unit] = STATE(6283),
    [sym_unboxed_unit] = STATE(6283),
    [sym_prefix_tuple] = STATE(6283),
    [sym_prefix_unboxed_tuple] = STATE(6283),
    [sym_prefix_unboxed_sum] = STATE(6283),
    [sym_literal] = STATE(6283),
    [sym__qualified_type] = STATE(6310),
    [sym__qtyconid] = STATE(6273),
    [sym__tycon_arrow] = STATE(6273),
    [sym__qtycon_arrow] = STATE(6273),
    [sym__promoted_tycons_alias] = STATE(6283),
    [sym__promoted_tycons] = STATE(6283),
    [sym__varsym_prefix] = STATE(6273),
    [sym__pvarsym] = STATE(6273),
    [sym__qvarsym_prefix] = STATE(6273),
    [sym__pqvarsym] = STATE(6273),
    [sym__consym_prefix] = STATE(6273),
    [sym__pconsym] = STATE(6273),
    [sym__qconsym_prefix] = STATE(6273),
    [sym__pqconsym] = STATE(6273),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(429),
    [sym__bracket_open] = STATE(1061),
    [sym__unboxed_open] = STATE(755),
    [sym_variable] = ACTIONS(2305),
    [anon_sym__] = ACTIONS(2307),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(2313),
    [anon_sym_u2605] = ACTIONS(2313),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym__integer_literal] = ACTIONS(2317),
    [sym__binary_literal] = ACTIONS(2319),
    [sym__octal_literal] = ACTIONS(2319),
    [sym__hex_literal] = ACTIONS(2319),
    [sym_implicit_variable] = ACTIONS(3447),
    [sym_name] = ACTIONS(3449),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2323),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1712] = {
    [sym__type_parens] = STATE(2825),
    [sym__type_tuple] = STATE(2808),
    [sym__type_unboxed_tuple] = STATE(2788),
    [sym__type_unboxed_sum] = STATE(2767),
    [sym__type_list] = STATE(2839),
    [sym__type_promoted] = STATE(2796),
    [sym__type_star] = STATE(2796),
    [sym__type_wildcard] = STATE(2796),
    [sym__type_apply] = STATE(2823),
    [sym__type_infix] = STATE(2774),
    [sym_type] = STATE(421),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10083),
    [sym__qtype_forall] = STATE(3138),
    [sym__qtype_forall_required] = STATE(3136),
    [sym_strict_field] = STATE(8681),
    [sym_lazy_field] = STATE(8681),
    [sym__qtype_function] = STATE(3135),
    [sym__qtype_linear_function] = STATE(3132),
    [sym__qtype_context] = STATE(3131),
    [sym_quantified_type] = STATE(2373),
    [sym_implicit_parameter] = STATE(3115),
    [sym__context_inline] = STATE(1721),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11145),
    [sym__splice_dollars] = STATE(7328),
    [sym_splice] = STATE(2796),
    [sym_quasiquote] = STATE(2796),
    [sym_integer] = STATE(2781),
    [sym__plist] = STATE(2777),
    [sym_unit] = STATE(2796),
    [sym_unboxed_unit] = STATE(2796),
    [sym_prefix_tuple] = STATE(2796),
    [sym_prefix_unboxed_tuple] = STATE(2796),
    [sym_prefix_unboxed_sum] = STATE(2796),
    [sym_literal] = STATE(2796),
    [sym__qualified_type] = STATE(2759),
    [sym__qtyconid] = STATE(2752),
    [sym__tycon_arrow] = STATE(2752),
    [sym__qtycon_arrow] = STATE(2752),
    [sym__promoted_tycons_alias] = STATE(2796),
    [sym__promoted_tycons] = STATE(2796),
    [sym__varsym_prefix] = STATE(2752),
    [sym__pvarsym] = STATE(2752),
    [sym__qvarsym_prefix] = STATE(2752),
    [sym__pqvarsym] = STATE(2752),
    [sym__consym_prefix] = STATE(2752),
    [sym__pconsym] = STATE(2752),
    [sym__qconsym_prefix] = STATE(2752),
    [sym__pqconsym] = STATE(2752),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(467),
    [sym__bracket_open] = STATE(1130),
    [sym__unboxed_open] = STATE(765),
    [sym_variable] = ACTIONS(1323),
    [anon_sym__] = ACTIONS(1325),
    [anon_sym_SQUOTE] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_u2605] = ACTIONS(1331),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1333),
    [sym_char] = ACTIONS(1333),
    [sym_string] = ACTIONS(1333),
    [sym__integer_literal] = ACTIONS(1335),
    [sym__binary_literal] = ACTIONS(1337),
    [sym__octal_literal] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1337),
    [sym_implicit_variable] = ACTIONS(3463),
    [sym_name] = ACTIONS(3465),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1341),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1713] = {
    [sym__type_parens] = STATE(3579),
    [sym__type_tuple] = STATE(3576),
    [sym__type_unboxed_tuple] = STATE(3572),
    [sym__type_unboxed_sum] = STATE(3570),
    [sym__type_list] = STATE(3569),
    [sym__type_promoted] = STATE(3582),
    [sym__type_star] = STATE(3582),
    [sym__type_wildcard] = STATE(3582),
    [sym__type_apply] = STATE(3567),
    [sym__type_infix] = STATE(3561),
    [sym_type] = STATE(511),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10109),
    [sym__qtype_forall] = STATE(3889),
    [sym__qtype_forall_required] = STATE(3901),
    [sym_strict_field] = STATE(8615),
    [sym_lazy_field] = STATE(8615),
    [sym__qtype_function] = STATE(3902),
    [sym__qtype_linear_function] = STATE(3905),
    [sym__qtype_context] = STATE(3909),
    [sym_quantified_type] = STATE(3039),
    [sym_implicit_parameter] = STATE(3910),
    [sym__context_inline] = STATE(1708),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11208),
    [sym__splice_dollars] = STATE(7292),
    [sym_splice] = STATE(3582),
    [sym_quasiquote] = STATE(3582),
    [sym_integer] = STATE(3435),
    [sym__plist] = STATE(3559),
    [sym_unit] = STATE(3582),
    [sym_unboxed_unit] = STATE(3582),
    [sym_prefix_tuple] = STATE(3582),
    [sym_prefix_unboxed_tuple] = STATE(3582),
    [sym_prefix_unboxed_sum] = STATE(3582),
    [sym_literal] = STATE(3582),
    [sym__qualified_type] = STATE(3610),
    [sym__qtyconid] = STATE(3556),
    [sym__tycon_arrow] = STATE(3556),
    [sym__qtycon_arrow] = STATE(3556),
    [sym__promoted_tycons_alias] = STATE(3582),
    [sym__promoted_tycons] = STATE(3582),
    [sym__varsym_prefix] = STATE(3556),
    [sym__pvarsym] = STATE(3556),
    [sym__qvarsym_prefix] = STATE(3556),
    [sym__pqvarsym] = STATE(3556),
    [sym__consym_prefix] = STATE(3556),
    [sym__pconsym] = STATE(3556),
    [sym__qconsym_prefix] = STATE(3556),
    [sym__pqconsym] = STATE(3556),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(465),
    [sym__bracket_open] = STATE(1069),
    [sym__unboxed_open] = STATE(772),
    [sym_variable] = ACTIONS(1649),
    [anon_sym__] = ACTIONS(1651),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_u2605] = ACTIONS(1657),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1659),
    [sym_char] = ACTIONS(1659),
    [sym_string] = ACTIONS(1659),
    [sym__integer_literal] = ACTIONS(1661),
    [sym__binary_literal] = ACTIONS(1663),
    [sym__octal_literal] = ACTIONS(1663),
    [sym__hex_literal] = ACTIONS(1663),
    [sym_implicit_variable] = ACTIONS(3359),
    [sym_name] = ACTIONS(3361),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1667),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1714] = {
    [sym__type_parens] = STATE(3579),
    [sym__type_tuple] = STATE(3576),
    [sym__type_unboxed_tuple] = STATE(3572),
    [sym__type_unboxed_sum] = STATE(3570),
    [sym__type_list] = STATE(3569),
    [sym__type_promoted] = STATE(3582),
    [sym__type_star] = STATE(3582),
    [sym__type_wildcard] = STATE(3582),
    [sym__type_apply] = STATE(3567),
    [sym__type_infix] = STATE(3561),
    [sym_type] = STATE(511),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10109),
    [sym__qtype_forall] = STATE(3889),
    [sym__qtype_forall_required] = STATE(3901),
    [sym_strict_field] = STATE(8615),
    [sym_lazy_field] = STATE(8615),
    [sym__qtype_function] = STATE(3902),
    [sym__qtype_linear_function] = STATE(3905),
    [sym__qtype_context] = STATE(3909),
    [sym_quantified_type] = STATE(3041),
    [sym_implicit_parameter] = STATE(3910),
    [sym__context_inline] = STATE(1708),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11208),
    [sym__splice_dollars] = STATE(7292),
    [sym_splice] = STATE(3582),
    [sym_quasiquote] = STATE(3582),
    [sym_integer] = STATE(3435),
    [sym__plist] = STATE(3559),
    [sym_unit] = STATE(3582),
    [sym_unboxed_unit] = STATE(3582),
    [sym_prefix_tuple] = STATE(3582),
    [sym_prefix_unboxed_tuple] = STATE(3582),
    [sym_prefix_unboxed_sum] = STATE(3582),
    [sym_literal] = STATE(3582),
    [sym__qualified_type] = STATE(3610),
    [sym__qtyconid] = STATE(3556),
    [sym__tycon_arrow] = STATE(3556),
    [sym__qtycon_arrow] = STATE(3556),
    [sym__promoted_tycons_alias] = STATE(3582),
    [sym__promoted_tycons] = STATE(3582),
    [sym__varsym_prefix] = STATE(3556),
    [sym__pvarsym] = STATE(3556),
    [sym__qvarsym_prefix] = STATE(3556),
    [sym__pqvarsym] = STATE(3556),
    [sym__consym_prefix] = STATE(3556),
    [sym__pconsym] = STATE(3556),
    [sym__qconsym_prefix] = STATE(3556),
    [sym__pqconsym] = STATE(3556),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(465),
    [sym__bracket_open] = STATE(1069),
    [sym__unboxed_open] = STATE(772),
    [sym_variable] = ACTIONS(1649),
    [anon_sym__] = ACTIONS(1651),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_u2605] = ACTIONS(1657),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1659),
    [sym_char] = ACTIONS(1659),
    [sym_string] = ACTIONS(1659),
    [sym__integer_literal] = ACTIONS(1661),
    [sym__binary_literal] = ACTIONS(1663),
    [sym__octal_literal] = ACTIONS(1663),
    [sym__hex_literal] = ACTIONS(1663),
    [sym_implicit_variable] = ACTIONS(3359),
    [sym_name] = ACTIONS(3361),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1667),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1715] = {
    [sym__type_parens] = STATE(3579),
    [sym__type_tuple] = STATE(3576),
    [sym__type_unboxed_tuple] = STATE(3572),
    [sym__type_unboxed_sum] = STATE(3570),
    [sym__type_list] = STATE(3569),
    [sym__type_promoted] = STATE(3582),
    [sym__type_star] = STATE(3582),
    [sym__type_wildcard] = STATE(3582),
    [sym__type_apply] = STATE(3567),
    [sym__type_infix] = STATE(3561),
    [sym_type] = STATE(511),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10109),
    [sym__qtype_forall] = STATE(3889),
    [sym__qtype_forall_required] = STATE(3901),
    [sym_strict_field] = STATE(8615),
    [sym_lazy_field] = STATE(8615),
    [sym__qtype_function] = STATE(3902),
    [sym__qtype_linear_function] = STATE(3905),
    [sym__qtype_context] = STATE(3909),
    [sym_quantified_type] = STATE(3044),
    [sym_implicit_parameter] = STATE(3910),
    [sym__context_inline] = STATE(1708),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11208),
    [sym__splice_dollars] = STATE(7292),
    [sym_splice] = STATE(3582),
    [sym_quasiquote] = STATE(3582),
    [sym_integer] = STATE(3435),
    [sym__plist] = STATE(3559),
    [sym_unit] = STATE(3582),
    [sym_unboxed_unit] = STATE(3582),
    [sym_prefix_tuple] = STATE(3582),
    [sym_prefix_unboxed_tuple] = STATE(3582),
    [sym_prefix_unboxed_sum] = STATE(3582),
    [sym_literal] = STATE(3582),
    [sym__qualified_type] = STATE(3610),
    [sym__qtyconid] = STATE(3556),
    [sym__tycon_arrow] = STATE(3556),
    [sym__qtycon_arrow] = STATE(3556),
    [sym__promoted_tycons_alias] = STATE(3582),
    [sym__promoted_tycons] = STATE(3582),
    [sym__varsym_prefix] = STATE(3556),
    [sym__pvarsym] = STATE(3556),
    [sym__qvarsym_prefix] = STATE(3556),
    [sym__pqvarsym] = STATE(3556),
    [sym__consym_prefix] = STATE(3556),
    [sym__pconsym] = STATE(3556),
    [sym__qconsym_prefix] = STATE(3556),
    [sym__pqconsym] = STATE(3556),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(465),
    [sym__bracket_open] = STATE(1069),
    [sym__unboxed_open] = STATE(772),
    [sym_variable] = ACTIONS(1649),
    [anon_sym__] = ACTIONS(1651),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_u2605] = ACTIONS(1657),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1659),
    [sym_char] = ACTIONS(1659),
    [sym_string] = ACTIONS(1659),
    [sym__integer_literal] = ACTIONS(1661),
    [sym__binary_literal] = ACTIONS(1663),
    [sym__octal_literal] = ACTIONS(1663),
    [sym__hex_literal] = ACTIONS(1663),
    [sym_implicit_variable] = ACTIONS(3359),
    [sym_name] = ACTIONS(3361),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1667),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1716] = {
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(233),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__paren_open] = STATE(416),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1717] = {
    [sym__type_parens] = STATE(3579),
    [sym__type_tuple] = STATE(3576),
    [sym__type_unboxed_tuple] = STATE(3572),
    [sym__type_unboxed_sum] = STATE(3570),
    [sym__type_list] = STATE(3569),
    [sym__type_promoted] = STATE(3582),
    [sym__type_star] = STATE(3582),
    [sym__type_wildcard] = STATE(3582),
    [sym__type_apply] = STATE(3567),
    [sym__type_infix] = STATE(3561),
    [sym_type] = STATE(511),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10109),
    [sym__qtype_forall] = STATE(3889),
    [sym__qtype_forall_required] = STATE(3901),
    [sym_strict_field] = STATE(8615),
    [sym_lazy_field] = STATE(8615),
    [sym__qtype_function] = STATE(3902),
    [sym__qtype_linear_function] = STATE(3905),
    [sym__qtype_context] = STATE(3909),
    [sym_quantified_type] = STATE(3046),
    [sym_implicit_parameter] = STATE(3910),
    [sym__context_inline] = STATE(1708),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11208),
    [sym__splice_dollars] = STATE(7292),
    [sym_splice] = STATE(3582),
    [sym_quasiquote] = STATE(3582),
    [sym_integer] = STATE(3435),
    [sym__plist] = STATE(3559),
    [sym_unit] = STATE(3582),
    [sym_unboxed_unit] = STATE(3582),
    [sym_prefix_tuple] = STATE(3582),
    [sym_prefix_unboxed_tuple] = STATE(3582),
    [sym_prefix_unboxed_sum] = STATE(3582),
    [sym_literal] = STATE(3582),
    [sym__qualified_type] = STATE(3610),
    [sym__qtyconid] = STATE(3556),
    [sym__tycon_arrow] = STATE(3556),
    [sym__qtycon_arrow] = STATE(3556),
    [sym__promoted_tycons_alias] = STATE(3582),
    [sym__promoted_tycons] = STATE(3582),
    [sym__varsym_prefix] = STATE(3556),
    [sym__pvarsym] = STATE(3556),
    [sym__qvarsym_prefix] = STATE(3556),
    [sym__pqvarsym] = STATE(3556),
    [sym__consym_prefix] = STATE(3556),
    [sym__pconsym] = STATE(3556),
    [sym__qconsym_prefix] = STATE(3556),
    [sym__pqconsym] = STATE(3556),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(465),
    [sym__bracket_open] = STATE(1069),
    [sym__unboxed_open] = STATE(772),
    [sym_variable] = ACTIONS(1649),
    [anon_sym__] = ACTIONS(1651),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_u2605] = ACTIONS(1657),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1659),
    [sym_char] = ACTIONS(1659),
    [sym_string] = ACTIONS(1659),
    [sym__integer_literal] = ACTIONS(1661),
    [sym__binary_literal] = ACTIONS(1663),
    [sym__octal_literal] = ACTIONS(1663),
    [sym__hex_literal] = ACTIONS(1663),
    [sym_implicit_variable] = ACTIONS(3359),
    [sym_name] = ACTIONS(3361),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1667),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1718] = {
    [sym__type_parens] = STATE(3579),
    [sym__type_tuple] = STATE(3576),
    [sym__type_unboxed_tuple] = STATE(3572),
    [sym__type_unboxed_sum] = STATE(3570),
    [sym__type_list] = STATE(3569),
    [sym__type_promoted] = STATE(3582),
    [sym__type_star] = STATE(3582),
    [sym__type_wildcard] = STATE(3582),
    [sym__type_apply] = STATE(3567),
    [sym__type_infix] = STATE(3561),
    [sym_type] = STATE(511),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10109),
    [sym__qtype_forall] = STATE(3889),
    [sym__qtype_forall_required] = STATE(3901),
    [sym_strict_field] = STATE(8615),
    [sym_lazy_field] = STATE(8615),
    [sym__qtype_function] = STATE(3902),
    [sym__qtype_linear_function] = STATE(3905),
    [sym__qtype_context] = STATE(3909),
    [sym_quantified_type] = STATE(3047),
    [sym_implicit_parameter] = STATE(3910),
    [sym__context_inline] = STATE(1708),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11208),
    [sym__splice_dollars] = STATE(7292),
    [sym_splice] = STATE(3582),
    [sym_quasiquote] = STATE(3582),
    [sym_integer] = STATE(3435),
    [sym__plist] = STATE(3559),
    [sym_unit] = STATE(3582),
    [sym_unboxed_unit] = STATE(3582),
    [sym_prefix_tuple] = STATE(3582),
    [sym_prefix_unboxed_tuple] = STATE(3582),
    [sym_prefix_unboxed_sum] = STATE(3582),
    [sym_literal] = STATE(3582),
    [sym__qualified_type] = STATE(3610),
    [sym__qtyconid] = STATE(3556),
    [sym__tycon_arrow] = STATE(3556),
    [sym__qtycon_arrow] = STATE(3556),
    [sym__promoted_tycons_alias] = STATE(3582),
    [sym__promoted_tycons] = STATE(3582),
    [sym__varsym_prefix] = STATE(3556),
    [sym__pvarsym] = STATE(3556),
    [sym__qvarsym_prefix] = STATE(3556),
    [sym__pqvarsym] = STATE(3556),
    [sym__consym_prefix] = STATE(3556),
    [sym__pconsym] = STATE(3556),
    [sym__qconsym_prefix] = STATE(3556),
    [sym__pqconsym] = STATE(3556),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(465),
    [sym__bracket_open] = STATE(1069),
    [sym__unboxed_open] = STATE(772),
    [sym_variable] = ACTIONS(1649),
    [anon_sym__] = ACTIONS(1651),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_u2605] = ACTIONS(1657),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1659),
    [sym_char] = ACTIONS(1659),
    [sym_string] = ACTIONS(1659),
    [sym__integer_literal] = ACTIONS(1661),
    [sym__binary_literal] = ACTIONS(1663),
    [sym__octal_literal] = ACTIONS(1663),
    [sym__hex_literal] = ACTIONS(1663),
    [sym_implicit_variable] = ACTIONS(3359),
    [sym_name] = ACTIONS(3361),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1667),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1719] = {
    [sym__type_parens] = STATE(2825),
    [sym__type_tuple] = STATE(2808),
    [sym__type_unboxed_tuple] = STATE(2788),
    [sym__type_unboxed_sum] = STATE(2767),
    [sym__type_list] = STATE(2839),
    [sym__type_promoted] = STATE(2796),
    [sym__type_star] = STATE(2796),
    [sym__type_wildcard] = STATE(2796),
    [sym__type_apply] = STATE(2823),
    [sym__type_infix] = STATE(2774),
    [sym_type] = STATE(421),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10083),
    [sym__qtype_forall] = STATE(3138),
    [sym__qtype_forall_required] = STATE(3136),
    [sym_strict_field] = STATE(8681),
    [sym_lazy_field] = STATE(8681),
    [sym__qtype_function] = STATE(3135),
    [sym__qtype_linear_function] = STATE(3132),
    [sym__qtype_context] = STATE(3131),
    [sym_quantified_type] = STATE(2364),
    [sym_implicit_parameter] = STATE(3115),
    [sym__context_inline] = STATE(1721),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11145),
    [sym__splice_dollars] = STATE(7328),
    [sym_splice] = STATE(2796),
    [sym_quasiquote] = STATE(2796),
    [sym_integer] = STATE(2781),
    [sym__plist] = STATE(2777),
    [sym_unit] = STATE(2796),
    [sym_unboxed_unit] = STATE(2796),
    [sym_prefix_tuple] = STATE(2796),
    [sym_prefix_unboxed_tuple] = STATE(2796),
    [sym_prefix_unboxed_sum] = STATE(2796),
    [sym_literal] = STATE(2796),
    [sym__qualified_type] = STATE(2759),
    [sym__qtyconid] = STATE(2752),
    [sym__tycon_arrow] = STATE(2752),
    [sym__qtycon_arrow] = STATE(2752),
    [sym__promoted_tycons_alias] = STATE(2796),
    [sym__promoted_tycons] = STATE(2796),
    [sym__varsym_prefix] = STATE(2752),
    [sym__pvarsym] = STATE(2752),
    [sym__qvarsym_prefix] = STATE(2752),
    [sym__pqvarsym] = STATE(2752),
    [sym__consym_prefix] = STATE(2752),
    [sym__pconsym] = STATE(2752),
    [sym__qconsym_prefix] = STATE(2752),
    [sym__pqconsym] = STATE(2752),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(467),
    [sym__bracket_open] = STATE(1130),
    [sym__unboxed_open] = STATE(765),
    [sym_variable] = ACTIONS(1323),
    [anon_sym__] = ACTIONS(1325),
    [anon_sym_SQUOTE] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_u2605] = ACTIONS(1331),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1333),
    [sym_char] = ACTIONS(1333),
    [sym_string] = ACTIONS(1333),
    [sym__integer_literal] = ACTIONS(1335),
    [sym__binary_literal] = ACTIONS(1337),
    [sym__octal_literal] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1337),
    [sym_implicit_variable] = ACTIONS(3463),
    [sym_name] = ACTIONS(3465),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1341),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1720] = {
    [sym__type_parens] = STATE(3294),
    [sym__type_tuple] = STATE(3295),
    [sym__type_unboxed_tuple] = STATE(3296),
    [sym__type_unboxed_sum] = STATE(3298),
    [sym__type_list] = STATE(3311),
    [sym__type_promoted] = STATE(3292),
    [sym__type_star] = STATE(3292),
    [sym__type_wildcard] = STATE(3292),
    [sym__type_apply] = STATE(3313),
    [sym__type_infix] = STATE(3314),
    [sym_type] = STATE(478),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10086),
    [sym__qtype_forall] = STATE(3726),
    [sym__qtype_forall_required] = STATE(3727),
    [sym_strict_field] = STATE(8686),
    [sym_lazy_field] = STATE(8686),
    [sym__qtype_function] = STATE(3728),
    [sym__qtype_linear_function] = STATE(3729),
    [sym__qtype_context] = STATE(3730),
    [sym_quantified_type] = STATE(2757),
    [sym_implicit_parameter] = STATE(3720),
    [sym__context_inline] = STATE(1666),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11151),
    [sym__splice_dollars] = STATE(7231),
    [sym_splice] = STATE(3292),
    [sym_quasiquote] = STATE(3292),
    [sym_integer] = STATE(3286),
    [sym__plist] = STATE(3318),
    [sym_unit] = STATE(3292),
    [sym_unboxed_unit] = STATE(3292),
    [sym_prefix_tuple] = STATE(3292),
    [sym_prefix_unboxed_tuple] = STATE(3292),
    [sym_prefix_unboxed_sum] = STATE(3292),
    [sym_literal] = STATE(3292),
    [sym__qualified_type] = STATE(3249),
    [sym__qtyconid] = STATE(3320),
    [sym__tycon_arrow] = STATE(3320),
    [sym__qtycon_arrow] = STATE(3320),
    [sym__promoted_tycons_alias] = STATE(3292),
    [sym__promoted_tycons] = STATE(3292),
    [sym__varsym_prefix] = STATE(3320),
    [sym__pvarsym] = STATE(3320),
    [sym__qvarsym_prefix] = STATE(3320),
    [sym__pqvarsym] = STATE(3320),
    [sym__consym_prefix] = STATE(3320),
    [sym__pconsym] = STATE(3320),
    [sym__qconsym_prefix] = STATE(3320),
    [sym__pqconsym] = STATE(3320),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(458),
    [sym__bracket_open] = STATE(1120),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = ACTIONS(1589),
    [anon_sym__] = ACTIONS(1591),
    [anon_sym_SQUOTE] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(1597),
    [anon_sym_u2605] = ACTIONS(1597),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1599),
    [sym_char] = ACTIONS(1599),
    [sym_string] = ACTIONS(1599),
    [sym__integer_literal] = ACTIONS(1601),
    [sym__binary_literal] = ACTIONS(1603),
    [sym__octal_literal] = ACTIONS(1603),
    [sym__hex_literal] = ACTIONS(1603),
    [sym_implicit_variable] = ACTIONS(3469),
    [sym_name] = ACTIONS(3471),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1607),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1721] = {
    [sym__type_parens] = STATE(2825),
    [sym__type_tuple] = STATE(2808),
    [sym__type_unboxed_tuple] = STATE(2788),
    [sym__type_unboxed_sum] = STATE(2767),
    [sym__type_list] = STATE(2839),
    [sym__type_promoted] = STATE(2796),
    [sym__type_star] = STATE(2796),
    [sym__type_wildcard] = STATE(2796),
    [sym__type_apply] = STATE(2823),
    [sym__type_infix] = STATE(2774),
    [sym_type] = STATE(421),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10083),
    [sym__qtype_forall] = STATE(3138),
    [sym__qtype_forall_required] = STATE(3136),
    [sym_strict_field] = STATE(8681),
    [sym_lazy_field] = STATE(8681),
    [sym__qtype_function] = STATE(3135),
    [sym__qtype_linear_function] = STATE(3132),
    [sym__qtype_context] = STATE(3131),
    [sym_quantified_type] = STATE(2376),
    [sym_implicit_parameter] = STATE(3115),
    [sym__context_inline] = STATE(1721),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11145),
    [sym__splice_dollars] = STATE(7328),
    [sym_splice] = STATE(2796),
    [sym_quasiquote] = STATE(2796),
    [sym_integer] = STATE(2781),
    [sym__plist] = STATE(2777),
    [sym_unit] = STATE(2796),
    [sym_unboxed_unit] = STATE(2796),
    [sym_prefix_tuple] = STATE(2796),
    [sym_prefix_unboxed_tuple] = STATE(2796),
    [sym_prefix_unboxed_sum] = STATE(2796),
    [sym_literal] = STATE(2796),
    [sym__qualified_type] = STATE(2759),
    [sym__qtyconid] = STATE(2752),
    [sym__tycon_arrow] = STATE(2752),
    [sym__qtycon_arrow] = STATE(2752),
    [sym__promoted_tycons_alias] = STATE(2796),
    [sym__promoted_tycons] = STATE(2796),
    [sym__varsym_prefix] = STATE(2752),
    [sym__pvarsym] = STATE(2752),
    [sym__qvarsym_prefix] = STATE(2752),
    [sym__pqvarsym] = STATE(2752),
    [sym__consym_prefix] = STATE(2752),
    [sym__pconsym] = STATE(2752),
    [sym__qconsym_prefix] = STATE(2752),
    [sym__pqconsym] = STATE(2752),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(467),
    [sym__bracket_open] = STATE(1130),
    [sym__unboxed_open] = STATE(765),
    [sym_variable] = ACTIONS(1323),
    [anon_sym__] = ACTIONS(1325),
    [anon_sym_SQUOTE] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_u2605] = ACTIONS(1331),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1333),
    [sym_char] = ACTIONS(1333),
    [sym_string] = ACTIONS(1333),
    [sym__integer_literal] = ACTIONS(1335),
    [sym__binary_literal] = ACTIONS(1337),
    [sym__octal_literal] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1337),
    [sym_implicit_variable] = ACTIONS(3463),
    [sym_name] = ACTIONS(3465),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1341),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1722] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8324),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1723] = {
    [sym__type_parens] = STATE(3379),
    [sym__type_tuple] = STATE(3377),
    [sym__type_unboxed_tuple] = STATE(3370),
    [sym__type_unboxed_sum] = STATE(3369),
    [sym__type_list] = STATE(3361),
    [sym__type_promoted] = STATE(3383),
    [sym__type_star] = STATE(3383),
    [sym__type_wildcard] = STATE(3383),
    [sym__type_apply] = STATE(3359),
    [sym__type_infix] = STATE(3358),
    [sym_type] = STATE(486),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10095),
    [sym__qtype_forall] = STATE(3757),
    [sym__qtype_forall_required] = STATE(3758),
    [sym_strict_field] = STATE(8706),
    [sym_lazy_field] = STATE(8706),
    [sym__qtype_function] = STATE(3762),
    [sym__qtype_linear_function] = STATE(3767),
    [sym__qtype_context] = STATE(3768),
    [sym_quantified_type] = STATE(2770),
    [sym_implicit_parameter] = STATE(3788),
    [sym__context_inline] = STATE(1749),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11178),
    [sym__splice_dollars] = STATE(7460),
    [sym_splice] = STATE(3383),
    [sym_quasiquote] = STATE(3383),
    [sym_integer] = STATE(3269),
    [sym__plist] = STATE(3357),
    [sym_unit] = STATE(3383),
    [sym_unboxed_unit] = STATE(3383),
    [sym_prefix_tuple] = STATE(3383),
    [sym_prefix_unboxed_tuple] = STATE(3383),
    [sym_prefix_unboxed_sum] = STATE(3383),
    [sym_literal] = STATE(3383),
    [sym__qualified_type] = STATE(3410),
    [sym__qtyconid] = STATE(3354),
    [sym__tycon_arrow] = STATE(3354),
    [sym__qtycon_arrow] = STATE(3354),
    [sym__promoted_tycons_alias] = STATE(3383),
    [sym__promoted_tycons] = STATE(3383),
    [sym__varsym_prefix] = STATE(3354),
    [sym__pvarsym] = STATE(3354),
    [sym__qvarsym_prefix] = STATE(3354),
    [sym__pqvarsym] = STATE(3354),
    [sym__consym_prefix] = STATE(3354),
    [sym__pconsym] = STATE(3354),
    [sym__qconsym_prefix] = STATE(3354),
    [sym__pqconsym] = STATE(3354),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(464),
    [sym__bracket_open] = STATE(1079),
    [sym__unboxed_open] = STATE(805),
    [sym_variable] = ACTIONS(1609),
    [anon_sym__] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_u2605] = ACTIONS(1617),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1619),
    [sym_char] = ACTIONS(1619),
    [sym_string] = ACTIONS(1619),
    [sym__integer_literal] = ACTIONS(1621),
    [sym__binary_literal] = ACTIONS(1623),
    [sym__octal_literal] = ACTIONS(1623),
    [sym__hex_literal] = ACTIONS(1623),
    [sym_implicit_variable] = ACTIONS(3385),
    [sym_name] = ACTIONS(3387),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1627),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1724] = {
    [sym__type_parens] = STATE(3220),
    [sym__type_tuple] = STATE(3210),
    [sym__type_unboxed_tuple] = STATE(3184),
    [sym__type_unboxed_sum] = STATE(3188),
    [sym__type_list] = STATE(3211),
    [sym__type_promoted] = STATE(3364),
    [sym__type_star] = STATE(3364),
    [sym__type_wildcard] = STATE(3364),
    [sym__type_apply] = STATE(3196),
    [sym__type_infix] = STATE(3225),
    [sym_type] = STATE(480),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10104),
    [sym__qtype_forall] = STATE(3791),
    [sym__qtype_forall_required] = STATE(3793),
    [sym_strict_field] = STATE(8711),
    [sym_lazy_field] = STATE(8711),
    [sym__qtype_function] = STATE(3794),
    [sym__qtype_linear_function] = STATE(3797),
    [sym__qtype_context] = STATE(3798),
    [sym_quantified_type] = STATE(2790),
    [sym_implicit_parameter] = STATE(3799),
    [sym__context_inline] = STATE(1724),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11198),
    [sym__splice_dollars] = STATE(7401),
    [sym_splice] = STATE(3364),
    [sym_quasiquote] = STATE(3364),
    [sym_integer] = STATE(3397),
    [sym__plist] = STATE(3177),
    [sym_unit] = STATE(3364),
    [sym_unboxed_unit] = STATE(3364),
    [sym_prefix_tuple] = STATE(3364),
    [sym_prefix_unboxed_tuple] = STATE(3364),
    [sym_prefix_unboxed_sum] = STATE(3364),
    [sym_literal] = STATE(3364),
    [sym__qualified_type] = STATE(3262),
    [sym__qtyconid] = STATE(3232),
    [sym__tycon_arrow] = STATE(3232),
    [sym__qtycon_arrow] = STATE(3232),
    [sym__promoted_tycons_alias] = STATE(3364),
    [sym__promoted_tycons] = STATE(3364),
    [sym__varsym_prefix] = STATE(3232),
    [sym__pvarsym] = STATE(3232),
    [sym__qvarsym_prefix] = STATE(3232),
    [sym__pqvarsym] = STATE(3232),
    [sym__consym_prefix] = STATE(3232),
    [sym__pconsym] = STATE(3232),
    [sym__qconsym_prefix] = STATE(3232),
    [sym__pqconsym] = STATE(3232),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(466),
    [sym__bracket_open] = STATE(1073),
    [sym__unboxed_open] = STATE(781),
    [sym_variable] = ACTIONS(1569),
    [anon_sym__] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(1577),
    [anon_sym_u2605] = ACTIONS(1577),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1579),
    [sym_char] = ACTIONS(1579),
    [sym_string] = ACTIONS(1579),
    [sym__integer_literal] = ACTIONS(1581),
    [sym__binary_literal] = ACTIONS(1583),
    [sym__octal_literal] = ACTIONS(1583),
    [sym__hex_literal] = ACTIONS(1583),
    [sym_implicit_variable] = ACTIONS(3441),
    [sym_name] = ACTIONS(3443),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1587),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1725] = {
    [sym__type_parens] = STATE(6922),
    [sym__type_tuple] = STATE(6929),
    [sym__type_unboxed_tuple] = STATE(6932),
    [sym__type_unboxed_sum] = STATE(6934),
    [sym__type_list] = STATE(6935),
    [sym__type_promoted] = STATE(6919),
    [sym__type_star] = STATE(6919),
    [sym__type_wildcard] = STATE(6919),
    [sym__type_apply] = STATE(6936),
    [sym__type_infix] = STATE(6937),
    [sym_type] = STATE(910),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10089),
    [sym__qtype_forall] = STATE(8937),
    [sym__qtype_forall_required] = STATE(8932),
    [sym_strict_field] = STATE(8700),
    [sym_lazy_field] = STATE(8700),
    [sym__qtype_function] = STATE(8931),
    [sym__qtype_linear_function] = STATE(8922),
    [sym__qtype_context] = STATE(8930),
    [sym_quantified_type] = STATE(8398),
    [sym_implicit_parameter] = STATE(8927),
    [sym__context_inline] = STATE(1434),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11154),
    [sym__splice_dollars] = STATE(7213),
    [sym_splice] = STATE(6919),
    [sym_quasiquote] = STATE(6919),
    [sym_integer] = STATE(6980),
    [sym__plist] = STATE(6939),
    [sym_unit] = STATE(6919),
    [sym_unboxed_unit] = STATE(6919),
    [sym_prefix_tuple] = STATE(6919),
    [sym_prefix_unboxed_tuple] = STATE(6919),
    [sym_prefix_unboxed_sum] = STATE(6919),
    [sym_literal] = STATE(6919),
    [sym__qualified_type] = STATE(7018),
    [sym__qtyconid] = STATE(6940),
    [sym__tycon_arrow] = STATE(6940),
    [sym__qtycon_arrow] = STATE(6940),
    [sym__promoted_tycons_alias] = STATE(6919),
    [sym__promoted_tycons] = STATE(6919),
    [sym__varsym_prefix] = STATE(6940),
    [sym__pvarsym] = STATE(6940),
    [sym__qvarsym_prefix] = STATE(6940),
    [sym__pqvarsym] = STATE(6940),
    [sym__consym_prefix] = STATE(6940),
    [sym__pconsym] = STATE(6940),
    [sym__qconsym_prefix] = STATE(6940),
    [sym__pqconsym] = STATE(6940),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(435),
    [sym__bracket_open] = STATE(1104),
    [sym__unboxed_open] = STATE(744),
    [sym_variable] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(2695),
    [anon_sym_SQUOTE] = ACTIONS(3325),
    [anon_sym_STAR] = ACTIONS(2701),
    [anon_sym_u2605] = ACTIONS(2701),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2703),
    [sym_char] = ACTIONS(2703),
    [sym_string] = ACTIONS(2703),
    [sym__integer_literal] = ACTIONS(2705),
    [sym__binary_literal] = ACTIONS(2707),
    [sym__octal_literal] = ACTIONS(2707),
    [sym__hex_literal] = ACTIONS(2707),
    [sym_implicit_variable] = ACTIONS(3327),
    [sym_name] = ACTIONS(3329),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2711),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1726] = {
    [sym__exp_th_quoted_name] = STATE(5387),
    [sym__exp_parens] = STATE(5386),
    [sym__exp_tuple] = STATE(5385),
    [sym__exp_unboxed_tuple] = STATE(5104),
    [sym__exp_unboxed_sum] = STATE(5383),
    [sym__exp_list] = STATE(5382),
    [sym__exp_arithmetic_sequence] = STATE(5381),
    [sym__exp_list_comprehension] = STATE(5380),
    [sym__exp_lambda] = STATE(5379),
    [sym__exp_let_in] = STATE(5378),
    [sym__exp_conditional] = STATE(5377),
    [sym__do_keyword] = STATE(11261),
    [sym_do_module] = STATE(11261),
    [sym__do] = STATE(11261),
    [sym__exp_do] = STATE(5376),
    [sym__exp_case] = STATE(5374),
    [sym__exp_lambda_case] = STATE(5373),
    [sym__exp_lambda_cases] = STATE(5372),
    [sym__exp_multi_way_if] = STATE(5371),
    [sym__exp_record] = STATE(5370),
    [sym__exp_projection_selector] = STATE(5369),
    [sym__exp_projection] = STATE(5368),
    [sym__exp_apply] = STATE(5367),
    [sym__exp_section_left] = STATE(5366),
    [sym__exp_section_right] = STATE(5365),
    [sym__exp_negation] = STATE(5364),
    [sym__exp_infix] = STATE(5363),
    [sym_expression] = STATE(317),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9491),
    [sym__splice_dollars] = STATE(7386),
    [sym_splice] = STATE(5388),
    [sym_quasiquote] = STATE(5388),
    [sym__exp_quote] = STATE(5362),
    [sym__exp_typed_quote] = STATE(5388),
    [sym_integer] = STATE(4690),
    [sym__plist] = STATE(5336),
    [sym_unit] = STATE(5388),
    [sym_unboxed_unit] = STATE(5388),
    [sym_prefix_tuple] = STATE(5388),
    [sym_prefix_unboxed_tuple] = STATE(5388),
    [sym_prefix_unboxed_sum] = STATE(5388),
    [sym_literal] = STATE(5388),
    [sym__qualified_variable] = STATE(4614),
    [sym__qvarid] = STATE(5388),
    [sym__qvar] = STATE(5388),
    [sym__qualified_constructor] = STATE(4610),
    [sym__qconid] = STATE(5388),
    [sym__varsym_prefix] = STATE(5388),
    [sym__pvarsym] = STATE(5388),
    [sym__qvarsym_prefix] = STATE(5388),
    [sym__pqvarsym] = STATE(5388),
    [sym__consym_prefix] = STATE(5335),
    [sym__pconsym] = STATE(5335),
    [sym__qconsym_prefix] = STATE(5388),
    [sym__pqconsym] = STATE(5388),
    [sym__paren_open] = STATE(407),
    [sym__bracket_open] = STATE(954),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = ACTIONS(1011),
    [anon_sym_let] = ACTIONS(1013),
    [anon_sym_SQUOTE] = ACTIONS(943),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(945),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_mdo] = ACTIONS(953),
    [anon_sym_do] = ACTIONS(953),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(959),
    [sym_float] = ACTIONS(1019),
    [sym_char] = ACTIONS(1019),
    [sym_string] = ACTIONS(1019),
    [sym__integer_literal] = ACTIONS(1021),
    [sym__binary_literal] = ACTIONS(1023),
    [sym__octal_literal] = ACTIONS(1023),
    [sym__hex_literal] = ACTIONS(1023),
    [sym_implicit_variable] = ACTIONS(961),
    [sym_name] = ACTIONS(1025),
    [sym_label] = ACTIONS(961),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1029),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1727] = {
    [sym__type_parens] = STATE(6766),
    [sym__type_tuple] = STATE(6767),
    [sym__type_unboxed_tuple] = STATE(6768),
    [sym__type_unboxed_sum] = STATE(6769),
    [sym__type_list] = STATE(6770),
    [sym__type_promoted] = STATE(6765),
    [sym__type_star] = STATE(6765),
    [sym__type_wildcard] = STATE(6765),
    [sym__type_apply] = STATE(6698),
    [sym__type_infix] = STATE(6780),
    [sym_type] = STATE(863),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10178),
    [sym__qtype_forall] = STATE(8836),
    [sym__qtype_forall_required] = STATE(8839),
    [sym_strict_field] = STATE(8670),
    [sym_lazy_field] = STATE(8670),
    [sym__qtype_function] = STATE(8850),
    [sym__qtype_linear_function] = STATE(8854),
    [sym__qtype_context] = STATE(8855),
    [sym_quantified_type] = STATE(8348),
    [sym_implicit_parameter] = STATE(8857),
    [sym__context_inline] = STATE(1490),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11231),
    [sym__splice_dollars] = STATE(7306),
    [sym_splice] = STATE(6765),
    [sym_quasiquote] = STATE(6765),
    [sym_integer] = STATE(6754),
    [sym__plist] = STATE(6782),
    [sym_unit] = STATE(6765),
    [sym_unboxed_unit] = STATE(6765),
    [sym_prefix_tuple] = STATE(6765),
    [sym_prefix_unboxed_tuple] = STATE(6765),
    [sym_prefix_unboxed_sum] = STATE(6765),
    [sym_literal] = STATE(6765),
    [sym__qualified_type] = STATE(6803),
    [sym__qtyconid] = STATE(6783),
    [sym__tycon_arrow] = STATE(6783),
    [sym__qtycon_arrow] = STATE(6783),
    [sym__promoted_tycons_alias] = STATE(6765),
    [sym__promoted_tycons] = STATE(6765),
    [sym__varsym_prefix] = STATE(6783),
    [sym__pvarsym] = STATE(6783),
    [sym__qvarsym_prefix] = STATE(6783),
    [sym__pqvarsym] = STATE(6783),
    [sym__consym_prefix] = STATE(6783),
    [sym__pconsym] = STATE(6783),
    [sym__qconsym_prefix] = STATE(6783),
    [sym__pqconsym] = STATE(6783),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(438),
    [sym__bracket_open] = STATE(966),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = ACTIONS(2627),
    [anon_sym__] = ACTIONS(2629),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_u2605] = ACTIONS(2635),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2637),
    [sym_char] = ACTIONS(2637),
    [sym_string] = ACTIONS(2637),
    [sym__integer_literal] = ACTIONS(2639),
    [sym__binary_literal] = ACTIONS(2641),
    [sym__octal_literal] = ACTIONS(2641),
    [sym__hex_literal] = ACTIONS(2641),
    [sym_implicit_variable] = ACTIONS(3313),
    [sym_name] = ACTIONS(3315),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2645),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1728] = {
    [sym__type_parens] = STATE(3851),
    [sym__type_tuple] = STATE(3846),
    [sym__type_unboxed_tuple] = STATE(3843),
    [sym__type_unboxed_sum] = STATE(3826),
    [sym__type_list] = STATE(3887),
    [sym__type_promoted] = STATE(3855),
    [sym__type_star] = STATE(3855),
    [sym__type_wildcard] = STATE(3855),
    [sym__type_apply] = STATE(3822),
    [sym__type_infix] = STATE(3888),
    [sym_type] = STATE(525),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10412),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8668),
    [sym_lazy_field] = STATE(8668),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8420),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1546),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11251),
    [sym__splice_dollars] = STATE(7480),
    [sym_splice] = STATE(3855),
    [sym_quasiquote] = STATE(3855),
    [sym_integer] = STATE(3886),
    [sym__plist] = STATE(3803),
    [sym_unit] = STATE(3855),
    [sym_unboxed_unit] = STATE(3855),
    [sym_prefix_tuple] = STATE(3855),
    [sym_prefix_unboxed_tuple] = STATE(3855),
    [sym_prefix_unboxed_sum] = STATE(3855),
    [sym_literal] = STATE(3855),
    [sym__qualified_type] = STATE(3898),
    [sym__qtyconid] = STATE(3807),
    [sym__tycon_arrow] = STATE(3807),
    [sym__qtycon_arrow] = STATE(3807),
    [sym__promoted_tycons_alias] = STATE(3855),
    [sym__promoted_tycons] = STATE(3855),
    [sym__varsym_prefix] = STATE(3807),
    [sym__pvarsym] = STATE(3807),
    [sym__qvarsym_prefix] = STATE(3807),
    [sym__pqvarsym] = STATE(3807),
    [sym__consym_prefix] = STATE(3807),
    [sym__pconsym] = STATE(3807),
    [sym__qconsym_prefix] = STATE(3807),
    [sym__pqconsym] = STATE(3807),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(456),
    [sym__bracket_open] = STATE(964),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = ACTIONS(1363),
    [anon_sym__] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u2605] = ACTIONS(1373),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1383),
    [sym_char] = ACTIONS(1383),
    [sym_string] = ACTIONS(1383),
    [sym__integer_literal] = ACTIONS(1385),
    [sym__binary_literal] = ACTIONS(1387),
    [sym__octal_literal] = ACTIONS(1387),
    [sym__hex_literal] = ACTIONS(1387),
    [sym_implicit_variable] = ACTIONS(1391),
    [sym_name] = ACTIONS(2595),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1397),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1729] = {
    [sym__type_parens] = STATE(7152),
    [sym__type_tuple] = STATE(7138),
    [sym__type_unboxed_tuple] = STATE(7137),
    [sym__type_unboxed_sum] = STATE(7135),
    [sym__type_list] = STATE(7133),
    [sym__type_promoted] = STATE(7020),
    [sym__type_star] = STATE(7020),
    [sym__type_wildcard] = STATE(7020),
    [sym__type_apply] = STATE(7132),
    [sym__type_infix] = STATE(7130),
    [sym_type] = STATE(938),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10217),
    [sym__qtype_forall] = STATE(8973),
    [sym__qtype_forall_required] = STATE(9051),
    [sym_strict_field] = STATE(8612),
    [sym_lazy_field] = STATE(8612),
    [sym__qtype_function] = STATE(8981),
    [sym__qtype_linear_function] = STATE(8983),
    [sym__qtype_context] = STATE(8984),
    [sym_quantified_type] = STATE(8477),
    [sym_implicit_parameter] = STATE(8985),
    [sym__context_inline] = STATE(1729),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10934),
    [sym__splice_dollars] = STATE(7456),
    [sym_splice] = STATE(7020),
    [sym_quasiquote] = STATE(7020),
    [sym_integer] = STATE(7159),
    [sym__plist] = STATE(7124),
    [sym_unit] = STATE(7020),
    [sym_unboxed_unit] = STATE(7020),
    [sym_prefix_tuple] = STATE(7020),
    [sym_prefix_unboxed_tuple] = STATE(7020),
    [sym_prefix_unboxed_sum] = STATE(7020),
    [sym_literal] = STATE(7020),
    [sym__qualified_type] = STATE(7160),
    [sym__qtyconid] = STATE(7122),
    [sym__tycon_arrow] = STATE(7122),
    [sym__qtycon_arrow] = STATE(7122),
    [sym__promoted_tycons_alias] = STATE(7020),
    [sym__promoted_tycons] = STATE(7020),
    [sym__varsym_prefix] = STATE(7122),
    [sym__pvarsym] = STATE(7122),
    [sym__qvarsym_prefix] = STATE(7122),
    [sym__pqvarsym] = STATE(7122),
    [sym__consym_prefix] = STATE(7122),
    [sym__pconsym] = STATE(7122),
    [sym__qconsym_prefix] = STATE(7122),
    [sym__pqconsym] = STATE(7122),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(473),
    [sym__bracket_open] = STATE(1082),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = ACTIONS(2781),
    [anon_sym__] = ACTIONS(2783),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [anon_sym_STAR] = ACTIONS(2789),
    [anon_sym_u2605] = ACTIONS(2789),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2791),
    [sym_char] = ACTIONS(2791),
    [sym_string] = ACTIONS(2791),
    [sym__integer_literal] = ACTIONS(2793),
    [sym__binary_literal] = ACTIONS(2795),
    [sym__octal_literal] = ACTIONS(2795),
    [sym__hex_literal] = ACTIONS(2795),
    [sym_implicit_variable] = ACTIONS(3435),
    [sym_name] = ACTIONS(3437),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2799),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1730] = {
    [sym__exp_th_quoted_name] = STATE(4786),
    [sym__exp_parens] = STATE(4787),
    [sym__exp_tuple] = STATE(4788),
    [sym__exp_unboxed_tuple] = STATE(4789),
    [sym__exp_unboxed_sum] = STATE(4790),
    [sym__exp_list] = STATE(4791),
    [sym__exp_arithmetic_sequence] = STATE(4792),
    [sym__exp_list_comprehension] = STATE(4793),
    [sym__exp_lambda] = STATE(4794),
    [sym__exp_let_in] = STATE(4795),
    [sym__exp_conditional] = STATE(4796),
    [sym__do_keyword] = STATE(11297),
    [sym_do_module] = STATE(11297),
    [sym__do] = STATE(11297),
    [sym__exp_do] = STATE(4797),
    [sym__exp_case] = STATE(4800),
    [sym__exp_lambda_case] = STATE(4802),
    [sym__exp_lambda_cases] = STATE(4805),
    [sym__exp_multi_way_if] = STATE(4807),
    [sym__exp_record] = STATE(4813),
    [sym__exp_projection_selector] = STATE(4814),
    [sym__exp_projection] = STATE(4815),
    [sym__exp_apply] = STATE(4816),
    [sym__exp_section_left] = STATE(4817),
    [sym__exp_section_right] = STATE(4818),
    [sym__exp_negation] = STATE(4819),
    [sym__exp_infix] = STATE(4820),
    [sym_expression] = STATE(221),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9497),
    [sym__splice_dollars] = STATE(7390),
    [sym_splice] = STATE(4785),
    [sym_quasiquote] = STATE(4785),
    [sym__exp_quote] = STATE(4821),
    [sym__exp_typed_quote] = STATE(4785),
    [sym_integer] = STATE(4193),
    [sym__plist] = STATE(4826),
    [sym_unit] = STATE(4785),
    [sym_unboxed_unit] = STATE(4785),
    [sym_prefix_tuple] = STATE(4785),
    [sym_prefix_unboxed_tuple] = STATE(4785),
    [sym_prefix_unboxed_sum] = STATE(4785),
    [sym_literal] = STATE(4785),
    [sym__qualified_variable] = STATE(3934),
    [sym__qvarid] = STATE(4785),
    [sym__qvar] = STATE(4785),
    [sym__qualified_constructor] = STATE(4205),
    [sym__qconid] = STATE(4785),
    [sym__varsym_prefix] = STATE(4785),
    [sym__pvarsym] = STATE(4785),
    [sym__qvarsym_prefix] = STATE(4785),
    [sym__pqvarsym] = STATE(4785),
    [sym__consym_prefix] = STATE(4827),
    [sym__pconsym] = STATE(4827),
    [sym__qconsym_prefix] = STATE(4785),
    [sym__pqconsym] = STATE(4785),
    [sym__paren_open] = STATE(410),
    [sym__bracket_open] = STATE(1070),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = ACTIONS(697),
    [anon_sym_let] = ACTIONS(699),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_mdo] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(717),
    [sym_float] = ACTIONS(719),
    [sym_char] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym__integer_literal] = ACTIONS(721),
    [sym__binary_literal] = ACTIONS(723),
    [sym__octal_literal] = ACTIONS(723),
    [sym__hex_literal] = ACTIONS(723),
    [sym_implicit_variable] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [sym_label] = ACTIONS(725),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(731),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1731] = {
    [sym__type_parens] = STATE(3579),
    [sym__type_tuple] = STATE(3576),
    [sym__type_unboxed_tuple] = STATE(3572),
    [sym__type_unboxed_sum] = STATE(3570),
    [sym__type_list] = STATE(3569),
    [sym__type_promoted] = STATE(3582),
    [sym__type_star] = STATE(3582),
    [sym__type_wildcard] = STATE(3582),
    [sym__type_apply] = STATE(3567),
    [sym__type_infix] = STATE(3561),
    [sym_type] = STATE(511),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10109),
    [sym__qtype_forall] = STATE(3889),
    [sym__qtype_forall_required] = STATE(3901),
    [sym_strict_field] = STATE(8615),
    [sym_lazy_field] = STATE(8615),
    [sym__qtype_function] = STATE(3902),
    [sym__qtype_linear_function] = STATE(3905),
    [sym__qtype_context] = STATE(3909),
    [sym_quantified_type] = STATE(2936),
    [sym_implicit_parameter] = STATE(3910),
    [sym__context_inline] = STATE(1708),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11208),
    [sym__splice_dollars] = STATE(7292),
    [sym_splice] = STATE(3582),
    [sym_quasiquote] = STATE(3582),
    [sym_integer] = STATE(3435),
    [sym__plist] = STATE(3559),
    [sym_unit] = STATE(3582),
    [sym_unboxed_unit] = STATE(3582),
    [sym_prefix_tuple] = STATE(3582),
    [sym_prefix_unboxed_tuple] = STATE(3582),
    [sym_prefix_unboxed_sum] = STATE(3582),
    [sym_literal] = STATE(3582),
    [sym__qualified_type] = STATE(3610),
    [sym__qtyconid] = STATE(3556),
    [sym__tycon_arrow] = STATE(3556),
    [sym__qtycon_arrow] = STATE(3556),
    [sym__promoted_tycons_alias] = STATE(3582),
    [sym__promoted_tycons] = STATE(3582),
    [sym__varsym_prefix] = STATE(3556),
    [sym__pvarsym] = STATE(3556),
    [sym__qvarsym_prefix] = STATE(3556),
    [sym__pqvarsym] = STATE(3556),
    [sym__consym_prefix] = STATE(3556),
    [sym__pconsym] = STATE(3556),
    [sym__qconsym_prefix] = STATE(3556),
    [sym__pqconsym] = STATE(3556),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(465),
    [sym__bracket_open] = STATE(1069),
    [sym__unboxed_open] = STATE(772),
    [sym_variable] = ACTIONS(1649),
    [anon_sym__] = ACTIONS(1651),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_u2605] = ACTIONS(1657),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1659),
    [sym_char] = ACTIONS(1659),
    [sym_string] = ACTIONS(1659),
    [sym__integer_literal] = ACTIONS(1661),
    [sym__binary_literal] = ACTIONS(1663),
    [sym__octal_literal] = ACTIONS(1663),
    [sym__hex_literal] = ACTIONS(1663),
    [sym_implicit_variable] = ACTIONS(3359),
    [sym_name] = ACTIONS(3361),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1667),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1732] = {
    [sym__type_parens] = STATE(3220),
    [sym__type_tuple] = STATE(3210),
    [sym__type_unboxed_tuple] = STATE(3184),
    [sym__type_unboxed_sum] = STATE(3188),
    [sym__type_list] = STATE(3211),
    [sym__type_promoted] = STATE(3364),
    [sym__type_star] = STATE(3364),
    [sym__type_wildcard] = STATE(3364),
    [sym__type_apply] = STATE(3196),
    [sym__type_infix] = STATE(3225),
    [sym_type] = STATE(480),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10104),
    [sym__qtype_forall] = STATE(3791),
    [sym__qtype_forall_required] = STATE(3793),
    [sym_strict_field] = STATE(8711),
    [sym_lazy_field] = STATE(8711),
    [sym__qtype_function] = STATE(3794),
    [sym__qtype_linear_function] = STATE(3797),
    [sym__qtype_context] = STATE(3798),
    [sym_quantified_type] = STATE(2793),
    [sym_implicit_parameter] = STATE(3799),
    [sym__context_inline] = STATE(1724),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11198),
    [sym__splice_dollars] = STATE(7401),
    [sym_splice] = STATE(3364),
    [sym_quasiquote] = STATE(3364),
    [sym_integer] = STATE(3397),
    [sym__plist] = STATE(3177),
    [sym_unit] = STATE(3364),
    [sym_unboxed_unit] = STATE(3364),
    [sym_prefix_tuple] = STATE(3364),
    [sym_prefix_unboxed_tuple] = STATE(3364),
    [sym_prefix_unboxed_sum] = STATE(3364),
    [sym_literal] = STATE(3364),
    [sym__qualified_type] = STATE(3262),
    [sym__qtyconid] = STATE(3232),
    [sym__tycon_arrow] = STATE(3232),
    [sym__qtycon_arrow] = STATE(3232),
    [sym__promoted_tycons_alias] = STATE(3364),
    [sym__promoted_tycons] = STATE(3364),
    [sym__varsym_prefix] = STATE(3232),
    [sym__pvarsym] = STATE(3232),
    [sym__qvarsym_prefix] = STATE(3232),
    [sym__pqvarsym] = STATE(3232),
    [sym__consym_prefix] = STATE(3232),
    [sym__pconsym] = STATE(3232),
    [sym__qconsym_prefix] = STATE(3232),
    [sym__pqconsym] = STATE(3232),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(466),
    [sym__bracket_open] = STATE(1073),
    [sym__unboxed_open] = STATE(781),
    [sym_variable] = ACTIONS(1569),
    [anon_sym__] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(1577),
    [anon_sym_u2605] = ACTIONS(1577),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1579),
    [sym_char] = ACTIONS(1579),
    [sym_string] = ACTIONS(1579),
    [sym__integer_literal] = ACTIONS(1581),
    [sym__binary_literal] = ACTIONS(1583),
    [sym__octal_literal] = ACTIONS(1583),
    [sym__hex_literal] = ACTIONS(1583),
    [sym_implicit_variable] = ACTIONS(3441),
    [sym_name] = ACTIONS(3443),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1587),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1733] = {
    [sym__type_parens] = STATE(3220),
    [sym__type_tuple] = STATE(3210),
    [sym__type_unboxed_tuple] = STATE(3184),
    [sym__type_unboxed_sum] = STATE(3188),
    [sym__type_list] = STATE(3211),
    [sym__type_promoted] = STATE(3364),
    [sym__type_star] = STATE(3364),
    [sym__type_wildcard] = STATE(3364),
    [sym__type_apply] = STATE(3196),
    [sym__type_infix] = STATE(3225),
    [sym_type] = STATE(480),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10104),
    [sym__qtype_forall] = STATE(3791),
    [sym__qtype_forall_required] = STATE(3793),
    [sym_strict_field] = STATE(8711),
    [sym_lazy_field] = STATE(8711),
    [sym__qtype_function] = STATE(3794),
    [sym__qtype_linear_function] = STATE(3797),
    [sym__qtype_context] = STATE(3798),
    [sym_quantified_type] = STATE(2780),
    [sym_implicit_parameter] = STATE(3799),
    [sym__context_inline] = STATE(1724),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11198),
    [sym__splice_dollars] = STATE(7401),
    [sym_splice] = STATE(3364),
    [sym_quasiquote] = STATE(3364),
    [sym_integer] = STATE(3397),
    [sym__plist] = STATE(3177),
    [sym_unit] = STATE(3364),
    [sym_unboxed_unit] = STATE(3364),
    [sym_prefix_tuple] = STATE(3364),
    [sym_prefix_unboxed_tuple] = STATE(3364),
    [sym_prefix_unboxed_sum] = STATE(3364),
    [sym_literal] = STATE(3364),
    [sym__qualified_type] = STATE(3262),
    [sym__qtyconid] = STATE(3232),
    [sym__tycon_arrow] = STATE(3232),
    [sym__qtycon_arrow] = STATE(3232),
    [sym__promoted_tycons_alias] = STATE(3364),
    [sym__promoted_tycons] = STATE(3364),
    [sym__varsym_prefix] = STATE(3232),
    [sym__pvarsym] = STATE(3232),
    [sym__qvarsym_prefix] = STATE(3232),
    [sym__pqvarsym] = STATE(3232),
    [sym__consym_prefix] = STATE(3232),
    [sym__pconsym] = STATE(3232),
    [sym__qconsym_prefix] = STATE(3232),
    [sym__pqconsym] = STATE(3232),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(466),
    [sym__bracket_open] = STATE(1073),
    [sym__unboxed_open] = STATE(781),
    [sym_variable] = ACTIONS(1569),
    [anon_sym__] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(1577),
    [anon_sym_u2605] = ACTIONS(1577),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1579),
    [sym_char] = ACTIONS(1579),
    [sym_string] = ACTIONS(1579),
    [sym__integer_literal] = ACTIONS(1581),
    [sym__binary_literal] = ACTIONS(1583),
    [sym__octal_literal] = ACTIONS(1583),
    [sym__hex_literal] = ACTIONS(1583),
    [sym_implicit_variable] = ACTIONS(3441),
    [sym_name] = ACTIONS(3443),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1587),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1734] = {
    [sym__type_parens] = STATE(3220),
    [sym__type_tuple] = STATE(3210),
    [sym__type_unboxed_tuple] = STATE(3184),
    [sym__type_unboxed_sum] = STATE(3188),
    [sym__type_list] = STATE(3211),
    [sym__type_promoted] = STATE(3364),
    [sym__type_star] = STATE(3364),
    [sym__type_wildcard] = STATE(3364),
    [sym__type_apply] = STATE(3196),
    [sym__type_infix] = STATE(3225),
    [sym_type] = STATE(480),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10104),
    [sym__qtype_forall] = STATE(3791),
    [sym__qtype_forall_required] = STATE(3793),
    [sym_strict_field] = STATE(8711),
    [sym_lazy_field] = STATE(8711),
    [sym__qtype_function] = STATE(3794),
    [sym__qtype_linear_function] = STATE(3797),
    [sym__qtype_context] = STATE(3798),
    [sym_quantified_type] = STATE(2794),
    [sym_implicit_parameter] = STATE(3799),
    [sym__context_inline] = STATE(1724),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11198),
    [sym__splice_dollars] = STATE(7401),
    [sym_splice] = STATE(3364),
    [sym_quasiquote] = STATE(3364),
    [sym_integer] = STATE(3397),
    [sym__plist] = STATE(3177),
    [sym_unit] = STATE(3364),
    [sym_unboxed_unit] = STATE(3364),
    [sym_prefix_tuple] = STATE(3364),
    [sym_prefix_unboxed_tuple] = STATE(3364),
    [sym_prefix_unboxed_sum] = STATE(3364),
    [sym_literal] = STATE(3364),
    [sym__qualified_type] = STATE(3262),
    [sym__qtyconid] = STATE(3232),
    [sym__tycon_arrow] = STATE(3232),
    [sym__qtycon_arrow] = STATE(3232),
    [sym__promoted_tycons_alias] = STATE(3364),
    [sym__promoted_tycons] = STATE(3364),
    [sym__varsym_prefix] = STATE(3232),
    [sym__pvarsym] = STATE(3232),
    [sym__qvarsym_prefix] = STATE(3232),
    [sym__pqvarsym] = STATE(3232),
    [sym__consym_prefix] = STATE(3232),
    [sym__pconsym] = STATE(3232),
    [sym__qconsym_prefix] = STATE(3232),
    [sym__pqconsym] = STATE(3232),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(466),
    [sym__bracket_open] = STATE(1073),
    [sym__unboxed_open] = STATE(781),
    [sym_variable] = ACTIONS(1569),
    [anon_sym__] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(1577),
    [anon_sym_u2605] = ACTIONS(1577),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1579),
    [sym_char] = ACTIONS(1579),
    [sym_string] = ACTIONS(1579),
    [sym__integer_literal] = ACTIONS(1581),
    [sym__binary_literal] = ACTIONS(1583),
    [sym__octal_literal] = ACTIONS(1583),
    [sym__hex_literal] = ACTIONS(1583),
    [sym_implicit_variable] = ACTIONS(3441),
    [sym_name] = ACTIONS(3443),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1587),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1735] = {
    [sym__type_parens] = STATE(3220),
    [sym__type_tuple] = STATE(3210),
    [sym__type_unboxed_tuple] = STATE(3184),
    [sym__type_unboxed_sum] = STATE(3188),
    [sym__type_list] = STATE(3211),
    [sym__type_promoted] = STATE(3364),
    [sym__type_star] = STATE(3364),
    [sym__type_wildcard] = STATE(3364),
    [sym__type_apply] = STATE(3196),
    [sym__type_infix] = STATE(3225),
    [sym_type] = STATE(480),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10104),
    [sym__qtype_forall] = STATE(3791),
    [sym__qtype_forall_required] = STATE(3793),
    [sym_strict_field] = STATE(8711),
    [sym_lazy_field] = STATE(8711),
    [sym__qtype_function] = STATE(3794),
    [sym__qtype_linear_function] = STATE(3797),
    [sym__qtype_context] = STATE(3798),
    [sym_quantified_type] = STATE(2798),
    [sym_implicit_parameter] = STATE(3799),
    [sym__context_inline] = STATE(1724),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11198),
    [sym__splice_dollars] = STATE(7401),
    [sym_splice] = STATE(3364),
    [sym_quasiquote] = STATE(3364),
    [sym_integer] = STATE(3397),
    [sym__plist] = STATE(3177),
    [sym_unit] = STATE(3364),
    [sym_unboxed_unit] = STATE(3364),
    [sym_prefix_tuple] = STATE(3364),
    [sym_prefix_unboxed_tuple] = STATE(3364),
    [sym_prefix_unboxed_sum] = STATE(3364),
    [sym_literal] = STATE(3364),
    [sym__qualified_type] = STATE(3262),
    [sym__qtyconid] = STATE(3232),
    [sym__tycon_arrow] = STATE(3232),
    [sym__qtycon_arrow] = STATE(3232),
    [sym__promoted_tycons_alias] = STATE(3364),
    [sym__promoted_tycons] = STATE(3364),
    [sym__varsym_prefix] = STATE(3232),
    [sym__pvarsym] = STATE(3232),
    [sym__qvarsym_prefix] = STATE(3232),
    [sym__pqvarsym] = STATE(3232),
    [sym__consym_prefix] = STATE(3232),
    [sym__pconsym] = STATE(3232),
    [sym__qconsym_prefix] = STATE(3232),
    [sym__pqconsym] = STATE(3232),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(466),
    [sym__bracket_open] = STATE(1073),
    [sym__unboxed_open] = STATE(781),
    [sym_variable] = ACTIONS(1569),
    [anon_sym__] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(1577),
    [anon_sym_u2605] = ACTIONS(1577),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1579),
    [sym_char] = ACTIONS(1579),
    [sym_string] = ACTIONS(1579),
    [sym__integer_literal] = ACTIONS(1581),
    [sym__binary_literal] = ACTIONS(1583),
    [sym__octal_literal] = ACTIONS(1583),
    [sym__hex_literal] = ACTIONS(1583),
    [sym_implicit_variable] = ACTIONS(3441),
    [sym_name] = ACTIONS(3443),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1587),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1736] = {
    [sym__type_parens] = STATE(3220),
    [sym__type_tuple] = STATE(3210),
    [sym__type_unboxed_tuple] = STATE(3184),
    [sym__type_unboxed_sum] = STATE(3188),
    [sym__type_list] = STATE(3211),
    [sym__type_promoted] = STATE(3364),
    [sym__type_star] = STATE(3364),
    [sym__type_wildcard] = STATE(3364),
    [sym__type_apply] = STATE(3196),
    [sym__type_infix] = STATE(3225),
    [sym_type] = STATE(480),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10104),
    [sym__qtype_forall] = STATE(3791),
    [sym__qtype_forall_required] = STATE(3793),
    [sym_strict_field] = STATE(8711),
    [sym_lazy_field] = STATE(8711),
    [sym__qtype_function] = STATE(3794),
    [sym__qtype_linear_function] = STATE(3797),
    [sym__qtype_context] = STATE(3798),
    [sym_quantified_type] = STATE(2801),
    [sym_implicit_parameter] = STATE(3799),
    [sym__context_inline] = STATE(1724),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11198),
    [sym__splice_dollars] = STATE(7401),
    [sym_splice] = STATE(3364),
    [sym_quasiquote] = STATE(3364),
    [sym_integer] = STATE(3397),
    [sym__plist] = STATE(3177),
    [sym_unit] = STATE(3364),
    [sym_unboxed_unit] = STATE(3364),
    [sym_prefix_tuple] = STATE(3364),
    [sym_prefix_unboxed_tuple] = STATE(3364),
    [sym_prefix_unboxed_sum] = STATE(3364),
    [sym_literal] = STATE(3364),
    [sym__qualified_type] = STATE(3262),
    [sym__qtyconid] = STATE(3232),
    [sym__tycon_arrow] = STATE(3232),
    [sym__qtycon_arrow] = STATE(3232),
    [sym__promoted_tycons_alias] = STATE(3364),
    [sym__promoted_tycons] = STATE(3364),
    [sym__varsym_prefix] = STATE(3232),
    [sym__pvarsym] = STATE(3232),
    [sym__qvarsym_prefix] = STATE(3232),
    [sym__pqvarsym] = STATE(3232),
    [sym__consym_prefix] = STATE(3232),
    [sym__pconsym] = STATE(3232),
    [sym__qconsym_prefix] = STATE(3232),
    [sym__pqconsym] = STATE(3232),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(466),
    [sym__bracket_open] = STATE(1073),
    [sym__unboxed_open] = STATE(781),
    [sym_variable] = ACTIONS(1569),
    [anon_sym__] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(1577),
    [anon_sym_u2605] = ACTIONS(1577),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1579),
    [sym_char] = ACTIONS(1579),
    [sym_string] = ACTIONS(1579),
    [sym__integer_literal] = ACTIONS(1581),
    [sym__binary_literal] = ACTIONS(1583),
    [sym__octal_literal] = ACTIONS(1583),
    [sym__hex_literal] = ACTIONS(1583),
    [sym_implicit_variable] = ACTIONS(3441),
    [sym_name] = ACTIONS(3443),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1587),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1737] = {
    [sym__type_parens] = STATE(3220),
    [sym__type_tuple] = STATE(3210),
    [sym__type_unboxed_tuple] = STATE(3184),
    [sym__type_unboxed_sum] = STATE(3188),
    [sym__type_list] = STATE(3211),
    [sym__type_promoted] = STATE(3364),
    [sym__type_star] = STATE(3364),
    [sym__type_wildcard] = STATE(3364),
    [sym__type_apply] = STATE(3196),
    [sym__type_infix] = STATE(3225),
    [sym_type] = STATE(480),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10104),
    [sym__qtype_forall] = STATE(3791),
    [sym__qtype_forall_required] = STATE(3793),
    [sym_strict_field] = STATE(8711),
    [sym_lazy_field] = STATE(8711),
    [sym__qtype_function] = STATE(3794),
    [sym__qtype_linear_function] = STATE(3797),
    [sym__qtype_context] = STATE(3798),
    [sym_quantified_type] = STATE(2805),
    [sym_implicit_parameter] = STATE(3799),
    [sym__context_inline] = STATE(1724),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11198),
    [sym__splice_dollars] = STATE(7401),
    [sym_splice] = STATE(3364),
    [sym_quasiquote] = STATE(3364),
    [sym_integer] = STATE(3397),
    [sym__plist] = STATE(3177),
    [sym_unit] = STATE(3364),
    [sym_unboxed_unit] = STATE(3364),
    [sym_prefix_tuple] = STATE(3364),
    [sym_prefix_unboxed_tuple] = STATE(3364),
    [sym_prefix_unboxed_sum] = STATE(3364),
    [sym_literal] = STATE(3364),
    [sym__qualified_type] = STATE(3262),
    [sym__qtyconid] = STATE(3232),
    [sym__tycon_arrow] = STATE(3232),
    [sym__qtycon_arrow] = STATE(3232),
    [sym__promoted_tycons_alias] = STATE(3364),
    [sym__promoted_tycons] = STATE(3364),
    [sym__varsym_prefix] = STATE(3232),
    [sym__pvarsym] = STATE(3232),
    [sym__qvarsym_prefix] = STATE(3232),
    [sym__pqvarsym] = STATE(3232),
    [sym__consym_prefix] = STATE(3232),
    [sym__pconsym] = STATE(3232),
    [sym__qconsym_prefix] = STATE(3232),
    [sym__pqconsym] = STATE(3232),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(466),
    [sym__bracket_open] = STATE(1073),
    [sym__unboxed_open] = STATE(781),
    [sym_variable] = ACTIONS(1569),
    [anon_sym__] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(1577),
    [anon_sym_u2605] = ACTIONS(1577),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1579),
    [sym_char] = ACTIONS(1579),
    [sym_string] = ACTIONS(1579),
    [sym__integer_literal] = ACTIONS(1581),
    [sym__binary_literal] = ACTIONS(1583),
    [sym__octal_literal] = ACTIONS(1583),
    [sym__hex_literal] = ACTIONS(1583),
    [sym_implicit_variable] = ACTIONS(3441),
    [sym_name] = ACTIONS(3443),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1587),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1738] = {
    [sym__type_parens] = STATE(3294),
    [sym__type_tuple] = STATE(3295),
    [sym__type_unboxed_tuple] = STATE(3296),
    [sym__type_unboxed_sum] = STATE(3298),
    [sym__type_list] = STATE(3311),
    [sym__type_promoted] = STATE(3292),
    [sym__type_star] = STATE(3292),
    [sym__type_wildcard] = STATE(3292),
    [sym__type_apply] = STATE(3313),
    [sym__type_infix] = STATE(3314),
    [sym_type] = STATE(478),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10086),
    [sym__qtype_forall] = STATE(3726),
    [sym__qtype_forall_required] = STATE(3727),
    [sym_strict_field] = STATE(8686),
    [sym_lazy_field] = STATE(8686),
    [sym__qtype_function] = STATE(3728),
    [sym__qtype_linear_function] = STATE(3729),
    [sym__qtype_context] = STATE(3730),
    [sym_quantified_type] = STATE(2834),
    [sym_implicit_parameter] = STATE(3720),
    [sym__context_inline] = STATE(1666),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11151),
    [sym__splice_dollars] = STATE(7231),
    [sym_splice] = STATE(3292),
    [sym_quasiquote] = STATE(3292),
    [sym_integer] = STATE(3286),
    [sym__plist] = STATE(3318),
    [sym_unit] = STATE(3292),
    [sym_unboxed_unit] = STATE(3292),
    [sym_prefix_tuple] = STATE(3292),
    [sym_prefix_unboxed_tuple] = STATE(3292),
    [sym_prefix_unboxed_sum] = STATE(3292),
    [sym_literal] = STATE(3292),
    [sym__qualified_type] = STATE(3249),
    [sym__qtyconid] = STATE(3320),
    [sym__tycon_arrow] = STATE(3320),
    [sym__qtycon_arrow] = STATE(3320),
    [sym__promoted_tycons_alias] = STATE(3292),
    [sym__promoted_tycons] = STATE(3292),
    [sym__varsym_prefix] = STATE(3320),
    [sym__pvarsym] = STATE(3320),
    [sym__qvarsym_prefix] = STATE(3320),
    [sym__pqvarsym] = STATE(3320),
    [sym__consym_prefix] = STATE(3320),
    [sym__pconsym] = STATE(3320),
    [sym__qconsym_prefix] = STATE(3320),
    [sym__pqconsym] = STATE(3320),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(458),
    [sym__bracket_open] = STATE(1120),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = ACTIONS(1589),
    [anon_sym__] = ACTIONS(1591),
    [anon_sym_SQUOTE] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(1597),
    [anon_sym_u2605] = ACTIONS(1597),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1599),
    [sym_char] = ACTIONS(1599),
    [sym_string] = ACTIONS(1599),
    [sym__integer_literal] = ACTIONS(1601),
    [sym__binary_literal] = ACTIONS(1603),
    [sym__octal_literal] = ACTIONS(1603),
    [sym__hex_literal] = ACTIONS(1603),
    [sym_implicit_variable] = ACTIONS(3469),
    [sym_name] = ACTIONS(3471),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1607),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1739] = {
    [sym__type_parens] = STATE(6323),
    [sym__type_tuple] = STATE(6324),
    [sym__type_unboxed_tuple] = STATE(6325),
    [sym__type_unboxed_sum] = STATE(6326),
    [sym__type_list] = STATE(6327),
    [sym__type_promoted] = STATE(6321),
    [sym__type_star] = STATE(6321),
    [sym__type_wildcard] = STATE(6321),
    [sym__type_apply] = STATE(6328),
    [sym__type_infix] = STATE(6329),
    [sym_type] = STATE(754),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10134),
    [sym__qtype_forall] = STATE(8674),
    [sym__qtype_forall_required] = STATE(8673),
    [sym_strict_field] = STATE(8650),
    [sym_lazy_field] = STATE(8650),
    [sym__qtype_function] = STATE(8647),
    [sym__qtype_linear_function] = STATE(8671),
    [sym__qtype_context] = STATE(8665),
    [sym_quantified_type] = STATE(8274),
    [sym_implicit_parameter] = STATE(8661),
    [sym__context_inline] = STATE(1567),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11328),
    [sym__splice_dollars] = STATE(7407),
    [sym_splice] = STATE(6321),
    [sym_quasiquote] = STATE(6321),
    [sym_integer] = STATE(6269),
    [sym__plist] = STATE(6330),
    [sym_unit] = STATE(6321),
    [sym_unboxed_unit] = STATE(6321),
    [sym_prefix_tuple] = STATE(6321),
    [sym_prefix_unboxed_tuple] = STATE(6321),
    [sym_prefix_unboxed_sum] = STATE(6321),
    [sym_literal] = STATE(6321),
    [sym__qualified_type] = STATE(6286),
    [sym__qtyconid] = STATE(6331),
    [sym__tycon_arrow] = STATE(6331),
    [sym__qtycon_arrow] = STATE(6331),
    [sym__promoted_tycons_alias] = STATE(6321),
    [sym__promoted_tycons] = STATE(6321),
    [sym__varsym_prefix] = STATE(6331),
    [sym__pvarsym] = STATE(6331),
    [sym__qvarsym_prefix] = STATE(6331),
    [sym__pqvarsym] = STATE(6331),
    [sym__consym_prefix] = STATE(6331),
    [sym__pconsym] = STATE(6331),
    [sym__qconsym_prefix] = STATE(6331),
    [sym__pqconsym] = STATE(6331),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(469),
    [sym__bracket_open] = STATE(990),
    [sym__unboxed_open] = STATE(810),
    [sym_variable] = ACTIONS(2155),
    [anon_sym__] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(2163),
    [anon_sym_u2605] = ACTIONS(2163),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2165),
    [sym_char] = ACTIONS(2165),
    [sym_string] = ACTIONS(2165),
    [sym__integer_literal] = ACTIONS(2167),
    [sym__binary_literal] = ACTIONS(2169),
    [sym__octal_literal] = ACTIONS(2169),
    [sym__hex_literal] = ACTIONS(2169),
    [sym_implicit_variable] = ACTIONS(3429),
    [sym_name] = ACTIONS(3431),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2173),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1740] = {
    [sym__type_parens] = STATE(3294),
    [sym__type_tuple] = STATE(3295),
    [sym__type_unboxed_tuple] = STATE(3296),
    [sym__type_unboxed_sum] = STATE(3298),
    [sym__type_list] = STATE(3311),
    [sym__type_promoted] = STATE(3292),
    [sym__type_star] = STATE(3292),
    [sym__type_wildcard] = STATE(3292),
    [sym__type_apply] = STATE(3313),
    [sym__type_infix] = STATE(3314),
    [sym_type] = STATE(478),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10086),
    [sym__qtype_forall] = STATE(3726),
    [sym__qtype_forall_required] = STATE(3727),
    [sym_strict_field] = STATE(8686),
    [sym_lazy_field] = STATE(8686),
    [sym__qtype_function] = STATE(3728),
    [sym__qtype_linear_function] = STATE(3729),
    [sym__qtype_context] = STATE(3730),
    [sym_quantified_type] = STATE(2827),
    [sym_implicit_parameter] = STATE(3720),
    [sym__context_inline] = STATE(1666),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11151),
    [sym__splice_dollars] = STATE(7231),
    [sym_splice] = STATE(3292),
    [sym_quasiquote] = STATE(3292),
    [sym_integer] = STATE(3286),
    [sym__plist] = STATE(3318),
    [sym_unit] = STATE(3292),
    [sym_unboxed_unit] = STATE(3292),
    [sym_prefix_tuple] = STATE(3292),
    [sym_prefix_unboxed_tuple] = STATE(3292),
    [sym_prefix_unboxed_sum] = STATE(3292),
    [sym_literal] = STATE(3292),
    [sym__qualified_type] = STATE(3249),
    [sym__qtyconid] = STATE(3320),
    [sym__tycon_arrow] = STATE(3320),
    [sym__qtycon_arrow] = STATE(3320),
    [sym__promoted_tycons_alias] = STATE(3292),
    [sym__promoted_tycons] = STATE(3292),
    [sym__varsym_prefix] = STATE(3320),
    [sym__pvarsym] = STATE(3320),
    [sym__qvarsym_prefix] = STATE(3320),
    [sym__pqvarsym] = STATE(3320),
    [sym__consym_prefix] = STATE(3320),
    [sym__pconsym] = STATE(3320),
    [sym__qconsym_prefix] = STATE(3320),
    [sym__pqconsym] = STATE(3320),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(458),
    [sym__bracket_open] = STATE(1120),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = ACTIONS(1589),
    [anon_sym__] = ACTIONS(1591),
    [anon_sym_SQUOTE] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(1597),
    [anon_sym_u2605] = ACTIONS(1597),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1599),
    [sym_char] = ACTIONS(1599),
    [sym_string] = ACTIONS(1599),
    [sym__integer_literal] = ACTIONS(1601),
    [sym__binary_literal] = ACTIONS(1603),
    [sym__octal_literal] = ACTIONS(1603),
    [sym__hex_literal] = ACTIONS(1603),
    [sym_implicit_variable] = ACTIONS(3469),
    [sym_name] = ACTIONS(3471),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1607),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1741] = {
    [sym__type_parens] = STATE(3294),
    [sym__type_tuple] = STATE(3295),
    [sym__type_unboxed_tuple] = STATE(3296),
    [sym__type_unboxed_sum] = STATE(3298),
    [sym__type_list] = STATE(3311),
    [sym__type_promoted] = STATE(3292),
    [sym__type_star] = STATE(3292),
    [sym__type_wildcard] = STATE(3292),
    [sym__type_apply] = STATE(3313),
    [sym__type_infix] = STATE(3314),
    [sym_type] = STATE(478),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10086),
    [sym__qtype_forall] = STATE(3726),
    [sym__qtype_forall_required] = STATE(3727),
    [sym_strict_field] = STATE(8686),
    [sym_lazy_field] = STATE(8686),
    [sym__qtype_function] = STATE(3728),
    [sym__qtype_linear_function] = STATE(3729),
    [sym__qtype_context] = STATE(3730),
    [sym_quantified_type] = STATE(2833),
    [sym_implicit_parameter] = STATE(3720),
    [sym__context_inline] = STATE(1666),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11151),
    [sym__splice_dollars] = STATE(7231),
    [sym_splice] = STATE(3292),
    [sym_quasiquote] = STATE(3292),
    [sym_integer] = STATE(3286),
    [sym__plist] = STATE(3318),
    [sym_unit] = STATE(3292),
    [sym_unboxed_unit] = STATE(3292),
    [sym_prefix_tuple] = STATE(3292),
    [sym_prefix_unboxed_tuple] = STATE(3292),
    [sym_prefix_unboxed_sum] = STATE(3292),
    [sym_literal] = STATE(3292),
    [sym__qualified_type] = STATE(3249),
    [sym__qtyconid] = STATE(3320),
    [sym__tycon_arrow] = STATE(3320),
    [sym__qtycon_arrow] = STATE(3320),
    [sym__promoted_tycons_alias] = STATE(3292),
    [sym__promoted_tycons] = STATE(3292),
    [sym__varsym_prefix] = STATE(3320),
    [sym__pvarsym] = STATE(3320),
    [sym__qvarsym_prefix] = STATE(3320),
    [sym__pqvarsym] = STATE(3320),
    [sym__consym_prefix] = STATE(3320),
    [sym__pconsym] = STATE(3320),
    [sym__qconsym_prefix] = STATE(3320),
    [sym__pqconsym] = STATE(3320),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(458),
    [sym__bracket_open] = STATE(1120),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = ACTIONS(1589),
    [anon_sym__] = ACTIONS(1591),
    [anon_sym_SQUOTE] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(1597),
    [anon_sym_u2605] = ACTIONS(1597),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1599),
    [sym_char] = ACTIONS(1599),
    [sym_string] = ACTIONS(1599),
    [sym__integer_literal] = ACTIONS(1601),
    [sym__binary_literal] = ACTIONS(1603),
    [sym__octal_literal] = ACTIONS(1603),
    [sym__hex_literal] = ACTIONS(1603),
    [sym_implicit_variable] = ACTIONS(3469),
    [sym_name] = ACTIONS(3471),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1607),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1742] = {
    [sym__type_parens] = STATE(6473),
    [sym__type_tuple] = STATE(6477),
    [sym__type_unboxed_tuple] = STATE(6479),
    [sym__type_unboxed_sum] = STATE(6480),
    [sym__type_list] = STATE(6481),
    [sym__type_promoted] = STATE(6470),
    [sym__type_star] = STATE(6470),
    [sym__type_wildcard] = STATE(6470),
    [sym__type_apply] = STATE(6483),
    [sym__type_infix] = STATE(6404),
    [sym_type] = STATE(773),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10288),
    [sym__qtype_forall] = STATE(7866),
    [sym__qtype_forall_required] = STATE(7871),
    [sym_strict_field] = STATE(8656),
    [sym_lazy_field] = STATE(8656),
    [sym__qtype_function] = STATE(7880),
    [sym__qtype_linear_function] = STATE(7876),
    [sym__qtype_context] = STATE(7870),
    [sym_quantified_type] = STATE(8252),
    [sym_implicit_parameter] = STATE(7869),
    [sym__context_inline] = STATE(1742),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11091),
    [sym__splice_dollars] = STATE(7378),
    [sym_splice] = STATE(6470),
    [sym_quasiquote] = STATE(6470),
    [sym_integer] = STATE(6258),
    [sym__plist] = STATE(6490),
    [sym_unit] = STATE(6470),
    [sym_unboxed_unit] = STATE(6470),
    [sym_prefix_tuple] = STATE(6470),
    [sym_prefix_unboxed_tuple] = STATE(6470),
    [sym_prefix_unboxed_sum] = STATE(6470),
    [sym_literal] = STATE(6470),
    [sym__qualified_type] = STATE(6456),
    [sym__qtyconid] = STATE(6494),
    [sym__tycon_arrow] = STATE(6494),
    [sym__qtycon_arrow] = STATE(6494),
    [sym__promoted_tycons_alias] = STATE(6470),
    [sym__promoted_tycons] = STATE(6470),
    [sym__varsym_prefix] = STATE(6494),
    [sym__pvarsym] = STATE(6494),
    [sym__qvarsym_prefix] = STATE(6494),
    [sym__pqvarsym] = STATE(6494),
    [sym__consym_prefix] = STATE(6494),
    [sym__pconsym] = STATE(6494),
    [sym__qconsym_prefix] = STATE(6494),
    [sym__pqconsym] = STATE(6494),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(449),
    [sym__bracket_open] = STATE(1028),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = ACTIONS(1989),
    [anon_sym__] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u2605] = ACTIONS(1997),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2001),
    [sym_char] = ACTIONS(2001),
    [sym_string] = ACTIONS(2001),
    [sym__integer_literal] = ACTIONS(2003),
    [sym__binary_literal] = ACTIONS(2005),
    [sym__octal_literal] = ACTIONS(2005),
    [sym__hex_literal] = ACTIONS(2005),
    [sym_implicit_variable] = ACTIONS(2009),
    [sym_name] = ACTIONS(2011),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2015),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1743] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8320),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1744] = {
    [sym__type_parens] = STATE(6447),
    [sym__type_tuple] = STATE(6435),
    [sym__type_unboxed_tuple] = STATE(6432),
    [sym__type_unboxed_sum] = STATE(6431),
    [sym__type_list] = STATE(6430),
    [sym__type_promoted] = STATE(6452),
    [sym__type_star] = STATE(6452),
    [sym__type_wildcard] = STATE(6452),
    [sym__type_apply] = STATE(6425),
    [sym__type_infix] = STATE(6459),
    [sym_type] = STATE(738),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10253),
    [sym__qtype_forall] = STATE(8716),
    [sym__qtype_forall_required] = STATE(8717),
    [sym_strict_field] = STATE(8682),
    [sym_lazy_field] = STATE(8682),
    [sym__qtype_function] = STATE(8718),
    [sym__qtype_linear_function] = STATE(8695),
    [sym__qtype_context] = STATE(8701),
    [sym_quantified_type] = STATE(8351),
    [sym_implicit_parameter] = STATE(8698),
    [sym__context_inline] = STATE(1532),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11242),
    [sym__splice_dollars] = STATE(7322),
    [sym_splice] = STATE(6452),
    [sym_quasiquote] = STATE(6452),
    [sym_integer] = STATE(6547),
    [sym__plist] = STATE(6424),
    [sym_unit] = STATE(6452),
    [sym_unboxed_unit] = STATE(6452),
    [sym_prefix_tuple] = STATE(6452),
    [sym_prefix_unboxed_tuple] = STATE(6452),
    [sym_prefix_unboxed_sum] = STATE(6452),
    [sym_literal] = STATE(6452),
    [sym__qualified_type] = STATE(6256),
    [sym__qtyconid] = STATE(6408),
    [sym__tycon_arrow] = STATE(6408),
    [sym__qtycon_arrow] = STATE(6408),
    [sym__promoted_tycons_alias] = STATE(6452),
    [sym__promoted_tycons] = STATE(6452),
    [sym__varsym_prefix] = STATE(6408),
    [sym__pvarsym] = STATE(6408),
    [sym__qvarsym_prefix] = STATE(6408),
    [sym__pqvarsym] = STATE(6408),
    [sym__consym_prefix] = STATE(6408),
    [sym__pconsym] = STATE(6408),
    [sym__qconsym_prefix] = STATE(6408),
    [sym__pqconsym] = STATE(6408),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(437),
    [sym__bracket_open] = STATE(982),
    [sym__unboxed_open] = STATE(827),
    [sym_variable] = ACTIONS(2041),
    [anon_sym__] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2049),
    [anon_sym_u2605] = ACTIONS(2049),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2051),
    [sym_char] = ACTIONS(2051),
    [sym_string] = ACTIONS(2051),
    [sym__integer_literal] = ACTIONS(2053),
    [sym__binary_literal] = ACTIONS(2055),
    [sym__octal_literal] = ACTIONS(2055),
    [sym__hex_literal] = ACTIONS(2055),
    [sym_implicit_variable] = ACTIONS(2651),
    [sym_name] = ACTIONS(2653),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2059),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1745] = {
    [sym__type_parens] = STATE(6784),
    [sym__type_tuple] = STATE(6785),
    [sym__type_unboxed_tuple] = STATE(6786),
    [sym__type_unboxed_sum] = STATE(6787),
    [sym__type_list] = STATE(6789),
    [sym__type_promoted] = STATE(6781),
    [sym__type_star] = STATE(6781),
    [sym__type_wildcard] = STATE(6781),
    [sym__type_apply] = STATE(6790),
    [sym__type_infix] = STATE(6791),
    [sym_type] = STATE(854),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10099),
    [sym__qtype_forall] = STATE(8826),
    [sym__qtype_forall_required] = STATE(8777),
    [sym_strict_field] = STATE(8709),
    [sym_lazy_field] = STATE(8709),
    [sym__qtype_function] = STATE(8779),
    [sym__qtype_linear_function] = STATE(8838),
    [sym__qtype_context] = STATE(8791),
    [sym_quantified_type] = STATE(8325),
    [sym_implicit_parameter] = STATE(8794),
    [sym__context_inline] = STATE(1751),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11189),
    [sym__splice_dollars] = STATE(7457),
    [sym_splice] = STATE(6781),
    [sym_quasiquote] = STATE(6781),
    [sym_integer] = STATE(6710),
    [sym__plist] = STATE(6792),
    [sym_unit] = STATE(6781),
    [sym_unboxed_unit] = STATE(6781),
    [sym_prefix_tuple] = STATE(6781),
    [sym_prefix_unboxed_tuple] = STATE(6781),
    [sym_prefix_unboxed_sum] = STATE(6781),
    [sym_literal] = STATE(6781),
    [sym__qualified_type] = STATE(6756),
    [sym__qtyconid] = STATE(6793),
    [sym__tycon_arrow] = STATE(6793),
    [sym__qtycon_arrow] = STATE(6793),
    [sym__promoted_tycons_alias] = STATE(6781),
    [sym__promoted_tycons] = STATE(6781),
    [sym__varsym_prefix] = STATE(6793),
    [sym__pvarsym] = STATE(6793),
    [sym__qvarsym_prefix] = STATE(6793),
    [sym__pqvarsym] = STATE(6793),
    [sym__consym_prefix] = STATE(6793),
    [sym__pconsym] = STATE(6793),
    [sym__qconsym_prefix] = STATE(6793),
    [sym__pqconsym] = STATE(6793),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(472),
    [sym__bracket_open] = STATE(1078),
    [sym__unboxed_open] = STATE(789),
    [sym_variable] = ACTIONS(2607),
    [anon_sym__] = ACTIONS(2609),
    [anon_sym_SQUOTE] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_u2605] = ACTIONS(2615),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2617),
    [sym_char] = ACTIONS(2617),
    [sym_string] = ACTIONS(2617),
    [sym__integer_literal] = ACTIONS(2619),
    [sym__binary_literal] = ACTIONS(2621),
    [sym__octal_literal] = ACTIONS(2621),
    [sym__hex_literal] = ACTIONS(2621),
    [sym_implicit_variable] = ACTIONS(3457),
    [sym_name] = ACTIONS(3459),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2625),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1746] = {
    [sym__exp_th_quoted_name] = STATE(4811),
    [sym__exp_parens] = STATE(4810),
    [sym__exp_tuple] = STATE(4808),
    [sym__exp_unboxed_tuple] = STATE(4806),
    [sym__exp_unboxed_sum] = STATE(4804),
    [sym__exp_list] = STATE(4803),
    [sym__exp_arithmetic_sequence] = STATE(4801),
    [sym__exp_list_comprehension] = STATE(4799),
    [sym__exp_lambda] = STATE(4697),
    [sym__exp_let_in] = STATE(4772),
    [sym__exp_conditional] = STATE(4771),
    [sym__do_keyword] = STATE(11233),
    [sym_do_module] = STATE(11233),
    [sym__do] = STATE(11233),
    [sym__exp_do] = STATE(4770),
    [sym__exp_case] = STATE(4760),
    [sym__exp_lambda_case] = STATE(4759),
    [sym__exp_lambda_cases] = STATE(4758),
    [sym__exp_multi_way_if] = STATE(4741),
    [sym__exp_record] = STATE(4740),
    [sym__exp_projection_selector] = STATE(4739),
    [sym__exp_projection] = STATE(4738),
    [sym__exp_apply] = STATE(4737),
    [sym__exp_section_left] = STATE(4736),
    [sym__exp_section_right] = STATE(4726),
    [sym__exp_negation] = STATE(4710),
    [sym__exp_infix] = STATE(4709),
    [sym_expression] = STATE(226),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9385),
    [sym__splice_dollars] = STATE(7478),
    [sym_splice] = STATE(4812),
    [sym_quasiquote] = STATE(4812),
    [sym__exp_quote] = STATE(4708),
    [sym__exp_typed_quote] = STATE(4812),
    [sym_integer] = STATE(4067),
    [sym__plist] = STATE(4671),
    [sym_unit] = STATE(4812),
    [sym_unboxed_unit] = STATE(4812),
    [sym_prefix_tuple] = STATE(4812),
    [sym_prefix_unboxed_tuple] = STATE(4812),
    [sym_prefix_unboxed_sum] = STATE(4812),
    [sym_literal] = STATE(4812),
    [sym__qualified_variable] = STATE(3954),
    [sym__qvarid] = STATE(4812),
    [sym__qvar] = STATE(4812),
    [sym__qualified_constructor] = STATE(4042),
    [sym__qconid] = STATE(4812),
    [sym__varsym_prefix] = STATE(4812),
    [sym__pvarsym] = STATE(4812),
    [sym__qvarsym_prefix] = STATE(4812),
    [sym__pqvarsym] = STATE(4812),
    [sym__consym_prefix] = STATE(4670),
    [sym__pconsym] = STATE(4670),
    [sym__qconsym_prefix] = STATE(4812),
    [sym__pqconsym] = STATE(4812),
    [sym__paren_open] = STATE(416),
    [sym__bracket_open] = STATE(951),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = ACTIONS(653),
    [anon_sym_let] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(659),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(661),
    [anon_sym_BSLASH] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_case] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(673),
    [sym_float] = ACTIONS(675),
    [sym_char] = ACTIONS(675),
    [sym_string] = ACTIONS(675),
    [sym__integer_literal] = ACTIONS(677),
    [sym__binary_literal] = ACTIONS(679),
    [sym__octal_literal] = ACTIONS(679),
    [sym__hex_literal] = ACTIONS(679),
    [sym_implicit_variable] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [sym_label] = ACTIONS(681),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(687),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1747] = {
    [sym__exp_th_quoted_name] = STATE(5067),
    [sym__exp_parens] = STATE(5066),
    [sym__exp_tuple] = STATE(5065),
    [sym__exp_unboxed_tuple] = STATE(5063),
    [sym__exp_unboxed_sum] = STATE(5010),
    [sym__exp_list] = STATE(5062),
    [sym__exp_arithmetic_sequence] = STATE(5061),
    [sym__exp_list_comprehension] = STATE(5060),
    [sym__exp_lambda] = STATE(5059),
    [sym__exp_let_in] = STATE(5056),
    [sym__exp_conditional] = STATE(5055),
    [sym__do_keyword] = STATE(11121),
    [sym_do_module] = STATE(11121),
    [sym__do] = STATE(11121),
    [sym__exp_do] = STATE(5054),
    [sym__exp_case] = STATE(5053),
    [sym__exp_lambda_case] = STATE(5051),
    [sym__exp_lambda_cases] = STATE(5050),
    [sym__exp_multi_way_if] = STATE(5048),
    [sym__exp_record] = STATE(5045),
    [sym__exp_projection_selector] = STATE(5043),
    [sym__exp_projection] = STATE(5040),
    [sym__exp_apply] = STATE(5037),
    [sym__exp_section_left] = STATE(5031),
    [sym__exp_section_right] = STATE(5030),
    [sym__exp_negation] = STATE(5029),
    [sym__exp_infix] = STATE(5028),
    [sym_expression] = STATE(251),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9236),
    [sym__splice_dollars] = STATE(7317),
    [sym_splice] = STATE(5069),
    [sym_quasiquote] = STATE(5069),
    [sym__exp_quote] = STATE(5027),
    [sym__exp_typed_quote] = STATE(5069),
    [sym_integer] = STATE(4282),
    [sym__plist] = STATE(5021),
    [sym_unit] = STATE(5069),
    [sym_unboxed_unit] = STATE(5069),
    [sym_prefix_tuple] = STATE(5069),
    [sym_prefix_unboxed_tuple] = STATE(5069),
    [sym_prefix_unboxed_sum] = STATE(5069),
    [sym_literal] = STATE(5069),
    [sym__qualified_variable] = STATE(4298),
    [sym__qvarid] = STATE(5069),
    [sym__qvar] = STATE(5069),
    [sym__qualified_constructor] = STATE(4251),
    [sym__qconid] = STATE(5069),
    [sym__varsym_prefix] = STATE(5069),
    [sym__pvarsym] = STATE(5069),
    [sym__qvarsym_prefix] = STATE(5069),
    [sym__pqvarsym] = STATE(5069),
    [sym__consym_prefix] = STATE(5020),
    [sym__pconsym] = STATE(5020),
    [sym__qconsym_prefix] = STATE(5069),
    [sym__pqconsym] = STATE(5069),
    [sym__paren_open] = STATE(404),
    [sym__bracket_open] = STATE(1093),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = ACTIONS(901),
    [anon_sym_let] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(135),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(139),
    [anon_sym_BSLASH] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_mdo] = ACTIONS(145),
    [anon_sym_do] = ACTIONS(145),
    [anon_sym_case] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(151),
    [sym_float] = ACTIONS(907),
    [sym_char] = ACTIONS(907),
    [sym_string] = ACTIONS(907),
    [sym__integer_literal] = ACTIONS(909),
    [sym__binary_literal] = ACTIONS(911),
    [sym__octal_literal] = ACTIONS(911),
    [sym__hex_literal] = ACTIONS(911),
    [sym_implicit_variable] = ACTIONS(165),
    [sym_name] = ACTIONS(913),
    [sym_label] = ACTIONS(165),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(915),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1748] = {
    [sym__type_parens] = STATE(2825),
    [sym__type_tuple] = STATE(2808),
    [sym__type_unboxed_tuple] = STATE(2788),
    [sym__type_unboxed_sum] = STATE(2767),
    [sym__type_list] = STATE(2839),
    [sym__type_promoted] = STATE(2796),
    [sym__type_star] = STATE(2796),
    [sym__type_wildcard] = STATE(2796),
    [sym__type_apply] = STATE(2823),
    [sym__type_infix] = STATE(2774),
    [sym_type] = STATE(421),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10083),
    [sym__qtype_forall] = STATE(3138),
    [sym__qtype_forall_required] = STATE(3136),
    [sym_strict_field] = STATE(8681),
    [sym_lazy_field] = STATE(8681),
    [sym__qtype_function] = STATE(3135),
    [sym__qtype_linear_function] = STATE(3132),
    [sym__qtype_context] = STATE(3131),
    [sym_quantified_type] = STATE(2369),
    [sym_implicit_parameter] = STATE(3115),
    [sym__context_inline] = STATE(1721),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11145),
    [sym__splice_dollars] = STATE(7328),
    [sym_splice] = STATE(2796),
    [sym_quasiquote] = STATE(2796),
    [sym_integer] = STATE(2781),
    [sym__plist] = STATE(2777),
    [sym_unit] = STATE(2796),
    [sym_unboxed_unit] = STATE(2796),
    [sym_prefix_tuple] = STATE(2796),
    [sym_prefix_unboxed_tuple] = STATE(2796),
    [sym_prefix_unboxed_sum] = STATE(2796),
    [sym_literal] = STATE(2796),
    [sym__qualified_type] = STATE(2759),
    [sym__qtyconid] = STATE(2752),
    [sym__tycon_arrow] = STATE(2752),
    [sym__qtycon_arrow] = STATE(2752),
    [sym__promoted_tycons_alias] = STATE(2796),
    [sym__promoted_tycons] = STATE(2796),
    [sym__varsym_prefix] = STATE(2752),
    [sym__pvarsym] = STATE(2752),
    [sym__qvarsym_prefix] = STATE(2752),
    [sym__pqvarsym] = STATE(2752),
    [sym__consym_prefix] = STATE(2752),
    [sym__pconsym] = STATE(2752),
    [sym__qconsym_prefix] = STATE(2752),
    [sym__pqconsym] = STATE(2752),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(467),
    [sym__bracket_open] = STATE(1130),
    [sym__unboxed_open] = STATE(765),
    [sym_variable] = ACTIONS(1323),
    [anon_sym__] = ACTIONS(1325),
    [anon_sym_SQUOTE] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_u2605] = ACTIONS(1331),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1333),
    [sym_char] = ACTIONS(1333),
    [sym_string] = ACTIONS(1333),
    [sym__integer_literal] = ACTIONS(1335),
    [sym__binary_literal] = ACTIONS(1337),
    [sym__octal_literal] = ACTIONS(1337),
    [sym__hex_literal] = ACTIONS(1337),
    [sym_implicit_variable] = ACTIONS(3463),
    [sym_name] = ACTIONS(3465),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1341),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1749] = {
    [sym__type_parens] = STATE(3379),
    [sym__type_tuple] = STATE(3377),
    [sym__type_unboxed_tuple] = STATE(3370),
    [sym__type_unboxed_sum] = STATE(3369),
    [sym__type_list] = STATE(3361),
    [sym__type_promoted] = STATE(3383),
    [sym__type_star] = STATE(3383),
    [sym__type_wildcard] = STATE(3383),
    [sym__type_apply] = STATE(3359),
    [sym__type_infix] = STATE(3358),
    [sym_type] = STATE(486),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10095),
    [sym__qtype_forall] = STATE(3757),
    [sym__qtype_forall_required] = STATE(3758),
    [sym_strict_field] = STATE(8706),
    [sym_lazy_field] = STATE(8706),
    [sym__qtype_function] = STATE(3762),
    [sym__qtype_linear_function] = STATE(3767),
    [sym__qtype_context] = STATE(3768),
    [sym_quantified_type] = STATE(2768),
    [sym_implicit_parameter] = STATE(3788),
    [sym__context_inline] = STATE(1749),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11178),
    [sym__splice_dollars] = STATE(7460),
    [sym_splice] = STATE(3383),
    [sym_quasiquote] = STATE(3383),
    [sym_integer] = STATE(3269),
    [sym__plist] = STATE(3357),
    [sym_unit] = STATE(3383),
    [sym_unboxed_unit] = STATE(3383),
    [sym_prefix_tuple] = STATE(3383),
    [sym_prefix_unboxed_tuple] = STATE(3383),
    [sym_prefix_unboxed_sum] = STATE(3383),
    [sym_literal] = STATE(3383),
    [sym__qualified_type] = STATE(3410),
    [sym__qtyconid] = STATE(3354),
    [sym__tycon_arrow] = STATE(3354),
    [sym__qtycon_arrow] = STATE(3354),
    [sym__promoted_tycons_alias] = STATE(3383),
    [sym__promoted_tycons] = STATE(3383),
    [sym__varsym_prefix] = STATE(3354),
    [sym__pvarsym] = STATE(3354),
    [sym__qvarsym_prefix] = STATE(3354),
    [sym__pqvarsym] = STATE(3354),
    [sym__consym_prefix] = STATE(3354),
    [sym__pconsym] = STATE(3354),
    [sym__qconsym_prefix] = STATE(3354),
    [sym__pqconsym] = STATE(3354),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(464),
    [sym__bracket_open] = STATE(1079),
    [sym__unboxed_open] = STATE(805),
    [sym_variable] = ACTIONS(1609),
    [anon_sym__] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_u2605] = ACTIONS(1617),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1619),
    [sym_char] = ACTIONS(1619),
    [sym_string] = ACTIONS(1619),
    [sym__integer_literal] = ACTIONS(1621),
    [sym__binary_literal] = ACTIONS(1623),
    [sym__octal_literal] = ACTIONS(1623),
    [sym__hex_literal] = ACTIONS(1623),
    [sym_implicit_variable] = ACTIONS(3385),
    [sym_name] = ACTIONS(3387),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1627),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1750] = {
    [sym__type_wildcard] = STATE(7980),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(12494),
    [sym__class_apply] = STATE(8005),
    [sym__class_infix] = STATE(8007),
    [sym__ctr_parens] = STATE(7980),
    [sym__ctr_tuple] = STATE(7980),
    [sym_implicit_parameter] = STATE(10828),
    [sym_constraint] = STATE(2234),
    [sym__ctr_forall] = STATE(10819),
    [sym__ctr_context] = STATE(10815),
    [sym__ctr_signature] = STATE(10805),
    [sym_constraints] = STATE(9180),
    [sym__context_inline] = STATE(2304),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8275),
    [sym__splice_dollars] = STATE(7254),
    [sym_splice] = STATE(7980),
    [sym_quasiquote] = STATE(7980),
    [sym_integer] = STATE(7997),
    [sym_unit] = STATE(7980),
    [sym_unboxed_unit] = STATE(7980),
    [sym_prefix_tuple] = STATE(7980),
    [sym_prefix_unboxed_tuple] = STATE(7980),
    [sym_prefix_unboxed_sum] = STATE(7980),
    [sym_literal] = STATE(7980),
    [sym__qualified_type] = STATE(7953),
    [sym__qtyconid] = STATE(8011),
    [sym__tycon_arrow] = STATE(8011),
    [sym__qualified_arrow] = STATE(12103),
    [sym__qtycon_arrow] = STATE(8011),
    [sym__promoted_tycons_alias] = STATE(7980),
    [sym__promoted_tycons] = STATE(7980),
    [sym__operator_qual_dot_head] = STATE(11683),
    [sym__operator_hash_head] = STATE(12770),
    [sym_operator] = STATE(11683),
    [sym__operator_minus] = STATE(11683),
    [sym__varsym_prefix] = STATE(8011),
    [sym__pvarsym] = STATE(8011),
    [sym__qualified_varsym] = STATE(11421),
    [sym__qvarsym_prefix] = STATE(8011),
    [sym__pqvarsym] = STATE(8011),
    [sym_constructor_operator] = STATE(11687),
    [sym__consym_prefix] = STATE(8011),
    [sym__pconsym] = STATE(8011),
    [sym__qualified_consym] = STATE(11392),
    [sym__qconsym_prefix] = STATE(8011),
    [sym__pqconsym] = STATE(8011),
    [sym__arrow] = STATE(11405),
    [sym__paren_open] = STATE(1536),
    [sym__paren_close] = STATE(7939),
    [sym__unboxed_open] = STATE(9192),
    [aux_sym__exp_tuple_elems_repeat1] = STATE(10808),
    [sym_variable] = ACTIONS(3389),
    [anon_sym_COMMA] = ACTIONS(3499),
    [anon_sym__] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3395),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_DASH_GT] = ACTIONS(1381),
    [sym_float] = ACTIONS(3397),
    [sym_char] = ACTIONS(3397),
    [sym_string] = ACTIONS(3397),
    [sym__integer_literal] = ACTIONS(3399),
    [sym__binary_literal] = ACTIONS(3401),
    [sym__octal_literal] = ACTIONS(3401),
    [sym__hex_literal] = ACTIONS(3401),
    [anon_sym_POUND] = ACTIONS(241),
    [anon_sym_POUND2] = ACTIONS(3403),
    [sym_implicit_variable] = ACTIONS(3405),
    [sym_name] = ACTIONS(3407),
    [anon_sym_u2192] = ACTIONS(1381),
    [aux_sym__paren_open_token1] = ACTIONS(3409),
    [aux_sym__paren_close_token1] = ACTIONS(3501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3413),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_qual_dot] = ACTIONS(253),
    [sym__cond_prefix_dot] = ACTIONS(255),
    [sym__cond_context] = ACTIONS(3415),
    [sym__cond_infix] = ACTIONS(3417),
    [sym__varsym] = ACTIONS(219),
    [sym__consym] = ACTIONS(257),
  },
  [1751] = {
    [sym__type_parens] = STATE(6784),
    [sym__type_tuple] = STATE(6785),
    [sym__type_unboxed_tuple] = STATE(6786),
    [sym__type_unboxed_sum] = STATE(6787),
    [sym__type_list] = STATE(6789),
    [sym__type_promoted] = STATE(6781),
    [sym__type_star] = STATE(6781),
    [sym__type_wildcard] = STATE(6781),
    [sym__type_apply] = STATE(6790),
    [sym__type_infix] = STATE(6791),
    [sym_type] = STATE(854),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10099),
    [sym__qtype_forall] = STATE(8826),
    [sym__qtype_forall_required] = STATE(8777),
    [sym_strict_field] = STATE(8709),
    [sym_lazy_field] = STATE(8709),
    [sym__qtype_function] = STATE(8779),
    [sym__qtype_linear_function] = STATE(8838),
    [sym__qtype_context] = STATE(8791),
    [sym_quantified_type] = STATE(8352),
    [sym_implicit_parameter] = STATE(8794),
    [sym__context_inline] = STATE(1751),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11189),
    [sym__splice_dollars] = STATE(7457),
    [sym_splice] = STATE(6781),
    [sym_quasiquote] = STATE(6781),
    [sym_integer] = STATE(6710),
    [sym__plist] = STATE(6792),
    [sym_unit] = STATE(6781),
    [sym_unboxed_unit] = STATE(6781),
    [sym_prefix_tuple] = STATE(6781),
    [sym_prefix_unboxed_tuple] = STATE(6781),
    [sym_prefix_unboxed_sum] = STATE(6781),
    [sym_literal] = STATE(6781),
    [sym__qualified_type] = STATE(6756),
    [sym__qtyconid] = STATE(6793),
    [sym__tycon_arrow] = STATE(6793),
    [sym__qtycon_arrow] = STATE(6793),
    [sym__promoted_tycons_alias] = STATE(6781),
    [sym__promoted_tycons] = STATE(6781),
    [sym__varsym_prefix] = STATE(6793),
    [sym__pvarsym] = STATE(6793),
    [sym__qvarsym_prefix] = STATE(6793),
    [sym__pqvarsym] = STATE(6793),
    [sym__consym_prefix] = STATE(6793),
    [sym__pconsym] = STATE(6793),
    [sym__qconsym_prefix] = STATE(6793),
    [sym__pqconsym] = STATE(6793),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(472),
    [sym__bracket_open] = STATE(1078),
    [sym__unboxed_open] = STATE(789),
    [sym_variable] = ACTIONS(2607),
    [anon_sym__] = ACTIONS(2609),
    [anon_sym_SQUOTE] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_u2605] = ACTIONS(2615),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2617),
    [sym_char] = ACTIONS(2617),
    [sym_string] = ACTIONS(2617),
    [sym__integer_literal] = ACTIONS(2619),
    [sym__binary_literal] = ACTIONS(2621),
    [sym__octal_literal] = ACTIONS(2621),
    [sym__hex_literal] = ACTIONS(2621),
    [sym_implicit_variable] = ACTIONS(3457),
    [sym_name] = ACTIONS(3459),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2625),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1752] = {
    [sym__type_parens] = STATE(3294),
    [sym__type_tuple] = STATE(3295),
    [sym__type_unboxed_tuple] = STATE(3296),
    [sym__type_unboxed_sum] = STATE(3298),
    [sym__type_list] = STATE(3311),
    [sym__type_promoted] = STATE(3292),
    [sym__type_star] = STATE(3292),
    [sym__type_wildcard] = STATE(3292),
    [sym__type_apply] = STATE(3313),
    [sym__type_infix] = STATE(3314),
    [sym_type] = STATE(478),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10086),
    [sym__qtype_forall] = STATE(3726),
    [sym__qtype_forall_required] = STATE(3727),
    [sym_strict_field] = STATE(8686),
    [sym_lazy_field] = STATE(8686),
    [sym__qtype_function] = STATE(3728),
    [sym__qtype_linear_function] = STATE(3729),
    [sym__qtype_context] = STATE(3730),
    [sym_quantified_type] = STATE(2826),
    [sym_implicit_parameter] = STATE(3720),
    [sym__context_inline] = STATE(1666),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11151),
    [sym__splice_dollars] = STATE(7231),
    [sym_splice] = STATE(3292),
    [sym_quasiquote] = STATE(3292),
    [sym_integer] = STATE(3286),
    [sym__plist] = STATE(3318),
    [sym_unit] = STATE(3292),
    [sym_unboxed_unit] = STATE(3292),
    [sym_prefix_tuple] = STATE(3292),
    [sym_prefix_unboxed_tuple] = STATE(3292),
    [sym_prefix_unboxed_sum] = STATE(3292),
    [sym_literal] = STATE(3292),
    [sym__qualified_type] = STATE(3249),
    [sym__qtyconid] = STATE(3320),
    [sym__tycon_arrow] = STATE(3320),
    [sym__qtycon_arrow] = STATE(3320),
    [sym__promoted_tycons_alias] = STATE(3292),
    [sym__promoted_tycons] = STATE(3292),
    [sym__varsym_prefix] = STATE(3320),
    [sym__pvarsym] = STATE(3320),
    [sym__qvarsym_prefix] = STATE(3320),
    [sym__pqvarsym] = STATE(3320),
    [sym__consym_prefix] = STATE(3320),
    [sym__pconsym] = STATE(3320),
    [sym__qconsym_prefix] = STATE(3320),
    [sym__pqconsym] = STATE(3320),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(458),
    [sym__bracket_open] = STATE(1120),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = ACTIONS(1589),
    [anon_sym__] = ACTIONS(1591),
    [anon_sym_SQUOTE] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(1597),
    [anon_sym_u2605] = ACTIONS(1597),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1599),
    [sym_char] = ACTIONS(1599),
    [sym_string] = ACTIONS(1599),
    [sym__integer_literal] = ACTIONS(1601),
    [sym__binary_literal] = ACTIONS(1603),
    [sym__octal_literal] = ACTIONS(1603),
    [sym__hex_literal] = ACTIONS(1603),
    [sym_implicit_variable] = ACTIONS(3469),
    [sym_name] = ACTIONS(3471),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1607),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1753] = {
    [sym__type_parens] = STATE(3220),
    [sym__type_tuple] = STATE(3210),
    [sym__type_unboxed_tuple] = STATE(3184),
    [sym__type_unboxed_sum] = STATE(3188),
    [sym__type_list] = STATE(3211),
    [sym__type_promoted] = STATE(3364),
    [sym__type_star] = STATE(3364),
    [sym__type_wildcard] = STATE(3364),
    [sym__type_apply] = STATE(3196),
    [sym__type_infix] = STATE(3225),
    [sym_type] = STATE(480),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10104),
    [sym__qtype_forall] = STATE(3791),
    [sym__qtype_forall_required] = STATE(3793),
    [sym_strict_field] = STATE(8711),
    [sym_lazy_field] = STATE(8711),
    [sym__qtype_function] = STATE(3794),
    [sym__qtype_linear_function] = STATE(3797),
    [sym__qtype_context] = STATE(3798),
    [sym_quantified_type] = STATE(2769),
    [sym_implicit_parameter] = STATE(3799),
    [sym__context_inline] = STATE(1724),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11198),
    [sym__splice_dollars] = STATE(7401),
    [sym_splice] = STATE(3364),
    [sym_quasiquote] = STATE(3364),
    [sym_integer] = STATE(3397),
    [sym__plist] = STATE(3177),
    [sym_unit] = STATE(3364),
    [sym_unboxed_unit] = STATE(3364),
    [sym_prefix_tuple] = STATE(3364),
    [sym_prefix_unboxed_tuple] = STATE(3364),
    [sym_prefix_unboxed_sum] = STATE(3364),
    [sym_literal] = STATE(3364),
    [sym__qualified_type] = STATE(3262),
    [sym__qtyconid] = STATE(3232),
    [sym__tycon_arrow] = STATE(3232),
    [sym__qtycon_arrow] = STATE(3232),
    [sym__promoted_tycons_alias] = STATE(3364),
    [sym__promoted_tycons] = STATE(3364),
    [sym__varsym_prefix] = STATE(3232),
    [sym__pvarsym] = STATE(3232),
    [sym__qvarsym_prefix] = STATE(3232),
    [sym__pqvarsym] = STATE(3232),
    [sym__consym_prefix] = STATE(3232),
    [sym__pconsym] = STATE(3232),
    [sym__qconsym_prefix] = STATE(3232),
    [sym__pqconsym] = STATE(3232),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(466),
    [sym__bracket_open] = STATE(1073),
    [sym__unboxed_open] = STATE(781),
    [sym_variable] = ACTIONS(1569),
    [anon_sym__] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(1577),
    [anon_sym_u2605] = ACTIONS(1577),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1579),
    [sym_char] = ACTIONS(1579),
    [sym_string] = ACTIONS(1579),
    [sym__integer_literal] = ACTIONS(1581),
    [sym__binary_literal] = ACTIONS(1583),
    [sym__octal_literal] = ACTIONS(1583),
    [sym__hex_literal] = ACTIONS(1583),
    [sym_implicit_variable] = ACTIONS(3441),
    [sym_name] = ACTIONS(3443),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1587),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1754] = {
    [sym__type_parens] = STATE(6784),
    [sym__type_tuple] = STATE(6785),
    [sym__type_unboxed_tuple] = STATE(6786),
    [sym__type_unboxed_sum] = STATE(6787),
    [sym__type_list] = STATE(6789),
    [sym__type_promoted] = STATE(6781),
    [sym__type_star] = STATE(6781),
    [sym__type_wildcard] = STATE(6781),
    [sym__type_apply] = STATE(6790),
    [sym__type_infix] = STATE(6791),
    [sym_type] = STATE(854),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10099),
    [sym__qtype_forall] = STATE(8826),
    [sym__qtype_forall_required] = STATE(8777),
    [sym_strict_field] = STATE(8709),
    [sym_lazy_field] = STATE(8709),
    [sym__qtype_function] = STATE(8779),
    [sym__qtype_linear_function] = STATE(8838),
    [sym__qtype_context] = STATE(8791),
    [sym_quantified_type] = STATE(8354),
    [sym_implicit_parameter] = STATE(8794),
    [sym__context_inline] = STATE(1751),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11189),
    [sym__splice_dollars] = STATE(7457),
    [sym_splice] = STATE(6781),
    [sym_quasiquote] = STATE(6781),
    [sym_integer] = STATE(6710),
    [sym__plist] = STATE(6792),
    [sym_unit] = STATE(6781),
    [sym_unboxed_unit] = STATE(6781),
    [sym_prefix_tuple] = STATE(6781),
    [sym_prefix_unboxed_tuple] = STATE(6781),
    [sym_prefix_unboxed_sum] = STATE(6781),
    [sym_literal] = STATE(6781),
    [sym__qualified_type] = STATE(6756),
    [sym__qtyconid] = STATE(6793),
    [sym__tycon_arrow] = STATE(6793),
    [sym__qtycon_arrow] = STATE(6793),
    [sym__promoted_tycons_alias] = STATE(6781),
    [sym__promoted_tycons] = STATE(6781),
    [sym__varsym_prefix] = STATE(6793),
    [sym__pvarsym] = STATE(6793),
    [sym__qvarsym_prefix] = STATE(6793),
    [sym__pqvarsym] = STATE(6793),
    [sym__consym_prefix] = STATE(6793),
    [sym__pconsym] = STATE(6793),
    [sym__qconsym_prefix] = STATE(6793),
    [sym__pqconsym] = STATE(6793),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(472),
    [sym__bracket_open] = STATE(1078),
    [sym__unboxed_open] = STATE(789),
    [sym_variable] = ACTIONS(2607),
    [anon_sym__] = ACTIONS(2609),
    [anon_sym_SQUOTE] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_u2605] = ACTIONS(2615),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2617),
    [sym_char] = ACTIONS(2617),
    [sym_string] = ACTIONS(2617),
    [sym__integer_literal] = ACTIONS(2619),
    [sym__binary_literal] = ACTIONS(2621),
    [sym__octal_literal] = ACTIONS(2621),
    [sym__hex_literal] = ACTIONS(2621),
    [sym_implicit_variable] = ACTIONS(3457),
    [sym_name] = ACTIONS(3459),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2625),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1755] = {
    [sym__type_parens] = STATE(6784),
    [sym__type_tuple] = STATE(6785),
    [sym__type_unboxed_tuple] = STATE(6786),
    [sym__type_unboxed_sum] = STATE(6787),
    [sym__type_list] = STATE(6789),
    [sym__type_promoted] = STATE(6781),
    [sym__type_star] = STATE(6781),
    [sym__type_wildcard] = STATE(6781),
    [sym__type_apply] = STATE(6790),
    [sym__type_infix] = STATE(6791),
    [sym_type] = STATE(854),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10099),
    [sym__qtype_forall] = STATE(8826),
    [sym__qtype_forall_required] = STATE(8777),
    [sym_strict_field] = STATE(8709),
    [sym_lazy_field] = STATE(8709),
    [sym__qtype_function] = STATE(8779),
    [sym__qtype_linear_function] = STATE(8838),
    [sym__qtype_context] = STATE(8791),
    [sym_quantified_type] = STATE(8335),
    [sym_implicit_parameter] = STATE(8794),
    [sym__context_inline] = STATE(1751),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11189),
    [sym__splice_dollars] = STATE(7457),
    [sym_splice] = STATE(6781),
    [sym_quasiquote] = STATE(6781),
    [sym_integer] = STATE(6710),
    [sym__plist] = STATE(6792),
    [sym_unit] = STATE(6781),
    [sym_unboxed_unit] = STATE(6781),
    [sym_prefix_tuple] = STATE(6781),
    [sym_prefix_unboxed_tuple] = STATE(6781),
    [sym_prefix_unboxed_sum] = STATE(6781),
    [sym_literal] = STATE(6781),
    [sym__qualified_type] = STATE(6756),
    [sym__qtyconid] = STATE(6793),
    [sym__tycon_arrow] = STATE(6793),
    [sym__qtycon_arrow] = STATE(6793),
    [sym__promoted_tycons_alias] = STATE(6781),
    [sym__promoted_tycons] = STATE(6781),
    [sym__varsym_prefix] = STATE(6793),
    [sym__pvarsym] = STATE(6793),
    [sym__qvarsym_prefix] = STATE(6793),
    [sym__pqvarsym] = STATE(6793),
    [sym__consym_prefix] = STATE(6793),
    [sym__pconsym] = STATE(6793),
    [sym__qconsym_prefix] = STATE(6793),
    [sym__pqconsym] = STATE(6793),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(472),
    [sym__bracket_open] = STATE(1078),
    [sym__unboxed_open] = STATE(789),
    [sym_variable] = ACTIONS(2607),
    [anon_sym__] = ACTIONS(2609),
    [anon_sym_SQUOTE] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_u2605] = ACTIONS(2615),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2617),
    [sym_char] = ACTIONS(2617),
    [sym_string] = ACTIONS(2617),
    [sym__integer_literal] = ACTIONS(2619),
    [sym__binary_literal] = ACTIONS(2621),
    [sym__octal_literal] = ACTIONS(2621),
    [sym__hex_literal] = ACTIONS(2621),
    [sym_implicit_variable] = ACTIONS(3457),
    [sym_name] = ACTIONS(3459),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2625),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1756] = {
    [sym__type_parens] = STATE(6784),
    [sym__type_tuple] = STATE(6785),
    [sym__type_unboxed_tuple] = STATE(6786),
    [sym__type_unboxed_sum] = STATE(6787),
    [sym__type_list] = STATE(6789),
    [sym__type_promoted] = STATE(6781),
    [sym__type_star] = STATE(6781),
    [sym__type_wildcard] = STATE(6781),
    [sym__type_apply] = STATE(6790),
    [sym__type_infix] = STATE(6791),
    [sym_type] = STATE(854),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10099),
    [sym__qtype_forall] = STATE(8826),
    [sym__qtype_forall_required] = STATE(8777),
    [sym_strict_field] = STATE(8709),
    [sym_lazy_field] = STATE(8709),
    [sym__qtype_function] = STATE(8779),
    [sym__qtype_linear_function] = STATE(8838),
    [sym__qtype_context] = STATE(8791),
    [sym_quantified_type] = STATE(8307),
    [sym_implicit_parameter] = STATE(8794),
    [sym__context_inline] = STATE(1751),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11189),
    [sym__splice_dollars] = STATE(7457),
    [sym_splice] = STATE(6781),
    [sym_quasiquote] = STATE(6781),
    [sym_integer] = STATE(6710),
    [sym__plist] = STATE(6792),
    [sym_unit] = STATE(6781),
    [sym_unboxed_unit] = STATE(6781),
    [sym_prefix_tuple] = STATE(6781),
    [sym_prefix_unboxed_tuple] = STATE(6781),
    [sym_prefix_unboxed_sum] = STATE(6781),
    [sym_literal] = STATE(6781),
    [sym__qualified_type] = STATE(6756),
    [sym__qtyconid] = STATE(6793),
    [sym__tycon_arrow] = STATE(6793),
    [sym__qtycon_arrow] = STATE(6793),
    [sym__promoted_tycons_alias] = STATE(6781),
    [sym__promoted_tycons] = STATE(6781),
    [sym__varsym_prefix] = STATE(6793),
    [sym__pvarsym] = STATE(6793),
    [sym__qvarsym_prefix] = STATE(6793),
    [sym__pqvarsym] = STATE(6793),
    [sym__consym_prefix] = STATE(6793),
    [sym__pconsym] = STATE(6793),
    [sym__qconsym_prefix] = STATE(6793),
    [sym__pqconsym] = STATE(6793),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(472),
    [sym__bracket_open] = STATE(1078),
    [sym__unboxed_open] = STATE(789),
    [sym_variable] = ACTIONS(2607),
    [anon_sym__] = ACTIONS(2609),
    [anon_sym_SQUOTE] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_u2605] = ACTIONS(2615),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2617),
    [sym_char] = ACTIONS(2617),
    [sym_string] = ACTIONS(2617),
    [sym__integer_literal] = ACTIONS(2619),
    [sym__binary_literal] = ACTIONS(2621),
    [sym__octal_literal] = ACTIONS(2621),
    [sym__hex_literal] = ACTIONS(2621),
    [sym_implicit_variable] = ACTIONS(3457),
    [sym_name] = ACTIONS(3459),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2625),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1757] = {
    [sym__type_parens] = STATE(6784),
    [sym__type_tuple] = STATE(6785),
    [sym__type_unboxed_tuple] = STATE(6786),
    [sym__type_unboxed_sum] = STATE(6787),
    [sym__type_list] = STATE(6789),
    [sym__type_promoted] = STATE(6781),
    [sym__type_star] = STATE(6781),
    [sym__type_wildcard] = STATE(6781),
    [sym__type_apply] = STATE(6790),
    [sym__type_infix] = STATE(6791),
    [sym_type] = STATE(854),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10099),
    [sym__qtype_forall] = STATE(8826),
    [sym__qtype_forall_required] = STATE(8777),
    [sym_strict_field] = STATE(8709),
    [sym_lazy_field] = STATE(8709),
    [sym__qtype_function] = STATE(8779),
    [sym__qtype_linear_function] = STATE(8838),
    [sym__qtype_context] = STATE(8791),
    [sym_quantified_type] = STATE(8306),
    [sym_implicit_parameter] = STATE(8794),
    [sym__context_inline] = STATE(1751),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11189),
    [sym__splice_dollars] = STATE(7457),
    [sym_splice] = STATE(6781),
    [sym_quasiquote] = STATE(6781),
    [sym_integer] = STATE(6710),
    [sym__plist] = STATE(6792),
    [sym_unit] = STATE(6781),
    [sym_unboxed_unit] = STATE(6781),
    [sym_prefix_tuple] = STATE(6781),
    [sym_prefix_unboxed_tuple] = STATE(6781),
    [sym_prefix_unboxed_sum] = STATE(6781),
    [sym_literal] = STATE(6781),
    [sym__qualified_type] = STATE(6756),
    [sym__qtyconid] = STATE(6793),
    [sym__tycon_arrow] = STATE(6793),
    [sym__qtycon_arrow] = STATE(6793),
    [sym__promoted_tycons_alias] = STATE(6781),
    [sym__promoted_tycons] = STATE(6781),
    [sym__varsym_prefix] = STATE(6793),
    [sym__pvarsym] = STATE(6793),
    [sym__qvarsym_prefix] = STATE(6793),
    [sym__pqvarsym] = STATE(6793),
    [sym__consym_prefix] = STATE(6793),
    [sym__pconsym] = STATE(6793),
    [sym__qconsym_prefix] = STATE(6793),
    [sym__pqconsym] = STATE(6793),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(472),
    [sym__bracket_open] = STATE(1078),
    [sym__unboxed_open] = STATE(789),
    [sym_variable] = ACTIONS(2607),
    [anon_sym__] = ACTIONS(2609),
    [anon_sym_SQUOTE] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_u2605] = ACTIONS(2615),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2617),
    [sym_char] = ACTIONS(2617),
    [sym_string] = ACTIONS(2617),
    [sym__integer_literal] = ACTIONS(2619),
    [sym__binary_literal] = ACTIONS(2621),
    [sym__octal_literal] = ACTIONS(2621),
    [sym__hex_literal] = ACTIONS(2621),
    [sym_implicit_variable] = ACTIONS(3457),
    [sym_name] = ACTIONS(3459),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2625),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1758] = {
    [sym__type_parens] = STATE(3294),
    [sym__type_tuple] = STATE(3295),
    [sym__type_unboxed_tuple] = STATE(3296),
    [sym__type_unboxed_sum] = STATE(3298),
    [sym__type_list] = STATE(3311),
    [sym__type_promoted] = STATE(3292),
    [sym__type_star] = STATE(3292),
    [sym__type_wildcard] = STATE(3292),
    [sym__type_apply] = STATE(3313),
    [sym__type_infix] = STATE(3314),
    [sym_type] = STATE(478),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10086),
    [sym__qtype_forall] = STATE(3726),
    [sym__qtype_forall_required] = STATE(3727),
    [sym_strict_field] = STATE(8686),
    [sym_lazy_field] = STATE(8686),
    [sym__qtype_function] = STATE(3728),
    [sym__qtype_linear_function] = STATE(3729),
    [sym__qtype_context] = STATE(3730),
    [sym_quantified_type] = STATE(2828),
    [sym_implicit_parameter] = STATE(3720),
    [sym__context_inline] = STATE(1666),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11151),
    [sym__splice_dollars] = STATE(7231),
    [sym_splice] = STATE(3292),
    [sym_quasiquote] = STATE(3292),
    [sym_integer] = STATE(3286),
    [sym__plist] = STATE(3318),
    [sym_unit] = STATE(3292),
    [sym_unboxed_unit] = STATE(3292),
    [sym_prefix_tuple] = STATE(3292),
    [sym_prefix_unboxed_tuple] = STATE(3292),
    [sym_prefix_unboxed_sum] = STATE(3292),
    [sym_literal] = STATE(3292),
    [sym__qualified_type] = STATE(3249),
    [sym__qtyconid] = STATE(3320),
    [sym__tycon_arrow] = STATE(3320),
    [sym__qtycon_arrow] = STATE(3320),
    [sym__promoted_tycons_alias] = STATE(3292),
    [sym__promoted_tycons] = STATE(3292),
    [sym__varsym_prefix] = STATE(3320),
    [sym__pvarsym] = STATE(3320),
    [sym__qvarsym_prefix] = STATE(3320),
    [sym__pqvarsym] = STATE(3320),
    [sym__consym_prefix] = STATE(3320),
    [sym__pconsym] = STATE(3320),
    [sym__qconsym_prefix] = STATE(3320),
    [sym__pqconsym] = STATE(3320),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(458),
    [sym__bracket_open] = STATE(1120),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = ACTIONS(1589),
    [anon_sym__] = ACTIONS(1591),
    [anon_sym_SQUOTE] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(1597),
    [anon_sym_u2605] = ACTIONS(1597),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1599),
    [sym_char] = ACTIONS(1599),
    [sym_string] = ACTIONS(1599),
    [sym__integer_literal] = ACTIONS(1601),
    [sym__binary_literal] = ACTIONS(1603),
    [sym__octal_literal] = ACTIONS(1603),
    [sym__hex_literal] = ACTIONS(1603),
    [sym_implicit_variable] = ACTIONS(3469),
    [sym_name] = ACTIONS(3471),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1607),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1759] = {
    [sym__type_parens] = STATE(6784),
    [sym__type_tuple] = STATE(6785),
    [sym__type_unboxed_tuple] = STATE(6786),
    [sym__type_unboxed_sum] = STATE(6787),
    [sym__type_list] = STATE(6789),
    [sym__type_promoted] = STATE(6781),
    [sym__type_star] = STATE(6781),
    [sym__type_wildcard] = STATE(6781),
    [sym__type_apply] = STATE(6790),
    [sym__type_infix] = STATE(6791),
    [sym_type] = STATE(854),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10099),
    [sym__qtype_forall] = STATE(8826),
    [sym__qtype_forall_required] = STATE(8777),
    [sym_strict_field] = STATE(8709),
    [sym_lazy_field] = STATE(8709),
    [sym__qtype_function] = STATE(8779),
    [sym__qtype_linear_function] = STATE(8838),
    [sym__qtype_context] = STATE(8791),
    [sym_quantified_type] = STATE(8349),
    [sym_implicit_parameter] = STATE(8794),
    [sym__context_inline] = STATE(1751),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11189),
    [sym__splice_dollars] = STATE(7457),
    [sym_splice] = STATE(6781),
    [sym_quasiquote] = STATE(6781),
    [sym_integer] = STATE(6710),
    [sym__plist] = STATE(6792),
    [sym_unit] = STATE(6781),
    [sym_unboxed_unit] = STATE(6781),
    [sym_prefix_tuple] = STATE(6781),
    [sym_prefix_unboxed_tuple] = STATE(6781),
    [sym_prefix_unboxed_sum] = STATE(6781),
    [sym_literal] = STATE(6781),
    [sym__qualified_type] = STATE(6756),
    [sym__qtyconid] = STATE(6793),
    [sym__tycon_arrow] = STATE(6793),
    [sym__qtycon_arrow] = STATE(6793),
    [sym__promoted_tycons_alias] = STATE(6781),
    [sym__promoted_tycons] = STATE(6781),
    [sym__varsym_prefix] = STATE(6793),
    [sym__pvarsym] = STATE(6793),
    [sym__qvarsym_prefix] = STATE(6793),
    [sym__pqvarsym] = STATE(6793),
    [sym__consym_prefix] = STATE(6793),
    [sym__pconsym] = STATE(6793),
    [sym__qconsym_prefix] = STATE(6793),
    [sym__pqconsym] = STATE(6793),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(472),
    [sym__bracket_open] = STATE(1078),
    [sym__unboxed_open] = STATE(789),
    [sym_variable] = ACTIONS(2607),
    [anon_sym__] = ACTIONS(2609),
    [anon_sym_SQUOTE] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_u2605] = ACTIONS(2615),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2617),
    [sym_char] = ACTIONS(2617),
    [sym_string] = ACTIONS(2617),
    [sym__integer_literal] = ACTIONS(2619),
    [sym__binary_literal] = ACTIONS(2621),
    [sym__octal_literal] = ACTIONS(2621),
    [sym__hex_literal] = ACTIONS(2621),
    [sym_implicit_variable] = ACTIONS(3457),
    [sym_name] = ACTIONS(3459),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2625),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1760] = {
    [sym__type_parens] = STATE(6784),
    [sym__type_tuple] = STATE(6785),
    [sym__type_unboxed_tuple] = STATE(6786),
    [sym__type_unboxed_sum] = STATE(6787),
    [sym__type_list] = STATE(6789),
    [sym__type_promoted] = STATE(6781),
    [sym__type_star] = STATE(6781),
    [sym__type_wildcard] = STATE(6781),
    [sym__type_apply] = STATE(6790),
    [sym__type_infix] = STATE(6791),
    [sym_type] = STATE(854),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10099),
    [sym__qtype_forall] = STATE(8826),
    [sym__qtype_forall_required] = STATE(8777),
    [sym_strict_field] = STATE(8709),
    [sym_lazy_field] = STATE(8709),
    [sym__qtype_function] = STATE(8779),
    [sym__qtype_linear_function] = STATE(8838),
    [sym__qtype_context] = STATE(8791),
    [sym_quantified_type] = STATE(8340),
    [sym_implicit_parameter] = STATE(8794),
    [sym__context_inline] = STATE(1751),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11189),
    [sym__splice_dollars] = STATE(7457),
    [sym_splice] = STATE(6781),
    [sym_quasiquote] = STATE(6781),
    [sym_integer] = STATE(6710),
    [sym__plist] = STATE(6792),
    [sym_unit] = STATE(6781),
    [sym_unboxed_unit] = STATE(6781),
    [sym_prefix_tuple] = STATE(6781),
    [sym_prefix_unboxed_tuple] = STATE(6781),
    [sym_prefix_unboxed_sum] = STATE(6781),
    [sym_literal] = STATE(6781),
    [sym__qualified_type] = STATE(6756),
    [sym__qtyconid] = STATE(6793),
    [sym__tycon_arrow] = STATE(6793),
    [sym__qtycon_arrow] = STATE(6793),
    [sym__promoted_tycons_alias] = STATE(6781),
    [sym__promoted_tycons] = STATE(6781),
    [sym__varsym_prefix] = STATE(6793),
    [sym__pvarsym] = STATE(6793),
    [sym__qvarsym_prefix] = STATE(6793),
    [sym__pqvarsym] = STATE(6793),
    [sym__consym_prefix] = STATE(6793),
    [sym__pconsym] = STATE(6793),
    [sym__qconsym_prefix] = STATE(6793),
    [sym__pqconsym] = STATE(6793),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(472),
    [sym__bracket_open] = STATE(1078),
    [sym__unboxed_open] = STATE(789),
    [sym_variable] = ACTIONS(2607),
    [anon_sym__] = ACTIONS(2609),
    [anon_sym_SQUOTE] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_u2605] = ACTIONS(2615),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2617),
    [sym_char] = ACTIONS(2617),
    [sym_string] = ACTIONS(2617),
    [sym__integer_literal] = ACTIONS(2619),
    [sym__binary_literal] = ACTIONS(2621),
    [sym__octal_literal] = ACTIONS(2621),
    [sym__hex_literal] = ACTIONS(2621),
    [sym_implicit_variable] = ACTIONS(3457),
    [sym_name] = ACTIONS(3459),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2625),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1761] = {
    [sym__type_parens] = STATE(3294),
    [sym__type_tuple] = STATE(3295),
    [sym__type_unboxed_tuple] = STATE(3296),
    [sym__type_unboxed_sum] = STATE(3298),
    [sym__type_list] = STATE(3311),
    [sym__type_promoted] = STATE(3292),
    [sym__type_star] = STATE(3292),
    [sym__type_wildcard] = STATE(3292),
    [sym__type_apply] = STATE(3313),
    [sym__type_infix] = STATE(3314),
    [sym_type] = STATE(478),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10086),
    [sym__qtype_forall] = STATE(3726),
    [sym__qtype_forall_required] = STATE(3727),
    [sym_strict_field] = STATE(8686),
    [sym_lazy_field] = STATE(8686),
    [sym__qtype_function] = STATE(3728),
    [sym__qtype_linear_function] = STATE(3729),
    [sym__qtype_context] = STATE(3730),
    [sym_quantified_type] = STATE(2831),
    [sym_implicit_parameter] = STATE(3720),
    [sym__context_inline] = STATE(1666),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11151),
    [sym__splice_dollars] = STATE(7231),
    [sym_splice] = STATE(3292),
    [sym_quasiquote] = STATE(3292),
    [sym_integer] = STATE(3286),
    [sym__plist] = STATE(3318),
    [sym_unit] = STATE(3292),
    [sym_unboxed_unit] = STATE(3292),
    [sym_prefix_tuple] = STATE(3292),
    [sym_prefix_unboxed_tuple] = STATE(3292),
    [sym_prefix_unboxed_sum] = STATE(3292),
    [sym_literal] = STATE(3292),
    [sym__qualified_type] = STATE(3249),
    [sym__qtyconid] = STATE(3320),
    [sym__tycon_arrow] = STATE(3320),
    [sym__qtycon_arrow] = STATE(3320),
    [sym__promoted_tycons_alias] = STATE(3292),
    [sym__promoted_tycons] = STATE(3292),
    [sym__varsym_prefix] = STATE(3320),
    [sym__pvarsym] = STATE(3320),
    [sym__qvarsym_prefix] = STATE(3320),
    [sym__pqvarsym] = STATE(3320),
    [sym__consym_prefix] = STATE(3320),
    [sym__pconsym] = STATE(3320),
    [sym__qconsym_prefix] = STATE(3320),
    [sym__pqconsym] = STATE(3320),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(458),
    [sym__bracket_open] = STATE(1120),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = ACTIONS(1589),
    [anon_sym__] = ACTIONS(1591),
    [anon_sym_SQUOTE] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(1597),
    [anon_sym_u2605] = ACTIONS(1597),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1599),
    [sym_char] = ACTIONS(1599),
    [sym_string] = ACTIONS(1599),
    [sym__integer_literal] = ACTIONS(1601),
    [sym__binary_literal] = ACTIONS(1603),
    [sym__octal_literal] = ACTIONS(1603),
    [sym__hex_literal] = ACTIONS(1603),
    [sym_implicit_variable] = ACTIONS(3469),
    [sym_name] = ACTIONS(3471),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1607),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1762] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(55),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(3647),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(3345),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(641),
    [sym__binary_literal] = ACTIONS(643),
    [sym__octal_literal] = ACTIONS(643),
    [sym__hex_literal] = ACTIONS(643),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1763] = {
    [sym__type_parens] = STATE(3294),
    [sym__type_tuple] = STATE(3295),
    [sym__type_unboxed_tuple] = STATE(3296),
    [sym__type_unboxed_sum] = STATE(3298),
    [sym__type_list] = STATE(3311),
    [sym__type_promoted] = STATE(3292),
    [sym__type_star] = STATE(3292),
    [sym__type_wildcard] = STATE(3292),
    [sym__type_apply] = STATE(3313),
    [sym__type_infix] = STATE(3314),
    [sym_type] = STATE(478),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10086),
    [sym__qtype_forall] = STATE(3726),
    [sym__qtype_forall_required] = STATE(3727),
    [sym_strict_field] = STATE(8686),
    [sym_lazy_field] = STATE(8686),
    [sym__qtype_function] = STATE(3728),
    [sym__qtype_linear_function] = STATE(3729),
    [sym__qtype_context] = STATE(3730),
    [sym_quantified_type] = STATE(2829),
    [sym_implicit_parameter] = STATE(3720),
    [sym__context_inline] = STATE(1666),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11151),
    [sym__splice_dollars] = STATE(7231),
    [sym_splice] = STATE(3292),
    [sym_quasiquote] = STATE(3292),
    [sym_integer] = STATE(3286),
    [sym__plist] = STATE(3318),
    [sym_unit] = STATE(3292),
    [sym_unboxed_unit] = STATE(3292),
    [sym_prefix_tuple] = STATE(3292),
    [sym_prefix_unboxed_tuple] = STATE(3292),
    [sym_prefix_unboxed_sum] = STATE(3292),
    [sym_literal] = STATE(3292),
    [sym__qualified_type] = STATE(3249),
    [sym__qtyconid] = STATE(3320),
    [sym__tycon_arrow] = STATE(3320),
    [sym__qtycon_arrow] = STATE(3320),
    [sym__promoted_tycons_alias] = STATE(3292),
    [sym__promoted_tycons] = STATE(3292),
    [sym__varsym_prefix] = STATE(3320),
    [sym__pvarsym] = STATE(3320),
    [sym__qvarsym_prefix] = STATE(3320),
    [sym__pqvarsym] = STATE(3320),
    [sym__consym_prefix] = STATE(3320),
    [sym__pconsym] = STATE(3320),
    [sym__qconsym_prefix] = STATE(3320),
    [sym__pqconsym] = STATE(3320),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(458),
    [sym__bracket_open] = STATE(1120),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = ACTIONS(1589),
    [anon_sym__] = ACTIONS(1591),
    [anon_sym_SQUOTE] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(1597),
    [anon_sym_u2605] = ACTIONS(1597),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(1599),
    [sym_char] = ACTIONS(1599),
    [sym_string] = ACTIONS(1599),
    [sym__integer_literal] = ACTIONS(1601),
    [sym__binary_literal] = ACTIONS(1603),
    [sym__octal_literal] = ACTIONS(1603),
    [sym__hex_literal] = ACTIONS(1603),
    [sym_implicit_variable] = ACTIONS(3469),
    [sym_name] = ACTIONS(3471),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1607),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1764] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(57),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1765] = {
    [sym__type_parens] = STATE(6922),
    [sym__type_tuple] = STATE(6929),
    [sym__type_unboxed_tuple] = STATE(6932),
    [sym__type_unboxed_sum] = STATE(6934),
    [sym__type_list] = STATE(6935),
    [sym__type_promoted] = STATE(6919),
    [sym__type_star] = STATE(6919),
    [sym__type_wildcard] = STATE(6919),
    [sym__type_apply] = STATE(6936),
    [sym__type_infix] = STATE(6937),
    [sym_type] = STATE(910),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(10089),
    [sym__qtype_forall] = STATE(8937),
    [sym__qtype_forall_required] = STATE(8932),
    [sym_strict_field] = STATE(8700),
    [sym_lazy_field] = STATE(8700),
    [sym__qtype_function] = STATE(8931),
    [sym__qtype_linear_function] = STATE(8922),
    [sym__qtype_context] = STATE(8930),
    [sym_quantified_type] = STATE(8402),
    [sym_implicit_parameter] = STATE(8927),
    [sym__context_inline] = STATE(1434),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11154),
    [sym__splice_dollars] = STATE(7213),
    [sym_splice] = STATE(6919),
    [sym_quasiquote] = STATE(6919),
    [sym_integer] = STATE(6980),
    [sym__plist] = STATE(6939),
    [sym_unit] = STATE(6919),
    [sym_unboxed_unit] = STATE(6919),
    [sym_prefix_tuple] = STATE(6919),
    [sym_prefix_unboxed_tuple] = STATE(6919),
    [sym_prefix_unboxed_sum] = STATE(6919),
    [sym_literal] = STATE(6919),
    [sym__qualified_type] = STATE(7018),
    [sym__qtyconid] = STATE(6940),
    [sym__tycon_arrow] = STATE(6940),
    [sym__qtycon_arrow] = STATE(6940),
    [sym__promoted_tycons_alias] = STATE(6919),
    [sym__promoted_tycons] = STATE(6919),
    [sym__varsym_prefix] = STATE(6940),
    [sym__pvarsym] = STATE(6940),
    [sym__qvarsym_prefix] = STATE(6940),
    [sym__pqvarsym] = STATE(6940),
    [sym__consym_prefix] = STATE(6940),
    [sym__pconsym] = STATE(6940),
    [sym__qconsym_prefix] = STATE(6940),
    [sym__pqconsym] = STATE(6940),
    [sym__prefix_bang] = STATE(2415),
    [sym__tight_bang] = STATE(2415),
    [sym__any_prefix_bang] = STATE(2415),
    [sym__prefix_tilde] = STATE(2416),
    [sym__tight_tilde] = STATE(2416),
    [sym__any_prefix_tilde] = STATE(2416),
    [sym__paren_open] = STATE(435),
    [sym__bracket_open] = STATE(1104),
    [sym__unboxed_open] = STATE(744),
    [sym_variable] = ACTIONS(2693),
    [anon_sym__] = ACTIONS(2695),
    [anon_sym_SQUOTE] = ACTIONS(3325),
    [anon_sym_STAR] = ACTIONS(2701),
    [anon_sym_u2605] = ACTIONS(2701),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2703),
    [sym_char] = ACTIONS(2703),
    [sym_string] = ACTIONS(2703),
    [sym__integer_literal] = ACTIONS(2705),
    [sym__binary_literal] = ACTIONS(2707),
    [sym__octal_literal] = ACTIONS(2707),
    [sym__hex_literal] = ACTIONS(2707),
    [sym_implicit_variable] = ACTIONS(3327),
    [sym_name] = ACTIONS(3329),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2711),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
    [sym__cond_context] = ACTIONS(1407),
  },
  [1766] = {
    [sym__exp_th_quoted_name] = STATE(2982),
    [sym__exp_parens] = STATE(2983),
    [sym__exp_tuple] = STATE(2985),
    [sym__exp_unboxed_tuple] = STATE(2986),
    [sym__exp_unboxed_sum] = STATE(2988),
    [sym__exp_list] = STATE(2993),
    [sym__exp_arithmetic_sequence] = STATE(2841),
    [sym__exp_list_comprehension] = STATE(3011),
    [sym__exp_lambda] = STATE(3017),
    [sym__exp_let_in] = STATE(3033),
    [sym__exp_conditional] = STATE(2908),
    [sym__do_keyword] = STATE(10923),
    [sym_do_module] = STATE(10923),
    [sym__do] = STATE(10923),
    [sym__exp_do] = STATE(3049),
    [sym__exp_case] = STATE(2845),
    [sym__exp_lambda_case] = STATE(2848),
    [sym__exp_lambda_cases] = STATE(2849),
    [sym__exp_multi_way_if] = STATE(2850),
    [sym__exp_record] = STATE(2858),
    [sym__exp_projection_selector] = STATE(2859),
    [sym__exp_projection] = STATE(2860),
    [sym__exp_apply] = STATE(2875),
    [sym__exp_section_left] = STATE(2877),
    [sym__exp_section_right] = STATE(2878),
    [sym__exp_negation] = STATE(2880),
    [sym__exp_infix] = STATE(2881),
    [sym_expression] = STATE(56),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(9326),
    [sym__splice_dollars] = STATE(7364),
    [sym_splice] = STATE(2980),
    [sym_quasiquote] = STATE(2980),
    [sym__exp_quote] = STATE(2906),
    [sym__exp_typed_quote] = STATE(2980),
    [sym_integer] = STATE(2734),
    [sym__plist] = STATE(3021),
    [sym_unit] = STATE(2980),
    [sym_unboxed_unit] = STATE(2980),
    [sym_prefix_tuple] = STATE(2980),
    [sym_prefix_unboxed_tuple] = STATE(2980),
    [sym_prefix_unboxed_sum] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym__qualified_variable] = STATE(2717),
    [sym__qvarid] = STATE(2980),
    [sym__qvar] = STATE(2980),
    [sym__qualified_constructor] = STATE(2750),
    [sym__qconid] = STATE(2980),
    [sym__varsym_prefix] = STATE(2980),
    [sym__pvarsym] = STATE(2980),
    [sym__qvarsym_prefix] = STATE(2980),
    [sym__pqvarsym] = STATE(2980),
    [sym__consym_prefix] = STATE(3015),
    [sym__pconsym] = STATE(3015),
    [sym__qconsym_prefix] = STATE(2980),
    [sym__pqconsym] = STATE(2980),
    [sym__paren_open] = STATE(414),
    [sym__bracket_open] = STATE(1008),
    [sym__unboxed_open] = STATE(741),
    [sym_variable] = ACTIONS(295),
    [anon_sym_let] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(217),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(223),
    [anon_sym_if] = ACTIONS(225),
    [anon_sym_mdo] = ACTIONS(227),
    [anon_sym_do] = ACTIONS(227),
    [anon_sym_case] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_u27e6] = ACTIONS(233),
    [sym_float] = ACTIONS(307),
    [sym_char] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym__integer_literal] = ACTIONS(309),
    [sym__binary_literal] = ACTIONS(311),
    [sym__octal_literal] = ACTIONS(311),
    [sym__hex_literal] = ACTIONS(311),
    [sym_implicit_variable] = ACTIONS(245),
    [sym_name] = ACTIONS(313),
    [sym_label] = ACTIONS(245),
    [aux_sym__paren_open_token1] = ACTIONS(317),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(319),
    [sym__cond_splice] = ACTIONS(83),
  },
  [1767] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__paren_close] = STATE(8039),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(3503),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1768] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__paren_close] = STATE(4203),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1255),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1769] = {
    [sym__at_type] = STATE(7064),
    [sym_explicit_type] = STATE(7062),
    [sym__pat_parens] = STATE(7041),
    [sym__pat_tuple] = STATE(7042),
    [sym__pat_unboxed_tuple] = STATE(7043),
    [sym__pat_unboxed_sum] = STATE(7044),
    [sym__pat_list] = STATE(7045),
    [sym__pat_record] = STATE(7046),
    [sym__pat_as] = STATE(7047),
    [sym__pat_wildcard] = STATE(7048),
    [sym__pat_strict] = STATE(7049),
    [sym__pat_irrefutable] = STATE(7050),
    [sym__pat_apply] = STATE(7051),
    [sym__pat_negation] = STATE(7052),
    [sym__pat_infix] = STATE(7053),
    [sym_pattern] = STATE(1769),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11245),
    [sym__splice_dollars] = STATE(7422),
    [sym_splice] = STATE(7048),
    [sym_quasiquote] = STATE(7048),
    [sym_integer] = STATE(7199),
    [sym__plist] = STATE(7057),
    [sym_unit] = STATE(7048),
    [sym_unboxed_unit] = STATE(7048),
    [sym_prefix_tuple] = STATE(7048),
    [sym_prefix_unboxed_tuple] = STATE(7048),
    [sym_prefix_unboxed_sum] = STATE(7048),
    [sym_literal] = STATE(7048),
    [sym__qualified_constructor] = STATE(7189),
    [sym__qconid] = STATE(7048),
    [sym__constructor_ticked] = STATE(2275),
    [sym__qconstructor_ticked] = STATE(2275),
    [sym__varsym_prefix] = STATE(7058),
    [sym__pvarsym] = STATE(7058),
    [sym_constructor_operator] = STATE(2275),
    [sym__consym_prefix] = STATE(7059),
    [sym__pconsym] = STATE(7059),
    [sym__qconsym_prefix] = STATE(7048),
    [sym__pqconsym] = STATE(7048),
    [sym__prefix_at] = STATE(2550),
    [sym__prefix_bang] = STATE(2256),
    [sym__tight_bang] = STATE(2256),
    [sym__any_prefix_bang] = STATE(2256),
    [sym__prefix_tilde] = STATE(2253),
    [sym__tight_tilde] = STATE(2253),
    [sym__any_prefix_tilde] = STATE(2253),
    [sym__paren_open] = STATE(42),
    [sym__bracket_open] = STATE(364),
    [sym__unboxed_open] = STATE(202),
    [sym_variable] = ACTIONS(3005),
    [anon_sym_SEMI] = ACTIONS(3007),
    [anon_sym_LBRACE] = ACTIONS(3475),
    [anon_sym__] = ACTIONS(3005),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [sym_float] = ACTIONS(3007),
    [sym_char] = ACTIONS(3007),
    [sym_string] = ACTIONS(3007),
    [sym__integer_literal] = ACTIONS(3005),
    [sym__binary_literal] = ACTIONS(3007),
    [sym__octal_literal] = ACTIONS(3007),
    [sym__hex_literal] = ACTIONS(3007),
    [anon_sym_BQUOTE] = ACTIONS(3007),
    [sym_name] = ACTIONS(3007),
    [anon_sym_COLON_COLON] = ACTIONS(3007),
    [anon_sym_u2237] = ACTIONS(3007),
    [aux_sym__paren_open_token1] = ACTIONS(3007),
    [anon_sym_where] = ACTIONS(3005),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3007),
    [sym__cond_layout_end] = ACTIONS(3007),
    [sym__cond_layout_end_explicit] = ACTIONS(3007),
    [sym__phantom_where] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3007),
    [sym__cond_splice] = ACTIONS(3007),
    [sym__cond_prefix_at] = ACTIONS(3007),
    [sym__cond_tight_bang] = ACTIONS(3007),
    [sym__cond_prefix_bang] = ACTIONS(3007),
    [sym__cond_tight_tilde] = ACTIONS(3007),
    [sym__cond_prefix_tilde] = ACTIONS(3007),
    [sym__cond_qualified_op] = ACTIONS(3007),
    [sym__cond_no_section_op] = ACTIONS(3007),
    [sym__consym] = ACTIONS(3007),
  },
  [1770] = {
    [sym__at_type] = STATE(7064),
    [sym_explicit_type] = STATE(7062),
    [sym__pat_parens] = STATE(7041),
    [sym__pat_tuple] = STATE(7042),
    [sym__pat_unboxed_tuple] = STATE(7043),
    [sym__pat_unboxed_sum] = STATE(7044),
    [sym__pat_list] = STATE(7045),
    [sym__pat_record] = STATE(7046),
    [sym__pat_as] = STATE(7047),
    [sym__pat_wildcard] = STATE(7048),
    [sym__pat_strict] = STATE(7049),
    [sym__pat_irrefutable] = STATE(7050),
    [sym__pat_apply] = STATE(7051),
    [sym__pat_negation] = STATE(7052),
    [sym__pat_infix] = STATE(7053),
    [sym_pattern] = STATE(1769),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11245),
    [sym__splice_dollars] = STATE(7422),
    [sym_splice] = STATE(7048),
    [sym_quasiquote] = STATE(7048),
    [sym_integer] = STATE(7199),
    [sym__plist] = STATE(7057),
    [sym_unit] = STATE(7048),
    [sym_unboxed_unit] = STATE(7048),
    [sym_prefix_tuple] = STATE(7048),
    [sym_prefix_unboxed_tuple] = STATE(7048),
    [sym_prefix_unboxed_sum] = STATE(7048),
    [sym_literal] = STATE(7048),
    [sym__qualified_constructor] = STATE(7189),
    [sym__qconid] = STATE(7048),
    [sym__constructor_ticked] = STATE(2275),
    [sym__qconstructor_ticked] = STATE(2275),
    [sym__varsym_prefix] = STATE(7058),
    [sym__pvarsym] = STATE(7058),
    [sym_constructor_operator] = STATE(2275),
    [sym__consym_prefix] = STATE(7059),
    [sym__pconsym] = STATE(7059),
    [sym__qconsym_prefix] = STATE(7048),
    [sym__pqconsym] = STATE(7048),
    [sym__prefix_at] = STATE(2550),
    [sym__prefix_bang] = STATE(2256),
    [sym__tight_bang] = STATE(2256),
    [sym__any_prefix_bang] = STATE(2256),
    [sym__prefix_tilde] = STATE(2253),
    [sym__tight_tilde] = STATE(2253),
    [sym__any_prefix_tilde] = STATE(2253),
    [sym__paren_open] = STATE(42),
    [sym__bracket_open] = STATE(364),
    [sym__unboxed_open] = STATE(202),
    [sym_variable] = ACTIONS(3009),
    [anon_sym_SEMI] = ACTIONS(3011),
    [anon_sym_LBRACE] = ACTIONS(3475),
    [anon_sym__] = ACTIONS(3009),
    [anon_sym_DASH] = ACTIONS(3011),
    [anon_sym_LBRACK] = ACTIONS(3011),
    [sym_float] = ACTIONS(3011),
    [sym_char] = ACTIONS(3011),
    [sym_string] = ACTIONS(3011),
    [sym__integer_literal] = ACTIONS(3009),
    [sym__binary_literal] = ACTIONS(3011),
    [sym__octal_literal] = ACTIONS(3011),
    [sym__hex_literal] = ACTIONS(3011),
    [anon_sym_BQUOTE] = ACTIONS(3011),
    [sym_name] = ACTIONS(3011),
    [anon_sym_COLON_COLON] = ACTIONS(3011),
    [anon_sym_u2237] = ACTIONS(3011),
    [aux_sym__paren_open_token1] = ACTIONS(3011),
    [anon_sym_where] = ACTIONS(3009),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3011),
    [sym__cond_layout_end] = ACTIONS(3011),
    [sym__cond_layout_end_explicit] = ACTIONS(3011),
    [sym__phantom_where] = ACTIONS(3011),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3011),
    [sym__cond_splice] = ACTIONS(3011),
    [sym__cond_prefix_at] = ACTIONS(3011),
    [sym__cond_tight_bang] = ACTIONS(3011),
    [sym__cond_prefix_bang] = ACTIONS(3011),
    [sym__cond_tight_tilde] = ACTIONS(3011),
    [sym__cond_prefix_tilde] = ACTIONS(3011),
    [sym__cond_qualified_op] = ACTIONS(3011),
    [sym__cond_no_section_op] = ACTIONS(3011),
    [sym__consym] = ACTIONS(3011),
  },
  [1771] = {
    [sym__at_type] = STATE(7064),
    [sym_explicit_type] = STATE(7062),
    [sym__pat_parens] = STATE(7041),
    [sym__pat_tuple] = STATE(7042),
    [sym__pat_unboxed_tuple] = STATE(7043),
    [sym__pat_unboxed_sum] = STATE(7044),
    [sym__pat_list] = STATE(7045),
    [sym__pat_record] = STATE(7046),
    [sym__pat_as] = STATE(7047),
    [sym__pat_wildcard] = STATE(7048),
    [sym__pat_strict] = STATE(7049),
    [sym__pat_irrefutable] = STATE(7050),
    [sym__pat_apply] = STATE(7051),
    [sym__pat_negation] = STATE(7052),
    [sym__pat_infix] = STATE(7053),
    [sym_pattern] = STATE(1769),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11245),
    [sym__splice_dollars] = STATE(7422),
    [sym_splice] = STATE(7048),
    [sym_quasiquote] = STATE(7048),
    [sym_integer] = STATE(7199),
    [sym__plist] = STATE(7057),
    [sym_unit] = STATE(7048),
    [sym_unboxed_unit] = STATE(7048),
    [sym_prefix_tuple] = STATE(7048),
    [sym_prefix_unboxed_tuple] = STATE(7048),
    [sym_prefix_unboxed_sum] = STATE(7048),
    [sym_literal] = STATE(7048),
    [sym__qualified_constructor] = STATE(7189),
    [sym__qconid] = STATE(7048),
    [sym__constructor_ticked] = STATE(2275),
    [sym__qconstructor_ticked] = STATE(2275),
    [sym__varsym_prefix] = STATE(7058),
    [sym__pvarsym] = STATE(7058),
    [sym_constructor_operator] = STATE(2275),
    [sym__consym_prefix] = STATE(7059),
    [sym__pconsym] = STATE(7059),
    [sym__qconsym_prefix] = STATE(7048),
    [sym__pqconsym] = STATE(7048),
    [sym__prefix_at] = STATE(2550),
    [sym__prefix_bang] = STATE(2256),
    [sym__tight_bang] = STATE(2256),
    [sym__any_prefix_bang] = STATE(2256),
    [sym__prefix_tilde] = STATE(2253),
    [sym__tight_tilde] = STATE(2253),
    [sym__any_prefix_tilde] = STATE(2253),
    [sym__paren_open] = STATE(42),
    [sym__bracket_open] = STATE(364),
    [sym__unboxed_open] = STATE(202),
    [sym_variable] = ACTIONS(3013),
    [anon_sym_SEMI] = ACTIONS(3015),
    [anon_sym_LBRACE] = ACTIONS(3475),
    [anon_sym__] = ACTIONS(3013),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [sym_float] = ACTIONS(3015),
    [sym_char] = ACTIONS(3015),
    [sym_string] = ACTIONS(3015),
    [sym__integer_literal] = ACTIONS(3013),
    [sym__binary_literal] = ACTIONS(3015),
    [sym__octal_literal] = ACTIONS(3015),
    [sym__hex_literal] = ACTIONS(3015),
    [anon_sym_BQUOTE] = ACTIONS(3015),
    [sym_name] = ACTIONS(3015),
    [anon_sym_COLON_COLON] = ACTIONS(3015),
    [anon_sym_u2237] = ACTIONS(3015),
    [aux_sym__paren_open_token1] = ACTIONS(3015),
    [anon_sym_where] = ACTIONS(3013),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3015),
    [sym__cond_layout_end] = ACTIONS(3015),
    [sym__cond_layout_end_explicit] = ACTIONS(3015),
    [sym__phantom_where] = ACTIONS(3015),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3015),
    [sym__cond_splice] = ACTIONS(3015),
    [sym__cond_prefix_at] = ACTIONS(3015),
    [sym__cond_tight_bang] = ACTIONS(3015),
    [sym__cond_prefix_bang] = ACTIONS(3015),
    [sym__cond_tight_tilde] = ACTIONS(3015),
    [sym__cond_prefix_tilde] = ACTIONS(3015),
    [sym__cond_qualified_op] = ACTIONS(3015),
    [sym__cond_no_section_op] = ACTIONS(3015),
    [sym__consym] = ACTIONS(3015),
  },
  [1772] = {
    [sym__at_type] = STATE(7319),
    [sym_explicit_type] = STATE(7342),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1804),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__constructor_ticked] = STATE(2273),
    [sym__qconstructor_ticked] = STATE(2273),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym_constructor_operator] = STATE(2273),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__colon2] = STATE(1457),
    [sym__prefix_at] = STATE(2396),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(40),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_EQ] = ACTIONS(2719),
    [anon_sym_PIPE] = ACTIONS(2719),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(2719),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(3519),
    [anon_sym_u2192] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2727),
    [anon_sym_u2237] = ACTIONS(2727),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(2719),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(3523),
    [sym__cond_no_section_op] = ACTIONS(3525),
    [sym__consym] = ACTIONS(2737),
  },
  [1773] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__paren_close] = STATE(5375),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1275),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1774] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__paren_close] = STATE(5492),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1257),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1775] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__paren_close] = STATE(7120),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1776] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__paren_close] = STATE(5765),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1777] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__paren_close] = STATE(7392),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(277),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1778] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__paren_close] = STATE(4344),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1295),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1779] = {
    [sym__at_type] = STATE(7064),
    [sym_explicit_type] = STATE(7062),
    [sym__pat_parens] = STATE(7041),
    [sym__pat_tuple] = STATE(7042),
    [sym__pat_unboxed_tuple] = STATE(7043),
    [sym__pat_unboxed_sum] = STATE(7044),
    [sym__pat_list] = STATE(7045),
    [sym__pat_record] = STATE(7046),
    [sym__pat_as] = STATE(7047),
    [sym__pat_wildcard] = STATE(7048),
    [sym__pat_strict] = STATE(7049),
    [sym__pat_irrefutable] = STATE(7050),
    [sym__pat_apply] = STATE(7051),
    [sym__pat_negation] = STATE(7052),
    [sym__pat_infix] = STATE(7053),
    [sym_pattern] = STATE(1769),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11245),
    [sym__splice_dollars] = STATE(7422),
    [sym_splice] = STATE(7048),
    [sym_quasiquote] = STATE(7048),
    [sym_integer] = STATE(7199),
    [sym__plist] = STATE(7057),
    [sym_unit] = STATE(7048),
    [sym_unboxed_unit] = STATE(7048),
    [sym_prefix_tuple] = STATE(7048),
    [sym_prefix_unboxed_tuple] = STATE(7048),
    [sym_prefix_unboxed_sum] = STATE(7048),
    [sym_literal] = STATE(7048),
    [sym__qualified_constructor] = STATE(7189),
    [sym__qconid] = STATE(7048),
    [sym__constructor_ticked] = STATE(2275),
    [sym__qconstructor_ticked] = STATE(2275),
    [sym__varsym_prefix] = STATE(7058),
    [sym__pvarsym] = STATE(7058),
    [sym_constructor_operator] = STATE(2275),
    [sym__consym_prefix] = STATE(7059),
    [sym__pconsym] = STATE(7059),
    [sym__qconsym_prefix] = STATE(7048),
    [sym__pqconsym] = STATE(7048),
    [sym__prefix_at] = STATE(2550),
    [sym__prefix_bang] = STATE(2256),
    [sym__tight_bang] = STATE(2256),
    [sym__any_prefix_bang] = STATE(2256),
    [sym__prefix_tilde] = STATE(2253),
    [sym__tight_tilde] = STATE(2253),
    [sym__any_prefix_tilde] = STATE(2253),
    [sym__paren_open] = STATE(42),
    [sym__bracket_open] = STATE(364),
    [sym__unboxed_open] = STATE(202),
    [sym_variable] = ACTIONS(2821),
    [anon_sym_SEMI] = ACTIONS(2823),
    [anon_sym_LBRACE] = ACTIONS(3475),
    [anon_sym__] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2823),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [sym_float] = ACTIONS(2823),
    [sym_char] = ACTIONS(2823),
    [sym_string] = ACTIONS(2823),
    [sym__integer_literal] = ACTIONS(2821),
    [sym__binary_literal] = ACTIONS(2823),
    [sym__octal_literal] = ACTIONS(2823),
    [sym__hex_literal] = ACTIONS(2823),
    [anon_sym_BQUOTE] = ACTIONS(2823),
    [sym_name] = ACTIONS(2823),
    [anon_sym_COLON_COLON] = ACTIONS(2823),
    [anon_sym_u2237] = ACTIONS(2823),
    [aux_sym__paren_open_token1] = ACTIONS(2823),
    [anon_sym_where] = ACTIONS(2821),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(2823),
    [sym__cond_layout_end] = ACTIONS(2823),
    [sym__cond_layout_end_explicit] = ACTIONS(2823),
    [sym__phantom_where] = ACTIONS(2823),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2823),
    [sym__cond_splice] = ACTIONS(2823),
    [sym__cond_prefix_at] = ACTIONS(2823),
    [sym__cond_tight_bang] = ACTIONS(2823),
    [sym__cond_prefix_bang] = ACTIONS(2823),
    [sym__cond_tight_tilde] = ACTIONS(2823),
    [sym__cond_prefix_tilde] = ACTIONS(2823),
    [sym__cond_qualified_op] = ACTIONS(2823),
    [sym__cond_no_section_op] = ACTIONS(2823),
    [sym__consym] = ACTIONS(2823),
  },
  [1780] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10717),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10716),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10716),
    [sym__local_decl] = STATE(10716),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3275),
    [sym__cond_layout_end_explicit] = ACTIONS(3275),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1781] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10464),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10716),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10716),
    [sym__local_decl] = STATE(10716),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3527),
    [sym__cond_layout_end_explicit] = ACTIONS(3527),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1782] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10468),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10716),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10716),
    [sym__local_decl] = STATE(10716),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3285),
    [sym__cond_layout_end_explicit] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1783] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__paren_close] = STATE(6741),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(283),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1784] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__paren_close] = STATE(5032),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1277),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1785] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__paren_close] = STATE(5470),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1269),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1786] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__paren_close] = STATE(7943),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(3529),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1787] = {
    [sym__at_type] = STATE(7064),
    [sym_explicit_type] = STATE(7062),
    [sym__pat_parens] = STATE(7041),
    [sym__pat_tuple] = STATE(7042),
    [sym__pat_unboxed_tuple] = STATE(7043),
    [sym__pat_unboxed_sum] = STATE(7044),
    [sym__pat_list] = STATE(7045),
    [sym__pat_record] = STATE(7046),
    [sym__pat_as] = STATE(7047),
    [sym__pat_wildcard] = STATE(7048),
    [sym__pat_strict] = STATE(7049),
    [sym__pat_irrefutable] = STATE(7050),
    [sym__pat_apply] = STATE(7051),
    [sym__pat_negation] = STATE(7052),
    [sym__pat_infix] = STATE(7053),
    [sym_pattern] = STATE(1769),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11245),
    [sym__splice_dollars] = STATE(7422),
    [sym_splice] = STATE(7048),
    [sym_quasiquote] = STATE(7048),
    [sym_integer] = STATE(7199),
    [sym__plist] = STATE(7057),
    [sym_unit] = STATE(7048),
    [sym_unboxed_unit] = STATE(7048),
    [sym_prefix_tuple] = STATE(7048),
    [sym_prefix_unboxed_tuple] = STATE(7048),
    [sym_prefix_unboxed_sum] = STATE(7048),
    [sym_literal] = STATE(7048),
    [sym__qualified_constructor] = STATE(7189),
    [sym__qconid] = STATE(7048),
    [sym__constructor_ticked] = STATE(2275),
    [sym__qconstructor_ticked] = STATE(2275),
    [sym__varsym_prefix] = STATE(7058),
    [sym__pvarsym] = STATE(7058),
    [sym_constructor_operator] = STATE(2275),
    [sym__consym_prefix] = STATE(7059),
    [sym__pconsym] = STATE(7059),
    [sym__qconsym_prefix] = STATE(7048),
    [sym__pqconsym] = STATE(7048),
    [sym__prefix_at] = STATE(2550),
    [sym__prefix_bang] = STATE(2256),
    [sym__tight_bang] = STATE(2256),
    [sym__any_prefix_bang] = STATE(2256),
    [sym__prefix_tilde] = STATE(2253),
    [sym__tight_tilde] = STATE(2253),
    [sym__any_prefix_tilde] = STATE(2253),
    [sym__paren_open] = STATE(42),
    [sym__bracket_open] = STATE(364),
    [sym__unboxed_open] = STATE(202),
    [sym_variable] = ACTIONS(3473),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(3475),
    [anon_sym__] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3481),
    [sym_char] = ACTIONS(3481),
    [sym_string] = ACTIONS(3481),
    [sym__integer_literal] = ACTIONS(3483),
    [sym__binary_literal] = ACTIONS(3485),
    [sym__octal_literal] = ACTIONS(3485),
    [sym__hex_literal] = ACTIONS(3485),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(2829),
    [anon_sym_u2237] = ACTIONS(2829),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_where] = ACTIONS(3239),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(2829),
    [sym__cond_layout_end] = ACTIONS(2829),
    [sym__cond_layout_end_explicit] = ACTIONS(2829),
    [sym__phantom_where] = ACTIONS(2829),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3493),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(3495),
    [sym__cond_no_section_op] = ACTIONS(3497),
    [sym__consym] = ACTIONS(2737),
  },
  [1788] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__paren_close] = STATE(4575),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1789] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__paren_close] = STATE(4683),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1249),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1790] = {
    [sym__at_type] = STATE(7064),
    [sym_explicit_type] = STATE(7062),
    [sym__pat_parens] = STATE(7041),
    [sym__pat_tuple] = STATE(7042),
    [sym__pat_unboxed_tuple] = STATE(7043),
    [sym__pat_unboxed_sum] = STATE(7044),
    [sym__pat_list] = STATE(7045),
    [sym__pat_record] = STATE(7046),
    [sym__pat_as] = STATE(7047),
    [sym__pat_wildcard] = STATE(7048),
    [sym__pat_strict] = STATE(7049),
    [sym__pat_irrefutable] = STATE(7050),
    [sym__pat_apply] = STATE(7051),
    [sym__pat_negation] = STATE(7052),
    [sym__pat_infix] = STATE(7053),
    [sym_pattern] = STATE(1769),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11245),
    [sym__splice_dollars] = STATE(7422),
    [sym_splice] = STATE(7048),
    [sym_quasiquote] = STATE(7048),
    [sym_integer] = STATE(7199),
    [sym__plist] = STATE(7057),
    [sym_unit] = STATE(7048),
    [sym_unboxed_unit] = STATE(7048),
    [sym_prefix_tuple] = STATE(7048),
    [sym_prefix_unboxed_tuple] = STATE(7048),
    [sym_prefix_unboxed_sum] = STATE(7048),
    [sym_literal] = STATE(7048),
    [sym__qualified_constructor] = STATE(7189),
    [sym__qconid] = STATE(7048),
    [sym__constructor_ticked] = STATE(2275),
    [sym__qconstructor_ticked] = STATE(2275),
    [sym__varsym_prefix] = STATE(7058),
    [sym__pvarsym] = STATE(7058),
    [sym_constructor_operator] = STATE(2275),
    [sym__consym_prefix] = STATE(7059),
    [sym__pconsym] = STATE(7059),
    [sym__qconsym_prefix] = STATE(7048),
    [sym__pqconsym] = STATE(7048),
    [sym__prefix_at] = STATE(2550),
    [sym__prefix_bang] = STATE(2256),
    [sym__tight_bang] = STATE(2256),
    [sym__any_prefix_bang] = STATE(2256),
    [sym__prefix_tilde] = STATE(2253),
    [sym__tight_tilde] = STATE(2253),
    [sym__any_prefix_tilde] = STATE(2253),
    [sym__paren_open] = STATE(42),
    [sym__bracket_open] = STATE(364),
    [sym__unboxed_open] = STATE(202),
    [sym_variable] = ACTIONS(3473),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym_LBRACE] = ACTIONS(3475),
    [anon_sym__] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3481),
    [sym_char] = ACTIONS(3481),
    [sym_string] = ACTIONS(3481),
    [sym__integer_literal] = ACTIONS(3483),
    [sym__binary_literal] = ACTIONS(3485),
    [sym__octal_literal] = ACTIONS(3485),
    [sym__hex_literal] = ACTIONS(3485),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_u2237] = ACTIONS(2903),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_where] = ACTIONS(3231),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(2903),
    [sym__cond_layout_end] = ACTIONS(2903),
    [sym__cond_layout_end_explicit] = ACTIONS(2903),
    [sym__phantom_where] = ACTIONS(2903),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3493),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(3495),
    [sym__cond_no_section_op] = ACTIONS(3497),
    [sym__consym] = ACTIONS(2737),
  },
  [1791] = {
    [sym__at_type] = STATE(7064),
    [sym_explicit_type] = STATE(7062),
    [sym__pat_parens] = STATE(7041),
    [sym__pat_tuple] = STATE(7042),
    [sym__pat_unboxed_tuple] = STATE(7043),
    [sym__pat_unboxed_sum] = STATE(7044),
    [sym__pat_list] = STATE(7045),
    [sym__pat_record] = STATE(7046),
    [sym__pat_as] = STATE(7047),
    [sym__pat_wildcard] = STATE(7048),
    [sym__pat_strict] = STATE(7049),
    [sym__pat_irrefutable] = STATE(7050),
    [sym__pat_apply] = STATE(7051),
    [sym__pat_negation] = STATE(7052),
    [sym__pat_infix] = STATE(7053),
    [sym_pattern] = STATE(1769),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11245),
    [sym__splice_dollars] = STATE(7422),
    [sym_splice] = STATE(7048),
    [sym_quasiquote] = STATE(7048),
    [sym_integer] = STATE(7199),
    [sym__plist] = STATE(7057),
    [sym_unit] = STATE(7048),
    [sym_unboxed_unit] = STATE(7048),
    [sym_prefix_tuple] = STATE(7048),
    [sym_prefix_unboxed_tuple] = STATE(7048),
    [sym_prefix_unboxed_sum] = STATE(7048),
    [sym_literal] = STATE(7048),
    [sym__qualified_constructor] = STATE(7189),
    [sym__qconid] = STATE(7048),
    [sym__constructor_ticked] = STATE(2275),
    [sym__qconstructor_ticked] = STATE(2275),
    [sym__varsym_prefix] = STATE(7058),
    [sym__pvarsym] = STATE(7058),
    [sym_constructor_operator] = STATE(2275),
    [sym__consym_prefix] = STATE(7059),
    [sym__pconsym] = STATE(7059),
    [sym__qconsym_prefix] = STATE(7048),
    [sym__pqconsym] = STATE(7048),
    [sym__prefix_at] = STATE(2550),
    [sym__prefix_bang] = STATE(2256),
    [sym__tight_bang] = STATE(2256),
    [sym__any_prefix_bang] = STATE(2256),
    [sym__prefix_tilde] = STATE(2253),
    [sym__tight_tilde] = STATE(2253),
    [sym__any_prefix_tilde] = STATE(2253),
    [sym__paren_open] = STATE(42),
    [sym__bracket_open] = STATE(364),
    [sym__unboxed_open] = STATE(202),
    [sym_variable] = ACTIONS(3473),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(3475),
    [anon_sym__] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3481),
    [sym_char] = ACTIONS(3481),
    [sym_string] = ACTIONS(3481),
    [sym__integer_literal] = ACTIONS(3483),
    [sym__binary_literal] = ACTIONS(3485),
    [sym__octal_literal] = ACTIONS(3485),
    [sym__hex_literal] = ACTIONS(3485),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(2899),
    [anon_sym_u2237] = ACTIONS(2899),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_where] = ACTIONS(3227),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(2899),
    [sym__cond_layout_end] = ACTIONS(2899),
    [sym__cond_layout_end_explicit] = ACTIONS(2899),
    [sym__phantom_where] = ACTIONS(2899),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3493),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(3495),
    [sym__cond_no_section_op] = ACTIONS(3497),
    [sym__consym] = ACTIONS(2737),
  },
  [1792] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__paren_close] = STATE(2884),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1279),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1793] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__paren_close] = STATE(5537),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(1263),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1794] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__paren_close] = STATE(6575),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(249),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1795] = {
    [sym__at_type] = STATE(7064),
    [sym_explicit_type] = STATE(7062),
    [sym__pat_parens] = STATE(7041),
    [sym__pat_tuple] = STATE(7042),
    [sym__pat_unboxed_tuple] = STATE(7043),
    [sym__pat_unboxed_sum] = STATE(7044),
    [sym__pat_list] = STATE(7045),
    [sym__pat_record] = STATE(7046),
    [sym__pat_as] = STATE(7047),
    [sym__pat_wildcard] = STATE(7048),
    [sym__pat_strict] = STATE(7049),
    [sym__pat_irrefutable] = STATE(7050),
    [sym__pat_apply] = STATE(7051),
    [sym__pat_negation] = STATE(7052),
    [sym__pat_infix] = STATE(7053),
    [sym_pattern] = STATE(1769),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11245),
    [sym__splice_dollars] = STATE(7422),
    [sym_splice] = STATE(7048),
    [sym_quasiquote] = STATE(7048),
    [sym_integer] = STATE(7199),
    [sym__plist] = STATE(7057),
    [sym_unit] = STATE(7048),
    [sym_unboxed_unit] = STATE(7048),
    [sym_prefix_tuple] = STATE(7048),
    [sym_prefix_unboxed_tuple] = STATE(7048),
    [sym_prefix_unboxed_sum] = STATE(7048),
    [sym_literal] = STATE(7048),
    [sym__qualified_constructor] = STATE(7189),
    [sym__qconid] = STATE(7048),
    [sym__constructor_ticked] = STATE(2275),
    [sym__qconstructor_ticked] = STATE(2275),
    [sym__varsym_prefix] = STATE(7058),
    [sym__pvarsym] = STATE(7058),
    [sym_constructor_operator] = STATE(2275),
    [sym__consym_prefix] = STATE(7059),
    [sym__pconsym] = STATE(7059),
    [sym__qconsym_prefix] = STATE(7048),
    [sym__pqconsym] = STATE(7048),
    [sym__prefix_at] = STATE(2550),
    [sym__prefix_bang] = STATE(2256),
    [sym__tight_bang] = STATE(2256),
    [sym__any_prefix_bang] = STATE(2256),
    [sym__prefix_tilde] = STATE(2253),
    [sym__tight_tilde] = STATE(2253),
    [sym__any_prefix_tilde] = STATE(2253),
    [sym__paren_open] = STATE(42),
    [sym__bracket_open] = STATE(364),
    [sym__unboxed_open] = STATE(202),
    [sym_variable] = ACTIONS(3473),
    [anon_sym_SEMI] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3475),
    [anon_sym__] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3481),
    [sym_char] = ACTIONS(3481),
    [sym_string] = ACTIONS(3481),
    [sym__integer_literal] = ACTIONS(3483),
    [sym__binary_literal] = ACTIONS(3485),
    [sym__octal_literal] = ACTIONS(3485),
    [sym__hex_literal] = ACTIONS(3485),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(3487),
    [anon_sym_COLON_COLON] = ACTIONS(3045),
    [anon_sym_u2237] = ACTIONS(3045),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_where] = ACTIONS(3241),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3045),
    [sym__cond_layout_end] = ACTIONS(3045),
    [sym__cond_layout_end_explicit] = ACTIONS(3045),
    [sym__phantom_where] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3493),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(3495),
    [sym__cond_no_section_op] = ACTIONS(3497),
    [sym__consym] = ACTIONS(2737),
  },
  [1796] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(10286),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10716),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10716),
    [sym__local_decl] = STATE(10716),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3531),
    [sym__cond_layout_end_explicit] = ACTIONS(3531),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1797] = {
    [sym__at_type] = STATE(7319),
    [sym_explicit_type] = STATE(7342),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1804),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__constructor_ticked] = STATE(2273),
    [sym__qconstructor_ticked] = STATE(2273),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym_constructor_operator] = STATE(2273),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2396),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(40),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_EQ] = ACTIONS(2903),
    [anon_sym_PIPE] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(2903),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(3519),
    [anon_sym_u2192] = ACTIONS(2903),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_u2237] = ACTIONS(2903),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(2903),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(3523),
    [sym__cond_no_section_op] = ACTIONS(3525),
    [sym__consym] = ACTIONS(2737),
  },
  [1798] = {
    [sym__at_type] = STATE(7319),
    [sym_explicit_type] = STATE(7342),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1804),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__constructor_ticked] = STATE(2273),
    [sym__qconstructor_ticked] = STATE(2273),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym_constructor_operator] = STATE(2273),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2396),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(40),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym__] = ACTIONS(3013),
    [anon_sym_EQ] = ACTIONS(3015),
    [anon_sym_PIPE] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3013),
    [anon_sym_DASH_GT] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [sym_float] = ACTIONS(3015),
    [sym_char] = ACTIONS(3015),
    [sym_string] = ACTIONS(3015),
    [sym__integer_literal] = ACTIONS(3013),
    [sym__binary_literal] = ACTIONS(3015),
    [sym__octal_literal] = ACTIONS(3015),
    [sym__hex_literal] = ACTIONS(3015),
    [anon_sym_BQUOTE] = ACTIONS(3015),
    [sym_name] = ACTIONS(3015),
    [anon_sym_u2192] = ACTIONS(3015),
    [anon_sym_COLON_COLON] = ACTIONS(3015),
    [anon_sym_u2237] = ACTIONS(3015),
    [aux_sym__paren_open_token1] = ACTIONS(3015),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(3015),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3015),
    [sym__cond_splice] = ACTIONS(3015),
    [sym__cond_prefix_at] = ACTIONS(3015),
    [sym__cond_tight_bang] = ACTIONS(3015),
    [sym__cond_prefix_bang] = ACTIONS(3015),
    [sym__cond_tight_tilde] = ACTIONS(3015),
    [sym__cond_prefix_tilde] = ACTIONS(3015),
    [sym__cond_qualified_op] = ACTIONS(3015),
    [sym__cond_no_section_op] = ACTIONS(3015),
    [sym__consym] = ACTIONS(3015),
  },
  [1799] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__assoc_tyinst] = STATE(10389),
    [sym__assoc_datainst_adt] = STATE(10386),
    [sym__assoc_datainst_newtype] = STATE(10381),
    [sym__assoc_datainst] = STATE(10379),
    [sym_instance_decl] = STATE(10756),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10379),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_newtype] = ACTIONS(2911),
    [anon_sym_data] = ACTIONS(2913),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1800] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10716),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10716),
    [sym__local_decl] = STATE(10716),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1801] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(9399),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(9399),
    [sym__local_decl] = STATE(9399),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1802] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__assoc_tyinst] = STATE(10389),
    [sym__assoc_datainst_adt] = STATE(10386),
    [sym__assoc_datainst_newtype] = STATE(10381),
    [sym__assoc_datainst] = STATE(10379),
    [sym_instance_decl] = STATE(9533),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10379),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_type] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_newtype] = ACTIONS(2911),
    [anon_sym_data] = ACTIONS(2913),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1803] = {
    [sym__at_type] = STATE(7319),
    [sym_explicit_type] = STATE(7342),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1804),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__constructor_ticked] = STATE(2273),
    [sym__qconstructor_ticked] = STATE(2273),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym_constructor_operator] = STATE(2273),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2396),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(40),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_EQ] = ACTIONS(2899),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(2899),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(3519),
    [anon_sym_u2192] = ACTIONS(2899),
    [anon_sym_COLON_COLON] = ACTIONS(2899),
    [anon_sym_u2237] = ACTIONS(2899),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(2899),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(3523),
    [sym__cond_no_section_op] = ACTIONS(3525),
    [sym__consym] = ACTIONS(2737),
  },
  [1804] = {
    [sym__at_type] = STATE(7319),
    [sym_explicit_type] = STATE(7342),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1804),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__constructor_ticked] = STATE(2273),
    [sym__qconstructor_ticked] = STATE(2273),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym_constructor_operator] = STATE(2273),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2396),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(40),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3005),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym__] = ACTIONS(3005),
    [anon_sym_EQ] = ACTIONS(3007),
    [anon_sym_PIPE] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3005),
    [anon_sym_DASH_GT] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [sym_float] = ACTIONS(3007),
    [sym_char] = ACTIONS(3007),
    [sym_string] = ACTIONS(3007),
    [sym__integer_literal] = ACTIONS(3005),
    [sym__binary_literal] = ACTIONS(3007),
    [sym__octal_literal] = ACTIONS(3007),
    [sym__hex_literal] = ACTIONS(3007),
    [anon_sym_BQUOTE] = ACTIONS(3007),
    [sym_name] = ACTIONS(3007),
    [anon_sym_u2192] = ACTIONS(3007),
    [anon_sym_COLON_COLON] = ACTIONS(3007),
    [anon_sym_u2237] = ACTIONS(3007),
    [aux_sym__paren_open_token1] = ACTIONS(3007),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3007),
    [sym__cond_splice] = ACTIONS(3007),
    [sym__cond_prefix_at] = ACTIONS(3007),
    [sym__cond_tight_bang] = ACTIONS(3007),
    [sym__cond_prefix_bang] = ACTIONS(3007),
    [sym__cond_tight_tilde] = ACTIONS(3007),
    [sym__cond_prefix_tilde] = ACTIONS(3007),
    [sym__cond_qualified_op] = ACTIONS(3007),
    [sym__cond_no_section_op] = ACTIONS(3007),
    [sym__consym] = ACTIONS(3007),
  },
  [1805] = {
    [sym__at_type] = STATE(7319),
    [sym_explicit_type] = STATE(7342),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1804),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__constructor_ticked] = STATE(2273),
    [sym__qconstructor_ticked] = STATE(2273),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym_constructor_operator] = STATE(2273),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2396),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(40),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_EQ] = ACTIONS(2829),
    [anon_sym_PIPE] = ACTIONS(2829),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(3519),
    [anon_sym_u2192] = ACTIONS(2829),
    [anon_sym_COLON_COLON] = ACTIONS(2829),
    [anon_sym_u2237] = ACTIONS(2829),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(2829),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(3523),
    [sym__cond_no_section_op] = ACTIONS(3525),
    [sym__consym] = ACTIONS(2737),
  },
  [1806] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__constructor_ticked] = STATE(2103),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2108),
    [sym__constructor_operator_alias] = STATE(2108),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(3533),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(2737),
  },
  [1807] = {
    [sym__at_type] = STATE(7319),
    [sym_explicit_type] = STATE(7342),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1804),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__constructor_ticked] = STATE(2273),
    [sym__qconstructor_ticked] = STATE(2273),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym_constructor_operator] = STATE(2273),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2396),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(40),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym_PIPE] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(3519),
    [anon_sym_u2192] = ACTIONS(3045),
    [anon_sym_COLON_COLON] = ACTIONS(3045),
    [anon_sym_u2237] = ACTIONS(3045),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(3523),
    [sym__cond_no_section_op] = ACTIONS(3525),
    [sym__consym] = ACTIONS(2737),
  },
  [1808] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1814),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2294),
    [sym__qconstructor_ticked] = STATE(2294),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2294),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__colon2] = STATE(1521),
    [sym__prefix_at] = STATE(2526),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(3535),
    [anon_sym_COMMA] = ACTIONS(2719),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_PIPE] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [anon_sym_PIPE2] = ACTIONS(2719),
    [sym_name] = ACTIONS(2841),
    [anon_sym_COLON_COLON] = ACTIONS(3537),
    [anon_sym_u2237] = ACTIONS(3537),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(2719),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(3539),
    [sym__cond_no_section_op] = ACTIONS(3541),
    [sym__consym] = ACTIONS(2737),
  },
  [1809] = {
    [sym__at_type] = STATE(7319),
    [sym_explicit_type] = STATE(7342),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1804),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__constructor_ticked] = STATE(2273),
    [sym__qconstructor_ticked] = STATE(2273),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym_constructor_operator] = STATE(2273),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2396),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(40),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym__] = ACTIONS(3009),
    [anon_sym_EQ] = ACTIONS(3011),
    [anon_sym_PIPE] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3009),
    [anon_sym_DASH_GT] = ACTIONS(3011),
    [anon_sym_LBRACK] = ACTIONS(3011),
    [sym_float] = ACTIONS(3011),
    [sym_char] = ACTIONS(3011),
    [sym_string] = ACTIONS(3011),
    [sym__integer_literal] = ACTIONS(3009),
    [sym__binary_literal] = ACTIONS(3011),
    [sym__octal_literal] = ACTIONS(3011),
    [sym__hex_literal] = ACTIONS(3011),
    [anon_sym_BQUOTE] = ACTIONS(3011),
    [sym_name] = ACTIONS(3011),
    [anon_sym_u2192] = ACTIONS(3011),
    [anon_sym_COLON_COLON] = ACTIONS(3011),
    [anon_sym_u2237] = ACTIONS(3011),
    [aux_sym__paren_open_token1] = ACTIONS(3011),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(3011),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3011),
    [sym__cond_splice] = ACTIONS(3011),
    [sym__cond_prefix_at] = ACTIONS(3011),
    [sym__cond_tight_bang] = ACTIONS(3011),
    [sym__cond_prefix_bang] = ACTIONS(3011),
    [sym__cond_tight_tilde] = ACTIONS(3011),
    [sym__cond_prefix_tilde] = ACTIONS(3011),
    [sym__cond_qualified_op] = ACTIONS(3011),
    [sym__cond_no_section_op] = ACTIONS(3011),
    [sym__consym] = ACTIONS(3011),
  },
  [1810] = {
    [sym__at_type] = STATE(7319),
    [sym_explicit_type] = STATE(7342),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1804),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__constructor_ticked] = STATE(2273),
    [sym__qconstructor_ticked] = STATE(2273),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym_constructor_operator] = STATE(2273),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2396),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(40),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(2821),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym__] = ACTIONS(2821),
    [anon_sym_EQ] = ACTIONS(2823),
    [anon_sym_PIPE] = ACTIONS(2823),
    [anon_sym_DASH] = ACTIONS(2821),
    [anon_sym_DASH_GT] = ACTIONS(2823),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [sym_float] = ACTIONS(2823),
    [sym_char] = ACTIONS(2823),
    [sym_string] = ACTIONS(2823),
    [sym__integer_literal] = ACTIONS(2821),
    [sym__binary_literal] = ACTIONS(2823),
    [sym__octal_literal] = ACTIONS(2823),
    [sym__hex_literal] = ACTIONS(2823),
    [anon_sym_BQUOTE] = ACTIONS(2823),
    [sym_name] = ACTIONS(2823),
    [anon_sym_u2192] = ACTIONS(2823),
    [anon_sym_COLON_COLON] = ACTIONS(2823),
    [anon_sym_u2237] = ACTIONS(2823),
    [aux_sym__paren_open_token1] = ACTIONS(2823),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(2823),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2823),
    [sym__cond_splice] = ACTIONS(2823),
    [sym__cond_prefix_at] = ACTIONS(2823),
    [sym__cond_tight_bang] = ACTIONS(2823),
    [sym__cond_prefix_bang] = ACTIONS(2823),
    [sym__cond_tight_tilde] = ACTIONS(2823),
    [sym__cond_prefix_tilde] = ACTIONS(2823),
    [sym__cond_qualified_op] = ACTIONS(2823),
    [sym__cond_no_section_op] = ACTIONS(2823),
    [sym__consym] = ACTIONS(2823),
  },
  [1811] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1814),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2294),
    [sym__qconstructor_ticked] = STATE(2294),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2294),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2526),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(3535),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_PIPE] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [anon_sym_PIPE2] = ACTIONS(2829),
    [sym_name] = ACTIONS(2841),
    [anon_sym_COLON_COLON] = ACTIONS(2829),
    [anon_sym_u2237] = ACTIONS(2829),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(2829),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(3539),
    [sym__cond_no_section_op] = ACTIONS(3541),
    [sym__consym] = ACTIONS(2737),
  },
  [1812] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2598),
    [sym__qtycon_ticked] = STATE(2598),
    [sym__tyconids_ticked] = STATE(2598),
    [sym__promoted_tyconops_alias] = STATE(2598),
    [sym__promoted_tyconops] = STATE(2598),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2598),
    [sym__operator_alias] = STATE(2598),
    [sym__operator_minus] = STATE(2598),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2599),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2598),
    [sym__constructor_operator_alias] = STATE(2598),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2600),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1813] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2462),
    [sym__qtycon_ticked] = STATE(2462),
    [sym__tyconids_ticked] = STATE(2462),
    [sym__promoted_tyconops_alias] = STATE(2462),
    [sym__promoted_tyconops] = STATE(2462),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2462),
    [sym__operator_alias] = STATE(2462),
    [sym__operator_minus] = STATE(2462),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2461),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2462),
    [sym__constructor_operator_alias] = STATE(2462),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2460),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1814] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1814),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2294),
    [sym__qconstructor_ticked] = STATE(2294),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2294),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2526),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(3005),
    [anon_sym_COMMA] = ACTIONS(3007),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym__] = ACTIONS(3005),
    [anon_sym_PIPE] = ACTIONS(3005),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [sym_float] = ACTIONS(3007),
    [sym_char] = ACTIONS(3007),
    [sym_string] = ACTIONS(3007),
    [sym__integer_literal] = ACTIONS(3005),
    [sym__binary_literal] = ACTIONS(3007),
    [sym__octal_literal] = ACTIONS(3007),
    [sym__hex_literal] = ACTIONS(3007),
    [anon_sym_BQUOTE] = ACTIONS(3007),
    [anon_sym_PIPE2] = ACTIONS(3007),
    [sym_name] = ACTIONS(3007),
    [anon_sym_COLON_COLON] = ACTIONS(3007),
    [anon_sym_u2237] = ACTIONS(3007),
    [aux_sym__paren_open_token1] = ACTIONS(3007),
    [anon_sym_POUND_RPAREN] = ACTIONS(3007),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3007),
    [sym__cond_splice] = ACTIONS(3007),
    [sym__cond_prefix_at] = ACTIONS(3007),
    [sym__cond_tight_bang] = ACTIONS(3007),
    [sym__cond_prefix_bang] = ACTIONS(3007),
    [sym__cond_tight_tilde] = ACTIONS(3007),
    [sym__cond_prefix_tilde] = ACTIONS(3007),
    [sym__cond_qualified_op] = ACTIONS(3007),
    [sym__cond_no_section_op] = ACTIONS(3007),
    [sym__consym] = ACTIONS(3007),
  },
  [1815] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1814),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2294),
    [sym__qconstructor_ticked] = STATE(2294),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2294),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2526),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(3009),
    [anon_sym_COMMA] = ACTIONS(3011),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym__] = ACTIONS(3009),
    [anon_sym_PIPE] = ACTIONS(3009),
    [anon_sym_DASH] = ACTIONS(3011),
    [anon_sym_LBRACK] = ACTIONS(3011),
    [sym_float] = ACTIONS(3011),
    [sym_char] = ACTIONS(3011),
    [sym_string] = ACTIONS(3011),
    [sym__integer_literal] = ACTIONS(3009),
    [sym__binary_literal] = ACTIONS(3011),
    [sym__octal_literal] = ACTIONS(3011),
    [sym__hex_literal] = ACTIONS(3011),
    [anon_sym_BQUOTE] = ACTIONS(3011),
    [anon_sym_PIPE2] = ACTIONS(3011),
    [sym_name] = ACTIONS(3011),
    [anon_sym_COLON_COLON] = ACTIONS(3011),
    [anon_sym_u2237] = ACTIONS(3011),
    [aux_sym__paren_open_token1] = ACTIONS(3011),
    [anon_sym_POUND_RPAREN] = ACTIONS(3011),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3011),
    [sym__cond_splice] = ACTIONS(3011),
    [sym__cond_prefix_at] = ACTIONS(3011),
    [sym__cond_tight_bang] = ACTIONS(3011),
    [sym__cond_prefix_bang] = ACTIONS(3011),
    [sym__cond_tight_tilde] = ACTIONS(3011),
    [sym__cond_prefix_tilde] = ACTIONS(3011),
    [sym__cond_qualified_op] = ACTIONS(3011),
    [sym__cond_no_section_op] = ACTIONS(3011),
    [sym__consym] = ACTIONS(3011),
  },
  [1816] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1814),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2294),
    [sym__qconstructor_ticked] = STATE(2294),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2294),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2526),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(3013),
    [anon_sym_COMMA] = ACTIONS(3015),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym__] = ACTIONS(3013),
    [anon_sym_PIPE] = ACTIONS(3013),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [sym_float] = ACTIONS(3015),
    [sym_char] = ACTIONS(3015),
    [sym_string] = ACTIONS(3015),
    [sym__integer_literal] = ACTIONS(3013),
    [sym__binary_literal] = ACTIONS(3015),
    [sym__octal_literal] = ACTIONS(3015),
    [sym__hex_literal] = ACTIONS(3015),
    [anon_sym_BQUOTE] = ACTIONS(3015),
    [anon_sym_PIPE2] = ACTIONS(3015),
    [sym_name] = ACTIONS(3015),
    [anon_sym_COLON_COLON] = ACTIONS(3015),
    [anon_sym_u2237] = ACTIONS(3015),
    [aux_sym__paren_open_token1] = ACTIONS(3015),
    [anon_sym_POUND_RPAREN] = ACTIONS(3015),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3015),
    [sym__cond_splice] = ACTIONS(3015),
    [sym__cond_prefix_at] = ACTIONS(3015),
    [sym__cond_tight_bang] = ACTIONS(3015),
    [sym__cond_prefix_bang] = ACTIONS(3015),
    [sym__cond_tight_tilde] = ACTIONS(3015),
    [sym__cond_prefix_tilde] = ACTIONS(3015),
    [sym__cond_qualified_op] = ACTIONS(3015),
    [sym__cond_no_section_op] = ACTIONS(3015),
    [sym__consym] = ACTIONS(3015),
  },
  [1817] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1814),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2294),
    [sym__qconstructor_ticked] = STATE(2294),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2294),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2526),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2821),
    [anon_sym_COMMA] = ACTIONS(2823),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym__] = ACTIONS(2821),
    [anon_sym_PIPE] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2823),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [sym_float] = ACTIONS(2823),
    [sym_char] = ACTIONS(2823),
    [sym_string] = ACTIONS(2823),
    [sym__integer_literal] = ACTIONS(2821),
    [sym__binary_literal] = ACTIONS(2823),
    [sym__octal_literal] = ACTIONS(2823),
    [sym__hex_literal] = ACTIONS(2823),
    [anon_sym_BQUOTE] = ACTIONS(2823),
    [anon_sym_PIPE2] = ACTIONS(2823),
    [sym_name] = ACTIONS(2823),
    [anon_sym_COLON_COLON] = ACTIONS(2823),
    [anon_sym_u2237] = ACTIONS(2823),
    [aux_sym__paren_open_token1] = ACTIONS(2823),
    [anon_sym_POUND_RPAREN] = ACTIONS(2823),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2823),
    [sym__cond_splice] = ACTIONS(2823),
    [sym__cond_prefix_at] = ACTIONS(2823),
    [sym__cond_tight_bang] = ACTIONS(2823),
    [sym__cond_prefix_bang] = ACTIONS(2823),
    [sym__cond_tight_tilde] = ACTIONS(2823),
    [sym__cond_prefix_tilde] = ACTIONS(2823),
    [sym__cond_qualified_op] = ACTIONS(2823),
    [sym__cond_no_section_op] = ACTIONS(2823),
    [sym__consym] = ACTIONS(2823),
  },
  [1818] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(2399),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(2399),
  },
  [1819] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1814),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2294),
    [sym__qconstructor_ticked] = STATE(2294),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2294),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2526),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(3535),
    [anon_sym_COMMA] = ACTIONS(2903),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_PIPE] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [anon_sym_PIPE2] = ACTIONS(2903),
    [sym_name] = ACTIONS(2841),
    [anon_sym_COLON_COLON] = ACTIONS(2903),
    [anon_sym_u2237] = ACTIONS(2903),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(2903),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(3539),
    [sym__cond_no_section_op] = ACTIONS(3541),
    [sym__consym] = ACTIONS(2737),
  },
  [1820] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1814),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2294),
    [sym__qconstructor_ticked] = STATE(2294),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2294),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2526),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(3535),
    [anon_sym_COMMA] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_PIPE] = ACTIONS(3227),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [anon_sym_PIPE2] = ACTIONS(2899),
    [sym_name] = ACTIONS(2841),
    [anon_sym_COLON_COLON] = ACTIONS(2899),
    [anon_sym_u2237] = ACTIONS(2899),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(2899),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(3539),
    [sym__cond_no_section_op] = ACTIONS(3541),
    [sym__consym] = ACTIONS(2737),
  },
  [1821] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2491),
    [sym__qtycon_ticked] = STATE(2491),
    [sym__tyconids_ticked] = STATE(2491),
    [sym__promoted_tyconops_alias] = STATE(2491),
    [sym__promoted_tyconops] = STATE(2491),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2491),
    [sym__operator_alias] = STATE(2491),
    [sym__operator_minus] = STATE(2491),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2488),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2491),
    [sym__constructor_operator_alias] = STATE(2491),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2479),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1822] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1814),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2294),
    [sym__qconstructor_ticked] = STATE(2294),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2294),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2526),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(3535),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_PIPE] = ACTIONS(3241),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [anon_sym_PIPE2] = ACTIONS(3045),
    [sym_name] = ACTIONS(2841),
    [anon_sym_COLON_COLON] = ACTIONS(3045),
    [anon_sym_u2237] = ACTIONS(3045),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [anon_sym_POUND_RPAREN] = ACTIONS(3045),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(3539),
    [sym__cond_no_section_op] = ACTIONS(3541),
    [sym__consym] = ACTIONS(2737),
  },
  [1823] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1824] = {
    [sym__type_parens] = STATE(6512),
    [sym__type_tuple] = STATE(6513),
    [sym__type_unboxed_tuple] = STATE(6514),
    [sym__type_unboxed_sum] = STATE(6515),
    [sym__type_list] = STATE(6516),
    [sym__type_promoted] = STATE(6510),
    [sym__type_star] = STATE(6510),
    [sym__type_wildcard] = STATE(6510),
    [sym__type_apply] = STATE(6517),
    [sym__type_infix] = STATE(6518),
    [sym_type] = STATE(748),
    [sym_strict_field] = STATE(7712),
    [sym_lazy_field] = STATE(7712),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11289),
    [sym__record_fields] = STATE(9087),
    [sym__splice_dollars] = STATE(7260),
    [sym_splice] = STATE(6510),
    [sym_quasiquote] = STATE(6510),
    [sym_integer] = STATE(6338),
    [sym__plist] = STATE(6519),
    [sym_unit] = STATE(6510),
    [sym_unboxed_unit] = STATE(6510),
    [sym_prefix_tuple] = STATE(6510),
    [sym_prefix_unboxed_tuple] = STATE(6510),
    [sym_prefix_unboxed_sum] = STATE(6510),
    [sym_literal] = STATE(6510),
    [sym__qualified_type] = STATE(6245),
    [sym__qtyconid] = STATE(6520),
    [sym__tycon_arrow] = STATE(6520),
    [sym__qtycon_arrow] = STATE(6520),
    [sym__promoted_tycons_alias] = STATE(6510),
    [sym__promoted_tycons] = STATE(6510),
    [sym__varsym_prefix] = STATE(6520),
    [sym__pvarsym] = STATE(6520),
    [sym__qvarsym_prefix] = STATE(6520),
    [sym__pqvarsym] = STATE(6520),
    [sym__consym_prefix] = STATE(6520),
    [sym__pconsym] = STATE(6520),
    [sym__qconsym_prefix] = STATE(6520),
    [sym__pqconsym] = STATE(6520),
    [sym__prefix_bang] = STATE(2665),
    [sym__tight_bang] = STATE(2665),
    [sym__any_prefix_bang] = STATE(2665),
    [sym__prefix_tilde] = STATE(2470),
    [sym__tight_tilde] = STATE(2470),
    [sym__any_prefix_tilde] = STATE(2470),
    [sym__paren_open] = STATE(431),
    [sym__bracket_open] = STATE(1029),
    [sym__unboxed_open] = STATE(771),
    [aux_sym__datacon_prefix_repeat1] = STATE(1855),
    [sym_variable] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(3543),
    [anon_sym_LBRACE] = ACTIONS(3545),
    [anon_sym__] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(2129),
    [anon_sym_u2605] = ACTIONS(2129),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_deriving] = ACTIONS(3549),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2131),
    [sym_char] = ACTIONS(2131),
    [sym_string] = ACTIONS(2131),
    [sym__integer_literal] = ACTIONS(2133),
    [sym__binary_literal] = ACTIONS(2135),
    [sym__octal_literal] = ACTIONS(2135),
    [sym__hex_literal] = ACTIONS(2135),
    [sym_name] = ACTIONS(3551),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3543),
    [sym__cond_layout_end] = ACTIONS(3543),
    [sym__cond_layout_end_explicit] = ACTIONS(3543),
    [sym__phantom_bar] = ACTIONS(3543),
    [sym__phantom_deriving] = ACTIONS(3543),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2139),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
  },
  [1825] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2556),
    [sym__qtycon_ticked] = STATE(2556),
    [sym__tyconids_ticked] = STATE(2556),
    [sym__promoted_tyconops_alias] = STATE(2556),
    [sym__promoted_tyconops] = STATE(2556),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2556),
    [sym__operator_alias] = STATE(2556),
    [sym__operator_minus] = STATE(2556),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2559),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2556),
    [sym__constructor_operator_alias] = STATE(2556),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2560),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1826] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2593),
    [sym__qtycon_ticked] = STATE(2593),
    [sym__tyconids_ticked] = STATE(2593),
    [sym__promoted_tyconops_alias] = STATE(2593),
    [sym__promoted_tyconops] = STATE(2593),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2593),
    [sym__operator_alias] = STATE(2593),
    [sym__operator_minus] = STATE(2593),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2594),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2593),
    [sym__constructor_operator_alias] = STATE(2593),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2595),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1827] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2484),
    [sym__qtycon_ticked] = STATE(2484),
    [sym__tyconids_ticked] = STATE(2484),
    [sym__promoted_tyconops_alias] = STATE(2484),
    [sym__promoted_tyconops] = STATE(2484),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2484),
    [sym__operator_alias] = STATE(2484),
    [sym__operator_minus] = STATE(2484),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2485),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2484),
    [sym__constructor_operator_alias] = STATE(2484),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2502),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(177),
  },
  [1828] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7376),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1096),
    [sym__modid_prefix] = STATE(8595),
    [aux_sym__qualifying_module] = STATE(8538),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__tycon_ticked] = STATE(2533),
    [sym__qtycon_ticked] = STATE(2533),
    [sym__tyconids_ticked] = STATE(2533),
    [sym__promoted_tyconops_alias] = STATE(2533),
    [sym__promoted_tyconops] = STATE(2533),
    [sym__operator_hash_head] = STATE(7724),
    [sym_operator] = STATE(2533),
    [sym__operator_alias] = STATE(2533),
    [sym__operator_minus] = STATE(2533),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qualified_varsym] = STATE(2529),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym_constructor_operator] = STATE(2533),
    [sym__constructor_operator_alias] = STATE(2533),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qualified_consym] = STATE(2528),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2543),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_STAR] = ACTIONS(2929),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [anon_sym_BQUOTE] = ACTIONS(2423),
    [anon_sym_POUND] = ACTIONS(1147),
    [anon_sym_POUND2] = ACTIONS(1709),
    [sym_name] = ACTIONS(2939),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_dot] = ACTIONS(1155),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__varsym] = ACTIONS(137),
    [sym__consym] = ACTIONS(2423),
  },
  [1829] = {
    [sym__type_parens] = STATE(6688),
    [sym__type_tuple] = STATE(6687),
    [sym__type_unboxed_tuple] = STATE(6686),
    [sym__type_unboxed_sum] = STATE(6685),
    [sym__type_list] = STATE(6574),
    [sym__type_promoted] = STATE(6689),
    [sym__type_star] = STATE(6689),
    [sym__type_wildcard] = STATE(6689),
    [sym__at_type] = STATE(7641),
    [sym__type_apply] = STATE(6683),
    [sym__type_infix] = STATE(6682),
    [sym_type] = STATE(837),
    [sym_type_patterns] = STATE(8288),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11009),
    [sym_deriving] = STATE(9582),
    [sym__gadt] = STATE(9555),
    [sym__data_rhs] = STATE(9114),
    [sym__splice_dollars] = STATE(7266),
    [sym_splice] = STATE(6689),
    [sym_quasiquote] = STATE(6689),
    [sym_integer] = STATE(6634),
    [sym__plist] = STATE(6681),
    [sym_unit] = STATE(6689),
    [sym_unboxed_unit] = STATE(6689),
    [sym_prefix_tuple] = STATE(6689),
    [sym_prefix_unboxed_tuple] = STATE(6689),
    [sym_prefix_unboxed_sum] = STATE(6689),
    [sym_literal] = STATE(6689),
    [sym__qualified_type] = STATE(6595),
    [sym__qtyconid] = STATE(6680),
    [sym__tycon_arrow] = STATE(6680),
    [sym__qtycon_arrow] = STATE(6680),
    [sym__promoted_tycons_alias] = STATE(6689),
    [sym__promoted_tycons] = STATE(6689),
    [sym__varsym_prefix] = STATE(6680),
    [sym__pvarsym] = STATE(6680),
    [sym__qvarsym_prefix] = STATE(6680),
    [sym__pqvarsym] = STATE(6680),
    [sym__consym_prefix] = STATE(6680),
    [sym__pconsym] = STATE(6680),
    [sym__qconsym_prefix] = STATE(6680),
    [sym__pqconsym] = STATE(6680),
    [sym__colon2] = STATE(1606),
    [sym__prefix_at] = STATE(2597),
    [sym__paren_open] = STATE(446),
    [sym__bracket_open] = STATE(965),
    [sym__unboxed_open] = STATE(803),
    [sym__where] = STATE(8883),
    [aux_sym_type_patterns_repeat1] = STATE(1981),
    [aux_sym__data_repeat1] = STATE(9112),
    [sym_variable] = ACTIONS(2573),
    [anon_sym_SEMI] = ACTIONS(3553),
    [anon_sym__] = ACTIONS(2575),
    [anon_sym_SQUOTE] = ACTIONS(3555),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_u2605] = ACTIONS(2581),
    [anon_sym_EQ] = ACTIONS(3557),
    [anon_sym_deriving] = ACTIONS(3559),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2583),
    [sym_char] = ACTIONS(2583),
    [sym_string] = ACTIONS(2583),
    [sym__integer_literal] = ACTIONS(2585),
    [sym__binary_literal] = ACTIONS(2587),
    [sym__octal_literal] = ACTIONS(2587),
    [sym__hex_literal] = ACTIONS(2587),
    [sym_name] = ACTIONS(3561),
    [anon_sym_COLON_COLON] = ACTIONS(3563),
    [anon_sym_u2237] = ACTIONS(3563),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(3565),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3553),
    [sym__cond_layout_end] = ACTIONS(3553),
    [sym__cond_layout_end_explicit] = ACTIONS(3553),
    [sym__phantom_where] = ACTIONS(3567),
    [sym__phantom_deriving] = ACTIONS(3569),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2591),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [1830] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9579),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(9451),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(1877),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(3571),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3573),
    [sym__cond_layout_end] = ACTIONS(3575),
    [sym__cond_layout_end_explicit] = ACTIONS(3575),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1831] = {
    [sym__type_parens] = STATE(6688),
    [sym__type_tuple] = STATE(6687),
    [sym__type_unboxed_tuple] = STATE(6686),
    [sym__type_unboxed_sum] = STATE(6685),
    [sym__type_list] = STATE(6574),
    [sym__type_promoted] = STATE(6689),
    [sym__type_star] = STATE(6689),
    [sym__type_wildcard] = STATE(6689),
    [sym__at_type] = STATE(7641),
    [sym__type_apply] = STATE(6683),
    [sym__type_infix] = STATE(6682),
    [sym_type] = STATE(837),
    [sym_type_patterns] = STATE(8292),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11009),
    [sym_deriving] = STATE(9582),
    [sym__gadt] = STATE(9555),
    [sym__data_rhs] = STATE(9018),
    [sym__splice_dollars] = STATE(7266),
    [sym_splice] = STATE(6689),
    [sym_quasiquote] = STATE(6689),
    [sym_integer] = STATE(6634),
    [sym__plist] = STATE(6681),
    [sym_unit] = STATE(6689),
    [sym_unboxed_unit] = STATE(6689),
    [sym_prefix_tuple] = STATE(6689),
    [sym_prefix_unboxed_tuple] = STATE(6689),
    [sym_prefix_unboxed_sum] = STATE(6689),
    [sym_literal] = STATE(6689),
    [sym__qualified_type] = STATE(6595),
    [sym__qtyconid] = STATE(6680),
    [sym__tycon_arrow] = STATE(6680),
    [sym__qtycon_arrow] = STATE(6680),
    [sym__promoted_tycons_alias] = STATE(6689),
    [sym__promoted_tycons] = STATE(6689),
    [sym__varsym_prefix] = STATE(6680),
    [sym__pvarsym] = STATE(6680),
    [sym__qvarsym_prefix] = STATE(6680),
    [sym__pqvarsym] = STATE(6680),
    [sym__consym_prefix] = STATE(6680),
    [sym__pconsym] = STATE(6680),
    [sym__qconsym_prefix] = STATE(6680),
    [sym__pqconsym] = STATE(6680),
    [sym__colon2] = STATE(1606),
    [sym__prefix_at] = STATE(2597),
    [sym__paren_open] = STATE(446),
    [sym__bracket_open] = STATE(965),
    [sym__unboxed_open] = STATE(803),
    [sym__where] = STATE(8883),
    [aux_sym_type_patterns_repeat1] = STATE(1981),
    [aux_sym__data_repeat1] = STATE(9020),
    [sym_variable] = ACTIONS(2573),
    [anon_sym_SEMI] = ACTIONS(3577),
    [anon_sym__] = ACTIONS(2575),
    [anon_sym_SQUOTE] = ACTIONS(3555),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_u2605] = ACTIONS(2581),
    [anon_sym_EQ] = ACTIONS(3557),
    [anon_sym_deriving] = ACTIONS(3559),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2583),
    [sym_char] = ACTIONS(2583),
    [sym_string] = ACTIONS(2583),
    [sym__integer_literal] = ACTIONS(2585),
    [sym__binary_literal] = ACTIONS(2587),
    [sym__octal_literal] = ACTIONS(2587),
    [sym__hex_literal] = ACTIONS(2587),
    [sym_name] = ACTIONS(3561),
    [anon_sym_COLON_COLON] = ACTIONS(3563),
    [anon_sym_u2237] = ACTIONS(3563),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(3565),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3577),
    [sym__cond_layout_end] = ACTIONS(3577),
    [sym__cond_layout_end_explicit] = ACTIONS(3577),
    [sym__phantom_where] = ACTIONS(3567),
    [sym__phantom_deriving] = ACTIONS(3569),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2591),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [1832] = {
    [sym__type_parens] = STATE(6688),
    [sym__type_tuple] = STATE(6687),
    [sym__type_unboxed_tuple] = STATE(6686),
    [sym__type_unboxed_sum] = STATE(6685),
    [sym__type_list] = STATE(6574),
    [sym__type_promoted] = STATE(6689),
    [sym__type_star] = STATE(6689),
    [sym__type_wildcard] = STATE(6689),
    [sym__at_type] = STATE(7641),
    [sym__type_apply] = STATE(6683),
    [sym__type_infix] = STATE(6682),
    [sym_type] = STATE(837),
    [sym_type_patterns] = STATE(8278),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11009),
    [sym_deriving] = STATE(9582),
    [sym__gadt] = STATE(9555),
    [sym__data_rhs] = STATE(9091),
    [sym__splice_dollars] = STATE(7266),
    [sym_splice] = STATE(6689),
    [sym_quasiquote] = STATE(6689),
    [sym_integer] = STATE(6634),
    [sym__plist] = STATE(6681),
    [sym_unit] = STATE(6689),
    [sym_unboxed_unit] = STATE(6689),
    [sym_prefix_tuple] = STATE(6689),
    [sym_prefix_unboxed_tuple] = STATE(6689),
    [sym_prefix_unboxed_sum] = STATE(6689),
    [sym_literal] = STATE(6689),
    [sym__qualified_type] = STATE(6595),
    [sym__qtyconid] = STATE(6680),
    [sym__tycon_arrow] = STATE(6680),
    [sym__qtycon_arrow] = STATE(6680),
    [sym__promoted_tycons_alias] = STATE(6689),
    [sym__promoted_tycons] = STATE(6689),
    [sym__varsym_prefix] = STATE(6680),
    [sym__pvarsym] = STATE(6680),
    [sym__qvarsym_prefix] = STATE(6680),
    [sym__pqvarsym] = STATE(6680),
    [sym__consym_prefix] = STATE(6680),
    [sym__pconsym] = STATE(6680),
    [sym__qconsym_prefix] = STATE(6680),
    [sym__pqconsym] = STATE(6680),
    [sym__colon2] = STATE(1606),
    [sym__prefix_at] = STATE(2597),
    [sym__paren_open] = STATE(446),
    [sym__bracket_open] = STATE(965),
    [sym__unboxed_open] = STATE(803),
    [sym__where] = STATE(8883),
    [aux_sym_type_patterns_repeat1] = STATE(1981),
    [aux_sym__data_repeat1] = STATE(9090),
    [sym_variable] = ACTIONS(2573),
    [anon_sym_SEMI] = ACTIONS(3579),
    [anon_sym__] = ACTIONS(2575),
    [anon_sym_SQUOTE] = ACTIONS(3555),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_u2605] = ACTIONS(2581),
    [anon_sym_EQ] = ACTIONS(3557),
    [anon_sym_deriving] = ACTIONS(3559),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2583),
    [sym_char] = ACTIONS(2583),
    [sym_string] = ACTIONS(2583),
    [sym__integer_literal] = ACTIONS(2585),
    [sym__binary_literal] = ACTIONS(2587),
    [sym__octal_literal] = ACTIONS(2587),
    [sym__hex_literal] = ACTIONS(2587),
    [sym_name] = ACTIONS(3561),
    [anon_sym_COLON_COLON] = ACTIONS(3563),
    [anon_sym_u2237] = ACTIONS(3563),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(3565),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3579),
    [sym__cond_layout_end] = ACTIONS(3579),
    [sym__cond_layout_end_explicit] = ACTIONS(3579),
    [sym__phantom_where] = ACTIONS(3567),
    [sym__phantom_deriving] = ACTIONS(3569),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2591),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [1833] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9666),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(9214),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(1880),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(3581),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3583),
    [sym__cond_layout_end] = ACTIONS(3585),
    [sym__cond_layout_end_explicit] = ACTIONS(3585),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1834] = {
    [sym__at_type] = STATE(7319),
    [sym_explicit_type] = STATE(7342),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1804),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__constructor_ticked] = STATE(2273),
    [sym__qconstructor_ticked] = STATE(2273),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym_constructor_operator] = STATE(2273),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2396),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(40),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym__] = ACTIONS(3587),
    [anon_sym_EQ] = ACTIONS(3589),
    [anon_sym_PIPE] = ACTIONS(3589),
    [anon_sym_DASH] = ACTIONS(3587),
    [anon_sym_DASH_GT] = ACTIONS(3589),
    [anon_sym_LBRACK] = ACTIONS(3589),
    [sym_float] = ACTIONS(3589),
    [sym_char] = ACTIONS(3589),
    [sym_string] = ACTIONS(3589),
    [sym__integer_literal] = ACTIONS(3587),
    [sym__binary_literal] = ACTIONS(3589),
    [sym__octal_literal] = ACTIONS(3589),
    [sym__hex_literal] = ACTIONS(3589),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(3589),
    [anon_sym_u2192] = ACTIONS(3589),
    [aux_sym__paren_open_token1] = ACTIONS(3589),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(3589),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3589),
    [sym__cond_splice] = ACTIONS(3589),
    [sym__cond_prefix_at] = ACTIONS(3589),
    [sym__cond_tight_bang] = ACTIONS(3589),
    [sym__cond_prefix_bang] = ACTIONS(3589),
    [sym__cond_tight_tilde] = ACTIONS(3589),
    [sym__cond_prefix_tilde] = ACTIONS(3589),
    [sym__cond_qualified_op] = ACTIONS(3523),
    [sym__cond_no_section_op] = ACTIONS(3525),
    [sym__consym] = ACTIONS(2737),
  },
  [1835] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9644),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(9290),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(1874),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(3591),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3593),
    [sym__cond_layout_end] = ACTIONS(3595),
    [sym__cond_layout_end_explicit] = ACTIONS(3595),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1836] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(10716),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10716),
    [sym__local_decl] = STATE(10716),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1837] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__fun_arrow_fixity] = STATE(10080),
    [sym_fixity] = STATE(9399),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(9399),
    [sym__local_decl] = STATE(9399),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_infixr] = ACTIONS(51),
    [anon_sym_infixl] = ACTIONS(53),
    [anon_sym_infix] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1838] = {
    [sym__type_parens] = STATE(6688),
    [sym__type_tuple] = STATE(6687),
    [sym__type_unboxed_tuple] = STATE(6686),
    [sym__type_unboxed_sum] = STATE(6685),
    [sym__type_list] = STATE(6574),
    [sym__type_promoted] = STATE(6689),
    [sym__type_star] = STATE(6689),
    [sym__type_wildcard] = STATE(6689),
    [sym__at_type] = STATE(7641),
    [sym__type_apply] = STATE(6683),
    [sym__type_infix] = STATE(6682),
    [sym_type] = STATE(837),
    [sym_type_patterns] = STATE(8276),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11009),
    [sym_deriving] = STATE(9582),
    [sym__gadt] = STATE(9555),
    [sym__data_rhs] = STATE(8952),
    [sym__splice_dollars] = STATE(7266),
    [sym_splice] = STATE(6689),
    [sym_quasiquote] = STATE(6689),
    [sym_integer] = STATE(6634),
    [sym__plist] = STATE(6681),
    [sym_unit] = STATE(6689),
    [sym_unboxed_unit] = STATE(6689),
    [sym_prefix_tuple] = STATE(6689),
    [sym_prefix_unboxed_tuple] = STATE(6689),
    [sym_prefix_unboxed_sum] = STATE(6689),
    [sym_literal] = STATE(6689),
    [sym__qualified_type] = STATE(6595),
    [sym__qtyconid] = STATE(6680),
    [sym__tycon_arrow] = STATE(6680),
    [sym__qtycon_arrow] = STATE(6680),
    [sym__promoted_tycons_alias] = STATE(6689),
    [sym__promoted_tycons] = STATE(6689),
    [sym__varsym_prefix] = STATE(6680),
    [sym__pvarsym] = STATE(6680),
    [sym__qvarsym_prefix] = STATE(6680),
    [sym__pqvarsym] = STATE(6680),
    [sym__consym_prefix] = STATE(6680),
    [sym__pconsym] = STATE(6680),
    [sym__qconsym_prefix] = STATE(6680),
    [sym__pqconsym] = STATE(6680),
    [sym__colon2] = STATE(1606),
    [sym__prefix_at] = STATE(2597),
    [sym__paren_open] = STATE(446),
    [sym__bracket_open] = STATE(965),
    [sym__unboxed_open] = STATE(803),
    [sym__where] = STATE(8883),
    [aux_sym_type_patterns_repeat1] = STATE(1981),
    [aux_sym__data_repeat1] = STATE(9043),
    [sym_variable] = ACTIONS(2573),
    [anon_sym_SEMI] = ACTIONS(3597),
    [anon_sym__] = ACTIONS(2575),
    [anon_sym_SQUOTE] = ACTIONS(3555),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_u2605] = ACTIONS(2581),
    [anon_sym_EQ] = ACTIONS(3557),
    [anon_sym_deriving] = ACTIONS(3559),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2583),
    [sym_char] = ACTIONS(2583),
    [sym_string] = ACTIONS(2583),
    [sym__integer_literal] = ACTIONS(2585),
    [sym__binary_literal] = ACTIONS(2587),
    [sym__octal_literal] = ACTIONS(2587),
    [sym__hex_literal] = ACTIONS(2587),
    [sym_name] = ACTIONS(3561),
    [anon_sym_COLON_COLON] = ACTIONS(3563),
    [anon_sym_u2237] = ACTIONS(3563),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(3565),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3597),
    [sym__cond_layout_end] = ACTIONS(3597),
    [sym__cond_layout_end_explicit] = ACTIONS(3597),
    [sym__phantom_where] = ACTIONS(3567),
    [sym__phantom_deriving] = ACTIONS(3569),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2591),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [1839] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9606),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3599),
    [sym__cond_layout_end_explicit] = ACTIONS(3599),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1840] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9629),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3601),
    [sym__cond_layout_end_explicit] = ACTIONS(3601),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1841] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9580),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3603),
    [sym__cond_layout_end_explicit] = ACTIONS(3603),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1842] = {
    [sym__type_parens] = STATE(6512),
    [sym__type_tuple] = STATE(6513),
    [sym__type_unboxed_tuple] = STATE(6514),
    [sym__type_unboxed_sum] = STATE(6515),
    [sym__type_list] = STATE(6516),
    [sym__type_promoted] = STATE(6510),
    [sym__type_star] = STATE(6510),
    [sym__type_wildcard] = STATE(6510),
    [sym__type_apply] = STATE(6517),
    [sym__type_infix] = STATE(6518),
    [sym_type] = STATE(748),
    [sym_strict_field] = STATE(7712),
    [sym_lazy_field] = STATE(7712),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11289),
    [sym__splice_dollars] = STATE(7260),
    [sym_splice] = STATE(6510),
    [sym_quasiquote] = STATE(6510),
    [sym_integer] = STATE(6338),
    [sym__plist] = STATE(6519),
    [sym_unit] = STATE(6510),
    [sym_unboxed_unit] = STATE(6510),
    [sym_prefix_tuple] = STATE(6510),
    [sym_prefix_unboxed_tuple] = STATE(6510),
    [sym_prefix_unboxed_sum] = STATE(6510),
    [sym_literal] = STATE(6510),
    [sym__qualified_type] = STATE(6245),
    [sym__qtyconid] = STATE(6520),
    [sym__tycon_arrow] = STATE(6520),
    [sym__qtycon_arrow] = STATE(6520),
    [sym__promoted_tycons_alias] = STATE(6510),
    [sym__promoted_tycons] = STATE(6510),
    [sym__varsym_prefix] = STATE(6520),
    [sym__pvarsym] = STATE(6520),
    [sym__qvarsym_prefix] = STATE(6520),
    [sym__pqvarsym] = STATE(6520),
    [sym__consym_prefix] = STATE(6520),
    [sym__pconsym] = STATE(6520),
    [sym__qconsym_prefix] = STATE(6520),
    [sym__pqconsym] = STATE(6520),
    [sym__prefix_bang] = STATE(2665),
    [sym__tight_bang] = STATE(2665),
    [sym__any_prefix_bang] = STATE(2665),
    [sym__prefix_tilde] = STATE(2470),
    [sym__tight_tilde] = STATE(2470),
    [sym__any_prefix_tilde] = STATE(2470),
    [sym__paren_open] = STATE(431),
    [sym__bracket_open] = STATE(1029),
    [sym__unboxed_open] = STATE(771),
    [aux_sym__datacon_prefix_repeat1] = STATE(1847),
    [sym_variable] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(3605),
    [anon_sym__] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(2129),
    [anon_sym_u2605] = ACTIONS(2129),
    [anon_sym_PIPE] = ACTIONS(3605),
    [anon_sym_deriving] = ACTIONS(3607),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2131),
    [sym_char] = ACTIONS(2131),
    [sym_string] = ACTIONS(2131),
    [sym__integer_literal] = ACTIONS(2133),
    [sym__binary_literal] = ACTIONS(2135),
    [sym__octal_literal] = ACTIONS(2135),
    [sym__hex_literal] = ACTIONS(2135),
    [sym_name] = ACTIONS(3551),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3605),
    [sym__cond_layout_end] = ACTIONS(3605),
    [sym__cond_layout_end_explicit] = ACTIONS(3605),
    [sym__phantom_bar] = ACTIONS(3605),
    [sym__phantom_deriving] = ACTIONS(3605),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2139),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
  },
  [1843] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9586),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3609),
    [sym__cond_layout_end_explicit] = ACTIONS(3609),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1844] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1056),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2280),
    [sym__qconstructor_ticked] = STATE(2280),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2280),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__larrow] = STATE(2226),
    [sym__prefix_at] = STATE(2642),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_EQ] = ACTIONS(3611),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(2841),
    [anon_sym_LT_DASH] = ACTIONS(3611),
    [anon_sym_u2190] = ACTIONS(3611),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(2845),
    [sym__cond_no_section_op] = ACTIONS(2847),
    [sym__consym] = ACTIONS(2737),
  },
  [1845] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9575),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3613),
    [sym__cond_layout_end_explicit] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1846] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9677),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3615),
    [sym__cond_layout_end_explicit] = ACTIONS(3615),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1847] = {
    [sym__type_parens] = STATE(6512),
    [sym__type_tuple] = STATE(6513),
    [sym__type_unboxed_tuple] = STATE(6514),
    [sym__type_unboxed_sum] = STATE(6515),
    [sym__type_list] = STATE(6516),
    [sym__type_promoted] = STATE(6510),
    [sym__type_star] = STATE(6510),
    [sym__type_wildcard] = STATE(6510),
    [sym__type_apply] = STATE(6517),
    [sym__type_infix] = STATE(6518),
    [sym_type] = STATE(748),
    [sym_strict_field] = STATE(7712),
    [sym_lazy_field] = STATE(7712),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11289),
    [sym__splice_dollars] = STATE(7260),
    [sym_splice] = STATE(6510),
    [sym_quasiquote] = STATE(6510),
    [sym_integer] = STATE(6338),
    [sym__plist] = STATE(6519),
    [sym_unit] = STATE(6510),
    [sym_unboxed_unit] = STATE(6510),
    [sym_prefix_tuple] = STATE(6510),
    [sym_prefix_unboxed_tuple] = STATE(6510),
    [sym_prefix_unboxed_sum] = STATE(6510),
    [sym_literal] = STATE(6510),
    [sym__qualified_type] = STATE(6245),
    [sym__qtyconid] = STATE(6520),
    [sym__tycon_arrow] = STATE(6520),
    [sym__qtycon_arrow] = STATE(6520),
    [sym__promoted_tycons_alias] = STATE(6510),
    [sym__promoted_tycons] = STATE(6510),
    [sym__varsym_prefix] = STATE(6520),
    [sym__pvarsym] = STATE(6520),
    [sym__qvarsym_prefix] = STATE(6520),
    [sym__pqvarsym] = STATE(6520),
    [sym__consym_prefix] = STATE(6520),
    [sym__pconsym] = STATE(6520),
    [sym__qconsym_prefix] = STATE(6520),
    [sym__pqconsym] = STATE(6520),
    [sym__prefix_bang] = STATE(2665),
    [sym__tight_bang] = STATE(2665),
    [sym__any_prefix_bang] = STATE(2665),
    [sym__prefix_tilde] = STATE(2470),
    [sym__tight_tilde] = STATE(2470),
    [sym__any_prefix_tilde] = STATE(2470),
    [sym__paren_open] = STATE(431),
    [sym__bracket_open] = STATE(1029),
    [sym__unboxed_open] = STATE(771),
    [aux_sym__datacon_prefix_repeat1] = STATE(1849),
    [sym_variable] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym__] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(2129),
    [anon_sym_u2605] = ACTIONS(2129),
    [anon_sym_PIPE] = ACTIONS(3617),
    [anon_sym_deriving] = ACTIONS(3619),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2131),
    [sym_char] = ACTIONS(2131),
    [sym_string] = ACTIONS(2131),
    [sym__integer_literal] = ACTIONS(2133),
    [sym__binary_literal] = ACTIONS(2135),
    [sym__octal_literal] = ACTIONS(2135),
    [sym__hex_literal] = ACTIONS(2135),
    [sym_name] = ACTIONS(3551),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3617),
    [sym__cond_layout_end] = ACTIONS(3617),
    [sym__cond_layout_end_explicit] = ACTIONS(3617),
    [sym__phantom_bar] = ACTIONS(3617),
    [sym__phantom_deriving] = ACTIONS(3617),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2139),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
  },
  [1848] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9554),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3621),
    [sym__cond_layout_end_explicit] = ACTIONS(3621),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1849] = {
    [sym__type_parens] = STATE(6512),
    [sym__type_tuple] = STATE(6513),
    [sym__type_unboxed_tuple] = STATE(6514),
    [sym__type_unboxed_sum] = STATE(6515),
    [sym__type_list] = STATE(6516),
    [sym__type_promoted] = STATE(6510),
    [sym__type_star] = STATE(6510),
    [sym__type_wildcard] = STATE(6510),
    [sym__type_apply] = STATE(6517),
    [sym__type_infix] = STATE(6518),
    [sym_type] = STATE(748),
    [sym_strict_field] = STATE(7712),
    [sym_lazy_field] = STATE(7712),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11289),
    [sym__splice_dollars] = STATE(7260),
    [sym_splice] = STATE(6510),
    [sym_quasiquote] = STATE(6510),
    [sym_integer] = STATE(6338),
    [sym__plist] = STATE(6519),
    [sym_unit] = STATE(6510),
    [sym_unboxed_unit] = STATE(6510),
    [sym_prefix_tuple] = STATE(6510),
    [sym_prefix_unboxed_tuple] = STATE(6510),
    [sym_prefix_unboxed_sum] = STATE(6510),
    [sym_literal] = STATE(6510),
    [sym__qualified_type] = STATE(6245),
    [sym__qtyconid] = STATE(6520),
    [sym__tycon_arrow] = STATE(6520),
    [sym__qtycon_arrow] = STATE(6520),
    [sym__promoted_tycons_alias] = STATE(6510),
    [sym__promoted_tycons] = STATE(6510),
    [sym__varsym_prefix] = STATE(6520),
    [sym__pvarsym] = STATE(6520),
    [sym__qvarsym_prefix] = STATE(6520),
    [sym__pqvarsym] = STATE(6520),
    [sym__consym_prefix] = STATE(6520),
    [sym__pconsym] = STATE(6520),
    [sym__qconsym_prefix] = STATE(6520),
    [sym__pqconsym] = STATE(6520),
    [sym__prefix_bang] = STATE(2665),
    [sym__tight_bang] = STATE(2665),
    [sym__any_prefix_bang] = STATE(2665),
    [sym__prefix_tilde] = STATE(2470),
    [sym__tight_tilde] = STATE(2470),
    [sym__any_prefix_tilde] = STATE(2470),
    [sym__paren_open] = STATE(431),
    [sym__bracket_open] = STATE(1029),
    [sym__unboxed_open] = STATE(771),
    [aux_sym__datacon_prefix_repeat1] = STATE(1849),
    [sym_variable] = ACTIONS(3623),
    [anon_sym_SEMI] = ACTIONS(3626),
    [anon_sym__] = ACTIONS(3628),
    [anon_sym_SQUOTE] = ACTIONS(3631),
    [anon_sym_STAR] = ACTIONS(3634),
    [anon_sym_u2605] = ACTIONS(3634),
    [anon_sym_PIPE] = ACTIONS(3626),
    [anon_sym_deriving] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3639),
    [sym_float] = ACTIONS(3642),
    [sym_char] = ACTIONS(3642),
    [sym_string] = ACTIONS(3642),
    [sym__integer_literal] = ACTIONS(3645),
    [sym__binary_literal] = ACTIONS(3648),
    [sym__octal_literal] = ACTIONS(3648),
    [sym__hex_literal] = ACTIONS(3648),
    [sym_name] = ACTIONS(3651),
    [aux_sym__paren_open_token1] = ACTIONS(3654),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3626),
    [sym__cond_layout_end] = ACTIONS(3626),
    [sym__cond_layout_end_explicit] = ACTIONS(3626),
    [sym__phantom_bar] = ACTIONS(3626),
    [sym__phantom_deriving] = ACTIONS(3626),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3657),
    [sym__cond_splice] = ACTIONS(3660),
    [sym__cond_tight_bang] = ACTIONS(3663),
    [sym__cond_prefix_bang] = ACTIONS(3666),
    [sym__cond_tight_tilde] = ACTIONS(3669),
    [sym__cond_prefix_tilde] = ACTIONS(3672),
  },
  [1850] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9620),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3675),
    [sym__cond_layout_end_explicit] = ACTIONS(3675),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1851] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9569),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3677),
    [sym__cond_layout_end_explicit] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1852] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9639),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3679),
    [sym__cond_layout_end_explicit] = ACTIONS(3679),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1853] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9625),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3681),
    [sym__cond_layout_end_explicit] = ACTIONS(3681),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1854] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9675),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3683),
    [sym__cond_layout_end_explicit] = ACTIONS(3683),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1855] = {
    [sym__type_parens] = STATE(6512),
    [sym__type_tuple] = STATE(6513),
    [sym__type_unboxed_tuple] = STATE(6514),
    [sym__type_unboxed_sum] = STATE(6515),
    [sym__type_list] = STATE(6516),
    [sym__type_promoted] = STATE(6510),
    [sym__type_star] = STATE(6510),
    [sym__type_wildcard] = STATE(6510),
    [sym__type_apply] = STATE(6517),
    [sym__type_infix] = STATE(6518),
    [sym_type] = STATE(748),
    [sym_strict_field] = STATE(7712),
    [sym_lazy_field] = STATE(7712),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11289),
    [sym__splice_dollars] = STATE(7260),
    [sym_splice] = STATE(6510),
    [sym_quasiquote] = STATE(6510),
    [sym_integer] = STATE(6338),
    [sym__plist] = STATE(6519),
    [sym_unit] = STATE(6510),
    [sym_unboxed_unit] = STATE(6510),
    [sym_prefix_tuple] = STATE(6510),
    [sym_prefix_unboxed_tuple] = STATE(6510),
    [sym_prefix_unboxed_sum] = STATE(6510),
    [sym_literal] = STATE(6510),
    [sym__qualified_type] = STATE(6245),
    [sym__qtyconid] = STATE(6520),
    [sym__tycon_arrow] = STATE(6520),
    [sym__qtycon_arrow] = STATE(6520),
    [sym__promoted_tycons_alias] = STATE(6510),
    [sym__promoted_tycons] = STATE(6510),
    [sym__varsym_prefix] = STATE(6520),
    [sym__pvarsym] = STATE(6520),
    [sym__qvarsym_prefix] = STATE(6520),
    [sym__pqvarsym] = STATE(6520),
    [sym__consym_prefix] = STATE(6520),
    [sym__pconsym] = STATE(6520),
    [sym__qconsym_prefix] = STATE(6520),
    [sym__pqconsym] = STATE(6520),
    [sym__prefix_bang] = STATE(2665),
    [sym__tight_bang] = STATE(2665),
    [sym__any_prefix_bang] = STATE(2665),
    [sym__prefix_tilde] = STATE(2470),
    [sym__tight_tilde] = STATE(2470),
    [sym__any_prefix_tilde] = STATE(2470),
    [sym__paren_open] = STATE(431),
    [sym__bracket_open] = STATE(1029),
    [sym__unboxed_open] = STATE(771),
    [aux_sym__datacon_prefix_repeat1] = STATE(1849),
    [sym_variable] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(3685),
    [anon_sym__] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(2129),
    [anon_sym_u2605] = ACTIONS(2129),
    [anon_sym_PIPE] = ACTIONS(3685),
    [anon_sym_deriving] = ACTIONS(3687),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2131),
    [sym_char] = ACTIONS(2131),
    [sym_string] = ACTIONS(2131),
    [sym__integer_literal] = ACTIONS(2133),
    [sym__binary_literal] = ACTIONS(2135),
    [sym__octal_literal] = ACTIONS(2135),
    [sym__hex_literal] = ACTIONS(2135),
    [sym_name] = ACTIONS(3551),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3685),
    [sym__cond_layout_end] = ACTIONS(3685),
    [sym__cond_layout_end_explicit] = ACTIONS(3685),
    [sym__phantom_bar] = ACTIONS(3685),
    [sym__phantom_deriving] = ACTIONS(3685),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2139),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
  },
  [1856] = {
    [sym__at_type] = STATE(7319),
    [sym_explicit_type] = STATE(7342),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1804),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__constructor_ticked] = STATE(2273),
    [sym__qconstructor_ticked] = STATE(2273),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym_constructor_operator] = STATE(2273),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2396),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(40),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_PIPE] = ACTIONS(3689),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(3689),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(3523),
    [sym__cond_no_section_op] = ACTIONS(3525),
    [sym__consym] = ACTIONS(2737),
  },
  [1857] = {
    [sym__at_type] = STATE(7319),
    [sym_explicit_type] = STATE(7342),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1804),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__constructor_ticked] = STATE(2273),
    [sym__qconstructor_ticked] = STATE(2273),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym_constructor_operator] = STATE(2273),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2396),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(40),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_EQ] = ACTIONS(3693),
    [anon_sym_PIPE] = ACTIONS(3693),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(3693),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(3523),
    [sym__cond_no_section_op] = ACTIONS(3525),
    [sym__consym] = ACTIONS(2737),
  },
  [1858] = {
    [sym__at_type] = STATE(7319),
    [sym_explicit_type] = STATE(7342),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1804),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__constructor_ticked] = STATE(2273),
    [sym__qconstructor_ticked] = STATE(2273),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym_constructor_operator] = STATE(2273),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2396),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(40),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_EQ] = ACTIONS(3695),
    [anon_sym_PIPE] = ACTIONS(3695),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(3695),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(3523),
    [sym__cond_no_section_op] = ACTIONS(3525),
    [sym__consym] = ACTIONS(2737),
  },
  [1859] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1056),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2280),
    [sym__qconstructor_ticked] = STATE(2280),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2280),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2642),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym__] = ACTIONS(3587),
    [anon_sym_DASH] = ACTIONS(3587),
    [anon_sym_DASH_GT] = ACTIONS(3589),
    [anon_sym_LBRACK] = ACTIONS(3589),
    [sym_float] = ACTIONS(3589),
    [sym_char] = ACTIONS(3589),
    [sym_string] = ACTIONS(3589),
    [sym__integer_literal] = ACTIONS(3587),
    [sym__binary_literal] = ACTIONS(3589),
    [sym__octal_literal] = ACTIONS(3589),
    [sym__hex_literal] = ACTIONS(3589),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(3589),
    [anon_sym_u2192] = ACTIONS(3589),
    [aux_sym__paren_open_token1] = ACTIONS(3589),
    [aux_sym__paren_close_token1] = ACTIONS(3589),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3589),
    [sym__cond_splice] = ACTIONS(3589),
    [sym__cond_prefix_at] = ACTIONS(3589),
    [sym__cond_tight_bang] = ACTIONS(3589),
    [sym__cond_prefix_bang] = ACTIONS(3589),
    [sym__cond_tight_tilde] = ACTIONS(3589),
    [sym__cond_prefix_tilde] = ACTIONS(3589),
    [sym__cond_qualified_op] = ACTIONS(2845),
    [sym__cond_no_section_op] = ACTIONS(2847),
    [sym__consym] = ACTIONS(2737),
  },
  [1860] = {
    [sym__at_type] = STATE(7319),
    [sym_explicit_type] = STATE(7342),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1804),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__constructor_ticked] = STATE(2273),
    [sym__qconstructor_ticked] = STATE(2273),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym_constructor_operator] = STATE(2273),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2396),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(40),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_EQ] = ACTIONS(3697),
    [anon_sym_PIPE] = ACTIONS(3697),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(3697),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(3523),
    [sym__cond_no_section_op] = ACTIONS(3525),
    [sym__consym] = ACTIONS(2737),
  },
  [1861] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9638),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3699),
    [sym__cond_layout_end_explicit] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1862] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9575),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3613),
    [sym__cond_layout_end_explicit] = ACTIONS(3613),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1863] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9621),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3701),
    [sym__cond_layout_end_explicit] = ACTIONS(3701),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1864] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9676),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3703),
    [sym__cond_layout_end_explicit] = ACTIONS(3703),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1865] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9586),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3609),
    [sym__cond_layout_end_explicit] = ACTIONS(3609),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1866] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9543),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3705),
    [sym__cond_layout_end_explicit] = ACTIONS(3705),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1867] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9625),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3681),
    [sym__cond_layout_end_explicit] = ACTIONS(3681),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1868] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9569),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3677),
    [sym__cond_layout_end_explicit] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1869] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9636),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3707),
    [sym__cond_layout_end_explicit] = ACTIONS(3707),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1870] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9554),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3621),
    [sym__cond_layout_end_explicit] = ACTIONS(3621),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1871] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9698),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3709),
    [sym__cond_layout_end_explicit] = ACTIONS(3709),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1872] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__layout_end] = STATE(9580),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3603),
    [sym__cond_layout_end_explicit] = ACTIONS(3603),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1873] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9206),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5281),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(2032),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3711),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3713),
    [sym__cond_layout_end] = ACTIONS(3715),
    [sym__cond_layout_end_explicit] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1874] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(9228),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1875] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9211),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4101),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(2028),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3717),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3719),
    [sym__cond_layout_end] = ACTIONS(3721),
    [sym__cond_layout_end_explicit] = ACTIONS(3721),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1876] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1056),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2280),
    [sym__qconstructor_ticked] = STATE(2280),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2280),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2642),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(3695),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(2845),
    [sym__cond_no_section_op] = ACTIONS(2847),
    [sym__consym] = ACTIONS(2737),
  },
  [1877] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(9245),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1878] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9376),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5276),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(2047),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3723),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3725),
    [sym__cond_layout_end] = ACTIONS(3727),
    [sym__cond_layout_end_explicit] = ACTIONS(3727),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1879] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9391),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5468),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(2029),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3729),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3731),
    [sym__cond_layout_end] = ACTIONS(3733),
    [sym__cond_layout_end_explicit] = ACTIONS(3733),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1880] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(9520),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1881] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9514),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4593),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(2033),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3735),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3737),
    [sym__cond_layout_end] = ACTIONS(3739),
    [sym__cond_layout_end_explicit] = ACTIONS(3739),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1882] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1883] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1056),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2280),
    [sym__qconstructor_ticked] = STATE(2280),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2280),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2642),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(3697),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(2845),
    [sym__cond_no_section_op] = ACTIONS(2847),
    [sym__consym] = ACTIONS(2737),
  },
  [1884] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9310),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4397),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(2039),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3741),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3743),
    [sym__cond_layout_end] = ACTIONS(3745),
    [sym__cond_layout_end_explicit] = ACTIONS(3745),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1885] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9517),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5646),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(2027),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3747),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3749),
    [sym__cond_layout_end] = ACTIONS(3751),
    [sym__cond_layout_end_explicit] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1886] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1056),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2280),
    [sym__qconstructor_ticked] = STATE(2280),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2280),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2642),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(3689),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(2845),
    [sym__cond_no_section_op] = ACTIONS(2847),
    [sym__consym] = ACTIONS(2737),
  },
  [1887] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9537),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(2929),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(2031),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3753),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3755),
    [sym__cond_layout_end] = ACTIONS(3757),
    [sym__cond_layout_end_explicit] = ACTIONS(3757),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1888] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9143),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4995),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(2041),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3759),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3761),
    [sym__cond_layout_end] = ACTIONS(3763),
    [sym__cond_layout_end_explicit] = ACTIONS(3763),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1889] = {
    [sym__at_type] = STATE(5768),
    [sym_explicit_type] = STATE(5767),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1056),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__constructor_ticked] = STATE(2280),
    [sym__qconstructor_ticked] = STATE(2280),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym_constructor_operator] = STATE(2280),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2642),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(38),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym_LBRACE] = ACTIONS(2825),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(3693),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
    [sym__cond_qualified_op] = ACTIONS(2845),
    [sym__cond_no_section_op] = ACTIONS(2847),
    [sym__consym] = ACTIONS(2737),
  },
  [1890] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9340),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4777),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(2048),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3765),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3767),
    [sym__cond_layout_end] = ACTIONS(3769),
    [sym__cond_layout_end_explicit] = ACTIONS(3769),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1891] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4471),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3773),
    [sym__cond_layout_end_explicit] = ACTIONS(3773),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1892] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4495),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3775),
    [sym__cond_layout_end_explicit] = ACTIONS(3775),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1893] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4682),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3777),
    [sym__cond_layout_end_explicit] = ACTIONS(3777),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1894] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5414),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3779),
    [sym__cond_layout_end_explicit] = ACTIONS(3779),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1895] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4616),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3781),
    [sym__cond_layout_end_explicit] = ACTIONS(3781),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1896] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3003),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3783),
    [sym__cond_layout_end_explicit] = ACTIONS(3783),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1897] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5149),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3785),
    [sym__cond_layout_end_explicit] = ACTIONS(3785),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1898] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4590),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3787),
    [sym__cond_layout_end_explicit] = ACTIONS(3787),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1899] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4749),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3789),
    [sym__cond_layout_end_explicit] = ACTIONS(3789),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1900] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3001),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3791),
    [sym__cond_layout_end_explicit] = ACTIONS(3791),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1901] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(2965),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3793),
    [sym__cond_layout_end_explicit] = ACTIONS(3793),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1902] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5179),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3795),
    [sym__cond_layout_end_explicit] = ACTIONS(3795),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1903] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4581),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3797),
    [sym__cond_layout_end_explicit] = ACTIONS(3797),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1904] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4824),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3799),
    [sym__cond_layout_end_explicit] = ACTIONS(3799),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1905] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3032),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3801),
    [sym__cond_layout_end_explicit] = ACTIONS(3801),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1906] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5396),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3803),
    [sym__cond_layout_end_explicit] = ACTIONS(3803),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1907] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4860),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3805),
    [sym__cond_layout_end_explicit] = ACTIONS(3805),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1908] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5399),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3807),
    [sym__cond_layout_end_explicit] = ACTIONS(3807),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1909] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4861),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3809),
    [sym__cond_layout_end_explicit] = ACTIONS(3809),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1910] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5184),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3811),
    [sym__cond_layout_end_explicit] = ACTIONS(3811),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1911] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5401),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3813),
    [sym__cond_layout_end_explicit] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1912] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3968),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3815),
    [sym__cond_layout_end_explicit] = ACTIONS(3815),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1913] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4830),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3817),
    [sym__cond_layout_end_explicit] = ACTIONS(3817),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1914] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4622),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3819),
    [sym__cond_layout_end_explicit] = ACTIONS(3819),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1915] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(2971),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3821),
    [sym__cond_layout_end_explicit] = ACTIONS(3821),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1916] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4828),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3823),
    [sym__cond_layout_end_explicit] = ACTIONS(3823),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1917] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3955),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3825),
    [sym__cond_layout_end_explicit] = ACTIONS(3825),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1918] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4870),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3827),
    [sym__cond_layout_end_explicit] = ACTIONS(3827),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1919] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3950),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3829),
    [sym__cond_layout_end_explicit] = ACTIONS(3829),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1920] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4872),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3831),
    [sym__cond_layout_end_explicit] = ACTIONS(3831),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1921] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3948),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3833),
    [sym__cond_layout_end_explicit] = ACTIONS(3833),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1922] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5151),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3835),
    [sym__cond_layout_end_explicit] = ACTIONS(3835),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1923] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3006),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3837),
    [sym__cond_layout_end_explicit] = ACTIONS(3837),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1924] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5669),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3839),
    [sym__cond_layout_end_explicit] = ACTIONS(3839),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1925] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5416),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3841),
    [sym__cond_layout_end_explicit] = ACTIONS(3841),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1926] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5673),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3843),
    [sym__cond_layout_end_explicit] = ACTIONS(3843),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1927] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5350),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3845),
    [sym__cond_layout_end_explicit] = ACTIONS(3845),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1928] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4900),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3847),
    [sym__cond_layout_end_explicit] = ACTIONS(3847),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1929] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4458),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3849),
    [sym__cond_layout_end_explicit] = ACTIONS(3849),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1930] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4460),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3851),
    [sym__cond_layout_end_explicit] = ACTIONS(3851),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1931] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4905),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3853),
    [sym__cond_layout_end_explicit] = ACTIONS(3853),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1932] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5160),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3855),
    [sym__cond_layout_end_explicit] = ACTIONS(3855),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1933] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4909),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3857),
    [sym__cond_layout_end_explicit] = ACTIONS(3857),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1934] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5198),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3859),
    [sym__cond_layout_end_explicit] = ACTIONS(3859),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1935] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4632),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3861),
    [sym__cond_layout_end_explicit] = ACTIONS(3861),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1936] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5193),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3863),
    [sym__cond_layout_end_explicit] = ACTIONS(3863),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1937] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5531),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3865),
    [sym__cond_layout_end_explicit] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1938] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3938),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3867),
    [sym__cond_layout_end_explicit] = ACTIONS(3867),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1939] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4473),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3869),
    [sym__cond_layout_end_explicit] = ACTIONS(3869),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1940] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5524),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3871),
    [sym__cond_layout_end_explicit] = ACTIONS(3871),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1941] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4476),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3873),
    [sym__cond_layout_end_explicit] = ACTIONS(3873),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1942] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5647),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3875),
    [sym__cond_layout_end_explicit] = ACTIONS(3875),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1943] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5163),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3877),
    [sym__cond_layout_end_explicit] = ACTIONS(3877),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1944] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3936),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3879),
    [sym__cond_layout_end_explicit] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1945] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5200),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3881),
    [sym__cond_layout_end_explicit] = ACTIONS(3881),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1946] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4924),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3883),
    [sym__cond_layout_end_explicit] = ACTIONS(3883),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1947] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5220),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3885),
    [sym__cond_layout_end_explicit] = ACTIONS(3885),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1948] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5167),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3887),
    [sym__cond_layout_end_explicit] = ACTIONS(3887),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1949] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5628),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3889),
    [sym__cond_layout_end_explicit] = ACTIONS(3889),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1950] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5203),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(7988),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3891),
    [sym__cond_layout_end_explicit] = ACTIONS(3891),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1951] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(9245),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1952] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(10259),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1953] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(9520),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1954] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(885),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__var_binding_list] = STATE(10941),
    [sym_signature] = STATE(10081),
    [sym__function_name] = STATE(2128),
    [sym_function_head_parens] = STATE(2130),
    [sym__function_head_infix] = STATE(8914),
    [sym_function] = STATE(10081),
    [sym_bind] = STATE(10081),
    [sym_decl] = STATE(9228),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(5087),
    [sym__pvarsym] = STATE(5087),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(37),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(1927),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1955] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5152),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3893),
    [sym__cond_layout_end_explicit] = ACTIONS(3893),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1956] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3949),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3895),
    [sym__cond_layout_end_explicit] = ACTIONS(3895),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1957] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4620),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3897),
    [sym__cond_layout_end_explicit] = ACTIONS(3897),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1958] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4925),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3899),
    [sym__cond_layout_end_explicit] = ACTIONS(3899),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1959] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5221),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3901),
    [sym__cond_layout_end_explicit] = ACTIONS(3901),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1960] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5199),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3903),
    [sym__cond_layout_end_explicit] = ACTIONS(3903),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1961] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5164),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3905),
    [sym__cond_layout_end_explicit] = ACTIONS(3905),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1962] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3937),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3907),
    [sym__cond_layout_end_explicit] = ACTIONS(3907),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1963] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5658),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3909),
    [sym__cond_layout_end_explicit] = ACTIONS(3909),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1964] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4477),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3911),
    [sym__cond_layout_end_explicit] = ACTIONS(3911),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1965] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5580),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3913),
    [sym__cond_layout_end_explicit] = ACTIONS(3913),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1966] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4474),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3915),
    [sym__cond_layout_end_explicit] = ACTIONS(3915),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1967] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3010),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3917),
    [sym__cond_layout_end_explicit] = ACTIONS(3917),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1968] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4472),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3919),
    [sym__cond_layout_end_explicit] = ACTIONS(3919),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1969] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4633),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3921),
    [sym__cond_layout_end_explicit] = ACTIONS(3921),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1970] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5525),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3923),
    [sym__cond_layout_end_explicit] = ACTIONS(3923),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1971] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5161),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3925),
    [sym__cond_layout_end_explicit] = ACTIONS(3925),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1972] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4910),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3927),
    [sym__cond_layout_end_explicit] = ACTIONS(3927),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1973] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3939),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3929),
    [sym__cond_layout_end_explicit] = ACTIONS(3929),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1974] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4906),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3931),
    [sym__cond_layout_end_explicit] = ACTIONS(3931),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1975] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3951),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3933),
    [sym__cond_layout_end_explicit] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1976] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4461),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3935),
    [sym__cond_layout_end_explicit] = ACTIONS(3935),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1977] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4904),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3937),
    [sym__cond_layout_end_explicit] = ACTIONS(3937),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1978] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4459),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3939),
    [sym__cond_layout_end_explicit] = ACTIONS(3939),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1979] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5194),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3941),
    [sym__cond_layout_end_explicit] = ACTIONS(3941),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1980] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5349),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3943),
    [sym__cond_layout_end_explicit] = ACTIONS(3943),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1981] = {
    [sym__type_parens] = STATE(6688),
    [sym__type_tuple] = STATE(6687),
    [sym__type_unboxed_tuple] = STATE(6686),
    [sym__type_unboxed_sum] = STATE(6685),
    [sym__type_list] = STATE(6574),
    [sym__type_promoted] = STATE(6689),
    [sym__type_star] = STATE(6689),
    [sym__type_wildcard] = STATE(6689),
    [sym__at_type] = STATE(7641),
    [sym__type_apply] = STATE(6683),
    [sym__type_infix] = STATE(6682),
    [sym_type] = STATE(837),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11009),
    [sym__splice_dollars] = STATE(7266),
    [sym_splice] = STATE(6689),
    [sym_quasiquote] = STATE(6689),
    [sym_integer] = STATE(6634),
    [sym__plist] = STATE(6681),
    [sym_unit] = STATE(6689),
    [sym_unboxed_unit] = STATE(6689),
    [sym_prefix_tuple] = STATE(6689),
    [sym_prefix_unboxed_tuple] = STATE(6689),
    [sym_prefix_unboxed_sum] = STATE(6689),
    [sym_literal] = STATE(6689),
    [sym__qualified_type] = STATE(6595),
    [sym__qtyconid] = STATE(6680),
    [sym__tycon_arrow] = STATE(6680),
    [sym__qtycon_arrow] = STATE(6680),
    [sym__promoted_tycons_alias] = STATE(6689),
    [sym__promoted_tycons] = STATE(6689),
    [sym__varsym_prefix] = STATE(6680),
    [sym__pvarsym] = STATE(6680),
    [sym__qvarsym_prefix] = STATE(6680),
    [sym__pqvarsym] = STATE(6680),
    [sym__consym_prefix] = STATE(6680),
    [sym__pconsym] = STATE(6680),
    [sym__qconsym_prefix] = STATE(6680),
    [sym__pqconsym] = STATE(6680),
    [sym__prefix_at] = STATE(2597),
    [sym__paren_open] = STATE(446),
    [sym__bracket_open] = STATE(965),
    [sym__unboxed_open] = STATE(803),
    [aux_sym_type_patterns_repeat1] = STATE(1993),
    [sym_variable] = ACTIONS(2573),
    [anon_sym_SEMI] = ACTIONS(3945),
    [anon_sym__] = ACTIONS(2575),
    [anon_sym_SQUOTE] = ACTIONS(3555),
    [anon_sym_STAR] = ACTIONS(2581),
    [anon_sym_u2605] = ACTIONS(2581),
    [anon_sym_EQ] = ACTIONS(3945),
    [anon_sym_deriving] = ACTIONS(3947),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2583),
    [sym_char] = ACTIONS(2583),
    [sym_string] = ACTIONS(2583),
    [sym__integer_literal] = ACTIONS(2585),
    [sym__binary_literal] = ACTIONS(2587),
    [sym__octal_literal] = ACTIONS(2587),
    [sym__hex_literal] = ACTIONS(2587),
    [sym_name] = ACTIONS(3561),
    [anon_sym_COLON_COLON] = ACTIONS(3945),
    [anon_sym_u2237] = ACTIONS(3945),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(3947),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3945),
    [sym__cond_layout_end] = ACTIONS(3945),
    [sym__cond_layout_end_explicit] = ACTIONS(3945),
    [sym__phantom_where] = ACTIONS(3945),
    [sym__phantom_deriving] = ACTIONS(3945),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2591),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [1982] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5654),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3949),
    [sym__cond_layout_end_explicit] = ACTIONS(3949),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1983] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5670),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3951),
    [sym__cond_layout_end_explicit] = ACTIONS(3951),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1984] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4629),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3953),
    [sym__cond_layout_end_explicit] = ACTIONS(3953),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1985] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5201),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3955),
    [sym__cond_layout_end_explicit] = ACTIONS(3955),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1986] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5150),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3957),
    [sym__cond_layout_end_explicit] = ACTIONS(3957),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1987] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4496),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3959),
    [sym__cond_layout_end_explicit] = ACTIONS(3959),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1988] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4871),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3961),
    [sym__cond_layout_end_explicit] = ACTIONS(3961),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1989] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4873),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3963),
    [sym__cond_layout_end_explicit] = ACTIONS(3963),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1990] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3004),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3965),
    [sym__cond_layout_end_explicit] = ACTIONS(3965),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1991] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(2972),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(3967),
    [sym__cond_layout_end_explicit] = ACTIONS(3967),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1992] = {
    [sym__at_type] = STATE(7955),
    [sym_explicit_type] = STATE(1992),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(1992),
    [sym_variable] = ACTIONS(3969),
    [anon_sym__] = ACTIONS(3972),
    [anon_sym_EQ] = ACTIONS(3975),
    [anon_sym_PIPE] = ACTIONS(3975),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_DASH_GT] = ACTIONS(3975),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [sym_float] = ACTIONS(3983),
    [sym_char] = ACTIONS(3983),
    [sym_string] = ACTIONS(3983),
    [sym__integer_literal] = ACTIONS(3986),
    [sym__binary_literal] = ACTIONS(3989),
    [sym__octal_literal] = ACTIONS(3989),
    [sym__hex_literal] = ACTIONS(3989),
    [sym_name] = ACTIONS(3992),
    [anon_sym_u2192] = ACTIONS(3975),
    [aux_sym__paren_open_token1] = ACTIONS(3995),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(3975),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3998),
    [sym__cond_splice] = ACTIONS(4001),
    [sym__cond_prefix_at] = ACTIONS(4004),
    [sym__cond_tight_bang] = ACTIONS(4007),
    [sym__cond_prefix_bang] = ACTIONS(4010),
    [sym__cond_tight_tilde] = ACTIONS(4013),
    [sym__cond_prefix_tilde] = ACTIONS(4016),
  },
  [1993] = {
    [sym__type_parens] = STATE(6688),
    [sym__type_tuple] = STATE(6687),
    [sym__type_unboxed_tuple] = STATE(6686),
    [sym__type_unboxed_sum] = STATE(6685),
    [sym__type_list] = STATE(6574),
    [sym__type_promoted] = STATE(6689),
    [sym__type_star] = STATE(6689),
    [sym__type_wildcard] = STATE(6689),
    [sym__at_type] = STATE(7641),
    [sym__type_apply] = STATE(6683),
    [sym__type_infix] = STATE(6682),
    [sym_type] = STATE(837),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11009),
    [sym__splice_dollars] = STATE(7266),
    [sym_splice] = STATE(6689),
    [sym_quasiquote] = STATE(6689),
    [sym_integer] = STATE(6634),
    [sym__plist] = STATE(6681),
    [sym_unit] = STATE(6689),
    [sym_unboxed_unit] = STATE(6689),
    [sym_prefix_tuple] = STATE(6689),
    [sym_prefix_unboxed_tuple] = STATE(6689),
    [sym_prefix_unboxed_sum] = STATE(6689),
    [sym_literal] = STATE(6689),
    [sym__qualified_type] = STATE(6595),
    [sym__qtyconid] = STATE(6680),
    [sym__tycon_arrow] = STATE(6680),
    [sym__qtycon_arrow] = STATE(6680),
    [sym__promoted_tycons_alias] = STATE(6689),
    [sym__promoted_tycons] = STATE(6689),
    [sym__varsym_prefix] = STATE(6680),
    [sym__pvarsym] = STATE(6680),
    [sym__qvarsym_prefix] = STATE(6680),
    [sym__pqvarsym] = STATE(6680),
    [sym__consym_prefix] = STATE(6680),
    [sym__pconsym] = STATE(6680),
    [sym__qconsym_prefix] = STATE(6680),
    [sym__pqconsym] = STATE(6680),
    [sym__prefix_at] = STATE(2597),
    [sym__paren_open] = STATE(446),
    [sym__bracket_open] = STATE(965),
    [sym__unboxed_open] = STATE(803),
    [aux_sym_type_patterns_repeat1] = STATE(1993),
    [sym_variable] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4022),
    [anon_sym__] = ACTIONS(4024),
    [anon_sym_SQUOTE] = ACTIONS(4027),
    [anon_sym_STAR] = ACTIONS(4030),
    [anon_sym_u2605] = ACTIONS(4030),
    [anon_sym_EQ] = ACTIONS(4022),
    [anon_sym_deriving] = ACTIONS(4033),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [sym_float] = ACTIONS(4038),
    [sym_char] = ACTIONS(4038),
    [sym_string] = ACTIONS(4038),
    [sym__integer_literal] = ACTIONS(4041),
    [sym__binary_literal] = ACTIONS(4044),
    [sym__octal_literal] = ACTIONS(4044),
    [sym__hex_literal] = ACTIONS(4044),
    [sym_name] = ACTIONS(4047),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_u2237] = ACTIONS(4022),
    [aux_sym__paren_open_token1] = ACTIONS(4050),
    [anon_sym_where] = ACTIONS(4033),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4022),
    [sym__cond_layout_end] = ACTIONS(4022),
    [sym__cond_layout_end_explicit] = ACTIONS(4022),
    [sym__phantom_where] = ACTIONS(4022),
    [sym__phantom_deriving] = ACTIONS(4022),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4053),
    [sym__cond_splice] = ACTIONS(4056),
    [sym__cond_prefix_at] = ACTIONS(4059),
  },
  [1994] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(10884),
    [sym_bind] = STATE(9257),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(6696),
    [sym__pvarsym] = STATE(6696),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(2146),
    [sym_variable] = ACTIONS(4062),
    [anon_sym_SEMI] = ACTIONS(4064),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4066),
    [sym__cond_layout_end] = ACTIONS(4068),
    [sym__cond_layout_end_explicit] = ACTIONS(4068),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1995] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3956),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4070),
    [sym__cond_layout_end_explicit] = ACTIONS(4070),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1996] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4829),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4072),
    [sym__cond_layout_end_explicit] = ACTIONS(4072),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1997] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5415),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4074),
    [sym__cond_layout_end_explicit] = ACTIONS(4074),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1998] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5651),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4076),
    [sym__cond_layout_end_explicit] = ACTIONS(4076),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [1999] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4831),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4078),
    [sym__cond_layout_end_explicit] = ACTIONS(4078),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2000] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5185),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4080),
    [sym__cond_layout_end_explicit] = ACTIONS(4080),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2001] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3969),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4082),
    [sym__cond_layout_end_explicit] = ACTIONS(4082),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2002] = {
    [sym__at_type] = STATE(7955),
    [sym_explicit_type] = STATE(1992),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(1992),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_EQ] = ACTIONS(4084),
    [anon_sym_PIPE] = ACTIONS(4084),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_DASH_GT] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [anon_sym_u2192] = ACTIONS(4084),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_bar] = ACTIONS(4084),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2003] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5400),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4086),
    [sym__cond_layout_end_explicit] = ACTIONS(4086),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2004] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3034),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4088),
    [sym__cond_layout_end_explicit] = ACTIONS(4088),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2005] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4863),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4090),
    [sym__cond_layout_end_explicit] = ACTIONS(4090),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2006] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5398),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4092),
    [sym__cond_layout_end_explicit] = ACTIONS(4092),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2007] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5183),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4094),
    [sym__cond_layout_end_explicit] = ACTIONS(4094),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2008] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5410),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4096),
    [sym__cond_layout_end_explicit] = ACTIONS(4096),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2009] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4842),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4098),
    [sym__cond_layout_end_explicit] = ACTIONS(4098),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2010] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4809),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4100),
    [sym__cond_layout_end_explicit] = ACTIONS(4100),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2011] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4684),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4102),
    [sym__cond_layout_end_explicit] = ACTIONS(4102),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2012] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4582),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4104),
    [sym__cond_layout_end_explicit] = ACTIONS(4104),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2013] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4306),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4106),
    [sym__cond_layout_end_explicit] = ACTIONS(4106),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2014] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4591),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4108),
    [sym__cond_layout_end_explicit] = ACTIONS(4108),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2015] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3002),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4110),
    [sym__cond_layout_end_explicit] = ACTIONS(4110),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2016] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5168),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4112),
    [sym__cond_layout_end_explicit] = ACTIONS(4112),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2017] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(2970),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4114),
    [sym__cond_layout_end_explicit] = ACTIONS(4114),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2018] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5413),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4116),
    [sym__cond_layout_end_explicit] = ACTIONS(4116),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2019] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5204),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4118),
    [sym__cond_layout_end_explicit] = ACTIONS(4118),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2020] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(10268),
    [sym_bind] = STATE(10373),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(6696),
    [sym__pvarsym] = STATE(6696),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(4062),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4120),
    [sym__cond_layout_end_explicit] = ACTIONS(4120),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2021] = {
    [sym_alternative] = STATE(9374),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5275),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(2176),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(4122),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4124),
    [sym__cond_layout_end] = ACTIONS(4126),
    [sym__cond_layout_end_explicit] = ACTIONS(4126),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2022] = {
    [sym_alternative] = STATE(9210),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4108),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(2173),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(4128),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4130),
    [sym__cond_layout_end] = ACTIONS(4132),
    [sym__cond_layout_end_explicit] = ACTIONS(4132),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2023] = {
    [sym_alternative] = STATE(9209),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5282),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(2190),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(4134),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4136),
    [sym__cond_layout_end] = ACTIONS(4138),
    [sym__cond_layout_end_explicit] = ACTIONS(4138),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2024] = {
    [sym__type_parens] = STATE(7585),
    [sym__type_tuple] = STATE(7602),
    [sym__type_unboxed_tuple] = STATE(7615),
    [sym__type_unboxed_sum] = STATE(7591),
    [sym__type_list] = STATE(7589),
    [sym__type_promoted] = STATE(7555),
    [sym__type_star] = STATE(7555),
    [sym__type_wildcard] = STATE(7555),
    [sym__at_type] = STATE(8035),
    [sym__type_apply] = STATE(7581),
    [sym__type_infix] = STATE(7580),
    [sym_type] = STATE(1267),
    [sym_type_patterns] = STATE(8892),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10889),
    [sym__gadt] = STATE(9109),
    [sym__newtype] = STATE(10038),
    [sym__splice_dollars] = STATE(7479),
    [sym_splice] = STATE(7555),
    [sym_quasiquote] = STATE(7555),
    [sym_integer] = STATE(7595),
    [sym__plist] = STATE(7579),
    [sym_unit] = STATE(7555),
    [sym_unboxed_unit] = STATE(7555),
    [sym_prefix_tuple] = STATE(7555),
    [sym_prefix_unboxed_tuple] = STATE(7555),
    [sym_prefix_unboxed_sum] = STATE(7555),
    [sym_literal] = STATE(7555),
    [sym__qualified_type] = STATE(7587),
    [sym__qtyconid] = STATE(7569),
    [sym__tycon_arrow] = STATE(7569),
    [sym__qtycon_arrow] = STATE(7569),
    [sym__promoted_tycons_alias] = STATE(7555),
    [sym__promoted_tycons] = STATE(7555),
    [sym__varsym_prefix] = STATE(7569),
    [sym__pvarsym] = STATE(7569),
    [sym__qvarsym_prefix] = STATE(7569),
    [sym__pqvarsym] = STATE(7569),
    [sym__consym_prefix] = STATE(7569),
    [sym__pconsym] = STATE(7569),
    [sym__qconsym_prefix] = STATE(7569),
    [sym__pqconsym] = STATE(7569),
    [sym__colon2] = STATE(1572),
    [sym__prefix_at] = STATE(2631),
    [sym__paren_open] = STATE(434),
    [sym__bracket_open] = STATE(963),
    [sym__unboxed_open] = STATE(763),
    [sym__where] = STATE(8883),
    [aux_sym_type_patterns_repeat1] = STATE(2203),
    [sym_variable] = ACTIONS(3203),
    [anon_sym__] = ACTIONS(3205),
    [anon_sym_SQUOTE] = ACTIONS(4140),
    [anon_sym_STAR] = ACTIONS(3211),
    [anon_sym_u2605] = ACTIONS(3211),
    [anon_sym_EQ] = ACTIONS(4142),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3213),
    [sym_char] = ACTIONS(3213),
    [sym_string] = ACTIONS(3213),
    [sym__integer_literal] = ACTIONS(3215),
    [sym__binary_literal] = ACTIONS(3217),
    [sym__octal_literal] = ACTIONS(3217),
    [sym__hex_literal] = ACTIONS(3217),
    [sym_name] = ACTIONS(4144),
    [anon_sym_COLON_COLON] = ACTIONS(4146),
    [anon_sym_u2237] = ACTIONS(4146),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(3565),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_where] = ACTIONS(3567),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3221),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2025] = {
    [sym_alternative] = STATE(9392),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5117),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(2180),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4150),
    [sym__cond_layout_end] = ACTIONS(4152),
    [sym__cond_layout_end_explicit] = ACTIONS(4152),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2026] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(10385),
    [sym_bind] = STATE(10373),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(6696),
    [sym__pvarsym] = STATE(6696),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(4062),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4154),
    [sym__cond_layout_end_explicit] = ACTIONS(4154),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2027] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9461),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(8069),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(4156),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2028] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9283),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(8069),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(4156),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2029] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9327),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(8069),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(4156),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2030] = {
    [sym_alternative] = STATE(9350),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4779),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(2177),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(4158),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4160),
    [sym__cond_layout_end] = ACTIONS(4162),
    [sym__cond_layout_end_explicit] = ACTIONS(4162),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2031] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9235),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(8069),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(4156),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2032] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9149),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(8069),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(4156),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2033] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9522),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(8069),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(4156),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2034] = {
    [sym_alternative] = STATE(9513),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4594),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(2186),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4166),
    [sym__cond_layout_end] = ACTIONS(4168),
    [sym__cond_layout_end_explicit] = ACTIONS(4168),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2035] = {
    [sym__type_parens] = STATE(7585),
    [sym__type_tuple] = STATE(7602),
    [sym__type_unboxed_tuple] = STATE(7615),
    [sym__type_unboxed_sum] = STATE(7591),
    [sym__type_list] = STATE(7589),
    [sym__type_promoted] = STATE(7555),
    [sym__type_star] = STATE(7555),
    [sym__type_wildcard] = STATE(7555),
    [sym__at_type] = STATE(8035),
    [sym__type_apply] = STATE(7581),
    [sym__type_infix] = STATE(7580),
    [sym_type] = STATE(1267),
    [sym_type_patterns] = STATE(8926),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10889),
    [sym__gadt] = STATE(9109),
    [sym__newtype] = STATE(10549),
    [sym__splice_dollars] = STATE(7479),
    [sym_splice] = STATE(7555),
    [sym_quasiquote] = STATE(7555),
    [sym_integer] = STATE(7595),
    [sym__plist] = STATE(7579),
    [sym_unit] = STATE(7555),
    [sym_unboxed_unit] = STATE(7555),
    [sym_prefix_tuple] = STATE(7555),
    [sym_prefix_unboxed_tuple] = STATE(7555),
    [sym_prefix_unboxed_sum] = STATE(7555),
    [sym_literal] = STATE(7555),
    [sym__qualified_type] = STATE(7587),
    [sym__qtyconid] = STATE(7569),
    [sym__tycon_arrow] = STATE(7569),
    [sym__qtycon_arrow] = STATE(7569),
    [sym__promoted_tycons_alias] = STATE(7555),
    [sym__promoted_tycons] = STATE(7555),
    [sym__varsym_prefix] = STATE(7569),
    [sym__pvarsym] = STATE(7569),
    [sym__qvarsym_prefix] = STATE(7569),
    [sym__pqvarsym] = STATE(7569),
    [sym__consym_prefix] = STATE(7569),
    [sym__pconsym] = STATE(7569),
    [sym__qconsym_prefix] = STATE(7569),
    [sym__pqconsym] = STATE(7569),
    [sym__colon2] = STATE(1572),
    [sym__prefix_at] = STATE(2631),
    [sym__paren_open] = STATE(434),
    [sym__bracket_open] = STATE(963),
    [sym__unboxed_open] = STATE(763),
    [sym__where] = STATE(8883),
    [aux_sym_type_patterns_repeat1] = STATE(2203),
    [sym_variable] = ACTIONS(3203),
    [anon_sym__] = ACTIONS(3205),
    [anon_sym_SQUOTE] = ACTIONS(4140),
    [anon_sym_STAR] = ACTIONS(3211),
    [anon_sym_u2605] = ACTIONS(3211),
    [anon_sym_EQ] = ACTIONS(4142),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3213),
    [sym_char] = ACTIONS(3213),
    [sym_string] = ACTIONS(3213),
    [sym__integer_literal] = ACTIONS(3215),
    [sym__binary_literal] = ACTIONS(3217),
    [sym__octal_literal] = ACTIONS(3217),
    [sym__hex_literal] = ACTIONS(3217),
    [sym_name] = ACTIONS(4144),
    [anon_sym_COLON_COLON] = ACTIONS(4146),
    [anon_sym_u2237] = ACTIONS(4146),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(3565),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_where] = ACTIONS(3567),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3221),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2036] = {
    [sym__type_parens] = STATE(7585),
    [sym__type_tuple] = STATE(7602),
    [sym__type_unboxed_tuple] = STATE(7615),
    [sym__type_unboxed_sum] = STATE(7591),
    [sym__type_list] = STATE(7589),
    [sym__type_promoted] = STATE(7555),
    [sym__type_star] = STATE(7555),
    [sym__type_wildcard] = STATE(7555),
    [sym__at_type] = STATE(8035),
    [sym__type_apply] = STATE(7581),
    [sym__type_infix] = STATE(7580),
    [sym_type] = STATE(1267),
    [sym_type_patterns] = STATE(8910),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10889),
    [sym__gadt] = STATE(9109),
    [sym__newtype] = STATE(10638),
    [sym__splice_dollars] = STATE(7479),
    [sym_splice] = STATE(7555),
    [sym_quasiquote] = STATE(7555),
    [sym_integer] = STATE(7595),
    [sym__plist] = STATE(7579),
    [sym_unit] = STATE(7555),
    [sym_unboxed_unit] = STATE(7555),
    [sym_prefix_tuple] = STATE(7555),
    [sym_prefix_unboxed_tuple] = STATE(7555),
    [sym_prefix_unboxed_sum] = STATE(7555),
    [sym_literal] = STATE(7555),
    [sym__qualified_type] = STATE(7587),
    [sym__qtyconid] = STATE(7569),
    [sym__tycon_arrow] = STATE(7569),
    [sym__qtycon_arrow] = STATE(7569),
    [sym__promoted_tycons_alias] = STATE(7555),
    [sym__promoted_tycons] = STATE(7555),
    [sym__varsym_prefix] = STATE(7569),
    [sym__pvarsym] = STATE(7569),
    [sym__qvarsym_prefix] = STATE(7569),
    [sym__pqvarsym] = STATE(7569),
    [sym__consym_prefix] = STATE(7569),
    [sym__pconsym] = STATE(7569),
    [sym__qconsym_prefix] = STATE(7569),
    [sym__pqconsym] = STATE(7569),
    [sym__colon2] = STATE(1572),
    [sym__prefix_at] = STATE(2631),
    [sym__paren_open] = STATE(434),
    [sym__bracket_open] = STATE(963),
    [sym__unboxed_open] = STATE(763),
    [sym__where] = STATE(8883),
    [aux_sym_type_patterns_repeat1] = STATE(2203),
    [sym_variable] = ACTIONS(3203),
    [anon_sym__] = ACTIONS(3205),
    [anon_sym_SQUOTE] = ACTIONS(4140),
    [anon_sym_STAR] = ACTIONS(3211),
    [anon_sym_u2605] = ACTIONS(3211),
    [anon_sym_EQ] = ACTIONS(4142),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3213),
    [sym_char] = ACTIONS(3213),
    [sym_string] = ACTIONS(3213),
    [sym__integer_literal] = ACTIONS(3215),
    [sym__binary_literal] = ACTIONS(3217),
    [sym__octal_literal] = ACTIONS(3217),
    [sym__hex_literal] = ACTIONS(3217),
    [sym_name] = ACTIONS(4144),
    [anon_sym_COLON_COLON] = ACTIONS(4146),
    [anon_sym_u2237] = ACTIONS(4146),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(3565),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_where] = ACTIONS(3567),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3221),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2037] = {
    [sym_alternative] = STATE(9515),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5640),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(2178),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(4170),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4172),
    [sym__cond_layout_end] = ACTIONS(4174),
    [sym__cond_layout_end_explicit] = ACTIONS(4174),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2038] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10483),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(8069),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(4156),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2039] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9347),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(8069),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(4156),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2040] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(10269),
    [sym_bind] = STATE(10373),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(6696),
    [sym__pvarsym] = STATE(6696),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(4062),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4176),
    [sym__cond_layout_end_explicit] = ACTIONS(4176),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2041] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9203),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(8069),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(4156),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2042] = {
    [sym__type_parens] = STATE(7585),
    [sym__type_tuple] = STATE(7602),
    [sym__type_unboxed_tuple] = STATE(7615),
    [sym__type_unboxed_sum] = STATE(7591),
    [sym__type_list] = STATE(7589),
    [sym__type_promoted] = STATE(7555),
    [sym__type_star] = STATE(7555),
    [sym__type_wildcard] = STATE(7555),
    [sym__at_type] = STATE(8035),
    [sym__type_apply] = STATE(7581),
    [sym__type_infix] = STATE(7580),
    [sym_type] = STATE(1267),
    [sym_type_patterns] = STATE(8869),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10889),
    [sym__gadt] = STATE(9109),
    [sym__newtype] = STATE(10046),
    [sym__splice_dollars] = STATE(7479),
    [sym_splice] = STATE(7555),
    [sym_quasiquote] = STATE(7555),
    [sym_integer] = STATE(7595),
    [sym__plist] = STATE(7579),
    [sym_unit] = STATE(7555),
    [sym_unboxed_unit] = STATE(7555),
    [sym_prefix_tuple] = STATE(7555),
    [sym_prefix_unboxed_tuple] = STATE(7555),
    [sym_prefix_unboxed_sum] = STATE(7555),
    [sym_literal] = STATE(7555),
    [sym__qualified_type] = STATE(7587),
    [sym__qtyconid] = STATE(7569),
    [sym__tycon_arrow] = STATE(7569),
    [sym__qtycon_arrow] = STATE(7569),
    [sym__promoted_tycons_alias] = STATE(7555),
    [sym__promoted_tycons] = STATE(7555),
    [sym__varsym_prefix] = STATE(7569),
    [sym__pvarsym] = STATE(7569),
    [sym__qvarsym_prefix] = STATE(7569),
    [sym__pqvarsym] = STATE(7569),
    [sym__consym_prefix] = STATE(7569),
    [sym__pconsym] = STATE(7569),
    [sym__qconsym_prefix] = STATE(7569),
    [sym__pqconsym] = STATE(7569),
    [sym__colon2] = STATE(1572),
    [sym__prefix_at] = STATE(2631),
    [sym__paren_open] = STATE(434),
    [sym__bracket_open] = STATE(963),
    [sym__unboxed_open] = STATE(763),
    [sym__where] = STATE(8883),
    [aux_sym_type_patterns_repeat1] = STATE(2203),
    [sym_variable] = ACTIONS(3203),
    [anon_sym__] = ACTIONS(3205),
    [anon_sym_SQUOTE] = ACTIONS(4140),
    [anon_sym_STAR] = ACTIONS(3211),
    [anon_sym_u2605] = ACTIONS(3211),
    [anon_sym_EQ] = ACTIONS(4142),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3213),
    [sym_char] = ACTIONS(3213),
    [sym_string] = ACTIONS(3213),
    [sym__integer_literal] = ACTIONS(3215),
    [sym__binary_literal] = ACTIONS(3217),
    [sym__octal_literal] = ACTIONS(3217),
    [sym__hex_literal] = ACTIONS(3217),
    [sym_name] = ACTIONS(4144),
    [anon_sym_COLON_COLON] = ACTIONS(4146),
    [anon_sym_u2237] = ACTIONS(4146),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(3565),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_where] = ACTIONS(3567),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3221),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2043] = {
    [sym_alternative] = STATE(9446),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(2931),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(2183),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(4178),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4180),
    [sym__cond_layout_end] = ACTIONS(4182),
    [sym__cond_layout_end_explicit] = ACTIONS(4182),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2044] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(10261),
    [sym_bind] = STATE(10373),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(6696),
    [sym__pvarsym] = STATE(6696),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(4062),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4184),
    [sym__cond_layout_end_explicit] = ACTIONS(4184),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2045] = {
    [sym_alternative] = STATE(9146),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4996),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(2179),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(4186),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4188),
    [sym__cond_layout_end] = ACTIONS(4190),
    [sym__cond_layout_end_explicit] = ACTIONS(4190),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2046] = {
    [sym_alternative] = STATE(9309),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4393),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(2184),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(4192),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4194),
    [sym__cond_layout_end] = ACTIONS(4196),
    [sym__cond_layout_end_explicit] = ACTIONS(4196),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2047] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9349),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(8069),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(4156),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2048] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9148),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(8069),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(4156),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2049] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3012),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4198),
    [sym__cond_layout_end_explicit] = ACTIONS(4198),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2050] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4911),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4200),
    [sym__cond_layout_end_explicit] = ACTIONS(4200),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2051] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5153),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4202),
    [sym__cond_layout_end_explicit] = ACTIONS(4202),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2052] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3940),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4204),
    [sym__cond_layout_end_explicit] = ACTIONS(4204),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2053] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4644),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4206),
    [sym__cond_layout_end_explicit] = ACTIONS(4206),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2054] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4478),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4208),
    [sym__cond_layout_end_explicit] = ACTIONS(4208),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2055] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5224),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4210),
    [sym__cond_layout_end_explicit] = ACTIONS(4210),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2056] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4485),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4212),
    [sym__cond_layout_end_explicit] = ACTIONS(4212),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2057] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5346),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4214),
    [sym__cond_layout_end_explicit] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2058] = {
    [sym__at_type] = STATE(8026),
    [sym_explicit_type] = STATE(2085),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1859),
    [sym_patterns] = STATE(10990),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2509),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(39),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [aux_sym_patterns_repeat1] = STATE(2085),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_case] = ACTIONS(4216),
    [anon_sym_cases] = ACTIONS(4218),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2059] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4499),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4220),
    [sym__cond_layout_end_explicit] = ACTIONS(4220),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2060] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3016),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4222),
    [sym__cond_layout_end_explicit] = ACTIONS(4222),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2061] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5171),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4224),
    [sym__cond_layout_end_explicit] = ACTIONS(4224),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2062] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4634),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4226),
    [sym__cond_layout_end_explicit] = ACTIONS(4226),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2063] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5210),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4228),
    [sym__cond_layout_end_explicit] = ACTIONS(4228),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2064] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5176),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4230),
    [sym__cond_layout_end_explicit] = ACTIONS(4230),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2065] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5205),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4232),
    [sym__cond_layout_end_explicit] = ACTIONS(4232),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2066] = {
    [sym__at_type] = STATE(8026),
    [sym_explicit_type] = STATE(2085),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1859),
    [sym_patterns] = STATE(10928),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2509),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(39),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [aux_sym_patterns_repeat1] = STATE(2085),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_case] = ACTIONS(4234),
    [anon_sym_cases] = ACTIONS(4236),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2067] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3957),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4238),
    [sym__cond_layout_end_explicit] = ACTIONS(4238),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2068] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3972),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4240),
    [sym__cond_layout_end_explicit] = ACTIONS(4240),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2069] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5391),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4242),
    [sym__cond_layout_end_explicit] = ACTIONS(4242),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2070] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5611),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4244),
    [sym__cond_layout_end_explicit] = ACTIONS(4244),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2071] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4928),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4246),
    [sym__cond_layout_end_explicit] = ACTIONS(4246),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2072] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5657),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4248),
    [sym__cond_layout_end_explicit] = ACTIONS(4248),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2073] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5667),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4250),
    [sym__cond_layout_end_explicit] = ACTIONS(4250),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2074] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4914),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4252),
    [sym__cond_layout_end_explicit] = ACTIONS(4252),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2075] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4595),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4254),
    [sym__cond_layout_end_explicit] = ACTIONS(4254),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2076] = {
    [sym__at_type] = STATE(8026),
    [sym_explicit_type] = STATE(2085),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1859),
    [sym_patterns] = STATE(11248),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2509),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(39),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [aux_sym_patterns_repeat1] = STATE(2085),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_case] = ACTIONS(4256),
    [anon_sym_cases] = ACTIONS(4258),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2077] = {
    [sym__at_type] = STATE(8026),
    [sym_explicit_type] = STATE(2077),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1859),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2509),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(39),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [aux_sym_patterns_repeat1] = STATE(2077),
    [sym_variable] = ACTIONS(4260),
    [anon_sym__] = ACTIONS(4263),
    [anon_sym_DASH] = ACTIONS(4266),
    [anon_sym_DASH_GT] = ACTIONS(3975),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [sym_float] = ACTIONS(4269),
    [sym_char] = ACTIONS(4269),
    [sym_string] = ACTIONS(4269),
    [sym__integer_literal] = ACTIONS(4272),
    [sym__binary_literal] = ACTIONS(4275),
    [sym__octal_literal] = ACTIONS(4275),
    [sym__hex_literal] = ACTIONS(4275),
    [sym_name] = ACTIONS(4278),
    [anon_sym_u2192] = ACTIONS(3975),
    [aux_sym__paren_open_token1] = ACTIONS(3995),
    [aux_sym__paren_close_token1] = ACTIONS(3975),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4281),
    [sym__cond_splice] = ACTIONS(4001),
    [sym__cond_prefix_at] = ACTIONS(4004),
    [sym__cond_tight_bang] = ACTIONS(4007),
    [sym__cond_prefix_bang] = ACTIONS(4010),
    [sym__cond_tight_tilde] = ACTIONS(4013),
    [sym__cond_prefix_tilde] = ACTIONS(4016),
  },
  [2078] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5215),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4284),
    [sym__cond_layout_end_explicit] = ACTIONS(4284),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2079] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5624),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4286),
    [sym__cond_layout_end_explicit] = ACTIONS(4286),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2080] = {
    [sym__at_type] = STATE(8026),
    [sym_explicit_type] = STATE(2085),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1859),
    [sym_patterns] = STATE(10929),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2509),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(39),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [aux_sym_patterns_repeat1] = STATE(2085),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_case] = ACTIONS(4288),
    [anon_sym_cases] = ACTIONS(4290),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2081] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5394),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4292),
    [sym__cond_layout_end_explicit] = ACTIONS(4292),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2082] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4874),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4294),
    [sym__cond_layout_end_explicit] = ACTIONS(4294),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2083] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3037),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4296),
    [sym__cond_layout_end_explicit] = ACTIONS(4296),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2084] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5186),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4298),
    [sym__cond_layout_end_explicit] = ACTIONS(4298),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2085] = {
    [sym__at_type] = STATE(8026),
    [sym_explicit_type] = STATE(2077),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1859),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2509),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(39),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [aux_sym_patterns_repeat1] = STATE(2077),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_DASH_GT] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [anon_sym_u2192] = ACTIONS(4084),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(4084),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2086] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4687),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4300),
    [sym__cond_layout_end_explicit] = ACTIONS(4300),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2087] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3960),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4302),
    [sym__cond_layout_end_explicit] = ACTIONS(4302),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2088] = {
    [sym__at_type] = STATE(8026),
    [sym_explicit_type] = STATE(2085),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1859),
    [sym_patterns] = STATE(11255),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2509),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(39),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [aux_sym_patterns_repeat1] = STATE(2085),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_case] = ACTIONS(4304),
    [anon_sym_cases] = ACTIONS(4306),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2089] = {
    [sym__at_type] = STATE(8026),
    [sym_explicit_type] = STATE(2085),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1859),
    [sym_patterns] = STATE(12184),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2509),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(39),
    [sym__paren_close] = STATE(8095),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [aux_sym_patterns_repeat1] = STATE(2085),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(3503),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2090] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4835),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4308),
    [sym__cond_layout_end_explicit] = ACTIONS(4308),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2091] = {
    [sym__at_type] = STATE(8026),
    [sym_explicit_type] = STATE(2085),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1859),
    [sym_patterns] = STATE(11674),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2509),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(39),
    [sym__paren_close] = STATE(8080),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [aux_sym_patterns_repeat1] = STATE(2085),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__paren_close_token1] = ACTIONS(3503),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2092] = {
    [sym__at_type] = STATE(8026),
    [sym_explicit_type] = STATE(2085),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1859),
    [sym_patterns] = STATE(11313),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2509),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(39),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [aux_sym_patterns_repeat1] = STATE(2085),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_case] = ACTIONS(4310),
    [anon_sym_cases] = ACTIONS(4312),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2093] = {
    [sym__at_type] = STATE(8026),
    [sym_explicit_type] = STATE(2085),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1859),
    [sym_patterns] = STATE(11128),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2509),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(39),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [aux_sym_patterns_repeat1] = STATE(2085),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_case] = ACTIONS(4314),
    [anon_sym_cases] = ACTIONS(4316),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2094] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(2974),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4318),
    [sym__cond_layout_end_explicit] = ACTIONS(4318),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2095] = {
    [sym__at_type] = STATE(8026),
    [sym_explicit_type] = STATE(2085),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1859),
    [sym_patterns] = STATE(11086),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2509),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(39),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [aux_sym_patterns_repeat1] = STATE(2085),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_case] = ACTIONS(4320),
    [anon_sym_cases] = ACTIONS(4322),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2096] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4784),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4324),
    [sym__cond_layout_end_explicit] = ACTIONS(4324),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2097] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4778),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4326),
    [sym__cond_layout_end_explicit] = ACTIONS(4326),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2098] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4462),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4328),
    [sym__cond_layout_end_explicit] = ACTIONS(4328),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2099] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4798),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4330),
    [sym__cond_layout_end_explicit] = ACTIONS(4330),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2100] = {
    [sym__at_type] = STATE(8026),
    [sym_explicit_type] = STATE(2085),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1859),
    [sym_patterns] = STATE(11039),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2509),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(39),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [aux_sym_patterns_repeat1] = STATE(2085),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_case] = ACTIONS(4332),
    [anon_sym_cases] = ACTIONS(4334),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2101] = {
    [sym__at_type] = STATE(8026),
    [sym_explicit_type] = STATE(2085),
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1859),
    [sym_patterns] = STATE(11010),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_at] = STATE(2509),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(39),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [aux_sym_patterns_repeat1] = STATE(2085),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_case] = ACTIONS(4336),
    [anon_sym_cases] = ACTIONS(4338),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2102] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5412),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5679),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4340),
    [sym__cond_layout_end_explicit] = ACTIONS(4340),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2103] = {
    [sym__type_parens] = STATE(7142),
    [sym__type_tuple] = STATE(7143),
    [sym__type_unboxed_tuple] = STATE(7144),
    [sym__type_unboxed_sum] = STATE(7145),
    [sym__type_list] = STATE(7146),
    [sym__type_promoted] = STATE(7140),
    [sym__type_star] = STATE(7140),
    [sym__type_wildcard] = STATE(7140),
    [sym__type_apply] = STATE(7147),
    [sym__type_infix] = STATE(7148),
    [sym_type] = STATE(936),
    [sym_strict_field] = STATE(9123),
    [sym_lazy_field] = STATE(9123),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11165),
    [sym__splice_dollars] = STATE(7440),
    [sym_splice] = STATE(7140),
    [sym_quasiquote] = STATE(7140),
    [sym_integer] = STATE(7036),
    [sym__plist] = STATE(7149),
    [sym_unit] = STATE(7140),
    [sym_unboxed_unit] = STATE(7140),
    [sym_prefix_tuple] = STATE(7140),
    [sym_prefix_unboxed_tuple] = STATE(7140),
    [sym_prefix_unboxed_sum] = STATE(7140),
    [sym_literal] = STATE(7140),
    [sym__qualified_type] = STATE(7079),
    [sym__qtyconid] = STATE(7150),
    [sym__tycon_arrow] = STATE(7150),
    [sym__qtycon_arrow] = STATE(7150),
    [sym__promoted_tycons_alias] = STATE(7140),
    [sym__promoted_tycons] = STATE(7140),
    [sym__varsym_prefix] = STATE(7150),
    [sym__pvarsym] = STATE(7150),
    [sym__qvarsym_prefix] = STATE(7150),
    [sym__pqvarsym] = STATE(7150),
    [sym__consym_prefix] = STATE(7150),
    [sym__pconsym] = STATE(7150),
    [sym__qconsym_prefix] = STATE(7150),
    [sym__pqconsym] = STATE(7150),
    [sym__prefix_bang] = STATE(2683),
    [sym__tight_bang] = STATE(2683),
    [sym__any_prefix_bang] = STATE(2683),
    [sym__prefix_tilde] = STATE(2674),
    [sym__tight_tilde] = STATE(2674),
    [sym__any_prefix_tilde] = STATE(2674),
    [sym__paren_open] = STATE(450),
    [sym__bracket_open] = STATE(1027),
    [sym__unboxed_open] = STATE(831),
    [sym_variable] = ACTIONS(2757),
    [anon_sym__] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(4342),
    [anon_sym_STAR] = ACTIONS(2767),
    [anon_sym_u2605] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2771),
    [sym_char] = ACTIONS(2771),
    [sym_string] = ACTIONS(2771),
    [sym__integer_literal] = ACTIONS(2773),
    [sym__binary_literal] = ACTIONS(2775),
    [sym__octal_literal] = ACTIONS(2775),
    [sym__hex_literal] = ACTIONS(2775),
    [sym_name] = ACTIONS(4344),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2779),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
  },
  [2104] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(10385),
    [sym_bind] = STATE(10373),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(6696),
    [sym__pvarsym] = STATE(6696),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(4062),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4154),
    [sym__cond_layout_end_explicit] = ACTIONS(4154),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2105] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(10261),
    [sym_bind] = STATE(10373),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(6696),
    [sym__pvarsym] = STATE(6696),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(4062),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4184),
    [sym__cond_layout_end_explicit] = ACTIONS(4184),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2106] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9366),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2107] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9199),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2108] = {
    [sym__type_parens] = STATE(7142),
    [sym__type_tuple] = STATE(7143),
    [sym__type_unboxed_tuple] = STATE(7144),
    [sym__type_unboxed_sum] = STATE(7145),
    [sym__type_list] = STATE(7146),
    [sym__type_promoted] = STATE(7140),
    [sym__type_star] = STATE(7140),
    [sym__type_wildcard] = STATE(7140),
    [sym__type_apply] = STATE(7147),
    [sym__type_infix] = STATE(7148),
    [sym_type] = STATE(937),
    [sym_strict_field] = STATE(9123),
    [sym_lazy_field] = STATE(9123),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11165),
    [sym__splice_dollars] = STATE(7440),
    [sym_splice] = STATE(7140),
    [sym_quasiquote] = STATE(7140),
    [sym_integer] = STATE(7036),
    [sym__plist] = STATE(7149),
    [sym_unit] = STATE(7140),
    [sym_unboxed_unit] = STATE(7140),
    [sym_prefix_tuple] = STATE(7140),
    [sym_prefix_unboxed_tuple] = STATE(7140),
    [sym_prefix_unboxed_sum] = STATE(7140),
    [sym_literal] = STATE(7140),
    [sym__qualified_type] = STATE(7079),
    [sym__qtyconid] = STATE(7150),
    [sym__tycon_arrow] = STATE(7150),
    [sym__qtycon_arrow] = STATE(7150),
    [sym__promoted_tycons_alias] = STATE(7140),
    [sym__promoted_tycons] = STATE(7140),
    [sym__varsym_prefix] = STATE(7150),
    [sym__pvarsym] = STATE(7150),
    [sym__qvarsym_prefix] = STATE(7150),
    [sym__pqvarsym] = STATE(7150),
    [sym__consym_prefix] = STATE(7150),
    [sym__pconsym] = STATE(7150),
    [sym__qconsym_prefix] = STATE(7150),
    [sym__pqconsym] = STATE(7150),
    [sym__prefix_bang] = STATE(2683),
    [sym__tight_bang] = STATE(2683),
    [sym__any_prefix_bang] = STATE(2683),
    [sym__prefix_tilde] = STATE(2674),
    [sym__tight_tilde] = STATE(2674),
    [sym__any_prefix_tilde] = STATE(2674),
    [sym__paren_open] = STATE(450),
    [sym__bracket_open] = STATE(1027),
    [sym__unboxed_open] = STATE(831),
    [sym_variable] = ACTIONS(2757),
    [anon_sym__] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(4342),
    [anon_sym_STAR] = ACTIONS(2767),
    [anon_sym_u2605] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2771),
    [sym_char] = ACTIONS(2771),
    [sym_string] = ACTIONS(2771),
    [sym__integer_literal] = ACTIONS(2773),
    [sym__binary_literal] = ACTIONS(2775),
    [sym__octal_literal] = ACTIONS(2775),
    [sym__hex_literal] = ACTIONS(2775),
    [sym_name] = ACTIONS(4344),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2779),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
  },
  [2109] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9194),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2110] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9207),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2111] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(10268),
    [sym_bind] = STATE(10373),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(6696),
    [sym__pvarsym] = STATE(6696),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(4062),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4120),
    [sym__cond_layout_end_explicit] = ACTIONS(4120),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2112] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9343),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2113] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9530),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2114] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9141),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2115] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(10269),
    [sym_bind] = STATE(10373),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(6696),
    [sym__pvarsym] = STATE(6696),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(4062),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4176),
    [sym__cond_layout_end_explicit] = ACTIONS(4176),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2116] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9503),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2117] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9272),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2118] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1806),
    [sym_strict_field] = STATE(9953),
    [sym_lazy_field] = STATE(9953),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11043),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_bang] = STATE(2566),
    [sym__tight_bang] = STATE(2566),
    [sym__any_prefix_bang] = STATE(2566),
    [sym__prefix_tilde] = STATE(2565),
    [sym__tight_tilde] = STATE(2565),
    [sym__any_prefix_tilde] = STATE(2565),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(4346),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [sym_name] = ACTIONS(4348),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(1399),
    [sym__cond_prefix_bang] = ACTIONS(1401),
    [sym__cond_tight_tilde] = ACTIONS(1403),
    [sym__cond_prefix_tilde] = ACTIONS(1405),
  },
  [2119] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(10477),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2120] = {
    [sym__at_type] = STATE(7955),
    [sym__nalt] = STATE(9332),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8735),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2121] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(2977),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4350),
    [sym__cond_layout_end_explicit] = ACTIONS(4350),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2122] = {
    [sym__type_parens] = STATE(7268),
    [sym__type_tuple] = STATE(7262),
    [sym__type_unboxed_tuple] = STATE(7258),
    [sym__type_unboxed_sum] = STATE(7246),
    [sym__type_list] = STATE(7247),
    [sym__type_promoted] = STATE(7269),
    [sym__type_star] = STATE(7269),
    [sym__type_wildcard] = STATE(7269),
    [sym__at_type] = STATE(7888),
    [sym__type_apply] = STATE(7237),
    [sym__type_infix] = STATE(7207),
    [sym_type] = STATE(1054),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11301),
    [sym_via] = STATE(9558),
    [sym__splice_dollars] = STATE(7208),
    [sym_splice] = STATE(7269),
    [sym_quasiquote] = STATE(7269),
    [sym_integer] = STATE(7206),
    [sym__plist] = STATE(7209),
    [sym_unit] = STATE(7269),
    [sym_unboxed_unit] = STATE(7269),
    [sym_prefix_tuple] = STATE(7269),
    [sym_prefix_unboxed_tuple] = STATE(7269),
    [sym_prefix_unboxed_sum] = STATE(7269),
    [sym_literal] = STATE(7269),
    [sym__qualified_type] = STATE(7374),
    [sym__qtyconid] = STATE(7210),
    [sym__tycon_arrow] = STATE(7210),
    [sym__qtycon_arrow] = STATE(7210),
    [sym__promoted_tycons_alias] = STATE(7269),
    [sym__promoted_tycons] = STATE(7269),
    [sym__varsym_prefix] = STATE(7210),
    [sym__pvarsym] = STATE(7210),
    [sym__qvarsym_prefix] = STATE(7210),
    [sym__pqvarsym] = STATE(7210),
    [sym__consym_prefix] = STATE(7210),
    [sym__pconsym] = STATE(7210),
    [sym__qconsym_prefix] = STATE(7210),
    [sym__pqconsym] = STATE(7210),
    [sym__prefix_at] = STATE(2498),
    [sym__paren_open] = STATE(448),
    [sym__bracket_open] = STATE(1009),
    [sym__unboxed_open] = STATE(824),
    [sym_variable] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(4352),
    [anon_sym__] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(4354),
    [anon_sym_STAR] = ACTIONS(2953),
    [anon_sym_u2605] = ACTIONS(2953),
    [anon_sym_via] = ACTIONS(4356),
    [anon_sym_deriving] = ACTIONS(4358),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2955),
    [sym_char] = ACTIONS(2955),
    [sym_string] = ACTIONS(2955),
    [sym__integer_literal] = ACTIONS(2957),
    [sym__binary_literal] = ACTIONS(2959),
    [sym__octal_literal] = ACTIONS(2959),
    [sym__hex_literal] = ACTIONS(2959),
    [sym_name] = ACTIONS(4360),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4352),
    [sym__cond_layout_end] = ACTIONS(4352),
    [sym__cond_layout_end_explicit] = ACTIONS(4352),
    [sym__phantom_deriving] = ACTIONS(4352),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2963),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2123] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4644),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4206),
    [sym__cond_layout_end_explicit] = ACTIONS(4206),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2124] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4687),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4300),
    [sym__cond_layout_end_explicit] = ACTIONS(4300),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2125] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5393),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4362),
    [sym__cond_layout_end_explicit] = ACTIONS(4362),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2126] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5224),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4210),
    [sym__cond_layout_end_explicit] = ACTIONS(4210),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2127] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4499),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4220),
    [sym__cond_layout_end_explicit] = ACTIONS(4220),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2128] = {
    [sym__at_type] = STATE(7955),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8938),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2129] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5187),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4364),
    [sym__cond_layout_end_explicit] = ACTIONS(4364),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2130] = {
    [sym__at_type] = STATE(7955),
    [sym_explicit_type] = STATE(2002),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1834),
    [sym_patterns] = STATE(8950),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_at] = STATE(2456),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(43),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym_patterns_repeat1] = STATE(2002),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2131] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5207),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4366),
    [sym__cond_layout_end_explicit] = ACTIONS(4366),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2132] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3960),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4302),
    [sym__cond_layout_end_explicit] = ACTIONS(4302),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2133] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4875),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4368),
    [sym__cond_layout_end_explicit] = ACTIONS(4368),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2134] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3037),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4296),
    [sym__cond_layout_end_explicit] = ACTIONS(4296),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2135] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4912),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4370),
    [sym__cond_layout_end_explicit] = ACTIONS(4370),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2136] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3972),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4240),
    [sym__cond_layout_end_explicit] = ACTIONS(4240),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2137] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym_bind] = STATE(10373),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(6696),
    [sym__pvarsym] = STATE(6696),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(4062),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2138] = {
    [sym__type_parens] = STATE(7268),
    [sym__type_tuple] = STATE(7262),
    [sym__type_unboxed_tuple] = STATE(7258),
    [sym__type_unboxed_sum] = STATE(7246),
    [sym__type_list] = STATE(7247),
    [sym__type_promoted] = STATE(7269),
    [sym__type_star] = STATE(7269),
    [sym__type_wildcard] = STATE(7269),
    [sym__at_type] = STATE(7888),
    [sym__type_apply] = STATE(7237),
    [sym__type_infix] = STATE(7207),
    [sym_type] = STATE(1054),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11301),
    [sym_via] = STATE(9647),
    [sym__splice_dollars] = STATE(7208),
    [sym_splice] = STATE(7269),
    [sym_quasiquote] = STATE(7269),
    [sym_integer] = STATE(7206),
    [sym__plist] = STATE(7209),
    [sym_unit] = STATE(7269),
    [sym_unboxed_unit] = STATE(7269),
    [sym_prefix_tuple] = STATE(7269),
    [sym_prefix_unboxed_tuple] = STATE(7269),
    [sym_prefix_unboxed_sum] = STATE(7269),
    [sym_literal] = STATE(7269),
    [sym__qualified_type] = STATE(7374),
    [sym__qtyconid] = STATE(7210),
    [sym__tycon_arrow] = STATE(7210),
    [sym__qtycon_arrow] = STATE(7210),
    [sym__promoted_tycons_alias] = STATE(7269),
    [sym__promoted_tycons] = STATE(7269),
    [sym__varsym_prefix] = STATE(7210),
    [sym__pvarsym] = STATE(7210),
    [sym__qvarsym_prefix] = STATE(7210),
    [sym__pqvarsym] = STATE(7210),
    [sym__consym_prefix] = STATE(7210),
    [sym__pconsym] = STATE(7210),
    [sym__qconsym_prefix] = STATE(7210),
    [sym__pqconsym] = STATE(7210),
    [sym__prefix_at] = STATE(2498),
    [sym__paren_open] = STATE(448),
    [sym__bracket_open] = STATE(1009),
    [sym__unboxed_open] = STATE(824),
    [sym_variable] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(4372),
    [anon_sym__] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(4354),
    [anon_sym_STAR] = ACTIONS(2953),
    [anon_sym_u2605] = ACTIONS(2953),
    [anon_sym_via] = ACTIONS(4356),
    [anon_sym_deriving] = ACTIONS(4374),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2955),
    [sym_char] = ACTIONS(2955),
    [sym_string] = ACTIONS(2955),
    [sym__integer_literal] = ACTIONS(2957),
    [sym__binary_literal] = ACTIONS(2959),
    [sym__octal_literal] = ACTIONS(2959),
    [sym__hex_literal] = ACTIONS(2959),
    [sym_name] = ACTIONS(4360),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4372),
    [sym__cond_layout_end] = ACTIONS(4372),
    [sym__cond_layout_end_explicit] = ACTIONS(4372),
    [sym__phantom_deriving] = ACTIONS(4372),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2963),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2139] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5215),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4284),
    [sym__cond_layout_end_explicit] = ACTIONS(4284),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2140] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4914),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4252),
    [sym__cond_layout_end_explicit] = ACTIONS(4252),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2141] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4485),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4212),
    [sym__cond_layout_end_explicit] = ACTIONS(4212),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2142] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5176),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4230),
    [sym__cond_layout_end_explicit] = ACTIONS(4230),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2143] = {
    [sym__type_parens] = STATE(7505),
    [sym__type_tuple] = STATE(7503),
    [sym__type_unboxed_tuple] = STATE(7497),
    [sym__type_unboxed_sum] = STATE(7492),
    [sym__type_list] = STATE(7528),
    [sym__type_promoted] = STATE(7491),
    [sym__type_star] = STATE(7491),
    [sym__type_wildcard] = STATE(7491),
    [sym__at_type] = STATE(7994),
    [sym__type_apply] = STATE(7550),
    [sym__type_infix] = STATE(7534),
    [sym_type] = STATE(1137),
    [sym_type_patterns] = STATE(9622),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11252),
    [sym__splice_dollars] = STATE(7345),
    [sym_splice] = STATE(7491),
    [sym_quasiquote] = STATE(7491),
    [sym_integer] = STATE(7542),
    [sym__plist] = STATE(7518),
    [sym_unit] = STATE(7491),
    [sym_unboxed_unit] = STATE(7491),
    [sym_prefix_tuple] = STATE(7491),
    [sym_prefix_unboxed_tuple] = STATE(7491),
    [sym_prefix_unboxed_sum] = STATE(7491),
    [sym_literal] = STATE(7491),
    [sym__qualified_type] = STATE(7541),
    [sym__qtyconid] = STATE(7511),
    [sym__tycon_arrow] = STATE(7511),
    [sym__qtycon_arrow] = STATE(7511),
    [sym__promoted_tycons_alias] = STATE(7491),
    [sym__promoted_tycons] = STATE(7491),
    [sym__varsym_prefix] = STATE(7511),
    [sym__pvarsym] = STATE(7511),
    [sym__qvarsym_prefix] = STATE(7511),
    [sym__pqvarsym] = STATE(7511),
    [sym__consym_prefix] = STATE(7511),
    [sym__pconsym] = STATE(7511),
    [sym__qconsym_prefix] = STATE(7511),
    [sym__pqconsym] = STATE(7511),
    [sym__prefix_at] = STATE(2667),
    [sym__paren_open] = STATE(455),
    [sym__bracket_open] = STATE(1090),
    [sym__unboxed_open] = STATE(770),
    [aux_sym_type_patterns_repeat1] = STATE(2181),
    [sym_variable] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(4376),
    [anon_sym__] = ACTIONS(3109),
    [anon_sym_SQUOTE] = ACTIONS(4378),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_u2605] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3117),
    [sym_char] = ACTIONS(3117),
    [sym_string] = ACTIONS(3117),
    [sym__integer_literal] = ACTIONS(3119),
    [sym__binary_literal] = ACTIONS(3121),
    [sym__octal_literal] = ACTIONS(3121),
    [sym__hex_literal] = ACTIONS(3121),
    [sym_name] = ACTIONS(4380),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(4382),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4376),
    [sym__cond_layout_end] = ACTIONS(4376),
    [sym__cond_layout_end_explicit] = ACTIONS(4376),
    [sym__phantom_where] = ACTIONS(4376),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3125),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2144] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4638),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4384),
    [sym__cond_layout_end_explicit] = ACTIONS(4384),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2145] = {
    [sym__type_parens] = STATE(7505),
    [sym__type_tuple] = STATE(7503),
    [sym__type_unboxed_tuple] = STATE(7497),
    [sym__type_unboxed_sum] = STATE(7492),
    [sym__type_list] = STATE(7528),
    [sym__type_promoted] = STATE(7491),
    [sym__type_star] = STATE(7491),
    [sym__type_wildcard] = STATE(7491),
    [sym__at_type] = STATE(7994),
    [sym__type_apply] = STATE(7550),
    [sym__type_infix] = STATE(7534),
    [sym_type] = STATE(1137),
    [sym_type_patterns] = STATE(9619),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11252),
    [sym__splice_dollars] = STATE(7345),
    [sym_splice] = STATE(7491),
    [sym_quasiquote] = STATE(7491),
    [sym_integer] = STATE(7542),
    [sym__plist] = STATE(7518),
    [sym_unit] = STATE(7491),
    [sym_unboxed_unit] = STATE(7491),
    [sym_prefix_tuple] = STATE(7491),
    [sym_prefix_unboxed_tuple] = STATE(7491),
    [sym_prefix_unboxed_sum] = STATE(7491),
    [sym_literal] = STATE(7491),
    [sym__qualified_type] = STATE(7541),
    [sym__qtyconid] = STATE(7511),
    [sym__tycon_arrow] = STATE(7511),
    [sym__qtycon_arrow] = STATE(7511),
    [sym__promoted_tycons_alias] = STATE(7491),
    [sym__promoted_tycons] = STATE(7491),
    [sym__varsym_prefix] = STATE(7511),
    [sym__pvarsym] = STATE(7511),
    [sym__qvarsym_prefix] = STATE(7511),
    [sym__pqvarsym] = STATE(7511),
    [sym__consym_prefix] = STATE(7511),
    [sym__pconsym] = STATE(7511),
    [sym__qconsym_prefix] = STATE(7511),
    [sym__pqconsym] = STATE(7511),
    [sym__prefix_at] = STATE(2667),
    [sym__paren_open] = STATE(455),
    [sym__bracket_open] = STATE(1090),
    [sym__unboxed_open] = STATE(770),
    [aux_sym_type_patterns_repeat1] = STATE(2181),
    [sym_variable] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(4386),
    [anon_sym__] = ACTIONS(3109),
    [anon_sym_SQUOTE] = ACTIONS(4378),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_u2605] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3117),
    [sym_char] = ACTIONS(3117),
    [sym_string] = ACTIONS(3117),
    [sym__integer_literal] = ACTIONS(3119),
    [sym__binary_literal] = ACTIONS(3121),
    [sym__octal_literal] = ACTIONS(3121),
    [sym__hex_literal] = ACTIONS(3121),
    [sym_name] = ACTIONS(4380),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(4388),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4386),
    [sym__cond_layout_end] = ACTIONS(4386),
    [sym__cond_layout_end_explicit] = ACTIONS(4386),
    [sym__phantom_where] = ACTIONS(4386),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3125),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2146] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym_bind] = STATE(9147),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(6696),
    [sym__pvarsym] = STATE(6696),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(4062),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2147] = {
    [sym__type_parens] = STATE(7505),
    [sym__type_tuple] = STATE(7503),
    [sym__type_unboxed_tuple] = STATE(7497),
    [sym__type_unboxed_sum] = STATE(7492),
    [sym__type_list] = STATE(7528),
    [sym__type_promoted] = STATE(7491),
    [sym__type_star] = STATE(7491),
    [sym__type_wildcard] = STATE(7491),
    [sym__at_type] = STATE(7994),
    [sym__type_apply] = STATE(7550),
    [sym__type_infix] = STATE(7534),
    [sym_type] = STATE(1137),
    [sym_type_patterns] = STATE(9682),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11252),
    [sym__splice_dollars] = STATE(7345),
    [sym_splice] = STATE(7491),
    [sym_quasiquote] = STATE(7491),
    [sym_integer] = STATE(7542),
    [sym__plist] = STATE(7518),
    [sym_unit] = STATE(7491),
    [sym_unboxed_unit] = STATE(7491),
    [sym_prefix_tuple] = STATE(7491),
    [sym_prefix_unboxed_tuple] = STATE(7491),
    [sym_prefix_unboxed_sum] = STATE(7491),
    [sym_literal] = STATE(7491),
    [sym__qualified_type] = STATE(7541),
    [sym__qtyconid] = STATE(7511),
    [sym__tycon_arrow] = STATE(7511),
    [sym__qtycon_arrow] = STATE(7511),
    [sym__promoted_tycons_alias] = STATE(7491),
    [sym__promoted_tycons] = STATE(7491),
    [sym__varsym_prefix] = STATE(7511),
    [sym__pvarsym] = STATE(7511),
    [sym__qvarsym_prefix] = STATE(7511),
    [sym__pqvarsym] = STATE(7511),
    [sym__consym_prefix] = STATE(7511),
    [sym__pconsym] = STATE(7511),
    [sym__qconsym_prefix] = STATE(7511),
    [sym__pqconsym] = STATE(7511),
    [sym__prefix_at] = STATE(2667),
    [sym__paren_open] = STATE(455),
    [sym__bracket_open] = STATE(1090),
    [sym__unboxed_open] = STATE(770),
    [aux_sym_type_patterns_repeat1] = STATE(2181),
    [sym_variable] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(4390),
    [anon_sym__] = ACTIONS(3109),
    [anon_sym_SQUOTE] = ACTIONS(4378),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_u2605] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3117),
    [sym_char] = ACTIONS(3117),
    [sym_string] = ACTIONS(3117),
    [sym__integer_literal] = ACTIONS(3119),
    [sym__binary_literal] = ACTIONS(3121),
    [sym__octal_literal] = ACTIONS(3121),
    [sym__hex_literal] = ACTIONS(3121),
    [sym_name] = ACTIONS(4380),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(4392),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4390),
    [sym__cond_layout_end] = ACTIONS(4390),
    [sym__cond_layout_end_explicit] = ACTIONS(4390),
    [sym__phantom_where] = ACTIONS(4390),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3125),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2148] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5154),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4394),
    [sym__cond_layout_end_explicit] = ACTIONS(4394),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2149] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3013),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4396),
    [sym__cond_layout_end_explicit] = ACTIONS(4396),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2150] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5172),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4398),
    [sym__cond_layout_end_explicit] = ACTIONS(4398),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2151] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3016),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4222),
    [sym__cond_layout_end_explicit] = ACTIONS(4222),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2152] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5619),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4400),
    [sym__cond_layout_end_explicit] = ACTIONS(4400),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2153] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5391),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4242),
    [sym__cond_layout_end_explicit] = ACTIONS(4242),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2154] = {
    [sym__type_parens] = STATE(7268),
    [sym__type_tuple] = STATE(7262),
    [sym__type_unboxed_tuple] = STATE(7258),
    [sym__type_unboxed_sum] = STATE(7246),
    [sym__type_list] = STATE(7247),
    [sym__type_promoted] = STATE(7269),
    [sym__type_star] = STATE(7269),
    [sym__type_wildcard] = STATE(7269),
    [sym__at_type] = STATE(7888),
    [sym__type_apply] = STATE(7237),
    [sym__type_infix] = STATE(7207),
    [sym_type] = STATE(1054),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11301),
    [sym_via] = STATE(9578),
    [sym__splice_dollars] = STATE(7208),
    [sym_splice] = STATE(7269),
    [sym_quasiquote] = STATE(7269),
    [sym_integer] = STATE(7206),
    [sym__plist] = STATE(7209),
    [sym_unit] = STATE(7269),
    [sym_unboxed_unit] = STATE(7269),
    [sym_prefix_tuple] = STATE(7269),
    [sym_prefix_unboxed_tuple] = STATE(7269),
    [sym_prefix_unboxed_sum] = STATE(7269),
    [sym_literal] = STATE(7269),
    [sym__qualified_type] = STATE(7374),
    [sym__qtyconid] = STATE(7210),
    [sym__tycon_arrow] = STATE(7210),
    [sym__qtycon_arrow] = STATE(7210),
    [sym__promoted_tycons_alias] = STATE(7269),
    [sym__promoted_tycons] = STATE(7269),
    [sym__varsym_prefix] = STATE(7210),
    [sym__pvarsym] = STATE(7210),
    [sym__qvarsym_prefix] = STATE(7210),
    [sym__pqvarsym] = STATE(7210),
    [sym__consym_prefix] = STATE(7210),
    [sym__pconsym] = STATE(7210),
    [sym__qconsym_prefix] = STATE(7210),
    [sym__pqconsym] = STATE(7210),
    [sym__prefix_at] = STATE(2498),
    [sym__paren_open] = STATE(448),
    [sym__bracket_open] = STATE(1009),
    [sym__unboxed_open] = STATE(824),
    [sym_variable] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(4402),
    [anon_sym__] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(4354),
    [anon_sym_STAR] = ACTIONS(2953),
    [anon_sym_u2605] = ACTIONS(2953),
    [anon_sym_via] = ACTIONS(4356),
    [anon_sym_deriving] = ACTIONS(4404),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2955),
    [sym_char] = ACTIONS(2955),
    [sym_string] = ACTIONS(2955),
    [sym__integer_literal] = ACTIONS(2957),
    [sym__binary_literal] = ACTIONS(2959),
    [sym__octal_literal] = ACTIONS(2959),
    [sym__hex_literal] = ACTIONS(2959),
    [sym_name] = ACTIONS(4360),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4402),
    [sym__cond_layout_end] = ACTIONS(4402),
    [sym__cond_layout_end_explicit] = ACTIONS(4402),
    [sym__phantom_deriving] = ACTIONS(4402),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2963),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2155] = {
    [sym__type_parens] = STATE(7268),
    [sym__type_tuple] = STATE(7262),
    [sym__type_unboxed_tuple] = STATE(7258),
    [sym__type_unboxed_sum] = STATE(7246),
    [sym__type_list] = STATE(7247),
    [sym__type_promoted] = STATE(7269),
    [sym__type_star] = STATE(7269),
    [sym__type_wildcard] = STATE(7269),
    [sym__at_type] = STATE(7888),
    [sym__type_apply] = STATE(7237),
    [sym__type_infix] = STATE(7207),
    [sym_type] = STATE(1054),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11301),
    [sym_via] = STATE(9684),
    [sym__splice_dollars] = STATE(7208),
    [sym_splice] = STATE(7269),
    [sym_quasiquote] = STATE(7269),
    [sym_integer] = STATE(7206),
    [sym__plist] = STATE(7209),
    [sym_unit] = STATE(7269),
    [sym_unboxed_unit] = STATE(7269),
    [sym_prefix_tuple] = STATE(7269),
    [sym_prefix_unboxed_tuple] = STATE(7269),
    [sym_prefix_unboxed_sum] = STATE(7269),
    [sym_literal] = STATE(7269),
    [sym__qualified_type] = STATE(7374),
    [sym__qtyconid] = STATE(7210),
    [sym__tycon_arrow] = STATE(7210),
    [sym__qtycon_arrow] = STATE(7210),
    [sym__promoted_tycons_alias] = STATE(7269),
    [sym__promoted_tycons] = STATE(7269),
    [sym__varsym_prefix] = STATE(7210),
    [sym__pvarsym] = STATE(7210),
    [sym__qvarsym_prefix] = STATE(7210),
    [sym__pqvarsym] = STATE(7210),
    [sym__consym_prefix] = STATE(7210),
    [sym__pconsym] = STATE(7210),
    [sym__qconsym_prefix] = STATE(7210),
    [sym__pqconsym] = STATE(7210),
    [sym__prefix_at] = STATE(2498),
    [sym__paren_open] = STATE(448),
    [sym__bracket_open] = STATE(1009),
    [sym__unboxed_open] = STATE(824),
    [sym_variable] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(4406),
    [anon_sym__] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(4354),
    [anon_sym_STAR] = ACTIONS(2953),
    [anon_sym_u2605] = ACTIONS(2953),
    [anon_sym_via] = ACTIONS(4356),
    [anon_sym_deriving] = ACTIONS(4408),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2955),
    [sym_char] = ACTIONS(2955),
    [sym_string] = ACTIONS(2955),
    [sym__integer_literal] = ACTIONS(2957),
    [sym__binary_literal] = ACTIONS(2959),
    [sym__octal_literal] = ACTIONS(2959),
    [sym__hex_literal] = ACTIONS(2959),
    [sym_name] = ACTIONS(4360),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4406),
    [sym__cond_layout_end] = ACTIONS(4406),
    [sym__cond_layout_end_explicit] = ACTIONS(4406),
    [sym__phantom_deriving] = ACTIONS(4406),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2963),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2156] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3958),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4410),
    [sym__cond_layout_end_explicit] = ACTIONS(4410),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2157] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4596),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4412),
    [sym__cond_layout_end_explicit] = ACTIONS(4412),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2158] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(3941),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4414),
    [sym__cond_layout_end_explicit] = ACTIONS(4414),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2159] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5346),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4214),
    [sym__cond_layout_end_explicit] = ACTIONS(4214),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2160] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5611),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4244),
    [sym__cond_layout_end_explicit] = ACTIONS(4244),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2161] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5657),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4248),
    [sym__cond_layout_end_explicit] = ACTIONS(4248),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2162] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5411),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4416),
    [sym__cond_layout_end_explicit] = ACTIONS(4416),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2163] = {
    [sym__type_parens] = STATE(7505),
    [sym__type_tuple] = STATE(7503),
    [sym__type_unboxed_tuple] = STATE(7497),
    [sym__type_unboxed_sum] = STATE(7492),
    [sym__type_list] = STATE(7528),
    [sym__type_promoted] = STATE(7491),
    [sym__type_star] = STATE(7491),
    [sym__type_wildcard] = STATE(7491),
    [sym__at_type] = STATE(7994),
    [sym__type_apply] = STATE(7550),
    [sym__type_infix] = STATE(7534),
    [sym_type] = STATE(1137),
    [sym_type_patterns] = STATE(9574),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11252),
    [sym__splice_dollars] = STATE(7345),
    [sym_splice] = STATE(7491),
    [sym_quasiquote] = STATE(7491),
    [sym_integer] = STATE(7542),
    [sym__plist] = STATE(7518),
    [sym_unit] = STATE(7491),
    [sym_unboxed_unit] = STATE(7491),
    [sym_prefix_tuple] = STATE(7491),
    [sym_prefix_unboxed_tuple] = STATE(7491),
    [sym_prefix_unboxed_sum] = STATE(7491),
    [sym_literal] = STATE(7491),
    [sym__qualified_type] = STATE(7541),
    [sym__qtyconid] = STATE(7511),
    [sym__tycon_arrow] = STATE(7511),
    [sym__qtycon_arrow] = STATE(7511),
    [sym__promoted_tycons_alias] = STATE(7491),
    [sym__promoted_tycons] = STATE(7491),
    [sym__varsym_prefix] = STATE(7511),
    [sym__pvarsym] = STATE(7511),
    [sym__qvarsym_prefix] = STATE(7511),
    [sym__pqvarsym] = STATE(7511),
    [sym__consym_prefix] = STATE(7511),
    [sym__pconsym] = STATE(7511),
    [sym__qconsym_prefix] = STATE(7511),
    [sym__pqconsym] = STATE(7511),
    [sym__prefix_at] = STATE(2667),
    [sym__paren_open] = STATE(455),
    [sym__bracket_open] = STATE(1090),
    [sym__unboxed_open] = STATE(770),
    [aux_sym_type_patterns_repeat1] = STATE(2181),
    [sym_variable] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(4418),
    [anon_sym__] = ACTIONS(3109),
    [anon_sym_SQUOTE] = ACTIONS(4378),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_u2605] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3117),
    [sym_char] = ACTIONS(3117),
    [sym_string] = ACTIONS(3117),
    [sym__integer_literal] = ACTIONS(3119),
    [sym__binary_literal] = ACTIONS(3121),
    [sym__octal_literal] = ACTIONS(3121),
    [sym__hex_literal] = ACTIONS(3121),
    [sym_name] = ACTIONS(4380),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(4420),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4418),
    [sym__cond_layout_end] = ACTIONS(4418),
    [sym__cond_layout_end_explicit] = ACTIONS(4418),
    [sym__phantom_where] = ACTIONS(4418),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3125),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2164] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5661),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4422),
    [sym__cond_layout_end_explicit] = ACTIONS(4422),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2165] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(5210),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4228),
    [sym__cond_layout_end_explicit] = ACTIONS(4228),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2166] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4463),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4424),
    [sym__cond_layout_end_explicit] = ACTIONS(4424),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2167] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4483),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4426),
    [sym__cond_layout_end_explicit] = ACTIONS(4426),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2168] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4798),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4330),
    [sym__cond_layout_end_explicit] = ACTIONS(4330),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2169] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4928),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4246),
    [sym__cond_layout_end_explicit] = ACTIONS(4246),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2170] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4778),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4326),
    [sym__cond_layout_end_explicit] = ACTIONS(4326),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2171] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4783),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4428),
    [sym__cond_layout_end_explicit] = ACTIONS(4428),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2172] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__layout_end] = STATE(4836),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_end] = ACTIONS(4430),
    [sym__cond_layout_end_explicit] = ACTIONS(4430),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2173] = {
    [sym_alternative] = STATE(9241),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2174] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(8047),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1371),
    [sym_type_patterns] = STATE(9871),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11043),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__colon2] = STATE(1451),
    [sym__prefix_at] = STATE(2497),
    [sym__paren_open] = STATE(439),
    [sym__paren_close] = STATE(8065),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [aux_sym_type_patterns_repeat1] = STATE(2221),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(4346),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [sym_name] = ACTIONS(4348),
    [anon_sym_COLON_COLON] = ACTIONS(4432),
    [anon_sym_u2237] = ACTIONS(4432),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(4434),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2175] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(8047),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1371),
    [sym_type_patterns] = STATE(9919),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11043),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__colon2] = STATE(1441),
    [sym__prefix_at] = STATE(2497),
    [sym__paren_open] = STATE(439),
    [sym__paren_close] = STATE(7649),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [aux_sym_type_patterns_repeat1] = STATE(2221),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(4346),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [sym_name] = ACTIONS(4348),
    [anon_sym_COLON_COLON] = ACTIONS(4436),
    [anon_sym_u2237] = ACTIONS(4436),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(4438),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2176] = {
    [sym_alternative] = STATE(9377),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2177] = {
    [sym_alternative] = STATE(9215),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2178] = {
    [sym_alternative] = STATE(9539),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2179] = {
    [sym_alternative] = STATE(9179),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2180] = {
    [sym_alternative] = STATE(9344),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2181] = {
    [sym__type_parens] = STATE(7505),
    [sym__type_tuple] = STATE(7503),
    [sym__type_unboxed_tuple] = STATE(7497),
    [sym__type_unboxed_sum] = STATE(7492),
    [sym__type_list] = STATE(7528),
    [sym__type_promoted] = STATE(7491),
    [sym__type_star] = STATE(7491),
    [sym__type_wildcard] = STATE(7491),
    [sym__at_type] = STATE(7994),
    [sym__type_apply] = STATE(7550),
    [sym__type_infix] = STATE(7534),
    [sym_type] = STATE(1137),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11252),
    [sym__splice_dollars] = STATE(7345),
    [sym_splice] = STATE(7491),
    [sym_quasiquote] = STATE(7491),
    [sym_integer] = STATE(7542),
    [sym__plist] = STATE(7518),
    [sym_unit] = STATE(7491),
    [sym_unboxed_unit] = STATE(7491),
    [sym_prefix_tuple] = STATE(7491),
    [sym_prefix_unboxed_tuple] = STATE(7491),
    [sym_prefix_unboxed_sum] = STATE(7491),
    [sym_literal] = STATE(7491),
    [sym__qualified_type] = STATE(7541),
    [sym__qtyconid] = STATE(7511),
    [sym__tycon_arrow] = STATE(7511),
    [sym__qtycon_arrow] = STATE(7511),
    [sym__promoted_tycons_alias] = STATE(7491),
    [sym__promoted_tycons] = STATE(7491),
    [sym__varsym_prefix] = STATE(7511),
    [sym__pvarsym] = STATE(7511),
    [sym__qvarsym_prefix] = STATE(7511),
    [sym__pqvarsym] = STATE(7511),
    [sym__consym_prefix] = STATE(7511),
    [sym__pconsym] = STATE(7511),
    [sym__qconsym_prefix] = STATE(7511),
    [sym__pqconsym] = STATE(7511),
    [sym__prefix_at] = STATE(2667),
    [sym__paren_open] = STATE(455),
    [sym__bracket_open] = STATE(1090),
    [sym__unboxed_open] = STATE(770),
    [aux_sym_type_patterns_repeat1] = STATE(2185),
    [sym_variable] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(3945),
    [anon_sym__] = ACTIONS(3109),
    [anon_sym_SQUOTE] = ACTIONS(4378),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_u2605] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3117),
    [sym_char] = ACTIONS(3117),
    [sym_string] = ACTIONS(3117),
    [sym__integer_literal] = ACTIONS(3119),
    [sym__binary_literal] = ACTIONS(3121),
    [sym__octal_literal] = ACTIONS(3121),
    [sym__hex_literal] = ACTIONS(3121),
    [sym_name] = ACTIONS(4380),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(3947),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3945),
    [sym__cond_layout_end] = ACTIONS(3945),
    [sym__cond_layout_end_explicit] = ACTIONS(3945),
    [sym__phantom_where] = ACTIONS(3945),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3125),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2182] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2183] = {
    [sym_alternative] = STATE(9186),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2184] = {
    [sym_alternative] = STATE(9339),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2185] = {
    [sym__type_parens] = STATE(7505),
    [sym__type_tuple] = STATE(7503),
    [sym__type_unboxed_tuple] = STATE(7497),
    [sym__type_unboxed_sum] = STATE(7492),
    [sym__type_list] = STATE(7528),
    [sym__type_promoted] = STATE(7491),
    [sym__type_star] = STATE(7491),
    [sym__type_wildcard] = STATE(7491),
    [sym__at_type] = STATE(7994),
    [sym__type_apply] = STATE(7550),
    [sym__type_infix] = STATE(7534),
    [sym_type] = STATE(1137),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11252),
    [sym__splice_dollars] = STATE(7345),
    [sym_splice] = STATE(7491),
    [sym_quasiquote] = STATE(7491),
    [sym_integer] = STATE(7542),
    [sym__plist] = STATE(7518),
    [sym_unit] = STATE(7491),
    [sym_unboxed_unit] = STATE(7491),
    [sym_prefix_tuple] = STATE(7491),
    [sym_prefix_unboxed_tuple] = STATE(7491),
    [sym_prefix_unboxed_sum] = STATE(7491),
    [sym_literal] = STATE(7491),
    [sym__qualified_type] = STATE(7541),
    [sym__qtyconid] = STATE(7511),
    [sym__tycon_arrow] = STATE(7511),
    [sym__qtycon_arrow] = STATE(7511),
    [sym__promoted_tycons_alias] = STATE(7491),
    [sym__promoted_tycons] = STATE(7491),
    [sym__varsym_prefix] = STATE(7511),
    [sym__pvarsym] = STATE(7511),
    [sym__qvarsym_prefix] = STATE(7511),
    [sym__pqvarsym] = STATE(7511),
    [sym__consym_prefix] = STATE(7511),
    [sym__pconsym] = STATE(7511),
    [sym__qconsym_prefix] = STATE(7511),
    [sym__pqconsym] = STATE(7511),
    [sym__prefix_at] = STATE(2667),
    [sym__paren_open] = STATE(455),
    [sym__bracket_open] = STATE(1090),
    [sym__unboxed_open] = STATE(770),
    [aux_sym_type_patterns_repeat1] = STATE(2185),
    [sym_variable] = ACTIONS(4440),
    [anon_sym_SEMI] = ACTIONS(4022),
    [anon_sym__] = ACTIONS(4443),
    [anon_sym_SQUOTE] = ACTIONS(4446),
    [anon_sym_STAR] = ACTIONS(4449),
    [anon_sym_u2605] = ACTIONS(4449),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [sym_float] = ACTIONS(4452),
    [sym_char] = ACTIONS(4452),
    [sym_string] = ACTIONS(4452),
    [sym__integer_literal] = ACTIONS(4455),
    [sym__binary_literal] = ACTIONS(4458),
    [sym__octal_literal] = ACTIONS(4458),
    [sym__hex_literal] = ACTIONS(4458),
    [sym_name] = ACTIONS(4461),
    [aux_sym__paren_open_token1] = ACTIONS(4050),
    [anon_sym_where] = ACTIONS(4033),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4022),
    [sym__cond_layout_end] = ACTIONS(4022),
    [sym__cond_layout_end_explicit] = ACTIONS(4022),
    [sym__phantom_where] = ACTIONS(4022),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4464),
    [sym__cond_splice] = ACTIONS(4056),
    [sym__cond_prefix_at] = ACTIONS(4059),
  },
  [2186] = {
    [sym_alternative] = STATE(9538),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2187] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(8047),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1371),
    [sym_type_patterns] = STATE(9907),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11043),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__colon2] = STATE(1583),
    [sym__prefix_at] = STATE(2497),
    [sym__paren_open] = STATE(439),
    [sym__paren_close] = STATE(7969),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [aux_sym_type_patterns_repeat1] = STATE(2221),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(4346),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [sym_name] = ACTIONS(4348),
    [anon_sym_COLON_COLON] = ACTIONS(4467),
    [anon_sym_u2237] = ACTIONS(4467),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(4469),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2188] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(8047),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1371),
    [sym_type_patterns] = STATE(9766),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11043),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__colon2] = STATE(1460),
    [sym__prefix_at] = STATE(2497),
    [sym__paren_open] = STATE(439),
    [sym__paren_close] = STATE(8021),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [aux_sym_type_patterns_repeat1] = STATE(2221),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(4346),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [sym_name] = ACTIONS(4348),
    [anon_sym_COLON_COLON] = ACTIONS(4471),
    [anon_sym_u2237] = ACTIONS(4471),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(4473),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2189] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(8047),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1371),
    [sym_type_patterns] = STATE(9717),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11043),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__colon2] = STATE(1520),
    [sym__prefix_at] = STATE(2497),
    [sym__paren_open] = STATE(439),
    [sym__paren_close] = STATE(8046),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [aux_sym_type_patterns_repeat1] = STATE(2221),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(4346),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [sym_name] = ACTIONS(4348),
    [anon_sym_COLON_COLON] = ACTIONS(4475),
    [anon_sym_u2237] = ACTIONS(4475),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(3411),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2190] = {
    [sym_alternative] = STATE(9159),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [aux_sym__let_binds_repeat1] = STATE(5849),
    [sym_variable] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2191] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym_bind] = STATE(9147),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(6696),
    [sym__pvarsym] = STATE(6696),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(4062),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2192] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(12213),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2853),
    [anon_sym_u27e7] = ACTIONS(2853),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2193] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11923),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2905),
    [anon_sym_u27e7] = ACTIONS(2905),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2194] = {
    [sym__type_parens] = STATE(7722),
    [sym__type_tuple] = STATE(7721),
    [sym__type_unboxed_tuple] = STATE(7686),
    [sym__type_unboxed_sum] = STATE(7703),
    [sym__type_list] = STATE(7696),
    [sym__type_promoted] = STATE(7670),
    [sym__type_star] = STATE(7670),
    [sym__type_wildcard] = STATE(7670),
    [sym__at_type] = STATE(8058),
    [sym__type_apply] = STATE(7690),
    [sym__type_infix] = STATE(7716),
    [sym_type] = STATE(1368),
    [sym_type_patterns] = STATE(10246),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10972),
    [sym__splice_dollars] = STATE(7311),
    [sym_splice] = STATE(7670),
    [sym_quasiquote] = STATE(7670),
    [sym_integer] = STATE(7653),
    [sym__plist] = STATE(7676),
    [sym_unit] = STATE(7670),
    [sym_unboxed_unit] = STATE(7670),
    [sym_prefix_tuple] = STATE(7670),
    [sym_prefix_unboxed_tuple] = STATE(7670),
    [sym_prefix_unboxed_sum] = STATE(7670),
    [sym_literal] = STATE(7670),
    [sym__qualified_type] = STATE(7677),
    [sym__qtyconid] = STATE(7664),
    [sym__tycon_arrow] = STATE(7664),
    [sym__qtycon_arrow] = STATE(7664),
    [sym__promoted_tycons_alias] = STATE(7670),
    [sym__promoted_tycons] = STATE(7670),
    [sym__varsym_prefix] = STATE(7664),
    [sym__pvarsym] = STATE(7664),
    [sym__qvarsym_prefix] = STATE(7664),
    [sym__pqvarsym] = STATE(7664),
    [sym__consym_prefix] = STATE(7664),
    [sym__pconsym] = STATE(7664),
    [sym__qconsym_prefix] = STATE(7664),
    [sym__pqconsym] = STATE(7664),
    [sym__prefix_at] = STATE(2640),
    [sym__paren_open] = STATE(463),
    [sym__bracket_open] = STATE(1066),
    [sym__unboxed_open] = STATE(825),
    [aux_sym_type_patterns_repeat1] = STATE(2214),
    [sym_variable] = ACTIONS(3247),
    [anon_sym_SEMI] = ACTIONS(4386),
    [anon_sym__] = ACTIONS(3249),
    [anon_sym_SQUOTE] = ACTIONS(4477),
    [anon_sym_STAR] = ACTIONS(3255),
    [anon_sym_u2605] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3257),
    [sym_char] = ACTIONS(3257),
    [sym_string] = ACTIONS(3257),
    [sym__integer_literal] = ACTIONS(3259),
    [sym__binary_literal] = ACTIONS(3261),
    [sym__octal_literal] = ACTIONS(3261),
    [sym__hex_literal] = ACTIONS(3261),
    [sym_name] = ACTIONS(4479),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4386),
    [sym__cond_layout_end] = ACTIONS(4386),
    [sym__cond_layout_end_explicit] = ACTIONS(4386),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3265),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2195] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11598),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3071),
    [anon_sym_u27e7] = ACTIONS(3071),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2196] = {
    [sym__type_parens] = STATE(7722),
    [sym__type_tuple] = STATE(7721),
    [sym__type_unboxed_tuple] = STATE(7686),
    [sym__type_unboxed_sum] = STATE(7703),
    [sym__type_list] = STATE(7696),
    [sym__type_promoted] = STATE(7670),
    [sym__type_star] = STATE(7670),
    [sym__type_wildcard] = STATE(7670),
    [sym__at_type] = STATE(8058),
    [sym__type_apply] = STATE(7690),
    [sym__type_infix] = STATE(7716),
    [sym_type] = STATE(1368),
    [sym_type_patterns] = STATE(10284),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10972),
    [sym__splice_dollars] = STATE(7311),
    [sym_splice] = STATE(7670),
    [sym_quasiquote] = STATE(7670),
    [sym_integer] = STATE(7653),
    [sym__plist] = STATE(7676),
    [sym_unit] = STATE(7670),
    [sym_unboxed_unit] = STATE(7670),
    [sym_prefix_tuple] = STATE(7670),
    [sym_prefix_unboxed_tuple] = STATE(7670),
    [sym_prefix_unboxed_sum] = STATE(7670),
    [sym_literal] = STATE(7670),
    [sym__qualified_type] = STATE(7677),
    [sym__qtyconid] = STATE(7664),
    [sym__tycon_arrow] = STATE(7664),
    [sym__qtycon_arrow] = STATE(7664),
    [sym__promoted_tycons_alias] = STATE(7670),
    [sym__promoted_tycons] = STATE(7670),
    [sym__varsym_prefix] = STATE(7664),
    [sym__pvarsym] = STATE(7664),
    [sym__qvarsym_prefix] = STATE(7664),
    [sym__pqvarsym] = STATE(7664),
    [sym__consym_prefix] = STATE(7664),
    [sym__pconsym] = STATE(7664),
    [sym__qconsym_prefix] = STATE(7664),
    [sym__pqconsym] = STATE(7664),
    [sym__prefix_at] = STATE(2640),
    [sym__paren_open] = STATE(463),
    [sym__bracket_open] = STATE(1066),
    [sym__unboxed_open] = STATE(825),
    [aux_sym_type_patterns_repeat1] = STATE(2214),
    [sym_variable] = ACTIONS(3247),
    [anon_sym_SEMI] = ACTIONS(4390),
    [anon_sym__] = ACTIONS(3249),
    [anon_sym_SQUOTE] = ACTIONS(4477),
    [anon_sym_STAR] = ACTIONS(3255),
    [anon_sym_u2605] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3257),
    [sym_char] = ACTIONS(3257),
    [sym_string] = ACTIONS(3257),
    [sym__integer_literal] = ACTIONS(3259),
    [sym__binary_literal] = ACTIONS(3261),
    [sym__octal_literal] = ACTIONS(3261),
    [sym__hex_literal] = ACTIONS(3261),
    [sym_name] = ACTIONS(4479),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4390),
    [sym__cond_layout_end] = ACTIONS(4390),
    [sym__cond_layout_end_explicit] = ACTIONS(4390),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3265),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2197] = {
    [sym__type_parens] = STATE(7585),
    [sym__type_tuple] = STATE(7602),
    [sym__type_unboxed_tuple] = STATE(7615),
    [sym__type_unboxed_sum] = STATE(7591),
    [sym__type_list] = STATE(7589),
    [sym__type_promoted] = STATE(7555),
    [sym__type_star] = STATE(7555),
    [sym__type_wildcard] = STATE(7555),
    [sym__at_type] = STATE(8035),
    [sym__type_apply] = STATE(7581),
    [sym__type_infix] = STATE(7580),
    [sym_type] = STATE(1267),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10889),
    [sym__splice_dollars] = STATE(7479),
    [sym_splice] = STATE(7555),
    [sym_quasiquote] = STATE(7555),
    [sym_integer] = STATE(7595),
    [sym__plist] = STATE(7579),
    [sym_unit] = STATE(7555),
    [sym_unboxed_unit] = STATE(7555),
    [sym_prefix_tuple] = STATE(7555),
    [sym_prefix_unboxed_tuple] = STATE(7555),
    [sym_prefix_unboxed_sum] = STATE(7555),
    [sym_literal] = STATE(7555),
    [sym__qualified_type] = STATE(7587),
    [sym__qtyconid] = STATE(7569),
    [sym__tycon_arrow] = STATE(7569),
    [sym__qtycon_arrow] = STATE(7569),
    [sym__promoted_tycons_alias] = STATE(7555),
    [sym__promoted_tycons] = STATE(7555),
    [sym__varsym_prefix] = STATE(7569),
    [sym__pvarsym] = STATE(7569),
    [sym__qvarsym_prefix] = STATE(7569),
    [sym__pqvarsym] = STATE(7569),
    [sym__consym_prefix] = STATE(7569),
    [sym__pconsym] = STATE(7569),
    [sym__qconsym_prefix] = STATE(7569),
    [sym__pqconsym] = STATE(7569),
    [sym__prefix_at] = STATE(2631),
    [sym__paren_open] = STATE(434),
    [sym__bracket_open] = STATE(963),
    [sym__unboxed_open] = STATE(763),
    [aux_sym_type_patterns_repeat1] = STATE(2197),
    [sym_variable] = ACTIONS(4481),
    [anon_sym__] = ACTIONS(4484),
    [anon_sym_SQUOTE] = ACTIONS(4487),
    [anon_sym_STAR] = ACTIONS(4490),
    [anon_sym_u2605] = ACTIONS(4490),
    [anon_sym_EQ] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [sym_float] = ACTIONS(4493),
    [sym_char] = ACTIONS(4493),
    [sym_string] = ACTIONS(4493),
    [sym__integer_literal] = ACTIONS(4496),
    [sym__binary_literal] = ACTIONS(4499),
    [sym__octal_literal] = ACTIONS(4499),
    [sym__hex_literal] = ACTIONS(4499),
    [sym_name] = ACTIONS(4502),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_u2237] = ACTIONS(4022),
    [aux_sym__paren_open_token1] = ACTIONS(4050),
    [anon_sym_where] = ACTIONS(4033),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_where] = ACTIONS(4022),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4505),
    [sym__cond_splice] = ACTIONS(4056),
    [sym__cond_prefix_at] = ACTIONS(4059),
  },
  [2198] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(12130),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2971),
    [anon_sym_u27e7] = ACTIONS(2971),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2199] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(12175),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3075),
    [anon_sym_u27e7] = ACTIONS(3075),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2200] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11933),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2991),
    [anon_sym_u27e7] = ACTIONS(2991),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2201] = {
    [sym__type_parens] = STATE(7722),
    [sym__type_tuple] = STATE(7721),
    [sym__type_unboxed_tuple] = STATE(7686),
    [sym__type_unboxed_sum] = STATE(7703),
    [sym__type_list] = STATE(7696),
    [sym__type_promoted] = STATE(7670),
    [sym__type_star] = STATE(7670),
    [sym__type_wildcard] = STATE(7670),
    [sym__at_type] = STATE(8058),
    [sym__type_apply] = STATE(7690),
    [sym__type_infix] = STATE(7716),
    [sym_type] = STATE(1368),
    [sym_type_patterns] = STATE(10247),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10972),
    [sym__splice_dollars] = STATE(7311),
    [sym_splice] = STATE(7670),
    [sym_quasiquote] = STATE(7670),
    [sym_integer] = STATE(7653),
    [sym__plist] = STATE(7676),
    [sym_unit] = STATE(7670),
    [sym_unboxed_unit] = STATE(7670),
    [sym_prefix_tuple] = STATE(7670),
    [sym_prefix_unboxed_tuple] = STATE(7670),
    [sym_prefix_unboxed_sum] = STATE(7670),
    [sym_literal] = STATE(7670),
    [sym__qualified_type] = STATE(7677),
    [sym__qtyconid] = STATE(7664),
    [sym__tycon_arrow] = STATE(7664),
    [sym__qtycon_arrow] = STATE(7664),
    [sym__promoted_tycons_alias] = STATE(7670),
    [sym__promoted_tycons] = STATE(7670),
    [sym__varsym_prefix] = STATE(7664),
    [sym__pvarsym] = STATE(7664),
    [sym__qvarsym_prefix] = STATE(7664),
    [sym__pqvarsym] = STATE(7664),
    [sym__consym_prefix] = STATE(7664),
    [sym__pconsym] = STATE(7664),
    [sym__qconsym_prefix] = STATE(7664),
    [sym__pqconsym] = STATE(7664),
    [sym__prefix_at] = STATE(2640),
    [sym__paren_open] = STATE(463),
    [sym__bracket_open] = STATE(1066),
    [sym__unboxed_open] = STATE(825),
    [aux_sym_type_patterns_repeat1] = STATE(2214),
    [sym_variable] = ACTIONS(3247),
    [anon_sym_SEMI] = ACTIONS(4376),
    [anon_sym__] = ACTIONS(3249),
    [anon_sym_SQUOTE] = ACTIONS(4477),
    [anon_sym_STAR] = ACTIONS(3255),
    [anon_sym_u2605] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3257),
    [sym_char] = ACTIONS(3257),
    [sym_string] = ACTIONS(3257),
    [sym__integer_literal] = ACTIONS(3259),
    [sym__binary_literal] = ACTIONS(3261),
    [sym__octal_literal] = ACTIONS(3261),
    [sym__hex_literal] = ACTIONS(3261),
    [sym_name] = ACTIONS(4479),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4376),
    [sym__cond_layout_end] = ACTIONS(4376),
    [sym__cond_layout_end_explicit] = ACTIONS(4376),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3265),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2202] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11570),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2987),
    [anon_sym_u27e7] = ACTIONS(2987),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2203] = {
    [sym__type_parens] = STATE(7585),
    [sym__type_tuple] = STATE(7602),
    [sym__type_unboxed_tuple] = STATE(7615),
    [sym__type_unboxed_sum] = STATE(7591),
    [sym__type_list] = STATE(7589),
    [sym__type_promoted] = STATE(7555),
    [sym__type_star] = STATE(7555),
    [sym__type_wildcard] = STATE(7555),
    [sym__at_type] = STATE(8035),
    [sym__type_apply] = STATE(7581),
    [sym__type_infix] = STATE(7580),
    [sym_type] = STATE(1267),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10889),
    [sym__splice_dollars] = STATE(7479),
    [sym_splice] = STATE(7555),
    [sym_quasiquote] = STATE(7555),
    [sym_integer] = STATE(7595),
    [sym__plist] = STATE(7579),
    [sym_unit] = STATE(7555),
    [sym_unboxed_unit] = STATE(7555),
    [sym_prefix_tuple] = STATE(7555),
    [sym_prefix_unboxed_tuple] = STATE(7555),
    [sym_prefix_unboxed_sum] = STATE(7555),
    [sym_literal] = STATE(7555),
    [sym__qualified_type] = STATE(7587),
    [sym__qtyconid] = STATE(7569),
    [sym__tycon_arrow] = STATE(7569),
    [sym__qtycon_arrow] = STATE(7569),
    [sym__promoted_tycons_alias] = STATE(7555),
    [sym__promoted_tycons] = STATE(7555),
    [sym__varsym_prefix] = STATE(7569),
    [sym__pvarsym] = STATE(7569),
    [sym__qvarsym_prefix] = STATE(7569),
    [sym__pqvarsym] = STATE(7569),
    [sym__consym_prefix] = STATE(7569),
    [sym__pconsym] = STATE(7569),
    [sym__qconsym_prefix] = STATE(7569),
    [sym__pqconsym] = STATE(7569),
    [sym__prefix_at] = STATE(2631),
    [sym__paren_open] = STATE(434),
    [sym__bracket_open] = STATE(963),
    [sym__unboxed_open] = STATE(763),
    [aux_sym_type_patterns_repeat1] = STATE(2197),
    [sym_variable] = ACTIONS(3203),
    [anon_sym__] = ACTIONS(3205),
    [anon_sym_SQUOTE] = ACTIONS(4140),
    [anon_sym_STAR] = ACTIONS(3211),
    [anon_sym_u2605] = ACTIONS(3211),
    [anon_sym_EQ] = ACTIONS(3945),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3213),
    [sym_char] = ACTIONS(3213),
    [sym_string] = ACTIONS(3213),
    [sym__integer_literal] = ACTIONS(3215),
    [sym__binary_literal] = ACTIONS(3217),
    [sym__octal_literal] = ACTIONS(3217),
    [sym__hex_literal] = ACTIONS(3217),
    [sym_name] = ACTIONS(4144),
    [anon_sym_COLON_COLON] = ACTIONS(3945),
    [anon_sym_u2237] = ACTIONS(3945),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [anon_sym_where] = ACTIONS(3947),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_where] = ACTIONS(3945),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3221),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2204] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8905),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym_bind] = STATE(10373),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(6696),
    [sym__pvarsym] = STATE(6696),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(4062),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_implicit_variable] = ACTIONS(1945),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2205] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11728),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2889),
    [anon_sym_u27e7] = ACTIONS(2889),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2206] = {
    [sym__type_parens] = STATE(7722),
    [sym__type_tuple] = STATE(7721),
    [sym__type_unboxed_tuple] = STATE(7686),
    [sym__type_unboxed_sum] = STATE(7703),
    [sym__type_list] = STATE(7696),
    [sym__type_promoted] = STATE(7670),
    [sym__type_star] = STATE(7670),
    [sym__type_wildcard] = STATE(7670),
    [sym__at_type] = STATE(8058),
    [sym__type_apply] = STATE(7690),
    [sym__type_infix] = STATE(7716),
    [sym_type] = STATE(1368),
    [sym_type_patterns] = STATE(10232),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10972),
    [sym__splice_dollars] = STATE(7311),
    [sym_splice] = STATE(7670),
    [sym_quasiquote] = STATE(7670),
    [sym_integer] = STATE(7653),
    [sym__plist] = STATE(7676),
    [sym_unit] = STATE(7670),
    [sym_unboxed_unit] = STATE(7670),
    [sym_prefix_tuple] = STATE(7670),
    [sym_prefix_unboxed_tuple] = STATE(7670),
    [sym_prefix_unboxed_sum] = STATE(7670),
    [sym_literal] = STATE(7670),
    [sym__qualified_type] = STATE(7677),
    [sym__qtyconid] = STATE(7664),
    [sym__tycon_arrow] = STATE(7664),
    [sym__qtycon_arrow] = STATE(7664),
    [sym__promoted_tycons_alias] = STATE(7670),
    [sym__promoted_tycons] = STATE(7670),
    [sym__varsym_prefix] = STATE(7664),
    [sym__pvarsym] = STATE(7664),
    [sym__qvarsym_prefix] = STATE(7664),
    [sym__pqvarsym] = STATE(7664),
    [sym__consym_prefix] = STATE(7664),
    [sym__pconsym] = STATE(7664),
    [sym__qconsym_prefix] = STATE(7664),
    [sym__pqconsym] = STATE(7664),
    [sym__prefix_at] = STATE(2640),
    [sym__paren_open] = STATE(463),
    [sym__bracket_open] = STATE(1066),
    [sym__unboxed_open] = STATE(825),
    [aux_sym_type_patterns_repeat1] = STATE(2214),
    [sym_variable] = ACTIONS(3247),
    [anon_sym_SEMI] = ACTIONS(4418),
    [anon_sym__] = ACTIONS(3249),
    [anon_sym_SQUOTE] = ACTIONS(4477),
    [anon_sym_STAR] = ACTIONS(3255),
    [anon_sym_u2605] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3257),
    [sym_char] = ACTIONS(3257),
    [sym_string] = ACTIONS(3257),
    [sym__integer_literal] = ACTIONS(3259),
    [sym__binary_literal] = ACTIONS(3261),
    [sym__octal_literal] = ACTIONS(3261),
    [sym__hex_literal] = ACTIONS(3261),
    [sym_name] = ACTIONS(4479),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4418),
    [sym__cond_layout_end] = ACTIONS(4418),
    [sym__cond_layout_end_explicit] = ACTIONS(4418),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3265),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2207] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(11482),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_PIPE_RBRACK] = ACTIONS(3079),
    [anon_sym_u27e7] = ACTIONS(3079),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2208] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1195),
    [sym__pat_signature] = STATE(8722),
    [sym__pat] = STATE(12159),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_PIPE_RBRACK] = ACTIONS(2877),
    [anon_sym_u27e7] = ACTIONS(2877),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2209] = {
    [sym_alternative] = STATE(9344),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2210] = {
    [sym_alternative] = STATE(10454),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2211] = {
    [sym__type_parens] = STATE(7722),
    [sym__type_tuple] = STATE(7721),
    [sym__type_unboxed_tuple] = STATE(7686),
    [sym__type_unboxed_sum] = STATE(7703),
    [sym__type_list] = STATE(7696),
    [sym__type_promoted] = STATE(7670),
    [sym__type_star] = STATE(7670),
    [sym__type_wildcard] = STATE(7670),
    [sym__at_type] = STATE(8058),
    [sym__type_apply] = STATE(7690),
    [sym__type_infix] = STATE(7716),
    [sym_type] = STATE(1368),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10972),
    [sym__splice_dollars] = STATE(7311),
    [sym_splice] = STATE(7670),
    [sym_quasiquote] = STATE(7670),
    [sym_integer] = STATE(7653),
    [sym__plist] = STATE(7676),
    [sym_unit] = STATE(7670),
    [sym_unboxed_unit] = STATE(7670),
    [sym_prefix_tuple] = STATE(7670),
    [sym_prefix_unboxed_tuple] = STATE(7670),
    [sym_prefix_unboxed_sum] = STATE(7670),
    [sym_literal] = STATE(7670),
    [sym__qualified_type] = STATE(7677),
    [sym__qtyconid] = STATE(7664),
    [sym__tycon_arrow] = STATE(7664),
    [sym__qtycon_arrow] = STATE(7664),
    [sym__promoted_tycons_alias] = STATE(7670),
    [sym__promoted_tycons] = STATE(7670),
    [sym__varsym_prefix] = STATE(7664),
    [sym__pvarsym] = STATE(7664),
    [sym__qvarsym_prefix] = STATE(7664),
    [sym__pqvarsym] = STATE(7664),
    [sym__consym_prefix] = STATE(7664),
    [sym__pconsym] = STATE(7664),
    [sym__qconsym_prefix] = STATE(7664),
    [sym__pqconsym] = STATE(7664),
    [sym__prefix_at] = STATE(2640),
    [sym__paren_open] = STATE(463),
    [sym__bracket_open] = STATE(1066),
    [sym__unboxed_open] = STATE(825),
    [aux_sym_type_patterns_repeat1] = STATE(2211),
    [sym_variable] = ACTIONS(4508),
    [anon_sym_SEMI] = ACTIONS(4022),
    [anon_sym__] = ACTIONS(4511),
    [anon_sym_SQUOTE] = ACTIONS(4514),
    [anon_sym_STAR] = ACTIONS(4517),
    [anon_sym_u2605] = ACTIONS(4517),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [sym_float] = ACTIONS(4520),
    [sym_char] = ACTIONS(4520),
    [sym_string] = ACTIONS(4520),
    [sym__integer_literal] = ACTIONS(4523),
    [sym__binary_literal] = ACTIONS(4526),
    [sym__octal_literal] = ACTIONS(4526),
    [sym__hex_literal] = ACTIONS(4526),
    [sym_name] = ACTIONS(4529),
    [aux_sym__paren_open_token1] = ACTIONS(4050),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4022),
    [sym__cond_layout_end] = ACTIONS(4022),
    [sym__cond_layout_end_explicit] = ACTIONS(4022),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4532),
    [sym__cond_splice] = ACTIONS(4056),
    [sym__cond_prefix_at] = ACTIONS(4059),
  },
  [2212] = {
    [sym_alternative] = STATE(9377),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2213] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1844),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__con_binding_list] = STATE(11016),
    [sym__patsyn_signature] = STATE(10172),
    [sym__patsyn_equation] = STATE(10173),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(7116),
    [sym__pconsym] = STATE(7116),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(4535),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2214] = {
    [sym__type_parens] = STATE(7722),
    [sym__type_tuple] = STATE(7721),
    [sym__type_unboxed_tuple] = STATE(7686),
    [sym__type_unboxed_sum] = STATE(7703),
    [sym__type_list] = STATE(7696),
    [sym__type_promoted] = STATE(7670),
    [sym__type_star] = STATE(7670),
    [sym__type_wildcard] = STATE(7670),
    [sym__at_type] = STATE(8058),
    [sym__type_apply] = STATE(7690),
    [sym__type_infix] = STATE(7716),
    [sym_type] = STATE(1368),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10972),
    [sym__splice_dollars] = STATE(7311),
    [sym_splice] = STATE(7670),
    [sym_quasiquote] = STATE(7670),
    [sym_integer] = STATE(7653),
    [sym__plist] = STATE(7676),
    [sym_unit] = STATE(7670),
    [sym_unboxed_unit] = STATE(7670),
    [sym_prefix_tuple] = STATE(7670),
    [sym_prefix_unboxed_tuple] = STATE(7670),
    [sym_prefix_unboxed_sum] = STATE(7670),
    [sym_literal] = STATE(7670),
    [sym__qualified_type] = STATE(7677),
    [sym__qtyconid] = STATE(7664),
    [sym__tycon_arrow] = STATE(7664),
    [sym__qtycon_arrow] = STATE(7664),
    [sym__promoted_tycons_alias] = STATE(7670),
    [sym__promoted_tycons] = STATE(7670),
    [sym__varsym_prefix] = STATE(7664),
    [sym__pvarsym] = STATE(7664),
    [sym__qvarsym_prefix] = STATE(7664),
    [sym__pqvarsym] = STATE(7664),
    [sym__consym_prefix] = STATE(7664),
    [sym__pconsym] = STATE(7664),
    [sym__qconsym_prefix] = STATE(7664),
    [sym__pqconsym] = STATE(7664),
    [sym__prefix_at] = STATE(2640),
    [sym__paren_open] = STATE(463),
    [sym__bracket_open] = STATE(1066),
    [sym__unboxed_open] = STATE(825),
    [aux_sym_type_patterns_repeat1] = STATE(2211),
    [sym_variable] = ACTIONS(3247),
    [anon_sym_SEMI] = ACTIONS(3945),
    [anon_sym__] = ACTIONS(3249),
    [anon_sym_SQUOTE] = ACTIONS(4477),
    [anon_sym_STAR] = ACTIONS(3255),
    [anon_sym_u2605] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(3257),
    [sym_char] = ACTIONS(3257),
    [sym_string] = ACTIONS(3257),
    [sym__integer_literal] = ACTIONS(3259),
    [sym__binary_literal] = ACTIONS(3261),
    [sym__octal_literal] = ACTIONS(3261),
    [sym__hex_literal] = ACTIONS(3261),
    [sym_name] = ACTIONS(4479),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(3945),
    [sym__cond_layout_end] = ACTIONS(3945),
    [sym__cond_layout_end_explicit] = ACTIONS(3945),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3265),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2215] = {
    [sym_alternative] = STATE(9539),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2216] = {
    [sym_alternative] = STATE(9241),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2217] = {
    [sym_alternative] = STATE(9179),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2218] = {
    [sym_alternative] = STATE(9215),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2219] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(8047),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1371),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11043),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2497),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [aux_sym_type_patterns_repeat1] = STATE(2219),
    [sym_variable] = ACTIONS(4537),
    [anon_sym__] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4543),
    [anon_sym_STAR] = ACTIONS(4546),
    [anon_sym_u2605] = ACTIONS(4546),
    [anon_sym_EQ] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [sym_float] = ACTIONS(4549),
    [sym_char] = ACTIONS(4549),
    [sym_string] = ACTIONS(4549),
    [sym__integer_literal] = ACTIONS(4552),
    [sym__binary_literal] = ACTIONS(4555),
    [sym__octal_literal] = ACTIONS(4555),
    [sym__hex_literal] = ACTIONS(4555),
    [sym_name] = ACTIONS(4558),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_u2237] = ACTIONS(4022),
    [aux_sym__paren_open_token1] = ACTIONS(4050),
    [aux_sym__paren_close_token1] = ACTIONS(4022),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4561),
    [sym__cond_splice] = ACTIONS(4056),
    [sym__cond_prefix_at] = ACTIONS(4059),
  },
  [2220] = {
    [sym_alternative] = STATE(9186),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2221] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(8047),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1371),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11043),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2497),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [aux_sym_type_patterns_repeat1] = STATE(2219),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(4346),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_EQ] = ACTIONS(3945),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [sym_name] = ACTIONS(4348),
    [anon_sym_COLON_COLON] = ACTIONS(3945),
    [anon_sym_u2237] = ACTIONS(3945),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(3945),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2222] = {
    [sym_alternative] = STATE(9339),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2223] = {
    [sym_alternative] = STATE(9538),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2224] = {
    [sym_alternative] = STATE(9159),
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1772),
    [sym__pat_signature] = STATE(9787),
    [sym__pat] = STATE(8732),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2225] = {
    [sym__fun_arrow] = STATE(1675),
    [sym_modifier] = STATE(9901),
    [sym__linear_fun_arrow] = STATE(1683),
    [sym__arrow] = STATE(7944),
    [sym__linear_arrow] = STATE(7941),
    [sym__prefix_percent] = STATE(2611),
    [sym_variable] = ACTIONS(4564),
    [anon_sym_SEMI] = ACTIONS(4566),
    [anon_sym_let] = ACTIONS(4564),
    [anon_sym_COMMA] = ACTIONS(4566),
    [anon_sym_LBRACE] = ACTIONS(4566),
    [anon_sym_RBRACE] = ACTIONS(4566),
    [anon_sym_SQUOTE] = ACTIONS(4564),
    [anon_sym_STAR] = ACTIONS(4566),
    [anon_sym_EQ] = ACTIONS(4566),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4566),
    [anon_sym_then] = ACTIONS(4564),
    [anon_sym_using] = ACTIONS(4564),
    [anon_sym_BSLASH] = ACTIONS(4566),
    [anon_sym_if] = ACTIONS(4564),
    [anon_sym_else] = ACTIONS(4564),
    [anon_sym_mdo] = ACTIONS(4564),
    [anon_sym_do] = ACTIONS(4564),
    [anon_sym_case] = ACTIONS(4564),
    [anon_sym_of] = ACTIONS(4564),
    [anon_sym_DASH] = ACTIONS(4564),
    [anon_sym_DASH_GT] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4566),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4566),
    [anon_sym_u27e7] = ACTIONS(4566),
    [anon_sym_u27e6] = ACTIONS(4566),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4566),
    [sym_float] = ACTIONS(4566),
    [sym_char] = ACTIONS(4566),
    [sym_string] = ACTIONS(4566),
    [sym__integer_literal] = ACTIONS(4564),
    [sym__binary_literal] = ACTIONS(4566),
    [sym__octal_literal] = ACTIONS(4566),
    [sym__hex_literal] = ACTIONS(4566),
    [anon_sym_BQUOTE] = ACTIONS(4566),
    [anon_sym_POUND] = ACTIONS(4564),
    [anon_sym_POUND2] = ACTIONS(4564),
    [sym_implicit_variable] = ACTIONS(4566),
    [sym_name] = ACTIONS(4566),
    [sym_label] = ACTIONS(4566),
    [anon_sym_u2192] = ACTIONS(4570),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4572),
    [anon_sym_u22b8] = ACTIONS(4572),
    [anon_sym_COLON_COLON] = ACTIONS(4566),
    [anon_sym_u2237] = ACTIONS(4566),
    [aux_sym__paren_open_token1] = ACTIONS(4566),
    [aux_sym__paren_close_token1] = ACTIONS(4566),
    [anon_sym_RBRACK] = ACTIONS(4566),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4574),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4566),
    [sym__cond_splice] = ACTIONS(4566),
    [sym__cond_tight_dot] = ACTIONS(4566),
    [sym__cond_prefix_dot] = ACTIONS(4566),
    [sym__cond_prefix_at] = ACTIONS(4566),
    [sym__cond_prefix_percent] = ACTIONS(4576),
    [sym__cond_qualified_op] = ACTIONS(4566),
    [sym__cond_no_section_op] = ACTIONS(4566),
    [sym__cond_minus] = ACTIONS(4566),
    [sym__varsym] = ACTIONS(4566),
    [sym__consym] = ACTIONS(4566),
  },
  [2226] = {
    [sym__pat_parens] = STATE(7041),
    [sym__pat_tuple] = STATE(7042),
    [sym__pat_unboxed_tuple] = STATE(7043),
    [sym__pat_unboxed_sum] = STATE(7044),
    [sym__pat_list] = STATE(7045),
    [sym__pat_record] = STATE(7046),
    [sym__pat_as] = STATE(7047),
    [sym__pat_wildcard] = STATE(7048),
    [sym__pat_strict] = STATE(7049),
    [sym__pat_irrefutable] = STATE(7050),
    [sym__pat_apply] = STATE(7051),
    [sym__pat_negation] = STATE(7052),
    [sym__pat_infix] = STATE(7053),
    [sym_pattern] = STATE(1673),
    [sym__pat_signature] = STATE(9604),
    [sym__pat] = STATE(9397),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11245),
    [sym__splice_dollars] = STATE(7422),
    [sym_splice] = STATE(7048),
    [sym_quasiquote] = STATE(7048),
    [sym_integer] = STATE(7199),
    [sym__plist] = STATE(7057),
    [sym_unit] = STATE(7048),
    [sym_unboxed_unit] = STATE(7048),
    [sym_prefix_tuple] = STATE(7048),
    [sym_prefix_unboxed_tuple] = STATE(7048),
    [sym_prefix_unboxed_sum] = STATE(7048),
    [sym_literal] = STATE(7048),
    [sym__qualified_constructor] = STATE(7189),
    [sym__qconid] = STATE(7048),
    [sym__varsym_prefix] = STATE(7058),
    [sym__pvarsym] = STATE(7058),
    [sym__consym_prefix] = STATE(7059),
    [sym__pconsym] = STATE(7059),
    [sym__qconsym_prefix] = STATE(7048),
    [sym__pqconsym] = STATE(7048),
    [sym__prefix_bang] = STATE(2256),
    [sym__tight_bang] = STATE(2256),
    [sym__any_prefix_bang] = STATE(2256),
    [sym__prefix_tilde] = STATE(2253),
    [sym__tight_tilde] = STATE(2253),
    [sym__any_prefix_tilde] = STATE(2253),
    [sym__paren_open] = STATE(47),
    [sym__bracket_open] = STATE(364),
    [sym__unboxed_open] = STATE(202),
    [sym_variable] = ACTIONS(3473),
    [anon_sym__] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3481),
    [sym_char] = ACTIONS(3481),
    [sym_string] = ACTIONS(3481),
    [sym__integer_literal] = ACTIONS(3483),
    [sym__binary_literal] = ACTIONS(3485),
    [sym__octal_literal] = ACTIONS(3485),
    [sym__hex_literal] = ACTIONS(3485),
    [sym_name] = ACTIONS(3487),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3493),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2227] = {
    [sym__fun_arrow] = STATE(1675),
    [sym_modifier] = STATE(9901),
    [sym__linear_fun_arrow] = STATE(1683),
    [sym__arrow] = STATE(7944),
    [sym__linear_arrow] = STATE(7941),
    [sym__prefix_percent] = STATE(2611),
    [sym_variable] = ACTIONS(4578),
    [anon_sym_SEMI] = ACTIONS(4580),
    [anon_sym_let] = ACTIONS(4578),
    [anon_sym_COMMA] = ACTIONS(4580),
    [anon_sym_LBRACE] = ACTIONS(4580),
    [anon_sym_RBRACE] = ACTIONS(4580),
    [anon_sym_SQUOTE] = ACTIONS(4578),
    [anon_sym_STAR] = ACTIONS(4580),
    [anon_sym_EQ] = ACTIONS(4580),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4580),
    [anon_sym_then] = ACTIONS(4578),
    [anon_sym_using] = ACTIONS(4578),
    [anon_sym_BSLASH] = ACTIONS(4580),
    [anon_sym_if] = ACTIONS(4578),
    [anon_sym_else] = ACTIONS(4578),
    [anon_sym_mdo] = ACTIONS(4578),
    [anon_sym_do] = ACTIONS(4578),
    [anon_sym_case] = ACTIONS(4578),
    [anon_sym_of] = ACTIONS(4578),
    [anon_sym_DASH] = ACTIONS(4578),
    [anon_sym_DASH_GT] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4580),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4580),
    [anon_sym_u27e7] = ACTIONS(4580),
    [anon_sym_u27e6] = ACTIONS(4580),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4580),
    [sym_float] = ACTIONS(4580),
    [sym_char] = ACTIONS(4580),
    [sym_string] = ACTIONS(4580),
    [sym__integer_literal] = ACTIONS(4578),
    [sym__binary_literal] = ACTIONS(4580),
    [sym__octal_literal] = ACTIONS(4580),
    [sym__hex_literal] = ACTIONS(4580),
    [anon_sym_BQUOTE] = ACTIONS(4580),
    [anon_sym_POUND] = ACTIONS(4578),
    [anon_sym_POUND2] = ACTIONS(4578),
    [sym_implicit_variable] = ACTIONS(4580),
    [sym_name] = ACTIONS(4580),
    [sym_label] = ACTIONS(4580),
    [anon_sym_u2192] = ACTIONS(4570),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4572),
    [anon_sym_u22b8] = ACTIONS(4572),
    [anon_sym_COLON_COLON] = ACTIONS(4580),
    [anon_sym_u2237] = ACTIONS(4580),
    [aux_sym__paren_open_token1] = ACTIONS(4580),
    [aux_sym__paren_close_token1] = ACTIONS(4580),
    [anon_sym_RBRACK] = ACTIONS(4580),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4574),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4580),
    [sym__cond_splice] = ACTIONS(4580),
    [sym__cond_tight_dot] = ACTIONS(4580),
    [sym__cond_prefix_dot] = ACTIONS(4580),
    [sym__cond_prefix_at] = ACTIONS(4580),
    [sym__cond_prefix_percent] = ACTIONS(4576),
    [sym__cond_qualified_op] = ACTIONS(4580),
    [sym__cond_no_section_op] = ACTIONS(4580),
    [sym__cond_minus] = ACTIONS(4580),
    [sym__varsym] = ACTIONS(4580),
    [sym__consym] = ACTIONS(4580),
  },
  [2228] = {
    [sym__fun_arrow] = STATE(1675),
    [sym_modifier] = STATE(9901),
    [sym__linear_fun_arrow] = STATE(1683),
    [sym__arrow] = STATE(7944),
    [sym__linear_arrow] = STATE(7941),
    [sym__prefix_percent] = STATE(2611),
    [sym_variable] = ACTIONS(4582),
    [anon_sym_SEMI] = ACTIONS(4584),
    [anon_sym_let] = ACTIONS(4582),
    [anon_sym_COMMA] = ACTIONS(4584),
    [anon_sym_LBRACE] = ACTIONS(4584),
    [anon_sym_RBRACE] = ACTIONS(4584),
    [anon_sym_SQUOTE] = ACTIONS(4582),
    [anon_sym_STAR] = ACTIONS(4584),
    [anon_sym_EQ] = ACTIONS(4584),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4584),
    [anon_sym_then] = ACTIONS(4582),
    [anon_sym_using] = ACTIONS(4582),
    [anon_sym_BSLASH] = ACTIONS(4584),
    [anon_sym_if] = ACTIONS(4582),
    [anon_sym_else] = ACTIONS(4582),
    [anon_sym_mdo] = ACTIONS(4582),
    [anon_sym_do] = ACTIONS(4582),
    [anon_sym_case] = ACTIONS(4582),
    [anon_sym_of] = ACTIONS(4582),
    [anon_sym_DASH] = ACTIONS(4582),
    [anon_sym_DASH_GT] = ACTIONS(4582),
    [anon_sym_LBRACK] = ACTIONS(4584),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4584),
    [anon_sym_u27e7] = ACTIONS(4584),
    [anon_sym_u27e6] = ACTIONS(4584),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4584),
    [sym_float] = ACTIONS(4584),
    [sym_char] = ACTIONS(4584),
    [sym_string] = ACTIONS(4584),
    [sym__integer_literal] = ACTIONS(4582),
    [sym__binary_literal] = ACTIONS(4584),
    [sym__octal_literal] = ACTIONS(4584),
    [sym__hex_literal] = ACTIONS(4584),
    [anon_sym_BQUOTE] = ACTIONS(4584),
    [anon_sym_POUND] = ACTIONS(4582),
    [anon_sym_POUND2] = ACTIONS(4582),
    [sym_implicit_variable] = ACTIONS(4584),
    [sym_name] = ACTIONS(4584),
    [sym_label] = ACTIONS(4584),
    [anon_sym_u2192] = ACTIONS(4584),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4584),
    [anon_sym_u22b8] = ACTIONS(4584),
    [anon_sym_COLON_COLON] = ACTIONS(4584),
    [anon_sym_u2237] = ACTIONS(4584),
    [aux_sym__paren_open_token1] = ACTIONS(4584),
    [aux_sym__paren_close_token1] = ACTIONS(4584),
    [anon_sym_RBRACK] = ACTIONS(4584),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4584),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4584),
    [sym__cond_splice] = ACTIONS(4584),
    [sym__cond_tight_dot] = ACTIONS(4584),
    [sym__cond_prefix_dot] = ACTIONS(4584),
    [sym__cond_prefix_at] = ACTIONS(4584),
    [sym__cond_prefix_percent] = ACTIONS(4584),
    [sym__cond_qualified_op] = ACTIONS(4584),
    [sym__cond_no_section_op] = ACTIONS(4584),
    [sym__cond_minus] = ACTIONS(4584),
    [sym__varsym] = ACTIONS(4584),
    [sym__consym] = ACTIONS(4584),
  },
  [2229] = {
    [sym__fun_arrow] = STATE(1675),
    [sym_modifier] = STATE(9901),
    [sym__linear_fun_arrow] = STATE(1683),
    [sym__arrow] = STATE(7944),
    [sym__linear_arrow] = STATE(7941),
    [sym__prefix_percent] = STATE(2611),
    [sym_variable] = ACTIONS(4586),
    [anon_sym_SEMI] = ACTIONS(4588),
    [anon_sym_let] = ACTIONS(4586),
    [anon_sym_COMMA] = ACTIONS(4588),
    [anon_sym_LBRACE] = ACTIONS(4588),
    [anon_sym_RBRACE] = ACTIONS(4588),
    [anon_sym_SQUOTE] = ACTIONS(4586),
    [anon_sym_STAR] = ACTIONS(4588),
    [anon_sym_EQ] = ACTIONS(4588),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4588),
    [anon_sym_then] = ACTIONS(4586),
    [anon_sym_using] = ACTIONS(4586),
    [anon_sym_BSLASH] = ACTIONS(4588),
    [anon_sym_if] = ACTIONS(4586),
    [anon_sym_else] = ACTIONS(4586),
    [anon_sym_mdo] = ACTIONS(4586),
    [anon_sym_do] = ACTIONS(4586),
    [anon_sym_case] = ACTIONS(4586),
    [anon_sym_of] = ACTIONS(4586),
    [anon_sym_DASH] = ACTIONS(4586),
    [anon_sym_DASH_GT] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4588),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4588),
    [anon_sym_u27e7] = ACTIONS(4588),
    [anon_sym_u27e6] = ACTIONS(4588),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4588),
    [sym_float] = ACTIONS(4588),
    [sym_char] = ACTIONS(4588),
    [sym_string] = ACTIONS(4588),
    [sym__integer_literal] = ACTIONS(4586),
    [sym__binary_literal] = ACTIONS(4588),
    [sym__octal_literal] = ACTIONS(4588),
    [sym__hex_literal] = ACTIONS(4588),
    [anon_sym_BQUOTE] = ACTIONS(4588),
    [anon_sym_POUND] = ACTIONS(4586),
    [anon_sym_POUND2] = ACTIONS(4586),
    [sym_implicit_variable] = ACTIONS(4588),
    [sym_name] = ACTIONS(4588),
    [sym_label] = ACTIONS(4588),
    [anon_sym_u2192] = ACTIONS(4570),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4572),
    [anon_sym_u22b8] = ACTIONS(4572),
    [anon_sym_COLON_COLON] = ACTIONS(4588),
    [anon_sym_u2237] = ACTIONS(4588),
    [aux_sym__paren_open_token1] = ACTIONS(4588),
    [aux_sym__paren_close_token1] = ACTIONS(4588),
    [anon_sym_RBRACK] = ACTIONS(4588),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4574),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4588),
    [sym__cond_splice] = ACTIONS(4588),
    [sym__cond_tight_dot] = ACTIONS(4588),
    [sym__cond_prefix_dot] = ACTIONS(4588),
    [sym__cond_prefix_at] = ACTIONS(4588),
    [sym__cond_prefix_percent] = ACTIONS(4576),
    [sym__cond_qualified_op] = ACTIONS(4588),
    [sym__cond_no_section_op] = ACTIONS(4588),
    [sym__cond_minus] = ACTIONS(4588),
    [sym__varsym] = ACTIONS(4588),
    [sym__consym] = ACTIONS(4588),
  },
  [2230] = {
    [sym__fun_arrow] = STATE(1675),
    [sym_modifier] = STATE(9901),
    [sym__linear_fun_arrow] = STATE(1683),
    [sym__arrow] = STATE(7944),
    [sym__linear_arrow] = STATE(7941),
    [sym__prefix_percent] = STATE(2611),
    [sym_variable] = ACTIONS(4590),
    [anon_sym_SEMI] = ACTIONS(4592),
    [anon_sym_let] = ACTIONS(4590),
    [anon_sym_COMMA] = ACTIONS(4592),
    [anon_sym_LBRACE] = ACTIONS(4592),
    [anon_sym_RBRACE] = ACTIONS(4592),
    [anon_sym_SQUOTE] = ACTIONS(4590),
    [anon_sym_STAR] = ACTIONS(4592),
    [anon_sym_EQ] = ACTIONS(4592),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4592),
    [anon_sym_then] = ACTIONS(4590),
    [anon_sym_using] = ACTIONS(4590),
    [anon_sym_BSLASH] = ACTIONS(4592),
    [anon_sym_if] = ACTIONS(4590),
    [anon_sym_else] = ACTIONS(4590),
    [anon_sym_mdo] = ACTIONS(4590),
    [anon_sym_do] = ACTIONS(4590),
    [anon_sym_case] = ACTIONS(4590),
    [anon_sym_of] = ACTIONS(4590),
    [anon_sym_DASH] = ACTIONS(4590),
    [anon_sym_DASH_GT] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4592),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4592),
    [anon_sym_u27e7] = ACTIONS(4592),
    [anon_sym_u27e6] = ACTIONS(4592),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4592),
    [sym_float] = ACTIONS(4592),
    [sym_char] = ACTIONS(4592),
    [sym_string] = ACTIONS(4592),
    [sym__integer_literal] = ACTIONS(4590),
    [sym__binary_literal] = ACTIONS(4592),
    [sym__octal_literal] = ACTIONS(4592),
    [sym__hex_literal] = ACTIONS(4592),
    [anon_sym_BQUOTE] = ACTIONS(4592),
    [anon_sym_POUND] = ACTIONS(4590),
    [anon_sym_POUND2] = ACTIONS(4590),
    [sym_implicit_variable] = ACTIONS(4592),
    [sym_name] = ACTIONS(4592),
    [sym_label] = ACTIONS(4592),
    [anon_sym_u2192] = ACTIONS(4570),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4572),
    [anon_sym_u22b8] = ACTIONS(4572),
    [anon_sym_COLON_COLON] = ACTIONS(4592),
    [anon_sym_u2237] = ACTIONS(4592),
    [aux_sym__paren_open_token1] = ACTIONS(4592),
    [aux_sym__paren_close_token1] = ACTIONS(4592),
    [anon_sym_RBRACK] = ACTIONS(4592),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4574),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4592),
    [sym__cond_splice] = ACTIONS(4592),
    [sym__cond_tight_dot] = ACTIONS(4592),
    [sym__cond_prefix_dot] = ACTIONS(4592),
    [sym__cond_prefix_at] = ACTIONS(4592),
    [sym__cond_prefix_percent] = ACTIONS(4576),
    [sym__cond_qualified_op] = ACTIONS(4592),
    [sym__cond_no_section_op] = ACTIONS(4592),
    [sym__cond_minus] = ACTIONS(4592),
    [sym__varsym] = ACTIONS(4592),
    [sym__consym] = ACTIONS(4592),
  },
  [2231] = {
    [sym__fun_arrow] = STATE(1675),
    [sym_modifier] = STATE(9901),
    [sym__linear_fun_arrow] = STATE(1683),
    [sym__arrow] = STATE(7944),
    [sym__linear_arrow] = STATE(7941),
    [sym__prefix_percent] = STATE(2611),
    [sym_variable] = ACTIONS(4564),
    [anon_sym_SEMI] = ACTIONS(4566),
    [anon_sym_let] = ACTIONS(4564),
    [anon_sym_COMMA] = ACTIONS(4566),
    [anon_sym_LBRACE] = ACTIONS(4566),
    [anon_sym_RBRACE] = ACTIONS(4566),
    [anon_sym_SQUOTE] = ACTIONS(4564),
    [anon_sym_STAR] = ACTIONS(4566),
    [anon_sym_EQ] = ACTIONS(4566),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4566),
    [anon_sym_then] = ACTIONS(4564),
    [anon_sym_using] = ACTIONS(4564),
    [anon_sym_BSLASH] = ACTIONS(4566),
    [anon_sym_if] = ACTIONS(4564),
    [anon_sym_else] = ACTIONS(4564),
    [anon_sym_mdo] = ACTIONS(4564),
    [anon_sym_do] = ACTIONS(4564),
    [anon_sym_case] = ACTIONS(4564),
    [anon_sym_of] = ACTIONS(4564),
    [anon_sym_DASH] = ACTIONS(4564),
    [anon_sym_DASH_GT] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4566),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4566),
    [anon_sym_u27e7] = ACTIONS(4566),
    [anon_sym_u27e6] = ACTIONS(4566),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4566),
    [sym_float] = ACTIONS(4566),
    [sym_char] = ACTIONS(4566),
    [sym_string] = ACTIONS(4566),
    [sym__integer_literal] = ACTIONS(4564),
    [sym__binary_literal] = ACTIONS(4566),
    [sym__octal_literal] = ACTIONS(4566),
    [sym__hex_literal] = ACTIONS(4566),
    [anon_sym_BQUOTE] = ACTIONS(4566),
    [anon_sym_POUND] = ACTIONS(4564),
    [anon_sym_POUND2] = ACTIONS(4564),
    [sym_implicit_variable] = ACTIONS(4566),
    [sym_name] = ACTIONS(4566),
    [sym_label] = ACTIONS(4566),
    [anon_sym_u2192] = ACTIONS(4570),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4572),
    [anon_sym_u22b8] = ACTIONS(4572),
    [anon_sym_COLON_COLON] = ACTIONS(4566),
    [anon_sym_u2237] = ACTIONS(4566),
    [aux_sym__paren_open_token1] = ACTIONS(4566),
    [aux_sym__paren_close_token1] = ACTIONS(4566),
    [anon_sym_RBRACK] = ACTIONS(4566),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4574),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4566),
    [sym__cond_splice] = ACTIONS(4566),
    [sym__cond_tight_dot] = ACTIONS(4566),
    [sym__cond_prefix_dot] = ACTIONS(4566),
    [sym__cond_prefix_at] = ACTIONS(4566),
    [sym__cond_prefix_percent] = ACTIONS(4576),
    [sym__cond_qualified_op] = ACTIONS(4566),
    [sym__cond_no_section_op] = ACTIONS(4566),
    [sym__cond_minus] = ACTIONS(4566),
    [sym__varsym] = ACTIONS(4566),
    [sym__consym] = ACTIONS(4566),
  },
  [2232] = {
    [sym__fun_arrow] = STATE(1675),
    [sym_modifier] = STATE(9901),
    [sym__linear_fun_arrow] = STATE(1683),
    [sym__arrow] = STATE(7944),
    [sym__linear_arrow] = STATE(7941),
    [sym__prefix_percent] = STATE(2611),
    [sym_variable] = ACTIONS(4594),
    [anon_sym_SEMI] = ACTIONS(4596),
    [anon_sym_let] = ACTIONS(4594),
    [anon_sym_COMMA] = ACTIONS(4596),
    [anon_sym_LBRACE] = ACTIONS(4596),
    [anon_sym_RBRACE] = ACTIONS(4596),
    [anon_sym_SQUOTE] = ACTIONS(4594),
    [anon_sym_STAR] = ACTIONS(4596),
    [anon_sym_EQ] = ACTIONS(4596),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4596),
    [anon_sym_then] = ACTIONS(4594),
    [anon_sym_using] = ACTIONS(4594),
    [anon_sym_BSLASH] = ACTIONS(4596),
    [anon_sym_if] = ACTIONS(4594),
    [anon_sym_else] = ACTIONS(4594),
    [anon_sym_mdo] = ACTIONS(4594),
    [anon_sym_do] = ACTIONS(4594),
    [anon_sym_case] = ACTIONS(4594),
    [anon_sym_of] = ACTIONS(4594),
    [anon_sym_DASH] = ACTIONS(4594),
    [anon_sym_DASH_GT] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4596),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4596),
    [anon_sym_u27e7] = ACTIONS(4596),
    [anon_sym_u27e6] = ACTIONS(4596),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4596),
    [sym_float] = ACTIONS(4596),
    [sym_char] = ACTIONS(4596),
    [sym_string] = ACTIONS(4596),
    [sym__integer_literal] = ACTIONS(4594),
    [sym__binary_literal] = ACTIONS(4596),
    [sym__octal_literal] = ACTIONS(4596),
    [sym__hex_literal] = ACTIONS(4596),
    [anon_sym_BQUOTE] = ACTIONS(4596),
    [anon_sym_POUND] = ACTIONS(4594),
    [anon_sym_POUND2] = ACTIONS(4594),
    [sym_implicit_variable] = ACTIONS(4596),
    [sym_name] = ACTIONS(4596),
    [sym_label] = ACTIONS(4596),
    [anon_sym_u2192] = ACTIONS(4570),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4572),
    [anon_sym_u22b8] = ACTIONS(4572),
    [anon_sym_COLON_COLON] = ACTIONS(4596),
    [anon_sym_u2237] = ACTIONS(4596),
    [aux_sym__paren_open_token1] = ACTIONS(4596),
    [aux_sym__paren_close_token1] = ACTIONS(4596),
    [anon_sym_RBRACK] = ACTIONS(4596),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4574),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4596),
    [sym__cond_splice] = ACTIONS(4596),
    [sym__cond_tight_dot] = ACTIONS(4596),
    [sym__cond_prefix_dot] = ACTIONS(4596),
    [sym__cond_prefix_at] = ACTIONS(4596),
    [sym__cond_prefix_percent] = ACTIONS(4576),
    [sym__cond_qualified_op] = ACTIONS(4596),
    [sym__cond_no_section_op] = ACTIONS(4596),
    [sym__cond_minus] = ACTIONS(4596),
    [sym__varsym] = ACTIONS(4596),
    [sym__consym] = ACTIONS(4596),
  },
  [2233] = {
    [sym__fun_arrow] = STATE(1675),
    [sym_modifier] = STATE(9901),
    [sym__linear_fun_arrow] = STATE(1683),
    [sym__arrow] = STATE(7944),
    [sym__linear_arrow] = STATE(7941),
    [sym__prefix_percent] = STATE(2611),
    [sym_variable] = ACTIONS(4590),
    [anon_sym_SEMI] = ACTIONS(4592),
    [anon_sym_let] = ACTIONS(4590),
    [anon_sym_COMMA] = ACTIONS(4592),
    [anon_sym_LBRACE] = ACTIONS(4592),
    [anon_sym_RBRACE] = ACTIONS(4592),
    [anon_sym_SQUOTE] = ACTIONS(4590),
    [anon_sym_STAR] = ACTIONS(4592),
    [anon_sym_EQ] = ACTIONS(4592),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4592),
    [anon_sym_then] = ACTIONS(4590),
    [anon_sym_using] = ACTIONS(4590),
    [anon_sym_BSLASH] = ACTIONS(4592),
    [anon_sym_if] = ACTIONS(4590),
    [anon_sym_else] = ACTIONS(4590),
    [anon_sym_mdo] = ACTIONS(4590),
    [anon_sym_do] = ACTIONS(4590),
    [anon_sym_case] = ACTIONS(4590),
    [anon_sym_of] = ACTIONS(4590),
    [anon_sym_DASH] = ACTIONS(4590),
    [anon_sym_DASH_GT] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4592),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4592),
    [anon_sym_u27e7] = ACTIONS(4592),
    [anon_sym_u27e6] = ACTIONS(4592),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4592),
    [sym_float] = ACTIONS(4592),
    [sym_char] = ACTIONS(4592),
    [sym_string] = ACTIONS(4592),
    [sym__integer_literal] = ACTIONS(4590),
    [sym__binary_literal] = ACTIONS(4592),
    [sym__octal_literal] = ACTIONS(4592),
    [sym__hex_literal] = ACTIONS(4592),
    [anon_sym_BQUOTE] = ACTIONS(4592),
    [anon_sym_POUND] = ACTIONS(4590),
    [anon_sym_POUND2] = ACTIONS(4590),
    [sym_implicit_variable] = ACTIONS(4592),
    [sym_name] = ACTIONS(4592),
    [sym_label] = ACTIONS(4592),
    [anon_sym_u2192] = ACTIONS(4570),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4572),
    [anon_sym_u22b8] = ACTIONS(4572),
    [anon_sym_COLON_COLON] = ACTIONS(4592),
    [anon_sym_u2237] = ACTIONS(4592),
    [aux_sym__paren_open_token1] = ACTIONS(4592),
    [aux_sym__paren_close_token1] = ACTIONS(4592),
    [anon_sym_RBRACK] = ACTIONS(4592),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4574),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4592),
    [sym__cond_splice] = ACTIONS(4592),
    [sym__cond_tight_dot] = ACTIONS(4592),
    [sym__cond_prefix_dot] = ACTIONS(4592),
    [sym__cond_prefix_at] = ACTIONS(4592),
    [sym__cond_prefix_percent] = ACTIONS(4576),
    [sym__cond_qualified_op] = ACTIONS(4592),
    [sym__cond_no_section_op] = ACTIONS(4592),
    [sym__cond_minus] = ACTIONS(4592),
    [sym__varsym] = ACTIONS(4592),
    [sym__consym] = ACTIONS(4592),
  },
  [2234] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7968),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1158),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11043),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2497),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(4598),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(4346),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [sym_name] = ACTIONS(4348),
    [anon_sym_COLON_COLON] = ACTIONS(4598),
    [anon_sym_u2237] = ACTIONS(4598),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__paren_close_token1] = ACTIONS(4598),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2235] = {
    [sym__fun_arrow] = STATE(1675),
    [sym_modifier] = STATE(9901),
    [sym__linear_fun_arrow] = STATE(1683),
    [sym__arrow] = STATE(7944),
    [sym__linear_arrow] = STATE(7941),
    [sym__prefix_percent] = STATE(2611),
    [sym_variable] = ACTIONS(4600),
    [anon_sym_SEMI] = ACTIONS(4602),
    [anon_sym_let] = ACTIONS(4600),
    [anon_sym_COMMA] = ACTIONS(4602),
    [anon_sym_LBRACE] = ACTIONS(4602),
    [anon_sym_RBRACE] = ACTIONS(4602),
    [anon_sym_SQUOTE] = ACTIONS(4600),
    [anon_sym_STAR] = ACTIONS(4602),
    [anon_sym_EQ] = ACTIONS(4602),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4602),
    [anon_sym_then] = ACTIONS(4600),
    [anon_sym_using] = ACTIONS(4600),
    [anon_sym_BSLASH] = ACTIONS(4602),
    [anon_sym_if] = ACTIONS(4600),
    [anon_sym_else] = ACTIONS(4600),
    [anon_sym_mdo] = ACTIONS(4600),
    [anon_sym_do] = ACTIONS(4600),
    [anon_sym_case] = ACTIONS(4600),
    [anon_sym_of] = ACTIONS(4600),
    [anon_sym_DASH] = ACTIONS(4600),
    [anon_sym_DASH_GT] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4602),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4602),
    [anon_sym_u27e7] = ACTIONS(4602),
    [anon_sym_u27e6] = ACTIONS(4602),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4602),
    [sym_float] = ACTIONS(4602),
    [sym_char] = ACTIONS(4602),
    [sym_string] = ACTIONS(4602),
    [sym__integer_literal] = ACTIONS(4600),
    [sym__binary_literal] = ACTIONS(4602),
    [sym__octal_literal] = ACTIONS(4602),
    [sym__hex_literal] = ACTIONS(4602),
    [anon_sym_BQUOTE] = ACTIONS(4602),
    [anon_sym_POUND] = ACTIONS(4600),
    [anon_sym_POUND2] = ACTIONS(4600),
    [sym_implicit_variable] = ACTIONS(4602),
    [sym_name] = ACTIONS(4602),
    [sym_label] = ACTIONS(4602),
    [anon_sym_u2192] = ACTIONS(4570),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4572),
    [anon_sym_u22b8] = ACTIONS(4572),
    [anon_sym_COLON_COLON] = ACTIONS(4602),
    [anon_sym_u2237] = ACTIONS(4602),
    [aux_sym__paren_open_token1] = ACTIONS(4602),
    [aux_sym__paren_close_token1] = ACTIONS(4602),
    [anon_sym_RBRACK] = ACTIONS(4602),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4574),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4602),
    [sym__cond_splice] = ACTIONS(4602),
    [sym__cond_tight_dot] = ACTIONS(4602),
    [sym__cond_prefix_dot] = ACTIONS(4602),
    [sym__cond_prefix_at] = ACTIONS(4602),
    [sym__cond_prefix_percent] = ACTIONS(4576),
    [sym__cond_qualified_op] = ACTIONS(4602),
    [sym__cond_no_section_op] = ACTIONS(4602),
    [sym__cond_minus] = ACTIONS(4602),
    [sym__varsym] = ACTIONS(4602),
    [sym__consym] = ACTIONS(4602),
  },
  [2236] = {
    [sym__qual_dot] = STATE(8574),
    [sym__tight_dot] = STATE(8574),
    [sym_variable] = ACTIONS(4604),
    [anon_sym_SEMI] = ACTIONS(4606),
    [anon_sym_let] = ACTIONS(4604),
    [anon_sym_COMMA] = ACTIONS(4606),
    [anon_sym_LBRACE] = ACTIONS(4606),
    [anon_sym_RBRACE] = ACTIONS(4606),
    [anon_sym__] = ACTIONS(4604),
    [anon_sym_SQUOTE] = ACTIONS(4604),
    [anon_sym_STAR] = ACTIONS(4606),
    [anon_sym_u2605] = ACTIONS(4606),
    [anon_sym_EQ] = ACTIONS(4606),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4606),
    [anon_sym_then] = ACTIONS(4604),
    [anon_sym_using] = ACTIONS(4604),
    [anon_sym_BSLASH] = ACTIONS(4606),
    [anon_sym_if] = ACTIONS(4604),
    [anon_sym_else] = ACTIONS(4604),
    [anon_sym_mdo] = ACTIONS(4604),
    [anon_sym_do] = ACTIONS(4604),
    [anon_sym_case] = ACTIONS(4604),
    [anon_sym_of] = ACTIONS(4604),
    [anon_sym_DASH] = ACTIONS(4604),
    [anon_sym_DASH_GT] = ACTIONS(4604),
    [anon_sym_LBRACK] = ACTIONS(4606),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4606),
    [anon_sym_u27e7] = ACTIONS(4606),
    [anon_sym_u27e6] = ACTIONS(4606),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4606),
    [sym_float] = ACTIONS(4606),
    [sym_char] = ACTIONS(4606),
    [sym_string] = ACTIONS(4606),
    [sym__integer_literal] = ACTIONS(4604),
    [sym__binary_literal] = ACTIONS(4606),
    [sym__octal_literal] = ACTIONS(4606),
    [sym__hex_literal] = ACTIONS(4606),
    [anon_sym_BQUOTE] = ACTIONS(4606),
    [anon_sym_POUND] = ACTIONS(4604),
    [anon_sym_POUND2] = ACTIONS(4604),
    [sym_implicit_variable] = ACTIONS(4606),
    [sym_name] = ACTIONS(4606),
    [sym_label] = ACTIONS(4606),
    [anon_sym_u2192] = ACTIONS(4606),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4606),
    [anon_sym_u22b8] = ACTIONS(4606),
    [anon_sym_COLON_COLON] = ACTIONS(4606),
    [anon_sym_u2237] = ACTIONS(4606),
    [aux_sym__paren_open_token1] = ACTIONS(4606),
    [aux_sym__paren_close_token1] = ACTIONS(4606),
    [anon_sym_RBRACK] = ACTIONS(4606),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4606),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4606),
    [sym__cond_splice] = ACTIONS(4606),
    [sym__cond_qual_dot] = ACTIONS(4608),
    [sym__cond_tight_dot] = ACTIONS(4610),
    [sym__cond_prefix_dot] = ACTIONS(4606),
    [sym__cond_prefix_at] = ACTIONS(4606),
    [sym__cond_prefix_percent] = ACTIONS(4606),
    [sym__cond_qualified_op] = ACTIONS(4606),
    [sym__cond_no_section_op] = ACTIONS(4606),
    [sym__cond_minus] = ACTIONS(4606),
    [sym__varsym] = ACTIONS(4606),
    [sym__consym] = ACTIONS(4606),
  },
  [2237] = {
    [sym__qual_dot] = STATE(10227),
    [sym__tight_dot] = STATE(10227),
    [sym_variable] = ACTIONS(4612),
    [anon_sym_SEMI] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4612),
    [anon_sym_COMMA] = ACTIONS(4614),
    [anon_sym_LBRACE] = ACTIONS(4614),
    [anon_sym_RBRACE] = ACTIONS(4614),
    [anon_sym__] = ACTIONS(4612),
    [anon_sym_SQUOTE] = ACTIONS(4612),
    [anon_sym_STAR] = ACTIONS(4614),
    [anon_sym_u2605] = ACTIONS(4614),
    [anon_sym_EQ] = ACTIONS(4614),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4614),
    [anon_sym_then] = ACTIONS(4612),
    [anon_sym_using] = ACTIONS(4612),
    [anon_sym_BSLASH] = ACTIONS(4614),
    [anon_sym_if] = ACTIONS(4612),
    [anon_sym_else] = ACTIONS(4612),
    [anon_sym_mdo] = ACTIONS(4612),
    [anon_sym_do] = ACTIONS(4612),
    [anon_sym_case] = ACTIONS(4612),
    [anon_sym_of] = ACTIONS(4612),
    [anon_sym_DASH] = ACTIONS(4612),
    [anon_sym_DASH_GT] = ACTIONS(4612),
    [anon_sym_LBRACK] = ACTIONS(4614),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4614),
    [anon_sym_u27e7] = ACTIONS(4614),
    [anon_sym_u27e6] = ACTIONS(4614),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4614),
    [sym_float] = ACTIONS(4614),
    [sym_char] = ACTIONS(4614),
    [sym_string] = ACTIONS(4614),
    [sym__integer_literal] = ACTIONS(4612),
    [sym__binary_literal] = ACTIONS(4614),
    [sym__octal_literal] = ACTIONS(4614),
    [sym__hex_literal] = ACTIONS(4614),
    [anon_sym_BQUOTE] = ACTIONS(4614),
    [anon_sym_POUND] = ACTIONS(4612),
    [anon_sym_POUND2] = ACTIONS(4612),
    [sym_implicit_variable] = ACTIONS(4614),
    [sym_name] = ACTIONS(4614),
    [sym_label] = ACTIONS(4614),
    [anon_sym_u2192] = ACTIONS(4614),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4614),
    [anon_sym_u22b8] = ACTIONS(4614),
    [anon_sym_COLON_COLON] = ACTIONS(4614),
    [anon_sym_u2237] = ACTIONS(4614),
    [aux_sym__paren_open_token1] = ACTIONS(4614),
    [aux_sym__paren_close_token1] = ACTIONS(4614),
    [anon_sym_RBRACK] = ACTIONS(4614),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4614),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4614),
    [sym__cond_splice] = ACTIONS(4614),
    [sym__cond_qual_dot] = ACTIONS(4616),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(4614),
    [sym__cond_prefix_at] = ACTIONS(4614),
    [sym__cond_prefix_percent] = ACTIONS(4614),
    [sym__cond_qualified_op] = ACTIONS(4614),
    [sym__cond_no_section_op] = ACTIONS(4614),
    [sym__cond_minus] = ACTIONS(4614),
    [sym__varsym] = ACTIONS(4614),
    [sym__consym] = ACTIONS(4614),
  },
  [2238] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7968),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1158),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11043),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__carrow] = STATE(10044),
    [sym__prefix_at] = STATE(2497),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(4346),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [sym_name] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4618),
    [anon_sym_u21d2] = ACTIONS(4618),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2239] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7968),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1158),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11043),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__carrow] = STATE(10989),
    [sym__prefix_at] = STATE(2497),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(4346),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [sym_name] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4620),
    [anon_sym_u21d2] = ACTIONS(4620),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2240] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7968),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1158),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11043),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__carrow] = STATE(8154),
    [sym__prefix_at] = STATE(2497),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(4346),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [sym_name] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4622),
    [anon_sym_u21d2] = ACTIONS(4622),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2241] = {
    [sym__qual_dot] = STATE(8574),
    [sym__tight_dot] = STATE(8574),
    [sym_variable] = ACTIONS(4624),
    [anon_sym_SEMI] = ACTIONS(4626),
    [anon_sym_let] = ACTIONS(4624),
    [anon_sym_COMMA] = ACTIONS(4626),
    [anon_sym_LBRACE] = ACTIONS(4626),
    [anon_sym_RBRACE] = ACTIONS(4626),
    [anon_sym__] = ACTIONS(4624),
    [anon_sym_SQUOTE] = ACTIONS(4624),
    [anon_sym_STAR] = ACTIONS(4626),
    [anon_sym_u2605] = ACTIONS(4626),
    [anon_sym_EQ] = ACTIONS(4626),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4626),
    [anon_sym_then] = ACTIONS(4624),
    [anon_sym_using] = ACTIONS(4624),
    [anon_sym_BSLASH] = ACTIONS(4626),
    [anon_sym_if] = ACTIONS(4624),
    [anon_sym_else] = ACTIONS(4624),
    [anon_sym_mdo] = ACTIONS(4624),
    [anon_sym_do] = ACTIONS(4624),
    [anon_sym_case] = ACTIONS(4624),
    [anon_sym_of] = ACTIONS(4624),
    [anon_sym_DASH] = ACTIONS(4624),
    [anon_sym_DASH_GT] = ACTIONS(4624),
    [anon_sym_LBRACK] = ACTIONS(4626),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4626),
    [anon_sym_u27e7] = ACTIONS(4626),
    [anon_sym_u27e6] = ACTIONS(4626),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4626),
    [sym_float] = ACTIONS(4626),
    [sym_char] = ACTIONS(4626),
    [sym_string] = ACTIONS(4626),
    [sym__integer_literal] = ACTIONS(4624),
    [sym__binary_literal] = ACTIONS(4626),
    [sym__octal_literal] = ACTIONS(4626),
    [sym__hex_literal] = ACTIONS(4626),
    [anon_sym_BQUOTE] = ACTIONS(4626),
    [anon_sym_POUND] = ACTIONS(4624),
    [anon_sym_POUND2] = ACTIONS(4624),
    [sym_implicit_variable] = ACTIONS(4626),
    [sym_name] = ACTIONS(4626),
    [sym_label] = ACTIONS(4626),
    [anon_sym_u2192] = ACTIONS(4626),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4626),
    [anon_sym_u22b8] = ACTIONS(4626),
    [anon_sym_COLON_COLON] = ACTIONS(4626),
    [anon_sym_u2237] = ACTIONS(4626),
    [aux_sym__paren_open_token1] = ACTIONS(4626),
    [aux_sym__paren_close_token1] = ACTIONS(4626),
    [anon_sym_RBRACK] = ACTIONS(4626),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4626),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4626),
    [sym__cond_splice] = ACTIONS(4626),
    [sym__cond_qual_dot] = ACTIONS(4608),
    [sym__cond_tight_dot] = ACTIONS(4610),
    [sym__cond_prefix_dot] = ACTIONS(4626),
    [sym__cond_prefix_at] = ACTIONS(4626),
    [sym__cond_prefix_percent] = ACTIONS(4626),
    [sym__cond_qualified_op] = ACTIONS(4626),
    [sym__cond_no_section_op] = ACTIONS(4626),
    [sym__cond_minus] = ACTIONS(4626),
    [sym__varsym] = ACTIONS(4626),
    [sym__consym] = ACTIONS(4626),
  },
  [2242] = {
    [sym__qual_dot] = STATE(10227),
    [sym__tight_dot] = STATE(10227),
    [sym_variable] = ACTIONS(4628),
    [anon_sym_SEMI] = ACTIONS(4630),
    [anon_sym_let] = ACTIONS(4628),
    [anon_sym_COMMA] = ACTIONS(4630),
    [anon_sym_LBRACE] = ACTIONS(4630),
    [anon_sym_RBRACE] = ACTIONS(4630),
    [anon_sym__] = ACTIONS(4628),
    [anon_sym_SQUOTE] = ACTIONS(4628),
    [anon_sym_STAR] = ACTIONS(4630),
    [anon_sym_u2605] = ACTIONS(4630),
    [anon_sym_EQ] = ACTIONS(4630),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4630),
    [anon_sym_then] = ACTIONS(4628),
    [anon_sym_using] = ACTIONS(4628),
    [anon_sym_BSLASH] = ACTIONS(4630),
    [anon_sym_if] = ACTIONS(4628),
    [anon_sym_else] = ACTIONS(4628),
    [anon_sym_mdo] = ACTIONS(4628),
    [anon_sym_do] = ACTIONS(4628),
    [anon_sym_case] = ACTIONS(4628),
    [anon_sym_of] = ACTIONS(4628),
    [anon_sym_DASH] = ACTIONS(4628),
    [anon_sym_DASH_GT] = ACTIONS(4628),
    [anon_sym_LBRACK] = ACTIONS(4630),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4630),
    [anon_sym_u27e7] = ACTIONS(4630),
    [anon_sym_u27e6] = ACTIONS(4630),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4630),
    [sym_float] = ACTIONS(4630),
    [sym_char] = ACTIONS(4630),
    [sym_string] = ACTIONS(4630),
    [sym__integer_literal] = ACTIONS(4628),
    [sym__binary_literal] = ACTIONS(4630),
    [sym__octal_literal] = ACTIONS(4630),
    [sym__hex_literal] = ACTIONS(4630),
    [anon_sym_BQUOTE] = ACTIONS(4630),
    [anon_sym_POUND] = ACTIONS(4628),
    [anon_sym_POUND2] = ACTIONS(4628),
    [sym_implicit_variable] = ACTIONS(4630),
    [sym_name] = ACTIONS(4630),
    [sym_label] = ACTIONS(4630),
    [anon_sym_u2192] = ACTIONS(4630),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4630),
    [anon_sym_u22b8] = ACTIONS(4630),
    [anon_sym_COLON_COLON] = ACTIONS(4630),
    [anon_sym_u2237] = ACTIONS(4630),
    [aux_sym__paren_open_token1] = ACTIONS(4630),
    [aux_sym__paren_close_token1] = ACTIONS(4630),
    [anon_sym_RBRACK] = ACTIONS(4630),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4630),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4630),
    [sym__cond_splice] = ACTIONS(4630),
    [sym__cond_qual_dot] = ACTIONS(4616),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(4630),
    [sym__cond_prefix_at] = ACTIONS(4630),
    [sym__cond_prefix_percent] = ACTIONS(4630),
    [sym__cond_qualified_op] = ACTIONS(4630),
    [sym__cond_no_section_op] = ACTIONS(4630),
    [sym__cond_minus] = ACTIONS(4630),
    [sym__varsym] = ACTIONS(4630),
    [sym__consym] = ACTIONS(4630),
  },
  [2243] = {
    [sym__qual_dot] = STATE(10227),
    [sym__tight_dot] = STATE(10227),
    [sym_variable] = ACTIONS(4604),
    [anon_sym_SEMI] = ACTIONS(4606),
    [anon_sym_let] = ACTIONS(4604),
    [anon_sym_COMMA] = ACTIONS(4606),
    [anon_sym_LBRACE] = ACTIONS(4606),
    [anon_sym_RBRACE] = ACTIONS(4606),
    [anon_sym__] = ACTIONS(4604),
    [anon_sym_SQUOTE] = ACTIONS(4604),
    [anon_sym_STAR] = ACTIONS(4606),
    [anon_sym_u2605] = ACTIONS(4606),
    [anon_sym_EQ] = ACTIONS(4606),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4606),
    [anon_sym_then] = ACTIONS(4604),
    [anon_sym_using] = ACTIONS(4604),
    [anon_sym_BSLASH] = ACTIONS(4606),
    [anon_sym_if] = ACTIONS(4604),
    [anon_sym_else] = ACTIONS(4604),
    [anon_sym_mdo] = ACTIONS(4604),
    [anon_sym_do] = ACTIONS(4604),
    [anon_sym_case] = ACTIONS(4604),
    [anon_sym_of] = ACTIONS(4604),
    [anon_sym_DASH] = ACTIONS(4604),
    [anon_sym_DASH_GT] = ACTIONS(4604),
    [anon_sym_LBRACK] = ACTIONS(4606),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4606),
    [anon_sym_u27e7] = ACTIONS(4606),
    [anon_sym_u27e6] = ACTIONS(4606),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4606),
    [sym_float] = ACTIONS(4606),
    [sym_char] = ACTIONS(4606),
    [sym_string] = ACTIONS(4606),
    [sym__integer_literal] = ACTIONS(4604),
    [sym__binary_literal] = ACTIONS(4606),
    [sym__octal_literal] = ACTIONS(4606),
    [sym__hex_literal] = ACTIONS(4606),
    [anon_sym_BQUOTE] = ACTIONS(4606),
    [anon_sym_POUND] = ACTIONS(4604),
    [anon_sym_POUND2] = ACTIONS(4604),
    [sym_implicit_variable] = ACTIONS(4606),
    [sym_name] = ACTIONS(4606),
    [sym_label] = ACTIONS(4606),
    [anon_sym_u2192] = ACTIONS(4606),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4606),
    [anon_sym_u22b8] = ACTIONS(4606),
    [anon_sym_COLON_COLON] = ACTIONS(4606),
    [anon_sym_u2237] = ACTIONS(4606),
    [aux_sym__paren_open_token1] = ACTIONS(4606),
    [aux_sym__paren_close_token1] = ACTIONS(4606),
    [anon_sym_RBRACK] = ACTIONS(4606),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4606),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4606),
    [sym__cond_splice] = ACTIONS(4606),
    [sym__cond_qual_dot] = ACTIONS(4616),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(4606),
    [sym__cond_prefix_at] = ACTIONS(4606),
    [sym__cond_prefix_percent] = ACTIONS(4606),
    [sym__cond_qualified_op] = ACTIONS(4606),
    [sym__cond_no_section_op] = ACTIONS(4606),
    [sym__cond_minus] = ACTIONS(4606),
    [sym__varsym] = ACTIONS(4606),
    [sym__consym] = ACTIONS(4606),
  },
  [2244] = {
    [sym__qual_dot] = STATE(10227),
    [sym__tight_dot] = STATE(10227),
    [sym_variable] = ACTIONS(4632),
    [anon_sym_SEMI] = ACTIONS(4634),
    [anon_sym_let] = ACTIONS(4632),
    [anon_sym_COMMA] = ACTIONS(4634),
    [anon_sym_LBRACE] = ACTIONS(4634),
    [anon_sym_RBRACE] = ACTIONS(4634),
    [anon_sym__] = ACTIONS(4632),
    [anon_sym_SQUOTE] = ACTIONS(4632),
    [anon_sym_STAR] = ACTIONS(4634),
    [anon_sym_u2605] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(4634),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4634),
    [anon_sym_then] = ACTIONS(4632),
    [anon_sym_using] = ACTIONS(4632),
    [anon_sym_BSLASH] = ACTIONS(4634),
    [anon_sym_if] = ACTIONS(4632),
    [anon_sym_else] = ACTIONS(4632),
    [anon_sym_mdo] = ACTIONS(4632),
    [anon_sym_do] = ACTIONS(4632),
    [anon_sym_case] = ACTIONS(4632),
    [anon_sym_of] = ACTIONS(4632),
    [anon_sym_DASH] = ACTIONS(4632),
    [anon_sym_DASH_GT] = ACTIONS(4632),
    [anon_sym_LBRACK] = ACTIONS(4634),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4634),
    [anon_sym_u27e7] = ACTIONS(4634),
    [anon_sym_u27e6] = ACTIONS(4634),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4634),
    [sym_float] = ACTIONS(4634),
    [sym_char] = ACTIONS(4634),
    [sym_string] = ACTIONS(4634),
    [sym__integer_literal] = ACTIONS(4632),
    [sym__binary_literal] = ACTIONS(4634),
    [sym__octal_literal] = ACTIONS(4634),
    [sym__hex_literal] = ACTIONS(4634),
    [anon_sym_BQUOTE] = ACTIONS(4634),
    [anon_sym_POUND] = ACTIONS(4632),
    [anon_sym_POUND2] = ACTIONS(4632),
    [sym_implicit_variable] = ACTIONS(4634),
    [sym_name] = ACTIONS(4634),
    [sym_label] = ACTIONS(4634),
    [anon_sym_u2192] = ACTIONS(4634),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4634),
    [anon_sym_u22b8] = ACTIONS(4634),
    [anon_sym_COLON_COLON] = ACTIONS(4634),
    [anon_sym_u2237] = ACTIONS(4634),
    [aux_sym__paren_open_token1] = ACTIONS(4634),
    [aux_sym__paren_close_token1] = ACTIONS(4634),
    [anon_sym_RBRACK] = ACTIONS(4634),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4634),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4634),
    [sym__cond_splice] = ACTIONS(4634),
    [sym__cond_qual_dot] = ACTIONS(4616),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(4634),
    [sym__cond_prefix_at] = ACTIONS(4634),
    [sym__cond_prefix_percent] = ACTIONS(4634),
    [sym__cond_qualified_op] = ACTIONS(4634),
    [sym__cond_no_section_op] = ACTIONS(4634),
    [sym__cond_minus] = ACTIONS(4634),
    [sym__varsym] = ACTIONS(4634),
    [sym__consym] = ACTIONS(4634),
  },
  [2245] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(8047),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1371),
    [sym_type_patterns] = STATE(12718),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11043),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__prefix_at] = STATE(2497),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [aux_sym_type_patterns_repeat1] = STATE(2221),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(4346),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_EQ] = ACTIONS(4636),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [sym_name] = ACTIONS(4348),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2246] = {
    [sym__qual_dot] = STATE(8574),
    [sym__tight_dot] = STATE(8574),
    [sym_variable] = ACTIONS(4632),
    [anon_sym_SEMI] = ACTIONS(4634),
    [anon_sym_let] = ACTIONS(4632),
    [anon_sym_COMMA] = ACTIONS(4634),
    [anon_sym_LBRACE] = ACTIONS(4634),
    [anon_sym_RBRACE] = ACTIONS(4634),
    [anon_sym__] = ACTIONS(4632),
    [anon_sym_SQUOTE] = ACTIONS(4632),
    [anon_sym_STAR] = ACTIONS(4634),
    [anon_sym_u2605] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(4634),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4634),
    [anon_sym_then] = ACTIONS(4632),
    [anon_sym_using] = ACTIONS(4632),
    [anon_sym_BSLASH] = ACTIONS(4634),
    [anon_sym_if] = ACTIONS(4632),
    [anon_sym_else] = ACTIONS(4632),
    [anon_sym_mdo] = ACTIONS(4632),
    [anon_sym_do] = ACTIONS(4632),
    [anon_sym_case] = ACTIONS(4632),
    [anon_sym_of] = ACTIONS(4632),
    [anon_sym_DASH] = ACTIONS(4632),
    [anon_sym_DASH_GT] = ACTIONS(4632),
    [anon_sym_LBRACK] = ACTIONS(4634),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4634),
    [anon_sym_u27e7] = ACTIONS(4634),
    [anon_sym_u27e6] = ACTIONS(4634),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4634),
    [sym_float] = ACTIONS(4634),
    [sym_char] = ACTIONS(4634),
    [sym_string] = ACTIONS(4634),
    [sym__integer_literal] = ACTIONS(4632),
    [sym__binary_literal] = ACTIONS(4634),
    [sym__octal_literal] = ACTIONS(4634),
    [sym__hex_literal] = ACTIONS(4634),
    [anon_sym_BQUOTE] = ACTIONS(4634),
    [anon_sym_POUND] = ACTIONS(4632),
    [anon_sym_POUND2] = ACTIONS(4632),
    [sym_implicit_variable] = ACTIONS(4634),
    [sym_name] = ACTIONS(4634),
    [sym_label] = ACTIONS(4634),
    [anon_sym_u2192] = ACTIONS(4634),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4634),
    [anon_sym_u22b8] = ACTIONS(4634),
    [anon_sym_COLON_COLON] = ACTIONS(4634),
    [anon_sym_u2237] = ACTIONS(4634),
    [aux_sym__paren_open_token1] = ACTIONS(4634),
    [aux_sym__paren_close_token1] = ACTIONS(4634),
    [anon_sym_RBRACK] = ACTIONS(4634),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4634),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4634),
    [sym__cond_splice] = ACTIONS(4634),
    [sym__cond_qual_dot] = ACTIONS(4608),
    [sym__cond_tight_dot] = ACTIONS(4610),
    [sym__cond_prefix_dot] = ACTIONS(4634),
    [sym__cond_prefix_at] = ACTIONS(4634),
    [sym__cond_prefix_percent] = ACTIONS(4634),
    [sym__cond_qualified_op] = ACTIONS(4634),
    [sym__cond_no_section_op] = ACTIONS(4634),
    [sym__cond_minus] = ACTIONS(4634),
    [sym__varsym] = ACTIONS(4634),
    [sym__consym] = ACTIONS(4634),
  },
  [2247] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7968),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1158),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11043),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__carrow] = STATE(7881),
    [sym__prefix_at] = STATE(2497),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(4346),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [sym_name] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4638),
    [anon_sym_u21d2] = ACTIONS(4638),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2248] = {
    [sym__qual_dot] = STATE(8574),
    [sym__tight_dot] = STATE(8574),
    [sym_variable] = ACTIONS(4612),
    [anon_sym_SEMI] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4612),
    [anon_sym_COMMA] = ACTIONS(4614),
    [anon_sym_LBRACE] = ACTIONS(4614),
    [anon_sym_RBRACE] = ACTIONS(4614),
    [anon_sym__] = ACTIONS(4612),
    [anon_sym_SQUOTE] = ACTIONS(4612),
    [anon_sym_STAR] = ACTIONS(4614),
    [anon_sym_u2605] = ACTIONS(4614),
    [anon_sym_EQ] = ACTIONS(4614),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4614),
    [anon_sym_then] = ACTIONS(4612),
    [anon_sym_using] = ACTIONS(4612),
    [anon_sym_BSLASH] = ACTIONS(4614),
    [anon_sym_if] = ACTIONS(4612),
    [anon_sym_else] = ACTIONS(4612),
    [anon_sym_mdo] = ACTIONS(4612),
    [anon_sym_do] = ACTIONS(4612),
    [anon_sym_case] = ACTIONS(4612),
    [anon_sym_of] = ACTIONS(4612),
    [anon_sym_DASH] = ACTIONS(4612),
    [anon_sym_DASH_GT] = ACTIONS(4612),
    [anon_sym_LBRACK] = ACTIONS(4614),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4614),
    [anon_sym_u27e7] = ACTIONS(4614),
    [anon_sym_u27e6] = ACTIONS(4614),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4614),
    [sym_float] = ACTIONS(4614),
    [sym_char] = ACTIONS(4614),
    [sym_string] = ACTIONS(4614),
    [sym__integer_literal] = ACTIONS(4612),
    [sym__binary_literal] = ACTIONS(4614),
    [sym__octal_literal] = ACTIONS(4614),
    [sym__hex_literal] = ACTIONS(4614),
    [anon_sym_BQUOTE] = ACTIONS(4614),
    [anon_sym_POUND] = ACTIONS(4612),
    [anon_sym_POUND2] = ACTIONS(4612),
    [sym_implicit_variable] = ACTIONS(4614),
    [sym_name] = ACTIONS(4614),
    [sym_label] = ACTIONS(4614),
    [anon_sym_u2192] = ACTIONS(4614),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4614),
    [anon_sym_u22b8] = ACTIONS(4614),
    [anon_sym_COLON_COLON] = ACTIONS(4614),
    [anon_sym_u2237] = ACTIONS(4614),
    [aux_sym__paren_open_token1] = ACTIONS(4614),
    [aux_sym__paren_close_token1] = ACTIONS(4614),
    [anon_sym_RBRACK] = ACTIONS(4614),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4614),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4614),
    [sym__cond_splice] = ACTIONS(4614),
    [sym__cond_qual_dot] = ACTIONS(4608),
    [sym__cond_tight_dot] = ACTIONS(4610),
    [sym__cond_prefix_dot] = ACTIONS(4614),
    [sym__cond_prefix_at] = ACTIONS(4614),
    [sym__cond_prefix_percent] = ACTIONS(4614),
    [sym__cond_qualified_op] = ACTIONS(4614),
    [sym__cond_no_section_op] = ACTIONS(4614),
    [sym__cond_minus] = ACTIONS(4614),
    [sym__varsym] = ACTIONS(4614),
    [sym__consym] = ACTIONS(4614),
  },
  [2249] = {
    [sym__qual_dot] = STATE(10227),
    [sym__tight_dot] = STATE(10227),
    [sym_variable] = ACTIONS(4624),
    [anon_sym_SEMI] = ACTIONS(4626),
    [anon_sym_let] = ACTIONS(4624),
    [anon_sym_COMMA] = ACTIONS(4626),
    [anon_sym_LBRACE] = ACTIONS(4626),
    [anon_sym_RBRACE] = ACTIONS(4626),
    [anon_sym__] = ACTIONS(4624),
    [anon_sym_SQUOTE] = ACTIONS(4624),
    [anon_sym_STAR] = ACTIONS(4626),
    [anon_sym_u2605] = ACTIONS(4626),
    [anon_sym_EQ] = ACTIONS(4626),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4626),
    [anon_sym_then] = ACTIONS(4624),
    [anon_sym_using] = ACTIONS(4624),
    [anon_sym_BSLASH] = ACTIONS(4626),
    [anon_sym_if] = ACTIONS(4624),
    [anon_sym_else] = ACTIONS(4624),
    [anon_sym_mdo] = ACTIONS(4624),
    [anon_sym_do] = ACTIONS(4624),
    [anon_sym_case] = ACTIONS(4624),
    [anon_sym_of] = ACTIONS(4624),
    [anon_sym_DASH] = ACTIONS(4624),
    [anon_sym_DASH_GT] = ACTIONS(4624),
    [anon_sym_LBRACK] = ACTIONS(4626),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4626),
    [anon_sym_u27e7] = ACTIONS(4626),
    [anon_sym_u27e6] = ACTIONS(4626),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4626),
    [sym_float] = ACTIONS(4626),
    [sym_char] = ACTIONS(4626),
    [sym_string] = ACTIONS(4626),
    [sym__integer_literal] = ACTIONS(4624),
    [sym__binary_literal] = ACTIONS(4626),
    [sym__octal_literal] = ACTIONS(4626),
    [sym__hex_literal] = ACTIONS(4626),
    [anon_sym_BQUOTE] = ACTIONS(4626),
    [anon_sym_POUND] = ACTIONS(4624),
    [anon_sym_POUND2] = ACTIONS(4624),
    [sym_implicit_variable] = ACTIONS(4626),
    [sym_name] = ACTIONS(4626),
    [sym_label] = ACTIONS(4626),
    [anon_sym_u2192] = ACTIONS(4626),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4626),
    [anon_sym_u22b8] = ACTIONS(4626),
    [anon_sym_COLON_COLON] = ACTIONS(4626),
    [anon_sym_u2237] = ACTIONS(4626),
    [aux_sym__paren_open_token1] = ACTIONS(4626),
    [aux_sym__paren_close_token1] = ACTIONS(4626),
    [anon_sym_RBRACK] = ACTIONS(4626),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4626),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4626),
    [sym__cond_splice] = ACTIONS(4626),
    [sym__cond_qual_dot] = ACTIONS(4616),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(4626),
    [sym__cond_prefix_at] = ACTIONS(4626),
    [sym__cond_prefix_percent] = ACTIONS(4626),
    [sym__cond_qualified_op] = ACTIONS(4626),
    [sym__cond_no_section_op] = ACTIONS(4626),
    [sym__cond_minus] = ACTIONS(4626),
    [sym__varsym] = ACTIONS(4626),
    [sym__consym] = ACTIONS(4626),
  },
  [2250] = {
    [sym__type_parens] = STATE(7302),
    [sym__type_tuple] = STATE(7305),
    [sym__type_unboxed_tuple] = STATE(7308),
    [sym__type_unboxed_sum] = STATE(7318),
    [sym__type_list] = STATE(7353),
    [sym__type_promoted] = STATE(7300),
    [sym__type_star] = STATE(7300),
    [sym__type_wildcard] = STATE(7300),
    [sym__at_type] = STATE(7968),
    [sym__type_apply] = STATE(7359),
    [sym__type_infix] = STATE(7368),
    [sym_type] = STATE(1158),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11043),
    [sym__splice_dollars] = STATE(7486),
    [sym_splice] = STATE(7300),
    [sym_quasiquote] = STATE(7300),
    [sym_integer] = STATE(7361),
    [sym__plist] = STATE(7383),
    [sym_unit] = STATE(7300),
    [sym_unboxed_unit] = STATE(7300),
    [sym_prefix_tuple] = STATE(7300),
    [sym_prefix_unboxed_tuple] = STATE(7300),
    [sym_prefix_unboxed_sum] = STATE(7300),
    [sym_literal] = STATE(7300),
    [sym__qualified_type] = STATE(7229),
    [sym__qtyconid] = STATE(7439),
    [sym__tycon_arrow] = STATE(7439),
    [sym__qtycon_arrow] = STATE(7439),
    [sym__promoted_tycons_alias] = STATE(7300),
    [sym__promoted_tycons] = STATE(7300),
    [sym__varsym_prefix] = STATE(7439),
    [sym__pvarsym] = STATE(7439),
    [sym__qvarsym_prefix] = STATE(7439),
    [sym__pqvarsym] = STATE(7439),
    [sym__consym_prefix] = STATE(7439),
    [sym__pconsym] = STATE(7439),
    [sym__qconsym_prefix] = STATE(7439),
    [sym__pqconsym] = STATE(7439),
    [sym__carrow] = STATE(9641),
    [sym__prefix_at] = STATE(2497),
    [sym__paren_open] = STATE(439),
    [sym__bracket_open] = STATE(955),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = ACTIONS(2923),
    [anon_sym__] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(4346),
    [anon_sym_STAR] = ACTIONS(2931),
    [anon_sym_u2605] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2933),
    [sym_char] = ACTIONS(2933),
    [sym_string] = ACTIONS(2933),
    [sym__integer_literal] = ACTIONS(2935),
    [sym__binary_literal] = ACTIONS(2937),
    [sym__octal_literal] = ACTIONS(2937),
    [sym__hex_literal] = ACTIONS(2937),
    [sym_name] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4640),
    [anon_sym_u21d2] = ACTIONS(4640),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2941),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_prefix_at] = ACTIONS(325),
  },
  [2251] = {
    [sym__pat_parens] = STATE(6709),
    [sym__pat_tuple] = STATE(6707),
    [sym__pat_unboxed_tuple] = STATE(6706),
    [sym__pat_unboxed_sum] = STATE(6705),
    [sym__pat_list] = STATE(6704),
    [sym__pat_record] = STATE(6703),
    [sym__pat_as] = STATE(6702),
    [sym__pat_wildcard] = STATE(6701),
    [sym__pat_strict] = STATE(6700),
    [sym__pat_irrefutable] = STATE(6699),
    [sym__pat_apply] = STATE(6772),
    [sym__pat_negation] = STATE(6711),
    [sym__pat_infix] = STATE(6715),
    [sym_pattern] = STATE(1393),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11259),
    [sym__splice_dollars] = STATE(7313),
    [sym_splice] = STATE(6701),
    [sym_quasiquote] = STATE(6701),
    [sym_integer] = STATE(6231),
    [sym__plist] = STATE(6728),
    [sym_unit] = STATE(6701),
    [sym_unboxed_unit] = STATE(6701),
    [sym_prefix_tuple] = STATE(6701),
    [sym_prefix_unboxed_tuple] = STATE(6701),
    [sym_prefix_unboxed_sum] = STATE(6701),
    [sym_literal] = STATE(6701),
    [sym__qualified_constructor] = STATE(6223),
    [sym__qconid] = STATE(6701),
    [sym__varsym_prefix] = STATE(6729),
    [sym__pvarsym] = STATE(6729),
    [sym__consym_prefix] = STATE(6731),
    [sym__pconsym] = STATE(6731),
    [sym__qconsym_prefix] = STATE(6701),
    [sym__pqconsym] = STATE(6701),
    [sym__prefix_bang] = STATE(2257),
    [sym__tight_bang] = STATE(2257),
    [sym__any_prefix_bang] = STATE(2257),
    [sym__prefix_tilde] = STATE(2258),
    [sym__tight_tilde] = STATE(2258),
    [sym__any_prefix_tilde] = STATE(2258),
    [sym__paren_open] = STATE(45),
    [sym__bracket_open] = STATE(369),
    [sym__unboxed_open] = STATE(193),
    [sym_variable] = ACTIONS(2801),
    [anon_sym__] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2467),
    [sym_char] = ACTIONS(2467),
    [sym_string] = ACTIONS(2467),
    [sym__integer_literal] = ACTIONS(2469),
    [sym__binary_literal] = ACTIONS(2471),
    [sym__octal_literal] = ACTIONS(2471),
    [sym__hex_literal] = ACTIONS(2471),
    [sym_name] = ACTIONS(2807),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2475),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2252] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(1209),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(6638),
    [sym__pvarsym] = STATE(6638),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(48),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(2713),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2253] = {
    [sym__pat_parens] = STATE(7041),
    [sym__pat_tuple] = STATE(7042),
    [sym__pat_unboxed_tuple] = STATE(7043),
    [sym__pat_unboxed_sum] = STATE(7044),
    [sym__pat_list] = STATE(7045),
    [sym__pat_record] = STATE(7046),
    [sym__pat_as] = STATE(7047),
    [sym__pat_wildcard] = STATE(7048),
    [sym__pat_strict] = STATE(7049),
    [sym__pat_irrefutable] = STATE(7050),
    [sym__pat_apply] = STATE(7051),
    [sym__pat_negation] = STATE(7052),
    [sym__pat_infix] = STATE(7053),
    [sym_pattern] = STATE(1771),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11245),
    [sym__splice_dollars] = STATE(7422),
    [sym_splice] = STATE(7048),
    [sym_quasiquote] = STATE(7048),
    [sym_integer] = STATE(7199),
    [sym__plist] = STATE(7057),
    [sym_unit] = STATE(7048),
    [sym_unboxed_unit] = STATE(7048),
    [sym_prefix_tuple] = STATE(7048),
    [sym_prefix_unboxed_tuple] = STATE(7048),
    [sym_prefix_unboxed_sum] = STATE(7048),
    [sym_literal] = STATE(7048),
    [sym__qualified_constructor] = STATE(7189),
    [sym__qconid] = STATE(7048),
    [sym__varsym_prefix] = STATE(7058),
    [sym__pvarsym] = STATE(7058),
    [sym__consym_prefix] = STATE(7059),
    [sym__pconsym] = STATE(7059),
    [sym__qconsym_prefix] = STATE(7048),
    [sym__pqconsym] = STATE(7048),
    [sym__prefix_bang] = STATE(2256),
    [sym__tight_bang] = STATE(2256),
    [sym__any_prefix_bang] = STATE(2256),
    [sym__prefix_tilde] = STATE(2253),
    [sym__tight_tilde] = STATE(2253),
    [sym__any_prefix_tilde] = STATE(2253),
    [sym__paren_open] = STATE(47),
    [sym__bracket_open] = STATE(364),
    [sym__unboxed_open] = STATE(202),
    [sym_variable] = ACTIONS(3473),
    [anon_sym__] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3481),
    [sym_char] = ACTIONS(3481),
    [sym_string] = ACTIONS(3481),
    [sym__integer_literal] = ACTIONS(3483),
    [sym__binary_literal] = ACTIONS(3485),
    [sym__octal_literal] = ACTIONS(3485),
    [sym__hex_literal] = ACTIONS(3485),
    [sym_name] = ACTIONS(3487),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3493),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2254] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1803),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2255] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1797),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2256] = {
    [sym__pat_parens] = STATE(7041),
    [sym__pat_tuple] = STATE(7042),
    [sym__pat_unboxed_tuple] = STATE(7043),
    [sym__pat_unboxed_sum] = STATE(7044),
    [sym__pat_list] = STATE(7045),
    [sym__pat_record] = STATE(7046),
    [sym__pat_as] = STATE(7047),
    [sym__pat_wildcard] = STATE(7048),
    [sym__pat_strict] = STATE(7049),
    [sym__pat_irrefutable] = STATE(7050),
    [sym__pat_apply] = STATE(7051),
    [sym__pat_negation] = STATE(7052),
    [sym__pat_infix] = STATE(7053),
    [sym_pattern] = STATE(1770),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11245),
    [sym__splice_dollars] = STATE(7422),
    [sym_splice] = STATE(7048),
    [sym_quasiquote] = STATE(7048),
    [sym_integer] = STATE(7199),
    [sym__plist] = STATE(7057),
    [sym_unit] = STATE(7048),
    [sym_unboxed_unit] = STATE(7048),
    [sym_prefix_tuple] = STATE(7048),
    [sym_prefix_unboxed_tuple] = STATE(7048),
    [sym_prefix_unboxed_sum] = STATE(7048),
    [sym_literal] = STATE(7048),
    [sym__qualified_constructor] = STATE(7189),
    [sym__qconid] = STATE(7048),
    [sym__varsym_prefix] = STATE(7058),
    [sym__pvarsym] = STATE(7058),
    [sym__consym_prefix] = STATE(7059),
    [sym__pconsym] = STATE(7059),
    [sym__qconsym_prefix] = STATE(7048),
    [sym__pqconsym] = STATE(7048),
    [sym__prefix_bang] = STATE(2256),
    [sym__tight_bang] = STATE(2256),
    [sym__any_prefix_bang] = STATE(2256),
    [sym__prefix_tilde] = STATE(2253),
    [sym__tight_tilde] = STATE(2253),
    [sym__any_prefix_tilde] = STATE(2253),
    [sym__paren_open] = STATE(47),
    [sym__bracket_open] = STATE(364),
    [sym__unboxed_open] = STATE(202),
    [sym_variable] = ACTIONS(3473),
    [anon_sym__] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3481),
    [sym_char] = ACTIONS(3481),
    [sym_string] = ACTIONS(3481),
    [sym__integer_literal] = ACTIONS(3483),
    [sym__binary_literal] = ACTIONS(3485),
    [sym__octal_literal] = ACTIONS(3485),
    [sym__hex_literal] = ACTIONS(3485),
    [sym_name] = ACTIONS(3487),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3493),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2257] = {
    [sym__pat_parens] = STATE(6709),
    [sym__pat_tuple] = STATE(6707),
    [sym__pat_unboxed_tuple] = STATE(6706),
    [sym__pat_unboxed_sum] = STATE(6705),
    [sym__pat_list] = STATE(6704),
    [sym__pat_record] = STATE(6703),
    [sym__pat_as] = STATE(6702),
    [sym__pat_wildcard] = STATE(6701),
    [sym__pat_strict] = STATE(6700),
    [sym__pat_irrefutable] = STATE(6699),
    [sym__pat_apply] = STATE(6772),
    [sym__pat_negation] = STATE(6711),
    [sym__pat_infix] = STATE(6715),
    [sym_pattern] = STATE(1363),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11259),
    [sym__splice_dollars] = STATE(7313),
    [sym_splice] = STATE(6701),
    [sym_quasiquote] = STATE(6701),
    [sym_integer] = STATE(6231),
    [sym__plist] = STATE(6728),
    [sym_unit] = STATE(6701),
    [sym_unboxed_unit] = STATE(6701),
    [sym_prefix_tuple] = STATE(6701),
    [sym_prefix_unboxed_tuple] = STATE(6701),
    [sym_prefix_unboxed_sum] = STATE(6701),
    [sym_literal] = STATE(6701),
    [sym__qualified_constructor] = STATE(6223),
    [sym__qconid] = STATE(6701),
    [sym__varsym_prefix] = STATE(6729),
    [sym__pvarsym] = STATE(6729),
    [sym__consym_prefix] = STATE(6731),
    [sym__pconsym] = STATE(6731),
    [sym__qconsym_prefix] = STATE(6701),
    [sym__pqconsym] = STATE(6701),
    [sym__prefix_bang] = STATE(2257),
    [sym__tight_bang] = STATE(2257),
    [sym__any_prefix_bang] = STATE(2257),
    [sym__prefix_tilde] = STATE(2258),
    [sym__tight_tilde] = STATE(2258),
    [sym__any_prefix_tilde] = STATE(2258),
    [sym__paren_open] = STATE(45),
    [sym__bracket_open] = STATE(369),
    [sym__unboxed_open] = STATE(193),
    [sym_variable] = ACTIONS(2801),
    [anon_sym__] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2467),
    [sym_char] = ACTIONS(2467),
    [sym_string] = ACTIONS(2467),
    [sym__integer_literal] = ACTIONS(2469),
    [sym__binary_literal] = ACTIONS(2471),
    [sym__octal_literal] = ACTIONS(2471),
    [sym__hex_literal] = ACTIONS(2471),
    [sym_name] = ACTIONS(2807),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2475),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2258] = {
    [sym__pat_parens] = STATE(6709),
    [sym__pat_tuple] = STATE(6707),
    [sym__pat_unboxed_tuple] = STATE(6706),
    [sym__pat_unboxed_sum] = STATE(6705),
    [sym__pat_list] = STATE(6704),
    [sym__pat_record] = STATE(6703),
    [sym__pat_as] = STATE(6702),
    [sym__pat_wildcard] = STATE(6701),
    [sym__pat_strict] = STATE(6700),
    [sym__pat_irrefutable] = STATE(6699),
    [sym__pat_apply] = STATE(6772),
    [sym__pat_negation] = STATE(6711),
    [sym__pat_infix] = STATE(6715),
    [sym_pattern] = STATE(1362),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11259),
    [sym__splice_dollars] = STATE(7313),
    [sym_splice] = STATE(6701),
    [sym_quasiquote] = STATE(6701),
    [sym_integer] = STATE(6231),
    [sym__plist] = STATE(6728),
    [sym_unit] = STATE(6701),
    [sym_unboxed_unit] = STATE(6701),
    [sym_prefix_tuple] = STATE(6701),
    [sym_prefix_unboxed_tuple] = STATE(6701),
    [sym_prefix_unboxed_sum] = STATE(6701),
    [sym_literal] = STATE(6701),
    [sym__qualified_constructor] = STATE(6223),
    [sym__qconid] = STATE(6701),
    [sym__varsym_prefix] = STATE(6729),
    [sym__pvarsym] = STATE(6729),
    [sym__consym_prefix] = STATE(6731),
    [sym__pconsym] = STATE(6731),
    [sym__qconsym_prefix] = STATE(6701),
    [sym__pqconsym] = STATE(6701),
    [sym__prefix_bang] = STATE(2257),
    [sym__tight_bang] = STATE(2257),
    [sym__any_prefix_bang] = STATE(2257),
    [sym__prefix_tilde] = STATE(2258),
    [sym__tight_tilde] = STATE(2258),
    [sym__any_prefix_tilde] = STATE(2258),
    [sym__paren_open] = STATE(45),
    [sym__bracket_open] = STATE(369),
    [sym__unboxed_open] = STATE(193),
    [sym_variable] = ACTIONS(2801),
    [anon_sym__] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2467),
    [sym_char] = ACTIONS(2467),
    [sym_string] = ACTIONS(2467),
    [sym__integer_literal] = ACTIONS(2469),
    [sym__binary_literal] = ACTIONS(2471),
    [sym__octal_literal] = ACTIONS(2471),
    [sym__hex_literal] = ACTIONS(2471),
    [sym_name] = ACTIONS(2807),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2475),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2259] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1820),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(3535),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2260] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1807),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2261] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1860),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2262] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(1346),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(6638),
    [sym__pvarsym] = STATE(6638),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(48),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(2713),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2263] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1822),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(3535),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2264] = {
    [sym__pat_parens] = STATE(6709),
    [sym__pat_tuple] = STATE(6707),
    [sym__pat_unboxed_tuple] = STATE(6706),
    [sym__pat_unboxed_sum] = STATE(6705),
    [sym__pat_list] = STATE(6704),
    [sym__pat_record] = STATE(6703),
    [sym__pat_as] = STATE(6702),
    [sym__pat_wildcard] = STATE(6701),
    [sym__pat_strict] = STATE(6700),
    [sym__pat_irrefutable] = STATE(6699),
    [sym__pat_apply] = STATE(6772),
    [sym__pat_negation] = STATE(6711),
    [sym__pat_infix] = STATE(6715),
    [sym_pattern] = STATE(1385),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11259),
    [sym__splice_dollars] = STATE(7313),
    [sym_splice] = STATE(6701),
    [sym_quasiquote] = STATE(6701),
    [sym_integer] = STATE(6231),
    [sym__plist] = STATE(6728),
    [sym_unit] = STATE(6701),
    [sym_unboxed_unit] = STATE(6701),
    [sym_prefix_tuple] = STATE(6701),
    [sym_prefix_unboxed_tuple] = STATE(6701),
    [sym_prefix_unboxed_sum] = STATE(6701),
    [sym_literal] = STATE(6701),
    [sym__qualified_constructor] = STATE(6223),
    [sym__qconid] = STATE(6701),
    [sym__varsym_prefix] = STATE(6729),
    [sym__pvarsym] = STATE(6729),
    [sym__consym_prefix] = STATE(6731),
    [sym__pconsym] = STATE(6731),
    [sym__qconsym_prefix] = STATE(6701),
    [sym__pqconsym] = STATE(6701),
    [sym__prefix_bang] = STATE(2257),
    [sym__tight_bang] = STATE(2257),
    [sym__any_prefix_bang] = STATE(2257),
    [sym__prefix_tilde] = STATE(2258),
    [sym__tight_tilde] = STATE(2258),
    [sym__any_prefix_tilde] = STATE(2258),
    [sym__paren_open] = STATE(45),
    [sym__bracket_open] = STATE(369),
    [sym__unboxed_open] = STATE(193),
    [sym_variable] = ACTIONS(2801),
    [anon_sym__] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2467),
    [sym_char] = ACTIONS(2467),
    [sym_string] = ACTIONS(2467),
    [sym__integer_literal] = ACTIONS(2469),
    [sym__binary_literal] = ACTIONS(2471),
    [sym__octal_literal] = ACTIONS(2471),
    [sym__hex_literal] = ACTIONS(2471),
    [sym_name] = ACTIONS(2807),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2475),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2265] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1058),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2266] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1057),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2267] = {
    [sym__pat_parens] = STATE(7041),
    [sym__pat_tuple] = STATE(7042),
    [sym__pat_unboxed_tuple] = STATE(7043),
    [sym__pat_unboxed_sum] = STATE(7044),
    [sym__pat_list] = STATE(7045),
    [sym__pat_record] = STATE(7046),
    [sym__pat_as] = STATE(7047),
    [sym__pat_wildcard] = STATE(7048),
    [sym__pat_strict] = STATE(7049),
    [sym__pat_irrefutable] = STATE(7050),
    [sym__pat_apply] = STATE(7051),
    [sym__pat_negation] = STATE(7052),
    [sym__pat_infix] = STATE(7053),
    [sym_pattern] = STATE(1791),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11245),
    [sym__splice_dollars] = STATE(7422),
    [sym_splice] = STATE(7048),
    [sym_quasiquote] = STATE(7048),
    [sym_integer] = STATE(7199),
    [sym__plist] = STATE(7057),
    [sym_unit] = STATE(7048),
    [sym_unboxed_unit] = STATE(7048),
    [sym_prefix_tuple] = STATE(7048),
    [sym_prefix_unboxed_tuple] = STATE(7048),
    [sym_prefix_unboxed_sum] = STATE(7048),
    [sym_literal] = STATE(7048),
    [sym__qualified_constructor] = STATE(7189),
    [sym__qconid] = STATE(7048),
    [sym__varsym_prefix] = STATE(7058),
    [sym__pvarsym] = STATE(7058),
    [sym__consym_prefix] = STATE(7059),
    [sym__pconsym] = STATE(7059),
    [sym__qconsym_prefix] = STATE(7048),
    [sym__pqconsym] = STATE(7048),
    [sym__prefix_bang] = STATE(2256),
    [sym__tight_bang] = STATE(2256),
    [sym__any_prefix_bang] = STATE(2256),
    [sym__prefix_tilde] = STATE(2253),
    [sym__tight_tilde] = STATE(2253),
    [sym__any_prefix_tilde] = STATE(2253),
    [sym__paren_open] = STATE(47),
    [sym__bracket_open] = STATE(364),
    [sym__unboxed_open] = STATE(202),
    [sym_variable] = ACTIONS(3473),
    [anon_sym__] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3481),
    [sym_char] = ACTIONS(3481),
    [sym_string] = ACTIONS(3481),
    [sym__integer_literal] = ACTIONS(3483),
    [sym__binary_literal] = ACTIONS(3485),
    [sym__octal_literal] = ACTIONS(3485),
    [sym__hex_literal] = ACTIONS(3485),
    [sym_name] = ACTIONS(3487),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3493),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2268] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(1255),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(6638),
    [sym__pvarsym] = STATE(6638),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(48),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(2713),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2269] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1856),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2270] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(1253),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(6638),
    [sym__pvarsym] = STATE(6638),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(48),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(2713),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2271] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1857),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2272] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(1208),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(6638),
    [sym__pvarsym] = STATE(6638),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(48),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(2713),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2273] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1805),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2274] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1810),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2275] = {
    [sym__pat_parens] = STATE(7041),
    [sym__pat_tuple] = STATE(7042),
    [sym__pat_unboxed_tuple] = STATE(7043),
    [sym__pat_unboxed_sum] = STATE(7044),
    [sym__pat_list] = STATE(7045),
    [sym__pat_record] = STATE(7046),
    [sym__pat_as] = STATE(7047),
    [sym__pat_wildcard] = STATE(7048),
    [sym__pat_strict] = STATE(7049),
    [sym__pat_irrefutable] = STATE(7050),
    [sym__pat_apply] = STATE(7051),
    [sym__pat_negation] = STATE(7052),
    [sym__pat_infix] = STATE(7053),
    [sym_pattern] = STATE(1787),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11245),
    [sym__splice_dollars] = STATE(7422),
    [sym_splice] = STATE(7048),
    [sym_quasiquote] = STATE(7048),
    [sym_integer] = STATE(7199),
    [sym__plist] = STATE(7057),
    [sym_unit] = STATE(7048),
    [sym_unboxed_unit] = STATE(7048),
    [sym_prefix_tuple] = STATE(7048),
    [sym_prefix_unboxed_tuple] = STATE(7048),
    [sym_prefix_unboxed_sum] = STATE(7048),
    [sym_literal] = STATE(7048),
    [sym__qualified_constructor] = STATE(7189),
    [sym__qconid] = STATE(7048),
    [sym__varsym_prefix] = STATE(7058),
    [sym__pvarsym] = STATE(7058),
    [sym__consym_prefix] = STATE(7059),
    [sym__pconsym] = STATE(7059),
    [sym__qconsym_prefix] = STATE(7048),
    [sym__pqconsym] = STATE(7048),
    [sym__prefix_bang] = STATE(2256),
    [sym__tight_bang] = STATE(2256),
    [sym__any_prefix_bang] = STATE(2256),
    [sym__prefix_tilde] = STATE(2253),
    [sym__tight_tilde] = STATE(2253),
    [sym__any_prefix_tilde] = STATE(2253),
    [sym__paren_open] = STATE(47),
    [sym__bracket_open] = STATE(364),
    [sym__unboxed_open] = STATE(202),
    [sym_variable] = ACTIONS(3473),
    [anon_sym__] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3481),
    [sym_char] = ACTIONS(3481),
    [sym_string] = ACTIONS(3481),
    [sym__integer_literal] = ACTIONS(3483),
    [sym__binary_literal] = ACTIONS(3485),
    [sym__octal_literal] = ACTIONS(3485),
    [sym__hex_literal] = ACTIONS(3485),
    [sym_name] = ACTIONS(3487),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3493),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2276] = {
    [sym__pat_parens] = STATE(7041),
    [sym__pat_tuple] = STATE(7042),
    [sym__pat_unboxed_tuple] = STATE(7043),
    [sym__pat_unboxed_sum] = STATE(7044),
    [sym__pat_list] = STATE(7045),
    [sym__pat_record] = STATE(7046),
    [sym__pat_as] = STATE(7047),
    [sym__pat_wildcard] = STATE(7048),
    [sym__pat_strict] = STATE(7049),
    [sym__pat_irrefutable] = STATE(7050),
    [sym__pat_apply] = STATE(7051),
    [sym__pat_negation] = STATE(7052),
    [sym__pat_infix] = STATE(7053),
    [sym_pattern] = STATE(1779),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11245),
    [sym__splice_dollars] = STATE(7422),
    [sym_splice] = STATE(7048),
    [sym_quasiquote] = STATE(7048),
    [sym_integer] = STATE(7199),
    [sym__plist] = STATE(7057),
    [sym_unit] = STATE(7048),
    [sym_unboxed_unit] = STATE(7048),
    [sym_prefix_tuple] = STATE(7048),
    [sym_prefix_unboxed_tuple] = STATE(7048),
    [sym_prefix_unboxed_sum] = STATE(7048),
    [sym_literal] = STATE(7048),
    [sym__qualified_constructor] = STATE(7189),
    [sym__qconid] = STATE(7048),
    [sym__varsym_prefix] = STATE(7058),
    [sym__pvarsym] = STATE(7058),
    [sym__consym_prefix] = STATE(7059),
    [sym__pconsym] = STATE(7059),
    [sym__qconsym_prefix] = STATE(7048),
    [sym__pqconsym] = STATE(7048),
    [sym__prefix_bang] = STATE(2256),
    [sym__tight_bang] = STATE(2256),
    [sym__any_prefix_bang] = STATE(2256),
    [sym__prefix_tilde] = STATE(2253),
    [sym__tight_tilde] = STATE(2253),
    [sym__any_prefix_tilde] = STATE(2253),
    [sym__paren_open] = STATE(47),
    [sym__bracket_open] = STATE(364),
    [sym__unboxed_open] = STATE(202),
    [sym_variable] = ACTIONS(3473),
    [anon_sym__] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3481),
    [sym_char] = ACTIONS(3481),
    [sym_string] = ACTIONS(3481),
    [sym__integer_literal] = ACTIONS(3483),
    [sym__binary_literal] = ACTIONS(3485),
    [sym__octal_literal] = ACTIONS(3485),
    [sym__hex_literal] = ACTIONS(3485),
    [sym_name] = ACTIONS(3487),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3493),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2277] = {
    [sym__pat_parens] = STATE(6709),
    [sym__pat_tuple] = STATE(6707),
    [sym__pat_unboxed_tuple] = STATE(6706),
    [sym__pat_unboxed_sum] = STATE(6705),
    [sym__pat_list] = STATE(6704),
    [sym__pat_record] = STATE(6703),
    [sym__pat_as] = STATE(6702),
    [sym__pat_wildcard] = STATE(6701),
    [sym__pat_strict] = STATE(6700),
    [sym__pat_irrefutable] = STATE(6699),
    [sym__pat_apply] = STATE(6772),
    [sym__pat_negation] = STATE(6711),
    [sym__pat_infix] = STATE(6715),
    [sym_pattern] = STATE(1378),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11259),
    [sym__splice_dollars] = STATE(7313),
    [sym_splice] = STATE(6701),
    [sym_quasiquote] = STATE(6701),
    [sym_integer] = STATE(6231),
    [sym__plist] = STATE(6728),
    [sym_unit] = STATE(6701),
    [sym_unboxed_unit] = STATE(6701),
    [sym_prefix_tuple] = STATE(6701),
    [sym_prefix_unboxed_tuple] = STATE(6701),
    [sym_prefix_unboxed_sum] = STATE(6701),
    [sym_literal] = STATE(6701),
    [sym__qualified_constructor] = STATE(6223),
    [sym__qconid] = STATE(6701),
    [sym__varsym_prefix] = STATE(6729),
    [sym__pvarsym] = STATE(6729),
    [sym__consym_prefix] = STATE(6731),
    [sym__pconsym] = STATE(6731),
    [sym__qconsym_prefix] = STATE(6701),
    [sym__pqconsym] = STATE(6701),
    [sym__prefix_bang] = STATE(2257),
    [sym__tight_bang] = STATE(2257),
    [sym__any_prefix_bang] = STATE(2257),
    [sym__prefix_tilde] = STATE(2258),
    [sym__tight_tilde] = STATE(2258),
    [sym__any_prefix_tilde] = STATE(2258),
    [sym__paren_open] = STATE(45),
    [sym__bracket_open] = STATE(369),
    [sym__unboxed_open] = STATE(193),
    [sym_variable] = ACTIONS(2801),
    [anon_sym__] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2467),
    [sym_char] = ACTIONS(2467),
    [sym_string] = ACTIONS(2467),
    [sym__integer_literal] = ACTIONS(2469),
    [sym__binary_literal] = ACTIONS(2471),
    [sym__octal_literal] = ACTIONS(2471),
    [sym__hex_literal] = ACTIONS(2471),
    [sym_name] = ACTIONS(2807),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2475),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2278] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1876),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2279] = {
    [sym__guards] = STATE(12352),
    [sym__simple_bind_match] = STATE(9050),
    [sym__bind_match] = STATE(8990),
    [sym__bind_matches] = STATE(10222),
    [sym__colon2] = STATE(1444),
    [sym__tight_at] = STATE(2289),
    [sym__bar] = STATE(12338),
    [aux_sym__var_binding_list_repeat1] = STATE(10223),
    [aux_sym__bind_matches_repeat1] = STATE(8422),
    [sym_variable] = ACTIONS(4642),
    [anon_sym_SEMI] = ACTIONS(4646),
    [anon_sym_let] = ACTIONS(4648),
    [anon_sym_COMMA] = ACTIONS(4650),
    [anon_sym_LBRACE] = ACTIONS(4652),
    [anon_sym__] = ACTIONS(4655),
    [anon_sym_SQUOTE] = ACTIONS(4648),
    [anon_sym_STAR] = ACTIONS(4652),
    [anon_sym_EQ] = ACTIONS(4658),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4646),
    [anon_sym_PIPE] = ACTIONS(4660),
    [anon_sym_BSLASH] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_mdo] = ACTIONS(4648),
    [anon_sym_do] = ACTIONS(4648),
    [anon_sym_case] = ACTIONS(4648),
    [anon_sym_DASH] = ACTIONS(4662),
    [anon_sym_LBRACK] = ACTIONS(4662),
    [anon_sym_u27e6] = ACTIONS(4646),
    [sym_float] = ACTIONS(4662),
    [sym_char] = ACTIONS(4662),
    [sym_string] = ACTIONS(4662),
    [sym__integer_literal] = ACTIONS(4642),
    [sym__binary_literal] = ACTIONS(4662),
    [sym__octal_literal] = ACTIONS(4662),
    [sym__hex_literal] = ACTIONS(4662),
    [anon_sym_BQUOTE] = ACTIONS(4652),
    [anon_sym_POUND] = ACTIONS(4666),
    [anon_sym_POUND2] = ACTIONS(4666),
    [sym_implicit_variable] = ACTIONS(4646),
    [sym_name] = ACTIONS(4662),
    [sym_label] = ACTIONS(4646),
    [anon_sym_COLON_COLON] = ACTIONS(4669),
    [anon_sym_u2237] = ACTIONS(4669),
    [aux_sym__paren_open_token1] = ACTIONS(4662),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4646),
    [sym__cond_layout_end] = ACTIONS(4646),
    [sym__cond_layout_end_explicit] = ACTIONS(4646),
    [sym__phantom_bar] = ACTIONS(4672),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4662),
    [sym__cond_splice] = ACTIONS(4662),
    [sym__cond_tight_dot] = ACTIONS(4646),
    [sym__cond_prefix_dot] = ACTIONS(4652),
    [sym__cond_tight_at] = ACTIONS(4674),
    [sym__cond_prefix_at] = ACTIONS(4662),
    [sym__cond_tight_bang] = ACTIONS(4676),
    [sym__cond_prefix_bang] = ACTIONS(4676),
    [sym__cond_tight_tilde] = ACTIONS(4676),
    [sym__cond_prefix_tilde] = ACTIONS(4676),
    [sym__cond_qualified_op] = ACTIONS(4652),
    [sym__cond_no_section_op] = ACTIONS(4652),
    [sym__cond_minus] = ACTIONS(4652),
    [sym__varsym] = ACTIONS(4652),
    [sym__consym] = ACTIONS(4652),
  },
  [2280] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(953),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2281] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1815),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(3535),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2282] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1816),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(3535),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2283] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1798),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2284] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(997),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2285] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1886),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2286] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(994),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2287] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1889),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2288] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1809),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2289] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(1265),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(6638),
    [sym__pvarsym] = STATE(6638),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(48),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(2713),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2290] = {
    [sym__pat_parens] = STATE(6709),
    [sym__pat_tuple] = STATE(6707),
    [sym__pat_unboxed_tuple] = STATE(6706),
    [sym__pat_unboxed_sum] = STATE(6705),
    [sym__pat_list] = STATE(6704),
    [sym__pat_record] = STATE(6703),
    [sym__pat_as] = STATE(6702),
    [sym__pat_wildcard] = STATE(6701),
    [sym__pat_strict] = STATE(6700),
    [sym__pat_irrefutable] = STATE(6699),
    [sym__pat_apply] = STATE(6772),
    [sym__pat_negation] = STATE(6711),
    [sym__pat_infix] = STATE(6715),
    [sym_pattern] = STATE(1377),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11259),
    [sym__splice_dollars] = STATE(7313),
    [sym_splice] = STATE(6701),
    [sym_quasiquote] = STATE(6701),
    [sym_integer] = STATE(6231),
    [sym__plist] = STATE(6728),
    [sym_unit] = STATE(6701),
    [sym_unboxed_unit] = STATE(6701),
    [sym_prefix_tuple] = STATE(6701),
    [sym_prefix_unboxed_tuple] = STATE(6701),
    [sym_prefix_unboxed_sum] = STATE(6701),
    [sym_literal] = STATE(6701),
    [sym__qualified_constructor] = STATE(6223),
    [sym__qconid] = STATE(6701),
    [sym__varsym_prefix] = STATE(6729),
    [sym__pvarsym] = STATE(6729),
    [sym__consym_prefix] = STATE(6731),
    [sym__pconsym] = STATE(6731),
    [sym__qconsym_prefix] = STATE(6701),
    [sym__pqconsym] = STATE(6701),
    [sym__prefix_bang] = STATE(2257),
    [sym__tight_bang] = STATE(2257),
    [sym__any_prefix_bang] = STATE(2257),
    [sym__prefix_tilde] = STATE(2258),
    [sym__tight_tilde] = STATE(2258),
    [sym__any_prefix_tilde] = STATE(2258),
    [sym__paren_open] = STATE(45),
    [sym__bracket_open] = STATE(369),
    [sym__unboxed_open] = STATE(193),
    [sym_variable] = ACTIONS(2801),
    [anon_sym__] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2467),
    [sym_char] = ACTIONS(2467),
    [sym_string] = ACTIONS(2467),
    [sym__integer_literal] = ACTIONS(2469),
    [sym__binary_literal] = ACTIONS(2471),
    [sym__octal_literal] = ACTIONS(2471),
    [sym__hex_literal] = ACTIONS(2471),
    [sym_name] = ACTIONS(2807),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2475),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2291] = {
    [sym__pat_parens] = STATE(6709),
    [sym__pat_tuple] = STATE(6707),
    [sym__pat_unboxed_tuple] = STATE(6706),
    [sym__pat_unboxed_sum] = STATE(6705),
    [sym__pat_list] = STATE(6704),
    [sym__pat_record] = STATE(6703),
    [sym__pat_as] = STATE(6702),
    [sym__pat_wildcard] = STATE(6701),
    [sym__pat_strict] = STATE(6700),
    [sym__pat_irrefutable] = STATE(6699),
    [sym__pat_apply] = STATE(6772),
    [sym__pat_negation] = STATE(6711),
    [sym__pat_infix] = STATE(6715),
    [sym_pattern] = STATE(1376),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11259),
    [sym__splice_dollars] = STATE(7313),
    [sym_splice] = STATE(6701),
    [sym_quasiquote] = STATE(6701),
    [sym_integer] = STATE(6231),
    [sym__plist] = STATE(6728),
    [sym_unit] = STATE(6701),
    [sym_unboxed_unit] = STATE(6701),
    [sym_prefix_tuple] = STATE(6701),
    [sym_prefix_unboxed_tuple] = STATE(6701),
    [sym_prefix_unboxed_sum] = STATE(6701),
    [sym_literal] = STATE(6701),
    [sym__qualified_constructor] = STATE(6223),
    [sym__qconid] = STATE(6701),
    [sym__varsym_prefix] = STATE(6729),
    [sym__pvarsym] = STATE(6729),
    [sym__consym_prefix] = STATE(6731),
    [sym__pconsym] = STATE(6731),
    [sym__qconsym_prefix] = STATE(6701),
    [sym__pqconsym] = STATE(6701),
    [sym__prefix_bang] = STATE(2257),
    [sym__tight_bang] = STATE(2257),
    [sym__any_prefix_bang] = STATE(2257),
    [sym__prefix_tilde] = STATE(2258),
    [sym__tight_tilde] = STATE(2258),
    [sym__any_prefix_tilde] = STATE(2258),
    [sym__paren_open] = STATE(45),
    [sym__bracket_open] = STATE(369),
    [sym__unboxed_open] = STATE(193),
    [sym_variable] = ACTIONS(2801),
    [anon_sym__] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2467),
    [sym_char] = ACTIONS(2467),
    [sym_string] = ACTIONS(2467),
    [sym__integer_literal] = ACTIONS(2469),
    [sym__binary_literal] = ACTIONS(2471),
    [sym__octal_literal] = ACTIONS(2471),
    [sym__hex_literal] = ACTIONS(2471),
    [sym_name] = ACTIONS(2807),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2475),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2292] = {
    [sym__pat_parens] = STATE(7412),
    [sym__pat_tuple] = STATE(7395),
    [sym__pat_unboxed_tuple] = STATE(7379),
    [sym__pat_unboxed_sum] = STATE(7373),
    [sym__pat_list] = STATE(7301),
    [sym__pat_record] = STATE(7367),
    [sym__pat_as] = STATE(7204),
    [sym__pat_wildcard] = STATE(7341),
    [sym__pat_strict] = STATE(7327),
    [sym__pat_irrefutable] = STATE(7326),
    [sym__pat_apply] = STATE(7325),
    [sym__pat_negation] = STATE(7324),
    [sym__pat_infix] = STATE(7321),
    [sym_pattern] = STATE(1858),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11130),
    [sym__splice_dollars] = STATE(7469),
    [sym_splice] = STATE(7341),
    [sym_quasiquote] = STATE(7341),
    [sym_integer] = STATE(7387),
    [sym__plist] = STATE(7281),
    [sym_unit] = STATE(7341),
    [sym_unboxed_unit] = STATE(7341),
    [sym_prefix_tuple] = STATE(7341),
    [sym_prefix_unboxed_tuple] = STATE(7341),
    [sym_prefix_unboxed_sum] = STATE(7341),
    [sym_literal] = STATE(7341),
    [sym__qualified_constructor] = STATE(7391),
    [sym__qconid] = STATE(7341),
    [sym__varsym_prefix] = STATE(7282),
    [sym__pvarsym] = STATE(7282),
    [sym__consym_prefix] = STATE(7286),
    [sym__pconsym] = STATE(7286),
    [sym__qconsym_prefix] = STATE(7341),
    [sym__pqconsym] = STATE(7341),
    [sym__prefix_bang] = STATE(2288),
    [sym__tight_bang] = STATE(2288),
    [sym__any_prefix_bang] = STATE(2288),
    [sym__prefix_tilde] = STATE(2283),
    [sym__tight_tilde] = STATE(2283),
    [sym__any_prefix_tilde] = STATE(2283),
    [sym__paren_open] = STATE(49),
    [sym__bracket_open] = STATE(358),
    [sym__unboxed_open] = STATE(175),
    [sym_variable] = ACTIONS(3505),
    [anon_sym__] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3513),
    [sym_char] = ACTIONS(3513),
    [sym_string] = ACTIONS(3513),
    [sym__integer_literal] = ACTIONS(3515),
    [sym__binary_literal] = ACTIONS(3517),
    [sym__octal_literal] = ACTIONS(3517),
    [sym__hex_literal] = ACTIONS(3517),
    [sym_name] = ACTIONS(3519),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3521),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2293] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1817),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(3535),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2294] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1811),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(3535),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2295] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1089),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2296] = {
    [sym__pat_parens] = STATE(6673),
    [sym__pat_tuple] = STATE(6671),
    [sym__pat_unboxed_tuple] = STATE(6667),
    [sym__pat_unboxed_sum] = STATE(6666),
    [sym__pat_list] = STATE(6661),
    [sym__pat_record] = STATE(6660),
    [sym__pat_as] = STATE(6659),
    [sym__pat_wildcard] = STATE(6657),
    [sym__pat_strict] = STATE(6656),
    [sym__pat_irrefutable] = STATE(6655),
    [sym__pat_apply] = STATE(6654),
    [sym__pat_negation] = STATE(6652),
    [sym__pat_infix] = STATE(6644),
    [sym_pattern] = STATE(1304),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(10930),
    [sym__splice_dollars] = STATE(7221),
    [sym_splice] = STATE(6657),
    [sym_quasiquote] = STATE(6657),
    [sym_integer] = STATE(6125),
    [sym__plist] = STATE(6640),
    [sym_unit] = STATE(6657),
    [sym_unboxed_unit] = STATE(6657),
    [sym_prefix_tuple] = STATE(6657),
    [sym_prefix_unboxed_tuple] = STATE(6657),
    [sym_prefix_unboxed_sum] = STATE(6657),
    [sym_literal] = STATE(6657),
    [sym__qualified_constructor] = STATE(6126),
    [sym__qconid] = STATE(6657),
    [sym__varsym_prefix] = STATE(6638),
    [sym__pvarsym] = STATE(6638),
    [sym__consym_prefix] = STATE(6636),
    [sym__pconsym] = STATE(6636),
    [sym__qconsym_prefix] = STATE(6657),
    [sym__pqconsym] = STATE(6657),
    [sym__prefix_bang] = STATE(2252),
    [sym__tight_bang] = STATE(2252),
    [sym__any_prefix_bang] = STATE(2252),
    [sym__prefix_tilde] = STATE(2272),
    [sym__tight_tilde] = STATE(2272),
    [sym__any_prefix_tilde] = STATE(2272),
    [sym__paren_open] = STATE(48),
    [sym__bracket_open] = STATE(363),
    [sym__unboxed_open] = STATE(185),
    [sym_variable] = ACTIONS(2713),
    [anon_sym__] = ACTIONS(17),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(1939),
    [sym_char] = ACTIONS(1939),
    [sym_string] = ACTIONS(1939),
    [sym__integer_literal] = ACTIONS(1941),
    [sym__binary_literal] = ACTIONS(1943),
    [sym__octal_literal] = ACTIONS(1943),
    [sym__hex_literal] = ACTIONS(1943),
    [sym_name] = ACTIONS(1947),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(1953),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2297] = {
    [sym__pat_parens] = STATE(7041),
    [sym__pat_tuple] = STATE(7042),
    [sym__pat_unboxed_tuple] = STATE(7043),
    [sym__pat_unboxed_sum] = STATE(7044),
    [sym__pat_list] = STATE(7045),
    [sym__pat_record] = STATE(7046),
    [sym__pat_as] = STATE(7047),
    [sym__pat_wildcard] = STATE(7048),
    [sym__pat_strict] = STATE(7049),
    [sym__pat_irrefutable] = STATE(7050),
    [sym__pat_apply] = STATE(7051),
    [sym__pat_negation] = STATE(7052),
    [sym__pat_infix] = STATE(7053),
    [sym_pattern] = STATE(1795),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11245),
    [sym__splice_dollars] = STATE(7422),
    [sym_splice] = STATE(7048),
    [sym_quasiquote] = STATE(7048),
    [sym_integer] = STATE(7199),
    [sym__plist] = STATE(7057),
    [sym_unit] = STATE(7048),
    [sym_unboxed_unit] = STATE(7048),
    [sym_prefix_tuple] = STATE(7048),
    [sym_prefix_unboxed_tuple] = STATE(7048),
    [sym_prefix_unboxed_sum] = STATE(7048),
    [sym_literal] = STATE(7048),
    [sym__qualified_constructor] = STATE(7189),
    [sym__qconid] = STATE(7048),
    [sym__varsym_prefix] = STATE(7058),
    [sym__pvarsym] = STATE(7058),
    [sym__consym_prefix] = STATE(7059),
    [sym__pconsym] = STATE(7059),
    [sym__qconsym_prefix] = STATE(7048),
    [sym__pqconsym] = STATE(7048),
    [sym__prefix_bang] = STATE(2256),
    [sym__tight_bang] = STATE(2256),
    [sym__any_prefix_bang] = STATE(2256),
    [sym__prefix_tilde] = STATE(2253),
    [sym__tight_tilde] = STATE(2253),
    [sym__any_prefix_tilde] = STATE(2253),
    [sym__paren_open] = STATE(47),
    [sym__bracket_open] = STATE(364),
    [sym__unboxed_open] = STATE(202),
    [sym_variable] = ACTIONS(3473),
    [anon_sym__] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3481),
    [sym_char] = ACTIONS(3481),
    [sym_string] = ACTIONS(3481),
    [sym__integer_literal] = ACTIONS(3483),
    [sym__binary_literal] = ACTIONS(3485),
    [sym__octal_literal] = ACTIONS(3485),
    [sym__hex_literal] = ACTIONS(3485),
    [sym_name] = ACTIONS(3487),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3493),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2298] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1883),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2299] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(952),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2266),
    [sym__tight_bang] = STATE(2266),
    [sym__any_prefix_bang] = STATE(2266),
    [sym__prefix_tilde] = STATE(2265),
    [sym__tight_tilde] = STATE(2265),
    [sym__any_prefix_tilde] = STATE(2265),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(2827),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2300] = {
    [sym__pat_parens] = STATE(7041),
    [sym__pat_tuple] = STATE(7042),
    [sym__pat_unboxed_tuple] = STATE(7043),
    [sym__pat_unboxed_sum] = STATE(7044),
    [sym__pat_list] = STATE(7045),
    [sym__pat_record] = STATE(7046),
    [sym__pat_as] = STATE(7047),
    [sym__pat_wildcard] = STATE(7048),
    [sym__pat_strict] = STATE(7049),
    [sym__pat_irrefutable] = STATE(7050),
    [sym__pat_apply] = STATE(7051),
    [sym__pat_negation] = STATE(7052),
    [sym__pat_infix] = STATE(7053),
    [sym_pattern] = STATE(1790),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11245),
    [sym__splice_dollars] = STATE(7422),
    [sym_splice] = STATE(7048),
    [sym_quasiquote] = STATE(7048),
    [sym_integer] = STATE(7199),
    [sym__plist] = STATE(7057),
    [sym_unit] = STATE(7048),
    [sym_unboxed_unit] = STATE(7048),
    [sym_prefix_tuple] = STATE(7048),
    [sym_prefix_unboxed_tuple] = STATE(7048),
    [sym_prefix_unboxed_sum] = STATE(7048),
    [sym_literal] = STATE(7048),
    [sym__qualified_constructor] = STATE(7189),
    [sym__qconid] = STATE(7048),
    [sym__varsym_prefix] = STATE(7058),
    [sym__pvarsym] = STATE(7058),
    [sym__consym_prefix] = STATE(7059),
    [sym__pconsym] = STATE(7059),
    [sym__qconsym_prefix] = STATE(7048),
    [sym__pqconsym] = STATE(7048),
    [sym__prefix_bang] = STATE(2256),
    [sym__tight_bang] = STATE(2256),
    [sym__any_prefix_bang] = STATE(2256),
    [sym__prefix_tilde] = STATE(2253),
    [sym__tight_tilde] = STATE(2253),
    [sym__any_prefix_tilde] = STATE(2253),
    [sym__paren_open] = STATE(47),
    [sym__bracket_open] = STATE(364),
    [sym__unboxed_open] = STATE(202),
    [sym_variable] = ACTIONS(3473),
    [anon_sym__] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(3481),
    [sym_char] = ACTIONS(3481),
    [sym_string] = ACTIONS(3481),
    [sym__integer_literal] = ACTIONS(3483),
    [sym__binary_literal] = ACTIONS(3485),
    [sym__octal_literal] = ACTIONS(3485),
    [sym__hex_literal] = ACTIONS(3485),
    [sym_name] = ACTIONS(3487),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3493),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2301] = {
    [sym__pat_parens] = STATE(5808),
    [sym__pat_tuple] = STATE(5751),
    [sym__pat_unboxed_tuple] = STATE(5753),
    [sym__pat_unboxed_sum] = STATE(5770),
    [sym__pat_list] = STATE(5772),
    [sym__pat_record] = STATE(5784),
    [sym__pat_as] = STATE(5785),
    [sym__pat_wildcard] = STATE(5786),
    [sym__pat_strict] = STATE(5788),
    [sym__pat_irrefutable] = STATE(5790),
    [sym__pat_apply] = STATE(5791),
    [sym__pat_negation] = STATE(5792),
    [sym__pat_infix] = STATE(5793),
    [sym_pattern] = STATE(1819),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11012),
    [sym__splice_dollars] = STATE(7303),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym_integer] = STATE(5721),
    [sym__plist] = STATE(5781),
    [sym_unit] = STATE(5786),
    [sym_unboxed_unit] = STATE(5786),
    [sym_prefix_tuple] = STATE(5786),
    [sym_prefix_unboxed_tuple] = STATE(5786),
    [sym_prefix_unboxed_sum] = STATE(5786),
    [sym_literal] = STATE(5786),
    [sym__qualified_constructor] = STATE(5750),
    [sym__qconid] = STATE(5786),
    [sym__varsym_prefix] = STATE(5780),
    [sym__pvarsym] = STATE(5780),
    [sym__consym_prefix] = STATE(5777),
    [sym__pconsym] = STATE(5777),
    [sym__qconsym_prefix] = STATE(5786),
    [sym__pqconsym] = STATE(5786),
    [sym__prefix_bang] = STATE(2281),
    [sym__tight_bang] = STATE(2281),
    [sym__any_prefix_bang] = STATE(2281),
    [sym__prefix_tilde] = STATE(2282),
    [sym__tight_tilde] = STATE(2282),
    [sym__any_prefix_tilde] = STATE(2282),
    [sym__paren_open] = STATE(46),
    [sym__bracket_open] = STATE(372),
    [sym__unboxed_open] = STATE(206),
    [sym_variable] = ACTIONS(3535),
    [anon_sym__] = ACTIONS(191),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_float] = ACTIONS(2833),
    [sym_char] = ACTIONS(2833),
    [sym_string] = ACTIONS(2833),
    [sym__integer_literal] = ACTIONS(2835),
    [sym__binary_literal] = ACTIONS(2837),
    [sym__octal_literal] = ACTIONS(2837),
    [sym__hex_literal] = ACTIONS(2837),
    [sym_name] = ACTIONS(2841),
    [aux_sym__paren_open_token1] = ACTIONS(73),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2843),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_tight_bang] = ACTIONS(85),
    [sym__cond_prefix_bang] = ACTIONS(87),
    [sym__cond_tight_tilde] = ACTIONS(89),
    [sym__cond_prefix_tilde] = ACTIONS(91),
  },
  [2302] = {
    [sym_variable] = ACTIONS(4679),
    [anon_sym_SEMI] = ACTIONS(4681),
    [anon_sym_let] = ACTIONS(4679),
    [anon_sym_COMMA] = ACTIONS(4681),
    [anon_sym_LBRACE] = ACTIONS(4681),
    [anon_sym_RBRACE] = ACTIONS(4681),
    [anon_sym__] = ACTIONS(4679),
    [anon_sym_SQUOTE] = ACTIONS(4679),
    [anon_sym_STAR] = ACTIONS(4681),
    [anon_sym_u2605] = ACTIONS(4681),
    [anon_sym_EQ] = ACTIONS(4681),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4681),
    [anon_sym_then] = ACTIONS(4679),
    [anon_sym_using] = ACTIONS(4679),
    [anon_sym_BSLASH] = ACTIONS(4681),
    [anon_sym_if] = ACTIONS(4679),
    [anon_sym_else] = ACTIONS(4679),
    [anon_sym_mdo] = ACTIONS(4679),
    [anon_sym_do] = ACTIONS(4679),
    [anon_sym_case] = ACTIONS(4679),
    [anon_sym_of] = ACTIONS(4679),
    [anon_sym_DASH] = ACTIONS(4679),
    [anon_sym_DASH_GT] = ACTIONS(4679),
    [anon_sym_LBRACK] = ACTIONS(4681),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4681),
    [anon_sym_u27e7] = ACTIONS(4681),
    [anon_sym_u27e6] = ACTIONS(4681),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4681),
    [sym_float] = ACTIONS(4681),
    [sym_char] = ACTIONS(4681),
    [sym_string] = ACTIONS(4681),
    [sym__integer_literal] = ACTIONS(4679),
    [sym__binary_literal] = ACTIONS(4681),
    [sym__octal_literal] = ACTIONS(4681),
    [sym__hex_literal] = ACTIONS(4681),
    [anon_sym_BQUOTE] = ACTIONS(4681),
    [anon_sym_POUND] = ACTIONS(4679),
    [anon_sym_POUND2] = ACTIONS(4679),
    [sym_implicit_variable] = ACTIONS(4681),
    [sym_name] = ACTIONS(4681),
    [sym_label] = ACTIONS(4681),
    [anon_sym_u2192] = ACTIONS(4681),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4681),
    [anon_sym_u22b8] = ACTIONS(4681),
    [anon_sym_COLON_COLON] = ACTIONS(4681),
    [anon_sym_u2237] = ACTIONS(4681),
    [aux_sym__paren_open_token1] = ACTIONS(4681),
    [aux_sym__paren_close_token1] = ACTIONS(4681),
    [anon_sym_RBRACK] = ACTIONS(4681),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4681),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4681),
    [sym__cond_splice] = ACTIONS(4681),
    [sym__cond_tight_dot] = ACTIONS(4681),
    [sym__cond_prefix_dot] = ACTIONS(4681),
    [sym__cond_prefix_at] = ACTIONS(4681),
    [sym__cond_prefix_percent] = ACTIONS(4681),
    [sym__cond_qualified_op] = ACTIONS(4681),
    [sym__cond_no_section_op] = ACTIONS(4681),
    [sym__cond_minus] = ACTIONS(4681),
    [sym__varsym] = ACTIONS(4681),
    [sym__consym] = ACTIONS(4681),
  },
  [2303] = {
    [sym_variable] = ACTIONS(4683),
    [anon_sym_SEMI] = ACTIONS(4685),
    [anon_sym_let] = ACTIONS(4683),
    [anon_sym_COMMA] = ACTIONS(4685),
    [anon_sym_LBRACE] = ACTIONS(4685),
    [anon_sym_RBRACE] = ACTIONS(4685),
    [anon_sym__] = ACTIONS(4683),
    [anon_sym_SQUOTE] = ACTIONS(4683),
    [anon_sym_STAR] = ACTIONS(4685),
    [anon_sym_u2605] = ACTIONS(4685),
    [anon_sym_EQ] = ACTIONS(4685),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4685),
    [anon_sym_then] = ACTIONS(4683),
    [anon_sym_using] = ACTIONS(4683),
    [anon_sym_BSLASH] = ACTIONS(4685),
    [anon_sym_if] = ACTIONS(4683),
    [anon_sym_else] = ACTIONS(4683),
    [anon_sym_mdo] = ACTIONS(4683),
    [anon_sym_do] = ACTIONS(4683),
    [anon_sym_case] = ACTIONS(4683),
    [anon_sym_of] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_DASH_GT] = ACTIONS(4683),
    [anon_sym_LBRACK] = ACTIONS(4685),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4685),
    [anon_sym_u27e7] = ACTIONS(4685),
    [anon_sym_u27e6] = ACTIONS(4685),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4685),
    [sym_float] = ACTIONS(4685),
    [sym_char] = ACTIONS(4685),
    [sym_string] = ACTIONS(4685),
    [sym__integer_literal] = ACTIONS(4683),
    [sym__binary_literal] = ACTIONS(4685),
    [sym__octal_literal] = ACTIONS(4685),
    [sym__hex_literal] = ACTIONS(4685),
    [anon_sym_BQUOTE] = ACTIONS(4685),
    [anon_sym_POUND] = ACTIONS(4683),
    [anon_sym_POUND2] = ACTIONS(4683),
    [sym_implicit_variable] = ACTIONS(4685),
    [sym_name] = ACTIONS(4685),
    [sym_label] = ACTIONS(4685),
    [anon_sym_u2192] = ACTIONS(4685),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4685),
    [anon_sym_u22b8] = ACTIONS(4685),
    [anon_sym_COLON_COLON] = ACTIONS(4685),
    [anon_sym_u2237] = ACTIONS(4685),
    [aux_sym__paren_open_token1] = ACTIONS(4685),
    [aux_sym__paren_close_token1] = ACTIONS(4685),
    [anon_sym_RBRACK] = ACTIONS(4685),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4685),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4685),
    [sym__cond_splice] = ACTIONS(4685),
    [sym__cond_tight_dot] = ACTIONS(4685),
    [sym__cond_prefix_dot] = ACTIONS(4685),
    [sym__cond_prefix_at] = ACTIONS(4685),
    [sym__cond_prefix_percent] = ACTIONS(4685),
    [sym__cond_qualified_op] = ACTIONS(4685),
    [sym__cond_no_section_op] = ACTIONS(4685),
    [sym__cond_minus] = ACTIONS(4685),
    [sym__varsym] = ACTIONS(4685),
    [sym__consym] = ACTIONS(4685),
  },
  [2304] = {
    [sym__type_wildcard] = STATE(7980),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(12494),
    [sym__class_apply] = STATE(8005),
    [sym__class_infix] = STATE(8007),
    [sym__ctr_parens] = STATE(7980),
    [sym__ctr_tuple] = STATE(7980),
    [sym_implicit_parameter] = STATE(10828),
    [sym_constraint] = STATE(2234),
    [sym__ctr_forall] = STATE(10819),
    [sym__ctr_context] = STATE(10815),
    [sym__ctr_signature] = STATE(10805),
    [sym_constraints] = STATE(9961),
    [sym__context_inline] = STATE(2304),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11126),
    [sym__splice_dollars] = STATE(7254),
    [sym_splice] = STATE(7980),
    [sym_quasiquote] = STATE(7980),
    [sym_integer] = STATE(7997),
    [sym_unit] = STATE(7980),
    [sym_unboxed_unit] = STATE(7980),
    [sym_prefix_tuple] = STATE(7980),
    [sym_prefix_unboxed_tuple] = STATE(7980),
    [sym_prefix_unboxed_sum] = STATE(7980),
    [sym_literal] = STATE(7980),
    [sym__qualified_type] = STATE(7953),
    [sym__qtyconid] = STATE(8011),
    [sym__tycon_arrow] = STATE(8011),
    [sym__qtycon_arrow] = STATE(8011),
    [sym__promoted_tycons_alias] = STATE(7980),
    [sym__promoted_tycons] = STATE(7980),
    [sym__varsym_prefix] = STATE(8011),
    [sym__pvarsym] = STATE(8011),
    [sym__qvarsym_prefix] = STATE(8011),
    [sym__pqvarsym] = STATE(8011),
    [sym__consym_prefix] = STATE(8011),
    [sym__pconsym] = STATE(8011),
    [sym__qconsym_prefix] = STATE(8011),
    [sym__pqconsym] = STATE(8011),
    [sym__paren_open] = STATE(1536),
    [sym__unboxed_open] = STATE(9192),
    [sym_variable] = ACTIONS(3389),
    [anon_sym__] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3395),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [sym_float] = ACTIONS(3397),
    [sym_char] = ACTIONS(3397),
    [sym_string] = ACTIONS(3397),
    [sym__integer_literal] = ACTIONS(3399),
    [sym__binary_literal] = ACTIONS(3401),
    [sym__octal_literal] = ACTIONS(3401),
    [sym__hex_literal] = ACTIONS(3401),
    [sym_implicit_variable] = ACTIONS(3405),
    [sym_name] = ACTIONS(4687),
    [aux_sym__paren_open_token1] = ACTIONS(3409),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3413),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_context] = ACTIONS(3415),
    [sym__cond_infix] = ACTIONS(3417),
  },
  [2305] = {
    [sym_variable] = ACTIONS(4689),
    [anon_sym_SEMI] = ACTIONS(4691),
    [anon_sym_let] = ACTIONS(4689),
    [anon_sym_COMMA] = ACTIONS(4691),
    [anon_sym_LBRACE] = ACTIONS(4691),
    [anon_sym_RBRACE] = ACTIONS(4691),
    [anon_sym__] = ACTIONS(4689),
    [anon_sym_SQUOTE] = ACTIONS(4689),
    [anon_sym_STAR] = ACTIONS(4691),
    [anon_sym_u2605] = ACTIONS(4691),
    [anon_sym_EQ] = ACTIONS(4691),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4691),
    [anon_sym_then] = ACTIONS(4689),
    [anon_sym_using] = ACTIONS(4689),
    [anon_sym_BSLASH] = ACTIONS(4691),
    [anon_sym_if] = ACTIONS(4689),
    [anon_sym_else] = ACTIONS(4689),
    [anon_sym_mdo] = ACTIONS(4689),
    [anon_sym_do] = ACTIONS(4689),
    [anon_sym_case] = ACTIONS(4689),
    [anon_sym_of] = ACTIONS(4689),
    [anon_sym_DASH] = ACTIONS(4689),
    [anon_sym_DASH_GT] = ACTIONS(4689),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4691),
    [anon_sym_u27e7] = ACTIONS(4691),
    [anon_sym_u27e6] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4691),
    [sym_float] = ACTIONS(4691),
    [sym_char] = ACTIONS(4691),
    [sym_string] = ACTIONS(4691),
    [sym__integer_literal] = ACTIONS(4689),
    [sym__binary_literal] = ACTIONS(4691),
    [sym__octal_literal] = ACTIONS(4691),
    [sym__hex_literal] = ACTIONS(4691),
    [anon_sym_BQUOTE] = ACTIONS(4691),
    [anon_sym_POUND] = ACTIONS(4689),
    [anon_sym_POUND2] = ACTIONS(4689),
    [sym_implicit_variable] = ACTIONS(4691),
    [sym_name] = ACTIONS(4691),
    [sym_label] = ACTIONS(4691),
    [anon_sym_u2192] = ACTIONS(4691),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4691),
    [anon_sym_u22b8] = ACTIONS(4691),
    [anon_sym_COLON_COLON] = ACTIONS(4691),
    [anon_sym_u2237] = ACTIONS(4691),
    [aux_sym__paren_open_token1] = ACTIONS(4691),
    [aux_sym__paren_close_token1] = ACTIONS(4691),
    [anon_sym_RBRACK] = ACTIONS(4691),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4691),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4691),
    [sym__cond_splice] = ACTIONS(4691),
    [sym__cond_tight_dot] = ACTIONS(4691),
    [sym__cond_prefix_dot] = ACTIONS(4691),
    [sym__cond_prefix_at] = ACTIONS(4691),
    [sym__cond_prefix_percent] = ACTIONS(4691),
    [sym__cond_qualified_op] = ACTIONS(4691),
    [sym__cond_no_section_op] = ACTIONS(4691),
    [sym__cond_minus] = ACTIONS(4691),
    [sym__varsym] = ACTIONS(4691),
    [sym__consym] = ACTIONS(4691),
  },
  [2306] = {
    [sym_variable] = ACTIONS(4693),
    [anon_sym_SEMI] = ACTIONS(4695),
    [anon_sym_let] = ACTIONS(4693),
    [anon_sym_COMMA] = ACTIONS(4695),
    [anon_sym_LBRACE] = ACTIONS(4695),
    [anon_sym_RBRACE] = ACTIONS(4695),
    [anon_sym__] = ACTIONS(4693),
    [anon_sym_SQUOTE] = ACTIONS(4693),
    [anon_sym_STAR] = ACTIONS(4695),
    [anon_sym_u2605] = ACTIONS(4695),
    [anon_sym_EQ] = ACTIONS(4695),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4695),
    [anon_sym_then] = ACTIONS(4693),
    [anon_sym_using] = ACTIONS(4693),
    [anon_sym_BSLASH] = ACTIONS(4695),
    [anon_sym_if] = ACTIONS(4693),
    [anon_sym_else] = ACTIONS(4693),
    [anon_sym_mdo] = ACTIONS(4693),
    [anon_sym_do] = ACTIONS(4693),
    [anon_sym_case] = ACTIONS(4693),
    [anon_sym_of] = ACTIONS(4693),
    [anon_sym_DASH] = ACTIONS(4693),
    [anon_sym_DASH_GT] = ACTIONS(4693),
    [anon_sym_LBRACK] = ACTIONS(4695),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4695),
    [anon_sym_u27e7] = ACTIONS(4695),
    [anon_sym_u27e6] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4695),
    [sym_float] = ACTIONS(4695),
    [sym_char] = ACTIONS(4695),
    [sym_string] = ACTIONS(4695),
    [sym__integer_literal] = ACTIONS(4693),
    [sym__binary_literal] = ACTIONS(4695),
    [sym__octal_literal] = ACTIONS(4695),
    [sym__hex_literal] = ACTIONS(4695),
    [anon_sym_BQUOTE] = ACTIONS(4695),
    [anon_sym_POUND] = ACTIONS(4693),
    [anon_sym_POUND2] = ACTIONS(4693),
    [sym_implicit_variable] = ACTIONS(4695),
    [sym_name] = ACTIONS(4695),
    [sym_label] = ACTIONS(4695),
    [anon_sym_u2192] = ACTIONS(4695),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4695),
    [anon_sym_u22b8] = ACTIONS(4695),
    [anon_sym_COLON_COLON] = ACTIONS(4695),
    [anon_sym_u2237] = ACTIONS(4695),
    [aux_sym__paren_open_token1] = ACTIONS(4695),
    [aux_sym__paren_close_token1] = ACTIONS(4695),
    [anon_sym_RBRACK] = ACTIONS(4695),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4695),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4695),
    [sym__cond_splice] = ACTIONS(4695),
    [sym__cond_tight_dot] = ACTIONS(4695),
    [sym__cond_prefix_dot] = ACTIONS(4695),
    [sym__cond_prefix_at] = ACTIONS(4695),
    [sym__cond_prefix_percent] = ACTIONS(4695),
    [sym__cond_qualified_op] = ACTIONS(4695),
    [sym__cond_no_section_op] = ACTIONS(4695),
    [sym__cond_minus] = ACTIONS(4695),
    [sym__varsym] = ACTIONS(4695),
    [sym__consym] = ACTIONS(4695),
  },
  [2307] = {
    [sym_variable] = ACTIONS(4697),
    [anon_sym_SEMI] = ACTIONS(4699),
    [anon_sym_let] = ACTIONS(4697),
    [anon_sym_COMMA] = ACTIONS(4699),
    [anon_sym_LBRACE] = ACTIONS(4699),
    [anon_sym_RBRACE] = ACTIONS(4699),
    [anon_sym__] = ACTIONS(4697),
    [anon_sym_SQUOTE] = ACTIONS(4697),
    [anon_sym_STAR] = ACTIONS(4699),
    [anon_sym_u2605] = ACTIONS(4699),
    [anon_sym_EQ] = ACTIONS(4699),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4699),
    [anon_sym_then] = ACTIONS(4697),
    [anon_sym_using] = ACTIONS(4697),
    [anon_sym_BSLASH] = ACTIONS(4699),
    [anon_sym_if] = ACTIONS(4697),
    [anon_sym_else] = ACTIONS(4697),
    [anon_sym_mdo] = ACTIONS(4697),
    [anon_sym_do] = ACTIONS(4697),
    [anon_sym_case] = ACTIONS(4697),
    [anon_sym_of] = ACTIONS(4697),
    [anon_sym_DASH] = ACTIONS(4697),
    [anon_sym_DASH_GT] = ACTIONS(4697),
    [anon_sym_LBRACK] = ACTIONS(4699),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4699),
    [anon_sym_u27e7] = ACTIONS(4699),
    [anon_sym_u27e6] = ACTIONS(4699),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4699),
    [sym_float] = ACTIONS(4699),
    [sym_char] = ACTIONS(4699),
    [sym_string] = ACTIONS(4699),
    [sym__integer_literal] = ACTIONS(4697),
    [sym__binary_literal] = ACTIONS(4699),
    [sym__octal_literal] = ACTIONS(4699),
    [sym__hex_literal] = ACTIONS(4699),
    [anon_sym_BQUOTE] = ACTIONS(4699),
    [anon_sym_POUND] = ACTIONS(4697),
    [anon_sym_POUND2] = ACTIONS(4697),
    [sym_implicit_variable] = ACTIONS(4699),
    [sym_name] = ACTIONS(4699),
    [sym_label] = ACTIONS(4699),
    [anon_sym_u2192] = ACTIONS(4699),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4699),
    [anon_sym_u22b8] = ACTIONS(4699),
    [anon_sym_COLON_COLON] = ACTIONS(4699),
    [anon_sym_u2237] = ACTIONS(4699),
    [aux_sym__paren_open_token1] = ACTIONS(4699),
    [aux_sym__paren_close_token1] = ACTIONS(4699),
    [anon_sym_RBRACK] = ACTIONS(4699),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4699),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4699),
    [sym__cond_splice] = ACTIONS(4699),
    [sym__cond_tight_dot] = ACTIONS(4699),
    [sym__cond_prefix_dot] = ACTIONS(4699),
    [sym__cond_prefix_at] = ACTIONS(4699),
    [sym__cond_prefix_percent] = ACTIONS(4699),
    [sym__cond_qualified_op] = ACTIONS(4699),
    [sym__cond_no_section_op] = ACTIONS(4699),
    [sym__cond_minus] = ACTIONS(4699),
    [sym__varsym] = ACTIONS(4699),
    [sym__consym] = ACTIONS(4699),
  },
  [2308] = {
    [sym_variable] = ACTIONS(4701),
    [anon_sym_SEMI] = ACTIONS(4703),
    [anon_sym_let] = ACTIONS(4701),
    [anon_sym_COMMA] = ACTIONS(4703),
    [anon_sym_LBRACE] = ACTIONS(4703),
    [anon_sym_RBRACE] = ACTIONS(4703),
    [anon_sym__] = ACTIONS(4701),
    [anon_sym_SQUOTE] = ACTIONS(4701),
    [anon_sym_STAR] = ACTIONS(4703),
    [anon_sym_u2605] = ACTIONS(4703),
    [anon_sym_EQ] = ACTIONS(4703),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4703),
    [anon_sym_then] = ACTIONS(4701),
    [anon_sym_using] = ACTIONS(4701),
    [anon_sym_BSLASH] = ACTIONS(4703),
    [anon_sym_if] = ACTIONS(4701),
    [anon_sym_else] = ACTIONS(4701),
    [anon_sym_mdo] = ACTIONS(4701),
    [anon_sym_do] = ACTIONS(4701),
    [anon_sym_case] = ACTIONS(4701),
    [anon_sym_of] = ACTIONS(4701),
    [anon_sym_DASH] = ACTIONS(4701),
    [anon_sym_DASH_GT] = ACTIONS(4701),
    [anon_sym_LBRACK] = ACTIONS(4703),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4703),
    [anon_sym_u27e7] = ACTIONS(4703),
    [anon_sym_u27e6] = ACTIONS(4703),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4703),
    [sym_float] = ACTIONS(4703),
    [sym_char] = ACTIONS(4703),
    [sym_string] = ACTIONS(4703),
    [sym__integer_literal] = ACTIONS(4701),
    [sym__binary_literal] = ACTIONS(4703),
    [sym__octal_literal] = ACTIONS(4703),
    [sym__hex_literal] = ACTIONS(4703),
    [anon_sym_BQUOTE] = ACTIONS(4703),
    [anon_sym_POUND] = ACTIONS(4701),
    [anon_sym_POUND2] = ACTIONS(4701),
    [sym_implicit_variable] = ACTIONS(4703),
    [sym_name] = ACTIONS(4703),
    [sym_label] = ACTIONS(4703),
    [anon_sym_u2192] = ACTIONS(4703),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4703),
    [anon_sym_u22b8] = ACTIONS(4703),
    [anon_sym_COLON_COLON] = ACTIONS(4703),
    [anon_sym_u2237] = ACTIONS(4703),
    [aux_sym__paren_open_token1] = ACTIONS(4703),
    [aux_sym__paren_close_token1] = ACTIONS(4703),
    [anon_sym_RBRACK] = ACTIONS(4703),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4703),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4703),
    [sym__cond_splice] = ACTIONS(4703),
    [sym__cond_tight_dot] = ACTIONS(4703),
    [sym__cond_prefix_dot] = ACTIONS(4703),
    [sym__cond_prefix_at] = ACTIONS(4703),
    [sym__cond_prefix_percent] = ACTIONS(4703),
    [sym__cond_qualified_op] = ACTIONS(4703),
    [sym__cond_no_section_op] = ACTIONS(4703),
    [sym__cond_minus] = ACTIONS(4703),
    [sym__varsym] = ACTIONS(4703),
    [sym__consym] = ACTIONS(4703),
  },
  [2309] = {
    [sym_variable] = ACTIONS(4705),
    [anon_sym_SEMI] = ACTIONS(4707),
    [anon_sym_let] = ACTIONS(4705),
    [anon_sym_COMMA] = ACTIONS(4707),
    [anon_sym_LBRACE] = ACTIONS(4707),
    [anon_sym_RBRACE] = ACTIONS(4707),
    [anon_sym__] = ACTIONS(4705),
    [anon_sym_SQUOTE] = ACTIONS(4705),
    [anon_sym_STAR] = ACTIONS(4707),
    [anon_sym_u2605] = ACTIONS(4707),
    [anon_sym_EQ] = ACTIONS(4707),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4707),
    [anon_sym_then] = ACTIONS(4705),
    [anon_sym_using] = ACTIONS(4705),
    [anon_sym_BSLASH] = ACTIONS(4707),
    [anon_sym_if] = ACTIONS(4705),
    [anon_sym_else] = ACTIONS(4705),
    [anon_sym_mdo] = ACTIONS(4705),
    [anon_sym_do] = ACTIONS(4705),
    [anon_sym_case] = ACTIONS(4705),
    [anon_sym_of] = ACTIONS(4705),
    [anon_sym_DASH] = ACTIONS(4705),
    [anon_sym_DASH_GT] = ACTIONS(4705),
    [anon_sym_LBRACK] = ACTIONS(4707),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4707),
    [anon_sym_u27e7] = ACTIONS(4707),
    [anon_sym_u27e6] = ACTIONS(4707),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4707),
    [sym_float] = ACTIONS(4707),
    [sym_char] = ACTIONS(4707),
    [sym_string] = ACTIONS(4707),
    [sym__integer_literal] = ACTIONS(4705),
    [sym__binary_literal] = ACTIONS(4707),
    [sym__octal_literal] = ACTIONS(4707),
    [sym__hex_literal] = ACTIONS(4707),
    [anon_sym_BQUOTE] = ACTIONS(4707),
    [anon_sym_POUND] = ACTIONS(4705),
    [anon_sym_POUND2] = ACTIONS(4705),
    [sym_implicit_variable] = ACTIONS(4707),
    [sym_name] = ACTIONS(4707),
    [sym_label] = ACTIONS(4707),
    [anon_sym_u2192] = ACTIONS(4707),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4707),
    [anon_sym_u22b8] = ACTIONS(4707),
    [anon_sym_COLON_COLON] = ACTIONS(4707),
    [anon_sym_u2237] = ACTIONS(4707),
    [aux_sym__paren_open_token1] = ACTIONS(4707),
    [aux_sym__paren_close_token1] = ACTIONS(4707),
    [anon_sym_RBRACK] = ACTIONS(4707),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4707),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4707),
    [sym__cond_splice] = ACTIONS(4707),
    [sym__cond_tight_dot] = ACTIONS(4707),
    [sym__cond_prefix_dot] = ACTIONS(4707),
    [sym__cond_prefix_at] = ACTIONS(4707),
    [sym__cond_prefix_percent] = ACTIONS(4707),
    [sym__cond_qualified_op] = ACTIONS(4707),
    [sym__cond_no_section_op] = ACTIONS(4707),
    [sym__cond_minus] = ACTIONS(4707),
    [sym__varsym] = ACTIONS(4707),
    [sym__consym] = ACTIONS(4707),
  },
  [2310] = {
    [sym_variable] = ACTIONS(4709),
    [anon_sym_SEMI] = ACTIONS(4711),
    [anon_sym_let] = ACTIONS(4709),
    [anon_sym_COMMA] = ACTIONS(4711),
    [anon_sym_LBRACE] = ACTIONS(4711),
    [anon_sym_RBRACE] = ACTIONS(4711),
    [anon_sym__] = ACTIONS(4709),
    [anon_sym_SQUOTE] = ACTIONS(4709),
    [anon_sym_STAR] = ACTIONS(4711),
    [anon_sym_u2605] = ACTIONS(4711),
    [anon_sym_EQ] = ACTIONS(4711),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4711),
    [anon_sym_then] = ACTIONS(4709),
    [anon_sym_using] = ACTIONS(4709),
    [anon_sym_BSLASH] = ACTIONS(4711),
    [anon_sym_if] = ACTIONS(4709),
    [anon_sym_else] = ACTIONS(4709),
    [anon_sym_mdo] = ACTIONS(4709),
    [anon_sym_do] = ACTIONS(4709),
    [anon_sym_case] = ACTIONS(4709),
    [anon_sym_of] = ACTIONS(4709),
    [anon_sym_DASH] = ACTIONS(4709),
    [anon_sym_DASH_GT] = ACTIONS(4709),
    [anon_sym_LBRACK] = ACTIONS(4711),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4711),
    [anon_sym_u27e7] = ACTIONS(4711),
    [anon_sym_u27e6] = ACTIONS(4711),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4711),
    [sym_float] = ACTIONS(4711),
    [sym_char] = ACTIONS(4711),
    [sym_string] = ACTIONS(4711),
    [sym__integer_literal] = ACTIONS(4709),
    [sym__binary_literal] = ACTIONS(4711),
    [sym__octal_literal] = ACTIONS(4711),
    [sym__hex_literal] = ACTIONS(4711),
    [anon_sym_BQUOTE] = ACTIONS(4711),
    [anon_sym_POUND] = ACTIONS(4709),
    [anon_sym_POUND2] = ACTIONS(4709),
    [sym_implicit_variable] = ACTIONS(4711),
    [sym_name] = ACTIONS(4711),
    [sym_label] = ACTIONS(4711),
    [anon_sym_u2192] = ACTIONS(4711),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4711),
    [anon_sym_u22b8] = ACTIONS(4711),
    [anon_sym_COLON_COLON] = ACTIONS(4711),
    [anon_sym_u2237] = ACTIONS(4711),
    [aux_sym__paren_open_token1] = ACTIONS(4711),
    [aux_sym__paren_close_token1] = ACTIONS(4711),
    [anon_sym_RBRACK] = ACTIONS(4711),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4711),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4711),
    [sym__cond_splice] = ACTIONS(4711),
    [sym__cond_tight_dot] = ACTIONS(4711),
    [sym__cond_prefix_dot] = ACTIONS(4711),
    [sym__cond_prefix_at] = ACTIONS(4711),
    [sym__cond_prefix_percent] = ACTIONS(4711),
    [sym__cond_qualified_op] = ACTIONS(4711),
    [sym__cond_no_section_op] = ACTIONS(4711),
    [sym__cond_minus] = ACTIONS(4711),
    [sym__varsym] = ACTIONS(4711),
    [sym__consym] = ACTIONS(4711),
  },
  [2311] = {
    [sym_variable] = ACTIONS(4713),
    [anon_sym_SEMI] = ACTIONS(4715),
    [anon_sym_let] = ACTIONS(4713),
    [anon_sym_COMMA] = ACTIONS(4715),
    [anon_sym_LBRACE] = ACTIONS(4715),
    [anon_sym_RBRACE] = ACTIONS(4715),
    [anon_sym__] = ACTIONS(4713),
    [anon_sym_SQUOTE] = ACTIONS(4713),
    [anon_sym_STAR] = ACTIONS(4715),
    [anon_sym_u2605] = ACTIONS(4715),
    [anon_sym_EQ] = ACTIONS(4715),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4715),
    [anon_sym_then] = ACTIONS(4713),
    [anon_sym_using] = ACTIONS(4713),
    [anon_sym_BSLASH] = ACTIONS(4715),
    [anon_sym_if] = ACTIONS(4713),
    [anon_sym_else] = ACTIONS(4713),
    [anon_sym_mdo] = ACTIONS(4713),
    [anon_sym_do] = ACTIONS(4713),
    [anon_sym_case] = ACTIONS(4713),
    [anon_sym_of] = ACTIONS(4713),
    [anon_sym_DASH] = ACTIONS(4713),
    [anon_sym_DASH_GT] = ACTIONS(4713),
    [anon_sym_LBRACK] = ACTIONS(4715),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4715),
    [anon_sym_u27e7] = ACTIONS(4715),
    [anon_sym_u27e6] = ACTIONS(4715),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4715),
    [sym_float] = ACTIONS(4715),
    [sym_char] = ACTIONS(4715),
    [sym_string] = ACTIONS(4715),
    [sym__integer_literal] = ACTIONS(4713),
    [sym__binary_literal] = ACTIONS(4715),
    [sym__octal_literal] = ACTIONS(4715),
    [sym__hex_literal] = ACTIONS(4715),
    [anon_sym_BQUOTE] = ACTIONS(4715),
    [anon_sym_POUND] = ACTIONS(4713),
    [anon_sym_POUND2] = ACTIONS(4713),
    [sym_implicit_variable] = ACTIONS(4715),
    [sym_name] = ACTIONS(4715),
    [sym_label] = ACTIONS(4715),
    [anon_sym_u2192] = ACTIONS(4715),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4715),
    [anon_sym_u22b8] = ACTIONS(4715),
    [anon_sym_COLON_COLON] = ACTIONS(4715),
    [anon_sym_u2237] = ACTIONS(4715),
    [aux_sym__paren_open_token1] = ACTIONS(4715),
    [aux_sym__paren_close_token1] = ACTIONS(4715),
    [anon_sym_RBRACK] = ACTIONS(4715),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4715),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4715),
    [sym__cond_splice] = ACTIONS(4715),
    [sym__cond_tight_dot] = ACTIONS(4715),
    [sym__cond_prefix_dot] = ACTIONS(4715),
    [sym__cond_prefix_at] = ACTIONS(4715),
    [sym__cond_prefix_percent] = ACTIONS(4715),
    [sym__cond_qualified_op] = ACTIONS(4715),
    [sym__cond_no_section_op] = ACTIONS(4715),
    [sym__cond_minus] = ACTIONS(4715),
    [sym__varsym] = ACTIONS(4715),
    [sym__consym] = ACTIONS(4715),
  },
  [2312] = {
    [sym_variable] = ACTIONS(4717),
    [anon_sym_SEMI] = ACTIONS(4719),
    [anon_sym_let] = ACTIONS(4717),
    [anon_sym_COMMA] = ACTIONS(4719),
    [anon_sym_LBRACE] = ACTIONS(4719),
    [anon_sym_RBRACE] = ACTIONS(4719),
    [anon_sym__] = ACTIONS(4717),
    [anon_sym_SQUOTE] = ACTIONS(4717),
    [anon_sym_STAR] = ACTIONS(4719),
    [anon_sym_u2605] = ACTIONS(4719),
    [anon_sym_EQ] = ACTIONS(4719),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4719),
    [anon_sym_then] = ACTIONS(4717),
    [anon_sym_using] = ACTIONS(4717),
    [anon_sym_BSLASH] = ACTIONS(4719),
    [anon_sym_if] = ACTIONS(4717),
    [anon_sym_else] = ACTIONS(4717),
    [anon_sym_mdo] = ACTIONS(4717),
    [anon_sym_do] = ACTIONS(4717),
    [anon_sym_case] = ACTIONS(4717),
    [anon_sym_of] = ACTIONS(4717),
    [anon_sym_DASH] = ACTIONS(4717),
    [anon_sym_DASH_GT] = ACTIONS(4717),
    [anon_sym_LBRACK] = ACTIONS(4719),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4719),
    [anon_sym_u27e7] = ACTIONS(4719),
    [anon_sym_u27e6] = ACTIONS(4719),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4719),
    [sym_float] = ACTIONS(4719),
    [sym_char] = ACTIONS(4719),
    [sym_string] = ACTIONS(4719),
    [sym__integer_literal] = ACTIONS(4717),
    [sym__binary_literal] = ACTIONS(4719),
    [sym__octal_literal] = ACTIONS(4719),
    [sym__hex_literal] = ACTIONS(4719),
    [anon_sym_BQUOTE] = ACTIONS(4719),
    [anon_sym_POUND] = ACTIONS(4717),
    [anon_sym_POUND2] = ACTIONS(4717),
    [sym_implicit_variable] = ACTIONS(4719),
    [sym_name] = ACTIONS(4719),
    [sym_label] = ACTIONS(4719),
    [anon_sym_u2192] = ACTIONS(4719),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4719),
    [anon_sym_u22b8] = ACTIONS(4719),
    [anon_sym_COLON_COLON] = ACTIONS(4719),
    [anon_sym_u2237] = ACTIONS(4719),
    [aux_sym__paren_open_token1] = ACTIONS(4719),
    [aux_sym__paren_close_token1] = ACTIONS(4719),
    [anon_sym_RBRACK] = ACTIONS(4719),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4719),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4719),
    [sym__cond_splice] = ACTIONS(4719),
    [sym__cond_tight_dot] = ACTIONS(4719),
    [sym__cond_prefix_dot] = ACTIONS(4719),
    [sym__cond_prefix_at] = ACTIONS(4719),
    [sym__cond_prefix_percent] = ACTIONS(4719),
    [sym__cond_qualified_op] = ACTIONS(4719),
    [sym__cond_no_section_op] = ACTIONS(4719),
    [sym__cond_minus] = ACTIONS(4719),
    [sym__varsym] = ACTIONS(4719),
    [sym__consym] = ACTIONS(4719),
  },
  [2313] = {
    [sym_variable] = ACTIONS(4721),
    [anon_sym_SEMI] = ACTIONS(4723),
    [anon_sym_let] = ACTIONS(4721),
    [anon_sym_COMMA] = ACTIONS(4723),
    [anon_sym_LBRACE] = ACTIONS(4723),
    [anon_sym_RBRACE] = ACTIONS(4723),
    [anon_sym__] = ACTIONS(4721),
    [anon_sym_SQUOTE] = ACTIONS(4721),
    [anon_sym_STAR] = ACTIONS(4723),
    [anon_sym_u2605] = ACTIONS(4723),
    [anon_sym_EQ] = ACTIONS(4723),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4723),
    [anon_sym_then] = ACTIONS(4721),
    [anon_sym_using] = ACTIONS(4721),
    [anon_sym_BSLASH] = ACTIONS(4723),
    [anon_sym_if] = ACTIONS(4721),
    [anon_sym_else] = ACTIONS(4721),
    [anon_sym_mdo] = ACTIONS(4721),
    [anon_sym_do] = ACTIONS(4721),
    [anon_sym_case] = ACTIONS(4721),
    [anon_sym_of] = ACTIONS(4721),
    [anon_sym_DASH] = ACTIONS(4721),
    [anon_sym_DASH_GT] = ACTIONS(4721),
    [anon_sym_LBRACK] = ACTIONS(4723),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4723),
    [anon_sym_u27e7] = ACTIONS(4723),
    [anon_sym_u27e6] = ACTIONS(4723),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4723),
    [sym_float] = ACTIONS(4723),
    [sym_char] = ACTIONS(4723),
    [sym_string] = ACTIONS(4723),
    [sym__integer_literal] = ACTIONS(4721),
    [sym__binary_literal] = ACTIONS(4723),
    [sym__octal_literal] = ACTIONS(4723),
    [sym__hex_literal] = ACTIONS(4723),
    [anon_sym_BQUOTE] = ACTIONS(4723),
    [anon_sym_POUND] = ACTIONS(4721),
    [anon_sym_POUND2] = ACTIONS(4721),
    [sym_implicit_variable] = ACTIONS(4723),
    [sym_name] = ACTIONS(4723),
    [sym_label] = ACTIONS(4723),
    [anon_sym_u2192] = ACTIONS(4723),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4723),
    [anon_sym_u22b8] = ACTIONS(4723),
    [anon_sym_COLON_COLON] = ACTIONS(4723),
    [anon_sym_u2237] = ACTIONS(4723),
    [aux_sym__paren_open_token1] = ACTIONS(4723),
    [aux_sym__paren_close_token1] = ACTIONS(4723),
    [anon_sym_RBRACK] = ACTIONS(4723),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4723),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4723),
    [sym__cond_splice] = ACTIONS(4723),
    [sym__cond_tight_dot] = ACTIONS(4723),
    [sym__cond_prefix_dot] = ACTIONS(4723),
    [sym__cond_prefix_at] = ACTIONS(4723),
    [sym__cond_prefix_percent] = ACTIONS(4723),
    [sym__cond_qualified_op] = ACTIONS(4723),
    [sym__cond_no_section_op] = ACTIONS(4723),
    [sym__cond_minus] = ACTIONS(4723),
    [sym__varsym] = ACTIONS(4723),
    [sym__consym] = ACTIONS(4723),
  },
  [2314] = {
    [sym_variable] = ACTIONS(4725),
    [anon_sym_SEMI] = ACTIONS(4727),
    [anon_sym_let] = ACTIONS(4725),
    [anon_sym_COMMA] = ACTIONS(4727),
    [anon_sym_LBRACE] = ACTIONS(4727),
    [anon_sym_RBRACE] = ACTIONS(4727),
    [anon_sym__] = ACTIONS(4725),
    [anon_sym_SQUOTE] = ACTIONS(4725),
    [anon_sym_STAR] = ACTIONS(4727),
    [anon_sym_u2605] = ACTIONS(4727),
    [anon_sym_EQ] = ACTIONS(4727),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4727),
    [anon_sym_then] = ACTIONS(4725),
    [anon_sym_using] = ACTIONS(4725),
    [anon_sym_BSLASH] = ACTIONS(4727),
    [anon_sym_if] = ACTIONS(4725),
    [anon_sym_else] = ACTIONS(4725),
    [anon_sym_mdo] = ACTIONS(4725),
    [anon_sym_do] = ACTIONS(4725),
    [anon_sym_case] = ACTIONS(4725),
    [anon_sym_of] = ACTIONS(4725),
    [anon_sym_DASH] = ACTIONS(4725),
    [anon_sym_DASH_GT] = ACTIONS(4725),
    [anon_sym_LBRACK] = ACTIONS(4727),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4727),
    [anon_sym_u27e7] = ACTIONS(4727),
    [anon_sym_u27e6] = ACTIONS(4727),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4727),
    [sym_float] = ACTIONS(4727),
    [sym_char] = ACTIONS(4727),
    [sym_string] = ACTIONS(4727),
    [sym__integer_literal] = ACTIONS(4725),
    [sym__binary_literal] = ACTIONS(4727),
    [sym__octal_literal] = ACTIONS(4727),
    [sym__hex_literal] = ACTIONS(4727),
    [anon_sym_BQUOTE] = ACTIONS(4727),
    [anon_sym_POUND] = ACTIONS(4725),
    [anon_sym_POUND2] = ACTIONS(4725),
    [sym_implicit_variable] = ACTIONS(4727),
    [sym_name] = ACTIONS(4727),
    [sym_label] = ACTIONS(4727),
    [anon_sym_u2192] = ACTIONS(4727),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4727),
    [anon_sym_u22b8] = ACTIONS(4727),
    [anon_sym_COLON_COLON] = ACTIONS(4727),
    [anon_sym_u2237] = ACTIONS(4727),
    [aux_sym__paren_open_token1] = ACTIONS(4727),
    [aux_sym__paren_close_token1] = ACTIONS(4727),
    [anon_sym_RBRACK] = ACTIONS(4727),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4727),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4727),
    [sym__cond_splice] = ACTIONS(4727),
    [sym__cond_tight_dot] = ACTIONS(4727),
    [sym__cond_prefix_dot] = ACTIONS(4727),
    [sym__cond_prefix_at] = ACTIONS(4727),
    [sym__cond_prefix_percent] = ACTIONS(4727),
    [sym__cond_qualified_op] = ACTIONS(4727),
    [sym__cond_no_section_op] = ACTIONS(4727),
    [sym__cond_minus] = ACTIONS(4727),
    [sym__varsym] = ACTIONS(4727),
    [sym__consym] = ACTIONS(4727),
  },
  [2315] = {
    [sym_variable] = ACTIONS(4729),
    [anon_sym_SEMI] = ACTIONS(4731),
    [anon_sym_let] = ACTIONS(4729),
    [anon_sym_COMMA] = ACTIONS(4731),
    [anon_sym_LBRACE] = ACTIONS(4731),
    [anon_sym_RBRACE] = ACTIONS(4731),
    [anon_sym__] = ACTIONS(4729),
    [anon_sym_SQUOTE] = ACTIONS(4729),
    [anon_sym_STAR] = ACTIONS(4731),
    [anon_sym_u2605] = ACTIONS(4731),
    [anon_sym_EQ] = ACTIONS(4731),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4731),
    [anon_sym_then] = ACTIONS(4729),
    [anon_sym_using] = ACTIONS(4729),
    [anon_sym_BSLASH] = ACTIONS(4731),
    [anon_sym_if] = ACTIONS(4729),
    [anon_sym_else] = ACTIONS(4729),
    [anon_sym_mdo] = ACTIONS(4729),
    [anon_sym_do] = ACTIONS(4729),
    [anon_sym_case] = ACTIONS(4729),
    [anon_sym_of] = ACTIONS(4729),
    [anon_sym_DASH] = ACTIONS(4729),
    [anon_sym_DASH_GT] = ACTIONS(4729),
    [anon_sym_LBRACK] = ACTIONS(4731),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4731),
    [anon_sym_u27e7] = ACTIONS(4731),
    [anon_sym_u27e6] = ACTIONS(4731),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4731),
    [sym_float] = ACTIONS(4731),
    [sym_char] = ACTIONS(4731),
    [sym_string] = ACTIONS(4731),
    [sym__integer_literal] = ACTIONS(4729),
    [sym__binary_literal] = ACTIONS(4731),
    [sym__octal_literal] = ACTIONS(4731),
    [sym__hex_literal] = ACTIONS(4731),
    [anon_sym_BQUOTE] = ACTIONS(4731),
    [anon_sym_POUND] = ACTIONS(4729),
    [anon_sym_POUND2] = ACTIONS(4729),
    [sym_implicit_variable] = ACTIONS(4731),
    [sym_name] = ACTIONS(4731),
    [sym_label] = ACTIONS(4731),
    [anon_sym_u2192] = ACTIONS(4731),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4731),
    [anon_sym_u22b8] = ACTIONS(4731),
    [anon_sym_COLON_COLON] = ACTIONS(4731),
    [anon_sym_u2237] = ACTIONS(4731),
    [aux_sym__paren_open_token1] = ACTIONS(4731),
    [aux_sym__paren_close_token1] = ACTIONS(4731),
    [anon_sym_RBRACK] = ACTIONS(4731),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4731),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4731),
    [sym__cond_splice] = ACTIONS(4731),
    [sym__cond_tight_dot] = ACTIONS(4731),
    [sym__cond_prefix_dot] = ACTIONS(4731),
    [sym__cond_prefix_at] = ACTIONS(4731),
    [sym__cond_prefix_percent] = ACTIONS(4731),
    [sym__cond_qualified_op] = ACTIONS(4731),
    [sym__cond_no_section_op] = ACTIONS(4731),
    [sym__cond_minus] = ACTIONS(4731),
    [sym__varsym] = ACTIONS(4731),
    [sym__consym] = ACTIONS(4731),
  },
  [2316] = {
    [sym_variable] = ACTIONS(4733),
    [anon_sym_SEMI] = ACTIONS(4735),
    [anon_sym_let] = ACTIONS(4733),
    [anon_sym_COMMA] = ACTIONS(4735),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [anon_sym_RBRACE] = ACTIONS(4735),
    [anon_sym__] = ACTIONS(4733),
    [anon_sym_SQUOTE] = ACTIONS(4733),
    [anon_sym_STAR] = ACTIONS(4735),
    [anon_sym_u2605] = ACTIONS(4735),
    [anon_sym_EQ] = ACTIONS(4735),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4735),
    [anon_sym_then] = ACTIONS(4733),
    [anon_sym_using] = ACTIONS(4733),
    [anon_sym_BSLASH] = ACTIONS(4735),
    [anon_sym_if] = ACTIONS(4733),
    [anon_sym_else] = ACTIONS(4733),
    [anon_sym_mdo] = ACTIONS(4733),
    [anon_sym_do] = ACTIONS(4733),
    [anon_sym_case] = ACTIONS(4733),
    [anon_sym_of] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4733),
    [anon_sym_DASH_GT] = ACTIONS(4733),
    [anon_sym_LBRACK] = ACTIONS(4735),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4735),
    [anon_sym_u27e7] = ACTIONS(4735),
    [anon_sym_u27e6] = ACTIONS(4735),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4735),
    [sym_float] = ACTIONS(4735),
    [sym_char] = ACTIONS(4735),
    [sym_string] = ACTIONS(4735),
    [sym__integer_literal] = ACTIONS(4733),
    [sym__binary_literal] = ACTIONS(4735),
    [sym__octal_literal] = ACTIONS(4735),
    [sym__hex_literal] = ACTIONS(4735),
    [anon_sym_BQUOTE] = ACTIONS(4735),
    [anon_sym_POUND] = ACTIONS(4733),
    [anon_sym_POUND2] = ACTIONS(4733),
    [sym_implicit_variable] = ACTIONS(4735),
    [sym_name] = ACTIONS(4735),
    [sym_label] = ACTIONS(4735),
    [anon_sym_u2192] = ACTIONS(4735),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4735),
    [anon_sym_u22b8] = ACTIONS(4735),
    [anon_sym_COLON_COLON] = ACTIONS(4735),
    [anon_sym_u2237] = ACTIONS(4735),
    [aux_sym__paren_open_token1] = ACTIONS(4735),
    [aux_sym__paren_close_token1] = ACTIONS(4735),
    [anon_sym_RBRACK] = ACTIONS(4735),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4735),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4735),
    [sym__cond_splice] = ACTIONS(4735),
    [sym__cond_tight_dot] = ACTIONS(4735),
    [sym__cond_prefix_dot] = ACTIONS(4735),
    [sym__cond_prefix_at] = ACTIONS(4735),
    [sym__cond_prefix_percent] = ACTIONS(4735),
    [sym__cond_qualified_op] = ACTIONS(4735),
    [sym__cond_no_section_op] = ACTIONS(4735),
    [sym__cond_minus] = ACTIONS(4735),
    [sym__varsym] = ACTIONS(4735),
    [sym__consym] = ACTIONS(4735),
  },
  [2317] = {
    [sym__guards] = STATE(12352),
    [sym__simple_bind_match] = STATE(9050),
    [sym__bind_match] = STATE(8990),
    [sym__bind_matches] = STATE(10251),
    [sym__colon2] = STATE(1444),
    [sym__bar] = STATE(12338),
    [aux_sym__var_binding_list_repeat1] = STATE(10252),
    [aux_sym__bind_matches_repeat1] = STATE(8422),
    [sym_variable] = ACTIONS(4642),
    [anon_sym_SEMI] = ACTIONS(4646),
    [anon_sym_let] = ACTIONS(4648),
    [anon_sym_COMMA] = ACTIONS(4650),
    [anon_sym_LBRACE] = ACTIONS(4652),
    [anon_sym__] = ACTIONS(4655),
    [anon_sym_SQUOTE] = ACTIONS(4648),
    [anon_sym_STAR] = ACTIONS(4652),
    [anon_sym_EQ] = ACTIONS(4658),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4646),
    [anon_sym_PIPE] = ACTIONS(4660),
    [anon_sym_BSLASH] = ACTIONS(4646),
    [anon_sym_if] = ACTIONS(4648),
    [anon_sym_mdo] = ACTIONS(4648),
    [anon_sym_do] = ACTIONS(4648),
    [anon_sym_case] = ACTIONS(4648),
    [anon_sym_DASH] = ACTIONS(4662),
    [anon_sym_LBRACK] = ACTIONS(4662),
    [anon_sym_u27e6] = ACTIONS(4646),
    [sym_float] = ACTIONS(4662),
    [sym_char] = ACTIONS(4662),
    [sym_string] = ACTIONS(4662),
    [sym__integer_literal] = ACTIONS(4642),
    [sym__binary_literal] = ACTIONS(4662),
    [sym__octal_literal] = ACTIONS(4662),
    [sym__hex_literal] = ACTIONS(4662),
    [anon_sym_BQUOTE] = ACTIONS(4652),
    [anon_sym_POUND] = ACTIONS(4666),
    [anon_sym_POUND2] = ACTIONS(4666),
    [sym_implicit_variable] = ACTIONS(4646),
    [sym_name] = ACTIONS(4662),
    [sym_label] = ACTIONS(4646),
    [anon_sym_COLON_COLON] = ACTIONS(4669),
    [anon_sym_u2237] = ACTIONS(4669),
    [aux_sym__paren_open_token1] = ACTIONS(4662),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4646),
    [sym__cond_layout_end] = ACTIONS(4646),
    [sym__cond_layout_end_explicit] = ACTIONS(4646),
    [sym__phantom_bar] = ACTIONS(4672),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4662),
    [sym__cond_splice] = ACTIONS(4662),
    [sym__cond_tight_dot] = ACTIONS(4646),
    [sym__cond_prefix_dot] = ACTIONS(4652),
    [sym__cond_prefix_at] = ACTIONS(4662),
    [sym__cond_tight_bang] = ACTIONS(4676),
    [sym__cond_prefix_bang] = ACTIONS(4676),
    [sym__cond_tight_tilde] = ACTIONS(4676),
    [sym__cond_prefix_tilde] = ACTIONS(4676),
    [sym__cond_qualified_op] = ACTIONS(4652),
    [sym__cond_no_section_op] = ACTIONS(4652),
    [sym__cond_minus] = ACTIONS(4652),
    [sym__varsym] = ACTIONS(4652),
    [sym__consym] = ACTIONS(4652),
  },
  [2318] = {
    [sym_variable] = ACTIONS(4737),
    [anon_sym_SEMI] = ACTIONS(4739),
    [anon_sym_let] = ACTIONS(4737),
    [anon_sym_COMMA] = ACTIONS(4739),
    [anon_sym_LBRACE] = ACTIONS(4739),
    [anon_sym_RBRACE] = ACTIONS(4739),
    [anon_sym__] = ACTIONS(4737),
    [anon_sym_SQUOTE] = ACTIONS(4737),
    [anon_sym_STAR] = ACTIONS(4739),
    [anon_sym_u2605] = ACTIONS(4739),
    [anon_sym_EQ] = ACTIONS(4739),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4739),
    [anon_sym_then] = ACTIONS(4737),
    [anon_sym_using] = ACTIONS(4737),
    [anon_sym_BSLASH] = ACTIONS(4739),
    [anon_sym_if] = ACTIONS(4737),
    [anon_sym_else] = ACTIONS(4737),
    [anon_sym_mdo] = ACTIONS(4737),
    [anon_sym_do] = ACTIONS(4737),
    [anon_sym_case] = ACTIONS(4737),
    [anon_sym_of] = ACTIONS(4737),
    [anon_sym_DASH] = ACTIONS(4737),
    [anon_sym_DASH_GT] = ACTIONS(4737),
    [anon_sym_LBRACK] = ACTIONS(4739),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4739),
    [anon_sym_u27e7] = ACTIONS(4739),
    [anon_sym_u27e6] = ACTIONS(4739),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4739),
    [sym_float] = ACTIONS(4739),
    [sym_char] = ACTIONS(4739),
    [sym_string] = ACTIONS(4739),
    [sym__integer_literal] = ACTIONS(4737),
    [sym__binary_literal] = ACTIONS(4739),
    [sym__octal_literal] = ACTIONS(4739),
    [sym__hex_literal] = ACTIONS(4739),
    [anon_sym_BQUOTE] = ACTIONS(4739),
    [anon_sym_POUND] = ACTIONS(4737),
    [anon_sym_POUND2] = ACTIONS(4737),
    [sym_implicit_variable] = ACTIONS(4739),
    [sym_name] = ACTIONS(4739),
    [sym_label] = ACTIONS(4739),
    [anon_sym_u2192] = ACTIONS(4739),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4739),
    [anon_sym_u22b8] = ACTIONS(4739),
    [anon_sym_COLON_COLON] = ACTIONS(4739),
    [anon_sym_u2237] = ACTIONS(4739),
    [aux_sym__paren_open_token1] = ACTIONS(4739),
    [aux_sym__paren_close_token1] = ACTIONS(4739),
    [anon_sym_RBRACK] = ACTIONS(4739),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4739),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4739),
    [sym__cond_splice] = ACTIONS(4739),
    [sym__cond_tight_dot] = ACTIONS(4739),
    [sym__cond_prefix_dot] = ACTIONS(4739),
    [sym__cond_prefix_at] = ACTIONS(4739),
    [sym__cond_prefix_percent] = ACTIONS(4739),
    [sym__cond_qualified_op] = ACTIONS(4739),
    [sym__cond_no_section_op] = ACTIONS(4739),
    [sym__cond_minus] = ACTIONS(4739),
    [sym__varsym] = ACTIONS(4739),
    [sym__consym] = ACTIONS(4739),
  },
  [2319] = {
    [sym_variable] = ACTIONS(4741),
    [anon_sym_SEMI] = ACTIONS(4743),
    [anon_sym_let] = ACTIONS(4741),
    [anon_sym_COMMA] = ACTIONS(4743),
    [anon_sym_LBRACE] = ACTIONS(4743),
    [anon_sym_RBRACE] = ACTIONS(4743),
    [anon_sym__] = ACTIONS(4741),
    [anon_sym_SQUOTE] = ACTIONS(4741),
    [anon_sym_STAR] = ACTIONS(4743),
    [anon_sym_u2605] = ACTIONS(4743),
    [anon_sym_EQ] = ACTIONS(4743),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4743),
    [anon_sym_then] = ACTIONS(4741),
    [anon_sym_using] = ACTIONS(4741),
    [anon_sym_BSLASH] = ACTIONS(4743),
    [anon_sym_if] = ACTIONS(4741),
    [anon_sym_else] = ACTIONS(4741),
    [anon_sym_mdo] = ACTIONS(4741),
    [anon_sym_do] = ACTIONS(4741),
    [anon_sym_case] = ACTIONS(4741),
    [anon_sym_of] = ACTIONS(4741),
    [anon_sym_DASH] = ACTIONS(4741),
    [anon_sym_DASH_GT] = ACTIONS(4741),
    [anon_sym_LBRACK] = ACTIONS(4743),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4743),
    [anon_sym_u27e7] = ACTIONS(4743),
    [anon_sym_u27e6] = ACTIONS(4743),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4743),
    [sym_float] = ACTIONS(4743),
    [sym_char] = ACTIONS(4743),
    [sym_string] = ACTIONS(4743),
    [sym__integer_literal] = ACTIONS(4741),
    [sym__binary_literal] = ACTIONS(4743),
    [sym__octal_literal] = ACTIONS(4743),
    [sym__hex_literal] = ACTIONS(4743),
    [anon_sym_BQUOTE] = ACTIONS(4743),
    [anon_sym_POUND] = ACTIONS(4741),
    [anon_sym_POUND2] = ACTIONS(4741),
    [sym_implicit_variable] = ACTIONS(4743),
    [sym_name] = ACTIONS(4743),
    [sym_label] = ACTIONS(4743),
    [anon_sym_u2192] = ACTIONS(4743),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4743),
    [anon_sym_u22b8] = ACTIONS(4743),
    [anon_sym_COLON_COLON] = ACTIONS(4743),
    [anon_sym_u2237] = ACTIONS(4743),
    [aux_sym__paren_open_token1] = ACTIONS(4743),
    [aux_sym__paren_close_token1] = ACTIONS(4743),
    [anon_sym_RBRACK] = ACTIONS(4743),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4743),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4743),
    [sym__cond_splice] = ACTIONS(4743),
    [sym__cond_tight_dot] = ACTIONS(4743),
    [sym__cond_prefix_dot] = ACTIONS(4743),
    [sym__cond_prefix_at] = ACTIONS(4743),
    [sym__cond_prefix_percent] = ACTIONS(4743),
    [sym__cond_qualified_op] = ACTIONS(4743),
    [sym__cond_no_section_op] = ACTIONS(4743),
    [sym__cond_minus] = ACTIONS(4743),
    [sym__varsym] = ACTIONS(4743),
    [sym__consym] = ACTIONS(4743),
  },
  [2320] = {
    [sym_variable] = ACTIONS(4745),
    [anon_sym_SEMI] = ACTIONS(4747),
    [anon_sym_let] = ACTIONS(4745),
    [anon_sym_COMMA] = ACTIONS(4747),
    [anon_sym_LBRACE] = ACTIONS(4747),
    [anon_sym_RBRACE] = ACTIONS(4747),
    [anon_sym__] = ACTIONS(4745),
    [anon_sym_SQUOTE] = ACTIONS(4745),
    [anon_sym_STAR] = ACTIONS(4747),
    [anon_sym_u2605] = ACTIONS(4747),
    [anon_sym_EQ] = ACTIONS(4747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4747),
    [anon_sym_then] = ACTIONS(4745),
    [anon_sym_using] = ACTIONS(4745),
    [anon_sym_BSLASH] = ACTIONS(4747),
    [anon_sym_if] = ACTIONS(4745),
    [anon_sym_else] = ACTIONS(4745),
    [anon_sym_mdo] = ACTIONS(4745),
    [anon_sym_do] = ACTIONS(4745),
    [anon_sym_case] = ACTIONS(4745),
    [anon_sym_of] = ACTIONS(4745),
    [anon_sym_DASH] = ACTIONS(4745),
    [anon_sym_DASH_GT] = ACTIONS(4745),
    [anon_sym_LBRACK] = ACTIONS(4747),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4747),
    [anon_sym_u27e7] = ACTIONS(4747),
    [anon_sym_u27e6] = ACTIONS(4747),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4747),
    [sym_float] = ACTIONS(4747),
    [sym_char] = ACTIONS(4747),
    [sym_string] = ACTIONS(4747),
    [sym__integer_literal] = ACTIONS(4745),
    [sym__binary_literal] = ACTIONS(4747),
    [sym__octal_literal] = ACTIONS(4747),
    [sym__hex_literal] = ACTIONS(4747),
    [anon_sym_BQUOTE] = ACTIONS(4747),
    [anon_sym_POUND] = ACTIONS(4745),
    [anon_sym_POUND2] = ACTIONS(4745),
    [sym_implicit_variable] = ACTIONS(4747),
    [sym_name] = ACTIONS(4747),
    [sym_label] = ACTIONS(4747),
    [anon_sym_u2192] = ACTIONS(4747),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4747),
    [anon_sym_u22b8] = ACTIONS(4747),
    [anon_sym_COLON_COLON] = ACTIONS(4747),
    [anon_sym_u2237] = ACTIONS(4747),
    [aux_sym__paren_open_token1] = ACTIONS(4747),
    [aux_sym__paren_close_token1] = ACTIONS(4747),
    [anon_sym_RBRACK] = ACTIONS(4747),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4747),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4747),
    [sym__cond_splice] = ACTIONS(4747),
    [sym__cond_tight_dot] = ACTIONS(4747),
    [sym__cond_prefix_dot] = ACTIONS(4747),
    [sym__cond_prefix_at] = ACTIONS(4747),
    [sym__cond_prefix_percent] = ACTIONS(4747),
    [sym__cond_qualified_op] = ACTIONS(4747),
    [sym__cond_no_section_op] = ACTIONS(4747),
    [sym__cond_minus] = ACTIONS(4747),
    [sym__varsym] = ACTIONS(4747),
    [sym__consym] = ACTIONS(4747),
  },
  [2321] = {
    [sym_variable] = ACTIONS(4749),
    [anon_sym_SEMI] = ACTIONS(4751),
    [anon_sym_let] = ACTIONS(4749),
    [anon_sym_COMMA] = ACTIONS(4751),
    [anon_sym_LBRACE] = ACTIONS(4751),
    [anon_sym_RBRACE] = ACTIONS(4751),
    [anon_sym__] = ACTIONS(4749),
    [anon_sym_SQUOTE] = ACTIONS(4749),
    [anon_sym_STAR] = ACTIONS(4751),
    [anon_sym_u2605] = ACTIONS(4751),
    [anon_sym_EQ] = ACTIONS(4751),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4751),
    [anon_sym_then] = ACTIONS(4749),
    [anon_sym_using] = ACTIONS(4749),
    [anon_sym_BSLASH] = ACTIONS(4751),
    [anon_sym_if] = ACTIONS(4749),
    [anon_sym_else] = ACTIONS(4749),
    [anon_sym_mdo] = ACTIONS(4749),
    [anon_sym_do] = ACTIONS(4749),
    [anon_sym_case] = ACTIONS(4749),
    [anon_sym_of] = ACTIONS(4749),
    [anon_sym_DASH] = ACTIONS(4749),
    [anon_sym_DASH_GT] = ACTIONS(4749),
    [anon_sym_LBRACK] = ACTIONS(4751),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4751),
    [anon_sym_u27e7] = ACTIONS(4751),
    [anon_sym_u27e6] = ACTIONS(4751),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4751),
    [sym_float] = ACTIONS(4751),
    [sym_char] = ACTIONS(4751),
    [sym_string] = ACTIONS(4751),
    [sym__integer_literal] = ACTIONS(4749),
    [sym__binary_literal] = ACTIONS(4751),
    [sym__octal_literal] = ACTIONS(4751),
    [sym__hex_literal] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4751),
    [anon_sym_POUND] = ACTIONS(4749),
    [anon_sym_POUND2] = ACTIONS(4749),
    [sym_implicit_variable] = ACTIONS(4751),
    [sym_name] = ACTIONS(4751),
    [sym_label] = ACTIONS(4751),
    [anon_sym_u2192] = ACTIONS(4751),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4751),
    [anon_sym_u22b8] = ACTIONS(4751),
    [anon_sym_COLON_COLON] = ACTIONS(4751),
    [anon_sym_u2237] = ACTIONS(4751),
    [aux_sym__paren_open_token1] = ACTIONS(4751),
    [aux_sym__paren_close_token1] = ACTIONS(4751),
    [anon_sym_RBRACK] = ACTIONS(4751),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4751),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4751),
    [sym__cond_splice] = ACTIONS(4751),
    [sym__cond_tight_dot] = ACTIONS(4751),
    [sym__cond_prefix_dot] = ACTIONS(4751),
    [sym__cond_prefix_at] = ACTIONS(4751),
    [sym__cond_prefix_percent] = ACTIONS(4751),
    [sym__cond_qualified_op] = ACTIONS(4751),
    [sym__cond_no_section_op] = ACTIONS(4751),
    [sym__cond_minus] = ACTIONS(4751),
    [sym__varsym] = ACTIONS(4751),
    [sym__consym] = ACTIONS(4751),
  },
  [2322] = {
    [sym_variable] = ACTIONS(4753),
    [anon_sym_SEMI] = ACTIONS(4755),
    [anon_sym_let] = ACTIONS(4753),
    [anon_sym_COMMA] = ACTIONS(4755),
    [anon_sym_LBRACE] = ACTIONS(4755),
    [anon_sym_RBRACE] = ACTIONS(4755),
    [anon_sym__] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4753),
    [anon_sym_STAR] = ACTIONS(4755),
    [anon_sym_u2605] = ACTIONS(4755),
    [anon_sym_EQ] = ACTIONS(4755),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4755),
    [anon_sym_then] = ACTIONS(4753),
    [anon_sym_using] = ACTIONS(4753),
    [anon_sym_BSLASH] = ACTIONS(4755),
    [anon_sym_if] = ACTIONS(4753),
    [anon_sym_else] = ACTIONS(4753),
    [anon_sym_mdo] = ACTIONS(4753),
    [anon_sym_do] = ACTIONS(4753),
    [anon_sym_case] = ACTIONS(4753),
    [anon_sym_of] = ACTIONS(4753),
    [anon_sym_DASH] = ACTIONS(4753),
    [anon_sym_DASH_GT] = ACTIONS(4753),
    [anon_sym_LBRACK] = ACTIONS(4755),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4755),
    [anon_sym_u27e7] = ACTIONS(4755),
    [anon_sym_u27e6] = ACTIONS(4755),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4755),
    [sym_float] = ACTIONS(4755),
    [sym_char] = ACTIONS(4755),
    [sym_string] = ACTIONS(4755),
    [sym__integer_literal] = ACTIONS(4753),
    [sym__binary_literal] = ACTIONS(4755),
    [sym__octal_literal] = ACTIONS(4755),
    [sym__hex_literal] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4755),
    [anon_sym_POUND] = ACTIONS(4753),
    [anon_sym_POUND2] = ACTIONS(4753),
    [sym_implicit_variable] = ACTIONS(4755),
    [sym_name] = ACTIONS(4755),
    [sym_label] = ACTIONS(4755),
    [anon_sym_u2192] = ACTIONS(4755),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4755),
    [anon_sym_u22b8] = ACTIONS(4755),
    [anon_sym_COLON_COLON] = ACTIONS(4755),
    [anon_sym_u2237] = ACTIONS(4755),
    [aux_sym__paren_open_token1] = ACTIONS(4755),
    [aux_sym__paren_close_token1] = ACTIONS(4755),
    [anon_sym_RBRACK] = ACTIONS(4755),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4755),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4755),
    [sym__cond_splice] = ACTIONS(4755),
    [sym__cond_tight_dot] = ACTIONS(4755),
    [sym__cond_prefix_dot] = ACTIONS(4755),
    [sym__cond_prefix_at] = ACTIONS(4755),
    [sym__cond_prefix_percent] = ACTIONS(4755),
    [sym__cond_qualified_op] = ACTIONS(4755),
    [sym__cond_no_section_op] = ACTIONS(4755),
    [sym__cond_minus] = ACTIONS(4755),
    [sym__varsym] = ACTIONS(4755),
    [sym__consym] = ACTIONS(4755),
  },
  [2323] = {
    [sym_variable] = ACTIONS(4757),
    [anon_sym_SEMI] = ACTIONS(4759),
    [anon_sym_let] = ACTIONS(4757),
    [anon_sym_COMMA] = ACTIONS(4759),
    [anon_sym_LBRACE] = ACTIONS(4759),
    [anon_sym_RBRACE] = ACTIONS(4759),
    [anon_sym__] = ACTIONS(4757),
    [anon_sym_SQUOTE] = ACTIONS(4757),
    [anon_sym_STAR] = ACTIONS(4759),
    [anon_sym_u2605] = ACTIONS(4759),
    [anon_sym_EQ] = ACTIONS(4759),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4759),
    [anon_sym_then] = ACTIONS(4757),
    [anon_sym_using] = ACTIONS(4757),
    [anon_sym_BSLASH] = ACTIONS(4759),
    [anon_sym_if] = ACTIONS(4757),
    [anon_sym_else] = ACTIONS(4757),
    [anon_sym_mdo] = ACTIONS(4757),
    [anon_sym_do] = ACTIONS(4757),
    [anon_sym_case] = ACTIONS(4757),
    [anon_sym_of] = ACTIONS(4757),
    [anon_sym_DASH] = ACTIONS(4757),
    [anon_sym_DASH_GT] = ACTIONS(4757),
    [anon_sym_LBRACK] = ACTIONS(4759),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4759),
    [anon_sym_u27e7] = ACTIONS(4759),
    [anon_sym_u27e6] = ACTIONS(4759),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4759),
    [sym_float] = ACTIONS(4759),
    [sym_char] = ACTIONS(4759),
    [sym_string] = ACTIONS(4759),
    [sym__integer_literal] = ACTIONS(4757),
    [sym__binary_literal] = ACTIONS(4759),
    [sym__octal_literal] = ACTIONS(4759),
    [sym__hex_literal] = ACTIONS(4759),
    [anon_sym_BQUOTE] = ACTIONS(4759),
    [anon_sym_POUND] = ACTIONS(4757),
    [anon_sym_POUND2] = ACTIONS(4757),
    [sym_implicit_variable] = ACTIONS(4759),
    [sym_name] = ACTIONS(4759),
    [sym_label] = ACTIONS(4759),
    [anon_sym_u2192] = ACTIONS(4759),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4759),
    [anon_sym_u22b8] = ACTIONS(4759),
    [anon_sym_COLON_COLON] = ACTIONS(4759),
    [anon_sym_u2237] = ACTIONS(4759),
    [aux_sym__paren_open_token1] = ACTIONS(4759),
    [aux_sym__paren_close_token1] = ACTIONS(4759),
    [anon_sym_RBRACK] = ACTIONS(4759),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4759),
    [sym__cond_splice] = ACTIONS(4759),
    [sym__cond_tight_dot] = ACTIONS(4759),
    [sym__cond_prefix_dot] = ACTIONS(4759),
    [sym__cond_prefix_at] = ACTIONS(4759),
    [sym__cond_prefix_percent] = ACTIONS(4759),
    [sym__cond_qualified_op] = ACTIONS(4759),
    [sym__cond_no_section_op] = ACTIONS(4759),
    [sym__cond_minus] = ACTIONS(4759),
    [sym__varsym] = ACTIONS(4759),
    [sym__consym] = ACTIONS(4759),
  },
  [2324] = {
    [sym_variable] = ACTIONS(4761),
    [anon_sym_SEMI] = ACTIONS(4763),
    [anon_sym_let] = ACTIONS(4761),
    [anon_sym_COMMA] = ACTIONS(4763),
    [anon_sym_LBRACE] = ACTIONS(4763),
    [anon_sym_RBRACE] = ACTIONS(4763),
    [anon_sym__] = ACTIONS(4761),
    [anon_sym_SQUOTE] = ACTIONS(4761),
    [anon_sym_STAR] = ACTIONS(4763),
    [anon_sym_u2605] = ACTIONS(4763),
    [anon_sym_EQ] = ACTIONS(4763),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4763),
    [anon_sym_then] = ACTIONS(4761),
    [anon_sym_using] = ACTIONS(4761),
    [anon_sym_BSLASH] = ACTIONS(4763),
    [anon_sym_if] = ACTIONS(4761),
    [anon_sym_else] = ACTIONS(4761),
    [anon_sym_mdo] = ACTIONS(4761),
    [anon_sym_do] = ACTIONS(4761),
    [anon_sym_case] = ACTIONS(4761),
    [anon_sym_of] = ACTIONS(4761),
    [anon_sym_DASH] = ACTIONS(4761),
    [anon_sym_DASH_GT] = ACTIONS(4761),
    [anon_sym_LBRACK] = ACTIONS(4763),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4763),
    [anon_sym_u27e7] = ACTIONS(4763),
    [anon_sym_u27e6] = ACTIONS(4763),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4763),
    [sym_float] = ACTIONS(4763),
    [sym_char] = ACTIONS(4763),
    [sym_string] = ACTIONS(4763),
    [sym__integer_literal] = ACTIONS(4761),
    [sym__binary_literal] = ACTIONS(4763),
    [sym__octal_literal] = ACTIONS(4763),
    [sym__hex_literal] = ACTIONS(4763),
    [anon_sym_BQUOTE] = ACTIONS(4763),
    [anon_sym_POUND] = ACTIONS(4761),
    [anon_sym_POUND2] = ACTIONS(4761),
    [sym_implicit_variable] = ACTIONS(4763),
    [sym_name] = ACTIONS(4763),
    [sym_label] = ACTIONS(4763),
    [anon_sym_u2192] = ACTIONS(4763),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4763),
    [anon_sym_u22b8] = ACTIONS(4763),
    [anon_sym_COLON_COLON] = ACTIONS(4763),
    [anon_sym_u2237] = ACTIONS(4763),
    [aux_sym__paren_open_token1] = ACTIONS(4763),
    [aux_sym__paren_close_token1] = ACTIONS(4763),
    [anon_sym_RBRACK] = ACTIONS(4763),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4763),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4763),
    [sym__cond_splice] = ACTIONS(4763),
    [sym__cond_tight_dot] = ACTIONS(4763),
    [sym__cond_prefix_dot] = ACTIONS(4763),
    [sym__cond_prefix_at] = ACTIONS(4763),
    [sym__cond_prefix_percent] = ACTIONS(4763),
    [sym__cond_qualified_op] = ACTIONS(4763),
    [sym__cond_no_section_op] = ACTIONS(4763),
    [sym__cond_minus] = ACTIONS(4763),
    [sym__varsym] = ACTIONS(4763),
    [sym__consym] = ACTIONS(4763),
  },
  [2325] = {
    [sym_variable] = ACTIONS(4765),
    [anon_sym_SEMI] = ACTIONS(4767),
    [anon_sym_let] = ACTIONS(4765),
    [anon_sym_COMMA] = ACTIONS(4767),
    [anon_sym_LBRACE] = ACTIONS(4767),
    [anon_sym_RBRACE] = ACTIONS(4767),
    [anon_sym__] = ACTIONS(4765),
    [anon_sym_SQUOTE] = ACTIONS(4765),
    [anon_sym_STAR] = ACTIONS(4767),
    [anon_sym_u2605] = ACTIONS(4767),
    [anon_sym_EQ] = ACTIONS(4767),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4767),
    [anon_sym_then] = ACTIONS(4765),
    [anon_sym_using] = ACTIONS(4765),
    [anon_sym_BSLASH] = ACTIONS(4767),
    [anon_sym_if] = ACTIONS(4765),
    [anon_sym_else] = ACTIONS(4765),
    [anon_sym_mdo] = ACTIONS(4765),
    [anon_sym_do] = ACTIONS(4765),
    [anon_sym_case] = ACTIONS(4765),
    [anon_sym_of] = ACTIONS(4765),
    [anon_sym_DASH] = ACTIONS(4765),
    [anon_sym_DASH_GT] = ACTIONS(4765),
    [anon_sym_LBRACK] = ACTIONS(4767),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4767),
    [anon_sym_u27e7] = ACTIONS(4767),
    [anon_sym_u27e6] = ACTIONS(4767),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4767),
    [sym_float] = ACTIONS(4767),
    [sym_char] = ACTIONS(4767),
    [sym_string] = ACTIONS(4767),
    [sym__integer_literal] = ACTIONS(4765),
    [sym__binary_literal] = ACTIONS(4767),
    [sym__octal_literal] = ACTIONS(4767),
    [sym__hex_literal] = ACTIONS(4767),
    [anon_sym_BQUOTE] = ACTIONS(4767),
    [anon_sym_POUND] = ACTIONS(4765),
    [anon_sym_POUND2] = ACTIONS(4765),
    [sym_implicit_variable] = ACTIONS(4767),
    [sym_name] = ACTIONS(4767),
    [sym_label] = ACTIONS(4767),
    [anon_sym_u2192] = ACTIONS(4767),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4767),
    [anon_sym_u22b8] = ACTIONS(4767),
    [anon_sym_COLON_COLON] = ACTIONS(4767),
    [anon_sym_u2237] = ACTIONS(4767),
    [aux_sym__paren_open_token1] = ACTIONS(4767),
    [aux_sym__paren_close_token1] = ACTIONS(4767),
    [anon_sym_RBRACK] = ACTIONS(4767),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4767),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4767),
    [sym__cond_splice] = ACTIONS(4767),
    [sym__cond_tight_dot] = ACTIONS(4767),
    [sym__cond_prefix_dot] = ACTIONS(4767),
    [sym__cond_prefix_at] = ACTIONS(4767),
    [sym__cond_prefix_percent] = ACTIONS(4767),
    [sym__cond_qualified_op] = ACTIONS(4767),
    [sym__cond_no_section_op] = ACTIONS(4767),
    [sym__cond_minus] = ACTIONS(4767),
    [sym__varsym] = ACTIONS(4767),
    [sym__consym] = ACTIONS(4767),
  },
  [2326] = {
    [sym_variable] = ACTIONS(4769),
    [anon_sym_SEMI] = ACTIONS(4747),
    [anon_sym_let] = ACTIONS(4745),
    [anon_sym_COMMA] = ACTIONS(4747),
    [anon_sym_LBRACE] = ACTIONS(4747),
    [anon_sym_RBRACE] = ACTIONS(4747),
    [anon_sym__] = ACTIONS(4769),
    [anon_sym_SQUOTE] = ACTIONS(4769),
    [anon_sym_STAR] = ACTIONS(4771),
    [anon_sym_u2605] = ACTIONS(4771),
    [anon_sym_EQ] = ACTIONS(4747),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4747),
    [anon_sym_then] = ACTIONS(4745),
    [anon_sym_using] = ACTIONS(4745),
    [anon_sym_BSLASH] = ACTIONS(4747),
    [anon_sym_if] = ACTIONS(4745),
    [anon_sym_else] = ACTIONS(4745),
    [anon_sym_mdo] = ACTIONS(4745),
    [anon_sym_do] = ACTIONS(4745),
    [anon_sym_case] = ACTIONS(4745),
    [anon_sym_of] = ACTIONS(4745),
    [anon_sym_DASH] = ACTIONS(4745),
    [anon_sym_DASH_GT] = ACTIONS(4745),
    [anon_sym_LBRACK] = ACTIONS(4771),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4747),
    [anon_sym_u27e7] = ACTIONS(4747),
    [anon_sym_u27e6] = ACTIONS(4747),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4747),
    [sym_float] = ACTIONS(4771),
    [sym_char] = ACTIONS(4771),
    [sym_string] = ACTIONS(4771),
    [sym__integer_literal] = ACTIONS(4769),
    [sym__binary_literal] = ACTIONS(4771),
    [sym__octal_literal] = ACTIONS(4771),
    [sym__hex_literal] = ACTIONS(4771),
    [anon_sym_BQUOTE] = ACTIONS(4747),
    [anon_sym_POUND] = ACTIONS(4745),
    [anon_sym_POUND2] = ACTIONS(4745),
    [sym_implicit_variable] = ACTIONS(4747),
    [sym_name] = ACTIONS(4771),
    [sym_label] = ACTIONS(4747),
    [anon_sym_u2192] = ACTIONS(4747),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4747),
    [anon_sym_u22b8] = ACTIONS(4747),
    [anon_sym_COLON_COLON] = ACTIONS(4747),
    [anon_sym_u2237] = ACTIONS(4747),
    [aux_sym__paren_open_token1] = ACTIONS(4771),
    [aux_sym__paren_close_token1] = ACTIONS(4747),
    [anon_sym_RBRACK] = ACTIONS(4747),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4747),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4771),
    [sym__cond_splice] = ACTIONS(4771),
    [sym__cond_tight_dot] = ACTIONS(4747),
    [sym__cond_prefix_dot] = ACTIONS(4747),
    [sym__cond_prefix_at] = ACTIONS(4747),
    [sym__cond_prefix_percent] = ACTIONS(4747),
    [sym__cond_qualified_op] = ACTIONS(4747),
    [sym__cond_no_section_op] = ACTIONS(4747),
    [sym__cond_minus] = ACTIONS(4747),
    [sym__varsym] = ACTIONS(4747),
    [sym__consym] = ACTIONS(4747),
  },
  [2327] = {
    [sym_variable] = ACTIONS(4604),
    [anon_sym_SEMI] = ACTIONS(4606),
    [anon_sym_let] = ACTIONS(4604),
    [anon_sym_COMMA] = ACTIONS(4606),
    [anon_sym_LBRACE] = ACTIONS(4606),
    [anon_sym_RBRACE] = ACTIONS(4606),
    [anon_sym__] = ACTIONS(4604),
    [anon_sym_SQUOTE] = ACTIONS(4604),
    [anon_sym_STAR] = ACTIONS(4606),
    [anon_sym_u2605] = ACTIONS(4606),
    [anon_sym_EQ] = ACTIONS(4606),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4606),
    [anon_sym_then] = ACTIONS(4604),
    [anon_sym_using] = ACTIONS(4604),
    [anon_sym_BSLASH] = ACTIONS(4606),
    [anon_sym_if] = ACTIONS(4604),
    [anon_sym_else] = ACTIONS(4604),
    [anon_sym_mdo] = ACTIONS(4604),
    [anon_sym_do] = ACTIONS(4604),
    [anon_sym_case] = ACTIONS(4604),
    [anon_sym_of] = ACTIONS(4604),
    [anon_sym_DASH] = ACTIONS(4604),
    [anon_sym_DASH_GT] = ACTIONS(4604),
    [anon_sym_LBRACK] = ACTIONS(4606),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4606),
    [anon_sym_u27e7] = ACTIONS(4606),
    [anon_sym_u27e6] = ACTIONS(4606),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4606),
    [sym_float] = ACTIONS(4606),
    [sym_char] = ACTIONS(4606),
    [sym_string] = ACTIONS(4606),
    [sym__integer_literal] = ACTIONS(4604),
    [sym__binary_literal] = ACTIONS(4606),
    [sym__octal_literal] = ACTIONS(4606),
    [sym__hex_literal] = ACTIONS(4606),
    [anon_sym_BQUOTE] = ACTIONS(4606),
    [anon_sym_POUND] = ACTIONS(4604),
    [anon_sym_POUND2] = ACTIONS(4604),
    [sym_implicit_variable] = ACTIONS(4606),
    [sym_name] = ACTIONS(4606),
    [sym_label] = ACTIONS(4606),
    [anon_sym_u2192] = ACTIONS(4606),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4606),
    [anon_sym_u22b8] = ACTIONS(4606),
    [anon_sym_COLON_COLON] = ACTIONS(4606),
    [anon_sym_u2237] = ACTIONS(4606),
    [aux_sym__paren_open_token1] = ACTIONS(4606),
    [aux_sym__paren_close_token1] = ACTIONS(4606),
    [anon_sym_RBRACK] = ACTIONS(4606),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4606),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4606),
    [sym__cond_splice] = ACTIONS(4606),
    [sym__cond_tight_dot] = ACTIONS(4606),
    [sym__cond_prefix_dot] = ACTIONS(4606),
    [sym__cond_prefix_at] = ACTIONS(4606),
    [sym__cond_prefix_percent] = ACTIONS(4606),
    [sym__cond_qualified_op] = ACTIONS(4606),
    [sym__cond_no_section_op] = ACTIONS(4606),
    [sym__cond_minus] = ACTIONS(4606),
    [sym__varsym] = ACTIONS(4606),
    [sym__consym] = ACTIONS(4606),
  },
  [2328] = {
    [sym_variable] = ACTIONS(4773),
    [anon_sym_SEMI] = ACTIONS(4775),
    [anon_sym_let] = ACTIONS(4773),
    [anon_sym_COMMA] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(4775),
    [anon_sym_RBRACE] = ACTIONS(4775),
    [anon_sym__] = ACTIONS(4773),
    [anon_sym_SQUOTE] = ACTIONS(4773),
    [anon_sym_STAR] = ACTIONS(4775),
    [anon_sym_u2605] = ACTIONS(4775),
    [anon_sym_EQ] = ACTIONS(4775),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4775),
    [anon_sym_then] = ACTIONS(4773),
    [anon_sym_using] = ACTIONS(4773),
    [anon_sym_BSLASH] = ACTIONS(4775),
    [anon_sym_if] = ACTIONS(4773),
    [anon_sym_else] = ACTIONS(4773),
    [anon_sym_mdo] = ACTIONS(4773),
    [anon_sym_do] = ACTIONS(4773),
    [anon_sym_case] = ACTIONS(4773),
    [anon_sym_of] = ACTIONS(4773),
    [anon_sym_DASH] = ACTIONS(4773),
    [anon_sym_DASH_GT] = ACTIONS(4773),
    [anon_sym_LBRACK] = ACTIONS(4775),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4775),
    [anon_sym_u27e7] = ACTIONS(4775),
    [anon_sym_u27e6] = ACTIONS(4775),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4775),
    [sym_float] = ACTIONS(4775),
    [sym_char] = ACTIONS(4775),
    [sym_string] = ACTIONS(4775),
    [sym__integer_literal] = ACTIONS(4773),
    [sym__binary_literal] = ACTIONS(4775),
    [sym__octal_literal] = ACTIONS(4775),
    [sym__hex_literal] = ACTIONS(4775),
    [anon_sym_BQUOTE] = ACTIONS(4775),
    [anon_sym_POUND] = ACTIONS(4773),
    [anon_sym_POUND2] = ACTIONS(4773),
    [sym_implicit_variable] = ACTIONS(4775),
    [sym_name] = ACTIONS(4775),
    [sym_label] = ACTIONS(4775),
    [anon_sym_u2192] = ACTIONS(4775),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4775),
    [anon_sym_u22b8] = ACTIONS(4775),
    [anon_sym_COLON_COLON] = ACTIONS(4775),
    [anon_sym_u2237] = ACTIONS(4775),
    [aux_sym__paren_open_token1] = ACTIONS(4775),
    [aux_sym__paren_close_token1] = ACTIONS(4775),
    [anon_sym_RBRACK] = ACTIONS(4775),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4775),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4775),
    [sym__cond_splice] = ACTIONS(4775),
    [sym__cond_tight_dot] = ACTIONS(4775),
    [sym__cond_prefix_dot] = ACTIONS(4775),
    [sym__cond_prefix_at] = ACTIONS(4775),
    [sym__cond_prefix_percent] = ACTIONS(4775),
    [sym__cond_qualified_op] = ACTIONS(4775),
    [sym__cond_no_section_op] = ACTIONS(4775),
    [sym__cond_minus] = ACTIONS(4775),
    [sym__varsym] = ACTIONS(4775),
    [sym__consym] = ACTIONS(4775),
  },
  [2329] = {
    [sym__type_parens] = STATE(7268),
    [sym__type_tuple] = STATE(7262),
    [sym__type_unboxed_tuple] = STATE(7258),
    [sym__type_unboxed_sum] = STATE(7246),
    [sym__type_list] = STATE(7247),
    [sym__type_promoted] = STATE(7269),
    [sym__type_star] = STATE(7269),
    [sym__type_wildcard] = STATE(7269),
    [sym__type_apply] = STATE(7237),
    [sym__type_infix] = STATE(7207),
    [sym_type] = STATE(1162),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11301),
    [sym__record_fields] = STATE(9704),
    [sym__newtype_con_field] = STATE(9703),
    [sym__splice_dollars] = STATE(7208),
    [sym_splice] = STATE(7269),
    [sym_quasiquote] = STATE(7269),
    [sym_integer] = STATE(7206),
    [sym__plist] = STATE(7209),
    [sym_unit] = STATE(7269),
    [sym_unboxed_unit] = STATE(7269),
    [sym_prefix_tuple] = STATE(7269),
    [sym_prefix_unboxed_tuple] = STATE(7269),
    [sym_prefix_unboxed_sum] = STATE(7269),
    [sym_literal] = STATE(7269),
    [sym__qualified_type] = STATE(7374),
    [sym__qtyconid] = STATE(7210),
    [sym__tycon_arrow] = STATE(7210),
    [sym__qtycon_arrow] = STATE(7210),
    [sym__promoted_tycons_alias] = STATE(7269),
    [sym__promoted_tycons] = STATE(7269),
    [sym__varsym_prefix] = STATE(7210),
    [sym__pvarsym] = STATE(7210),
    [sym__qvarsym_prefix] = STATE(7210),
    [sym__pqvarsym] = STATE(7210),
    [sym__consym_prefix] = STATE(7210),
    [sym__pconsym] = STATE(7210),
    [sym__qconsym_prefix] = STATE(7210),
    [sym__pqconsym] = STATE(7210),
    [sym__paren_open] = STATE(448),
    [sym__bracket_open] = STATE(1009),
    [sym__unboxed_open] = STATE(824),
    [sym_variable] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(4777),
    [anon_sym__] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(4354),
    [anon_sym_STAR] = ACTIONS(2953),
    [anon_sym_u2605] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2955),
    [sym_char] = ACTIONS(2955),
    [sym_string] = ACTIONS(2955),
    [sym__integer_literal] = ACTIONS(2957),
    [sym__binary_literal] = ACTIONS(2959),
    [sym__octal_literal] = ACTIONS(2959),
    [sym__hex_literal] = ACTIONS(2959),
    [sym_name] = ACTIONS(4360),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2963),
    [sym__cond_splice] = ACTIONS(83),
  },
  [2330] = {
    [sym__type_parens] = STATE(7268),
    [sym__type_tuple] = STATE(7262),
    [sym__type_unboxed_tuple] = STATE(7258),
    [sym__type_unboxed_sum] = STATE(7246),
    [sym__type_list] = STATE(7247),
    [sym__type_promoted] = STATE(7269),
    [sym__type_star] = STATE(7269),
    [sym__type_wildcard] = STATE(7269),
    [sym__type_apply] = STATE(7237),
    [sym__type_infix] = STATE(7207),
    [sym_type] = STATE(1162),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11301),
    [sym__record_fields] = STATE(9700),
    [sym__newtype_con_field] = STATE(9697),
    [sym__splice_dollars] = STATE(7208),
    [sym_splice] = STATE(7269),
    [sym_quasiquote] = STATE(7269),
    [sym_integer] = STATE(7206),
    [sym__plist] = STATE(7209),
    [sym_unit] = STATE(7269),
    [sym_unboxed_unit] = STATE(7269),
    [sym_prefix_tuple] = STATE(7269),
    [sym_prefix_unboxed_tuple] = STATE(7269),
    [sym_prefix_unboxed_sum] = STATE(7269),
    [sym_literal] = STATE(7269),
    [sym__qualified_type] = STATE(7374),
    [sym__qtyconid] = STATE(7210),
    [sym__tycon_arrow] = STATE(7210),
    [sym__qtycon_arrow] = STATE(7210),
    [sym__promoted_tycons_alias] = STATE(7269),
    [sym__promoted_tycons] = STATE(7269),
    [sym__varsym_prefix] = STATE(7210),
    [sym__pvarsym] = STATE(7210),
    [sym__qvarsym_prefix] = STATE(7210),
    [sym__pqvarsym] = STATE(7210),
    [sym__consym_prefix] = STATE(7210),
    [sym__pconsym] = STATE(7210),
    [sym__qconsym_prefix] = STATE(7210),
    [sym__pqconsym] = STATE(7210),
    [sym__paren_open] = STATE(448),
    [sym__bracket_open] = STATE(1009),
    [sym__unboxed_open] = STATE(824),
    [sym_variable] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(4777),
    [anon_sym__] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(4354),
    [anon_sym_STAR] = ACTIONS(2953),
    [anon_sym_u2605] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [sym_float] = ACTIONS(2955),
    [sym_char] = ACTIONS(2955),
    [sym_string] = ACTIONS(2955),
    [sym__integer_literal] = ACTIONS(2957),
    [sym__binary_literal] = ACTIONS(2959),
    [sym__octal_literal] = ACTIONS(2959),
    [sym__hex_literal] = ACTIONS(2959),
    [sym_name] = ACTIONS(4360),
    [aux_sym__paren_open_token1] = ACTIONS(1151),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(2963),
    [sym__cond_splice] = ACTIONS(83),
  },
  [2331] = {
    [sym_variable] = ACTIONS(4779),
    [anon_sym_SEMI] = ACTIONS(4781),
    [anon_sym_let] = ACTIONS(4779),
    [anon_sym_COMMA] = ACTIONS(4781),
    [anon_sym_LBRACE] = ACTIONS(4781),
    [anon_sym_RBRACE] = ACTIONS(4781),
    [anon_sym__] = ACTIONS(4779),
    [anon_sym_SQUOTE] = ACTIONS(4779),
    [anon_sym_STAR] = ACTIONS(4781),
    [anon_sym_u2605] = ACTIONS(4781),
    [anon_sym_EQ] = ACTIONS(4781),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4781),
    [anon_sym_then] = ACTIONS(4779),
    [anon_sym_using] = ACTIONS(4779),
    [anon_sym_BSLASH] = ACTIONS(4781),
    [anon_sym_if] = ACTIONS(4779),
    [anon_sym_else] = ACTIONS(4779),
    [anon_sym_mdo] = ACTIONS(4779),
    [anon_sym_do] = ACTIONS(4779),
    [anon_sym_case] = ACTIONS(4779),
    [anon_sym_of] = ACTIONS(4779),
    [anon_sym_DASH] = ACTIONS(4779),
    [anon_sym_DASH_GT] = ACTIONS(4779),
    [anon_sym_LBRACK] = ACTIONS(4781),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4781),
    [anon_sym_u27e7] = ACTIONS(4781),
    [anon_sym_u27e6] = ACTIONS(4781),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4781),
    [sym_float] = ACTIONS(4781),
    [sym_char] = ACTIONS(4781),
    [sym_string] = ACTIONS(4781),
    [sym__integer_literal] = ACTIONS(4779),
    [sym__binary_literal] = ACTIONS(4781),
    [sym__octal_literal] = ACTIONS(4781),
    [sym__hex_literal] = ACTIONS(4781),
    [anon_sym_BQUOTE] = ACTIONS(4781),
    [anon_sym_POUND] = ACTIONS(4779),
    [anon_sym_POUND2] = ACTIONS(4779),
    [sym_implicit_variable] = ACTIONS(4781),
    [sym_name] = ACTIONS(4781),
    [sym_label] = ACTIONS(4781),
    [anon_sym_u2192] = ACTIONS(4781),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4781),
    [anon_sym_u22b8] = ACTIONS(4781),
    [anon_sym_COLON_COLON] = ACTIONS(4781),
    [anon_sym_u2237] = ACTIONS(4781),
    [aux_sym__paren_open_token1] = ACTIONS(4781),
    [aux_sym__paren_close_token1] = ACTIONS(4781),
    [anon_sym_RBRACK] = ACTIONS(4781),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4781),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4781),
    [sym__cond_splice] = ACTIONS(4781),
    [sym__cond_tight_dot] = ACTIONS(4781),
    [sym__cond_prefix_dot] = ACTIONS(4781),
    [sym__cond_prefix_at] = ACTIONS(4781),
    [sym__cond_prefix_percent] = ACTIONS(4781),
    [sym__cond_qualified_op] = ACTIONS(4781),
    [sym__cond_no_section_op] = ACTIONS(4781),
    [sym__cond_minus] = ACTIONS(4781),
    [sym__varsym] = ACTIONS(4781),
    [sym__consym] = ACTIONS(4781),
  },
  [2332] = {
    [sym_variable] = ACTIONS(4783),
    [anon_sym_SEMI] = ACTIONS(4785),
    [anon_sym_let] = ACTIONS(4783),
    [anon_sym_COMMA] = ACTIONS(4785),
    [anon_sym_LBRACE] = ACTIONS(4785),
    [anon_sym_RBRACE] = ACTIONS(4785),
    [anon_sym__] = ACTIONS(4783),
    [anon_sym_SQUOTE] = ACTIONS(4783),
    [anon_sym_STAR] = ACTIONS(4785),
    [anon_sym_u2605] = ACTIONS(4785),
    [anon_sym_EQ] = ACTIONS(4785),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4785),
    [anon_sym_then] = ACTIONS(4783),
    [anon_sym_using] = ACTIONS(4783),
    [anon_sym_BSLASH] = ACTIONS(4785),
    [anon_sym_if] = ACTIONS(4783),
    [anon_sym_else] = ACTIONS(4783),
    [anon_sym_mdo] = ACTIONS(4783),
    [anon_sym_do] = ACTIONS(4783),
    [anon_sym_case] = ACTIONS(4783),
    [anon_sym_of] = ACTIONS(4783),
    [anon_sym_DASH] = ACTIONS(4783),
    [anon_sym_DASH_GT] = ACTIONS(4783),
    [anon_sym_LBRACK] = ACTIONS(4785),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4785),
    [anon_sym_u27e7] = ACTIONS(4785),
    [anon_sym_u27e6] = ACTIONS(4785),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4785),
    [sym_float] = ACTIONS(4785),
    [sym_char] = ACTIONS(4785),
    [sym_string] = ACTIONS(4785),
    [sym__integer_literal] = ACTIONS(4783),
    [sym__binary_literal] = ACTIONS(4785),
    [sym__octal_literal] = ACTIONS(4785),
    [sym__hex_literal] = ACTIONS(4785),
    [anon_sym_BQUOTE] = ACTIONS(4785),
    [anon_sym_POUND] = ACTIONS(4783),
    [anon_sym_POUND2] = ACTIONS(4783),
    [sym_implicit_variable] = ACTIONS(4785),
    [sym_name] = ACTIONS(4785),
    [sym_label] = ACTIONS(4785),
    [anon_sym_u2192] = ACTIONS(4785),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4785),
    [anon_sym_u22b8] = ACTIONS(4785),
    [anon_sym_COLON_COLON] = ACTIONS(4785),
    [anon_sym_u2237] = ACTIONS(4785),
    [aux_sym__paren_open_token1] = ACTIONS(4785),
    [aux_sym__paren_close_token1] = ACTIONS(4785),
    [anon_sym_RBRACK] = ACTIONS(4785),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4785),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4785),
    [sym__cond_splice] = ACTIONS(4785),
    [sym__cond_tight_dot] = ACTIONS(4785),
    [sym__cond_prefix_dot] = ACTIONS(4785),
    [sym__cond_prefix_at] = ACTIONS(4785),
    [sym__cond_prefix_percent] = ACTIONS(4785),
    [sym__cond_qualified_op] = ACTIONS(4785),
    [sym__cond_no_section_op] = ACTIONS(4785),
    [sym__cond_minus] = ACTIONS(4785),
    [sym__varsym] = ACTIONS(4785),
    [sym__consym] = ACTIONS(4785),
  },
  [2333] = {
    [sym_variable] = ACTIONS(4787),
    [anon_sym_SEMI] = ACTIONS(4789),
    [anon_sym_let] = ACTIONS(4787),
    [anon_sym_COMMA] = ACTIONS(4789),
    [anon_sym_LBRACE] = ACTIONS(4789),
    [anon_sym_RBRACE] = ACTIONS(4789),
    [anon_sym__] = ACTIONS(4787),
    [anon_sym_SQUOTE] = ACTIONS(4787),
    [anon_sym_STAR] = ACTIONS(4789),
    [anon_sym_u2605] = ACTIONS(4789),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4789),
    [anon_sym_then] = ACTIONS(4787),
    [anon_sym_using] = ACTIONS(4787),
    [anon_sym_BSLASH] = ACTIONS(4789),
    [anon_sym_if] = ACTIONS(4787),
    [anon_sym_else] = ACTIONS(4787),
    [anon_sym_mdo] = ACTIONS(4787),
    [anon_sym_do] = ACTIONS(4787),
    [anon_sym_case] = ACTIONS(4787),
    [anon_sym_of] = ACTIONS(4787),
    [anon_sym_DASH] = ACTIONS(4787),
    [anon_sym_DASH_GT] = ACTIONS(4787),
    [anon_sym_LBRACK] = ACTIONS(4789),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4789),
    [anon_sym_u27e7] = ACTIONS(4789),
    [anon_sym_u27e6] = ACTIONS(4789),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4789),
    [sym_float] = ACTIONS(4789),
    [sym_char] = ACTIONS(4789),
    [sym_string] = ACTIONS(4789),
    [sym__integer_literal] = ACTIONS(4787),
    [sym__binary_literal] = ACTIONS(4789),
    [sym__octal_literal] = ACTIONS(4789),
    [sym__hex_literal] = ACTIONS(4789),
    [anon_sym_BQUOTE] = ACTIONS(4789),
    [anon_sym_POUND] = ACTIONS(4787),
    [anon_sym_POUND2] = ACTIONS(4787),
    [sym_implicit_variable] = ACTIONS(4789),
    [sym_name] = ACTIONS(4789),
    [sym_label] = ACTIONS(4789),
    [anon_sym_u2192] = ACTIONS(4789),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4789),
    [anon_sym_u22b8] = ACTIONS(4789),
    [anon_sym_COLON_COLON] = ACTIONS(4789),
    [anon_sym_u2237] = ACTIONS(4789),
    [aux_sym__paren_open_token1] = ACTIONS(4789),
    [aux_sym__paren_close_token1] = ACTIONS(4789),
    [anon_sym_RBRACK] = ACTIONS(4789),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4789),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4789),
    [sym__cond_splice] = ACTIONS(4789),
    [sym__cond_tight_dot] = ACTIONS(4789),
    [sym__cond_prefix_dot] = ACTIONS(4789),
    [sym__cond_prefix_at] = ACTIONS(4789),
    [sym__cond_prefix_percent] = ACTIONS(4789),
    [sym__cond_qualified_op] = ACTIONS(4789),
    [sym__cond_no_section_op] = ACTIONS(4789),
    [sym__cond_minus] = ACTIONS(4789),
    [sym__varsym] = ACTIONS(4789),
    [sym__consym] = ACTIONS(4789),
  },
  [2334] = {
    [sym_variable] = ACTIONS(4791),
    [anon_sym_SEMI] = ACTIONS(4793),
    [anon_sym_let] = ACTIONS(4791),
    [anon_sym_COMMA] = ACTIONS(4793),
    [anon_sym_LBRACE] = ACTIONS(4793),
    [anon_sym_RBRACE] = ACTIONS(4793),
    [anon_sym__] = ACTIONS(4791),
    [anon_sym_SQUOTE] = ACTIONS(4791),
    [anon_sym_STAR] = ACTIONS(4793),
    [anon_sym_u2605] = ACTIONS(4793),
    [anon_sym_EQ] = ACTIONS(4793),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4793),
    [anon_sym_then] = ACTIONS(4791),
    [anon_sym_using] = ACTIONS(4791),
    [anon_sym_BSLASH] = ACTIONS(4793),
    [anon_sym_if] = ACTIONS(4791),
    [anon_sym_else] = ACTIONS(4791),
    [anon_sym_mdo] = ACTIONS(4791),
    [anon_sym_do] = ACTIONS(4791),
    [anon_sym_case] = ACTIONS(4791),
    [anon_sym_of] = ACTIONS(4791),
    [anon_sym_DASH] = ACTIONS(4791),
    [anon_sym_DASH_GT] = ACTIONS(4791),
    [anon_sym_LBRACK] = ACTIONS(4793),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4793),
    [anon_sym_u27e7] = ACTIONS(4793),
    [anon_sym_u27e6] = ACTIONS(4793),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4793),
    [sym_float] = ACTIONS(4793),
    [sym_char] = ACTIONS(4793),
    [sym_string] = ACTIONS(4793),
    [sym__integer_literal] = ACTIONS(4791),
    [sym__binary_literal] = ACTIONS(4793),
    [sym__octal_literal] = ACTIONS(4793),
    [sym__hex_literal] = ACTIONS(4793),
    [anon_sym_BQUOTE] = ACTIONS(4793),
    [anon_sym_POUND] = ACTIONS(4791),
    [anon_sym_POUND2] = ACTIONS(4791),
    [sym_implicit_variable] = ACTIONS(4793),
    [sym_name] = ACTIONS(4793),
    [sym_label] = ACTIONS(4793),
    [anon_sym_u2192] = ACTIONS(4793),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4793),
    [anon_sym_u22b8] = ACTIONS(4793),
    [anon_sym_COLON_COLON] = ACTIONS(4793),
    [anon_sym_u2237] = ACTIONS(4793),
    [aux_sym__paren_open_token1] = ACTIONS(4793),
    [aux_sym__paren_close_token1] = ACTIONS(4793),
    [anon_sym_RBRACK] = ACTIONS(4793),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4793),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4793),
    [sym__cond_splice] = ACTIONS(4793),
    [sym__cond_tight_dot] = ACTIONS(4793),
    [sym__cond_prefix_dot] = ACTIONS(4793),
    [sym__cond_prefix_at] = ACTIONS(4793),
    [sym__cond_prefix_percent] = ACTIONS(4793),
    [sym__cond_qualified_op] = ACTIONS(4793),
    [sym__cond_no_section_op] = ACTIONS(4793),
    [sym__cond_minus] = ACTIONS(4793),
    [sym__varsym] = ACTIONS(4793),
    [sym__consym] = ACTIONS(4793),
  },
  [2335] = {
    [sym_variable] = ACTIONS(4795),
    [anon_sym_SEMI] = ACTIONS(4797),
    [anon_sym_let] = ACTIONS(4795),
    [anon_sym_COMMA] = ACTIONS(4797),
    [anon_sym_LBRACE] = ACTIONS(4797),
    [anon_sym_RBRACE] = ACTIONS(4797),
    [anon_sym__] = ACTIONS(4795),
    [anon_sym_SQUOTE] = ACTIONS(4795),
    [anon_sym_STAR] = ACTIONS(4797),
    [anon_sym_u2605] = ACTIONS(4797),
    [anon_sym_EQ] = ACTIONS(4797),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4797),
    [anon_sym_then] = ACTIONS(4795),
    [anon_sym_using] = ACTIONS(4795),
    [anon_sym_BSLASH] = ACTIONS(4797),
    [anon_sym_if] = ACTIONS(4795),
    [anon_sym_else] = ACTIONS(4795),
    [anon_sym_mdo] = ACTIONS(4795),
    [anon_sym_do] = ACTIONS(4795),
    [anon_sym_case] = ACTIONS(4795),
    [anon_sym_of] = ACTIONS(4795),
    [anon_sym_DASH] = ACTIONS(4795),
    [anon_sym_DASH_GT] = ACTIONS(4795),
    [anon_sym_LBRACK] = ACTIONS(4797),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4797),
    [anon_sym_u27e7] = ACTIONS(4797),
    [anon_sym_u27e6] = ACTIONS(4797),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4797),
    [sym_float] = ACTIONS(4797),
    [sym_char] = ACTIONS(4797),
    [sym_string] = ACTIONS(4797),
    [sym__integer_literal] = ACTIONS(4795),
    [sym__binary_literal] = ACTIONS(4797),
    [sym__octal_literal] = ACTIONS(4797),
    [sym__hex_literal] = ACTIONS(4797),
    [anon_sym_BQUOTE] = ACTIONS(4797),
    [anon_sym_POUND] = ACTIONS(4795),
    [anon_sym_POUND2] = ACTIONS(4795),
    [sym_implicit_variable] = ACTIONS(4797),
    [sym_name] = ACTIONS(4797),
    [sym_label] = ACTIONS(4797),
    [anon_sym_u2192] = ACTIONS(4797),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4797),
    [anon_sym_u22b8] = ACTIONS(4797),
    [anon_sym_COLON_COLON] = ACTIONS(4797),
    [anon_sym_u2237] = ACTIONS(4797),
    [aux_sym__paren_open_token1] = ACTIONS(4797),
    [aux_sym__paren_close_token1] = ACTIONS(4797),
    [anon_sym_RBRACK] = ACTIONS(4797),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4797),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4797),
    [sym__cond_splice] = ACTIONS(4797),
    [sym__cond_tight_dot] = ACTIONS(4797),
    [sym__cond_prefix_dot] = ACTIONS(4797),
    [sym__cond_prefix_at] = ACTIONS(4797),
    [sym__cond_prefix_percent] = ACTIONS(4797),
    [sym__cond_qualified_op] = ACTIONS(4797),
    [sym__cond_no_section_op] = ACTIONS(4797),
    [sym__cond_minus] = ACTIONS(4797),
    [sym__varsym] = ACTIONS(4797),
    [sym__consym] = ACTIONS(4797),
  },
  [2336] = {
    [sym_variable] = ACTIONS(4799),
    [anon_sym_SEMI] = ACTIONS(4801),
    [anon_sym_let] = ACTIONS(4799),
    [anon_sym_COMMA] = ACTIONS(4801),
    [anon_sym_LBRACE] = ACTIONS(4801),
    [anon_sym_RBRACE] = ACTIONS(4801),
    [anon_sym__] = ACTIONS(4799),
    [anon_sym_SQUOTE] = ACTIONS(4799),
    [anon_sym_STAR] = ACTIONS(4801),
    [anon_sym_u2605] = ACTIONS(4801),
    [anon_sym_EQ] = ACTIONS(4801),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4801),
    [anon_sym_then] = ACTIONS(4799),
    [anon_sym_using] = ACTIONS(4799),
    [anon_sym_BSLASH] = ACTIONS(4801),
    [anon_sym_if] = ACTIONS(4799),
    [anon_sym_else] = ACTIONS(4799),
    [anon_sym_mdo] = ACTIONS(4799),
    [anon_sym_do] = ACTIONS(4799),
    [anon_sym_case] = ACTIONS(4799),
    [anon_sym_of] = ACTIONS(4799),
    [anon_sym_DASH] = ACTIONS(4799),
    [anon_sym_DASH_GT] = ACTIONS(4799),
    [anon_sym_LBRACK] = ACTIONS(4801),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4801),
    [anon_sym_u27e7] = ACTIONS(4801),
    [anon_sym_u27e6] = ACTIONS(4801),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4801),
    [sym_float] = ACTIONS(4801),
    [sym_char] = ACTIONS(4801),
    [sym_string] = ACTIONS(4801),
    [sym__integer_literal] = ACTIONS(4799),
    [sym__binary_literal] = ACTIONS(4801),
    [sym__octal_literal] = ACTIONS(4801),
    [sym__hex_literal] = ACTIONS(4801),
    [anon_sym_BQUOTE] = ACTIONS(4801),
    [anon_sym_POUND] = ACTIONS(4799),
    [anon_sym_POUND2] = ACTIONS(4799),
    [sym_implicit_variable] = ACTIONS(4801),
    [sym_name] = ACTIONS(4801),
    [sym_label] = ACTIONS(4801),
    [anon_sym_u2192] = ACTIONS(4801),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4801),
    [anon_sym_u22b8] = ACTIONS(4801),
    [anon_sym_COLON_COLON] = ACTIONS(4801),
    [anon_sym_u2237] = ACTIONS(4801),
    [aux_sym__paren_open_token1] = ACTIONS(4801),
    [aux_sym__paren_close_token1] = ACTIONS(4801),
    [anon_sym_RBRACK] = ACTIONS(4801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4801),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4801),
    [sym__cond_splice] = ACTIONS(4801),
    [sym__cond_tight_dot] = ACTIONS(4801),
    [sym__cond_prefix_dot] = ACTIONS(4801),
    [sym__cond_prefix_at] = ACTIONS(4801),
    [sym__cond_prefix_percent] = ACTIONS(4801),
    [sym__cond_qualified_op] = ACTIONS(4801),
    [sym__cond_no_section_op] = ACTIONS(4801),
    [sym__cond_minus] = ACTIONS(4801),
    [sym__varsym] = ACTIONS(4801),
    [sym__consym] = ACTIONS(4801),
  },
  [2337] = {
    [sym_variable] = ACTIONS(4803),
    [anon_sym_SEMI] = ACTIONS(4805),
    [anon_sym_let] = ACTIONS(4803),
    [anon_sym_COMMA] = ACTIONS(4805),
    [anon_sym_LBRACE] = ACTIONS(4805),
    [anon_sym_RBRACE] = ACTIONS(4805),
    [anon_sym__] = ACTIONS(4803),
    [anon_sym_SQUOTE] = ACTIONS(4803),
    [anon_sym_STAR] = ACTIONS(4805),
    [anon_sym_u2605] = ACTIONS(4805),
    [anon_sym_EQ] = ACTIONS(4805),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4805),
    [anon_sym_then] = ACTIONS(4803),
    [anon_sym_using] = ACTIONS(4803),
    [anon_sym_BSLASH] = ACTIONS(4805),
    [anon_sym_if] = ACTIONS(4803),
    [anon_sym_else] = ACTIONS(4803),
    [anon_sym_mdo] = ACTIONS(4803),
    [anon_sym_do] = ACTIONS(4803),
    [anon_sym_case] = ACTIONS(4803),
    [anon_sym_of] = ACTIONS(4803),
    [anon_sym_DASH] = ACTIONS(4803),
    [anon_sym_DASH_GT] = ACTIONS(4803),
    [anon_sym_LBRACK] = ACTIONS(4805),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4805),
    [anon_sym_u27e7] = ACTIONS(4805),
    [anon_sym_u27e6] = ACTIONS(4805),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4805),
    [sym_float] = ACTIONS(4805),
    [sym_char] = ACTIONS(4805),
    [sym_string] = ACTIONS(4805),
    [sym__integer_literal] = ACTIONS(4803),
    [sym__binary_literal] = ACTIONS(4805),
    [sym__octal_literal] = ACTIONS(4805),
    [sym__hex_literal] = ACTIONS(4805),
    [anon_sym_BQUOTE] = ACTIONS(4805),
    [anon_sym_POUND] = ACTIONS(4803),
    [anon_sym_POUND2] = ACTIONS(4803),
    [sym_implicit_variable] = ACTIONS(4805),
    [sym_name] = ACTIONS(4805),
    [sym_label] = ACTIONS(4805),
    [anon_sym_u2192] = ACTIONS(4805),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4805),
    [anon_sym_u22b8] = ACTIONS(4805),
    [anon_sym_COLON_COLON] = ACTIONS(4805),
    [anon_sym_u2237] = ACTIONS(4805),
    [aux_sym__paren_open_token1] = ACTIONS(4805),
    [aux_sym__paren_close_token1] = ACTIONS(4805),
    [anon_sym_RBRACK] = ACTIONS(4805),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4805),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4805),
    [sym__cond_splice] = ACTIONS(4805),
    [sym__cond_tight_dot] = ACTIONS(4805),
    [sym__cond_prefix_dot] = ACTIONS(4805),
    [sym__cond_prefix_at] = ACTIONS(4805),
    [sym__cond_prefix_percent] = ACTIONS(4805),
    [sym__cond_qualified_op] = ACTIONS(4805),
    [sym__cond_no_section_op] = ACTIONS(4805),
    [sym__cond_minus] = ACTIONS(4805),
    [sym__varsym] = ACTIONS(4805),
    [sym__consym] = ACTIONS(4805),
  },
  [2338] = {
    [sym_variable] = ACTIONS(4803),
    [anon_sym_SEMI] = ACTIONS(4805),
    [anon_sym_let] = ACTIONS(4803),
    [anon_sym_COMMA] = ACTIONS(4805),
    [anon_sym_LBRACE] = ACTIONS(4805),
    [anon_sym_RBRACE] = ACTIONS(4805),
    [anon_sym__] = ACTIONS(4803),
    [anon_sym_SQUOTE] = ACTIONS(4803),
    [anon_sym_STAR] = ACTIONS(4805),
    [anon_sym_u2605] = ACTIONS(4805),
    [anon_sym_EQ] = ACTIONS(4805),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4805),
    [anon_sym_then] = ACTIONS(4803),
    [anon_sym_using] = ACTIONS(4803),
    [anon_sym_BSLASH] = ACTIONS(4805),
    [anon_sym_if] = ACTIONS(4803),
    [anon_sym_else] = ACTIONS(4803),
    [anon_sym_mdo] = ACTIONS(4803),
    [anon_sym_do] = ACTIONS(4803),
    [anon_sym_case] = ACTIONS(4803),
    [anon_sym_of] = ACTIONS(4803),
    [anon_sym_DASH] = ACTIONS(4803),
    [anon_sym_DASH_GT] = ACTIONS(4803),
    [anon_sym_LBRACK] = ACTIONS(4805),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4805),
    [anon_sym_u27e7] = ACTIONS(4805),
    [anon_sym_u27e6] = ACTIONS(4805),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4805),
    [sym_float] = ACTIONS(4805),
    [sym_char] = ACTIONS(4805),
    [sym_string] = ACTIONS(4805),
    [sym__integer_literal] = ACTIONS(4803),
    [sym__binary_literal] = ACTIONS(4805),
    [sym__octal_literal] = ACTIONS(4805),
    [sym__hex_literal] = ACTIONS(4805),
    [anon_sym_BQUOTE] = ACTIONS(4805),
    [anon_sym_POUND] = ACTIONS(4803),
    [anon_sym_POUND2] = ACTIONS(4803),
    [sym_implicit_variable] = ACTIONS(4805),
    [sym_name] = ACTIONS(4805),
    [sym_label] = ACTIONS(4805),
    [anon_sym_u2192] = ACTIONS(4805),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4805),
    [anon_sym_u22b8] = ACTIONS(4805),
    [anon_sym_COLON_COLON] = ACTIONS(4805),
    [anon_sym_u2237] = ACTIONS(4805),
    [aux_sym__paren_open_token1] = ACTIONS(4805),
    [aux_sym__paren_close_token1] = ACTIONS(4805),
    [anon_sym_RBRACK] = ACTIONS(4805),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4805),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4805),
    [sym__cond_splice] = ACTIONS(4805),
    [sym__cond_tight_dot] = ACTIONS(4805),
    [sym__cond_prefix_dot] = ACTIONS(4805),
    [sym__cond_prefix_at] = ACTIONS(4805),
    [sym__cond_prefix_percent] = ACTIONS(4805),
    [sym__cond_qualified_op] = ACTIONS(4805),
    [sym__cond_no_section_op] = ACTIONS(4805),
    [sym__cond_minus] = ACTIONS(4805),
    [sym__varsym] = ACTIONS(4805),
    [sym__consym] = ACTIONS(4805),
  },
  [2339] = {
    [sym_variable] = ACTIONS(4807),
    [anon_sym_SEMI] = ACTIONS(4809),
    [anon_sym_let] = ACTIONS(4807),
    [anon_sym_COMMA] = ACTIONS(4809),
    [anon_sym_LBRACE] = ACTIONS(4809),
    [anon_sym_RBRACE] = ACTIONS(4809),
    [anon_sym__] = ACTIONS(4807),
    [anon_sym_SQUOTE] = ACTIONS(4807),
    [anon_sym_STAR] = ACTIONS(4809),
    [anon_sym_u2605] = ACTIONS(4809),
    [anon_sym_EQ] = ACTIONS(4809),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4809),
    [anon_sym_then] = ACTIONS(4807),
    [anon_sym_using] = ACTIONS(4807),
    [anon_sym_BSLASH] = ACTIONS(4809),
    [anon_sym_if] = ACTIONS(4807),
    [anon_sym_else] = ACTIONS(4807),
    [anon_sym_mdo] = ACTIONS(4807),
    [anon_sym_do] = ACTIONS(4807),
    [anon_sym_case] = ACTIONS(4807),
    [anon_sym_of] = ACTIONS(4807),
    [anon_sym_DASH] = ACTIONS(4807),
    [anon_sym_DASH_GT] = ACTIONS(4807),
    [anon_sym_LBRACK] = ACTIONS(4809),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4809),
    [anon_sym_u27e7] = ACTIONS(4809),
    [anon_sym_u27e6] = ACTIONS(4809),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4809),
    [sym_float] = ACTIONS(4809),
    [sym_char] = ACTIONS(4809),
    [sym_string] = ACTIONS(4809),
    [sym__integer_literal] = ACTIONS(4807),
    [sym__binary_literal] = ACTIONS(4809),
    [sym__octal_literal] = ACTIONS(4809),
    [sym__hex_literal] = ACTIONS(4809),
    [anon_sym_BQUOTE] = ACTIONS(4809),
    [anon_sym_POUND] = ACTIONS(4807),
    [anon_sym_POUND2] = ACTIONS(4807),
    [sym_implicit_variable] = ACTIONS(4809),
    [sym_name] = ACTIONS(4809),
    [sym_label] = ACTIONS(4809),
    [anon_sym_u2192] = ACTIONS(4809),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4809),
    [anon_sym_u22b8] = ACTIONS(4809),
    [anon_sym_COLON_COLON] = ACTIONS(4809),
    [anon_sym_u2237] = ACTIONS(4809),
    [aux_sym__paren_open_token1] = ACTIONS(4809),
    [aux_sym__paren_close_token1] = ACTIONS(4809),
    [anon_sym_RBRACK] = ACTIONS(4809),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4809),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4809),
    [sym__cond_splice] = ACTIONS(4809),
    [sym__cond_tight_dot] = ACTIONS(4809),
    [sym__cond_prefix_dot] = ACTIONS(4809),
    [sym__cond_prefix_at] = ACTIONS(4809),
    [sym__cond_prefix_percent] = ACTIONS(4809),
    [sym__cond_qualified_op] = ACTIONS(4809),
    [sym__cond_no_section_op] = ACTIONS(4809),
    [sym__cond_minus] = ACTIONS(4809),
    [sym__varsym] = ACTIONS(4809),
    [sym__consym] = ACTIONS(4809),
  },
  [2340] = {
    [sym_variable] = ACTIONS(4689),
    [anon_sym_SEMI] = ACTIONS(4691),
    [anon_sym_let] = ACTIONS(4689),
    [anon_sym_COMMA] = ACTIONS(4691),
    [anon_sym_LBRACE] = ACTIONS(4691),
    [anon_sym_RBRACE] = ACTIONS(4691),
    [anon_sym__] = ACTIONS(4689),
    [anon_sym_SQUOTE] = ACTIONS(4689),
    [anon_sym_STAR] = ACTIONS(4691),
    [anon_sym_u2605] = ACTIONS(4691),
    [anon_sym_EQ] = ACTIONS(4691),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4691),
    [anon_sym_then] = ACTIONS(4689),
    [anon_sym_using] = ACTIONS(4689),
    [anon_sym_BSLASH] = ACTIONS(4691),
    [anon_sym_if] = ACTIONS(4689),
    [anon_sym_else] = ACTIONS(4689),
    [anon_sym_mdo] = ACTIONS(4689),
    [anon_sym_do] = ACTIONS(4689),
    [anon_sym_case] = ACTIONS(4689),
    [anon_sym_of] = ACTIONS(4689),
    [anon_sym_DASH] = ACTIONS(4689),
    [anon_sym_DASH_GT] = ACTIONS(4689),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4691),
    [anon_sym_u27e7] = ACTIONS(4691),
    [anon_sym_u27e6] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4691),
    [sym_float] = ACTIONS(4691),
    [sym_char] = ACTIONS(4691),
    [sym_string] = ACTIONS(4691),
    [sym__integer_literal] = ACTIONS(4689),
    [sym__binary_literal] = ACTIONS(4691),
    [sym__octal_literal] = ACTIONS(4691),
    [sym__hex_literal] = ACTIONS(4691),
    [anon_sym_BQUOTE] = ACTIONS(4691),
    [anon_sym_POUND] = ACTIONS(4689),
    [anon_sym_POUND2] = ACTIONS(4689),
    [sym_implicit_variable] = ACTIONS(4691),
    [sym_name] = ACTIONS(4691),
    [sym_label] = ACTIONS(4691),
    [anon_sym_u2192] = ACTIONS(4691),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4691),
    [anon_sym_u22b8] = ACTIONS(4691),
    [anon_sym_COLON_COLON] = ACTIONS(4691),
    [anon_sym_u2237] = ACTIONS(4691),
    [aux_sym__paren_open_token1] = ACTIONS(4691),
    [aux_sym__paren_close_token1] = ACTIONS(4691),
    [anon_sym_RBRACK] = ACTIONS(4691),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4691),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4691),
    [sym__cond_splice] = ACTIONS(4691),
    [sym__cond_tight_dot] = ACTIONS(4691),
    [sym__cond_prefix_dot] = ACTIONS(4691),
    [sym__cond_prefix_at] = ACTIONS(4691),
    [sym__cond_prefix_percent] = ACTIONS(4691),
    [sym__cond_qualified_op] = ACTIONS(4691),
    [sym__cond_no_section_op] = ACTIONS(4691),
    [sym__cond_minus] = ACTIONS(4691),
    [sym__varsym] = ACTIONS(4691),
    [sym__consym] = ACTIONS(4691),
  },
  [2341] = {
    [sym_variable] = ACTIONS(4803),
    [anon_sym_SEMI] = ACTIONS(4805),
    [anon_sym_let] = ACTIONS(4803),
    [anon_sym_COMMA] = ACTIONS(4805),
    [anon_sym_LBRACE] = ACTIONS(4805),
    [anon_sym_RBRACE] = ACTIONS(4805),
    [anon_sym__] = ACTIONS(4803),
    [anon_sym_SQUOTE] = ACTIONS(4803),
    [anon_sym_STAR] = ACTIONS(4805),
    [anon_sym_u2605] = ACTIONS(4805),
    [anon_sym_EQ] = ACTIONS(4805),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4805),
    [anon_sym_then] = ACTIONS(4803),
    [anon_sym_using] = ACTIONS(4803),
    [anon_sym_BSLASH] = ACTIONS(4805),
    [anon_sym_if] = ACTIONS(4803),
    [anon_sym_else] = ACTIONS(4803),
    [anon_sym_mdo] = ACTIONS(4803),
    [anon_sym_do] = ACTIONS(4803),
    [anon_sym_case] = ACTIONS(4803),
    [anon_sym_of] = ACTIONS(4803),
    [anon_sym_DASH] = ACTIONS(4803),
    [anon_sym_DASH_GT] = ACTIONS(4803),
    [anon_sym_LBRACK] = ACTIONS(4805),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4805),
    [anon_sym_u27e7] = ACTIONS(4805),
    [anon_sym_u27e6] = ACTIONS(4805),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4805),
    [sym_float] = ACTIONS(4805),
    [sym_char] = ACTIONS(4805),
    [sym_string] = ACTIONS(4805),
    [sym__integer_literal] = ACTIONS(4803),
    [sym__binary_literal] = ACTIONS(4805),
    [sym__octal_literal] = ACTIONS(4805),
    [sym__hex_literal] = ACTIONS(4805),
    [anon_sym_BQUOTE] = ACTIONS(4805),
    [anon_sym_POUND] = ACTIONS(4803),
    [anon_sym_POUND2] = ACTIONS(4803),
    [sym_implicit_variable] = ACTIONS(4805),
    [sym_name] = ACTIONS(4805),
    [sym_label] = ACTIONS(4805),
    [anon_sym_u2192] = ACTIONS(4805),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4805),
    [anon_sym_u22b8] = ACTIONS(4805),
    [anon_sym_COLON_COLON] = ACTIONS(4805),
    [anon_sym_u2237] = ACTIONS(4805),
    [aux_sym__paren_open_token1] = ACTIONS(4805),
    [aux_sym__paren_close_token1] = ACTIONS(4805),
    [anon_sym_RBRACK] = ACTIONS(4805),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4805),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4805),
    [sym__cond_splice] = ACTIONS(4805),
    [sym__cond_tight_dot] = ACTIONS(4805),
    [sym__cond_prefix_dot] = ACTIONS(4805),
    [sym__cond_prefix_at] = ACTIONS(4805),
    [sym__cond_prefix_percent] = ACTIONS(4805),
    [sym__cond_qualified_op] = ACTIONS(4805),
    [sym__cond_no_section_op] = ACTIONS(4805),
    [sym__cond_minus] = ACTIONS(4805),
    [sym__varsym] = ACTIONS(4805),
    [sym__consym] = ACTIONS(4805),
  },
  [2342] = {
    [sym_variable] = ACTIONS(4803),
    [anon_sym_SEMI] = ACTIONS(4805),
    [anon_sym_let] = ACTIONS(4803),
    [anon_sym_COMMA] = ACTIONS(4805),
    [anon_sym_LBRACE] = ACTIONS(4805),
    [anon_sym_RBRACE] = ACTIONS(4805),
    [anon_sym__] = ACTIONS(4803),
    [anon_sym_SQUOTE] = ACTIONS(4803),
    [anon_sym_STAR] = ACTIONS(4805),
    [anon_sym_u2605] = ACTIONS(4805),
    [anon_sym_EQ] = ACTIONS(4805),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4805),
    [anon_sym_then] = ACTIONS(4803),
    [anon_sym_using] = ACTIONS(4803),
    [anon_sym_BSLASH] = ACTIONS(4805),
    [anon_sym_if] = ACTIONS(4803),
    [anon_sym_else] = ACTIONS(4803),
    [anon_sym_mdo] = ACTIONS(4803),
    [anon_sym_do] = ACTIONS(4803),
    [anon_sym_case] = ACTIONS(4803),
    [anon_sym_of] = ACTIONS(4803),
    [anon_sym_DASH] = ACTIONS(4803),
    [anon_sym_DASH_GT] = ACTIONS(4803),
    [anon_sym_LBRACK] = ACTIONS(4805),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4805),
    [anon_sym_u27e7] = ACTIONS(4805),
    [anon_sym_u27e6] = ACTIONS(4805),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4805),
    [sym_float] = ACTIONS(4805),
    [sym_char] = ACTIONS(4805),
    [sym_string] = ACTIONS(4805),
    [sym__integer_literal] = ACTIONS(4803),
    [sym__binary_literal] = ACTIONS(4805),
    [sym__octal_literal] = ACTIONS(4805),
    [sym__hex_literal] = ACTIONS(4805),
    [anon_sym_BQUOTE] = ACTIONS(4805),
    [anon_sym_POUND] = ACTIONS(4803),
    [anon_sym_POUND2] = ACTIONS(4803),
    [sym_implicit_variable] = ACTIONS(4805),
    [sym_name] = ACTIONS(4805),
    [sym_label] = ACTIONS(4805),
    [anon_sym_u2192] = ACTIONS(4805),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4805),
    [anon_sym_u22b8] = ACTIONS(4805),
    [anon_sym_COLON_COLON] = ACTIONS(4805),
    [anon_sym_u2237] = ACTIONS(4805),
    [aux_sym__paren_open_token1] = ACTIONS(4805),
    [aux_sym__paren_close_token1] = ACTIONS(4805),
    [anon_sym_RBRACK] = ACTIONS(4805),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4805),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4805),
    [sym__cond_splice] = ACTIONS(4805),
    [sym__cond_tight_dot] = ACTIONS(4805),
    [sym__cond_prefix_dot] = ACTIONS(4805),
    [sym__cond_prefix_at] = ACTIONS(4805),
    [sym__cond_prefix_percent] = ACTIONS(4805),
    [sym__cond_qualified_op] = ACTIONS(4805),
    [sym__cond_no_section_op] = ACTIONS(4805),
    [sym__cond_minus] = ACTIONS(4805),
    [sym__varsym] = ACTIONS(4805),
    [sym__consym] = ACTIONS(4805),
  },
  [2343] = {
    [sym_variable] = ACTIONS(4811),
    [anon_sym_SEMI] = ACTIONS(4813),
    [anon_sym_let] = ACTIONS(4811),
    [anon_sym_COMMA] = ACTIONS(4813),
    [anon_sym_LBRACE] = ACTIONS(4813),
    [anon_sym_RBRACE] = ACTIONS(4813),
    [anon_sym__] = ACTIONS(4811),
    [anon_sym_SQUOTE] = ACTIONS(4811),
    [anon_sym_STAR] = ACTIONS(4813),
    [anon_sym_u2605] = ACTIONS(4813),
    [anon_sym_EQ] = ACTIONS(4813),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4813),
    [anon_sym_then] = ACTIONS(4811),
    [anon_sym_using] = ACTIONS(4811),
    [anon_sym_BSLASH] = ACTIONS(4813),
    [anon_sym_if] = ACTIONS(4811),
    [anon_sym_else] = ACTIONS(4811),
    [anon_sym_mdo] = ACTIONS(4811),
    [anon_sym_do] = ACTIONS(4811),
    [anon_sym_case] = ACTIONS(4811),
    [anon_sym_of] = ACTIONS(4811),
    [anon_sym_DASH] = ACTIONS(4811),
    [anon_sym_DASH_GT] = ACTIONS(4811),
    [anon_sym_LBRACK] = ACTIONS(4813),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4813),
    [anon_sym_u27e7] = ACTIONS(4813),
    [anon_sym_u27e6] = ACTIONS(4813),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4813),
    [sym_float] = ACTIONS(4813),
    [sym_char] = ACTIONS(4813),
    [sym_string] = ACTIONS(4813),
    [sym__integer_literal] = ACTIONS(4811),
    [sym__binary_literal] = ACTIONS(4813),
    [sym__octal_literal] = ACTIONS(4813),
    [sym__hex_literal] = ACTIONS(4813),
    [anon_sym_BQUOTE] = ACTIONS(4813),
    [anon_sym_POUND] = ACTIONS(4811),
    [anon_sym_POUND2] = ACTIONS(4811),
    [sym_implicit_variable] = ACTIONS(4813),
    [sym_name] = ACTIONS(4813),
    [sym_label] = ACTIONS(4813),
    [anon_sym_u2192] = ACTIONS(4813),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4813),
    [anon_sym_u22b8] = ACTIONS(4813),
    [anon_sym_COLON_COLON] = ACTIONS(4813),
    [anon_sym_u2237] = ACTIONS(4813),
    [aux_sym__paren_open_token1] = ACTIONS(4813),
    [aux_sym__paren_close_token1] = ACTIONS(4813),
    [anon_sym_RBRACK] = ACTIONS(4813),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4813),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4813),
    [sym__cond_splice] = ACTIONS(4813),
    [sym__cond_tight_dot] = ACTIONS(4813),
    [sym__cond_prefix_dot] = ACTIONS(4813),
    [sym__cond_prefix_at] = ACTIONS(4813),
    [sym__cond_prefix_percent] = ACTIONS(4813),
    [sym__cond_qualified_op] = ACTIONS(4813),
    [sym__cond_no_section_op] = ACTIONS(4813),
    [sym__cond_minus] = ACTIONS(4813),
    [sym__varsym] = ACTIONS(4813),
    [sym__consym] = ACTIONS(4813),
  },
  [2344] = {
    [sym_variable] = ACTIONS(4815),
    [anon_sym_SEMI] = ACTIONS(4817),
    [anon_sym_let] = ACTIONS(4815),
    [anon_sym_COMMA] = ACTIONS(4817),
    [anon_sym_LBRACE] = ACTIONS(4817),
    [anon_sym_RBRACE] = ACTIONS(4817),
    [anon_sym__] = ACTIONS(4815),
    [anon_sym_SQUOTE] = ACTIONS(4815),
    [anon_sym_STAR] = ACTIONS(4817),
    [anon_sym_u2605] = ACTIONS(4817),
    [anon_sym_EQ] = ACTIONS(4817),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4817),
    [anon_sym_then] = ACTIONS(4815),
    [anon_sym_using] = ACTIONS(4815),
    [anon_sym_BSLASH] = ACTIONS(4817),
    [anon_sym_if] = ACTIONS(4815),
    [anon_sym_else] = ACTIONS(4815),
    [anon_sym_mdo] = ACTIONS(4815),
    [anon_sym_do] = ACTIONS(4815),
    [anon_sym_case] = ACTIONS(4815),
    [anon_sym_of] = ACTIONS(4815),
    [anon_sym_DASH] = ACTIONS(4815),
    [anon_sym_DASH_GT] = ACTIONS(4815),
    [anon_sym_LBRACK] = ACTIONS(4817),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4817),
    [anon_sym_u27e7] = ACTIONS(4817),
    [anon_sym_u27e6] = ACTIONS(4817),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4817),
    [sym_float] = ACTIONS(4817),
    [sym_char] = ACTIONS(4817),
    [sym_string] = ACTIONS(4817),
    [sym__integer_literal] = ACTIONS(4815),
    [sym__binary_literal] = ACTIONS(4817),
    [sym__octal_literal] = ACTIONS(4817),
    [sym__hex_literal] = ACTIONS(4817),
    [anon_sym_BQUOTE] = ACTIONS(4817),
    [anon_sym_POUND] = ACTIONS(4815),
    [anon_sym_POUND2] = ACTIONS(4815),
    [sym_implicit_variable] = ACTIONS(4817),
    [sym_name] = ACTIONS(4817),
    [sym_label] = ACTIONS(4817),
    [anon_sym_u2192] = ACTIONS(4817),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4817),
    [anon_sym_u22b8] = ACTIONS(4817),
    [anon_sym_COLON_COLON] = ACTIONS(4817),
    [anon_sym_u2237] = ACTIONS(4817),
    [aux_sym__paren_open_token1] = ACTIONS(4817),
    [aux_sym__paren_close_token1] = ACTIONS(4817),
    [anon_sym_RBRACK] = ACTIONS(4817),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4817),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4817),
    [sym__cond_splice] = ACTIONS(4817),
    [sym__cond_tight_dot] = ACTIONS(4817),
    [sym__cond_prefix_dot] = ACTIONS(4817),
    [sym__cond_prefix_at] = ACTIONS(4817),
    [sym__cond_prefix_percent] = ACTIONS(4817),
    [sym__cond_qualified_op] = ACTIONS(4817),
    [sym__cond_no_section_op] = ACTIONS(4817),
    [sym__cond_minus] = ACTIONS(4817),
    [sym__varsym] = ACTIONS(4817),
    [sym__consym] = ACTIONS(4817),
  },
  [2345] = {
    [sym_variable] = ACTIONS(4819),
    [anon_sym_SEMI] = ACTIONS(4821),
    [anon_sym_let] = ACTIONS(4819),
    [anon_sym_COMMA] = ACTIONS(4821),
    [anon_sym_LBRACE] = ACTIONS(4821),
    [anon_sym_RBRACE] = ACTIONS(4821),
    [anon_sym__] = ACTIONS(4819),
    [anon_sym_SQUOTE] = ACTIONS(4819),
    [anon_sym_STAR] = ACTIONS(4821),
    [anon_sym_u2605] = ACTIONS(4821),
    [anon_sym_EQ] = ACTIONS(4821),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4821),
    [anon_sym_then] = ACTIONS(4819),
    [anon_sym_using] = ACTIONS(4819),
    [anon_sym_BSLASH] = ACTIONS(4821),
    [anon_sym_if] = ACTIONS(4819),
    [anon_sym_else] = ACTIONS(4819),
    [anon_sym_mdo] = ACTIONS(4819),
    [anon_sym_do] = ACTIONS(4819),
    [anon_sym_case] = ACTIONS(4819),
    [anon_sym_of] = ACTIONS(4819),
    [anon_sym_DASH] = ACTIONS(4819),
    [anon_sym_DASH_GT] = ACTIONS(4819),
    [anon_sym_LBRACK] = ACTIONS(4821),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4821),
    [anon_sym_u27e7] = ACTIONS(4821),
    [anon_sym_u27e6] = ACTIONS(4821),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4821),
    [sym_float] = ACTIONS(4821),
    [sym_char] = ACTIONS(4821),
    [sym_string] = ACTIONS(4821),
    [sym__integer_literal] = ACTIONS(4819),
    [sym__binary_literal] = ACTIONS(4821),
    [sym__octal_literal] = ACTIONS(4821),
    [sym__hex_literal] = ACTIONS(4821),
    [anon_sym_BQUOTE] = ACTIONS(4821),
    [anon_sym_POUND] = ACTIONS(4819),
    [anon_sym_POUND2] = ACTIONS(4819),
    [sym_implicit_variable] = ACTIONS(4821),
    [sym_name] = ACTIONS(4821),
    [sym_label] = ACTIONS(4821),
    [anon_sym_u2192] = ACTIONS(4821),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4821),
    [anon_sym_u22b8] = ACTIONS(4821),
    [anon_sym_COLON_COLON] = ACTIONS(4821),
    [anon_sym_u2237] = ACTIONS(4821),
    [aux_sym__paren_open_token1] = ACTIONS(4821),
    [aux_sym__paren_close_token1] = ACTIONS(4821),
    [anon_sym_RBRACK] = ACTIONS(4821),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4821),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4821),
    [sym__cond_splice] = ACTIONS(4821),
    [sym__cond_tight_dot] = ACTIONS(4821),
    [sym__cond_prefix_dot] = ACTIONS(4821),
    [sym__cond_prefix_at] = ACTIONS(4821),
    [sym__cond_prefix_percent] = ACTIONS(4821),
    [sym__cond_qualified_op] = ACTIONS(4821),
    [sym__cond_no_section_op] = ACTIONS(4821),
    [sym__cond_minus] = ACTIONS(4821),
    [sym__varsym] = ACTIONS(4821),
    [sym__consym] = ACTIONS(4821),
  },
  [2346] = {
    [sym_variable] = ACTIONS(4799),
    [anon_sym_SEMI] = ACTIONS(4801),
    [anon_sym_let] = ACTIONS(4799),
    [anon_sym_COMMA] = ACTIONS(4801),
    [anon_sym_LBRACE] = ACTIONS(4801),
    [anon_sym_RBRACE] = ACTIONS(4801),
    [anon_sym__] = ACTIONS(4799),
    [anon_sym_SQUOTE] = ACTIONS(4799),
    [anon_sym_STAR] = ACTIONS(4801),
    [anon_sym_u2605] = ACTIONS(4801),
    [anon_sym_EQ] = ACTIONS(4801),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4801),
    [anon_sym_then] = ACTIONS(4799),
    [anon_sym_using] = ACTIONS(4799),
    [anon_sym_BSLASH] = ACTIONS(4801),
    [anon_sym_if] = ACTIONS(4799),
    [anon_sym_else] = ACTIONS(4799),
    [anon_sym_mdo] = ACTIONS(4799),
    [anon_sym_do] = ACTIONS(4799),
    [anon_sym_case] = ACTIONS(4799),
    [anon_sym_of] = ACTIONS(4799),
    [anon_sym_DASH] = ACTIONS(4799),
    [anon_sym_DASH_GT] = ACTIONS(4799),
    [anon_sym_LBRACK] = ACTIONS(4801),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4801),
    [anon_sym_u27e7] = ACTIONS(4801),
    [anon_sym_u27e6] = ACTIONS(4801),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4801),
    [sym_float] = ACTIONS(4801),
    [sym_char] = ACTIONS(4801),
    [sym_string] = ACTIONS(4801),
    [sym__integer_literal] = ACTIONS(4799),
    [sym__binary_literal] = ACTIONS(4801),
    [sym__octal_literal] = ACTIONS(4801),
    [sym__hex_literal] = ACTIONS(4801),
    [anon_sym_BQUOTE] = ACTIONS(4801),
    [anon_sym_POUND] = ACTIONS(4799),
    [anon_sym_POUND2] = ACTIONS(4799),
    [sym_implicit_variable] = ACTIONS(4801),
    [sym_name] = ACTIONS(4801),
    [sym_label] = ACTIONS(4801),
    [anon_sym_u2192] = ACTIONS(4801),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4801),
    [anon_sym_u22b8] = ACTIONS(4801),
    [anon_sym_COLON_COLON] = ACTIONS(4801),
    [anon_sym_u2237] = ACTIONS(4801),
    [aux_sym__paren_open_token1] = ACTIONS(4801),
    [aux_sym__paren_close_token1] = ACTIONS(4801),
    [anon_sym_RBRACK] = ACTIONS(4801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4801),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4801),
    [sym__cond_splice] = ACTIONS(4801),
    [sym__cond_tight_dot] = ACTIONS(4801),
    [sym__cond_prefix_dot] = ACTIONS(4801),
    [sym__cond_prefix_at] = ACTIONS(4801),
    [sym__cond_prefix_percent] = ACTIONS(4801),
    [sym__cond_qualified_op] = ACTIONS(4801),
    [sym__cond_no_section_op] = ACTIONS(4801),
    [sym__cond_minus] = ACTIONS(4801),
    [sym__varsym] = ACTIONS(4801),
    [sym__consym] = ACTIONS(4801),
  },
  [2347] = {
    [sym_variable] = ACTIONS(4823),
    [anon_sym_SEMI] = ACTIONS(4825),
    [anon_sym_let] = ACTIONS(4823),
    [anon_sym_COMMA] = ACTIONS(4825),
    [anon_sym_LBRACE] = ACTIONS(4825),
    [anon_sym_RBRACE] = ACTIONS(4825),
    [anon_sym__] = ACTIONS(4823),
    [anon_sym_SQUOTE] = ACTIONS(4823),
    [anon_sym_STAR] = ACTIONS(4825),
    [anon_sym_u2605] = ACTIONS(4825),
    [anon_sym_EQ] = ACTIONS(4825),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4825),
    [anon_sym_then] = ACTIONS(4823),
    [anon_sym_using] = ACTIONS(4823),
    [anon_sym_BSLASH] = ACTIONS(4825),
    [anon_sym_if] = ACTIONS(4823),
    [anon_sym_else] = ACTIONS(4823),
    [anon_sym_mdo] = ACTIONS(4823),
    [anon_sym_do] = ACTIONS(4823),
    [anon_sym_case] = ACTIONS(4823),
    [anon_sym_of] = ACTIONS(4823),
    [anon_sym_DASH] = ACTIONS(4823),
    [anon_sym_DASH_GT] = ACTIONS(4823),
    [anon_sym_LBRACK] = ACTIONS(4825),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4825),
    [anon_sym_u27e7] = ACTIONS(4825),
    [anon_sym_u27e6] = ACTIONS(4825),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4825),
    [sym_float] = ACTIONS(4825),
    [sym_char] = ACTIONS(4825),
    [sym_string] = ACTIONS(4825),
    [sym__integer_literal] = ACTIONS(4823),
    [sym__binary_literal] = ACTIONS(4825),
    [sym__octal_literal] = ACTIONS(4825),
    [sym__hex_literal] = ACTIONS(4825),
    [anon_sym_BQUOTE] = ACTIONS(4825),
    [anon_sym_POUND] = ACTIONS(4823),
    [anon_sym_POUND2] = ACTIONS(4823),
    [sym_implicit_variable] = ACTIONS(4825),
    [sym_name] = ACTIONS(4825),
    [sym_label] = ACTIONS(4825),
    [anon_sym_u2192] = ACTIONS(4825),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4825),
    [anon_sym_u22b8] = ACTIONS(4825),
    [anon_sym_COLON_COLON] = ACTIONS(4825),
    [anon_sym_u2237] = ACTIONS(4825),
    [aux_sym__paren_open_token1] = ACTIONS(4825),
    [aux_sym__paren_close_token1] = ACTIONS(4825),
    [anon_sym_RBRACK] = ACTIONS(4825),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4825),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4825),
    [sym__cond_splice] = ACTIONS(4825),
    [sym__cond_tight_dot] = ACTIONS(4825),
    [sym__cond_prefix_dot] = ACTIONS(4825),
    [sym__cond_prefix_at] = ACTIONS(4825),
    [sym__cond_prefix_percent] = ACTIONS(4825),
    [sym__cond_qualified_op] = ACTIONS(4825),
    [sym__cond_no_section_op] = ACTIONS(4825),
    [sym__cond_minus] = ACTIONS(4825),
    [sym__varsym] = ACTIONS(4825),
    [sym__consym] = ACTIONS(4825),
  },
  [2348] = {
    [sym_variable] = ACTIONS(4604),
    [anon_sym_SEMI] = ACTIONS(4606),
    [anon_sym_let] = ACTIONS(4604),
    [anon_sym_COMMA] = ACTIONS(4606),
    [anon_sym_LBRACE] = ACTIONS(4606),
    [anon_sym_RBRACE] = ACTIONS(4606),
    [anon_sym__] = ACTIONS(4604),
    [anon_sym_SQUOTE] = ACTIONS(4604),
    [anon_sym_STAR] = ACTIONS(4606),
    [anon_sym_u2605] = ACTIONS(4606),
    [anon_sym_EQ] = ACTIONS(4606),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4606),
    [anon_sym_then] = ACTIONS(4604),
    [anon_sym_using] = ACTIONS(4604),
    [anon_sym_BSLASH] = ACTIONS(4606),
    [anon_sym_if] = ACTIONS(4604),
    [anon_sym_else] = ACTIONS(4604),
    [anon_sym_mdo] = ACTIONS(4604),
    [anon_sym_do] = ACTIONS(4604),
    [anon_sym_case] = ACTIONS(4604),
    [anon_sym_of] = ACTIONS(4604),
    [anon_sym_DASH] = ACTIONS(4604),
    [anon_sym_DASH_GT] = ACTIONS(4604),
    [anon_sym_LBRACK] = ACTIONS(4606),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4606),
    [anon_sym_u27e7] = ACTIONS(4606),
    [anon_sym_u27e6] = ACTIONS(4606),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4606),
    [sym_float] = ACTIONS(4606),
    [sym_char] = ACTIONS(4606),
    [sym_string] = ACTIONS(4606),
    [sym__integer_literal] = ACTIONS(4604),
    [sym__binary_literal] = ACTIONS(4606),
    [sym__octal_literal] = ACTIONS(4606),
    [sym__hex_literal] = ACTIONS(4606),
    [anon_sym_BQUOTE] = ACTIONS(4606),
    [anon_sym_POUND] = ACTIONS(4604),
    [anon_sym_POUND2] = ACTIONS(4604),
    [sym_implicit_variable] = ACTIONS(4606),
    [sym_name] = ACTIONS(4606),
    [sym_label] = ACTIONS(4606),
    [anon_sym_u2192] = ACTIONS(4606),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4606),
    [anon_sym_u22b8] = ACTIONS(4606),
    [anon_sym_COLON_COLON] = ACTIONS(4606),
    [anon_sym_u2237] = ACTIONS(4606),
    [aux_sym__paren_open_token1] = ACTIONS(4606),
    [aux_sym__paren_close_token1] = ACTIONS(4606),
    [anon_sym_RBRACK] = ACTIONS(4606),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4606),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4606),
    [sym__cond_splice] = ACTIONS(4606),
    [sym__cond_tight_dot] = ACTIONS(4606),
    [sym__cond_prefix_dot] = ACTIONS(4606),
    [sym__cond_prefix_at] = ACTIONS(4606),
    [sym__cond_prefix_percent] = ACTIONS(4606),
    [sym__cond_qualified_op] = ACTIONS(4606),
    [sym__cond_no_section_op] = ACTIONS(4606),
    [sym__cond_minus] = ACTIONS(4606),
    [sym__varsym] = ACTIONS(4606),
    [sym__consym] = ACTIONS(4606),
  },
  [2349] = {
    [sym_variable] = ACTIONS(4827),
    [anon_sym_SEMI] = ACTIONS(4829),
    [anon_sym_let] = ACTIONS(4827),
    [anon_sym_COMMA] = ACTIONS(4829),
    [anon_sym_LBRACE] = ACTIONS(4829),
    [anon_sym_RBRACE] = ACTIONS(4829),
    [anon_sym__] = ACTIONS(4827),
    [anon_sym_SQUOTE] = ACTIONS(4827),
    [anon_sym_STAR] = ACTIONS(4829),
    [anon_sym_u2605] = ACTIONS(4829),
    [anon_sym_EQ] = ACTIONS(4829),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4829),
    [anon_sym_then] = ACTIONS(4827),
    [anon_sym_using] = ACTIONS(4827),
    [anon_sym_BSLASH] = ACTIONS(4829),
    [anon_sym_if] = ACTIONS(4827),
    [anon_sym_else] = ACTIONS(4827),
    [anon_sym_mdo] = ACTIONS(4827),
    [anon_sym_do] = ACTIONS(4827),
    [anon_sym_case] = ACTIONS(4827),
    [anon_sym_of] = ACTIONS(4827),
    [anon_sym_DASH] = ACTIONS(4827),
    [anon_sym_DASH_GT] = ACTIONS(4827),
    [anon_sym_LBRACK] = ACTIONS(4829),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4829),
    [anon_sym_u27e7] = ACTIONS(4829),
    [anon_sym_u27e6] = ACTIONS(4829),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4829),
    [sym_float] = ACTIONS(4829),
    [sym_char] = ACTIONS(4829),
    [sym_string] = ACTIONS(4829),
    [sym__integer_literal] = ACTIONS(4827),
    [sym__binary_literal] = ACTIONS(4829),
    [sym__octal_literal] = ACTIONS(4829),
    [sym__hex_literal] = ACTIONS(4829),
    [anon_sym_BQUOTE] = ACTIONS(4829),
    [anon_sym_POUND] = ACTIONS(4827),
    [anon_sym_POUND2] = ACTIONS(4827),
    [sym_implicit_variable] = ACTIONS(4829),
    [sym_name] = ACTIONS(4829),
    [sym_label] = ACTIONS(4829),
    [anon_sym_u2192] = ACTIONS(4829),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4829),
    [anon_sym_u22b8] = ACTIONS(4829),
    [anon_sym_COLON_COLON] = ACTIONS(4829),
    [anon_sym_u2237] = ACTIONS(4829),
    [aux_sym__paren_open_token1] = ACTIONS(4829),
    [aux_sym__paren_close_token1] = ACTIONS(4829),
    [anon_sym_RBRACK] = ACTIONS(4829),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4829),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4829),
    [sym__cond_splice] = ACTIONS(4829),
    [sym__cond_tight_dot] = ACTIONS(4829),
    [sym__cond_prefix_dot] = ACTIONS(4829),
    [sym__cond_prefix_at] = ACTIONS(4829),
    [sym__cond_prefix_percent] = ACTIONS(4829),
    [sym__cond_qualified_op] = ACTIONS(4829),
    [sym__cond_no_section_op] = ACTIONS(4829),
    [sym__cond_minus] = ACTIONS(4829),
    [sym__varsym] = ACTIONS(4829),
    [sym__consym] = ACTIONS(4829),
  },
  [2350] = {
    [sym_variable] = ACTIONS(4831),
    [anon_sym_SEMI] = ACTIONS(4833),
    [anon_sym_let] = ACTIONS(4831),
    [anon_sym_COMMA] = ACTIONS(4833),
    [anon_sym_LBRACE] = ACTIONS(4833),
    [anon_sym_RBRACE] = ACTIONS(4833),
    [anon_sym__] = ACTIONS(4831),
    [anon_sym_SQUOTE] = ACTIONS(4831),
    [anon_sym_STAR] = ACTIONS(4833),
    [anon_sym_u2605] = ACTIONS(4833),
    [anon_sym_EQ] = ACTIONS(4833),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4833),
    [anon_sym_then] = ACTIONS(4831),
    [anon_sym_using] = ACTIONS(4831),
    [anon_sym_BSLASH] = ACTIONS(4833),
    [anon_sym_if] = ACTIONS(4831),
    [anon_sym_else] = ACTIONS(4831),
    [anon_sym_mdo] = ACTIONS(4831),
    [anon_sym_do] = ACTIONS(4831),
    [anon_sym_case] = ACTIONS(4831),
    [anon_sym_of] = ACTIONS(4831),
    [anon_sym_DASH] = ACTIONS(4831),
    [anon_sym_DASH_GT] = ACTIONS(4831),
    [anon_sym_LBRACK] = ACTIONS(4833),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4833),
    [anon_sym_u27e7] = ACTIONS(4833),
    [anon_sym_u27e6] = ACTIONS(4833),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4833),
    [sym_float] = ACTIONS(4833),
    [sym_char] = ACTIONS(4833),
    [sym_string] = ACTIONS(4833),
    [sym__integer_literal] = ACTIONS(4831),
    [sym__binary_literal] = ACTIONS(4833),
    [sym__octal_literal] = ACTIONS(4833),
    [sym__hex_literal] = ACTIONS(4833),
    [anon_sym_BQUOTE] = ACTIONS(4833),
    [anon_sym_POUND] = ACTIONS(4831),
    [anon_sym_POUND2] = ACTIONS(4831),
    [sym_implicit_variable] = ACTIONS(4833),
    [sym_name] = ACTIONS(4833),
    [sym_label] = ACTIONS(4833),
    [anon_sym_u2192] = ACTIONS(4833),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4833),
    [anon_sym_u22b8] = ACTIONS(4833),
    [anon_sym_COLON_COLON] = ACTIONS(4833),
    [anon_sym_u2237] = ACTIONS(4833),
    [aux_sym__paren_open_token1] = ACTIONS(4833),
    [aux_sym__paren_close_token1] = ACTIONS(4833),
    [anon_sym_RBRACK] = ACTIONS(4833),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4833),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4833),
    [sym__cond_splice] = ACTIONS(4833),
    [sym__cond_tight_dot] = ACTIONS(4833),
    [sym__cond_prefix_dot] = ACTIONS(4833),
    [sym__cond_prefix_at] = ACTIONS(4833),
    [sym__cond_prefix_percent] = ACTIONS(4833),
    [sym__cond_qualified_op] = ACTIONS(4833),
    [sym__cond_no_section_op] = ACTIONS(4833),
    [sym__cond_minus] = ACTIONS(4833),
    [sym__varsym] = ACTIONS(4833),
    [sym__consym] = ACTIONS(4833),
  },
  [2351] = {
    [sym_variable] = ACTIONS(4835),
    [anon_sym_SEMI] = ACTIONS(4837),
    [anon_sym_let] = ACTIONS(4835),
    [anon_sym_COMMA] = ACTIONS(4837),
    [anon_sym_LBRACE] = ACTIONS(4837),
    [anon_sym_RBRACE] = ACTIONS(4837),
    [anon_sym__] = ACTIONS(4835),
    [anon_sym_SQUOTE] = ACTIONS(4835),
    [anon_sym_STAR] = ACTIONS(4837),
    [anon_sym_u2605] = ACTIONS(4837),
    [anon_sym_EQ] = ACTIONS(4837),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4837),
    [anon_sym_then] = ACTIONS(4835),
    [anon_sym_using] = ACTIONS(4835),
    [anon_sym_BSLASH] = ACTIONS(4837),
    [anon_sym_if] = ACTIONS(4835),
    [anon_sym_else] = ACTIONS(4835),
    [anon_sym_mdo] = ACTIONS(4835),
    [anon_sym_do] = ACTIONS(4835),
    [anon_sym_case] = ACTIONS(4835),
    [anon_sym_of] = ACTIONS(4835),
    [anon_sym_DASH] = ACTIONS(4835),
    [anon_sym_DASH_GT] = ACTIONS(4835),
    [anon_sym_LBRACK] = ACTIONS(4837),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4837),
    [anon_sym_u27e7] = ACTIONS(4837),
    [anon_sym_u27e6] = ACTIONS(4837),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4837),
    [sym_float] = ACTIONS(4837),
    [sym_char] = ACTIONS(4837),
    [sym_string] = ACTIONS(4837),
    [sym__integer_literal] = ACTIONS(4835),
    [sym__binary_literal] = ACTIONS(4837),
    [sym__octal_literal] = ACTIONS(4837),
    [sym__hex_literal] = ACTIONS(4837),
    [anon_sym_BQUOTE] = ACTIONS(4837),
    [anon_sym_POUND] = ACTIONS(4835),
    [anon_sym_POUND2] = ACTIONS(4835),
    [sym_implicit_variable] = ACTIONS(4837),
    [sym_name] = ACTIONS(4837),
    [sym_label] = ACTIONS(4837),
    [anon_sym_u2192] = ACTIONS(4837),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4837),
    [anon_sym_u22b8] = ACTIONS(4837),
    [anon_sym_COLON_COLON] = ACTIONS(4837),
    [anon_sym_u2237] = ACTIONS(4837),
    [aux_sym__paren_open_token1] = ACTIONS(4837),
    [aux_sym__paren_close_token1] = ACTIONS(4837),
    [anon_sym_RBRACK] = ACTIONS(4837),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4837),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4837),
    [sym__cond_splice] = ACTIONS(4837),
    [sym__cond_tight_dot] = ACTIONS(4837),
    [sym__cond_prefix_dot] = ACTIONS(4837),
    [sym__cond_prefix_at] = ACTIONS(4837),
    [sym__cond_prefix_percent] = ACTIONS(4837),
    [sym__cond_qualified_op] = ACTIONS(4837),
    [sym__cond_no_section_op] = ACTIONS(4837),
    [sym__cond_minus] = ACTIONS(4837),
    [sym__varsym] = ACTIONS(4837),
    [sym__consym] = ACTIONS(4837),
  },
  [2352] = {
    [sym_variable] = ACTIONS(4839),
    [anon_sym_SEMI] = ACTIONS(4841),
    [anon_sym_let] = ACTIONS(4839),
    [anon_sym_COMMA] = ACTIONS(4841),
    [anon_sym_LBRACE] = ACTIONS(4841),
    [anon_sym_RBRACE] = ACTIONS(4841),
    [anon_sym__] = ACTIONS(4839),
    [anon_sym_SQUOTE] = ACTIONS(4839),
    [anon_sym_STAR] = ACTIONS(4841),
    [anon_sym_u2605] = ACTIONS(4841),
    [anon_sym_EQ] = ACTIONS(4841),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4841),
    [anon_sym_then] = ACTIONS(4839),
    [anon_sym_using] = ACTIONS(4839),
    [anon_sym_BSLASH] = ACTIONS(4841),
    [anon_sym_if] = ACTIONS(4839),
    [anon_sym_else] = ACTIONS(4839),
    [anon_sym_mdo] = ACTIONS(4839),
    [anon_sym_do] = ACTIONS(4839),
    [anon_sym_case] = ACTIONS(4839),
    [anon_sym_of] = ACTIONS(4839),
    [anon_sym_DASH] = ACTIONS(4839),
    [anon_sym_DASH_GT] = ACTIONS(4839),
    [anon_sym_LBRACK] = ACTIONS(4841),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4841),
    [anon_sym_u27e7] = ACTIONS(4841),
    [anon_sym_u27e6] = ACTIONS(4841),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4841),
    [sym_float] = ACTIONS(4841),
    [sym_char] = ACTIONS(4841),
    [sym_string] = ACTIONS(4841),
    [sym__integer_literal] = ACTIONS(4839),
    [sym__binary_literal] = ACTIONS(4841),
    [sym__octal_literal] = ACTIONS(4841),
    [sym__hex_literal] = ACTIONS(4841),
    [anon_sym_BQUOTE] = ACTIONS(4841),
    [anon_sym_POUND] = ACTIONS(4839),
    [anon_sym_POUND2] = ACTIONS(4839),
    [sym_implicit_variable] = ACTIONS(4841),
    [sym_name] = ACTIONS(4841),
    [sym_label] = ACTIONS(4841),
    [anon_sym_u2192] = ACTIONS(4841),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4841),
    [anon_sym_u22b8] = ACTIONS(4841),
    [anon_sym_COLON_COLON] = ACTIONS(4841),
    [anon_sym_u2237] = ACTIONS(4841),
    [aux_sym__paren_open_token1] = ACTIONS(4841),
    [aux_sym__paren_close_token1] = ACTIONS(4841),
    [anon_sym_RBRACK] = ACTIONS(4841),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4841),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4841),
    [sym__cond_splice] = ACTIONS(4841),
    [sym__cond_tight_dot] = ACTIONS(4841),
    [sym__cond_prefix_dot] = ACTIONS(4841),
    [sym__cond_prefix_at] = ACTIONS(4841),
    [sym__cond_prefix_percent] = ACTIONS(4841),
    [sym__cond_qualified_op] = ACTIONS(4841),
    [sym__cond_no_section_op] = ACTIONS(4841),
    [sym__cond_minus] = ACTIONS(4841),
    [sym__varsym] = ACTIONS(4841),
    [sym__consym] = ACTIONS(4841),
  },
  [2353] = {
    [sym_variable] = ACTIONS(4843),
    [anon_sym_SEMI] = ACTIONS(4845),
    [anon_sym_let] = ACTIONS(4843),
    [anon_sym_COMMA] = ACTIONS(4845),
    [anon_sym_LBRACE] = ACTIONS(4845),
    [anon_sym_RBRACE] = ACTIONS(4845),
    [anon_sym__] = ACTIONS(4843),
    [anon_sym_SQUOTE] = ACTIONS(4843),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_u2605] = ACTIONS(4845),
    [anon_sym_EQ] = ACTIONS(4845),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4845),
    [anon_sym_then] = ACTIONS(4843),
    [anon_sym_using] = ACTIONS(4843),
    [anon_sym_BSLASH] = ACTIONS(4845),
    [anon_sym_if] = ACTIONS(4843),
    [anon_sym_else] = ACTIONS(4843),
    [anon_sym_mdo] = ACTIONS(4843),
    [anon_sym_do] = ACTIONS(4843),
    [anon_sym_case] = ACTIONS(4843),
    [anon_sym_of] = ACTIONS(4843),
    [anon_sym_DASH] = ACTIONS(4843),
    [anon_sym_DASH_GT] = ACTIONS(4843),
    [anon_sym_LBRACK] = ACTIONS(4845),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4845),
    [anon_sym_u27e7] = ACTIONS(4845),
    [anon_sym_u27e6] = ACTIONS(4845),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4845),
    [sym_float] = ACTIONS(4845),
    [sym_char] = ACTIONS(4845),
    [sym_string] = ACTIONS(4845),
    [sym__integer_literal] = ACTIONS(4843),
    [sym__binary_literal] = ACTIONS(4845),
    [sym__octal_literal] = ACTIONS(4845),
    [sym__hex_literal] = ACTIONS(4845),
    [anon_sym_BQUOTE] = ACTIONS(4845),
    [anon_sym_POUND] = ACTIONS(4843),
    [anon_sym_POUND2] = ACTIONS(4843),
    [sym_implicit_variable] = ACTIONS(4845),
    [sym_name] = ACTIONS(4845),
    [sym_label] = ACTIONS(4845),
    [anon_sym_u2192] = ACTIONS(4845),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4845),
    [anon_sym_u22b8] = ACTIONS(4845),
    [anon_sym_COLON_COLON] = ACTIONS(4845),
    [anon_sym_u2237] = ACTIONS(4845),
    [aux_sym__paren_open_token1] = ACTIONS(4845),
    [aux_sym__paren_close_token1] = ACTIONS(4845),
    [anon_sym_RBRACK] = ACTIONS(4845),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4845),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4845),
    [sym__cond_splice] = ACTIONS(4845),
    [sym__cond_tight_dot] = ACTIONS(4845),
    [sym__cond_prefix_dot] = ACTIONS(4845),
    [sym__cond_prefix_at] = ACTIONS(4845),
    [sym__cond_prefix_percent] = ACTIONS(4845),
    [sym__cond_qualified_op] = ACTIONS(4845),
    [sym__cond_no_section_op] = ACTIONS(4845),
    [sym__cond_minus] = ACTIONS(4845),
    [sym__varsym] = ACTIONS(4845),
    [sym__consym] = ACTIONS(4845),
  },
  [2354] = {
    [sym_variable] = ACTIONS(4847),
    [anon_sym_SEMI] = ACTIONS(4849),
    [anon_sym_let] = ACTIONS(4847),
    [anon_sym_COMMA] = ACTIONS(4849),
    [anon_sym_LBRACE] = ACTIONS(4849),
    [anon_sym_RBRACE] = ACTIONS(4849),
    [anon_sym__] = ACTIONS(4847),
    [anon_sym_SQUOTE] = ACTIONS(4847),
    [anon_sym_STAR] = ACTIONS(4849),
    [anon_sym_u2605] = ACTIONS(4849),
    [anon_sym_EQ] = ACTIONS(4849),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4849),
    [anon_sym_then] = ACTIONS(4847),
    [anon_sym_using] = ACTIONS(4847),
    [anon_sym_BSLASH] = ACTIONS(4849),
    [anon_sym_if] = ACTIONS(4847),
    [anon_sym_else] = ACTIONS(4847),
    [anon_sym_mdo] = ACTIONS(4847),
    [anon_sym_do] = ACTIONS(4847),
    [anon_sym_case] = ACTIONS(4847),
    [anon_sym_of] = ACTIONS(4847),
    [anon_sym_DASH] = ACTIONS(4847),
    [anon_sym_DASH_GT] = ACTIONS(4847),
    [anon_sym_LBRACK] = ACTIONS(4849),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4849),
    [anon_sym_u27e7] = ACTIONS(4849),
    [anon_sym_u27e6] = ACTIONS(4849),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4849),
    [sym_float] = ACTIONS(4849),
    [sym_char] = ACTIONS(4849),
    [sym_string] = ACTIONS(4849),
    [sym__integer_literal] = ACTIONS(4847),
    [sym__binary_literal] = ACTIONS(4849),
    [sym__octal_literal] = ACTIONS(4849),
    [sym__hex_literal] = ACTIONS(4849),
    [anon_sym_BQUOTE] = ACTIONS(4849),
    [anon_sym_POUND] = ACTIONS(4847),
    [anon_sym_POUND2] = ACTIONS(4847),
    [sym_implicit_variable] = ACTIONS(4849),
    [sym_name] = ACTIONS(4849),
    [sym_label] = ACTIONS(4849),
    [anon_sym_u2192] = ACTIONS(4849),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4849),
    [anon_sym_u22b8] = ACTIONS(4849),
    [anon_sym_COLON_COLON] = ACTIONS(4849),
    [anon_sym_u2237] = ACTIONS(4849),
    [aux_sym__paren_open_token1] = ACTIONS(4849),
    [aux_sym__paren_close_token1] = ACTIONS(4849),
    [anon_sym_RBRACK] = ACTIONS(4849),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4849),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4849),
    [sym__cond_splice] = ACTIONS(4849),
    [sym__cond_tight_dot] = ACTIONS(4849),
    [sym__cond_prefix_dot] = ACTIONS(4849),
    [sym__cond_prefix_at] = ACTIONS(4849),
    [sym__cond_prefix_percent] = ACTIONS(4849),
    [sym__cond_qualified_op] = ACTIONS(4849),
    [sym__cond_no_section_op] = ACTIONS(4849),
    [sym__cond_minus] = ACTIONS(4849),
    [sym__varsym] = ACTIONS(4849),
    [sym__consym] = ACTIONS(4849),
  },
  [2355] = {
    [sym_variable] = ACTIONS(4851),
    [anon_sym_SEMI] = ACTIONS(4853),
    [anon_sym_let] = ACTIONS(4851),
    [anon_sym_COMMA] = ACTIONS(4853),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [anon_sym_RBRACE] = ACTIONS(4853),
    [anon_sym__] = ACTIONS(4851),
    [anon_sym_SQUOTE] = ACTIONS(4851),
    [anon_sym_STAR] = ACTIONS(4853),
    [anon_sym_u2605] = ACTIONS(4853),
    [anon_sym_EQ] = ACTIONS(4853),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4853),
    [anon_sym_then] = ACTIONS(4851),
    [anon_sym_using] = ACTIONS(4851),
    [anon_sym_BSLASH] = ACTIONS(4853),
    [anon_sym_if] = ACTIONS(4851),
    [anon_sym_else] = ACTIONS(4851),
    [anon_sym_mdo] = ACTIONS(4851),
    [anon_sym_do] = ACTIONS(4851),
    [anon_sym_case] = ACTIONS(4851),
    [anon_sym_of] = ACTIONS(4851),
    [anon_sym_DASH] = ACTIONS(4851),
    [anon_sym_DASH_GT] = ACTIONS(4851),
    [anon_sym_LBRACK] = ACTIONS(4853),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4853),
    [anon_sym_u27e7] = ACTIONS(4853),
    [anon_sym_u27e6] = ACTIONS(4853),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4853),
    [sym_float] = ACTIONS(4853),
    [sym_char] = ACTIONS(4853),
    [sym_string] = ACTIONS(4853),
    [sym__integer_literal] = ACTIONS(4851),
    [sym__binary_literal] = ACTIONS(4853),
    [sym__octal_literal] = ACTIONS(4853),
    [sym__hex_literal] = ACTIONS(4853),
    [anon_sym_BQUOTE] = ACTIONS(4853),
    [anon_sym_POUND] = ACTIONS(4851),
    [anon_sym_POUND2] = ACTIONS(4851),
    [sym_implicit_variable] = ACTIONS(4853),
    [sym_name] = ACTIONS(4853),
    [sym_label] = ACTIONS(4853),
    [anon_sym_u2192] = ACTIONS(4853),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4853),
    [anon_sym_u22b8] = ACTIONS(4853),
    [anon_sym_COLON_COLON] = ACTIONS(4853),
    [anon_sym_u2237] = ACTIONS(4853),
    [aux_sym__paren_open_token1] = ACTIONS(4853),
    [aux_sym__paren_close_token1] = ACTIONS(4853),
    [anon_sym_RBRACK] = ACTIONS(4853),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4853),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4853),
    [sym__cond_splice] = ACTIONS(4853),
    [sym__cond_tight_dot] = ACTIONS(4853),
    [sym__cond_prefix_dot] = ACTIONS(4853),
    [sym__cond_prefix_at] = ACTIONS(4853),
    [sym__cond_prefix_percent] = ACTIONS(4853),
    [sym__cond_qualified_op] = ACTIONS(4853),
    [sym__cond_no_section_op] = ACTIONS(4853),
    [sym__cond_minus] = ACTIONS(4853),
    [sym__varsym] = ACTIONS(4853),
    [sym__consym] = ACTIONS(4853),
  },
  [2356] = {
    [sym__type_wildcard] = STATE(7980),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(12494),
    [sym__class_apply] = STATE(8005),
    [sym__class_infix] = STATE(8007),
    [sym__ctr_parens] = STATE(7980),
    [sym__ctr_tuple] = STATE(7980),
    [sym_implicit_parameter] = STATE(10828),
    [sym_constraint] = STATE(2234),
    [sym__ctr_forall] = STATE(10819),
    [sym__ctr_context] = STATE(10815),
    [sym__ctr_signature] = STATE(10805),
    [sym_constraints] = STATE(9712),
    [sym__context_inline] = STATE(2304),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11126),
    [sym__splice_dollars] = STATE(7254),
    [sym_splice] = STATE(7980),
    [sym_quasiquote] = STATE(7980),
    [sym_integer] = STATE(7997),
    [sym_unit] = STATE(7980),
    [sym_unboxed_unit] = STATE(7980),
    [sym_prefix_tuple] = STATE(7980),
    [sym_prefix_unboxed_tuple] = STATE(7980),
    [sym_prefix_unboxed_sum] = STATE(7980),
    [sym_literal] = STATE(7980),
    [sym__qualified_type] = STATE(7953),
    [sym__qtyconid] = STATE(8011),
    [sym__tycon_arrow] = STATE(8011),
    [sym__qtycon_arrow] = STATE(8011),
    [sym__promoted_tycons_alias] = STATE(7980),
    [sym__promoted_tycons] = STATE(7980),
    [sym__varsym_prefix] = STATE(8011),
    [sym__pvarsym] = STATE(8011),
    [sym__qvarsym_prefix] = STATE(8011),
    [sym__pqvarsym] = STATE(8011),
    [sym__consym_prefix] = STATE(8011),
    [sym__pconsym] = STATE(8011),
    [sym__qconsym_prefix] = STATE(8011),
    [sym__pqconsym] = STATE(8011),
    [sym__paren_open] = STATE(1536),
    [sym__unboxed_open] = STATE(9192),
    [sym_variable] = ACTIONS(3389),
    [anon_sym__] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3395),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [sym_float] = ACTIONS(3397),
    [sym_char] = ACTIONS(3397),
    [sym_string] = ACTIONS(3397),
    [sym__integer_literal] = ACTIONS(3399),
    [sym__binary_literal] = ACTIONS(3401),
    [sym__octal_literal] = ACTIONS(3401),
    [sym__hex_literal] = ACTIONS(3401),
    [sym_implicit_variable] = ACTIONS(3405),
    [sym_name] = ACTIONS(4687),
    [aux_sym__paren_open_token1] = ACTIONS(3409),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3413),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_context] = ACTIONS(3415),
    [sym__cond_infix] = ACTIONS(3417),
  },
  [2357] = {
    [sym__type_wildcard] = STATE(7980),
    [sym__forall_keyword] = STATE(8285),
    [sym__forall_body] = STATE(12494),
    [sym__class_apply] = STATE(8005),
    [sym__class_infix] = STATE(8007),
    [sym__ctr_parens] = STATE(7980),
    [sym__ctr_tuple] = STATE(7980),
    [sym_implicit_parameter] = STATE(10828),
    [sym_constraint] = STATE(2234),
    [sym__ctr_forall] = STATE(10819),
    [sym__ctr_context] = STATE(10815),
    [sym__ctr_signature] = STATE(10805),
    [sym_constraints] = STATE(9709),
    [sym__context_inline] = STATE(2304),
    [sym__modid_prefix] = STATE(10076),
    [aux_sym__qualifying_module] = STATE(11126),
    [sym__splice_dollars] = STATE(7254),
    [sym_splice] = STATE(7980),
    [sym_quasiquote] = STATE(7980),
    [sym_integer] = STATE(7997),
    [sym_unit] = STATE(7980),
    [sym_unboxed_unit] = STATE(7980),
    [sym_prefix_tuple] = STATE(7980),
    [sym_prefix_unboxed_tuple] = STATE(7980),
    [sym_prefix_unboxed_sum] = STATE(7980),
    [sym_literal] = STATE(7980),
    [sym__qualified_type] = STATE(7953),
    [sym__qtyconid] = STATE(8011),
    [sym__tycon_arrow] = STATE(8011),
    [sym__qtycon_arrow] = STATE(8011),
    [sym__promoted_tycons_alias] = STATE(7980),
    [sym__promoted_tycons] = STATE(7980),
    [sym__varsym_prefix] = STATE(8011),
    [sym__pvarsym] = STATE(8011),
    [sym__qvarsym_prefix] = STATE(8011),
    [sym__pqvarsym] = STATE(8011),
    [sym__consym_prefix] = STATE(8011),
    [sym__pconsym] = STATE(8011),
    [sym__qconsym_prefix] = STATE(8011),
    [sym__pqconsym] = STATE(8011),
    [sym__paren_open] = STATE(1536),
    [sym__unboxed_open] = STATE(9192),
    [sym_variable] = ACTIONS(3389),
    [anon_sym__] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3395),
    [anon_sym_forall] = ACTIONS(1375),
    [anon_sym_u2200] = ACTIONS(1377),
    [sym_float] = ACTIONS(3397),
    [sym_char] = ACTIONS(3397),
    [sym_string] = ACTIONS(3397),
    [sym__integer_literal] = ACTIONS(3399),
    [sym__binary_literal] = ACTIONS(3401),
    [sym__octal_literal] = ACTIONS(3401),
    [sym__hex_literal] = ACTIONS(3401),
    [sym_implicit_variable] = ACTIONS(3405),
    [sym_name] = ACTIONS(4687),
    [aux_sym__paren_open_token1] = ACTIONS(3409),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(3413),
    [sym__cond_splice] = ACTIONS(83),
    [sym__cond_context] = ACTIONS(3415),
    [sym__cond_infix] = ACTIONS(3417),
  },
  [2358] = {
    [sym_variable] = ACTIONS(4855),
    [anon_sym_SEMI] = ACTIONS(4857),
    [anon_sym_let] = ACTIONS(4855),
    [anon_sym_COMMA] = ACTIONS(4857),
    [anon_sym_LBRACE] = ACTIONS(4857),
    [anon_sym_RBRACE] = ACTIONS(4857),
    [anon_sym__] = ACTIONS(4855),
    [anon_sym_SQUOTE] = ACTIONS(4855),
    [anon_sym_STAR] = ACTIONS(4857),
    [anon_sym_u2605] = ACTIONS(4857),
    [anon_sym_EQ] = ACTIONS(4857),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4857),
    [anon_sym_then] = ACTIONS(4855),
    [anon_sym_using] = ACTIONS(4855),
    [anon_sym_BSLASH] = ACTIONS(4857),
    [anon_sym_if] = ACTIONS(4855),
    [anon_sym_else] = ACTIONS(4855),
    [anon_sym_mdo] = ACTIONS(4855),
    [anon_sym_do] = ACTIONS(4855),
    [anon_sym_case] = ACTIONS(4855),
    [anon_sym_of] = ACTIONS(4855),
    [anon_sym_DASH] = ACTIONS(4855),
    [anon_sym_DASH_GT] = ACTIONS(4855),
    [anon_sym_LBRACK] = ACTIONS(4857),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4857),
    [anon_sym_u27e7] = ACTIONS(4857),
    [anon_sym_u27e6] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4857),
    [sym_float] = ACTIONS(4857),
    [sym_char] = ACTIONS(4857),
    [sym_string] = ACTIONS(4857),
    [sym__integer_literal] = ACTIONS(4855),
    [sym__binary_literal] = ACTIONS(4857),
    [sym__octal_literal] = ACTIONS(4857),
    [sym__hex_literal] = ACTIONS(4857),
    [anon_sym_BQUOTE] = ACTIONS(4857),
    [anon_sym_POUND] = ACTIONS(4855),
    [anon_sym_POUND2] = ACTIONS(4855),
    [sym_implicit_variable] = ACTIONS(4857),
    [sym_name] = ACTIONS(4857),
    [sym_label] = ACTIONS(4857),
    [anon_sym_u2192] = ACTIONS(4857),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4857),
    [anon_sym_u22b8] = ACTIONS(4857),
    [anon_sym_COLON_COLON] = ACTIONS(4857),
    [anon_sym_u2237] = ACTIONS(4857),
    [aux_sym__paren_open_token1] = ACTIONS(4857),
    [aux_sym__paren_close_token1] = ACTIONS(4857),
    [anon_sym_RBRACK] = ACTIONS(4857),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4857),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4857),
    [sym__cond_splice] = ACTIONS(4857),
    [sym__cond_tight_dot] = ACTIONS(4857),
    [sym__cond_prefix_dot] = ACTIONS(4857),
    [sym__cond_prefix_at] = ACTIONS(4857),
    [sym__cond_prefix_percent] = ACTIONS(4857),
    [sym__cond_qualified_op] = ACTIONS(4857),
    [sym__cond_no_section_op] = ACTIONS(4857),
    [sym__cond_minus] = ACTIONS(4857),
    [sym__varsym] = ACTIONS(4857),
    [sym__consym] = ACTIONS(4857),
  },
  [2359] = {
    [sym_variable] = ACTIONS(4859),
    [anon_sym_SEMI] = ACTIONS(4861),
    [anon_sym_let] = ACTIONS(4859),
    [anon_sym_COMMA] = ACTIONS(4861),
    [anon_sym_LBRACE] = ACTIONS(4861),
    [anon_sym_RBRACE] = ACTIONS(4861),
    [anon_sym__] = ACTIONS(4859),
    [anon_sym_SQUOTE] = ACTIONS(4859),
    [anon_sym_STAR] = ACTIONS(4861),
    [anon_sym_u2605] = ACTIONS(4861),
    [anon_sym_EQ] = ACTIONS(4861),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4861),
    [anon_sym_then] = ACTIONS(4859),
    [anon_sym_using] = ACTIONS(4859),
    [anon_sym_BSLASH] = ACTIONS(4861),
    [anon_sym_if] = ACTIONS(4859),
    [anon_sym_else] = ACTIONS(4859),
    [anon_sym_mdo] = ACTIONS(4859),
    [anon_sym_do] = ACTIONS(4859),
    [anon_sym_case] = ACTIONS(4859),
    [anon_sym_of] = ACTIONS(4859),
    [anon_sym_DASH] = ACTIONS(4859),
    [anon_sym_DASH_GT] = ACTIONS(4859),
    [anon_sym_LBRACK] = ACTIONS(4861),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4861),
    [anon_sym_u27e7] = ACTIONS(4861),
    [anon_sym_u27e6] = ACTIONS(4861),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4861),
    [sym_float] = ACTIONS(4861),
    [sym_char] = ACTIONS(4861),
    [sym_string] = ACTIONS(4861),
    [sym__integer_literal] = ACTIONS(4859),
    [sym__binary_literal] = ACTIONS(4861),
    [sym__octal_literal] = ACTIONS(4861),
    [sym__hex_literal] = ACTIONS(4861),
    [anon_sym_BQUOTE] = ACTIONS(4861),
    [anon_sym_POUND] = ACTIONS(4859),
    [anon_sym_POUND2] = ACTIONS(4859),
    [sym_implicit_variable] = ACTIONS(4861),
    [sym_name] = ACTIONS(4861),
    [sym_label] = ACTIONS(4861),
    [anon_sym_u2192] = ACTIONS(4861),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4861),
    [anon_sym_u22b8] = ACTIONS(4861),
    [anon_sym_COLON_COLON] = ACTIONS(4861),
    [anon_sym_u2237] = ACTIONS(4861),
    [aux_sym__paren_open_token1] = ACTIONS(4861),
    [aux_sym__paren_close_token1] = ACTIONS(4861),
    [anon_sym_RBRACK] = ACTIONS(4861),
    [aux_sym__token1] = ACTIONS(3),
    [sym__phantom_arrow] = ACTIONS(4861),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4861),
    [sym__cond_splice] = ACTIONS(4861),
    [sym__cond_tight_dot] = ACTIONS(4861),
    [sym__cond_prefix_dot] = ACTIONS(4861),
    [sym__cond_prefix_at] = ACTIONS(4861),
    [sym__cond_prefix_percent] = ACTIONS(4861),
    [sym__cond_qualified_op] = ACTIONS(4861),
    [sym__cond_no_section_op] = ACTIONS(4861),
    [sym__cond_minus] = ACTIONS(4861),
    [sym__varsym] = ACTIONS(4861),
    [sym__consym] = ACTIONS(4861),
  },
  [2360] = {
    [sym__qual_dot] = STATE(10227),
    [sym__tight_dot] = STATE(10227),
    [sym_variable] = ACTIONS(4624),
    [anon_sym_SEMI] = ACTIONS(4626),
    [anon_sym_let] = ACTIONS(4624),
    [anon_sym_COMMA] = ACTIONS(4626),
    [anon_sym_LBRACE] = ACTIONS(4626),
    [anon_sym_RBRACE] = ACTIONS(4626),
    [anon_sym__] = ACTIONS(4624),
    [anon_sym_SQUOTE] = ACTIONS(4624),
    [anon_sym_STAR] = ACTIONS(4626),
    [anon_sym_u2605] = ACTIONS(4626),
    [anon_sym_EQ] = ACTIONS(4626),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4626),
    [anon_sym_then] = ACTIONS(4624),
    [anon_sym_using] = ACTIONS(4624),
    [anon_sym_BSLASH] = ACTIONS(4626),
    [anon_sym_if] = ACTIONS(4624),
    [anon_sym_else] = ACTIONS(4624),
    [anon_sym_mdo] = ACTIONS(4624),
    [anon_sym_do] = ACTIONS(4624),
    [anon_sym_case] = ACTIONS(4624),
    [anon_sym_of] = ACTIONS(4624),
    [anon_sym_DASH] = ACTIONS(4624),
    [anon_sym_DASH_GT] = ACTIONS(4626),
    [anon_sym_LBRACK] = ACTIONS(4626),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4626),
    [anon_sym_u27e7] = ACTIONS(4626),
    [anon_sym_u27e6] = ACTIONS(4626),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4626),
    [sym_float] = ACTIONS(4626),
    [sym_char] = ACTIONS(4626),
    [sym_string] = ACTIONS(4626),
    [sym__integer_literal] = ACTIONS(4624),
    [sym__binary_literal] = ACTIONS(4626),
    [sym__octal_literal] = ACTIONS(4626),
    [sym__hex_literal] = ACTIONS(4626),
    [anon_sym_BQUOTE] = ACTIONS(4626),
    [anon_sym_POUND] = ACTIONS(4624),
    [anon_sym_POUND2] = ACTIONS(4624),
    [sym_implicit_variable] = ACTIONS(4626),
    [sym_name] = ACTIONS(4626),
    [sym_label] = ACTIONS(4626),
    [anon_sym_u2192] = ACTIONS(4626),
    [anon_sym_COLON_COLON] = ACTIONS(4626),
    [anon_sym_u2237] = ACTIONS(4626),
    [aux_sym__paren_open_token1] = ACTIONS(4626),
    [aux_sym__paren_close_token1] = ACTIONS(4626),
    [anon_sym_RBRACK] = ACTIONS(4626),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4626),
    [sym__cond_splice] = ACTIONS(4626),
    [sym__cond_qual_dot] = ACTIONS(4616),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(4626),
    [sym__cond_prefix_at] = ACTIONS(4626),
    [sym__cond_qualified_op] = ACTIONS(4626),
    [sym__cond_no_section_op] = ACTIONS(4626),
    [sym__cond_minus] = ACTIONS(4626),
    [sym__varsym] = ACTIONS(4626),
    [sym__consym] = ACTIONS(4626),
  },
  [2361] = {
    [sym__qual_dot] = STATE(10227),
    [sym__tight_dot] = STATE(10227),
    [sym_variable] = ACTIONS(4628),
    [anon_sym_SEMI] = ACTIONS(4630),
    [anon_sym_let] = ACTIONS(4628),
    [anon_sym_COMMA] = ACTIONS(4630),
    [anon_sym_LBRACE] = ACTIONS(4630),
    [anon_sym_RBRACE] = ACTIONS(4630),
    [anon_sym__] = ACTIONS(4628),
    [anon_sym_SQUOTE] = ACTIONS(4628),
    [anon_sym_STAR] = ACTIONS(4630),
    [anon_sym_u2605] = ACTIONS(4630),
    [anon_sym_EQ] = ACTIONS(4630),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4630),
    [anon_sym_then] = ACTIONS(4628),
    [anon_sym_using] = ACTIONS(4628),
    [anon_sym_BSLASH] = ACTIONS(4630),
    [anon_sym_if] = ACTIONS(4628),
    [anon_sym_else] = ACTIONS(4628),
    [anon_sym_mdo] = ACTIONS(4628),
    [anon_sym_do] = ACTIONS(4628),
    [anon_sym_case] = ACTIONS(4628),
    [anon_sym_of] = ACTIONS(4628),
    [anon_sym_DASH] = ACTIONS(4628),
    [anon_sym_DASH_GT] = ACTIONS(4630),
    [anon_sym_LBRACK] = ACTIONS(4630),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4630),
    [anon_sym_u27e7] = ACTIONS(4630),
    [anon_sym_u27e6] = ACTIONS(4630),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4630),
    [sym_float] = ACTIONS(4630),
    [sym_char] = ACTIONS(4630),
    [sym_string] = ACTIONS(4630),
    [sym__integer_literal] = ACTIONS(4628),
    [sym__binary_literal] = ACTIONS(4630),
    [sym__octal_literal] = ACTIONS(4630),
    [sym__hex_literal] = ACTIONS(4630),
    [anon_sym_BQUOTE] = ACTIONS(4630),
    [anon_sym_POUND] = ACTIONS(4628),
    [anon_sym_POUND2] = ACTIONS(4628),
    [sym_implicit_variable] = ACTIONS(4630),
    [sym_name] = ACTIONS(4630),
    [sym_label] = ACTIONS(4630),
    [anon_sym_u2192] = ACTIONS(4630),
    [anon_sym_COLON_COLON] = ACTIONS(4630),
    [anon_sym_u2237] = ACTIONS(4630),
    [aux_sym__paren_open_token1] = ACTIONS(4630),
    [aux_sym__paren_close_token1] = ACTIONS(4630),
    [anon_sym_RBRACK] = ACTIONS(4630),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4630),
    [sym__cond_splice] = ACTIONS(4630),
    [sym__cond_qual_dot] = ACTIONS(4616),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(4630),
    [sym__cond_prefix_at] = ACTIONS(4630),
    [sym__cond_qualified_op] = ACTIONS(4630),
    [sym__cond_no_section_op] = ACTIONS(4630),
    [sym__cond_minus] = ACTIONS(4630),
    [sym__varsym] = ACTIONS(4630),
    [sym__consym] = ACTIONS(4630),
  },
  [2362] = {
    [sym__fun_arrow] = STATE(1677),
    [sym_modifier] = STATE(9901),
    [sym__linear_fun_arrow] = STATE(1676),
    [sym__arrow] = STATE(7944),
    [sym__linear_arrow] = STATE(7941),
    [sym__prefix_percent] = STATE(2611),
    [sym_variable] = ACTIONS(4564),
    [anon_sym_SEMI] = ACTIONS(4566),
    [anon_sym_let] = ACTIONS(4564),
    [anon_sym_LBRACE] = ACTIONS(4566),
    [anon_sym_SQUOTE] = ACTIONS(4564),
    [anon_sym_STAR] = ACTIONS(4566),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4566),
    [anon_sym_PIPE] = ACTIONS(4566),
    [anon_sym_BSLASH] = ACTIONS(4566),
    [anon_sym_if] = ACTIONS(4564),
    [anon_sym_mdo] = ACTIONS(4564),
    [anon_sym_do] = ACTIONS(4564),
    [anon_sym_case] = ACTIONS(4564),
    [anon_sym_DASH] = ACTIONS(4564),
    [anon_sym_DASH_GT] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4566),
    [anon_sym_u27e6] = ACTIONS(4566),
    [sym_float] = ACTIONS(4566),
    [sym_char] = ACTIONS(4566),
    [sym_string] = ACTIONS(4566),
    [sym__integer_literal] = ACTIONS(4564),
    [sym__binary_literal] = ACTIONS(4566),
    [sym__octal_literal] = ACTIONS(4566),
    [sym__hex_literal] = ACTIONS(4566),
    [anon_sym_BQUOTE] = ACTIONS(4566),
    [anon_sym_POUND] = ACTIONS(4564),
    [anon_sym_POUND2] = ACTIONS(4564),
    [sym_implicit_variable] = ACTIONS(4566),
    [sym_name] = ACTIONS(4566),
    [sym_label] = ACTIONS(4566),
    [anon_sym_u2192] = ACTIONS(4570),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4572),
    [anon_sym_u22b8] = ACTIONS(4572),
    [anon_sym_COLON_COLON] = ACTIONS(4566),
    [anon_sym_u2237] = ACTIONS(4566),
    [aux_sym__paren_open_token1] = ACTIONS(4566),
    [anon_sym_where] = ACTIONS(4564),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4566),
    [sym__cond_layout_end] = ACTIONS(4566),
    [sym__cond_layout_end_explicit] = ACTIONS(4566),
    [sym__phantom_where] = ACTIONS(4566),
    [sym__phantom_arrow] = ACTIONS(4574),
    [sym__phantom_bar] = ACTIONS(4566),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4566),
    [sym__cond_splice] = ACTIONS(4566),
    [sym__cond_tight_dot] = ACTIONS(4566),
    [sym__cond_prefix_dot] = ACTIONS(4566),
    [sym__cond_prefix_at] = ACTIONS(4566),
    [sym__cond_prefix_percent] = ACTIONS(4576),
    [sym__cond_qualified_op] = ACTIONS(4566),
    [sym__cond_no_section_op] = ACTIONS(4566),
    [sym__cond_minus] = ACTIONS(4566),
    [sym__varsym] = ACTIONS(4566),
    [sym__consym] = ACTIONS(4566),
  },
  [2363] = {
    [sym__qual_dot] = STATE(10227),
    [sym__tight_dot] = STATE(10227),
    [sym_variable] = ACTIONS(4612),
    [anon_sym_SEMI] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4612),
    [anon_sym_COMMA] = ACTIONS(4614),
    [anon_sym_LBRACE] = ACTIONS(4614),
    [anon_sym_RBRACE] = ACTIONS(4614),
    [anon_sym__] = ACTIONS(4612),
    [anon_sym_SQUOTE] = ACTIONS(4612),
    [anon_sym_STAR] = ACTIONS(4614),
    [anon_sym_u2605] = ACTIONS(4614),
    [anon_sym_EQ] = ACTIONS(4614),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4614),
    [anon_sym_then] = ACTIONS(4612),
    [anon_sym_using] = ACTIONS(4612),
    [anon_sym_BSLASH] = ACTIONS(4614),
    [anon_sym_if] = ACTIONS(4612),
    [anon_sym_else] = ACTIONS(4612),
    [anon_sym_mdo] = ACTIONS(4612),
    [anon_sym_do] = ACTIONS(4612),
    [anon_sym_case] = ACTIONS(4612),
    [anon_sym_of] = ACTIONS(4612),
    [anon_sym_DASH] = ACTIONS(4612),
    [anon_sym_DASH_GT] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(4614),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4614),
    [anon_sym_u27e7] = ACTIONS(4614),
    [anon_sym_u27e6] = ACTIONS(4614),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4614),
    [sym_float] = ACTIONS(4614),
    [sym_char] = ACTIONS(4614),
    [sym_string] = ACTIONS(4614),
    [sym__integer_literal] = ACTIONS(4612),
    [sym__binary_literal] = ACTIONS(4614),
    [sym__octal_literal] = ACTIONS(4614),
    [sym__hex_literal] = ACTIONS(4614),
    [anon_sym_BQUOTE] = ACTIONS(4614),
    [anon_sym_POUND] = ACTIONS(4612),
    [anon_sym_POUND2] = ACTIONS(4612),
    [sym_implicit_variable] = ACTIONS(4614),
    [sym_name] = ACTIONS(4614),
    [sym_label] = ACTIONS(4614),
    [anon_sym_u2192] = ACTIONS(4614),
    [anon_sym_COLON_COLON] = ACTIONS(4614),
    [anon_sym_u2237] = ACTIONS(4614),
    [aux_sym__paren_open_token1] = ACTIONS(4614),
    [aux_sym__paren_close_token1] = ACTIONS(4614),
    [anon_sym_RBRACK] = ACTIONS(4614),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4614),
    [sym__cond_splice] = ACTIONS(4614),
    [sym__cond_qual_dot] = ACTIONS(4616),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(4614),
    [sym__cond_prefix_at] = ACTIONS(4614),
    [sym__cond_qualified_op] = ACTIONS(4614),
    [sym__cond_no_section_op] = ACTIONS(4614),
    [sym__cond_minus] = ACTIONS(4614),
    [sym__varsym] = ACTIONS(4614),
    [sym__consym] = ACTIONS(4614),
  },
  [2364] = {
    [sym__fun_arrow] = STATE(1677),
    [sym_modifier] = STATE(9901),
    [sym__linear_fun_arrow] = STATE(1676),
    [sym__arrow] = STATE(7944),
    [sym__linear_arrow] = STATE(7941),
    [sym__prefix_percent] = STATE(2611),
    [sym_variable] = ACTIONS(4578),
    [anon_sym_SEMI] = ACTIONS(4580),
    [anon_sym_let] = ACTIONS(4578),
    [anon_sym_LBRACE] = ACTIONS(4580),
    [anon_sym_SQUOTE] = ACTIONS(4578),
    [anon_sym_STAR] = ACTIONS(4580),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4580),
    [anon_sym_PIPE] = ACTIONS(4580),
    [anon_sym_BSLASH] = ACTIONS(4580),
    [anon_sym_if] = ACTIONS(4578),
    [anon_sym_mdo] = ACTIONS(4578),
    [anon_sym_do] = ACTIONS(4578),
    [anon_sym_case] = ACTIONS(4578),
    [anon_sym_DASH] = ACTIONS(4578),
    [anon_sym_DASH_GT] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4580),
    [anon_sym_u27e6] = ACTIONS(4580),
    [sym_float] = ACTIONS(4580),
    [sym_char] = ACTIONS(4580),
    [sym_string] = ACTIONS(4580),
    [sym__integer_literal] = ACTIONS(4578),
    [sym__binary_literal] = ACTIONS(4580),
    [sym__octal_literal] = ACTIONS(4580),
    [sym__hex_literal] = ACTIONS(4580),
    [anon_sym_BQUOTE] = ACTIONS(4580),
    [anon_sym_POUND] = ACTIONS(4578),
    [anon_sym_POUND2] = ACTIONS(4578),
    [sym_implicit_variable] = ACTIONS(4580),
    [sym_name] = ACTIONS(4580),
    [sym_label] = ACTIONS(4580),
    [anon_sym_u2192] = ACTIONS(4570),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4572),
    [anon_sym_u22b8] = ACTIONS(4572),
    [anon_sym_COLON_COLON] = ACTIONS(4580),
    [anon_sym_u2237] = ACTIONS(4580),
    [aux_sym__paren_open_token1] = ACTIONS(4580),
    [anon_sym_where] = ACTIONS(4578),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4580),
    [sym__cond_layout_end] = ACTIONS(4580),
    [sym__cond_layout_end_explicit] = ACTIONS(4580),
    [sym__phantom_where] = ACTIONS(4580),
    [sym__phantom_arrow] = ACTIONS(4574),
    [sym__phantom_bar] = ACTIONS(4580),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4580),
    [sym__cond_splice] = ACTIONS(4580),
    [sym__cond_tight_dot] = ACTIONS(4580),
    [sym__cond_prefix_dot] = ACTIONS(4580),
    [sym__cond_prefix_at] = ACTIONS(4580),
    [sym__cond_prefix_percent] = ACTIONS(4576),
    [sym__cond_qualified_op] = ACTIONS(4580),
    [sym__cond_no_section_op] = ACTIONS(4580),
    [sym__cond_minus] = ACTIONS(4580),
    [sym__varsym] = ACTIONS(4580),
    [sym__consym] = ACTIONS(4580),
  },
  [2365] = {
    [sym__qual_dot] = STATE(8574),
    [sym__tight_dot] = STATE(8574),
    [sym_variable] = ACTIONS(4604),
    [anon_sym_SEMI] = ACTIONS(4606),
    [anon_sym_let] = ACTIONS(4604),
    [anon_sym_COMMA] = ACTIONS(4606),
    [anon_sym_LBRACE] = ACTIONS(4606),
    [anon_sym_RBRACE] = ACTIONS(4606),
    [anon_sym__] = ACTIONS(4604),
    [anon_sym_SQUOTE] = ACTIONS(4604),
    [anon_sym_STAR] = ACTIONS(4606),
    [anon_sym_u2605] = ACTIONS(4606),
    [anon_sym_EQ] = ACTIONS(4606),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4606),
    [anon_sym_then] = ACTIONS(4604),
    [anon_sym_using] = ACTIONS(4604),
    [anon_sym_BSLASH] = ACTIONS(4606),
    [anon_sym_if] = ACTIONS(4604),
    [anon_sym_else] = ACTIONS(4604),
    [anon_sym_mdo] = ACTIONS(4604),
    [anon_sym_do] = ACTIONS(4604),
    [anon_sym_case] = ACTIONS(4604),
    [anon_sym_of] = ACTIONS(4604),
    [anon_sym_DASH] = ACTIONS(4604),
    [anon_sym_DASH_GT] = ACTIONS(4606),
    [anon_sym_LBRACK] = ACTIONS(4606),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4606),
    [anon_sym_u27e7] = ACTIONS(4606),
    [anon_sym_u27e6] = ACTIONS(4606),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4606),
    [sym_float] = ACTIONS(4606),
    [sym_char] = ACTIONS(4606),
    [sym_string] = ACTIONS(4606),
    [sym__integer_literal] = ACTIONS(4604),
    [sym__binary_literal] = ACTIONS(4606),
    [sym__octal_literal] = ACTIONS(4606),
    [sym__hex_literal] = ACTIONS(4606),
    [anon_sym_BQUOTE] = ACTIONS(4606),
    [anon_sym_POUND] = ACTIONS(4604),
    [anon_sym_POUND2] = ACTIONS(4604),
    [sym_implicit_variable] = ACTIONS(4606),
    [sym_name] = ACTIONS(4606),
    [sym_label] = ACTIONS(4606),
    [anon_sym_u2192] = ACTIONS(4606),
    [anon_sym_COLON_COLON] = ACTIONS(4606),
    [anon_sym_u2237] = ACTIONS(4606),
    [aux_sym__paren_open_token1] = ACTIONS(4606),
    [aux_sym__paren_close_token1] = ACTIONS(4606),
    [anon_sym_RBRACK] = ACTIONS(4606),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4606),
    [sym__cond_splice] = ACTIONS(4606),
    [sym__cond_qual_dot] = ACTIONS(4608),
    [sym__cond_tight_dot] = ACTIONS(4610),
    [sym__cond_prefix_dot] = ACTIONS(4606),
    [sym__cond_prefix_at] = ACTIONS(4606),
    [sym__cond_qualified_op] = ACTIONS(4606),
    [sym__cond_no_section_op] = ACTIONS(4606),
    [sym__cond_minus] = ACTIONS(4606),
    [sym__varsym] = ACTIONS(4606),
    [sym__consym] = ACTIONS(4606),
  },
  [2366] = {
    [sym__qual_dot] = STATE(8574),
    [sym__tight_dot] = STATE(8574),
    [sym_variable] = ACTIONS(4612),
    [anon_sym_SEMI] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4612),
    [anon_sym_COMMA] = ACTIONS(4614),
    [anon_sym_LBRACE] = ACTIONS(4614),
    [anon_sym_RBRACE] = ACTIONS(4614),
    [anon_sym__] = ACTIONS(4612),
    [anon_sym_SQUOTE] = ACTIONS(4612),
    [anon_sym_STAR] = ACTIONS(4614),
    [anon_sym_u2605] = ACTIONS(4614),
    [anon_sym_EQ] = ACTIONS(4614),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4614),
    [anon_sym_then] = ACTIONS(4612),
    [anon_sym_using] = ACTIONS(4612),
    [anon_sym_BSLASH] = ACTIONS(4614),
    [anon_sym_if] = ACTIONS(4612),
    [anon_sym_else] = ACTIONS(4612),
    [anon_sym_mdo] = ACTIONS(4612),
    [anon_sym_do] = ACTIONS(4612),
    [anon_sym_case] = ACTIONS(4612),
    [anon_sym_of] = ACTIONS(4612),
    [anon_sym_DASH] = ACTIONS(4612),
    [anon_sym_DASH_GT] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(4614),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4614),
    [anon_sym_u27e7] = ACTIONS(4614),
    [anon_sym_u27e6] = ACTIONS(4614),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4614),
    [sym_float] = ACTIONS(4614),
    [sym_char] = ACTIONS(4614),
    [sym_string] = ACTIONS(4614),
    [sym__integer_literal] = ACTIONS(4612),
    [sym__binary_literal] = ACTIONS(4614),
    [sym__octal_literal] = ACTIONS(4614),
    [sym__hex_literal] = ACTIONS(4614),
    [anon_sym_BQUOTE] = ACTIONS(4614),
    [anon_sym_POUND] = ACTIONS(4612),
    [anon_sym_POUND2] = ACTIONS(4612),
    [sym_implicit_variable] = ACTIONS(4614),
    [sym_name] = ACTIONS(4614),
    [sym_label] = ACTIONS(4614),
    [anon_sym_u2192] = ACTIONS(4614),
    [anon_sym_COLON_COLON] = ACTIONS(4614),
    [anon_sym_u2237] = ACTIONS(4614),
    [aux_sym__paren_open_token1] = ACTIONS(4614),
    [aux_sym__paren_close_token1] = ACTIONS(4614),
    [anon_sym_RBRACK] = ACTIONS(4614),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4614),
    [sym__cond_splice] = ACTIONS(4614),
    [sym__cond_qual_dot] = ACTIONS(4608),
    [sym__cond_tight_dot] = ACTIONS(4610),
    [sym__cond_prefix_dot] = ACTIONS(4614),
    [sym__cond_prefix_at] = ACTIONS(4614),
    [sym__cond_qualified_op] = ACTIONS(4614),
    [sym__cond_no_section_op] = ACTIONS(4614),
    [sym__cond_minus] = ACTIONS(4614),
    [sym__varsym] = ACTIONS(4614),
    [sym__consym] = ACTIONS(4614),
  },
  [2367] = {
    [sym__fun_arrow] = STATE(1677),
    [sym_modifier] = STATE(9901),
    [sym__linear_fun_arrow] = STATE(1676),
    [sym__arrow] = STATE(7944),
    [sym__linear_arrow] = STATE(7941),
    [sym__prefix_percent] = STATE(2611),
    [sym_variable] = ACTIONS(4590),
    [anon_sym_SEMI] = ACTIONS(4592),
    [anon_sym_let] = ACTIONS(4590),
    [anon_sym_LBRACE] = ACTIONS(4592),
    [anon_sym_SQUOTE] = ACTIONS(4590),
    [anon_sym_STAR] = ACTIONS(4592),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4592),
    [anon_sym_PIPE] = ACTIONS(4592),
    [anon_sym_BSLASH] = ACTIONS(4592),
    [anon_sym_if] = ACTIONS(4590),
    [anon_sym_mdo] = ACTIONS(4590),
    [anon_sym_do] = ACTIONS(4590),
    [anon_sym_case] = ACTIONS(4590),
    [anon_sym_DASH] = ACTIONS(4590),
    [anon_sym_DASH_GT] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4592),
    [anon_sym_u27e6] = ACTIONS(4592),
    [sym_float] = ACTIONS(4592),
    [sym_char] = ACTIONS(4592),
    [sym_string] = ACTIONS(4592),
    [sym__integer_literal] = ACTIONS(4590),
    [sym__binary_literal] = ACTIONS(4592),
    [sym__octal_literal] = ACTIONS(4592),
    [sym__hex_literal] = ACTIONS(4592),
    [anon_sym_BQUOTE] = ACTIONS(4592),
    [anon_sym_POUND] = ACTIONS(4590),
    [anon_sym_POUND2] = ACTIONS(4590),
    [sym_implicit_variable] = ACTIONS(4592),
    [sym_name] = ACTIONS(4592),
    [sym_label] = ACTIONS(4592),
    [anon_sym_u2192] = ACTIONS(4570),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4572),
    [anon_sym_u22b8] = ACTIONS(4572),
    [anon_sym_COLON_COLON] = ACTIONS(4592),
    [anon_sym_u2237] = ACTIONS(4592),
    [aux_sym__paren_open_token1] = ACTIONS(4592),
    [anon_sym_where] = ACTIONS(4590),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4592),
    [sym__cond_layout_end] = ACTIONS(4592),
    [sym__cond_layout_end_explicit] = ACTIONS(4592),
    [sym__phantom_where] = ACTIONS(4592),
    [sym__phantom_arrow] = ACTIONS(4574),
    [sym__phantom_bar] = ACTIONS(4592),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4592),
    [sym__cond_splice] = ACTIONS(4592),
    [sym__cond_tight_dot] = ACTIONS(4592),
    [sym__cond_prefix_dot] = ACTIONS(4592),
    [sym__cond_prefix_at] = ACTIONS(4592),
    [sym__cond_prefix_percent] = ACTIONS(4576),
    [sym__cond_qualified_op] = ACTIONS(4592),
    [sym__cond_no_section_op] = ACTIONS(4592),
    [sym__cond_minus] = ACTIONS(4592),
    [sym__varsym] = ACTIONS(4592),
    [sym__consym] = ACTIONS(4592),
  },
  [2368] = {
    [sym__fun_arrow] = STATE(1677),
    [sym_modifier] = STATE(9901),
    [sym__linear_fun_arrow] = STATE(1676),
    [sym__arrow] = STATE(7944),
    [sym__linear_arrow] = STATE(7941),
    [sym__prefix_percent] = STATE(2611),
    [sym_variable] = ACTIONS(4564),
    [anon_sym_SEMI] = ACTIONS(4566),
    [anon_sym_let] = ACTIONS(4564),
    [anon_sym_LBRACE] = ACTIONS(4566),
    [anon_sym_SQUOTE] = ACTIONS(4564),
    [anon_sym_STAR] = ACTIONS(4566),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4566),
    [anon_sym_PIPE] = ACTIONS(4566),
    [anon_sym_BSLASH] = ACTIONS(4566),
    [anon_sym_if] = ACTIONS(4564),
    [anon_sym_mdo] = ACTIONS(4564),
    [anon_sym_do] = ACTIONS(4564),
    [anon_sym_case] = ACTIONS(4564),
    [anon_sym_DASH] = ACTIONS(4564),
    [anon_sym_DASH_GT] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4566),
    [anon_sym_u27e6] = ACTIONS(4566),
    [sym_float] = ACTIONS(4566),
    [sym_char] = ACTIONS(4566),
    [sym_string] = ACTIONS(4566),
    [sym__integer_literal] = ACTIONS(4564),
    [sym__binary_literal] = ACTIONS(4566),
    [sym__octal_literal] = ACTIONS(4566),
    [sym__hex_literal] = ACTIONS(4566),
    [anon_sym_BQUOTE] = ACTIONS(4566),
    [anon_sym_POUND] = ACTIONS(4564),
    [anon_sym_POUND2] = ACTIONS(4564),
    [sym_implicit_variable] = ACTIONS(4566),
    [sym_name] = ACTIONS(4566),
    [sym_label] = ACTIONS(4566),
    [anon_sym_u2192] = ACTIONS(4570),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4572),
    [anon_sym_u22b8] = ACTIONS(4572),
    [anon_sym_COLON_COLON] = ACTIONS(4566),
    [anon_sym_u2237] = ACTIONS(4566),
    [aux_sym__paren_open_token1] = ACTIONS(4566),
    [anon_sym_where] = ACTIONS(4564),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4566),
    [sym__cond_layout_end] = ACTIONS(4566),
    [sym__cond_layout_end_explicit] = ACTIONS(4566),
    [sym__phantom_where] = ACTIONS(4566),
    [sym__phantom_arrow] = ACTIONS(4574),
    [sym__phantom_bar] = ACTIONS(4566),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4566),
    [sym__cond_splice] = ACTIONS(4566),
    [sym__cond_tight_dot] = ACTIONS(4566),
    [sym__cond_prefix_dot] = ACTIONS(4566),
    [sym__cond_prefix_at] = ACTIONS(4566),
    [sym__cond_prefix_percent] = ACTIONS(4576),
    [sym__cond_qualified_op] = ACTIONS(4566),
    [sym__cond_no_section_op] = ACTIONS(4566),
    [sym__cond_minus] = ACTIONS(4566),
    [sym__varsym] = ACTIONS(4566),
    [sym__consym] = ACTIONS(4566),
  },
  [2369] = {
    [sym__fun_arrow] = STATE(1677),
    [sym_modifier] = STATE(9901),
    [sym__linear_fun_arrow] = STATE(1676),
    [sym__arrow] = STATE(7944),
    [sym__linear_arrow] = STATE(7941),
    [sym__prefix_percent] = STATE(2611),
    [sym_variable] = ACTIONS(4600),
    [anon_sym_SEMI] = ACTIONS(4602),
    [anon_sym_let] = ACTIONS(4600),
    [anon_sym_LBRACE] = ACTIONS(4602),
    [anon_sym_SQUOTE] = ACTIONS(4600),
    [anon_sym_STAR] = ACTIONS(4602),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4602),
    [anon_sym_PIPE] = ACTIONS(4602),
    [anon_sym_BSLASH] = ACTIONS(4602),
    [anon_sym_if] = ACTIONS(4600),
    [anon_sym_mdo] = ACTIONS(4600),
    [anon_sym_do] = ACTIONS(4600),
    [anon_sym_case] = ACTIONS(4600),
    [anon_sym_DASH] = ACTIONS(4600),
    [anon_sym_DASH_GT] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4602),
    [anon_sym_u27e6] = ACTIONS(4602),
    [sym_float] = ACTIONS(4602),
    [sym_char] = ACTIONS(4602),
    [sym_string] = ACTIONS(4602),
    [sym__integer_literal] = ACTIONS(4600),
    [sym__binary_literal] = ACTIONS(4602),
    [sym__octal_literal] = ACTIONS(4602),
    [sym__hex_literal] = ACTIONS(4602),
    [anon_sym_BQUOTE] = ACTIONS(4602),
    [anon_sym_POUND] = ACTIONS(4600),
    [anon_sym_POUND2] = ACTIONS(4600),
    [sym_implicit_variable] = ACTIONS(4602),
    [sym_name] = ACTIONS(4602),
    [sym_label] = ACTIONS(4602),
    [anon_sym_u2192] = ACTIONS(4570),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4572),
    [anon_sym_u22b8] = ACTIONS(4572),
    [anon_sym_COLON_COLON] = ACTIONS(4602),
    [anon_sym_u2237] = ACTIONS(4602),
    [aux_sym__paren_open_token1] = ACTIONS(4602),
    [anon_sym_where] = ACTIONS(4600),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4602),
    [sym__cond_layout_end] = ACTIONS(4602),
    [sym__cond_layout_end_explicit] = ACTIONS(4602),
    [sym__phantom_where] = ACTIONS(4602),
    [sym__phantom_arrow] = ACTIONS(4574),
    [sym__phantom_bar] = ACTIONS(4602),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4602),
    [sym__cond_splice] = ACTIONS(4602),
    [sym__cond_tight_dot] = ACTIONS(4602),
    [sym__cond_prefix_dot] = ACTIONS(4602),
    [sym__cond_prefix_at] = ACTIONS(4602),
    [sym__cond_prefix_percent] = ACTIONS(4576),
    [sym__cond_qualified_op] = ACTIONS(4602),
    [sym__cond_no_section_op] = ACTIONS(4602),
    [sym__cond_minus] = ACTIONS(4602),
    [sym__varsym] = ACTIONS(4602),
    [sym__consym] = ACTIONS(4602),
  },
  [2370] = {
    [sym__fun_arrow] = STATE(1677),
    [sym_modifier] = STATE(9901),
    [sym__linear_fun_arrow] = STATE(1676),
    [sym__arrow] = STATE(7944),
    [sym__linear_arrow] = STATE(7941),
    [sym__prefix_percent] = STATE(2611),
    [sym_variable] = ACTIONS(4582),
    [anon_sym_SEMI] = ACTIONS(4584),
    [anon_sym_let] = ACTIONS(4582),
    [anon_sym_LBRACE] = ACTIONS(4584),
    [anon_sym_SQUOTE] = ACTIONS(4582),
    [anon_sym_STAR] = ACTIONS(4584),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4584),
    [anon_sym_PIPE] = ACTIONS(4584),
    [anon_sym_BSLASH] = ACTIONS(4584),
    [anon_sym_if] = ACTIONS(4582),
    [anon_sym_mdo] = ACTIONS(4582),
    [anon_sym_do] = ACTIONS(4582),
    [anon_sym_case] = ACTIONS(4582),
    [anon_sym_DASH] = ACTIONS(4582),
    [anon_sym_DASH_GT] = ACTIONS(4582),
    [anon_sym_LBRACK] = ACTIONS(4584),
    [anon_sym_u27e6] = ACTIONS(4584),
    [sym_float] = ACTIONS(4584),
    [sym_char] = ACTIONS(4584),
    [sym_string] = ACTIONS(4584),
    [sym__integer_literal] = ACTIONS(4582),
    [sym__binary_literal] = ACTIONS(4584),
    [sym__octal_literal] = ACTIONS(4584),
    [sym__hex_literal] = ACTIONS(4584),
    [anon_sym_BQUOTE] = ACTIONS(4584),
    [anon_sym_POUND] = ACTIONS(4582),
    [anon_sym_POUND2] = ACTIONS(4582),
    [sym_implicit_variable] = ACTIONS(4584),
    [sym_name] = ACTIONS(4584),
    [sym_label] = ACTIONS(4584),
    [anon_sym_u2192] = ACTIONS(4584),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4584),
    [anon_sym_u22b8] = ACTIONS(4584),
    [anon_sym_COLON_COLON] = ACTIONS(4584),
    [anon_sym_u2237] = ACTIONS(4584),
    [aux_sym__paren_open_token1] = ACTIONS(4584),
    [anon_sym_where] = ACTIONS(4582),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4584),
    [sym__cond_layout_end] = ACTIONS(4584),
    [sym__cond_layout_end_explicit] = ACTIONS(4584),
    [sym__phantom_where] = ACTIONS(4584),
    [sym__phantom_arrow] = ACTIONS(4584),
    [sym__phantom_bar] = ACTIONS(4584),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4584),
    [sym__cond_splice] = ACTIONS(4584),
    [sym__cond_tight_dot] = ACTIONS(4584),
    [sym__cond_prefix_dot] = ACTIONS(4584),
    [sym__cond_prefix_at] = ACTIONS(4584),
    [sym__cond_prefix_percent] = ACTIONS(4584),
    [sym__cond_qualified_op] = ACTIONS(4584),
    [sym__cond_no_section_op] = ACTIONS(4584),
    [sym__cond_minus] = ACTIONS(4584),
    [sym__varsym] = ACTIONS(4584),
    [sym__consym] = ACTIONS(4584),
  },
  [2371] = {
    [sym__fun_arrow] = STATE(1677),
    [sym_modifier] = STATE(9901),
    [sym__linear_fun_arrow] = STATE(1676),
    [sym__arrow] = STATE(7944),
    [sym__linear_arrow] = STATE(7941),
    [sym__prefix_percent] = STATE(2611),
    [sym_variable] = ACTIONS(4590),
    [anon_sym_SEMI] = ACTIONS(4592),
    [anon_sym_let] = ACTIONS(4590),
    [anon_sym_LBRACE] = ACTIONS(4592),
    [anon_sym_SQUOTE] = ACTIONS(4590),
    [anon_sym_STAR] = ACTIONS(4592),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4592),
    [anon_sym_PIPE] = ACTIONS(4592),
    [anon_sym_BSLASH] = ACTIONS(4592),
    [anon_sym_if] = ACTIONS(4590),
    [anon_sym_mdo] = ACTIONS(4590),
    [anon_sym_do] = ACTIONS(4590),
    [anon_sym_case] = ACTIONS(4590),
    [anon_sym_DASH] = ACTIONS(4590),
    [anon_sym_DASH_GT] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4592),
    [anon_sym_u27e6] = ACTIONS(4592),
    [sym_float] = ACTIONS(4592),
    [sym_char] = ACTIONS(4592),
    [sym_string] = ACTIONS(4592),
    [sym__integer_literal] = ACTIONS(4590),
    [sym__binary_literal] = ACTIONS(4592),
    [sym__octal_literal] = ACTIONS(4592),
    [sym__hex_literal] = ACTIONS(4592),
    [anon_sym_BQUOTE] = ACTIONS(4592),
    [anon_sym_POUND] = ACTIONS(4590),
    [anon_sym_POUND2] = ACTIONS(4590),
    [sym_implicit_variable] = ACTIONS(4592),
    [sym_name] = ACTIONS(4592),
    [sym_label] = ACTIONS(4592),
    [anon_sym_u2192] = ACTIONS(4570),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4572),
    [anon_sym_u22b8] = ACTIONS(4572),
    [anon_sym_COLON_COLON] = ACTIONS(4592),
    [anon_sym_u2237] = ACTIONS(4592),
    [aux_sym__paren_open_token1] = ACTIONS(4592),
    [anon_sym_where] = ACTIONS(4590),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4592),
    [sym__cond_layout_end] = ACTIONS(4592),
    [sym__cond_layout_end_explicit] = ACTIONS(4592),
    [sym__phantom_where] = ACTIONS(4592),
    [sym__phantom_arrow] = ACTIONS(4574),
    [sym__phantom_bar] = ACTIONS(4592),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4592),
    [sym__cond_splice] = ACTIONS(4592),
    [sym__cond_tight_dot] = ACTIONS(4592),
    [sym__cond_prefix_dot] = ACTIONS(4592),
    [sym__cond_prefix_at] = ACTIONS(4592),
    [sym__cond_prefix_percent] = ACTIONS(4576),
    [sym__cond_qualified_op] = ACTIONS(4592),
    [sym__cond_no_section_op] = ACTIONS(4592),
    [sym__cond_minus] = ACTIONS(4592),
    [sym__varsym] = ACTIONS(4592),
    [sym__consym] = ACTIONS(4592),
  },
  [2372] = {
    [sym__qual_dot] = STATE(8574),
    [sym__tight_dot] = STATE(8574),
    [sym_variable] = ACTIONS(4632),
    [anon_sym_SEMI] = ACTIONS(4634),
    [anon_sym_let] = ACTIONS(4632),
    [anon_sym_COMMA] = ACTIONS(4634),
    [anon_sym_LBRACE] = ACTIONS(4634),
    [anon_sym_RBRACE] = ACTIONS(4634),
    [anon_sym__] = ACTIONS(4632),
    [anon_sym_SQUOTE] = ACTIONS(4632),
    [anon_sym_STAR] = ACTIONS(4634),
    [anon_sym_u2605] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(4634),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4634),
    [anon_sym_then] = ACTIONS(4632),
    [anon_sym_using] = ACTIONS(4632),
    [anon_sym_BSLASH] = ACTIONS(4634),
    [anon_sym_if] = ACTIONS(4632),
    [anon_sym_else] = ACTIONS(4632),
    [anon_sym_mdo] = ACTIONS(4632),
    [anon_sym_do] = ACTIONS(4632),
    [anon_sym_case] = ACTIONS(4632),
    [anon_sym_of] = ACTIONS(4632),
    [anon_sym_DASH] = ACTIONS(4632),
    [anon_sym_DASH_GT] = ACTIONS(4634),
    [anon_sym_LBRACK] = ACTIONS(4634),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4634),
    [anon_sym_u27e7] = ACTIONS(4634),
    [anon_sym_u27e6] = ACTIONS(4634),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4634),
    [sym_float] = ACTIONS(4634),
    [sym_char] = ACTIONS(4634),
    [sym_string] = ACTIONS(4634),
    [sym__integer_literal] = ACTIONS(4632),
    [sym__binary_literal] = ACTIONS(4634),
    [sym__octal_literal] = ACTIONS(4634),
    [sym__hex_literal] = ACTIONS(4634),
    [anon_sym_BQUOTE] = ACTIONS(4634),
    [anon_sym_POUND] = ACTIONS(4632),
    [anon_sym_POUND2] = ACTIONS(4632),
    [sym_implicit_variable] = ACTIONS(4634),
    [sym_name] = ACTIONS(4634),
    [sym_label] = ACTIONS(4634),
    [anon_sym_u2192] = ACTIONS(4634),
    [anon_sym_COLON_COLON] = ACTIONS(4634),
    [anon_sym_u2237] = ACTIONS(4634),
    [aux_sym__paren_open_token1] = ACTIONS(4634),
    [aux_sym__paren_close_token1] = ACTIONS(4634),
    [anon_sym_RBRACK] = ACTIONS(4634),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4634),
    [sym__cond_splice] = ACTIONS(4634),
    [sym__cond_qual_dot] = ACTIONS(4608),
    [sym__cond_tight_dot] = ACTIONS(4610),
    [sym__cond_prefix_dot] = ACTIONS(4634),
    [sym__cond_prefix_at] = ACTIONS(4634),
    [sym__cond_qualified_op] = ACTIONS(4634),
    [sym__cond_no_section_op] = ACTIONS(4634),
    [sym__cond_minus] = ACTIONS(4634),
    [sym__varsym] = ACTIONS(4634),
    [sym__consym] = ACTIONS(4634),
  },
  [2373] = {
    [sym__fun_arrow] = STATE(1677),
    [sym_modifier] = STATE(9901),
    [sym__linear_fun_arrow] = STATE(1676),
    [sym__arrow] = STATE(7944),
    [sym__linear_arrow] = STATE(7941),
    [sym__prefix_percent] = STATE(2611),
    [sym_variable] = ACTIONS(4586),
    [anon_sym_SEMI] = ACTIONS(4588),
    [anon_sym_let] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(4588),
    [anon_sym_SQUOTE] = ACTIONS(4586),
    [anon_sym_STAR] = ACTIONS(4588),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4588),
    [anon_sym_PIPE] = ACTIONS(4588),
    [anon_sym_BSLASH] = ACTIONS(4588),
    [anon_sym_if] = ACTIONS(4586),
    [anon_sym_mdo] = ACTIONS(4586),
    [anon_sym_do] = ACTIONS(4586),
    [anon_sym_case] = ACTIONS(4586),
    [anon_sym_DASH] = ACTIONS(4586),
    [anon_sym_DASH_GT] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4588),
    [anon_sym_u27e6] = ACTIONS(4588),
    [sym_float] = ACTIONS(4588),
    [sym_char] = ACTIONS(4588),
    [sym_string] = ACTIONS(4588),
    [sym__integer_literal] = ACTIONS(4586),
    [sym__binary_literal] = ACTIONS(4588),
    [sym__octal_literal] = ACTIONS(4588),
    [sym__hex_literal] = ACTIONS(4588),
    [anon_sym_BQUOTE] = ACTIONS(4588),
    [anon_sym_POUND] = ACTIONS(4586),
    [anon_sym_POUND2] = ACTIONS(4586),
    [sym_implicit_variable] = ACTIONS(4588),
    [sym_name] = ACTIONS(4588),
    [sym_label] = ACTIONS(4588),
    [anon_sym_u2192] = ACTIONS(4570),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4572),
    [anon_sym_u22b8] = ACTIONS(4572),
    [anon_sym_COLON_COLON] = ACTIONS(4588),
    [anon_sym_u2237] = ACTIONS(4588),
    [aux_sym__paren_open_token1] = ACTIONS(4588),
    [anon_sym_where] = ACTIONS(4586),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4588),
    [sym__cond_layout_end] = ACTIONS(4588),
    [sym__cond_layout_end_explicit] = ACTIONS(4588),
    [sym__phantom_where] = ACTIONS(4588),
    [sym__phantom_arrow] = ACTIONS(4574),
    [sym__phantom_bar] = ACTIONS(4588),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4588),
    [sym__cond_splice] = ACTIONS(4588),
    [sym__cond_tight_dot] = ACTIONS(4588),
    [sym__cond_prefix_dot] = ACTIONS(4588),
    [sym__cond_prefix_at] = ACTIONS(4588),
    [sym__cond_prefix_percent] = ACTIONS(4576),
    [sym__cond_qualified_op] = ACTIONS(4588),
    [sym__cond_no_section_op] = ACTIONS(4588),
    [sym__cond_minus] = ACTIONS(4588),
    [sym__varsym] = ACTIONS(4588),
    [sym__consym] = ACTIONS(4588),
  },
  [2374] = {
    [sym__qual_dot] = STATE(10227),
    [sym__tight_dot] = STATE(10227),
    [sym_variable] = ACTIONS(4604),
    [anon_sym_SEMI] = ACTIONS(4606),
    [anon_sym_let] = ACTIONS(4604),
    [anon_sym_COMMA] = ACTIONS(4606),
    [anon_sym_LBRACE] = ACTIONS(4606),
    [anon_sym_RBRACE] = ACTIONS(4606),
    [anon_sym__] = ACTIONS(4604),
    [anon_sym_SQUOTE] = ACTIONS(4604),
    [anon_sym_STAR] = ACTIONS(4606),
    [anon_sym_u2605] = ACTIONS(4606),
    [anon_sym_EQ] = ACTIONS(4606),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4606),
    [anon_sym_then] = ACTIONS(4604),
    [anon_sym_using] = ACTIONS(4604),
    [anon_sym_BSLASH] = ACTIONS(4606),
    [anon_sym_if] = ACTIONS(4604),
    [anon_sym_else] = ACTIONS(4604),
    [anon_sym_mdo] = ACTIONS(4604),
    [anon_sym_do] = ACTIONS(4604),
    [anon_sym_case] = ACTIONS(4604),
    [anon_sym_of] = ACTIONS(4604),
    [anon_sym_DASH] = ACTIONS(4604),
    [anon_sym_DASH_GT] = ACTIONS(4606),
    [anon_sym_LBRACK] = ACTIONS(4606),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4606),
    [anon_sym_u27e7] = ACTIONS(4606),
    [anon_sym_u27e6] = ACTIONS(4606),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4606),
    [sym_float] = ACTIONS(4606),
    [sym_char] = ACTIONS(4606),
    [sym_string] = ACTIONS(4606),
    [sym__integer_literal] = ACTIONS(4604),
    [sym__binary_literal] = ACTIONS(4606),
    [sym__octal_literal] = ACTIONS(4606),
    [sym__hex_literal] = ACTIONS(4606),
    [anon_sym_BQUOTE] = ACTIONS(4606),
    [anon_sym_POUND] = ACTIONS(4604),
    [anon_sym_POUND2] = ACTIONS(4604),
    [sym_implicit_variable] = ACTIONS(4606),
    [sym_name] = ACTIONS(4606),
    [sym_label] = ACTIONS(4606),
    [anon_sym_u2192] = ACTIONS(4606),
    [anon_sym_COLON_COLON] = ACTIONS(4606),
    [anon_sym_u2237] = ACTIONS(4606),
    [aux_sym__paren_open_token1] = ACTIONS(4606),
    [aux_sym__paren_close_token1] = ACTIONS(4606),
    [anon_sym_RBRACK] = ACTIONS(4606),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4606),
    [sym__cond_splice] = ACTIONS(4606),
    [sym__cond_qual_dot] = ACTIONS(4616),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(4606),
    [sym__cond_prefix_at] = ACTIONS(4606),
    [sym__cond_qualified_op] = ACTIONS(4606),
    [sym__cond_no_section_op] = ACTIONS(4606),
    [sym__cond_minus] = ACTIONS(4606),
    [sym__varsym] = ACTIONS(4606),
    [sym__consym] = ACTIONS(4606),
  },
  [2375] = {
    [sym__qual_dot] = STATE(10227),
    [sym__tight_dot] = STATE(10227),
    [sym_variable] = ACTIONS(4632),
    [anon_sym_SEMI] = ACTIONS(4634),
    [anon_sym_let] = ACTIONS(4632),
    [anon_sym_COMMA] = ACTIONS(4634),
    [anon_sym_LBRACE] = ACTIONS(4634),
    [anon_sym_RBRACE] = ACTIONS(4634),
    [anon_sym__] = ACTIONS(4632),
    [anon_sym_SQUOTE] = ACTIONS(4632),
    [anon_sym_STAR] = ACTIONS(4634),
    [anon_sym_u2605] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(4634),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4634),
    [anon_sym_then] = ACTIONS(4632),
    [anon_sym_using] = ACTIONS(4632),
    [anon_sym_BSLASH] = ACTIONS(4634),
    [anon_sym_if] = ACTIONS(4632),
    [anon_sym_else] = ACTIONS(4632),
    [anon_sym_mdo] = ACTIONS(4632),
    [anon_sym_do] = ACTIONS(4632),
    [anon_sym_case] = ACTIONS(4632),
    [anon_sym_of] = ACTIONS(4632),
    [anon_sym_DASH] = ACTIONS(4632),
    [anon_sym_DASH_GT] = ACTIONS(4634),
    [anon_sym_LBRACK] = ACTIONS(4634),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4634),
    [anon_sym_u27e7] = ACTIONS(4634),
    [anon_sym_u27e6] = ACTIONS(4634),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4634),
    [sym_float] = ACTIONS(4634),
    [sym_char] = ACTIONS(4634),
    [sym_string] = ACTIONS(4634),
    [sym__integer_literal] = ACTIONS(4632),
    [sym__binary_literal] = ACTIONS(4634),
    [sym__octal_literal] = ACTIONS(4634),
    [sym__hex_literal] = ACTIONS(4634),
    [anon_sym_BQUOTE] = ACTIONS(4634),
    [anon_sym_POUND] = ACTIONS(4632),
    [anon_sym_POUND2] = ACTIONS(4632),
    [sym_implicit_variable] = ACTIONS(4634),
    [sym_name] = ACTIONS(4634),
    [sym_label] = ACTIONS(4634),
    [anon_sym_u2192] = ACTIONS(4634),
    [anon_sym_COLON_COLON] = ACTIONS(4634),
    [anon_sym_u2237] = ACTIONS(4634),
    [aux_sym__paren_open_token1] = ACTIONS(4634),
    [aux_sym__paren_close_token1] = ACTIONS(4634),
    [anon_sym_RBRACK] = ACTIONS(4634),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4634),
    [sym__cond_splice] = ACTIONS(4634),
    [sym__cond_qual_dot] = ACTIONS(4616),
    [sym__cond_tight_dot] = ACTIONS(321),
    [sym__cond_prefix_dot] = ACTIONS(4634),
    [sym__cond_prefix_at] = ACTIONS(4634),
    [sym__cond_qualified_op] = ACTIONS(4634),
    [sym__cond_no_section_op] = ACTIONS(4634),
    [sym__cond_minus] = ACTIONS(4634),
    [sym__varsym] = ACTIONS(4634),
    [sym__consym] = ACTIONS(4634),
  },
  [2376] = {
    [sym__fun_arrow] = STATE(1677),
    [sym_modifier] = STATE(9901),
    [sym__linear_fun_arrow] = STATE(1676),
    [sym__arrow] = STATE(7944),
    [sym__linear_arrow] = STATE(7941),
    [sym__prefix_percent] = STATE(2611),
    [sym_variable] = ACTIONS(4594),
    [anon_sym_SEMI] = ACTIONS(4596),
    [anon_sym_let] = ACTIONS(4594),
    [anon_sym_LBRACE] = ACTIONS(4596),
    [anon_sym_SQUOTE] = ACTIONS(4594),
    [anon_sym_STAR] = ACTIONS(4596),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4596),
    [anon_sym_PIPE] = ACTIONS(4596),
    [anon_sym_BSLASH] = ACTIONS(4596),
    [anon_sym_if] = ACTIONS(4594),
    [anon_sym_mdo] = ACTIONS(4594),
    [anon_sym_do] = ACTIONS(4594),
    [anon_sym_case] = ACTIONS(4594),
    [anon_sym_DASH] = ACTIONS(4594),
    [anon_sym_DASH_GT] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4596),
    [anon_sym_u27e6] = ACTIONS(4596),
    [sym_float] = ACTIONS(4596),
    [sym_char] = ACTIONS(4596),
    [sym_string] = ACTIONS(4596),
    [sym__integer_literal] = ACTIONS(4594),
    [sym__binary_literal] = ACTIONS(4596),
    [sym__octal_literal] = ACTIONS(4596),
    [sym__hex_literal] = ACTIONS(4596),
    [anon_sym_BQUOTE] = ACTIONS(4596),
    [anon_sym_POUND] = ACTIONS(4594),
    [anon_sym_POUND2] = ACTIONS(4594),
    [sym_implicit_variable] = ACTIONS(4596),
    [sym_name] = ACTIONS(4596),
    [sym_label] = ACTIONS(4596),
    [anon_sym_u2192] = ACTIONS(4570),
    [anon_sym_DASH_GT_DOT] = ACTIONS(4572),
    [anon_sym_u22b8] = ACTIONS(4572),
    [anon_sym_COLON_COLON] = ACTIONS(4596),
    [anon_sym_u2237] = ACTIONS(4596),
    [aux_sym__paren_open_token1] = ACTIONS(4596),
    [anon_sym_where] = ACTIONS(4594),
    [aux_sym__token1] = ACTIONS(3),
    [sym__cond_layout_semicolon] = ACTIONS(4596),
    [sym__cond_layout_end] = ACTIONS(4596),
    [sym__cond_layout_end_explicit] = ACTIONS(4596),
    [sym__phantom_where] = ACTIONS(4596),
    [sym__phantom_arrow] = ACTIONS(4574),
    [sym__phantom_bar] = ACTIONS(4596),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4596),
    [sym__cond_splice] = ACTIONS(4596),
    [sym__cond_tight_dot] = ACTIONS(4596),
    [sym__cond_prefix_dot] = ACTIONS(4596),
    [sym__cond_prefix_at] = ACTIONS(4596),
    [sym__cond_prefix_percent] = ACTIONS(4576),
    [sym__cond_qualified_op] = ACTIONS(4596),
    [sym__cond_no_section_op] = ACTIONS(4596),
    [sym__cond_minus] = ACTIONS(4596),
    [sym__varsym] = ACTIONS(4596),
    [sym__consym] = ACTIONS(4596),
  },
  [2377] = {
    [sym__qual_dot] = STATE(8574),
    [sym__tight_dot] = STATE(8574),
    [sym_variable] = ACTIONS(4624),
    [anon_sym_SEMI] = ACTIONS(4626),
    [anon_sym_let] = ACTIONS(4624),
    [anon_sym_COMMA] = ACTIONS(4626),
    [anon_sym_LBRACE] = ACTIONS(4626),
    [anon_sym_RBRACE] = ACTIONS(4626),
    [anon_sym__] = ACTIONS(4624),
    [anon_sym_SQUOTE] = ACTIONS(4624),
    [anon_sym_STAR] = ACTIONS(4626),
    [anon_sym_u2605] = ACTIONS(4626),
    [anon_sym_EQ] = ACTIONS(4626),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4626),
    [anon_sym_then] = ACTIONS(4624),
    [anon_sym_using] = ACTIONS(4624),
    [anon_sym_BSLASH] = ACTIONS(4626),
    [anon_sym_if] = ACTIONS(4624),
    [anon_sym_else] = ACTIONS(4624),
    [anon_sym_mdo] = ACTIONS(4624),
    [anon_sym_do] = ACTIONS(4624),
    [anon_sym_case] = ACTIONS(4624),
    [anon_sym_of] = ACTIONS(4624),
    [anon_sym_DASH] = ACTIONS(4624),
    [anon_sym_DASH_GT] = ACTIONS(4626),
    [anon_sym_LBRACK] = ACTIONS(4626),
    [anon_sym_PIPE_RBRACK] = ACTIONS(4626),
    [anon_sym_u27e7] = ACTIONS(4626),
    [anon_sym_u27e6] = ACTIONS(4626),
    [anon_sym_PIPE_PIPE_RBRACK] = ACTIONS(4626),
    [sym_float] = ACTIONS(4626),
    [sym_char] = ACTIONS(4626),
    [sym_string] = ACTIONS(4626),
    [sym__integer_literal] = ACTIONS(4624),
    [sym__binary_literal] = ACTIONS(4626),
    [sym__octal_literal] = ACTIONS(4626),
    [sym__hex_literal] = ACTIONS(4626),
    [anon_sym_BQUOTE] = ACTIONS(4626),
    [anon_sym_POUND] = ACTIONS(4624),
    [anon_sym_POUND2] = ACTIONS(4624),
    [sym_implicit_variable] = ACTIONS(4626),
    [sym_name] = ACTIONS(4626),
    [sym_label] = ACTIONS(4626),
    [anon_sym_u2192] = ACTIONS(4626),
    [anon_sym_COLON_COLON] = ACTIONS(4626),
    [anon_sym_u2237] = ACTIONS(4626),
    [aux_sym__paren_open_token1] = ACTIONS(4626),
    [aux_sym__paren_close_token1] = ACTIONS(4626),
    [anon_sym_RBRACK] = ACTIONS(4626),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_haddock] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_pragma] = ACTIONS(3),
    [sym__cond_quote_start] = ACTIONS(4626),
    [sym__cond_splice] = ACTIONS(4626),
    [sym__cond_qual_dot] = ACTIONS(4608),
    [sym__cond_tight_dot] = ACTIONS(4610),
    [sym__cond_prefix_dot] = ACTIONS(4626),
    [sym__cond_prefix_at] = ACTIONS(4626),
    [sym__cond_qualified_op] = ACTIONS(4626),
    [sym__cond_no_section_op] = ACTIONS(4626),
    [sym__cond_minus] = ACTIONS(4626),
    [sym__varsym] = ACTIONS(4626),
    [sym__consym] = ACTIONS(4626),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [77] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [154] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4630), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [231] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4863), 16,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4865), 43,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [302] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [379] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4863), 16,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4865), 43,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [450] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [527] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [604] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4867), 16,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4869), 43,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [675] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4871), 16,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4873), 43,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [746] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [823] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [900] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4875), 16,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4877), 43,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [971] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(1125), 16,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(1123), 43,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [1042] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [1119] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2607), 1,
      sym_variable,
    ACTIONS(2609), 1,
      anon_sym__,
    ACTIONS(2619), 1,
      sym__integer_literal,
    ACTIONS(2625), 1,
      sym__cond_quote_start,
    ACTIONS(3455), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      sym_name,
    STATE(472), 1,
      sym__paren_open,
    STATE(789), 1,
      sym__unboxed_open,
    STATE(842), 1,
      sym_type,
    STATE(1078), 1,
      sym__bracket_open,
    STATE(6710), 1,
      sym_integer,
    STATE(6756), 1,
      sym__qualified_type,
    STATE(6784), 1,
      sym__type_parens,
    STATE(6785), 1,
      sym__type_tuple,
    STATE(6786), 1,
      sym__type_unboxed_tuple,
    STATE(6787), 1,
      sym__type_unboxed_sum,
    STATE(6789), 1,
      sym__type_list,
    STATE(6790), 1,
      sym__type_apply,
    STATE(6791), 1,
      sym__type_infix,
    STATE(6792), 1,
      sym__plist,
    STATE(7457), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11189), 1,
      aux_sym__qualifying_module,
    ACTIONS(2615), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2617), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2621), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6793), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6781), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [1247] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1823), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(7618), 1,
      sym__type_infix,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [1375] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1021), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1767), 1,
      sym_variable,
    ACTIONS(1769), 1,
      anon_sym__,
    ACTIONS(1779), 1,
      sym__cond_quote_start,
    ACTIONS(4879), 1,
      anon_sym_SQUOTE,
    ACTIONS(4881), 1,
      sym_name,
    STATE(440), 1,
      sym__paren_open,
    STATE(559), 1,
      sym_type,
    STATE(804), 1,
      sym__unboxed_open,
    STATE(1037), 1,
      sym__bracket_open,
    STATE(4588), 1,
      sym__type_unboxed_tuple,
    STATE(4653), 1,
      sym__type_parens,
    STATE(4654), 1,
      sym__type_tuple,
    STATE(4657), 1,
      sym__type_unboxed_sum,
    STATE(4667), 1,
      sym__type_list,
    STATE(4669), 1,
      sym__type_apply,
    STATE(4672), 1,
      sym__type_infix,
    STATE(4673), 1,
      sym__plist,
    STATE(4690), 1,
      sym_integer,
    STATE(4841), 1,
      sym__qualified_type,
    STATE(7386), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11282), 1,
      aux_sym__qualifying_module,
    ACTIONS(1775), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1019), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1023), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4674), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4652), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [1503] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1907), 1,
      sym_variable,
    ACTIONS(1909), 1,
      anon_sym__,
    ACTIONS(1919), 1,
      sym__integer_literal,
    ACTIONS(1925), 1,
      sym__cond_quote_start,
    ACTIONS(4883), 1,
      anon_sym_SQUOTE,
    ACTIONS(4885), 1,
      sym_name,
    STATE(475), 1,
      sym__paren_open,
    STATE(665), 1,
      sym_type,
    STATE(788), 1,
      sym__unboxed_open,
    STATE(1067), 1,
      sym__bracket_open,
    STATE(5902), 1,
      sym_integer,
    STATE(5944), 1,
      sym__type_parens,
    STATE(5945), 1,
      sym__type_tuple,
    STATE(5946), 1,
      sym__type_unboxed_tuple,
    STATE(5947), 1,
      sym__type_unboxed_sum,
    STATE(5948), 1,
      sym__type_list,
    STATE(5949), 1,
      sym__type_apply,
    STATE(5950), 1,
      sym__type_infix,
    STATE(5951), 1,
      sym__plist,
    STATE(5976), 1,
      sym__qualified_type,
    STATE(7347), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11157), 1,
      aux_sym__qualifying_module,
    ACTIONS(1915), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1917), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1921), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5952), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5942), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [1631] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1669), 1,
      sym_variable,
    ACTIONS(1671), 1,
      anon_sym__,
    ACTIONS(1681), 1,
      sym__integer_literal,
    ACTIONS(1687), 1,
      sym__cond_quote_start,
    ACTIONS(3419), 1,
      anon_sym_SQUOTE,
    ACTIONS(3423), 1,
      sym_name,
    STATE(461), 1,
      sym__paren_open,
    STATE(510), 1,
      sym_type,
    STATE(829), 1,
      sym__unboxed_open,
    STATE(1131), 1,
      sym__bracket_open,
    STATE(3509), 1,
      sym_integer,
    STATE(3557), 1,
      sym__type_parens,
    STATE(3597), 1,
      sym__plist,
    STATE(3602), 1,
      sym__type_infix,
    STATE(3604), 1,
      sym__type_apply,
    STATE(3605), 1,
      sym__type_list,
    STATE(3606), 1,
      sym__type_unboxed_sum,
    STATE(3607), 1,
      sym__type_unboxed_tuple,
    STATE(3612), 1,
      sym__type_tuple,
    STATE(3643), 1,
      sym__qualified_type,
    STATE(7350), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11140), 1,
      aux_sym__qualifying_module,
    ACTIONS(1677), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1679), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1683), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3583), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3638), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [1759] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1867), 1,
      sym_variable,
    ACTIONS(1869), 1,
      anon_sym__,
    ACTIONS(1879), 1,
      sym__integer_literal,
    ACTIONS(1885), 1,
      sym__cond_quote_start,
    ACTIONS(3349), 1,
      anon_sym_SQUOTE,
    ACTIONS(3353), 1,
      sym_name,
    STATE(468), 1,
      sym__paren_open,
    STATE(664), 1,
      sym_type,
    STATE(795), 1,
      sym__unboxed_open,
    STATE(986), 1,
      sym__bracket_open,
    STATE(5906), 1,
      sym__qualified_type,
    STATE(5925), 1,
      sym_integer,
    STATE(5999), 1,
      sym__type_parens,
    STATE(6002), 1,
      sym__type_tuple,
    STATE(6004), 1,
      sym__type_unboxed_tuple,
    STATE(6006), 1,
      sym__type_unboxed_sum,
    STATE(6007), 1,
      sym__type_list,
    STATE(6008), 1,
      sym__type_apply,
    STATE(6009), 1,
      sym__type_infix,
    STATE(6010), 1,
      sym__plist,
    STATE(7346), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11325), 1,
      aux_sym__qualifying_module,
    ACTIONS(1875), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1877), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1881), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6014), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5993), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [1887] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1827), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(7495), 1,
      sym__type_infix,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [2015] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1823), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(7620), 1,
      sym__type_infix,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [2143] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1323), 1,
      sym_variable,
    ACTIONS(1325), 1,
      anon_sym__,
    ACTIONS(1335), 1,
      sym__integer_literal,
    ACTIONS(1341), 1,
      sym__cond_quote_start,
    ACTIONS(3461), 1,
      anon_sym_SQUOTE,
    ACTIONS(3465), 1,
      sym_name,
    STATE(418), 1,
      sym_type,
    STATE(467), 1,
      sym__paren_open,
    STATE(765), 1,
      sym__unboxed_open,
    STATE(1130), 1,
      sym__bracket_open,
    STATE(2759), 1,
      sym__qualified_type,
    STATE(2767), 1,
      sym__type_unboxed_sum,
    STATE(2774), 1,
      sym__type_infix,
    STATE(2777), 1,
      sym__plist,
    STATE(2781), 1,
      sym_integer,
    STATE(2788), 1,
      sym__type_unboxed_tuple,
    STATE(2808), 1,
      sym__type_tuple,
    STATE(2823), 1,
      sym__type_apply,
    STATE(2825), 1,
      sym__type_parens,
    STATE(2839), 1,
      sym__type_list,
    STATE(7328), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11145), 1,
      aux_sym__qualifying_module,
    ACTIONS(1331), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1333), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1337), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(2752), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(2796), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [2271] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1323), 1,
      sym_variable,
    ACTIONS(1325), 1,
      anon_sym__,
    ACTIONS(1335), 1,
      sym__integer_literal,
    ACTIONS(1341), 1,
      sym__cond_quote_start,
    ACTIONS(3461), 1,
      anon_sym_SQUOTE,
    ACTIONS(3465), 1,
      sym_name,
    STATE(419), 1,
      sym_type,
    STATE(467), 1,
      sym__paren_open,
    STATE(765), 1,
      sym__unboxed_open,
    STATE(1130), 1,
      sym__bracket_open,
    STATE(2759), 1,
      sym__qualified_type,
    STATE(2767), 1,
      sym__type_unboxed_sum,
    STATE(2774), 1,
      sym__type_infix,
    STATE(2777), 1,
      sym__plist,
    STATE(2781), 1,
      sym_integer,
    STATE(2788), 1,
      sym__type_unboxed_tuple,
    STATE(2808), 1,
      sym__type_tuple,
    STATE(2823), 1,
      sym__type_apply,
    STATE(2825), 1,
      sym__type_parens,
    STATE(2839), 1,
      sym__type_list,
    STATE(7328), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11145), 1,
      aux_sym__qualifying_module,
    ACTIONS(1331), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1333), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1337), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(2752), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(2796), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [2399] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1323), 1,
      sym_variable,
    ACTIONS(1325), 1,
      anon_sym__,
    ACTIONS(1335), 1,
      sym__integer_literal,
    ACTIONS(1341), 1,
      sym__cond_quote_start,
    ACTIONS(3461), 1,
      anon_sym_SQUOTE,
    ACTIONS(3465), 1,
      sym_name,
    STATE(422), 1,
      sym_type,
    STATE(467), 1,
      sym__paren_open,
    STATE(765), 1,
      sym__unboxed_open,
    STATE(1130), 1,
      sym__bracket_open,
    STATE(2759), 1,
      sym__qualified_type,
    STATE(2767), 1,
      sym__type_unboxed_sum,
    STATE(2774), 1,
      sym__type_infix,
    STATE(2777), 1,
      sym__plist,
    STATE(2781), 1,
      sym_integer,
    STATE(2788), 1,
      sym__type_unboxed_tuple,
    STATE(2808), 1,
      sym__type_tuple,
    STATE(2823), 1,
      sym__type_apply,
    STATE(2825), 1,
      sym__type_parens,
    STATE(2839), 1,
      sym__type_list,
    STATE(7328), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11145), 1,
      aux_sym__qualifying_module,
    ACTIONS(1331), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1333), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1337), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(2752), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(2796), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [2527] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1045), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1781), 1,
      anon_sym__,
    ACTIONS(1785), 1,
      sym_variable,
    ACTIONS(1793), 1,
      sym__cond_quote_start,
    ACTIONS(4887), 1,
      anon_sym_SQUOTE,
    ACTIONS(4889), 1,
      sym_name,
    STATE(433), 1,
      sym__paren_open,
    STATE(573), 1,
      sym_type,
    STATE(820), 1,
      sym__unboxed_open,
    STATE(998), 1,
      sym__bracket_open,
    STATE(4318), 1,
      sym__type_parens,
    STATE(4319), 1,
      sym__type_tuple,
    STATE(4324), 1,
      sym__type_unboxed_tuple,
    STATE(4325), 1,
      sym__type_unboxed_sum,
    STATE(4326), 1,
      sym__type_list,
    STATE(4327), 1,
      sym__type_apply,
    STATE(4328), 1,
      sym__type_infix,
    STATE(4329), 1,
      sym__plist,
    STATE(4366), 1,
      sym_integer,
    STATE(4389), 1,
      sym__qualified_type,
    STATE(7227), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10933), 1,
      aux_sym__qualifying_module,
    ACTIONS(1783), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1043), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1047), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4330), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4317), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [2655] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1045), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1781), 1,
      anon_sym__,
    ACTIONS(1785), 1,
      sym_variable,
    ACTIONS(1793), 1,
      sym__cond_quote_start,
    ACTIONS(4887), 1,
      anon_sym_SQUOTE,
    ACTIONS(4889), 1,
      sym_name,
    STATE(433), 1,
      sym__paren_open,
    STATE(569), 1,
      sym_type,
    STATE(820), 1,
      sym__unboxed_open,
    STATE(998), 1,
      sym__bracket_open,
    STATE(4318), 1,
      sym__type_parens,
    STATE(4319), 1,
      sym__type_tuple,
    STATE(4324), 1,
      sym__type_unboxed_tuple,
    STATE(4325), 1,
      sym__type_unboxed_sum,
    STATE(4326), 1,
      sym__type_list,
    STATE(4327), 1,
      sym__type_apply,
    STATE(4328), 1,
      sym__type_infix,
    STATE(4329), 1,
      sym__plist,
    STATE(4366), 1,
      sym_integer,
    STATE(4389), 1,
      sym__qualified_type,
    STATE(7227), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10933), 1,
      aux_sym__qualifying_module,
    ACTIONS(1783), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1043), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1047), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4330), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4317), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [2783] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1045), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1781), 1,
      anon_sym__,
    ACTIONS(1785), 1,
      sym_variable,
    ACTIONS(1793), 1,
      sym__cond_quote_start,
    ACTIONS(4887), 1,
      anon_sym_SQUOTE,
    ACTIONS(4889), 1,
      sym_name,
    STATE(433), 1,
      sym__paren_open,
    STATE(556), 1,
      sym_type,
    STATE(820), 1,
      sym__unboxed_open,
    STATE(998), 1,
      sym__bracket_open,
    STATE(4318), 1,
      sym__type_parens,
    STATE(4319), 1,
      sym__type_tuple,
    STATE(4324), 1,
      sym__type_unboxed_tuple,
    STATE(4325), 1,
      sym__type_unboxed_sum,
    STATE(4326), 1,
      sym__type_list,
    STATE(4327), 1,
      sym__type_apply,
    STATE(4328), 1,
      sym__type_infix,
    STATE(4329), 1,
      sym__plist,
    STATE(4366), 1,
      sym_integer,
    STATE(4389), 1,
      sym__qualified_type,
    STATE(7227), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10933), 1,
      aux_sym__qualifying_module,
    ACTIONS(1783), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1043), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1047), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4330), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4317), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [2911] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1629), 1,
      sym_variable,
    ACTIONS(1631), 1,
      anon_sym__,
    ACTIONS(1641), 1,
      sym__integer_literal,
    ACTIONS(1647), 1,
      sym__cond_quote_start,
    ACTIONS(3305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3309), 1,
      sym_name,
    STATE(447), 1,
      sym__paren_open,
    STATE(494), 1,
      sym_type,
    STATE(743), 1,
      sym__unboxed_open,
    STATE(976), 1,
      sym__bracket_open,
    STATE(3185), 1,
      sym__plist,
    STATE(3189), 1,
      sym__type_infix,
    STATE(3195), 1,
      sym__type_apply,
    STATE(3198), 1,
      sym__type_list,
    STATE(3209), 1,
      sym__type_unboxed_sum,
    STATE(3214), 1,
      sym__type_unboxed_tuple,
    STATE(3215), 1,
      sym__type_tuple,
    STATE(3217), 1,
      sym__type_parens,
    STATE(3330), 1,
      sym_integer,
    STATE(3420), 1,
      sym__qualified_type,
    STATE(7385), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11305), 1,
      aux_sym__qualifying_module,
    ACTIONS(1637), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1639), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1643), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3183), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3219), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [3039] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1589), 1,
      sym_variable,
    ACTIONS(1591), 1,
      anon_sym__,
    ACTIONS(1601), 1,
      sym__integer_literal,
    ACTIONS(1607), 1,
      sym__cond_quote_start,
    ACTIONS(3467), 1,
      anon_sym_SQUOTE,
    ACTIONS(3471), 1,
      sym_name,
    STATE(458), 1,
      sym__paren_open,
    STATE(479), 1,
      sym_type,
    STATE(792), 1,
      sym__unboxed_open,
    STATE(1120), 1,
      sym__bracket_open,
    STATE(3249), 1,
      sym__qualified_type,
    STATE(3286), 1,
      sym_integer,
    STATE(3294), 1,
      sym__type_parens,
    STATE(3295), 1,
      sym__type_tuple,
    STATE(3296), 1,
      sym__type_unboxed_tuple,
    STATE(3298), 1,
      sym__type_unboxed_sum,
    STATE(3311), 1,
      sym__type_list,
    STATE(3313), 1,
      sym__type_apply,
    STATE(3314), 1,
      sym__type_infix,
    STATE(3318), 1,
      sym__plist,
    STATE(7231), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11151), 1,
      aux_sym__qualifying_module,
    ACTIONS(1597), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1599), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1603), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3320), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3292), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [3167] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1589), 1,
      sym_variable,
    ACTIONS(1591), 1,
      anon_sym__,
    ACTIONS(1601), 1,
      sym__integer_literal,
    ACTIONS(1607), 1,
      sym__cond_quote_start,
    ACTIONS(3467), 1,
      anon_sym_SQUOTE,
    ACTIONS(3471), 1,
      sym_name,
    STATE(458), 1,
      sym__paren_open,
    STATE(483), 1,
      sym_type,
    STATE(792), 1,
      sym__unboxed_open,
    STATE(1120), 1,
      sym__bracket_open,
    STATE(3249), 1,
      sym__qualified_type,
    STATE(3286), 1,
      sym_integer,
    STATE(3294), 1,
      sym__type_parens,
    STATE(3295), 1,
      sym__type_tuple,
    STATE(3296), 1,
      sym__type_unboxed_tuple,
    STATE(3298), 1,
      sym__type_unboxed_sum,
    STATE(3311), 1,
      sym__type_list,
    STATE(3313), 1,
      sym__type_apply,
    STATE(3314), 1,
      sym__type_infix,
    STATE(3318), 1,
      sym__plist,
    STATE(7231), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11151), 1,
      aux_sym__qualifying_module,
    ACTIONS(1597), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1599), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1603), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3320), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3292), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [3295] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1045), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1781), 1,
      anon_sym__,
    ACTIONS(1785), 1,
      sym_variable,
    ACTIONS(1793), 1,
      sym__cond_quote_start,
    ACTIONS(4887), 1,
      anon_sym_SQUOTE,
    ACTIONS(4889), 1,
      sym_name,
    STATE(433), 1,
      sym__paren_open,
    STATE(555), 1,
      sym_type,
    STATE(820), 1,
      sym__unboxed_open,
    STATE(998), 1,
      sym__bracket_open,
    STATE(4318), 1,
      sym__type_parens,
    STATE(4319), 1,
      sym__type_tuple,
    STATE(4324), 1,
      sym__type_unboxed_tuple,
    STATE(4325), 1,
      sym__type_unboxed_sum,
    STATE(4326), 1,
      sym__type_list,
    STATE(4327), 1,
      sym__type_apply,
    STATE(4328), 1,
      sym__type_infix,
    STATE(4329), 1,
      sym__plist,
    STATE(4366), 1,
      sym_integer,
    STATE(4389), 1,
      sym__qualified_type,
    STATE(7227), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10933), 1,
      aux_sym__qualifying_module,
    ACTIONS(1783), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1043), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1047), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4330), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4317), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [3423] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1813), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [3551] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1589), 1,
      sym_variable,
    ACTIONS(1591), 1,
      anon_sym__,
    ACTIONS(1601), 1,
      sym__integer_literal,
    ACTIONS(1607), 1,
      sym__cond_quote_start,
    ACTIONS(3467), 1,
      anon_sym_SQUOTE,
    ACTIONS(3471), 1,
      sym_name,
    STATE(458), 1,
      sym__paren_open,
    STATE(485), 1,
      sym_type,
    STATE(792), 1,
      sym__unboxed_open,
    STATE(1120), 1,
      sym__bracket_open,
    STATE(3249), 1,
      sym__qualified_type,
    STATE(3286), 1,
      sym_integer,
    STATE(3294), 1,
      sym__type_parens,
    STATE(3295), 1,
      sym__type_tuple,
    STATE(3296), 1,
      sym__type_unboxed_tuple,
    STATE(3298), 1,
      sym__type_unboxed_sum,
    STATE(3311), 1,
      sym__type_list,
    STATE(3313), 1,
      sym__type_apply,
    STATE(3314), 1,
      sym__type_infix,
    STATE(3318), 1,
      sym__plist,
    STATE(7231), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11151), 1,
      aux_sym__qualifying_module,
    ACTIONS(1597), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1599), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1603), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3320), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3292), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [3679] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1045), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1781), 1,
      anon_sym__,
    ACTIONS(1785), 1,
      sym_variable,
    ACTIONS(1793), 1,
      sym__cond_quote_start,
    ACTIONS(4887), 1,
      anon_sym_SQUOTE,
    ACTIONS(4889), 1,
      sym_name,
    STATE(433), 1,
      sym__paren_open,
    STATE(574), 1,
      sym_type,
    STATE(820), 1,
      sym__unboxed_open,
    STATE(998), 1,
      sym__bracket_open,
    STATE(4318), 1,
      sym__type_parens,
    STATE(4319), 1,
      sym__type_tuple,
    STATE(4324), 1,
      sym__type_unboxed_tuple,
    STATE(4325), 1,
      sym__type_unboxed_sum,
    STATE(4326), 1,
      sym__type_list,
    STATE(4327), 1,
      sym__type_apply,
    STATE(4328), 1,
      sym__type_infix,
    STATE(4329), 1,
      sym__plist,
    STATE(4366), 1,
      sym_integer,
    STATE(4389), 1,
      sym__qualified_type,
    STATE(7227), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10933), 1,
      aux_sym__qualifying_module,
    ACTIONS(1783), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1043), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1047), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4330), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4317), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [3807] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1975), 1,
      sym_variable,
    ACTIONS(1977), 1,
      anon_sym__,
    ACTIONS(1981), 1,
      sym__integer_literal,
    ACTIONS(1987), 1,
      sym__cond_quote_start,
    ACTIONS(4891), 1,
      anon_sym_SQUOTE,
    ACTIONS(4893), 1,
      sym_name,
    STATE(436), 1,
      sym__paren_open,
    STATE(730), 1,
      sym_type,
    STATE(752), 1,
      sym__unboxed_open,
    STATE(971), 1,
      sym__bracket_open,
    STATE(6083), 1,
      sym__qualified_type,
    STATE(6128), 1,
      sym_integer,
    STATE(6134), 1,
      sym__type_parens,
    STATE(6135), 1,
      sym__type_tuple,
    STATE(6136), 1,
      sym__type_unboxed_tuple,
    STATE(6137), 1,
      sym__type_unboxed_sum,
    STATE(6138), 1,
      sym__type_list,
    STATE(6139), 1,
      sym__type_apply,
    STATE(6140), 1,
      sym__type_infix,
    STATE(6141), 1,
      sym__plist,
    STATE(7279), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11268), 1,
      aux_sym__qualifying_module,
    ACTIONS(1973), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1979), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1983), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6142), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6132), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [3935] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1363), 1,
      sym_variable,
    ACTIONS(1367), 1,
      anon_sym__,
    ACTIONS(1369), 1,
      anon_sym_SQUOTE,
    ACTIONS(1385), 1,
      sym__integer_literal,
    ACTIONS(1397), 1,
      sym__cond_quote_start,
    ACTIONS(2595), 1,
      sym_name,
    STATE(456), 1,
      sym__paren_open,
    STATE(794), 1,
      sym__unboxed_open,
    STATE(944), 1,
      sym_type,
    STATE(964), 1,
      sym__bracket_open,
    STATE(3803), 1,
      sym__plist,
    STATE(3822), 1,
      sym__type_apply,
    STATE(3826), 1,
      sym__type_unboxed_sum,
    STATE(3843), 1,
      sym__type_unboxed_tuple,
    STATE(3846), 1,
      sym__type_tuple,
    STATE(3851), 1,
      sym__type_parens,
    STATE(3886), 1,
      sym_integer,
    STATE(3887), 1,
      sym__type_list,
    STATE(3888), 1,
      sym__type_infix,
    STATE(3898), 1,
      sym__qualified_type,
    STATE(7480), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11251), 1,
      aux_sym__qualifying_module,
    ACTIONS(1373), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1383), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1387), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3807), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3855), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [4063] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1363), 1,
      sym_variable,
    ACTIONS(1367), 1,
      anon_sym__,
    ACTIONS(1369), 1,
      anon_sym_SQUOTE,
    ACTIONS(1385), 1,
      sym__integer_literal,
    ACTIONS(1397), 1,
      sym__cond_quote_start,
    ACTIONS(2595), 1,
      sym_name,
    STATE(456), 1,
      sym__paren_open,
    STATE(794), 1,
      sym__unboxed_open,
    STATE(943), 1,
      sym_type,
    STATE(964), 1,
      sym__bracket_open,
    STATE(3803), 1,
      sym__plist,
    STATE(3822), 1,
      sym__type_apply,
    STATE(3826), 1,
      sym__type_unboxed_sum,
    STATE(3843), 1,
      sym__type_unboxed_tuple,
    STATE(3846), 1,
      sym__type_tuple,
    STATE(3851), 1,
      sym__type_parens,
    STATE(3886), 1,
      sym_integer,
    STATE(3887), 1,
      sym__type_list,
    STATE(3888), 1,
      sym__type_infix,
    STATE(3898), 1,
      sym__qualified_type,
    STATE(7480), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11251), 1,
      aux_sym__qualifying_module,
    ACTIONS(1373), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1383), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1387), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3807), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3855), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [4191] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2461), 1,
      sym_variable,
    ACTIONS(2463), 1,
      anon_sym__,
    ACTIONS(2469), 1,
      sym__integer_literal,
    ACTIONS(2475), 1,
      sym__cond_quote_start,
    ACTIONS(4895), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      sym_name,
    STATE(442), 1,
      sym__paren_open,
    STATE(739), 1,
      sym_type,
    STATE(762), 1,
      sym__unboxed_open,
    STATE(962), 1,
      sym__bracket_open,
    STATE(6231), 1,
      sym_integer,
    STATE(6337), 1,
      sym__type_tuple,
    STATE(6345), 1,
      sym__plist,
    STATE(6346), 1,
      sym__type_infix,
    STATE(6347), 1,
      sym__type_apply,
    STATE(6349), 1,
      sym__type_list,
    STATE(6350), 1,
      sym__type_unboxed_sum,
    STATE(6351), 1,
      sym__type_unboxed_tuple,
    STATE(6363), 1,
      sym__type_parens,
    STATE(6444), 1,
      sym__qualified_type,
    STATE(7313), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11194), 1,
      aux_sym__qualifying_module,
    ACTIONS(2063), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2467), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2471), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6341), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6364), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [4319] = 9,
    STATE(1485), 1,
      sym__linear_fun_arrow,
    STATE(1493), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4582), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4584), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [4401] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2693), 1,
      sym_variable,
    ACTIONS(2695), 1,
      anon_sym__,
    ACTIONS(2705), 1,
      sym__integer_literal,
    ACTIONS(2711), 1,
      sym__cond_quote_start,
    ACTIONS(3325), 1,
      anon_sym_SQUOTE,
    ACTIONS(3329), 1,
      sym_name,
    STATE(435), 1,
      sym__paren_open,
    STATE(744), 1,
      sym__unboxed_open,
    STATE(884), 1,
      sym_type,
    STATE(1104), 1,
      sym__bracket_open,
    STATE(6922), 1,
      sym__type_parens,
    STATE(6929), 1,
      sym__type_tuple,
    STATE(6932), 1,
      sym__type_unboxed_tuple,
    STATE(6934), 1,
      sym__type_unboxed_sum,
    STATE(6935), 1,
      sym__type_list,
    STATE(6936), 1,
      sym__type_apply,
    STATE(6937), 1,
      sym__type_infix,
    STATE(6939), 1,
      sym__plist,
    STATE(6980), 1,
      sym_integer,
    STATE(7018), 1,
      sym__qualified_type,
    STATE(7213), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11154), 1,
      aux_sym__qualifying_module,
    ACTIONS(2701), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2703), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2707), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6940), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6919), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [4529] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2693), 1,
      sym_variable,
    ACTIONS(2695), 1,
      anon_sym__,
    ACTIONS(2705), 1,
      sym__integer_literal,
    ACTIONS(2711), 1,
      sym__cond_quote_start,
    ACTIONS(3325), 1,
      anon_sym_SQUOTE,
    ACTIONS(3329), 1,
      sym_name,
    STATE(435), 1,
      sym__paren_open,
    STATE(744), 1,
      sym__unboxed_open,
    STATE(883), 1,
      sym_type,
    STATE(1104), 1,
      sym__bracket_open,
    STATE(6922), 1,
      sym__type_parens,
    STATE(6929), 1,
      sym__type_tuple,
    STATE(6932), 1,
      sym__type_unboxed_tuple,
    STATE(6934), 1,
      sym__type_unboxed_sum,
    STATE(6935), 1,
      sym__type_list,
    STATE(6936), 1,
      sym__type_apply,
    STATE(6937), 1,
      sym__type_infix,
    STATE(6939), 1,
      sym__plist,
    STATE(6980), 1,
      sym_integer,
    STATE(7018), 1,
      sym__qualified_type,
    STATE(7213), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11154), 1,
      aux_sym__qualifying_module,
    ACTIONS(2701), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2703), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2707), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6940), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6919), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [4657] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2693), 1,
      sym_variable,
    ACTIONS(2695), 1,
      anon_sym__,
    ACTIONS(2705), 1,
      sym__integer_literal,
    ACTIONS(2711), 1,
      sym__cond_quote_start,
    ACTIONS(3325), 1,
      anon_sym_SQUOTE,
    ACTIONS(3329), 1,
      sym_name,
    STATE(435), 1,
      sym__paren_open,
    STATE(744), 1,
      sym__unboxed_open,
    STATE(882), 1,
      sym_type,
    STATE(1104), 1,
      sym__bracket_open,
    STATE(6922), 1,
      sym__type_parens,
    STATE(6929), 1,
      sym__type_tuple,
    STATE(6932), 1,
      sym__type_unboxed_tuple,
    STATE(6934), 1,
      sym__type_unboxed_sum,
    STATE(6935), 1,
      sym__type_list,
    STATE(6936), 1,
      sym__type_apply,
    STATE(6937), 1,
      sym__type_infix,
    STATE(6939), 1,
      sym__plist,
    STATE(6980), 1,
      sym_integer,
    STATE(7018), 1,
      sym__qualified_type,
    STATE(7213), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11154), 1,
      aux_sym__qualifying_module,
    ACTIONS(2701), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2703), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2707), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6940), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6919), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [4785] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1021), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1767), 1,
      sym_variable,
    ACTIONS(1769), 1,
      anon_sym__,
    ACTIONS(1779), 1,
      sym__cond_quote_start,
    ACTIONS(4879), 1,
      anon_sym_SQUOTE,
    ACTIONS(4881), 1,
      sym_name,
    STATE(440), 1,
      sym__paren_open,
    STATE(571), 1,
      sym_type,
    STATE(804), 1,
      sym__unboxed_open,
    STATE(1037), 1,
      sym__bracket_open,
    STATE(4588), 1,
      sym__type_unboxed_tuple,
    STATE(4653), 1,
      sym__type_parens,
    STATE(4654), 1,
      sym__type_tuple,
    STATE(4657), 1,
      sym__type_unboxed_sum,
    STATE(4667), 1,
      sym__type_list,
    STATE(4669), 1,
      sym__type_apply,
    STATE(4672), 1,
      sym__type_infix,
    STATE(4673), 1,
      sym__plist,
    STATE(4690), 1,
      sym_integer,
    STATE(4841), 1,
      sym__qualified_type,
    STATE(7386), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11282), 1,
      aux_sym__qualifying_module,
    ACTIONS(1775), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1019), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1023), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4674), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4652), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [4913] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1767), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [5041] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1343), 1,
      sym_variable,
    ACTIONS(1345), 1,
      anon_sym__,
    ACTIONS(1355), 1,
      sym__integer_literal,
    ACTIONS(1361), 1,
      sym__cond_quote_start,
    ACTIONS(3333), 1,
      anon_sym_SQUOTE,
    ACTIONS(3337), 1,
      sym_name,
    STATE(426), 1,
      sym_type,
    STATE(441), 1,
      sym__paren_open,
    STATE(764), 1,
      sym__unboxed_open,
    STATE(1101), 1,
      sym__bracket_open,
    STATE(3082), 1,
      sym__plist,
    STATE(3083), 1,
      sym__qualified_type,
    STATE(3084), 1,
      sym__type_infix,
    STATE(3091), 1,
      sym__type_tuple,
    STATE(3092), 1,
      sym__type_unboxed_tuple,
    STATE(3095), 1,
      sym__type_unboxed_sum,
    STATE(3099), 1,
      sym__type_apply,
    STATE(3100), 1,
      sym__type_list,
    STATE(3111), 1,
      sym__type_parens,
    STATE(3118), 1,
      sym_integer,
    STATE(7411), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11161), 1,
      aux_sym__qualifying_module,
    ACTIONS(1351), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1353), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1357), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3071), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3123), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [5169] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1343), 1,
      sym_variable,
    ACTIONS(1345), 1,
      anon_sym__,
    ACTIONS(1355), 1,
      sym__integer_literal,
    ACTIONS(1361), 1,
      sym__cond_quote_start,
    ACTIONS(3333), 1,
      anon_sym_SQUOTE,
    ACTIONS(3337), 1,
      sym_name,
    STATE(427), 1,
      sym_type,
    STATE(441), 1,
      sym__paren_open,
    STATE(764), 1,
      sym__unboxed_open,
    STATE(1101), 1,
      sym__bracket_open,
    STATE(3082), 1,
      sym__plist,
    STATE(3083), 1,
      sym__qualified_type,
    STATE(3084), 1,
      sym__type_infix,
    STATE(3091), 1,
      sym__type_tuple,
    STATE(3092), 1,
      sym__type_unboxed_tuple,
    STATE(3095), 1,
      sym__type_unboxed_sum,
    STATE(3099), 1,
      sym__type_apply,
    STATE(3100), 1,
      sym__type_list,
    STATE(3111), 1,
      sym__type_parens,
    STATE(3118), 1,
      sym_integer,
    STATE(7411), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11161), 1,
      aux_sym__qualifying_module,
    ACTIONS(1351), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1353), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1357), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3071), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3123), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [5297] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1343), 1,
      sym_variable,
    ACTIONS(1345), 1,
      anon_sym__,
    ACTIONS(1355), 1,
      sym__integer_literal,
    ACTIONS(1361), 1,
      sym__cond_quote_start,
    ACTIONS(3333), 1,
      anon_sym_SQUOTE,
    ACTIONS(3337), 1,
      sym_name,
    STATE(423), 1,
      sym_type,
    STATE(441), 1,
      sym__paren_open,
    STATE(764), 1,
      sym__unboxed_open,
    STATE(1101), 1,
      sym__bracket_open,
    STATE(3082), 1,
      sym__plist,
    STATE(3083), 1,
      sym__qualified_type,
    STATE(3084), 1,
      sym__type_infix,
    STATE(3091), 1,
      sym__type_tuple,
    STATE(3092), 1,
      sym__type_unboxed_tuple,
    STATE(3095), 1,
      sym__type_unboxed_sum,
    STATE(3099), 1,
      sym__type_apply,
    STATE(3100), 1,
      sym__type_list,
    STATE(3111), 1,
      sym__type_parens,
    STATE(3118), 1,
      sym_integer,
    STATE(7411), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11161), 1,
      aux_sym__qualifying_module,
    ACTIONS(1351), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1353), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1357), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3071), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3123), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [5425] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2673), 1,
      sym_variable,
    ACTIONS(2675), 1,
      anon_sym__,
    ACTIONS(2685), 1,
      sym__integer_literal,
    ACTIONS(2691), 1,
      sym__cond_quote_start,
    ACTIONS(3339), 1,
      anon_sym_SQUOTE,
    ACTIONS(3343), 1,
      sym_name,
    STATE(430), 1,
      sym__paren_open,
    STATE(737), 1,
      sym__unboxed_open,
    STATE(887), 1,
      sym_type,
    STATE(1017), 1,
      sym__bracket_open,
    STATE(6883), 1,
      sym__type_tuple,
    STATE(6889), 1,
      sym__plist,
    STATE(6890), 1,
      sym__type_apply,
    STATE(6891), 1,
      sym__type_list,
    STATE(6892), 1,
      sym__type_unboxed_sum,
    STATE(6903), 1,
      sym__type_unboxed_tuple,
    STATE(6909), 1,
      sym__type_parens,
    STATE(6928), 1,
      sym_integer,
    STATE(6933), 1,
      sym__qualified_type,
    STATE(6959), 1,
      sym__type_infix,
    STATE(7211), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11277), 1,
      aux_sym__qualifying_module,
    ACTIONS(2681), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2683), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2687), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6884), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6911), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [5553] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2041), 1,
      sym_variable,
    ACTIONS(2043), 1,
      anon_sym__,
    ACTIONS(2053), 1,
      sym__integer_literal,
    ACTIONS(2059), 1,
      sym__cond_quote_start,
    ACTIONS(2649), 1,
      anon_sym_SQUOTE,
    ACTIONS(2653), 1,
      sym_name,
    STATE(437), 1,
      sym__paren_open,
    STATE(745), 1,
      sym_type,
    STATE(827), 1,
      sym__unboxed_open,
    STATE(982), 1,
      sym__bracket_open,
    STATE(6256), 1,
      sym__qualified_type,
    STATE(6424), 1,
      sym__plist,
    STATE(6425), 1,
      sym__type_apply,
    STATE(6430), 1,
      sym__type_list,
    STATE(6431), 1,
      sym__type_unboxed_sum,
    STATE(6432), 1,
      sym__type_unboxed_tuple,
    STATE(6435), 1,
      sym__type_tuple,
    STATE(6447), 1,
      sym__type_parens,
    STATE(6459), 1,
      sym__type_infix,
    STATE(6547), 1,
      sym_integer,
    STATE(7322), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11242), 1,
      aux_sym__qualifying_module,
    ACTIONS(2049), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2051), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2055), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6408), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6452), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [5681] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2673), 1,
      sym_variable,
    ACTIONS(2675), 1,
      anon_sym__,
    ACTIONS(2685), 1,
      sym__integer_literal,
    ACTIONS(2691), 1,
      sym__cond_quote_start,
    ACTIONS(3339), 1,
      anon_sym_SQUOTE,
    ACTIONS(3343), 1,
      sym_name,
    STATE(430), 1,
      sym__paren_open,
    STATE(737), 1,
      sym__unboxed_open,
    STATE(911), 1,
      sym_type,
    STATE(1017), 1,
      sym__bracket_open,
    STATE(6883), 1,
      sym__type_tuple,
    STATE(6889), 1,
      sym__plist,
    STATE(6890), 1,
      sym__type_apply,
    STATE(6891), 1,
      sym__type_list,
    STATE(6892), 1,
      sym__type_unboxed_sum,
    STATE(6903), 1,
      sym__type_unboxed_tuple,
    STATE(6909), 1,
      sym__type_parens,
    STATE(6928), 1,
      sym_integer,
    STATE(6933), 1,
      sym__qualified_type,
    STATE(6959), 1,
      sym__type_infix,
    STATE(7211), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11277), 1,
      aux_sym__qualifying_module,
    ACTIONS(2681), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2683), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2687), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6884), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6911), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [5809] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2627), 1,
      sym_variable,
    ACTIONS(2629), 1,
      anon_sym__,
    ACTIONS(2639), 1,
      sym__integer_literal,
    ACTIONS(2645), 1,
      sym__cond_quote_start,
    ACTIONS(3311), 1,
      anon_sym_SQUOTE,
    ACTIONS(3315), 1,
      sym_name,
    STATE(438), 1,
      sym__paren_open,
    STATE(757), 1,
      sym__unboxed_open,
    STATE(844), 1,
      sym_type,
    STATE(966), 1,
      sym__bracket_open,
    STATE(6698), 1,
      sym__type_apply,
    STATE(6754), 1,
      sym_integer,
    STATE(6766), 1,
      sym__type_parens,
    STATE(6767), 1,
      sym__type_tuple,
    STATE(6768), 1,
      sym__type_unboxed_tuple,
    STATE(6769), 1,
      sym__type_unboxed_sum,
    STATE(6770), 1,
      sym__type_list,
    STATE(6780), 1,
      sym__type_infix,
    STATE(6782), 1,
      sym__plist,
    STATE(6803), 1,
      sym__qualified_type,
    STATE(7306), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11231), 1,
      aux_sym__qualifying_module,
    ACTIONS(2635), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2637), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2641), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6783), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6765), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [5937] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2673), 1,
      sym_variable,
    ACTIONS(2675), 1,
      anon_sym__,
    ACTIONS(2685), 1,
      sym__integer_literal,
    ACTIONS(2691), 1,
      sym__cond_quote_start,
    ACTIONS(3339), 1,
      anon_sym_SQUOTE,
    ACTIONS(3343), 1,
      sym_name,
    STATE(430), 1,
      sym__paren_open,
    STATE(737), 1,
      sym__unboxed_open,
    STATE(914), 1,
      sym_type,
    STATE(1017), 1,
      sym__bracket_open,
    STATE(6883), 1,
      sym__type_tuple,
    STATE(6889), 1,
      sym__plist,
    STATE(6890), 1,
      sym__type_apply,
    STATE(6891), 1,
      sym__type_list,
    STATE(6892), 1,
      sym__type_unboxed_sum,
    STATE(6903), 1,
      sym__type_unboxed_tuple,
    STATE(6909), 1,
      sym__type_parens,
    STATE(6928), 1,
      sym_integer,
    STATE(6933), 1,
      sym__qualified_type,
    STATE(6959), 1,
      sym__type_infix,
    STATE(7211), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11277), 1,
      aux_sym__qualifying_module,
    ACTIONS(2681), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2683), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2687), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6884), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6911), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [6065] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(991), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1795), 1,
      sym_variable,
    ACTIONS(1797), 1,
      anon_sym__,
    ACTIONS(1807), 1,
      sym__cond_quote_start,
    ACTIONS(4899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4901), 1,
      sym_name,
    STATE(443), 1,
      sym__paren_open,
    STATE(561), 1,
      sym_type,
    STATE(784), 1,
      sym__unboxed_open,
    STATE(1042), 1,
      sym__bracket_open,
    STATE(4322), 1,
      sym__qualified_type,
    STATE(4374), 1,
      sym__type_parens,
    STATE(4375), 1,
      sym__type_tuple,
    STATE(4376), 1,
      sym__type_unboxed_tuple,
    STATE(4377), 1,
      sym__type_unboxed_sum,
    STATE(4379), 1,
      sym__type_list,
    STATE(4380), 1,
      sym__type_apply,
    STATE(4381), 1,
      sym__type_infix,
    STATE(4382), 1,
      sym__plist,
    STATE(4597), 1,
      sym_integer,
    STATE(7263), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11266), 1,
      aux_sym__qualifying_module,
    ACTIONS(1803), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(989), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(993), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4383), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4373), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [6193] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(909), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1753), 1,
      anon_sym__,
    ACTIONS(1757), 1,
      sym_variable,
    ACTIONS(1765), 1,
      sym__cond_quote_start,
    ACTIONS(4903), 1,
      anon_sym_SQUOTE,
    ACTIONS(4905), 1,
      sym_name,
    STATE(471), 1,
      sym__paren_open,
    STATE(547), 1,
      sym_type,
    STATE(778), 1,
      sym__unboxed_open,
    STATE(1071), 1,
      sym__bracket_open,
    STATE(4235), 1,
      sym__plist,
    STATE(4241), 1,
      sym__type_infix,
    STATE(4248), 1,
      sym__qualified_type,
    STATE(4258), 1,
      sym__type_parens,
    STATE(4261), 1,
      sym__type_tuple,
    STATE(4262), 1,
      sym__type_unboxed_tuple,
    STATE(4263), 1,
      sym__type_unboxed_sum,
    STATE(4264), 1,
      sym__type_list,
    STATE(4265), 1,
      sym__type_apply,
    STATE(4282), 1,
      sym_integer,
    STATE(7317), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11227), 1,
      aux_sym__qualifying_module,
    ACTIONS(1755), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(907), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(911), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4275), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4257), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [6321] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2757), 1,
      sym_variable,
    ACTIONS(2761), 1,
      anon_sym__,
    ACTIONS(2773), 1,
      sym__integer_literal,
    ACTIONS(2779), 1,
      sym__cond_quote_start,
    ACTIONS(4342), 1,
      anon_sym_SQUOTE,
    ACTIONS(4344), 1,
      sym_name,
    STATE(450), 1,
      sym__paren_open,
    STATE(831), 1,
      sym__unboxed_open,
    STATE(940), 1,
      sym_type,
    STATE(1027), 1,
      sym__bracket_open,
    STATE(7036), 1,
      sym_integer,
    STATE(7079), 1,
      sym__qualified_type,
    STATE(7142), 1,
      sym__type_parens,
    STATE(7143), 1,
      sym__type_tuple,
    STATE(7144), 1,
      sym__type_unboxed_tuple,
    STATE(7145), 1,
      sym__type_unboxed_sum,
    STATE(7146), 1,
      sym__type_list,
    STATE(7147), 1,
      sym__type_apply,
    STATE(7148), 1,
      sym__type_infix,
    STATE(7149), 1,
      sym__plist,
    STATE(7440), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11165), 1,
      aux_sym__qualifying_module,
    ACTIONS(2767), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2771), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2775), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7150), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7140), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [6449] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2757), 1,
      sym_variable,
    ACTIONS(2761), 1,
      anon_sym__,
    ACTIONS(2773), 1,
      sym__integer_literal,
    ACTIONS(2779), 1,
      sym__cond_quote_start,
    ACTIONS(4342), 1,
      anon_sym_SQUOTE,
    ACTIONS(4344), 1,
      sym_name,
    STATE(450), 1,
      sym__paren_open,
    STATE(831), 1,
      sym__unboxed_open,
    STATE(942), 1,
      sym_type,
    STATE(1027), 1,
      sym__bracket_open,
    STATE(7036), 1,
      sym_integer,
    STATE(7079), 1,
      sym__qualified_type,
    STATE(7142), 1,
      sym__type_parens,
    STATE(7143), 1,
      sym__type_tuple,
    STATE(7144), 1,
      sym__type_unboxed_tuple,
    STATE(7145), 1,
      sym__type_unboxed_sum,
    STATE(7146), 1,
      sym__type_list,
    STATE(7147), 1,
      sym__type_apply,
    STATE(7148), 1,
      sym__type_infix,
    STATE(7149), 1,
      sym__plist,
    STATE(7440), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11165), 1,
      aux_sym__qualifying_module,
    ACTIONS(2767), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2771), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2775), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7150), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7140), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [6577] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2757), 1,
      sym_variable,
    ACTIONS(2761), 1,
      anon_sym__,
    ACTIONS(2773), 1,
      sym__integer_literal,
    ACTIONS(2779), 1,
      sym__cond_quote_start,
    ACTIONS(4342), 1,
      anon_sym_SQUOTE,
    ACTIONS(4344), 1,
      sym_name,
    STATE(450), 1,
      sym__paren_open,
    STATE(831), 1,
      sym__unboxed_open,
    STATE(950), 1,
      sym_type,
    STATE(1027), 1,
      sym__bracket_open,
    STATE(7036), 1,
      sym_integer,
    STATE(7079), 1,
      sym__qualified_type,
    STATE(7142), 1,
      sym__type_parens,
    STATE(7143), 1,
      sym__type_tuple,
    STATE(7144), 1,
      sym__type_unboxed_tuple,
    STATE(7145), 1,
      sym__type_unboxed_sum,
    STATE(7146), 1,
      sym__type_list,
    STATE(7147), 1,
      sym__type_apply,
    STATE(7148), 1,
      sym__type_infix,
    STATE(7149), 1,
      sym__plist,
    STATE(7440), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11165), 1,
      aux_sym__qualifying_module,
    ACTIONS(2767), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2771), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2775), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7150), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7140), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [6705] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2461), 1,
      sym_variable,
    ACTIONS(2463), 1,
      anon_sym__,
    ACTIONS(2469), 1,
      sym__integer_literal,
    ACTIONS(2475), 1,
      sym__cond_quote_start,
    ACTIONS(4895), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      sym_name,
    STATE(442), 1,
      sym__paren_open,
    STATE(762), 1,
      sym__unboxed_open,
    STATE(777), 1,
      sym_type,
    STATE(962), 1,
      sym__bracket_open,
    STATE(6231), 1,
      sym_integer,
    STATE(6337), 1,
      sym__type_tuple,
    STATE(6345), 1,
      sym__plist,
    STATE(6346), 1,
      sym__type_infix,
    STATE(6347), 1,
      sym__type_apply,
    STATE(6349), 1,
      sym__type_list,
    STATE(6350), 1,
      sym__type_unboxed_sum,
    STATE(6351), 1,
      sym__type_unboxed_tuple,
    STATE(6363), 1,
      sym__type_parens,
    STATE(6444), 1,
      sym__qualified_type,
    STATE(7313), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11194), 1,
      aux_sym__qualifying_module,
    ACTIONS(2063), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2467), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2471), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6341), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6364), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [6833] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1363), 1,
      sym_variable,
    ACTIONS(1367), 1,
      anon_sym__,
    ACTIONS(1369), 1,
      anon_sym_SQUOTE,
    ACTIONS(1385), 1,
      sym__integer_literal,
    ACTIONS(1397), 1,
      sym__cond_quote_start,
    ACTIONS(2595), 1,
      sym_name,
    STATE(456), 1,
      sym__paren_open,
    STATE(521), 1,
      sym_type,
    STATE(794), 1,
      sym__unboxed_open,
    STATE(964), 1,
      sym__bracket_open,
    STATE(3803), 1,
      sym__plist,
    STATE(3822), 1,
      sym__type_apply,
    STATE(3826), 1,
      sym__type_unboxed_sum,
    STATE(3843), 1,
      sym__type_unboxed_tuple,
    STATE(3846), 1,
      sym__type_tuple,
    STATE(3851), 1,
      sym__type_parens,
    STATE(3886), 1,
      sym_integer,
    STATE(3887), 1,
      sym__type_list,
    STATE(3888), 1,
      sym__type_infix,
    STATE(3898), 1,
      sym__qualified_type,
    STATE(7480), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11251), 1,
      aux_sym__qualifying_module,
    ACTIONS(1373), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1383), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1387), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3807), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3855), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [6961] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1363), 1,
      sym_variable,
    ACTIONS(1367), 1,
      anon_sym__,
    ACTIONS(1369), 1,
      anon_sym_SQUOTE,
    ACTIONS(1385), 1,
      sym__integer_literal,
    ACTIONS(1397), 1,
      sym__cond_quote_start,
    ACTIONS(2595), 1,
      sym_name,
    STATE(456), 1,
      sym__paren_open,
    STATE(524), 1,
      sym_type,
    STATE(794), 1,
      sym__unboxed_open,
    STATE(964), 1,
      sym__bracket_open,
    STATE(3803), 1,
      sym__plist,
    STATE(3822), 1,
      sym__type_apply,
    STATE(3826), 1,
      sym__type_unboxed_sum,
    STATE(3843), 1,
      sym__type_unboxed_tuple,
    STATE(3846), 1,
      sym__type_tuple,
    STATE(3851), 1,
      sym__type_parens,
    STATE(3886), 1,
      sym_integer,
    STATE(3887), 1,
      sym__type_list,
    STATE(3888), 1,
      sym__type_infix,
    STATE(3898), 1,
      sym__qualified_type,
    STATE(7480), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11251), 1,
      aux_sym__qualifying_module,
    ACTIONS(1373), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1383), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1387), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3807), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3855), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [7089] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1363), 1,
      sym_variable,
    ACTIONS(1367), 1,
      anon_sym__,
    ACTIONS(1369), 1,
      anon_sym_SQUOTE,
    ACTIONS(1385), 1,
      sym__integer_literal,
    ACTIONS(1397), 1,
      sym__cond_quote_start,
    ACTIONS(2595), 1,
      sym_name,
    STATE(456), 1,
      sym__paren_open,
    STATE(523), 1,
      sym_type,
    STATE(794), 1,
      sym__unboxed_open,
    STATE(964), 1,
      sym__bracket_open,
    STATE(3803), 1,
      sym__plist,
    STATE(3822), 1,
      sym__type_apply,
    STATE(3826), 1,
      sym__type_unboxed_sum,
    STATE(3843), 1,
      sym__type_unboxed_tuple,
    STATE(3846), 1,
      sym__type_tuple,
    STATE(3851), 1,
      sym__type_parens,
    STATE(3886), 1,
      sym_integer,
    STATE(3887), 1,
      sym__type_list,
    STATE(3888), 1,
      sym__type_infix,
    STATE(3898), 1,
      sym__qualified_type,
    STATE(7480), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11251), 1,
      aux_sym__qualifying_module,
    ACTIONS(1373), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1383), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1387), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3807), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3855), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [7217] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2041), 1,
      sym_variable,
    ACTIONS(2043), 1,
      anon_sym__,
    ACTIONS(2053), 1,
      sym__integer_literal,
    ACTIONS(2059), 1,
      sym__cond_quote_start,
    ACTIONS(2649), 1,
      anon_sym_SQUOTE,
    ACTIONS(2653), 1,
      sym_name,
    STATE(437), 1,
      sym__paren_open,
    STATE(747), 1,
      sym_type,
    STATE(827), 1,
      sym__unboxed_open,
    STATE(982), 1,
      sym__bracket_open,
    STATE(6256), 1,
      sym__qualified_type,
    STATE(6424), 1,
      sym__plist,
    STATE(6425), 1,
      sym__type_apply,
    STATE(6430), 1,
      sym__type_list,
    STATE(6431), 1,
      sym__type_unboxed_sum,
    STATE(6432), 1,
      sym__type_unboxed_tuple,
    STATE(6435), 1,
      sym__type_tuple,
    STATE(6447), 1,
      sym__type_parens,
    STATE(6459), 1,
      sym__type_infix,
    STATE(6547), 1,
      sym_integer,
    STATE(7322), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11242), 1,
      aux_sym__qualifying_module,
    ACTIONS(2049), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2051), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2055), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6408), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6452), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [7345] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2041), 1,
      sym_variable,
    ACTIONS(2043), 1,
      anon_sym__,
    ACTIONS(2053), 1,
      sym__integer_literal,
    ACTIONS(2059), 1,
      sym__cond_quote_start,
    ACTIONS(2649), 1,
      anon_sym_SQUOTE,
    ACTIONS(2653), 1,
      sym_name,
    STATE(437), 1,
      sym__paren_open,
    STATE(751), 1,
      sym_type,
    STATE(827), 1,
      sym__unboxed_open,
    STATE(982), 1,
      sym__bracket_open,
    STATE(6256), 1,
      sym__qualified_type,
    STATE(6424), 1,
      sym__plist,
    STATE(6425), 1,
      sym__type_apply,
    STATE(6430), 1,
      sym__type_list,
    STATE(6431), 1,
      sym__type_unboxed_sum,
    STATE(6432), 1,
      sym__type_unboxed_tuple,
    STATE(6435), 1,
      sym__type_tuple,
    STATE(6447), 1,
      sym__type_parens,
    STATE(6459), 1,
      sym__type_infix,
    STATE(6547), 1,
      sym_integer,
    STATE(7322), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11242), 1,
      aux_sym__qualifying_module,
    ACTIONS(2049), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2051), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2055), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6408), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6452), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [7473] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1093), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1809), 1,
      anon_sym__,
    ACTIONS(1833), 1,
      sym_variable,
    ACTIONS(1841), 1,
      sym__cond_quote_start,
    ACTIONS(4907), 1,
      anon_sym_SQUOTE,
    ACTIONS(4909), 1,
      sym_name,
    STATE(451), 1,
      sym__paren_open,
    STATE(583), 1,
      sym_type,
    STATE(817), 1,
      sym__unboxed_open,
    STATE(1084), 1,
      sym__bracket_open,
    STATE(4963), 1,
      sym__qualified_type,
    STATE(5034), 1,
      sym__plist,
    STATE(5035), 1,
      sym__type_infix,
    STATE(5036), 1,
      sym__type_apply,
    STATE(5038), 1,
      sym__type_list,
    STATE(5039), 1,
      sym__type_unboxed_sum,
    STATE(5041), 1,
      sym__type_unboxed_tuple,
    STATE(5042), 1,
      sym__type_tuple,
    STATE(5044), 1,
      sym__type_parens,
    STATE(5084), 1,
      sym_integer,
    STATE(7449), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11170), 1,
      aux_sym__qualifying_module,
    ACTIONS(1811), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1091), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1095), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5033), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5046), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [7601] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1093), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1809), 1,
      anon_sym__,
    ACTIONS(1833), 1,
      sym_variable,
    ACTIONS(1841), 1,
      sym__cond_quote_start,
    ACTIONS(4907), 1,
      anon_sym_SQUOTE,
    ACTIONS(4909), 1,
      sym_name,
    STATE(451), 1,
      sym__paren_open,
    STATE(581), 1,
      sym_type,
    STATE(817), 1,
      sym__unboxed_open,
    STATE(1084), 1,
      sym__bracket_open,
    STATE(4963), 1,
      sym__qualified_type,
    STATE(5034), 1,
      sym__plist,
    STATE(5035), 1,
      sym__type_infix,
    STATE(5036), 1,
      sym__type_apply,
    STATE(5038), 1,
      sym__type_list,
    STATE(5039), 1,
      sym__type_unboxed_sum,
    STATE(5041), 1,
      sym__type_unboxed_tuple,
    STATE(5042), 1,
      sym__type_tuple,
    STATE(5044), 1,
      sym__type_parens,
    STATE(5084), 1,
      sym_integer,
    STATE(7449), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11170), 1,
      aux_sym__qualifying_module,
    ACTIONS(1811), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1091), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1095), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5033), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5046), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [7729] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1941), 1,
      sym__integer_literal,
    ACTIONS(1953), 1,
      sym__cond_quote_start,
    ACTIONS(1955), 1,
      sym_variable,
    ACTIONS(1957), 1,
      anon_sym__,
    ACTIONS(4911), 1,
      anon_sym_SQUOTE,
    ACTIONS(4913), 1,
      sym_name,
    STATE(453), 1,
      sym__paren_open,
    STATE(673), 1,
      sym_type,
    STATE(815), 1,
      sym__unboxed_open,
    STATE(1072), 1,
      sym__bracket_open,
    STATE(6064), 1,
      sym__type_infix,
    STATE(6085), 1,
      sym__type_tuple,
    STATE(6100), 1,
      sym__type_parens,
    STATE(6116), 1,
      sym__plist,
    STATE(6118), 1,
      sym__type_apply,
    STATE(6120), 1,
      sym__type_list,
    STATE(6122), 1,
      sym__type_unboxed_sum,
    STATE(6123), 1,
      sym__type_unboxed_tuple,
    STATE(6125), 1,
      sym_integer,
    STATE(6171), 1,
      sym__qualified_type,
    STATE(7221), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11317), 1,
      aux_sym__qualifying_module,
    ACTIONS(1963), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1939), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1943), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6112), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6129), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [7857] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1941), 1,
      sym__integer_literal,
    ACTIONS(1953), 1,
      sym__cond_quote_start,
    ACTIONS(1955), 1,
      sym_variable,
    ACTIONS(1957), 1,
      anon_sym__,
    ACTIONS(4911), 1,
      anon_sym_SQUOTE,
    ACTIONS(4913), 1,
      sym_name,
    STATE(453), 1,
      sym__paren_open,
    STATE(720), 1,
      sym_type,
    STATE(815), 1,
      sym__unboxed_open,
    STATE(1072), 1,
      sym__bracket_open,
    STATE(6064), 1,
      sym__type_infix,
    STATE(6085), 1,
      sym__type_tuple,
    STATE(6100), 1,
      sym__type_parens,
    STATE(6116), 1,
      sym__plist,
    STATE(6118), 1,
      sym__type_apply,
    STATE(6120), 1,
      sym__type_list,
    STATE(6122), 1,
      sym__type_unboxed_sum,
    STATE(6123), 1,
      sym__type_unboxed_tuple,
    STATE(6125), 1,
      sym_integer,
    STATE(6171), 1,
      sym__qualified_type,
    STATE(7221), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11317), 1,
      aux_sym__qualifying_module,
    ACTIONS(1963), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1939), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1943), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6112), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6129), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [7985] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1941), 1,
      sym__integer_literal,
    ACTIONS(1953), 1,
      sym__cond_quote_start,
    ACTIONS(1955), 1,
      sym_variable,
    ACTIONS(1957), 1,
      anon_sym__,
    ACTIONS(4911), 1,
      anon_sym_SQUOTE,
    ACTIONS(4913), 1,
      sym_name,
    STATE(453), 1,
      sym__paren_open,
    STATE(726), 1,
      sym_type,
    STATE(815), 1,
      sym__unboxed_open,
    STATE(1072), 1,
      sym__bracket_open,
    STATE(6064), 1,
      sym__type_infix,
    STATE(6085), 1,
      sym__type_tuple,
    STATE(6100), 1,
      sym__type_parens,
    STATE(6116), 1,
      sym__plist,
    STATE(6118), 1,
      sym__type_apply,
    STATE(6120), 1,
      sym__type_list,
    STATE(6122), 1,
      sym__type_unboxed_sum,
    STATE(6123), 1,
      sym__type_unboxed_tuple,
    STATE(6125), 1,
      sym_integer,
    STATE(6171), 1,
      sym__qualified_type,
    STATE(7221), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11317), 1,
      aux_sym__qualifying_module,
    ACTIONS(1963), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1939), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1943), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6112), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6129), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [8113] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(565), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1689), 1,
      anon_sym__,
    ACTIONS(1693), 1,
      sym_variable,
    ACTIONS(1703), 1,
      sym__cond_quote_start,
    ACTIONS(4915), 1,
      anon_sym_SQUOTE,
    ACTIONS(4917), 1,
      sym_name,
    STATE(462), 1,
      sym__paren_open,
    STATE(513), 1,
      sym_type,
    STATE(768), 1,
      sym__unboxed_open,
    STATE(1063), 1,
      sym__bracket_open,
    STATE(3701), 1,
      sym__type_parens,
    STATE(3702), 1,
      sym__type_tuple,
    STATE(3703), 1,
      sym__qualified_type,
    STATE(3709), 1,
      sym__type_unboxed_tuple,
    STATE(3711), 1,
      sym__type_unboxed_sum,
    STATE(3712), 1,
      sym__type_list,
    STATE(3715), 1,
      sym__type_apply,
    STATE(3717), 1,
      sym__type_infix,
    STATE(3718), 1,
      sym__plist,
    STATE(3781), 1,
      sym_integer,
    STATE(7323), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11219), 1,
      aux_sym__qualifying_module,
    ACTIONS(1691), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(563), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(567), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3721), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3699), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [8241] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1793), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [8369] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(909), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1753), 1,
      anon_sym__,
    ACTIONS(1757), 1,
      sym_variable,
    ACTIONS(1765), 1,
      sym__cond_quote_start,
    ACTIONS(4903), 1,
      anon_sym_SQUOTE,
    ACTIONS(4905), 1,
      sym_name,
    STATE(471), 1,
      sym__paren_open,
    STATE(553), 1,
      sym_type,
    STATE(778), 1,
      sym__unboxed_open,
    STATE(1071), 1,
      sym__bracket_open,
    STATE(4235), 1,
      sym__plist,
    STATE(4241), 1,
      sym__type_infix,
    STATE(4248), 1,
      sym__qualified_type,
    STATE(4258), 1,
      sym__type_parens,
    STATE(4261), 1,
      sym__type_tuple,
    STATE(4262), 1,
      sym__type_unboxed_tuple,
    STATE(4263), 1,
      sym__type_unboxed_sum,
    STATE(4264), 1,
      sym__type_list,
    STATE(4265), 1,
      sym__type_apply,
    STATE(4282), 1,
      sym_integer,
    STATE(7317), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11227), 1,
      aux_sym__qualifying_module,
    ACTIONS(1755), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(907), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(911), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4275), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4257), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [8497] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1768), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [8625] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1773), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [8753] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1774), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [8881] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1775), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [9009] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1812), 1,
      sym_type,
    STATE(5677), 1,
      sym__type_infix,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [9137] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2739), 1,
      sym_variable,
    ACTIONS(2741), 1,
      anon_sym__,
    ACTIONS(2745), 1,
      sym__integer_literal,
    ACTIONS(2751), 1,
      sym__cond_quote_start,
    ACTIONS(4919), 1,
      anon_sym_SQUOTE,
    ACTIONS(4921), 1,
      sym_name,
    STATE(459), 1,
      sym__paren_open,
    STATE(793), 1,
      sym__unboxed_open,
    STATE(874), 1,
      sym_type,
    STATE(1113), 1,
      sym__bracket_open,
    STATE(6887), 1,
      sym_integer,
    STATE(6927), 1,
      sym__type_infix,
    STATE(6931), 1,
      sym__qualified_type,
    STATE(6989), 1,
      sym__type_parens,
    STATE(6991), 1,
      sym__type_tuple,
    STATE(6992), 1,
      sym__type_unboxed_tuple,
    STATE(6993), 1,
      sym__type_unboxed_sum,
    STATE(6994), 1,
      sym__type_list,
    STATE(6995), 1,
      sym__type_apply,
    STATE(6996), 1,
      sym__plist,
    STATE(7369), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11311), 1,
      aux_sym__qualifying_module,
    ACTIONS(2671), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2743), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2747), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6997), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6987), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [9265] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1825), 1,
      sym_type,
    STATE(6956), 1,
      sym__type_infix,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [9393] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1093), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1809), 1,
      anon_sym__,
    ACTIONS(1833), 1,
      sym_variable,
    ACTIONS(1841), 1,
      sym__cond_quote_start,
    ACTIONS(4907), 1,
      anon_sym_SQUOTE,
    ACTIONS(4909), 1,
      sym_name,
    STATE(451), 1,
      sym__paren_open,
    STATE(580), 1,
      sym_type,
    STATE(817), 1,
      sym__unboxed_open,
    STATE(1084), 1,
      sym__bracket_open,
    STATE(4963), 1,
      sym__qualified_type,
    STATE(5034), 1,
      sym__plist,
    STATE(5035), 1,
      sym__type_infix,
    STATE(5036), 1,
      sym__type_apply,
    STATE(5038), 1,
      sym__type_list,
    STATE(5039), 1,
      sym__type_unboxed_sum,
    STATE(5041), 1,
      sym__type_unboxed_tuple,
    STATE(5042), 1,
      sym__type_tuple,
    STATE(5044), 1,
      sym__type_parens,
    STATE(5084), 1,
      sym_integer,
    STATE(7449), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11170), 1,
      aux_sym__qualifying_module,
    ACTIONS(1811), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1091), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1095), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5033), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5046), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [9521] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1825), 1,
      sym_type,
    STATE(6983), 1,
      sym__type_infix,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [9649] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2945), 1,
      sym_variable,
    ACTIONS(2947), 1,
      anon_sym__,
    ACTIONS(2957), 1,
      sym__integer_literal,
    ACTIONS(2963), 1,
      sym__cond_quote_start,
    ACTIONS(4354), 1,
      anon_sym_SQUOTE,
    ACTIONS(4360), 1,
      sym_name,
    STATE(448), 1,
      sym__paren_open,
    STATE(824), 1,
      sym__unboxed_open,
    STATE(1009), 1,
      sym__bracket_open,
    STATE(1119), 1,
      sym_type,
    STATE(7206), 1,
      sym_integer,
    STATE(7207), 1,
      sym__type_infix,
    STATE(7208), 1,
      sym__splice_dollars,
    STATE(7209), 1,
      sym__plist,
    STATE(7237), 1,
      sym__type_apply,
    STATE(7246), 1,
      sym__type_unboxed_sum,
    STATE(7247), 1,
      sym__type_list,
    STATE(7258), 1,
      sym__type_unboxed_tuple,
    STATE(7262), 1,
      sym__type_tuple,
    STATE(7268), 1,
      sym__type_parens,
    STATE(7374), 1,
      sym__qualified_type,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11301), 1,
      aux_sym__qualifying_module,
    ACTIONS(2953), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2955), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2959), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7210), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7269), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [9777] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2945), 1,
      sym_variable,
    ACTIONS(2947), 1,
      anon_sym__,
    ACTIONS(2957), 1,
      sym__integer_literal,
    ACTIONS(2963), 1,
      sym__cond_quote_start,
    ACTIONS(4354), 1,
      anon_sym_SQUOTE,
    ACTIONS(4360), 1,
      sym_name,
    STATE(448), 1,
      sym__paren_open,
    STATE(824), 1,
      sym__unboxed_open,
    STATE(1009), 1,
      sym__bracket_open,
    STATE(1125), 1,
      sym_type,
    STATE(7206), 1,
      sym_integer,
    STATE(7207), 1,
      sym__type_infix,
    STATE(7208), 1,
      sym__splice_dollars,
    STATE(7209), 1,
      sym__plist,
    STATE(7237), 1,
      sym__type_apply,
    STATE(7246), 1,
      sym__type_unboxed_sum,
    STATE(7247), 1,
      sym__type_list,
    STATE(7258), 1,
      sym__type_unboxed_tuple,
    STATE(7262), 1,
      sym__type_tuple,
    STATE(7268), 1,
      sym__type_parens,
    STATE(7374), 1,
      sym__qualified_type,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11301), 1,
      aux_sym__qualifying_module,
    ACTIONS(2953), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2955), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2959), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7210), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7269), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [9905] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2945), 1,
      sym_variable,
    ACTIONS(2947), 1,
      anon_sym__,
    ACTIONS(2957), 1,
      sym__integer_literal,
    ACTIONS(2963), 1,
      sym__cond_quote_start,
    ACTIONS(4354), 1,
      anon_sym_SQUOTE,
    ACTIONS(4360), 1,
      sym_name,
    STATE(448), 1,
      sym__paren_open,
    STATE(824), 1,
      sym__unboxed_open,
    STATE(1009), 1,
      sym__bracket_open,
    STATE(1126), 1,
      sym_type,
    STATE(7206), 1,
      sym_integer,
    STATE(7207), 1,
      sym__type_infix,
    STATE(7208), 1,
      sym__splice_dollars,
    STATE(7209), 1,
      sym__plist,
    STATE(7237), 1,
      sym__type_apply,
    STATE(7246), 1,
      sym__type_unboxed_sum,
    STATE(7247), 1,
      sym__type_list,
    STATE(7258), 1,
      sym__type_unboxed_tuple,
    STATE(7262), 1,
      sym__type_tuple,
    STATE(7268), 1,
      sym__type_parens,
    STATE(7374), 1,
      sym__qualified_type,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11301), 1,
      aux_sym__qualifying_module,
    ACTIONS(2953), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2955), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2959), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7210), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7269), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [10033] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1907), 1,
      sym_variable,
    ACTIONS(1909), 1,
      anon_sym__,
    ACTIONS(1919), 1,
      sym__integer_literal,
    ACTIONS(1925), 1,
      sym__cond_quote_start,
    ACTIONS(4883), 1,
      anon_sym_SQUOTE,
    ACTIONS(4885), 1,
      sym_name,
    STATE(475), 1,
      sym__paren_open,
    STATE(663), 1,
      sym_type,
    STATE(788), 1,
      sym__unboxed_open,
    STATE(1067), 1,
      sym__bracket_open,
    STATE(5902), 1,
      sym_integer,
    STATE(5944), 1,
      sym__type_parens,
    STATE(5945), 1,
      sym__type_tuple,
    STATE(5946), 1,
      sym__type_unboxed_tuple,
    STATE(5947), 1,
      sym__type_unboxed_sum,
    STATE(5948), 1,
      sym__type_list,
    STATE(5949), 1,
      sym__type_apply,
    STATE(5950), 1,
      sym__type_infix,
    STATE(5951), 1,
      sym__plist,
    STATE(5976), 1,
      sym__qualified_type,
    STATE(7347), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11157), 1,
      aux_sym__qualifying_module,
    ACTIONS(1915), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1917), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1921), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5952), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5942), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [10161] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1788), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [10289] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1609), 1,
      sym_variable,
    ACTIONS(1611), 1,
      anon_sym__,
    ACTIONS(1621), 1,
      sym__integer_literal,
    ACTIONS(1627), 1,
      sym__cond_quote_start,
    ACTIONS(3383), 1,
      anon_sym_SQUOTE,
    ACTIONS(3387), 1,
      sym_name,
    STATE(464), 1,
      sym__paren_open,
    STATE(484), 1,
      sym_type,
    STATE(805), 1,
      sym__unboxed_open,
    STATE(1079), 1,
      sym__bracket_open,
    STATE(3269), 1,
      sym_integer,
    STATE(3357), 1,
      sym__plist,
    STATE(3358), 1,
      sym__type_infix,
    STATE(3359), 1,
      sym__type_apply,
    STATE(3361), 1,
      sym__type_list,
    STATE(3369), 1,
      sym__type_unboxed_sum,
    STATE(3370), 1,
      sym__type_unboxed_tuple,
    STATE(3377), 1,
      sym__type_tuple,
    STATE(3379), 1,
      sym__type_parens,
    STATE(3410), 1,
      sym__qualified_type,
    STATE(7460), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11178), 1,
      aux_sym__qualifying_module,
    ACTIONS(1617), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1619), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1623), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3354), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3383), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [10417] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4923), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4925), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [10493] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(309), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1305), 1,
      sym_variable,
    ACTIONS(1307), 1,
      anon_sym__,
    ACTIONS(1317), 1,
      sym__cond_quote_start,
    ACTIONS(4927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4929), 1,
      sym_name,
    STATE(408), 1,
      sym_type,
    STATE(432), 1,
      sym__paren_open,
    STATE(753), 1,
      sym__unboxed_open,
    STATE(1055), 1,
      sym__bracket_open,
    STATE(2693), 1,
      sym__plist,
    STATE(2697), 1,
      sym__qualified_type,
    STATE(2713), 1,
      sym__type_infix,
    STATE(2729), 1,
      sym__type_tuple,
    STATE(2733), 1,
      sym__type_parens,
    STATE(2734), 1,
      sym_integer,
    STATE(2745), 1,
      sym__type_apply,
    STATE(2746), 1,
      sym__type_unboxed_sum,
    STATE(2749), 1,
      sym__type_list,
    STATE(2751), 1,
      sym__type_unboxed_tuple,
    STATE(7364), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10987), 1,
      aux_sym__qualifying_module,
    ACTIONS(1313), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(307), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(311), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(2694), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(2710), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [10621] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1485), 1,
      sym__linear_fun_arrow,
    STATE(1493), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4600), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4602), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [10713] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1609), 1,
      sym_variable,
    ACTIONS(1611), 1,
      anon_sym__,
    ACTIONS(1621), 1,
      sym__integer_literal,
    ACTIONS(1627), 1,
      sym__cond_quote_start,
    ACTIONS(3383), 1,
      anon_sym_SQUOTE,
    ACTIONS(3387), 1,
      sym_name,
    STATE(464), 1,
      sym__paren_open,
    STATE(482), 1,
      sym_type,
    STATE(805), 1,
      sym__unboxed_open,
    STATE(1079), 1,
      sym__bracket_open,
    STATE(3269), 1,
      sym_integer,
    STATE(3357), 1,
      sym__plist,
    STATE(3358), 1,
      sym__type_infix,
    STATE(3359), 1,
      sym__type_apply,
    STATE(3361), 1,
      sym__type_list,
    STATE(3369), 1,
      sym__type_unboxed_sum,
    STATE(3370), 1,
      sym__type_unboxed_tuple,
    STATE(3377), 1,
      sym__type_tuple,
    STATE(3379), 1,
      sym__type_parens,
    STATE(3410), 1,
      sym__qualified_type,
    STATE(7460), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11178), 1,
      aux_sym__qualifying_module,
    ACTIONS(1617), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1619), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1623), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3354), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3383), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [10841] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2121), 1,
      sym_variable,
    ACTIONS(2123), 1,
      anon_sym__,
    ACTIONS(2133), 1,
      sym__integer_literal,
    ACTIONS(2139), 1,
      sym__cond_quote_start,
    ACTIONS(3547), 1,
      anon_sym_SQUOTE,
    ACTIONS(3551), 1,
      sym_name,
    STATE(431), 1,
      sym__paren_open,
    STATE(771), 1,
      sym__unboxed_open,
    STATE(797), 1,
      sym_type,
    STATE(1029), 1,
      sym__bracket_open,
    STATE(6245), 1,
      sym__qualified_type,
    STATE(6338), 1,
      sym_integer,
    STATE(6512), 1,
      sym__type_parens,
    STATE(6513), 1,
      sym__type_tuple,
    STATE(6514), 1,
      sym__type_unboxed_tuple,
    STATE(6515), 1,
      sym__type_unboxed_sum,
    STATE(6516), 1,
      sym__type_list,
    STATE(6517), 1,
      sym__type_apply,
    STATE(6518), 1,
      sym__type_infix,
    STATE(6519), 1,
      sym__plist,
    STATE(7260), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11289), 1,
      aux_sym__qualifying_module,
    ACTIONS(2129), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2135), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6520), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6510), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [10969] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2739), 1,
      sym_variable,
    ACTIONS(2741), 1,
      anon_sym__,
    ACTIONS(2745), 1,
      sym__integer_literal,
    ACTIONS(2751), 1,
      sym__cond_quote_start,
    ACTIONS(4919), 1,
      anon_sym_SQUOTE,
    ACTIONS(4921), 1,
      sym_name,
    STATE(459), 1,
      sym__paren_open,
    STATE(793), 1,
      sym__unboxed_open,
    STATE(927), 1,
      sym_type,
    STATE(1113), 1,
      sym__bracket_open,
    STATE(6887), 1,
      sym_integer,
    STATE(6927), 1,
      sym__type_infix,
    STATE(6931), 1,
      sym__qualified_type,
    STATE(6989), 1,
      sym__type_parens,
    STATE(6991), 1,
      sym__type_tuple,
    STATE(6992), 1,
      sym__type_unboxed_tuple,
    STATE(6993), 1,
      sym__type_unboxed_sum,
    STATE(6994), 1,
      sym__type_list,
    STATE(6995), 1,
      sym__type_apply,
    STATE(6996), 1,
      sym__plist,
    STATE(7369), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11311), 1,
      aux_sym__qualifying_module,
    ACTIONS(2671), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2743), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2747), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6997), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6987), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [11097] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2739), 1,
      sym_variable,
    ACTIONS(2741), 1,
      anon_sym__,
    ACTIONS(2745), 1,
      sym__integer_literal,
    ACTIONS(2751), 1,
      sym__cond_quote_start,
    ACTIONS(4919), 1,
      anon_sym_SQUOTE,
    ACTIONS(4921), 1,
      sym_name,
    STATE(459), 1,
      sym__paren_open,
    STATE(793), 1,
      sym__unboxed_open,
    STATE(925), 1,
      sym_type,
    STATE(1113), 1,
      sym__bracket_open,
    STATE(6887), 1,
      sym_integer,
    STATE(6927), 1,
      sym__type_infix,
    STATE(6931), 1,
      sym__qualified_type,
    STATE(6989), 1,
      sym__type_parens,
    STATE(6991), 1,
      sym__type_tuple,
    STATE(6992), 1,
      sym__type_unboxed_tuple,
    STATE(6993), 1,
      sym__type_unboxed_sum,
    STATE(6994), 1,
      sym__type_list,
    STATE(6995), 1,
      sym__type_apply,
    STATE(6996), 1,
      sym__plist,
    STATE(7369), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11311), 1,
      aux_sym__qualifying_module,
    ACTIONS(2671), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2743), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2747), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6997), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6987), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [11225] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2739), 1,
      sym_variable,
    ACTIONS(2741), 1,
      anon_sym__,
    ACTIONS(2745), 1,
      sym__integer_literal,
    ACTIONS(2751), 1,
      sym__cond_quote_start,
    ACTIONS(4919), 1,
      anon_sym_SQUOTE,
    ACTIONS(4921), 1,
      sym_name,
    STATE(459), 1,
      sym__paren_open,
    STATE(793), 1,
      sym__unboxed_open,
    STATE(921), 1,
      sym_type,
    STATE(1113), 1,
      sym__bracket_open,
    STATE(6887), 1,
      sym_integer,
    STATE(6927), 1,
      sym__type_infix,
    STATE(6931), 1,
      sym__qualified_type,
    STATE(6989), 1,
      sym__type_parens,
    STATE(6991), 1,
      sym__type_tuple,
    STATE(6992), 1,
      sym__type_unboxed_tuple,
    STATE(6993), 1,
      sym__type_unboxed_sum,
    STATE(6994), 1,
      sym__type_list,
    STATE(6995), 1,
      sym__type_apply,
    STATE(6996), 1,
      sym__plist,
    STATE(7369), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11311), 1,
      aux_sym__qualifying_module,
    ACTIONS(2671), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2743), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2747), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6997), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6987), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [11353] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1093), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1809), 1,
      anon_sym__,
    ACTIONS(1833), 1,
      sym_variable,
    ACTIONS(1841), 1,
      sym__cond_quote_start,
    ACTIONS(4907), 1,
      anon_sym_SQUOTE,
    ACTIONS(4909), 1,
      sym_name,
    STATE(451), 1,
      sym__paren_open,
    STATE(576), 1,
      sym_type,
    STATE(817), 1,
      sym__unboxed_open,
    STATE(1084), 1,
      sym__bracket_open,
    STATE(4963), 1,
      sym__qualified_type,
    STATE(5034), 1,
      sym__plist,
    STATE(5035), 1,
      sym__type_infix,
    STATE(5036), 1,
      sym__type_apply,
    STATE(5038), 1,
      sym__type_list,
    STATE(5039), 1,
      sym__type_unboxed_sum,
    STATE(5041), 1,
      sym__type_unboxed_tuple,
    STATE(5042), 1,
      sym__type_tuple,
    STATE(5044), 1,
      sym__type_parens,
    STATE(5084), 1,
      sym_integer,
    STATE(7449), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11170), 1,
      aux_sym__qualifying_module,
    ACTIONS(1811), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1091), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1095), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5033), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5046), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [11481] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(677), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1711), 1,
      sym_variable,
    ACTIONS(1713), 1,
      anon_sym__,
    ACTIONS(1723), 1,
      sym__cond_quote_start,
    ACTIONS(4931), 1,
      anon_sym_SQUOTE,
    ACTIONS(4933), 1,
      sym_name,
    STATE(452), 1,
      sym__paren_open,
    STATE(539), 1,
      sym_type,
    STATE(806), 1,
      sym__unboxed_open,
    STATE(1122), 1,
      sym__bracket_open,
    STATE(3989), 1,
      sym__type_tuple,
    STATE(3996), 1,
      sym__type_parens,
    STATE(4000), 1,
      sym__type_unboxed_tuple,
    STATE(4001), 1,
      sym__type_unboxed_sum,
    STATE(4003), 1,
      sym__type_list,
    STATE(4004), 1,
      sym__type_apply,
    STATE(4005), 1,
      sym__type_infix,
    STATE(4006), 1,
      sym__plist,
    STATE(4067), 1,
      sym_integer,
    STATE(4144), 1,
      sym__qualified_type,
    STATE(7478), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11120), 1,
      aux_sym__qualifying_module,
    ACTIONS(1719), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(675), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(679), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3997), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3975), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [11609] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(721), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1725), 1,
      sym_variable,
    ACTIONS(1727), 1,
      anon_sym__,
    ACTIONS(1737), 1,
      sym__cond_quote_start,
    ACTIONS(4935), 1,
      anon_sym_SQUOTE,
    ACTIONS(4937), 1,
      sym_name,
    STATE(444), 1,
      sym__paren_open,
    STATE(530), 1,
      sym_type,
    STATE(787), 1,
      sym__unboxed_open,
    STATE(1041), 1,
      sym__bracket_open,
    STATE(4078), 1,
      sym__type_parens,
    STATE(4080), 1,
      sym__type_tuple,
    STATE(4081), 1,
      sym__type_unboxed_tuple,
    STATE(4082), 1,
      sym__type_unboxed_sum,
    STATE(4084), 1,
      sym__type_list,
    STATE(4085), 1,
      sym__type_apply,
    STATE(4097), 1,
      sym__plist,
    STATE(4133), 1,
      sym__type_infix,
    STATE(4138), 1,
      sym__qualified_type,
    STATE(4193), 1,
      sym_integer,
    STATE(7390), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11143), 1,
      aux_sym__qualifying_module,
    ACTIONS(1733), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(719), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(723), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4098), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4075), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [11737] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(677), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1711), 1,
      sym_variable,
    ACTIONS(1713), 1,
      anon_sym__,
    ACTIONS(1723), 1,
      sym__cond_quote_start,
    ACTIONS(4931), 1,
      anon_sym_SQUOTE,
    ACTIONS(4933), 1,
      sym_name,
    STATE(452), 1,
      sym__paren_open,
    STATE(533), 1,
      sym_type,
    STATE(806), 1,
      sym__unboxed_open,
    STATE(1122), 1,
      sym__bracket_open,
    STATE(3989), 1,
      sym__type_tuple,
    STATE(3996), 1,
      sym__type_parens,
    STATE(4000), 1,
      sym__type_unboxed_tuple,
    STATE(4001), 1,
      sym__type_unboxed_sum,
    STATE(4003), 1,
      sym__type_list,
    STATE(4004), 1,
      sym__type_apply,
    STATE(4005), 1,
      sym__type_infix,
    STATE(4006), 1,
      sym__plist,
    STATE(4067), 1,
      sym_integer,
    STATE(4144), 1,
      sym__qualified_type,
    STATE(7478), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11120), 1,
      aux_sym__qualifying_module,
    ACTIONS(1719), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(675), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(679), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3997), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3975), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [11865] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(309), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1305), 1,
      sym_variable,
    ACTIONS(1307), 1,
      anon_sym__,
    ACTIONS(1317), 1,
      sym__cond_quote_start,
    ACTIONS(4927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4929), 1,
      sym_name,
    STATE(401), 1,
      sym_type,
    STATE(432), 1,
      sym__paren_open,
    STATE(753), 1,
      sym__unboxed_open,
    STATE(1055), 1,
      sym__bracket_open,
    STATE(2693), 1,
      sym__plist,
    STATE(2697), 1,
      sym__qualified_type,
    STATE(2713), 1,
      sym__type_infix,
    STATE(2729), 1,
      sym__type_tuple,
    STATE(2733), 1,
      sym__type_parens,
    STATE(2734), 1,
      sym_integer,
    STATE(2745), 1,
      sym__type_apply,
    STATE(2746), 1,
      sym__type_unboxed_sum,
    STATE(2749), 1,
      sym__type_list,
    STATE(2751), 1,
      sym__type_unboxed_tuple,
    STATE(7364), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10987), 1,
      aux_sym__qualifying_module,
    ACTIONS(1313), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(307), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(311), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(2694), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(2710), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [11993] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1152), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [12121] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1789), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [12249] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1827), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(7535), 1,
      sym__type_infix,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [12377] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2607), 1,
      sym_variable,
    ACTIONS(2609), 1,
      anon_sym__,
    ACTIONS(2619), 1,
      sym__integer_literal,
    ACTIONS(2625), 1,
      sym__cond_quote_start,
    ACTIONS(3455), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      sym_name,
    STATE(472), 1,
      sym__paren_open,
    STATE(789), 1,
      sym__unboxed_open,
    STATE(865), 1,
      sym_type,
    STATE(1078), 1,
      sym__bracket_open,
    STATE(6710), 1,
      sym_integer,
    STATE(6756), 1,
      sym__qualified_type,
    STATE(6784), 1,
      sym__type_parens,
    STATE(6785), 1,
      sym__type_tuple,
    STATE(6786), 1,
      sym__type_unboxed_tuple,
    STATE(6787), 1,
      sym__type_unboxed_sum,
    STATE(6789), 1,
      sym__type_list,
    STATE(6790), 1,
      sym__type_apply,
    STATE(6791), 1,
      sym__type_infix,
    STATE(6792), 1,
      sym__plist,
    STATE(7457), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11189), 1,
      aux_sym__qualifying_module,
    ACTIONS(2615), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2617), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2621), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6793), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6781), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [12505] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1783), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [12633] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3107), 1,
      sym_variable,
    ACTIONS(3109), 1,
      anon_sym__,
    ACTIONS(3119), 1,
      sym__integer_literal,
    ACTIONS(3125), 1,
      sym__cond_quote_start,
    ACTIONS(4378), 1,
      anon_sym_SQUOTE,
    ACTIONS(4380), 1,
      sym_name,
    STATE(455), 1,
      sym__paren_open,
    STATE(770), 1,
      sym__unboxed_open,
    STATE(1090), 1,
      sym__bracket_open,
    STATE(1164), 1,
      sym_type,
    STATE(7345), 1,
      sym__splice_dollars,
    STATE(7492), 1,
      sym__type_unboxed_sum,
    STATE(7497), 1,
      sym__type_unboxed_tuple,
    STATE(7503), 1,
      sym__type_tuple,
    STATE(7505), 1,
      sym__type_parens,
    STATE(7518), 1,
      sym__plist,
    STATE(7528), 1,
      sym__type_list,
    STATE(7534), 1,
      sym__type_infix,
    STATE(7541), 1,
      sym__qualified_type,
    STATE(7542), 1,
      sym_integer,
    STATE(7550), 1,
      sym__type_apply,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11252), 1,
      aux_sym__qualifying_module,
    ACTIONS(3115), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3117), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3121), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7511), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7491), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [12761] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3107), 1,
      sym_variable,
    ACTIONS(3109), 1,
      anon_sym__,
    ACTIONS(3119), 1,
      sym__integer_literal,
    ACTIONS(3125), 1,
      sym__cond_quote_start,
    ACTIONS(4378), 1,
      anon_sym_SQUOTE,
    ACTIONS(4380), 1,
      sym_name,
    STATE(455), 1,
      sym__paren_open,
    STATE(770), 1,
      sym__unboxed_open,
    STATE(1090), 1,
      sym__bracket_open,
    STATE(1141), 1,
      sym_type,
    STATE(7345), 1,
      sym__splice_dollars,
    STATE(7492), 1,
      sym__type_unboxed_sum,
    STATE(7497), 1,
      sym__type_unboxed_tuple,
    STATE(7503), 1,
      sym__type_tuple,
    STATE(7505), 1,
      sym__type_parens,
    STATE(7518), 1,
      sym__plist,
    STATE(7528), 1,
      sym__type_list,
    STATE(7534), 1,
      sym__type_infix,
    STATE(7541), 1,
      sym__qualified_type,
    STATE(7542), 1,
      sym_integer,
    STATE(7550), 1,
      sym__type_apply,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11252), 1,
      aux_sym__qualifying_module,
    ACTIONS(3115), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3117), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3121), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7511), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7491), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [12889] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1812), 1,
      sym_type,
    STATE(5680), 1,
      sym__type_infix,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [13017] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2607), 1,
      sym_variable,
    ACTIONS(2609), 1,
      anon_sym__,
    ACTIONS(2619), 1,
      sym__integer_literal,
    ACTIONS(2625), 1,
      sym__cond_quote_start,
    ACTIONS(3455), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      sym_name,
    STATE(472), 1,
      sym__paren_open,
    STATE(789), 1,
      sym__unboxed_open,
    STATE(849), 1,
      sym_type,
    STATE(1078), 1,
      sym__bracket_open,
    STATE(6710), 1,
      sym_integer,
    STATE(6756), 1,
      sym__qualified_type,
    STATE(6784), 1,
      sym__type_parens,
    STATE(6785), 1,
      sym__type_tuple,
    STATE(6786), 1,
      sym__type_unboxed_tuple,
    STATE(6787), 1,
      sym__type_unboxed_sum,
    STATE(6789), 1,
      sym__type_list,
    STATE(6790), 1,
      sym__type_apply,
    STATE(6791), 1,
      sym__type_infix,
    STATE(6792), 1,
      sym__plist,
    STATE(7457), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11189), 1,
      aux_sym__qualifying_module,
    ACTIONS(2615), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2617), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2621), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6793), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6781), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [13145] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1151), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [13273] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2607), 1,
      sym_variable,
    ACTIONS(2609), 1,
      anon_sym__,
    ACTIONS(2619), 1,
      sym__integer_literal,
    ACTIONS(2625), 1,
      sym__cond_quote_start,
    ACTIONS(3455), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      sym_name,
    STATE(472), 1,
      sym__paren_open,
    STATE(789), 1,
      sym__unboxed_open,
    STATE(843), 1,
      sym_type,
    STATE(1078), 1,
      sym__bracket_open,
    STATE(6710), 1,
      sym_integer,
    STATE(6756), 1,
      sym__qualified_type,
    STATE(6784), 1,
      sym__type_parens,
    STATE(6785), 1,
      sym__type_tuple,
    STATE(6786), 1,
      sym__type_unboxed_tuple,
    STATE(6787), 1,
      sym__type_unboxed_sum,
    STATE(6789), 1,
      sym__type_list,
    STATE(6790), 1,
      sym__type_apply,
    STATE(6791), 1,
      sym__type_infix,
    STATE(6792), 1,
      sym__plist,
    STATE(7457), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11189), 1,
      aux_sym__qualifying_module,
    ACTIONS(2615), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2617), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2621), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6793), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6781), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [13401] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1887), 1,
      sym_variable,
    ACTIONS(1889), 1,
      anon_sym__,
    ACTIONS(1899), 1,
      sym__integer_literal,
    ACTIONS(1905), 1,
      sym__cond_quote_start,
    ACTIONS(3299), 1,
      anon_sym_SQUOTE,
    ACTIONS(3303), 1,
      sym_name,
    STATE(460), 1,
      sym__paren_open,
    STATE(654), 1,
      sym_type,
    STATE(826), 1,
      sym__unboxed_open,
    STATE(1045), 1,
      sym__bracket_open,
    STATE(5900), 1,
      sym__plist,
    STATE(5912), 1,
      sym__type_infix,
    STATE(5917), 1,
      sym__type_apply,
    STATE(5923), 1,
      sym__type_list,
    STATE(5927), 1,
      sym__type_unboxed_sum,
    STATE(5928), 1,
      sym__type_unboxed_tuple,
    STATE(5929), 1,
      sym__type_tuple,
    STATE(5938), 1,
      sym__type_parens,
    STATE(5983), 1,
      sym__qualified_type,
    STATE(6013), 1,
      sym_integer,
    STATE(7467), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11083), 1,
      aux_sym__qualifying_module,
    ACTIONS(1895), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1897), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1901), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5894), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5958), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [13529] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1150), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [13657] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1569), 1,
      sym_variable,
    ACTIONS(1571), 1,
      anon_sym__,
    ACTIONS(1581), 1,
      sym__integer_literal,
    ACTIONS(1587), 1,
      sym__cond_quote_start,
    ACTIONS(3439), 1,
      anon_sym_SQUOTE,
    ACTIONS(3443), 1,
      sym_name,
    STATE(466), 1,
      sym__paren_open,
    STATE(493), 1,
      sym_type,
    STATE(781), 1,
      sym__unboxed_open,
    STATE(1073), 1,
      sym__bracket_open,
    STATE(3177), 1,
      sym__plist,
    STATE(3184), 1,
      sym__type_unboxed_tuple,
    STATE(3188), 1,
      sym__type_unboxed_sum,
    STATE(3196), 1,
      sym__type_apply,
    STATE(3210), 1,
      sym__type_tuple,
    STATE(3211), 1,
      sym__type_list,
    STATE(3220), 1,
      sym__type_parens,
    STATE(3225), 1,
      sym__type_infix,
    STATE(3262), 1,
      sym__qualified_type,
    STATE(3397), 1,
      sym_integer,
    STATE(7401), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11198), 1,
      aux_sym__qualifying_module,
    ACTIONS(1577), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1579), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1583), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3232), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3364), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [13785] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1669), 1,
      sym_variable,
    ACTIONS(1671), 1,
      anon_sym__,
    ACTIONS(1681), 1,
      sym__integer_literal,
    ACTIONS(1687), 1,
      sym__cond_quote_start,
    ACTIONS(3419), 1,
      anon_sym_SQUOTE,
    ACTIONS(3423), 1,
      sym_name,
    STATE(461), 1,
      sym__paren_open,
    STATE(512), 1,
      sym_type,
    STATE(829), 1,
      sym__unboxed_open,
    STATE(1131), 1,
      sym__bracket_open,
    STATE(3509), 1,
      sym_integer,
    STATE(3557), 1,
      sym__type_parens,
    STATE(3597), 1,
      sym__plist,
    STATE(3602), 1,
      sym__type_infix,
    STATE(3604), 1,
      sym__type_apply,
    STATE(3605), 1,
      sym__type_list,
    STATE(3606), 1,
      sym__type_unboxed_sum,
    STATE(3607), 1,
      sym__type_unboxed_tuple,
    STATE(3612), 1,
      sym__type_tuple,
    STATE(3643), 1,
      sym__qualified_type,
    STATE(7350), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11140), 1,
      aux_sym__qualifying_module,
    ACTIONS(1677), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1679), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1683), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3583), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3638), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [13913] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1569), 1,
      sym_variable,
    ACTIONS(1571), 1,
      anon_sym__,
    ACTIONS(1581), 1,
      sym__integer_literal,
    ACTIONS(1587), 1,
      sym__cond_quote_start,
    ACTIONS(3439), 1,
      anon_sym_SQUOTE,
    ACTIONS(3443), 1,
      sym_name,
    STATE(466), 1,
      sym__paren_open,
    STATE(477), 1,
      sym_type,
    STATE(781), 1,
      sym__unboxed_open,
    STATE(1073), 1,
      sym__bracket_open,
    STATE(3177), 1,
      sym__plist,
    STATE(3184), 1,
      sym__type_unboxed_tuple,
    STATE(3188), 1,
      sym__type_unboxed_sum,
    STATE(3196), 1,
      sym__type_apply,
    STATE(3210), 1,
      sym__type_tuple,
    STATE(3211), 1,
      sym__type_list,
    STATE(3220), 1,
      sym__type_parens,
    STATE(3225), 1,
      sym__type_infix,
    STATE(3262), 1,
      sym__qualified_type,
    STATE(3397), 1,
      sym_integer,
    STATE(7401), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11198), 1,
      aux_sym__qualifying_module,
    ACTIONS(1577), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1579), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1583), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3232), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3364), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [14041] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1778), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [14169] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1569), 1,
      sym_variable,
    ACTIONS(1571), 1,
      anon_sym__,
    ACTIONS(1581), 1,
      sym__integer_literal,
    ACTIONS(1587), 1,
      sym__cond_quote_start,
    ACTIONS(3439), 1,
      anon_sym_SQUOTE,
    ACTIONS(3443), 1,
      sym_name,
    STATE(466), 1,
      sym__paren_open,
    STATE(495), 1,
      sym_type,
    STATE(781), 1,
      sym__unboxed_open,
    STATE(1073), 1,
      sym__bracket_open,
    STATE(3177), 1,
      sym__plist,
    STATE(3184), 1,
      sym__type_unboxed_tuple,
    STATE(3188), 1,
      sym__type_unboxed_sum,
    STATE(3196), 1,
      sym__type_apply,
    STATE(3210), 1,
      sym__type_tuple,
    STATE(3211), 1,
      sym__type_list,
    STATE(3220), 1,
      sym__type_parens,
    STATE(3225), 1,
      sym__type_infix,
    STATE(3262), 1,
      sym__qualified_type,
    STATE(3397), 1,
      sym_integer,
    STATE(7401), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11198), 1,
      aux_sym__qualifying_module,
    ACTIONS(1577), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1579), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1583), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3232), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3364), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [14297] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1087), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [14425] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2945), 1,
      sym_variable,
    ACTIONS(2947), 1,
      anon_sym__,
    ACTIONS(2957), 1,
      sym__integer_literal,
    ACTIONS(2963), 1,
      sym__cond_quote_start,
    ACTIONS(4354), 1,
      anon_sym_SQUOTE,
    ACTIONS(4360), 1,
      sym_name,
    STATE(448), 1,
      sym__paren_open,
    STATE(824), 1,
      sym__unboxed_open,
    STATE(1009), 1,
      sym__bracket_open,
    STATE(1117), 1,
      sym_type,
    STATE(7206), 1,
      sym_integer,
    STATE(7207), 1,
      sym__type_infix,
    STATE(7208), 1,
      sym__splice_dollars,
    STATE(7209), 1,
      sym__plist,
    STATE(7237), 1,
      sym__type_apply,
    STATE(7246), 1,
      sym__type_unboxed_sum,
    STATE(7247), 1,
      sym__type_list,
    STATE(7258), 1,
      sym__type_unboxed_tuple,
    STATE(7262), 1,
      sym__type_tuple,
    STATE(7268), 1,
      sym__type_parens,
    STATE(7374), 1,
      sym__qualified_type,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11301), 1,
      aux_sym__qualifying_module,
    ACTIONS(2953), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2955), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2959), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7210), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7269), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [14553] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(309), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1305), 1,
      sym_variable,
    ACTIONS(1307), 1,
      anon_sym__,
    ACTIONS(1317), 1,
      sym__cond_quote_start,
    ACTIONS(4927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4929), 1,
      sym_name,
    STATE(413), 1,
      sym_type,
    STATE(432), 1,
      sym__paren_open,
    STATE(753), 1,
      sym__unboxed_open,
    STATE(1055), 1,
      sym__bracket_open,
    STATE(2693), 1,
      sym__plist,
    STATE(2697), 1,
      sym__qualified_type,
    STATE(2713), 1,
      sym__type_infix,
    STATE(2729), 1,
      sym__type_tuple,
    STATE(2733), 1,
      sym__type_parens,
    STATE(2734), 1,
      sym_integer,
    STATE(2745), 1,
      sym__type_apply,
    STATE(2746), 1,
      sym__type_unboxed_sum,
    STATE(2749), 1,
      sym__type_list,
    STATE(2751), 1,
      sym__type_unboxed_tuple,
    STATE(7364), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10987), 1,
      aux_sym__qualifying_module,
    ACTIONS(1313), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(307), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(311), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(2694), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(2710), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [14681] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1649), 1,
      sym_variable,
    ACTIONS(1651), 1,
      anon_sym__,
    ACTIONS(1661), 1,
      sym__integer_literal,
    ACTIONS(1667), 1,
      sym__cond_quote_start,
    ACTIONS(3357), 1,
      anon_sym_SQUOTE,
    ACTIONS(3361), 1,
      sym_name,
    STATE(465), 1,
      sym__paren_open,
    STATE(509), 1,
      sym_type,
    STATE(772), 1,
      sym__unboxed_open,
    STATE(1069), 1,
      sym__bracket_open,
    STATE(3435), 1,
      sym_integer,
    STATE(3559), 1,
      sym__plist,
    STATE(3561), 1,
      sym__type_infix,
    STATE(3567), 1,
      sym__type_apply,
    STATE(3569), 1,
      sym__type_list,
    STATE(3570), 1,
      sym__type_unboxed_sum,
    STATE(3572), 1,
      sym__type_unboxed_tuple,
    STATE(3576), 1,
      sym__type_tuple,
    STATE(3579), 1,
      sym__type_parens,
    STATE(3610), 1,
      sym__qualified_type,
    STATE(7292), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11208), 1,
      aux_sym__qualifying_module,
    ACTIONS(1657), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1659), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1663), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3556), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3582), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [14809] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1649), 1,
      sym_variable,
    ACTIONS(1651), 1,
      anon_sym__,
    ACTIONS(1661), 1,
      sym__integer_literal,
    ACTIONS(1667), 1,
      sym__cond_quote_start,
    ACTIONS(3357), 1,
      anon_sym_SQUOTE,
    ACTIONS(3361), 1,
      sym_name,
    STATE(465), 1,
      sym__paren_open,
    STATE(501), 1,
      sym_type,
    STATE(772), 1,
      sym__unboxed_open,
    STATE(1069), 1,
      sym__bracket_open,
    STATE(3435), 1,
      sym_integer,
    STATE(3559), 1,
      sym__plist,
    STATE(3561), 1,
      sym__type_infix,
    STATE(3567), 1,
      sym__type_apply,
    STATE(3569), 1,
      sym__type_list,
    STATE(3570), 1,
      sym__type_unboxed_sum,
    STATE(3572), 1,
      sym__type_unboxed_tuple,
    STATE(3576), 1,
      sym__type_tuple,
    STATE(3579), 1,
      sym__type_parens,
    STATE(3610), 1,
      sym__qualified_type,
    STATE(7292), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11208), 1,
      aux_sym__qualifying_module,
    ACTIONS(1657), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1659), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1663), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3556), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3582), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [14937] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3107), 1,
      sym_variable,
    ACTIONS(3109), 1,
      anon_sym__,
    ACTIONS(3119), 1,
      sym__integer_literal,
    ACTIONS(3125), 1,
      sym__cond_quote_start,
    ACTIONS(4378), 1,
      anon_sym_SQUOTE,
    ACTIONS(4380), 1,
      sym_name,
    STATE(455), 1,
      sym__paren_open,
    STATE(770), 1,
      sym__unboxed_open,
    STATE(1090), 1,
      sym__bracket_open,
    STATE(1133), 1,
      sym_type,
    STATE(7345), 1,
      sym__splice_dollars,
    STATE(7492), 1,
      sym__type_unboxed_sum,
    STATE(7497), 1,
      sym__type_unboxed_tuple,
    STATE(7503), 1,
      sym__type_tuple,
    STATE(7505), 1,
      sym__type_parens,
    STATE(7518), 1,
      sym__plist,
    STATE(7528), 1,
      sym__type_list,
    STATE(7534), 1,
      sym__type_infix,
    STATE(7541), 1,
      sym__qualified_type,
    STATE(7542), 1,
      sym_integer,
    STATE(7550), 1,
      sym__type_apply,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11252), 1,
      aux_sym__qualifying_module,
    ACTIONS(3115), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3117), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3121), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7511), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7491), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [15065] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1649), 1,
      sym_variable,
    ACTIONS(1651), 1,
      anon_sym__,
    ACTIONS(1661), 1,
      sym__integer_literal,
    ACTIONS(1667), 1,
      sym__cond_quote_start,
    ACTIONS(3357), 1,
      anon_sym_SQUOTE,
    ACTIONS(3361), 1,
      sym_name,
    STATE(465), 1,
      sym__paren_open,
    STATE(504), 1,
      sym_type,
    STATE(772), 1,
      sym__unboxed_open,
    STATE(1069), 1,
      sym__bracket_open,
    STATE(3435), 1,
      sym_integer,
    STATE(3559), 1,
      sym__plist,
    STATE(3561), 1,
      sym__type_infix,
    STATE(3567), 1,
      sym__type_apply,
    STATE(3569), 1,
      sym__type_list,
    STATE(3570), 1,
      sym__type_unboxed_sum,
    STATE(3572), 1,
      sym__type_unboxed_tuple,
    STATE(3576), 1,
      sym__type_tuple,
    STATE(3579), 1,
      sym__type_parens,
    STATE(3610), 1,
      sym__qualified_type,
    STATE(7292), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11208), 1,
      aux_sym__qualifying_module,
    ACTIONS(1657), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1659), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1663), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3556), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3582), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [15193] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(309), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1305), 1,
      sym_variable,
    ACTIONS(1307), 1,
      anon_sym__,
    ACTIONS(1317), 1,
      sym__cond_quote_start,
    ACTIONS(4927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4929), 1,
      sym_name,
    STATE(412), 1,
      sym_type,
    STATE(432), 1,
      sym__paren_open,
    STATE(753), 1,
      sym__unboxed_open,
    STATE(1055), 1,
      sym__bracket_open,
    STATE(2693), 1,
      sym__plist,
    STATE(2697), 1,
      sym__qualified_type,
    STATE(2713), 1,
      sym__type_infix,
    STATE(2729), 1,
      sym__type_tuple,
    STATE(2733), 1,
      sym__type_parens,
    STATE(2734), 1,
      sym_integer,
    STATE(2745), 1,
      sym__type_apply,
    STATE(2746), 1,
      sym__type_unboxed_sum,
    STATE(2749), 1,
      sym__type_list,
    STATE(2751), 1,
      sym__type_unboxed_tuple,
    STATE(7364), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10987), 1,
      aux_sym__qualifying_module,
    ACTIONS(1313), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(307), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(311), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(2694), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(2710), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [15321] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(909), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1753), 1,
      anon_sym__,
    ACTIONS(1757), 1,
      sym_variable,
    ACTIONS(1765), 1,
      sym__cond_quote_start,
    ACTIONS(4903), 1,
      anon_sym_SQUOTE,
    ACTIONS(4905), 1,
      sym_name,
    STATE(471), 1,
      sym__paren_open,
    STATE(550), 1,
      sym_type,
    STATE(778), 1,
      sym__unboxed_open,
    STATE(1071), 1,
      sym__bracket_open,
    STATE(4235), 1,
      sym__plist,
    STATE(4241), 1,
      sym__type_infix,
    STATE(4248), 1,
      sym__qualified_type,
    STATE(4258), 1,
      sym__type_parens,
    STATE(4261), 1,
      sym__type_tuple,
    STATE(4262), 1,
      sym__type_unboxed_tuple,
    STATE(4263), 1,
      sym__type_unboxed_sum,
    STATE(4264), 1,
      sym__type_list,
    STATE(4265), 1,
      sym__type_apply,
    STATE(4282), 1,
      sym_integer,
    STATE(7317), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11227), 1,
      aux_sym__qualifying_module,
    ACTIONS(1755), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(907), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(911), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4275), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4257), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [15449] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(909), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1753), 1,
      anon_sym__,
    ACTIONS(1757), 1,
      sym_variable,
    ACTIONS(1765), 1,
      sym__cond_quote_start,
    ACTIONS(4903), 1,
      anon_sym_SQUOTE,
    ACTIONS(4905), 1,
      sym_name,
    STATE(471), 1,
      sym__paren_open,
    STATE(549), 1,
      sym_type,
    STATE(778), 1,
      sym__unboxed_open,
    STATE(1071), 1,
      sym__bracket_open,
    STATE(4235), 1,
      sym__plist,
    STATE(4241), 1,
      sym__type_infix,
    STATE(4248), 1,
      sym__qualified_type,
    STATE(4258), 1,
      sym__type_parens,
    STATE(4261), 1,
      sym__type_tuple,
    STATE(4262), 1,
      sym__type_unboxed_tuple,
    STATE(4263), 1,
      sym__type_unboxed_sum,
    STATE(4264), 1,
      sym__type_list,
    STATE(4265), 1,
      sym__type_apply,
    STATE(4282), 1,
      sym_integer,
    STATE(7317), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11227), 1,
      aux_sym__qualifying_module,
    ACTIONS(1755), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(907), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(911), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4275), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4257), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [15577] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2573), 1,
      sym_variable,
    ACTIONS(2575), 1,
      anon_sym__,
    ACTIONS(2585), 1,
      sym__integer_literal,
    ACTIONS(2591), 1,
      sym__cond_quote_start,
    ACTIONS(3555), 1,
      anon_sym_SQUOTE,
    ACTIONS(3561), 1,
      sym_name,
    STATE(446), 1,
      sym__paren_open,
    STATE(803), 1,
      sym__unboxed_open,
    STATE(836), 1,
      sym_type,
    STATE(965), 1,
      sym__bracket_open,
    STATE(6574), 1,
      sym__type_list,
    STATE(6595), 1,
      sym__qualified_type,
    STATE(6634), 1,
      sym_integer,
    STATE(6681), 1,
      sym__plist,
    STATE(6682), 1,
      sym__type_infix,
    STATE(6683), 1,
      sym__type_apply,
    STATE(6685), 1,
      sym__type_unboxed_sum,
    STATE(6686), 1,
      sym__type_unboxed_tuple,
    STATE(6687), 1,
      sym__type_tuple,
    STATE(6688), 1,
      sym__type_parens,
    STATE(7266), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11009), 1,
      aux_sym__qualifying_module,
    ACTIONS(2581), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2583), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2587), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6680), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6689), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [15705] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(565), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1689), 1,
      anon_sym__,
    ACTIONS(1693), 1,
      sym_variable,
    ACTIONS(1703), 1,
      sym__cond_quote_start,
    ACTIONS(4915), 1,
      anon_sym_SQUOTE,
    ACTIONS(4917), 1,
      sym_name,
    STATE(462), 1,
      sym__paren_open,
    STATE(516), 1,
      sym_type,
    STATE(768), 1,
      sym__unboxed_open,
    STATE(1063), 1,
      sym__bracket_open,
    STATE(3701), 1,
      sym__type_parens,
    STATE(3702), 1,
      sym__type_tuple,
    STATE(3703), 1,
      sym__qualified_type,
    STATE(3709), 1,
      sym__type_unboxed_tuple,
    STATE(3711), 1,
      sym__type_unboxed_sum,
    STATE(3712), 1,
      sym__type_list,
    STATE(3715), 1,
      sym__type_apply,
    STATE(3717), 1,
      sym__type_infix,
    STATE(3718), 1,
      sym__plist,
    STATE(3781), 1,
      sym_integer,
    STATE(7323), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11219), 1,
      aux_sym__qualifying_module,
    ACTIONS(1691), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(563), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(567), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3721), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3699), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [15833] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3057), 1,
      sym_variable,
    ACTIONS(3059), 1,
      anon_sym__,
    ACTIONS(3063), 1,
      sym__integer_literal,
    ACTIONS(3069), 1,
      sym__cond_quote_start,
    ACTIONS(4939), 1,
      anon_sym_SQUOTE,
    ACTIONS(4941), 1,
      sym_name,
    STATE(474), 1,
      sym__paren_open,
    STATE(733), 1,
      sym__unboxed_open,
    STATE(1092), 1,
      sym_type,
    STATE(1124), 1,
      sym__bracket_open,
    STATE(7240), 1,
      sym__type_infix,
    STATE(7267), 1,
      sym__qualified_type,
    STATE(7270), 1,
      sym__splice_dollars,
    STATE(7274), 1,
      sym_integer,
    STATE(7416), 1,
      sym__type_parens,
    STATE(7417), 1,
      sym__type_tuple,
    STATE(7424), 1,
      sym__type_unboxed_tuple,
    STATE(7426), 1,
      sym__type_unboxed_sum,
    STATE(7427), 1,
      sym__type_list,
    STATE(7428), 1,
      sym__type_apply,
    STATE(7429), 1,
      sym__plist,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10936), 1,
      aux_sym__qualifying_module,
    ACTIONS(3055), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3061), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3065), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7438), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7415), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [15961] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(565), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1689), 1,
      anon_sym__,
    ACTIONS(1693), 1,
      sym_variable,
    ACTIONS(1703), 1,
      sym__cond_quote_start,
    ACTIONS(4915), 1,
      anon_sym_SQUOTE,
    ACTIONS(4917), 1,
      sym_name,
    STATE(462), 1,
      sym__paren_open,
    STATE(518), 1,
      sym_type,
    STATE(768), 1,
      sym__unboxed_open,
    STATE(1063), 1,
      sym__bracket_open,
    STATE(3701), 1,
      sym__type_parens,
    STATE(3702), 1,
      sym__type_tuple,
    STATE(3703), 1,
      sym__qualified_type,
    STATE(3709), 1,
      sym__type_unboxed_tuple,
    STATE(3711), 1,
      sym__type_unboxed_sum,
    STATE(3712), 1,
      sym__type_list,
    STATE(3715), 1,
      sym__type_apply,
    STATE(3717), 1,
      sym__type_infix,
    STATE(3718), 1,
      sym__plist,
    STATE(3781), 1,
      sym_integer,
    STATE(7323), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11219), 1,
      aux_sym__qualifying_module,
    ACTIONS(1691), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(563), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(567), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3721), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3699), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [16089] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(565), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1689), 1,
      anon_sym__,
    ACTIONS(1693), 1,
      sym_variable,
    ACTIONS(1703), 1,
      sym__cond_quote_start,
    ACTIONS(4915), 1,
      anon_sym_SQUOTE,
    ACTIONS(4917), 1,
      sym_name,
    STATE(462), 1,
      sym__paren_open,
    STATE(514), 1,
      sym_type,
    STATE(768), 1,
      sym__unboxed_open,
    STATE(1063), 1,
      sym__bracket_open,
    STATE(3701), 1,
      sym__type_parens,
    STATE(3702), 1,
      sym__type_tuple,
    STATE(3703), 1,
      sym__qualified_type,
    STATE(3709), 1,
      sym__type_unboxed_tuple,
    STATE(3711), 1,
      sym__type_unboxed_sum,
    STATE(3712), 1,
      sym__type_list,
    STATE(3715), 1,
      sym__type_apply,
    STATE(3717), 1,
      sym__type_infix,
    STATE(3718), 1,
      sym__plist,
    STATE(3781), 1,
      sym_integer,
    STATE(7323), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11219), 1,
      aux_sym__qualifying_module,
    ACTIONS(1691), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(563), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(567), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3721), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3699), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [16217] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3247), 1,
      sym_variable,
    ACTIONS(3249), 1,
      anon_sym__,
    ACTIONS(3259), 1,
      sym__integer_literal,
    ACTIONS(3265), 1,
      sym__cond_quote_start,
    ACTIONS(4477), 1,
      anon_sym_SQUOTE,
    ACTIONS(4479), 1,
      sym_name,
    STATE(463), 1,
      sym__paren_open,
    STATE(825), 1,
      sym__unboxed_open,
    STATE(1066), 1,
      sym__bracket_open,
    STATE(1392), 1,
      sym_type,
    STATE(7311), 1,
      sym__splice_dollars,
    STATE(7653), 1,
      sym_integer,
    STATE(7676), 1,
      sym__plist,
    STATE(7677), 1,
      sym__qualified_type,
    STATE(7686), 1,
      sym__type_unboxed_tuple,
    STATE(7690), 1,
      sym__type_apply,
    STATE(7696), 1,
      sym__type_list,
    STATE(7703), 1,
      sym__type_unboxed_sum,
    STATE(7716), 1,
      sym__type_infix,
    STATE(7721), 1,
      sym__type_tuple,
    STATE(7722), 1,
      sym__type_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10972), 1,
      aux_sym__qualifying_module,
    ACTIONS(3255), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3257), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3261), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7664), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7670), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [16345] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2305), 1,
      sym_variable,
    ACTIONS(2307), 1,
      anon_sym__,
    ACTIONS(2317), 1,
      sym__integer_literal,
    ACTIONS(2323), 1,
      sym__cond_quote_start,
    ACTIONS(3445), 1,
      anon_sym_SQUOTE,
    ACTIONS(3449), 1,
      sym_name,
    STATE(429), 1,
      sym__paren_open,
    STATE(755), 1,
      sym__unboxed_open,
    STATE(782), 1,
      sym_type,
    STATE(1061), 1,
      sym__bracket_open,
    STATE(6275), 1,
      sym__plist,
    STATE(6276), 1,
      sym__type_infix,
    STATE(6277), 1,
      sym__type_apply,
    STATE(6278), 1,
      sym__type_list,
    STATE(6279), 1,
      sym__type_unboxed_sum,
    STATE(6280), 1,
      sym__type_unboxed_tuple,
    STATE(6281), 1,
      sym__type_tuple,
    STATE(6282), 1,
      sym__type_parens,
    STATE(6310), 1,
      sym__qualified_type,
    STATE(6535), 1,
      sym_integer,
    STATE(7421), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11228), 1,
      aux_sym__qualifying_module,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2315), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2319), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6273), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6283), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [16473] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2305), 1,
      sym_variable,
    ACTIONS(2307), 1,
      anon_sym__,
    ACTIONS(2317), 1,
      sym__integer_literal,
    ACTIONS(2323), 1,
      sym__cond_quote_start,
    ACTIONS(3445), 1,
      anon_sym_SQUOTE,
    ACTIONS(3449), 1,
      sym_name,
    STATE(429), 1,
      sym__paren_open,
    STATE(755), 1,
      sym__unboxed_open,
    STATE(785), 1,
      sym_type,
    STATE(1061), 1,
      sym__bracket_open,
    STATE(6275), 1,
      sym__plist,
    STATE(6276), 1,
      sym__type_infix,
    STATE(6277), 1,
      sym__type_apply,
    STATE(6278), 1,
      sym__type_list,
    STATE(6279), 1,
      sym__type_unboxed_sum,
    STATE(6280), 1,
      sym__type_unboxed_tuple,
    STATE(6281), 1,
      sym__type_tuple,
    STATE(6282), 1,
      sym__type_parens,
    STATE(6310), 1,
      sym__qualified_type,
    STATE(6535), 1,
      sym_integer,
    STATE(7421), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11228), 1,
      aux_sym__qualifying_module,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2315), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2319), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6273), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6283), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [16601] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(909), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1753), 1,
      anon_sym__,
    ACTIONS(1757), 1,
      sym_variable,
    ACTIONS(1765), 1,
      sym__cond_quote_start,
    ACTIONS(4903), 1,
      anon_sym_SQUOTE,
    ACTIONS(4905), 1,
      sym_name,
    STATE(471), 1,
      sym__paren_open,
    STATE(548), 1,
      sym_type,
    STATE(778), 1,
      sym__unboxed_open,
    STATE(1071), 1,
      sym__bracket_open,
    STATE(4235), 1,
      sym__plist,
    STATE(4241), 1,
      sym__type_infix,
    STATE(4248), 1,
      sym__qualified_type,
    STATE(4258), 1,
      sym__type_parens,
    STATE(4261), 1,
      sym__type_tuple,
    STATE(4262), 1,
      sym__type_unboxed_tuple,
    STATE(4263), 1,
      sym__type_unboxed_sum,
    STATE(4264), 1,
      sym__type_list,
    STATE(4265), 1,
      sym__type_apply,
    STATE(4282), 1,
      sym_integer,
    STATE(7317), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11227), 1,
      aux_sym__qualifying_module,
    ACTIONS(1755), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(907), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(911), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4275), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4257), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [16729] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4943), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4945), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [16805] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2305), 1,
      sym_variable,
    ACTIONS(2307), 1,
      anon_sym__,
    ACTIONS(2317), 1,
      sym__integer_literal,
    ACTIONS(2323), 1,
      sym__cond_quote_start,
    ACTIONS(3445), 1,
      anon_sym_SQUOTE,
    ACTIONS(3449), 1,
      sym_name,
    STATE(429), 1,
      sym__paren_open,
    STATE(755), 1,
      sym__unboxed_open,
    STATE(790), 1,
      sym_type,
    STATE(1061), 1,
      sym__bracket_open,
    STATE(6275), 1,
      sym__plist,
    STATE(6276), 1,
      sym__type_infix,
    STATE(6277), 1,
      sym__type_apply,
    STATE(6278), 1,
      sym__type_list,
    STATE(6279), 1,
      sym__type_unboxed_sum,
    STATE(6280), 1,
      sym__type_unboxed_tuple,
    STATE(6281), 1,
      sym__type_tuple,
    STATE(6282), 1,
      sym__type_parens,
    STATE(6310), 1,
      sym__qualified_type,
    STATE(6535), 1,
      sym_integer,
    STATE(7421), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11228), 1,
      aux_sym__qualifying_module,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2315), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2319), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6273), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6283), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [16933] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2781), 1,
      sym_variable,
    ACTIONS(2783), 1,
      anon_sym__,
    ACTIONS(2793), 1,
      sym__integer_literal,
    ACTIONS(2799), 1,
      sym__cond_quote_start,
    ACTIONS(3433), 1,
      anon_sym_SQUOTE,
    ACTIONS(3437), 1,
      sym_name,
    STATE(473), 1,
      sym__paren_open,
    STATE(799), 1,
      sym__unboxed_open,
    STATE(928), 1,
      sym_type,
    STATE(1082), 1,
      sym__bracket_open,
    STATE(7124), 1,
      sym__plist,
    STATE(7130), 1,
      sym__type_infix,
    STATE(7132), 1,
      sym__type_apply,
    STATE(7133), 1,
      sym__type_list,
    STATE(7135), 1,
      sym__type_unboxed_sum,
    STATE(7137), 1,
      sym__type_unboxed_tuple,
    STATE(7138), 1,
      sym__type_tuple,
    STATE(7152), 1,
      sym__type_parens,
    STATE(7159), 1,
      sym_integer,
    STATE(7160), 1,
      sym__qualified_type,
    STATE(7456), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10934), 1,
      aux_sym__qualifying_module,
    ACTIONS(2789), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2791), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2795), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7122), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7020), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [17061] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(765), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1739), 1,
      anon_sym__,
    ACTIONS(1743), 1,
      sym_variable,
    ACTIONS(1751), 1,
      sym__cond_quote_start,
    ACTIONS(4947), 1,
      anon_sym_SQUOTE,
    ACTIONS(4949), 1,
      sym_name,
    STATE(470), 1,
      sym__paren_open,
    STATE(546), 1,
      sym_type,
    STATE(734), 1,
      sym__unboxed_open,
    STATE(1007), 1,
      sym__bracket_open,
    STATE(3988), 1,
      sym__type_unboxed_tuple,
    STATE(4020), 1,
      sym__type_tuple,
    STATE(4027), 1,
      sym__type_parens,
    STATE(4041), 1,
      sym__plist,
    STATE(4047), 1,
      sym__type_apply,
    STATE(4056), 1,
      sym__type_list,
    STATE(4061), 1,
      sym__qualified_type,
    STATE(4088), 1,
      sym__type_infix,
    STATE(4148), 1,
      sym_integer,
    STATE(4177), 1,
      sym__type_unboxed_sum,
    STATE(7343), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11047), 1,
      aux_sym__qualifying_module,
    ACTIONS(1741), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(763), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(767), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4046), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4029), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [17189] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1847), 1,
      sym_variable,
    ACTIONS(1849), 1,
      anon_sym__,
    ACTIONS(1859), 1,
      sym__integer_literal,
    ACTIONS(1865), 1,
      sym__cond_quote_start,
    ACTIONS(4951), 1,
      anon_sym_SQUOTE,
    ACTIONS(4953), 1,
      sym_name,
    STATE(454), 1,
      sym__paren_open,
    STATE(649), 1,
      sym_type,
    STATE(749), 1,
      sym__unboxed_open,
    STATE(1050), 1,
      sym__bracket_open,
    STATE(5812), 1,
      sym__type_tuple,
    STATE(5845), 1,
      sym_integer,
    STATE(5853), 1,
      sym__qualified_type,
    STATE(5859), 1,
      sym__type_list,
    STATE(5860), 1,
      sym__type_apply,
    STATE(5862), 1,
      sym__type_infix,
    STATE(5864), 1,
      sym__plist,
    STATE(5871), 1,
      sym__type_parens,
    STATE(5874), 1,
      sym__type_unboxed_tuple,
    STATE(5875), 1,
      sym__type_unboxed_sum,
    STATE(7272), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11241), 1,
      aux_sym__qualifying_module,
    ACTIONS(1855), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1857), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1861), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5869), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5866), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [17317] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1847), 1,
      sym_variable,
    ACTIONS(1849), 1,
      anon_sym__,
    ACTIONS(1859), 1,
      sym__integer_literal,
    ACTIONS(1865), 1,
      sym__cond_quote_start,
    ACTIONS(4951), 1,
      anon_sym_SQUOTE,
    ACTIONS(4953), 1,
      sym_name,
    STATE(454), 1,
      sym__paren_open,
    STATE(648), 1,
      sym_type,
    STATE(749), 1,
      sym__unboxed_open,
    STATE(1050), 1,
      sym__bracket_open,
    STATE(5812), 1,
      sym__type_tuple,
    STATE(5845), 1,
      sym_integer,
    STATE(5853), 1,
      sym__qualified_type,
    STATE(5859), 1,
      sym__type_list,
    STATE(5860), 1,
      sym__type_apply,
    STATE(5862), 1,
      sym__type_infix,
    STATE(5864), 1,
      sym__plist,
    STATE(5871), 1,
      sym__type_parens,
    STATE(5874), 1,
      sym__type_unboxed_tuple,
    STATE(5875), 1,
      sym__type_unboxed_sum,
    STATE(7272), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11241), 1,
      aux_sym__qualifying_module,
    ACTIONS(1855), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1857), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1861), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5869), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5866), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [17445] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(721), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1725), 1,
      sym_variable,
    ACTIONS(1727), 1,
      anon_sym__,
    ACTIONS(1737), 1,
      sym__cond_quote_start,
    ACTIONS(4935), 1,
      anon_sym_SQUOTE,
    ACTIONS(4937), 1,
      sym_name,
    STATE(444), 1,
      sym__paren_open,
    STATE(544), 1,
      sym_type,
    STATE(787), 1,
      sym__unboxed_open,
    STATE(1041), 1,
      sym__bracket_open,
    STATE(4078), 1,
      sym__type_parens,
    STATE(4080), 1,
      sym__type_tuple,
    STATE(4081), 1,
      sym__type_unboxed_tuple,
    STATE(4082), 1,
      sym__type_unboxed_sum,
    STATE(4084), 1,
      sym__type_list,
    STATE(4085), 1,
      sym__type_apply,
    STATE(4097), 1,
      sym__plist,
    STATE(4133), 1,
      sym__type_infix,
    STATE(4138), 1,
      sym__qualified_type,
    STATE(4193), 1,
      sym_integer,
    STATE(7390), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11143), 1,
      aux_sym__qualifying_module,
    ACTIONS(1733), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(719), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(723), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4098), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4075), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [17573] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1826), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(7638), 1,
      sym__type_infix,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [17701] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(721), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1725), 1,
      sym_variable,
    ACTIONS(1727), 1,
      anon_sym__,
    ACTIONS(1737), 1,
      sym__cond_quote_start,
    ACTIONS(4935), 1,
      anon_sym_SQUOTE,
    ACTIONS(4937), 1,
      sym_name,
    STATE(444), 1,
      sym__paren_open,
    STATE(540), 1,
      sym_type,
    STATE(787), 1,
      sym__unboxed_open,
    STATE(1041), 1,
      sym__bracket_open,
    STATE(4078), 1,
      sym__type_parens,
    STATE(4080), 1,
      sym__type_tuple,
    STATE(4081), 1,
      sym__type_unboxed_tuple,
    STATE(4082), 1,
      sym__type_unboxed_sum,
    STATE(4084), 1,
      sym__type_list,
    STATE(4085), 1,
      sym__type_apply,
    STATE(4097), 1,
      sym__plist,
    STATE(4133), 1,
      sym__type_infix,
    STATE(4138), 1,
      sym__qualified_type,
    STATE(4193), 1,
      sym_integer,
    STATE(7390), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11143), 1,
      aux_sym__qualifying_module,
    ACTIONS(1733), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(719), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(723), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4098), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4075), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [17829] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(721), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1725), 1,
      sym_variable,
    ACTIONS(1727), 1,
      anon_sym__,
    ACTIONS(1737), 1,
      sym__cond_quote_start,
    ACTIONS(4935), 1,
      anon_sym_SQUOTE,
    ACTIONS(4937), 1,
      sym_name,
    STATE(444), 1,
      sym__paren_open,
    STATE(528), 1,
      sym_type,
    STATE(787), 1,
      sym__unboxed_open,
    STATE(1041), 1,
      sym__bracket_open,
    STATE(4078), 1,
      sym__type_parens,
    STATE(4080), 1,
      sym__type_tuple,
    STATE(4081), 1,
      sym__type_unboxed_tuple,
    STATE(4082), 1,
      sym__type_unboxed_sum,
    STATE(4084), 1,
      sym__type_list,
    STATE(4085), 1,
      sym__type_apply,
    STATE(4097), 1,
      sym__plist,
    STATE(4133), 1,
      sym__type_infix,
    STATE(4138), 1,
      sym__qualified_type,
    STATE(4193), 1,
      sym_integer,
    STATE(7390), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11143), 1,
      aux_sym__qualifying_module,
    ACTIONS(1733), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(719), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(723), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4098), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4075), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [17957] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1975), 1,
      sym_variable,
    ACTIONS(1977), 1,
      anon_sym__,
    ACTIONS(1981), 1,
      sym__integer_literal,
    ACTIONS(1987), 1,
      sym__cond_quote_start,
    ACTIONS(4891), 1,
      anon_sym_SQUOTE,
    ACTIONS(4893), 1,
      sym_name,
    STATE(436), 1,
      sym__paren_open,
    STATE(688), 1,
      sym_type,
    STATE(752), 1,
      sym__unboxed_open,
    STATE(971), 1,
      sym__bracket_open,
    STATE(6083), 1,
      sym__qualified_type,
    STATE(6128), 1,
      sym_integer,
    STATE(6134), 1,
      sym__type_parens,
    STATE(6135), 1,
      sym__type_tuple,
    STATE(6136), 1,
      sym__type_unboxed_tuple,
    STATE(6137), 1,
      sym__type_unboxed_sum,
    STATE(6138), 1,
      sym__type_list,
    STATE(6139), 1,
      sym__type_apply,
    STATE(6140), 1,
      sym__type_infix,
    STATE(6141), 1,
      sym__plist,
    STATE(7279), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11268), 1,
      aux_sym__qualifying_module,
    ACTIONS(1973), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1979), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1983), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6142), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6132), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [18085] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1847), 1,
      sym_variable,
    ACTIONS(1849), 1,
      anon_sym__,
    ACTIONS(1859), 1,
      sym__integer_literal,
    ACTIONS(1865), 1,
      sym__cond_quote_start,
    ACTIONS(4951), 1,
      anon_sym_SQUOTE,
    ACTIONS(4953), 1,
      sym_name,
    STATE(454), 1,
      sym__paren_open,
    STATE(650), 1,
      sym_type,
    STATE(749), 1,
      sym__unboxed_open,
    STATE(1050), 1,
      sym__bracket_open,
    STATE(5812), 1,
      sym__type_tuple,
    STATE(5845), 1,
      sym_integer,
    STATE(5853), 1,
      sym__qualified_type,
    STATE(5859), 1,
      sym__type_list,
    STATE(5860), 1,
      sym__type_apply,
    STATE(5862), 1,
      sym__type_infix,
    STATE(5864), 1,
      sym__plist,
    STATE(5871), 1,
      sym__type_parens,
    STATE(5874), 1,
      sym__type_unboxed_tuple,
    STATE(5875), 1,
      sym__type_unboxed_sum,
    STATE(7272), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11241), 1,
      aux_sym__qualifying_module,
    ACTIONS(1855), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1857), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1861), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5869), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5866), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [18213] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1018), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [18341] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1006), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [18469] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(765), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1739), 1,
      anon_sym__,
    ACTIONS(1743), 1,
      sym_variable,
    ACTIONS(1751), 1,
      sym__cond_quote_start,
    ACTIONS(4947), 1,
      anon_sym_SQUOTE,
    ACTIONS(4949), 1,
      sym_name,
    STATE(470), 1,
      sym__paren_open,
    STATE(538), 1,
      sym_type,
    STATE(734), 1,
      sym__unboxed_open,
    STATE(1007), 1,
      sym__bracket_open,
    STATE(3988), 1,
      sym__type_unboxed_tuple,
    STATE(4020), 1,
      sym__type_tuple,
    STATE(4027), 1,
      sym__type_parens,
    STATE(4041), 1,
      sym__plist,
    STATE(4047), 1,
      sym__type_apply,
    STATE(4056), 1,
      sym__type_list,
    STATE(4061), 1,
      sym__qualified_type,
    STATE(4088), 1,
      sym__type_infix,
    STATE(4148), 1,
      sym_integer,
    STATE(4177), 1,
      sym__type_unboxed_sum,
    STATE(7343), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11047), 1,
      aux_sym__qualifying_module,
    ACTIONS(1741), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(763), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(767), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4046), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4029), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [18597] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(765), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1739), 1,
      anon_sym__,
    ACTIONS(1743), 1,
      sym_variable,
    ACTIONS(1751), 1,
      sym__cond_quote_start,
    ACTIONS(4947), 1,
      anon_sym_SQUOTE,
    ACTIONS(4949), 1,
      sym_name,
    STATE(470), 1,
      sym__paren_open,
    STATE(532), 1,
      sym_type,
    STATE(734), 1,
      sym__unboxed_open,
    STATE(1007), 1,
      sym__bracket_open,
    STATE(3988), 1,
      sym__type_unboxed_tuple,
    STATE(4020), 1,
      sym__type_tuple,
    STATE(4027), 1,
      sym__type_parens,
    STATE(4041), 1,
      sym__plist,
    STATE(4047), 1,
      sym__type_apply,
    STATE(4056), 1,
      sym__type_list,
    STATE(4061), 1,
      sym__qualified_type,
    STATE(4088), 1,
      sym__type_infix,
    STATE(4148), 1,
      sym_integer,
    STATE(4177), 1,
      sym__type_unboxed_sum,
    STATE(7343), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11047), 1,
      aux_sym__qualifying_module,
    ACTIONS(1741), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(763), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(767), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4046), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4029), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [18725] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(765), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1739), 1,
      anon_sym__,
    ACTIONS(1743), 1,
      sym_variable,
    ACTIONS(1751), 1,
      sym__cond_quote_start,
    ACTIONS(4947), 1,
      anon_sym_SQUOTE,
    ACTIONS(4949), 1,
      sym_name,
    STATE(470), 1,
      sym__paren_open,
    STATE(537), 1,
      sym_type,
    STATE(734), 1,
      sym__unboxed_open,
    STATE(1007), 1,
      sym__bracket_open,
    STATE(3988), 1,
      sym__type_unboxed_tuple,
    STATE(4020), 1,
      sym__type_tuple,
    STATE(4027), 1,
      sym__type_parens,
    STATE(4041), 1,
      sym__plist,
    STATE(4047), 1,
      sym__type_apply,
    STATE(4056), 1,
      sym__type_list,
    STATE(4061), 1,
      sym__qualified_type,
    STATE(4088), 1,
      sym__type_infix,
    STATE(4148), 1,
      sym_integer,
    STATE(4177), 1,
      sym__type_unboxed_sum,
    STATE(7343), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11047), 1,
      aux_sym__qualifying_module,
    ACTIONS(1741), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(763), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(767), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4046), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4029), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [18853] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1003), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [18981] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3203), 1,
      sym_variable,
    ACTIONS(3205), 1,
      anon_sym__,
    ACTIONS(3215), 1,
      sym__integer_literal,
    ACTIONS(3221), 1,
      sym__cond_quote_start,
    ACTIONS(4140), 1,
      anon_sym_SQUOTE,
    ACTIONS(4144), 1,
      sym_name,
    STATE(434), 1,
      sym__paren_open,
    STATE(763), 1,
      sym__unboxed_open,
    STATE(963), 1,
      sym__bracket_open,
    STATE(1246), 1,
      sym_type,
    STATE(7479), 1,
      sym__splice_dollars,
    STATE(7579), 1,
      sym__plist,
    STATE(7580), 1,
      sym__type_infix,
    STATE(7581), 1,
      sym__type_apply,
    STATE(7585), 1,
      sym__type_parens,
    STATE(7587), 1,
      sym__qualified_type,
    STATE(7589), 1,
      sym__type_list,
    STATE(7591), 1,
      sym__type_unboxed_sum,
    STATE(7595), 1,
      sym_integer,
    STATE(7602), 1,
      sym__type_tuple,
    STATE(7615), 1,
      sym__type_unboxed_tuple,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10889), 1,
      aux_sym__qualifying_module,
    ACTIONS(3211), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3213), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3217), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7569), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7555), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [19109] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1121), 1,
      sym_variable,
    ACTIONS(1127), 1,
      anon_sym__,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1141), 1,
      sym__integer_literal,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1153), 1,
      sym__cond_quote_start,
    ACTIONS(3317), 1,
      anon_sym_SQUOTE,
    ACTIONS(3321), 1,
      sym_name,
    STATE(335), 1,
      sym_type,
    STATE(445), 1,
      sym__paren_open,
    STATE(740), 1,
      sym__unboxed_open,
    STATE(1047), 1,
      sym__bracket_open,
    STATE(2318), 1,
      sym_integer,
    STATE(2335), 1,
      sym__type_parens,
    STATE(2337), 1,
      sym__type_tuple,
    STATE(2338), 1,
      sym__type_unboxed_tuple,
    STATE(2341), 1,
      sym__type_unboxed_sum,
    STATE(2342), 1,
      sym__type_list,
    STATE(2343), 1,
      sym__qualified_type,
    STATE(2350), 1,
      sym__plist,
    STATE(2352), 1,
      sym__type_infix,
    STATE(2353), 1,
      sym__type_apply,
    STATE(7396), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11256), 1,
      aux_sym__qualifying_module,
    ACTIONS(1133), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1139), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1143), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(2348), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(2327), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [19237] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1121), 1,
      sym_variable,
    ACTIONS(1127), 1,
      anon_sym__,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1141), 1,
      sym__integer_literal,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1153), 1,
      sym__cond_quote_start,
    ACTIONS(3317), 1,
      anon_sym_SQUOTE,
    ACTIONS(3321), 1,
      sym_name,
    STATE(333), 1,
      sym_type,
    STATE(445), 1,
      sym__paren_open,
    STATE(740), 1,
      sym__unboxed_open,
    STATE(1047), 1,
      sym__bracket_open,
    STATE(2318), 1,
      sym_integer,
    STATE(2335), 1,
      sym__type_parens,
    STATE(2337), 1,
      sym__type_tuple,
    STATE(2338), 1,
      sym__type_unboxed_tuple,
    STATE(2341), 1,
      sym__type_unboxed_sum,
    STATE(2342), 1,
      sym__type_list,
    STATE(2343), 1,
      sym__qualified_type,
    STATE(2350), 1,
      sym__plist,
    STATE(2352), 1,
      sym__type_infix,
    STATE(2353), 1,
      sym__type_apply,
    STATE(7396), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11256), 1,
      aux_sym__qualifying_module,
    ACTIONS(1133), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1139), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1143), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(2348), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(2327), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [19365] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1669), 1,
      sym_variable,
    ACTIONS(1671), 1,
      anon_sym__,
    ACTIONS(1681), 1,
      sym__integer_literal,
    ACTIONS(1687), 1,
      sym__cond_quote_start,
    ACTIONS(3419), 1,
      anon_sym_SQUOTE,
    ACTIONS(3423), 1,
      sym_name,
    STATE(461), 1,
      sym__paren_open,
    STATE(507), 1,
      sym_type,
    STATE(829), 1,
      sym__unboxed_open,
    STATE(1131), 1,
      sym__bracket_open,
    STATE(3509), 1,
      sym_integer,
    STATE(3557), 1,
      sym__type_parens,
    STATE(3597), 1,
      sym__plist,
    STATE(3602), 1,
      sym__type_infix,
    STATE(3604), 1,
      sym__type_apply,
    STATE(3605), 1,
      sym__type_list,
    STATE(3606), 1,
      sym__type_unboxed_sum,
    STATE(3607), 1,
      sym__type_unboxed_tuple,
    STATE(3612), 1,
      sym__type_tuple,
    STATE(3643), 1,
      sym__qualified_type,
    STATE(7350), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11140), 1,
      aux_sym__qualifying_module,
    ACTIONS(1677), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1679), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1683), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3583), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3638), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [19493] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1989), 1,
      sym_variable,
    ACTIONS(1993), 1,
      anon_sym__,
    ACTIONS(1995), 1,
      anon_sym_SQUOTE,
    ACTIONS(2003), 1,
      sym__integer_literal,
    ACTIONS(2011), 1,
      sym_name,
    ACTIONS(2015), 1,
      sym__cond_quote_start,
    STATE(449), 1,
      sym__paren_open,
    STATE(767), 1,
      sym_type,
    STATE(769), 1,
      sym__unboxed_open,
    STATE(1028), 1,
      sym__bracket_open,
    STATE(6258), 1,
      sym_integer,
    STATE(6404), 1,
      sym__type_infix,
    STATE(6456), 1,
      sym__qualified_type,
    STATE(6473), 1,
      sym__type_parens,
    STATE(6477), 1,
      sym__type_tuple,
    STATE(6479), 1,
      sym__type_unboxed_tuple,
    STATE(6480), 1,
      sym__type_unboxed_sum,
    STATE(6481), 1,
      sym__type_list,
    STATE(6483), 1,
      sym__type_apply,
    STATE(6490), 1,
      sym__plist,
    STATE(7378), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11091), 1,
      aux_sym__qualifying_module,
    ACTIONS(1997), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2001), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2005), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6494), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6470), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [19621] = 5,
    STATE(2889), 1,
      sym_alternatives,
    ACTIONS(4959), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4955), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4957), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [19695] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1819), 1,
      sym_variable,
    ACTIONS(1821), 1,
      anon_sym__,
    ACTIONS(1825), 1,
      sym__integer_literal,
    ACTIONS(1831), 1,
      sym__cond_quote_start,
    ACTIONS(4961), 1,
      anon_sym_SQUOTE,
    ACTIONS(4963), 1,
      sym_name,
    STATE(476), 1,
      sym__paren_open,
    STATE(579), 1,
      sym_type,
    STATE(802), 1,
      sym__unboxed_open,
    STATE(987), 1,
      sym__bracket_open,
    STATE(4880), 1,
      sym__type_parens,
    STATE(4881), 1,
      sym__type_tuple,
    STATE(4882), 1,
      sym__type_unboxed_tuple,
    STATE(4885), 1,
      sym__type_unboxed_sum,
    STATE(4886), 1,
      sym__type_list,
    STATE(4887), 1,
      sym__type_apply,
    STATE(4890), 1,
      sym__type_infix,
    STATE(4891), 1,
      sym__plist,
    STATE(5078), 1,
      sym__qualified_type,
    STATE(5100), 1,
      sym_integer,
    STATE(7289), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10957), 1,
      aux_sym__qualifying_module,
    ACTIONS(1817), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1823), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1827), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4892), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4879), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [19823] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1819), 1,
      sym_variable,
    ACTIONS(1821), 1,
      anon_sym__,
    ACTIONS(1825), 1,
      sym__integer_literal,
    ACTIONS(1831), 1,
      sym__cond_quote_start,
    ACTIONS(4961), 1,
      anon_sym_SQUOTE,
    ACTIONS(4963), 1,
      sym_name,
    STATE(476), 1,
      sym__paren_open,
    STATE(587), 1,
      sym_type,
    STATE(802), 1,
      sym__unboxed_open,
    STATE(987), 1,
      sym__bracket_open,
    STATE(4880), 1,
      sym__type_parens,
    STATE(4881), 1,
      sym__type_tuple,
    STATE(4882), 1,
      sym__type_unboxed_tuple,
    STATE(4885), 1,
      sym__type_unboxed_sum,
    STATE(4886), 1,
      sym__type_list,
    STATE(4887), 1,
      sym__type_apply,
    STATE(4890), 1,
      sym__type_infix,
    STATE(4891), 1,
      sym__plist,
    STATE(5078), 1,
      sym__qualified_type,
    STATE(5100), 1,
      sym_integer,
    STATE(7289), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10957), 1,
      aux_sym__qualifying_module,
    ACTIONS(1817), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1823), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1827), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4892), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4879), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [19951] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1819), 1,
      sym_variable,
    ACTIONS(1821), 1,
      anon_sym__,
    ACTIONS(1825), 1,
      sym__integer_literal,
    ACTIONS(1831), 1,
      sym__cond_quote_start,
    ACTIONS(4961), 1,
      anon_sym_SQUOTE,
    ACTIONS(4963), 1,
      sym_name,
    STATE(476), 1,
      sym__paren_open,
    STATE(584), 1,
      sym_type,
    STATE(802), 1,
      sym__unboxed_open,
    STATE(987), 1,
      sym__bracket_open,
    STATE(4880), 1,
      sym__type_parens,
    STATE(4881), 1,
      sym__type_tuple,
    STATE(4882), 1,
      sym__type_unboxed_tuple,
    STATE(4885), 1,
      sym__type_unboxed_sum,
    STATE(4886), 1,
      sym__type_list,
    STATE(4887), 1,
      sym__type_apply,
    STATE(4890), 1,
      sym__type_infix,
    STATE(4891), 1,
      sym__plist,
    STATE(5078), 1,
      sym__qualified_type,
    STATE(5100), 1,
      sym_integer,
    STATE(7289), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10957), 1,
      aux_sym__qualifying_module,
    ACTIONS(1817), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1823), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1827), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4892), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4879), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [20079] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1123), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [20207] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2155), 1,
      sym_variable,
    ACTIONS(2157), 1,
      anon_sym__,
    ACTIONS(2167), 1,
      sym__integer_literal,
    ACTIONS(2173), 1,
      sym__cond_quote_start,
    ACTIONS(3427), 1,
      anon_sym_SQUOTE,
    ACTIONS(3431), 1,
      sym_name,
    STATE(469), 1,
      sym__paren_open,
    STATE(780), 1,
      sym_type,
    STATE(810), 1,
      sym__unboxed_open,
    STATE(990), 1,
      sym__bracket_open,
    STATE(6269), 1,
      sym_integer,
    STATE(6286), 1,
      sym__qualified_type,
    STATE(6323), 1,
      sym__type_parens,
    STATE(6324), 1,
      sym__type_tuple,
    STATE(6325), 1,
      sym__type_unboxed_tuple,
    STATE(6326), 1,
      sym__type_unboxed_sum,
    STATE(6327), 1,
      sym__type_list,
    STATE(6328), 1,
      sym__type_apply,
    STATE(6329), 1,
      sym__type_infix,
    STATE(6330), 1,
      sym__plist,
    STATE(7407), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11328), 1,
      aux_sym__qualifying_module,
    ACTIONS(2163), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2165), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2169), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6331), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6321), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [20335] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1784), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [20463] = 5,
    STATE(2890), 1,
      sym__nalts,
    ACTIONS(4969), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4965), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4967), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [20537] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3363), 1,
      sym_variable,
    ACTIONS(3365), 1,
      anon_sym__,
    ACTIONS(3375), 1,
      sym__integer_literal,
    ACTIONS(3381), 1,
      sym__cond_quote_start,
    ACTIONS(4971), 1,
      anon_sym_SQUOTE,
    ACTIONS(4973), 1,
      sym_name,
    STATE(457), 1,
      sym__paren_open,
    STATE(813), 1,
      sym__unboxed_open,
    STATE(995), 1,
      sym__bracket_open,
    STATE(1427), 1,
      sym_type,
    STATE(7310), 1,
      sym__splice_dollars,
    STATE(7738), 1,
      sym__qualified_type,
    STATE(7755), 1,
      sym__type_parens,
    STATE(7759), 1,
      sym__type_tuple,
    STATE(7760), 1,
      sym__type_unboxed_tuple,
    STATE(7761), 1,
      sym__type_unboxed_sum,
    STATE(7762), 1,
      sym_integer,
    STATE(7763), 1,
      sym__type_list,
    STATE(7764), 1,
      sym__type_apply,
    STATE(7765), 1,
      sym__type_infix,
    STATE(7766), 1,
      sym__plist,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11318), 1,
      aux_sym__qualifying_module,
    ACTIONS(3371), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3373), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3377), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7767), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7754), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [20665] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1777), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [20793] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1121), 1,
      sym_variable,
    ACTIONS(1127), 1,
      anon_sym__,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1141), 1,
      sym__integer_literal,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1153), 1,
      sym__cond_quote_start,
    ACTIONS(3317), 1,
      anon_sym_SQUOTE,
    ACTIONS(3321), 1,
      sym_name,
    STATE(328), 1,
      sym_type,
    STATE(445), 1,
      sym__paren_open,
    STATE(740), 1,
      sym__unboxed_open,
    STATE(1047), 1,
      sym__bracket_open,
    STATE(2318), 1,
      sym_integer,
    STATE(2335), 1,
      sym__type_parens,
    STATE(2337), 1,
      sym__type_tuple,
    STATE(2338), 1,
      sym__type_unboxed_tuple,
    STATE(2341), 1,
      sym__type_unboxed_sum,
    STATE(2342), 1,
      sym__type_list,
    STATE(2343), 1,
      sym__qualified_type,
    STATE(2350), 1,
      sym__plist,
    STATE(2352), 1,
      sym__type_infix,
    STATE(2353), 1,
      sym__type_apply,
    STATE(7396), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11256), 1,
      aux_sym__qualifying_module,
    ACTIONS(1133), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1139), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1143), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(2348), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(2327), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [20921] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1847), 1,
      sym_variable,
    ACTIONS(1849), 1,
      anon_sym__,
    ACTIONS(1859), 1,
      sym__integer_literal,
    ACTIONS(1865), 1,
      sym__cond_quote_start,
    ACTIONS(4951), 1,
      anon_sym_SQUOTE,
    ACTIONS(4953), 1,
      sym_name,
    STATE(454), 1,
      sym__paren_open,
    STATE(651), 1,
      sym_type,
    STATE(749), 1,
      sym__unboxed_open,
    STATE(1050), 1,
      sym__bracket_open,
    STATE(5812), 1,
      sym__type_tuple,
    STATE(5845), 1,
      sym_integer,
    STATE(5853), 1,
      sym__qualified_type,
    STATE(5859), 1,
      sym__type_list,
    STATE(5860), 1,
      sym__type_apply,
    STATE(5862), 1,
      sym__type_infix,
    STATE(5864), 1,
      sym__plist,
    STATE(5871), 1,
      sym__type_parens,
    STATE(5874), 1,
      sym__type_unboxed_tuple,
    STATE(5875), 1,
      sym__type_unboxed_sum,
    STATE(7272), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11241), 1,
      aux_sym__qualifying_module,
    ACTIONS(1855), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1857), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1861), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5869), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5866), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [21049] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(991), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1795), 1,
      sym_variable,
    ACTIONS(1797), 1,
      anon_sym__,
    ACTIONS(1807), 1,
      sym__cond_quote_start,
    ACTIONS(4899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4901), 1,
      sym_name,
    STATE(443), 1,
      sym__paren_open,
    STATE(568), 1,
      sym_type,
    STATE(784), 1,
      sym__unboxed_open,
    STATE(1042), 1,
      sym__bracket_open,
    STATE(4322), 1,
      sym__qualified_type,
    STATE(4374), 1,
      sym__type_parens,
    STATE(4375), 1,
      sym__type_tuple,
    STATE(4376), 1,
      sym__type_unboxed_tuple,
    STATE(4377), 1,
      sym__type_unboxed_sum,
    STATE(4379), 1,
      sym__type_list,
    STATE(4380), 1,
      sym__type_apply,
    STATE(4381), 1,
      sym__type_infix,
    STATE(4382), 1,
      sym__plist,
    STATE(4597), 1,
      sym_integer,
    STATE(7263), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11266), 1,
      aux_sym__qualifying_module,
    ACTIONS(1803), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(989), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(993), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4383), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4373), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [21177] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(991), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1795), 1,
      sym_variable,
    ACTIONS(1797), 1,
      anon_sym__,
    ACTIONS(1807), 1,
      sym__cond_quote_start,
    ACTIONS(4899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4901), 1,
      sym_name,
    STATE(443), 1,
      sym__paren_open,
    STATE(572), 1,
      sym_type,
    STATE(784), 1,
      sym__unboxed_open,
    STATE(1042), 1,
      sym__bracket_open,
    STATE(4322), 1,
      sym__qualified_type,
    STATE(4374), 1,
      sym__type_parens,
    STATE(4375), 1,
      sym__type_tuple,
    STATE(4376), 1,
      sym__type_unboxed_tuple,
    STATE(4377), 1,
      sym__type_unboxed_sum,
    STATE(4379), 1,
      sym__type_list,
    STATE(4380), 1,
      sym__type_apply,
    STATE(4381), 1,
      sym__type_infix,
    STATE(4382), 1,
      sym__plist,
    STATE(4597), 1,
      sym_integer,
    STATE(7263), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11266), 1,
      aux_sym__qualifying_module,
    ACTIONS(1803), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(989), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(993), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4383), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4373), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [21305] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4630), 42,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [21381] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2945), 1,
      sym_variable,
    ACTIONS(2947), 1,
      anon_sym__,
    ACTIONS(2957), 1,
      sym__integer_literal,
    ACTIONS(2963), 1,
      sym__cond_quote_start,
    ACTIONS(4354), 1,
      anon_sym_SQUOTE,
    ACTIONS(4360), 1,
      sym_name,
    STATE(448), 1,
      sym__paren_open,
    STATE(824), 1,
      sym__unboxed_open,
    STATE(958), 1,
      sym_type,
    STATE(1009), 1,
      sym__bracket_open,
    STATE(7206), 1,
      sym_integer,
    STATE(7207), 1,
      sym__type_infix,
    STATE(7208), 1,
      sym__splice_dollars,
    STATE(7209), 1,
      sym__plist,
    STATE(7237), 1,
      sym__type_apply,
    STATE(7246), 1,
      sym__type_unboxed_sum,
    STATE(7247), 1,
      sym__type_list,
    STATE(7258), 1,
      sym__type_unboxed_tuple,
    STATE(7262), 1,
      sym__type_tuple,
    STATE(7268), 1,
      sym__type_parens,
    STATE(7374), 1,
      sym__qualified_type,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11301), 1,
      aux_sym__qualifying_module,
    ACTIONS(2953), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2955), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2959), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7210), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7269), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [21509] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1989), 1,
      sym_variable,
    ACTIONS(1993), 1,
      anon_sym__,
    ACTIONS(1995), 1,
      anon_sym_SQUOTE,
    ACTIONS(2003), 1,
      sym__integer_literal,
    ACTIONS(2011), 1,
      sym_name,
    ACTIONS(2015), 1,
      sym__cond_quote_start,
    STATE(449), 1,
      sym__paren_open,
    STATE(736), 1,
      sym_type,
    STATE(769), 1,
      sym__unboxed_open,
    STATE(1028), 1,
      sym__bracket_open,
    STATE(6258), 1,
      sym_integer,
    STATE(6404), 1,
      sym__type_infix,
    STATE(6456), 1,
      sym__qualified_type,
    STATE(6473), 1,
      sym__type_parens,
    STATE(6477), 1,
      sym__type_tuple,
    STATE(6479), 1,
      sym__type_unboxed_tuple,
    STATE(6480), 1,
      sym__type_unboxed_sum,
    STATE(6481), 1,
      sym__type_list,
    STATE(6483), 1,
      sym__type_apply,
    STATE(6490), 1,
      sym__plist,
    STATE(7378), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11091), 1,
      aux_sym__qualifying_module,
    ACTIONS(1997), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2001), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2005), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6494), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6470), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [21637] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3203), 1,
      sym_variable,
    ACTIONS(3205), 1,
      anon_sym__,
    ACTIONS(3215), 1,
      sym__integer_literal,
    ACTIONS(3221), 1,
      sym__cond_quote_start,
    ACTIONS(4140), 1,
      anon_sym_SQUOTE,
    ACTIONS(4144), 1,
      sym_name,
    STATE(434), 1,
      sym__paren_open,
    STATE(763), 1,
      sym__unboxed_open,
    STATE(963), 1,
      sym__bracket_open,
    STATE(1293), 1,
      sym_type,
    STATE(7479), 1,
      sym__splice_dollars,
    STATE(7579), 1,
      sym__plist,
    STATE(7580), 1,
      sym__type_infix,
    STATE(7581), 1,
      sym__type_apply,
    STATE(7585), 1,
      sym__type_parens,
    STATE(7587), 1,
      sym__qualified_type,
    STATE(7589), 1,
      sym__type_list,
    STATE(7591), 1,
      sym__type_unboxed_sum,
    STATE(7595), 1,
      sym_integer,
    STATE(7602), 1,
      sym__type_tuple,
    STATE(7615), 1,
      sym__type_unboxed_tuple,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10889), 1,
      aux_sym__qualifying_module,
    ACTIONS(3211), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3213), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3217), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7569), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7555), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [21765] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(991), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1795), 1,
      sym_variable,
    ACTIONS(1797), 1,
      anon_sym__,
    ACTIONS(1807), 1,
      sym__cond_quote_start,
    ACTIONS(4899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4901), 1,
      sym_name,
    STATE(443), 1,
      sym__paren_open,
    STATE(567), 1,
      sym_type,
    STATE(784), 1,
      sym__unboxed_open,
    STATE(1042), 1,
      sym__bracket_open,
    STATE(4322), 1,
      sym__qualified_type,
    STATE(4374), 1,
      sym__type_parens,
    STATE(4375), 1,
      sym__type_tuple,
    STATE(4376), 1,
      sym__type_unboxed_tuple,
    STATE(4377), 1,
      sym__type_unboxed_sum,
    STATE(4379), 1,
      sym__type_list,
    STATE(4380), 1,
      sym__type_apply,
    STATE(4381), 1,
      sym__type_infix,
    STATE(4382), 1,
      sym__plist,
    STATE(4597), 1,
      sym_integer,
    STATE(7263), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11266), 1,
      aux_sym__qualifying_module,
    ACTIONS(1803), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(989), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(993), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4383), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4373), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [21893] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1821), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [22021] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3203), 1,
      sym_variable,
    ACTIONS(3205), 1,
      anon_sym__,
    ACTIONS(3215), 1,
      sym__integer_literal,
    ACTIONS(3221), 1,
      sym__cond_quote_start,
    ACTIONS(4140), 1,
      anon_sym_SQUOTE,
    ACTIONS(4144), 1,
      sym_name,
    STATE(434), 1,
      sym__paren_open,
    STATE(763), 1,
      sym__unboxed_open,
    STATE(963), 1,
      sym__bracket_open,
    STATE(1186), 1,
      sym_type,
    STATE(7479), 1,
      sym__splice_dollars,
    STATE(7579), 1,
      sym__plist,
    STATE(7580), 1,
      sym__type_infix,
    STATE(7581), 1,
      sym__type_apply,
    STATE(7585), 1,
      sym__type_parens,
    STATE(7587), 1,
      sym__qualified_type,
    STATE(7589), 1,
      sym__type_list,
    STATE(7591), 1,
      sym__type_unboxed_sum,
    STATE(7595), 1,
      sym_integer,
    STATE(7602), 1,
      sym__type_tuple,
    STATE(7615), 1,
      sym__type_unboxed_tuple,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10889), 1,
      aux_sym__qualifying_module,
    ACTIONS(3211), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3213), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3217), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7569), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7555), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [22149] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3203), 1,
      sym_variable,
    ACTIONS(3205), 1,
      anon_sym__,
    ACTIONS(3215), 1,
      sym__integer_literal,
    ACTIONS(3221), 1,
      sym__cond_quote_start,
    ACTIONS(4140), 1,
      anon_sym_SQUOTE,
    ACTIONS(4144), 1,
      sym_name,
    STATE(434), 1,
      sym__paren_open,
    STATE(763), 1,
      sym__unboxed_open,
    STATE(963), 1,
      sym__bracket_open,
    STATE(1187), 1,
      sym_type,
    STATE(7479), 1,
      sym__splice_dollars,
    STATE(7579), 1,
      sym__plist,
    STATE(7580), 1,
      sym__type_infix,
    STATE(7581), 1,
      sym__type_apply,
    STATE(7585), 1,
      sym__type_parens,
    STATE(7587), 1,
      sym__qualified_type,
    STATE(7589), 1,
      sym__type_list,
    STATE(7591), 1,
      sym__type_unboxed_sum,
    STATE(7595), 1,
      sym_integer,
    STATE(7602), 1,
      sym__type_tuple,
    STATE(7615), 1,
      sym__type_unboxed_tuple,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10889), 1,
      aux_sym__qualifying_module,
    ACTIONS(3211), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3213), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3217), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7569), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7555), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [22277] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3107), 1,
      sym_variable,
    ACTIONS(3109), 1,
      anon_sym__,
    ACTIONS(3119), 1,
      sym__integer_literal,
    ACTIONS(3125), 1,
      sym__cond_quote_start,
    ACTIONS(4378), 1,
      anon_sym_SQUOTE,
    ACTIONS(4380), 1,
      sym_name,
    STATE(455), 1,
      sym__paren_open,
    STATE(770), 1,
      sym__unboxed_open,
    STATE(1090), 1,
      sym__bracket_open,
    STATE(1144), 1,
      sym_type,
    STATE(7345), 1,
      sym__splice_dollars,
    STATE(7492), 1,
      sym__type_unboxed_sum,
    STATE(7497), 1,
      sym__type_unboxed_tuple,
    STATE(7503), 1,
      sym__type_tuple,
    STATE(7505), 1,
      sym__type_parens,
    STATE(7518), 1,
      sym__plist,
    STATE(7528), 1,
      sym__type_list,
    STATE(7534), 1,
      sym__type_infix,
    STATE(7541), 1,
      sym__qualified_type,
    STATE(7542), 1,
      sym_integer,
    STATE(7550), 1,
      sym__type_apply,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11252), 1,
      aux_sym__qualifying_module,
    ACTIONS(3115), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3117), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3121), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7511), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7491), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [22405] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1792), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [22533] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2781), 1,
      sym_variable,
    ACTIONS(2783), 1,
      anon_sym__,
    ACTIONS(2793), 1,
      sym__integer_literal,
    ACTIONS(2799), 1,
      sym__cond_quote_start,
    ACTIONS(3433), 1,
      anon_sym_SQUOTE,
    ACTIONS(3437), 1,
      sym_name,
    STATE(473), 1,
      sym__paren_open,
    STATE(799), 1,
      sym__unboxed_open,
    STATE(948), 1,
      sym_type,
    STATE(1082), 1,
      sym__bracket_open,
    STATE(7124), 1,
      sym__plist,
    STATE(7130), 1,
      sym__type_infix,
    STATE(7132), 1,
      sym__type_apply,
    STATE(7133), 1,
      sym__type_list,
    STATE(7135), 1,
      sym__type_unboxed_sum,
    STATE(7137), 1,
      sym__type_unboxed_tuple,
    STATE(7138), 1,
      sym__type_tuple,
    STATE(7152), 1,
      sym__type_parens,
    STATE(7159), 1,
      sym_integer,
    STATE(7160), 1,
      sym__qualified_type,
    STATE(7456), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10934), 1,
      aux_sym__qualifying_module,
    ACTIONS(2789), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2791), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2795), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7122), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7020), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [22661] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2781), 1,
      sym_variable,
    ACTIONS(2783), 1,
      anon_sym__,
    ACTIONS(2793), 1,
      sym__integer_literal,
    ACTIONS(2799), 1,
      sym__cond_quote_start,
    ACTIONS(3433), 1,
      anon_sym_SQUOTE,
    ACTIONS(3437), 1,
      sym_name,
    STATE(473), 1,
      sym__paren_open,
    STATE(799), 1,
      sym__unboxed_open,
    STATE(949), 1,
      sym_type,
    STATE(1082), 1,
      sym__bracket_open,
    STATE(7124), 1,
      sym__plist,
    STATE(7130), 1,
      sym__type_infix,
    STATE(7132), 1,
      sym__type_apply,
    STATE(7133), 1,
      sym__type_list,
    STATE(7135), 1,
      sym__type_unboxed_sum,
    STATE(7137), 1,
      sym__type_unboxed_tuple,
    STATE(7138), 1,
      sym__type_tuple,
    STATE(7152), 1,
      sym__type_parens,
    STATE(7159), 1,
      sym_integer,
    STATE(7160), 1,
      sym__qualified_type,
    STATE(7456), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10934), 1,
      aux_sym__qualifying_module,
    ACTIONS(2789), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2791), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2795), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7122), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7020), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [22789] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1818), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [22917] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1828), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [23045] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2781), 1,
      sym_variable,
    ACTIONS(2783), 1,
      anon_sym__,
    ACTIONS(2793), 1,
      sym__integer_literal,
    ACTIONS(2799), 1,
      sym__cond_quote_start,
    ACTIONS(3433), 1,
      anon_sym_SQUOTE,
    ACTIONS(3437), 1,
      sym_name,
    STATE(473), 1,
      sym__paren_open,
    STATE(799), 1,
      sym__unboxed_open,
    STATE(941), 1,
      sym_type,
    STATE(1082), 1,
      sym__bracket_open,
    STATE(7124), 1,
      sym__plist,
    STATE(7130), 1,
      sym__type_infix,
    STATE(7132), 1,
      sym__type_apply,
    STATE(7133), 1,
      sym__type_list,
    STATE(7135), 1,
      sym__type_unboxed_sum,
    STATE(7137), 1,
      sym__type_unboxed_tuple,
    STATE(7138), 1,
      sym__type_tuple,
    STATE(7152), 1,
      sym__type_parens,
    STATE(7159), 1,
      sym_integer,
    STATE(7160), 1,
      sym__qualified_type,
    STATE(7456), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10934), 1,
      aux_sym__qualifying_module,
    ACTIONS(2789), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2791), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2795), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7122), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7020), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [23173] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(991), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1795), 1,
      sym_variable,
    ACTIONS(1797), 1,
      anon_sym__,
    ACTIONS(1807), 1,
      sym__cond_quote_start,
    ACTIONS(4899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4901), 1,
      sym_name,
    STATE(443), 1,
      sym__paren_open,
    STATE(558), 1,
      sym_type,
    STATE(784), 1,
      sym__unboxed_open,
    STATE(1042), 1,
      sym__bracket_open,
    STATE(4322), 1,
      sym__qualified_type,
    STATE(4374), 1,
      sym__type_parens,
    STATE(4375), 1,
      sym__type_tuple,
    STATE(4376), 1,
      sym__type_unboxed_tuple,
    STATE(4377), 1,
      sym__type_unboxed_sum,
    STATE(4379), 1,
      sym__type_list,
    STATE(4380), 1,
      sym__type_apply,
    STATE(4381), 1,
      sym__type_infix,
    STATE(4382), 1,
      sym__plist,
    STATE(4597), 1,
      sym_integer,
    STATE(7263), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11266), 1,
      aux_sym__qualifying_module,
    ACTIONS(1803), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(989), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(993), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4383), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4373), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [23301] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1819), 1,
      sym_variable,
    ACTIONS(1821), 1,
      anon_sym__,
    ACTIONS(1825), 1,
      sym__integer_literal,
    ACTIONS(1831), 1,
      sym__cond_quote_start,
    ACTIONS(4961), 1,
      anon_sym_SQUOTE,
    ACTIONS(4963), 1,
      sym_name,
    STATE(476), 1,
      sym__paren_open,
    STATE(575), 1,
      sym_type,
    STATE(802), 1,
      sym__unboxed_open,
    STATE(987), 1,
      sym__bracket_open,
    STATE(4880), 1,
      sym__type_parens,
    STATE(4881), 1,
      sym__type_tuple,
    STATE(4882), 1,
      sym__type_unboxed_tuple,
    STATE(4885), 1,
      sym__type_unboxed_sum,
    STATE(4886), 1,
      sym__type_list,
    STATE(4887), 1,
      sym__type_apply,
    STATE(4890), 1,
      sym__type_infix,
    STATE(4891), 1,
      sym__plist,
    STATE(5078), 1,
      sym__qualified_type,
    STATE(5100), 1,
      sym_integer,
    STATE(7289), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10957), 1,
      aux_sym__qualifying_module,
    ACTIONS(1817), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1823), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1827), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4892), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4879), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [23429] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1045), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1781), 1,
      anon_sym__,
    ACTIONS(1785), 1,
      sym_variable,
    ACTIONS(1793), 1,
      sym__cond_quote_start,
    ACTIONS(4887), 1,
      anon_sym_SQUOTE,
    ACTIONS(4889), 1,
      sym_name,
    STATE(433), 1,
      sym__paren_open,
    STATE(562), 1,
      sym_type,
    STATE(820), 1,
      sym__unboxed_open,
    STATE(998), 1,
      sym__bracket_open,
    STATE(4318), 1,
      sym__type_parens,
    STATE(4319), 1,
      sym__type_tuple,
    STATE(4324), 1,
      sym__type_unboxed_tuple,
    STATE(4325), 1,
      sym__type_unboxed_sum,
    STATE(4326), 1,
      sym__type_list,
    STATE(4327), 1,
      sym__type_apply,
    STATE(4328), 1,
      sym__type_infix,
    STATE(4329), 1,
      sym__plist,
    STATE(4366), 1,
      sym_integer,
    STATE(4389), 1,
      sym__qualified_type,
    STATE(7227), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10933), 1,
      aux_sym__qualifying_module,
    ACTIONS(1783), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1043), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1047), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4330), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4317), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [23557] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1609), 1,
      sym_variable,
    ACTIONS(1611), 1,
      anon_sym__,
    ACTIONS(1621), 1,
      sym__integer_literal,
    ACTIONS(1627), 1,
      sym__cond_quote_start,
    ACTIONS(3383), 1,
      anon_sym_SQUOTE,
    ACTIONS(3387), 1,
      sym_name,
    STATE(464), 1,
      sym__paren_open,
    STATE(492), 1,
      sym_type,
    STATE(805), 1,
      sym__unboxed_open,
    STATE(1079), 1,
      sym__bracket_open,
    STATE(3269), 1,
      sym_integer,
    STATE(3357), 1,
      sym__plist,
    STATE(3358), 1,
      sym__type_infix,
    STATE(3359), 1,
      sym__type_apply,
    STATE(3361), 1,
      sym__type_list,
    STATE(3369), 1,
      sym__type_unboxed_sum,
    STATE(3370), 1,
      sym__type_unboxed_tuple,
    STATE(3377), 1,
      sym__type_tuple,
    STATE(3379), 1,
      sym__type_parens,
    STATE(3410), 1,
      sym__qualified_type,
    STATE(7460), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11178), 1,
      aux_sym__qualifying_module,
    ACTIONS(1617), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1619), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1623), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3354), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3383), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [23685] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1823), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(7597), 1,
      sym__type_infix,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [23813] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1989), 1,
      sym_variable,
    ACTIONS(1993), 1,
      anon_sym__,
    ACTIONS(1995), 1,
      anon_sym_SQUOTE,
    ACTIONS(2003), 1,
      sym__integer_literal,
    ACTIONS(2011), 1,
      sym_name,
    ACTIONS(2015), 1,
      sym__cond_quote_start,
    STATE(449), 1,
      sym__paren_open,
    STATE(756), 1,
      sym_type,
    STATE(769), 1,
      sym__unboxed_open,
    STATE(1028), 1,
      sym__bracket_open,
    STATE(6258), 1,
      sym_integer,
    STATE(6404), 1,
      sym__type_infix,
    STATE(6456), 1,
      sym__qualified_type,
    STATE(6473), 1,
      sym__type_parens,
    STATE(6477), 1,
      sym__type_tuple,
    STATE(6479), 1,
      sym__type_unboxed_tuple,
    STATE(6480), 1,
      sym__type_unboxed_sum,
    STATE(6481), 1,
      sym__type_list,
    STATE(6483), 1,
      sym__type_apply,
    STATE(6490), 1,
      sym__plist,
    STATE(7378), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11091), 1,
      aux_sym__qualifying_module,
    ACTIONS(1997), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2001), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2005), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6494), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6470), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [23941] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1021), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1767), 1,
      sym_variable,
    ACTIONS(1769), 1,
      anon_sym__,
    ACTIONS(1779), 1,
      sym__cond_quote_start,
    ACTIONS(4879), 1,
      anon_sym_SQUOTE,
    ACTIONS(4881), 1,
      sym_name,
    STATE(440), 1,
      sym__paren_open,
    STATE(560), 1,
      sym_type,
    STATE(804), 1,
      sym__unboxed_open,
    STATE(1037), 1,
      sym__bracket_open,
    STATE(4588), 1,
      sym__type_unboxed_tuple,
    STATE(4653), 1,
      sym__type_parens,
    STATE(4654), 1,
      sym__type_tuple,
    STATE(4657), 1,
      sym__type_unboxed_sum,
    STATE(4667), 1,
      sym__type_list,
    STATE(4669), 1,
      sym__type_apply,
    STATE(4672), 1,
      sym__type_infix,
    STATE(4673), 1,
      sym__plist,
    STATE(4690), 1,
      sym_integer,
    STATE(4841), 1,
      sym__qualified_type,
    STATE(7386), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11282), 1,
      aux_sym__qualifying_module,
    ACTIONS(1775), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1019), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1023), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4674), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4652), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [24069] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1786), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [24197] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2121), 1,
      sym_variable,
    ACTIONS(2123), 1,
      anon_sym__,
    ACTIONS(2133), 1,
      sym__integer_literal,
    ACTIONS(2139), 1,
      sym__cond_quote_start,
    ACTIONS(3547), 1,
      anon_sym_SQUOTE,
    ACTIONS(3551), 1,
      sym_name,
    STATE(431), 1,
      sym__paren_open,
    STATE(771), 1,
      sym__unboxed_open,
    STATE(783), 1,
      sym_type,
    STATE(1029), 1,
      sym__bracket_open,
    STATE(6245), 1,
      sym__qualified_type,
    STATE(6338), 1,
      sym_integer,
    STATE(6512), 1,
      sym__type_parens,
    STATE(6513), 1,
      sym__type_tuple,
    STATE(6514), 1,
      sym__type_unboxed_tuple,
    STATE(6515), 1,
      sym__type_unboxed_sum,
    STATE(6516), 1,
      sym__type_list,
    STATE(6517), 1,
      sym__type_apply,
    STATE(6518), 1,
      sym__type_infix,
    STATE(6519), 1,
      sym__plist,
    STATE(7260), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11289), 1,
      aux_sym__qualifying_module,
    ACTIONS(2129), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2135), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6520), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6510), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [24325] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(565), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1689), 1,
      anon_sym__,
    ACTIONS(1693), 1,
      sym_variable,
    ACTIONS(1703), 1,
      sym__cond_quote_start,
    ACTIONS(4915), 1,
      anon_sym_SQUOTE,
    ACTIONS(4917), 1,
      sym_name,
    STATE(462), 1,
      sym__paren_open,
    STATE(515), 1,
      sym_type,
    STATE(768), 1,
      sym__unboxed_open,
    STATE(1063), 1,
      sym__bracket_open,
    STATE(3701), 1,
      sym__type_parens,
    STATE(3702), 1,
      sym__type_tuple,
    STATE(3703), 1,
      sym__qualified_type,
    STATE(3709), 1,
      sym__type_unboxed_tuple,
    STATE(3711), 1,
      sym__type_unboxed_sum,
    STATE(3712), 1,
      sym__type_list,
    STATE(3715), 1,
      sym__type_apply,
    STATE(3717), 1,
      sym__type_infix,
    STATE(3718), 1,
      sym__plist,
    STATE(3781), 1,
      sym_integer,
    STATE(7323), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11219), 1,
      aux_sym__qualifying_module,
    ACTIONS(1691), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(563), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(567), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3721), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3699), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [24453] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1823), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(7565), 1,
      sym__type_infix,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [24581] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1021), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1767), 1,
      sym_variable,
    ACTIONS(1769), 1,
      anon_sym__,
    ACTIONS(1779), 1,
      sym__cond_quote_start,
    ACTIONS(4879), 1,
      anon_sym_SQUOTE,
    ACTIONS(4881), 1,
      sym_name,
    STATE(440), 1,
      sym__paren_open,
    STATE(554), 1,
      sym_type,
    STATE(804), 1,
      sym__unboxed_open,
    STATE(1037), 1,
      sym__bracket_open,
    STATE(4588), 1,
      sym__type_unboxed_tuple,
    STATE(4653), 1,
      sym__type_parens,
    STATE(4654), 1,
      sym__type_tuple,
    STATE(4657), 1,
      sym__type_unboxed_sum,
    STATE(4667), 1,
      sym__type_list,
    STATE(4669), 1,
      sym__type_apply,
    STATE(4672), 1,
      sym__type_infix,
    STATE(4673), 1,
      sym__plist,
    STATE(4690), 1,
      sym_integer,
    STATE(4841), 1,
      sym__qualified_type,
    STATE(7386), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11282), 1,
      aux_sym__qualifying_module,
    ACTIONS(1775), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1019), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1023), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4674), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4652), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [24709] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1794), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [24837] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1823), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(7606), 1,
      sym__type_infix,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [24965] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1989), 1,
      sym_variable,
    ACTIONS(1993), 1,
      anon_sym__,
    ACTIONS(1995), 1,
      anon_sym_SQUOTE,
    ACTIONS(2003), 1,
      sym__integer_literal,
    ACTIONS(2011), 1,
      sym_name,
    ACTIONS(2015), 1,
      sym__cond_quote_start,
    STATE(449), 1,
      sym__paren_open,
    STATE(758), 1,
      sym_type,
    STATE(769), 1,
      sym__unboxed_open,
    STATE(1028), 1,
      sym__bracket_open,
    STATE(6258), 1,
      sym_integer,
    STATE(6404), 1,
      sym__type_infix,
    STATE(6456), 1,
      sym__qualified_type,
    STATE(6473), 1,
      sym__type_parens,
    STATE(6477), 1,
      sym__type_tuple,
    STATE(6479), 1,
      sym__type_unboxed_tuple,
    STATE(6480), 1,
      sym__type_unboxed_sum,
    STATE(6481), 1,
      sym__type_list,
    STATE(6483), 1,
      sym__type_apply,
    STATE(6490), 1,
      sym__plist,
    STATE(7378), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11091), 1,
      aux_sym__qualifying_module,
    ACTIONS(1997), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2001), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2005), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6494), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6470), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [25093] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1826), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(7645), 1,
      sym__type_infix,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [25221] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1826), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(7621), 1,
      sym__type_infix,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [25349] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1812), 1,
      sym_type,
    STATE(5675), 1,
      sym__type_infix,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [25477] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1363), 1,
      sym_variable,
    ACTIONS(1367), 1,
      anon_sym__,
    ACTIONS(1369), 1,
      anon_sym_SQUOTE,
    ACTIONS(1385), 1,
      sym__integer_literal,
    ACTIONS(1397), 1,
      sym__cond_quote_start,
    ACTIONS(2595), 1,
      sym_name,
    STATE(456), 1,
      sym__paren_open,
    STATE(520), 1,
      sym_type,
    STATE(794), 1,
      sym__unboxed_open,
    STATE(964), 1,
      sym__bracket_open,
    STATE(3803), 1,
      sym__plist,
    STATE(3822), 1,
      sym__type_apply,
    STATE(3826), 1,
      sym__type_unboxed_sum,
    STATE(3843), 1,
      sym__type_unboxed_tuple,
    STATE(3846), 1,
      sym__type_tuple,
    STATE(3851), 1,
      sym__type_parens,
    STATE(3886), 1,
      sym_integer,
    STATE(3887), 1,
      sym__type_list,
    STATE(3888), 1,
      sym__type_infix,
    STATE(3898), 1,
      sym__qualified_type,
    STATE(7480), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11251), 1,
      aux_sym__qualifying_module,
    ACTIONS(1373), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1383), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1387), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3807), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3855), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [25605] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(765), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1739), 1,
      anon_sym__,
    ACTIONS(1743), 1,
      sym_variable,
    ACTIONS(1751), 1,
      sym__cond_quote_start,
    ACTIONS(4947), 1,
      anon_sym_SQUOTE,
    ACTIONS(4949), 1,
      sym_name,
    STATE(470), 1,
      sym__paren_open,
    STATE(542), 1,
      sym_type,
    STATE(734), 1,
      sym__unboxed_open,
    STATE(1007), 1,
      sym__bracket_open,
    STATE(3988), 1,
      sym__type_unboxed_tuple,
    STATE(4020), 1,
      sym__type_tuple,
    STATE(4027), 1,
      sym__type_parens,
    STATE(4041), 1,
      sym__plist,
    STATE(4047), 1,
      sym__type_apply,
    STATE(4056), 1,
      sym__type_list,
    STATE(4061), 1,
      sym__qualified_type,
    STATE(4088), 1,
      sym__type_infix,
    STATE(4148), 1,
      sym_integer,
    STATE(4177), 1,
      sym__type_unboxed_sum,
    STATE(7343), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11047), 1,
      aux_sym__qualifying_module,
    ACTIONS(1741), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(763), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(767), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4046), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4029), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [25733] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1812), 1,
      sym_type,
    STATE(5681), 1,
      sym__type_infix,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [25861] = 5,
    STATE(2921), 1,
      sym_alternatives,
    ACTIONS(4959), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4975), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4977), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [25935] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(721), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1725), 1,
      sym_variable,
    ACTIONS(1727), 1,
      anon_sym__,
    ACTIONS(1737), 1,
      sym__cond_quote_start,
    ACTIONS(4935), 1,
      anon_sym_SQUOTE,
    ACTIONS(4937), 1,
      sym_name,
    STATE(444), 1,
      sym__paren_open,
    STATE(545), 1,
      sym_type,
    STATE(787), 1,
      sym__unboxed_open,
    STATE(1041), 1,
      sym__bracket_open,
    STATE(4078), 1,
      sym__type_parens,
    STATE(4080), 1,
      sym__type_tuple,
    STATE(4081), 1,
      sym__type_unboxed_tuple,
    STATE(4082), 1,
      sym__type_unboxed_sum,
    STATE(4084), 1,
      sym__type_list,
    STATE(4085), 1,
      sym__type_apply,
    STATE(4097), 1,
      sym__plist,
    STATE(4133), 1,
      sym__type_infix,
    STATE(4138), 1,
      sym__qualified_type,
    STATE(4193), 1,
      sym_integer,
    STATE(7390), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11143), 1,
      aux_sym__qualifying_module,
    ACTIONS(1733), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(719), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(723), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4098), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4075), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [26063] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1825), 1,
      sym_type,
    STATE(6852), 1,
      sym__type_infix,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [26191] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1825), 1,
      sym_type,
    STATE(7017), 1,
      sym__type_infix,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [26319] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3247), 1,
      sym_variable,
    ACTIONS(3249), 1,
      anon_sym__,
    ACTIONS(3259), 1,
      sym__integer_literal,
    ACTIONS(3265), 1,
      sym__cond_quote_start,
    ACTIONS(4477), 1,
      anon_sym_SQUOTE,
    ACTIONS(4479), 1,
      sym_name,
    STATE(463), 1,
      sym__paren_open,
    STATE(825), 1,
      sym__unboxed_open,
    STATE(1066), 1,
      sym__bracket_open,
    STATE(1365), 1,
      sym_type,
    STATE(7311), 1,
      sym__splice_dollars,
    STATE(7653), 1,
      sym_integer,
    STATE(7676), 1,
      sym__plist,
    STATE(7677), 1,
      sym__qualified_type,
    STATE(7686), 1,
      sym__type_unboxed_tuple,
    STATE(7690), 1,
      sym__type_apply,
    STATE(7696), 1,
      sym__type_list,
    STATE(7703), 1,
      sym__type_unboxed_sum,
    STATE(7716), 1,
      sym__type_infix,
    STATE(7721), 1,
      sym__type_tuple,
    STATE(7722), 1,
      sym__type_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10972), 1,
      aux_sym__qualifying_module,
    ACTIONS(3255), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3257), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3261), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7664), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7670), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [26447] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3247), 1,
      sym_variable,
    ACTIONS(3249), 1,
      anon_sym__,
    ACTIONS(3259), 1,
      sym__integer_literal,
    ACTIONS(3265), 1,
      sym__cond_quote_start,
    ACTIONS(4477), 1,
      anon_sym_SQUOTE,
    ACTIONS(4479), 1,
      sym_name,
    STATE(463), 1,
      sym__paren_open,
    STATE(825), 1,
      sym__unboxed_open,
    STATE(1066), 1,
      sym__bracket_open,
    STATE(1382), 1,
      sym_type,
    STATE(7311), 1,
      sym__splice_dollars,
    STATE(7653), 1,
      sym_integer,
    STATE(7676), 1,
      sym__plist,
    STATE(7677), 1,
      sym__qualified_type,
    STATE(7686), 1,
      sym__type_unboxed_tuple,
    STATE(7690), 1,
      sym__type_apply,
    STATE(7696), 1,
      sym__type_list,
    STATE(7703), 1,
      sym__type_unboxed_sum,
    STATE(7716), 1,
      sym__type_infix,
    STATE(7721), 1,
      sym__type_tuple,
    STATE(7722), 1,
      sym__type_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10972), 1,
      aux_sym__qualifying_module,
    ACTIONS(3255), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3257), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3261), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7664), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7670), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [26575] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3247), 1,
      sym_variable,
    ACTIONS(3249), 1,
      anon_sym__,
    ACTIONS(3259), 1,
      sym__integer_literal,
    ACTIONS(3265), 1,
      sym__cond_quote_start,
    ACTIONS(4477), 1,
      anon_sym_SQUOTE,
    ACTIONS(4479), 1,
      sym_name,
    STATE(463), 1,
      sym__paren_open,
    STATE(825), 1,
      sym__unboxed_open,
    STATE(1066), 1,
      sym__bracket_open,
    STATE(1384), 1,
      sym_type,
    STATE(7311), 1,
      sym__splice_dollars,
    STATE(7653), 1,
      sym_integer,
    STATE(7676), 1,
      sym__plist,
    STATE(7677), 1,
      sym__qualified_type,
    STATE(7686), 1,
      sym__type_unboxed_tuple,
    STATE(7690), 1,
      sym__type_apply,
    STATE(7696), 1,
      sym__type_list,
    STATE(7703), 1,
      sym__type_unboxed_sum,
    STATE(7716), 1,
      sym__type_infix,
    STATE(7721), 1,
      sym__type_tuple,
    STATE(7722), 1,
      sym__type_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10972), 1,
      aux_sym__qualifying_module,
    ACTIONS(3255), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3257), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3261), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7664), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7670), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [26703] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1021), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1767), 1,
      sym_variable,
    ACTIONS(1769), 1,
      anon_sym__,
    ACTIONS(1779), 1,
      sym__cond_quote_start,
    ACTIONS(4879), 1,
      anon_sym_SQUOTE,
    ACTIONS(4881), 1,
      sym_name,
    STATE(440), 1,
      sym__paren_open,
    STATE(564), 1,
      sym_type,
    STATE(804), 1,
      sym__unboxed_open,
    STATE(1037), 1,
      sym__bracket_open,
    STATE(4588), 1,
      sym__type_unboxed_tuple,
    STATE(4653), 1,
      sym__type_parens,
    STATE(4654), 1,
      sym__type_tuple,
    STATE(4657), 1,
      sym__type_unboxed_sum,
    STATE(4667), 1,
      sym__type_list,
    STATE(4669), 1,
      sym__type_apply,
    STATE(4672), 1,
      sym__type_infix,
    STATE(4673), 1,
      sym__plist,
    STATE(4690), 1,
      sym_integer,
    STATE(4841), 1,
      sym__qualified_type,
    STATE(7386), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11282), 1,
      aux_sym__qualifying_module,
    ACTIONS(1775), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1019), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1023), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4674), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4652), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [26831] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2573), 1,
      sym_variable,
    ACTIONS(2575), 1,
      anon_sym__,
    ACTIONS(2585), 1,
      sym__integer_literal,
    ACTIONS(2591), 1,
      sym__cond_quote_start,
    ACTIONS(3555), 1,
      anon_sym_SQUOTE,
    ACTIONS(3561), 1,
      sym_name,
    STATE(446), 1,
      sym__paren_open,
    STATE(803), 1,
      sym__unboxed_open,
    STATE(840), 1,
      sym_type,
    STATE(965), 1,
      sym__bracket_open,
    STATE(6574), 1,
      sym__type_list,
    STATE(6595), 1,
      sym__qualified_type,
    STATE(6634), 1,
      sym_integer,
    STATE(6681), 1,
      sym__plist,
    STATE(6682), 1,
      sym__type_infix,
    STATE(6683), 1,
      sym__type_apply,
    STATE(6685), 1,
      sym__type_unboxed_sum,
    STATE(6686), 1,
      sym__type_unboxed_tuple,
    STATE(6687), 1,
      sym__type_tuple,
    STATE(6688), 1,
      sym__type_parens,
    STATE(7266), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11009), 1,
      aux_sym__qualifying_module,
    ACTIONS(2581), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2583), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2587), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6680), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6689), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [26959] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2573), 1,
      sym_variable,
    ACTIONS(2575), 1,
      anon_sym__,
    ACTIONS(2585), 1,
      sym__integer_literal,
    ACTIONS(2591), 1,
      sym__cond_quote_start,
    ACTIONS(3555), 1,
      anon_sym_SQUOTE,
    ACTIONS(3561), 1,
      sym_name,
    STATE(446), 1,
      sym__paren_open,
    STATE(803), 1,
      sym__unboxed_open,
    STATE(838), 1,
      sym_type,
    STATE(965), 1,
      sym__bracket_open,
    STATE(6574), 1,
      sym__type_list,
    STATE(6595), 1,
      sym__qualified_type,
    STATE(6634), 1,
      sym_integer,
    STATE(6681), 1,
      sym__plist,
    STATE(6682), 1,
      sym__type_infix,
    STATE(6683), 1,
      sym__type_apply,
    STATE(6685), 1,
      sym__type_unboxed_sum,
    STATE(6686), 1,
      sym__type_unboxed_tuple,
    STATE(6687), 1,
      sym__type_tuple,
    STATE(6688), 1,
      sym__type_parens,
    STATE(7266), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11009), 1,
      aux_sym__qualifying_module,
    ACTIONS(2581), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2583), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2587), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6680), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6689), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [27087] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2573), 1,
      sym_variable,
    ACTIONS(2575), 1,
      anon_sym__,
    ACTIONS(2585), 1,
      sym__integer_literal,
    ACTIONS(2591), 1,
      sym__cond_quote_start,
    ACTIONS(3555), 1,
      anon_sym_SQUOTE,
    ACTIONS(3561), 1,
      sym_name,
    STATE(446), 1,
      sym__paren_open,
    STATE(803), 1,
      sym__unboxed_open,
    STATE(833), 1,
      sym_type,
    STATE(965), 1,
      sym__bracket_open,
    STATE(6574), 1,
      sym__type_list,
    STATE(6595), 1,
      sym__qualified_type,
    STATE(6634), 1,
      sym_integer,
    STATE(6681), 1,
      sym__plist,
    STATE(6682), 1,
      sym__type_infix,
    STATE(6683), 1,
      sym__type_apply,
    STATE(6685), 1,
      sym__type_unboxed_sum,
    STATE(6686), 1,
      sym__type_unboxed_tuple,
    STATE(6687), 1,
      sym__type_tuple,
    STATE(6688), 1,
      sym__type_parens,
    STATE(7266), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11009), 1,
      aux_sym__qualifying_module,
    ACTIONS(2581), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2583), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2587), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6680), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6689), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [27215] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2573), 1,
      sym_variable,
    ACTIONS(2575), 1,
      anon_sym__,
    ACTIONS(2585), 1,
      sym__integer_literal,
    ACTIONS(2591), 1,
      sym__cond_quote_start,
    ACTIONS(3555), 1,
      anon_sym_SQUOTE,
    ACTIONS(3561), 1,
      sym_name,
    STATE(446), 1,
      sym__paren_open,
    STATE(803), 1,
      sym__unboxed_open,
    STATE(839), 1,
      sym_type,
    STATE(965), 1,
      sym__bracket_open,
    STATE(6574), 1,
      sym__type_list,
    STATE(6595), 1,
      sym__qualified_type,
    STATE(6634), 1,
      sym_integer,
    STATE(6681), 1,
      sym__plist,
    STATE(6682), 1,
      sym__type_infix,
    STATE(6683), 1,
      sym__type_apply,
    STATE(6685), 1,
      sym__type_unboxed_sum,
    STATE(6686), 1,
      sym__type_unboxed_tuple,
    STATE(6687), 1,
      sym__type_tuple,
    STATE(6688), 1,
      sym__type_parens,
    STATE(7266), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11009), 1,
      aux_sym__qualifying_module,
    ACTIONS(2581), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2583), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2587), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6680), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6689), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [27343] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1093), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1809), 1,
      anon_sym__,
    ACTIONS(1833), 1,
      sym_variable,
    ACTIONS(1841), 1,
      sym__cond_quote_start,
    ACTIONS(4907), 1,
      anon_sym_SQUOTE,
    ACTIONS(4909), 1,
      sym_name,
    STATE(451), 1,
      sym__paren_open,
    STATE(585), 1,
      sym_type,
    STATE(817), 1,
      sym__unboxed_open,
    STATE(1084), 1,
      sym__bracket_open,
    STATE(4963), 1,
      sym__qualified_type,
    STATE(5034), 1,
      sym__plist,
    STATE(5035), 1,
      sym__type_infix,
    STATE(5036), 1,
      sym__type_apply,
    STATE(5038), 1,
      sym__type_list,
    STATE(5039), 1,
      sym__type_unboxed_sum,
    STATE(5041), 1,
      sym__type_unboxed_tuple,
    STATE(5042), 1,
      sym__type_tuple,
    STATE(5044), 1,
      sym__type_parens,
    STATE(5084), 1,
      sym_integer,
    STATE(7449), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11170), 1,
      aux_sym__qualifying_module,
    ACTIONS(1811), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1091), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1095), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5033), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5046), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [27471] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3057), 1,
      sym_variable,
    ACTIONS(3059), 1,
      anon_sym__,
    ACTIONS(3063), 1,
      sym__integer_literal,
    ACTIONS(3069), 1,
      sym__cond_quote_start,
    ACTIONS(4939), 1,
      anon_sym_SQUOTE,
    ACTIONS(4941), 1,
      sym_name,
    STATE(474), 1,
      sym__paren_open,
    STATE(733), 1,
      sym__unboxed_open,
    STATE(969), 1,
      sym_type,
    STATE(1124), 1,
      sym__bracket_open,
    STATE(7240), 1,
      sym__type_infix,
    STATE(7267), 1,
      sym__qualified_type,
    STATE(7270), 1,
      sym__splice_dollars,
    STATE(7274), 1,
      sym_integer,
    STATE(7416), 1,
      sym__type_parens,
    STATE(7417), 1,
      sym__type_tuple,
    STATE(7424), 1,
      sym__type_unboxed_tuple,
    STATE(7426), 1,
      sym__type_unboxed_sum,
    STATE(7427), 1,
      sym__type_list,
    STATE(7428), 1,
      sym__type_apply,
    STATE(7429), 1,
      sym__plist,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10936), 1,
      aux_sym__qualifying_module,
    ACTIONS(3055), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3061), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3065), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7438), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7415), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [27599] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2121), 1,
      sym_variable,
    ACTIONS(2123), 1,
      anon_sym__,
    ACTIONS(2133), 1,
      sym__integer_literal,
    ACTIONS(2139), 1,
      sym__cond_quote_start,
    ACTIONS(3547), 1,
      anon_sym_SQUOTE,
    ACTIONS(3551), 1,
      sym_name,
    STATE(431), 1,
      sym__paren_open,
    STATE(771), 1,
      sym__unboxed_open,
    STATE(823), 1,
      sym_type,
    STATE(1029), 1,
      sym__bracket_open,
    STATE(6245), 1,
      sym__qualified_type,
    STATE(6338), 1,
      sym_integer,
    STATE(6512), 1,
      sym__type_parens,
    STATE(6513), 1,
      sym__type_tuple,
    STATE(6514), 1,
      sym__type_unboxed_tuple,
    STATE(6515), 1,
      sym__type_unboxed_sum,
    STATE(6516), 1,
      sym__type_list,
    STATE(6517), 1,
      sym__type_apply,
    STATE(6518), 1,
      sym__type_infix,
    STATE(6519), 1,
      sym__plist,
    STATE(7260), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11289), 1,
      aux_sym__qualifying_module,
    ACTIONS(2129), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2135), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6520), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6510), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [27727] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1776), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [27855] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2121), 1,
      sym_variable,
    ACTIONS(2123), 1,
      anon_sym__,
    ACTIONS(2133), 1,
      sym__integer_literal,
    ACTIONS(2139), 1,
      sym__cond_quote_start,
    ACTIONS(3547), 1,
      anon_sym_SQUOTE,
    ACTIONS(3551), 1,
      sym_name,
    STATE(431), 1,
      sym__paren_open,
    STATE(750), 1,
      sym_type,
    STATE(771), 1,
      sym__unboxed_open,
    STATE(1029), 1,
      sym__bracket_open,
    STATE(6245), 1,
      sym__qualified_type,
    STATE(6338), 1,
      sym_integer,
    STATE(6512), 1,
      sym__type_parens,
    STATE(6513), 1,
      sym__type_tuple,
    STATE(6514), 1,
      sym__type_unboxed_tuple,
    STATE(6515), 1,
      sym__type_unboxed_sum,
    STATE(6516), 1,
      sym__type_list,
    STATE(6517), 1,
      sym__type_apply,
    STATE(6518), 1,
      sym__type_infix,
    STATE(6519), 1,
      sym__plist,
    STATE(7260), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11289), 1,
      aux_sym__qualifying_module,
    ACTIONS(2129), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2135), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6520), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6510), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [27983] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(991), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1795), 1,
      sym_variable,
    ACTIONS(1797), 1,
      anon_sym__,
    ACTIONS(1807), 1,
      sym__cond_quote_start,
    ACTIONS(4899), 1,
      anon_sym_SQUOTE,
    ACTIONS(4901), 1,
      sym_name,
    STATE(443), 1,
      sym__paren_open,
    STATE(565), 1,
      sym_type,
    STATE(784), 1,
      sym__unboxed_open,
    STATE(1042), 1,
      sym__bracket_open,
    STATE(4322), 1,
      sym__qualified_type,
    STATE(4374), 1,
      sym__type_parens,
    STATE(4375), 1,
      sym__type_tuple,
    STATE(4376), 1,
      sym__type_unboxed_tuple,
    STATE(4377), 1,
      sym__type_unboxed_sum,
    STATE(4379), 1,
      sym__type_list,
    STATE(4380), 1,
      sym__type_apply,
    STATE(4381), 1,
      sym__type_infix,
    STATE(4382), 1,
      sym__plist,
    STATE(4597), 1,
      sym_integer,
    STATE(7263), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11266), 1,
      aux_sym__qualifying_module,
    ACTIONS(1803), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(989), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(993), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4383), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4373), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [28111] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1121), 1,
      sym_variable,
    ACTIONS(1127), 1,
      anon_sym__,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1141), 1,
      sym__integer_literal,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1153), 1,
      sym__cond_quote_start,
    ACTIONS(3317), 1,
      anon_sym_SQUOTE,
    ACTIONS(3321), 1,
      sym_name,
    STATE(332), 1,
      sym_type,
    STATE(445), 1,
      sym__paren_open,
    STATE(740), 1,
      sym__unboxed_open,
    STATE(1047), 1,
      sym__bracket_open,
    STATE(2318), 1,
      sym_integer,
    STATE(2335), 1,
      sym__type_parens,
    STATE(2337), 1,
      sym__type_tuple,
    STATE(2338), 1,
      sym__type_unboxed_tuple,
    STATE(2341), 1,
      sym__type_unboxed_sum,
    STATE(2342), 1,
      sym__type_list,
    STATE(2343), 1,
      sym__qualified_type,
    STATE(2350), 1,
      sym__plist,
    STATE(2352), 1,
      sym__type_infix,
    STATE(2353), 1,
      sym__type_apply,
    STATE(7396), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11256), 1,
      aux_sym__qualifying_module,
    ACTIONS(1133), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1139), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1143), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(2348), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(2327), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [28239] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1847), 1,
      sym_variable,
    ACTIONS(1849), 1,
      anon_sym__,
    ACTIONS(1859), 1,
      sym__integer_literal,
    ACTIONS(1865), 1,
      sym__cond_quote_start,
    ACTIONS(4951), 1,
      anon_sym_SQUOTE,
    ACTIONS(4953), 1,
      sym_name,
    STATE(454), 1,
      sym__paren_open,
    STATE(653), 1,
      sym_type,
    STATE(749), 1,
      sym__unboxed_open,
    STATE(1050), 1,
      sym__bracket_open,
    STATE(5812), 1,
      sym__type_tuple,
    STATE(5845), 1,
      sym_integer,
    STATE(5853), 1,
      sym__qualified_type,
    STATE(5859), 1,
      sym__type_list,
    STATE(5860), 1,
      sym__type_apply,
    STATE(5862), 1,
      sym__type_infix,
    STATE(5864), 1,
      sym__plist,
    STATE(5871), 1,
      sym__type_parens,
    STATE(5874), 1,
      sym__type_unboxed_tuple,
    STATE(5875), 1,
      sym__type_unboxed_sum,
    STATE(7272), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11241), 1,
      aux_sym__qualifying_module,
    ACTIONS(1855), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1857), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1861), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5869), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5866), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [28367] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2121), 1,
      sym_variable,
    ACTIONS(2123), 1,
      anon_sym__,
    ACTIONS(2133), 1,
      sym__integer_literal,
    ACTIONS(2139), 1,
      sym__cond_quote_start,
    ACTIONS(3547), 1,
      anon_sym_SQUOTE,
    ACTIONS(3551), 1,
      sym_name,
    STATE(431), 1,
      sym__paren_open,
    STATE(771), 1,
      sym__unboxed_open,
    STATE(779), 1,
      sym_type,
    STATE(1029), 1,
      sym__bracket_open,
    STATE(6245), 1,
      sym__qualified_type,
    STATE(6338), 1,
      sym_integer,
    STATE(6512), 1,
      sym__type_parens,
    STATE(6513), 1,
      sym__type_tuple,
    STATE(6514), 1,
      sym__type_unboxed_tuple,
    STATE(6515), 1,
      sym__type_unboxed_sum,
    STATE(6516), 1,
      sym__type_list,
    STATE(6517), 1,
      sym__type_apply,
    STATE(6518), 1,
      sym__type_infix,
    STATE(6519), 1,
      sym__plist,
    STATE(7260), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11289), 1,
      aux_sym__qualifying_module,
    ACTIONS(2129), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2135), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6520), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6510), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [28495] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2305), 1,
      sym_variable,
    ACTIONS(2307), 1,
      anon_sym__,
    ACTIONS(2317), 1,
      sym__integer_literal,
    ACTIONS(2323), 1,
      sym__cond_quote_start,
    ACTIONS(3445), 1,
      anon_sym_SQUOTE,
    ACTIONS(3449), 1,
      sym_name,
    STATE(429), 1,
      sym__paren_open,
    STATE(755), 1,
      sym__unboxed_open,
    STATE(796), 1,
      sym_type,
    STATE(1061), 1,
      sym__bracket_open,
    STATE(6275), 1,
      sym__plist,
    STATE(6276), 1,
      sym__type_infix,
    STATE(6277), 1,
      sym__type_apply,
    STATE(6278), 1,
      sym__type_list,
    STATE(6279), 1,
      sym__type_unboxed_sum,
    STATE(6280), 1,
      sym__type_unboxed_tuple,
    STATE(6281), 1,
      sym__type_tuple,
    STATE(6282), 1,
      sym__type_parens,
    STATE(6310), 1,
      sym__qualified_type,
    STATE(6535), 1,
      sym_integer,
    STATE(7421), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11228), 1,
      aux_sym__qualifying_module,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2315), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2319), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6273), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6283), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [28623] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3363), 1,
      sym_variable,
    ACTIONS(3365), 1,
      anon_sym__,
    ACTIONS(3375), 1,
      sym__integer_literal,
    ACTIONS(3381), 1,
      sym__cond_quote_start,
    ACTIONS(4971), 1,
      anon_sym_SQUOTE,
    ACTIONS(4973), 1,
      sym_name,
    STATE(457), 1,
      sym__paren_open,
    STATE(813), 1,
      sym__unboxed_open,
    STATE(995), 1,
      sym__bracket_open,
    STATE(1563), 1,
      sym_type,
    STATE(7310), 1,
      sym__splice_dollars,
    STATE(7738), 1,
      sym__qualified_type,
    STATE(7755), 1,
      sym__type_parens,
    STATE(7759), 1,
      sym__type_tuple,
    STATE(7760), 1,
      sym__type_unboxed_tuple,
    STATE(7761), 1,
      sym__type_unboxed_sum,
    STATE(7762), 1,
      sym_integer,
    STATE(7763), 1,
      sym__type_list,
    STATE(7764), 1,
      sym__type_apply,
    STATE(7765), 1,
      sym__type_infix,
    STATE(7766), 1,
      sym__plist,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11318), 1,
      aux_sym__qualifying_module,
    ACTIONS(3371), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3373), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3377), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7767), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7754), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [28751] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1887), 1,
      sym_variable,
    ACTIONS(1889), 1,
      anon_sym__,
    ACTIONS(1899), 1,
      sym__integer_literal,
    ACTIONS(1905), 1,
      sym__cond_quote_start,
    ACTIONS(3299), 1,
      anon_sym_SQUOTE,
    ACTIONS(3303), 1,
      sym_name,
    STATE(460), 1,
      sym__paren_open,
    STATE(668), 1,
      sym_type,
    STATE(826), 1,
      sym__unboxed_open,
    STATE(1045), 1,
      sym__bracket_open,
    STATE(5900), 1,
      sym__plist,
    STATE(5912), 1,
      sym__type_infix,
    STATE(5917), 1,
      sym__type_apply,
    STATE(5923), 1,
      sym__type_list,
    STATE(5927), 1,
      sym__type_unboxed_sum,
    STATE(5928), 1,
      sym__type_unboxed_tuple,
    STATE(5929), 1,
      sym__type_tuple,
    STATE(5938), 1,
      sym__type_parens,
    STATE(5983), 1,
      sym__qualified_type,
    STATE(6013), 1,
      sym_integer,
    STATE(7467), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11083), 1,
      aux_sym__qualifying_module,
    ACTIONS(1895), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1897), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1901), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5894), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5958), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [28879] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1887), 1,
      sym_variable,
    ACTIONS(1889), 1,
      anon_sym__,
    ACTIONS(1899), 1,
      sym__integer_literal,
    ACTIONS(1905), 1,
      sym__cond_quote_start,
    ACTIONS(3299), 1,
      anon_sym_SQUOTE,
    ACTIONS(3303), 1,
      sym_name,
    STATE(460), 1,
      sym__paren_open,
    STATE(667), 1,
      sym_type,
    STATE(826), 1,
      sym__unboxed_open,
    STATE(1045), 1,
      sym__bracket_open,
    STATE(5900), 1,
      sym__plist,
    STATE(5912), 1,
      sym__type_infix,
    STATE(5917), 1,
      sym__type_apply,
    STATE(5923), 1,
      sym__type_list,
    STATE(5927), 1,
      sym__type_unboxed_sum,
    STATE(5928), 1,
      sym__type_unboxed_tuple,
    STATE(5929), 1,
      sym__type_tuple,
    STATE(5938), 1,
      sym__type_parens,
    STATE(5983), 1,
      sym__qualified_type,
    STATE(6013), 1,
      sym_integer,
    STATE(7467), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11083), 1,
      aux_sym__qualifying_module,
    ACTIONS(1895), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1897), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1901), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5894), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5958), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [29007] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1887), 1,
      sym_variable,
    ACTIONS(1889), 1,
      anon_sym__,
    ACTIONS(1899), 1,
      sym__integer_literal,
    ACTIONS(1905), 1,
      sym__cond_quote_start,
    ACTIONS(3299), 1,
      anon_sym_SQUOTE,
    ACTIONS(3303), 1,
      sym_name,
    STATE(460), 1,
      sym__paren_open,
    STATE(661), 1,
      sym_type,
    STATE(826), 1,
      sym__unboxed_open,
    STATE(1045), 1,
      sym__bracket_open,
    STATE(5900), 1,
      sym__plist,
    STATE(5912), 1,
      sym__type_infix,
    STATE(5917), 1,
      sym__type_apply,
    STATE(5923), 1,
      sym__type_list,
    STATE(5927), 1,
      sym__type_unboxed_sum,
    STATE(5928), 1,
      sym__type_unboxed_tuple,
    STATE(5929), 1,
      sym__type_tuple,
    STATE(5938), 1,
      sym__type_parens,
    STATE(5983), 1,
      sym__qualified_type,
    STATE(6013), 1,
      sym_integer,
    STATE(7467), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11083), 1,
      aux_sym__qualifying_module,
    ACTIONS(1895), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1897), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1901), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5894), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5958), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [29135] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1785), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7368), 1,
      sym__type_infix,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [29263] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1827), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(7496), 1,
      sym__type_infix,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [29391] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(721), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1725), 1,
      sym_variable,
    ACTIONS(1727), 1,
      anon_sym__,
    ACTIONS(1737), 1,
      sym__cond_quote_start,
    ACTIONS(4935), 1,
      anon_sym_SQUOTE,
    ACTIONS(4937), 1,
      sym_name,
    STATE(444), 1,
      sym__paren_open,
    STATE(536), 1,
      sym_type,
    STATE(787), 1,
      sym__unboxed_open,
    STATE(1041), 1,
      sym__bracket_open,
    STATE(4078), 1,
      sym__type_parens,
    STATE(4080), 1,
      sym__type_tuple,
    STATE(4081), 1,
      sym__type_unboxed_tuple,
    STATE(4082), 1,
      sym__type_unboxed_sum,
    STATE(4084), 1,
      sym__type_list,
    STATE(4085), 1,
      sym__type_apply,
    STATE(4097), 1,
      sym__plist,
    STATE(4133), 1,
      sym__type_infix,
    STATE(4138), 1,
      sym__qualified_type,
    STATE(4193), 1,
      sym_integer,
    STATE(7390), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11143), 1,
      aux_sym__qualifying_module,
    ACTIONS(1733), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(719), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(723), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4098), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4075), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [29519] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(565), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1689), 1,
      anon_sym__,
    ACTIONS(1693), 1,
      sym_variable,
    ACTIONS(1703), 1,
      sym__cond_quote_start,
    ACTIONS(4915), 1,
      anon_sym_SQUOTE,
    ACTIONS(4917), 1,
      sym_name,
    STATE(462), 1,
      sym__paren_open,
    STATE(519), 1,
      sym_type,
    STATE(768), 1,
      sym__unboxed_open,
    STATE(1063), 1,
      sym__bracket_open,
    STATE(3701), 1,
      sym__type_parens,
    STATE(3702), 1,
      sym__type_tuple,
    STATE(3703), 1,
      sym__qualified_type,
    STATE(3709), 1,
      sym__type_unboxed_tuple,
    STATE(3711), 1,
      sym__type_unboxed_sum,
    STATE(3712), 1,
      sym__type_list,
    STATE(3715), 1,
      sym__type_apply,
    STATE(3717), 1,
      sym__type_infix,
    STATE(3718), 1,
      sym__plist,
    STATE(3781), 1,
      sym_integer,
    STATE(7323), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11219), 1,
      aux_sym__qualifying_module,
    ACTIONS(1691), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(563), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(567), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3721), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3699), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [29647] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2945), 1,
      sym_variable,
    ACTIONS(2947), 1,
      anon_sym__,
    ACTIONS(2957), 1,
      sym__integer_literal,
    ACTIONS(2963), 1,
      sym__cond_quote_start,
    ACTIONS(4354), 1,
      anon_sym_SQUOTE,
    ACTIONS(4360), 1,
      sym_name,
    STATE(448), 1,
      sym__paren_open,
    STATE(824), 1,
      sym__unboxed_open,
    STATE(1009), 1,
      sym__bracket_open,
    STATE(1012), 1,
      sym_type,
    STATE(7206), 1,
      sym_integer,
    STATE(7207), 1,
      sym__type_infix,
    STATE(7208), 1,
      sym__splice_dollars,
    STATE(7209), 1,
      sym__plist,
    STATE(7237), 1,
      sym__type_apply,
    STATE(7246), 1,
      sym__type_unboxed_sum,
    STATE(7247), 1,
      sym__type_list,
    STATE(7258), 1,
      sym__type_unboxed_tuple,
    STATE(7262), 1,
      sym__type_tuple,
    STATE(7268), 1,
      sym__type_parens,
    STATE(7374), 1,
      sym__qualified_type,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11301), 1,
      aux_sym__qualifying_module,
    ACTIONS(2953), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2955), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2959), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7210), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7269), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [29775] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2945), 1,
      sym_variable,
    ACTIONS(2947), 1,
      anon_sym__,
    ACTIONS(2957), 1,
      sym__integer_literal,
    ACTIONS(2963), 1,
      sym__cond_quote_start,
    ACTIONS(4354), 1,
      anon_sym_SQUOTE,
    ACTIONS(4360), 1,
      sym_name,
    STATE(448), 1,
      sym__paren_open,
    STATE(824), 1,
      sym__unboxed_open,
    STATE(1009), 1,
      sym__bracket_open,
    STATE(1013), 1,
      sym_type,
    STATE(7206), 1,
      sym_integer,
    STATE(7207), 1,
      sym__type_infix,
    STATE(7208), 1,
      sym__splice_dollars,
    STATE(7209), 1,
      sym__plist,
    STATE(7237), 1,
      sym__type_apply,
    STATE(7246), 1,
      sym__type_unboxed_sum,
    STATE(7247), 1,
      sym__type_list,
    STATE(7258), 1,
      sym__type_unboxed_tuple,
    STATE(7262), 1,
      sym__type_tuple,
    STATE(7268), 1,
      sym__type_parens,
    STATE(7374), 1,
      sym__qualified_type,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11301), 1,
      aux_sym__qualifying_module,
    ACTIONS(2953), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2955), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2959), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7210), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7269), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [29903] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2945), 1,
      sym_variable,
    ACTIONS(2947), 1,
      anon_sym__,
    ACTIONS(2957), 1,
      sym__integer_literal,
    ACTIONS(2963), 1,
      sym__cond_quote_start,
    ACTIONS(4354), 1,
      anon_sym_SQUOTE,
    ACTIONS(4360), 1,
      sym_name,
    STATE(448), 1,
      sym__paren_open,
    STATE(824), 1,
      sym__unboxed_open,
    STATE(1009), 1,
      sym__bracket_open,
    STATE(1014), 1,
      sym_type,
    STATE(7206), 1,
      sym_integer,
    STATE(7207), 1,
      sym__type_infix,
    STATE(7208), 1,
      sym__splice_dollars,
    STATE(7209), 1,
      sym__plist,
    STATE(7237), 1,
      sym__type_apply,
    STATE(7246), 1,
      sym__type_unboxed_sum,
    STATE(7247), 1,
      sym__type_list,
    STATE(7258), 1,
      sym__type_unboxed_tuple,
    STATE(7262), 1,
      sym__type_tuple,
    STATE(7268), 1,
      sym__type_parens,
    STATE(7374), 1,
      sym__qualified_type,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11301), 1,
      aux_sym__qualifying_module,
    ACTIONS(2953), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2955), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2959), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7210), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7269), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [30031] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1649), 1,
      sym_variable,
    ACTIONS(1651), 1,
      anon_sym__,
    ACTIONS(1661), 1,
      sym__integer_literal,
    ACTIONS(1667), 1,
      sym__cond_quote_start,
    ACTIONS(3357), 1,
      anon_sym_SQUOTE,
    ACTIONS(3361), 1,
      sym_name,
    STATE(465), 1,
      sym__paren_open,
    STATE(506), 1,
      sym_type,
    STATE(772), 1,
      sym__unboxed_open,
    STATE(1069), 1,
      sym__bracket_open,
    STATE(3435), 1,
      sym_integer,
    STATE(3559), 1,
      sym__plist,
    STATE(3561), 1,
      sym__type_infix,
    STATE(3567), 1,
      sym__type_apply,
    STATE(3569), 1,
      sym__type_list,
    STATE(3570), 1,
      sym__type_unboxed_sum,
    STATE(3572), 1,
      sym__type_unboxed_tuple,
    STATE(3576), 1,
      sym__type_tuple,
    STATE(3579), 1,
      sym__type_parens,
    STATE(3610), 1,
      sym__qualified_type,
    STATE(7292), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11208), 1,
      aux_sym__qualifying_module,
    ACTIONS(1657), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1659), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1663), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3556), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3582), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [30159] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(309), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1305), 1,
      sym_variable,
    ACTIONS(1307), 1,
      anon_sym__,
    ACTIONS(1317), 1,
      sym__cond_quote_start,
    ACTIONS(4927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4929), 1,
      sym_name,
    STATE(415), 1,
      sym_type,
    STATE(432), 1,
      sym__paren_open,
    STATE(753), 1,
      sym__unboxed_open,
    STATE(1055), 1,
      sym__bracket_open,
    STATE(2693), 1,
      sym__plist,
    STATE(2697), 1,
      sym__qualified_type,
    STATE(2713), 1,
      sym__type_infix,
    STATE(2729), 1,
      sym__type_tuple,
    STATE(2733), 1,
      sym__type_parens,
    STATE(2734), 1,
      sym_integer,
    STATE(2745), 1,
      sym__type_apply,
    STATE(2746), 1,
      sym__type_unboxed_sum,
    STATE(2749), 1,
      sym__type_list,
    STATE(2751), 1,
      sym__type_unboxed_tuple,
    STATE(7364), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10987), 1,
      aux_sym__qualifying_module,
    ACTIONS(1313), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(307), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(311), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(2694), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(2710), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [30287] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 42,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [30363] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1569), 1,
      sym_variable,
    ACTIONS(1571), 1,
      anon_sym__,
    ACTIONS(1581), 1,
      sym__integer_literal,
    ACTIONS(1587), 1,
      sym__cond_quote_start,
    ACTIONS(3439), 1,
      anon_sym_SQUOTE,
    ACTIONS(3443), 1,
      sym_name,
    STATE(466), 1,
      sym__paren_open,
    STATE(488), 1,
      sym_type,
    STATE(781), 1,
      sym__unboxed_open,
    STATE(1073), 1,
      sym__bracket_open,
    STATE(3177), 1,
      sym__plist,
    STATE(3184), 1,
      sym__type_unboxed_tuple,
    STATE(3188), 1,
      sym__type_unboxed_sum,
    STATE(3196), 1,
      sym__type_apply,
    STATE(3210), 1,
      sym__type_tuple,
    STATE(3211), 1,
      sym__type_list,
    STATE(3220), 1,
      sym__type_parens,
    STATE(3225), 1,
      sym__type_infix,
    STATE(3262), 1,
      sym__qualified_type,
    STATE(3397), 1,
      sym_integer,
    STATE(7401), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11198), 1,
      aux_sym__qualifying_module,
    ACTIONS(1577), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1579), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1583), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3232), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3364), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [30491] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1827), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(7547), 1,
      sym__type_infix,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [30619] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(677), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1711), 1,
      sym_variable,
    ACTIONS(1713), 1,
      anon_sym__,
    ACTIONS(1723), 1,
      sym__cond_quote_start,
    ACTIONS(4931), 1,
      anon_sym_SQUOTE,
    ACTIONS(4933), 1,
      sym_name,
    STATE(452), 1,
      sym__paren_open,
    STATE(543), 1,
      sym_type,
    STATE(806), 1,
      sym__unboxed_open,
    STATE(1122), 1,
      sym__bracket_open,
    STATE(3989), 1,
      sym__type_tuple,
    STATE(3996), 1,
      sym__type_parens,
    STATE(4000), 1,
      sym__type_unboxed_tuple,
    STATE(4001), 1,
      sym__type_unboxed_sum,
    STATE(4003), 1,
      sym__type_list,
    STATE(4004), 1,
      sym__type_apply,
    STATE(4005), 1,
      sym__type_infix,
    STATE(4006), 1,
      sym__plist,
    STATE(4067), 1,
      sym_integer,
    STATE(4144), 1,
      sym__qualified_type,
    STATE(7478), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11120), 1,
      aux_sym__qualifying_module,
    ACTIONS(1719), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(675), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(679), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3997), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3975), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [30747] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(677), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1711), 1,
      sym_variable,
    ACTIONS(1713), 1,
      anon_sym__,
    ACTIONS(1723), 1,
      sym__cond_quote_start,
    ACTIONS(4931), 1,
      anon_sym_SQUOTE,
    ACTIONS(4933), 1,
      sym_name,
    STATE(452), 1,
      sym__paren_open,
    STATE(527), 1,
      sym_type,
    STATE(806), 1,
      sym__unboxed_open,
    STATE(1122), 1,
      sym__bracket_open,
    STATE(3989), 1,
      sym__type_tuple,
    STATE(3996), 1,
      sym__type_parens,
    STATE(4000), 1,
      sym__type_unboxed_tuple,
    STATE(4001), 1,
      sym__type_unboxed_sum,
    STATE(4003), 1,
      sym__type_list,
    STATE(4004), 1,
      sym__type_apply,
    STATE(4005), 1,
      sym__type_infix,
    STATE(4006), 1,
      sym__plist,
    STATE(4067), 1,
      sym_integer,
    STATE(4144), 1,
      sym__qualified_type,
    STATE(7478), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11120), 1,
      aux_sym__qualifying_module,
    ACTIONS(1719), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(675), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(679), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3997), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3975), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [30875] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(677), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1711), 1,
      sym_variable,
    ACTIONS(1713), 1,
      anon_sym__,
    ACTIONS(1723), 1,
      sym__cond_quote_start,
    ACTIONS(4931), 1,
      anon_sym_SQUOTE,
    ACTIONS(4933), 1,
      sym_name,
    STATE(452), 1,
      sym__paren_open,
    STATE(529), 1,
      sym_type,
    STATE(806), 1,
      sym__unboxed_open,
    STATE(1122), 1,
      sym__bracket_open,
    STATE(3989), 1,
      sym__type_tuple,
    STATE(3996), 1,
      sym__type_parens,
    STATE(4000), 1,
      sym__type_unboxed_tuple,
    STATE(4001), 1,
      sym__type_unboxed_sum,
    STATE(4003), 1,
      sym__type_list,
    STATE(4004), 1,
      sym__type_apply,
    STATE(4005), 1,
      sym__type_infix,
    STATE(4006), 1,
      sym__plist,
    STATE(4067), 1,
      sym_integer,
    STATE(4144), 1,
      sym__qualified_type,
    STATE(7478), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11120), 1,
      aux_sym__qualifying_module,
    ACTIONS(1719), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(675), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(679), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3997), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3975), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [31003] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(909), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1753), 1,
      anon_sym__,
    ACTIONS(1757), 1,
      sym_variable,
    ACTIONS(1765), 1,
      sym__cond_quote_start,
    ACTIONS(4903), 1,
      anon_sym_SQUOTE,
    ACTIONS(4905), 1,
      sym_name,
    STATE(471), 1,
      sym__paren_open,
    STATE(552), 1,
      sym_type,
    STATE(778), 1,
      sym__unboxed_open,
    STATE(1071), 1,
      sym__bracket_open,
    STATE(4235), 1,
      sym__plist,
    STATE(4241), 1,
      sym__type_infix,
    STATE(4248), 1,
      sym__qualified_type,
    STATE(4258), 1,
      sym__type_parens,
    STATE(4261), 1,
      sym__type_tuple,
    STATE(4262), 1,
      sym__type_unboxed_tuple,
    STATE(4263), 1,
      sym__type_unboxed_sum,
    STATE(4264), 1,
      sym__type_list,
    STATE(4265), 1,
      sym__type_apply,
    STATE(4282), 1,
      sym_integer,
    STATE(7317), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11227), 1,
      aux_sym__qualifying_module,
    ACTIONS(1755), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(907), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(911), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4275), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4257), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [31131] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3203), 1,
      sym_variable,
    ACTIONS(3205), 1,
      anon_sym__,
    ACTIONS(3215), 1,
      sym__integer_literal,
    ACTIONS(3221), 1,
      sym__cond_quote_start,
    ACTIONS(4140), 1,
      anon_sym_SQUOTE,
    ACTIONS(4144), 1,
      sym_name,
    STATE(434), 1,
      sym__paren_open,
    STATE(763), 1,
      sym__unboxed_open,
    STATE(963), 1,
      sym__bracket_open,
    STATE(1296), 1,
      sym_type,
    STATE(7479), 1,
      sym__splice_dollars,
    STATE(7579), 1,
      sym__plist,
    STATE(7580), 1,
      sym__type_infix,
    STATE(7581), 1,
      sym__type_apply,
    STATE(7585), 1,
      sym__type_parens,
    STATE(7587), 1,
      sym__qualified_type,
    STATE(7589), 1,
      sym__type_list,
    STATE(7591), 1,
      sym__type_unboxed_sum,
    STATE(7595), 1,
      sym_integer,
    STATE(7602), 1,
      sym__type_tuple,
    STATE(7615), 1,
      sym__type_unboxed_tuple,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10889), 1,
      aux_sym__qualifying_module,
    ACTIONS(3211), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3213), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3217), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7569), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7555), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [31259] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1823), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(7875), 1,
      sym__type_infix,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [31387] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1485), 1,
      sym__linear_fun_arrow,
    STATE(1493), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4594), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4596), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [31479] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1907), 1,
      sym_variable,
    ACTIONS(1909), 1,
      anon_sym__,
    ACTIONS(1919), 1,
      sym__integer_literal,
    ACTIONS(1925), 1,
      sym__cond_quote_start,
    ACTIONS(4883), 1,
      anon_sym_SQUOTE,
    ACTIONS(4885), 1,
      sym_name,
    STATE(475), 1,
      sym__paren_open,
    STATE(671), 1,
      sym_type,
    STATE(788), 1,
      sym__unboxed_open,
    STATE(1067), 1,
      sym__bracket_open,
    STATE(5902), 1,
      sym_integer,
    STATE(5944), 1,
      sym__type_parens,
    STATE(5945), 1,
      sym__type_tuple,
    STATE(5946), 1,
      sym__type_unboxed_tuple,
    STATE(5947), 1,
      sym__type_unboxed_sum,
    STATE(5948), 1,
      sym__type_list,
    STATE(5949), 1,
      sym__type_apply,
    STATE(5950), 1,
      sym__type_infix,
    STATE(5951), 1,
      sym__plist,
    STATE(5976), 1,
      sym__qualified_type,
    STATE(7347), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11157), 1,
      aux_sym__qualifying_module,
    ACTIONS(1915), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1917), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1921), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5952), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5942), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [31607] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1907), 1,
      sym_variable,
    ACTIONS(1909), 1,
      anon_sym__,
    ACTIONS(1919), 1,
      sym__integer_literal,
    ACTIONS(1925), 1,
      sym__cond_quote_start,
    ACTIONS(4883), 1,
      anon_sym_SQUOTE,
    ACTIONS(4885), 1,
      sym_name,
    STATE(475), 1,
      sym__paren_open,
    STATE(669), 1,
      sym_type,
    STATE(788), 1,
      sym__unboxed_open,
    STATE(1067), 1,
      sym__bracket_open,
    STATE(5902), 1,
      sym_integer,
    STATE(5944), 1,
      sym__type_parens,
    STATE(5945), 1,
      sym__type_tuple,
    STATE(5946), 1,
      sym__type_unboxed_tuple,
    STATE(5947), 1,
      sym__type_unboxed_sum,
    STATE(5948), 1,
      sym__type_list,
    STATE(5949), 1,
      sym__type_apply,
    STATE(5950), 1,
      sym__type_infix,
    STATE(5951), 1,
      sym__plist,
    STATE(5976), 1,
      sym__qualified_type,
    STATE(7347), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11157), 1,
      aux_sym__qualifying_module,
    ACTIONS(1915), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1917), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1921), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5952), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5942), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [31735] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1907), 1,
      sym_variable,
    ACTIONS(1909), 1,
      anon_sym__,
    ACTIONS(1919), 1,
      sym__integer_literal,
    ACTIONS(1925), 1,
      sym__cond_quote_start,
    ACTIONS(4883), 1,
      anon_sym_SQUOTE,
    ACTIONS(4885), 1,
      sym_name,
    STATE(475), 1,
      sym__paren_open,
    STATE(660), 1,
      sym_type,
    STATE(788), 1,
      sym__unboxed_open,
    STATE(1067), 1,
      sym__bracket_open,
    STATE(5902), 1,
      sym_integer,
    STATE(5944), 1,
      sym__type_parens,
    STATE(5945), 1,
      sym__type_tuple,
    STATE(5946), 1,
      sym__type_unboxed_tuple,
    STATE(5947), 1,
      sym__type_unboxed_sum,
    STATE(5948), 1,
      sym__type_list,
    STATE(5949), 1,
      sym__type_apply,
    STATE(5950), 1,
      sym__type_infix,
    STATE(5951), 1,
      sym__plist,
    STATE(5976), 1,
      sym__qualified_type,
    STATE(7347), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11157), 1,
      aux_sym__qualifying_module,
    ACTIONS(1915), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1917), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1921), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5952), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5942), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [31863] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1941), 1,
      sym__integer_literal,
    ACTIONS(1953), 1,
      sym__cond_quote_start,
    ACTIONS(1955), 1,
      sym_variable,
    ACTIONS(1957), 1,
      anon_sym__,
    ACTIONS(4911), 1,
      anon_sym_SQUOTE,
    ACTIONS(4913), 1,
      sym_name,
    STATE(453), 1,
      sym__paren_open,
    STATE(715), 1,
      sym_type,
    STATE(815), 1,
      sym__unboxed_open,
    STATE(1072), 1,
      sym__bracket_open,
    STATE(6064), 1,
      sym__type_infix,
    STATE(6085), 1,
      sym__type_tuple,
    STATE(6100), 1,
      sym__type_parens,
    STATE(6116), 1,
      sym__plist,
    STATE(6118), 1,
      sym__type_apply,
    STATE(6120), 1,
      sym__type_list,
    STATE(6122), 1,
      sym__type_unboxed_sum,
    STATE(6123), 1,
      sym__type_unboxed_tuple,
    STATE(6125), 1,
      sym_integer,
    STATE(6171), 1,
      sym__qualified_type,
    STATE(7221), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11317), 1,
      aux_sym__qualifying_module,
    ACTIONS(1963), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1939), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1943), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6112), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6129), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [31991] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1609), 1,
      sym_variable,
    ACTIONS(1611), 1,
      anon_sym__,
    ACTIONS(1621), 1,
      sym__integer_literal,
    ACTIONS(1627), 1,
      sym__cond_quote_start,
    ACTIONS(3383), 1,
      anon_sym_SQUOTE,
    ACTIONS(3387), 1,
      sym_name,
    STATE(464), 1,
      sym__paren_open,
    STATE(497), 1,
      sym_type,
    STATE(805), 1,
      sym__unboxed_open,
    STATE(1079), 1,
      sym__bracket_open,
    STATE(3269), 1,
      sym_integer,
    STATE(3357), 1,
      sym__plist,
    STATE(3358), 1,
      sym__type_infix,
    STATE(3359), 1,
      sym__type_apply,
    STATE(3361), 1,
      sym__type_list,
    STATE(3369), 1,
      sym__type_unboxed_sum,
    STATE(3370), 1,
      sym__type_unboxed_tuple,
    STATE(3377), 1,
      sym__type_tuple,
    STATE(3379), 1,
      sym__type_parens,
    STATE(3410), 1,
      sym__qualified_type,
    STATE(7460), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11178), 1,
      aux_sym__qualifying_module,
    ACTIONS(1617), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1619), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1623), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3354), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3383), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [32119] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1485), 1,
      sym__linear_fun_arrow,
    STATE(1493), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4578), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4580), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [32211] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3247), 1,
      sym_variable,
    ACTIONS(3249), 1,
      anon_sym__,
    ACTIONS(3259), 1,
      sym__integer_literal,
    ACTIONS(3265), 1,
      sym__cond_quote_start,
    ACTIONS(4477), 1,
      anon_sym_SQUOTE,
    ACTIONS(4479), 1,
      sym_name,
    STATE(463), 1,
      sym__paren_open,
    STATE(825), 1,
      sym__unboxed_open,
    STATE(1066), 1,
      sym__bracket_open,
    STATE(1375), 1,
      sym_type,
    STATE(7311), 1,
      sym__splice_dollars,
    STATE(7653), 1,
      sym_integer,
    STATE(7676), 1,
      sym__plist,
    STATE(7677), 1,
      sym__qualified_type,
    STATE(7686), 1,
      sym__type_unboxed_tuple,
    STATE(7690), 1,
      sym__type_apply,
    STATE(7696), 1,
      sym__type_list,
    STATE(7703), 1,
      sym__type_unboxed_sum,
    STATE(7716), 1,
      sym__type_infix,
    STATE(7721), 1,
      sym__type_tuple,
    STATE(7722), 1,
      sym__type_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10972), 1,
      aux_sym__qualifying_module,
    ACTIONS(3255), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3257), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3261), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7664), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7670), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [32339] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2461), 1,
      sym_variable,
    ACTIONS(2463), 1,
      anon_sym__,
    ACTIONS(2469), 1,
      sym__integer_literal,
    ACTIONS(2475), 1,
      sym__cond_quote_start,
    ACTIONS(4895), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      sym_name,
    STATE(442), 1,
      sym__paren_open,
    STATE(762), 1,
      sym__unboxed_open,
    STATE(812), 1,
      sym_type,
    STATE(962), 1,
      sym__bracket_open,
    STATE(6231), 1,
      sym_integer,
    STATE(6337), 1,
      sym__type_tuple,
    STATE(6345), 1,
      sym__plist,
    STATE(6346), 1,
      sym__type_infix,
    STATE(6347), 1,
      sym__type_apply,
    STATE(6349), 1,
      sym__type_list,
    STATE(6350), 1,
      sym__type_unboxed_sum,
    STATE(6351), 1,
      sym__type_unboxed_tuple,
    STATE(6363), 1,
      sym__type_parens,
    STATE(6444), 1,
      sym__qualified_type,
    STATE(7313), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11194), 1,
      aux_sym__qualifying_module,
    ACTIONS(2063), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2467), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2471), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6341), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6364), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [32467] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1819), 1,
      sym_variable,
    ACTIONS(1821), 1,
      anon_sym__,
    ACTIONS(1825), 1,
      sym__integer_literal,
    ACTIONS(1831), 1,
      sym__cond_quote_start,
    ACTIONS(4961), 1,
      anon_sym_SQUOTE,
    ACTIONS(4963), 1,
      sym_name,
    STATE(476), 1,
      sym__paren_open,
    STATE(578), 1,
      sym_type,
    STATE(802), 1,
      sym__unboxed_open,
    STATE(987), 1,
      sym__bracket_open,
    STATE(4880), 1,
      sym__type_parens,
    STATE(4881), 1,
      sym__type_tuple,
    STATE(4882), 1,
      sym__type_unboxed_tuple,
    STATE(4885), 1,
      sym__type_unboxed_sum,
    STATE(4886), 1,
      sym__type_list,
    STATE(4887), 1,
      sym__type_apply,
    STATE(4890), 1,
      sym__type_infix,
    STATE(4891), 1,
      sym__plist,
    STATE(5078), 1,
      sym__qualified_type,
    STATE(5100), 1,
      sym_integer,
    STATE(7289), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10957), 1,
      aux_sym__qualifying_module,
    ACTIONS(1817), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1823), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1827), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4892), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4879), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [32595] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2461), 1,
      sym_variable,
    ACTIONS(2463), 1,
      anon_sym__,
    ACTIONS(2469), 1,
      sym__integer_literal,
    ACTIONS(2475), 1,
      sym__cond_quote_start,
    ACTIONS(4895), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      sym_name,
    STATE(442), 1,
      sym__paren_open,
    STATE(762), 1,
      sym__unboxed_open,
    STATE(811), 1,
      sym_type,
    STATE(962), 1,
      sym__bracket_open,
    STATE(6231), 1,
      sym_integer,
    STATE(6337), 1,
      sym__type_tuple,
    STATE(6345), 1,
      sym__plist,
    STATE(6346), 1,
      sym__type_infix,
    STATE(6347), 1,
      sym__type_apply,
    STATE(6349), 1,
      sym__type_list,
    STATE(6350), 1,
      sym__type_unboxed_sum,
    STATE(6351), 1,
      sym__type_unboxed_tuple,
    STATE(6363), 1,
      sym__type_parens,
    STATE(6444), 1,
      sym__qualified_type,
    STATE(7313), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11194), 1,
      aux_sym__qualifying_module,
    ACTIONS(2063), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2467), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2471), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6341), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6364), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [32723] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(765), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1739), 1,
      anon_sym__,
    ACTIONS(1743), 1,
      sym_variable,
    ACTIONS(1751), 1,
      sym__cond_quote_start,
    ACTIONS(4947), 1,
      anon_sym_SQUOTE,
    ACTIONS(4949), 1,
      sym_name,
    STATE(470), 1,
      sym__paren_open,
    STATE(531), 1,
      sym_type,
    STATE(734), 1,
      sym__unboxed_open,
    STATE(1007), 1,
      sym__bracket_open,
    STATE(3988), 1,
      sym__type_unboxed_tuple,
    STATE(4020), 1,
      sym__type_tuple,
    STATE(4027), 1,
      sym__type_parens,
    STATE(4041), 1,
      sym__plist,
    STATE(4047), 1,
      sym__type_apply,
    STATE(4056), 1,
      sym__type_list,
    STATE(4061), 1,
      sym__qualified_type,
    STATE(4088), 1,
      sym__type_infix,
    STATE(4148), 1,
      sym_integer,
    STATE(4177), 1,
      sym__type_unboxed_sum,
    STATE(7343), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11047), 1,
      aux_sym__qualifying_module,
    ACTIONS(1741), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(763), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(767), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4046), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4029), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [32851] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3057), 1,
      sym_variable,
    ACTIONS(3059), 1,
      anon_sym__,
    ACTIONS(3063), 1,
      sym__integer_literal,
    ACTIONS(3069), 1,
      sym__cond_quote_start,
    ACTIONS(4939), 1,
      anon_sym_SQUOTE,
    ACTIONS(4941), 1,
      sym_name,
    STATE(474), 1,
      sym__paren_open,
    STATE(733), 1,
      sym__unboxed_open,
    STATE(1124), 1,
      sym__bracket_open,
    STATE(1129), 1,
      sym_type,
    STATE(7240), 1,
      sym__type_infix,
    STATE(7267), 1,
      sym__qualified_type,
    STATE(7270), 1,
      sym__splice_dollars,
    STATE(7274), 1,
      sym_integer,
    STATE(7416), 1,
      sym__type_parens,
    STATE(7417), 1,
      sym__type_tuple,
    STATE(7424), 1,
      sym__type_unboxed_tuple,
    STATE(7426), 1,
      sym__type_unboxed_sum,
    STATE(7427), 1,
      sym__type_list,
    STATE(7428), 1,
      sym__type_apply,
    STATE(7429), 1,
      sym__plist,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10936), 1,
      aux_sym__qualifying_module,
    ACTIONS(3055), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3061), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3065), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7438), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7415), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [32979] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2461), 1,
      sym_variable,
    ACTIONS(2463), 1,
      anon_sym__,
    ACTIONS(2469), 1,
      sym__integer_literal,
    ACTIONS(2475), 1,
      sym__cond_quote_start,
    ACTIONS(4895), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      sym_name,
    STATE(442), 1,
      sym__paren_open,
    STATE(762), 1,
      sym__unboxed_open,
    STATE(807), 1,
      sym_type,
    STATE(962), 1,
      sym__bracket_open,
    STATE(6231), 1,
      sym_integer,
    STATE(6337), 1,
      sym__type_tuple,
    STATE(6345), 1,
      sym__plist,
    STATE(6346), 1,
      sym__type_infix,
    STATE(6347), 1,
      sym__type_apply,
    STATE(6349), 1,
      sym__type_list,
    STATE(6350), 1,
      sym__type_unboxed_sum,
    STATE(6351), 1,
      sym__type_unboxed_tuple,
    STATE(6363), 1,
      sym__type_parens,
    STATE(6444), 1,
      sym__qualified_type,
    STATE(7313), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11194), 1,
      aux_sym__qualifying_module,
    ACTIONS(2063), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2467), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2471), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6341), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6364), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [33107] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1629), 1,
      sym_variable,
    ACTIONS(1631), 1,
      anon_sym__,
    ACTIONS(1641), 1,
      sym__integer_literal,
    ACTIONS(1647), 1,
      sym__cond_quote_start,
    ACTIONS(3305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3309), 1,
      sym_name,
    STATE(447), 1,
      sym__paren_open,
    STATE(491), 1,
      sym_type,
    STATE(743), 1,
      sym__unboxed_open,
    STATE(976), 1,
      sym__bracket_open,
    STATE(3185), 1,
      sym__plist,
    STATE(3189), 1,
      sym__type_infix,
    STATE(3195), 1,
      sym__type_apply,
    STATE(3198), 1,
      sym__type_list,
    STATE(3209), 1,
      sym__type_unboxed_sum,
    STATE(3214), 1,
      sym__type_unboxed_tuple,
    STATE(3215), 1,
      sym__type_tuple,
    STATE(3217), 1,
      sym__type_parens,
    STATE(3330), 1,
      sym_integer,
    STATE(3420), 1,
      sym__qualified_type,
    STATE(7385), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11305), 1,
      aux_sym__qualifying_module,
    ACTIONS(1637), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1639), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1643), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3183), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3219), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [33235] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1093), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1809), 1,
      anon_sym__,
    ACTIONS(1833), 1,
      sym_variable,
    ACTIONS(1841), 1,
      sym__cond_quote_start,
    ACTIONS(4907), 1,
      anon_sym_SQUOTE,
    ACTIONS(4909), 1,
      sym_name,
    STATE(451), 1,
      sym__paren_open,
    STATE(577), 1,
      sym_type,
    STATE(817), 1,
      sym__unboxed_open,
    STATE(1084), 1,
      sym__bracket_open,
    STATE(4963), 1,
      sym__qualified_type,
    STATE(5034), 1,
      sym__plist,
    STATE(5035), 1,
      sym__type_infix,
    STATE(5036), 1,
      sym__type_apply,
    STATE(5038), 1,
      sym__type_list,
    STATE(5039), 1,
      sym__type_unboxed_sum,
    STATE(5041), 1,
      sym__type_unboxed_tuple,
    STATE(5042), 1,
      sym__type_tuple,
    STATE(5044), 1,
      sym__type_parens,
    STATE(5084), 1,
      sym_integer,
    STATE(7449), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11170), 1,
      aux_sym__qualifying_module,
    ACTIONS(1811), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1091), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1095), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5033), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5046), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [33363] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2627), 1,
      sym_variable,
    ACTIONS(2629), 1,
      anon_sym__,
    ACTIONS(2639), 1,
      sym__integer_literal,
    ACTIONS(2645), 1,
      sym__cond_quote_start,
    ACTIONS(3311), 1,
      anon_sym_SQUOTE,
    ACTIONS(3315), 1,
      sym_name,
    STATE(438), 1,
      sym__paren_open,
    STATE(757), 1,
      sym__unboxed_open,
    STATE(851), 1,
      sym_type,
    STATE(966), 1,
      sym__bracket_open,
    STATE(6698), 1,
      sym__type_apply,
    STATE(6754), 1,
      sym_integer,
    STATE(6766), 1,
      sym__type_parens,
    STATE(6767), 1,
      sym__type_tuple,
    STATE(6768), 1,
      sym__type_unboxed_tuple,
    STATE(6769), 1,
      sym__type_unboxed_sum,
    STATE(6770), 1,
      sym__type_list,
    STATE(6780), 1,
      sym__type_infix,
    STATE(6782), 1,
      sym__plist,
    STATE(6803), 1,
      sym__qualified_type,
    STATE(7306), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11231), 1,
      aux_sym__qualifying_module,
    ACTIONS(2635), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2637), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2641), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6783), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6765), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [33491] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2627), 1,
      sym_variable,
    ACTIONS(2629), 1,
      anon_sym__,
    ACTIONS(2639), 1,
      sym__integer_literal,
    ACTIONS(2645), 1,
      sym__cond_quote_start,
    ACTIONS(3311), 1,
      anon_sym_SQUOTE,
    ACTIONS(3315), 1,
      sym_name,
    STATE(438), 1,
      sym__paren_open,
    STATE(757), 1,
      sym__unboxed_open,
    STATE(852), 1,
      sym_type,
    STATE(966), 1,
      sym__bracket_open,
    STATE(6698), 1,
      sym__type_apply,
    STATE(6754), 1,
      sym_integer,
    STATE(6766), 1,
      sym__type_parens,
    STATE(6767), 1,
      sym__type_tuple,
    STATE(6768), 1,
      sym__type_unboxed_tuple,
    STATE(6769), 1,
      sym__type_unboxed_sum,
    STATE(6770), 1,
      sym__type_list,
    STATE(6780), 1,
      sym__type_infix,
    STATE(6782), 1,
      sym__plist,
    STATE(6803), 1,
      sym__qualified_type,
    STATE(7306), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11231), 1,
      aux_sym__qualifying_module,
    ACTIONS(2635), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2637), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2641), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6783), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6765), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [33619] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2627), 1,
      sym_variable,
    ACTIONS(2629), 1,
      anon_sym__,
    ACTIONS(2639), 1,
      sym__integer_literal,
    ACTIONS(2645), 1,
      sym__cond_quote_start,
    ACTIONS(3311), 1,
      anon_sym_SQUOTE,
    ACTIONS(3315), 1,
      sym_name,
    STATE(438), 1,
      sym__paren_open,
    STATE(757), 1,
      sym__unboxed_open,
    STATE(869), 1,
      sym_type,
    STATE(966), 1,
      sym__bracket_open,
    STATE(6698), 1,
      sym__type_apply,
    STATE(6754), 1,
      sym_integer,
    STATE(6766), 1,
      sym__type_parens,
    STATE(6767), 1,
      sym__type_tuple,
    STATE(6768), 1,
      sym__type_unboxed_tuple,
    STATE(6769), 1,
      sym__type_unboxed_sum,
    STATE(6770), 1,
      sym__type_list,
    STATE(6780), 1,
      sym__type_infix,
    STATE(6782), 1,
      sym__plist,
    STATE(6803), 1,
      sym__qualified_type,
    STATE(7306), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11231), 1,
      aux_sym__qualifying_module,
    ACTIONS(2635), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2637), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2641), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6783), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6765), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [33747] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1485), 1,
      sym__linear_fun_arrow,
    STATE(1493), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4586), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4588), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [33839] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3057), 1,
      sym_variable,
    ACTIONS(3059), 1,
      anon_sym__,
    ACTIONS(3063), 1,
      sym__integer_literal,
    ACTIONS(3069), 1,
      sym__cond_quote_start,
    ACTIONS(4939), 1,
      anon_sym_SQUOTE,
    ACTIONS(4941), 1,
      sym_name,
    STATE(474), 1,
      sym__paren_open,
    STATE(733), 1,
      sym__unboxed_open,
    STATE(1124), 1,
      sym__bracket_open,
    STATE(1127), 1,
      sym_type,
    STATE(7240), 1,
      sym__type_infix,
    STATE(7267), 1,
      sym__qualified_type,
    STATE(7270), 1,
      sym__splice_dollars,
    STATE(7274), 1,
      sym_integer,
    STATE(7416), 1,
      sym__type_parens,
    STATE(7417), 1,
      sym__type_tuple,
    STATE(7424), 1,
      sym__type_unboxed_tuple,
    STATE(7426), 1,
      sym__type_unboxed_sum,
    STATE(7427), 1,
      sym__type_list,
    STATE(7428), 1,
      sym__type_apply,
    STATE(7429), 1,
      sym__plist,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10936), 1,
      aux_sym__qualifying_module,
    ACTIONS(3055), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3061), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3065), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7438), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7415), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [33967] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2923), 1,
      sym_variable,
    ACTIONS(2925), 1,
      anon_sym__,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(2941), 1,
      sym__cond_quote_start,
    ACTIONS(4346), 1,
      anon_sym_SQUOTE,
    ACTIONS(4348), 1,
      sym_name,
    STATE(439), 1,
      sym__paren_open,
    STATE(786), 1,
      sym__unboxed_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(1826), 1,
      sym_type,
    STATE(7229), 1,
      sym__qualified_type,
    STATE(7302), 1,
      sym__type_parens,
    STATE(7305), 1,
      sym__type_tuple,
    STATE(7308), 1,
      sym__type_unboxed_tuple,
    STATE(7318), 1,
      sym__type_unboxed_sum,
    STATE(7353), 1,
      sym__type_list,
    STATE(7359), 1,
      sym__type_apply,
    STATE(7361), 1,
      sym_integer,
    STATE(7383), 1,
      sym__plist,
    STATE(7486), 1,
      sym__splice_dollars,
    STATE(7711), 1,
      sym__type_infix,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11043), 1,
      aux_sym__qualifying_module,
    ACTIONS(2931), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7439), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7300), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [34095] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2757), 1,
      sym_variable,
    ACTIONS(2761), 1,
      anon_sym__,
    ACTIONS(2773), 1,
      sym__integer_literal,
    ACTIONS(2779), 1,
      sym__cond_quote_start,
    ACTIONS(4342), 1,
      anon_sym_SQUOTE,
    ACTIONS(4344), 1,
      sym_name,
    STATE(450), 1,
      sym__paren_open,
    STATE(831), 1,
      sym__unboxed_open,
    STATE(929), 1,
      sym_type,
    STATE(1027), 1,
      sym__bracket_open,
    STATE(7036), 1,
      sym_integer,
    STATE(7079), 1,
      sym__qualified_type,
    STATE(7142), 1,
      sym__type_parens,
    STATE(7143), 1,
      sym__type_tuple,
    STATE(7144), 1,
      sym__type_unboxed_tuple,
    STATE(7145), 1,
      sym__type_unboxed_sum,
    STATE(7146), 1,
      sym__type_list,
    STATE(7147), 1,
      sym__type_apply,
    STATE(7148), 1,
      sym__type_infix,
    STATE(7149), 1,
      sym__plist,
    STATE(7440), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11165), 1,
      aux_sym__qualifying_module,
    ACTIONS(2767), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2771), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2775), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7150), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7140), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [34223] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(677), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1711), 1,
      sym_variable,
    ACTIONS(1713), 1,
      anon_sym__,
    ACTIONS(1723), 1,
      sym__cond_quote_start,
    ACTIONS(4931), 1,
      anon_sym_SQUOTE,
    ACTIONS(4933), 1,
      sym_name,
    STATE(452), 1,
      sym__paren_open,
    STATE(534), 1,
      sym_type,
    STATE(806), 1,
      sym__unboxed_open,
    STATE(1122), 1,
      sym__bracket_open,
    STATE(3989), 1,
      sym__type_tuple,
    STATE(3996), 1,
      sym__type_parens,
    STATE(4000), 1,
      sym__type_unboxed_tuple,
    STATE(4001), 1,
      sym__type_unboxed_sum,
    STATE(4003), 1,
      sym__type_list,
    STATE(4004), 1,
      sym__type_apply,
    STATE(4005), 1,
      sym__type_infix,
    STATE(4006), 1,
      sym__plist,
    STATE(4067), 1,
      sym_integer,
    STATE(4144), 1,
      sym__qualified_type,
    STATE(7478), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11120), 1,
      aux_sym__qualifying_module,
    ACTIONS(1719), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(675), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(679), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3997), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3975), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [34351] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1975), 1,
      sym_variable,
    ACTIONS(1977), 1,
      anon_sym__,
    ACTIONS(1981), 1,
      sym__integer_literal,
    ACTIONS(1987), 1,
      sym__cond_quote_start,
    ACTIONS(4891), 1,
      anon_sym_SQUOTE,
    ACTIONS(4893), 1,
      sym_name,
    STATE(436), 1,
      sym__paren_open,
    STATE(704), 1,
      sym_type,
    STATE(752), 1,
      sym__unboxed_open,
    STATE(971), 1,
      sym__bracket_open,
    STATE(6083), 1,
      sym__qualified_type,
    STATE(6128), 1,
      sym_integer,
    STATE(6134), 1,
      sym__type_parens,
    STATE(6135), 1,
      sym__type_tuple,
    STATE(6136), 1,
      sym__type_unboxed_tuple,
    STATE(6137), 1,
      sym__type_unboxed_sum,
    STATE(6138), 1,
      sym__type_list,
    STATE(6139), 1,
      sym__type_apply,
    STATE(6140), 1,
      sym__type_infix,
    STATE(6141), 1,
      sym__plist,
    STATE(7279), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11268), 1,
      aux_sym__qualifying_module,
    ACTIONS(1973), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1979), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1983), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6142), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6132), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [34479] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1975), 1,
      sym_variable,
    ACTIONS(1977), 1,
      anon_sym__,
    ACTIONS(1981), 1,
      sym__integer_literal,
    ACTIONS(1987), 1,
      sym__cond_quote_start,
    ACTIONS(4891), 1,
      anon_sym_SQUOTE,
    ACTIONS(4893), 1,
      sym_name,
    STATE(436), 1,
      sym__paren_open,
    STATE(703), 1,
      sym_type,
    STATE(752), 1,
      sym__unboxed_open,
    STATE(971), 1,
      sym__bracket_open,
    STATE(6083), 1,
      sym__qualified_type,
    STATE(6128), 1,
      sym_integer,
    STATE(6134), 1,
      sym__type_parens,
    STATE(6135), 1,
      sym__type_tuple,
    STATE(6136), 1,
      sym__type_unboxed_tuple,
    STATE(6137), 1,
      sym__type_unboxed_sum,
    STATE(6138), 1,
      sym__type_list,
    STATE(6139), 1,
      sym__type_apply,
    STATE(6140), 1,
      sym__type_infix,
    STATE(6141), 1,
      sym__plist,
    STATE(7279), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11268), 1,
      aux_sym__qualifying_module,
    ACTIONS(1973), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1979), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1983), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6142), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6132), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [34607] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1975), 1,
      sym_variable,
    ACTIONS(1977), 1,
      anon_sym__,
    ACTIONS(1981), 1,
      sym__integer_literal,
    ACTIONS(1987), 1,
      sym__cond_quote_start,
    ACTIONS(4891), 1,
      anon_sym_SQUOTE,
    ACTIONS(4893), 1,
      sym_name,
    STATE(436), 1,
      sym__paren_open,
    STATE(698), 1,
      sym_type,
    STATE(752), 1,
      sym__unboxed_open,
    STATE(971), 1,
      sym__bracket_open,
    STATE(6083), 1,
      sym__qualified_type,
    STATE(6128), 1,
      sym_integer,
    STATE(6134), 1,
      sym__type_parens,
    STATE(6135), 1,
      sym__type_tuple,
    STATE(6136), 1,
      sym__type_unboxed_tuple,
    STATE(6137), 1,
      sym__type_unboxed_sum,
    STATE(6138), 1,
      sym__type_list,
    STATE(6139), 1,
      sym__type_apply,
    STATE(6140), 1,
      sym__type_infix,
    STATE(6141), 1,
      sym__plist,
    STATE(7279), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11268), 1,
      aux_sym__qualifying_module,
    ACTIONS(1973), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1979), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1983), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6142), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6132), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [34735] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2041), 1,
      sym_variable,
    ACTIONS(2043), 1,
      anon_sym__,
    ACTIONS(2053), 1,
      sym__integer_literal,
    ACTIONS(2059), 1,
      sym__cond_quote_start,
    ACTIONS(2649), 1,
      anon_sym_SQUOTE,
    ACTIONS(2653), 1,
      sym_name,
    STATE(437), 1,
      sym__paren_open,
    STATE(819), 1,
      sym_type,
    STATE(827), 1,
      sym__unboxed_open,
    STATE(982), 1,
      sym__bracket_open,
    STATE(6256), 1,
      sym__qualified_type,
    STATE(6424), 1,
      sym__plist,
    STATE(6425), 1,
      sym__type_apply,
    STATE(6430), 1,
      sym__type_list,
    STATE(6431), 1,
      sym__type_unboxed_sum,
    STATE(6432), 1,
      sym__type_unboxed_tuple,
    STATE(6435), 1,
      sym__type_tuple,
    STATE(6447), 1,
      sym__type_parens,
    STATE(6459), 1,
      sym__type_infix,
    STATE(6547), 1,
      sym_integer,
    STATE(7322), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11242), 1,
      aux_sym__qualifying_module,
    ACTIONS(2049), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2051), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2055), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6408), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6452), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [34863] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1629), 1,
      sym_variable,
    ACTIONS(1631), 1,
      anon_sym__,
    ACTIONS(1641), 1,
      sym__integer_literal,
    ACTIONS(1647), 1,
      sym__cond_quote_start,
    ACTIONS(3305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3309), 1,
      sym_name,
    STATE(447), 1,
      sym__paren_open,
    STATE(489), 1,
      sym_type,
    STATE(743), 1,
      sym__unboxed_open,
    STATE(976), 1,
      sym__bracket_open,
    STATE(3185), 1,
      sym__plist,
    STATE(3189), 1,
      sym__type_infix,
    STATE(3195), 1,
      sym__type_apply,
    STATE(3198), 1,
      sym__type_list,
    STATE(3209), 1,
      sym__type_unboxed_sum,
    STATE(3214), 1,
      sym__type_unboxed_tuple,
    STATE(3215), 1,
      sym__type_tuple,
    STATE(3217), 1,
      sym__type_parens,
    STATE(3330), 1,
      sym_integer,
    STATE(3420), 1,
      sym__qualified_type,
    STATE(7385), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11305), 1,
      aux_sym__qualifying_module,
    ACTIONS(1637), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1639), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1643), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3183), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3219), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [34991] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1629), 1,
      sym_variable,
    ACTIONS(1631), 1,
      anon_sym__,
    ACTIONS(1641), 1,
      sym__integer_literal,
    ACTIONS(1647), 1,
      sym__cond_quote_start,
    ACTIONS(3305), 1,
      anon_sym_SQUOTE,
    ACTIONS(3309), 1,
      sym_name,
    STATE(447), 1,
      sym__paren_open,
    STATE(490), 1,
      sym_type,
    STATE(743), 1,
      sym__unboxed_open,
    STATE(976), 1,
      sym__bracket_open,
    STATE(3185), 1,
      sym__plist,
    STATE(3189), 1,
      sym__type_infix,
    STATE(3195), 1,
      sym__type_apply,
    STATE(3198), 1,
      sym__type_list,
    STATE(3209), 1,
      sym__type_unboxed_sum,
    STATE(3214), 1,
      sym__type_unboxed_tuple,
    STATE(3215), 1,
      sym__type_tuple,
    STATE(3217), 1,
      sym__type_parens,
    STATE(3330), 1,
      sym_integer,
    STATE(3420), 1,
      sym__qualified_type,
    STATE(7385), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11305), 1,
      aux_sym__qualifying_module,
    ACTIONS(1637), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1639), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1643), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3183), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3219), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [35119] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(309), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1305), 1,
      sym_variable,
    ACTIONS(1307), 1,
      anon_sym__,
    ACTIONS(1317), 1,
      sym__cond_quote_start,
    ACTIONS(4927), 1,
      anon_sym_SQUOTE,
    ACTIONS(4929), 1,
      sym_name,
    STATE(411), 1,
      sym_type,
    STATE(432), 1,
      sym__paren_open,
    STATE(753), 1,
      sym__unboxed_open,
    STATE(1055), 1,
      sym__bracket_open,
    STATE(2693), 1,
      sym__plist,
    STATE(2697), 1,
      sym__qualified_type,
    STATE(2713), 1,
      sym__type_infix,
    STATE(2729), 1,
      sym__type_tuple,
    STATE(2733), 1,
      sym__type_parens,
    STATE(2734), 1,
      sym_integer,
    STATE(2745), 1,
      sym__type_apply,
    STATE(2746), 1,
      sym__type_unboxed_sum,
    STATE(2749), 1,
      sym__type_list,
    STATE(2751), 1,
      sym__type_unboxed_tuple,
    STATE(7364), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10987), 1,
      aux_sym__qualifying_module,
    ACTIONS(1313), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(307), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(311), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(2694), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(2710), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [35247] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3057), 1,
      sym_variable,
    ACTIONS(3059), 1,
      anon_sym__,
    ACTIONS(3063), 1,
      sym__integer_literal,
    ACTIONS(3069), 1,
      sym__cond_quote_start,
    ACTIONS(4939), 1,
      anon_sym_SQUOTE,
    ACTIONS(4941), 1,
      sym_name,
    STATE(474), 1,
      sym__paren_open,
    STATE(733), 1,
      sym__unboxed_open,
    STATE(1094), 1,
      sym_type,
    STATE(1124), 1,
      sym__bracket_open,
    STATE(7240), 1,
      sym__type_infix,
    STATE(7267), 1,
      sym__qualified_type,
    STATE(7270), 1,
      sym__splice_dollars,
    STATE(7274), 1,
      sym_integer,
    STATE(7416), 1,
      sym__type_parens,
    STATE(7417), 1,
      sym__type_tuple,
    STATE(7424), 1,
      sym__type_unboxed_tuple,
    STATE(7426), 1,
      sym__type_unboxed_sum,
    STATE(7427), 1,
      sym__type_list,
    STATE(7428), 1,
      sym__type_apply,
    STATE(7429), 1,
      sym__plist,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10936), 1,
      aux_sym__qualifying_module,
    ACTIONS(3055), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3061), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3065), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7438), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7415), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [35375] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2121), 1,
      sym_variable,
    ACTIONS(2123), 1,
      anon_sym__,
    ACTIONS(2133), 1,
      sym__integer_literal,
    ACTIONS(2139), 1,
      sym__cond_quote_start,
    ACTIONS(3547), 1,
      anon_sym_SQUOTE,
    ACTIONS(3551), 1,
      sym_name,
    STATE(431), 1,
      sym__paren_open,
    STATE(771), 1,
      sym__unboxed_open,
    STATE(801), 1,
      sym_type,
    STATE(1029), 1,
      sym__bracket_open,
    STATE(6245), 1,
      sym__qualified_type,
    STATE(6338), 1,
      sym_integer,
    STATE(6512), 1,
      sym__type_parens,
    STATE(6513), 1,
      sym__type_tuple,
    STATE(6514), 1,
      sym__type_unboxed_tuple,
    STATE(6515), 1,
      sym__type_unboxed_sum,
    STATE(6516), 1,
      sym__type_list,
    STATE(6517), 1,
      sym__type_apply,
    STATE(6518), 1,
      sym__type_infix,
    STATE(6519), 1,
      sym__plist,
    STATE(7260), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11289), 1,
      aux_sym__qualifying_module,
    ACTIONS(2129), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2135), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6520), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6510), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [35503] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1021), 1,
      sym__integer_literal,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1767), 1,
      sym_variable,
    ACTIONS(1769), 1,
      anon_sym__,
    ACTIONS(1779), 1,
      sym__cond_quote_start,
    ACTIONS(4879), 1,
      anon_sym_SQUOTE,
    ACTIONS(4881), 1,
      sym_name,
    STATE(440), 1,
      sym__paren_open,
    STATE(570), 1,
      sym_type,
    STATE(804), 1,
      sym__unboxed_open,
    STATE(1037), 1,
      sym__bracket_open,
    STATE(4588), 1,
      sym__type_unboxed_tuple,
    STATE(4653), 1,
      sym__type_parens,
    STATE(4654), 1,
      sym__type_tuple,
    STATE(4657), 1,
      sym__type_unboxed_sum,
    STATE(4667), 1,
      sym__type_list,
    STATE(4669), 1,
      sym__type_apply,
    STATE(4672), 1,
      sym__type_infix,
    STATE(4673), 1,
      sym__plist,
    STATE(4690), 1,
      sym_integer,
    STATE(4841), 1,
      sym__qualified_type,
    STATE(7386), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11282), 1,
      aux_sym__qualifying_module,
    ACTIONS(1775), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1019), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1023), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4674), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4652), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [35631] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3107), 1,
      sym_variable,
    ACTIONS(3109), 1,
      anon_sym__,
    ACTIONS(3119), 1,
      sym__integer_literal,
    ACTIONS(3125), 1,
      sym__cond_quote_start,
    ACTIONS(4378), 1,
      anon_sym_SQUOTE,
    ACTIONS(4380), 1,
      sym_name,
    STATE(455), 1,
      sym__paren_open,
    STATE(770), 1,
      sym__unboxed_open,
    STATE(1090), 1,
      sym__bracket_open,
    STATE(1167), 1,
      sym_type,
    STATE(7345), 1,
      sym__splice_dollars,
    STATE(7492), 1,
      sym__type_unboxed_sum,
    STATE(7497), 1,
      sym__type_unboxed_tuple,
    STATE(7503), 1,
      sym__type_tuple,
    STATE(7505), 1,
      sym__type_parens,
    STATE(7518), 1,
      sym__plist,
    STATE(7528), 1,
      sym__type_list,
    STATE(7534), 1,
      sym__type_infix,
    STATE(7541), 1,
      sym__qualified_type,
    STATE(7542), 1,
      sym_integer,
    STATE(7550), 1,
      sym__type_apply,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11252), 1,
      aux_sym__qualifying_module,
    ACTIONS(3115), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3117), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3121), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7511), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7491), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [35759] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1485), 1,
      sym__linear_fun_arrow,
    STATE(1493), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4590), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4592), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [35851] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1485), 1,
      sym__linear_fun_arrow,
    STATE(1493), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4564), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4566), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [35943] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1485), 1,
      sym__linear_fun_arrow,
    STATE(1493), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4590), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4592), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [36035] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2673), 1,
      sym_variable,
    ACTIONS(2675), 1,
      anon_sym__,
    ACTIONS(2685), 1,
      sym__integer_literal,
    ACTIONS(2691), 1,
      sym__cond_quote_start,
    ACTIONS(3339), 1,
      anon_sym_SQUOTE,
    ACTIONS(3343), 1,
      sym_name,
    STATE(430), 1,
      sym__paren_open,
    STATE(737), 1,
      sym__unboxed_open,
    STATE(897), 1,
      sym_type,
    STATE(1017), 1,
      sym__bracket_open,
    STATE(6883), 1,
      sym__type_tuple,
    STATE(6889), 1,
      sym__plist,
    STATE(6890), 1,
      sym__type_apply,
    STATE(6891), 1,
      sym__type_list,
    STATE(6892), 1,
      sym__type_unboxed_sum,
    STATE(6903), 1,
      sym__type_unboxed_tuple,
    STATE(6909), 1,
      sym__type_parens,
    STATE(6928), 1,
      sym_integer,
    STATE(6933), 1,
      sym__qualified_type,
    STATE(6959), 1,
      sym__type_infix,
    STATE(7211), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11277), 1,
      aux_sym__qualifying_module,
    ACTIONS(2681), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2683), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2687), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6884), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6911), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [36163] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1867), 1,
      sym_variable,
    ACTIONS(1869), 1,
      anon_sym__,
    ACTIONS(1879), 1,
      sym__integer_literal,
    ACTIONS(1885), 1,
      sym__cond_quote_start,
    ACTIONS(3349), 1,
      anon_sym_SQUOTE,
    ACTIONS(3353), 1,
      sym_name,
    STATE(468), 1,
      sym__paren_open,
    STATE(655), 1,
      sym_type,
    STATE(795), 1,
      sym__unboxed_open,
    STATE(986), 1,
      sym__bracket_open,
    STATE(5906), 1,
      sym__qualified_type,
    STATE(5925), 1,
      sym_integer,
    STATE(5999), 1,
      sym__type_parens,
    STATE(6002), 1,
      sym__type_tuple,
    STATE(6004), 1,
      sym__type_unboxed_tuple,
    STATE(6006), 1,
      sym__type_unboxed_sum,
    STATE(6007), 1,
      sym__type_list,
    STATE(6008), 1,
      sym__type_apply,
    STATE(6009), 1,
      sym__type_infix,
    STATE(6010), 1,
      sym__plist,
    STATE(7346), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11325), 1,
      aux_sym__qualifying_module,
    ACTIONS(1875), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1877), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1881), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6014), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5993), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [36291] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1867), 1,
      sym_variable,
    ACTIONS(1869), 1,
      anon_sym__,
    ACTIONS(1879), 1,
      sym__integer_literal,
    ACTIONS(1885), 1,
      sym__cond_quote_start,
    ACTIONS(3349), 1,
      anon_sym_SQUOTE,
    ACTIONS(3353), 1,
      sym_name,
    STATE(468), 1,
      sym__paren_open,
    STATE(656), 1,
      sym_type,
    STATE(795), 1,
      sym__unboxed_open,
    STATE(986), 1,
      sym__bracket_open,
    STATE(5906), 1,
      sym__qualified_type,
    STATE(5925), 1,
      sym_integer,
    STATE(5999), 1,
      sym__type_parens,
    STATE(6002), 1,
      sym__type_tuple,
    STATE(6004), 1,
      sym__type_unboxed_tuple,
    STATE(6006), 1,
      sym__type_unboxed_sum,
    STATE(6007), 1,
      sym__type_list,
    STATE(6008), 1,
      sym__type_apply,
    STATE(6009), 1,
      sym__type_infix,
    STATE(6010), 1,
      sym__plist,
    STATE(7346), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11325), 1,
      aux_sym__qualifying_module,
    ACTIONS(1875), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1877), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1881), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6014), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5993), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [36419] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2757), 1,
      sym_variable,
    ACTIONS(2761), 1,
      anon_sym__,
    ACTIONS(2773), 1,
      sym__integer_literal,
    ACTIONS(2779), 1,
      sym__cond_quote_start,
    ACTIONS(4342), 1,
      anon_sym_SQUOTE,
    ACTIONS(4344), 1,
      sym_name,
    STATE(450), 1,
      sym__paren_open,
    STATE(831), 1,
      sym__unboxed_open,
    STATE(946), 1,
      sym_type,
    STATE(1027), 1,
      sym__bracket_open,
    STATE(7036), 1,
      sym_integer,
    STATE(7079), 1,
      sym__qualified_type,
    STATE(7142), 1,
      sym__type_parens,
    STATE(7143), 1,
      sym__type_tuple,
    STATE(7144), 1,
      sym__type_unboxed_tuple,
    STATE(7145), 1,
      sym__type_unboxed_sum,
    STATE(7146), 1,
      sym__type_list,
    STATE(7147), 1,
      sym__type_apply,
    STATE(7148), 1,
      sym__type_infix,
    STATE(7149), 1,
      sym__plist,
    STATE(7440), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11165), 1,
      aux_sym__qualifying_module,
    ACTIONS(2767), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2771), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2775), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7150), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7140), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [36547] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1867), 1,
      sym_variable,
    ACTIONS(1869), 1,
      anon_sym__,
    ACTIONS(1879), 1,
      sym__integer_literal,
    ACTIONS(1885), 1,
      sym__cond_quote_start,
    ACTIONS(3349), 1,
      anon_sym_SQUOTE,
    ACTIONS(3353), 1,
      sym_name,
    STATE(468), 1,
      sym__paren_open,
    STATE(662), 1,
      sym_type,
    STATE(795), 1,
      sym__unboxed_open,
    STATE(986), 1,
      sym__bracket_open,
    STATE(5906), 1,
      sym__qualified_type,
    STATE(5925), 1,
      sym_integer,
    STATE(5999), 1,
      sym__type_parens,
    STATE(6002), 1,
      sym__type_tuple,
    STATE(6004), 1,
      sym__type_unboxed_tuple,
    STATE(6006), 1,
      sym__type_unboxed_sum,
    STATE(6007), 1,
      sym__type_list,
    STATE(6008), 1,
      sym__type_apply,
    STATE(6009), 1,
      sym__type_infix,
    STATE(6010), 1,
      sym__plist,
    STATE(7346), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11325), 1,
      aux_sym__qualifying_module,
    ACTIONS(1875), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1877), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1881), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6014), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5993), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [36675] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1941), 1,
      sym__integer_literal,
    ACTIONS(1953), 1,
      sym__cond_quote_start,
    ACTIONS(1955), 1,
      sym_variable,
    ACTIONS(1957), 1,
      anon_sym__,
    ACTIONS(4911), 1,
      anon_sym_SQUOTE,
    ACTIONS(4913), 1,
      sym_name,
    STATE(453), 1,
      sym__paren_open,
    STATE(684), 1,
      sym_type,
    STATE(815), 1,
      sym__unboxed_open,
    STATE(1072), 1,
      sym__bracket_open,
    STATE(6064), 1,
      sym__type_infix,
    STATE(6085), 1,
      sym__type_tuple,
    STATE(6100), 1,
      sym__type_parens,
    STATE(6116), 1,
      sym__plist,
    STATE(6118), 1,
      sym__type_apply,
    STATE(6120), 1,
      sym__type_list,
    STATE(6122), 1,
      sym__type_unboxed_sum,
    STATE(6123), 1,
      sym__type_unboxed_tuple,
    STATE(6125), 1,
      sym_integer,
    STATE(6171), 1,
      sym__qualified_type,
    STATE(7221), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11317), 1,
      aux_sym__qualifying_module,
    ACTIONS(1963), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1939), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1943), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6112), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6129), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [36803] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1343), 1,
      sym_variable,
    ACTIONS(1345), 1,
      anon_sym__,
    ACTIONS(1355), 1,
      sym__integer_literal,
    ACTIONS(1361), 1,
      sym__cond_quote_start,
    ACTIONS(3333), 1,
      anon_sym_SQUOTE,
    ACTIONS(3337), 1,
      sym_name,
    STATE(428), 1,
      sym_type,
    STATE(441), 1,
      sym__paren_open,
    STATE(764), 1,
      sym__unboxed_open,
    STATE(1101), 1,
      sym__bracket_open,
    STATE(3082), 1,
      sym__plist,
    STATE(3083), 1,
      sym__qualified_type,
    STATE(3084), 1,
      sym__type_infix,
    STATE(3091), 1,
      sym__type_tuple,
    STATE(3092), 1,
      sym__type_unboxed_tuple,
    STATE(3095), 1,
      sym__type_unboxed_sum,
    STATE(3099), 1,
      sym__type_apply,
    STATE(3100), 1,
      sym__type_list,
    STATE(3111), 1,
      sym__type_parens,
    STATE(3118), 1,
      sym_integer,
    STATE(7411), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11161), 1,
      aux_sym__qualifying_module,
    ACTIONS(1351), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1353), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1357), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3071), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3123), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [36931] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2155), 1,
      sym_variable,
    ACTIONS(2157), 1,
      anon_sym__,
    ACTIONS(2167), 1,
      sym__integer_literal,
    ACTIONS(2173), 1,
      sym__cond_quote_start,
    ACTIONS(3427), 1,
      anon_sym_SQUOTE,
    ACTIONS(3431), 1,
      sym_name,
    STATE(469), 1,
      sym__paren_open,
    STATE(766), 1,
      sym_type,
    STATE(810), 1,
      sym__unboxed_open,
    STATE(990), 1,
      sym__bracket_open,
    STATE(6269), 1,
      sym_integer,
    STATE(6286), 1,
      sym__qualified_type,
    STATE(6323), 1,
      sym__type_parens,
    STATE(6324), 1,
      sym__type_tuple,
    STATE(6325), 1,
      sym__type_unboxed_tuple,
    STATE(6326), 1,
      sym__type_unboxed_sum,
    STATE(6327), 1,
      sym__type_list,
    STATE(6328), 1,
      sym__type_apply,
    STATE(6329), 1,
      sym__type_infix,
    STATE(6330), 1,
      sym__plist,
    STATE(7407), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11328), 1,
      aux_sym__qualifying_module,
    ACTIONS(2163), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2165), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2169), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6331), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6321), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [37059] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3363), 1,
      sym_variable,
    ACTIONS(3365), 1,
      anon_sym__,
    ACTIONS(3375), 1,
      sym__integer_literal,
    ACTIONS(3381), 1,
      sym__cond_quote_start,
    ACTIONS(4971), 1,
      anon_sym_SQUOTE,
    ACTIONS(4973), 1,
      sym_name,
    STATE(457), 1,
      sym__paren_open,
    STATE(813), 1,
      sym__unboxed_open,
    STATE(995), 1,
      sym__bracket_open,
    STATE(1629), 1,
      sym_type,
    STATE(7310), 1,
      sym__splice_dollars,
    STATE(7738), 1,
      sym__qualified_type,
    STATE(7755), 1,
      sym__type_parens,
    STATE(7759), 1,
      sym__type_tuple,
    STATE(7760), 1,
      sym__type_unboxed_tuple,
    STATE(7761), 1,
      sym__type_unboxed_sum,
    STATE(7762), 1,
      sym_integer,
    STATE(7763), 1,
      sym__type_list,
    STATE(7764), 1,
      sym__type_apply,
    STATE(7765), 1,
      sym__type_infix,
    STATE(7766), 1,
      sym__plist,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11318), 1,
      aux_sym__qualifying_module,
    ACTIONS(3371), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3373), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3377), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7767), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7754), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [37187] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2155), 1,
      sym_variable,
    ACTIONS(2157), 1,
      anon_sym__,
    ACTIONS(2167), 1,
      sym__integer_literal,
    ACTIONS(2173), 1,
      sym__cond_quote_start,
    ACTIONS(3427), 1,
      anon_sym_SQUOTE,
    ACTIONS(3431), 1,
      sym_name,
    STATE(469), 1,
      sym__paren_open,
    STATE(810), 1,
      sym__unboxed_open,
    STATE(814), 1,
      sym_type,
    STATE(990), 1,
      sym__bracket_open,
    STATE(6269), 1,
      sym_integer,
    STATE(6286), 1,
      sym__qualified_type,
    STATE(6323), 1,
      sym__type_parens,
    STATE(6324), 1,
      sym__type_tuple,
    STATE(6325), 1,
      sym__type_unboxed_tuple,
    STATE(6326), 1,
      sym__type_unboxed_sum,
    STATE(6327), 1,
      sym__type_list,
    STATE(6328), 1,
      sym__type_apply,
    STATE(6329), 1,
      sym__type_infix,
    STATE(6330), 1,
      sym__plist,
    STATE(7407), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11328), 1,
      aux_sym__qualifying_module,
    ACTIONS(2163), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2165), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2169), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6331), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6321), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [37315] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2693), 1,
      sym_variable,
    ACTIONS(2695), 1,
      anon_sym__,
    ACTIONS(2705), 1,
      sym__integer_literal,
    ACTIONS(2711), 1,
      sym__cond_quote_start,
    ACTIONS(3325), 1,
      anon_sym_SQUOTE,
    ACTIONS(3329), 1,
      sym_name,
    STATE(435), 1,
      sym__paren_open,
    STATE(744), 1,
      sym__unboxed_open,
    STATE(877), 1,
      sym_type,
    STATE(1104), 1,
      sym__bracket_open,
    STATE(6922), 1,
      sym__type_parens,
    STATE(6929), 1,
      sym__type_tuple,
    STATE(6932), 1,
      sym__type_unboxed_tuple,
    STATE(6934), 1,
      sym__type_unboxed_sum,
    STATE(6935), 1,
      sym__type_list,
    STATE(6936), 1,
      sym__type_apply,
    STATE(6937), 1,
      sym__type_infix,
    STATE(6939), 1,
      sym__plist,
    STATE(6980), 1,
      sym_integer,
    STATE(7018), 1,
      sym__qualified_type,
    STATE(7213), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11154), 1,
      aux_sym__qualifying_module,
    ACTIONS(2701), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2703), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2707), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6940), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6919), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [37443] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1485), 1,
      sym__linear_fun_arrow,
    STATE(1493), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4564), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4566), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [37535] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2757), 1,
      sym_variable,
    ACTIONS(2761), 1,
      anon_sym__,
    ACTIONS(2773), 1,
      sym__integer_literal,
    ACTIONS(2779), 1,
      sym__cond_quote_start,
    ACTIONS(4342), 1,
      anon_sym_SQUOTE,
    ACTIONS(4344), 1,
      sym_name,
    STATE(450), 1,
      sym__paren_open,
    STATE(831), 1,
      sym__unboxed_open,
    STATE(947), 1,
      sym_type,
    STATE(1027), 1,
      sym__bracket_open,
    STATE(7036), 1,
      sym_integer,
    STATE(7079), 1,
      sym__qualified_type,
    STATE(7142), 1,
      sym__type_parens,
    STATE(7143), 1,
      sym__type_tuple,
    STATE(7144), 1,
      sym__type_unboxed_tuple,
    STATE(7145), 1,
      sym__type_unboxed_sum,
    STATE(7146), 1,
      sym__type_list,
    STATE(7147), 1,
      sym__type_apply,
    STATE(7148), 1,
      sym__type_infix,
    STATE(7149), 1,
      sym__plist,
    STATE(7440), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11165), 1,
      aux_sym__qualifying_module,
    ACTIONS(2767), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2771), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2775), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7150), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7140), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [37663] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2155), 1,
      sym_variable,
    ACTIONS(2157), 1,
      anon_sym__,
    ACTIONS(2167), 1,
      sym__integer_literal,
    ACTIONS(2173), 1,
      sym__cond_quote_start,
    ACTIONS(3427), 1,
      anon_sym_SQUOTE,
    ACTIONS(3431), 1,
      sym_name,
    STATE(469), 1,
      sym__paren_open,
    STATE(810), 1,
      sym__unboxed_open,
    STATE(818), 1,
      sym_type,
    STATE(990), 1,
      sym__bracket_open,
    STATE(6269), 1,
      sym_integer,
    STATE(6286), 1,
      sym__qualified_type,
    STATE(6323), 1,
      sym__type_parens,
    STATE(6324), 1,
      sym__type_tuple,
    STATE(6325), 1,
      sym__type_unboxed_tuple,
    STATE(6326), 1,
      sym__type_unboxed_sum,
    STATE(6327), 1,
      sym__type_list,
    STATE(6328), 1,
      sym__type_apply,
    STATE(6329), 1,
      sym__type_infix,
    STATE(6330), 1,
      sym__plist,
    STATE(7407), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11328), 1,
      aux_sym__qualifying_module,
    ACTIONS(2163), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2165), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2169), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6331), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6321), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [37791] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1589), 1,
      sym_variable,
    ACTIONS(1591), 1,
      anon_sym__,
    ACTIONS(1601), 1,
      sym__integer_literal,
    ACTIONS(1607), 1,
      sym__cond_quote_start,
    ACTIONS(3467), 1,
      anon_sym_SQUOTE,
    ACTIONS(3471), 1,
      sym_name,
    STATE(458), 1,
      sym__paren_open,
    STATE(499), 1,
      sym_type,
    STATE(792), 1,
      sym__unboxed_open,
    STATE(1120), 1,
      sym__bracket_open,
    STATE(3249), 1,
      sym__qualified_type,
    STATE(3286), 1,
      sym_integer,
    STATE(3294), 1,
      sym__type_parens,
    STATE(3295), 1,
      sym__type_tuple,
    STATE(3296), 1,
      sym__type_unboxed_tuple,
    STATE(3298), 1,
      sym__type_unboxed_sum,
    STATE(3311), 1,
      sym__type_list,
    STATE(3313), 1,
      sym__type_apply,
    STATE(3314), 1,
      sym__type_infix,
    STATE(3318), 1,
      sym__plist,
    STATE(7231), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11151), 1,
      aux_sym__qualifying_module,
    ACTIONS(1597), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1599), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1603), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3320), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3292), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [37919] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3363), 1,
      sym_variable,
    ACTIONS(3365), 1,
      anon_sym__,
    ACTIONS(3375), 1,
      sym__integer_literal,
    ACTIONS(3381), 1,
      sym__cond_quote_start,
    ACTIONS(4971), 1,
      anon_sym_SQUOTE,
    ACTIONS(4973), 1,
      sym_name,
    STATE(457), 1,
      sym__paren_open,
    STATE(813), 1,
      sym__unboxed_open,
    STATE(995), 1,
      sym__bracket_open,
    STATE(1511), 1,
      sym_type,
    STATE(7310), 1,
      sym__splice_dollars,
    STATE(7738), 1,
      sym__qualified_type,
    STATE(7755), 1,
      sym__type_parens,
    STATE(7759), 1,
      sym__type_tuple,
    STATE(7760), 1,
      sym__type_unboxed_tuple,
    STATE(7761), 1,
      sym__type_unboxed_sum,
    STATE(7762), 1,
      sym_integer,
    STATE(7763), 1,
      sym__type_list,
    STATE(7764), 1,
      sym__type_apply,
    STATE(7765), 1,
      sym__type_infix,
    STATE(7766), 1,
      sym__plist,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11318), 1,
      aux_sym__qualifying_module,
    ACTIONS(3371), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3373), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3377), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7767), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7754), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [38047] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3363), 1,
      sym_variable,
    ACTIONS(3365), 1,
      anon_sym__,
    ACTIONS(3375), 1,
      sym__integer_literal,
    ACTIONS(3381), 1,
      sym__cond_quote_start,
    ACTIONS(4971), 1,
      anon_sym_SQUOTE,
    ACTIONS(4973), 1,
      sym_name,
    STATE(457), 1,
      sym__paren_open,
    STATE(813), 1,
      sym__unboxed_open,
    STATE(995), 1,
      sym__bracket_open,
    STATE(1507), 1,
      sym_type,
    STATE(7310), 1,
      sym__splice_dollars,
    STATE(7738), 1,
      sym__qualified_type,
    STATE(7755), 1,
      sym__type_parens,
    STATE(7759), 1,
      sym__type_tuple,
    STATE(7760), 1,
      sym__type_unboxed_tuple,
    STATE(7761), 1,
      sym__type_unboxed_sum,
    STATE(7762), 1,
      sym_integer,
    STATE(7763), 1,
      sym__type_list,
    STATE(7764), 1,
      sym__type_apply,
    STATE(7765), 1,
      sym__type_infix,
    STATE(7766), 1,
      sym__plist,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11318), 1,
      aux_sym__qualifying_module,
    ACTIONS(3371), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(3373), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3377), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7767), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7754), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [38175] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1669), 1,
      sym_variable,
    ACTIONS(1671), 1,
      anon_sym__,
    ACTIONS(1681), 1,
      sym__integer_literal,
    ACTIONS(1687), 1,
      sym__cond_quote_start,
    ACTIONS(3419), 1,
      anon_sym_SQUOTE,
    ACTIONS(3423), 1,
      sym_name,
    STATE(461), 1,
      sym__paren_open,
    STATE(502), 1,
      sym_type,
    STATE(829), 1,
      sym__unboxed_open,
    STATE(1131), 1,
      sym__bracket_open,
    STATE(3509), 1,
      sym_integer,
    STATE(3557), 1,
      sym__type_parens,
    STATE(3597), 1,
      sym__plist,
    STATE(3602), 1,
      sym__type_infix,
    STATE(3604), 1,
      sym__type_apply,
    STATE(3605), 1,
      sym__type_list,
    STATE(3606), 1,
      sym__type_unboxed_sum,
    STATE(3607), 1,
      sym__type_unboxed_tuple,
    STATE(3612), 1,
      sym__type_tuple,
    STATE(3643), 1,
      sym__qualified_type,
    STATE(7350), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11140), 1,
      aux_sym__qualifying_module,
    ACTIONS(1677), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1679), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1683), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3583), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3638), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [38303] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2739), 1,
      sym_variable,
    ACTIONS(2741), 1,
      anon_sym__,
    ACTIONS(2745), 1,
      sym__integer_literal,
    ACTIONS(2751), 1,
      sym__cond_quote_start,
    ACTIONS(4919), 1,
      anon_sym_SQUOTE,
    ACTIONS(4921), 1,
      sym_name,
    STATE(459), 1,
      sym__paren_open,
    STATE(793), 1,
      sym__unboxed_open,
    STATE(888), 1,
      sym_type,
    STATE(1113), 1,
      sym__bracket_open,
    STATE(6887), 1,
      sym_integer,
    STATE(6927), 1,
      sym__type_infix,
    STATE(6931), 1,
      sym__qualified_type,
    STATE(6989), 1,
      sym__type_parens,
    STATE(6991), 1,
      sym__type_tuple,
    STATE(6992), 1,
      sym__type_unboxed_tuple,
    STATE(6993), 1,
      sym__type_unboxed_sum,
    STATE(6994), 1,
      sym__type_list,
    STATE(6995), 1,
      sym__type_apply,
    STATE(6996), 1,
      sym__plist,
    STATE(7369), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11311), 1,
      aux_sym__qualifying_module,
    ACTIONS(2671), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(2743), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2747), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6997), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6987), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [38431] = 32,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1151), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1323), 1,
      sym_variable,
    ACTIONS(1325), 1,
      anon_sym__,
    ACTIONS(1335), 1,
      sym__integer_literal,
    ACTIONS(1341), 1,
      sym__cond_quote_start,
    ACTIONS(3461), 1,
      anon_sym_SQUOTE,
    ACTIONS(3465), 1,
      sym_name,
    STATE(417), 1,
      sym_type,
    STATE(467), 1,
      sym__paren_open,
    STATE(765), 1,
      sym__unboxed_open,
    STATE(1130), 1,
      sym__bracket_open,
    STATE(2759), 1,
      sym__qualified_type,
    STATE(2767), 1,
      sym__type_unboxed_sum,
    STATE(2774), 1,
      sym__type_infix,
    STATE(2777), 1,
      sym__plist,
    STATE(2781), 1,
      sym_integer,
    STATE(2788), 1,
      sym__type_unboxed_tuple,
    STATE(2808), 1,
      sym__type_tuple,
    STATE(2823), 1,
      sym__type_apply,
    STATE(2825), 1,
      sym__type_parens,
    STATE(2839), 1,
      sym__type_list,
    STATE(7328), 1,
      sym__splice_dollars,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11145), 1,
      aux_sym__qualifying_module,
    ACTIONS(1331), 2,
      anon_sym_STAR,
      anon_sym_u2605,
    ACTIONS(1333), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1337), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(2752), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(2796), 13,
      sym__type_promoted,
      sym__type_star,
      sym__type_wildcard,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [38559] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [38628] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4743), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [38697] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4833), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [38766] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [38835] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4703), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [38904] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4763), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [38973] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4813), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [39042] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [39117] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [39186] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [39255] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [39324] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [39393] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [39462] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [39531] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [39600] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4630), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [39675] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4781), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [39744] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [39813] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4747), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [39882] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [39951] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [40026] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4735), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [40095] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4841), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [40164] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [40239] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [40308] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [40377] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [40446] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4719), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [40515] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [40584] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [40659] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [40734] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [40809] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4727), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [40878] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4767), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [40947] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4731), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [41016] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [41085] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [41160] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [41229] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [41298] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [41367] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [41436] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [41511] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4797), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [41580] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [41649] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [41718] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [41787] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [41856] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [41925] = 5,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 12,
      anon_sym_let,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 28,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [41998] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [42067] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [42136] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [42205] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [42274] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4817), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [42343] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4845), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [42412] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [42481] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4681), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [42550] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4821), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [42619] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [42688] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [42757] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 16,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 41,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [42826] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [42894] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [42962] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4849), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [43030] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4715), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [43098] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1736), 1,
      sym__fun_arrow,
    STATE(1737), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4600), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4602), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [43188] = 9,
    STATE(1740), 1,
      sym__linear_fun_arrow,
    STATE(1758), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4582), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4584), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [43268] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4809), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [43336] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4813), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [43404] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4853), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [43472] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4829), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [43540] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4825), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [43608] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4759), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [43676] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4775), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [43744] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4837), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [43812] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4735), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [43880] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [43948] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1576), 1,
      sym__linear_fun_arrow,
    STATE(1584), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4594), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4596), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [44038] = 9,
    STATE(1736), 1,
      sym__fun_arrow,
    STATE(1737), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4582), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4584), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [44118] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1576), 1,
      sym__linear_fun_arrow,
    STATE(1584), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4578), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4580), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [44208] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4711), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [44276] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1576), 1,
      sym__linear_fun_arrow,
    STATE(1584), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4586), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4588), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [44366] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4707), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [44434] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4841), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [44502] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4685), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [44570] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4767), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [44638] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4833), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [44706] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4751), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [44774] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4755), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [44842] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1736), 1,
      sym__fun_arrow,
    STATE(1737), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4586), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4588), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [44932] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4739), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [45000] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1576), 1,
      sym__linear_fun_arrow,
    STATE(1584), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4590), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4592), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [45090] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1576), 1,
      sym__linear_fun_arrow,
    STATE(1584), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4564), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4566), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [45180] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1576), 1,
      sym__linear_fun_arrow,
    STATE(1584), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4590), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4592), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [45270] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1576), 1,
      sym__linear_fun_arrow,
    STATE(1584), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4564), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4566), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [45360] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4789), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [45428] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4817), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [45496] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [45564] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4731), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [45632] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1736), 1,
      sym__fun_arrow,
    STATE(1737), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4594), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4596), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [45722] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1576), 1,
      sym__linear_fun_arrow,
    STATE(1584), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4600), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4602), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [45812] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4723), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [45880] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1736), 1,
      sym__fun_arrow,
    STATE(1737), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4578), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4580), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [45970] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1736), 1,
      sym__fun_arrow,
    STATE(1737), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4590), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4592), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [46060] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4861), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [46128] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [46196] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4699), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [46264] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1736), 1,
      sym__fun_arrow,
    STATE(1737), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4564), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4566), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [46354] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1396), 1,
      sym__linear_fun_arrow,
    STATE(1397), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4590), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4592), 33,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [46444] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1396), 1,
      sym__linear_fun_arrow,
    STATE(1397), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4564), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4566), 33,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [46534] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1736), 1,
      sym__fun_arrow,
    STATE(1737), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4590), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4592), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [46624] = 9,
    STATE(1396), 1,
      sym__linear_fun_arrow,
    STATE(1397), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4582), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4584), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [46704] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1396), 1,
      sym__linear_fun_arrow,
    STATE(1397), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4590), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4592), 33,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [46794] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1396), 1,
      sym__linear_fun_arrow,
    STATE(1397), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4586), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4588), 33,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [46884] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1736), 1,
      sym__fun_arrow,
    STATE(1737), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4564), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4566), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [46974] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4743), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [47042] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1396), 1,
      sym__linear_fun_arrow,
    STATE(1397), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4578), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4580), 33,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [47132] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [47200] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4763), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [47268] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [47336] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [47404] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4727), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [47472] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4857), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [47540] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4785), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [47608] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4719), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [47676] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4703), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [47744] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4793), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [47812] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1396), 1,
      sym__linear_fun_arrow,
    STATE(1397), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4600), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4602), 33,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [47902] = 5,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 10,
      anon_sym_let,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_POUND,
      anon_sym_POUND2,
      anon_sym_where,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [47974] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4821), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [48042] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4681), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [48110] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [48178] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4845), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [48246] = 9,
    STATE(1576), 1,
      sym__linear_fun_arrow,
    STATE(1584), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4582), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4584), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [48326] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4797), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [48394] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1740), 1,
      sym__linear_fun_arrow,
    STATE(1758), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4600), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4602), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [48484] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1740), 1,
      sym__linear_fun_arrow,
    STATE(1758), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4564), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4566), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [48574] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1740), 1,
      sym__linear_fun_arrow,
    STATE(1758), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4590), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4592), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [48664] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1740), 1,
      sym__linear_fun_arrow,
    STATE(1758), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4564), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4566), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [48754] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4747), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [48822] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1740), 1,
      sym__linear_fun_arrow,
    STATE(1758), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4590), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4592), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [48912] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1396), 1,
      sym__linear_fun_arrow,
    STATE(1397), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4564), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4566), 33,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [49002] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1740), 1,
      sym__linear_fun_arrow,
    STATE(1758), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4586), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4588), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [49092] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1740), 1,
      sym__linear_fun_arrow,
    STATE(1758), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4578), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4580), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [49182] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4695), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [49250] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1396), 1,
      sym__linear_fun_arrow,
    STATE(1397), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4594), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4596), 33,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [49340] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4781), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [49408] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1740), 1,
      sym__linear_fun_arrow,
    STATE(1758), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4594), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4596), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [49498] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [49566] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4979), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4981), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [49633] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4983), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4985), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [49700] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [49773] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [49840] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4987), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4989), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [49907] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [49974] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [50047] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [50114] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [50181] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [50248] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4995), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4997), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [50315] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [50382] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [50449] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4630), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [50522] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [50595] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [50668] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [50735] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [50808] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4999), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5001), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [50875] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5003), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5005), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [50942] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4999), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5001), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [51009] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5007), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5009), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [51076] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5011), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5013), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [51143] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [51216] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [51283] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [51350] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [51417] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [51484] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [51557] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [51630] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5015), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5017), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [51697] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5019), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5021), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [51764] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [51837] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [51910] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [51983] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5023), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5025), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [52050] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [52123] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5027), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5029), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [52190] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5031), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5033), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [52257] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [52330] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5035), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5037), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [52397] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5039), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5041), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [52464] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5043), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5045), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [52531] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [52598] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5047), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5049), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [52665] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5051), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5053), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [52732] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [52799] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [52866] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5055), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5057), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [52933] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5059), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5061), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [53000] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5063), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5065), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [53067] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [53140] = 10,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    ACTIONS(5073), 1,
      anon_sym__,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(5067), 4,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4943), 6,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
    ACTIONS(4945), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
    ACTIONS(5075), 9,
      sym__phantom_bar,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(5070), 22,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      aux_sym__paren_open_token1,
  [53221] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [53294] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5077), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5079), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [53361] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [53428] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5081), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5083), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [53495] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5085), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5087), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [53562] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5089), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5091), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [53629] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [53702] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5093), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5095), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [53769] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5097), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5099), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [53836] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [53903] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [53976] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5101), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5103), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [54043] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [54110] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5105), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5107), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [54177] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5109), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5111), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [54244] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5113), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5115), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [54311] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [54384] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [54457] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1685), 1,
      sym__linear_fun_arrow,
    STATE(1718), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4600), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4602), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [54546] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5117), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5119), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [54613] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5121), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5123), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [54680] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5125), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5127), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [54747] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [54820] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [54887] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [54954] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4630), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [55027] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [55094] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1642), 1,
      sym__linear_fun_arrow,
    STATE(1643), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4594), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4596), 32,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [55183] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5129), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5131), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [55250] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5133), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5135), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [55317] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [55384] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5137), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5139), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [55451] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5141), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5143), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [55518] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5145), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5147), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [55585] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5149), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5151), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [55652] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5153), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5155), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [55719] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5157), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5159), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [55786] = 9,
    STATE(1642), 1,
      sym__linear_fun_arrow,
    STATE(1643), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4582), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4584), 37,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [55865] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5161), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5163), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [55932] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4630), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [56005] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [56072] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [56145] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5165), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5167), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [56212] = 9,
    STATE(1685), 1,
      sym__linear_fun_arrow,
    STATE(1718), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4582), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4584), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [56291] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5169), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5171), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [56358] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5173), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5175), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [56425] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1642), 1,
      sym__linear_fun_arrow,
    STATE(1643), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4564), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4566), 32,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [56514] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1642), 1,
      sym__linear_fun_arrow,
    STATE(1643), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4590), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4592), 32,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [56603] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5177), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5179), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [56670] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [56743] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5181), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5183), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [56810] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [56883] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(337), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(339), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [56950] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5185), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5187), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [57017] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1642), 1,
      sym__linear_fun_arrow,
    STATE(1643), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4564), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4566), 32,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [57106] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5189), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5191), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [57173] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1642), 1,
      sym__linear_fun_arrow,
    STATE(1643), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4590), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4592), 32,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [57262] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5193), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5195), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [57329] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5197), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5199), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [57396] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5201), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5203), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [57463] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [57536] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5205), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5207), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [57603] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1642), 1,
      sym__linear_fun_arrow,
    STATE(1643), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4586), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4588), 32,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [57692] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5209), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5211), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [57759] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5213), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5215), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [57826] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1642), 1,
      sym__linear_fun_arrow,
    STATE(1643), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4578), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4580), 32,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [57915] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5217), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5219), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [57982] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [58055] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4630), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [58128] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5221), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5223), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [58195] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5225), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5227), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [58262] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [58335] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [58402] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5137), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5139), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [58469] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [58542] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5233), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5235), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [58609] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [58676] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [58743] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [58810] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [58877] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5237), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5239), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [58944] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5241), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5243), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [59011] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5237), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5239), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [59078] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5245), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5247), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [59145] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5241), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5243), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [59212] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [59285] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [59358] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4646), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [59425] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5249), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5251), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [59492] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5253), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5255), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [59559] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5257), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5259), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [59626] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [59699] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [59766] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [59833] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5265), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5267), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [59900] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [59967] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5269), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5271), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [60034] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5269), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5271), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [60101] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5273), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5275), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [60168] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [60235] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5277), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5279), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [60302] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5281), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5283), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [60369] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5285), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5287), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [60436] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5289), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5291), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [60503] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5293), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5295), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [60570] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5297), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5299), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [60637] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5301), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5303), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [60704] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5305), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5307), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [60771] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [60838] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [60905] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5313), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5315), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [60972] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5313), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5315), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [61039] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5305), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5307), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [61106] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [61173] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1642), 1,
      sym__linear_fun_arrow,
    STATE(1643), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4600), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4602), 32,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [61262] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [61335] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5317), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5319), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [61402] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [61469] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5321), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5323), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [61536] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5325), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5327), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [61603] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5325), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5327), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [61670] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5329), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5331), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [61737] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4646), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [61804] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5333), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5335), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [61871] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5337), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5339), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [61938] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5341), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5343), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [62005] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5345), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5347), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [62072] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4630), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [62145] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5349), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5351), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [62212] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 43,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [62279] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5353), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5355), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [62346] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5357), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5359), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [62413] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5361), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5363), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [62480] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5361), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5363), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [62547] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5365), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5367), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [62614] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5369), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5371), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [62681] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5373), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5375), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [62748] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5377), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5379), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [62815] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5381), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5383), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [62882] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5385), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5387), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [62949] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5389), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5391), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [63016] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5385), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5387), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [63083] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5377), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5379), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [63150] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5393), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5395), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [63217] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5397), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5399), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [63284] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1685), 1,
      sym__linear_fun_arrow,
    STATE(1718), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4594), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4596), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [63373] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1685), 1,
      sym__linear_fun_arrow,
    STATE(1718), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4578), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4580), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [63462] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5401), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5403), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [63529] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1685), 1,
      sym__linear_fun_arrow,
    STATE(1718), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4586), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4588), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [63618] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5405), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5407), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [63685] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [63758] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1685), 1,
      sym__linear_fun_arrow,
    STATE(1718), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4590), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4592), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [63847] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5409), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5411), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [63914] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1685), 1,
      sym__linear_fun_arrow,
    STATE(1718), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4564), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4566), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [64003] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1685), 1,
      sym__linear_fun_arrow,
    STATE(1718), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4590), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4592), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [64092] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1685), 1,
      sym__linear_fun_arrow,
    STATE(1718), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4564), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4566), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [64181] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5413), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5415), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [64248] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [64321] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5417), 15,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_then,
      anon_sym_using,
      anon_sym_if,
      anon_sym_else,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_of,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5419), 40,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u27e6,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [64388] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4755), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [64454] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 37,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [64526] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 37,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [64598] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [64670] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4630), 37,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [64742] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [64814] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4723), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [64880] = 10,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    ACTIONS(5073), 1,
      anon_sym__,
    ACTIONS(5067), 2,
      sym__integer_literal,
      sym_variable,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5075), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_LT_DASH,
      anon_sym_u2190,
    ACTIONS(4943), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4945), 13,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
    ACTIONS(5070), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [64960] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4735), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [65026] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4785), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [65092] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4630), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [65164] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4715), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [65230] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4711), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [65296] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4707), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [65362] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4747), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [65428] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4681), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [65494] = 10,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    ACTIONS(5073), 1,
      anon_sym__,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(5067), 4,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5075), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4943), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4945), 11,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5070), 22,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [65574] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [65646] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4817), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [65712] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [65778] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [65844] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4685), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [65910] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 37,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [65982] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [66048] = 5,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 10,
      anon_sym_let,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_POUND,
      anon_sym_POUND2,
      anon_sym_where,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [66118] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [66190] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4630), 37,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [66262] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 37,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [66334] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [66406] = 10,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    ACTIONS(5073), 1,
      anon_sym__,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(5067), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5075), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_LT_DASH,
      anon_sym_u2190,
    ACTIONS(4943), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4945), 13,
      sym__phantom_arrow,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5070), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [66486] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4833), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [66552] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4813), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [66618] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4841), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [66684] = 10,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    ACTIONS(5073), 1,
      anon_sym__,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(5067), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5075), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4943), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4945), 13,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5070), 21,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [66764] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4763), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [66830] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4743), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [66896] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4767), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [66962] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [67034] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4789), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [67100] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [67166] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [67232] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 37,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [67304] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [67376] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [67442] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4781), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [67508] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4809), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [67574] = 10,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    ACTIONS(5073), 1,
      anon_sym__,
    ACTIONS(5067), 2,
      sym__integer_literal,
      sym_variable,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5075), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_LT_DASH,
      anon_sym_u2190,
    ACTIONS(4943), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4945), 13,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_RBRACK,
    ACTIONS(5070), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [67654] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4845), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [67720] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [67786] = 10,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    ACTIONS(5073), 2,
      anon_sym__,
      anon_sym_PIPE,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(5067), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5075), 7,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_COMMA,
      anon_sym_PIPE2,
      anon_sym_POUND_RPAREN,
    ACTIONS(4943), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4945), 11,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5070), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [67866] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4695), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [67932] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4731), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [67998] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4849), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [68064] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [68136] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [68202] = 10,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    ACTIONS(5073), 1,
      anon_sym__,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(5067), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4943), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(5075), 8,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
    ACTIONS(4945), 11,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5070), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [68282] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 37,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [68354] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4837), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [68420] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4793), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [68486] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4797), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [68552] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4703), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [68618] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 37,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [68690] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [68756] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(1125), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(1123), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [68822] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4861), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [68888] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [68960] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4739), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [69026] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4630), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [69098] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4630), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [69170] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4857), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [69236] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4751), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [69302] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [69368] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4630), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [69440] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4853), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [69506] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4829), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [69572] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [69644] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4825), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [69710] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4759), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [69776] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4775), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [69842] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4875), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4877), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [69908] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4871), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4873), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [69974] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 37,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [70046] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4699), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [70112] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4867), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4869), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [70178] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4863), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4865), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [70244] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [70316] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4863), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4865), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [70382] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4821), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [70448] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4719), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [70514] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4727), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [70580] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 37,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [70652] = 9,
    ACTIONS(4674), 1,
      sym__cond_tight_at,
    ACTIONS(5421), 1,
      anon_sym__,
    STATE(2293), 1,
      sym__tight_at,
    ACTIONS(4666), 4,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5423), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 12,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(4652), 22,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [70729] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [70800] = 9,
    ACTIONS(4674), 1,
      sym__cond_tight_at,
    ACTIONS(5421), 1,
      anon_sym__,
    STATE(2299), 1,
      sym__tight_at,
    ACTIONS(4666), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5423), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_LT_DASH,
      anon_sym_u2190,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 14,
      sym__phantom_arrow,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(4652), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [70877] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [70948] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [71013] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4630), 37,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [71084] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 37,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [71155] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [71226] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [71297] = 9,
    ACTIONS(4674), 1,
      sym__cond_tight_at,
    ACTIONS(5421), 1,
      anon_sym__,
    STATE(2299), 1,
      sym__tight_at,
    ACTIONS(4666), 2,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5423), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_LT_DASH,
      anon_sym_u2190,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 14,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_RBRACK,
    ACTIONS(4652), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [71374] = 26,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(3409), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5425), 1,
      sym_variable,
    ACTIONS(5427), 1,
      anon_sym__,
    ACTIONS(5429), 1,
      anon_sym_SQUOTE,
    ACTIONS(5435), 1,
      sym__integer_literal,
    ACTIONS(5439), 1,
      sym_name,
    ACTIONS(5441), 1,
      sym__cond_quote_start,
    ACTIONS(5443), 1,
      sym__cond_infix,
    STATE(1750), 1,
      sym__paren_open,
    STATE(2138), 1,
      sym_constraint,
    STATE(3854), 1,
      sym_deriving_strategy,
    STATE(7357), 1,
      sym__splice_dollars,
    STATE(7893), 1,
      sym_integer,
    STATE(7927), 1,
      sym__class_infix,
    STATE(7930), 1,
      sym__class_apply,
    STATE(7935), 1,
      sym__qualified_type,
    STATE(9358), 1,
      sym__unboxed_open,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11046), 1,
      aux_sym__qualifying_module,
    ACTIONS(5431), 3,
      anon_sym_stock,
      anon_sym_newtype,
      anon_sym_anyclass,
    ACTIONS(5433), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5437), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7926), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7931), 13,
      sym__type_wildcard,
      sym__ctr_parens,
      sym__ctr_tuple,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [71485] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [71556] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 42,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [71621] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [71692] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 37,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [71763] = 10,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    ACTIONS(5073), 1,
      anon_sym__,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(5067), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5075), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4943), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4945), 12,
      sym__cond_prefix_dot,
      sym__cond_left_section_op,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5070), 21,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [71842] = 9,
    ACTIONS(4674), 1,
      sym__cond_tight_at,
    ACTIONS(5421), 1,
      anon_sym__,
    STATE(2299), 1,
      sym__tight_at,
    ACTIONS(4666), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(5423), 8,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
    ACTIONS(4646), 12,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(4652), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [71919] = 9,
    ACTIONS(4674), 1,
      sym__cond_tight_at,
    ACTIONS(5421), 1,
      anon_sym__,
    STATE(2299), 1,
      sym__tight_at,
    ACTIONS(4666), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5423), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 14,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(4652), 21,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [71996] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [72067] = 9,
    ACTIONS(4674), 1,
      sym__cond_tight_at,
    STATE(2293), 1,
      sym__tight_at,
    ACTIONS(5421), 2,
      anon_sym__,
      anon_sym_PIPE,
    ACTIONS(4666), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5423), 7,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_COMMA,
      anon_sym_PIPE2,
      anon_sym_POUND_RPAREN,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 12,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(4652), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [72144] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [72215] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [72286] = 9,
    ACTIONS(4674), 1,
      sym__cond_tight_at,
    ACTIONS(5421), 1,
      anon_sym__,
    STATE(2299), 1,
      sym__tight_at,
    ACTIONS(4666), 2,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5423), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_LT_DASH,
      anon_sym_u2190,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 14,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
    ACTIONS(4652), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [72363] = 10,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    ACTIONS(5073), 1,
      anon_sym__,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(5075), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5067), 5,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4943), 6,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
    ACTIONS(4945), 8,
      sym__cond_left_section_op,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5070), 25,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [72442] = 26,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(3409), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5425), 1,
      sym_variable,
    ACTIONS(5427), 1,
      anon_sym__,
    ACTIONS(5429), 1,
      anon_sym_SQUOTE,
    ACTIONS(5435), 1,
      sym__integer_literal,
    ACTIONS(5439), 1,
      sym_name,
    ACTIONS(5441), 1,
      sym__cond_quote_start,
    ACTIONS(5443), 1,
      sym__cond_infix,
    STATE(1750), 1,
      sym__paren_open,
    STATE(2122), 1,
      sym_constraint,
    STATE(3874), 1,
      sym_deriving_strategy,
    STATE(7357), 1,
      sym__splice_dollars,
    STATE(7893), 1,
      sym_integer,
    STATE(7927), 1,
      sym__class_infix,
    STATE(7930), 1,
      sym__class_apply,
    STATE(7935), 1,
      sym__qualified_type,
    STATE(9358), 1,
      sym__unboxed_open,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11046), 1,
      aux_sym__qualifying_module,
    ACTIONS(5431), 3,
      anon_sym_stock,
      anon_sym_newtype,
      anon_sym_anyclass,
    ACTIONS(5433), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5437), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7926), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7931), 13,
      sym__type_wildcard,
      sym__ctr_parens,
      sym__ctr_tuple,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [72553] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [72624] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4630), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [72695] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [72766] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4630), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [72837] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [72908] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [72979] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [73050] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [73121] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [73192] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4833), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [73256] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [73320] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [73384] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [73448] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [73512] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [73576] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [73640] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [73704] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4833), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [73768] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4767), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [73832] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [73896] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [73960] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4841), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [74024] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [74088] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [74152] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [74216] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [74280] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [74344] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4845), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [74408] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4845), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [74472] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [74536] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [74600] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [74664] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [74728] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [74792] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [74856] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4735), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [74920] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [74984] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [75048] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [75112] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [75176] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [75240] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [75304] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [75368] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [75432] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4743), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [75496] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [75560] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [75624] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [75688] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4763), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [75752] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4797), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [75816] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4735), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [75880] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [75944] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4797), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [76008] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [76072] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4747), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [76136] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [76200] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [76264] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4841), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [76328] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [76392] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [76456] = 7,
    ACTIONS(5451), 1,
      anon_sym__,
    ACTIONS(5445), 4,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 6,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
    ACTIONS(5453), 9,
      sym__phantom_bar,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(4646), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_tight_dot,
      anon_sym_SEMI,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
    ACTIONS(5448), 22,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      aux_sym__paren_open_token1,
  [76528] = 7,
    ACTIONS(5461), 1,
      anon_sym__,
    ACTIONS(5455), 4,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5349), 6,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
    ACTIONS(5463), 9,
      sym__phantom_bar,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(5351), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_tight_dot,
      anon_sym_SEMI,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
    ACTIONS(5458), 22,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      aux_sym__paren_open_token1,
  [76600] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [76664] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [76728] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [76792] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [76856] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [76920] = 7,
    ACTIONS(5451), 1,
      anon_sym__,
    ACTIONS(5445), 4,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 6,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
    ACTIONS(5453), 9,
      sym__phantom_bar,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(4646), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_tight_dot,
      anon_sym_SEMI,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
    ACTIONS(5448), 22,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      aux_sym__paren_open_token1,
  [76992] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [77056] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4681), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [77120] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [77184] = 6,
    ACTIONS(5465), 1,
      sym__cond_qual_dot,
    ACTIONS(5467), 1,
      sym__cond_tight_dot,
    STATE(9944), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [77254] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [77318] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4821), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [77382] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [77446] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [77510] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4703), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [77574] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4719), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [77638] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [77702] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4727), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [77766] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4731), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [77830] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4813), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [77894] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [77958] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [78022] = 5,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5469), 5,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4737), 6,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
    ACTIONS(4739), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_tight_dot,
      anon_sym_SEMI,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
    ACTIONS(5471), 31,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [78090] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [78154] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [78218] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [78282] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [78346] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [78410] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [78474] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [78538] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [78602] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [78666] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4813), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [78730] = 11,
    ACTIONS(4655), 1,
      anon_sym__,
    ACTIONS(4674), 1,
      sym__cond_tight_at,
    STATE(2264), 1,
      sym__tight_at,
    ACTIONS(4666), 2,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4642), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4676), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 6,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
    ACTIONS(4646), 9,
      sym__cond_tight_dot,
      sym__cond_left_section_op,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(4652), 12,
      sym__cond_prefix_dot,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(4662), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [78810] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [78874] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [78938] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [79002] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [79066] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [79130] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [79194] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [79258] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [79322] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [79386] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4735), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [79450] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [79514] = 5,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 9,
      anon_sym_let,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 26,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [79582] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [79646] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [79710] = 5,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 10,
      anon_sym_let,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 25,
      sym__phantom_arrow,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_POUND_RPAREN,
  [79778] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [79842] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [79906] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [79970] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [80034] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [80098] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [80162] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4763), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [80226] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [80290] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [80354] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [80418] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [80482] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4747), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [80546] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4743), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [80610] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [80674] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [80738] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4797), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [80802] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [80866] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [80930] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4767), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [80994] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [81058] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [81122] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [81186] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [81250] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [81314] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [81378] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [81442] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [81506] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4781), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [81570] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [81634] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [81698] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [81762] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4781), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [81826] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [81890] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [81954] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4845), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [82018] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4841), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [82082] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [82146] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4731), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [82210] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [82274] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4833), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [82338] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [82402] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [82466] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4767), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [82530] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [82594] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [82658] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4727), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [82722] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4743), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [82786] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4719), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [82850] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [82914] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [82978] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [83042] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [83106] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [83170] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4703), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [83234] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4763), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [83298] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [83362] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4735), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [83426] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [83490] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [83554] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [83618] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [83682] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4681), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [83746] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4821), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [83810] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [83874] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4821), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [83938] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [84002] = 5,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 9,
      anon_sym_let,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 26,
      sym__phantom_arrow,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_RBRACK,
  [84070] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [84134] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4681), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [84198] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4681), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [84262] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [84326] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [84390] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [84454] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4821), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [84518] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [84582] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [84646] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4817), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [84710] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [84774] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4833), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [84838] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4841), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [84902] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4845), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [84966] = 10,
    ACTIONS(5073), 1,
      anon_sym__,
    ACTIONS(5465), 1,
      sym__cond_qual_dot,
    ACTIONS(5467), 1,
      sym__cond_tight_dot,
    STATE(9944), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(5067), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5075), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(4943), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4945), 11,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5070), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [85044] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [85108] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 41,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [85172] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(1125), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(1123), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [85236] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [85300] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [85364] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4875), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4877), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [85428] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [85492] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [85556] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [85620] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [85684] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4703), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [85748] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [85812] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [85876] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4871), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4873), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [85940] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4719), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [86004] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4747), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [86068] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [86132] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [86196] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4797), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [86260] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [86324] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4867), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4869), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [86388] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [86452] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [86516] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4727), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [86580] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4747), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [86644] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4731), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [86708] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4863), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4865), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [86772] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [86836] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [86900] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4863), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4865), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [86964] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [87028] = 9,
    ACTIONS(4674), 1,
      sym__cond_tight_at,
    ACTIONS(5421), 1,
      anon_sym__,
    STATE(2299), 1,
      sym__tight_at,
    ACTIONS(4666), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5423), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 13,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_left_section_op,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(4652), 21,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [87104] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [87168] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4817), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [87232] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4817), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [87296] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [87360] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [87424] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [87488] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [87552] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4731), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [87616] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4727), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [87680] = 5,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 10,
      anon_sym_let,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 25,
      sym__phantom_arrow,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_RBRACK,
  [87748] = 10,
    ACTIONS(5073), 1,
      anon_sym__,
    ACTIONS(5465), 1,
      sym__cond_qual_dot,
    ACTIONS(5467), 1,
      sym__cond_tight_dot,
    STATE(9944), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5067), 5,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4943), 6,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
    ACTIONS(5075), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(4945), 7,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5070), 23,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [87826] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [87890] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4719), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [87954] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [88018] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4703), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [88082] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4763), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [88146] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4817), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [88210] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4813), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [88274] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4743), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [88338] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4767), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [88402] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4781), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [88466] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [88530] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [88594] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [88658] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 14,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4781), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [88722] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [88786] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [88850] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4813), 39,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [88914] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [88977] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [89040] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [89103] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4727), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [89166] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [89229] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [89292] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [89355] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [89424] = 5,
    ACTIONS(5469), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4739), 14,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_RBRACK,
    ACTIONS(5471), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [89491] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4630), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [89560] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [89623] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [89686] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [89749] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [89812] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [89875] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4731), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [89938] = 7,
    ACTIONS(5421), 1,
      anon_sym__,
    ACTIONS(4666), 2,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5423), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_LT_DASH,
      anon_sym_u2190,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 14,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_RBRACK,
    ACTIONS(4652), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [90009] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4735), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [90072] = 12,
    ACTIONS(4655), 1,
      anon_sym__,
    ACTIONS(4674), 1,
      sym__cond_tight_at,
    ACTIONS(5423), 1,
      anon_sym_COMMA,
    STATE(2264), 1,
      sym__tight_at,
    ACTIONS(4666), 2,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4642), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4676), 5,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      aux_sym__paren_close_token1,
    ACTIONS(4648), 6,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
    ACTIONS(4646), 8,
      sym__cond_tight_dot,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(4652), 11,
      sym__cond_prefix_dot,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(4662), 12,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [90153] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4719), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [90216] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4703), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [90279] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [90342] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [90411] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4727), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [90474] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [90537] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [90600] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [90663] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [90726] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4731), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [90789] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4743), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [90852] = 5,
    ACTIONS(5469), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4739), 12,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5471), 27,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [90919] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [90982] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [91051] = 5,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 9,
      anon_sym_let,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 25,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [91118] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [91187] = 7,
    ACTIONS(5451), 1,
      anon_sym__,
    ACTIONS(5445), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(5453), 8,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
    ACTIONS(4646), 12,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5448), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [91258] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [91327] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [91390] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4763), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [91453] = 7,
    ACTIONS(5461), 1,
      anon_sym__,
    ACTIONS(5455), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5349), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(5463), 8,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
    ACTIONS(5351), 12,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5458), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [91524] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4767), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [91587] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [91650] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [91719] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [91782] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [91845] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [91908] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4719), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [91971] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4703), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [92034] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [92097] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [92166] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [92229] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [92298] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [92367] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [92430] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [92493] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [92562] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [92631] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [92700] = 7,
    ACTIONS(5421), 1,
      anon_sym__,
    ACTIONS(4666), 2,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5423), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_LT_DASH,
      anon_sym_u2190,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 14,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
    ACTIONS(4652), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [92771] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [92840] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [92909] = 7,
    ACTIONS(5451), 1,
      anon_sym__,
    ACTIONS(5445), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(5453), 8,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
    ACTIONS(4646), 12,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5448), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [92980] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [93043] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4630), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [93112] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [93175] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [93244] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [93307] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [93370] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [93433] = 7,
    ACTIONS(5421), 1,
      anon_sym__,
    ACTIONS(4666), 4,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5423), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 12,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(4652), 22,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [93504] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [93573] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4763), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [93636] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4743), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [93699] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4767), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [93762] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [93825] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [93888] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [93951] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [94014] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4781), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [94077] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [94140] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [94203] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [94266] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [94329] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4781), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [94392] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [94455] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [94518] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [94587] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [94650] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [94713] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [94776] = 7,
    ACTIONS(5451), 1,
      anon_sym__,
    ACTIONS(5445), 2,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5453), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_LT_DASH,
      anon_sym_u2190,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 14,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
    ACTIONS(5448), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [94847] = 7,
    ACTIONS(5451), 1,
      anon_sym__,
    ACTIONS(5445), 4,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5453), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 12,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5448), 22,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [94918] = 7,
    ACTIONS(5461), 1,
      anon_sym__,
    ACTIONS(5455), 4,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5463), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5349), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(5351), 12,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5458), 22,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [94989] = 7,
    ACTIONS(5461), 1,
      anon_sym__,
    ACTIONS(5455), 2,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5463), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_LT_DASH,
      anon_sym_u2190,
    ACTIONS(5349), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(5351), 14,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
    ACTIONS(5458), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [95060] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [95123] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [95186] = 7,
    ACTIONS(5451), 1,
      anon_sym__,
    ACTIONS(5445), 2,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5453), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_LT_DASH,
      anon_sym_u2190,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 14,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
    ACTIONS(5448), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [95257] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [95320] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4821), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [95383] = 5,
    ACTIONS(5469), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4739), 14,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
    ACTIONS(5471), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [95450] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4681), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [95513] = 7,
    ACTIONS(5451), 1,
      anon_sym__,
    ACTIONS(5445), 4,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5453), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 12,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5448), 22,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [95584] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [95647] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [95710] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [95773] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [95836] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4943), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4945), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [95905] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [95968] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [96031] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4821), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [96094] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4630), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [96163] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [96226] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [96289] = 7,
    ACTIONS(5451), 1,
      anon_sym__,
    ACTIONS(5445), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5453), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 14,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5448), 21,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [96360] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4681), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [96423] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [96486] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [96549] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [96612] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [96675] = 7,
    ACTIONS(5461), 1,
      anon_sym__,
    ACTIONS(5455), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5463), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5349), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(5351), 14,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5458), 21,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [96746] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [96809] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [96872] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [96935] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [96998] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [97061] = 5,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 9,
      anon_sym_let,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 25,
      sym__phantom_arrow,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
  [97128] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [97191] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [97254] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [97317] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [97380] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [97443] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [97506] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [97569] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [97632] = 7,
    ACTIONS(5451), 1,
      anon_sym__,
    ACTIONS(5445), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5453), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 14,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5448), 21,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [97703] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [97766] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4797), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [97829] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [97892] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4833), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [97955] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [98018] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4841), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [98081] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [98144] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [98207] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [98276] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [98339] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [98402] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4845), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [98465] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [98528] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [98591] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [98654] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [98717] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [98780] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [98843] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [98906] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [98969] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [99032] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [99095] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [99158] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4797), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [99221] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [99284] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [99347] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [99410] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [99473] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [99536] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4747), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [99599] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [99662] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [99725] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4735), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [99788] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [99851] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [99914] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [99977] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [100040] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [100103] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [100166] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [100235] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [100298] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4833), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [100361] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [100424] = 7,
    ACTIONS(5451), 2,
      anon_sym__,
      anon_sym_PIPE,
    ACTIONS(5445), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5453), 7,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_COMMA,
      anon_sym_PIPE2,
      anon_sym_POUND_RPAREN,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 12,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5448), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [100495] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [100558] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [100621] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4841), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [100684] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [100753] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4845), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [100816] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [100879] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [100942] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [101005] = 7,
    ACTIONS(5461), 2,
      anon_sym__,
      anon_sym_PIPE,
    ACTIONS(5455), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5463), 7,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_COMMA,
      anon_sym_PIPE2,
      anon_sym_POUND_RPAREN,
    ACTIONS(5349), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(5351), 12,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5458), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [101076] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [101139] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4813), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [101202] = 7,
    ACTIONS(5451), 2,
      anon_sym__,
      anon_sym_PIPE,
    ACTIONS(5445), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5453), 7,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_COMMA,
      anon_sym_PIPE2,
      anon_sym_POUND_RPAREN,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 12,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5448), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [101273] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [101336] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [101399] = 12,
    ACTIONS(4658), 1,
      anon_sym_EQ,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    STATE(8422), 1,
      aux_sym__bind_matches_repeat1,
    STATE(8990), 1,
      sym__bind_match,
    STATE(9050), 1,
      sym__simple_bind_match,
    STATE(10224), 1,
      sym__bind_matches,
    STATE(12338), 1,
      sym__bar,
    STATE(12352), 1,
      sym__guards,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4646), 32,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [101480] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [101543] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [101612] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [101675] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [101738] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [101801] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [101864] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [101927] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [101990] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [102053] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [102116] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [102179] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [102242] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [102305] = 7,
    ACTIONS(5451), 1,
      anon_sym__,
    ACTIONS(5445), 2,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5453), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_LT_DASH,
      anon_sym_u2190,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 14,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_RBRACK,
    ACTIONS(5448), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [102376] = 7,
    ACTIONS(5461), 1,
      anon_sym__,
    ACTIONS(5455), 2,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5463), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_LT_DASH,
      anon_sym_u2190,
    ACTIONS(5349), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(5351), 14,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_RBRACK,
    ACTIONS(5458), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [102447] = 5,
    ACTIONS(5469), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4739), 14,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5471), 25,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [102514] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [102577] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [102640] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [102703] = 7,
    ACTIONS(5451), 1,
      anon_sym__,
    ACTIONS(5445), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5453), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_LT_DASH,
      anon_sym_u2190,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 14,
      sym__phantom_arrow,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5448), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [102774] = 7,
    ACTIONS(5451), 1,
      anon_sym__,
    ACTIONS(5445), 2,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5453), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_LT_DASH,
      anon_sym_u2190,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 14,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_RBRACK,
    ACTIONS(5448), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [102845] = 7,
    ACTIONS(5421), 1,
      anon_sym__,
    ACTIONS(4666), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5423), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 14,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(4652), 21,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [102916] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [102979] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [103042] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [103105] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [103168] = 7,
    ACTIONS(5461), 1,
      anon_sym__,
    ACTIONS(5455), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5463), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_LT_DASH,
      anon_sym_u2190,
    ACTIONS(5349), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(5351), 14,
      sym__phantom_arrow,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5458), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [103239] = 7,
    ACTIONS(5451), 1,
      anon_sym__,
    ACTIONS(5445), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5453), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_LT_DASH,
      anon_sym_u2190,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 14,
      sym__phantom_arrow,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5448), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [103310] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4813), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [103373] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4747), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [103436] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [103499] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [103562] = 5,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5469), 5,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4737), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4739), 12,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5471), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [103629] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [103692] = 5,
    STATE(4077), 1,
      sym_alternatives,
    ACTIONS(5473), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4975), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4977), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [103759] = 5,
    ACTIONS(5469), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4739), 14,
      sym__phantom_arrow,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5471), 25,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [103826] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 40,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [103889] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [103952] = 7,
    ACTIONS(5421), 2,
      anon_sym__,
      anon_sym_PIPE,
    ACTIONS(4666), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5423), 7,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_COMMA,
      anon_sym_PIPE2,
      anon_sym_POUND_RPAREN,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 12,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(4652), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [104023] = 7,
    ACTIONS(5421), 1,
      anon_sym__,
    ACTIONS(4666), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(5423), 8,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
    ACTIONS(4646), 12,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(4652), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [104094] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [104157] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [104220] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [104283] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [104346] = 7,
    ACTIONS(5421), 1,
      anon_sym__,
    ACTIONS(4666), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5423), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_LT_DASH,
      anon_sym_u2190,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 14,
      sym__phantom_arrow,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_minus,
      sym__varsym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(4652), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [104417] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [104480] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [104543] = 5,
    STATE(4198), 1,
      sym_alternatives,
    ACTIONS(5473), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4955), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4957), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [104610] = 5,
    STATE(4197), 1,
      sym__nalts,
    ACTIONS(5475), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4965), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4967), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [104677] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [104740] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [104803] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [104866] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [104935] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [104998] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [105061] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [105124] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4923), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4925), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [105193] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [105256] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [105319] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [105382] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [105445] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [105508] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [105571] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [105634] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4817), 38,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [105697] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4817), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [105760] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [105823] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [105892] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 39,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [105955] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [106024] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [106086] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [106154] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4781), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [106216] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4715), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [106278] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4630), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [106346] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [106408] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4775), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [106470] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4759), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [106532] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4825), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [106594] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [106656] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4785), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [106718] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4861), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [106780] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4849), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [106842] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4747), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [106904] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [106966] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4695), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [107028] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4797), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [107090] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [107152] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4813), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [107214] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [107276] = 7,
    ACTIONS(5451), 1,
      anon_sym__,
    ACTIONS(5445), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5453), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 13,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_left_section_op,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5448), 21,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [107346] = 7,
    ACTIONS(5461), 1,
      anon_sym__,
    ACTIONS(5455), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5463), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5349), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(5351), 13,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_left_section_op,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5458), 21,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [107416] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4817), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [107478] = 7,
    ACTIONS(5451), 1,
      anon_sym__,
    ACTIONS(5445), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5453), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 13,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_left_section_op,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5448), 21,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [107548] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [107610] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [107672] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [107734] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [107796] = 7,
    ACTIONS(5451), 1,
      anon_sym__,
    ACTIONS(5453), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5445), 5,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4648), 6,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
    ACTIONS(4646), 9,
      sym__cond_tight_dot,
      sym__cond_left_section_op,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5448), 25,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [107866] = 7,
    ACTIONS(5461), 1,
      anon_sym__,
    ACTIONS(5463), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5455), 5,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5349), 6,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
    ACTIONS(5351), 9,
      sym__cond_tight_dot,
      sym__cond_left_section_op,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5458), 25,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [107936] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4845), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [107998] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [108060] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4841), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [108122] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4833), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [108184] = 7,
    ACTIONS(5451), 1,
      anon_sym__,
    ACTIONS(5453), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5445), 5,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4648), 6,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
    ACTIONS(4646), 9,
      sym__cond_tight_dot,
      sym__cond_left_section_op,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5448), 25,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [108254] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(1125), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(1123), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [108316] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [108378] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4809), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [108440] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4829), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [108502] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [108564] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [108626] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4863), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4865), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [108688] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4863), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4865), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [108750] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4867), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4869), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [108812] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4871), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4873), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [108874] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4875), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4877), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [108936] = 5,
    ACTIONS(5469), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4739), 13,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_left_section_op,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5471), 25,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [109002] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [109064] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4751), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [109126] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [109188] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [109256] = 5,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 6,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
    ACTIONS(5469), 6,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 9,
      sym__cond_tight_dot,
      sym__cond_left_section_op,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5471), 29,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [109322] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [109384] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4853), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [109446] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [109508] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4755), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [109570] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4857), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [109632] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4699), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [109694] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4821), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [109756] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [109818] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [109880] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [109942] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4703), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [110004] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4719), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [110066] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4727), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [110128] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4789), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [110190] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [110252] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4793), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [110314] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4731), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [110376] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [110438] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4763), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [110500] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [110562] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4863), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4865), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [110624] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4863), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4865), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [110686] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4735), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [110748] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4711), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [110810] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4681), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [110872] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4867), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4869), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [110934] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4863), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4865), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [110996] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4863), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4865), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [111058] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4867), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4869), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [111120] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4871), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4873), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [111182] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4871), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4873), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [111244] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4875), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4877), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [111306] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4875), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4877), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [111368] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(1125), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(1123), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [111430] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4707), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [111492] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4685), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [111554] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4743), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [111616] = 5,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 8,
      anon_sym_let,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
      anon_sym_where,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_u27e6,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [111682] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [111744] = 9,
    ACTIONS(4655), 1,
      anon_sym__,
    ACTIONS(4666), 2,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4642), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4676), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 6,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
    ACTIONS(4646), 9,
      sym__cond_tight_dot,
      sym__cond_left_section_op,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(4652), 12,
      sym__cond_prefix_dot,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(4662), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [111818] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [111886] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [111954] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [112016] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [112084] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4739), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [112146] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [112208] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4837), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [112270] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [112332] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [112394] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [112456] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [112524] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(1125), 13,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(1123), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [112586] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4723), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [112648] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [112716] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4863), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4865), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [112778] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [112846] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4863), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4865), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [112908] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4867), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4869), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [112970] = 7,
    ACTIONS(5421), 1,
      anon_sym__,
    ACTIONS(4666), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5423), 4,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4646), 13,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_left_section_op,
      sym__cond_minus,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(4652), 21,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [113040] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [113102] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4871), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4873), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [113164] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4875), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4877), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [113226] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(1125), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(1123), 38,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [113288] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [113350] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 38,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [113412] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4767), 38,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [113474] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4833), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [113535] = 24,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(3389), 1,
      sym_variable,
    ACTIONS(3393), 1,
      anon_sym__,
    ACTIONS(3395), 1,
      anon_sym_SQUOTE,
    ACTIONS(3399), 1,
      sym__integer_literal,
    ACTIONS(3409), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3413), 1,
      sym__cond_quote_start,
    ACTIONS(3417), 1,
      sym__cond_infix,
    ACTIONS(4687), 1,
      sym_name,
    STATE(1536), 1,
      sym__paren_open,
    STATE(2238), 1,
      sym_constraint,
    STATE(7254), 1,
      sym__splice_dollars,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(7997), 1,
      sym_integer,
    STATE(8005), 1,
      sym__class_apply,
    STATE(8007), 1,
      sym__class_infix,
    STATE(9192), 1,
      sym__unboxed_open,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(3397), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3401), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8011), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7980), 13,
      sym__type_wildcard,
      sym__ctr_parens,
      sym__ctr_tuple,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [113638] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [113699] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [113760] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [113821] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4759), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [113882] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [113949] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4785), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [114010] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4775), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [114071] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [114138] = 5,
    STATE(4769), 1,
      sym_alternatives,
    ACTIONS(5477), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4975), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4977), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [114203] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4695), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [114264] = 5,
    STATE(4843), 1,
      sym_alternatives,
    ACTIONS(5477), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4955), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4957), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [114329] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [114396] = 24,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(3389), 1,
      sym_variable,
    ACTIONS(3393), 1,
      anon_sym__,
    ACTIONS(3395), 1,
      anon_sym_SQUOTE,
    ACTIONS(3399), 1,
      sym__integer_literal,
    ACTIONS(3409), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3413), 1,
      sym__cond_quote_start,
    ACTIONS(3417), 1,
      sym__cond_infix,
    ACTIONS(4687), 1,
      sym_name,
    STATE(1536), 1,
      sym__paren_open,
    STATE(2250), 1,
      sym_constraint,
    STATE(7254), 1,
      sym__splice_dollars,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(7997), 1,
      sym_integer,
    STATE(8005), 1,
      sym__class_apply,
    STATE(8007), 1,
      sym__class_infix,
    STATE(9192), 1,
      sym__unboxed_open,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(3397), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3401), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8011), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7980), 13,
      sym__type_wildcard,
      sym__ctr_parens,
      sym__ctr_tuple,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [114499] = 5,
    STATE(4847), 1,
      sym__nalts,
    ACTIONS(5479), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4965), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4967), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [114564] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4825), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [114625] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [114692] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4875), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4877), 37,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [114753] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4845), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [114814] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4871), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4873), 37,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [114875] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4867), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4869), 37,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [114936] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4767), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [114997] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [115058] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4817), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [115119] = 5,
    STATE(4539), 1,
      sym_alternatives,
    ACTIONS(5481), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4975), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4977), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [115184] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4863), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4865), 37,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [115245] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [115312] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [115379] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4863), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4865), 37,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [115440] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [115507] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [115574] = 7,
    ACTIONS(39), 1,
      anon_sym_import,
    ACTIONS(93), 1,
      anon_sym_SEMI,
    STATE(4174), 1,
      aux_sym__let_binds_repeat1,
    STATE(11812), 1,
      sym_import,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5483), 21,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_type,
      anon_sym_instance,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_pattern,
      anon_sym_newtype,
      anon_sym_deriving,
      anon_sym_data,
      anon_sym_default,
      anon_sym_class,
      anon_sym_infixr,
      anon_sym_infixl,
      anon_sym_infix,
      anon_sym_foreign,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5485), 24,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [115643] = 5,
    STATE(4419), 1,
      sym_alternatives,
    ACTIONS(5487), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4975), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4977), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [115708] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [115775] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(1125), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(1123), 37,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [115836] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [115903] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4731), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [115964] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4727), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [116025] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4789), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [116086] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [116147] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4707), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [116208] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4715), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [116269] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [116330] = 24,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(3389), 1,
      sym_variable,
    ACTIONS(3393), 1,
      anon_sym__,
    ACTIONS(3395), 1,
      anon_sym_SQUOTE,
    ACTIONS(3399), 1,
      sym__integer_literal,
    ACTIONS(3409), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3413), 1,
      sym__cond_quote_start,
    ACTIONS(3417), 1,
      sym__cond_infix,
    ACTIONS(4687), 1,
      sym_name,
    STATE(1536), 1,
      sym__paren_open,
    STATE(2247), 1,
      sym_constraint,
    STATE(7254), 1,
      sym__splice_dollars,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(7997), 1,
      sym_integer,
    STATE(8005), 1,
      sym__class_apply,
    STATE(8007), 1,
      sym__class_infix,
    STATE(9192), 1,
      sym__unboxed_open,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(3397), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3401), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8011), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7980), 13,
      sym__type_wildcard,
      sym__ctr_parens,
      sym__ctr_tuple,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [116433] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4751), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [116494] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4755), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [116555] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [116622] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4797), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [116683] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4943), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4945), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [116750] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [116817] = 24,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(3409), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5425), 1,
      sym_variable,
    ACTIONS(5427), 1,
      anon_sym__,
    ACTIONS(5429), 1,
      anon_sym_SQUOTE,
    ACTIONS(5435), 1,
      sym__integer_literal,
    ACTIONS(5439), 1,
      sym_name,
    ACTIONS(5441), 1,
      sym__cond_quote_start,
    ACTIONS(5443), 1,
      sym__cond_infix,
    STATE(1750), 1,
      sym__paren_open,
    STATE(2154), 1,
      sym_constraint,
    STATE(7357), 1,
      sym__splice_dollars,
    STATE(7893), 1,
      sym_integer,
    STATE(7927), 1,
      sym__class_infix,
    STATE(7930), 1,
      sym__class_apply,
    STATE(7935), 1,
      sym__qualified_type,
    STATE(9358), 1,
      sym__unboxed_open,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11046), 1,
      aux_sym__qualifying_module,
    ACTIONS(5433), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5437), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7926), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7931), 13,
      sym__type_wildcard,
      sym__ctr_parens,
      sym__ctr_tuple,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [116920] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [116981] = 5,
    STATE(4628), 1,
      sym__nalts,
    ACTIONS(5489), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4965), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4967), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [117046] = 5,
    STATE(4631), 1,
      sym_alternatives,
    ACTIONS(5481), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4955), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4957), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [117111] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4809), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [117172] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4943), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4945), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [117239] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4861), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [117300] = 7,
    ACTIONS(39), 1,
      anon_sym_import,
    ACTIONS(93), 1,
      anon_sym_SEMI,
    STATE(4174), 1,
      aux_sym__let_binds_repeat1,
    STATE(11812), 1,
      sym_import,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5491), 21,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_type,
      anon_sym_instance,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_pattern,
      anon_sym_newtype,
      anon_sym_deriving,
      anon_sym_data,
      anon_sym_default,
      anon_sym_class,
      anon_sym_infixr,
      anon_sym_infixl,
      anon_sym_infix,
      anon_sym_foreign,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5493), 24,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [117369] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4943), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4945), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [117436] = 24,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(3389), 1,
      sym_variable,
    ACTIONS(3393), 1,
      anon_sym__,
    ACTIONS(3395), 1,
      anon_sym_SQUOTE,
    ACTIONS(3399), 1,
      sym__integer_literal,
    ACTIONS(3409), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3413), 1,
      sym__cond_quote_start,
    ACTIONS(3417), 1,
      sym__cond_infix,
    ACTIONS(4687), 1,
      sym_name,
    STATE(1536), 1,
      sym__paren_open,
    STATE(2240), 1,
      sym_constraint,
    STATE(7254), 1,
      sym__splice_dollars,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(7997), 1,
      sym_integer,
    STATE(8005), 1,
      sym__class_apply,
    STATE(8007), 1,
      sym__class_infix,
    STATE(9192), 1,
      sym__unboxed_open,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(3397), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3401), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8011), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7980), 13,
      sym__type_wildcard,
      sym__ctr_parens,
      sym__ctr_tuple,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [117539] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [117606] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4630), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [117673] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4829), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [117734] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [117801] = 5,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 8,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_POUND,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 24,
      sym__phantom_arrow,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [117866] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4747), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [117927] = 10,
    ACTIONS(4655), 1,
      anon_sym__,
    ACTIONS(5423), 1,
      anon_sym_COMMA,
    ACTIONS(4666), 2,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4642), 3,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4676), 5,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      aux_sym__paren_close_token1,
    ACTIONS(4648), 6,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
    ACTIONS(4646), 8,
      sym__cond_tight_dot,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(4652), 11,
      sym__cond_prefix_dot,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(4662), 12,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [118002] = 5,
    STATE(4333), 1,
      sym__nalts,
    ACTIONS(5495), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4965), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4967), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [118067] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4630), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [118134] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [118201] = 24,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(3409), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5425), 1,
      sym_variable,
    ACTIONS(5427), 1,
      anon_sym__,
    ACTIONS(5429), 1,
      anon_sym_SQUOTE,
    ACTIONS(5435), 1,
      sym__integer_literal,
    ACTIONS(5439), 1,
      sym_name,
    ACTIONS(5441), 1,
      sym__cond_quote_start,
    ACTIONS(5443), 1,
      sym__cond_infix,
    STATE(1750), 1,
      sym__paren_open,
    STATE(2155), 1,
      sym_constraint,
    STATE(7357), 1,
      sym__splice_dollars,
    STATE(7893), 1,
      sym_integer,
    STATE(7927), 1,
      sym__class_infix,
    STATE(7930), 1,
      sym__class_apply,
    STATE(7935), 1,
      sym__qualified_type,
    STATE(9358), 1,
      sym__unboxed_open,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11046), 1,
      aux_sym__qualifying_module,
    ACTIONS(5433), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5437), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7926), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7931), 13,
      sym__type_wildcard,
      sym__ctr_parens,
      sym__ctr_tuple,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [118304] = 5,
    STATE(4332), 1,
      sym_alternatives,
    ACTIONS(5487), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4955), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4957), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [118369] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [118436] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [118503] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4630), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [118570] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [118637] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [118704] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [118771] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [118838] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4923), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4925), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [118905] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [118972] = 24,
    ACTIONS(83), 1,
      sym__cond_splice,
    ACTIONS(3389), 1,
      sym_variable,
    ACTIONS(3393), 1,
      anon_sym__,
    ACTIONS(3395), 1,
      anon_sym_SQUOTE,
    ACTIONS(3399), 1,
      sym__integer_literal,
    ACTIONS(3409), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3413), 1,
      sym__cond_quote_start,
    ACTIONS(3417), 1,
      sym__cond_infix,
    ACTIONS(4687), 1,
      sym_name,
    STATE(1536), 1,
      sym__paren_open,
    STATE(2239), 1,
      sym_constraint,
    STATE(7254), 1,
      sym__splice_dollars,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(7997), 1,
      sym_integer,
    STATE(8005), 1,
      sym__class_apply,
    STATE(8007), 1,
      sym__class_infix,
    STATE(9192), 1,
      sym__unboxed_open,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(3397), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3401), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8011), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7980), 13,
      sym__type_wildcard,
      sym__ctr_parens,
      sym__ctr_tuple,
      sym_splice,
      sym_quasiquote,
      sym_unit,
      sym_unboxed_unit,
      sym_prefix_tuple,
      sym_prefix_unboxed_tuple,
      sym_prefix_unboxed_sum,
      sym_literal,
      sym__promoted_tycons_alias,
      sym__promoted_tycons,
  [119075] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4739), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [119136] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [119197] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [119258] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4863), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4865), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [119319] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4923), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4925), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [119386] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [119447] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [119508] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [119575] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4681), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [119636] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [119703] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4821), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [119764] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4781), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [119825] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4813), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [119886] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [119953] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4853), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [120014] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4863), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4865), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [120075] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4867), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4869), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [120136] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4735), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [120197] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [120264] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4871), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4873), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [120325] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4793), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [120386] = 5,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 6,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
    ACTIONS(5469), 6,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 8,
      sym__cond_tight_dot,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5471), 29,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [120451] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4837), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [120512] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4875), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4877), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [120573] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(1125), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(1123), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [120634] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4857), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [120695] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4743), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [120756] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4719), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [120817] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4685), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [120878] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4923), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4925), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [120945] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4711), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [121006] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [121073] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4699), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [121134] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4703), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [121195] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [121262] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [121329] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4763), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [121390] = 7,
    ACTIONS(5451), 1,
      anon_sym__,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5445), 5,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4648), 6,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
    ACTIONS(5453), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(4646), 8,
      sym__cond_tight_dot,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5448), 23,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [121459] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [121526] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4723), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [121587] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [121654] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [121721] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 12,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4849), 37,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_PIPE_PIPE_RBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [121782] = 7,
    ACTIONS(5461), 1,
      anon_sym__,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5455), 5,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5349), 6,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
    ACTIONS(5463), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(5351), 8,
      sym__cond_tight_dot,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5458), 23,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [121851] = 7,
    ACTIONS(5451), 1,
      anon_sym__,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5445), 5,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4648), 6,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
    ACTIONS(5453), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(4646), 8,
      sym__cond_tight_dot,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
    ACTIONS(5448), 23,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [121920] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4630), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [121987] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [122047] = 5,
    STATE(4990), 1,
      sym_alternatives,
    ACTIONS(5497), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4975), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4977), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [122111] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [122171] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5217), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5219), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [122231] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5231), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [122291] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5231), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [122351] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5231), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [122411] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5231), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [122471] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5241), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5243), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [122531] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5241), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5243), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [122591] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5249), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5251), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [122651] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5265), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5267), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [122711] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [122777] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5285), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5287), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [122837] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5301), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5303), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [122897] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5305), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5307), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [122957] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5311), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [123017] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5311), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [123077] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5313), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5315), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [123137] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5313), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5315), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [123197] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5305), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5307), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [123257] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4809), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [123317] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4861), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [123377] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5311), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [123437] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5311), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [123497] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5325), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5327), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [123557] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5325), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5327), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [123617] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5329), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5331), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [123677] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5333), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5335), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [123737] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5341), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5343), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [123797] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5357), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5359), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [123857] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4793), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [123917] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4747), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [123977] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5373), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5375), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [124037] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5377), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5379), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [124097] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5381), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5383), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [124157] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5385), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5387), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [124217] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5385), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5387), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [124277] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5377), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5379), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [124337] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5393), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5395), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [124397] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5397), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5399), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [124457] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5401), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5403), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [124517] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4857), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [124577] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [124637] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5417), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5419), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [124697] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5405), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5407), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [124757] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5365), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5367), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [124817] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5353), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5355), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [124877] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5345), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5347), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [124937] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5317), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5319), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [124997] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5297), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5299), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [125057] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5293), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5295), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [125117] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5289), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5291), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [125177] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5273), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5275), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [125237] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5245), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5247), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [125297] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4853), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [125357] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [125417] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [125477] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5237), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5239), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [125537] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5237), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5239), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [125597] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5233), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5235), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [125657] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5225), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5227), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [125717] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4817), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [125777] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4825), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [125837] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4797), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [125897] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [125957] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5125), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5127), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [126017] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5117), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5119), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [126077] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [126137] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [126197] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4759), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [126257] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [126317] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4845), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [126377] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4841), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [126437] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4833), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [126497] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5109), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5111), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [126557] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4785), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [126617] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5101), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5103), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [126677] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5097), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5099), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [126737] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5093), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5095), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [126797] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5089), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5091), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [126857] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5085), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5087), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [126917] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5081), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5083), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [126977] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5055), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5057), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [127037] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4775), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [127097] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5051), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5053), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [127157] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [127217] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5043), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5045), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [127277] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [127337] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4715), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [127397] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [127463] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5019), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5021), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [127523] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5145), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5147), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [127583] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5015), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5017), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [127643] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5011), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5013), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [127703] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4797), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [127763] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [127829] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [127889] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [127949] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4703), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [128009] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4747), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [128069] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [128129] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4681), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [128189] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4821), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [128249] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4781), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [128309] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4719), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [128369] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4789), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [128429] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [128495] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4751), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [128555] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4833), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [128615] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4849), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [128675] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [128735] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4719), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [128795] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4703), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [128855] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [128915] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4845), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [128975] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [129035] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4731), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [129095] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5007), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5009), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [129155] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5349), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5351), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [129215] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4646), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [129275] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4755), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [129335] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4695), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [129395] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5409), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5411), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [129455] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [129515] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4727), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [129575] = 5,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 8,
      anon_sym_let,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
      anon_sym_where,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 23,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_u27e6,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [129639] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5137), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5139), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [129699] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [129759] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4813), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [129819] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [129879] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5137), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5139), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [129939] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [129999] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4821), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [130059] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [130119] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4739), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [130179] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [130239] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5105), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5107), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [130299] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4743), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [130359] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4727), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [130419] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5039), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5041), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [130479] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [130539] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4747), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [130599] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [130659] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [130719] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5129), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5131), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [130779] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4797), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [130839] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4630), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [130905] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [130965] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [131025] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [131085] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4829), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [131145] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [131205] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4845), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [131265] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4763), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [131325] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4743), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [131385] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4841), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [131445] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4817), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [131505] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [131565] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [131631] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [131691] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [131751] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [131811] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4767), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [131871] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5133), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5135), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [131931] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4833), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [131991] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [132051] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5153), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5155), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [132111] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5035), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5037), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [132171] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5157), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5159), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [132231] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5031), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5033), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [132291] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4685), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [132351] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4781), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [132411] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5027), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5029), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [132471] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4817), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [132531] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [132591] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5161), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5163), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [132651] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5023), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5025), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [132711] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4999), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5001), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [132771] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4731), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [132831] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [132891] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5003), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5005), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [132951] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [133011] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [133071] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [133131] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4999), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5001), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [133191] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [133251] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4837), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [133311] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [133371] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5281), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5283), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [133431] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [133491] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4781), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [133551] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4681), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [133611] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [133671] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4995), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4997), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [133731] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [133791] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [133851] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4993), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [133911] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4993), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [133971] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5201), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5203), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [134031] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4821), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [134091] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4841), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [134151] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4993), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [134211] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5413), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5415), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [134271] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5113), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5115), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [134331] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5389), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5391), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [134391] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4813), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [134451] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [134511] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5213), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5215), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [134571] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5337), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5339), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [134631] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4979), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4981), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [134691] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5197), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5199), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [134751] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4813), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [134811] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5193), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5195), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [134871] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [134931] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [134991] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [135051] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5321), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5323), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [135111] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [135171] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [135231] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4983), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4985), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [135291] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4943), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4945), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [135357] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5277), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5279), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [135417] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [135477] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5173), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5175), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [135537] = 5,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 9,
      anon_sym_let,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 22,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_POUND_RPAREN,
  [135601] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5169), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5171), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [135661] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [135721] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5263), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [135781] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5263), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [135841] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [135901] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5263), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [135961] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [136021] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4699), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [136081] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5165), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5167), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [136141] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [136201] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [136261] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5149), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5151), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [136321] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [136381] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4767), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [136441] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4763), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [136501] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5257), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5259), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [136561] = 5,
    ACTIONS(5501), 1,
      anon_sym_SEMI,
    STATE(4174), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5499), 22,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_type,
      anon_sym_instance,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_pattern,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_deriving,
      anon_sym_data,
      anon_sym_default,
      anon_sym_class,
      anon_sym_infixr,
      anon_sym_infixl,
      anon_sym_infix,
      anon_sym_foreign,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5504), 24,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [136625] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4763), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [136685] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5253), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5255), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [136745] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [136805] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5209), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5211), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [136865] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [136925] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [136985] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4646), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [137045] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [137105] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4703), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [137165] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [137225] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4735), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [137285] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4719), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [137345] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4743), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [137405] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [137465] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4735), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [137525] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5269), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5271), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [137585] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [137645] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5121), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5123), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [137705] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [137765] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5077), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5079), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [137825] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4711), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [137885] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [137945] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5063), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5065), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [138005] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5059), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5061), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [138065] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5221), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5223), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [138125] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4707), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [138185] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [138251] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5189), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5191), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [138311] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5047), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5049), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [138371] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5185), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5187), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [138431] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [138491] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4923), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4925), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [138557] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(337), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(339), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [138617] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5269), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5271), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [138677] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [138737] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4727), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [138797] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4735), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [138857] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [138923] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [138983] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5361), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5363), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [139043] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4767), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [139103] = 5,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 8,
      anon_sym_let,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 23,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_RBRACK,
  [139167] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5177), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5179), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [139227] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5181), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5183), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [139287] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [139347] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5205), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5207), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [139407] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [139473] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [139533] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4987), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4989), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [139593] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [139653] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [139713] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4681), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [139773] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 13,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [139833] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5361), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5363), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [139893] = 5,
    STATE(5009), 1,
      sym_alternatives,
    ACTIONS(5497), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4955), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4957), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [139957] = 5,
    STATE(5008), 1,
      sym__nalts,
    ACTIONS(5506), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4965), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4967), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [140021] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5369), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5371), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [140081] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4731), 36,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [140141] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4723), 36,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [140201] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5141), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5143), 37,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [140261] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4833), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [140320] = 5,
    STATE(5442), 1,
      sym_alternatives,
    ACTIONS(5508), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4975), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4977), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [140383] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [140442] = 5,
    STATE(5208), 1,
      sym_alternatives,
    ACTIONS(5510), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4955), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4957), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [140505] = 5,
    STATE(5213), 1,
      sym__nalts,
    ACTIONS(5512), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4965), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4967), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [140568] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4735), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [140627] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4841), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [140686] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [140745] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [140804] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [140863] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [140922] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [140981] = 5,
    ACTIONS(39), 1,
      anon_sym_import,
    STATE(11812), 1,
      sym_import,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5491), 21,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_type,
      anon_sym_instance,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_pattern,
      anon_sym_newtype,
      anon_sym_deriving,
      anon_sym_data,
      anon_sym_default,
      anon_sym_class,
      anon_sym_infixr,
      anon_sym_infixl,
      anon_sym_infix,
      anon_sym_foreign,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5493), 24,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [141044] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4813), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [141103] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [141162] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [141221] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [141280] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [141339] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [141398] = 20,
    ACTIONS(4650), 1,
      anon_sym_COMMA,
    ACTIONS(4658), 1,
      anon_sym_EQ,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(4674), 1,
      sym__cond_tight_at,
    ACTIONS(5421), 1,
      anon_sym_POUND,
    STATE(1444), 1,
      sym__colon2,
    STATE(2289), 1,
      sym__tight_at,
    STATE(8422), 1,
      aux_sym__bind_matches_repeat1,
    STATE(8990), 1,
      sym__bind_match,
    STATE(9050), 1,
      sym__simple_bind_match,
    STATE(10222), 1,
      sym__bind_matches,
    STATE(10223), 1,
      aux_sym__var_binding_list_repeat1,
    STATE(12338), 1,
      sym__bar,
    STATE(12352), 1,
      sym__guards,
    ACTIONS(4669), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(4655), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5423), 10,
      sym__cond_prefix_dot,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
    ACTIONS(4676), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [141491] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4747), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [141550] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4817), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [141609] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [141668] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4797), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [141727] = 5,
    STATE(5284), 1,
      sym_alternatives,
    ACTIONS(5510), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4975), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4977), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [141790] = 5,
    ACTIONS(39), 1,
      anon_sym_import,
    STATE(11812), 1,
      sym_import,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5483), 21,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_type,
      anon_sym_instance,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_pattern,
      anon_sym_newtype,
      anon_sym_deriving,
      anon_sym_data,
      anon_sym_default,
      anon_sym_class,
      anon_sym_infixr,
      anon_sym_infixl,
      anon_sym_infix,
      anon_sym_foreign,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5485), 24,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [141853] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [141912] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [141971] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [142030] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [142089] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4845), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [142148] = 5,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 8,
      anon_sym_let,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 22,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
  [142211] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [142270] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [142329] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [142388] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4923), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4925), 33,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [142453] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [142512] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [142571] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4681), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [142630] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [142689] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [142748] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4821), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [142807] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4923), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4925), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [142872] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [142931] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4781), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [142990] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [143049] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4943), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4945), 33,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [143114] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [143173] = 5,
    STATE(5303), 1,
      sym_alternatives,
    ACTIONS(5514), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4955), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4957), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [143236] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [143295] = 5,
    STATE(5302), 1,
      sym__nalts,
    ACTIONS(5516), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4965), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4967), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [143358] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4731), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [143417] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4767), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [143476] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [143535] = 5,
    STATE(5462), 1,
      sym__nalts,
    ACTIONS(5518), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4965), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4967), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [143598] = 5,
    STATE(5463), 1,
      sym_alternatives,
    ACTIONS(5508), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4955), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4957), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [143661] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4743), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [143720] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4943), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4945), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [143785] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [143844] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [143903] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [143962] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4943), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4945), 32,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [144027] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4719), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [144086] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [144145] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [144204] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4923), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4925), 32,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [144269] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4703), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [144328] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4763), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [144387] = 5,
    STATE(5277), 1,
      sym_alternatives,
    ACTIONS(5514), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4975), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4977), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [144450] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4727), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [144509] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5221), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5223), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [144567] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5385), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5387), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [144625] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5189), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5191), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [144683] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5185), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5187), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [144741] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(337), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(339), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [144799] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4943), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4945), 32,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [144863] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [144921] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5201), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5203), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [144979] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [145037] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4781), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [145095] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4747), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [145153] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [145211] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [145269] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4797), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [145327] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [145385] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4987), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4989), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [145443] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4781), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [145501] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4813), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [145559] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4767), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [145617] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [145675] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [145733] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [145791] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4845), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [145849] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4841), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [145907] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4833), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [145965] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [146023] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4743), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [146081] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5059), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5061), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [146139] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5063), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5065), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [146197] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5077), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5079), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [146255] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4763), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [146313] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5121), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5123), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [146371] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5281), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5283), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [146429] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [146487] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [146545] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5149), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5151), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [146603] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5165), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5167), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [146661] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [146719] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4681), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [146777] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5047), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5049), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [146835] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [146893] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [146951] = 5,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 7,
      anon_sym_let,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 22,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_u27e6,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [147013] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4821), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [147071] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [147129] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [147187] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [147245] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [147303] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5169), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5171), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [147361] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [147419] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4703), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [147477] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4719), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [147535] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4743), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [147593] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5173), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5175), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [147651] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4763), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [147709] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4767), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [147767] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4731), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [147825] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4727), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [147883] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5193), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5195), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [147941] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5197), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5199), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [147999] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4979), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4981), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [148057] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [148115] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5213), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5215), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [148173] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [148231] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [148289] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5145), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5147), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [148347] = 5,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 8,
      anon_sym_let,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 21,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_u27e6,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_RBRACK,
  [148409] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4747), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [148467] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [148525] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4797), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [148583] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [148641] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [148699] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [148757] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [148815] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [148873] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4845), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [148931] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4841), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [148989] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4833), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [149047] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [149105] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4817), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [149163] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [149221] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [149279] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4681), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [149337] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4821), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [149395] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4813), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [149453] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4703), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [149511] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4719), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [149569] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4727), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [149627] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5161), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5163), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [149685] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4731), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [149743] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [149801] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [149859] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5157), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5159), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [149917] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [149975] = 5,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 8,
      anon_sym_let,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 21,
      sym__phantom_arrow,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_u27e6,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [150037] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4763), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [150095] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [150153] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [150211] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5145), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5147), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [150269] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4743), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [150327] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [150385] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4767), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [150443] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [150501] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [150559] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5153), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5155), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [150617] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4646), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [150675] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4781), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [150733] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [150791] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [150849] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4817), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [150907] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [150965] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [151023] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5349), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5351), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [151081] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5133), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5135), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [151139] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5129), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5131), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [151197] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5209), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5211), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [151255] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5409), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5411), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [151313] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [151371] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [151429] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5007), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5009), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [151487] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5011), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5013), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [151545] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5015), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5017), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [151603] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5019), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5021), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [151661] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [151719] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5245), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5247), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [151777] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5043), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5045), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [151835] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5051), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5053), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [151893] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5337), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5339), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [151951] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5055), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5057), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [152009] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5081), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5083), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [152067] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5085), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5087), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [152125] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5089), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5091), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [152183] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5093), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5095), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [152241] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5097), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5099), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [152299] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5101), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5103), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [152357] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5137), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5139), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [152415] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5137), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5139), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [152473] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5201), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5203), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [152531] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5109), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5111), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [152589] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4731), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [152647] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5117), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5119), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [152705] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5105), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5107), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [152763] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [152821] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5125), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5127), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [152879] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5039), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5041), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [152937] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5035), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5037), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [152995] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5177), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5179), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [153053] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [153111] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [153169] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4943), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4945), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [153233] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5181), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5183), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [153291] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5205), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5207), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [153349] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5217), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5219), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [153407] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5231), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [153465] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5231), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [153523] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5231), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [153581] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5231), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [153639] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5241), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5243), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [153697] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5241), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5243), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [153755] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5249), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5251), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [153813] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5265), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5267), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [153871] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5269), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5271), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [153929] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5269), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5271), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [153987] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5285), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5287), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [154045] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5301), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5303), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [154103] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5305), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5307), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [154161] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5311), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [154219] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5311), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [154277] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5313), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5315), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [154335] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5313), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5315), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [154393] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5305), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5307), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [154451] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5311), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [154509] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5311), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [154567] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5325), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5327), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [154625] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [154683] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [154741] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5225), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5227), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [154799] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4727), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [154857] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5325), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5327), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [154915] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5329), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5331), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [154973] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5333), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5335), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [155031] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5341), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5343), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [155089] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5357), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5359), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [155147] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5361), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5363), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [155205] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5361), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5363), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [155263] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5141), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5143), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [155321] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5369), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5371), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [155379] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5373), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5375), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [155437] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5377), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5379), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [155495] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5381), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5383), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [155553] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5385), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5387), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [155611] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5385), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5387), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [155669] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5377), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5379), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [155727] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5393), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5395), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [155785] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5397), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5399), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [155843] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5233), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5235), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [155901] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5237), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5239), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [155959] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5401), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5403), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [156017] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5237), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5239), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [156075] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5417), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5419), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [156133] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5405), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5407), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [156191] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5365), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5367), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [156249] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5353), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5355), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [156307] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5345), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5347), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [156365] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5317), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5319), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [156423] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5297), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5299), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [156481] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5293), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5295), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [156539] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5289), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5291), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [156597] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5273), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5275), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [156655] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5245), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5247), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [156713] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5273), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5275), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [156771] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5031), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5033), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [156829] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [156887] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [156945] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5027), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5029), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [157003] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [157061] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [157119] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [157177] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [157235] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [157293] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5023), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5025), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [157351] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4999), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5001), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [157409] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5003), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5005), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [157467] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4999), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5001), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [157525] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4995), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4997), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [157583] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [157641] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [157699] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [157757] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [157815] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [157873] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5413), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5415), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [157931] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4735), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [157989] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5113), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5115), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [158047] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5389), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5391), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [158105] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5129), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5131), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [158163] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5237), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5239), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [158221] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5409), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5411), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [158279] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5237), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5239), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [158337] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5233), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5235), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [158395] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5225), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5227), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [158453] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5205), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5207), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [158511] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5321), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5323), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [158569] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4923), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4925), 32,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [158633] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4735), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [158691] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5181), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5183), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [158749] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [158807] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [158865] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4983), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4985), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [158923] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5277), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5279), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [158981] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5177), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5179), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [159039] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5125), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5127), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [159097] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5117), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5119), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [159155] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [159213] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [159271] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4735), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [159329] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [159387] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5109), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5111), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [159445] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5101), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5103), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [159503] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5097), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5099), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [159561] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5093), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5095), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [159619] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5257), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5259), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [159677] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5089), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5091), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [159735] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5085), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5087), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [159793] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5253), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5255), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [159851] = 5,
    STATE(5609), 1,
      sym_alternatives,
    ACTIONS(5520), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4955), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4957), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [159913] = 5,
    STATE(5610), 1,
      sym__nalts,
    ACTIONS(5522), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4965), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4967), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [159975] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5081), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5083), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [160033] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5055), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5057), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [160091] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5201), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5203), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [160149] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [160207] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5047), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5049), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [160265] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5051), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5053), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [160323] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5043), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5045), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [160381] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4646), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [160439] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5019), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5021), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [160497] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5217), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5219), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [160555] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [160613] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [160671] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5015), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5017), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [160729] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5011), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5013), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [160787] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5007), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5009), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [160845] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5409), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5411), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [160903] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5209), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5211), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [160961] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [161019] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5133), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5135), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [161077] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [161135] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [161193] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5153), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5155), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [161251] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5157), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5159), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [161309] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5161), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5163), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [161367] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5241), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5243), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [161425] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5241), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5243), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [161483] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [161541] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5249), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5251), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [161599] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5265), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5267), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [161657] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [161715] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5269), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5271), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [161773] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5269), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5271), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [161831] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [161889] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [161947] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5285), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5287), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [162005] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5301), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5303), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [162063] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5213), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5215), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [162121] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4979), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4981), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [162179] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5197), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5199), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [162237] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [162295] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5193), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5195), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [162353] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5173), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5175), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [162411] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5169), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5171), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [162469] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [162527] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5305), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5307), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [162585] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [162643] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [162701] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5165), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5167), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [162759] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [162817] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [162875] = 5,
    STATE(5662), 1,
      sym_alternatives,
    ACTIONS(5520), 2,
      sym__cmd_layout_start_case,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4975), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4977), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [162937] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5313), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5315), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [162995] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5149), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5151), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [163053] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5145), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5147), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [163111] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5281), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5283), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [163169] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5121), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5123), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [163227] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5077), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5079), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [163285] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5063), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5065), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [163343] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5313), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5315), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [163401] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5305), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5307), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [163459] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5059), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5061), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [163517] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [163575] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [163633] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5325), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5327), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [163691] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [163749] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [163807] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [163865] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5325), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5327), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [163923] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [163981] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [164039] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [164097] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5329), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5331), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [164155] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [164213] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5333), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5335), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [164271] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [164329] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [164387] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [164445] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4987), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4989), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [164503] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5341), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5343), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [164561] = 5,
    ACTIONS(5524), 1,
      anon_sym_SEMI,
    STATE(4650), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5499), 22,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_type,
      anon_sym_instance,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_pattern,
      anon_sym_import,
      anon_sym_newtype,
      anon_sym_deriving,
      anon_sym_data,
      anon_sym_default,
      anon_sym_class,
      anon_sym_infixr,
      anon_sym_infixl,
      anon_sym_infix,
      anon_sym_foreign,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5504), 22,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [164623] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4747), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [164681] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [164739] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4797), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [164797] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [164855] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4681), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [164913] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5357), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5359), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [164971] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [165029] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(337), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(339), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [165087] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5361), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5363), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [165145] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5185), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5187), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [165203] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [165261] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [165319] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [165377] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5361), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5363), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [165435] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5189), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5191), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [165493] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5141), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5143), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [165551] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [165609] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5221), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5223), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [165667] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4845), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [165725] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4646), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [165783] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5349), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5351), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [165841] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4841), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [165899] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4833), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [165957] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [166015] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5369), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5371), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [166073] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5373), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5375), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [166131] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5289), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5291), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [166189] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5293), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5295), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [166247] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4719), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [166305] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5377), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5379), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [166363] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5381), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5383), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [166421] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5385), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5387), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [166479] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5047), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5049), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [166537] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5385), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5387), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [166595] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5377), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5379), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [166653] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5393), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5395), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [166711] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5397), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5399), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [166769] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5401), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5403), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [166827] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5297), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5299), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [166885] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [166943] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5317), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5319), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [167001] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4703), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [167059] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [167117] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [167175] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [167233] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5345), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5347), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [167291] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5337), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5339), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [167349] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4821), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [167407] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5353), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5355), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [167465] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5365), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5367), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [167523] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5417), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5419), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [167581] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5405), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5407), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [167639] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5365), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5367), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [167697] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5353), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5355), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [167755] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5137), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5139), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [167813] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5137), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5139), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [167871] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [167929] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5105), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5107), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [167987] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5039), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5041), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [168045] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5035), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5037), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [168103] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5345), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5347), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [168161] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [168219] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5317), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5319), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [168277] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5297), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5299), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [168335] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5293), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5295), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [168393] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [168451] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5289), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5291), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [168509] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5273), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5275), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [168567] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5245), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5247), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [168625] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5237), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5239), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [168683] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5237), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5239), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [168741] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5233), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5235), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [168799] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5225), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5227), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [168857] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5405), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5407), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [168915] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5417), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5419), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [168973] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5031), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5033), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [169031] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5205), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5207), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [169089] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5401), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5403), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [169147] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5181), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5183), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [169205] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5177), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5179), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [169263] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5125), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5127), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [169321] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5117), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5119), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [169379] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5109), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5111), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [169437] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5101), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5103), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [169495] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5097), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5099), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [169553] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5027), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5029), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [169611] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5023), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5025), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [169669] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4999), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5001), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [169727] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5003), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5005), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [169785] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4999), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5001), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [169843] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4995), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4997), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [169901] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5093), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5095), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [169959] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5089), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5091), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [170017] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5393), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5395), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [170075] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5085), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5087), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [170133] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5081), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5083), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [170191] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5377), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5379), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [170249] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5221), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5223), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [170307] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5385), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5387), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [170365] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5381), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5383), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [170423] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5377), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5379), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [170481] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5373), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5375), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [170539] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5055), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5057), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [170597] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5051), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5053), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [170655] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5043), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5045), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [170713] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5019), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5021), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [170771] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5369), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5371), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [170829] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4993), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [170887] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4993), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [170945] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4993), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [171003] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5141), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5143), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [171061] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5015), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5017), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [171119] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5361), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5363), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [171177] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5011), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5013), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [171235] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5361), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5363), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [171293] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5007), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5009), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [171351] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5357), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5359), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [171409] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5209), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5211), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [171467] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5129), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5131), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [171525] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5413), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5415), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [171583] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5113), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5115), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [171641] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5389), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5391), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [171699] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5133), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5135), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [171757] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [171815] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5341), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5343), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [171873] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5153), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5155), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [171931] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5157), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5159), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [171989] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5333), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5335), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [172047] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5161), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5163), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [172105] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5329), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5331), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [172163] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5213), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5215), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [172221] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4979), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4981), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [172279] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5325), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5327), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [172337] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5325), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5327), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [172395] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4646), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [172453] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5253), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5255), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [172511] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5257), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5259), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [172569] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [172627] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [172685] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [172743] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5277), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5279), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [172801] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4983), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4985), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [172859] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5321), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5323), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [172917] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5337), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5339), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [172975] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5389), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5391), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [173033] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5113), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5115), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [173091] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5413), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5415), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [173149] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5397), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5399), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [173207] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5321), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5323), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [173265] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [173323] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4983), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4985), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [173381] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [173439] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5277), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5279), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [173497] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5263), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [173555] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [173613] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5263), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [173671] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4995), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4997), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [173729] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5263), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [173787] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [173845] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5257), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5259), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [173903] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5253), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(5255), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [173961] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
      anon_sym_where,
    ACTIONS(4646), 35,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [174019] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4999), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5001), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [174077] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5003), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5005), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [174135] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4999), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5001), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [174193] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5023), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5025), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [174251] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5027), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5029), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [174309] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5031), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5033), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [174367] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5035), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5037), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [174425] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5039), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5041), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [174483] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5105), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5107), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [174541] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5137), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5139), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [174599] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5137), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5139), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [174657] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [174715] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5217), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5219), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [174773] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5349), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5351), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [174831] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4646), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [174889] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [174947] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [175005] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [175063] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [175121] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5189), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5191), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [175179] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5185), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5187), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [175237] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(337), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(339), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [175295] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5241), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5243), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [175353] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5241), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5243), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [175411] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5305), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5307), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [175469] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5249), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5251), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [175527] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4987), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4989), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [175585] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4817), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [175643] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4813), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [175701] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5313), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5315), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [175759] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5059), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5061), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [175817] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5265), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5267), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [175875] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5269), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5271), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [175933] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5269), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5271), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [175991] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5063), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5065), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [176049] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5077), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5079), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [176107] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5285), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5287), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [176165] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5121), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5123), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [176223] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5281), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5283), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [176281] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5149), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5151), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [176339] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5165), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5167), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [176397] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5301), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5303), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [176455] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 34,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [176513] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5169), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5171), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [176571] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5173), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5175), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [176629] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5193), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5195), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [176687] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5305), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5307), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [176745] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5313), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5315), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [176803] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [176861] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5197), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5199), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [176919] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 12,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [176977] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4731), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [177034] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4735), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [177091] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5217), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5219), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [177148] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [177205] = 5,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 7,
      anon_sym_let,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 21,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_u27e6,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [177266] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5361), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5363), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [177323] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [177380] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [177437] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [177494] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [177551] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5241), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5243), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [177608] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5241), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5243), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [177665] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5249), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5251), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [177722] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4747), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [177779] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4817), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [177836] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [177893] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4797), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [177950] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [178007] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [178064] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4727), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [178121] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [178178] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [178235] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [178292] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4845), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [178349] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4719), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [178406] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4703), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [178463] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [178520] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4833), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [178577] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [178634] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5265), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5267), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [178691] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5269), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5271), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [178748] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5269), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5271), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [178805] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5285), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5287), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [178862] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5301), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5303), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [178919] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5305), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5307), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [178976] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4837), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [179033] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [179090] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [179147] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [179204] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4681), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [179261] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [179318] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5313), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5315), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [179375] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5313), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5315), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [179432] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4821), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [179489] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5305), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5307), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [179546] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [179603] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [179660] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5325), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5327), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [179717] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5325), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5327), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [179774] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5329), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5331), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [179831] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5333), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5335), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [179888] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5341), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5343), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [179945] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5357), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5359), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [180002] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4793), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [180059] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5361), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5363), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [180116] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5141), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5143), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [180173] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5369), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5371), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [180230] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5373), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5375), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [180287] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5377), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5379), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [180344] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5381), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5383), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [180401] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5385), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5387), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [180458] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5385), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5387), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [180515] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5377), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5379), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [180572] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5393), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5395), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [180629] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5397), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5399), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [180686] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5401), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5403), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [180743] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4763), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [180800] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4703), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [180857] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4719), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [180914] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4743), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [180971] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5417), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5419), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [181028] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5405), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5407), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [181085] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5365), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5367), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [181142] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5353), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5355), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [181199] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5345), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5347), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [181256] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5317), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5319), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [181313] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5297), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5299), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [181370] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4763), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [181427] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4743), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [181484] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5293), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5295), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [181541] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4727), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [181598] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4767), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [181655] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4731), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [181712] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5289), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5291), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [181769] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5273), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5275), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [181826] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5245), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5247), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [181883] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5237), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5239), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [181940] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5237), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5239), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [181997] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4781), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [182054] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5233), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5235), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [182111] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5225), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5227), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [182168] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5205), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5207), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [182225] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5181), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5183), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [182282] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5177), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5179), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [182339] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5125), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5127), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [182396] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5117), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5119), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [182453] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4767), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [182510] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4781), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [182567] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [182624] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4813), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [182681] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5109), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5111), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [182738] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5101), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5103), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [182795] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [182852] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [182909] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [182966] = 5,
    ACTIONS(4745), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 26,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [183027] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5097), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5099), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [183084] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5093), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5095), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [183141] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5089), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5091), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [183198] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5085), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5087), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [183255] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5081), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5083), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [183312] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [183369] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5055), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5057), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [183426] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5051), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5053), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [183483] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [183540] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [183597] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [183654] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [183711] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5043), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5045), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [183768] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5019), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5021), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [183825] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5015), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5017), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [183882] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5011), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5013), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [183939] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5007), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5009), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [183996] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5409), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5411), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [184053] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5165), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5167), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [184110] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5209), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5211), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [184167] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5129), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5131), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [184224] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5133), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5135), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [184281] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [184338] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5153), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5155), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [184395] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [184452] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5157), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5159), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [184509] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5161), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5163), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [184566] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5213), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5215), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [184623] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4979), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4981), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [184680] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5197), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5199), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [184737] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5193), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5195), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [184794] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5173), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5175), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [184851] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5169), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5171), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [184908] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4987), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4989), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [184965] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5149), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5151), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [185022] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5281), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5283), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [185079] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5121), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5123), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [185136] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5077), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5079), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [185193] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5063), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5065), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [185250] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5059), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5061), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [185307] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [185364] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4630), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [185427] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4626), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [185490] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(337), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(339), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [185547] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [185604] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4821), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [185661] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5185), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5187), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [185718] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5189), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5191), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [185775] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5221), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5223), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [185832] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [185889] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4646), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [185946] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5349), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5351), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [186003] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5137), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5139), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [186060] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4681), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [186117] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [186174] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [186231] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5137), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5139), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [186288] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5105), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5107), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [186345] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5039), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5041), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [186402] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5035), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5037), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [186459] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5031), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5033), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [186516] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5027), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5029), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [186573] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5047), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5049), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [186630] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [186687] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4833), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [186744] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4841), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [186801] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4845), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [186858] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5023), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5025), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [186915] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [186972] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [187029] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4999), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5001), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [187086] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [187143] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [187200] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5003), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5005), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [187257] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4797), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [187314] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4999), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5001), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [187371] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [187428] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [187485] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4995), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4997), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [187542] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4747), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [187599] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [187656] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [187713] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [187770] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [187827] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5413), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5415), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [187884] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5113), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5115), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [187941] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5389), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5391), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [187998] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [188055] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [188112] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5337), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5339), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [188169] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5321), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5323), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [188226] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4983), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4985), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [188283] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5277), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5279), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [188340] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [188397] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [188454] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [188511] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5257), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5259), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [188568] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5253), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5255), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [188625] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5201), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5203), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [188682] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4646), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [188739] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [188796] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [188853] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [188910] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [188967] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4715), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [189024] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4695), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [189081] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4711), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [189138] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4707), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [189195] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4813), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [189252] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4723), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [189309] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4817), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [189366] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4685), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [189423] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4849), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [189480] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [189537] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [189594] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4735), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [189651] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5145), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5147), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_left_section_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [189708] = 18,
    ACTIONS(4650), 1,
      anon_sym_COMMA,
    ACTIONS(4658), 1,
      anon_sym_EQ,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(5421), 1,
      anon_sym_POUND,
    STATE(1444), 1,
      sym__colon2,
    STATE(8422), 1,
      aux_sym__bind_matches_repeat1,
    STATE(8990), 1,
      sym__bind_match,
    STATE(9050), 1,
      sym__simple_bind_match,
    STATE(10251), 1,
      sym__bind_matches,
    STATE(10252), 1,
      aux_sym__var_binding_list_repeat1,
    STATE(12338), 1,
      sym__bar,
    STATE(12352), 1,
      sym__guards,
    ACTIONS(4669), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(4655), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5423), 10,
      sym__cond_prefix_dot,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
    ACTIONS(4676), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [189795] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4809), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [189852] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4861), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [189909] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4857), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [189966] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4853), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [190023] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4829), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [190080] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5073), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5075), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [190143] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4825), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [190200] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4759), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [190257] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 11,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 34,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [190314] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4785), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [190371] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4775), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [190428] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4699), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [190485] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4739), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [190542] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4755), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [190599] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4751), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [190656] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4789), 39,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [190713] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [190769] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5105), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5107), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [190825] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5253), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5255), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [190881] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5177), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5179), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [190937] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5181), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5183), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [190993] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5205), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5207), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [191049] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5257), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5259), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [191105] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5369), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5371), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [191161] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5141), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5143), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [191217] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5361), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5363), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [191273] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5361), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5363), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [191329] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5269), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5271), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [191385] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5269), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5271), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [191441] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5161), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5163), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [191497] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5217), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5219), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [191553] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [191609] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [191665] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [191721] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5277), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5279), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [191777] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4983), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4985), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [191833] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5321), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5323), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [191889] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5337), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5339), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [191945] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5389), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5391), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [192001] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5209), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5211), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [192057] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4630), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [192119] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5113), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5115), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [192175] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5413), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5415), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [192231] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [192287] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [192343] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [192399] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4995), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4997), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [192455] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [192517] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4999), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5001), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [192573] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5003), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5005), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [192629] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4999), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5001), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [192685] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5023), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5025), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [192741] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5027), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5029), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [192797] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5031), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5033), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [192853] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5035), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5037), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [192909] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5039), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5041), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [192965] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5105), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5107), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [193021] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5137), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5139), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [193077] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5137), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5139), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [193133] = 35,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(1379), 1,
      anon_sym_DASH,
    ACTIONS(5527), 1,
      sym_variable,
    ACTIONS(5529), 1,
      anon_sym__,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(5535), 1,
      sym_name,
    ACTIONS(5537), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5539), 1,
      aux_sym__paren_close_token1,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    STATE(5147), 1,
      sym__paren_open,
    STATE(7868), 1,
      sym_type_param,
    STATE(8535), 1,
      sym__type_head_params,
    STATE(8677), 1,
      sym__type_param_invisible,
    STATE(8807), 1,
      sym__prefix_at,
    STATE(8975), 1,
      sym__plist,
    STATE(8978), 1,
      sym__type_head_parens,
    STATE(8979), 1,
      sym__type_head_name,
    STATE(9053), 1,
      sym__paren_close,
    STATE(11603), 1,
      sym_constructor_operator,
    STATE(11806), 1,
      sym__bracket_open,
    STATE(11950), 1,
      sym__arrow,
    STATE(11968), 1,
      sym__type_head_infix,
    STATE(12001), 1,
      sym__ktype_param,
    STATE(12028), 1,
      sym__type_param_annotated,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(1381), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8679), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    STATE(11840), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8988), 6,
      sym_unit,
      sym__tycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__consym_prefix,
      sym__pconsym,
  [193253] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4646), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [193309] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [193365] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [193421] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [193477] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [193533] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5241), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5243), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [193589] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5241), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5243), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [193645] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5249), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5251), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [193701] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5265), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5267), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [193757] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5285), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5287), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [193813] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5301), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5303), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [193869] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5305), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5307), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [193925] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [193981] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [194037] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5281), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5283), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [194093] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5313), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5315), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [194149] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5313), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5315), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [194205] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5305), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5307), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [194261] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5117), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5119), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [194317] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [194373] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [194429] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5221), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5223), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [194485] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5145), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5147), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [194541] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5325), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5327), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [194597] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5325), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5327), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [194653] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5329), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5331), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [194709] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5189), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5191), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [194765] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5185), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5187), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [194821] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5333), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5335), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [194877] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(337), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(339), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [194933] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5217), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5219), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [194989] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [195045] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5357), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5359), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [195101] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4987), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4989), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [195157] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5373), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5375), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [195213] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [195269] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [195325] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [195381] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5241), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5243), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [195437] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5241), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5243), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [195493] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5249), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5251), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [195549] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5265), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5267), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [195605] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5377), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5379), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [195661] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5381), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5383), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [195717] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5285), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5287), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [195773] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5385), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5387), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [195829] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5385), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5387), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [195885] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5377), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5379), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [195941] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5301), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5303), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [195997] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5305), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5307), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [196053] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [196109] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [196165] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5313), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5315), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [196221] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5313), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5315), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [196277] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5305), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5307), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [196333] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [196389] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [196445] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5325), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5327), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [196501] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5393), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5395), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [196557] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5325), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5327), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [196613] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5059), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5061), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [196669] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5329), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5331), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [196725] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5333), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5335), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [196781] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5341), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5343), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [196837] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5357), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5359), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [196893] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5063), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5065), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [196949] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5077), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5079), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [197005] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5397), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5399), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [197061] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5281), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5283), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [197117] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5373), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5375), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [197173] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5377), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5379), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [197229] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5381), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5383), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [197285] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5385), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5387), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [197341] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5385), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5387), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [197397] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5377), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5379), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [197453] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5393), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5395), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [197509] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5397), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5399), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [197565] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5401), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5403), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [197621] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5145), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5147), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [197677] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5417), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5419), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [197733] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5405), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5407), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [197789] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5365), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5367), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [197845] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5353), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5355), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [197901] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5345), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5347), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [197957] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5317), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5319), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [198013] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5297), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5299), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [198069] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5149), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5151), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [198125] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5293), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5295), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [198181] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5289), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5291), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [198237] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5273), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5275), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [198293] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5245), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5247), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [198349] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5237), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5239), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [198405] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5237), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5239), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [198461] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5121), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5123), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [198517] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5233), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5235), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [198573] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5225), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5227), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [198629] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5401), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5403), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [198685] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5417), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5419), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [198741] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5405), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5407), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [198797] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5125), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5127), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [198853] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5365), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5367), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [198909] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5169), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5171), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [198965] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5173), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5175), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [199021] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5193), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5195), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [199077] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5197), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5199), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [199133] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4979), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4981), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [199189] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5109), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5111), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [199245] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5353), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5355), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [199301] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5101), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5103), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [199357] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5097), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5099), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [199413] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5093), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5095), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [199469] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5089), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5091), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [199525] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5085), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5087), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [199581] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5081), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5083), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [199637] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5055), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5057), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [199693] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5213), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5215), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [199749] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5051), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5053), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [199805] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5165), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5167), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [199861] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5043), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5045), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [199917] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5019), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5021), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [199973] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5015), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5017), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [200029] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5011), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5013), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [200085] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5007), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5009), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [200141] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5345), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5347), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [200197] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5317), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5319), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [200253] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5297), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5299), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [200309] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5409), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5411), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [200365] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5161), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5163), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [200421] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5157), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5159), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [200477] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5129), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5131), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [200533] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5153), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5155), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [200589] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5133), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5135), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [200645] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5153), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5155), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [200701] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5157), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5159), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [200757] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5161), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5163), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [200813] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5133), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5135), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [200869] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5129), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5131), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [200925] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5293), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5295), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [200981] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5289), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5291), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [201037] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5213), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5215), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [201093] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4979), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4981), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [201149] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5197), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5199), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [201205] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5193), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5195), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [201261] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5173), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5175), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [201317] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5169), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5171), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [201373] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5209), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5211), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [201429] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5007), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5009), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [201485] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5011), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5013), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [201541] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5165), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5167), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [201597] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5015), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5017), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [201653] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5149), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5151), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [201709] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5019), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5021), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [201765] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5121), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5123), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [201821] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5077), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5079), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [201877] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5063), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5065), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [201933] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5059), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5061), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [201989] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5043), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5045), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [202045] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5051), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5053), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [202101] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5055), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5057), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [202157] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5081), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5083), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [202213] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5085), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5087), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [202269] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5089), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5091), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [202325] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5093), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5095), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [202381] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5097), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5099), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [202437] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5101), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5103), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [202493] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5109), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5111), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [202549] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5409), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5411), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [202605] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5201), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5203), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [202661] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4987), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4989), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [202717] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5273), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5275), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [202773] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5245), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5247), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [202829] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5117), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5119), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [202885] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5125), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5127), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [202941] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5341), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5343), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [202997] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5181), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5183), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [203053] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5205), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5207), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [203109] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5225), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5227), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [203165] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5233), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5235), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [203221] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5237), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5239), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [203277] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5237), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5239), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [203333] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5245), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5247), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [203389] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(337), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(339), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [203445] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5185), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5187), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [203501] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5273), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5275), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [203557] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5289), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5291), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [203613] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5189), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5191), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [203669] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5221), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5223), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [203725] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4646), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [203781] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5349), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5351), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [203837] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5293), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5295), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [203893] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5297), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5299), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [203949] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5177), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5179), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [204005] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5317), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5319), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [204061] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5353), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5355), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [204117] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5365), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5367), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [204173] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5405), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5407), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [204229] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5417), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5419), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [204285] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5401), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5403), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [204341] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5397), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5399), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [204397] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5393), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5395), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [204453] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5377), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5379), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [204509] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5385), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5387), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [204565] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5385), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5387), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [204621] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5381), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5383), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [204677] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5377), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5379), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [204733] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5373), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5375), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [204789] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5345), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5347), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [204845] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5369), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5371), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [204901] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5281), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5283), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [204957] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [205019] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5141), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5143), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [205075] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5137), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5139), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [205131] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5137), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5139), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [205187] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5361), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5363), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [205243] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5105), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5107), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [205299] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5039), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5041), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [205355] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5035), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5037), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [205411] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5031), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5033), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [205467] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5027), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5029), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [205523] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5023), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5025), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [205579] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4999), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5001), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [205635] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5003), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5005), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [205691] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4999), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5001), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [205747] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4995), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4997), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [205803] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [205859] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [205915] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [205971] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5047), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5049), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [206027] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5413), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5415), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [206083] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5113), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5115), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [206139] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5389), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5391), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [206195] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5337), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5339), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [206251] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5321), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5323), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [206307] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4983), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4985), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [206363] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5277), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5279), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [206419] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [206475] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5361), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5363), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [206531] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [206587] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5257), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5259), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [206643] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5253), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5255), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [206699] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4646), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [206755] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5357), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5359), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [206811] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5341), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5343), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [206867] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5333), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5335), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [206923] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5329), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5331), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [206979] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5325), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5327), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [207035] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5325), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5327), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [207091] = 35,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(1379), 1,
      anon_sym_DASH,
    ACTIONS(5527), 1,
      sym_variable,
    ACTIONS(5529), 1,
      anon_sym__,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(5535), 1,
      sym_name,
    ACTIONS(5537), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(5543), 1,
      aux_sym__paren_close_token1,
    STATE(5147), 1,
      sym__paren_open,
    STATE(7868), 1,
      sym_type_param,
    STATE(8541), 1,
      sym__type_head_params,
    STATE(8677), 1,
      sym__type_param_invisible,
    STATE(8750), 1,
      sym__paren_close,
    STATE(8807), 1,
      sym__prefix_at,
    STATE(8975), 1,
      sym__plist,
    STATE(8978), 1,
      sym__type_head_parens,
    STATE(8979), 1,
      sym__type_head_name,
    STATE(11373), 1,
      sym__type_head_infix,
    STATE(11622), 1,
      sym_constructor_operator,
    STATE(11806), 1,
      sym__bracket_open,
    STATE(12001), 1,
      sym__ktype_param,
    STATE(12028), 1,
      sym__type_param_annotated,
    STATE(12223), 1,
      sym__arrow,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(1381), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8679), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    STATE(11775), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8988), 6,
      sym_unit,
      sym__tycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__consym_prefix,
      sym__pconsym,
  [207211] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [207267] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5305), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5307), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [207323] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5313), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5315), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [207379] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5313), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5315), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [207435] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [207491] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [207547] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5305), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5307), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [207603] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5301), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5303), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [207659] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5285), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5287), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [207715] = 35,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(1379), 1,
      anon_sym_DASH,
    ACTIONS(5527), 1,
      sym_variable,
    ACTIONS(5529), 1,
      anon_sym__,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(5535), 1,
      sym_name,
    ACTIONS(5537), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(5545), 1,
      aux_sym__paren_close_token1,
    STATE(5147), 1,
      sym__paren_open,
    STATE(7868), 1,
      sym_type_param,
    STATE(8551), 1,
      sym__type_head_params,
    STATE(8583), 1,
      sym__paren_close,
    STATE(8677), 1,
      sym__type_param_invisible,
    STATE(8807), 1,
      sym__prefix_at,
    STATE(8975), 1,
      sym__plist,
    STATE(8978), 1,
      sym__type_head_parens,
    STATE(8979), 1,
      sym__type_head_name,
    STATE(11463), 1,
      sym__type_head_infix,
    STATE(11779), 1,
      sym_constructor_operator,
    STATE(11806), 1,
      sym__bracket_open,
    STATE(12001), 1,
      sym__ktype_param,
    STATE(12002), 1,
      sym__arrow,
    STATE(12028), 1,
      sym__type_param_annotated,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(1381), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8679), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    STATE(11403), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8988), 6,
      sym_unit,
      sym__tycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__consym_prefix,
      sym__pconsym,
  [207835] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5269), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5271), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [207891] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5237), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5239), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [207947] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5269), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5271), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [208003] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5265), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5267), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [208059] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [208115] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5241), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5243), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [208171] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5241), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5243), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [208227] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [208283] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [208339] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [208395] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [208451] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5217), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5219), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [208507] = 35,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(1379), 1,
      anon_sym_DASH,
    ACTIONS(5527), 1,
      sym_variable,
    ACTIONS(5529), 1,
      anon_sym__,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(5535), 1,
      sym_name,
    ACTIONS(5537), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(5547), 1,
      aux_sym__paren_close_token1,
    STATE(5147), 1,
      sym__paren_open,
    STATE(7868), 1,
      sym_type_param,
    STATE(8460), 1,
      sym__type_head_params,
    STATE(8677), 1,
      sym__type_param_invisible,
    STATE(8702), 1,
      sym__paren_close,
    STATE(8807), 1,
      sym__prefix_at,
    STATE(8975), 1,
      sym__plist,
    STATE(8978), 1,
      sym__type_head_parens,
    STATE(8979), 1,
      sym__type_head_name,
    STATE(11347), 1,
      sym__type_head_infix,
    STATE(11374), 1,
      sym__arrow,
    STATE(11709), 1,
      sym_constructor_operator,
    STATE(11806), 1,
      sym__bracket_open,
    STATE(12001), 1,
      sym__ktype_param,
    STATE(12028), 1,
      sym__type_param_annotated,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(1381), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8679), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    STATE(11388), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8988), 6,
      sym_unit,
      sym__tycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__consym_prefix,
      sym__pconsym,
  [208627] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5249), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5251), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [208683] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [208745] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5233), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5235), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [208801] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5225), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5227), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [208857] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5125), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5127), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [208913] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5117), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5119), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [208969] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5109), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5111), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [209025] = 35,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(1379), 1,
      anon_sym_DASH,
    ACTIONS(5527), 1,
      sym_variable,
    ACTIONS(5529), 1,
      anon_sym__,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(5535), 1,
      sym_name,
    ACTIONS(5537), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(5549), 1,
      aux_sym__paren_close_token1,
    STATE(5147), 1,
      sym__paren_open,
    STATE(7868), 1,
      sym_type_param,
    STATE(8384), 1,
      sym__paren_close,
    STATE(8497), 1,
      sym__type_head_params,
    STATE(8677), 1,
      sym__type_param_invisible,
    STATE(8807), 1,
      sym__prefix_at,
    STATE(8975), 1,
      sym__plist,
    STATE(8978), 1,
      sym__type_head_parens,
    STATE(8979), 1,
      sym__type_head_name,
    STATE(11366), 1,
      sym_constructor_operator,
    STATE(11462), 1,
      sym__arrow,
    STATE(11792), 1,
      sym__type_head_infix,
    STATE(11806), 1,
      sym__bracket_open,
    STATE(12001), 1,
      sym__ktype_param,
    STATE(12028), 1,
      sym__type_param_annotated,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(1381), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8679), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    STATE(12084), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8988), 6,
      sym_unit,
      sym__tycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__consym_prefix,
      sym__pconsym,
  [209145] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5101), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5103), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [209201] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5097), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5099), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [209257] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5093), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5095), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [209313] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5089), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5091), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [209369] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5085), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5087), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [209425] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5081), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5083), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [209481] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5055), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5057), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [209537] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5051), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5053), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [209593] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5043), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5045), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [209649] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5019), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5021), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [209705] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5015), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5017), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [209761] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5011), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5013), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [209817] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5007), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5009), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [209873] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5409), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5411), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [209929] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [209991] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5129), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5131), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [210047] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5133), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5135), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [210103] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5153), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5155), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [210159] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5237), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5239), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [210215] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [210277] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5349), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5351), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [210333] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4646), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [210389] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [210451] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5169), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5171), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [210507] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5213), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5215), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [210563] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4979), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4981), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [210619] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5197), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5199), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [210675] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5193), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5195), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [210731] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5173), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5175), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [210787] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5023), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5025), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [210843] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5201), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5203), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [210899] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5165), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5167), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [210955] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5149), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5151), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [211011] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5121), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5123), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [211067] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5077), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5079), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [211123] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5063), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5065), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [211179] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5059), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5061), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [211235] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5209), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5211), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [211291] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4987), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4989), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [211347] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(337), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(339), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [211403] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [211465] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5157), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5159), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [211521] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5189), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5191), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [211577] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5047), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5049), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [211633] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5221), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5223), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [211689] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5137), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5139), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [211745] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5137), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5139), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [211801] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5039), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5041), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [211857] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5035), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5037), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [211913] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5031), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5033), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [211969] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5027), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5029), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [212025] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4999), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5001), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [212081] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5003), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5005), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [212137] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4999), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5001), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [212193] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4995), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4997), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [212249] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [212305] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5185), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5187), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [212361] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [212417] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5413), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5415), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [212473] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5113), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5115), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [212529] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5389), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5391), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [212585] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5337), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5339), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [212641] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5321), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5323), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [212697] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5177), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5179), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [212753] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5181), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5183), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [212809] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5047), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5049), 33,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [212865] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5205), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5207), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [212921] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4983), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4985), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [212977] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5145), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5147), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [213033] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4943), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4945), 30,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [213095] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5277), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5279), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [213151] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [213207] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [213263] = 35,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(1379), 1,
      anon_sym_DASH,
    ACTIONS(5527), 1,
      sym_variable,
    ACTIONS(5529), 1,
      anon_sym__,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(5535), 1,
      sym_name,
    ACTIONS(5537), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(5551), 1,
      aux_sym__paren_close_token1,
    STATE(5147), 1,
      sym__paren_open,
    STATE(7868), 1,
      sym_type_param,
    STATE(8545), 1,
      sym__type_head_params,
    STATE(8677), 1,
      sym__type_param_invisible,
    STATE(8807), 1,
      sym__prefix_at,
    STATE(8889), 1,
      sym__paren_close,
    STATE(8975), 1,
      sym__plist,
    STATE(8978), 1,
      sym__type_head_parens,
    STATE(8979), 1,
      sym__type_head_name,
    STATE(11346), 1,
      sym__arrow,
    STATE(11491), 1,
      sym_constructor_operator,
    STATE(11610), 1,
      sym__type_head_infix,
    STATE(11806), 1,
      sym__bracket_open,
    STATE(12001), 1,
      sym__ktype_param,
    STATE(12028), 1,
      sym__type_param_annotated,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(1381), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8679), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    STATE(11667), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8988), 6,
      sym_unit,
      sym__tycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__consym_prefix,
      sym__pconsym,
  [213383] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [213439] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5257), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5259), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [213495] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5253), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5255), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [213551] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5201), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5203), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [213607] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4646), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [213663] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5369), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5371), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [213719] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5141), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5143), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [213775] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5361), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5363), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [213831] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5361), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5363), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [213887] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5269), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5271), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [213943] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5269), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5271), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [213999] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [214055] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [214117] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5349), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5351), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [214173] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4646), 33,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [214229] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5401), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5403), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [214284] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [214345] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5189), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5191), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [214400] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5221), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5223), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [214455] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(337), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(339), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [214510] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5349), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5351), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [214565] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4646), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [214620] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4999), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5001), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [214675] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5313), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5315), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [214730] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [214785] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5043), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5045), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [214840] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5237), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5239), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [214895] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5237), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5239), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [214950] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5233), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5235), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [215005] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5225), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5227), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [215060] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [215115] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5305), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5307), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [215170] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5301), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5303), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [215225] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5273), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5275), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [215280] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5137), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5139), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [215335] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5137), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5139), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [215390] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5047), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5049), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [215445] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5105), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5107), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [215500] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5039), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5041), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [215555] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5035), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5037), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [215610] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [215671] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5289), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5291), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [215726] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5031), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5033), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [215781] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5293), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5295), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [215836] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5027), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5029), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [215891] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5285), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5287), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [215946] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5023), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5025), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [216001] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5297), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5299), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [216056] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5317), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5319), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [216111] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [216172] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5145), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5147), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [216227] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [216288] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4987), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4989), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [216343] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5003), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5005), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [216398] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4999), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5001), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [216453] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5125), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5127), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [216508] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5117), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5119), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [216563] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [216624] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4995), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4997), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [216679] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5345), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5347), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [216734] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5353), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5355), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [216789] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [216844] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [216899] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4991), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4993), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [216954] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5413), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5415), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [217009] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5113), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5115), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [217064] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5019), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5021), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [217119] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5389), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5391), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [217174] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5209), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5211), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [217229] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5337), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5339), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [217284] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5321), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5323), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [217339] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4983), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4985), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [217394] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5109), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5111), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [217449] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [217510] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4630), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [217571] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5277), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5279), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [217626] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5265), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5267), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [217681] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [217736] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [217791] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5313), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5315), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [217846] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5101), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5103), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [217901] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5261), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5263), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [217956] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5257), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5259), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [218011] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5253), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5255), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [218066] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [218127] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4648), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4646), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [218182] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5097), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5099), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [218237] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5093), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5095), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [218292] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [218353] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [218414] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5417), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5419), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [218469] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [218530] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5269), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5271), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [218585] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [218646] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5015), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5017), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [218701] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5269), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5271), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [218756] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5361), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5363), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [218811] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [218872] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5361), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5363), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [218927] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5141), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5143), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [218982] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5369), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5371), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [219037] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [219098] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5205), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5207), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [219153] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5181), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5183), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [219208] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5177), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5179), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [219263] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5405), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5407), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [219318] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5185), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5187), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [219373] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5365), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5367), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [219428] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5059), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5061), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [219483] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5063), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5065), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [219538] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5397), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5399), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [219593] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5077), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5079), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [219648] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5121), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5123), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [219703] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5149), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5151), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [219758] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5165), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5167), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [219813] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5393), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5395), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [219868] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5249), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5251), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [219923] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4630), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [219984] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5241), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5243), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [220039] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5281), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5283), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [220094] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5377), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5379), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [220149] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [220210] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5169), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5171), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [220265] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5241), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5243), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [220320] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5173), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5175), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [220375] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [220436] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [220497] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5385), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5387), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [220552] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5193), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5195), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [220607] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5051), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5053), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [220662] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5305), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5307), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [220717] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [220778] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [220839] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [220900] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [220961] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5197), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5199), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [221016] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4979), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4981), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [221071] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [221132] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5213), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5215), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [221187] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5161), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5163), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [221242] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5011), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5013), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [221297] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5201), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5203), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [221352] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5381), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5383), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [221407] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5377), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5379), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [221462] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [221523] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5157), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5159), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [221578] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [221633] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5153), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5155), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [221688] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5373), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5375), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [221743] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5357), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5359), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [221798] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5385), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5387), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [221853] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5133), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5135), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [221908] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [221969] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [222024] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5055), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5057), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [222079] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5341), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5343), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [222134] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5333), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5335), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [222189] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5309), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5311), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [222244] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5329), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5331), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [222299] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5089), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5091), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [222354] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5325), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5327), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [222409] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5129), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5131), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [222464] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5085), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5087), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [222519] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5245), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5247), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [222574] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [222635] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4630), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [222696] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5325), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5327), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [222751] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5217), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5219), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [222806] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [222861] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [222916] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5081), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5083), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [222971] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5409), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5411), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [223026] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5229), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5231), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [223081] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5007), 10,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5009), 33,
      sym__cond_layout_end,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_PIPE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [223136] = 16,
    ACTIONS(3557), 1,
      anon_sym_EQ,
    ACTIONS(3559), 1,
      anon_sym_deriving,
    ACTIONS(3565), 1,
      anon_sym_where,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    STATE(1606), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(9025), 1,
      sym__data_rhs,
    STATE(9026), 1,
      aux_sym__data_repeat1,
    STATE(9555), 1,
      sym__gadt,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(3563), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(5553), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [223216] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [223276] = 16,
    ACTIONS(3557), 1,
      anon_sym_EQ,
    ACTIONS(3559), 1,
      anon_sym_deriving,
    ACTIONS(3565), 1,
      anon_sym_where,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    STATE(1606), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(9129), 1,
      aux_sym__data_repeat1,
    STATE(9130), 1,
      sym__data_rhs,
    STATE(9555), 1,
      sym__gadt,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(3563), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(5555), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [223356] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [223416] = 5,
    ACTIONS(5557), 1,
      anon_sym_SEMI,
    STATE(5679), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5499), 17,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_type,
      anon_sym_if,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_newtype,
      anon_sym_data,
      anon_sym_default,
      anon_sym_infixr,
      anon_sym_infixl,
      anon_sym_infix,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5504), 23,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [223474] = 16,
    ACTIONS(3557), 1,
      anon_sym_EQ,
    ACTIONS(3559), 1,
      anon_sym_deriving,
    ACTIONS(3565), 1,
      anon_sym_where,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    STATE(1606), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(9116), 1,
      aux_sym__data_repeat1,
    STATE(9136), 1,
      sym__data_rhs,
    STATE(9555), 1,
      sym__gadt,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(3563), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(5560), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [223554] = 16,
    ACTIONS(3557), 1,
      anon_sym_EQ,
    ACTIONS(3559), 1,
      anon_sym_deriving,
    ACTIONS(3565), 1,
      anon_sym_where,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    STATE(1606), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(9005), 1,
      sym__data_rhs,
    STATE(9006), 1,
      aux_sym__data_repeat1,
    STATE(9555), 1,
      sym__gadt,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(3563), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(5562), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [223634] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [223694] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [223754] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [223814] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [223874] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [223934] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [223994] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [224054] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [224114] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [224174] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [224234] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [224294] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [224354] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [224414] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4630), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [224474] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4630), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [224534] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [224594] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5564), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5566), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [224647] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [224706] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5568), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5570), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [224759] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [224818] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [224877] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [224936] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [224995] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5572), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5574), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [225048] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [225107] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [225166] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5576), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5578), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [225219] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5580), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5582), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [225272] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5584), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5586), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [225325] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5588), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5590), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [225378] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5592), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5594), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [225431] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [225490] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5596), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5598), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [225543] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5600), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5602), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [225596] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4630), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [225655] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5604), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5606), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [225708] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5608), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5610), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [225761] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5612), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5614), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [225814] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5616), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5618), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [225867] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4739), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [225920] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4857), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [225973] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [226032] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [226091] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4861), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [226144] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4685), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [226197] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4723), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [226250] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4793), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [226303] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [226362] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5620), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5622), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [226415] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [226474] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [226533] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [226592] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4699), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [226645] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4630), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [226704] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4626), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [226763] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4695), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [226816] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [226875] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [226934] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [226993] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4707), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [227046] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5624), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5626), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [227099] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4829), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [227152] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4711), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [227205] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4634), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [227264] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4715), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [227317] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [227376] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [227435] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [227494] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4849), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [227547] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5628), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5630), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [227600] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [227659] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5628), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5630), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [227712] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [227771] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5469), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5471), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [227824] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [227883] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [227942] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [228001] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4614), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [228060] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [228119] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [228178] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [228237] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [228296] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [228355] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5047), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5049), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [228408] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4755), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [228461] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(3005), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(3007), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [228514] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5632), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5634), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [228567] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4751), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [228620] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5628), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5630), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [228673] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [228732] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5636), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5638), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [228785] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [228844] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4789), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [228897] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [228956] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5640), 12,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_type,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5642), 29,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_qual_dot,
      sym__cond_prefix_dot,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [229009] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5451), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5453), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [229062] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [229121] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [229180] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5421), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5423), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [229233] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5461), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5463), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [229286] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [229345] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [229404] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5644), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5646), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [229457] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5648), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5650), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [229510] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5451), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5453), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [229563] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [229622] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5652), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5654), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [229675] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4809), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [229728] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5652), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5654), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [229781] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5656), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5658), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [229834] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5660), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5662), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [229887] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5664), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5666), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [229940] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [229999] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4837), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [230052] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [230111] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [230170] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4775), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [230223] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4785), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [230276] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4759), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [230329] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [230388] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4825), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [230441] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [230500] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4630), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [230559] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4630), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [230618] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [230677] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4630), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [230736] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5652), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(5654), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [230789] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 6,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_PIPE2,
      sym_variable,
    ACTIONS(4853), 35,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [230842] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [230901] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4630), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [230960] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [231012] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [231064] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4699), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [231116] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4775), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [231168] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4759), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [231220] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [231278] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4755), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [231330] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4751), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [231382] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4825), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [231434] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4829), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [231486] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4853), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [231538] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4861), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [231590] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(5073), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5075), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [231648] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4849), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [231700] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4809), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [231752] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4789), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [231804] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [231862] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4793), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [231914] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4781), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [231966] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4767), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [232018] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4743), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [232070] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4763), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [232122] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4785), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [232174] = 5,
    ACTIONS(4674), 1,
      sym__cond_tight_at,
    STATE(2299), 1,
      sym__tight_at,
    ACTIONS(5421), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5423), 34,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [232230] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4837), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [232282] = 5,
    ACTIONS(4745), 2,
      anon_sym_POUND,
      anon_sym_where,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 21,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [232338] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4857), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [232390] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [232442] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4731), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [232494] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [232546] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4695), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [232598] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4727), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [232650] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4719), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [232702] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4739), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [232754] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [232812] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4703), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [232864] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4723), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [232916] = 5,
    ACTIONS(5668), 1,
      anon_sym_SEMI,
    STATE(5849), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5499), 17,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_type,
      anon_sym_if,
      anon_sym_rec,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      anon_sym_newtype,
      anon_sym_data,
      anon_sym_default,
      anon_sym_infixr,
      anon_sym_infixl,
      anon_sym_infix,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5504), 21,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [232972] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4685), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [233024] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4707), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [233076] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4711), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [233128] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4813), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [233180] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4821), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [233232] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [233290] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4735), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [233342] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [233400] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [233452] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [233504] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4845), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [233556] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4817), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [233608] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4841), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [233660] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [233718] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4833), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [233770] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4747), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [233822] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [233874] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [233932] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [233990] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [234042] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4715), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [234094] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4797), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [234146] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4681), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [234198] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4630), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [234256] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [234308] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 34,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [234360] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4695), 34,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [234411] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4731), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [234462] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [234519] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [234576] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4785), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [234627] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [234684] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [234741] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [234798] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4681), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [234849] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4837), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [234900] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [234951] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4775), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [235002] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4711), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [235053] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4759), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [235104] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4825), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [235155] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4707), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [235206] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4735), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [235257] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [235314] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [235365] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4809), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [235416] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4829), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [235467] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [235524] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [235581] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4853), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [235632] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4833), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [235683] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4789), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [235734] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4739), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [235785] = 5,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 5,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      anon_sym_POUND,
      anon_sym_where,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 17,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [235840] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4685), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [235891] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4857), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [235942] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4813), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [235993] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4685), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [236044] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4715), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [236095] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [236152] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4857), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [236203] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4853), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [236254] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4841), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [236305] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4793), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [236356] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4723), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [236407] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [236464] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4723), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [236515] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4845), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [236566] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4755), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [236617] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4751), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [236668] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4763), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [236719] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4829), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [236770] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4789), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [236821] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [236872] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4743), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [236923] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4739), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [236974] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4793), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [237025] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [237076] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [237127] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [237178] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4735), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [237229] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4695), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [237280] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4785), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [237331] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4767), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [237382] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(5073), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5075), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [237439] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4817), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [237490] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4695), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [237541] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4715), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [237592] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4797), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [237643] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [237694] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4781), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [237745] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4747), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [237796] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [237847] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4703), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [237898] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4797), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [237949] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [238000] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [238051] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [238102] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [238153] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4845), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [238204] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [238255] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4833), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [238306] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [238357] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [238408] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4849), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [238459] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4861), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [238510] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4685), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [238561] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4755), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [238612] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [238663] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4747), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [238714] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4630), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [238771] = 26,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(1379), 1,
      anon_sym_DASH,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(5671), 1,
      sym_name,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5675), 1,
      sym__cond_infix,
    STATE(2175), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8275), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11402), 1,
      sym_constructor_operator,
    STATE(11517), 1,
      sym__qualified_varsym,
    STATE(11564), 1,
      sym__qualified_consym,
    STATE(11679), 1,
      sym__qualified_arrow,
    STATE(11824), 1,
      sym__arrow,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(1381), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(11912), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [238868] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4699), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [238919] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [238970] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [239021] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4681), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [239072] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [239123] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [239174] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4809), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [239225] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4821), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [239276] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4731), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [239327] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4789), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [239378] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4775), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [239429] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4785), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [239480] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4759), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [239531] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4781), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [239582] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4813), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [239633] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4727), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [239684] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4849), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [239735] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4825), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [239786] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [239843] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4861), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [239894] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4817), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [239945] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4813), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [239996] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4767), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [240047] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [240098] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [240155] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [240206] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4747), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [240257] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4703), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [240308] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4719), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [240359] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4711), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [240410] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4707), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [240461] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [240512] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4727), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [240563] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4630), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [240620] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4731), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [240671] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4809), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [240722] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4743), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [240773] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4797), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [240824] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4763), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [240875] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4821), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [240926] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [240977] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4793), 34,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [241028] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [241079] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4715), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [241130] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [241181] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [241232] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4845), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [241283] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4841), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [241334] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4833), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [241385] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [241442] = 5,
    ACTIONS(4745), 4,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_POUND,
      anon_sym_where,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 18,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [241497] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4739), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [241548] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [241599] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [241656] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4829), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [241707] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4755), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [241758] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4751), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [241809] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [241860] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4723), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [241911] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4735), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [241962] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4849), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [242013] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [242064] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [242115] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4837), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [242166] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [242223] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4681), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [242274] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4781), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [242325] = 26,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(1379), 1,
      anon_sym_DASH,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(5671), 1,
      sym_name,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5677), 1,
      sym__cond_infix,
    STATE(2187), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8275), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11587), 1,
      sym__qualified_varsym,
    STATE(11604), 1,
      sym__qualified_consym,
    STATE(11611), 1,
      sym__arrow,
    STATE(11789), 1,
      sym__qualified_arrow,
    STATE(11808), 1,
      sym_constructor_operator,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(1381), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(11378), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [242422] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4821), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [242473] = 26,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(1379), 1,
      anon_sym_DASH,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(5671), 1,
      sym_name,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5679), 1,
      sym__cond_infix,
    STATE(2174), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8275), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11398), 1,
      sym__qualified_consym,
    STATE(11476), 1,
      sym_constructor_operator,
    STATE(11569), 1,
      sym__arrow,
    STATE(11594), 1,
      sym__qualified_varsym,
    STATE(11773), 1,
      sym__qualified_arrow,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(1381), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(12096), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [242570] = 5,
    ACTIONS(4745), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 20,
      sym__phantom_bar,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [242625] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4751), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [242676] = 26,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(1379), 1,
      anon_sym_DASH,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(5671), 1,
      sym_name,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5681), 1,
      sym__cond_infix,
    STATE(2188), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8275), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11396), 1,
      sym__arrow,
    STATE(11511), 1,
      sym__qualified_consym,
    STATE(11703), 1,
      sym__qualified_varsym,
    STATE(11947), 1,
      sym__qualified_arrow,
    STATE(11987), 1,
      sym_constructor_operator,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(1381), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(12187), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [242773] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4695), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [242824] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4699), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [242875] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4719), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [242926] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4853), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [242977] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4727), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [243028] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4793), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [243079] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4837), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [243130] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4719), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [243181] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4699), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [243232] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4703), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [243283] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4825), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [243334] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4767), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [243385] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4707), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [243436] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4775), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [243487] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4711), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [243538] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4857), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [243589] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4861), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [243640] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4763), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [243691] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4817), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [243742] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4759), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [243793] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4743), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [243844] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [243901] = 26,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(1379), 1,
      anon_sym_DASH,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(5671), 1,
      sym_name,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5683), 1,
      sym__cond_infix,
    STATE(2189), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8275), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11353), 1,
      sym__qualified_varsym,
    STATE(11710), 1,
      sym__qualified_consym,
    STATE(11731), 1,
      sym__arrow,
    STATE(11747), 1,
      sym__qualified_arrow,
    STATE(11978), 1,
      sym_constructor_operator,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(1381), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(11528), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [243998] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4775), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [244048] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4707), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [244098] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [244148] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [244204] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [244254] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [244304] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [244354] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [244404] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [244454] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4837), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [244504] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [244554] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4731), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [244604] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4767), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [244654] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [244704] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4727), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [244754] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4715), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [244804] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [244854] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4630), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [244910] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [244966] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4781), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [245016] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4853), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [245066] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4743), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [245116] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4719), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [245166] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4703), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [245216] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4630), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [245272] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4813), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [245322] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4763), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [245372] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [245422] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4699), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [245472] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4711), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [245522] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [245572] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4821), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [245622] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4681), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [245672] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [245722] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [245772] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [245828] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [245884] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4781), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [245934] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4735), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [245984] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [246040] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [246096] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4817), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [246146] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4797), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [246196] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [246246] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4829), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [246296] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [246346] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [246402] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4767), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [246452] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4809), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [246502] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [246552] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4743), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [246602] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [246652] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [246702] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4630), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [246758] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [246808] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [246864] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [246920] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4763), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [246970] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4833), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [247020] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [247070] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4845), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [247120] = 5,
    ACTIONS(4745), 1,
      anon_sym_POUND,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 20,
      sym__phantom_bar,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [247174] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [247224] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [247274] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [247324] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [247374] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4735), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [247424] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4739), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [247474] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4849), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [247524] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [247574] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [247624] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [247674] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4747), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [247724] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4747), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [247774] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [247824] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4857), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [247874] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4797), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [247924] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [247974] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [248024] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [248074] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [248124] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4845), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [248174] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4841), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [248224] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4833), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [248274] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [248324] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4861), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [248374] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [248424] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4685), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [248474] = 5,
    ACTIONS(4745), 3,
      anon_sym_PIPE,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 18,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_POUND_RPAREN,
  [248528] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4817), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [248578] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [248634] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [248690] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [248746] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [248796] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [248846] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4681), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [248896] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4821), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [248946] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [249002] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [249052] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4755), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [249102] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [249152] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [249202] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4751), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [249252] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4789), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [249302] = 14,
    ACTIONS(4658), 1,
      anon_sym_EQ,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(4674), 1,
      sym__cond_tight_at,
    STATE(2274), 1,
      sym__tight_at,
    STATE(8422), 1,
      aux_sym__bind_matches_repeat1,
    STATE(8990), 1,
      sym__bind_match,
    STATE(9050), 1,
      sym__simple_bind_match,
    STATE(10222), 1,
      sym__bind_matches,
    STATE(12338), 1,
      sym__bar,
    STATE(12352), 1,
      sym__guards,
    ACTIONS(5421), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5423), 24,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [249374] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [249430] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [249480] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [249536] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4703), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [249586] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4719), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [249636] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4727), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [249686] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4731), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [249736] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [249786] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4813), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [249836] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [249892] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [249948] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4785), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [249998] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [250048] = 5,
    ACTIONS(4674), 1,
      sym__cond_tight_at,
    STATE(2289), 1,
      sym__tight_at,
    ACTIONS(5421), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5423), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [250102] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [250152] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4759), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [250202] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4825), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [250252] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [250308] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [250364] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [250414] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [250470] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [250526] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [250582] = 6,
    ACTIONS(5465), 1,
      sym__cond_qual_dot,
    ACTIONS(5467), 1,
      sym__cond_tight_dot,
    STATE(9944), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [250638] = 6,
    ACTIONS(5465), 1,
      sym__cond_qual_dot,
    ACTIONS(5467), 1,
      sym__cond_tight_dot,
    STATE(9944), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [250694] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4723), 33,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [250744] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [250800] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [250856] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4763), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [250905] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5685), 1,
      sym_name,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    STATE(697), 1,
      sym__paren_open,
    STATE(1079), 1,
      sym__bracket_open,
    STATE(3190), 1,
      sym__qualified_constructor,
    STATE(3349), 1,
      sym__type_list,
    STATE(3350), 1,
      sym__type_tuple,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8435), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(3283), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(3259), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3348), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [250998] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4743), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [251047] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4759), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [251096] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4825), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [251145] = 10,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    ACTIONS(5689), 1,
      anon_sym_COMMA,
    STATE(1557), 1,
      sym__colon2,
    STATE(10486), 1,
      aux_sym__con_binding_list_repeat1,
    ACTIONS(5691), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(5073), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5075), 25,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      aux_sym__paren_open_token1,
  [251208] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4763), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [251257] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4699), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [251306] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [251355] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4735), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [251404] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4837), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [251453] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4789), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [251502] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4793), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [251551] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4707), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [251600] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4829), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [251649] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4809), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [251698] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4775), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [251747] = 5,
    ACTIONS(4745), 4,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      anon_sym_POUND,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 16,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [251800] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [251849] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4853), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [251898] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4785), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [251947] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4723), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [251996] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4857), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [252045] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4781), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [252094] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [252143] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4861), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [252192] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5693), 1,
      sym_name,
    STATE(701), 1,
      sym__paren_open,
    STATE(1090), 1,
      sym__bracket_open,
    STATE(7489), 1,
      sym__qualified_constructor,
    STATE(7524), 1,
      sym__type_tuple,
    STATE(7527), 1,
      sym__type_list,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8453), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7520), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(7519), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7539), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [252285] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4849), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [252334] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [252383] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4695), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [252432] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4751), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [252481] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4755), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [252530] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4849), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [252579] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4781), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [252628] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4685), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [252677] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4857), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [252726] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4853), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [252775] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [252830] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4829), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [252879] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4707), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [252928] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4739), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [252977] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4711), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [253026] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4817), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [253075] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4825), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [253124] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4767), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [253173] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4731), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [253222] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4759), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [253271] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4727), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [253320] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4743), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [253369] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4785), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [253418] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4719), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [253467] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4763), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [253516] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4703), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [253565] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [253620] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4813), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [253669] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [253724] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4775), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [253773] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4817), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [253822] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4789), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [253871] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5695), 1,
      sym_name,
    STATE(729), 1,
      sym__paren_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(7352), 1,
      sym__qualified_constructor,
    STATE(7425), 1,
      sym__type_list,
    STATE(7436), 1,
      sym__type_tuple,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8445), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7410), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(7413), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7420), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [253964] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4751), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [254013] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [254068] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4755), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [254117] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [254172] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4695), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [254221] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4813), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [254270] = 5,
    ACTIONS(4745), 1,
      anon_sym_POUND,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 19,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
  [254323] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4739), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [254372] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4735), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [254421] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5697), 1,
      sym_name,
    STATE(706), 1,
      sym__paren_open,
    STATE(982), 1,
      sym__bracket_open,
    STATE(6218), 1,
      sym__qualified_constructor,
    STATE(6395), 1,
      sym__type_list,
    STATE(6398), 1,
      sym__type_tuple,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8405), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(6314), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6315), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6394), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [254514] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4821), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [254563] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4685), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [254612] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5699), 1,
      sym_name,
    STATE(679), 1,
      sym__paren_open,
    STATE(1113), 1,
      sym__bracket_open,
    STATE(6874), 1,
      sym__qualified_constructor,
    STATE(7009), 1,
      sym__type_tuple,
    STATE(7016), 1,
      sym__type_list,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8443), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7000), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(7001), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7010), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [254705] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4681), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [254754] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [254803] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(4624), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4626), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [254858] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [254907] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4817), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [254956] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4739), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [255005] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4755), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [255054] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(4628), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4630), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [255109] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4751), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [255158] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [255207] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4715), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [255256] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4833), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [255305] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [255354] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4845), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [255403] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [255452] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [255501] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [255550] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [255599] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4797), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [255648] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [255697] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4747), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [255746] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4775), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [255795] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4813), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [255844] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4759), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [255893] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4825), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [255942] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4829), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [255991] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5701), 1,
      sym_name,
    STATE(718), 1,
      sym__paren_open,
    STATE(1071), 1,
      sym__bracket_open,
    STATE(4244), 1,
      sym__type_tuple,
    STATE(4251), 1,
      sym__qualified_constructor,
    STATE(4272), 1,
      sym__type_list,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8462), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(4267), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(4268), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4273), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [256084] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4853), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [256133] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4857), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [256182] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4731), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [256231] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4789), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [256280] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4727), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [256329] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4785), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [256378] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [256433] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [256488] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [256543] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4719), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [256592] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4703), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [256641] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [256696] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [256751] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5703), 1,
      sym_name,
    STATE(676), 1,
      sym__paren_open,
    STATE(1041), 1,
      sym__bracket_open,
    STATE(4116), 1,
      sym__type_tuple,
    STATE(4118), 1,
      sym__type_list,
    STATE(4205), 1,
      sym__qualified_constructor,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8485), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(4222), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(4124), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(4225), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [256844] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4699), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [256893] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4735), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [256942] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4695), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [256991] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4861), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [257040] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4849), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [257089] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4813), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [257138] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4809), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [257187] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5705), 1,
      sym_name,
    STATE(675), 1,
      sym__paren_open,
    STATE(1007), 1,
      sym__bracket_open,
    STATE(4062), 1,
      sym__qualified_constructor,
    STATE(4188), 1,
      sym__type_tuple,
    STATE(4227), 1,
      sym__type_list,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8498), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(4155), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(4151), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4226), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [257280] = 5,
    ACTIONS(4745), 3,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_POUND,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 17,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [257333] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [257382] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [257431] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4821), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [257480] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4681), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [257529] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [257578] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [257627] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4747), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [257676] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [257725] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [257780] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4797), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [257829] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [257878] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [257927] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [257976] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [258025] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4845), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [258074] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4841), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [258123] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4833), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [258172] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [258221] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4817), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [258270] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4695), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [258319] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4837), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [258368] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5707), 1,
      sym_name,
    STATE(714), 1,
      sym__paren_open,
    STATE(1131), 1,
      sym__bracket_open,
    STATE(3525), 1,
      sym__type_list,
    STATE(3528), 1,
      sym__type_tuple,
    STATE(3563), 1,
      sym__qualified_constructor,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8547), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(3577), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(3521), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(3574), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [258461] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5709), 1,
      sym_name,
    STATE(722), 1,
      sym__paren_open,
    STATE(1130), 1,
      sym__bracket_open,
    STATE(2753), 1,
      sym__type_tuple,
    STATE(2754), 1,
      sym__qualified_constructor,
    STATE(2822), 1,
      sym__type_list,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8529), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(2810), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(2811), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(2821), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [258554] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [258603] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4739), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [258652] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5711), 1,
      sym_name,
    STATE(694), 1,
      sym__paren_open,
    STATE(998), 1,
      sym__bracket_open,
    STATE(4342), 1,
      sym__type_list,
    STATE(4349), 1,
      sym__type_tuple,
    STATE(4378), 1,
      sym__qualified_constructor,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8412), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(4346), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(4343), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(4345), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [258745] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4781), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [258794] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [258843] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [258892] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [258941] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4681), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [258990] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4833), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [259039] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [259088] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4845), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [259137] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4821), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [259186] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [259235] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [259284] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [259333] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5713), 1,
      sym_name,
    STATE(709), 1,
      sym__paren_open,
    STATE(1120), 1,
      sym__bracket_open,
    STATE(3233), 1,
      sym__qualified_constructor,
    STATE(3338), 1,
      sym__type_tuple,
    STATE(3339), 1,
      sym__type_list,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8404), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(3414), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(3340), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(3415), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [259426] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4793), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [259475] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4837), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [259524] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4723), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [259573] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [259628] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4755), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [259677] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4751), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [259726] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [259781] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5715), 1,
      sym_name,
    STATE(725), 1,
      sym__paren_open,
    STATE(1055), 1,
      sym__bracket_open,
    STATE(2740), 1,
      sym__type_tuple,
    STATE(2741), 1,
      sym__type_list,
    STATE(2750), 1,
      sym__qualified_constructor,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8451), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(2738), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(2737), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(2747), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [259874] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4731), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [259923] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4767), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [259972] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4797), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [260021] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [260070] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4747), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [260119] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4685), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [260168] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4727), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [260217] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4703), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [260266] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4719), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [260315] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4775), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [260364] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4699), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [260413] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4727), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [260462] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4759), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [260511] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4731), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [260560] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4825), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [260609] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4743), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [260658] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5717), 1,
      sym_name,
    STATE(678), 1,
      sym__paren_open,
    STATE(1104), 1,
      sym__bracket_open,
    STATE(6941), 1,
      sym__type_tuple,
    STATE(6942), 1,
      sym__type_list,
    STATE(6961), 1,
      sym__qualified_constructor,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8489), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(6985), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6943), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(6984), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [260751] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5719), 1,
      sym_name,
    STATE(681), 1,
      sym__paren_open,
    STATE(1101), 1,
      sym__bracket_open,
    STATE(3072), 1,
      sym__type_tuple,
    STATE(3075), 1,
      sym__type_list,
    STATE(3104), 1,
      sym__qualified_constructor,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8473), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(3114), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(3067), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(3106), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [260844] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4829), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [260893] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5721), 1,
      sym_name,
    STATE(682), 1,
      sym__paren_open,
    STATE(1027), 1,
      sym__bracket_open,
    STATE(7084), 1,
      sym__qualified_constructor,
    STATE(7161), 1,
      sym__type_tuple,
    STATE(7162), 1,
      sym__type_list,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8459), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7134), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(7136), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7163), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [260986] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5723), 1,
      sym_name,
    STATE(695), 1,
      sym__paren_open,
    STATE(1084), 1,
      sym__bracket_open,
    STATE(5024), 1,
      sym__type_list,
    STATE(5025), 1,
      sym__type_tuple,
    STATE(5073), 1,
      sym__qualified_constructor,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8448), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(4980), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(4979), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5023), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [261079] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4727), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [261128] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4695), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [261177] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5725), 1,
      sym_name,
    STATE(707), 1,
      sym__paren_open,
    STATE(1078), 1,
      sym__bracket_open,
    STATE(6723), 1,
      sym__qualified_constructor,
    STATE(6806), 1,
      sym__type_tuple,
    STATE(6809), 1,
      sym__type_list,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8406), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(6836), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6810), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(6838), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [261270] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4719), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [261319] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4711), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [261368] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4853), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [261417] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4857), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [261466] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4703), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [261515] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4763), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [261564] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4817), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [261613] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5727), 1,
      sym_name,
    STATE(708), 1,
      sym__paren_open,
    STATE(987), 1,
      sym__bracket_open,
    STATE(4901), 1,
      sym__type_tuple,
    STATE(4902), 1,
      sym__type_list,
    STATE(5082), 1,
      sym__qualified_constructor,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8534), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(4968), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(4903), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(4967), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [261706] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4821), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [261755] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4681), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [261804] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [261853] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4861), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [261902] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4630), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [261957] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [262006] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4837), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [262055] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5729), 1,
      sym_name,
    STATE(711), 1,
      sym__paren_open,
    STATE(1073), 1,
      sym__bracket_open,
    STATE(3266), 1,
      sym__qualified_constructor,
    STATE(3331), 1,
      sym__type_tuple,
    STATE(3346), 1,
      sym__type_list,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8408), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(3284), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(3287), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3347), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [262148] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4715), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [262197] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5731), 1,
      sym_name,
    STATE(690), 1,
      sym__paren_open,
    STATE(964), 1,
      sym__bracket_open,
    STATE(3891), 1,
      sym__type_tuple,
    STATE(3892), 1,
      sym__type_list,
    STATE(3928), 1,
      sym__qualified_constructor,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8480), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(3805), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(3806), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3894), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [262290] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5733), 1,
      sym_name,
    STATE(713), 1,
      sym__paren_open,
    STATE(1069), 1,
      sym__bracket_open,
    STATE(3474), 1,
      sym__type_tuple,
    STATE(3501), 1,
      sym__qualified_constructor,
    STATE(3536), 1,
      sym__type_list,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8432), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(3550), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(3535), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(3549), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [262383] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4841), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [262432] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5735), 1,
      sym_name,
    STATE(727), 1,
      sym__paren_open,
    STATE(963), 1,
      sym__bracket_open,
    STATE(7603), 1,
      sym__type_list,
    STATE(7612), 1,
      sym__type_tuple,
    STATE(7616), 1,
      sym__qualified_constructor,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8465), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7613), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(7556), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7601), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [262525] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4723), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [262574] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4789), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [262623] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [262672] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4809), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [262721] = 5,
    ACTIONS(4745), 4,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_POUND,
      anon_sym_where,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 16,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [262774] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5737), 1,
      sym_name,
    STATE(732), 1,
      sym__paren_open,
    STATE(1063), 1,
      sym__bracket_open,
    STATE(3697), 1,
      sym__qualified_constructor,
    STATE(3725), 1,
      sym__type_tuple,
    STATE(3732), 1,
      sym__type_list,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8437), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(3745), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(3746), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3761), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [262867] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4767), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [262916] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4849), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [262965] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4861), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [263014] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4809), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [263063] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4711), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [263112] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4707), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [263161] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4685), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [263210] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4793), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [263259] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4715), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [263308] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4723), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [263357] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5739), 1,
      sym_name,
    STATE(717), 1,
      sym__paren_open,
    STATE(1061), 1,
      sym__bracket_open,
    STATE(6265), 1,
      sym__type_list,
    STATE(6267), 1,
      sym__type_tuple,
    STATE(6486), 1,
      sym__qualified_constructor,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8439), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(6219), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6215), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6264), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [263450] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [263505] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4833), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [263554] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4845), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [263603] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4857), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [263652] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4853), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [263701] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5741), 1,
      sym_name,
    STATE(721), 1,
      sym__paren_open,
    STATE(1050), 1,
      sym__bracket_open,
    STATE(5813), 1,
      sym__type_tuple,
    STATE(5825), 1,
      sym__qualified_constructor,
    STATE(5841), 1,
      sym__type_list,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8449), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(5858), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(5839), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5872), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [263794] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4829), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [263843] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [263892] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [263941] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [263990] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4743), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [264039] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4630), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [264094] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [264143] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4767), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [264192] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4695), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [264241] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4707), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [264290] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5743), 1,
      sym_name,
    STATE(723), 1,
      sym__paren_open,
    STATE(1047), 1,
      sym__bracket_open,
    STATE(2336), 1,
      sym__type_tuple,
    STATE(2346), 1,
      sym__type_list,
    STATE(2354), 1,
      sym__qualified_constructor,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8456), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(2340), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(2302), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(2305), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [264383] = 5,
    ACTIONS(4674), 1,
      sym__cond_tight_at,
    STATE(2264), 1,
      sym__tight_at,
    ACTIONS(5421), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5423), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [264436] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5745), 1,
      sym_name,
    STATE(712), 1,
      sym__paren_open,
    STATE(1042), 1,
      sym__bracket_open,
    STATE(4368), 1,
      sym__qualified_constructor,
    STATE(4385), 1,
      sym__type_tuple,
    STATE(4386), 1,
      sym__type_list,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8463), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(4428), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(4387), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(4423), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [264529] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5747), 1,
      sym_name,
    STATE(677), 1,
      sym__paren_open,
    STATE(1037), 1,
      sym__bracket_open,
    STATE(4610), 1,
      sym__qualified_constructor,
    STATE(4694), 1,
      sym__type_tuple,
    STATE(4695), 1,
      sym__type_list,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8470), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(4311), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(4316), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4655), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [264622] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4837), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [264671] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4813), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [264720] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4781), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [264769] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5749), 1,
      sym_name,
    STATE(686), 1,
      sym__paren_open,
    STATE(1029), 1,
      sym__bracket_open,
    STATE(6531), 1,
      sym__type_tuple,
    STATE(6532), 1,
      sym__type_list,
    STATE(6552), 1,
      sym__qualified_constructor,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8474), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(6449), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6450), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6533), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [264862] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4797), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [264911] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4711), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [264960] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [265009] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [265058] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4785), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [265107] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [265156] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4747), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [265205] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5751), 1,
      sym_name,
    STATE(689), 1,
      sym__paren_open,
    STATE(1009), 1,
      sym__bracket_open,
    STATE(7226), 1,
      sym__type_tuple,
    STATE(7228), 1,
      sym__type_list,
    STATE(7451), 1,
      sym__qualified_constructor,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8478), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7464), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(7234), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(7461), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [265298] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4735), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [265347] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4813), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [265396] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5753), 1,
      sym_name,
    STATE(700), 1,
      sym__paren_open,
    STATE(1082), 1,
      sym__bracket_open,
    STATE(7021), 1,
      sym__type_list,
    STATE(7061), 1,
      sym__qualified_constructor,
    STATE(7083), 1,
      sym__type_tuple,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8427), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7128), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(7093), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(7131), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [265489] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5755), 1,
      sym_name,
    STATE(687), 1,
      sym__paren_open,
    STATE(1066), 1,
      sym__bracket_open,
    STATE(7636), 1,
      sym__type_list,
    STATE(7642), 1,
      sym__type_tuple,
    STATE(7651), 1,
      sym__qualified_constructor,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8425), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7659), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(7655), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7656), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [265582] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [265631] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5757), 1,
      sym_name,
    STATE(680), 1,
      sym__paren_open,
    STATE(995), 1,
      sym__bracket_open,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(7735), 1,
      sym__qualified_constructor,
    STATE(7775), 1,
      sym__type_tuple,
    STATE(7776), 1,
      sym__type_list,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8484), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7757), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(7756), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7778), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [265724] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5759), 1,
      sym_name,
    STATE(696), 1,
      sym__paren_open,
    STATE(1124), 1,
      sym__bracket_open,
    STATE(7205), 1,
      sym__qualified_constructor,
    STATE(7463), 1,
      sym__type_tuple,
    STATE(7481), 1,
      sym__type_list,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8543), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7404), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(7405), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7473), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [265817] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5761), 1,
      sym_name,
    STATE(693), 1,
      sym__paren_open,
    STATE(1072), 1,
      sym__bracket_open,
    STATE(6091), 1,
      sym__type_list,
    STATE(6092), 1,
      sym__type_tuple,
    STATE(6126), 1,
      sym__qualified_constructor,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8423), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(6110), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6090), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(6107), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [265910] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4785), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [265959] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4723), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [266008] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5763), 1,
      sym_name,
    STATE(691), 1,
      sym__paren_open,
    STATE(990), 1,
      sym__bracket_open,
    STATE(6309), 1,
      sym__qualified_constructor,
    STATE(6342), 1,
      sym__type_tuple,
    STATE(6343), 1,
      sym__type_list,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8495), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(6472), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6344), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(6471), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [266101] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4825), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [266150] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4759), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [266199] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4793), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [266248] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4747), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [266297] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [266346] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [266395] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [266444] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4797), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [266493] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4789), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [266542] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4785), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [266591] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4775), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [266640] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [266689] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4715), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [266738] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [266787] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [266836] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4805), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [266885] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4707), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [266934] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4845), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [266983] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4711), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [267032] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4809), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [267081] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4849), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [267130] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4861), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [267179] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4857), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [267228] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4817), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [267277] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4833), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [267326] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4793), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [267375] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4699), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [267424] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4853), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [267473] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4606), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [267522] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4829), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [267571] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4781), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [267620] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(5073), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5075), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [267675] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4825), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [267724] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4759), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [267773] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4775), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [267822] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5765), 1,
      sym_name,
    STATE(705), 1,
      sym__paren_open,
    STATE(986), 1,
      sym__bracket_open,
    STATE(5978), 1,
      sym__qualified_constructor,
    STATE(6023), 1,
      sym__type_tuple,
    STATE(6024), 1,
      sym__type_list,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8512), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(5939), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(5953), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6027), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [267915] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5767), 1,
      sym_name,
    STATE(683), 1,
      sym__paren_open,
    STATE(965), 1,
      sym__bracket_open,
    STATE(6632), 1,
      sym__qualified_constructor,
    STATE(6670), 1,
      sym__type_list,
    STATE(6672), 1,
      sym__type_tuple,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8410), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(6600), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6601), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6668), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [268008] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4699), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [268057] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4715), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [268106] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4767), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [268155] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5769), 1,
      sym_name,
    STATE(719), 1,
      sym__paren_open,
    STATE(1028), 1,
      sym__bracket_open,
    STATE(6413), 1,
      sym__qualified_constructor,
    STATE(6527), 1,
      sym__type_tuple,
    STATE(6529), 1,
      sym__type_list,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8461), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(6528), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6530), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(6548), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [268248] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4743), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [268297] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4751), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [268346] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4747), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [268395] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [268444] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4755), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [268493] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4797), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [268542] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [268591] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [268640] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [268689] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [268738] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4845), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [268787] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [268836] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4833), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [268885] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [268934] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4763), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [268983] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [269038] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4699), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [269087] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5771), 1,
      sym_name,
    STATE(692), 1,
      sym__paren_open,
    STATE(1045), 1,
      sym__bracket_open,
    STATE(5886), 1,
      sym__type_tuple,
    STATE(6019), 1,
      sym__type_list,
    STATE(6022), 1,
      sym__qualified_constructor,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8430), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(5967), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(5884), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(5966), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [269180] = 5,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 5,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_POUND,
      anon_sym_POUND2,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 15,
      sym__phantom_arrow,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_POUND_RPAREN,
  [269233] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4715), 32,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [269282] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [269331] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [269380] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4801), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [269429] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4681), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [269478] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [269527] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [269576] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4681), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [269625] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4821), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [269674] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4739), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [269723] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4837), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [269772] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4821), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [269821] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4789), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [269870] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4751), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [269919] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5773), 1,
      sym_name,
    STATE(724), 1,
      sym__paren_open,
    STATE(976), 1,
      sym__bracket_open,
    STATE(3182), 1,
      sym__type_tuple,
    STATE(3253), 1,
      sym__type_list,
    STATE(3312), 1,
      sym__qualified_constructor,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8523), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(3323), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(3237), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(3319), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [270012] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_deriving,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4735), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [270061] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4755), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [270110] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5775), 1,
      sym_name,
    STATE(716), 1,
      sym__paren_open,
    STATE(971), 1,
      sym__bracket_open,
    STATE(6151), 1,
      sym__type_tuple,
    STATE(6152), 1,
      sym__type_list,
    STATE(6159), 1,
      sym__qualified_constructor,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8531), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(6066), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6068), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6153), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [270203] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4711), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [270252] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4707), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [270301] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4793), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [270350] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4739), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [270399] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4691), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [270448] = 5,
    ACTIONS(4745), 2,
      anon_sym_deriving,
      anon_sym_POUND,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 18,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
  [270501] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5777), 1,
      sym_name,
    STATE(699), 1,
      sym__paren_open,
    STATE(1017), 1,
      sym__bracket_open,
    STATE(6853), 1,
      sym__qualified_constructor,
    STATE(6868), 1,
      sym__type_list,
    STATE(6882), 1,
      sym__type_tuple,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8436), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(6947), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6869), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(6944), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [270594] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4861), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [270643] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4849), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [270692] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5779), 1,
      sym_name,
    STATE(702), 1,
      sym__paren_open,
    STATE(1122), 1,
      sym__bracket_open,
    STATE(4030), 1,
      sym__type_tuple,
    STATE(4033), 1,
      sym__type_list,
    STATE(4042), 1,
      sym__qualified_constructor,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8508), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(4147), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(4034), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(4146), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [270785] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4685), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [270834] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5781), 1,
      sym_name,
    STATE(731), 1,
      sym__paren_open,
    STATE(966), 1,
      sym__bracket_open,
    STATE(6794), 1,
      sym__type_tuple,
    STATE(6796), 1,
      sym__type_list,
    STATE(6807), 1,
      sym__qualified_constructor,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8539), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(6830), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6797), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(6831), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [270927] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4809), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [270976] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4703), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [271025] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4719), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [271074] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4781), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [271123] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5783), 1,
      sym_name,
    STATE(710), 1,
      sym__paren_open,
    STATE(1067), 1,
      sym__bracket_open,
    STATE(5954), 1,
      sym__qualified_constructor,
    STATE(5963), 1,
      sym__type_tuple,
    STATE(5964), 1,
      sym__type_list,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8550), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(5985), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(5965), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(5987), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [271216] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4727), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [271265] = 25,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(1145), 1,
      anon_sym_BQUOTE,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5785), 1,
      sym_name,
    STATE(728), 1,
      sym__paren_open,
    STATE(962), 1,
      sym__bracket_open,
    STATE(6223), 1,
      sym__qualified_constructor,
    STATE(6318), 1,
      sym__type_list,
    STATE(6319), 1,
      sym__type_tuple,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8284), 1,
      sym__qualified_varsym,
    STATE(8286), 1,
      sym__qualified_consym,
    STATE(8546), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(6199), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6209), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6317), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8283), 8,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [271358] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4731), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [271407] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4685), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [271456] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [271511] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4735), 30,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [271560] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4763), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [271609] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4723), 31,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [271658] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4703), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [271707] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4719), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [271756] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4743), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [271805] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4767), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [271854] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 9,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(4731), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [271903] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [271951] = 3,
    ACTIONS(5047), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5049), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [271999] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4735), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [272047] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4857), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [272095] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4853), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [272143] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4829), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [272191] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [272245] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4817), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [272293] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4711), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [272341] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4707), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [272389] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [272443] = 3,
    ACTIONS(5632), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5634), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [272491] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4723), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [272539] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5640), 11,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_type,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      anon_sym_POUND,
      anon_sym_POUND2,
      sym_variable,
    ACTIONS(5642), 25,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_qual_dot,
      sym__cond_prefix_dot,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [272587] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(4624), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4626), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [272641] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(4628), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4630), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [272695] = 3,
    ACTIONS(3005), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(3007), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [272743] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4715), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [272791] = 3,
    ACTIONS(5620), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5622), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [272839] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [272893] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [272947] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4813), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [272995] = 5,
    ACTIONS(4745), 3,
      anon_sym_deriving,
      anon_sym_POUND,
      anon_sym_where,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 16,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [273047] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4630), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [273101] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [273155] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4825), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [273203] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [273251] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [273299] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4759), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [273347] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [273401] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4699), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [273449] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4785), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [273497] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [273551] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4775), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [273599] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [273653] = 3,
    ACTIONS(5572), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5574), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [273701] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4789), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [273749] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4751), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [273797] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [273851] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4755), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [273899] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4695), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [273947] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4719), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [273995] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4781), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [274043] = 8,
    ACTIONS(5797), 1,
      anon_sym_POUND2,
    ACTIONS(5799), 1,
      anon_sym_PIPE2,
    ACTIONS(5802), 1,
      aux_sym__paren_close_token1,
    ACTIONS(5792), 2,
      anon_sym__,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5790), 6,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_COMMA,
      anon_sym_POUND_RPAREN,
    ACTIONS(5787), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5794), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [274101] = 3,
    ACTIONS(5469), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5471), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [274149] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [274203] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [274257] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4731), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [274305] = 3,
    ACTIONS(5568), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5570), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [274353] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [274407] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4767), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [274455] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [274509] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4727), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [274557] = 3,
    ACTIONS(5592), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5594), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [274605] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5640), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_forall,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(5642), 29,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_qual_dot,
      sym__cond_prefix_dot,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_context,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_POUND2,
      sym_implicit_variable,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [274653] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [274707] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [274761] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4861), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [274809] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4849), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [274857] = 3,
    ACTIONS(5596), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5598), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [274905] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4739), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [274953] = 3,
    ACTIONS(5564), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5566), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [275001] = 3,
    ACTIONS(5451), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5453), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [275049] = 3,
    ACTIONS(5600), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5602), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [275097] = 3,
    ACTIONS(5421), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5423), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [275145] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4743), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [275193] = 3,
    ACTIONS(5461), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5463), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [275241] = 3,
    ACTIONS(5624), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5626), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [275289] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4703), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [275337] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4763), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [275385] = 3,
    ACTIONS(5664), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5666), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [275433] = 3,
    ACTIONS(5588), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5590), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [275481] = 3,
    ACTIONS(5584), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5586), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [275529] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4809), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [275577] = 3,
    ACTIONS(5580), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5582), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [275625] = 3,
    ACTIONS(5608), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5610), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [275673] = 3,
    ACTIONS(5604), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5606), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [275721] = 3,
    ACTIONS(5612), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5614), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [275769] = 3,
    ACTIONS(5660), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5662), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [275817] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [275871] = 3,
    ACTIONS(5656), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5658), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [275919] = 3,
    ACTIONS(5652), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5654), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [275967] = 3,
    ACTIONS(5652), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5654), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [276015] = 3,
    ACTIONS(5451), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5453), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [276063] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [276117] = 3,
    ACTIONS(5648), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5650), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [276165] = 3,
    ACTIONS(5644), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5646), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [276213] = 3,
    ACTIONS(5636), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5638), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [276261] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4821), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [276309] = 3,
    ACTIONS(5576), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5578), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [276357] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [276411] = 3,
    ACTIONS(5616), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5618), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [276459] = 3,
    ACTIONS(5628), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5630), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [276507] = 3,
    ACTIONS(5628), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5630), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [276555] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4681), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [276603] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4685), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [276651] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [276699] = 3,
    ACTIONS(5628), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5630), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [276747] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [276795] = 3,
    ACTIONS(5652), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5654), 32,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [276843] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4630), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [276897] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [276951] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [277005] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(5073), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5075), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [277059] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [277113] = 6,
    ACTIONS(5802), 1,
      aux_sym__paren_close_token1,
    ACTIONS(5804), 1,
      anon_sym_POUND2,
    ACTIONS(5806), 1,
      anon_sym_PIPE2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5792), 10,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5790), 23,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_COMMA,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [277167] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [277215] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4833), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [277263] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4841), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [277311] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4845), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [277359] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4630), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [277413] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [277461] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [277509] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [277557] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4797), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [277605] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [277653] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4747), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [277701] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [277755] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [277809] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4793), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [277857] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [277911] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4837), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [277959] = 12,
    ACTIONS(4658), 1,
      anon_sym_EQ,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    STATE(8422), 1,
      aux_sym__bind_matches_repeat1,
    STATE(8990), 1,
      sym__bind_match,
    STATE(9050), 1,
      sym__simple_bind_match,
    STATE(10251), 1,
      sym__bind_matches,
    STATE(12338), 1,
      sym__bar,
    STATE(12352), 1,
      sym__guards,
    ACTIONS(5421), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5423), 24,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [278025] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4755), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [278072] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4845), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [278119] = 3,
    ACTIONS(5652), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5654), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [278166] = 3,
    ACTIONS(5652), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5654), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [278213] = 3,
    ACTIONS(5451), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5453), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [278260] = 3,
    ACTIONS(5648), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5650), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [278307] = 3,
    ACTIONS(5644), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5646), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [278354] = 3,
    ACTIONS(5636), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5638), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [278401] = 3,
    ACTIONS(5628), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5630), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [278448] = 3,
    ACTIONS(5628), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5630), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [278495] = 3,
    ACTIONS(5628), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5630), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [278542] = 3,
    ACTIONS(5624), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5626), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [278589] = 3,
    ACTIONS(5652), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5654), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [278636] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4739), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [278683] = 3,
    ACTIONS(5660), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5662), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [278730] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4751), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [278777] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4699), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [278824] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4775), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [278871] = 3,
    ACTIONS(5664), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5666), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [278918] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4759), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [278965] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4825), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [279012] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4735), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [279059] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4829), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [279106] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4853), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [279153] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4723), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [279200] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4861), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [279247] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4849), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [279294] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4809), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [279341] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4789), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [279388] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4781), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [279435] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4785), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [279482] = 3,
    ACTIONS(5461), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5463), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [279529] = 3,
    ACTIONS(5421), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5423), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [279576] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4781), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [279623] = 3,
    ACTIONS(5451), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5453), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [279670] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4685), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [279717] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4707), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [279764] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4715), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [279811] = 3,
    ACTIONS(5632), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5634), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [279858] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4711), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [279905] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4715), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [279952] = 3,
    ACTIONS(3005), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(3007), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [279999] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4793), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [280046] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [280099] = 3,
    ACTIONS(5047), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5049), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [280146] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4837), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [280193] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [280246] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4695), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [280293] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4817), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [280340] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4711), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [280387] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4707), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [280434] = 3,
    ACTIONS(5469), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5471), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [280481] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4723), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [280528] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4695), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [280575] = 3,
    ACTIONS(5612), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5614), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [280622] = 3,
    ACTIONS(5604), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5606), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [280669] = 3,
    ACTIONS(5568), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5570), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [280716] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4739), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [280763] = 3,
    ACTIONS(5572), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5574), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [280810] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4813), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [280857] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4857), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [280904] = 3,
    ACTIONS(5592), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5594), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [280951] = 3,
    ACTIONS(5580), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5582), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [280998] = 3,
    ACTIONS(5584), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5586), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [281045] = 3,
    ACTIONS(5588), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5590), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [281092] = 3,
    ACTIONS(5620), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5622), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [281139] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4685), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [281186] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4747), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [281233] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [281280] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4797), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [281327] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [281374] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [281421] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [281468] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [281515] = 3,
    ACTIONS(5596), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5598), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [281562] = 3,
    ACTIONS(5656), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5658), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [281609] = 3,
    ACTIONS(5564), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5566), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [281656] = 3,
    ACTIONS(5600), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5602), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [281703] = 3,
    ACTIONS(5608), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5610), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [281750] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4755), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [281797] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4751), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [281844] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4747), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [281891] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4630), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [281944] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [281991] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [282038] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4833), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [282085] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [282132] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4797), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [282179] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [282226] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [282273] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [282320] = 5,
    ACTIONS(4674), 1,
      sym__cond_tight_at,
    STATE(2276), 1,
      sym__tight_at,
    ACTIONS(5421), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5423), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [282371] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [282418] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4845), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [282465] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [282512] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4833), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [282559] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [282606] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [282653] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4809), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [282700] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [282747] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4681), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [282794] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4775), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [282841] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4821), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [282888] = 3,
    ACTIONS(5616), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5618), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [282935] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4759), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [282982] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4825), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [283029] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4813), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [283076] = 4,
    ACTIONS(4771), 1,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4747), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [283125] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [283178] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [283225] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4849), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [283272] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4861), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [283319] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [283366] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4681), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [283413] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4703), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [283460] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4829), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [283507] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4719), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [283554] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4821), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [283601] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4793), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [283648] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4853), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [283695] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4727), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [283742] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4857), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [283789] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4731), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [283836] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [283889] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4703), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [283936] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4719), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [283983] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [284036] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [284089] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4727), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [284136] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4735), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [284183] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4731), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [284230] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4699), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [284277] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [284330] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [284377] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [284424] = 3,
    ACTIONS(5576), 4,
      anon_sym__,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5578), 31,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__cond_minus,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [284471] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [284524] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4817), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [284571] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4837), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [284618] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [284665] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4789), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [284712] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [284759] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4767), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [284806] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4743), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [284853] = 5,
    ACTIONS(4745), 4,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_POUND,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 14,
      sym__phantom_arrow,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_RBRACK,
  [284904] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4763), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [284951] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4743), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [284998] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4785), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [285045] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4763), 28,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [285092] = 23,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5809), 1,
      anon_sym_SEMI,
    ACTIONS(5811), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5815), 1,
      sym__cond_layout_semicolon,
    ACTIONS(5819), 1,
      sym__cond_infix,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7599), 1,
      aux_sym__let_binds_repeat1,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(9455), 1,
      sym__type_instance,
    STATE(10065), 1,
      sym__forall_body,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10291), 1,
      sym__type_instance_common,
    STATE(10384), 1,
      sym__layout_end,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5817), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    STATE(8083), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [285179] = 5,
    ACTIONS(4745), 3,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_POUND,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 15,
      sym__phantom_arrow,
      sym__cond_prefix_dot,
      sym__cond_dotdot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_RBRACK,
  [285230] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_by,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4767), 27,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [285277] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4837), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [285323] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4719), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [285369] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4763), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [285415] = 11,
    ACTIONS(3565), 1,
      anon_sym_where,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(4142), 1,
      anon_sym_EQ,
    STATE(1572), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(9109), 1,
      sym__gadt,
    STATE(10550), 1,
      sym__newtype,
    ACTIONS(4146), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [285477] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4849), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [285523] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4809), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [285569] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4695), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [285615] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4755), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [285661] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4861), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [285707] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4857), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [285753] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4853), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [285799] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4829), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [285845] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4825), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [285891] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [285943] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4759), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [285989] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4785), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [286035] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [286087] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4703), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [286133] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4775), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [286179] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [286225] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4681), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [286271] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4685), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [286317] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [286369] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4699), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [286415] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4793), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [286461] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4849), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [286507] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [286559] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4719), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [286605] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4789), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [286651] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4751), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [286697] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4755), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [286743] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4809), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [286789] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4743), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [286835] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [286881] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [286927] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [286973] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4861), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [287019] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4857), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [287065] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4739), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [287111] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4853), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [287157] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4833), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [287203] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4845), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [287249] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [287295] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [287341] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4829), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [287387] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4727), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [287433] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [287485] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4735), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [287531] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4825), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [287577] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4759), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [287623] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4785), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [287669] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4695), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [287715] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4767), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [287761] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4775), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [287807] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [287853] = 5,
    ACTIONS(4674), 1,
      sym__cond_tight_at,
    STATE(2274), 1,
      sym__tight_at,
    ACTIONS(5421), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5423), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [287903] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4731), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [287949] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4837), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [287995] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4699), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [288041] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4817), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [288087] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4797), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [288133] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4793), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [288179] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [288225] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4747), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [288271] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4747), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [288317] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4751), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [288363] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4630), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [288415] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4715), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [288461] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4723), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [288507] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4711), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [288553] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [288599] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4707), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [288645] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4685), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [288691] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4797), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [288737] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4707), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [288783] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4723), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [288829] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4781), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [288875] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4711), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [288921] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [288967] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4739), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [289013] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [289059] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4789), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [289105] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4813), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [289151] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [289197] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4813), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [289243] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [289289] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [289335] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4845), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [289381] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [289427] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4821), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [289473] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4833), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [289519] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [289565] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [289611] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [289657] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4681), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [289703] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [289749] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4735), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [289795] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4821), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [289841] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [289887] = 5,
    ACTIONS(4745), 3,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_POUND,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 14,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [289937] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4685), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [289983] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4703), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [290029] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4719), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [290075] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4785), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [290121] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4727), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [290167] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4731), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [290213] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4715), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [290259] = 11,
    ACTIONS(3565), 1,
      anon_sym_where,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(4142), 1,
      anon_sym_EQ,
    STATE(1572), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(9109), 1,
      sym__gadt,
    STATE(10813), 1,
      sym__newtype,
    ACTIONS(4146), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [290321] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4723), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [290367] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4789), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [290413] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [290459] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4809), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [290505] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4849), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [290551] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4837), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [290597] = 5,
    ACTIONS(4745), 3,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_POUND,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 14,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [290647] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4861), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [290693] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4857), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [290739] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4793), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [290785] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4853), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [290831] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4829), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [290877] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4825), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [290923] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4763), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [290969] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4759), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [291015] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4775), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [291061] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [291113] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4699), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [291159] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4751), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [291205] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4755), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [291251] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4743), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [291297] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4695), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [291343] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4634), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [291395] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4739), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [291441] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4767), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [291487] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4781), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [291533] = 11,
    ACTIONS(3565), 1,
      anon_sym_where,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(4142), 1,
      anon_sym_EQ,
    STATE(1572), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(9109), 1,
      sym__gadt,
    STATE(10049), 1,
      sym__newtype,
    ACTIONS(4146), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [291595] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [291641] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [291687] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4747), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [291733] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [291779] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4707), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [291825] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4797), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [291871] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4711), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [291917] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [291963] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [292009] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [292055] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [292101] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4845), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [292147] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4833), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [292193] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [292239] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4626), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [292291] = 5,
    ACTIONS(4745), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 15,
      sym__phantom_bar,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      anon_sym_u2192,
  [292341] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [292387] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [292433] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4821), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [292479] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4731), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [292525] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4767), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [292571] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4727), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [292617] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4703), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [292663] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4763), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [292709] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4735), 27,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [292755] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [292801] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4681), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [292847] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4817), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [292893] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4781), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [292939] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4715), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [292985] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4817), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [293031] = 6,
    ACTIONS(5825), 1,
      anon_sym_PIPE,
    ACTIONS(5828), 1,
      anon_sym_PIPE2,
    STATE(7015), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5821), 9,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5823), 22,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [293083] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [293129] = 11,
    ACTIONS(3565), 1,
      anon_sym_where,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(4142), 1,
      anon_sym_EQ,
    STATE(1572), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(9109), 1,
      sym__gadt,
    STATE(10545), 1,
      sym__newtype,
    ACTIONS(4146), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [293191] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4813), 27,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [293237] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4743), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [293283] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [293328] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [293373] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4857), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [293418] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4853), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [293463] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4829), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [293508] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4735), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [293553] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4825), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [293598] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4759), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [293643] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4821), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [293688] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4775), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [293733] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4699), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [293778] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4829), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [293823] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4715), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [293868] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4751), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [293913] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4755), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [293958] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4853), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [294003] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4739), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [294048] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4857), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [294093] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4825), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [294138] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4630), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [294189] = 3,
    ACTIONS(5624), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5626), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [294234] = 3,
    ACTIONS(5652), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5654), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [294279] = 3,
    ACTIONS(5628), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5630), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [294324] = 3,
    ACTIONS(5628), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5630), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [294369] = 3,
    ACTIONS(5628), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5630), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [294414] = 3,
    ACTIONS(5636), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5638), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [294459] = 3,
    ACTIONS(5644), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5646), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [294504] = 3,
    ACTIONS(5648), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5650), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [294549] = 3,
    ACTIONS(5451), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5453), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [294594] = 3,
    ACTIONS(5652), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5654), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [294639] = 3,
    ACTIONS(5652), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5654), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [294684] = 3,
    ACTIONS(5656), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5658), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [294729] = 3,
    ACTIONS(5660), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5662), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [294774] = 3,
    ACTIONS(5664), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5666), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [294819] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5831), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(5833), 23,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [294870] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4781), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [294915] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4699), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [294960] = 3,
    ACTIONS(5461), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5463), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [295005] = 3,
    ACTIONS(5421), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5423), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [295050] = 3,
    ACTIONS(5451), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5453), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [295095] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4861), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [295140] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4849), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [295185] = 3,
    ACTIONS(3005), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(3007), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [295230] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4809), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [295275] = 3,
    ACTIONS(5632), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5634), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [295320] = 3,
    ACTIONS(5469), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5471), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [295365] = 3,
    ACTIONS(5612), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5614), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [295410] = 3,
    ACTIONS(5604), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5606), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [295455] = 3,
    ACTIONS(5568), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5570), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [295500] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4763), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [295545] = 3,
    ACTIONS(5572), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5574), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [295590] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4703), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [295635] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4817), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [295680] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4719), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [295725] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4685), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [295770] = 3,
    ACTIONS(5592), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5594), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [295815] = 3,
    ACTIONS(5580), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5582), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [295860] = 3,
    ACTIONS(5584), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5586), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [295905] = 3,
    ACTIONS(5588), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5590), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [295950] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4813), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [295995] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4743), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [296040] = 3,
    ACTIONS(5620), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5622), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [296085] = 3,
    ACTIONS(5596), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5598), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [296130] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [296175] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4849), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [296220] = 21,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5819), 1,
      sym__cond_infix,
    ACTIONS(5835), 1,
      anon_sym_SEMI,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(8933), 1,
      aux_sym__let_binds_repeat1,
    STATE(10065), 1,
      sym__forall_body,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10291), 1,
      sym__type_instance_common,
    STATE(10442), 1,
      sym__layout_end,
    STATE(10602), 1,
      sym__type_instance,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5837), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    STATE(8083), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [296301] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4809), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [296346] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4759), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [296391] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4785), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [296436] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4789), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [296481] = 3,
    ACTIONS(5564), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5566), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [296526] = 3,
    ACTIONS(5600), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5602), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [296571] = 3,
    ACTIONS(5608), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5610), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [296616] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4681), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [296661] = 3,
    ACTIONS(5616), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5618), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [296706] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4727), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [296751] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4775), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [296796] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4785), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [296841] = 3,
    ACTIONS(5576), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5578), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [296886] = 21,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5819), 1,
      sym__cond_infix,
    ACTIONS(5835), 1,
      anon_sym_SEMI,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(8933), 1,
      aux_sym__let_binds_repeat1,
    STATE(10065), 1,
      sym__forall_body,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10291), 1,
      sym__type_instance_common,
    STATE(10596), 1,
      sym__layout_end,
    STATE(10602), 1,
      sym__type_instance,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5839), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    STATE(8083), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [296967] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [297018] = 3,
    ACTIONS(4721), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4723), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [297063] = 3,
    ACTIONS(4705), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4707), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [297108] = 3,
    ACTIONS(4709), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4711), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [297153] = 3,
    ACTIONS(4683), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4685), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [297198] = 27,
    ACTIONS(1375), 1,
      anon_sym_forall,
    ACTIONS(1377), 1,
      anon_sym_u2200,
    ACTIONS(5527), 1,
      sym_variable,
    ACTIONS(5529), 1,
      anon_sym__,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5537), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(5841), 1,
      anon_sym_instance,
    ACTIONS(5843), 1,
      anon_sym_family,
    ACTIONS(5845), 1,
      sym_name,
    ACTIONS(5847), 1,
      sym__cond_assoc_tyinst,
    STATE(5395), 1,
      sym__paren_open,
    STATE(8056), 1,
      sym_type_param,
    STATE(8092), 1,
      sym__type_head_params,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(8677), 1,
      sym__type_param_invisible,
    STATE(8746), 1,
      sym__plist,
    STATE(8768), 1,
      sym__type_head_parens,
    STATE(8769), 1,
      sym__type_head_name,
    STATE(8807), 1,
      sym__prefix_at,
    STATE(8912), 1,
      sym__type_head_infix,
    STATE(10017), 1,
      sym__forall_body,
    STATE(11624), 1,
      sym__bracket_open,
    STATE(8679), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    STATE(12246), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8773), 6,
      sym_unit,
      sym__tycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__consym_prefix,
      sym__pconsym,
  [297291] = 21,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5819), 1,
      sym__cond_infix,
    ACTIONS(5835), 1,
      anon_sym_SEMI,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(8933), 1,
      aux_sym__let_binds_repeat1,
    STATE(10065), 1,
      sym__forall_body,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10291), 1,
      sym__type_instance_common,
    STATE(10414), 1,
      sym__layout_end,
    STATE(10602), 1,
      sym__type_instance,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5849), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    STATE(8083), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [297372] = 3,
    ACTIONS(4693), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4695), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [297417] = 3,
    ACTIONS(4835), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4837), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [297462] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4793), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [297507] = 3,
    ACTIONS(4713), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4715), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [297552] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4861), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [297597] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4767), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [297642] = 3,
    ACTIONS(4791), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4793), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [297687] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4731), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [297732] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4735), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [297777] = 7,
    ACTIONS(5689), 1,
      anon_sym_COMMA,
    STATE(1565), 1,
      sym__colon2,
    STATE(10487), 1,
      aux_sym__con_binding_list_repeat1,
    ACTIONS(5851), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(5451), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5453), 25,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      aux_sym__paren_open_token1,
  [297830] = 21,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5819), 1,
      sym__cond_infix,
    ACTIONS(5835), 1,
      anon_sym_SEMI,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(8933), 1,
      aux_sym__let_binds_repeat1,
    STATE(10065), 1,
      sym__forall_body,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10291), 1,
      sym__type_instance_common,
    STATE(10410), 1,
      sym__layout_end,
    STATE(10602), 1,
      sym__type_instance,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5853), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    STATE(8083), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [297911] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [297962] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 23,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [298013] = 3,
    ACTIONS(5047), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5049), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [298058] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4789), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [298103] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [298148] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4751), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [298193] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4833), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [298238] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4755), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [298283] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4723), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [298328] = 5,
    ACTIONS(4745), 4,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      anon_sym_POUND,
      anon_sym_where,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4747), 12,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [298377] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [298422] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4695), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [298467] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4841), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [298512] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [298557] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4845), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [298602] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [298647] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [298692] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [298737] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [298782] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [298827] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [298872] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4747), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [298917] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [298962] = 3,
    ACTIONS(4807), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4809), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [299007] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4797), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [299052] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [299097] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [299142] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [299187] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [299232] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4845), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [299277] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [299322] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4833), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [299367] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [299412] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4723), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [299457] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4797), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [299502] = 3,
    ACTIONS(4859), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4861), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [299547] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4685), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [299592] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4747), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [299637] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4707), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [299682] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4711), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [299727] = 21,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5819), 1,
      sym__cond_infix,
    ACTIONS(5835), 1,
      anon_sym_SEMI,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(8933), 1,
      aux_sym__let_binds_repeat1,
    STATE(10065), 1,
      sym__forall_body,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10279), 1,
      sym__layout_end,
    STATE(10291), 1,
      sym__type_instance_common,
    STATE(10602), 1,
      sym__type_instance,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5855), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    STATE(8083), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [299808] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4739), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [299853] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4813), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [299898] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [299943] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [299988] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4681), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [300033] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4715), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [300078] = 21,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5819), 1,
      sym__cond_infix,
    ACTIONS(5835), 1,
      anon_sym_SEMI,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(8933), 1,
      aux_sym__let_binds_repeat1,
    STATE(10065), 1,
      sym__forall_body,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10272), 1,
      sym__layout_end,
    STATE(10291), 1,
      sym__type_instance_common,
    STATE(10602), 1,
      sym__type_instance,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(5857), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    STATE(8083), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [300159] = 3,
    ACTIONS(4697), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4699), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [300204] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4821), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [300249] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4781), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [300294] = 5,
    ACTIONS(4674), 1,
      sym__cond_tight_at,
    STATE(2293), 1,
      sym__tight_at,
    ACTIONS(5421), 4,
      anon_sym__,
      anon_sym_PIPE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5423), 27,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_PIPE2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [300343] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4793), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [300388] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4767), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [300433] = 3,
    ACTIONS(4855), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4857), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [300478] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4743), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [300523] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4837), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [300568] = 3,
    ACTIONS(4851), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4853), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [300613] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4763), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [300658] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4837), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [300703] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [300754] = 3,
    ACTIONS(4827), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4829), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [300799] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4695), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [300844] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [300895] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4817), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [300940] = 3,
    ACTIONS(4823), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4825), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [300985] = 3,
    ACTIONS(4757), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4759), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [301030] = 3,
    ACTIONS(4783), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4785), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [301075] = 3,
    ACTIONS(4773), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4775), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [301120] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4703), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [301165] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4719), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [301210] = 3,
    ACTIONS(4847), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4849), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [301255] = 3,
    ACTIONS(4787), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4789), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [301300] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4727), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [301345] = 3,
    ACTIONS(4749), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4751), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [301390] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4731), 27,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [301435] = 3,
    ACTIONS(4753), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4755), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [301480] = 5,
    ACTIONS(4745), 2,
      anon_sym_deriving,
      anon_sym_POUND,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(4747), 14,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
  [301529] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4711), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [301574] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [301625] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [301676] = 3,
    ACTIONS(4737), 4,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4739), 29,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [301721] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 8,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      anon_sym_DASH_GT,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4707), 25,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_prefix_percent,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      aux_sym__paren_open_token1,
  [301766] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [301817] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [301868] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4695), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [301912] = 3,
    ACTIONS(5648), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5650), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [301956] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4849), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [302000] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4739), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [302044] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [302088] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2957), 1,
      sym__integer_literal,
    ACTIONS(5861), 1,
      sym_name,
    STATE(610), 1,
      sym__paren_open,
    STATE(7206), 1,
      sym_integer,
    STATE(7224), 1,
      sym__exp_parens,
    STATE(7450), 1,
      sym__qualified_variable,
    STATE(7451), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10415), 1,
      aux_sym__qualifying_module,
    ACTIONS(2955), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2959), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5859), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7225), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [302156] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4833), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [302200] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [302244] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2685), 1,
      sym__integer_literal,
    ACTIONS(5865), 1,
      sym_name,
    STATE(647), 1,
      sym__paren_open,
    STATE(6853), 1,
      sym__qualified_constructor,
    STATE(6856), 1,
      sym__exp_parens,
    STATE(6885), 1,
      sym__qualified_variable,
    STATE(6928), 1,
      sym_integer,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10838), 1,
      aux_sym__qualifying_module,
    ACTIONS(2683), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2687), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5863), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6914), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [302312] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4817), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [302356] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2705), 1,
      sym__integer_literal,
    ACTIONS(5869), 1,
      sym_name,
    STATE(623), 1,
      sym__paren_open,
    STATE(6961), 1,
      sym__qualified_constructor,
    STATE(6964), 1,
      sym__qualified_variable,
    STATE(6976), 1,
      sym__exp_parens,
    STATE(6980), 1,
      sym_integer,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10314), 1,
      aux_sym__qualifying_module,
    ACTIONS(2703), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2707), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5867), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6975), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [302424] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4853), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [302468] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4853), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [302512] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4857), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [302556] = 15,
    ACTIONS(237), 1,
      sym__integer_literal,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5873), 1,
      sym_name,
    STATE(609), 1,
      sym__paren_open,
    STATE(2887), 1,
      sym__exp_parens,
    STATE(2917), 1,
      sym_integer,
    STATE(2919), 1,
      sym__qualified_constructor,
    STATE(2933), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10798), 1,
      aux_sym__qualifying_module,
    ACTIONS(235), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(239), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5871), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(2886), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [302624] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4861), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [302668] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4781), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [302712] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4829), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [302756] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1941), 1,
      sym__integer_literal,
    ACTIONS(5877), 1,
      sym_name,
    STATE(608), 1,
      sym__paren_open,
    STATE(6125), 1,
      sym_integer,
    STATE(6126), 1,
      sym__qualified_constructor,
    STATE(6143), 1,
      sym__qualified_variable,
    STATE(6157), 1,
      sym__exp_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10691), 1,
      aux_sym__qualifying_module,
    ACTIONS(1939), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1943), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5875), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6160), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [302824] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4825), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [302868] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4829), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [302912] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4755), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [302956] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4751), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [303000] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [303044] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1045), 1,
      sym__integer_literal,
    ACTIONS(5881), 1,
      sym_name,
    STATE(638), 1,
      sym__paren_open,
    STATE(4313), 1,
      sym__qualified_variable,
    STATE(4366), 1,
      sym_integer,
    STATE(4378), 1,
      sym__qualified_constructor,
    STATE(4395), 1,
      sym__exp_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10115), 1,
      aux_sym__qualifying_module,
    ACTIONS(1043), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1047), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5879), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4396), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [303112] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [303156] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4813), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [303200] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4731), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [303244] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1601), 1,
      sym__integer_literal,
    ACTIONS(5885), 1,
      sym_name,
    STATE(617), 1,
      sym__paren_open,
    STATE(3233), 1,
      sym__qualified_constructor,
    STATE(3236), 1,
      sym__qualified_variable,
    STATE(3282), 1,
      sym__exp_parens,
    STATE(3286), 1,
      sym_integer,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10313), 1,
      aux_sym__qualifying_module,
    ACTIONS(1599), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1603), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5883), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3281), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [303312] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4767), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [303356] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4727), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [303400] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4681), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [303444] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4821), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [303488] = 3,
    ACTIONS(5576), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5578), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [303532] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4845), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [303576] = 3,
    ACTIONS(5592), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5594), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [303620] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4775), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [303664] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [303708] = 3,
    ACTIONS(5580), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5582), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [303752] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4759), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [303796] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4825), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [303840] = 3,
    ACTIONS(5584), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5586), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [303884] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4785), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [303928] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [303972] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [304016] = 3,
    ACTIONS(5588), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5590), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [304060] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4703), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [304104] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(641), 1,
      sym__integer_literal,
    ACTIONS(5889), 1,
      sym_name,
    STATE(589), 1,
      sym__paren_open,
    STATE(3431), 1,
      sym__exp_parens,
    STATE(3448), 1,
      sym__qualified_constructor,
    STATE(3505), 1,
      sym_integer,
    STATE(3665), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10429), 1,
      aux_sym__qualifying_module,
    ACTIONS(639), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(643), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5887), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3432), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [304172] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4719), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [304216] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4727), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [304260] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4829), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [304304] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3399), 1,
      sym__integer_literal,
    ACTIONS(5893), 1,
      sym_name,
    STATE(618), 1,
      sym__paren_open,
    STATE(7986), 1,
      sym__qualified_variable,
    STATE(7987), 1,
      sym__exp_parens,
    STATE(7995), 1,
      sym__qualified_constructor,
    STATE(7997), 1,
      sym_integer,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10485), 1,
      aux_sym__qualifying_module,
    ACTIONS(3397), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3401), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5891), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7990), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [304372] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4775), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [304416] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4707), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [304460] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4853), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [304504] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [304548] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4857), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [304592] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2133), 1,
      sym__integer_literal,
    ACTIONS(5897), 1,
      sym_name,
    STATE(622), 1,
      sym__paren_open,
    STATE(6338), 1,
      sym_integer,
    STATE(6357), 1,
      sym__exp_parens,
    STATE(6551), 1,
      sym__qualified_variable,
    STATE(6552), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10387), 1,
      aux_sym__qualifying_module,
    ACTIONS(2131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2135), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5895), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6358), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [304660] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4731), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [304704] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [304748] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(991), 1,
      sym__integer_literal,
    ACTIONS(5901), 1,
      sym_name,
    STATE(597), 1,
      sym__paren_open,
    STATE(4352), 1,
      sym__qualified_variable,
    STATE(4368), 1,
      sym__qualified_constructor,
    STATE(4597), 1,
      sym_integer,
    STATE(4603), 1,
      sym__exp_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10460), 1,
      aux_sym__qualifying_module,
    ACTIONS(989), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(993), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5899), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4604), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [304816] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [304866] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4751), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [304910] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2585), 1,
      sym__integer_literal,
    ACTIONS(5905), 1,
      sym_name,
    STATE(624), 1,
      sym__paren_open,
    STATE(6613), 1,
      sym__exp_parens,
    STATE(6631), 1,
      sym__qualified_variable,
    STATE(6632), 1,
      sym__qualified_constructor,
    STATE(6634), 1,
      sym_integer,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10669), 1,
      aux_sym__qualifying_module,
    ACTIONS(2583), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2587), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5903), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6611), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [304978] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4813), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [305022] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4797), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [305066] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [305110] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3063), 1,
      sym__integer_literal,
    ACTIONS(5909), 1,
      sym_name,
    STATE(600), 1,
      sym__paren_open,
    STATE(7205), 1,
      sym__qualified_constructor,
    STATE(7274), 1,
      sym_integer,
    STATE(7394), 1,
      sym__exp_parens,
    STATE(7482), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10751), 1,
      aux_sym__qualifying_module,
    ACTIONS(3061), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3065), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5907), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7265), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [305178] = 3,
    ACTIONS(4835), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4837), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [305222] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1859), 1,
      sym__integer_literal,
    ACTIONS(5913), 1,
      sym_name,
    STATE(629), 1,
      sym__paren_open,
    STATE(5818), 1,
      sym__exp_parens,
    STATE(5823), 1,
      sym__qualified_variable,
    STATE(5825), 1,
      sym__qualified_constructor,
    STATE(5845), 1,
      sym_integer,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10337), 1,
      aux_sym__qualifying_module,
    ACTIONS(1857), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1861), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5911), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5819), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [305290] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4715), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [305334] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4739), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [305378] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4735), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [305422] = 3,
    ACTIONS(4713), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4715), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [305466] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4809), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [305510] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4626), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [305560] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1981), 1,
      sym__integer_literal,
    ACTIONS(5917), 1,
      sym_name,
    STATE(620), 1,
      sym__paren_open,
    STATE(6128), 1,
      sym_integer,
    STATE(6158), 1,
      sym__qualified_variable,
    STATE(6159), 1,
      sym__qualified_constructor,
    STATE(6164), 1,
      sym__exp_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10564), 1,
      aux_sym__qualifying_module,
    ACTIONS(1979), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1983), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5915), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6170), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [305628] = 3,
    ACTIONS(4791), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4793), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [305672] = 3,
    ACTIONS(5461), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5463), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [305716] = 3,
    ACTIONS(5421), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5423), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [305760] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [305810] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4789), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [305854] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4747), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [305898] = 3,
    ACTIONS(5451), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5453), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [305942] = 3,
    ACTIONS(4721), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4723), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [305986] = 3,
    ACTIONS(4693), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4695), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [306030] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1825), 1,
      sym__integer_literal,
    ACTIONS(5921), 1,
      sym_name,
    STATE(643), 1,
      sym__paren_open,
    STATE(5082), 1,
      sym__qualified_constructor,
    STATE(5089), 1,
      sym__qualified_variable,
    STATE(5100), 1,
      sym_integer,
    STATE(5101), 1,
      sym__exp_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10779), 1,
      aux_sym__qualifying_module,
    ACTIONS(1823), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1827), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5919), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5102), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [306098] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4723), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [306142] = 3,
    ACTIONS(5620), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5622), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [306186] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1661), 1,
      sym__integer_literal,
    ACTIONS(5925), 1,
      sym_name,
    STATE(621), 1,
      sym__paren_open,
    STATE(3433), 1,
      sym__exp_parens,
    STATE(3435), 1,
      sym_integer,
    STATE(3489), 1,
      sym__qualified_variable,
    STATE(3501), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10326), 1,
      aux_sym__qualifying_module,
    ACTIONS(1659), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1663), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5923), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3421), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [306254] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1169), 1,
      sym__integer_literal,
    ACTIONS(5929), 1,
      sym_name,
    STATE(611), 1,
      sym__paren_open,
    STATE(3562), 1,
      sym__qualified_constructor,
    STATE(3645), 1,
      sym__qualified_variable,
    STATE(3656), 1,
      sym__exp_parens,
    STATE(3683), 1,
      sym_integer,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10440), 1,
      aux_sym__qualifying_module,
    ACTIONS(1167), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1171), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5927), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3652), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [306322] = 5,
    ACTIONS(4745), 3,
      anon_sym_via,
      anon_sym_deriving,
      anon_sym_POUND,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4747), 12,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [306370] = 3,
    ACTIONS(5596), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5598), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [306414] = 3,
    ACTIONS(5564), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5566), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [306458] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4747), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [306502] = 3,
    ACTIONS(5600), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5602), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [306546] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4685), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [306590] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [306634] = 3,
    ACTIONS(5636), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5638), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [306678] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4797), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [306722] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2835), 1,
      sym__integer_literal,
    ACTIONS(5933), 1,
      sym_name,
    STATE(641), 1,
      sym__paren_open,
    STATE(5721), 1,
      sym_integer,
    STATE(5725), 1,
      sym__qualified_variable,
    STATE(5750), 1,
      sym__qualified_constructor,
    STATE(5766), 1,
      sym__exp_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10299), 1,
      aux_sym__qualifying_module,
    ACTIONS(2833), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2837), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5931), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5769), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [306790] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4785), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [306834] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [306878] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2639), 1,
      sym__integer_literal,
    ACTIONS(5937), 1,
      sym_name,
    STATE(630), 1,
      sym__paren_open,
    STATE(6754), 1,
      sym_integer,
    STATE(6776), 1,
      sym__exp_parens,
    STATE(6807), 1,
      sym__qualified_constructor,
    STATE(6808), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10601), 1,
      aux_sym__qualifying_module,
    ACTIONS(2637), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2641), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5935), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6777), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [306946] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4735), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [306990] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [307034] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4837), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [307078] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3375), 1,
      sym__integer_literal,
    ACTIONS(5941), 1,
      sym_name,
    STATE(612), 1,
      sym__paren_open,
    STATE(7734), 1,
      sym__qualified_variable,
    STATE(7735), 1,
      sym__qualified_constructor,
    STATE(7762), 1,
      sym_integer,
    STATE(7783), 1,
      sym__exp_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10484), 1,
      aux_sym__qualifying_module,
    ACTIONS(3373), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3377), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5939), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7789), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [307146] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3259), 1,
      sym__integer_literal,
    ACTIONS(5945), 1,
      sym_name,
    STATE(625), 1,
      sym__paren_open,
    STATE(7650), 1,
      sym__qualified_variable,
    STATE(7651), 1,
      sym__qualified_constructor,
    STATE(7653), 1,
      sym_integer,
    STATE(7714), 1,
      sym__exp_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10701), 1,
      aux_sym__qualifying_module,
    ACTIONS(3257), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3261), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5943), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7704), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [307214] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4789), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [307258] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2469), 1,
      sym__integer_literal,
    ACTIONS(5949), 1,
      sym_name,
    STATE(644), 1,
      sym__paren_open,
    STATE(6216), 1,
      sym__qualified_variable,
    STATE(6222), 1,
      sym__exp_parens,
    STATE(6223), 1,
      sym__qualified_constructor,
    STATE(6231), 1,
      sym_integer,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10800), 1,
      aux_sym__qualifying_module,
    ACTIONS(2467), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2471), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5947), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6221), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [307326] = 3,
    ACTIONS(4709), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4711), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [307370] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4699), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [307414] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4793), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [307458] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(909), 1,
      sym__integer_literal,
    ACTIONS(5953), 1,
      sym_name,
    STATE(614), 1,
      sym__paren_open,
    STATE(4251), 1,
      sym__qualified_constructor,
    STATE(4253), 1,
      sym__exp_parens,
    STATE(4282), 1,
      sym_integer,
    STATE(4298), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10255), 1,
      aux_sym__qualifying_module,
    ACTIONS(907), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(911), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5951), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4294), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [307526] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [307570] = 3,
    ACTIONS(5632), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5634), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [307614] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4837), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [307658] = 3,
    ACTIONS(5664), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5666), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [307702] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2053), 1,
      sym__integer_literal,
    ACTIONS(5957), 1,
      sym_name,
    STATE(636), 1,
      sym__paren_open,
    STATE(6218), 1,
      sym__qualified_constructor,
    STATE(6414), 1,
      sym__qualified_variable,
    STATE(6542), 1,
      sym__exp_parens,
    STATE(6547), 1,
      sym_integer,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10886), 1,
      aux_sym__qualifying_module,
    ACTIONS(2051), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2055), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5955), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6539), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [307770] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(565), 1,
      sym__integer_literal,
    ACTIONS(5961), 1,
      sym_name,
    STATE(603), 1,
      sym__paren_open,
    STATE(3696), 1,
      sym__qualified_variable,
    STATE(3697), 1,
      sym__qualified_constructor,
    STATE(3740), 1,
      sym__exp_parens,
    STATE(3781), 1,
      sym_integer,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10370), 1,
      aux_sym__qualifying_module,
    ACTIONS(563), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(567), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5959), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3733), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [307838] = 3,
    ACTIONS(5660), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5662), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [307882] = 3,
    ACTIONS(5656), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5658), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [307926] = 3,
    ACTIONS(5652), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5654), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [307970] = 3,
    ACTIONS(5652), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5654), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [308014] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1335), 1,
      sym__integer_literal,
    ACTIONS(5965), 1,
      sym_name,
    STATE(606), 1,
      sym__paren_open,
    STATE(2754), 1,
      sym__qualified_constructor,
    STATE(2779), 1,
      sym__exp_parens,
    STATE(2781), 1,
      sym_integer,
    STATE(2795), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10311), 1,
      aux_sym__qualifying_module,
    ACTIONS(1333), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1337), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5963), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(2778), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [308082] = 3,
    ACTIONS(5616), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5618), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [308126] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4743), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [308170] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4857), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [308214] = 3,
    ACTIONS(4697), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4699), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [308258] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4719), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [308302] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1203), 1,
      sym__integer_literal,
    ACTIONS(5969), 1,
      sym_name,
    STATE(639), 1,
      sym__paren_open,
    STATE(3541), 1,
      sym__qualified_variable,
    STATE(3661), 1,
      sym__exp_parens,
    STATE(3666), 1,
      sym_integer,
    STATE(3669), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10302), 1,
      aux_sym__qualifying_module,
    ACTIONS(1201), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1205), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5967), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3660), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [308370] = 3,
    ACTIONS(5572), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5574), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [308414] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [308464] = 3,
    ACTIONS(5568), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5570), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [308508] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4703), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [308552] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4763), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [308596] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4763), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [308640] = 3,
    ACTIONS(5451), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5453), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [308684] = 3,
    ACTIONS(3005), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(3007), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [308728] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(765), 1,
      sym__integer_literal,
    ACTIONS(5973), 1,
      sym_name,
    STATE(633), 1,
      sym__paren_open,
    STATE(4062), 1,
      sym__qualified_constructor,
    STATE(4125), 1,
      sym__exp_parens,
    STATE(4148), 1,
      sym_integer,
    STATE(4219), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10372), 1,
      aux_sym__qualifying_module,
    ACTIONS(763), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(767), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5971), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4122), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [308796] = 3,
    ACTIONS(5608), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5610), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [308840] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3119), 1,
      sym__integer_literal,
    ACTIONS(5977), 1,
      sym_name,
    STATE(591), 1,
      sym__paren_open,
    STATE(7489), 1,
      sym__qualified_constructor,
    STATE(7536), 1,
      sym__qualified_variable,
    STATE(7542), 1,
      sym_integer,
    STATE(7546), 1,
      sym__exp_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10595), 1,
      aux_sym__qualifying_module,
    ACTIONS(3117), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3121), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5975), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7540), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [308908] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1879), 1,
      sym__integer_literal,
    ACTIONS(5981), 1,
      sym_name,
    STATE(615), 1,
      sym__paren_open,
    STATE(5925), 1,
      sym_integer,
    STATE(5978), 1,
      sym__qualified_constructor,
    STATE(5981), 1,
      sym__qualified_variable,
    STATE(6017), 1,
      sym__exp_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10520), 1,
      aux_sym__qualifying_module,
    ACTIONS(1877), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1881), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5979), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6018), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [308976] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1919), 1,
      sym__integer_literal,
    ACTIONS(5985), 1,
      sym_name,
    STATE(599), 1,
      sym__paren_open,
    STATE(5902), 1,
      sym_integer,
    STATE(5918), 1,
      sym__exp_parens,
    STATE(5954), 1,
      sym__qualified_constructor,
    STATE(5955), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10617), 1,
      aux_sym__qualifying_module,
    ACTIONS(1917), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1921), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5983), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5919), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [309044] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4825), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [309088] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4743), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [309132] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1681), 1,
      sym__integer_literal,
    ACTIONS(5989), 1,
      sym_name,
    STATE(605), 1,
      sym__paren_open,
    STATE(3442), 1,
      sym__exp_parens,
    STATE(3509), 1,
      sym_integer,
    STATE(3560), 1,
      sym__qualified_variable,
    STATE(3563), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10310), 1,
      aux_sym__qualifying_module,
    ACTIONS(1679), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1683), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5987), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3447), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [309200] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4767), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [309244] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4849), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [309288] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [309332] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4817), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [309376] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4735), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [309420] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4723), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [309464] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5435), 1,
      sym__integer_literal,
    ACTIONS(5993), 1,
      sym_name,
    STATE(619), 1,
      sym__paren_open,
    STATE(7890), 1,
      sym__qualified_variable,
    STATE(7892), 1,
      sym__qualified_constructor,
    STATE(7893), 1,
      sym_integer,
    STATE(7958), 1,
      sym__exp_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10654), 1,
      aux_sym__qualifying_module,
    ACTIONS(5433), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5437), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5991), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7956), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [309532] = 3,
    ACTIONS(5604), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5606), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [309576] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4845), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [309620] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4781), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [309664] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4739), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [309708] = 3,
    ACTIONS(5612), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5614), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [309752] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4789), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [309796] = 15,
    ACTIONS(309), 1,
      sym__integer_literal,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5997), 1,
      sym_name,
    STATE(592), 1,
      sym__paren_open,
    STATE(2717), 1,
      sym__qualified_variable,
    STATE(2719), 1,
      sym__exp_parens,
    STATE(2734), 1,
      sym_integer,
    STATE(2750), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10581), 1,
      aux_sym__qualifying_module,
    ACTIONS(307), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(311), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5995), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(2691), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [309864] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4751), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [309908] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4755), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [309952] = 3,
    ACTIONS(5644), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5646), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [309996] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [310040] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2745), 1,
      sym__integer_literal,
    ACTIONS(6001), 1,
      sym_name,
    STATE(645), 1,
      sym__paren_open,
    STATE(6857), 1,
      sym__qualified_variable,
    STATE(6874), 1,
      sym__qualified_constructor,
    STATE(6879), 1,
      sym__exp_parens,
    STATE(6887), 1,
      sym_integer,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10814), 1,
      aux_sym__qualifying_module,
    ACTIONS(2743), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2747), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(5999), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6878), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [310108] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4759), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [310152] = 3,
    ACTIONS(4807), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4809), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [310196] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4685), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [310240] = 3,
    ACTIONS(5628), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5630), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [310284] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4813), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [310328] = 3,
    ACTIONS(5469), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5471), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [310372] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4821), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [310416] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4785), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [310460] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2003), 1,
      sym__integer_literal,
    ACTIONS(6005), 1,
      sym_name,
    STATE(596), 1,
      sym__paren_open,
    STATE(6253), 1,
      sym__exp_parens,
    STATE(6258), 1,
      sym_integer,
    STATE(6396), 1,
      sym__qualified_variable,
    STATE(6413), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10703), 1,
      aux_sym__qualifying_module,
    ACTIONS(2001), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2005), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6003), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6251), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [310528] = 3,
    ACTIONS(5628), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5630), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [310572] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4630), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [310622] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4793), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [310666] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4793), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [310710] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4833), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [310754] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4809), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [310798] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1641), 1,
      sym__integer_literal,
    ACTIONS(6009), 1,
      sym_name,
    STATE(616), 1,
      sym__paren_open,
    STATE(3312), 1,
      sym__qualified_constructor,
    STATE(3315), 1,
      sym__qualified_variable,
    STATE(3330), 1,
      sym_integer,
    STATE(3344), 1,
      sym__exp_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10553), 1,
      aux_sym__qualifying_module,
    ACTIONS(1639), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1643), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6007), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3351), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [310866] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1021), 1,
      sym__integer_literal,
    ACTIONS(6013), 1,
      sym_name,
    STATE(601), 1,
      sym__paren_open,
    STATE(4610), 1,
      sym__qualified_constructor,
    STATE(4614), 1,
      sym__qualified_variable,
    STATE(4663), 1,
      sym__exp_parens,
    STATE(4690), 1,
      sym_integer,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10578), 1,
      aux_sym__qualifying_module,
    ACTIONS(1019), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1023), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6011), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4662), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [310934] = 3,
    ACTIONS(4737), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4739), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [310978] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4759), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [311022] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [311072] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(721), 1,
      sym__integer_literal,
    ACTIONS(6017), 1,
      sym_name,
    STATE(590), 1,
      sym__paren_open,
    STATE(3934), 1,
      sym__qualified_variable,
    STATE(4182), 1,
      sym__exp_parens,
    STATE(4193), 1,
      sym_integer,
    STATE(4205), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10136), 1,
      aux_sym__qualifying_module,
    ACTIONS(719), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(723), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6015), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4180), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [311140] = 3,
    ACTIONS(4847), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4849), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [311184] = 3,
    ACTIONS(5047), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5049), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [311228] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4707), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [311272] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4755), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [311316] = 3,
    ACTIONS(5628), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5630), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [311360] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1141), 1,
      sym__integer_literal,
    ACTIONS(6021), 1,
      sym_name,
    STATE(594), 1,
      sym__paren_open,
    STATE(2318), 1,
      sym_integer,
    STATE(2322), 1,
      sym__exp_parens,
    STATE(2354), 1,
      sym__qualified_constructor,
    STATE(2359), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10342), 1,
      aux_sym__qualifying_module,
    ACTIONS(1139), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1143), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6019), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(2321), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [311428] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4711), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [311472] = 3,
    ACTIONS(4705), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4707), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [311516] = 5,
    ACTIONS(4745), 2,
      anon_sym_EQ,
      anon_sym_POUND,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4747), 13,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [311564] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4707), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [311608] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1581), 1,
      sym__integer_literal,
    ACTIONS(6025), 1,
      sym_name,
    STATE(631), 1,
      sym__paren_open,
    STATE(3266), 1,
      sym__qualified_constructor,
    STATE(3267), 1,
      sym__qualified_variable,
    STATE(3389), 1,
      sym__exp_parens,
    STATE(3397), 1,
      sym_integer,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10323), 1,
      aux_sym__qualifying_module,
    ACTIONS(1579), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1583), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6023), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3388), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [311676] = 3,
    ACTIONS(4855), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4857), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [311720] = 5,
    ACTIONS(4745), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4747), 13,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      anon_sym_u2192,
      aux_sym__paren_close_token1,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [311768] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [311812] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [311856] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4837), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [311900] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2167), 1,
      sym__integer_literal,
    ACTIONS(6029), 1,
      sym_name,
    STATE(613), 1,
      sym__paren_open,
    STATE(6269), 1,
      sym_integer,
    STATE(6270), 1,
      sym__exp_parens,
    STATE(6308), 1,
      sym__qualified_variable,
    STATE(6309), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10502), 1,
      aux_sym__qualifying_module,
    ACTIONS(2165), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2169), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6027), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6272), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [311968] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4685), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [312012] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4695), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [312056] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [312100] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1355), 1,
      sym__integer_literal,
    ACTIONS(6033), 1,
      sym_name,
    STATE(646), 1,
      sym__paren_open,
    STATE(3052), 1,
      sym__exp_parens,
    STATE(3104), 1,
      sym__qualified_constructor,
    STATE(3116), 1,
      sym__qualified_variable,
    STATE(3118), 1,
      sym_integer,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10315), 1,
      aux_sym__qualifying_module,
    ACTIONS(1353), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1357), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6031), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3122), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [312168] = 3,
    ACTIONS(5652), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5654), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [312212] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [312256] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4747), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [312300] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [312344] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4797), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [312388] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [312432] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4781), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [312476] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4723), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [312520] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4681), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [312564] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2317), 1,
      sym__integer_literal,
    ACTIONS(6037), 1,
      sym_name,
    STATE(588), 1,
      sym__paren_open,
    STATE(6486), 1,
      sym__qualified_constructor,
    STATE(6487), 1,
      sym__qualified_variable,
    STATE(6511), 1,
      sym__exp_parens,
    STATE(6535), 1,
      sym_integer,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10329), 1,
      aux_sym__qualifying_module,
    ACTIONS(2315), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2319), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6035), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6508), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [312632] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3483), 1,
      sym__integer_literal,
    ACTIONS(6041), 1,
      sym_name,
    STATE(634), 1,
      sym__paren_open,
    STATE(7153), 1,
      sym__qualified_variable,
    STATE(7189), 1,
      sym__qualified_constructor,
    STATE(7194), 1,
      sym__exp_parens,
    STATE(7199), 1,
      sym_integer,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10761), 1,
      aux_sym__qualifying_module,
    ACTIONS(3481), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3485), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6039), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7192), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [312700] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4699), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [312744] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [312788] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [312832] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [312876] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [312920] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4845), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [312964] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4833), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [313008] = 15,
    ACTIONS(155), 1,
      sym__integer_literal,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6045), 1,
      sym_name,
    STATE(628), 1,
      sym__paren_open,
    STATE(3685), 1,
      sym__qualified_constructor,
    STATE(3690), 1,
      sym_integer,
    STATE(3734), 1,
      sym__exp_parens,
    STATE(3784), 1,
      sym__qualified_variable,
    STATE(10070), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(153), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(157), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6043), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3744), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [313076] = 3,
    ACTIONS(4773), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4775), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [313120] = 3,
    ACTIONS(4851), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4853), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [313164] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4731), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [313208] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4767), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [313252] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4727), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [313296] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [313340] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4817), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [313384] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [313428] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [313472] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2773), 1,
      sym__integer_literal,
    ACTIONS(6049), 1,
      sym_name,
    STATE(642), 1,
      sym__paren_open,
    STATE(7034), 1,
      sym__exp_parens,
    STATE(7036), 1,
      sym_integer,
    STATE(7084), 1,
      sym__qualified_constructor,
    STATE(7111), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10317), 1,
      aux_sym__qualifying_module,
    ACTIONS(2771), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2775), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6047), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7033), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [313540] = 3,
    ACTIONS(4753), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4755), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [313584] = 3,
    ACTIONS(4749), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4751), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [313628] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4614), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [313678] = 3,
    ACTIONS(4827), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4829), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [313722] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4743), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [313766] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4719), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [313810] = 3,
    ACTIONS(4787), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4789), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [313854] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4703), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [313898] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1093), 1,
      sym__integer_literal,
    ACTIONS(6053), 1,
      sym_name,
    STATE(598), 1,
      sym__paren_open,
    STATE(5071), 1,
      sym__exp_parens,
    STATE(5072), 1,
      sym__qualified_variable,
    STATE(5073), 1,
      sym__qualified_constructor,
    STATE(5084), 1,
      sym_integer,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10355), 1,
      aux_sym__qualifying_module,
    ACTIONS(1091), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1095), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6051), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5070), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [313966] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4861), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [314010] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4849), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [314054] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4763), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [314098] = 3,
    ACTIONS(5624), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5626), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [314142] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4699), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [314186] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4715), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [314230] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2793), 1,
      sym__integer_literal,
    ACTIONS(6057), 1,
      sym_name,
    STATE(626), 1,
      sym__paren_open,
    STATE(7060), 1,
      sym__qualified_variable,
    STATE(7061), 1,
      sym__qualified_constructor,
    STATE(7125), 1,
      sym__exp_parens,
    STATE(7159), 1,
      sym_integer,
    STATE(10016), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(2791), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2795), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6055), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7123), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [314298] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2619), 1,
      sym__integer_literal,
    ACTIONS(6061), 1,
      sym_name,
    STATE(632), 1,
      sym__paren_open,
    STATE(6697), 1,
      sym__exp_parens,
    STATE(6710), 1,
      sym_integer,
    STATE(6722), 1,
      sym__qualified_variable,
    STATE(6723), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10320), 1,
      aux_sym__qualifying_module,
    ACTIONS(2617), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2621), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6059), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6712), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [314366] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4711), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [314410] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [314460] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1621), 1,
      sym__integer_literal,
    ACTIONS(6065), 1,
      sym_name,
    STATE(640), 1,
      sym__paren_open,
    STATE(3190), 1,
      sym__qualified_constructor,
    STATE(3193), 1,
      sym__qualified_variable,
    STATE(3251), 1,
      sym__exp_parens,
    STATE(3269), 1,
      sym_integer,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10318), 1,
      aux_sym__qualifying_module,
    ACTIONS(1619), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1623), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6063), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3250), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [314528] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [314572] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4775), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [314616] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [314660] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [314704] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4695), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [314748] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4809), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [314792] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1899), 1,
      sym__integer_literal,
    ACTIONS(6069), 1,
      sym_name,
    STATE(607), 1,
      sym__paren_open,
    STATE(5957), 1,
      sym__exp_parens,
    STATE(6013), 1,
      sym_integer,
    STATE(6022), 1,
      sym__qualified_constructor,
    STATE(6051), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10641), 1,
      aux_sym__qualifying_module,
    ACTIONS(1897), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1901), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6067), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6033), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [314860] = 3,
    ACTIONS(4683), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4685), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [314904] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3515), 1,
      sym__integer_literal,
    ACTIONS(6073), 1,
      sym_name,
    STATE(602), 1,
      sym__paren_open,
    STATE(7387), 1,
      sym_integer,
    STATE(7391), 1,
      sym__qualified_constructor,
    STATE(7441), 1,
      sym__exp_parens,
    STATE(7475), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10397), 1,
      aux_sym__qualifying_module,
    ACTIONS(3513), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3517), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6071), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7442), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [314972] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4715), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [315016] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(379), 1,
      sym__integer_literal,
    ACTIONS(6077), 1,
      sym_name,
    STATE(637), 1,
      sym__paren_open,
    STATE(3475), 1,
      sym__qualified_constructor,
    STATE(3537), 1,
      sym_integer,
    STATE(3545), 1,
      sym__exp_parens,
    STATE(3566), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10853), 1,
      aux_sym__qualifying_module,
    ACTIONS(377), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(381), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6075), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3547), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [315084] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4634), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [315134] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4681), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [315178] = 15,
    ACTIONS(63), 1,
      sym__integer_literal,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6081), 1,
      sym_name,
    STATE(593), 1,
      sym__paren_open,
    STATE(3234), 1,
      sym__qualified_constructor,
    STATE(3242), 1,
      sym_integer,
    STATE(3257), 1,
      sym__exp_parens,
    STATE(3353), 1,
      sym__qualified_variable,
    STATE(10062), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(61), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(65), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6079), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3261), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [315246] = 3,
    ACTIONS(4859), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4861), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [315290] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4821), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [315334] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4711), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [315378] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(677), 1,
      sym__integer_literal,
    ACTIONS(6085), 1,
      sym_name,
    STATE(635), 1,
      sym__paren_open,
    STATE(3954), 1,
      sym__qualified_variable,
    STATE(4042), 1,
      sym__qualified_constructor,
    STATE(4053), 1,
      sym__exp_parens,
    STATE(4067), 1,
      sym_integer,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10843), 1,
      aux_sym__qualifying_module,
    ACTIONS(675), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(679), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6083), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4040), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [315446] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(3215), 1,
      sym__integer_literal,
    ACTIONS(6089), 1,
      sym_name,
    STATE(627), 1,
      sym__paren_open,
    STATE(7563), 1,
      sym__exp_parens,
    STATE(7595), 1,
      sym_integer,
    STATE(7611), 1,
      sym__qualified_variable,
    STATE(7616), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10739), 1,
      aux_sym__qualifying_module,
    ACTIONS(3213), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3217), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6087), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7568), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [315514] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(1385), 1,
      sym__integer_literal,
    ACTIONS(6093), 1,
      sym_name,
    STATE(595), 1,
      sym__paren_open,
    STATE(3849), 1,
      sym__exp_parens,
    STATE(3860), 1,
      sym__qualified_variable,
    STATE(3886), 1,
      sym_integer,
    STATE(3928), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10649), 1,
      aux_sym__qualifying_module,
    ACTIONS(1383), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1387), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6091), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3848), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [315582] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [315626] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4861), 26,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [315670] = 3,
    ACTIONS(4823), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4825), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [315714] = 3,
    ACTIONS(4757), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4759), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [315758] = 3,
    ACTIONS(4783), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4785), 28,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_qualified_op,
      sym__cond_no_section_op,
      sym__consym,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      sym_name,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [315802] = 15,
    ACTIONS(317), 1,
      aux_sym__paren_open_token1,
    ACTIONS(2935), 1,
      sym__integer_literal,
    ACTIONS(6097), 1,
      sym_name,
    STATE(604), 1,
      sym__paren_open,
    STATE(7218), 1,
      sym__qualified_variable,
    STATE(7352), 1,
      sym__qualified_constructor,
    STATE(7361), 1,
      sym_integer,
    STATE(7366), 1,
      sym__exp_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10540), 1,
      aux_sym__qualifying_module,
    ACTIONS(2933), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(2937), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(6095), 3,
      sym_variable,
      sym_implicit_variable,
      sym_label,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7365), 13,
      sym__splice_exp,
      sym_literal,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [315870] = 19,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5819), 1,
      sym__cond_infix,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(10065), 1,
      sym__forall_body,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10291), 1,
      sym__type_instance_common,
    STATE(10413), 1,
      sym__layout_end,
    STATE(10611), 1,
      sym__type_instance,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6099), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    STATE(8083), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [315945] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4775), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [315988] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4849), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [316031] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4731), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [316074] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [316117] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [316160] = 19,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5819), 1,
      sym__cond_infix,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(10065), 1,
      sym__forall_body,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10276), 1,
      sym__layout_end,
    STATE(10291), 1,
      sym__type_instance_common,
    STATE(10611), 1,
      sym__type_instance,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6101), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    STATE(8083), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [316235] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4711), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [316278] = 5,
    ACTIONS(6105), 1,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(6103), 5,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
    ACTIONS(4841), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [316325] = 5,
    ACTIONS(6109), 1,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(6107), 5,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
    ACTIONS(4841), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [316372] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [316415] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4699), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [316458] = 19,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5819), 1,
      sym__cond_infix,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(10065), 1,
      sym__forall_body,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10287), 1,
      sym__layout_end,
    STATE(10291), 1,
      sym__type_instance_common,
    STATE(10611), 1,
      sym__type_instance,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6111), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    STATE(8083), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [316533] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4727), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [316576] = 5,
    ACTIONS(4745), 2,
      anon_sym_POUND,
      anon_sym_where,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4747), 12,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [316623] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4785), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [316666] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [316709] = 19,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5819), 1,
      sym__cond_infix,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(10065), 1,
      sym__forall_body,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10281), 1,
      sym__layout_end,
    STATE(10291), 1,
      sym__type_instance_common,
    STATE(10611), 1,
      sym__type_instance,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6113), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    STATE(8083), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [316784] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4797), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [316827] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4829), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [316870] = 6,
    ACTIONS(5802), 1,
      aux_sym__paren_close_token1,
    ACTIONS(5804), 1,
      anon_sym_POUND2,
    ACTIONS(5806), 1,
      anon_sym_PIPE2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5792), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_forall,
      anon_sym_PIPE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5790), 22,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_context,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u2200,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [316919] = 19,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5819), 1,
      sym__cond_infix,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(10065), 1,
      sym__forall_body,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10291), 1,
      sym__type_instance_common,
    STATE(10444), 1,
      sym__layout_end,
    STATE(10611), 1,
      sym__type_instance,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6115), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    STATE(8083), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [316994] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5640), 7,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_forall,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(5642), 24,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_qual_dot,
      sym__cond_prefix_dot,
      sym__cond_context,
      sym__cond_infix,
      sym__varsym,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2200,
      anon_sym_DASH_GT,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_POUND2,
      sym_implicit_variable,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [317037] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4707), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [317080] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [317123] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4723), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [317166] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4837), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [317209] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4853), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [317252] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4793), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [317295] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4817), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [317338] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4763), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [317381] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4833), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [317424] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [317467] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [317510] = 19,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5819), 1,
      sym__cond_infix,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(10065), 1,
      sym__forall_body,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10291), 1,
      sym__type_instance_common,
    STATE(10603), 1,
      sym__layout_end,
    STATE(10611), 1,
      sym__type_instance,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(6117), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    STATE(8083), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [317585] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4685), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [317628] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4747), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [317671] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [317714] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4857), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [317757] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4703), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [317800] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [317843] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [317886] = 8,
    ACTIONS(5792), 1,
      anon_sym_PIPE,
    ACTIONS(5797), 1,
      anon_sym_POUND2,
    ACTIONS(5799), 1,
      anon_sym_PIPE2,
    ACTIONS(5802), 1,
      aux_sym__paren_close_token1,
    ACTIONS(5790), 2,
      anon_sym_COMMA,
      anon_sym_POUND_RPAREN,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5787), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5794), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [317939] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4719), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [317982] = 20,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6119), 1,
      anon_sym_instance,
    ACTIONS(6121), 1,
      sym_name,
    ACTIONS(6123), 1,
      sym__cond_context,
    ACTIONS(6125), 1,
      sym__cond_infix,
    STATE(1838), 1,
      sym__type_instance_head_params,
    STATE(5961), 1,
      sym__paren_open,
    STATE(7691), 1,
      sym__type_instance_head_parens,
    STATE(7697), 1,
      sym__qualified_type,
    STATE(8102), 1,
      sym_context,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10148), 1,
      sym__forall_body,
    STATE(10265), 1,
      sym__inst_adt,
    STATE(10999), 1,
      sym__context_inline,
    STATE(11213), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(8017), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7689), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [318059] = 20,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6123), 1,
      sym__cond_context,
    ACTIONS(6127), 1,
      anon_sym_instance,
    ACTIONS(6129), 1,
      sym_name,
    ACTIONS(6131), 1,
      sym__cond_infix,
    STATE(2036), 1,
      sym__type_instance_head_params,
    STATE(6034), 1,
      sym__paren_open,
    STATE(8018), 1,
      sym__type_instance_head_parens,
    STATE(8030), 1,
      sym__qualified_type,
    STATE(8125), 1,
      sym_context,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10148), 1,
      sym__forall_body,
    STATE(10264), 1,
      sym__inst_newtype,
    STATE(10999), 1,
      sym__context_inline,
    STATE(11124), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(8028), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8014), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [318136] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4789), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [318179] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4841), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [318222] = 5,
    ACTIONS(6135), 1,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(6133), 5,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
    ACTIONS(4841), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [318269] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4861), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [318312] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4735), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [318355] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4743), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [318398] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4681), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [318441] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4751), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [318484] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4813), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [318527] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4739), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [318570] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6137), 9,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6139), 22,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [318613] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4759), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [318656] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4695), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [318699] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4755), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [318742] = 5,
    ACTIONS(6143), 1,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(6141), 5,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
    ACTIONS(4841), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [318789] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4825), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [318832] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4715), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [318875] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4845), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [318918] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4809), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [318961] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4781), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [319004] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4767), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [319047] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4821), 25,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [319090] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [319132] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [319174] = 19,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6123), 1,
      sym__cond_context,
    ACTIONS(6129), 1,
      sym_name,
    ACTIONS(6131), 1,
      sym__cond_infix,
    STATE(2036), 1,
      sym__type_instance_head_params,
    STATE(6034), 1,
      sym__paren_open,
    STATE(8018), 1,
      sym__type_instance_head_parens,
    STATE(8030), 1,
      sym__qualified_type,
    STATE(8125), 1,
      sym_context,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10148), 1,
      sym__forall_body,
    STATE(10750), 1,
      sym__inst_newtype,
    STATE(10999), 1,
      sym__context_inline,
    STATE(11124), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(8028), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8014), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [319248] = 19,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6121), 1,
      sym_name,
    ACTIONS(6123), 1,
      sym__cond_context,
    ACTIONS(6125), 1,
      sym__cond_infix,
    STATE(1838), 1,
      sym__type_instance_head_params,
    STATE(5961), 1,
      sym__paren_open,
    STATE(7691), 1,
      sym__type_instance_head_parens,
    STATE(7697), 1,
      sym__qualified_type,
    STATE(8102), 1,
      sym_context,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10148), 1,
      sym__forall_body,
    STATE(10753), 1,
      sym__inst_adt,
    STATE(10999), 1,
      sym__context_inline,
    STATE(11213), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(8017), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7689), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [319322] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4853), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [319364] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4837), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [319406] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4763), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [319448] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4759), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [319490] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4755), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [319532] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4719), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [319574] = 7,
    ACTIONS(4434), 1,
      aux_sym__paren_close_token1,
    STATE(1448), 1,
      sym__colon2,
    STATE(8071), 1,
      sym__paren_close,
    ACTIONS(6145), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [319624] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4685), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [319666] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4727), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [319708] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4751), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [319750] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4606), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [319792] = 19,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6123), 1,
      sym__cond_context,
    ACTIONS(6129), 1,
      sym_name,
    ACTIONS(6131), 1,
      sym__cond_infix,
    STATE(2036), 1,
      sym__type_instance_head_params,
    STATE(6034), 1,
      sym__paren_open,
    STATE(8018), 1,
      sym__type_instance_head_parens,
    STATE(8030), 1,
      sym__qualified_type,
    STATE(8125), 1,
      sym_context,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10148), 1,
      sym__forall_body,
    STATE(10518), 1,
      sym__inst_newtype,
    STATE(10999), 1,
      sym__context_inline,
    STATE(11124), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(8028), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8014), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [319866] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4747), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [319908] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4735), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [319950] = 5,
    ACTIONS(4745), 2,
      anon_sym_POUND,
      anon_sym_where,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4747), 11,
      sym__phantom_where,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [319996] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4857), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [320038] = 26,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6147), 1,
      sym_name,
    ACTIONS(6149), 1,
      sym__cond_context,
    ACTIONS(6151), 1,
      sym__cond_data_infix,
    STATE(834), 1,
      sym__paren_open,
    STATE(870), 1,
      sym__unboxed_open,
    STATE(8150), 1,
      sym_context,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(8853), 1,
      sym_data_constructor,
    STATE(9013), 1,
      sym__datacon_special,
    STATE(9014), 1,
      sym__datacon_unboxed_sum,
    STATE(9017), 1,
      sym__datacon_record,
    STATE(9019), 1,
      sym__datacon_infix,
    STATE(9031), 1,
      sym__datacon_prefix,
    STATE(9038), 1,
      sym__type_unboxed_tuple,
    STATE(9039), 1,
      sym__type_tuple,
    STATE(9545), 1,
      sym_data_constructors,
    STATE(10061), 1,
      sym__context_inline,
    STATE(10303), 1,
      sym__forall_body,
    STATE(11600), 1,
      sym__bracket_open,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(1842), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(8061), 2,
      sym_forall,
      sym_forall_required,
    STATE(8980), 3,
      sym__plist,
      sym_unit,
      sym_unboxed_unit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [320126] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4793), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [320168] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4723), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [320210] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4785), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [320252] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4833), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [320294] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4841), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [320336] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4845), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [320378] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4703), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [320420] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4781), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [320462] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4695), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [320504] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4797), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [320546] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4775), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [320588] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4813), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [320630] = 19,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5819), 1,
      sym__cond_infix,
    ACTIONS(6153), 1,
      anon_sym_SEMI,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(9499), 1,
      aux_sym__let_binds_repeat1,
    STATE(10065), 1,
      sym__forall_body,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10291), 1,
      sym__type_instance_common,
    STATE(10602), 1,
      sym__type_instance,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(8083), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [320704] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [320746] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4707), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [320788] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [320830] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4821), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [320872] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4711), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [320914] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4699), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [320956] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4739), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [320998] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6155), 9,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6157), 21,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [321040] = 7,
    ACTIONS(4438), 1,
      aux_sym__paren_close_token1,
    STATE(1438), 1,
      sym__colon2,
    STATE(7662), 1,
      sym__paren_close,
    ACTIONS(6159), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [321090] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4767), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [321132] = 19,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5819), 1,
      sym__cond_infix,
    ACTIONS(6153), 1,
      anon_sym_SEMI,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(9274), 1,
      sym__type_instance,
    STATE(9499), 1,
      aux_sym__let_binds_repeat1,
    STATE(10065), 1,
      sym__forall_body,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10291), 1,
      sym__type_instance_common,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(8083), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [321206] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4829), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [321248] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4681), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [321290] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [321332] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [321374] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4731), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [321416] = 19,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6121), 1,
      sym_name,
    ACTIONS(6123), 1,
      sym__cond_context,
    ACTIONS(6125), 1,
      sym__cond_infix,
    STATE(1838), 1,
      sym__type_instance_head_params,
    STATE(5961), 1,
      sym__paren_open,
    STATE(7691), 1,
      sym__type_instance_head_parens,
    STATE(7697), 1,
      sym__qualified_type,
    STATE(8102), 1,
      sym_context,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10148), 1,
      sym__forall_body,
    STATE(10555), 1,
      sym__inst_adt,
    STATE(10999), 1,
      sym__context_inline,
    STATE(11213), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(8017), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7689), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [321490] = 7,
    ACTIONS(4473), 1,
      aux_sym__paren_close_token1,
    STATE(1459), 1,
      sym__colon2,
    STATE(8031), 1,
      sym__paren_close,
    ACTIONS(6161), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [321540] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4825), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [321582] = 25,
    ACTIONS(5527), 1,
      sym_variable,
    ACTIONS(5529), 1,
      anon_sym__,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5537), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6163), 1,
      anon_sym_instance,
    ACTIONS(6165), 1,
      anon_sym_family,
    ACTIONS(6167), 1,
      sym_name,
    ACTIONS(6169), 1,
      sym__cond_context,
    STATE(5426), 1,
      sym__paren_open,
    STATE(7725), 1,
      sym__type_head_params,
    STATE(7974), 1,
      sym_context,
    STATE(8042), 1,
      sym_type_param,
    STATE(8280), 1,
      sym__type_head_infix,
    STATE(8355), 1,
      sym__type_head_parens,
    STATE(8380), 1,
      sym__plist,
    STATE(8381), 1,
      sym__type_head_name,
    STATE(8677), 1,
      sym__type_param_invisible,
    STATE(8807), 1,
      sym__prefix_at,
    STATE(9618), 1,
      sym__context_inline,
    STATE(10198), 1,
      sym__data,
    STATE(12129), 1,
      sym__bracket_open,
    STATE(8679), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8382), 6,
      sym_unit,
      sym__tycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__consym_prefix,
      sym__pconsym,
  [321668] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4789), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [321710] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4809), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [321752] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4861), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [321794] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4801), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [321836] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4691), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [321878] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4715), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [321920] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4805), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [321962] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4849), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [322004] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4743), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [322046] = 7,
    ACTIONS(3411), 1,
      aux_sym__paren_close_token1,
    STATE(1518), 1,
      sym__colon2,
    STATE(8052), 1,
      sym__paren_close,
    ACTIONS(6171), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [322096] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
      anon_sym_where,
    ACTIONS(4817), 24,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [322138] = 7,
    ACTIONS(4469), 1,
      aux_sym__paren_close_token1,
    STATE(1566), 1,
      sym__colon2,
    STATE(7984), 1,
      sym__paren_close,
    ACTIONS(6173), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [322188] = 4,
    ACTIONS(6107), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [322231] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4767), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [322272] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4743), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [322313] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4624), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4626), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [322360] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4592), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [322421] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4719), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [322462] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4821), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [322503] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4703), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [322544] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4763), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [322585] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4699), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [322626] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4735), 23,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [322667] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4727), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [322708] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4580), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [322769] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4685), 23,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [322810] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4614), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [322857] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [322898] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4715), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [322939] = 4,
    ACTIONS(6141), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [322982] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4632), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4634), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [323029] = 6,
    ACTIONS(6175), 1,
      anon_sym_PIPE,
    ACTIONS(6178), 1,
      anon_sym_PIPE2,
    STATE(7640), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5821), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5823), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [323076] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6181), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6183), 23,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [323117] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [323158] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6185), 9,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6187), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [323199] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4731), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [323240] = 4,
    ACTIONS(6103), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [323283] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4817), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [323324] = 18,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6123), 1,
      sym__cond_context,
    ACTIONS(6189), 1,
      sym_name,
    ACTIONS(6191), 1,
      sym__cond_infix,
    STATE(2147), 1,
      sym__type_instance_head_params,
    STATE(6029), 1,
      sym__paren_open,
    STATE(8001), 1,
      sym__qualified_type,
    STATE(8004), 1,
      sym__type_instance_head_parens,
    STATE(8110), 1,
      sym_context,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10148), 1,
      sym__forall_body,
    STATE(10999), 1,
      sym__context_inline,
    STATE(11000), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(8015), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7991), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [323395] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4781), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [323436] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6193), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6195), 23,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [323477] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4861), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [323518] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4849), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [323559] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4695), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [323600] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4739), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [323641] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4837), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [323682] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [323723] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4681), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [323764] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4857), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [323805] = 5,
    ACTIONS(6199), 1,
      anon_sym_COMMA,
    STATE(7658), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6197), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6202), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
      anon_sym_POUND_RPAREN,
  [323850] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [323891] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4853), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [323932] = 5,
    ACTIONS(4745), 1,
      anon_sym_POUND,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4747), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [323977] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6204), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6206), 23,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [324018] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6208), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6210), 23,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [324059] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [324100] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4747), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [324141] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4793), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [324182] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4566), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [324243] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4829), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [324284] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4592), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [324345] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [324386] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4566), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [324447] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4711), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [324488] = 9,
    ACTIONS(4582), 1,
      anon_sym_DASH_GT,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4584), 22,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [324541] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6212), 9,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6214), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [324582] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4825), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [324623] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4833), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [324664] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4813), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [324705] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4759), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [324746] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4785), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [324787] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4775), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [324828] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4837), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [324869] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5640), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_forall,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5642), 24,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_context,
      sym__consym,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u2200,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_POUND2,
      sym_implicit_variable,
      sym_name,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [324910] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4735), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [324951] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6216), 9,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6218), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [324992] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6220), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6222), 23,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [325033] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [325074] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4707), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [325115] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4588), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [325176] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5831), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(5833), 23,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [325217] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4845), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [325258] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6224), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6226), 23,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [325299] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6228), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6230), 23,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [325340] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6232), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6234), 23,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [325381] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4817), 23,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [325422] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4723), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [325463] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [325504] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4813), 23,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [325545] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6236), 9,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6238), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [325586] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4789), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [325627] = 25,
    ACTIONS(3557), 1,
      anon_sym_EQ,
    ACTIONS(3559), 1,
      anon_sym_deriving,
    ACTIONS(3565), 1,
      anon_sym_where,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6240), 1,
      sym_variable,
    ACTIONS(6244), 1,
      anon_sym__,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    STATE(1606), 1,
      sym__colon2,
    STATE(8059), 1,
      aux_sym_type_params_repeat1,
    STATE(8293), 1,
      sym_type_params,
    STATE(8360), 1,
      sym__type_param_invisible,
    STATE(8377), 1,
      sym_type_param,
    STATE(8631), 1,
      sym__paren_open,
    STATE(8835), 1,
      sym__prefix_at,
    STATE(8883), 1,
      sym__where,
    STATE(8994), 1,
      aux_sym__data_repeat1,
    STATE(8997), 1,
      sym__data_rhs,
    STATE(9555), 1,
      sym__gadt,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(3563), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    STATE(8359), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(6242), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [325712] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6248), 9,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6250), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [325753] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4695), 23,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [325794] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [325835] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4751), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [325876] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4809), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [325917] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4707), 23,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [325958] = 18,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6123), 1,
      sym__cond_context,
    ACTIONS(6252), 1,
      sym_name,
    ACTIONS(6254), 1,
      sym__cond_infix,
    STATE(2196), 1,
      sym__type_instance_head_params,
    STATE(6031), 1,
      sym__paren_open,
    STATE(8044), 1,
      sym__qualified_type,
    STATE(8070), 1,
      sym__type_instance_head_parens,
    STATE(8116), 1,
      sym_context,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10148), 1,
      sym__forall_body,
    STATE(10999), 1,
      sym__context_inline,
    STATE(11191), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(8020), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8068), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [326029] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4628), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4630), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [326076] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6256), 9,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3269), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [326117] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4793), 23,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [326158] = 4,
    ACTIONS(6133), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [326201] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(2109), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(2111), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [326242] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4596), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [326303] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4755), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [326344] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6258), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6260), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [326391] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [326432] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4695), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_PIPE,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [326473] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4685), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [326514] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4614), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [326561] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4837), 23,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [326602] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [326643] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4797), 24,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [326684] = 25,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6147), 1,
      sym_name,
    ACTIONS(6149), 1,
      sym__cond_context,
    ACTIONS(6151), 1,
      sym__cond_data_infix,
    STATE(834), 1,
      sym__paren_open,
    STATE(870), 1,
      sym__unboxed_open,
    STATE(8150), 1,
      sym_context,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(9013), 1,
      sym__datacon_special,
    STATE(9014), 1,
      sym__datacon_unboxed_sum,
    STATE(9017), 1,
      sym__datacon_record,
    STATE(9019), 1,
      sym__datacon_infix,
    STATE(9031), 1,
      sym__datacon_prefix,
    STATE(9038), 1,
      sym__type_unboxed_tuple,
    STATE(9039), 1,
      sym__type_tuple,
    STATE(9047), 1,
      sym_data_constructor,
    STATE(10061), 1,
      sym__context_inline,
    STATE(10303), 1,
      sym__forall_body,
    STATE(11600), 1,
      sym__bracket_open,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(1842), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(8061), 2,
      sym_forall,
      sym_forall_required,
    STATE(8980), 3,
      sym__plist,
      sym_unit,
      sym_unboxed_unit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [326769] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4769), 9,
      anon_sym_let,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4771), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [326810] = 25,
    ACTIONS(3557), 1,
      anon_sym_EQ,
    ACTIONS(3559), 1,
      anon_sym_deriving,
    ACTIONS(3565), 1,
      anon_sym_where,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6240), 1,
      sym_variable,
    ACTIONS(6244), 1,
      anon_sym__,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    STATE(1606), 1,
      sym__colon2,
    STATE(8059), 1,
      aux_sym_type_params_repeat1,
    STATE(8296), 1,
      sym_type_params,
    STATE(8360), 1,
      sym__type_param_invisible,
    STATE(8377), 1,
      sym_type_param,
    STATE(8631), 1,
      sym__paren_open,
    STATE(8835), 1,
      sym__prefix_at,
    STATE(8883), 1,
      sym__where,
    STATE(8953), 1,
      aux_sym__data_repeat1,
    STATE(9046), 1,
      sym__data_rhs,
    STATE(9555), 1,
      sym__gadt,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(3563), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    STATE(8359), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(6262), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [326895] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4775), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [326935] = 5,
    ACTIONS(5797), 1,
      anon_sym_POUND2,
    ACTIONS(6266), 1,
      anon_sym_PIPE2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6264), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5802), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [326979] = 17,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5819), 1,
      sym__cond_infix,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(10065), 1,
      sym__forall_body,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10291), 1,
      sym__type_instance_common,
    STATE(10611), 1,
      sym__type_instance,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(8083), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [327047] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4699), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [327087] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4829), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [327127] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4735), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [327167] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4785), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [327207] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4793), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [327247] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4861), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [327287] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4849), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [327327] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4789), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [327367] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(4628), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4630), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [327413] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4813), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [327453] = 20,
    ACTIONS(6268), 1,
      sym_variable,
    ACTIONS(6270), 1,
      anon_sym_COMMA,
    ACTIONS(6274), 1,
      anon_sym_module,
    ACTIONS(6276), 1,
      sym_name,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6280), 1,
      aux_sym__paren_close_token1,
    STATE(8147), 1,
      sym_namespace,
    STATE(8192), 1,
      sym__paren_open,
    STATE(8993), 1,
      sym__qualified_type,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(9981), 1,
      sym__qtyconid,
    STATE(9984), 1,
      sym__qvarid,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10831), 1,
      aux_sym__qualifying_module,
    STATE(10834), 1,
      sym__ie_entity,
    STATE(10839), 1,
      sym_module_export,
    STATE(11490), 1,
      sym__paren_close,
    ACTIONS(6272), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9980), 9,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
      sym__sym_prefix,
  [327527] = 5,
    ACTIONS(4745), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(4769), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4747), 9,
      sym__phantom_arrow,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      anon_sym_u2192,
    ACTIONS(4771), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [327571] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4695), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [327611] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4809), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [327651] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(4624), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4626), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [327697] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4761), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4763), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [327737] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4741), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4743), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [327777] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4765), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4767), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [327817] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4857), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [327857] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4853), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [327897] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5831), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(5833), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [327943] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4781), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [327983] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4745), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4747), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [328023] = 23,
    ACTIONS(5527), 1,
      sym_variable,
    ACTIONS(5529), 1,
      anon_sym__,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5535), 1,
      sym_name,
    ACTIONS(5537), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6282), 1,
      anon_sym_instance,
    ACTIONS(6284), 1,
      anon_sym_family,
    ACTIONS(6286), 1,
      anon_sym_role,
    ACTIONS(6288), 1,
      anon_sym_data,
    STATE(5147), 1,
      sym__paren_open,
    STATE(8040), 1,
      sym_type_param,
    STATE(8303), 1,
      sym__type_head_params,
    STATE(8677), 1,
      sym__type_param_invisible,
    STATE(8807), 1,
      sym__prefix_at,
    STATE(8975), 1,
      sym__plist,
    STATE(8978), 1,
      sym__type_head_parens,
    STATE(8979), 1,
      sym__type_head_name,
    STATE(10135), 1,
      sym__type_head_infix,
    STATE(11806), 1,
      sym__bracket_open,
    STATE(8679), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8988), 6,
      sym_unit,
      sym__tycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__consym_prefix,
      sym__pconsym,
  [328103] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [328149] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [328189] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4795), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4797), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [328229] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [328269] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4691), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [328309] = 23,
    ACTIONS(5527), 1,
      sym_variable,
    ACTIONS(5529), 1,
      anon_sym__,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5537), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6169), 1,
      sym__cond_context,
    ACTIONS(6290), 1,
      anon_sym_instance,
    ACTIONS(6292), 1,
      sym_name,
    STATE(5500), 1,
      sym__paren_open,
    STATE(7975), 1,
      sym_context,
    STATE(8045), 1,
      sym_type_param,
    STATE(8084), 1,
      sym__type_head_params,
    STATE(8677), 1,
      sym__type_param_invisible,
    STATE(8807), 1,
      sym__prefix_at,
    STATE(8895), 1,
      sym__type_head_name,
    STATE(8898), 1,
      sym__type_head_parens,
    STATE(8899), 1,
      sym__plist,
    STATE(8911), 1,
      sym__type_head_infix,
    STATE(9618), 1,
      sym__context_inline,
    STATE(11495), 1,
      sym__bracket_open,
    STATE(8679), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8881), 6,
      sym_unit,
      sym__tycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__consym_prefix,
      sym__pconsym,
  [328389] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [328429] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [328469] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [328509] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4739), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [328549] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4803), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4805), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [328589] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4843), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4845), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [328629] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [328669] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4831), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4833), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [328709] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4604), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4606), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [328749] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4685), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [328789] = 6,
    ACTIONS(6294), 1,
      anon_sym_PIPE,
    ACTIONS(6297), 1,
      anon_sym_PIPE2,
    STATE(7769), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5821), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_forall,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5823), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_context,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u2200,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      aux_sym__paren_open_token1,
  [328835] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4825), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [328875] = 23,
    ACTIONS(5527), 1,
      sym_variable,
    ACTIONS(5529), 1,
      anon_sym__,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5537), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6167), 1,
      sym_name,
    ACTIONS(6169), 1,
      sym__cond_context,
    STATE(5426), 1,
      sym__paren_open,
    STATE(7725), 1,
      sym__type_head_params,
    STATE(7974), 1,
      sym_context,
    STATE(8042), 1,
      sym_type_param,
    STATE(8280), 1,
      sym__type_head_infix,
    STATE(8355), 1,
      sym__type_head_parens,
    STATE(8380), 1,
      sym__plist,
    STATE(8381), 1,
      sym__type_head_name,
    STATE(8677), 1,
      sym__type_param_invisible,
    STATE(8807), 1,
      sym__prefix_at,
    STATE(9618), 1,
      sym__context_inline,
    STATE(10300), 1,
      sym__data,
    STATE(12129), 1,
      sym__bracket_open,
    STATE(8679), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8382), 6,
      sym_unit,
      sym__tycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__consym_prefix,
      sym__pconsym,
  [328955] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4729), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4731), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [328995] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4725), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4727), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [329035] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4759), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [329075] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [329115] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4799), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4801), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [329155] = 17,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5819), 1,
      sym__cond_infix,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(10065), 1,
      sym__forall_body,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10291), 1,
      sym__type_instance_common,
    STATE(10293), 1,
      sym__type_instance,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(8083), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [329223] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4679), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4681), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [329263] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4721), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4723), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [329303] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4717), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4719), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [329343] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4701), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4703), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [329383] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4817), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [329423] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4755), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [329463] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4819), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4821), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [329503] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4837), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [329543] = 17,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5819), 1,
      sym__cond_infix,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(9291), 1,
      sym__type_instance,
    STATE(10065), 1,
      sym__forall_body,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10291), 1,
      sym__type_instance_common,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(8083), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [329611] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4707), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [329651] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(6258), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6260), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [329697] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4751), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [329737] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5792), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_forall,
      anon_sym_PIPE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5790), 22,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_context,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u2200,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_PIPE2,
      sym_implicit_variable,
      sym_name,
      aux_sym__paren_open_token1,
      anon_sym_POUND_RPAREN,
  [329777] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4715), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [329817] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(4632), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4634), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [329863] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4709), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_DASH,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4711), 22,
      sym__phantom_arrow,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [329903] = 5,
    ACTIONS(169), 1,
      aux_sym__paren_close_token1,
    STATE(3801), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [329946] = 5,
    ACTIONS(1249), 1,
      aux_sym__paren_close_token1,
    STATE(4018), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [329989] = 19,
    ACTIONS(6268), 1,
      sym_variable,
    ACTIONS(6274), 1,
      anon_sym_module,
    ACTIONS(6276), 1,
      sym_name,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6280), 1,
      aux_sym__paren_close_token1,
    STATE(8147), 1,
      sym_namespace,
    STATE(8192), 1,
      sym__paren_open,
    STATE(8993), 1,
      sym__qualified_type,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(9981), 1,
      sym__qtyconid,
    STATE(9984), 1,
      sym__qvarid,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10831), 1,
      aux_sym__qualifying_module,
    STATE(11796), 1,
      sym__paren_close,
    STATE(12089), 1,
      sym_module_export,
    STATE(12110), 1,
      sym__ie_entity,
    ACTIONS(6272), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9980), 9,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
      sym__sym_prefix,
  [330060] = 5,
    ACTIONS(1249), 1,
      aux_sym__paren_close_token1,
    STATE(4115), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [330103] = 5,
    ACTIONS(1279), 1,
      aux_sym__paren_close_token1,
    STATE(2742), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [330146] = 5,
    ACTIONS(1279), 1,
      aux_sym__paren_close_token1,
    STATE(2726), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [330189] = 5,
    ACTIONS(197), 1,
      aux_sym__paren_close_token1,
    STATE(3672), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [330232] = 5,
    ACTIONS(1279), 1,
      aux_sym__paren_close_token1,
    STATE(2743), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [330275] = 5,
    ACTIONS(1279), 1,
      aux_sym__paren_close_token1,
    STATE(2708), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [330318] = 5,
    ACTIONS(169), 1,
      aux_sym__paren_close_token1,
    STATE(3704), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [330361] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4612), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4614), 18,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [330406] = 5,
    ACTIONS(197), 1,
      aux_sym__paren_close_token1,
    STATE(3657), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [330449] = 5,
    ACTIONS(197), 1,
      aux_sym__paren_close_token1,
    STATE(3469), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [330492] = 5,
    ACTIONS(181), 1,
      aux_sym__paren_close_token1,
    STATE(2916), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [330535] = 5,
    ACTIONS(181), 1,
      aux_sym__paren_close_token1,
    STATE(2847), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [330578] = 5,
    ACTIONS(209), 1,
      aux_sym__paren_close_token1,
    STATE(3619), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [330621] = 5,
    ACTIONS(201), 1,
      aux_sym__paren_close_token1,
    STATE(3464), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [330664] = 5,
    ACTIONS(1257), 1,
      aux_sym__paren_close_token1,
    STATE(4523), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [330707] = 5,
    ACTIONS(1249), 1,
      aux_sym__paren_close_token1,
    STATE(4209), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [330750] = 5,
    ACTIONS(181), 1,
      aux_sym__paren_close_token1,
    STATE(2852), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [330793] = 5,
    ACTIONS(185), 1,
      aux_sym__paren_close_token1,
    STATE(3301), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [330836] = 5,
    ACTIONS(1295), 1,
      aux_sym__paren_close_token1,
    STATE(4114), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [330879] = 5,
    ACTIONS(209), 1,
      aux_sym__paren_close_token1,
    STATE(3620), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [330922] = 5,
    ACTIONS(185), 1,
      aux_sym__paren_close_token1,
    STATE(3300), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [330965] = 5,
    ACTIONS(1269), 1,
      aux_sym__paren_close_token1,
    STATE(4351), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [331008] = 5,
    ACTIONS(209), 1,
      aux_sym__paren_close_token1,
    STATE(3495), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [331051] = 19,
    ACTIONS(6268), 1,
      sym_variable,
    ACTIONS(6274), 1,
      anon_sym_module,
    ACTIONS(6276), 1,
      sym_name,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6280), 1,
      aux_sym__paren_close_token1,
    STATE(8147), 1,
      sym_namespace,
    STATE(8192), 1,
      sym__paren_open,
    STATE(8993), 1,
      sym__qualified_type,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(9981), 1,
      sym__qtyconid,
    STATE(9984), 1,
      sym__qvarid,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10831), 1,
      aux_sym__qualifying_module,
    STATE(11707), 1,
      sym__paren_close,
    STATE(12089), 1,
      sym_module_export,
    STATE(12110), 1,
      sym__ie_entity,
    ACTIONS(6272), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9980), 9,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
      sym__sym_prefix,
  [331122] = 5,
    ACTIONS(1255), 1,
      aux_sym__paren_close_token1,
    STATE(3752), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [331165] = 5,
    ACTIONS(185), 1,
      aux_sym__paren_close_token1,
    STATE(3155), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [331208] = 5,
    ACTIONS(169), 1,
      aux_sym__paren_close_token1,
    STATE(3710), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [331251] = 5,
    ACTIONS(1269), 1,
      aux_sym__paren_close_token1,
    STATE(4405), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [331294] = 5,
    ACTIONS(1295), 1,
      aux_sym__paren_close_token1,
    STATE(4191), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [331337] = 5,
    ACTIONS(1277), 1,
      aux_sym__paren_close_token1,
    STATE(4243), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [331380] = 5,
    ACTIONS(1257), 1,
      aux_sym__paren_close_token1,
    STATE(4522), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [331423] = 5,
    ACTIONS(1269), 1,
      aux_sym__paren_close_token1,
    STATE(4402), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [331466] = 5,
    ACTIONS(1255), 1,
      aux_sym__paren_close_token1,
    STATE(3772), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [331509] = 5,
    ACTIONS(1263), 1,
      aux_sym__paren_close_token1,
    STATE(5057), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [331552] = 5,
    ACTIONS(1277), 1,
      aux_sym__paren_close_token1,
    STATE(4271), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [331595] = 5,
    ACTIONS(1269), 1,
      aux_sym__paren_close_token1,
    STATE(4401), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [331638] = 5,
    ACTIONS(1249), 1,
      aux_sym__paren_close_token1,
    STATE(4224), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [331681] = 5,
    ACTIONS(1263), 1,
      aux_sym__paren_close_token1,
    STATE(4867), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [331724] = 19,
    ACTIONS(6268), 1,
      sym_variable,
    ACTIONS(6274), 1,
      anon_sym_module,
    ACTIONS(6276), 1,
      sym_name,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6280), 1,
      aux_sym__paren_close_token1,
    STATE(8147), 1,
      sym_namespace,
    STATE(8192), 1,
      sym__paren_open,
    STATE(8993), 1,
      sym__qualified_type,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(9981), 1,
      sym__qtyconid,
    STATE(9984), 1,
      sym__qvarid,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10831), 1,
      aux_sym__qualifying_module,
    STATE(12079), 1,
      sym__paren_close,
    STATE(12089), 1,
      sym_module_export,
    STATE(12110), 1,
      sym__ie_entity,
    ACTIONS(6272), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9980), 9,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
      sym__sym_prefix,
  [331795] = 19,
    ACTIONS(6268), 1,
      sym_variable,
    ACTIONS(6274), 1,
      anon_sym_module,
    ACTIONS(6276), 1,
      sym_name,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6280), 1,
      aux_sym__paren_close_token1,
    STATE(8147), 1,
      sym_namespace,
    STATE(8192), 1,
      sym__paren_open,
    STATE(8993), 1,
      sym__qualified_type,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(9981), 1,
      sym__qtyconid,
    STATE(9984), 1,
      sym__qvarid,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10831), 1,
      aux_sym__qualifying_module,
    STATE(11943), 1,
      sym__paren_close,
    STATE(12089), 1,
      sym_module_export,
    STATE(12110), 1,
      sym__ie_entity,
    ACTIONS(6272), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9980), 9,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
      sym__sym_prefix,
  [331866] = 5,
    ACTIONS(1257), 1,
      aux_sym__paren_close_token1,
    STATE(4479), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [331909] = 5,
    ACTIONS(1263), 1,
      aux_sym__paren_close_token1,
    STATE(4962), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [331952] = 5,
    ACTIONS(1275), 1,
      aux_sym__paren_close_token1,
    STATE(4422), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [331995] = 5,
    ACTIONS(1295), 1,
      aux_sym__paren_close_token1,
    STATE(4213), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [332038] = 5,
    ACTIONS(1255), 1,
      aux_sym__paren_close_token1,
    STATE(3783), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [332081] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5831), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(5833), 18,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [332126] = 5,
    ACTIONS(1263), 1,
      aux_sym__paren_close_token1,
    STATE(5096), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [332169] = 5,
    ACTIONS(1289), 1,
      aux_sym__paren_close_token1,
    STATE(3963), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [332212] = 5,
    ACTIONS(1255), 1,
      aux_sym__paren_close_token1,
    STATE(3771), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [332255] = 5,
    ACTIONS(1295), 1,
      aux_sym__paren_close_token1,
    STATE(4043), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [332298] = 5,
    ACTIONS(201), 1,
      aux_sym__paren_close_token1,
    STATE(3639), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [332341] = 5,
    ACTIONS(1257), 1,
      aux_sym__paren_close_token1,
    STATE(4453), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [332384] = 5,
    ACTIONS(1275), 1,
      aux_sym__paren_close_token1,
    STATE(4712), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [332427] = 5,
    ACTIONS(1275), 1,
      aux_sym__paren_close_token1,
    STATE(4551), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [332470] = 5,
    ACTIONS(1275), 1,
      aux_sym__paren_close_token1,
    STATE(4774), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [332513] = 5,
    ACTIONS(1289), 1,
      aux_sym__paren_close_token1,
    STATE(4200), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [332556] = 5,
    ACTIONS(201), 1,
      aux_sym__paren_close_token1,
    STATE(3471), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [332599] = 5,
    ACTIONS(1277), 1,
      aux_sym__paren_close_token1,
    STATE(4242), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [332642] = 5,
    ACTIONS(1289), 1,
      aux_sym__paren_close_token1,
    STATE(4119), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [332685] = 22,
    ACTIONS(5527), 1,
      sym_variable,
    ACTIONS(5529), 1,
      anon_sym__,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5537), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6169), 1,
      sym__cond_context,
    ACTIONS(6308), 1,
      sym_name,
    STATE(5418), 1,
      sym__paren_open,
    STATE(7971), 1,
      sym_context,
    STATE(8034), 1,
      sym__type_head_params,
    STATE(8074), 1,
      sym_type_param,
    STATE(8625), 1,
      sym__type_head_name,
    STATE(8626), 1,
      sym__type_head_parens,
    STATE(8628), 1,
      sym__plist,
    STATE(8677), 1,
      sym__type_param_invisible,
    STATE(8720), 1,
      sym__type_head_infix,
    STATE(8807), 1,
      sym__prefix_at,
    STATE(9618), 1,
      sym__context_inline,
    STATE(11443), 1,
      sym__bracket_open,
    STATE(8679), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8623), 6,
      sym_unit,
      sym__tycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__consym_prefix,
      sym__pconsym,
  [332762] = 5,
    ACTIONS(1277), 1,
      aux_sym__paren_close_token1,
    STATE(4274), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [332805] = 5,
    ACTIONS(205), 1,
      aux_sym__paren_close_token1,
    STATE(3670), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [332848] = 5,
    ACTIONS(205), 1,
      aux_sym__paren_close_token1,
    STATE(3526), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [332891] = 5,
    ACTIONS(1289), 1,
      aux_sym__paren_close_token1,
    STATE(4103), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6300), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6302), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [332934] = 5,
    ACTIONS(205), 1,
      aux_sym__paren_close_token1,
    STATE(3524), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6304), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6306), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [332977] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(6258), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6260), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [333021] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6137), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6139), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [333059] = 18,
    ACTIONS(2983), 1,
      aux_sym__paren_close_token1,
    ACTIONS(6268), 1,
      sym_variable,
    ACTIONS(6276), 1,
      sym_name,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6310), 1,
      anon_sym_COMMA,
    STATE(8147), 1,
      sym_namespace,
    STATE(8192), 1,
      sym__paren_open,
    STATE(8993), 1,
      sym__qualified_type,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(9981), 1,
      sym__qtyconid,
    STATE(9984), 1,
      sym__qvarid,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10167), 1,
      sym__ie_entity,
    STATE(10237), 1,
      sym__paren_close,
    STATE(10831), 1,
      aux_sym__qualifying_module,
    ACTIONS(6272), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9980), 9,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
      sym__sym_prefix,
  [333127] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(4612), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4614), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [333171] = 3,
    ACTIONS(4863), 3,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_PIPE2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 23,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [333209] = 21,
    ACTIONS(5527), 1,
      sym_variable,
    ACTIONS(5529), 1,
      anon_sym__,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5537), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(5845), 1,
      sym_name,
    ACTIONS(6312), 1,
      anon_sym_family,
    STATE(5395), 1,
      sym__paren_open,
    STATE(8056), 1,
      sym_type_param,
    STATE(8149), 1,
      sym__type_head_params,
    STATE(8677), 1,
      sym__type_param_invisible,
    STATE(8746), 1,
      sym__plist,
    STATE(8768), 1,
      sym__type_head_parens,
    STATE(8769), 1,
      sym__type_head_name,
    STATE(8807), 1,
      sym__prefix_at,
    STATE(9408), 1,
      sym__type_head_infix,
    STATE(10771), 1,
      sym__datafam,
    STATE(11624), 1,
      sym__bracket_open,
    STATE(8679), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8773), 6,
      sym_unit,
      sym__tycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__consym_prefix,
      sym__pconsym,
  [333283] = 21,
    ACTIONS(6316), 1,
      anon_sym_DASH,
    ACTIONS(6318), 1,
      anon_sym_BQUOTE,
    ACTIONS(6320), 1,
      anon_sym_POUND,
    ACTIONS(6322), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6328), 1,
      aux_sym__paren_close_token1,
    ACTIONS(6330), 1,
      sym__cond_prefix_dot,
    ACTIONS(6332), 1,
      sym__consym,
    STATE(1728), 1,
      sym__colon2,
    STATE(8503), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(8811), 1,
      sym__operator_minus,
    STATE(8815), 1,
      sym__qualified_consym,
    STATE(8829), 1,
      sym__qualified_varsym,
    STATE(10048), 1,
      sym__operator_hash_head,
    ACTIONS(6314), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(6326), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    STATE(8774), 2,
      sym_constructor_operator,
      sym__constructor_operator_alias,
    STATE(8805), 2,
      sym_operator,
      sym__operator_alias,
    STATE(8799), 3,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [333357] = 3,
    ACTIONS(1125), 3,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_PIPE2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(1123), 23,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [333395] = 3,
    ACTIONS(4875), 3,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_PIPE2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4877), 23,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [333433] = 3,
    ACTIONS(4863), 3,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_PIPE2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 23,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [333471] = 18,
    ACTIONS(6268), 1,
      sym_variable,
    ACTIONS(6276), 1,
      sym_name,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6334), 1,
      anon_sym_COMMA,
    ACTIONS(6336), 1,
      aux_sym__paren_close_token1,
    STATE(8147), 1,
      sym_namespace,
    STATE(8192), 1,
      sym__paren_open,
    STATE(8993), 1,
      sym__qualified_type,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(9981), 1,
      sym__qtyconid,
    STATE(9984), 1,
      sym__qvarid,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10652), 1,
      sym__ie_entity,
    STATE(10831), 1,
      aux_sym__qualifying_module,
    STATE(11334), 1,
      sym__paren_close,
    ACTIONS(6272), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9980), 9,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
      sym__sym_prefix,
  [333539] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(5831), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5833), 18,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [333583] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5640), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_forall,
      sym__integer_literal,
      sym_variable,
    ACTIONS(5642), 21,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_context,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u2200,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [333621] = 4,
    ACTIONS(6338), 1,
      anon_sym_EQ,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4839), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(4841), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      aux_sym__paren_open_token1,
  [333661] = 3,
    ACTIONS(4871), 3,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_PIPE2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4873), 23,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [333699] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6340), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6342), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [333737] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6344), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6346), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [333775] = 15,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6348), 1,
      sym_variable,
    ACTIONS(6350), 1,
      anon_sym_type,
    ACTIONS(6352), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6354), 1,
      sym_name,
    ACTIONS(6356), 1,
      aux_sym__paren_close_token1,
    STATE(8192), 1,
      sym__paren_open,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10799), 1,
      aux_sym__qualifying_module,
    STATE(10891), 1,
      sym__qualified_constructor,
    STATE(12158), 1,
      sym__paren_close,
    STATE(12161), 1,
      sym__child_type,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10297), 13,
      sym__child,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__qname,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [333837] = 3,
    ACTIONS(4867), 3,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_PIPE2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4869), 23,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [333875] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6358), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_forall,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6360), 21,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_context,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u2200,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      aux_sym__paren_open_token1,
  [333913] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6155), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_forall,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6157), 21,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_context,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u2200,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      aux_sym__paren_open_token1,
  [333951] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(4612), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4614), 18,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [333995] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6137), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_forall,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6139), 21,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_context,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u2200,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      aux_sym__paren_open_token1,
      anon_sym_RBRACK,
  [334033] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4697), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4699), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [334070] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4779), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4781), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [334107] = 16,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    ACTIONS(6364), 1,
      anon_sym_BQUOTE,
    ACTIONS(6366), 1,
      sym__cond_prefix_dot,
    STATE(8500), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(12150), 1,
      sym__qualified_varsym,
    STATE(12151), 1,
      sym__qualified_consym,
    STATE(12242), 1,
      sym__prefix_dot,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12148), 10,
      sym__exp_op,
      sym__variable_ticked,
      sym__qvariable_ticked,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [334170] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6368), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6370), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [334207] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4783), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4785), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [334244] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4859), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4861), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [334281] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6155), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6157), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [334318] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4847), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4849), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [334355] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4737), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4739), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [334392] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6372), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_forall,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6374), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_context,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u2200,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      aux_sym__paren_open_token1,
  [334429] = 16,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    ACTIONS(6364), 1,
      anon_sym_BQUOTE,
    ACTIONS(6366), 1,
      sym__cond_prefix_dot,
    STATE(8500), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11446), 1,
      sym__qualified_varsym,
    STATE(11449), 1,
      sym__qualified_consym,
    STATE(12242), 1,
      sym__prefix_dot,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11445), 10,
      sym__exp_op,
      sym__variable_ticked,
      sym__qvariable_ticked,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [334492] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4691), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [334529] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4689), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4691), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [334566] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6376), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6378), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [334603] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4685), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [334640] = 17,
    ACTIONS(6268), 1,
      sym_variable,
    ACTIONS(6276), 1,
      sym_name,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6336), 1,
      aux_sym__paren_close_token1,
    STATE(8147), 1,
      sym_namespace,
    STATE(8192), 1,
      sym__paren_open,
    STATE(8993), 1,
      sym__qualified_type,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(9981), 1,
      sym__qtyconid,
    STATE(9984), 1,
      sym__qvarid,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10831), 1,
      aux_sym__qualifying_module,
    STATE(11549), 1,
      sym__ie_entity,
    STATE(11839), 1,
      sym__paren_close,
    ACTIONS(6272), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9980), 9,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
      sym__sym_prefix,
  [334705] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4817), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [334742] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4793), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [334779] = 16,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    ACTIONS(6364), 1,
      anon_sym_BQUOTE,
    ACTIONS(6366), 1,
      sym__cond_prefix_dot,
    STATE(8500), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11625), 1,
      sym__qualified_consym,
    STATE(11628), 1,
      sym__qualified_varsym,
    STATE(12242), 1,
      sym__prefix_dot,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11631), 10,
      sym__exp_op,
      sym__variable_ticked,
      sym__qvariable_ticked,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [334842] = 3,
    ACTIONS(4693), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4695), 21,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [334879] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4807), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4809), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [334916] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4707), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [334953] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6380), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6382), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [334990] = 16,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    ACTIONS(6364), 1,
      anon_sym_BQUOTE,
    ACTIONS(6366), 1,
      sym__cond_prefix_dot,
    STATE(8500), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11496), 1,
      sym__qualified_varsym,
    STATE(11497), 1,
      sym__qualified_consym,
    STATE(12242), 1,
      sym__prefix_dot,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11494), 10,
      sym__exp_op,
      sym__variable_ticked,
      sym__qvariable_ticked,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [335053] = 20,
    ACTIONS(5527), 1,
      sym_variable,
    ACTIONS(5529), 1,
      anon_sym__,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5537), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(5845), 1,
      sym_name,
    STATE(5395), 1,
      sym__paren_open,
    STATE(8056), 1,
      sym_type_param,
    STATE(8149), 1,
      sym__type_head_params,
    STATE(8677), 1,
      sym__type_param_invisible,
    STATE(8746), 1,
      sym__plist,
    STATE(8768), 1,
      sym__type_head_parens,
    STATE(8769), 1,
      sym__type_head_name,
    STATE(8807), 1,
      sym__prefix_at,
    STATE(9408), 1,
      sym__type_head_infix,
    STATE(10749), 1,
      sym__datafam,
    STATE(11624), 1,
      sym__bracket_open,
    STATE(8679), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8773), 6,
      sym_unit,
      sym__tycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__consym_prefix,
      sym__pconsym,
  [335124] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6384), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6386), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [335161] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4793), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [335198] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4707), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [335235] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4695), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [335272] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4735), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [335309] = 20,
    ACTIONS(5527), 1,
      sym_variable,
    ACTIONS(5529), 1,
      anon_sym__,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5537), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6388), 1,
      sym_name,
    STATE(5405), 1,
      sym__paren_open,
    STATE(7962), 1,
      sym__type_head_params,
    STATE(8041), 1,
      sym_type_param,
    STATE(8559), 1,
      sym__plist,
    STATE(8560), 1,
      sym__type_head_parens,
    STATE(8565), 1,
      sym__type_head_name,
    STATE(8666), 1,
      sym__type_head_infix,
    STATE(8677), 1,
      sym__type_param_invisible,
    STATE(8807), 1,
      sym__prefix_at,
    STATE(9258), 1,
      sym__tyfam,
    STATE(12057), 1,
      sym__bracket_open,
    STATE(8679), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8572), 6,
      sym_unit,
      sym__tycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__consym_prefix,
      sym__pconsym,
  [335380] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4837), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [335417] = 6,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(5831), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5833), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [335460] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4787), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4789), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [335497] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6390), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6392), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [335534] = 17,
    ACTIONS(6268), 1,
      sym_variable,
    ACTIONS(6276), 1,
      sym_name,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6336), 1,
      aux_sym__paren_close_token1,
    STATE(8147), 1,
      sym_namespace,
    STATE(8192), 1,
      sym__paren_open,
    STATE(8993), 1,
      sym__qualified_type,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(9981), 1,
      sym__qtyconid,
    STATE(9984), 1,
      sym__qvarid,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10831), 1,
      aux_sym__qualifying_module,
    STATE(11548), 1,
      sym__paren_close,
    STATE(11549), 1,
      sym__ie_entity,
    ACTIONS(6272), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9980), 9,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
      sym__sym_prefix,
  [335599] = 16,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    ACTIONS(6364), 1,
      anon_sym_BQUOTE,
    ACTIONS(6366), 1,
      sym__cond_prefix_dot,
    STATE(8500), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11815), 1,
      sym__qualified_varsym,
    STATE(11825), 1,
      sym__qualified_consym,
    STATE(12242), 1,
      sym__prefix_dot,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11814), 10,
      sym__exp_op,
      sym__variable_ticked,
      sym__qvariable_ticked,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [335662] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6394), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_forall,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6396), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_context,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u2200,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      aux_sym__paren_open_token1,
  [335699] = 16,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    ACTIONS(6364), 1,
      anon_sym_BQUOTE,
    ACTIONS(6366), 1,
      sym__cond_prefix_dot,
    STATE(8500), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11903), 1,
      sym__qualified_varsym,
    STATE(11910), 1,
      sym__qualified_consym,
    STATE(12242), 1,
      sym__prefix_dot,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11892), 10,
      sym__exp_op,
      sym__variable_ticked,
      sym__qvariable_ticked,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [335762] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4837), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [335799] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4695), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [335836] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6258), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6260), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [335873] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6398), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6400), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [335910] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6402), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6404), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [335947] = 16,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    ACTIONS(6364), 1,
      anon_sym_BQUOTE,
    ACTIONS(6366), 1,
      sym__cond_prefix_dot,
    STATE(8500), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11963), 1,
      sym__qualified_varsym,
    STATE(11966), 1,
      sym__qualified_consym,
    STATE(12242), 1,
      sym__prefix_dot,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11945), 10,
      sym__exp_op,
      sym__variable_ticked,
      sym__qvariable_ticked,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [336010] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6406), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6408), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [336047] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6258), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6260), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [336084] = 17,
    ACTIONS(2983), 1,
      aux_sym__paren_close_token1,
    ACTIONS(6268), 1,
      sym_variable,
    ACTIONS(6276), 1,
      sym_name,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    STATE(8147), 1,
      sym_namespace,
    STATE(8192), 1,
      sym__paren_open,
    STATE(8993), 1,
      sym__qualified_type,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(9981), 1,
      sym__qtyconid,
    STATE(9984), 1,
      sym__qvarid,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10100), 1,
      sym__paren_close,
    STATE(10831), 1,
      aux_sym__qualifying_module,
    STATE(11549), 1,
      sym__ie_entity,
    ACTIONS(6272), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9980), 9,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
      sym__sym_prefix,
  [336149] = 16,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    ACTIONS(6364), 1,
      anon_sym_BQUOTE,
    ACTIONS(6366), 1,
      sym__cond_prefix_dot,
    STATE(8500), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(12045), 1,
      sym__qualified_varsym,
    STATE(12055), 1,
      sym__qualified_consym,
    STATE(12242), 1,
      sym__prefix_dot,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12032), 10,
      sym__exp_op,
      sym__variable_ticked,
      sym__qvariable_ticked,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [336212] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6410), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6412), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [336249] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4813), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [336286] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6414), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_forall,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6416), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_context,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u2200,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      aux_sym__paren_open_token1,
  [336323] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6418), 8,
      anon_sym_let,
      anon_sym_SQUOTE,
      anon_sym_if,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_case,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6420), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_DASH,
      anon_sym_LBRACK,
      anon_sym_u27e6,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [336360] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4855), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4857), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [336397] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4713), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4715), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [336434] = 16,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    ACTIONS(6364), 1,
      anon_sym_BQUOTE,
    ACTIONS(6366), 1,
      sym__cond_prefix_dot,
    STATE(8500), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11750), 1,
      sym__qualified_consym,
    STATE(11759), 1,
      sym__qualified_varsym,
    STATE(12242), 1,
      sym__prefix_dot,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11766), 10,
      sym__exp_op,
      sym__variable_ticked,
      sym__qvariable_ticked,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [336497] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6422), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_forall,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6424), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_context,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u2200,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      aux_sym__paren_open_token1,
  [336534] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6426), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6428), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [336571] = 3,
    ACTIONS(5047), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5049), 21,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [336608] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6430), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_forall,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6432), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      sym__cond_context,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_u2200,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      aux_sym__paren_open_token1,
  [336645] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4851), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4853), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [336682] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4827), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4829), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [336719] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4685), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [336756] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4735), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [336793] = 16,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    ACTIONS(6364), 1,
      anon_sym_BQUOTE,
    ACTIONS(6366), 1,
      sym__cond_prefix_dot,
    STATE(8500), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11846), 1,
      sym__qualified_varsym,
    STATE(11852), 1,
      sym__qualified_consym,
    STATE(12242), 1,
      sym__prefix_dot,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11845), 10,
      sym__exp_op,
      sym__variable_ticked,
      sym__qvariable_ticked,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_operator,
      sym__operator_alias,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [336856] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4823), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4825), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [336893] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4757), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4759), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [336930] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4773), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4775), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [336967] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4813), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [337004] = 17,
    ACTIONS(6268), 1,
      sym_variable,
    ACTIONS(6274), 1,
      anon_sym_module,
    ACTIONS(6276), 1,
      sym_name,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    STATE(8147), 1,
      sym_namespace,
    STATE(8192), 1,
      sym__paren_open,
    STATE(8993), 1,
      sym__qualified_type,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(9981), 1,
      sym__qtyconid,
    STATE(9984), 1,
      sym__qvarid,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10831), 1,
      aux_sym__qualifying_module,
    STATE(12089), 1,
      sym_module_export,
    STATE(12110), 1,
      sym__ie_entity,
    ACTIONS(6272), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9980), 9,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
      sym__sym_prefix,
  [337069] = 3,
    ACTIONS(6434), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6436), 21,
      sym__phantom_bar,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [337106] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4749), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4751), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [337143] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4817), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [337180] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4753), 6,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_via,
      anon_sym_deriving,
      sym__integer_literal,
      sym_variable,
    ACTIONS(4755), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [337217] = 17,
    ACTIONS(2983), 1,
      aux_sym__paren_close_token1,
    ACTIONS(6268), 1,
      sym_variable,
    ACTIONS(6276), 1,
      sym_name,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    STATE(8147), 1,
      sym_namespace,
    STATE(8192), 1,
      sym__paren_open,
    STATE(8993), 1,
      sym__qualified_type,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(9981), 1,
      sym__qtyconid,
    STATE(9984), 1,
      sym__qvarid,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10176), 1,
      sym__paren_close,
    STATE(10831), 1,
      aux_sym__qualifying_module,
    STATE(11549), 1,
      sym__ie_entity,
    ACTIONS(6272), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9980), 9,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
      sym__sym_prefix,
  [337282] = 20,
    ACTIONS(5527), 1,
      sym_variable,
    ACTIONS(5529), 1,
      anon_sym__,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5537), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(5845), 1,
      sym_name,
    STATE(5395), 1,
      sym__paren_open,
    STATE(8056), 1,
      sym_type_param,
    STATE(8149), 1,
      sym__type_head_params,
    STATE(8677), 1,
      sym__type_param_invisible,
    STATE(8746), 1,
      sym__plist,
    STATE(8768), 1,
      sym__type_head_parens,
    STATE(8769), 1,
      sym__type_head_name,
    STATE(8807), 1,
      sym__prefix_at,
    STATE(9408), 1,
      sym__type_head_infix,
    STATE(10563), 1,
      sym__datafam,
    STATE(11624), 1,
      sym__bracket_open,
    STATE(8679), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8773), 6,
      sym_unit,
      sym__tycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__consym_prefix,
      sym__pconsym,
  [337353] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4793), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [337389] = 19,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6438), 1,
      sym_variable,
    ACTIONS(6442), 1,
      anon_sym__,
    ACTIONS(6444), 1,
      anon_sym_EQ,
    ACTIONS(6448), 1,
      anon_sym_where,
    STATE(1663), 1,
      sym__colon2,
    STATE(8114), 1,
      aux_sym_type_params_repeat1,
    STATE(8558), 1,
      sym_type_param,
    STATE(8570), 1,
      sym__type_param_invisible,
    STATE(8696), 1,
      sym_type_params,
    STATE(8697), 1,
      sym__paren_open,
    STATE(8816), 1,
      sym_type_family_result,
    STATE(8823), 1,
      sym__prefix_at,
    STATE(9665), 1,
      sym__tyfam_inj,
    ACTIONS(6446), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    STATE(8566), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6440), 5,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
  [337457] = 3,
    ACTIONS(4779), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4781), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [337493] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6232), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6234), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [337529] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6228), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6230), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [337565] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6220), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6222), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [337601] = 3,
    ACTIONS(4807), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4809), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [337637] = 3,
    ACTIONS(6368), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6370), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [337673] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6193), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6195), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [337709] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4817), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [337745] = 19,
    ACTIONS(5527), 1,
      sym_variable,
    ACTIONS(5529), 1,
      anon_sym__,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5537), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6308), 1,
      sym_name,
    STATE(5418), 1,
      sym__paren_open,
    STATE(8032), 1,
      sym__type_head_params,
    STATE(8074), 1,
      sym_type_param,
    STATE(8625), 1,
      sym__type_head_name,
    STATE(8626), 1,
      sym__type_head_parens,
    STATE(8628), 1,
      sym__plist,
    STATE(8677), 1,
      sym__type_param_invisible,
    STATE(8745), 1,
      sym__type_head_infix,
    STATE(8807), 1,
      sym__prefix_at,
    STATE(11443), 1,
      sym__bracket_open,
    STATE(8679), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8623), 6,
      sym_unit,
      sym__tycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__consym_prefix,
      sym__pconsym,
  [337813] = 13,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6350), 1,
      anon_sym_type,
    ACTIONS(6354), 1,
      sym_name,
    ACTIONS(6450), 1,
      sym_variable,
    ACTIONS(6452), 1,
      anon_sym_DOT_DOT,
    STATE(8192), 1,
      sym__paren_open,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10799), 1,
      aux_sym__qualifying_module,
    STATE(10891), 1,
      sym__qualified_constructor,
    STATE(12161), 1,
      sym__child_type,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11457), 13,
      sym__child,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__qname,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [337869] = 3,
    ACTIONS(4713), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4715), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [337905] = 19,
    ACTIONS(5527), 1,
      sym_variable,
    ACTIONS(5529), 1,
      anon_sym__,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5537), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6167), 1,
      sym_name,
    STATE(5426), 1,
      sym__paren_open,
    STATE(7700), 1,
      sym__type_head_params,
    STATE(8042), 1,
      sym_type_param,
    STATE(8298), 1,
      sym__type_head_infix,
    STATE(8355), 1,
      sym__type_head_parens,
    STATE(8380), 1,
      sym__plist,
    STATE(8381), 1,
      sym__type_head_name,
    STATE(8677), 1,
      sym__type_param_invisible,
    STATE(8807), 1,
      sym__prefix_at,
    STATE(12129), 1,
      sym__bracket_open,
    STATE(8679), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8382), 6,
      sym_unit,
      sym__tycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__consym_prefix,
      sym__pconsym,
  [337973] = 19,
    ACTIONS(5527), 1,
      sym_variable,
    ACTIONS(5529), 1,
      anon_sym__,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5537), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6292), 1,
      sym_name,
    STATE(5500), 1,
      sym__paren_open,
    STATE(8045), 1,
      sym_type_param,
    STATE(8088), 1,
      sym__type_head_params,
    STATE(8677), 1,
      sym__type_param_invisible,
    STATE(8807), 1,
      sym__prefix_at,
    STATE(8894), 1,
      sym__type_head_infix,
    STATE(8895), 1,
      sym__type_head_name,
    STATE(8898), 1,
      sym__type_head_parens,
    STATE(8899), 1,
      sym__plist,
    STATE(11495), 1,
      sym__bracket_open,
    STATE(8679), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8881), 6,
      sym_unit,
      sym__tycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__consym_prefix,
      sym__pconsym,
  [338041] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4837), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [338077] = 3,
    ACTIONS(4855), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4857), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [338113] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6208), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6210), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [338149] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4602), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_then,
      anon_sym_using,
      anon_sym_else,
      anon_sym_of,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [338205] = 3,
    ACTIONS(6258), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6260), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [338241] = 3,
    ACTIONS(4689), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4691), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [338277] = 3,
    ACTIONS(4689), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4691), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [338313] = 3,
    ACTIONS(6390), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6392), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [338349] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6204), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6206), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [338385] = 3,
    ACTIONS(4851), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4853), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [338421] = 3,
    ACTIONS(4859), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4861), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [338457] = 3,
    ACTIONS(4753), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4755), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [338493] = 5,
    ACTIONS(6454), 1,
      anon_sym_SEMI,
    STATE(7988), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(5499), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5504), 19,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [338533] = 19,
    ACTIONS(5527), 1,
      sym_variable,
    ACTIONS(5529), 1,
      anon_sym__,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5537), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(5845), 1,
      sym_name,
    STATE(5395), 1,
      sym__paren_open,
    STATE(8056), 1,
      sym_type_param,
    STATE(8096), 1,
      sym__type_head_params,
    STATE(8677), 1,
      sym__type_param_invisible,
    STATE(8746), 1,
      sym__plist,
    STATE(8768), 1,
      sym__type_head_parens,
    STATE(8769), 1,
      sym__type_head_name,
    STATE(8807), 1,
      sym__prefix_at,
    STATE(8871), 1,
      sym__type_head_infix,
    STATE(11624), 1,
      sym__bracket_open,
    STATE(8679), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8773), 6,
      sym_unit,
      sym__tycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__consym_prefix,
      sym__pconsym,
  [338601] = 3,
    ACTIONS(4749), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4751), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [338637] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5831), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(5833), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [338673] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4707), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [338709] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4685), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [338745] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6181), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6183), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [338781] = 3,
    ACTIONS(4847), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4849), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [338817] = 3,
    ACTIONS(4787), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4789), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [338853] = 3,
    ACTIONS(4737), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4739), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [338889] = 3,
    ACTIONS(4697), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4699), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [338925] = 3,
    ACTIONS(4827), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4829), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [338961] = 3,
    ACTIONS(6426), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6428), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [338997] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4813), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [339033] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4695), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [339069] = 3,
    ACTIONS(4823), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4825), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [339105] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6224), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6226), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [339141] = 3,
    ACTIONS(6406), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6408), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [339177] = 3,
    ACTIONS(4773), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4775), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [339213] = 3,
    ACTIONS(6398), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6400), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [339249] = 3,
    ACTIONS(4783), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4785), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [339285] = 3,
    ACTIONS(4757), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4759), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [339321] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4735), 19,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [339357] = 3,
    ACTIONS(6258), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6260), 20,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_EQ_GT,
      anon_sym_u21d2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [339393] = 15,
    ACTIONS(6268), 1,
      sym_variable,
    ACTIONS(6276), 1,
      sym_name,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    STATE(8147), 1,
      sym_namespace,
    STATE(8192), 1,
      sym__paren_open,
    STATE(8993), 1,
      sym__qualified_type,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(9981), 1,
      sym__qtyconid,
    STATE(9984), 1,
      sym__qvarid,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10831), 1,
      aux_sym__qualifying_module,
    STATE(11549), 1,
      sym__ie_entity,
    ACTIONS(6272), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9980), 9,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
      sym__sym_prefix,
  [339452] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6220), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6222), 18,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [339487] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5831), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(5833), 18,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [339522] = 14,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6123), 1,
      sym__cond_context,
    ACTIONS(6189), 1,
      sym_name,
    ACTIONS(6457), 1,
      sym__cond_infix,
    STATE(2143), 1,
      sym__type_instance_head_params,
    STATE(6029), 1,
      sym__paren_open,
    STATE(8001), 1,
      sym__qualified_type,
    STATE(8004), 1,
      sym__type_instance_head_parens,
    STATE(8123), 1,
      sym_context,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10999), 1,
      sym__context_inline,
    STATE(11000), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7991), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [339579] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4815), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4817), 18,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [339614] = 14,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6121), 1,
      sym_name,
    ACTIONS(6123), 1,
      sym__cond_context,
    ACTIONS(6459), 1,
      sym__cond_infix,
    STATE(1829), 1,
      sym__type_instance_head_params,
    STATE(5961), 1,
      sym__paren_open,
    STATE(7691), 1,
      sym__type_instance_head_parens,
    STATE(7697), 1,
      sym__qualified_type,
    STATE(8109), 1,
      sym_context,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10999), 1,
      sym__context_inline,
    STATE(11213), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7689), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [339671] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6224), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6226), 18,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [339706] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(5831), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5833), 15,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [339747] = 14,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6123), 1,
      sym__cond_context,
    ACTIONS(6252), 1,
      sym_name,
    ACTIONS(6461), 1,
      sym__cond_infix,
    STATE(2201), 1,
      sym__type_instance_head_params,
    STATE(6031), 1,
      sym__paren_open,
    STATE(8044), 1,
      sym__qualified_type,
    STATE(8070), 1,
      sym__type_instance_head_parens,
    STATE(8130), 1,
      sym_context,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10999), 1,
      sym__context_inline,
    STATE(11191), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8068), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [339804] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6193), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6195), 18,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [339839] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4683), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4685), 18,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [339874] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4835), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4837), 18,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [339909] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4791), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4793), 18,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [339944] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6232), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6234), 18,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [339979] = 3,
    ACTIONS(6434), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6436), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [340014] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6228), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6230), 18,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [340049] = 14,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6123), 1,
      sym__cond_context,
    ACTIONS(6129), 1,
      sym_name,
    ACTIONS(6463), 1,
      sym__cond_infix,
    STATE(2042), 1,
      sym__type_instance_head_params,
    STATE(6034), 1,
      sym__paren_open,
    STATE(8018), 1,
      sym__type_instance_head_parens,
    STATE(8030), 1,
      sym__qualified_type,
    STATE(8111), 1,
      sym_context,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10999), 1,
      sym__context_inline,
    STATE(11124), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8014), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [340106] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4693), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4695), 18,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [340141] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4811), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4813), 18,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [340176] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6204), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6206), 18,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [340211] = 20,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6465), 1,
      sym_variable,
    ACTIONS(6469), 1,
      anon_sym__,
    ACTIONS(6471), 1,
      anon_sym_PIPE,
    ACTIONS(6473), 1,
      anon_sym_where,
    ACTIONS(6475), 1,
      sym__phantom_where,
    ACTIONS(6477), 1,
      sym__phantom_bar,
    STATE(8167), 1,
      aux_sym_type_params_repeat1,
    STATE(8617), 1,
      sym__paren_open,
    STATE(8636), 1,
      sym_type_param,
    STATE(8692), 1,
      sym__type_param_invisible,
    STATE(8743), 1,
      sym_type_params,
    STATE(8840), 1,
      sym__prefix_at,
    STATE(9418), 1,
      sym__where,
    STATE(9437), 1,
      sym_fundeps,
    STATE(11316), 1,
      sym__bar,
    STATE(8689), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(6467), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [340280] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6208), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6210), 18,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [340315] = 20,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6465), 1,
      sym_variable,
    ACTIONS(6469), 1,
      anon_sym__,
    ACTIONS(6471), 1,
      anon_sym_PIPE,
    ACTIONS(6475), 1,
      sym__phantom_where,
    ACTIONS(6477), 1,
      sym__phantom_bar,
    ACTIONS(6481), 1,
      anon_sym_where,
    STATE(8167), 1,
      aux_sym_type_params_repeat1,
    STATE(8617), 1,
      sym__paren_open,
    STATE(8636), 1,
      sym_type_param,
    STATE(8692), 1,
      sym__type_param_invisible,
    STATE(8737), 1,
      sym_type_params,
    STATE(8840), 1,
      sym__prefix_at,
    STATE(9160), 1,
      sym_fundeps,
    STATE(9165), 1,
      sym__where,
    STATE(11316), 1,
      sym__bar,
    STATE(8689), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(6479), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [340384] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6181), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(6183), 18,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [340419] = 3,
    ACTIONS(4693), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4695), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [340454] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4705), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4707), 18,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [340489] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4733), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
      anon_sym_where,
    ACTIONS(4735), 18,
      sym__phantom_where,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [340524] = 3,
    ACTIONS(5047), 4,
      anon_sym__,
      anon_sym_DASH,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5049), 19,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [340559] = 18,
    ACTIONS(6316), 1,
      anon_sym_DASH,
    ACTIONS(6318), 1,
      anon_sym_BQUOTE,
    ACTIONS(6320), 1,
      anon_sym_POUND,
    ACTIONS(6322), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6330), 1,
      sym__cond_prefix_dot,
    ACTIONS(6332), 1,
      sym__consym,
    STATE(8503), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(8811), 1,
      sym__operator_minus,
    STATE(8815), 1,
      sym__qualified_consym,
    STATE(8829), 1,
      sym__qualified_varsym,
    STATE(10048), 1,
      sym__operator_hash_head,
    ACTIONS(6314), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(8774), 2,
      sym_constructor_operator,
      sym__constructor_operator_alias,
    STATE(8805), 2,
      sym_operator,
      sym__operator_alias,
    STATE(8799), 3,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [340623] = 18,
    ACTIONS(6316), 1,
      anon_sym_DASH,
    ACTIONS(6318), 1,
      anon_sym_BQUOTE,
    ACTIONS(6320), 1,
      anon_sym_POUND,
    ACTIONS(6322), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6330), 1,
      sym__cond_prefix_dot,
    ACTIONS(6332), 1,
      sym__consym,
    STATE(8503), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(8775), 1,
      sym__qualified_consym,
    STATE(8830), 1,
      sym__qualified_varsym,
    STATE(8832), 1,
      sym__operator_minus,
    STATE(10048), 1,
      sym__operator_hash_head,
    ACTIONS(6314), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(8814), 2,
      sym_operator,
      sym__operator_alias,
    STATE(8828), 2,
      sym_constructor_operator,
      sym__constructor_operator_alias,
    STATE(8790), 3,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [340687] = 18,
    ACTIONS(6316), 1,
      anon_sym_DASH,
    ACTIONS(6318), 1,
      anon_sym_BQUOTE,
    ACTIONS(6320), 1,
      anon_sym_POUND,
    ACTIONS(6322), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6330), 1,
      sym__cond_prefix_dot,
    ACTIONS(6332), 1,
      sym__consym,
    STATE(8503), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(8819), 1,
      sym__qualified_consym,
    STATE(8821), 1,
      sym__qualified_varsym,
    STATE(8822), 1,
      sym__operator_minus,
    STATE(10048), 1,
      sym__operator_hash_head,
    ACTIONS(6314), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(8820), 2,
      sym_constructor_operator,
      sym__constructor_operator_alias,
    STATE(8824), 2,
      sym_operator,
      sym__operator_alias,
    STATE(8825), 3,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [340751] = 19,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(1379), 1,
      anon_sym_DASH,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    STATE(8279), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11343), 1,
      sym__qualified_arrow,
    STATE(11384), 1,
      sym__arrow,
    STATE(11499), 1,
      sym__qualified_varsym,
    STATE(11698), 1,
      sym_constructor_operator,
    STATE(12016), 1,
      sym__qualified_consym,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(1381), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(11473), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [340817] = 3,
    ACTIONS(4811), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4813), 18,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [340851] = 18,
    ACTIONS(6316), 1,
      anon_sym_DASH,
    ACTIONS(6318), 1,
      anon_sym_BQUOTE,
    ACTIONS(6320), 1,
      anon_sym_POUND,
    ACTIONS(6322), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6330), 1,
      sym__cond_prefix_dot,
    ACTIONS(6332), 1,
      sym__consym,
    STATE(8503), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(8781), 1,
      sym__operator_minus,
    STATE(8798), 1,
      sym__qualified_consym,
    STATE(8817), 1,
      sym__qualified_varsym,
    STATE(10048), 1,
      sym__operator_hash_head,
    ACTIONS(6314), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(8786), 2,
      sym_operator,
      sym__operator_alias,
    STATE(8797), 2,
      sym_constructor_operator,
      sym__constructor_operator_alias,
    STATE(8787), 3,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [340915] = 3,
    ACTIONS(6193), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6195), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [340949] = 3,
    ACTIONS(6181), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6183), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [340983] = 3,
    ACTIONS(6208), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6210), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [341017] = 3,
    ACTIONS(4835), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4837), 18,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [341051] = 3,
    ACTIONS(6228), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6230), 18,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [341085] = 13,
    ACTIONS(6483), 1,
      sym_variable,
    ACTIONS(6488), 1,
      anon_sym__,
    ACTIONS(6493), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6496), 1,
      sym__cond_prefix_at,
    STATE(8051), 1,
      aux_sym_type_params_repeat1,
    STATE(8360), 1,
      sym__type_param_invisible,
    STATE(8377), 1,
      sym_type_param,
    STATE(8631), 1,
      sym__paren_open,
    STATE(8835), 1,
      sym__prefix_at,
    ACTIONS(6491), 2,
      anon_sym_deriving,
      anon_sym_where,
    STATE(8359), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6486), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [341139] = 3,
    ACTIONS(6204), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6206), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [341173] = 3,
    ACTIONS(4693), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4695), 18,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [341207] = 3,
    ACTIONS(4791), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4793), 18,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [341241] = 3,
    ACTIONS(6384), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6386), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [341275] = 18,
    ACTIONS(6316), 1,
      anon_sym_DASH,
    ACTIONS(6318), 1,
      anon_sym_BQUOTE,
    ACTIONS(6320), 1,
      anon_sym_POUND,
    ACTIONS(6322), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6330), 1,
      sym__cond_prefix_dot,
    ACTIONS(6332), 1,
      sym__consym,
    STATE(8503), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(8785), 1,
      sym__qualified_varsym,
    STATE(8788), 1,
      sym__operator_minus,
    STATE(8793), 1,
      sym__qualified_consym,
    STATE(10048), 1,
      sym__operator_hash_head,
    ACTIONS(6314), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(8784), 2,
      sym_constructor_operator,
      sym__constructor_operator_alias,
    STATE(8789), 2,
      sym_operator,
      sym__operator_alias,
    STATE(8796), 3,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [341339] = 3,
    ACTIONS(4815), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4817), 18,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [341373] = 3,
    ACTIONS(6181), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6183), 18,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [341407] = 13,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6240), 1,
      sym_variable,
    ACTIONS(6244), 1,
      anon_sym__,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    STATE(8051), 1,
      aux_sym_type_params_repeat1,
    STATE(8360), 1,
      sym__type_param_invisible,
    STATE(8377), 1,
      sym_type_param,
    STATE(8631), 1,
      sym__paren_open,
    STATE(8835), 1,
      sym__prefix_at,
    ACTIONS(6501), 2,
      anon_sym_deriving,
      anon_sym_where,
    STATE(8359), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6499), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [341461] = 3,
    ACTIONS(6185), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6187), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [341495] = 20,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6147), 1,
      sym_name,
    ACTIONS(6149), 1,
      sym__cond_context,
    ACTIONS(6151), 1,
      sym__cond_data_infix,
    STATE(834), 1,
      sym__paren_open,
    STATE(870), 1,
      sym__unboxed_open,
    STATE(8165), 1,
      sym_context,
    STATE(9014), 1,
      sym__datacon_unboxed_sum,
    STATE(9038), 1,
      sym__type_unboxed_tuple,
    STATE(9039), 1,
      sym__type_tuple,
    STATE(9082), 1,
      sym__datacon_special,
    STATE(9083), 1,
      sym__datacon_record,
    STATE(9084), 1,
      sym__datacon_infix,
    STATE(9086), 1,
      sym__datacon_prefix,
    STATE(10061), 1,
      sym__context_inline,
    STATE(11600), 1,
      sym__bracket_open,
    STATE(1842), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(8980), 3,
      sym__plist,
      sym_unit,
      sym_unboxed_unit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [341563] = 3,
    ACTIONS(6220), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6222), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [341597] = 3,
    ACTIONS(5831), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5833), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [341631] = 3,
    ACTIONS(4683), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4685), 18,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [341665] = 3,
    ACTIONS(6193), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6195), 18,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [341699] = 3,
    ACTIONS(4705), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4707), 18,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [341733] = 3,
    ACTIONS(6224), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6226), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [341767] = 3,
    ACTIONS(5831), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5833), 18,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [341801] = 5,
    ACTIONS(6503), 1,
      anon_sym_SEMI,
    STATE(8069), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(5499), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5504), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [341839] = 3,
    ACTIONS(6224), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6226), 18,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [341873] = 3,
    ACTIONS(6204), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6206), 18,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [341907] = 3,
    ACTIONS(6208), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6210), 18,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [341941] = 3,
    ACTIONS(4733), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4735), 18,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [341975] = 18,
    ACTIONS(6316), 1,
      anon_sym_DASH,
    ACTIONS(6318), 1,
      anon_sym_BQUOTE,
    ACTIONS(6320), 1,
      anon_sym_POUND,
    ACTIONS(6322), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6330), 1,
      sym__cond_prefix_dot,
    ACTIONS(6332), 1,
      sym__consym,
    STATE(8503), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(8804), 1,
      sym__qualified_consym,
    STATE(8808), 1,
      sym__qualified_varsym,
    STATE(8809), 1,
      sym__operator_minus,
    STATE(10048), 1,
      sym__operator_hash_head,
    ACTIONS(6314), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(8806), 2,
      sym_constructor_operator,
      sym__constructor_operator_alias,
    STATE(8810), 2,
      sym_operator,
      sym__operator_alias,
    STATE(8812), 3,
      sym__tycon_ticked,
      sym__qtycon_ticked,
      sym__tyconids_ticked,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [342039] = 3,
    ACTIONS(6232), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6234), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [342073] = 3,
    ACTIONS(6228), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6230), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_EQ,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [342107] = 3,
    ACTIONS(6220), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6222), 18,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [342141] = 3,
    ACTIONS(6232), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6234), 18,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [342175] = 4,
    ACTIONS(6506), 2,
      anon_sym_POUND2,
      anon_sym_PIPE2,
    ACTIONS(6264), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5802), 16,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [342210] = 3,
    ACTIONS(6508), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6510), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [342243] = 12,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5819), 1,
      sym__cond_infix,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10705), 1,
      sym__type_instance_common,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [342294] = 3,
    ACTIONS(6512), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6514), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [342327] = 12,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5819), 1,
      sym__cond_infix,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10856), 1,
      sym__type_instance_common,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [342378] = 20,
    ACTIONS(3565), 1,
      anon_sym_where,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(4142), 1,
      anon_sym_EQ,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6516), 1,
      sym_variable,
    ACTIONS(6518), 1,
      anon_sym__,
    STATE(1572), 1,
      sym__colon2,
    STATE(8334), 1,
      aux_sym_type_params_repeat1,
    STATE(8688), 1,
      sym__paren_open,
    STATE(8843), 1,
      sym__prefix_at,
    STATE(8876), 1,
      sym_type_params,
    STATE(8883), 1,
      sym__where,
    STATE(8900), 1,
      sym__type_param_invisible,
    STATE(8918), 1,
      sym_type_param,
    STATE(9109), 1,
      sym__gadt,
    STATE(10521), 1,
      sym__newtype,
    ACTIONS(4146), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    STATE(8901), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [342445] = 3,
    ACTIONS(6520), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6522), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [342478] = 3,
    ACTIONS(6384), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6386), 17,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [342511] = 12,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5819), 1,
      sym__cond_infix,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10684), 1,
      sym__type_instance_common,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [342562] = 20,
    ACTIONS(3565), 1,
      anon_sym_where,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(4142), 1,
      anon_sym_EQ,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6516), 1,
      sym_variable,
    ACTIONS(6518), 1,
      anon_sym__,
    STATE(1572), 1,
      sym__colon2,
    STATE(8334), 1,
      aux_sym_type_params_repeat1,
    STATE(8688), 1,
      sym__paren_open,
    STATE(8843), 1,
      sym__prefix_at,
    STATE(8883), 1,
      sym__where,
    STATE(8900), 1,
      sym__type_param_invisible,
    STATE(8915), 1,
      sym_type_params,
    STATE(8918), 1,
      sym_type_param,
    STATE(9109), 1,
      sym__gadt,
    STATE(10622), 1,
      sym__newtype,
    ACTIONS(4146), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    STATE(8901), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [342629] = 14,
    ACTIONS(6526), 1,
      anon_sym_DASH,
    ACTIONS(6528), 1,
      sym__integer_literal,
    ACTIONS(6532), 1,
      anon_sym_BQUOTE,
    ACTIONS(6534), 1,
      anon_sym_POUND,
    ACTIONS(6536), 1,
      anon_sym_POUND2,
    ACTIONS(6538), 1,
      sym__cond_prefix_dot,
    ACTIONS(6540), 1,
      sym__consym,
    STATE(8401), 1,
      sym_integer,
    STATE(9955), 1,
      sym__operator_hash_head,
    STATE(12363), 1,
      sym__fun_arrow_prec,
    ACTIONS(6524), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(6530), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9589), 6,
      sym__variable_ticked,
      sym__constructor_ticked,
      sym_operator,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [342684] = 12,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5819), 1,
      sym__cond_infix,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10747), 1,
      sym__type_instance_common,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [342735] = 12,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(5813), 1,
      sym_name,
    ACTIONS(5819), 1,
      sym__cond_infix,
    STATE(2245), 1,
      sym__type_instance_head_params,
    STATE(6057), 1,
      sym__paren_open,
    STATE(7953), 1,
      sym__qualified_type,
    STATE(8067), 1,
      sym__type_instance_head_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10452), 1,
      sym__type_instance_common,
    STATE(11126), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8063), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [342786] = 17,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6542), 1,
      sym_variable,
    ACTIONS(6546), 1,
      anon_sym__,
    ACTIONS(6548), 1,
      anon_sym_EQ,
    STATE(1540), 1,
      sym__colon2,
    STATE(8191), 1,
      aux_sym_type_params_repeat1,
    STATE(8630), 1,
      sym__paren_open,
    STATE(8740), 1,
      sym_type_param,
    STATE(8764), 1,
      sym__type_param_invisible,
    STATE(8801), 1,
      sym__prefix_at,
    STATE(8872), 1,
      sym_type_params,
    STATE(10763), 1,
      sym_type_family_result,
    ACTIONS(6550), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    STATE(8763), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(6544), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [342847] = 3,
    ACTIONS(6552), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6554), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [342880] = 16,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    ACTIONS(6558), 1,
      anon_sym_where,
    STATE(1394), 1,
      sym__linear_fun_arrow,
    STATE(1577), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(8863), 1,
      sym__where,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6556), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [342939] = 3,
    ACTIONS(6560), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6562), 18,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_prefix_at,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [342972] = 17,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6542), 1,
      sym_variable,
    ACTIONS(6546), 1,
      anon_sym__,
    ACTIONS(6548), 1,
      anon_sym_EQ,
    STATE(1600), 1,
      sym__colon2,
    STATE(8191), 1,
      aux_sym_type_params_repeat1,
    STATE(8630), 1,
      sym__paren_open,
    STATE(8740), 1,
      sym_type_param,
    STATE(8764), 1,
      sym__type_param_invisible,
    STATE(8801), 1,
      sym__prefix_at,
    STATE(8866), 1,
      sym_type_params,
    STATE(10507), 1,
      sym_type_family_result,
    ACTIONS(6566), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    STATE(8763), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(6564), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [343033] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6568), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [343085] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1510), 1,
      sym__fun_arrow,
    STATE(1512), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4602), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [343137] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1510), 1,
      sym__fun_arrow,
    STATE(1512), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4592), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [343189] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1510), 1,
      sym__fun_arrow,
    STATE(1512), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4588), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [343241] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1510), 1,
      sym__fun_arrow,
    STATE(1512), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4580), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [343293] = 11,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6121), 1,
      sym_name,
    ACTIONS(6570), 1,
      sym__cond_infix,
    STATE(1832), 1,
      sym__type_instance_head_params,
    STATE(5961), 1,
      sym__paren_open,
    STATE(7691), 1,
      sym__type_instance_head_parens,
    STATE(7697), 1,
      sym__qualified_type,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11213), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7689), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [343341] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1510), 1,
      sym__fun_arrow,
    STATE(1512), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4596), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [343393] = 9,
    ACTIONS(4582), 1,
      anon_sym_DASH_GT,
    STATE(1510), 1,
      sym__fun_arrow,
    STATE(1512), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4584), 13,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [343437] = 15,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(1480), 1,
      sym__colon2,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6574), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6572), 5,
      anon_sym_COMMA,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [343493] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1510), 1,
      sym__fun_arrow,
    STATE(1512), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4592), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [343545] = 12,
    ACTIONS(159), 1,
      anon_sym_BQUOTE,
    ACTIONS(161), 1,
      anon_sym_POUND,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(323), 1,
      sym__cond_prefix_dot,
    ACTIONS(6576), 1,
      anon_sym_POUND2,
    ACTIONS(6578), 1,
      sym__cond_qualified_op,
    ACTIONS(6580), 1,
      sym__cond_minus,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(7928), 1,
      sym__prefix_dot,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1602), 9,
      sym__exp_op,
      sym__variable_ticked,
      sym__qvariable_ticked,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_operator,
      sym__operator_alias,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [343595] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1394), 1,
      sym__linear_fun_arrow,
    STATE(1577), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4596), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
      anon_sym_where,
  [343647] = 11,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6121), 1,
      sym_name,
    ACTIONS(6582), 1,
      sym__cond_infix,
    STATE(1831), 1,
      sym__type_instance_head_params,
    STATE(5961), 1,
      sym__paren_open,
    STATE(7691), 1,
      sym__type_instance_head_parens,
    STATE(7697), 1,
      sym__qualified_type,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11213), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7689), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [343695] = 11,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6189), 1,
      sym_name,
    ACTIONS(6584), 1,
      sym__cond_infix,
    STATE(2145), 1,
      sym__type_instance_head_params,
    STATE(6029), 1,
      sym__paren_open,
    STATE(8001), 1,
      sym__qualified_type,
    STATE(8004), 1,
      sym__type_instance_head_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11000), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7991), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [343743] = 11,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6129), 1,
      sym_name,
    ACTIONS(6586), 1,
      sym__cond_infix,
    STATE(2035), 1,
      sym__type_instance_head_params,
    STATE(6034), 1,
      sym__paren_open,
    STATE(8018), 1,
      sym__type_instance_head_parens,
    STATE(8030), 1,
      sym__qualified_type,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11124), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8014), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [343791] = 12,
    ACTIONS(159), 1,
      anon_sym_BQUOTE,
    ACTIONS(161), 1,
      anon_sym_POUND,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(323), 1,
      sym__cond_prefix_dot,
    ACTIONS(6576), 1,
      anon_sym_POUND2,
    ACTIONS(6588), 1,
      sym__cond_qualified_op,
    ACTIONS(6590), 1,
      sym__cond_minus,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(7928), 1,
      sym__prefix_dot,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1672), 9,
      sym__exp_op,
      sym__variable_ticked,
      sym__qvariable_ticked,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_operator,
      sym__operator_alias,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [343841] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1510), 1,
      sym__fun_arrow,
    STATE(1512), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4566), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [343893] = 13,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6438), 1,
      sym_variable,
    ACTIONS(6442), 1,
      anon_sym__,
    ACTIONS(6501), 1,
      anon_sym_where,
    STATE(8135), 1,
      aux_sym_type_params_repeat1,
    STATE(8558), 1,
      sym_type_param,
    STATE(8570), 1,
      sym__type_param_invisible,
    STATE(8697), 1,
      sym__paren_open,
    STATE(8823), 1,
      sym__prefix_at,
    STATE(8566), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6499), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [343945] = 12,
    ACTIONS(159), 1,
      anon_sym_BQUOTE,
    ACTIONS(161), 1,
      anon_sym_POUND,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(323), 1,
      sym__cond_prefix_dot,
    ACTIONS(6576), 1,
      anon_sym_POUND2,
    ACTIONS(6592), 1,
      sym__cond_qualified_op,
    ACTIONS(6594), 1,
      sym__cond_minus,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(7928), 1,
      sym__prefix_dot,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1403), 9,
      sym__exp_op,
      sym__variable_ticked,
      sym__qvariable_ticked,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_operator,
      sym__operator_alias,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [343995] = 11,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6252), 1,
      sym_name,
    ACTIONS(6596), 1,
      sym__cond_infix,
    STATE(2194), 1,
      sym__type_instance_head_params,
    STATE(6031), 1,
      sym__paren_open,
    STATE(8044), 1,
      sym__qualified_type,
    STATE(8070), 1,
      sym__type_instance_head_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11191), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8068), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [344043] = 12,
    ACTIONS(159), 1,
      anon_sym_BQUOTE,
    ACTIONS(161), 1,
      anon_sym_POUND,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(323), 1,
      sym__cond_prefix_dot,
    ACTIONS(6576), 1,
      anon_sym_POUND2,
    ACTIONS(6598), 1,
      sym__cond_qualified_op,
    ACTIONS(6600), 1,
      sym__cond_minus,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(7928), 1,
      sym__prefix_dot,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1465), 9,
      sym__exp_op,
      sym__variable_ticked,
      sym__qvariable_ticked,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_operator,
      sym__operator_alias,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [344093] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1510), 1,
      sym__fun_arrow,
    STATE(1512), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4566), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [344145] = 13,
    ACTIONS(6528), 1,
      sym__integer_literal,
    ACTIONS(6532), 1,
      anon_sym_BQUOTE,
    ACTIONS(6534), 1,
      anon_sym_POUND,
    ACTIONS(6536), 1,
      anon_sym_POUND2,
    ACTIONS(6538), 1,
      sym__cond_prefix_dot,
    ACTIONS(6540), 1,
      sym__consym,
    ACTIONS(6602), 1,
      anon_sym_DASH,
    STATE(8401), 1,
      sym_integer,
    STATE(9955), 1,
      sym__operator_hash_head,
    ACTIONS(6524), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(6530), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9589), 6,
      sym__variable_ticked,
      sym__constructor_ticked,
      sym_operator,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [344197] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1394), 1,
      sym__linear_fun_arrow,
    STATE(1577), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4592), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
      anon_sym_where,
  [344249] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1394), 1,
      sym__linear_fun_arrow,
    STATE(1577), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4566), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
      anon_sym_where,
  [344301] = 12,
    ACTIONS(159), 1,
      anon_sym_BQUOTE,
    ACTIONS(161), 1,
      anon_sym_POUND,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(323), 1,
      sym__cond_prefix_dot,
    ACTIONS(6576), 1,
      anon_sym_POUND2,
    ACTIONS(6604), 1,
      sym__cond_qualified_op,
    ACTIONS(6606), 1,
      sym__cond_minus,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(7928), 1,
      sym__prefix_dot,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1467), 9,
      sym__exp_op,
      sym__variable_ticked,
      sym__qvariable_ticked,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_operator,
      sym__operator_alias,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [344351] = 11,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6189), 1,
      sym_name,
    ACTIONS(6608), 1,
      sym__cond_infix,
    STATE(2163), 1,
      sym__type_instance_head_params,
    STATE(6029), 1,
      sym__paren_open,
    STATE(8001), 1,
      sym__qualified_type,
    STATE(8004), 1,
      sym__type_instance_head_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11000), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7991), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [344399] = 12,
    ACTIONS(159), 1,
      anon_sym_BQUOTE,
    ACTIONS(161), 1,
      anon_sym_POUND,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(323), 1,
      sym__cond_prefix_dot,
    ACTIONS(6576), 1,
      anon_sym_POUND2,
    ACTIONS(6610), 1,
      sym__cond_qualified_op,
    ACTIONS(6612), 1,
      sym__cond_minus,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(7928), 1,
      sym__prefix_dot,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1615), 9,
      sym__exp_op,
      sym__variable_ticked,
      sym__qvariable_ticked,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_operator,
      sym__operator_alias,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [344449] = 11,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6129), 1,
      sym_name,
    ACTIONS(6614), 1,
      sym__cond_infix,
    STATE(2024), 1,
      sym__type_instance_head_params,
    STATE(6034), 1,
      sym__paren_open,
    STATE(8018), 1,
      sym__type_instance_head_parens,
    STATE(8030), 1,
      sym__qualified_type,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11124), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8014), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [344497] = 12,
    ACTIONS(159), 1,
      anon_sym_BQUOTE,
    ACTIONS(161), 1,
      anon_sym_POUND,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(323), 1,
      sym__cond_prefix_dot,
    ACTIONS(6576), 1,
      anon_sym_POUND2,
    ACTIONS(6616), 1,
      sym__cond_qualified_op,
    ACTIONS(6618), 1,
      sym__cond_minus,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(7928), 1,
      sym__prefix_dot,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1571), 9,
      sym__exp_op,
      sym__variable_ticked,
      sym__qvariable_ticked,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_operator,
      sym__operator_alias,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [344547] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1510), 1,
      sym__fun_arrow,
    STATE(1512), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6620), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [344599] = 12,
    ACTIONS(159), 1,
      anon_sym_BQUOTE,
    ACTIONS(161), 1,
      anon_sym_POUND,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(323), 1,
      sym__cond_prefix_dot,
    ACTIONS(6576), 1,
      anon_sym_POUND2,
    ACTIONS(6622), 1,
      sym__cond_qualified_op,
    ACTIONS(6624), 1,
      sym__cond_minus,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(7928), 1,
      sym__prefix_dot,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1764), 9,
      sym__exp_op,
      sym__variable_ticked,
      sym__qvariable_ticked,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_operator,
      sym__operator_alias,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [344649] = 12,
    ACTIONS(159), 1,
      anon_sym_BQUOTE,
    ACTIONS(161), 1,
      anon_sym_POUND,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(323), 1,
      sym__cond_prefix_dot,
    ACTIONS(6576), 1,
      anon_sym_POUND2,
    ACTIONS(6626), 1,
      sym__cond_qualified_op,
    ACTIONS(6628), 1,
      sym__cond_minus,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(7928), 1,
      sym__prefix_dot,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1489), 9,
      sym__exp_op,
      sym__variable_ticked,
      sym__qvariable_ticked,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_operator,
      sym__operator_alias,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [344699] = 11,
    ACTIONS(5673), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6252), 1,
      sym_name,
    ACTIONS(6630), 1,
      sym__cond_infix,
    STATE(2206), 1,
      sym__type_instance_head_params,
    STATE(6031), 1,
      sym__paren_open,
    STATE(8044), 1,
      sym__qualified_type,
    STATE(8070), 1,
      sym__type_instance_head_parens,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11191), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8068), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [344747] = 12,
    ACTIONS(159), 1,
      anon_sym_BQUOTE,
    ACTIONS(161), 1,
      anon_sym_POUND,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(323), 1,
      sym__cond_prefix_dot,
    ACTIONS(6576), 1,
      anon_sym_POUND2,
    ACTIONS(6632), 1,
      sym__cond_qualified_op,
    ACTIONS(6634), 1,
      sym__cond_minus,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(7928), 1,
      sym__prefix_dot,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1657), 9,
      sym__exp_op,
      sym__variable_ticked,
      sym__qvariable_ticked,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_operator,
      sym__operator_alias,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [344797] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1394), 1,
      sym__linear_fun_arrow,
    STATE(1577), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4580), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
      anon_sym_where,
  [344849] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1394), 1,
      sym__linear_fun_arrow,
    STATE(1577), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4588), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
      anon_sym_where,
  [344901] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1394), 1,
      sym__linear_fun_arrow,
    STATE(1577), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4592), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
      anon_sym_where,
  [344953] = 13,
    ACTIONS(6491), 1,
      anon_sym_where,
    ACTIONS(6493), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6496), 1,
      sym__cond_prefix_at,
    ACTIONS(6636), 1,
      sym_variable,
    ACTIONS(6639), 1,
      anon_sym__,
    STATE(8135), 1,
      aux_sym_type_params_repeat1,
    STATE(8558), 1,
      sym_type_param,
    STATE(8570), 1,
      sym__type_param_invisible,
    STATE(8697), 1,
      sym__paren_open,
    STATE(8823), 1,
      sym__prefix_at,
    STATE(8566), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6486), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [345005] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1394), 1,
      sym__linear_fun_arrow,
    STATE(1577), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4566), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
      anon_sym_where,
  [345057] = 9,
    ACTIONS(4582), 1,
      anon_sym_DASH_GT,
    STATE(1394), 1,
      sym__linear_fun_arrow,
    STATE(1577), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4584), 13,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_deriving,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [345101] = 3,
    ACTIONS(6642), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6644), 16,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [345132] = 3,
    ACTIONS(6646), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6648), 16,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [345163] = 11,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6650), 1,
      sym_variable,
    ACTIONS(6652), 1,
      sym_name,
    STATE(4062), 1,
      sym__qualified_constructor,
    STATE(4219), 1,
      sym__qualified_variable,
    STATE(8245), 1,
      sym__paren_open,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10372), 1,
      aux_sym__qualifying_module,
    STATE(4440), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4441), 9,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [345210] = 11,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6654), 1,
      sym_variable,
    ACTIONS(6656), 1,
      sym_name,
    STATE(4251), 1,
      sym__qualified_constructor,
    STATE(4298), 1,
      sym__qualified_variable,
    STATE(8208), 1,
      sym__paren_open,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10255), 1,
      aux_sym__qualifying_module,
    STATE(5022), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5026), 9,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [345257] = 16,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    ACTIONS(6658), 1,
      anon_sym_PIPE,
    STATE(1608), 1,
      sym__colon2,
    STATE(1625), 1,
      sym__linear_fun_arrow,
    STATE(1627), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6660), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(6572), 3,
      anon_sym_COMMA,
      anon_sym_PIPE2,
      anon_sym_POUND_RPAREN,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [345314] = 3,
    ACTIONS(6410), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6412), 16,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [345345] = 11,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6662), 1,
      sym_variable,
    ACTIONS(6664), 1,
      sym_name,
    STATE(4610), 1,
      sym__qualified_constructor,
    STATE(4614), 1,
      sym__qualified_variable,
    STATE(8214), 1,
      sym__paren_open,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10578), 1,
      aux_sym__qualifying_module,
    STATE(5359), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5360), 9,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [345392] = 11,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6666), 1,
      sym_variable,
    ACTIONS(6668), 1,
      sym_name,
    STATE(2717), 1,
      sym__qualified_variable,
    STATE(2750), 1,
      sym__qualified_constructor,
    STATE(8209), 1,
      sym__paren_open,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10581), 1,
      aux_sym__qualifying_module,
    STATE(2966), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(2924), 9,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [345439] = 3,
    ACTIONS(6212), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6214), 16,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [345470] = 12,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6670), 1,
      sym_variable,
    ACTIONS(6672), 1,
      sym_name,
    STATE(8192), 1,
      sym__paren_open,
    STATE(8993), 1,
      sym__qualified_type,
    STATE(9750), 1,
      sym__qvarid,
    STATE(9757), 1,
      sym__qtyconid,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10831), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9758), 9,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
      sym__sym_prefix,
  [345519] = 3,
    ACTIONS(6216), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6218), 16,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [345550] = 15,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6542), 1,
      sym_variable,
    ACTIONS(6546), 1,
      anon_sym__,
    STATE(1744), 1,
      sym__colon2,
    STATE(8191), 1,
      aux_sym_type_params_repeat1,
    STATE(8630), 1,
      sym__paren_open,
    STATE(8740), 1,
      sym_type_param,
    STATE(8764), 1,
      sym__type_param_invisible,
    STATE(8801), 1,
      sym__prefix_at,
    STATE(9482), 1,
      sym_type_params,
    ACTIONS(6676), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    STATE(8763), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(6674), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [345605] = 17,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6147), 1,
      sym_name,
    ACTIONS(6151), 1,
      sym__cond_data_infix,
    STATE(834), 1,
      sym__paren_open,
    STATE(870), 1,
      sym__unboxed_open,
    STATE(8996), 1,
      sym__datacon_record,
    STATE(9014), 1,
      sym__datacon_unboxed_sum,
    STATE(9038), 1,
      sym__type_unboxed_tuple,
    STATE(9039), 1,
      sym__type_tuple,
    STATE(9079), 1,
      sym__datacon_special,
    STATE(9080), 1,
      sym__datacon_infix,
    STATE(9081), 1,
      sym__datacon_prefix,
    STATE(11600), 1,
      sym__bracket_open,
    STATE(1842), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(8980), 3,
      sym__plist,
      sym_unit,
      sym_unboxed_unit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [345664] = 11,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6678), 1,
      sym_variable,
    ACTIONS(6680), 1,
      sym_name,
    STATE(4313), 1,
      sym__qualified_variable,
    STATE(4378), 1,
      sym__qualified_constructor,
    STATE(8226), 1,
      sym__paren_open,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10115), 1,
      aux_sym__qualifying_module,
    STATE(5146), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5145), 9,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [345711] = 3,
    ACTIONS(4769), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4771), 16,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [345742] = 11,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6682), 1,
      sym_variable,
    ACTIONS(6684), 1,
      sym_name,
    STATE(3934), 1,
      sym__qualified_variable,
    STATE(4205), 1,
      sym__qualified_constructor,
    STATE(8272), 1,
      sym__paren_open,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10136), 1,
      aux_sym__qualifying_module,
    STATE(4823), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4822), 9,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [345789] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6358), 5,
      anon_sym__,
      anon_sym_SQUOTE,
      anon_sym_forall,
      sym__integer_literal,
      sym_variable,
    ACTIONS(6360), 14,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_context,
      sym__cond_infix,
      anon_sym_u2200,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_implicit_variable,
      sym_name,
      aux_sym__paren_open_token1,
  [345820] = 3,
    ACTIONS(6256), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(3269), 16,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [345851] = 11,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6686), 1,
      sym_variable,
    ACTIONS(6688), 1,
      sym_name,
    STATE(5072), 1,
      sym__qualified_variable,
    STATE(5073), 1,
      sym__qualified_constructor,
    STATE(8239), 1,
      sym__paren_open,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10355), 1,
      aux_sym__qualifying_module,
    STATE(5535), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5536), 9,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [345898] = 15,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(1569), 1,
      sym__colon2,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6690), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(6572), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [345953] = 3,
    ACTIONS(6692), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6694), 16,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [345984] = 4,
    ACTIONS(6266), 2,
      anon_sym_POUND2,
      anon_sym_PIPE2,
    ACTIONS(6264), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5802), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [346017] = 3,
    ACTIONS(6380), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6382), 16,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [346048] = 3,
    ACTIONS(6696), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6698), 16,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [346079] = 11,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6700), 1,
      sym_variable,
    ACTIONS(6702), 1,
      sym_name,
    STATE(3696), 1,
      sym__qualified_variable,
    STATE(3697), 1,
      sym__qualified_constructor,
    STATE(8266), 1,
      sym__paren_open,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10370), 1,
      aux_sym__qualifying_module,
    STATE(4059), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4063), 9,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [346126] = 11,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6704), 1,
      sym_variable,
    ACTIONS(6706), 1,
      sym_name,
    STATE(4352), 1,
      sym__qualified_variable,
    STATE(4368), 1,
      sym__qualified_constructor,
    STATE(8249), 1,
      sym__paren_open,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10460), 1,
      aux_sym__qualifying_module,
    STATE(5472), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5473), 9,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [346173] = 17,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    ACTIONS(6708), 1,
      anon_sym_PIPE,
    ACTIONS(6710), 1,
      anon_sym_PIPE2,
    STATE(1608), 1,
      sym__colon2,
    STATE(1625), 1,
      sym__linear_fun_arrow,
    STATE(1627), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6572), 2,
      anon_sym_COMMA,
      anon_sym_POUND_RPAREN,
    ACTIONS(6660), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [346232] = 17,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6147), 1,
      sym_name,
    ACTIONS(6151), 1,
      sym__cond_data_infix,
    STATE(834), 1,
      sym__paren_open,
    STATE(870), 1,
      sym__unboxed_open,
    STATE(9014), 1,
      sym__datacon_unboxed_sum,
    STATE(9038), 1,
      sym__type_unboxed_tuple,
    STATE(9039), 1,
      sym__type_tuple,
    STATE(9040), 1,
      sym__datacon_prefix,
    STATE(9041), 1,
      sym__datacon_infix,
    STATE(9042), 1,
      sym__datacon_record,
    STATE(9044), 1,
      sym__datacon_special,
    STATE(11600), 1,
      sym__bracket_open,
    STATE(1842), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(8980), 3,
      sym__plist,
      sym_unit,
      sym_unboxed_unit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [346291] = 3,
    ACTIONS(6712), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6714), 16,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [346322] = 13,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6465), 1,
      sym_variable,
    ACTIONS(6469), 1,
      anon_sym__,
    ACTIONS(6501), 1,
      anon_sym_where,
    STATE(8168), 1,
      aux_sym_type_params_repeat1,
    STATE(8617), 1,
      sym__paren_open,
    STATE(8636), 1,
      sym_type_param,
    STATE(8692), 1,
      sym__type_param_invisible,
    STATE(8840), 1,
      sym__prefix_at,
    STATE(8689), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6499), 7,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [346373] = 13,
    ACTIONS(6491), 1,
      anon_sym_where,
    ACTIONS(6493), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6496), 1,
      sym__cond_prefix_at,
    ACTIONS(6716), 1,
      sym_variable,
    ACTIONS(6719), 1,
      anon_sym__,
    STATE(8168), 1,
      aux_sym_type_params_repeat1,
    STATE(8617), 1,
      sym__paren_open,
    STATE(8636), 1,
      sym_type_param,
    STATE(8692), 1,
      sym__type_param_invisible,
    STATE(8840), 1,
      sym__prefix_at,
    STATE(8689), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6486), 7,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [346424] = 3,
    ACTIONS(6236), 3,
      anon_sym__,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6238), 16,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_tight_bang,
      sym__cond_prefix_bang,
      sym__cond_tight_tilde,
      sym__cond_prefix_tilde,
      anon_sym_DASH,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [346455] = 11,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6722), 1,
      sym_variable,
    ACTIONS(6724), 1,
      sym_name,
    STATE(3954), 1,
      sym__qualified_variable,
    STATE(4042), 1,
      sym__qualified_constructor,
    STATE(8187), 1,
      sym__paren_open,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10843), 1,
      aux_sym__qualifying_module,
    STATE(4705), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4706), 9,
      sym__qvarid,
      sym__qvar,
      sym__qconid,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [346502] = 9,
    ACTIONS(4582), 1,
      anon_sym_DASH_GT,
    STATE(1589), 1,
      sym__fun_arrow,
    STATE(1590), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4584), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [346544] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6726), 1,
      sym_name,
    STATE(687), 1,
      sym__paren_open,
    STATE(1066), 1,
      sym__bracket_open,
    STATE(7636), 1,
      sym__type_list,
    STATE(7642), 1,
      sym__type_tuple,
    STATE(7651), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10977), 1,
      aux_sym__qualifying_module,
    STATE(7659), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(7655), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7656), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [346596] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6728), 1,
      sym_name,
    STATE(712), 1,
      sym__paren_open,
    STATE(1042), 1,
      sym__bracket_open,
    STATE(4368), 1,
      sym__qualified_constructor,
    STATE(4385), 1,
      sym__type_tuple,
    STATE(4386), 1,
      sym__type_list,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11279), 1,
      aux_sym__qualifying_module,
    STATE(4428), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(4387), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(4423), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [346648] = 14,
    ACTIONS(4564), 1,
      anon_sym_PIPE,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1625), 1,
      sym__linear_fun_arrow,
    STATE(1627), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4566), 5,
      anon_sym_COMMA,
      anon_sym_PIPE2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_POUND_RPAREN,
  [346700] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6730), 1,
      sym_name,
    STATE(710), 1,
      sym__paren_open,
    STATE(1067), 1,
      sym__bracket_open,
    STATE(5954), 1,
      sym__qualified_constructor,
    STATE(5963), 1,
      sym__type_tuple,
    STATE(5964), 1,
      sym__type_list,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11162), 1,
      aux_sym__qualifying_module,
    STATE(5985), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(5965), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(5987), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [346752] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    ACTIONS(4590), 1,
      anon_sym_PIPE,
    STATE(1625), 1,
      sym__linear_fun_arrow,
    STATE(1627), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4592), 5,
      anon_sym_COMMA,
      anon_sym_PIPE2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_POUND_RPAREN,
  [346804] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    ACTIONS(4586), 1,
      anon_sym_PIPE,
    STATE(1625), 1,
      sym__linear_fun_arrow,
    STATE(1627), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4588), 5,
      anon_sym_COMMA,
      anon_sym_PIPE2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_POUND_RPAREN,
  [346856] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    ACTIONS(4578), 1,
      anon_sym_PIPE,
    STATE(1625), 1,
      sym__linear_fun_arrow,
    STATE(1627), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4580), 5,
      anon_sym_COMMA,
      anon_sym_PIPE2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_POUND_RPAREN,
  [346908] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6732), 1,
      sym_name,
    STATE(699), 1,
      sym__paren_open,
    STATE(1017), 1,
      sym__bracket_open,
    STATE(6853), 1,
      sym__qualified_constructor,
    STATE(6868), 1,
      sym__type_list,
    STATE(6882), 1,
      sym__type_tuple,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11319), 1,
      aux_sym__qualifying_module,
    STATE(6947), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6869), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(6944), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [346960] = 9,
    STATE(1625), 1,
      sym__linear_fun_arrow,
    STATE(1627), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4582), 2,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4584), 10,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_COMMA,
      anon_sym_PIPE2,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_POUND_RPAREN,
  [347002] = 16,
    ACTIONS(161), 1,
      anon_sym_POUND,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(6576), 1,
      anon_sym_POUND2,
    ACTIONS(6734), 1,
      sym_variable,
    ACTIONS(6738), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(12149), 1,
      sym__do_keyword,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(6736), 2,
      anon_sym_mdo,
      anon_sym_do,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [347058] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6740), 1,
      sym_name,
    STATE(678), 1,
      sym__paren_open,
    STATE(1104), 1,
      sym__bracket_open,
    STATE(6941), 1,
      sym__type_tuple,
    STATE(6942), 1,
      sym__type_list,
    STATE(6961), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11160), 1,
      aux_sym__qualifying_module,
    STATE(6985), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6943), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(6984), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [347110] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1589), 1,
      sym__fun_arrow,
    STATE(1590), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6742), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [347160] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1589), 1,
      sym__fun_arrow,
    STATE(1590), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4596), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [347210] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1702), 1,
      sym__fun_arrow,
    STATE(1704), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4566), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [347260] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6744), 1,
      sym_name,
    STATE(676), 1,
      sym__paren_open,
    STATE(1041), 1,
      sym__bracket_open,
    STATE(4116), 1,
      sym__type_tuple,
    STATE(4118), 1,
      sym__type_list,
    STATE(4205), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11141), 1,
      aux_sym__qualifying_module,
    STATE(4222), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(4124), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(4225), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [347312] = 16,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    STATE(8500), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11390), 1,
      sym__qualified_varsym,
    STATE(11466), 1,
      sym__qualified_consym,
    STATE(11761), 1,
      sym_constructor_operator,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(11644), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [347368] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6746), 1,
      sym_name,
    STATE(702), 1,
      sym__paren_open,
    STATE(1122), 1,
      sym__bracket_open,
    STATE(4030), 1,
      sym__type_tuple,
    STATE(4033), 1,
      sym__type_list,
    STATE(4042), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11125), 1,
      aux_sym__qualifying_module,
    STATE(4147), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(4034), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(4146), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [347420] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6748), 1,
      sym_name,
    STATE(718), 1,
      sym__paren_open,
    STATE(1071), 1,
      sym__bracket_open,
    STATE(4244), 1,
      sym__type_tuple,
    STATE(4251), 1,
      sym__qualified_constructor,
    STATE(4272), 1,
      sym__type_list,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11218), 1,
      aux_sym__qualifying_module,
    STATE(4267), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(4268), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4273), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [347472] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6750), 1,
      sym_name,
    STATE(681), 1,
      sym__paren_open,
    STATE(1101), 1,
      sym__bracket_open,
    STATE(3072), 1,
      sym__type_tuple,
    STATE(3075), 1,
      sym__type_list,
    STATE(3104), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11164), 1,
      aux_sym__qualifying_module,
    STATE(3114), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(3067), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(3106), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [347524] = 12,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6542), 1,
      sym_variable,
    ACTIONS(6546), 1,
      anon_sym__,
    STATE(8200), 1,
      aux_sym_type_params_repeat1,
    STATE(8630), 1,
      sym__paren_open,
    STATE(8740), 1,
      sym_type_param,
    STATE(8764), 1,
      sym__type_param_invisible,
    STATE(8801), 1,
      sym__prefix_at,
    STATE(8763), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6499), 7,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [347572] = 16,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    STATE(8500), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11499), 1,
      sym__qualified_varsym,
    STATE(11698), 1,
      sym_constructor_operator,
    STATE(12016), 1,
      sym__qualified_consym,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(11473), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [347628] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6752), 1,
      sym_name,
    STATE(692), 1,
      sym__paren_open,
    STATE(1045), 1,
      sym__bracket_open,
    STATE(5886), 1,
      sym__type_tuple,
    STATE(6019), 1,
      sym__type_list,
    STATE(6022), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11088), 1,
      aux_sym__qualifying_module,
    STATE(5967), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(5884), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(5966), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [347680] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1702), 1,
      sym__fun_arrow,
    STATE(1704), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4592), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [347730] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6754), 1,
      sym_name,
    STATE(723), 1,
      sym__paren_open,
    STATE(1047), 1,
      sym__bracket_open,
    STATE(2336), 1,
      sym__type_tuple,
    STATE(2346), 1,
      sym__type_list,
    STATE(2354), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11263), 1,
      aux_sym__qualifying_module,
    STATE(2340), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(2302), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(2305), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [347782] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    ACTIONS(4590), 1,
      anon_sym_PIPE,
    STATE(1625), 1,
      sym__linear_fun_arrow,
    STATE(1627), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4592), 5,
      anon_sym_COMMA,
      anon_sym_PIPE2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_POUND_RPAREN,
  [347834] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6756), 1,
      sym_name,
    STATE(682), 1,
      sym__paren_open,
    STATE(1027), 1,
      sym__bracket_open,
    STATE(7084), 1,
      sym__qualified_constructor,
    STATE(7161), 1,
      sym__type_tuple,
    STATE(7162), 1,
      sym__type_list,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11169), 1,
      aux_sym__qualifying_module,
    STATE(7134), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(7136), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7163), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [347886] = 14,
    ACTIONS(4564), 1,
      anon_sym_PIPE,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1625), 1,
      sym__linear_fun_arrow,
    STATE(1627), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4566), 5,
      anon_sym_COMMA,
      anon_sym_PIPE2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_POUND_RPAREN,
  [347938] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6758), 1,
      sym_name,
    STATE(683), 1,
      sym__paren_open,
    STATE(965), 1,
      sym__bracket_open,
    STATE(6632), 1,
      sym__qualified_constructor,
    STATE(6670), 1,
      sym__type_list,
    STATE(6672), 1,
      sym__type_tuple,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11014), 1,
      aux_sym__qualifying_module,
    STATE(6600), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6601), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6668), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [347990] = 12,
    ACTIONS(6493), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6496), 1,
      sym__cond_prefix_at,
    ACTIONS(6760), 1,
      sym_variable,
    ACTIONS(6763), 1,
      anon_sym__,
    STATE(8200), 1,
      aux_sym_type_params_repeat1,
    STATE(8630), 1,
      sym__paren_open,
    STATE(8740), 1,
      sym_type_param,
    STATE(8764), 1,
      sym__type_param_invisible,
    STATE(8801), 1,
      sym__prefix_at,
    STATE(8763), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6486), 7,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [348038] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1589), 1,
      sym__fun_arrow,
    STATE(1590), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4580), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [348088] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1702), 1,
      sym__fun_arrow,
    STATE(1704), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4588), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [348138] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6766), 1,
      sym_name,
    STATE(675), 1,
      sym__paren_open,
    STATE(1007), 1,
      sym__bracket_open,
    STATE(4062), 1,
      sym__qualified_constructor,
    STATE(4188), 1,
      sym__type_tuple,
    STATE(4227), 1,
      sym__type_list,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11037), 1,
      aux_sym__qualifying_module,
    STATE(4155), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(4151), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4226), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [348190] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6768), 1,
      sym_name,
    STATE(695), 1,
      sym__paren_open,
    STATE(1084), 1,
      sym__bracket_open,
    STATE(5024), 1,
      sym__type_list,
    STATE(5025), 1,
      sym__type_tuple,
    STATE(5073), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11175), 1,
      aux_sym__qualifying_module,
    STATE(4980), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(4979), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5023), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [348242] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1589), 1,
      sym__fun_arrow,
    STATE(1590), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4588), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [348292] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1589), 1,
      sym__fun_arrow,
    STATE(1590), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4592), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [348342] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4566), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [348392] = 16,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    STATE(8500), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11459), 1,
      sym__qualified_consym,
    STATE(11492), 1,
      sym__qualified_varsym,
    STATE(12204), 1,
      sym_constructor_operator,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(11735), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [348448] = 16,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    STATE(8500), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11592), 1,
      sym__qualified_consym,
    STATE(11781), 1,
      sym__qualified_varsym,
    STATE(12207), 1,
      sym_constructor_operator,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(11337), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [348504] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6770), 1,
      sym_name,
    STATE(701), 1,
      sym__paren_open,
    STATE(1090), 1,
      sym__bracket_open,
    STATE(7489), 1,
      sym__qualified_constructor,
    STATE(7524), 1,
      sym__type_tuple,
    STATE(7527), 1,
      sym__type_list,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10925), 1,
      aux_sym__qualifying_module,
    STATE(7520), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(7519), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7539), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [348556] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4592), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [348606] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4566), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [348656] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4592), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [348706] = 16,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    STATE(8500), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11868), 1,
      sym__qualified_varsym,
    STATE(11870), 1,
      sym__qualified_consym,
    STATE(12021), 1,
      sym_constructor_operator,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(12017), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [348762] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4588), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [348812] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4580), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [348862] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6772), 1,
      sym_name,
    STATE(679), 1,
      sym__paren_open,
    STATE(1113), 1,
      sym__bracket_open,
    STATE(6874), 1,
      sym__qualified_constructor,
    STATE(7009), 1,
      sym__type_tuple,
    STATE(7016), 1,
      sym__type_list,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11303), 1,
      aux_sym__qualifying_module,
    STATE(7000), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(7001), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7010), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [348914] = 9,
    ACTIONS(4582), 1,
      anon_sym_DASH_GT,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4584), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [348956] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6774), 1,
      sym_name,
    STATE(721), 1,
      sym__paren_open,
    STATE(1050), 1,
      sym__bracket_open,
    STATE(5813), 1,
      sym__type_tuple,
    STATE(5825), 1,
      sym__qualified_constructor,
    STATE(5841), 1,
      sym__type_list,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11254), 1,
      aux_sym__qualifying_module,
    STATE(5858), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(5839), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(5872), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [349008] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1702), 1,
      sym__fun_arrow,
    STATE(1704), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4566), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [349058] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1702), 1,
      sym__fun_arrow,
    STATE(1704), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4596), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [349108] = 3,
    ACTIONS(4693), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4695), 14,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [349138] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6776), 1,
      sym_name,
    STATE(717), 1,
      sym__paren_open,
    STATE(1061), 1,
      sym__bracket_open,
    STATE(6265), 1,
      sym__type_list,
    STATE(6267), 1,
      sym__type_tuple,
    STATE(6486), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11239), 1,
      aux_sym__qualifying_module,
    STATE(6219), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6215), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6264), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [349190] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6778), 1,
      sym_name,
    STATE(697), 1,
      sym__paren_open,
    STATE(1079), 1,
      sym__bracket_open,
    STATE(3190), 1,
      sym__qualified_constructor,
    STATE(3349), 1,
      sym__type_list,
    STATE(3350), 1,
      sym__type_tuple,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11185), 1,
      aux_sym__qualifying_module,
    STATE(3283), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(3259), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3348), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [349242] = 3,
    ACTIONS(4835), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4837), 14,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [349272] = 16,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    STATE(8500), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(12178), 1,
      sym__qualified_consym,
    STATE(12183), 1,
      sym_constructor_operator,
    STATE(12185), 1,
      sym__qualified_varsym,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(11565), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [349328] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1589), 1,
      sym__fun_arrow,
    STATE(1590), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4566), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [349378] = 16,
    ACTIONS(161), 1,
      anon_sym_POUND,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(6576), 1,
      anon_sym_POUND2,
    ACTIONS(6734), 1,
      sym_variable,
    ACTIONS(6780), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(12149), 1,
      sym__do_keyword,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(6736), 2,
      anon_sym_mdo,
      anon_sym_do,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [349434] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1589), 1,
      sym__fun_arrow,
    STATE(1590), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4592), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [349484] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6782), 1,
      sym_name,
    STATE(690), 1,
      sym__paren_open,
    STATE(964), 1,
      sym__bracket_open,
    STATE(3891), 1,
      sym__type_tuple,
    STATE(3892), 1,
      sym__type_list,
    STATE(3928), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10991), 1,
      aux_sym__qualifying_module,
    STATE(3805), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(3806), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3894), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [349536] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1589), 1,
      sym__fun_arrow,
    STATE(1590), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4566), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [349586] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6784), 1,
      sym_name,
    STATE(696), 1,
      sym__paren_open,
    STATE(1124), 1,
      sym__bracket_open,
    STATE(7205), 1,
      sym__qualified_constructor,
    STATE(7463), 1,
      sym__type_tuple,
    STATE(7481), 1,
      sym__type_list,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11196), 1,
      aux_sym__qualifying_module,
    STATE(7404), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(7405), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7473), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [349638] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6786), 1,
      sym_name,
    STATE(700), 1,
      sym__paren_open,
    STATE(1082), 1,
      sym__bracket_open,
    STATE(7021), 1,
      sym__type_list,
    STATE(7061), 1,
      sym__qualified_constructor,
    STATE(7083), 1,
      sym__type_tuple,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10939), 1,
      aux_sym__qualifying_module,
    STATE(7128), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(7093), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(7131), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [349690] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6788), 1,
      sym_name,
    STATE(729), 1,
      sym__paren_open,
    STATE(955), 1,
      sym__bracket_open,
    STATE(7352), 1,
      sym__qualified_constructor,
    STATE(7425), 1,
      sym__type_list,
    STATE(7436), 1,
      sym__type_tuple,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11078), 1,
      aux_sym__qualifying_module,
    STATE(7410), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(7413), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7420), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [349742] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6790), 1,
      sym_name,
    STATE(709), 1,
      sym__paren_open,
    STATE(1120), 1,
      sym__bracket_open,
    STATE(3233), 1,
      sym__qualified_constructor,
    STATE(3338), 1,
      sym__type_tuple,
    STATE(3339), 1,
      sym__type_list,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11153), 1,
      aux_sym__qualifying_module,
    STATE(3414), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(3340), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(3415), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [349794] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1589), 1,
      sym__fun_arrow,
    STATE(1590), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6792), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [349844] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1589), 1,
      sym__fun_arrow,
    STATE(1590), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4602), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [349894] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1702), 1,
      sym__fun_arrow,
    STATE(1704), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6794), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [349944] = 16,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    STATE(8500), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(12059), 1,
      sym__qualified_varsym,
    STATE(12061), 1,
      sym__qualified_consym,
    STATE(12124), 1,
      sym_constructor_operator,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(12030), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [350000] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6796), 1,
      sym_name,
    STATE(694), 1,
      sym__paren_open,
    STATE(998), 1,
      sym__bracket_open,
    STATE(4342), 1,
      sym__type_list,
    STATE(4349), 1,
      sym__type_tuple,
    STATE(4378), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11314), 1,
      aux_sym__qualifying_module,
    STATE(4346), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(4343), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(4345), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [350052] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6798), 1,
      sym_name,
    STATE(686), 1,
      sym__paren_open,
    STATE(1029), 1,
      sym__bracket_open,
    STATE(6531), 1,
      sym__type_tuple,
    STATE(6532), 1,
      sym__type_list,
    STATE(6552), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11296), 1,
      aux_sym__qualifying_module,
    STATE(6449), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6450), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6533), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [350104] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6800), 1,
      sym_name,
    STATE(719), 1,
      sym__paren_open,
    STATE(1028), 1,
      sym__bracket_open,
    STATE(6413), 1,
      sym__qualified_constructor,
    STATE(6527), 1,
      sym__type_tuple,
    STATE(6529), 1,
      sym__type_list,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11127), 1,
      aux_sym__qualifying_module,
    STATE(6528), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6530), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(6548), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [350156] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6802), 1,
      sym_name,
    STATE(716), 1,
      sym__paren_open,
    STATE(971), 1,
      sym__bracket_open,
    STATE(6151), 1,
      sym__type_tuple,
    STATE(6152), 1,
      sym__type_list,
    STATE(6159), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11236), 1,
      aux_sym__qualifying_module,
    STATE(6066), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6068), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6153), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [350208] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6804), 1,
      sym_name,
    STATE(724), 1,
      sym__paren_open,
    STATE(976), 1,
      sym__bracket_open,
    STATE(3182), 1,
      sym__type_tuple,
    STATE(3253), 1,
      sym__type_list,
    STATE(3312), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11273), 1,
      aux_sym__qualifying_module,
    STATE(3323), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(3237), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(3319), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [350260] = 16,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    STATE(8500), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11532), 1,
      sym_constructor_operator,
    STATE(11913), 1,
      sym__qualified_varsym,
    STATE(12097), 1,
      sym__qualified_consym,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(12077), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [350316] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6806), 1,
      sym_name,
    STATE(732), 1,
      sym__paren_open,
    STATE(1063), 1,
      sym__bracket_open,
    STATE(3697), 1,
      sym__qualified_constructor,
    STATE(3725), 1,
      sym__type_tuple,
    STATE(3732), 1,
      sym__type_list,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11225), 1,
      aux_sym__qualifying_module,
    STATE(3745), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(3746), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3761), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [350368] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1702), 1,
      sym__fun_arrow,
    STATE(1704), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4580), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [350418] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6808), 1,
      sym_name,
    STATE(707), 1,
      sym__paren_open,
    STATE(1078), 1,
      sym__bracket_open,
    STATE(6723), 1,
      sym__qualified_constructor,
    STATE(6806), 1,
      sym__type_tuple,
    STATE(6809), 1,
      sym__type_list,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11197), 1,
      aux_sym__qualifying_module,
    STATE(6836), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6810), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(6838), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [350470] = 16,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    STATE(8500), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11897), 1,
      sym__qualified_varsym,
    STATE(11899), 1,
      sym__qualified_consym,
    STATE(12034), 1,
      sym_constructor_operator,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(12043), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [350526] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1702), 1,
      sym__fun_arrow,
    STATE(1704), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4592), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [350576] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1589), 1,
      sym__fun_arrow,
    STATE(1590), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6810), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [350626] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    ACTIONS(4594), 1,
      anon_sym_PIPE,
    STATE(1625), 1,
      sym__linear_fun_arrow,
    STATE(1627), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4596), 5,
      anon_sym_COMMA,
      anon_sym_PIPE2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_POUND_RPAREN,
  [350678] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6812), 1,
      sym_name,
    STATE(728), 1,
      sym__paren_open,
    STATE(962), 1,
      sym__bracket_open,
    STATE(6223), 1,
      sym__qualified_constructor,
    STATE(6318), 1,
      sym__type_list,
    STATE(6319), 1,
      sym__type_tuple,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11259), 1,
      aux_sym__qualifying_module,
    STATE(6199), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6209), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6317), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [350730] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6814), 1,
      sym_name,
    STATE(727), 1,
      sym__paren_open,
    STATE(963), 1,
      sym__bracket_open,
    STATE(7603), 1,
      sym__type_list,
    STATE(7612), 1,
      sym__type_tuple,
    STATE(7616), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10894), 1,
      aux_sym__qualifying_module,
    STATE(7613), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(7556), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7601), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [350782] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6816), 1,
      sym_name,
    STATE(725), 1,
      sym__paren_open,
    STATE(1055), 1,
      sym__bracket_open,
    STATE(2740), 1,
      sym__type_tuple,
    STATE(2741), 1,
      sym__type_list,
    STATE(2750), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11215), 1,
      aux_sym__qualifying_module,
    STATE(2738), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(2737), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(2747), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [350834] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6818), 1,
      sym_name,
    STATE(714), 1,
      sym__paren_open,
    STATE(1131), 1,
      sym__bracket_open,
    STATE(3525), 1,
      sym__type_list,
    STATE(3528), 1,
      sym__type_tuple,
    STATE(3563), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11144), 1,
      aux_sym__qualifying_module,
    STATE(3577), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(3521), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(3574), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [350886] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6820), 1,
      sym_name,
    STATE(677), 1,
      sym__paren_open,
    STATE(1037), 1,
      sym__bracket_open,
    STATE(4610), 1,
      sym__qualified_constructor,
    STATE(4694), 1,
      sym__type_tuple,
    STATE(4695), 1,
      sym__type_list,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11287), 1,
      aux_sym__qualifying_module,
    STATE(4311), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(4316), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(4655), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [350938] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6822), 1,
      sym_name,
    STATE(713), 1,
      sym__paren_open,
    STATE(1069), 1,
      sym__bracket_open,
    STATE(3474), 1,
      sym__type_tuple,
    STATE(3501), 1,
      sym__qualified_constructor,
    STATE(3536), 1,
      sym__type_list,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11216), 1,
      aux_sym__qualifying_module,
    STATE(3550), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(3535), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(3549), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [350990] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6824), 1,
      sym_name,
    STATE(722), 1,
      sym__paren_open,
    STATE(1130), 1,
      sym__bracket_open,
    STATE(2753), 1,
      sym__type_tuple,
    STATE(2754), 1,
      sym__qualified_constructor,
    STATE(2822), 1,
      sym__type_list,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11150), 1,
      aux_sym__qualifying_module,
    STATE(2810), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(2811), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(2821), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [351042] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6826), 1,
      sym_name,
    STATE(731), 1,
      sym__paren_open,
    STATE(966), 1,
      sym__bracket_open,
    STATE(6794), 1,
      sym__type_tuple,
    STATE(6796), 1,
      sym__type_list,
    STATE(6807), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11199), 1,
      aux_sym__qualifying_module,
    STATE(6830), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6797), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(6831), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [351094] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6828), 1,
      sym_name,
    STATE(680), 1,
      sym__paren_open,
    STATE(995), 1,
      sym__bracket_open,
    STATE(7735), 1,
      sym__qualified_constructor,
    STATE(7775), 1,
      sym__type_tuple,
    STATE(7776), 1,
      sym__type_list,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11326), 1,
      aux_sym__qualifying_module,
    STATE(7757), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(7756), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(7778), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [351146] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4596), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [351196] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6830), 1,
      sym_name,
    STATE(705), 1,
      sym__paren_open,
    STATE(986), 1,
      sym__bracket_open,
    STATE(5978), 1,
      sym__qualified_constructor,
    STATE(6023), 1,
      sym__type_tuple,
    STATE(6024), 1,
      sym__type_list,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11310), 1,
      aux_sym__qualifying_module,
    STATE(5939), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(5953), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6027), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [351248] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6832), 1,
      sym_name,
    STATE(689), 1,
      sym__paren_open,
    STATE(1009), 1,
      sym__bracket_open,
    STATE(7226), 1,
      sym__type_tuple,
    STATE(7228), 1,
      sym__type_list,
    STATE(7451), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11315), 1,
      aux_sym__qualifying_module,
    STATE(7464), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(7234), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(7461), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [351300] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6834), 1,
      sym_name,
    STATE(708), 1,
      sym__paren_open,
    STATE(987), 1,
      sym__bracket_open,
    STATE(4901), 1,
      sym__type_tuple,
    STATE(4902), 1,
      sym__type_list,
    STATE(5082), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10954), 1,
      aux_sym__qualifying_module,
    STATE(4968), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(4903), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(4967), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [351352] = 16,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    STATE(8500), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11991), 1,
      sym__qualified_varsym,
    STATE(11993), 1,
      sym__qualified_consym,
    STATE(12094), 1,
      sym_constructor_operator,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(12003), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [351408] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6836), 1,
      sym_name,
    STATE(693), 1,
      sym__paren_open,
    STATE(1072), 1,
      sym__bracket_open,
    STATE(6091), 1,
      sym__type_list,
    STATE(6092), 1,
      sym__type_tuple,
    STATE(6126), 1,
      sym__qualified_constructor,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10930), 1,
      aux_sym__qualifying_module,
    STATE(6110), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6090), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(6107), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [351460] = 16,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    ACTIONS(6838), 1,
      sym_variable,
    ACTIONS(6840), 1,
      sym_name,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(12149), 1,
      sym__do_keyword,
    STATE(12269), 1,
      sym_constructor_operator,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(6736), 2,
      anon_sym_mdo,
      anon_sym_do,
    STATE(12368), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [351516] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6842), 1,
      sym_name,
    STATE(691), 1,
      sym__paren_open,
    STATE(990), 1,
      sym__bracket_open,
    STATE(6309), 1,
      sym__qualified_constructor,
    STATE(6342), 1,
      sym__type_tuple,
    STATE(6343), 1,
      sym__type_list,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10887), 1,
      aux_sym__qualifying_module,
    STATE(6472), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6344), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    STATE(6471), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [351568] = 9,
    ACTIONS(4582), 1,
      anon_sym_DASH_GT,
    STATE(1702), 1,
      sym__fun_arrow,
    STATE(1704), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4584), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_deriving,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [351610] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6844), 1,
      sym_name,
    STATE(711), 1,
      sym__paren_open,
    STATE(1073), 1,
      sym__bracket_open,
    STATE(3266), 1,
      sym__qualified_constructor,
    STATE(3331), 1,
      sym__type_tuple,
    STATE(3346), 1,
      sym__type_list,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11204), 1,
      aux_sym__qualifying_module,
    STATE(3284), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(3287), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(3347), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [351662] = 16,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    STATE(8500), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(11608), 1,
      sym__qualified_varsym,
    STATE(11753), 1,
      sym_constructor_operator,
    STATE(11769), 1,
      sym__qualified_consym,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(11885), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [351718] = 14,
    ACTIONS(1137), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6846), 1,
      sym_name,
    STATE(706), 1,
      sym__paren_open,
    STATE(982), 1,
      sym__bracket_open,
    STATE(6218), 1,
      sym__qualified_constructor,
    STATE(6395), 1,
      sym__type_list,
    STATE(6398), 1,
      sym__type_tuple,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11281), 1,
      aux_sym__qualifying_module,
    STATE(6314), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(6315), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    STATE(6394), 3,
      sym__plist,
      sym_unit,
      sym_prefix_tuple,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [351770] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1589), 1,
      sym__fun_arrow,
    STATE(1590), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6568), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [351820] = 15,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(1379), 1,
      anon_sym_DASH,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6848), 1,
      sym_name,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(12269), 1,
      sym_constructor_operator,
    STATE(12288), 1,
      sym__arrow,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(1381), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(12368), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [351873] = 14,
    ACTIONS(3557), 1,
      anon_sym_EQ,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    ACTIONS(6854), 1,
      anon_sym_where,
    STATE(1606), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(9105), 1,
      aux_sym__data_repeat1,
    STATE(9107), 1,
      sym__data_rhs,
    STATE(9555), 1,
      sym__gadt,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(3563), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(6850), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [351924] = 3,
    ACTIONS(6692), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6694), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [351953] = 14,
    ACTIONS(3557), 1,
      anon_sym_EQ,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    ACTIONS(6854), 1,
      anon_sym_where,
    STATE(1606), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(9027), 1,
      sym__data_rhs,
    STATE(9028), 1,
      aux_sym__data_repeat1,
    STATE(9555), 1,
      sym__gadt,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(3563), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(6856), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [352004] = 15,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(1379), 1,
      anon_sym_DASH,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(12269), 1,
      sym_constructor_operator,
    STATE(12288), 1,
      sym__arrow,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(1381), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(12368), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [352057] = 14,
    ACTIONS(3557), 1,
      anon_sym_EQ,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    ACTIONS(6854), 1,
      anon_sym_where,
    STATE(1606), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(8954), 1,
      sym__data_rhs,
    STATE(8955), 1,
      aux_sym__data_repeat1,
    STATE(9555), 1,
      sym__gadt,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(3563), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(6858), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [352108] = 3,
    ACTIONS(6860), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6862), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [352137] = 3,
    ACTIONS(5640), 4,
      anon_sym__,
      anon_sym_DASH,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5642), 13,
      sym__cond_qual_dot,
      sym__cond_prefix_dot,
      sym__cond_prefix_at,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [352166] = 3,
    ACTIONS(6864), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6866), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [352195] = 3,
    ACTIONS(6868), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6870), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [352224] = 14,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6872), 1,
      sym_variable,
    ACTIONS(6874), 1,
      anon_sym_LBRACE,
    ACTIONS(6876), 1,
      anon_sym__,
    STATE(8614), 1,
      sym__type_param_invisible,
    STATE(8684), 1,
      sym__paren_open,
    STATE(8795), 1,
      sym__prefix_at,
    STATE(9135), 1,
      sym_type_param,
    STATE(11186), 1,
      sym_quantified_variables,
    STATE(8338), 2,
      sym__inferred_tyvar,
      aux_sym_quantified_variables_repeat1,
    STATE(8616), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(6878), 3,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [352275] = 3,
    ACTIONS(6868), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6870), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [352304] = 3,
    ACTIONS(6712), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6714), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [352333] = 14,
    ACTIONS(3557), 1,
      anon_sym_EQ,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    ACTIONS(6854), 1,
      anon_sym_where,
    STATE(1606), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(9007), 1,
      sym__data_rhs,
    STATE(9010), 1,
      aux_sym__data_repeat1,
    STATE(9555), 1,
      sym__gadt,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(3563), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(6880), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [352384] = 3,
    ACTIONS(6696), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6698), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [352413] = 3,
    ACTIONS(6882), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6884), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [352442] = 15,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(1379), 1,
      anon_sym_DASH,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6886), 1,
      sym_name,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(12269), 1,
      sym_constructor_operator,
    STATE(12288), 1,
      sym__arrow,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(1381), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(12368), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [352495] = 14,
    ACTIONS(3557), 1,
      anon_sym_EQ,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    ACTIONS(6854), 1,
      anon_sym_where,
    STATE(1606), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(9127), 1,
      aux_sym__data_repeat1,
    STATE(9128), 1,
      sym__data_rhs,
    STATE(9555), 1,
      sym__gadt,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(3563), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(6888), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [352546] = 14,
    ACTIONS(3557), 1,
      anon_sym_EQ,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    ACTIONS(6854), 1,
      anon_sym_where,
    STATE(1606), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(9070), 1,
      aux_sym__data_repeat1,
    STATE(9074), 1,
      sym__data_rhs,
    STATE(9555), 1,
      sym__gadt,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(3563), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(6890), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [352597] = 3,
    ACTIONS(6892), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6894), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [352626] = 3,
    ACTIONS(6642), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6644), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [352655] = 14,
    ACTIONS(3557), 1,
      anon_sym_EQ,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    ACTIONS(6854), 1,
      anon_sym_where,
    STATE(1606), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(9009), 1,
      aux_sym__data_repeat1,
    STATE(9011), 1,
      sym__data_rhs,
    STATE(9555), 1,
      sym__gadt,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(3563), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(6896), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [352706] = 3,
    ACTIONS(6898), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6900), 13,
      sym__cond_quote_start,
      sym__cond_splice,
      anon_sym_STAR,
      anon_sym_u2605,
      anon_sym_LBRACK,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [352735] = 14,
    ACTIONS(3557), 1,
      anon_sym_EQ,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    ACTIONS(6854), 1,
      anon_sym_where,
    STATE(1606), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(8991), 1,
      aux_sym__data_repeat1,
    STATE(8992), 1,
      sym__data_rhs,
    STATE(9555), 1,
      sym__gadt,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(3563), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(6902), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [352786] = 8,
    ACTIONS(6278), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6904), 1,
      sym_name,
    STATE(8043), 1,
      sym__paren_open,
    STATE(8993), 1,
      sym__qualified_type,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11308), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9658), 11,
      sym__qtyconid,
      sym__tycon_arrow,
      sym__qtycon_arrow,
      sym__varsym_prefix,
      sym__pvarsym,
      sym__qvarsym_prefix,
      sym__pqvarsym,
      sym__consym_prefix,
      sym__pconsym,
      sym__qconsym_prefix,
      sym__pqconsym,
  [352825] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6906), 5,
      anon_sym_COMMA,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
  [352874] = 17,
    ACTIONS(2663), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    ACTIONS(6908), 1,
      anon_sym_PIPE,
    ACTIONS(6910), 1,
      anon_sym_PIPE2,
    STATE(1625), 1,
      sym__linear_fun_arrow,
    STATE(1627), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9120), 1,
      sym__unboxed_close,
    STATE(9901), 1,
      sym_modifier,
    STATE(9941), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [352931] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6912), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [352979] = 15,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6872), 1,
      sym_variable,
    ACTIONS(6876), 1,
      anon_sym__,
    ACTIONS(6914), 1,
      anon_sym_EQ,
    STATE(1529), 1,
      sym__colon2,
    STATE(8378), 1,
      aux_sym_type_params_repeat1,
    STATE(8614), 1,
      sym__type_param_invisible,
    STATE(8684), 1,
      sym__paren_open,
    STATE(8795), 1,
      sym__prefix_at,
    STATE(9102), 1,
      sym_type_param,
    STATE(10309), 1,
      sym_type_params,
    ACTIONS(6916), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    STATE(8616), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [353031] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6918), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [353079] = 13,
    ACTIONS(6491), 1,
      anon_sym_where,
    ACTIONS(6493), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6496), 1,
      sym__cond_prefix_at,
    ACTIONS(6920), 1,
      sym_variable,
    ACTIONS(6923), 1,
      anon_sym__,
    STATE(8305), 1,
      aux_sym_type_params_repeat1,
    STATE(8688), 1,
      sym__paren_open,
    STATE(8843), 1,
      sym__prefix_at,
    STATE(8900), 1,
      sym__type_param_invisible,
    STATE(8918), 1,
      sym_type_param,
    STATE(8901), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(6486), 4,
      sym__phantom_where,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [353127] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1759), 1,
      sym__fun_arrow,
    STATE(1760), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4566), 4,
      anon_sym_COMMA,
      anon_sym_by,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [353175] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1759), 1,
      sym__fun_arrow,
    STATE(1760), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4592), 4,
      anon_sym_COMMA,
      anon_sym_by,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [353223] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4602), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [353271] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    ACTIONS(4600), 1,
      anon_sym_PIPE,
    STATE(1625), 1,
      sym__linear_fun_arrow,
    STATE(1627), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4602), 3,
      anon_sym_COMMA,
      anon_sym_PIPE2,
      anon_sym_POUND_RPAREN,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [353321] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4584), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [353369] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6926), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [353417] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6928), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [353465] = 3,
    ACTIONS(5201), 2,
      anon_sym_PIPE,
      anon_sym_PIPE2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5203), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_DASH_GT,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_u2192,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [353493] = 9,
    ACTIONS(4582), 1,
      anon_sym_DASH_GT,
    STATE(1466), 1,
      sym__linear_fun_arrow,
    STATE(1468), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4584), 9,
      sym__phantom_arrow,
      sym__cond_dotdot,
      sym__cond_prefix_percent,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_RBRACK,
  [353533] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6930), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [353581] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6932), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [353629] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6934), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [353677] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6936), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [353725] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6938), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [353773] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6940), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [353821] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1466), 1,
      sym__linear_fun_arrow,
    STATE(1468), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4566), 4,
      sym__cond_dotdot,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [353869] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1466), 1,
      sym__linear_fun_arrow,
    STATE(1468), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4592), 4,
      sym__cond_dotdot,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [353917] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1759), 1,
      sym__fun_arrow,
    STATE(1760), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4602), 4,
      anon_sym_COMMA,
      anon_sym_by,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [353965] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6942), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [354013] = 9,
    ACTIONS(4582), 1,
      anon_sym_DASH_GT,
    STATE(1759), 1,
      sym__fun_arrow,
    STATE(1760), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4584), 9,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_COMMA,
      anon_sym_by,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_RBRACK,
  [354053] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1466), 1,
      sym__linear_fun_arrow,
    STATE(1468), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4566), 4,
      sym__cond_dotdot,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [354101] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1466), 1,
      sym__linear_fun_arrow,
    STATE(1468), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4592), 4,
      sym__cond_dotdot,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [354149] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6944), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [354197] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6946), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [354245] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6906), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [354293] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1466), 1,
      sym__linear_fun_arrow,
    STATE(1468), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4588), 4,
      sym__cond_dotdot,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [354341] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1466), 1,
      sym__linear_fun_arrow,
    STATE(1468), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4580), 4,
      sym__cond_dotdot,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [354389] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1466), 1,
      sym__linear_fun_arrow,
    STATE(1468), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4596), 4,
      sym__cond_dotdot,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [354437] = 13,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6501), 1,
      anon_sym_where,
    ACTIONS(6516), 1,
      sym_variable,
    ACTIONS(6518), 1,
      anon_sym__,
    STATE(8305), 1,
      aux_sym_type_params_repeat1,
    STATE(8688), 1,
      sym__paren_open,
    STATE(8843), 1,
      sym__prefix_at,
    STATE(8900), 1,
      sym__type_param_invisible,
    STATE(8918), 1,
      sym_type_param,
    STATE(8901), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(6499), 4,
      sym__phantom_where,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [354485] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1759), 1,
      sym__fun_arrow,
    STATE(1760), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4588), 4,
      anon_sym_COMMA,
      anon_sym_by,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [354533] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6948), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [354581] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    ACTIONS(6950), 1,
      anon_sym_PIPE,
    STATE(1625), 1,
      sym__linear_fun_arrow,
    STATE(1627), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6906), 3,
      anon_sym_COMMA,
      anon_sym_PIPE2,
      anon_sym_POUND_RPAREN,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [354631] = 13,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6872), 1,
      sym_variable,
    ACTIONS(6874), 1,
      anon_sym_LBRACE,
    ACTIONS(6876), 1,
      anon_sym__,
    STATE(8614), 1,
      sym__type_param_invisible,
    STATE(8684), 1,
      sym__paren_open,
    STATE(8795), 1,
      sym__prefix_at,
    STATE(9135), 1,
      sym_type_param,
    STATE(8342), 2,
      sym__inferred_tyvar,
      aux_sym_quantified_variables_repeat1,
    STATE(8616), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(6952), 3,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [354679] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6954), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [354727] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1759), 1,
      sym__fun_arrow,
    STATE(1760), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4566), 4,
      anon_sym_COMMA,
      anon_sym_by,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [354775] = 14,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    ACTIONS(6956), 1,
      anon_sym_PIPE,
    STATE(1625), 1,
      sym__linear_fun_arrow,
    STATE(1627), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6568), 3,
      anon_sym_COMMA,
      anon_sym_PIPE2,
      anon_sym_POUND_RPAREN,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [354825] = 13,
    ACTIONS(6958), 1,
      sym_variable,
    ACTIONS(6961), 1,
      anon_sym_LBRACE,
    ACTIONS(6964), 1,
      anon_sym__,
    ACTIONS(6969), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6972), 1,
      sym__cond_prefix_at,
    STATE(8614), 1,
      sym__type_param_invisible,
    STATE(8684), 1,
      sym__paren_open,
    STATE(8795), 1,
      sym__prefix_at,
    STATE(9135), 1,
      sym_type_param,
    STATE(8342), 2,
      sym__inferred_tyvar,
      aux_sym_quantified_variables_repeat1,
    STATE(8616), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(6967), 3,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [354873] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6975), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [354921] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6977), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [354969] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6979), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [355017] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6981), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [355065] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6983), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [355113] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1466), 1,
      sym__linear_fun_arrow,
    STATE(1468), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4602), 4,
      sym__cond_dotdot,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [355161] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1759), 1,
      sym__fun_arrow,
    STATE(1760), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4592), 4,
      anon_sym_COMMA,
      anon_sym_by,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [355209] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6985), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [355257] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6987), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [355305] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1759), 1,
      sym__fun_arrow,
    STATE(1760), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4596), 4,
      anon_sym_COMMA,
      anon_sym_by,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [355353] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1561), 1,
      sym__fun_arrow,
    STATE(1568), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6989), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [355401] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1759), 1,
      sym__fun_arrow,
    STATE(1760), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4580), 4,
      anon_sym_COMMA,
      anon_sym_by,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [355449] = 3,
    ACTIONS(6991), 4,
      anon_sym__,
      anon_sym_deriving,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6993), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [355476] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1542), 1,
      sym__fun_arrow,
    STATE(1765), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4592), 3,
      sym__cond_layout_end,
      sym__phantom_bar,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [355523] = 3,
    ACTIONS(6995), 4,
      anon_sym__,
      anon_sym_deriving,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6997), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [355550] = 3,
    ACTIONS(6999), 4,
      anon_sym__,
      anon_sym_deriving,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7001), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [355577] = 3,
    ACTIONS(7003), 4,
      anon_sym__,
      anon_sym_deriving,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7005), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [355604] = 3,
    ACTIONS(7007), 4,
      anon_sym__,
      anon_sym_deriving,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7009), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [355631] = 3,
    ACTIONS(7011), 4,
      anon_sym__,
      anon_sym_deriving,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7013), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [355658] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1508), 1,
      sym__fun_arrow,
    STATE(1514), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4566), 3,
      sym__phantom_bar,
      anon_sym_EQ,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [355705] = 10,
    ACTIONS(6532), 1,
      anon_sym_BQUOTE,
    ACTIONS(6534), 1,
      anon_sym_POUND,
    ACTIONS(6536), 1,
      anon_sym_POUND2,
    ACTIONS(6538), 1,
      sym__cond_prefix_dot,
    ACTIONS(6540), 1,
      sym__consym,
    ACTIONS(6602), 1,
      anon_sym_DASH,
    STATE(9955), 1,
      sym__operator_hash_head,
    ACTIONS(6524), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9762), 6,
      sym__variable_ticked,
      sym__constructor_ticked,
      sym_operator,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [355746] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1508), 1,
      sym__fun_arrow,
    STATE(1514), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4592), 3,
      sym__phantom_bar,
      anon_sym_EQ,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [355793] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1508), 1,
      sym__fun_arrow,
    STATE(1514), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4566), 3,
      sym__phantom_bar,
      anon_sym_EQ,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [355840] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1508), 1,
      sym__fun_arrow,
    STATE(1514), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4592), 3,
      sym__phantom_bar,
      anon_sym_EQ,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [355887] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1508), 1,
      sym__fun_arrow,
    STATE(1514), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4588), 3,
      sym__phantom_bar,
      anon_sym_EQ,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [355934] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1508), 1,
      sym__fun_arrow,
    STATE(1514), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4580), 3,
      sym__phantom_bar,
      anon_sym_EQ,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [355981] = 9,
    ACTIONS(4582), 1,
      anon_sym_DASH_GT,
    STATE(1508), 1,
      sym__fun_arrow,
    STATE(1514), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4584), 8,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_percent,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [356020] = 3,
    ACTIONS(7015), 4,
      anon_sym__,
      anon_sym_deriving,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7017), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [356047] = 3,
    ACTIONS(7019), 4,
      anon_sym__,
      anon_sym_deriving,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7021), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [356074] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1508), 1,
      sym__fun_arrow,
    STATE(1514), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4596), 3,
      sym__phantom_bar,
      anon_sym_EQ,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [356121] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1508), 1,
      sym__fun_arrow,
    STATE(1514), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6568), 3,
      sym__phantom_bar,
      anon_sym_EQ,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [356168] = 3,
    ACTIONS(7023), 4,
      anon_sym__,
      anon_sym_deriving,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7025), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [356195] = 3,
    ACTIONS(7027), 4,
      anon_sym__,
      anon_sym_deriving,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7029), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [356222] = 3,
    ACTIONS(4733), 4,
      anon_sym__,
      anon_sym_deriving,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4735), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [356249] = 3,
    ACTIONS(7031), 4,
      anon_sym__,
      anon_sym_deriving,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7033), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [356276] = 12,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6872), 1,
      sym_variable,
    ACTIONS(6876), 1,
      anon_sym__,
    STATE(8379), 1,
      aux_sym_type_params_repeat1,
    STATE(8614), 1,
      sym__type_param_invisible,
    STATE(8684), 1,
      sym__paren_open,
    STATE(8795), 1,
      sym__prefix_at,
    STATE(9102), 1,
      sym_type_param,
    STATE(8616), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(6499), 4,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [356321] = 12,
    ACTIONS(6493), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6496), 1,
      sym__cond_prefix_at,
    ACTIONS(7035), 1,
      sym_variable,
    ACTIONS(7038), 1,
      anon_sym__,
    STATE(8379), 1,
      aux_sym_type_params_repeat1,
    STATE(8614), 1,
      sym__type_param_invisible,
    STATE(8684), 1,
      sym__paren_open,
    STATE(8795), 1,
      sym__prefix_at,
    STATE(9102), 1,
      sym_type_param,
    STATE(8616), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(6486), 4,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [356366] = 3,
    ACTIONS(7041), 4,
      anon_sym__,
      anon_sym_deriving,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7043), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [356393] = 3,
    ACTIONS(7045), 4,
      anon_sym__,
      anon_sym_deriving,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7047), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [356420] = 3,
    ACTIONS(7049), 4,
      anon_sym__,
      anon_sym_deriving,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7051), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [356447] = 12,
    ACTIONS(2721), 1,
      anon_sym_BQUOTE,
    ACTIONS(2723), 1,
      anon_sym_POUND,
    ACTIONS(2725), 1,
      anon_sym_POUND2,
    ACTIONS(2729), 1,
      sym__cond_prefix_dot,
    ACTIONS(2737), 1,
      sym__consym,
    ACTIONS(7053), 1,
      sym__cond_qualified_op,
    ACTIONS(7055), 1,
      sym__cond_minus,
    STATE(8152), 1,
      sym__operator_hash_head,
    ACTIONS(2717), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(2285), 2,
      sym__variable_ticked,
      sym_operator,
    STATE(2291), 3,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_constructor_operator,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [356492] = 3,
    ACTIONS(4713), 4,
      anon_sym__,
      anon_sym_deriving,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4715), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [356519] = 3,
    ACTIONS(4721), 4,
      anon_sym__,
      anon_sym_deriving,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4723), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [356546] = 3,
    ACTIONS(4693), 4,
      anon_sym__,
      anon_sym_deriving,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4695), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [356573] = 3,
    ACTIONS(4709), 4,
      anon_sym__,
      anon_sym_deriving,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4711), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [356600] = 3,
    ACTIONS(7057), 4,
      anon_sym__,
      anon_sym_SQUOTE,
      sym__integer_literal,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7059), 11,
      sym__cond_quote_start,
      sym__cond_splice,
      sym__cond_infix,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_name,
      aux_sym__paren_open_token1,
  [356627] = 15,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    ACTIONS(6558), 1,
      anon_sym_where,
    STATE(1680), 1,
      sym__linear_fun_arrow,
    STATE(1681), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(8863), 1,
      sym__where,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [356678] = 6,
    ACTIONS(7065), 1,
      sym_name,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7061), 5,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_DASH,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(7063), 7,
      sym__cond_prefix_dot,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_DASH_GT,
      anon_sym_POUND2,
      anon_sym_u2192,
  [356711] = 3,
    ACTIONS(4791), 4,
      anon_sym__,
      anon_sym_deriving,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4793), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [356738] = 3,
    ACTIONS(4835), 4,
      anon_sym__,
      anon_sym_deriving,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4837), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [356765] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1542), 1,
      sym__fun_arrow,
    STATE(1765), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4566), 3,
      sym__cond_layout_end,
      sym__phantom_bar,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [356812] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1542), 1,
      sym__fun_arrow,
    STATE(1765), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4592), 3,
      sym__cond_layout_end,
      sym__phantom_bar,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [356859] = 9,
    ACTIONS(4582), 1,
      anon_sym_DASH_GT,
    STATE(1542), 1,
      sym__fun_arrow,
    STATE(1765), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4584), 8,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_percent,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [356898] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1542), 1,
      sym__fun_arrow,
    STATE(1765), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4588), 3,
      sym__cond_layout_end,
      sym__phantom_bar,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [356945] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1542), 1,
      sym__fun_arrow,
    STATE(1765), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4580), 3,
      sym__cond_layout_end,
      sym__phantom_bar,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [356992] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1542), 1,
      sym__fun_arrow,
    STATE(1765), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4602), 3,
      sym__cond_layout_end,
      sym__phantom_bar,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [357039] = 12,
    ACTIONS(2721), 1,
      anon_sym_BQUOTE,
    ACTIONS(2723), 1,
      anon_sym_POUND,
    ACTIONS(2725), 1,
      anon_sym_POUND2,
    ACTIONS(2729), 1,
      sym__cond_prefix_dot,
    ACTIONS(2737), 1,
      sym__consym,
    ACTIONS(7068), 1,
      sym__cond_qualified_op,
    ACTIONS(7070), 1,
      sym__cond_minus,
    STATE(8152), 1,
      sym__operator_hash_head,
    ACTIONS(2717), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(2269), 2,
      sym__variable_ticked,
      sym_operator,
    STATE(2270), 3,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_constructor_operator,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [357084] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1542), 1,
      sym__fun_arrow,
    STATE(1765), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4596), 3,
      sym__cond_layout_end,
      sym__phantom_bar,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [357131] = 10,
    ACTIONS(6532), 1,
      anon_sym_BQUOTE,
    ACTIONS(6534), 1,
      anon_sym_POUND,
    ACTIONS(6536), 1,
      anon_sym_POUND2,
    ACTIONS(6538), 1,
      sym__cond_prefix_dot,
    ACTIONS(6540), 1,
      sym__consym,
    ACTIONS(6602), 1,
      anon_sym_DASH,
    STATE(9955), 1,
      sym__operator_hash_head,
    ACTIONS(6524), 2,
      sym__varsym,
      anon_sym_STAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9587), 6,
      sym__variable_ticked,
      sym__constructor_ticked,
      sym_operator,
      sym__operator_minus,
      sym_constructor_operator,
      sym__constructor_operator_alias,
  [357172] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1542), 1,
      sym__fun_arrow,
    STATE(1765), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4566), 3,
      sym__cond_layout_end,
      sym__phantom_bar,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [357219] = 14,
    ACTIONS(4434), 1,
      aux_sym__paren_close_token1,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(8050), 1,
      sym__paren_close,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [357267] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7072), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [357313] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7074), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [357359] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7076), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [357405] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4592), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [357451] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7078), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [357497] = 14,
    ACTIONS(4438), 1,
      aux_sym__paren_close_token1,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7685), 1,
      sym__paren_close,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [357545] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7080), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [357591] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7082), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [357637] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7084), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [357683] = 14,
    ACTIONS(4473), 1,
      aux_sym__paren_close_token1,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(8027), 1,
      sym__paren_close,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [357731] = 14,
    ACTIONS(4469), 1,
      aux_sym__paren_close_token1,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(7966), 1,
      sym__paren_close,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [357779] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7086), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [357825] = 14,
    ACTIONS(4438), 1,
      aux_sym__paren_close_token1,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7692), 1,
      sym__paren_close,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [357873] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7088), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [357919] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1508), 1,
      sym__fun_arrow,
    STATE(1514), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(6620), 2,
      sym__phantom_bar,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [357965] = 14,
    ACTIONS(4473), 1,
      aux_sym__paren_close_token1,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(8025), 1,
      sym__paren_close,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [358013] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(7090), 2,
      anon_sym_RBRACE,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [358059] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7092), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [358105] = 12,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(6475), 1,
      sym__phantom_where,
    ACTIONS(7096), 1,
      anon_sym_where,
    STATE(8651), 1,
      aux_sym__bind_matches_repeat1,
    STATE(8990), 1,
      sym__bind_match,
    STATE(9510), 1,
      sym__where,
    STATE(10655), 1,
      sym__where_binds,
    STATE(12338), 1,
      sym__bar,
    STATE(12352), 1,
      sym__guards,
    ACTIONS(7094), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [358149] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7098), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [358195] = 14,
    ACTIONS(4438), 1,
      aux_sym__paren_close_token1,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7693), 1,
      sym__paren_close,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [358243] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7100), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [358289] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7102), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [358335] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7104), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [358381] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7106), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [358427] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7108), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [358473] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7110), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [358519] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7112), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [358565] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7114), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [358611] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7116), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [358657] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7118), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [358703] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7120), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [358749] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7122), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [358795] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7124), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [358841] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7126), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [358887] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7128), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [358933] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4566), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [358979] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7130), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [359025] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7132), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [359071] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7134), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [359117] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(7136), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [359163] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7138), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [359209] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7140), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [359255] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1445), 1,
      sym__linear_fun_arrow,
    STATE(1446), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(7136), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [359301] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7142), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [359347] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7144), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [359393] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7146), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [359439] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(6840), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [359485] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1455), 1,
      sym__fun_arrow,
    STATE(1461), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(7136), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [359531] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7148), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [359577] = 14,
    ACTIONS(3411), 1,
      aux_sym__paren_close_token1,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(8062), 1,
      sym__paren_close,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [359625] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7150), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [359671] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7152), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [359717] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7154), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [359763] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7156), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [359809] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7158), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [359855] = 14,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(5547), 1,
      aux_sym__paren_close_token1,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6872), 1,
      sym_variable,
    ACTIONS(6876), 1,
      anon_sym__,
    STATE(8378), 1,
      aux_sym_type_params_repeat1,
    STATE(8614), 1,
      sym__type_param_invisible,
    STATE(8657), 1,
      sym__paren_close,
    STATE(8684), 1,
      sym__paren_open,
    STATE(8795), 1,
      sym__prefix_at,
    STATE(9102), 1,
      sym_type_param,
    STATE(11791), 1,
      sym_type_params,
    STATE(8616), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [359903] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7160), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [359949] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(6738), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [359995] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7162), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [360041] = 14,
    ACTIONS(4469), 1,
      aux_sym__paren_close_token1,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(7965), 1,
      sym__paren_close,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [360089] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7164), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [360135] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(6886), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [360181] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7166), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [360227] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7168), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [360273] = 14,
    ACTIONS(4469), 1,
      aux_sym__paren_close_token1,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(7964), 1,
      sym__paren_close,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [360321] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7170), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [360367] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7172), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [360413] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7174), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [360459] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7176), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [360505] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7178), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [360551] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7180), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [360597] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7182), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [360643] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1680), 1,
      sym__linear_fun_arrow,
    STATE(1681), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4596), 2,
      sym__phantom_where,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [360689] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7184), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [360735] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7186), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [360781] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7188), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [360827] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1680), 1,
      sym__linear_fun_arrow,
    STATE(1681), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4580), 2,
      sym__phantom_where,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [360873] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1680), 1,
      sym__linear_fun_arrow,
    STATE(1681), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4588), 2,
      sym__phantom_where,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [360919] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7190), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [360965] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7192), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [361011] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7194), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [361057] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7196), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [361103] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1680), 1,
      sym__linear_fun_arrow,
    STATE(1681), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4592), 2,
      sym__phantom_where,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [361149] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1680), 1,
      sym__linear_fun_arrow,
    STATE(1681), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4566), 2,
      sym__phantom_where,
      anon_sym_where,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [361195] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7198), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [361241] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1680), 1,
      sym__linear_fun_arrow,
    STATE(1681), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(4592), 2,
      sym__phantom_where,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [361287] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7200), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [361333] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7202), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [361379] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7204), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [361425] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1680), 1,
      sym__linear_fun_arrow,
    STATE(1681), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4566), 2,
      sym__phantom_where,
      anon_sym_where,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [361471] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7206), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [361517] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7208), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [361563] = 14,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(5549), 1,
      aux_sym__paren_close_token1,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6872), 1,
      sym_variable,
    ACTIONS(6876), 1,
      anon_sym__,
    STATE(8375), 1,
      sym__paren_close,
    STATE(8378), 1,
      aux_sym_type_params_repeat1,
    STATE(8614), 1,
      sym__type_param_invisible,
    STATE(8684), 1,
      sym__paren_open,
    STATE(8795), 1,
      sym__prefix_at,
    STATE(9102), 1,
      sym_type_param,
    STATE(11681), 1,
      sym_type_params,
    STATE(8616), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [361611] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7210), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [361657] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7212), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [361703] = 13,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(12269), 1,
      sym_constructor_operator,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(12368), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [361749] = 13,
    ACTIONS(161), 1,
      anon_sym_POUND,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6576), 1,
      anon_sym_POUND2,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [361795] = 3,
    ACTIONS(1125), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(1123), 13,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [361821] = 13,
    ACTIONS(6316), 1,
      anon_sym_DASH,
    ACTIONS(6320), 1,
      anon_sym_POUND,
    ACTIONS(6322), 1,
      anon_sym_POUND2,
    ACTIONS(6324), 1,
      sym_name,
    ACTIONS(6330), 1,
      sym__cond_prefix_dot,
    ACTIONS(6332), 1,
      sym__consym,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    STATE(10048), 1,
      sym__operator_hash_head,
    STATE(10056), 1,
      sym_constructor_operator,
    ACTIONS(6314), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(10057), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [361867] = 14,
    ACTIONS(3411), 1,
      aux_sym__paren_close_token1,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(8076), 1,
      sym__paren_close,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [361915] = 14,
    ACTIONS(4434), 1,
      aux_sym__paren_close_token1,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(8077), 1,
      sym__paren_close,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [361963] = 14,
    ACTIONS(4473), 1,
      aux_sym__paren_close_token1,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(8013), 1,
      sym__paren_close,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [362011] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7214), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [362057] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7216), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [362103] = 9,
    ACTIONS(4582), 1,
      anon_sym_DASH_GT,
    STATE(1680), 1,
      sym__linear_fun_arrow,
    STATE(1681), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4584), 7,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [362141] = 14,
    ACTIONS(3411), 1,
      aux_sym__paren_close_token1,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(8075), 1,
      sym__paren_close,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [362189] = 3,
    ACTIONS(4875), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4877), 13,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [362215] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7218), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [362261] = 3,
    ACTIONS(4863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 13,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_deriving,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [362287] = 3,
    ACTIONS(4871), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4873), 13,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [362313] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7220), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [362359] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7222), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [362405] = 14,
    ACTIONS(4434), 1,
      aux_sym__paren_close_token1,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(8078), 1,
      sym__paren_close,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [362453] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7224), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [362499] = 3,
    ACTIONS(4867), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4869), 13,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [362525] = 3,
    ACTIONS(4863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 13,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [362551] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1455), 1,
      sym__fun_arrow,
    STATE(1461), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(7226), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [362597] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7228), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [362643] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7230), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [362689] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7232), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [362735] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7234), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [362781] = 3,
    ACTIONS(4863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 13,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_deriving,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [362807] = 3,
    ACTIONS(4867), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4869), 13,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_deriving,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [362833] = 3,
    ACTIONS(4871), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4873), 13,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_deriving,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [362859] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7236), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [362905] = 3,
    ACTIONS(4875), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4877), 13,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_deriving,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [362931] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7238), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [362977] = 3,
    ACTIONS(4863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 13,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [363003] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7240), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [363049] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7242), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [363095] = 14,
    ACTIONS(5539), 1,
      aux_sym__paren_close_token1,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6872), 1,
      sym_variable,
    ACTIONS(6876), 1,
      anon_sym__,
    STATE(8378), 1,
      aux_sym_type_params_repeat1,
    STATE(8614), 1,
      sym__type_param_invisible,
    STATE(8684), 1,
      sym__paren_open,
    STATE(8795), 1,
      sym__prefix_at,
    STATE(9092), 1,
      sym__paren_close,
    STATE(9102), 1,
      sym_type_param,
    STATE(11675), 1,
      sym_type_params,
    STATE(8616), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [363143] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7244), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [363189] = 3,
    ACTIONS(1125), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(1123), 13,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_deriving,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [363215] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7246), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [363261] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7248), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [363307] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7250), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [363353] = 14,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(5543), 1,
      aux_sym__paren_close_token1,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6872), 1,
      sym_variable,
    ACTIONS(6876), 1,
      anon_sym__,
    STATE(8378), 1,
      aux_sym_type_params_repeat1,
    STATE(8614), 1,
      sym__type_param_invisible,
    STATE(8684), 1,
      sym__paren_open,
    STATE(8725), 1,
      sym__paren_close,
    STATE(8795), 1,
      sym__prefix_at,
    STATE(9102), 1,
      sym_type_param,
    STATE(11436), 1,
      sym_type_params,
    STATE(8616), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [363401] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7252), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [363447] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7254), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [363493] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7256), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [363539] = 14,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(5551), 1,
      aux_sym__paren_close_token1,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6872), 1,
      sym_variable,
    ACTIONS(6876), 1,
      anon_sym__,
    STATE(8378), 1,
      aux_sym_type_params_repeat1,
    STATE(8614), 1,
      sym__type_param_invisible,
    STATE(8684), 1,
      sym__paren_open,
    STATE(8795), 1,
      sym__prefix_at,
    STATE(8860), 1,
      sym__paren_close,
    STATE(9102), 1,
      sym_type_param,
    STATE(11828), 1,
      sym_type_params,
    STATE(8616), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [363587] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7258), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [363633] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7260), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [363679] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7262), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [363725] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7264), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [363771] = 13,
    ACTIONS(177), 1,
      sym__consym,
    ACTIONS(1147), 1,
      anon_sym_POUND,
    ACTIONS(1155), 1,
      sym__cond_prefix_dot,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    ACTIONS(1709), 1,
      anon_sym_POUND2,
    ACTIONS(7266), 1,
      sym_name,
    STATE(7698), 1,
      sym_constructor_operator,
    STATE(7724), 1,
      sym__operator_hash_head,
    STATE(8390), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(137), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(7701), 2,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [363817] = 14,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(5545), 1,
      aux_sym__paren_close_token1,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6872), 1,
      sym_variable,
    ACTIONS(6876), 1,
      anon_sym__,
    STATE(8378), 1,
      aux_sym_type_params_repeat1,
    STATE(8553), 1,
      sym__paren_close,
    STATE(8614), 1,
      sym__type_param_invisible,
    STATE(8684), 1,
      sym__paren_open,
    STATE(8795), 1,
      sym__prefix_at,
    STATE(9102), 1,
      sym_type_param,
    STATE(11678), 1,
      sym_type_params,
    STATE(8616), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [363865] = 14,
    ACTIONS(7268), 1,
      sym_variable,
    ACTIONS(7270), 1,
      anon_sym_PIPE,
    ACTIONS(7272), 1,
      anon_sym_e,
    ACTIONS(7274), 1,
      anon_sym_t,
    ACTIONS(7276), 1,
      anon_sym_p,
    ACTIONS(7278), 1,
      anon_sym_d,
    ACTIONS(7280), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7282), 1,
      sym_name,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12581), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [363912] = 3,
    ACTIONS(7027), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7029), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [363937] = 14,
    ACTIONS(7268), 1,
      sym_variable,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7284), 1,
      anon_sym_PIPE,
    ACTIONS(7286), 1,
      anon_sym_e,
    ACTIONS(7288), 1,
      anon_sym_t,
    ACTIONS(7290), 1,
      anon_sym_p,
    ACTIONS(7292), 1,
      anon_sym_d,
    ACTIONS(7294), 1,
      anon_sym_PIPE_PIPE,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12413), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [363984] = 14,
    ACTIONS(7268), 1,
      sym_variable,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7296), 1,
      anon_sym_PIPE,
    ACTIONS(7298), 1,
      anon_sym_e,
    ACTIONS(7300), 1,
      anon_sym_t,
    ACTIONS(7302), 1,
      anon_sym_p,
    ACTIONS(7304), 1,
      anon_sym_d,
    ACTIONS(7306), 1,
      anon_sym_PIPE_PIPE,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12304), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [364031] = 3,
    ACTIONS(7023), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7025), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [364056] = 14,
    ACTIONS(7268), 1,
      sym_variable,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7308), 1,
      anon_sym_PIPE,
    ACTIONS(7310), 1,
      anon_sym_e,
    ACTIONS(7312), 1,
      anon_sym_t,
    ACTIONS(7314), 1,
      anon_sym_p,
    ACTIONS(7316), 1,
      anon_sym_d,
    ACTIONS(7318), 1,
      anon_sym_PIPE_PIPE,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12251), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [364103] = 3,
    ACTIONS(7031), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7033), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [364128] = 3,
    ACTIONS(7041), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7043), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [364153] = 3,
    ACTIONS(6991), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6993), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [364178] = 3,
    ACTIONS(7015), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7017), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [364203] = 13,
    ACTIONS(4566), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1646), 1,
      sym__fun_arrow,
    STATE(1647), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [364248] = 3,
    ACTIONS(6995), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6997), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [364273] = 3,
    ACTIONS(6999), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7001), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [364298] = 3,
    ACTIONS(7045), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7047), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [364323] = 3,
    ACTIONS(7003), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7005), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [364348] = 3,
    ACTIONS(4733), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4735), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [364373] = 14,
    ACTIONS(7268), 1,
      sym_variable,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7296), 1,
      anon_sym_PIPE,
    ACTIONS(7298), 1,
      anon_sym_e,
    ACTIONS(7300), 1,
      anon_sym_t,
    ACTIONS(7302), 1,
      anon_sym_p,
    ACTIONS(7304), 1,
      anon_sym_d,
    ACTIONS(7306), 1,
      anon_sym_PIPE_PIPE,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12473), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [364420] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7320), 5,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_DASH,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(7322), 8,
      sym__cond_prefix_dot,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_DASH_GT,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
  [364445] = 3,
    ACTIONS(7007), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7009), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [364470] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7324), 5,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_DASH,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(7326), 8,
      sym__cond_prefix_dot,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_DASH_GT,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
  [364495] = 3,
    ACTIONS(7049), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7051), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [364520] = 13,
    ACTIONS(4566), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1646), 1,
      sym__fun_arrow,
    STATE(1647), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [364565] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7328), 5,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_DASH,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(7330), 8,
      sym__cond_prefix_dot,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_DASH_GT,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
  [364590] = 14,
    ACTIONS(7268), 1,
      sym_variable,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7308), 1,
      anon_sym_PIPE,
    ACTIONS(7310), 1,
      anon_sym_e,
    ACTIONS(7312), 1,
      anon_sym_t,
    ACTIONS(7314), 1,
      anon_sym_p,
    ACTIONS(7316), 1,
      anon_sym_d,
    ACTIONS(7318), 1,
      anon_sym_PIPE_PIPE,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12591), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [364637] = 9,
    ACTIONS(4582), 1,
      anon_sym_DASH_GT,
    STATE(1646), 1,
      sym__fun_arrow,
    STATE(1647), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4584), 6,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_PIPE_PIPE_RBRACK,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [364674] = 12,
    ACTIONS(7332), 1,
      anon_sym_SEMI,
    ACTIONS(7334), 1,
      sym_name,
    ACTIONS(7336), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7338), 1,
      sym__cond_layout_semicolon,
    STATE(8865), 1,
      aux_sym__let_binds_repeat1,
    STATE(9176), 1,
      sym_gadt_constructor,
    STATE(9688), 1,
      sym__layout_end,
    STATE(11306), 1,
      sym__con_binding_list,
    STATE(11672), 1,
      sym__paren_open,
    ACTIONS(7340), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    STATE(9995), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [364717] = 14,
    ACTIONS(7268), 1,
      sym_variable,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7342), 1,
      anon_sym_PIPE,
    ACTIONS(7344), 1,
      anon_sym_e,
    ACTIONS(7346), 1,
      anon_sym_t,
    ACTIONS(7348), 1,
      anon_sym_p,
    ACTIONS(7350), 1,
      anon_sym_d,
    ACTIONS(7352), 1,
      anon_sym_PIPE_PIPE,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12643), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [364764] = 14,
    ACTIONS(7268), 1,
      sym_variable,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7354), 1,
      anon_sym_PIPE,
    ACTIONS(7356), 1,
      anon_sym_e,
    ACTIONS(7358), 1,
      anon_sym_t,
    ACTIONS(7360), 1,
      anon_sym_p,
    ACTIONS(7362), 1,
      anon_sym_d,
    ACTIONS(7364), 1,
      anon_sym_PIPE_PIPE,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12443), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [364811] = 14,
    ACTIONS(7268), 1,
      sym_variable,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7366), 1,
      anon_sym_PIPE,
    ACTIONS(7368), 1,
      anon_sym_e,
    ACTIONS(7370), 1,
      anon_sym_t,
    ACTIONS(7372), 1,
      anon_sym_p,
    ACTIONS(7374), 1,
      anon_sym_d,
    ACTIONS(7376), 1,
      anon_sym_PIPE_PIPE,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12559), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [364858] = 3,
    ACTIONS(5640), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5642), 11,
      sym__cond_qual_dot,
      sym__cond_prefix_dot,
      sym__cond_infix,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_DASH_GT,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [364883] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    ACTIONS(4596), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    STATE(1646), 1,
      sym__fun_arrow,
    STATE(1647), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [364928] = 3,
    ACTIONS(4713), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4715), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [364953] = 14,
    ACTIONS(7268), 1,
      sym_variable,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7378), 1,
      anon_sym_PIPE,
    ACTIONS(7380), 1,
      anon_sym_e,
    ACTIONS(7382), 1,
      anon_sym_t,
    ACTIONS(7384), 1,
      anon_sym_p,
    ACTIONS(7386), 1,
      anon_sym_d,
    ACTIONS(7388), 1,
      anon_sym_PIPE_PIPE,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12473), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [365000] = 3,
    ACTIONS(4721), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4723), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [365025] = 14,
    ACTIONS(7268), 1,
      sym_variable,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7390), 1,
      anon_sym_PIPE,
    ACTIONS(7392), 1,
      anon_sym_e,
    ACTIONS(7394), 1,
      anon_sym_t,
    ACTIONS(7396), 1,
      anon_sym_p,
    ACTIONS(7398), 1,
      anon_sym_d,
    ACTIONS(7400), 1,
      anon_sym_PIPE_PIPE,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12639), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [365072] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    ACTIONS(4580), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    STATE(1646), 1,
      sym__fun_arrow,
    STATE(1647), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [365117] = 3,
    ACTIONS(7011), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7013), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [365142] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    ACTIONS(4588), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    STATE(1646), 1,
      sym__fun_arrow,
    STATE(1647), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [365187] = 14,
    ACTIONS(7268), 1,
      sym_variable,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7402), 1,
      anon_sym_PIPE,
    ACTIONS(7404), 1,
      anon_sym_e,
    ACTIONS(7406), 1,
      anon_sym_t,
    ACTIONS(7408), 1,
      anon_sym_p,
    ACTIONS(7410), 1,
      anon_sym_d,
    ACTIONS(7412), 1,
      anon_sym_PIPE_PIPE,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12645), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [365234] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    ACTIONS(4592), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    STATE(1646), 1,
      sym__fun_arrow,
    STATE(1647), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [365279] = 3,
    ACTIONS(4709), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4711), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [365304] = 14,
    ACTIONS(7268), 1,
      sym_variable,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7308), 1,
      anon_sym_PIPE,
    ACTIONS(7310), 1,
      anon_sym_e,
    ACTIONS(7312), 1,
      anon_sym_t,
    ACTIONS(7314), 1,
      anon_sym_p,
    ACTIONS(7316), 1,
      anon_sym_d,
    ACTIONS(7318), 1,
      anon_sym_PIPE_PIPE,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12270), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [365351] = 14,
    ACTIONS(7268), 1,
      sym_variable,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7366), 1,
      anon_sym_PIPE,
    ACTIONS(7368), 1,
      anon_sym_e,
    ACTIONS(7370), 1,
      anon_sym_t,
    ACTIONS(7372), 1,
      anon_sym_p,
    ACTIONS(7374), 1,
      anon_sym_d,
    ACTIONS(7376), 1,
      anon_sym_PIPE_PIPE,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12641), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [365398] = 3,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7414), 5,
      anon_sym_mdo,
      anon_sym_do,
      anon_sym_DASH,
      anon_sym_POUND,
      sym_variable,
    ACTIONS(7416), 8,
      sym__cond_prefix_dot,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_DASH_GT,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
  [365423] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    ACTIONS(4602), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    STATE(1646), 1,
      sym__fun_arrow,
    STATE(1647), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [365468] = 14,
    ACTIONS(7268), 1,
      sym_variable,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7378), 1,
      anon_sym_PIPE,
    ACTIONS(7380), 1,
      anon_sym_e,
    ACTIONS(7382), 1,
      anon_sym_t,
    ACTIONS(7384), 1,
      anon_sym_p,
    ACTIONS(7386), 1,
      anon_sym_d,
    ACTIONS(7388), 1,
      anon_sym_PIPE_PIPE,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12576), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [365515] = 14,
    ACTIONS(7268), 1,
      sym_variable,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7354), 1,
      anon_sym_PIPE,
    ACTIONS(7356), 1,
      anon_sym_e,
    ACTIONS(7358), 1,
      anon_sym_t,
    ACTIONS(7360), 1,
      anon_sym_p,
    ACTIONS(7362), 1,
      anon_sym_d,
    ACTIONS(7364), 1,
      anon_sym_PIPE_PIPE,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12571), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [365562] = 14,
    ACTIONS(7268), 1,
      sym_variable,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7284), 1,
      anon_sym_PIPE,
    ACTIONS(7286), 1,
      anon_sym_e,
    ACTIONS(7288), 1,
      anon_sym_t,
    ACTIONS(7290), 1,
      anon_sym_p,
    ACTIONS(7292), 1,
      anon_sym_d,
    ACTIONS(7294), 1,
      anon_sym_PIPE_PIPE,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12565), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [365609] = 14,
    ACTIONS(7268), 1,
      sym_variable,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7296), 1,
      anon_sym_PIPE,
    ACTIONS(7298), 1,
      anon_sym_e,
    ACTIONS(7300), 1,
      anon_sym_t,
    ACTIONS(7302), 1,
      anon_sym_p,
    ACTIONS(7304), 1,
      anon_sym_d,
    ACTIONS(7306), 1,
      anon_sym_PIPE_PIPE,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12559), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [365656] = 3,
    ACTIONS(7019), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7021), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [365681] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    ACTIONS(6794), 1,
      anon_sym_instance,
    STATE(1464), 1,
      sym__fun_arrow,
    STATE(1470), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [365726] = 3,
    ACTIONS(4791), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4793), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [365751] = 3,
    ACTIONS(4693), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4695), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [365776] = 3,
    ACTIONS(4835), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4837), 10,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [365801] = 14,
    ACTIONS(7268), 1,
      sym_variable,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7402), 1,
      anon_sym_PIPE,
    ACTIONS(7404), 1,
      anon_sym_e,
    ACTIONS(7406), 1,
      anon_sym_t,
    ACTIONS(7408), 1,
      anon_sym_p,
    ACTIONS(7410), 1,
      anon_sym_d,
    ACTIONS(7412), 1,
      anon_sym_PIPE_PIPE,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12633), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [365848] = 13,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    ACTIONS(4592), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    STATE(1646), 1,
      sym__fun_arrow,
    STATE(1647), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [365893] = 12,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1637), 1,
      sym__fun_arrow,
    STATE(1638), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [365935] = 11,
    ACTIONS(7334), 1,
      sym_name,
    ACTIONS(7336), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7418), 1,
      anon_sym_SEMI,
    STATE(9614), 1,
      aux_sym__let_binds_repeat1,
    STATE(9689), 1,
      sym__layout_end,
    STATE(10810), 1,
      sym_gadt_constructor,
    STATE(11306), 1,
      sym__con_binding_list,
    STATE(11672), 1,
      sym__paren_open,
    ACTIONS(7420), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    STATE(9995), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [365975] = 11,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7422), 1,
      sym_variable,
    ACTIONS(7424), 1,
      anon_sym_RBRACE,
    ACTIONS(7426), 1,
      anon_sym_DOT_DOT,
    STATE(9742), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10432), 1,
      sym__qfield_name,
    STATE(11007), 1,
      sym_field_update,
    STATE(9650), 2,
      sym_field_name,
      sym__field_names,
    STATE(11212), 2,
      sym_field_path,
      sym__field_spec,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [366015] = 11,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7422), 1,
      sym_variable,
    ACTIONS(7426), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7428), 1,
      anon_sym_RBRACE,
    STATE(9742), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10432), 1,
      sym__qfield_name,
    STATE(11048), 1,
      sym_field_update,
    STATE(9650), 2,
      sym_field_name,
      sym__field_names,
    STATE(11212), 2,
      sym_field_path,
      sym__field_spec,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [366055] = 12,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1682), 1,
      sym__linear_fun_arrow,
    STATE(1684), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [366097] = 12,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1578), 1,
      sym__linear_fun_arrow,
    STATE(1579), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [366139] = 3,
    ACTIONS(7007), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7009), 10,
      sym__cond_prefix_at,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [366163] = 12,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1715), 1,
      sym__fun_arrow,
    STATE(1717), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [366205] = 3,
    ACTIONS(7003), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7005), 10,
      sym__cond_prefix_at,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [366229] = 12,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7430), 1,
      sym_variable,
    ACTIONS(7432), 1,
      anon_sym__,
    STATE(8620), 1,
      sym__paren_open,
    STATE(8831), 1,
      sym__prefix_at,
    STATE(9879), 1,
      sym__type_param_invisible,
    STATE(9929), 1,
      sym_type_param,
    STATE(11470), 1,
      sym__ktype_param,
    STATE(12028), 1,
      sym__type_param_annotated,
    STATE(9880), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [366271] = 3,
    ACTIONS(6999), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7001), 10,
      sym__cond_prefix_at,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [366295] = 3,
    ACTIONS(6995), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6997), 10,
      sym__cond_prefix_at,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [366319] = 12,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7430), 1,
      sym_variable,
    ACTIONS(7432), 1,
      anon_sym__,
    STATE(8620), 1,
      sym__paren_open,
    STATE(8831), 1,
      sym__prefix_at,
    STATE(9879), 1,
      sym__type_param_invisible,
    STATE(9929), 1,
      sym_type_param,
    STATE(11714), 1,
      sym__ktype_param,
    STATE(12028), 1,
      sym__type_param_annotated,
    STATE(9880), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [366361] = 11,
    ACTIONS(7334), 1,
      sym_name,
    ACTIONS(7336), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7418), 1,
      anon_sym_SEMI,
    STATE(9614), 1,
      aux_sym__let_binds_repeat1,
    STATE(9668), 1,
      sym__layout_end,
    STATE(10810), 1,
      sym_gadt_constructor,
    STATE(11306), 1,
      sym__con_binding_list,
    STATE(11672), 1,
      sym__paren_open,
    ACTIONS(7434), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    STATE(9995), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [366401] = 11,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7422), 1,
      sym_variable,
    ACTIONS(7426), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7436), 1,
      anon_sym_RBRACE,
    STATE(9742), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10432), 1,
      sym__qfield_name,
    STATE(11063), 1,
      sym_field_update,
    STATE(9650), 2,
      sym_field_name,
      sym__field_names,
    STATE(11212), 2,
      sym_field_path,
      sym__field_spec,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [366441] = 3,
    ACTIONS(7049), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7051), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_PIPE,
      aux_sym__paren_open_token1,
  [366465] = 12,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1501), 1,
      sym__fun_arrow,
    STATE(1506), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [366507] = 3,
    ACTIONS(7045), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7047), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_PIPE,
      aux_sym__paren_open_token1,
  [366531] = 3,
    ACTIONS(6991), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6993), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_PIPE,
      aux_sym__paren_open_token1,
  [366555] = 3,
    ACTIONS(4733), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4735), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_PIPE,
      aux_sym__paren_open_token1,
  [366579] = 3,
    ACTIONS(7041), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7043), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_PIPE,
      aux_sym__paren_open_token1,
  [366603] = 12,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1398), 1,
      sym__linear_fun_arrow,
    STATE(1399), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [366645] = 12,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7430), 1,
      sym_variable,
    ACTIONS(7432), 1,
      anon_sym__,
    STATE(8620), 1,
      sym__paren_open,
    STATE(8831), 1,
      sym__prefix_at,
    STATE(9879), 1,
      sym__type_param_invisible,
    STATE(9929), 1,
      sym_type_param,
    STATE(11375), 1,
      sym__ktype_param,
    STATE(12028), 1,
      sym__type_param_annotated,
    STATE(9880), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [366687] = 12,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7430), 1,
      sym_variable,
    ACTIONS(7432), 1,
      anon_sym__,
    STATE(8620), 1,
      sym__paren_open,
    STATE(8831), 1,
      sym__prefix_at,
    STATE(9879), 1,
      sym__type_param_invisible,
    STATE(9929), 1,
      sym_type_param,
    STATE(11349), 1,
      sym__ktype_param,
    STATE(12028), 1,
      sym__type_param_annotated,
    STATE(9880), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [366729] = 3,
    ACTIONS(1125), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(1123), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_deriving,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [366753] = 3,
    ACTIONS(4875), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4877), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_deriving,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [366777] = 12,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1505), 1,
      sym__fun_arrow,
    STATE(1509), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [366819] = 3,
    ACTIONS(4871), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4873), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_deriving,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [366843] = 3,
    ACTIONS(7031), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7033), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_PIPE,
      aux_sym__paren_open_token1,
  [366867] = 12,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7430), 1,
      sym_variable,
    ACTIONS(7432), 1,
      anon_sym__,
    STATE(8620), 1,
      sym__paren_open,
    STATE(8831), 1,
      sym__prefix_at,
    STATE(9879), 1,
      sym__type_param_invisible,
    STATE(9929), 1,
      sym_type_param,
    STATE(12028), 1,
      sym__type_param_annotated,
    STATE(12404), 1,
      sym__ktype_param,
    STATE(9880), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [366909] = 3,
    ACTIONS(4867), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4869), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_deriving,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [366933] = 5,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7438), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_qualified,
      anon_sym_as,
      anon_sym_hiding,
      aux_sym__paren_open_token1,
  [366961] = 3,
    ACTIONS(4863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_deriving,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [366985] = 7,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    STATE(10067), 1,
      sym__guards,
    STATE(12282), 1,
      sym__bar,
    STATE(8664), 2,
      sym_match,
      aux_sym__matches_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7440), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [367017] = 5,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4614), 8,
      anon_sym_COMMA,
      anon_sym__,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym_BQUOTE,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [367045] = 11,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7422), 1,
      sym_variable,
    ACTIONS(7426), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7444), 1,
      anon_sym_RBRACE,
    STATE(9742), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10432), 1,
      sym__qfield_name,
    STATE(10995), 1,
      sym_field_update,
    STATE(9650), 2,
      sym_field_name,
      sym__field_names,
    STATE(11212), 2,
      sym_field_path,
      sym__field_spec,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [367085] = 3,
    ACTIONS(4863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__phantom_deriving,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_deriving,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [367109] = 3,
    ACTIONS(7015), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7017), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_PIPE,
      aux_sym__paren_open_token1,
  [367133] = 3,
    ACTIONS(7019), 1,
      anon_sym_POUND,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7021), 11,
      sym__cond_prefix_dot,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
  [367157] = 3,
    ACTIONS(4867), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4869), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [367181] = 12,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7430), 1,
      sym_variable,
    ACTIONS(7432), 1,
      anon_sym__,
    STATE(8620), 1,
      sym__paren_open,
    STATE(8831), 1,
      sym__prefix_at,
    STATE(9879), 1,
      sym__type_param_invisible,
    STATE(9929), 1,
      sym_type_param,
    STATE(11917), 1,
      sym__ktype_param,
    STATE(12028), 1,
      sym__type_param_annotated,
    STATE(9880), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [367223] = 3,
    ACTIONS(4693), 1,
      anon_sym_POUND,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4695), 11,
      sym__cond_prefix_dot,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
  [367247] = 12,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1587), 1,
      sym__fun_arrow,
    STATE(1588), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [367289] = 8,
    ACTIONS(7448), 1,
      anon_sym_PIPE,
    ACTIONS(7451), 1,
      sym__phantom_bar,
    STATE(8651), 1,
      aux_sym__bind_matches_repeat1,
    STATE(8990), 1,
      sym__bind_match,
    STATE(12338), 1,
      sym__bar,
    STATE(12352), 1,
      sym__guards,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7446), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [367323] = 3,
    ACTIONS(4835), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4837), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_PIPE,
      aux_sym__paren_open_token1,
  [367347] = 11,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7422), 1,
      sym_variable,
    ACTIONS(7426), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_RBRACE,
    STATE(9742), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10432), 1,
      sym__qfield_name,
    STATE(11111), 1,
      sym_field_update,
    STATE(9650), 2,
      sym_field_name,
      sym__field_names,
    STATE(11212), 2,
      sym_field_path,
      sym__field_spec,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [367387] = 3,
    ACTIONS(4791), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4793), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_PIPE,
      aux_sym__paren_open_token1,
  [367411] = 3,
    ACTIONS(4693), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4695), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_PIPE,
      aux_sym__paren_open_token1,
  [367435] = 12,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1628), 1,
      sym__linear_fun_arrow,
    STATE(1630), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [367477] = 3,
    ACTIONS(7027), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7029), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_PIPE,
      aux_sym__paren_open_token1,
  [367501] = 12,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7430), 1,
      sym_variable,
    ACTIONS(7432), 1,
      anon_sym__,
    STATE(8620), 1,
      sym__paren_open,
    STATE(8831), 1,
      sym__prefix_at,
    STATE(9879), 1,
      sym__type_param_invisible,
    STATE(9929), 1,
      sym_type_param,
    STATE(12001), 1,
      sym__ktype_param,
    STATE(12028), 1,
      sym__type_param_annotated,
    STATE(9880), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [367543] = 12,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1648), 1,
      sym__linear_fun_arrow,
    STATE(1650), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [367585] = 3,
    ACTIONS(7023), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7025), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_PIPE,
      aux_sym__paren_open_token1,
  [367609] = 3,
    ACTIONS(1125), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(1123), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [367633] = 11,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7422), 1,
      sym_variable,
    ACTIONS(7426), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7456), 1,
      anon_sym_RBRACE,
    STATE(9742), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10432), 1,
      sym__qfield_name,
    STATE(10983), 1,
      sym_field_update,
    STATE(9650), 2,
      sym_field_name,
      sym__field_names,
    STATE(11212), 2,
      sym_field_path,
      sym__field_spec,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [367673] = 11,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7422), 1,
      sym_variable,
    ACTIONS(7426), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7458), 1,
      anon_sym_RBRACE,
    STATE(9742), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10432), 1,
      sym__qfield_name,
    STATE(11214), 1,
      sym_field_update,
    STATE(9650), 2,
      sym_field_name,
      sym__field_names,
    STATE(11212), 2,
      sym_field_path,
      sym__field_spec,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [367713] = 7,
    ACTIONS(7462), 1,
      anon_sym_PIPE,
    ACTIONS(7465), 1,
      sym__phantom_bar,
    STATE(10067), 1,
      sym__guards,
    STATE(12282), 1,
      sym__bar,
    STATE(8664), 2,
      sym_match,
      aux_sym__matches_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7460), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [367745] = 3,
    ACTIONS(4875), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4877), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [367769] = 7,
    ACTIONS(6444), 1,
      anon_sym_EQ,
    STATE(1607), 1,
      sym__colon2,
    STATE(8816), 1,
      sym_type_family_result,
    STATE(9661), 1,
      sym__tyfam_inj,
    ACTIONS(7470), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7468), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [367801] = 11,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7422), 1,
      sym_variable,
    ACTIONS(7426), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7472), 1,
      anon_sym_RBRACE,
    STATE(9742), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10432), 1,
      sym__qfield_name,
    STATE(11026), 1,
      sym_field_update,
    STATE(9650), 2,
      sym_field_name,
      sym__field_names,
    STATE(11212), 2,
      sym_field_path,
      sym__field_spec,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [367841] = 12,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1455), 1,
      sym__fun_arrow,
    STATE(1461), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [367883] = 3,
    ACTIONS(7019), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7021), 10,
      sym__cond_prefix_at,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [367907] = 12,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1469), 1,
      sym__linear_fun_arrow,
    STATE(1472), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [367949] = 3,
    ACTIONS(4871), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4873), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [367973] = 11,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7422), 1,
      sym_variable,
    ACTIONS(7426), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7474), 1,
      anon_sym_RBRACE,
    STATE(9742), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10432), 1,
      sym__qfield_name,
    STATE(11020), 1,
      sym_field_update,
    STATE(9650), 2,
      sym_field_name,
      sym__field_names,
    STATE(11212), 2,
      sym_field_path,
      sym__field_spec,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [368013] = 3,
    ACTIONS(4863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [368037] = 3,
    ACTIONS(4863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [368061] = 5,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7476), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_qualified,
      anon_sym_as,
      anon_sym_hiding,
      aux_sym__paren_open_token1,
  [368089] = 3,
    ACTIONS(7011), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7013), 10,
      sym__cond_prefix_at,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [368113] = 3,
    ACTIONS(7007), 1,
      anon_sym_POUND,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7009), 11,
      sym__cond_prefix_dot,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
  [368137] = 11,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7422), 1,
      sym_variable,
    ACTIONS(7426), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7478), 1,
      anon_sym_RBRACE,
    STATE(9742), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10432), 1,
      sym__qfield_name,
    STATE(11081), 1,
      sym_field_update,
    STATE(9650), 2,
      sym_field_name,
      sym__field_names,
    STATE(11212), 2,
      sym_field_path,
      sym__field_spec,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [368177] = 3,
    ACTIONS(7003), 1,
      anon_sym_POUND,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7005), 11,
      sym__cond_prefix_dot,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
  [368201] = 3,
    ACTIONS(4693), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4695), 10,
      sym__cond_prefix_at,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [368225] = 12,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1703), 1,
      sym__linear_fun_arrow,
    STATE(1710), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [368267] = 12,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1556), 1,
      sym__fun_arrow,
    STATE(1559), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [368309] = 3,
    ACTIONS(6995), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6997), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_PIPE,
      aux_sym__paren_open_token1,
  [368333] = 12,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7430), 1,
      sym_variable,
    ACTIONS(7432), 1,
      anon_sym__,
    STATE(8620), 1,
      sym__paren_open,
    STATE(8831), 1,
      sym__prefix_at,
    STATE(9879), 1,
      sym__type_param_invisible,
    STATE(9929), 1,
      sym_type_param,
    STATE(11605), 1,
      sym__ktype_param,
    STATE(12028), 1,
      sym__type_param_annotated,
    STATE(9880), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [368375] = 3,
    ACTIONS(6999), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7001), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_PIPE,
      aux_sym__paren_open_token1,
  [368399] = 12,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1761), 1,
      sym__fun_arrow,
    STATE(1763), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [368441] = 3,
    ACTIONS(7011), 1,
      anon_sym_POUND,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7013), 11,
      sym__cond_prefix_dot,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
  [368465] = 12,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7430), 1,
      sym_variable,
    ACTIONS(7432), 1,
      anon_sym__,
    STATE(8620), 1,
      sym__paren_open,
    STATE(8831), 1,
      sym__prefix_at,
    STATE(9879), 1,
      sym__type_param_invisible,
    STATE(9929), 1,
      sym_type_param,
    STATE(11802), 1,
      sym__ktype_param,
    STATE(12028), 1,
      sym__type_param_annotated,
    STATE(9880), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [368507] = 3,
    ACTIONS(7003), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7005), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_PIPE,
      aux_sym__paren_open_token1,
  [368531] = 3,
    ACTIONS(6999), 1,
      anon_sym_POUND,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7001), 11,
      sym__cond_prefix_dot,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
  [368555] = 3,
    ACTIONS(4709), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4711), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_PIPE,
      aux_sym__paren_open_token1,
  [368579] = 3,
    ACTIONS(7007), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7009), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_PIPE,
      aux_sym__paren_open_token1,
  [368603] = 12,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7430), 1,
      sym_variable,
    ACTIONS(7432), 1,
      anon_sym__,
    STATE(8620), 1,
      sym__paren_open,
    STATE(8831), 1,
      sym__prefix_at,
    STATE(9879), 1,
      sym__type_param_invisible,
    STATE(9929), 1,
      sym_type_param,
    STATE(11961), 1,
      sym__ktype_param,
    STATE(12028), 1,
      sym__type_param_annotated,
    STATE(9880), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [368645] = 3,
    ACTIONS(7011), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7013), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_PIPE,
      aux_sym__paren_open_token1,
  [368669] = 3,
    ACTIONS(4871), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4873), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [368693] = 7,
    ACTIONS(6444), 1,
      anon_sym_EQ,
    STATE(1593), 1,
      sym__colon2,
    STATE(8816), 1,
      sym_type_family_result,
    STATE(9546), 1,
      sym__tyfam_inj,
    ACTIONS(7482), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7480), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [368725] = 12,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7430), 1,
      sym_variable,
    ACTIONS(7432), 1,
      anon_sym__,
    STATE(8620), 1,
      sym__paren_open,
    STATE(8831), 1,
      sym__prefix_at,
    STATE(9879), 1,
      sym__type_param_invisible,
    STATE(9929), 1,
      sym_type_param,
    STATE(11368), 1,
      sym__ktype_param,
    STATE(12028), 1,
      sym__type_param_annotated,
    STATE(9880), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [368767] = 3,
    ACTIONS(1125), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(1123), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [368791] = 12,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7430), 1,
      sym_variable,
    ACTIONS(7432), 1,
      anon_sym__,
    STATE(8620), 1,
      sym__paren_open,
    STATE(8831), 1,
      sym__prefix_at,
    STATE(9879), 1,
      sym__type_param_invisible,
    STATE(9929), 1,
      sym_type_param,
    STATE(11777), 1,
      sym__ktype_param,
    STATE(12028), 1,
      sym__type_param_annotated,
    STATE(9880), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [368833] = 12,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1544), 1,
      sym__linear_fun_arrow,
    STATE(1554), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [368875] = 3,
    ACTIONS(4875), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4877), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [368899] = 3,
    ACTIONS(4713), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4715), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_PIPE,
      aux_sym__paren_open_token1,
  [368923] = 12,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1502), 1,
      sym__linear_fun_arrow,
    STATE(1515), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [368965] = 3,
    ACTIONS(7019), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7021), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_PIPE,
      aux_sym__paren_open_token1,
  [368989] = 3,
    ACTIONS(4721), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4723), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_PIPE,
      aux_sym__paren_open_token1,
  [369013] = 12,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1623), 1,
      sym__linear_fun_arrow,
    STATE(1626), 1,
      sym__fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [369055] = 3,
    ACTIONS(7486), 1,
      sym__integer_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7484), 11,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      sym_variable,
      sym_implicit_variable,
      sym_name,
      sym_label,
      aux_sym__paren_open_token1,
  [369079] = 12,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1670), 1,
      sym__fun_arrow,
    STATE(1674), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [369121] = 12,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1756), 1,
      sym__fun_arrow,
    STATE(1757), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [369163] = 11,
    ACTIONS(7334), 1,
      sym_name,
    ACTIONS(7336), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7418), 1,
      anon_sym_SEMI,
    STATE(9614), 1,
      aux_sym__let_binds_repeat1,
    STATE(9654), 1,
      sym__layout_end,
    STATE(10810), 1,
      sym_gadt_constructor,
    STATE(11306), 1,
      sym__con_binding_list,
    STATE(11672), 1,
      sym__paren_open,
    ACTIONS(7488), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    STATE(9995), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [369203] = 12,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1734), 1,
      sym__fun_arrow,
    STATE(1735), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [369245] = 3,
    ACTIONS(6995), 1,
      anon_sym_POUND,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6997), 11,
      sym__cond_prefix_dot,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
      sym_name,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
  [369269] = 11,
    ACTIONS(7334), 1,
      sym_name,
    ACTIONS(7336), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7418), 1,
      anon_sym_SEMI,
    STATE(9610), 1,
      sym__layout_end,
    STATE(9614), 1,
      aux_sym__let_binds_repeat1,
    STATE(10810), 1,
      sym_gadt_constructor,
    STATE(11306), 1,
      sym__con_binding_list,
    STATE(11672), 1,
      sym__paren_open,
    ACTIONS(7490), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    STATE(9995), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [369309] = 12,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    ACTIONS(4574), 1,
      sym__phantom_arrow,
    ACTIONS(4576), 1,
      sym__cond_prefix_percent,
    STATE(1699), 1,
      sym__fun_arrow,
    STATE(1700), 1,
      sym__linear_fun_arrow,
    STATE(2611), 1,
      sym__prefix_percent,
    STATE(7941), 1,
      sym__linear_arrow,
    STATE(7944), 1,
      sym__arrow,
    STATE(9901), 1,
      sym_modifier,
    ACTIONS(4572), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [369351] = 12,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7430), 1,
      sym_variable,
    ACTIONS(7432), 1,
      anon_sym__,
    STATE(8620), 1,
      sym__paren_open,
    STATE(8831), 1,
      sym__prefix_at,
    STATE(9879), 1,
      sym__type_param_invisible,
    STATE(9929), 1,
      sym_type_param,
    STATE(11695), 1,
      sym__ktype_param,
    STATE(12028), 1,
      sym__type_param_annotated,
    STATE(9880), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [369393] = 3,
    ACTIONS(4863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [369417] = 3,
    ACTIONS(4863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [369441] = 3,
    ACTIONS(4867), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4869), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_SEMI,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [369465] = 12,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7430), 1,
      sym_variable,
    ACTIONS(7432), 1,
      anon_sym__,
    STATE(8620), 1,
      sym__paren_open,
    STATE(8831), 1,
      sym__prefix_at,
    STATE(9879), 1,
      sym__type_param_invisible,
    STATE(9929), 1,
      sym_type_param,
    STATE(12012), 1,
      sym__ktype_param,
    STATE(12028), 1,
      sym__type_param_annotated,
    STATE(9880), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [369507] = 9,
    ACTIONS(6471), 1,
      anon_sym_PIPE,
    ACTIONS(6475), 1,
      sym__phantom_where,
    ACTIONS(6477), 1,
      sym__phantom_bar,
    ACTIONS(7494), 1,
      anon_sym_where,
    STATE(9225), 1,
      sym_fundeps,
    STATE(9246), 1,
      sym__where,
    STATE(11316), 1,
      sym__bar,
    ACTIONS(7492), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [369542] = 11,
    ACTIONS(2881), 1,
      anon_sym_RBRACK,
    ACTIONS(7496), 1,
      anon_sym_COMMA,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    STATE(384), 1,
      sym__arrow,
    STATE(979), 1,
      sym__dotdot,
    STATE(5450), 1,
      sym__bracket_close,
    STATE(10165), 1,
      aux_sym__exp_list_comprehension_repeat1,
    STATE(10168), 1,
      aux_sym__exp_list_repeat1,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [369581] = 3,
    ACTIONS(7506), 2,
      anon_sym_PIPE,
      anon_sym_PIPE2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7504), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      anon_sym_LT_DASH,
      anon_sym_u2190,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [369604] = 9,
    ACTIONS(7336), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7508), 1,
      sym_name,
    STATE(7892), 1,
      sym__qualified_constructor,
    STATE(9646), 1,
      sym__paren_open,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11051), 1,
      aux_sym__qualifying_module,
    STATE(7897), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(7896), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [369639] = 11,
    ACTIONS(2919), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    ACTIONS(7510), 1,
      anon_sym_COMMA,
    STATE(384), 1,
      sym__arrow,
    STATE(1039), 1,
      sym__dotdot,
    STATE(2937), 1,
      sym__bracket_close,
    STATE(10126), 1,
      aux_sym__exp_list_repeat1,
    STATE(10127), 1,
      aux_sym__exp_list_comprehension_repeat1,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [369678] = 3,
    ACTIONS(7027), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7029), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [369701] = 10,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7422), 1,
      sym_variable,
    ACTIONS(7426), 1,
      anon_sym_DOT_DOT,
    STATE(9742), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10432), 1,
      sym__qfield_name,
    STATE(11712), 1,
      sym_field_update,
    STATE(9650), 2,
      sym_field_name,
      sym__field_names,
    STATE(11212), 2,
      sym_field_path,
      sym__field_spec,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [369738] = 3,
    ACTIONS(7023), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7025), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [369761] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4695), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [369782] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4695), 11,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym__,
      anon_sym_EQ,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [369803] = 3,
    ACTIONS(4709), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4711), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [369826] = 11,
    ACTIONS(2857), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    ACTIONS(7512), 1,
      anon_sym_COMMA,
    STATE(384), 1,
      sym__arrow,
    STATE(992), 1,
      sym__dotdot,
    STATE(4856), 1,
      sym__bracket_close,
    STATE(10689), 1,
      aux_sym__exp_list_repeat1,
    STATE(10692), 1,
      aux_sym__exp_list_comprehension_repeat1,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [369865] = 10,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    STATE(1225), 1,
      sym__arrow,
    STATE(9063), 1,
      sym__matches,
    STATE(9608), 1,
      sym__simple_match,
    STATE(10067), 1,
      sym__guards,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(7514), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8641), 2,
      sym_match,
      aux_sym__matches_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [369902] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7516), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [369923] = 11,
    ACTIONS(2887), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    ACTIONS(7518), 1,
      anon_sym_COMMA,
    STATE(384), 1,
      sym__arrow,
    STATE(977), 1,
      sym__dotdot,
    STATE(5249), 1,
      sym__bracket_close,
    STATE(10781), 1,
      aux_sym__exp_list_repeat1,
    STATE(10793), 1,
      aux_sym__exp_list_comprehension_repeat1,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [369962] = 10,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    STATE(1225), 1,
      sym__arrow,
    STATE(9064), 1,
      sym__matches,
    STATE(9608), 1,
      sym__simple_match,
    STATE(10067), 1,
      sym__guards,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(7514), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    STATE(8641), 2,
      sym_match,
      aux_sym__matches_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [369999] = 3,
    ACTIONS(7015), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7017), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [370022] = 9,
    ACTIONS(6471), 1,
      anon_sym_PIPE,
    ACTIONS(6475), 1,
      sym__phantom_where,
    ACTIONS(6477), 1,
      sym__phantom_bar,
    ACTIONS(7522), 1,
      anon_sym_where,
    STATE(9467), 1,
      sym__where,
    STATE(9476), 1,
      sym_fundeps,
    STATE(11316), 1,
      sym__bar,
    ACTIONS(7520), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [370057] = 11,
    ACTIONS(2995), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    ACTIONS(7524), 1,
      anon_sym_COMMA,
    STATE(384), 1,
      sym__arrow,
    STATE(1121), 1,
      sym__dotdot,
    STATE(5002), 1,
      sym__bracket_close,
    STATE(10428), 1,
      aux_sym__exp_list_repeat1,
    STATE(10434), 1,
      aux_sym__exp_list_comprehension_repeat1,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [370096] = 9,
    ACTIONS(7336), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7526), 1,
      sym_name,
    STATE(7995), 1,
      sym__qualified_constructor,
    STATE(9635), 1,
      sym__paren_open,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11247), 1,
      aux_sym__qualifying_module,
    STATE(7982), 2,
      sym__consym_prefix,
      sym__pconsym,
    STATE(7981), 3,
      sym__qconid,
      sym__qconsym_prefix,
      sym__pqconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [370131] = 3,
    ACTIONS(7031), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7033), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [370154] = 3,
    ACTIONS(4733), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4735), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [370177] = 3,
    ACTIONS(6995), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6997), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [370200] = 9,
    ACTIONS(6471), 1,
      anon_sym_PIPE,
    ACTIONS(6475), 1,
      sym__phantom_where,
    ACTIONS(6477), 1,
      sym__phantom_bar,
    ACTIONS(7530), 1,
      anon_sym_where,
    STATE(9422), 1,
      sym_fundeps,
    STATE(9425), 1,
      sym__where,
    STATE(11316), 1,
      sym__bar,
    ACTIONS(7528), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [370235] = 11,
    ACTIONS(2849), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    STATE(384), 1,
      sym__arrow,
    STATE(1015), 1,
      sym__dotdot,
    STATE(5292), 1,
      sym__bracket_close,
    STATE(10403), 1,
      aux_sym__exp_list_comprehension_repeat1,
    STATE(10405), 1,
      aux_sym__exp_list_repeat1,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [370274] = 9,
    ACTIONS(6471), 1,
      anon_sym_PIPE,
    ACTIONS(6475), 1,
      sym__phantom_where,
    ACTIONS(6477), 1,
      sym__phantom_bar,
    ACTIONS(7536), 1,
      anon_sym_where,
    STATE(9402), 1,
      sym__where,
    STATE(9411), 1,
      sym_fundeps,
    STATE(11316), 1,
      sym__bar,
    ACTIONS(7534), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [370309] = 3,
    ACTIONS(7041), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7043), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [370332] = 3,
    ACTIONS(4721), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4723), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [370355] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7021), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [370376] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7013), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [370397] = 3,
    ACTIONS(4713), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4715), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [370420] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7009), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [370441] = 11,
    ACTIONS(2859), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    ACTIONS(7538), 1,
      anon_sym_COMMA,
    STATE(384), 1,
      sym__arrow,
    STATE(1021), 1,
      sym__dotdot,
    STATE(4353), 1,
      sym__bracket_close,
    STATE(10872), 1,
      aux_sym__exp_list_comprehension_repeat1,
    STATE(10882), 1,
      aux_sym__exp_list_repeat1,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [370480] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7005), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [370501] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7001), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [370522] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7516), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [370543] = 3,
    ACTIONS(4791), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4793), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [370566] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7516), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [370587] = 9,
    ACTIONS(241), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      sym__cond_qual_dot,
    ACTIONS(255), 1,
      sym__cond_prefix_dot,
    ACTIONS(5533), 1,
      anon_sym_POUND2,
    ACTIONS(6362), 1,
      anon_sym_DASH,
    STATE(12770), 1,
      sym__operator_hash_head,
    ACTIONS(219), 2,
      sym__varsym,
      anon_sym_STAR,
    STATE(11473), 3,
      sym__operator_qual_dot_head,
      sym_operator,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [370622] = 3,
    ACTIONS(4835), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4837), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [370645] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7516), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [370666] = 3,
    ACTIONS(6999), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7001), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [370689] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7540), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [370710] = 3,
    ACTIONS(7003), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7005), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [370733] = 3,
    ACTIONS(7007), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7009), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [370756] = 3,
    ACTIONS(4693), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4695), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [370779] = 3,
    ACTIONS(7011), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7013), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [370802] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6997), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [370823] = 3,
    ACTIONS(6991), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6993), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [370846] = 3,
    ACTIONS(7045), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7047), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [370869] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7540), 11,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [370890] = 3,
    ACTIONS(7019), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7021), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [370913] = 3,
    ACTIONS(5640), 2,
      anon_sym_DASH,
      anon_sym_POUND,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5642), 9,
      sym__cond_qual_dot,
      sym__cond_prefix_dot,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_DASH_GT,
      anon_sym_POUND2,
      sym_name,
      anon_sym_u2192,
  [370936] = 3,
    ACTIONS(7049), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7051), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_prefix_at,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [370959] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7430), 1,
      sym_variable,
    ACTIONS(7432), 1,
      anon_sym__,
    STATE(8620), 1,
      sym__paren_open,
    STATE(8831), 1,
      sym__prefix_at,
    STATE(9879), 1,
      sym__type_param_invisible,
    STATE(10874), 1,
      sym_type_param,
    STATE(9880), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [370995] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7542), 1,
      sym_variable,
    ACTIONS(7544), 1,
      anon_sym__,
    STATE(8699), 1,
      sym__paren_open,
    STATE(8841), 1,
      sym__prefix_at,
    STATE(8878), 1,
      sym_type_param,
    STATE(8947), 1,
      sym__type_param_invisible,
    STATE(8945), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371031] = 7,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(8778), 1,
      aux_sym_role_annotation_repeat1,
    STATE(9099), 1,
      sym_type_role,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(7546), 4,
      anon_sym__,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371061] = 3,
    ACTIONS(4863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 9,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_COMMA,
      anon_sym_by,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_RBRACK,
  [371083] = 5,
    STATE(8852), 1,
      aux_sym_role_annotation_repeat1,
    STATE(9099), 1,
      sym_type_role,
    ACTIONS(7546), 4,
      anon_sym__,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
    ACTIONS(7548), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371109] = 3,
    ACTIONS(4867), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4869), 9,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_COMMA,
      anon_sym_by,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_RBRACK,
  [371131] = 10,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7550), 1,
      sym_variable,
    ACTIONS(7552), 1,
      anon_sym_RBRACE,
    ACTIONS(7554), 1,
      anon_sym_DOT_DOT,
    STATE(9869), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11067), 1,
      sym__qfield_name,
    STATE(11207), 1,
      sym_field_pattern,
    STATE(11205), 2,
      sym_field_name,
      sym__field_names,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371167] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7556), 1,
      sym_variable,
    ACTIONS(7558), 1,
      anon_sym__,
    STATE(8719), 1,
      sym__paren_open,
    STATE(8837), 1,
      sym__prefix_at,
    STATE(9755), 1,
      sym_type_param,
    STATE(9843), 1,
      sym__type_param_invisible,
    STATE(9844), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371203] = 5,
    STATE(8852), 1,
      aux_sym_role_annotation_repeat1,
    STATE(9099), 1,
      sym_type_role,
    ACTIONS(7546), 4,
      anon_sym__,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
    ACTIONS(7548), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371229] = 5,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7476), 6,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
      anon_sym_qualified,
      anon_sym_as,
      anon_sym_hiding,
      aux_sym__paren_open_token1,
  [371255] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7560), 1,
      sym_variable,
    ACTIONS(7562), 1,
      anon_sym__,
    STATE(8715), 1,
      sym__paren_open,
    STATE(8851), 1,
      sym__prefix_at,
    STATE(9363), 1,
      sym_type_param,
    STATE(9413), 1,
      sym__type_param_invisible,
    STATE(9371), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371291] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7560), 1,
      sym_variable,
    ACTIONS(7562), 1,
      anon_sym__,
    STATE(8715), 1,
      sym__paren_open,
    STATE(8851), 1,
      sym__prefix_at,
    STATE(9361), 1,
      sym_type_param,
    STATE(9413), 1,
      sym__type_param_invisible,
    STATE(9371), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371327] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7556), 1,
      sym_variable,
    ACTIONS(7558), 1,
      anon_sym__,
    STATE(8719), 1,
      sym__paren_open,
    STATE(8837), 1,
      sym__prefix_at,
    STATE(9759), 1,
      sym_type_param,
    STATE(9843), 1,
      sym__type_param_invisible,
    STATE(9844), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371363] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7556), 1,
      sym_variable,
    ACTIONS(7558), 1,
      anon_sym__,
    STATE(8719), 1,
      sym__paren_open,
    STATE(8837), 1,
      sym__prefix_at,
    STATE(9822), 1,
      sym_type_param,
    STATE(9843), 1,
      sym__type_param_invisible,
    STATE(9844), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371399] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7560), 1,
      sym_variable,
    ACTIONS(7562), 1,
      anon_sym__,
    STATE(8715), 1,
      sym__paren_open,
    STATE(8851), 1,
      sym__prefix_at,
    STATE(9356), 1,
      sym_type_param,
    STATE(9413), 1,
      sym__type_param_invisible,
    STATE(9371), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371435] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7560), 1,
      sym_variable,
    ACTIONS(7562), 1,
      anon_sym__,
    STATE(8715), 1,
      sym__paren_open,
    STATE(8851), 1,
      sym__prefix_at,
    STATE(9355), 1,
      sym_type_param,
    STATE(9413), 1,
      sym__type_param_invisible,
    STATE(9371), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371471] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7542), 1,
      sym_variable,
    ACTIONS(7544), 1,
      anon_sym__,
    STATE(8699), 1,
      sym__paren_open,
    STATE(8841), 1,
      sym__prefix_at,
    STATE(8862), 1,
      sym_type_param,
    STATE(8947), 1,
      sym__type_param_invisible,
    STATE(8945), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371507] = 3,
    ACTIONS(4875), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4877), 9,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_COMMA,
      anon_sym_by,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_RBRACK,
  [371529] = 10,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7550), 1,
      sym_variable,
    ACTIONS(7554), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7564), 1,
      anon_sym_RBRACE,
    STATE(9869), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11067), 1,
      sym__qfield_name,
    STATE(11110), 1,
      sym_field_pattern,
    STATE(11205), 2,
      sym_field_name,
      sym__field_names,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371565] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7560), 1,
      sym_variable,
    ACTIONS(7562), 1,
      anon_sym__,
    STATE(8715), 1,
      sym__paren_open,
    STATE(8851), 1,
      sym__prefix_at,
    STATE(9364), 1,
      sym_type_param,
    STATE(9413), 1,
      sym__type_param_invisible,
    STATE(9371), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371601] = 3,
    ACTIONS(1125), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(1123), 9,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_COMMA,
      anon_sym_by,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_RBRACK,
  [371623] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6872), 1,
      sym_variable,
    ACTIONS(6876), 1,
      anon_sym__,
    STATE(8614), 1,
      sym__type_param_invisible,
    STATE(8676), 1,
      sym_type_param,
    STATE(8684), 1,
      sym__paren_open,
    STATE(8795), 1,
      sym__prefix_at,
    STATE(8616), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371659] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7560), 1,
      sym_variable,
    ACTIONS(7562), 1,
      anon_sym__,
    STATE(8715), 1,
      sym__paren_open,
    STATE(8851), 1,
      sym__prefix_at,
    STATE(9341), 1,
      sym_type_param,
    STATE(9413), 1,
      sym__type_param_invisible,
    STATE(9371), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371695] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7556), 1,
      sym_variable,
    ACTIONS(7558), 1,
      anon_sym__,
    STATE(8719), 1,
      sym__paren_open,
    STATE(8837), 1,
      sym__prefix_at,
    STATE(9752), 1,
      sym_type_param,
    STATE(9843), 1,
      sym__type_param_invisible,
    STATE(9844), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371731] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7556), 1,
      sym_variable,
    ACTIONS(7558), 1,
      anon_sym__,
    STATE(8719), 1,
      sym__paren_open,
    STATE(8837), 1,
      sym__prefix_at,
    STATE(9749), 1,
      sym_type_param,
    STATE(9843), 1,
      sym__type_param_invisible,
    STATE(9844), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371767] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7430), 1,
      sym_variable,
    ACTIONS(7432), 1,
      anon_sym__,
    STATE(8620), 1,
      sym__paren_open,
    STATE(8831), 1,
      sym__prefix_at,
    STATE(9879), 1,
      sym__type_param_invisible,
    STATE(10878), 1,
      sym_type_param,
    STATE(9880), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371803] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7566), 1,
      sym_variable,
    ACTIONS(7568), 1,
      anon_sym__,
    STATE(8693), 1,
      sym__paren_open,
    STATE(8800), 1,
      sym__prefix_at,
    STATE(8964), 1,
      sym_type_param,
    STATE(8966), 1,
      sym__type_param_invisible,
    STATE(8967), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371839] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6542), 1,
      sym_variable,
    ACTIONS(6546), 1,
      anon_sym__,
    STATE(8630), 1,
      sym__paren_open,
    STATE(8764), 1,
      sym__type_param_invisible,
    STATE(8766), 1,
      sym_type_param,
    STATE(8801), 1,
      sym__prefix_at,
    STATE(8763), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371875] = 8,
    ACTIONS(7572), 1,
      anon_sym_qualified,
    ACTIONS(7574), 1,
      anon_sym_as,
    ACTIONS(7576), 1,
      anon_sym_hiding,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10201), 1,
      sym_import_list,
    ACTIONS(7570), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371907] = 10,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7550), 1,
      sym_variable,
    ACTIONS(7554), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_RBRACE,
    STATE(9869), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11067), 1,
      sym__qfield_name,
    STATE(11080), 1,
      sym_field_pattern,
    STATE(11205), 2,
      sym_field_name,
      sym__field_names,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371943] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7566), 1,
      sym_variable,
    ACTIONS(7568), 1,
      anon_sym__,
    STATE(8693), 1,
      sym__paren_open,
    STATE(8800), 1,
      sym__prefix_at,
    STATE(8966), 1,
      sym__type_param_invisible,
    STATE(9073), 1,
      sym_type_param,
    STATE(8967), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [371979] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7430), 1,
      sym_variable,
    ACTIONS(7432), 1,
      anon_sym__,
    STATE(8620), 1,
      sym__paren_open,
    STATE(8831), 1,
      sym__prefix_at,
    STATE(9879), 1,
      sym__type_param_invisible,
    STATE(10877), 1,
      sym_type_param,
    STATE(9880), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372015] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7566), 1,
      sym_variable,
    ACTIONS(7568), 1,
      anon_sym__,
    STATE(8693), 1,
      sym__paren_open,
    STATE(8800), 1,
      sym__prefix_at,
    STATE(8966), 1,
      sym__type_param_invisible,
    STATE(9022), 1,
      sym_type_param,
    STATE(8967), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372051] = 10,
    ACTIONS(5527), 1,
      sym_variable,
    ACTIONS(5529), 1,
      anon_sym__,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    STATE(8658), 1,
      sym__paren_open,
    STATE(8677), 1,
      sym__type_param_invisible,
    STATE(8687), 1,
      sym_type_param,
    STATE(8807), 1,
      sym__prefix_at,
    STATE(8679), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372087] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7566), 1,
      sym_variable,
    ACTIONS(7568), 1,
      anon_sym__,
    STATE(8693), 1,
      sym__paren_open,
    STATE(8800), 1,
      sym__prefix_at,
    STATE(8966), 1,
      sym__type_param_invisible,
    STATE(9021), 1,
      sym_type_param,
    STATE(8967), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372123] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7566), 1,
      sym_variable,
    ACTIONS(7568), 1,
      anon_sym__,
    STATE(8693), 1,
      sym__paren_open,
    STATE(8800), 1,
      sym__prefix_at,
    STATE(8966), 1,
      sym__type_param_invisible,
    STATE(9012), 1,
      sym_type_param,
    STATE(8967), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372159] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7566), 1,
      sym_variable,
    ACTIONS(7568), 1,
      anon_sym__,
    STATE(8693), 1,
      sym__paren_open,
    STATE(8800), 1,
      sym__prefix_at,
    STATE(8966), 1,
      sym__type_param_invisible,
    STATE(9002), 1,
      sym_type_param,
    STATE(8967), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372195] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7430), 1,
      sym_variable,
    ACTIONS(7432), 1,
      anon_sym__,
    STATE(8620), 1,
      sym__paren_open,
    STATE(8831), 1,
      sym__prefix_at,
    STATE(9879), 1,
      sym__type_param_invisible,
    STATE(10876), 1,
      sym_type_param,
    STATE(9880), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372231] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7566), 1,
      sym_variable,
    ACTIONS(7568), 1,
      anon_sym__,
    STATE(8693), 1,
      sym__paren_open,
    STATE(8800), 1,
      sym__prefix_at,
    STATE(8966), 1,
      sym__type_param_invisible,
    STATE(9001), 1,
      sym_type_param,
    STATE(8967), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372267] = 10,
    ACTIONS(7582), 1,
      sym_variable,
    ACTIONS(7584), 1,
      sym_safety,
    ACTIONS(7586), 1,
      sym_string,
    ACTIONS(7588), 1,
      aux_sym__paren_open_token1,
    STATE(8758), 1,
      sym__paren_open,
    STATE(9333), 1,
      sym_entity,
    STATE(10480), 1,
      sym_signature,
    STATE(10941), 1,
      sym__var_binding_list,
    STATE(9761), 2,
      sym__varsym_prefix,
      sym__pvarsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372303] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7542), 1,
      sym_variable,
    ACTIONS(7544), 1,
      anon_sym__,
    STATE(8699), 1,
      sym__paren_open,
    STATE(8841), 1,
      sym__prefix_at,
    STATE(8925), 1,
      sym_type_param,
    STATE(8947), 1,
      sym__type_param_invisible,
    STATE(8945), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372339] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7430), 1,
      sym_variable,
    ACTIONS(7432), 1,
      anon_sym__,
    STATE(8620), 1,
      sym__paren_open,
    STATE(8831), 1,
      sym__prefix_at,
    STATE(9879), 1,
      sym__type_param_invisible,
    STATE(10873), 1,
      sym_type_param,
    STATE(9880), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372375] = 6,
    ACTIONS(6477), 1,
      sym__phantom_bar,
    ACTIONS(7592), 1,
      anon_sym_PIPE,
    STATE(9547), 1,
      sym_type_family_injectivity,
    STATE(12309), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7590), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [372403] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7556), 1,
      sym_variable,
    ACTIONS(7558), 1,
      anon_sym__,
    STATE(8719), 1,
      sym__paren_open,
    STATE(8837), 1,
      sym__prefix_at,
    STATE(9754), 1,
      sym_type_param,
    STATE(9843), 1,
      sym__type_param_invisible,
    STATE(9844), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372439] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7594), 1,
      sym_variable,
    ACTIONS(7596), 1,
      anon_sym__,
    STATE(8648), 1,
      sym__paren_open,
    STATE(8749), 1,
      sym_type_param,
    STATE(8751), 1,
      sym__type_param_invisible,
    STATE(8818), 1,
      sym__prefix_at,
    STATE(8753), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372475] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7594), 1,
      sym_variable,
    ACTIONS(7596), 1,
      anon_sym__,
    STATE(8648), 1,
      sym__paren_open,
    STATE(8751), 1,
      sym__type_param_invisible,
    STATE(8770), 1,
      sym_type_param,
    STATE(8818), 1,
      sym__prefix_at,
    STATE(8753), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372511] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7594), 1,
      sym_variable,
    ACTIONS(7596), 1,
      anon_sym__,
    STATE(8648), 1,
      sym__paren_open,
    STATE(8733), 1,
      sym_type_param,
    STATE(8751), 1,
      sym__type_param_invisible,
    STATE(8818), 1,
      sym__prefix_at,
    STATE(8753), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372547] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7594), 1,
      sym_variable,
    ACTIONS(7596), 1,
      anon_sym__,
    STATE(8648), 1,
      sym__paren_open,
    STATE(8751), 1,
      sym__type_param_invisible,
    STATE(8762), 1,
      sym_type_param,
    STATE(8818), 1,
      sym__prefix_at,
    STATE(8753), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372583] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7594), 1,
      sym_variable,
    ACTIONS(7596), 1,
      anon_sym__,
    STATE(8648), 1,
      sym__paren_open,
    STATE(8751), 1,
      sym__type_param_invisible,
    STATE(8760), 1,
      sym_type_param,
    STATE(8818), 1,
      sym__prefix_at,
    STATE(8753), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372619] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6438), 1,
      sym_variable,
    ACTIONS(6442), 1,
      anon_sym__,
    STATE(8570), 1,
      sym__type_param_invisible,
    STATE(8588), 1,
      sym_type_param,
    STATE(8697), 1,
      sym__paren_open,
    STATE(8823), 1,
      sym__prefix_at,
    STATE(8566), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372655] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7594), 1,
      sym_variable,
    ACTIONS(7596), 1,
      anon_sym__,
    STATE(8648), 1,
      sym__paren_open,
    STATE(8751), 1,
      sym__type_param_invisible,
    STATE(8757), 1,
      sym_type_param,
    STATE(8818), 1,
      sym__prefix_at,
    STATE(8753), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372691] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7594), 1,
      sym_variable,
    ACTIONS(7596), 1,
      anon_sym__,
    STATE(8648), 1,
      sym__paren_open,
    STATE(8751), 1,
      sym__type_param_invisible,
    STATE(8755), 1,
      sym_type_param,
    STATE(8818), 1,
      sym__prefix_at,
    STATE(8753), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372727] = 3,
    ACTIONS(4863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 9,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_COMMA,
      anon_sym_by,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_RBRACK,
  [372749] = 8,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7600), 1,
      anon_sym_qualified,
    ACTIONS(7602), 1,
      anon_sym_as,
    ACTIONS(7604), 1,
      anon_sym_hiding,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10254), 1,
      sym_import_list,
    ACTIONS(7598), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372781] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7542), 1,
      sym_variable,
    ACTIONS(7544), 1,
      anon_sym__,
    STATE(8699), 1,
      sym__paren_open,
    STATE(8841), 1,
      sym__prefix_at,
    STATE(8882), 1,
      sym_type_param,
    STATE(8947), 1,
      sym__type_param_invisible,
    STATE(8945), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372817] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7430), 1,
      sym_variable,
    ACTIONS(7432), 1,
      anon_sym__,
    STATE(8620), 1,
      sym__paren_open,
    STATE(8831), 1,
      sym__prefix_at,
    STATE(9879), 1,
      sym__type_param_invisible,
    STATE(10875), 1,
      sym_type_param,
    STATE(9880), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372853] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7542), 1,
      sym_variable,
    ACTIONS(7544), 1,
      anon_sym__,
    STATE(8699), 1,
      sym__paren_open,
    STATE(8841), 1,
      sym__prefix_at,
    STATE(8877), 1,
      sym_type_param,
    STATE(8947), 1,
      sym__type_param_invisible,
    STATE(8945), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372889] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7430), 1,
      sym_variable,
    ACTIONS(7432), 1,
      anon_sym__,
    STATE(8620), 1,
      sym__paren_open,
    STATE(8831), 1,
      sym__prefix_at,
    STATE(9874), 1,
      sym_type_param,
    STATE(9879), 1,
      sym__type_param_invisible,
    STATE(9880), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372925] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7542), 1,
      sym_variable,
    ACTIONS(7544), 1,
      anon_sym__,
    STATE(8699), 1,
      sym__paren_open,
    STATE(8841), 1,
      sym__prefix_at,
    STATE(8875), 1,
      sym_type_param,
    STATE(8947), 1,
      sym__type_param_invisible,
    STATE(8945), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372961] = 8,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7608), 1,
      anon_sym_qualified,
    ACTIONS(7610), 1,
      anon_sym_as,
    ACTIONS(7612), 1,
      anon_sym_hiding,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10239), 1,
      sym_import_list,
    ACTIONS(7606), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [372993] = 8,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7616), 1,
      anon_sym_qualified,
    ACTIONS(7618), 1,
      anon_sym_as,
    ACTIONS(7620), 1,
      anon_sym_hiding,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10242), 1,
      sym_import_list,
    ACTIONS(7614), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [373025] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6240), 1,
      sym_variable,
    ACTIONS(6244), 1,
      anon_sym__,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    STATE(8360), 1,
      sym__type_param_invisible,
    STATE(8361), 1,
      sym_type_param,
    STATE(8631), 1,
      sym__paren_open,
    STATE(8835), 1,
      sym__prefix_at,
    STATE(8359), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [373061] = 3,
    ACTIONS(4863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 9,
      sym__phantom_arrow,
      sym__cond_dotdot,
      sym__cond_prefix_percent,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_RBRACK,
  [373083] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7556), 1,
      sym_variable,
    ACTIONS(7558), 1,
      anon_sym__,
    STATE(8719), 1,
      sym__paren_open,
    STATE(8837), 1,
      sym__prefix_at,
    STATE(9815), 1,
      sym_type_param,
    STATE(9843), 1,
      sym__type_param_invisible,
    STATE(9844), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [373119] = 3,
    ACTIONS(4871), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4873), 9,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_COMMA,
      anon_sym_by,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_RBRACK,
  [373141] = 3,
    ACTIONS(4863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 9,
      sym__phantom_arrow,
      sym__cond_dotdot,
      sym__cond_prefix_percent,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_RBRACK,
  [373163] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6465), 1,
      sym_variable,
    ACTIONS(6469), 1,
      anon_sym__,
    STATE(8617), 1,
      sym__paren_open,
    STATE(8692), 1,
      sym__type_param_invisible,
    STATE(8694), 1,
      sym_type_param,
    STATE(8840), 1,
      sym__prefix_at,
    STATE(8689), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [373199] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7542), 1,
      sym_variable,
    ACTIONS(7544), 1,
      anon_sym__,
    STATE(8699), 1,
      sym__paren_open,
    STATE(8841), 1,
      sym__prefix_at,
    STATE(8946), 1,
      sym_type_param,
    STATE(8947), 1,
      sym__type_param_invisible,
    STATE(8945), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [373235] = 5,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7438), 6,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
      anon_sym_qualified,
      anon_sym_as,
      anon_sym_hiding,
      aux_sym__paren_open_token1,
  [373261] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(6516), 1,
      sym_variable,
    ACTIONS(6518), 1,
      anon_sym__,
    STATE(8688), 1,
      sym__paren_open,
    STATE(8843), 1,
      sym__prefix_at,
    STATE(8884), 1,
      sym_type_param,
    STATE(8900), 1,
      sym__type_param_invisible,
    STATE(8901), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [373297] = 9,
    ACTIONS(7334), 1,
      sym_name,
    ACTIONS(7336), 1,
      aux_sym__paren_open_token1,
    STATE(9652), 1,
      sym__layout_end,
    STATE(10810), 1,
      sym_gadt_constructor,
    STATE(11306), 1,
      sym__con_binding_list,
    STATE(11672), 1,
      sym__paren_open,
    ACTIONS(7622), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    STATE(9995), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [373331] = 9,
    ACTIONS(7334), 1,
      sym_name,
    ACTIONS(7336), 1,
      aux_sym__paren_open_token1,
    STATE(9669), 1,
      sym__layout_end,
    STATE(10810), 1,
      sym_gadt_constructor,
    STATE(11306), 1,
      sym__con_binding_list,
    STATE(11672), 1,
      sym__paren_open,
    ACTIONS(7624), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    STATE(9995), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [373365] = 6,
    ACTIONS(7628), 1,
      anon_sym_PIPE,
    ACTIONS(7630), 1,
      sym__phantom_bar,
    STATE(7723), 1,
      sym__bar,
    STATE(8858), 1,
      aux_sym_data_constructors_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7626), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [373393] = 9,
    ACTIONS(7334), 1,
      sym_name,
    ACTIONS(7336), 1,
      aux_sym__paren_open_token1,
    STATE(9689), 1,
      sym__layout_end,
    STATE(10810), 1,
      sym_gadt_constructor,
    STATE(11306), 1,
      sym__con_binding_list,
    STATE(11672), 1,
      sym__paren_open,
    ACTIONS(7420), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    STATE(9995), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [373427] = 10,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7550), 1,
      sym_variable,
    ACTIONS(7554), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7632), 1,
      anon_sym_RBRACE,
    STATE(9869), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11062), 1,
      sym_field_pattern,
    STATE(11067), 1,
      sym__qfield_name,
    STATE(11205), 2,
      sym_field_name,
      sym__field_names,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [373463] = 9,
    ACTIONS(7334), 1,
      sym_name,
    ACTIONS(7336), 1,
      aux_sym__paren_open_token1,
    STATE(9610), 1,
      sym__layout_end,
    STATE(10810), 1,
      sym_gadt_constructor,
    STATE(11306), 1,
      sym__con_binding_list,
    STATE(11672), 1,
      sym__paren_open,
    ACTIONS(7490), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    STATE(9995), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [373497] = 3,
    ACTIONS(4867), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4869), 9,
      sym__phantom_arrow,
      sym__cond_dotdot,
      sym__cond_prefix_percent,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_RBRACK,
  [373519] = 10,
    ACTIONS(5541), 1,
      sym__cond_prefix_at,
    ACTIONS(6246), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7560), 1,
      sym_variable,
    ACTIONS(7562), 1,
      anon_sym__,
    STATE(8715), 1,
      sym__paren_open,
    STATE(8851), 1,
      sym__prefix_at,
    STATE(9265), 1,
      sym_type_param,
    STATE(9413), 1,
      sym__type_param_invisible,
    STATE(9371), 2,
      sym__type_param_parens,
      sym__type_param_wildcard,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [373555] = 5,
    STATE(8852), 1,
      aux_sym_role_annotation_repeat1,
    STATE(9099), 1,
      sym_type_role,
    ACTIONS(7634), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(7636), 4,
      anon_sym__,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [373581] = 6,
    ACTIONS(7628), 1,
      anon_sym_PIPE,
    ACTIONS(7630), 1,
      sym__phantom_bar,
    STATE(7723), 1,
      sym__bar,
    STATE(8846), 1,
      aux_sym_data_constructors_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7639), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [373609] = 3,
    ACTIONS(4871), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4873), 9,
      sym__phantom_arrow,
      sym__cond_dotdot,
      sym__cond_prefix_percent,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_RBRACK,
  [373631] = 3,
    ACTIONS(4875), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4877), 9,
      sym__phantom_arrow,
      sym__cond_dotdot,
      sym__cond_prefix_percent,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_RBRACK,
  [373653] = 10,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7550), 1,
      sym_variable,
    ACTIONS(7554), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7641), 1,
      anon_sym_RBRACE,
    STATE(9869), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11045), 1,
      sym_field_pattern,
    STATE(11067), 1,
      sym__qfield_name,
    STATE(11205), 2,
      sym_field_name,
      sym__field_names,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [373689] = 3,
    ACTIONS(1125), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(1123), 9,
      sym__phantom_arrow,
      sym__cond_dotdot,
      sym__cond_prefix_percent,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_RBRACK,
  [373711] = 6,
    ACTIONS(7645), 1,
      anon_sym_PIPE,
    ACTIONS(7648), 1,
      sym__phantom_bar,
    STATE(7723), 1,
      sym__bar,
    STATE(8858), 1,
      aux_sym_data_constructors_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7643), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [373739] = 3,
    ACTIONS(7019), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7021), 6,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [373760] = 3,
    ACTIONS(7027), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7029), 6,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [373781] = 3,
    ACTIONS(4867), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4869), 8,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_percent,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [373802] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7516), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [373821] = 4,
    STATE(9556), 1,
      sym_gadt_constructors,
    ACTIONS(7653), 2,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7651), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [373844] = 5,
    ACTIONS(7655), 1,
      sym_variable,
    ACTIONS(7660), 1,
      anon_sym_where,
    STATE(8864), 1,
      aux_sym_type_family_injectivity_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7658), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [373869] = 9,
    ACTIONS(7334), 1,
      sym_name,
    ACTIONS(7336), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    STATE(9426), 1,
      sym_gadt_constructor,
    STATE(11306), 1,
      sym__con_binding_list,
    STATE(11672), 1,
      sym__paren_open,
    STATE(9995), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [373902] = 6,
    ACTIONS(6548), 1,
      anon_sym_EQ,
    STATE(1479), 1,
      sym__colon2,
    STATE(10294), 1,
      sym_type_family_result,
    ACTIONS(7666), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(7664), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [373929] = 3,
    ACTIONS(4871), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4873), 8,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_percent,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [373950] = 3,
    ACTIONS(1125), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(1123), 8,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_percent,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [373971] = 9,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(4142), 1,
      anon_sym_EQ,
    ACTIONS(6854), 1,
      anon_sym_where,
    STATE(1572), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(9109), 1,
      sym__gadt,
    STATE(10547), 1,
      sym__newtype,
    ACTIONS(4146), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [374004] = 9,
    ACTIONS(2347), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    ACTIONS(7670), 1,
      anon_sym_PIPE,
    ACTIONS(7672), 1,
      anon_sym_PIPE2,
    STATE(379), 1,
      sym__arrow,
    STATE(4857), 1,
      sym__unboxed_close,
    STATE(10697), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [374037] = 6,
    ACTIONS(6548), 1,
      anon_sym_EQ,
    STATE(1597), 1,
      sym__colon2,
    STATE(10506), 1,
      sym_type_family_result,
    ACTIONS(7676), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(7674), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [374064] = 6,
    ACTIONS(6548), 1,
      anon_sym_EQ,
    STATE(1591), 1,
      sym__colon2,
    STATE(10503), 1,
      sym_type_family_result,
    ACTIONS(7680), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(7678), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [374091] = 3,
    ACTIONS(4863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 8,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_percent,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [374112] = 8,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7879), 1,
      sym__paren_open,
    STATE(12173), 1,
      sym_children,
    ACTIONS(7682), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [374143] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7516), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [374162] = 9,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(4142), 1,
      anon_sym_EQ,
    ACTIONS(6854), 1,
      anon_sym_where,
    STATE(1572), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(9109), 1,
      sym__gadt,
    STATE(10636), 1,
      sym__newtype,
    ACTIONS(4146), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [374195] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7540), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [374214] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7540), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [374233] = 9,
    ACTIONS(2081), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    ACTIONS(7684), 1,
      anon_sym_PIPE,
    ACTIONS(7686), 1,
      anon_sym_PIPE2,
    STATE(379), 1,
      sym__arrow,
    STATE(2938), 1,
      sym__unboxed_close,
    STATE(10131), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [374266] = 3,
    ACTIONS(4709), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4711), 6,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [374287] = 3,
    ACTIONS(7049), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7051), 6,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [374308] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7516), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [374327] = 4,
    STATE(9584), 1,
      sym_gadt_constructors,
    ACTIONS(7653), 2,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7688), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [374350] = 3,
    ACTIONS(7011), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7013), 6,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [374371] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4695), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [374390] = 9,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(6838), 1,
      sym_variable,
    ACTIONS(7690), 1,
      sym_name,
    STATE(9251), 1,
      aux_sym__qualifying_module,
    STATE(9892), 1,
      sym__modid_prefix,
    STATE(12149), 1,
      sym__do_keyword,
    STATE(12269), 1,
      sym_constructor_operator,
    ACTIONS(6736), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [374423] = 3,
    ACTIONS(4863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 8,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_percent,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [374444] = 10,
    ACTIONS(4658), 1,
      anon_sym_EQ,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    STATE(8422), 1,
      aux_sym__bind_matches_repeat1,
    STATE(8990), 1,
      sym__bind_match,
    STATE(9050), 1,
      sym__simple_bind_match,
    STATE(10224), 1,
      sym__bind_matches,
    STATE(12338), 1,
      sym__bar,
    STATE(12352), 1,
      sym__guards,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [374479] = 3,
    ACTIONS(4713), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4715), 6,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [374500] = 3,
    ACTIONS(4721), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4723), 6,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [374521] = 9,
    ACTIONS(2511), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    ACTIONS(7692), 1,
      anon_sym_PIPE,
    ACTIONS(7694), 1,
      anon_sym_PIPE2,
    STATE(379), 1,
      sym__arrow,
    STATE(5250), 1,
      sym__unboxed_close,
    STATE(10797), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [374554] = 9,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(4142), 1,
      anon_sym_EQ,
    ACTIONS(6854), 1,
      anon_sym_where,
    STATE(1572), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(9109), 1,
      sym__gadt,
    STATE(10552), 1,
      sym__newtype,
    ACTIONS(4146), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [374587] = 7,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7698), 1,
      anon_sym_as,
    ACTIONS(7700), 1,
      anon_sym_hiding,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10155), 1,
      sym_import_list,
    ACTIONS(7696), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [374616] = 9,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(4142), 1,
      anon_sym_EQ,
    ACTIONS(6854), 1,
      anon_sym_where,
    STATE(1572), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(9109), 1,
      sym__gadt,
    STATE(10618), 1,
      sym__newtype,
    ACTIONS(4146), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [374649] = 3,
    ACTIONS(7045), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7047), 6,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [374670] = 3,
    ACTIONS(4693), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4695), 6,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [374691] = 9,
    ACTIONS(7334), 1,
      sym_name,
    ACTIONS(7336), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    STATE(10810), 1,
      sym_gadt_constructor,
    STATE(11306), 1,
      sym__con_binding_list,
    STATE(11672), 1,
      sym__paren_open,
    STATE(9995), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [374724] = 3,
    ACTIONS(6991), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6993), 6,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [374745] = 3,
    ACTIONS(7041), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7043), 6,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [374766] = 3,
    ACTIONS(7007), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7009), 6,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [374787] = 3,
    ACTIONS(7003), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7005), 6,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [374808] = 3,
    ACTIONS(6999), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7001), 6,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [374829] = 3,
    ACTIONS(6995), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6997), 6,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [374850] = 3,
    ACTIONS(4875), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4877), 8,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_percent,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [374871] = 10,
    ACTIONS(4658), 1,
      anon_sym_EQ,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    STATE(8422), 1,
      aux_sym__bind_matches_repeat1,
    STATE(8990), 1,
      sym__bind_match,
    STATE(9050), 1,
      sym__simple_bind_match,
    STATE(10235), 1,
      sym__bind_matches,
    STATE(12338), 1,
      sym__bar,
    STATE(12352), 1,
      sym__guards,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [374906] = 5,
    ACTIONS(7702), 1,
      sym_variable,
    ACTIONS(7706), 1,
      anon_sym_where,
    STATE(8864), 1,
      aux_sym_type_family_injectivity_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7704), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [374931] = 9,
    ACTIONS(2211), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    ACTIONS(7708), 1,
      anon_sym_PIPE,
    ACTIONS(7710), 1,
      anon_sym_PIPE2,
    STATE(379), 1,
      sym__arrow,
    STATE(5001), 1,
      sym__unboxed_close,
    STATE(10436), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [374964] = 3,
    ACTIONS(4791), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4793), 6,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [374985] = 3,
    ACTIONS(4835), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4837), 6,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [375006] = 9,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(4142), 1,
      anon_sym_EQ,
    ACTIONS(6854), 1,
      anon_sym_where,
    STATE(1572), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(9109), 1,
      sym__gadt,
    STATE(10045), 1,
      sym__newtype,
    ACTIONS(4146), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [375039] = 9,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(4142), 1,
      anon_sym_EQ,
    ACTIONS(6854), 1,
      anon_sym_where,
    STATE(1572), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(9109), 1,
      sym__gadt,
    STATE(10524), 1,
      sym__newtype,
    ACTIONS(4146), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [375072] = 6,
    ACTIONS(6548), 1,
      anon_sym_EQ,
    STATE(1538), 1,
      sym__colon2,
    STATE(10762), 1,
      sym_type_family_result,
    ACTIONS(7714), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(7712), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [375099] = 9,
    ACTIONS(2197), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    ACTIONS(7716), 1,
      anon_sym_PIPE,
    ACTIONS(7718), 1,
      anon_sym_PIPE2,
    STATE(379), 1,
      sym__arrow,
    STATE(5291), 1,
      sym__unboxed_close,
    STATE(10400), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [375132] = 10,
    ACTIONS(4658), 1,
      anon_sym_EQ,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    STATE(8422), 1,
      aux_sym__bind_matches_repeat1,
    STATE(8990), 1,
      sym__bind_match,
    STATE(9050), 1,
      sym__simple_bind_match,
    STATE(10250), 1,
      sym__bind_matches,
    STATE(12338), 1,
      sym__bar,
    STATE(12352), 1,
      sym__guards,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [375167] = 9,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(4142), 1,
      anon_sym_EQ,
    ACTIONS(6854), 1,
      anon_sym_where,
    STATE(1572), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(9109), 1,
      sym__gadt,
    STATE(10084), 1,
      sym__newtype,
    ACTIONS(4146), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [375200] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4837), 9,
      anon_sym_COMMA,
      anon_sym__,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [375219] = 3,
    ACTIONS(7015), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7017), 6,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [375240] = 3,
    ACTIONS(7031), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7033), 6,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [375261] = 3,
    ACTIONS(4733), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4735), 6,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [375282] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4793), 9,
      anon_sym_COMMA,
      anon_sym__,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [375301] = 9,
    ACTIONS(7586), 1,
      sym_string,
    ACTIONS(7588), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7720), 1,
      sym_variable,
    STATE(8758), 1,
      sym__paren_open,
    STATE(9330), 1,
      sym_entity,
    STATE(10473), 1,
      sym_signature,
    STATE(10941), 1,
      sym__var_binding_list,
    STATE(9761), 2,
      sym__varsym_prefix,
      sym__pvarsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [375334] = 3,
    ACTIONS(4871), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4873), 8,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_percent,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [375355] = 6,
    ACTIONS(7724), 1,
      anon_sym_in,
    ACTIONS(7728), 1,
      sym__phantom_in,
    STATE(9640), 1,
      sym__let_binds,
    ACTIONS(7726), 2,
      sym__cmd_layout_start_let,
      sym__cmd_layout_start_explicit,
    ACTIONS(7722), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [375382] = 3,
    ACTIONS(5640), 4,
      anon_sym_type,
      anon_sym_pattern,
      anon_sym_module,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5642), 5,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      sym_name,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [375403] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7516), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [375422] = 9,
    ACTIONS(3567), 1,
      sym__phantom_where,
    ACTIONS(4142), 1,
      anon_sym_EQ,
    ACTIONS(6854), 1,
      anon_sym_where,
    STATE(1572), 1,
      sym__colon2,
    STATE(8883), 1,
      sym__where,
    STATE(9109), 1,
      sym__gadt,
    STATE(10812), 1,
      sym__newtype,
    ACTIONS(4146), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [375455] = 3,
    ACTIONS(1125), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(1123), 8,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_percent,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [375476] = 9,
    ACTIONS(2023), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    ACTIONS(7730), 1,
      anon_sym_PIPE,
    ACTIONS(7732), 1,
      anon_sym_PIPE2,
    STATE(379), 1,
      sym__arrow,
    STATE(4358), 1,
      sym__unboxed_close,
    STATE(10867), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [375509] = 7,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7736), 1,
      anon_sym_as,
    ACTIONS(7738), 1,
      anon_sym_hiding,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10238), 1,
      sym_import_list,
    ACTIONS(7734), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [375538] = 3,
    ACTIONS(4875), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4877), 8,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_percent,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [375559] = 3,
    ACTIONS(4867), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4869), 8,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_percent,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [375580] = 3,
    ACTIONS(4863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 8,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_percent,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [375601] = 4,
    ACTIONS(7740), 1,
      anon_sym_SEMI,
    STATE(8933), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5504), 7,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__cond_infix,
      anon_sym_forall,
      anon_sym_u2200,
      sym_name,
      aux_sym__paren_open_token1,
  [375624] = 6,
    ACTIONS(7743), 1,
      anon_sym_in,
    ACTIONS(7747), 1,
      sym__phantom_in,
    STATE(9595), 1,
      sym__let_binds,
    ACTIONS(7745), 2,
      sym__cmd_layout_start_let,
      sym__cmd_layout_start_explicit,
    ACTIONS(7722), 4,
      sym__phantom_arrow,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [375651] = 7,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7751), 1,
      anon_sym_as,
    ACTIONS(7753), 1,
      anon_sym_hiding,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10197), 1,
      sym_import_list,
    ACTIONS(7749), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [375680] = 7,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7757), 1,
      anon_sym_as,
    ACTIONS(7759), 1,
      anon_sym_hiding,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10199), 1,
      sym_import_list,
    ACTIONS(7755), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [375709] = 3,
    ACTIONS(4863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 8,
      sym__cond_layout_end,
      sym__phantom_arrow,
      sym__phantom_bar,
      sym__cond_prefix_percent,
      anon_sym_PIPE,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [375730] = 10,
    ACTIONS(4658), 1,
      anon_sym_EQ,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    STATE(8422), 1,
      aux_sym__bind_matches_repeat1,
    STATE(8990), 1,
      sym__bind_match,
    STATE(9050), 1,
      sym__simple_bind_match,
    STATE(10738), 1,
      sym__bind_matches,
    STATE(12338), 1,
      sym__bar,
    STATE(12352), 1,
      sym__guards,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [375765] = 9,
    ACTIONS(7586), 1,
      sym_string,
    ACTIONS(7588), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7720), 1,
      sym_variable,
    STATE(8758), 1,
      sym__paren_open,
    STATE(9465), 1,
      sym_entity,
    STATE(10170), 1,
      sym_signature,
    STATE(10941), 1,
      sym__var_binding_list,
    STATE(9761), 2,
      sym__varsym_prefix,
      sym__pvarsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [375798] = 9,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7550), 1,
      sym_variable,
    ACTIONS(7554), 1,
      anon_sym_DOT_DOT,
    STATE(9869), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11067), 1,
      sym__qfield_name,
    STATE(11857), 1,
      sym_field_pattern,
    STATE(11205), 2,
      sym_field_name,
      sym__field_names,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [375831] = 9,
    ACTIONS(2331), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    ACTIONS(7761), 1,
      anon_sym_PIPE,
    ACTIONS(7763), 1,
      anon_sym_PIPE2,
    STATE(379), 1,
      sym__arrow,
    STATE(5455), 1,
      sym__unboxed_close,
    STATE(10164), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [375864] = 3,
    ACTIONS(7023), 3,
      anon_sym__,
      sym_variable,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7025), 6,
      sym__phantom_where,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
  [375885] = 8,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7879), 1,
      sym__paren_open,
    STATE(12133), 1,
      sym_children,
    ACTIONS(7765), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [375916] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7021), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [375935] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7005), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [375954] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7013), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [375973] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7009), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [375992] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7001), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [376011] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6997), 9,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [376030] = 10,
    ACTIONS(4658), 1,
      anon_sym_EQ,
    ACTIONS(4660), 1,
      anon_sym_PIPE,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    STATE(8422), 1,
      aux_sym__bind_matches_repeat1,
    STATE(8990), 1,
      sym__bind_match,
    STATE(9050), 1,
      sym__simple_bind_match,
    STATE(10742), 1,
      sym__bind_matches,
    STATE(12338), 1,
      sym__bar,
    STATE(12352), 1,
      sym__guards,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [376065] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7767), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [376091] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9103), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7769), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [376117] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7771), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [376143] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(8951), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7773), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [376169] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7775), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [376195] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4723), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [376213] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4711), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [376231] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4715), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [376249] = 9,
    ACTIONS(7777), 1,
      sym_variable,
    ACTIONS(7779), 1,
      sym_name,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10799), 1,
      aux_sym__qualifying_module,
    STATE(10891), 1,
      sym__qualified_constructor,
    STATE(12557), 1,
      sym__qconid,
    STATE(12560), 1,
      sym__qvarid,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [376281] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7021), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [376299] = 6,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7783), 1,
      anon_sym_hiding,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10116), 1,
      sym_import_list,
    ACTIONS(7781), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [376325] = 6,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7787), 1,
      anon_sym_hiding,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10114), 1,
      sym_import_list,
    ACTIONS(7785), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [376351] = 6,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7791), 1,
      anon_sym_hiding,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10110), 1,
      sym_import_list,
    ACTIONS(7789), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [376377] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7013), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [376395] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5203), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [376413] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7009), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [376431] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7005), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [376449] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7001), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [376467] = 6,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7795), 1,
      anon_sym_hiding,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10191), 1,
      sym_import_list,
    ACTIONS(7793), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [376493] = 9,
    ACTIONS(2919), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    ACTIONS(7510), 1,
      anon_sym_COMMA,
    STATE(1039), 1,
      sym__dotdot,
    STATE(2937), 1,
      sym__bracket_close,
    STATE(10126), 1,
      aux_sym__exp_list_repeat1,
    STATE(10127), 1,
      aux_sym__exp_list_comprehension_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [376525] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6997), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [376543] = 8,
    ACTIONS(2331), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7797), 1,
      anon_sym_PIPE,
    ACTIONS(7799), 1,
      anon_sym_PIPE2,
    STATE(379), 1,
      sym__arrow,
    STATE(5431), 1,
      sym__unboxed_close,
    STATE(9896), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [376573] = 3,
    ACTIONS(4863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 7,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [376593] = 9,
    ACTIONS(2985), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    ACTIONS(7801), 1,
      anon_sym_COMMA,
    STATE(1035), 1,
      sym__dotdot,
    STATE(4158), 1,
      sym__bracket_close,
    STATE(10030), 1,
      aux_sym__exp_list_repeat1,
    STATE(10031), 1,
      aux_sym__exp_list_comprehension_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [376625] = 3,
    ACTIONS(7041), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7043), 6,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [376645] = 7,
    ACTIONS(5847), 1,
      sym__cond_assoc_tyinst,
    ACTIONS(7803), 1,
      anon_sym_instance,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(10017), 1,
      sym__forall_body,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(12246), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [376673] = 8,
    ACTIONS(2211), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7805), 1,
      anon_sym_PIPE,
    ACTIONS(7807), 1,
      anon_sym_PIPE2,
    STATE(379), 1,
      sym__arrow,
    STATE(4973), 1,
      sym__unboxed_close,
    STATE(9947), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [376703] = 3,
    ACTIONS(6991), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6993), 6,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [376723] = 3,
    ACTIONS(7045), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7047), 6,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [376743] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7809), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [376761] = 3,
    ACTIONS(4867), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4869), 7,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [376781] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7811), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [376799] = 3,
    ACTIONS(4871), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4873), 7,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [376819] = 3,
    ACTIONS(4875), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4877), 7,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [376839] = 3,
    ACTIONS(1125), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(1123), 7,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [376859] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7813), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [376877] = 3,
    ACTIONS(4709), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4711), 6,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [376897] = 3,
    ACTIONS(7049), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7051), 6,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [376917] = 4,
    ACTIONS(7817), 1,
      anon_sym_COMMA,
    STATE(9054), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7815), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [376939] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7819), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [376957] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7821), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [376983] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9067), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7823), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377009] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4813), 8,
      anon_sym_COMMA,
      anon_sym__,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym_BQUOTE,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [377027] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7825), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377053] = 5,
    ACTIONS(7702), 1,
      sym_variable,
    ACTIONS(7829), 1,
      anon_sym_where,
    STATE(8864), 1,
      aux_sym_type_family_injectivity_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7827), 5,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
  [377077] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7831), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [377095] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9068), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7833), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377121] = 6,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7837), 1,
      anon_sym_hiding,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10096), 1,
      sym_import_list,
    ACTIONS(7835), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377147] = 9,
    ACTIONS(2887), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    ACTIONS(7518), 1,
      anon_sym_COMMA,
    STATE(977), 1,
      sym__dotdot,
    STATE(5249), 1,
      sym__bracket_close,
    STATE(10781), 1,
      aux_sym__exp_list_repeat1,
    STATE(10793), 1,
      aux_sym__exp_list_comprehension_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377179] = 3,
    ACTIONS(7015), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7017), 6,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [377199] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7516), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [377217] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7516), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [377235] = 6,
    ACTIONS(7841), 1,
      anon_sym_deriving,
    ACTIONS(7844), 1,
      sym__phantom_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7839), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377261] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7847), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377287] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9132), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7849), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377313] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7851), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377339] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9131), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7853), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377365] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7855), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377391] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7857), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377417] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7859), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377443] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9076), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7861), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377469] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7516), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [377487] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7863), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [377505] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7865), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [377523] = 8,
    ACTIONS(2347), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7867), 1,
      anon_sym_PIPE,
    ACTIONS(7869), 1,
      anon_sym_PIPE2,
    STATE(379), 1,
      sym__arrow,
    STATE(4745), 1,
      sym__unboxed_close,
    STATE(9958), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377553] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7871), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377579] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7873), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [377597] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9126), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7875), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377623] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7877), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [377641] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7879), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377667] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7540), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [377685] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7516), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [377703] = 3,
    ACTIONS(7883), 2,
      anon_sym_PIPE,
      anon_sym_PIPE2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7881), 6,
      anon_sym_COMMA,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [377723] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7885), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377749] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9125), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7887), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377775] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7889), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377801] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9124), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7891), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377827] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7893), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377853] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7895), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377879] = 7,
    ACTIONS(7897), 1,
      anon_sym_instance,
    ACTIONS(7899), 1,
      anon_sym_via,
    STATE(10304), 1,
      sym__instance,
    STATE(12220), 1,
      sym_deriving_strategy,
    STATE(12221), 1,
      sym_via,
    ACTIONS(7901), 3,
      anon_sym_stock,
      anon_sym_newtype,
      anon_sym_anyclass,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377907] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7903), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [377925] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7905), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [377943] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7907), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [377969] = 9,
    ACTIONS(2881), 1,
      anon_sym_RBRACK,
    ACTIONS(7496), 1,
      anon_sym_COMMA,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    STATE(979), 1,
      sym__dotdot,
    STATE(5450), 1,
      sym__bracket_close,
    STATE(10165), 1,
      aux_sym__exp_list_comprehension_repeat1,
    STATE(10168), 1,
      aux_sym__exp_list_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378001] = 9,
    ACTIONS(2857), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    ACTIONS(7512), 1,
      anon_sym_COMMA,
    STATE(992), 1,
      sym__dotdot,
    STATE(4856), 1,
      sym__bracket_close,
    STATE(10689), 1,
      aux_sym__exp_list_repeat1,
    STATE(10692), 1,
      aux_sym__exp_list_comprehension_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378033] = 8,
    ACTIONS(2197), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7909), 1,
      anon_sym_PIPE,
    ACTIONS(7911), 1,
      anon_sym_PIPE2,
    STATE(379), 1,
      sym__arrow,
    STATE(5260), 1,
      sym__unboxed_close,
    STATE(9716), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378063] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7913), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [378081] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7865), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [378099] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7865), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [378117] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7915), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [378135] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7917), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [378153] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7919), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [378171] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7921), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378197] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7923), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [378215] = 9,
    ACTIONS(2819), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    ACTIONS(7925), 1,
      anon_sym_COMMA,
    STATE(1107), 1,
      sym__dotdot,
    STATE(4613), 1,
      sym__bracket_close,
    STATE(10599), 1,
      aux_sym__exp_list_comprehension_repeat1,
    STATE(10600), 1,
      aux_sym__exp_list_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378247] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9008), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7927), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378273] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7929), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [378291] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7931), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [378309] = 9,
    ACTIONS(2849), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    ACTIONS(7532), 1,
      anon_sym_COMMA,
    STATE(1015), 1,
      sym__dotdot,
    STATE(5292), 1,
      sym__bracket_close,
    STATE(10403), 1,
      aux_sym__exp_list_comprehension_repeat1,
    STATE(10405), 1,
      aux_sym__exp_list_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378341] = 6,
    ACTIONS(6475), 1,
      sym__phantom_where,
    ACTIONS(7096), 1,
      anon_sym_where,
    STATE(9510), 1,
      sym__where,
    STATE(10650), 1,
      sym__where_binds,
    ACTIONS(7933), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378367] = 3,
    ACTIONS(4863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 7,
      sym__phantom_where,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
      anon_sym_where,
  [378387] = 3,
    ACTIONS(4721), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4723), 6,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [378407] = 3,
    ACTIONS(4713), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4715), 6,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [378427] = 4,
    ACTIONS(7817), 1,
      anon_sym_COMMA,
    STATE(9069), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7935), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [378449] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7937), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [378467] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7939), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [378485] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7941), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [378503] = 8,
    ACTIONS(2023), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7943), 1,
      anon_sym_PIPE,
    ACTIONS(7945), 1,
      anon_sym_PIPE2,
    STATE(379), 1,
      sym__arrow,
    STATE(4435), 1,
      sym__unboxed_close,
    STATE(9910), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378533] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7947), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378559] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7949), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378585] = 8,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7951), 1,
      anon_sym_qualified,
    ACTIONS(7953), 1,
      anon_sym_as,
    ACTIONS(7955), 1,
      anon_sym_hiding,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11599), 1,
      sym_import_list,
    ACTIONS(7598), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378615] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9033), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7957), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378641] = 6,
    ACTIONS(6475), 1,
      sym__phantom_where,
    ACTIONS(7096), 1,
      anon_sym_where,
    STATE(9510), 1,
      sym__where,
    STATE(10457), 1,
      sym__where_binds,
    ACTIONS(7959), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378667] = 6,
    ACTIONS(6475), 1,
      sym__phantom_where,
    ACTIONS(7096), 1,
      anon_sym_where,
    STATE(9510), 1,
      sym__where,
    STATE(10488), 1,
      sym__where_binds,
    ACTIONS(7961), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378693] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7963), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [378711] = 8,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7965), 1,
      anon_sym_qualified,
    ACTIONS(7967), 1,
      anon_sym_as,
    ACTIONS(7969), 1,
      anon_sym_hiding,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11618), 1,
      sym_import_list,
    ACTIONS(7614), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378741] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7971), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378767] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7973), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378793] = 4,
    ACTIONS(7977), 1,
      anon_sym_COMMA,
    STATE(9069), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7975), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [378815] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7980), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378841] = 9,
    ACTIONS(2995), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    ACTIONS(7524), 1,
      anon_sym_COMMA,
    STATE(1121), 1,
      sym__dotdot,
    STATE(5002), 1,
      sym__bracket_close,
    STATE(10428), 1,
      aux_sym__exp_list_repeat1,
    STATE(10434), 1,
      aux_sym__exp_list_comprehension_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378873] = 8,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7982), 1,
      anon_sym_qualified,
    ACTIONS(7984), 1,
      anon_sym_as,
    ACTIONS(7986), 1,
      anon_sym_hiding,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11677), 1,
      sym_import_list,
    ACTIONS(7570), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378903] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7540), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [378921] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9059), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7988), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378947] = 3,
    ACTIONS(7023), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7025), 6,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [378967] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(7990), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [378993] = 7,
    ACTIONS(7897), 1,
      anon_sym_instance,
    ACTIONS(7899), 1,
      anon_sym_via,
    STATE(10179), 1,
      sym__instance,
    STATE(11935), 1,
      sym_via,
    STATE(11936), 1,
      sym_deriving_strategy,
    ACTIONS(7901), 3,
      anon_sym_stock,
      anon_sym_newtype,
      anon_sym_anyclass,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [379021] = 8,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7992), 1,
      anon_sym_qualified,
    ACTIONS(7994), 1,
      anon_sym_as,
    ACTIONS(7996), 1,
      anon_sym_hiding,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11514), 1,
      sym_import_list,
    ACTIONS(7606), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [379051] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7998), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [379069] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(8000), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [379087] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(8002), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [379105] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(8004), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [379123] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(8006), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [379141] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(8008), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [379159] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4785), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [379177] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(8010), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [379195] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(8012), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [379213] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4789), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [379231] = 3,
    ACTIONS(4733), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4735), 6,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [379251] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(8014), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [379277] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9029), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(8016), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [379303] = 3,
    ACTIONS(7027), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7029), 6,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [379323] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4763), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [379341] = 8,
    ACTIONS(2081), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8018), 1,
      anon_sym_PIPE,
    ACTIONS(8020), 1,
      anon_sym_PIPE2,
    STATE(379), 1,
      sym__arrow,
    STATE(2897), 1,
      sym__unboxed_close,
    STATE(9930), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [379371] = 3,
    ACTIONS(8022), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(8024), 6,
      sym__cond_prefix_at,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [379391] = 9,
    ACTIONS(2859), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    ACTIONS(7538), 1,
      anon_sym_COMMA,
    STATE(1021), 1,
      sym__dotdot,
    STATE(4353), 1,
      sym__bracket_close,
    STATE(10872), 1,
      aux_sym__exp_list_comprehension_repeat1,
    STATE(10882), 1,
      aux_sym__exp_list_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [379423] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4743), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [379441] = 9,
    ACTIONS(8026), 1,
      sym_variable,
    ACTIONS(8028), 1,
      sym_name,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10799), 1,
      aux_sym__qualifying_module,
    STATE(10891), 1,
      sym__qualified_constructor,
    STATE(12518), 1,
      sym__qvarid,
    STATE(12519), 1,
      sym__qconid,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [379473] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(8030), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym__,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
  [379491] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(8032), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym__,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
  [379509] = 5,
    STATE(10220), 1,
      sym_abstract_family,
    STATE(10221), 1,
      sym__tyfam_equations,
    ACTIONS(8036), 2,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
    ACTIONS(8034), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [379533] = 3,
    ACTIONS(7031), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7033), 6,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [379553] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(8038), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [379579] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4695), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      sym__phantom_bar,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_where,
  [379597] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(8040), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [379623] = 3,
    ACTIONS(4855), 1,
      anon_sym_POUND,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4857), 7,
      sym__cond_prefix_dot,
      sym__varsym,
      sym__consym,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_POUND2,
  [379643] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9024), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(8042), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [379669] = 3,
    ACTIONS(4835), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4837), 6,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [379689] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9060), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(8044), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [379715] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(8046), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [379741] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4695), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [379759] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(8048), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [379785] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(8050), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [379811] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9016), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(8052), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [379837] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4767), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [379855] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(8054), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [379881] = 6,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(8058), 1,
      anon_sym_hiding,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10151), 1,
      sym_import_list,
    ACTIONS(8056), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [379907] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(8060), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [379925] = 3,
    ACTIONS(4791), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4793), 6,
      sym__cond_prefix_at,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [379945] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(8062), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [379963] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(8064), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [379981] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(8066), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [379999] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(2759), 8,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_bar,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [380017] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(8068), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380043] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(8070), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380069] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(8072), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380095] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(8074), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380121] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9113), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(8076), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380147] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(8078), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380173] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9110), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(8080), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380199] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(8082), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380225] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9003), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(8084), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380251] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(8086), 8,
      sym__cond_layout_semicolon,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [380269] = 6,
    ACTIONS(8088), 1,
      anon_sym_in,
    ACTIONS(8092), 1,
      sym__phantom_in,
    STATE(9867), 1,
      sym__let_binds,
    ACTIONS(8090), 2,
      sym__cmd_layout_start_let,
      sym__cmd_layout_start_explicit,
    ACTIONS(7722), 3,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380295] = 3,
    ACTIONS(8094), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(8096), 6,
      sym__cond_prefix_at,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      aux_sym__paren_open_token1,
  [380315] = 6,
    ACTIONS(3569), 1,
      sym__phantom_deriving,
    ACTIONS(6852), 1,
      anon_sym_deriving,
    STATE(9004), 1,
      aux_sym__data_repeat1,
    STATE(9582), 1,
      sym_deriving,
    ACTIONS(8098), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380341] = 8,
    ACTIONS(2511), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8100), 1,
      anon_sym_PIPE,
    ACTIONS(8102), 1,
      anon_sym_PIPE2,
    STATE(379), 1,
      sym__arrow,
    STATE(5308), 1,
      sym__unboxed_close,
    STATE(9739), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380371] = 6,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(8106), 1,
      anon_sym_hiding,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10149), 1,
      sym_import_list,
    ACTIONS(8104), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380397] = 6,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(8110), 1,
      anon_sym_hiding,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10111), 1,
      sym_import_list,
    ACTIONS(8108), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380423] = 9,
    ACTIONS(2969), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    ACTIONS(8112), 1,
      anon_sym_COMMA,
    STATE(1099), 1,
      sym__dotdot,
    STATE(5623), 1,
      sym__bracket_close,
    STATE(10204), 1,
      aux_sym__exp_list_repeat1,
    STATE(10205), 1,
      aux_sym__exp_list_comprehension_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380455] = 7,
    ACTIONS(8114), 1,
      anon_sym_SEMI,
    ACTIONS(8116), 1,
      sym__cond_layout_semicolon,
    STATE(1950), 1,
      aux_sym__let_binds_repeat1,
    STATE(5222), 1,
      sym__layout_end,
    STATE(9320), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8118), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380482] = 7,
    ACTIONS(8120), 1,
      sym_variable,
    ACTIONS(8122), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(12149), 1,
      sym__do_keyword,
    ACTIONS(6736), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380509] = 7,
    ACTIONS(8124), 1,
      anon_sym_SEMI,
    ACTIONS(8126), 1,
      sym__cond_layout_semicolon,
    STATE(1946), 1,
      aux_sym__let_binds_repeat1,
    STATE(4958), 1,
      sym__layout_end,
    STATE(9201), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8128), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380536] = 8,
    ACTIONS(2395), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(5998), 1,
      sym__unboxed_close,
    STATE(10010), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10746), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380565] = 7,
    ACTIONS(8136), 1,
      anon_sym_SEMI,
    ACTIONS(8138), 1,
      sym__cond_layout_semicolon,
    STATE(1903), 1,
      aux_sym__let_binds_repeat1,
    STATE(4615), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8140), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380592] = 7,
    ACTIONS(8142), 1,
      anon_sym_SEMI,
    ACTIONS(8144), 1,
      sym__cond_layout_semicolon,
    STATE(2071), 1,
      aux_sym__let_binds_repeat1,
    STATE(4959), 1,
      sym__layout_end,
    STATE(9190), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8146), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380619] = 7,
    ACTIONS(8148), 1,
      anon_sym_SEMI,
    ACTIONS(8150), 1,
      sym__cond_layout_semicolon,
    STATE(2040), 1,
      aux_sym__let_binds_repeat1,
    STATE(9264), 1,
      aux_sym__patsyn_cons_repeat1,
    STATE(10388), 1,
      sym__layout_end,
    ACTIONS(8152), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380646] = 7,
    ACTIONS(8154), 1,
      anon_sym_SEMI,
    ACTIONS(8156), 1,
      sym__cond_layout_semicolon,
    STATE(1895), 1,
      aux_sym__let_binds_repeat1,
    STATE(4680), 1,
      sym__layout_end,
    STATE(9145), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8158), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380673] = 7,
    ACTIONS(8160), 1,
      anon_sym_SEMI,
    ACTIONS(8162), 1,
      sym__cond_layout_semicolon,
    STATE(1934), 1,
      aux_sym__let_binds_repeat1,
    STATE(5218), 1,
      sym__layout_end,
    STATE(9322), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8164), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380700] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12540), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380729] = 7,
    ACTIONS(8168), 1,
      anon_sym_SEMI,
    ACTIONS(8170), 1,
      sym__cond_layout_semicolon,
    STATE(1945), 1,
      aux_sym__let_binds_repeat1,
    STATE(5219), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8172), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380756] = 7,
    ACTIONS(8174), 1,
      anon_sym_SEMI,
    ACTIONS(8176), 1,
      sym__cond_layout_semicolon,
    STATE(7165), 1,
      aux_sym__let_binds_repeat1,
    STATE(9672), 1,
      aux_sym__tyfam_equations_repeat1,
    STATE(10391), 1,
      sym__layout_end,
    ACTIONS(8178), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380783] = 7,
    ACTIONS(8180), 1,
      anon_sym_SEMI,
    ACTIONS(8182), 1,
      sym__cond_layout_semicolon,
    STATE(75), 1,
      aux_sym__let_binds_repeat1,
    STATE(5464), 1,
      sym__layout_end,
    STATE(9229), 1,
      aux_sym__statements_repeat1,
    ACTIONS(8184), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380810] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12581), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380839] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12619), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380868] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12621), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380897] = 7,
    ACTIONS(8186), 1,
      anon_sym_SEMI,
    ACTIONS(8188), 1,
      sym__cond_layout_semicolon,
    STATE(2065), 1,
      aux_sym__let_binds_repeat1,
    STATE(5223), 1,
      sym__layout_end,
    STATE(9637), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8190), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380924] = 7,
    ACTIONS(8192), 1,
      anon_sym_SEMI,
    ACTIONS(8194), 1,
      sym__cond_layout_semicolon,
    STATE(84), 1,
      aux_sym__let_binds_repeat1,
    STATE(5323), 1,
      sym__layout_end,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    ACTIONS(8196), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380951] = 7,
    ACTIONS(8198), 1,
      anon_sym_SEMI,
    ACTIONS(8200), 1,
      sym__cond_layout_semicolon,
    STATE(2063), 1,
      aux_sym__let_binds_repeat1,
    STATE(5225), 1,
      sym__layout_end,
    STATE(9295), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8202), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380978] = 5,
    ACTIONS(6475), 1,
      sym__phantom_where,
    ACTIONS(8206), 1,
      anon_sym_where,
    STATE(9462), 1,
      sym__where,
    ACTIONS(8204), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381001] = 8,
    ACTIONS(2379), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(7019), 1,
      sym__unboxed_close,
    STATE(9715), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10350), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381030] = 7,
    ACTIONS(8208), 1,
      anon_sym_SEMI,
    ACTIONS(8210), 1,
      sym__cond_layout_semicolon,
    STATE(94), 1,
      aux_sym__let_binds_repeat1,
    STATE(5569), 1,
      sym__layout_end,
    STATE(9173), 1,
      aux_sym__statements_repeat1,
    ACTIONS(8212), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381057] = 7,
    ACTIONS(8214), 1,
      anon_sym_SEMI,
    ACTIONS(8216), 1,
      sym__cond_layout_semicolon,
    STATE(1839), 1,
      aux_sym__let_binds_repeat1,
    STATE(9564), 1,
      aux_sym__let_binds_repeat2,
    STATE(9701), 1,
      sym__layout_end,
    ACTIONS(8218), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381084] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12533), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381113] = 4,
    STATE(10527), 1,
      sym_class_declarations,
    ACTIONS(8222), 2,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
    ACTIONS(8220), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381134] = 8,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    ACTIONS(8224), 1,
      sym__cond_layout_end,
    STATE(9384), 1,
      aux_sym__exp_multi_way_if_repeat1,
    STATE(10462), 1,
      sym__guards,
    STATE(11229), 1,
      sym_match,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381163] = 7,
    ACTIONS(8226), 1,
      anon_sym_SEMI,
    ACTIONS(8228), 1,
      sym__cond_layout_semicolon,
    STATE(95), 1,
      aux_sym__let_binds_repeat1,
    STATE(5605), 1,
      sym__layout_end,
    STATE(9184), 1,
      aux_sym__statements_repeat1,
    ACTIONS(8230), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381190] = 7,
    ACTIONS(7334), 1,
      sym_name,
    ACTIONS(7336), 1,
      aux_sym__paren_open_token1,
    STATE(9426), 1,
      sym_gadt_constructor,
    STATE(11306), 1,
      sym__con_binding_list,
    STATE(11672), 1,
      sym__paren_open,
    STATE(9995), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381217] = 8,
    ACTIONS(2091), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(3291), 1,
      sym__unboxed_close,
    STATE(10008), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10764), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381246] = 8,
    ACTIONS(2039), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6881), 1,
      sym__unboxed_close,
    STATE(9983), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10052), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381275] = 7,
    ACTIONS(8232), 1,
      sym_variable,
    ACTIONS(8234), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(12149), 1,
      sym__do_keyword,
    ACTIONS(6736), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381302] = 7,
    ACTIONS(8236), 1,
      anon_sym_SEMI,
    ACTIONS(8238), 1,
      sym__cond_layout_semicolon,
    STATE(2075), 1,
      aux_sym__let_binds_repeat1,
    STATE(4642), 1,
      sym__layout_end,
    STATE(9637), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8240), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381329] = 7,
    ACTIONS(8242), 1,
      anon_sym_SEMI,
    ACTIONS(8244), 1,
      sym__cond_layout_semicolon,
    STATE(98), 1,
      aux_sym__let_binds_repeat1,
    STATE(5603), 1,
      sym__layout_end,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    ACTIONS(8246), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381356] = 8,
    ACTIONS(2363), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6843), 1,
      sym__unboxed_close,
    STATE(10012), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10490), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381385] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12623), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381414] = 7,
    ACTIONS(8248), 1,
      anon_sym_SEMI,
    ACTIONS(8250), 1,
      sym__cond_layout_semicolon,
    STATE(8609), 1,
      aux_sym__let_binds_repeat1,
    STATE(9505), 1,
      aux_sym_gadt_constructors_repeat1,
    STATE(9552), 1,
      sym__layout_end,
    ACTIONS(8252), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381441] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(8254), 7,
      sym__cond_context,
      sym__cond_data_infix,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_LBRACK,
      sym_name,
      aux_sym__paren_open_token1,
  [381458] = 8,
    ACTIONS(2239), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(2806), 1,
      sym__unboxed_close,
    STATE(9992), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10343), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381487] = 7,
    ACTIONS(8256), 1,
      anon_sym_SEMI,
    ACTIONS(8258), 1,
      sym__cond_layout_semicolon,
    STATE(2074), 1,
      aux_sym__let_binds_repeat1,
    STATE(4929), 1,
      sym__layout_end,
    STATE(9233), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8260), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381514] = 7,
    ACTIONS(3501), 1,
      aux_sym__paren_close_token1,
    ACTIONS(8262), 1,
      anon_sym_COMMA,
    STATE(1574), 1,
      sym__colon2,
    STATE(7942), 1,
      sym__paren_close,
    STATE(10195), 1,
      aux_sym__ctr_tuple_repeat1,
    ACTIONS(8264), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381541] = 7,
    ACTIONS(8266), 1,
      anon_sym_SEMI,
    ACTIONS(8268), 1,
      sym__cond_layout_semicolon,
    STATE(1840), 1,
      aux_sym__let_binds_repeat1,
    STATE(9564), 1,
      aux_sym__let_binds_repeat2,
    STATE(9585), 1,
      sym__layout_end,
    ACTIONS(8270), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381568] = 7,
    ACTIONS(8272), 1,
      anon_sym_SEMI,
    ACTIONS(8274), 1,
      sym__cond_layout_semicolon,
    STATE(8621), 1,
      aux_sym__let_binds_repeat1,
    STATE(9645), 1,
      sym__layout_end,
    STATE(9694), 1,
      aux_sym_gadt_constructors_repeat1,
    ACTIONS(8276), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381595] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12304), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381624] = 7,
    ACTIONS(8278), 1,
      anon_sym_SEMI,
    ACTIONS(8280), 1,
      sym__cond_layout_semicolon,
    STATE(101), 1,
      aux_sym__let_binds_repeat1,
    STATE(5600), 1,
      sym__layout_end,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    ACTIONS(8282), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381651] = 7,
    ACTIONS(8284), 1,
      anon_sym_SEMI,
    ACTIONS(8286), 1,
      sym__cond_layout_semicolon,
    STATE(1914), 1,
      aux_sym__let_binds_repeat1,
    STATE(4681), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8288), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381678] = 7,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      sym__cond_layout_semicolon,
    STATE(2060), 1,
      aux_sym__let_binds_repeat1,
    STATE(3040), 1,
      sym__layout_end,
    STATE(9321), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8294), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381705] = 7,
    ACTIONS(8296), 1,
      anon_sym_SEMI,
    ACTIONS(8298), 1,
      sym__cond_layout_semicolon,
    STATE(99), 1,
      aux_sym__let_binds_repeat1,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    STATE(10036), 1,
      sym__layout_end,
    ACTIONS(8300), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381732] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12547), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381761] = 8,
    ACTIONS(2147), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6108), 1,
      sym__unboxed_close,
    STATE(9994), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10784), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381790] = 7,
    ACTIONS(8302), 1,
      anon_sym_SEMI,
    ACTIONS(8304), 1,
      sym__cond_layout_semicolon,
    STATE(2050), 1,
      aux_sym__let_binds_repeat1,
    STATE(4927), 1,
      sym__layout_end,
    STATE(9637), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8306), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381817] = 8,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    ACTIONS(8308), 1,
      sym__cond_layout_end,
    STATE(9261), 1,
      aux_sym__exp_multi_way_if_repeat1,
    STATE(10462), 1,
      sym__guards,
    STATE(11229), 1,
      sym_match,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381846] = 8,
    ACTIONS(8310), 1,
      anon_sym_COMMA,
    ACTIONS(8312), 1,
      anon_sym_PIPE,
    ACTIONS(8314), 1,
      anon_sym_PIPE2,
    ACTIONS(8316), 1,
      anon_sym_POUND_RPAREN,
    STATE(7996), 1,
      sym__unboxed_close,
    STATE(9780), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(10883), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381875] = 7,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      sym__cond_layout_semicolon,
    STATE(2049), 1,
      aux_sym__let_binds_repeat1,
    STATE(3036), 1,
      sym__layout_end,
    STATE(9637), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8322), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381902] = 7,
    ACTIONS(8324), 1,
      anon_sym_SEMI,
    ACTIONS(8326), 1,
      sym__cond_layout_semicolon,
    STATE(1933), 1,
      aux_sym__let_binds_repeat1,
    STATE(4926), 1,
      sym__layout_end,
    STATE(9253), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8328), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381929] = 7,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      sym__cond_layout_semicolon,
    STATE(11), 1,
      aux_sym__let_binds_repeat1,
    STATE(9302), 1,
      aux_sym_quoted_decls_repeat1,
    STATE(11704), 1,
      sym__layout_end,
    ACTIONS(8334), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381956] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12625), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [381985] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12627), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382014] = 7,
    ACTIONS(8336), 1,
      anon_sym_SEMI,
    ACTIONS(8338), 1,
      sym__cond_layout_semicolon,
    STATE(776), 1,
      aux_sym__let_binds_repeat1,
    STATE(9617), 1,
      aux_sym_class_declarations_repeat1,
    STATE(10509), 1,
      sym__layout_end,
    ACTIONS(8340), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382041] = 7,
    ACTIONS(8342), 1,
      anon_sym_SEMI,
    ACTIONS(8344), 1,
      sym__cond_layout_semicolon,
    STATE(1923), 1,
      aux_sym__let_binds_repeat1,
    STATE(3035), 1,
      sym__layout_end,
    STATE(9421), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8346), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382068] = 7,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8350), 1,
      sym__cond_layout_semicolon,
    STATE(1898), 1,
      aux_sym__let_binds_repeat1,
    STATE(4630), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8352), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382095] = 7,
    ACTIONS(8354), 1,
      anon_sym_SEMI,
    ACTIONS(8356), 1,
      sym__cond_layout_semicolon,
    STATE(1931), 1,
      aux_sym__let_binds_repeat1,
    STATE(4923), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8358), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382122] = 7,
    ACTIONS(8360), 1,
      anon_sym_SEMI,
    ACTIONS(8362), 1,
      sym__cond_layout_semicolon,
    STATE(91), 1,
      aux_sym__let_binds_repeat1,
    STATE(4666), 1,
      sym__layout_end,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    ACTIONS(8364), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382149] = 7,
    ACTIONS(8366), 1,
      anon_sym_SEMI,
    ACTIONS(8368), 1,
      sym__cond_layout_semicolon,
    STATE(1928), 1,
      aux_sym__let_binds_repeat1,
    STATE(4922), 1,
      sym__layout_end,
    STATE(9268), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8370), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382176] = 8,
    ACTIONS(2189), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6840), 1,
      sym__unboxed_close,
    STATE(9987), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10803), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382205] = 7,
    ACTIONS(8372), 1,
      anon_sym_SEMI,
    ACTIONS(8374), 1,
      sym__cond_layout_semicolon,
    STATE(97), 1,
      aux_sym__let_binds_repeat1,
    STATE(9424), 1,
      aux_sym__statements_repeat1,
    STATE(10039), 1,
      sym__layout_end,
    ACTIONS(8376), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382232] = 7,
    ACTIONS(8378), 1,
      anon_sym_SEMI,
    ACTIONS(8380), 1,
      sym__cond_layout_semicolon,
    STATE(1947), 1,
      aux_sym__let_binds_repeat1,
    STATE(5247), 1,
      sym__layout_end,
    STATE(9151), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8382), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382259] = 7,
    ACTIONS(8384), 1,
      anon_sym_SEMI,
    ACTIONS(8386), 1,
      sym__cond_layout_semicolon,
    STATE(1935), 1,
      aux_sym__let_binds_repeat1,
    STATE(4685), 1,
      sym__layout_end,
    STATE(9200), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8388), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382286] = 7,
    ACTIONS(8390), 1,
      anon_sym_SEMI,
    ACTIONS(8392), 1,
      sym__cond_layout_semicolon,
    STATE(2062), 1,
      aux_sym__let_binds_repeat1,
    STATE(4686), 1,
      sym__layout_end,
    STATE(9637), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8394), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382313] = 7,
    ACTIONS(8396), 1,
      anon_sym_SEMI,
    ACTIONS(8398), 1,
      sym__cond_layout_semicolon,
    STATE(2055), 1,
      aux_sym__let_binds_repeat1,
    STATE(5166), 1,
      sym__layout_end,
    STATE(9157), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8400), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382340] = 7,
    ACTIONS(8402), 1,
      anon_sym_SEMI,
    ACTIONS(8404), 1,
      sym__cond_layout_semicolon,
    STATE(2068), 1,
      aux_sym__let_binds_repeat1,
    STATE(3999), 1,
      sym__layout_end,
    STATE(9243), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8406), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382367] = 7,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      sym__cond_layout_semicolon,
    STATE(1912), 1,
      aux_sym__let_binds_repeat1,
    STATE(3998), 1,
      sym__layout_end,
    STATE(9277), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8412), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382394] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12586), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382423] = 7,
    ACTIONS(8414), 1,
      anon_sym_SEMI,
    ACTIONS(8416), 1,
      sym__cond_layout_semicolon,
    STATE(1896), 1,
      aux_sym__let_binds_repeat1,
    STATE(3031), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8418), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382450] = 7,
    ACTIONS(8420), 1,
      anon_sym_SEMI,
    ACTIONS(8422), 1,
      sym__cond_layout_semicolon,
    STATE(1851), 1,
      aux_sym__let_binds_repeat1,
    STATE(9494), 1,
      aux_sym__let_binds_repeat2,
    STATE(9670), 1,
      sym__layout_end,
    ACTIONS(8424), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382477] = 7,
    ACTIONS(8426), 1,
      anon_sym_SEMI,
    ACTIONS(8428), 1,
      sym__cond_layout_semicolon,
    STATE(2053), 1,
      aux_sym__let_binds_repeat1,
    STATE(4688), 1,
      sym__layout_end,
    STATE(9172), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8430), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382504] = 7,
    ACTIONS(8432), 1,
      anon_sym_SEMI,
    ACTIONS(8434), 1,
      sym__cond_layout_semicolon,
    STATE(86), 1,
      aux_sym__let_binds_repeat1,
    STATE(5490), 1,
      sym__layout_end,
    STATE(9294), 1,
      aux_sym__statements_repeat1,
    ACTIONS(8436), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382531] = 3,
    ACTIONS(8440), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(8438), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PIPE2,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
  [382550] = 7,
    ACTIONS(8442), 1,
      anon_sym_SEMI,
    ACTIONS(8444), 1,
      sym__cond_layout_semicolon,
    STATE(74), 1,
      aux_sym__let_binds_repeat1,
    STATE(4919), 1,
      sym__layout_end,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    ACTIONS(8446), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382577] = 8,
    ACTIONS(2557), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(3493), 1,
      sym__unboxed_close,
    STATE(9972), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10338), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382606] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12596), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382635] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12599), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382664] = 8,
    ACTIONS(839), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6239), 1,
      sym__unboxed_close,
    STATE(9975), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10817), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382693] = 8,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    ACTIONS(8448), 1,
      sym__cond_layout_end,
    STATE(9166), 1,
      aux_sym__exp_multi_way_if_repeat1,
    STATE(10462), 1,
      sym__guards,
    STATE(11229), 1,
      sym_match,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382722] = 7,
    ACTIONS(8450), 1,
      anon_sym_SEMI,
    ACTIONS(8452), 1,
      sym__cond_layout_semicolon,
    STATE(1850), 1,
      aux_sym__let_binds_repeat1,
    STATE(9562), 1,
      sym__layout_end,
    STATE(9564), 1,
      aux_sym__let_binds_repeat2,
    ACTIONS(8454), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382749] = 5,
    ACTIONS(6475), 1,
      sym__phantom_where,
    ACTIONS(8458), 1,
      anon_sym_where,
    STATE(9456), 1,
      sym__where,
    ACTIONS(8456), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382772] = 7,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(8460), 1,
      anon_sym_as,
    ACTIONS(8462), 1,
      anon_sym_hiding,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11453), 1,
      sym_import_list,
    ACTIONS(7734), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382799] = 8,
    ACTIONS(2371), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(3411), 1,
      sym__unboxed_close,
    STATE(9982), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10356), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382828] = 7,
    ACTIONS(8464), 1,
      anon_sym_SEMI,
    ACTIONS(8466), 1,
      sym__cond_layout_semicolon,
    STATE(1853), 1,
      aux_sym__let_binds_repeat1,
    STATE(9438), 1,
      aux_sym__let_binds_repeat2,
    STATE(9599), 1,
      sym__layout_end,
    ACTIONS(8468), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382855] = 7,
    ACTIONS(8470), 1,
      anon_sym_SEMI,
    ACTIONS(8472), 1,
      sym__cond_layout_semicolon,
    STATE(87), 1,
      aux_sym__let_binds_repeat1,
    STATE(5493), 1,
      sym__layout_end,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    ACTIONS(8474), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382882] = 8,
    ACTIONS(2303), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(3325), 1,
      sym__unboxed_close,
    STATE(9971), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10504), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382911] = 8,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    ACTIONS(8476), 1,
      sym__cond_layout_end,
    STATE(9500), 1,
      aux_sym__exp_multi_way_if_repeat1,
    STATE(10462), 1,
      sym__guards,
    STATE(11229), 1,
      sym_match,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382940] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12629), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382969] = 7,
    ACTIONS(8478), 1,
      anon_sym_SEMI,
    ACTIONS(8480), 1,
      sym__cond_layout_semicolon,
    STATE(2082), 1,
      aux_sym__let_binds_repeat1,
    STATE(4913), 1,
      sym__layout_end,
    STATE(9637), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8482), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [382996] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12605), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383025] = 7,
    ACTIONS(8484), 1,
      anon_sym_SEMI,
    ACTIONS(8486), 1,
      sym__cond_layout_semicolon,
    STATE(1900), 1,
      aux_sym__let_binds_repeat1,
    STATE(3030), 1,
      sym__layout_end,
    STATE(9445), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8488), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383052] = 7,
    ACTIONS(6734), 1,
      sym_variable,
    ACTIONS(8490), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(12149), 1,
      sym__do_keyword,
    ACTIONS(6736), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383079] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12607), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383108] = 8,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    ACTIONS(8492), 1,
      sym__cond_layout_end,
    STATE(9403), 1,
      aux_sym__exp_multi_way_if_repeat1,
    STATE(10462), 1,
      sym__guards,
    STATE(11229), 1,
      sym_match,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383137] = 7,
    ACTIONS(8232), 1,
      sym_variable,
    ACTIONS(8494), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(12149), 1,
      sym__do_keyword,
    ACTIONS(6736), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383164] = 7,
    ACTIONS(8496), 1,
      anon_sym_SEMI,
    ACTIONS(8498), 1,
      sym__cond_layout_semicolon,
    STATE(1135), 1,
      aux_sym__let_binds_repeat1,
    STATE(9242), 1,
      aux_sym_instance_declarations_repeat1,
    STATE(10266), 1,
      sym__layout_end,
    ACTIONS(8500), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383191] = 7,
    ACTIONS(8502), 1,
      anon_sym_SEMI,
    ACTIONS(8504), 1,
      sym__cond_layout_semicolon,
    STATE(2087), 1,
      aux_sym__let_binds_repeat1,
    STATE(3973), 1,
      sym__layout_end,
    STATE(9297), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8506), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383218] = 7,
    ACTIONS(8508), 1,
      anon_sym_SEMI,
    ACTIONS(8510), 1,
      sym__cond_layout_semicolon,
    STATE(1173), 1,
      aux_sym__let_binds_repeat1,
    STATE(9613), 1,
      aux_sym_instance_declarations_repeat1,
    STATE(10758), 1,
      sym__layout_end,
    ACTIONS(8512), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383245] = 7,
    ACTIONS(8514), 1,
      anon_sym_SEMI,
    ACTIONS(8516), 1,
      sym__cond_layout_semicolon,
    STATE(2067), 1,
      aux_sym__let_binds_repeat1,
    STATE(3971), 1,
      sym__layout_end,
    STATE(9637), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8518), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383272] = 8,
    ACTIONS(2355), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6055), 1,
      sym__unboxed_close,
    STATE(9967), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10840), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383301] = 7,
    ACTIONS(8520), 1,
      anon_sym_SEMI,
    ACTIONS(8522), 1,
      sym__cond_layout_semicolon,
    STATE(1843), 1,
      aux_sym__let_binds_repeat1,
    STATE(9181), 1,
      aux_sym__let_binds_repeat2,
    STATE(9551), 1,
      sym__layout_end,
    ACTIONS(8524), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383328] = 4,
    STATE(10523), 1,
      sym_class_declarations,
    ACTIONS(8222), 2,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
    ACTIONS(8526), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383349] = 8,
    ACTIONS(2287), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(4942), 1,
      sym__unboxed_close,
    STATE(9725), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10445), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383378] = 4,
    ACTIONS(8528), 1,
      anon_sym_SEMI,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5504), 5,
      anon_sym_then,
      anon_sym_else,
      anon_sym_import,
      sym_name,
      aux_sym__paren_open_token1,
  [383399] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12663), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383428] = 8,
    ACTIONS(2211), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(4291), 1,
      sym__unboxed_close,
    STATE(9730), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10418), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383457] = 6,
    ACTIONS(7063), 1,
      sym__consym,
    ACTIONS(8531), 1,
      sym_name,
    STATE(9251), 1,
      aux_sym__qualifying_module,
    STATE(9892), 1,
      sym__modid_prefix,
    ACTIONS(7061), 3,
      anon_sym_mdo,
      anon_sym_do,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383482] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12565), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383511] = 7,
    ACTIONS(8534), 1,
      anon_sym_SEMI,
    ACTIONS(8536), 1,
      sym__cond_layout_semicolon,
    STATE(1920), 1,
      aux_sym__let_binds_repeat1,
    STATE(4908), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8538), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383538] = 8,
    ACTIONS(2255), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6571), 1,
      sym__unboxed_close,
    STATE(9916), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10832), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383567] = 7,
    ACTIONS(8540), 1,
      anon_sym_SEMI,
    ACTIONS(8542), 1,
      sym__cond_layout_semicolon,
    STATE(88), 1,
      aux_sym__let_binds_repeat1,
    STATE(9187), 1,
      aux_sym__statements_repeat1,
    STATE(10040), 1,
      sym__layout_end,
    ACTIONS(8544), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383594] = 7,
    ACTIONS(7334), 1,
      sym_name,
    ACTIONS(7336), 1,
      aux_sym__paren_open_token1,
    STATE(10810), 1,
      sym_gadt_constructor,
    STATE(11306), 1,
      sym__con_binding_list,
    STATE(11672), 1,
      sym__paren_open,
    STATE(9995), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383621] = 7,
    ACTIONS(8546), 1,
      anon_sym_SEMI,
    ACTIONS(8548), 1,
      sym__cond_layout_semicolon,
    STATE(2026), 1,
      aux_sym__let_binds_repeat1,
    STATE(9325), 1,
      aux_sym__patsyn_cons_repeat1,
    STATE(10592), 1,
      sym__layout_end,
    ACTIONS(8550), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383648] = 5,
    ACTIONS(6475), 1,
      sym__phantom_where,
    ACTIONS(8554), 1,
      anon_sym_where,
    STATE(9101), 1,
      sym__where,
    ACTIONS(8552), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383671] = 8,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    ACTIONS(8556), 1,
      sym__cond_layout_end,
    STATE(9384), 1,
      aux_sym__exp_multi_way_if_repeat1,
    STATE(10462), 1,
      sym__guards,
    STATE(11229), 1,
      sym_match,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383700] = 7,
    ACTIONS(8558), 1,
      sym_variable,
    ACTIONS(8560), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(12149), 1,
      sym__do_keyword,
    ACTIONS(6736), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383727] = 8,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    ACTIONS(8562), 1,
      sym__cond_layout_end,
    STATE(9384), 1,
      aux_sym__exp_multi_way_if_repeat1,
    STATE(10462), 1,
      sym__guards,
    STATE(11229), 1,
      sym_match,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383756] = 8,
    ACTIONS(2485), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6433), 1,
      sym__unboxed_close,
    STATE(9928), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10722), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383785] = 8,
    ACTIONS(2081), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(2692), 1,
      sym__unboxed_close,
    STATE(9726), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10365), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383814] = 7,
    ACTIONS(8564), 1,
      anon_sym_SEMI,
    ACTIONS(8566), 1,
      sym__cond_layout_semicolon,
    STATE(2044), 1,
      aux_sym__let_binds_repeat1,
    STATE(9690), 1,
      aux_sym__patsyn_cons_repeat1,
    STATE(10269), 1,
      sym__layout_end,
    ACTIONS(4176), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383841] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7013), 7,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [383858] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12661), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383887] = 7,
    ACTIONS(8568), 1,
      anon_sym_SEMI,
    ACTIONS(8570), 1,
      sym__cond_layout_semicolon,
    STATE(114), 1,
      aux_sym__let_binds_repeat1,
    STATE(4420), 1,
      sym__layout_end,
    STATE(9317), 1,
      aux_sym__statements_repeat1,
    ACTIONS(8572), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383914] = 7,
    ACTIONS(8574), 1,
      anon_sym_SEMI,
    ACTIONS(8576), 1,
      sym__cond_layout_semicolon,
    STATE(1918), 1,
      aux_sym__let_binds_repeat1,
    STATE(4898), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8578), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383941] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12601), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383970] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12524), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [383999] = 8,
    ACTIONS(2119), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(5832), 1,
      sym__unboxed_close,
    STATE(9729), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10582), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384028] = 7,
    ACTIONS(8580), 1,
      anon_sym_SEMI,
    ACTIONS(8582), 1,
      sym__cond_layout_semicolon,
    STATE(1917), 1,
      aux_sym__let_binds_repeat1,
    STATE(3970), 1,
      sym__layout_end,
    STATE(9313), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8584), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384055] = 3,
    ACTIONS(5640), 1,
      anon_sym_POUND,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5642), 6,
      sym__cond_qual_dot,
      sym__cond_prefix_dot,
      sym__varsym,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_POUND2,
  [384074] = 7,
    ACTIONS(8586), 1,
      anon_sym_SEMI,
    ACTIONS(8588), 1,
      sym__cond_layout_semicolon,
    STATE(7117), 1,
      aux_sym__let_binds_repeat1,
    STATE(9152), 1,
      aux_sym__tyfam_equations_repeat1,
    STATE(10593), 1,
      sym__layout_end,
    ACTIONS(8590), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384101] = 7,
    ACTIONS(8592), 1,
      anon_sym_SEMI,
    ACTIONS(8594), 1,
      sym__cond_layout_semicolon,
    STATE(7106), 1,
      aux_sym__let_binds_repeat1,
    STATE(9672), 1,
      aux_sym__tyfam_equations_repeat1,
    STATE(10594), 1,
      sym__layout_end,
    ACTIONS(8596), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384128] = 4,
    STATE(10737), 1,
      sym_instance_declarations,
    ACTIONS(8600), 2,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
    ACTIONS(8598), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384149] = 7,
    ACTIONS(8602), 1,
      anon_sym_SEMI,
    ACTIONS(8604), 1,
      sym__cond_layout_semicolon,
    STATE(1919), 1,
      aux_sym__let_binds_repeat1,
    STATE(3967), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8606), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384176] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12503), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384205] = 8,
    ACTIONS(2107), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(4087), 1,
      sym__unboxed_close,
    STATE(9890), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10854), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384234] = 7,
    ACTIONS(8608), 1,
      anon_sym_SEMI,
    ACTIONS(8610), 1,
      sym__cond_layout_semicolon,
    STATE(1897), 1,
      aux_sym__let_binds_repeat1,
    STATE(5159), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8612), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384261] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12383), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384290] = 7,
    ACTIONS(8614), 1,
      anon_sym_SEMI,
    ACTIONS(8616), 1,
      sym__cond_layout_semicolon,
    STATE(112), 1,
      aux_sym__let_binds_repeat1,
    STATE(2925), 1,
      sym__layout_end,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    ACTIONS(8618), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384317] = 7,
    ACTIONS(8620), 1,
      anon_sym_SEMI,
    ACTIONS(8622), 1,
      sym__cond_layout_semicolon,
    STATE(1921), 1,
      aux_sym__let_binds_repeat1,
    STATE(3966), 1,
      sym__layout_end,
    STATE(9323), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8624), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384344] = 7,
    ACTIONS(8626), 1,
      anon_sym_SEMI,
    ACTIONS(8628), 1,
      sym__cond_layout_semicolon,
    STATE(1922), 1,
      aux_sym__let_binds_repeat1,
    STATE(5165), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8630), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384371] = 8,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    ACTIONS(8632), 1,
      sym__cond_layout_end,
    STATE(9384), 1,
      aux_sym__exp_multi_way_if_repeat1,
    STATE(10462), 1,
      sym__guards,
    STATE(11229), 1,
      sym_match,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384400] = 7,
    ACTIONS(8634), 1,
      anon_sym_SEMI,
    ACTIONS(8636), 1,
      sym__cond_layout_semicolon,
    STATE(2051), 1,
      aux_sym__let_binds_repeat1,
    STATE(5173), 1,
      sym__layout_end,
    STATE(9637), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8638), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384427] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12345), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384456] = 8,
    ACTIONS(2279), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(3450), 1,
      sym__unboxed_close,
    STATE(9926), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10528), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384485] = 7,
    ACTIONS(8640), 1,
      sym_variable,
    ACTIONS(8642), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(12149), 1,
      sym__do_keyword,
    ACTIONS(6736), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384512] = 7,
    ACTIONS(8644), 1,
      anon_sym_SEMI,
    ACTIONS(8646), 1,
      sym__cond_layout_semicolon,
    STATE(1841), 1,
      aux_sym__let_binds_repeat1,
    STATE(9303), 1,
      aux_sym__let_binds_repeat2,
    STATE(9671), 1,
      sym__layout_end,
    ACTIONS(8648), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384539] = 7,
    ACTIONS(8650), 1,
      anon_sym_SEMI,
    ACTIONS(8652), 1,
      sym__cond_layout_semicolon,
    STATE(7085), 1,
      aux_sym__let_binds_repeat1,
    STATE(9301), 1,
      aux_sym__tyfam_equations_repeat1,
    STATE(10625), 1,
      sym__layout_end,
    ACTIONS(8654), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384566] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4685), 7,
      anon_sym_COMMA,
      anon_sym__,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [384583] = 7,
    ACTIONS(8558), 1,
      sym_variable,
    ACTIONS(8656), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(12149), 1,
      sym__do_keyword,
    ACTIONS(6736), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384610] = 7,
    ACTIONS(8658), 1,
      anon_sym_SEMI,
    ACTIONS(8660), 1,
      sym__cond_layout_semicolon,
    STATE(73), 1,
      aux_sym__let_binds_repeat1,
    STATE(5507), 1,
      sym__layout_end,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    ACTIONS(8662), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384637] = 7,
    ACTIONS(8664), 1,
      anon_sym_SEMI,
    ACTIONS(8666), 1,
      sym__cond_layout_semicolon,
    STATE(2084), 1,
      aux_sym__let_binds_repeat1,
    STATE(5209), 1,
      sym__layout_end,
    STATE(9637), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8668), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384664] = 8,
    ACTIONS(2099), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6977), 1,
      sym__unboxed_close,
    STATE(9921), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10375), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384693] = 7,
    ACTIONS(8670), 1,
      anon_sym_SEMI,
    ACTIONS(8672), 1,
      sym__cond_layout_semicolon,
    STATE(2052), 1,
      aux_sym__let_binds_repeat1,
    STATE(3959), 1,
      sym__layout_end,
    STATE(9637), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8674), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384720] = 7,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(8676), 1,
      anon_sym_as,
    ACTIONS(8678), 1,
      anon_sym_hiding,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11583), 1,
      sym_import_list,
    ACTIONS(7696), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384747] = 7,
    ACTIONS(8680), 1,
      anon_sym_SEMI,
    ACTIONS(8682), 1,
      sym__cond_layout_semicolon,
    STATE(93), 1,
      aux_sym__let_binds_repeat1,
    STATE(5112), 1,
      sym__layout_end,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    ACTIONS(8684), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384774] = 7,
    ACTIONS(8686), 1,
      anon_sym_SEMI,
    ACTIONS(8688), 1,
      sym__cond_layout_semicolon,
    STATE(2102), 1,
      aux_sym__let_binds_repeat1,
    STATE(5392), 1,
      sym__layout_end,
    STATE(9637), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8690), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384801] = 7,
    ACTIONS(8692), 1,
      anon_sym_SEMI,
    ACTIONS(8694), 1,
      sym__cond_layout_semicolon,
    STATE(7158), 1,
      aux_sym__let_binds_repeat1,
    STATE(9672), 1,
      aux_sym__tyfam_equations_repeat1,
    STATE(10424), 1,
      sym__layout_end,
    ACTIONS(8696), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384828] = 7,
    ACTIONS(8698), 1,
      anon_sym_SEMI,
    ACTIONS(8700), 1,
      sym__cond_layout_semicolon,
    STATE(9), 1,
      aux_sym__let_binds_repeat1,
    STATE(9565), 1,
      aux_sym_quoted_decls_repeat1,
    STATE(11369), 1,
      sym__layout_end,
    ACTIONS(8702), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384855] = 7,
    ACTIONS(8704), 1,
      anon_sym_SEMI,
    ACTIONS(8706), 1,
      sym__cond_layout_semicolon,
    STATE(1854), 1,
      aux_sym__let_binds_repeat1,
    STATE(9564), 1,
      aux_sym__let_binds_repeat2,
    STATE(9571), 1,
      sym__layout_end,
    ACTIONS(8708), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384882] = 7,
    ACTIONS(8710), 1,
      anon_sym_SEMI,
    ACTIONS(8712), 1,
      sym__cond_layout_semicolon,
    STATE(10), 1,
      aux_sym__let_binds_repeat1,
    STATE(9523), 1,
      aux_sym_quoted_decls_repeat1,
    STATE(11340), 1,
      sym__layout_end,
    ACTIONS(8714), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384909] = 7,
    ACTIONS(8716), 1,
      anon_sym_SEMI,
    ACTIONS(8718), 1,
      sym__cond_layout_semicolon,
    STATE(78), 1,
      aux_sym__let_binds_repeat1,
    STATE(4727), 1,
      sym__layout_end,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    ACTIONS(8720), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384936] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4707), 7,
      anon_sym_COMMA,
      anon_sym__,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [384953] = 7,
    ACTIONS(8722), 1,
      anon_sym_SEMI,
    ACTIONS(8724), 1,
      sym__cond_layout_semicolon,
    STATE(81), 1,
      aux_sym__let_binds_repeat1,
    STATE(5339), 1,
      sym__layout_end,
    STATE(9495), 1,
      aux_sym__statements_repeat1,
    ACTIONS(8726), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [384980] = 4,
    STATE(10637), 1,
      sym_class_declarations,
    ACTIONS(8222), 2,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
    ACTIONS(8728), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385001] = 7,
    ACTIONS(8730), 1,
      anon_sym_SEMI,
    ACTIONS(8732), 1,
      sym__cond_layout_semicolon,
    STATE(2099), 1,
      aux_sym__let_binds_repeat1,
    STATE(4445), 1,
      sym__layout_end,
    STATE(9342), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8734), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385028] = 7,
    ACTIONS(8736), 1,
      anon_sym_SEMI,
    ACTIONS(8738), 1,
      sym__cond_layout_semicolon,
    STATE(1899), 1,
      aux_sym__let_binds_repeat1,
    STATE(4448), 1,
      sym__layout_end,
    STATE(9346), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8740), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385055] = 5,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(7476), 3,
      sym__phantom_where,
      aux_sym__paren_open_token1,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385078] = 8,
    ACTIONS(2347), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(4187), 1,
      sym__unboxed_close,
    STATE(9756), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10475), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385107] = 7,
    ACTIONS(8742), 1,
      anon_sym_SEMI,
    ACTIONS(8744), 1,
      sym__cond_layout_semicolon,
    STATE(1938), 1,
      aux_sym__let_binds_repeat1,
    STATE(3952), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8746), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385134] = 7,
    ACTIONS(8748), 1,
      anon_sym_SEMI,
    ACTIONS(8750), 1,
      sym__cond_layout_semicolon,
    STATE(109), 1,
      aux_sym__let_binds_repeat1,
    STATE(4451), 1,
      sym__layout_end,
    STATE(9352), 1,
      aux_sym__statements_repeat1,
    ACTIONS(8752), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385161] = 4,
    STATE(10495), 1,
      sym__patsyn_cons,
    ACTIONS(8756), 2,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
    ACTIONS(8754), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385182] = 8,
    ACTIONS(2535), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(5924), 1,
      sym__unboxed_close,
    STATE(9917), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10881), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385211] = 7,
    ACTIONS(8758), 1,
      anon_sym_SEMI,
    ACTIONS(8760), 1,
      sym__cond_layout_semicolon,
    STATE(105), 1,
      aux_sym__let_binds_repeat1,
    STATE(4456), 1,
      sym__layout_end,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    ACTIONS(8762), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385238] = 8,
    ACTIONS(2181), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6193), 1,
      sym__unboxed_close,
    STATE(9782), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10570), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385267] = 7,
    ACTIONS(3411), 1,
      aux_sym__paren_close_token1,
    ACTIONS(8262), 1,
      anon_sym_COMMA,
    STATE(1574), 1,
      sym__colon2,
    STATE(8000), 1,
      sym__paren_close,
    STATE(10200), 1,
      aux_sym__ctr_tuple_repeat1,
    ACTIONS(8264), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385294] = 7,
    ACTIONS(8764), 1,
      anon_sym_SEMI,
    ACTIONS(8766), 1,
      sym__cond_layout_semicolon,
    STATE(1910), 1,
      aux_sym__let_binds_repeat1,
    STATE(5202), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8768), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385321] = 7,
    ACTIONS(8770), 1,
      anon_sym_SEMI,
    ACTIONS(8772), 1,
      sym__cond_layout_semicolon,
    STATE(2094), 1,
      aux_sym__let_binds_repeat1,
    STATE(3014), 1,
      sym__layout_end,
    STATE(9637), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8774), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385348] = 7,
    ACTIONS(8776), 1,
      anon_sym_SEMI,
    ACTIONS(8778), 1,
      sym__cond_layout_semicolon,
    STATE(1902), 1,
      aux_sym__let_binds_repeat1,
    STATE(5197), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8780), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385375] = 7,
    ACTIONS(8782), 1,
      anon_sym_SEMI,
    ACTIONS(8784), 1,
      sym__cond_layout_semicolon,
    STATE(1944), 1,
      aux_sym__let_binds_repeat1,
    STATE(3947), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8786), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385402] = 7,
    ACTIONS(8788), 1,
      anon_sym_SEMI,
    ACTIONS(8790), 1,
      sym__cond_layout_semicolon,
    STATE(1894), 1,
      aux_sym__let_binds_repeat1,
    STATE(5397), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8792), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385429] = 7,
    ACTIONS(8794), 1,
      anon_sym_SEMI,
    ACTIONS(8796), 1,
      sym__cond_layout_semicolon,
    STATE(2020), 1,
      aux_sym__let_binds_repeat1,
    STATE(9690), 1,
      aux_sym__patsyn_cons_repeat1,
    STATE(10385), 1,
      sym__layout_end,
    ACTIONS(4154), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385456] = 7,
    ACTIONS(6838), 1,
      sym_variable,
    ACTIONS(8798), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(12149), 1,
      sym__do_keyword,
    ACTIONS(6736), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385483] = 7,
    ACTIONS(8800), 1,
      anon_sym_SEMI,
    ACTIONS(8802), 1,
      sym__cond_layout_semicolon,
    STATE(1932), 1,
      aux_sym__let_binds_repeat1,
    STATE(5190), 1,
      sym__layout_end,
    STATE(9280), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8804), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385510] = 7,
    ACTIONS(8806), 1,
      anon_sym_SEMI,
    ACTIONS(8808), 1,
      sym__cond_layout_semicolon,
    STATE(1943), 1,
      aux_sym__let_binds_repeat1,
    STATE(5191), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8810), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385537] = 7,
    ACTIONS(8812), 1,
      anon_sym_SEMI,
    ACTIONS(8814), 1,
      sym__cond_layout_semicolon,
    STATE(79), 1,
      aux_sym__let_binds_repeat1,
    STATE(4730), 1,
      sym__layout_end,
    STATE(9202), 1,
      aux_sym__statements_repeat1,
    ACTIONS(8816), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385564] = 7,
    ACTIONS(7588), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7720), 1,
      sym_variable,
    STATE(8758), 1,
      sym__paren_open,
    STATE(10187), 1,
      sym_signature,
    STATE(10941), 1,
      sym__var_binding_list,
    STATE(9761), 2,
      sym__varsym_prefix,
      sym__pvarsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385591] = 3,
    ACTIONS(8818), 2,
      anon_sym_POUND2,
      anon_sym_PIPE2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5802), 5,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [385610] = 7,
    ACTIONS(8820), 1,
      anon_sym_SEMI,
    ACTIONS(8822), 1,
      sym__cond_layout_semicolon,
    STATE(1948), 1,
      aux_sym__let_binds_repeat1,
    STATE(5195), 1,
      sym__layout_end,
    STATE(9284), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8824), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385637] = 7,
    ACTIONS(7588), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7720), 1,
      sym_variable,
    STATE(8758), 1,
      sym__paren_open,
    STATE(10185), 1,
      sym_signature,
    STATE(10941), 1,
      sym__var_binding_list,
    STATE(9761), 2,
      sym__varsym_prefix,
      sym__pvarsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385664] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12270), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385693] = 7,
    ACTIONS(8826), 1,
      anon_sym_SEMI,
    ACTIONS(8828), 1,
      sym__cond_layout_semicolon,
    STATE(2061), 1,
      aux_sym__let_binds_repeat1,
    STATE(5206), 1,
      sym__layout_end,
    STATE(9637), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8830), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385720] = 7,
    ACTIONS(7588), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7720), 1,
      sym_variable,
    STATE(8758), 1,
      sym__paren_open,
    STATE(10634), 1,
      sym_signature,
    STATE(10941), 1,
      sym__var_binding_list,
    STATE(9761), 2,
      sym__varsym_prefix,
      sym__pvarsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385747] = 8,
    ACTIONS(2263), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(7538), 1,
      sym__unboxed_close,
    STATE(9713), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10479), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385776] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6997), 7,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [385793] = 7,
    ACTIONS(8832), 1,
      anon_sym_SEMI,
    ACTIONS(8834), 1,
      sym__cond_layout_semicolon,
    STATE(2097), 1,
      aux_sym__let_binds_repeat1,
    STATE(4728), 1,
      sym__layout_end,
    STATE(9362), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8836), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385820] = 7,
    ACTIONS(8838), 1,
      anon_sym_SEMI,
    ACTIONS(8840), 1,
      sym__cond_layout_semicolon,
    STATE(1893), 1,
      aux_sym__let_binds_repeat1,
    STATE(4731), 1,
      sym__layout_end,
    STATE(9185), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8842), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385847] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7516), 7,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [385864] = 7,
    ACTIONS(8844), 1,
      anon_sym_SEMI,
    ACTIONS(8846), 1,
      sym__cond_layout_semicolon,
    STATE(2096), 1,
      aux_sym__let_binds_repeat1,
    STATE(4744), 1,
      sym__layout_end,
    STATE(9637), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8848), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385891] = 7,
    ACTIONS(8850), 1,
      anon_sym_SEMI,
    ACTIONS(8852), 1,
      sym__cond_layout_semicolon,
    STATE(1904), 1,
      aux_sym__let_binds_repeat1,
    STATE(4747), 1,
      sym__layout_end,
    STATE(9367), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8854), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385918] = 7,
    ACTIONS(8856), 1,
      anon_sym_SEMI,
    ACTIONS(8858), 1,
      sym__cond_layout_semicolon,
    STATE(2064), 1,
      aux_sym__let_binds_repeat1,
    STATE(5244), 1,
      sym__layout_end,
    STATE(9286), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8860), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385945] = 7,
    ACTIONS(8862), 1,
      anon_sym_SEMI,
    ACTIONS(8864), 1,
      sym__cond_layout_semicolon,
    STATE(1924), 1,
      aux_sym__let_binds_repeat1,
    STATE(5532), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8866), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385972] = 7,
    ACTIONS(8868), 1,
      anon_sym_SEMI,
    ACTIONS(8870), 1,
      sym__cond_layout_semicolon,
    STATE(1907), 1,
      aux_sym__let_binds_repeat1,
    STATE(4750), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8872), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [385999] = 7,
    ACTIONS(8874), 1,
      anon_sym_SEMI,
    ACTIONS(8876), 1,
      sym__cond_layout_semicolon,
    STATE(1909), 1,
      aux_sym__let_binds_repeat1,
    STATE(4751), 1,
      sym__layout_end,
    STATE(9372), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8878), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386026] = 8,
    ACTIONS(2439), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6639), 1,
      sym__unboxed_close,
    STATE(9908), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10791), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386055] = 7,
    ACTIONS(8880), 1,
      anon_sym_SEMI,
    ACTIONS(8882), 1,
      sym__cond_layout_semicolon,
    STATE(1911), 1,
      aux_sym__let_binds_repeat1,
    STATE(5352), 1,
      sym__layout_end,
    STATE(9359), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8884), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386082] = 7,
    ACTIONS(8886), 1,
      anon_sym_SEMI,
    ACTIONS(8888), 1,
      sym__cond_layout_semicolon,
    STATE(2086), 1,
      aux_sym__let_binds_repeat1,
    STATE(4732), 1,
      sym__layout_end,
    STATE(9208), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8890), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386109] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7001), 7,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [386126] = 7,
    ACTIONS(8892), 1,
      anon_sym_SEMI,
    ACTIONS(8894), 1,
      sym__cond_layout_semicolon,
    STATE(85), 1,
      aux_sym__let_binds_repeat1,
    STATE(4761), 1,
      sym__layout_end,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    ACTIONS(8896), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386153] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12255), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386182] = 7,
    ACTIONS(8898), 1,
      sym_variable,
    ACTIONS(8900), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(12149), 1,
      sym__do_keyword,
    ACTIONS(6736), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386209] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7516), 7,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [386226] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7516), 7,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [386243] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12643), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386272] = 8,
    ACTIONS(8902), 1,
      anon_sym_COMMA,
    ACTIONS(8904), 1,
      anon_sym_PIPE,
    ACTIONS(8906), 1,
      anon_sym_PIPE2,
    ACTIONS(8908), 1,
      anon_sym_POUND_RPAREN,
    STATE(7918), 1,
      sym__unboxed_close,
    STATE(9937), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(10806), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386301] = 7,
    ACTIONS(8910), 1,
      anon_sym_SEMI,
    ACTIONS(8912), 1,
      sym__cond_layout_semicolon,
    STATE(1925), 1,
      aux_sym__let_binds_repeat1,
    STATE(5402), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8914), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386328] = 7,
    ACTIONS(8916), 1,
      anon_sym_SEMI,
    ACTIONS(8918), 1,
      sym__cond_layout_semicolon,
    STATE(1908), 1,
      aux_sym__let_binds_repeat1,
    STATE(5351), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8920), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386355] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7540), 7,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [386372] = 7,
    ACTIONS(8922), 1,
      anon_sym_SEMI,
    ACTIONS(8924), 1,
      sym__cond_layout_semicolon,
    STATE(2090), 1,
      aux_sym__let_binds_repeat1,
    STATE(4780), 1,
      sym__layout_end,
    STATE(9637), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8926), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386399] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7516), 7,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [386416] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7540), 7,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [386433] = 8,
    ACTIONS(2493), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(7745), 1,
      sym__unboxed_close,
    STATE(9954), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10706), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386462] = 7,
    ACTIONS(8928), 1,
      anon_sym_SEMI,
    ACTIONS(8930), 1,
      sym__cond_layout_semicolon,
    STATE(1906), 1,
      aux_sym__let_binds_repeat1,
    STATE(5348), 1,
      sym__layout_end,
    STATE(9324), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8932), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386489] = 7,
    ACTIONS(8934), 1,
      anon_sym_SEMI,
    ACTIONS(8936), 1,
      sym__cond_layout_semicolon,
    STATE(1913), 1,
      aux_sym__let_binds_repeat1,
    STATE(4837), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8938), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386516] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12609), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386545] = 8,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    ACTIONS(8940), 1,
      sym__cond_layout_end,
    STATE(9259), 1,
      aux_sym__exp_multi_way_if_repeat1,
    STATE(10462), 1,
      sym__guards,
    STATE(11229), 1,
      sym_match,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386574] = 7,
    ACTIONS(8942), 1,
      anon_sym_SEMI,
    ACTIONS(8944), 1,
      sym__cond_layout_semicolon,
    STATE(1143), 1,
      aux_sym__let_binds_repeat1,
    STATE(9613), 1,
      aux_sym_instance_declarations_repeat1,
    STATE(10708), 1,
      sym__layout_end,
    ACTIONS(8946), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386601] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7005), 7,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [386618] = 7,
    ACTIONS(8948), 1,
      anon_sym_SEMI,
    ACTIONS(8950), 1,
      sym__cond_layout_semicolon,
    STATE(1916), 1,
      aux_sym__let_binds_repeat1,
    STATE(4859), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8952), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386645] = 7,
    ACTIONS(8954), 1,
      anon_sym_SEMI,
    ACTIONS(8956), 1,
      sym__cond_layout_semicolon,
    STATE(2081), 1,
      aux_sym__let_binds_repeat1,
    STATE(5347), 1,
      sym__layout_end,
    STATE(9637), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8958), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386672] = 7,
    ACTIONS(8960), 1,
      anon_sym_SEMI,
    ACTIONS(8962), 1,
      sym__cond_layout_semicolon,
    STATE(2057), 1,
      aux_sym__let_binds_repeat1,
    STATE(5319), 1,
      sym__layout_end,
    STATE(9373), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8964), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386699] = 8,
    ACTIONS(2197), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(4331), 1,
      sym__unboxed_close,
    STATE(9809), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10642), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386728] = 7,
    ACTIONS(8966), 1,
      anon_sym_SEMI,
    ACTIONS(8968), 1,
      sym__cond_layout_semicolon,
    STATE(1927), 1,
      aux_sym__let_binds_repeat1,
    STATE(5320), 1,
      sym__layout_end,
    STATE(9360), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8970), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386755] = 7,
    ACTIONS(8972), 1,
      anon_sym_SEMI,
    ACTIONS(8974), 1,
      sym__cond_layout_semicolon,
    STATE(2069), 1,
      aux_sym__let_binds_repeat1,
    STATE(5345), 1,
      sym__layout_end,
    STATE(9300), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(8976), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386782] = 7,
    ACTIONS(8978), 1,
      anon_sym_SEMI,
    ACTIONS(8980), 1,
      sym__cond_layout_semicolon,
    STATE(1926), 1,
      aux_sym__let_binds_repeat1,
    STATE(5631), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(8982), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386809] = 3,
    ACTIONS(1125), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(1123), 6,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_PIPE_PIPE_RBRACK,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [386828] = 8,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      sym__cond_layout_end,
    STATE(9498), 1,
      aux_sym__exp_multi_way_if_repeat1,
    STATE(10462), 1,
      sym__guards,
    STATE(11229), 1,
      sym_match,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386857] = 8,
    ACTIONS(2527), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(7623), 1,
      sym__unboxed_close,
    STATE(9899), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10744), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386886] = 7,
    ACTIONS(8986), 1,
      anon_sym_SEMI,
    ACTIONS(8988), 1,
      sym__cond_layout_semicolon,
    STATE(102), 1,
      aux_sym__let_binds_repeat1,
    STATE(5109), 1,
      sym__layout_end,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    ACTIONS(8990), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386913] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12611), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386942] = 8,
    ACTIONS(8992), 1,
      anon_sym_PIPE,
    ACTIONS(8995), 1,
      sym__cond_layout_end,
    ACTIONS(8997), 1,
      sym__phantom_bar,
    STATE(9384), 1,
      aux_sym__exp_multi_way_if_repeat1,
    STATE(10462), 1,
      sym__guards,
    STATE(11229), 1,
      sym_match,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386971] = 7,
    ACTIONS(9000), 1,
      sym_variable,
    ACTIONS(9002), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(12149), 1,
      sym__do_keyword,
    ACTIONS(6736), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386998] = 3,
    ACTIONS(4875), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4877), 6,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_PIPE_PIPE_RBRACK,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [387017] = 7,
    ACTIONS(9004), 1,
      anon_sym_SEMI,
    ACTIONS(9006), 1,
      sym__cond_layout_semicolon,
    STATE(107), 1,
      aux_sym__let_binds_repeat1,
    STATE(5107), 1,
      sym__layout_end,
    STATE(9299), 1,
      aux_sym__statements_repeat1,
    ACTIONS(9008), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387044] = 7,
    ACTIONS(9010), 1,
      anon_sym_SEMI,
    ACTIONS(9012), 1,
      sym__cond_layout_semicolon,
    STATE(1390), 1,
      aux_sym__let_binds_repeat1,
    STATE(9596), 1,
      aux_sym_local_binds_repeat1,
    STATE(10465), 1,
      sym__layout_end,
    ACTIONS(9014), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387071] = 3,
    ACTIONS(4871), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4873), 6,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_PIPE_PIPE_RBRACK,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [387090] = 3,
    ACTIONS(4867), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4869), 6,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_PIPE_PIPE_RBRACK,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [387109] = 7,
    ACTIONS(9016), 1,
      anon_sym_SEMI,
    ACTIONS(9018), 1,
      sym__cond_layout_semicolon,
    STATE(1936), 1,
      aux_sym__let_binds_repeat1,
    STATE(5423), 1,
      sym__layout_end,
    STATE(9328), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(9020), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387136] = 7,
    ACTIONS(9022), 1,
      anon_sym_SEMI,
    ACTIONS(9024), 1,
      sym__cond_layout_semicolon,
    STATE(2078), 1,
      aux_sym__let_binds_repeat1,
    STATE(5424), 1,
      sym__layout_end,
    STATE(9335), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(9026), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387163] = 7,
    ACTIONS(8898), 1,
      sym_variable,
    ACTIONS(9028), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(12149), 1,
      sym__do_keyword,
    ACTIONS(6736), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387190] = 7,
    ACTIONS(9030), 1,
      anon_sym_SEMI,
    ACTIONS(9032), 1,
      sym__cond_layout_semicolon,
    STATE(1383), 1,
      aux_sym__let_binds_repeat1,
    STATE(9596), 1,
      aux_sym_local_binds_repeat1,
    STATE(10715), 1,
      sym__layout_end,
    ACTIONS(9034), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387217] = 3,
    ACTIONS(4863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 6,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_PIPE_PIPE_RBRACK,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [387236] = 3,
    ACTIONS(4863), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4865), 6,
      sym__phantom_arrow,
      sym__cond_prefix_percent,
      anon_sym_PIPE_PIPE_RBRACK,
      anon_sym_u2192,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
  [387255] = 5,
    ACTIONS(6475), 1,
      sym__phantom_where,
    ACTIONS(9038), 1,
      anon_sym_where,
    STATE(9315), 1,
      sym__where,
    ACTIONS(9036), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387278] = 7,
    ACTIONS(6838), 1,
      sym_variable,
    ACTIONS(8642), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(12149), 1,
      sym__do_keyword,
    ACTIONS(6736), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387305] = 7,
    ACTIONS(9040), 1,
      anon_sym_SEMI,
    ACTIONS(9042), 1,
      sym__cond_layout_semicolon,
    STATE(1380), 1,
      aux_sym__let_binds_repeat1,
    STATE(9388), 1,
      aux_sym_local_binds_repeat1,
    STATE(10720), 1,
      sym__layout_end,
    ACTIONS(9044), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387332] = 8,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    ACTIONS(9046), 1,
      sym__cond_layout_end,
    STATE(9478), 1,
      aux_sym__exp_multi_way_if_repeat1,
    STATE(10462), 1,
      sym__guards,
    STATE(11229), 1,
      sym_match,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387361] = 7,
    ACTIONS(9048), 1,
      anon_sym_SEMI,
    ACTIONS(9050), 1,
      sym__cond_layout_semicolon,
    STATE(2079), 1,
      aux_sym__let_binds_repeat1,
    STATE(5659), 1,
      sym__layout_end,
    STATE(9637), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(9052), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387388] = 4,
    STATE(10169), 1,
      sym_class_declarations,
    ACTIONS(8222), 2,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
    ACTIONS(9054), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387409] = 8,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    ACTIONS(9056), 1,
      sym__cond_layout_end,
    STATE(9384), 1,
      aux_sym__exp_multi_way_if_repeat1,
    STATE(10462), 1,
      sym__guards,
    STATE(11229), 1,
      sym_match,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387438] = 7,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(9058), 1,
      anon_sym_as,
    ACTIONS(9060), 1,
      anon_sym_hiding,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11668), 1,
      sym_import_list,
    ACTIONS(7755), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387465] = 7,
    ACTIONS(8558), 1,
      sym_variable,
    ACTIONS(9062), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(12149), 1,
      sym__do_keyword,
    ACTIONS(6736), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387492] = 7,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(9064), 1,
      anon_sym_as,
    ACTIONS(9066), 1,
      anon_sym_hiding,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11647), 1,
      sym_import_list,
    ACTIONS(7749), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387519] = 7,
    ACTIONS(9068), 1,
      anon_sym_SEMI,
    ACTIONS(9070), 1,
      sym__cond_layout_semicolon,
    STATE(735), 1,
      aux_sym__let_binds_repeat1,
    STATE(9417), 1,
      aux_sym_class_declarations_repeat1,
    STATE(10662), 1,
      sym__layout_end,
    ACTIONS(9072), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387546] = 4,
    STATE(1743), 1,
      sym__colon2,
    ACTIONS(9076), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(9074), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387567] = 8,
    ACTIONS(2413), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(7080), 1,
      sym__unboxed_close,
    STATE(9795), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10694), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387596] = 4,
    STATE(10721), 1,
      sym_class_declarations,
    ACTIONS(8222), 2,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
    ACTIONS(9078), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387617] = 5,
    ACTIONS(6475), 1,
      sym__phantom_where,
    ACTIONS(9082), 1,
      anon_sym_where,
    STATE(9449), 1,
      sym__where,
    ACTIONS(9080), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387640] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12631), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387669] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7009), 7,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [387686] = 8,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    ACTIONS(9084), 1,
      sym__cond_layout_end,
    STATE(9473), 1,
      aux_sym__exp_multi_way_if_repeat1,
    STATE(10462), 1,
      sym__guards,
    STATE(11229), 1,
      sym_match,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387715] = 7,
    ACTIONS(9086), 1,
      anon_sym_SEMI,
    ACTIONS(9088), 1,
      sym__cond_layout_semicolon,
    STATE(83), 1,
      aux_sym__let_binds_repeat1,
    STATE(2954), 1,
      sym__layout_end,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    ACTIONS(9090), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387742] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9092), 7,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_where,
  [387759] = 7,
    ACTIONS(9094), 1,
      anon_sym_SEMI,
    ACTIONS(9096), 1,
      sym__cond_layout_semicolon,
    STATE(742), 1,
      aux_sym__let_binds_repeat1,
    STATE(9617), 1,
      aux_sym_class_declarations_repeat1,
    STATE(10735), 1,
      sym__layout_end,
    ACTIONS(9098), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387786] = 4,
    STATE(10160), 1,
      sym_class_declarations,
    ACTIONS(8222), 2,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
    ACTIONS(9100), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387807] = 7,
    ACTIONS(6838), 1,
      sym_variable,
    ACTIONS(8234), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(12149), 1,
      sym__do_keyword,
    ACTIONS(6736), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387834] = 8,
    ACTIONS(2023), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(4070), 1,
      sym__unboxed_close,
    STATE(9776), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10530), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387863] = 7,
    ACTIONS(9102), 1,
      anon_sym_SEMI,
    ACTIONS(9104), 1,
      sym__cond_layout_semicolon,
    STATE(1915), 1,
      aux_sym__let_binds_repeat1,
    STATE(3005), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(9106), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387890] = 5,
    ACTIONS(6475), 1,
      sym__phantom_where,
    ACTIONS(9110), 1,
      anon_sym_where,
    STATE(9410), 1,
      sym__where,
    ACTIONS(9108), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387913] = 7,
    ACTIONS(9112), 1,
      anon_sym_SEMI,
    ACTIONS(9114), 1,
      sym__cond_layout_semicolon,
    STATE(100), 1,
      aux_sym__let_binds_repeat1,
    STATE(4989), 1,
      sym__layout_end,
    STATE(9454), 1,
      aux_sym__statements_repeat1,
    ACTIONS(9116), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387940] = 7,
    ACTIONS(9118), 1,
      anon_sym_SEMI,
    ACTIONS(9120), 1,
      sym__cond_layout_semicolon,
    STATE(116), 1,
      aux_sym__let_binds_repeat1,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    STATE(10032), 1,
      sym__layout_end,
    ACTIONS(9122), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387967] = 4,
    STATE(10681), 1,
      sym_class_declarations,
    ACTIONS(8222), 2,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
    ACTIONS(9124), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387988] = 7,
    ACTIONS(9126), 1,
      anon_sym_SEMI,
    ACTIONS(9128), 1,
      sym__cond_layout_semicolon,
    STATE(8713), 1,
      aux_sym__let_binds_repeat1,
    STATE(9182), 1,
      aux_sym_gadt_constructors_repeat1,
    STATE(9685), 1,
      sym__layout_end,
    ACTIONS(9130), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388015] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12635), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388044] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12637), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388073] = 7,
    ACTIONS(9132), 1,
      anon_sym_SEMI,
    ACTIONS(9134), 1,
      sym__cond_layout_semicolon,
    STATE(77), 1,
      aux_sym__let_binds_repeat1,
    STATE(4234), 1,
      sym__layout_end,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    ACTIONS(9136), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388100] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12641), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388129] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12645), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388158] = 4,
    STATE(10682), 1,
      sym_class_declarations,
    ACTIONS(8222), 2,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
    ACTIONS(9138), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388179] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12647), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388208] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12649), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388237] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12651), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388266] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12617), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388295] = 5,
    ACTIONS(6475), 1,
      sym__phantom_where,
    ACTIONS(9142), 1,
      anon_sym_where,
    STATE(9432), 1,
      sym__where,
    ACTIONS(9140), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388318] = 7,
    ACTIONS(9144), 1,
      anon_sym_SEMI,
    ACTIONS(9146), 1,
      sym__cond_layout_semicolon,
    STATE(1852), 1,
      aux_sym__let_binds_repeat1,
    STATE(9564), 1,
      aux_sym__let_binds_repeat2,
    STATE(9681), 1,
      sym__layout_end,
    ACTIONS(9148), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388345] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12639), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388374] = 8,
    ACTIONS(2519), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(7349), 1,
      sym__unboxed_close,
    STATE(9858), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10672), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388403] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12671), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388432] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12653), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388461] = 7,
    ACTIONS(9150), 1,
      anon_sym_SEMI,
    ACTIONS(9152), 1,
      sym__cond_layout_semicolon,
    STATE(808), 1,
      aux_sym__let_binds_repeat1,
    STATE(9198), 1,
      aux_sym_class_declarations_repeat1,
    STATE(10674), 1,
      sym__layout_end,
    ACTIONS(9154), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388488] = 6,
    ACTIONS(9156), 1,
      anon_sym_in,
    ACTIONS(9158), 1,
      sym__phantom_in,
    STATE(10231), 1,
      sym__let_binds,
    ACTIONS(7722), 2,
      anon_sym_COMMA,
      anon_sym_EQ,
    ACTIONS(8090), 2,
      sym__cmd_layout_start_let,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388513] = 7,
    ACTIONS(9160), 1,
      anon_sym_SEMI,
    ACTIONS(9162), 1,
      sym__cond_layout_semicolon,
    STATE(1901), 1,
      aux_sym__let_binds_repeat1,
    STATE(3000), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(9164), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388540] = 7,
    ACTIONS(9166), 1,
      anon_sym_SEMI,
    ACTIONS(9168), 1,
      sym__cond_layout_semicolon,
    STATE(2083), 1,
      aux_sym__let_binds_repeat1,
    STATE(2912), 1,
      sym__layout_end,
    STATE(9193), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(9170), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388567] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12615), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388596] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12665), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388625] = 4,
    STATE(10690), 1,
      sym_class_declarations,
    ACTIONS(8222), 2,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
    ACTIONS(9172), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388646] = 5,
    ACTIONS(6475), 1,
      sym__phantom_where,
    ACTIONS(9176), 1,
      anon_sym_where,
    STATE(9276), 1,
      sym__where,
    ACTIONS(9174), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388669] = 7,
    ACTIONS(9178), 1,
      anon_sym_SEMI,
    ACTIONS(9180), 1,
      sym__cond_layout_semicolon,
    STATE(1848), 1,
      aux_sym__let_binds_repeat1,
    STATE(9224), 1,
      aux_sym__let_binds_repeat2,
    STATE(9602), 1,
      sym__layout_end,
    ACTIONS(9182), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388696] = 7,
    ACTIONS(9184), 1,
      anon_sym_SEMI,
    ACTIONS(9186), 1,
      sym__cond_layout_semicolon,
    STATE(76), 1,
      aux_sym__let_binds_repeat1,
    STATE(2941), 1,
      sym__layout_end,
    STATE(9282), 1,
      aux_sym__statements_repeat1,
    ACTIONS(9188), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388723] = 5,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(7438), 3,
      sym__phantom_where,
      aux_sym__paren_open_token1,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388746] = 7,
    ACTIONS(9190), 1,
      anon_sym_SEMI,
    ACTIONS(9192), 1,
      sym__cond_layout_semicolon,
    STATE(110), 1,
      aux_sym__let_binds_repeat1,
    STATE(4955), 1,
      sym__layout_end,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    ACTIONS(9194), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388773] = 7,
    ACTIONS(9196), 1,
      anon_sym_SEMI,
    ACTIONS(9198), 1,
      sym__cond_layout_semicolon,
    STATE(7099), 1,
      aux_sym__let_binds_repeat1,
    STATE(9275), 1,
      aux_sym__tyfam_equations_repeat1,
    STATE(10848), 1,
      sym__layout_end,
    ACTIONS(9200), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388800] = 4,
    STATE(10153), 1,
      sym_class_declarations,
    ACTIONS(8222), 2,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
    ACTIONS(9202), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388821] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12667), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388850] = 7,
    ACTIONS(9204), 1,
      anon_sym_SEMI,
    ACTIONS(9206), 1,
      sym__cond_layout_semicolon,
    STATE(111), 1,
      aux_sym__let_binds_repeat1,
    STATE(5127), 1,
      sym__layout_end,
    STATE(9382), 1,
      aux_sym__statements_repeat1,
    ACTIONS(9208), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388877] = 8,
    ACTIONS(2223), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(7617), 1,
      sym__unboxed_close,
    STATE(9861), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10640), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388906] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12613), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388935] = 7,
    ACTIONS(9210), 1,
      anon_sym_SEMI,
    ACTIONS(9212), 1,
      sym__cond_layout_semicolon,
    STATE(1937), 1,
      aux_sym__let_binds_repeat1,
    STATE(5644), 1,
      sym__layout_end,
    STATE(9345), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(9214), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388962] = 4,
    STATE(10112), 1,
      sym_class_declarations,
    ACTIONS(8222), 2,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
    ACTIONS(9216), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388983] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12655), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389012] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12657), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389041] = 7,
    ACTIONS(7588), 1,
      aux_sym__paren_open_token1,
    ACTIONS(7720), 1,
      sym_variable,
    STATE(8758), 1,
      sym__paren_open,
    STATE(10696), 1,
      sym_signature,
    STATE(10941), 1,
      sym__var_binding_list,
    STATE(9761), 2,
      sym__varsym_prefix,
      sym__pvarsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389068] = 8,
    ACTIONS(2453), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(3212), 1,
      sym__unboxed_close,
    STATE(9857), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10466), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389097] = 4,
    STATE(10105), 1,
      sym_class_declarations,
    ACTIONS(8222), 2,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
    ACTIONS(9218), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389118] = 8,
    ACTIONS(2013), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(7445), 1,
      sym__unboxed_close,
    STATE(9807), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10587), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389147] = 8,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    ACTIONS(9220), 1,
      sym__cond_layout_end,
    STATE(9285), 1,
      aux_sym__exp_multi_way_if_repeat1,
    STATE(10462), 1,
      sym__guards,
    STATE(11229), 1,
      sym_match,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389176] = 8,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    ACTIONS(9222), 1,
      sym__cond_layout_end,
    STATE(9384), 1,
      aux_sym__exp_multi_way_if_repeat1,
    STATE(10462), 1,
      sym__guards,
    STATE(11229), 1,
      sym_match,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389205] = 8,
    ACTIONS(791), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6079), 1,
      sym__unboxed_close,
    STATE(9805), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10226), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389234] = 8,
    ACTIONS(2543), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6376), 1,
      sym__unboxed_close,
    STATE(9877), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10144), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389263] = 8,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    ACTIONS(9224), 1,
      sym__cond_layout_end,
    STATE(9384), 1,
      aux_sym__exp_multi_way_if_repeat1,
    STATE(10462), 1,
      sym__guards,
    STATE(11229), 1,
      sym_match,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389292] = 7,
    ACTIONS(9226), 1,
      anon_sym_SEMI,
    ACTIONS(9228), 1,
      sym__cond_layout_semicolon,
    STATE(1940), 1,
      aux_sym__let_binds_repeat1,
    STATE(5643), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(9230), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389319] = 8,
    ACTIONS(2271), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6507), 1,
      sym__unboxed_close,
    STATE(9831), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10659), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389348] = 5,
    ACTIONS(6475), 1,
      sym__phantom_where,
    ACTIONS(9234), 1,
      anon_sym_where,
    STATE(9308), 1,
      sym__where,
    ACTIONS(9232), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389371] = 7,
    ACTIONS(9236), 1,
      sym_variable,
    ACTIONS(9238), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(12149), 1,
      sym__do_keyword,
    ACTIONS(6736), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389398] = 8,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    ACTIONS(9240), 1,
      sym__cond_layout_end,
    STATE(9384), 1,
      aux_sym__exp_multi_way_if_repeat1,
    STATE(10462), 1,
      sym__guards,
    STATE(11229), 1,
      sym_match,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389427] = 7,
    ACTIONS(9242), 1,
      anon_sym_SEMI,
    ACTIONS(9244), 1,
      sym__cond_layout_semicolon,
    STATE(115), 1,
      aux_sym__let_binds_repeat1,
    STATE(4587), 1,
      sym__layout_end,
    STATE(9521), 1,
      aux_sym__statements_repeat1,
    ACTIONS(9246), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389454] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12553), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389483] = 7,
    ACTIONS(9248), 1,
      anon_sym_SEMI,
    ACTIONS(9250), 1,
      sym__cond_layout_semicolon,
    STATE(89), 1,
      aux_sym__let_binds_repeat1,
    STATE(2956), 1,
      sym__layout_end,
    STATE(9415), 1,
      aux_sym__statements_repeat1,
    ACTIONS(9252), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389510] = 4,
    STATE(1463), 1,
      sym__colon2,
    ACTIONS(9256), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(9254), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389531] = 7,
    ACTIONS(9258), 1,
      anon_sym_SEMI,
    ACTIONS(9260), 1,
      sym__cond_layout_semicolon,
    STATE(1929), 1,
      aux_sym__let_binds_repeat1,
    STATE(4470), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(9262), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389558] = 8,
    ACTIONS(2071), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(2319), 1,
      sym__unboxed_close,
    STATE(9764), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10604), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389587] = 7,
    ACTIONS(9264), 1,
      anon_sym_SEMI,
    ACTIONS(9266), 1,
      sym__cond_layout_semicolon,
    STATE(1369), 1,
      aux_sym__let_binds_repeat1,
    STATE(9394), 1,
      aux_sym_local_binds_repeat1,
    STATE(10702), 1,
      sym__layout_end,
    ACTIONS(9268), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389614] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4695), 7,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [389631] = 7,
    ACTIONS(9270), 1,
      anon_sym_SEMI,
    ACTIONS(9272), 1,
      sym__cond_layout_semicolon,
    STATE(104), 1,
      aux_sym__let_binds_repeat1,
    STATE(5293), 1,
      sym__layout_end,
    STATE(9158), 1,
      aux_sym__statements_repeat1,
    ACTIONS(9274), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389658] = 7,
    ACTIONS(9276), 1,
      anon_sym_SEMI,
    ACTIONS(9278), 1,
      sym__cond_layout_semicolon,
    STATE(108), 1,
      aux_sym__let_binds_repeat1,
    STATE(4768), 1,
      sym__layout_end,
    STATE(9305), 1,
      aux_sym__statements_repeat1,
    ACTIONS(9280), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389685] = 7,
    ACTIONS(9282), 1,
      anon_sym_SEMI,
    ACTIONS(9284), 1,
      sym__cond_layout_semicolon,
    STATE(80), 1,
      aux_sym__let_binds_repeat1,
    STATE(4178), 1,
      sym__layout_end,
    STATE(9524), 1,
      aux_sym__statements_repeat1,
    ACTIONS(9286), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389712] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12659), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389741] = 7,
    ACTIONS(8640), 1,
      sym_variable,
    ACTIONS(9288), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(12149), 1,
      sym__do_keyword,
    ACTIONS(6736), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389768] = 7,
    ACTIONS(9290), 1,
      anon_sym_SEMI,
    ACTIONS(9292), 1,
      sym__cond_layout_semicolon,
    STATE(106), 1,
      aux_sym__let_binds_repeat1,
    STATE(4957), 1,
      sym__layout_end,
    STATE(9218), 1,
      aux_sym__statements_repeat1,
    ACTIONS(9294), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389795] = 7,
    ACTIONS(9296), 1,
      anon_sym_SEMI,
    ACTIONS(9298), 1,
      sym__cond_layout_semicolon,
    STATE(1930), 1,
      aux_sym__let_binds_repeat1,
    STATE(4475), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(9300), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389822] = 7,
    ACTIONS(9302), 1,
      anon_sym_SEMI,
    ACTIONS(9304), 1,
      sym__cond_layout_semicolon,
    STATE(1846), 1,
      aux_sym__let_binds_repeat1,
    STATE(9549), 1,
      sym__layout_end,
    STATE(9564), 1,
      aux_sym__let_binds_repeat2,
    ACTIONS(9306), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389849] = 7,
    ACTIONS(9308), 1,
      anon_sym_SEMI,
    ACTIONS(9310), 1,
      sym__cond_layout_semicolon,
    STATE(82), 1,
      aux_sym__let_binds_repeat1,
    STATE(5358), 1,
      sym__layout_end,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    ACTIONS(9312), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389876] = 7,
    ACTIONS(9314), 1,
      anon_sym_SEMI,
    ACTIONS(9316), 1,
      sym__cond_layout_semicolon,
    STATE(2098), 1,
      aux_sym__let_binds_repeat1,
    STATE(4484), 1,
      sym__layout_end,
    STATE(9637), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(9318), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389903] = 7,
    ACTIONS(9320), 1,
      sym_variable,
    ACTIONS(9322), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(12149), 1,
      sym__do_keyword,
    ACTIONS(6736), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389930] = 8,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    ACTIONS(9324), 1,
      sym__cond_layout_end,
    STATE(9384), 1,
      aux_sym__exp_multi_way_if_repeat1,
    STATE(10462), 1,
      sym__guards,
    STATE(11229), 1,
      sym_match,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389959] = 4,
    ACTIONS(9326), 1,
      anon_sym_SEMI,
    STATE(9499), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5504), 5,
      sym__cond_infix,
      anon_sym_forall,
      anon_sym_u2200,
      sym_name,
      aux_sym__paren_open_token1,
  [389980] = 8,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    ACTIONS(9329), 1,
      sym__cond_layout_end,
    STATE(9384), 1,
      aux_sym__exp_multi_way_if_repeat1,
    STATE(10462), 1,
      sym__guards,
    STATE(11229), 1,
      sym_match,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390009] = 7,
    ACTIONS(9331), 1,
      anon_sym_SEMI,
    ACTIONS(9333), 1,
      sym__cond_layout_semicolon,
    STATE(113), 1,
      aux_sym__let_binds_repeat1,
    STATE(4490), 1,
      sym__layout_end,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    ACTIONS(9335), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390036] = 8,
    ACTIONS(2247), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(3773), 1,
      sym__unboxed_close,
    STATE(9841), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10556), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390065] = 7,
    ACTIONS(9337), 1,
      anon_sym_SEMI,
    ACTIONS(9339), 1,
      sym__cond_layout_semicolon,
    STATE(1942), 1,
      aux_sym__let_binds_repeat1,
    STATE(5621), 1,
      sym__layout_end,
    STATE(9378), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(9341), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390092] = 7,
    ACTIONS(9320), 1,
      sym_variable,
    ACTIONS(9343), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(12149), 1,
      sym__do_keyword,
    ACTIONS(6736), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390119] = 7,
    ACTIONS(9345), 1,
      anon_sym_SEMI,
    ACTIONS(9347), 1,
      sym__cond_layout_semicolon,
    STATE(8710), 1,
      aux_sym__let_binds_repeat1,
    STATE(9692), 1,
      sym__layout_end,
    STATE(9694), 1,
      aux_sym_gadt_constructors_repeat1,
    ACTIONS(9349), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390146] = 6,
    ACTIONS(9351), 1,
      sym__cond_assoc_tyinst,
    STATE(8285), 1,
      sym__forall_keyword,
    STATE(10017), 1,
      sym__forall_body,
    ACTIONS(1377), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(12426), 2,
      sym_forall,
      sym_forall_required,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390171] = 5,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(4626), 3,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390194] = 8,
    ACTIONS(2387), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(3912), 1,
      sym__unboxed_close,
    STATE(9706), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10729), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390223] = 8,
    ACTIONS(2231), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(3087), 1,
      sym__unboxed_close,
    STATE(9829), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10392), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390252] = 4,
    STATE(10471), 1,
      sym_local_binds,
    ACTIONS(9355), 2,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
    ACTIONS(9353), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390273] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12669), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390302] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12571), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390331] = 7,
    ACTIONS(9357), 1,
      anon_sym_SEMI,
    ACTIONS(9359), 1,
      sym__cond_layout_semicolon,
    STATE(2059), 1,
      aux_sym__let_binds_repeat1,
    STATE(4556), 1,
      sym__layout_end,
    STATE(9532), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(9361), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390358] = 7,
    ACTIONS(9363), 1,
      anon_sym_SEMI,
    ACTIONS(9365), 1,
      sym__cond_layout_semicolon,
    STATE(1892), 1,
      aux_sym__let_binds_repeat1,
    STATE(4555), 1,
      sym__layout_end,
    STATE(9525), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(9367), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390385] = 7,
    ACTIONS(9369), 1,
      anon_sym_SEMI,
    ACTIONS(9371), 1,
      sym__cond_layout_semicolon,
    STATE(2070), 1,
      aux_sym__let_binds_repeat1,
    STATE(5557), 1,
      sym__layout_end,
    STATE(9528), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(9373), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390412] = 8,
    ACTIONS(2331), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(4404), 1,
      sym__unboxed_close,
    STATE(9760), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10627), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390441] = 7,
    ACTIONS(9375), 1,
      anon_sym_SEMI,
    ACTIONS(9377), 1,
      sym__cond_layout_semicolon,
    STATE(1949), 1,
      aux_sym__let_binds_repeat1,
    STATE(5556), 1,
      sym__layout_end,
    STATE(9474), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(9379), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390468] = 7,
    ACTIONS(9381), 1,
      anon_sym_SEMI,
    ACTIONS(9383), 1,
      sym__cond_layout_semicolon,
    STATE(90), 1,
      aux_sym__let_binds_repeat1,
    STATE(4554), 1,
      sym__layout_end,
    STATE(9501), 1,
      aux_sym__statements_repeat1,
    ACTIONS(9385), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390495] = 7,
    ACTIONS(9387), 1,
      anon_sym_SEMI,
    ACTIONS(9389), 1,
      sym__cond_layout_semicolon,
    STATE(92), 1,
      aux_sym__let_binds_repeat1,
    STATE(4217), 1,
      sym__layout_end,
    STATE(9429), 1,
      aux_sym__statements_repeat1,
    ACTIONS(9391), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390522] = 7,
    ACTIONS(9393), 1,
      anon_sym_SEMI,
    ACTIONS(9395), 1,
      sym__cond_layout_semicolon,
    STATE(1845), 1,
      aux_sym__let_binds_repeat1,
    STATE(9163), 1,
      aux_sym__let_binds_repeat2,
    STATE(9581), 1,
      sym__layout_end,
    ACTIONS(9397), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390549] = 7,
    ACTIONS(9399), 1,
      anon_sym_SEMI,
    ACTIONS(9401), 1,
      sym__cond_layout_semicolon,
    STATE(103), 1,
      aux_sym__let_binds_repeat1,
    STATE(4545), 1,
      sym__layout_end,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    ACTIONS(9403), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390576] = 7,
    ACTIONS(9405), 1,
      anon_sym_SEMI,
    ACTIONS(9407), 1,
      sym__cond_layout_semicolon,
    STATE(1891), 1,
      aux_sym__let_binds_repeat1,
    STATE(4493), 1,
      sym__layout_end,
    STATE(9483), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(9409), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390603] = 7,
    ACTIONS(9411), 1,
      anon_sym_SEMI,
    ACTIONS(9413), 1,
      sym__cond_layout_semicolon,
    STATE(8), 1,
      aux_sym__let_binds_repeat1,
    STATE(9565), 1,
      aux_sym_quoted_decls_repeat1,
    STATE(11692), 1,
      sym__layout_end,
    ACTIONS(9415), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390630] = 7,
    ACTIONS(9417), 1,
      anon_sym_SEMI,
    ACTIONS(9419), 1,
      sym__cond_layout_semicolon,
    STATE(96), 1,
      aux_sym__let_binds_repeat1,
    STATE(4220), 1,
      sym__layout_end,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    ACTIONS(9421), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390657] = 7,
    ACTIONS(9423), 1,
      anon_sym_SEMI,
    ACTIONS(9425), 1,
      sym__cond_layout_semicolon,
    STATE(1939), 1,
      aux_sym__let_binds_repeat1,
    STATE(4494), 1,
      sym__layout_end,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(9427), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390684] = 8,
    ACTIONS(2565), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(7173), 1,
      sym__unboxed_close,
    STATE(9785), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10419), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390713] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12576), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390742] = 7,
    ACTIONS(9429), 1,
      anon_sym_SEMI,
    ACTIONS(9431), 1,
      sym__cond_layout_semicolon,
    STATE(2073), 1,
      aux_sym__let_binds_repeat1,
    STATE(5616), 1,
      sym__layout_end,
    STATE(9637), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(9433), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390769] = 8,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(8166), 1,
      sym_variable,
    STATE(9886), 1,
      sym__qualified_variable,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10275), 1,
      aux_sym__qualifying_module,
    STATE(12243), 1,
      sym__qvarid,
    STATE(12603), 1,
      sym_quoter,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390798] = 7,
    ACTIONS(9435), 1,
      anon_sym_SEMI,
    ACTIONS(9437), 1,
      sym__cond_layout_semicolon,
    STATE(1941), 1,
      aux_sym__let_binds_repeat1,
    STATE(4497), 1,
      sym__layout_end,
    STATE(9493), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(9439), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390825] = 8,
    ACTIONS(4672), 1,
      sym__phantom_bar,
    ACTIONS(7442), 1,
      anon_sym_PIPE,
    ACTIONS(9441), 1,
      sym__cond_layout_end,
    STATE(9470), 1,
      aux_sym__exp_multi_way_if_repeat1,
    STATE(10462), 1,
      sym__guards,
    STATE(11229), 1,
      sym_match,
    STATE(12282), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390854] = 7,
    ACTIONS(9443), 1,
      anon_sym_SEMI,
    ACTIONS(9445), 1,
      sym__cond_layout_semicolon,
    STATE(2054), 1,
      aux_sym__let_binds_repeat1,
    STATE(4498), 1,
      sym__layout_end,
    STATE(9637), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(9447), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390881] = 7,
    ACTIONS(9449), 1,
      anon_sym_SEMI,
    ACTIONS(9451), 1,
      sym__cond_layout_semicolon,
    STATE(1171), 1,
      aux_sym__let_binds_repeat1,
    STATE(9370), 1,
      aux_sym_instance_declarations_repeat1,
    STATE(10745), 1,
      sym__layout_end,
    ACTIONS(9453), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390908] = 8,
    ACTIONS(2431), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(4933), 1,
      sym__unboxed_close,
    STATE(9808), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10585), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390937] = 8,
    ACTIONS(2511), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(4357), 1,
      sym__unboxed_close,
    STATE(9893), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10740), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390966] = 8,
    ACTIONS(2339), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(7330), 1,
      sym__unboxed_close,
    STATE(9767), 1,
      aux_sym__type_unboxed_sum_repeat1,
    STATE(10158), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390995] = 7,
    ACTIONS(9455), 1,
      anon_sym_SEMI,
    ACTIONS(9457), 1,
      sym__cond_layout_semicolon,
    STATE(1905), 1,
      aux_sym__let_binds_repeat1,
    STATE(2914), 1,
      sym__layout_end,
    STATE(9213), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(9459), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391022] = 7,
    ACTIONS(9461), 1,
      anon_sym_SEMI,
    ACTIONS(9463), 1,
      sym__cond_layout_semicolon,
    STATE(2056), 1,
      aux_sym__let_binds_repeat1,
    STATE(4502), 1,
      sym__layout_end,
    STATE(9496), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(9465), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391049] = 7,
    ACTIONS(9467), 1,
      anon_sym_SEMI,
    ACTIONS(9469), 1,
      sym__cond_layout_semicolon,
    STATE(2072), 1,
      aux_sym__let_binds_repeat1,
    STATE(5516), 1,
      sym__layout_end,
    STATE(9401), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(9471), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391076] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7021), 7,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [391093] = 6,
    ACTIONS(1275), 1,
      aux_sym__paren_close_token1,
    ACTIONS(9473), 1,
      anon_sym_COMMA,
    STATE(384), 1,
      sym__arrow,
    STATE(4338), 1,
      sym__paren_close,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391117] = 5,
    ACTIONS(2737), 1,
      sym__consym,
    ACTIONS(2839), 1,
      anon_sym_BQUOTE,
    ACTIONS(9475), 1,
      sym__cond_qualified_op,
    STATE(2286), 3,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_constructor_operator,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391139] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9477), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_in,
      anon_sym_SEMI,
      anon_sym_in,
  [391155] = 5,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    STATE(9601), 1,
      aux_sym_field_path_repeat1,
    STATE(12152), 1,
      sym__tight_dot,
    ACTIONS(9479), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391177] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9481), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [391193] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9483), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [391209] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9485), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [391225] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5203), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [391241] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9487), 6,
      sym__phantom_in,
      sym__phantom_arrow,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [391257] = 5,
    ACTIONS(2737), 1,
      sym__consym,
    ACTIONS(2839), 1,
      anon_sym_BQUOTE,
    ACTIONS(7053), 1,
      sym__cond_qualified_op,
    STATE(2291), 3,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_constructor_operator,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391279] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9489), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_in,
      anon_sym_SEMI,
      anon_sym_in,
  [391295] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9491), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [391311] = 5,
    ACTIONS(2737), 1,
      sym__consym,
    ACTIONS(2839), 1,
      anon_sym_BQUOTE,
    ACTIONS(7068), 1,
      sym__cond_qualified_op,
    STATE(2270), 3,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_constructor_operator,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391333] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9493), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_in,
      anon_sym_SEMI,
      anon_sym_in,
  [391349] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9495), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [391365] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9497), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [391381] = 6,
    ACTIONS(9499), 1,
      anon_sym_SEMI,
    ACTIONS(9502), 1,
      sym__cond_layout_semicolon,
    STATE(184), 1,
      aux_sym__let_binds_repeat1,
    STATE(9557), 1,
      aux_sym__statements_repeat1,
    ACTIONS(9505), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391405] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9507), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [391421] = 7,
    ACTIONS(2511), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    ACTIONS(7692), 1,
      anon_sym_PIPE,
    ACTIONS(7694), 1,
      anon_sym_PIPE2,
    STATE(5250), 1,
      sym__unboxed_close,
    STATE(10797), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391447] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7963), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [391463] = 4,
    ACTIONS(9511), 1,
      anon_sym_COMMA,
    STATE(9607), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(9509), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391483] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9487), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_in,
      anon_sym_SEMI,
      anon_sym_in,
  [391499] = 7,
    ACTIONS(2347), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    ACTIONS(7670), 1,
      anon_sym_PIPE,
    ACTIONS(7672), 1,
      anon_sym_PIPE2,
    STATE(4857), 1,
      sym__unboxed_close,
    STATE(10697), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391525] = 6,
    ACTIONS(9513), 1,
      anon_sym_SEMI,
    ACTIONS(9516), 1,
      sym__cond_layout_semicolon,
    STATE(1882), 1,
      aux_sym__let_binds_repeat1,
    STATE(9564), 1,
      aux_sym__let_binds_repeat2,
    ACTIONS(9519), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391549] = 6,
    ACTIONS(9521), 1,
      anon_sym_SEMI,
    ACTIONS(9524), 1,
      sym__cond_layout_semicolon,
    STATE(22), 1,
      aux_sym__let_binds_repeat1,
    STATE(9565), 1,
      aux_sym_quoted_decls_repeat1,
    ACTIONS(9527), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391573] = 7,
    ACTIONS(839), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9529), 1,
      anon_sym_COMMA,
    ACTIONS(9531), 1,
      anon_sym_PIPE,
    ACTIONS(9533), 1,
      anon_sym_PIPE2,
    STATE(6755), 1,
      sym__unboxed_close,
    STATE(10698), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391599] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7905), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [391615] = 7,
    ACTIONS(2331), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    ACTIONS(7761), 1,
      anon_sym_PIPE,
    ACTIONS(7763), 1,
      anon_sym_PIPE2,
    STATE(5455), 1,
      sym__unboxed_close,
    STATE(10164), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391641] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9493), 6,
      sym__phantom_in,
      sym__phantom_arrow,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [391657] = 7,
    ACTIONS(2107), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    ACTIONS(9535), 1,
      anon_sym_PIPE,
    ACTIONS(9537), 1,
      anon_sym_PIPE2,
    STATE(4612), 1,
      sym__unboxed_close,
    STATE(10598), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391683] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9487), 6,
      sym__phantom_in,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_RBRACK,
  [391699] = 6,
    ACTIONS(1269), 1,
      aux_sym__paren_close_token1,
    ACTIONS(9473), 1,
      anon_sym_COMMA,
    STATE(384), 1,
      sym__arrow,
    STATE(4350), 1,
      sym__paren_close,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391723] = 5,
    ACTIONS(2835), 1,
      sym__integer_literal,
    ACTIONS(9539), 1,
      sym_float,
    STATE(5755), 1,
      sym_integer,
    ACTIONS(2837), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391745] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9541), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [391761] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9543), 6,
      sym__phantom_in,
      sym__phantom_arrow,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [391777] = 7,
    ACTIONS(2197), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    ACTIONS(7716), 1,
      anon_sym_PIPE,
    ACTIONS(7718), 1,
      anon_sym_PIPE2,
    STATE(5291), 1,
      sym__unboxed_close,
    STATE(10400), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391803] = 7,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(9545), 1,
      anon_sym_where,
    ACTIONS(9547), 1,
      sym__phantom_where,
    STATE(7739), 1,
      sym__paren_open,
    STATE(11099), 1,
      sym_exports,
    STATE(11101), 1,
      sym__where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391829] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9549), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [391845] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9551), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_in,
      anon_sym_SEMI,
      anon_sym_in,
  [391861] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9493), 6,
      sym__phantom_in,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_RBRACK,
  [391877] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9489), 6,
      sym__phantom_in,
      sym__phantom_arrow,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [391893] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9553), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [391909] = 6,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(9555), 1,
      anon_sym_hiding,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11682), 1,
      sym_import_list,
    ACTIONS(7789), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391933] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9557), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [391949] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9559), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_in,
      anon_sym_SEMI,
      anon_sym_in,
  [391965] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9543), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_in,
      anon_sym_SEMI,
      anon_sym_in,
  [391981] = 4,
    ACTIONS(9511), 1,
      anon_sym_COMMA,
    STATE(9605), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(9561), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392001] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5203), 6,
      sym__cond_dotdot,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_u2192,
      anon_sym_RBRACK,
  [392017] = 4,
    ACTIONS(9511), 1,
      anon_sym_COMMA,
    STATE(9561), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(9563), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392037] = 6,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(9565), 1,
      anon_sym_hiding,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11523), 1,
      sym_import_list,
    ACTIONS(7785), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392061] = 6,
    ACTIONS(1257), 1,
      aux_sym__paren_close_token1,
    ACTIONS(9473), 1,
      anon_sym_COMMA,
    STATE(384), 1,
      sym__arrow,
    STATE(4661), 1,
      sym__paren_close,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392085] = 6,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(9567), 1,
      anon_sym_hiding,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11386), 1,
      sym_import_list,
    ACTIONS(7793), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392109] = 7,
    ACTIONS(2211), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    ACTIONS(7708), 1,
      anon_sym_PIPE,
    ACTIONS(7710), 1,
      anon_sym_PIPE2,
    STATE(5001), 1,
      sym__unboxed_close,
    STATE(10436), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392135] = 6,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(9569), 1,
      anon_sym_hiding,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11507), 1,
      sym_import_list,
    ACTIONS(7781), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392159] = 4,
    ACTIONS(9573), 1,
      anon_sym_in,
    ACTIONS(9575), 1,
      sym__phantom_in,
    ACTIONS(9571), 4,
      sym__phantom_arrow,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392179] = 6,
    ACTIONS(9577), 1,
      anon_sym_SEMI,
    ACTIONS(9580), 1,
      sym__cond_layout_semicolon,
    STATE(1800), 1,
      aux_sym__let_binds_repeat1,
    STATE(9596), 1,
      aux_sym_local_binds_repeat1,
    ACTIONS(9583), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392203] = 6,
    ACTIONS(9585), 1,
      anon_sym_SEMI,
    ACTIONS(9587), 1,
      sym__cond_layout_semicolon,
    STATE(5), 1,
      aux_sym__let_binds_repeat1,
    STATE(9659), 1,
      aux_sym_declarations_repeat1,
    ACTIONS(9589), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392227] = 5,
    ACTIONS(2737), 1,
      sym__consym,
    ACTIONS(2839), 1,
      anon_sym_BQUOTE,
    ACTIONS(9591), 1,
      sym__cond_qualified_op,
    STATE(2254), 3,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_constructor_operator,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392249] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9489), 6,
      sym__phantom_in,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_RBRACK,
  [392265] = 6,
    ACTIONS(1277), 1,
      aux_sym__paren_close_token1,
    ACTIONS(9473), 1,
      anon_sym_COMMA,
    STATE(384), 1,
      sym__arrow,
    STATE(4288), 1,
      sym__paren_close,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392289] = 5,
    ACTIONS(9595), 1,
      sym__cond_tight_dot,
    STATE(9601), 1,
      aux_sym_field_path_repeat1,
    STATE(12152), 1,
      sym__tight_dot,
    ACTIONS(9593), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392311] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9598), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_in,
      anon_sym_SEMI,
      anon_sym_in,
  [392327] = 7,
    ACTIONS(899), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9529), 1,
      anon_sym_COMMA,
    ACTIONS(9600), 1,
      anon_sym_PIPE,
    ACTIONS(9602), 1,
      anon_sym_PIPE2,
    STATE(5705), 1,
      sym__unboxed_close,
    STATE(10132), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392353] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7504), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [392369] = 4,
    ACTIONS(9511), 1,
      anon_sym_COMMA,
    STATE(9607), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(9604), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392389] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9606), 6,
      sym__phantom_in,
      sym__phantom_arrow,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [392405] = 4,
    ACTIONS(9610), 1,
      anon_sym_COMMA,
    STATE(9607), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(9608), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392425] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9613), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [392441] = 5,
    ACTIONS(1941), 1,
      sym__integer_literal,
    ACTIONS(9615), 1,
      sym_float,
    STATE(6618), 1,
      sym_integer,
    ACTIONS(1943), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392463] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9617), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [392479] = 6,
    ACTIONS(4568), 1,
      anon_sym_DASH_GT,
    ACTIONS(4570), 1,
      anon_sym_u2192,
    STATE(7922), 1,
      sym__linear_arrow,
    STATE(7936), 1,
      sym__arrow,
    ACTIONS(9619), 2,
      anon_sym_DASH_GT_DOT,
      anon_sym_u22b8,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392503] = 6,
    ACTIONS(9621), 1,
      anon_sym_SEMI,
    ACTIONS(9624), 1,
      sym__cond_layout_semicolon,
    STATE(2038), 1,
      aux_sym__let_binds_repeat1,
    STATE(9612), 1,
      aux_sym__nalts_repeat1,
    ACTIONS(9627), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392527] = 6,
    ACTIONS(9629), 1,
      anon_sym_SEMI,
    ACTIONS(9632), 1,
      sym__cond_layout_semicolon,
    STATE(1617), 1,
      aux_sym__let_binds_repeat1,
    STATE(9613), 1,
      aux_sym_instance_declarations_repeat1,
    ACTIONS(9635), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392551] = 4,
    ACTIONS(9637), 1,
      anon_sym_SEMI,
    STATE(9614), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(5504), 4,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392571] = 6,
    ACTIONS(9640), 1,
      anon_sym_qualified,
    ACTIONS(9642), 1,
      sym_string,
    ACTIONS(9644), 1,
      sym_name,
    STATE(9061), 1,
      sym_module,
    STATE(10924), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392595] = 5,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    ACTIONS(9646), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392617] = 6,
    ACTIONS(9648), 1,
      anon_sym_SEMI,
    ACTIONS(9651), 1,
      sym__cond_layout_semicolon,
    STATE(920), 1,
      aux_sym__let_binds_repeat1,
    STATE(9617), 1,
      aux_sym_class_declarations_repeat1,
    ACTIONS(9654), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392641] = 3,
    ACTIONS(3243), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3245), 4,
      sym__cond_prefix_at,
      anon_sym_LBRACK,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392659] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9656), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [392675] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9477), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_in,
      anon_sym_SEMI,
      anon_sym_in,
  [392691] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9477), 6,
      sym__phantom_in,
      sym__phantom_arrow,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [392707] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9658), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [392723] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9660), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [392739] = 4,
    ACTIONS(9662), 1,
      sym_variable,
    STATE(9656), 1,
      aux_sym_type_family_injectivity_repeat1,
    ACTIONS(7827), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392759] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9543), 6,
      sym__phantom_in,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_RBRACK,
  [392775] = 7,
    ACTIONS(791), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9529), 1,
      anon_sym_COMMA,
    ACTIONS(9664), 1,
      anon_sym_PIPE,
    ACTIONS(9666), 1,
      anon_sym_PIPE2,
    STATE(6609), 1,
      sym__unboxed_close,
    STATE(10801), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392801] = 5,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    ACTIONS(9668), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392823] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7941), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [392839] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9606), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_in,
      anon_sym_SEMI,
      anon_sym_in,
  [392855] = 6,
    ACTIONS(9670), 1,
      anon_sym_qualified,
    ACTIONS(9672), 1,
      sym_string,
    ACTIONS(9674), 1,
      sym_name,
    STATE(8827), 1,
      sym_module,
    STATE(11122), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392879] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7939), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [392895] = 6,
    ACTIONS(1295), 1,
      aux_sym__paren_close_token1,
    ACTIONS(9473), 1,
      anon_sym_COMMA,
    STATE(384), 1,
      sym__arrow,
    STATE(3932), 1,
      sym__paren_close,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392919] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9676), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [392935] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(8086), 6,
      sym__cond_layout_semicolon,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
  [392951] = 7,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(9678), 1,
      sym_name,
    STATE(9769), 1,
      aux_sym__qualifying_module,
    STATE(9892), 1,
      sym__modid_prefix,
    STATE(11710), 1,
      sym__qualified_consym,
    STATE(11978), 1,
      sym_constructor_operator,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392977] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9606), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_in,
      anon_sym_SEMI,
      anon_sym_in,
  [392993] = 6,
    ACTIONS(9680), 1,
      anon_sym_SEMI,
    ACTIONS(9683), 1,
      sym__cond_layout_semicolon,
    STATE(2182), 1,
      aux_sym__let_binds_repeat1,
    STATE(9637), 1,
      aux_sym_alternatives_repeat1,
    ACTIONS(9686), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393017] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9606), 6,
      sym__phantom_in,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_RBRACK,
  [393033] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9606), 6,
      sym__phantom_in,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_RBRACK,
  [393049] = 4,
    ACTIONS(9688), 1,
      anon_sym_in,
    ACTIONS(9690), 1,
      sym__phantom_in,
    ACTIONS(9571), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393069] = 3,
    ACTIONS(6358), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(6360), 4,
      sym__cond_prefix_at,
      anon_sym_LBRACK,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393087] = 6,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(9692), 1,
      anon_sym_hiding,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11560), 1,
      sym_import_list,
    ACTIONS(8056), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393111] = 7,
    ACTIONS(2081), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    ACTIONS(7684), 1,
      anon_sym_PIPE,
    ACTIONS(7686), 1,
      anon_sym_PIPE2,
    STATE(2938), 1,
      sym__unboxed_close,
    STATE(10131), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393137] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9551), 6,
      sym__phantom_in,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_RBRACK,
  [393153] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9694), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [393169] = 7,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(9678), 1,
      sym_name,
    STATE(9769), 1,
      aux_sym__qualifying_module,
    STATE(9892), 1,
      sym__modid_prefix,
    STATE(11392), 1,
      sym__qualified_consym,
    STATE(11687), 1,
      sym_constructor_operator,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393195] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9696), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [393211] = 6,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(9698), 1,
      anon_sym_hiding,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11557), 1,
      sym_import_list,
    ACTIONS(8104), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393235] = 6,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(9700), 1,
      anon_sym_hiding,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11555), 1,
      sym_import_list,
    ACTIONS(8108), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393259] = 5,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    STATE(9544), 1,
      aux_sym_field_path_repeat1,
    STATE(12152), 1,
      sym__tight_dot,
    ACTIONS(9702), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393281] = 5,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    ACTIONS(7438), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393303] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9704), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [393319] = 7,
    ACTIONS(2023), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    ACTIONS(7730), 1,
      anon_sym_PIPE,
    ACTIONS(7732), 1,
      anon_sym_PIPE2,
    STATE(4358), 1,
      sym__unboxed_close,
    STATE(10867), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393345] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9704), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [393361] = 5,
    ACTIONS(2737), 1,
      sym__consym,
    ACTIONS(2839), 1,
      anon_sym_BQUOTE,
    ACTIONS(9706), 1,
      sym__cond_qualified_op,
    STATE(2267), 3,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_constructor_operator,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393383] = 4,
    ACTIONS(9708), 1,
      sym_variable,
    STATE(9656), 1,
      aux_sym_type_family_injectivity_repeat1,
    ACTIONS(7658), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393403] = 7,
    ACTIONS(2247), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    ACTIONS(9711), 1,
      anon_sym_PIPE,
    ACTIONS(9713), 1,
      anon_sym_PIPE2,
    STATE(4156), 1,
      sym__unboxed_close,
    STATE(10033), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393429] = 4,
    STATE(8782), 1,
      aux_sym_role_annotation_repeat1,
    STATE(9099), 1,
      sym_type_role,
    ACTIONS(7546), 4,
      anon_sym__,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393449] = 6,
    ACTIONS(9715), 1,
      anon_sym_SEMI,
    ACTIONS(9717), 1,
      sym__cond_layout_semicolon,
    STATE(7), 1,
      aux_sym__let_binds_repeat1,
    STATE(9683), 1,
      aux_sym_declarations_repeat1,
    ACTIONS(99), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393473] = 3,
    ACTIONS(9719), 1,
      anon_sym_1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(3269), 5,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [393491] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9721), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [393507] = 6,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    ACTIONS(9723), 1,
      anon_sym_hiding,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11456), 1,
      sym_import_list,
    ACTIONS(7835), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393531] = 5,
    ACTIONS(2737), 1,
      sym__consym,
    ACTIONS(2839), 1,
      anon_sym_BQUOTE,
    ACTIONS(9725), 1,
      sym__cond_qualified_op,
    STATE(2259), 3,
      sym__constructor_ticked,
      sym__qconstructor_ticked,
      sym_constructor_operator,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393553] = 5,
    ACTIONS(9727), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(7061), 3,
      anon_sym_mdo,
      anon_sym_do,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393575] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9730), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [393591] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9551), 6,
      sym__phantom_in,
      sym__phantom_arrow,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [393607] = 5,
    ACTIONS(3515), 1,
      sym__integer_literal,
    ACTIONS(9732), 1,
      sym_float,
    STATE(7375), 1,
      sym_integer,
    ACTIONS(3517), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393629] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9734), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [393645] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9734), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [393661] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9598), 6,
      sym__phantom_in,
      sym__phantom_arrow,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [393677] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9598), 6,
      sym__phantom_in,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_RBRACK,
  [393693] = 6,
    ACTIONS(9736), 1,
      anon_sym_SEMI,
    ACTIONS(9739), 1,
      sym__cond_layout_semicolon,
    STATE(7588), 1,
      aux_sym__let_binds_repeat1,
    STATE(9672), 1,
      aux_sym__tyfam_equations_repeat1,
    ACTIONS(9742), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393717] = 7,
    ACTIONS(877), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9529), 1,
      anon_sym_COMMA,
    ACTIONS(9744), 1,
      anon_sym_PIPE,
    ACTIONS(9746), 1,
      anon_sym_PIPE2,
    STATE(7070), 1,
      sym__unboxed_close,
    STATE(10861), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393743] = 5,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    ACTIONS(7476), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393765] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9477), 6,
      sym__phantom_in,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_RBRACK,
  [393781] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9477), 6,
      sym__phantom_in,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_RBRACK,
  [393797] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9477), 6,
      sym__phantom_in,
      sym__phantom_arrow,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [393813] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7937), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [393829] = 6,
    ACTIONS(1279), 1,
      aux_sym__paren_close_token1,
    ACTIONS(9473), 1,
      anon_sym_COMMA,
    STATE(384), 1,
      sym__arrow,
    STATE(2703), 1,
      sym__paren_close,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393853] = 6,
    ACTIONS(7336), 1,
      aux_sym__paren_open_token1,
    ACTIONS(9748), 1,
      sym_name,
    STATE(9062), 1,
      sym_newtype_constructor,
    STATE(12200), 1,
      sym__paren_open,
    STATE(2330), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393877] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9559), 6,
      sym__phantom_in,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_RBRACK,
  [393893] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9750), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_where,
      anon_sym_SEMI,
      anon_sym_where,
  [393909] = 6,
    ACTIONS(9752), 1,
      anon_sym_SEMI,
    ACTIONS(9755), 1,
      sym__cond_layout_semicolon,
    STATE(12), 1,
      aux_sym__let_binds_repeat1,
    STATE(9683), 1,
      aux_sym_declarations_repeat1,
    ACTIONS(9758), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393933] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9760), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [393949] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9762), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [393965] = 5,
    ACTIONS(3483), 1,
      sym__integer_literal,
    ACTIONS(9764), 1,
      sym_float,
    STATE(7065), 1,
      sym_integer,
    ACTIONS(3485), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393987] = 6,
    ACTIONS(1249), 1,
      aux_sym__paren_close_token1,
    ACTIONS(9473), 1,
      anon_sym_COMMA,
    STATE(384), 1,
      sym__arrow,
    STATE(4184), 1,
      sym__paren_close,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394011] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9766), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [394027] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9768), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [394043] = 6,
    ACTIONS(9770), 1,
      anon_sym_SEMI,
    ACTIONS(9773), 1,
      sym__cond_layout_semicolon,
    STATE(2137), 1,
      aux_sym__let_binds_repeat1,
    STATE(9690), 1,
      aux_sym__patsyn_cons_repeat1,
    ACTIONS(9776), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394067] = 6,
    ACTIONS(5792), 1,
      anon_sym_PIPE,
    ACTIONS(5802), 1,
      aux_sym__paren_close_token1,
    ACTIONS(5804), 1,
      anon_sym_POUND2,
    ACTIONS(5806), 1,
      anon_sym_PIPE2,
    ACTIONS(5790), 2,
      anon_sym_COMMA,
      anon_sym_POUND_RPAREN,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394091] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9778), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [394107] = 7,
    ACTIONS(2287), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    ACTIONS(9780), 1,
      anon_sym_PIPE,
    ACTIONS(9782), 1,
      anon_sym_PIPE2,
    STATE(5625), 1,
      sym__unboxed_close,
    STATE(10207), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394133] = 6,
    ACTIONS(9784), 1,
      anon_sym_SEMI,
    ACTIONS(9787), 1,
      sym__cond_layout_semicolon,
    STATE(8897), 1,
      aux_sym__let_binds_repeat1,
    STATE(9694), 1,
      aux_sym_gadt_constructors_repeat1,
    ACTIONS(9790), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394157] = 4,
    ACTIONS(5802), 2,
      sym__cond_prefix_at,
      aux_sym__paren_open_token1,
    ACTIONS(6264), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(9792), 2,
      anon_sym_POUND2,
      anon_sym_PIPE2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394177] = 5,
    ACTIONS(2469), 1,
      sym__integer_literal,
    ACTIONS(9794), 1,
      sym_float,
    STATE(6748), 1,
      sym_integer,
    ACTIONS(2471), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394199] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9796), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [394215] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9606), 6,
      sym__phantom_in,
      sym__phantom_arrow,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [394231] = 7,
    ACTIONS(649), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9529), 1,
      anon_sym_COMMA,
    ACTIONS(9798), 1,
      anon_sym_PIPE,
    ACTIONS(9800), 1,
      anon_sym_PIPE2,
    STATE(7335), 1,
      sym__unboxed_close,
    STATE(10438), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394257] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9802), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [394273] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9559), 6,
      sym__phantom_in,
      sym__phantom_arrow,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [394289] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7931), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [394305] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9804), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [394321] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9806), 6,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      sym__phantom_deriving,
      anon_sym_SEMI,
      anon_sym_deriving,
  [394337] = 7,
    ACTIONS(9808), 1,
      sym_variable,
    ACTIONS(9810), 1,
      sym_name,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10891), 1,
      sym__qualified_constructor,
    STATE(11036), 1,
      aux_sym__qualifying_module,
    STATE(12517), 1,
      sym__qconid,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394363] = 6,
    ACTIONS(2387), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(3840), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394386] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(1279), 1,
      aux_sym__paren_close_token1,
    STATE(2861), 1,
      sym__paren_close,
    STATE(9889), 1,
      aux_sym__exp_projection_selector_repeat1,
    STATE(12469), 1,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394409] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(1257), 1,
      aux_sym__paren_close_token1,
    STATE(5270), 1,
      sym__paren_close,
    STATE(9711), 1,
      aux_sym__exp_projection_selector_repeat1,
    STATE(12469), 1,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394432] = 4,
    STATE(1574), 1,
      sym__colon2,
    ACTIONS(8264), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(9812), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394451] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(1269), 1,
      aux_sym__paren_close_token1,
    STATE(5328), 1,
      sym__paren_close,
    STATE(10278), 1,
      aux_sym__exp_projection_selector_repeat1,
    STATE(12469), 1,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394474] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(1257), 1,
      aux_sym__paren_close_token1,
    STATE(5238), 1,
      sym__paren_close,
    STATE(10278), 1,
      aux_sym__exp_projection_selector_repeat1,
    STATE(12469), 1,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394497] = 3,
    STATE(1574), 1,
      sym__colon2,
    ACTIONS(9814), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394514] = 6,
    ACTIONS(2263), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(7490), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394537] = 6,
    ACTIONS(2197), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(5235), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394560] = 6,
    ACTIONS(2379), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(7003), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394583] = 6,
    ACTIONS(2197), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(5232), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394606] = 5,
    ACTIONS(3411), 1,
      aux_sym__paren_close_token1,
    STATE(1517), 1,
      sym__colon2,
    STATE(8048), 1,
      sym__paren_close,
    ACTIONS(9820), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394627] = 6,
    ACTIONS(2013), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(7348), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394650] = 6,
    ACTIONS(791), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(6179), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394673] = 6,
    ACTIONS(2363), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(6717), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394696] = 4,
    ACTIONS(9822), 1,
      anon_sym_COMMA,
    STATE(9870), 1,
      aux_sym_guards_repeat1,
    ACTIONS(9824), 3,
      sym__phantom_arrow,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394715] = 6,
    ACTIONS(2197), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9826), 1,
      anon_sym_PIPE,
    ACTIONS(9828), 1,
      anon_sym_PIPE2,
    STATE(5264), 1,
      sym__unboxed_close,
    STATE(9714), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394738] = 6,
    ACTIONS(7550), 1,
      sym_variable,
    ACTIONS(9830), 1,
      anon_sym_COMMA,
    ACTIONS(9832), 1,
      anon_sym_RBRACE,
    STATE(9990), 1,
      sym_field_name,
    STATE(11074), 1,
      sym_field,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394761] = 6,
    ACTIONS(6324), 1,
      sym_name,
    STATE(1406), 1,
      sym__qualified_consym,
    STATE(1410), 1,
      sym__qualified_varsym,
    STATE(8501), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394784] = 6,
    ACTIONS(2287), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(4864), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394807] = 6,
    ACTIONS(2081), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(2725), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394830] = 6,
    ACTIONS(899), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9834), 1,
      anon_sym_PIPE,
    ACTIONS(9836), 1,
      anon_sym_PIPE2,
    STATE(5711), 1,
      sym__unboxed_close,
    STATE(9932), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394853] = 6,
    ACTIONS(2511), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(5337), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394876] = 6,
    ACTIONS(2119), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(5840), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394899] = 6,
    ACTIONS(2211), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(4286), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394922] = 5,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    ACTIONS(9838), 1,
      anon_sym_BQUOTE,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394943] = 6,
    ACTIONS(2247), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9840), 1,
      anon_sym_PIPE,
    ACTIONS(9842), 1,
      anon_sym_PIPE2,
    STATE(4013), 1,
      sym__unboxed_close,
    STATE(9959), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394966] = 6,
    ACTIONS(6324), 1,
      sym_name,
    STATE(1609), 1,
      sym__qualified_consym,
    STATE(1610), 1,
      sym__qualified_varsym,
    STATE(8501), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394989] = 6,
    ACTIONS(2331), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(4636), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395012] = 4,
    STATE(11924), 1,
      sym_quoted_decls,
    ACTIONS(2905), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(9844), 2,
      sym__cmd_layout_start_quote,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395031] = 6,
    ACTIONS(2379), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(6861), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395054] = 6,
    ACTIONS(791), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(6635), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395077] = 6,
    ACTIONS(6324), 1,
      sym_name,
    STATE(1692), 1,
      sym__qualified_varsym,
    STATE(1726), 1,
      sym__qualified_consym,
    STATE(8501), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395100] = 6,
    ACTIONS(2511), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(5340), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395123] = 6,
    ACTIONS(899), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9846), 1,
      anon_sym_PIPE,
    ACTIONS(9848), 1,
      anon_sym_PIPE2,
    STATE(5709), 1,
      sym__unboxed_close,
    STATE(9905), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395146] = 6,
    ACTIONS(2081), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9850), 1,
      anon_sym_PIPE,
    ACTIONS(9852), 1,
      anon_sym_PIPE2,
    STATE(2885), 1,
      sym__unboxed_close,
    STATE(9898), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395169] = 6,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7422), 1,
      sym_variable,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10234), 1,
      sym_field_name,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395192] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6218), 5,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [395207] = 4,
    ACTIONS(9854), 1,
      anon_sym_COMMA,
    STATE(9744), 1,
      aux_sym_guards_repeat1,
    ACTIONS(9857), 3,
      sym__phantom_arrow,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395226] = 6,
    ACTIONS(791), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(6637), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395249] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6214), 5,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [395264] = 6,
    ACTIONS(2071), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(2347), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395287] = 5,
    ACTIONS(7336), 1,
      aux_sym__paren_open_token1,
    ACTIONS(9859), 1,
      sym_name,
    STATE(11672), 1,
      sym__paren_open,
    STATE(11302), 2,
      sym__consym_prefix,
      sym__pconsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395308] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7540), 5,
      sym__phantom_where,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [395323] = 5,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7879), 1,
      sym__paren_open,
    STATE(12155), 1,
      sym_children,
    ACTIONS(9861), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395344] = 6,
    ACTIONS(9863), 1,
      sym_name,
    STATE(8993), 1,
      sym__qualified_type,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11308), 1,
      aux_sym__qualifying_module,
    STATE(12165), 1,
      sym__qtyconid,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395367] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7516), 5,
      sym__phantom_where,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [395382] = 6,
    ACTIONS(2211), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(4249), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395405] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7540), 5,
      sym__phantom_where,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [395420] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7516), 5,
      sym__phantom_where,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [395435] = 6,
    ACTIONS(2347), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(4232), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395458] = 5,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7879), 1,
      sym__paren_open,
    STATE(12133), 1,
      sym_children,
    ACTIONS(7765), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395479] = 5,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7879), 1,
      sym__paren_open,
    STATE(12117), 1,
      sym_children,
    ACTIONS(9865), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395500] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7516), 5,
      sym__phantom_where,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [395515] = 6,
    ACTIONS(2331), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(4394), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395538] = 5,
    ACTIONS(4650), 1,
      anon_sym_COMMA,
    STATE(1444), 1,
      sym__colon2,
    STATE(10223), 1,
      aux_sym__var_binding_list_repeat1,
    ACTIONS(9867), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395559] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9608), 5,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [395574] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6386), 5,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [395589] = 6,
    ACTIONS(2071), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(2315), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395612] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6382), 5,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [395627] = 5,
    ACTIONS(4473), 1,
      aux_sym__paren_close_token1,
    STATE(1458), 1,
      sym__colon2,
    STATE(8033), 1,
      sym__paren_close,
    ACTIONS(9869), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395648] = 6,
    ACTIONS(2339), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(7230), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395671] = 6,
    ACTIONS(2347), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(4162), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395694] = 6,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(9678), 1,
      sym_name,
    STATE(9251), 1,
      aux_sym__qualifying_module,
    STATE(9892), 1,
      sym__modid_prefix,
    STATE(12269), 1,
      sym_constructor_operator,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395717] = 5,
    ACTIONS(8088), 1,
      anon_sym_in,
    ACTIONS(8092), 1,
      sym__phantom_in,
    STATE(12198), 1,
      sym__let_binds,
    ACTIONS(8090), 2,
      sym__cmd_layout_start_let,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395738] = 5,
    ACTIONS(9871), 1,
      anon_sym_in,
    ACTIONS(9873), 1,
      sym__phantom_in,
    STATE(11586), 1,
      sym__let_binds,
    ACTIONS(8090), 2,
      sym__cmd_layout_start_let,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395759] = 5,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    ACTIONS(9875), 1,
      anon_sym_BQUOTE,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395780] = 6,
    ACTIONS(6324), 1,
      sym_name,
    STATE(1500), 1,
      sym__qualified_consym,
    STATE(1513), 1,
      sym__qualified_varsym,
    STATE(8501), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395803] = 5,
    ACTIONS(9877), 1,
      sym_variable,
    STATE(10152), 1,
      aux_sym_type_family_injectivity_repeat1,
    STATE(11829), 1,
      sym__arrow,
    ACTIONS(1381), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395824] = 6,
    ACTIONS(2197), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(4645), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395847] = 6,
    ACTIONS(2023), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(4111), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395870] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7021), 5,
      sym__phantom_where,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [395885] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5147), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
  [395900] = 6,
    ACTIONS(7550), 1,
      sym_variable,
    ACTIONS(9879), 1,
      anon_sym_COMMA,
    ACTIONS(9881), 1,
      anon_sym_RBRACE,
    STATE(9990), 1,
      sym_field_name,
    STATE(11033), 1,
      sym_field,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395923] = 6,
    ACTIONS(8316), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(8003), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395946] = 6,
    ACTIONS(2511), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(4413), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395969] = 6,
    ACTIONS(2181), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6236), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395992] = 4,
    STATE(11597), 1,
      sym_quoted_decls,
    ACTIONS(3071), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(9844), 2,
      sym__cmd_layout_start_quote,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396011] = 6,
    ACTIONS(2453), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(3204), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396034] = 6,
    ACTIONS(2565), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(7193), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396057] = 6,
    ACTIONS(6324), 1,
      sym_name,
    STATE(1611), 1,
      sym__qualified_varsym,
    STATE(1613), 1,
      sym__qualified_consym,
    STATE(8501), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396080] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7504), 5,
      sym__phantom_bar,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH_GT,
      anon_sym_u2192,
  [396095] = 6,
    ACTIONS(2287), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(5549), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396118] = 6,
    ACTIONS(2287), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(5544), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396141] = 6,
    ACTIONS(2023), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(4090), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396164] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(1263), 1,
      aux_sym__paren_close_token1,
    STATE(5664), 1,
      sym__paren_close,
    STATE(10278), 1,
      aux_sym__exp_projection_selector_repeat1,
    STATE(12469), 1,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396187] = 6,
    ACTIONS(649), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9883), 1,
      anon_sym_PIPE,
    ACTIONS(9885), 1,
      anon_sym_PIPE2,
    STATE(7248), 1,
      sym__unboxed_close,
    STATE(9952), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396210] = 6,
    ACTIONS(2107), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(4509), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396233] = 6,
    ACTIONS(2107), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(4511), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396256] = 6,
    ACTIONS(2413), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(7114), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396279] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(1289), 1,
      aux_sym__paren_close_token1,
    STATE(4429), 1,
      sym__paren_close,
    STATE(10278), 1,
      aux_sym__exp_projection_selector_repeat1,
    STATE(12469), 1,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396302] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(3269), 5,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [396317] = 6,
    ACTIONS(2271), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(6375), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396340] = 6,
    ACTIONS(649), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9887), 1,
      anon_sym_PIPE,
    ACTIONS(9889), 1,
      anon_sym_PIPE2,
    STATE(7241), 1,
      sym__unboxed_close,
    STATE(9936), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396363] = 6,
    ACTIONS(6324), 1,
      sym_name,
    STATE(1452), 1,
      sym__qualified_varsym,
    STATE(1453), 1,
      sym__qualified_consym,
    STATE(8501), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396386] = 6,
    ACTIONS(2511), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8100), 1,
      anon_sym_PIPE,
    ACTIONS(8102), 1,
      anon_sym_PIPE2,
    STATE(5308), 1,
      sym__unboxed_close,
    STATE(9739), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396409] = 6,
    ACTIONS(2331), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7797), 1,
      anon_sym_PIPE,
    ACTIONS(7799), 1,
      anon_sym_PIPE2,
    STATE(5431), 1,
      sym__unboxed_close,
    STATE(9896), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396432] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6157), 5,
      sym__cond_context,
      sym__cond_data_infix,
      anon_sym_LBRACK,
      sym_name,
      aux_sym__paren_open_token1,
  [396447] = 6,
    ACTIONS(2107), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9891), 1,
      anon_sym_PIPE,
    ACTIONS(9893), 1,
      anon_sym_PIPE2,
    STATE(4567), 1,
      sym__unboxed_close,
    STATE(9793), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396470] = 6,
    ACTIONS(791), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6069), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396493] = 6,
    ACTIONS(2211), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9895), 1,
      anon_sym_PIPE,
    ACTIONS(9897), 1,
      anon_sym_PIPE2,
    STATE(4977), 1,
      sym__unboxed_close,
    STATE(9925), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396516] = 6,
    ACTIONS(2013), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(7433), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396539] = 6,
    ACTIONS(2431), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(4946), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396562] = 6,
    ACTIONS(2197), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(4444), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396585] = 6,
    ACTIONS(2263), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(7548), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396608] = 6,
    ACTIONS(2211), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7805), 1,
      anon_sym_PIPE,
    ACTIONS(7807), 1,
      anon_sym_PIPE2,
    STATE(4973), 1,
      sym__unboxed_close,
    STATE(9947), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396631] = 6,
    ACTIONS(2519), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(7243), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396654] = 6,
    ACTIONS(2119), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(5820), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396677] = 6,
    ACTIONS(9810), 1,
      sym_name,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(10891), 1,
      sym__qualified_constructor,
    STATE(11036), 1,
      aux_sym__qualifying_module,
    STATE(12517), 1,
      sym__qconid,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396700] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7013), 5,
      sym__phantom_where,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [396715] = 4,
    STATE(12177), 1,
      sym_quoted_decls,
    ACTIONS(3075), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(9844), 2,
      sym__cmd_layout_start_quote,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396734] = 4,
    STATE(11485), 1,
      sym_quoted_decls,
    ACTIONS(3079), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(9844), 2,
      sym__cmd_layout_start_quote,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396753] = 5,
    ACTIONS(9899), 1,
      anon_sym_in,
    ACTIONS(9901), 1,
      sym__phantom_in,
    STATE(11448), 1,
      sym__let_binds,
    ACTIONS(8090), 2,
      sym__cmd_layout_start_let,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396774] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(1277), 1,
      aux_sym__paren_close_token1,
    STATE(4986), 1,
      sym__paren_close,
    STATE(9897), 1,
      aux_sym__exp_projection_selector_repeat1,
    STATE(12469), 1,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396797] = 6,
    ACTIONS(9903), 1,
      sym_name,
    STATE(8993), 1,
      sym__qualified_type,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11308), 1,
      aux_sym__qualifying_module,
    STATE(12483), 1,
      sym__qtyconid,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396820] = 6,
    ACTIONS(2287), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9905), 1,
      anon_sym_PIPE,
    ACTIONS(9907), 1,
      anon_sym_PIPE2,
    STATE(5630), 1,
      sym__unboxed_close,
    STATE(9789), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396843] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7516), 5,
      sym__phantom_where,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [396858] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4695), 5,
      sym__phantom_where,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [396873] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(1263), 1,
      aux_sym__paren_close_token1,
    STATE(5674), 1,
      sym__paren_close,
    STATE(9791), 1,
      aux_sym__exp_projection_selector_repeat1,
    STATE(12469), 1,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396896] = 6,
    ACTIONS(6324), 1,
      sym_name,
    STATE(1701), 1,
      sym__qualified_varsym,
    STATE(1706), 1,
      sym__qualified_consym,
    STATE(8501), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396919] = 6,
    ACTIONS(2287), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(4994), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396942] = 6,
    ACTIONS(2107), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9909), 1,
      anon_sym_PIPE,
    ACTIONS(9911), 1,
      anon_sym_PIPE2,
    STATE(4576), 1,
      sym__unboxed_close,
    STATE(9794), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396965] = 6,
    ACTIONS(6324), 1,
      sym_name,
    STATE(1411), 1,
      sym__qualified_varsym,
    STATE(1412), 1,
      sym__qualified_consym,
    STATE(8501), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396988] = 6,
    ACTIONS(2231), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(3103), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397011] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(1289), 1,
      aux_sym__paren_close_token1,
    STATE(4585), 1,
      sym__paren_close,
    STATE(9796), 1,
      aux_sym__exp_projection_selector_repeat1,
    STATE(12469), 1,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397034] = 6,
    ACTIONS(2271), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6563), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397057] = 6,
    ACTIONS(6324), 1,
      sym_name,
    STATE(1432), 1,
      sym__qualified_consym,
    STATE(1433), 1,
      sym__qualified_varsym,
    STATE(8501), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397080] = 6,
    ACTIONS(2493), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(7770), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397103] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(1249), 1,
      aux_sym__paren_close_token1,
    STATE(4766), 1,
      sym__paren_close,
    STATE(9940), 1,
      aux_sym__exp_projection_selector_repeat1,
    STATE(12469), 1,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397126] = 5,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    ACTIONS(9913), 1,
      anon_sym_BQUOTE,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397147] = 6,
    ACTIONS(2039), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(6897), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397170] = 6,
    ACTIONS(2081), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(2699), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397193] = 5,
    ACTIONS(9915), 1,
      anon_sym_COMMA,
    STATE(1523), 1,
      sym__colon2,
    STATE(10360), 1,
      aux_sym_field_repeat1,
    ACTIONS(9917), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397214] = 6,
    ACTIONS(6324), 1,
      sym_name,
    STATE(1690), 1,
      sym__qualified_consym,
    STATE(1691), 1,
      sym__qualified_varsym,
    STATE(8501), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397237] = 6,
    ACTIONS(2663), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9919), 1,
      anon_sym_PIPE,
    ACTIONS(9921), 1,
      anon_sym_PIPE2,
    STATE(9122), 1,
      sym__unboxed_close,
    STATE(10007), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397260] = 6,
    ACTIONS(2247), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(3753), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397283] = 6,
    ACTIONS(2255), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(6234), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397306] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7009), 5,
      sym__phantom_where,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [397321] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7005), 5,
      sym__phantom_where,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [397336] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7001), 5,
      sym__phantom_where,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [397351] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6997), 5,
      sym__phantom_where,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      anon_sym_where,
  [397366] = 6,
    ACTIONS(6324), 1,
      sym_name,
    STATE(1418), 1,
      sym__qualified_consym,
    STATE(1486), 1,
      sym__qualified_varsym,
    STATE(8501), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397389] = 6,
    ACTIONS(2431), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(5094), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397412] = 6,
    ACTIONS(2347), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9923), 1,
      anon_sym_PIPE,
    ACTIONS(9925), 1,
      anon_sym_PIPE2,
    STATE(4754), 1,
      sym__unboxed_close,
    STATE(9948), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397435] = 5,
    ACTIONS(7588), 1,
      aux_sym__paren_open_token1,
    ACTIONS(9927), 1,
      sym_variable,
    STATE(8758), 1,
      sym__paren_open,
    STATE(11323), 2,
      sym__varsym_prefix,
      sym__pvarsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397456] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(1275), 1,
      aux_sym__paren_close_token1,
    STATE(5439), 1,
      sym__paren_close,
    STATE(9891), 1,
      aux_sym__exp_projection_selector_repeat1,
    STATE(12469), 1,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397479] = 5,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    ACTIONS(9929), 1,
      anon_sym_BQUOTE,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397500] = 6,
    ACTIONS(839), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9931), 1,
      anon_sym_PIPE,
    ACTIONS(9933), 1,
      anon_sym_PIPE2,
    STATE(6759), 1,
      sym__unboxed_close,
    STATE(9949), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397523] = 6,
    ACTIONS(6324), 1,
      sym_name,
    STATE(1545), 1,
      sym__qualified_varsym,
    STATE(1547), 1,
      sym__qualified_consym,
    STATE(8501), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397546] = 6,
    ACTIONS(839), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9935), 1,
      anon_sym_PIPE,
    ACTIONS(9937), 1,
      anon_sym_PIPE2,
    STATE(6761), 1,
      sym__unboxed_close,
    STATE(9963), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397569] = 6,
    ACTIONS(2331), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9939), 1,
      anon_sym_PIPE,
    ACTIONS(9941), 1,
      anon_sym_PIPE2,
    STATE(5434), 1,
      sym__unboxed_close,
    STATE(9894), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397592] = 6,
    ACTIONS(2453), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(3316), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397615] = 6,
    ACTIONS(2519), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(7261), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397638] = 5,
    ACTIONS(7724), 1,
      anon_sym_in,
    ACTIONS(7728), 1,
      sym__phantom_in,
    STATE(11784), 1,
      sym__let_binds,
    ACTIONS(8090), 2,
      sym__cmd_layout_start_let,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397659] = 6,
    ACTIONS(2485), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(6288), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397682] = 6,
    ACTIONS(2223), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(7604), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397705] = 4,
    STATE(12164), 1,
      sym_quoted_decls,
    ACTIONS(2877), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(9844), 2,
      sym__cmd_layout_start_quote,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397724] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7021), 5,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
  [397739] = 4,
    STATE(11721), 1,
      sym_quoted_decls,
    ACTIONS(2889), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(9844), 2,
      sym__cmd_layout_start_quote,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397758] = 6,
    ACTIONS(6324), 1,
      sym_name,
    STATE(1620), 1,
      sym__qualified_varsym,
    STATE(1678), 1,
      sym__qualified_consym,
    STATE(8501), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397781] = 6,
    ACTIONS(2303), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(3274), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397804] = 4,
    ACTIONS(9943), 1,
      anon_sym_in,
    ACTIONS(9945), 1,
      sym__phantom_in,
    ACTIONS(9571), 3,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397823] = 6,
    ACTIONS(6324), 1,
      sym_name,
    STATE(1639), 1,
      sym__qualified_varsym,
    STATE(1645), 1,
      sym__qualified_consym,
    STATE(8501), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397846] = 6,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(7550), 1,
      sym_variable,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11021), 1,
      sym_field_name,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397869] = 4,
    ACTIONS(9822), 1,
      anon_sym_COMMA,
    STATE(9744), 1,
      aux_sym_guards_repeat1,
    ACTIONS(9947), 3,
      sym__phantom_arrow,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397888] = 5,
    ACTIONS(4434), 1,
      aux_sym__paren_close_token1,
    STATE(1524), 1,
      sym__colon2,
    STATE(8072), 1,
      sym__paren_close,
    ACTIONS(9949), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397909] = 5,
    ACTIONS(9644), 1,
      sym_name,
    ACTIONS(9951), 1,
      sym_string,
    STATE(9066), 1,
      sym_module,
    STATE(10924), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397930] = 6,
    ACTIONS(2223), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(7607), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397953] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7013), 5,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
  [397968] = 6,
    ACTIONS(2413), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(7038), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397991] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4809), 5,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [398006] = 6,
    ACTIONS(2543), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6361), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398029] = 6,
    ACTIONS(6324), 1,
      sym_name,
    STATE(1592), 1,
      sym__qualified_varsym,
    STATE(1649), 1,
      sym__qualified_consym,
    STATE(8501), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398052] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7009), 5,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
  [398067] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7005), 5,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
  [398082] = 5,
    ACTIONS(9953), 1,
      anon_sym_in,
    ACTIONS(9955), 1,
      sym__phantom_in,
    STATE(11627), 1,
      sym__let_binds,
    ACTIONS(8090), 2,
      sym__cmd_layout_start_let,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398103] = 6,
    ACTIONS(2197), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7909), 1,
      anon_sym_PIPE,
    ACTIONS(7911), 1,
      anon_sym_PIPE2,
    STATE(5260), 1,
      sym__unboxed_close,
    STATE(9716), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398126] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(7001), 5,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
  [398141] = 6,
    ACTIONS(2081), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8018), 1,
      anon_sym_PIPE,
    ACTIONS(8020), 1,
      anon_sym_PIPE2,
    STATE(2897), 1,
      sym__unboxed_close,
    STATE(9930), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398164] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6997), 5,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
  [398179] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4861), 5,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      aux_sym__paren_open_token1,
      aux_sym__paren_close_token1,
  [398194] = 5,
    ACTIONS(9674), 1,
      sym_name,
    ACTIONS(9957), 1,
      sym_string,
    STATE(8834), 1,
      sym_module,
    STATE(11122), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398215] = 5,
    ACTIONS(7743), 1,
      anon_sym_in,
    ACTIONS(7747), 1,
      sym__phantom_in,
    STATE(11793), 1,
      sym__let_binds,
    ACTIONS(8090), 2,
      sym__cmd_layout_start_let,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398236] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(1279), 1,
      aux_sym__paren_close_token1,
    STATE(2976), 1,
      sym__paren_close,
    STATE(10278), 1,
      aux_sym__exp_projection_selector_repeat1,
    STATE(12469), 1,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398259] = 6,
    ACTIONS(2107), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(4049), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398282] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(1275), 1,
      aux_sym__paren_close_token1,
    STATE(5318), 1,
      sym__paren_close,
    STATE(10278), 1,
      aux_sym__exp_projection_selector_repeat1,
    STATE(12469), 1,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398305] = 3,
    ACTIONS(7416), 2,
      sym__consym,
      sym_name,
    ACTIONS(7414), 3,
      anon_sym_mdo,
      anon_sym_do,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398322] = 6,
    ACTIONS(2511), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(4361), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398345] = 6,
    ACTIONS(2331), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(5285), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398368] = 6,
    ACTIONS(2339), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(7222), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398391] = 6,
    ACTIONS(2331), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(5272), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398414] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(1277), 1,
      aux_sym__paren_close_token1,
    STATE(4949), 1,
      sym__paren_close,
    STATE(10278), 1,
      aux_sym__exp_projection_selector_repeat1,
    STATE(12469), 1,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398437] = 6,
    ACTIONS(2081), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(2997), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398460] = 6,
    ACTIONS(2527), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(7644), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398483] = 6,
    ACTIONS(2395), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(6045), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398506] = 5,
    ACTIONS(9959), 1,
      sym__phantom_arrow,
    STATE(7894), 1,
      sym__fun_arrow,
    STATE(7944), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398527] = 6,
    ACTIONS(2147), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(6071), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398550] = 6,
    ACTIONS(257), 1,
      sym__consym,
    ACTIONS(9961), 1,
      sym_name,
    STATE(9251), 1,
      aux_sym__qualifying_module,
    STATE(9892), 1,
      sym__modid_prefix,
    STATE(12269), 1,
      sym_constructor_operator,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398573] = 6,
    ACTIONS(2527), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(7675), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398596] = 6,
    ACTIONS(899), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(5698), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398619] = 6,
    ACTIONS(2347), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7867), 1,
      anon_sym_PIPE,
    ACTIONS(7869), 1,
      anon_sym_PIPE2,
    STATE(4745), 1,
      sym__unboxed_close,
    STATE(9958), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398642] = 5,
    ACTIONS(4469), 1,
      aux_sym__paren_close_token1,
    STATE(1564), 1,
      sym__colon2,
    STATE(7978), 1,
      sym__paren_close,
    ACTIONS(9963), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398663] = 6,
    ACTIONS(2439), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6621), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398686] = 6,
    ACTIONS(877), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(7091), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398709] = 6,
    ACTIONS(2023), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(4691), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398732] = 6,
    ACTIONS(877), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(7090), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398755] = 6,
    ACTIONS(2023), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(4678), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398778] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(1295), 1,
      aux_sym__paren_close_token1,
    STATE(4514), 1,
      sym__paren_close,
    STATE(10278), 1,
      aux_sym__exp_projection_selector_repeat1,
    STATE(12469), 1,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398801] = 6,
    ACTIONS(2439), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(6599), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398824] = 6,
    ACTIONS(2023), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7943), 1,
      anon_sym_PIPE,
    ACTIONS(7945), 1,
      anon_sym_PIPE2,
    STATE(4435), 1,
      sym__unboxed_close,
    STATE(9910), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398847] = 6,
    ACTIONS(2255), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6573), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398870] = 6,
    ACTIONS(2535), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(5970), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398893] = 6,
    ACTIONS(7550), 1,
      sym_variable,
    ACTIONS(9965), 1,
      anon_sym_COMMA,
    ACTIONS(9967), 1,
      anon_sym_RBRACE,
    STATE(9990), 1,
      sym_field_name,
    STATE(11105), 1,
      sym_field,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398916] = 5,
    ACTIONS(4438), 1,
      aux_sym__paren_close_token1,
    STATE(1437), 1,
      sym__colon2,
    STATE(7663), 1,
      sym__paren_close,
    ACTIONS(9969), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398937] = 6,
    ACTIONS(2565), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(7026), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398960] = 6,
    ACTIONS(2099), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6954), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398983] = 4,
    STATE(12134), 1,
      sym_quoted_decls,
    ACTIONS(2971), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(9844), 2,
      sym__cmd_layout_start_quote,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399002] = 5,
    ACTIONS(9156), 1,
      anon_sym_in,
    ACTIONS(9158), 1,
      sym__phantom_in,
    STATE(11493), 1,
      sym__let_binds,
    ACTIONS(8090), 2,
      sym__cmd_layout_start_let,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399023] = 6,
    ACTIONS(2181), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(6498), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399046] = 6,
    ACTIONS(2211), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(4943), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399069] = 6,
    ACTIONS(2279), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(3449), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399092] = 6,
    ACTIONS(877), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9971), 1,
      anon_sym_PIPE,
    ACTIONS(9973), 1,
      anon_sym_PIPE2,
    STATE(7078), 1,
      sym__unboxed_close,
    STATE(9909), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399115] = 6,
    ACTIONS(2485), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6374), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399138] = 4,
    STATE(1728), 1,
      sym__colon2,
    ACTIONS(6326), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(6328), 2,
      anon_sym_RBRACE,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399157] = 6,
    ACTIONS(2081), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(3009), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399180] = 5,
    ACTIONS(9975), 1,
      anon_sym_in,
    ACTIONS(9977), 1,
      sym__phantom_in,
    STATE(12156), 1,
      sym__let_binds,
    ACTIONS(8090), 2,
      sym__cmd_layout_start_let,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399201] = 6,
    ACTIONS(899), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(5715), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399224] = 6,
    ACTIONS(877), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9979), 1,
      anon_sym_PIPE,
    ACTIONS(9981), 1,
      anon_sym_PIPE2,
    STATE(7076), 1,
      sym__unboxed_close,
    STATE(9911), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399247] = 6,
    ACTIONS(2023), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9983), 1,
      anon_sym_PIPE,
    ACTIONS(9985), 1,
      anon_sym_PIPE2,
    STATE(4431), 1,
      sym__unboxed_close,
    STATE(9912), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399270] = 4,
    STATE(11951), 1,
      sym_quoted_decls,
    ACTIONS(2991), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(9844), 2,
      sym__cmd_layout_start_quote,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399289] = 6,
    ACTIONS(649), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(7296), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399312] = 6,
    ACTIONS(8908), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(7950), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399335] = 6,
    ACTIONS(9987), 1,
      sym_name,
    STATE(8993), 1,
      sym__qualified_type,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11308), 1,
      aux_sym__qualifying_module,
    STATE(12483), 1,
      sym__qtyconid,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399358] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(1295), 1,
      aux_sym__paren_close_token1,
    STATE(4424), 1,
      sym__paren_close,
    STATE(9913), 1,
      aux_sym__exp_projection_selector_repeat1,
    STATE(12469), 1,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399381] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(1249), 1,
      aux_sym__paren_close_token1,
    STATE(4719), 1,
      sym__paren_close,
    STATE(10278), 1,
      aux_sym__exp_projection_selector_repeat1,
    STATE(12469), 1,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399404] = 6,
    ACTIONS(2663), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(9121), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399427] = 5,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    ACTIONS(9989), 1,
      anon_sym_BQUOTE,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399448] = 6,
    ACTIONS(6324), 1,
      sym_name,
    STATE(1531), 1,
      sym__qualified_varsym,
    STATE(1533), 1,
      sym__qualified_consym,
    STATE(8501), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399471] = 3,
    ACTIONS(7330), 2,
      sym__consym,
      sym_name,
    ACTIONS(7328), 3,
      anon_sym_mdo,
      anon_sym_do,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399488] = 6,
    ACTIONS(2091), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(3399), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399511] = 6,
    ACTIONS(2387), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(3819), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399534] = 6,
    ACTIONS(2211), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(4939), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399557] = 6,
    ACTIONS(2347), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(4715), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399580] = 6,
    ACTIONS(839), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(6773), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399603] = 5,
    ACTIONS(9991), 1,
      anon_sym_in,
    ACTIONS(9993), 1,
      sym__phantom_in,
    STATE(11546), 1,
      sym__let_binds,
    ACTIONS(8090), 2,
      sym__cmd_layout_start_let,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399624] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6187), 5,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [399639] = 6,
    ACTIONS(649), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(7298), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399662] = 4,
    ACTIONS(2737), 1,
      sym__consym,
    ACTIONS(9995), 1,
      anon_sym_BQUOTE,
    STATE(2103), 3,
      sym__constructor_ticked,
      sym_constructor_operator,
      sym__constructor_operator_alias,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399681] = 6,
    ACTIONS(2493), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(7772), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399704] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4771), 5,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [399719] = 6,
    ACTIONS(9997), 1,
      sym_name,
    STATE(8993), 1,
      sym__qualified_type,
    STATE(10076), 1,
      sym__modid_prefix,
    STATE(11308), 1,
      aux_sym__qualifying_module,
    STATE(12788), 1,
      sym__qtyconid,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399742] = 6,
    ACTIONS(2535), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(5890), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399765] = 6,
    ACTIONS(2347), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(4713), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399788] = 6,
    ACTIONS(2247), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(3981), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399811] = 6,
    ACTIONS(2247), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(3983), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399834] = 3,
    STATE(1574), 1,
      sym__colon2,
    ACTIONS(9999), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399851] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(1255), 1,
      aux_sym__paren_close_token1,
    STATE(3986), 1,
      sym__paren_close,
    STATE(10278), 1,
      aux_sym__exp_projection_selector_repeat1,
    STATE(12469), 1,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399874] = 6,
    ACTIONS(839), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(6774), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399897] = 6,
    ACTIONS(2557), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(3543), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399920] = 6,
    ACTIONS(2239), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(2762), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399943] = 6,
    ACTIONS(2247), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(3693), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399966] = 6,
    ACTIONS(2355), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(5996), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [399989] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(3273), 5,
      sym__cond_context,
      sym__cond_data_infix,
      anon_sym_LBRACK,
      sym_name,
      aux_sym__paren_open_token1,
  [400004] = 4,
    STATE(12215), 1,
      sym_quoted_decls,
    ACTIONS(2853), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(9844), 2,
      sym__cmd_layout_start_quote,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400023] = 6,
    ACTIONS(2231), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(3128), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400046] = 6,
    ACTIONS(2303), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(3400), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400069] = 6,
    ACTIONS(2557), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(3436), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400092] = 6,
    ACTIONS(2107), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(3995), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400115] = 6,
    ACTIONS(2371), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(3256), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400138] = 6,
    ACTIONS(839), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6293), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400161] = 6,
    ACTIONS(2287), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10001), 1,
      anon_sym_PIPE,
    ACTIONS(10003), 1,
      anon_sym_PIPE2,
    STATE(5663), 1,
      sym__unboxed_close,
    STATE(9788), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400184] = 2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(3279), 5,
      sym__cond_context,
      sym__cond_data_infix,
      anon_sym_LBRACK,
      sym_name,
      aux_sym__paren_open_token1,
  [400199] = 6,
    ACTIONS(6324), 1,
      sym_name,
    STATE(1596), 1,
      sym__qualified_consym,
    STATE(1618), 1,
      sym__qualified_varsym,
    STATE(8501), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400222] = 6,
    ACTIONS(6324), 1,
      sym_name,
    STATE(1603), 1,
      sym__qualified_consym,
    STATE(1604), 1,
      sym__qualified_varsym,
    STATE(8501), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400245] = 5,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7879), 1,
      sym__paren_open,
    STATE(12195), 1,
      sym_children,
    ACTIONS(10005), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400266] = 5,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7879), 1,
      sym__paren_open,
    STATE(12173), 1,
      sym_children,
    ACTIONS(7682), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400287] = 6,
    ACTIONS(2371), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(3386), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400310] = 6,
    ACTIONS(2039), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6905), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400333] = 5,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7879), 1,
      sym__paren_open,
    STATE(12167), 1,
      sym_children,
    ACTIONS(10007), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400354] = 6,
    ACTIONS(2355), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(5979), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400377] = 6,
    ACTIONS(6324), 1,
      sym_name,
    STATE(1477), 1,
      sym__qualified_varsym,
    STATE(1488), 1,
      sym__qualified_consym,
    STATE(8501), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400400] = 6,
    ACTIONS(2189), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6819), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400423] = 6,
    ACTIONS(791), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10009), 1,
      anon_sym_PIPE,
    ACTIONS(10011), 1,
      anon_sym_PIPE2,
    STATE(6645), 1,
      sym__unboxed_close,
    STATE(9745), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400446] = 5,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    ACTIONS(10013), 1,
      anon_sym_BQUOTE,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400467] = 5,
    ACTIONS(9915), 1,
      anon_sym_COMMA,
    STATE(1640), 1,
      sym__colon2,
    STATE(9838), 1,
      aux_sym_field_repeat1,
    ACTIONS(10015), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400488] = 6,
    ACTIONS(839), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(6195), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400511] = 6,
    ACTIONS(2239), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(2789), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400534] = 4,
    STATE(11571), 1,
      sym_quoted_decls,
    ACTIONS(2987), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(9844), 2,
      sym__cmd_layout_start_quote,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400553] = 6,
    ACTIONS(2147), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6169), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400576] = 5,
    ACTIONS(5689), 1,
      anon_sym_COMMA,
    STATE(862), 1,
      sym__colon2,
    STATE(10487), 1,
      aux_sym__con_binding_list_repeat1,
    ACTIONS(10017), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400597] = 6,
    ACTIONS(2099), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(6969), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400620] = 6,
    ACTIONS(791), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10019), 1,
      anon_sym_PIPE,
    ACTIONS(10021), 1,
      anon_sym_PIPE2,
    STATE(6648), 1,
      sym__unboxed_close,
    STATE(9737), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400643] = 6,
    ACTIONS(2511), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10023), 1,
      anon_sym_PIPE,
    ACTIONS(10025), 1,
      anon_sym_PIPE2,
    STATE(5305), 1,
      sym__unboxed_close,
    STATE(9728), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400666] = 5,
    ACTIONS(9959), 1,
      sym__phantom_arrow,
    STATE(1395), 1,
      sym__fun_arrow,
    STATE(7944), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400687] = 6,
    ACTIONS(2543), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(6466), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400710] = 5,
    ACTIONS(5689), 1,
      anon_sym_COMMA,
    STATE(857), 1,
      sym__colon2,
    STATE(10486), 1,
      aux_sym__con_binding_list_repeat1,
    ACTIONS(10027), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400731] = 3,
    ACTIONS(7322), 2,
      sym__consym,
      sym_name,
    ACTIONS(7320), 3,
      anon_sym_mdo,
      anon_sym_do,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400748] = 6,
    ACTIONS(2189), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(6802), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400771] = 3,
    ACTIONS(7326), 2,
      sym__consym,
      sym_name,
    ACTIONS(7324), 3,
      anon_sym_mdo,
      anon_sym_do,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400788] = 6,
    ACTIONS(2279), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(3552), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400811] = 5,
    ACTIONS(10029), 1,
      anon_sym_in,
    ACTIONS(10031), 1,
      sym__phantom_in,
    STATE(12068), 1,
      sym__let_binds,
    ACTIONS(8090), 2,
      sym__cmd_layout_start_let,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400832] = 6,
    ACTIONS(2663), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9816), 1,
      anon_sym_PIPE,
    ACTIONS(9818), 1,
      anon_sym_PIPE2,
    STATE(9118), 1,
      sym__unboxed_close,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400855] = 6,
    ACTIONS(2091), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(3248), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400878] = 6,
    ACTIONS(6324), 1,
      sym_name,
    STATE(1539), 1,
      sym__qualified_consym,
    STATE(1570), 1,
      sym__qualified_varsym,
    STATE(8501), 1,
      aux_sym__qualifying_module,
    STATE(8595), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400901] = 6,
    ACTIONS(2395), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(5877), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400924] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(1255), 1,
      aux_sym__paren_close_token1,
    STATE(4050), 1,
      sym__paren_close,
    STATE(9962), 1,
      aux_sym__exp_projection_selector_repeat1,
    STATE(12469), 1,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400947] = 6,
    ACTIONS(2363), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8132), 1,
      anon_sym_PIPE,
    ACTIONS(8134), 1,
      anon_sym_PIPE2,
    STATE(6827), 1,
      sym__unboxed_close,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400970] = 6,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(1269), 1,
      aux_sym__paren_close_token1,
    STATE(5294), 1,
      sym__paren_close,
    STATE(9710), 1,
      aux_sym__exp_projection_selector_repeat1,
    STATE(12469), 1,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [400993] = 6,
    ACTIONS(2247), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10033), 1,
      anon_sym_PIPE,
    ACTIONS(10035), 1,
      anon_sym_PIPE2,
    STATE(4017), 1,
      sym__unboxed_close,
    STATE(9960), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401016] = 6,
    ACTIONS(2737), 1,
      sym__consym,
    ACTIONS(9678), 1,
      sym_name,
    STATE(8169), 1,
      sym_constructor_operator,
    STATE(9251), 1,
      aux_sym__qualifying_module,
    STATE(9892), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401039] = 5,
    ACTIONS(10037), 1,
      sym_variable,
    ACTIONS(10039), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401059] = 4,
    ACTIONS(10041), 1,
      anon_sym_DOT,
    STATE(12774), 1,
      sym__arrow,
    ACTIONS(10043), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401077] = 2,
    ACTIONS(5203), 4,
      anon_sym_COMMA,
      anon_sym_by,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401091] = 2,
    ACTIONS(4735), 4,
      anon_sym__,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401105] = 3,
    ACTIONS(5640), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(5642), 2,
      sym__cond_prefix_at,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401121] = 5,
    ACTIONS(1411), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6866), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401141] = 2,
    ACTIONS(5203), 4,
      sym__phantom_arrow,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401155] = 5,
    ACTIONS(1473), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6247), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401175] = 2,
    ACTIONS(5271), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401189] = 2,
    ACTIONS(5283), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401203] = 5,
    ACTIONS(2967), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6876), 1,
      sym__bracket_close,
    STATE(10051), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401223] = 2,
    ACTIONS(5363), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401237] = 5,
    ACTIONS(2255), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6237), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401257] = 2,
    ACTIONS(5363), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401271] = 5,
    ACTIONS(2985), 1,
      anon_sym_RBRACK,
    ACTIONS(10049), 1,
      anon_sym_COMMA,
    STATE(4023), 1,
      sym__bracket_close,
    STATE(11171), 1,
      aux_sym__exp_list_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401291] = 5,
    ACTIONS(2985), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    STATE(4019), 1,
      sym__bracket_close,
    STATE(11166), 1,
      aux_sym__exp_list_comprehension_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401311] = 2,
    ACTIONS(5143), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401325] = 5,
    ACTIONS(2247), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(4015), 1,
      sym__unboxed_close,
    STATE(11132), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401345] = 5,
    ACTIONS(2247), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(4014), 1,
      sym__unboxed_close,
    STATE(10071), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401365] = 2,
    ACTIONS(5371), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401379] = 2,
    ACTIONS(5207), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401393] = 2,
    ACTIONS(5183), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401407] = 2,
    ACTIONS(10051), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401421] = 2,
    ACTIONS(5179), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401435] = 2,
    ACTIONS(5211), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401449] = 2,
    ACTIONS(5271), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401463] = 3,
    ACTIONS(6212), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(6214), 2,
      sym__cond_prefix_at,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401479] = 3,
    ACTIONS(6216), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(6218), 2,
      sym__cond_prefix_at,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401495] = 2,
    ACTIONS(6360), 4,
      sym__cond_data_infix,
      anon_sym_LBRACK,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401509] = 2,
    ACTIONS(10053), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401523] = 2,
    ACTIONS(10055), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401537] = 3,
    ACTIONS(6185), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(6187), 2,
      sym__cond_prefix_at,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401553] = 3,
    ACTIONS(4769), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(4771), 2,
      sym__cond_prefix_at,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401569] = 2,
    ACTIONS(10057), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401583] = 5,
    ACTIONS(6336), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10059), 1,
      anon_sym_COMMA,
    STATE(11280), 1,
      aux_sym_import_list_repeat1,
    STATE(11543), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401603] = 5,
    ACTIONS(2967), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6894), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401623] = 5,
    ACTIONS(2039), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(6901), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401643] = 2,
    ACTIONS(5203), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401657] = 2,
    ACTIONS(4817), 4,
      anon_sym__,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401671] = 2,
    ACTIONS(10061), 4,
      sym__phantom_arrow,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401685] = 3,
    ACTIONS(6236), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(6238), 2,
      sym__cond_prefix_at,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401701] = 3,
    ACTIONS(6248), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(6250), 2,
      sym__cond_prefix_at,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401717] = 4,
    ACTIONS(10063), 1,
      sym_name,
    STATE(9577), 1,
      sym_module,
    STATE(10946), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401735] = 2,
    ACTIONS(5147), 4,
      sym__cond_tight_dot,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401749] = 4,
    ACTIONS(10065), 1,
      ts_builtin_sym_end,
    STATE(12580), 1,
      sym__body,
    ACTIONS(9), 2,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401767] = 2,
    ACTIONS(3245), 4,
      sym__cond_data_infix,
      anon_sym_LBRACK,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401781] = 5,
    ACTIONS(9062), 1,
      sym_name,
    ACTIONS(10067), 1,
      sym_variable,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401801] = 5,
    ACTIONS(9678), 1,
      sym_name,
    STATE(2263), 1,
      sym__qualified_consym,
    STATE(9892), 1,
      sym__modid_prefix,
    STATE(10015), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401821] = 5,
    ACTIONS(9678), 1,
      sym_name,
    STATE(2301), 1,
      sym__qualified_consym,
    STATE(9892), 1,
      sym__modid_prefix,
    STATE(10015), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401841] = 4,
    ACTIONS(10069), 1,
      anon_sym_DOT,
    STATE(11092), 1,
      sym__arrow,
    ACTIONS(10071), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401859] = 3,
    ACTIONS(3269), 2,
      sym__cond_prefix_at,
      aux_sym__paren_open_token1,
    ACTIONS(6256), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401875] = 4,
    ACTIONS(10075), 1,
      sym__phantom_arrow,
    STATE(12249), 1,
      sym__arrow,
    ACTIONS(10073), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401893] = 4,
    ACTIONS(9674), 1,
      sym_name,
    STATE(8833), 1,
      sym_module,
    STATE(11122), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401911] = 2,
    ACTIONS(10077), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401925] = 5,
    ACTIONS(10079), 1,
      sym_variable,
    ACTIONS(10081), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401945] = 5,
    ACTIONS(2247), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(3982), 1,
      sym__unboxed_close,
    STATE(11132), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401965] = 2,
    ACTIONS(10083), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401979] = 5,
    ACTIONS(9678), 1,
      sym_name,
    STATE(2284), 1,
      sym__qualified_consym,
    STATE(9892), 1,
      sym__modid_prefix,
    STATE(10015), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [401999] = 5,
    ACTIONS(269), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10085), 1,
      anon_sym_COMMA,
    STATE(5717), 1,
      sym__paren_close,
    STATE(11123), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402019] = 5,
    ACTIONS(1231), 1,
      anon_sym_RBRACK,
    ACTIONS(10087), 1,
      anon_sym_COMMA,
    STATE(5700), 1,
      sym__bracket_close,
    STATE(10128), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402039] = 3,
    ACTIONS(7416), 1,
      sym_name,
    ACTIONS(7414), 3,
      anon_sym_mdo,
      anon_sym_do,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402055] = 5,
    ACTIONS(10089), 1,
      anon_sym_SEMI,
    ACTIONS(10091), 1,
      sym__cond_layout_semicolon,
    STATE(3861), 1,
      aux_sym__let_binds_repeat1,
    STATE(10243), 1,
      aux_sym_imports_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402075] = 4,
    ACTIONS(4608), 1,
      sym__cond_qual_dot,
    ACTIONS(4610), 1,
      sym__cond_tight_dot,
    STATE(8574), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402093] = 2,
    ACTIONS(10093), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402107] = 2,
    ACTIONS(10095), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402121] = 2,
    ACTIONS(10097), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402135] = 4,
    ACTIONS(10099), 1,
      anon_sym_DOT,
    STATE(1652), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402153] = 4,
    ACTIONS(10101), 1,
      anon_sym_DOT,
    STATE(1712), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402171] = 2,
    ACTIONS(10103), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402185] = 2,
    ACTIONS(10105), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402199] = 4,
    ACTIONS(10107), 1,
      anon_sym_DOT,
    STATE(1741), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402217] = 2,
    ACTIONS(10109), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402231] = 2,
    ACTIONS(10111), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402245] = 4,
    ACTIONS(10113), 1,
      anon_sym_DOT,
    STATE(1408), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402263] = 2,
    ACTIONS(10115), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402277] = 4,
    ACTIONS(10117), 1,
      anon_sym_DOT,
    STATE(1519), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402295] = 5,
    ACTIONS(2663), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(9097), 1,
      sym__unboxed_close,
    STATE(10836), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402315] = 4,
    ACTIONS(9644), 1,
      sym_name,
    STATE(9583), 1,
      sym_module,
    STATE(10924), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402333] = 2,
    ACTIONS(10119), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402347] = 4,
    ACTIONS(10121), 1,
      anon_sym_DOT,
    STATE(1705), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402365] = 2,
    ACTIONS(10123), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402379] = 5,
    ACTIONS(1443), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7338), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402399] = 4,
    ACTIONS(9644), 1,
      sym_name,
    STATE(9590), 1,
      sym_module,
    STATE(10924), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402417] = 4,
    ACTIONS(10125), 1,
      anon_sym_DOT,
    STATE(1755), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402435] = 2,
    ACTIONS(10127), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402449] = 2,
    ACTIONS(10129), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402463] = 4,
    ACTIONS(9644), 1,
      sym_name,
    STATE(9594), 1,
      sym_module,
    STATE(10924), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402481] = 2,
    ACTIONS(10131), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402495] = 4,
    ACTIONS(10133), 1,
      anon_sym_DOT,
    STATE(1733), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402513] = 2,
    ACTIONS(10135), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402527] = 5,
    ACTIONS(269), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(5798), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402547] = 5,
    ACTIONS(2851), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7333), 1,
      sym__bracket_close,
    STATE(10157), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402567] = 5,
    ACTIONS(899), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(5800), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402587] = 4,
    ACTIONS(10137), 1,
      anon_sym_DOT,
    STATE(1714), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402605] = 2,
    ACTIONS(10139), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402619] = 2,
    ACTIONS(10141), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402633] = 2,
    ACTIONS(10143), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402647] = 4,
    ACTIONS(10145), 1,
      anon_sym_DOT,
    STATE(1697), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402665] = 2,
    ACTIONS(10147), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402679] = 5,
    ACTIONS(8560), 1,
      sym_name,
    ACTIONS(10149), 1,
      sym_variable,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402699] = 2,
    ACTIONS(10151), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402713] = 4,
    ACTIONS(10153), 1,
      anon_sym_DOT,
    STATE(1669), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402731] = 2,
    ACTIONS(10155), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402745] = 4,
    ACTIONS(9674), 1,
      sym_name,
    STATE(8802), 1,
      sym_module,
    STATE(11122), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402763] = 4,
    ACTIONS(9674), 1,
      sym_name,
    STATE(8969), 1,
      sym_module,
    STATE(11122), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402781] = 5,
    ACTIONS(2331), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(5273), 1,
      sym__unboxed_close,
    STATE(11132), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402801] = 4,
    ACTIONS(10157), 1,
      anon_sym_DOT,
    STATE(1636), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402819] = 4,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    STATE(1116), 1,
      sym__dotdot,
    ACTIONS(10159), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402837] = 5,
    ACTIONS(10161), 1,
      anon_sym_PIPE,
    ACTIONS(10164), 1,
      anon_sym_PIPE2,
    ACTIONS(10167), 1,
      anon_sym_POUND_RPAREN,
    STATE(10124), 1,
      aux_sym__type_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402857] = 5,
    ACTIONS(9678), 1,
      sym_name,
    STATE(2295), 1,
      sym__qualified_consym,
    STATE(9892), 1,
      sym__modid_prefix,
    STATE(10015), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402877] = 5,
    ACTIONS(2919), 1,
      anon_sym_RBRACK,
    ACTIONS(10169), 1,
      anon_sym_COMMA,
    STATE(2871), 1,
      sym__bracket_close,
    STATE(11171), 1,
      aux_sym__exp_list_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402897] = 5,
    ACTIONS(2919), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    STATE(2882), 1,
      sym__bracket_close,
    STATE(11166), 1,
      aux_sym__exp_list_comprehension_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402917] = 5,
    ACTIONS(1231), 1,
      anon_sym_RBRACK,
    ACTIONS(10171), 1,
      anon_sym_COMMA,
    STATE(5712), 1,
      sym__bracket_close,
    STATE(10362), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402937] = 4,
    ACTIONS(10173), 1,
      anon_sym_COMMA,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(10176), 2,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402955] = 2,
    ACTIONS(10178), 4,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402969] = 5,
    ACTIONS(2081), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(2888), 1,
      sym__unboxed_close,
    STATE(11132), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [402989] = 5,
    ACTIONS(899), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9529), 1,
      anon_sym_COMMA,
    STATE(5710), 1,
      sym__unboxed_close,
    STATE(11018), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403009] = 5,
    ACTIONS(2081), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(2896), 1,
      sym__unboxed_close,
    STATE(10177), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403029] = 4,
    ACTIONS(10180), 1,
      anon_sym_DOT,
    STATE(1586), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403047] = 4,
    ACTIONS(10182), 1,
      anon_sym_EQ,
    STATE(1530), 1,
      sym__colon2,
    ACTIONS(10184), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403065] = 5,
    ACTIONS(9322), 1,
      sym_name,
    ACTIONS(10186), 1,
      sym_variable,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403085] = 2,
    ACTIONS(10188), 4,
      sym__phantom_arrow,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403099] = 2,
    ACTIONS(10190), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403113] = 2,
    ACTIONS(10192), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403127] = 2,
    ACTIONS(10194), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403141] = 2,
    ACTIONS(10190), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403155] = 2,
    ACTIONS(10196), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403169] = 2,
    ACTIONS(10198), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403183] = 5,
    ACTIONS(2543), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(6362), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403203] = 5,
    ACTIONS(2891), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6367), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403223] = 2,
    ACTIONS(10200), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403237] = 4,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    STATE(1053), 1,
      sym__dotdot,
    ACTIONS(10159), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403255] = 4,
    ACTIONS(10202), 1,
      anon_sym_DOT,
    STATE(10371), 1,
      sym__arrow,
    ACTIONS(10204), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403273] = 2,
    ACTIONS(10206), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403287] = 2,
    ACTIONS(10208), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403301] = 2,
    ACTIONS(10210), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403315] = 4,
    ACTIONS(10212), 1,
      sym_variable,
    STATE(10152), 1,
      aux_sym_type_family_injectivity_repeat1,
    ACTIONS(7658), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403333] = 2,
    ACTIONS(10215), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403347] = 2,
    ACTIONS(10217), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403361] = 2,
    ACTIONS(10219), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403375] = 4,
    ACTIONS(10221), 1,
      anon_sym_DOT,
    STATE(1504), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403393] = 5,
    ACTIONS(2851), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7233), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403413] = 5,
    ACTIONS(2339), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(7232), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403433] = 4,
    ACTIONS(9674), 1,
      sym_name,
    STATE(9117), 1,
      sym_module,
    STATE(11122), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403451] = 2,
    ACTIONS(10223), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403465] = 4,
    ACTIONS(9674), 1,
      sym_name,
    STATE(9138), 1,
      sym_module,
    STATE(11122), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403483] = 4,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    STATE(989), 1,
      sym__dotdot,
    ACTIONS(10159), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403501] = 5,
    ACTIONS(2331), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(5432), 1,
      sym__unboxed_close,
    STATE(10121), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403521] = 5,
    ACTIONS(2331), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(5433), 1,
      sym__unboxed_close,
    STATE(11132), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403541] = 5,
    ACTIONS(2881), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    STATE(5435), 1,
      sym__bracket_close,
    STATE(11166), 1,
      aux_sym__exp_list_comprehension_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403561] = 4,
    ACTIONS(9674), 1,
      sym_name,
    STATE(9139), 1,
      sym_module,
    STATE(11122), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403579] = 5,
    ACTIONS(2983), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10225), 1,
      anon_sym_COMMA,
    STATE(10180), 1,
      sym__paren_close,
    STATE(10210), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403599] = 5,
    ACTIONS(2881), 1,
      anon_sym_RBRACK,
    ACTIONS(10227), 1,
      anon_sym_COMMA,
    STATE(5436), 1,
      sym__bracket_close,
    STATE(11171), 1,
      aux_sym__exp_list_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403619] = 2,
    ACTIONS(10229), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403633] = 2,
    ACTIONS(10231), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403647] = 4,
    ACTIONS(10233), 1,
      anon_sym_DOT,
    STATE(1400), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403665] = 2,
    ACTIONS(10235), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403679] = 2,
    ACTIONS(10237), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403693] = 4,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    STATE(991), 1,
      sym__dotdot,
    ACTIONS(10159), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403711] = 4,
    ACTIONS(9644), 1,
      sym_name,
    STATE(9078), 1,
      sym_module,
    STATE(10924), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403729] = 2,
    ACTIONS(10239), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403743] = 5,
    ACTIONS(2081), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(2998), 1,
      sym__unboxed_close,
    STATE(11132), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403763] = 4,
    ACTIONS(10241), 1,
      anon_sym_DOT,
    STATE(1473), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403781] = 2,
    ACTIONS(10243), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403795] = 2,
    ACTIONS(10245), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403809] = 5,
    ACTIONS(249), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6081), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403829] = 2,
    ACTIONS(10247), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403843] = 5,
    ACTIONS(1559), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7462), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403863] = 5,
    ACTIONS(1195), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6080), 1,
      sym__bracket_close,
    STATE(10225), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403883] = 2,
    ACTIONS(10249), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403897] = 5,
    ACTIONS(2013), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7370), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403917] = 2,
    ACTIONS(10251), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403931] = 5,
    ACTIONS(2387), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(3808), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403951] = 5,
    ACTIONS(2891), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6385), 1,
      sym__bracket_close,
    STATE(10145), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403971] = 5,
    ACTIONS(1493), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(3811), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403991] = 2,
    ACTIONS(10253), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404005] = 2,
    ACTIONS(10255), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404019] = 2,
    ACTIONS(10257), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404033] = 5,
    ACTIONS(1435), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6389), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404053] = 5,
    ACTIONS(3501), 1,
      aux_sym__paren_close_token1,
    ACTIONS(8262), 1,
      anon_sym_COMMA,
    STATE(7919), 1,
      sym__paren_close,
    STATE(11209), 1,
      aux_sym__ctr_tuple_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404073] = 4,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    STATE(1060), 1,
      sym__dotdot,
    ACTIONS(10159), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404091] = 2,
    ACTIONS(10259), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404105] = 2,
    ACTIONS(10261), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404119] = 2,
    ACTIONS(10263), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404133] = 5,
    ACTIONS(3411), 1,
      aux_sym__paren_close_token1,
    ACTIONS(8262), 1,
      anon_sym_COMMA,
    STATE(7983), 1,
      sym__paren_close,
    STATE(11209), 1,
      aux_sym__ctr_tuple_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404153] = 2,
    ACTIONS(10265), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404167] = 4,
    ACTIONS(9674), 1,
      sym_name,
    STATE(8961), 1,
      sym_module,
    STATE(11122), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404185] = 4,
    ACTIONS(9674), 1,
      sym_name,
    STATE(8962), 1,
      sym_module,
    STATE(11122), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404203] = 5,
    ACTIONS(2969), 1,
      anon_sym_RBRACK,
    ACTIONS(10267), 1,
      anon_sym_COMMA,
    STATE(5567), 1,
      sym__bracket_close,
    STATE(11171), 1,
      aux_sym__exp_list_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404223] = 5,
    ACTIONS(2969), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    STATE(5526), 1,
      sym__bracket_close,
    STATE(11166), 1,
      aux_sym__exp_list_comprehension_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404243] = 4,
    ACTIONS(10269), 1,
      anon_sym_DOT,
    STATE(1580), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404261] = 5,
    ACTIONS(2287), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(5655), 1,
      sym__unboxed_close,
    STATE(11132), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404281] = 5,
    ACTIONS(2287), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(5671), 1,
      sym__unboxed_close,
    STATE(10245), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404301] = 4,
    ACTIONS(9674), 1,
      sym_name,
    STATE(8963), 1,
      sym_module,
    STATE(11122), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404319] = 5,
    ACTIONS(2983), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10271), 1,
      anon_sym_COMMA,
    STATE(10140), 1,
      sym__paren_close,
    STATE(11280), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404339] = 2,
    ACTIONS(10061), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404353] = 2,
    ACTIONS(10273), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404367] = 3,
    ACTIONS(6892), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(6894), 2,
      sym__cond_prefix_at,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404383] = 2,
    ACTIONS(10275), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404397] = 4,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    STATE(1074), 1,
      sym__dotdot,
    ACTIONS(10159), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404415] = 4,
    ACTIONS(9674), 1,
      sym_name,
    STATE(8998), 1,
      sym_module,
    STATE(11122), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404433] = 4,
    ACTIONS(10277), 1,
      anon_sym_DOT,
    STATE(1686), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404451] = 3,
    ACTIONS(6898), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(6900), 2,
      sym__cond_prefix_at,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404467] = 2,
    ACTIONS(10061), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404481] = 2,
    ACTIONS(10279), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404495] = 2,
    ACTIONS(10281), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404509] = 2,
    ACTIONS(10283), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404523] = 4,
    ACTIONS(4650), 1,
      anon_sym_COMMA,
    STATE(10651), 1,
      aux_sym__var_binding_list_repeat1,
    ACTIONS(10285), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404541] = 2,
    ACTIONS(10287), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404555] = 5,
    ACTIONS(1195), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6072), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404575] = 5,
    ACTIONS(791), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(6070), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404595] = 3,
    ACTIONS(7330), 1,
      sym_name,
    ACTIONS(7328), 3,
      anon_sym_mdo,
      anon_sym_do,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404611] = 4,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    STATE(1076), 1,
      sym__dotdot,
    ACTIONS(10159), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404629] = 5,
    ACTIONS(9678), 1,
      sym_name,
    STATE(2268), 1,
      sym__qualified_consym,
    STATE(9892), 1,
      sym__modid_prefix,
    STATE(10015), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404649] = 4,
    ACTIONS(10289), 1,
      anon_sym_DOT,
    STATE(1498), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404667] = 4,
    ACTIONS(10291), 1,
      anon_sym_in,
    ACTIONS(10293), 1,
      sym__phantom_in,
    ACTIONS(9571), 2,
      anon_sym_COMMA,
      anon_sym_EQ,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404685] = 2,
    ACTIONS(9541), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404699] = 2,
    ACTIONS(10295), 4,
      sym__phantom_arrow,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404713] = 2,
    ACTIONS(10297), 4,
      sym__cond_tight_dot,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404727] = 2,
    ACTIONS(10299), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404741] = 2,
    ACTIONS(10301), 4,
      sym__phantom_arrow,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404755] = 2,
    ACTIONS(10303), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404769] = 2,
    ACTIONS(10305), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404783] = 2,
    ACTIONS(10307), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404797] = 5,
    ACTIONS(7550), 1,
      sym_variable,
    ACTIONS(10309), 1,
      anon_sym_RBRACE,
    STATE(9990), 1,
      sym_field_name,
    STATE(11861), 1,
      sym_field,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404817] = 5,
    ACTIONS(7550), 1,
      sym_variable,
    ACTIONS(10311), 1,
      anon_sym_RBRACE,
    STATE(9990), 1,
      sym_field_name,
    STATE(11861), 1,
      sym_field,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404837] = 2,
    ACTIONS(10313), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404851] = 5,
    ACTIONS(10315), 1,
      anon_sym_SEMI,
    ACTIONS(10317), 1,
      sym__cond_layout_semicolon,
    STATE(3835), 1,
      aux_sym__let_binds_repeat1,
    STATE(10718), 1,
      aux_sym_imports_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404871] = 4,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    STATE(1046), 1,
      sym__dotdot,
    ACTIONS(10159), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404889] = 5,
    ACTIONS(2287), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(5548), 1,
      sym__unboxed_close,
    STATE(11132), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404909] = 2,
    ACTIONS(9656), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404923] = 2,
    ACTIONS(9658), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404937] = 5,
    ACTIONS(5823), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10319), 1,
      anon_sym_PIPE,
    ACTIONS(10322), 1,
      anon_sym_PIPE2,
    STATE(10248), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404957] = 4,
    ACTIONS(10325), 1,
      anon_sym_COMMA,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(6202), 2,
      aux_sym__paren_close_token1,
      anon_sym_POUND_RPAREN,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404975] = 2,
    ACTIONS(10328), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404989] = 2,
    ACTIONS(10283), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405003] = 4,
    ACTIONS(4650), 1,
      anon_sym_COMMA,
    STATE(10651), 1,
      aux_sym__var_binding_list_repeat1,
    ACTIONS(10285), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405021] = 4,
    ACTIONS(10330), 1,
      anon_sym_DOT,
    STATE(1555), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405039] = 2,
    ACTIONS(10332), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405053] = 5,
    ACTIONS(8490), 1,
      sym_name,
    ACTIONS(10334), 1,
      sym_variable,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405073] = 2,
    ACTIONS(7881), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405087] = 5,
    ACTIONS(249), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10085), 1,
      anon_sym_COMMA,
    STATE(6650), 1,
      sym__paren_close,
    STATE(11123), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405107] = 2,
    ACTIONS(10336), 4,
      sym__phantom_arrow,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405121] = 2,
    ACTIONS(10338), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405135] = 2,
    ACTIONS(6157), 4,
      sym__cond_context,
      sym__cond_infix,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405149] = 2,
    ACTIONS(10340), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405163] = 2,
    ACTIONS(10342), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405177] = 5,
    ACTIONS(1195), 1,
      anon_sym_RBRACK,
    ACTIONS(10344), 1,
      anon_sym_COMMA,
    STATE(6622), 1,
      sym__bracket_close,
    STATE(10794), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405197] = 2,
    ACTIONS(10346), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405211] = 2,
    ACTIONS(10348), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405225] = 2,
    ACTIONS(10350), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405239] = 2,
    ACTIONS(10352), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405253] = 2,
    ACTIONS(10354), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405267] = 2,
    ACTIONS(10356), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405281] = 5,
    ACTIONS(7550), 1,
      sym_variable,
    ACTIONS(10358), 1,
      anon_sym_RBRACE,
    STATE(9990), 1,
      sym_field_name,
    STATE(11861), 1,
      sym_field,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405301] = 5,
    ACTIONS(7550), 1,
      sym_variable,
    ACTIONS(10360), 1,
      anon_sym_RBRACE,
    STATE(9990), 1,
      sym_field_name,
    STATE(11861), 1,
      sym_field,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405321] = 2,
    ACTIONS(10362), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405335] = 4,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    STATE(1001), 1,
      sym__dotdot,
    ACTIONS(10159), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405353] = 4,
    ACTIONS(321), 1,
      sym__cond_tight_dot,
    ACTIONS(4616), 1,
      sym__cond_qual_dot,
    STATE(10227), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405371] = 5,
    ACTIONS(7282), 1,
      sym_name,
    ACTIONS(10364), 1,
      sym_variable,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405391] = 2,
    ACTIONS(10362), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405405] = 5,
    ACTIONS(6280), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10366), 1,
      anon_sym_COMMA,
    STATE(11138), 1,
      aux_sym_exports_repeat1,
    STATE(11942), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405425] = 5,
    ACTIONS(10368), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10370), 1,
      sym__cond_tight_dot,
    STATE(10278), 1,
      aux_sym__exp_projection_selector_repeat1,
    STATE(12469), 1,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405445] = 2,
    ACTIONS(10362), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405459] = 5,
    ACTIONS(6280), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10373), 1,
      anon_sym_COMMA,
    STATE(11138), 1,
      aux_sym_exports_repeat1,
    STATE(12053), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405479] = 2,
    ACTIONS(10362), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405493] = 3,
    ACTIONS(10377), 1,
      anon_sym_by,
    ACTIONS(10375), 3,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405509] = 4,
    ACTIONS(10379), 1,
      anon_sym_COMMA,
    STATE(10774), 1,
      aux_sym_qualifiers_repeat1,
    ACTIONS(10381), 2,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405527] = 2,
    ACTIONS(9750), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405541] = 2,
    ACTIONS(10383), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405555] = 2,
    ACTIONS(10383), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405569] = 2,
    ACTIONS(10385), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405583] = 4,
    ACTIONS(10387), 1,
      anon_sym_DOT,
    STATE(1633), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405601] = 3,
    ACTIONS(6882), 2,
      anon_sym__,
      sym_variable,
    ACTIONS(6884), 2,
      sym__cond_prefix_at,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405617] = 2,
    ACTIONS(10389), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405631] = 2,
    ACTIONS(10391), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405645] = 5,
    ACTIONS(6356), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10393), 1,
      anon_sym_COMMA,
    STATE(10796), 1,
      aux_sym_children_repeat1,
    STATE(12153), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405665] = 2,
    ACTIONS(10395), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405679] = 5,
    ACTIONS(6477), 1,
      sym__phantom_bar,
    ACTIONS(10397), 1,
      anon_sym_PIPE,
    STATE(10262), 1,
      sym_type_family_injectivity,
    STATE(12684), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405699] = 2,
    ACTIONS(10399), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405713] = 2,
    ACTIONS(10399), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405727] = 5,
    ACTIONS(6356), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10393), 1,
      anon_sym_COMMA,
    STATE(10824), 1,
      aux_sym_children_repeat1,
    STATE(12066), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405747] = 2,
    ACTIONS(10401), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405761] = 5,
    ACTIONS(10403), 1,
      sym_variable,
    ACTIONS(10405), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405781] = 2,
    ACTIONS(10407), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405795] = 2,
    ACTIONS(10409), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405809] = 5,
    ACTIONS(9343), 1,
      sym_name,
    ACTIONS(10411), 1,
      sym_variable,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405829] = 4,
    ACTIONS(10413), 1,
      anon_sym_DOT,
    STATE(9977), 1,
      sym__arrow,
    ACTIONS(10415), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405847] = 2,
    ACTIONS(10417), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405861] = 2,
    ACTIONS(10419), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405875] = 5,
    ACTIONS(2511), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(5338), 1,
      sym__unboxed_close,
    STATE(11132), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405895] = 2,
    ACTIONS(10421), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405909] = 2,
    ACTIONS(10419), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405923] = 4,
    ACTIONS(10423), 1,
      anon_sym_EQ,
    STATE(1722), 1,
      sym__colon2,
    ACTIONS(10425), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405941] = 5,
    ACTIONS(10427), 1,
      sym_variable,
    ACTIONS(10429), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405961] = 5,
    ACTIONS(10431), 1,
      sym_variable,
    ACTIONS(10433), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405981] = 2,
    ACTIONS(10435), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [405995] = 5,
    ACTIONS(10437), 1,
      sym_variable,
    ACTIONS(10439), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406015] = 5,
    ACTIONS(10441), 1,
      sym_variable,
    ACTIONS(10443), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406035] = 5,
    ACTIONS(10445), 1,
      sym_variable,
    ACTIONS(10447), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406055] = 2,
    ACTIONS(10449), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406069] = 5,
    ACTIONS(10451), 1,
      sym_variable,
    ACTIONS(10453), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406089] = 5,
    ACTIONS(10455), 1,
      sym_variable,
    ACTIONS(10457), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406109] = 2,
    ACTIONS(10459), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406123] = 5,
    ACTIONS(10461), 1,
      sym_variable,
    ACTIONS(10463), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406143] = 5,
    ACTIONS(2557), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(3542), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406163] = 5,
    ACTIONS(1513), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(3523), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406183] = 5,
    ACTIONS(10465), 1,
      sym_variable,
    ACTIONS(10467), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406203] = 5,
    ACTIONS(2239), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(2763), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406223] = 5,
    ACTIONS(1535), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(2764), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406243] = 5,
    ACTIONS(10469), 1,
      sym_variable,
    ACTIONS(10471), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406263] = 5,
    ACTIONS(2371), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(3260), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406283] = 5,
    ACTIONS(1501), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(3264), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406303] = 5,
    ACTIONS(10473), 1,
      sym_variable,
    ACTIONS(10475), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406323] = 5,
    ACTIONS(1505), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7006), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406343] = 2,
    ACTIONS(10421), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406357] = 5,
    ACTIONS(1279), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(2702), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406377] = 5,
    ACTIONS(3083), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6850), 1,
      sym__bracket_close,
    STATE(10349), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406397] = 5,
    ACTIONS(2099), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6971), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406417] = 5,
    ACTIONS(2081), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(2700), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406437] = 5,
    ACTIONS(1427), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6972), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406457] = 5,
    ACTIONS(10477), 1,
      sym_variable,
    ACTIONS(10479), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406477] = 5,
    ACTIONS(2557), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(3494), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406497] = 5,
    ACTIONS(7550), 1,
      sym_variable,
    ACTIONS(10481), 1,
      anon_sym_RBRACE,
    STATE(9990), 1,
      sym_field_name,
    STATE(11861), 1,
      sym_field,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406517] = 5,
    ACTIONS(2231), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(3129), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406537] = 5,
    ACTIONS(1449), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(3130), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406557] = 5,
    ACTIONS(10483), 1,
      sym_variable,
    ACTIONS(10485), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406577] = 5,
    ACTIONS(2239), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(2776), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406597] = 5,
    ACTIONS(3103), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3424), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406617] = 5,
    ACTIONS(2565), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7027), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406637] = 4,
    ACTIONS(10379), 1,
      anon_sym_COMMA,
    STATE(10283), 1,
      aux_sym_qualifiers_repeat1,
    ACTIONS(10487), 2,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406655] = 5,
    ACTIONS(3103), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3440), 1,
      sym__bracket_close,
    STATE(10344), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406675] = 4,
    ACTIONS(7502), 1,
      sym__cond_dotdot,
    STATE(984), 1,
      sym__dotdot,
    ACTIONS(10159), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406693] = 5,
    ACTIONS(3083), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7005), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406713] = 5,
    ACTIONS(2379), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(7004), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406733] = 5,
    ACTIONS(1477), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7029), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406753] = 5,
    ACTIONS(2197), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(5233), 1,
      sym__unboxed_close,
    STATE(11132), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406773] = 5,
    ACTIONS(1513), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3441), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406793] = 5,
    ACTIONS(9678), 1,
      sym_name,
    STATE(2255), 1,
      sym__qualified_consym,
    STATE(9892), 1,
      sym__modid_prefix,
    STATE(10015), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406813] = 5,
    ACTIONS(8122), 1,
      sym_name,
    ACTIONS(10489), 1,
      sym_variable,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406833] = 5,
    ACTIONS(2371), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(3412), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406853] = 5,
    ACTIONS(3101), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(2812), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406873] = 5,
    ACTIONS(277), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10085), 1,
      anon_sym_COMMA,
    STATE(7358), 1,
      sym__paren_close,
    STATE(11123), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406893] = 5,
    ACTIONS(2287), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(5014), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406913] = 4,
    ACTIONS(10491), 1,
      anon_sym_COMMA,
    STATE(10360), 1,
      aux_sym_field_repeat1,
    ACTIONS(10494), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406931] = 5,
    ACTIONS(3101), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(2815), 1,
      sym__bracket_close,
    STATE(10357), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406951] = 4,
    ACTIONS(10496), 1,
      anon_sym_COMMA,
    STATE(10362), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(10499), 2,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406969] = 2,
    ACTIONS(10501), 4,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
      anon_sym_RBRACK,
      anon_sym_POUND_RPAREN,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [406983] = 5,
    ACTIONS(1263), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(5064), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407003] = 5,
    ACTIONS(2081), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(2724), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407023] = 5,
    ACTIONS(1535), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(2816), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407043] = 5,
    ACTIONS(1213), 1,
      anon_sym_RBRACK,
    ACTIONS(10503), 1,
      anon_sym_COMMA,
    STATE(7337), 1,
      sym__bracket_close,
    STATE(10435), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407063] = 2,
    ACTIONS(3273), 4,
      sym__cond_context,
      sym__cond_infix,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407077] = 5,
    ACTIONS(2919), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(2723), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407097] = 5,
    ACTIONS(9238), 1,
      sym_name,
    ACTIONS(10505), 1,
      sym_variable,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407117] = 2,
    ACTIONS(3279), 4,
      sym__cond_context,
      sym__cond_infix,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407131] = 5,
    ACTIONS(8494), 1,
      sym_name,
    ACTIONS(10507), 1,
      sym_variable,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407151] = 2,
    ACTIONS(10509), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407165] = 4,
    ACTIONS(5465), 1,
      sym__cond_qual_dot,
    ACTIONS(5467), 1,
      sym__cond_tight_dot,
    STATE(9944), 2,
      sym__qual_dot,
      sym__tight_dot,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407183] = 5,
    ACTIONS(2099), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(6981), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407203] = 5,
    ACTIONS(3093), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3384), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407223] = 5,
    ACTIONS(2453), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(3205), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407243] = 5,
    ACTIONS(3093), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3375), 1,
      sym__bracket_close,
    STATE(10376), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407263] = 2,
    ACTIONS(10511), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407277] = 5,
    ACTIONS(1523), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(3208), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407297] = 2,
    ACTIONS(10513), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407311] = 5,
    ACTIONS(2197), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(5261), 1,
      sym__unboxed_close,
    STATE(10352), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407331] = 5,
    ACTIONS(1501), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3371), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407351] = 2,
    ACTIONS(10515), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407365] = 2,
    ACTIONS(10517), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407379] = 2,
    ACTIONS(10519), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407393] = 5,
    ACTIONS(10521), 1,
      sym_variable,
    ACTIONS(10523), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407413] = 2,
    ACTIONS(10525), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407427] = 2,
    ACTIONS(10527), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407441] = 5,
    ACTIONS(1489), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7526), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407461] = 2,
    ACTIONS(10529), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407475] = 5,
    ACTIONS(2231), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(3088), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407495] = 5,
    ACTIONS(3077), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6953), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407515] = 5,
    ACTIONS(249), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6058), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407535] = 5,
    ACTIONS(3047), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7530), 1,
      sym__bracket_close,
    STATE(10544), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407555] = 2,
    ACTIONS(10531), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407569] = 5,
    ACTIONS(10533), 1,
      sym_variable,
    ACTIONS(10535), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407589] = 5,
    ACTIONS(2363), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6716), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407609] = 5,
    ACTIONS(1277), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4301), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407629] = 5,
    ACTIONS(2197), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(5262), 1,
      sym__unboxed_close,
    STATE(11132), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407649] = 5,
    ACTIONS(1435), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6476), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407669] = 5,
    ACTIONS(2995), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4297), 1,
      sym__bracket_close,
    STATE(10417), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407689] = 5,
    ACTIONS(2849), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    STATE(5266), 1,
      sym__bracket_close,
    STATE(11166), 1,
      aux_sym__exp_list_comprehension_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407709] = 5,
    ACTIONS(2543), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6467), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407729] = 5,
    ACTIONS(2849), 1,
      anon_sym_RBRACK,
    ACTIONS(10537), 1,
      anon_sym_COMMA,
    STATE(5267), 1,
      sym__bracket_close,
    STATE(11171), 1,
      aux_sym__exp_list_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407749] = 5,
    ACTIONS(791), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6178), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407769] = 5,
    ACTIONS(3077), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6951), 1,
      sym__bracket_close,
    STATE(10393), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407789] = 5,
    ACTIONS(1551), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6714), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407809] = 5,
    ACTIONS(1427), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6950), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407829] = 2,
    ACTIONS(10539), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407843] = 5,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(10541), 1,
      anon_sym_import,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    STATE(11812), 1,
      sym_import,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407863] = 4,
    ACTIONS(10543), 1,
      anon_sym_DOT,
    STATE(1450), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407881] = 2,
    ACTIONS(10539), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407895] = 2,
    ACTIONS(10385), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407909] = 5,
    ACTIONS(10545), 1,
      sym_variable,
    ACTIONS(10547), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407929] = 5,
    ACTIONS(9678), 1,
      sym_name,
    STATE(2260), 1,
      sym__qualified_consym,
    STATE(9892), 1,
      sym__modid_prefix,
    STATE(10015), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407949] = 5,
    ACTIONS(2995), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4304), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407969] = 5,
    ACTIONS(2211), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(4287), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [407989] = 5,
    ACTIONS(2565), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(7171), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408009] = 5,
    ACTIONS(3073), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3141), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408029] = 2,
    ACTIONS(10549), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408043] = 5,
    ACTIONS(2263), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7544), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408063] = 5,
    ACTIONS(2919), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(2718), 1,
      sym__bracket_close,
    STATE(10369), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408083] = 2,
    ACTIONS(10529), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408097] = 5,
    ACTIONS(1489), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7488), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408117] = 5,
    ACTIONS(1279), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(2695), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408137] = 5,
    ACTIONS(2303), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(3280), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408157] = 5,
    ACTIONS(2995), 1,
      anon_sym_RBRACK,
    ACTIONS(10551), 1,
      anon_sym_COMMA,
    STATE(4983), 1,
      sym__bracket_close,
    STATE(11171), 1,
      aux_sym__exp_list_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408177] = 5,
    ACTIONS(8234), 1,
      sym_name,
    ACTIONS(10553), 1,
      sym_variable,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408197] = 5,
    ACTIONS(3073), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3140), 1,
      sym__bracket_close,
    STATE(10420), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408217] = 5,
    ACTIONS(1531), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(3299), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408237] = 2,
    ACTIONS(10555), 4,
      sym__cond_tight_dot,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408251] = 5,
    ACTIONS(1449), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3112), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408271] = 5,
    ACTIONS(2995), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    STATE(4982), 1,
      sym__bracket_close,
    STATE(11166), 1,
      aux_sym__exp_list_comprehension_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408291] = 5,
    ACTIONS(1213), 1,
      anon_sym_RBRACK,
    ACTIONS(10557), 1,
      anon_sym_COMMA,
    STATE(7238), 1,
      sym__bracket_close,
    STATE(10362), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408311] = 5,
    ACTIONS(2211), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(4976), 1,
      sym__unboxed_close,
    STATE(11132), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408331] = 5,
    ACTIONS(1269), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4355), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408351] = 5,
    ACTIONS(649), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9529), 1,
      anon_sym_COMMA,
    STATE(7244), 1,
      sym__unboxed_close,
    STATE(11018), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408371] = 5,
    ACTIONS(2211), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(4974), 1,
      sym__unboxed_close,
    STATE(10499), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408391] = 5,
    ACTIONS(8900), 1,
      sym_name,
    ACTIONS(10559), 1,
      sym_variable,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408411] = 5,
    ACTIONS(2887), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4356), 1,
      sym__bracket_close,
    STATE(10741), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408431] = 2,
    ACTIONS(10539), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408445] = 5,
    ACTIONS(2511), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(4412), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408465] = 2,
    ACTIONS(10539), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408479] = 5,
    ACTIONS(2287), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(4960), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408499] = 2,
    ACTIONS(10561), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408513] = 5,
    ACTIONS(2975), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7191), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408533] = 5,
    ACTIONS(2279), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(3423), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408553] = 5,
    ACTIONS(2975), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7188), 1,
      sym__bracket_close,
    STATE(10447), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408573] = 5,
    ACTIONS(1527), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(3425), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408593] = 5,
    ACTIONS(1477), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7187), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408613] = 2,
    ACTIONS(10563), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408627] = 2,
    ACTIONS(10565), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408641] = 2,
    ACTIONS(10567), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408655] = 2,
    ACTIONS(10565), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408669] = 5,
    ACTIONS(1249), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4183), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408689] = 2,
    ACTIONS(10569), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408703] = 5,
    ACTIONS(1411), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6902), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408723] = 5,
    ACTIONS(2857), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4186), 1,
      sym__bracket_close,
    STATE(10474), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408743] = 5,
    ACTIONS(9028), 1,
      sym_name,
    ACTIONS(10571), 1,
      sym_variable,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408763] = 5,
    ACTIONS(2039), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6898), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408783] = 4,
    ACTIONS(10573), 1,
      sym__phantom_arrow,
    STATE(12482), 1,
      sym__arrow,
    ACTIONS(10073), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408801] = 2,
    ACTIONS(10575), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408815] = 2,
    ACTIONS(10575), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408829] = 2,
    ACTIONS(10577), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408843] = 5,
    ACTIONS(2453), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(3186), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408863] = 5,
    ACTIONS(2969), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4883), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408883] = 2,
    ACTIONS(10579), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408897] = 2,
    ACTIONS(10581), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408911] = 5,
    ACTIONS(2247), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(3692), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408931] = 2,
    ACTIONS(10583), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408945] = 5,
    ACTIONS(2969), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4888), 1,
      sym__bracket_close,
    STATE(10467), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408965] = 2,
    ACTIONS(10585), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408979] = 5,
    ACTIONS(2857), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4210), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [408999] = 5,
    ACTIONS(2347), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(4215), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409019] = 5,
    ACTIONS(1255), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(3691), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409039] = 2,
    ACTIONS(10587), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409053] = 5,
    ACTIONS(1263), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4889), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409073] = 5,
    ACTIONS(2263), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(7553), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409093] = 2,
    ACTIONS(10589), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409107] = 2,
    ACTIONS(10581), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409121] = 2,
    ACTIONS(10591), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409135] = 2,
    ACTIONS(10587), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409149] = 5,
    ACTIONS(10593), 1,
      sym_variable,
    ACTIONS(10595), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409169] = 5,
    ACTIONS(10597), 1,
      sym_variable,
    ACTIONS(10599), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409189] = 4,
    ACTIONS(5689), 1,
      anon_sym_COMMA,
    STATE(10699), 1,
      aux_sym__con_binding_list_repeat1,
    ACTIONS(10601), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409207] = 4,
    ACTIONS(5689), 1,
      anon_sym_COMMA,
    STATE(10699), 1,
      aux_sym__con_binding_list_repeat1,
    ACTIONS(10603), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409225] = 2,
    ACTIONS(10605), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409239] = 4,
    ACTIONS(9644), 1,
      sym_name,
    STATE(9072), 1,
      sym_module,
    STATE(10924), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409257] = 5,
    ACTIONS(2363), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(6848), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409277] = 5,
    ACTIONS(3035), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3324), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409297] = 5,
    ACTIONS(2181), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6499), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409317] = 5,
    ACTIONS(3035), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3326), 1,
      sym__bracket_close,
    STATE(10491), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409337] = 5,
    ACTIONS(1395), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6500), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409357] = 2,
    ACTIONS(10607), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409371] = 5,
    ACTIONS(1523), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3332), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409391] = 4,
    ACTIONS(9644), 1,
      sym_name,
    STATE(9662), 1,
      sym_module,
    STATE(10924), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409409] = 2,
    ACTIONS(10609), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409423] = 5,
    ACTIONS(2211), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(4940), 1,
      sym__unboxed_close,
    STATE(11132), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409443] = 4,
    ACTIONS(9644), 1,
      sym_name,
    STATE(9592), 1,
      sym_module,
    STATE(10924), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409461] = 5,
    ACTIONS(1269), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(4407), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409481] = 5,
    ACTIONS(10611), 1,
      sym_variable,
    ACTIONS(10613), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409501] = 5,
    ACTIONS(6477), 1,
      sym__phantom_bar,
    ACTIONS(10397), 1,
      anon_sym_PIPE,
    STATE(10267), 1,
      sym_type_family_injectivity,
    STATE(12684), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409521] = 5,
    ACTIONS(2303), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(3321), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409541] = 5,
    ACTIONS(3033), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6825), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409561] = 5,
    ACTIONS(6477), 1,
      sym__phantom_bar,
    ACTIONS(10397), 1,
      anon_sym_PIPE,
    STATE(10290), 1,
      sym_type_family_injectivity,
    STATE(12684), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409581] = 5,
    ACTIONS(6477), 1,
      sym__phantom_bar,
    ACTIONS(10397), 1,
      anon_sym_PIPE,
    STATE(10312), 1,
      sym_type_family_injectivity,
    STATE(12684), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409601] = 5,
    ACTIONS(2119), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(5816), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409621] = 2,
    ACTIONS(10615), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409635] = 5,
    ACTIONS(3033), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6822), 1,
      sym__bracket_close,
    STATE(10505), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409655] = 5,
    ACTIONS(1295), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4031), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409675] = 5,
    ACTIONS(1485), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(5815), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409695] = 5,
    ACTIONS(1505), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6867), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409715] = 5,
    ACTIONS(2859), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4037), 1,
      sym__bracket_close,
    STATE(10529), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409735] = 5,
    ACTIONS(1551), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6821), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409755] = 5,
    ACTIONS(2379), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6863), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409775] = 2,
    ACTIONS(10617), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409789] = 2,
    ACTIONS(10619), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409803] = 2,
    ACTIONS(10621), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409817] = 5,
    ACTIONS(10623), 1,
      sym_variable,
    ACTIONS(10625), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409837] = 2,
    ACTIONS(10627), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409851] = 2,
    ACTIONS(10629), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409865] = 2,
    ACTIONS(10631), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409879] = 2,
    ACTIONS(10633), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409893] = 2,
    ACTIONS(10635), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409907] = 2,
    ACTIONS(10637), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409921] = 2,
    ACTIONS(10639), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409935] = 5,
    ACTIONS(2279), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(3461), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409955] = 5,
    ACTIONS(2859), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4071), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409975] = 5,
    ACTIONS(2023), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(4171), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [409995] = 5,
    ACTIONS(3031), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3401), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410015] = 2,
    ACTIONS(10641), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410029] = 5,
    ACTIONS(2071), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(2323), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410049] = 2,
    ACTIONS(10643), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410063] = 5,
    ACTIONS(3031), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3405), 1,
      sym__bracket_close,
    STATE(10531), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410083] = 5,
    ACTIONS(2983), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10645), 1,
      anon_sym_COMMA,
    STATE(10103), 1,
      sym__paren_close,
    STATE(10964), 1,
      aux_sym_default_types_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410103] = 2,
    ACTIONS(10647), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410117] = 5,
    ACTIONS(1457), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(2328), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410137] = 5,
    ACTIONS(1531), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3407), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410157] = 5,
    ACTIONS(10649), 1,
      sym_variable,
    ACTIONS(10651), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410177] = 2,
    ACTIONS(10653), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410191] = 2,
    ACTIONS(10643), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410205] = 2,
    ACTIONS(10653), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410219] = 5,
    ACTIONS(3047), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7500), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410239] = 2,
    ACTIONS(10655), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410253] = 2,
    ACTIONS(10657), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410267] = 2,
    ACTIONS(10659), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410281] = 2,
    ACTIONS(10661), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410295] = 2,
    ACTIONS(10663), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410309] = 2,
    ACTIONS(10665), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410323] = 2,
    ACTIONS(10667), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410337] = 2,
    ACTIONS(10669), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410351] = 5,
    ACTIONS(10671), 1,
      sym_variable,
    ACTIONS(10673), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410371] = 2,
    ACTIONS(10675), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410385] = 2,
    ACTIONS(10677), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410399] = 5,
    ACTIONS(2247), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(3802), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410419] = 5,
    ACTIONS(3029), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3444), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410439] = 2,
    ACTIONS(10679), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410453] = 5,
    ACTIONS(2331), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(4635), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410473] = 5,
    ACTIONS(3029), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3467), 1,
      sym__bracket_close,
    STATE(10557), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410493] = 5,
    ACTIONS(1275), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(4619), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410513] = 5,
    ACTIONS(1527), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3468), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410533] = 2,
    ACTIONS(10681), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410547] = 5,
    ACTIONS(10683), 1,
      sym_variable,
    ACTIONS(10685), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410567] = 2,
    ACTIONS(10687), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410581] = 5,
    ACTIONS(1567), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4931), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410601] = 5,
    ACTIONS(7550), 1,
      sym_variable,
    ACTIONS(10689), 1,
      anon_sym_RBRACE,
    STATE(9990), 1,
      sym_field_name,
    STATE(11861), 1,
      sym_field,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410621] = 5,
    ACTIONS(1277), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(4280), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410641] = 5,
    ACTIONS(2895), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4932), 1,
      sym__bracket_close,
    STATE(10584), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410661] = 5,
    ACTIONS(2181), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(6412), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410681] = 5,
    ACTIONS(2211), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(4250), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410701] = 5,
    ACTIONS(2985), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3749), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410721] = 5,
    ACTIONS(2197), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(4646), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410741] = 5,
    ACTIONS(2985), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3748), 1,
      sym__bracket_close,
    STATE(10572), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410761] = 5,
    ACTIONS(1257), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(4647), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410781] = 5,
    ACTIONS(1255), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3747), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410801] = 5,
    ACTIONS(2107), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(4510), 1,
      sym__unboxed_close,
    STATE(11132), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410821] = 5,
    ACTIONS(9288), 1,
      sym_name,
    ACTIONS(10691), 1,
      sym_variable,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410841] = 5,
    ACTIONS(2983), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10645), 1,
      anon_sym_COMMA,
    STATE(10536), 1,
      aux_sym_default_types_repeat1,
    STATE(10537), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410861] = 2,
    ACTIONS(10693), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410875] = 5,
    ACTIONS(8798), 1,
      sym_name,
    ACTIONS(10695), 1,
      sym_variable,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410895] = 5,
    ACTIONS(2119), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(5831), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410915] = 5,
    ACTIONS(3019), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6238), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410935] = 5,
    ACTIONS(2895), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4944), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410955] = 5,
    ACTIONS(2431), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(4945), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410975] = 5,
    ACTIONS(2271), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6373), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [410995] = 5,
    ACTIONS(2013), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(7434), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411015] = 5,
    ACTIONS(3019), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6241), 1,
      sym__bracket_close,
    STATE(10583), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411035] = 5,
    ACTIONS(3095), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7435), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411055] = 5,
    ACTIONS(1415), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6370), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411075] = 5,
    ACTIONS(1395), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6243), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411095] = 2,
    ACTIONS(10697), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411109] = 2,
    ACTIONS(10699), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411123] = 2,
    ACTIONS(10701), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411137] = 5,
    ACTIONS(10703), 1,
      sym_variable,
    ACTIONS(10705), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411157] = 2,
    ACTIONS(10707), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411171] = 5,
    ACTIONS(2107), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(4571), 1,
      sym__unboxed_close,
    STATE(10577), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411191] = 5,
    ACTIONS(2107), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(4572), 1,
      sym__unboxed_close,
    STATE(11132), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411211] = 5,
    ACTIONS(2819), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    STATE(4577), 1,
      sym__bracket_close,
    STATE(11166), 1,
      aux_sym__exp_list_comprehension_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411231] = 5,
    ACTIONS(2819), 1,
      anon_sym_RBRACK,
    ACTIONS(10709), 1,
      anon_sym_COMMA,
    STATE(4579), 1,
      sym__bracket_close,
    STATE(11171), 1,
      aux_sym__exp_list_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411251] = 5,
    ACTIONS(10711), 1,
      sym_variable,
    ACTIONS(10713), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411271] = 2,
    ACTIONS(10715), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411285] = 2,
    ACTIONS(10707), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411299] = 5,
    ACTIONS(2071), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(2325), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411319] = 5,
    ACTIONS(2999), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(5843), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411339] = 2,
    ACTIONS(10717), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411353] = 5,
    ACTIONS(2339), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7388), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411373] = 5,
    ACTIONS(3095), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7446), 1,
      sym__bracket_close,
    STATE(10589), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411393] = 5,
    ACTIONS(1443), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7255), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411413] = 5,
    ACTIONS(2519), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7242), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411433] = 2,
    ACTIONS(10715), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411447] = 5,
    ACTIONS(1559), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7448), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411467] = 5,
    ACTIONS(2999), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(5844), 1,
      sym__bracket_close,
    STATE(10605), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411487] = 5,
    ACTIONS(1469), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7239), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411507] = 5,
    ACTIONS(1485), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(5847), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411527] = 5,
    ACTIONS(9678), 1,
      sym_name,
    STATE(2290), 1,
      sym__qualified_consym,
    STATE(9892), 1,
      sym__modid_prefix,
    STATE(10015), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411547] = 5,
    ACTIONS(10719), 1,
      sym_variable,
    ACTIONS(10721), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411567] = 2,
    ACTIONS(10723), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411581] = 2,
    ACTIONS(10725), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411595] = 5,
    ACTIONS(283), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10085), 1,
      anon_sym_COMMA,
    STATE(6752), 1,
      sym__paren_close,
    STATE(11123), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411615] = 5,
    ACTIONS(1423), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7582), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411635] = 2,
    ACTIONS(10727), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411649] = 5,
    ACTIONS(283), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6207), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411669] = 5,
    ACTIONS(2861), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7564), 1,
      sym__bracket_close,
    STATE(10639), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411689] = 2,
    ACTIONS(10699), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411703] = 5,
    ACTIONS(839), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6194), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411723] = 5,
    ACTIONS(2331), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(4406), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411743] = 5,
    ACTIONS(2997), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(2314), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411763] = 5,
    ACTIONS(1215), 1,
      anon_sym_RBRACK,
    ACTIONS(10729), 1,
      anon_sym_COMMA,
    STATE(6753), 1,
      sym__bracket_close,
    STATE(10695), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411783] = 5,
    ACTIONS(2493), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7774), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411803] = 5,
    ACTIONS(2997), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(2312), 1,
      sym__bracket_close,
    STATE(10628), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411823] = 5,
    ACTIONS(1497), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7726), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411843] = 5,
    ACTIONS(1457), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(2308), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411863] = 2,
    ACTIONS(10731), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411877] = 2,
    ACTIONS(10733), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411891] = 2,
    ACTIONS(10735), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411905] = 2,
    ACTIONS(10737), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411919] = 2,
    ACTIONS(10739), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411933] = 5,
    ACTIONS(2861), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7567), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411953] = 5,
    ACTIONS(2223), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(7598), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411973] = 5,
    ACTIONS(10741), 1,
      sym_variable,
    ACTIONS(10743), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [411993] = 5,
    ACTIONS(2197), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(4323), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412013] = 5,
    ACTIONS(2881), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4392), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412033] = 5,
    ACTIONS(2485), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6287), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412053] = 5,
    ACTIONS(1493), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3919), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412073] = 5,
    ACTIONS(2881), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4391), 1,
      sym__bracket_close,
    STATE(10643), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412093] = 5,
    ACTIONS(1543), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6285), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412113] = 5,
    ACTIONS(1275), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4390), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412133] = 5,
    ACTIONS(10745), 1,
      sym_variable,
    ACTIONS(10747), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412153] = 2,
    ACTIONS(10749), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412167] = 4,
    ACTIONS(10751), 1,
      anon_sym_COMMA,
    STATE(10651), 1,
      aux_sym__var_binding_list_repeat1,
    ACTIONS(10754), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412185] = 5,
    ACTIONS(6336), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10756), 1,
      anon_sym_COMMA,
    STATE(10050), 1,
      aux_sym_import_list_repeat1,
    STATE(11420), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412205] = 5,
    ACTIONS(277), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7431), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412225] = 5,
    ACTIONS(10758), 1,
      sym_variable,
    ACTIONS(10760), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412245] = 2,
    ACTIONS(10762), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412259] = 5,
    ACTIONS(2863), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3913), 1,
      sym__bracket_close,
    STATE(10726), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412279] = 3,
    ACTIONS(7322), 1,
      sym_name,
    ACTIONS(7320), 3,
      anon_sym_mdo,
      anon_sym_do,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412295] = 5,
    ACTIONS(649), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7484), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412315] = 5,
    ACTIONS(2271), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(6505), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412335] = 5,
    ACTIONS(2849), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4482), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412355] = 5,
    ACTIONS(2395), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6054), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412375] = 2,
    ACTIONS(10764), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412389] = 4,
    ACTIONS(9644), 1,
      sym_name,
    STATE(9649), 1,
      sym_module,
    STATE(10924), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412407] = 5,
    ACTIONS(2849), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4679), 1,
      sym__bracket_close,
    STATE(10660), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412427] = 5,
    ACTIONS(1539), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6048), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412447] = 5,
    ACTIONS(1257), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4692), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412467] = 3,
    ACTIONS(7326), 1,
      sym_name,
    ACTIONS(7324), 3,
      anon_sym_mdo,
      anon_sym_do,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412483] = 2,
    ACTIONS(10766), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412497] = 5,
    ACTIONS(10768), 1,
      sym_variable,
    ACTIONS(10770), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412517] = 2,
    ACTIONS(10772), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412531] = 5,
    ACTIONS(9678), 1,
      sym_name,
    STATE(2277), 1,
      sym__qualified_consym,
    STATE(9892), 1,
      sym__modid_prefix,
    STATE(10015), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412551] = 5,
    ACTIONS(2519), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(7351), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412571] = 5,
    ACTIONS(2979), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6561), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412591] = 2,
    ACTIONS(10774), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412605] = 5,
    ACTIONS(1555), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7071), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412625] = 4,
    ACTIONS(9644), 1,
      sym_name,
    STATE(9648), 1,
      sym_module,
    STATE(10924), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412643] = 5,
    ACTIONS(1249), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(4168), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412663] = 5,
    ACTIONS(3037), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7073), 1,
      sym__bracket_close,
    STATE(10693), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412683] = 2,
    ACTIONS(10687), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412697] = 5,
    ACTIONS(2347), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(4164), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412717] = 2,
    ACTIONS(10776), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412731] = 2,
    ACTIONS(10778), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412745] = 5,
    ACTIONS(2091), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(3398), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412765] = 2,
    ACTIONS(10780), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412779] = 5,
    ACTIONS(2979), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6558), 1,
      sym__bracket_close,
    STATE(10673), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412799] = 5,
    ACTIONS(1465), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(3396), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412819] = 5,
    ACTIONS(1415), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6557), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412839] = 4,
    ACTIONS(9644), 1,
      sym_name,
    STATE(9642), 1,
      sym_module,
    STATE(10924), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412857] = 5,
    ACTIONS(2857), 1,
      anon_sym_RBRACK,
    ACTIONS(10782), 1,
      anon_sym_COMMA,
    STATE(4756), 1,
      sym__bracket_close,
    STATE(11171), 1,
      aux_sym__exp_list_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412877] = 2,
    ACTIONS(10784), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412891] = 5,
    ACTIONS(10786), 1,
      sym_variable,
    ACTIONS(10788), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412911] = 5,
    ACTIONS(2857), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    STATE(4755), 1,
      sym__bracket_close,
    STATE(11166), 1,
      aux_sym__exp_list_comprehension_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412931] = 5,
    ACTIONS(3037), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7095), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412951] = 5,
    ACTIONS(2413), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(7112), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412971] = 5,
    ACTIONS(1215), 1,
      anon_sym_RBRACK,
    ACTIONS(10790), 1,
      anon_sym_COMMA,
    STATE(6758), 1,
      sym__bracket_close,
    STATE(10362), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [412991] = 2,
    ACTIONS(10792), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413005] = 5,
    ACTIONS(2347), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(4753), 1,
      sym__unboxed_close,
    STATE(11132), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413025] = 5,
    ACTIONS(839), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9529), 1,
      anon_sym_COMMA,
    STATE(6760), 1,
      sym__unboxed_close,
    STATE(11018), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413045] = 4,
    ACTIONS(10794), 1,
      anon_sym_COMMA,
    STATE(10699), 1,
      aux_sym__con_binding_list_repeat1,
    ACTIONS(10797), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413063] = 5,
    ACTIONS(2347), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(4746), 1,
      sym__unboxed_close,
    STATE(10755), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413083] = 5,
    ACTIONS(10799), 1,
      sym_variable,
    ACTIONS(10801), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413103] = 2,
    ACTIONS(10803), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413117] = 5,
    ACTIONS(10805), 1,
      sym_variable,
    ACTIONS(10807), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413137] = 2,
    ACTIONS(10809), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413151] = 2,
    ACTIONS(10811), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413165] = 5,
    ACTIONS(2493), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(7746), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413185] = 5,
    ACTIONS(2943), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7252), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413205] = 2,
    ACTIONS(10813), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413219] = 2,
    ACTIONS(10815), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413233] = 5,
    ACTIONS(2147), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6065), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413253] = 5,
    ACTIONS(2943), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7251), 1,
      sym__bracket_close,
    STATE(10707), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413273] = 5,
    ACTIONS(1431), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6063), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413293] = 5,
    ACTIONS(1469), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7249), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413313] = 5,
    ACTIONS(9678), 1,
      sym_name,
    STATE(2262), 1,
      sym__qualified_consym,
    STATE(9892), 1,
      sym__modid_prefix,
    STATE(10015), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413333] = 2,
    ACTIONS(10817), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413347] = 2,
    ACTIONS(10819), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413361] = 2,
    ACTIONS(10821), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413375] = 5,
    ACTIONS(10823), 1,
      anon_sym_SEMI,
    ACTIONS(10826), 1,
      sym__cond_layout_semicolon,
    STATE(10411), 1,
      aux_sym__let_binds_repeat1,
    STATE(10718), 1,
      aux_sym_imports_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413395] = 2,
    ACTIONS(9758), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413409] = 2,
    ACTIONS(10829), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413423] = 2,
    ACTIONS(10831), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413437] = 5,
    ACTIONS(2485), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(6436), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413457] = 2,
    ACTIONS(10833), 4,
      sym__cond_tight_dot,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413471] = 5,
    ACTIONS(2901), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7773), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413491] = 5,
    ACTIONS(1519), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7628), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413511] = 5,
    ACTIONS(2863), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3841), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413531] = 5,
    ACTIONS(1295), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(4094), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413551] = 5,
    ACTIONS(3023), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7626), 1,
      sym__bracket_close,
    STATE(10743), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413571] = 5,
    ACTIONS(2387), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(3825), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413591] = 5,
    ACTIONS(2023), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(4092), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413611] = 5,
    ACTIONS(2189), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6801), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413631] = 5,
    ACTIONS(2901), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7780), 1,
      sym__bracket_close,
    STATE(10724), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413651] = 5,
    ACTIONS(1439), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6798), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413671] = 5,
    ACTIONS(1497), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7781), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413691] = 2,
    ACTIONS(10835), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413705] = 2,
    ACTIONS(10837), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413719] = 2,
    ACTIONS(10839), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413733] = 2,
    ACTIONS(10841), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413747] = 5,
    ACTIONS(10843), 1,
      sym_variable,
    ACTIONS(10845), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413767] = 5,
    ACTIONS(2511), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(4360), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413787] = 5,
    ACTIONS(2887), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4362), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413807] = 2,
    ACTIONS(10847), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413821] = 5,
    ACTIONS(3023), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(7632), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413841] = 5,
    ACTIONS(2527), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(7622), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413861] = 2,
    ACTIONS(10849), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413875] = 5,
    ACTIONS(2395), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(5984), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413895] = 2,
    ACTIONS(10851), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413909] = 5,
    ACTIONS(2897), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6372), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413929] = 2,
    ACTIONS(10853), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413943] = 2,
    ACTIONS(10855), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413957] = 5,
    ACTIONS(10857), 1,
      sym_variable,
    ACTIONS(10859), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413977] = 5,
    ACTIONS(2355), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(5974), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [413997] = 2,
    ACTIONS(10861), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414011] = 2,
    ACTIONS(10863), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414025] = 5,
    ACTIONS(2347), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(4714), 1,
      sym__unboxed_close,
    STATE(11132), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414045] = 2,
    ACTIONS(10865), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414059] = 5,
    ACTIONS(2897), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6369), 1,
      sym__bracket_close,
    STATE(10748), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414079] = 2,
    ACTIONS(10867), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414093] = 5,
    ACTIONS(1563), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(5972), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414113] = 5,
    ACTIONS(1543), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6368), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414133] = 5,
    ACTIONS(10869), 1,
      sym_variable,
    ACTIONS(10871), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414153] = 5,
    ACTIONS(6477), 1,
      sym__phantom_bar,
    ACTIONS(10397), 1,
      anon_sym_PIPE,
    STATE(10482), 1,
      sym_type_family_injectivity,
    STATE(12684), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414173] = 5,
    ACTIONS(6477), 1,
      sym__phantom_bar,
    ACTIONS(10397), 1,
      anon_sym_PIPE,
    STATE(10498), 1,
      sym_type_family_injectivity,
    STATE(12684), 1,
      sym__bar,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414193] = 5,
    ACTIONS(2091), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(3297), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414213] = 5,
    ACTIONS(2893), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6039), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414233] = 2,
    ACTIONS(10873), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414247] = 5,
    ACTIONS(2107), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(4002), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414267] = 5,
    ACTIONS(2893), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6042), 1,
      sym__bracket_close,
    STATE(10765), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414287] = 5,
    ACTIONS(1289), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(4016), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414307] = 5,
    ACTIONS(1539), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6044), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414327] = 2,
    ACTIONS(10875), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414341] = 2,
    ACTIONS(10877), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414355] = 5,
    ACTIONS(1461), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6642), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414375] = 4,
    ACTIONS(10879), 1,
      anon_sym_COMMA,
    STATE(10774), 1,
      aux_sym_qualifiers_repeat1,
    ACTIONS(10882), 2,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414393] = 5,
    ACTIONS(1567), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(5098), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414413] = 5,
    ACTIONS(2865), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6615), 1,
      sym__bracket_close,
    STATE(10790), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414433] = 2,
    ACTIONS(10884), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414447] = 5,
    ACTIONS(2431), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(5095), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414467] = 5,
    ACTIONS(10886), 1,
      sym_variable,
    ACTIONS(10888), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414487] = 2,
    ACTIONS(10890), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414501] = 5,
    ACTIONS(2887), 1,
      anon_sym_RBRACK,
    ACTIONS(10892), 1,
      anon_sym_COMMA,
    STATE(5299), 1,
      sym__bracket_close,
    STATE(11171), 1,
      aux_sym__exp_list_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414521] = 2,
    ACTIONS(10894), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414535] = 2,
    ACTIONS(10896), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414549] = 5,
    ACTIONS(2147), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(6105), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414569] = 5,
    ACTIONS(2885), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3247), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414589] = 2,
    ACTIONS(10898), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414603] = 5,
    ACTIONS(2535), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(5889), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414623] = 5,
    ACTIONS(2885), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3245), 1,
      sym__bracket_close,
    STATE(10785), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414643] = 5,
    ACTIONS(1509), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(5887), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414663] = 5,
    ACTIONS(2865), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6626), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414683] = 5,
    ACTIONS(2439), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(6624), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414703] = 5,
    ACTIONS(1465), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(3244), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414723] = 5,
    ACTIONS(2887), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    STATE(5304), 1,
      sym__bracket_close,
    STATE(11166), 1,
      aux_sym__exp_list_comprehension_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414743] = 5,
    ACTIONS(1195), 1,
      anon_sym_RBRACK,
    ACTIONS(10900), 1,
      anon_sym_COMMA,
    STATE(6627), 1,
      sym__bracket_close,
    STATE(10362), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414763] = 5,
    ACTIONS(2023), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(4689), 1,
      sym__unboxed_close,
    STATE(11132), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414783] = 5,
    ACTIONS(6356), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10393), 1,
      anon_sym_COMMA,
    STATE(11309), 1,
      aux_sym_children_repeat1,
    STATE(11439), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414803] = 5,
    ACTIONS(2511), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(5306), 1,
      sym__unboxed_close,
    STATE(11132), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414823] = 5,
    ACTIONS(8642), 1,
      sym_name,
    ACTIONS(10902), 1,
      sym_variable,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414843] = 5,
    ACTIONS(10364), 1,
      sym_variable,
    ACTIONS(10904), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414863] = 5,
    ACTIONS(10906), 1,
      sym_variable,
    ACTIONS(10908), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414883] = 5,
    ACTIONS(791), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9529), 1,
      anon_sym_COMMA,
    STATE(6646), 1,
      sym__unboxed_close,
    STATE(11018), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414903] = 4,
    ACTIONS(10910), 1,
      anon_sym_DOT,
    STATE(1372), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414921] = 5,
    ACTIONS(2189), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(6839), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414941] = 5,
    ACTIONS(2875), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6168), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414961] = 2,
    ACTIONS(10912), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414975] = 5,
    ACTIONS(8908), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7951), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [414995] = 5,
    ACTIONS(2875), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6167), 1,
      sym__bracket_close,
    STATE(10804), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415015] = 5,
    ACTIONS(3501), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7952), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415035] = 5,
    ACTIONS(1431), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6166), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415055] = 2,
    ACTIONS(10914), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415069] = 5,
    ACTIONS(2511), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(5307), 1,
      sym__unboxed_close,
    STATE(10306), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415089] = 2,
    ACTIONS(10916), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415103] = 2,
    ACTIONS(10918), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415117] = 5,
    ACTIONS(10920), 1,
      sym_variable,
    ACTIONS(10922), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415137] = 2,
    ACTIONS(10924), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415151] = 4,
    ACTIONS(10926), 1,
      sym_name,
    STATE(12163), 1,
      sym_module,
    STATE(11299), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415169] = 5,
    ACTIONS(839), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(6235), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415189] = 5,
    ACTIONS(1509), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(5943), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415209] = 2,
    ACTIONS(10928), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415223] = 5,
    ACTIONS(289), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7186), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415243] = 5,
    ACTIONS(2993), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6037), 1,
      sym__bracket_close,
    STATE(10835), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415263] = 5,
    ACTIONS(2867), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6817), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415283] = 5,
    ACTIONS(877), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7184), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415303] = 5,
    ACTIONS(6356), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10393), 1,
      anon_sym_COMMA,
    STATE(11309), 1,
      aux_sym_children_repeat1,
    STATE(12095), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415323] = 5,
    ACTIONS(2439), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6602), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415343] = 5,
    ACTIONS(2867), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6813), 1,
      sym__bracket_close,
    STATE(10822), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415363] = 5,
    ACTIONS(1461), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(6607), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415383] = 2,
    ACTIONS(4598), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415397] = 5,
    ACTIONS(1439), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6811), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415417] = 5,
    ACTIONS(9678), 1,
      sym_name,
    STATE(2300), 1,
      sym__qualified_consym,
    STATE(9892), 1,
      sym__modid_prefix,
    STATE(10015), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415437] = 5,
    ACTIONS(10364), 1,
      sym_variable,
    ACTIONS(10930), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415457] = 5,
    ACTIONS(2255), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(6572), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415477] = 5,
    ACTIONS(2977), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6382), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415497] = 5,
    ACTIONS(6280), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10932), 1,
      anon_sym_COMMA,
    STATE(10280), 1,
      aux_sym_exports_repeat1,
    STATE(12193), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415517] = 5,
    ACTIONS(2993), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(5977), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415537] = 5,
    ACTIONS(2663), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(9115), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415557] = 5,
    ACTIONS(289), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10085), 1,
      anon_sym_COMMA,
    STATE(7067), 1,
      sym__paren_close,
    STATE(11123), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415577] = 5,
    ACTIONS(10934), 1,
      sym_variable,
    ACTIONS(10936), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415597] = 5,
    ACTIONS(6280), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10938), 1,
      anon_sym_COMMA,
    STATE(10277), 1,
      aux_sym_exports_repeat1,
    STATE(12160), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415617] = 5,
    ACTIONS(2355), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(6046), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415637] = 5,
    ACTIONS(1215), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6295), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415657] = 5,
    ACTIONS(1193), 1,
      anon_sym_RBRACK,
    ACTIONS(10940), 1,
      anon_sym_COMMA,
    STATE(7068), 1,
      sym__bracket_close,
    STATE(10869), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415677] = 5,
    ACTIONS(9002), 1,
      sym_name,
    ACTIONS(10942), 1,
      sym_variable,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415697] = 5,
    ACTIONS(2527), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7678), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415717] = 5,
    ACTIONS(1215), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6300), 1,
      sym__bracket_close,
    STATE(10841), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415737] = 2,
    ACTIONS(10944), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415751] = 2,
    ACTIONS(10946), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415765] = 2,
    ACTIONS(10948), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415779] = 5,
    ACTIONS(1519), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7680), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415799] = 5,
    ACTIONS(283), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6301), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415819] = 2,
    ACTIONS(10950), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415833] = 2,
    ACTIONS(10952), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415847] = 5,
    ACTIONS(8656), 1,
      sym_name,
    ACTIONS(10954), 1,
      sym_variable,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415867] = 5,
    ACTIONS(2107), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(4095), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415887] = 5,
    ACTIONS(3025), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(5994), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415907] = 2,
    ACTIONS(10956), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415921] = 5,
    ACTIONS(2413), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7087), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415941] = 5,
    ACTIONS(3025), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(5990), 1,
      sym__bracket_close,
    STATE(10855), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415961] = 5,
    ACTIONS(1555), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7096), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415981] = 5,
    ACTIONS(2023), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(4434), 1,
      sym__unboxed_close,
    STATE(10795), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416001] = 5,
    ACTIONS(877), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(9529), 1,
      anon_sym_COMMA,
    STATE(7077), 1,
      sym__unboxed_close,
    STATE(11018), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416021] = 5,
    ACTIONS(1563), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(5989), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416041] = 5,
    ACTIONS(1289), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4045), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416061] = 2,
    ACTIONS(10958), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416075] = 5,
    ACTIONS(1423), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7586), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416095] = 5,
    ACTIONS(2819), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4044), 1,
      sym__bracket_close,
    STATE(10880), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416115] = 5,
    ACTIONS(2023), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(7668), 1,
      anon_sym_COMMA,
    STATE(4433), 1,
      sym__unboxed_close,
    STATE(11132), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416135] = 5,
    ACTIONS(2223), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(7562), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416155] = 5,
    ACTIONS(1193), 1,
      anon_sym_RBRACK,
    ACTIONS(10960), 1,
      anon_sym_COMMA,
    STATE(7075), 1,
      sym__bracket_close,
    STATE(10362), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416175] = 5,
    ACTIONS(1473), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6569), 1,
      sym__paren_close,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416195] = 5,
    ACTIONS(3411), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(8006), 1,
      sym__paren_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416215] = 5,
    ACTIONS(2859), 1,
      anon_sym_RBRACK,
    ACTIONS(7498), 1,
      anon_sym_PIPE,
    STATE(4430), 1,
      sym__bracket_close,
    STATE(11166), 1,
      aux_sym__exp_list_comprehension_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416235] = 2,
    ACTIONS(7540), 4,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416249] = 2,
    ACTIONS(7516), 4,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416263] = 2,
    ACTIONS(7540), 4,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416277] = 2,
    ACTIONS(7516), 4,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416291] = 2,
    ACTIONS(7516), 4,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416305] = 2,
    ACTIONS(7516), 4,
      anon_sym_EQ,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416319] = 5,
    ACTIONS(2977), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(6570), 1,
      sym__bracket_close,
    STATE(10833), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416339] = 5,
    ACTIONS(2819), 1,
      anon_sym_RBRACK,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(4057), 1,
      sym__bracket_close,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416359] = 5,
    ACTIONS(2535), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(8130), 1,
      anon_sym_COMMA,
    STATE(5933), 1,
      sym__unboxed_close,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416379] = 5,
    ACTIONS(2859), 1,
      anon_sym_RBRACK,
    ACTIONS(10962), 1,
      anon_sym_COMMA,
    STATE(4427), 1,
      sym__bracket_close,
    STATE(11171), 1,
      aux_sym__exp_list_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416399] = 5,
    ACTIONS(8316), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(8009), 1,
      sym__unboxed_close,
    STATE(10249), 1,
      aux_sym__exp_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416419] = 2,
    ACTIONS(10964), 4,
      sym__cond_layout_semicolon,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416433] = 5,
    ACTIONS(9678), 1,
      sym_name,
    STATE(2297), 1,
      sym__qualified_consym,
    STATE(9892), 1,
      sym__modid_prefix,
    STATE(10015), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416453] = 5,
    ACTIONS(10966), 1,
      sym_variable,
    ACTIONS(10968), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416473] = 4,
    ACTIONS(10613), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416490] = 4,
    ACTIONS(1263), 1,
      aux_sym__paren_close_token1,
    ACTIONS(9473), 1,
      anon_sym_COMMA,
    STATE(5047), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416507] = 4,
    ACTIONS(10970), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416524] = 2,
    ACTIONS(5203), 3,
      sym__cond_layout_end,
      sym__phantom_bar,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416537] = 2,
    ACTIONS(4849), 3,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416550] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(10972), 1,
      anon_sym_else,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416567] = 3,
    ACTIONS(10976), 1,
      sym_quasiquote_body,
    ACTIONS(10974), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416582] = 4,
    ACTIONS(10845), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416599] = 3,
    ACTIONS(10980), 1,
      sym_quasiquote_body,
    ACTIONS(10978), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416614] = 2,
    ACTIONS(6157), 3,
      sym__cond_infix,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416627] = 3,
    ACTIONS(5802), 1,
      aux_sym__paren_close_token1,
    ACTIONS(10982), 2,
      anon_sym_POUND2,
      anon_sym_PIPE2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416642] = 2,
    ACTIONS(7941), 3,
      sym__phantom_arrow,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416655] = 2,
    ACTIONS(7939), 3,
      sym__phantom_arrow,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416668] = 2,
    ACTIONS(7937), 3,
      sym__phantom_arrow,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416681] = 2,
    ACTIONS(7931), 3,
      sym__phantom_arrow,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416694] = 2,
    ACTIONS(7905), 3,
      sym__phantom_arrow,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416707] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(10984), 1,
      anon_sym_then,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416724] = 4,
    ACTIONS(10986), 1,
      anon_sym_SEMI,
    ACTIONS(10988), 1,
      anon_sym_then,
    STATE(10903), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416741] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(10990), 1,
      anon_sym_then,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416758] = 4,
    ACTIONS(10992), 1,
      anon_sym_SEMI,
    ACTIONS(10994), 1,
      anon_sym_else,
    STATE(10948), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416775] = 4,
    ACTIONS(10996), 1,
      anon_sym_SEMI,
    ACTIONS(10998), 1,
      anon_sym_then,
    STATE(10905), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416792] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11000), 1,
      anon_sym_then,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416809] = 4,
    ACTIONS(11002), 1,
      anon_sym_SEMI,
    ACTIONS(11004), 1,
      anon_sym_then,
    STATE(10908), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416826] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11006), 1,
      anon_sym_then,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416843] = 2,
    ACTIONS(7963), 3,
      sym__phantom_arrow,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416856] = 4,
    ACTIONS(11008), 1,
      anon_sym_SEMI,
    ACTIONS(11010), 1,
      anon_sym_then,
    STATE(10910), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416873] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11012), 1,
      anon_sym_then,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416890] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11469), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416907] = 4,
    ACTIONS(11014), 1,
      anon_sym_SEMI,
    ACTIONS(11016), 1,
      anon_sym_then,
    STATE(10913), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416924] = 3,
    ACTIONS(11020), 1,
      sym_quasiquote_body,
    ACTIONS(11018), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416939] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11022), 1,
      anon_sym_then,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416956] = 4,
    ACTIONS(11024), 1,
      anon_sym_SEMI,
    ACTIONS(11026), 1,
      anon_sym_then,
    STATE(10917), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416973] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11028), 1,
      anon_sym_then,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [416990] = 4,
    ACTIONS(11030), 1,
      anon_sym_SEMI,
    ACTIONS(11032), 1,
      anon_sym_then,
    STATE(10919), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417007] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11034), 1,
      anon_sym_then,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417024] = 4,
    ACTIONS(11036), 1,
      anon_sym_SEMI,
    ACTIONS(11038), 1,
      anon_sym_then,
    STATE(10921), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417041] = 3,
    STATE(2948), 1,
      sym__statements,
    ACTIONS(11040), 2,
      sym__cmd_layout_start_do,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417056] = 3,
    ACTIONS(11042), 1,
      sym_name,
    STATE(11102), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417071] = 4,
    ACTIONS(10705), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417088] = 3,
    STATE(12234), 1,
      sym__arrow,
    ACTIONS(10073), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417103] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11044), 1,
      anon_sym_then,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417120] = 3,
    STATE(1303), 1,
      sym__arrow,
    ACTIONS(7514), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417135] = 3,
    STATE(1321), 1,
      sym__arrow,
    ACTIONS(7514), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417150] = 4,
    ACTIONS(10788), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417167] = 3,
    ACTIONS(11048), 1,
      sym_quasiquote_body,
    ACTIONS(11046), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417182] = 4,
    ACTIONS(11050), 1,
      anon_sym_SEMI,
    ACTIONS(11052), 1,
      anon_sym_then,
    STATE(10927), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417199] = 4,
    ACTIONS(11054), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417216] = 4,
    ACTIONS(11056), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417233] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11475), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417250] = 4,
    ACTIONS(11058), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417267] = 3,
    STATE(5174), 1,
      sym__statements,
    ACTIONS(11060), 2,
      sym__cmd_layout_start_do,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417282] = 3,
    STATE(12275), 1,
      sym__layout_end,
    ACTIONS(11062), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417297] = 4,
    ACTIONS(10039), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417314] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11554), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417331] = 3,
    STATE(1462), 1,
      sym__colon2,
    ACTIONS(11064), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417346] = 3,
    STATE(1641), 1,
      sym__colon2,
    ACTIONS(11066), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417361] = 3,
    STATE(4202), 1,
      sym__statements,
    ACTIONS(11068), 2,
      sym__cmd_layout_start_do,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417376] = 3,
    STATE(1656), 1,
      sym__colon2,
    ACTIONS(11070), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417391] = 3,
    STATE(1720), 1,
      sym__colon2,
    ACTIONS(11072), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417406] = 3,
    ACTIONS(11074), 1,
      sym_name,
    STATE(11102), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417421] = 3,
    STATE(1679), 1,
      sym__colon2,
    ACTIONS(11076), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417436] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11078), 1,
      anon_sym_else,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417453] = 4,
    ACTIONS(11080), 1,
      anon_sym_SEMI,
    ACTIONS(11082), 1,
      anon_sym_else,
    STATE(10971), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417470] = 3,
    STATE(1420), 1,
      sym__colon2,
    ACTIONS(11084), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417485] = 3,
    STATE(12543), 1,
      sym__layout_end,
    ACTIONS(11086), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417500] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11526), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417517] = 3,
    STATE(1528), 1,
      sym__colon2,
    ACTIONS(11088), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417532] = 4,
    ACTIONS(10888), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417549] = 2,
    ACTIONS(7813), 3,
      sym__cond_layout_end,
      sym__phantom_bar,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417562] = 3,
    STATE(1745), 1,
      sym__colon2,
    ACTIONS(11090), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417577] = 4,
    ACTIONS(11092), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417594] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11477), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417611] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11562), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417628] = 3,
    ACTIONS(11096), 1,
      sym_quasiquote_body,
    ACTIONS(11094), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417643] = 3,
    ACTIONS(11100), 1,
      sym_quasiquote_body,
    ACTIONS(11098), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417658] = 3,
    STATE(1753), 1,
      sym__colon2,
    ACTIONS(11102), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417673] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11583), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417690] = 4,
    ACTIONS(11104), 1,
      anon_sym_COMMA,
    ACTIONS(11107), 1,
      aux_sym__paren_close_token1,
    STATE(10964), 1,
      aux_sym_default_types_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417707] = 3,
    STATE(1731), 1,
      sym__colon2,
    ACTIONS(11109), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417722] = 4,
    ACTIONS(11111), 1,
      anon_sym_SEMI,
    ACTIONS(11113), 1,
      anon_sym_else,
    STATE(11244), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417739] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11115), 1,
      anon_sym_else,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417756] = 4,
    ACTIONS(11117), 1,
      anon_sym_SEMI,
    ACTIONS(11119), 1,
      anon_sym_else,
    STATE(10892), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417773] = 3,
    STATE(1711), 1,
      sym__colon2,
    ACTIONS(11121), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417788] = 2,
    ACTIONS(11123), 3,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417801] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11125), 1,
      anon_sym_else,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417818] = 4,
    ACTIONS(11127), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417835] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11129), 1,
      anon_sym_else,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417852] = 3,
    STATE(1695), 1,
      sym__colon2,
    ACTIONS(11131), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417867] = 4,
    ACTIONS(1269), 1,
      aux_sym__paren_close_token1,
    ACTIONS(9473), 1,
      anon_sym_COMMA,
    STATE(4350), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417884] = 4,
    ACTIONS(11133), 1,
      anon_sym_SEMI,
    ACTIONS(11135), 1,
      anon_sym_else,
    STATE(11082), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417901] = 4,
    ACTIONS(10801), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417918] = 3,
    STATE(1667), 1,
      sym__colon2,
    ACTIONS(11137), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417933] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10238), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417950] = 3,
    STATE(1634), 1,
      sym__colon2,
    ACTIONS(11139), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417965] = 3,
    STATE(1244), 1,
      sym__larrow,
    ACTIONS(11141), 2,
      anon_sym_LT_DASH,
      anon_sym_u2190,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417980] = 4,
    ACTIONS(11143), 1,
      anon_sym_COMMA,
    ACTIONS(11145), 1,
      anon_sym_RBRACE,
    STATE(11195), 1,
      aux_sym__exp_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [417997] = 4,
    ACTIONS(11143), 1,
      anon_sym_COMMA,
    ACTIONS(11147), 1,
      anon_sym_RBRACE,
    STATE(10982), 1,
      aux_sym__exp_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418014] = 3,
    ACTIONS(11149), 1,
      anon_sym_PIPE,
    ACTIONS(11151), 2,
      anon_sym_PIPE2,
      anon_sym_POUND_RPAREN,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418029] = 3,
    STATE(5518), 1,
      sym__statements,
    ACTIONS(11153), 2,
      sym__cmd_layout_start_do,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418044] = 3,
    STATE(1483), 1,
      sym__colon2,
    ACTIONS(11155), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418059] = 4,
    ACTIONS(11157), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418076] = 4,
    ACTIONS(11159), 1,
      anon_sym_SEMI,
    ACTIONS(11161), 1,
      anon_sym_else,
    STATE(10973), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418093] = 2,
    ACTIONS(6360), 3,
      sym__cond_infix,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418106] = 3,
    STATE(1191), 1,
      sym__arrow,
    ACTIONS(7514), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418121] = 4,
    ACTIONS(10747), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418138] = 4,
    ACTIONS(11143), 1,
      anon_sym_COMMA,
    ACTIONS(11163), 1,
      anon_sym_RBRACE,
    STATE(11195), 1,
      aux_sym__exp_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418155] = 3,
    ACTIONS(11167), 1,
      sym_quasiquote_body,
    ACTIONS(11165), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418170] = 3,
    STATE(7936), 1,
      sym__arrow,
    ACTIONS(4570), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418185] = 4,
    ACTIONS(11143), 1,
      anon_sym_COMMA,
    ACTIONS(11169), 1,
      anon_sym_RBRACE,
    STATE(10992), 1,
      aux_sym__exp_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418202] = 3,
    ACTIONS(11173), 1,
      sym_quasiquote_body,
    ACTIONS(11171), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418217] = 4,
    ACTIONS(11175), 1,
      sym_variable,
    STATE(9416), 1,
      sym_fundep,
    STATE(9774), 1,
      aux_sym_type_family_injectivity_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418234] = 3,
    ACTIONS(11179), 1,
      sym_quasiquote_body,
    ACTIONS(11177), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418249] = 2,
    ACTIONS(3245), 3,
      sym__cond_infix,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418262] = 4,
    ACTIONS(11181), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418279] = 3,
    ACTIONS(11185), 1,
      sym_quasiquote_body,
    ACTIONS(11183), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418294] = 3,
    STATE(1497), 1,
      sym__colon2,
    ACTIONS(11187), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418309] = 4,
    ACTIONS(11189), 1,
      anon_sym_SEMI,
    ACTIONS(11191), 1,
      anon_sym_else,
    STATE(11028), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418326] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10199), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418343] = 4,
    ACTIONS(11143), 1,
      anon_sym_COMMA,
    ACTIONS(11193), 1,
      anon_sym_RBRACE,
    STATE(11195), 1,
      aux_sym__exp_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418360] = 2,
    ACTIONS(11195), 3,
      sym_variable,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418373] = 4,
    ACTIONS(11143), 1,
      anon_sym_COMMA,
    ACTIONS(11197), 1,
      anon_sym_RBRACE,
    STATE(11005), 1,
      aux_sym__exp_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418390] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10197), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418407] = 4,
    ACTIONS(11199), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418424] = 3,
    STATE(1189), 1,
      sym__arrow,
    ACTIONS(7514), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418439] = 2,
    ACTIONS(11201), 3,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
      ts_builtin_sym_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418452] = 4,
    ACTIONS(10405), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418469] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10192), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418486] = 4,
    ACTIONS(10770), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418503] = 4,
    ACTIONS(11203), 1,
      anon_sym_SEMI,
    ACTIONS(11205), 1,
      anon_sym_then,
    STATE(11237), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418520] = 3,
    STATE(1562), 1,
      sym__colon2,
    ACTIONS(11207), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418535] = 3,
    STATE(1402), 1,
      sym__colon2,
    ACTIONS(11209), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418550] = 4,
    ACTIONS(10499), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(11211), 1,
      anon_sym_COMMA,
    STATE(11018), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418567] = 4,
    ACTIONS(11143), 1,
      anon_sym_COMMA,
    ACTIONS(11214), 1,
      anon_sym_RBRACE,
    STATE(11195), 1,
      aux_sym__exp_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418584] = 4,
    ACTIONS(11143), 1,
      anon_sym_COMMA,
    ACTIONS(11216), 1,
      anon_sym_RBRACE,
    STATE(11019), 1,
      aux_sym__exp_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418601] = 2,
    ACTIONS(10297), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418614] = 3,
    STATE(1475), 1,
      sym__colon2,
    ACTIONS(11218), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418629] = 4,
    ACTIONS(1257), 1,
      aux_sym__paren_close_token1,
    ACTIONS(9473), 1,
      anon_sym_COMMA,
    STATE(4661), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418646] = 4,
    ACTIONS(1275), 1,
      aux_sym__paren_close_token1,
    ACTIONS(9473), 1,
      anon_sym_COMMA,
    STATE(4338), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418663] = 4,
    ACTIONS(11143), 1,
      anon_sym_COMMA,
    ACTIONS(11220), 1,
      anon_sym_RBRACE,
    STATE(11195), 1,
      aux_sym__exp_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418680] = 4,
    ACTIONS(11143), 1,
      anon_sym_COMMA,
    ACTIONS(11222), 1,
      anon_sym_RBRACE,
    STATE(11025), 1,
      aux_sym__exp_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418697] = 4,
    ACTIONS(10176), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(11224), 1,
      anon_sym_COMMA,
    STATE(11027), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418714] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11227), 1,
      anon_sym_else,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418731] = 4,
    ACTIONS(11229), 1,
      anon_sym_SEMI,
    ACTIONS(11231), 1,
      anon_sym_else,
    STATE(11044), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418748] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10155), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418765] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10154), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418782] = 3,
    STATE(1582), 1,
      sym__colon2,
    ACTIONS(11233), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418797] = 4,
    ACTIONS(11235), 1,
      anon_sym_COMMA,
    ACTIONS(11237), 1,
      anon_sym_RBRACE,
    STATE(11276), 1,
      aux_sym__record_fields_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418814] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10150), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418831] = 3,
    ACTIONS(11241), 1,
      sym_quasiquote_body,
    ACTIONS(11239), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418846] = 4,
    ACTIONS(10904), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418863] = 4,
    ACTIONS(8494), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418880] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10143), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418897] = 3,
    STATE(1213), 1,
      sym__arrow,
    ACTIONS(7514), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418912] = 4,
    ACTIONS(9947), 1,
      anon_sym_EQ,
    ACTIONS(11243), 1,
      anon_sym_COMMA,
    STATE(11222), 1,
      aux_sym_guards_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418929] = 4,
    ACTIONS(11245), 1,
      anon_sym_COMMA,
    ACTIONS(11247), 1,
      anon_sym_RBRACE,
    STATE(11159), 1,
      aux_sym__pat_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418946] = 4,
    ACTIONS(11143), 1,
      anon_sym_COMMA,
    ACTIONS(11249), 1,
      anon_sym_RBRACE,
    STATE(11195), 1,
      aux_sym__exp_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418963] = 4,
    ACTIONS(11251), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418980] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11253), 1,
      anon_sym_else,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418997] = 4,
    ACTIONS(11245), 1,
      anon_sym_COMMA,
    ACTIONS(11255), 1,
      anon_sym_RBRACE,
    STATE(11041), 1,
      aux_sym__pat_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419014] = 4,
    ACTIONS(11257), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419031] = 4,
    ACTIONS(11259), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419048] = 4,
    ACTIONS(11143), 1,
      anon_sym_COMMA,
    ACTIONS(11261), 1,
      anon_sym_RBRACE,
    STATE(11042), 1,
      aux_sym__exp_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419065] = 3,
    ACTIONS(11265), 1,
      sym_quasiquote_body,
    ACTIONS(11263), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419080] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10118), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419097] = 4,
    ACTIONS(10760), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419114] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10072), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419131] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10142), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419148] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10101), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419165] = 3,
    STATE(1688), 1,
      sym__colon2,
    ACTIONS(11267), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419180] = 4,
    ACTIONS(11269), 1,
      anon_sym_COMMA,
    ACTIONS(11272), 1,
      aux_sym__paren_close_token1,
    STATE(11056), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419197] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10094), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419214] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10090), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419231] = 4,
    ACTIONS(11245), 1,
      anon_sym_COMMA,
    ACTIONS(11274), 1,
      anon_sym_RBRACE,
    STATE(11159), 1,
      aux_sym__pat_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419248] = 4,
    ACTIONS(11143), 1,
      anon_sym_COMMA,
    ACTIONS(11276), 1,
      anon_sym_RBRACE,
    STATE(11195), 1,
      aux_sym__exp_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419265] = 4,
    ACTIONS(11245), 1,
      anon_sym_COMMA,
    ACTIONS(11278), 1,
      anon_sym_RBRACE,
    STATE(11159), 1,
      aux_sym__pat_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419282] = 4,
    ACTIONS(11245), 1,
      anon_sym_COMMA,
    ACTIONS(11280), 1,
      anon_sym_RBRACE,
    STATE(11059), 1,
      aux_sym__pat_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419299] = 4,
    ACTIONS(11143), 1,
      anon_sym_COMMA,
    ACTIONS(11282), 1,
      anon_sym_RBRACE,
    STATE(11060), 1,
      aux_sym__exp_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419316] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10088), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419333] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7864), 1,
      sym__paren_open,
    STATE(10085), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419350] = 4,
    ACTIONS(11143), 1,
      anon_sym_COMMA,
    ACTIONS(11284), 1,
      anon_sym_RBRACE,
    STATE(11195), 1,
      aux_sym__exp_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419367] = 2,
    ACTIONS(10555), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419380] = 3,
    STATE(4307), 1,
      sym__statements,
    ACTIONS(11286), 2,
      sym__cmd_layout_start_do,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419395] = 3,
    STATE(1494), 1,
      sym__colon2,
    ACTIONS(11288), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419410] = 4,
    ACTIONS(11290), 1,
      anon_sym_SEMI,
    ACTIONS(11292), 1,
      anon_sym_else,
    STATE(11095), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419427] = 2,
    ACTIONS(11294), 3,
      sym__phantom_arrow,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419440] = 3,
    ACTIONS(11298), 1,
      sym_quasiquote_body,
    ACTIONS(11296), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419455] = 4,
    ACTIONS(11300), 1,
      anon_sym_COMMA,
    ACTIONS(11302), 1,
      anon_sym_RBRACE,
    STATE(11158), 1,
      aux_sym__record_fields_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419472] = 4,
    ACTIONS(11304), 1,
      anon_sym_COMMA,
    ACTIONS(11306), 1,
      anon_sym_RBRACE,
    STATE(11073), 1,
      aux_sym__record_fields_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419489] = 4,
    ACTIONS(11245), 1,
      anon_sym_COMMA,
    ACTIONS(11308), 1,
      anon_sym_RBRACE,
    STATE(11159), 1,
      aux_sym__pat_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419506] = 4,
    ACTIONS(11143), 1,
      anon_sym_COMMA,
    ACTIONS(11310), 1,
      anon_sym_RBRACE,
    STATE(11195), 1,
      aux_sym__exp_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419523] = 3,
    STATE(12486), 1,
      sym__layout_end,
    ACTIONS(11312), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419538] = 4,
    ACTIONS(10651), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419555] = 3,
    ACTIONS(11316), 1,
      sym_quasiquote_body,
    ACTIONS(11314), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419570] = 4,
    ACTIONS(11245), 1,
      anon_sym_COMMA,
    ACTIONS(11318), 1,
      anon_sym_RBRACE,
    STATE(11075), 1,
      aux_sym__pat_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419587] = 4,
    ACTIONS(11143), 1,
      anon_sym_COMMA,
    ACTIONS(11320), 1,
      anon_sym_RBRACE,
    STATE(11076), 1,
      aux_sym__exp_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419604] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11322), 1,
      anon_sym_else,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419621] = 4,
    ACTIONS(11324), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419638] = 4,
    ACTIONS(11326), 1,
      anon_sym_SEMI,
    ACTIONS(11328), 1,
      anon_sym_else,
    STATE(11155), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419655] = 4,
    ACTIONS(2753), 1,
      anon_sym_COMMA,
    ACTIONS(11330), 1,
      aux_sym__paren_close_token1,
    STATE(11177), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419672] = 3,
    STATE(1280), 1,
      sym__arrow,
    ACTIONS(7514), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419687] = 2,
    ACTIONS(8086), 3,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
      ts_builtin_sym_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419700] = 4,
    ACTIONS(10743), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419717] = 3,
    STATE(10846), 1,
      sym__layout_end,
    ACTIONS(11332), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419732] = 3,
    STATE(1551), 1,
      sym__colon2,
    ACTIONS(11334), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419747] = 4,
    ACTIONS(11336), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419764] = 2,
    ACTIONS(3279), 3,
      sym__cond_infix,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419777] = 2,
    ACTIONS(3273), 3,
      sym__cond_infix,
      sym_name,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419790] = 3,
    STATE(5469), 1,
      sym__statements,
    ACTIONS(11338), 2,
      sym__cmd_layout_start_do,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419805] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11340), 1,
      anon_sym_else,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419822] = 4,
    ACTIONS(11342), 1,
      anon_sym_SEMI,
    ACTIONS(11344), 1,
      anon_sym_else,
    STATE(11112), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419839] = 4,
    ACTIONS(7550), 1,
      sym_variable,
    STATE(9990), 1,
      sym_field_name,
    STATE(11861), 1,
      sym_field,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419856] = 4,
    ACTIONS(2753), 1,
      anon_sym_COMMA,
    ACTIONS(11346), 1,
      aux_sym__paren_close_token1,
    STATE(11056), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419873] = 4,
    ACTIONS(9547), 1,
      sym__phantom_where,
    ACTIONS(11348), 1,
      anon_sym_where,
    STATE(11011), 1,
      sym__where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419890] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11350), 1,
      anon_sym_else,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419907] = 2,
    ACTIONS(11352), 3,
      sym__cmd_layout_start,
      sym__cmd_layout_start_explicit,
      ts_builtin_sym_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419920] = 3,
    ACTIONS(11354), 1,
      sym_name,
    STATE(11102), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419935] = 3,
    STATE(12578), 1,
      sym__layout_end,
    ACTIONS(11357), 2,
      sym__cond_layout_end,
      sym__cond_layout_end_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419950] = 4,
    ACTIONS(11359), 1,
      anon_sym_COMMA,
    ACTIONS(11361), 1,
      anon_sym_RBRACE,
    STATE(11158), 1,
      aux_sym__record_fields_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419967] = 4,
    ACTIONS(11363), 1,
      anon_sym_COMMA,
    ACTIONS(11365), 1,
      anon_sym_RBRACE,
    STATE(11104), 1,
      aux_sym__record_fields_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419984] = 3,
    STATE(12081), 1,
      sym__arrow,
    ACTIONS(1381), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [419999] = 4,
    ACTIONS(11245), 1,
      anon_sym_COMMA,
    ACTIONS(11367), 1,
      anon_sym_RBRACE,
    STATE(11159), 1,
      aux_sym__pat_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420016] = 4,
    ACTIONS(11143), 1,
      anon_sym_COMMA,
    ACTIONS(11369), 1,
      anon_sym_RBRACE,
    STATE(11195), 1,
      aux_sym__exp_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420033] = 3,
    ACTIONS(11373), 1,
      sym_quasiquote_body,
    ACTIONS(11371), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420048] = 4,
    ACTIONS(11245), 1,
      anon_sym_COMMA,
    ACTIONS(11375), 1,
      anon_sym_RBRACE,
    STATE(11107), 1,
      aux_sym__pat_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420065] = 4,
    ACTIONS(11143), 1,
      anon_sym_COMMA,
    ACTIONS(11377), 1,
      anon_sym_RBRACE,
    STATE(11108), 1,
      aux_sym__exp_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420082] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11379), 1,
      anon_sym_else,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420099] = 4,
    ACTIONS(11381), 1,
      anon_sym_SEMI,
    ACTIONS(11383), 1,
      anon_sym_else,
    STATE(11100), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420116] = 2,
    ACTIONS(11385), 3,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420129] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11387), 1,
      anon_sym_else,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420146] = 3,
    STATE(379), 1,
      sym__arrow,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420161] = 3,
    STATE(1660), 1,
      sym__colon2,
    ACTIONS(11389), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420176] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11391), 1,
      anon_sym_else,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420193] = 2,
    ACTIONS(11393), 3,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420206] = 4,
    ACTIONS(11395), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420223] = 3,
    STATE(5017), 1,
      sym__statements,
    ACTIONS(11397), 2,
      sym__cmd_layout_start_do,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420238] = 3,
    ACTIONS(11399), 1,
      sym_name,
    STATE(11102), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420253] = 4,
    ACTIONS(10085), 1,
      anon_sym_COMMA,
    ACTIONS(11401), 1,
      aux_sym__paren_close_token1,
    STATE(10362), 1,
      aux_sym__pat_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420270] = 4,
    ACTIONS(11403), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420287] = 4,
    ACTIONS(9002), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420304] = 4,
    ACTIONS(11405), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420321] = 4,
    ACTIONS(10807), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420338] = 3,
    STATE(1222), 1,
      sym__arrow,
    ACTIONS(7514), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420353] = 3,
    ACTIONS(11409), 1,
      sym_quasiquote_body,
    ACTIONS(11407), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420368] = 4,
    ACTIONS(10535), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420385] = 3,
    ACTIONS(11413), 1,
      sym_quasiquote_body,
    ACTIONS(11411), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420400] = 4,
    ACTIONS(11272), 1,
      anon_sym_POUND_RPAREN,
    ACTIONS(11415), 1,
      anon_sym_COMMA,
    STATE(11132), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420417] = 3,
    ACTIONS(11420), 1,
      sym_quasiquote_body,
    ACTIONS(11418), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420432] = 3,
    ACTIONS(11424), 1,
      sym_quasiquote_body,
    ACTIONS(11422), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420447] = 4,
    ACTIONS(11426), 1,
      anon_sym_SEMI,
    ACTIONS(11428), 1,
      anon_sym_else,
    STATE(11118), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420464] = 3,
    ACTIONS(11432), 1,
      sym_quasiquote_body,
    ACTIONS(11430), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420479] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11434), 1,
      anon_sym_else,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420496] = 4,
    ACTIONS(11436), 1,
      anon_sym_COMMA,
    ACTIONS(11439), 1,
      aux_sym__paren_close_token1,
    STATE(11138), 1,
      aux_sym_exports_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420513] = 3,
    ACTIONS(11443), 1,
      sym_quasiquote_body,
    ACTIONS(11441), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420528] = 4,
    ACTIONS(11445), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420545] = 4,
    ACTIONS(9322), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420562] = 3,
    ACTIONS(11449), 1,
      sym_quasiquote_body,
    ACTIONS(11447), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420577] = 4,
    ACTIONS(11451), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420594] = 4,
    ACTIONS(10429), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420611] = 4,
    ACTIONS(11453), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420628] = 3,
    ACTIONS(11457), 1,
      sym_quasiquote_body,
    ACTIONS(11455), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420643] = 2,
    ACTIONS(11459), 3,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
      anon_sym_POUND_RPAREN,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420656] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(11461), 1,
      aux_sym__paren_close_token1,
    STATE(10129), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420673] = 3,
    ACTIONS(11465), 1,
      sym_quasiquote_body,
    ACTIONS(11463), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420688] = 4,
    ACTIONS(10433), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420705] = 4,
    ACTIONS(11467), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420722] = 3,
    ACTIONS(11471), 1,
      sym_quasiquote_body,
    ACTIONS(11469), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420737] = 4,
    ACTIONS(10439), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420754] = 4,
    ACTIONS(11473), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420771] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11475), 1,
      anon_sym_else,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420788] = 3,
    ACTIONS(11479), 1,
      sym_quasiquote_body,
    ACTIONS(11477), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420803] = 4,
    ACTIONS(11481), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420820] = 4,
    ACTIONS(11483), 1,
      anon_sym_COMMA,
    ACTIONS(11486), 1,
      anon_sym_RBRACE,
    STATE(11158), 1,
      aux_sym__record_fields_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420837] = 4,
    ACTIONS(11488), 1,
      anon_sym_COMMA,
    ACTIONS(11491), 1,
      anon_sym_RBRACE,
    STATE(11159), 1,
      aux_sym__pat_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420854] = 4,
    ACTIONS(10443), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420871] = 4,
    ACTIONS(11493), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420888] = 4,
    ACTIONS(10721), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420905] = 3,
    ACTIONS(11497), 1,
      sym_quasiquote_body,
    ACTIONS(11495), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420920] = 4,
    ACTIONS(10447), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420937] = 4,
    ACTIONS(11499), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420954] = 4,
    ACTIONS(11501), 1,
      anon_sym_PIPE,
    ACTIONS(11504), 1,
      anon_sym_RBRACK,
    STATE(11166), 1,
      aux_sym__exp_list_comprehension_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420971] = 3,
    ACTIONS(11508), 1,
      sym_quasiquote_body,
    ACTIONS(11506), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [420986] = 3,
    ACTIONS(11512), 1,
      sym_quasiquote_body,
    ACTIONS(11510), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421001] = 4,
    ACTIONS(10453), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421018] = 4,
    ACTIONS(11514), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421035] = 4,
    ACTIONS(11516), 1,
      anon_sym_COMMA,
    ACTIONS(11519), 1,
      anon_sym_RBRACK,
    STATE(11171), 1,
      aux_sym__exp_list_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421052] = 2,
    ACTIONS(11521), 3,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421065] = 3,
    ACTIONS(11525), 1,
      sym_quasiquote_body,
    ACTIONS(11523), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421080] = 2,
    ACTIONS(11527), 3,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421093] = 4,
    ACTIONS(8122), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421110] = 3,
    ACTIONS(11531), 1,
      sym_quasiquote_body,
    ACTIONS(11529), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421125] = 4,
    ACTIONS(2753), 1,
      anon_sym_COMMA,
    ACTIONS(11533), 1,
      aux_sym__paren_close_token1,
    STATE(11056), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421142] = 4,
    ACTIONS(11535), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421159] = 4,
    ACTIONS(11537), 1,
      anon_sym_SEMI,
    ACTIONS(11539), 1,
      anon_sym_else,
    STATE(11115), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421176] = 3,
    ACTIONS(11543), 1,
      sym_quasiquote_body,
    ACTIONS(11541), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421191] = 4,
    ACTIONS(11545), 1,
      anon_sym_SEMI,
    ACTIONS(11547), 1,
      anon_sym_else,
    STATE(11137), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421208] = 4,
    ACTIONS(2753), 1,
      anon_sym_COMMA,
    ACTIONS(11549), 1,
      aux_sym__paren_close_token1,
    STATE(11056), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421225] = 3,
    ACTIONS(11553), 1,
      sym_quasiquote_body,
    ACTIONS(11551), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421240] = 3,
    STATE(12550), 1,
      sym__arrow,
    ACTIONS(10073), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421255] = 4,
    ACTIONS(10457), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421272] = 2,
    ACTIONS(11555), 3,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421285] = 4,
    ACTIONS(2753), 1,
      anon_sym_COMMA,
    ACTIONS(11557), 1,
      aux_sym__paren_close_token1,
    STATE(11098), 1,
      aux_sym__exp_tuple_elems_repeat2,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421302] = 2,
    ACTIONS(11559), 3,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421315] = 4,
    ACTIONS(11561), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421332] = 3,
    STATE(12111), 1,
      sym__arrow,
    ACTIONS(1381), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421347] = 4,
    ACTIONS(11563), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421364] = 3,
    ACTIONS(11567), 1,
      sym_quasiquote_body,
    ACTIONS(11565), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421379] = 3,
    ACTIONS(11571), 1,
      sym_quasiquote_body,
    ACTIONS(11569), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421394] = 4,
    ACTIONS(11573), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421411] = 4,
    ACTIONS(11575), 1,
      anon_sym_COMMA,
    ACTIONS(11578), 1,
      anon_sym_RBRACE,
    STATE(11195), 1,
      aux_sym__exp_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421428] = 4,
    ACTIONS(10859), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421445] = 4,
    ACTIONS(10463), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421462] = 4,
    ACTIONS(11580), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421479] = 4,
    ACTIONS(10713), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421496] = 3,
    STATE(1440), 1,
      sym__colon2,
    ACTIONS(11582), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421511] = 3,
    ACTIONS(11586), 1,
      sym_quasiquote_body,
    ACTIONS(11584), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421526] = 3,
    ACTIONS(11590), 1,
      sym_quasiquote_body,
    ACTIONS(11588), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421541] = 4,
    ACTIONS(1255), 1,
      aux_sym__paren_close_token1,
    ACTIONS(9473), 1,
      anon_sym_COMMA,
    STATE(3742), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421558] = 4,
    ACTIONS(10467), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421575] = 3,
    ACTIONS(11594), 1,
      anon_sym_EQ,
    ACTIONS(11592), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421590] = 4,
    ACTIONS(1277), 1,
      aux_sym__paren_close_token1,
    ACTIONS(9473), 1,
      anon_sym_COMMA,
    STATE(4288), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421607] = 4,
    ACTIONS(11245), 1,
      anon_sym_COMMA,
    ACTIONS(11596), 1,
      anon_sym_RBRACE,
    STATE(11061), 1,
      aux_sym__pat_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421624] = 4,
    ACTIONS(11598), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421641] = 4,
    ACTIONS(9812), 1,
      aux_sym__paren_close_token1,
    ACTIONS(11600), 1,
      anon_sym_COMMA,
    STATE(11209), 1,
      aux_sym__ctr_tuple_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421658] = 3,
    ACTIONS(11605), 1,
      sym_quasiquote_body,
    ACTIONS(11603), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421673] = 3,
    ACTIONS(11609), 1,
      sym_quasiquote_body,
    ACTIONS(11607), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421688] = 3,
    ACTIONS(11613), 1,
      anon_sym_EQ,
    ACTIONS(11611), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421703] = 4,
    ACTIONS(11615), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421720] = 4,
    ACTIONS(11143), 1,
      anon_sym_COMMA,
    ACTIONS(11617), 1,
      anon_sym_RBRACE,
    STATE(11066), 1,
      aux_sym__exp_record_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421737] = 4,
    ACTIONS(8798), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421754] = 4,
    ACTIONS(10471), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421771] = 4,
    ACTIONS(11619), 1,
      anon_sym_SEMI,
    ACTIONS(11621), 1,
      anon_sym_else,
    STATE(10967), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421788] = 4,
    ACTIONS(8490), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421805] = 4,
    ACTIONS(11623), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421822] = 3,
    ACTIONS(11627), 1,
      sym_quasiquote_body,
    ACTIONS(11625), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421837] = 3,
    ACTIONS(11631), 1,
      sym_quasiquote_body,
    ACTIONS(11629), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421852] = 4,
    ACTIONS(9857), 1,
      anon_sym_EQ,
    ACTIONS(11633), 1,
      anon_sym_COMMA,
    STATE(11222), 1,
      aux_sym_guards_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421869] = 2,
    ACTIONS(11636), 3,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421882] = 3,
    ACTIONS(11640), 1,
      sym_quasiquote_body,
    ACTIONS(11638), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421897] = 4,
    ACTIONS(9238), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421914] = 3,
    STATE(384), 1,
      sym__arrow,
    ACTIONS(7500), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421929] = 4,
    ACTIONS(11642), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421946] = 4,
    ACTIONS(11644), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421963] = 2,
    ACTIONS(11646), 3,
      sym__cond_layout_end,
      sym__phantom_bar,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421976] = 3,
    ACTIONS(11650), 1,
      sym_quasiquote_body,
    ACTIONS(11648), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421991] = 4,
    ACTIONS(11652), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422008] = 4,
    ACTIONS(9824), 1,
      anon_sym_EQ,
    ACTIONS(11243), 1,
      anon_sym_COMMA,
    STATE(11040), 1,
      aux_sym_guards_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422025] = 3,
    STATE(4665), 1,
      sym__statements,
    ACTIONS(11654), 2,
      sym__cmd_layout_start_do,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422040] = 3,
    ACTIONS(11658), 1,
      sym_quasiquote_body,
    ACTIONS(11656), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422055] = 3,
    STATE(1185), 1,
      sym__larrow,
    ACTIONS(11660), 2,
      anon_sym_LT_DASH,
      anon_sym_u2190,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422070] = 4,
    ACTIONS(10685), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422087] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11662), 1,
      anon_sym_then,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422104] = 4,
    ACTIONS(1279), 1,
      aux_sym__paren_close_token1,
    ACTIONS(9473), 1,
      anon_sym_COMMA,
    STATE(2703), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422121] = 4,
    ACTIONS(10475), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422138] = 4,
    ACTIONS(11664), 1,
      anon_sym_SEMI,
    ACTIONS(11666), 1,
      anon_sym_else,
    STATE(11262), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422155] = 4,
    ACTIONS(11668), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422172] = 4,
    ACTIONS(11670), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422189] = 2,
    ACTIONS(7811), 3,
      sym__cond_layout_end,
      sym__phantom_bar,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422202] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11672), 1,
      anon_sym_else,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422219] = 4,
    ACTIONS(10871), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422236] = 3,
    ACTIONS(11676), 1,
      sym_quasiquote_body,
    ACTIONS(11674), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422251] = 4,
    ACTIONS(10599), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422268] = 3,
    STATE(1188), 1,
      sym__arrow,
    ACTIONS(7514), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422283] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11452), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422300] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11668), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422317] = 4,
    ACTIONS(11678), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422334] = 4,
    ACTIONS(11680), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422351] = 3,
    ACTIONS(11684), 1,
      sym_quasiquote_body,
    ACTIONS(11682), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422366] = 4,
    ACTIONS(10479), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422383] = 3,
    STATE(1306), 1,
      sym__arrow,
    ACTIONS(7514), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422398] = 4,
    ACTIONS(11686), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422415] = 3,
    ACTIONS(11690), 1,
      sym_quasiquote_body,
    ACTIONS(11688), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422430] = 3,
    ACTIONS(11694), 1,
      sym_quasiquote_body,
    ACTIONS(11692), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422445] = 4,
    ACTIONS(10908), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422462] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11647), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422479] = 3,
    STATE(5333), 1,
      sym__statements,
    ACTIONS(11696), 2,
      sym__cmd_layout_start_do,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422494] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11698), 1,
      anon_sym_else,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422511] = 4,
    ACTIONS(10485), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422528] = 3,
    STATE(1275), 1,
      sym__larrow,
    ACTIONS(11700), 2,
      anon_sym_LT_DASH,
      anon_sym_u2190,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422543] = 4,
    ACTIONS(11702), 1,
      anon_sym_SEMI,
    ACTIONS(11704), 1,
      anon_sym_else,
    STATE(11286), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422560] = 4,
    ACTIONS(11706), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422577] = 3,
    ACTIONS(11710), 1,
      sym_quasiquote_body,
    ACTIONS(11708), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422592] = 4,
    ACTIONS(11712), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422609] = 3,
    STATE(1228), 1,
      sym__larrow,
    ACTIONS(11714), 2,
      anon_sym_LT_DASH,
      anon_sym_u2190,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422624] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11643), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422641] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11685), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422658] = 3,
    STATE(10446), 1,
      sym__statements,
    ACTIONS(11716), 2,
      sym__cmd_layout_start_do,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422673] = 4,
    ACTIONS(10673), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422690] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11807), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422707] = 3,
    ACTIONS(11720), 1,
      sym_quasiquote_body,
    ACTIONS(11718), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422722] = 4,
    ACTIONS(11722), 1,
      anon_sym_COMMA,
    ACTIONS(11724), 1,
      anon_sym_RBRACE,
    STATE(11158), 1,
      aux_sym__record_fields_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422739] = 4,
    ACTIONS(11726), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422756] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11728), 1,
      anon_sym_else,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422773] = 4,
    ACTIONS(9028), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422790] = 4,
    ACTIONS(11730), 1,
      anon_sym_COMMA,
    ACTIONS(11733), 1,
      aux_sym__paren_close_token1,
    STATE(11280), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422807] = 4,
    ACTIONS(10968), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422824] = 4,
    ACTIONS(11735), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422841] = 4,
    ACTIONS(11737), 1,
      anon_sym_SEMI,
    ACTIONS(11739), 1,
      anon_sym_else,
    STATE(11278), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422858] = 3,
    ACTIONS(11743), 1,
      sym_quasiquote_body,
    ACTIONS(11741), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422873] = 4,
    ACTIONS(1249), 1,
      aux_sym__paren_close_token1,
    ACTIONS(9473), 1,
      anon_sym_COMMA,
    STATE(4184), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422890] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11745), 1,
      anon_sym_else,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422907] = 4,
    ACTIONS(9288), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422924] = 4,
    ACTIONS(7662), 1,
      anon_sym_SEMI,
    ACTIONS(11747), 1,
      anon_sym_else,
    STATE(9248), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422941] = 4,
    ACTIONS(11749), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422958] = 2,
    ACTIONS(11751), 3,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422971] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11453), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422988] = 2,
    ACTIONS(11753), 3,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423001] = 3,
    ACTIONS(11757), 1,
      sym_quasiquote_body,
    ACTIONS(11755), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423016] = 3,
    ACTIONS(11761), 1,
      sym_quasiquote_body,
    ACTIONS(11759), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423031] = 3,
    ACTIONS(11765), 1,
      sym_quasiquote_body,
    ACTIONS(11763), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423046] = 4,
    ACTIONS(10523), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423063] = 3,
    STATE(4832), 1,
      sym__statements,
    ACTIONS(11767), 2,
      sym__cmd_layout_start_do,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423078] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11819), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423095] = 3,
    ACTIONS(11769), 1,
      sym_name,
    STATE(11102), 2,
      sym__modid_prefix,
      aux_sym_module_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423110] = 4,
    ACTIONS(7578), 1,
      aux_sym__paren_open_token1,
    STATE(7872), 1,
      sym__paren_open,
    STATE(11584), 1,
      sym_import_list,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423127] = 4,
    ACTIONS(11771), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423144] = 2,
    ACTIONS(11773), 3,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423157] = 4,
    ACTIONS(10922), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423174] = 3,
    ACTIONS(11777), 1,
      sym_quasiquote_body,
    ACTIONS(11775), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423189] = 4,
    ACTIONS(11779), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423206] = 3,
    STATE(868), 1,
      sym__colon2,
    ACTIONS(11781), 2,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423221] = 4,
    ACTIONS(11783), 1,
      anon_sym_SEMI,
    ACTIONS(11785), 1,
      anon_sym_else,
    STATE(11288), 1,
      aux_sym__let_binds_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423238] = 4,
    ACTIONS(10930), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423255] = 4,
    ACTIONS(11787), 1,
      anon_sym_COMMA,
    ACTIONS(11790), 1,
      aux_sym__paren_close_token1,
    STATE(11309), 1,
      aux_sym_children_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423272] = 4,
    ACTIONS(10625), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423289] = 4,
    ACTIONS(11792), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423306] = 3,
    ACTIONS(11796), 1,
      sym_quasiquote_body,
    ACTIONS(11794), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423321] = 3,
    STATE(1227), 1,
      sym__arrow,
    ACTIONS(7514), 2,
      anon_sym_DASH_GT,
      anon_sym_u2192,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423336] = 4,
    ACTIONS(8560), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423353] = 4,
    ACTIONS(10547), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423370] = 4,
    ACTIONS(11175), 1,
      sym_variable,
    STATE(8989), 1,
      sym_fundep,
    STATE(9774), 1,
      aux_sym_type_family_injectivity_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423387] = 4,
    ACTIONS(11798), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423404] = 4,
    ACTIONS(11800), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423421] = 4,
    ACTIONS(10936), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423438] = 4,
    ACTIONS(1289), 1,
      aux_sym__paren_close_token1,
    ACTIONS(9473), 1,
      anon_sym_COMMA,
    STATE(4165), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423455] = 3,
    ACTIONS(11804), 1,
      sym_quasiquote_body,
    ACTIONS(11802), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423470] = 3,
    ACTIONS(11808), 1,
      sym_quasiquote_body,
    ACTIONS(11806), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423485] = 2,
    ACTIONS(11810), 3,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_u2237,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423498] = 3,
    ACTIONS(11814), 1,
      sym_quasiquote_body,
    ACTIONS(11812), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423513] = 4,
    ACTIONS(11816), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423530] = 4,
    ACTIONS(10595), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423547] = 3,
    ACTIONS(11820), 1,
      sym_quasiquote_body,
    ACTIONS(11818), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423562] = 4,
    ACTIONS(11822), 1,
      sym_name,
    STATE(9664), 1,
      aux_sym__qualifying_module,
    STATE(10076), 1,
      sym__modid_prefix,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423579] = 4,
    ACTIONS(1295), 1,
      aux_sym__paren_close_token1,
    ACTIONS(9473), 1,
      anon_sym_COMMA,
    STATE(3932), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423596] = 3,
    ACTIONS(283), 1,
      aux_sym__paren_close_token1,
    STATE(6751), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423610] = 3,
    ACTIONS(1427), 1,
      aux_sym__paren_close_token1,
    STATE(6920), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423624] = 3,
    ACTIONS(1257), 1,
      aux_sym__paren_close_token1,
    STATE(4335), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423638] = 3,
    ACTIONS(11824), 1,
      sym_variable,
    STATE(4623), 1,
      sym_field_name,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423652] = 2,
    ACTIONS(10303), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423664] = 2,
    ACTIONS(4695), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423676] = 3,
    ACTIONS(1289), 1,
      aux_sym__paren_close_token1,
    STATE(4618), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423690] = 3,
    ACTIONS(1279), 1,
      aux_sym__paren_close_token1,
    STATE(2742), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423704] = 3,
    ACTIONS(1493), 1,
      aux_sym__paren_close_token1,
    STATE(3922), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423718] = 3,
    ACTIONS(1509), 1,
      aux_sym__paren_close_token1,
    STATE(5962), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423732] = 2,
    ACTIONS(11826), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423744] = 2,
    ACTIONS(11828), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423756] = 2,
    ACTIONS(5642), 2,
      sym__consym,
      sym_name,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423768] = 3,
    ACTIONS(6356), 1,
      aux_sym__paren_close_token1,
    STATE(10054), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423782] = 2,
    ACTIONS(11830), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423794] = 2,
    ACTIONS(11832), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423806] = 3,
    ACTIONS(5551), 1,
      aux_sym__paren_close_token1,
    STATE(8919), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423820] = 3,
    ACTIONS(5547), 1,
      aux_sym__paren_close_token1,
    STATE(8660), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423834] = 3,
    ACTIONS(249), 1,
      aux_sym__paren_close_token1,
    STATE(6086), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423848] = 3,
    ACTIONS(5549), 1,
      aux_sym__paren_close_token1,
    STATE(8371), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423862] = 3,
    ACTIONS(249), 1,
      aux_sym__paren_close_token1,
    STATE(6059), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423876] = 2,
    ACTIONS(11834), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423888] = 3,
    ACTIONS(269), 1,
      aux_sym__paren_close_token1,
    STATE(5795), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423902] = 3,
    ACTIONS(3411), 1,
      aux_sym__paren_close_token1,
    STATE(7899), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423916] = 3,
    ACTIONS(1411), 1,
      aux_sym__paren_close_token1,
    STATE(6851), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423930] = 3,
    ACTIONS(1411), 1,
      aux_sym__paren_close_token1,
    STATE(6873), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423944] = 3,
    ACTIONS(1473), 1,
      aux_sym__paren_close_token1,
    STATE(6225), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423958] = 3,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    STATE(1525), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423972] = 3,
    ACTIONS(1509), 1,
      aux_sym__paren_close_token1,
    STATE(5956), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [423986] = 3,
    ACTIONS(1567), 1,
      aux_sym__paren_close_token1,
    STATE(4899), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424000] = 3,
    ACTIONS(1461), 1,
      aux_sym__paren_close_token1,
    STATE(6583), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424014] = 3,
    ACTIONS(1289), 1,
      aux_sym__paren_close_token1,
    STATE(4185), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424028] = 3,
    ACTIONS(1539), 1,
      aux_sym__paren_close_token1,
    STATE(5982), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424042] = 3,
    ACTIONS(205), 1,
      aux_sym__paren_close_token1,
    STATE(3618), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424056] = 3,
    ACTIONS(277), 1,
      aux_sym__paren_close_token1,
    STATE(7271), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424070] = 3,
    ACTIONS(1275), 1,
      aux_sym__paren_close_token1,
    STATE(4400), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424084] = 3,
    ACTIONS(5549), 1,
      aux_sym__paren_close_token1,
    STATE(8392), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424098] = 3,
    ACTIONS(185), 1,
      aux_sym__paren_close_token1,
    STATE(3301), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424112] = 3,
    ACTIONS(5545), 1,
      aux_sym__paren_close_token1,
    STATE(8601), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424126] = 2,
    ACTIONS(11836), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424138] = 3,
    ACTIONS(1443), 1,
      aux_sym__paren_close_token1,
    STATE(7393), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424152] = 3,
    ACTIONS(1563), 1,
      aux_sym__paren_close_token1,
    STATE(6043), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424166] = 3,
    ACTIONS(181), 1,
      aux_sym__paren_close_token1,
    STATE(2969), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424180] = 3,
    ACTIONS(5543), 1,
      aux_sym__paren_close_token1,
    STATE(8727), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424194] = 3,
    ACTIONS(5547), 1,
      aux_sym__paren_close_token1,
    STATE(8627), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424208] = 3,
    ACTIONS(5543), 1,
      aux_sym__paren_close_token1,
    STATE(8771), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424222] = 2,
    ACTIONS(11838), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424234] = 3,
    ACTIONS(1489), 1,
      aux_sym__paren_close_token1,
    STATE(7516), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424248] = 3,
    ACTIONS(4469), 1,
      aux_sym__paren_close_token1,
    STATE(7961), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424262] = 3,
    ACTIONS(1423), 1,
      aux_sym__paren_close_token1,
    STATE(7561), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424276] = 3,
    ACTIONS(1559), 1,
      aux_sym__paren_close_token1,
    STATE(7452), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424290] = 3,
    ACTIONS(249), 1,
      aux_sym__paren_close_token1,
    STATE(6147), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424304] = 3,
    ACTIONS(1249), 1,
      aux_sym__paren_close_token1,
    STATE(4853), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424318] = 2,
    ACTIONS(11840), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424330] = 3,
    ACTIONS(6356), 1,
      aux_sym__paren_close_token1,
    STATE(10019), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424344] = 3,
    ACTIONS(1559), 1,
      aux_sym__paren_close_token1,
    STATE(7212), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424358] = 2,
    ACTIONS(10253), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424370] = 3,
    ACTIONS(1505), 1,
      aux_sym__paren_close_token1,
    STATE(6966), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424384] = 3,
    ACTIONS(5547), 1,
      aux_sym__paren_close_token1,
    STATE(8654), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424398] = 3,
    ACTIONS(1255), 1,
      aux_sym__paren_close_token1,
    STATE(4166), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424412] = 3,
    ACTIONS(1289), 1,
      aux_sym__paren_close_token1,
    STATE(4103), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424426] = 3,
    ACTIONS(181), 1,
      aux_sym__paren_close_token1,
    STATE(2847), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424440] = 3,
    ACTIONS(3501), 1,
      aux_sym__paren_close_token1,
    STATE(7906), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424454] = 3,
    ACTIONS(1563), 1,
      aux_sym__paren_close_token1,
    STATE(5930), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424468] = 3,
    ACTIONS(1543), 1,
      aux_sym__paren_close_token1,
    STATE(6248), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424482] = 3,
    ACTIONS(1559), 1,
      aux_sym__paren_close_token1,
    STATE(7381), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424496] = 3,
    ACTIONS(4473), 1,
      aux_sym__paren_close_token1,
    STATE(8038), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424510] = 3,
    ACTIONS(1457), 1,
      aux_sym__paren_close_token1,
    STATE(2324), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424524] = 3,
    ACTIONS(4434), 1,
      aux_sym__paren_close_token1,
    STATE(8066), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424538] = 3,
    ACTIONS(1493), 1,
      aux_sym__paren_close_token1,
    STATE(3908), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424552] = 3,
    ACTIONS(1435), 1,
      aux_sym__paren_close_token1,
    STATE(6564), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424566] = 3,
    ACTIONS(169), 1,
      aux_sym__paren_close_token1,
    STATE(3724), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424580] = 3,
    ACTIONS(4438), 1,
      aux_sym__paren_close_token1,
    STATE(7720), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424594] = 3,
    ACTIONS(5545), 1,
      aux_sym__paren_close_token1,
    STATE(8603), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424608] = 3,
    ACTIONS(1439), 1,
      aux_sym__paren_close_token1,
    STATE(6828), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424622] = 3,
    ACTIONS(3501), 1,
      aux_sym__paren_close_token1,
    STATE(7948), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424636] = 3,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    STATE(1421), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424650] = 3,
    ACTIONS(283), 1,
      aux_sym__paren_close_token1,
    STATE(6482), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424664] = 3,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    STATE(1429), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424678] = 3,
    ACTIONS(249), 1,
      aux_sym__paren_close_token1,
    STATE(6096), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424692] = 2,
    ACTIONS(11842), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424704] = 2,
    ACTIONS(11844), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424716] = 3,
    ACTIONS(11846), 1,
      sym_variable,
    STATE(4169), 1,
      sym_field_name,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424730] = 3,
    ACTIONS(277), 1,
      aux_sym__paren_close_token1,
    STATE(7332), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424744] = 3,
    ACTIONS(1423), 1,
      aux_sym__paren_close_token1,
    STATE(7619), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424758] = 3,
    ACTIONS(1465), 1,
      aux_sym__paren_close_token1,
    STATE(3395), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424772] = 3,
    ACTIONS(1509), 1,
      aux_sym__paren_close_token1,
    STATE(5892), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424786] = 3,
    ACTIONS(1519), 1,
      aux_sym__paren_close_token1,
    STATE(7687), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424800] = 2,
    ACTIONS(11848), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424812] = 3,
    ACTIONS(205), 1,
      aux_sym__paren_close_token1,
    STATE(3524), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424826] = 2,
    ACTIONS(10245), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424838] = 3,
    ACTIONS(3501), 1,
      aux_sym__paren_close_token1,
    STATE(7947), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424852] = 3,
    ACTIONS(1435), 1,
      aux_sym__paren_close_token1,
    STATE(6492), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424866] = 3,
    ACTIONS(1473), 1,
      aux_sym__paren_close_token1,
    STATE(6567), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424880] = 3,
    ACTIONS(283), 1,
      aux_sym__paren_close_token1,
    STATE(6203), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424894] = 3,
    ACTIONS(1289), 1,
      aux_sym__paren_close_token1,
    STATE(4086), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424908] = 3,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    STATE(1575), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424922] = 3,
    ACTIONS(201), 1,
      aux_sym__paren_close_token1,
    STATE(3594), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424936] = 3,
    ACTIONS(289), 1,
      aux_sym__paren_close_token1,
    STATE(7108), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424950] = 3,
    ACTIONS(1509), 1,
      aux_sym__paren_close_token1,
    STATE(6047), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424964] = 3,
    ACTIONS(283), 1,
      aux_sym__paren_close_token1,
    STATE(6200), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424978] = 3,
    ACTIONS(1497), 1,
      aux_sym__paren_close_token1,
    STATE(7782), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [424992] = 3,
    ACTIONS(1509), 1,
      aux_sym__paren_close_token1,
    STATE(5920), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425006] = 3,
    ACTIONS(1443), 1,
      aux_sym__paren_close_token1,
    STATE(7354), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425020] = 3,
    ACTIONS(1485), 1,
      aux_sym__paren_close_token1,
    STATE(5833), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425034] = 3,
    ACTIONS(201), 1,
      aux_sym__paren_close_token1,
    STATE(3464), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425048] = 3,
    ACTIONS(5543), 1,
      aux_sym__paren_close_token1,
    STATE(8736), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425062] = 2,
    ACTIONS(11850), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425074] = 2,
    ACTIONS(11852), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425086] = 2,
    ACTIONS(11854), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425098] = 3,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    STATE(1671), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425112] = 3,
    ACTIONS(1431), 1,
      aux_sym__paren_close_token1,
    STATE(6060), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425126] = 3,
    ACTIONS(6336), 1,
      aux_sym__paren_close_token1,
    STATE(11487), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425140] = 3,
    ACTIONS(11856), 1,
      anon_sym_RBRACK,
    STATE(8705), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425154] = 3,
    ACTIONS(1567), 1,
      aux_sym__paren_close_token1,
    STATE(5080), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425168] = 3,
    ACTIONS(1289), 1,
      aux_sym__paren_close_token1,
    STATE(4543), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425182] = 3,
    ACTIONS(1289), 1,
      aux_sym__paren_close_token1,
    STATE(4542), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425196] = 2,
    ACTIONS(11858), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425208] = 3,
    ACTIONS(11860), 1,
      anon_sym_in,
    ACTIONS(11862), 1,
      sym__phantom_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425222] = 3,
    ACTIONS(1289), 1,
      aux_sym__paren_close_token1,
    STATE(4540), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425236] = 3,
    ACTIONS(2819), 1,
      anon_sym_RBRACK,
    STATE(4513), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425250] = 3,
    ACTIONS(1411), 1,
      aux_sym__paren_close_token1,
    STATE(7008), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425264] = 2,
    ACTIONS(10155), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425276] = 2,
    ACTIONS(10305), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425288] = 3,
    ACTIONS(11864), 1,
      anon_sym_DOLLAR,
    ACTIONS(11866), 1,
      anon_sym_DOLLAR_DOLLAR,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425302] = 2,
    ACTIONS(11868), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425314] = 2,
    ACTIONS(10123), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425326] = 2,
    ACTIONS(11870), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425338] = 2,
    ACTIONS(11872), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425350] = 3,
    ACTIONS(1277), 1,
      aux_sym__paren_close_token1,
    STATE(4274), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425364] = 3,
    ACTIONS(201), 1,
      aux_sym__paren_close_token1,
    STATE(3558), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425378] = 3,
    ACTIONS(1567), 1,
      aux_sym__paren_close_token1,
    STATE(4917), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425392] = 3,
    ACTIONS(5549), 1,
      aux_sym__paren_close_token1,
    STATE(8376), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425406] = 3,
    ACTIONS(5545), 1,
      aux_sym__paren_close_token1,
    STATE(8556), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425420] = 3,
    ACTIONS(1563), 1,
      aux_sym__paren_close_token1,
    STATE(5904), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425434] = 3,
    ACTIONS(1423), 1,
      aux_sym__paren_close_token1,
    STATE(7560), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425448] = 3,
    ACTIONS(1289), 1,
      aux_sym__paren_close_token1,
    STATE(4200), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425462] = 3,
    ACTIONS(1439), 1,
      aux_sym__paren_close_token1,
    STATE(6826), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425476] = 3,
    ACTIONS(1469), 1,
      aux_sym__paren_close_token1,
    STATE(7437), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425490] = 2,
    ACTIONS(10119), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425502] = 3,
    ACTIONS(5547), 1,
      aux_sym__paren_close_token1,
    STATE(8704), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425516] = 3,
    ACTIONS(1395), 1,
      aux_sym__paren_close_token1,
    STATE(6197), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425530] = 2,
    ACTIONS(11874), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425542] = 3,
    ACTIONS(6356), 1,
      aux_sym__paren_close_token1,
    STATE(8920), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425556] = 3,
    ACTIONS(1559), 1,
      aux_sym__paren_close_token1,
    STATE(7454), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425570] = 2,
    ACTIONS(10115), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425582] = 3,
    ACTIONS(4434), 1,
      aux_sym__paren_close_token1,
    STATE(8049), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425596] = 2,
    ACTIONS(10111), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425608] = 3,
    ACTIONS(1465), 1,
      aux_sym__paren_close_token1,
    STATE(3336), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425622] = 2,
    ACTIONS(11876), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425634] = 3,
    ACTIONS(277), 1,
      aux_sym__paren_close_token1,
    STATE(7398), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425648] = 2,
    ACTIONS(11878), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425660] = 2,
    ACTIONS(11880), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425672] = 3,
    ACTIONS(7550), 1,
      sym_variable,
    STATE(11188), 1,
      sym_field_name,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425686] = 2,
    ACTIONS(11882), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425698] = 2,
    ACTIONS(11884), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425710] = 3,
    ACTIONS(3501), 1,
      aux_sym__paren_close_token1,
    STATE(7885), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425724] = 2,
    ACTIONS(10247), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425736] = 3,
    ACTIONS(1567), 1,
      aux_sym__paren_close_token1,
    STATE(4930), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425750] = 2,
    ACTIONS(11886), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425762] = 2,
    ACTIONS(11888), 2,
      sym__phantom_where,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425774] = 3,
    ACTIONS(5551), 1,
      aux_sym__paren_close_token1,
    STATE(8909), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425788] = 3,
    ACTIONS(1277), 1,
      aux_sym__paren_close_token1,
    STATE(4271), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425802] = 3,
    ACTIONS(10291), 1,
      anon_sym_in,
    ACTIONS(10293), 1,
      sym__phantom_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425816] = 3,
    ACTIONS(1255), 1,
      aux_sym__paren_close_token1,
    STATE(3992), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425830] = 3,
    ACTIONS(11890), 1,
      anon_sym_RBRACK,
    STATE(8890), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425844] = 3,
    ACTIONS(1255), 1,
      aux_sym__paren_close_token1,
    STATE(3991), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425858] = 3,
    ACTIONS(1255), 1,
      aux_sym__paren_close_token1,
    STATE(3990), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425872] = 3,
    ACTIONS(289), 1,
      aux_sym__paren_close_token1,
    STATE(7113), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425886] = 3,
    ACTIONS(6356), 1,
      aux_sym__paren_close_token1,
    STATE(9292), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425900] = 2,
    ACTIONS(11892), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425912] = 3,
    ACTIONS(283), 1,
      aux_sym__paren_close_token1,
    STATE(6262), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425926] = 3,
    ACTIONS(11894), 1,
      aux_sym__paren_close_token1,
    STATE(8225), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425940] = 3,
    ACTIONS(201), 1,
      aux_sym__paren_close_token1,
    STATE(3639), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425954] = 3,
    ACTIONS(1431), 1,
      aux_sym__paren_close_token1,
    STATE(6124), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425968] = 3,
    ACTIONS(1415), 1,
      aux_sym__paren_close_token1,
    STATE(6268), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425982] = 3,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    STATE(1534), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425996] = 2,
    ACTIONS(10151), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426008] = 3,
    ACTIONS(1255), 1,
      aux_sym__paren_close_token1,
    STATE(3755), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426022] = 3,
    ACTIONS(1411), 1,
      aux_sym__paren_close_token1,
    STATE(6908), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426036] = 3,
    ACTIONS(1279), 1,
      aux_sym__paren_close_token1,
    STATE(2712), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426050] = 3,
    ACTIONS(4473), 1,
      aux_sym__paren_close_token1,
    STATE(8037), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426064] = 3,
    ACTIONS(2985), 1,
      anon_sym_RBRACK,
    STATE(3985), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426078] = 3,
    ACTIONS(1489), 1,
      aux_sym__paren_close_token1,
    STATE(7513), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426092] = 2,
    ACTIONS(10307), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426104] = 3,
    ACTIONS(1539), 1,
      aux_sym__paren_close_token1,
    STATE(6036), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426118] = 3,
    ACTIONS(1415), 1,
      aux_sym__paren_close_token1,
    STATE(6521), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426132] = 3,
    ACTIONS(4438), 1,
      aux_sym__paren_close_token1,
    STATE(7634), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426146] = 3,
    ACTIONS(249), 1,
      aux_sym__paren_close_token1,
    STATE(6145), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426160] = 3,
    ACTIONS(11896), 1,
      aux_sym__paren_open_token1,
    STATE(1031), 1,
      sym__paren_open,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426174] = 3,
    ACTIONS(2995), 1,
      anon_sym_RBRACK,
    STATE(4876), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426188] = 2,
    ACTIONS(11898), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426200] = 2,
    ACTIONS(11900), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426212] = 2,
    ACTIONS(10147), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426224] = 3,
    ACTIONS(11902), 1,
      anon_sym_import,
    ACTIONS(11904), 1,
      anon_sym_export,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426238] = 3,
    ACTIONS(1443), 1,
      aux_sym__paren_close_token1,
    STATE(7299), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426252] = 2,
    ACTIONS(10208), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426264] = 3,
    ACTIONS(1431), 1,
      aux_sym__paren_close_token1,
    STATE(6099), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426278] = 3,
    ACTIONS(3411), 1,
      aux_sym__paren_close_token1,
    STATE(7902), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426292] = 2,
    ACTIONS(11906), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426304] = 3,
    ACTIONS(11908), 1,
      sym_variable,
    STATE(4852), 1,
      sym_field_name,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426318] = 3,
    ACTIONS(1555), 1,
      aux_sym__paren_close_token1,
    STATE(7200), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426332] = 3,
    ACTIONS(1295), 1,
      aux_sym__paren_close_token1,
    STATE(4213), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426346] = 3,
    ACTIONS(1461), 1,
      aux_sym__paren_close_token1,
    STATE(6669), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426360] = 3,
    ACTIONS(1473), 1,
      aux_sym__paren_close_token1,
    STATE(6491), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426374] = 3,
    ACTIONS(1423), 1,
      aux_sym__paren_close_token1,
    STATE(7576), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426388] = 3,
    ACTIONS(11910), 1,
      anon_sym_DOT,
    ACTIONS(11912), 1,
      sym__varsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426402] = 3,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    STATE(1766), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426416] = 3,
    ACTIONS(1439), 1,
      aux_sym__paren_close_token1,
    STATE(6763), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426430] = 3,
    ACTIONS(1555), 1,
      aux_sym__paren_close_token1,
    STATE(7174), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426444] = 3,
    ACTIONS(1563), 1,
      aux_sym__paren_close_token1,
    STATE(5891), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426458] = 3,
    ACTIONS(1465), 1,
      aux_sym__paren_close_token1,
    STATE(3335), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426472] = 3,
    ACTIONS(1257), 1,
      aux_sym__paren_close_token1,
    STATE(4840), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426486] = 2,
    ACTIONS(10194), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426498] = 3,
    ACTIONS(11914), 1,
      sym_variable,
    STATE(2927), 1,
      sym_field_name,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426512] = 3,
    ACTIONS(1527), 1,
      aux_sym__paren_close_token1,
    STATE(3459), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426526] = 3,
    ACTIONS(11916), 1,
      anon_sym_in,
    ACTIONS(11918), 1,
      sym__phantom_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426540] = 3,
    ACTIONS(2819), 1,
      anon_sym_RBRACK,
    STATE(4464), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426554] = 2,
    ACTIONS(10239), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426566] = 2,
    ACTIONS(11920), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426578] = 2,
    ACTIONS(11922), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426590] = 2,
    ACTIONS(11924), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426602] = 3,
    ACTIONS(1543), 1,
      aux_sym__paren_close_token1,
    STATE(6305), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426616] = 3,
    ACTIONS(1435), 1,
      aux_sym__paren_close_token1,
    STATE(6546), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426630] = 2,
    ACTIONS(10198), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426642] = 2,
    ACTIONS(10141), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426654] = 3,
    ACTIONS(11926), 1,
      anon_sym_DASH,
    STATE(2287), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426668] = 2,
    ACTIONS(10206), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426680] = 2,
    ACTIONS(11928), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426692] = 3,
    ACTIONS(1279), 1,
      aux_sym__paren_close_token1,
    STATE(2935), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426706] = 2,
    ACTIONS(10210), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426718] = 3,
    ACTIONS(1473), 1,
      aux_sym__paren_close_token1,
    STATE(6354), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426732] = 2,
    ACTIONS(10217), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426744] = 3,
    ACTIONS(269), 1,
      aux_sym__paren_close_token1,
    STATE(5719), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426758] = 3,
    ACTIONS(4438), 1,
      aux_sym__paren_close_token1,
    STATE(7706), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426772] = 3,
    ACTIONS(1269), 1,
      aux_sym__paren_close_token1,
    STATE(4401), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426786] = 2,
    ACTIONS(11930), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426798] = 3,
    ACTIONS(1473), 1,
      aux_sym__paren_close_token1,
    STATE(6371), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426812] = 3,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    STATE(1416), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426826] = 3,
    ACTIONS(4434), 1,
      aux_sym__paren_close_token1,
    STATE(8073), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426840] = 2,
    ACTIONS(11932), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426852] = 2,
    ACTIONS(11934), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426864] = 3,
    ACTIONS(1555), 1,
      aux_sym__paren_close_token1,
    STATE(7109), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426878] = 2,
    ACTIONS(11936), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426890] = 3,
    ACTIONS(181), 1,
      aux_sym__paren_close_token1,
    STATE(2852), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426904] = 3,
    ACTIONS(1431), 1,
      aux_sym__paren_close_token1,
    STATE(6074), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426918] = 3,
    ACTIONS(1519), 1,
      aux_sym__paren_close_token1,
    STATE(7681), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426932] = 3,
    ACTIONS(1439), 1,
      aux_sym__paren_close_token1,
    STATE(6747), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426946] = 3,
    ACTIONS(1539), 1,
      aux_sym__paren_close_token1,
    STATE(6021), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426960] = 3,
    ACTIONS(1275), 1,
      aux_sym__paren_close_token1,
    STATE(4384), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426974] = 3,
    ACTIONS(1505), 1,
      aux_sym__paren_close_token1,
    STATE(7014), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [426988] = 2,
    ACTIONS(11938), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427000] = 3,
    ACTIONS(1531), 1,
      aux_sym__paren_close_token1,
    STATE(3333), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427014] = 2,
    ACTIONS(10219), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427026] = 2,
    ACTIONS(10255), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427038] = 3,
    ACTIONS(1295), 1,
      aux_sym__paren_close_token1,
    STATE(4172), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427052] = 3,
    ACTIONS(11940), 1,
      anon_sym_in,
    ACTIONS(11942), 1,
      sym__phantom_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427066] = 3,
    ACTIONS(4469), 1,
      aux_sym__paren_close_token1,
    STATE(7993), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427080] = 3,
    ACTIONS(1435), 1,
      aux_sym__paren_close_token1,
    STATE(6233), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427094] = 3,
    ACTIONS(1497), 1,
      aux_sym__paren_close_token1,
    STATE(7729), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427108] = 3,
    ACTIONS(1279), 1,
      aux_sym__paren_close_token1,
    STATE(2703), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427122] = 3,
    ACTIONS(1559), 1,
      aux_sym__paren_close_token1,
    STATE(7275), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427136] = 3,
    ACTIONS(1279), 1,
      aux_sym__paren_close_token1,
    STATE(2708), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427150] = 3,
    ACTIONS(1443), 1,
      aux_sym__paren_close_token1,
    STATE(7320), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427164] = 3,
    ACTIONS(4434), 1,
      aux_sym__paren_close_token1,
    STATE(8064), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427178] = 2,
    ACTIONS(11944), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427190] = 2,
    ACTIONS(11946), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427202] = 2,
    ACTIONS(11948), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427214] = 2,
    ACTIONS(11950), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427226] = 2,
    ACTIONS(10332), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427238] = 3,
    ACTIONS(11952), 1,
      anon_sym_RBRACK,
    STATE(8956), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427252] = 3,
    ACTIONS(1555), 1,
      aux_sym__paren_close_token1,
    STATE(7069), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427266] = 2,
    ACTIONS(11954), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427278] = 3,
    ACTIONS(5539), 1,
      aux_sym__paren_close_token1,
    STATE(9108), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427292] = 3,
    ACTIONS(4469), 1,
      aux_sym__paren_close_token1,
    STATE(7992), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427306] = 3,
    ACTIONS(5539), 1,
      aux_sym__paren_close_token1,
    STATE(8669), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427320] = 3,
    ACTIONS(1461), 1,
      aux_sym__paren_close_token1,
    STATE(6604), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427334] = 2,
    ACTIONS(11956), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427346] = 3,
    ACTIONS(1249), 1,
      aux_sym__paren_close_token1,
    STATE(4115), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427360] = 3,
    ACTIONS(1519), 1,
      aux_sym__paren_close_token1,
    STATE(7666), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427374] = 3,
    ACTIONS(5551), 1,
      aux_sym__paren_close_token1,
    STATE(8942), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427388] = 3,
    ACTIONS(4469), 1,
      aux_sym__paren_close_token1,
    STATE(8010), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427402] = 3,
    ACTIONS(1465), 1,
      aux_sym__paren_close_token1,
    STATE(3289), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427416] = 3,
    ACTIONS(1461), 1,
      aux_sym__paren_close_token1,
    STATE(6695), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427430] = 3,
    ACTIONS(1431), 1,
      aux_sym__paren_close_token1,
    STATE(6177), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427444] = 3,
    ACTIONS(1543), 1,
      aux_sym__paren_close_token1,
    STATE(6306), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427458] = 3,
    ACTIONS(1457), 1,
      aux_sym__paren_close_token1,
    STATE(2344), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427472] = 3,
    ACTIONS(1277), 1,
      aux_sym__paren_close_token1,
    STATE(4288), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427486] = 2,
    ACTIONS(10313), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427498] = 3,
    ACTIONS(1551), 1,
      aux_sym__paren_close_token1,
    STATE(6842), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427512] = 3,
    ACTIONS(205), 1,
      aux_sym__paren_close_token1,
    STATE(3526), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427526] = 3,
    ACTIONS(1469), 1,
      aux_sym__paren_close_token1,
    STATE(7340), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427540] = 3,
    ACTIONS(5543), 1,
      aux_sym__paren_close_token1,
    STATE(8759), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427554] = 3,
    ACTIONS(2995), 1,
      anon_sym_RBRACK,
    STATE(4948), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427568] = 3,
    ACTIONS(11958), 1,
      anon_sym_RBRACK,
    STATE(8747), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427582] = 3,
    ACTIONS(1277), 1,
      aux_sym__paren_close_token1,
    STATE(4950), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427596] = 3,
    ACTIONS(197), 1,
      aux_sym__paren_close_token1,
    STATE(3681), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427610] = 3,
    ACTIONS(11960), 1,
      anon_sym_in,
    ACTIONS(11962), 1,
      sym__phantom_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427624] = 3,
    ACTIONS(1277), 1,
      aux_sym__paren_close_token1,
    STATE(4951), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427638] = 3,
    ACTIONS(1439), 1,
      aux_sym__paren_close_token1,
    STATE(6834), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427652] = 3,
    ACTIONS(1461), 1,
      aux_sym__paren_close_token1,
    STATE(6576), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427666] = 3,
    ACTIONS(1277), 1,
      aux_sym__paren_close_token1,
    STATE(4953), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427680] = 2,
    ACTIONS(11964), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427692] = 3,
    ACTIONS(169), 1,
      aux_sym__paren_close_token1,
    STATE(3801), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427706] = 3,
    ACTIONS(1423), 1,
      aux_sym__paren_close_token1,
    STATE(7590), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427720] = 3,
    ACTIONS(2881), 1,
      anon_sym_RBRACK,
    STATE(5155), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427734] = 3,
    ACTIONS(209), 1,
      aux_sym__paren_close_token1,
    STATE(3620), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427748] = 2,
    ACTIONS(11966), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427760] = 3,
    ACTIONS(1519), 1,
      aux_sym__paren_close_token1,
    STATE(7718), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427774] = 3,
    ACTIONS(1505), 1,
      aux_sym__paren_close_token1,
    STATE(6896), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427788] = 2,
    ACTIONS(11968), 2,
      sym_variable,
      aux_sym__paren_open_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427800] = 3,
    ACTIONS(1555), 1,
      aux_sym__paren_close_token1,
    STATE(7182), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427814] = 3,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    STATE(1560), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427828] = 2,
    ACTIONS(10083), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427840] = 3,
    ACTIONS(1289), 1,
      aux_sym__paren_close_token1,
    STATE(3963), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427854] = 3,
    ACTIONS(1563), 1,
      aux_sym__paren_close_token1,
    STATE(6052), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427868] = 3,
    ACTIONS(1461), 1,
      aux_sym__paren_close_token1,
    STATE(6693), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427882] = 2,
    ACTIONS(10259), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427894] = 2,
    ACTIONS(11970), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427906] = 3,
    ACTIONS(1539), 1,
      aux_sym__paren_close_token1,
    STATE(5907), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427920] = 3,
    ACTIONS(11972), 1,
      aux_sym__paren_close_token1,
    STATE(7654), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427934] = 3,
    ACTIONS(1465), 1,
      aux_sym__paren_close_token1,
    STATE(3178), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427948] = 3,
    ACTIONS(1497), 1,
      aux_sym__paren_close_token1,
    STATE(7731), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427962] = 3,
    ACTIONS(1485), 1,
      aux_sym__paren_close_token1,
    STATE(5861), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427976] = 2,
    ACTIONS(11974), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427988] = 3,
    ACTIONS(11976), 1,
      sym_variable,
    STATE(5298), 1,
      sym_field_name,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428002] = 3,
    ACTIONS(1523), 1,
      aux_sym__paren_close_token1,
    STATE(3216), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428016] = 2,
    ACTIONS(11978), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428028] = 3,
    ACTIONS(1269), 1,
      aux_sym__paren_close_token1,
    STATE(4414), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428042] = 3,
    ACTIONS(1257), 1,
      aux_sym__paren_close_token1,
    STATE(5296), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428056] = 3,
    ACTIONS(11926), 1,
      anon_sym_DASH,
    STATE(2261), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428070] = 2,
    ACTIONS(10301), 2,
      anon_sym_COMMA,
      anon_sym_EQ,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428082] = 2,
    ACTIONS(10295), 2,
      anon_sym_COMMA,
      anon_sym_EQ,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428094] = 3,
    ACTIONS(1469), 1,
      aux_sym__paren_close_token1,
    STATE(7423), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428108] = 3,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    STATE(1689), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428122] = 2,
    ACTIONS(11980), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428134] = 3,
    ACTIONS(1411), 1,
      aux_sym__paren_close_token1,
    STATE(6907), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428148] = 3,
    ACTIONS(5551), 1,
      aux_sym__paren_close_token1,
    STATE(8908), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428162] = 2,
    ACTIONS(10263), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428174] = 2,
    ACTIONS(11982), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428186] = 3,
    ACTIONS(1493), 1,
      aux_sym__paren_close_token1,
    STATE(3918), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428200] = 2,
    ACTIONS(10336), 2,
      anon_sym_COMMA,
      anon_sym_EQ,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428212] = 3,
    ACTIONS(257), 1,
      sym__consym,
    STATE(11698), 1,
      sym_constructor_operator,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428226] = 3,
    ACTIONS(1443), 1,
      aux_sym__paren_close_token1,
    STATE(7339), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428240] = 3,
    ACTIONS(3503), 1,
      aux_sym__paren_close_token1,
    STATE(8085), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428254] = 3,
    ACTIONS(5539), 1,
      aux_sym__paren_close_token1,
    STATE(9000), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428268] = 3,
    ACTIONS(1249), 1,
      aux_sym__paren_close_token1,
    STATE(4175), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428282] = 2,
    ACTIONS(10265), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428294] = 3,
    ACTIONS(5545), 1,
      aux_sym__paren_close_token1,
    STATE(8561), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428308] = 3,
    ACTIONS(4438), 1,
      aux_sym__paren_close_token1,
    STATE(7694), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428322] = 2,
    ACTIONS(11984), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428334] = 3,
    ACTIONS(5549), 1,
      aux_sym__paren_close_token1,
    STATE(8370), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428348] = 2,
    ACTIONS(10139), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428360] = 3,
    ACTIONS(3501), 1,
      aux_sym__paren_close_token1,
    STATE(7911), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428374] = 3,
    ACTIONS(269), 1,
      aux_sym__paren_close_token1,
    STATE(5728), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428388] = 2,
    ACTIONS(10196), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428400] = 3,
    ACTIONS(1543), 1,
      aux_sym__paren_close_token1,
    STATE(6366), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428414] = 3,
    ACTIONS(3501), 1,
      aux_sym__paren_close_token1,
    STATE(7924), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428428] = 3,
    ACTIONS(1539), 1,
      aux_sym__paren_close_token1,
    STATE(5992), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428442] = 3,
    ACTIONS(1469), 1,
      aux_sym__paren_close_token1,
    STATE(7307), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428456] = 3,
    ACTIONS(1395), 1,
      aux_sym__paren_close_token1,
    STATE(6332), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428470] = 2,
    ACTIONS(11986), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428482] = 2,
    ACTIONS(11988), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428494] = 3,
    ACTIONS(1263), 1,
      aux_sym__paren_close_token1,
    STATE(4941), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428508] = 3,
    ACTIONS(1473), 1,
      aux_sym__paren_close_token1,
    STATE(6259), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428522] = 3,
    ACTIONS(2983), 1,
      aux_sym__paren_close_token1,
    STATE(9540), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428536] = 3,
    ACTIONS(1559), 1,
      aux_sym__paren_close_token1,
    STATE(7256), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428550] = 2,
    ACTIONS(11990), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428562] = 3,
    ACTIONS(6356), 1,
      aux_sym__paren_close_token1,
    STATE(8916), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428576] = 2,
    ACTIONS(11992), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428588] = 3,
    ACTIONS(1415), 1,
      aux_sym__paren_close_token1,
    STATE(6523), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428602] = 2,
    ACTIONS(10188), 2,
      anon_sym_COMMA,
      anon_sym_EQ,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428614] = 2,
    ACTIONS(11994), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428626] = 3,
    ACTIONS(4473), 1,
      aux_sym__paren_close_token1,
    STATE(8022), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428640] = 2,
    ACTIONS(11996), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428652] = 2,
    ACTIONS(11994), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428664] = 2,
    ACTIONS(11998), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428676] = 2,
    ACTIONS(12000), 2,
      sym__phantom_where,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428688] = 3,
    ACTIONS(1489), 1,
      aux_sym__paren_close_token1,
    STATE(7522), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428702] = 3,
    ACTIONS(5547), 1,
      aux_sym__paren_close_token1,
    STATE(8652), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428716] = 3,
    ACTIONS(3411), 1,
      aux_sym__paren_close_token1,
    STATE(7912), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428730] = 3,
    ACTIONS(209), 1,
      aux_sym__paren_close_token1,
    STATE(3619), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428744] = 2,
    ACTIONS(12002), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428756] = 2,
    ACTIONS(12004), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428768] = 3,
    ACTIONS(6356), 1,
      aux_sym__paren_close_token1,
    STATE(9863), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428782] = 3,
    ACTIONS(289), 1,
      aux_sym__paren_close_token1,
    STATE(7066), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428796] = 3,
    ACTIONS(2985), 1,
      anon_sym_RBRACK,
    STATE(3942), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428810] = 3,
    ACTIONS(1519), 1,
      aux_sym__paren_close_token1,
    STATE(7630), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428824] = 2,
    ACTIONS(12006), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428836] = 2,
    ACTIONS(12008), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428848] = 3,
    ACTIONS(1509), 1,
      aux_sym__paren_close_token1,
    STATE(6040), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428862] = 2,
    ACTIONS(12010), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428874] = 3,
    ACTIONS(1295), 1,
      aux_sym__paren_close_token1,
    STATE(4341), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428888] = 3,
    ACTIONS(1497), 1,
      aux_sym__paren_close_token1,
    STATE(7768), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428902] = 3,
    ACTIONS(1509), 1,
      aux_sym__paren_close_token1,
    STATE(6041), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428916] = 3,
    ACTIONS(1543), 1,
      aux_sym__paren_close_token1,
    STATE(6438), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428930] = 3,
    ACTIONS(1415), 1,
      aux_sym__paren_close_token1,
    STATE(6455), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428944] = 3,
    ACTIONS(1255), 1,
      aux_sym__paren_close_token1,
    STATE(3707), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428958] = 2,
    ACTIONS(12012), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428970] = 2,
    ACTIONS(12014), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428982] = 3,
    ACTIONS(1477), 1,
      aux_sym__paren_close_token1,
    STATE(7176), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428996] = 3,
    ACTIONS(3411), 1,
      aux_sym__paren_close_token1,
    STATE(7914), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429010] = 3,
    ACTIONS(1493), 1,
      aux_sym__paren_close_token1,
    STATE(3827), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429024] = 2,
    ACTIONS(12016), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429036] = 3,
    ACTIONS(1279), 1,
      aux_sym__paren_close_token1,
    STATE(2696), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429050] = 3,
    ACTIONS(1277), 1,
      aux_sym__paren_close_token1,
    STATE(4243), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429064] = 3,
    ACTIONS(1443), 1,
      aux_sym__paren_close_token1,
    STATE(7316), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429078] = 3,
    ACTIONS(1255), 1,
      aux_sym__paren_close_token1,
    STATE(3742), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429092] = 3,
    ACTIONS(1497), 1,
      aux_sym__paren_close_token1,
    STATE(7744), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429106] = 2,
    ACTIONS(12018), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429118] = 3,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    STATE(1499), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429132] = 3,
    ACTIONS(209), 1,
      aux_sym__paren_close_token1,
    STATE(3655), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429146] = 3,
    ACTIONS(269), 1,
      aux_sym__paren_close_token1,
    STATE(5734), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429160] = 2,
    ACTIONS(12020), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429172] = 3,
    ACTIONS(2881), 1,
      anon_sym_RBRACK,
    STATE(5317), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429186] = 3,
    ACTIONS(1435), 1,
      aux_sym__paren_close_token1,
    STATE(6536), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429200] = 3,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    STATE(1543), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429214] = 3,
    ACTIONS(3411), 1,
      aux_sym__paren_close_token1,
    STATE(7957), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429228] = 2,
    ACTIONS(12022), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429240] = 3,
    ACTIONS(283), 1,
      aux_sym__paren_close_token1,
    STATE(6489), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429254] = 3,
    ACTIONS(1275), 1,
      aux_sym__paren_close_token1,
    STATE(5445), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429268] = 3,
    ACTIONS(1519), 1,
      aux_sym__paren_close_token1,
    STATE(7683), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429282] = 3,
    ACTIONS(289), 1,
      aux_sym__paren_close_token1,
    STATE(7102), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429296] = 3,
    ACTIONS(1249), 1,
      aux_sym__paren_close_token1,
    STATE(4209), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429310] = 3,
    ACTIONS(1555), 1,
      aux_sym__paren_close_token1,
    STATE(7074), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429324] = 3,
    ACTIONS(10541), 1,
      anon_sym_import,
    STATE(11812), 1,
      sym_import,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429338] = 3,
    ACTIONS(11926), 1,
      anon_sym_DASH,
    STATE(2298), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429352] = 3,
    ACTIONS(1563), 1,
      aux_sym__paren_close_token1,
    STATE(5913), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429366] = 3,
    ACTIONS(1269), 1,
      aux_sym__paren_close_token1,
    STATE(4350), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429380] = 3,
    ACTIONS(1275), 1,
      aux_sym__paren_close_token1,
    STATE(5407), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429394] = 3,
    ACTIONS(289), 1,
      aux_sym__paren_close_token1,
    STATE(7104), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429408] = 3,
    ACTIONS(1289), 1,
      aux_sym__paren_close_token1,
    STATE(4119), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429422] = 3,
    ACTIONS(1497), 1,
      aux_sym__paren_close_token1,
    STATE(7787), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429436] = 3,
    ACTIONS(1257), 1,
      aux_sym__paren_close_token1,
    STATE(4536), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429450] = 3,
    ACTIONS(1527), 1,
      aux_sym__paren_close_token1,
    STATE(3680), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429464] = 3,
    ACTIONS(1269), 1,
      aux_sym__paren_close_token1,
    STATE(4359), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429478] = 3,
    ACTIONS(1275), 1,
      aux_sym__paren_close_token1,
    STATE(5421), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429492] = 3,
    ACTIONS(1449), 1,
      aux_sym__paren_close_token1,
    STATE(3086), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429506] = 3,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    STATE(1550), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429520] = 3,
    ACTIONS(1249), 1,
      aux_sym__paren_close_token1,
    STATE(4018), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429534] = 3,
    ACTIONS(1489), 1,
      aux_sym__paren_close_token1,
    STATE(7498), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429548] = 3,
    ACTIONS(169), 1,
      aux_sym__paren_close_token1,
    STATE(3754), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429562] = 3,
    ACTIONS(1277), 1,
      aux_sym__paren_close_token1,
    STATE(4302), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429576] = 3,
    ACTIONS(4434), 1,
      aux_sym__paren_close_token1,
    STATE(8057), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429590] = 3,
    ACTIONS(1257), 1,
      aux_sym__paren_close_token1,
    STATE(4661), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429604] = 3,
    ACTIONS(5543), 1,
      aux_sym__paren_close_token1,
    STATE(8756), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429618] = 3,
    ACTIONS(1493), 1,
      aux_sym__paren_close_token1,
    STATE(3903), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429632] = 3,
    ACTIONS(12024), 1,
      aux_sym__paren_close_token1,
    STATE(8944), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429646] = 3,
    ACTIONS(1473), 1,
      aux_sym__paren_close_token1,
    STATE(6204), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429660] = 3,
    ACTIONS(5545), 1,
      aux_sym__paren_close_token1,
    STATE(8605), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429674] = 2,
    ACTIONS(12026), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429686] = 3,
    ACTIONS(1279), 1,
      aux_sym__paren_close_token1,
    STATE(2726), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429700] = 3,
    ACTIONS(1277), 1,
      aux_sym__paren_close_token1,
    STATE(4240), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429714] = 3,
    ACTIONS(1489), 1,
      aux_sym__paren_close_token1,
    STATE(7517), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429728] = 3,
    ACTIONS(9688), 1,
      anon_sym_in,
    ACTIONS(9690), 1,
      sym__phantom_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429742] = 3,
    ACTIONS(1519), 1,
      aux_sym__paren_close_token1,
    STATE(7646), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429756] = 2,
    ACTIONS(12028), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429768] = 3,
    ACTIONS(12030), 1,
      anon_sym_PIPE,
    ACTIONS(12032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429782] = 2,
    ACTIONS(12034), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429794] = 3,
    ACTIONS(4469), 1,
      aux_sym__paren_close_token1,
    STATE(7970), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429808] = 3,
    ACTIONS(1269), 1,
      aux_sym__paren_close_token1,
    STATE(4548), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429822] = 3,
    ACTIONS(5547), 1,
      aux_sym__paren_close_token1,
    STATE(8645), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429836] = 3,
    ACTIONS(5549), 1,
      aux_sym__paren_close_token1,
    STATE(8374), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429850] = 3,
    ACTIONS(9573), 1,
      anon_sym_in,
    ACTIONS(9575), 1,
      sym__phantom_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429864] = 3,
    ACTIONS(1439), 1,
      aux_sym__paren_close_token1,
    STATE(6815), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429878] = 3,
    ACTIONS(283), 1,
      aux_sym__paren_close_token1,
    STATE(6242), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429892] = 2,
    ACTIONS(12036), 2,
      sym__phantom_where,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429904] = 3,
    ACTIONS(1469), 1,
      aux_sym__paren_close_token1,
    STATE(7408), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429918] = 3,
    ACTIONS(201), 1,
      aux_sym__paren_close_token1,
    STATE(3471), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429932] = 3,
    ACTIONS(1469), 1,
      aux_sym__paren_close_token1,
    STATE(7400), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429946] = 3,
    ACTIONS(1275), 1,
      aux_sym__paren_close_token1,
    STATE(4559), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429960] = 3,
    ACTIONS(1531), 1,
      aux_sym__paren_close_token1,
    STATE(3409), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429974] = 3,
    ACTIONS(5551), 1,
      aux_sym__paren_close_token1,
    STATE(8859), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429988] = 3,
    ACTIONS(269), 1,
      aux_sym__paren_close_token1,
    STATE(5741), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430002] = 3,
    ACTIONS(1427), 1,
      aux_sym__paren_close_token1,
    STATE(6970), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430016] = 3,
    ACTIONS(169), 1,
      aux_sym__paren_close_token1,
    STATE(3704), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430030] = 3,
    ACTIONS(12038), 1,
      anon_sym_RBRACK,
    STATE(9052), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430044] = 2,
    ACTIONS(10129), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430056] = 3,
    ACTIONS(4469), 1,
      aux_sym__paren_close_token1,
    STATE(7976), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430070] = 3,
    ACTIONS(1289), 1,
      aux_sym__paren_close_token1,
    STATE(4165), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430084] = 3,
    ACTIONS(185), 1,
      aux_sym__paren_close_token1,
    STATE(3181), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430098] = 3,
    ACTIONS(1263), 1,
      aux_sym__paren_close_token1,
    STATE(5047), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430112] = 2,
    ACTIONS(12040), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430124] = 3,
    ACTIONS(12042), 1,
      sym_variable,
    STATE(4340), 1,
      sym_field_name,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430138] = 3,
    ACTIONS(1269), 1,
      aux_sym__paren_close_token1,
    STATE(5325), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430152] = 3,
    ACTIONS(1269), 1,
      aux_sym__paren_close_token1,
    STATE(5326), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430166] = 3,
    ACTIONS(1411), 1,
      aux_sym__paren_close_token1,
    STATE(6949), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430180] = 2,
    ACTIONS(12044), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430192] = 3,
    ACTIONS(1559), 1,
      aux_sym__paren_close_token1,
    STATE(7309), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430206] = 2,
    ACTIONS(10105), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430218] = 3,
    ACTIONS(1505), 1,
      aux_sym__paren_close_token1,
    STATE(6872), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430232] = 3,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    STATE(1492), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430246] = 2,
    ACTIONS(12046), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430258] = 3,
    ACTIONS(1435), 1,
      aux_sym__paren_close_token1,
    STATE(6230), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430272] = 3,
    ACTIONS(4438), 1,
      aux_sym__paren_close_token1,
    STATE(7631), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430286] = 3,
    ACTIONS(1269), 1,
      aux_sym__paren_close_token1,
    STATE(5327), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430300] = 2,
    ACTIONS(12048), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430312] = 3,
    ACTIONS(1277), 1,
      aux_sym__paren_close_token1,
    STATE(4256), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430326] = 3,
    ACTIONS(5551), 1,
      aux_sym__paren_close_token1,
    STATE(8917), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430340] = 3,
    ACTIONS(12050), 1,
      sym_variable,
    STATE(8906), 1,
      aux_sym_type_family_injectivity_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430354] = 3,
    ACTIONS(2597), 1,
      aux_sym__paren_close_token1,
    STATE(9093), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430368] = 3,
    ACTIONS(1431), 1,
      aux_sym__paren_close_token1,
    STATE(6182), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430382] = 3,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    STATE(1659), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430396] = 3,
    ACTIONS(12052), 1,
      sym_variable,
    STATE(5614), 1,
      sym_field_name,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430410] = 3,
    ACTIONS(1415), 1,
      aux_sym__paren_close_token1,
    STATE(6554), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430424] = 3,
    ACTIONS(1563), 1,
      aux_sym__paren_close_token1,
    STATE(5885), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430438] = 3,
    ACTIONS(1415), 1,
      aux_sym__paren_close_token1,
    STATE(6545), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430452] = 3,
    ACTIONS(1457), 1,
      aux_sym__paren_close_token1,
    STATE(2316), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430466] = 3,
    ACTIONS(1551), 1,
      aux_sym__paren_close_token1,
    STATE(6745), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430480] = 2,
    ACTIONS(10127), 2,
      sym__cond_layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430492] = 3,
    ACTIONS(5539), 1,
      aux_sym__paren_close_token1,
    STATE(9119), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430506] = 3,
    ACTIONS(1501), 1,
      aux_sym__paren_close_token1,
    STATE(3408), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430520] = 3,
    ACTIONS(1519), 1,
      aux_sym__paren_close_token1,
    STATE(7629), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430534] = 3,
    ACTIONS(1555), 1,
      aux_sym__paren_close_token1,
    STATE(7056), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430548] = 2,
    ACTIONS(12054), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430560] = 3,
    ACTIONS(1257), 1,
      aux_sym__paren_close_token1,
    STATE(5242), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430574] = 3,
    ACTIONS(1257), 1,
      aux_sym__paren_close_token1,
    STATE(5240), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430588] = 3,
    ACTIONS(12056), 1,
      anon_sym_PIPE,
    ACTIONS(12058), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430602] = 3,
    ACTIONS(1275), 1,
      aux_sym__paren_close_token1,
    STATE(4338), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430616] = 2,
    ACTIONS(12060), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430628] = 3,
    ACTIONS(277), 1,
      aux_sym__paren_close_token1,
    STATE(7362), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430642] = 2,
    ACTIONS(12062), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430654] = 3,
    ACTIONS(1257), 1,
      aux_sym__paren_close_token1,
    STATE(5239), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430668] = 3,
    ACTIONS(1277), 1,
      aux_sym__paren_close_token1,
    STATE(4988), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430682] = 2,
    ACTIONS(12064), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430694] = 3,
    ACTIONS(1263), 1,
      aux_sym__paren_close_token1,
    STATE(5615), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430708] = 3,
    ACTIONS(2849), 1,
      anon_sym_RBRACK,
    STATE(5237), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430722] = 2,
    ACTIONS(12066), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430734] = 2,
    ACTIONS(12068), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430746] = 3,
    ACTIONS(249), 1,
      aux_sym__paren_close_token1,
    STATE(6003), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430760] = 3,
    ACTIONS(6280), 1,
      aux_sym__paren_close_token1,
    STATE(12160), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430774] = 2,
    ACTIONS(12070), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430786] = 3,
    ACTIONS(1249), 1,
      aux_sym__paren_close_token1,
    STATE(4184), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430800] = 3,
    ACTIONS(12072), 1,
      sym_variable,
    STATE(5004), 1,
      sym_field_name,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430814] = 2,
    ACTIONS(12074), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430826] = 3,
    ACTIONS(1465), 1,
      aux_sym__paren_close_token1,
    STATE(3342), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430840] = 3,
    ACTIONS(1295), 1,
      aux_sym__paren_close_token1,
    STATE(3994), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430854] = 3,
    ACTIONS(1435), 1,
      aux_sym__paren_close_token1,
    STATE(6566), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430868] = 3,
    ACTIONS(1257), 1,
      aux_sym__paren_close_token1,
    STATE(4523), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430882] = 3,
    ACTIONS(1439), 1,
      aux_sym__paren_close_token1,
    STATE(6835), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430896] = 3,
    ACTIONS(1257), 1,
      aux_sym__paren_close_token1,
    STATE(4522), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430910] = 3,
    ACTIONS(1485), 1,
      aux_sym__paren_close_token1,
    STATE(5856), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430924] = 3,
    ACTIONS(1523), 1,
      aux_sym__paren_close_token1,
    STATE(3394), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430938] = 3,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    STATE(1601), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430952] = 3,
    ACTIONS(11910), 1,
      anon_sym_DOT,
    ACTIONS(12076), 1,
      sym__varsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430966] = 3,
    ACTIONS(1535), 1,
      aux_sym__paren_close_token1,
    STATE(2809), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430980] = 2,
    ACTIONS(12078), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430992] = 2,
    ACTIONS(12080), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431004] = 3,
    ACTIONS(1543), 1,
      aux_sym__paren_close_token1,
    STATE(6191), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431018] = 3,
    ACTIONS(1505), 1,
      aux_sym__paren_close_token1,
    STATE(6988), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431032] = 2,
    ACTIONS(12082), 2,
      anon_sym_PIPE,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431044] = 3,
    ACTIONS(2983), 1,
      aux_sym__paren_close_token1,
    STATE(10182), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431058] = 3,
    ACTIONS(1457), 1,
      aux_sym__paren_close_token1,
    STATE(2307), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431072] = 3,
    ACTIONS(2859), 1,
      anon_sym_RBRACK,
    STATE(4838), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431086] = 2,
    ACTIONS(12084), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431098] = 3,
    ACTIONS(1249), 1,
      aux_sym__paren_close_token1,
    STATE(4224), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431112] = 3,
    ACTIONS(2887), 1,
      anon_sym_RBRACK,
    STATE(5331), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431126] = 2,
    ACTIONS(12086), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431138] = 2,
    ACTIONS(12088), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431150] = 3,
    ACTIONS(1563), 1,
      aux_sym__paren_close_token1,
    STATE(5935), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431164] = 3,
    ACTIONS(1555), 1,
      aux_sym__paren_close_token1,
    STATE(7025), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431178] = 3,
    ACTIONS(181), 1,
      aux_sym__paren_close_token1,
    STATE(2916), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431192] = 3,
    ACTIONS(1279), 1,
      aux_sym__paren_close_token1,
    STATE(2968), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431206] = 3,
    ACTIONS(12090), 1,
      anon_sym_PIPE,
    ACTIONS(12092), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431220] = 3,
    ACTIONS(1539), 1,
      aux_sym__paren_close_token1,
    STATE(5926), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431234] = 3,
    ACTIONS(269), 1,
      aux_sym__paren_close_token1,
    STATE(5726), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431248] = 3,
    ACTIONS(185), 1,
      aux_sym__paren_close_token1,
    STATE(3300), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431262] = 3,
    ACTIONS(1275), 1,
      aux_sym__paren_close_token1,
    STATE(4422), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431276] = 3,
    ACTIONS(1431), 1,
      aux_sym__paren_close_token1,
    STATE(6121), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431290] = 3,
    ACTIONS(1275), 1,
      aux_sym__paren_close_token1,
    STATE(4712), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431304] = 3,
    ACTIONS(1395), 1,
      aux_sym__paren_close_token1,
    STATE(6541), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431318] = 3,
    ACTIONS(1263), 1,
      aux_sym__paren_close_token1,
    STATE(4878), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431332] = 3,
    ACTIONS(1513), 1,
      aux_sym__paren_close_token1,
    STATE(3492), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431346] = 3,
    ACTIONS(1279), 1,
      aux_sym__paren_close_token1,
    STATE(2973), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431360] = 3,
    ACTIONS(169), 1,
      aux_sym__paren_close_token1,
    STATE(3710), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431374] = 3,
    ACTIONS(1443), 1,
      aux_sym__paren_close_token1,
    STATE(7315), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431388] = 3,
    ACTIONS(1485), 1,
      aux_sym__paren_close_token1,
    STATE(5814), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431402] = 3,
    ACTIONS(1423), 1,
      aux_sym__paren_close_token1,
    STATE(7566), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431416] = 2,
    ACTIONS(12094), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431428] = 2,
    ACTIONS(12096), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431440] = 3,
    ACTIONS(1279), 1,
      aux_sym__paren_close_token1,
    STATE(2975), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431454] = 3,
    ACTIONS(2919), 1,
      anon_sym_RBRACK,
    STATE(2991), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431468] = 3,
    ACTIONS(4438), 1,
      aux_sym__paren_close_token1,
    STATE(7710), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431482] = 3,
    ACTIONS(1295), 1,
      aux_sym__paren_close_token1,
    STATE(4114), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431496] = 3,
    ACTIONS(1489), 1,
      aux_sym__paren_close_token1,
    STATE(7510), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431510] = 3,
    ACTIONS(1543), 1,
      aux_sym__paren_close_token1,
    STATE(6468), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431524] = 3,
    ACTIONS(1411), 1,
      aux_sym__paren_close_token1,
    STATE(6849), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431538] = 3,
    ACTIONS(12098), 1,
      aux_sym__paren_close_token1,
    STATE(8748), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431552] = 3,
    ACTIONS(197), 1,
      aux_sym__paren_close_token1,
    STATE(3596), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431566] = 3,
    ACTIONS(1465), 1,
      aux_sym__paren_close_token1,
    STATE(3418), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431580] = 3,
    ACTIONS(197), 1,
      aux_sym__paren_close_token1,
    STATE(3469), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431594] = 3,
    ACTIONS(1255), 1,
      aux_sym__paren_close_token1,
    STATE(3759), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431608] = 3,
    ACTIONS(1477), 1,
      aux_sym__paren_close_token1,
    STATE(7072), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431622] = 2,
    ACTIONS(12100), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431634] = 2,
    ACTIONS(12102), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431646] = 2,
    ACTIONS(12104), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431658] = 3,
    ACTIONS(1395), 1,
      aux_sym__paren_close_token1,
    STATE(6503), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431672] = 3,
    ACTIONS(1443), 1,
      aux_sym__paren_close_token1,
    STATE(7355), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431686] = 2,
    ACTIONS(12106), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431698] = 3,
    ACTIONS(1505), 1,
      aux_sym__paren_close_token1,
    STATE(7007), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431712] = 3,
    ACTIONS(1279), 1,
      aux_sym__paren_close_token1,
    STATE(2744), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431726] = 2,
    ACTIONS(12108), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431738] = 2,
    ACTIONS(12110), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431750] = 2,
    ACTIONS(12112), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431762] = 3,
    ACTIONS(1497), 1,
      aux_sym__paren_close_token1,
    STATE(7733), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431776] = 3,
    ACTIONS(7897), 1,
      anon_sym_instance,
    STATE(10546), 1,
      sym__instance,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431790] = 3,
    ACTIONS(7897), 1,
      anon_sym_instance,
    STATE(10548), 1,
      sym__instance,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431804] = 3,
    ACTIONS(1457), 1,
      aux_sym__paren_close_token1,
    STATE(2303), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431818] = 3,
    ACTIONS(1539), 1,
      aux_sym__paren_close_token1,
    STATE(6025), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431832] = 3,
    ACTIONS(1457), 1,
      aux_sym__paren_close_token1,
    STATE(2309), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431846] = 3,
    ACTIONS(1527), 1,
      aux_sym__paren_close_token1,
    STATE(3438), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431860] = 3,
    ACTIONS(1449), 1,
      aux_sym__paren_close_token1,
    STATE(3070), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431874] = 2,
    ACTIONS(12114), 2,
      sym__phantom_where,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431886] = 2,
    ACTIONS(12116), 2,
      sym__phantom_where,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431898] = 3,
    ACTIONS(1527), 1,
      aux_sym__paren_close_token1,
    STATE(3427), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431912] = 3,
    ACTIONS(1249), 1,
      aux_sym__paren_close_token1,
    STATE(4722), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431926] = 2,
    ACTIONS(12118), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431938] = 3,
    ACTIONS(4473), 1,
      aux_sym__paren_close_token1,
    STATE(8016), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431952] = 2,
    ACTIONS(12120), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431964] = 3,
    ACTIONS(185), 1,
      aux_sym__paren_close_token1,
    STATE(3227), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431978] = 3,
    ACTIONS(5539), 1,
      aux_sym__paren_close_token1,
    STATE(9089), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431992] = 2,
    ACTIONS(12122), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432004] = 3,
    ACTIONS(197), 1,
      aux_sym__paren_close_token1,
    STATE(3672), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432018] = 3,
    ACTIONS(209), 1,
      aux_sym__paren_close_token1,
    STATE(3466), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432032] = 3,
    ACTIONS(1249), 1,
      aux_sym__paren_close_token1,
    STATE(4189), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432046] = 3,
    ACTIONS(1485), 1,
      aux_sym__paren_close_token1,
    STATE(5850), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432060] = 3,
    ACTIONS(1543), 1,
      aux_sym__paren_close_token1,
    STATE(6443), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432074] = 3,
    ACTIONS(1485), 1,
      aux_sym__paren_close_token1,
    STATE(5851), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432088] = 3,
    ACTIONS(1531), 1,
      aux_sym__paren_close_token1,
    STATE(3273), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432102] = 3,
    ACTIONS(1427), 1,
      aux_sym__paren_close_token1,
    STATE(7011), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432116] = 3,
    ACTIONS(1489), 1,
      aux_sym__paren_close_token1,
    STATE(7537), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432130] = 3,
    ACTIONS(12124), 1,
      aux_sym__paren_close_token1,
    STATE(8960), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432144] = 3,
    ACTIONS(1531), 1,
      aux_sym__paren_close_token1,
    STATE(3328), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432158] = 3,
    ACTIONS(1249), 1,
      aux_sym__paren_close_token1,
    STATE(4721), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432172] = 2,
    ACTIONS(12126), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432184] = 3,
    ACTIONS(1493), 1,
      aux_sym__paren_close_token1,
    STATE(3844), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432198] = 3,
    ACTIONS(1249), 1,
      aux_sym__paren_close_token1,
    STATE(4720), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432212] = 2,
    ACTIONS(12128), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432224] = 3,
    ACTIONS(5539), 1,
      aux_sym__paren_close_token1,
    STATE(9075), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432238] = 2,
    ACTIONS(12130), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432250] = 3,
    ACTIONS(1469), 1,
      aux_sym__paren_close_token1,
    STATE(7382), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432264] = 3,
    ACTIONS(12132), 1,
      anon_sym_PIPE,
    ACTIONS(12134), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432278] = 3,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    STATE(1431), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432292] = 3,
    ACTIONS(1395), 1,
      aux_sym__paren_close_token1,
    STATE(6418), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432306] = 3,
    ACTIONS(1497), 1,
      aux_sym__paren_close_token1,
    STATE(7785), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432320] = 3,
    ACTIONS(1395), 1,
      aux_sym__paren_close_token1,
    STATE(6417), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432334] = 3,
    ACTIONS(1551), 1,
      aux_sym__paren_close_token1,
    STATE(6718), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432348] = 3,
    ACTIONS(1501), 1,
      aux_sym__paren_close_token1,
    STATE(3355), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432362] = 3,
    ACTIONS(3411), 1,
      aux_sym__paren_close_token1,
    STATE(7916), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432376] = 3,
    ACTIONS(1559), 1,
      aux_sym__paren_close_token1,
    STATE(7372), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432390] = 3,
    ACTIONS(1551), 1,
      aux_sym__paren_close_token1,
    STATE(6713), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432404] = 3,
    ACTIONS(2857), 1,
      anon_sym_RBRACK,
    STATE(4718), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432418] = 2,
    ACTIONS(12136), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432430] = 2,
    ACTIONS(12138), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432442] = 3,
    ACTIONS(249), 1,
      aux_sym__paren_close_token1,
    STATE(6084), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432456] = 3,
    ACTIONS(1423), 1,
      aux_sym__paren_close_token1,
    STATE(7594), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432470] = 3,
    ACTIONS(1461), 1,
      aux_sym__paren_close_token1,
    STATE(6581), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432484] = 3,
    ACTIONS(4473), 1,
      aux_sym__paren_close_token1,
    STATE(8023), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432498] = 3,
    ACTIONS(1415), 1,
      aux_sym__paren_close_token1,
    STATE(6419), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432512] = 3,
    ACTIONS(1435), 1,
      aux_sym__paren_close_token1,
    STATE(6390), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432526] = 3,
    ACTIONS(1505), 1,
      aux_sym__paren_close_token1,
    STATE(6870), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432540] = 3,
    ACTIONS(1255), 1,
      aux_sym__paren_close_token1,
    STATE(3772), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432554] = 3,
    ACTIONS(1469), 1,
      aux_sym__paren_close_token1,
    STATE(7406), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432568] = 3,
    ACTIONS(1255), 1,
      aux_sym__paren_close_token1,
    STATE(3771), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432582] = 3,
    ACTIONS(1523), 1,
      aux_sym__paren_close_token1,
    STATE(3203), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432596] = 3,
    ACTIONS(1535), 1,
      aux_sym__paren_close_token1,
    STATE(2787), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432610] = 3,
    ACTIONS(1523), 1,
      aux_sym__paren_close_token1,
    STATE(3213), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432624] = 3,
    ACTIONS(1423), 1,
      aux_sym__paren_close_token1,
    STATE(7572), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432638] = 2,
    ACTIONS(12140), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432650] = 3,
    ACTIONS(1473), 1,
      aux_sym__paren_close_token1,
    STATE(6391), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432664] = 3,
    ACTIONS(1439), 1,
      aux_sym__paren_close_token1,
    STATE(6845), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432678] = 3,
    ACTIONS(12142), 1,
      aux_sym__paren_close_token1,
    STATE(8646), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432692] = 3,
    ACTIONS(5545), 1,
      aux_sym__paren_close_token1,
    STATE(8567), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432706] = 3,
    ACTIONS(1255), 1,
      aux_sym__paren_close_token1,
    STATE(3752), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432720] = 3,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    STATE(1707), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432734] = 3,
    ACTIONS(3411), 1,
      aux_sym__paren_close_token1,
    STATE(7998), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432748] = 3,
    ACTIONS(1527), 1,
      aux_sym__paren_close_token1,
    STATE(3637), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432762] = 3,
    ACTIONS(1415), 1,
      aux_sym__paren_close_token1,
    STATE(6399), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432776] = 3,
    ACTIONS(1527), 1,
      aux_sym__paren_close_token1,
    STATE(3617), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432790] = 3,
    ACTIONS(1263), 1,
      aux_sym__paren_close_token1,
    STATE(4865), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432804] = 3,
    ACTIONS(1513), 1,
      aux_sym__paren_close_token1,
    STATE(3679), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432818] = 3,
    ACTIONS(1477), 1,
      aux_sym__paren_close_token1,
    STATE(7030), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432832] = 3,
    ACTIONS(6280), 1,
      aux_sym__paren_close_token1,
    STATE(9777), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432846] = 2,
    ACTIONS(12144), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432858] = 3,
    ACTIONS(1493), 1,
      aux_sym__paren_close_token1,
    STATE(3906), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432872] = 3,
    ACTIONS(1539), 1,
      aux_sym__paren_close_token1,
    STATE(6000), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432886] = 3,
    ACTIONS(6356), 1,
      aux_sym__paren_close_token1,
    STATE(9306), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432900] = 3,
    ACTIONS(1257), 1,
      aux_sym__paren_close_token1,
    STATE(4479), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432914] = 3,
    ACTIONS(249), 1,
      aux_sym__paren_close_token1,
    STATE(6067), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432928] = 3,
    ACTIONS(1493), 1,
      aux_sym__paren_close_token1,
    STATE(3914), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432942] = 3,
    ACTIONS(1531), 1,
      aux_sym__paren_close_token1,
    STATE(3368), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432956] = 3,
    ACTIONS(1257), 1,
      aux_sym__paren_close_token1,
    STATE(4453), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432970] = 3,
    ACTIONS(1531), 1,
      aux_sym__paren_close_token1,
    STATE(3380), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432984] = 3,
    ACTIONS(1477), 1,
      aux_sym__paren_close_token1,
    STATE(7115), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432998] = 3,
    ACTIONS(1449), 1,
      aux_sym__paren_close_token1,
    STATE(3134), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433012] = 2,
    ACTIONS(12146), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433024] = 2,
    ACTIONS(12148), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433036] = 3,
    ACTIONS(283), 1,
      aux_sym__paren_close_token1,
    STATE(6198), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433050] = 2,
    ACTIONS(12150), 2,
      anon_sym_RBRACE,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433062] = 2,
    ACTIONS(12152), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433074] = 3,
    ACTIONS(1263), 1,
      aux_sym__paren_close_token1,
    STATE(4867), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433088] = 3,
    ACTIONS(12154), 1,
      anon_sym_PIPE,
    ACTIONS(12156), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433102] = 3,
    ACTIONS(1295), 1,
      aux_sym__paren_close_token1,
    STATE(4500), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433116] = 3,
    ACTIONS(1551), 1,
      aux_sym__paren_close_token1,
    STATE(6732), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433130] = 3,
    ACTIONS(1275), 1,
      aux_sym__paren_close_token1,
    STATE(4551), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433144] = 3,
    ACTIONS(1551), 1,
      aux_sym__paren_close_token1,
    STATE(6733), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433158] = 3,
    ACTIONS(1449), 1,
      aux_sym__paren_close_token1,
    STATE(3060), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433172] = 3,
    ACTIONS(1427), 1,
      aux_sym__paren_close_token1,
    STATE(6974), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433186] = 3,
    ACTIONS(1289), 1,
      aux_sym__paren_close_token1,
    STATE(4106), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433200] = 2,
    ACTIONS(12158), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433212] = 3,
    ACTIONS(277), 1,
      aux_sym__paren_close_token1,
    STATE(7280), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433226] = 2,
    ACTIONS(6157), 2,
      sym_variable,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433238] = 3,
    ACTIONS(12160), 1,
      sym_variable,
    ACTIONS(12162), 1,
      sym_name,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433252] = 3,
    ACTIONS(1275), 1,
      aux_sym__paren_close_token1,
    STATE(4774), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433266] = 2,
    ACTIONS(12164), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433278] = 3,
    ACTIONS(1295), 1,
      aux_sym__paren_close_token1,
    STATE(4501), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433292] = 3,
    ACTIONS(1523), 1,
      aux_sym__paren_close_token1,
    STATE(3372), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433306] = 3,
    ACTIONS(197), 1,
      aux_sym__paren_close_token1,
    STATE(3657), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433320] = 3,
    ACTIONS(1523), 1,
      aux_sym__paren_close_token1,
    STATE(3367), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433334] = 3,
    ACTIONS(1427), 1,
      aux_sym__paren_close_token1,
    STATE(6945), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433348] = 3,
    ACTIONS(1501), 1,
      aux_sym__paren_close_token1,
    STATE(3265), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433362] = 2,
    ACTIONS(12166), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433374] = 2,
    ACTIONS(12168), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433386] = 2,
    ACTIONS(12170), 2,
      sym__phantom_where,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433398] = 3,
    ACTIONS(1567), 1,
      aux_sym__paren_close_token1,
    STATE(5077), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433412] = 3,
    ACTIONS(1295), 1,
      aux_sym__paren_close_token1,
    STATE(4503), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433426] = 3,
    ACTIONS(1457), 1,
      aux_sym__paren_close_token1,
    STATE(2334), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433440] = 3,
    ACTIONS(12172), 1,
      anon_sym_RBRACK,
    STATE(8585), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433454] = 3,
    ACTIONS(2859), 1,
      anon_sym_RBRACK,
    STATE(4515), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433468] = 3,
    ACTIONS(1263), 1,
      aux_sym__paren_close_token1,
    STATE(5057), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433482] = 3,
    ACTIONS(1457), 1,
      aux_sym__paren_close_token1,
    STATE(2351), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433496] = 3,
    ACTIONS(1263), 1,
      aux_sym__paren_close_token1,
    STATE(5096), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433510] = 3,
    ACTIONS(1501), 1,
      aux_sym__paren_close_token1,
    STATE(3218), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433524] = 3,
    ACTIONS(1535), 1,
      aux_sym__paren_close_token1,
    STATE(2797), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433538] = 3,
    ACTIONS(283), 1,
      aux_sym__paren_close_token1,
    STATE(6201), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433552] = 2,
    ACTIONS(12174), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433564] = 2,
    ACTIONS(12176), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433576] = 3,
    ACTIONS(181), 1,
      aux_sym__paren_close_token1,
    STATE(2895), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433590] = 3,
    ACTIONS(12178), 1,
      anon_sym_in,
    ACTIONS(12180), 1,
      sym__phantom_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433604] = 3,
    ACTIONS(1485), 1,
      aux_sym__paren_close_token1,
    STATE(5829), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433618] = 2,
    ACTIONS(12182), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433630] = 2,
    ACTIONS(12184), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433642] = 3,
    ACTIONS(1477), 1,
      aux_sym__paren_close_token1,
    STATE(7154), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433656] = 3,
    ACTIONS(1485), 1,
      aux_sym__paren_close_token1,
    STATE(5836), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433670] = 3,
    ACTIONS(1477), 1,
      aux_sym__paren_close_token1,
    STATE(7156), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433684] = 3,
    ACTIONS(1535), 1,
      aux_sym__paren_close_token1,
    STATE(2766), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433698] = 3,
    ACTIONS(1513), 1,
      aux_sym__paren_close_token1,
    STATE(3458), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433712] = 3,
    ACTIONS(1295), 1,
      aux_sym__paren_close_token1,
    STATE(4191), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433726] = 2,
    ACTIONS(12186), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433738] = 2,
    ACTIONS(12188), 2,
      sym__phantom_where,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433750] = 3,
    ACTIONS(2919), 1,
      anon_sym_RBRACK,
    STATE(2981), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433764] = 3,
    ACTIONS(12190), 1,
      sym_variable,
    STATE(9624), 1,
      aux_sym_type_family_injectivity_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433778] = 3,
    ACTIONS(1395), 1,
      aux_sym__paren_close_token1,
    STATE(6353), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433792] = 3,
    ACTIONS(12192), 1,
      anon_sym_PIPE,
    ACTIONS(12194), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433806] = 3,
    ACTIONS(5549), 1,
      aux_sym__paren_close_token1,
    STATE(8391), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433820] = 3,
    ACTIONS(1449), 1,
      aux_sym__paren_close_token1,
    STATE(3073), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433834] = 3,
    ACTIONS(1395), 1,
      aux_sym__paren_close_token1,
    STATE(6334), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433848] = 3,
    ACTIONS(1449), 1,
      aux_sym__paren_close_token1,
    STATE(3065), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433862] = 3,
    ACTIONS(1513), 1,
      aux_sym__paren_close_token1,
    STATE(3588), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433876] = 2,
    ACTIONS(12196), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433888] = 3,
    ACTIONS(205), 1,
      aux_sym__paren_close_token1,
    STATE(3640), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433902] = 3,
    ACTIONS(1527), 1,
      aux_sym__paren_close_token1,
    STATE(3664), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433916] = 3,
    ACTIONS(1505), 1,
      aux_sym__paren_close_token1,
    STATE(6962), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433930] = 3,
    ACTIONS(1427), 1,
      aux_sym__paren_close_token1,
    STATE(6921), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433944] = 3,
    ACTIONS(1255), 1,
      aux_sym__paren_close_token1,
    STATE(3783), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433958] = 2,
    ACTIONS(12198), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433970] = 3,
    ACTIONS(4434), 1,
      aux_sym__paren_close_token1,
    STATE(8054), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433984] = 3,
    ACTIONS(1295), 1,
      aux_sym__paren_close_token1,
    STATE(4043), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433998] = 3,
    ACTIONS(1531), 1,
      aux_sym__paren_close_token1,
    STATE(3207), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434012] = 3,
    ACTIONS(1295), 1,
      aux_sym__paren_close_token1,
    STATE(4211), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434026] = 3,
    ACTIONS(1501), 1,
      aux_sym__paren_close_token1,
    STATE(3191), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434040] = 3,
    ACTIONS(1527), 1,
      aux_sym__paren_close_token1,
    STATE(3677), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434054] = 3,
    ACTIONS(1501), 1,
      aux_sym__paren_close_token1,
    STATE(3226), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434068] = 3,
    ACTIONS(3501), 1,
      aux_sym__paren_close_token1,
    STATE(7901), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434082] = 3,
    ACTIONS(1275), 1,
      aux_sym__paren_close_token1,
    STATE(5458), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434096] = 3,
    ACTIONS(1551), 1,
      aux_sym__paren_close_token1,
    STATE(6739), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434110] = 2,
    ACTIONS(12200), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434122] = 3,
    ACTIONS(1535), 1,
      aux_sym__paren_close_token1,
    STATE(2775), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434136] = 3,
    ACTIONS(1531), 1,
      aux_sym__paren_close_token1,
    STATE(3197), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434150] = 3,
    ACTIONS(1535), 1,
      aux_sym__paren_close_token1,
    STATE(2773), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434164] = 2,
    ACTIONS(12202), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434176] = 3,
    ACTIONS(12204), 1,
      sym_variable,
    STATE(8995), 1,
      aux_sym_type_family_injectivity_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434190] = 3,
    ACTIONS(1523), 1,
      aux_sym__paren_close_token1,
    STATE(3202), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434204] = 3,
    ACTIONS(1431), 1,
      aux_sym__paren_close_token1,
    STATE(6115), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434218] = 3,
    ACTIONS(1513), 1,
      aux_sym__paren_close_token1,
    STATE(3673), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434232] = 3,
    ACTIONS(1551), 1,
      aux_sym__paren_close_token1,
    STATE(6742), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434246] = 3,
    ACTIONS(1513), 1,
      aux_sym__paren_close_token1,
    STATE(3674), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434260] = 2,
    ACTIONS(12206), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434272] = 3,
    ACTIONS(11912), 1,
      sym__varsym,
    ACTIONS(12208), 1,
      anon_sym_DOT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434286] = 3,
    ACTIONS(1477), 1,
      aux_sym__paren_close_token1,
    STATE(7170), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434300] = 3,
    ACTIONS(1523), 1,
      aux_sym__paren_close_token1,
    STATE(3180), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434314] = 3,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    STATE(1616), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434328] = 2,
    ACTIONS(12210), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434340] = 3,
    ACTIONS(1449), 1,
      aux_sym__paren_close_token1,
    STATE(3110), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434354] = 3,
    ACTIONS(1263), 1,
      aux_sym__paren_close_token1,
    STATE(4962), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434368] = 2,
    ACTIONS(12212), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434380] = 3,
    ACTIONS(12214), 1,
      sym_variable,
    STATE(5234), 1,
      sym_field_name,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434394] = 3,
    ACTIONS(1427), 1,
      aux_sym__paren_close_token1,
    STATE(6910), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434408] = 3,
    ACTIONS(1477), 1,
      aux_sym__paren_close_token1,
    STATE(7177), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434422] = 3,
    ACTIONS(12216), 1,
      anon_sym_RBRACK,
    STATE(8385), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434436] = 2,
    ACTIONS(12218), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434448] = 3,
    ACTIONS(1501), 1,
      aux_sym__paren_close_token1,
    STATE(3304), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434462] = 3,
    ACTIONS(1449), 1,
      aux_sym__paren_close_token1,
    STATE(3109), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434476] = 2,
    ACTIONS(12220), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434488] = 2,
    ACTIONS(12222), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434500] = 3,
    ACTIONS(1535), 1,
      aux_sym__paren_close_token1,
    STATE(2817), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434514] = 3,
    ACTIONS(1427), 1,
      aux_sym__paren_close_token1,
    STATE(6906), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434528] = 3,
    ACTIONS(11926), 1,
      anon_sym_DASH,
    STATE(2271), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434542] = 3,
    ACTIONS(1513), 1,
      aux_sym__paren_close_token1,
    STATE(3646), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434556] = 3,
    ACTIONS(1501), 1,
      aux_sym__paren_close_token1,
    STATE(3309), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434570] = 3,
    ACTIONS(1567), 1,
      aux_sym__paren_close_token1,
    STATE(5099), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434584] = 3,
    ACTIONS(1535), 1,
      aux_sym__paren_close_token1,
    STATE(2765), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434598] = 3,
    ACTIONS(12224), 1,
      anon_sym_PIPE,
    ACTIONS(12226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434612] = 3,
    ACTIONS(1513), 1,
      aux_sym__paren_close_token1,
    STATE(3623), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434626] = 3,
    ACTIONS(12228), 1,
      sym_variable,
    STATE(5459), 1,
      sym_field_name,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434640] = 3,
    ACTIONS(209), 1,
      aux_sym__paren_close_token1,
    STATE(3495), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434654] = 3,
    ACTIONS(1699), 1,
      anon_sym_DASH,
    STATE(1471), 1,
      sym__operator_minus,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434668] = 2,
    ACTIONS(12230), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434680] = 3,
    ACTIONS(1263), 1,
      aux_sym__paren_close_token1,
    STATE(5529), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434694] = 2,
    ACTIONS(12232), 2,
      sym__cmd_layout_start_do,
      sym__cmd_layout_start_explicit,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434706] = 3,
    ACTIONS(1263), 1,
      aux_sym__paren_close_token1,
    STATE(5528), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434720] = 3,
    ACTIONS(1263), 1,
      aux_sym__paren_close_token1,
    STATE(5527), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434734] = 3,
    ACTIONS(7422), 1,
      sym_variable,
    STATE(10723), 1,
      sym_field_name,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434748] = 2,
    ACTIONS(12234), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434760] = 3,
    ACTIONS(2969), 1,
      anon_sym_RBRACK,
    STATE(5534), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434774] = 2,
    ACTIONS(12236), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434786] = 3,
    ACTIONS(12238), 1,
      anon_sym_in,
    ACTIONS(12240), 1,
      sym__phantom_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434800] = 3,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    STATE(11148), 1,
      aux_sym__type_tuple_elems_repeat1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434814] = 2,
    ACTIONS(12242), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434826] = 2,
    ACTIONS(12244), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434838] = 2,
    ACTIONS(12246), 2,
      sym__phantom_where,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434850] = 2,
    ACTIONS(12248), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434862] = 2,
    ACTIONS(12250), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434874] = 2,
    ACTIONS(12252), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434886] = 2,
    ACTIONS(12254), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434898] = 2,
    ACTIONS(9646), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434910] = 3,
    ACTIONS(1295), 1,
      aux_sym__paren_close_token1,
    STATE(3932), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434924] = 2,
    ACTIONS(12256), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434936] = 3,
    ACTIONS(12258), 1,
      anon_sym_PIPE,
    ACTIONS(12260), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434950] = 3,
    ACTIONS(1461), 1,
      aux_sym__paren_close_token1,
    STATE(6643), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434964] = 3,
    ACTIONS(2857), 1,
      anon_sym_RBRACK,
    STATE(4598), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434978] = 2,
    ACTIONS(12262), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434990] = 2,
    ACTIONS(12264), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435002] = 2,
    ACTIONS(12266), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435014] = 2,
    ACTIONS(12268), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435026] = 2,
    ACTIONS(12270), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435038] = 3,
    ACTIONS(1489), 1,
      aux_sym__paren_close_token1,
    STATE(7515), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435052] = 2,
    ACTIONS(12272), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435064] = 3,
    ACTIONS(1269), 1,
      aux_sym__paren_close_token1,
    STATE(4405), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435078] = 2,
    ACTIONS(12274), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435090] = 3,
    ACTIONS(2969), 1,
      anon_sym_RBRACK,
    STATE(5617), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435104] = 2,
    ACTIONS(6378), 2,
      sym_variable,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435116] = 3,
    ACTIONS(2849), 1,
      anon_sym_RBRACK,
    STATE(5188), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435130] = 3,
    ACTIONS(1269), 1,
      aux_sym__paren_close_token1,
    STATE(4402), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435144] = 3,
    ACTIONS(3503), 1,
      aux_sym__paren_close_token1,
    STATE(8082), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435158] = 3,
    ACTIONS(1269), 1,
      aux_sym__paren_close_token1,
    STATE(4351), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435172] = 2,
    ACTIONS(10159), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435184] = 3,
    ACTIONS(4473), 1,
      aux_sym__paren_close_token1,
    STATE(8024), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435198] = 3,
    ACTIONS(12276), 1,
      anon_sym_DOT,
    ACTIONS(12278), 1,
      sym__varsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435212] = 2,
    ACTIONS(12280), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435224] = 2,
    ACTIONS(12282), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435236] = 3,
    ACTIONS(1269), 1,
      aux_sym__paren_close_token1,
    STATE(5265), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435250] = 2,
    ACTIONS(12282), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435262] = 2,
    ACTIONS(12284), 2,
      sym__phantom_where,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435274] = 3,
    ACTIONS(12286), 1,
      anon_sym_by,
    ACTIONS(12288), 1,
      anon_sym_using,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435288] = 2,
    ACTIONS(12290), 2,
      anon_sym_COMMA,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435300] = 3,
    ACTIONS(12292), 1,
      anon_sym_PIPE,
    ACTIONS(12294), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435314] = 2,
    ACTIONS(12296), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435326] = 3,
    ACTIONS(9943), 1,
      anon_sym_in,
    ACTIONS(9945), 1,
      sym__phantom_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435340] = 3,
    ACTIONS(249), 1,
      aux_sym__paren_close_token1,
    STATE(6651), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435354] = 3,
    ACTIONS(257), 1,
      sym__consym,
    STATE(11502), 1,
      sym_constructor_operator,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435368] = 3,
    ACTIONS(1567), 1,
      aux_sym__paren_close_token1,
    STATE(5081), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435382] = 3,
    ACTIONS(277), 1,
      aux_sym__paren_close_token1,
    STATE(7468), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435396] = 2,
    ACTIONS(12298), 2,
      sym__cond_tight_dot,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435408] = 3,
    ACTIONS(1277), 1,
      aux_sym__paren_close_token1,
    STATE(4242), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435422] = 3,
    ACTIONS(185), 1,
      aux_sym__paren_close_token1,
    STATE(3155), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435436] = 3,
    ACTIONS(205), 1,
      aux_sym__paren_close_token1,
    STATE(3670), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435450] = 3,
    ACTIONS(1279), 1,
      aux_sym__paren_close_token1,
    STATE(2743), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435464] = 3,
    ACTIONS(289), 1,
      aux_sym__paren_close_token1,
    STATE(7166), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435478] = 3,
    ACTIONS(1567), 1,
      aux_sym__paren_close_token1,
    STATE(5085), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435492] = 2,
    ACTIONS(12300), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435504] = 3,
    ACTIONS(1509), 1,
      aux_sym__paren_close_token1,
    STATE(6053), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435518] = 3,
    ACTIONS(1411), 1,
      aux_sym__paren_close_token1,
    STATE(6923), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435532] = 2,
    ACTIONS(12302), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435544] = 3,
    ACTIONS(1465), 1,
      aux_sym__paren_close_token1,
    STATE(3285), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435558] = 2,
    ACTIONS(12304), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435570] = 2,
    ACTIONS(12306), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_u27e7,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435582] = 3,
    ACTIONS(2887), 1,
      anon_sym_RBRACK,
    STATE(5419), 1,
      sym__bracket_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435596] = 3,
    ACTIONS(12308), 1,
      anon_sym_PIPE,
    ACTIONS(12310), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435610] = 3,
    ACTIONS(3503), 1,
      aux_sym__paren_close_token1,
    STATE(8093), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435624] = 3,
    ACTIONS(7897), 1,
      anon_sym_instance,
    STATE(10852), 1,
      sym__instance,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435638] = 3,
    ACTIONS(7897), 1,
      anon_sym_instance,
    STATE(10851), 1,
      sym__instance,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435652] = 3,
    ACTIONS(1249), 1,
      aux_sym__paren_close_token1,
    STATE(4089), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435666] = 3,
    ACTIONS(5543), 1,
      aux_sym__paren_close_token1,
    STATE(8741), 1,
      sym__paren_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435680] = 2,
    ACTIONS(12312), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435691] = 2,
    ACTIONS(12314), 1,
      sym__cmd_texp_start,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435702] = 2,
    ACTIONS(12316), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435713] = 2,
    ACTIONS(12318), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435724] = 2,
    ACTIONS(12320), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435735] = 2,
    ACTIONS(12322), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435746] = 2,
    ACTIONS(12324), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435757] = 2,
    ACTIONS(12326), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435768] = 2,
    ACTIONS(12328), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435779] = 2,
    ACTIONS(12330), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435790] = 2,
    ACTIONS(12332), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435801] = 2,
    ACTIONS(12334), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435812] = 2,
    ACTIONS(12336), 1,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435823] = 2,
    ACTIONS(12338), 1,
      sym__cmd_texp_start,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435834] = 2,
    ACTIONS(12340), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435845] = 2,
    ACTIONS(3269), 1,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435856] = 2,
    ACTIONS(12342), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435867] = 2,
    ACTIONS(6139), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435878] = 2,
    ACTIONS(6404), 1,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435889] = 2,
    ACTIONS(12344), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435900] = 2,
    ACTIONS(12346), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435911] = 2,
    ACTIONS(12348), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435922] = 2,
    ACTIONS(12350), 1,
      sym__cond_assoc_tyinst,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435933] = 2,
    ACTIONS(12352), 1,
      anon_sym_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435944] = 2,
    ACTIONS(12354), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435955] = 2,
    ACTIONS(12356), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435966] = 2,
    ACTIONS(12358), 1,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435977] = 2,
    ACTIONS(12360), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435988] = 2,
    ACTIONS(12362), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435999] = 2,
    ACTIONS(12364), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436010] = 2,
    ACTIONS(12366), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436021] = 2,
    ACTIONS(12368), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436032] = 2,
    ACTIONS(12370), 1,
      anon_sym_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436043] = 2,
    ACTIONS(12372), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436054] = 2,
    ACTIONS(12374), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436065] = 2,
    ACTIONS(8254), 1,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436076] = 2,
    ACTIONS(12376), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436087] = 2,
    ACTIONS(12378), 1,
      sym__varsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436098] = 2,
    ACTIONS(12380), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436109] = 2,
    ACTIONS(12382), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436120] = 2,
    ACTIONS(12384), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436131] = 2,
    ACTIONS(12386), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436142] = 2,
    ACTIONS(12388), 1,
      sym__cmd_texp_start,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436153] = 2,
    ACTIONS(12390), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436164] = 2,
    ACTIONS(6342), 1,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436175] = 2,
    ACTIONS(6238), 1,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436186] = 2,
    ACTIONS(12392), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436197] = 2,
    ACTIONS(12394), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436208] = 2,
    ACTIONS(12396), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436219] = 2,
    ACTIONS(12398), 1,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436230] = 2,
    ACTIONS(12400), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436241] = 2,
    ACTIONS(12402), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436252] = 2,
    ACTIONS(12404), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436263] = 2,
    ACTIONS(12406), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436274] = 2,
    ACTIONS(12408), 1,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436285] = 2,
    ACTIONS(12410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436296] = 2,
    ACTIONS(12412), 1,
      sym__cmd_texp_start,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436307] = 2,
    ACTIONS(12414), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436318] = 2,
    ACTIONS(12416), 1,
      sym__cmd_texp_start,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436329] = 2,
    ACTIONS(12418), 1,
      anon_sym_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436340] = 2,
    ACTIONS(12420), 1,
      sym__cmd_texp_start,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436351] = 2,
    ACTIONS(12422), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436362] = 2,
    ACTIONS(12424), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436373] = 2,
    ACTIONS(12426), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436384] = 2,
    ACTIONS(12428), 1,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436395] = 2,
    ACTIONS(12430), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436406] = 2,
    ACTIONS(12432), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436417] = 2,
    ACTIONS(12434), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436428] = 2,
    ACTIONS(12436), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436439] = 2,
    ACTIONS(12438), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436450] = 2,
    ACTIONS(12440), 1,
      anon_sym_of,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436461] = 2,
    ACTIONS(12442), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436472] = 2,
    ACTIONS(12444), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436483] = 2,
    ACTIONS(12446), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436494] = 2,
    ACTIONS(12448), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436505] = 2,
    ACTIONS(12450), 1,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436516] = 2,
    ACTIONS(12452), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436527] = 2,
    ACTIONS(12454), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436538] = 2,
    ACTIONS(12456), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436549] = 2,
    ACTIONS(12458), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436560] = 2,
    ACTIONS(12460), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436571] = 2,
    ACTIONS(12462), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436582] = 2,
    ACTIONS(12464), 1,
      sym__cmd_brace_open,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436593] = 2,
    ACTIONS(12466), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436604] = 2,
    ACTIONS(12468), 1,
      sym__cmd_texp_start,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436615] = 2,
    ACTIONS(12470), 1,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436626] = 2,
    ACTIONS(12472), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436637] = 2,
    ACTIONS(12474), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436648] = 2,
    ACTIONS(12476), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436659] = 2,
    ACTIONS(12478), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436670] = 2,
    ACTIONS(12480), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436681] = 2,
    ACTIONS(12482), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436692] = 2,
    ACTIONS(12484), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436703] = 2,
    ACTIONS(12486), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436714] = 2,
    ACTIONS(12488), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436725] = 2,
    ACTIONS(12490), 1,
      sym__cmd_brace_open,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436736] = 2,
    ACTIONS(12492), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436747] = 2,
    ACTIONS(12494), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436758] = 2,
    ACTIONS(12496), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436769] = 2,
    ACTIONS(12498), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436780] = 2,
    ACTIONS(12500), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436791] = 2,
    ACTIONS(12502), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436802] = 2,
    ACTIONS(12504), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436813] = 2,
    ACTIONS(12506), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436824] = 2,
    ACTIONS(12508), 1,
      anon_sym_DOT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436835] = 2,
    ACTIONS(12510), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436846] = 2,
    ACTIONS(12512), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436857] = 2,
    ACTIONS(12276), 1,
      anon_sym_DOT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436868] = 2,
    ACTIONS(12514), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436879] = 2,
    ACTIONS(12516), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436890] = 2,
    ACTIONS(12518), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436901] = 2,
    ACTIONS(6420), 1,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436912] = 2,
    ACTIONS(12520), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436923] = 2,
    ACTIONS(12522), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436934] = 2,
    ACTIONS(12524), 1,
      sym__cmd_texp_start,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436945] = 2,
    ACTIONS(12526), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436956] = 2,
    ACTIONS(12528), 1,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436967] = 2,
    ACTIONS(12530), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436978] = 2,
    ACTIONS(12532), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436989] = 2,
    ACTIONS(12534), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437000] = 2,
    ACTIONS(12536), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437011] = 2,
    ACTIONS(12538), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437022] = 2,
    ACTIONS(12540), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437033] = 2,
    ACTIONS(12542), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437044] = 2,
    ACTIONS(12544), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437055] = 2,
    ACTIONS(12546), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437066] = 2,
    ACTIONS(12548), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437077] = 2,
    ACTIONS(12550), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437088] = 2,
    ACTIONS(12552), 1,
      anon_sym_EQ,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437099] = 2,
    ACTIONS(12554), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437110] = 2,
    ACTIONS(12556), 1,
      anon_sym_AT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437121] = 2,
    ACTIONS(12558), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437132] = 2,
    ACTIONS(12560), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437143] = 2,
    ACTIONS(12562), 1,
      anon_sym_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437154] = 2,
    ACTIONS(12564), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437165] = 2,
    ACTIONS(12566), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437176] = 2,
    ACTIONS(12568), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437187] = 2,
    ACTIONS(12570), 1,
      sym_calling_convention,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437198] = 2,
    ACTIONS(12572), 1,
      sym_calling_convention,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437209] = 2,
    ACTIONS(12574), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437220] = 2,
    ACTIONS(12576), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437231] = 2,
    ACTIONS(12578), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437242] = 2,
    ACTIONS(12580), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437253] = 2,
    ACTIONS(12582), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437264] = 2,
    ACTIONS(6250), 1,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437275] = 2,
    ACTIONS(12584), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437286] = 2,
    ACTIONS(12586), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437297] = 2,
    ACTIONS(12588), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437308] = 2,
    ACTIONS(12590), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437319] = 2,
    ACTIONS(12592), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437330] = 2,
    ACTIONS(12594), 1,
      anon_sym_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437341] = 2,
    ACTIONS(12596), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437352] = 2,
    ACTIONS(12598), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437363] = 2,
    ACTIONS(12600), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437374] = 2,
    ACTIONS(12602), 1,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437385] = 2,
    ACTIONS(12604), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437396] = 2,
    ACTIONS(12606), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437407] = 2,
    ACTIONS(12608), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437418] = 2,
    ACTIONS(12610), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437429] = 2,
    ACTIONS(12612), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437440] = 2,
    ACTIONS(12614), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437451] = 2,
    ACTIONS(12616), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437462] = 2,
    ACTIONS(12618), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437473] = 2,
    ACTIONS(12620), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437484] = 2,
    ACTIONS(12622), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437495] = 2,
    ACTIONS(12624), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437506] = 2,
    ACTIONS(12626), 1,
      sym__varsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437517] = 2,
    ACTIONS(12628), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437528] = 2,
    ACTIONS(12630), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437539] = 2,
    ACTIONS(12632), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437550] = 2,
    ACTIONS(12634), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437561] = 2,
    ACTIONS(12636), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437572] = 2,
    ACTIONS(12638), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437583] = 2,
    ACTIONS(12640), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437594] = 2,
    ACTIONS(12642), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437605] = 2,
    ACTIONS(12644), 1,
      anon_sym_PERCENT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437616] = 2,
    ACTIONS(12646), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437627] = 2,
    ACTIONS(12648), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437638] = 2,
    ACTIONS(12650), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437649] = 2,
    ACTIONS(12652), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437660] = 2,
    ACTIONS(12654), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437671] = 2,
    ACTIONS(12656), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437682] = 2,
    ACTIONS(12658), 1,
      anon_sym_using,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437693] = 2,
    ACTIONS(12660), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437704] = 2,
    ACTIONS(12662), 1,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437715] = 2,
    ACTIONS(12664), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437726] = 2,
    ACTIONS(12666), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437737] = 2,
    ACTIONS(12668), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437748] = 2,
    ACTIONS(12670), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437759] = 2,
    ACTIONS(12672), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437770] = 2,
    ACTIONS(12674), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437781] = 2,
    ACTIONS(12676), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437792] = 2,
    ACTIONS(12678), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437803] = 2,
    ACTIONS(12680), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437814] = 2,
    ACTIONS(12682), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437825] = 2,
    ACTIONS(12684), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437836] = 2,
    ACTIONS(7059), 1,
      anon_sym_instance,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437847] = 2,
    ACTIONS(12686), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437858] = 2,
    ACTIONS(12688), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437869] = 2,
    ACTIONS(12690), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437880] = 2,
    ACTIONS(12692), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437891] = 2,
    ACTIONS(12694), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437902] = 2,
    ACTIONS(12696), 1,
      sym__cond_assoc_tyinst,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437913] = 2,
    ACTIONS(12698), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437924] = 2,
    ACTIONS(12700), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437935] = 2,
    ACTIONS(12702), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437946] = 2,
    ACTIONS(12704), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437957] = 2,
    ACTIONS(12706), 1,
      anon_sym_of,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437968] = 2,
    ACTIONS(12708), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437979] = 2,
    ACTIONS(12710), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437990] = 2,
    ACTIONS(12712), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438001] = 2,
    ACTIONS(12714), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438012] = 2,
    ACTIONS(12716), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438023] = 2,
    ACTIONS(12718), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438034] = 2,
    ACTIONS(12720), 1,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438045] = 2,
    ACTIONS(12722), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438056] = 2,
    ACTIONS(12724), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438067] = 2,
    ACTIONS(12726), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438078] = 2,
    ACTIONS(12728), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438089] = 2,
    ACTIONS(12730), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438100] = 2,
    ACTIONS(12076), 1,
      sym__varsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438111] = 2,
    ACTIONS(12732), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438122] = 2,
    ACTIONS(12734), 1,
      anon_sym_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438133] = 2,
    ACTIONS(12736), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438144] = 2,
    ACTIONS(12738), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438155] = 2,
    ACTIONS(12740), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438166] = 2,
    ACTIONS(12742), 1,
      anon_sym_of,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438177] = 2,
    ACTIONS(12744), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438188] = 2,
    ACTIONS(12746), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438199] = 2,
    ACTIONS(12748), 1,
      anon_sym_DOT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438210] = 2,
    ACTIONS(12750), 1,
      anon_sym_DOT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438221] = 2,
    ACTIONS(12752), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438232] = 2,
    ACTIONS(12754), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438243] = 2,
    ACTIONS(12756), 1,
      anon_sym_of,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438254] = 2,
    ACTIONS(11912), 1,
      sym__varsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438265] = 2,
    ACTIONS(12758), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438276] = 2,
    ACTIONS(12760), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438287] = 2,
    ACTIONS(12762), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438298] = 2,
    ACTIONS(12764), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438309] = 2,
    ACTIONS(12766), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438320] = 2,
    ACTIONS(12768), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438331] = 2,
    ACTIONS(12770), 1,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438342] = 2,
    ACTIONS(12772), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438353] = 2,
    ACTIONS(12774), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438364] = 2,
    ACTIONS(12776), 1,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438375] = 2,
    ACTIONS(12778), 1,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438386] = 2,
    ACTIONS(12780), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438397] = 2,
    ACTIONS(12782), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438408] = 2,
    ACTIONS(12784), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438419] = 2,
    ACTIONS(12786), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438430] = 2,
    ACTIONS(12788), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438441] = 2,
    ACTIONS(12790), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438452] = 2,
    ACTIONS(12792), 1,
      sym__cmd_brace_open,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438463] = 2,
    ACTIONS(12794), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438474] = 2,
    ACTIONS(12796), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438485] = 2,
    ACTIONS(12798), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438496] = 2,
    ACTIONS(12800), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438507] = 2,
    ACTIONS(12802), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438518] = 2,
    ACTIONS(12804), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438529] = 2,
    ACTIONS(12806), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438540] = 2,
    ACTIONS(12808), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438551] = 2,
    ACTIONS(12810), 1,
      anon_sym_of,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438562] = 2,
    ACTIONS(12812), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438573] = 2,
    ACTIONS(12814), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438584] = 2,
    ACTIONS(12816), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438595] = 2,
    ACTIONS(12818), 1,
      anon_sym_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438606] = 2,
    ACTIONS(12820), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438617] = 2,
    ACTIONS(12822), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438628] = 2,
    ACTIONS(12824), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438639] = 2,
    ACTIONS(12826), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438650] = 2,
    ACTIONS(12828), 1,
      anon_sym_DOT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438661] = 2,
    ACTIONS(12830), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438672] = 2,
    ACTIONS(12832), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438683] = 2,
    ACTIONS(12834), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438694] = 2,
    ACTIONS(12836), 1,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438705] = 2,
    ACTIONS(12838), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438716] = 2,
    ACTIONS(12840), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438727] = 2,
    ACTIONS(12842), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438738] = 2,
    ACTIONS(12844), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438749] = 2,
    ACTIONS(12846), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438760] = 2,
    ACTIONS(12848), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438771] = 2,
    ACTIONS(12850), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438782] = 2,
    ACTIONS(12852), 1,
      anon_sym_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438793] = 2,
    ACTIONS(12854), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438804] = 2,
    ACTIONS(12856), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438815] = 2,
    ACTIONS(12858), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438826] = 2,
    ACTIONS(12860), 1,
      sym__cmd_texp_start,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438837] = 2,
    ACTIONS(12862), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438848] = 2,
    ACTIONS(12864), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438859] = 2,
    ACTIONS(12866), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438870] = 2,
    ACTIONS(12868), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438881] = 2,
    ACTIONS(12870), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438892] = 2,
    ACTIONS(12872), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438903] = 2,
    ACTIONS(12874), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438914] = 2,
    ACTIONS(12876), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438925] = 2,
    ACTIONS(12878), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438936] = 2,
    ACTIONS(12880), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438947] = 2,
    ACTIONS(12882), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438958] = 2,
    ACTIONS(12884), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438969] = 2,
    ACTIONS(12886), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438980] = 2,
    ACTIONS(12888), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438991] = 2,
    ACTIONS(9875), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439002] = 2,
    ACTIONS(12890), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439013] = 2,
    ACTIONS(12892), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439024] = 2,
    ACTIONS(12894), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439035] = 2,
    ACTIONS(12896), 1,
      sym__cmd_texp_start,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439046] = 2,
    ACTIONS(12898), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439057] = 2,
    ACTIONS(12900), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439068] = 2,
    ACTIONS(12902), 1,
      anon_sym_AT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439079] = 2,
    ACTIONS(12904), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439090] = 2,
    ACTIONS(12906), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439101] = 2,
    ACTIONS(12908), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439112] = 2,
    ACTIONS(12910), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439123] = 2,
    ACTIONS(12912), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439134] = 2,
    ACTIONS(12914), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439145] = 2,
    ACTIONS(12916), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439156] = 2,
    ACTIONS(12918), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439167] = 2,
    ACTIONS(12920), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439178] = 2,
    ACTIONS(12922), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439189] = 2,
    ACTIONS(12924), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439200] = 2,
    ACTIONS(12926), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439211] = 2,
    ACTIONS(12928), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439222] = 2,
    ACTIONS(12930), 1,
      anon_sym_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439233] = 2,
    ACTIONS(12932), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439244] = 2,
    ACTIONS(12934), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439255] = 2,
    ACTIONS(12936), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439266] = 2,
    ACTIONS(12938), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439277] = 2,
    ACTIONS(12940), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439288] = 2,
    ACTIONS(12942), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439299] = 2,
    ACTIONS(12944), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439310] = 2,
    ACTIONS(12946), 1,
      anon_sym_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439321] = 2,
    ACTIONS(12948), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439332] = 2,
    ACTIONS(12950), 1,
      anon_sym_DOT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439343] = 2,
    ACTIONS(12952), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439354] = 2,
    ACTIONS(12954), 1,
      anon_sym_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439365] = 2,
    ACTIONS(12956), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439376] = 2,
    ACTIONS(12958), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439387] = 2,
    ACTIONS(12960), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439398] = 2,
    ACTIONS(12962), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439409] = 2,
    ACTIONS(12964), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439420] = 2,
    ACTIONS(12966), 1,
      sym__cmd_texp_start,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439431] = 2,
    ACTIONS(12968), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439442] = 2,
    ACTIONS(11294), 1,
      anon_sym_EQ,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439453] = 2,
    ACTIONS(12970), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439464] = 2,
    ACTIONS(12972), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439475] = 2,
    ACTIONS(12974), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439486] = 2,
    ACTIONS(12976), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439497] = 2,
    ACTIONS(12978), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439508] = 2,
    ACTIONS(12980), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439519] = 2,
    ACTIONS(12982), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439530] = 2,
    ACTIONS(12984), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439541] = 2,
    ACTIONS(12986), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439552] = 2,
    ACTIONS(12988), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439563] = 2,
    ACTIONS(12990), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439574] = 2,
    ACTIONS(12992), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439585] = 2,
    ACTIONS(12994), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439596] = 2,
    ACTIONS(12996), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439607] = 2,
    ACTIONS(12998), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439618] = 2,
    ACTIONS(13000), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439629] = 2,
    ACTIONS(13002), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439640] = 2,
    ACTIONS(13004), 1,
      anon_sym_of,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439651] = 2,
    ACTIONS(13006), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439662] = 2,
    ACTIONS(13008), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439673] = 2,
    ACTIONS(13010), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439684] = 2,
    ACTIONS(13012), 1,
      sym__cmd_texp_start,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439695] = 2,
    ACTIONS(13014), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439706] = 2,
    ACTIONS(13016), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439717] = 2,
    ACTIONS(13018), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439728] = 2,
    ACTIONS(13020), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439739] = 2,
    ACTIONS(13022), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439750] = 2,
    ACTIONS(13024), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439761] = 2,
    ACTIONS(13026), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439772] = 2,
    ACTIONS(13028), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439783] = 2,
    ACTIONS(13030), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439794] = 2,
    ACTIONS(13032), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439805] = 2,
    ACTIONS(13034), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439816] = 2,
    ACTIONS(13036), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439827] = 2,
    ACTIONS(13038), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439838] = 2,
    ACTIONS(13040), 1,
      anon_sym_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439849] = 2,
    ACTIONS(13042), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439860] = 2,
    ACTIONS(13044), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439871] = 2,
    ACTIONS(13046), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439882] = 2,
    ACTIONS(13048), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439893] = 2,
    ACTIONS(13050), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439904] = 2,
    ACTIONS(13052), 1,
      anon_sym_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439915] = 2,
    ACTIONS(13054), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439926] = 2,
    ACTIONS(13056), 1,
      anon_sym_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439937] = 2,
    ACTIONS(13058), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439948] = 2,
    ACTIONS(13060), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439959] = 2,
    ACTIONS(13062), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439970] = 2,
    ACTIONS(13064), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439981] = 2,
    ACTIONS(13066), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439992] = 2,
    ACTIONS(13068), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440003] = 2,
    ACTIONS(13070), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440014] = 2,
    ACTIONS(13072), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440025] = 2,
    ACTIONS(13074), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440036] = 2,
    ACTIONS(13076), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440047] = 2,
    ACTIONS(13078), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440058] = 2,
    ACTIONS(13080), 1,
      sym__cmd_texp_start,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440069] = 2,
    ACTIONS(13082), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440080] = 2,
    ACTIONS(13084), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440091] = 2,
    ACTIONS(13086), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440102] = 2,
    ACTIONS(13088), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440113] = 2,
    ACTIONS(13090), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440124] = 2,
    ACTIONS(13092), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440135] = 2,
    ACTIONS(13094), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440146] = 2,
    ACTIONS(13096), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440157] = 2,
    ACTIONS(13098), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440168] = 2,
    ACTIONS(13100), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440179] = 2,
    ACTIONS(13102), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440190] = 2,
    ACTIONS(13104), 1,
      anon_sym_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440201] = 2,
    ACTIONS(13106), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440212] = 2,
    ACTIONS(13108), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440223] = 2,
    ACTIONS(13110), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440234] = 2,
    ACTIONS(13112), 1,
      anon_sym_where,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440245] = 2,
    ACTIONS(13114), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440256] = 2,
    ACTIONS(13116), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440267] = 2,
    ACTIONS(13118), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440278] = 2,
    ACTIONS(13120), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440289] = 2,
    ACTIONS(13122), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440300] = 2,
    ACTIONS(13124), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440311] = 2,
    ACTIONS(13126), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440322] = 2,
    ACTIONS(13128), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440333] = 2,
    ACTIONS(13130), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440344] = 2,
    ACTIONS(13132), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440355] = 2,
    ACTIONS(13134), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440366] = 2,
    ACTIONS(13136), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440377] = 2,
    ACTIONS(13138), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440388] = 2,
    ACTIONS(13140), 1,
      anon_sym_DOT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440399] = 2,
    ACTIONS(13142), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440410] = 2,
    ACTIONS(13144), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440421] = 2,
    ACTIONS(13146), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440432] = 2,
    ACTIONS(13148), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440443] = 2,
    ACTIONS(13150), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440454] = 2,
    ACTIONS(13152), 1,
      sym__cmd_texp_start,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440465] = 2,
    ACTIONS(13154), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440476] = 2,
    ACTIONS(13156), 1,
      sym__cmd_texp_start,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440487] = 2,
    ACTIONS(13158), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440498] = 2,
    ACTIONS(13160), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440509] = 2,
    ACTIONS(13162), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440520] = 2,
    ACTIONS(13164), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440531] = 2,
    ACTIONS(13166), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440542] = 2,
    ACTIONS(13168), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440553] = 2,
    ACTIONS(13170), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440564] = 2,
    ACTIONS(13172), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440575] = 2,
    ACTIONS(13174), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440586] = 2,
    ACTIONS(13176), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440597] = 2,
    ACTIONS(13178), 1,
      anon_sym_PIPE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440608] = 2,
    ACTIONS(13180), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440619] = 2,
    ACTIONS(13182), 1,
      sym__varsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440630] = 2,
    ACTIONS(13184), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440641] = 2,
    ACTIONS(13186), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440652] = 2,
    ACTIONS(13188), 1,
      sym__cmd_brace_open,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440663] = 2,
    ACTIONS(13190), 1,
      sym__cmd_brace_open,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440674] = 2,
    ACTIONS(13192), 1,
      anon_sym_of,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440685] = 2,
    ACTIONS(13194), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440696] = 2,
    ACTIONS(13196), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440707] = 2,
    ACTIONS(13198), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440718] = 2,
    ACTIONS(13200), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440729] = 2,
    ACTIONS(13202), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440740] = 2,
    ACTIONS(13204), 1,
      sym_variable,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440751] = 2,
    ACTIONS(13206), 1,
      sym__cmd_brace_open,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440762] = 2,
    ACTIONS(13208), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440773] = 2,
    ACTIONS(13210), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440784] = 2,
    ACTIONS(13212), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440795] = 2,
    ACTIONS(13214), 1,
      anon_sym_AT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440806] = 2,
    ACTIONS(13216), 1,
      anon_sym_TILDE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440817] = 2,
    ACTIONS(13218), 1,
      anon_sym_TILDE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440828] = 2,
    ACTIONS(13220), 1,
      anon_sym_BANG,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440839] = 2,
    ACTIONS(13222), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440850] = 2,
    ACTIONS(13224), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440861] = 2,
    ACTIONS(13226), 1,
      anon_sym_BANG,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440872] = 2,
    ACTIONS(13228), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440883] = 2,
    ACTIONS(13230), 1,
      anon_sym_deriving,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440894] = 2,
    ACTIONS(13232), 1,
      anon_sym_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440905] = 2,
    ACTIONS(13234), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440916] = 2,
    ACTIONS(13236), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440927] = 2,
    ACTIONS(13238), 1,
      sym__cmd_texp_start,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440938] = 2,
    ACTIONS(13240), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440949] = 2,
    ACTIONS(13242), 1,
      sym__cmd_texp_start,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440960] = 2,
    ACTIONS(13244), 1,
      anon_sym_of,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440971] = 2,
    ACTIONS(13246), 1,
      sym__cmd_brace_open,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440982] = 2,
    ACTIONS(13248), 1,
      sym__cmd_brace_open,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440993] = 2,
    ACTIONS(13250), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441004] = 2,
    ACTIONS(13252), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441015] = 2,
    ACTIONS(13254), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441026] = 2,
    ACTIONS(13256), 1,
      sym__cmd_brace_open,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441037] = 2,
    ACTIONS(13258), 1,
      anon_sym_TILDE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441048] = 2,
    ACTIONS(13260), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441059] = 2,
    ACTIONS(13262), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441070] = 2,
    ACTIONS(13264), 1,
      sym__cmd_brace_open,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441081] = 2,
    ACTIONS(13266), 1,
      sym__cmd_brace_open,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441092] = 2,
    ACTIONS(13268), 1,
      anon_sym_deriving,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441103] = 2,
    ACTIONS(13270), 1,
      anon_sym_TILDE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441114] = 2,
    ACTIONS(13272), 1,
      anon_sym_EQ,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441125] = 2,
    ACTIONS(13274), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441136] = 2,
    ACTIONS(13276), 1,
      sym__cmd_texp_start,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441147] = 2,
    ACTIONS(13278), 1,
      sym__cmd_brace_open,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441158] = 2,
    ACTIONS(13280), 1,
      sym__cmd_brace_open,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441169] = 2,
    ACTIONS(13282), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441180] = 2,
    ACTIONS(13284), 1,
      anon_sym_BANG,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441191] = 2,
    ACTIONS(13286), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441202] = 2,
    ACTIONS(13288), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441213] = 2,
    ACTIONS(13290), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441224] = 2,
    ACTIONS(13292), 1,
      sym__cmd_brace_open,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441235] = 2,
    ACTIONS(13294), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441246] = 2,
    ACTIONS(13296), 1,
      anon_sym_BANG,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441257] = 2,
    ACTIONS(13298), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441268] = 2,
    ACTIONS(13300), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441279] = 2,
    ACTIONS(13302), 1,
      sym__cmd_texp_start,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441290] = 2,
    ACTIONS(13304), 1,
      sym__cmd_brace_open,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441301] = 2,
    ACTIONS(13306), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441312] = 2,
    ACTIONS(13308), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441323] = 2,
    ACTIONS(13310), 1,
      anon_sym_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441334] = 2,
    ACTIONS(13312), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441345] = 2,
    ACTIONS(13314), 1,
      sym__cmd_brace_close,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441356] = 2,
    ACTIONS(13316), 1,
      sym__cmd_brace_open,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441367] = 2,
    ACTIONS(13318), 1,
      anon_sym_of,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441378] = 2,
    ACTIONS(13320), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441389] = 2,
    ACTIONS(13322), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441400] = 2,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441411] = 2,
    ACTIONS(13326), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441422] = 2,
    ACTIONS(13328), 1,
      sym__cmd_brace_open,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441433] = 2,
    ACTIONS(13330), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441444] = 2,
    ACTIONS(13332), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441455] = 2,
    ACTIONS(13334), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441466] = 2,
    ACTIONS(13336), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441477] = 2,
    ACTIONS(13338), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441488] = 2,
    ACTIONS(13340), 1,
      sym__cmd_brace_open,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441499] = 2,
    ACTIONS(13342), 1,
      sym_name,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441510] = 2,
    ACTIONS(6412), 1,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441521] = 2,
    ACTIONS(13344), 1,
      anon_sym_of,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441532] = 2,
    ACTIONS(13346), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441543] = 2,
    ACTIONS(13348), 1,
      sym__varsym,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441554] = 2,
    ACTIONS(13350), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441565] = 2,
    ACTIONS(13352), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441576] = 2,
    ACTIONS(13354), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441587] = 2,
    ACTIONS(13356), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441598] = 2,
    ACTIONS(13358), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441609] = 2,
    ACTIONS(13360), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441620] = 2,
    ACTIONS(13362), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441631] = 2,
    ACTIONS(13364), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441642] = 2,
    ACTIONS(13366), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441653] = 2,
    ACTIONS(13368), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441664] = 2,
    ACTIONS(13370), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441675] = 2,
    ACTIONS(6214), 1,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441686] = 2,
    ACTIONS(4771), 1,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441697] = 2,
    ACTIONS(6187), 1,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441708] = 2,
    ACTIONS(13372), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441719] = 2,
    ACTIONS(3273), 1,
      sym__cond_assoc_tyinst,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441730] = 2,
    ACTIONS(3279), 1,
      sym__cond_assoc_tyinst,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441741] = 2,
    ACTIONS(6218), 1,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441752] = 2,
    ACTIONS(13374), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441763] = 2,
    ACTIONS(13376), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441774] = 2,
    ACTIONS(6382), 1,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441785] = 2,
    ACTIONS(6386), 1,
      aux_sym__paren_close_token1,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441796] = 2,
    ACTIONS(13378), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441807] = 2,
    ACTIONS(13380), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441818] = 2,
    ACTIONS(13382), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441829] = 2,
    ACTIONS(13384), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441840] = 2,
    ACTIONS(13386), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441851] = 2,
    ACTIONS(13388), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441862] = 2,
    ACTIONS(13390), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441873] = 2,
    ACTIONS(6157), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441884] = 2,
    ACTIONS(13392), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441895] = 2,
    ACTIONS(13394), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441906] = 2,
    ACTIONS(13396), 1,
      sym__cmd_brace_open,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441917] = 2,
    ACTIONS(13398), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441928] = 2,
    ACTIONS(13400), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441939] = 2,
    ACTIONS(13402), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441950] = 2,
    ACTIONS(13404), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441961] = 2,
    ACTIONS(13406), 1,
      anon_sym_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441972] = 2,
    ACTIONS(13408), 1,
      anon_sym_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441983] = 2,
    ACTIONS(13410), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441994] = 2,
    ACTIONS(13412), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442005] = 2,
    ACTIONS(13414), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442016] = 2,
    ACTIONS(6157), 1,
      sym__cond_assoc_tyinst,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442027] = 2,
    ACTIONS(13416), 1,
      anon_sym_in,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442038] = 2,
    ACTIONS(8254), 1,
      sym__cmd_texp_start,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442049] = 2,
    ACTIONS(13418), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442060] = 2,
    ACTIONS(13420), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442071] = 2,
    ACTIONS(5203), 1,
      anon_sym_PIPE_PIPE_RBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442082] = 2,
    ACTIONS(13422), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442093] = 2,
    ACTIONS(13424), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442104] = 2,
    ACTIONS(13426), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442115] = 2,
    ACTIONS(13428), 1,
      sym__cmd_texp_end,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442126] = 2,
    ACTIONS(13430), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442137] = 2,
    ACTIONS(13432), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442148] = 2,
    ACTIONS(13434), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442159] = 2,
    ACTIONS(13436), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442170] = 2,
    ACTIONS(13438), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442181] = 2,
    ACTIONS(13440), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442192] = 2,
    ACTIONS(13442), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442203] = 2,
    ACTIONS(13444), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442214] = 2,
    ACTIONS(13446), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442225] = 2,
    ACTIONS(13448), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442236] = 2,
    ACTIONS(13450), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442247] = 2,
    ACTIONS(13452), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442258] = 2,
    ACTIONS(13454), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442269] = 2,
    ACTIONS(13456), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442280] = 2,
    ACTIONS(13458), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442291] = 2,
    ACTIONS(13460), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442302] = 2,
    ACTIONS(13462), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442313] = 2,
    ACTIONS(13464), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442324] = 2,
    ACTIONS(13466), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442335] = 2,
    ACTIONS(13468), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442346] = 2,
    ACTIONS(13470), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442357] = 2,
    ACTIONS(13472), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442368] = 2,
    ACTIONS(13474), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442379] = 2,
    ACTIONS(13476), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442390] = 2,
    ACTIONS(13478), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442401] = 2,
    ACTIONS(13480), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442412] = 2,
    ACTIONS(13482), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442423] = 2,
    ACTIONS(13484), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442434] = 2,
    ACTIONS(13486), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442445] = 2,
    ACTIONS(13488), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442456] = 2,
    ACTIONS(13490), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442467] = 2,
    ACTIONS(13492), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442478] = 2,
    ACTIONS(13494), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442489] = 2,
    ACTIONS(13496), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442500] = 2,
    ACTIONS(13498), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442511] = 2,
    ACTIONS(13500), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442522] = 2,
    ACTIONS(13502), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442533] = 2,
    ACTIONS(13504), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442544] = 2,
    ACTIONS(13506), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442555] = 2,
    ACTIONS(13508), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442566] = 2,
    ACTIONS(13510), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442577] = 2,
    ACTIONS(13512), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442588] = 2,
    ACTIONS(13514), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442599] = 2,
    ACTIONS(13516), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442610] = 2,
    ACTIONS(13518), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442621] = 2,
    ACTIONS(13520), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442632] = 2,
    ACTIONS(13522), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442643] = 2,
    ACTIONS(13524), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442654] = 2,
    ACTIONS(13526), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442665] = 2,
    ACTIONS(13528), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442676] = 2,
    ACTIONS(13530), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442687] = 2,
    ACTIONS(13532), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 5,
      sym_comment,
      sym_haddock,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2378)] = 0,
  [SMALL_STATE(2379)] = 77,
  [SMALL_STATE(2380)] = 154,
  [SMALL_STATE(2381)] = 231,
  [SMALL_STATE(2382)] = 302,
  [SMALL_STATE(2383)] = 379,
  [SMALL_STATE(2384)] = 450,
  [SMALL_STATE(2385)] = 527,
  [SMALL_STATE(2386)] = 604,
  [SMALL_STATE(2387)] = 675,
  [SMALL_STATE(2388)] = 746,
  [SMALL_STATE(2389)] = 823,
  [SMALL_STATE(2390)] = 900,
  [SMALL_STATE(2391)] = 971,
  [SMALL_STATE(2392)] = 1042,
  [SMALL_STATE(2393)] = 1119,
  [SMALL_STATE(2394)] = 1247,
  [SMALL_STATE(2395)] = 1375,
  [SMALL_STATE(2396)] = 1503,
  [SMALL_STATE(2397)] = 1631,
  [SMALL_STATE(2398)] = 1759,
  [SMALL_STATE(2399)] = 1887,
  [SMALL_STATE(2400)] = 2015,
  [SMALL_STATE(2401)] = 2143,
  [SMALL_STATE(2402)] = 2271,
  [SMALL_STATE(2403)] = 2399,
  [SMALL_STATE(2404)] = 2527,
  [SMALL_STATE(2405)] = 2655,
  [SMALL_STATE(2406)] = 2783,
  [SMALL_STATE(2407)] = 2911,
  [SMALL_STATE(2408)] = 3039,
  [SMALL_STATE(2409)] = 3167,
  [SMALL_STATE(2410)] = 3295,
  [SMALL_STATE(2411)] = 3423,
  [SMALL_STATE(2412)] = 3551,
  [SMALL_STATE(2413)] = 3679,
  [SMALL_STATE(2414)] = 3807,
  [SMALL_STATE(2415)] = 3935,
  [SMALL_STATE(2416)] = 4063,
  [SMALL_STATE(2417)] = 4191,
  [SMALL_STATE(2418)] = 4319,
  [SMALL_STATE(2419)] = 4401,
  [SMALL_STATE(2420)] = 4529,
  [SMALL_STATE(2421)] = 4657,
  [SMALL_STATE(2422)] = 4785,
  [SMALL_STATE(2423)] = 4913,
  [SMALL_STATE(2424)] = 5041,
  [SMALL_STATE(2425)] = 5169,
  [SMALL_STATE(2426)] = 5297,
  [SMALL_STATE(2427)] = 5425,
  [SMALL_STATE(2428)] = 5553,
  [SMALL_STATE(2429)] = 5681,
  [SMALL_STATE(2430)] = 5809,
  [SMALL_STATE(2431)] = 5937,
  [SMALL_STATE(2432)] = 6065,
  [SMALL_STATE(2433)] = 6193,
  [SMALL_STATE(2434)] = 6321,
  [SMALL_STATE(2435)] = 6449,
  [SMALL_STATE(2436)] = 6577,
  [SMALL_STATE(2437)] = 6705,
  [SMALL_STATE(2438)] = 6833,
  [SMALL_STATE(2439)] = 6961,
  [SMALL_STATE(2440)] = 7089,
  [SMALL_STATE(2441)] = 7217,
  [SMALL_STATE(2442)] = 7345,
  [SMALL_STATE(2443)] = 7473,
  [SMALL_STATE(2444)] = 7601,
  [SMALL_STATE(2445)] = 7729,
  [SMALL_STATE(2446)] = 7857,
  [SMALL_STATE(2447)] = 7985,
  [SMALL_STATE(2448)] = 8113,
  [SMALL_STATE(2449)] = 8241,
  [SMALL_STATE(2450)] = 8369,
  [SMALL_STATE(2451)] = 8497,
  [SMALL_STATE(2452)] = 8625,
  [SMALL_STATE(2453)] = 8753,
  [SMALL_STATE(2454)] = 8881,
  [SMALL_STATE(2455)] = 9009,
  [SMALL_STATE(2456)] = 9137,
  [SMALL_STATE(2457)] = 9265,
  [SMALL_STATE(2458)] = 9393,
  [SMALL_STATE(2459)] = 9521,
  [SMALL_STATE(2460)] = 9649,
  [SMALL_STATE(2461)] = 9777,
  [SMALL_STATE(2462)] = 9905,
  [SMALL_STATE(2463)] = 10033,
  [SMALL_STATE(2464)] = 10161,
  [SMALL_STATE(2465)] = 10289,
  [SMALL_STATE(2466)] = 10417,
  [SMALL_STATE(2467)] = 10493,
  [SMALL_STATE(2468)] = 10621,
  [SMALL_STATE(2469)] = 10713,
  [SMALL_STATE(2470)] = 10841,
  [SMALL_STATE(2471)] = 10969,
  [SMALL_STATE(2472)] = 11097,
  [SMALL_STATE(2473)] = 11225,
  [SMALL_STATE(2474)] = 11353,
  [SMALL_STATE(2475)] = 11481,
  [SMALL_STATE(2476)] = 11609,
  [SMALL_STATE(2477)] = 11737,
  [SMALL_STATE(2478)] = 11865,
  [SMALL_STATE(2479)] = 11993,
  [SMALL_STATE(2480)] = 12121,
  [SMALL_STATE(2481)] = 12249,
  [SMALL_STATE(2482)] = 12377,
  [SMALL_STATE(2483)] = 12505,
  [SMALL_STATE(2484)] = 12633,
  [SMALL_STATE(2485)] = 12761,
  [SMALL_STATE(2486)] = 12889,
  [SMALL_STATE(2487)] = 13017,
  [SMALL_STATE(2488)] = 13145,
  [SMALL_STATE(2489)] = 13273,
  [SMALL_STATE(2490)] = 13401,
  [SMALL_STATE(2491)] = 13529,
  [SMALL_STATE(2492)] = 13657,
  [SMALL_STATE(2493)] = 13785,
  [SMALL_STATE(2494)] = 13913,
  [SMALL_STATE(2495)] = 14041,
  [SMALL_STATE(2496)] = 14169,
  [SMALL_STATE(2497)] = 14297,
  [SMALL_STATE(2498)] = 14425,
  [SMALL_STATE(2499)] = 14553,
  [SMALL_STATE(2500)] = 14681,
  [SMALL_STATE(2501)] = 14809,
  [SMALL_STATE(2502)] = 14937,
  [SMALL_STATE(2503)] = 15065,
  [SMALL_STATE(2504)] = 15193,
  [SMALL_STATE(2505)] = 15321,
  [SMALL_STATE(2506)] = 15449,
  [SMALL_STATE(2507)] = 15577,
  [SMALL_STATE(2508)] = 15705,
  [SMALL_STATE(2509)] = 15833,
  [SMALL_STATE(2510)] = 15961,
  [SMALL_STATE(2511)] = 16089,
  [SMALL_STATE(2512)] = 16217,
  [SMALL_STATE(2513)] = 16345,
  [SMALL_STATE(2514)] = 16473,
  [SMALL_STATE(2515)] = 16601,
  [SMALL_STATE(2516)] = 16729,
  [SMALL_STATE(2517)] = 16805,
  [SMALL_STATE(2518)] = 16933,
  [SMALL_STATE(2519)] = 17061,
  [SMALL_STATE(2520)] = 17189,
  [SMALL_STATE(2521)] = 17317,
  [SMALL_STATE(2522)] = 17445,
  [SMALL_STATE(2523)] = 17573,
  [SMALL_STATE(2524)] = 17701,
  [SMALL_STATE(2525)] = 17829,
  [SMALL_STATE(2526)] = 17957,
  [SMALL_STATE(2527)] = 18085,
  [SMALL_STATE(2528)] = 18213,
  [SMALL_STATE(2529)] = 18341,
  [SMALL_STATE(2530)] = 18469,
  [SMALL_STATE(2531)] = 18597,
  [SMALL_STATE(2532)] = 18725,
  [SMALL_STATE(2533)] = 18853,
  [SMALL_STATE(2534)] = 18981,
  [SMALL_STATE(2535)] = 19109,
  [SMALL_STATE(2536)] = 19237,
  [SMALL_STATE(2537)] = 19365,
  [SMALL_STATE(2538)] = 19493,
  [SMALL_STATE(2539)] = 19621,
  [SMALL_STATE(2540)] = 19695,
  [SMALL_STATE(2541)] = 19823,
  [SMALL_STATE(2542)] = 19951,
  [SMALL_STATE(2543)] = 20079,
  [SMALL_STATE(2544)] = 20207,
  [SMALL_STATE(2545)] = 20335,
  [SMALL_STATE(2546)] = 20463,
  [SMALL_STATE(2547)] = 20537,
  [SMALL_STATE(2548)] = 20665,
  [SMALL_STATE(2549)] = 20793,
  [SMALL_STATE(2550)] = 20921,
  [SMALL_STATE(2551)] = 21049,
  [SMALL_STATE(2552)] = 21177,
  [SMALL_STATE(2553)] = 21305,
  [SMALL_STATE(2554)] = 21381,
  [SMALL_STATE(2555)] = 21509,
  [SMALL_STATE(2556)] = 21637,
  [SMALL_STATE(2557)] = 21765,
  [SMALL_STATE(2558)] = 21893,
  [SMALL_STATE(2559)] = 22021,
  [SMALL_STATE(2560)] = 22149,
  [SMALL_STATE(2561)] = 22277,
  [SMALL_STATE(2562)] = 22405,
  [SMALL_STATE(2563)] = 22533,
  [SMALL_STATE(2564)] = 22661,
  [SMALL_STATE(2565)] = 22789,
  [SMALL_STATE(2566)] = 22917,
  [SMALL_STATE(2567)] = 23045,
  [SMALL_STATE(2568)] = 23173,
  [SMALL_STATE(2569)] = 23301,
  [SMALL_STATE(2570)] = 23429,
  [SMALL_STATE(2571)] = 23557,
  [SMALL_STATE(2572)] = 23685,
  [SMALL_STATE(2573)] = 23813,
  [SMALL_STATE(2574)] = 23941,
  [SMALL_STATE(2575)] = 24069,
  [SMALL_STATE(2576)] = 24197,
  [SMALL_STATE(2577)] = 24325,
  [SMALL_STATE(2578)] = 24453,
  [SMALL_STATE(2579)] = 24581,
  [SMALL_STATE(2580)] = 24709,
  [SMALL_STATE(2581)] = 24837,
  [SMALL_STATE(2582)] = 24965,
  [SMALL_STATE(2583)] = 25093,
  [SMALL_STATE(2584)] = 25221,
  [SMALL_STATE(2585)] = 25349,
  [SMALL_STATE(2586)] = 25477,
  [SMALL_STATE(2587)] = 25605,
  [SMALL_STATE(2588)] = 25733,
  [SMALL_STATE(2589)] = 25861,
  [SMALL_STATE(2590)] = 25935,
  [SMALL_STATE(2591)] = 26063,
  [SMALL_STATE(2592)] = 26191,
  [SMALL_STATE(2593)] = 26319,
  [SMALL_STATE(2594)] = 26447,
  [SMALL_STATE(2595)] = 26575,
  [SMALL_STATE(2596)] = 26703,
  [SMALL_STATE(2597)] = 26831,
  [SMALL_STATE(2598)] = 26959,
  [SMALL_STATE(2599)] = 27087,
  [SMALL_STATE(2600)] = 27215,
  [SMALL_STATE(2601)] = 27343,
  [SMALL_STATE(2602)] = 27471,
  [SMALL_STATE(2603)] = 27599,
  [SMALL_STATE(2604)] = 27727,
  [SMALL_STATE(2605)] = 27855,
  [SMALL_STATE(2606)] = 27983,
  [SMALL_STATE(2607)] = 28111,
  [SMALL_STATE(2608)] = 28239,
  [SMALL_STATE(2609)] = 28367,
  [SMALL_STATE(2610)] = 28495,
  [SMALL_STATE(2611)] = 28623,
  [SMALL_STATE(2612)] = 28751,
  [SMALL_STATE(2613)] = 28879,
  [SMALL_STATE(2614)] = 29007,
  [SMALL_STATE(2615)] = 29135,
  [SMALL_STATE(2616)] = 29263,
  [SMALL_STATE(2617)] = 29391,
  [SMALL_STATE(2618)] = 29519,
  [SMALL_STATE(2619)] = 29647,
  [SMALL_STATE(2620)] = 29775,
  [SMALL_STATE(2621)] = 29903,
  [SMALL_STATE(2622)] = 30031,
  [SMALL_STATE(2623)] = 30159,
  [SMALL_STATE(2624)] = 30287,
  [SMALL_STATE(2625)] = 30363,
  [SMALL_STATE(2626)] = 30491,
  [SMALL_STATE(2627)] = 30619,
  [SMALL_STATE(2628)] = 30747,
  [SMALL_STATE(2629)] = 30875,
  [SMALL_STATE(2630)] = 31003,
  [SMALL_STATE(2631)] = 31131,
  [SMALL_STATE(2632)] = 31259,
  [SMALL_STATE(2633)] = 31387,
  [SMALL_STATE(2634)] = 31479,
  [SMALL_STATE(2635)] = 31607,
  [SMALL_STATE(2636)] = 31735,
  [SMALL_STATE(2637)] = 31863,
  [SMALL_STATE(2638)] = 31991,
  [SMALL_STATE(2639)] = 32119,
  [SMALL_STATE(2640)] = 32211,
  [SMALL_STATE(2641)] = 32339,
  [SMALL_STATE(2642)] = 32467,
  [SMALL_STATE(2643)] = 32595,
  [SMALL_STATE(2644)] = 32723,
  [SMALL_STATE(2645)] = 32851,
  [SMALL_STATE(2646)] = 32979,
  [SMALL_STATE(2647)] = 33107,
  [SMALL_STATE(2648)] = 33235,
  [SMALL_STATE(2649)] = 33363,
  [SMALL_STATE(2650)] = 33491,
  [SMALL_STATE(2651)] = 33619,
  [SMALL_STATE(2652)] = 33747,
  [SMALL_STATE(2653)] = 33839,
  [SMALL_STATE(2654)] = 33967,
  [SMALL_STATE(2655)] = 34095,
  [SMALL_STATE(2656)] = 34223,
  [SMALL_STATE(2657)] = 34351,
  [SMALL_STATE(2658)] = 34479,
  [SMALL_STATE(2659)] = 34607,
  [SMALL_STATE(2660)] = 34735,
  [SMALL_STATE(2661)] = 34863,
  [SMALL_STATE(2662)] = 34991,
  [SMALL_STATE(2663)] = 35119,
  [SMALL_STATE(2664)] = 35247,
  [SMALL_STATE(2665)] = 35375,
  [SMALL_STATE(2666)] = 35503,
  [SMALL_STATE(2667)] = 35631,
  [SMALL_STATE(2668)] = 35759,
  [SMALL_STATE(2669)] = 35851,
  [SMALL_STATE(2670)] = 35943,
  [SMALL_STATE(2671)] = 36035,
  [SMALL_STATE(2672)] = 36163,
  [SMALL_STATE(2673)] = 36291,
  [SMALL_STATE(2674)] = 36419,
  [SMALL_STATE(2675)] = 36547,
  [SMALL_STATE(2676)] = 36675,
  [SMALL_STATE(2677)] = 36803,
  [SMALL_STATE(2678)] = 36931,
  [SMALL_STATE(2679)] = 37059,
  [SMALL_STATE(2680)] = 37187,
  [SMALL_STATE(2681)] = 37315,
  [SMALL_STATE(2682)] = 37443,
  [SMALL_STATE(2683)] = 37535,
  [SMALL_STATE(2684)] = 37663,
  [SMALL_STATE(2685)] = 37791,
  [SMALL_STATE(2686)] = 37919,
  [SMALL_STATE(2687)] = 38047,
  [SMALL_STATE(2688)] = 38175,
  [SMALL_STATE(2689)] = 38303,
  [SMALL_STATE(2690)] = 38431,
  [SMALL_STATE(2691)] = 38559,
  [SMALL_STATE(2692)] = 38628,
  [SMALL_STATE(2693)] = 38697,
  [SMALL_STATE(2694)] = 38766,
  [SMALL_STATE(2695)] = 38835,
  [SMALL_STATE(2696)] = 38904,
  [SMALL_STATE(2697)] = 38973,
  [SMALL_STATE(2698)] = 39042,
  [SMALL_STATE(2699)] = 39117,
  [SMALL_STATE(2700)] = 39186,
  [SMALL_STATE(2701)] = 39255,
  [SMALL_STATE(2702)] = 39324,
  [SMALL_STATE(2703)] = 39393,
  [SMALL_STATE(2704)] = 39462,
  [SMALL_STATE(2705)] = 39531,
  [SMALL_STATE(2706)] = 39600,
  [SMALL_STATE(2707)] = 39675,
  [SMALL_STATE(2708)] = 39744,
  [SMALL_STATE(2709)] = 39813,
  [SMALL_STATE(2710)] = 39882,
  [SMALL_STATE(2711)] = 39951,
  [SMALL_STATE(2712)] = 40026,
  [SMALL_STATE(2713)] = 40095,
  [SMALL_STATE(2714)] = 40164,
  [SMALL_STATE(2715)] = 40239,
  [SMALL_STATE(2716)] = 40308,
  [SMALL_STATE(2717)] = 40377,
  [SMALL_STATE(2718)] = 40446,
  [SMALL_STATE(2719)] = 40515,
  [SMALL_STATE(2720)] = 40584,
  [SMALL_STATE(2721)] = 40659,
  [SMALL_STATE(2722)] = 40734,
  [SMALL_STATE(2723)] = 40809,
  [SMALL_STATE(2724)] = 40878,
  [SMALL_STATE(2725)] = 40947,
  [SMALL_STATE(2726)] = 41016,
  [SMALL_STATE(2727)] = 41085,
  [SMALL_STATE(2728)] = 41160,
  [SMALL_STATE(2729)] = 41229,
  [SMALL_STATE(2730)] = 41298,
  [SMALL_STATE(2731)] = 41367,
  [SMALL_STATE(2732)] = 41436,
  [SMALL_STATE(2733)] = 41511,
  [SMALL_STATE(2734)] = 41580,
  [SMALL_STATE(2735)] = 41649,
  [SMALL_STATE(2736)] = 41718,
  [SMALL_STATE(2737)] = 41787,
  [SMALL_STATE(2738)] = 41856,
  [SMALL_STATE(2739)] = 41925,
  [SMALL_STATE(2740)] = 41998,
  [SMALL_STATE(2741)] = 42067,
  [SMALL_STATE(2742)] = 42136,
  [SMALL_STATE(2743)] = 42205,
  [SMALL_STATE(2744)] = 42274,
  [SMALL_STATE(2745)] = 42343,
  [SMALL_STATE(2746)] = 42412,
  [SMALL_STATE(2747)] = 42481,
  [SMALL_STATE(2748)] = 42550,
  [SMALL_STATE(2749)] = 42619,
  [SMALL_STATE(2750)] = 42688,
  [SMALL_STATE(2751)] = 42757,
  [SMALL_STATE(2752)] = 42826,
  [SMALL_STATE(2753)] = 42894,
  [SMALL_STATE(2754)] = 42962,
  [SMALL_STATE(2755)] = 43030,
  [SMALL_STATE(2756)] = 43098,
  [SMALL_STATE(2757)] = 43188,
  [SMALL_STATE(2758)] = 43268,
  [SMALL_STATE(2759)] = 43336,
  [SMALL_STATE(2760)] = 43404,
  [SMALL_STATE(2761)] = 43472,
  [SMALL_STATE(2762)] = 43540,
  [SMALL_STATE(2763)] = 43608,
  [SMALL_STATE(2764)] = 43676,
  [SMALL_STATE(2765)] = 43744,
  [SMALL_STATE(2766)] = 43812,
  [SMALL_STATE(2767)] = 43880,
  [SMALL_STATE(2768)] = 43948,
  [SMALL_STATE(2769)] = 44038,
  [SMALL_STATE(2770)] = 44118,
  [SMALL_STATE(2771)] = 44208,
  [SMALL_STATE(2772)] = 44276,
  [SMALL_STATE(2773)] = 44366,
  [SMALL_STATE(2774)] = 44434,
  [SMALL_STATE(2775)] = 44502,
  [SMALL_STATE(2776)] = 44570,
  [SMALL_STATE(2777)] = 44638,
  [SMALL_STATE(2778)] = 44706,
  [SMALL_STATE(2779)] = 44774,
  [SMALL_STATE(2780)] = 44842,
  [SMALL_STATE(2781)] = 44932,
  [SMALL_STATE(2782)] = 45000,
  [SMALL_STATE(2783)] = 45090,
  [SMALL_STATE(2784)] = 45180,
  [SMALL_STATE(2785)] = 45270,
  [SMALL_STATE(2786)] = 45360,
  [SMALL_STATE(2787)] = 45428,
  [SMALL_STATE(2788)] = 45496,
  [SMALL_STATE(2789)] = 45564,
  [SMALL_STATE(2790)] = 45632,
  [SMALL_STATE(2791)] = 45722,
  [SMALL_STATE(2792)] = 45812,
  [SMALL_STATE(2793)] = 45880,
  [SMALL_STATE(2794)] = 45970,
  [SMALL_STATE(2795)] = 46060,
  [SMALL_STATE(2796)] = 46128,
  [SMALL_STATE(2797)] = 46196,
  [SMALL_STATE(2798)] = 46264,
  [SMALL_STATE(2799)] = 46354,
  [SMALL_STATE(2800)] = 46444,
  [SMALL_STATE(2801)] = 46534,
  [SMALL_STATE(2802)] = 46624,
  [SMALL_STATE(2803)] = 46704,
  [SMALL_STATE(2804)] = 46794,
  [SMALL_STATE(2805)] = 46884,
  [SMALL_STATE(2806)] = 46974,
  [SMALL_STATE(2807)] = 47042,
  [SMALL_STATE(2808)] = 47132,
  [SMALL_STATE(2809)] = 47200,
  [SMALL_STATE(2810)] = 47268,
  [SMALL_STATE(2811)] = 47336,
  [SMALL_STATE(2812)] = 47404,
  [SMALL_STATE(2813)] = 47472,
  [SMALL_STATE(2814)] = 47540,
  [SMALL_STATE(2815)] = 47608,
  [SMALL_STATE(2816)] = 47676,
  [SMALL_STATE(2817)] = 47744,
  [SMALL_STATE(2818)] = 47812,
  [SMALL_STATE(2819)] = 47902,
  [SMALL_STATE(2820)] = 47974,
  [SMALL_STATE(2821)] = 48042,
  [SMALL_STATE(2822)] = 48110,
  [SMALL_STATE(2823)] = 48178,
  [SMALL_STATE(2824)] = 48246,
  [SMALL_STATE(2825)] = 48326,
  [SMALL_STATE(2826)] = 48394,
  [SMALL_STATE(2827)] = 48484,
  [SMALL_STATE(2828)] = 48574,
  [SMALL_STATE(2829)] = 48664,
  [SMALL_STATE(2830)] = 48754,
  [SMALL_STATE(2831)] = 48822,
  [SMALL_STATE(2832)] = 48912,
  [SMALL_STATE(2833)] = 49002,
  [SMALL_STATE(2834)] = 49092,
  [SMALL_STATE(2835)] = 49182,
  [SMALL_STATE(2836)] = 49250,
  [SMALL_STATE(2837)] = 49340,
  [SMALL_STATE(2838)] = 49408,
  [SMALL_STATE(2839)] = 49498,
  [SMALL_STATE(2840)] = 49566,
  [SMALL_STATE(2841)] = 49633,
  [SMALL_STATE(2842)] = 49700,
  [SMALL_STATE(2843)] = 49773,
  [SMALL_STATE(2844)] = 49840,
  [SMALL_STATE(2845)] = 49907,
  [SMALL_STATE(2846)] = 49974,
  [SMALL_STATE(2847)] = 50047,
  [SMALL_STATE(2848)] = 50114,
  [SMALL_STATE(2849)] = 50181,
  [SMALL_STATE(2850)] = 50248,
  [SMALL_STATE(2851)] = 50315,
  [SMALL_STATE(2852)] = 50382,
  [SMALL_STATE(2853)] = 50449,
  [SMALL_STATE(2854)] = 50522,
  [SMALL_STATE(2855)] = 50595,
  [SMALL_STATE(2856)] = 50668,
  [SMALL_STATE(2857)] = 50735,
  [SMALL_STATE(2858)] = 50808,
  [SMALL_STATE(2859)] = 50875,
  [SMALL_STATE(2860)] = 50942,
  [SMALL_STATE(2861)] = 51009,
  [SMALL_STATE(2862)] = 51076,
  [SMALL_STATE(2863)] = 51143,
  [SMALL_STATE(2864)] = 51216,
  [SMALL_STATE(2865)] = 51283,
  [SMALL_STATE(2866)] = 51350,
  [SMALL_STATE(2867)] = 51417,
  [SMALL_STATE(2868)] = 51484,
  [SMALL_STATE(2869)] = 51557,
  [SMALL_STATE(2870)] = 51630,
  [SMALL_STATE(2871)] = 51697,
  [SMALL_STATE(2872)] = 51764,
  [SMALL_STATE(2873)] = 51837,
  [SMALL_STATE(2874)] = 51910,
  [SMALL_STATE(2875)] = 51983,
  [SMALL_STATE(2876)] = 52050,
  [SMALL_STATE(2877)] = 52123,
  [SMALL_STATE(2878)] = 52190,
  [SMALL_STATE(2879)] = 52257,
  [SMALL_STATE(2880)] = 52330,
  [SMALL_STATE(2881)] = 52397,
  [SMALL_STATE(2882)] = 52464,
  [SMALL_STATE(2883)] = 52531,
  [SMALL_STATE(2884)] = 52598,
  [SMALL_STATE(2885)] = 52665,
  [SMALL_STATE(2886)] = 52732,
  [SMALL_STATE(2887)] = 52799,
  [SMALL_STATE(2888)] = 52866,
  [SMALL_STATE(2889)] = 52933,
  [SMALL_STATE(2890)] = 53000,
  [SMALL_STATE(2891)] = 53067,
  [SMALL_STATE(2892)] = 53140,
  [SMALL_STATE(2893)] = 53221,
  [SMALL_STATE(2894)] = 53294,
  [SMALL_STATE(2895)] = 53361,
  [SMALL_STATE(2896)] = 53428,
  [SMALL_STATE(2897)] = 53495,
  [SMALL_STATE(2898)] = 53562,
  [SMALL_STATE(2899)] = 53629,
  [SMALL_STATE(2900)] = 53702,
  [SMALL_STATE(2901)] = 53769,
  [SMALL_STATE(2902)] = 53836,
  [SMALL_STATE(2903)] = 53903,
  [SMALL_STATE(2904)] = 53976,
  [SMALL_STATE(2905)] = 54043,
  [SMALL_STATE(2906)] = 54110,
  [SMALL_STATE(2907)] = 54177,
  [SMALL_STATE(2908)] = 54244,
  [SMALL_STATE(2909)] = 54311,
  [SMALL_STATE(2910)] = 54384,
  [SMALL_STATE(2911)] = 54457,
  [SMALL_STATE(2912)] = 54546,
  [SMALL_STATE(2913)] = 54613,
  [SMALL_STATE(2914)] = 54680,
  [SMALL_STATE(2915)] = 54747,
  [SMALL_STATE(2916)] = 54820,
  [SMALL_STATE(2917)] = 54887,
  [SMALL_STATE(2918)] = 54954,
  [SMALL_STATE(2919)] = 55027,
  [SMALL_STATE(2920)] = 55094,
  [SMALL_STATE(2921)] = 55183,
  [SMALL_STATE(2922)] = 55250,
  [SMALL_STATE(2923)] = 55317,
  [SMALL_STATE(2924)] = 55384,
  [SMALL_STATE(2925)] = 55451,
  [SMALL_STATE(2926)] = 55518,
  [SMALL_STATE(2927)] = 55585,
  [SMALL_STATE(2928)] = 55652,
  [SMALL_STATE(2929)] = 55719,
  [SMALL_STATE(2930)] = 55786,
  [SMALL_STATE(2931)] = 55865,
  [SMALL_STATE(2932)] = 55932,
  [SMALL_STATE(2933)] = 56005,
  [SMALL_STATE(2934)] = 56072,
  [SMALL_STATE(2935)] = 56145,
  [SMALL_STATE(2936)] = 56212,
  [SMALL_STATE(2937)] = 56291,
  [SMALL_STATE(2938)] = 56358,
  [SMALL_STATE(2939)] = 56425,
  [SMALL_STATE(2940)] = 56514,
  [SMALL_STATE(2941)] = 56603,
  [SMALL_STATE(2942)] = 56670,
  [SMALL_STATE(2943)] = 56743,
  [SMALL_STATE(2944)] = 56810,
  [SMALL_STATE(2945)] = 56883,
  [SMALL_STATE(2946)] = 56950,
  [SMALL_STATE(2947)] = 57017,
  [SMALL_STATE(2948)] = 57106,
  [SMALL_STATE(2949)] = 57173,
  [SMALL_STATE(2950)] = 57262,
  [SMALL_STATE(2951)] = 57329,
  [SMALL_STATE(2952)] = 57396,
  [SMALL_STATE(2953)] = 57463,
  [SMALL_STATE(2954)] = 57536,
  [SMALL_STATE(2955)] = 57603,
  [SMALL_STATE(2956)] = 57692,
  [SMALL_STATE(2957)] = 57759,
  [SMALL_STATE(2958)] = 57826,
  [SMALL_STATE(2959)] = 57915,
  [SMALL_STATE(2960)] = 57982,
  [SMALL_STATE(2961)] = 58055,
  [SMALL_STATE(2962)] = 58128,
  [SMALL_STATE(2963)] = 58195,
  [SMALL_STATE(2964)] = 58262,
  [SMALL_STATE(2965)] = 58335,
  [SMALL_STATE(2966)] = 58402,
  [SMALL_STATE(2967)] = 58469,
  [SMALL_STATE(2968)] = 58542,
  [SMALL_STATE(2969)] = 58609,
  [SMALL_STATE(2970)] = 58676,
  [SMALL_STATE(2971)] = 58743,
  [SMALL_STATE(2972)] = 58810,
  [SMALL_STATE(2973)] = 58877,
  [SMALL_STATE(2974)] = 58944,
  [SMALL_STATE(2975)] = 59011,
  [SMALL_STATE(2976)] = 59078,
  [SMALL_STATE(2977)] = 59145,
  [SMALL_STATE(2978)] = 59212,
  [SMALL_STATE(2979)] = 59285,
  [SMALL_STATE(2980)] = 59358,
  [SMALL_STATE(2981)] = 59425,
  [SMALL_STATE(2982)] = 59492,
  [SMALL_STATE(2983)] = 59559,
  [SMALL_STATE(2984)] = 59626,
  [SMALL_STATE(2985)] = 59699,
  [SMALL_STATE(2986)] = 59766,
  [SMALL_STATE(2987)] = 59833,
  [SMALL_STATE(2988)] = 59900,
  [SMALL_STATE(2989)] = 59967,
  [SMALL_STATE(2990)] = 60034,
  [SMALL_STATE(2991)] = 60101,
  [SMALL_STATE(2992)] = 60168,
  [SMALL_STATE(2993)] = 60235,
  [SMALL_STATE(2994)] = 60302,
  [SMALL_STATE(2995)] = 60369,
  [SMALL_STATE(2996)] = 60436,
  [SMALL_STATE(2997)] = 60503,
  [SMALL_STATE(2998)] = 60570,
  [SMALL_STATE(2999)] = 60637,
  [SMALL_STATE(3000)] = 60704,
  [SMALL_STATE(3001)] = 60771,
  [SMALL_STATE(3002)] = 60838,
  [SMALL_STATE(3003)] = 60905,
  [SMALL_STATE(3004)] = 60972,
  [SMALL_STATE(3005)] = 61039,
  [SMALL_STATE(3006)] = 61106,
  [SMALL_STATE(3007)] = 61173,
  [SMALL_STATE(3008)] = 61262,
  [SMALL_STATE(3009)] = 61335,
  [SMALL_STATE(3010)] = 61402,
  [SMALL_STATE(3011)] = 61469,
  [SMALL_STATE(3012)] = 61536,
  [SMALL_STATE(3013)] = 61603,
  [SMALL_STATE(3014)] = 61670,
  [SMALL_STATE(3015)] = 61737,
  [SMALL_STATE(3016)] = 61804,
  [SMALL_STATE(3017)] = 61871,
  [SMALL_STATE(3018)] = 61938,
  [SMALL_STATE(3019)] = 62005,
  [SMALL_STATE(3020)] = 62072,
  [SMALL_STATE(3021)] = 62145,
  [SMALL_STATE(3022)] = 62212,
  [SMALL_STATE(3023)] = 62279,
  [SMALL_STATE(3024)] = 62346,
  [SMALL_STATE(3025)] = 62413,
  [SMALL_STATE(3026)] = 62480,
  [SMALL_STATE(3027)] = 62547,
  [SMALL_STATE(3028)] = 62614,
  [SMALL_STATE(3029)] = 62681,
  [SMALL_STATE(3030)] = 62748,
  [SMALL_STATE(3031)] = 62815,
  [SMALL_STATE(3032)] = 62882,
  [SMALL_STATE(3033)] = 62949,
  [SMALL_STATE(3034)] = 63016,
  [SMALL_STATE(3035)] = 63083,
  [SMALL_STATE(3036)] = 63150,
  [SMALL_STATE(3037)] = 63217,
  [SMALL_STATE(3038)] = 63284,
  [SMALL_STATE(3039)] = 63373,
  [SMALL_STATE(3040)] = 63462,
  [SMALL_STATE(3041)] = 63529,
  [SMALL_STATE(3042)] = 63618,
  [SMALL_STATE(3043)] = 63685,
  [SMALL_STATE(3044)] = 63758,
  [SMALL_STATE(3045)] = 63847,
  [SMALL_STATE(3046)] = 63914,
  [SMALL_STATE(3047)] = 64003,
  [SMALL_STATE(3048)] = 64092,
  [SMALL_STATE(3049)] = 64181,
  [SMALL_STATE(3050)] = 64248,
  [SMALL_STATE(3051)] = 64321,
  [SMALL_STATE(3052)] = 64388,
  [SMALL_STATE(3053)] = 64454,
  [SMALL_STATE(3054)] = 64526,
  [SMALL_STATE(3055)] = 64598,
  [SMALL_STATE(3056)] = 64670,
  [SMALL_STATE(3057)] = 64742,
  [SMALL_STATE(3058)] = 64814,
  [SMALL_STATE(3059)] = 64880,
  [SMALL_STATE(3060)] = 64960,
  [SMALL_STATE(3061)] = 65026,
  [SMALL_STATE(3062)] = 65092,
  [SMALL_STATE(3063)] = 65164,
  [SMALL_STATE(3064)] = 65230,
  [SMALL_STATE(3065)] = 65296,
  [SMALL_STATE(3066)] = 65362,
  [SMALL_STATE(3067)] = 65428,
  [SMALL_STATE(3068)] = 65494,
  [SMALL_STATE(3069)] = 65574,
  [SMALL_STATE(3070)] = 65646,
  [SMALL_STATE(3071)] = 65712,
  [SMALL_STATE(3072)] = 65778,
  [SMALL_STATE(3073)] = 65844,
  [SMALL_STATE(3074)] = 65910,
  [SMALL_STATE(3075)] = 65982,
  [SMALL_STATE(3076)] = 66048,
  [SMALL_STATE(3077)] = 66118,
  [SMALL_STATE(3078)] = 66190,
  [SMALL_STATE(3079)] = 66262,
  [SMALL_STATE(3080)] = 66334,
  [SMALL_STATE(3081)] = 66406,
  [SMALL_STATE(3082)] = 66486,
  [SMALL_STATE(3083)] = 66552,
  [SMALL_STATE(3084)] = 66618,
  [SMALL_STATE(3085)] = 66684,
  [SMALL_STATE(3086)] = 66764,
  [SMALL_STATE(3087)] = 66830,
  [SMALL_STATE(3088)] = 66896,
  [SMALL_STATE(3089)] = 66962,
  [SMALL_STATE(3090)] = 67034,
  [SMALL_STATE(3091)] = 67100,
  [SMALL_STATE(3092)] = 67166,
  [SMALL_STATE(3093)] = 67232,
  [SMALL_STATE(3094)] = 67304,
  [SMALL_STATE(3095)] = 67376,
  [SMALL_STATE(3096)] = 67442,
  [SMALL_STATE(3097)] = 67508,
  [SMALL_STATE(3098)] = 67574,
  [SMALL_STATE(3099)] = 67654,
  [SMALL_STATE(3100)] = 67720,
  [SMALL_STATE(3101)] = 67786,
  [SMALL_STATE(3102)] = 67866,
  [SMALL_STATE(3103)] = 67932,
  [SMALL_STATE(3104)] = 67998,
  [SMALL_STATE(3105)] = 68064,
  [SMALL_STATE(3106)] = 68136,
  [SMALL_STATE(3107)] = 68202,
  [SMALL_STATE(3108)] = 68282,
  [SMALL_STATE(3109)] = 68354,
  [SMALL_STATE(3110)] = 68420,
  [SMALL_STATE(3111)] = 68486,
  [SMALL_STATE(3112)] = 68552,
  [SMALL_STATE(3113)] = 68618,
  [SMALL_STATE(3114)] = 68690,
  [SMALL_STATE(3115)] = 68756,
  [SMALL_STATE(3116)] = 68822,
  [SMALL_STATE(3117)] = 68888,
  [SMALL_STATE(3118)] = 68960,
  [SMALL_STATE(3119)] = 69026,
  [SMALL_STATE(3120)] = 69098,
  [SMALL_STATE(3121)] = 69170,
  [SMALL_STATE(3122)] = 69236,
  [SMALL_STATE(3123)] = 69302,
  [SMALL_STATE(3124)] = 69368,
  [SMALL_STATE(3125)] = 69440,
  [SMALL_STATE(3126)] = 69506,
  [SMALL_STATE(3127)] = 69572,
  [SMALL_STATE(3128)] = 69644,
  [SMALL_STATE(3129)] = 69710,
  [SMALL_STATE(3130)] = 69776,
  [SMALL_STATE(3131)] = 69842,
  [SMALL_STATE(3132)] = 69908,
  [SMALL_STATE(3133)] = 69974,
  [SMALL_STATE(3134)] = 70046,
  [SMALL_STATE(3135)] = 70112,
  [SMALL_STATE(3136)] = 70178,
  [SMALL_STATE(3137)] = 70244,
  [SMALL_STATE(3138)] = 70316,
  [SMALL_STATE(3139)] = 70382,
  [SMALL_STATE(3140)] = 70448,
  [SMALL_STATE(3141)] = 70514,
  [SMALL_STATE(3142)] = 70580,
  [SMALL_STATE(3143)] = 70652,
  [SMALL_STATE(3144)] = 70729,
  [SMALL_STATE(3145)] = 70800,
  [SMALL_STATE(3146)] = 70877,
  [SMALL_STATE(3147)] = 70948,
  [SMALL_STATE(3148)] = 71013,
  [SMALL_STATE(3149)] = 71084,
  [SMALL_STATE(3150)] = 71155,
  [SMALL_STATE(3151)] = 71226,
  [SMALL_STATE(3152)] = 71297,
  [SMALL_STATE(3153)] = 71374,
  [SMALL_STATE(3154)] = 71485,
  [SMALL_STATE(3155)] = 71556,
  [SMALL_STATE(3156)] = 71621,
  [SMALL_STATE(3157)] = 71692,
  [SMALL_STATE(3158)] = 71763,
  [SMALL_STATE(3159)] = 71842,
  [SMALL_STATE(3160)] = 71919,
  [SMALL_STATE(3161)] = 71996,
  [SMALL_STATE(3162)] = 72067,
  [SMALL_STATE(3163)] = 72144,
  [SMALL_STATE(3164)] = 72215,
  [SMALL_STATE(3165)] = 72286,
  [SMALL_STATE(3166)] = 72363,
  [SMALL_STATE(3167)] = 72442,
  [SMALL_STATE(3168)] = 72553,
  [SMALL_STATE(3169)] = 72624,
  [SMALL_STATE(3170)] = 72695,
  [SMALL_STATE(3171)] = 72766,
  [SMALL_STATE(3172)] = 72837,
  [SMALL_STATE(3173)] = 72908,
  [SMALL_STATE(3174)] = 72979,
  [SMALL_STATE(3175)] = 73050,
  [SMALL_STATE(3176)] = 73121,
  [SMALL_STATE(3177)] = 73192,
  [SMALL_STATE(3178)] = 73256,
  [SMALL_STATE(3179)] = 73320,
  [SMALL_STATE(3180)] = 73384,
  [SMALL_STATE(3181)] = 73448,
  [SMALL_STATE(3182)] = 73512,
  [SMALL_STATE(3183)] = 73576,
  [SMALL_STATE(3184)] = 73640,
  [SMALL_STATE(3185)] = 73704,
  [SMALL_STATE(3186)] = 73768,
  [SMALL_STATE(3187)] = 73832,
  [SMALL_STATE(3188)] = 73896,
  [SMALL_STATE(3189)] = 73960,
  [SMALL_STATE(3190)] = 74024,
  [SMALL_STATE(3191)] = 74088,
  [SMALL_STATE(3192)] = 74152,
  [SMALL_STATE(3193)] = 74216,
  [SMALL_STATE(3194)] = 74280,
  [SMALL_STATE(3195)] = 74344,
  [SMALL_STATE(3196)] = 74408,
  [SMALL_STATE(3197)] = 74472,
  [SMALL_STATE(3198)] = 74536,
  [SMALL_STATE(3199)] = 74600,
  [SMALL_STATE(3200)] = 74664,
  [SMALL_STATE(3201)] = 74728,
  [SMALL_STATE(3202)] = 74792,
  [SMALL_STATE(3203)] = 74856,
  [SMALL_STATE(3204)] = 74920,
  [SMALL_STATE(3205)] = 74984,
  [SMALL_STATE(3206)] = 75048,
  [SMALL_STATE(3207)] = 75112,
  [SMALL_STATE(3208)] = 75176,
  [SMALL_STATE(3209)] = 75240,
  [SMALL_STATE(3210)] = 75304,
  [SMALL_STATE(3211)] = 75368,
  [SMALL_STATE(3212)] = 75432,
  [SMALL_STATE(3213)] = 75496,
  [SMALL_STATE(3214)] = 75560,
  [SMALL_STATE(3215)] = 75624,
  [SMALL_STATE(3216)] = 75688,
  [SMALL_STATE(3217)] = 75752,
  [SMALL_STATE(3218)] = 75816,
  [SMALL_STATE(3219)] = 75880,
  [SMALL_STATE(3220)] = 75944,
  [SMALL_STATE(3221)] = 76008,
  [SMALL_STATE(3222)] = 76072,
  [SMALL_STATE(3223)] = 76136,
  [SMALL_STATE(3224)] = 76200,
  [SMALL_STATE(3225)] = 76264,
  [SMALL_STATE(3226)] = 76328,
  [SMALL_STATE(3227)] = 76392,
  [SMALL_STATE(3228)] = 76456,
  [SMALL_STATE(3229)] = 76528,
  [SMALL_STATE(3230)] = 76600,
  [SMALL_STATE(3231)] = 76664,
  [SMALL_STATE(3232)] = 76728,
  [SMALL_STATE(3233)] = 76792,
  [SMALL_STATE(3234)] = 76856,
  [SMALL_STATE(3235)] = 76920,
  [SMALL_STATE(3236)] = 76992,
  [SMALL_STATE(3237)] = 77056,
  [SMALL_STATE(3238)] = 77120,
  [SMALL_STATE(3239)] = 77184,
  [SMALL_STATE(3240)] = 77254,
  [SMALL_STATE(3241)] = 77318,
  [SMALL_STATE(3242)] = 77382,
  [SMALL_STATE(3243)] = 77446,
  [SMALL_STATE(3244)] = 77510,
  [SMALL_STATE(3245)] = 77574,
  [SMALL_STATE(3246)] = 77638,
  [SMALL_STATE(3247)] = 77702,
  [SMALL_STATE(3248)] = 77766,
  [SMALL_STATE(3249)] = 77830,
  [SMALL_STATE(3250)] = 77894,
  [SMALL_STATE(3251)] = 77958,
  [SMALL_STATE(3252)] = 78022,
  [SMALL_STATE(3253)] = 78090,
  [SMALL_STATE(3254)] = 78154,
  [SMALL_STATE(3255)] = 78218,
  [SMALL_STATE(3256)] = 78282,
  [SMALL_STATE(3257)] = 78346,
  [SMALL_STATE(3258)] = 78410,
  [SMALL_STATE(3259)] = 78474,
  [SMALL_STATE(3260)] = 78538,
  [SMALL_STATE(3261)] = 78602,
  [SMALL_STATE(3262)] = 78666,
  [SMALL_STATE(3263)] = 78730,
  [SMALL_STATE(3264)] = 78810,
  [SMALL_STATE(3265)] = 78874,
  [SMALL_STATE(3266)] = 78938,
  [SMALL_STATE(3267)] = 79002,
  [SMALL_STATE(3268)] = 79066,
  [SMALL_STATE(3269)] = 79130,
  [SMALL_STATE(3270)] = 79194,
  [SMALL_STATE(3271)] = 79258,
  [SMALL_STATE(3272)] = 79322,
  [SMALL_STATE(3273)] = 79386,
  [SMALL_STATE(3274)] = 79450,
  [SMALL_STATE(3275)] = 79514,
  [SMALL_STATE(3276)] = 79582,
  [SMALL_STATE(3277)] = 79646,
  [SMALL_STATE(3278)] = 79710,
  [SMALL_STATE(3279)] = 79778,
  [SMALL_STATE(3280)] = 79842,
  [SMALL_STATE(3281)] = 79906,
  [SMALL_STATE(3282)] = 79970,
  [SMALL_STATE(3283)] = 80034,
  [SMALL_STATE(3284)] = 80098,
  [SMALL_STATE(3285)] = 80162,
  [SMALL_STATE(3286)] = 80226,
  [SMALL_STATE(3287)] = 80290,
  [SMALL_STATE(3288)] = 80354,
  [SMALL_STATE(3289)] = 80418,
  [SMALL_STATE(3290)] = 80482,
  [SMALL_STATE(3291)] = 80546,
  [SMALL_STATE(3292)] = 80610,
  [SMALL_STATE(3293)] = 80674,
  [SMALL_STATE(3294)] = 80738,
  [SMALL_STATE(3295)] = 80802,
  [SMALL_STATE(3296)] = 80866,
  [SMALL_STATE(3297)] = 80930,
  [SMALL_STATE(3298)] = 80994,
  [SMALL_STATE(3299)] = 81058,
  [SMALL_STATE(3300)] = 81122,
  [SMALL_STATE(3301)] = 81186,
  [SMALL_STATE(3302)] = 81250,
  [SMALL_STATE(3303)] = 81314,
  [SMALL_STATE(3304)] = 81378,
  [SMALL_STATE(3305)] = 81442,
  [SMALL_STATE(3306)] = 81506,
  [SMALL_STATE(3307)] = 81570,
  [SMALL_STATE(3308)] = 81634,
  [SMALL_STATE(3309)] = 81698,
  [SMALL_STATE(3310)] = 81762,
  [SMALL_STATE(3311)] = 81826,
  [SMALL_STATE(3312)] = 81890,
  [SMALL_STATE(3313)] = 81954,
  [SMALL_STATE(3314)] = 82018,
  [SMALL_STATE(3315)] = 82082,
  [SMALL_STATE(3316)] = 82146,
  [SMALL_STATE(3317)] = 82210,
  [SMALL_STATE(3318)] = 82274,
  [SMALL_STATE(3319)] = 82338,
  [SMALL_STATE(3320)] = 82402,
  [SMALL_STATE(3321)] = 82466,
  [SMALL_STATE(3322)] = 82530,
  [SMALL_STATE(3323)] = 82594,
  [SMALL_STATE(3324)] = 82658,
  [SMALL_STATE(3325)] = 82722,
  [SMALL_STATE(3326)] = 82786,
  [SMALL_STATE(3327)] = 82850,
  [SMALL_STATE(3328)] = 82914,
  [SMALL_STATE(3329)] = 82978,
  [SMALL_STATE(3330)] = 83042,
  [SMALL_STATE(3331)] = 83106,
  [SMALL_STATE(3332)] = 83170,
  [SMALL_STATE(3333)] = 83234,
  [SMALL_STATE(3334)] = 83298,
  [SMALL_STATE(3335)] = 83362,
  [SMALL_STATE(3336)] = 83426,
  [SMALL_STATE(3337)] = 83490,
  [SMALL_STATE(3338)] = 83554,
  [SMALL_STATE(3339)] = 83618,
  [SMALL_STATE(3340)] = 83682,
  [SMALL_STATE(3341)] = 83746,
  [SMALL_STATE(3342)] = 83810,
  [SMALL_STATE(3343)] = 83874,
  [SMALL_STATE(3344)] = 83938,
  [SMALL_STATE(3345)] = 84002,
  [SMALL_STATE(3346)] = 84070,
  [SMALL_STATE(3347)] = 84134,
  [SMALL_STATE(3348)] = 84198,
  [SMALL_STATE(3349)] = 84262,
  [SMALL_STATE(3350)] = 84326,
  [SMALL_STATE(3351)] = 84390,
  [SMALL_STATE(3352)] = 84454,
  [SMALL_STATE(3353)] = 84518,
  [SMALL_STATE(3354)] = 84582,
  [SMALL_STATE(3355)] = 84646,
  [SMALL_STATE(3356)] = 84710,
  [SMALL_STATE(3357)] = 84774,
  [SMALL_STATE(3358)] = 84838,
  [SMALL_STATE(3359)] = 84902,
  [SMALL_STATE(3360)] = 84966,
  [SMALL_STATE(3361)] = 85044,
  [SMALL_STATE(3362)] = 85108,
  [SMALL_STATE(3363)] = 85172,
  [SMALL_STATE(3364)] = 85236,
  [SMALL_STATE(3365)] = 85300,
  [SMALL_STATE(3366)] = 85364,
  [SMALL_STATE(3367)] = 85428,
  [SMALL_STATE(3368)] = 85492,
  [SMALL_STATE(3369)] = 85556,
  [SMALL_STATE(3370)] = 85620,
  [SMALL_STATE(3371)] = 85684,
  [SMALL_STATE(3372)] = 85748,
  [SMALL_STATE(3373)] = 85812,
  [SMALL_STATE(3374)] = 85876,
  [SMALL_STATE(3375)] = 85940,
  [SMALL_STATE(3376)] = 86004,
  [SMALL_STATE(3377)] = 86068,
  [SMALL_STATE(3378)] = 86132,
  [SMALL_STATE(3379)] = 86196,
  [SMALL_STATE(3380)] = 86260,
  [SMALL_STATE(3381)] = 86324,
  [SMALL_STATE(3382)] = 86388,
  [SMALL_STATE(3383)] = 86452,
  [SMALL_STATE(3384)] = 86516,
  [SMALL_STATE(3385)] = 86580,
  [SMALL_STATE(3386)] = 86644,
  [SMALL_STATE(3387)] = 86708,
  [SMALL_STATE(3388)] = 86772,
  [SMALL_STATE(3389)] = 86836,
  [SMALL_STATE(3390)] = 86900,
  [SMALL_STATE(3391)] = 86964,
  [SMALL_STATE(3392)] = 87028,
  [SMALL_STATE(3393)] = 87104,
  [SMALL_STATE(3394)] = 87168,
  [SMALL_STATE(3395)] = 87232,
  [SMALL_STATE(3396)] = 87296,
  [SMALL_STATE(3397)] = 87360,
  [SMALL_STATE(3398)] = 87424,
  [SMALL_STATE(3399)] = 87488,
  [SMALL_STATE(3400)] = 87552,
  [SMALL_STATE(3401)] = 87616,
  [SMALL_STATE(3402)] = 87680,
  [SMALL_STATE(3403)] = 87748,
  [SMALL_STATE(3404)] = 87826,
  [SMALL_STATE(3405)] = 87890,
  [SMALL_STATE(3406)] = 87954,
  [SMALL_STATE(3407)] = 88018,
  [SMALL_STATE(3408)] = 88082,
  [SMALL_STATE(3409)] = 88146,
  [SMALL_STATE(3410)] = 88210,
  [SMALL_STATE(3411)] = 88274,
  [SMALL_STATE(3412)] = 88338,
  [SMALL_STATE(3413)] = 88402,
  [SMALL_STATE(3414)] = 88466,
  [SMALL_STATE(3415)] = 88530,
  [SMALL_STATE(3416)] = 88594,
  [SMALL_STATE(3417)] = 88658,
  [SMALL_STATE(3418)] = 88722,
  [SMALL_STATE(3419)] = 88786,
  [SMALL_STATE(3420)] = 88850,
  [SMALL_STATE(3421)] = 88914,
  [SMALL_STATE(3422)] = 88977,
  [SMALL_STATE(3423)] = 89040,
  [SMALL_STATE(3424)] = 89103,
  [SMALL_STATE(3425)] = 89166,
  [SMALL_STATE(3426)] = 89229,
  [SMALL_STATE(3427)] = 89292,
  [SMALL_STATE(3428)] = 89355,
  [SMALL_STATE(3429)] = 89424,
  [SMALL_STATE(3430)] = 89491,
  [SMALL_STATE(3431)] = 89560,
  [SMALL_STATE(3432)] = 89623,
  [SMALL_STATE(3433)] = 89686,
  [SMALL_STATE(3434)] = 89749,
  [SMALL_STATE(3435)] = 89812,
  [SMALL_STATE(3436)] = 89875,
  [SMALL_STATE(3437)] = 89938,
  [SMALL_STATE(3438)] = 90009,
  [SMALL_STATE(3439)] = 90072,
  [SMALL_STATE(3440)] = 90153,
  [SMALL_STATE(3441)] = 90216,
  [SMALL_STATE(3442)] = 90279,
  [SMALL_STATE(3443)] = 90342,
  [SMALL_STATE(3444)] = 90411,
  [SMALL_STATE(3445)] = 90474,
  [SMALL_STATE(3446)] = 90537,
  [SMALL_STATE(3447)] = 90600,
  [SMALL_STATE(3448)] = 90663,
  [SMALL_STATE(3449)] = 90726,
  [SMALL_STATE(3450)] = 90789,
  [SMALL_STATE(3451)] = 90852,
  [SMALL_STATE(3452)] = 90919,
  [SMALL_STATE(3453)] = 90982,
  [SMALL_STATE(3454)] = 91051,
  [SMALL_STATE(3455)] = 91118,
  [SMALL_STATE(3456)] = 91187,
  [SMALL_STATE(3457)] = 91258,
  [SMALL_STATE(3458)] = 91327,
  [SMALL_STATE(3459)] = 91390,
  [SMALL_STATE(3460)] = 91453,
  [SMALL_STATE(3461)] = 91524,
  [SMALL_STATE(3462)] = 91587,
  [SMALL_STATE(3463)] = 91650,
  [SMALL_STATE(3464)] = 91719,
  [SMALL_STATE(3465)] = 91782,
  [SMALL_STATE(3466)] = 91845,
  [SMALL_STATE(3467)] = 91908,
  [SMALL_STATE(3468)] = 91971,
  [SMALL_STATE(3469)] = 92034,
  [SMALL_STATE(3470)] = 92097,
  [SMALL_STATE(3471)] = 92166,
  [SMALL_STATE(3472)] = 92229,
  [SMALL_STATE(3473)] = 92298,
  [SMALL_STATE(3474)] = 92367,
  [SMALL_STATE(3475)] = 92430,
  [SMALL_STATE(3476)] = 92493,
  [SMALL_STATE(3477)] = 92562,
  [SMALL_STATE(3478)] = 92631,
  [SMALL_STATE(3479)] = 92700,
  [SMALL_STATE(3480)] = 92771,
  [SMALL_STATE(3481)] = 92840,
  [SMALL_STATE(3482)] = 92909,
  [SMALL_STATE(3483)] = 92980,
  [SMALL_STATE(3484)] = 93043,
  [SMALL_STATE(3485)] = 93112,
  [SMALL_STATE(3486)] = 93175,
  [SMALL_STATE(3487)] = 93244,
  [SMALL_STATE(3488)] = 93307,
  [SMALL_STATE(3489)] = 93370,
  [SMALL_STATE(3490)] = 93433,
  [SMALL_STATE(3491)] = 93504,
  [SMALL_STATE(3492)] = 93573,
  [SMALL_STATE(3493)] = 93636,
  [SMALL_STATE(3494)] = 93699,
  [SMALL_STATE(3495)] = 93762,
  [SMALL_STATE(3496)] = 93825,
  [SMALL_STATE(3497)] = 93888,
  [SMALL_STATE(3498)] = 93951,
  [SMALL_STATE(3499)] = 94014,
  [SMALL_STATE(3500)] = 94077,
  [SMALL_STATE(3501)] = 94140,
  [SMALL_STATE(3502)] = 94203,
  [SMALL_STATE(3503)] = 94266,
  [SMALL_STATE(3504)] = 94329,
  [SMALL_STATE(3505)] = 94392,
  [SMALL_STATE(3506)] = 94455,
  [SMALL_STATE(3507)] = 94518,
  [SMALL_STATE(3508)] = 94587,
  [SMALL_STATE(3509)] = 94650,
  [SMALL_STATE(3510)] = 94713,
  [SMALL_STATE(3511)] = 94776,
  [SMALL_STATE(3512)] = 94847,
  [SMALL_STATE(3513)] = 94918,
  [SMALL_STATE(3514)] = 94989,
  [SMALL_STATE(3515)] = 95060,
  [SMALL_STATE(3516)] = 95123,
  [SMALL_STATE(3517)] = 95186,
  [SMALL_STATE(3518)] = 95257,
  [SMALL_STATE(3519)] = 95320,
  [SMALL_STATE(3520)] = 95383,
  [SMALL_STATE(3521)] = 95450,
  [SMALL_STATE(3522)] = 95513,
  [SMALL_STATE(3523)] = 95584,
  [SMALL_STATE(3524)] = 95647,
  [SMALL_STATE(3525)] = 95710,
  [SMALL_STATE(3526)] = 95773,
  [SMALL_STATE(3527)] = 95836,
  [SMALL_STATE(3528)] = 95905,
  [SMALL_STATE(3529)] = 95968,
  [SMALL_STATE(3530)] = 96031,
  [SMALL_STATE(3531)] = 96094,
  [SMALL_STATE(3532)] = 96163,
  [SMALL_STATE(3533)] = 96226,
  [SMALL_STATE(3534)] = 96289,
  [SMALL_STATE(3535)] = 96360,
  [SMALL_STATE(3536)] = 96423,
  [SMALL_STATE(3537)] = 96486,
  [SMALL_STATE(3538)] = 96549,
  [SMALL_STATE(3539)] = 96612,
  [SMALL_STATE(3540)] = 96675,
  [SMALL_STATE(3541)] = 96746,
  [SMALL_STATE(3542)] = 96809,
  [SMALL_STATE(3543)] = 96872,
  [SMALL_STATE(3544)] = 96935,
  [SMALL_STATE(3545)] = 96998,
  [SMALL_STATE(3546)] = 97061,
  [SMALL_STATE(3547)] = 97128,
  [SMALL_STATE(3548)] = 97191,
  [SMALL_STATE(3549)] = 97254,
  [SMALL_STATE(3550)] = 97317,
  [SMALL_STATE(3551)] = 97380,
  [SMALL_STATE(3552)] = 97443,
  [SMALL_STATE(3553)] = 97506,
  [SMALL_STATE(3554)] = 97569,
  [SMALL_STATE(3555)] = 97632,
  [SMALL_STATE(3556)] = 97703,
  [SMALL_STATE(3557)] = 97766,
  [SMALL_STATE(3558)] = 97829,
  [SMALL_STATE(3559)] = 97892,
  [SMALL_STATE(3560)] = 97955,
  [SMALL_STATE(3561)] = 98018,
  [SMALL_STATE(3562)] = 98081,
  [SMALL_STATE(3563)] = 98144,
  [SMALL_STATE(3564)] = 98207,
  [SMALL_STATE(3565)] = 98276,
  [SMALL_STATE(3566)] = 98339,
  [SMALL_STATE(3567)] = 98402,
  [SMALL_STATE(3568)] = 98465,
  [SMALL_STATE(3569)] = 98528,
  [SMALL_STATE(3570)] = 98591,
  [SMALL_STATE(3571)] = 98654,
  [SMALL_STATE(3572)] = 98717,
  [SMALL_STATE(3573)] = 98780,
  [SMALL_STATE(3574)] = 98843,
  [SMALL_STATE(3575)] = 98906,
  [SMALL_STATE(3576)] = 98969,
  [SMALL_STATE(3577)] = 99032,
  [SMALL_STATE(3578)] = 99095,
  [SMALL_STATE(3579)] = 99158,
  [SMALL_STATE(3580)] = 99221,
  [SMALL_STATE(3581)] = 99284,
  [SMALL_STATE(3582)] = 99347,
  [SMALL_STATE(3583)] = 99410,
  [SMALL_STATE(3584)] = 99473,
  [SMALL_STATE(3585)] = 99536,
  [SMALL_STATE(3586)] = 99599,
  [SMALL_STATE(3587)] = 99662,
  [SMALL_STATE(3588)] = 99725,
  [SMALL_STATE(3589)] = 99788,
  [SMALL_STATE(3590)] = 99851,
  [SMALL_STATE(3591)] = 99914,
  [SMALL_STATE(3592)] = 99977,
  [SMALL_STATE(3593)] = 100040,
  [SMALL_STATE(3594)] = 100103,
  [SMALL_STATE(3595)] = 100166,
  [SMALL_STATE(3596)] = 100235,
  [SMALL_STATE(3597)] = 100298,
  [SMALL_STATE(3598)] = 100361,
  [SMALL_STATE(3599)] = 100424,
  [SMALL_STATE(3600)] = 100495,
  [SMALL_STATE(3601)] = 100558,
  [SMALL_STATE(3602)] = 100621,
  [SMALL_STATE(3603)] = 100684,
  [SMALL_STATE(3604)] = 100753,
  [SMALL_STATE(3605)] = 100816,
  [SMALL_STATE(3606)] = 100879,
  [SMALL_STATE(3607)] = 100942,
  [SMALL_STATE(3608)] = 101005,
  [SMALL_STATE(3609)] = 101076,
  [SMALL_STATE(3610)] = 101139,
  [SMALL_STATE(3611)] = 101202,
  [SMALL_STATE(3612)] = 101273,
  [SMALL_STATE(3613)] = 101336,
  [SMALL_STATE(3614)] = 101399,
  [SMALL_STATE(3615)] = 101480,
  [SMALL_STATE(3616)] = 101543,
  [SMALL_STATE(3617)] = 101612,
  [SMALL_STATE(3618)] = 101675,
  [SMALL_STATE(3619)] = 101738,
  [SMALL_STATE(3620)] = 101801,
  [SMALL_STATE(3621)] = 101864,
  [SMALL_STATE(3622)] = 101927,
  [SMALL_STATE(3623)] = 101990,
  [SMALL_STATE(3624)] = 102053,
  [SMALL_STATE(3625)] = 102116,
  [SMALL_STATE(3626)] = 102179,
  [SMALL_STATE(3627)] = 102242,
  [SMALL_STATE(3628)] = 102305,
  [SMALL_STATE(3629)] = 102376,
  [SMALL_STATE(3630)] = 102447,
  [SMALL_STATE(3631)] = 102514,
  [SMALL_STATE(3632)] = 102577,
  [SMALL_STATE(3633)] = 102640,
  [SMALL_STATE(3634)] = 102703,
  [SMALL_STATE(3635)] = 102774,
  [SMALL_STATE(3636)] = 102845,
  [SMALL_STATE(3637)] = 102916,
  [SMALL_STATE(3638)] = 102979,
  [SMALL_STATE(3639)] = 103042,
  [SMALL_STATE(3640)] = 103105,
  [SMALL_STATE(3641)] = 103168,
  [SMALL_STATE(3642)] = 103239,
  [SMALL_STATE(3643)] = 103310,
  [SMALL_STATE(3644)] = 103373,
  [SMALL_STATE(3645)] = 103436,
  [SMALL_STATE(3646)] = 103499,
  [SMALL_STATE(3647)] = 103562,
  [SMALL_STATE(3648)] = 103629,
  [SMALL_STATE(3649)] = 103692,
  [SMALL_STATE(3650)] = 103759,
  [SMALL_STATE(3651)] = 103826,
  [SMALL_STATE(3652)] = 103889,
  [SMALL_STATE(3653)] = 103952,
  [SMALL_STATE(3654)] = 104023,
  [SMALL_STATE(3655)] = 104094,
  [SMALL_STATE(3656)] = 104157,
  [SMALL_STATE(3657)] = 104220,
  [SMALL_STATE(3658)] = 104283,
  [SMALL_STATE(3659)] = 104346,
  [SMALL_STATE(3660)] = 104417,
  [SMALL_STATE(3661)] = 104480,
  [SMALL_STATE(3662)] = 104543,
  [SMALL_STATE(3663)] = 104610,
  [SMALL_STATE(3664)] = 104677,
  [SMALL_STATE(3665)] = 104740,
  [SMALL_STATE(3666)] = 104803,
  [SMALL_STATE(3667)] = 104866,
  [SMALL_STATE(3668)] = 104935,
  [SMALL_STATE(3669)] = 104998,
  [SMALL_STATE(3670)] = 105061,
  [SMALL_STATE(3671)] = 105124,
  [SMALL_STATE(3672)] = 105193,
  [SMALL_STATE(3673)] = 105256,
  [SMALL_STATE(3674)] = 105319,
  [SMALL_STATE(3675)] = 105382,
  [SMALL_STATE(3676)] = 105445,
  [SMALL_STATE(3677)] = 105508,
  [SMALL_STATE(3678)] = 105571,
  [SMALL_STATE(3679)] = 105634,
  [SMALL_STATE(3680)] = 105697,
  [SMALL_STATE(3681)] = 105760,
  [SMALL_STATE(3682)] = 105823,
  [SMALL_STATE(3683)] = 105892,
  [SMALL_STATE(3684)] = 105955,
  [SMALL_STATE(3685)] = 106024,
  [SMALL_STATE(3686)] = 106086,
  [SMALL_STATE(3687)] = 106154,
  [SMALL_STATE(3688)] = 106216,
  [SMALL_STATE(3689)] = 106278,
  [SMALL_STATE(3690)] = 106346,
  [SMALL_STATE(3691)] = 106408,
  [SMALL_STATE(3692)] = 106470,
  [SMALL_STATE(3693)] = 106532,
  [SMALL_STATE(3694)] = 106594,
  [SMALL_STATE(3695)] = 106656,
  [SMALL_STATE(3696)] = 106718,
  [SMALL_STATE(3697)] = 106780,
  [SMALL_STATE(3698)] = 106842,
  [SMALL_STATE(3699)] = 106904,
  [SMALL_STATE(3700)] = 106966,
  [SMALL_STATE(3701)] = 107028,
  [SMALL_STATE(3702)] = 107090,
  [SMALL_STATE(3703)] = 107152,
  [SMALL_STATE(3704)] = 107214,
  [SMALL_STATE(3705)] = 107276,
  [SMALL_STATE(3706)] = 107346,
  [SMALL_STATE(3707)] = 107416,
  [SMALL_STATE(3708)] = 107478,
  [SMALL_STATE(3709)] = 107548,
  [SMALL_STATE(3710)] = 107610,
  [SMALL_STATE(3711)] = 107672,
  [SMALL_STATE(3712)] = 107734,
  [SMALL_STATE(3713)] = 107796,
  [SMALL_STATE(3714)] = 107866,
  [SMALL_STATE(3715)] = 107936,
  [SMALL_STATE(3716)] = 107998,
  [SMALL_STATE(3717)] = 108060,
  [SMALL_STATE(3718)] = 108122,
  [SMALL_STATE(3719)] = 108184,
  [SMALL_STATE(3720)] = 108254,
  [SMALL_STATE(3721)] = 108316,
  [SMALL_STATE(3722)] = 108378,
  [SMALL_STATE(3723)] = 108440,
  [SMALL_STATE(3724)] = 108502,
  [SMALL_STATE(3725)] = 108564,
  [SMALL_STATE(3726)] = 108626,
  [SMALL_STATE(3727)] = 108688,
  [SMALL_STATE(3728)] = 108750,
  [SMALL_STATE(3729)] = 108812,
  [SMALL_STATE(3730)] = 108874,
  [SMALL_STATE(3731)] = 108936,
  [SMALL_STATE(3732)] = 109002,
  [SMALL_STATE(3733)] = 109064,
  [SMALL_STATE(3734)] = 109126,
  [SMALL_STATE(3735)] = 109188,
  [SMALL_STATE(3736)] = 109256,
  [SMALL_STATE(3737)] = 109322,
  [SMALL_STATE(3738)] = 109384,
  [SMALL_STATE(3739)] = 109446,
  [SMALL_STATE(3740)] = 109508,
  [SMALL_STATE(3741)] = 109570,
  [SMALL_STATE(3742)] = 109632,
  [SMALL_STATE(3743)] = 109694,
  [SMALL_STATE(3744)] = 109756,
  [SMALL_STATE(3745)] = 109818,
  [SMALL_STATE(3746)] = 109880,
  [SMALL_STATE(3747)] = 109942,
  [SMALL_STATE(3748)] = 110004,
  [SMALL_STATE(3749)] = 110066,
  [SMALL_STATE(3750)] = 110128,
  [SMALL_STATE(3751)] = 110190,
  [SMALL_STATE(3752)] = 110252,
  [SMALL_STATE(3753)] = 110314,
  [SMALL_STATE(3754)] = 110376,
  [SMALL_STATE(3755)] = 110438,
  [SMALL_STATE(3756)] = 110500,
  [SMALL_STATE(3757)] = 110562,
  [SMALL_STATE(3758)] = 110624,
  [SMALL_STATE(3759)] = 110686,
  [SMALL_STATE(3760)] = 110748,
  [SMALL_STATE(3761)] = 110810,
  [SMALL_STATE(3762)] = 110872,
  [SMALL_STATE(3763)] = 110934,
  [SMALL_STATE(3764)] = 110996,
  [SMALL_STATE(3765)] = 111058,
  [SMALL_STATE(3766)] = 111120,
  [SMALL_STATE(3767)] = 111182,
  [SMALL_STATE(3768)] = 111244,
  [SMALL_STATE(3769)] = 111306,
  [SMALL_STATE(3770)] = 111368,
  [SMALL_STATE(3771)] = 111430,
  [SMALL_STATE(3772)] = 111492,
  [SMALL_STATE(3773)] = 111554,
  [SMALL_STATE(3774)] = 111616,
  [SMALL_STATE(3775)] = 111682,
  [SMALL_STATE(3776)] = 111744,
  [SMALL_STATE(3777)] = 111818,
  [SMALL_STATE(3778)] = 111886,
  [SMALL_STATE(3779)] = 111954,
  [SMALL_STATE(3780)] = 112016,
  [SMALL_STATE(3781)] = 112084,
  [SMALL_STATE(3782)] = 112146,
  [SMALL_STATE(3783)] = 112208,
  [SMALL_STATE(3784)] = 112270,
  [SMALL_STATE(3785)] = 112332,
  [SMALL_STATE(3786)] = 112394,
  [SMALL_STATE(3787)] = 112456,
  [SMALL_STATE(3788)] = 112524,
  [SMALL_STATE(3789)] = 112586,
  [SMALL_STATE(3790)] = 112648,
  [SMALL_STATE(3791)] = 112716,
  [SMALL_STATE(3792)] = 112778,
  [SMALL_STATE(3793)] = 112846,
  [SMALL_STATE(3794)] = 112908,
  [SMALL_STATE(3795)] = 112970,
  [SMALL_STATE(3796)] = 113040,
  [SMALL_STATE(3797)] = 113102,
  [SMALL_STATE(3798)] = 113164,
  [SMALL_STATE(3799)] = 113226,
  [SMALL_STATE(3800)] = 113288,
  [SMALL_STATE(3801)] = 113350,
  [SMALL_STATE(3802)] = 113412,
  [SMALL_STATE(3803)] = 113474,
  [SMALL_STATE(3804)] = 113535,
  [SMALL_STATE(3805)] = 113638,
  [SMALL_STATE(3806)] = 113699,
  [SMALL_STATE(3807)] = 113760,
  [SMALL_STATE(3808)] = 113821,
  [SMALL_STATE(3809)] = 113882,
  [SMALL_STATE(3810)] = 113949,
  [SMALL_STATE(3811)] = 114010,
  [SMALL_STATE(3812)] = 114071,
  [SMALL_STATE(3813)] = 114138,
  [SMALL_STATE(3814)] = 114203,
  [SMALL_STATE(3815)] = 114264,
  [SMALL_STATE(3816)] = 114329,
  [SMALL_STATE(3817)] = 114396,
  [SMALL_STATE(3818)] = 114499,
  [SMALL_STATE(3819)] = 114564,
  [SMALL_STATE(3820)] = 114625,
  [SMALL_STATE(3821)] = 114692,
  [SMALL_STATE(3822)] = 114753,
  [SMALL_STATE(3823)] = 114814,
  [SMALL_STATE(3824)] = 114875,
  [SMALL_STATE(3825)] = 114936,
  [SMALL_STATE(3826)] = 114997,
  [SMALL_STATE(3827)] = 115058,
  [SMALL_STATE(3828)] = 115119,
  [SMALL_STATE(3829)] = 115184,
  [SMALL_STATE(3830)] = 115245,
  [SMALL_STATE(3831)] = 115312,
  [SMALL_STATE(3832)] = 115379,
  [SMALL_STATE(3833)] = 115440,
  [SMALL_STATE(3834)] = 115507,
  [SMALL_STATE(3835)] = 115574,
  [SMALL_STATE(3836)] = 115643,
  [SMALL_STATE(3837)] = 115708,
  [SMALL_STATE(3838)] = 115775,
  [SMALL_STATE(3839)] = 115836,
  [SMALL_STATE(3840)] = 115903,
  [SMALL_STATE(3841)] = 115964,
  [SMALL_STATE(3842)] = 116025,
  [SMALL_STATE(3843)] = 116086,
  [SMALL_STATE(3844)] = 116147,
  [SMALL_STATE(3845)] = 116208,
  [SMALL_STATE(3846)] = 116269,
  [SMALL_STATE(3847)] = 116330,
  [SMALL_STATE(3848)] = 116433,
  [SMALL_STATE(3849)] = 116494,
  [SMALL_STATE(3850)] = 116555,
  [SMALL_STATE(3851)] = 116622,
  [SMALL_STATE(3852)] = 116683,
  [SMALL_STATE(3853)] = 116750,
  [SMALL_STATE(3854)] = 116817,
  [SMALL_STATE(3855)] = 116920,
  [SMALL_STATE(3856)] = 116981,
  [SMALL_STATE(3857)] = 117046,
  [SMALL_STATE(3858)] = 117111,
  [SMALL_STATE(3859)] = 117172,
  [SMALL_STATE(3860)] = 117239,
  [SMALL_STATE(3861)] = 117300,
  [SMALL_STATE(3862)] = 117369,
  [SMALL_STATE(3863)] = 117436,
  [SMALL_STATE(3864)] = 117539,
  [SMALL_STATE(3865)] = 117606,
  [SMALL_STATE(3866)] = 117673,
  [SMALL_STATE(3867)] = 117734,
  [SMALL_STATE(3868)] = 117801,
  [SMALL_STATE(3869)] = 117866,
  [SMALL_STATE(3870)] = 117927,
  [SMALL_STATE(3871)] = 118002,
  [SMALL_STATE(3872)] = 118067,
  [SMALL_STATE(3873)] = 118134,
  [SMALL_STATE(3874)] = 118201,
  [SMALL_STATE(3875)] = 118304,
  [SMALL_STATE(3876)] = 118369,
  [SMALL_STATE(3877)] = 118436,
  [SMALL_STATE(3878)] = 118503,
  [SMALL_STATE(3879)] = 118570,
  [SMALL_STATE(3880)] = 118637,
  [SMALL_STATE(3881)] = 118704,
  [SMALL_STATE(3882)] = 118771,
  [SMALL_STATE(3883)] = 118838,
  [SMALL_STATE(3884)] = 118905,
  [SMALL_STATE(3885)] = 118972,
  [SMALL_STATE(3886)] = 119075,
  [SMALL_STATE(3887)] = 119136,
  [SMALL_STATE(3888)] = 119197,
  [SMALL_STATE(3889)] = 119258,
  [SMALL_STATE(3890)] = 119319,
  [SMALL_STATE(3891)] = 119386,
  [SMALL_STATE(3892)] = 119447,
  [SMALL_STATE(3893)] = 119508,
  [SMALL_STATE(3894)] = 119575,
  [SMALL_STATE(3895)] = 119636,
  [SMALL_STATE(3896)] = 119703,
  [SMALL_STATE(3897)] = 119764,
  [SMALL_STATE(3898)] = 119825,
  [SMALL_STATE(3899)] = 119886,
  [SMALL_STATE(3900)] = 119953,
  [SMALL_STATE(3901)] = 120014,
  [SMALL_STATE(3902)] = 120075,
  [SMALL_STATE(3903)] = 120136,
  [SMALL_STATE(3904)] = 120197,
  [SMALL_STATE(3905)] = 120264,
  [SMALL_STATE(3906)] = 120325,
  [SMALL_STATE(3907)] = 120386,
  [SMALL_STATE(3908)] = 120451,
  [SMALL_STATE(3909)] = 120512,
  [SMALL_STATE(3910)] = 120573,
  [SMALL_STATE(3911)] = 120634,
  [SMALL_STATE(3912)] = 120695,
  [SMALL_STATE(3913)] = 120756,
  [SMALL_STATE(3914)] = 120817,
  [SMALL_STATE(3915)] = 120878,
  [SMALL_STATE(3916)] = 120945,
  [SMALL_STATE(3917)] = 121006,
  [SMALL_STATE(3918)] = 121073,
  [SMALL_STATE(3919)] = 121134,
  [SMALL_STATE(3920)] = 121195,
  [SMALL_STATE(3921)] = 121262,
  [SMALL_STATE(3922)] = 121329,
  [SMALL_STATE(3923)] = 121390,
  [SMALL_STATE(3924)] = 121459,
  [SMALL_STATE(3925)] = 121526,
  [SMALL_STATE(3926)] = 121587,
  [SMALL_STATE(3927)] = 121654,
  [SMALL_STATE(3928)] = 121721,
  [SMALL_STATE(3929)] = 121782,
  [SMALL_STATE(3930)] = 121851,
  [SMALL_STATE(3931)] = 121920,
  [SMALL_STATE(3932)] = 121987,
  [SMALL_STATE(3933)] = 122047,
  [SMALL_STATE(3934)] = 122111,
  [SMALL_STATE(3935)] = 122171,
  [SMALL_STATE(3936)] = 122231,
  [SMALL_STATE(3937)] = 122291,
  [SMALL_STATE(3938)] = 122351,
  [SMALL_STATE(3939)] = 122411,
  [SMALL_STATE(3940)] = 122471,
  [SMALL_STATE(3941)] = 122531,
  [SMALL_STATE(3942)] = 122591,
  [SMALL_STATE(3943)] = 122651,
  [SMALL_STATE(3944)] = 122711,
  [SMALL_STATE(3945)] = 122777,
  [SMALL_STATE(3946)] = 122837,
  [SMALL_STATE(3947)] = 122897,
  [SMALL_STATE(3948)] = 122957,
  [SMALL_STATE(3949)] = 123017,
  [SMALL_STATE(3950)] = 123077,
  [SMALL_STATE(3951)] = 123137,
  [SMALL_STATE(3952)] = 123197,
  [SMALL_STATE(3953)] = 123257,
  [SMALL_STATE(3954)] = 123317,
  [SMALL_STATE(3955)] = 123377,
  [SMALL_STATE(3956)] = 123437,
  [SMALL_STATE(3957)] = 123497,
  [SMALL_STATE(3958)] = 123557,
  [SMALL_STATE(3959)] = 123617,
  [SMALL_STATE(3960)] = 123677,
  [SMALL_STATE(3961)] = 123737,
  [SMALL_STATE(3962)] = 123797,
  [SMALL_STATE(3963)] = 123857,
  [SMALL_STATE(3964)] = 123917,
  [SMALL_STATE(3965)] = 123977,
  [SMALL_STATE(3966)] = 124037,
  [SMALL_STATE(3967)] = 124097,
  [SMALL_STATE(3968)] = 124157,
  [SMALL_STATE(3969)] = 124217,
  [SMALL_STATE(3970)] = 124277,
  [SMALL_STATE(3971)] = 124337,
  [SMALL_STATE(3972)] = 124397,
  [SMALL_STATE(3973)] = 124457,
  [SMALL_STATE(3974)] = 124517,
  [SMALL_STATE(3975)] = 124577,
  [SMALL_STATE(3976)] = 124637,
  [SMALL_STATE(3977)] = 124697,
  [SMALL_STATE(3978)] = 124757,
  [SMALL_STATE(3979)] = 124817,
  [SMALL_STATE(3980)] = 124877,
  [SMALL_STATE(3981)] = 124937,
  [SMALL_STATE(3982)] = 124997,
  [SMALL_STATE(3983)] = 125057,
  [SMALL_STATE(3984)] = 125117,
  [SMALL_STATE(3985)] = 125177,
  [SMALL_STATE(3986)] = 125237,
  [SMALL_STATE(3987)] = 125297,
  [SMALL_STATE(3988)] = 125357,
  [SMALL_STATE(3989)] = 125417,
  [SMALL_STATE(3990)] = 125477,
  [SMALL_STATE(3991)] = 125537,
  [SMALL_STATE(3992)] = 125597,
  [SMALL_STATE(3993)] = 125657,
  [SMALL_STATE(3994)] = 125717,
  [SMALL_STATE(3995)] = 125777,
  [SMALL_STATE(3996)] = 125837,
  [SMALL_STATE(3997)] = 125897,
  [SMALL_STATE(3998)] = 125957,
  [SMALL_STATE(3999)] = 126017,
  [SMALL_STATE(4000)] = 126077,
  [SMALL_STATE(4001)] = 126137,
  [SMALL_STATE(4002)] = 126197,
  [SMALL_STATE(4003)] = 126257,
  [SMALL_STATE(4004)] = 126317,
  [SMALL_STATE(4005)] = 126377,
  [SMALL_STATE(4006)] = 126437,
  [SMALL_STATE(4007)] = 126497,
  [SMALL_STATE(4008)] = 126557,
  [SMALL_STATE(4009)] = 126617,
  [SMALL_STATE(4010)] = 126677,
  [SMALL_STATE(4011)] = 126737,
  [SMALL_STATE(4012)] = 126797,
  [SMALL_STATE(4013)] = 126857,
  [SMALL_STATE(4014)] = 126917,
  [SMALL_STATE(4015)] = 126977,
  [SMALL_STATE(4016)] = 127037,
  [SMALL_STATE(4017)] = 127097,
  [SMALL_STATE(4018)] = 127157,
  [SMALL_STATE(4019)] = 127217,
  [SMALL_STATE(4020)] = 127277,
  [SMALL_STATE(4021)] = 127337,
  [SMALL_STATE(4022)] = 127397,
  [SMALL_STATE(4023)] = 127463,
  [SMALL_STATE(4024)] = 127523,
  [SMALL_STATE(4025)] = 127583,
  [SMALL_STATE(4026)] = 127643,
  [SMALL_STATE(4027)] = 127703,
  [SMALL_STATE(4028)] = 127763,
  [SMALL_STATE(4029)] = 127829,
  [SMALL_STATE(4030)] = 127889,
  [SMALL_STATE(4031)] = 127949,
  [SMALL_STATE(4032)] = 128009,
  [SMALL_STATE(4033)] = 128069,
  [SMALL_STATE(4034)] = 128129,
  [SMALL_STATE(4035)] = 128189,
  [SMALL_STATE(4036)] = 128249,
  [SMALL_STATE(4037)] = 128309,
  [SMALL_STATE(4038)] = 128369,
  [SMALL_STATE(4039)] = 128429,
  [SMALL_STATE(4040)] = 128495,
  [SMALL_STATE(4041)] = 128555,
  [SMALL_STATE(4042)] = 128615,
  [SMALL_STATE(4043)] = 128675,
  [SMALL_STATE(4044)] = 128735,
  [SMALL_STATE(4045)] = 128795,
  [SMALL_STATE(4046)] = 128855,
  [SMALL_STATE(4047)] = 128915,
  [SMALL_STATE(4048)] = 128975,
  [SMALL_STATE(4049)] = 129035,
  [SMALL_STATE(4050)] = 129095,
  [SMALL_STATE(4051)] = 129155,
  [SMALL_STATE(4052)] = 129215,
  [SMALL_STATE(4053)] = 129275,
  [SMALL_STATE(4054)] = 129335,
  [SMALL_STATE(4055)] = 129395,
  [SMALL_STATE(4056)] = 129455,
  [SMALL_STATE(4057)] = 129515,
  [SMALL_STATE(4058)] = 129575,
  [SMALL_STATE(4059)] = 129639,
  [SMALL_STATE(4060)] = 129699,
  [SMALL_STATE(4061)] = 129759,
  [SMALL_STATE(4062)] = 129819,
  [SMALL_STATE(4063)] = 129879,
  [SMALL_STATE(4064)] = 129939,
  [SMALL_STATE(4065)] = 129999,
  [SMALL_STATE(4066)] = 130059,
  [SMALL_STATE(4067)] = 130119,
  [SMALL_STATE(4068)] = 130179,
  [SMALL_STATE(4069)] = 130239,
  [SMALL_STATE(4070)] = 130299,
  [SMALL_STATE(4071)] = 130359,
  [SMALL_STATE(4072)] = 130419,
  [SMALL_STATE(4073)] = 130479,
  [SMALL_STATE(4074)] = 130539,
  [SMALL_STATE(4075)] = 130599,
  [SMALL_STATE(4076)] = 130659,
  [SMALL_STATE(4077)] = 130719,
  [SMALL_STATE(4078)] = 130779,
  [SMALL_STATE(4079)] = 130839,
  [SMALL_STATE(4080)] = 130905,
  [SMALL_STATE(4081)] = 130965,
  [SMALL_STATE(4082)] = 131025,
  [SMALL_STATE(4083)] = 131085,
  [SMALL_STATE(4084)] = 131145,
  [SMALL_STATE(4085)] = 131205,
  [SMALL_STATE(4086)] = 131265,
  [SMALL_STATE(4087)] = 131325,
  [SMALL_STATE(4088)] = 131385,
  [SMALL_STATE(4089)] = 131445,
  [SMALL_STATE(4090)] = 131505,
  [SMALL_STATE(4091)] = 131565,
  [SMALL_STATE(4092)] = 131631,
  [SMALL_STATE(4093)] = 131691,
  [SMALL_STATE(4094)] = 131751,
  [SMALL_STATE(4095)] = 131811,
  [SMALL_STATE(4096)] = 131871,
  [SMALL_STATE(4097)] = 131931,
  [SMALL_STATE(4098)] = 131991,
  [SMALL_STATE(4099)] = 132051,
  [SMALL_STATE(4100)] = 132111,
  [SMALL_STATE(4101)] = 132171,
  [SMALL_STATE(4102)] = 132231,
  [SMALL_STATE(4103)] = 132291,
  [SMALL_STATE(4104)] = 132351,
  [SMALL_STATE(4105)] = 132411,
  [SMALL_STATE(4106)] = 132471,
  [SMALL_STATE(4107)] = 132531,
  [SMALL_STATE(4108)] = 132591,
  [SMALL_STATE(4109)] = 132651,
  [SMALL_STATE(4110)] = 132711,
  [SMALL_STATE(4111)] = 132771,
  [SMALL_STATE(4112)] = 132831,
  [SMALL_STATE(4113)] = 132891,
  [SMALL_STATE(4114)] = 132951,
  [SMALL_STATE(4115)] = 133011,
  [SMALL_STATE(4116)] = 133071,
  [SMALL_STATE(4117)] = 133131,
  [SMALL_STATE(4118)] = 133191,
  [SMALL_STATE(4119)] = 133251,
  [SMALL_STATE(4120)] = 133311,
  [SMALL_STATE(4121)] = 133371,
  [SMALL_STATE(4122)] = 133431,
  [SMALL_STATE(4123)] = 133491,
  [SMALL_STATE(4124)] = 133551,
  [SMALL_STATE(4125)] = 133611,
  [SMALL_STATE(4126)] = 133671,
  [SMALL_STATE(4127)] = 133731,
  [SMALL_STATE(4128)] = 133791,
  [SMALL_STATE(4129)] = 133851,
  [SMALL_STATE(4130)] = 133911,
  [SMALL_STATE(4131)] = 133971,
  [SMALL_STATE(4132)] = 134031,
  [SMALL_STATE(4133)] = 134091,
  [SMALL_STATE(4134)] = 134151,
  [SMALL_STATE(4135)] = 134211,
  [SMALL_STATE(4136)] = 134271,
  [SMALL_STATE(4137)] = 134331,
  [SMALL_STATE(4138)] = 134391,
  [SMALL_STATE(4139)] = 134451,
  [SMALL_STATE(4140)] = 134511,
  [SMALL_STATE(4141)] = 134571,
  [SMALL_STATE(4142)] = 134631,
  [SMALL_STATE(4143)] = 134691,
  [SMALL_STATE(4144)] = 134751,
  [SMALL_STATE(4145)] = 134811,
  [SMALL_STATE(4146)] = 134871,
  [SMALL_STATE(4147)] = 134931,
  [SMALL_STATE(4148)] = 134991,
  [SMALL_STATE(4149)] = 135051,
  [SMALL_STATE(4150)] = 135111,
  [SMALL_STATE(4151)] = 135171,
  [SMALL_STATE(4152)] = 135231,
  [SMALL_STATE(4153)] = 135291,
  [SMALL_STATE(4154)] = 135357,
  [SMALL_STATE(4155)] = 135417,
  [SMALL_STATE(4156)] = 135477,
  [SMALL_STATE(4157)] = 135537,
  [SMALL_STATE(4158)] = 135601,
  [SMALL_STATE(4159)] = 135661,
  [SMALL_STATE(4160)] = 135721,
  [SMALL_STATE(4161)] = 135781,
  [SMALL_STATE(4162)] = 135841,
  [SMALL_STATE(4163)] = 135901,
  [SMALL_STATE(4164)] = 135961,
  [SMALL_STATE(4165)] = 136021,
  [SMALL_STATE(4166)] = 136081,
  [SMALL_STATE(4167)] = 136141,
  [SMALL_STATE(4168)] = 136201,
  [SMALL_STATE(4169)] = 136261,
  [SMALL_STATE(4170)] = 136321,
  [SMALL_STATE(4171)] = 136381,
  [SMALL_STATE(4172)] = 136441,
  [SMALL_STATE(4173)] = 136501,
  [SMALL_STATE(4174)] = 136561,
  [SMALL_STATE(4175)] = 136625,
  [SMALL_STATE(4176)] = 136685,
  [SMALL_STATE(4177)] = 136745,
  [SMALL_STATE(4178)] = 136805,
  [SMALL_STATE(4179)] = 136865,
  [SMALL_STATE(4180)] = 136925,
  [SMALL_STATE(4181)] = 136985,
  [SMALL_STATE(4182)] = 137045,
  [SMALL_STATE(4183)] = 137105,
  [SMALL_STATE(4184)] = 137165,
  [SMALL_STATE(4185)] = 137225,
  [SMALL_STATE(4186)] = 137285,
  [SMALL_STATE(4187)] = 137345,
  [SMALL_STATE(4188)] = 137405,
  [SMALL_STATE(4189)] = 137465,
  [SMALL_STATE(4190)] = 137525,
  [SMALL_STATE(4191)] = 137585,
  [SMALL_STATE(4192)] = 137645,
  [SMALL_STATE(4193)] = 137705,
  [SMALL_STATE(4194)] = 137765,
  [SMALL_STATE(4195)] = 137825,
  [SMALL_STATE(4196)] = 137885,
  [SMALL_STATE(4197)] = 137945,
  [SMALL_STATE(4198)] = 138005,
  [SMALL_STATE(4199)] = 138065,
  [SMALL_STATE(4200)] = 138125,
  [SMALL_STATE(4201)] = 138185,
  [SMALL_STATE(4202)] = 138251,
  [SMALL_STATE(4203)] = 138311,
  [SMALL_STATE(4204)] = 138371,
  [SMALL_STATE(4205)] = 138431,
  [SMALL_STATE(4206)] = 138491,
  [SMALL_STATE(4207)] = 138557,
  [SMALL_STATE(4208)] = 138617,
  [SMALL_STATE(4209)] = 138677,
  [SMALL_STATE(4210)] = 138737,
  [SMALL_STATE(4211)] = 138797,
  [SMALL_STATE(4212)] = 138857,
  [SMALL_STATE(4213)] = 138923,
  [SMALL_STATE(4214)] = 138983,
  [SMALL_STATE(4215)] = 139043,
  [SMALL_STATE(4216)] = 139103,
  [SMALL_STATE(4217)] = 139167,
  [SMALL_STATE(4218)] = 139227,
  [SMALL_STATE(4219)] = 139287,
  [SMALL_STATE(4220)] = 139347,
  [SMALL_STATE(4221)] = 139407,
  [SMALL_STATE(4222)] = 139473,
  [SMALL_STATE(4223)] = 139533,
  [SMALL_STATE(4224)] = 139593,
  [SMALL_STATE(4225)] = 139653,
  [SMALL_STATE(4226)] = 139713,
  [SMALL_STATE(4227)] = 139773,
  [SMALL_STATE(4228)] = 139833,
  [SMALL_STATE(4229)] = 139893,
  [SMALL_STATE(4230)] = 139957,
  [SMALL_STATE(4231)] = 140021,
  [SMALL_STATE(4232)] = 140081,
  [SMALL_STATE(4233)] = 140141,
  [SMALL_STATE(4234)] = 140201,
  [SMALL_STATE(4235)] = 140261,
  [SMALL_STATE(4236)] = 140320,
  [SMALL_STATE(4237)] = 140383,
  [SMALL_STATE(4238)] = 140442,
  [SMALL_STATE(4239)] = 140505,
  [SMALL_STATE(4240)] = 140568,
  [SMALL_STATE(4241)] = 140627,
  [SMALL_STATE(4242)] = 140686,
  [SMALL_STATE(4243)] = 140745,
  [SMALL_STATE(4244)] = 140804,
  [SMALL_STATE(4245)] = 140863,
  [SMALL_STATE(4246)] = 140922,
  [SMALL_STATE(4247)] = 140981,
  [SMALL_STATE(4248)] = 141044,
  [SMALL_STATE(4249)] = 141103,
  [SMALL_STATE(4250)] = 141162,
  [SMALL_STATE(4251)] = 141221,
  [SMALL_STATE(4252)] = 141280,
  [SMALL_STATE(4253)] = 141339,
  [SMALL_STATE(4254)] = 141398,
  [SMALL_STATE(4255)] = 141491,
  [SMALL_STATE(4256)] = 141550,
  [SMALL_STATE(4257)] = 141609,
  [SMALL_STATE(4258)] = 141668,
  [SMALL_STATE(4259)] = 141727,
  [SMALL_STATE(4260)] = 141790,
  [SMALL_STATE(4261)] = 141853,
  [SMALL_STATE(4262)] = 141912,
  [SMALL_STATE(4263)] = 141971,
  [SMALL_STATE(4264)] = 142030,
  [SMALL_STATE(4265)] = 142089,
  [SMALL_STATE(4266)] = 142148,
  [SMALL_STATE(4267)] = 142211,
  [SMALL_STATE(4268)] = 142270,
  [SMALL_STATE(4269)] = 142329,
  [SMALL_STATE(4270)] = 142388,
  [SMALL_STATE(4271)] = 142453,
  [SMALL_STATE(4272)] = 142512,
  [SMALL_STATE(4273)] = 142571,
  [SMALL_STATE(4274)] = 142630,
  [SMALL_STATE(4275)] = 142689,
  [SMALL_STATE(4276)] = 142748,
  [SMALL_STATE(4277)] = 142807,
  [SMALL_STATE(4278)] = 142872,
  [SMALL_STATE(4279)] = 142931,
  [SMALL_STATE(4280)] = 142990,
  [SMALL_STATE(4281)] = 143049,
  [SMALL_STATE(4282)] = 143114,
  [SMALL_STATE(4283)] = 143173,
  [SMALL_STATE(4284)] = 143236,
  [SMALL_STATE(4285)] = 143295,
  [SMALL_STATE(4286)] = 143358,
  [SMALL_STATE(4287)] = 143417,
  [SMALL_STATE(4288)] = 143476,
  [SMALL_STATE(4289)] = 143535,
  [SMALL_STATE(4290)] = 143598,
  [SMALL_STATE(4291)] = 143661,
  [SMALL_STATE(4292)] = 143720,
  [SMALL_STATE(4293)] = 143785,
  [SMALL_STATE(4294)] = 143844,
  [SMALL_STATE(4295)] = 143903,
  [SMALL_STATE(4296)] = 143962,
  [SMALL_STATE(4297)] = 144027,
  [SMALL_STATE(4298)] = 144086,
  [SMALL_STATE(4299)] = 144145,
  [SMALL_STATE(4300)] = 144204,
  [SMALL_STATE(4301)] = 144269,
  [SMALL_STATE(4302)] = 144328,
  [SMALL_STATE(4303)] = 144387,
  [SMALL_STATE(4304)] = 144450,
  [SMALL_STATE(4305)] = 144509,
  [SMALL_STATE(4306)] = 144567,
  [SMALL_STATE(4307)] = 144625,
  [SMALL_STATE(4308)] = 144683,
  [SMALL_STATE(4309)] = 144741,
  [SMALL_STATE(4310)] = 144799,
  [SMALL_STATE(4311)] = 144863,
  [SMALL_STATE(4312)] = 144921,
  [SMALL_STATE(4313)] = 144979,
  [SMALL_STATE(4314)] = 145037,
  [SMALL_STATE(4315)] = 145095,
  [SMALL_STATE(4316)] = 145153,
  [SMALL_STATE(4317)] = 145211,
  [SMALL_STATE(4318)] = 145269,
  [SMALL_STATE(4319)] = 145327,
  [SMALL_STATE(4320)] = 145385,
  [SMALL_STATE(4321)] = 145443,
  [SMALL_STATE(4322)] = 145501,
  [SMALL_STATE(4323)] = 145559,
  [SMALL_STATE(4324)] = 145617,
  [SMALL_STATE(4325)] = 145675,
  [SMALL_STATE(4326)] = 145733,
  [SMALL_STATE(4327)] = 145791,
  [SMALL_STATE(4328)] = 145849,
  [SMALL_STATE(4329)] = 145907,
  [SMALL_STATE(4330)] = 145965,
  [SMALL_STATE(4331)] = 146023,
  [SMALL_STATE(4332)] = 146081,
  [SMALL_STATE(4333)] = 146139,
  [SMALL_STATE(4334)] = 146197,
  [SMALL_STATE(4335)] = 146255,
  [SMALL_STATE(4336)] = 146313,
  [SMALL_STATE(4337)] = 146371,
  [SMALL_STATE(4338)] = 146429,
  [SMALL_STATE(4339)] = 146487,
  [SMALL_STATE(4340)] = 146545,
  [SMALL_STATE(4341)] = 146603,
  [SMALL_STATE(4342)] = 146661,
  [SMALL_STATE(4343)] = 146719,
  [SMALL_STATE(4344)] = 146777,
  [SMALL_STATE(4345)] = 146835,
  [SMALL_STATE(4346)] = 146893,
  [SMALL_STATE(4347)] = 146951,
  [SMALL_STATE(4348)] = 147013,
  [SMALL_STATE(4349)] = 147071,
  [SMALL_STATE(4350)] = 147129,
  [SMALL_STATE(4351)] = 147187,
  [SMALL_STATE(4352)] = 147245,
  [SMALL_STATE(4353)] = 147303,
  [SMALL_STATE(4354)] = 147361,
  [SMALL_STATE(4355)] = 147419,
  [SMALL_STATE(4356)] = 147477,
  [SMALL_STATE(4357)] = 147535,
  [SMALL_STATE(4358)] = 147593,
  [SMALL_STATE(4359)] = 147651,
  [SMALL_STATE(4360)] = 147709,
  [SMALL_STATE(4361)] = 147767,
  [SMALL_STATE(4362)] = 147825,
  [SMALL_STATE(4363)] = 147883,
  [SMALL_STATE(4364)] = 147941,
  [SMALL_STATE(4365)] = 147999,
  [SMALL_STATE(4366)] = 148057,
  [SMALL_STATE(4367)] = 148115,
  [SMALL_STATE(4368)] = 148173,
  [SMALL_STATE(4369)] = 148231,
  [SMALL_STATE(4370)] = 148289,
  [SMALL_STATE(4371)] = 148347,
  [SMALL_STATE(4372)] = 148409,
  [SMALL_STATE(4373)] = 148467,
  [SMALL_STATE(4374)] = 148525,
  [SMALL_STATE(4375)] = 148583,
  [SMALL_STATE(4376)] = 148641,
  [SMALL_STATE(4377)] = 148699,
  [SMALL_STATE(4378)] = 148757,
  [SMALL_STATE(4379)] = 148815,
  [SMALL_STATE(4380)] = 148873,
  [SMALL_STATE(4381)] = 148931,
  [SMALL_STATE(4382)] = 148989,
  [SMALL_STATE(4383)] = 149047,
  [SMALL_STATE(4384)] = 149105,
  [SMALL_STATE(4385)] = 149163,
  [SMALL_STATE(4386)] = 149221,
  [SMALL_STATE(4387)] = 149279,
  [SMALL_STATE(4388)] = 149337,
  [SMALL_STATE(4389)] = 149395,
  [SMALL_STATE(4390)] = 149453,
  [SMALL_STATE(4391)] = 149511,
  [SMALL_STATE(4392)] = 149569,
  [SMALL_STATE(4393)] = 149627,
  [SMALL_STATE(4394)] = 149685,
  [SMALL_STATE(4395)] = 149743,
  [SMALL_STATE(4396)] = 149801,
  [SMALL_STATE(4397)] = 149859,
  [SMALL_STATE(4398)] = 149917,
  [SMALL_STATE(4399)] = 149975,
  [SMALL_STATE(4400)] = 150037,
  [SMALL_STATE(4401)] = 150095,
  [SMALL_STATE(4402)] = 150153,
  [SMALL_STATE(4403)] = 150211,
  [SMALL_STATE(4404)] = 150269,
  [SMALL_STATE(4405)] = 150327,
  [SMALL_STATE(4406)] = 150385,
  [SMALL_STATE(4407)] = 150443,
  [SMALL_STATE(4408)] = 150501,
  [SMALL_STATE(4409)] = 150559,
  [SMALL_STATE(4410)] = 150617,
  [SMALL_STATE(4411)] = 150675,
  [SMALL_STATE(4412)] = 150733,
  [SMALL_STATE(4413)] = 150791,
  [SMALL_STATE(4414)] = 150849,
  [SMALL_STATE(4415)] = 150907,
  [SMALL_STATE(4416)] = 150965,
  [SMALL_STATE(4417)] = 151023,
  [SMALL_STATE(4418)] = 151081,
  [SMALL_STATE(4419)] = 151139,
  [SMALL_STATE(4420)] = 151197,
  [SMALL_STATE(4421)] = 151255,
  [SMALL_STATE(4422)] = 151313,
  [SMALL_STATE(4423)] = 151371,
  [SMALL_STATE(4424)] = 151429,
  [SMALL_STATE(4425)] = 151487,
  [SMALL_STATE(4426)] = 151545,
  [SMALL_STATE(4427)] = 151603,
  [SMALL_STATE(4428)] = 151661,
  [SMALL_STATE(4429)] = 151719,
  [SMALL_STATE(4430)] = 151777,
  [SMALL_STATE(4431)] = 151835,
  [SMALL_STATE(4432)] = 151893,
  [SMALL_STATE(4433)] = 151951,
  [SMALL_STATE(4434)] = 152009,
  [SMALL_STATE(4435)] = 152067,
  [SMALL_STATE(4436)] = 152125,
  [SMALL_STATE(4437)] = 152183,
  [SMALL_STATE(4438)] = 152241,
  [SMALL_STATE(4439)] = 152299,
  [SMALL_STATE(4440)] = 152357,
  [SMALL_STATE(4441)] = 152415,
  [SMALL_STATE(4442)] = 152473,
  [SMALL_STATE(4443)] = 152531,
  [SMALL_STATE(4444)] = 152589,
  [SMALL_STATE(4445)] = 152647,
  [SMALL_STATE(4446)] = 152705,
  [SMALL_STATE(4447)] = 152763,
  [SMALL_STATE(4448)] = 152821,
  [SMALL_STATE(4449)] = 152879,
  [SMALL_STATE(4450)] = 152937,
  [SMALL_STATE(4451)] = 152995,
  [SMALL_STATE(4452)] = 153053,
  [SMALL_STATE(4453)] = 153111,
  [SMALL_STATE(4454)] = 153169,
  [SMALL_STATE(4455)] = 153233,
  [SMALL_STATE(4456)] = 153291,
  [SMALL_STATE(4457)] = 153349,
  [SMALL_STATE(4458)] = 153407,
  [SMALL_STATE(4459)] = 153465,
  [SMALL_STATE(4460)] = 153523,
  [SMALL_STATE(4461)] = 153581,
  [SMALL_STATE(4462)] = 153639,
  [SMALL_STATE(4463)] = 153697,
  [SMALL_STATE(4464)] = 153755,
  [SMALL_STATE(4465)] = 153813,
  [SMALL_STATE(4466)] = 153871,
  [SMALL_STATE(4467)] = 153929,
  [SMALL_STATE(4468)] = 153987,
  [SMALL_STATE(4469)] = 154045,
  [SMALL_STATE(4470)] = 154103,
  [SMALL_STATE(4471)] = 154161,
  [SMALL_STATE(4472)] = 154219,
  [SMALL_STATE(4473)] = 154277,
  [SMALL_STATE(4474)] = 154335,
  [SMALL_STATE(4475)] = 154393,
  [SMALL_STATE(4476)] = 154451,
  [SMALL_STATE(4477)] = 154509,
  [SMALL_STATE(4478)] = 154567,
  [SMALL_STATE(4479)] = 154625,
  [SMALL_STATE(4480)] = 154683,
  [SMALL_STATE(4481)] = 154741,
  [SMALL_STATE(4482)] = 154799,
  [SMALL_STATE(4483)] = 154857,
  [SMALL_STATE(4484)] = 154915,
  [SMALL_STATE(4485)] = 154973,
  [SMALL_STATE(4486)] = 155031,
  [SMALL_STATE(4487)] = 155089,
  [SMALL_STATE(4488)] = 155147,
  [SMALL_STATE(4489)] = 155205,
  [SMALL_STATE(4490)] = 155263,
  [SMALL_STATE(4491)] = 155321,
  [SMALL_STATE(4492)] = 155379,
  [SMALL_STATE(4493)] = 155437,
  [SMALL_STATE(4494)] = 155495,
  [SMALL_STATE(4495)] = 155553,
  [SMALL_STATE(4496)] = 155611,
  [SMALL_STATE(4497)] = 155669,
  [SMALL_STATE(4498)] = 155727,
  [SMALL_STATE(4499)] = 155785,
  [SMALL_STATE(4500)] = 155843,
  [SMALL_STATE(4501)] = 155901,
  [SMALL_STATE(4502)] = 155959,
  [SMALL_STATE(4503)] = 156017,
  [SMALL_STATE(4504)] = 156075,
  [SMALL_STATE(4505)] = 156133,
  [SMALL_STATE(4506)] = 156191,
  [SMALL_STATE(4507)] = 156249,
  [SMALL_STATE(4508)] = 156307,
  [SMALL_STATE(4509)] = 156365,
  [SMALL_STATE(4510)] = 156423,
  [SMALL_STATE(4511)] = 156481,
  [SMALL_STATE(4512)] = 156539,
  [SMALL_STATE(4513)] = 156597,
  [SMALL_STATE(4514)] = 156655,
  [SMALL_STATE(4515)] = 156713,
  [SMALL_STATE(4516)] = 156771,
  [SMALL_STATE(4517)] = 156829,
  [SMALL_STATE(4518)] = 156887,
  [SMALL_STATE(4519)] = 156945,
  [SMALL_STATE(4520)] = 157003,
  [SMALL_STATE(4521)] = 157061,
  [SMALL_STATE(4522)] = 157119,
  [SMALL_STATE(4523)] = 157177,
  [SMALL_STATE(4524)] = 157235,
  [SMALL_STATE(4525)] = 157293,
  [SMALL_STATE(4526)] = 157351,
  [SMALL_STATE(4527)] = 157409,
  [SMALL_STATE(4528)] = 157467,
  [SMALL_STATE(4529)] = 157525,
  [SMALL_STATE(4530)] = 157583,
  [SMALL_STATE(4531)] = 157641,
  [SMALL_STATE(4532)] = 157699,
  [SMALL_STATE(4533)] = 157757,
  [SMALL_STATE(4534)] = 157815,
  [SMALL_STATE(4535)] = 157873,
  [SMALL_STATE(4536)] = 157931,
  [SMALL_STATE(4537)] = 157989,
  [SMALL_STATE(4538)] = 158047,
  [SMALL_STATE(4539)] = 158105,
  [SMALL_STATE(4540)] = 158163,
  [SMALL_STATE(4541)] = 158221,
  [SMALL_STATE(4542)] = 158279,
  [SMALL_STATE(4543)] = 158337,
  [SMALL_STATE(4544)] = 158395,
  [SMALL_STATE(4545)] = 158453,
  [SMALL_STATE(4546)] = 158511,
  [SMALL_STATE(4547)] = 158569,
  [SMALL_STATE(4548)] = 158633,
  [SMALL_STATE(4549)] = 158691,
  [SMALL_STATE(4550)] = 158749,
  [SMALL_STATE(4551)] = 158807,
  [SMALL_STATE(4552)] = 158865,
  [SMALL_STATE(4553)] = 158923,
  [SMALL_STATE(4554)] = 158981,
  [SMALL_STATE(4555)] = 159039,
  [SMALL_STATE(4556)] = 159097,
  [SMALL_STATE(4557)] = 159155,
  [SMALL_STATE(4558)] = 159213,
  [SMALL_STATE(4559)] = 159271,
  [SMALL_STATE(4560)] = 159329,
  [SMALL_STATE(4561)] = 159387,
  [SMALL_STATE(4562)] = 159445,
  [SMALL_STATE(4563)] = 159503,
  [SMALL_STATE(4564)] = 159561,
  [SMALL_STATE(4565)] = 159619,
  [SMALL_STATE(4566)] = 159677,
  [SMALL_STATE(4567)] = 159735,
  [SMALL_STATE(4568)] = 159793,
  [SMALL_STATE(4569)] = 159851,
  [SMALL_STATE(4570)] = 159913,
  [SMALL_STATE(4571)] = 159975,
  [SMALL_STATE(4572)] = 160033,
  [SMALL_STATE(4573)] = 160091,
  [SMALL_STATE(4574)] = 160149,
  [SMALL_STATE(4575)] = 160207,
  [SMALL_STATE(4576)] = 160265,
  [SMALL_STATE(4577)] = 160323,
  [SMALL_STATE(4578)] = 160381,
  [SMALL_STATE(4579)] = 160439,
  [SMALL_STATE(4580)] = 160497,
  [SMALL_STATE(4581)] = 160555,
  [SMALL_STATE(4582)] = 160613,
  [SMALL_STATE(4583)] = 160671,
  [SMALL_STATE(4584)] = 160729,
  [SMALL_STATE(4585)] = 160787,
  [SMALL_STATE(4586)] = 160845,
  [SMALL_STATE(4587)] = 160903,
  [SMALL_STATE(4588)] = 160961,
  [SMALL_STATE(4589)] = 161019,
  [SMALL_STATE(4590)] = 161077,
  [SMALL_STATE(4591)] = 161135,
  [SMALL_STATE(4592)] = 161193,
  [SMALL_STATE(4593)] = 161251,
  [SMALL_STATE(4594)] = 161309,
  [SMALL_STATE(4595)] = 161367,
  [SMALL_STATE(4596)] = 161425,
  [SMALL_STATE(4597)] = 161483,
  [SMALL_STATE(4598)] = 161541,
  [SMALL_STATE(4599)] = 161599,
  [SMALL_STATE(4600)] = 161657,
  [SMALL_STATE(4601)] = 161715,
  [SMALL_STATE(4602)] = 161773,
  [SMALL_STATE(4603)] = 161831,
  [SMALL_STATE(4604)] = 161889,
  [SMALL_STATE(4605)] = 161947,
  [SMALL_STATE(4606)] = 162005,
  [SMALL_STATE(4607)] = 162063,
  [SMALL_STATE(4608)] = 162121,
  [SMALL_STATE(4609)] = 162179,
  [SMALL_STATE(4610)] = 162237,
  [SMALL_STATE(4611)] = 162295,
  [SMALL_STATE(4612)] = 162353,
  [SMALL_STATE(4613)] = 162411,
  [SMALL_STATE(4614)] = 162469,
  [SMALL_STATE(4615)] = 162527,
  [SMALL_STATE(4616)] = 162585,
  [SMALL_STATE(4617)] = 162643,
  [SMALL_STATE(4618)] = 162701,
  [SMALL_STATE(4619)] = 162759,
  [SMALL_STATE(4620)] = 162817,
  [SMALL_STATE(4621)] = 162875,
  [SMALL_STATE(4622)] = 162937,
  [SMALL_STATE(4623)] = 162995,
  [SMALL_STATE(4624)] = 163053,
  [SMALL_STATE(4625)] = 163111,
  [SMALL_STATE(4626)] = 163169,
  [SMALL_STATE(4627)] = 163227,
  [SMALL_STATE(4628)] = 163285,
  [SMALL_STATE(4629)] = 163343,
  [SMALL_STATE(4630)] = 163401,
  [SMALL_STATE(4631)] = 163459,
  [SMALL_STATE(4632)] = 163517,
  [SMALL_STATE(4633)] = 163575,
  [SMALL_STATE(4634)] = 163633,
  [SMALL_STATE(4635)] = 163691,
  [SMALL_STATE(4636)] = 163749,
  [SMALL_STATE(4637)] = 163807,
  [SMALL_STATE(4638)] = 163865,
  [SMALL_STATE(4639)] = 163923,
  [SMALL_STATE(4640)] = 163981,
  [SMALL_STATE(4641)] = 164039,
  [SMALL_STATE(4642)] = 164097,
  [SMALL_STATE(4643)] = 164155,
  [SMALL_STATE(4644)] = 164213,
  [SMALL_STATE(4645)] = 164271,
  [SMALL_STATE(4646)] = 164329,
  [SMALL_STATE(4647)] = 164387,
  [SMALL_STATE(4648)] = 164445,
  [SMALL_STATE(4649)] = 164503,
  [SMALL_STATE(4650)] = 164561,
  [SMALL_STATE(4651)] = 164623,
  [SMALL_STATE(4652)] = 164681,
  [SMALL_STATE(4653)] = 164739,
  [SMALL_STATE(4654)] = 164797,
  [SMALL_STATE(4655)] = 164855,
  [SMALL_STATE(4656)] = 164913,
  [SMALL_STATE(4657)] = 164971,
  [SMALL_STATE(4658)] = 165029,
  [SMALL_STATE(4659)] = 165087,
  [SMALL_STATE(4660)] = 165145,
  [SMALL_STATE(4661)] = 165203,
  [SMALL_STATE(4662)] = 165261,
  [SMALL_STATE(4663)] = 165319,
  [SMALL_STATE(4664)] = 165377,
  [SMALL_STATE(4665)] = 165435,
  [SMALL_STATE(4666)] = 165493,
  [SMALL_STATE(4667)] = 165551,
  [SMALL_STATE(4668)] = 165609,
  [SMALL_STATE(4669)] = 165667,
  [SMALL_STATE(4670)] = 165725,
  [SMALL_STATE(4671)] = 165783,
  [SMALL_STATE(4672)] = 165841,
  [SMALL_STATE(4673)] = 165899,
  [SMALL_STATE(4674)] = 165957,
  [SMALL_STATE(4675)] = 166015,
  [SMALL_STATE(4676)] = 166073,
  [SMALL_STATE(4677)] = 166131,
  [SMALL_STATE(4678)] = 166189,
  [SMALL_STATE(4679)] = 166247,
  [SMALL_STATE(4680)] = 166305,
  [SMALL_STATE(4681)] = 166363,
  [SMALL_STATE(4682)] = 166421,
  [SMALL_STATE(4683)] = 166479,
  [SMALL_STATE(4684)] = 166537,
  [SMALL_STATE(4685)] = 166595,
  [SMALL_STATE(4686)] = 166653,
  [SMALL_STATE(4687)] = 166711,
  [SMALL_STATE(4688)] = 166769,
  [SMALL_STATE(4689)] = 166827,
  [SMALL_STATE(4690)] = 166885,
  [SMALL_STATE(4691)] = 166943,
  [SMALL_STATE(4692)] = 167001,
  [SMALL_STATE(4693)] = 167059,
  [SMALL_STATE(4694)] = 167117,
  [SMALL_STATE(4695)] = 167175,
  [SMALL_STATE(4696)] = 167233,
  [SMALL_STATE(4697)] = 167291,
  [SMALL_STATE(4698)] = 167349,
  [SMALL_STATE(4699)] = 167407,
  [SMALL_STATE(4700)] = 167465,
  [SMALL_STATE(4701)] = 167523,
  [SMALL_STATE(4702)] = 167581,
  [SMALL_STATE(4703)] = 167639,
  [SMALL_STATE(4704)] = 167697,
  [SMALL_STATE(4705)] = 167755,
  [SMALL_STATE(4706)] = 167813,
  [SMALL_STATE(4707)] = 167871,
  [SMALL_STATE(4708)] = 167929,
  [SMALL_STATE(4709)] = 167987,
  [SMALL_STATE(4710)] = 168045,
  [SMALL_STATE(4711)] = 168103,
  [SMALL_STATE(4712)] = 168161,
  [SMALL_STATE(4713)] = 168219,
  [SMALL_STATE(4714)] = 168277,
  [SMALL_STATE(4715)] = 168335,
  [SMALL_STATE(4716)] = 168393,
  [SMALL_STATE(4717)] = 168451,
  [SMALL_STATE(4718)] = 168509,
  [SMALL_STATE(4719)] = 168567,
  [SMALL_STATE(4720)] = 168625,
  [SMALL_STATE(4721)] = 168683,
  [SMALL_STATE(4722)] = 168741,
  [SMALL_STATE(4723)] = 168799,
  [SMALL_STATE(4724)] = 168857,
  [SMALL_STATE(4725)] = 168915,
  [SMALL_STATE(4726)] = 168973,
  [SMALL_STATE(4727)] = 169031,
  [SMALL_STATE(4728)] = 169089,
  [SMALL_STATE(4729)] = 169147,
  [SMALL_STATE(4730)] = 169205,
  [SMALL_STATE(4731)] = 169263,
  [SMALL_STATE(4732)] = 169321,
  [SMALL_STATE(4733)] = 169379,
  [SMALL_STATE(4734)] = 169437,
  [SMALL_STATE(4735)] = 169495,
  [SMALL_STATE(4736)] = 169553,
  [SMALL_STATE(4737)] = 169611,
  [SMALL_STATE(4738)] = 169669,
  [SMALL_STATE(4739)] = 169727,
  [SMALL_STATE(4740)] = 169785,
  [SMALL_STATE(4741)] = 169843,
  [SMALL_STATE(4742)] = 169901,
  [SMALL_STATE(4743)] = 169959,
  [SMALL_STATE(4744)] = 170017,
  [SMALL_STATE(4745)] = 170075,
  [SMALL_STATE(4746)] = 170133,
  [SMALL_STATE(4747)] = 170191,
  [SMALL_STATE(4748)] = 170249,
  [SMALL_STATE(4749)] = 170307,
  [SMALL_STATE(4750)] = 170365,
  [SMALL_STATE(4751)] = 170423,
  [SMALL_STATE(4752)] = 170481,
  [SMALL_STATE(4753)] = 170539,
  [SMALL_STATE(4754)] = 170597,
  [SMALL_STATE(4755)] = 170655,
  [SMALL_STATE(4756)] = 170713,
  [SMALL_STATE(4757)] = 170771,
  [SMALL_STATE(4758)] = 170829,
  [SMALL_STATE(4759)] = 170887,
  [SMALL_STATE(4760)] = 170945,
  [SMALL_STATE(4761)] = 171003,
  [SMALL_STATE(4762)] = 171061,
  [SMALL_STATE(4763)] = 171119,
  [SMALL_STATE(4764)] = 171177,
  [SMALL_STATE(4765)] = 171235,
  [SMALL_STATE(4766)] = 171293,
  [SMALL_STATE(4767)] = 171351,
  [SMALL_STATE(4768)] = 171409,
  [SMALL_STATE(4769)] = 171467,
  [SMALL_STATE(4770)] = 171525,
  [SMALL_STATE(4771)] = 171583,
  [SMALL_STATE(4772)] = 171641,
  [SMALL_STATE(4773)] = 171699,
  [SMALL_STATE(4774)] = 171757,
  [SMALL_STATE(4775)] = 171815,
  [SMALL_STATE(4776)] = 171873,
  [SMALL_STATE(4777)] = 171931,
  [SMALL_STATE(4778)] = 171989,
  [SMALL_STATE(4779)] = 172047,
  [SMALL_STATE(4780)] = 172105,
  [SMALL_STATE(4781)] = 172163,
  [SMALL_STATE(4782)] = 172221,
  [SMALL_STATE(4783)] = 172279,
  [SMALL_STATE(4784)] = 172337,
  [SMALL_STATE(4785)] = 172395,
  [SMALL_STATE(4786)] = 172453,
  [SMALL_STATE(4787)] = 172511,
  [SMALL_STATE(4788)] = 172569,
  [SMALL_STATE(4789)] = 172627,
  [SMALL_STATE(4790)] = 172685,
  [SMALL_STATE(4791)] = 172743,
  [SMALL_STATE(4792)] = 172801,
  [SMALL_STATE(4793)] = 172859,
  [SMALL_STATE(4794)] = 172917,
  [SMALL_STATE(4795)] = 172975,
  [SMALL_STATE(4796)] = 173033,
  [SMALL_STATE(4797)] = 173091,
  [SMALL_STATE(4798)] = 173149,
  [SMALL_STATE(4799)] = 173207,
  [SMALL_STATE(4800)] = 173265,
  [SMALL_STATE(4801)] = 173323,
  [SMALL_STATE(4802)] = 173381,
  [SMALL_STATE(4803)] = 173439,
  [SMALL_STATE(4804)] = 173497,
  [SMALL_STATE(4805)] = 173555,
  [SMALL_STATE(4806)] = 173613,
  [SMALL_STATE(4807)] = 173671,
  [SMALL_STATE(4808)] = 173729,
  [SMALL_STATE(4809)] = 173787,
  [SMALL_STATE(4810)] = 173845,
  [SMALL_STATE(4811)] = 173903,
  [SMALL_STATE(4812)] = 173961,
  [SMALL_STATE(4813)] = 174019,
  [SMALL_STATE(4814)] = 174077,
  [SMALL_STATE(4815)] = 174135,
  [SMALL_STATE(4816)] = 174193,
  [SMALL_STATE(4817)] = 174251,
  [SMALL_STATE(4818)] = 174309,
  [SMALL_STATE(4819)] = 174367,
  [SMALL_STATE(4820)] = 174425,
  [SMALL_STATE(4821)] = 174483,
  [SMALL_STATE(4822)] = 174541,
  [SMALL_STATE(4823)] = 174599,
  [SMALL_STATE(4824)] = 174657,
  [SMALL_STATE(4825)] = 174715,
  [SMALL_STATE(4826)] = 174773,
  [SMALL_STATE(4827)] = 174831,
  [SMALL_STATE(4828)] = 174889,
  [SMALL_STATE(4829)] = 174947,
  [SMALL_STATE(4830)] = 175005,
  [SMALL_STATE(4831)] = 175063,
  [SMALL_STATE(4832)] = 175121,
  [SMALL_STATE(4833)] = 175179,
  [SMALL_STATE(4834)] = 175237,
  [SMALL_STATE(4835)] = 175295,
  [SMALL_STATE(4836)] = 175353,
  [SMALL_STATE(4837)] = 175411,
  [SMALL_STATE(4838)] = 175469,
  [SMALL_STATE(4839)] = 175527,
  [SMALL_STATE(4840)] = 175585,
  [SMALL_STATE(4841)] = 175643,
  [SMALL_STATE(4842)] = 175701,
  [SMALL_STATE(4843)] = 175759,
  [SMALL_STATE(4844)] = 175817,
  [SMALL_STATE(4845)] = 175875,
  [SMALL_STATE(4846)] = 175933,
  [SMALL_STATE(4847)] = 175991,
  [SMALL_STATE(4848)] = 176049,
  [SMALL_STATE(4849)] = 176107,
  [SMALL_STATE(4850)] = 176165,
  [SMALL_STATE(4851)] = 176223,
  [SMALL_STATE(4852)] = 176281,
  [SMALL_STATE(4853)] = 176339,
  [SMALL_STATE(4854)] = 176397,
  [SMALL_STATE(4855)] = 176455,
  [SMALL_STATE(4856)] = 176513,
  [SMALL_STATE(4857)] = 176571,
  [SMALL_STATE(4858)] = 176629,
  [SMALL_STATE(4859)] = 176687,
  [SMALL_STATE(4860)] = 176745,
  [SMALL_STATE(4861)] = 176803,
  [SMALL_STATE(4862)] = 176861,
  [SMALL_STATE(4863)] = 176919,
  [SMALL_STATE(4864)] = 176977,
  [SMALL_STATE(4865)] = 177034,
  [SMALL_STATE(4866)] = 177091,
  [SMALL_STATE(4867)] = 177148,
  [SMALL_STATE(4868)] = 177205,
  [SMALL_STATE(4869)] = 177266,
  [SMALL_STATE(4870)] = 177323,
  [SMALL_STATE(4871)] = 177380,
  [SMALL_STATE(4872)] = 177437,
  [SMALL_STATE(4873)] = 177494,
  [SMALL_STATE(4874)] = 177551,
  [SMALL_STATE(4875)] = 177608,
  [SMALL_STATE(4876)] = 177665,
  [SMALL_STATE(4877)] = 177722,
  [SMALL_STATE(4878)] = 177779,
  [SMALL_STATE(4879)] = 177836,
  [SMALL_STATE(4880)] = 177893,
  [SMALL_STATE(4881)] = 177950,
  [SMALL_STATE(4882)] = 178007,
  [SMALL_STATE(4883)] = 178064,
  [SMALL_STATE(4884)] = 178121,
  [SMALL_STATE(4885)] = 178178,
  [SMALL_STATE(4886)] = 178235,
  [SMALL_STATE(4887)] = 178292,
  [SMALL_STATE(4888)] = 178349,
  [SMALL_STATE(4889)] = 178406,
  [SMALL_STATE(4890)] = 178463,
  [SMALL_STATE(4891)] = 178520,
  [SMALL_STATE(4892)] = 178577,
  [SMALL_STATE(4893)] = 178634,
  [SMALL_STATE(4894)] = 178691,
  [SMALL_STATE(4895)] = 178748,
  [SMALL_STATE(4896)] = 178805,
  [SMALL_STATE(4897)] = 178862,
  [SMALL_STATE(4898)] = 178919,
  [SMALL_STATE(4899)] = 178976,
  [SMALL_STATE(4900)] = 179033,
  [SMALL_STATE(4901)] = 179090,
  [SMALL_STATE(4902)] = 179147,
  [SMALL_STATE(4903)] = 179204,
  [SMALL_STATE(4904)] = 179261,
  [SMALL_STATE(4905)] = 179318,
  [SMALL_STATE(4906)] = 179375,
  [SMALL_STATE(4907)] = 179432,
  [SMALL_STATE(4908)] = 179489,
  [SMALL_STATE(4909)] = 179546,
  [SMALL_STATE(4910)] = 179603,
  [SMALL_STATE(4911)] = 179660,
  [SMALL_STATE(4912)] = 179717,
  [SMALL_STATE(4913)] = 179774,
  [SMALL_STATE(4914)] = 179831,
  [SMALL_STATE(4915)] = 179888,
  [SMALL_STATE(4916)] = 179945,
  [SMALL_STATE(4917)] = 180002,
  [SMALL_STATE(4918)] = 180059,
  [SMALL_STATE(4919)] = 180116,
  [SMALL_STATE(4920)] = 180173,
  [SMALL_STATE(4921)] = 180230,
  [SMALL_STATE(4922)] = 180287,
  [SMALL_STATE(4923)] = 180344,
  [SMALL_STATE(4924)] = 180401,
  [SMALL_STATE(4925)] = 180458,
  [SMALL_STATE(4926)] = 180515,
  [SMALL_STATE(4927)] = 180572,
  [SMALL_STATE(4928)] = 180629,
  [SMALL_STATE(4929)] = 180686,
  [SMALL_STATE(4930)] = 180743,
  [SMALL_STATE(4931)] = 180800,
  [SMALL_STATE(4932)] = 180857,
  [SMALL_STATE(4933)] = 180914,
  [SMALL_STATE(4934)] = 180971,
  [SMALL_STATE(4935)] = 181028,
  [SMALL_STATE(4936)] = 181085,
  [SMALL_STATE(4937)] = 181142,
  [SMALL_STATE(4938)] = 181199,
  [SMALL_STATE(4939)] = 181256,
  [SMALL_STATE(4940)] = 181313,
  [SMALL_STATE(4941)] = 181370,
  [SMALL_STATE(4942)] = 181427,
  [SMALL_STATE(4943)] = 181484,
  [SMALL_STATE(4944)] = 181541,
  [SMALL_STATE(4945)] = 181598,
  [SMALL_STATE(4946)] = 181655,
  [SMALL_STATE(4947)] = 181712,
  [SMALL_STATE(4948)] = 181769,
  [SMALL_STATE(4949)] = 181826,
  [SMALL_STATE(4950)] = 181883,
  [SMALL_STATE(4951)] = 181940,
  [SMALL_STATE(4952)] = 181997,
  [SMALL_STATE(4953)] = 182054,
  [SMALL_STATE(4954)] = 182111,
  [SMALL_STATE(4955)] = 182168,
  [SMALL_STATE(4956)] = 182225,
  [SMALL_STATE(4957)] = 182282,
  [SMALL_STATE(4958)] = 182339,
  [SMALL_STATE(4959)] = 182396,
  [SMALL_STATE(4960)] = 182453,
  [SMALL_STATE(4961)] = 182510,
  [SMALL_STATE(4962)] = 182567,
  [SMALL_STATE(4963)] = 182624,
  [SMALL_STATE(4964)] = 182681,
  [SMALL_STATE(4965)] = 182738,
  [SMALL_STATE(4966)] = 182795,
  [SMALL_STATE(4967)] = 182852,
  [SMALL_STATE(4968)] = 182909,
  [SMALL_STATE(4969)] = 182966,
  [SMALL_STATE(4970)] = 183027,
  [SMALL_STATE(4971)] = 183084,
  [SMALL_STATE(4972)] = 183141,
  [SMALL_STATE(4973)] = 183198,
  [SMALL_STATE(4974)] = 183255,
  [SMALL_STATE(4975)] = 183312,
  [SMALL_STATE(4976)] = 183369,
  [SMALL_STATE(4977)] = 183426,
  [SMALL_STATE(4978)] = 183483,
  [SMALL_STATE(4979)] = 183540,
  [SMALL_STATE(4980)] = 183597,
  [SMALL_STATE(4981)] = 183654,
  [SMALL_STATE(4982)] = 183711,
  [SMALL_STATE(4983)] = 183768,
  [SMALL_STATE(4984)] = 183825,
  [SMALL_STATE(4985)] = 183882,
  [SMALL_STATE(4986)] = 183939,
  [SMALL_STATE(4987)] = 183996,
  [SMALL_STATE(4988)] = 184053,
  [SMALL_STATE(4989)] = 184110,
  [SMALL_STATE(4990)] = 184167,
  [SMALL_STATE(4991)] = 184224,
  [SMALL_STATE(4992)] = 184281,
  [SMALL_STATE(4993)] = 184338,
  [SMALL_STATE(4994)] = 184395,
  [SMALL_STATE(4995)] = 184452,
  [SMALL_STATE(4996)] = 184509,
  [SMALL_STATE(4997)] = 184566,
  [SMALL_STATE(4998)] = 184623,
  [SMALL_STATE(4999)] = 184680,
  [SMALL_STATE(5000)] = 184737,
  [SMALL_STATE(5001)] = 184794,
  [SMALL_STATE(5002)] = 184851,
  [SMALL_STATE(5003)] = 184908,
  [SMALL_STATE(5004)] = 184965,
  [SMALL_STATE(5005)] = 185022,
  [SMALL_STATE(5006)] = 185079,
  [SMALL_STATE(5007)] = 185136,
  [SMALL_STATE(5008)] = 185193,
  [SMALL_STATE(5009)] = 185250,
  [SMALL_STATE(5010)] = 185307,
  [SMALL_STATE(5011)] = 185364,
  [SMALL_STATE(5012)] = 185427,
  [SMALL_STATE(5013)] = 185490,
  [SMALL_STATE(5014)] = 185547,
  [SMALL_STATE(5015)] = 185604,
  [SMALL_STATE(5016)] = 185661,
  [SMALL_STATE(5017)] = 185718,
  [SMALL_STATE(5018)] = 185775,
  [SMALL_STATE(5019)] = 185832,
  [SMALL_STATE(5020)] = 185889,
  [SMALL_STATE(5021)] = 185946,
  [SMALL_STATE(5022)] = 186003,
  [SMALL_STATE(5023)] = 186060,
  [SMALL_STATE(5024)] = 186117,
  [SMALL_STATE(5025)] = 186174,
  [SMALL_STATE(5026)] = 186231,
  [SMALL_STATE(5027)] = 186288,
  [SMALL_STATE(5028)] = 186345,
  [SMALL_STATE(5029)] = 186402,
  [SMALL_STATE(5030)] = 186459,
  [SMALL_STATE(5031)] = 186516,
  [SMALL_STATE(5032)] = 186573,
  [SMALL_STATE(5033)] = 186630,
  [SMALL_STATE(5034)] = 186687,
  [SMALL_STATE(5035)] = 186744,
  [SMALL_STATE(5036)] = 186801,
  [SMALL_STATE(5037)] = 186858,
  [SMALL_STATE(5038)] = 186915,
  [SMALL_STATE(5039)] = 186972,
  [SMALL_STATE(5040)] = 187029,
  [SMALL_STATE(5041)] = 187086,
  [SMALL_STATE(5042)] = 187143,
  [SMALL_STATE(5043)] = 187200,
  [SMALL_STATE(5044)] = 187257,
  [SMALL_STATE(5045)] = 187314,
  [SMALL_STATE(5046)] = 187371,
  [SMALL_STATE(5047)] = 187428,
  [SMALL_STATE(5048)] = 187485,
  [SMALL_STATE(5049)] = 187542,
  [SMALL_STATE(5050)] = 187599,
  [SMALL_STATE(5051)] = 187656,
  [SMALL_STATE(5052)] = 187713,
  [SMALL_STATE(5053)] = 187770,
  [SMALL_STATE(5054)] = 187827,
  [SMALL_STATE(5055)] = 187884,
  [SMALL_STATE(5056)] = 187941,
  [SMALL_STATE(5057)] = 187998,
  [SMALL_STATE(5058)] = 188055,
  [SMALL_STATE(5059)] = 188112,
  [SMALL_STATE(5060)] = 188169,
  [SMALL_STATE(5061)] = 188226,
  [SMALL_STATE(5062)] = 188283,
  [SMALL_STATE(5063)] = 188340,
  [SMALL_STATE(5064)] = 188397,
  [SMALL_STATE(5065)] = 188454,
  [SMALL_STATE(5066)] = 188511,
  [SMALL_STATE(5067)] = 188568,
  [SMALL_STATE(5068)] = 188625,
  [SMALL_STATE(5069)] = 188682,
  [SMALL_STATE(5070)] = 188739,
  [SMALL_STATE(5071)] = 188796,
  [SMALL_STATE(5072)] = 188853,
  [SMALL_STATE(5073)] = 188910,
  [SMALL_STATE(5074)] = 188967,
  [SMALL_STATE(5075)] = 189024,
  [SMALL_STATE(5076)] = 189081,
  [SMALL_STATE(5077)] = 189138,
  [SMALL_STATE(5078)] = 189195,
  [SMALL_STATE(5079)] = 189252,
  [SMALL_STATE(5080)] = 189309,
  [SMALL_STATE(5081)] = 189366,
  [SMALL_STATE(5082)] = 189423,
  [SMALL_STATE(5083)] = 189480,
  [SMALL_STATE(5084)] = 189537,
  [SMALL_STATE(5085)] = 189594,
  [SMALL_STATE(5086)] = 189651,
  [SMALL_STATE(5087)] = 189708,
  [SMALL_STATE(5088)] = 189795,
  [SMALL_STATE(5089)] = 189852,
  [SMALL_STATE(5090)] = 189909,
  [SMALL_STATE(5091)] = 189966,
  [SMALL_STATE(5092)] = 190023,
  [SMALL_STATE(5093)] = 190080,
  [SMALL_STATE(5094)] = 190143,
  [SMALL_STATE(5095)] = 190200,
  [SMALL_STATE(5096)] = 190257,
  [SMALL_STATE(5097)] = 190314,
  [SMALL_STATE(5098)] = 190371,
  [SMALL_STATE(5099)] = 190428,
  [SMALL_STATE(5100)] = 190485,
  [SMALL_STATE(5101)] = 190542,
  [SMALL_STATE(5102)] = 190599,
  [SMALL_STATE(5103)] = 190656,
  [SMALL_STATE(5104)] = 190713,
  [SMALL_STATE(5105)] = 190769,
  [SMALL_STATE(5106)] = 190825,
  [SMALL_STATE(5107)] = 190881,
  [SMALL_STATE(5108)] = 190937,
  [SMALL_STATE(5109)] = 190993,
  [SMALL_STATE(5110)] = 191049,
  [SMALL_STATE(5111)] = 191105,
  [SMALL_STATE(5112)] = 191161,
  [SMALL_STATE(5113)] = 191217,
  [SMALL_STATE(5114)] = 191273,
  [SMALL_STATE(5115)] = 191329,
  [SMALL_STATE(5116)] = 191385,
  [SMALL_STATE(5117)] = 191441,
  [SMALL_STATE(5118)] = 191497,
  [SMALL_STATE(5119)] = 191553,
  [SMALL_STATE(5120)] = 191609,
  [SMALL_STATE(5121)] = 191665,
  [SMALL_STATE(5122)] = 191721,
  [SMALL_STATE(5123)] = 191777,
  [SMALL_STATE(5124)] = 191833,
  [SMALL_STATE(5125)] = 191889,
  [SMALL_STATE(5126)] = 191945,
  [SMALL_STATE(5127)] = 192001,
  [SMALL_STATE(5128)] = 192057,
  [SMALL_STATE(5129)] = 192119,
  [SMALL_STATE(5130)] = 192175,
  [SMALL_STATE(5131)] = 192231,
  [SMALL_STATE(5132)] = 192287,
  [SMALL_STATE(5133)] = 192343,
  [SMALL_STATE(5134)] = 192399,
  [SMALL_STATE(5135)] = 192455,
  [SMALL_STATE(5136)] = 192517,
  [SMALL_STATE(5137)] = 192573,
  [SMALL_STATE(5138)] = 192629,
  [SMALL_STATE(5139)] = 192685,
  [SMALL_STATE(5140)] = 192741,
  [SMALL_STATE(5141)] = 192797,
  [SMALL_STATE(5142)] = 192853,
  [SMALL_STATE(5143)] = 192909,
  [SMALL_STATE(5144)] = 192965,
  [SMALL_STATE(5145)] = 193021,
  [SMALL_STATE(5146)] = 193077,
  [SMALL_STATE(5147)] = 193133,
  [SMALL_STATE(5148)] = 193253,
  [SMALL_STATE(5149)] = 193309,
  [SMALL_STATE(5150)] = 193365,
  [SMALL_STATE(5151)] = 193421,
  [SMALL_STATE(5152)] = 193477,
  [SMALL_STATE(5153)] = 193533,
  [SMALL_STATE(5154)] = 193589,
  [SMALL_STATE(5155)] = 193645,
  [SMALL_STATE(5156)] = 193701,
  [SMALL_STATE(5157)] = 193757,
  [SMALL_STATE(5158)] = 193813,
  [SMALL_STATE(5159)] = 193869,
  [SMALL_STATE(5160)] = 193925,
  [SMALL_STATE(5161)] = 193981,
  [SMALL_STATE(5162)] = 194037,
  [SMALL_STATE(5163)] = 194093,
  [SMALL_STATE(5164)] = 194149,
  [SMALL_STATE(5165)] = 194205,
  [SMALL_STATE(5166)] = 194261,
  [SMALL_STATE(5167)] = 194317,
  [SMALL_STATE(5168)] = 194373,
  [SMALL_STATE(5169)] = 194429,
  [SMALL_STATE(5170)] = 194485,
  [SMALL_STATE(5171)] = 194541,
  [SMALL_STATE(5172)] = 194597,
  [SMALL_STATE(5173)] = 194653,
  [SMALL_STATE(5174)] = 194709,
  [SMALL_STATE(5175)] = 194765,
  [SMALL_STATE(5176)] = 194821,
  [SMALL_STATE(5177)] = 194877,
  [SMALL_STATE(5178)] = 194933,
  [SMALL_STATE(5179)] = 194989,
  [SMALL_STATE(5180)] = 195045,
  [SMALL_STATE(5181)] = 195101,
  [SMALL_STATE(5182)] = 195157,
  [SMALL_STATE(5183)] = 195213,
  [SMALL_STATE(5184)] = 195269,
  [SMALL_STATE(5185)] = 195325,
  [SMALL_STATE(5186)] = 195381,
  [SMALL_STATE(5187)] = 195437,
  [SMALL_STATE(5188)] = 195493,
  [SMALL_STATE(5189)] = 195549,
  [SMALL_STATE(5190)] = 195605,
  [SMALL_STATE(5191)] = 195661,
  [SMALL_STATE(5192)] = 195717,
  [SMALL_STATE(5193)] = 195773,
  [SMALL_STATE(5194)] = 195829,
  [SMALL_STATE(5195)] = 195885,
  [SMALL_STATE(5196)] = 195941,
  [SMALL_STATE(5197)] = 195997,
  [SMALL_STATE(5198)] = 196053,
  [SMALL_STATE(5199)] = 196109,
  [SMALL_STATE(5200)] = 196165,
  [SMALL_STATE(5201)] = 196221,
  [SMALL_STATE(5202)] = 196277,
  [SMALL_STATE(5203)] = 196333,
  [SMALL_STATE(5204)] = 196389,
  [SMALL_STATE(5205)] = 196445,
  [SMALL_STATE(5206)] = 196501,
  [SMALL_STATE(5207)] = 196557,
  [SMALL_STATE(5208)] = 196613,
  [SMALL_STATE(5209)] = 196669,
  [SMALL_STATE(5210)] = 196725,
  [SMALL_STATE(5211)] = 196781,
  [SMALL_STATE(5212)] = 196837,
  [SMALL_STATE(5213)] = 196893,
  [SMALL_STATE(5214)] = 196949,
  [SMALL_STATE(5215)] = 197005,
  [SMALL_STATE(5216)] = 197061,
  [SMALL_STATE(5217)] = 197117,
  [SMALL_STATE(5218)] = 197173,
  [SMALL_STATE(5219)] = 197229,
  [SMALL_STATE(5220)] = 197285,
  [SMALL_STATE(5221)] = 197341,
  [SMALL_STATE(5222)] = 197397,
  [SMALL_STATE(5223)] = 197453,
  [SMALL_STATE(5224)] = 197509,
  [SMALL_STATE(5225)] = 197565,
  [SMALL_STATE(5226)] = 197621,
  [SMALL_STATE(5227)] = 197677,
  [SMALL_STATE(5228)] = 197733,
  [SMALL_STATE(5229)] = 197789,
  [SMALL_STATE(5230)] = 197845,
  [SMALL_STATE(5231)] = 197901,
  [SMALL_STATE(5232)] = 197957,
  [SMALL_STATE(5233)] = 198013,
  [SMALL_STATE(5234)] = 198069,
  [SMALL_STATE(5235)] = 198125,
  [SMALL_STATE(5236)] = 198181,
  [SMALL_STATE(5237)] = 198237,
  [SMALL_STATE(5238)] = 198293,
  [SMALL_STATE(5239)] = 198349,
  [SMALL_STATE(5240)] = 198405,
  [SMALL_STATE(5241)] = 198461,
  [SMALL_STATE(5242)] = 198517,
  [SMALL_STATE(5243)] = 198573,
  [SMALL_STATE(5244)] = 198629,
  [SMALL_STATE(5245)] = 198685,
  [SMALL_STATE(5246)] = 198741,
  [SMALL_STATE(5247)] = 198797,
  [SMALL_STATE(5248)] = 198853,
  [SMALL_STATE(5249)] = 198909,
  [SMALL_STATE(5250)] = 198965,
  [SMALL_STATE(5251)] = 199021,
  [SMALL_STATE(5252)] = 199077,
  [SMALL_STATE(5253)] = 199133,
  [SMALL_STATE(5254)] = 199189,
  [SMALL_STATE(5255)] = 199245,
  [SMALL_STATE(5256)] = 199301,
  [SMALL_STATE(5257)] = 199357,
  [SMALL_STATE(5258)] = 199413,
  [SMALL_STATE(5259)] = 199469,
  [SMALL_STATE(5260)] = 199525,
  [SMALL_STATE(5261)] = 199581,
  [SMALL_STATE(5262)] = 199637,
  [SMALL_STATE(5263)] = 199693,
  [SMALL_STATE(5264)] = 199749,
  [SMALL_STATE(5265)] = 199805,
  [SMALL_STATE(5266)] = 199861,
  [SMALL_STATE(5267)] = 199917,
  [SMALL_STATE(5268)] = 199973,
  [SMALL_STATE(5269)] = 200029,
  [SMALL_STATE(5270)] = 200085,
  [SMALL_STATE(5271)] = 200141,
  [SMALL_STATE(5272)] = 200197,
  [SMALL_STATE(5273)] = 200253,
  [SMALL_STATE(5274)] = 200309,
  [SMALL_STATE(5275)] = 200365,
  [SMALL_STATE(5276)] = 200421,
  [SMALL_STATE(5277)] = 200477,
  [SMALL_STATE(5278)] = 200533,
  [SMALL_STATE(5279)] = 200589,
  [SMALL_STATE(5280)] = 200645,
  [SMALL_STATE(5281)] = 200701,
  [SMALL_STATE(5282)] = 200757,
  [SMALL_STATE(5283)] = 200813,
  [SMALL_STATE(5284)] = 200869,
  [SMALL_STATE(5285)] = 200925,
  [SMALL_STATE(5286)] = 200981,
  [SMALL_STATE(5287)] = 201037,
  [SMALL_STATE(5288)] = 201093,
  [SMALL_STATE(5289)] = 201149,
  [SMALL_STATE(5290)] = 201205,
  [SMALL_STATE(5291)] = 201261,
  [SMALL_STATE(5292)] = 201317,
  [SMALL_STATE(5293)] = 201373,
  [SMALL_STATE(5294)] = 201429,
  [SMALL_STATE(5295)] = 201485,
  [SMALL_STATE(5296)] = 201541,
  [SMALL_STATE(5297)] = 201597,
  [SMALL_STATE(5298)] = 201653,
  [SMALL_STATE(5299)] = 201709,
  [SMALL_STATE(5300)] = 201765,
  [SMALL_STATE(5301)] = 201821,
  [SMALL_STATE(5302)] = 201877,
  [SMALL_STATE(5303)] = 201933,
  [SMALL_STATE(5304)] = 201989,
  [SMALL_STATE(5305)] = 202045,
  [SMALL_STATE(5306)] = 202101,
  [SMALL_STATE(5307)] = 202157,
  [SMALL_STATE(5308)] = 202213,
  [SMALL_STATE(5309)] = 202269,
  [SMALL_STATE(5310)] = 202325,
  [SMALL_STATE(5311)] = 202381,
  [SMALL_STATE(5312)] = 202437,
  [SMALL_STATE(5313)] = 202493,
  [SMALL_STATE(5314)] = 202549,
  [SMALL_STATE(5315)] = 202605,
  [SMALL_STATE(5316)] = 202661,
  [SMALL_STATE(5317)] = 202717,
  [SMALL_STATE(5318)] = 202773,
  [SMALL_STATE(5319)] = 202829,
  [SMALL_STATE(5320)] = 202885,
  [SMALL_STATE(5321)] = 202941,
  [SMALL_STATE(5322)] = 202997,
  [SMALL_STATE(5323)] = 203053,
  [SMALL_STATE(5324)] = 203109,
  [SMALL_STATE(5325)] = 203165,
  [SMALL_STATE(5326)] = 203221,
  [SMALL_STATE(5327)] = 203277,
  [SMALL_STATE(5328)] = 203333,
  [SMALL_STATE(5329)] = 203389,
  [SMALL_STATE(5330)] = 203445,
  [SMALL_STATE(5331)] = 203501,
  [SMALL_STATE(5332)] = 203557,
  [SMALL_STATE(5333)] = 203613,
  [SMALL_STATE(5334)] = 203669,
  [SMALL_STATE(5335)] = 203725,
  [SMALL_STATE(5336)] = 203781,
  [SMALL_STATE(5337)] = 203837,
  [SMALL_STATE(5338)] = 203893,
  [SMALL_STATE(5339)] = 203949,
  [SMALL_STATE(5340)] = 204005,
  [SMALL_STATE(5341)] = 204061,
  [SMALL_STATE(5342)] = 204117,
  [SMALL_STATE(5343)] = 204173,
  [SMALL_STATE(5344)] = 204229,
  [SMALL_STATE(5345)] = 204285,
  [SMALL_STATE(5346)] = 204341,
  [SMALL_STATE(5347)] = 204397,
  [SMALL_STATE(5348)] = 204453,
  [SMALL_STATE(5349)] = 204509,
  [SMALL_STATE(5350)] = 204565,
  [SMALL_STATE(5351)] = 204621,
  [SMALL_STATE(5352)] = 204677,
  [SMALL_STATE(5353)] = 204733,
  [SMALL_STATE(5354)] = 204789,
  [SMALL_STATE(5355)] = 204845,
  [SMALL_STATE(5356)] = 204901,
  [SMALL_STATE(5357)] = 204957,
  [SMALL_STATE(5358)] = 205019,
  [SMALL_STATE(5359)] = 205075,
  [SMALL_STATE(5360)] = 205131,
  [SMALL_STATE(5361)] = 205187,
  [SMALL_STATE(5362)] = 205243,
  [SMALL_STATE(5363)] = 205299,
  [SMALL_STATE(5364)] = 205355,
  [SMALL_STATE(5365)] = 205411,
  [SMALL_STATE(5366)] = 205467,
  [SMALL_STATE(5367)] = 205523,
  [SMALL_STATE(5368)] = 205579,
  [SMALL_STATE(5369)] = 205635,
  [SMALL_STATE(5370)] = 205691,
  [SMALL_STATE(5371)] = 205747,
  [SMALL_STATE(5372)] = 205803,
  [SMALL_STATE(5373)] = 205859,
  [SMALL_STATE(5374)] = 205915,
  [SMALL_STATE(5375)] = 205971,
  [SMALL_STATE(5376)] = 206027,
  [SMALL_STATE(5377)] = 206083,
  [SMALL_STATE(5378)] = 206139,
  [SMALL_STATE(5379)] = 206195,
  [SMALL_STATE(5380)] = 206251,
  [SMALL_STATE(5381)] = 206307,
  [SMALL_STATE(5382)] = 206363,
  [SMALL_STATE(5383)] = 206419,
  [SMALL_STATE(5384)] = 206475,
  [SMALL_STATE(5385)] = 206531,
  [SMALL_STATE(5386)] = 206587,
  [SMALL_STATE(5387)] = 206643,
  [SMALL_STATE(5388)] = 206699,
  [SMALL_STATE(5389)] = 206755,
  [SMALL_STATE(5390)] = 206811,
  [SMALL_STATE(5391)] = 206867,
  [SMALL_STATE(5392)] = 206923,
  [SMALL_STATE(5393)] = 206979,
  [SMALL_STATE(5394)] = 207035,
  [SMALL_STATE(5395)] = 207091,
  [SMALL_STATE(5396)] = 207211,
  [SMALL_STATE(5397)] = 207267,
  [SMALL_STATE(5398)] = 207323,
  [SMALL_STATE(5399)] = 207379,
  [SMALL_STATE(5400)] = 207435,
  [SMALL_STATE(5401)] = 207491,
  [SMALL_STATE(5402)] = 207547,
  [SMALL_STATE(5403)] = 207603,
  [SMALL_STATE(5404)] = 207659,
  [SMALL_STATE(5405)] = 207715,
  [SMALL_STATE(5406)] = 207835,
  [SMALL_STATE(5407)] = 207891,
  [SMALL_STATE(5408)] = 207947,
  [SMALL_STATE(5409)] = 208003,
  [SMALL_STATE(5410)] = 208059,
  [SMALL_STATE(5411)] = 208115,
  [SMALL_STATE(5412)] = 208171,
  [SMALL_STATE(5413)] = 208227,
  [SMALL_STATE(5414)] = 208283,
  [SMALL_STATE(5415)] = 208339,
  [SMALL_STATE(5416)] = 208395,
  [SMALL_STATE(5417)] = 208451,
  [SMALL_STATE(5418)] = 208507,
  [SMALL_STATE(5419)] = 208627,
  [SMALL_STATE(5420)] = 208683,
  [SMALL_STATE(5421)] = 208745,
  [SMALL_STATE(5422)] = 208801,
  [SMALL_STATE(5423)] = 208857,
  [SMALL_STATE(5424)] = 208913,
  [SMALL_STATE(5425)] = 208969,
  [SMALL_STATE(5426)] = 209025,
  [SMALL_STATE(5427)] = 209145,
  [SMALL_STATE(5428)] = 209201,
  [SMALL_STATE(5429)] = 209257,
  [SMALL_STATE(5430)] = 209313,
  [SMALL_STATE(5431)] = 209369,
  [SMALL_STATE(5432)] = 209425,
  [SMALL_STATE(5433)] = 209481,
  [SMALL_STATE(5434)] = 209537,
  [SMALL_STATE(5435)] = 209593,
  [SMALL_STATE(5436)] = 209649,
  [SMALL_STATE(5437)] = 209705,
  [SMALL_STATE(5438)] = 209761,
  [SMALL_STATE(5439)] = 209817,
  [SMALL_STATE(5440)] = 209873,
  [SMALL_STATE(5441)] = 209929,
  [SMALL_STATE(5442)] = 209991,
  [SMALL_STATE(5443)] = 210047,
  [SMALL_STATE(5444)] = 210103,
  [SMALL_STATE(5445)] = 210159,
  [SMALL_STATE(5446)] = 210215,
  [SMALL_STATE(5447)] = 210277,
  [SMALL_STATE(5448)] = 210333,
  [SMALL_STATE(5449)] = 210389,
  [SMALL_STATE(5450)] = 210451,
  [SMALL_STATE(5451)] = 210507,
  [SMALL_STATE(5452)] = 210563,
  [SMALL_STATE(5453)] = 210619,
  [SMALL_STATE(5454)] = 210675,
  [SMALL_STATE(5455)] = 210731,
  [SMALL_STATE(5456)] = 210787,
  [SMALL_STATE(5457)] = 210843,
  [SMALL_STATE(5458)] = 210899,
  [SMALL_STATE(5459)] = 210955,
  [SMALL_STATE(5460)] = 211011,
  [SMALL_STATE(5461)] = 211067,
  [SMALL_STATE(5462)] = 211123,
  [SMALL_STATE(5463)] = 211179,
  [SMALL_STATE(5464)] = 211235,
  [SMALL_STATE(5465)] = 211291,
  [SMALL_STATE(5466)] = 211347,
  [SMALL_STATE(5467)] = 211403,
  [SMALL_STATE(5468)] = 211465,
  [SMALL_STATE(5469)] = 211521,
  [SMALL_STATE(5470)] = 211577,
  [SMALL_STATE(5471)] = 211633,
  [SMALL_STATE(5472)] = 211689,
  [SMALL_STATE(5473)] = 211745,
  [SMALL_STATE(5474)] = 211801,
  [SMALL_STATE(5475)] = 211857,
  [SMALL_STATE(5476)] = 211913,
  [SMALL_STATE(5477)] = 211969,
  [SMALL_STATE(5478)] = 212025,
  [SMALL_STATE(5479)] = 212081,
  [SMALL_STATE(5480)] = 212137,
  [SMALL_STATE(5481)] = 212193,
  [SMALL_STATE(5482)] = 212249,
  [SMALL_STATE(5483)] = 212305,
  [SMALL_STATE(5484)] = 212361,
  [SMALL_STATE(5485)] = 212417,
  [SMALL_STATE(5486)] = 212473,
  [SMALL_STATE(5487)] = 212529,
  [SMALL_STATE(5488)] = 212585,
  [SMALL_STATE(5489)] = 212641,
  [SMALL_STATE(5490)] = 212697,
  [SMALL_STATE(5491)] = 212753,
  [SMALL_STATE(5492)] = 212809,
  [SMALL_STATE(5493)] = 212865,
  [SMALL_STATE(5494)] = 212921,
  [SMALL_STATE(5495)] = 212977,
  [SMALL_STATE(5496)] = 213033,
  [SMALL_STATE(5497)] = 213095,
  [SMALL_STATE(5498)] = 213151,
  [SMALL_STATE(5499)] = 213207,
  [SMALL_STATE(5500)] = 213263,
  [SMALL_STATE(5501)] = 213383,
  [SMALL_STATE(5502)] = 213439,
  [SMALL_STATE(5503)] = 213495,
  [SMALL_STATE(5504)] = 213551,
  [SMALL_STATE(5505)] = 213607,
  [SMALL_STATE(5506)] = 213663,
  [SMALL_STATE(5507)] = 213719,
  [SMALL_STATE(5508)] = 213775,
  [SMALL_STATE(5509)] = 213831,
  [SMALL_STATE(5510)] = 213887,
  [SMALL_STATE(5511)] = 213943,
  [SMALL_STATE(5512)] = 213999,
  [SMALL_STATE(5513)] = 214055,
  [SMALL_STATE(5514)] = 214117,
  [SMALL_STATE(5515)] = 214173,
  [SMALL_STATE(5516)] = 214229,
  [SMALL_STATE(5517)] = 214284,
  [SMALL_STATE(5518)] = 214345,
  [SMALL_STATE(5519)] = 214400,
  [SMALL_STATE(5520)] = 214455,
  [SMALL_STATE(5521)] = 214510,
  [SMALL_STATE(5522)] = 214565,
  [SMALL_STATE(5523)] = 214620,
  [SMALL_STATE(5524)] = 214675,
  [SMALL_STATE(5525)] = 214730,
  [SMALL_STATE(5526)] = 214785,
  [SMALL_STATE(5527)] = 214840,
  [SMALL_STATE(5528)] = 214895,
  [SMALL_STATE(5529)] = 214950,
  [SMALL_STATE(5530)] = 215005,
  [SMALL_STATE(5531)] = 215060,
  [SMALL_STATE(5532)] = 215115,
  [SMALL_STATE(5533)] = 215170,
  [SMALL_STATE(5534)] = 215225,
  [SMALL_STATE(5535)] = 215280,
  [SMALL_STATE(5536)] = 215335,
  [SMALL_STATE(5537)] = 215390,
  [SMALL_STATE(5538)] = 215445,
  [SMALL_STATE(5539)] = 215500,
  [SMALL_STATE(5540)] = 215555,
  [SMALL_STATE(5541)] = 215610,
  [SMALL_STATE(5542)] = 215671,
  [SMALL_STATE(5543)] = 215726,
  [SMALL_STATE(5544)] = 215781,
  [SMALL_STATE(5545)] = 215836,
  [SMALL_STATE(5546)] = 215891,
  [SMALL_STATE(5547)] = 215946,
  [SMALL_STATE(5548)] = 216001,
  [SMALL_STATE(5549)] = 216056,
  [SMALL_STATE(5550)] = 216111,
  [SMALL_STATE(5551)] = 216172,
  [SMALL_STATE(5552)] = 216227,
  [SMALL_STATE(5553)] = 216288,
  [SMALL_STATE(5554)] = 216343,
  [SMALL_STATE(5555)] = 216398,
  [SMALL_STATE(5556)] = 216453,
  [SMALL_STATE(5557)] = 216508,
  [SMALL_STATE(5558)] = 216563,
  [SMALL_STATE(5559)] = 216624,
  [SMALL_STATE(5560)] = 216679,
  [SMALL_STATE(5561)] = 216734,
  [SMALL_STATE(5562)] = 216789,
  [SMALL_STATE(5563)] = 216844,
  [SMALL_STATE(5564)] = 216899,
  [SMALL_STATE(5565)] = 216954,
  [SMALL_STATE(5566)] = 217009,
  [SMALL_STATE(5567)] = 217064,
  [SMALL_STATE(5568)] = 217119,
  [SMALL_STATE(5569)] = 217174,
  [SMALL_STATE(5570)] = 217229,
  [SMALL_STATE(5571)] = 217284,
  [SMALL_STATE(5572)] = 217339,
  [SMALL_STATE(5573)] = 217394,
  [SMALL_STATE(5574)] = 217449,
  [SMALL_STATE(5575)] = 217510,
  [SMALL_STATE(5576)] = 217571,
  [SMALL_STATE(5577)] = 217626,
  [SMALL_STATE(5578)] = 217681,
  [SMALL_STATE(5579)] = 217736,
  [SMALL_STATE(5580)] = 217791,
  [SMALL_STATE(5581)] = 217846,
  [SMALL_STATE(5582)] = 217901,
  [SMALL_STATE(5583)] = 217956,
  [SMALL_STATE(5584)] = 218011,
  [SMALL_STATE(5585)] = 218066,
  [SMALL_STATE(5586)] = 218127,
  [SMALL_STATE(5587)] = 218182,
  [SMALL_STATE(5588)] = 218237,
  [SMALL_STATE(5589)] = 218292,
  [SMALL_STATE(5590)] = 218353,
  [SMALL_STATE(5591)] = 218414,
  [SMALL_STATE(5592)] = 218469,
  [SMALL_STATE(5593)] = 218530,
  [SMALL_STATE(5594)] = 218585,
  [SMALL_STATE(5595)] = 218646,
  [SMALL_STATE(5596)] = 218701,
  [SMALL_STATE(5597)] = 218756,
  [SMALL_STATE(5598)] = 218811,
  [SMALL_STATE(5599)] = 218872,
  [SMALL_STATE(5600)] = 218927,
  [SMALL_STATE(5601)] = 218982,
  [SMALL_STATE(5602)] = 219037,
  [SMALL_STATE(5603)] = 219098,
  [SMALL_STATE(5604)] = 219153,
  [SMALL_STATE(5605)] = 219208,
  [SMALL_STATE(5606)] = 219263,
  [SMALL_STATE(5607)] = 219318,
  [SMALL_STATE(5608)] = 219373,
  [SMALL_STATE(5609)] = 219428,
  [SMALL_STATE(5610)] = 219483,
  [SMALL_STATE(5611)] = 219538,
  [SMALL_STATE(5612)] = 219593,
  [SMALL_STATE(5613)] = 219648,
  [SMALL_STATE(5614)] = 219703,
  [SMALL_STATE(5615)] = 219758,
  [SMALL_STATE(5616)] = 219813,
  [SMALL_STATE(5617)] = 219868,
  [SMALL_STATE(5618)] = 219923,
  [SMALL_STATE(5619)] = 219984,
  [SMALL_STATE(5620)] = 220039,
  [SMALL_STATE(5621)] = 220094,
  [SMALL_STATE(5622)] = 220149,
  [SMALL_STATE(5623)] = 220210,
  [SMALL_STATE(5624)] = 220265,
  [SMALL_STATE(5625)] = 220320,
  [SMALL_STATE(5626)] = 220375,
  [SMALL_STATE(5627)] = 220436,
  [SMALL_STATE(5628)] = 220497,
  [SMALL_STATE(5629)] = 220552,
  [SMALL_STATE(5630)] = 220607,
  [SMALL_STATE(5631)] = 220662,
  [SMALL_STATE(5632)] = 220717,
  [SMALL_STATE(5633)] = 220778,
  [SMALL_STATE(5634)] = 220839,
  [SMALL_STATE(5635)] = 220900,
  [SMALL_STATE(5636)] = 220961,
  [SMALL_STATE(5637)] = 221016,
  [SMALL_STATE(5638)] = 221071,
  [SMALL_STATE(5639)] = 221132,
  [SMALL_STATE(5640)] = 221187,
  [SMALL_STATE(5641)] = 221242,
  [SMALL_STATE(5642)] = 221297,
  [SMALL_STATE(5643)] = 221352,
  [SMALL_STATE(5644)] = 221407,
  [SMALL_STATE(5645)] = 221462,
  [SMALL_STATE(5646)] = 221523,
  [SMALL_STATE(5647)] = 221578,
  [SMALL_STATE(5648)] = 221633,
  [SMALL_STATE(5649)] = 221688,
  [SMALL_STATE(5650)] = 221743,
  [SMALL_STATE(5651)] = 221798,
  [SMALL_STATE(5652)] = 221853,
  [SMALL_STATE(5653)] = 221908,
  [SMALL_STATE(5654)] = 221969,
  [SMALL_STATE(5655)] = 222024,
  [SMALL_STATE(5656)] = 222079,
  [SMALL_STATE(5657)] = 222134,
  [SMALL_STATE(5658)] = 222189,
  [SMALL_STATE(5659)] = 222244,
  [SMALL_STATE(5660)] = 222299,
  [SMALL_STATE(5661)] = 222354,
  [SMALL_STATE(5662)] = 222409,
  [SMALL_STATE(5663)] = 222464,
  [SMALL_STATE(5664)] = 222519,
  [SMALL_STATE(5665)] = 222574,
  [SMALL_STATE(5666)] = 222635,
  [SMALL_STATE(5667)] = 222696,
  [SMALL_STATE(5668)] = 222751,
  [SMALL_STATE(5669)] = 222806,
  [SMALL_STATE(5670)] = 222861,
  [SMALL_STATE(5671)] = 222916,
  [SMALL_STATE(5672)] = 222971,
  [SMALL_STATE(5673)] = 223026,
  [SMALL_STATE(5674)] = 223081,
  [SMALL_STATE(5675)] = 223136,
  [SMALL_STATE(5676)] = 223216,
  [SMALL_STATE(5677)] = 223276,
  [SMALL_STATE(5678)] = 223356,
  [SMALL_STATE(5679)] = 223416,
  [SMALL_STATE(5680)] = 223474,
  [SMALL_STATE(5681)] = 223554,
  [SMALL_STATE(5682)] = 223634,
  [SMALL_STATE(5683)] = 223694,
  [SMALL_STATE(5684)] = 223754,
  [SMALL_STATE(5685)] = 223814,
  [SMALL_STATE(5686)] = 223874,
  [SMALL_STATE(5687)] = 223934,
  [SMALL_STATE(5688)] = 223994,
  [SMALL_STATE(5689)] = 224054,
  [SMALL_STATE(5690)] = 224114,
  [SMALL_STATE(5691)] = 224174,
  [SMALL_STATE(5692)] = 224234,
  [SMALL_STATE(5693)] = 224294,
  [SMALL_STATE(5694)] = 224354,
  [SMALL_STATE(5695)] = 224414,
  [SMALL_STATE(5696)] = 224474,
  [SMALL_STATE(5697)] = 224534,
  [SMALL_STATE(5698)] = 224594,
  [SMALL_STATE(5699)] = 224647,
  [SMALL_STATE(5700)] = 224706,
  [SMALL_STATE(5701)] = 224759,
  [SMALL_STATE(5702)] = 224818,
  [SMALL_STATE(5703)] = 224877,
  [SMALL_STATE(5704)] = 224936,
  [SMALL_STATE(5705)] = 224995,
  [SMALL_STATE(5706)] = 225048,
  [SMALL_STATE(5707)] = 225107,
  [SMALL_STATE(5708)] = 225166,
  [SMALL_STATE(5709)] = 225219,
  [SMALL_STATE(5710)] = 225272,
  [SMALL_STATE(5711)] = 225325,
  [SMALL_STATE(5712)] = 225378,
  [SMALL_STATE(5713)] = 225431,
  [SMALL_STATE(5714)] = 225490,
  [SMALL_STATE(5715)] = 225543,
  [SMALL_STATE(5716)] = 225596,
  [SMALL_STATE(5717)] = 225655,
  [SMALL_STATE(5718)] = 225708,
  [SMALL_STATE(5719)] = 225761,
  [SMALL_STATE(5720)] = 225814,
  [SMALL_STATE(5721)] = 225867,
  [SMALL_STATE(5722)] = 225920,
  [SMALL_STATE(5723)] = 225973,
  [SMALL_STATE(5724)] = 226032,
  [SMALL_STATE(5725)] = 226091,
  [SMALL_STATE(5726)] = 226144,
  [SMALL_STATE(5727)] = 226197,
  [SMALL_STATE(5728)] = 226250,
  [SMALL_STATE(5729)] = 226303,
  [SMALL_STATE(5730)] = 226362,
  [SMALL_STATE(5731)] = 226415,
  [SMALL_STATE(5732)] = 226474,
  [SMALL_STATE(5733)] = 226533,
  [SMALL_STATE(5734)] = 226592,
  [SMALL_STATE(5735)] = 226645,
  [SMALL_STATE(5736)] = 226704,
  [SMALL_STATE(5737)] = 226763,
  [SMALL_STATE(5738)] = 226816,
  [SMALL_STATE(5739)] = 226875,
  [SMALL_STATE(5740)] = 226934,
  [SMALL_STATE(5741)] = 226993,
  [SMALL_STATE(5742)] = 227046,
  [SMALL_STATE(5743)] = 227099,
  [SMALL_STATE(5744)] = 227152,
  [SMALL_STATE(5745)] = 227205,
  [SMALL_STATE(5746)] = 227264,
  [SMALL_STATE(5747)] = 227317,
  [SMALL_STATE(5748)] = 227376,
  [SMALL_STATE(5749)] = 227435,
  [SMALL_STATE(5750)] = 227494,
  [SMALL_STATE(5751)] = 227547,
  [SMALL_STATE(5752)] = 227600,
  [SMALL_STATE(5753)] = 227659,
  [SMALL_STATE(5754)] = 227712,
  [SMALL_STATE(5755)] = 227771,
  [SMALL_STATE(5756)] = 227824,
  [SMALL_STATE(5757)] = 227883,
  [SMALL_STATE(5758)] = 227942,
  [SMALL_STATE(5759)] = 228001,
  [SMALL_STATE(5760)] = 228060,
  [SMALL_STATE(5761)] = 228119,
  [SMALL_STATE(5762)] = 228178,
  [SMALL_STATE(5763)] = 228237,
  [SMALL_STATE(5764)] = 228296,
  [SMALL_STATE(5765)] = 228355,
  [SMALL_STATE(5766)] = 228408,
  [SMALL_STATE(5767)] = 228461,
  [SMALL_STATE(5768)] = 228514,
  [SMALL_STATE(5769)] = 228567,
  [SMALL_STATE(5770)] = 228620,
  [SMALL_STATE(5771)] = 228673,
  [SMALL_STATE(5772)] = 228732,
  [SMALL_STATE(5773)] = 228785,
  [SMALL_STATE(5774)] = 228844,
  [SMALL_STATE(5775)] = 228897,
  [SMALL_STATE(5776)] = 228956,
  [SMALL_STATE(5777)] = 229009,
  [SMALL_STATE(5778)] = 229062,
  [SMALL_STATE(5779)] = 229121,
  [SMALL_STATE(5780)] = 229180,
  [SMALL_STATE(5781)] = 229233,
  [SMALL_STATE(5782)] = 229286,
  [SMALL_STATE(5783)] = 229345,
  [SMALL_STATE(5784)] = 229404,
  [SMALL_STATE(5785)] = 229457,
  [SMALL_STATE(5786)] = 229510,
  [SMALL_STATE(5787)] = 229563,
  [SMALL_STATE(5788)] = 229622,
  [SMALL_STATE(5789)] = 229675,
  [SMALL_STATE(5790)] = 229728,
  [SMALL_STATE(5791)] = 229781,
  [SMALL_STATE(5792)] = 229834,
  [SMALL_STATE(5793)] = 229887,
  [SMALL_STATE(5794)] = 229940,
  [SMALL_STATE(5795)] = 229999,
  [SMALL_STATE(5796)] = 230052,
  [SMALL_STATE(5797)] = 230111,
  [SMALL_STATE(5798)] = 230170,
  [SMALL_STATE(5799)] = 230223,
  [SMALL_STATE(5800)] = 230276,
  [SMALL_STATE(5801)] = 230329,
  [SMALL_STATE(5802)] = 230388,
  [SMALL_STATE(5803)] = 230441,
  [SMALL_STATE(5804)] = 230500,
  [SMALL_STATE(5805)] = 230559,
  [SMALL_STATE(5806)] = 230618,
  [SMALL_STATE(5807)] = 230677,
  [SMALL_STATE(5808)] = 230736,
  [SMALL_STATE(5809)] = 230789,
  [SMALL_STATE(5810)] = 230842,
  [SMALL_STATE(5811)] = 230901,
  [SMALL_STATE(5812)] = 230960,
  [SMALL_STATE(5813)] = 231012,
  [SMALL_STATE(5814)] = 231064,
  [SMALL_STATE(5815)] = 231116,
  [SMALL_STATE(5816)] = 231168,
  [SMALL_STATE(5817)] = 231220,
  [SMALL_STATE(5818)] = 231278,
  [SMALL_STATE(5819)] = 231330,
  [SMALL_STATE(5820)] = 231382,
  [SMALL_STATE(5821)] = 231434,
  [SMALL_STATE(5822)] = 231486,
  [SMALL_STATE(5823)] = 231538,
  [SMALL_STATE(5824)] = 231590,
  [SMALL_STATE(5825)] = 231648,
  [SMALL_STATE(5826)] = 231700,
  [SMALL_STATE(5827)] = 231752,
  [SMALL_STATE(5828)] = 231804,
  [SMALL_STATE(5829)] = 231862,
  [SMALL_STATE(5830)] = 231914,
  [SMALL_STATE(5831)] = 231966,
  [SMALL_STATE(5832)] = 232018,
  [SMALL_STATE(5833)] = 232070,
  [SMALL_STATE(5834)] = 232122,
  [SMALL_STATE(5835)] = 232174,
  [SMALL_STATE(5836)] = 232230,
  [SMALL_STATE(5837)] = 232282,
  [SMALL_STATE(5838)] = 232338,
  [SMALL_STATE(5839)] = 232390,
  [SMALL_STATE(5840)] = 232442,
  [SMALL_STATE(5841)] = 232494,
  [SMALL_STATE(5842)] = 232546,
  [SMALL_STATE(5843)] = 232598,
  [SMALL_STATE(5844)] = 232650,
  [SMALL_STATE(5845)] = 232702,
  [SMALL_STATE(5846)] = 232754,
  [SMALL_STATE(5847)] = 232812,
  [SMALL_STATE(5848)] = 232864,
  [SMALL_STATE(5849)] = 232916,
  [SMALL_STATE(5850)] = 232972,
  [SMALL_STATE(5851)] = 233024,
  [SMALL_STATE(5852)] = 233076,
  [SMALL_STATE(5853)] = 233128,
  [SMALL_STATE(5854)] = 233180,
  [SMALL_STATE(5855)] = 233232,
  [SMALL_STATE(5856)] = 233290,
  [SMALL_STATE(5857)] = 233342,
  [SMALL_STATE(5858)] = 233400,
  [SMALL_STATE(5859)] = 233452,
  [SMALL_STATE(5860)] = 233504,
  [SMALL_STATE(5861)] = 233556,
  [SMALL_STATE(5862)] = 233608,
  [SMALL_STATE(5863)] = 233660,
  [SMALL_STATE(5864)] = 233718,
  [SMALL_STATE(5865)] = 233770,
  [SMALL_STATE(5866)] = 233822,
  [SMALL_STATE(5867)] = 233874,
  [SMALL_STATE(5868)] = 233932,
  [SMALL_STATE(5869)] = 233990,
  [SMALL_STATE(5870)] = 234042,
  [SMALL_STATE(5871)] = 234094,
  [SMALL_STATE(5872)] = 234146,
  [SMALL_STATE(5873)] = 234198,
  [SMALL_STATE(5874)] = 234256,
  [SMALL_STATE(5875)] = 234308,
  [SMALL_STATE(5876)] = 234360,
  [SMALL_STATE(5877)] = 234411,
  [SMALL_STATE(5878)] = 234462,
  [SMALL_STATE(5879)] = 234519,
  [SMALL_STATE(5880)] = 234576,
  [SMALL_STATE(5881)] = 234627,
  [SMALL_STATE(5882)] = 234684,
  [SMALL_STATE(5883)] = 234741,
  [SMALL_STATE(5884)] = 234798,
  [SMALL_STATE(5885)] = 234849,
  [SMALL_STATE(5886)] = 234900,
  [SMALL_STATE(5887)] = 234951,
  [SMALL_STATE(5888)] = 235002,
  [SMALL_STATE(5889)] = 235053,
  [SMALL_STATE(5890)] = 235104,
  [SMALL_STATE(5891)] = 235155,
  [SMALL_STATE(5892)] = 235206,
  [SMALL_STATE(5893)] = 235257,
  [SMALL_STATE(5894)] = 235314,
  [SMALL_STATE(5895)] = 235365,
  [SMALL_STATE(5896)] = 235416,
  [SMALL_STATE(5897)] = 235467,
  [SMALL_STATE(5898)] = 235524,
  [SMALL_STATE(5899)] = 235581,
  [SMALL_STATE(5900)] = 235632,
  [SMALL_STATE(5901)] = 235683,
  [SMALL_STATE(5902)] = 235734,
  [SMALL_STATE(5903)] = 235785,
  [SMALL_STATE(5904)] = 235840,
  [SMALL_STATE(5905)] = 235891,
  [SMALL_STATE(5906)] = 235942,
  [SMALL_STATE(5907)] = 235993,
  [SMALL_STATE(5908)] = 236044,
  [SMALL_STATE(5909)] = 236095,
  [SMALL_STATE(5910)] = 236152,
  [SMALL_STATE(5911)] = 236203,
  [SMALL_STATE(5912)] = 236254,
  [SMALL_STATE(5913)] = 236305,
  [SMALL_STATE(5914)] = 236356,
  [SMALL_STATE(5915)] = 236407,
  [SMALL_STATE(5916)] = 236464,
  [SMALL_STATE(5917)] = 236515,
  [SMALL_STATE(5918)] = 236566,
  [SMALL_STATE(5919)] = 236617,
  [SMALL_STATE(5920)] = 236668,
  [SMALL_STATE(5921)] = 236719,
  [SMALL_STATE(5922)] = 236770,
  [SMALL_STATE(5923)] = 236821,
  [SMALL_STATE(5924)] = 236872,
  [SMALL_STATE(5925)] = 236923,
  [SMALL_STATE(5926)] = 236974,
  [SMALL_STATE(5927)] = 237025,
  [SMALL_STATE(5928)] = 237076,
  [SMALL_STATE(5929)] = 237127,
  [SMALL_STATE(5930)] = 237178,
  [SMALL_STATE(5931)] = 237229,
  [SMALL_STATE(5932)] = 237280,
  [SMALL_STATE(5933)] = 237331,
  [SMALL_STATE(5934)] = 237382,
  [SMALL_STATE(5935)] = 237439,
  [SMALL_STATE(5936)] = 237490,
  [SMALL_STATE(5937)] = 237541,
  [SMALL_STATE(5938)] = 237592,
  [SMALL_STATE(5939)] = 237643,
  [SMALL_STATE(5940)] = 237694,
  [SMALL_STATE(5941)] = 237745,
  [SMALL_STATE(5942)] = 237796,
  [SMALL_STATE(5943)] = 237847,
  [SMALL_STATE(5944)] = 237898,
  [SMALL_STATE(5945)] = 237949,
  [SMALL_STATE(5946)] = 238000,
  [SMALL_STATE(5947)] = 238051,
  [SMALL_STATE(5948)] = 238102,
  [SMALL_STATE(5949)] = 238153,
  [SMALL_STATE(5950)] = 238204,
  [SMALL_STATE(5951)] = 238255,
  [SMALL_STATE(5952)] = 238306,
  [SMALL_STATE(5953)] = 238357,
  [SMALL_STATE(5954)] = 238408,
  [SMALL_STATE(5955)] = 238459,
  [SMALL_STATE(5956)] = 238510,
  [SMALL_STATE(5957)] = 238561,
  [SMALL_STATE(5958)] = 238612,
  [SMALL_STATE(5959)] = 238663,
  [SMALL_STATE(5960)] = 238714,
  [SMALL_STATE(5961)] = 238771,
  [SMALL_STATE(5962)] = 238868,
  [SMALL_STATE(5963)] = 238919,
  [SMALL_STATE(5964)] = 238970,
  [SMALL_STATE(5965)] = 239021,
  [SMALL_STATE(5966)] = 239072,
  [SMALL_STATE(5967)] = 239123,
  [SMALL_STATE(5968)] = 239174,
  [SMALL_STATE(5969)] = 239225,
  [SMALL_STATE(5970)] = 239276,
  [SMALL_STATE(5971)] = 239327,
  [SMALL_STATE(5972)] = 239378,
  [SMALL_STATE(5973)] = 239429,
  [SMALL_STATE(5974)] = 239480,
  [SMALL_STATE(5975)] = 239531,
  [SMALL_STATE(5976)] = 239582,
  [SMALL_STATE(5977)] = 239633,
  [SMALL_STATE(5978)] = 239684,
  [SMALL_STATE(5979)] = 239735,
  [SMALL_STATE(5980)] = 239786,
  [SMALL_STATE(5981)] = 239843,
  [SMALL_STATE(5982)] = 239894,
  [SMALL_STATE(5983)] = 239945,
  [SMALL_STATE(5984)] = 239996,
  [SMALL_STATE(5985)] = 240047,
  [SMALL_STATE(5986)] = 240098,
  [SMALL_STATE(5987)] = 240155,
  [SMALL_STATE(5988)] = 240206,
  [SMALL_STATE(5989)] = 240257,
  [SMALL_STATE(5990)] = 240308,
  [SMALL_STATE(5991)] = 240359,
  [SMALL_STATE(5992)] = 240410,
  [SMALL_STATE(5993)] = 240461,
  [SMALL_STATE(5994)] = 240512,
  [SMALL_STATE(5995)] = 240563,
  [SMALL_STATE(5996)] = 240620,
  [SMALL_STATE(5997)] = 240671,
  [SMALL_STATE(5998)] = 240722,
  [SMALL_STATE(5999)] = 240773,
  [SMALL_STATE(6000)] = 240824,
  [SMALL_STATE(6001)] = 240875,
  [SMALL_STATE(6002)] = 240926,
  [SMALL_STATE(6003)] = 240977,
  [SMALL_STATE(6004)] = 241028,
  [SMALL_STATE(6005)] = 241079,
  [SMALL_STATE(6006)] = 241130,
  [SMALL_STATE(6007)] = 241181,
  [SMALL_STATE(6008)] = 241232,
  [SMALL_STATE(6009)] = 241283,
  [SMALL_STATE(6010)] = 241334,
  [SMALL_STATE(6011)] = 241385,
  [SMALL_STATE(6012)] = 241442,
  [SMALL_STATE(6013)] = 241497,
  [SMALL_STATE(6014)] = 241548,
  [SMALL_STATE(6015)] = 241599,
  [SMALL_STATE(6016)] = 241656,
  [SMALL_STATE(6017)] = 241707,
  [SMALL_STATE(6018)] = 241758,
  [SMALL_STATE(6019)] = 241809,
  [SMALL_STATE(6020)] = 241860,
  [SMALL_STATE(6021)] = 241911,
  [SMALL_STATE(6022)] = 241962,
  [SMALL_STATE(6023)] = 242013,
  [SMALL_STATE(6024)] = 242064,
  [SMALL_STATE(6025)] = 242115,
  [SMALL_STATE(6026)] = 242166,
  [SMALL_STATE(6027)] = 242223,
  [SMALL_STATE(6028)] = 242274,
  [SMALL_STATE(6029)] = 242325,
  [SMALL_STATE(6030)] = 242422,
  [SMALL_STATE(6031)] = 242473,
  [SMALL_STATE(6032)] = 242570,
  [SMALL_STATE(6033)] = 242625,
  [SMALL_STATE(6034)] = 242676,
  [SMALL_STATE(6035)] = 242773,
  [SMALL_STATE(6036)] = 242824,
  [SMALL_STATE(6037)] = 242875,
  [SMALL_STATE(6038)] = 242926,
  [SMALL_STATE(6039)] = 242977,
  [SMALL_STATE(6040)] = 243028,
  [SMALL_STATE(6041)] = 243079,
  [SMALL_STATE(6042)] = 243130,
  [SMALL_STATE(6043)] = 243181,
  [SMALL_STATE(6044)] = 243232,
  [SMALL_STATE(6045)] = 243283,
  [SMALL_STATE(6046)] = 243334,
  [SMALL_STATE(6047)] = 243385,
  [SMALL_STATE(6048)] = 243436,
  [SMALL_STATE(6049)] = 243487,
  [SMALL_STATE(6050)] = 243538,
  [SMALL_STATE(6051)] = 243589,
  [SMALL_STATE(6052)] = 243640,
  [SMALL_STATE(6053)] = 243691,
  [SMALL_STATE(6054)] = 243742,
  [SMALL_STATE(6055)] = 243793,
  [SMALL_STATE(6056)] = 243844,
  [SMALL_STATE(6057)] = 243901,
  [SMALL_STATE(6058)] = 243998,
  [SMALL_STATE(6059)] = 244048,
  [SMALL_STATE(6060)] = 244098,
  [SMALL_STATE(6061)] = 244148,
  [SMALL_STATE(6062)] = 244204,
  [SMALL_STATE(6063)] = 244254,
  [SMALL_STATE(6064)] = 244304,
  [SMALL_STATE(6065)] = 244354,
  [SMALL_STATE(6066)] = 244404,
  [SMALL_STATE(6067)] = 244454,
  [SMALL_STATE(6068)] = 244504,
  [SMALL_STATE(6069)] = 244554,
  [SMALL_STATE(6070)] = 244604,
  [SMALL_STATE(6071)] = 244654,
  [SMALL_STATE(6072)] = 244704,
  [SMALL_STATE(6073)] = 244754,
  [SMALL_STATE(6074)] = 244804,
  [SMALL_STATE(6075)] = 244854,
  [SMALL_STATE(6076)] = 244910,
  [SMALL_STATE(6077)] = 244966,
  [SMALL_STATE(6078)] = 245016,
  [SMALL_STATE(6079)] = 245066,
  [SMALL_STATE(6080)] = 245116,
  [SMALL_STATE(6081)] = 245166,
  [SMALL_STATE(6082)] = 245216,
  [SMALL_STATE(6083)] = 245272,
  [SMALL_STATE(6084)] = 245322,
  [SMALL_STATE(6085)] = 245372,
  [SMALL_STATE(6086)] = 245422,
  [SMALL_STATE(6087)] = 245472,
  [SMALL_STATE(6088)] = 245522,
  [SMALL_STATE(6089)] = 245572,
  [SMALL_STATE(6090)] = 245622,
  [SMALL_STATE(6091)] = 245672,
  [SMALL_STATE(6092)] = 245722,
  [SMALL_STATE(6093)] = 245772,
  [SMALL_STATE(6094)] = 245828,
  [SMALL_STATE(6095)] = 245884,
  [SMALL_STATE(6096)] = 245934,
  [SMALL_STATE(6097)] = 245984,
  [SMALL_STATE(6098)] = 246040,
  [SMALL_STATE(6099)] = 246096,
  [SMALL_STATE(6100)] = 246146,
  [SMALL_STATE(6101)] = 246196,
  [SMALL_STATE(6102)] = 246246,
  [SMALL_STATE(6103)] = 246296,
  [SMALL_STATE(6104)] = 246346,
  [SMALL_STATE(6105)] = 246402,
  [SMALL_STATE(6106)] = 246452,
  [SMALL_STATE(6107)] = 246502,
  [SMALL_STATE(6108)] = 246552,
  [SMALL_STATE(6109)] = 246602,
  [SMALL_STATE(6110)] = 246652,
  [SMALL_STATE(6111)] = 246702,
  [SMALL_STATE(6112)] = 246758,
  [SMALL_STATE(6113)] = 246808,
  [SMALL_STATE(6114)] = 246864,
  [SMALL_STATE(6115)] = 246920,
  [SMALL_STATE(6116)] = 246970,
  [SMALL_STATE(6117)] = 247020,
  [SMALL_STATE(6118)] = 247070,
  [SMALL_STATE(6119)] = 247120,
  [SMALL_STATE(6120)] = 247174,
  [SMALL_STATE(6121)] = 247224,
  [SMALL_STATE(6122)] = 247274,
  [SMALL_STATE(6123)] = 247324,
  [SMALL_STATE(6124)] = 247374,
  [SMALL_STATE(6125)] = 247424,
  [SMALL_STATE(6126)] = 247474,
  [SMALL_STATE(6127)] = 247524,
  [SMALL_STATE(6128)] = 247574,
  [SMALL_STATE(6129)] = 247624,
  [SMALL_STATE(6130)] = 247674,
  [SMALL_STATE(6131)] = 247724,
  [SMALL_STATE(6132)] = 247774,
  [SMALL_STATE(6133)] = 247824,
  [SMALL_STATE(6134)] = 247874,
  [SMALL_STATE(6135)] = 247924,
  [SMALL_STATE(6136)] = 247974,
  [SMALL_STATE(6137)] = 248024,
  [SMALL_STATE(6138)] = 248074,
  [SMALL_STATE(6139)] = 248124,
  [SMALL_STATE(6140)] = 248174,
  [SMALL_STATE(6141)] = 248224,
  [SMALL_STATE(6142)] = 248274,
  [SMALL_STATE(6143)] = 248324,
  [SMALL_STATE(6144)] = 248374,
  [SMALL_STATE(6145)] = 248424,
  [SMALL_STATE(6146)] = 248474,
  [SMALL_STATE(6147)] = 248528,
  [SMALL_STATE(6148)] = 248578,
  [SMALL_STATE(6149)] = 248634,
  [SMALL_STATE(6150)] = 248690,
  [SMALL_STATE(6151)] = 248746,
  [SMALL_STATE(6152)] = 248796,
  [SMALL_STATE(6153)] = 248846,
  [SMALL_STATE(6154)] = 248896,
  [SMALL_STATE(6155)] = 248946,
  [SMALL_STATE(6156)] = 249002,
  [SMALL_STATE(6157)] = 249052,
  [SMALL_STATE(6158)] = 249102,
  [SMALL_STATE(6159)] = 249152,
  [SMALL_STATE(6160)] = 249202,
  [SMALL_STATE(6161)] = 249252,
  [SMALL_STATE(6162)] = 249302,
  [SMALL_STATE(6163)] = 249374,
  [SMALL_STATE(6164)] = 249430,
  [SMALL_STATE(6165)] = 249480,
  [SMALL_STATE(6166)] = 249536,
  [SMALL_STATE(6167)] = 249586,
  [SMALL_STATE(6168)] = 249636,
  [SMALL_STATE(6169)] = 249686,
  [SMALL_STATE(6170)] = 249736,
  [SMALL_STATE(6171)] = 249786,
  [SMALL_STATE(6172)] = 249836,
  [SMALL_STATE(6173)] = 249892,
  [SMALL_STATE(6174)] = 249948,
  [SMALL_STATE(6175)] = 249998,
  [SMALL_STATE(6176)] = 250048,
  [SMALL_STATE(6177)] = 250102,
  [SMALL_STATE(6178)] = 250152,
  [SMALL_STATE(6179)] = 250202,
  [SMALL_STATE(6180)] = 250252,
  [SMALL_STATE(6181)] = 250308,
  [SMALL_STATE(6182)] = 250364,
  [SMALL_STATE(6183)] = 250414,
  [SMALL_STATE(6184)] = 250470,
  [SMALL_STATE(6185)] = 250526,
  [SMALL_STATE(6186)] = 250582,
  [SMALL_STATE(6187)] = 250638,
  [SMALL_STATE(6188)] = 250694,
  [SMALL_STATE(6189)] = 250744,
  [SMALL_STATE(6190)] = 250800,
  [SMALL_STATE(6191)] = 250856,
  [SMALL_STATE(6192)] = 250905,
  [SMALL_STATE(6193)] = 250998,
  [SMALL_STATE(6194)] = 251047,
  [SMALL_STATE(6195)] = 251096,
  [SMALL_STATE(6196)] = 251145,
  [SMALL_STATE(6197)] = 251208,
  [SMALL_STATE(6198)] = 251257,
  [SMALL_STATE(6199)] = 251306,
  [SMALL_STATE(6200)] = 251355,
  [SMALL_STATE(6201)] = 251404,
  [SMALL_STATE(6202)] = 251453,
  [SMALL_STATE(6203)] = 251502,
  [SMALL_STATE(6204)] = 251551,
  [SMALL_STATE(6205)] = 251600,
  [SMALL_STATE(6206)] = 251649,
  [SMALL_STATE(6207)] = 251698,
  [SMALL_STATE(6208)] = 251747,
  [SMALL_STATE(6209)] = 251800,
  [SMALL_STATE(6210)] = 251849,
  [SMALL_STATE(6211)] = 251898,
  [SMALL_STATE(6212)] = 251947,
  [SMALL_STATE(6213)] = 251996,
  [SMALL_STATE(6214)] = 252045,
  [SMALL_STATE(6215)] = 252094,
  [SMALL_STATE(6216)] = 252143,
  [SMALL_STATE(6217)] = 252192,
  [SMALL_STATE(6218)] = 252285,
  [SMALL_STATE(6219)] = 252334,
  [SMALL_STATE(6220)] = 252383,
  [SMALL_STATE(6221)] = 252432,
  [SMALL_STATE(6222)] = 252481,
  [SMALL_STATE(6223)] = 252530,
  [SMALL_STATE(6224)] = 252579,
  [SMALL_STATE(6225)] = 252628,
  [SMALL_STATE(6226)] = 252677,
  [SMALL_STATE(6227)] = 252726,
  [SMALL_STATE(6228)] = 252775,
  [SMALL_STATE(6229)] = 252830,
  [SMALL_STATE(6230)] = 252879,
  [SMALL_STATE(6231)] = 252928,
  [SMALL_STATE(6232)] = 252977,
  [SMALL_STATE(6233)] = 253026,
  [SMALL_STATE(6234)] = 253075,
  [SMALL_STATE(6235)] = 253124,
  [SMALL_STATE(6236)] = 253173,
  [SMALL_STATE(6237)] = 253222,
  [SMALL_STATE(6238)] = 253271,
  [SMALL_STATE(6239)] = 253320,
  [SMALL_STATE(6240)] = 253369,
  [SMALL_STATE(6241)] = 253418,
  [SMALL_STATE(6242)] = 253467,
  [SMALL_STATE(6243)] = 253516,
  [SMALL_STATE(6244)] = 253565,
  [SMALL_STATE(6245)] = 253620,
  [SMALL_STATE(6246)] = 253669,
  [SMALL_STATE(6247)] = 253724,
  [SMALL_STATE(6248)] = 253773,
  [SMALL_STATE(6249)] = 253822,
  [SMALL_STATE(6250)] = 253871,
  [SMALL_STATE(6251)] = 253964,
  [SMALL_STATE(6252)] = 254013,
  [SMALL_STATE(6253)] = 254068,
  [SMALL_STATE(6254)] = 254117,
  [SMALL_STATE(6255)] = 254172,
  [SMALL_STATE(6256)] = 254221,
  [SMALL_STATE(6257)] = 254270,
  [SMALL_STATE(6258)] = 254323,
  [SMALL_STATE(6259)] = 254372,
  [SMALL_STATE(6260)] = 254421,
  [SMALL_STATE(6261)] = 254514,
  [SMALL_STATE(6262)] = 254563,
  [SMALL_STATE(6263)] = 254612,
  [SMALL_STATE(6264)] = 254705,
  [SMALL_STATE(6265)] = 254754,
  [SMALL_STATE(6266)] = 254803,
  [SMALL_STATE(6267)] = 254858,
  [SMALL_STATE(6268)] = 254907,
  [SMALL_STATE(6269)] = 254956,
  [SMALL_STATE(6270)] = 255005,
  [SMALL_STATE(6271)] = 255054,
  [SMALL_STATE(6272)] = 255109,
  [SMALL_STATE(6273)] = 255158,
  [SMALL_STATE(6274)] = 255207,
  [SMALL_STATE(6275)] = 255256,
  [SMALL_STATE(6276)] = 255305,
  [SMALL_STATE(6277)] = 255354,
  [SMALL_STATE(6278)] = 255403,
  [SMALL_STATE(6279)] = 255452,
  [SMALL_STATE(6280)] = 255501,
  [SMALL_STATE(6281)] = 255550,
  [SMALL_STATE(6282)] = 255599,
  [SMALL_STATE(6283)] = 255648,
  [SMALL_STATE(6284)] = 255697,
  [SMALL_STATE(6285)] = 255746,
  [SMALL_STATE(6286)] = 255795,
  [SMALL_STATE(6287)] = 255844,
  [SMALL_STATE(6288)] = 255893,
  [SMALL_STATE(6289)] = 255942,
  [SMALL_STATE(6290)] = 255991,
  [SMALL_STATE(6291)] = 256084,
  [SMALL_STATE(6292)] = 256133,
  [SMALL_STATE(6293)] = 256182,
  [SMALL_STATE(6294)] = 256231,
  [SMALL_STATE(6295)] = 256280,
  [SMALL_STATE(6296)] = 256329,
  [SMALL_STATE(6297)] = 256378,
  [SMALL_STATE(6298)] = 256433,
  [SMALL_STATE(6299)] = 256488,
  [SMALL_STATE(6300)] = 256543,
  [SMALL_STATE(6301)] = 256592,
  [SMALL_STATE(6302)] = 256641,
  [SMALL_STATE(6303)] = 256696,
  [SMALL_STATE(6304)] = 256751,
  [SMALL_STATE(6305)] = 256844,
  [SMALL_STATE(6306)] = 256893,
  [SMALL_STATE(6307)] = 256942,
  [SMALL_STATE(6308)] = 256991,
  [SMALL_STATE(6309)] = 257040,
  [SMALL_STATE(6310)] = 257089,
  [SMALL_STATE(6311)] = 257138,
  [SMALL_STATE(6312)] = 257187,
  [SMALL_STATE(6313)] = 257280,
  [SMALL_STATE(6314)] = 257333,
  [SMALL_STATE(6315)] = 257382,
  [SMALL_STATE(6316)] = 257431,
  [SMALL_STATE(6317)] = 257480,
  [SMALL_STATE(6318)] = 257529,
  [SMALL_STATE(6319)] = 257578,
  [SMALL_STATE(6320)] = 257627,
  [SMALL_STATE(6321)] = 257676,
  [SMALL_STATE(6322)] = 257725,
  [SMALL_STATE(6323)] = 257780,
  [SMALL_STATE(6324)] = 257829,
  [SMALL_STATE(6325)] = 257878,
  [SMALL_STATE(6326)] = 257927,
  [SMALL_STATE(6327)] = 257976,
  [SMALL_STATE(6328)] = 258025,
  [SMALL_STATE(6329)] = 258074,
  [SMALL_STATE(6330)] = 258123,
  [SMALL_STATE(6331)] = 258172,
  [SMALL_STATE(6332)] = 258221,
  [SMALL_STATE(6333)] = 258270,
  [SMALL_STATE(6334)] = 258319,
  [SMALL_STATE(6335)] = 258368,
  [SMALL_STATE(6336)] = 258461,
  [SMALL_STATE(6337)] = 258554,
  [SMALL_STATE(6338)] = 258603,
  [SMALL_STATE(6339)] = 258652,
  [SMALL_STATE(6340)] = 258745,
  [SMALL_STATE(6341)] = 258794,
  [SMALL_STATE(6342)] = 258843,
  [SMALL_STATE(6343)] = 258892,
  [SMALL_STATE(6344)] = 258941,
  [SMALL_STATE(6345)] = 258990,
  [SMALL_STATE(6346)] = 259039,
  [SMALL_STATE(6347)] = 259088,
  [SMALL_STATE(6348)] = 259137,
  [SMALL_STATE(6349)] = 259186,
  [SMALL_STATE(6350)] = 259235,
  [SMALL_STATE(6351)] = 259284,
  [SMALL_STATE(6352)] = 259333,
  [SMALL_STATE(6353)] = 259426,
  [SMALL_STATE(6354)] = 259475,
  [SMALL_STATE(6355)] = 259524,
  [SMALL_STATE(6356)] = 259573,
  [SMALL_STATE(6357)] = 259628,
  [SMALL_STATE(6358)] = 259677,
  [SMALL_STATE(6359)] = 259726,
  [SMALL_STATE(6360)] = 259781,
  [SMALL_STATE(6361)] = 259874,
  [SMALL_STATE(6362)] = 259923,
  [SMALL_STATE(6363)] = 259972,
  [SMALL_STATE(6364)] = 260021,
  [SMALL_STATE(6365)] = 260070,
  [SMALL_STATE(6366)] = 260119,
  [SMALL_STATE(6367)] = 260168,
  [SMALL_STATE(6368)] = 260217,
  [SMALL_STATE(6369)] = 260266,
  [SMALL_STATE(6370)] = 260315,
  [SMALL_STATE(6371)] = 260364,
  [SMALL_STATE(6372)] = 260413,
  [SMALL_STATE(6373)] = 260462,
  [SMALL_STATE(6374)] = 260511,
  [SMALL_STATE(6375)] = 260560,
  [SMALL_STATE(6376)] = 260609,
  [SMALL_STATE(6377)] = 260658,
  [SMALL_STATE(6378)] = 260751,
  [SMALL_STATE(6379)] = 260844,
  [SMALL_STATE(6380)] = 260893,
  [SMALL_STATE(6381)] = 260986,
  [SMALL_STATE(6382)] = 261079,
  [SMALL_STATE(6383)] = 261128,
  [SMALL_STATE(6384)] = 261177,
  [SMALL_STATE(6385)] = 261270,
  [SMALL_STATE(6386)] = 261319,
  [SMALL_STATE(6387)] = 261368,
  [SMALL_STATE(6388)] = 261417,
  [SMALL_STATE(6389)] = 261466,
  [SMALL_STATE(6390)] = 261515,
  [SMALL_STATE(6391)] = 261564,
  [SMALL_STATE(6392)] = 261613,
  [SMALL_STATE(6393)] = 261706,
  [SMALL_STATE(6394)] = 261755,
  [SMALL_STATE(6395)] = 261804,
  [SMALL_STATE(6396)] = 261853,
  [SMALL_STATE(6397)] = 261902,
  [SMALL_STATE(6398)] = 261957,
  [SMALL_STATE(6399)] = 262006,
  [SMALL_STATE(6400)] = 262055,
  [SMALL_STATE(6401)] = 262148,
  [SMALL_STATE(6402)] = 262197,
  [SMALL_STATE(6403)] = 262290,
  [SMALL_STATE(6404)] = 262383,
  [SMALL_STATE(6405)] = 262432,
  [SMALL_STATE(6406)] = 262525,
  [SMALL_STATE(6407)] = 262574,
  [SMALL_STATE(6408)] = 262623,
  [SMALL_STATE(6409)] = 262672,
  [SMALL_STATE(6410)] = 262721,
  [SMALL_STATE(6411)] = 262774,
  [SMALL_STATE(6412)] = 262867,
  [SMALL_STATE(6413)] = 262916,
  [SMALL_STATE(6414)] = 262965,
  [SMALL_STATE(6415)] = 263014,
  [SMALL_STATE(6416)] = 263063,
  [SMALL_STATE(6417)] = 263112,
  [SMALL_STATE(6418)] = 263161,
  [SMALL_STATE(6419)] = 263210,
  [SMALL_STATE(6420)] = 263259,
  [SMALL_STATE(6421)] = 263308,
  [SMALL_STATE(6422)] = 263357,
  [SMALL_STATE(6423)] = 263450,
  [SMALL_STATE(6424)] = 263505,
  [SMALL_STATE(6425)] = 263554,
  [SMALL_STATE(6426)] = 263603,
  [SMALL_STATE(6427)] = 263652,
  [SMALL_STATE(6428)] = 263701,
  [SMALL_STATE(6429)] = 263794,
  [SMALL_STATE(6430)] = 263843,
  [SMALL_STATE(6431)] = 263892,
  [SMALL_STATE(6432)] = 263941,
  [SMALL_STATE(6433)] = 263990,
  [SMALL_STATE(6434)] = 264039,
  [SMALL_STATE(6435)] = 264094,
  [SMALL_STATE(6436)] = 264143,
  [SMALL_STATE(6437)] = 264192,
  [SMALL_STATE(6438)] = 264241,
  [SMALL_STATE(6439)] = 264290,
  [SMALL_STATE(6440)] = 264383,
  [SMALL_STATE(6441)] = 264436,
  [SMALL_STATE(6442)] = 264529,
  [SMALL_STATE(6443)] = 264622,
  [SMALL_STATE(6444)] = 264671,
  [SMALL_STATE(6445)] = 264720,
  [SMALL_STATE(6446)] = 264769,
  [SMALL_STATE(6447)] = 264862,
  [SMALL_STATE(6448)] = 264911,
  [SMALL_STATE(6449)] = 264960,
  [SMALL_STATE(6450)] = 265009,
  [SMALL_STATE(6451)] = 265058,
  [SMALL_STATE(6452)] = 265107,
  [SMALL_STATE(6453)] = 265156,
  [SMALL_STATE(6454)] = 265205,
  [SMALL_STATE(6455)] = 265298,
  [SMALL_STATE(6456)] = 265347,
  [SMALL_STATE(6457)] = 265396,
  [SMALL_STATE(6458)] = 265489,
  [SMALL_STATE(6459)] = 265582,
  [SMALL_STATE(6460)] = 265631,
  [SMALL_STATE(6461)] = 265724,
  [SMALL_STATE(6462)] = 265817,
  [SMALL_STATE(6463)] = 265910,
  [SMALL_STATE(6464)] = 265959,
  [SMALL_STATE(6465)] = 266008,
  [SMALL_STATE(6466)] = 266101,
  [SMALL_STATE(6467)] = 266150,
  [SMALL_STATE(6468)] = 266199,
  [SMALL_STATE(6469)] = 266248,
  [SMALL_STATE(6470)] = 266297,
  [SMALL_STATE(6471)] = 266346,
  [SMALL_STATE(6472)] = 266395,
  [SMALL_STATE(6473)] = 266444,
  [SMALL_STATE(6474)] = 266493,
  [SMALL_STATE(6475)] = 266542,
  [SMALL_STATE(6476)] = 266591,
  [SMALL_STATE(6477)] = 266640,
  [SMALL_STATE(6478)] = 266689,
  [SMALL_STATE(6479)] = 266738,
  [SMALL_STATE(6480)] = 266787,
  [SMALL_STATE(6481)] = 266836,
  [SMALL_STATE(6482)] = 266885,
  [SMALL_STATE(6483)] = 266934,
  [SMALL_STATE(6484)] = 266983,
  [SMALL_STATE(6485)] = 267032,
  [SMALL_STATE(6486)] = 267081,
  [SMALL_STATE(6487)] = 267130,
  [SMALL_STATE(6488)] = 267179,
  [SMALL_STATE(6489)] = 267228,
  [SMALL_STATE(6490)] = 267277,
  [SMALL_STATE(6491)] = 267326,
  [SMALL_STATE(6492)] = 267375,
  [SMALL_STATE(6493)] = 267424,
  [SMALL_STATE(6494)] = 267473,
  [SMALL_STATE(6495)] = 267522,
  [SMALL_STATE(6496)] = 267571,
  [SMALL_STATE(6497)] = 267620,
  [SMALL_STATE(6498)] = 267675,
  [SMALL_STATE(6499)] = 267724,
  [SMALL_STATE(6500)] = 267773,
  [SMALL_STATE(6501)] = 267822,
  [SMALL_STATE(6502)] = 267915,
  [SMALL_STATE(6503)] = 268008,
  [SMALL_STATE(6504)] = 268057,
  [SMALL_STATE(6505)] = 268106,
  [SMALL_STATE(6506)] = 268155,
  [SMALL_STATE(6507)] = 268248,
  [SMALL_STATE(6508)] = 268297,
  [SMALL_STATE(6509)] = 268346,
  [SMALL_STATE(6510)] = 268395,
  [SMALL_STATE(6511)] = 268444,
  [SMALL_STATE(6512)] = 268493,
  [SMALL_STATE(6513)] = 268542,
  [SMALL_STATE(6514)] = 268591,
  [SMALL_STATE(6515)] = 268640,
  [SMALL_STATE(6516)] = 268689,
  [SMALL_STATE(6517)] = 268738,
  [SMALL_STATE(6518)] = 268787,
  [SMALL_STATE(6519)] = 268836,
  [SMALL_STATE(6520)] = 268885,
  [SMALL_STATE(6521)] = 268934,
  [SMALL_STATE(6522)] = 268983,
  [SMALL_STATE(6523)] = 269038,
  [SMALL_STATE(6524)] = 269087,
  [SMALL_STATE(6525)] = 269180,
  [SMALL_STATE(6526)] = 269233,
  [SMALL_STATE(6527)] = 269282,
  [SMALL_STATE(6528)] = 269331,
  [SMALL_STATE(6529)] = 269380,
  [SMALL_STATE(6530)] = 269429,
  [SMALL_STATE(6531)] = 269478,
  [SMALL_STATE(6532)] = 269527,
  [SMALL_STATE(6533)] = 269576,
  [SMALL_STATE(6534)] = 269625,
  [SMALL_STATE(6535)] = 269674,
  [SMALL_STATE(6536)] = 269723,
  [SMALL_STATE(6537)] = 269772,
  [SMALL_STATE(6538)] = 269821,
  [SMALL_STATE(6539)] = 269870,
  [SMALL_STATE(6540)] = 269919,
  [SMALL_STATE(6541)] = 270012,
  [SMALL_STATE(6542)] = 270061,
  [SMALL_STATE(6543)] = 270110,
  [SMALL_STATE(6544)] = 270203,
  [SMALL_STATE(6545)] = 270252,
  [SMALL_STATE(6546)] = 270301,
  [SMALL_STATE(6547)] = 270350,
  [SMALL_STATE(6548)] = 270399,
  [SMALL_STATE(6549)] = 270448,
  [SMALL_STATE(6550)] = 270501,
  [SMALL_STATE(6551)] = 270594,
  [SMALL_STATE(6552)] = 270643,
  [SMALL_STATE(6553)] = 270692,
  [SMALL_STATE(6554)] = 270785,
  [SMALL_STATE(6555)] = 270834,
  [SMALL_STATE(6556)] = 270927,
  [SMALL_STATE(6557)] = 270976,
  [SMALL_STATE(6558)] = 271025,
  [SMALL_STATE(6559)] = 271074,
  [SMALL_STATE(6560)] = 271123,
  [SMALL_STATE(6561)] = 271216,
  [SMALL_STATE(6562)] = 271265,
  [SMALL_STATE(6563)] = 271358,
  [SMALL_STATE(6564)] = 271407,
  [SMALL_STATE(6565)] = 271456,
  [SMALL_STATE(6566)] = 271511,
  [SMALL_STATE(6567)] = 271560,
  [SMALL_STATE(6568)] = 271609,
  [SMALL_STATE(6569)] = 271658,
  [SMALL_STATE(6570)] = 271707,
  [SMALL_STATE(6571)] = 271756,
  [SMALL_STATE(6572)] = 271805,
  [SMALL_STATE(6573)] = 271854,
  [SMALL_STATE(6574)] = 271903,
  [SMALL_STATE(6575)] = 271951,
  [SMALL_STATE(6576)] = 271999,
  [SMALL_STATE(6577)] = 272047,
  [SMALL_STATE(6578)] = 272095,
  [SMALL_STATE(6579)] = 272143,
  [SMALL_STATE(6580)] = 272191,
  [SMALL_STATE(6581)] = 272245,
  [SMALL_STATE(6582)] = 272293,
  [SMALL_STATE(6583)] = 272341,
  [SMALL_STATE(6584)] = 272389,
  [SMALL_STATE(6585)] = 272443,
  [SMALL_STATE(6586)] = 272491,
  [SMALL_STATE(6587)] = 272539,
  [SMALL_STATE(6588)] = 272587,
  [SMALL_STATE(6589)] = 272641,
  [SMALL_STATE(6590)] = 272695,
  [SMALL_STATE(6591)] = 272743,
  [SMALL_STATE(6592)] = 272791,
  [SMALL_STATE(6593)] = 272839,
  [SMALL_STATE(6594)] = 272893,
  [SMALL_STATE(6595)] = 272947,
  [SMALL_STATE(6596)] = 272995,
  [SMALL_STATE(6597)] = 273047,
  [SMALL_STATE(6598)] = 273101,
  [SMALL_STATE(6599)] = 273155,
  [SMALL_STATE(6600)] = 273203,
  [SMALL_STATE(6601)] = 273251,
  [SMALL_STATE(6602)] = 273299,
  [SMALL_STATE(6603)] = 273347,
  [SMALL_STATE(6604)] = 273401,
  [SMALL_STATE(6605)] = 273449,
  [SMALL_STATE(6606)] = 273497,
  [SMALL_STATE(6607)] = 273551,
  [SMALL_STATE(6608)] = 273599,
  [SMALL_STATE(6609)] = 273653,
  [SMALL_STATE(6610)] = 273701,
  [SMALL_STATE(6611)] = 273749,
  [SMALL_STATE(6612)] = 273797,
  [SMALL_STATE(6613)] = 273851,
  [SMALL_STATE(6614)] = 273899,
  [SMALL_STATE(6615)] = 273947,
  [SMALL_STATE(6616)] = 273995,
  [SMALL_STATE(6617)] = 274043,
  [SMALL_STATE(6618)] = 274101,
  [SMALL_STATE(6619)] = 274149,
  [SMALL_STATE(6620)] = 274203,
  [SMALL_STATE(6621)] = 274257,
  [SMALL_STATE(6622)] = 274305,
  [SMALL_STATE(6623)] = 274353,
  [SMALL_STATE(6624)] = 274407,
  [SMALL_STATE(6625)] = 274455,
  [SMALL_STATE(6626)] = 274509,
  [SMALL_STATE(6627)] = 274557,
  [SMALL_STATE(6628)] = 274605,
  [SMALL_STATE(6629)] = 274653,
  [SMALL_STATE(6630)] = 274707,
  [SMALL_STATE(6631)] = 274761,
  [SMALL_STATE(6632)] = 274809,
  [SMALL_STATE(6633)] = 274857,
  [SMALL_STATE(6634)] = 274905,
  [SMALL_STATE(6635)] = 274953,
  [SMALL_STATE(6636)] = 275001,
  [SMALL_STATE(6637)] = 275049,
  [SMALL_STATE(6638)] = 275097,
  [SMALL_STATE(6639)] = 275145,
  [SMALL_STATE(6640)] = 275193,
  [SMALL_STATE(6641)] = 275241,
  [SMALL_STATE(6642)] = 275289,
  [SMALL_STATE(6643)] = 275337,
  [SMALL_STATE(6644)] = 275385,
  [SMALL_STATE(6645)] = 275433,
  [SMALL_STATE(6646)] = 275481,
  [SMALL_STATE(6647)] = 275529,
  [SMALL_STATE(6648)] = 275577,
  [SMALL_STATE(6649)] = 275625,
  [SMALL_STATE(6650)] = 275673,
  [SMALL_STATE(6651)] = 275721,
  [SMALL_STATE(6652)] = 275769,
  [SMALL_STATE(6653)] = 275817,
  [SMALL_STATE(6654)] = 275871,
  [SMALL_STATE(6655)] = 275919,
  [SMALL_STATE(6656)] = 275967,
  [SMALL_STATE(6657)] = 276015,
  [SMALL_STATE(6658)] = 276063,
  [SMALL_STATE(6659)] = 276117,
  [SMALL_STATE(6660)] = 276165,
  [SMALL_STATE(6661)] = 276213,
  [SMALL_STATE(6662)] = 276261,
  [SMALL_STATE(6663)] = 276309,
  [SMALL_STATE(6664)] = 276357,
  [SMALL_STATE(6665)] = 276411,
  [SMALL_STATE(6666)] = 276459,
  [SMALL_STATE(6667)] = 276507,
  [SMALL_STATE(6668)] = 276555,
  [SMALL_STATE(6669)] = 276603,
  [SMALL_STATE(6670)] = 276651,
  [SMALL_STATE(6671)] = 276699,
  [SMALL_STATE(6672)] = 276747,
  [SMALL_STATE(6673)] = 276795,
  [SMALL_STATE(6674)] = 276843,
  [SMALL_STATE(6675)] = 276897,
  [SMALL_STATE(6676)] = 276951,
  [SMALL_STATE(6677)] = 277005,
  [SMALL_STATE(6678)] = 277059,
  [SMALL_STATE(6679)] = 277113,
  [SMALL_STATE(6680)] = 277167,
  [SMALL_STATE(6681)] = 277215,
  [SMALL_STATE(6682)] = 277263,
  [SMALL_STATE(6683)] = 277311,
  [SMALL_STATE(6684)] = 277359,
  [SMALL_STATE(6685)] = 277413,
  [SMALL_STATE(6686)] = 277461,
  [SMALL_STATE(6687)] = 277509,
  [SMALL_STATE(6688)] = 277557,
  [SMALL_STATE(6689)] = 277605,
  [SMALL_STATE(6690)] = 277653,
  [SMALL_STATE(6691)] = 277701,
  [SMALL_STATE(6692)] = 277755,
  [SMALL_STATE(6693)] = 277809,
  [SMALL_STATE(6694)] = 277857,
  [SMALL_STATE(6695)] = 277911,
  [SMALL_STATE(6696)] = 277959,
  [SMALL_STATE(6697)] = 278025,
  [SMALL_STATE(6698)] = 278072,
  [SMALL_STATE(6699)] = 278119,
  [SMALL_STATE(6700)] = 278166,
  [SMALL_STATE(6701)] = 278213,
  [SMALL_STATE(6702)] = 278260,
  [SMALL_STATE(6703)] = 278307,
  [SMALL_STATE(6704)] = 278354,
  [SMALL_STATE(6705)] = 278401,
  [SMALL_STATE(6706)] = 278448,
  [SMALL_STATE(6707)] = 278495,
  [SMALL_STATE(6708)] = 278542,
  [SMALL_STATE(6709)] = 278589,
  [SMALL_STATE(6710)] = 278636,
  [SMALL_STATE(6711)] = 278683,
  [SMALL_STATE(6712)] = 278730,
  [SMALL_STATE(6713)] = 278777,
  [SMALL_STATE(6714)] = 278824,
  [SMALL_STATE(6715)] = 278871,
  [SMALL_STATE(6716)] = 278918,
  [SMALL_STATE(6717)] = 278965,
  [SMALL_STATE(6718)] = 279012,
  [SMALL_STATE(6719)] = 279059,
  [SMALL_STATE(6720)] = 279106,
  [SMALL_STATE(6721)] = 279153,
  [SMALL_STATE(6722)] = 279200,
  [SMALL_STATE(6723)] = 279247,
  [SMALL_STATE(6724)] = 279294,
  [SMALL_STATE(6725)] = 279341,
  [SMALL_STATE(6726)] = 279388,
  [SMALL_STATE(6727)] = 279435,
  [SMALL_STATE(6728)] = 279482,
  [SMALL_STATE(6729)] = 279529,
  [SMALL_STATE(6730)] = 279576,
  [SMALL_STATE(6731)] = 279623,
  [SMALL_STATE(6732)] = 279670,
  [SMALL_STATE(6733)] = 279717,
  [SMALL_STATE(6734)] = 279764,
  [SMALL_STATE(6735)] = 279811,
  [SMALL_STATE(6736)] = 279858,
  [SMALL_STATE(6737)] = 279905,
  [SMALL_STATE(6738)] = 279952,
  [SMALL_STATE(6739)] = 279999,
  [SMALL_STATE(6740)] = 280046,
  [SMALL_STATE(6741)] = 280099,
  [SMALL_STATE(6742)] = 280146,
  [SMALL_STATE(6743)] = 280193,
  [SMALL_STATE(6744)] = 280246,
  [SMALL_STATE(6745)] = 280293,
  [SMALL_STATE(6746)] = 280340,
  [SMALL_STATE(6747)] = 280387,
  [SMALL_STATE(6748)] = 280434,
  [SMALL_STATE(6749)] = 280481,
  [SMALL_STATE(6750)] = 280528,
  [SMALL_STATE(6751)] = 280575,
  [SMALL_STATE(6752)] = 280622,
  [SMALL_STATE(6753)] = 280669,
  [SMALL_STATE(6754)] = 280716,
  [SMALL_STATE(6755)] = 280763,
  [SMALL_STATE(6756)] = 280810,
  [SMALL_STATE(6757)] = 280857,
  [SMALL_STATE(6758)] = 280904,
  [SMALL_STATE(6759)] = 280951,
  [SMALL_STATE(6760)] = 280998,
  [SMALL_STATE(6761)] = 281045,
  [SMALL_STATE(6762)] = 281092,
  [SMALL_STATE(6763)] = 281139,
  [SMALL_STATE(6764)] = 281186,
  [SMALL_STATE(6765)] = 281233,
  [SMALL_STATE(6766)] = 281280,
  [SMALL_STATE(6767)] = 281327,
  [SMALL_STATE(6768)] = 281374,
  [SMALL_STATE(6769)] = 281421,
  [SMALL_STATE(6770)] = 281468,
  [SMALL_STATE(6771)] = 281515,
  [SMALL_STATE(6772)] = 281562,
  [SMALL_STATE(6773)] = 281609,
  [SMALL_STATE(6774)] = 281656,
  [SMALL_STATE(6775)] = 281703,
  [SMALL_STATE(6776)] = 281750,
  [SMALL_STATE(6777)] = 281797,
  [SMALL_STATE(6778)] = 281844,
  [SMALL_STATE(6779)] = 281891,
  [SMALL_STATE(6780)] = 281944,
  [SMALL_STATE(6781)] = 281991,
  [SMALL_STATE(6782)] = 282038,
  [SMALL_STATE(6783)] = 282085,
  [SMALL_STATE(6784)] = 282132,
  [SMALL_STATE(6785)] = 282179,
  [SMALL_STATE(6786)] = 282226,
  [SMALL_STATE(6787)] = 282273,
  [SMALL_STATE(6788)] = 282320,
  [SMALL_STATE(6789)] = 282371,
  [SMALL_STATE(6790)] = 282418,
  [SMALL_STATE(6791)] = 282465,
  [SMALL_STATE(6792)] = 282512,
  [SMALL_STATE(6793)] = 282559,
  [SMALL_STATE(6794)] = 282606,
  [SMALL_STATE(6795)] = 282653,
  [SMALL_STATE(6796)] = 282700,
  [SMALL_STATE(6797)] = 282747,
  [SMALL_STATE(6798)] = 282794,
  [SMALL_STATE(6799)] = 282841,
  [SMALL_STATE(6800)] = 282888,
  [SMALL_STATE(6801)] = 282935,
  [SMALL_STATE(6802)] = 282982,
  [SMALL_STATE(6803)] = 283029,
  [SMALL_STATE(6804)] = 283076,
  [SMALL_STATE(6805)] = 283125,
  [SMALL_STATE(6806)] = 283178,
  [SMALL_STATE(6807)] = 283225,
  [SMALL_STATE(6808)] = 283272,
  [SMALL_STATE(6809)] = 283319,
  [SMALL_STATE(6810)] = 283366,
  [SMALL_STATE(6811)] = 283413,
  [SMALL_STATE(6812)] = 283460,
  [SMALL_STATE(6813)] = 283507,
  [SMALL_STATE(6814)] = 283554,
  [SMALL_STATE(6815)] = 283601,
  [SMALL_STATE(6816)] = 283648,
  [SMALL_STATE(6817)] = 283695,
  [SMALL_STATE(6818)] = 283742,
  [SMALL_STATE(6819)] = 283789,
  [SMALL_STATE(6820)] = 283836,
  [SMALL_STATE(6821)] = 283889,
  [SMALL_STATE(6822)] = 283936,
  [SMALL_STATE(6823)] = 283983,
  [SMALL_STATE(6824)] = 284036,
  [SMALL_STATE(6825)] = 284089,
  [SMALL_STATE(6826)] = 284136,
  [SMALL_STATE(6827)] = 284183,
  [SMALL_STATE(6828)] = 284230,
  [SMALL_STATE(6829)] = 284277,
  [SMALL_STATE(6830)] = 284330,
  [SMALL_STATE(6831)] = 284377,
  [SMALL_STATE(6832)] = 284424,
  [SMALL_STATE(6833)] = 284471,
  [SMALL_STATE(6834)] = 284524,
  [SMALL_STATE(6835)] = 284571,
  [SMALL_STATE(6836)] = 284618,
  [SMALL_STATE(6837)] = 284665,
  [SMALL_STATE(6838)] = 284712,
  [SMALL_STATE(6839)] = 284759,
  [SMALL_STATE(6840)] = 284806,
  [SMALL_STATE(6841)] = 284853,
  [SMALL_STATE(6842)] = 284904,
  [SMALL_STATE(6843)] = 284951,
  [SMALL_STATE(6844)] = 284998,
  [SMALL_STATE(6845)] = 285045,
  [SMALL_STATE(6846)] = 285092,
  [SMALL_STATE(6847)] = 285179,
  [SMALL_STATE(6848)] = 285230,
  [SMALL_STATE(6849)] = 285277,
  [SMALL_STATE(6850)] = 285323,
  [SMALL_STATE(6851)] = 285369,
  [SMALL_STATE(6852)] = 285415,
  [SMALL_STATE(6853)] = 285477,
  [SMALL_STATE(6854)] = 285523,
  [SMALL_STATE(6855)] = 285569,
  [SMALL_STATE(6856)] = 285615,
  [SMALL_STATE(6857)] = 285661,
  [SMALL_STATE(6858)] = 285707,
  [SMALL_STATE(6859)] = 285753,
  [SMALL_STATE(6860)] = 285799,
  [SMALL_STATE(6861)] = 285845,
  [SMALL_STATE(6862)] = 285891,
  [SMALL_STATE(6863)] = 285943,
  [SMALL_STATE(6864)] = 285989,
  [SMALL_STATE(6865)] = 286035,
  [SMALL_STATE(6866)] = 286087,
  [SMALL_STATE(6867)] = 286133,
  [SMALL_STATE(6868)] = 286179,
  [SMALL_STATE(6869)] = 286225,
  [SMALL_STATE(6870)] = 286271,
  [SMALL_STATE(6871)] = 286317,
  [SMALL_STATE(6872)] = 286369,
  [SMALL_STATE(6873)] = 286415,
  [SMALL_STATE(6874)] = 286461,
  [SMALL_STATE(6875)] = 286507,
  [SMALL_STATE(6876)] = 286559,
  [SMALL_STATE(6877)] = 286605,
  [SMALL_STATE(6878)] = 286651,
  [SMALL_STATE(6879)] = 286697,
  [SMALL_STATE(6880)] = 286743,
  [SMALL_STATE(6881)] = 286789,
  [SMALL_STATE(6882)] = 286835,
  [SMALL_STATE(6883)] = 286881,
  [SMALL_STATE(6884)] = 286927,
  [SMALL_STATE(6885)] = 286973,
  [SMALL_STATE(6886)] = 287019,
  [SMALL_STATE(6887)] = 287065,
  [SMALL_STATE(6888)] = 287111,
  [SMALL_STATE(6889)] = 287157,
  [SMALL_STATE(6890)] = 287203,
  [SMALL_STATE(6891)] = 287249,
  [SMALL_STATE(6892)] = 287295,
  [SMALL_STATE(6893)] = 287341,
  [SMALL_STATE(6894)] = 287387,
  [SMALL_STATE(6895)] = 287433,
  [SMALL_STATE(6896)] = 287485,
  [SMALL_STATE(6897)] = 287531,
  [SMALL_STATE(6898)] = 287577,
  [SMALL_STATE(6899)] = 287623,
  [SMALL_STATE(6900)] = 287669,
  [SMALL_STATE(6901)] = 287715,
  [SMALL_STATE(6902)] = 287761,
  [SMALL_STATE(6903)] = 287807,
  [SMALL_STATE(6904)] = 287853,
  [SMALL_STATE(6905)] = 287903,
  [SMALL_STATE(6906)] = 287949,
  [SMALL_STATE(6907)] = 287995,
  [SMALL_STATE(6908)] = 288041,
  [SMALL_STATE(6909)] = 288087,
  [SMALL_STATE(6910)] = 288133,
  [SMALL_STATE(6911)] = 288179,
  [SMALL_STATE(6912)] = 288225,
  [SMALL_STATE(6913)] = 288271,
  [SMALL_STATE(6914)] = 288317,
  [SMALL_STATE(6915)] = 288363,
  [SMALL_STATE(6916)] = 288415,
  [SMALL_STATE(6917)] = 288461,
  [SMALL_STATE(6918)] = 288507,
  [SMALL_STATE(6919)] = 288553,
  [SMALL_STATE(6920)] = 288599,
  [SMALL_STATE(6921)] = 288645,
  [SMALL_STATE(6922)] = 288691,
  [SMALL_STATE(6923)] = 288737,
  [SMALL_STATE(6924)] = 288783,
  [SMALL_STATE(6925)] = 288829,
  [SMALL_STATE(6926)] = 288875,
  [SMALL_STATE(6927)] = 288921,
  [SMALL_STATE(6928)] = 288967,
  [SMALL_STATE(6929)] = 289013,
  [SMALL_STATE(6930)] = 289059,
  [SMALL_STATE(6931)] = 289105,
  [SMALL_STATE(6932)] = 289151,
  [SMALL_STATE(6933)] = 289197,
  [SMALL_STATE(6934)] = 289243,
  [SMALL_STATE(6935)] = 289289,
  [SMALL_STATE(6936)] = 289335,
  [SMALL_STATE(6937)] = 289381,
  [SMALL_STATE(6938)] = 289427,
  [SMALL_STATE(6939)] = 289473,
  [SMALL_STATE(6940)] = 289519,
  [SMALL_STATE(6941)] = 289565,
  [SMALL_STATE(6942)] = 289611,
  [SMALL_STATE(6943)] = 289657,
  [SMALL_STATE(6944)] = 289703,
  [SMALL_STATE(6945)] = 289749,
  [SMALL_STATE(6946)] = 289795,
  [SMALL_STATE(6947)] = 289841,
  [SMALL_STATE(6948)] = 289887,
  [SMALL_STATE(6949)] = 289937,
  [SMALL_STATE(6950)] = 289983,
  [SMALL_STATE(6951)] = 290029,
  [SMALL_STATE(6952)] = 290075,
  [SMALL_STATE(6953)] = 290121,
  [SMALL_STATE(6954)] = 290167,
  [SMALL_STATE(6955)] = 290213,
  [SMALL_STATE(6956)] = 290259,
  [SMALL_STATE(6957)] = 290321,
  [SMALL_STATE(6958)] = 290367,
  [SMALL_STATE(6959)] = 290413,
  [SMALL_STATE(6960)] = 290459,
  [SMALL_STATE(6961)] = 290505,
  [SMALL_STATE(6962)] = 290551,
  [SMALL_STATE(6963)] = 290597,
  [SMALL_STATE(6964)] = 290647,
  [SMALL_STATE(6965)] = 290693,
  [SMALL_STATE(6966)] = 290739,
  [SMALL_STATE(6967)] = 290785,
  [SMALL_STATE(6968)] = 290831,
  [SMALL_STATE(6969)] = 290877,
  [SMALL_STATE(6970)] = 290923,
  [SMALL_STATE(6971)] = 290969,
  [SMALL_STATE(6972)] = 291015,
  [SMALL_STATE(6973)] = 291061,
  [SMALL_STATE(6974)] = 291113,
  [SMALL_STATE(6975)] = 291159,
  [SMALL_STATE(6976)] = 291205,
  [SMALL_STATE(6977)] = 291251,
  [SMALL_STATE(6978)] = 291297,
  [SMALL_STATE(6979)] = 291343,
  [SMALL_STATE(6980)] = 291395,
  [SMALL_STATE(6981)] = 291441,
  [SMALL_STATE(6982)] = 291487,
  [SMALL_STATE(6983)] = 291533,
  [SMALL_STATE(6984)] = 291595,
  [SMALL_STATE(6985)] = 291641,
  [SMALL_STATE(6986)] = 291687,
  [SMALL_STATE(6987)] = 291733,
  [SMALL_STATE(6988)] = 291779,
  [SMALL_STATE(6989)] = 291825,
  [SMALL_STATE(6990)] = 291871,
  [SMALL_STATE(6991)] = 291917,
  [SMALL_STATE(6992)] = 291963,
  [SMALL_STATE(6993)] = 292009,
  [SMALL_STATE(6994)] = 292055,
  [SMALL_STATE(6995)] = 292101,
  [SMALL_STATE(6996)] = 292147,
  [SMALL_STATE(6997)] = 292193,
  [SMALL_STATE(6998)] = 292239,
  [SMALL_STATE(6999)] = 292291,
  [SMALL_STATE(7000)] = 292341,
  [SMALL_STATE(7001)] = 292387,
  [SMALL_STATE(7002)] = 292433,
  [SMALL_STATE(7003)] = 292479,
  [SMALL_STATE(7004)] = 292525,
  [SMALL_STATE(7005)] = 292571,
  [SMALL_STATE(7006)] = 292617,
  [SMALL_STATE(7007)] = 292663,
  [SMALL_STATE(7008)] = 292709,
  [SMALL_STATE(7009)] = 292755,
  [SMALL_STATE(7010)] = 292801,
  [SMALL_STATE(7011)] = 292847,
  [SMALL_STATE(7012)] = 292893,
  [SMALL_STATE(7013)] = 292939,
  [SMALL_STATE(7014)] = 292985,
  [SMALL_STATE(7015)] = 293031,
  [SMALL_STATE(7016)] = 293083,
  [SMALL_STATE(7017)] = 293129,
  [SMALL_STATE(7018)] = 293191,
  [SMALL_STATE(7019)] = 293237,
  [SMALL_STATE(7020)] = 293283,
  [SMALL_STATE(7021)] = 293328,
  [SMALL_STATE(7022)] = 293373,
  [SMALL_STATE(7023)] = 293418,
  [SMALL_STATE(7024)] = 293463,
  [SMALL_STATE(7025)] = 293508,
  [SMALL_STATE(7026)] = 293553,
  [SMALL_STATE(7027)] = 293598,
  [SMALL_STATE(7028)] = 293643,
  [SMALL_STATE(7029)] = 293688,
  [SMALL_STATE(7030)] = 293733,
  [SMALL_STATE(7031)] = 293778,
  [SMALL_STATE(7032)] = 293823,
  [SMALL_STATE(7033)] = 293868,
  [SMALL_STATE(7034)] = 293913,
  [SMALL_STATE(7035)] = 293958,
  [SMALL_STATE(7036)] = 294003,
  [SMALL_STATE(7037)] = 294048,
  [SMALL_STATE(7038)] = 294093,
  [SMALL_STATE(7039)] = 294138,
  [SMALL_STATE(7040)] = 294189,
  [SMALL_STATE(7041)] = 294234,
  [SMALL_STATE(7042)] = 294279,
  [SMALL_STATE(7043)] = 294324,
  [SMALL_STATE(7044)] = 294369,
  [SMALL_STATE(7045)] = 294414,
  [SMALL_STATE(7046)] = 294459,
  [SMALL_STATE(7047)] = 294504,
  [SMALL_STATE(7048)] = 294549,
  [SMALL_STATE(7049)] = 294594,
  [SMALL_STATE(7050)] = 294639,
  [SMALL_STATE(7051)] = 294684,
  [SMALL_STATE(7052)] = 294729,
  [SMALL_STATE(7053)] = 294774,
  [SMALL_STATE(7054)] = 294819,
  [SMALL_STATE(7055)] = 294870,
  [SMALL_STATE(7056)] = 294915,
  [SMALL_STATE(7057)] = 294960,
  [SMALL_STATE(7058)] = 295005,
  [SMALL_STATE(7059)] = 295050,
  [SMALL_STATE(7060)] = 295095,
  [SMALL_STATE(7061)] = 295140,
  [SMALL_STATE(7062)] = 295185,
  [SMALL_STATE(7063)] = 295230,
  [SMALL_STATE(7064)] = 295275,
  [SMALL_STATE(7065)] = 295320,
  [SMALL_STATE(7066)] = 295365,
  [SMALL_STATE(7067)] = 295410,
  [SMALL_STATE(7068)] = 295455,
  [SMALL_STATE(7069)] = 295500,
  [SMALL_STATE(7070)] = 295545,
  [SMALL_STATE(7071)] = 295590,
  [SMALL_STATE(7072)] = 295635,
  [SMALL_STATE(7073)] = 295680,
  [SMALL_STATE(7074)] = 295725,
  [SMALL_STATE(7075)] = 295770,
  [SMALL_STATE(7076)] = 295815,
  [SMALL_STATE(7077)] = 295860,
  [SMALL_STATE(7078)] = 295905,
  [SMALL_STATE(7079)] = 295950,
  [SMALL_STATE(7080)] = 295995,
  [SMALL_STATE(7081)] = 296040,
  [SMALL_STATE(7082)] = 296085,
  [SMALL_STATE(7083)] = 296130,
  [SMALL_STATE(7084)] = 296175,
  [SMALL_STATE(7085)] = 296220,
  [SMALL_STATE(7086)] = 296301,
  [SMALL_STATE(7087)] = 296346,
  [SMALL_STATE(7088)] = 296391,
  [SMALL_STATE(7089)] = 296436,
  [SMALL_STATE(7090)] = 296481,
  [SMALL_STATE(7091)] = 296526,
  [SMALL_STATE(7092)] = 296571,
  [SMALL_STATE(7093)] = 296616,
  [SMALL_STATE(7094)] = 296661,
  [SMALL_STATE(7095)] = 296706,
  [SMALL_STATE(7096)] = 296751,
  [SMALL_STATE(7097)] = 296796,
  [SMALL_STATE(7098)] = 296841,
  [SMALL_STATE(7099)] = 296886,
  [SMALL_STATE(7100)] = 296967,
  [SMALL_STATE(7101)] = 297018,
  [SMALL_STATE(7102)] = 297063,
  [SMALL_STATE(7103)] = 297108,
  [SMALL_STATE(7104)] = 297153,
  [SMALL_STATE(7105)] = 297198,
  [SMALL_STATE(7106)] = 297291,
  [SMALL_STATE(7107)] = 297372,
  [SMALL_STATE(7108)] = 297417,
  [SMALL_STATE(7109)] = 297462,
  [SMALL_STATE(7110)] = 297507,
  [SMALL_STATE(7111)] = 297552,
  [SMALL_STATE(7112)] = 297597,
  [SMALL_STATE(7113)] = 297642,
  [SMALL_STATE(7114)] = 297687,
  [SMALL_STATE(7115)] = 297732,
  [SMALL_STATE(7116)] = 297777,
  [SMALL_STATE(7117)] = 297830,
  [SMALL_STATE(7118)] = 297911,
  [SMALL_STATE(7119)] = 297962,
  [SMALL_STATE(7120)] = 298013,
  [SMALL_STATE(7121)] = 298058,
  [SMALL_STATE(7122)] = 298103,
  [SMALL_STATE(7123)] = 298148,
  [SMALL_STATE(7124)] = 298193,
  [SMALL_STATE(7125)] = 298238,
  [SMALL_STATE(7126)] = 298283,
  [SMALL_STATE(7127)] = 298328,
  [SMALL_STATE(7128)] = 298377,
  [SMALL_STATE(7129)] = 298422,
  [SMALL_STATE(7130)] = 298467,
  [SMALL_STATE(7131)] = 298512,
  [SMALL_STATE(7132)] = 298557,
  [SMALL_STATE(7133)] = 298602,
  [SMALL_STATE(7134)] = 298647,
  [SMALL_STATE(7135)] = 298692,
  [SMALL_STATE(7136)] = 298737,
  [SMALL_STATE(7137)] = 298782,
  [SMALL_STATE(7138)] = 298827,
  [SMALL_STATE(7139)] = 298872,
  [SMALL_STATE(7140)] = 298917,
  [SMALL_STATE(7141)] = 298962,
  [SMALL_STATE(7142)] = 299007,
  [SMALL_STATE(7143)] = 299052,
  [SMALL_STATE(7144)] = 299097,
  [SMALL_STATE(7145)] = 299142,
  [SMALL_STATE(7146)] = 299187,
  [SMALL_STATE(7147)] = 299232,
  [SMALL_STATE(7148)] = 299277,
  [SMALL_STATE(7149)] = 299322,
  [SMALL_STATE(7150)] = 299367,
  [SMALL_STATE(7151)] = 299412,
  [SMALL_STATE(7152)] = 299457,
  [SMALL_STATE(7153)] = 299502,
  [SMALL_STATE(7154)] = 299547,
  [SMALL_STATE(7155)] = 299592,
  [SMALL_STATE(7156)] = 299637,
  [SMALL_STATE(7157)] = 299682,
  [SMALL_STATE(7158)] = 299727,
  [SMALL_STATE(7159)] = 299808,
  [SMALL_STATE(7160)] = 299853,
  [SMALL_STATE(7161)] = 299898,
  [SMALL_STATE(7162)] = 299943,
  [SMALL_STATE(7163)] = 299988,
  [SMALL_STATE(7164)] = 300033,
  [SMALL_STATE(7165)] = 300078,
  [SMALL_STATE(7166)] = 300159,
  [SMALL_STATE(7167)] = 300204,
  [SMALL_STATE(7168)] = 300249,
  [SMALL_STATE(7169)] = 300294,
  [SMALL_STATE(7170)] = 300343,
  [SMALL_STATE(7171)] = 300388,
  [SMALL_STATE(7172)] = 300433,
  [SMALL_STATE(7173)] = 300478,
  [SMALL_STATE(7174)] = 300523,
  [SMALL_STATE(7175)] = 300568,
  [SMALL_STATE(7176)] = 300613,
  [SMALL_STATE(7177)] = 300658,
  [SMALL_STATE(7178)] = 300703,
  [SMALL_STATE(7179)] = 300754,
  [SMALL_STATE(7180)] = 300799,
  [SMALL_STATE(7181)] = 300844,
  [SMALL_STATE(7182)] = 300895,
  [SMALL_STATE(7183)] = 300940,
  [SMALL_STATE(7184)] = 300985,
  [SMALL_STATE(7185)] = 301030,
  [SMALL_STATE(7186)] = 301075,
  [SMALL_STATE(7187)] = 301120,
  [SMALL_STATE(7188)] = 301165,
  [SMALL_STATE(7189)] = 301210,
  [SMALL_STATE(7190)] = 301255,
  [SMALL_STATE(7191)] = 301300,
  [SMALL_STATE(7192)] = 301345,
  [SMALL_STATE(7193)] = 301390,
  [SMALL_STATE(7194)] = 301435,
  [SMALL_STATE(7195)] = 301480,
  [SMALL_STATE(7196)] = 301529,
  [SMALL_STATE(7197)] = 301574,
  [SMALL_STATE(7198)] = 301625,
  [SMALL_STATE(7199)] = 301676,
  [SMALL_STATE(7200)] = 301721,
  [SMALL_STATE(7201)] = 301766,
  [SMALL_STATE(7202)] = 301817,
  [SMALL_STATE(7203)] = 301868,
  [SMALL_STATE(7204)] = 301912,
  [SMALL_STATE(7205)] = 301956,
  [SMALL_STATE(7206)] = 302000,
  [SMALL_STATE(7207)] = 302044,
  [SMALL_STATE(7208)] = 302088,
  [SMALL_STATE(7209)] = 302156,
  [SMALL_STATE(7210)] = 302200,
  [SMALL_STATE(7211)] = 302244,
  [SMALL_STATE(7212)] = 302312,
  [SMALL_STATE(7213)] = 302356,
  [SMALL_STATE(7214)] = 302424,
  [SMALL_STATE(7215)] = 302468,
  [SMALL_STATE(7216)] = 302512,
  [SMALL_STATE(7217)] = 302556,
  [SMALL_STATE(7218)] = 302624,
  [SMALL_STATE(7219)] = 302668,
  [SMALL_STATE(7220)] = 302712,
  [SMALL_STATE(7221)] = 302756,
  [SMALL_STATE(7222)] = 302824,
  [SMALL_STATE(7223)] = 302868,
  [SMALL_STATE(7224)] = 302912,
  [SMALL_STATE(7225)] = 302956,
  [SMALL_STATE(7226)] = 303000,
  [SMALL_STATE(7227)] = 303044,
  [SMALL_STATE(7228)] = 303112,
  [SMALL_STATE(7229)] = 303156,
  [SMALL_STATE(7230)] = 303200,
  [SMALL_STATE(7231)] = 303244,
  [SMALL_STATE(7232)] = 303312,
  [SMALL_STATE(7233)] = 303356,
  [SMALL_STATE(7234)] = 303400,
  [SMALL_STATE(7235)] = 303444,
  [SMALL_STATE(7236)] = 303488,
  [SMALL_STATE(7237)] = 303532,
  [SMALL_STATE(7238)] = 303576,
  [SMALL_STATE(7239)] = 303620,
  [SMALL_STATE(7240)] = 303664,
  [SMALL_STATE(7241)] = 303708,
  [SMALL_STATE(7242)] = 303752,
  [SMALL_STATE(7243)] = 303796,
  [SMALL_STATE(7244)] = 303840,
  [SMALL_STATE(7245)] = 303884,
  [SMALL_STATE(7246)] = 303928,
  [SMALL_STATE(7247)] = 303972,
  [SMALL_STATE(7248)] = 304016,
  [SMALL_STATE(7249)] = 304060,
  [SMALL_STATE(7250)] = 304104,
  [SMALL_STATE(7251)] = 304172,
  [SMALL_STATE(7252)] = 304216,
  [SMALL_STATE(7253)] = 304260,
  [SMALL_STATE(7254)] = 304304,
  [SMALL_STATE(7255)] = 304372,
  [SMALL_STATE(7256)] = 304416,
  [SMALL_STATE(7257)] = 304460,
  [SMALL_STATE(7258)] = 304504,
  [SMALL_STATE(7259)] = 304548,
  [SMALL_STATE(7260)] = 304592,
  [SMALL_STATE(7261)] = 304660,
  [SMALL_STATE(7262)] = 304704,
  [SMALL_STATE(7263)] = 304748,
  [SMALL_STATE(7264)] = 304816,
  [SMALL_STATE(7265)] = 304866,
  [SMALL_STATE(7266)] = 304910,
  [SMALL_STATE(7267)] = 304978,
  [SMALL_STATE(7268)] = 305022,
  [SMALL_STATE(7269)] = 305066,
  [SMALL_STATE(7270)] = 305110,
  [SMALL_STATE(7271)] = 305178,
  [SMALL_STATE(7272)] = 305222,
  [SMALL_STATE(7273)] = 305290,
  [SMALL_STATE(7274)] = 305334,
  [SMALL_STATE(7275)] = 305378,
  [SMALL_STATE(7276)] = 305422,
  [SMALL_STATE(7277)] = 305466,
  [SMALL_STATE(7278)] = 305510,
  [SMALL_STATE(7279)] = 305560,
  [SMALL_STATE(7280)] = 305628,
  [SMALL_STATE(7281)] = 305672,
  [SMALL_STATE(7282)] = 305716,
  [SMALL_STATE(7283)] = 305760,
  [SMALL_STATE(7284)] = 305810,
  [SMALL_STATE(7285)] = 305854,
  [SMALL_STATE(7286)] = 305898,
  [SMALL_STATE(7287)] = 305942,
  [SMALL_STATE(7288)] = 305986,
  [SMALL_STATE(7289)] = 306030,
  [SMALL_STATE(7290)] = 306098,
  [SMALL_STATE(7291)] = 306142,
  [SMALL_STATE(7292)] = 306186,
  [SMALL_STATE(7293)] = 306254,
  [SMALL_STATE(7294)] = 306322,
  [SMALL_STATE(7295)] = 306370,
  [SMALL_STATE(7296)] = 306414,
  [SMALL_STATE(7297)] = 306458,
  [SMALL_STATE(7298)] = 306502,
  [SMALL_STATE(7299)] = 306546,
  [SMALL_STATE(7300)] = 306590,
  [SMALL_STATE(7301)] = 306634,
  [SMALL_STATE(7302)] = 306678,
  [SMALL_STATE(7303)] = 306722,
  [SMALL_STATE(7304)] = 306790,
  [SMALL_STATE(7305)] = 306834,
  [SMALL_STATE(7306)] = 306878,
  [SMALL_STATE(7307)] = 306946,
  [SMALL_STATE(7308)] = 306990,
  [SMALL_STATE(7309)] = 307034,
  [SMALL_STATE(7310)] = 307078,
  [SMALL_STATE(7311)] = 307146,
  [SMALL_STATE(7312)] = 307214,
  [SMALL_STATE(7313)] = 307258,
  [SMALL_STATE(7314)] = 307326,
  [SMALL_STATE(7315)] = 307370,
  [SMALL_STATE(7316)] = 307414,
  [SMALL_STATE(7317)] = 307458,
  [SMALL_STATE(7318)] = 307526,
  [SMALL_STATE(7319)] = 307570,
  [SMALL_STATE(7320)] = 307614,
  [SMALL_STATE(7321)] = 307658,
  [SMALL_STATE(7322)] = 307702,
  [SMALL_STATE(7323)] = 307770,
  [SMALL_STATE(7324)] = 307838,
  [SMALL_STATE(7325)] = 307882,
  [SMALL_STATE(7326)] = 307926,
  [SMALL_STATE(7327)] = 307970,
  [SMALL_STATE(7328)] = 308014,
  [SMALL_STATE(7329)] = 308082,
  [SMALL_STATE(7330)] = 308126,
  [SMALL_STATE(7331)] = 308170,
  [SMALL_STATE(7332)] = 308214,
  [SMALL_STATE(7333)] = 308258,
  [SMALL_STATE(7334)] = 308302,
  [SMALL_STATE(7335)] = 308370,
  [SMALL_STATE(7336)] = 308414,
  [SMALL_STATE(7337)] = 308464,
  [SMALL_STATE(7338)] = 308508,
  [SMALL_STATE(7339)] = 308552,
  [SMALL_STATE(7340)] = 308596,
  [SMALL_STATE(7341)] = 308640,
  [SMALL_STATE(7342)] = 308684,
  [SMALL_STATE(7343)] = 308728,
  [SMALL_STATE(7344)] = 308796,
  [SMALL_STATE(7345)] = 308840,
  [SMALL_STATE(7346)] = 308908,
  [SMALL_STATE(7347)] = 308976,
  [SMALL_STATE(7348)] = 309044,
  [SMALL_STATE(7349)] = 309088,
  [SMALL_STATE(7350)] = 309132,
  [SMALL_STATE(7351)] = 309200,
  [SMALL_STATE(7352)] = 309244,
  [SMALL_STATE(7353)] = 309288,
  [SMALL_STATE(7354)] = 309332,
  [SMALL_STATE(7355)] = 309376,
  [SMALL_STATE(7356)] = 309420,
  [SMALL_STATE(7357)] = 309464,
  [SMALL_STATE(7358)] = 309532,
  [SMALL_STATE(7359)] = 309576,
  [SMALL_STATE(7360)] = 309620,
  [SMALL_STATE(7361)] = 309664,
  [SMALL_STATE(7362)] = 309708,
  [SMALL_STATE(7363)] = 309752,
  [SMALL_STATE(7364)] = 309796,
  [SMALL_STATE(7365)] = 309864,
  [SMALL_STATE(7366)] = 309908,
  [SMALL_STATE(7367)] = 309952,
  [SMALL_STATE(7368)] = 309996,
  [SMALL_STATE(7369)] = 310040,
  [SMALL_STATE(7370)] = 310108,
  [SMALL_STATE(7371)] = 310152,
  [SMALL_STATE(7372)] = 310196,
  [SMALL_STATE(7373)] = 310240,
  [SMALL_STATE(7374)] = 310284,
  [SMALL_STATE(7375)] = 310328,
  [SMALL_STATE(7376)] = 310372,
  [SMALL_STATE(7377)] = 310416,
  [SMALL_STATE(7378)] = 310460,
  [SMALL_STATE(7379)] = 310528,
  [SMALL_STATE(7380)] = 310572,
  [SMALL_STATE(7381)] = 310622,
  [SMALL_STATE(7382)] = 310666,
  [SMALL_STATE(7383)] = 310710,
  [SMALL_STATE(7384)] = 310754,
  [SMALL_STATE(7385)] = 310798,
  [SMALL_STATE(7386)] = 310866,
  [SMALL_STATE(7387)] = 310934,
  [SMALL_STATE(7388)] = 310978,
  [SMALL_STATE(7389)] = 311022,
  [SMALL_STATE(7390)] = 311072,
  [SMALL_STATE(7391)] = 311140,
  [SMALL_STATE(7392)] = 311184,
  [SMALL_STATE(7393)] = 311228,
  [SMALL_STATE(7394)] = 311272,
  [SMALL_STATE(7395)] = 311316,
  [SMALL_STATE(7396)] = 311360,
  [SMALL_STATE(7397)] = 311428,
  [SMALL_STATE(7398)] = 311472,
  [SMALL_STATE(7399)] = 311516,
  [SMALL_STATE(7400)] = 311564,
  [SMALL_STATE(7401)] = 311608,
  [SMALL_STATE(7402)] = 311676,
  [SMALL_STATE(7403)] = 311720,
  [SMALL_STATE(7404)] = 311768,
  [SMALL_STATE(7405)] = 311812,
  [SMALL_STATE(7406)] = 311856,
  [SMALL_STATE(7407)] = 311900,
  [SMALL_STATE(7408)] = 311968,
  [SMALL_STATE(7409)] = 312012,
  [SMALL_STATE(7410)] = 312056,
  [SMALL_STATE(7411)] = 312100,
  [SMALL_STATE(7412)] = 312168,
  [SMALL_STATE(7413)] = 312212,
  [SMALL_STATE(7414)] = 312256,
  [SMALL_STATE(7415)] = 312300,
  [SMALL_STATE(7416)] = 312344,
  [SMALL_STATE(7417)] = 312388,
  [SMALL_STATE(7418)] = 312432,
  [SMALL_STATE(7419)] = 312476,
  [SMALL_STATE(7420)] = 312520,
  [SMALL_STATE(7421)] = 312564,
  [SMALL_STATE(7422)] = 312632,
  [SMALL_STATE(7423)] = 312700,
  [SMALL_STATE(7424)] = 312744,
  [SMALL_STATE(7425)] = 312788,
  [SMALL_STATE(7426)] = 312832,
  [SMALL_STATE(7427)] = 312876,
  [SMALL_STATE(7428)] = 312920,
  [SMALL_STATE(7429)] = 312964,
  [SMALL_STATE(7430)] = 313008,
  [SMALL_STATE(7431)] = 313076,
  [SMALL_STATE(7432)] = 313120,
  [SMALL_STATE(7433)] = 313164,
  [SMALL_STATE(7434)] = 313208,
  [SMALL_STATE(7435)] = 313252,
  [SMALL_STATE(7436)] = 313296,
  [SMALL_STATE(7437)] = 313340,
  [SMALL_STATE(7438)] = 313384,
  [SMALL_STATE(7439)] = 313428,
  [SMALL_STATE(7440)] = 313472,
  [SMALL_STATE(7441)] = 313540,
  [SMALL_STATE(7442)] = 313584,
  [SMALL_STATE(7443)] = 313628,
  [SMALL_STATE(7444)] = 313678,
  [SMALL_STATE(7445)] = 313722,
  [SMALL_STATE(7446)] = 313766,
  [SMALL_STATE(7447)] = 313810,
  [SMALL_STATE(7448)] = 313854,
  [SMALL_STATE(7449)] = 313898,
  [SMALL_STATE(7450)] = 313966,
  [SMALL_STATE(7451)] = 314010,
  [SMALL_STATE(7452)] = 314054,
  [SMALL_STATE(7453)] = 314098,
  [SMALL_STATE(7454)] = 314142,
  [SMALL_STATE(7455)] = 314186,
  [SMALL_STATE(7456)] = 314230,
  [SMALL_STATE(7457)] = 314298,
  [SMALL_STATE(7458)] = 314366,
  [SMALL_STATE(7459)] = 314410,
  [SMALL_STATE(7460)] = 314460,
  [SMALL_STATE(7461)] = 314528,
  [SMALL_STATE(7462)] = 314572,
  [SMALL_STATE(7463)] = 314616,
  [SMALL_STATE(7464)] = 314660,
  [SMALL_STATE(7465)] = 314704,
  [SMALL_STATE(7466)] = 314748,
  [SMALL_STATE(7467)] = 314792,
  [SMALL_STATE(7468)] = 314860,
  [SMALL_STATE(7469)] = 314904,
  [SMALL_STATE(7470)] = 314972,
  [SMALL_STATE(7471)] = 315016,
  [SMALL_STATE(7472)] = 315084,
  [SMALL_STATE(7473)] = 315134,
  [SMALL_STATE(7474)] = 315178,
  [SMALL_STATE(7475)] = 315246,
  [SMALL_STATE(7476)] = 315290,
  [SMALL_STATE(7477)] = 315334,
  [SMALL_STATE(7478)] = 315378,
  [SMALL_STATE(7479)] = 315446,
  [SMALL_STATE(7480)] = 315514,
  [SMALL_STATE(7481)] = 315582,
  [SMALL_STATE(7482)] = 315626,
  [SMALL_STATE(7483)] = 315670,
  [SMALL_STATE(7484)] = 315714,
  [SMALL_STATE(7485)] = 315758,
  [SMALL_STATE(7486)] = 315802,
  [SMALL_STATE(7487)] = 315870,
  [SMALL_STATE(7488)] = 315945,
  [SMALL_STATE(7489)] = 315988,
  [SMALL_STATE(7490)] = 316031,
  [SMALL_STATE(7491)] = 316074,
  [SMALL_STATE(7492)] = 316117,
  [SMALL_STATE(7493)] = 316160,
  [SMALL_STATE(7494)] = 316235,
  [SMALL_STATE(7495)] = 316278,
  [SMALL_STATE(7496)] = 316325,
  [SMALL_STATE(7497)] = 316372,
  [SMALL_STATE(7498)] = 316415,
  [SMALL_STATE(7499)] = 316458,
  [SMALL_STATE(7500)] = 316533,
  [SMALL_STATE(7501)] = 316576,
  [SMALL_STATE(7502)] = 316623,
  [SMALL_STATE(7503)] = 316666,
  [SMALL_STATE(7504)] = 316709,
  [SMALL_STATE(7505)] = 316784,
  [SMALL_STATE(7506)] = 316827,
  [SMALL_STATE(7507)] = 316870,
  [SMALL_STATE(7508)] = 316919,
  [SMALL_STATE(7509)] = 316994,
  [SMALL_STATE(7510)] = 317037,
  [SMALL_STATE(7511)] = 317080,
  [SMALL_STATE(7512)] = 317123,
  [SMALL_STATE(7513)] = 317166,
  [SMALL_STATE(7514)] = 317209,
  [SMALL_STATE(7515)] = 317252,
  [SMALL_STATE(7516)] = 317295,
  [SMALL_STATE(7517)] = 317338,
  [SMALL_STATE(7518)] = 317381,
  [SMALL_STATE(7519)] = 317424,
  [SMALL_STATE(7520)] = 317467,
  [SMALL_STATE(7521)] = 317510,
  [SMALL_STATE(7522)] = 317585,
  [SMALL_STATE(7523)] = 317628,
  [SMALL_STATE(7524)] = 317671,
  [SMALL_STATE(7525)] = 317714,
  [SMALL_STATE(7526)] = 317757,
  [SMALL_STATE(7527)] = 317800,
  [SMALL_STATE(7528)] = 317843,
  [SMALL_STATE(7529)] = 317886,
  [SMALL_STATE(7530)] = 317939,
  [SMALL_STATE(7531)] = 317982,
  [SMALL_STATE(7532)] = 318059,
  [SMALL_STATE(7533)] = 318136,
  [SMALL_STATE(7534)] = 318179,
  [SMALL_STATE(7535)] = 318222,
  [SMALL_STATE(7536)] = 318269,
  [SMALL_STATE(7537)] = 318312,
  [SMALL_STATE(7538)] = 318355,
  [SMALL_STATE(7539)] = 318398,
  [SMALL_STATE(7540)] = 318441,
  [SMALL_STATE(7541)] = 318484,
  [SMALL_STATE(7542)] = 318527,
  [SMALL_STATE(7543)] = 318570,
  [SMALL_STATE(7544)] = 318613,
  [SMALL_STATE(7545)] = 318656,
  [SMALL_STATE(7546)] = 318699,
  [SMALL_STATE(7547)] = 318742,
  [SMALL_STATE(7548)] = 318789,
  [SMALL_STATE(7549)] = 318832,
  [SMALL_STATE(7550)] = 318875,
  [SMALL_STATE(7551)] = 318918,
  [SMALL_STATE(7552)] = 318961,
  [SMALL_STATE(7553)] = 319004,
  [SMALL_STATE(7554)] = 319047,
  [SMALL_STATE(7555)] = 319090,
  [SMALL_STATE(7556)] = 319132,
  [SMALL_STATE(7557)] = 319174,
  [SMALL_STATE(7558)] = 319248,
  [SMALL_STATE(7559)] = 319322,
  [SMALL_STATE(7560)] = 319364,
  [SMALL_STATE(7561)] = 319406,
  [SMALL_STATE(7562)] = 319448,
  [SMALL_STATE(7563)] = 319490,
  [SMALL_STATE(7564)] = 319532,
  [SMALL_STATE(7565)] = 319574,
  [SMALL_STATE(7566)] = 319624,
  [SMALL_STATE(7567)] = 319666,
  [SMALL_STATE(7568)] = 319708,
  [SMALL_STATE(7569)] = 319750,
  [SMALL_STATE(7570)] = 319792,
  [SMALL_STATE(7571)] = 319866,
  [SMALL_STATE(7572)] = 319908,
  [SMALL_STATE(7573)] = 319950,
  [SMALL_STATE(7574)] = 319996,
  [SMALL_STATE(7575)] = 320038,
  [SMALL_STATE(7576)] = 320126,
  [SMALL_STATE(7577)] = 320168,
  [SMALL_STATE(7578)] = 320210,
  [SMALL_STATE(7579)] = 320252,
  [SMALL_STATE(7580)] = 320294,
  [SMALL_STATE(7581)] = 320336,
  [SMALL_STATE(7582)] = 320378,
  [SMALL_STATE(7583)] = 320420,
  [SMALL_STATE(7584)] = 320462,
  [SMALL_STATE(7585)] = 320504,
  [SMALL_STATE(7586)] = 320546,
  [SMALL_STATE(7587)] = 320588,
  [SMALL_STATE(7588)] = 320630,
  [SMALL_STATE(7589)] = 320704,
  [SMALL_STATE(7590)] = 320746,
  [SMALL_STATE(7591)] = 320788,
  [SMALL_STATE(7592)] = 320830,
  [SMALL_STATE(7593)] = 320872,
  [SMALL_STATE(7594)] = 320914,
  [SMALL_STATE(7595)] = 320956,
  [SMALL_STATE(7596)] = 320998,
  [SMALL_STATE(7597)] = 321040,
  [SMALL_STATE(7598)] = 321090,
  [SMALL_STATE(7599)] = 321132,
  [SMALL_STATE(7600)] = 321206,
  [SMALL_STATE(7601)] = 321248,
  [SMALL_STATE(7602)] = 321290,
  [SMALL_STATE(7603)] = 321332,
  [SMALL_STATE(7604)] = 321374,
  [SMALL_STATE(7605)] = 321416,
  [SMALL_STATE(7606)] = 321490,
  [SMALL_STATE(7607)] = 321540,
  [SMALL_STATE(7608)] = 321582,
  [SMALL_STATE(7609)] = 321668,
  [SMALL_STATE(7610)] = 321710,
  [SMALL_STATE(7611)] = 321752,
  [SMALL_STATE(7612)] = 321794,
  [SMALL_STATE(7613)] = 321836,
  [SMALL_STATE(7614)] = 321878,
  [SMALL_STATE(7615)] = 321920,
  [SMALL_STATE(7616)] = 321962,
  [SMALL_STATE(7617)] = 322004,
  [SMALL_STATE(7618)] = 322046,
  [SMALL_STATE(7619)] = 322096,
  [SMALL_STATE(7620)] = 322138,
  [SMALL_STATE(7621)] = 322188,
  [SMALL_STATE(7622)] = 322231,
  [SMALL_STATE(7623)] = 322272,
  [SMALL_STATE(7624)] = 322313,
  [SMALL_STATE(7625)] = 322360,
  [SMALL_STATE(7626)] = 322421,
  [SMALL_STATE(7627)] = 322462,
  [SMALL_STATE(7628)] = 322503,
  [SMALL_STATE(7629)] = 322544,
  [SMALL_STATE(7630)] = 322585,
  [SMALL_STATE(7631)] = 322626,
  [SMALL_STATE(7632)] = 322667,
  [SMALL_STATE(7633)] = 322708,
  [SMALL_STATE(7634)] = 322769,
  [SMALL_STATE(7635)] = 322810,
  [SMALL_STATE(7636)] = 322857,
  [SMALL_STATE(7637)] = 322898,
  [SMALL_STATE(7638)] = 322939,
  [SMALL_STATE(7639)] = 322982,
  [SMALL_STATE(7640)] = 323029,
  [SMALL_STATE(7641)] = 323076,
  [SMALL_STATE(7642)] = 323117,
  [SMALL_STATE(7643)] = 323158,
  [SMALL_STATE(7644)] = 323199,
  [SMALL_STATE(7645)] = 323240,
  [SMALL_STATE(7646)] = 323283,
  [SMALL_STATE(7647)] = 323324,
  [SMALL_STATE(7648)] = 323395,
  [SMALL_STATE(7649)] = 323436,
  [SMALL_STATE(7650)] = 323477,
  [SMALL_STATE(7651)] = 323518,
  [SMALL_STATE(7652)] = 323559,
  [SMALL_STATE(7653)] = 323600,
  [SMALL_STATE(7654)] = 323641,
  [SMALL_STATE(7655)] = 323682,
  [SMALL_STATE(7656)] = 323723,
  [SMALL_STATE(7657)] = 323764,
  [SMALL_STATE(7658)] = 323805,
  [SMALL_STATE(7659)] = 323850,
  [SMALL_STATE(7660)] = 323891,
  [SMALL_STATE(7661)] = 323932,
  [SMALL_STATE(7662)] = 323977,
  [SMALL_STATE(7663)] = 324018,
  [SMALL_STATE(7664)] = 324059,
  [SMALL_STATE(7665)] = 324100,
  [SMALL_STATE(7666)] = 324141,
  [SMALL_STATE(7667)] = 324182,
  [SMALL_STATE(7668)] = 324243,
  [SMALL_STATE(7669)] = 324284,
  [SMALL_STATE(7670)] = 324345,
  [SMALL_STATE(7671)] = 324386,
  [SMALL_STATE(7672)] = 324447,
  [SMALL_STATE(7673)] = 324488,
  [SMALL_STATE(7674)] = 324541,
  [SMALL_STATE(7675)] = 324582,
  [SMALL_STATE(7676)] = 324623,
  [SMALL_STATE(7677)] = 324664,
  [SMALL_STATE(7678)] = 324705,
  [SMALL_STATE(7679)] = 324746,
  [SMALL_STATE(7680)] = 324787,
  [SMALL_STATE(7681)] = 324828,
  [SMALL_STATE(7682)] = 324869,
  [SMALL_STATE(7683)] = 324910,
  [SMALL_STATE(7684)] = 324951,
  [SMALL_STATE(7685)] = 324992,
  [SMALL_STATE(7686)] = 325033,
  [SMALL_STATE(7687)] = 325074,
  [SMALL_STATE(7688)] = 325115,
  [SMALL_STATE(7689)] = 325176,
  [SMALL_STATE(7690)] = 325217,
  [SMALL_STATE(7691)] = 325258,
  [SMALL_STATE(7692)] = 325299,
  [SMALL_STATE(7693)] = 325340,
  [SMALL_STATE(7694)] = 325381,
  [SMALL_STATE(7695)] = 325422,
  [SMALL_STATE(7696)] = 325463,
  [SMALL_STATE(7697)] = 325504,
  [SMALL_STATE(7698)] = 325545,
  [SMALL_STATE(7699)] = 325586,
  [SMALL_STATE(7700)] = 325627,
  [SMALL_STATE(7701)] = 325712,
  [SMALL_STATE(7702)] = 325753,
  [SMALL_STATE(7703)] = 325794,
  [SMALL_STATE(7704)] = 325835,
  [SMALL_STATE(7705)] = 325876,
  [SMALL_STATE(7706)] = 325917,
  [SMALL_STATE(7707)] = 325958,
  [SMALL_STATE(7708)] = 326029,
  [SMALL_STATE(7709)] = 326076,
  [SMALL_STATE(7710)] = 326117,
  [SMALL_STATE(7711)] = 326158,
  [SMALL_STATE(7712)] = 326201,
  [SMALL_STATE(7713)] = 326242,
  [SMALL_STATE(7714)] = 326303,
  [SMALL_STATE(7715)] = 326344,
  [SMALL_STATE(7716)] = 326391,
  [SMALL_STATE(7717)] = 326432,
  [SMALL_STATE(7718)] = 326473,
  [SMALL_STATE(7719)] = 326514,
  [SMALL_STATE(7720)] = 326561,
  [SMALL_STATE(7721)] = 326602,
  [SMALL_STATE(7722)] = 326643,
  [SMALL_STATE(7723)] = 326684,
  [SMALL_STATE(7724)] = 326769,
  [SMALL_STATE(7725)] = 326810,
  [SMALL_STATE(7726)] = 326895,
  [SMALL_STATE(7727)] = 326935,
  [SMALL_STATE(7728)] = 326979,
  [SMALL_STATE(7729)] = 327047,
  [SMALL_STATE(7730)] = 327087,
  [SMALL_STATE(7731)] = 327127,
  [SMALL_STATE(7732)] = 327167,
  [SMALL_STATE(7733)] = 327207,
  [SMALL_STATE(7734)] = 327247,
  [SMALL_STATE(7735)] = 327287,
  [SMALL_STATE(7736)] = 327327,
  [SMALL_STATE(7737)] = 327367,
  [SMALL_STATE(7738)] = 327413,
  [SMALL_STATE(7739)] = 327453,
  [SMALL_STATE(7740)] = 327527,
  [SMALL_STATE(7741)] = 327571,
  [SMALL_STATE(7742)] = 327611,
  [SMALL_STATE(7743)] = 327651,
  [SMALL_STATE(7744)] = 327697,
  [SMALL_STATE(7745)] = 327737,
  [SMALL_STATE(7746)] = 327777,
  [SMALL_STATE(7747)] = 327817,
  [SMALL_STATE(7748)] = 327857,
  [SMALL_STATE(7749)] = 327897,
  [SMALL_STATE(7750)] = 327943,
  [SMALL_STATE(7751)] = 327983,
  [SMALL_STATE(7752)] = 328023,
  [SMALL_STATE(7753)] = 328103,
  [SMALL_STATE(7754)] = 328149,
  [SMALL_STATE(7755)] = 328189,
  [SMALL_STATE(7756)] = 328229,
  [SMALL_STATE(7757)] = 328269,
  [SMALL_STATE(7758)] = 328309,
  [SMALL_STATE(7759)] = 328389,
  [SMALL_STATE(7760)] = 328429,
  [SMALL_STATE(7761)] = 328469,
  [SMALL_STATE(7762)] = 328509,
  [SMALL_STATE(7763)] = 328549,
  [SMALL_STATE(7764)] = 328589,
  [SMALL_STATE(7765)] = 328629,
  [SMALL_STATE(7766)] = 328669,
  [SMALL_STATE(7767)] = 328709,
  [SMALL_STATE(7768)] = 328749,
  [SMALL_STATE(7769)] = 328789,
  [SMALL_STATE(7770)] = 328835,
  [SMALL_STATE(7771)] = 328875,
  [SMALL_STATE(7772)] = 328955,
  [SMALL_STATE(7773)] = 328995,
  [SMALL_STATE(7774)] = 329035,
  [SMALL_STATE(7775)] = 329075,
  [SMALL_STATE(7776)] = 329115,
  [SMALL_STATE(7777)] = 329155,
  [SMALL_STATE(7778)] = 329223,
  [SMALL_STATE(7779)] = 329263,
  [SMALL_STATE(7780)] = 329303,
  [SMALL_STATE(7781)] = 329343,
  [SMALL_STATE(7782)] = 329383,
  [SMALL_STATE(7783)] = 329423,
  [SMALL_STATE(7784)] = 329463,
  [SMALL_STATE(7785)] = 329503,
  [SMALL_STATE(7786)] = 329543,
  [SMALL_STATE(7787)] = 329611,
  [SMALL_STATE(7788)] = 329651,
  [SMALL_STATE(7789)] = 329697,
  [SMALL_STATE(7790)] = 329737,
  [SMALL_STATE(7791)] = 329777,
  [SMALL_STATE(7792)] = 329817,
  [SMALL_STATE(7793)] = 329863,
  [SMALL_STATE(7794)] = 329903,
  [SMALL_STATE(7795)] = 329946,
  [SMALL_STATE(7796)] = 329989,
  [SMALL_STATE(7797)] = 330060,
  [SMALL_STATE(7798)] = 330103,
  [SMALL_STATE(7799)] = 330146,
  [SMALL_STATE(7800)] = 330189,
  [SMALL_STATE(7801)] = 330232,
  [SMALL_STATE(7802)] = 330275,
  [SMALL_STATE(7803)] = 330318,
  [SMALL_STATE(7804)] = 330361,
  [SMALL_STATE(7805)] = 330406,
  [SMALL_STATE(7806)] = 330449,
  [SMALL_STATE(7807)] = 330492,
  [SMALL_STATE(7808)] = 330535,
  [SMALL_STATE(7809)] = 330578,
  [SMALL_STATE(7810)] = 330621,
  [SMALL_STATE(7811)] = 330664,
  [SMALL_STATE(7812)] = 330707,
  [SMALL_STATE(7813)] = 330750,
  [SMALL_STATE(7814)] = 330793,
  [SMALL_STATE(7815)] = 330836,
  [SMALL_STATE(7816)] = 330879,
  [SMALL_STATE(7817)] = 330922,
  [SMALL_STATE(7818)] = 330965,
  [SMALL_STATE(7819)] = 331008,
  [SMALL_STATE(7820)] = 331051,
  [SMALL_STATE(7821)] = 331122,
  [SMALL_STATE(7822)] = 331165,
  [SMALL_STATE(7823)] = 331208,
  [SMALL_STATE(7824)] = 331251,
  [SMALL_STATE(7825)] = 331294,
  [SMALL_STATE(7826)] = 331337,
  [SMALL_STATE(7827)] = 331380,
  [SMALL_STATE(7828)] = 331423,
  [SMALL_STATE(7829)] = 331466,
  [SMALL_STATE(7830)] = 331509,
  [SMALL_STATE(7831)] = 331552,
  [SMALL_STATE(7832)] = 331595,
  [SMALL_STATE(7833)] = 331638,
  [SMALL_STATE(7834)] = 331681,
  [SMALL_STATE(7835)] = 331724,
  [SMALL_STATE(7836)] = 331795,
  [SMALL_STATE(7837)] = 331866,
  [SMALL_STATE(7838)] = 331909,
  [SMALL_STATE(7839)] = 331952,
  [SMALL_STATE(7840)] = 331995,
  [SMALL_STATE(7841)] = 332038,
  [SMALL_STATE(7842)] = 332081,
  [SMALL_STATE(7843)] = 332126,
  [SMALL_STATE(7844)] = 332169,
  [SMALL_STATE(7845)] = 332212,
  [SMALL_STATE(7846)] = 332255,
  [SMALL_STATE(7847)] = 332298,
  [SMALL_STATE(7848)] = 332341,
  [SMALL_STATE(7849)] = 332384,
  [SMALL_STATE(7850)] = 332427,
  [SMALL_STATE(7851)] = 332470,
  [SMALL_STATE(7852)] = 332513,
  [SMALL_STATE(7853)] = 332556,
  [SMALL_STATE(7854)] = 332599,
  [SMALL_STATE(7855)] = 332642,
  [SMALL_STATE(7856)] = 332685,
  [SMALL_STATE(7857)] = 332762,
  [SMALL_STATE(7858)] = 332805,
  [SMALL_STATE(7859)] = 332848,
  [SMALL_STATE(7860)] = 332891,
  [SMALL_STATE(7861)] = 332934,
  [SMALL_STATE(7862)] = 332977,
  [SMALL_STATE(7863)] = 333021,
  [SMALL_STATE(7864)] = 333059,
  [SMALL_STATE(7865)] = 333127,
  [SMALL_STATE(7866)] = 333171,
  [SMALL_STATE(7867)] = 333209,
  [SMALL_STATE(7868)] = 333283,
  [SMALL_STATE(7869)] = 333357,
  [SMALL_STATE(7870)] = 333395,
  [SMALL_STATE(7871)] = 333433,
  [SMALL_STATE(7872)] = 333471,
  [SMALL_STATE(7873)] = 333539,
  [SMALL_STATE(7874)] = 333583,
  [SMALL_STATE(7875)] = 333621,
  [SMALL_STATE(7876)] = 333661,
  [SMALL_STATE(7877)] = 333699,
  [SMALL_STATE(7878)] = 333737,
  [SMALL_STATE(7879)] = 333775,
  [SMALL_STATE(7880)] = 333837,
  [SMALL_STATE(7881)] = 333875,
  [SMALL_STATE(7882)] = 333913,
  [SMALL_STATE(7883)] = 333951,
  [SMALL_STATE(7884)] = 333995,
  [SMALL_STATE(7885)] = 334033,
  [SMALL_STATE(7886)] = 334070,
  [SMALL_STATE(7887)] = 334107,
  [SMALL_STATE(7888)] = 334170,
  [SMALL_STATE(7889)] = 334207,
  [SMALL_STATE(7890)] = 334244,
  [SMALL_STATE(7891)] = 334281,
  [SMALL_STATE(7892)] = 334318,
  [SMALL_STATE(7893)] = 334355,
  [SMALL_STATE(7894)] = 334392,
  [SMALL_STATE(7895)] = 334429,
  [SMALL_STATE(7896)] = 334492,
  [SMALL_STATE(7897)] = 334529,
  [SMALL_STATE(7898)] = 334566,
  [SMALL_STATE(7899)] = 334603,
  [SMALL_STATE(7900)] = 334640,
  [SMALL_STATE(7901)] = 334705,
  [SMALL_STATE(7902)] = 334742,
  [SMALL_STATE(7903)] = 334779,
  [SMALL_STATE(7904)] = 334842,
  [SMALL_STATE(7905)] = 334879,
  [SMALL_STATE(7906)] = 334916,
  [SMALL_STATE(7907)] = 334953,
  [SMALL_STATE(7908)] = 334990,
  [SMALL_STATE(7909)] = 335053,
  [SMALL_STATE(7910)] = 335124,
  [SMALL_STATE(7911)] = 335161,
  [SMALL_STATE(7912)] = 335198,
  [SMALL_STATE(7913)] = 335235,
  [SMALL_STATE(7914)] = 335272,
  [SMALL_STATE(7915)] = 335309,
  [SMALL_STATE(7916)] = 335380,
  [SMALL_STATE(7917)] = 335417,
  [SMALL_STATE(7918)] = 335460,
  [SMALL_STATE(7919)] = 335497,
  [SMALL_STATE(7920)] = 335534,
  [SMALL_STATE(7921)] = 335599,
  [SMALL_STATE(7922)] = 335662,
  [SMALL_STATE(7923)] = 335699,
  [SMALL_STATE(7924)] = 335762,
  [SMALL_STATE(7925)] = 335799,
  [SMALL_STATE(7926)] = 335836,
  [SMALL_STATE(7927)] = 335873,
  [SMALL_STATE(7928)] = 335910,
  [SMALL_STATE(7929)] = 335947,
  [SMALL_STATE(7930)] = 336010,
  [SMALL_STATE(7931)] = 336047,
  [SMALL_STATE(7932)] = 336084,
  [SMALL_STATE(7933)] = 336149,
  [SMALL_STATE(7934)] = 336212,
  [SMALL_STATE(7935)] = 336249,
  [SMALL_STATE(7936)] = 336286,
  [SMALL_STATE(7937)] = 336323,
  [SMALL_STATE(7938)] = 336360,
  [SMALL_STATE(7939)] = 336397,
  [SMALL_STATE(7940)] = 336434,
  [SMALL_STATE(7941)] = 336497,
  [SMALL_STATE(7942)] = 336534,
  [SMALL_STATE(7943)] = 336571,
  [SMALL_STATE(7944)] = 336608,
  [SMALL_STATE(7945)] = 336645,
  [SMALL_STATE(7946)] = 336682,
  [SMALL_STATE(7947)] = 336719,
  [SMALL_STATE(7948)] = 336756,
  [SMALL_STATE(7949)] = 336793,
  [SMALL_STATE(7950)] = 336856,
  [SMALL_STATE(7951)] = 336893,
  [SMALL_STATE(7952)] = 336930,
  [SMALL_STATE(7953)] = 336967,
  [SMALL_STATE(7954)] = 337004,
  [SMALL_STATE(7955)] = 337069,
  [SMALL_STATE(7956)] = 337106,
  [SMALL_STATE(7957)] = 337143,
  [SMALL_STATE(7958)] = 337180,
  [SMALL_STATE(7959)] = 337217,
  [SMALL_STATE(7960)] = 337282,
  [SMALL_STATE(7961)] = 337353,
  [SMALL_STATE(7962)] = 337389,
  [SMALL_STATE(7963)] = 337457,
  [SMALL_STATE(7964)] = 337493,
  [SMALL_STATE(7965)] = 337529,
  [SMALL_STATE(7966)] = 337565,
  [SMALL_STATE(7967)] = 337601,
  [SMALL_STATE(7968)] = 337637,
  [SMALL_STATE(7969)] = 337673,
  [SMALL_STATE(7970)] = 337709,
  [SMALL_STATE(7971)] = 337745,
  [SMALL_STATE(7972)] = 337813,
  [SMALL_STATE(7973)] = 337869,
  [SMALL_STATE(7974)] = 337905,
  [SMALL_STATE(7975)] = 337973,
  [SMALL_STATE(7976)] = 338041,
  [SMALL_STATE(7977)] = 338077,
  [SMALL_STATE(7978)] = 338113,
  [SMALL_STATE(7979)] = 338149,
  [SMALL_STATE(7980)] = 338205,
  [SMALL_STATE(7981)] = 338241,
  [SMALL_STATE(7982)] = 338277,
  [SMALL_STATE(7983)] = 338313,
  [SMALL_STATE(7984)] = 338349,
  [SMALL_STATE(7985)] = 338385,
  [SMALL_STATE(7986)] = 338421,
  [SMALL_STATE(7987)] = 338457,
  [SMALL_STATE(7988)] = 338493,
  [SMALL_STATE(7989)] = 338533,
  [SMALL_STATE(7990)] = 338601,
  [SMALL_STATE(7991)] = 338637,
  [SMALL_STATE(7992)] = 338673,
  [SMALL_STATE(7993)] = 338709,
  [SMALL_STATE(7994)] = 338745,
  [SMALL_STATE(7995)] = 338781,
  [SMALL_STATE(7996)] = 338817,
  [SMALL_STATE(7997)] = 338853,
  [SMALL_STATE(7998)] = 338889,
  [SMALL_STATE(7999)] = 338925,
  [SMALL_STATE(8000)] = 338961,
  [SMALL_STATE(8001)] = 338997,
  [SMALL_STATE(8002)] = 339033,
  [SMALL_STATE(8003)] = 339069,
  [SMALL_STATE(8004)] = 339105,
  [SMALL_STATE(8005)] = 339141,
  [SMALL_STATE(8006)] = 339177,
  [SMALL_STATE(8007)] = 339213,
  [SMALL_STATE(8008)] = 339249,
  [SMALL_STATE(8009)] = 339285,
  [SMALL_STATE(8010)] = 339321,
  [SMALL_STATE(8011)] = 339357,
  [SMALL_STATE(8012)] = 339393,
  [SMALL_STATE(8013)] = 339452,
  [SMALL_STATE(8014)] = 339487,
  [SMALL_STATE(8015)] = 339522,
  [SMALL_STATE(8016)] = 339579,
  [SMALL_STATE(8017)] = 339614,
  [SMALL_STATE(8018)] = 339671,
  [SMALL_STATE(8019)] = 339706,
  [SMALL_STATE(8020)] = 339747,
  [SMALL_STATE(8021)] = 339804,
  [SMALL_STATE(8022)] = 339839,
  [SMALL_STATE(8023)] = 339874,
  [SMALL_STATE(8024)] = 339909,
  [SMALL_STATE(8025)] = 339944,
  [SMALL_STATE(8026)] = 339979,
  [SMALL_STATE(8027)] = 340014,
  [SMALL_STATE(8028)] = 340049,
  [SMALL_STATE(8029)] = 340106,
  [SMALL_STATE(8030)] = 340141,
  [SMALL_STATE(8031)] = 340176,
  [SMALL_STATE(8032)] = 340211,
  [SMALL_STATE(8033)] = 340280,
  [SMALL_STATE(8034)] = 340315,
  [SMALL_STATE(8035)] = 340384,
  [SMALL_STATE(8036)] = 340419,
  [SMALL_STATE(8037)] = 340454,
  [SMALL_STATE(8038)] = 340489,
  [SMALL_STATE(8039)] = 340524,
  [SMALL_STATE(8040)] = 340559,
  [SMALL_STATE(8041)] = 340623,
  [SMALL_STATE(8042)] = 340687,
  [SMALL_STATE(8043)] = 340751,
  [SMALL_STATE(8044)] = 340817,
  [SMALL_STATE(8045)] = 340851,
  [SMALL_STATE(8046)] = 340915,
  [SMALL_STATE(8047)] = 340949,
  [SMALL_STATE(8048)] = 340983,
  [SMALL_STATE(8049)] = 341017,
  [SMALL_STATE(8050)] = 341051,
  [SMALL_STATE(8051)] = 341085,
  [SMALL_STATE(8052)] = 341139,
  [SMALL_STATE(8053)] = 341173,
  [SMALL_STATE(8054)] = 341207,
  [SMALL_STATE(8055)] = 341241,
  [SMALL_STATE(8056)] = 341275,
  [SMALL_STATE(8057)] = 341339,
  [SMALL_STATE(8058)] = 341373,
  [SMALL_STATE(8059)] = 341407,
  [SMALL_STATE(8060)] = 341461,
  [SMALL_STATE(8061)] = 341495,
  [SMALL_STATE(8062)] = 341563,
  [SMALL_STATE(8063)] = 341597,
  [SMALL_STATE(8064)] = 341631,
  [SMALL_STATE(8065)] = 341665,
  [SMALL_STATE(8066)] = 341699,
  [SMALL_STATE(8067)] = 341733,
  [SMALL_STATE(8068)] = 341767,
  [SMALL_STATE(8069)] = 341801,
  [SMALL_STATE(8070)] = 341839,
  [SMALL_STATE(8071)] = 341873,
  [SMALL_STATE(8072)] = 341907,
  [SMALL_STATE(8073)] = 341941,
  [SMALL_STATE(8074)] = 341975,
  [SMALL_STATE(8075)] = 342039,
  [SMALL_STATE(8076)] = 342073,
  [SMALL_STATE(8077)] = 342107,
  [SMALL_STATE(8078)] = 342141,
  [SMALL_STATE(8079)] = 342175,
  [SMALL_STATE(8080)] = 342210,
  [SMALL_STATE(8081)] = 342243,
  [SMALL_STATE(8082)] = 342294,
  [SMALL_STATE(8083)] = 342327,
  [SMALL_STATE(8084)] = 342378,
  [SMALL_STATE(8085)] = 342445,
  [SMALL_STATE(8086)] = 342478,
  [SMALL_STATE(8087)] = 342511,
  [SMALL_STATE(8088)] = 342562,
  [SMALL_STATE(8089)] = 342629,
  [SMALL_STATE(8090)] = 342684,
  [SMALL_STATE(8091)] = 342735,
  [SMALL_STATE(8092)] = 342786,
  [SMALL_STATE(8093)] = 342847,
  [SMALL_STATE(8094)] = 342880,
  [SMALL_STATE(8095)] = 342939,
  [SMALL_STATE(8096)] = 342972,
  [SMALL_STATE(8097)] = 343033,
  [SMALL_STATE(8098)] = 343085,
  [SMALL_STATE(8099)] = 343137,
  [SMALL_STATE(8100)] = 343189,
  [SMALL_STATE(8101)] = 343241,
  [SMALL_STATE(8102)] = 343293,
  [SMALL_STATE(8103)] = 343341,
  [SMALL_STATE(8104)] = 343393,
  [SMALL_STATE(8105)] = 343437,
  [SMALL_STATE(8106)] = 343493,
  [SMALL_STATE(8107)] = 343545,
  [SMALL_STATE(8108)] = 343595,
  [SMALL_STATE(8109)] = 343647,
  [SMALL_STATE(8110)] = 343695,
  [SMALL_STATE(8111)] = 343743,
  [SMALL_STATE(8112)] = 343791,
  [SMALL_STATE(8113)] = 343841,
  [SMALL_STATE(8114)] = 343893,
  [SMALL_STATE(8115)] = 343945,
  [SMALL_STATE(8116)] = 343995,
  [SMALL_STATE(8117)] = 344043,
  [SMALL_STATE(8118)] = 344093,
  [SMALL_STATE(8119)] = 344145,
  [SMALL_STATE(8120)] = 344197,
  [SMALL_STATE(8121)] = 344249,
  [SMALL_STATE(8122)] = 344301,
  [SMALL_STATE(8123)] = 344351,
  [SMALL_STATE(8124)] = 344399,
  [SMALL_STATE(8125)] = 344449,
  [SMALL_STATE(8126)] = 344497,
  [SMALL_STATE(8127)] = 344547,
  [SMALL_STATE(8128)] = 344599,
  [SMALL_STATE(8129)] = 344649,
  [SMALL_STATE(8130)] = 344699,
  [SMALL_STATE(8131)] = 344747,
  [SMALL_STATE(8132)] = 344797,
  [SMALL_STATE(8133)] = 344849,
  [SMALL_STATE(8134)] = 344901,
  [SMALL_STATE(8135)] = 344953,
  [SMALL_STATE(8136)] = 345005,
  [SMALL_STATE(8137)] = 345057,
  [SMALL_STATE(8138)] = 345101,
  [SMALL_STATE(8139)] = 345132,
  [SMALL_STATE(8140)] = 345163,
  [SMALL_STATE(8141)] = 345210,
  [SMALL_STATE(8142)] = 345257,
  [SMALL_STATE(8143)] = 345314,
  [SMALL_STATE(8144)] = 345345,
  [SMALL_STATE(8145)] = 345392,
  [SMALL_STATE(8146)] = 345439,
  [SMALL_STATE(8147)] = 345470,
  [SMALL_STATE(8148)] = 345519,
  [SMALL_STATE(8149)] = 345550,
  [SMALL_STATE(8150)] = 345605,
  [SMALL_STATE(8151)] = 345664,
  [SMALL_STATE(8152)] = 345711,
  [SMALL_STATE(8153)] = 345742,
  [SMALL_STATE(8154)] = 345789,
  [SMALL_STATE(8155)] = 345820,
  [SMALL_STATE(8156)] = 345851,
  [SMALL_STATE(8157)] = 345898,
  [SMALL_STATE(8158)] = 345953,
  [SMALL_STATE(8159)] = 345984,
  [SMALL_STATE(8160)] = 346017,
  [SMALL_STATE(8161)] = 346048,
  [SMALL_STATE(8162)] = 346079,
  [SMALL_STATE(8163)] = 346126,
  [SMALL_STATE(8164)] = 346173,
  [SMALL_STATE(8165)] = 346232,
  [SMALL_STATE(8166)] = 346291,
  [SMALL_STATE(8167)] = 346322,
  [SMALL_STATE(8168)] = 346373,
  [SMALL_STATE(8169)] = 346424,
  [SMALL_STATE(8170)] = 346455,
  [SMALL_STATE(8171)] = 346502,
  [SMALL_STATE(8172)] = 346544,
  [SMALL_STATE(8173)] = 346596,
  [SMALL_STATE(8174)] = 346648,
  [SMALL_STATE(8175)] = 346700,
  [SMALL_STATE(8176)] = 346752,
  [SMALL_STATE(8177)] = 346804,
  [SMALL_STATE(8178)] = 346856,
  [SMALL_STATE(8179)] = 346908,
  [SMALL_STATE(8180)] = 346960,
  [SMALL_STATE(8181)] = 347002,
  [SMALL_STATE(8182)] = 347058,
  [SMALL_STATE(8183)] = 347110,
  [SMALL_STATE(8184)] = 347160,
  [SMALL_STATE(8185)] = 347210,
  [SMALL_STATE(8186)] = 347260,
  [SMALL_STATE(8187)] = 347312,
  [SMALL_STATE(8188)] = 347368,
  [SMALL_STATE(8189)] = 347420,
  [SMALL_STATE(8190)] = 347472,
  [SMALL_STATE(8191)] = 347524,
  [SMALL_STATE(8192)] = 347572,
  [SMALL_STATE(8193)] = 347628,
  [SMALL_STATE(8194)] = 347680,
  [SMALL_STATE(8195)] = 347730,
  [SMALL_STATE(8196)] = 347782,
  [SMALL_STATE(8197)] = 347834,
  [SMALL_STATE(8198)] = 347886,
  [SMALL_STATE(8199)] = 347938,
  [SMALL_STATE(8200)] = 347990,
  [SMALL_STATE(8201)] = 348038,
  [SMALL_STATE(8202)] = 348088,
  [SMALL_STATE(8203)] = 348138,
  [SMALL_STATE(8204)] = 348190,
  [SMALL_STATE(8205)] = 348242,
  [SMALL_STATE(8206)] = 348292,
  [SMALL_STATE(8207)] = 348342,
  [SMALL_STATE(8208)] = 348392,
  [SMALL_STATE(8209)] = 348448,
  [SMALL_STATE(8210)] = 348504,
  [SMALL_STATE(8211)] = 348556,
  [SMALL_STATE(8212)] = 348606,
  [SMALL_STATE(8213)] = 348656,
  [SMALL_STATE(8214)] = 348706,
  [SMALL_STATE(8215)] = 348762,
  [SMALL_STATE(8216)] = 348812,
  [SMALL_STATE(8217)] = 348862,
  [SMALL_STATE(8218)] = 348914,
  [SMALL_STATE(8219)] = 348956,
  [SMALL_STATE(8220)] = 349008,
  [SMALL_STATE(8221)] = 349058,
  [SMALL_STATE(8222)] = 349108,
  [SMALL_STATE(8223)] = 349138,
  [SMALL_STATE(8224)] = 349190,
  [SMALL_STATE(8225)] = 349242,
  [SMALL_STATE(8226)] = 349272,
  [SMALL_STATE(8227)] = 349328,
  [SMALL_STATE(8228)] = 349378,
  [SMALL_STATE(8229)] = 349434,
  [SMALL_STATE(8230)] = 349484,
  [SMALL_STATE(8231)] = 349536,
  [SMALL_STATE(8232)] = 349586,
  [SMALL_STATE(8233)] = 349638,
  [SMALL_STATE(8234)] = 349690,
  [SMALL_STATE(8235)] = 349742,
  [SMALL_STATE(8236)] = 349794,
  [SMALL_STATE(8237)] = 349844,
  [SMALL_STATE(8238)] = 349894,
  [SMALL_STATE(8239)] = 349944,
  [SMALL_STATE(8240)] = 350000,
  [SMALL_STATE(8241)] = 350052,
  [SMALL_STATE(8242)] = 350104,
  [SMALL_STATE(8243)] = 350156,
  [SMALL_STATE(8244)] = 350208,
  [SMALL_STATE(8245)] = 350260,
  [SMALL_STATE(8246)] = 350316,
  [SMALL_STATE(8247)] = 350368,
  [SMALL_STATE(8248)] = 350418,
  [SMALL_STATE(8249)] = 350470,
  [SMALL_STATE(8250)] = 350526,
  [SMALL_STATE(8251)] = 350576,
  [SMALL_STATE(8252)] = 350626,
  [SMALL_STATE(8253)] = 350678,
  [SMALL_STATE(8254)] = 350730,
  [SMALL_STATE(8255)] = 350782,
  [SMALL_STATE(8256)] = 350834,
  [SMALL_STATE(8257)] = 350886,
  [SMALL_STATE(8258)] = 350938,
  [SMALL_STATE(8259)] = 350990,
  [SMALL_STATE(8260)] = 351042,
  [SMALL_STATE(8261)] = 351094,
  [SMALL_STATE(8262)] = 351146,
  [SMALL_STATE(8263)] = 351196,
  [SMALL_STATE(8264)] = 351248,
  [SMALL_STATE(8265)] = 351300,
  [SMALL_STATE(8266)] = 351352,
  [SMALL_STATE(8267)] = 351408,
  [SMALL_STATE(8268)] = 351460,
  [SMALL_STATE(8269)] = 351516,
  [SMALL_STATE(8270)] = 351568,
  [SMALL_STATE(8271)] = 351610,
  [SMALL_STATE(8272)] = 351662,
  [SMALL_STATE(8273)] = 351718,
  [SMALL_STATE(8274)] = 351770,
  [SMALL_STATE(8275)] = 351820,
  [SMALL_STATE(8276)] = 351873,
  [SMALL_STATE(8277)] = 351924,
  [SMALL_STATE(8278)] = 351953,
  [SMALL_STATE(8279)] = 352004,
  [SMALL_STATE(8280)] = 352057,
  [SMALL_STATE(8281)] = 352108,
  [SMALL_STATE(8282)] = 352137,
  [SMALL_STATE(8283)] = 352166,
  [SMALL_STATE(8284)] = 352195,
  [SMALL_STATE(8285)] = 352224,
  [SMALL_STATE(8286)] = 352275,
  [SMALL_STATE(8287)] = 352304,
  [SMALL_STATE(8288)] = 352333,
  [SMALL_STATE(8289)] = 352384,
  [SMALL_STATE(8290)] = 352413,
  [SMALL_STATE(8291)] = 352442,
  [SMALL_STATE(8292)] = 352495,
  [SMALL_STATE(8293)] = 352546,
  [SMALL_STATE(8294)] = 352597,
  [SMALL_STATE(8295)] = 352626,
  [SMALL_STATE(8296)] = 352655,
  [SMALL_STATE(8297)] = 352706,
  [SMALL_STATE(8298)] = 352735,
  [SMALL_STATE(8299)] = 352786,
  [SMALL_STATE(8300)] = 352825,
  [SMALL_STATE(8301)] = 352874,
  [SMALL_STATE(8302)] = 352931,
  [SMALL_STATE(8303)] = 352979,
  [SMALL_STATE(8304)] = 353031,
  [SMALL_STATE(8305)] = 353079,
  [SMALL_STATE(8306)] = 353127,
  [SMALL_STATE(8307)] = 353175,
  [SMALL_STATE(8308)] = 353223,
  [SMALL_STATE(8309)] = 353271,
  [SMALL_STATE(8310)] = 353321,
  [SMALL_STATE(8311)] = 353369,
  [SMALL_STATE(8312)] = 353417,
  [SMALL_STATE(8313)] = 353465,
  [SMALL_STATE(8314)] = 353493,
  [SMALL_STATE(8315)] = 353533,
  [SMALL_STATE(8316)] = 353581,
  [SMALL_STATE(8317)] = 353629,
  [SMALL_STATE(8318)] = 353677,
  [SMALL_STATE(8319)] = 353725,
  [SMALL_STATE(8320)] = 353773,
  [SMALL_STATE(8321)] = 353821,
  [SMALL_STATE(8322)] = 353869,
  [SMALL_STATE(8323)] = 353917,
  [SMALL_STATE(8324)] = 353965,
  [SMALL_STATE(8325)] = 354013,
  [SMALL_STATE(8326)] = 354053,
  [SMALL_STATE(8327)] = 354101,
  [SMALL_STATE(8328)] = 354149,
  [SMALL_STATE(8329)] = 354197,
  [SMALL_STATE(8330)] = 354245,
  [SMALL_STATE(8331)] = 354293,
  [SMALL_STATE(8332)] = 354341,
  [SMALL_STATE(8333)] = 354389,
  [SMALL_STATE(8334)] = 354437,
  [SMALL_STATE(8335)] = 354485,
  [SMALL_STATE(8336)] = 354533,
  [SMALL_STATE(8337)] = 354581,
  [SMALL_STATE(8338)] = 354631,
  [SMALL_STATE(8339)] = 354679,
  [SMALL_STATE(8340)] = 354727,
  [SMALL_STATE(8341)] = 354775,
  [SMALL_STATE(8342)] = 354825,
  [SMALL_STATE(8343)] = 354873,
  [SMALL_STATE(8344)] = 354921,
  [SMALL_STATE(8345)] = 354969,
  [SMALL_STATE(8346)] = 355017,
  [SMALL_STATE(8347)] = 355065,
  [SMALL_STATE(8348)] = 355113,
  [SMALL_STATE(8349)] = 355161,
  [SMALL_STATE(8350)] = 355209,
  [SMALL_STATE(8351)] = 355257,
  [SMALL_STATE(8352)] = 355305,
  [SMALL_STATE(8353)] = 355353,
  [SMALL_STATE(8354)] = 355401,
  [SMALL_STATE(8355)] = 355449,
  [SMALL_STATE(8356)] = 355476,
  [SMALL_STATE(8357)] = 355523,
  [SMALL_STATE(8358)] = 355550,
  [SMALL_STATE(8359)] = 355577,
  [SMALL_STATE(8360)] = 355604,
  [SMALL_STATE(8361)] = 355631,
  [SMALL_STATE(8362)] = 355658,
  [SMALL_STATE(8363)] = 355705,
  [SMALL_STATE(8364)] = 355746,
  [SMALL_STATE(8365)] = 355793,
  [SMALL_STATE(8366)] = 355840,
  [SMALL_STATE(8367)] = 355887,
  [SMALL_STATE(8368)] = 355934,
  [SMALL_STATE(8369)] = 355981,
  [SMALL_STATE(8370)] = 356020,
  [SMALL_STATE(8371)] = 356047,
  [SMALL_STATE(8372)] = 356074,
  [SMALL_STATE(8373)] = 356121,
  [SMALL_STATE(8374)] = 356168,
  [SMALL_STATE(8375)] = 356195,
  [SMALL_STATE(8376)] = 356222,
  [SMALL_STATE(8377)] = 356249,
  [SMALL_STATE(8378)] = 356276,
  [SMALL_STATE(8379)] = 356321,
  [SMALL_STATE(8380)] = 356366,
  [SMALL_STATE(8381)] = 356393,
  [SMALL_STATE(8382)] = 356420,
  [SMALL_STATE(8383)] = 356447,
  [SMALL_STATE(8384)] = 356492,
  [SMALL_STATE(8385)] = 356519,
  [SMALL_STATE(8386)] = 356546,
  [SMALL_STATE(8387)] = 356573,
  [SMALL_STATE(8388)] = 356600,
  [SMALL_STATE(8389)] = 356627,
  [SMALL_STATE(8390)] = 356678,
  [SMALL_STATE(8391)] = 356711,
  [SMALL_STATE(8392)] = 356738,
  [SMALL_STATE(8393)] = 356765,
  [SMALL_STATE(8394)] = 356812,
  [SMALL_STATE(8395)] = 356859,
  [SMALL_STATE(8396)] = 356898,
  [SMALL_STATE(8397)] = 356945,
  [SMALL_STATE(8398)] = 356992,
  [SMALL_STATE(8399)] = 357039,
  [SMALL_STATE(8400)] = 357084,
  [SMALL_STATE(8401)] = 357131,
  [SMALL_STATE(8402)] = 357172,
  [SMALL_STATE(8403)] = 357219,
  [SMALL_STATE(8404)] = 357267,
  [SMALL_STATE(8405)] = 357313,
  [SMALL_STATE(8406)] = 357359,
  [SMALL_STATE(8407)] = 357405,
  [SMALL_STATE(8408)] = 357451,
  [SMALL_STATE(8409)] = 357497,
  [SMALL_STATE(8410)] = 357545,
  [SMALL_STATE(8411)] = 357591,
  [SMALL_STATE(8412)] = 357637,
  [SMALL_STATE(8413)] = 357683,
  [SMALL_STATE(8414)] = 357731,
  [SMALL_STATE(8415)] = 357779,
  [SMALL_STATE(8416)] = 357825,
  [SMALL_STATE(8417)] = 357873,
  [SMALL_STATE(8418)] = 357919,
  [SMALL_STATE(8419)] = 357965,
  [SMALL_STATE(8420)] = 358013,
  [SMALL_STATE(8421)] = 358059,
  [SMALL_STATE(8422)] = 358105,
  [SMALL_STATE(8423)] = 358149,
  [SMALL_STATE(8424)] = 358195,
  [SMALL_STATE(8425)] = 358243,
  [SMALL_STATE(8426)] = 358289,
  [SMALL_STATE(8427)] = 358335,
  [SMALL_STATE(8428)] = 358381,
  [SMALL_STATE(8429)] = 358427,
  [SMALL_STATE(8430)] = 358473,
  [SMALL_STATE(8431)] = 358519,
  [SMALL_STATE(8432)] = 358565,
  [SMALL_STATE(8433)] = 358611,
  [SMALL_STATE(8434)] = 358657,
  [SMALL_STATE(8435)] = 358703,
  [SMALL_STATE(8436)] = 358749,
  [SMALL_STATE(8437)] = 358795,
  [SMALL_STATE(8438)] = 358841,
  [SMALL_STATE(8439)] = 358887,
  [SMALL_STATE(8440)] = 358933,
  [SMALL_STATE(8441)] = 358979,
  [SMALL_STATE(8442)] = 359025,
  [SMALL_STATE(8443)] = 359071,
  [SMALL_STATE(8444)] = 359117,
  [SMALL_STATE(8445)] = 359163,
  [SMALL_STATE(8446)] = 359209,
  [SMALL_STATE(8447)] = 359255,
  [SMALL_STATE(8448)] = 359301,
  [SMALL_STATE(8449)] = 359347,
  [SMALL_STATE(8450)] = 359393,
  [SMALL_STATE(8451)] = 359439,
  [SMALL_STATE(8452)] = 359485,
  [SMALL_STATE(8453)] = 359531,
  [SMALL_STATE(8454)] = 359577,
  [SMALL_STATE(8455)] = 359625,
  [SMALL_STATE(8456)] = 359671,
  [SMALL_STATE(8457)] = 359717,
  [SMALL_STATE(8458)] = 359763,
  [SMALL_STATE(8459)] = 359809,
  [SMALL_STATE(8460)] = 359855,
  [SMALL_STATE(8461)] = 359903,
  [SMALL_STATE(8462)] = 359949,
  [SMALL_STATE(8463)] = 359995,
  [SMALL_STATE(8464)] = 360041,
  [SMALL_STATE(8465)] = 360089,
  [SMALL_STATE(8466)] = 360135,
  [SMALL_STATE(8467)] = 360181,
  [SMALL_STATE(8468)] = 360227,
  [SMALL_STATE(8469)] = 360273,
  [SMALL_STATE(8470)] = 360321,
  [SMALL_STATE(8471)] = 360367,
  [SMALL_STATE(8472)] = 360413,
  [SMALL_STATE(8473)] = 360459,
  [SMALL_STATE(8474)] = 360505,
  [SMALL_STATE(8475)] = 360551,
  [SMALL_STATE(8476)] = 360597,
  [SMALL_STATE(8477)] = 360643,
  [SMALL_STATE(8478)] = 360689,
  [SMALL_STATE(8479)] = 360735,
  [SMALL_STATE(8480)] = 360781,
  [SMALL_STATE(8481)] = 360827,
  [SMALL_STATE(8482)] = 360873,
  [SMALL_STATE(8483)] = 360919,
  [SMALL_STATE(8484)] = 360965,
  [SMALL_STATE(8485)] = 361011,
  [SMALL_STATE(8486)] = 361057,
  [SMALL_STATE(8487)] = 361103,
  [SMALL_STATE(8488)] = 361149,
  [SMALL_STATE(8489)] = 361195,
  [SMALL_STATE(8490)] = 361241,
  [SMALL_STATE(8491)] = 361287,
  [SMALL_STATE(8492)] = 361333,
  [SMALL_STATE(8493)] = 361379,
  [SMALL_STATE(8494)] = 361425,
  [SMALL_STATE(8495)] = 361471,
  [SMALL_STATE(8496)] = 361517,
  [SMALL_STATE(8497)] = 361563,
  [SMALL_STATE(8498)] = 361611,
  [SMALL_STATE(8499)] = 361657,
  [SMALL_STATE(8500)] = 361703,
  [SMALL_STATE(8501)] = 361749,
  [SMALL_STATE(8502)] = 361795,
  [SMALL_STATE(8503)] = 361821,
  [SMALL_STATE(8504)] = 361867,
  [SMALL_STATE(8505)] = 361915,
  [SMALL_STATE(8506)] = 361963,
  [SMALL_STATE(8507)] = 362011,
  [SMALL_STATE(8508)] = 362057,
  [SMALL_STATE(8509)] = 362103,
  [SMALL_STATE(8510)] = 362141,
  [SMALL_STATE(8511)] = 362189,
  [SMALL_STATE(8512)] = 362215,
  [SMALL_STATE(8513)] = 362261,
  [SMALL_STATE(8514)] = 362287,
  [SMALL_STATE(8515)] = 362313,
  [SMALL_STATE(8516)] = 362359,
  [SMALL_STATE(8517)] = 362405,
  [SMALL_STATE(8518)] = 362453,
  [SMALL_STATE(8519)] = 362499,
  [SMALL_STATE(8520)] = 362525,
  [SMALL_STATE(8521)] = 362551,
  [SMALL_STATE(8522)] = 362597,
  [SMALL_STATE(8523)] = 362643,
  [SMALL_STATE(8524)] = 362689,
  [SMALL_STATE(8525)] = 362735,
  [SMALL_STATE(8526)] = 362781,
  [SMALL_STATE(8527)] = 362807,
  [SMALL_STATE(8528)] = 362833,
  [SMALL_STATE(8529)] = 362859,
  [SMALL_STATE(8530)] = 362905,
  [SMALL_STATE(8531)] = 362931,
  [SMALL_STATE(8532)] = 362977,
  [SMALL_STATE(8533)] = 363003,
  [SMALL_STATE(8534)] = 363049,
  [SMALL_STATE(8535)] = 363095,
  [SMALL_STATE(8536)] = 363143,
  [SMALL_STATE(8537)] = 363189,
  [SMALL_STATE(8538)] = 363215,
  [SMALL_STATE(8539)] = 363261,
  [SMALL_STATE(8540)] = 363307,
  [SMALL_STATE(8541)] = 363353,
  [SMALL_STATE(8542)] = 363401,
  [SMALL_STATE(8543)] = 363447,
  [SMALL_STATE(8544)] = 363493,
  [SMALL_STATE(8545)] = 363539,
  [SMALL_STATE(8546)] = 363587,
  [SMALL_STATE(8547)] = 363633,
  [SMALL_STATE(8548)] = 363679,
  [SMALL_STATE(8549)] = 363725,
  [SMALL_STATE(8550)] = 363771,
  [SMALL_STATE(8551)] = 363817,
  [SMALL_STATE(8552)] = 363865,
  [SMALL_STATE(8553)] = 363912,
  [SMALL_STATE(8554)] = 363937,
  [SMALL_STATE(8555)] = 363984,
  [SMALL_STATE(8556)] = 364031,
  [SMALL_STATE(8557)] = 364056,
  [SMALL_STATE(8558)] = 364103,
  [SMALL_STATE(8559)] = 364128,
  [SMALL_STATE(8560)] = 364153,
  [SMALL_STATE(8561)] = 364178,
  [SMALL_STATE(8562)] = 364203,
  [SMALL_STATE(8563)] = 364248,
  [SMALL_STATE(8564)] = 364273,
  [SMALL_STATE(8565)] = 364298,
  [SMALL_STATE(8566)] = 364323,
  [SMALL_STATE(8567)] = 364348,
  [SMALL_STATE(8568)] = 364373,
  [SMALL_STATE(8569)] = 364420,
  [SMALL_STATE(8570)] = 364445,
  [SMALL_STATE(8571)] = 364470,
  [SMALL_STATE(8572)] = 364495,
  [SMALL_STATE(8573)] = 364520,
  [SMALL_STATE(8574)] = 364565,
  [SMALL_STATE(8575)] = 364590,
  [SMALL_STATE(8576)] = 364637,
  [SMALL_STATE(8577)] = 364674,
  [SMALL_STATE(8578)] = 364717,
  [SMALL_STATE(8579)] = 364764,
  [SMALL_STATE(8580)] = 364811,
  [SMALL_STATE(8581)] = 364858,
  [SMALL_STATE(8582)] = 364883,
  [SMALL_STATE(8583)] = 364928,
  [SMALL_STATE(8584)] = 364953,
  [SMALL_STATE(8585)] = 365000,
  [SMALL_STATE(8586)] = 365025,
  [SMALL_STATE(8587)] = 365072,
  [SMALL_STATE(8588)] = 365117,
  [SMALL_STATE(8589)] = 365142,
  [SMALL_STATE(8590)] = 365187,
  [SMALL_STATE(8591)] = 365234,
  [SMALL_STATE(8592)] = 365279,
  [SMALL_STATE(8593)] = 365304,
  [SMALL_STATE(8594)] = 365351,
  [SMALL_STATE(8595)] = 365398,
  [SMALL_STATE(8596)] = 365423,
  [SMALL_STATE(8597)] = 365468,
  [SMALL_STATE(8598)] = 365515,
  [SMALL_STATE(8599)] = 365562,
  [SMALL_STATE(8600)] = 365609,
  [SMALL_STATE(8601)] = 365656,
  [SMALL_STATE(8602)] = 365681,
  [SMALL_STATE(8603)] = 365726,
  [SMALL_STATE(8604)] = 365751,
  [SMALL_STATE(8605)] = 365776,
  [SMALL_STATE(8606)] = 365801,
  [SMALL_STATE(8607)] = 365848,
  [SMALL_STATE(8608)] = 365893,
  [SMALL_STATE(8609)] = 365935,
  [SMALL_STATE(8610)] = 365975,
  [SMALL_STATE(8611)] = 366015,
  [SMALL_STATE(8612)] = 366055,
  [SMALL_STATE(8613)] = 366097,
  [SMALL_STATE(8614)] = 366139,
  [SMALL_STATE(8615)] = 366163,
  [SMALL_STATE(8616)] = 366205,
  [SMALL_STATE(8617)] = 366229,
  [SMALL_STATE(8618)] = 366271,
  [SMALL_STATE(8619)] = 366295,
  [SMALL_STATE(8620)] = 366319,
  [SMALL_STATE(8621)] = 366361,
  [SMALL_STATE(8622)] = 366401,
  [SMALL_STATE(8623)] = 366441,
  [SMALL_STATE(8624)] = 366465,
  [SMALL_STATE(8625)] = 366507,
  [SMALL_STATE(8626)] = 366531,
  [SMALL_STATE(8627)] = 366555,
  [SMALL_STATE(8628)] = 366579,
  [SMALL_STATE(8629)] = 366603,
  [SMALL_STATE(8630)] = 366645,
  [SMALL_STATE(8631)] = 366687,
  [SMALL_STATE(8632)] = 366729,
  [SMALL_STATE(8633)] = 366753,
  [SMALL_STATE(8634)] = 366777,
  [SMALL_STATE(8635)] = 366819,
  [SMALL_STATE(8636)] = 366843,
  [SMALL_STATE(8637)] = 366867,
  [SMALL_STATE(8638)] = 366909,
  [SMALL_STATE(8639)] = 366933,
  [SMALL_STATE(8640)] = 366961,
  [SMALL_STATE(8641)] = 366985,
  [SMALL_STATE(8642)] = 367017,
  [SMALL_STATE(8643)] = 367045,
  [SMALL_STATE(8644)] = 367085,
  [SMALL_STATE(8645)] = 367109,
  [SMALL_STATE(8646)] = 367133,
  [SMALL_STATE(8647)] = 367157,
  [SMALL_STATE(8648)] = 367181,
  [SMALL_STATE(8649)] = 367223,
  [SMALL_STATE(8650)] = 367247,
  [SMALL_STATE(8651)] = 367289,
  [SMALL_STATE(8652)] = 367323,
  [SMALL_STATE(8653)] = 367347,
  [SMALL_STATE(8654)] = 367387,
  [SMALL_STATE(8655)] = 367411,
  [SMALL_STATE(8656)] = 367435,
  [SMALL_STATE(8657)] = 367477,
  [SMALL_STATE(8658)] = 367501,
  [SMALL_STATE(8659)] = 367543,
  [SMALL_STATE(8660)] = 367585,
  [SMALL_STATE(8661)] = 367609,
  [SMALL_STATE(8662)] = 367633,
  [SMALL_STATE(8663)] = 367673,
  [SMALL_STATE(8664)] = 367713,
  [SMALL_STATE(8665)] = 367745,
  [SMALL_STATE(8666)] = 367769,
  [SMALL_STATE(8667)] = 367801,
  [SMALL_STATE(8668)] = 367841,
  [SMALL_STATE(8669)] = 367883,
  [SMALL_STATE(8670)] = 367907,
  [SMALL_STATE(8671)] = 367949,
  [SMALL_STATE(8672)] = 367973,
  [SMALL_STATE(8673)] = 368013,
  [SMALL_STATE(8674)] = 368037,
  [SMALL_STATE(8675)] = 368061,
  [SMALL_STATE(8676)] = 368089,
  [SMALL_STATE(8677)] = 368113,
  [SMALL_STATE(8678)] = 368137,
  [SMALL_STATE(8679)] = 368177,
  [SMALL_STATE(8680)] = 368201,
  [SMALL_STATE(8681)] = 368225,
  [SMALL_STATE(8682)] = 368267,
  [SMALL_STATE(8683)] = 368309,
  [SMALL_STATE(8684)] = 368333,
  [SMALL_STATE(8685)] = 368375,
  [SMALL_STATE(8686)] = 368399,
  [SMALL_STATE(8687)] = 368441,
  [SMALL_STATE(8688)] = 368465,
  [SMALL_STATE(8689)] = 368507,
  [SMALL_STATE(8690)] = 368531,
  [SMALL_STATE(8691)] = 368555,
  [SMALL_STATE(8692)] = 368579,
  [SMALL_STATE(8693)] = 368603,
  [SMALL_STATE(8694)] = 368645,
  [SMALL_STATE(8695)] = 368669,
  [SMALL_STATE(8696)] = 368693,
  [SMALL_STATE(8697)] = 368725,
  [SMALL_STATE(8698)] = 368767,
  [SMALL_STATE(8699)] = 368791,
  [SMALL_STATE(8700)] = 368833,
  [SMALL_STATE(8701)] = 368875,
  [SMALL_STATE(8702)] = 368899,
  [SMALL_STATE(8703)] = 368923,
  [SMALL_STATE(8704)] = 368965,
  [SMALL_STATE(8705)] = 368989,
  [SMALL_STATE(8706)] = 369013,
  [SMALL_STATE(8707)] = 369055,
  [SMALL_STATE(8708)] = 369079,
  [SMALL_STATE(8709)] = 369121,
  [SMALL_STATE(8710)] = 369163,
  [SMALL_STATE(8711)] = 369203,
  [SMALL_STATE(8712)] = 369245,
  [SMALL_STATE(8713)] = 369269,
  [SMALL_STATE(8714)] = 369309,
  [SMALL_STATE(8715)] = 369351,
  [SMALL_STATE(8716)] = 369393,
  [SMALL_STATE(8717)] = 369417,
  [SMALL_STATE(8718)] = 369441,
  [SMALL_STATE(8719)] = 369465,
  [SMALL_STATE(8720)] = 369507,
  [SMALL_STATE(8721)] = 369542,
  [SMALL_STATE(8722)] = 369581,
  [SMALL_STATE(8723)] = 369604,
  [SMALL_STATE(8724)] = 369639,
  [SMALL_STATE(8725)] = 369678,
  [SMALL_STATE(8726)] = 369701,
  [SMALL_STATE(8727)] = 369738,
  [SMALL_STATE(8728)] = 369761,
  [SMALL_STATE(8729)] = 369782,
  [SMALL_STATE(8730)] = 369803,
  [SMALL_STATE(8731)] = 369826,
  [SMALL_STATE(8732)] = 369865,
  [SMALL_STATE(8733)] = 369902,
  [SMALL_STATE(8734)] = 369923,
  [SMALL_STATE(8735)] = 369962,
  [SMALL_STATE(8736)] = 369999,
  [SMALL_STATE(8737)] = 370022,
  [SMALL_STATE(8738)] = 370057,
  [SMALL_STATE(8739)] = 370096,
  [SMALL_STATE(8740)] = 370131,
  [SMALL_STATE(8741)] = 370154,
  [SMALL_STATE(8742)] = 370177,
  [SMALL_STATE(8743)] = 370200,
  [SMALL_STATE(8744)] = 370235,
  [SMALL_STATE(8745)] = 370274,
  [SMALL_STATE(8746)] = 370309,
  [SMALL_STATE(8747)] = 370332,
  [SMALL_STATE(8748)] = 370355,
  [SMALL_STATE(8749)] = 370376,
  [SMALL_STATE(8750)] = 370397,
  [SMALL_STATE(8751)] = 370420,
  [SMALL_STATE(8752)] = 370441,
  [SMALL_STATE(8753)] = 370480,
  [SMALL_STATE(8754)] = 370501,
  [SMALL_STATE(8755)] = 370522,
  [SMALL_STATE(8756)] = 370543,
  [SMALL_STATE(8757)] = 370566,
  [SMALL_STATE(8758)] = 370587,
  [SMALL_STATE(8759)] = 370622,
  [SMALL_STATE(8760)] = 370645,
  [SMALL_STATE(8761)] = 370666,
  [SMALL_STATE(8762)] = 370689,
  [SMALL_STATE(8763)] = 370710,
  [SMALL_STATE(8764)] = 370733,
  [SMALL_STATE(8765)] = 370756,
  [SMALL_STATE(8766)] = 370779,
  [SMALL_STATE(8767)] = 370802,
  [SMALL_STATE(8768)] = 370823,
  [SMALL_STATE(8769)] = 370846,
  [SMALL_STATE(8770)] = 370869,
  [SMALL_STATE(8771)] = 370890,
  [SMALL_STATE(8772)] = 370913,
  [SMALL_STATE(8773)] = 370936,
  [SMALL_STATE(8774)] = 370959,
  [SMALL_STATE(8775)] = 370995,
  [SMALL_STATE(8776)] = 371031,
  [SMALL_STATE(8777)] = 371061,
  [SMALL_STATE(8778)] = 371083,
  [SMALL_STATE(8779)] = 371109,
  [SMALL_STATE(8780)] = 371131,
  [SMALL_STATE(8781)] = 371167,
  [SMALL_STATE(8782)] = 371203,
  [SMALL_STATE(8783)] = 371229,
  [SMALL_STATE(8784)] = 371255,
  [SMALL_STATE(8785)] = 371291,
  [SMALL_STATE(8786)] = 371327,
  [SMALL_STATE(8787)] = 371363,
  [SMALL_STATE(8788)] = 371399,
  [SMALL_STATE(8789)] = 371435,
  [SMALL_STATE(8790)] = 371471,
  [SMALL_STATE(8791)] = 371507,
  [SMALL_STATE(8792)] = 371529,
  [SMALL_STATE(8793)] = 371565,
  [SMALL_STATE(8794)] = 371601,
  [SMALL_STATE(8795)] = 371623,
  [SMALL_STATE(8796)] = 371659,
  [SMALL_STATE(8797)] = 371695,
  [SMALL_STATE(8798)] = 371731,
  [SMALL_STATE(8799)] = 371767,
  [SMALL_STATE(8800)] = 371803,
  [SMALL_STATE(8801)] = 371839,
  [SMALL_STATE(8802)] = 371875,
  [SMALL_STATE(8803)] = 371907,
  [SMALL_STATE(8804)] = 371943,
  [SMALL_STATE(8805)] = 371979,
  [SMALL_STATE(8806)] = 372015,
  [SMALL_STATE(8807)] = 372051,
  [SMALL_STATE(8808)] = 372087,
  [SMALL_STATE(8809)] = 372123,
  [SMALL_STATE(8810)] = 372159,
  [SMALL_STATE(8811)] = 372195,
  [SMALL_STATE(8812)] = 372231,
  [SMALL_STATE(8813)] = 372267,
  [SMALL_STATE(8814)] = 372303,
  [SMALL_STATE(8815)] = 372339,
  [SMALL_STATE(8816)] = 372375,
  [SMALL_STATE(8817)] = 372403,
  [SMALL_STATE(8818)] = 372439,
  [SMALL_STATE(8819)] = 372475,
  [SMALL_STATE(8820)] = 372511,
  [SMALL_STATE(8821)] = 372547,
  [SMALL_STATE(8822)] = 372583,
  [SMALL_STATE(8823)] = 372619,
  [SMALL_STATE(8824)] = 372655,
  [SMALL_STATE(8825)] = 372691,
  [SMALL_STATE(8826)] = 372727,
  [SMALL_STATE(8827)] = 372749,
  [SMALL_STATE(8828)] = 372781,
  [SMALL_STATE(8829)] = 372817,
  [SMALL_STATE(8830)] = 372853,
  [SMALL_STATE(8831)] = 372889,
  [SMALL_STATE(8832)] = 372925,
  [SMALL_STATE(8833)] = 372961,
  [SMALL_STATE(8834)] = 372993,
  [SMALL_STATE(8835)] = 373025,
  [SMALL_STATE(8836)] = 373061,
  [SMALL_STATE(8837)] = 373083,
  [SMALL_STATE(8838)] = 373119,
  [SMALL_STATE(8839)] = 373141,
  [SMALL_STATE(8840)] = 373163,
  [SMALL_STATE(8841)] = 373199,
  [SMALL_STATE(8842)] = 373235,
  [SMALL_STATE(8843)] = 373261,
  [SMALL_STATE(8844)] = 373297,
  [SMALL_STATE(8845)] = 373331,
  [SMALL_STATE(8846)] = 373365,
  [SMALL_STATE(8847)] = 373393,
  [SMALL_STATE(8848)] = 373427,
  [SMALL_STATE(8849)] = 373463,
  [SMALL_STATE(8850)] = 373497,
  [SMALL_STATE(8851)] = 373519,
  [SMALL_STATE(8852)] = 373555,
  [SMALL_STATE(8853)] = 373581,
  [SMALL_STATE(8854)] = 373609,
  [SMALL_STATE(8855)] = 373631,
  [SMALL_STATE(8856)] = 373653,
  [SMALL_STATE(8857)] = 373689,
  [SMALL_STATE(8858)] = 373711,
  [SMALL_STATE(8859)] = 373739,
  [SMALL_STATE(8860)] = 373760,
  [SMALL_STATE(8861)] = 373781,
  [SMALL_STATE(8862)] = 373802,
  [SMALL_STATE(8863)] = 373821,
  [SMALL_STATE(8864)] = 373844,
  [SMALL_STATE(8865)] = 373869,
  [SMALL_STATE(8866)] = 373902,
  [SMALL_STATE(8867)] = 373929,
  [SMALL_STATE(8868)] = 373950,
  [SMALL_STATE(8869)] = 373971,
  [SMALL_STATE(8870)] = 374004,
  [SMALL_STATE(8871)] = 374037,
  [SMALL_STATE(8872)] = 374064,
  [SMALL_STATE(8873)] = 374091,
  [SMALL_STATE(8874)] = 374112,
  [SMALL_STATE(8875)] = 374143,
  [SMALL_STATE(8876)] = 374162,
  [SMALL_STATE(8877)] = 374195,
  [SMALL_STATE(8878)] = 374214,
  [SMALL_STATE(8879)] = 374233,
  [SMALL_STATE(8880)] = 374266,
  [SMALL_STATE(8881)] = 374287,
  [SMALL_STATE(8882)] = 374308,
  [SMALL_STATE(8883)] = 374327,
  [SMALL_STATE(8884)] = 374350,
  [SMALL_STATE(8885)] = 374371,
  [SMALL_STATE(8886)] = 374390,
  [SMALL_STATE(8887)] = 374423,
  [SMALL_STATE(8888)] = 374444,
  [SMALL_STATE(8889)] = 374479,
  [SMALL_STATE(8890)] = 374500,
  [SMALL_STATE(8891)] = 374521,
  [SMALL_STATE(8892)] = 374554,
  [SMALL_STATE(8893)] = 374587,
  [SMALL_STATE(8894)] = 374616,
  [SMALL_STATE(8895)] = 374649,
  [SMALL_STATE(8896)] = 374670,
  [SMALL_STATE(8897)] = 374691,
  [SMALL_STATE(8898)] = 374724,
  [SMALL_STATE(8899)] = 374745,
  [SMALL_STATE(8900)] = 374766,
  [SMALL_STATE(8901)] = 374787,
  [SMALL_STATE(8902)] = 374808,
  [SMALL_STATE(8903)] = 374829,
  [SMALL_STATE(8904)] = 374850,
  [SMALL_STATE(8905)] = 374871,
  [SMALL_STATE(8906)] = 374906,
  [SMALL_STATE(8907)] = 374931,
  [SMALL_STATE(8908)] = 374964,
  [SMALL_STATE(8909)] = 374985,
  [SMALL_STATE(8910)] = 375006,
  [SMALL_STATE(8911)] = 375039,
  [SMALL_STATE(8912)] = 375072,
  [SMALL_STATE(8913)] = 375099,
  [SMALL_STATE(8914)] = 375132,
  [SMALL_STATE(8915)] = 375167,
  [SMALL_STATE(8916)] = 375200,
  [SMALL_STATE(8917)] = 375219,
  [SMALL_STATE(8918)] = 375240,
  [SMALL_STATE(8919)] = 375261,
  [SMALL_STATE(8920)] = 375282,
  [SMALL_STATE(8921)] = 375301,
  [SMALL_STATE(8922)] = 375334,
  [SMALL_STATE(8923)] = 375355,
  [SMALL_STATE(8924)] = 375382,
  [SMALL_STATE(8925)] = 375403,
  [SMALL_STATE(8926)] = 375422,
  [SMALL_STATE(8927)] = 375455,
  [SMALL_STATE(8928)] = 375476,
  [SMALL_STATE(8929)] = 375509,
  [SMALL_STATE(8930)] = 375538,
  [SMALL_STATE(8931)] = 375559,
  [SMALL_STATE(8932)] = 375580,
  [SMALL_STATE(8933)] = 375601,
  [SMALL_STATE(8934)] = 375624,
  [SMALL_STATE(8935)] = 375651,
  [SMALL_STATE(8936)] = 375680,
  [SMALL_STATE(8937)] = 375709,
  [SMALL_STATE(8938)] = 375730,
  [SMALL_STATE(8939)] = 375765,
  [SMALL_STATE(8940)] = 375798,
  [SMALL_STATE(8941)] = 375831,
  [SMALL_STATE(8942)] = 375864,
  [SMALL_STATE(8943)] = 375885,
  [SMALL_STATE(8944)] = 375916,
  [SMALL_STATE(8945)] = 375935,
  [SMALL_STATE(8946)] = 375954,
  [SMALL_STATE(8947)] = 375973,
  [SMALL_STATE(8948)] = 375992,
  [SMALL_STATE(8949)] = 376011,
  [SMALL_STATE(8950)] = 376030,
  [SMALL_STATE(8951)] = 376065,
  [SMALL_STATE(8952)] = 376091,
  [SMALL_STATE(8953)] = 376117,
  [SMALL_STATE(8954)] = 376143,
  [SMALL_STATE(8955)] = 376169,
  [SMALL_STATE(8956)] = 376195,
  [SMALL_STATE(8957)] = 376213,
  [SMALL_STATE(8958)] = 376231,
  [SMALL_STATE(8959)] = 376249,
  [SMALL_STATE(8960)] = 376281,
  [SMALL_STATE(8961)] = 376299,
  [SMALL_STATE(8962)] = 376325,
  [SMALL_STATE(8963)] = 376351,
  [SMALL_STATE(8964)] = 376377,
  [SMALL_STATE(8965)] = 376395,
  [SMALL_STATE(8966)] = 376413,
  [SMALL_STATE(8967)] = 376431,
  [SMALL_STATE(8968)] = 376449,
  [SMALL_STATE(8969)] = 376467,
  [SMALL_STATE(8970)] = 376493,
  [SMALL_STATE(8971)] = 376525,
  [SMALL_STATE(8972)] = 376543,
  [SMALL_STATE(8973)] = 376573,
  [SMALL_STATE(8974)] = 376593,
  [SMALL_STATE(8975)] = 376625,
  [SMALL_STATE(8976)] = 376645,
  [SMALL_STATE(8977)] = 376673,
  [SMALL_STATE(8978)] = 376703,
  [SMALL_STATE(8979)] = 376723,
  [SMALL_STATE(8980)] = 376743,
  [SMALL_STATE(8981)] = 376761,
  [SMALL_STATE(8982)] = 376781,
  [SMALL_STATE(8983)] = 376799,
  [SMALL_STATE(8984)] = 376819,
  [SMALL_STATE(8985)] = 376839,
  [SMALL_STATE(8986)] = 376859,
  [SMALL_STATE(8987)] = 376877,
  [SMALL_STATE(8988)] = 376897,
  [SMALL_STATE(8989)] = 376917,
  [SMALL_STATE(8990)] = 376939,
  [SMALL_STATE(8991)] = 376957,
  [SMALL_STATE(8992)] = 376983,
  [SMALL_STATE(8993)] = 377009,
  [SMALL_STATE(8994)] = 377027,
  [SMALL_STATE(8995)] = 377053,
  [SMALL_STATE(8996)] = 377077,
  [SMALL_STATE(8997)] = 377095,
  [SMALL_STATE(8998)] = 377121,
  [SMALL_STATE(8999)] = 377147,
  [SMALL_STATE(9000)] = 377179,
  [SMALL_STATE(9001)] = 377199,
  [SMALL_STATE(9002)] = 377217,
  [SMALL_STATE(9003)] = 377235,
  [SMALL_STATE(9004)] = 377261,
  [SMALL_STATE(9005)] = 377287,
  [SMALL_STATE(9006)] = 377313,
  [SMALL_STATE(9007)] = 377339,
  [SMALL_STATE(9008)] = 377365,
  [SMALL_STATE(9009)] = 377391,
  [SMALL_STATE(9010)] = 377417,
  [SMALL_STATE(9011)] = 377443,
  [SMALL_STATE(9012)] = 377469,
  [SMALL_STATE(9013)] = 377487,
  [SMALL_STATE(9014)] = 377505,
  [SMALL_STATE(9015)] = 377523,
  [SMALL_STATE(9016)] = 377553,
  [SMALL_STATE(9017)] = 377579,
  [SMALL_STATE(9018)] = 377597,
  [SMALL_STATE(9019)] = 377623,
  [SMALL_STATE(9020)] = 377641,
  [SMALL_STATE(9021)] = 377667,
  [SMALL_STATE(9022)] = 377685,
  [SMALL_STATE(9023)] = 377703,
  [SMALL_STATE(9024)] = 377723,
  [SMALL_STATE(9025)] = 377749,
  [SMALL_STATE(9026)] = 377775,
  [SMALL_STATE(9027)] = 377801,
  [SMALL_STATE(9028)] = 377827,
  [SMALL_STATE(9029)] = 377853,
  [SMALL_STATE(9030)] = 377879,
  [SMALL_STATE(9031)] = 377907,
  [SMALL_STATE(9032)] = 377925,
  [SMALL_STATE(9033)] = 377943,
  [SMALL_STATE(9034)] = 377969,
  [SMALL_STATE(9035)] = 378001,
  [SMALL_STATE(9036)] = 378033,
  [SMALL_STATE(9037)] = 378063,
  [SMALL_STATE(9038)] = 378081,
  [SMALL_STATE(9039)] = 378099,
  [SMALL_STATE(9040)] = 378117,
  [SMALL_STATE(9041)] = 378135,
  [SMALL_STATE(9042)] = 378153,
  [SMALL_STATE(9043)] = 378171,
  [SMALL_STATE(9044)] = 378197,
  [SMALL_STATE(9045)] = 378215,
  [SMALL_STATE(9046)] = 378247,
  [SMALL_STATE(9047)] = 378273,
  [SMALL_STATE(9048)] = 378291,
  [SMALL_STATE(9049)] = 378309,
  [SMALL_STATE(9050)] = 378341,
  [SMALL_STATE(9051)] = 378367,
  [SMALL_STATE(9052)] = 378387,
  [SMALL_STATE(9053)] = 378407,
  [SMALL_STATE(9054)] = 378427,
  [SMALL_STATE(9055)] = 378449,
  [SMALL_STATE(9056)] = 378467,
  [SMALL_STATE(9057)] = 378485,
  [SMALL_STATE(9058)] = 378503,
  [SMALL_STATE(9059)] = 378533,
  [SMALL_STATE(9060)] = 378559,
  [SMALL_STATE(9061)] = 378585,
  [SMALL_STATE(9062)] = 378615,
  [SMALL_STATE(9063)] = 378641,
  [SMALL_STATE(9064)] = 378667,
  [SMALL_STATE(9065)] = 378693,
  [SMALL_STATE(9066)] = 378711,
  [SMALL_STATE(9067)] = 378741,
  [SMALL_STATE(9068)] = 378767,
  [SMALL_STATE(9069)] = 378793,
  [SMALL_STATE(9070)] = 378815,
  [SMALL_STATE(9071)] = 378841,
  [SMALL_STATE(9072)] = 378873,
  [SMALL_STATE(9073)] = 378903,
  [SMALL_STATE(9074)] = 378921,
  [SMALL_STATE(9075)] = 378947,
  [SMALL_STATE(9076)] = 378967,
  [SMALL_STATE(9077)] = 378993,
  [SMALL_STATE(9078)] = 379021,
  [SMALL_STATE(9079)] = 379051,
  [SMALL_STATE(9080)] = 379069,
  [SMALL_STATE(9081)] = 379087,
  [SMALL_STATE(9082)] = 379105,
  [SMALL_STATE(9083)] = 379123,
  [SMALL_STATE(9084)] = 379141,
  [SMALL_STATE(9085)] = 379159,
  [SMALL_STATE(9086)] = 379177,
  [SMALL_STATE(9087)] = 379195,
  [SMALL_STATE(9088)] = 379213,
  [SMALL_STATE(9089)] = 379231,
  [SMALL_STATE(9090)] = 379251,
  [SMALL_STATE(9091)] = 379277,
  [SMALL_STATE(9092)] = 379303,
  [SMALL_STATE(9093)] = 379323,
  [SMALL_STATE(9094)] = 379341,
  [SMALL_STATE(9095)] = 379371,
  [SMALL_STATE(9096)] = 379391,
  [SMALL_STATE(9097)] = 379423,
  [SMALL_STATE(9098)] = 379441,
  [SMALL_STATE(9099)] = 379473,
  [SMALL_STATE(9100)] = 379491,
  [SMALL_STATE(9101)] = 379509,
  [SMALL_STATE(9102)] = 379533,
  [SMALL_STATE(9103)] = 379553,
  [SMALL_STATE(9104)] = 379579,
  [SMALL_STATE(9105)] = 379597,
  [SMALL_STATE(9106)] = 379623,
  [SMALL_STATE(9107)] = 379643,
  [SMALL_STATE(9108)] = 379669,
  [SMALL_STATE(9109)] = 379689,
  [SMALL_STATE(9110)] = 379715,
  [SMALL_STATE(9111)] = 379741,
  [SMALL_STATE(9112)] = 379759,
  [SMALL_STATE(9113)] = 379785,
  [SMALL_STATE(9114)] = 379811,
  [SMALL_STATE(9115)] = 379837,
  [SMALL_STATE(9116)] = 379855,
  [SMALL_STATE(9117)] = 379881,
  [SMALL_STATE(9118)] = 379907,
  [SMALL_STATE(9119)] = 379925,
  [SMALL_STATE(9120)] = 379945,
  [SMALL_STATE(9121)] = 379963,
  [SMALL_STATE(9122)] = 379981,
  [SMALL_STATE(9123)] = 379999,
  [SMALL_STATE(9124)] = 380017,
  [SMALL_STATE(9125)] = 380043,
  [SMALL_STATE(9126)] = 380069,
  [SMALL_STATE(9127)] = 380095,
  [SMALL_STATE(9128)] = 380121,
  [SMALL_STATE(9129)] = 380147,
  [SMALL_STATE(9130)] = 380173,
  [SMALL_STATE(9131)] = 380199,
  [SMALL_STATE(9132)] = 380225,
  [SMALL_STATE(9133)] = 380251,
  [SMALL_STATE(9134)] = 380269,
  [SMALL_STATE(9135)] = 380295,
  [SMALL_STATE(9136)] = 380315,
  [SMALL_STATE(9137)] = 380341,
  [SMALL_STATE(9138)] = 380371,
  [SMALL_STATE(9139)] = 380397,
  [SMALL_STATE(9140)] = 380423,
  [SMALL_STATE(9141)] = 380455,
  [SMALL_STATE(9142)] = 380482,
  [SMALL_STATE(9143)] = 380509,
  [SMALL_STATE(9144)] = 380536,
  [SMALL_STATE(9145)] = 380565,
  [SMALL_STATE(9146)] = 380592,
  [SMALL_STATE(9147)] = 380619,
  [SMALL_STATE(9148)] = 380646,
  [SMALL_STATE(9149)] = 380673,
  [SMALL_STATE(9150)] = 380700,
  [SMALL_STATE(9151)] = 380729,
  [SMALL_STATE(9152)] = 380756,
  [SMALL_STATE(9153)] = 380783,
  [SMALL_STATE(9154)] = 380810,
  [SMALL_STATE(9155)] = 380839,
  [SMALL_STATE(9156)] = 380868,
  [SMALL_STATE(9157)] = 380897,
  [SMALL_STATE(9158)] = 380924,
  [SMALL_STATE(9159)] = 380951,
  [SMALL_STATE(9160)] = 380978,
  [SMALL_STATE(9161)] = 381001,
  [SMALL_STATE(9162)] = 381030,
  [SMALL_STATE(9163)] = 381057,
  [SMALL_STATE(9164)] = 381084,
  [SMALL_STATE(9165)] = 381113,
  [SMALL_STATE(9166)] = 381134,
  [SMALL_STATE(9167)] = 381163,
  [SMALL_STATE(9168)] = 381190,
  [SMALL_STATE(9169)] = 381217,
  [SMALL_STATE(9170)] = 381246,
  [SMALL_STATE(9171)] = 381275,
  [SMALL_STATE(9172)] = 381302,
  [SMALL_STATE(9173)] = 381329,
  [SMALL_STATE(9174)] = 381356,
  [SMALL_STATE(9175)] = 381385,
  [SMALL_STATE(9176)] = 381414,
  [SMALL_STATE(9177)] = 381441,
  [SMALL_STATE(9178)] = 381458,
  [SMALL_STATE(9179)] = 381487,
  [SMALL_STATE(9180)] = 381514,
  [SMALL_STATE(9181)] = 381541,
  [SMALL_STATE(9182)] = 381568,
  [SMALL_STATE(9183)] = 381595,
  [SMALL_STATE(9184)] = 381624,
  [SMALL_STATE(9185)] = 381651,
  [SMALL_STATE(9186)] = 381678,
  [SMALL_STATE(9187)] = 381705,
  [SMALL_STATE(9188)] = 381732,
  [SMALL_STATE(9189)] = 381761,
  [SMALL_STATE(9190)] = 381790,
  [SMALL_STATE(9191)] = 381817,
  [SMALL_STATE(9192)] = 381846,
  [SMALL_STATE(9193)] = 381875,
  [SMALL_STATE(9194)] = 381902,
  [SMALL_STATE(9195)] = 381929,
  [SMALL_STATE(9196)] = 381956,
  [SMALL_STATE(9197)] = 381985,
  [SMALL_STATE(9198)] = 382014,
  [SMALL_STATE(9199)] = 382041,
  [SMALL_STATE(9200)] = 382068,
  [SMALL_STATE(9201)] = 382095,
  [SMALL_STATE(9202)] = 382122,
  [SMALL_STATE(9203)] = 382149,
  [SMALL_STATE(9204)] = 382176,
  [SMALL_STATE(9205)] = 382205,
  [SMALL_STATE(9206)] = 382232,
  [SMALL_STATE(9207)] = 382259,
  [SMALL_STATE(9208)] = 382286,
  [SMALL_STATE(9209)] = 382313,
  [SMALL_STATE(9210)] = 382340,
  [SMALL_STATE(9211)] = 382367,
  [SMALL_STATE(9212)] = 382394,
  [SMALL_STATE(9213)] = 382423,
  [SMALL_STATE(9214)] = 382450,
  [SMALL_STATE(9215)] = 382477,
  [SMALL_STATE(9216)] = 382504,
  [SMALL_STATE(9217)] = 382531,
  [SMALL_STATE(9218)] = 382550,
  [SMALL_STATE(9219)] = 382577,
  [SMALL_STATE(9220)] = 382606,
  [SMALL_STATE(9221)] = 382635,
  [SMALL_STATE(9222)] = 382664,
  [SMALL_STATE(9223)] = 382693,
  [SMALL_STATE(9224)] = 382722,
  [SMALL_STATE(9225)] = 382749,
  [SMALL_STATE(9226)] = 382772,
  [SMALL_STATE(9227)] = 382799,
  [SMALL_STATE(9228)] = 382828,
  [SMALL_STATE(9229)] = 382855,
  [SMALL_STATE(9230)] = 382882,
  [SMALL_STATE(9231)] = 382911,
  [SMALL_STATE(9232)] = 382940,
  [SMALL_STATE(9233)] = 382969,
  [SMALL_STATE(9234)] = 382996,
  [SMALL_STATE(9235)] = 383025,
  [SMALL_STATE(9236)] = 383052,
  [SMALL_STATE(9237)] = 383079,
  [SMALL_STATE(9238)] = 383108,
  [SMALL_STATE(9239)] = 383137,
  [SMALL_STATE(9240)] = 383164,
  [SMALL_STATE(9241)] = 383191,
  [SMALL_STATE(9242)] = 383218,
  [SMALL_STATE(9243)] = 383245,
  [SMALL_STATE(9244)] = 383272,
  [SMALL_STATE(9245)] = 383301,
  [SMALL_STATE(9246)] = 383328,
  [SMALL_STATE(9247)] = 383349,
  [SMALL_STATE(9248)] = 383378,
  [SMALL_STATE(9249)] = 383399,
  [SMALL_STATE(9250)] = 383428,
  [SMALL_STATE(9251)] = 383457,
  [SMALL_STATE(9252)] = 383482,
  [SMALL_STATE(9253)] = 383511,
  [SMALL_STATE(9254)] = 383538,
  [SMALL_STATE(9255)] = 383567,
  [SMALL_STATE(9256)] = 383594,
  [SMALL_STATE(9257)] = 383621,
  [SMALL_STATE(9258)] = 383648,
  [SMALL_STATE(9259)] = 383671,
  [SMALL_STATE(9260)] = 383700,
  [SMALL_STATE(9261)] = 383727,
  [SMALL_STATE(9262)] = 383756,
  [SMALL_STATE(9263)] = 383785,
  [SMALL_STATE(9264)] = 383814,
  [SMALL_STATE(9265)] = 383841,
  [SMALL_STATE(9266)] = 383858,
  [SMALL_STATE(9267)] = 383887,
  [SMALL_STATE(9268)] = 383914,
  [SMALL_STATE(9269)] = 383941,
  [SMALL_STATE(9270)] = 383970,
  [SMALL_STATE(9271)] = 383999,
  [SMALL_STATE(9272)] = 384028,
  [SMALL_STATE(9273)] = 384055,
  [SMALL_STATE(9274)] = 384074,
  [SMALL_STATE(9275)] = 384101,
  [SMALL_STATE(9276)] = 384128,
  [SMALL_STATE(9277)] = 384149,
  [SMALL_STATE(9278)] = 384176,
  [SMALL_STATE(9279)] = 384205,
  [SMALL_STATE(9280)] = 384234,
  [SMALL_STATE(9281)] = 384261,
  [SMALL_STATE(9282)] = 384290,
  [SMALL_STATE(9283)] = 384317,
  [SMALL_STATE(9284)] = 384344,
  [SMALL_STATE(9285)] = 384371,
  [SMALL_STATE(9286)] = 384400,
  [SMALL_STATE(9287)] = 384427,
  [SMALL_STATE(9288)] = 384456,
  [SMALL_STATE(9289)] = 384485,
  [SMALL_STATE(9290)] = 384512,
  [SMALL_STATE(9291)] = 384539,
  [SMALL_STATE(9292)] = 384566,
  [SMALL_STATE(9293)] = 384583,
  [SMALL_STATE(9294)] = 384610,
  [SMALL_STATE(9295)] = 384637,
  [SMALL_STATE(9296)] = 384664,
  [SMALL_STATE(9297)] = 384693,
  [SMALL_STATE(9298)] = 384720,
  [SMALL_STATE(9299)] = 384747,
  [SMALL_STATE(9300)] = 384774,
  [SMALL_STATE(9301)] = 384801,
  [SMALL_STATE(9302)] = 384828,
  [SMALL_STATE(9303)] = 384855,
  [SMALL_STATE(9304)] = 384882,
  [SMALL_STATE(9305)] = 384909,
  [SMALL_STATE(9306)] = 384936,
  [SMALL_STATE(9307)] = 384953,
  [SMALL_STATE(9308)] = 384980,
  [SMALL_STATE(9309)] = 385001,
  [SMALL_STATE(9310)] = 385028,
  [SMALL_STATE(9311)] = 385055,
  [SMALL_STATE(9312)] = 385078,
  [SMALL_STATE(9313)] = 385107,
  [SMALL_STATE(9314)] = 385134,
  [SMALL_STATE(9315)] = 385161,
  [SMALL_STATE(9316)] = 385182,
  [SMALL_STATE(9317)] = 385211,
  [SMALL_STATE(9318)] = 385238,
  [SMALL_STATE(9319)] = 385267,
  [SMALL_STATE(9320)] = 385294,
  [SMALL_STATE(9321)] = 385321,
  [SMALL_STATE(9322)] = 385348,
  [SMALL_STATE(9323)] = 385375,
  [SMALL_STATE(9324)] = 385402,
  [SMALL_STATE(9325)] = 385429,
  [SMALL_STATE(9326)] = 385456,
  [SMALL_STATE(9327)] = 385483,
  [SMALL_STATE(9328)] = 385510,
  [SMALL_STATE(9329)] = 385537,
  [SMALL_STATE(9330)] = 385564,
  [SMALL_STATE(9331)] = 385591,
  [SMALL_STATE(9332)] = 385610,
  [SMALL_STATE(9333)] = 385637,
  [SMALL_STATE(9334)] = 385664,
  [SMALL_STATE(9335)] = 385693,
  [SMALL_STATE(9336)] = 385720,
  [SMALL_STATE(9337)] = 385747,
  [SMALL_STATE(9338)] = 385776,
  [SMALL_STATE(9339)] = 385793,
  [SMALL_STATE(9340)] = 385820,
  [SMALL_STATE(9341)] = 385847,
  [SMALL_STATE(9342)] = 385864,
  [SMALL_STATE(9343)] = 385891,
  [SMALL_STATE(9344)] = 385918,
  [SMALL_STATE(9345)] = 385945,
  [SMALL_STATE(9346)] = 385972,
  [SMALL_STATE(9347)] = 385999,
  [SMALL_STATE(9348)] = 386026,
  [SMALL_STATE(9349)] = 386055,
  [SMALL_STATE(9350)] = 386082,
  [SMALL_STATE(9351)] = 386109,
  [SMALL_STATE(9352)] = 386126,
  [SMALL_STATE(9353)] = 386153,
  [SMALL_STATE(9354)] = 386182,
  [SMALL_STATE(9355)] = 386209,
  [SMALL_STATE(9356)] = 386226,
  [SMALL_STATE(9357)] = 386243,
  [SMALL_STATE(9358)] = 386272,
  [SMALL_STATE(9359)] = 386301,
  [SMALL_STATE(9360)] = 386328,
  [SMALL_STATE(9361)] = 386355,
  [SMALL_STATE(9362)] = 386372,
  [SMALL_STATE(9363)] = 386399,
  [SMALL_STATE(9364)] = 386416,
  [SMALL_STATE(9365)] = 386433,
  [SMALL_STATE(9366)] = 386462,
  [SMALL_STATE(9367)] = 386489,
  [SMALL_STATE(9368)] = 386516,
  [SMALL_STATE(9369)] = 386545,
  [SMALL_STATE(9370)] = 386574,
  [SMALL_STATE(9371)] = 386601,
  [SMALL_STATE(9372)] = 386618,
  [SMALL_STATE(9373)] = 386645,
  [SMALL_STATE(9374)] = 386672,
  [SMALL_STATE(9375)] = 386699,
  [SMALL_STATE(9376)] = 386728,
  [SMALL_STATE(9377)] = 386755,
  [SMALL_STATE(9378)] = 386782,
  [SMALL_STATE(9379)] = 386809,
  [SMALL_STATE(9380)] = 386828,
  [SMALL_STATE(9381)] = 386857,
  [SMALL_STATE(9382)] = 386886,
  [SMALL_STATE(9383)] = 386913,
  [SMALL_STATE(9384)] = 386942,
  [SMALL_STATE(9385)] = 386971,
  [SMALL_STATE(9386)] = 386998,
  [SMALL_STATE(9387)] = 387017,
  [SMALL_STATE(9388)] = 387044,
  [SMALL_STATE(9389)] = 387071,
  [SMALL_STATE(9390)] = 387090,
  [SMALL_STATE(9391)] = 387109,
  [SMALL_STATE(9392)] = 387136,
  [SMALL_STATE(9393)] = 387163,
  [SMALL_STATE(9394)] = 387190,
  [SMALL_STATE(9395)] = 387217,
  [SMALL_STATE(9396)] = 387236,
  [SMALL_STATE(9397)] = 387255,
  [SMALL_STATE(9398)] = 387278,
  [SMALL_STATE(9399)] = 387305,
  [SMALL_STATE(9400)] = 387332,
  [SMALL_STATE(9401)] = 387361,
  [SMALL_STATE(9402)] = 387388,
  [SMALL_STATE(9403)] = 387409,
  [SMALL_STATE(9404)] = 387438,
  [SMALL_STATE(9405)] = 387465,
  [SMALL_STATE(9406)] = 387492,
  [SMALL_STATE(9407)] = 387519,
  [SMALL_STATE(9408)] = 387546,
  [SMALL_STATE(9409)] = 387567,
  [SMALL_STATE(9410)] = 387596,
  [SMALL_STATE(9411)] = 387617,
  [SMALL_STATE(9412)] = 387640,
  [SMALL_STATE(9413)] = 387669,
  [SMALL_STATE(9414)] = 387686,
  [SMALL_STATE(9415)] = 387715,
  [SMALL_STATE(9416)] = 387742,
  [SMALL_STATE(9417)] = 387759,
  [SMALL_STATE(9418)] = 387786,
  [SMALL_STATE(9419)] = 387807,
  [SMALL_STATE(9420)] = 387834,
  [SMALL_STATE(9421)] = 387863,
  [SMALL_STATE(9422)] = 387890,
  [SMALL_STATE(9423)] = 387913,
  [SMALL_STATE(9424)] = 387940,
  [SMALL_STATE(9425)] = 387967,
  [SMALL_STATE(9426)] = 387988,
  [SMALL_STATE(9427)] = 388015,
  [SMALL_STATE(9428)] = 388044,
  [SMALL_STATE(9429)] = 388073,
  [SMALL_STATE(9430)] = 388100,
  [SMALL_STATE(9431)] = 388129,
  [SMALL_STATE(9432)] = 388158,
  [SMALL_STATE(9433)] = 388179,
  [SMALL_STATE(9434)] = 388208,
  [SMALL_STATE(9435)] = 388237,
  [SMALL_STATE(9436)] = 388266,
  [SMALL_STATE(9437)] = 388295,
  [SMALL_STATE(9438)] = 388318,
  [SMALL_STATE(9439)] = 388345,
  [SMALL_STATE(9440)] = 388374,
  [SMALL_STATE(9441)] = 388403,
  [SMALL_STATE(9442)] = 388432,
  [SMALL_STATE(9443)] = 388461,
  [SMALL_STATE(9444)] = 388488,
  [SMALL_STATE(9445)] = 388513,
  [SMALL_STATE(9446)] = 388540,
  [SMALL_STATE(9447)] = 388567,
  [SMALL_STATE(9448)] = 388596,
  [SMALL_STATE(9449)] = 388625,
  [SMALL_STATE(9450)] = 388646,
  [SMALL_STATE(9451)] = 388669,
  [SMALL_STATE(9452)] = 388696,
  [SMALL_STATE(9453)] = 388723,
  [SMALL_STATE(9454)] = 388746,
  [SMALL_STATE(9455)] = 388773,
  [SMALL_STATE(9456)] = 388800,
  [SMALL_STATE(9457)] = 388821,
  [SMALL_STATE(9458)] = 388850,
  [SMALL_STATE(9459)] = 388877,
  [SMALL_STATE(9460)] = 388906,
  [SMALL_STATE(9461)] = 388935,
  [SMALL_STATE(9462)] = 388962,
  [SMALL_STATE(9463)] = 388983,
  [SMALL_STATE(9464)] = 389012,
  [SMALL_STATE(9465)] = 389041,
  [SMALL_STATE(9466)] = 389068,
  [SMALL_STATE(9467)] = 389097,
  [SMALL_STATE(9468)] = 389118,
  [SMALL_STATE(9469)] = 389147,
  [SMALL_STATE(9470)] = 389176,
  [SMALL_STATE(9471)] = 389205,
  [SMALL_STATE(9472)] = 389234,
  [SMALL_STATE(9473)] = 389263,
  [SMALL_STATE(9474)] = 389292,
  [SMALL_STATE(9475)] = 389319,
  [SMALL_STATE(9476)] = 389348,
  [SMALL_STATE(9477)] = 389371,
  [SMALL_STATE(9478)] = 389398,
  [SMALL_STATE(9479)] = 389427,
  [SMALL_STATE(9480)] = 389454,
  [SMALL_STATE(9481)] = 389483,
  [SMALL_STATE(9482)] = 389510,
  [SMALL_STATE(9483)] = 389531,
  [SMALL_STATE(9484)] = 389558,
  [SMALL_STATE(9485)] = 389587,
  [SMALL_STATE(9486)] = 389614,
  [SMALL_STATE(9487)] = 389631,
  [SMALL_STATE(9488)] = 389658,
  [SMALL_STATE(9489)] = 389685,
  [SMALL_STATE(9490)] = 389712,
  [SMALL_STATE(9491)] = 389741,
  [SMALL_STATE(9492)] = 389768,
  [SMALL_STATE(9493)] = 389795,
  [SMALL_STATE(9494)] = 389822,
  [SMALL_STATE(9495)] = 389849,
  [SMALL_STATE(9496)] = 389876,
  [SMALL_STATE(9497)] = 389903,
  [SMALL_STATE(9498)] = 389930,
  [SMALL_STATE(9499)] = 389959,
  [SMALL_STATE(9500)] = 389980,
  [SMALL_STATE(9501)] = 390009,
  [SMALL_STATE(9502)] = 390036,
  [SMALL_STATE(9503)] = 390065,
  [SMALL_STATE(9504)] = 390092,
  [SMALL_STATE(9505)] = 390119,
  [SMALL_STATE(9506)] = 390146,
  [SMALL_STATE(9507)] = 390171,
  [SMALL_STATE(9508)] = 390194,
  [SMALL_STATE(9509)] = 390223,
  [SMALL_STATE(9510)] = 390252,
  [SMALL_STATE(9511)] = 390273,
  [SMALL_STATE(9512)] = 390302,
  [SMALL_STATE(9513)] = 390331,
  [SMALL_STATE(9514)] = 390358,
  [SMALL_STATE(9515)] = 390385,
  [SMALL_STATE(9516)] = 390412,
  [SMALL_STATE(9517)] = 390441,
  [SMALL_STATE(9518)] = 390468,
  [SMALL_STATE(9519)] = 390495,
  [SMALL_STATE(9520)] = 390522,
  [SMALL_STATE(9521)] = 390549,
  [SMALL_STATE(9522)] = 390576,
  [SMALL_STATE(9523)] = 390603,
  [SMALL_STATE(9524)] = 390630,
  [SMALL_STATE(9525)] = 390657,
  [SMALL_STATE(9526)] = 390684,
  [SMALL_STATE(9527)] = 390713,
  [SMALL_STATE(9528)] = 390742,
  [SMALL_STATE(9529)] = 390769,
  [SMALL_STATE(9530)] = 390798,
  [SMALL_STATE(9531)] = 390825,
  [SMALL_STATE(9532)] = 390854,
  [SMALL_STATE(9533)] = 390881,
  [SMALL_STATE(9534)] = 390908,
  [SMALL_STATE(9535)] = 390937,
  [SMALL_STATE(9536)] = 390966,
  [SMALL_STATE(9537)] = 390995,
  [SMALL_STATE(9538)] = 391022,
  [SMALL_STATE(9539)] = 391049,
  [SMALL_STATE(9540)] = 391076,
  [SMALL_STATE(9541)] = 391093,
  [SMALL_STATE(9542)] = 391117,
  [SMALL_STATE(9543)] = 391139,
  [SMALL_STATE(9544)] = 391155,
  [SMALL_STATE(9545)] = 391177,
  [SMALL_STATE(9546)] = 391193,
  [SMALL_STATE(9547)] = 391209,
  [SMALL_STATE(9548)] = 391225,
  [SMALL_STATE(9549)] = 391241,
  [SMALL_STATE(9550)] = 391257,
  [SMALL_STATE(9551)] = 391279,
  [SMALL_STATE(9552)] = 391295,
  [SMALL_STATE(9553)] = 391311,
  [SMALL_STATE(9554)] = 391333,
  [SMALL_STATE(9555)] = 391349,
  [SMALL_STATE(9556)] = 391365,
  [SMALL_STATE(9557)] = 391381,
  [SMALL_STATE(9558)] = 391405,
  [SMALL_STATE(9559)] = 391421,
  [SMALL_STATE(9560)] = 391447,
  [SMALL_STATE(9561)] = 391463,
  [SMALL_STATE(9562)] = 391483,
  [SMALL_STATE(9563)] = 391499,
  [SMALL_STATE(9564)] = 391525,
  [SMALL_STATE(9565)] = 391549,
  [SMALL_STATE(9566)] = 391573,
  [SMALL_STATE(9567)] = 391599,
  [SMALL_STATE(9568)] = 391615,
  [SMALL_STATE(9569)] = 391641,
  [SMALL_STATE(9570)] = 391657,
  [SMALL_STATE(9571)] = 391683,
  [SMALL_STATE(9572)] = 391699,
  [SMALL_STATE(9573)] = 391723,
  [SMALL_STATE(9574)] = 391745,
  [SMALL_STATE(9575)] = 391761,
  [SMALL_STATE(9576)] = 391777,
  [SMALL_STATE(9577)] = 391803,
  [SMALL_STATE(9578)] = 391829,
  [SMALL_STATE(9579)] = 391845,
  [SMALL_STATE(9580)] = 391861,
  [SMALL_STATE(9581)] = 391877,
  [SMALL_STATE(9582)] = 391893,
  [SMALL_STATE(9583)] = 391909,
  [SMALL_STATE(9584)] = 391933,
  [SMALL_STATE(9585)] = 391949,
  [SMALL_STATE(9586)] = 391965,
  [SMALL_STATE(9587)] = 391981,
  [SMALL_STATE(9588)] = 392001,
  [SMALL_STATE(9589)] = 392017,
  [SMALL_STATE(9590)] = 392037,
  [SMALL_STATE(9591)] = 392061,
  [SMALL_STATE(9592)] = 392085,
  [SMALL_STATE(9593)] = 392109,
  [SMALL_STATE(9594)] = 392135,
  [SMALL_STATE(9595)] = 392159,
  [SMALL_STATE(9596)] = 392179,
  [SMALL_STATE(9597)] = 392203,
  [SMALL_STATE(9598)] = 392227,
  [SMALL_STATE(9599)] = 392249,
  [SMALL_STATE(9600)] = 392265,
  [SMALL_STATE(9601)] = 392289,
  [SMALL_STATE(9602)] = 392311,
  [SMALL_STATE(9603)] = 392327,
  [SMALL_STATE(9604)] = 392353,
  [SMALL_STATE(9605)] = 392369,
  [SMALL_STATE(9606)] = 392389,
  [SMALL_STATE(9607)] = 392405,
  [SMALL_STATE(9608)] = 392425,
  [SMALL_STATE(9609)] = 392441,
  [SMALL_STATE(9610)] = 392463,
  [SMALL_STATE(9611)] = 392479,
  [SMALL_STATE(9612)] = 392503,
  [SMALL_STATE(9613)] = 392527,
  [SMALL_STATE(9614)] = 392551,
  [SMALL_STATE(9615)] = 392571,
  [SMALL_STATE(9616)] = 392595,
  [SMALL_STATE(9617)] = 392617,
  [SMALL_STATE(9618)] = 392641,
  [SMALL_STATE(9619)] = 392659,
  [SMALL_STATE(9620)] = 392675,
  [SMALL_STATE(9621)] = 392691,
  [SMALL_STATE(9622)] = 392707,
  [SMALL_STATE(9623)] = 392723,
  [SMALL_STATE(9624)] = 392739,
  [SMALL_STATE(9625)] = 392759,
  [SMALL_STATE(9626)] = 392775,
  [SMALL_STATE(9627)] = 392801,
  [SMALL_STATE(9628)] = 392823,
  [SMALL_STATE(9629)] = 392839,
  [SMALL_STATE(9630)] = 392855,
  [SMALL_STATE(9631)] = 392879,
  [SMALL_STATE(9632)] = 392895,
  [SMALL_STATE(9633)] = 392919,
  [SMALL_STATE(9634)] = 392935,
  [SMALL_STATE(9635)] = 392951,
  [SMALL_STATE(9636)] = 392977,
  [SMALL_STATE(9637)] = 392993,
  [SMALL_STATE(9638)] = 393017,
  [SMALL_STATE(9639)] = 393033,
  [SMALL_STATE(9640)] = 393049,
  [SMALL_STATE(9641)] = 393069,
  [SMALL_STATE(9642)] = 393087,
  [SMALL_STATE(9643)] = 393111,
  [SMALL_STATE(9644)] = 393137,
  [SMALL_STATE(9645)] = 393153,
  [SMALL_STATE(9646)] = 393169,
  [SMALL_STATE(9647)] = 393195,
  [SMALL_STATE(9648)] = 393211,
  [SMALL_STATE(9649)] = 393235,
  [SMALL_STATE(9650)] = 393259,
  [SMALL_STATE(9651)] = 393281,
  [SMALL_STATE(9652)] = 393303,
  [SMALL_STATE(9653)] = 393319,
  [SMALL_STATE(9654)] = 393345,
  [SMALL_STATE(9655)] = 393361,
  [SMALL_STATE(9656)] = 393383,
  [SMALL_STATE(9657)] = 393403,
  [SMALL_STATE(9658)] = 393429,
  [SMALL_STATE(9659)] = 393449,
  [SMALL_STATE(9660)] = 393473,
  [SMALL_STATE(9661)] = 393491,
  [SMALL_STATE(9662)] = 393507,
  [SMALL_STATE(9663)] = 393531,
  [SMALL_STATE(9664)] = 393553,
  [SMALL_STATE(9665)] = 393575,
  [SMALL_STATE(9666)] = 393591,
  [SMALL_STATE(9667)] = 393607,
  [SMALL_STATE(9668)] = 393629,
  [SMALL_STATE(9669)] = 393645,
  [SMALL_STATE(9670)] = 393661,
  [SMALL_STATE(9671)] = 393677,
  [SMALL_STATE(9672)] = 393693,
  [SMALL_STATE(9673)] = 393717,
  [SMALL_STATE(9674)] = 393743,
  [SMALL_STATE(9675)] = 393765,
  [SMALL_STATE(9676)] = 393781,
  [SMALL_STATE(9677)] = 393797,
  [SMALL_STATE(9678)] = 393813,
  [SMALL_STATE(9679)] = 393829,
  [SMALL_STATE(9680)] = 393853,
  [SMALL_STATE(9681)] = 393877,
  [SMALL_STATE(9682)] = 393893,
  [SMALL_STATE(9683)] = 393909,
  [SMALL_STATE(9684)] = 393933,
  [SMALL_STATE(9685)] = 393949,
  [SMALL_STATE(9686)] = 393965,
  [SMALL_STATE(9687)] = 393987,
  [SMALL_STATE(9688)] = 394011,
  [SMALL_STATE(9689)] = 394027,
  [SMALL_STATE(9690)] = 394043,
  [SMALL_STATE(9691)] = 394067,
  [SMALL_STATE(9692)] = 394091,
  [SMALL_STATE(9693)] = 394107,
  [SMALL_STATE(9694)] = 394133,
  [SMALL_STATE(9695)] = 394157,
  [SMALL_STATE(9696)] = 394177,
  [SMALL_STATE(9697)] = 394199,
  [SMALL_STATE(9698)] = 394215,
  [SMALL_STATE(9699)] = 394231,
  [SMALL_STATE(9700)] = 394257,
  [SMALL_STATE(9701)] = 394273,
  [SMALL_STATE(9702)] = 394289,
  [SMALL_STATE(9703)] = 394305,
  [SMALL_STATE(9704)] = 394321,
  [SMALL_STATE(9705)] = 394337,
  [SMALL_STATE(9706)] = 394363,
  [SMALL_STATE(9707)] = 394386,
  [SMALL_STATE(9708)] = 394409,
  [SMALL_STATE(9709)] = 394432,
  [SMALL_STATE(9710)] = 394451,
  [SMALL_STATE(9711)] = 394474,
  [SMALL_STATE(9712)] = 394497,
  [SMALL_STATE(9713)] = 394514,
  [SMALL_STATE(9714)] = 394537,
  [SMALL_STATE(9715)] = 394560,
  [SMALL_STATE(9716)] = 394583,
  [SMALL_STATE(9717)] = 394606,
  [SMALL_STATE(9718)] = 394627,
  [SMALL_STATE(9719)] = 394650,
  [SMALL_STATE(9720)] = 394673,
  [SMALL_STATE(9721)] = 394696,
  [SMALL_STATE(9722)] = 394715,
  [SMALL_STATE(9723)] = 394738,
  [SMALL_STATE(9724)] = 394761,
  [SMALL_STATE(9725)] = 394784,
  [SMALL_STATE(9726)] = 394807,
  [SMALL_STATE(9727)] = 394830,
  [SMALL_STATE(9728)] = 394853,
  [SMALL_STATE(9729)] = 394876,
  [SMALL_STATE(9730)] = 394899,
  [SMALL_STATE(9731)] = 394922,
  [SMALL_STATE(9732)] = 394943,
  [SMALL_STATE(9733)] = 394966,
  [SMALL_STATE(9734)] = 394989,
  [SMALL_STATE(9735)] = 395012,
  [SMALL_STATE(9736)] = 395031,
  [SMALL_STATE(9737)] = 395054,
  [SMALL_STATE(9738)] = 395077,
  [SMALL_STATE(9739)] = 395100,
  [SMALL_STATE(9740)] = 395123,
  [SMALL_STATE(9741)] = 395146,
  [SMALL_STATE(9742)] = 395169,
  [SMALL_STATE(9743)] = 395192,
  [SMALL_STATE(9744)] = 395207,
  [SMALL_STATE(9745)] = 395226,
  [SMALL_STATE(9746)] = 395249,
  [SMALL_STATE(9747)] = 395264,
  [SMALL_STATE(9748)] = 395287,
  [SMALL_STATE(9749)] = 395308,
  [SMALL_STATE(9750)] = 395323,
  [SMALL_STATE(9751)] = 395344,
  [SMALL_STATE(9752)] = 395367,
  [SMALL_STATE(9753)] = 395382,
  [SMALL_STATE(9754)] = 395405,
  [SMALL_STATE(9755)] = 395420,
  [SMALL_STATE(9756)] = 395435,
  [SMALL_STATE(9757)] = 395458,
  [SMALL_STATE(9758)] = 395479,
  [SMALL_STATE(9759)] = 395500,
  [SMALL_STATE(9760)] = 395515,
  [SMALL_STATE(9761)] = 395538,
  [SMALL_STATE(9762)] = 395559,
  [SMALL_STATE(9763)] = 395574,
  [SMALL_STATE(9764)] = 395589,
  [SMALL_STATE(9765)] = 395612,
  [SMALL_STATE(9766)] = 395627,
  [SMALL_STATE(9767)] = 395648,
  [SMALL_STATE(9768)] = 395671,
  [SMALL_STATE(9769)] = 395694,
  [SMALL_STATE(9770)] = 395717,
  [SMALL_STATE(9771)] = 395738,
  [SMALL_STATE(9772)] = 395759,
  [SMALL_STATE(9773)] = 395780,
  [SMALL_STATE(9774)] = 395803,
  [SMALL_STATE(9775)] = 395824,
  [SMALL_STATE(9776)] = 395847,
  [SMALL_STATE(9777)] = 395870,
  [SMALL_STATE(9778)] = 395885,
  [SMALL_STATE(9779)] = 395900,
  [SMALL_STATE(9780)] = 395923,
  [SMALL_STATE(9781)] = 395946,
  [SMALL_STATE(9782)] = 395969,
  [SMALL_STATE(9783)] = 395992,
  [SMALL_STATE(9784)] = 396011,
  [SMALL_STATE(9785)] = 396034,
  [SMALL_STATE(9786)] = 396057,
  [SMALL_STATE(9787)] = 396080,
  [SMALL_STATE(9788)] = 396095,
  [SMALL_STATE(9789)] = 396118,
  [SMALL_STATE(9790)] = 396141,
  [SMALL_STATE(9791)] = 396164,
  [SMALL_STATE(9792)] = 396187,
  [SMALL_STATE(9793)] = 396210,
  [SMALL_STATE(9794)] = 396233,
  [SMALL_STATE(9795)] = 396256,
  [SMALL_STATE(9796)] = 396279,
  [SMALL_STATE(9797)] = 396302,
  [SMALL_STATE(9798)] = 396317,
  [SMALL_STATE(9799)] = 396340,
  [SMALL_STATE(9800)] = 396363,
  [SMALL_STATE(9801)] = 396386,
  [SMALL_STATE(9802)] = 396409,
  [SMALL_STATE(9803)] = 396432,
  [SMALL_STATE(9804)] = 396447,
  [SMALL_STATE(9805)] = 396470,
  [SMALL_STATE(9806)] = 396493,
  [SMALL_STATE(9807)] = 396516,
  [SMALL_STATE(9808)] = 396539,
  [SMALL_STATE(9809)] = 396562,
  [SMALL_STATE(9810)] = 396585,
  [SMALL_STATE(9811)] = 396608,
  [SMALL_STATE(9812)] = 396631,
  [SMALL_STATE(9813)] = 396654,
  [SMALL_STATE(9814)] = 396677,
  [SMALL_STATE(9815)] = 396700,
  [SMALL_STATE(9816)] = 396715,
  [SMALL_STATE(9817)] = 396734,
  [SMALL_STATE(9818)] = 396753,
  [SMALL_STATE(9819)] = 396774,
  [SMALL_STATE(9820)] = 396797,
  [SMALL_STATE(9821)] = 396820,
  [SMALL_STATE(9822)] = 396843,
  [SMALL_STATE(9823)] = 396858,
  [SMALL_STATE(9824)] = 396873,
  [SMALL_STATE(9825)] = 396896,
  [SMALL_STATE(9826)] = 396919,
  [SMALL_STATE(9827)] = 396942,
  [SMALL_STATE(9828)] = 396965,
  [SMALL_STATE(9829)] = 396988,
  [SMALL_STATE(9830)] = 397011,
  [SMALL_STATE(9831)] = 397034,
  [SMALL_STATE(9832)] = 397057,
  [SMALL_STATE(9833)] = 397080,
  [SMALL_STATE(9834)] = 397103,
  [SMALL_STATE(9835)] = 397126,
  [SMALL_STATE(9836)] = 397147,
  [SMALL_STATE(9837)] = 397170,
  [SMALL_STATE(9838)] = 397193,
  [SMALL_STATE(9839)] = 397214,
  [SMALL_STATE(9840)] = 397237,
  [SMALL_STATE(9841)] = 397260,
  [SMALL_STATE(9842)] = 397283,
  [SMALL_STATE(9843)] = 397306,
  [SMALL_STATE(9844)] = 397321,
  [SMALL_STATE(9845)] = 397336,
  [SMALL_STATE(9846)] = 397351,
  [SMALL_STATE(9847)] = 397366,
  [SMALL_STATE(9848)] = 397389,
  [SMALL_STATE(9849)] = 397412,
  [SMALL_STATE(9850)] = 397435,
  [SMALL_STATE(9851)] = 397456,
  [SMALL_STATE(9852)] = 397479,
  [SMALL_STATE(9853)] = 397500,
  [SMALL_STATE(9854)] = 397523,
  [SMALL_STATE(9855)] = 397546,
  [SMALL_STATE(9856)] = 397569,
  [SMALL_STATE(9857)] = 397592,
  [SMALL_STATE(9858)] = 397615,
  [SMALL_STATE(9859)] = 397638,
  [SMALL_STATE(9860)] = 397659,
  [SMALL_STATE(9861)] = 397682,
  [SMALL_STATE(9862)] = 397705,
  [SMALL_STATE(9863)] = 397724,
  [SMALL_STATE(9864)] = 397739,
  [SMALL_STATE(9865)] = 397758,
  [SMALL_STATE(9866)] = 397781,
  [SMALL_STATE(9867)] = 397804,
  [SMALL_STATE(9868)] = 397823,
  [SMALL_STATE(9869)] = 397846,
  [SMALL_STATE(9870)] = 397869,
  [SMALL_STATE(9871)] = 397888,
  [SMALL_STATE(9872)] = 397909,
  [SMALL_STATE(9873)] = 397930,
  [SMALL_STATE(9874)] = 397953,
  [SMALL_STATE(9875)] = 397968,
  [SMALL_STATE(9876)] = 397991,
  [SMALL_STATE(9877)] = 398006,
  [SMALL_STATE(9878)] = 398029,
  [SMALL_STATE(9879)] = 398052,
  [SMALL_STATE(9880)] = 398067,
  [SMALL_STATE(9881)] = 398082,
  [SMALL_STATE(9882)] = 398103,
  [SMALL_STATE(9883)] = 398126,
  [SMALL_STATE(9884)] = 398141,
  [SMALL_STATE(9885)] = 398164,
  [SMALL_STATE(9886)] = 398179,
  [SMALL_STATE(9887)] = 398194,
  [SMALL_STATE(9888)] = 398215,
  [SMALL_STATE(9889)] = 398236,
  [SMALL_STATE(9890)] = 398259,
  [SMALL_STATE(9891)] = 398282,
  [SMALL_STATE(9892)] = 398305,
  [SMALL_STATE(9893)] = 398322,
  [SMALL_STATE(9894)] = 398345,
  [SMALL_STATE(9895)] = 398368,
  [SMALL_STATE(9896)] = 398391,
  [SMALL_STATE(9897)] = 398414,
  [SMALL_STATE(9898)] = 398437,
  [SMALL_STATE(9899)] = 398460,
  [SMALL_STATE(9900)] = 398483,
  [SMALL_STATE(9901)] = 398506,
  [SMALL_STATE(9902)] = 398527,
  [SMALL_STATE(9903)] = 398550,
  [SMALL_STATE(9904)] = 398573,
  [SMALL_STATE(9905)] = 398596,
  [SMALL_STATE(9906)] = 398619,
  [SMALL_STATE(9907)] = 398642,
  [SMALL_STATE(9908)] = 398663,
  [SMALL_STATE(9909)] = 398686,
  [SMALL_STATE(9910)] = 398709,
  [SMALL_STATE(9911)] = 398732,
  [SMALL_STATE(9912)] = 398755,
  [SMALL_STATE(9913)] = 398778,
  [SMALL_STATE(9914)] = 398801,
  [SMALL_STATE(9915)] = 398824,
  [SMALL_STATE(9916)] = 398847,
  [SMALL_STATE(9917)] = 398870,
  [SMALL_STATE(9918)] = 398893,
  [SMALL_STATE(9919)] = 398916,
  [SMALL_STATE(9920)] = 398937,
  [SMALL_STATE(9921)] = 398960,
  [SMALL_STATE(9922)] = 398983,
  [SMALL_STATE(9923)] = 399002,
  [SMALL_STATE(9924)] = 399023,
  [SMALL_STATE(9925)] = 399046,
  [SMALL_STATE(9926)] = 399069,
  [SMALL_STATE(9927)] = 399092,
  [SMALL_STATE(9928)] = 399115,
  [SMALL_STATE(9929)] = 399138,
  [SMALL_STATE(9930)] = 399157,
  [SMALL_STATE(9931)] = 399180,
  [SMALL_STATE(9932)] = 399201,
  [SMALL_STATE(9933)] = 399224,
  [SMALL_STATE(9934)] = 399247,
  [SMALL_STATE(9935)] = 399270,
  [SMALL_STATE(9936)] = 399289,
  [SMALL_STATE(9937)] = 399312,
  [SMALL_STATE(9938)] = 399335,
  [SMALL_STATE(9939)] = 399358,
  [SMALL_STATE(9940)] = 399381,
  [SMALL_STATE(9941)] = 399404,
  [SMALL_STATE(9942)] = 399427,
  [SMALL_STATE(9943)] = 399448,
  [SMALL_STATE(9944)] = 399471,
  [SMALL_STATE(9945)] = 399488,
  [SMALL_STATE(9946)] = 399511,
  [SMALL_STATE(9947)] = 399534,
  [SMALL_STATE(9948)] = 399557,
  [SMALL_STATE(9949)] = 399580,
  [SMALL_STATE(9950)] = 399603,
  [SMALL_STATE(9951)] = 399624,
  [SMALL_STATE(9952)] = 399639,
  [SMALL_STATE(9953)] = 399662,
  [SMALL_STATE(9954)] = 399681,
  [SMALL_STATE(9955)] = 399704,
  [SMALL_STATE(9956)] = 399719,
  [SMALL_STATE(9957)] = 399742,
  [SMALL_STATE(9958)] = 399765,
  [SMALL_STATE(9959)] = 399788,
  [SMALL_STATE(9960)] = 399811,
  [SMALL_STATE(9961)] = 399834,
  [SMALL_STATE(9962)] = 399851,
  [SMALL_STATE(9963)] = 399874,
  [SMALL_STATE(9964)] = 399897,
  [SMALL_STATE(9965)] = 399920,
  [SMALL_STATE(9966)] = 399943,
  [SMALL_STATE(9967)] = 399966,
  [SMALL_STATE(9968)] = 399989,
  [SMALL_STATE(9969)] = 400004,
  [SMALL_STATE(9970)] = 400023,
  [SMALL_STATE(9971)] = 400046,
  [SMALL_STATE(9972)] = 400069,
  [SMALL_STATE(9973)] = 400092,
  [SMALL_STATE(9974)] = 400115,
  [SMALL_STATE(9975)] = 400138,
  [SMALL_STATE(9976)] = 400161,
  [SMALL_STATE(9977)] = 400184,
  [SMALL_STATE(9978)] = 400199,
  [SMALL_STATE(9979)] = 400222,
  [SMALL_STATE(9980)] = 400245,
  [SMALL_STATE(9981)] = 400266,
  [SMALL_STATE(9982)] = 400287,
  [SMALL_STATE(9983)] = 400310,
  [SMALL_STATE(9984)] = 400333,
  [SMALL_STATE(9985)] = 400354,
  [SMALL_STATE(9986)] = 400377,
  [SMALL_STATE(9987)] = 400400,
  [SMALL_STATE(9988)] = 400423,
  [SMALL_STATE(9989)] = 400446,
  [SMALL_STATE(9990)] = 400467,
  [SMALL_STATE(9991)] = 400488,
  [SMALL_STATE(9992)] = 400511,
  [SMALL_STATE(9993)] = 400534,
  [SMALL_STATE(9994)] = 400553,
  [SMALL_STATE(9995)] = 400576,
  [SMALL_STATE(9996)] = 400597,
  [SMALL_STATE(9997)] = 400620,
  [SMALL_STATE(9998)] = 400643,
  [SMALL_STATE(9999)] = 400666,
  [SMALL_STATE(10000)] = 400687,
  [SMALL_STATE(10001)] = 400710,
  [SMALL_STATE(10002)] = 400731,
  [SMALL_STATE(10003)] = 400748,
  [SMALL_STATE(10004)] = 400771,
  [SMALL_STATE(10005)] = 400788,
  [SMALL_STATE(10006)] = 400811,
  [SMALL_STATE(10007)] = 400832,
  [SMALL_STATE(10008)] = 400855,
  [SMALL_STATE(10009)] = 400878,
  [SMALL_STATE(10010)] = 400901,
  [SMALL_STATE(10011)] = 400924,
  [SMALL_STATE(10012)] = 400947,
  [SMALL_STATE(10013)] = 400970,
  [SMALL_STATE(10014)] = 400993,
  [SMALL_STATE(10015)] = 401016,
  [SMALL_STATE(10016)] = 401039,
  [SMALL_STATE(10017)] = 401059,
  [SMALL_STATE(10018)] = 401077,
  [SMALL_STATE(10019)] = 401091,
  [SMALL_STATE(10020)] = 401105,
  [SMALL_STATE(10021)] = 401121,
  [SMALL_STATE(10022)] = 401141,
  [SMALL_STATE(10023)] = 401155,
  [SMALL_STATE(10024)] = 401175,
  [SMALL_STATE(10025)] = 401189,
  [SMALL_STATE(10026)] = 401203,
  [SMALL_STATE(10027)] = 401223,
  [SMALL_STATE(10028)] = 401237,
  [SMALL_STATE(10029)] = 401257,
  [SMALL_STATE(10030)] = 401271,
  [SMALL_STATE(10031)] = 401291,
  [SMALL_STATE(10032)] = 401311,
  [SMALL_STATE(10033)] = 401325,
  [SMALL_STATE(10034)] = 401345,
  [SMALL_STATE(10035)] = 401365,
  [SMALL_STATE(10036)] = 401379,
  [SMALL_STATE(10037)] = 401393,
  [SMALL_STATE(10038)] = 401407,
  [SMALL_STATE(10039)] = 401421,
  [SMALL_STATE(10040)] = 401435,
  [SMALL_STATE(10041)] = 401449,
  [SMALL_STATE(10042)] = 401463,
  [SMALL_STATE(10043)] = 401479,
  [SMALL_STATE(10044)] = 401495,
  [SMALL_STATE(10045)] = 401509,
  [SMALL_STATE(10046)] = 401523,
  [SMALL_STATE(10047)] = 401537,
  [SMALL_STATE(10048)] = 401553,
  [SMALL_STATE(10049)] = 401569,
  [SMALL_STATE(10050)] = 401583,
  [SMALL_STATE(10051)] = 401603,
  [SMALL_STATE(10052)] = 401623,
  [SMALL_STATE(10053)] = 401643,
  [SMALL_STATE(10054)] = 401657,
  [SMALL_STATE(10055)] = 401671,
  [SMALL_STATE(10056)] = 401685,
  [SMALL_STATE(10057)] = 401701,
  [SMALL_STATE(10058)] = 401717,
  [SMALL_STATE(10059)] = 401735,
  [SMALL_STATE(10060)] = 401749,
  [SMALL_STATE(10061)] = 401767,
  [SMALL_STATE(10062)] = 401781,
  [SMALL_STATE(10063)] = 401801,
  [SMALL_STATE(10064)] = 401821,
  [SMALL_STATE(10065)] = 401841,
  [SMALL_STATE(10066)] = 401859,
  [SMALL_STATE(10067)] = 401875,
  [SMALL_STATE(10068)] = 401893,
  [SMALL_STATE(10069)] = 401911,
  [SMALL_STATE(10070)] = 401925,
  [SMALL_STATE(10071)] = 401945,
  [SMALL_STATE(10072)] = 401965,
  [SMALL_STATE(10073)] = 401979,
  [SMALL_STATE(10074)] = 401999,
  [SMALL_STATE(10075)] = 402019,
  [SMALL_STATE(10076)] = 402039,
  [SMALL_STATE(10077)] = 402055,
  [SMALL_STATE(10078)] = 402075,
  [SMALL_STATE(10079)] = 402093,
  [SMALL_STATE(10080)] = 402107,
  [SMALL_STATE(10081)] = 402121,
  [SMALL_STATE(10082)] = 402135,
  [SMALL_STATE(10083)] = 402153,
  [SMALL_STATE(10084)] = 402171,
  [SMALL_STATE(10085)] = 402185,
  [SMALL_STATE(10086)] = 402199,
  [SMALL_STATE(10087)] = 402217,
  [SMALL_STATE(10088)] = 402231,
  [SMALL_STATE(10089)] = 402245,
  [SMALL_STATE(10090)] = 402263,
  [SMALL_STATE(10091)] = 402277,
  [SMALL_STATE(10092)] = 402295,
  [SMALL_STATE(10093)] = 402315,
  [SMALL_STATE(10094)] = 402333,
  [SMALL_STATE(10095)] = 402347,
  [SMALL_STATE(10096)] = 402365,
  [SMALL_STATE(10097)] = 402379,
  [SMALL_STATE(10098)] = 402399,
  [SMALL_STATE(10099)] = 402417,
  [SMALL_STATE(10100)] = 402435,
  [SMALL_STATE(10101)] = 402449,
  [SMALL_STATE(10102)] = 402463,
  [SMALL_STATE(10103)] = 402481,
  [SMALL_STATE(10104)] = 402495,
  [SMALL_STATE(10105)] = 402513,
  [SMALL_STATE(10106)] = 402527,
  [SMALL_STATE(10107)] = 402547,
  [SMALL_STATE(10108)] = 402567,
  [SMALL_STATE(10109)] = 402587,
  [SMALL_STATE(10110)] = 402605,
  [SMALL_STATE(10111)] = 402619,
  [SMALL_STATE(10112)] = 402633,
  [SMALL_STATE(10113)] = 402647,
  [SMALL_STATE(10114)] = 402665,
  [SMALL_STATE(10115)] = 402679,
  [SMALL_STATE(10116)] = 402699,
  [SMALL_STATE(10117)] = 402713,
  [SMALL_STATE(10118)] = 402731,
  [SMALL_STATE(10119)] = 402745,
  [SMALL_STATE(10120)] = 402763,
  [SMALL_STATE(10121)] = 402781,
  [SMALL_STATE(10122)] = 402801,
  [SMALL_STATE(10123)] = 402819,
  [SMALL_STATE(10124)] = 402837,
  [SMALL_STATE(10125)] = 402857,
  [SMALL_STATE(10126)] = 402877,
  [SMALL_STATE(10127)] = 402897,
  [SMALL_STATE(10128)] = 402917,
  [SMALL_STATE(10129)] = 402937,
  [SMALL_STATE(10130)] = 402955,
  [SMALL_STATE(10131)] = 402969,
  [SMALL_STATE(10132)] = 402989,
  [SMALL_STATE(10133)] = 403009,
  [SMALL_STATE(10134)] = 403029,
  [SMALL_STATE(10135)] = 403047,
  [SMALL_STATE(10136)] = 403065,
  [SMALL_STATE(10137)] = 403085,
  [SMALL_STATE(10138)] = 403099,
  [SMALL_STATE(10139)] = 403113,
  [SMALL_STATE(10140)] = 403127,
  [SMALL_STATE(10141)] = 403141,
  [SMALL_STATE(10142)] = 403155,
  [SMALL_STATE(10143)] = 403169,
  [SMALL_STATE(10144)] = 403183,
  [SMALL_STATE(10145)] = 403203,
  [SMALL_STATE(10146)] = 403223,
  [SMALL_STATE(10147)] = 403237,
  [SMALL_STATE(10148)] = 403255,
  [SMALL_STATE(10149)] = 403273,
  [SMALL_STATE(10150)] = 403287,
  [SMALL_STATE(10151)] = 403301,
  [SMALL_STATE(10152)] = 403315,
  [SMALL_STATE(10153)] = 403333,
  [SMALL_STATE(10154)] = 403347,
  [SMALL_STATE(10155)] = 403361,
  [SMALL_STATE(10156)] = 403375,
  [SMALL_STATE(10157)] = 403393,
  [SMALL_STATE(10158)] = 403413,
  [SMALL_STATE(10159)] = 403433,
  [SMALL_STATE(10160)] = 403451,
  [SMALL_STATE(10161)] = 403465,
  [SMALL_STATE(10162)] = 403483,
  [SMALL_STATE(10163)] = 403501,
  [SMALL_STATE(10164)] = 403521,
  [SMALL_STATE(10165)] = 403541,
  [SMALL_STATE(10166)] = 403561,
  [SMALL_STATE(10167)] = 403579,
  [SMALL_STATE(10168)] = 403599,
  [SMALL_STATE(10169)] = 403619,
  [SMALL_STATE(10170)] = 403633,
  [SMALL_STATE(10171)] = 403647,
  [SMALL_STATE(10172)] = 403665,
  [SMALL_STATE(10173)] = 403679,
  [SMALL_STATE(10174)] = 403693,
  [SMALL_STATE(10175)] = 403711,
  [SMALL_STATE(10176)] = 403729,
  [SMALL_STATE(10177)] = 403743,
  [SMALL_STATE(10178)] = 403763,
  [SMALL_STATE(10179)] = 403781,
  [SMALL_STATE(10180)] = 403795,
  [SMALL_STATE(10181)] = 403809,
  [SMALL_STATE(10182)] = 403829,
  [SMALL_STATE(10183)] = 403843,
  [SMALL_STATE(10184)] = 403863,
  [SMALL_STATE(10185)] = 403883,
  [SMALL_STATE(10186)] = 403897,
  [SMALL_STATE(10187)] = 403917,
  [SMALL_STATE(10188)] = 403931,
  [SMALL_STATE(10189)] = 403951,
  [SMALL_STATE(10190)] = 403971,
  [SMALL_STATE(10191)] = 403991,
  [SMALL_STATE(10192)] = 404005,
  [SMALL_STATE(10193)] = 404019,
  [SMALL_STATE(10194)] = 404033,
  [SMALL_STATE(10195)] = 404053,
  [SMALL_STATE(10196)] = 404073,
  [SMALL_STATE(10197)] = 404091,
  [SMALL_STATE(10198)] = 404105,
  [SMALL_STATE(10199)] = 404119,
  [SMALL_STATE(10200)] = 404133,
  [SMALL_STATE(10201)] = 404153,
  [SMALL_STATE(10202)] = 404167,
  [SMALL_STATE(10203)] = 404185,
  [SMALL_STATE(10204)] = 404203,
  [SMALL_STATE(10205)] = 404223,
  [SMALL_STATE(10206)] = 404243,
  [SMALL_STATE(10207)] = 404261,
  [SMALL_STATE(10208)] = 404281,
  [SMALL_STATE(10209)] = 404301,
  [SMALL_STATE(10210)] = 404319,
  [SMALL_STATE(10211)] = 404339,
  [SMALL_STATE(10212)] = 404353,
  [SMALL_STATE(10213)] = 404367,
  [SMALL_STATE(10214)] = 404383,
  [SMALL_STATE(10215)] = 404397,
  [SMALL_STATE(10216)] = 404415,
  [SMALL_STATE(10217)] = 404433,
  [SMALL_STATE(10218)] = 404451,
  [SMALL_STATE(10219)] = 404467,
  [SMALL_STATE(10220)] = 404481,
  [SMALL_STATE(10221)] = 404495,
  [SMALL_STATE(10222)] = 404509,
  [SMALL_STATE(10223)] = 404523,
  [SMALL_STATE(10224)] = 404541,
  [SMALL_STATE(10225)] = 404555,
  [SMALL_STATE(10226)] = 404575,
  [SMALL_STATE(10227)] = 404595,
  [SMALL_STATE(10228)] = 404611,
  [SMALL_STATE(10229)] = 404629,
  [SMALL_STATE(10230)] = 404649,
  [SMALL_STATE(10231)] = 404667,
  [SMALL_STATE(10232)] = 404685,
  [SMALL_STATE(10233)] = 404699,
  [SMALL_STATE(10234)] = 404713,
  [SMALL_STATE(10235)] = 404727,
  [SMALL_STATE(10236)] = 404741,
  [SMALL_STATE(10237)] = 404755,
  [SMALL_STATE(10238)] = 404769,
  [SMALL_STATE(10239)] = 404783,
  [SMALL_STATE(10240)] = 404797,
  [SMALL_STATE(10241)] = 404817,
  [SMALL_STATE(10242)] = 404837,
  [SMALL_STATE(10243)] = 404851,
  [SMALL_STATE(10244)] = 404871,
  [SMALL_STATE(10245)] = 404889,
  [SMALL_STATE(10246)] = 404909,
  [SMALL_STATE(10247)] = 404923,
  [SMALL_STATE(10248)] = 404937,
  [SMALL_STATE(10249)] = 404957,
  [SMALL_STATE(10250)] = 404975,
  [SMALL_STATE(10251)] = 404989,
  [SMALL_STATE(10252)] = 405003,
  [SMALL_STATE(10253)] = 405021,
  [SMALL_STATE(10254)] = 405039,
  [SMALL_STATE(10255)] = 405053,
  [SMALL_STATE(10256)] = 405073,
  [SMALL_STATE(10257)] = 405087,
  [SMALL_STATE(10258)] = 405107,
  [SMALL_STATE(10259)] = 405121,
  [SMALL_STATE(10260)] = 405135,
  [SMALL_STATE(10261)] = 405149,
  [SMALL_STATE(10262)] = 405163,
  [SMALL_STATE(10263)] = 405177,
  [SMALL_STATE(10264)] = 405197,
  [SMALL_STATE(10265)] = 405211,
  [SMALL_STATE(10266)] = 405225,
  [SMALL_STATE(10267)] = 405239,
  [SMALL_STATE(10268)] = 405253,
  [SMALL_STATE(10269)] = 405267,
  [SMALL_STATE(10270)] = 405281,
  [SMALL_STATE(10271)] = 405301,
  [SMALL_STATE(10272)] = 405321,
  [SMALL_STATE(10273)] = 405335,
  [SMALL_STATE(10274)] = 405353,
  [SMALL_STATE(10275)] = 405371,
  [SMALL_STATE(10276)] = 405391,
  [SMALL_STATE(10277)] = 405405,
  [SMALL_STATE(10278)] = 405425,
  [SMALL_STATE(10279)] = 405445,
  [SMALL_STATE(10280)] = 405459,
  [SMALL_STATE(10281)] = 405479,
  [SMALL_STATE(10282)] = 405493,
  [SMALL_STATE(10283)] = 405509,
  [SMALL_STATE(10284)] = 405527,
  [SMALL_STATE(10285)] = 405541,
  [SMALL_STATE(10286)] = 405555,
  [SMALL_STATE(10287)] = 405569,
  [SMALL_STATE(10288)] = 405583,
  [SMALL_STATE(10289)] = 405601,
  [SMALL_STATE(10290)] = 405617,
  [SMALL_STATE(10291)] = 405631,
  [SMALL_STATE(10292)] = 405645,
  [SMALL_STATE(10293)] = 405665,
  [SMALL_STATE(10294)] = 405679,
  [SMALL_STATE(10295)] = 405699,
  [SMALL_STATE(10296)] = 405713,
  [SMALL_STATE(10297)] = 405727,
  [SMALL_STATE(10298)] = 405747,
  [SMALL_STATE(10299)] = 405761,
  [SMALL_STATE(10300)] = 405781,
  [SMALL_STATE(10301)] = 405795,
  [SMALL_STATE(10302)] = 405809,
  [SMALL_STATE(10303)] = 405829,
  [SMALL_STATE(10304)] = 405847,
  [SMALL_STATE(10305)] = 405861,
  [SMALL_STATE(10306)] = 405875,
  [SMALL_STATE(10307)] = 405895,
  [SMALL_STATE(10308)] = 405909,
  [SMALL_STATE(10309)] = 405923,
  [SMALL_STATE(10310)] = 405941,
  [SMALL_STATE(10311)] = 405961,
  [SMALL_STATE(10312)] = 405981,
  [SMALL_STATE(10313)] = 405995,
  [SMALL_STATE(10314)] = 406015,
  [SMALL_STATE(10315)] = 406035,
  [SMALL_STATE(10316)] = 406055,
  [SMALL_STATE(10317)] = 406069,
  [SMALL_STATE(10318)] = 406089,
  [SMALL_STATE(10319)] = 406109,
  [SMALL_STATE(10320)] = 406123,
  [SMALL_STATE(10321)] = 406143,
  [SMALL_STATE(10322)] = 406163,
  [SMALL_STATE(10323)] = 406183,
  [SMALL_STATE(10324)] = 406203,
  [SMALL_STATE(10325)] = 406223,
  [SMALL_STATE(10326)] = 406243,
  [SMALL_STATE(10327)] = 406263,
  [SMALL_STATE(10328)] = 406283,
  [SMALL_STATE(10329)] = 406303,
  [SMALL_STATE(10330)] = 406323,
  [SMALL_STATE(10331)] = 406343,
  [SMALL_STATE(10332)] = 406357,
  [SMALL_STATE(10333)] = 406377,
  [SMALL_STATE(10334)] = 406397,
  [SMALL_STATE(10335)] = 406417,
  [SMALL_STATE(10336)] = 406437,
  [SMALL_STATE(10337)] = 406457,
  [SMALL_STATE(10338)] = 406477,
  [SMALL_STATE(10339)] = 406497,
  [SMALL_STATE(10340)] = 406517,
  [SMALL_STATE(10341)] = 406537,
  [SMALL_STATE(10342)] = 406557,
  [SMALL_STATE(10343)] = 406577,
  [SMALL_STATE(10344)] = 406597,
  [SMALL_STATE(10345)] = 406617,
  [SMALL_STATE(10346)] = 406637,
  [SMALL_STATE(10347)] = 406655,
  [SMALL_STATE(10348)] = 406675,
  [SMALL_STATE(10349)] = 406693,
  [SMALL_STATE(10350)] = 406713,
  [SMALL_STATE(10351)] = 406733,
  [SMALL_STATE(10352)] = 406753,
  [SMALL_STATE(10353)] = 406773,
  [SMALL_STATE(10354)] = 406793,
  [SMALL_STATE(10355)] = 406813,
  [SMALL_STATE(10356)] = 406833,
  [SMALL_STATE(10357)] = 406853,
  [SMALL_STATE(10358)] = 406873,
  [SMALL_STATE(10359)] = 406893,
  [SMALL_STATE(10360)] = 406913,
  [SMALL_STATE(10361)] = 406931,
  [SMALL_STATE(10362)] = 406951,
  [SMALL_STATE(10363)] = 406969,
  [SMALL_STATE(10364)] = 406983,
  [SMALL_STATE(10365)] = 407003,
  [SMALL_STATE(10366)] = 407023,
  [SMALL_STATE(10367)] = 407043,
  [SMALL_STATE(10368)] = 407063,
  [SMALL_STATE(10369)] = 407077,
  [SMALL_STATE(10370)] = 407097,
  [SMALL_STATE(10371)] = 407117,
  [SMALL_STATE(10372)] = 407131,
  [SMALL_STATE(10373)] = 407151,
  [SMALL_STATE(10374)] = 407165,
  [SMALL_STATE(10375)] = 407183,
  [SMALL_STATE(10376)] = 407203,
  [SMALL_STATE(10377)] = 407223,
  [SMALL_STATE(10378)] = 407243,
  [SMALL_STATE(10379)] = 407263,
  [SMALL_STATE(10380)] = 407277,
  [SMALL_STATE(10381)] = 407297,
  [SMALL_STATE(10382)] = 407311,
  [SMALL_STATE(10383)] = 407331,
  [SMALL_STATE(10384)] = 407351,
  [SMALL_STATE(10385)] = 407365,
  [SMALL_STATE(10386)] = 407379,
  [SMALL_STATE(10387)] = 407393,
  [SMALL_STATE(10388)] = 407413,
  [SMALL_STATE(10389)] = 407427,
  [SMALL_STATE(10390)] = 407441,
  [SMALL_STATE(10391)] = 407461,
  [SMALL_STATE(10392)] = 407475,
  [SMALL_STATE(10393)] = 407495,
  [SMALL_STATE(10394)] = 407515,
  [SMALL_STATE(10395)] = 407535,
  [SMALL_STATE(10396)] = 407555,
  [SMALL_STATE(10397)] = 407569,
  [SMALL_STATE(10398)] = 407589,
  [SMALL_STATE(10399)] = 407609,
  [SMALL_STATE(10400)] = 407629,
  [SMALL_STATE(10401)] = 407649,
  [SMALL_STATE(10402)] = 407669,
  [SMALL_STATE(10403)] = 407689,
  [SMALL_STATE(10404)] = 407709,
  [SMALL_STATE(10405)] = 407729,
  [SMALL_STATE(10406)] = 407749,
  [SMALL_STATE(10407)] = 407769,
  [SMALL_STATE(10408)] = 407789,
  [SMALL_STATE(10409)] = 407809,
  [SMALL_STATE(10410)] = 407829,
  [SMALL_STATE(10411)] = 407843,
  [SMALL_STATE(10412)] = 407863,
  [SMALL_STATE(10413)] = 407881,
  [SMALL_STATE(10414)] = 407895,
  [SMALL_STATE(10415)] = 407909,
  [SMALL_STATE(10416)] = 407929,
  [SMALL_STATE(10417)] = 407949,
  [SMALL_STATE(10418)] = 407969,
  [SMALL_STATE(10419)] = 407989,
  [SMALL_STATE(10420)] = 408009,
  [SMALL_STATE(10421)] = 408029,
  [SMALL_STATE(10422)] = 408043,
  [SMALL_STATE(10423)] = 408063,
  [SMALL_STATE(10424)] = 408083,
  [SMALL_STATE(10425)] = 408097,
  [SMALL_STATE(10426)] = 408117,
  [SMALL_STATE(10427)] = 408137,
  [SMALL_STATE(10428)] = 408157,
  [SMALL_STATE(10429)] = 408177,
  [SMALL_STATE(10430)] = 408197,
  [SMALL_STATE(10431)] = 408217,
  [SMALL_STATE(10432)] = 408237,
  [SMALL_STATE(10433)] = 408251,
  [SMALL_STATE(10434)] = 408271,
  [SMALL_STATE(10435)] = 408291,
  [SMALL_STATE(10436)] = 408311,
  [SMALL_STATE(10437)] = 408331,
  [SMALL_STATE(10438)] = 408351,
  [SMALL_STATE(10439)] = 408371,
  [SMALL_STATE(10440)] = 408391,
  [SMALL_STATE(10441)] = 408411,
  [SMALL_STATE(10442)] = 408431,
  [SMALL_STATE(10443)] = 408445,
  [SMALL_STATE(10444)] = 408465,
  [SMALL_STATE(10445)] = 408479,
  [SMALL_STATE(10446)] = 408499,
  [SMALL_STATE(10447)] = 408513,
  [SMALL_STATE(10448)] = 408533,
  [SMALL_STATE(10449)] = 408553,
  [SMALL_STATE(10450)] = 408573,
  [SMALL_STATE(10451)] = 408593,
  [SMALL_STATE(10452)] = 408613,
  [SMALL_STATE(10453)] = 408627,
  [SMALL_STATE(10454)] = 408641,
  [SMALL_STATE(10455)] = 408655,
  [SMALL_STATE(10456)] = 408669,
  [SMALL_STATE(10457)] = 408689,
  [SMALL_STATE(10458)] = 408703,
  [SMALL_STATE(10459)] = 408723,
  [SMALL_STATE(10460)] = 408743,
  [SMALL_STATE(10461)] = 408763,
  [SMALL_STATE(10462)] = 408783,
  [SMALL_STATE(10463)] = 408801,
  [SMALL_STATE(10464)] = 408815,
  [SMALL_STATE(10465)] = 408829,
  [SMALL_STATE(10466)] = 408843,
  [SMALL_STATE(10467)] = 408863,
  [SMALL_STATE(10468)] = 408883,
  [SMALL_STATE(10469)] = 408897,
  [SMALL_STATE(10470)] = 408911,
  [SMALL_STATE(10471)] = 408931,
  [SMALL_STATE(10472)] = 408945,
  [SMALL_STATE(10473)] = 408965,
  [SMALL_STATE(10474)] = 408979,
  [SMALL_STATE(10475)] = 408999,
  [SMALL_STATE(10476)] = 409019,
  [SMALL_STATE(10477)] = 409039,
  [SMALL_STATE(10478)] = 409053,
  [SMALL_STATE(10479)] = 409073,
  [SMALL_STATE(10480)] = 409093,
  [SMALL_STATE(10481)] = 409107,
  [SMALL_STATE(10482)] = 409121,
  [SMALL_STATE(10483)] = 409135,
  [SMALL_STATE(10484)] = 409149,
  [SMALL_STATE(10485)] = 409169,
  [SMALL_STATE(10486)] = 409189,
  [SMALL_STATE(10487)] = 409207,
  [SMALL_STATE(10488)] = 409225,
  [SMALL_STATE(10489)] = 409239,
  [SMALL_STATE(10490)] = 409257,
  [SMALL_STATE(10491)] = 409277,
  [SMALL_STATE(10492)] = 409297,
  [SMALL_STATE(10493)] = 409317,
  [SMALL_STATE(10494)] = 409337,
  [SMALL_STATE(10495)] = 409357,
  [SMALL_STATE(10496)] = 409371,
  [SMALL_STATE(10497)] = 409391,
  [SMALL_STATE(10498)] = 409409,
  [SMALL_STATE(10499)] = 409423,
  [SMALL_STATE(10500)] = 409443,
  [SMALL_STATE(10501)] = 409461,
  [SMALL_STATE(10502)] = 409481,
  [SMALL_STATE(10503)] = 409501,
  [SMALL_STATE(10504)] = 409521,
  [SMALL_STATE(10505)] = 409541,
  [SMALL_STATE(10506)] = 409561,
  [SMALL_STATE(10507)] = 409581,
  [SMALL_STATE(10508)] = 409601,
  [SMALL_STATE(10509)] = 409621,
  [SMALL_STATE(10510)] = 409635,
  [SMALL_STATE(10511)] = 409655,
  [SMALL_STATE(10512)] = 409675,
  [SMALL_STATE(10513)] = 409695,
  [SMALL_STATE(10514)] = 409715,
  [SMALL_STATE(10515)] = 409735,
  [SMALL_STATE(10516)] = 409755,
  [SMALL_STATE(10517)] = 409775,
  [SMALL_STATE(10518)] = 409789,
  [SMALL_STATE(10519)] = 409803,
  [SMALL_STATE(10520)] = 409817,
  [SMALL_STATE(10521)] = 409837,
  [SMALL_STATE(10522)] = 409851,
  [SMALL_STATE(10523)] = 409865,
  [SMALL_STATE(10524)] = 409879,
  [SMALL_STATE(10525)] = 409893,
  [SMALL_STATE(10526)] = 409907,
  [SMALL_STATE(10527)] = 409921,
  [SMALL_STATE(10528)] = 409935,
  [SMALL_STATE(10529)] = 409955,
  [SMALL_STATE(10530)] = 409975,
  [SMALL_STATE(10531)] = 409995,
  [SMALL_STATE(10532)] = 410015,
  [SMALL_STATE(10533)] = 410029,
  [SMALL_STATE(10534)] = 410049,
  [SMALL_STATE(10535)] = 410063,
  [SMALL_STATE(10536)] = 410083,
  [SMALL_STATE(10537)] = 410103,
  [SMALL_STATE(10538)] = 410117,
  [SMALL_STATE(10539)] = 410137,
  [SMALL_STATE(10540)] = 410157,
  [SMALL_STATE(10541)] = 410177,
  [SMALL_STATE(10542)] = 410191,
  [SMALL_STATE(10543)] = 410205,
  [SMALL_STATE(10544)] = 410219,
  [SMALL_STATE(10545)] = 410239,
  [SMALL_STATE(10546)] = 410253,
  [SMALL_STATE(10547)] = 410267,
  [SMALL_STATE(10548)] = 410281,
  [SMALL_STATE(10549)] = 410295,
  [SMALL_STATE(10550)] = 410309,
  [SMALL_STATE(10551)] = 410323,
  [SMALL_STATE(10552)] = 410337,
  [SMALL_STATE(10553)] = 410351,
  [SMALL_STATE(10554)] = 410371,
  [SMALL_STATE(10555)] = 410385,
  [SMALL_STATE(10556)] = 410399,
  [SMALL_STATE(10557)] = 410419,
  [SMALL_STATE(10558)] = 410439,
  [SMALL_STATE(10559)] = 410453,
  [SMALL_STATE(10560)] = 410473,
  [SMALL_STATE(10561)] = 410493,
  [SMALL_STATE(10562)] = 410513,
  [SMALL_STATE(10563)] = 410533,
  [SMALL_STATE(10564)] = 410547,
  [SMALL_STATE(10565)] = 410567,
  [SMALL_STATE(10566)] = 410581,
  [SMALL_STATE(10567)] = 410601,
  [SMALL_STATE(10568)] = 410621,
  [SMALL_STATE(10569)] = 410641,
  [SMALL_STATE(10570)] = 410661,
  [SMALL_STATE(10571)] = 410681,
  [SMALL_STATE(10572)] = 410701,
  [SMALL_STATE(10573)] = 410721,
  [SMALL_STATE(10574)] = 410741,
  [SMALL_STATE(10575)] = 410761,
  [SMALL_STATE(10576)] = 410781,
  [SMALL_STATE(10577)] = 410801,
  [SMALL_STATE(10578)] = 410821,
  [SMALL_STATE(10579)] = 410841,
  [SMALL_STATE(10580)] = 410861,
  [SMALL_STATE(10581)] = 410875,
  [SMALL_STATE(10582)] = 410895,
  [SMALL_STATE(10583)] = 410915,
  [SMALL_STATE(10584)] = 410935,
  [SMALL_STATE(10585)] = 410955,
  [SMALL_STATE(10586)] = 410975,
  [SMALL_STATE(10587)] = 410995,
  [SMALL_STATE(10588)] = 411015,
  [SMALL_STATE(10589)] = 411035,
  [SMALL_STATE(10590)] = 411055,
  [SMALL_STATE(10591)] = 411075,
  [SMALL_STATE(10592)] = 411095,
  [SMALL_STATE(10593)] = 411109,
  [SMALL_STATE(10594)] = 411123,
  [SMALL_STATE(10595)] = 411137,
  [SMALL_STATE(10596)] = 411157,
  [SMALL_STATE(10597)] = 411171,
  [SMALL_STATE(10598)] = 411191,
  [SMALL_STATE(10599)] = 411211,
  [SMALL_STATE(10600)] = 411231,
  [SMALL_STATE(10601)] = 411251,
  [SMALL_STATE(10602)] = 411271,
  [SMALL_STATE(10603)] = 411285,
  [SMALL_STATE(10604)] = 411299,
  [SMALL_STATE(10605)] = 411319,
  [SMALL_STATE(10606)] = 411339,
  [SMALL_STATE(10607)] = 411353,
  [SMALL_STATE(10608)] = 411373,
  [SMALL_STATE(10609)] = 411393,
  [SMALL_STATE(10610)] = 411413,
  [SMALL_STATE(10611)] = 411433,
  [SMALL_STATE(10612)] = 411447,
  [SMALL_STATE(10613)] = 411467,
  [SMALL_STATE(10614)] = 411487,
  [SMALL_STATE(10615)] = 411507,
  [SMALL_STATE(10616)] = 411527,
  [SMALL_STATE(10617)] = 411547,
  [SMALL_STATE(10618)] = 411567,
  [SMALL_STATE(10619)] = 411581,
  [SMALL_STATE(10620)] = 411595,
  [SMALL_STATE(10621)] = 411615,
  [SMALL_STATE(10622)] = 411635,
  [SMALL_STATE(10623)] = 411649,
  [SMALL_STATE(10624)] = 411669,
  [SMALL_STATE(10625)] = 411689,
  [SMALL_STATE(10626)] = 411703,
  [SMALL_STATE(10627)] = 411723,
  [SMALL_STATE(10628)] = 411743,
  [SMALL_STATE(10629)] = 411763,
  [SMALL_STATE(10630)] = 411783,
  [SMALL_STATE(10631)] = 411803,
  [SMALL_STATE(10632)] = 411823,
  [SMALL_STATE(10633)] = 411843,
  [SMALL_STATE(10634)] = 411863,
  [SMALL_STATE(10635)] = 411877,
  [SMALL_STATE(10636)] = 411891,
  [SMALL_STATE(10637)] = 411905,
  [SMALL_STATE(10638)] = 411919,
  [SMALL_STATE(10639)] = 411933,
  [SMALL_STATE(10640)] = 411953,
  [SMALL_STATE(10641)] = 411973,
  [SMALL_STATE(10642)] = 411993,
  [SMALL_STATE(10643)] = 412013,
  [SMALL_STATE(10644)] = 412033,
  [SMALL_STATE(10645)] = 412053,
  [SMALL_STATE(10646)] = 412073,
  [SMALL_STATE(10647)] = 412093,
  [SMALL_STATE(10648)] = 412113,
  [SMALL_STATE(10649)] = 412133,
  [SMALL_STATE(10650)] = 412153,
  [SMALL_STATE(10651)] = 412167,
  [SMALL_STATE(10652)] = 412185,
  [SMALL_STATE(10653)] = 412205,
  [SMALL_STATE(10654)] = 412225,
  [SMALL_STATE(10655)] = 412245,
  [SMALL_STATE(10656)] = 412259,
  [SMALL_STATE(10657)] = 412279,
  [SMALL_STATE(10658)] = 412295,
  [SMALL_STATE(10659)] = 412315,
  [SMALL_STATE(10660)] = 412335,
  [SMALL_STATE(10661)] = 412355,
  [SMALL_STATE(10662)] = 412375,
  [SMALL_STATE(10663)] = 412389,
  [SMALL_STATE(10664)] = 412407,
  [SMALL_STATE(10665)] = 412427,
  [SMALL_STATE(10666)] = 412447,
  [SMALL_STATE(10667)] = 412467,
  [SMALL_STATE(10668)] = 412483,
  [SMALL_STATE(10669)] = 412497,
  [SMALL_STATE(10670)] = 412517,
  [SMALL_STATE(10671)] = 412531,
  [SMALL_STATE(10672)] = 412551,
  [SMALL_STATE(10673)] = 412571,
  [SMALL_STATE(10674)] = 412591,
  [SMALL_STATE(10675)] = 412605,
  [SMALL_STATE(10676)] = 412625,
  [SMALL_STATE(10677)] = 412643,
  [SMALL_STATE(10678)] = 412663,
  [SMALL_STATE(10679)] = 412683,
  [SMALL_STATE(10680)] = 412697,
  [SMALL_STATE(10681)] = 412717,
  [SMALL_STATE(10682)] = 412731,
  [SMALL_STATE(10683)] = 412745,
  [SMALL_STATE(10684)] = 412765,
  [SMALL_STATE(10685)] = 412779,
  [SMALL_STATE(10686)] = 412799,
  [SMALL_STATE(10687)] = 412819,
  [SMALL_STATE(10688)] = 412839,
  [SMALL_STATE(10689)] = 412857,
  [SMALL_STATE(10690)] = 412877,
  [SMALL_STATE(10691)] = 412891,
  [SMALL_STATE(10692)] = 412911,
  [SMALL_STATE(10693)] = 412931,
  [SMALL_STATE(10694)] = 412951,
  [SMALL_STATE(10695)] = 412971,
  [SMALL_STATE(10696)] = 412991,
  [SMALL_STATE(10697)] = 413005,
  [SMALL_STATE(10698)] = 413025,
  [SMALL_STATE(10699)] = 413045,
  [SMALL_STATE(10700)] = 413063,
  [SMALL_STATE(10701)] = 413083,
  [SMALL_STATE(10702)] = 413103,
  [SMALL_STATE(10703)] = 413117,
  [SMALL_STATE(10704)] = 413137,
  [SMALL_STATE(10705)] = 413151,
  [SMALL_STATE(10706)] = 413165,
  [SMALL_STATE(10707)] = 413185,
  [SMALL_STATE(10708)] = 413205,
  [SMALL_STATE(10709)] = 413219,
  [SMALL_STATE(10710)] = 413233,
  [SMALL_STATE(10711)] = 413253,
  [SMALL_STATE(10712)] = 413273,
  [SMALL_STATE(10713)] = 413293,
  [SMALL_STATE(10714)] = 413313,
  [SMALL_STATE(10715)] = 413333,
  [SMALL_STATE(10716)] = 413347,
  [SMALL_STATE(10717)] = 413361,
  [SMALL_STATE(10718)] = 413375,
  [SMALL_STATE(10719)] = 413395,
  [SMALL_STATE(10720)] = 413409,
  [SMALL_STATE(10721)] = 413423,
  [SMALL_STATE(10722)] = 413437,
  [SMALL_STATE(10723)] = 413457,
  [SMALL_STATE(10724)] = 413471,
  [SMALL_STATE(10725)] = 413491,
  [SMALL_STATE(10726)] = 413511,
  [SMALL_STATE(10727)] = 413531,
  [SMALL_STATE(10728)] = 413551,
  [SMALL_STATE(10729)] = 413571,
  [SMALL_STATE(10730)] = 413591,
  [SMALL_STATE(10731)] = 413611,
  [SMALL_STATE(10732)] = 413631,
  [SMALL_STATE(10733)] = 413651,
  [SMALL_STATE(10734)] = 413671,
  [SMALL_STATE(10735)] = 413691,
  [SMALL_STATE(10736)] = 413705,
  [SMALL_STATE(10737)] = 413719,
  [SMALL_STATE(10738)] = 413733,
  [SMALL_STATE(10739)] = 413747,
  [SMALL_STATE(10740)] = 413767,
  [SMALL_STATE(10741)] = 413787,
  [SMALL_STATE(10742)] = 413807,
  [SMALL_STATE(10743)] = 413821,
  [SMALL_STATE(10744)] = 413841,
  [SMALL_STATE(10745)] = 413861,
  [SMALL_STATE(10746)] = 413875,
  [SMALL_STATE(10747)] = 413895,
  [SMALL_STATE(10748)] = 413909,
  [SMALL_STATE(10749)] = 413929,
  [SMALL_STATE(10750)] = 413943,
  [SMALL_STATE(10751)] = 413957,
  [SMALL_STATE(10752)] = 413977,
  [SMALL_STATE(10753)] = 413997,
  [SMALL_STATE(10754)] = 414011,
  [SMALL_STATE(10755)] = 414025,
  [SMALL_STATE(10756)] = 414045,
  [SMALL_STATE(10757)] = 414059,
  [SMALL_STATE(10758)] = 414079,
  [SMALL_STATE(10759)] = 414093,
  [SMALL_STATE(10760)] = 414113,
  [SMALL_STATE(10761)] = 414133,
  [SMALL_STATE(10762)] = 414153,
  [SMALL_STATE(10763)] = 414173,
  [SMALL_STATE(10764)] = 414193,
  [SMALL_STATE(10765)] = 414213,
  [SMALL_STATE(10766)] = 414233,
  [SMALL_STATE(10767)] = 414247,
  [SMALL_STATE(10768)] = 414267,
  [SMALL_STATE(10769)] = 414287,
  [SMALL_STATE(10770)] = 414307,
  [SMALL_STATE(10771)] = 414327,
  [SMALL_STATE(10772)] = 414341,
  [SMALL_STATE(10773)] = 414355,
  [SMALL_STATE(10774)] = 414375,
  [SMALL_STATE(10775)] = 414393,
  [SMALL_STATE(10776)] = 414413,
  [SMALL_STATE(10777)] = 414433,
  [SMALL_STATE(10778)] = 414447,
  [SMALL_STATE(10779)] = 414467,
  [SMALL_STATE(10780)] = 414487,
  [SMALL_STATE(10781)] = 414501,
  [SMALL_STATE(10782)] = 414521,
  [SMALL_STATE(10783)] = 414535,
  [SMALL_STATE(10784)] = 414549,
  [SMALL_STATE(10785)] = 414569,
  [SMALL_STATE(10786)] = 414589,
  [SMALL_STATE(10787)] = 414603,
  [SMALL_STATE(10788)] = 414623,
  [SMALL_STATE(10789)] = 414643,
  [SMALL_STATE(10790)] = 414663,
  [SMALL_STATE(10791)] = 414683,
  [SMALL_STATE(10792)] = 414703,
  [SMALL_STATE(10793)] = 414723,
  [SMALL_STATE(10794)] = 414743,
  [SMALL_STATE(10795)] = 414763,
  [SMALL_STATE(10796)] = 414783,
  [SMALL_STATE(10797)] = 414803,
  [SMALL_STATE(10798)] = 414823,
  [SMALL_STATE(10799)] = 414843,
  [SMALL_STATE(10800)] = 414863,
  [SMALL_STATE(10801)] = 414883,
  [SMALL_STATE(10802)] = 414903,
  [SMALL_STATE(10803)] = 414921,
  [SMALL_STATE(10804)] = 414941,
  [SMALL_STATE(10805)] = 414961,
  [SMALL_STATE(10806)] = 414975,
  [SMALL_STATE(10807)] = 414995,
  [SMALL_STATE(10808)] = 415015,
  [SMALL_STATE(10809)] = 415035,
  [SMALL_STATE(10810)] = 415055,
  [SMALL_STATE(10811)] = 415069,
  [SMALL_STATE(10812)] = 415089,
  [SMALL_STATE(10813)] = 415103,
  [SMALL_STATE(10814)] = 415117,
  [SMALL_STATE(10815)] = 415137,
  [SMALL_STATE(10816)] = 415151,
  [SMALL_STATE(10817)] = 415169,
  [SMALL_STATE(10818)] = 415189,
  [SMALL_STATE(10819)] = 415209,
  [SMALL_STATE(10820)] = 415223,
  [SMALL_STATE(10821)] = 415243,
  [SMALL_STATE(10822)] = 415263,
  [SMALL_STATE(10823)] = 415283,
  [SMALL_STATE(10824)] = 415303,
  [SMALL_STATE(10825)] = 415323,
  [SMALL_STATE(10826)] = 415343,
  [SMALL_STATE(10827)] = 415363,
  [SMALL_STATE(10828)] = 415383,
  [SMALL_STATE(10829)] = 415397,
  [SMALL_STATE(10830)] = 415417,
  [SMALL_STATE(10831)] = 415437,
  [SMALL_STATE(10832)] = 415457,
  [SMALL_STATE(10833)] = 415477,
  [SMALL_STATE(10834)] = 415497,
  [SMALL_STATE(10835)] = 415517,
  [SMALL_STATE(10836)] = 415537,
  [SMALL_STATE(10837)] = 415557,
  [SMALL_STATE(10838)] = 415577,
  [SMALL_STATE(10839)] = 415597,
  [SMALL_STATE(10840)] = 415617,
  [SMALL_STATE(10841)] = 415637,
  [SMALL_STATE(10842)] = 415657,
  [SMALL_STATE(10843)] = 415677,
  [SMALL_STATE(10844)] = 415697,
  [SMALL_STATE(10845)] = 415717,
  [SMALL_STATE(10846)] = 415737,
  [SMALL_STATE(10847)] = 415751,
  [SMALL_STATE(10848)] = 415765,
  [SMALL_STATE(10849)] = 415779,
  [SMALL_STATE(10850)] = 415799,
  [SMALL_STATE(10851)] = 415819,
  [SMALL_STATE(10852)] = 415833,
  [SMALL_STATE(10853)] = 415847,
  [SMALL_STATE(10854)] = 415867,
  [SMALL_STATE(10855)] = 415887,
  [SMALL_STATE(10856)] = 415907,
  [SMALL_STATE(10857)] = 415921,
  [SMALL_STATE(10858)] = 415941,
  [SMALL_STATE(10859)] = 415961,
  [SMALL_STATE(10860)] = 415981,
  [SMALL_STATE(10861)] = 416001,
  [SMALL_STATE(10862)] = 416021,
  [SMALL_STATE(10863)] = 416041,
  [SMALL_STATE(10864)] = 416061,
  [SMALL_STATE(10865)] = 416075,
  [SMALL_STATE(10866)] = 416095,
  [SMALL_STATE(10867)] = 416115,
  [SMALL_STATE(10868)] = 416135,
  [SMALL_STATE(10869)] = 416155,
  [SMALL_STATE(10870)] = 416175,
  [SMALL_STATE(10871)] = 416195,
  [SMALL_STATE(10872)] = 416215,
  [SMALL_STATE(10873)] = 416235,
  [SMALL_STATE(10874)] = 416249,
  [SMALL_STATE(10875)] = 416263,
  [SMALL_STATE(10876)] = 416277,
  [SMALL_STATE(10877)] = 416291,
  [SMALL_STATE(10878)] = 416305,
  [SMALL_STATE(10879)] = 416319,
  [SMALL_STATE(10880)] = 416339,
  [SMALL_STATE(10881)] = 416359,
  [SMALL_STATE(10882)] = 416379,
  [SMALL_STATE(10883)] = 416399,
  [SMALL_STATE(10884)] = 416419,
  [SMALL_STATE(10885)] = 416433,
  [SMALL_STATE(10886)] = 416453,
  [SMALL_STATE(10887)] = 416473,
  [SMALL_STATE(10888)] = 416490,
  [SMALL_STATE(10889)] = 416507,
  [SMALL_STATE(10890)] = 416524,
  [SMALL_STATE(10891)] = 416537,
  [SMALL_STATE(10892)] = 416550,
  [SMALL_STATE(10893)] = 416567,
  [SMALL_STATE(10894)] = 416582,
  [SMALL_STATE(10895)] = 416599,
  [SMALL_STATE(10896)] = 416614,
  [SMALL_STATE(10897)] = 416627,
  [SMALL_STATE(10898)] = 416642,
  [SMALL_STATE(10899)] = 416655,
  [SMALL_STATE(10900)] = 416668,
  [SMALL_STATE(10901)] = 416681,
  [SMALL_STATE(10902)] = 416694,
  [SMALL_STATE(10903)] = 416707,
  [SMALL_STATE(10904)] = 416724,
  [SMALL_STATE(10905)] = 416741,
  [SMALL_STATE(10906)] = 416758,
  [SMALL_STATE(10907)] = 416775,
  [SMALL_STATE(10908)] = 416792,
  [SMALL_STATE(10909)] = 416809,
  [SMALL_STATE(10910)] = 416826,
  [SMALL_STATE(10911)] = 416843,
  [SMALL_STATE(10912)] = 416856,
  [SMALL_STATE(10913)] = 416873,
  [SMALL_STATE(10914)] = 416890,
  [SMALL_STATE(10915)] = 416907,
  [SMALL_STATE(10916)] = 416924,
  [SMALL_STATE(10917)] = 416939,
  [SMALL_STATE(10918)] = 416956,
  [SMALL_STATE(10919)] = 416973,
  [SMALL_STATE(10920)] = 416990,
  [SMALL_STATE(10921)] = 417007,
  [SMALL_STATE(10922)] = 417024,
  [SMALL_STATE(10923)] = 417041,
  [SMALL_STATE(10924)] = 417056,
  [SMALL_STATE(10925)] = 417071,
  [SMALL_STATE(10926)] = 417088,
  [SMALL_STATE(10927)] = 417103,
  [SMALL_STATE(10928)] = 417120,
  [SMALL_STATE(10929)] = 417135,
  [SMALL_STATE(10930)] = 417150,
  [SMALL_STATE(10931)] = 417167,
  [SMALL_STATE(10932)] = 417182,
  [SMALL_STATE(10933)] = 417199,
  [SMALL_STATE(10934)] = 417216,
  [SMALL_STATE(10935)] = 417233,
  [SMALL_STATE(10936)] = 417250,
  [SMALL_STATE(10937)] = 417267,
  [SMALL_STATE(10938)] = 417282,
  [SMALL_STATE(10939)] = 417297,
  [SMALL_STATE(10940)] = 417314,
  [SMALL_STATE(10941)] = 417331,
  [SMALL_STATE(10942)] = 417346,
  [SMALL_STATE(10943)] = 417361,
  [SMALL_STATE(10944)] = 417376,
  [SMALL_STATE(10945)] = 417391,
  [SMALL_STATE(10946)] = 417406,
  [SMALL_STATE(10947)] = 417421,
  [SMALL_STATE(10948)] = 417436,
  [SMALL_STATE(10949)] = 417453,
  [SMALL_STATE(10950)] = 417470,
  [SMALL_STATE(10951)] = 417485,
  [SMALL_STATE(10952)] = 417500,
  [SMALL_STATE(10953)] = 417517,
  [SMALL_STATE(10954)] = 417532,
  [SMALL_STATE(10955)] = 417549,
  [SMALL_STATE(10956)] = 417562,
  [SMALL_STATE(10957)] = 417577,
  [SMALL_STATE(10958)] = 417594,
  [SMALL_STATE(10959)] = 417611,
  [SMALL_STATE(10960)] = 417628,
  [SMALL_STATE(10961)] = 417643,
  [SMALL_STATE(10962)] = 417658,
  [SMALL_STATE(10963)] = 417673,
  [SMALL_STATE(10964)] = 417690,
  [SMALL_STATE(10965)] = 417707,
  [SMALL_STATE(10966)] = 417722,
  [SMALL_STATE(10967)] = 417739,
  [SMALL_STATE(10968)] = 417756,
  [SMALL_STATE(10969)] = 417773,
  [SMALL_STATE(10970)] = 417788,
  [SMALL_STATE(10971)] = 417801,
  [SMALL_STATE(10972)] = 417818,
  [SMALL_STATE(10973)] = 417835,
  [SMALL_STATE(10974)] = 417852,
  [SMALL_STATE(10975)] = 417867,
  [SMALL_STATE(10976)] = 417884,
  [SMALL_STATE(10977)] = 417901,
  [SMALL_STATE(10978)] = 417918,
  [SMALL_STATE(10979)] = 417933,
  [SMALL_STATE(10980)] = 417950,
  [SMALL_STATE(10981)] = 417965,
  [SMALL_STATE(10982)] = 417980,
  [SMALL_STATE(10983)] = 417997,
  [SMALL_STATE(10984)] = 418014,
  [SMALL_STATE(10985)] = 418029,
  [SMALL_STATE(10986)] = 418044,
  [SMALL_STATE(10987)] = 418059,
  [SMALL_STATE(10988)] = 418076,
  [SMALL_STATE(10989)] = 418093,
  [SMALL_STATE(10990)] = 418106,
  [SMALL_STATE(10991)] = 418121,
  [SMALL_STATE(10992)] = 418138,
  [SMALL_STATE(10993)] = 418155,
  [SMALL_STATE(10994)] = 418170,
  [SMALL_STATE(10995)] = 418185,
  [SMALL_STATE(10996)] = 418202,
  [SMALL_STATE(10997)] = 418217,
  [SMALL_STATE(10998)] = 418234,
  [SMALL_STATE(10999)] = 418249,
  [SMALL_STATE(11000)] = 418262,
  [SMALL_STATE(11001)] = 418279,
  [SMALL_STATE(11002)] = 418294,
  [SMALL_STATE(11003)] = 418309,
  [SMALL_STATE(11004)] = 418326,
  [SMALL_STATE(11005)] = 418343,
  [SMALL_STATE(11006)] = 418360,
  [SMALL_STATE(11007)] = 418373,
  [SMALL_STATE(11008)] = 418390,
  [SMALL_STATE(11009)] = 418407,
  [SMALL_STATE(11010)] = 418424,
  [SMALL_STATE(11011)] = 418439,
  [SMALL_STATE(11012)] = 418452,
  [SMALL_STATE(11013)] = 418469,
  [SMALL_STATE(11014)] = 418486,
  [SMALL_STATE(11015)] = 418503,
  [SMALL_STATE(11016)] = 418520,
  [SMALL_STATE(11017)] = 418535,
  [SMALL_STATE(11018)] = 418550,
  [SMALL_STATE(11019)] = 418567,
  [SMALL_STATE(11020)] = 418584,
  [SMALL_STATE(11021)] = 418601,
  [SMALL_STATE(11022)] = 418614,
  [SMALL_STATE(11023)] = 418629,
  [SMALL_STATE(11024)] = 418646,
  [SMALL_STATE(11025)] = 418663,
  [SMALL_STATE(11026)] = 418680,
  [SMALL_STATE(11027)] = 418697,
  [SMALL_STATE(11028)] = 418714,
  [SMALL_STATE(11029)] = 418731,
  [SMALL_STATE(11030)] = 418748,
  [SMALL_STATE(11031)] = 418765,
  [SMALL_STATE(11032)] = 418782,
  [SMALL_STATE(11033)] = 418797,
  [SMALL_STATE(11034)] = 418814,
  [SMALL_STATE(11035)] = 418831,
  [SMALL_STATE(11036)] = 418846,
  [SMALL_STATE(11037)] = 418863,
  [SMALL_STATE(11038)] = 418880,
  [SMALL_STATE(11039)] = 418897,
  [SMALL_STATE(11040)] = 418912,
  [SMALL_STATE(11041)] = 418929,
  [SMALL_STATE(11042)] = 418946,
  [SMALL_STATE(11043)] = 418963,
  [SMALL_STATE(11044)] = 418980,
  [SMALL_STATE(11045)] = 418997,
  [SMALL_STATE(11046)] = 419014,
  [SMALL_STATE(11047)] = 419031,
  [SMALL_STATE(11048)] = 419048,
  [SMALL_STATE(11049)] = 419065,
  [SMALL_STATE(11050)] = 419080,
  [SMALL_STATE(11051)] = 419097,
  [SMALL_STATE(11052)] = 419114,
  [SMALL_STATE(11053)] = 419131,
  [SMALL_STATE(11054)] = 419148,
  [SMALL_STATE(11055)] = 419165,
  [SMALL_STATE(11056)] = 419180,
  [SMALL_STATE(11057)] = 419197,
  [SMALL_STATE(11058)] = 419214,
  [SMALL_STATE(11059)] = 419231,
  [SMALL_STATE(11060)] = 419248,
  [SMALL_STATE(11061)] = 419265,
  [SMALL_STATE(11062)] = 419282,
  [SMALL_STATE(11063)] = 419299,
  [SMALL_STATE(11064)] = 419316,
  [SMALL_STATE(11065)] = 419333,
  [SMALL_STATE(11066)] = 419350,
  [SMALL_STATE(11067)] = 419367,
  [SMALL_STATE(11068)] = 419380,
  [SMALL_STATE(11069)] = 419395,
  [SMALL_STATE(11070)] = 419410,
  [SMALL_STATE(11071)] = 419427,
  [SMALL_STATE(11072)] = 419440,
  [SMALL_STATE(11073)] = 419455,
  [SMALL_STATE(11074)] = 419472,
  [SMALL_STATE(11075)] = 419489,
  [SMALL_STATE(11076)] = 419506,
  [SMALL_STATE(11077)] = 419523,
  [SMALL_STATE(11078)] = 419538,
  [SMALL_STATE(11079)] = 419555,
  [SMALL_STATE(11080)] = 419570,
  [SMALL_STATE(11081)] = 419587,
  [SMALL_STATE(11082)] = 419604,
  [SMALL_STATE(11083)] = 419621,
  [SMALL_STATE(11084)] = 419638,
  [SMALL_STATE(11085)] = 419655,
  [SMALL_STATE(11086)] = 419672,
  [SMALL_STATE(11087)] = 419687,
  [SMALL_STATE(11088)] = 419700,
  [SMALL_STATE(11089)] = 419717,
  [SMALL_STATE(11090)] = 419732,
  [SMALL_STATE(11091)] = 419747,
  [SMALL_STATE(11092)] = 419764,
  [SMALL_STATE(11093)] = 419777,
  [SMALL_STATE(11094)] = 419790,
  [SMALL_STATE(11095)] = 419805,
  [SMALL_STATE(11096)] = 419822,
  [SMALL_STATE(11097)] = 419839,
  [SMALL_STATE(11098)] = 419856,
  [SMALL_STATE(11099)] = 419873,
  [SMALL_STATE(11100)] = 419890,
  [SMALL_STATE(11101)] = 419907,
  [SMALL_STATE(11102)] = 419920,
  [SMALL_STATE(11103)] = 419935,
  [SMALL_STATE(11104)] = 419950,
  [SMALL_STATE(11105)] = 419967,
  [SMALL_STATE(11106)] = 419984,
  [SMALL_STATE(11107)] = 419999,
  [SMALL_STATE(11108)] = 420016,
  [SMALL_STATE(11109)] = 420033,
  [SMALL_STATE(11110)] = 420048,
  [SMALL_STATE(11111)] = 420065,
  [SMALL_STATE(11112)] = 420082,
  [SMALL_STATE(11113)] = 420099,
  [SMALL_STATE(11114)] = 420116,
  [SMALL_STATE(11115)] = 420129,
  [SMALL_STATE(11116)] = 420146,
  [SMALL_STATE(11117)] = 420161,
  [SMALL_STATE(11118)] = 420176,
  [SMALL_STATE(11119)] = 420193,
  [SMALL_STATE(11120)] = 420206,
  [SMALL_STATE(11121)] = 420223,
  [SMALL_STATE(11122)] = 420238,
  [SMALL_STATE(11123)] = 420253,
  [SMALL_STATE(11124)] = 420270,
  [SMALL_STATE(11125)] = 420287,
  [SMALL_STATE(11126)] = 420304,
  [SMALL_STATE(11127)] = 420321,
  [SMALL_STATE(11128)] = 420338,
  [SMALL_STATE(11129)] = 420353,
  [SMALL_STATE(11130)] = 420368,
  [SMALL_STATE(11131)] = 420385,
  [SMALL_STATE(11132)] = 420400,
  [SMALL_STATE(11133)] = 420417,
  [SMALL_STATE(11134)] = 420432,
  [SMALL_STATE(11135)] = 420447,
  [SMALL_STATE(11136)] = 420464,
  [SMALL_STATE(11137)] = 420479,
  [SMALL_STATE(11138)] = 420496,
  [SMALL_STATE(11139)] = 420513,
  [SMALL_STATE(11140)] = 420528,
  [SMALL_STATE(11141)] = 420545,
  [SMALL_STATE(11142)] = 420562,
  [SMALL_STATE(11143)] = 420577,
  [SMALL_STATE(11144)] = 420594,
  [SMALL_STATE(11145)] = 420611,
  [SMALL_STATE(11146)] = 420628,
  [SMALL_STATE(11147)] = 420643,
  [SMALL_STATE(11148)] = 420656,
  [SMALL_STATE(11149)] = 420673,
  [SMALL_STATE(11150)] = 420688,
  [SMALL_STATE(11151)] = 420705,
  [SMALL_STATE(11152)] = 420722,
  [SMALL_STATE(11153)] = 420737,
  [SMALL_STATE(11154)] = 420754,
  [SMALL_STATE(11155)] = 420771,
  [SMALL_STATE(11156)] = 420788,
  [SMALL_STATE(11157)] = 420803,
  [SMALL_STATE(11158)] = 420820,
  [SMALL_STATE(11159)] = 420837,
  [SMALL_STATE(11160)] = 420854,
  [SMALL_STATE(11161)] = 420871,
  [SMALL_STATE(11162)] = 420888,
  [SMALL_STATE(11163)] = 420905,
  [SMALL_STATE(11164)] = 420920,
  [SMALL_STATE(11165)] = 420937,
  [SMALL_STATE(11166)] = 420954,
  [SMALL_STATE(11167)] = 420971,
  [SMALL_STATE(11168)] = 420986,
  [SMALL_STATE(11169)] = 421001,
  [SMALL_STATE(11170)] = 421018,
  [SMALL_STATE(11171)] = 421035,
  [SMALL_STATE(11172)] = 421052,
  [SMALL_STATE(11173)] = 421065,
  [SMALL_STATE(11174)] = 421080,
  [SMALL_STATE(11175)] = 421093,
  [SMALL_STATE(11176)] = 421110,
  [SMALL_STATE(11177)] = 421125,
  [SMALL_STATE(11178)] = 421142,
  [SMALL_STATE(11179)] = 421159,
  [SMALL_STATE(11180)] = 421176,
  [SMALL_STATE(11181)] = 421191,
  [SMALL_STATE(11182)] = 421208,
  [SMALL_STATE(11183)] = 421225,
  [SMALL_STATE(11184)] = 421240,
  [SMALL_STATE(11185)] = 421255,
  [SMALL_STATE(11186)] = 421272,
  [SMALL_STATE(11187)] = 421285,
  [SMALL_STATE(11188)] = 421302,
  [SMALL_STATE(11189)] = 421315,
  [SMALL_STATE(11190)] = 421332,
  [SMALL_STATE(11191)] = 421347,
  [SMALL_STATE(11192)] = 421364,
  [SMALL_STATE(11193)] = 421379,
  [SMALL_STATE(11194)] = 421394,
  [SMALL_STATE(11195)] = 421411,
  [SMALL_STATE(11196)] = 421428,
  [SMALL_STATE(11197)] = 421445,
  [SMALL_STATE(11198)] = 421462,
  [SMALL_STATE(11199)] = 421479,
  [SMALL_STATE(11200)] = 421496,
  [SMALL_STATE(11201)] = 421511,
  [SMALL_STATE(11202)] = 421526,
  [SMALL_STATE(11203)] = 421541,
  [SMALL_STATE(11204)] = 421558,
  [SMALL_STATE(11205)] = 421575,
  [SMALL_STATE(11206)] = 421590,
  [SMALL_STATE(11207)] = 421607,
  [SMALL_STATE(11208)] = 421624,
  [SMALL_STATE(11209)] = 421641,
  [SMALL_STATE(11210)] = 421658,
  [SMALL_STATE(11211)] = 421673,
  [SMALL_STATE(11212)] = 421688,
  [SMALL_STATE(11213)] = 421703,
  [SMALL_STATE(11214)] = 421720,
  [SMALL_STATE(11215)] = 421737,
  [SMALL_STATE(11216)] = 421754,
  [SMALL_STATE(11217)] = 421771,
  [SMALL_STATE(11218)] = 421788,
  [SMALL_STATE(11219)] = 421805,
  [SMALL_STATE(11220)] = 421822,
  [SMALL_STATE(11221)] = 421837,
  [SMALL_STATE(11222)] = 421852,
  [SMALL_STATE(11223)] = 421869,
  [SMALL_STATE(11224)] = 421882,
  [SMALL_STATE(11225)] = 421897,
  [SMALL_STATE(11226)] = 421914,
  [SMALL_STATE(11227)] = 421929,
  [SMALL_STATE(11228)] = 421946,
  [SMALL_STATE(11229)] = 421963,
  [SMALL_STATE(11230)] = 421976,
  [SMALL_STATE(11231)] = 421991,
  [SMALL_STATE(11232)] = 422008,
  [SMALL_STATE(11233)] = 422025,
  [SMALL_STATE(11234)] = 422040,
  [SMALL_STATE(11235)] = 422055,
  [SMALL_STATE(11236)] = 422070,
  [SMALL_STATE(11237)] = 422087,
  [SMALL_STATE(11238)] = 422104,
  [SMALL_STATE(11239)] = 422121,
  [SMALL_STATE(11240)] = 422138,
  [SMALL_STATE(11241)] = 422155,
  [SMALL_STATE(11242)] = 422172,
  [SMALL_STATE(11243)] = 422189,
  [SMALL_STATE(11244)] = 422202,
  [SMALL_STATE(11245)] = 422219,
  [SMALL_STATE(11246)] = 422236,
  [SMALL_STATE(11247)] = 422251,
  [SMALL_STATE(11248)] = 422268,
  [SMALL_STATE(11249)] = 422283,
  [SMALL_STATE(11250)] = 422300,
  [SMALL_STATE(11251)] = 422317,
  [SMALL_STATE(11252)] = 422334,
  [SMALL_STATE(11253)] = 422351,
  [SMALL_STATE(11254)] = 422366,
  [SMALL_STATE(11255)] = 422383,
  [SMALL_STATE(11256)] = 422398,
  [SMALL_STATE(11257)] = 422415,
  [SMALL_STATE(11258)] = 422430,
  [SMALL_STATE(11259)] = 422445,
  [SMALL_STATE(11260)] = 422462,
  [SMALL_STATE(11261)] = 422479,
  [SMALL_STATE(11262)] = 422494,
  [SMALL_STATE(11263)] = 422511,
  [SMALL_STATE(11264)] = 422528,
  [SMALL_STATE(11265)] = 422543,
  [SMALL_STATE(11266)] = 422560,
  [SMALL_STATE(11267)] = 422577,
  [SMALL_STATE(11268)] = 422592,
  [SMALL_STATE(11269)] = 422609,
  [SMALL_STATE(11270)] = 422624,
  [SMALL_STATE(11271)] = 422641,
  [SMALL_STATE(11272)] = 422658,
  [SMALL_STATE(11273)] = 422673,
  [SMALL_STATE(11274)] = 422690,
  [SMALL_STATE(11275)] = 422707,
  [SMALL_STATE(11276)] = 422722,
  [SMALL_STATE(11277)] = 422739,
  [SMALL_STATE(11278)] = 422756,
  [SMALL_STATE(11279)] = 422773,
  [SMALL_STATE(11280)] = 422790,
  [SMALL_STATE(11281)] = 422807,
  [SMALL_STATE(11282)] = 422824,
  [SMALL_STATE(11283)] = 422841,
  [SMALL_STATE(11284)] = 422858,
  [SMALL_STATE(11285)] = 422873,
  [SMALL_STATE(11286)] = 422890,
  [SMALL_STATE(11287)] = 422907,
  [SMALL_STATE(11288)] = 422924,
  [SMALL_STATE(11289)] = 422941,
  [SMALL_STATE(11290)] = 422958,
  [SMALL_STATE(11291)] = 422971,
  [SMALL_STATE(11292)] = 422988,
  [SMALL_STATE(11293)] = 423001,
  [SMALL_STATE(11294)] = 423016,
  [SMALL_STATE(11295)] = 423031,
  [SMALL_STATE(11296)] = 423046,
  [SMALL_STATE(11297)] = 423063,
  [SMALL_STATE(11298)] = 423078,
  [SMALL_STATE(11299)] = 423095,
  [SMALL_STATE(11300)] = 423110,
  [SMALL_STATE(11301)] = 423127,
  [SMALL_STATE(11302)] = 423144,
  [SMALL_STATE(11303)] = 423157,
  [SMALL_STATE(11304)] = 423174,
  [SMALL_STATE(11305)] = 423189,
  [SMALL_STATE(11306)] = 423206,
  [SMALL_STATE(11307)] = 423221,
  [SMALL_STATE(11308)] = 423238,
  [SMALL_STATE(11309)] = 423255,
  [SMALL_STATE(11310)] = 423272,
  [SMALL_STATE(11311)] = 423289,
  [SMALL_STATE(11312)] = 423306,
  [SMALL_STATE(11313)] = 423321,
  [SMALL_STATE(11314)] = 423336,
  [SMALL_STATE(11315)] = 423353,
  [SMALL_STATE(11316)] = 423370,
  [SMALL_STATE(11317)] = 423387,
  [SMALL_STATE(11318)] = 423404,
  [SMALL_STATE(11319)] = 423421,
  [SMALL_STATE(11320)] = 423438,
  [SMALL_STATE(11321)] = 423455,
  [SMALL_STATE(11322)] = 423470,
  [SMALL_STATE(11323)] = 423485,
  [SMALL_STATE(11324)] = 423498,
  [SMALL_STATE(11325)] = 423513,
  [SMALL_STATE(11326)] = 423530,
  [SMALL_STATE(11327)] = 423547,
  [SMALL_STATE(11328)] = 423562,
  [SMALL_STATE(11329)] = 423579,
  [SMALL_STATE(11330)] = 423596,
  [SMALL_STATE(11331)] = 423610,
  [SMALL_STATE(11332)] = 423624,
  [SMALL_STATE(11333)] = 423638,
  [SMALL_STATE(11334)] = 423652,
  [SMALL_STATE(11335)] = 423664,
  [SMALL_STATE(11336)] = 423676,
  [SMALL_STATE(11337)] = 423690,
  [SMALL_STATE(11338)] = 423704,
  [SMALL_STATE(11339)] = 423718,
  [SMALL_STATE(11340)] = 423732,
  [SMALL_STATE(11341)] = 423744,
  [SMALL_STATE(11342)] = 423756,
  [SMALL_STATE(11343)] = 423768,
  [SMALL_STATE(11344)] = 423782,
  [SMALL_STATE(11345)] = 423794,
  [SMALL_STATE(11346)] = 423806,
  [SMALL_STATE(11347)] = 423820,
  [SMALL_STATE(11348)] = 423834,
  [SMALL_STATE(11349)] = 423848,
  [SMALL_STATE(11350)] = 423862,
  [SMALL_STATE(11351)] = 423876,
  [SMALL_STATE(11352)] = 423888,
  [SMALL_STATE(11353)] = 423902,
  [SMALL_STATE(11354)] = 423916,
  [SMALL_STATE(11355)] = 423930,
  [SMALL_STATE(11356)] = 423944,
  [SMALL_STATE(11357)] = 423958,
  [SMALL_STATE(11358)] = 423972,
  [SMALL_STATE(11359)] = 423986,
  [SMALL_STATE(11360)] = 424000,
  [SMALL_STATE(11361)] = 424014,
  [SMALL_STATE(11362)] = 424028,
  [SMALL_STATE(11363)] = 424042,
  [SMALL_STATE(11364)] = 424056,
  [SMALL_STATE(11365)] = 424070,
  [SMALL_STATE(11366)] = 424084,
  [SMALL_STATE(11367)] = 424098,
  [SMALL_STATE(11368)] = 424112,
  [SMALL_STATE(11369)] = 424126,
  [SMALL_STATE(11370)] = 424138,
  [SMALL_STATE(11371)] = 424152,
  [SMALL_STATE(11372)] = 424166,
  [SMALL_STATE(11373)] = 424180,
  [SMALL_STATE(11374)] = 424194,
  [SMALL_STATE(11375)] = 424208,
  [SMALL_STATE(11376)] = 424222,
  [SMALL_STATE(11377)] = 424234,
  [SMALL_STATE(11378)] = 424248,
  [SMALL_STATE(11379)] = 424262,
  [SMALL_STATE(11380)] = 424276,
  [SMALL_STATE(11381)] = 424290,
  [SMALL_STATE(11382)] = 424304,
  [SMALL_STATE(11383)] = 424318,
  [SMALL_STATE(11384)] = 424330,
  [SMALL_STATE(11385)] = 424344,
  [SMALL_STATE(11386)] = 424358,
  [SMALL_STATE(11387)] = 424370,
  [SMALL_STATE(11388)] = 424384,
  [SMALL_STATE(11389)] = 424398,
  [SMALL_STATE(11390)] = 424412,
  [SMALL_STATE(11391)] = 424426,
  [SMALL_STATE(11392)] = 424440,
  [SMALL_STATE(11393)] = 424454,
  [SMALL_STATE(11394)] = 424468,
  [SMALL_STATE(11395)] = 424482,
  [SMALL_STATE(11396)] = 424496,
  [SMALL_STATE(11397)] = 424510,
  [SMALL_STATE(11398)] = 424524,
  [SMALL_STATE(11399)] = 424538,
  [SMALL_STATE(11400)] = 424552,
  [SMALL_STATE(11401)] = 424566,
  [SMALL_STATE(11402)] = 424580,
  [SMALL_STATE(11403)] = 424594,
  [SMALL_STATE(11404)] = 424608,
  [SMALL_STATE(11405)] = 424622,
  [SMALL_STATE(11406)] = 424636,
  [SMALL_STATE(11407)] = 424650,
  [SMALL_STATE(11408)] = 424664,
  [SMALL_STATE(11409)] = 424678,
  [SMALL_STATE(11410)] = 424692,
  [SMALL_STATE(11411)] = 424704,
  [SMALL_STATE(11412)] = 424716,
  [SMALL_STATE(11413)] = 424730,
  [SMALL_STATE(11414)] = 424744,
  [SMALL_STATE(11415)] = 424758,
  [SMALL_STATE(11416)] = 424772,
  [SMALL_STATE(11417)] = 424786,
  [SMALL_STATE(11418)] = 424800,
  [SMALL_STATE(11419)] = 424812,
  [SMALL_STATE(11420)] = 424826,
  [SMALL_STATE(11421)] = 424838,
  [SMALL_STATE(11422)] = 424852,
  [SMALL_STATE(11423)] = 424866,
  [SMALL_STATE(11424)] = 424880,
  [SMALL_STATE(11425)] = 424894,
  [SMALL_STATE(11426)] = 424908,
  [SMALL_STATE(11427)] = 424922,
  [SMALL_STATE(11428)] = 424936,
  [SMALL_STATE(11429)] = 424950,
  [SMALL_STATE(11430)] = 424964,
  [SMALL_STATE(11431)] = 424978,
  [SMALL_STATE(11432)] = 424992,
  [SMALL_STATE(11433)] = 425006,
  [SMALL_STATE(11434)] = 425020,
  [SMALL_STATE(11435)] = 425034,
  [SMALL_STATE(11436)] = 425048,
  [SMALL_STATE(11437)] = 425062,
  [SMALL_STATE(11438)] = 425074,
  [SMALL_STATE(11439)] = 425086,
  [SMALL_STATE(11440)] = 425098,
  [SMALL_STATE(11441)] = 425112,
  [SMALL_STATE(11442)] = 425126,
  [SMALL_STATE(11443)] = 425140,
  [SMALL_STATE(11444)] = 425154,
  [SMALL_STATE(11445)] = 425168,
  [SMALL_STATE(11446)] = 425182,
  [SMALL_STATE(11447)] = 425196,
  [SMALL_STATE(11448)] = 425208,
  [SMALL_STATE(11449)] = 425222,
  [SMALL_STATE(11450)] = 425236,
  [SMALL_STATE(11451)] = 425250,
  [SMALL_STATE(11452)] = 425264,
  [SMALL_STATE(11453)] = 425276,
  [SMALL_STATE(11454)] = 425288,
  [SMALL_STATE(11455)] = 425302,
  [SMALL_STATE(11456)] = 425314,
  [SMALL_STATE(11457)] = 425326,
  [SMALL_STATE(11458)] = 425338,
  [SMALL_STATE(11459)] = 425350,
  [SMALL_STATE(11460)] = 425364,
  [SMALL_STATE(11461)] = 425378,
  [SMALL_STATE(11462)] = 425392,
  [SMALL_STATE(11463)] = 425406,
  [SMALL_STATE(11464)] = 425420,
  [SMALL_STATE(11465)] = 425434,
  [SMALL_STATE(11466)] = 425448,
  [SMALL_STATE(11467)] = 425462,
  [SMALL_STATE(11468)] = 425476,
  [SMALL_STATE(11469)] = 425490,
  [SMALL_STATE(11470)] = 425502,
  [SMALL_STATE(11471)] = 425516,
  [SMALL_STATE(11472)] = 425530,
  [SMALL_STATE(11473)] = 425542,
  [SMALL_STATE(11474)] = 425556,
  [SMALL_STATE(11475)] = 425570,
  [SMALL_STATE(11476)] = 425582,
  [SMALL_STATE(11477)] = 425596,
  [SMALL_STATE(11478)] = 425608,
  [SMALL_STATE(11479)] = 425622,
  [SMALL_STATE(11480)] = 425634,
  [SMALL_STATE(11481)] = 425648,
  [SMALL_STATE(11482)] = 425660,
  [SMALL_STATE(11483)] = 425672,
  [SMALL_STATE(11484)] = 425686,
  [SMALL_STATE(11485)] = 425698,
  [SMALL_STATE(11486)] = 425710,
  [SMALL_STATE(11487)] = 425724,
  [SMALL_STATE(11488)] = 425736,
  [SMALL_STATE(11489)] = 425750,
  [SMALL_STATE(11490)] = 425762,
  [SMALL_STATE(11491)] = 425774,
  [SMALL_STATE(11492)] = 425788,
  [SMALL_STATE(11493)] = 425802,
  [SMALL_STATE(11494)] = 425816,
  [SMALL_STATE(11495)] = 425830,
  [SMALL_STATE(11496)] = 425844,
  [SMALL_STATE(11497)] = 425858,
  [SMALL_STATE(11498)] = 425872,
  [SMALL_STATE(11499)] = 425886,
  [SMALL_STATE(11500)] = 425900,
  [SMALL_STATE(11501)] = 425912,
  [SMALL_STATE(11502)] = 425926,
  [SMALL_STATE(11503)] = 425940,
  [SMALL_STATE(11504)] = 425954,
  [SMALL_STATE(11505)] = 425968,
  [SMALL_STATE(11506)] = 425982,
  [SMALL_STATE(11507)] = 425996,
  [SMALL_STATE(11508)] = 426008,
  [SMALL_STATE(11509)] = 426022,
  [SMALL_STATE(11510)] = 426036,
  [SMALL_STATE(11511)] = 426050,
  [SMALL_STATE(11512)] = 426064,
  [SMALL_STATE(11513)] = 426078,
  [SMALL_STATE(11514)] = 426092,
  [SMALL_STATE(11515)] = 426104,
  [SMALL_STATE(11516)] = 426118,
  [SMALL_STATE(11517)] = 426132,
  [SMALL_STATE(11518)] = 426146,
  [SMALL_STATE(11519)] = 426160,
  [SMALL_STATE(11520)] = 426174,
  [SMALL_STATE(11521)] = 426188,
  [SMALL_STATE(11522)] = 426200,
  [SMALL_STATE(11523)] = 426212,
  [SMALL_STATE(11524)] = 426224,
  [SMALL_STATE(11525)] = 426238,
  [SMALL_STATE(11526)] = 426252,
  [SMALL_STATE(11527)] = 426264,
  [SMALL_STATE(11528)] = 426278,
  [SMALL_STATE(11529)] = 426292,
  [SMALL_STATE(11530)] = 426304,
  [SMALL_STATE(11531)] = 426318,
  [SMALL_STATE(11532)] = 426332,
  [SMALL_STATE(11533)] = 426346,
  [SMALL_STATE(11534)] = 426360,
  [SMALL_STATE(11535)] = 426374,
  [SMALL_STATE(11536)] = 426388,
  [SMALL_STATE(11537)] = 426402,
  [SMALL_STATE(11538)] = 426416,
  [SMALL_STATE(11539)] = 426430,
  [SMALL_STATE(11540)] = 426444,
  [SMALL_STATE(11541)] = 426458,
  [SMALL_STATE(11542)] = 426472,
  [SMALL_STATE(11543)] = 426486,
  [SMALL_STATE(11544)] = 426498,
  [SMALL_STATE(11545)] = 426512,
  [SMALL_STATE(11546)] = 426526,
  [SMALL_STATE(11547)] = 426540,
  [SMALL_STATE(11548)] = 426554,
  [SMALL_STATE(11549)] = 426566,
  [SMALL_STATE(11550)] = 426578,
  [SMALL_STATE(11551)] = 426590,
  [SMALL_STATE(11552)] = 426602,
  [SMALL_STATE(11553)] = 426616,
  [SMALL_STATE(11554)] = 426630,
  [SMALL_STATE(11555)] = 426642,
  [SMALL_STATE(11556)] = 426654,
  [SMALL_STATE(11557)] = 426668,
  [SMALL_STATE(11558)] = 426680,
  [SMALL_STATE(11559)] = 426692,
  [SMALL_STATE(11560)] = 426706,
  [SMALL_STATE(11561)] = 426718,
  [SMALL_STATE(11562)] = 426732,
  [SMALL_STATE(11563)] = 426744,
  [SMALL_STATE(11564)] = 426758,
  [SMALL_STATE(11565)] = 426772,
  [SMALL_STATE(11566)] = 426786,
  [SMALL_STATE(11567)] = 426798,
  [SMALL_STATE(11568)] = 426812,
  [SMALL_STATE(11569)] = 426826,
  [SMALL_STATE(11570)] = 426840,
  [SMALL_STATE(11571)] = 426852,
  [SMALL_STATE(11572)] = 426864,
  [SMALL_STATE(11573)] = 426878,
  [SMALL_STATE(11574)] = 426890,
  [SMALL_STATE(11575)] = 426904,
  [SMALL_STATE(11576)] = 426918,
  [SMALL_STATE(11577)] = 426932,
  [SMALL_STATE(11578)] = 426946,
  [SMALL_STATE(11579)] = 426960,
  [SMALL_STATE(11580)] = 426974,
  [SMALL_STATE(11581)] = 426988,
  [SMALL_STATE(11582)] = 427000,
  [SMALL_STATE(11583)] = 427014,
  [SMALL_STATE(11584)] = 427026,
  [SMALL_STATE(11585)] = 427038,
  [SMALL_STATE(11586)] = 427052,
  [SMALL_STATE(11587)] = 427066,
  [SMALL_STATE(11588)] = 427080,
  [SMALL_STATE(11589)] = 427094,
  [SMALL_STATE(11590)] = 427108,
  [SMALL_STATE(11591)] = 427122,
  [SMALL_STATE(11592)] = 427136,
  [SMALL_STATE(11593)] = 427150,
  [SMALL_STATE(11594)] = 427164,
  [SMALL_STATE(11595)] = 427178,
  [SMALL_STATE(11596)] = 427190,
  [SMALL_STATE(11597)] = 427202,
  [SMALL_STATE(11598)] = 427214,
  [SMALL_STATE(11599)] = 427226,
  [SMALL_STATE(11600)] = 427238,
  [SMALL_STATE(11601)] = 427252,
  [SMALL_STATE(11602)] = 427266,
  [SMALL_STATE(11603)] = 427278,
  [SMALL_STATE(11604)] = 427292,
  [SMALL_STATE(11605)] = 427306,
  [SMALL_STATE(11606)] = 427320,
  [SMALL_STATE(11607)] = 427334,
  [SMALL_STATE(11608)] = 427346,
  [SMALL_STATE(11609)] = 427360,
  [SMALL_STATE(11610)] = 427374,
  [SMALL_STATE(11611)] = 427388,
  [SMALL_STATE(11612)] = 427402,
  [SMALL_STATE(11613)] = 427416,
  [SMALL_STATE(11614)] = 427430,
  [SMALL_STATE(11615)] = 427444,
  [SMALL_STATE(11616)] = 427458,
  [SMALL_STATE(11617)] = 427472,
  [SMALL_STATE(11618)] = 427486,
  [SMALL_STATE(11619)] = 427498,
  [SMALL_STATE(11620)] = 427512,
  [SMALL_STATE(11621)] = 427526,
  [SMALL_STATE(11622)] = 427540,
  [SMALL_STATE(11623)] = 427554,
  [SMALL_STATE(11624)] = 427568,
  [SMALL_STATE(11625)] = 427582,
  [SMALL_STATE(11626)] = 427596,
  [SMALL_STATE(11627)] = 427610,
  [SMALL_STATE(11628)] = 427624,
  [SMALL_STATE(11629)] = 427638,
  [SMALL_STATE(11630)] = 427652,
  [SMALL_STATE(11631)] = 427666,
  [SMALL_STATE(11632)] = 427680,
  [SMALL_STATE(11633)] = 427692,
  [SMALL_STATE(11634)] = 427706,
  [SMALL_STATE(11635)] = 427720,
  [SMALL_STATE(11636)] = 427734,
  [SMALL_STATE(11637)] = 427748,
  [SMALL_STATE(11638)] = 427760,
  [SMALL_STATE(11639)] = 427774,
  [SMALL_STATE(11640)] = 427788,
  [SMALL_STATE(11641)] = 427800,
  [SMALL_STATE(11642)] = 427814,
  [SMALL_STATE(11643)] = 427828,
  [SMALL_STATE(11644)] = 427840,
  [SMALL_STATE(11645)] = 427854,
  [SMALL_STATE(11646)] = 427868,
  [SMALL_STATE(11647)] = 427882,
  [SMALL_STATE(11648)] = 427894,
  [SMALL_STATE(11649)] = 427906,
  [SMALL_STATE(11650)] = 427920,
  [SMALL_STATE(11651)] = 427934,
  [SMALL_STATE(11652)] = 427948,
  [SMALL_STATE(11653)] = 427962,
  [SMALL_STATE(11654)] = 427976,
  [SMALL_STATE(11655)] = 427988,
  [SMALL_STATE(11656)] = 428002,
  [SMALL_STATE(11657)] = 428016,
  [SMALL_STATE(11658)] = 428028,
  [SMALL_STATE(11659)] = 428042,
  [SMALL_STATE(11660)] = 428056,
  [SMALL_STATE(11661)] = 428070,
  [SMALL_STATE(11662)] = 428082,
  [SMALL_STATE(11663)] = 428094,
  [SMALL_STATE(11664)] = 428108,
  [SMALL_STATE(11665)] = 428122,
  [SMALL_STATE(11666)] = 428134,
  [SMALL_STATE(11667)] = 428148,
  [SMALL_STATE(11668)] = 428162,
  [SMALL_STATE(11669)] = 428174,
  [SMALL_STATE(11670)] = 428186,
  [SMALL_STATE(11671)] = 428200,
  [SMALL_STATE(11672)] = 428212,
  [SMALL_STATE(11673)] = 428226,
  [SMALL_STATE(11674)] = 428240,
  [SMALL_STATE(11675)] = 428254,
  [SMALL_STATE(11676)] = 428268,
  [SMALL_STATE(11677)] = 428282,
  [SMALL_STATE(11678)] = 428294,
  [SMALL_STATE(11679)] = 428308,
  [SMALL_STATE(11680)] = 428322,
  [SMALL_STATE(11681)] = 428334,
  [SMALL_STATE(11682)] = 428348,
  [SMALL_STATE(11683)] = 428360,
  [SMALL_STATE(11684)] = 428374,
  [SMALL_STATE(11685)] = 428388,
  [SMALL_STATE(11686)] = 428400,
  [SMALL_STATE(11687)] = 428414,
  [SMALL_STATE(11688)] = 428428,
  [SMALL_STATE(11689)] = 428442,
  [SMALL_STATE(11690)] = 428456,
  [SMALL_STATE(11691)] = 428470,
  [SMALL_STATE(11692)] = 428482,
  [SMALL_STATE(11693)] = 428494,
  [SMALL_STATE(11694)] = 428508,
  [SMALL_STATE(11695)] = 428522,
  [SMALL_STATE(11696)] = 428536,
  [SMALL_STATE(11697)] = 428550,
  [SMALL_STATE(11698)] = 428562,
  [SMALL_STATE(11699)] = 428576,
  [SMALL_STATE(11700)] = 428588,
  [SMALL_STATE(11701)] = 428602,
  [SMALL_STATE(11702)] = 428614,
  [SMALL_STATE(11703)] = 428626,
  [SMALL_STATE(11704)] = 428640,
  [SMALL_STATE(11705)] = 428652,
  [SMALL_STATE(11706)] = 428664,
  [SMALL_STATE(11707)] = 428676,
  [SMALL_STATE(11708)] = 428688,
  [SMALL_STATE(11709)] = 428702,
  [SMALL_STATE(11710)] = 428716,
  [SMALL_STATE(11711)] = 428730,
  [SMALL_STATE(11712)] = 428744,
  [SMALL_STATE(11713)] = 428756,
  [SMALL_STATE(11714)] = 428768,
  [SMALL_STATE(11715)] = 428782,
  [SMALL_STATE(11716)] = 428796,
  [SMALL_STATE(11717)] = 428810,
  [SMALL_STATE(11718)] = 428824,
  [SMALL_STATE(11719)] = 428836,
  [SMALL_STATE(11720)] = 428848,
  [SMALL_STATE(11721)] = 428862,
  [SMALL_STATE(11722)] = 428874,
  [SMALL_STATE(11723)] = 428888,
  [SMALL_STATE(11724)] = 428902,
  [SMALL_STATE(11725)] = 428916,
  [SMALL_STATE(11726)] = 428930,
  [SMALL_STATE(11727)] = 428944,
  [SMALL_STATE(11728)] = 428958,
  [SMALL_STATE(11729)] = 428970,
  [SMALL_STATE(11730)] = 428982,
  [SMALL_STATE(11731)] = 428996,
  [SMALL_STATE(11732)] = 429010,
  [SMALL_STATE(11733)] = 429024,
  [SMALL_STATE(11734)] = 429036,
  [SMALL_STATE(11735)] = 429050,
  [SMALL_STATE(11736)] = 429064,
  [SMALL_STATE(11737)] = 429078,
  [SMALL_STATE(11738)] = 429092,
  [SMALL_STATE(11739)] = 429106,
  [SMALL_STATE(11740)] = 429118,
  [SMALL_STATE(11741)] = 429132,
  [SMALL_STATE(11742)] = 429146,
  [SMALL_STATE(11743)] = 429160,
  [SMALL_STATE(11744)] = 429172,
  [SMALL_STATE(11745)] = 429186,
  [SMALL_STATE(11746)] = 429200,
  [SMALL_STATE(11747)] = 429214,
  [SMALL_STATE(11748)] = 429228,
  [SMALL_STATE(11749)] = 429240,
  [SMALL_STATE(11750)] = 429254,
  [SMALL_STATE(11751)] = 429268,
  [SMALL_STATE(11752)] = 429282,
  [SMALL_STATE(11753)] = 429296,
  [SMALL_STATE(11754)] = 429310,
  [SMALL_STATE(11755)] = 429324,
  [SMALL_STATE(11756)] = 429338,
  [SMALL_STATE(11757)] = 429352,
  [SMALL_STATE(11758)] = 429366,
  [SMALL_STATE(11759)] = 429380,
  [SMALL_STATE(11760)] = 429394,
  [SMALL_STATE(11761)] = 429408,
  [SMALL_STATE(11762)] = 429422,
  [SMALL_STATE(11763)] = 429436,
  [SMALL_STATE(11764)] = 429450,
  [SMALL_STATE(11765)] = 429464,
  [SMALL_STATE(11766)] = 429478,
  [SMALL_STATE(11767)] = 429492,
  [SMALL_STATE(11768)] = 429506,
  [SMALL_STATE(11769)] = 429520,
  [SMALL_STATE(11770)] = 429534,
  [SMALL_STATE(11771)] = 429548,
  [SMALL_STATE(11772)] = 429562,
  [SMALL_STATE(11773)] = 429576,
  [SMALL_STATE(11774)] = 429590,
  [SMALL_STATE(11775)] = 429604,
  [SMALL_STATE(11776)] = 429618,
  [SMALL_STATE(11777)] = 429632,
  [SMALL_STATE(11778)] = 429646,
  [SMALL_STATE(11779)] = 429660,
  [SMALL_STATE(11780)] = 429674,
  [SMALL_STATE(11781)] = 429686,
  [SMALL_STATE(11782)] = 429700,
  [SMALL_STATE(11783)] = 429714,
  [SMALL_STATE(11784)] = 429728,
  [SMALL_STATE(11785)] = 429742,
  [SMALL_STATE(11786)] = 429756,
  [SMALL_STATE(11787)] = 429768,
  [SMALL_STATE(11788)] = 429782,
  [SMALL_STATE(11789)] = 429794,
  [SMALL_STATE(11790)] = 429808,
  [SMALL_STATE(11791)] = 429822,
  [SMALL_STATE(11792)] = 429836,
  [SMALL_STATE(11793)] = 429850,
  [SMALL_STATE(11794)] = 429864,
  [SMALL_STATE(11795)] = 429878,
  [SMALL_STATE(11796)] = 429892,
  [SMALL_STATE(11797)] = 429904,
  [SMALL_STATE(11798)] = 429918,
  [SMALL_STATE(11799)] = 429932,
  [SMALL_STATE(11800)] = 429946,
  [SMALL_STATE(11801)] = 429960,
  [SMALL_STATE(11802)] = 429974,
  [SMALL_STATE(11803)] = 429988,
  [SMALL_STATE(11804)] = 430002,
  [SMALL_STATE(11805)] = 430016,
  [SMALL_STATE(11806)] = 430030,
  [SMALL_STATE(11807)] = 430044,
  [SMALL_STATE(11808)] = 430056,
  [SMALL_STATE(11809)] = 430070,
  [SMALL_STATE(11810)] = 430084,
  [SMALL_STATE(11811)] = 430098,
  [SMALL_STATE(11812)] = 430112,
  [SMALL_STATE(11813)] = 430124,
  [SMALL_STATE(11814)] = 430138,
  [SMALL_STATE(11815)] = 430152,
  [SMALL_STATE(11816)] = 430166,
  [SMALL_STATE(11817)] = 430180,
  [SMALL_STATE(11818)] = 430192,
  [SMALL_STATE(11819)] = 430206,
  [SMALL_STATE(11820)] = 430218,
  [SMALL_STATE(11821)] = 430232,
  [SMALL_STATE(11822)] = 430246,
  [SMALL_STATE(11823)] = 430258,
  [SMALL_STATE(11824)] = 430272,
  [SMALL_STATE(11825)] = 430286,
  [SMALL_STATE(11826)] = 430300,
  [SMALL_STATE(11827)] = 430312,
  [SMALL_STATE(11828)] = 430326,
  [SMALL_STATE(11829)] = 430340,
  [SMALL_STATE(11830)] = 430354,
  [SMALL_STATE(11831)] = 430368,
  [SMALL_STATE(11832)] = 430382,
  [SMALL_STATE(11833)] = 430396,
  [SMALL_STATE(11834)] = 430410,
  [SMALL_STATE(11835)] = 430424,
  [SMALL_STATE(11836)] = 430438,
  [SMALL_STATE(11837)] = 430452,
  [SMALL_STATE(11838)] = 430466,
  [SMALL_STATE(11839)] = 430480,
  [SMALL_STATE(11840)] = 430492,
  [SMALL_STATE(11841)] = 430506,
  [SMALL_STATE(11842)] = 430520,
  [SMALL_STATE(11843)] = 430534,
  [SMALL_STATE(11844)] = 430548,
  [SMALL_STATE(11845)] = 430560,
  [SMALL_STATE(11846)] = 430574,
  [SMALL_STATE(11847)] = 430588,
  [SMALL_STATE(11848)] = 430602,
  [SMALL_STATE(11849)] = 430616,
  [SMALL_STATE(11850)] = 430628,
  [SMALL_STATE(11851)] = 430642,
  [SMALL_STATE(11852)] = 430654,
  [SMALL_STATE(11853)] = 430668,
  [SMALL_STATE(11854)] = 430682,
  [SMALL_STATE(11855)] = 430694,
  [SMALL_STATE(11856)] = 430708,
  [SMALL_STATE(11857)] = 430722,
  [SMALL_STATE(11858)] = 430734,
  [SMALL_STATE(11859)] = 430746,
  [SMALL_STATE(11860)] = 430760,
  [SMALL_STATE(11861)] = 430774,
  [SMALL_STATE(11862)] = 430786,
  [SMALL_STATE(11863)] = 430800,
  [SMALL_STATE(11864)] = 430814,
  [SMALL_STATE(11865)] = 430826,
  [SMALL_STATE(11866)] = 430840,
  [SMALL_STATE(11867)] = 430854,
  [SMALL_STATE(11868)] = 430868,
  [SMALL_STATE(11869)] = 430882,
  [SMALL_STATE(11870)] = 430896,
  [SMALL_STATE(11871)] = 430910,
  [SMALL_STATE(11872)] = 430924,
  [SMALL_STATE(11873)] = 430938,
  [SMALL_STATE(11874)] = 430952,
  [SMALL_STATE(11875)] = 430966,
  [SMALL_STATE(11876)] = 430980,
  [SMALL_STATE(11877)] = 430992,
  [SMALL_STATE(11878)] = 431004,
  [SMALL_STATE(11879)] = 431018,
  [SMALL_STATE(11880)] = 431032,
  [SMALL_STATE(11881)] = 431044,
  [SMALL_STATE(11882)] = 431058,
  [SMALL_STATE(11883)] = 431072,
  [SMALL_STATE(11884)] = 431086,
  [SMALL_STATE(11885)] = 431098,
  [SMALL_STATE(11886)] = 431112,
  [SMALL_STATE(11887)] = 431126,
  [SMALL_STATE(11888)] = 431138,
  [SMALL_STATE(11889)] = 431150,
  [SMALL_STATE(11890)] = 431164,
  [SMALL_STATE(11891)] = 431178,
  [SMALL_STATE(11892)] = 431192,
  [SMALL_STATE(11893)] = 431206,
  [SMALL_STATE(11894)] = 431220,
  [SMALL_STATE(11895)] = 431234,
  [SMALL_STATE(11896)] = 431248,
  [SMALL_STATE(11897)] = 431262,
  [SMALL_STATE(11898)] = 431276,
  [SMALL_STATE(11899)] = 431290,
  [SMALL_STATE(11900)] = 431304,
  [SMALL_STATE(11901)] = 431318,
  [SMALL_STATE(11902)] = 431332,
  [SMALL_STATE(11903)] = 431346,
  [SMALL_STATE(11904)] = 431360,
  [SMALL_STATE(11905)] = 431374,
  [SMALL_STATE(11906)] = 431388,
  [SMALL_STATE(11907)] = 431402,
  [SMALL_STATE(11908)] = 431416,
  [SMALL_STATE(11909)] = 431428,
  [SMALL_STATE(11910)] = 431440,
  [SMALL_STATE(11911)] = 431454,
  [SMALL_STATE(11912)] = 431468,
  [SMALL_STATE(11913)] = 431482,
  [SMALL_STATE(11914)] = 431496,
  [SMALL_STATE(11915)] = 431510,
  [SMALL_STATE(11916)] = 431524,
  [SMALL_STATE(11917)] = 431538,
  [SMALL_STATE(11918)] = 431552,
  [SMALL_STATE(11919)] = 431566,
  [SMALL_STATE(11920)] = 431580,
  [SMALL_STATE(11921)] = 431594,
  [SMALL_STATE(11922)] = 431608,
  [SMALL_STATE(11923)] = 431622,
  [SMALL_STATE(11924)] = 431634,
  [SMALL_STATE(11925)] = 431646,
  [SMALL_STATE(11926)] = 431658,
  [SMALL_STATE(11927)] = 431672,
  [SMALL_STATE(11928)] = 431686,
  [SMALL_STATE(11929)] = 431698,
  [SMALL_STATE(11930)] = 431712,
  [SMALL_STATE(11931)] = 431726,
  [SMALL_STATE(11932)] = 431738,
  [SMALL_STATE(11933)] = 431750,
  [SMALL_STATE(11934)] = 431762,
  [SMALL_STATE(11935)] = 431776,
  [SMALL_STATE(11936)] = 431790,
  [SMALL_STATE(11937)] = 431804,
  [SMALL_STATE(11938)] = 431818,
  [SMALL_STATE(11939)] = 431832,
  [SMALL_STATE(11940)] = 431846,
  [SMALL_STATE(11941)] = 431860,
  [SMALL_STATE(11942)] = 431874,
  [SMALL_STATE(11943)] = 431886,
  [SMALL_STATE(11944)] = 431898,
  [SMALL_STATE(11945)] = 431912,
  [SMALL_STATE(11946)] = 431926,
  [SMALL_STATE(11947)] = 431938,
  [SMALL_STATE(11948)] = 431952,
  [SMALL_STATE(11949)] = 431964,
  [SMALL_STATE(11950)] = 431978,
  [SMALL_STATE(11951)] = 431992,
  [SMALL_STATE(11952)] = 432004,
  [SMALL_STATE(11953)] = 432018,
  [SMALL_STATE(11954)] = 432032,
  [SMALL_STATE(11955)] = 432046,
  [SMALL_STATE(11956)] = 432060,
  [SMALL_STATE(11957)] = 432074,
  [SMALL_STATE(11958)] = 432088,
  [SMALL_STATE(11959)] = 432102,
  [SMALL_STATE(11960)] = 432116,
  [SMALL_STATE(11961)] = 432130,
  [SMALL_STATE(11962)] = 432144,
  [SMALL_STATE(11963)] = 432158,
  [SMALL_STATE(11964)] = 432172,
  [SMALL_STATE(11965)] = 432184,
  [SMALL_STATE(11966)] = 432198,
  [SMALL_STATE(11967)] = 432212,
  [SMALL_STATE(11968)] = 432224,
  [SMALL_STATE(11969)] = 432238,
  [SMALL_STATE(11970)] = 432250,
  [SMALL_STATE(11971)] = 432264,
  [SMALL_STATE(11972)] = 432278,
  [SMALL_STATE(11973)] = 432292,
  [SMALL_STATE(11974)] = 432306,
  [SMALL_STATE(11975)] = 432320,
  [SMALL_STATE(11976)] = 432334,
  [SMALL_STATE(11977)] = 432348,
  [SMALL_STATE(11978)] = 432362,
  [SMALL_STATE(11979)] = 432376,
  [SMALL_STATE(11980)] = 432390,
  [SMALL_STATE(11981)] = 432404,
  [SMALL_STATE(11982)] = 432418,
  [SMALL_STATE(11983)] = 432430,
  [SMALL_STATE(11984)] = 432442,
  [SMALL_STATE(11985)] = 432456,
  [SMALL_STATE(11986)] = 432470,
  [SMALL_STATE(11987)] = 432484,
  [SMALL_STATE(11988)] = 432498,
  [SMALL_STATE(11989)] = 432512,
  [SMALL_STATE(11990)] = 432526,
  [SMALL_STATE(11991)] = 432540,
  [SMALL_STATE(11992)] = 432554,
  [SMALL_STATE(11993)] = 432568,
  [SMALL_STATE(11994)] = 432582,
  [SMALL_STATE(11995)] = 432596,
  [SMALL_STATE(11996)] = 432610,
  [SMALL_STATE(11997)] = 432624,
  [SMALL_STATE(11998)] = 432638,
  [SMALL_STATE(11999)] = 432650,
  [SMALL_STATE(12000)] = 432664,
  [SMALL_STATE(12001)] = 432678,
  [SMALL_STATE(12002)] = 432692,
  [SMALL_STATE(12003)] = 432706,
  [SMALL_STATE(12004)] = 432720,
  [SMALL_STATE(12005)] = 432734,
  [SMALL_STATE(12006)] = 432748,
  [SMALL_STATE(12007)] = 432762,
  [SMALL_STATE(12008)] = 432776,
  [SMALL_STATE(12009)] = 432790,
  [SMALL_STATE(12010)] = 432804,
  [SMALL_STATE(12011)] = 432818,
  [SMALL_STATE(12012)] = 432832,
  [SMALL_STATE(12013)] = 432846,
  [SMALL_STATE(12014)] = 432858,
  [SMALL_STATE(12015)] = 432872,
  [SMALL_STATE(12016)] = 432886,
  [SMALL_STATE(12017)] = 432900,
  [SMALL_STATE(12018)] = 432914,
  [SMALL_STATE(12019)] = 432928,
  [SMALL_STATE(12020)] = 432942,
  [SMALL_STATE(12021)] = 432956,
  [SMALL_STATE(12022)] = 432970,
  [SMALL_STATE(12023)] = 432984,
  [SMALL_STATE(12024)] = 432998,
  [SMALL_STATE(12025)] = 433012,
  [SMALL_STATE(12026)] = 433024,
  [SMALL_STATE(12027)] = 433036,
  [SMALL_STATE(12028)] = 433050,
  [SMALL_STATE(12029)] = 433062,
  [SMALL_STATE(12030)] = 433074,
  [SMALL_STATE(12031)] = 433088,
  [SMALL_STATE(12032)] = 433102,
  [SMALL_STATE(12033)] = 433116,
  [SMALL_STATE(12034)] = 433130,
  [SMALL_STATE(12035)] = 433144,
  [SMALL_STATE(12036)] = 433158,
  [SMALL_STATE(12037)] = 433172,
  [SMALL_STATE(12038)] = 433186,
  [SMALL_STATE(12039)] = 433200,
  [SMALL_STATE(12040)] = 433212,
  [SMALL_STATE(12041)] = 433226,
  [SMALL_STATE(12042)] = 433238,
  [SMALL_STATE(12043)] = 433252,
  [SMALL_STATE(12044)] = 433266,
  [SMALL_STATE(12045)] = 433278,
  [SMALL_STATE(12046)] = 433292,
  [SMALL_STATE(12047)] = 433306,
  [SMALL_STATE(12048)] = 433320,
  [SMALL_STATE(12049)] = 433334,
  [SMALL_STATE(12050)] = 433348,
  [SMALL_STATE(12051)] = 433362,
  [SMALL_STATE(12052)] = 433374,
  [SMALL_STATE(12053)] = 433386,
  [SMALL_STATE(12054)] = 433398,
  [SMALL_STATE(12055)] = 433412,
  [SMALL_STATE(12056)] = 433426,
  [SMALL_STATE(12057)] = 433440,
  [SMALL_STATE(12058)] = 433454,
  [SMALL_STATE(12059)] = 433468,
  [SMALL_STATE(12060)] = 433482,
  [SMALL_STATE(12061)] = 433496,
  [SMALL_STATE(12062)] = 433510,
  [SMALL_STATE(12063)] = 433524,
  [SMALL_STATE(12064)] = 433538,
  [SMALL_STATE(12065)] = 433552,
  [SMALL_STATE(12066)] = 433564,
  [SMALL_STATE(12067)] = 433576,
  [SMALL_STATE(12068)] = 433590,
  [SMALL_STATE(12069)] = 433604,
  [SMALL_STATE(12070)] = 433618,
  [SMALL_STATE(12071)] = 433630,
  [SMALL_STATE(12072)] = 433642,
  [SMALL_STATE(12073)] = 433656,
  [SMALL_STATE(12074)] = 433670,
  [SMALL_STATE(12075)] = 433684,
  [SMALL_STATE(12076)] = 433698,
  [SMALL_STATE(12077)] = 433712,
  [SMALL_STATE(12078)] = 433726,
  [SMALL_STATE(12079)] = 433738,
  [SMALL_STATE(12080)] = 433750,
  [SMALL_STATE(12081)] = 433764,
  [SMALL_STATE(12082)] = 433778,
  [SMALL_STATE(12083)] = 433792,
  [SMALL_STATE(12084)] = 433806,
  [SMALL_STATE(12085)] = 433820,
  [SMALL_STATE(12086)] = 433834,
  [SMALL_STATE(12087)] = 433848,
  [SMALL_STATE(12088)] = 433862,
  [SMALL_STATE(12089)] = 433876,
  [SMALL_STATE(12090)] = 433888,
  [SMALL_STATE(12091)] = 433902,
  [SMALL_STATE(12092)] = 433916,
  [SMALL_STATE(12093)] = 433930,
  [SMALL_STATE(12094)] = 433944,
  [SMALL_STATE(12095)] = 433958,
  [SMALL_STATE(12096)] = 433970,
  [SMALL_STATE(12097)] = 433984,
  [SMALL_STATE(12098)] = 433998,
  [SMALL_STATE(12099)] = 434012,
  [SMALL_STATE(12100)] = 434026,
  [SMALL_STATE(12101)] = 434040,
  [SMALL_STATE(12102)] = 434054,
  [SMALL_STATE(12103)] = 434068,
  [SMALL_STATE(12104)] = 434082,
  [SMALL_STATE(12105)] = 434096,
  [SMALL_STATE(12106)] = 434110,
  [SMALL_STATE(12107)] = 434122,
  [SMALL_STATE(12108)] = 434136,
  [SMALL_STATE(12109)] = 434150,
  [SMALL_STATE(12110)] = 434164,
  [SMALL_STATE(12111)] = 434176,
  [SMALL_STATE(12112)] = 434190,
  [SMALL_STATE(12113)] = 434204,
  [SMALL_STATE(12114)] = 434218,
  [SMALL_STATE(12115)] = 434232,
  [SMALL_STATE(12116)] = 434246,
  [SMALL_STATE(12117)] = 434260,
  [SMALL_STATE(12118)] = 434272,
  [SMALL_STATE(12119)] = 434286,
  [SMALL_STATE(12120)] = 434300,
  [SMALL_STATE(12121)] = 434314,
  [SMALL_STATE(12122)] = 434328,
  [SMALL_STATE(12123)] = 434340,
  [SMALL_STATE(12124)] = 434354,
  [SMALL_STATE(12125)] = 434368,
  [SMALL_STATE(12126)] = 434380,
  [SMALL_STATE(12127)] = 434394,
  [SMALL_STATE(12128)] = 434408,
  [SMALL_STATE(12129)] = 434422,
  [SMALL_STATE(12130)] = 434436,
  [SMALL_STATE(12131)] = 434448,
  [SMALL_STATE(12132)] = 434462,
  [SMALL_STATE(12133)] = 434476,
  [SMALL_STATE(12134)] = 434488,
  [SMALL_STATE(12135)] = 434500,
  [SMALL_STATE(12136)] = 434514,
  [SMALL_STATE(12137)] = 434528,
  [SMALL_STATE(12138)] = 434542,
  [SMALL_STATE(12139)] = 434556,
  [SMALL_STATE(12140)] = 434570,
  [SMALL_STATE(12141)] = 434584,
  [SMALL_STATE(12142)] = 434598,
  [SMALL_STATE(12143)] = 434612,
  [SMALL_STATE(12144)] = 434626,
  [SMALL_STATE(12145)] = 434640,
  [SMALL_STATE(12146)] = 434654,
  [SMALL_STATE(12147)] = 434668,
  [SMALL_STATE(12148)] = 434680,
  [SMALL_STATE(12149)] = 434694,
  [SMALL_STATE(12150)] = 434706,
  [SMALL_STATE(12151)] = 434720,
  [SMALL_STATE(12152)] = 434734,
  [SMALL_STATE(12153)] = 434748,
  [SMALL_STATE(12154)] = 434760,
  [SMALL_STATE(12155)] = 434774,
  [SMALL_STATE(12156)] = 434786,
  [SMALL_STATE(12157)] = 434800,
  [SMALL_STATE(12158)] = 434814,
  [SMALL_STATE(12159)] = 434826,
  [SMALL_STATE(12160)] = 434838,
  [SMALL_STATE(12161)] = 434850,
  [SMALL_STATE(12162)] = 434862,
  [SMALL_STATE(12163)] = 434874,
  [SMALL_STATE(12164)] = 434886,
  [SMALL_STATE(12165)] = 434898,
  [SMALL_STATE(12166)] = 434910,
  [SMALL_STATE(12167)] = 434924,
  [SMALL_STATE(12168)] = 434936,
  [SMALL_STATE(12169)] = 434950,
  [SMALL_STATE(12170)] = 434964,
  [SMALL_STATE(12171)] = 434978,
  [SMALL_STATE(12172)] = 434990,
  [SMALL_STATE(12173)] = 435002,
  [SMALL_STATE(12174)] = 435014,
  [SMALL_STATE(12175)] = 435026,
  [SMALL_STATE(12176)] = 435038,
  [SMALL_STATE(12177)] = 435052,
  [SMALL_STATE(12178)] = 435064,
  [SMALL_STATE(12179)] = 435078,
  [SMALL_STATE(12180)] = 435090,
  [SMALL_STATE(12181)] = 435104,
  [SMALL_STATE(12182)] = 435116,
  [SMALL_STATE(12183)] = 435130,
  [SMALL_STATE(12184)] = 435144,
  [SMALL_STATE(12185)] = 435158,
  [SMALL_STATE(12186)] = 435172,
  [SMALL_STATE(12187)] = 435184,
  [SMALL_STATE(12188)] = 435198,
  [SMALL_STATE(12189)] = 435212,
  [SMALL_STATE(12190)] = 435224,
  [SMALL_STATE(12191)] = 435236,
  [SMALL_STATE(12192)] = 435250,
  [SMALL_STATE(12193)] = 435262,
  [SMALL_STATE(12194)] = 435274,
  [SMALL_STATE(12195)] = 435288,
  [SMALL_STATE(12196)] = 435300,
  [SMALL_STATE(12197)] = 435314,
  [SMALL_STATE(12198)] = 435326,
  [SMALL_STATE(12199)] = 435340,
  [SMALL_STATE(12200)] = 435354,
  [SMALL_STATE(12201)] = 435368,
  [SMALL_STATE(12202)] = 435382,
  [SMALL_STATE(12203)] = 435396,
  [SMALL_STATE(12204)] = 435408,
  [SMALL_STATE(12205)] = 435422,
  [SMALL_STATE(12206)] = 435436,
  [SMALL_STATE(12207)] = 435450,
  [SMALL_STATE(12208)] = 435464,
  [SMALL_STATE(12209)] = 435478,
  [SMALL_STATE(12210)] = 435492,
  [SMALL_STATE(12211)] = 435504,
  [SMALL_STATE(12212)] = 435518,
  [SMALL_STATE(12213)] = 435532,
  [SMALL_STATE(12214)] = 435544,
  [SMALL_STATE(12215)] = 435558,
  [SMALL_STATE(12216)] = 435570,
  [SMALL_STATE(12217)] = 435582,
  [SMALL_STATE(12218)] = 435596,
  [SMALL_STATE(12219)] = 435610,
  [SMALL_STATE(12220)] = 435624,
  [SMALL_STATE(12221)] = 435638,
  [SMALL_STATE(12222)] = 435652,
  [SMALL_STATE(12223)] = 435666,
  [SMALL_STATE(12224)] = 435680,
  [SMALL_STATE(12225)] = 435691,
  [SMALL_STATE(12226)] = 435702,
  [SMALL_STATE(12227)] = 435713,
  [SMALL_STATE(12228)] = 435724,
  [SMALL_STATE(12229)] = 435735,
  [SMALL_STATE(12230)] = 435746,
  [SMALL_STATE(12231)] = 435757,
  [SMALL_STATE(12232)] = 435768,
  [SMALL_STATE(12233)] = 435779,
  [SMALL_STATE(12234)] = 435790,
  [SMALL_STATE(12235)] = 435801,
  [SMALL_STATE(12236)] = 435812,
  [SMALL_STATE(12237)] = 435823,
  [SMALL_STATE(12238)] = 435834,
  [SMALL_STATE(12239)] = 435845,
  [SMALL_STATE(12240)] = 435856,
  [SMALL_STATE(12241)] = 435867,
  [SMALL_STATE(12242)] = 435878,
  [SMALL_STATE(12243)] = 435889,
  [SMALL_STATE(12244)] = 435900,
  [SMALL_STATE(12245)] = 435911,
  [SMALL_STATE(12246)] = 435922,
  [SMALL_STATE(12247)] = 435933,
  [SMALL_STATE(12248)] = 435944,
  [SMALL_STATE(12249)] = 435955,
  [SMALL_STATE(12250)] = 435966,
  [SMALL_STATE(12251)] = 435977,
  [SMALL_STATE(12252)] = 435988,
  [SMALL_STATE(12253)] = 435999,
  [SMALL_STATE(12254)] = 436010,
  [SMALL_STATE(12255)] = 436021,
  [SMALL_STATE(12256)] = 436032,
  [SMALL_STATE(12257)] = 436043,
  [SMALL_STATE(12258)] = 436054,
  [SMALL_STATE(12259)] = 436065,
  [SMALL_STATE(12260)] = 436076,
  [SMALL_STATE(12261)] = 436087,
  [SMALL_STATE(12262)] = 436098,
  [SMALL_STATE(12263)] = 436109,
  [SMALL_STATE(12264)] = 436120,
  [SMALL_STATE(12265)] = 436131,
  [SMALL_STATE(12266)] = 436142,
  [SMALL_STATE(12267)] = 436153,
  [SMALL_STATE(12268)] = 436164,
  [SMALL_STATE(12269)] = 436175,
  [SMALL_STATE(12270)] = 436186,
  [SMALL_STATE(12271)] = 436197,
  [SMALL_STATE(12272)] = 436208,
  [SMALL_STATE(12273)] = 436219,
  [SMALL_STATE(12274)] = 436230,
  [SMALL_STATE(12275)] = 436241,
  [SMALL_STATE(12276)] = 436252,
  [SMALL_STATE(12277)] = 436263,
  [SMALL_STATE(12278)] = 436274,
  [SMALL_STATE(12279)] = 436285,
  [SMALL_STATE(12280)] = 436296,
  [SMALL_STATE(12281)] = 436307,
  [SMALL_STATE(12282)] = 436318,
  [SMALL_STATE(12283)] = 436329,
  [SMALL_STATE(12284)] = 436340,
  [SMALL_STATE(12285)] = 436351,
  [SMALL_STATE(12286)] = 436362,
  [SMALL_STATE(12287)] = 436373,
  [SMALL_STATE(12288)] = 436384,
  [SMALL_STATE(12289)] = 436395,
  [SMALL_STATE(12290)] = 436406,
  [SMALL_STATE(12291)] = 436417,
  [SMALL_STATE(12292)] = 436428,
  [SMALL_STATE(12293)] = 436439,
  [SMALL_STATE(12294)] = 436450,
  [SMALL_STATE(12295)] = 436461,
  [SMALL_STATE(12296)] = 436472,
  [SMALL_STATE(12297)] = 436483,
  [SMALL_STATE(12298)] = 436494,
  [SMALL_STATE(12299)] = 436505,
  [SMALL_STATE(12300)] = 436516,
  [SMALL_STATE(12301)] = 436527,
  [SMALL_STATE(12302)] = 436538,
  [SMALL_STATE(12303)] = 436549,
  [SMALL_STATE(12304)] = 436560,
  [SMALL_STATE(12305)] = 436571,
  [SMALL_STATE(12306)] = 436582,
  [SMALL_STATE(12307)] = 436593,
  [SMALL_STATE(12308)] = 436604,
  [SMALL_STATE(12309)] = 436615,
  [SMALL_STATE(12310)] = 436626,
  [SMALL_STATE(12311)] = 436637,
  [SMALL_STATE(12312)] = 436648,
  [SMALL_STATE(12313)] = 436659,
  [SMALL_STATE(12314)] = 436670,
  [SMALL_STATE(12315)] = 436681,
  [SMALL_STATE(12316)] = 436692,
  [SMALL_STATE(12317)] = 436703,
  [SMALL_STATE(12318)] = 436714,
  [SMALL_STATE(12319)] = 436725,
  [SMALL_STATE(12320)] = 436736,
  [SMALL_STATE(12321)] = 436747,
  [SMALL_STATE(12322)] = 436758,
  [SMALL_STATE(12323)] = 436769,
  [SMALL_STATE(12324)] = 436780,
  [SMALL_STATE(12325)] = 436791,
  [SMALL_STATE(12326)] = 436802,
  [SMALL_STATE(12327)] = 436813,
  [SMALL_STATE(12328)] = 436824,
  [SMALL_STATE(12329)] = 436835,
  [SMALL_STATE(12330)] = 436846,
  [SMALL_STATE(12331)] = 436857,
  [SMALL_STATE(12332)] = 436868,
  [SMALL_STATE(12333)] = 436879,
  [SMALL_STATE(12334)] = 436890,
  [SMALL_STATE(12335)] = 436901,
  [SMALL_STATE(12336)] = 436912,
  [SMALL_STATE(12337)] = 436923,
  [SMALL_STATE(12338)] = 436934,
  [SMALL_STATE(12339)] = 436945,
  [SMALL_STATE(12340)] = 436956,
  [SMALL_STATE(12341)] = 436967,
  [SMALL_STATE(12342)] = 436978,
  [SMALL_STATE(12343)] = 436989,
  [SMALL_STATE(12344)] = 437000,
  [SMALL_STATE(12345)] = 437011,
  [SMALL_STATE(12346)] = 437022,
  [SMALL_STATE(12347)] = 437033,
  [SMALL_STATE(12348)] = 437044,
  [SMALL_STATE(12349)] = 437055,
  [SMALL_STATE(12350)] = 437066,
  [SMALL_STATE(12351)] = 437077,
  [SMALL_STATE(12352)] = 437088,
  [SMALL_STATE(12353)] = 437099,
  [SMALL_STATE(12354)] = 437110,
  [SMALL_STATE(12355)] = 437121,
  [SMALL_STATE(12356)] = 437132,
  [SMALL_STATE(12357)] = 437143,
  [SMALL_STATE(12358)] = 437154,
  [SMALL_STATE(12359)] = 437165,
  [SMALL_STATE(12360)] = 437176,
  [SMALL_STATE(12361)] = 437187,
  [SMALL_STATE(12362)] = 437198,
  [SMALL_STATE(12363)] = 437209,
  [SMALL_STATE(12364)] = 437220,
  [SMALL_STATE(12365)] = 437231,
  [SMALL_STATE(12366)] = 437242,
  [SMALL_STATE(12367)] = 437253,
  [SMALL_STATE(12368)] = 437264,
  [SMALL_STATE(12369)] = 437275,
  [SMALL_STATE(12370)] = 437286,
  [SMALL_STATE(12371)] = 437297,
  [SMALL_STATE(12372)] = 437308,
  [SMALL_STATE(12373)] = 437319,
  [SMALL_STATE(12374)] = 437330,
  [SMALL_STATE(12375)] = 437341,
  [SMALL_STATE(12376)] = 437352,
  [SMALL_STATE(12377)] = 437363,
  [SMALL_STATE(12378)] = 437374,
  [SMALL_STATE(12379)] = 437385,
  [SMALL_STATE(12380)] = 437396,
  [SMALL_STATE(12381)] = 437407,
  [SMALL_STATE(12382)] = 437418,
  [SMALL_STATE(12383)] = 437429,
  [SMALL_STATE(12384)] = 437440,
  [SMALL_STATE(12385)] = 437451,
  [SMALL_STATE(12386)] = 437462,
  [SMALL_STATE(12387)] = 437473,
  [SMALL_STATE(12388)] = 437484,
  [SMALL_STATE(12389)] = 437495,
  [SMALL_STATE(12390)] = 437506,
  [SMALL_STATE(12391)] = 437517,
  [SMALL_STATE(12392)] = 437528,
  [SMALL_STATE(12393)] = 437539,
  [SMALL_STATE(12394)] = 437550,
  [SMALL_STATE(12395)] = 437561,
  [SMALL_STATE(12396)] = 437572,
  [SMALL_STATE(12397)] = 437583,
  [SMALL_STATE(12398)] = 437594,
  [SMALL_STATE(12399)] = 437605,
  [SMALL_STATE(12400)] = 437616,
  [SMALL_STATE(12401)] = 437627,
  [SMALL_STATE(12402)] = 437638,
  [SMALL_STATE(12403)] = 437649,
  [SMALL_STATE(12404)] = 437660,
  [SMALL_STATE(12405)] = 437671,
  [SMALL_STATE(12406)] = 437682,
  [SMALL_STATE(12407)] = 437693,
  [SMALL_STATE(12408)] = 437704,
  [SMALL_STATE(12409)] = 437715,
  [SMALL_STATE(12410)] = 437726,
  [SMALL_STATE(12411)] = 437737,
  [SMALL_STATE(12412)] = 437748,
  [SMALL_STATE(12413)] = 437759,
  [SMALL_STATE(12414)] = 437770,
  [SMALL_STATE(12415)] = 437781,
  [SMALL_STATE(12416)] = 437792,
  [SMALL_STATE(12417)] = 437803,
  [SMALL_STATE(12418)] = 437814,
  [SMALL_STATE(12419)] = 437825,
  [SMALL_STATE(12420)] = 437836,
  [SMALL_STATE(12421)] = 437847,
  [SMALL_STATE(12422)] = 437858,
  [SMALL_STATE(12423)] = 437869,
  [SMALL_STATE(12424)] = 437880,
  [SMALL_STATE(12425)] = 437891,
  [SMALL_STATE(12426)] = 437902,
  [SMALL_STATE(12427)] = 437913,
  [SMALL_STATE(12428)] = 437924,
  [SMALL_STATE(12429)] = 437935,
  [SMALL_STATE(12430)] = 437946,
  [SMALL_STATE(12431)] = 437957,
  [SMALL_STATE(12432)] = 437968,
  [SMALL_STATE(12433)] = 437979,
  [SMALL_STATE(12434)] = 437990,
  [SMALL_STATE(12435)] = 438001,
  [SMALL_STATE(12436)] = 438012,
  [SMALL_STATE(12437)] = 438023,
  [SMALL_STATE(12438)] = 438034,
  [SMALL_STATE(12439)] = 438045,
  [SMALL_STATE(12440)] = 438056,
  [SMALL_STATE(12441)] = 438067,
  [SMALL_STATE(12442)] = 438078,
  [SMALL_STATE(12443)] = 438089,
  [SMALL_STATE(12444)] = 438100,
  [SMALL_STATE(12445)] = 438111,
  [SMALL_STATE(12446)] = 438122,
  [SMALL_STATE(12447)] = 438133,
  [SMALL_STATE(12448)] = 438144,
  [SMALL_STATE(12449)] = 438155,
  [SMALL_STATE(12450)] = 438166,
  [SMALL_STATE(12451)] = 438177,
  [SMALL_STATE(12452)] = 438188,
  [SMALL_STATE(12453)] = 438199,
  [SMALL_STATE(12454)] = 438210,
  [SMALL_STATE(12455)] = 438221,
  [SMALL_STATE(12456)] = 438232,
  [SMALL_STATE(12457)] = 438243,
  [SMALL_STATE(12458)] = 438254,
  [SMALL_STATE(12459)] = 438265,
  [SMALL_STATE(12460)] = 438276,
  [SMALL_STATE(12461)] = 438287,
  [SMALL_STATE(12462)] = 438298,
  [SMALL_STATE(12463)] = 438309,
  [SMALL_STATE(12464)] = 438320,
  [SMALL_STATE(12465)] = 438331,
  [SMALL_STATE(12466)] = 438342,
  [SMALL_STATE(12467)] = 438353,
  [SMALL_STATE(12468)] = 438364,
  [SMALL_STATE(12469)] = 438375,
  [SMALL_STATE(12470)] = 438386,
  [SMALL_STATE(12471)] = 438397,
  [SMALL_STATE(12472)] = 438408,
  [SMALL_STATE(12473)] = 438419,
  [SMALL_STATE(12474)] = 438430,
  [SMALL_STATE(12475)] = 438441,
  [SMALL_STATE(12476)] = 438452,
  [SMALL_STATE(12477)] = 438463,
  [SMALL_STATE(12478)] = 438474,
  [SMALL_STATE(12479)] = 438485,
  [SMALL_STATE(12480)] = 438496,
  [SMALL_STATE(12481)] = 438507,
  [SMALL_STATE(12482)] = 438518,
  [SMALL_STATE(12483)] = 438529,
  [SMALL_STATE(12484)] = 438540,
  [SMALL_STATE(12485)] = 438551,
  [SMALL_STATE(12486)] = 438562,
  [SMALL_STATE(12487)] = 438573,
  [SMALL_STATE(12488)] = 438584,
  [SMALL_STATE(12489)] = 438595,
  [SMALL_STATE(12490)] = 438606,
  [SMALL_STATE(12491)] = 438617,
  [SMALL_STATE(12492)] = 438628,
  [SMALL_STATE(12493)] = 438639,
  [SMALL_STATE(12494)] = 438650,
  [SMALL_STATE(12495)] = 438661,
  [SMALL_STATE(12496)] = 438672,
  [SMALL_STATE(12497)] = 438683,
  [SMALL_STATE(12498)] = 438694,
  [SMALL_STATE(12499)] = 438705,
  [SMALL_STATE(12500)] = 438716,
  [SMALL_STATE(12501)] = 438727,
  [SMALL_STATE(12502)] = 438738,
  [SMALL_STATE(12503)] = 438749,
  [SMALL_STATE(12504)] = 438760,
  [SMALL_STATE(12505)] = 438771,
  [SMALL_STATE(12506)] = 438782,
  [SMALL_STATE(12507)] = 438793,
  [SMALL_STATE(12508)] = 438804,
  [SMALL_STATE(12509)] = 438815,
  [SMALL_STATE(12510)] = 438826,
  [SMALL_STATE(12511)] = 438837,
  [SMALL_STATE(12512)] = 438848,
  [SMALL_STATE(12513)] = 438859,
  [SMALL_STATE(12514)] = 438870,
  [SMALL_STATE(12515)] = 438881,
  [SMALL_STATE(12516)] = 438892,
  [SMALL_STATE(12517)] = 438903,
  [SMALL_STATE(12518)] = 438914,
  [SMALL_STATE(12519)] = 438925,
  [SMALL_STATE(12520)] = 438936,
  [SMALL_STATE(12521)] = 438947,
  [SMALL_STATE(12522)] = 438958,
  [SMALL_STATE(12523)] = 438969,
  [SMALL_STATE(12524)] = 438980,
  [SMALL_STATE(12525)] = 438991,
  [SMALL_STATE(12526)] = 439002,
  [SMALL_STATE(12527)] = 439013,
  [SMALL_STATE(12528)] = 439024,
  [SMALL_STATE(12529)] = 439035,
  [SMALL_STATE(12530)] = 439046,
  [SMALL_STATE(12531)] = 439057,
  [SMALL_STATE(12532)] = 439068,
  [SMALL_STATE(12533)] = 439079,
  [SMALL_STATE(12534)] = 439090,
  [SMALL_STATE(12535)] = 439101,
  [SMALL_STATE(12536)] = 439112,
  [SMALL_STATE(12537)] = 439123,
  [SMALL_STATE(12538)] = 439134,
  [SMALL_STATE(12539)] = 439145,
  [SMALL_STATE(12540)] = 439156,
  [SMALL_STATE(12541)] = 439167,
  [SMALL_STATE(12542)] = 439178,
  [SMALL_STATE(12543)] = 439189,
  [SMALL_STATE(12544)] = 439200,
  [SMALL_STATE(12545)] = 439211,
  [SMALL_STATE(12546)] = 439222,
  [SMALL_STATE(12547)] = 439233,
  [SMALL_STATE(12548)] = 439244,
  [SMALL_STATE(12549)] = 439255,
  [SMALL_STATE(12550)] = 439266,
  [SMALL_STATE(12551)] = 439277,
  [SMALL_STATE(12552)] = 439288,
  [SMALL_STATE(12553)] = 439299,
  [SMALL_STATE(12554)] = 439310,
  [SMALL_STATE(12555)] = 439321,
  [SMALL_STATE(12556)] = 439332,
  [SMALL_STATE(12557)] = 439343,
  [SMALL_STATE(12558)] = 439354,
  [SMALL_STATE(12559)] = 439365,
  [SMALL_STATE(12560)] = 439376,
  [SMALL_STATE(12561)] = 439387,
  [SMALL_STATE(12562)] = 439398,
  [SMALL_STATE(12563)] = 439409,
  [SMALL_STATE(12564)] = 439420,
  [SMALL_STATE(12565)] = 439431,
  [SMALL_STATE(12566)] = 439442,
  [SMALL_STATE(12567)] = 439453,
  [SMALL_STATE(12568)] = 439464,
  [SMALL_STATE(12569)] = 439475,
  [SMALL_STATE(12570)] = 439486,
  [SMALL_STATE(12571)] = 439497,
  [SMALL_STATE(12572)] = 439508,
  [SMALL_STATE(12573)] = 439519,
  [SMALL_STATE(12574)] = 439530,
  [SMALL_STATE(12575)] = 439541,
  [SMALL_STATE(12576)] = 439552,
  [SMALL_STATE(12577)] = 439563,
  [SMALL_STATE(12578)] = 439574,
  [SMALL_STATE(12579)] = 439585,
  [SMALL_STATE(12580)] = 439596,
  [SMALL_STATE(12581)] = 439607,
  [SMALL_STATE(12582)] = 439618,
  [SMALL_STATE(12583)] = 439629,
  [SMALL_STATE(12584)] = 439640,
  [SMALL_STATE(12585)] = 439651,
  [SMALL_STATE(12586)] = 439662,
  [SMALL_STATE(12587)] = 439673,
  [SMALL_STATE(12588)] = 439684,
  [SMALL_STATE(12589)] = 439695,
  [SMALL_STATE(12590)] = 439706,
  [SMALL_STATE(12591)] = 439717,
  [SMALL_STATE(12592)] = 439728,
  [SMALL_STATE(12593)] = 439739,
  [SMALL_STATE(12594)] = 439750,
  [SMALL_STATE(12595)] = 439761,
  [SMALL_STATE(12596)] = 439772,
  [SMALL_STATE(12597)] = 439783,
  [SMALL_STATE(12598)] = 439794,
  [SMALL_STATE(12599)] = 439805,
  [SMALL_STATE(12600)] = 439816,
  [SMALL_STATE(12601)] = 439827,
  [SMALL_STATE(12602)] = 439838,
  [SMALL_STATE(12603)] = 439849,
  [SMALL_STATE(12604)] = 439860,
  [SMALL_STATE(12605)] = 439871,
  [SMALL_STATE(12606)] = 439882,
  [SMALL_STATE(12607)] = 439893,
  [SMALL_STATE(12608)] = 439904,
  [SMALL_STATE(12609)] = 439915,
  [SMALL_STATE(12610)] = 439926,
  [SMALL_STATE(12611)] = 439937,
  [SMALL_STATE(12612)] = 439948,
  [SMALL_STATE(12613)] = 439959,
  [SMALL_STATE(12614)] = 439970,
  [SMALL_STATE(12615)] = 439981,
  [SMALL_STATE(12616)] = 439992,
  [SMALL_STATE(12617)] = 440003,
  [SMALL_STATE(12618)] = 440014,
  [SMALL_STATE(12619)] = 440025,
  [SMALL_STATE(12620)] = 440036,
  [SMALL_STATE(12621)] = 440047,
  [SMALL_STATE(12622)] = 440058,
  [SMALL_STATE(12623)] = 440069,
  [SMALL_STATE(12624)] = 440080,
  [SMALL_STATE(12625)] = 440091,
  [SMALL_STATE(12626)] = 440102,
  [SMALL_STATE(12627)] = 440113,
  [SMALL_STATE(12628)] = 440124,
  [SMALL_STATE(12629)] = 440135,
  [SMALL_STATE(12630)] = 440146,
  [SMALL_STATE(12631)] = 440157,
  [SMALL_STATE(12632)] = 440168,
  [SMALL_STATE(12633)] = 440179,
  [SMALL_STATE(12634)] = 440190,
  [SMALL_STATE(12635)] = 440201,
  [SMALL_STATE(12636)] = 440212,
  [SMALL_STATE(12637)] = 440223,
  [SMALL_STATE(12638)] = 440234,
  [SMALL_STATE(12639)] = 440245,
  [SMALL_STATE(12640)] = 440256,
  [SMALL_STATE(12641)] = 440267,
  [SMALL_STATE(12642)] = 440278,
  [SMALL_STATE(12643)] = 440289,
  [SMALL_STATE(12644)] = 440300,
  [SMALL_STATE(12645)] = 440311,
  [SMALL_STATE(12646)] = 440322,
  [SMALL_STATE(12647)] = 440333,
  [SMALL_STATE(12648)] = 440344,
  [SMALL_STATE(12649)] = 440355,
  [SMALL_STATE(12650)] = 440366,
  [SMALL_STATE(12651)] = 440377,
  [SMALL_STATE(12652)] = 440388,
  [SMALL_STATE(12653)] = 440399,
  [SMALL_STATE(12654)] = 440410,
  [SMALL_STATE(12655)] = 440421,
  [SMALL_STATE(12656)] = 440432,
  [SMALL_STATE(12657)] = 440443,
  [SMALL_STATE(12658)] = 440454,
  [SMALL_STATE(12659)] = 440465,
  [SMALL_STATE(12660)] = 440476,
  [SMALL_STATE(12661)] = 440487,
  [SMALL_STATE(12662)] = 440498,
  [SMALL_STATE(12663)] = 440509,
  [SMALL_STATE(12664)] = 440520,
  [SMALL_STATE(12665)] = 440531,
  [SMALL_STATE(12666)] = 440542,
  [SMALL_STATE(12667)] = 440553,
  [SMALL_STATE(12668)] = 440564,
  [SMALL_STATE(12669)] = 440575,
  [SMALL_STATE(12670)] = 440586,
  [SMALL_STATE(12671)] = 440597,
  [SMALL_STATE(12672)] = 440608,
  [SMALL_STATE(12673)] = 440619,
  [SMALL_STATE(12674)] = 440630,
  [SMALL_STATE(12675)] = 440641,
  [SMALL_STATE(12676)] = 440652,
  [SMALL_STATE(12677)] = 440663,
  [SMALL_STATE(12678)] = 440674,
  [SMALL_STATE(12679)] = 440685,
  [SMALL_STATE(12680)] = 440696,
  [SMALL_STATE(12681)] = 440707,
  [SMALL_STATE(12682)] = 440718,
  [SMALL_STATE(12683)] = 440729,
  [SMALL_STATE(12684)] = 440740,
  [SMALL_STATE(12685)] = 440751,
  [SMALL_STATE(12686)] = 440762,
  [SMALL_STATE(12687)] = 440773,
  [SMALL_STATE(12688)] = 440784,
  [SMALL_STATE(12689)] = 440795,
  [SMALL_STATE(12690)] = 440806,
  [SMALL_STATE(12691)] = 440817,
  [SMALL_STATE(12692)] = 440828,
  [SMALL_STATE(12693)] = 440839,
  [SMALL_STATE(12694)] = 440850,
  [SMALL_STATE(12695)] = 440861,
  [SMALL_STATE(12696)] = 440872,
  [SMALL_STATE(12697)] = 440883,
  [SMALL_STATE(12698)] = 440894,
  [SMALL_STATE(12699)] = 440905,
  [SMALL_STATE(12700)] = 440916,
  [SMALL_STATE(12701)] = 440927,
  [SMALL_STATE(12702)] = 440938,
  [SMALL_STATE(12703)] = 440949,
  [SMALL_STATE(12704)] = 440960,
  [SMALL_STATE(12705)] = 440971,
  [SMALL_STATE(12706)] = 440982,
  [SMALL_STATE(12707)] = 440993,
  [SMALL_STATE(12708)] = 441004,
  [SMALL_STATE(12709)] = 441015,
  [SMALL_STATE(12710)] = 441026,
  [SMALL_STATE(12711)] = 441037,
  [SMALL_STATE(12712)] = 441048,
  [SMALL_STATE(12713)] = 441059,
  [SMALL_STATE(12714)] = 441070,
  [SMALL_STATE(12715)] = 441081,
  [SMALL_STATE(12716)] = 441092,
  [SMALL_STATE(12717)] = 441103,
  [SMALL_STATE(12718)] = 441114,
  [SMALL_STATE(12719)] = 441125,
  [SMALL_STATE(12720)] = 441136,
  [SMALL_STATE(12721)] = 441147,
  [SMALL_STATE(12722)] = 441158,
  [SMALL_STATE(12723)] = 441169,
  [SMALL_STATE(12724)] = 441180,
  [SMALL_STATE(12725)] = 441191,
  [SMALL_STATE(12726)] = 441202,
  [SMALL_STATE(12727)] = 441213,
  [SMALL_STATE(12728)] = 441224,
  [SMALL_STATE(12729)] = 441235,
  [SMALL_STATE(12730)] = 441246,
  [SMALL_STATE(12731)] = 441257,
  [SMALL_STATE(12732)] = 441268,
  [SMALL_STATE(12733)] = 441279,
  [SMALL_STATE(12734)] = 441290,
  [SMALL_STATE(12735)] = 441301,
  [SMALL_STATE(12736)] = 441312,
  [SMALL_STATE(12737)] = 441323,
  [SMALL_STATE(12738)] = 441334,
  [SMALL_STATE(12739)] = 441345,
  [SMALL_STATE(12740)] = 441356,
  [SMALL_STATE(12741)] = 441367,
  [SMALL_STATE(12742)] = 441378,
  [SMALL_STATE(12743)] = 441389,
  [SMALL_STATE(12744)] = 441400,
  [SMALL_STATE(12745)] = 441411,
  [SMALL_STATE(12746)] = 441422,
  [SMALL_STATE(12747)] = 441433,
  [SMALL_STATE(12748)] = 441444,
  [SMALL_STATE(12749)] = 441455,
  [SMALL_STATE(12750)] = 441466,
  [SMALL_STATE(12751)] = 441477,
  [SMALL_STATE(12752)] = 441488,
  [SMALL_STATE(12753)] = 441499,
  [SMALL_STATE(12754)] = 441510,
  [SMALL_STATE(12755)] = 441521,
  [SMALL_STATE(12756)] = 441532,
  [SMALL_STATE(12757)] = 441543,
  [SMALL_STATE(12758)] = 441554,
  [SMALL_STATE(12759)] = 441565,
  [SMALL_STATE(12760)] = 441576,
  [SMALL_STATE(12761)] = 441587,
  [SMALL_STATE(12762)] = 441598,
  [SMALL_STATE(12763)] = 441609,
  [SMALL_STATE(12764)] = 441620,
  [SMALL_STATE(12765)] = 441631,
  [SMALL_STATE(12766)] = 441642,
  [SMALL_STATE(12767)] = 441653,
  [SMALL_STATE(12768)] = 441664,
  [SMALL_STATE(12769)] = 441675,
  [SMALL_STATE(12770)] = 441686,
  [SMALL_STATE(12771)] = 441697,
  [SMALL_STATE(12772)] = 441708,
  [SMALL_STATE(12773)] = 441719,
  [SMALL_STATE(12774)] = 441730,
  [SMALL_STATE(12775)] = 441741,
  [SMALL_STATE(12776)] = 441752,
  [SMALL_STATE(12777)] = 441763,
  [SMALL_STATE(12778)] = 441774,
  [SMALL_STATE(12779)] = 441785,
  [SMALL_STATE(12780)] = 441796,
  [SMALL_STATE(12781)] = 441807,
  [SMALL_STATE(12782)] = 441818,
  [SMALL_STATE(12783)] = 441829,
  [SMALL_STATE(12784)] = 441840,
  [SMALL_STATE(12785)] = 441851,
  [SMALL_STATE(12786)] = 441862,
  [SMALL_STATE(12787)] = 441873,
  [SMALL_STATE(12788)] = 441884,
  [SMALL_STATE(12789)] = 441895,
  [SMALL_STATE(12790)] = 441906,
  [SMALL_STATE(12791)] = 441917,
  [SMALL_STATE(12792)] = 441928,
  [SMALL_STATE(12793)] = 441939,
  [SMALL_STATE(12794)] = 441950,
  [SMALL_STATE(12795)] = 441961,
  [SMALL_STATE(12796)] = 441972,
  [SMALL_STATE(12797)] = 441983,
  [SMALL_STATE(12798)] = 441994,
  [SMALL_STATE(12799)] = 442005,
  [SMALL_STATE(12800)] = 442016,
  [SMALL_STATE(12801)] = 442027,
  [SMALL_STATE(12802)] = 442038,
  [SMALL_STATE(12803)] = 442049,
  [SMALL_STATE(12804)] = 442060,
  [SMALL_STATE(12805)] = 442071,
  [SMALL_STATE(12806)] = 442082,
  [SMALL_STATE(12807)] = 442093,
  [SMALL_STATE(12808)] = 442104,
  [SMALL_STATE(12809)] = 442115,
  [SMALL_STATE(12810)] = 442126,
  [SMALL_STATE(12811)] = 442137,
  [SMALL_STATE(12812)] = 442148,
  [SMALL_STATE(12813)] = 442159,
  [SMALL_STATE(12814)] = 442170,
  [SMALL_STATE(12815)] = 442181,
  [SMALL_STATE(12816)] = 442192,
  [SMALL_STATE(12817)] = 442203,
  [SMALL_STATE(12818)] = 442214,
  [SMALL_STATE(12819)] = 442225,
  [SMALL_STATE(12820)] = 442236,
  [SMALL_STATE(12821)] = 442247,
  [SMALL_STATE(12822)] = 442258,
  [SMALL_STATE(12823)] = 442269,
  [SMALL_STATE(12824)] = 442280,
  [SMALL_STATE(12825)] = 442291,
  [SMALL_STATE(12826)] = 442302,
  [SMALL_STATE(12827)] = 442313,
  [SMALL_STATE(12828)] = 442324,
  [SMALL_STATE(12829)] = 442335,
  [SMALL_STATE(12830)] = 442346,
  [SMALL_STATE(12831)] = 442357,
  [SMALL_STATE(12832)] = 442368,
  [SMALL_STATE(12833)] = 442379,
  [SMALL_STATE(12834)] = 442390,
  [SMALL_STATE(12835)] = 442401,
  [SMALL_STATE(12836)] = 442412,
  [SMALL_STATE(12837)] = 442423,
  [SMALL_STATE(12838)] = 442434,
  [SMALL_STATE(12839)] = 442445,
  [SMALL_STATE(12840)] = 442456,
  [SMALL_STATE(12841)] = 442467,
  [SMALL_STATE(12842)] = 442478,
  [SMALL_STATE(12843)] = 442489,
  [SMALL_STATE(12844)] = 442500,
  [SMALL_STATE(12845)] = 442511,
  [SMALL_STATE(12846)] = 442522,
  [SMALL_STATE(12847)] = 442533,
  [SMALL_STATE(12848)] = 442544,
  [SMALL_STATE(12849)] = 442555,
  [SMALL_STATE(12850)] = 442566,
  [SMALL_STATE(12851)] = 442577,
  [SMALL_STATE(12852)] = 442588,
  [SMALL_STATE(12853)] = 442599,
  [SMALL_STATE(12854)] = 442610,
  [SMALL_STATE(12855)] = 442621,
  [SMALL_STATE(12856)] = 442632,
  [SMALL_STATE(12857)] = 442643,
  [SMALL_STATE(12858)] = 442654,
  [SMALL_STATE(12859)] = 442665,
  [SMALL_STATE(12860)] = 442676,
  [SMALL_STATE(12861)] = 442687,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_haskell, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10058),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2279),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9859),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6641),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8151),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7752),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7647),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10937),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1201),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2213),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9615),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7758),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9077),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7608),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11519),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7856),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8089),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8119),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11524),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12660),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3242),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3179),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3179),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3614),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2892),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5148),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12658),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12614),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12716),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12707),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11454),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12695),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12692),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12691),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12690),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4174),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12570),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9630),
  [99] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declarations, 2, 0, 0),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11876),
  [107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declarations, 3, 0, 0),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12192),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11705),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11691),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11345),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4650),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12538),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12276),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12190),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11702),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3263),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9931),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6708),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8141),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7724),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11121),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1198),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3690),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3716),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3716),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8959),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7727),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6617),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5069),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12541),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12702),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12188),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11536),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7643),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12356),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12257),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3392),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5742),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3158),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12370),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12799),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12656),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12587),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3439),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9923),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10394),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8145),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12770),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10923),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2917),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2851),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2851),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10897),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6679),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2980),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3403),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12474),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12726),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12261),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12444),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12771),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3159),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10106),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2604),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12776),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2423),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10653),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2548),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12365),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10623),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2483),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12731),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10820),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2454),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12618),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2575),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2580),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2980),
  [297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp, 1, 0, 0),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12676),
  [301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp, 1, 0, 0),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12720),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2735),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2735),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12564),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12672),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12328),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12118),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12689),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9878),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8128),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11537),
  [333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_infix, 4, 0, 245),
  [335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_infix, 4, 0, 245),
  [337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_apply, 2, 0, 69),
  [339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_apply, 2, 0, 69),
  [341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_infix, 3, 0, 142),
  [343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_infix, 3, 0, 142),
  [345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_negation, 2, 0, 53),
  [347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_negation, 2, 0, 53),
  [349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_infix, 4, 0, 247),
  [351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_infix, 4, 0, 247),
  [353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_infix, 4, 0, 246),
  [355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_infix, 4, 0, 246),
  [357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_infix, 5, 0, 365),
  [359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_infix, 5, 0, 365),
  [361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_infix, 5, 0, 366),
  [363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_infix, 5, 0, 366),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3165),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8923),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11272),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3537),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3589),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3589),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3059),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5216),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12810),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4337),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5005),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4121),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5356),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4851),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10025),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5162),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4625),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5620),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5679),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5511),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4894),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5491),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3028),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4190),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4659),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4675),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4218),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5355),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5408),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3025),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5384),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4845),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5506),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5509),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10037),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2943),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4491),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4601),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4231),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5116),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5604),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5601),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4214),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10035),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5597),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10027),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4956),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5593),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5114),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4488),
  [515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5322),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4765),
  [519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4920),
  [521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5111),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4729),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4757),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4869),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5108),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2989),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4466),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4455),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4549),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10024),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4181),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9771),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12746),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8162),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10943),
  [557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3741),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4181),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3527),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12762),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9978),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8122),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11426),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5508),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4467),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5510),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4918),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4489),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10041),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4763),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4208),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2990),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4228),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5113),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5406),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5596),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10029),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4664),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4895),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5599),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5361),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5115),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4846),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4602),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5849),
  [631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3162),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10658),
  [635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3505),
  [641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3627),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3627),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12803),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12732),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4812),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9881),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12728),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8170),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11233),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4067),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3974),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3974),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4812),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3852),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12756),
  [689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9865),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8112),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11440),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4785),
  [699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9818),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12714),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8153),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11297),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1730),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4193),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4139),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4139),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4785),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3859),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12744),
  [733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9724),
  [735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8115),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11406),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4578),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10006),
  [745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12721),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8140),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11068),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1257),
  [759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4148),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4066),
  [767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4066),
  [769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4578),
  [771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3862),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12750),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9986),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8129),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11821),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10406),
  [787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12572),
  [793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3143),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12232),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12719),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12562),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12349),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12784),
  [833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10626),
  [835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12433),
  [841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12573),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12765),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12767),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10823),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12245),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10108),
  [895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12487),
  [901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5069),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12705),
  [905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1747),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4282),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4246),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4246),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4153),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12738),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9979),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7940),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8107),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11873),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7949),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7933),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7929),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7903),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7921),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7923),
  [939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3152),
  [941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9134),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8144),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11261),
  [955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5388),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3098),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12758),
  [967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5505),
  [969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9888),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12740),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8163),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11094),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4597),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4643),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4643),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5505),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4296),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12768),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9800),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8117),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12146),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7015),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7015),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5388),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9770),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12734),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4690),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4617),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4617),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4292),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12764),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9738),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8126),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11642),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5148),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12319),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4366),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4369),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4369),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4281),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12806),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9786),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8124),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12121),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7887),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5586),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9950),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12752),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8156),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10985),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1331),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5084),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4978),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4978),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5586),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4310),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12766),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9868),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8131),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11832),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7895),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7908),
  [1117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_apply, 2, 0, 100),
  [1119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_apply, 2, 0, 100),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2327),
  [1123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified_type, 1, 0, 0),
  [1125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quantified_type, 1, 0, 0),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2331),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6439),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7709),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12266),
  [1139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2358),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [1145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9938),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8159),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12308),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12847),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12458),
  [1157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_infix, 3, 0, 142),
  [1159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_infix, 3, 0, 142),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3145),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8934),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3683),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3515),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3515),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12760),
  [1177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__at_type, 2, 0, 48),
  [1179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__at_type, 2, 0, 48),
  [1181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_infix, 3, 0, 188),
  [1183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_infix, 3, 0, 188),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9444),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3107),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12642),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12783),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3160),
  [1199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3503),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3503),
  [1207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12393),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12712),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12455),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12511),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [1221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12400),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12258),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12235),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12505),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12793),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12501),
  [1235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_top_splice, 1, 0, 0),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12495),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2480),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [1245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7529),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4454),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12320),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2451),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12323),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12318),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [1261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2453),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12312),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2615),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12467),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [1273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2452),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12310),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12262),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12496),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2449),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [1287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2464),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12640),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [1293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2495),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12504),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [1299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2562),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [1303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2545),
  [1305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2710),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2707),
  [1309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6360),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12819),
  [1319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_th_quoted_name, 2, 0, 48),
  [1321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_th_quoted_name, 2, 0, 48),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2796),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2837),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6336),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [1335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2813),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12860),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3123),
  [1345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3096),
  [1347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6378),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [1355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3121),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12857),
  [1363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3855),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10494),
  [1367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3897),
  [1369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8230),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6804),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3869),
  [1375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8285),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8285),
  [1379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12239),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12041),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3886),
  [1385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3911),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3911),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7507),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11200),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12300),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12816),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12730),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12724),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12717),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12711),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10458),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12782),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10590),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12333),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10332),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10501),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10865),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12592),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10336),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12290),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10712),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12403),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10401),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12742),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10733),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12414),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10609),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12387),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10575),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10341),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12291),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10561),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10677),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10538),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12307),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10827),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12497),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10686),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12397),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10614),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12364),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10023),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12535),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10351),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12292),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10364),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10769),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10512),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12305),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10425),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12616),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10190),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12606),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10632),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12376),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10328),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12289),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10513),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12749),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10789),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12430),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10322),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12286),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10476),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10849),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12539),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10380),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12295),
  [1525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10450),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12298),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10431),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12297),
  [1533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10325),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12287),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10665),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12391),
  [1541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10647),
  [1543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12384),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10727),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10568),
  [1549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10408),
  [1551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12296),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10859),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12552),
  [1557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10183),
  [1559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12427),
  [1561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10759),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12421),
  [1565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10775),
  [1567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12654),
  [1569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3364),
  [1571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3310),
  [1573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6400),
  [1575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3397),
  [1581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3268),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [1585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12852),
  [1589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3292),
  [1591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3413),
  [1593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6352),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3402),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [1599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3286),
  [1601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3238),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [1605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2944),
  [1607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12859),
  [1609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3383),
  [1611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3417),
  [1613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6192),
  [1615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [1617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [1619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3269),
  [1621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3199),
  [1623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12854),
  [1629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3219),
  [1631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3306),
  [1633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6540),
  [1635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [1637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [1639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [1641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3391),
  [1643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3391),
  [1645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2874),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12839),
  [1649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3582),
  [1651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3504),
  [1653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6403),
  [1655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3546),
  [1657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [1659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3435),
  [1661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3488),
  [1663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3488),
  [1665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [1667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12851),
  [1669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3638),
  [1671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3499),
  [1673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6335),
  [1675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [1677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3644),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3509),
  [1681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3554),
  [1683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3554),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [1687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12861),
  [1689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3687),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3698),
  [1693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3699),
  [1695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6411),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3774),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7709),
  [1701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3168),
  [1703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12850),
  [1705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6402),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3868),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8159),
  [1711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3975),
  [1713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4104),
  [1715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6553),
  [1717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4058),
  [1719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3964),
  [1721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3455),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12835),
  [1725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4075),
  [1727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4036),
  [1729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6304),
  [1731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4216),
  [1733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4074),
  [1735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [1737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12825),
  [1739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4123),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4032),
  [1743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4029),
  [1745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6312),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4157),
  [1749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [1751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12826),
  [1753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4279),
  [1755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4255),
  [1757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4257),
  [1759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6290),
  [1761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4266),
  [1763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3790),
  [1765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12823),
  [1767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4652),
  [1769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4321),
  [1771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6442),
  [1773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4371),
  [1775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4651),
  [1777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3927),
  [1779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12845),
  [1781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4314),
  [1783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4315),
  [1785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4317),
  [1787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6339),
  [1789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4347),
  [1791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [1793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12466),
  [1795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4373),
  [1797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4411),
  [1799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6441),
  [1801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4399),
  [1803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4372),
  [1805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3876),
  [1807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12846),
  [1809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4961),
  [1811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5049),
  [1813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6392),
  [1815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4969),
  [1817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4877),
  [1819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4879),
  [1821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4952),
  [1823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5100),
  [1825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5090),
  [1827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5090),
  [1829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3834),
  [1831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12827),
  [1833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5046),
  [1835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6381),
  [1837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4868),
  [1839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4039),
  [1841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12855),
  [1843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [1845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5496),
  [1847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5866),
  [1849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5830),
  [1851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6428),
  [1853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5837),
  [1855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5865),
  [1857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5845),
  [1859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5838),
  [1861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5838),
  [1863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5449),
  [1865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12848),
  [1867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5993),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5975),
  [1871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6501),
  [1873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6012),
  [1875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5988),
  [1877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5925),
  [1879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5910),
  [1881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5910),
  [1883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5602),
  [1885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12840),
  [1887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5958),
  [1889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5940),
  [1891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6524),
  [1893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5903),
  [1895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5959),
  [1897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6013),
  [1899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5905),
  [1901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5905),
  [1903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5635),
  [1905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12834),
  [1907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5942),
  [1909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6028),
  [1911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6560),
  [1913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6032),
  [1915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5941),
  [1917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5902),
  [1919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6050),
  [1921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6050),
  [1923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5627),
  [1925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12836),
  [1927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4254),
  [1929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [1931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7105),
  [1933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9609),
  [1935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7867),
  [1937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9336),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6125),
  [1941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6133),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6133),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8888),
  [1947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5824),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [1951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10087),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12811),
  [1955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6129),
  [1957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6077),
  [1959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6462),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6119),
  [1963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6130),
  [1965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5697),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6187),
  [1969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6543),
  [1971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6146),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6131),
  [1975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6132),
  [1977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6095),
  [1979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6128),
  [1981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6103),
  [1983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6103),
  [1985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5676),
  [1987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12838),
  [1989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6470),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10186),
  [1993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6559),
  [1995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8242),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6469),
  [1999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9718),
  [2001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6258),
  [2003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6226),
  [2005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6226),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9718),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11117),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5782),
  [2013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12670),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12817),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10730),
  [2019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9790),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9790),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12260),
  [2025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10783),
  [2027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6506),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6525),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5707),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10461),
  [2035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9836),
  [2037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9836),
  [2039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12593),
  [2041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6452),
  [2043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6340),
  [2045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6260),
  [2047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6313),
  [2049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6453),
  [2051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6547),
  [2053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6426),
  [2055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6426),
  [2057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5704),
  [2059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12820),
  [2061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6562),
  [2063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6365),
  [2065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10533),
  [2067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9747),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9747),
  [2071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12436),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [2075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [2077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [2079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [2081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12794),
  [2083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10469),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10683),
  [2087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9945),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9945),
  [2091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12682),
  [2093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10334),
  [2095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9996),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9996),
  [2099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12371),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [2103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [2107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12398),
  [2109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__datacon_prefix_repeat1, 1, 0, 249),
  [2111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__datacon_prefix_repeat1, 1, 0, 249),
  [2113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10508),
  [2115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9813),
  [2117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9813),
  [2119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12428),
  [2121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6510),
  [2123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6496),
  [2125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6446),
  [2127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6549),
  [2129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6509),
  [2131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6338),
  [2133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6388),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6388),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5763),
  [2139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12844),
  [2141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10710),
  [2143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9902),
  [2145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9902),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12725),
  [2149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10335),
  [2151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9837),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9837),
  [2155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6321),
  [2157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6445),
  [2159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6465),
  [2161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6410),
  [2163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6320),
  [2165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6269),
  [2167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6292),
  [2169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6292),
  [2171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5756),
  [2173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12841),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10492),
  [2177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9924),
  [2179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9924),
  [2181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12418),
  [2183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10731),
  [2185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10003),
  [2187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10003),
  [2189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12747),
  [2191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [2193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [2195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [2197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12493),
  [2199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [2201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [2203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [2205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [2207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [2211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12688),
  [2213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9991),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9991),
  [2217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10868),
  [2219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9873),
  [2221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9873),
  [2223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12355),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10340),
  [2227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9970),
  [2229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9970),
  [2231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12377),
  [2233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10324),
  [2235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9965),
  [2237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9965),
  [2239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12359),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10470),
  [2243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9966),
  [2245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9966),
  [2247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12513),
  [2249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10028),
  [2251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9842),
  [2253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9842),
  [2255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12598),
  [2257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10422),
  [2259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9810),
  [2261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9810),
  [2263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12508),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10586),
  [2267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9798),
  [2269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9798),
  [2271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12537),
  [2273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10448),
  [2275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10005),
  [2277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10005),
  [2279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12415),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [2283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12477),
  [2289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10295),
  [2291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10571),
  [2293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9753),
  [2295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9753),
  [2297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10427),
  [2299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9866),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9866),
  [2303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12407),
  [2305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6283),
  [2307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6214),
  [2309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6422),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6208),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6284),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6535),
  [2317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6488),
  [2319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6488),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5779),
  [2323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12849),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10559),
  [2327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9734),
  [2329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9734),
  [2331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12456),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10607),
  [2335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9895),
  [2337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9895),
  [2339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12405),
  [2341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10680),
  [2343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9768),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9768),
  [2347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12491),
  [2349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10752),
  [2351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9985),
  [2353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9985),
  [2355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12780),
  [2357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10398),
  [2359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9720),
  [2361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9720),
  [2363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12401),
  [2365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10327),
  [2367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9974),
  [2369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9974),
  [2371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12367),
  [2373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10516),
  [2375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9736),
  [2377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9736),
  [2379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12523),
  [2381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10188),
  [2383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9946),
  [2385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9946),
  [2387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12545),
  [2389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10661),
  [2391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9900),
  [2393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9900),
  [2395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12648),
  [2397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lazy_field, 2, 0, 48),
  [2399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lazy_field, 2, 0, 48),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [2403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [2405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [2407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10857),
  [2409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9875),
  [2411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9875),
  [2413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12434),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [2417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [2419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [2421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_strict_field, 2, 0, 48),
  [2423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_strict_field, 2, 0, 48),
  [2425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10778),
  [2427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9848),
  [2429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9848),
  [2431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12348),
  [2433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10825),
  [2435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9914),
  [2437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9914),
  [2439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12579),
  [2441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10573),
  [2443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9775),
  [2445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9775),
  [2447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10377),
  [2449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9784),
  [2451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9784),
  [2453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12395),
  [2455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10767),
  [2457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9973),
  [2459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9973),
  [2461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6364),
  [2463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6224),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6257),
  [2467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6231),
  [2469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6213),
  [2471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6213),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5738),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12824),
  [2477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10517),
  [2479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10644),
  [2481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9860),
  [2483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9860),
  [2485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12604),
  [2487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10630),
  [2489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9833),
  [2491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9833),
  [2493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12589),
  [2495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9719),
  [2497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9719),
  [2499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10359),
  [2501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9826),
  [2503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9826),
  [2505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10443),
  [2507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9781),
  [2509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9781),
  [2511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12620),
  [2513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10610),
  [2515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9812),
  [2517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9812),
  [2519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12549),
  [2521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10844),
  [2523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9904),
  [2525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9904),
  [2527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12512),
  [2529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10787),
  [2531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9957),
  [2533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9957),
  [2535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12797),
  [2537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10404),
  [2539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10000),
  [2541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10000),
  [2543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12696),
  [2545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [2547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [2549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [2551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10321),
  [2553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9964),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9964),
  [2557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12337),
  [2559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10345),
  [2561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9920),
  [2563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9920),
  [2565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12386),
  [2567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [2569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [2571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [2573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6689),
  [2575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6616),
  [2577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6502),
  [2579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6596),
  [2581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6690),
  [2583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6634),
  [2585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6577),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6577),
  [2589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5868),
  [2591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12832),
  [2593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7790),
  [2595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3151),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12460),
  [2599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 1, 0, 0),
  [2601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 1, 0, 0),
  [2603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7640),
  [2605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7640),
  [2607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6781),
  [2609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6726),
  [2611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6384),
  [2613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6841),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6778),
  [2617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6710),
  [2619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6757),
  [2621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6757),
  [2623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5909),
  [2625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12853),
  [2627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6765),
  [2629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6730),
  [2631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6555),
  [2633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6847),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6764),
  [2637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6754),
  [2639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6818),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6818),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5879),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12837),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12710),
  [2649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8273),
  [2651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11090),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5713),
  [2655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10296),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10481),
  [2659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12646),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7658),
  [2667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6263),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6999),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6986),
  [2673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6911),
  [2675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6925),
  [2677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6550),
  [2679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6948),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6912),
  [2683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6928),
  [2685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6886),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6886),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6148),
  [2691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12821),
  [2693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6919),
  [2695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6982),
  [2697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6377),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6963),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6913),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6980),
  [2705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6965),
  [2707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6965),
  [2709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6173),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12858),
  [2713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6176),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12306),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8152),
  [2719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat, 1, 0, 0),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9705),
  [2723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8079),
  [2725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8079),
  [2727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [2729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12673),
  [2731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10229),
  [2733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8399),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12137),
  [2737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8060),
  [2739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6987),
  [2741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7012),
  [2743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6887),
  [2745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6858),
  [2747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6858),
  [2749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6180),
  [2751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12822),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [2755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_tuple_elems, 2, 0, 153),
  [2757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7140),
  [2759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datacon_infix, 4, 0, 396),
  [2761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7168),
  [2763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6380),
  [2765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7195),
  [2767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7139),
  [2769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__datacon_infix, 4, 0, 396),
  [2771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7036),
  [2773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7022),
  [2775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7022),
  [2777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6297),
  [2779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12856),
  [2781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7020),
  [2783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7055),
  [2785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6457),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7127),
  [2789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7155),
  [2791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7159),
  [2793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7037),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7037),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6244),
  [2799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12830),
  [2801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6440),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12715),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9696),
  [2807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5934),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10616),
  [2813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8383),
  [2815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11556),
  [2817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12445),
  [2821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_as, 3, 0, 137),
  [2823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_as, 3, 0, 137),
  [2825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12677),
  [2827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5835),
  [2829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_infix, 3, 0, 142),
  [2831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9573),
  [2833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5721),
  [2835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5722),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5722),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9814),
  [2841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5093),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12807),
  [2845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10073),
  [2847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9542),
  [2849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12429),
  [2851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12664),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5310),
  [2855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5169),
  [2857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12772),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12597),
  [2861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12745),
  [2863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12693),
  [2865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12748),
  [2867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12612),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [2871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5454),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5471),
  [2875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12590),
  [2877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4742),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4363),
  [2881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12416),
  [2883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_tuple_elems_repeat2, 1, 0, 0),
  [2885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12574),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12480),
  [2889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5429),
  [2891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12353),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12551),
  [2895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12577),
  [2897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12542),
  [2899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_infix, 4, 0, 246),
  [2901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12514),
  [2903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_infix, 4, 0, 245),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5258),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [2909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8976),
  [2911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7532),
  [2913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7531),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [2917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10396),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12555),
  [2921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4305),
  [2923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7300),
  [2925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7219),
  [2927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6250),
  [2929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7399),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7297),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7361),
  [2935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7331),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7331),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6584),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12814),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12478),
  [2945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7269),
  [2947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7360),
  [2949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6454),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7294),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7285),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7206),
  [2957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7259),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7259),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6625),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12843),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4199),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12347),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12419),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4437),
  [2973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2950),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12360),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12521),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12459),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4145),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12527),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12437),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4011),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5290),
  [2991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12683),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12675),
  [2997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12409),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12402),
  [3001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_apply, 2, 0, 100),
  [3003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_apply, 2, 0, 100),
  [3005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_apply, 2, 0, 69),
  [3007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_apply, 2, 0, 69),
  [3009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_strict, 2, 0, 79),
  [3011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_strict, 2, 0, 79),
  [3013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_irrefutable, 2, 0, 79),
  [3015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_irrefutable, 2, 0, 79),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5334),
  [3019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12396),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4748),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12781),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12650),
  [3027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5519),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12388),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12379),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12375),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12369),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12798),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5629),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5018),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4858),
  [3045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_infix, 5, 0, 365),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12763),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5251),
  [3051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6461),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7403),
  [3055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7414),
  [3057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7415),
  [3059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7418),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7274),
  [3063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7216),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7216),
  [3067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6606),
  [3069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12818),
  [3071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4971),
  [3073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12341),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5588),
  [3077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12334),
  [3079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4564),
  [3081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4611),
  [3083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12432),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5000),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4668),
  [3089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_infix, 4, 0, 397),
  [3091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_infix, 4, 0, 397),
  [3093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12330),
  [3095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12264),
  [3097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_infix, 4, 0, 396),
  [3099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_infix, 4, 0, 396),
  [3101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12326),
  [3103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12324),
  [3105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4735),
  [3107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7491),
  [3109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7552),
  [3111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6217),
  [3113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7501),
  [3115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7523),
  [3117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7542),
  [3119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7525),
  [3121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7525),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6829),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12815),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9469),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10754),
  [3131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5311),
  [3133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5453),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4364),
  [3137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5428),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9380),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10453),
  [3143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9400),
  [3145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7769),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7769),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9223),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4999),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5257),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4609),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9531),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4438),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4143),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4970),
  [3167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9369),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5289),
  [3171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__newtype_con_field, 1, 0, 0),
  [3173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__newtype_con_field, 1, 0, 0),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4010),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9414),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9231),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4563),
  [3183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5636),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10709),
  [3187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5252),
  [3189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10565),
  [3191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5587),
  [3193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4862),
  [3195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2901),
  [3197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9238),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9191),
  [3201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12194),
  [3203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7555),
  [3205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7583),
  [3207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6405),
  [3209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7573),
  [3211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7571),
  [3213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7595),
  [3215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7574),
  [3217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7574),
  [3219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6862),
  [3221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12829),
  [3223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9573),
  [3225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [3227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_infix, 4, 0, 246),
  [3229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9553),
  [3231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_infix, 4, 0, 245),
  [3233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [3235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [3237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10193),
  [3239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_infix, 3, 0, 142),
  [3241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_infix, 5, 0, 365),
  [3243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_context, 1, 0, 45),
  [3245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_context, 1, 0, 45),
  [3247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7670),
  [3249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7648),
  [3251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6458),
  [3253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7661),
  [3255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7665),
  [3257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7653),
  [3259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7657),
  [3261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7657),
  [3263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7202),
  [3265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12831),
  [3267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3731),
  [3269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__operator_minus, 1, 0, 60),
  [3271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_forall, 2, 0, 93),
  [3273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_forall, 2, 0, 93),
  [3275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10717),
  [3277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_forall_required, 2, 0, 93),
  [3279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_forall_required, 2, 0, 93),
  [3281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10455),
  [3283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9550),
  [3285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10468),
  [3287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3907),
  [3289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10463),
  [3291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [3293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10679),
  [3295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3736),
  [3297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10285),
  [3299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8193),
  [3301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11022),
  [3303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5550),
  [3305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8244),
  [3307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11002),
  [3309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2899),
  [3311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8260),
  [3313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11017),
  [3315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6026),
  [3317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8195),
  [3319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10974),
  [3321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [3323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [3325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8182),
  [3327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10947),
  [3329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6150),
  [3331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3429),
  [3333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8190),
  [3335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10950),
  [3337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [3339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8179),
  [3341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11069),
  [3343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6155),
  [3345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3647),
  [3347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3650),
  [3349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8263),
  [3351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10986),
  [3353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5574),
  [3355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10978),
  [3357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8258),
  [3359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10965),
  [3361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [3363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7754),
  [3365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7750),
  [3367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6460),
  [3369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7740),
  [3371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7751),
  [3373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7762),
  [3375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7747),
  [3377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7747),
  [3379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7459),
  [3381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12842),
  [3383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8224),
  [3385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10953),
  [3387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [3389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7980),
  [3391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10871),
  [3393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7963),
  [3395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8739),
  [3397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7997),
  [3399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7977),
  [3401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7977),
  [3403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9691),
  [3405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11055),
  [3407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7862),
  [3409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12510),
  [3411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12394),
  [3413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12813),
  [3415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3863),
  [3417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [3419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8256),
  [3421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10942),
  [3423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3113),
  [3425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier, 2, 0, 0),
  [3427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8269),
  [3429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10980),
  [3431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5752),
  [3433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8233),
  [3435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11032),
  [3437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6228),
  [3439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8271),
  [3441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10962),
  [3443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2893),
  [3445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8223),
  [3447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10969),
  [3449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5764),
  [3451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3630),
  [3453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3520),
  [3455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8248),
  [3457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10956),
  [3459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6056),
  [3461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8259),
  [3463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10944),
  [3465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [3467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8235),
  [3469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10945),
  [3471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [3473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6788),
  [3475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12722),
  [3477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7040),
  [3479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9686),
  [3481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7199),
  [3483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7172),
  [3485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7172),
  [3487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6497),
  [3489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [3491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat, 1, 0, 0),
  [3493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12828),
  [3495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10830),
  [3497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9655),
  [3499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10808),
  [3501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12439),
  [3503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12492),
  [3505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6904),
  [3507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12706),
  [3509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7453),
  [3511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9667),
  [3513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7387),
  [3515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7402),
  [3517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7402),
  [3519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6677),
  [3521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12812),
  [3523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10354),
  [3525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9598),
  [3527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10464),
  [3529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12417),
  [3531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10286),
  [3533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9820),
  [3535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7169),
  [3537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [3539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10064),
  [3541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9663),
  [3543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datacon_prefix, 1, 0, 212),
  [3545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12685),
  [3547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8241),
  [3549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__datacon_prefix, 1, 0, 212),
  [3551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5702),
  [3553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 2, 0, 211),
  [3555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8199),
  [3557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7575),
  [3559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3153),
  [3561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5867),
  [3563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [3565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8883),
  [3567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12465),
  [3569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12697),
  [3571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [3573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [3575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9579),
  [3577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 3, 0, 326),
  [3579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 2, 0, 126),
  [3581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [3583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [3585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9666),
  [3587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_patterns_repeat1, 1, 0, 0),
  [3589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_patterns_repeat1, 1, 0, 0),
  [3591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [3593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [3595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9644),
  [3597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 1, 0, 39),
  [3599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9606),
  [3601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9629),
  [3603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9580),
  [3605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datacon_prefix, 1, 0, 2),
  [3607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__datacon_prefix, 1, 0, 2),
  [3609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9586),
  [3611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [3613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9575),
  [3615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9677),
  [3617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datacon_prefix, 2, 0, 340),
  [3619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__datacon_prefix, 2, 0, 340),
  [3621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9554),
  [3623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__datacon_prefix_repeat1, 2, 0, 377), SHIFT_REPEAT(6510),
  [3626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__datacon_prefix_repeat1, 2, 0, 377),
  [3628] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__datacon_prefix_repeat1, 2, 0, 377), SHIFT_REPEAT(6496),
  [3631] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__datacon_prefix_repeat1, 2, 0, 377), SHIFT_REPEAT(8241),
  [3634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__datacon_prefix_repeat1, 2, 0, 377), SHIFT_REPEAT(6509),
  [3637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__datacon_prefix_repeat1, 2, 0, 377),
  [3639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__datacon_prefix_repeat1, 2, 0, 377), SHIFT_REPEAT(12266),
  [3642] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__datacon_prefix_repeat1, 2, 0, 377), SHIFT_REPEAT(6338),
  [3645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__datacon_prefix_repeat1, 2, 0, 377), SHIFT_REPEAT(6388),
  [3648] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__datacon_prefix_repeat1, 2, 0, 377), SHIFT_REPEAT(6388),
  [3651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__datacon_prefix_repeat1, 2, 0, 377), SHIFT_REPEAT(5702),
  [3654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__datacon_prefix_repeat1, 2, 0, 377), SHIFT_REPEAT(12308),
  [3657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__datacon_prefix_repeat1, 2, 0, 377), SHIFT_REPEAT(12844),
  [3660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__datacon_prefix_repeat1, 2, 0, 377), SHIFT_REPEAT(11454),
  [3663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__datacon_prefix_repeat1, 2, 0, 377), SHIFT_REPEAT(12730),
  [3666] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__datacon_prefix_repeat1, 2, 0, 377), SHIFT_REPEAT(12724),
  [3669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__datacon_prefix_repeat1, 2, 0, 377), SHIFT_REPEAT(12717),
  [3672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__datacon_prefix_repeat1, 2, 0, 377), SHIFT_REPEAT(12711),
  [3675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9620),
  [3677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9569),
  [3679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9639),
  [3681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9625),
  [3683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9675),
  [3685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datacon_prefix, 2, 0, 330),
  [3687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__datacon_prefix, 2, 0, 330),
  [3689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_head_infix, 4, 0, 246),
  [3691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9667),
  [3693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_head_infix, 4, 0, 247),
  [3695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_head_infix, 3, 0, 142),
  [3697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_head_infix, 5, 0, 366),
  [3699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9638),
  [3701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9621),
  [3703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9676),
  [3705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9543),
  [3707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9636),
  [3709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9698),
  [3711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [3713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [3715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5281),
  [3717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [3719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [3721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4101),
  [3723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [3725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [3727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5276),
  [3729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [3731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [3733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5468),
  [3735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [3737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [3739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4593),
  [3741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [3743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [3745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4397),
  [3747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [3749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [3751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5646),
  [3753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [3755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [3757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [3759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [3761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [3763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4995),
  [3765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [3767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [3769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4777),
  [3771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7988),
  [3773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4471),
  [3775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4495),
  [3777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4682),
  [3779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5414),
  [3781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4616),
  [3783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3003),
  [3785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5149),
  [3787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4590),
  [3789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4749),
  [3791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [3793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [3795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5179),
  [3797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4581),
  [3799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4824),
  [3801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [3803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5396),
  [3805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4860),
  [3807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5399),
  [3809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4861),
  [3811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5184),
  [3813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5401),
  [3815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [3817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4830),
  [3819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4622),
  [3821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2971),
  [3823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4828),
  [3825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3955),
  [3827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4870),
  [3829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3950),
  [3831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4872),
  [3833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3948),
  [3835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5151),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [3839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5669),
  [3841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5416),
  [3843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5673),
  [3845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5350),
  [3847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4900),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4458),
  [3851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4460),
  [3853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4905),
  [3855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5160),
  [3857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4909),
  [3859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5198),
  [3861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4632),
  [3863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5193),
  [3865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5531),
  [3867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3938),
  [3869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4473),
  [3871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5524),
  [3873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4476),
  [3875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5647),
  [3877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5163),
  [3879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3936),
  [3881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5200),
  [3883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4924),
  [3885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5220),
  [3887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5167),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5628),
  [3891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5203),
  [3893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5152),
  [3895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3949),
  [3897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4620),
  [3899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4925),
  [3901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5221),
  [3903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5199),
  [3905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5164),
  [3907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3937),
  [3909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5658),
  [3911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4477),
  [3913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5580),
  [3915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4474),
  [3917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [3919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4472),
  [3921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4633),
  [3923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5525),
  [3925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5161),
  [3927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4910),
  [3929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3939),
  [3931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4906),
  [3933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3951),
  [3935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4461),
  [3937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4904),
  [3939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4459),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5194),
  [3943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5349),
  [3945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_patterns, 1, 0, 0),
  [3947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_patterns, 1, 0, 0),
  [3949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5654),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5670),
  [3953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4629),
  [3955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5201),
  [3957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5150),
  [3959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4496),
  [3961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4871),
  [3963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4873),
  [3965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [3967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2972),
  [3969] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(6904),
  [3972] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7453),
  [3975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0),
  [3977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(9667),
  [3980] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(12660),
  [3983] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7387),
  [3986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7402),
  [3989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7402),
  [3992] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(6677),
  [3995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(12658),
  [3998] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(12812),
  [4001] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(11454),
  [4004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(12689),
  [4007] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(12695),
  [4010] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(12692),
  [4013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(12691),
  [4016] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(12690),
  [4019] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(6689),
  [4022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0),
  [4024] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(6616),
  [4027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(8199),
  [4030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(6690),
  [4033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0),
  [4035] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(12266),
  [4038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(6634),
  [4041] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(6577),
  [4044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(6577),
  [4047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(5867),
  [4050] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(12308),
  [4053] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(12832),
  [4056] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(11454),
  [4059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(12689),
  [4062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6162),
  [4064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10884),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3956),
  [4072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4829),
  [4074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5415),
  [4076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5651),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4831),
  [4080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5185),
  [4082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3969),
  [4084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_patterns, 1, 0, 0),
  [4086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5400),
  [4088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [4090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4863),
  [4092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5398),
  [4094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5183),
  [4096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5410),
  [4098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4842),
  [4100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4809),
  [4102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4684),
  [4104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4582),
  [4106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4306),
  [4108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4591),
  [4110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [4112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5168),
  [4114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [4116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5413),
  [4118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5204),
  [4120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10268),
  [4122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [4124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [4126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5275),
  [4128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [4130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [4132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4108),
  [4134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [4136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [4138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5282),
  [4140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8254),
  [4142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9680),
  [4144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6895),
  [4146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [4148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [4150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [4152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5117),
  [4154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10385),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8069),
  [4158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [4162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4779),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [4168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4594),
  [4170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [4172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [4174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5640),
  [4176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10269),
  [4178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [4182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [4184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10261),
  [4186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [4188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [4190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4996),
  [4192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [4194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [4196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4393),
  [4198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [4200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4911),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5153),
  [4204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [4206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4644),
  [4208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4478),
  [4210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5224),
  [4212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4485),
  [4214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5346),
  [4216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4569),
  [4218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4570),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4499),
  [4222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [4224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5171),
  [4226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4634),
  [4228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5210),
  [4230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5176),
  [4232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5205),
  [4234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3662),
  [4236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3663),
  [4238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [4240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3972),
  [4242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5391),
  [4244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5611),
  [4246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4928),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5657),
  [4250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5667),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4914),
  [4254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4595),
  [4256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4283),
  [4258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4285),
  [4260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(5835),
  [4263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(5742),
  [4266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(9573),
  [4269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(5721),
  [4272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(5722),
  [4275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(5722),
  [4278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(5093),
  [4281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(12807),
  [4284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5215),
  [4286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5624),
  [4288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2539),
  [4290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2546),
  [4292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5394),
  [4294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4874),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3037),
  [4298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5186),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4687),
  [4302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3960),
  [4304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3857),
  [4306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3856),
  [4308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4835),
  [4310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3815),
  [4312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3818),
  [4314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4229),
  [4316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4230),
  [4318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [4320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4290),
  [4322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4289),
  [4324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4784),
  [4326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4778),
  [4328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4462),
  [4330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4798),
  [4332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3875),
  [4334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3871),
  [4336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4238),
  [4338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4239),
  [4340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5412),
  [4342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8197),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6299),
  [4346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8234),
  [4348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6675),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [4352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 3, 0, 328),
  [4354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8264),
  [4356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [4358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_deriving, 3, 0, 328),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6664),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5393),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5187),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5207),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4875),
  [4370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4912),
  [4372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 2, 0, 217),
  [4374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_deriving, 2, 0, 217),
  [4376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__instance, 3, 0, 94),
  [4378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8210),
  [4380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6743),
  [4382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__instance, 3, 0, 94),
  [4384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4638),
  [4386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__instance, 3, 0, 96),
  [4388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__instance, 3, 0, 96),
  [4390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__instance, 2, 0, 44),
  [4392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__instance, 2, 0, 44),
  [4394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5154),
  [4396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [4398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5172),
  [4400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5619),
  [4402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 3, 0, 342),
  [4404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_deriving, 3, 0, 342),
  [4406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 4, 0, 439),
  [4408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_deriving, 4, 0, 439),
  [4410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3958),
  [4412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4596),
  [4414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3941),
  [4416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5411),
  [4418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__instance, 4, 0, 184),
  [4420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__instance, 4, 0, 184),
  [4422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5661),
  [4424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4463),
  [4426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4483),
  [4428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4783),
  [4430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4836),
  [4432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [4434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12515),
  [4436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [4438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12479),
  [4440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7491),
  [4443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7552),
  [4446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(8210),
  [4449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7523),
  [4452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7542),
  [4455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7525),
  [4458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7525),
  [4461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(6743),
  [4464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(12815),
  [4467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [4469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12785),
  [4471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [4473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12575),
  [4475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [4477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8172),
  [4479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7181),
  [4481] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7555),
  [4484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7583),
  [4487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(8254),
  [4490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7571),
  [4493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7595),
  [4496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7574),
  [4499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7574),
  [4502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(6895),
  [4505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(12829),
  [4508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7670),
  [4511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7648),
  [4514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(8172),
  [4517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7665),
  [4520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7653),
  [4523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7657),
  [4526] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7657),
  [4529] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7181),
  [4532] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(12831),
  [4535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6196),
  [4537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7300),
  [4540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7219),
  [4543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(8234),
  [4546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7297),
  [4549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7361),
  [4552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7331),
  [4555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(7331),
  [4558] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(6675),
  [4561] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(12814),
  [4564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qtype_linear_function, 3, 0, 296),
  [4566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qtype_linear_function, 3, 0, 296),
  [4568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7882),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7882),
  [4572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7941),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9611),
  [4576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12399),
  [4578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qtype_forall, 3, 0, 292),
  [4580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qtype_forall, 3, 0, 292),
  [4582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_parameter, 3, 0, 136),
  [4584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_parameter, 3, 0, 136),
  [4586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qtype_forall_required, 3, 0, 292),
  [4588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qtype_forall_required, 3, 0, 292),
  [4590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qtype_function, 3, 0, 294),
  [4592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qtype_function, 3, 0, 294),
  [4594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qtype_context, 2, 0, 190),
  [4596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qtype_context, 2, 0, 190),
  [4598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraints, 1, 0, 0),
  [4600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_signature, 3, 0, 193),
  [4602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_signature, 3, 0, 193),
  [4604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, 0, 0),
  [4606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 0),
  [4608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12556),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12652),
  [4612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qualified_type, 2, 0, 72),
  [4614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qualified_type, 2, 0, 72),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12331),
  [4618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10044),
  [4620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10989),
  [4622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8154),
  [4624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qualified_constructor, 2, 0, 73),
  [4626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qualified_constructor, 2, 0, 73),
  [4628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__splice_exp, 1, 0, 3),
  [4630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__splice_exp, 1, 0, 3),
  [4632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__promoted_tycons_alias, 2, 0, 97),
  [4634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__promoted_tycons_alias, 2, 0, 97),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [4638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7881),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9641),
  [4642] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym_pattern, 1, -1000, 0), REDUCE(sym__function_name, 1, 0, 2),
  [4646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [4648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [4650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9850),
  [4652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym_pattern, 1, -1000, 0),
  [4655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, -1000, 0), REDUCE(sym__function_name, 1, 0, 2),
  [4658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12338),
  [4662] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym_pattern, 1, -1000, 0), REDUCE(sym__function_name, 1, 0, 2),
  [4666] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym_pattern, 1, -1000, 0),
  [4669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, -1000, 0), SHIFT(1444),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12358),
  [4674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12354),
  [4676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, -1000, 0), REDUCE(sym__function_name, 1, 0, 2),
  [4679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_promoted, 2, 0, 0),
  [4681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_promoted, 2, 0, 0),
  [4683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qvarsym_prefix, 3, 0, 156),
  [4685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qvarsym_prefix, 3, 0, 156),
  [4687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7788),
  [4689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__promoted_tycons_alias, 2, 0, 0),
  [4691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__promoted_tycons_alias, 2, 0, 0),
  [4693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__paren_close, 2, 0, 0),
  [4695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__paren_close, 2, 0, 0),
  [4697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_parens, 3, 0, 78),
  [4699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_parens, 3, 0, 78),
  [4701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_parens, 3, 0, 48),
  [4703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_parens, 3, 0, 48),
  [4705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qconsym_prefix, 3, 0, 156),
  [4707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qconsym_prefix, 3, 0, 156),
  [4709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__bracket_close, 2, 0, 0),
  [4711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bracket_close, 2, 0, 0),
  [4713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unit, 2, 0, 0),
  [4715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unit, 2, 0, 0),
  [4717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_list, 3, 0, 157),
  [4719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_list, 3, 0, 157),
  [4721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__plist, 2, 0, 0),
  [4723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__plist, 2, 0, 0),
  [4725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_list, 4, 0, 260),
  [4727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_list, 4, 0, 260),
  [4729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_unboxed_sum, 4, 0, 260),
  [4731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_unboxed_sum, 4, 0, 260),
  [4733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tycon_arrow, 3, 0, 177),
  [4735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tycon_arrow, 3, 0, 177),
  [4737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal, 1, 0, 0),
  [4739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal, 1, 0, 0),
  [4741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_unboxed_tuple, 3, 0, 157),
  [4743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_unboxed_tuple, 3, 0, 157),
  [4745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_star, 1, 0, 0),
  [4747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_star, 1, 0, 0),
  [4749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splice, 2, 0, 78),
  [4751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splice, 2, 0, 78),
  [4753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__splice_exp, 1, 0, 5),
  [4755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__splice_exp, 1, 0, 5),
  [4757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefix_unboxed_tuple, 3, 0, 0),
  [4759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefix_unboxed_tuple, 3, 0, 0),
  [4761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_tuple, 3, 0, 98),
  [4763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_tuple, 3, 0, 98),
  [4765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_unboxed_tuple, 4, 0, 260),
  [4767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_unboxed_tuple, 4, 0, 260),
  [4769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator, 1, 0, 0),
  [4771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator, 1, 0, 0),
  [4773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefix_tuple, 3, 0, 0),
  [4775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefix_tuple, 3, 0, 0),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12790),
  [4779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_wildcard, 1, 0, 0),
  [4781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_wildcard, 1, 0, 0),
  [4783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unboxed_close, 2, 0, 0),
  [4785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unboxed_close, 2, 0, 0),
  [4787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unboxed_unit, 2, 0, 0),
  [4789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unboxed_unit, 2, 0, 0),
  [4791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__varsym_prefix, 3, 0, 0),
  [4793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__varsym_prefix, 3, 0, 0),
  [4795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, 0, 46),
  [4797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 46),
  [4799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_promoted, 2, 0, 98),
  [4801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_promoted, 2, 0, 98),
  [4803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, 0, 6),
  [4805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 6),
  [4807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qualified_variable, 2, 0, 72),
  [4809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qualified_variable, 2, 0, 72),
  [4811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qtyconid, 1, 0, 32),
  [4813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qtyconid, 1, 0, 32),
  [4815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qtycon_arrow, 3, 0, 156),
  [4817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qtycon_arrow, 3, 0, 156),
  [4819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_apply, 2, 0, 99),
  [4821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_apply, 2, 0, 99),
  [4823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefix_unboxed_sum, 3, 0, 0),
  [4825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefix_unboxed_sum, 3, 0, 0),
  [4827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quasiquote, 5, 0, 275),
  [4829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quasiquote, 5, 0, 275),
  [4831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, 0, 49),
  [4833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 49),
  [4835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__consym_prefix, 3, 0, 0),
  [4837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__consym_prefix, 3, 0, 0),
  [4839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, 0, 22),
  [4841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 22),
  [4843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, 0, 47),
  [4845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 47),
  [4847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qconid, 1, 0, 32),
  [4849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qconid, 1, 0, 32),
  [4851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quasiquote, 6, 0, 393),
  [4853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quasiquote, 6, 0, 393),
  [4855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integer, 1, 0, 0),
  [4857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integer, 1, 0, 0),
  [4859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qvarid, 1, 0, 32),
  [4861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qvarid, 1, 0, 32),
  [4863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quantified_type, 1, 0, 101),
  [4865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified_type, 1, 0, 101),
  [4867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quantified_type, 1, 0, 102),
  [4869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified_type, 1, 0, 102),
  [4871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quantified_type, 1, 0, 103),
  [4873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified_type, 1, 0, 103),
  [4875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quantified_type, 1, 0, 104),
  [4877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified_type, 1, 0, 104),
  [4879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8257),
  [4881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3820),
  [4883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8175),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5645),
  [4887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8240),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3884),
  [4891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8243),
  [4893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5691),
  [4895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8253),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5748),
  [4899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8173),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3921),
  [4903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8189),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3686),
  [4907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8204),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4221),
  [4911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8267),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5685),
  [4915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8246),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3164),
  [4919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8217),
  [4921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6097),
  [4923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_th_quoted_name, 2, 0, 36),
  [4925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_th_quoted_name, 2, 0, 36),
  [4927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8255),
  [4929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [4931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8188),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3507),
  [4935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8186),
  [4937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3564),
  [4939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8232),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6580),
  [4943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 3),
  [4945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 3),
  [4947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8203),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3684),
  [4951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8219),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5467),
  [4955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_lambda_case, 2, 0, 0),
  [4957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_lambda_case, 2, 0, 0),
  [4959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [4961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8265),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3831),
  [4965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_lambda_cases, 2, 0, 0),
  [4967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_lambda_cases, 2, 0, 0),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [4971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8261),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7336),
  [4975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_case, 3, 0, 0),
  [4977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_case, 3, 0, 0),
  [4979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_let_in, 4, 0, 166),
  [4981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_let_in, 4, 0, 166),
  [4983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 8),
  [4985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 8),
  [4987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_let_in, 3, 0, 85),
  [4989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_let_in, 3, 0, 85),
  [4991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 14),
  [4993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 14),
  [4995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 15),
  [4997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 15),
  [4999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 16),
  [5001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 16),
  [5003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 17),
  [5005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 17),
  [5007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_projection_selector, 4, 0, 259),
  [5009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_projection_selector, 4, 0, 259),
  [5011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_list, 4, 0, 157),
  [5013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_list, 4, 0, 157),
  [5015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_arithmetic_sequence, 4, 0, 263),
  [5017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_arithmetic_sequence, 4, 0, 263),
  [5019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_list, 4, 0, 260),
  [5021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_list, 4, 0, 260),
  [5023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 18),
  [5025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 18),
  [5027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 19),
  [5029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 19),
  [5031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 20),
  [5033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 20),
  [5035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 21),
  [5037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 21),
  [5039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 22),
  [5041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 22),
  [5043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_list_comprehension, 4, 0, 264),
  [5045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_list_comprehension, 4, 0, 264),
  [5047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_type, 4, 0, 229),
  [5049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_type, 4, 0, 229),
  [5051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_unboxed_sum, 4, 0, 157),
  [5053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_unboxed_sum, 4, 0, 157),
  [5055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_unboxed_tuple, 4, 0, 260),
  [5057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_unboxed_tuple, 4, 0, 260),
  [5059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_lambda_case, 3, 0, 106),
  [5061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_lambda_case, 3, 0, 106),
  [5063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_lambda_cases, 3, 0, 107),
  [5065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_lambda_cases, 3, 0, 107),
  [5067] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 3), REDUCE(sym_pattern, 1, 0, 3),
  [5070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 3), REDUCE(sym_pattern, 1, 0, 3),
  [5073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 3),
  [5075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 3),
  [5077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_multi_way_if, 3, 0, 0),
  [5079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_multi_way_if, 3, 0, 0),
  [5081] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_unboxed_tuple, 4, 0, 266),
  [5083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_unboxed_tuple, 4, 0, 266),
  [5085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_unboxed_sum, 4, 0, 266),
  [5087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_unboxed_sum, 4, 0, 266),
  [5089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_quote, 5, 0, 274),
  [5091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_quote, 5, 0, 274),
  [5093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_quote, 5, 0, 275),
  [5095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_quote, 5, 0, 275),
  [5097] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_typed_quote, 5, 0, 0),
  [5099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_typed_quote, 5, 0, 0),
  [5101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_typed_quote, 5, 0, 274),
  [5103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_typed_quote, 5, 0, 274),
  [5105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 30),
  [5107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 30),
  [5109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_let_in, 5, 0, 279),
  [5111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_let_in, 5, 0, 279),
  [5113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 12),
  [5115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 12),
  [5117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alternatives, 3, 0, 298),
  [5119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alternatives, 3, 0, 298),
  [5121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_quote, 3, 0, 134),
  [5123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_quote, 3, 0, 134),
  [5125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__nalts, 3, 0, 300),
  [5127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__nalts, 3, 0, 300),
  [5129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_case, 4, 0, 194),
  [5131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_case, 4, 0, 194),
  [5133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_multi_way_if, 4, 0, 192),
  [5135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_multi_way_if, 4, 0, 192),
  [5137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_th_quoted_name, 2, 0, 35),
  [5139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_th_quoted_name, 2, 0, 35),
  [5141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statements, 5, 0, 458),
  [5143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements, 5, 0, 458),
  [5145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_name, 1, 0, 0),
  [5147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_name, 1, 0, 0),
  [5149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_projection, 3, 0, 143),
  [5151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_projection, 3, 0, 143),
  [5153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_lambda, 4, 0, 191),
  [5155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_lambda, 4, 0, 191),
  [5157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__nalts, 2, 0, 0),
  [5159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__nalts, 2, 0, 0),
  [5161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alternatives, 2, 0, 0),
  [5163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alternatives, 2, 0, 0),
  [5165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_tuple, 3, 0, 98),
  [5167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_tuple, 3, 0, 98),
  [5169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_list, 3, 0, 157),
  [5171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_list, 3, 0, 157),
  [5173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_unboxed_tuple, 3, 0, 157),
  [5175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_unboxed_tuple, 3, 0, 157),
  [5177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statements, 4, 0, 361),
  [5179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements, 4, 0, 361),
  [5181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statements, 4, 0, 244),
  [5183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements, 4, 0, 244),
  [5185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_apply, 2, 0, 68),
  [5187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_apply, 2, 0, 68),
  [5189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_do, 2, 0, 67),
  [5191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_do, 2, 0, 67),
  [5193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_quote, 4, 0, 0),
  [5195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_quote, 4, 0, 0),
  [5197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_typed_quote, 4, 0, 0),
  [5199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_typed_quote, 4, 0, 0),
  [5201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp, 1, 0, 51),
  [5203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp, 1, 0, 51),
  [5205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statements, 4, 0, 362),
  [5207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements, 4, 0, 362),
  [5209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statements, 3, 0, 244),
  [5211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements, 3, 0, 244),
  [5213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_let_in, 4, 0, 167),
  [5215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_let_in, 4, 0, 167),
  [5217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_conditional, 8, 0, 522),
  [5219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_conditional, 8, 0, 522),
  [5221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_quote, 2, 0, 0),
  [5223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_quote, 2, 0, 0),
  [5225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_record, 5, 0, 367),
  [5227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_record, 5, 0, 367),
  [5229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__nalts, 6, 0, 476),
  [5231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__nalts, 6, 0, 476),
  [5233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_section_left, 5, 0, 372),
  [5235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_section_left, 5, 0, 372),
  [5237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_section_left, 5, 0, 373),
  [5239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_section_left, 5, 0, 373),
  [5241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alternatives, 6, 0, 475),
  [5243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alternatives, 6, 0, 475),
  [5245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_projection_selector, 5, 0, 376),
  [5247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_projection_selector, 5, 0, 376),
  [5249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_arithmetic_sequence, 7, 0, 514),
  [5251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_arithmetic_sequence, 7, 0, 514),
  [5253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 4),
  [5255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 4),
  [5257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 5),
  [5259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 5),
  [5261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 6),
  [5263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 6),
  [5265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_record, 7, 0, 509),
  [5267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_record, 7, 0, 509),
  [5269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statements, 6, 0, 458),
  [5271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements, 6, 0, 458),
  [5273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_arithmetic_sequence, 5, 0, 380),
  [5275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_arithmetic_sequence, 5, 0, 380),
  [5277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 7),
  [5279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 7),
  [5281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statements, 2, 0, 0),
  [5283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements, 2, 0, 0),
  [5285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_conditional, 7, 0, 479),
  [5287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_conditional, 7, 0, 479),
  [5289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_list, 5, 0, 260),
  [5291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_list, 5, 0, 260),
  [5293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_unboxed_sum, 5, 0, 157),
  [5295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_unboxed_sum, 5, 0, 157),
  [5297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_unboxed_tuple, 5, 0, 381),
  [5299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_unboxed_tuple, 5, 0, 381),
  [5301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_conditional, 7, 0, 478),
  [5303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_conditional, 7, 0, 478),
  [5305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__nalts, 5, 0, 476),
  [5307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__nalts, 5, 0, 476),
  [5309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__nalts, 5, 0, 404),
  [5311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__nalts, 5, 0, 404),
  [5313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__nalts, 5, 0, 405),
  [5315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__nalts, 5, 0, 405),
  [5317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_unboxed_sum, 5, 0, 266),
  [5319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_unboxed_sum, 5, 0, 266),
  [5321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 9),
  [5323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 9),
  [5325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alternatives, 5, 0, 401),
  [5327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alternatives, 5, 0, 401),
  [5329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alternatives, 5, 0, 475),
  [5331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alternatives, 5, 0, 475),
  [5333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alternatives, 5, 0, 400),
  [5335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alternatives, 5, 0, 400),
  [5337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 10),
  [5339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 10),
  [5341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_arithmetic_sequence, 6, 0, 469),
  [5343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_arithmetic_sequence, 6, 0, 469),
  [5345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_quote, 6, 0, 389),
  [5347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_quote, 6, 0, 389),
  [5349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 31),
  [5351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 31),
  [5353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_typed_quote, 6, 0, 390),
  [5355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_typed_quote, 6, 0, 390),
  [5357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_record, 6, 0, 459),
  [5359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_record, 6, 0, 459),
  [5361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statements, 5, 0, 362),
  [5363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements, 5, 0, 362),
  [5365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_quote, 6, 0, 391),
  [5367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_quote, 6, 0, 391),
  [5369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statements, 5, 0, 361),
  [5371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements, 5, 0, 361),
  [5373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_conditional, 6, 0, 407),
  [5375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_conditional, 6, 0, 407),
  [5377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__nalts, 4, 0, 404),
  [5379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__nalts, 4, 0, 404),
  [5381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__nalts, 4, 0, 405),
  [5383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__nalts, 4, 0, 405),
  [5385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__nalts, 4, 0, 300),
  [5387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__nalts, 4, 0, 300),
  [5389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 11),
  [5391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 11),
  [5393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alternatives, 4, 0, 401),
  [5395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alternatives, 4, 0, 401),
  [5397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alternatives, 4, 0, 298),
  [5399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alternatives, 4, 0, 298),
  [5401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alternatives, 4, 0, 400),
  [5403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alternatives, 4, 0, 400),
  [5405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_quote, 6, 0, 392),
  [5407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_quote, 6, 0, 392),
  [5409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_section_right, 4, 0, 258),
  [5411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_section_right, 4, 0, 258),
  [5413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 13),
  [5415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 13),
  [5417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_quote, 6, 0, 275),
  [5419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_quote, 6, 0, 275),
  [5421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, -1000, 0),
  [5423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, -1000, 0),
  [5425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7931),
  [5427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7886),
  [5429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8723),
  [5431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8388),
  [5433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7893),
  [5435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7938),
  [5437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7938),
  [5439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7715),
  [5441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12833),
  [5443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [5445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym_pattern, 1, 0, 0),
  [5448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym_pattern, 1, 0, 0),
  [5451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 0),
  [5453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 0),
  [5455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 31), REDUCE(sym_pattern, 1, 0, 31),
  [5458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 31), REDUCE(sym_pattern, 1, 0, 31),
  [5461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 31),
  [5463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 31),
  [5465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12453),
  [5467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12454),
  [5469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_negation, 2, 0, 52),
  [5471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_negation, 2, 0, 52),
  [5473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [5475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [5477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [5479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [5481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [5483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_imports, 3, 0, 146),
  [5485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_imports, 3, 0, 146),
  [5487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [5489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [5491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_imports, 2, 0, 74),
  [5493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_imports, 2, 0, 74),
  [5495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [5497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [5499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__let_binds_repeat1, 2, 0, 0),
  [5501] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__let_binds_repeat1, 2, 0, 0), SHIFT_REPEAT(4174),
  [5504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__let_binds_repeat1, 2, 0, 0),
  [5506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [5508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [5510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [5512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [5514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [5516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [5518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [5520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [5522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [5524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__let_binds_repeat1, 2, 0, 0), SHIFT_REPEAT(4650),
  [5527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8690),
  [5529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8712),
  [5531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12703),
  [5533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10897),
  [5535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8988),
  [5537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12280),
  [5539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12636),
  [5541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12532),
  [5543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12569),
  [5545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12735),
  [5547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12777),
  [5549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12568),
  [5551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12809),
  [5553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 3, 0, 327),
  [5555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 4, 0, 432),
  [5557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__let_binds_repeat1, 2, 0, 0), SHIFT_REPEAT(5679),
  [5560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 2, 0, 59),
  [5562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 3, 0, 322),
  [5564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_unboxed_sum, 5, 0, 157),
  [5566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_unboxed_sum, 5, 0, 157),
  [5568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_list, 3, 0, 157),
  [5570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_list, 3, 0, 157),
  [5572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_unboxed_tuple, 3, 0, 157),
  [5574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_unboxed_tuple, 3, 0, 157),
  [5576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_list, 4, 0, 157),
  [5578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_list, 4, 0, 157),
  [5580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_unboxed_sum, 4, 0, 157),
  [5582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_unboxed_sum, 4, 0, 157),
  [5584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_unboxed_tuple, 4, 0, 260),
  [5586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_unboxed_tuple, 4, 0, 260),
  [5588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_unboxed_sum, 4, 0, 266),
  [5590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_unboxed_sum, 4, 0, 266),
  [5592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_list, 4, 0, 260),
  [5594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_list, 4, 0, 260),
  [5596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_list, 5, 0, 260),
  [5598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_list, 5, 0, 260),
  [5600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_unboxed_sum, 5, 0, 266),
  [5602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_unboxed_sum, 5, 0, 266),
  [5604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_parens, 3, 0, 79),
  [5606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_parens, 3, 0, 79),
  [5608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_record, 6, 0, 463),
  [5610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_record, 6, 0, 463),
  [5612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_tuple, 3, 0, 98),
  [5614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_tuple, 3, 0, 98),
  [5616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_record, 7, 0, 510),
  [5618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_record, 7, 0, 510),
  [5620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_record, 5, 0, 216),
  [5622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_record, 5, 0, 216),
  [5624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_wildcard, 1, 0, 0),
  [5626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_wildcard, 1, 0, 0),
  [5628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 6),
  [5630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 6),
  [5632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_apply, 2, 0, 70),
  [5634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_apply, 2, 0, 70),
  [5636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 7),
  [5638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 7),
  [5640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__paren_open, 2, 0, 0),
  [5642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__paren_open, 2, 0, 0),
  [5644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 24),
  [5646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 24),
  [5648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 25),
  [5650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 25),
  [5652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 23),
  [5654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 23),
  [5656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 18),
  [5658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 18),
  [5660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 26),
  [5662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 26),
  [5664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 22),
  [5666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 22),
  [5668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__let_binds_repeat1, 2, 0, 0), SHIFT_REPEAT(5849),
  [5671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7917),
  [5673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12733),
  [5675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [5677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [5679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [5681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [5683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [5685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2978),
  [5687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12284),
  [5689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9748),
  [5691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [5693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6823),
  [5695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6598),
  [5697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5703),
  [5699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6181),
  [5701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3787),
  [5703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [5705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3473),
  [5707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3053),
  [5709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [5711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [5713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2915),
  [5715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [5717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6165),
  [5719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [5721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6298),
  [5723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4028),
  [5725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5878),
  [5727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3839),
  [5729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [5731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [5733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [5735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6865),
  [5737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [5739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5801),
  [5741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5446),
  [5743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [5745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3882),
  [5747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [5749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5771),
  [5751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6630),
  [5753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6246),
  [5755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7201),
  [5757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7472),
  [5759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6608),
  [5761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5684),
  [5763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5762),
  [5765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5592),
  [5767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5863),
  [5769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5701),
  [5771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5626),
  [5773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [5775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5690),
  [5777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6172),
  [5779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [5781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5980),
  [5783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5622),
  [5785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5749),
  [5787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__operator_hash_head, 1, 0, 0), REDUCE(sym__unboxed_open, 2, 0, 80),
  [5790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unboxed_open, 2, 0, 80),
  [5792] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unboxed_open, 2, 0, 80),
  [5794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__operator_hash_head, 1, 0, 0), REDUCE(sym__unboxed_open, 2, 0, 80),
  [5797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7674),
  [5799] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__unboxed_open, 2, 0, 80), SHIFT(7674),
  [5802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__operator_hash_head, 1, 0, 0),
  [5804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12769),
  [5806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__unboxed_open, 2, 0, 80), SHIFT(12769),
  [5809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7599),
  [5811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11089),
  [5813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8019),
  [5815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7786),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10384),
  [5819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [5821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__exp_unboxed_sum_repeat1, 2, 0, 0),
  [5823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_unboxed_sum_repeat1, 2, 0, 0),
  [5825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__exp_unboxed_sum_repeat1, 2, 0, 0), SHIFT_REPEAT(7015),
  [5828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_unboxed_sum_repeat1, 2, 0, 0), SHIFT_REPEAT(7015),
  [5831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_instance_head_params, 1, 0, 2),
  [5833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_instance_head_params, 1, 0, 2),
  [5835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8933),
  [5837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10442),
  [5839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10596),
  [5841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9506),
  [5843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7989),
  [5845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8773),
  [5847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8090),
  [5849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10414),
  [5851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [5853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10410),
  [5855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10279),
  [5857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10272),
  [5859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7225),
  [5861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6684),
  [5863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6914),
  [5865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6075),
  [5867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6975),
  [5869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6111),
  [5871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [5873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [5875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6160),
  [5877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5696),
  [5879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4396),
  [5881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3872),
  [5883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3281),
  [5885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [5887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3432),
  [5889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [5891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7990),
  [5893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7737),
  [5895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6358),
  [5897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5805),
  [5899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4604),
  [5901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3865),
  [5903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6611),
  [5905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5873),
  [5907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7265),
  [5909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6597),
  [5911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5819),
  [5913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5128),
  [5915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6170),
  [5917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5695),
  [5919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5102),
  [5921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3931),
  [5923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3421),
  [5925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3062),
  [5927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3652),
  [5929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [5931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5769),
  [5933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5011),
  [5935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6777),
  [5937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5995),
  [5939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7789),
  [5941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7380),
  [5943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7704),
  [5945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7039),
  [5947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6221),
  [5949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5807),
  [5951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4294),
  [5953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3689),
  [5955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6539),
  [5957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5716),
  [5959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3733),
  [5961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3169),
  [5963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2778),
  [5965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [5967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3660),
  [5969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [5971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4122),
  [5973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [5975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7540),
  [5977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6779),
  [5979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6018),
  [5981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5575),
  [5983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5919),
  [5985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5666),
  [5987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3447),
  [5989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3056),
  [5991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7956),
  [5993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7708),
  [5995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [5997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [5999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6878),
  [6001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6082),
  [6003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6251),
  [6005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5735),
  [6007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [6009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [6011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4662),
  [6013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3878),
  [6015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4180),
  [6017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [6019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [6021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [6023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [6025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [6027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6272),
  [6029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5804),
  [6031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [6033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [6035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6508),
  [6037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5811),
  [6039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7192),
  [6041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6271),
  [6043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3744),
  [6045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [6047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7033),
  [6049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6434),
  [6051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5070),
  [6053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4079),
  [6055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7123),
  [6057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6397),
  [6059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6712),
  [6061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5960),
  [6063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [6065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2932),
  [6067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6033),
  [6069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5618),
  [6071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7442),
  [6073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6589),
  [6075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [6077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [6079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3261),
  [6081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2961),
  [6083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4040),
  [6085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3430),
  [6087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7568),
  [6089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6915),
  [6091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3848),
  [6093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [6095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7365),
  [6097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6674),
  [6099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10413),
  [6101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10276),
  [6103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__instance, 4, 0, 185),
  [6105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__instance, 4, 0, 185),
  [6107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__instance, 4, 0, 182),
  [6109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__instance, 4, 0, 182),
  [6111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10287),
  [6113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10281),
  [6115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10444),
  [6117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10603),
  [6119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7558),
  [6121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7054),
  [6123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3885),
  [6125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [6127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7557),
  [6129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7842),
  [6131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [6133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__instance, 3, 0, 91),
  [6135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__instance, 3, 0, 91),
  [6137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__bracket_open, 2, 0, 0),
  [6139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bracket_open, 2, 0, 0),
  [6141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__instance, 5, 0, 290),
  [6143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__instance, 5, 0, 290),
  [6145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [6147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [6149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3804),
  [6151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [6153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9499),
  [6155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arrow, 1, 0, 0),
  [6157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow, 1, 0, 0),
  [6159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [6161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [6163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7605),
  [6165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7960),
  [6167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8382),
  [6169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3817),
  [6171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [6173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [6175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__exp_unboxed_sum_repeat1, 2, 0, 0), SHIFT_REPEAT(7640),
  [6178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_unboxed_sum_repeat1, 2, 0, 0), SHIFT_REPEAT(7640),
  [6181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_patterns_repeat1, 1, 0, 46),
  [6183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_patterns_repeat1, 1, 0, 46),
  [6185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_operator, 1, 0, 0),
  [6187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_operator, 1, 0, 0),
  [6189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7749),
  [6191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [6193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_instance_head_parens, 3, 0, 44),
  [6195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_instance_head_parens, 3, 0, 44),
  [6197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__exp_tuple_elems_repeat1, 2, 0, 0),
  [6199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_tuple_elems_repeat1, 2, 0, 0), SHIFT_REPEAT(7658),
  [6202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_tuple_elems_repeat1, 2, 0, 0),
  [6204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_instance_head_parens, 4, 0, 91),
  [6206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_instance_head_parens, 4, 0, 91),
  [6208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_instance_head_parens, 4, 0, 95),
  [6210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_instance_head_parens, 4, 0, 95),
  [6212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__operator_hash_head, 2, 0, 0),
  [6214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__operator_hash_head, 2, 0, 0),
  [6216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator, 2, 0, 0),
  [6218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator, 2, 0, 0),
  [6220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_instance_head_parens, 5, 0, 174),
  [6222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_instance_head_parens, 5, 0, 174),
  [6224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_instance_head_params, 1, 0, 43),
  [6226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_instance_head_params, 1, 0, 43),
  [6228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_instance_head_parens, 6, 0, 474),
  [6230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_instance_head_parens, 6, 0, 474),
  [6232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_instance_head_parens, 6, 0, 287),
  [6234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_instance_head_parens, 6, 0, 287),
  [6236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qualified_consym, 2, 0, 72),
  [6238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qualified_consym, 2, 0, 72),
  [6240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8358),
  [6242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 2, 0, 126),
  [6244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8357),
  [6246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12588),
  [6248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qualified_varsym, 2, 0, 72),
  [6250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qualified_varsym, 2, 0, 72),
  [6252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7873),
  [6254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [6256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__operator_minus, 1, 0, 60),
  [6258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 1, 0, 0),
  [6260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 1, 0, 0),
  [6262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 1, 0, 39),
  [6264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__operator_hash_head, 1, 0, 0),
  [6266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7674),
  [6268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9984),
  [6270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11860),
  [6272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11006),
  [6274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10816),
  [6276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8874),
  [6278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12701),
  [6280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12759),
  [6282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7777),
  [6284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7915),
  [6286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8299),
  [6288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7771),
  [6290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7570),
  [6292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8881),
  [6294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__exp_unboxed_sum_repeat1, 2, 0, 0), SHIFT_REPEAT(7769),
  [6297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_unboxed_sum_repeat1, 2, 0, 0), SHIFT_REPEAT(7769),
  [6300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ops, 1, 0, 32),
  [6302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ops, 1, 0, 32),
  [6304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ops, 1, 0, 0),
  [6306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ops, 1, 0, 0),
  [6308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8623),
  [6310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11881),
  [6312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7909),
  [6314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10048),
  [6316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10066),
  [6318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9956),
  [6320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9695),
  [6322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9695),
  [6324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10078),
  [6326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [6328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ktype_param, 1, 0, 38),
  [6330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12757),
  [6332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10047),
  [6334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11442),
  [6336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12509),
  [6338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [6340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__operator_qual_dot_head, 2, 0, 0),
  [6342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__operator_qual_dot_head, 2, 0, 0),
  [6344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__dotdot, 2, 0, 0),
  [6346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dotdot, 2, 0, 0),
  [6348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10297),
  [6350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9751),
  [6352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10292),
  [6354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9627),
  [6356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12686),
  [6358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__context_inline, 3, 0, 178),
  [6360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__context_inline, 3, 0, 178),
  [6362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12239),
  [6364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9098),
  [6366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11874),
  [6368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_apply, 2, 0, 99),
  [6370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_apply, 2, 0, 99),
  [6372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__linear_fun_arrow, 2, 0, 295),
  [6374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__linear_fun_arrow, 2, 0, 295),
  [6376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__prefix_dot, 2, 0, 0),
  [6378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__prefix_dot, 2, 0, 0),
  [6380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_ticked, 3, 0, 0),
  [6382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_ticked, 3, 0, 0),
  [6384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__constructor_ticked, 3, 0, 97),
  [6386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_ticked, 3, 0, 97),
  [6388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8572),
  [6390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ctr_tuple, 4, 0, 0),
  [6392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ctr_tuple, 4, 0, 0),
  [6394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__linear_fun_arrow, 2, 0, 293),
  [6396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__linear_fun_arrow, 2, 0, 293),
  [6398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 1, 0, 22),
  [6400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 1, 0, 22),
  [6402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_op, 1, 0, 60),
  [6404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_op, 1, 0, 60),
  [6406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 1, 0, 47),
  [6408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 1, 0, 47),
  [6410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qconstructor_ticked, 3, 0, 0),
  [6412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qconstructor_ticked, 3, 0, 0),
  [6414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fun_arrow, 2, 0, 293),
  [6416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fun_arrow, 2, 0, 293),
  [6418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qvariable_ticked, 3, 0, 0),
  [6420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qvariable_ticked, 3, 0, 0),
  [6422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__linear_fun_arrow, 1, 0, 189),
  [6424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__linear_fun_arrow, 1, 0, 189),
  [6426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ctr_parens, 3, 0, 0),
  [6428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ctr_parens, 3, 0, 0),
  [6430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fun_arrow, 1, 0, 189),
  [6432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fun_arrow, 1, 0, 189),
  [6434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_patterns_repeat1, 1, 0, 50),
  [6436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_patterns_repeat1, 1, 0, 50),
  [6438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8564),
  [6440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam, 1, 0, 39),
  [6442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8563),
  [6444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [6446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [6448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tyfam, 1, 0, 39),
  [6450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11457),
  [6452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11479),
  [6454] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__let_binds_repeat1, 2, 0, 0), SHIFT_REPEAT(7988),
  [6457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2616),
  [6459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [6461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [6463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [6465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8685),
  [6467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 96),
  [6469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8683),
  [6471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11316),
  [6473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9418),
  [6475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12273),
  [6477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12666),
  [6479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, 0, 44),
  [6481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9165),
  [6483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_params_repeat1, 2, 0, 0), SHIFT_REPEAT(8358),
  [6486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_params_repeat1, 2, 0, 0),
  [6488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_params_repeat1, 2, 0, 0), SHIFT_REPEAT(8357),
  [6491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_params_repeat1, 2, 0, 0),
  [6493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_params_repeat1, 2, 0, 0), SHIFT_REPEAT(12588),
  [6496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_params_repeat1, 2, 0, 0), SHIFT_REPEAT(12532),
  [6499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_params, 1, 0, 0),
  [6501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_params, 1, 0, 0),
  [6503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__let_binds_repeat1, 2, 0, 0), SHIFT_REPEAT(8069),
  [6506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8146),
  [6508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_head_parens, 3, 0, 155),
  [6510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_head_parens, 3, 0, 155),
  [6512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_head_parens, 4, 0, 95),
  [6514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_head_parens, 4, 0, 95),
  [6516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8902),
  [6518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8903),
  [6520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_head_parens, 4, 0, 257),
  [6522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_head_parens, 4, 0, 257),
  [6524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9955),
  [6526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9660),
  [6528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9106),
  [6530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9106),
  [6532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12042),
  [6534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9331),
  [6536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9331),
  [6538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12390),
  [6540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9951),
  [6542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8761),
  [6544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_tyfam, 2, 0, 44),
  [6546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8742),
  [6548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [6550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [6552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_head_parens, 3, 0, 59),
  [6554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_head_parens, 3, 0, 59),
  [6556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data_rhs, 2, 0, 221),
  [6558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8863),
  [6560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_head_parens, 3, 0, 44),
  [6562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_head_parens, 3, 0, 44),
  [6564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_tyfam, 3, 0, 507),
  [6566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [6568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_signature, 3, 0, 144),
  [6570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [6572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ktype, 1, 0, 0),
  [6574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [6576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7727),
  [6578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9854),
  [6580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11746),
  [6582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [6584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [6586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [6588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9832),
  [6590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11408),
  [6592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9828),
  [6594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11568),
  [6596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [6598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9847),
  [6600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11972),
  [6602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9797),
  [6604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10009),
  [6606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11357),
  [6608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [6610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9839),
  [6612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11664),
  [6614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [6616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9733),
  [6618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11768),
  [6620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_family_result, 2, 0, 280),
  [6622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9773),
  [6624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11740),
  [6626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9943),
  [6628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11506),
  [6630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [6632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9825),
  [6634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12004),
  [6636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_params_repeat1, 2, 0, 0), SHIFT_REPEAT(8564),
  [6639] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_params_repeat1, 2, 0, 0), SHIFT_REPEAT(8563),
  [6642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__prefix_tilde, 2, 0, 0),
  [6644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__prefix_tilde, 2, 0, 0),
  [6646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tight_at, 2, 0, 0),
  [6648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tight_at, 2, 0, 0),
  [6650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4441),
  [6652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3915),
  [6654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5026),
  [6656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4206),
  [6658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ktype, 1, 0, 0),
  [6660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [6662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5360),
  [6664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4277),
  [6666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [6668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [6670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9750),
  [6672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8943),
  [6674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datafam, 1, 0, 39),
  [6676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [6678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5145),
  [6680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4270),
  [6682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4822),
  [6684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3890),
  [6686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5536),
  [6688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4547),
  [6690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [6692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tight_bang, 2, 0, 0),
  [6694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tight_bang, 2, 0, 0),
  [6696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__prefix_bang, 2, 0, 0),
  [6698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__prefix_bang, 2, 0, 0),
  [6700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4063),
  [6702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3671),
  [6704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5473),
  [6706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4300),
  [6708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9840),
  [6710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9840),
  [6712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tight_tilde, 2, 0, 0),
  [6714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tight_tilde, 2, 0, 0),
  [6716] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_params_repeat1, 2, 0, 0), SHIFT_REPEAT(8685),
  [6719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_params_repeat1, 2, 0, 0), SHIFT_REPEAT(8683),
  [6722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4706),
  [6724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3883),
  [6726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7118),
  [6728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3924),
  [6730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5517),
  [6732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6094),
  [6734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4269),
  [6736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12149),
  [6738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3735),
  [6740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6149),
  [6742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam, 3, 0, 282),
  [6744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3667),
  [6746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3616),
  [6748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [6750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [6752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5633),
  [6754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [6756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6359),
  [6758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5817),
  [6760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_params_repeat1, 2, 0, 0), SHIFT_REPEAT(8761),
  [6763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_params_repeat1, 2, 0, 0), SHIFT_REPEAT(8742),
  [6766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3491),
  [6768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4091),
  [6770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6740),
  [6772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6061),
  [6774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5513),
  [6776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5794),
  [6778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2879),
  [6780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [6782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [6784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6653),
  [6786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6356),
  [6788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6691),
  [6790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [6792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam, 4, 0, 395),
  [6794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_via, 2, 0, 48),
  [6796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3816),
  [6798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5740),
  [6800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5745),
  [6802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5682),
  [6804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [6806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [6808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5898),
  [6810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam, 3, 0, 281),
  [6812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5810),
  [6814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6979),
  [6816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [6818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [6820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3837),
  [6822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [6824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [6826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5882),
  [6828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7283),
  [6830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5634),
  [6832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6593),
  [6834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3880),
  [6836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5689),
  [6838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2705),
  [6840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [6842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5724),
  [6844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [6846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5760),
  [6848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7865),
  [6850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 2, 0, 120),
  [6852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [6854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8883),
  [6856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 3, 0, 224),
  [6858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 1, 0, 22),
  [6860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__prefix_percent, 2, 0, 0),
  [6862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__prefix_percent, 2, 0, 0),
  [6864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__promoted_tyconops_alias, 2, 0, 0),
  [6866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__promoted_tyconops_alias, 2, 0, 0),
  [6868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__promoted_tyconops_alias, 2, 0, 156),
  [6870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__promoted_tyconops_alias, 2, 0, 156),
  [6872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8618),
  [6874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12476),
  [6876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8619),
  [6878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__forall_body, 1, 0, 42),
  [6880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 3, 0, 323),
  [6882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__prefix_at, 2, 0, 0),
  [6884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__prefix_at, 2, 0, 0),
  [6886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [6888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 4, 0, 433),
  [6890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 3, 0, 224),
  [6892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qtycon_ticked, 3, 0, 0),
  [6894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qtycon_ticked, 3, 0, 0),
  [6896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 2, 0, 120),
  [6898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tycon_ticked, 3, 0, 0),
  [6900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tycon_ticked, 3, 0, 0),
  [6902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 2, 0, 127),
  [6904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8776),
  [6906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_signature, 3, 0, 297),
  [6908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9941),
  [6910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9941),
  [6912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patsyn_signature, 3, 0, 198),
  [6914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [6916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [6918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datafam, 4, 0, 395),
  [6920] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_params_repeat1, 2, 0, 0), SHIFT_REPEAT(8902),
  [6923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_params_repeat1, 2, 0, 0), SHIFT_REPEAT(8903),
  [6926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_tyfam, 5, 0, 287),
  [6928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ctr_signature, 3, 0, 399),
  [6930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patsyn_signature, 3, 0, 197),
  [6932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patsyn_signature, 3, 0, 195),
  [6934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_tyfam, 4, 0, 174),
  [6936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 3, 0, 150),
  [6938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_con_record, 3, 0, 550),
  [6940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datafam, 3, 0, 282),
  [6942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_kind_signature, 5, 0, 287),
  [6944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_con_prefix, 1, 0, 160),
  [6946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_instance_common, 4, 0, 59),
  [6948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_tyfam, 4, 0, 176),
  [6950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_signature, 3, 0, 297),
  [6952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quantified_variables, 1, 0, 0),
  [6954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_instance_common, 3, 0, 39),
  [6956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_signature, 3, 0, 144),
  [6958] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_quantified_variables_repeat1, 2, 0, 0), SHIFT_REPEAT(8618),
  [6961] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_quantified_variables_repeat1, 2, 0, 0), SHIFT_REPEAT(12476),
  [6964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_quantified_variables_repeat1, 2, 0, 0), SHIFT_REPEAT(8619),
  [6967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_quantified_variables_repeat1, 2, 0, 0),
  [6969] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_quantified_variables_repeat1, 2, 0, 0), SHIFT_REPEAT(12588),
  [6972] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_quantified_variables_repeat1, 2, 0, 0), SHIFT_REPEAT(12532),
  [6975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_tyfam, 5, 0, 555),
  [6977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_kind_signature, 4, 0, 176),
  [6979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_kind_signature, 4, 0, 174),
  [6981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_instance_common, 4, 0, 120),
  [6983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 3, 0, 136),
  [6985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_tyfam, 5, 0, 474),
  [6987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datafam, 3, 0, 281),
  [6989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_tyfam, 6, 0, 559),
  [6991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_head_params, 1, 0, 40),
  [6993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_head_params, 1, 0, 40),
  [6995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_param_wildcard, 1, 0, 0),
  [6997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_param_wildcard, 1, 0, 0),
  [6999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_param, 1, 0, 37),
  [7001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_param, 1, 0, 37),
  [7003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_param, 1, 0, 0),
  [7005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_param, 1, 0, 0),
  [7007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_param, 1, 0, 38),
  [7009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_param, 1, 0, 38),
  [7011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_param_invisible, 2, 0, 89),
  [7013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_param_invisible, 2, 0, 89),
  [7015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_head_parens, 4, 0, 95),
  [7017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_head_parens, 4, 0, 95),
  [7019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_param_parens, 3, 0, 0),
  [7021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_param_parens, 3, 0, 0),
  [7023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_head_parens, 3, 0, 59),
  [7025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_head_parens, 3, 0, 59),
  [7027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_head_parens, 3, 0, 44),
  [7029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_head_parens, 3, 0, 44),
  [7031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_params_repeat1, 1, 0, 38),
  [7033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_params_repeat1, 1, 0, 38),
  [7035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_params_repeat1, 2, 0, 0), SHIFT_REPEAT(8618),
  [7038] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_params_repeat1, 2, 0, 0), SHIFT_REPEAT(8619),
  [7041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_head_name, 1, 0, 41),
  [7043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_head_name, 1, 0, 41),
  [7045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_head_params, 1, 0, 39),
  [7047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_head_params, 1, 0, 39),
  [7049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_head_name, 1, 0, 2),
  [7051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_head_name, 1, 0, 2),
  [7053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10671),
  [7055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11756),
  [7057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_deriving_strategy, 1, 0, 0),
  [7059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving_strategy, 1, 0, 0),
  [7061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__qualifying_module, 2, 0, 0),
  [7063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__qualifying_module, 2, 0, 0),
  [7065] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__qualifying_module, 2, 0, 0), SHIFT_REPEAT(10078),
  [7068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10714),
  [7070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11660),
  [7072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [7074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5747),
  [7076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5883),
  [7078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [7080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5846),
  [7082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5855),
  [7084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3809),
  [7086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5678),
  [7088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5723),
  [7090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_param_annotated, 3, 0, 288),
  [7092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2910),
  [7094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bind_matches, 1, 0, 15),
  [7096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9510),
  [7098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5686),
  [7100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7197),
  [7102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7198),
  [7104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6254),
  [7106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6252),
  [7108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5598),
  [7110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5552),
  [7112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6184),
  [7114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3105),
  [7116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2903),
  [7118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [7120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2872),
  [7122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6098),
  [7124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [7126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [7128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5731),
  [7130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6185),
  [7132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5796),
  [7134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6093),
  [7136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 4, 0, 558),
  [7138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6620),
  [7140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3944),
  [7142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4022),
  [7144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5420),
  [7146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5441),
  [7148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6805),
  [7150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3777),
  [7152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [7154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [7156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6302),
  [7158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6303),
  [7160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5736),
  [7162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3904),
  [7164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6875),
  [7166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3893),
  [7168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [7170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [7172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [7174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3920),
  [7176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [7178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5739),
  [7180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5803),
  [7182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [7184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6676),
  [7186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6658),
  [7188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [7190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6190),
  [7192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7264),
  [7194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [7196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7443),
  [7198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6189),
  [7200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6820),
  [7202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3457),
  [7204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3812),
  [7206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5797),
  [7208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5783),
  [7210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3480),
  [7212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2869),
  [7214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [7216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3477),
  [7218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5594),
  [7220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5558),
  [7222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5881),
  [7224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5699),
  [7226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 3, 0, 136),
  [7228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5590),
  [7230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [7232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2964),
  [7234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [7236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [7238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5693),
  [7240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [7242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3864),
  [7244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5688),
  [7246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6603),
  [7248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5893),
  [7250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6011),
  [7252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6871),
  [7254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6623),
  [7256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [7258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5729),
  [7260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [7262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5761),
  [7264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6612),
  [7266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5541),
  [7268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12243),
  [7270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [7272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12031),
  [7274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12380),
  [7276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12381),
  [7278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12382),
  [7280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [7282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10274),
  [7284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [7286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12196),
  [7288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12252),
  [7290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12253),
  [7292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12254),
  [7294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [7296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1025),
  [7298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12168),
  [7300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12277),
  [7302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12274),
  [7304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12272),
  [7306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [7308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1091),
  [7310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12218),
  [7312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12227),
  [7314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12228),
  [7316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12240),
  [7318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [7320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qual_dot, 2, 0, 0),
  [7322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qual_dot, 2, 0, 0),
  [7324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tight_dot, 2, 0, 0),
  [7326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tight_dot, 2, 0, 0),
  [7328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__modid_prefix, 2, 0, 33),
  [7330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__modid_prefix, 2, 0, 33),
  [7332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8865),
  [7334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10001),
  [7336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12529),
  [7338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9168),
  [7340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9688),
  [7342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [7344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11787),
  [7346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12500),
  [7348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12544),
  [7350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12502),
  [7352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [7354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [7356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12142),
  [7358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12301),
  [7360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12302),
  [7362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12303),
  [7364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [7366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [7368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11971),
  [7370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12410),
  [7372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12411),
  [7374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12412),
  [7376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [7378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [7380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12083),
  [7382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12342),
  [7384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12343),
  [7386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12344),
  [7388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [7390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [7392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11847),
  [7394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12470),
  [7396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12471),
  [7398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12472),
  [7400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [7402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [7404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11893),
  [7406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12440),
  [7408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12441),
  [7410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12442),
  [7412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [7414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__qualifying_module, 1, 0, 0),
  [7416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__qualifying_module, 1, 0, 0),
  [7418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9614),
  [7420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9689),
  [7422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10059),
  [7424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12507),
  [7426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11718),
  [7428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12481),
  [7430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9883),
  [7432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9885),
  [7434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9668),
  [7436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12425),
  [7438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 1, 0, 33),
  [7440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__matches, 1, 0, 108),
  [7442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12282),
  [7444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12694),
  [7446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__bind_matches_repeat1, 2, 0, 140),
  [7448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__bind_matches_repeat1, 2, 0, 140), SHIFT_REPEAT(12338),
  [7451] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__bind_matches_repeat1, 2, 0, 140), SHIFT_REPEAT(12358),
  [7454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12449),
  [7456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12293),
  [7458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12224),
  [7460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__matches_repeat1, 2, 0, 0),
  [7462] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__matches_repeat1, 2, 0, 0), SHIFT_REPEAT(12282),
  [7465] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__matches_repeat1, 2, 0, 0), SHIFT_REPEAT(12358),
  [7468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam, 1, 0, 22),
  [7470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [7472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12739),
  [7474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12475),
  [7476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 2, 0, 81),
  [7478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12582),
  [7480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam, 2, 0, 120),
  [7482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [7484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__splice_dollars, 2, 0, 0),
  [7486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__splice_dollars, 2, 0, 0),
  [7488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9654),
  [7490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9610),
  [7492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, 0, 59),
  [7494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9246),
  [7496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [7498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [7500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7596),
  [7502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12279),
  [7504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat, 1, 0, 27),
  [7506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat, 1, 0, 27),
  [7508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7639),
  [7510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [7512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [7514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7891),
  [7516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_head_infix, 3, 0, 171),
  [7518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [7520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 95),
  [7522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9467),
  [7524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [7526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7792),
  [7528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 186),
  [7530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9425),
  [7532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [7534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 130),
  [7536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9402),
  [7538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [7540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_head_infix, 3, 0, 172),
  [7542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8948),
  [7544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8949),
  [7546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9100),
  [7548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_role_annotation, 4, 0, 170),
  [7550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9778),
  [7552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12520),
  [7554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11748),
  [7556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9845),
  [7558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9846),
  [7560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9351),
  [7562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9338),
  [7564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12447),
  [7566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8968),
  [7568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8971),
  [7570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 4, 0, 199),
  [7572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8893),
  [7574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10202),
  [7576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11030),
  [7578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12237),
  [7580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12585),
  [7582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9761),
  [7584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8939),
  [7586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11640),
  [7588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12225),
  [7590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam_inj, 1, 0, 0),
  [7592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12309),
  [7594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8754),
  [7596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8767),
  [7598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 2, 0, 56),
  [7600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8929),
  [7602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10120),
  [7604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10979),
  [7606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 3, 0, 111),
  [7608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8935),
  [7610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10161),
  [7612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11008),
  [7614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 3, 0, 110),
  [7616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8936),
  [7618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10159),
  [7620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11004),
  [7622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9652),
  [7624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9669),
  [7626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructors, 2, 0, 339),
  [7628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7723),
  [7630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12451),
  [7632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12422),
  [7634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_role_annotation_repeat1, 2, 0, 285),
  [7636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_role_annotation_repeat1, 2, 0, 285), SHIFT_REPEAT(9100),
  [7639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructors, 1, 0, 216),
  [7641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12463),
  [7643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_data_constructors_repeat1, 2, 0, 444),
  [7645] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructors_repeat1, 2, 0, 444), SHIFT_REPEAT(7723),
  [7648] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructors_repeat1, 2, 0, 444), SHIFT_REPEAT(12451),
  [7651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt, 3, 0, 221),
  [7653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8577),
  [7655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_family_injectivity_repeat1, 2, 0, 0), SHIFT_REPEAT(8864),
  [7658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_family_injectivity_repeat1, 2, 0, 0),
  [7660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_family_injectivity_repeat1, 2, 0, 0),
  [7662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9248),
  [7664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_tyfam, 4, 0, 543),
  [7666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [7668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [7670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9849),
  [7672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9849),
  [7674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_tyfam, 3, 0, 91),
  [7676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [7678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_tyfam, 3, 0, 95),
  [7680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [7682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ie_entity, 1, 0, 160),
  [7684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9741),
  [7686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9741),
  [7688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt, 1, 0, 0),
  [7690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3239),
  [7692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9998),
  [7694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9998),
  [7696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 5, 0, 199),
  [7698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10216),
  [7700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11050),
  [7702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8864),
  [7704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fundep, 3, 0, 451),
  [7706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fundep, 3, 0, 451),
  [7708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9806),
  [7710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9806),
  [7712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_tyfam, 2, 0, 59),
  [7714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [7716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9722),
  [7718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9722),
  [7720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9761),
  [7722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let, 1, 0, 0),
  [7724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [7726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [7728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12546),
  [7730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9934),
  [7732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9934),
  [7734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 3, 0, 56),
  [7736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10166),
  [7738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11013),
  [7740] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__let_binds_repeat1, 2, 0, 0), SHIFT_REPEAT(8933),
  [7743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [7745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [7747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12247),
  [7749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 4, 0, 111),
  [7751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10209),
  [7753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11034),
  [7755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 4, 0, 110),
  [7757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10203),
  [7759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11031),
  [7761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9856),
  [7763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9856),
  [7765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ie_entity, 2, 0, 270),
  [7767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 3, 0, 223),
  [7769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 2, 0, 122),
  [7771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 2, 0, 123),
  [7773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 2, 0, 124),
  [7775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 2, 0, 125),
  [7777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12528),
  [7779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9852),
  [7781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 6, 0, 410),
  [7783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11057),
  [7785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 6, 0, 411),
  [7787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11058),
  [7789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 6, 0, 414),
  [7791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11064),
  [7793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 4, 0, 203),
  [7795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11038),
  [7797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9896),
  [7799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9896),
  [7801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [7803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9506),
  [7805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9947),
  [7807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9947),
  [7809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datacon_special, 1, 0, 0),
  [7811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match, 4, 0, 359),
  [7813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match, 5, 0, 477),
  [7815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fundeps, 2, 0, 232),
  [7817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10997),
  [7819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__bind_matches_repeat1, 1, 0, 63),
  [7821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 3, 0, 228),
  [7823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 3, 0, 227),
  [7825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 3, 0, 226),
  [7827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_family_injectivity, 4, 0, 518),
  [7829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_family_injectivity, 4, 0, 518),
  [7831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 2, 0, 337),
  [7833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 3, 0, 225),
  [7835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 7, 0, 480),
  [7837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11065),
  [7839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__data_repeat1, 2, 0, 222),
  [7841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__data_repeat1, 2, 0, 222), SHIFT_REPEAT(3153),
  [7844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__data_repeat1, 2, 0, 222), SHIFT_REPEAT(12697),
  [7847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 4, 0, 426),
  [7849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 4, 0, 427),
  [7851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 4, 0, 428),
  [7853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 4, 0, 429),
  [7855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 3, 0, 220),
  [7857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 3, 0, 219),
  [7859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 4, 0, 430),
  [7861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 3, 0, 218),
  [7863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 1, 0, 216),
  [7865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datacon_special, 1, 0, 6),
  [7867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9958),
  [7869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9958),
  [7871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 4, 0, 431),
  [7873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 1, 0, 215),
  [7875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 4, 0, 434),
  [7877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 1, 0, 214),
  [7879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 4, 0, 435),
  [7881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ktype, 1, 0, 105),
  [7883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ktype, 1, 0, 105),
  [7885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 4, 0, 343),
  [7887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 4, 0, 436),
  [7889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 4, 0, 437),
  [7891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 4, 0, 344),
  [7893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 4, 0, 345),
  [7895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 4, 0, 346),
  [7897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7707),
  [7899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [7901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12420),
  [7903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 1, 0, 213),
  [7905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_fields, 4, 0, 0),
  [7907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__newtype, 3, 0, 316),
  [7909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9716),
  [7911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9716),
  [7913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bind_match, 4, 0, 359),
  [7915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 3, 0, 440),
  [7917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 3, 0, 441),
  [7919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 3, 0, 442),
  [7921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 2, 0, 123),
  [7923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 3, 0, 443),
  [7925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [7927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 2, 0, 122),
  [7929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_data_constructors_repeat1, 2, 0, 205),
  [7931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_fields, 5, 0, 0),
  [7933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bind_matches, 1, 0, 62),
  [7935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fundeps, 3, 0, 352),
  [7937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_fields, 5, 0, 259),
  [7939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_fields, 6, 0, 259),
  [7941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_fields, 6, 0, 376),
  [7943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9910),
  [7945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9910),
  [7947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 5, 0, 446),
  [7949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__newtype, 2, 0, 207),
  [7951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9226),
  [7953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10500),
  [7955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11291),
  [7957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__newtype, 2, 0, 205),
  [7959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alternative, 2, 0, 299),
  [7961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__nalt, 2, 0, 301),
  [7963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_fields, 7, 0, 376),
  [7965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9404),
  [7967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10688),
  [7969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11250),
  [7971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 4, 0, 347),
  [7973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 4, 0, 346),
  [7975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_fundeps_repeat1, 2, 0, 450),
  [7977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fundeps_repeat1, 2, 0, 450), SHIFT_REPEAT(10997),
  [7980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 4, 0, 345),
  [7982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9298),
  [7984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10102),
  [7986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10963),
  [7988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 4, 0, 344),
  [7990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data, 4, 0, 343),
  [7992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9406),
  [7994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10676),
  [7996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11260),
  [7998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 2, 0, 338),
  [8000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 2, 0, 336),
  [8002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 2, 0, 335),
  [8004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 2, 0, 334),
  [8006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 2, 0, 333),
  [8008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 2, 0, 332),
  [8010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 2, 0, 331),
  [8012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datacon_record, 2, 0, 329),
  [8014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 3, 0, 226),
  [8016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 3, 0, 225),
  [8018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9930),
  [8020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9930),
  [8022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inferred_tyvar, 5, 0, 0),
  [8024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inferred_tyvar, 5, 0, 0),
  [8026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12632),
  [8028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9835),
  [8030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_role_annotation_repeat1, 1, 0, 169),
  [8032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_role, 1, 0, 0),
  [8034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_family, 4, 0, 87),
  [8036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6846),
  [8038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 3, 0, 220),
  [8040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 3, 0, 219),
  [8042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 3, 0, 218),
  [8044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__newtype, 1, 0, 114),
  [8046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 6, 0, 541),
  [8048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 3, 0, 325),
  [8050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 6, 0, 542),
  [8052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 3, 0, 324),
  [8054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 3, 0, 321),
  [8056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 5, 0, 304),
  [8058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11052),
  [8060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datacon_unboxed_sum, 5, 0, 157),
  [8062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datacon_unboxed_sum, 4, 0, 266),
  [8064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datacon_unboxed_sum, 5, 0, 266),
  [8066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datacon_unboxed_sum, 4, 0, 157),
  [8068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 5, 0, 446),
  [8070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 5, 0, 505),
  [8072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 5, 0, 504),
  [8074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 5, 0, 503),
  [8076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 5, 0, 502),
  [8078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 5, 0, 501),
  [8080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 5, 0, 500),
  [8082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 5, 0, 499),
  [8084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 5, 0, 498),
  [8086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__where, 2, 0, 0),
  [8088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [8090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [8092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12602),
  [8094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_quantified_variables_repeat1, 1, 0, 38),
  [8096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_quantified_variables_repeat1, 1, 0, 38),
  [8098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_adt, 3, 0, 320),
  [8100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9739),
  [8102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9739),
  [8104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 5, 0, 306),
  [8106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11053),
  [8108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 5, 0, 307),
  [8110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11054),
  [8112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [8114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [8116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [8118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5222),
  [8120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5083),
  [8122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4212),
  [8124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [8126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [8128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4958),
  [8130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [8132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [8134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [8136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [8138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [8140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4615),
  [8142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [8144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [8146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4959),
  [8148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [8150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [8152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10388),
  [8154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [8156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [8158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4680),
  [8160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [8162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [8164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5218),
  [8166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12243),
  [8168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [8170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [8172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5219),
  [8174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7165),
  [8176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7493),
  [8178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10391),
  [8180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [8182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [8184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5464),
  [8186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [8188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [8190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5223),
  [8192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [8194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [8196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5323),
  [8198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [8200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [8202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5225),
  [8204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 128),
  [8206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9462),
  [8208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [8210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [8212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5569),
  [8214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [8216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [8218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9701),
  [8220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 44),
  [8222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [8224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4096),
  [8226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [8228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [8230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5605),
  [8232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4150),
  [8234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [8236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [8238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [8240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4642),
  [8242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [8244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [8246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5603),
  [8248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8609),
  [8250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8847),
  [8252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9552),
  [8254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bar, 2, 0, 0),
  [8256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [8258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [8260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4929),
  [8262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [8264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [8266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [8268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [8270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9585),
  [8272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8621),
  [8274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8845),
  [8276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9645),
  [8278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [8280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [8282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5600),
  [8284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [8286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [8288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4681),
  [8290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [8292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [8294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [8296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [8298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [8300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10036),
  [8302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [8304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [8306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4927),
  [8308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4334),
  [8310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10883),
  [8312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9780),
  [8314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9780),
  [8316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12452),
  [8318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [8320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [8322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3036),
  [8324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [8326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [8328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4926),
  [8330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [8332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [8334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11704),
  [8336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [8338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [8340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10509),
  [8342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [8344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [8346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3035),
  [8348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [8350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [8352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4630),
  [8354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [8356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [8358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4923),
  [8360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [8362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [8364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4666),
  [8366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [8368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [8370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4922),
  [8372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [8374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [8376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10039),
  [8378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [8380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [8382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5247),
  [8384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [8386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [8388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4685),
  [8390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [8392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [8394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4686),
  [8396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [8398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [8400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5166),
  [8402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [8404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [8406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3999),
  [8408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [8410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [8412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3998),
  [8414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [8416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [8418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [8420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [8422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [8424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9670),
  [8426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [8428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [8430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4688),
  [8432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [8434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [8436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5490),
  [8438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_view_pattern, 3, 0, 255),
  [8440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_view_pattern, 3, 0, 255),
  [8442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [8444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [8446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4919),
  [8448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4194),
  [8450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [8452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [8454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9562),
  [8456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 129),
  [8458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9456),
  [8460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10663),
  [8462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11300),
  [8464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [8466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [8468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9599),
  [8470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [8472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [8474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5493),
  [8476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4848),
  [8478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [8480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [8482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4913),
  [8484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [8486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [8488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3030),
  [8490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3792),
  [8492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5007),
  [8494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3595),
  [8496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [8498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [8500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10266),
  [8502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [8504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [8506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3973),
  [8508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [8510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [8512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10758),
  [8514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [8516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [8518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3971),
  [8520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [8522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [8524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9551),
  [8526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 59),
  [8528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__let_binds_repeat1, 2, 0, 0), SHIFT_REPEAT(9248),
  [8531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__qualifying_module, 2, 0, 0), SHIFT_REPEAT(10374),
  [8534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [8536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [8538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4908),
  [8540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [8542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [8544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10040),
  [8546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [8548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [8550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10592),
  [8552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_family, 3, 0, 87),
  [8554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9101),
  [8556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5279),
  [8558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4339),
  [8560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3873),
  [8562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4418),
  [8564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [8566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [8568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [8570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [8572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4420),
  [8574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [8576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [8578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4898),
  [8580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [8582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [8584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [8586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7117),
  [8588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7487),
  [8590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10593),
  [8592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7106),
  [8594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7499),
  [8596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10594),
  [8598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance, 2, 0, 28),
  [8600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [8602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [8604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [8606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3967),
  [8608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [8610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [8612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5159),
  [8614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [8616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [8618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [8620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [8622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [8624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3966),
  [8626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [8628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [8630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5165),
  [8632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5283),
  [8634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [8636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [8638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5173),
  [8640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4600),
  [8642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [8644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [8646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [8648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9671),
  [8650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7085),
  [8652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7508),
  [8654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10625),
  [8656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [8658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [8660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [8662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5507),
  [8664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [8666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [8668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5209),
  [8670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [8672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [8674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3959),
  [8676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10497),
  [8678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11249),
  [8680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [8682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [8684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5112),
  [8686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [8688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [8690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5392),
  [8692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7158),
  [8694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7504),
  [8696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10424),
  [8698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [8700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [8702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11369),
  [8704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [8706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [8708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9571),
  [8710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [8712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [8714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11340),
  [8716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [8718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [8720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4727),
  [8722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [8724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [8726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5339),
  [8728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 230),
  [8730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [8732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [8734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4445),
  [8736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [8738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [8740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4448),
  [8742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [8744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [8746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3952),
  [8748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [8750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [8752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4451),
  [8754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patsyn_equation, 4, 0, 196),
  [8756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [8758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [8760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [8762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4456),
  [8764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [8766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [8768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5202),
  [8770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [8772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [8774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3014),
  [8776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [8778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [8780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5197),
  [8782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [8784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [8786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3947),
  [8788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [8790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [8792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5397),
  [8794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [8796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [8798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [8800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [8802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [8804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5190),
  [8806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [8808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [8810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5191),
  [8812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [8814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [8816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4730),
  [8818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9746),
  [8820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [8822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [8824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5195),
  [8826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [8828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [8830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5206),
  [8832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [8834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [8836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4728),
  [8838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [8840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [8842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4731),
  [8844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [8846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [8848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4744),
  [8850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [8852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [8854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4747),
  [8856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [8858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [8860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5244),
  [8862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [8864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [8866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5532),
  [8868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [8870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [8872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4750),
  [8874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [8876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [8878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4751),
  [8880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [8882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [8884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5352),
  [8886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [8888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [8890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4732),
  [8892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [8894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [8896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4761),
  [8898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4354),
  [8900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3089),
  [8902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10806),
  [8904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9937),
  [8906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9937),
  [8908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12751),
  [8910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [8912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [8914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5402),
  [8916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [8918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [8920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5351),
  [8922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [8924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [8926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4780),
  [8928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [8930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [8932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5348),
  [8934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [8936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [8938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4837),
  [8940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5301),
  [8942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [8944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [8946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10708),
  [8948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [8950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [8952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4859),
  [8954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [8956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [8958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5347),
  [8960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [8962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [8964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5319),
  [8966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [8968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [8970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5320),
  [8972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [8974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [8976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5345),
  [8978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [8980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [8982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5631),
  [8984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [8986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [8988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [8990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5109),
  [8992] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_multi_way_if_repeat1, 2, 0, 140), SHIFT_REPEAT(12282),
  [8995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_multi_way_if_repeat1, 2, 0, 140),
  [8997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_multi_way_if_repeat1, 2, 0, 140), SHIFT_REPEAT(12358),
  [9000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3953),
  [9002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [9004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [9006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [9008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5107),
  [9010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [9012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [9014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10465),
  [9016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [9018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [9020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5423),
  [9022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [9024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [9026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5424),
  [9028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3867),
  [9030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [9032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [9034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10715),
  [9036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patsyn_equation, 3, 0, 196),
  [9038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9315),
  [9040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [9042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [9044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10720),
  [9046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5612),
  [9048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [9050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [9052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5659),
  [9054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 130),
  [9056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4991),
  [9058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10098),
  [9060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10959),
  [9062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [9064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10093),
  [9066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10952),
  [9068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [9070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [9072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10662),
  [9074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datafam, 1, 0, 22),
  [9076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [9078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, 0, 354),
  [9080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 235),
  [9082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9449),
  [9084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4627),
  [9086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [9088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [9090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2954),
  [9092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_fundeps_repeat1, 2, 0, 232),
  [9094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [9096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [9098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10735),
  [9100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 96),
  [9102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [9104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [9106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [9108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 354),
  [9110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9410),
  [9112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [9114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [9116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4989),
  [9118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [9120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [9122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10032),
  [9124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 186),
  [9126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8713),
  [9128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8849),
  [9130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9685),
  [9132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [9134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [9136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4234),
  [9138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 234),
  [9140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 234),
  [9142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9432),
  [9144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [9146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [9148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9681),
  [9150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [9152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [9154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10674),
  [9156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [9158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12698),
  [9160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [9162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [9164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3000),
  [9166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [9168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [9170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [9172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 235),
  [9174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance, 1, 0, 28),
  [9176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9276),
  [9178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [9180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [9182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9602),
  [9184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [9186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [9188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [9190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [9192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [9194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4955),
  [9196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7099),
  [9198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7521),
  [9200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10848),
  [9202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 129),
  [9204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [9206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [9208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5127),
  [9210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [9212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [9214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5644),
  [9216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 128),
  [9218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 95),
  [9220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5214),
  [9222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5443),
  [9224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4589),
  [9226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [9228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [9230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5643),
  [9232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 230),
  [9234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9308),
  [9236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3722),
  [9238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3175),
  [9240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5652),
  [9242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [9244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [9246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4587),
  [9248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [9250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [9252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [9254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datafam, 2, 0, 120),
  [9256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [9258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [9260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [9262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4470),
  [9264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [9266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [9268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10702),
  [9270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [9272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [9274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5293),
  [9276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [9278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [9280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4768),
  [9282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [9284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [9286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4178),
  [9288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [9290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [9292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [9294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4957),
  [9296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [9298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [9300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4475),
  [9302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [9304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [9306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9549),
  [9308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [9310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [9312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5358),
  [9314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [9316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [9318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4484),
  [9320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4112),
  [9322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3470),
  [9324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2922),
  [9326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__let_binds_repeat1, 2, 0, 0), SHIFT_REPEAT(9499),
  [9329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4773),
  [9331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [9333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [9335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4490),
  [9337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [9339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [9341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5621),
  [9343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [9345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8710),
  [9347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8844),
  [9349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9692),
  [9351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8081),
  [9353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__where_binds, 1, 0, 0),
  [9355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [9357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [9359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [9361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4556),
  [9363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [9365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [9367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4555),
  [9369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [9371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [9373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5557),
  [9375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [9377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [9379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5556),
  [9381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [9383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [9385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4554),
  [9387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [9389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [9391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4217),
  [9393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [9395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [9397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9581),
  [9399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [9401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [9403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4545),
  [9405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [9407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [9409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4493),
  [9411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [9413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [9415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11692),
  [9417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [9419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [9421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4220),
  [9423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [9425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [9427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4494),
  [9429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [9431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [9433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5616),
  [9435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [9437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [9439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4497),
  [9441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5461),
  [9443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [9445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [9447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4498),
  [9449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [9451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [9453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10745),
  [9455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [9457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [9459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [9461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [9463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [9465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4502),
  [9467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [9469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [9471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5516),
  [9473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [9475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10125),
  [9477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_binds, 5, 0, 277),
  [9479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_path, 2, 0, 368),
  [9481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data_rhs, 2, 0, 208),
  [9483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam, 3, 0, 120),
  [9485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam_inj, 2, 0, 0),
  [9487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_binds, 4, 0, 277),
  [9489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_binds, 4, 0, 276),
  [9491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructors, 3, 0, 205),
  [9493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_binds, 4, 0, 165),
  [9495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__data_rhs, 1, 0, 114),
  [9497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt, 4, 0, 425),
  [9499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 363), SHIFT_REPEAT(184),
  [9502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 363), SHIFT_REPEAT(248),
  [9505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 363),
  [9507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 4, 0, 438),
  [9509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fixity, 3, 0, 133),
  [9511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8363),
  [9513] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__let_binds_repeat2, 2, 0, 278), SHIFT_REPEAT(1882),
  [9516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__let_binds_repeat2, 2, 0, 278), SHIFT_REPEAT(1952),
  [9519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__let_binds_repeat2, 2, 0, 278),
  [9521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_quoted_decls_repeat1, 2, 0, 468), SHIFT_REPEAT(22),
  [9524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_quoted_decls_repeat1, 2, 0, 468), SHIFT_REPEAT(25),
  [9527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_quoted_decls_repeat1, 2, 0, 468),
  [9529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [9531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9853),
  [9533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9853),
  [9535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9827),
  [9537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9827),
  [9539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5755),
  [9541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__instance, 5, 0, 291),
  [9543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_binds, 5, 0, 276),
  [9545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11101),
  [9547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12638),
  [9549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 4, 0, 445),
  [9551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_binds, 2, 0, 0),
  [9553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__data_repeat1, 1, 0, 121),
  [9555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10958),
  [9557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt, 2, 0, 208),
  [9559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_binds, 5, 0, 394),
  [9561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fixity, 3, 0, 132),
  [9563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fixity, 2, 0, 61),
  [9565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10935),
  [9567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10940),
  [9569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10914),
  [9571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let, 2, 0, 243),
  [9573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [9575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12374),
  [9577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_local_binds_repeat1, 2, 0, 278), SHIFT_REPEAT(1800),
  [9580] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_local_binds_repeat1, 2, 0, 278), SHIFT_REPEAT(1836),
  [9583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_local_binds_repeat1, 2, 0, 278),
  [9585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [9587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [9589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declarations, 1, 0, 0),
  [9591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10416),
  [9593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_path_repeat1, 2, 0, 461),
  [9595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_path_repeat1, 2, 0, 461), SHIFT_REPEAT(12328),
  [9598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_binds, 3, 0, 165),
  [9600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9740),
  [9602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9740),
  [9604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fixity, 4, 0, 236),
  [9606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_binds, 6, 0, 394),
  [9608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_fixity_repeat1, 2, 0, 0),
  [9610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fixity_repeat1, 2, 0, 0), SHIFT_REPEAT(8363),
  [9613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__matches, 1, 0, 62),
  [9615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6618),
  [9617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructors, 5, 0, 490),
  [9619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7922),
  [9621] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__nalts_repeat1, 2, 0, 402), SHIFT_REPEAT(2038),
  [9624] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__nalts_repeat1, 2, 0, 402), SHIFT_REPEAT(2119),
  [9627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__nalts_repeat1, 2, 0, 402),
  [9629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instance_declarations_repeat1, 2, 0, 468), SHIFT_REPEAT(1617),
  [9632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instance_declarations_repeat1, 2, 0, 468), SHIFT_REPEAT(1799),
  [9635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instance_declarations_repeat1, 2, 0, 468),
  [9637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__let_binds_repeat1, 2, 0, 0), SHIFT_REPEAT(9614),
  [9640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9872),
  [9642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10175),
  [9644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8842),
  [9646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__child_type, 2, 0, 270),
  [9648] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_declarations_repeat1, 2, 0, 468), SHIFT_REPEAT(920),
  [9651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_declarations_repeat1, 2, 0, 468), SHIFT_REPEAT(1080),
  [9654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_declarations_repeat1, 2, 0, 468),
  [9656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__instance, 4, 0, 186),
  [9658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__instance, 4, 0, 183),
  [9660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_bind_match, 2, 0, 78),
  [9662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9656),
  [9664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9997),
  [9666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9997),
  [9668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qname, 1, 0, 3),
  [9670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9887),
  [9672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10068),
  [9674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8639),
  [9676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_match, 2, 0, 78),
  [9678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10374),
  [9680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alternatives_repeat1, 2, 0, 402), SHIFT_REPEAT(2182),
  [9683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alternatives_repeat1, 2, 0, 402), SHIFT_REPEAT(2210),
  [9686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alternatives_repeat1, 2, 0, 402),
  [9688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [9690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12256),
  [9692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11270),
  [9694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructors, 5, 0, 528),
  [9696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 3, 0, 341),
  [9698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11271),
  [9700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11274),
  [9702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_spec, 1, 0, 0),
  [9704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructors, 5, 0, 493),
  [9706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10885),
  [9708] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_family_injectivity_repeat1, 2, 0, 0), SHIFT_REPEAT(9656),
  [9711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10014),
  [9713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10014),
  [9715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [9717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [9719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12789),
  [9721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam, 2, 0, 22),
  [9723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11298),
  [9725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10063),
  [9727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__qualifying_module, 2, 0, 0), SHIFT_REPEAT(10274),
  [9730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam, 2, 0, 39),
  [9732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7375),
  [9734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructors, 6, 0, 528),
  [9736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__tyfam_equations_repeat1, 2, 0, 521), SHIFT_REPEAT(7588),
  [9739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__tyfam_equations_repeat1, 2, 0, 521), SHIFT_REPEAT(7728),
  [9742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__tyfam_equations_repeat1, 2, 0, 521),
  [9744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9933),
  [9746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9933),
  [9748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [9750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__instance, 3, 0, 95),
  [9752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declarations_repeat1, 2, 0, 0), SHIFT_REPEAT(12),
  [9755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declarations_repeat1, 2, 0, 0), SHIFT_REPEAT(23),
  [9758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declarations_repeat1, 2, 0, 0),
  [9760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 5, 0, 506),
  [9762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructors, 4, 0, 490),
  [9764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7065),
  [9766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructors, 2, 0, 0),
  [9768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructors, 4, 0, 205),
  [9770] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patsyn_cons_repeat1, 2, 0, 0), SHIFT_REPEAT(2137),
  [9773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patsyn_cons_repeat1, 2, 0, 0), SHIFT_REPEAT(2204),
  [9776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__patsyn_cons_repeat1, 2, 0, 0),
  [9778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructors, 4, 0, 493),
  [9780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9821),
  [9782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9821),
  [9784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gadt_constructors_repeat1, 2, 0, 444), SHIFT_REPEAT(8897),
  [9787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gadt_constructors_repeat1, 2, 0, 444), SHIFT_REPEAT(9256),
  [9790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gadt_constructors_repeat1, 2, 0, 444),
  [9792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10042),
  [9794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6748),
  [9796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_newtype_constructor, 2, 0, 318),
  [9798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9799),
  [9800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9799),
  [9802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_newtype_constructor, 2, 0, 317),
  [9804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_newtype_constructor, 2, 0, 315),
  [9806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_newtype_constructor, 2, 0, 314),
  [9808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12516),
  [9810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9772),
  [9812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__ctr_tuple_repeat1, 2, 0, 0),
  [9814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ctr_forall, 3, 0, 398),
  [9816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10248),
  [9818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10248),
  [9820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [9822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [9824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guards, 1, 0, 240),
  [9826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9714),
  [9828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9714),
  [9830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12285),
  [9832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12674),
  [9834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9932),
  [9836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9932),
  [9838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8297),
  [9840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9959),
  [9842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9959),
  [9844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [9846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9905),
  [9848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9905),
  [9850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9898),
  [9852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9898),
  [9854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_guards_repeat1, 2, 0, 457), SHIFT_REPEAT(354),
  [9857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_guards_repeat1, 2, 0, 457),
  [9859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11223),
  [9861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ie_entity, 2, 0, 269),
  [9863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9616),
  [9865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ie_entity, 2, 0, 271),
  [9867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [9869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [9871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [9873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12610),
  [9875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8055),
  [9877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10152),
  [9879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12808),
  [9881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12389),
  [9883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9952),
  [9885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9952),
  [9887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9936),
  [9889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9936),
  [9891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9793),
  [9893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9793),
  [9895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9925),
  [9897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9925),
  [9899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [9901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12737),
  [9903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9989),
  [9905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9789),
  [9907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9789),
  [9909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9794),
  [9911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9794),
  [9913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12779),
  [9915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11483),
  [9917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [9919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10007),
  [9921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10007),
  [9923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9948),
  [9925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9948),
  [9927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11323),
  [9929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7910),
  [9931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9949),
  [9933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9949),
  [9935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9963),
  [9937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9963),
  [9939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9894),
  [9941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9894),
  [9943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [9945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12558),
  [9947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guards, 2, 0, 360),
  [9949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [9951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10489),
  [9953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [9955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12634),
  [9957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10119),
  [9959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10994),
  [9961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6186),
  [9963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [9965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12231),
  [9967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12321),
  [9969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [9971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9909),
  [9973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9909),
  [9975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [9977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12283),
  [9979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9911),
  [9981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9911),
  [9983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9912),
  [9985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9912),
  [9987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9731),
  [9989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10218),
  [9991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [9993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12506),
  [9995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12753),
  [9997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9942),
  [9999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ctr_context, 2, 0, 289),
  [10001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9788),
  [10003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9788),
  [10005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ie_entity, 1, 0, 161),
  [10007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ie_entity, 1, 0, 159),
  [10009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9745),
  [10011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9745),
  [10013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8086),
  [10015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [10017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [10019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9737),
  [10021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9737),
  [10023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9728),
  [10025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9728),
  [10027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [10029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [10031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12357),
  [10033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9960),
  [10035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9960),
  [10037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7063),
  [10039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6522),
  [10041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12773),
  [10043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12800),
  [10045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [10047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10249),
  [10049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [10051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_newtype, 3, 0, 313),
  [10053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_newtype, 3, 0, 312),
  [10055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_newtype, 3, 0, 311),
  [10057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_newtype, 3, 0, 116),
  [10059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7900),
  [10061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator, 3, 0, 364),
  [10063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9453),
  [10065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_haskell, 1, 0, 0),
  [10067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [10069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11093),
  [10071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10896),
  [10073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12787),
  [10075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10926),
  [10077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, 0, 0),
  [10079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3775),
  [10081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3157),
  [10083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 7, 0, 484),
  [10085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [10087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [10089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3861),
  [10091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4247),
  [10093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_instance, 1, 0, 0),
  [10095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fixity, 1, 0, 29),
  [10097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl, 1, 0, 0),
  [10099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [10101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [10103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_newtype, 5, 0, 319),
  [10105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 9, 0, 547),
  [10107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [10109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declarations, 2, 0, 0),
  [10111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 8, 0, 527),
  [10113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [10115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 8, 0, 526),
  [10117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [10119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 8, 0, 525),
  [10121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [10123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 8, 0, 524),
  [10125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [10127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_list, 5, 0, 419),
  [10129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 7, 0, 487),
  [10131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_types, 5, 0, 348),
  [10133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [10135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 350),
  [10137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [10139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 7, 0, 485),
  [10141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 6, 0, 417),
  [10143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 351),
  [10145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [10147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 7, 0, 483),
  [10149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4339),
  [10151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 7, 0, 482),
  [10153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [10155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 7, 0, 481),
  [10157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [10159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_list_repeat1, 2, 0, 157),
  [10161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_unboxed_sum_repeat1, 2, 0, 256), SHIFT_REPEAT(1232),
  [10164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_unboxed_sum_repeat1, 2, 0, 256), SHIFT_REPEAT(1232),
  [10167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_unboxed_sum_repeat1, 2, 0, 256),
  [10169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [10171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [10173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_tuple_elems_repeat1, 2, 0, 256), SHIFT_REPEAT(1226),
  [10176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_tuple_elems_repeat1, 2, 0, 256),
  [10178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_tuple_elems_repeat1, 2, 0, 157),
  [10180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [10182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [10184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [10186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4112),
  [10188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_guards_repeat1, 2, 0, 456),
  [10190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_decl, 1, 0, 43),
  [10192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_decl, 1, 0, 250),
  [10194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_list, 4, 0, 419),
  [10196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 7, 0, 486),
  [10198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 6, 0, 418),
  [10200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_decl, 1, 0, 0),
  [10202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10368),
  [10204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10260),
  [10206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 6, 0, 416),
  [10208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 6, 0, 415),
  [10210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 6, 0, 413),
  [10212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_family_injectivity_repeat1, 2, 0, 0), SHIFT_REPEAT(10152),
  [10215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 353),
  [10217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 6, 0, 412),
  [10219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 6, 0, 409),
  [10221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [10223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 355),
  [10225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7959),
  [10227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [10229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 356),
  [10231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_import, 5, 0, 357),
  [10233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [10235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_synonym, 2, 0, 54),
  [10237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_synonym, 2, 0, 55),
  [10239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_list, 4, 0, 310),
  [10241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [10243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving_instance, 2, 0, 57),
  [10245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_list, 3, 0, 310),
  [10247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_list, 3, 0, 0),
  [10249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_import, 5, 0, 358),
  [10251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_export, 5, 0, 358),
  [10253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 5, 0, 309),
  [10255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 5, 0, 308),
  [10257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_binds, 2, 0, 0),
  [10259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 5, 0, 305),
  [10261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type, 2, 0, 58),
  [10263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 5, 0, 303),
  [10265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 5, 0, 302),
  [10267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [10269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [10271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7932),
  [10273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_synomym, 5, 0, 286),
  [10275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statements_repeat1, 2, 0, 244),
  [10277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [10279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_family, 5, 0, 284),
  [10281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_family, 5, 0, 283),
  [10283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bind, 2, 0, 64),
  [10285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__var_binding_list, 2, 0, 65),
  [10287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bind, 2, 0, 66),
  [10289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [10291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [10293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12608),
  [10295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guard, 1, 0, 0),
  [10297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qfield_name, 2, 0, 72),
  [10299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bind, 2, 0, 71),
  [10301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guard, 1, 0, 239),
  [10303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_list, 2, 0, 0),
  [10305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 4, 0, 202),
  [10307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 4, 0, 201),
  [10309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12700),
  [10311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12687),
  [10313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 4, 0, 200),
  [10315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3835),
  [10317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4260),
  [10319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__exp_unboxed_sum_repeat1, 2, 0, 0), SHIFT_REPEAT(10248),
  [10322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_unboxed_sum_repeat1, 2, 0, 0), SHIFT_REPEAT(10248),
  [10325] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_tuple_elems_repeat1, 2, 0, 0), SHIFT_REPEAT(10249),
  [10328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 2, 0, 77),
  [10330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [10332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 3, 0, 112),
  [10334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4269),
  [10336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guard, 1, 0, 242),
  [10338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__let_binds_repeat2, 2, 0, 165),
  [10340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patsyn_cons, 6, 0, 546),
  [10342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_tyfam, 6, 0, 543),
  [10344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [10346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_datainst_newtype, 2, 0, 369),
  [10348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_datainst_adt, 2, 0, 370),
  [10350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance_declarations, 3, 0, 371),
  [10352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_tyfam, 5, 0, 95),
  [10354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patsyn_cons, 5, 0, 523),
  [10356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patsyn_cons, 5, 0, 546),
  [10358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12311),
  [10360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12315),
  [10362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam_equations, 6, 0, 545),
  [10364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9876),
  [10366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7820),
  [10368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_projection_selector_repeat1, 2, 0, 377),
  [10370] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_projection_selector_repeat1, 2, 0, 377), SHIFT_REPEAT(12328),
  [10373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7796),
  [10375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_transform, 2, 0, 378),
  [10377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [10379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [10381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualifiers, 2, 0, 379),
  [10383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_binds, 6, 0, 394),
  [10385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam_equations, 5, 0, 520),
  [10387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [10389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_tyfam, 5, 0, 91),
  [10391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_instance, 1, 0, 40),
  [10393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7972),
  [10395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_instance, 3, 0, 86),
  [10397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12684),
  [10399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declarations, 6, 0, 511),
  [10401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 5, 0, 554),
  [10403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5789),
  [10405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5012),
  [10407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_type, 3, 0, 88),
  [10409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 5, 0, 553),
  [10411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3593),
  [10413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9968),
  [10415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9803),
  [10417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving_instance, 3, 0, 84),
  [10419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 5, 0, 552),
  [10421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 5, 0, 551),
  [10423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [10425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [10427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3571),
  [10429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [10431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2758),
  [10433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [10435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_tyfam, 5, 0, 507),
  [10437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [10439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [10441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6960),
  [10443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6114),
  [10445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [10447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [10449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 5, 0, 549),
  [10451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7086),
  [10453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6423),
  [10455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [10457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2873),
  [10459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 5, 0, 548),
  [10461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6724),
  [10463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5915),
  [10465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [10467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2934),
  [10469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3502),
  [10471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [10473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6485),
  [10475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5787),
  [10477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5826),
  [10479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5135),
  [10481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12238),
  [10483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [10485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [10487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualifiers, 1, 0, 261),
  [10489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5083),
  [10491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_repeat1, 2, 0, 138), SHIFT_REPEAT(11483),
  [10494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_repeat1, 2, 0, 138),
  [10496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pat_tuple_elems_repeat1, 2, 0, 256), SHIFT_REPEAT(385),
  [10499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pat_tuple_elems_repeat1, 2, 0, 256),
  [10501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pat_tuple_elems_repeat1, 2, 0, 157),
  [10503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [10505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3722),
  [10507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4150),
  [10509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__patsyn_cons_repeat1, 2, 0, 523),
  [10511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance_decl, 1, 0, 0),
  [10513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_datainst, 1, 0, 252),
  [10515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam_equations, 2, 0, 0),
  [10517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patsyn_cons, 4, 0, 523),
  [10519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_datainst, 1, 0, 251),
  [10521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6556),
  [10523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5773),
  [10525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patsyn_cons, 4, 0, 546),
  [10527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance_decl, 1, 0, 250),
  [10529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam_equations, 5, 0, 545),
  [10531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance_declarations, 2, 0, 0),
  [10533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7371),
  [10535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6588),
  [10537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [10539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam_equations, 5, 0, 519),
  [10541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9615),
  [10543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [10545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7466),
  [10547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6629),
  [10549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 4, 0, 535),
  [10551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [10553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3676),
  [10555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_names, 1, 0, 32),
  [10557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [10559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [10561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rec, 2, 0, 67),
  [10563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_tyinst, 5, 0, 544),
  [10565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance_declarations, 6, 0, 511),
  [10567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alternatives_repeat1, 2, 0, 298),
  [10569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alternative, 3, 0, 403),
  [10571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4354),
  [10573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11184),
  [10575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_binds, 5, 0, 277),
  [10577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_binds, 5, 0, 394),
  [10579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_binds, 5, 0, 276),
  [10581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declarations, 5, 0, 467),
  [10583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__where_binds, 2, 0, 238),
  [10585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_export, 4, 0, 237),
  [10587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__nalts_repeat1, 2, 0, 300),
  [10589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_import, 4, 0, 237),
  [10591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_tyfam, 4, 0, 59),
  [10593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7742),
  [10595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7278),
  [10597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7967),
  [10599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7743),
  [10601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__con_binding_list, 2, 0, 109),
  [10603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__con_binding_list, 2, 0, 65),
  [10605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__nalt, 3, 0, 406),
  [10607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patsyn_equation, 5, 0, 408),
  [10609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_tyfam, 4, 0, 44),
  [10611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6311),
  [10613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5757),
  [10615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declarations, 5, 0, 511),
  [10617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declarations, 5, 0, 465),
  [10619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_inst_newtype, 3, 0, 113),
  [10621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 4, 0, 540),
  [10623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5968),
  [10625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5638),
  [10627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_newtype, 3, 0, 115),
  [10629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 4, 0, 539),
  [10631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 233),
  [10633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_newtype, 3, 0, 116),
  [10635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 4, 0, 538),
  [10637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 4, 0, 537),
  [10639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 231),
  [10641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 4, 0, 536),
  [10643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 4, 0, 534),
  [10645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [10647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_types, 4, 0, 229),
  [10649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7384),
  [10651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6678),
  [10653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 4, 0, 533),
  [10655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_newtype, 4, 0, 420),
  [10657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving_instance, 3, 0, 117),
  [10659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_newtype, 4, 0, 421),
  [10661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving_instance, 3, 0, 118),
  [10663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_newtype, 4, 0, 422),
  [10665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_newtype, 4, 0, 423),
  [10667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 4, 0, 532),
  [10669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_newtype, 4, 0, 424),
  [10671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [10673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2857),
  [10675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 4, 0, 531),
  [10677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_inst_adt, 3, 0, 119),
  [10679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 4, 0, 530),
  [10681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_family, 3, 0, 87),
  [10683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6127),
  [10685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5683),
  [10687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance_declarations, 5, 0, 467),
  [10689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12462),
  [10691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4600),
  [10693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_types, 3, 0, 0),
  [10695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [10697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patsyn_cons, 3, 0, 523),
  [10699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam_equations, 4, 0, 519),
  [10701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam_equations, 4, 0, 520),
  [10703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7551),
  [10705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6824),
  [10707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam_equations, 4, 0, 473),
  [10709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [10711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6795),
  [10713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6015),
  [10715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__tyfam_equations_repeat1, 2, 0, 473),
  [10717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 4, 0, 529),
  [10719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5895),
  [10721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5665),
  [10723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_newtype, 4, 0, 210),
  [10725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fun_arrow_fixity, 3, 0, 131),
  [10727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_newtype, 4, 0, 209),
  [10729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [10731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_signature, 2, 0, 449),
  [10733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_quoted_decls_repeat1, 2, 0, 371),
  [10735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_newtype, 4, 0, 206),
  [10737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, 0, 447),
  [10739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_newtype, 2, 0, 204),
  [10741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5997),
  [10743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5585),
  [10745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [10747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [10749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bind_matches, 2, 0, 135),
  [10751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__var_binding_list_repeat1, 2, 0, 138), SHIFT_REPEAT(9850),
  [10754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__var_binding_list_repeat1, 2, 0, 138),
  [10756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7920),
  [10758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7905),
  [10760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7624),
  [10762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bind_matches, 2, 0, 139),
  [10764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declarations, 3, 0, 371),
  [10766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 141),
  [10768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6647),
  [10770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5857),
  [10772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_statement, 1, 0, 0),
  [10774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declarations, 4, 0, 465),
  [10776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, 0, 452),
  [10778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, 0, 453),
  [10780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_tyinst, 4, 0, 513),
  [10782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [10784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, 0, 454),
  [10786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6106),
  [10788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5692),
  [10790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [10792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_import, 6, 0, 455),
  [10794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__con_binding_list_repeat1, 2, 0, 138), SHIFT_REPEAT(9748),
  [10797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__con_binding_list_repeat1, 2, 0, 138),
  [10799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7705),
  [10801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7100),
  [10803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_binds, 3, 0, 165),
  [10805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6415),
  [10807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5732),
  [10809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [10811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_tyinst, 4, 0, 512),
  [10813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance_declarations, 5, 0, 511),
  [10815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance_declarations, 5, 0, 465),
  [10817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_binds, 4, 0, 277),
  [10819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_local_binds_repeat1, 2, 0, 165),
  [10821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_binds, 4, 0, 165),
  [10823] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_imports_repeat1, 2, 0, 147), SHIFT_REPEAT(10411),
  [10826] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_imports_repeat1, 2, 0, 147), SHIFT_REPEAT(11755),
  [10829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_binds, 4, 0, 276),
  [10831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 7, 0, 508),
  [10833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_path_repeat1, 2, 0, 460),
  [10835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declarations, 4, 0, 467),
  [10837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_declarations_repeat1, 2, 0, 371),
  [10839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance, 3, 0, 149),
  [10841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, 0, 151),
  [10843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7610),
  [10845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6998),
  [10847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, 0, 152),
  [10849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance_declarations, 4, 0, 465),
  [10851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_tyinst, 3, 0, 466),
  [10853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_datafam, 3, 0, 87),
  [10855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_datainst_newtype, 3, 0, 113),
  [10857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7277),
  [10859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6694),
  [10861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_datainst_adt, 3, 0, 119),
  [10863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance_declarations, 4, 0, 371),
  [10865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instance_declarations_repeat1, 2, 0, 371),
  [10867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance_declarations, 4, 0, 467),
  [10869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7141),
  [10871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6266),
  [10873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 3, 0, 491),
  [10875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assoc_datafam, 2, 0, 448),
  [10877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 3, 0, 497),
  [10879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_qualifiers_repeat1, 2, 0, 471), SHIFT_REPEAT(265),
  [10882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_qualifiers_repeat1, 2, 0, 471),
  [10884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 3, 0, 496),
  [10886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5088),
  [10888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3830),
  [10890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 3, 0, 495),
  [10892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [10894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 3, 0, 494),
  [10896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declarations, 4, 0, 371),
  [10898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 3, 0, 492),
  [10900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [10902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2905),
  [10904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9507),
  [10906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6206),
  [10908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5778),
  [10910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [10912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraints, 1, 0, 181),
  [10914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gadt_constructors_repeat1, 2, 0, 205),
  [10916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_newtype, 5, 0, 489),
  [10918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inst_newtype, 5, 0, 488),
  [10920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6854),
  [10922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6076),
  [10924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraints, 1, 0, 180),
  [10926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9651),
  [10928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraints, 1, 0, 179),
  [10930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8642),
  [10932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7835),
  [10934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6880),
  [10936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6183),
  [10938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7836),
  [10940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [10942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3953),
  [10944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_family, 3, 0, 0),
  [10946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_synomym, 4, 0, 175),
  [10948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam_equations, 3, 0, 473),
  [10950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving_instance, 4, 0, 163),
  [10952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving_instance, 4, 0, 164),
  [10954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3598),
  [10956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_instance, 2, 0, 168),
  [10958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_synomym, 4, 0, 173),
  [10960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [10962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [10964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patsyn_cons, 2, 0, 0),
  [10966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6409),
  [10968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5806),
  [10970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6973),
  [10972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [10974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3538),
  [10976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11573),
  [10978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6429),
  [10980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11351),
  [10982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12769),
  [10984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [10986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10903),
  [10988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [10990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [10992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10948),
  [10994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [10996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10905),
  [10998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [11000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [11002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10908),
  [11004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [11006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [11008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10910),
  [11010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [11012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [11014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10913),
  [11016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [11018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3584),
  [11020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11500),
  [11022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [11024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10917),
  [11026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [11028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [11030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10919),
  [11032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [11034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [11036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10921),
  [11038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [11040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [11042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8783),
  [11044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [11046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [11048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12216),
  [11050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10927),
  [11052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [11054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3853),
  [11056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6322),
  [11058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6692),
  [11060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [11062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12275),
  [11064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [11066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [11068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [11070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [11072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [11074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9311),
  [11076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [11078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [11080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10971),
  [11082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [11084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [11086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12543),
  [11088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [11090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [11092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [11094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6893),
  [11096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11884),
  [11098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6102),
  [11100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12174),
  [11102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [11104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_default_types_repeat1, 2, 0, 349), SHIFT_REPEAT(1333),
  [11107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_default_types_repeat1, 2, 0, 349),
  [11109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [11111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11244),
  [11113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [11115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [11117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10892),
  [11119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [11121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [11123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_qualifiers_repeat1, 2, 0, 470),
  [11125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [11127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7178),
  [11129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [11131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [11133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11082),
  [11135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [11137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [11139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [11141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [11143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8726),
  [11145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12263),
  [11147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12226),
  [11149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_unboxed_sum_repeat1, 2, 0, 157),
  [11151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_unboxed_sum_repeat1, 2, 0, 157),
  [11153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [11155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [11157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [11159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10973),
  [11161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [11163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12484),
  [11165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4083),
  [11167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11699),
  [11169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12567),
  [11171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4415),
  [11173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11969),
  [11175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9774),
  [11177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6860),
  [11179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11844),
  [11181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7753),
  [11183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3508),
  [11185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11719),
  [11187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [11189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11028),
  [11191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [11193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12583),
  [11195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace, 1, 0, 0),
  [11197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12561),
  [11199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5828),
  [11201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_header, 4, 0, 158),
  [11203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11237),
  [11205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [11207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [11209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [11211] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pat_tuple_elems_repeat1, 2, 0, 256), SHIFT_REPEAT(386),
  [11214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12265),
  [11216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12329),
  [11218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [11220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12644),
  [11222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12600),
  [11224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_tuple_elems_repeat1, 2, 0, 256), SHIFT_REPEAT(1350),
  [11227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [11229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11044),
  [11231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [11233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [11235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10567),
  [11237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12708),
  [11239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6205),
  [11241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12044),
  [11243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [11245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8940),
  [11247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12448),
  [11249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12424),
  [11251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6619),
  [11253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [11255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12392),
  [11257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7635),
  [11259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [11261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12736),
  [11263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7999),
  [11265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12179),
  [11267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [11269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_tuple_elems_repeat2, 2, 0, 256), SHIFT_REPEAT(993),
  [11272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_tuple_elems_repeat2, 2, 0, 256),
  [11274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12267),
  [11276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12230),
  [11278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12461),
  [11280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12229),
  [11282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12233),
  [11284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12530),
  [11286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [11288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [11290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11095),
  [11292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [11294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__guards, 3, 0, 241),
  [11296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5092),
  [11298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12162),
  [11300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10240),
  [11302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12699),
  [11304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10241),
  [11306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12681),
  [11308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12668),
  [11310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12662),
  [11312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12486),
  [11314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4073),
  [11316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12106),
  [11318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12628),
  [11320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12624),
  [11322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [11324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5589),
  [11326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11155),
  [11328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [11330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_tuple_elems, 2, 0, 157),
  [11332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10846),
  [11334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [11336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5759),
  [11338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [11340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [11342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11112),
  [11344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [11346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_tuple_elems, 4, 0, 374),
  [11348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11011),
  [11350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [11352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_header, 3, 0, 56),
  [11354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(10274),
  [11357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12578),
  [11359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10270),
  [11361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12313),
  [11363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10271),
  [11365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12316),
  [11367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12350),
  [11369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12351),
  [11371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7179),
  [11373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12189),
  [11375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12372),
  [11377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12373),
  [11379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [11381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11100),
  [11383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [11385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_group, 6, 0, 556),
  [11387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [11389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [11391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [11393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_group, 6, 0, 557),
  [11395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3603),
  [11397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [11399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8675),
  [11401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_tuple_elems, 2, 0, 154),
  [11403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7804),
  [11405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7719),
  [11407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3544),
  [11409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12078),
  [11411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2761),
  [11413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12065),
  [11415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_tuple_elems_repeat2, 2, 0, 256), SHIFT_REPEAT(975),
  [11418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3246),
  [11420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12052),
  [11422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6968),
  [11424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12039),
  [11426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11118),
  [11428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [11430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3126),
  [11432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12026),
  [11434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [11436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exports_repeat1, 2, 0, 387), SHIFT_REPEAT(7954),
  [11439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exports_repeat1, 2, 0, 387),
  [11441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7024),
  [11443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12013),
  [11445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3142),
  [11447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3201),
  [11449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11998),
  [11451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3472),
  [11453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [11455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7600),
  [11457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11967),
  [11459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_tuple_elems_repeat2, 2, 0, 157),
  [11461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_tuple_elems, 2, 0, 154),
  [11463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6719),
  [11465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11982),
  [11467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2953),
  [11469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [11471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11964),
  [11473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6113),
  [11475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [11477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3483),
  [11479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11946),
  [11481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5632),
  [11483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__record_fields_repeat1, 2, 0, 377), SHIFT_REPEAT(11097),
  [11486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__record_fields_repeat1, 2, 0, 377),
  [11488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pat_record_repeat1, 2, 0, 377), SHIFT_REPEAT(8940),
  [11491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pat_record_repeat1, 2, 0, 377),
  [11493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [11495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6495),
  [11497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11928),
  [11499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6565),
  [11501] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_list_comprehension_repeat1, 2, 0, 265), SHIFT_REPEAT(236),
  [11504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_list_comprehension_repeat1, 2, 0, 265),
  [11506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5821),
  [11508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11909),
  [11510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7220),
  [11512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11851),
  [11514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4201),
  [11516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_list_repeat1, 2, 0, 256), SHIFT_REPEAT(1339),
  [11519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_list_repeat1, 2, 0, 256),
  [11521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualifier, 1, 0, 242),
  [11523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [11525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11888),
  [11527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualifier, 1, 0, 0),
  [11529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4170),
  [11531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11983),
  [11533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_tuple_elems, 3, 0, 260),
  [11535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2863),
  [11537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11115),
  [11539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [11541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4637),
  [11543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11854),
  [11545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11137),
  [11547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [11549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_tuple_elems, 3, 0, 254),
  [11551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7031),
  [11553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11826),
  [11555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__forall_body, 2, 0, 92),
  [11557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_tuple_elems, 3, 0, 253),
  [11559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_repeat1, 2, 0, 35),
  [11561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5986),
  [11563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7883),
  [11565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3796),
  [11567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11925),
  [11569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4992),
  [11571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11817),
  [11573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5706),
  [11575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_record_repeat1, 2, 0, 377), SHIFT_REPEAT(8726),
  [11578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_record_repeat1, 2, 0, 377),
  [11580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [11582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [11584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4640),
  [11586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11780),
  [11588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7506),
  [11590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11739),
  [11592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 1, 0, 249),
  [11594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [11596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12281),
  [11598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3117),
  [11600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__ctr_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(2357),
  [11603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3723),
  [11605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11743),
  [11607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2731),
  [11609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12051),
  [11611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_update, 1, 0, 249),
  [11613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [11615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7119),
  [11617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12332),
  [11619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10967),
  [11621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [11623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [11625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7668),
  [11627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11697),
  [11629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6379),
  [11631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11706),
  [11633] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_guards_repeat1, 2, 0, 457), SHIFT_REPEAT(359),
  [11636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__con_binding_list_repeat1, 2, 0, 36),
  [11638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5743),
  [11640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11596),
  [11642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [11644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5758),
  [11646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_multi_way_if_repeat1, 1, 0, 108),
  [11648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3866),
  [11650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11657),
  [11652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5897),
  [11654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [11656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7253),
  [11658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11669),
  [11660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [11662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [11664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11262),
  [11666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [11668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5357),
  [11670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5733),
  [11672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [11674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3518),
  [11676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11632),
  [11678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3176),
  [11680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6833),
  [11682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4237),
  [11684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11665),
  [11686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [11688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6579),
  [11690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11581),
  [11692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7730),
  [11694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11595),
  [11696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [11698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [11700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [11702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11286),
  [11704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [11706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3877),
  [11708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6229),
  [11710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11550),
  [11712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5694),
  [11714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [11716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [11718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6289),
  [11720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11558),
  [11722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10339),
  [11724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12499),
  [11726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6163),
  [11728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [11730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_list_repeat1, 2, 0, 138), SHIFT_REPEAT(8012),
  [11733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_list_repeat1, 2, 0, 138),
  [11735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3895),
  [11737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11278),
  [11739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [11741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5921),
  [11743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11521),
  [11745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [11747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [11749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5754),
  [11751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_group, 4, 0, 515),
  [11753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_transform, 4, 0, 516),
  [11755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [11757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11484),
  [11759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7946),
  [11761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11455),
  [11763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7223),
  [11765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11437),
  [11767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [11769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9674),
  [11771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6594),
  [11773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__con_binding_list_repeat1, 2, 0, 35),
  [11775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6088),
  [11777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11447),
  [11779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2842),
  [11781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [11783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11288),
  [11785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [11787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_children_repeat1, 2, 0, 256), SHIFT_REPEAT(7972),
  [11790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_children_repeat1, 2, 0, 256),
  [11792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6104),
  [11794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7444),
  [11796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11489),
  [11798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5687),
  [11800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7389),
  [11802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6812),
  [11804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11410),
  [11806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5896),
  [11808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11344),
  [11810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__var_binding_list_repeat1, 2, 0, 35),
  [11812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6016),
  [11814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11376),
  [11816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5653),
  [11818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2843),
  [11820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11341),
  [11822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5775),
  [11824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4370),
  [11826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_decls, 4, 0, 465),
  [11828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [11830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5899),
  [11832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_decls, 4, 0, 371),
  [11834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6427),
  [11836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_decls, 4, 0, 467),
  [11838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6038),
  [11840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4012),
  [11842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6816),
  [11844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4850),
  [11846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4024),
  [11848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4566),
  [11850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7215),
  [11852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4192),
  [11854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_children, 4, 0, 517),
  [11856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12339),
  [11858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6101),
  [11860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [11862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12796),
  [11864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8707),
  [11866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8707),
  [11868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7945),
  [11870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_children_repeat1, 2, 0, 157),
  [11872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4626),
  [11874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4508),
  [11876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_children_repeat1, 2, 0, 472),
  [11878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4506),
  [11880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4505),
  [11882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3393),
  [11884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4504),
  [11886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7432),
  [11888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports, 2, 0, 0),
  [11890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12804),
  [11892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3586),
  [11894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12346),
  [11896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12622),
  [11898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5911),
  [11900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2913),
  [11902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12362),
  [11904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12361),
  [11906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5309),
  [11908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4624),
  [11910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12181),
  [11912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7684),
  [11914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [11916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [11918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12446),
  [11920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_list_repeat1, 2, 0, 310),
  [11922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6227),
  [11924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3980),
  [11926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8155),
  [11928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6291),
  [11930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3978),
  [11932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3977),
  [11934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3976),
  [11936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3615),
  [11938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6578),
  [11940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [11942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12801),
  [11944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7748),
  [11946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5809),
  [11948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4934),
  [11950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4935),
  [11952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12727),
  [11954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4936),
  [11956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4938),
  [11958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12526),
  [11960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [11962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12795),
  [11964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [11966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5300),
  [11968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity, 1, 0, 0),
  [11970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4436),
  [11972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12327),
  [11974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_default_types_repeat1, 2, 0, 48),
  [11976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5170),
  [11978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3900),
  [11980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4245),
  [11982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7257),
  [11984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4743),
  [11986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_decls, 5, 0, 465),
  [11988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_decls, 5, 0, 511),
  [11990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7660),
  [11992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3987),
  [11994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_decls, 5, 0, 467),
  [11996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_decls, 3, 0, 371),
  [11998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6387),
  [12000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports, 5, 0, 388),
  [12002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_record_repeat1, 2, 0, 375),
  [12004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4972),
  [12006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_update, 1, 0, 248),
  [12008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3506),
  [12010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5245),
  [12012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5246),
  [12014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5248),
  [12016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5271),
  [12018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7514),
  [12020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3738),
  [12022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 1, 0, 248),
  [12024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12314),
  [12026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4639),
  [12028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2898),
  [12030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1102),
  [12032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [12034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5259),
  [12036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports, 5, 0, 386),
  [12038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12626),
  [12040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_imports_repeat1, 2, 0, 145),
  [12042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4403),
  [12044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4981),
  [12046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5613),
  [12048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7035),
  [12050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8906),
  [12052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5551),
  [12054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6859),
  [12056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [12058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [12060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_update, 3, 0, 462),
  [12062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7214),
  [12064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4641),
  [12066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pat_record_repeat1, 2, 0, 375),
  [12068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4336),
  [12070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__record_fields_repeat1, 2, 0, 375),
  [12072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5086),
  [12074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5430),
  [12076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12775),
  [12078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_decls, 2, 0, 0),
  [12080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5231),
  [12082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_list_comprehension_repeat1, 2, 0, 262),
  [12084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6888),
  [12086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5006),
  [12088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [12090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(980),
  [12092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [12094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5229),
  [12096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5822),
  [12098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12336),
  [12100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5228),
  [12102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5227),
  [12104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3756),
  [12106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6493),
  [12108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3019),
  [12110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3027),
  [12112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3042),
  [12114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports, 4, 0, 388),
  [12116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports, 4, 0, 0),
  [12118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [12120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 3, 0, 464),
  [12122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [12124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12325),
  [12126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3270),
  [12128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7559),
  [12130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4416),
  [12132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [12134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [12136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6720),
  [12138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4048),
  [12140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3200),
  [12142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12534),
  [12144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7023),
  [12146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4711),
  [12148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [12150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ktype_param, 1, 0, 90),
  [12152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5660),
  [12154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [12156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [12158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6967),
  [12160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12791),
  [12162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12792),
  [12164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6210),
  [12166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2736),
  [12168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3243),
  [12170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports, 4, 0, 386),
  [12172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12595),
  [12174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2760),
  [12176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_children, 3, 0, 157),
  [12178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [12180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12554),
  [12182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4696),
  [12184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5241),
  [12186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3553),
  [12188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports, 4, 0, 272),
  [12190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9624),
  [12192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [12194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [12196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exports_repeat1, 2, 0, 0),
  [12198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_children, 4, 0, 260),
  [12200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4068),
  [12202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exports_repeat1, 2, 0, 272),
  [12204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8995),
  [12206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ie_entity, 3, 0, 385),
  [12208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7898),
  [12210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4700),
  [12212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4703),
  [12214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5226),
  [12216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12563),
  [12218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4724),
  [12220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ie_entity, 3, 0, 384),
  [12222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4725),
  [12224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(972),
  [12226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [12228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5495),
  [12230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5460),
  [12232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_module, 2, 0, 72),
  [12234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_children, 3, 0, 472),
  [12236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ie_entity, 3, 0, 383),
  [12238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [12240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12489),
  [12242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_children, 2, 0, 0),
  [12244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4702),
  [12246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports, 3, 0, 0),
  [12248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__child, 1, 0, 382),
  [12250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5091),
  [12252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_export, 2, 0, 56),
  [12254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4701),
  [12256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ie_entity, 2, 0, 267),
  [12258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [12260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [12262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5560),
  [12264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5608),
  [12266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ie_entity, 2, 0, 268),
  [12268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6078),
  [12270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5606),
  [12272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5591),
  [12274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7985),
  [12276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10657),
  [12278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7877),
  [12280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7175),
  [12282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_decls, 6, 0, 511),
  [12284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports, 3, 0, 272),
  [12286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [12288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [12290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ie_entity, 2, 0, 273),
  [12292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [12294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [12296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5354),
  [12298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_projection_selector_repeat1, 2, 0, 375),
  [12300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5342),
  [12302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5343),
  [12304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5344),
  [12306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [12308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [12310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [12312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5324),
  [12314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9273),
  [12316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5650),
  [12318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [12320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [12322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6775),
  [12324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4599),
  [12326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12317),
  [12328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3305),
  [12330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4656),
  [12332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [12334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [12336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10013),
  [12338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8924),
  [12340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9560),
  [12342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9969),
  [12344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoter, 1, 0, 0),
  [12346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4439),
  [12348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7185),
  [12350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8087),
  [12352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [12354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5341),
  [12356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [12358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9819),
  [12360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10931),
  [12362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [12364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [12366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9783),
  [12368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11224),
  [12370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [12372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [12374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3621),
  [12376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4093),
  [12378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12268),
  [12380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4252),
  [12382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5577),
  [12384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7458),
  [12386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5189),
  [12388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7884),
  [12390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6800),
  [12392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10996),
  [12394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5561),
  [12396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9935),
  [12398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9634),
  [12400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [12402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__body, 3, 0, 76),
  [12404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__body, 3, 0, 75),
  [12406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [12408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9707),
  [12410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7878),
  [12412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8282),
  [12414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6649),
  [12416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [12418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [12420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7682),
  [12422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12680),
  [12424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3592),
  [12426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2835),
  [12428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qualified_arrow, 2, 0, 187),
  [12430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [12432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6900),
  [12434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [12436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7180),
  [12438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5530),
  [12440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4236),
  [12442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [12444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6744),
  [12446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3322),
  [12448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3613),
  [12450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9834),
  [12452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6307),
  [12454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [12456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [12458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9862),
  [12460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11211),
  [12462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5842),
  [12464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8780),
  [12466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [12468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6628),
  [12470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11190),
  [12472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4480),
  [12474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9065),
  [12476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5019),
  [12478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9057),
  [12480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8885),
  [12482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9056),
  [12484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9055),
  [12486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9048),
  [12488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4452),
  [12490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8663),
  [12492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4107),
  [12494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9032),
  [12496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4699),
  [12498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [12500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3675),
  [12502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9104),
  [12504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2771),
  [12506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7717),
  [12508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10667),
  [12510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5212),
  [12512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [12514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5389),
  [12516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6333),
  [12518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6918),
  [12520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8728),
  [12522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3587),
  [12524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [12526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8691),
  [12528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9939),
  [12530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3064),
  [12532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [12534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [12536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9922),
  [12538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10961),
  [12540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8222),
  [12542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6926),
  [12544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5097),
  [12546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3632),
  [12548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5720),
  [12550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [12552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12761),
  [12554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6232),
  [12556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8139),
  [12558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7578),
  [12560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [12562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [12564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12802),
  [12566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [12568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7157),
  [12570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8921),
  [12572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8813),
  [12574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10619),
  [12576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7203),
  [12578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7288),
  [12580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5581),
  [12582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [12584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [12586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3625),
  [12588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6952),
  [12590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5718),
  [12592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [12594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [12596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6736),
  [12598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7741),
  [12600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [12602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9830),
  [12604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [12606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [12608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [12610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9817),
  [12612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11312),
  [12614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6383),
  [12616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4704),
  [12618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7097),
  [12620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7409),
  [12622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3551),
  [12624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9567),
  [12626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9743),
  [12628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5931),
  [12630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7092),
  [12632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [12634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7925),
  [12636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3192),
  [12638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6416),
  [12640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3279),
  [12642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4008),
  [12644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8281),
  [12646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [12648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6727),
  [12650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5852),
  [12652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6109),
  [12654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12522),
  [12656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7245),
  [12658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [12660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3206),
  [12662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9708),
  [12664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [12666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [12668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [12670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9735),
  [12672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11192),
  [12674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6750),
  [12676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3624),
  [12678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4716),
  [12680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7904),
  [12682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6463),
  [12684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5052),
  [12686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6035),
  [12688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6762),
  [12690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [12692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4844),
  [12694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4723),
  [12696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8091),
  [12698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7465),
  [12700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5834),
  [12702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4521),
  [12704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5936),
  [12706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3933),
  [12708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6990),
  [12710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6211),
  [12712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7088),
  [12714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5230),
  [12716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [12718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3760),
  [12720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9851),
  [12722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7913),
  [12724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [12726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [12728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9864),
  [12730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11001),
  [12732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4195),
  [12734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [12736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5730),
  [12738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7094),
  [12740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [12742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4259),
  [12744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9177),
  [12746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8008),
  [12748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10002),
  [12750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10004),
  [12752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7314),
  [12754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4707),
  [12756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3836),
  [12758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6544),
  [12760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9111),
  [12762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6665),
  [12764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9631),
  [12766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7081),
  [12768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5427),
  [12770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9133),
  [12772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9334),
  [12774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4531),
  [12776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10011),
  [12778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12203),
  [12780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [12782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [12784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9993),
  [12786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10893),
  [12788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5876),
  [12790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5243),
  [12792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8637),
  [12794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4966),
  [12796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7397),
  [12798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7702),
  [12800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4533),
  [12802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4481),
  [12804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [12806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8294),
  [12808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3943),
  [12810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4621),
  [12812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__body, 4, 0, 148),
  [12814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5799),
  [12816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [12818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [12820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5256),
  [12822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4167),
  [12824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8036),
  [12826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4550),
  [12828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [12830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3487),
  [12832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [12834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6614),
  [12836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9824),
  [12838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9628),
  [12840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [12842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3622),
  [12844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9816),
  [12846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11049),
  [12848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4060),
  [12850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3510),
  [12852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [12854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5422),
  [12856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7502),
  [12858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11335),
  [12860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7509),
  [12862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6484),
  [12864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7679),
  [12866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3695),
  [12868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7793),
  [12870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8053),
  [12872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8160),
  [12874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8143),
  [12876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12335),
  [12878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12754),
  [12880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6592),
  [12882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6386),
  [12884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9095),
  [12886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6864),
  [12888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11168),
  [12890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8730),
  [12892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9486),
  [12894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7907),
  [12896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11342),
  [12898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5409),
  [12900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5255),
  [12902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10289),
  [12904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11202),
  [12906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8649),
  [12908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6255),
  [12910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4734),
  [12912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6451),
  [12914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__body, 4, 0, 82),
  [12916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7652),
  [12918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11230),
  [12920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3800),
  [12922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6448),
  [12924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__body, 4, 0, 83),
  [12926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [12928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3810),
  [12930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [12932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11267),
  [12934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4965),
  [12936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7304),
  [12938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [12940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5991),
  [12942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7129),
  [12944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11295),
  [12946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [12948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [12950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8569),
  [12952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7934),
  [12954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [12956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11327),
  [12958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7937),
  [12960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5180),
  [12962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3782),
  [12964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8387),
  [12966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6587),
  [12968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11253),
  [12970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3962),
  [12972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8386),
  [12974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8765),
  [12976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__body, 3, 0, 0),
  [12978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11176),
  [12980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6174),
  [12982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3426),
  [12984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3419),
  [12986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8029),
  [12988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11079),
  [12990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5076),
  [12992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__body, 5, 0, 162),
  [12994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6605),
  [12996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_haskell, 2, 0, 34),
  [12998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10993),
  [13000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4954),
  [13002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5156),
  [13004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4303),
  [13006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7291),
  [13008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10895),
  [13010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3539),
  [13012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10020),
  [13014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7732),
  [13016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6062),
  [13018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10916),
  [13020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7584),
  [13022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6899),
  [13024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4937),
  [13026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8592),
  [13028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10960),
  [13030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4159),
  [13032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6240),
  [13034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10998),
  [13036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4487),
  [13038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11035),
  [13040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [13042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11072),
  [13044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6296),
  [13046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11109),
  [13048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3814),
  [13050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11146),
  [13052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [13054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11183),
  [13056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [13058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11220),
  [13060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6746),
  [13062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11257),
  [13064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__body, 2, 0, 0),
  [13066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11294),
  [13068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7545),
  [13070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11322),
  [13072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7107),
  [13074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11324),
  [13076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4408),
  [13078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11321),
  [13080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7874),
  [13082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11304),
  [13084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4916),
  [13086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11293),
  [13088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8987),
  [13090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11284),
  [13092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7344),
  [13094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11275),
  [13096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3979),
  [13098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11258),
  [13100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12778),
  [13102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11246),
  [13104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [13106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11234),
  [13108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8680),
  [13110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11221),
  [13112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11087),
  [13114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11210),
  [13116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4054),
  [13118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11201),
  [13120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7103),
  [13122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11193),
  [13124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4465),
  [13126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11180),
  [13128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9085),
  [13130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11173),
  [13132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5880),
  [13134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11167),
  [13136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5888),
  [13138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11163),
  [13140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8571),
  [13142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11156),
  [13144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5075),
  [13146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11152),
  [13148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [13150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11149),
  [13152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5776),
  [13154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11142),
  [13156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7543),
  [13158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11139),
  [13160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4893),
  [13162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11136),
  [13164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7477),
  [13166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11134),
  [13168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12259),
  [13170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11133),
  [13172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7329),
  [13174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11131),
  [13176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7377),
  [13178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11129),
  [13180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8555),
  [13182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8148),
  [13184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10902),
  [13186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4293),
  [13188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8653),
  [13190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8792),
  [13192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [13194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5312),
  [13196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10901),
  [13198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10900),
  [13200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3378),
  [13202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6049),
  [13204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11106),
  [13206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9918),
  [13208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8729),
  [13210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10899),
  [13212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4278),
  [13214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8290),
  [13216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8138),
  [13218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8166),
  [13220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8161),
  [13222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3916),
  [13224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [13226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8158),
  [13228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6475),
  [13230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [13232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [13234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10898),
  [13236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10911),
  [13238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8772),
  [13240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8554),
  [13242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12241),
  [13244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3828),
  [13246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8678),
  [13248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8803),
  [13250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8557),
  [13252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9678),
  [13254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9702),
  [13256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9723),
  [13258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8295),
  [13260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8579),
  [13262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4507),
  [13264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8622),
  [13266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8848),
  [13268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9030),
  [13270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8287),
  [13272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [13274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8584),
  [13276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7863),
  [13278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8611),
  [13280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8856),
  [13282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_haskell, 1, 0, 1),
  [13284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8289),
  [13286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6156),
  [13288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8600),
  [13290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8957),
  [13292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8667),
  [13294] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [13296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8277),
  [13298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6220),
  [13300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8568),
  [13302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8581),
  [13304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8672),
  [13306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8604),
  [13308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4767),
  [13310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [13312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8599),
  [13314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4544),
  [13316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8610),
  [13318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [13320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6437),
  [13322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4562),
  [13324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8598),
  [13326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7593),
  [13328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8643),
  [13330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6844),
  [13332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6582),
  [13334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6855),
  [13336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8597),
  [13338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7889),
  [13340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8662),
  [13342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12525),
  [13344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3813),
  [13346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8552),
  [13348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10043),
  [13350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8580),
  [13352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9823),
  [13354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8606),
  [13356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [13358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8586),
  [13360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7494),
  [13362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8594),
  [13364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [13366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8578),
  [13368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3422),
  [13370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8590),
  [13372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4076),
  [13374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5737),
  [13376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8655),
  [13378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5932),
  [13380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7672),
  [13382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6978),
  [13384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6087),
  [13386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3497),
  [13388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8002),
  [13390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4009),
  [13392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10213),
  [13394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fun_arrow_prec, 2, 0, 0),
  [13396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9779),
  [13398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9765),
  [13400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9763),
  [13402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5744),
  [13404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [13406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [13408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [13410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5973),
  [13412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7196),
  [13414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3532),
  [13416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [13418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7485),
  [13420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8880),
  [13422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8593),
  [13424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9353),
  [13426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12709),
  [13428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8896),
  [13430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8575),
  [13432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9287),
  [13434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9281),
  [13436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9278),
  [13438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9270),
  [13440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9164),
  [13442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9150),
  [13444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9188),
  [13446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9480),
  [13448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9183),
  [13450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9212),
  [13452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9220),
  [13454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9221),
  [13456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9252),
  [13458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9269),
  [13460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9512),
  [13462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9527),
  [13464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9529),
  [13466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9234),
  [13468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9237),
  [13470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9368),
  [13472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9383),
  [13474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9460),
  [13476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9447),
  [13478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9436),
  [13480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9154),
  [13482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9155),
  [13484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9156),
  [13486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9175),
  [13488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9196),
  [13490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9197),
  [13492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9232),
  [13494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9412),
  [13496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9427),
  [13498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9428),
  [13500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9430),
  [13502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9431),
  [13504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9433),
  [13506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9434),
  [13508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9435),
  [13510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9439),
  [13512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9442),
  [13514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9463),
  [13516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9464),
  [13518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9490),
  [13520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9357),
  [13522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9266),
  [13524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9249),
  [13526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9448),
  [13528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9457),
  [13530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9511),
  [13532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9441),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token_error_sentinel = 0,
  ts_external_token__cond_layout_semicolon = 1,
  ts_external_token__cmd_layout_start = 2,
  ts_external_token__cmd_layout_start_do = 3,
  ts_external_token__cmd_layout_start_case = 4,
  ts_external_token__cmd_layout_start_if = 5,
  ts_external_token__cmd_layout_start_let = 6,
  ts_external_token__cmd_layout_start_quote = 7,
  ts_external_token__cmd_layout_start_explicit = 8,
  ts_external_token__cond_layout_end = 9,
  ts_external_token__cond_layout_end_explicit = 10,
  ts_external_token__cmd_brace_open = 11,
  ts_external_token__cmd_brace_close = 12,
  ts_external_token__cmd_texp_start = 13,
  ts_external_token__cmd_texp_end = 14,
  ts_external_token__phantom_where = 15,
  ts_external_token__phantom_in = 16,
  ts_external_token__phantom_arrow = 17,
  ts_external_token__phantom_bar = 18,
  ts_external_token__phantom_deriving = 19,
  ts_external_token_comment = 20,
  ts_external_token_haddock = 21,
  ts_external_token_cpp = 22,
  ts_external_token_pragma = 23,
  ts_external_token__cond_quote_start = 24,
  ts_external_token_quasiquote_body = 25,
  ts_external_token__cond_splice = 26,
  ts_external_token__cond_qual_dot = 27,
  ts_external_token__cond_tight_dot = 28,
  ts_external_token__cond_prefix_dot = 29,
  ts_external_token__cond_dotdot = 30,
  ts_external_token__cond_tight_at = 31,
  ts_external_token__cond_prefix_at = 32,
  ts_external_token__cond_tight_bang = 33,
  ts_external_token__cond_prefix_bang = 34,
  ts_external_token__cond_tight_tilde = 35,
  ts_external_token__cond_prefix_tilde = 36,
  ts_external_token__cond_prefix_percent = 37,
  ts_external_token__cond_qualified_op = 38,
  ts_external_token__cond_left_section_op = 39,
  ts_external_token__cond_no_section_op = 40,
  ts_external_token__cond_minus = 41,
  ts_external_token__cond_context = 42,
  ts_external_token__cond_infix = 43,
  ts_external_token__cond_data_infix = 44,
  ts_external_token__cond_assoc_tyinst = 45,
  ts_external_token__varsym = 46,
  ts_external_token__consym = 47,
  ts_external_token__token1 = 48,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_error_sentinel] = sym_error_sentinel,
  [ts_external_token__cond_layout_semicolon] = sym__cond_layout_semicolon,
  [ts_external_token__cmd_layout_start] = sym__cmd_layout_start,
  [ts_external_token__cmd_layout_start_do] = sym__cmd_layout_start_do,
  [ts_external_token__cmd_layout_start_case] = sym__cmd_layout_start_case,
  [ts_external_token__cmd_layout_start_if] = sym__cmd_layout_start_if,
  [ts_external_token__cmd_layout_start_let] = sym__cmd_layout_start_let,
  [ts_external_token__cmd_layout_start_quote] = sym__cmd_layout_start_quote,
  [ts_external_token__cmd_layout_start_explicit] = sym__cmd_layout_start_explicit,
  [ts_external_token__cond_layout_end] = sym__cond_layout_end,
  [ts_external_token__cond_layout_end_explicit] = sym__cond_layout_end_explicit,
  [ts_external_token__cmd_brace_open] = sym__cmd_brace_open,
  [ts_external_token__cmd_brace_close] = sym__cmd_brace_close,
  [ts_external_token__cmd_texp_start] = sym__cmd_texp_start,
  [ts_external_token__cmd_texp_end] = sym__cmd_texp_end,
  [ts_external_token__phantom_where] = sym__phantom_where,
  [ts_external_token__phantom_in] = sym__phantom_in,
  [ts_external_token__phantom_arrow] = sym__phantom_arrow,
  [ts_external_token__phantom_bar] = sym__phantom_bar,
  [ts_external_token__phantom_deriving] = sym__phantom_deriving,
  [ts_external_token_comment] = sym_comment,
  [ts_external_token_haddock] = sym_haddock,
  [ts_external_token_cpp] = sym_cpp,
  [ts_external_token_pragma] = sym_pragma,
  [ts_external_token__cond_quote_start] = sym__cond_quote_start,
  [ts_external_token_quasiquote_body] = sym_quasiquote_body,
  [ts_external_token__cond_splice] = sym__cond_splice,
  [ts_external_token__cond_qual_dot] = sym__cond_qual_dot,
  [ts_external_token__cond_tight_dot] = sym__cond_tight_dot,
  [ts_external_token__cond_prefix_dot] = sym__cond_prefix_dot,
  [ts_external_token__cond_dotdot] = sym__cond_dotdot,
  [ts_external_token__cond_tight_at] = sym__cond_tight_at,
  [ts_external_token__cond_prefix_at] = sym__cond_prefix_at,
  [ts_external_token__cond_tight_bang] = sym__cond_tight_bang,
  [ts_external_token__cond_prefix_bang] = sym__cond_prefix_bang,
  [ts_external_token__cond_tight_tilde] = sym__cond_tight_tilde,
  [ts_external_token__cond_prefix_tilde] = sym__cond_prefix_tilde,
  [ts_external_token__cond_prefix_percent] = sym__cond_prefix_percent,
  [ts_external_token__cond_qualified_op] = sym__cond_qualified_op,
  [ts_external_token__cond_left_section_op] = sym__cond_left_section_op,
  [ts_external_token__cond_no_section_op] = sym__cond_no_section_op,
  [ts_external_token__cond_minus] = sym__cond_minus,
  [ts_external_token__cond_context] = sym__cond_context,
  [ts_external_token__cond_infix] = sym__cond_infix,
  [ts_external_token__cond_data_infix] = sym__cond_data_infix,
  [ts_external_token__cond_assoc_tyinst] = sym__cond_assoc_tyinst,
  [ts_external_token__varsym] = sym__varsym,
  [ts_external_token__consym] = sym__consym,
  [ts_external_token__token1] = aux_sym__token1,
};

static const bool ts_external_scanner_states[223][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_error_sentinel] = true,
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cmd_layout_start] = true,
    [ts_external_token__cmd_layout_start_do] = true,
    [ts_external_token__cmd_layout_start_case] = true,
    [ts_external_token__cmd_layout_start_if] = true,
    [ts_external_token__cmd_layout_start_let] = true,
    [ts_external_token__cmd_layout_start_quote] = true,
    [ts_external_token__cmd_layout_start_explicit] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__cmd_brace_open] = true,
    [ts_external_token__cmd_brace_close] = true,
    [ts_external_token__cmd_texp_start] = true,
    [ts_external_token__cmd_texp_end] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_in] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token_quasiquote_body] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_dotdot] = true,
    [ts_external_token__cond_tight_at] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_left_section_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__cond_context] = true,
    [ts_external_token__cond_infix] = true,
    [ts_external_token__cond_data_infix] = true,
    [ts_external_token__cond_assoc_tyinst] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [2] = {
    [ts_external_token__cmd_layout_start] = true,
    [ts_external_token__cmd_layout_start_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [3] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__token1] = true,
  },
  [4] = {
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__token1] = true,
  },
  [5] = {
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__token1] = true,
  },
  [6] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [7] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [8] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__token1] = true,
  },
  [9] = {
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__token1] = true,
  },
  [10] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [11] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__token1] = true,
  },
  [12] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [13] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_dotdot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [14] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_left_section_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [15] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [16] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [17] = {
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [18] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [19] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [20] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [21] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [22] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_context] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [23] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_dotdot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [24] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [25] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_left_section_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [26] = {
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [27] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [28] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [29] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [30] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [31] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [32] = {
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [33] = {
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [34] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_context] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [35] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_context] = true,
    [ts_external_token__token1] = true,
  },
  [36] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [37] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [38] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__token1] = true,
  },
  [39] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [40] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [41] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [42] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [43] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_dotdot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [44] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [45] = {
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [46] = {
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [47] = {
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [48] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [49] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [50] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [51] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [52] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [53] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [54] = {
    [ts_external_token__cmd_layout_start_if] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__token1] = true,
  },
  [55] = {
    [ts_external_token__phantom_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [56] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [57] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [58] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_context] = true,
    [ts_external_token__cond_infix] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [59] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [60] = {
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [61] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__token1] = true,
  },
  [62] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__token1] = true,
  },
  [63] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__token1] = true,
  },
  [64] = {
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__token1] = true,
  },
  [65] = {
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__token1] = true,
  },
  [66] = {
    [ts_external_token__phantom_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__token1] = true,
  },
  [67] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__token1] = true,
  },
  [68] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__token1] = true,
  },
  [69] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__token1] = true,
  },
  [70] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__token1] = true,
  },
  [71] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__token1] = true,
  },
  [72] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [73] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_tight_at] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [74] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_context] = true,
    [ts_external_token__cond_infix] = true,
    [ts_external_token__token1] = true,
  },
  [75] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [76] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [77] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [78] = {
    [ts_external_token__cmd_layout_start_case] = true,
    [ts_external_token__cmd_layout_start_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [79] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [80] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [81] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [82] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [83] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_dotdot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [84] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [85] = {
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [86] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_left_section_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [87] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [88] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [89] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_dotdot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [90] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_tight_at] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [91] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [92] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_tight_at] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [93] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_left_section_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [94] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [95] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_infix] = true,
    [ts_external_token__token1] = true,
  },
  [96] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_dotdot] = true,
    [ts_external_token__cond_tight_at] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [97] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_tight_at] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [98] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_tight_at] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_left_section_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [99] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [100] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [101] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [102] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_dotdot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [103] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_dotdot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [104] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [105] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cmd_layout_start_case] = true,
    [ts_external_token__cmd_layout_start_explicit] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [106] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_left_section_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [107] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_left_section_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [108] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [109] = {
    [ts_external_token__cmd_layout_start_case] = true,
    [ts_external_token__cmd_layout_start_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_dotdot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [110] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cmd_layout_start_case] = true,
    [ts_external_token__cmd_layout_start_explicit] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [111] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [112] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [113] = {
    [ts_external_token__cmd_layout_start_case] = true,
    [ts_external_token__cmd_layout_start_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_left_section_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [114] = {
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [115] = {
    [ts_external_token__cmd_layout_start_case] = true,
    [ts_external_token__cmd_layout_start_explicit] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [116] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cmd_layout_start_case] = true,
    [ts_external_token__cmd_layout_start_explicit] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [117] = {
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_tight_at] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [118] = {
    [ts_external_token__cmd_layout_start_case] = true,
    [ts_external_token__cmd_layout_start_explicit] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [119] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [120] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [121] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [122] = {
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [123] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [124] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [125] = {
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [126] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [127] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [128] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [129] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [130] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [131] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_at] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [132] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_dotdot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [133] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_infix] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [134] = {
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [135] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [136] = {
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [137] = {
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_at] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [138] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [139] = {
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [140] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [141] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [142] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_tight_at] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [143] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [144] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [145] = {
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [146] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [147] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [148] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_tight_at] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_tight_bang] = true,
    [ts_external_token__cond_prefix_bang] = true,
    [ts_external_token__cond_tight_tilde] = true,
    [ts_external_token__cond_prefix_tilde] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_no_section_op] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [149] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_infix] = true,
    [ts_external_token__token1] = true,
  },
  [150] = {
    [ts_external_token__phantom_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [151] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [152] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__token1] = true,
  },
  [153] = {
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_infix] = true,
    [ts_external_token__token1] = true,
  },
  [154] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_assoc_tyinst] = true,
    [ts_external_token__token1] = true,
  },
  [155] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [156] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [157] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_context] = true,
    [ts_external_token__cond_infix] = true,
    [ts_external_token__token1] = true,
  },
  [158] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_context] = true,
    [ts_external_token__cond_data_infix] = true,
    [ts_external_token__token1] = true,
  },
  [159] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_infix] = true,
    [ts_external_token__token1] = true,
  },
  [160] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__cond_context] = true,
    [ts_external_token__token1] = true,
  },
  [161] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__token1] = true,
  },
  [162] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__token1] = true,
  },
  [163] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__token1] = true,
  },
  [164] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__token1] = true,
  },
  [165] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__token1] = true,
  },
  [166] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__token1] = true,
  },
  [167] = {
    [ts_external_token__phantom_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__token1] = true,
  },
  [168] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_quote_start] = true,
    [ts_external_token__cond_splice] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__token1] = true,
  },
  [169] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__token1] = true,
  },
  [170] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__token1] = true,
  },
  [171] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [172] = {
    [ts_external_token__phantom_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__token1] = true,
  },
  [173] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_prefix_at] = true,
    [ts_external_token__token1] = true,
  },
  [174] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__token1] = true,
  },
  [175] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__token1] = true,
  },
  [176] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__cond_minus] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [177] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_data_infix] = true,
    [ts_external_token__token1] = true,
  },
  [178] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__token1] = true,
  },
  [179] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__token1] = true,
  },
  [180] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__token1] = true,
  },
  [181] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [182] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_dotdot] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__token1] = true,
  },
  [183] = {
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__token1] = true,
  },
  [184] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__token1] = true,
  },
  [185] = {
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_prefix_percent] = true,
    [ts_external_token__token1] = true,
  },
  [186] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [187] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [188] = {
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [189] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__token1] = true,
  },
  [190] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__token1] = true,
  },
  [191] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [192] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_dotdot] = true,
    [ts_external_token__token1] = true,
  },
  [193] = {
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [194] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_prefix_dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__token1] = true,
  },
  [195] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__token1] = true,
  },
  [196] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [197] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cmd_layout_start] = true,
    [ts_external_token__cmd_layout_start_explicit] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [198] = {
    [ts_external_token__phantom_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [199] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [200] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cmd_layout_start_let] = true,
    [ts_external_token__cmd_layout_start_explicit] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_in] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [201] = {
    [ts_external_token__cmd_layout_start_let] = true,
    [ts_external_token__cmd_layout_start_explicit] = true,
    [ts_external_token__phantom_in] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [202] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_deriving] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [203] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_assoc_tyinst] = true,
    [ts_external_token__token1] = true,
  },
  [204] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [205] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cmd_layout_start] = true,
    [ts_external_token__cmd_layout_start_explicit] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [206] = {
    [ts_external_token__cmd_layout_start_let] = true,
    [ts_external_token__cmd_layout_start_explicit] = true,
    [ts_external_token__phantom_in] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [207] = {
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__phantom_bar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [208] = {
    [ts_external_token__phantom_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_qual_dot] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__token1] = true,
  },
  [209] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_qualified_op] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__token1] = true,
  },
  [210] = {
    [ts_external_token__cond_layout_semicolon] = true,
    [ts_external_token__cond_layout_end] = true,
    [ts_external_token__cond_layout_end_explicit] = true,
    [ts_external_token__phantom_in] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [211] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__cond_tight_dot] = true,
    [ts_external_token__token1] = true,
  },
  [212] = {
    [ts_external_token__phantom_in] = true,
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [213] = {
    [ts_external_token__phantom_in] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [214] = {
    [ts_external_token__phantom_arrow] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [215] = {
    [ts_external_token__cmd_layout_start_quote] = true,
    [ts_external_token__cmd_layout_start_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [216] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token_quasiquote_body] = true,
    [ts_external_token__token1] = true,
  },
  [217] = {
    [ts_external_token__cmd_layout_start_do] = true,
    [ts_external_token__cmd_layout_start_explicit] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [218] = {
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__token1] = true,
  },
  [219] = {
    [ts_external_token__cmd_brace_close] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [220] = {
    [ts_external_token__cmd_texp_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [221] = {
    [ts_external_token__cmd_texp_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
  [222] = {
    [ts_external_token__cmd_brace_open] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_haddock] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_pragma] = true,
    [ts_external_token__token1] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_haskell_external_scanner_create(void);
void tree_sitter_haskell_external_scanner_destroy(void *);
bool tree_sitter_haskell_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_haskell_external_scanner_serialize(void *, char *);
void tree_sitter_haskell_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_haskell(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_variable,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_haskell_external_scanner_create,
      tree_sitter_haskell_external_scanner_destroy,
      tree_sitter_haskell_external_scanner_scan,
      tree_sitter_haskell_external_scanner_serialize,
      tree_sitter_haskell_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
